<?php
class Template
{
	public $site_name;
	public $site_url;
	public $site_description;
	public $site_logo;
	public $site_language;
	public $site_tagline;
	public $theme_url;
	public $close_site = 0;
	public $close_site_allow;
	public $version;

	public $title;
	public $description;
	public $url;
	public $image;

	public $header_code;
	public $footer_code;
	public $body_top_code;
	public $body_bottom_code;

	public $social_media;
	public $top_menu;
	public $main_menu;
	public $breadcrumb_list;
	public $breadcrumb_hide = false;

	public $words;
	public $prefix_site_title = 0;
	public $powered_by = 1;
	public $nav_counter = 0;
	public $full_screen = false;
	public $footer_wrapper;
	public $hide_top_menu = false;
	public $main_menu_line = false;
	public $lazy_loading = false;
	public $navbar_sticky = false;
	public $overlay = false;
	public $overlay_navigation = false;

	public $_params = [];
	public $_lang;
	public $_action;
	public $_id = '';
	public $_id2 = '';
	public $_pager = 1;

	public $home_header_code;
	public $home_body_code;
	public $home_footer_code;
	public $languages;
	public $body_class = 'cyan';

	public $colors = ['cyan', 'purple', 'red', 'orange', 'yellow', 'blue', 'gray', 'green'];
	public $colors_code = ['38cbcb', '8e74b2', 'ef3852', 'fdb655', 'BAA56A', '3498db', '8a8a8a', '1bbc9b'];

	public function __construct()
	{
		$this->version = '1.1';
	}

	public function site_url($url = '')
	{
		$site_url = rtrim($this->site_url, '/');
		return $site_url . '/' . $url;
	}

	public function logo_site()
	{
		$body_class = $this->body_class;
		if( in_array($body_class, $this->colors) && $body_class != 'cyan' ){
			if ($this->lang('language') == 'ar') {
				return (empty($this->site_logo) ? $this->site_url($this->theme_url) . '/images/logo-'.$body_class.'.png?v='.$this->version : $this->site_logo);
			}else{
				return (empty($this->site_logo) ? $this->site_url($this->theme_url) . '/images/logo-en.png?v='.$this->version : $this->site_logo);
			}
		}else{
			if ($this->lang('language') == 'ar') {
				return (empty($this->site_logo) ? $this->site_url($this->theme_url) . '/images/logo.png?v='.$this->version : $this->site_logo);
			}else{
				return (empty($this->site_logo) ? $this->site_url($this->theme_url) . '/images/logo-en.png?v='.$this->version : $this->site_logo);
			}
		}
	}

	public function lang($w)
	{
		$get_words = get_words($w, $this->site_language);
		return $get_words;
	}

	public function change_color($place = '')
	{
		$clas = ( empty($place) ? 'choose-color' : 'choose-color2' );
		$html = '<div class="change-color ms-auto">';
		$html .= '<ul class="list-inline mb-0">';
		foreach($this->colors as $k => $v){
			$html .= '<li id="color-'.$v.$place.'" class="list-inline-item '.$clas.' '.$v.' qa-bg" onclick="check(\''.$v.'\')"></li>';
		}
		$html .= '</ul>';
		$html .= '</div>';

		return $html;
	}

	public function share($title, $url)
	{
		//'pdf' => ['title' => 'PDF', 'icon' => 'fa-solid fa-file-pdf'],
		$social = [
			'whatsapp' => ['title' => 'WhatsApp', 'icon' => 'fab fa-whatsapp'],
			'twitter' => ['title' => 'Twitter', 'icon' => 'fab fa-twitter'],
			'facebook' => ['title' => 'Facebook', 'icon' => 'fab fa-facebook'],
			'pinterest' => ['title' => 'Pinterest', 'icon' => 'fab fa-pinterest'],
			'linkedIn' => ['title' => 'LinkedIn', 'icon' => 'fab fa-linkedin'],
			'buffer' => ['title' => 'Buffer', 'icon' => 'fab fa-buffer'],
			'tumblr' => ['title' => 'Tumblr', 'icon' => 'fab fa-tumblr'],
			'reddit' => ['title' => 'Reddit', 'icon' => 'fab fa-reddit'],
			'mix' => ['title' => 'Mix', 'icon' => 'fab fa-mix'],
			'evernote' => ['title' => 'Evernote', 'icon' => 'fab fa-evernote'],
			'pocket' => ['title' => 'Pocket', 'icon' => 'fab fa-get-pocket'],
			'wordpress' => ['title' => 'Wordpress', 'icon' => 'fab fa-wordpress']
		];

		$html = '<div class="qa-share">';
		foreach ($social as $key => $value) {
			if( $key == 'pdf' ){
				$html .= '<a href="' . $url . '?pdf=1" target="_blank" class="qa-social2 btn btn-secondary btn-sm" title="' . $title . '">';
				$html .= '<i class="' . $value['icon'] . '"></i> ' . $value['title'];
				$html .= '</a> ';
			}else{
				$html .= '<button class="qa-social btn btn-secondary btn-sm" data-type="' . $key . '" data-url="' . $url . '" title="' . $title . '">';
				$html .= '<i class="' . $value['icon'] . '"></i> ' . $value['title'];
				$html .= '</button> ';
			}
		}
		$html .= '</div>';
		return $html;
	}

	public function breadcrumb()
	{
		$lang = (empty($this->_lang) ? 'ar' : $this->_lang);
		$action = (empty($this->_action) ? 'home' : $this->_action);
		$page = (intval($this->_pager) > 1 ? ' | ' . $this->lang('the_page') . ' ' . intval($this->_pager) : '');
		$title = (empty($this->title) ? $this->lang('main_title') : $this->title . $page);

		$not_allow = array('home');

		if (in_array($action, $not_allow) || $this->breadcrumb_hide) {
			$breadcrumb = '';
		} else {
			$breadcrumb = '<div class="container breadcrumb-container">';
			$breadcrumb .= '<nav aria-label="breadcrumb">';
			$breadcrumb .= '<ol class="breadcrumb custom-breadcrumb">';
			$breadcrumb .= '<li class="breadcrumb-item"><a href="' . $this->site_url() . '">' . $this->lang('home') . '</a></li>';
			$breadcrumb_list = $this->breadcrumb_list;
			if (is_array($breadcrumb_list)) {
				$parent_title = (isset($breadcrumb_list['title']) ? $breadcrumb_list['title'] : '');
				$parent_url = (isset($breadcrumb_list['url']) ? $breadcrumb_list['url'] : '');

				if (!empty($parent_title)) {
					$breadcrumb .= '<li class="breadcrumb-item"><a href="' . $parent_url . '">' . $parent_title . '</a></li>';
				} else {
					foreach ($breadcrumb_list as $key => $value) {
						$v_parent_title = (isset($value['title']) ? $value['title'] : '');
						$v_parent_url = (isset($value['url']) ? $value['url'] : '');
						if (!empty($v_parent_title)) {
							$breadcrumb .= '<li class="breadcrumb-item"><a href="' . $v_parent_url . '">' . $v_parent_title . '</a></li>';
						}
					}
				}
			}
			$breadcrumb .= '<li class="breadcrumb-item active" aria-current="page">' . $title . '</li>';
			$breadcrumb .= '</ol>';
			$breadcrumb .= '</nav>';
			$breadcrumb .= '</div>';
		}
		return $breadcrumb;
	}

	public function tpl_replace($text)
	{
		$page = (intval($this->_pager) > 1 ? ' | ' . $this->lang('the_page') . ' ' . intval($this->_pager) : '');
		$site_name = $this->site_name;
		$tagline = $this->site_tagline;
		$site_url = $this->site_url;
		$site_description = $this->site_description;
		$page_url = (empty($this->url) ? $site_url : $this->url);

		$get_tagline = (empty($tagline) ? '' : ($site_name == $tagline ? '' : ' | ' . $tagline));
		$og_type = (isset($_GET['action']) ? 'article' : 'website');

		if ($this->prefix_site_title == 1) {
			$current_site_title = $this->title . ' | ' . $site_name . $page;
		} else {
			$current_site_title = $this->title . $page;
		}

		$page_title = (empty($this->title) ? $site_name . $get_tagline : ($this->title == $site_name ? $this->title : $current_site_title));
		$page_description = (empty($this->description) ? $site_description : $this->description);
		$logo = $this->logo_site();
		$page_image = (empty($this->image) ? $this->site_url($this->theme_url) . '/images/og.jpg?v='.$this->version : $this->image);

		$body_class = $this->body_class;

		$page_title = strip_tags($page_title);
		$page_description = strip_tags($page_description);

		if ($this->lang('language') == 'ar') {
			$css = "\n" . '<link href="' . $this->site_url($this->theme_url) . '/css/bootstrap.rtl.min.css?v=5.0.1" rel="stylesheet">';
		} else {
			$css = '<link href="' . $this->site_url($this->theme_url) . '/css/bootstrap.min.css?v=5.0.1" rel="stylesheet">';
		}
		$css .= '<link href="' . $this->site_url($this->theme_url) . '/css/all.min.css?v=6.4.0" rel="stylesheet">' . "\n";
		$css .= '<link href="' . $this->site_url($this->theme_url) . '/css/style.css?v=' . $this->version . '_' . time() . '" rel="stylesheet">' . "\n";
		if ($this->lang('language') == 'ar') {
			$css .= '<link type="text/css" href="' . $this->site_url($this->theme_url) . '/css/rtl.css?v=' . $this->version . '_' . time() . '" rel="stylesheet">' . "\n";
		}

		$og = $css;
		$og .= "\n" . '<meta property="og:url" content="' . $page_url . '">' . "\n";
		$og .= '<meta property="og:type" content="' . $og_type . '">' . "\n";
		$og .= '<meta property="og:title" content="' . $this->title . '">' . "\n";
		$og .= '<meta property="og:description" content="' . $page_description . '">' . "\n";
		$og .= '<meta property="og:image" content="' . $page_image . '">' . "\n";
		$og .= '<meta property="og:locale" content="'.$this->lang('language').'">' . "\n";
		$og .= '<meta property="og:site_name" content="' . $site_name . '">' . "\n";
		$og .= '<meta name="twitter:card" content="summary_large_image">' . "\n";
		//$og .= '<meta name="twitter:site" content="@islamic_php">' . "\n";
		$og .= '<meta name="twitter:title" content="' . $this->title . '">' . "\n";
		$og .= '<meta name="twitter:description" content="' . $page_description . '">' . "\n";
		$og .= '<link rel="canonical" href="' . $page_url . '">' . "\n";
		$og .= $this->header_code;
		$og .= $this->home_header_code;

		if ($this->powered_by == 1) {
			$powered_by = '<p class="mb-0">'.$this->lang('site_name').' '.$this->lang('ver').' ' . $this->version . ' - '.$this->lang('dev').'</p>';
		} else {
			$powered_by = '';
		}

		$top_menu = ($this->hide_top_menu ? '' : $this->tpl_top_menu());
		$main_menu = ($this->main_menu_line ? $this->tpl_main_menu_line() : $this->tpl_main_menu());
		$main_menu_ul = $this->tpl_main_menu_line();
		$breadcrumb = $this->breadcrumb();

		$t_1 = array("{lang}", "{title}", "{site_name}", "{site_url}", "{description}", "{style}", "{js}", "{body_top_code}", "{body_bottom_code}", "{footer_code}", "{v}", "{logo}", "{social_media}", "{top_menu}", "{main_menu}", "{main_menu_ul}", "{powered_by}", "{breadcrumb}", "{body_class}");
		$t_2 = array($this->site_language, $page_title, $site_name, $site_url, $page_description, $this->site_url($this->theme_url), $og, $this->body_top_code, $this->body_bottom_code, $this->footer_code(), $this->version, $logo, $this->social_media(), $top_menu, $main_menu, $main_menu_ul, $powered_by, $breadcrumb, $body_class);

		$read = preg_replace_callback("/LANG\[([a-z0-9_]*?)\]/s", 'word_id', $text);
		$url = preg_replace_callback("/URL\[([a-z0-9_]*?)\]/s", 'url_id', $read);
		$code = str_replace($t_1, $t_2, $url);

		return $code;
	}

	public function tpl_header()
	{
		$openfile = $this->theme_url . "/header.html";
		if (!file_exists($this->theme_url)) {
			$read = '<div style="text-align:center;">FOLDER TEMPLATES <b>' . $this->theme_url . '</b> NOT FOUND</div>';
			exit;
		}
		if (!file_exists($openfile)) {
			$read = '<div style="text-align:center;">FILE TEMPLATE header.html NOT FOUND INSIDE FOLDER ' . $this->theme_url . '</div>';
			exit;
		}

		$writefile = fopen($openfile, "r");
		$read = fread($writefile, filesize($openfile));

		$read = $this->tpl_replace($read);

		fclose($writefile);
		return $read;
	}

	public function tpl_footer()
	{
		$openfile = $this->theme_url . "/footer.html";
		if (!file_exists($openfile)) {
			$read = '<div style="text-align:center;">FILE TEMPLATE footer.html NOT FOUND INSIDE FOLDER ' . $this->theme_url . '</div>';
		} else {
			$writefile = fopen($openfile, "r");
			$read = '';
			$read .= fread($writefile, filesize($openfile));
			$read = $this->tpl_replace($read);

			$wrapper = $this->footer_wrapper;
			$row = '';
			if( is_array($wrapper) && count($wrapper) > 0 ){
				$wrapperCount = count($wrapper);
			
				foreach ($wrapper as $value) {
					$title = ( isset($value['title']) ? $value['title'] : '' );
					$text = ( isset($value['text']) ? $value['text'] : '' );

					if( empty($text) && !is_array($value) ){
						$text = $value;
					}

					if ($wrapperCount == 1) {
						$class = 'col-12 col-md-12';
					} elseif ($wrapperCount == 2) {
						$class = 'col-6 col-md-6';
					} elseif ($wrapperCount == 3) {
						$class = 'col-12 col-md-4';
					} elseif ($wrapperCount == 4) {
						$class = 'col-12 col-md-3';
					} elseif ($wrapperCount == 6) {
						$class = 'col-6 col-md-2';
					} else {
						$class = 'col-6 col-md-3';
					}

					if( !empty($text) ){
						$row .= '<div class="' . $class . '">';
						$row .= '<div class="widget">';
						if( !empty($title) ){
							$row .= '<h3 class="widget_title">'.$title.'</h3>';
						}
						$row .= $text;
						$row .= '</div>';
						$row .= '</div>';
					}

				}
			}

			$bobes = '';
			if (!empty($row)) {
				$bobes .= '<div class="footer-wrapper">';
				$bobes .= '<div class="container">';
				$bobes .= '<div class="row g-3">';
				$bobes .= $row;
				$bobes .= '</div>';
				$bobes .= '</div>';
				$bobes .= '</div>';
			}

			$read = str_replace('[footer_wrapper]', $bobes, $read);

			fclose($writefile);
		}
		return $read;
	}

	public function tpl_content($title, $content)
	{
		$openfile = $this->theme_url . "/content.html";
		if (!file_exists($openfile)) {
			$read = '<div style="text-align:center;">FILE TEMPLATE content.html NOT FOUND INSIDE FOLDER ' . $this->theme_url . '</div>';
		} else {
			$writefile = @fopen($openfile, "r");
			$read = @fread($writefile, filesize($openfile));
			$read = str_replace("{title}", $title, $read);
			$read = str_replace("{text}", $content, $read);
			$read = str_replace("{style}", $this->theme_url, $read);
			@fclose($writefile);
		}
		return $read;
	}

	public function body_widget($right, $left)
	{
		$code = $this->tpl_header();
		$code .= '<div class="well">';
		$code .= '<div class="container" data-sticky-container>';
		$code .= $this->home_body_code;
		$code .= $this->body_top_code;
		$code .= $this->breadcrumb();
		$code .= '<div class="row g-3">';
		$code .= '<div class="col-12 col-md-8">';
		$code .= $right;
		$code .= '</div>';
		$code .= '<div class="col-12 col-md-4" data-sticky data-margin-top="80" data-sticky-for="768">';
		$code .= $left;
		$code .= '</div>';
		$code .= '</div>';
		$code .= '</div>';
		$code .= $this->body_bottom_code;
		$code .= $this->home_footer_code;
		$code .= '</div>';
		$code .= $this->tpl_footer();
		return $code;
	}

	public function body($text)
	{
		$class = ($this->full_screen ? 'full-screen-container' : 'container');
		$code = $this->tpl_header();
		$code .= '<div class="well">';
		$code .= '<div class="' . $class . '">';
		$code .= $this->home_body_code;
		$code .= $this->body_top_code;
		$code .= $this->breadcrumb();
		$code .= $text;
		$code .= '</div>';
		$code .= $this->body_bottom_code;
		$code .= $this->home_footer_code;
		$code .= '</div>';
		$code .= $this->tpl_footer();
		return $code;
	}

	public function view($text, $right='')
	{
		if ($this->close_site == 1) {
			$code = $this->close_site_allow;
		} else {
			if( !empty($right) || !empty($right) ){
				$code = $this->body_widget($text, $right);
			}else{
				$code = $this->body($text);
			}
		}
		return $code;
	}

	public function menu($type = 'top_menu', $remove_nav = false)
	{
		$this->nav_counter++;
		$type = ($type == 'top_menu' ? 'top_menu' : 'main_menu');
		$code = '';
		$html = '';
		$menu_key = ($type == 'top_menu' ? $this->top_menu : $this->main_menu);
		if (is_array($menu_key) && count($menu_key) > 0) {
			foreach ($menu_key as $k => $v) {
				$url = $v['url'];
				$li_attr = ( isset($v['attr']) ? ' '.$v['attr'] : '' );
				$child = '';
				if (isset($v['child']) && is_array($v['child']) && count($v['child']) > 0 && empty($li_attr)) {
					$li_class = 'nav-item dropdown';
					$a_class = 'nav-link dropdown-toggle';
					$url = '#';
					$attr = ' id="dropdown_' . $k . '" role="button" data-bs-toggle="dropdown" aria-haspopup="true" aria-expanded="false"';
					$child .= '<div class="dropdown-menu" aria-labelledby="dropdown_' . $k . '">';
					foreach ($v['child'] as $keyc => $valuec) {
						$child .= '<a class="dropdown-item" href="' . $valuec['url'] . '">' . $valuec['title'] . '</a>';
					}
					$child .= '</div>';
				} else {
					$li_class = 'nav-item';
					$a_class = 'nav-link';
					$attr = '';
				}
				if (isset($v['target']) && $v['target'] == 1) {
					$attr .= ' target="_blank"';
				}
				$code .= '<li class="' . $li_class . '">';
				$code .= '<a class="' . $a_class . '" href="' . $url . '"' . $attr . $li_attr.'>' . $v['title'] . '</a>';
				$code .= $child;
				$code .= '</li>';
			}

			if (!empty($code)) {
				if ($remove_nav) {
					$collapse_id = 'navbarNavDropdown_' . $this->nav_counter;
					if ($remove_nav) {
						$collapse_id .= $collapse_id . '_ul';
					}
					$html .= '<div class="mt-3 mb-3">';
					$html .= '<nav class="navbar navbar-expand-lg navbar-light bg-light">';
					$html .= '<button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#' . $collapse_id . '" aria-controls="' . $collapse_id . '" aria-expanded="false" aria-label="Toggle navigation"><span class="navbar-toggler-icon"></span></button>';
					$html .= '<div class="collapse navbar-collapse" id="' . $collapse_id . '">';
					$html .= '<ul class="navbar-nav">';
				}
				$html .= $code;
				if ($remove_nav) {
					$html .= '</ul>';
					$html .= '</div>';
					$html .= '</nav>';
					$html .= '</div>';
				}
			}
		}
		return $html;
	}

	public function social_media($nav = false)
	{
		$social_media = $this->social_media;
		if (is_array($social_media) && count($social_media) > 0) {
			$li = '';
			foreach ($social_media as $k => $v) {
				$title = (isset($v['title']) ? $v['title'] : '');
				$link = (isset($v['url']) ? $v['url'] : '');
				$icon = (isset($v['icon']) ? $v['icon'] : '');
				$show = (isset($v['show']) ? $v['show'] : 0);

				if (!empty($icon)) {
					$title = $icon;
				}

				if ($show == 1) {
					$li .= '<li id="social-media-' . $k . '" class="list-inline-item social-media-' . $k . '"><a target="_blank" href="' . $link . '" rel="nofollow">' . $title . '</a></li>';
				}
			}

			if (empty($li)) {
				$output = '';
			} else {
				$calss = ($nav ? ' ms-auto' : '');
				$output = '<ul class="social-media list-inline mb-0' . $calss . '">';
				$output .= $li;
				$output .= '</ul>';
			}
		} else {
			$output = '';
		}
		return $output;
	}

	public function footer_code()
	{
		$code = $this->footer_code;

		if ($this->navbar_sticky) {
			$code .= '<script>
					window.onscroll = function() {myFunction()};

					var navbar = document.getElementById("navbar-sticky");
					var sticky = navbar.offsetTop;

					function myFunction() {
					  if (window.pageYOffset >= sticky) {
					    navbar.classList.add("sticky")
					  } else {
					    navbar.classList.remove("sticky");
					  }
					}
					</script>';
		}

		if ($this->overlay_navigation) {
			$code .= '<script>
	function openNav() {
	  document.getElementById("menu-navigation").style.width = "100%";
	}

	function closeNav() {
	  document.getElementById("menu-navigation").style.width = "0%";
	}
	</script>';
		}
		return $code;
	}

	public function overlay_navigation()
	{
		$html = '<div id="menu-navigation" class="overlay-navigation">
<a href="javascript:void(0)" class="closebtn" onclick="closeNav()">&times;</a>
<div class="overlay-navigation-content">
	<ul class="navbar-nav">
	' . $this->menu('main_menu') . '
	</ul>
	' . $this->social_media() . '
	' . $this->change_color('-overlay') . '
</div>
</div>';

		return $html;
	}

	public function tpl_top_menu()
	{
		if ($this->overlay_navigation) {
			$attr = 'onclick="openNav()"';
			$overlay_navigation = $this->overlay_navigation();
		} else {
			$attr = 'data-bs-toggle="collapse" data-bs-target="#navbarCollapse" aria-controls="navbarCollapse" aria-expanded="false" aria-label="Toggle navigation"';
			$overlay_navigation = '';
		}
		$nav = $overlay_navigation;
		$nav .= '<nav class="navbar navbar-expand-md article-top-navbar">
	  <div class="container">
	    <button class="navbar-toggler" type="button" ' . $attr . '>
	      <i class="fas fa-bars"></i>
	    </button>
	    <div class="collapse navbar-collapse" id="navbarCollapse">
	      <ul class="navbar-nav me-auto top-menu-align">
	      ' . $this->menu('top_menu') . '
	      </ul>
	      <div class="clearfix"></div>
	      <div class="form-inline mb-0">' . $this->social_media() . '</div>
	    </div>
	    </div>
	  </nav>';
		return $nav;
	}

	public function tpl_main_menu()
	{
		if ($this->overlay_navigation) {
			$attr = 'onclick="openNav()"';
			$overlay_navigation = $this->overlay_navigation();
		} else {
			$attr = 'data-bs-toggle="collapse" data-bs-target="#navbarCollapseMain" aria-controls="navbarCollapseMain" aria-expanded="false" aria-label="Toggle navigation"';
			$overlay_navigation = '';
		}
		$nav = $overlay_navigation;
		$nav .= '<div class="navbar-container sticky-container" id="navbar-sticky">';
		$nav .= '<nav class="navbar navbar-expand-md navbar-two-col">';
		$nav .= '<div class="container">';
		$nav .= '<a href="' . $this->site_url . '"><img class="mw-100 site-logo"  alt="' . $this->site_name . '" src="' . $this->logo_site() . '" /></a>';
		$nav .= '<button class="navbar-toggler" type="button" ' . $attr . '>';
		$nav .= '<i class="fas fa-bars"></i>';
		$nav .= '</button>';
		$nav .= '<div class="collapse navbar-collapse" id="navbarCollapseMain">';
		$nav .= $this->social_media(true);
		$nav .= $this->change_color();
		$nav .= '<ul class="main-navbar navbar-nav ms-auto">';
		$nav .= $this->menu('main_menu');
		$nav .= '</ul>';
		$nav .= '</div>';
		$nav .= '</div>';
		$nav .= '</nav>';
		$nav .= '</div>';
		return $nav;
	}

	public function tpl_main_menu_line()
	{
		$div = '<div class="logo-wrapper">
			<div class="container">
				<div class="text-center"><a href="' . $this->site_url . '"><img class="mw-100 site-logo"  alt="' . $this->site_name . '" src="' . $this->logo_site() . '" /></a></div>
			</div>
		</div>
		<div class="container">
			' . $this->menu('main_menu', true) . '
		</div>';

		return $div;
	}
}
