function searchList() {
    var input, filter, qa, questions, a, i, txtValue, c, r, lang;
    input = document.getElementById('qaInput');
    filter = input.value.toUpperCase();
    qa = document.getElementById("questionsList");
    questions = qa.getElementsByClassName('qa-question');
    r = document.getElementById("questionsResult");
    lang = document.documentElement.lang;

    c = 0;
    for (i = 0; i < questions.length; i++) {
        a = questions[i].getElementsByTagName("a")[0];
        txtValue = a.textContent || a.innerText;
        if (txtValue.toUpperCase().indexOf(filter) > -1) {
            c++
            questions[i].style.display = "";
        } else {
            questions[i].style.display = "none";
        }
    }

    if( c == 0 ){
        var str;
        if( lang == 'ar' ){
            str = 'لا يوجد نتائج للبحث';
        }else{
            str = 'Not Found';
        }
        r.innerHTML = '<div class="alert alert-danger mb-0 p-2">' + str + '</div>';
    }else{
        r.innerHTML = '';
    }
}

function changeLogo(x) {
    const logo = document.getElementsByClassName("site-logo");
    var lang = document.documentElement.lang;

    if( lang == 'ar' ){
        var getLogo = logo[0].attributes.src.value.replace(/logo.png|logo-(.*?).png/g, "logo-"+x+".png");
        var newLogo = getLogo.replace("logo-cyan", "logo");
    }else{
        var getLogo = logo[0].attributes.src.value.replace(/logo.png|logo-(.*?).png/g, "logo-"+x+"-en.png");
        var newLogo = getLogo.replace("logo-cyan", "logo");
    }
    
    logo[0].attributes.src.value = newLogo;
}

function check(x) {
    changeLogo(x);

    localStorage.setItem("color", x);
    document.body.className = '';
    document.body.classList.add(x);

    var cc = document.getElementsByClassName("choose-color");
    var cc2 = document.getElementsByClassName("choose-color2");
    for (var i = 0; i < cc.length; i++) {
        var className = cc[i].attributes.id.value.replace("color-", "");
        var className2 = cc2[i].attributes.id.value.replace("color-", "");
        if( className == x ){
            cc[i].style.border = '1px solid #000';
            cc[i].style.opacity = .5;
        }else{
            cc[i].style.border = 'none';
            cc[i].style.opacity = 1;
        }

        if( className2 == x ){
            cc2[i].style.border = '1px solid #000';
            cc2[i].style.opacity = .5;
        }else{
            cc2[i].style.border = 'none';
            cc2[i].style.opacity = 1;
        }
    }

    var c = document.getElementById("color-" + x);
    var c2 = document.getElementById("color-" + x + '-overlay');
    c.style.border = '1px solid #000';
    c.style.opacity = .5;
    c2.style.border = '1px solid #000';
    c2.style.opacity = .5;
}

function qaLoad() {
    var s = localStorage.getItem("color");

    if( s != null ) {
        changeLogo(s);
        document.body.className = '';
        document.body.classList.add(s);

        var c = document.getElementById("color-" + s);
        var c2 = document.getElementById("color-" + s + '-overlay');
        c.style.border = '1px solid #000';
        c.style.opacity = .5;
        c2.style.border = '1px solid #000';
        c2.style.opacity = .5;
    }

}

$(document).on('click', '.qa-social', function(e){
    var url = $(this).data("url");
    var type = $(this).data("type");
    var title = $(this).attr("title");

    if( type == "facebook" ) url = 'https://www.facebook.com/sharer.php?u=' + url;
    if( type == "twitter" ) url = 'https://twitter.com/share?url=' + url + "&text=" + title;
    if( type == "pinterest" ) url = 'https://pinterest.com/pin/create/bookmarklet/?url=' + url + "&description=" + title;
    if( type == "linkedin" ) url = 'https://www.linkedin.com/shareArticle?url=' + url + "&title=" + title;
    if( type == "whatsapp" ) url = 'https://api.whatsapp.com/send?text=' + title + " " + url;
    if( type == "buffer" ) url = 'https://bufferapp.com/add?url=' + url + "&text=" + title;
    if( type == "tumblr" ) url = 'https://www.tumblr.com/share/link?url=' + url + "&name=" + title;
    if( type == "reddit" ) url = 'https://reddit.com/submit?url=' + url + "&title=" + title;
    if( type == "mix" ) url = 'https://mix.com/add?url=' + url;
    if( type == "evernote" ) url = 'https://www.evernote.com/clip.action?url=' + url + "&title=" + title;
    if( type == "pocket" ) url = 'https://getpocket.com/save?url=' + url + "&title=" + title;
    if( type == "wordpress" ) url = 'https://wordpress.com/press-this.php?u=' + url + "&t=" + title;

    window.open(url, '', "width=500,height=500,left=400px,top=100px,location=no");
});

function playAudio(ev,obj,src){
    var base = 'https://kids.islamenc.com/assets/audios/ar';
    var file = base+'/'+src+'.mp3';
    ev.stopPropagation();
    ev.preventDefault();
    if($("#main_audio").attr('src') == file){
        $("#main_audio").attr('src','').hide()[0].pause();
        return;
    }
    $("#main_audio").attr('src',file).show()[0].play(); 
    
    if($(obj).parents('.collapse-item').find('.collapse').is(':hidden')){
        $(obj).parents('.collapse-item').find('.collpase-btn').click();
    }
}

if(location.hash.indexOf('question')){
    var elem = document.getElementById(location.hash.substring(1)+"_cnt");
    if(elem){
        elem.classList.add('show')
    }  
}
function navTo(link){
    const param = link.href.split('#')[1].split(':~:');
    document.getElementById(param).scrollIntoView({behavior: "smooth"});
    document.title = $(link).children('.question-span').text() + ' - ' + document.title.split(' - ').pop();
    setTimeout(function(){
        location.hash = '#'+link.href.split('#')[1];
    },500);
}