<?php
$data = [
  'title' => 'What Muslim Children Must Know',
  'description' => 'A project that contains a simple and easy curriculum for issues that a Muslim must know. It includes issues of belief, jurisprudence, prophetic biography, etiquette, tafsir, hadith, morals, and remembrance of Allah. It is suitable for young children in particular, for all ages, and newcomers to Islam.',
  'source' => 'https://kids.islamenc.com/ak/home',
  'author' => 'Yazan Abdul Razzaq Raziq Alghanim',
  'sections' => [
    0 => 'Aqeeda ɛnkyekyɛmo (Gyedie)',
    1 => 'Fiqhu ɛnhyehyɛmo.',
    2 => 'ɔkomhyane Abakwasɛm afam',
    3 => 'Tafseer Afamo',
    4 => 'Ɔkɔmhyɛni nsɛm (Hadis) afa',
    5 => 'Ɛfa a ɛfa Nkramosom Suban ho',
    6 => 'Ɛfa a ɛfa Suban ho',
    7 => 'Mpaebo ɛne Azkaar afa mo',
    8 => 'Ɛnkyekyɛmu ahoroɔ',
  ],
  'data' => [
    1 => [
      0 => [
        'question' => 'Asɛmbosa 1: Wae nayɛ wo Awurade?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/200.mp3',
        'answer' => '<p> Anuye- Me Awurade nayɛ Allaah deɛ ɔyɛ me Awurade ɛne mɔ Awurade adasanma nyinara ɛfa na adom mo.<span class="c6"><br /> ɛna ɛngyinasoɔ :</span> ɛfa ɔkɛsie kasa: <span class="c4">{ Aseda nyinara ɛyɛ Awurade ɛdea 2}</span>. <span class="c5">[ Suuratul Faatiha: 2]</span>. </p>',
      ],
      1 => [
        'question' => 'Asɛmbosa 2:Deɛbɛn nayɛ wosom ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/240.mp3',
        'answer' => '<p> Anuye- Mesom yɛ Islam,<span class="c6"> ɛna ɛno nayɛ :</span> wode wohɔ ama Onyame ɛfa nekropɛ tawoheede nimdie,ɛna wobɛtwire wohɔ ama neteɛ ɛdeso,ɛna wobɛgyae afiri adeɛ a ɛyɛ abosomsom ɛne deɛ ɛkaho nyinara.<span class="c6"><br /> Na ɔkrɔnkɔnii kɛsie akasɛ:</span> <span class="c4">{ Nokorɛ ɛsom ɛfiri Onyame ho yɛ Islam}</span>. <span class="c5">[Suuratul Aali Imraan 19]</span>. </p>',
      ],
      2 => [
        'question' => 'Asɛmbosa 3: Wae nayɛ wo komhyane?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/280.mp3',
        'answer' => '<p> Anuye- ɔyɛ Mohammɛd Onyame asomdwie nka nɔ.<span class="c6"><br /> Na ɔkrɔnkɔnii kɛsie akasɛ:</span> <span class="c4">{ Mohammɛd Onyame somafoɔ}</span>. <span class="c5">[ Suuratul Fathi: 29]</span>. </p>',
      ],
      3 => [
        'question' => 'Asɛmbosa 4: ka kasa ɛfa tawoheede nimdie hɔ,ɛne nasekyerɛ deɛ ɛkyerɛ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/310.mp3',
        'answer' => '<p> Anuye-<span class="c6">kasa ɛfa tawoheede hɔ \'\'Laa ilaaha illallaah\'\' ɛna nasekyerɛ sɛ :</span> adesom biara nneho nokorɛ mo ɛsom agye Onyame Allah.<span class="c6"><br /> Na ɔkrɔnkɔnii kɛsie akasɛ:</span> <span class="c4">{ Na kae hunu sɛ nokware ɔnɔ nɔ nayɛ deɛ ɔbiara nneho nokware mo agye ɔno Allaah}</span>. <span class="c5">[ Suuratul Mohammɛd: 19]</span>. </p>',
      ],
      4 => [
        'question' => 'Asɛmbosa 5: Onyame krɔnkɔ ɔtumifuo nɔ ɔwɔ heni?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/350.mp3',
        'answer' => '<p> Anuye- Onyame Allaah ɔwɔ ho ɛwɔ ɔsoro aruhye soro,ɛwɔ nabɔdeɛ nyinara ɛsoro,<span class="c6">ɔkɛsie akasɛ:</span> <span class="c4">{ Arrahamaan ɔho ahenie npaso aruhyi pɛpɛɛ mo \'\'istawa\' 5}</span>. <span class="c5">[ Suuratul Taaha:5]</span>.<span class="c6"> ɛna wakasɛ:</span> <span class="c4">{ ɛna ɔnɔ nɔ nayɛ ɔtumifuo ɛkɔm ɛwɔ nenkoa ɛsoro so,ɛna ɔnɔ nayɛ yansawura adwene wura18}</span>. <span class="c5">[ Suuratul An\'aam: 18]</span>. </p>',
      ],
      5 => [
        'question' => 'Asɛmbosa 6: Deɛbɛn nayɛ adansie nokware sɛ Mohammɛd yɛ Onyame somanee asekyerɛ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/380.mp3',
        'answer' => '<p> Anuye-<span class="c6"> Nasekyerɛ sɛ:</span> nokorɛ Onyame asoma nɔ ama adasanma nyinara anuba kasa yɛnee ɛne kwɔkwɔboyɛnee.<span class="c6"><br /> ɛna ɛfata sɛ:</span><br /> 1- Asoteɛ ɛdiso ɛfa deɛ yahyɛ wo.<br /> 2- Wogyeatom ɛfa deɛ yabo wo amanieɛ.<br /> 3- Na wobɛgyae boneyɛ.<br /> 4- Wonsom Onyame Allaah agye ɛfa deɛ wayɛ hɔ mmera.<span class="c6"><br /> ɔkɛsie akasɛ:</span> .<span class="c4">{ Deɛ ɔbɛdi somafoɔ akyi na nokware wadi Onyame Allaah akye}</span>. <span class="c5">[Suuratul Nisaai:80]</span>,<span class="c6"> ɛna ɔkronkɔ akasɛ:</span> <span class="c4">{ ɛna ɛnyɛ adeɛ a ɔde napɛdeɛ ɛkasa 3 agyesɛ ɔnɔ nɔ agye ayedeɛ yekyerɛ ɛna yɛye ɛkyerɛ nɔ 4}</span>. <span class="c5">[ Suuratul Najm:3,4]</span>.<span class="c6"> ɛna ɔtumifuo ɔkɛsie:</span> <span class="c4">{ Nokorɛ nokware mo ɛyɛ adeɛ a wagyae amayɛ Onyame somafoɔ subae pa ɛsuasua ɛdema deɛ ɔhwihwɛ Onyame anidaasoɔ ɛne atamoada ɛda ɛna ɔtomtom Onyame dodoɔ 21}</span>. <span class="c5">[ Suuratul Ahzaab: 21]</span>. </p>',
      ],
      6 => [
        'question' => 'Asɛmbosa 7: Deɛbɛn ntira na Onyame kɛsie abɔyɛ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/480.mp3',
        'answer' => '<p> Anuye- ɔrebɔɔyɛ ɛfa nesom nti ɛne yɛbɛyɛ nɔ krɔpɛ na yɛnyɛ nɔ nfatahɔ.<br /> ɛnyɛ ɛfa ahohodeɛ ɛne agorɔdie.<span class="c6"><br /> Na ɔkrɔnkɔnii kɛsie akasɛ:</span> <span class="c4">{ ɛna ɛnyɛ adeɛ a yabɔ asaasebɔadensi\'\'jinni\'\' ɛne nipa saakwa agye ɛfa sɛ ɔmɔ ɛbɛsom me }</span> <span class="c5">[ Suuratul Dhaariyaat: 56]</span>. </p>',
      ],
      7 => [
        'question' => 'Asɛmbosa 8: Deɛbɛn nayɛ ɛsom \'\'Ibaada\'\'?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/530.mp3',
        'answer' => '<p> Anuye- ɛyɛ ɛdii ɛbom ɛfa adeɛ biara deɛ Onyame ɛpɛ ɛna wapene so afiri kasa mo ɛne dwumadie awinta ɛne adaade.<br /> Anuye- ɛyɛ ɛdii ɛbom ɛfa adeɛ biara deɛ Onyame ɛpɛ ɛna wapene so afiri kasa mo ɛne dwumadie awinta ɛne adaade.<span class="c6"><br /> Awinta \'\'Al Baatinatu:</span> ɛnfatohɔ nom bi ne Atwire ɛne ɛhuu ɛne anidaasoɔ. </p>',
      ],
      8 => [
        'question' => 'Asɛmbosa 9: Deɛbɛn na ɛso ɛdemo ɛyɛnhyɛ ɛwɔ yɛso?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/580.mp3',
        'answer' => '<p> Anuye-<span class="c6"> Adeɛ a ɛdemo ɛso yɛnhyɛ ɛwɔ yɛso :</span> nayɛ Onyame Allaah krɔpɛ hɔ nimdie \'\'Tawoheede\'\'ɔkɛsie. </p>',
      ],
      9 => [
        'question' => 'Asɛmbosa 10: Adeɛbɛn nayɛ Tawoheede nkyekyɛmo?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/610.mp3',
        'answer' => '<p> Anuye-1-<span class="c6"> Tawoheede Rubiibiyya:</span> ɛno nayɛ gyedie ɛfa sɛ nokware Onyame Allaah ɔnɔ nayɛ ɔbɔadeɛ ahɔya wura ɔtumifuo ɔdanidanifoɔ,ɔnɔ nkoaa na yɛnyɛ nɔ ɛnpatahɔ.<br /> 2-<span class="c6"> Tawoheede Auluuhiyya:</span> ɛno nayɛ Onyame Allaah baakopɛ ɛyɛ ɛfa nesom,na ɛnyɛ adeɛ a ɔbi ɛbɛsom obi aka nehɔ agye ɔnɔ nkoaa Allaah ɔkɛsie.<br /> 3-<span class="c6"> Tawoheede Al asmaa\'a Wassiffaati:</span> ɛno nayɛ gyedie ɛfa Onyame Allaah ɛdii ɛne nesu ɔkɛsie ɛfa deɛ aba ɛwɔ quraan ɛne sunna mo,ɛna ɛfiri nakyi yɛnne ɛnsɛsoɔ bi anaasɛ ɔsɛ biribi anaasɛ yɛhyɛ neso ɔnne tumi.<span class="c6"><br /> ɛna ɛngyinasoɔ ɛfa tawoheede ɛnkyekyɛmo mmiensa:</span> ɛwɔ ɔkɛsie kasa mo: <span class="c4">{ ɔsoro nsu ɛne asaase mo ɛne adeɛ a ɛwɔ ɛmo ɛntɛm Awurade na mɔnsom nɔ ɛna mɔnsi abotarɛ ɛfa nesom hɔ,Asɛnti wonim ɛfa nedii hɔ yɛ de ato obi 65}</span>. <span class="c5">[ Suuratul Maryam:65]</span>. </p>',
      ],
      10 => [
        'question' => 'Asɛmbosa 11: Boneyɛ bɛn nasu ɛyie?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/670.mp3',
        'answer' => '<p> Anuye- ɛyɛ Abosomsom anaasɛ ɛnpatahɔ ɛka Onyame Allaah ɔkɛsie hɔ.<span class="c6"><br /> Na ɔkrɔnkɔnii kɛsie akasɛ:</span> <span class="c4">{ Nokorɛ Onyame ɛnyɛ adeɛ a ɔbiara ɔbɛyɛ nɔ abosomsom anaasɛ ɛnpatahɔ bone ɛbɛkyɛ nɔ da ɛfahɔ ɛna ɔde bone biara ɛkyɛ ɛfiri deɛ ɛyɛ wɛi akye ɛfa deɛ ɔpɛ ɛna obiara ɔbɛyɛ afa Onyame ɛnpatahɔ na nokware na wafrɛfrɛ bone kasie ɛyie 48}</span>. <span class="c5">[ Suuratul Nisaai:48]</span> </p>',
      ],
      11 => [
        'question' => 'Asɛmbosa 12: bobɔ ɛnpatahɔ hyerik ɛne nenkyekyɛmo?0',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/710.mp3',
        'answer' => '<p> Anuye-<span class="c6"> Hyerik:</span> ɛno nayɛ adanidani ɛkyerɛ baako ɛfiri dodoɔ ɛsom ɛfiri Onyame kɛsie akye.<span class="c6"><br /> Nenkyekyɛmo:</span><br /> Hyeriki Akbaru\'\'kɛsie\'\' ;ɛnsɛsoɔ ɛtisɛ: ɔfrɛ obi afiri Onyame kɛsie akye,anaasɛ ɔbɛyɛ sujuudu afiri ɔkronkɔ Onyame akye,anaasɛ wobɛtwa akɔm aboa bi afiri ɔtumifoɔ ɔkɛsie Onyame akye.<span class="c6"><br /> SHyerik Asgar \'kitua\' :</span>ɛnsi di ɛfa ɛfiri Onyame kɛsie akye, anaasɛ sabɛ,ɛna ɛno nayɛ deɛ ɛtwire ho ɛfiri dwumadie mo ɛfa nfasoɔ ɛma anaasɛ woma ɛhao,ɛna ɛnante yɛkyerɛ mo,nokorɛ ɛtisɛ wayɛ wo nyamefrɛ ɛyie sɛdeɛ nipa nom ɛbɛhunu ahwɛ wɔhɔ. </p>',
      ],
      12 => [
        'question' => 'Asɛmbosa 13: Sɛnti obi ɛnim ɛnsumayɛ nsɛm a awinta ɛwɔ Onyame kɛsie akye anaa?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/770.mp3',
        'answer' => '<p> Anuye- ɔbiara nneho a ɔnim ɛnsumayɛ monsɛm agye Onyame krɔpɛ nkoaa nanim.<span class="c6"><br /> Na ɔkrɔnkɔnii kɛsie akasɛ:</span> <span class="c4">{ Kasɛ ɔbiara nneho a ɔnim ɛnsumayɛ nsɛm a ɛho ɔsoro nsu ɛne asaase mo agye Onyame Allaah ɛna obiara nnim ɛdaa yɛ bɛyane yɛ 65}</span>. <span class="c5">[ Suuratul Naml: 65]</span>. </p>',
      ],
      13 => [
        'question' => 'Asɛmbosa 14: \'\'Iimaan\'\'Gyedie Afapim dodoɔ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/810.mp3',
        'answer' => '<p> Anuye- 1- Gyedie ɛfa Onyame kɛsie Allaah hɔ.<br /> ne na Asoroboafoɔ.<br /> 3- ɛna Nenwoma.<br /> 4- ɛne nasomafoɔ.<br /> 5- ɛne Atamoada awieyɛ ɛda.<br /> 6- ɛne ɛnhyehyɛyɛ adepa anaasɛ nemosoɔ ɛhao.<span class="c6"><br /> ɛna ɛngyinasoɔ :</span> Hadiis gyibreel yɛnim ɛwɔ muslim mo,<span class="c6"> gyibreel ɛkakyerɛ ɛfa ɔkomhyane Onyame asomdwie nka nɔ:</span> <span class="c3">«Na yekyerɛ me adeɛ a ɛyɛ gyedie,<span class="c6">ɔkaasɛ :</span> sɛ wobɛgye Onyame atom,ɛne asoroboafoɔ,ɛne nenwoma,ɛne nesomafoɔ,ɛne atamoada awieyɛ ɛda,ɛna wobɛgye atom afa ɛnhyehyɛyɛ ne adepa mo anaasɛ nemosoɔ mo»</span>. </p>',
      ],
      14 => [
        'question' => 'Asɛmbosa 15: yɛ ɛnkyerɛ kyerɛ ɛfa gyedie afapim?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/900.mp3',
        'answer' => '<p> Anuye- Gyedie ɛfa Onyame kɛsie Allaah hɔ.<br /> Sɛ wobɛya gyedie ɛfa nokware Onyame hɔ ɔnɔ nayɛ deɛ wabɔyɛ ɛna wamayɛ agyapadeɛ,ɛna ɔnɔ nayɛ ɔhene wura ɛne ɔdanidani nee ɔkrɔpɛ ɛfa abɔadeɛ.<br /> ɛna ɔnɔ nayɛ deɛ yɛsom nɔ,yɛnsom obiara agye ɛfa nokorɛ mo nakye.<br /> ɛna nokware ɔnɔ nayɛ kɛsie ɛbae ɛmua deɛ ɔwɔ aseda nyinara,ɛna ɔnɔ na ɔwɔ ɛdii fɛfɛɛfɛ ɛne ɛsu a ɛkrɔn soro,ɔnne adeɛ a ɛyɛ npatahɔ,ɛna ɛnyɛ adeɛ a ɔkrɔnkɔ nee ɛsesɛ biribiara.<span class="c6"><br /> Gyedie ɛfa Asoroboafoɔ:</span><br /> ɛna ɛyɛ abɔadeɛ na Onyame nabɔɔyɛ ɛfiri ɛhae nhyerɛne \'Nuur\',ɛna ɛfa nesom ɛna ɛfa atwire hɔ ɛmua ɛfa nenhyehyɛyɛ.<br /> - ɛna ɛfiri wɔnnom mo gyibreel Onyame asomdwie nka nɔ deɛ ɔsani ɛfa yekyerɛ ɛwɔ akomhyafoɔ mo.<br /> Gyedie ɛfa Nwoma/Buuku<br /> ɛna ɛyɛ nwoma deɛ Onyame asani ama nasomafoɔ.<br /> -<span class="c6"> ɛtisɛ Quraan:</span> ɛwɔ Mohammɛd so Onyame asomdwie nka nɔ.<br /> -<span class="c6"> Engyeel:</span> yɛ de ama Eesa Onyame asomdwie nka nɔ.<br /> -<span class="c6"> TAWRAAT:</span> yɛ de ama Musa Onyame asomdwie nka nɔ.<br /> -<span class="c6"> ZABOUR:</span> yɛ de ama Daawoodu Onyame asomdwie nka nɔ.<br /> -<span class="c6"> ɛyɛ apam suhufi Ibraheem ɛne Mosa:</span> yɛ de ama Ibraheem ɛne Mosa.<span class="c6"><br /> Gyedie ɛfa asomafoɔ:</span><br /> ɛna ɔmɔ nayɛ deɛ Onyame asoma ɔmɔ ama nenkoa sɛdeɛ ɔmɔ ɛbɛkyerɛ wɔnnom,ɛna ɔmɔ ɛbɛkakyerɛ wɔnnom anohuba kasa dɛ ɛfa adepa ɛne aljannah,ɛna ɔbɛbo ɔmɔ kwɔkwɔbɔ wɔ mosoɔ ɛne amanehunu ɛgya.<br /> -<span class="c6"> ɛna deɛ ɔdemo ɛwɔ wɔnnom mo:</span> Aulul Azim,<span class="c6">wɔnnom nayɛ:</span><br /> Noah Onyame asomdwie nka nɔ.<br /> Abraham Onyame asomdwie nka nɔ.<br /> Mosa Onyame asomdwie nka nɔ<br /> Eesa Onyame asomdwie nka nɔ.<br /> Mohammɛd Onyame nka nɔ.<span class="c6"><br /> Gyedie ɛfa awieyɛ ɛda:</span><br /> ɛna ɛno nayɛ deɛ ɛwɔ ɛwuo akye ɛwɔ adakamina mo,ɛna atamoada ɛda,ɛna yaniyɛ ɛne akwɔntabuo ɛda,ɛwɔ mmerɛ a atimtim ama aljannafoɔ ɛwɔ ɔmɔ suɛbrɛ ɛna ɛgyamfoɔ wɔ ɔmɔ tinabrɛ.<br /> - ɛne ɛnhyehyɛyɛ adepa anaasɛ nemosoɔ ɛhao.<span class="c6"><br /> ɛnhyehyɛyɛ:</span> ɛno nayɛ atwire nokware ɛfa Onyame ɔnim biribiara ɛbɛsi wiase mo nyinara,ɛna nokware mo saa no yatworɔ wɔ lauhul mahafuuz,ɛna ɔpɛ a ɛwɔ ho ɛma no ɛne nabɔdeɛ mo.<span class="c6"><br /> Onyame kɛsie aka:</span> <span class="c4">{Nokware adeɛ biara yabɔ no ɛnhyehyɛyɛ mo49}</span>. <span class="c5">[Suuratul Qamar 49]</span>.<br /> -<span class="c6">ɛna ɛno no ɛwɔ ɛndidisoɔ ɛnae:</span><br /> ɛdikae: Onyame kɛsie nimdie mo,ɛna ɛfiri saa no nenimdie ɛdikae ɛfa biribiara mo,ansaana adeɛ no asi ɛna anoakye ɛsi.<span class="c6"><br /> ɛna ɛngyinasoɔ :</span> ɛfa ɔkɛsie kasa: <span class="c4">{ Nokorɛ Onyame neho na mmerɛ atamoada nimdie ho ɛna ɔnɔ nasane nsuoto ɛna ɔnim deɛ ɛwɔ awodeɛ mo ɛna ɛnyɛ adeɛ a kiraa bi ɛnim deɛ ɛbɛsi daakye bi ɛna ɛnyɛ adeɛ a kiraa bi ɛnim asaase a ɔbɛwu ada nokorɛ Onyame nayɛ nimdiewura yansawura 34}</span>. <span class="c5">[ Suuratul Luckman:34]</span>.<span class="c6"><br /> Mmienu:</span> Nokorɛ Onyame atworɔ saa ɛwɔ lauhul maafuuz mo,na adeɛ biara ɛsi ɛna ɛbɛsi na ɛyɛ adeɛ a yatworɔ wɔ nenkyɛ ɛwɔ nwoma nom.<span class="c6"><br /> ɛna ɛngyinasoɔ :</span> ɛfa ɔkɛsie kasa: <span class="c4">{ɛna nenkyɛ na ɛnsumayɛ mo safoa ɛho ɛnyɛ adeɛ a obi ɛnim agye ɔnɔ,ɛna ɔnim deɛ ɛwɔ asaase mo ɛne ɛpɔnsuo mo, ɛna deɛ ɛbɛtɔ ate afiri ahahabae mo agye ɔnim anaasɛ aba a ɛwɔ asaase sum mo anaasɛ deɛ yɛ munu anaasɛ deɛ awu agye ɛwɔ nwoma pɛfɛɛ mo-59}</span> <span class="c5">[ Suuratul An\'aam: 59]</span>.<span class="c6"><br /> Mmiensa:</span> ɛna ɛno no yɛ sɛ adeɛ biara a ɛsi ɛfa Onyame ɛpɛ mo anaasɛ ɛnyɛ adeɛ a ɛbɛsi afiri mo anaasɛ ɛfiri nabɔdeɛ mo agye ɛfa nepɛ ɔkɛsie.<span class="c6"><br /> ɛna ɛngyinasoɔ :</span> ɛfa ɔkɛsie kasa: <span class="c4">{ Deɛ ɔpɛ ɛfiri mɔ mo nom sɛ ɔntimtim 28 ɛna ɛnyɛ adeɛ a wopɛ agye sɛ deɛ Onyame ɛpɛ adasamae Awurade 29}</span>. <span class="c5">[ Suuratul Takwiir: 28,29]</span>.<span class="c6"><br /> ɛnae:</span> Gyedie nokware sɛ nkwɔyaye nyinara yɛ abɔdeɛ na Onyame nabɔɔyɛ,ɛna wabɔ wɔnnom biara ɛne ɔmɔ ɛsu ɛne ɔmɔ nkekahɔ,ɛna adeɛ biara ɛwom.<span class="c6"><br /> ɛna ɛngyinasoɔ :</span> ɛfa ɔkɛsie kasa: <span class="c4">{ ɛna Onyame nabɔɔ mɔ ɛne deɛ mɔyɛ nyinara 96}</span>. <span class="c5">[ Suuratul Safaat: 96]</span>. </p>',
      ],
      15 => [
        'question' => 'Asɛmbosa 16: Deɛbɛn nayɛ Quran asekyerɛ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/1300.mp3',
        'answer' => '<p> Anuye- ɛno no nɛyɛ Onyuame kɛsie nɔ kasa,na ɛnyɛ ɛfa abɔdeɛ.<span class="c6"><br /> Na ɔkrɔnkɔnii kɛsie akasɛ:</span> <span class="c4">{ɛnasɛ abosomsomfoɔ nom bi ɛba wonkyɛ a natwine ɛbɛɛwo ɛkwɔpimsɛ ɔbɛteɛ Onyame asɛm}</span>.<span class="c6"> Suratul Tawba:</span> 6]. </p>',
      ],
      16 => [
        'question' => 'Asɛmbosa 17: Deɛbɛn nayɛ Sunnah?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/1330.mp3',
        'answer' => '<p> Anuye- ɛyɛ kasa biara anaasɛ dwumadie anaasɛ ɛntimtimyɛ anaasɛ ɛsu subae,anaasɛ subae ɛfa ɔkomhyane hɔ Onyame asomtwie nka nɔ. </p>',
      ],
      17 => [
        'question' => 'Asɛmbosa18: Deɛbɛn nayɛ Bid\'atu? Sɛnti yɛgyetom?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/1350.mp3',
        'answer' => '<p> Anuye- Adeɛ biara ɛfiri nipa kasa mo ɛwɔ ɛsom mo,ɛna ɛnyɛ adeɛ a ɛho wɔ ɔkomhyane Onyame asomdwie nka nɔ mmerɛ mo ɛne nesuafoɔ sahaaba nom.<br /> * ɛnyɛ adeɛ a yagyetom ɛna yɛpo ɛkahɔ,nti yebe gyae no.<span class="c6"><br /> ɛfa ɔkomhyane kasa Onyame asomdwie nka nɔ:</span> <span class="c3">«Adeɛ biara ɛyɛ bid\'ah ɛyɛ yira»</span> Abu Dawuda Nhoma mu,<span class="c6"><br /> ɛnfatohu:</span> nkekahɔ wɔ ɛsom mo,ɛtisɛ nkekahɔ wɔ nsuokuta hɔ ɛwoworo ɛnae,ɛna ɛbi ne ɔkomhyane awoɔ ɛda afakyɛ Onyame asomdwie nka nɔ,na ɛnyɛ adeɛ ɔkomhyane ɛne nasuafoɔ ayɛ Onyame asomdwie nka nɔ. </p>',
      ],
      18 => [
        'question' => 'Asɛmbosa 19: keka gyedie ɛfa Walaa\'a ɛne Baraa\'a ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/1410.mp3',
        'answer' => '<p> Anuye-<span class="c6"> Al Walaa\'a:</span> ɛno nayɛ agyediefoɔ ɛdɔ ɛne wɔnnom mmoaboa.<span class="c6"><br /> Na ɔkrɔnkɔnii kɛsie akasɛ:</span> <span class="c4">{ ɛna agyediefoɔ mbɛrima ɛne agyediefoɔ mmaa yɛ aboafoɔ wɔnnom ɛntɛm ɛmo mo}</span>.<span class="c6"> Suratul Tawba:</span> 71].<br /> ALBARAAU eni se wo be ye abofow ewu Aboniaye fow nu so eni etain.<span class="c6"><br /> Na ɔkrɔnkɔnii kɛsie akasɛ:</span> <span class="c4">{Nokware mo asuasua pa wɔ Abraham ne agyidifoɔ a wɔn ka ne ho,<span class="c6"> bere a wɔn ka kyerɛ wɔn dɔm sɛ:</span> ɛsipi yɛ ne mo ntam wa na yatwe yɛ ho afiri mo ho ne neɛ mo som a ɛnyɛ Nyame, y\'ayi mo bɔniayɛ na ɔtan ne abufuo wɔ yɛ ne mo ntam daa kɔpim sɛ mo bɛ gye Nyame baako pɛ no adi}</span>. <span class="c5">[ Suuratul Mumtahina: 4]</span>. </p>',
      ],
      19 => [
        'question' => 'Asɛmbosa 20: Sɛnti Onyame ɛbɛgye ɛsom bi atom ɛfiri Islaam akye anaa?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/1480.mp3',
        'answer' => '<p> Anuye- ɛnyɛ adeɛ a Onyame ɛbɛgye ɛsom bi atom ɛfiri Islaam akye da.<span class="c6"><br /> Na ɔkrɔnkɔnii kɛsie akasɛ:</span> <span class="c4">{ ɛna ɔbiara a ɔbɛgye ɛsom bi atom ɛfiri Islaam som akye biara na ɛnyɛ adeɛ a ɔbɛgye atom ɛfiri nenkyɛ da ɛna ɔnɔ no ɛwɔ awieyɛ da no ɔbɛka brɛguofoɔ nom 85}</span>. <span class="c5">[Suuratul Aali Imraan 85]</span>. </p>',
      ],
      20 => [
        'question' => 'Asɛmbosa 21: Kaafiriya ɛyɛ adeɛ ɛfiri kasa mo ɛne dwumadie mo ɛne atwire gyedie mo,saa yi ɛnsɛsoɔ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/1520.mp3',
        'answer' => '<p> Anuye-<span class="c6"> ɛnfatohɔ kasa mo:</span> Onyame krɔnkɔ adideɛtɛm anaasɛ nesomanee Onyame asomdwie nka nɔ.<span class="c6"><br /> Dwumadie ɛnfatohɔ:</span>wobɛbu Quraan abonfia anaasɛ sujuuduyɛ ɛfiri Onyame kɛsie akye.<span class="c6"><br /> Gyedie Atwirehɔ:</span> Gyedie sɛ yɛho ɛfiri deɛ ɔfata ɛsom ɛfiri Onyame kɛsie akye anaasɛ yɛho ɔbɔadeɛ ɛka Onyame kɛsie hɔ. </p>',
      ],
      21 => [
        'question' => 'Asɛmbosa 22: Deɛbɛn nayɛ konkonsa\'\'Nifaaq\'\' ɛne nenkyekyɛmo?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/1570.mp3',
        'answer' => '<p> Anuye-<br /> 1-<span class="c6"> Konkonsa Kɛsie:</span> ɛno nayɛ kaafiriya ɛyam ɛseɛ ɛna gyedie ɛndaade.<br /> ɛna ɛyeno ɛfiri Islaam mo ɛna ɛno nayɛ kaafiriya kɛsie.<span class="c6"><br /> Na ɔkrɔnkɔnii kɛsie akasɛ:</span> <span class="c4">{ Nokorɛ akonkonsafoɔ ɛwɔ ɛgya asfari asi yie ɛwɔ ɛgyam ɛna ɛnyɛ adeɛ a wɔnnom ɛbɛya aboafoɔ biara 145}</span>. <span class="c5">[ Suuratul Nisaai:145]</span><br /> 2-<span class="c6"> Konkonsa Kitua\'Nifaaq Asgar\':</span><br /> ɛnfatohɔ: Atorɔ ɛne bohyɛyɛ ɛbuso ɛne ahwɛsoɔ ɛsɛi.<br /> ɛna ɛnyɛ adeɛ a ɛyeno ɛfiri Islaam mo,ɛna ɛno no ɛwɔ ɛfiri bonee mo ɛne nenyonkɔ ɔmane ɛkwɔ bone yɛ mo.<br /> -<span class="c6"> ɔkomhyane Onyame somafoɔ nɔ akasɛ Onyame asomdwie nka nɔ:</span> <span class="c2">((Akonkonsafoɔ ahyɛnsodeɛ ɛyɛ mmiensa: nasɛ ɔrekasa a atorɔ ɛwom, ɛna sɛ ɔndi bohyɛyɛ so, ɛnasɛ ahwɛsoɔ so ɔsɛi no)</span>) ɛfiri Buhaari ɛne Muslim mo. </p>',
      ],
      22 => [
        'question' => 'Asɛmbosa 23: Wae nayɛ akomhyafoɔ ɛne Asomafoɔ awieyɛ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/1680.mp3',
        'answer' => '<p> Anuye- ɔyɛ Mohammɛd Onyame asomdwie nka nɔ.<span class="c6"><br /> Na ɔkrɔnkɔnii kɛsie akasɛ:</span> <span class="c4">{ ɛnyɛm adeɛ a Mohammɛd ɛyɛ mɔ mo biara papa ɛfiri moɔ mbranteɛ yi mo na ɛmom ɔyɛ Onyame asomafoɔ ɛne akomhyafoɔ awieyɛ}</span>. <span class="c5">[ Suuratul Ahzaab: 40]</span>. -<span class="c6"> ɔkomhyane Onyame somafoɔ nɔ akasɛ Onyame asomdwie nka nɔ:</span> <span class="c3">«ɛna me na meyɛ akomhyafoɔ awieyɛ ɛsi anu na ɛnyɛ adeɛ a komhyane bi ɛbɛba makye»</span> Abu Dawud , Tirmizii ne Nasai na wenom de baee. </p>',
      ],
      23 => [
        'question' => 'Asɛmbosa 24: Deɛbɛn nayɛ Sankyerɛne \'Mu\'ugiza\'\'?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/1730.mp3',
        'answer' => '<p> Anuye-<span class="c6"> Sankyerɛne:</span> ɛyɛ adeɛ biara a Onyame ɛde ama ɛfa nekomhyafoɔ tumi amamerɛ ɛfa ɛngyinasoɔ wɔ nenokorɛ mo,<span class="c6">ɛnfatohɔ:</span><br /> - Bosomi ɛndwidwamo ɛfa ɔkomhyane Onyame asomdwie nka nɔ.<br /> - ɛna ɛponsuo ɛndwidwamo ɛfa Mosa Onyame asomdwie nka nɔ,ɛna ɛfaa ɛkɔm fɛɛro ɛne naminadom. </p>',
      ],
      24 => [
        'question' => 'Asɛmbosa 25: Wae nom nayɛ Asuafoɔ Sahaaba? Sɛnti wodɔ wɔnnom?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/1780.mp3',
        'answer' => '<p> Anuye-<span class="c6"> Sahaaba\'\'Asuanee\'\':</span> ɔnɔ nayɛ deɛ wahyia ɔkomhyane Onyame asomdwie nka nɔ gyedie mo ɛfa nehɔ ɛna wawu wɔ Islaam mo.<br /> - Yɛ dɔ wɔnnom ɛna yɛsuasua ɔmɔ,ɛna ɔmɔ yɛ apapamofoɔ ɛna ɔmɔ nadimo animuoyam mo ɛwɔ nipa nom ɛfiri akomhyafoɔ akye.<span class="c6"><br /> ɛna Animuoyam:</span> Khulafaa\'u ɛnae:<br /> Abuu Bakari Onyame npenie nka nɔ.<br /> Umar Onyame npenie nka nɔ.<br /> Usman Onyame npenie nka nɔ.<br /> Ali Onyame npenie nka nɔ. </p>',
      ],
      25 => [
        'question' => 'Asɛmbosa 26: Wae mo nayɛ agyediefoɔ maame nom?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/1870.mp3',
        'answer' => '<p> Anuye- Wɔnnom nayɛ ɔkomhyane yire nom Onyame asomdwie nka nɔ.<span class="c6"><br /> Na ɔkrɔnkɔnii kɛsie akasɛ:</span> <span class="c4">{ ɔkomhyane nadekae ɛwɔ agyediefoɔ nom ɛfiri wɔnnom mo,ɛna yire nom yɛ yɛmaame nom}</span>. <span class="c5">[ Suuratul Ahzaab: 6]</span>. </p>',
      ],
      26 => [
        'question' => 'Asɛmbosa 27: Adeɛbɛn nayɛ komhyane Onyame asomdwie nka nɔ ɛfiefoɔ kyɛfa?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/1910.mp3',
        'answer' => '<p> Anuye- Yɛ dɔ wɔnnom yɛboa ɔmɔ ɛna yɛbofo deɛ nebofo wɔnnom ɛna ɛnyɛ adeɛ ɛha ɔmɔ,ɛna ɔmɔ nayɛ neyire nom ɛne nabusuafoɔ ɛne banuu haahyim ɛne banuu muttallib ɛfiri agyidiefoɔ nom. </p>',
      ],
      27 => [
        'question' => 'Asɛmbosa 28: Deɛbɛn nayɛ ɛnhyɛ adepa ɛhwɛ ɛmane musliminii dwumadie mmoaboa?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/1940.mp3',
        'answer' => '<p> Anuye-<span class="c6"> Yɛnhyɛ:</span> Anideɛ ɛma ɔmɔ ɛne atieɛ ɛne adiso ɛma ɔmɔ ɛwɔ bone akye,ɛna wɔnnom npeɛ ɛnfiri mo,ɛna mparbo ɛne afotuo ɛma ɔmɔ ɛnsumayɛ mo. </p>',
      ],
      28 => [
        'question' => 'Asɛmbosa 29: Deɛbɛn nayɛ agyediefoɔ ɛdae?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/1970.mp3',
        'answer' => '<p> Anuye- Aljanna.<span class="c6"> ɔkɛsie akasɛ:</span> <span class="c4">{ Nokorɛ Onyame ɔde deɛ ɔmɔ yɛ agyediefoɔ no ɛna ɔmɔ adedwumadie pa ɛbɛwura aljannah dodoɔ mo a nsuo ahodoɔ ɛnam ɛfiri nase }</span>. <span class="c5">[ Suuratul Mohammɛd: 12]</span>. </p>',
      ],
      29 => [
        'question' => 'Asɛmbosa 29: Deɛbɛn nayɛ kaafirifoɔ ɛdae?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2000.mp3',
        'answer' => '<p> Anuye- Aljanna.<span class="c6"> ɔkɛsie akasɛ:</span> <span class="c4">{ Na mɔnsro ɛgya deɛ yɛde nipa ɛne abuo ɛbɛsɔ na yaboaboa no ɛdema kaafirifoɔ 24}</span>. <span class="c5">[ Suuratul Baqara: 24]</span>. </p>',
      ],
      30 => [
        'question' => 'Asɛmbosa 31:Deɛbɛn nayɛ ɛhuu? ɛna deɛbɛn nayɛ anidaasoɔ? ɛna ɛngyinasoɔ wai ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2020.mp3',
        'answer' => '<p> Anuye-<span class="c6"> ɛhuu :</span>ɛno no ɛyɛ ɛhuu bi a ɛfiri Onyame ho ɛne nasotwie.<span class="c6"><br /> Anidaasoɔ:</span> ɛno nayɛ anidaasoɔ bi a ɛyɛ Onyame nhyira ɛne nebonefakyɛ ɛne nahunumobro.<span class="c6"><br /> ɛngyinasoɔ :</span> ɛfa ɔkɛsie kasa: <span class="c2">((Na wɔn a wɔsu frɛ wɔn wɔ abɔfoɔ mu ne wɔn a wɔka abɔfoɔ ho, wɔn ankasa mpo no(abɔfoɔ, akomhyɛfoɔ ne awufoɔ)</span> a wɔsu frɛ wɔn sɛ wɔmmoa wɔn no, wɔpɛ dwumadi pa a ɛbɛma wɔabɛn Nyankopɔn, na wɔde sotie ne nyamesom yɛ akansie wɔ wɔntam sɛ, hwan na ɔbɛtumi de sotie abɛn Nyankopɔn paa yie, saa ara nso na wɔpɛ sɛ Nyankopɔn hu wɔn mmɔbɔ, na wɔsuro sɛ Nyankopɔn bɛtwe wɔn aso, oh ɔsomani ee! ɛsi pi sɛ, wo wura Nyankopɔn mpɔnse no ne adeɛ a ɛwɔ sɛ obiara yɛ ahwɛyie wɔ ho-57)) <span class="c5">[ Suuratul Israa\'a: 57]</span>.<span class="c6"> Na ɔkrɔnkɔnii kɛsie akasɛ:</span> <span class="c4">{ Bo menkoa amanie me na meyɛ bonefakyɛ wura ɔdɛɛfoɔ nee 49 ɛna nokorɛ masotwie nayɛ asotwie yayaaya 50}</span>. <span class="c5">[ Suraatul Al Hijir: 49,50]</span> </p>',
      ],
      31 => [
        'question' => 'Asɛmbosa 32: Keka Onyame kɛsie ɛdii ɛne nesu nom bi?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2070.mp3',
        'answer' => '<p> Anuye- Allaahu,Arrabbi,Arrahamaan,Assamii\'i , Albasiir,Al Aliim, Arrazzaaq, Al Hayyu, Al Azeem ɛne deɛ ɛkekahɔ saa so ɛfiri ɛdii fɛfɛɛfɛ ɛne ɛsu kɛsie. </p>',
      ],
      32 => [
        'question' => 'Asɛmbosa 33: Yɛnkyerɛ kyerɛ ɛfa saa ɛdii yi ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2100.mp3',
        'answer' => '<p> Anuye-<span class="c6"> Allaahu:</span> nasekyerɛ ne adesom yɛsom no ɛwɔ nokorɛ mo,ɔnɔ nayɛ krɔpɛ yɛnyɛ no npatahɔ.<span class="c6"><br /> Arrabb:</span> ɛkyerɛ ɔbɔadeɛ ɛna ɔtumifoɔ ɛna ahoyanee ɛna ɔdanidani nee ɔkrɔ pɛ ɔkronkɔnee.<span class="c6"><br /> Assamii\'i:</span> Deɛ neteɛ ɛbae ɛbro biribiara,ɛna ɔte nnee biara wɔ sɛdeɛ ɛtie biara ɛne nenkyekyɛmo so.<span class="c6"><br /> Al Basiir :</span> Deɛ ɔhunu adeɛ biara, ɛna ɔhunu adeɛ biara kitua anaasɛ kɛsie.<span class="c6"><br /> Al Aleem:</span> Na ɔno nayɛ deɛ nenimdie atwaahyia ɛfa adeɛ biara ɛfa deɛ atwam ɛne deɛ ɛho animmo ɛne daakye bi.<span class="c6"><br /> Arrhamaan:</span> Deɛ nahunumobro ɛbae ɛterɛ nabɔdeɛ nkwa biara, na nenkoa nyinara ɛne nabɔdeɛ ɛhyɛ nahunumobro ase.<span class="c6"><br /> Arrazzaaq:</span> Deɛ nagyapadeɛ ahoya ɛwɔ nenkoa nyinara so ɛfiri nipa nom ɛne asaaseboadinse jinni ɛne mmoa.<span class="c6"><br /> Al Hayyu :</span> Alhayya nkwa deɛ ɔnwu, ɛna nabɔdeɛ nyinara ɛbɛwu.<span class="c6"><br /> Al Azeem :</span> Deɛ ɔwɔ ɛsu a ahyɛ ɛma nyinara ɛwɔ nedii mo ɛne nesu mo ɛne nedwumadie mo. </p>',
      ],
      33 => [
        'question' => 'Asɛmbosa 34: Deɛbɛn nayɛ yɛnhyɛ ɛhwɛ ɛmane musliminii nimdiefoɔ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2210.mp3',
        'answer' => '<p> Anuye- Yɛ dɔ wɔnnom, ɔmɔ nkyɛ na yɛya asɛmbosa anu a yɛnnim ɛne nne yɛmmerɛ yi mo mmera,ɛna ɛnyɛ adeɛ a yɛ bɛka ɔmɔ nsɛm agye adepa nkoaa,ɛna deɛ ɔbɛka ɔmɔ nsɛm bobe biara ɛwɔ yakye;na ɔwɔ wɔ ɛkwan fofro bi so ɛnyɛ ɛkwan pa.<span class="c6"><br /> Na ɔkrɔnkɔnii kɛsie akasɛ:</span> <span class="c4">{ Onyame ɛma deɛ ɔmɔ yɛ agyediefoɔ no animuoayam ɛpɛgye wɔnnom ɛfiri mɔ mo ɛne deɛ yama ɔmɔ nimdie animuoyam debrɛ,ɛna Onyame ɛfa adeɛ biara mɔ di ɔnim ɛyie 11}</span>. <span class="c5">[ Suuratul Mujadala 11]</span>. </p>',
      ],
      34 => [
        'question' => 'Asɛmbosa 35- Wae mo nayɛ Onyame kesie adɔfo nom aboafo?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2240.mp3',
        'answer' => '<p> Anuye- ɔmɔ nayɛ agyediefoɔ Nyamesrofoɔ.<span class="c6"><br /> Na ɔkrɔnkɔnii kɛsie akasɛ:</span> <span class="c4">{ Sɛnti ɛnyɛ nokorɛ mo Onyame adɔfo nom ɛnne ɛhuu wɔnnom so ɛna ɛnyɛ adeɛ ɔmɔ ɛwɔ akomasɛiyyɛ mo 62 deɛ ɔmɔ ɛwɔ gyedie ɛna ɔmɔ ɛsro Nyame 63}</span>. <span class="c5">[ Suuratul Yunus: 62,63]</span>. </p>',
      ],
      35 => [
        'question' => 'Asɛmboas 36: Sɛnti yɛho gyedie kasa ɛne dwumadie mo?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2280.mp3',
        'answer' => '<p> Anuye- Gyedie kasa mo ɛne dwumadie mo ɛne atwire mo. </p>',
      ],
      36 => [
        'question' => 'Asɛmbosa 37: Sɛnti gyedie ɛde bi ɛkahɔ ɛne ɛso ɛti?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2310.mp3',
        'answer' => '<p> Anuye- Gyedie ɛde bi ɛkahɔ ɛfa asotwie ɛdiso ɛna ɛso ɛti ɛfa boneyɛ.<span class="c6"><br /> Na ɔkrɔnkɔnii kɛsie akasɛ:</span> <span class="c4">{ Nokorɛ agyediefoɔ no nayɛ deɛ nasɛ yɛkaekae ɔmɔ ɛfa Onyame asɛm na ɔmɔ akoma abobrim ɛhuu mo ɛnasɛ yɛkenkae yɛ aaya ɛkyerɛ wɔnnom a na ɔmɔ gyedie akahɔ gyedie mo ɛna ɛwɔ ɔmɔ Awurade ho ɔmɔ de wɔnnom ɛhɔ ɛtwire 2}</span> <span class="c5">[ Suuratul Anfaal: 2]</span>. </p>',
      ],
      37 => [
        'question' => 'Asɛmbosa 38: Deɛbɛn nayɛ Ihisaan\'\'Adepa\'\'?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2350.mp3',
        'answer' => '<p> Anuye- Sɛ wobɛsom Onyame ɛtisɛ wo hunu nɔ,nasɛ ɛyɛ wo sɛ wonhunu nɔ;ɛnɛ nokorɛ ɔnɔ ɔhunu wo. </p>',
      ],
      38 => [
        'question' => 'Asɛmbosa39 : Mmerɛ bɛn na Onyame kɛsie ɛgye swumadie ɛtom ɛwɔ nenkyɛ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2370.mp3',
        'answer' => '<p> Anuye-<span class="c6"> ɛwɔ mmera mmienu:</span><br /> 1- Nasɛ ɛkwɔbasɛ nedwumadie ɛyɛ Onyame kɛsie nti.<br /> 2- ɛnasɛ ɛkwɔbasɛ ɛyɛ ɔkomhyane sunnah Onyame asomdwie nka nɔ. </p>',
      ],
      39 => [
        'question' => 'Asɛmbosa 40: Deɛbɛn nayɛ atwire wɔ Onyame kɛsie hɔ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2420.mp3',
        'answer' => '<p> Anuye- ɛno nayɛ Onyame atwire hɔ wɔ ɛnfasoɔ ɛma ɛne ɛhao ɛye,ɛwɔ negye mo ɛfa ɛngyinasoɔ.<span class="c6"><br /> Na ɔkrɔnkɔnii kɛsie akasɛ:</span> <span class="c4">{ ɛna ɔbiara a ɔde nehɔ ɛbɛtwire Onyame na ɔnɔ na ɔsonibo ɛma no}</span>. <span class="c5">[ Suuratul Talaaq:3]</span>.<br /> <span class="c4">{ ɔsonibo ɛma wo}</span>.: ɛkyerɛ ɔsonibo ɛma no biribiara mo. </p>',
      ],
      40 => [
        'question' => 'Asɛmbosa 41: Deɛbɛn nayɛ ɛnhyɛ ɛfa woboa ahyɛ ɛfa dwumadie pa ɛdi ɛne woboa amayɛ agyae dwumadie bone ɛdi?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2470.mp3',
        'answer' => '<p> Anuye-<span class="c6"> Alma\'aruf:</span> ɛno nayɛ ahyɛsoɔ ɛfa ɛkwan biara asotwie ɛdiso ɛma Onyame kɛsie ɔtumifoɔ asɛm ɛdiso,<span class="c6">ɛna Monkari:</span> ɛyɛ sɛ yabra wo afiri dwumadie bone biara ɛma Onyame kɛsie ɔtumifoɔ asɛm mo.<span class="c6"><br /> Na ɔkrɔnkɔnii kɛsie akasɛ:</span> <span class="c4">{ Mɔ na mɔyɛ ɛdom pa ɛwɔ ɛfa nipa nom nyinara ɛnamsɛ mɔhyɛ ɛfa dwumadie pa hɔ ɛna mɔbra wɔ dwumadie bone hɔ ɛna magye Onyame atom }</span>. <span class="c5">[Suuratul Aali Imraan 110]</span>. </p>',
      ],
      41 => [
        'question' => 'Asɛmbosa 42: Wae mo nayɛ Ahlu Sunnah Wal Jamaa\'ah?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2510.mp3',
        'answer' => '<p> Anuye- ɔmɔ nayɛ deɛ ɔmɔ ɛwɔ deɛ me wɔho ɛnsɛsoɔ me ɔkomhyane Onyame asomdwie nka nɔ ɛne nasuafoɔ nom sahaaba ɛwɔ kasa mo ɛne dwumadie mo ɛne atwire gyedie mo.<span class="c6"><br /> ɛna yato wɔnom ɛdii Ahlu Sunnah:</span> ɛnam sɛ ɔmɔ ɛdi ɔkomhyane sunnah so,ɛna ɔmɔ ɛgyae sakratom bid\'a.<span class="c6"><br /> ɛna jamaa\'ah:</span> ɛfisɛ nokorɛ wɔnnom ɛboaboa ɔmɔ hɔ wɔ nokorɛ mo ɛna ɛnyɛ adeɛ ɔmɔ ɛtete ɔmɔ ɛntɛm ɛwɔ ɛwom. </p>',
      ],
    ],
    2 => [
      0 => [
        'question' => 'Asɛmbosa 1:Kyerɛ ahɔmideɛ asekyerɛ \'\'Tahaara\'\'?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2580.mp3',
        'answer' => '<p> Anuye-<span class="c6"> Tahaara:</span> ɛyɛ sɛ wo ye ɛfii afiri ho,ɛne ade fii ɛpepa.<br /> Taharaat Al-Khabath,enu se Kramunee be ye efih den ewu nihu anna ne ntuma anna bea a wu ye Sallah/nyame fere ewu su.<span class="c6"><br /> Tahaara Hadathi:</span> ɛna ɛyɛ adeɛ a ɛyɛ ɛfa nsuokuta anaasɛ awoworohɔ,ɛfa nsuo ahɔtie,anaasɛ tayammum ɛfa deɛ wanya nsuo,anaasɛ akwama ɛwɔ nedwumadie mo. </p>',
      ],
      1 => [
        'question' => 'Asɛmbosa 2: wobɛti wohɔ wɔ deɛ ɛfii bi aka no yɛ \'\'Najaasa\'\'?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2630.mp3',
        'answer' => '<p> Anuye- ɛfa newoworo hɔ ɛfa nsuo ɛkwɔpimsɛ nehɔ ɛbɛti \'\'Gusl\'\'<br /> - ɛna ɛmom deɛ kramae atafire nehɔ; na ɔnwoworo nehɔ mprɛnsu ɛdekae ɛfa nateɛ. </p>',
      ],
      2 => [
        'question' => 'Asɛmbosa 3: Deɛbɛn nayɛ nsuokuta ɛnfasoɔ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2660.mp3',
        'answer' => '<p> ɛfa ɔkomhyane kasa Onyame asomdwie nka nɔ: <span class="c3">«Nasɛ musliminii akoa ɛkuta nsuo»</span> - anaasɛ <span class="c3">«Gyedie»</span> - <span class="c3">«Na wawoworo nanim; nebone nyinara ɛye ɛfiri nanim ɛfa deɛ wade nanim ahwɛ ɛfa nsuo no»</span> -anaasɛ <span class="c3">«ɛne nsuo kitua a ɛtwatuo»</span> - <span class="c3">«Nasɛ ɔwoworo nensaa; ɛpepa ɛfiri nebone biara ɛyɛ ɛfa nensa ɛkuta mo ɛfa nsuo no»</span> -anaasɛ ɛwɔ nsuo no awieyɛ kitua» - <span class="c3">«Nasɛ ɔwoworo nenae yi a ; nebone biara ɛpeɛ ɔde nenae ɛnanteyɛ ɛfa nsuo no»</span> -anaasɛ <span class="c3">«ɛfa nsuo no kitua awieyɛ»</span> - <span class="c3">«ɛkwɔpimsɛ ɛye ɛpeɛ ɛfiri nebone mo ɛtehɔ»</span> Ɛfiri Muslim Nhoma mu. </p>',
      ],
      3 => [
        'question' => 'Asɛmbosa 4: Sɛdeɛ yɛkuta nsuo\'\'wuduu\'\'?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2690.mp3',
        'answer' => '<p> Anuye- Woworo wonsa yamonswan swan mmprɛ mmiensa.<br /> ɛna wobɛ woworo wanu ɛbɛwura ɛwene mo ɛne ɛbɛpeɛ mmprɛ mmiensa.<span class="c6"><br /> Wal Madamada:</span> Sɛ wo de nsuo ɛbɛgu wanum awoworo na wobɛhwie agu.<span class="c6"><br /> Wal Estenhyaaq:</span> Sɛ wobɛgya nsuo akwɔ wohwine mo wɔ wo nifa mo.<span class="c6"><br /> Wa Estenthara:</span> ɛno ne sɛ wobɛ ye nsuo afiri wohwine mo ɛwɔ mmerɛ wode wo bonkom aye.<br /> ɛnoakye na wawoworo wanim mmprɛ mmiensa.<br /> ɛnoakye wobɛ woworo wonsa ɛkwɔpim wabatwɛ mmienu mmprɛ mmiensa.<br /> ɛnoakye na ɔde wonsa ne nsuo afa wotiri so wanim ɛkwɔpim wakye,na wo de afa wasu mmienu no mo.<br /> ɛnoakye na wawoworo wonae ɛkwɔpim wonae ani ɛpɔ so mprɛ mmiensa.<br /> Wae yi nayɛ ahyɛma awieyɛ,ɛna nokware atimtim saa yi wɔ ɔkomhyane Onyame asomdwie nka nɔ hadiis dodoɔ mo ɛwɔ Buhaari ɛne Muslim mo,deɛ yɛya afiri Osman ɛne Abdallah bun Zaid ɛne deɛ ɔmɔ ɛkekahɔ nkyɛ.<span class="c6"> ɛna nokware mo atimtim so biom ɛwɔ wɔnnom ho Buhaari ɛne de ɔmɔ ɛkahɔ wɔnnom akye:</span> \'\'nokorɛ ɔnɔ no ɔyɛ nsuokuta mprɛ baako baako pɛ,<span class="c6">ɛna nokorɛ ɔnɔ no ɔyɛ wuduu mprɛ mmienu mmienu\'\' ɛfa saa no ɛkyerɛ :</span> nokorɛ ɔnɔ no ɔwoworo naposo naposo ɛfiri nsuokuta aposo baako pɛ,anaasɛ mprɛ mmienu. </p>',
      ],
      4 => [
        'question' => 'Asɛmbosa 5: Deɛbɛn nayɛ nsuokuta nhyɛ,ɛne nedodoɔ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2810.mp3',
        'answer' => '<p> Anuye- ɛyɛ adeɛ nma musliminii nsuokuta hɔ ɛnte nasɛ ɔgyae ɛmo biara ɛfiri mo.<br /> 1- Anim woworo ɛna ɛfiri wode nsuo ɛwura mo ɛne woye afiri mo.<br /> 2-wobɛ woworo wonsa mmienu ɛkwɔpim wabatwɛ.<br /> 3- ɛtiri ɛwoworo ɛna ɛfiri mo ne aso mmienu.<br /> 4- ɛnae mmienu ɛwoworo ɛkwɔpim ani ɛpo no so.<br /> 5- ɛndidisoɔ wɔ aposo aposo ɛntɛm,ɛfa sɛ wo bɛ woworo wanim,ɛnoakye wonsa,ɛnoakye wotiri hɔ nsuo ɛfaso,ɛnoakye wo nae mmienu hɔ awoworo.<br /> 6-<span class="c6"> ahɔbaebo\'\'walaayaati\'\':</span> ɛno nayɛ nsuokuta ɛwɔ mmerɛ ɛdidiso,na ɛnyɛ ndidisuo ɛfiri mmerɛ mo ɛkwɔpimsɛ waposo ɛbɛwo afiri nsuo no hɔ.<br /> - ɛtisɛ nokorɛ ɔbɛ woworo nsuokuta ɛfa nsuokuta,na wahyɛ no ɛma ɛwɔ awieyɛ mmerɛ mo,na ɛnyɛ adeɛ a ɛdemo nensuokuta. </p>',
      ],
      5 => [
        'question' => 'Asɛmbosa 6: Deɛbɛn nayɛ sunnah nsuokuta ,ɛne nedodoɔ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2910.mp3',
        'answer' => '<p> Anuye-<span class="c6"> Nsuokuta sunnah:</span> ɛno nayɛ deɛ sanka wobɛyɛ wɔhɔ; ɔwɔ ɛfiri nhyira ɛne akɛtua ɛnkahɔ nom bi,ɛna sanka ɔgyae neyɛ koraa;na ɛnyɛ adeɛ a bone ɛwom,ɛna nensuokuta ɛdemo.<br /> 1-<span class="c6"> Tasmiya:</span> Bismillaahi ɛka.<br /> 2- Sokwodua ɛhwihwi si.<br /> 3- Nsuokuta ɛwoworo ɛnae ani aposo mmienu.<br /> 4- Nsasoa nsuo ɛwura.<br /> 5- Awoworo mmienu ɛne mmiens wɔ aposo aposo.<br /> 6- Ahyeasie ɛfiri nifa so.<br /> 7-<span class="c6">AZZIKR/empaebo ewo nsukuta akyere:</span> Me di adansie sɛ nokware ade som biara nne ho agyese Nyame nkoa bofoa,na daabi onni ahokane biara,na me de adansie sɛ Mohammad yɛ na koa ne nebɔfoɔ.<br /> 8- Rakaa yɛ mmienu wɔ Nyamefrɛ akye. </p>',
      ],
      6 => [
        'question' => 'Asɛmbosa 7: Ade dodoɔ a ɛsɛi nsuokuta?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3020.mp3',
        'answer' => '<p> Anuye- Deɛ ɛpeɛ ɛfiri mipa twokworo mmienu mo animo ɛne akyerɛ,ɛfiri dwonsoɔ anaasɛ ɛbene anaasɛ mframa.<br /> ɛda,anaasɛ ɛdam anaasɛ atwine ɛfiri mo.<br /> Aboa ɛkwɔntintee<span class="c2">(YOMA)</span> ɛnam ɛdi.<br /> Apepa animo ɛne akyerɛ ɛfa nsa ɛwɔ abraa ɛbene nneho. </p>',
      ],
      7 => [
        'question' => 'Asɛmbosa 8: Deɛbɛn nayɛ tayammum?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3080.mp3',
        'answer' => '<p> Anuye-<span class="c6"> Tayammum:</span> ɛyɛ nɛteɛ dwumadie ɛdi ɛne deɛ ɛkahɔ ɛfiri asaase pae ahɔtie,ɛwɔ mmerɛ a nsuo nneho anaasɛ ɛwɔ akwansie dwumadie bi. </p>',
      ],
      8 => [
        'question' => 'Asɛmbosa 9: Sɛdeɛ yɛyɛ Tayammum?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3110.mp3',
        'answer' => '<p> Anuye- wode wonsa yam ɛbɔ tare nɛteɛ no abɔ baako pɛ mo,na wo de afa wanim wɔ wonsa yam ɛposo baako pɛ. </p>',
      ],
      9 => [
        'question' => 'Asɛmbosa 10: Deɛbɛn nayɛ adeɛ a ɛsɛi tayammu?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3140.mp3',
        'answer' => '<p> Anuye- Adeɛ biara a ɛsɛi nsuokuta.<br /> Nasɛ woya nsuo a </p>',
      ],
      10 => [
        'question' => 'Asɛmbosa 11: Deɛbɛn nayɛ khuffaene wal gyaorabaene? Sɛnti yɛpepa ɛfa ɛso mmienu no anaa?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3180.mp3',
        'answer' => '<p> Anuye-<span class="c6"> Al khuffaene:</span> ɛyɛ deɛ yɛhyɛ wɔ ɛnae mo ɛfiri honam leda nom\'\'mpaboa\'\'.<span class="c6"><br /> Al gyaorabaene:</span> ɛyɛ deɛ yɛhyɛ wɔ ɛnae so ɛfiri ɛnyɛ honam leda so.<br /> ɛna yayɛ hɔ mmera ɛfaso nensuo ɛwɔ abraa ɛyɛ ɛnsesayɛ wonwoworo wonae. </p>',
      ],
      11 => [
        'question' => 'Asɛmbosa 12: Keka mmera(Nyansa) a ɛfiri apepa ɛfaso wɔ khuffaene neso?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3230.mp3',
        'answer' => '<p> Anuye- Agogono mo ɛne mmerɛ mmerɛ ɛwɔ nkoa so,netitirew wɔ awo ɛne ɛhyew ɛne akwantuo mmerɛ mo,ɛwɔ mmerɛ ɛmo ayɛden ɛtwe deɛ wɔ ɛnae mmienu neso. </p>',
      ],
      12 => [
        'question' => 'Asɛmbosa 13- Deɛbɛn nayɛ mmera ɛyɛyie apepa ɛfaso wɔ mpaboa khuffaene neso?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3260.mp3',
        'answer' => '<p> Anuye- 1- Sɛ ɔbɛhyɛ khuffaene wɔ abraa ɛwɔ ahotie mo,ɛkyerɛ nsuokuta no akye.<br /> 2- Sɛ ɛbɛyɛ khuffi ahotei,na ɛnyɛ adeɛ ɛfata apepa ɛfaso wɔ ɛfii mo.<br /> 3-Sɛ ɛbɛ dani khuffi ahobaebo ɛfa akwama nhyɛ newoworo hɔ wɔ nsuokuta mo.<br /> 4- Sɛ ɛbɛ dani deɛ yapepa afaso mmerɛ kakra mo yatwa atoho mmera mo,<span class="c6">ɛfa ɛyɛ deɛ ɔwɔ kro mo ɛnyɛ kwantunee:</span> ɛda ne anadwo,<span class="c6">ɛfa kwantunee:</span> nda mmiensa ɛne anadwo mmienu no. </p>',
      ],
      13 => [
        'question' => 'Asɛmbosa 14- Deɛbɛn nayɛ ɛsu apepa ɛfaso wɔ mpaboa khuffaene neso?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3320.mp3',
        'answer' => '<p> Anuye-<span class="c6"> ɛmom apepa afaso nayɛ:</span> Sɛ wode wonsansoa ɛbɛtoso ne nsuo wɔ nsoasoa neso ɛnae mmienu neso ɛnoakye wode bɛkwɔ anam wɔ wonae no akye,na ɔde afa wonae nifa so ɛfa wonsa nifa so,ɛna ɛnae bonkom so ɛfa wonsa bonkom so,ɛne na ɔde nsasoa no apepa afa so wɔ braa ɔnsiso biom. </p>',
      ],
      14 => [
        'question' => 'Asɛmbosa 15- Deɛbɛn nayɛ deɛ ɛsɛi apepa ɛfaso wɔ mpaboa khuffaene neso?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3350.mp3',
        'answer' => '<p> Anuye- 1-ɛsɛi wɔ mmerɛ mo a atwam ɛpepa ɛfaso, na ɛnyɛ adeɛ ɛfata apepa so wɔ khuffaene mmerɛ a atwam apepaso mmera mmerɛ mo,ɛda ɛne anadwo ɛma ɔtimaemo ɛne nda mmiensa ɛfa anadwo mmienu ɛma ɔkwantunee.<br /> 2- ɛna khuffaene neye nasɛ nipa ɛye nekhuffaene anaasɛ ɛmo mmienu biara no wɔ nepepaso no ɛsɛi nepepa hɔ wɔsɔ mmienu. </p>',
      ],
      15 => [
        'question' => 'Asɛmbosa 16: Nyamefrɛ \'\'Salat\'\' asekyerɛ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3390.mp3',
        'answer' => '<p> Anuye-<span class="c6"> Salat:</span> ɛyɛ ɛsom ɛma Onyame ɛfa kasa ɛne dwumadie soronkwo mo,yɛ de ɛfa takbeer nabeɛ,ɛna yɛ salaam nɛba awieyɛ. </p>',
      ],
      16 => [
        'question' => 'Asɛmbosa 17: Nyamefrɛ salat mmera ɛnhyehyɛyɛ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3420.mp3',
        'answer' => '<p> Anuye-<span class="c6"> Nyamefrɛ ɛnhyɛ ɛwɔ muslimini biara so?<br /> Na ɔkrɔnkɔnii kɛsie akasɛ:</span> <span class="c4">{ Nokorɛ nyamefrɛ ɛyɛ adeɛ a ɛwɔ ɛda gyedienee nesu atworɔ mmerɛ mo}</span>. <span class="c5">[ Suuratul Nisaai:103]</span> </p>',
      ],
      17 => [
        'question' => 'Asɛmbosa 18: Deɛbɛn nayɛ mmera ɛfa deɛ wagyae Nyamefrɛ Salat?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3460.mp3',
        'answer' => '<p> Anuye- Nyamefrɛ ɛgyae yɛ kaafiriya,<span class="c6">ɔkomhyane Onyame asomdwie nka nɔ akasɛ:</span><br /> <span class="c3">«Bohyɛ deɛ ɛda yɛntɛm ɛne ɔmɔ ɛntɛm nayɛ Nyamefrɛ salat,na deɛ ɔbɛgyae no na nokorɛ ɔyɛ kaafirinii»</span><br /> ɛfiri Ahmɛd ɛne Tarmidhi nkyɛ ɛne deɛ ɔmɔ ɛkahɔ. </p>',
      ],
      18 => [
        'question' => 'Asɛmbosa 19- Nyamefrɛ dodoɔ sɛn na ɛfata wɔ musliminii so wɔ ɛda mo ɛne anadwo mo? ɛna dodoɔ sɛn rakaat ɛwɔ nyamefrɛ biara mo?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3500.mp3',
        'answer' => '<p> Anuye- Nyamefrɛ ɛnum wɔ ɛda ɛne anadwo,<span class="c6">fajir Nyamefrɛ:</span>Rakaa mmienu,<span class="c6">ɛna Zuhur Nyamefrɛ:</span> Rakaa ɛnae,<span class="c6">ɛna Asr Nyamefrɛ:</span> Rakaa ɛnae,<span class="c6">ɛna Maghrib Nyamefrɛ:</span>rakaa mmiensa,<span class="c6">ɛna Isha Nyamefrɛ:</span>Rakaa ɛnae. </p>',
      ],
      19 => [
        'question' => 'Asɛmbosa 20:Mmera Nyamefrɛ dodoɔ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3530.mp3',
        'answer' => '<p> Anuye- 1- Islaam ; na ɛnyɛ adeɛ a ɛfata ɛyɛ ɛma kaafirinii.<br /> 2- Adwene; na ɛnyɛ adeɛ ɛdemo ɛma obia a wabodam.<br /> 3- Anibeɛ ɛyene; na ɛnyɛ adeɛ a ɛdemo ɛma akwɔdaa abraa ɔnyene yɛ.<br /> 4- Akoma monsɛm \'\'Niyya\'\'.<br /> 5- Mmerɛ ɛwura mo.<br /> 6- Ahoteɛ ɛfiri ɛfii mo.<br /> 7- Ahotie wɔ ɛfii ɛyefri ho \'\'hadath\'\'.<br /> 8- Adagya so kata.<br /> 9- Kaaba<span class="c2">(KIBLAH)</span> ɛhwɛ. </p>',
      ],
      20 => [
        'question' => 'Asɛmbosa 21: Nyamefrɛ salat afapim dodoɔ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3640.mp3',
        'answer' => '<p> Anuye- ɛyɛ afapim ɛduanonae,<span class="c6">sɛdeɛ ɛdidiso yi:</span><br /> 1- sore gyina ho wɔ ɛnhyɛ ɛwɔ nhyehyɛyɛ mo.<br /> Takbeeratul Iheraam,ɛno nayɛ \'\'Allaahu Akbar\'\'.<br /> Faatiha akenkae.<br /> Rukuu\'u, ɛna wobɛ tɛrɛ wakye pɛpɛɛpɛ ɛna ɔbɛdani netire ne no ayɛ pɛ.<br /> Sore ɛfiri so.<br /> Pɛpɛɛpɛ ɛngyina ho.<br /> Sujuudu yɛ,ɛyɛ ɛfata wanim moma,ɛne ɛhwene,ɛne wonsa yam mmienu,ɛne wonsansoa ɛne wonae ɛka sujuudu akwama.<br /> Sore ɛfiri sujuuduu mo.<br /> Atinaseɛ ɛwɔ sujuudu mmienu ɛntɛm.<span class="c6"><br /> ɛne sunnah:</span> sɛ wobɛtina wonae so bonkom so,ɛna wafa nifa wɔso,na wama wɔnnom ahwɛ qibla.<br /> Akomatɔyɛ,ɛna wobɛya akomatoyɛ ɛwɔ rukuu biara mo nedwumadie.<br /> Attahyahhud awieyɛ.<br /> Atinaseɛ ɛma no.<br /> Assalaamu Alaikum mmienu ɛka,<span class="c6"> ɛno ne sɛ wobɛ no mmprɛ mmienu:</span> "Assalaamu Alaikum warahamatullaahi".<br /> Afapim ɛndidisoɔ -Sɛdeɛ yaka atwam-nanka sujuudu yɛ ɛnfatohɔ ansaana nerukuu\'u yɛ boapayɛ;asɛi,sahawe ɛnseɛsie aba mo; ɛyɛ ɛnhyɛ ɛmawo ɛfa rukuu ɛyɛ so biom,ɛnoaky na wayɛ sujuudu. </p>',
      ],
      21 => [
        'question' => 'Asɛmbosa 22: Keka Nyamefrɛ ɛnhyɛ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3820.mp3',
        'answer' => '<p> 1- Attakbeeraati ɛka ɛwɔ abraa ɛnyɛ takbeeratul Ihiraam.<br /> Anuye- Nyamefrɛ ɛnhyɛ, ɛno no ɛyɛ wɔtwe\'\'8\'\',<span class="c6"> sɛdeɛ ɛdidiso yi:</span><br /> 2-<span class="c6"> Kasa ka :</span> <span class="c3">«Sami \'Allaahu Liman Hamdihi »</span> ɛfa Imaam ɛne ɔkrɔ.<br /> 3-<span class="c6"> Kasa ka:</span> <span class="c3">«Rabbanaa walakal Hamd »</span>.<br /> 4-<span class="c6"> Kasa ka :</span> <span class="c3">«Subhaana Rabbiyal Azeem»</span> mprɛ wɔ rukuu\'u.<br /> 5-<span class="c6"> Kasa ka :</span> <span class="c3">«Subhaana Rabbiyal A\'alaa»</span> mprɛ wɔ sujuudu mo.<br /> 6- Kasa ɛka <span class="c3">«Rabbi Igfiri lee»</span> ɛwɔ sujuudu mmienu ɛntɛm.<br /> 7- Attashahudu ɛdekae.<br /> 8-Ɛntinaseɛ ma Attahiya a, ɛdikan no <span class="c2">( Attahyahudu)</span> </p>',
      ],
      22 => [
        'question' => 'Asɛmbosa 23: Deɛbɛn nayɛ Nyamefrɛ Sunnah?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3930.mp3',
        'answer' => '<p> Anuye- ɛyɛ dodoɔ ɛdu baako sunnah,<span class="c6">sɛdeɛ ɛdidisoɔ:</span><br /> 1-<span class="c6"> Wo kasa ɛka ɛwɔ takbeeratul Ihraam akye:</span> \'\'Subhaanaka Allaahumma wabi Hamdika,wata baaraka ismuka,wata aalaa jadduka,<span class="c6">walaa ilaaha gayruka\'\' na yɛfrɛ wayi:</span> duwaa\'u al istiftaaha.<br /> 2- ɛna ta\'awwuzu ɛka.<br /> 3- ɛne Bismillaahi.<br /> 4-<span class="c6"> Kasa ɛka:</span> Aameen.w<br /> 5-ɛne suura akenkae wɔ faatiha akye.<br /> 6- ɛndaade ɛfa Imaam quraan akenkae.<br /> 7-<span class="c6"> Kasa ɛka wɔ Alhamdu akye:</span> \'\'Mil\'u Samaawaati,wal arudu,wamil\'u,wamil\'u maashi\'iti min shay\'in bandi.\'\'<br /> 8- Sɛdeɛ ɛde bi ɛka hɔ mprɛ baako mo wɔ tasbeehi rukuu mo.<span class="c6">ɛkyerɛ :</span> tasbeehi mmienu ɛne mmiensa,ɛna sɛdeɛ ɔbɛpɛ na ɔde bi akahɔ saa so.<br /> 9- Sɛdeɛ ɛda so ɛde bi ɛkahɔ mprɛ baako mo wɔ sujuudu tasbeehi mo.<br /> 10-<span class="c6"> Sɛdeɛ ɔda so ɛde bi ɛkahɔ wɔ nekasa yɛ mo ne sujuudu mmienu ɛntɛm:</span> <span class="c3">«Rabbi Igfiri lee»</span>.<br /> 11- Nyamefrɛ tashahhudu awieyɛ wɔ Alaa Aalihii Alayhum Salaam,wabarakatu alayhi wa alayhim,ɛna mpaebo wɔ nakye.<span class="c6"><br /> ɛnae\' :</span> Sunnah dwumadie,<span class="c6">ɛna yato dii ɛkwoɔkwuo:</span><br /> 1- Nsa mmienu ɛpɛgya ɛfa takbeeratul Iheraam ɛka.<br /> 2- ɛna ɛwɔ Rukuu\'u.<br /> 3- ɛna ɛwɔ nakye soregyina ɛfiri hɔ.<br /> 4- ɛna ɔde nemmienu ɛbɛba fum saa so.<br /> 5- na ɔde nifa ɛbɛto bonkom so.<br /> 6- Na wahwɛ wɔ beya a ɔbɛyɛ sujuudu.<br /> 7- Na watiti wɔnnom ɛntɛm ne wonae ɛngyina hɔ mo.<br /> 8- Na wakuta wonsa mo ɛfa wonsa nsoa ɛmo beyɛ wɔ rukuu mo,ɛne na waterɛ woakye ɛwom saa,na wama wotire ne no ayɛpɛ ne woakye.<br /> 9- Na wama wo aposo aposo atare fum yie wɔ sujuudu mo,ɛna ɛbɛkwɔ pɛpɛɛpɛ akwama ne sujuudu no.<br /> 10- Na prɛkwɔ pɛ aboa wɔ wonkyɛ mo,ɛna woyam ɛwɔ woserɛ mo,ɛna woserɛ so wɔ wonae akye,ɛna na watiti wo abɛti ɛntɛm,na wonae no atimtim ɛgyina so,na wama woyam ne wonsansoa mmienu no wɔ fum ɛmo abeɛ beyɛ,na wo de wonsa ato wo abɛti na wabeɛ mo wonsasoa ɛda fum.<br /> 11- ɛna awoto wɔ atinasie mo ɛntɛm ne sujuudu mmienu nom,ɛna ɛwɔ tashahuddu ɛdekae,ɛne awieyɛ wɔ mmienu nom.<br /> 12- Na wo de wonsa ato wɔ woserɛ kwɔtodwɛ so na wabeɛ wonsansoa no sujuudu mmienu ɛntɛm,ɛna saa so wɔ tashahuddu agye nokware ɔno no ɔkutam ɛfiri nifa so,ɛna wobɛma wonsansoa akyerɛkwan no atine wonim na wotomtom Onyame.<br /> 13- Na wahwɛ wonifa so ɛne wobonkom so wɔ salaam ɛka. </p>',
      ],
      23 => [
        'question' => 'Asɛmbosa 24: Nyamefrɛ sɛiyyɛ dodoɔ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/4210.mp3',
        'answer' => '<p> Anuye- <span class="c2">(1)</span> Wo bɛgyae afapim anaasɛ mmera ɛfiri mmera mo Nyamefrɛ.<br /> <span class="c2">(2)</span> Sɛ wobɛ kasa boapayɛ mo.<br /> <span class="c2">(3)</span> ɛduane di anaasɛ nsuo num.<br /> <span class="c2">(4)</span> Nkekahɔ dodoɔ adanidani.<br /> <span class="c2">(5)</span> Wobɛgyae ɛnhyɛ ɛfiri ɛnhyɛ Nyamefrɛ boapayɛ. </p>',
      ],
      24 => [
        'question' => 'Asɛmbosa 25: ɛkwan bɛnso na musliminii ɛfrɛ Nyame \'\'salat\'\'?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/4280.mp3',
        'answer' => '<p> Anuye-<span class="c6"> Sɛdeɛ yɛfrɛ Nyame \'\'Salat\'\':</span><br /> 1- Sɛ wobɛhwɛ qibila ɛfa wohonam nyinara,wɔ abraa wonmani anaasɛ wondanidani wonim.<br /> 2- ɛnoakye waya niyya wɔ nyamefrɛ neso deɛ ɔpɛsɛ ɔfrɛ ɛnyɛ kasa ka niyya.<br /> 3-<span class="c6"> ɛnoakye wobɛyɛ takbeeratul Iheraam na wakasɛ :</span> <span class="c2">( Allaahu Akbar)</span>, na wapɛgya wonsa akwɔsoro ne wo abɛti ayɛ pɛ ɛwɔ takbeer nohɔ.<br /> 4 - ɛnoakye ɔde nensa nifa ɛbɛto wɔ nensa bonkom no nebuso soro.<br /> 5 -<span class="c6"> ɛnoakye wabeɛ nyamefrɛ mpaebo na wakasɛ:</span> <span class="c3">«Allaahumma baa\'id baynii wabayna khataayaaya kamaa baa\'iditu baynal mashriq wal magrib,Allaahumma naqnii min khataayaaya kamaa yonqii thawbal abyad minal danas,Allaahum igsilnii min khataayaaya bilmaa\'i walthalgi walbarid»</span>.<span class="c6"><br /> Anaasɛ wabɛka:</span> <span class="c3">«Subhaanaka Allaahumma wabi hamdika,watabaaraka ismuka,wata aalaa jadduka,walaa ilaaha gayruka»</span>.<br /> 6 -<span class="c6"> ɛnoakye na waka Auuzubillaahi:</span> <span class="c3">«Auuzubillaahi mina shaytaani rajeem»</span>. 7 -<span class="c6"> ɛnoakye na wakae basmala Alfaatiha na wakasɛ:</span> <span class="c4">{ Bismillaahi Rahmaanir Raheem 1 Alhamdu Lillaahi Rabil Aalameen 2 Arrahmaanir Raheem 3 Maaliki Yawmi deen 4 Iyyaaka na\'abudu wa iyyaaka nasta\'een 5 Ihidinal siraa\'tal mustaqeem 6 Siraa\'tal laziina an\'amta \'alayhim gayril magduubi \'alayhim wala \'daalleen 7}</span> <span class="c5">[ Suuratul Faatiha: ]</span>.<span class="c6"><br /> ɛnoakye na waka sɛ :</span> <span class="c2">( Aameen )</span> ɛkyerɛ : Allaahumma istajib Oh Onyame gyetom.<br /> 8 - ɛnoakye na wakenkae deɛ ɔbɛtumi akae afiri quraan nom,ɛna ahomakye Nyamefrɛ yɛkenkae tentee ɛwom.<br /> 9 - ɛnoakye na wayɛ rukuu,<span class="c6">ɛkyerɛ:</span> na wabu womo akyere ahobrasie mo ɛma Onyame,ɛna waka Allaahu Akbar ɛwɔ rukuu yɛ no mo,na wapɛgya wonsa adoro wo abɛti.<span class="c6">ɛna sunnah yɛ:</span> sɛ woterɛ wo akye yie,ɛna wobɛma wotire atine ne no ayɛ pɛ,na wode wonsa ato wɔ wobuso wakaatom wonsansoa no ɛkutam.<br /> 10 -<span class="c6"> Na waka wɔ worukuu yi mo:</span> <span class="c3">«Subhaana Rabbiyal Azeem »</span> Mprɛ mmiensa,<span class="c6">ɛnasɛ wode bi ɛbɛkahɔ:</span> <span class="c3">«Subhaanaka Allaahumma wabi Hamdika,Allaahumma Igfiri lee »</span> Na watihɔ.<br /> 11 -<span class="c6"> ɛnoakye na wapɛgya netire afiri rukuu yi nom asore agyina akasɛ:</span> <span class="c3">«Simi\'a Allaahu liman Hamida»</span>, na wapɛgya nensa saa mmerɛ nom akwɔ nabɛti so.<span class="c6"> ɛna akyerɛdifoɔ nkasɛ:</span> <span class="c3">«Sim\'a Allaahu liman Hameda»</span>,<span class="c6"> ɛna nokware sɛdeɛ ɔbɛka ahyɛ anaamo:</span> <span class="c3">«Rabbanaa walakal Hamdi »</span>.<br /> 12 -<span class="c6"> ɛnoakye na waka pɛgya no akye :</span> <span class="c3">«Rabbanaa walakal Hamd,mil\'ul samaawaati wal arudu,wamil\'u maa shiit min shay\'in band»</span>.<br /> 13 - ɛnoakye na ɔbɛyɛ sujuudu a ɛyɛ sujuudu ɛdekae,<span class="c6">na waka ho nejuudu mo:</span> <span class="c3">«Allaahu Akbar»</span>,<span class="c6"> na wayɛ sujuudu ɛwɔ neposo nsu mo:</span> wo moma ɛne wohwine,ɛne wonsa yam,ɛna wokotodwɛ mmienu,ɛne wonae mmienu,ɛna wo aposo abɛti mmienu,ɛna ɛnyɛ adeɛ wobɛpaepae wonsa atente atente no ato fum,ɛna wobɛ wotire ahwɛ ɛne wonsansoa ahwɛ qibla.<br /> 14 -<span class="c6"> Na waka wɔ sujuudu yi mo:</span> <span class="c3">«Subhaana Rabbiyal A\'alaa »</span> Mprɛ mmiensa,<span class="c6">ɛnasɛ wode bi ɛbɛkahɔ:</span> <span class="c3">«Subhaanaka Allaahumma wabi Hamdika,Allaahumma Igfiri lee »</span> Na watihɔ.<br /> 15 -<span class="c6"> ɛnoakye na wapɛ netire afiri sujuudu mo akasɛ:</span> <span class="c3">«Allaahu Akbar»</span>.<br /> 16 - ɛnoakye na watinasi wɔ sujuudu mmienu ɛntɛm ɛwɔ wonae bonkonsu,na wonae nifa no ɛdasu,na wode wonsa nifa ato wɔ woserɛ kwɔtodwɛsu ɛfiri sɛdeɛ ɛdidiso,na wakuta wakyekyere wonsansoa nom,na wapɛgya akyerɛkwan nsansoa no ahwɛ animo wɔ mpaebo mo,ɛna afei wode wonsansoa bonkom no so ɛbɛto adaso abeɛ mo ɛwɔ woserɛ kwɔtodwɛ nesu ɛfri sɛdeɛ ɛdidisu.<br /> 17 -<span class="c6"> Na waka wɔ wontinasie nom sujuudu mmienu ɛntɛm:</span> <span class="c3">«Rabbi Igfiri lee, Wal Hamnii,wa ihedinii,wa irizuqunii,wa igbarinii,wa \'aafinii»</span>.<br /> 18 - ɛnoakye nawayɛ sujuudu a ɛtoaso mmienu ɛtisɛ kanii deɛ no ɛfa deɛ wokaa yɛ no nawaka nawayɛ,na wayɛ takbeer wɔ wosujuudu no.<br /> 19 -<span class="c6"> ɛnoakye na wasore afiri sujuudu mmienu nom na wakasɛ:</span> <span class="c3">«Allaahu Akbar»</span> na wayɛ rakaa ɛtoaso mmienu ɛtisɛ baako no ɛne deɛ ɛwom nawaka,agyesɛ nokware ɛnyɛ adeɛ ɔbeɛ ɛwom soa.<br /> 20 -<span class="c6"> ɛnoakye na watinase wɔ rakaa mmienu no awieyɛ no nom na wakasɛ:</span> <span class="c3">«Allaahu Akbar»</span>, ɛna afei ɔbɛtinase sɛdeɛ ɔtinaase wɔ sujuudu mmienu ɛntɛm pɛpɛɛpɛ.<br /> 21 - Na wakenkae attashahuddu wɔ saa ɛntinasie nom,<span class="c6">na wakasɛ:</span> <span class="c3">«Attahiyaatu Lillaahi wass\'alawaati wata\'yyibaati,Assalaamu alayka ayyuhal Nabiyyu warahamatullaahi wabarakatuhu,Assaalamu alaynaa wa\'alaa ibaadillaahi saaliheen,Ash\'hadu an laa ilaaha illal Laah,Wa ash\'hadu anna Muhammadan a\'bduhuu warasuuluhu,Allaahumma \'salli \'alaa Muhammad wa\'alaa aali Muhammad,kamaa \'salayta \'alaa ibraaheem wa\'alaa aali ibraaheem,Innaka Hameedun majeed,wabaarik alaa muhammad wa\'alaa aali muhammad,Kamaa baarakata alaa ibraaheem wa\'alaa aali ibraaheem,Innaka Hameedun majeed.A\'uuzubillaahi min \'azaabi jahannam,wa min \'azaabil qabir,wamin fitnatil mahayaa walmamaati,wamin fitnatil masiihi dajaal»</span>, ɛnoakye na wabon mpaebo afrɛ wo Awurade ɛfa adeɛ wapeneso afiri adepa mo wiase mo ɛne awieyɛ da ɛmo.<br /> 22-<span class="c6">ɛnoakye na wato salaam wɔ wonifa so na waka:</span> <span class="c3">«Assallaamu alaykum warahamatullaahi»</span> ɛna saa so na wobɛyɛ wo bonkomso saa.<br /> 23 - ɛna ɛkwɔbasɛ Nyamefrɛ no yɛ mmiensa anaasɛ ɛnae;na wagyina wɔ nawieyɛ ɛdekae tashahhudu mo,<span class="c6">ɛno nayɛ:</span> <span class="c3">«Ash\'hadu an laa ilaaha illal Laah,Wa ash\'hadu anna muhammadan\'abduhu warasuuluhu»</span>.<br /> 24 -<span class="c6"> ɛnoakye ɔde aba agyina ho mo na wakasɛ:</span> <span class="c3">«Allaahu Akbar»</span> ɛnɛ wobɛgya wonsa akwɔ wo apɛtiso saa mmerɛ nom.<br /> 25 - ɛnoakye na wafrɛ nyamefrɛ no deɛ aka afiri nyamefrɛ nom ɛwɔ rakaa mmienu ɛsu mo,agye nokorɛ ɔno no ɔtiso ɛwɔ nefaatiha akenkae mo.<br /> 26 - ɛnoakye na watinase na ɔde nifa no ato bonkom no so,na waye wonae bonkom no afiri wonae akye ase nifa so,na ɛwɔ nebeya mo ɛfiriyfum,na ɔde wonsa ato wɔ ɛsu a yɛ de ɛto ɛwɔ tasha\'hudu ɛdekae mo.<br /> 27 - Na wakenkae ɛwɔ saa ɛntinasie nom tasha\'huddu nyinara.<br /> 28 -<span class="c6"> ɛnoakye na wato salaam wɔ wonifa so na waka:</span> <span class="c3">«Assallaamu alaykum warahamatullaahi»</span> ɛna saa so na wobɛyɛ wo bonkomso saa. </p>',
      ],
      25 => [
        'question' => 'Asɛmbosa 2\'6\' : Deɛ wobɛka afiri azkaari mpaebo mo wɔ salaam akye afiri Nyamefrɛ nom?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/4610.mp3',
        'answer' => '<p> Anuye - <span class="c3">«Astagfirul Laahi»</span> mprɛ mmiensa.<br /> - <span class="c3">«Allaahumma antassalaam waminka salaam,tabaarakta yaa zul jalaali wal ikraam»</span>.<br /> - <span class="c3">«Laa ilaaha illallaahi wahadahuu laa shariika lahu,lahul mulku walahul hamd,wahuwa \'alaa kulli shau\'in qadiir,Allaahumma laa maani\'a limaa a\'atayta,walaa mu\'tiya limaa mana\'ta,walaa yanfa\'u,\'zul jaddi minkal jaddi»</span>.<br /> - <span class="c3">«Laa ilaaha illallaah,wahadahuu laa shariika lahu,lahul mulku walahul hamd,wahuwa alaa kulli shay\'in qadiir,Laa hawla walaa quwwata illaa Billaah,walaa na\'abudu illaa iyyaahu,Lahu nii\'matu walahul fadul walahu thanaa\'ul hasan,Laa ilaaha illallaah mukhli\'siina lahul deena walaw karehal kaafiruun»</span>.<br /> - <span class="c3">«Subhaanal Laah»</span> mprɛ ɛduasie mmiensa.<br /> - <span class="c3">«Alhamdu Lillaah»</span> mprɛ ɛduasie mmiensa.<br /> - <span class="c3">«Allaahu Akbar »</span> mprɛ ɛduasie mmiensa.<span class="c6"><br /> ɛnoakye na waka ama no ahyɛma:</span> - <span class="c3">«Laa ilaaha illallaah,wahadahuu laa shariika lahu,lahul mulku walahul hamd,wahuwa alaa kulli shay\'in qadiir,»</span>.<br /> - Na wakenkae suuratul Ikhlas ɛne mu\'awwadhaati.mprɛ mmiensa wɔ fajir ɛne maghrib akye,ɛna baako pɛ wɔ Nyamefrɛ deɛaka no akye.<br /> - Na afei wakenkae aayatul kursiyyu.mprɛ baako pɛ. </p>',
      ],
      26 => [
        'question' => 'Asɛmbosa 27: Deɛbɛn nayɛ sunanen rawaatib? ɛna deɛ yɛ nenfasoɔ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/4730.mp3',
        'answer' => '<p> Anuye - Rakaa mmienu ɛyɛ ansaana fajir.<br /> Rakaa ɛnae ansaana zuhur.<br /> Rakaa mmienu zuhur akye.<br /> Rakaa mmienu ansaana maghrib.<br /> Rakaa mmienu Isha akye.<span class="c6"><br /> Nenfasoɔ:</span>ɔkomhyane akasɛ: <span class="c3">«Deɛ ɔbɛfrɛ Nyame wɔ ɛda ɛne anadwo mo ɛdu mmienu rakaa naafila bi na Onyame ɛbɛsi ɛfie ama nɔ wɔ aljannah mo»</span> ɛfiri Muslim ɛne Ahmed ɛne deɛ ɔmɔ ɛka hɔ. </p>',
      ],
      27 => [
        'question' => 'Asɛmbosa 2\'8\': Deɛbɛn nayɛ nawɔtwe nda mo ɛnfasoɔ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/4800.mp3',
        'answer' => '<p> ɛyɛ ɛfieda ɛda,<span class="c6">ɔkomhyane aka Onyame asomdwie nka nɔ:</span> <span class="c3">«Nokorɛ ɛfiri animuoyam nfasoɔ ɛma mɔ nda mo ɛfieda ɛda mo ɛmo na yɛbɔɔ Aadam ɛwom ɛna ɛmo na yɛgyee nenkwa ɛna ɛmo na yɛbɛhu totrobɛnto ɛna ɛmo na yɛbɛwu na mɔnfrɛ Nyamefrɛ dodoɔ ɛnfiri ɛmo na nokorɛ mɔ Nyamefrɛ no ɛbɛba meho saa ɛda no »</span>.<span class="c6"> Wakasɛ :</span> ɔmɔ ɛkaasɛ oh yaa Rasuulul Laahi ɛbɛyɛ dɛnna yɛ salaati ɛbɛduro wonkyɛ na nokorɛ wamani amayɛ? -na wɔnnom ɛrekasɛ ɛfa ɛhao neɛ -<span class="c6"> Na waka:</span> <span class="c3">«Nokorɛ Onyame ɔtumifoɔ ɔkɛsie wayɛ no akyerɛwadeɛ ama asaase sɛ ɔbɛdi akomhyafoɔ honam»</span> Rawaawu Abu Dawud ,ɛne deɛ ɔmɔ ɛkahɔ. </p>',
      ],
      28 => [
        'question' => 'Asɛmbosa 29\'\': Deɛbɛn nayɛ ɛfieda Nyamefrɛ jum\'ah mmera ɛnhyehyɛyɛ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/4840.mp3',
        'answer' => '<p> Anuye - ɛyɛ farudu \'Ayne ɛwɔ musliminii biara bɛrima ɔyene ɔwɔ adwene ɔyɛ ɔtimofoɔ.<span class="c6"><br /> Na ɔkrɔnkɔnii kɛsie akasɛ:</span> <span class="c4">{ Oh ɛyɛ mɔ deɛ mayagyie nasɛ yɛfrɛ mɔ ɛfa Nyamefrɛ ɛwɔ ɛfieda jum\'ah ɛda na mɔnyɛ ɛntɛm ɛnkwɔ Onyame ɛntomtomyɛ ɛna mɔngyae dwadie,saa no ɛmamɔ yɛ adepa ɛma mɔ,nasɛ ɛyɛ adeɛ a anka mɔnim a 9}</span>. <span class="c5">[ Suuratul Munaafiquun: 9]</span>. </p>',
      ],
      29 => [
        'question' => 'Asɛmbosa 30: Jum\'ah Nyamefrɛ rakaa dodoɔ ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/4880.mp3',
        'answer' => '<p> Anuye - Dodoɔ jumah rakaat nyamefrɛ yɛ rakaa mmienu ɛwɔ ɛmo ɛntɛm Imaam ɛkenkae ɛma no ɛpeɛ adaadi ɛfa quraan no,ɛwɔ mmerɛ a yɛyɛ khutuba mprɛ mmienu yɛnim saa. </p>',
      ],
      30 => [
        'question' => 'Asɛmbosa 31:Sɛnti ɛyɛsɛ wobɛdani dani wɔ jumah ɛda na wonba anaa?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/4910.mp3',
        'answer' => '<p> Anuye - ɛnyɛ adeɛ a ɛyɛ adepa ɛwɔ jum\'ah ɛda agye sɛ ɛfiri akwansi bi mmera,<span class="c6">ɛbaa wɔ ɔkomhyane kasa mo Onyame asomdwie nka nɔ:</span> <span class="c3">«Deɛ ɔbɛgyae nenkabom mmerɛ mmerɛ ɛfa hɔ; ɛntoatoaso Onyame akyeredie ɛwɔ nakoma mo»</span> Rawaawu Abu Dawud ,ɛne deɛ ɔmɔ ɛkahɔ. </p>',
      ],
      31 => [
        'question' => 'Asɛmbosa 32: Ke ka sunnah ɛwɔ jumaah ɛda?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/4940.mp3',
        'answer' => '<p> Anuye-<br /> 1 - Adwareyɛ \'\'Gusl\'\'.<br /> 2 - Adehwam.<br /> 3 - Na wahyɛ adaade fɛfɛɛfɛ.<br /> 4 - Attabkeer ɛwɔ Nyamedae mo.<br /> 5 - Dodoɔ ɛka ɛfiri salaati ɛma ɔkomhyane Onyame asomdwie nka nɔ.<br /> 6 - Suuratul Qaaf akenkae.<br /> 7 - Nanteɛ ɛkwɔ Nyamedae mo ne nanteɛ mo.<br /> 8 - ɛyɛ mmerɛ a yɛgye mpaebo. </p>',
      ],
      32 => [
        'question' => 'Asɛmbosa 33: Keka animuoyam nfasoɔ ɛfa Jumaah Nyamefrɛ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5050.mp3',
        'answer' => '<p> Anuye - ɛfa Abdullaahi bun Umar Onyame npenie nka wɔnnom,<span class="c6">nokware Onyame somafoɔ Onyame asomdwie nka nɔ akasɛ:</span> <span class="c3">«Nipa dodoɔ Nyamefrɛ ɛdemo animuoyam mo ɛsene baakofoɔ nyamefrɛ ɛfa ɛduanunsu ɛnhyira»</span> Ɛfiri Muslim Nwoma mo. </p>',
      ],
      33 => [
        'question' => 'Asɛmbosa 34: Dɛɛbɛn nayɛ ahobrasie khushuu\'i ɛwɔ Nyamefrɛ mo?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5080.mp3',
        'answer' => '<p> Anuye - ɛno nayɛ wode wakoma ɛbɛma Nyamefrɛ no ɛne wobɛtimtim aya ahosie honam ɛwom.<span class="c6"><br /> Na ɔkrɔnkɔnii kɛsie akasɛ:</span> <span class="c4">{Nokorɛ agyediefoɔ adi nkɔnim 1 Deɛ ɔmɔ ɛwɔ wɔnnom Nyamefrɛ mo ahobrasie ɛwom 2}</span> <span class="c5">[ Suuratul Muminuun: 1,2,]</span>. </p>',
      ],
      34 => [
        'question' => 'Asɛmbosa 35: Zaka asekyerɛ ase ne?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5120.mp3',
        'answer' => '<p> Anuye - ɛyɛ noware kyɛfa ɛnhyɛ wɔ agyapadie soronkwo mo ɛma nkrufoɔ soronkwo bi mo wɔ mmerɛ soronkwo mo.<br /> - ɛna ɛyɛ afapim afiri Islaam afapim nom,ɛna sadaqa yɛ ɛnhyɛ yɛye ɛfiri asikafoɔ nom agyapadie mo na yɛ de ama ahiafoɔ.<span class="c6"><br /> Na ɔkrɔnkɔnii kɛsie akasɛ:</span> <span class="c4">{ ɛna mɔnye mɔ zaka ɛmma }</span>. <span class="c5">[ Suuratul Baqara: 43]</span>. </p>',
      ],
      35 => [
        'question' => 'Asɛmbosa 36: Deɛbɛn nayɛ sadaqa mustahabba \'\'ɛnyɛ ɛnhyɛ\'\'?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5170.mp3',
        'answer' => '<p> Anuye - ɛyɛ deɛ ɛnyɛ zaka ye,<span class="c6">ɛtisɛ:</span> sɛ wode adeɛ a biara ɛyɛ adepa ɛsɔ ani ɛbɛyɛ sadaqa ama obi ɛwɔ mmerɛ biara mo.<span class="c6"><br /> Na ɔkrɔnkɔnii kɛsie akasɛ:</span> <span class="c4">{ ɛna mɔnye mɔ agyapadie ɛmma ɛwɔ Onyame ɛkwan so}</span> <span class="c5">[ Suuratul Baqara: 195]</span>. </p>',
      ],
      36 => [
        'question' => 'Asɛmbosa 37: kyerɛ akyerewia siyaam ase?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5210.mp3',
        'answer' => '<p> Anuye - ɛno nayɛ ɛsom ɛma Onyame ɛfa ɛbɛkuta wanu afiri aduane di mo biara afiri anoba fajir ɛkwɔpim ɛnummrɛ ɛwia akwɔtɔ,ɛfa niyya nkankyerɛ,<span class="c6">ɛno no ɛwom mmienu:</span><br /> Siyaam akwamkyerɛ ɛnhyɛ: ɛtisɛ ramadan akyerewia bosome mo dea,ɛno no ɛka Islaam afapim nom bi.<span class="c6"><br /> Na ɔkrɔnkɔnii kɛsie akasɛ:</span> <span class="c4">{ Oh ɛyɛ mɔ deɛ mayagyedie yayɛ akyirewia no nhyɛ wɔ mɔso sɛdeɛ yayɛ no nhyɛ ama deɛ ɔmɔ ɛde ɔmɔ animo kae sɛdeɛ mɔbɛsro Onyame 183}</span>. <span class="c5">[ Suuratul Baqara: 183]</span>.<span class="c6"><br /> ɛna akwamkyerɛ siyaam ɛnyɛ ɛnhyɛ:</span> ɛtisɛ ɛdwoada akyerewia yɛ ɛne yawada ɛfiri naɛwɔtwi biara mo,ɛna akyerewia mmiensa wɔ nda mo ɛfiri bosomi biara mo,ɛna nendemo nayɛ ayyaamul bayd <span class="c2">(13,14,15)</span> ɛfiri bosome qamarii biara mo. </p>',
      ],
      37 => [
        'question' => 'Asɛmbosa 38\': Keka ɛnfasoɔ animuoyam ɛwɔ Ramadan akyerewia bosome mo?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5270.mp3',
        'answer' => '<p> Anuye :Ɛfiri Abaa Huraira papa nkyɛn Nyame ngye no ntum,<span class="c6"> Sɛ Onyame Somanii Nyame nhyira ne n\'asomdwie nka no aka sɛ:</span> <span class="c3">«ɔbiara a ɔbɛyɛ akyerewia ɛwɔ gyedie mo ɛna ɔde ɛrehwehwɛ nhyira; yɛ de nebone ɛkyɛ nɔ deɛ atwam ɛfiri nebone mo»</span> Yatimtim so.Bukhaare ɛne Muslim. </p>',
      ],
      38 => [
        'question' => 'Asɛmbosa 39\': Keka nfasoɔ adom akyerewia akwama ɛnyɛ ramadan ɛnhyɛ deɛ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5300.mp3',
        'answer' => '<p> Ɛfiri Abii Saeed papa nkyɛn Nyame ngye no ntum,<span class="c6"> Onyame Somanii Nyame nhyira ne n\'asomdwie nka no aka sɛ:</span> <span class="c3">«Yɛnne ɛfiri akoa bi nom na ɔbɛyɛ akyerewia ɛda bi mo ɛwɔ Oyame ɛkwan so,agye saa ɛda Onyame ɛma ɔne nanim ɛware yie afiri amanehunu ɛgya ɛkyew ɛduasu khareefan mo»</span> Yatimtim so.Bukhaare ɛne Muslim.<br /> - Nasekyerɛ <span class="c3">«saba\'uuna»</span>; ɛkyerɛ: afi ɛnfie ɛduasu. </p>',
      ],
      39 => [
        'question' => 'Asɛmbosa 40: Keka adeɛ a ɛsɛi akyerewia nom bi?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5330.mp3',
        'answer' => '<p> Anuye- 1- Aduane di ɛne nsuo num boabayɛ mo.<br /> 2- ɛfeɛ boabayɛ mo.<br /> 3- Islaam ɛgyae. </p>',
      ],
      40 => [
        'question' => 'Asɛmbosa 41: Deɛbɛn nayɛ akyerewia sunnah?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5380.mp3',
        'answer' => '<p> Anuye- 1- Ntɛmtɛm ɛbeɛ wanu fitir ɛduane.<br /> 2 - ahomakye sahuur afuane ɛdi awieyɛ mmerɛ mo.<br /> 3 - wo bɛyɛ bi akahɔ wɔ dwumadie pa ɛne ɛsom mo.<br /> Kyerewia nee be kasa me ye Kyerewia nee<br /> 5 - Mpaebo ɛwɔ fitir aduane ɛbeɛ.<br /> 6 - Fitir aduane di yɛ ratab \'\'dabino mono\'\' anaasɛ Dabino,nasɛ wanya bi a; ɛnɛ num nsuo. </p>',
      ],
      41 => [
        'question' => 'Asɛmbosa 42: Deɛbɛn nayɛ Hajji asekyerɛ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5460.mp3',
        'answer' => '<p> Anuye-<span class="c6"> Al Hajji:</span> ɛno no ɛyɛ ɛsom ɛma Onyame kɛsie,ɛfa nensusuyɛ ɛkwɔ Onyame fie haraam mo ne dwumadie soronkwo ɛdi ɛwɔ ɛmmerɛ mo.<span class="c6"><br /> Na ɔkrɔnkɔnii kɛsie akasɛ:</span> <span class="c4">{ ɛna Onyame wɔ nipa so ne hajji fie ɛfiri deɛ ɛwɔ ho tumi ɛkwantwayɛ wɔhɔ,ɛna deɛ ɔbɛ yeno kaafiriya na nokorɛ Onyame nɛyɛ agyapadie ahɔya wura wɔ adasamma so 97}</span>. <span class="c5">[Suuratul Aali Imraan 97]</span>. </p>',
      ],
      42 => [
        'question' => 'Asɛmbosa 43: Hajji afapim dodoɔ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5500.mp3',
        'answer' => '<p> Anuye- 1- Ihraam ɛhyɛ frantoma.<br /> 2 - Arafa ɛgyina.<br /> 3 - ɛna tawaaf ifaada ɛtwa kaaba hɔ ɛhyia mmienu.<br /> 4 - Sa\'ayi safaa ɛne mariwa ɛntɛm nanteɛ. </p>',
      ],
      43 => [
        'question' => 'Asɛmbosa 44: Deɛbɛn nayɛ Hajji ɛnfasoɔ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5560.mp3',
        'answer' => '<p> Anuye :Ɛfiri Abaa Huraira papa nkyɛn Nyame ngye no ntum,<span class="c6"> Sɛ Onyame Somanii Nyame nhyira ne n\'asomdwie nka no aka sɛ:</span>Watisɛ Onyame somafoɔ ɛrekasɛ: <span class="c3">«ɔbiara a ɔbɛyɛ Hajji Onyame nti na wanyɛ ɛwɔ ho adwamae anaasɛ kwasiade bi boneyɛ mo; ɔsani nakye aba fie no na ɔtisɛ ɛdaa nemaame awo no»</span> ɛfiri Bukhaari mo.<br /> - <span class="c3">«ɛtisɛ ɛda a nemaame awo nɔ»</span> ɛkyerɛ ɛfa sɛ ɔnne bone biara. </p>',
      ],
      44 => [
        'question' => 'Asɛmbosa 45: kyerɛ Umura asekyerɛ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5600.mp3',
        'answer' => '<p> Anuye-<span class="c6"> Al \'Umura:</span> ɛno no ɛyɛ ɛsom ɛma Onyame kɛsie,ɛfa nensusuyɛ ɛkwɔ Onyame fie haraam mo ne dwumadie soronkwo ɛdi ɛwɔ ɛmmerɛ mo. </p>',
      ],
      45 => [
        'question' => 'Asɛmbosa 46\': Umura afapim dodoɔ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5630.mp3',
        'answer' => '<p> Anuye- 1- Ihraam ɛhyɛ frantoma.<br /> 2 - Tawaaf yɛ wɔ ɛfie ho.<br /> 3 - Sa\'ayi safaa ɛne mariwa ɛntɛm nanteɛ. </p>',
      ],
      46 => [
        'question' => 'Asɛmbosa 47: Deɛbɛn nayɛ Jihaad wɔ Onyame ɛkwan so?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5690.mp3',
        'answer' => '<p> Anuye- ɛyɛ mmodenbo dwumadie ɛne mbaeyɛ mo wɔ Islaam ɛterɛ mo ɛne nemmoaboa wɔhɔ ɛne deɛ ɛkahɔ biara,anaasɛ akɔ ɛtia Islaam atanfo ɛne deɛ ɛkekahɔ nyinara.<span class="c6"><br /> Na ɔkrɔnkɔnii kɛsie akasɛ:</span> <span class="c4">{ ɛna mɔnbo moden ɛfa mɔ agyapadie ɛne mɔhɔ ɛwɔ Onyame ɛkwan so saa no nɛyɛ adepa ɛma mɔ nasɛ ɛyɛ adeɛ a anka mɔnim a 41}</span> Suratul Tawba: 41]. </p>',
      ],
    ],
    3 => [
      0 => [
        'question' => 'Asɛmbosa 1: Wae mo nayɛ ɔkomhyane Muhammed abusua Onyame asomdwie nka nɔ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5740.mp3',
        'answer' => '<p> Anuye- ɔnɔ nayɛ Muhammɛd bun Abdullaah bun Abdul Muttallib bun Haashim ɛna Haashim ɛfiri Quraish mo ɛna Quraish so ɛfiri Arab mo ɛna Arab ɛfiri abusua a ɛyɛ Ismaael abusua mo ɛna Ismaael Ibn Ibraaheem neso ɛna ɛwɔ yɛ ɔkomhyane ɔnimuoyamfoɔ mpaebo ɛne asomdwie nka nɔ. </p>',
      ],
      1 => [
        'question' => 'Asɛmbosa 2: ɔkomhyane Onyame asomdwie nka nɔ nemaame ɛdii ɛdesɛn?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5770.mp3',
        'answer' => '<p> Anuye - Aaminatu Bintu Wahab. </p>',
      ],
      2 => [
        'question' => 'Asɛmbosa 3: ɛdabɛn na nepapa ɛwu yɛ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5800.mp3',
        'answer' => '<p> Anuye- Nepapa ɛwu wɔ Madina na yafa neyensɛ yɛfunu,ɛnyɛ adeɛ a yawono Onyame asomdwie nka nɔ. </p>',
      ],
      3 => [
        'question' => 'Asɛmbosa 4: Dabɛn na yɛwoo ɔkomhyane Onyame asomdwie nka nɔ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5830.mp3',
        'answer' => '<p> Anuye- ɛwɔ ɔsono afi mo,ɛwɔ ɛdwoada ɛwɔ rabii\'ul awwal bosome mo. </p>',
      ],
      4 => [
        'question' => 'Asɛmbosa 5:ɛwɔ kro bɛnso na yɛwo no?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5850.mp3',
        'answer' => '<p> Anuye- ɛwɔ makkah. </p>',
      ],
      5 => [
        'question' => 'Asɛmbosa 6: Wae na ɛmaa nɔ nofoɔ ɛhwɛɛ no ɛwɔ nemaame akye?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5880.mp3',
        'answer' => '<p> Anuye-Naboafoɔ nepapa ummi Ayiman.<br /> - Aboafoɔ nesua Abii Lahab,suwaeba.<br /> - Haleematu Sa\'aaditu. </p>',
      ],
      6 => [
        'question' => 'Asɛmbosa 7: Mmerɛ bɛn na nemaame ɛwuu yɛ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5930.mp3',
        'answer' => '<p> Anuye- Nemaame ɛwu yɛ na ɛwɔ nfie nsia,ɛna nenana ɛgyeeno Abdul Mutallib. </p>',
      ],
      7 => [
        'question' => 'Asɛmbosa 8: Wae na ɔkutaa no wɔ abraa nenana ɛwu yɛ Abdul Muttallib?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5960.mp3',
        'answer' => '<p> Anuye- Nenana ɛwu yɛ Abdul Muttallib na ɔwɔ ibn nfie wɔhwe,ɛna newofa ɛgyeeno Abuu Taalib. </p>',
      ],
      8 => [
        'question' => 'Asɛmbosa 9: Mmerɛ bɛn na ɔde nɔ ɛtuu ɛkwan ɛkwɔɔ wɔ hyaam?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5990.mp3',
        'answer' => '<p> Anuye- ɛne nɔ newofa tuukwan ɛkwɔɔ wɔ hyaam ɛna nenfie ɛyɛ ɛdu mmienu. </p>',
      ],
      9 => [
        'question' => 'Asɛmbosa 10:Mmerɛ bɛnna akwɔntuo mmienu no ɛkwuoso?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6020.mp3',
        'answer' => '<p> Anuye- ɛyɛ adeɛ a akwantuo mmienu no wɔ dwadie ɛfa agyapadie hɔ Khadija Onyame npenie nka no,ɛna mmerɛ a ɔbaa sɛ ɔɔware ne no Onyame asomdwie,Na ɔwɔ ɛnfie ɛduano ɛnum. </p>',
      ],
      10 => [
        'question' => 'Asɛmbosa 11: Mmerɛ bɛn na quraishfoɔ ɛba bɛsii Ka\'abah?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6050.mp3',
        'answer' => '<p> Anuye- Quraishfoɔ ɛbabɛsii kaabah,Na nenfie ɛyɛ ɛduasia ɛnum.<br /> ɛna ɔdii mmera ɛwɔ mmerɛ a ɔmɔ akyenie ɛbaa wɔnnom ɛntɛm wɔ ɛfiri wae na ode hajaril aswad buo no ɛbɛhyɛ ho,ɛna ɔde nadaadeɛ ɛtuu fum,ɛna ɔhyɛɛ abusua biara sɛ ɔbɛkuta ɛntuma no anu,na ɔmɔ ɛyɛ ɛnae,na mmerɛ a ɔmopɛgya ɛrekwɔɔ soro no ɛna ɔde nensa ɛpea ɛwura mo Onyame asomdwie nka nɔ. </p>',
      ],
      11 => [
        'question' => 'Asɛmbosa 12: Na nenfie adoro sɛyn na yɛmaa nɔ komhyɛ?ɛna henfa na yasoma wɔ wɔnnom so?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6080.mp3',
        'answer' => '<p> Anuye- Na ɛyɛ adeɛ a nenfie ɛwɔ ɛduanae,ɛna yɛsomaa nɔ ɛkwɔɔ nipa so nyinara so anuhuba mo ɛne kwɔkwɔbɔ mo. </p>',
      ],
      12 => [
        'question' => 'Asɛmbosa 13:Deɛbɛn nayɛ ayedeɛ yekyerɛ a ɛdiekae wɔhɔ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6110.mp3',
        'answer' => '<p> Anuye- ɛyɛ nokorɛ dayɛsum,na nokware mo ɛnyɛ adeɛ ɔhunu dayɛ agye sɛ ɛba ɛtisɛ anuba nsoroma. </p>',
      ],
      13 => [
        'question' => 'Asɛmbosa 14: Sɛn na ɛteɛ ansaana yekyerɛ?ɛna mmerɛ bɛnna yɛsanii ayedeɛ ɛmaa nɔ ɛnfitiasie mprɛkwɔ pɛ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6140.mp3',
        'answer' => '<p> Anuye- ɛyɛ adeɛ na ɔresom ɛfa Onyame hɔ wɔ gaare haraam na watwi nehɔ afiri wiase pɛ hɔ wɔ saa so.<br /> ɛna yasane ayedeɛ ama nɔ,na ɔwɔ wɔ gaare nom ɛresom. </p>',
      ],
      14 => [
        'question' => 'Asɛmbosa15: Deɛbɛn nayɛ deɛ yasane ama nɔ ɛfiri quraan mo ɛnfitiasie mo?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6180.mp3',
        'answer' => '<p> Anuye-<span class="c6"> ɛngyinasoɔ :</span> ɛfa ɔkɛsie kasa: { Kenkae ɛfa wo Awurade ɛdii mo deɛ wabɔadeɛ 1 Deɛ wabɔ nipa afiri mogyatoa mo <span class="c2">(2)</span> Kenkae ɛna wo Awurade kɛsie animuoyam 3 Deɛ ɔde atworɔdua akyerɛ nimdie 4 Wakyerɛ nipa nimdie deɛ na ɛyɛ adeɛ na ɔnnim 5} <span class="c5">[ Suura Alaq:1 -5 ]</span>, </p>',
      ],
      15 => [
        'question' => 'Asɛmbosa 16: Wae nayɛ deɛ ɔdekae ɛyaagyedie ɛfa nesomayɛ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6200.mp3',
        'answer' => '<p> Anuye-<span class="c6"> ɛwɔ mbranteɛ mo:</span> Abubakar Siddiiq,<span class="c6">ɛna ɛfiri mmaa mo:</span> Khadija bintu Khaolad,<span class="c6">ɛna ɛfiri nkwadaa mo:</span>Ali Ibn Abii Taalib,<span class="c6">ɛna ɛfiri Aboafoɔ mo:</span> Zaid bun Haaritha,<span class="c6">ɛna ɛfiri nkoa mo:</span> Bilaal Habashiyy Onyame npenie nka ɔmɔ,ɛne deɛ ɔmɔ ɛkahɔ. </p>',
      ],
      16 => [
        'question' => 'Asɛmbos 17: ɛkwan bɛnso na Nyamesɛm afrɛ ɛrehyɛasie wɔ Islaam mo?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6230.mp3',
        'answer' => '<p> Anuye- ɛyɛ adeɛ a afrɛ ɛkwɔsɔ ɛnsumayɛ mo ɛnsɛsoɔ ɛnfie mmiensa,ɛnoakye ɛna yɛhyɛ nɔ Onyame asomdwie nka nɔ,ɛfa Nyamesɛm afrɛ ɛndaadi mo. </p>',
      ],
      17 => [
        'question' => 'Asɛmbosa 18: Na ɔkomhyane tibia ɛtisɛn Onyame asomdwie nka nɔ ɛne deɛ ɔmɔ ayagyedie ama nɔ wɔ ɛndaade no akye?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6260.mp3',
        'answer' => '<p> Anuye-Abosomsomfoɔ ɛyene wɔ wɔnnom asotwie mo ɛne muslimifoɔ asotwie ɛhao mo ateetie,ɛkwɔpimsɛ yɛ maa agyediefoɔ akwama ɛfa amantuo nanteɛ ɛkwɔ ohene Najaashi ho wɔ Habasha.<br /> ɛna abosomsofoɔ ahyia wɔ ɔmɔ ateeteɛ ɛhao mo ɛne ɔkomhyane Onyame asomdwie nka nɔ ɛkɔm,ɛna Onyame ɛbɔɔ nehɔ ɛbae ɛna ɔmaa newofa abuu Taalib ɛde ahobaebo ɛtwaa nehɔ ɛhyiaa yɛ afiri wɔnnom mɔ. </p>',
      ],
      18 => [
        'question' => 'Asɛmbosa 19: Wae mo na awu wɔ afi ɛdu mo ɛfiri mmerɛ a yasoma nɔ Onyame asomdwie nka nɔ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6300.mp3',
        'answer' => '<p> Anuye- Newofa Abuu Taalib ɛwuyɛ,ɛna neyire Khadija Onyame npenie nka nɔ. </p>',
      ],
      19 => [
        'question' => 'Asɛmbosa 20: Mmerɛ bɛnna Israa\'i wal meeraaj ɛbaa so?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6330.mp3',
        'answer' => '<p> Anuye- ɛyɛ adeɛ a ɛsii wɔ nenfie ɛduanum ɛfiri nenfie mo,ɛna yɛyɛɛ Nyamefrɛ ɛnum nhyɛ wɔ nesu.<span class="c6"><br /> Israai\':</span> ɛfiri masjidil haraam ɛkwɔ masjidil aqsaa.<span class="c6"><br /> wal Me\'eraaj:</span> ɛyɛ adeɛ a ɛfiri masjidil aqsaa ɛrekwɔɔ ɔsoro ɛkwɔɔ siderati muntahaa mo. </p>',
      ],
      20 => [
        'question' => 'Asɛmbosa 21: ɛkwan bɛnso na ɔkomhyane Onyame asomdwie nka nɔ ɛfaso ɛfrɛ nipa nom ɛfiri makkah akye?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6380.mp3',
        'answer' => '<p> Anuye- ɛyɛ adeɛ a na ɔfrɛ Nyamesɛm ɛfa taaefofoɔ,ɛna ɔmane kwɔ mmerɛ mo na waboaboa nipa anu nyinara,ɛkwɔpim sɛ madinafoɔ akristofoɔ ɛbaayɛ,ɛna ɔmɔ ɛyaagyie ɛma ɔkomhyane Onyame asomdwie nka nɔ,ɛna ɔmɔ ɛswaeyɛ ɛtimtimso ɛfa wɔ nemmoaboa nkɔnimdi. </p>',
      ],
      21 => [
        'question' => 'Asɛmbosa 22: Mmerɛ dodoɔ sɛn na ɔkomhyane ɛtina Onyame asomdwie nka nɔ wɔ Makka mo Nyamesɛm ɛfrɛ mo?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6410.mp3',
        'answer' => '<p> Anuye- ɔtina ho ɛnfie ɛdu mmiensa. </p>',
      ],
      22 => [
        'question' => 'Asɛmbosa 23: Henfa na ɔkomhyane ɛtuu amantuo hijira ɛkwɔɔyɛ Onyame asomdwie nka nɔ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6440.mp3',
        'answer' => '<p> Anuye- ɛfiri Makkah ɛrekwɔɔ madinah. </p>',
      ],
      23 => [
        'question' => 'Asɛmbosa 24: ɔtina madina mo ɛnfie sɛn?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6470.mp3',
        'answer' => '<p> Anuye- ɛnfie ɛdu. </p>',
      ],
      24 => [
        'question' => 'Asɛmbosa 25: Mmera bɛnna yayɛ amanɔ wɔ madina mo ɛnhyɛ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6490.mp3',
        'answer' => '<p> Anuye- yɛyɛ zaka ɛnhyɛ wɔ nesu,ɛne akyerewia,ɛne Hajji,ɛne Jihaad,ɛna adhaan,ɛne Islaam mmera ɛfiri mo nakye. </p>',
      ],
      25 => [
        'question' => 'Asɛmbosa 26: Deɛ bɛn nayɛ nakɔ a ɛdemo Onyame asomdwie nka nɔ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6520.mp3',
        'answer' => '<p> Anuye- Gazwa Badari akɔ kɛsie.<br /> Gazwa Uhud.<br /> Gazwa Ahazaab.<br /> Gazwa Fatihu Makkah. </p>',
      ],
      26 => [
        'question' => 'Asɛmbosa 27: Quraan aaya bɛnna yɛsane ɛmaa ɔkomhyane awieyɛ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6580.mp3',
        'answer' => '<p> Anuyeɛna ɛngyinasoɔ : ɛfa ɔkɛsie kasa: <span class="c4">{ ɛna mɔnsro ɛdaa yɛde mɔ ɛrekwɔ wɔ Onyame nkyɛ,ɛnoakye yahyɛno ɛma ama kiraa biara ɛfa deɛ wadi ɛna wɔnnom ɛnyɛ adeɛ yɛbɛsisi ɔmɔ 281}</span> <span class="c5">[ Suuratul Baqara 281]</span>. </p>',
      ],
      27 => [
        'question' => 'Asɛmbosa28: Mmerɛ bɛn na ɔkomhyani Onyame asomdwie nka nɔ ɛwuu? Na nenfie ɛyɛ sɛn?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6610.mp3',
        'answer' => '<p> Anuye- ɔwuu ɛwɔ Rabii\'ul awwal bosomi mo,ɛfiri ɛnfie ɛdu baako mo ɛfiri hijira mo,na nenfie yɛ ɛduasia mmiensa. </p>',
      ],
      28 => [
        'question' => 'Asɛmbosa 29: Keka ɔkomhyane yere nom Onyame asomdwie nka nɔ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6640.mp3',
        'answer' => '<p> Anuye- 1- Khadija Bintu Khaolad Onyame npenie nka nɔ.<br /> 2- Sawdatu Bintu Zam\'atu Onyame npenie nka nɔ.<br /> 3- Ayishatu Bintu Abaa Bakar Siddiiq Onyame npenie nka nɔ.<br /> 4- Hafsatu Bintu Umar Onyame npenie nka nɔ.<br /> 5- Zainab Bintu Khuzaematu Onyame npenie nka nɔ.<br /> 6- Ummu Salma Hindu Bintu Abii Umayyatu Onyame npenie nka nɔ.<br /> 7- Ummi Habeebatu Ramlatu Bintu Abii Sufyaan Onyame npenie nka nɔ.<br /> 8- Juwaeratu Bintu Haarith Onyame npenie nka nɔ.<br /> 9- Maemuunatu Bintu Haarith Onyame npenie nka nɔ.<br /> 10- Sufiyyatu Bintu Hayyayi Onyame npenie nka nɔ.<br /> 11-ZAYNAB BINTU JAHSH Onyame npenie nka nɔ. </p>',
      ],
      29 => [
        'question' => 'Asɛmbosa 30: Wae mo nayɛ nenbanom Onyame asomdwie nka nɔ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6760.mp3',
        'answer' => '<p> Anuye-<span class="c6"> ɛfiri mbɛrima mo yɛ mmiensa:</span><br /> Alqaasim, ɛna ɛbi yɛ samerane ɛdii.<br /> Abdul Laahi,<br /> ɛna Ibraaheem.<span class="c6"><br /> ɛfiri mmaa mo so:</span><br /> Faatimatu.<br /> Ruqayyatu.<br /> Ummi Kulthuum.<br /> Zainab.<br /> ɛna nenbanom nyinara ɛfiri Khadija mo Onyame npenie nka nɔ,ɛna wɔnnom nyinara ɛwuyɛ ansaan ɔnɔ agye Faatimatu nakye ɛfa bosome nsia. </p>',
      ],
      30 => [
        'question' => 'Asɛmbosa 31: Keka ɔkomhyane Onyame asomdwie nka nɔ ɛsu abɔadeɛ nom bi?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6880.mp3',
        'answer' => '<p> Anuye- ɛyɛ adeɛ ɔyɛ adɛntɛmo ɛwɔ mbranteɛ mo Onyame asomdwie nka nɔ ɛnyɛ adeɛ a ɔyɛ ɛfa tiatia ɛna ɛnyɛ adeɛ ɔyɛ tentee pee na ɛmom ɔyɛ adɛntɛmo wɔ saa so,ɛna ɛyɛ adeɛ a na ɔyɛ fitaa ɛna kwɔkwɔ nfoni ɛka nehɔ Onyame mpaebo ɛne nasomtwie nka nɔ,ɛna nabodwesɛ yɛ dodoɔ yie,ɛna nanim ɛterɛ,ɛna nanu ɛsu,ɛna netiriwe yɛ tuntum yie,ɛna nabɛti so ɛbae ɛɛhwɛm ɛnframa pa ɛne deɛ ɛkekahɔ ɛfiri nabɔadeɛ fɛfɛɛfɛ Onyame asomdwie nka nɔ. </p>',
      ],
      31 => [
        'question' => 'Asɛmbosa 31: ɛwɔ deɛbɛn adeɛ ɔkomhyane Onyame asomdwie nka nɔ wagyae ama nedom?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6910.mp3',
        'answer' => '<p> Anuye- ɔgyae ɛmaa nedom Onyame asomdwie nka nɔ wɔ ɛngyinasoɔ fitaa,na nadwo ɛtisɛ nawia ɛnyɛ adeɛ ɛbɛhwe naakye agye nesɛiyyɛ,ɛnyɛ adeɛ a wagyae adepa bi agye ɛngyinasoɔ ɛma nedom,ɛnyɛ adeɛ a mosoɔ ɛhao bi agye ahwɛyie ɛfiri mo. </p>',
      ],
    ],
    4 => [
      0 => [
        'question' => 'Asɛmbosa 1: Suuratul Faatiha ɛne nasekyerɛ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6960.mp3',
        'answer' => '<p> Anuye- Suura Al- Faatiha ɛne ne kyerɛaseɛ.<br /> Me de Onyame dii ɛna ɛrehyaasie ahunumobro Hene ɔdɛɛfoɔ Hene.<span class="c4">{ Bismillaahi Rahmaanir Raheem 1 { Aseda nyinara ɛyɛ Awurade ɛdea 2}</span>. Ahunumobro Hene ɔdɛɛfoɔ Hene<span class="c2">(Arrahmaanir Raheem 3)</span> Atamoada Hene<span class="c2">(Maaliki Yawmi deen 4)</span>. Wonkoaa na yɛbɛsom wo ɛna wonkoa na yɛbɛhwehwɛ mmoaboa afiri <span class="c2">(Iyyaaka na\'abudu wa iyyaaka nasta\'een 5)</span>. Tineyɛ ɛfa ɛkwan a atimtim <span class="c2">(Ihidinal siraa\'tal mustaqeem 6 ɛkwan ɛfa deɛ wayɛ ɔmɔ adom ɛnyɛ ɔmɔ a wobuafo wɔnnom anaasɛ ayerafoɔ nom(\'Siraa\'tal laziina an\'amta \'alayhim gayril magduubi \'alayhim wala \'daalleen 7} <span class="c5">[ Suuratul Faatiha: 1 - 7]</span>.<br /> Ɛnkyerɛkyerɛ \'\'Tafseer\'\'<br /> Yatu dii Suuratul Faatiha; Yɛ de ɛbeɛ Onyame nwoma wɔhɔ.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001001.mp3"></audio> 1 - <span class="c4">{ Bismillaahi Arrahamaanir Raheem 1}</span>. Bismillaahi Me de Quraan akenkae yi na me de ɛrehyɛasie,me de ɛrehwehwɛ mmoaboa wɔhɔ ɛfa ɔkɛsie nhyira ɛfa nedii nkaekaeyɛ mo.<br /> <span class="c4">{ Allaahu }</span> ɛkyerɛ: deɛ yɛsom nɔ ɛwɔ nokorɛ mo,ɛna ɛnyɛ adeɛ a yatu dii wɔhɔ wɔ ɔkrɔnkɔ akye.<br /> <span class="c4">{ Arrahamaan}</span> ɛkyerɛ: deɛ ɔwɔ dodoɔ Ahunumobro a ɛterɛ deɛ nahunumobro ɛterɛ adeɛ biara so.<br /> <span class="c4">{ Arraheem }</span> ɛkyerɛ: deɛ ɔwɔ dodoɔ Ahunumobro ɛma agyediefoɔ.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001002.mp3"></audio> 2- <span class="c4">{ Alhamdu Lillaahi Rabbil aalameen 2 }</span> ɛkyerɛ: Aseda ɛne ɛsu nyinara ahɔdoɔ ɛma Onyame nkoaa.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001003.mp3"></audio> 3- <span class="c4">{ Arrahamaan Arraheem }</span> ɛkyerɛ: dodoɔ Ahunumobro nee deɛ ɛterɛ adeɛ biara mo,ɛna dodoɔ Ahunumobro ɛsi agyediefoɔ so.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001004.mp3"></audio> 4- <span class="c4">{ Maalik Yawmi deen 4}</span> : ɛno nayɛ atamoada.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001005.mp3"></audio> 5- <span class="c4">{ Iyyaaka na\'abudu wa iyyaaka nasta\'een }</span> ɛkyerɛ : yɛ bɛsom wo wonkoaa ɛna wonkoaa na ɛrehwehwɛ mmoaboa ɛfiri.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001006.mp3"></audio> 6- <span class="c4">{ Ihedina siraatal mustaqeen 6 }</span> : ɛno nayɛ tineyɛ ɛwɔ Islaam mo ɛne Sunnah mo.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001007.mp3"></audio> 7- <span class="c4">{ Siraatal Lazee na an\'amta alayhim gayrul magduubi alayhim waladdaalleen 7}</span> ɛkyerɛ :ɛkwan a ɛyɛ Onyame nkoa pa ɛkwan ɛfiri akomhyafoɔ mo ɛne ɔmɔ akyeredifoɔ,ɛnyɛ akristofoɔ ɛne jewfoɔ akwan.<br /> -<span class="c6"> ɛna ɛyɛ sunnah sɛ wobɛkae akenkae no akye akasɛ:</span> (Aameen)</span> ɛkyerɛ: gyesu ɛmayɛ. </p>',
      ],
      1 => [
        'question' => 'Kenkae Suura Zalzala ɛne nakyerɛaseɛ.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/7130.mp3',
        'answer' => '<p> Suura Al- Zalzala ɛne ne kyerɛaseɛ.<br /> Me hyɛ ase wɔ Onyame din mu ahomɔborɔ hene ɔdɛɛfoɔ hene.<br /> { Nasɛ asaase ɛwusu nawusuo mo a 1yɛ ɛna asaase ɛbɛye nenuama duduudu 2 ɛna nipa ɛbɛkasɛ deɛbɛn na atono 3 Saa ɛda no ɔbɛbo namanie 4 ɛfa nokorɛ wo Awurade na ahyɛno ɛfa saa 5 Saa ɛda no nipa akoma mo mpaepaeyɛ ahodoɔ sɛdeɛ ɔmɔ ɛbɛhunu ɔmɔ dwumadie 6 {ɛna deɛ wadi dwumadie pa kitikiti kitua yie ɔbɛhunu <span class="c2">(7)</span> } {ɛna deɛ wadi dwumadie bone kitikiti kitua yie ɔbɛhunu <span class="c2">(8)</span> } <span class="c5">[ Suuratul Zalzala: 1- 8 ]</span>.<br /> Ɛnkyerɛkyerɛ \'\'Tafseer\'\'.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099001.mp3"></audio> 1 - Nasɛ asaase ɛwosɔ nawosoɔ mo dendeede mo deɛ ɔbɛkasa hɔ atamoada.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099002.mp3"></audio> 2- ɛna asaase ɛbɛye deɛ wɔ neyam ɛfiri ɛwuo ɛne deɛ ɛkikahɔ ɛwom.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099003.mp3"></audio> 3-<span class="c6"> ɛna nipa wɔ ahɔhiahia mo ɛbɛkasɛ:</span> Deɛ bɛn adeɛ na atɔ asaase yi na ɔrekika nehɔ ɛne ɔrebo nehɔ?!<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099004.mp3"></audio> 4- ɛwɔ saa ɛda kɛsie nom asaase ɛbɛbɔ namanie ɛfa deɛ yadi wɔ nesɔ ɛfiri adepa mo ɛne mosoɔ mo.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099005.mp3"></audio> 5- ɛfisɛ nokorɛ Onyame na akyirɛ nɔ ɛna wahyɛ nɔ ɛfa saa sɔ.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099006.mp3"></audio> 6- ɛwɔ saa ɛda kɛsie nom deɛ asaase ɛbɛwosɔ awosoɔ mo ɛwom ɛbɛye nipa nom apeɛ ɛfiri akwɔntabuo sɔyɛbrɛ gyinaho sonsonie ɛfa adansidie wɔnom dwumadie deɛ wɔnom ɛyɛɛyɛ wɔ wiase mo.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099007.mp3"></audio> 7- Na deɛ wadi dwumadie ɛnsɛsoɔ ɛtisɛ ntɛtie kitua ɛfiri nedwumadie pa mo ɔbɛhunu nɔ nanim wɔ nsɛnie sɔ.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099008.mp3"></audio> 8- ɛna deɛ wadi nsɛnie dwumadie ɛfiri dwumadie mosoɔ bone ɔbɛhunu wɔ saa sɔ. </p>',
      ],
      2 => [
        'question' => 'Asɛmbosa 3: Kenkan Suura Aadiyaati na kyerɛaseɛ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/7270.mp3',
        'answer' => '<p> Anuye- Suura An-Aadiyaati ɛne ne kyerɛaseɛ.<br /> Me hyɛ ase wɔ Onyame din mu ahomɔborɔ hene ɔdɛɛfoɔ hene.<br /> <span class="c2">(Onyankop]n de ap]nk] a w]rek] sa)</span>na w]retu mmirika home teheetehyee no, {ne wne wen tete a <span class="c2">(etia obo] so a,)</span> na ate gye.2 Na wokoto hy[<span class="c2">( atamfo] no)</span> so anepa tutuutu, 3 Na oma mfuturotu ko wiem, 4 Na wo’bewurw<span class="c2">( atamfoo no)</span> dom no mu no die nse s<span class="c5">[: 5 Na eye nokore nso se onipa dansani ye oni berefo wo sikap[ ho paa. 6 na eye nokware se wo ye adanse nee ewu saa 7 Na eye Nkore nso se onipa dansani ye oni berefo wo sikap[ ho paa. 8 Anaa onipa danasani nnim s[, s[ ade[ a [w]</span> adakamena mu no firi adi 9 Na ade<span class="c5">[ a [w]</span><span class="c2">( onipa)</span> akoma mu nso da adi a, 10 Saa Da no<span class="c2">( onipa behunu s[, s[[ na)</span> Onyankop]n ani tua w]n 11 <span class="c5">[ Suuratul Aadiyaati: 1 - 11]</span>.<span class="c6"><br /> Tafseer \'\'Ɛnkyerɛkyerɛ\'\':</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100001.mp3"></audio> 1- Onyame ɛdensi ɛfa ponkwɔ deɛ ɔdwane ɛkwɔpim sɛ ɔteɛ ɛfa nehɔ ɛnnee dɛdɛ ɛfiri namirakatuo nantie den nti.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100002.mp3"></audio> 2- ɛna medinse ɛfa pɔnkwɔ deɛ ɔsɔgya ɛfa ninaetifi ɛgya nasɛ ɔfaboɔ sɔ ɛtiaso ɛfa ɛnam ɛden tia ɛwɔ wɔ.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100003.mp3"></audio> 3- ɛna ɔdensi ɛfa pɔnkwɔ deɛ yɛyɛ nɔ ahɔboa wɔ atanfɔ sɔ wɔ ahɔmakyi ɛmmerɛ.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100004.mp3"></audio> 4- Na nedwaeyɛ anamotuo ne nfɔtrɔ ɛna ɛnam.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100005.mp3"></audio> 5- Na ɛtitimo ɛkyɛ pɔnkwɔ dodoɔ nkabom sɔ ɛfiri ɛgyina atanfɔfoɔ nɔ sɔ nfinfin.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100006.mp3"></audio> 6- Onyame sro ɛma ngyinasoɔ wɔ nenpenie wɔ nakoa sɔ.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100007.mp3"></audio> 7- Wiase adansidie wɔ banii Adam nba dwumadie mo.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100008.mp3"></audio> 8- ɛna nokware ɔnɔ nkoaa ɛpɛ ɛdɔ agyapadie ɛna ɔyɛ ɛfa hɔ atirimoden pɛpɛɛ.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100009.mp3"></audio> 9- Sɛnti ɔnim saa nipa ɔpɛ ɛfa wiase nkwa anigyie nasɛ Onyame ɛyani deɛ ɛwɔ adamina mo ɛfiri awufoɔ ɛna ɔye wɔnom ɛfiri asaase mo ɛfa akwɔntabuo ɛne akɛtua sɛ nokorɛ nhyihyɛyɛ ɛnyɛ saa nɛtie sɛdeɛ na ɔmɔ ɛsusu hɔ?!<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100010.mp3"></audio> 10- ɔnim ɛna ɔbɛdanide ɛfa deɛ ɛwɔ akoma mo ɛfiri nkankyirɛ ɛne atwirehɔ ɛne deɛ ɛkikahɔ.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100011.mp3"></audio> 11- Nokorɛ wɔnom Awurade ɛfa ɔmɔ hɔ wɔ saa ɛda nɔ nokorɛ amanibɔ, ɛnyɛ adeɛ biribi be ɛfiri menkoa dwumadie mo ɛwinta me koraa, ɛna ɔbɛtua wɔnom ka wɔ saa sɔ. </p>',
      ],
      3 => [
        'question' => 'Asɛmbosa 4:Kenkan Suura Al- Qaari\'a na kyerɛaseɛ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/7450.mp3',
        'answer' => '<p> Anuye:Suura Al-<span class="c6"> Qaari\'a na kyerɛaseɛ:</span><br /> Me hyɛ ase wɔ Onyame din mu ahomɔborɔ hene ɔdɛɛfoɔ hene.<br /> Dede ne Gyegeegye<span class="c2">(Da)</span> no! 1 {de[n ne Dede ne Gyegyeegye <span class="c2">(Da)</span> no? 2 {de[n na [b[kyer[ wo s[de[ Dede ne gyegyegye da no site[? 3 <span class="c2">(eye)</span> Da a O nipa beye seakobonso a, w’abe asnte<span class="c5">[, 4 Na mmep]</span> nso b<span class="c5">[y[ s[ oboa nwii a [rehu kor]</span>. 5 Na <span class="c2">( saa da no )</span> obi a y[besusu<span class="c2">( ne papa a ]y]e[ na)</span> emu bey[ duro no, 6 <span class="c2">(Saa nipa)</span> no benya asetena pa,7 Na ona ye be susu na adwumadie na ebe ye mere nu 8 <span class="c2">(Saa nipa)</span> no ‘Haawiya’ na [b[y[ oni.9 Na [de[n na [b[kyer[ wo sede[ ‘ Haawiya’ no site[? 10 <span class="c2">({ny<span class="c5">[ Onyankop]</span>n abu fuhye[)</span> gya a yas] a, ano y<span class="c5">[ hy[ papaapa! 11 [ Suuratul Qaaria: 1 - 11]</span>.<span class="c6"><br /> Tafseer \'\'Ɛnkyerɛkyerɛ\'\':</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101001.mp3"></audio> 1- Deɛbɛn nɛyɛ saa ɛmmerɛ atamoada yi deɛ nipa akoma ɛbɛbom kwɔkwɔɔkwɔ ɛfa nekɛsie atwaahyia ɛda nɔ?! ɛmmerɛ atamoada deɛ ɛbɛbom nipa akoma kwɔkwɔɔkwɔ ɛfa nekɛsie atwaahyia ɛda no.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101002.mp3"></audio> 2- Deɛbɛn nɛyɛ saa ɛmmerɛ atamoada yi deɛ nipa akoma ɛbɛbom kwɔkwɔɔkwɔ ɛfa nekɛsie atwaahyia ɛda nɔ?!<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101003.mp3"></audio> 3- ɛna ɛnyɛ adeɛ yakyirɛ wo - ɛyɛ wo somafoɔ - ɛmmerɛ bɛnnie deɛ ɛbɛbom nipa akoma kwɔkwɔɔkwɔ ɛfa nekɛsie atwaahyia ɛda no?! Nokorɛ ɛyɛ atamoada.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101004.mp3"></audio> 4-ɛdaa nipa akoma ɛbɛbɛbomk wɔkwɔɔkwɔ ɛtisɛ afrafratom a ye apit wɔnomi neha bɛɛbiara.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101005.mp3"></audio> 5- ɛna pipɔ ɛbɛyɛ ɛtisɛ ɔdwae ɛnwii ɛwɔ nenwoma mo nayahu ɛnenam ho.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101006.mp3"></audio> 6- Na ɛmom deɛ yɛ bɛ susu nedwumadie pa wɔ nedwumadie bone sɔ.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101007.mp3"></audio> 7- Na ɔwɔ wɔ ahɔtɔ asitina npenie mo yɛ bɛ mani nɔ wɔ algyannah mo.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101008.mp3"></audio> 8- ɛna ɛmom deɛ yɛ susu nedwumadie bone wɔ nedwumadie pa sɔ.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101009.mp3"></audio> 9- Na yɛ de nɔ ɛbɛtina ɛna yɛ bɛtimtim nɔ sɔ atamoada ɛnɔ nɛyɛ gyahannama ɛgyam.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101010.mp3"></audio> 10- ɛna ɛnyɛ adeɛ yakyirɛ wo - ɛyɛ wo somafoɔ - Deɛ bɛn nie?!<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101011.mp3"></audio> 11- ɛnɔ nɛyɛ amanihunu ɛgya dendeede hyehyeehye. </p>',
      ],
      4 => [
        'question' => 'Asɛmbosa 5: Kenkae suuratul Takaathur ɛne nasekyerɛ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/7610.mp3',
        'answer' => '<p> Suura Takaathur ɛne ne nkyerɛaseɛ.<br /> Me hyɛ ase wɔ Onyame din mu ahomɔborɔ hene ɔdɛɛfoɔ hene.<br /> <span class="c2">(Wiase ahoyade[)</span> do do] apere- apere[ asi mo aso, 1 <span class="c2">(Mode no saa ara)</span> kosi s<span class="c5">[ mob[k]</span> adakamena mu 2 Sedee etee biara mo mohunu! 3 Bio, Sede eteebiara mo mohunu! 4 Daabi, s<span class="c5">[ anka monim no w]</span> nimde[ pefee mu a, 5 Anka nokor[ s[ mobehunu Amaniehunu gya no<span class="c2">( w] wiase)</span> 6 Ansa na moahunu no anikann <span class="c2">(w] Atemmuada)</span> 7 Afei saa Da no y<span class="c5">[bebisa mo fa anigyede[ no ho as[m.<span class="c6"> 8 [ Suuratul Takaathur:</span> 1 - 8 ]</span>.<br /> Ɛnkyerɛkyerɛ<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102001.mp3"></audio> 1- Adaagyie anibre - ɛyɛ moɔ nipa nom – ahoahoa mɔhɔ ɛfa agyapadie ɛne mma nom ɛwɔ Onyame asuteɛ ɛdisɔ.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102002.mp3"></audio> 2- ɛkwɔpim sɛ ɔmɔ ɛbɛwu ɛna yɛ de wɔnom ɛbɛwura ɔmɔ adakamina mo.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102003.mp3"></audio> 3- Na deɛ bɛn adeɛ na ama moɔ maniabre ahoahoa hɔ nne adaagyie ɛfa wɔ Onyame asuteɛ asɛm ɛdisɔ, Na ɛnkyɛ mɔ bɛhunu asutwie saa adaagyie nɔ sɔ.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102004.mp3"></audio> 4- ɛnɔakyi ɛnkyɛ mɔ bɛhunu nasutwie.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102005.mp3"></audio> 5- Nokorɛ sanka nokware wɔnom ɛnim nokorɛ mo gyidie noko rɛ ɔmɔ yɛ bɛyani wɔnom akwɔ Onyame ho, ɛna nokorɛ ɔnɔ ɔbɛtua wɔnom ka wɔ ɔmɔ dwumadie sɔ; ɛfa deɛ ama ɔmɔ adaagyie ɛfa ahoahoa ɛfa agyapadie ɛne mma nom.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102006.mp3"></audio> 6- ɛna Onyame ɛbɛ wɔnom adi ɛgya hɔ adansie atamoada.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102007.mp3"></audio> 7- ɛnɔakyi sɛdeɛ ɛtie biara ɛbɛma ɔmɔ adi ɛgya adansie ɛhunu gyidie nokware mo naa biara ɛnnim.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102008.mp3"></audio> 8- ɛnɔakyi sɛdeɛ ɛtie biara Onyame ɛbɛ bosa wɔnom wɔ saa ɛda nɔ wɔ deɛ yɛ adom a wayɛ ama wɔnom wɔhɔ ɛfiri apɔtie ɛne ahɔya agyapadie ɛne deɛ ɛkikahɔ. </p>',
      ],
      5 => [
        'question' => 'Asɛmbosa 6:Kenkan Suura An-Asr na kyerɛaseɛ.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/7750.mp3',
        'answer' => '<p> Anuye- Suura An-Asr ɛne ne kyerɛaseɛ.<br /> Me hyɛ ase wɔ Onyame din mu ahomɔborɔ hene ɔdɛɛfoɔ hene.<br /> Onyankopɔn ahoteɛnii de ɛmmerɛ adi nsedie. Ɛsipi sɛ Onipa biara wɔ berɛguo mu. Gye Obi a wagye Nyame adi na wayɛ dwumadi pa, ɛka wei ho, na wɔn abɔ dawubɔ afrɛ akɔ nokware kwan so, na wɔn asi ho abotare, na saa nkrɔfoɔ yi wɔnnom na yɛ ɛnkunimdifoɔ firi berɛguo mu. Suura Al-<span class="c6">Asr:</span>1-3<br /> Ɛnkyerɛkyerɛ<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/103001.mp3"></audio> 1-Onyankopɔn ahoteɛnii de ɛmmerɛ adi nsedie.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/103002.mp3"></audio> 2-<span class="c6">Ɛsipi sɛ Onipa biara wɔ berɛguo mu) kyerɛ sɛ :</span> Onipa biara wɔ sintɔ ne ɔsaeɛ mu.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/103003.mp3"></audio> 3-Gye Obi a wagye Nyame adi na wayɛ dwumadi pa, ɛka wei ho, na wɔn abɔ dawubɔ afrɛ akɔ nokware kwan so, na wɔn asi ho abotare, na saa nkrɔfoɔ yi wɔnnom na yɛ ɛnkunimdifoɔ firi berɛguo mu.Kenkan Suura Al-Humaza na kyerɛaseɛ. </p>',
      ],
      6 => [
        'question' => 'Asembisa 7:Kenkan Suura Al-Humaza na kyerɛaseɛ.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/7830.mp3',
        'answer' => '<p> Anuye:Suura Al-Humaza ɛne ne nkyerɛaseɛ.<br /> Me hyɛ ase wɔ Onyame din mu ahomɔborɔ hene ɔdɛɛfoɔ hene.<br /> Nsɔpa ne mpɔnsee a ɛmu yɛ den wɔ wɔn a watwitwa amanfoɔ nantini, na waka wɔn anim gu wɔn anim ase.1 Onipa a wabua sika ano na wasese ne dodoɔ.2 ɔdwene sɛ nokorɛ nagyapadie nɔ deɛ waboaboa ano no ɛbɛtwitwa agye no ɛfiri ɛwuo ho.3 Daabi da, ɛsipi sɛ deɛ ɛteɛ biara yɛde no bɛto <span class="c2">(Al-Hutamati)</span> mu.4 Na ɛdeɛn na bɛkyerɛ wo ade a ɛyɛ <span class="c2">(Al-Hutamatu)</span> no. 5 Ɛyɛ Onyame Allah ogya dareɛ a wasɔ ano. 6 A ɛhye nnipa honam kɔ ka wɔn akoma. 7 Na ɛwɔ wɔn a yɛretwe wɔn aso wɔ mu no so a yato mu. 8 Yɛde odum a ɛtrɛ na ɛwa sɛ neɛ bɛyɛ a wɔntumi mpue mfiri mu.9 Suura Al-Humaza 1-9.<br /> Ɛnkyerɛkyerɛ<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104001.mp3"></audio> 1-Nsɔpa ne mpɔnsee a ɛmu yɛ den wɔ wɔn a watwitwa amanfoɔ nantini, na waka wɔn anim gu wɔn anim ase.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104002.mp3"></audio> 2-Deɛ ne botae nyina ne sɛ ɔbɛboa sika ano na wasese, Ɔnni botae biara wɔ wei akyi.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104003.mp3"></audio> 3-ɔdwene sɛ nokorɛ nagyapadie nɔ deɛ waboaboa ano no ɛbɛtwitwa agye no ɛfiri ɛwuo ho, Na waka daanidaa ɛwɔ wiase asitina nkwa mo.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104004.mp3"></audio> 4-ɛnyɛ saa na nhyihyɛyɛ no ɛteɛ sɛdeɛ saa fratamnii yi susu, Na nokware yɛ bɛtɔno ato ogya gyahannama deɛ ɛbom ɛna ɛbubu adeɛ biara a yɛ bɛtɔ atɔ ɛwom ɛnam sɛdeɛ ɛɛden ɛfa mosoɔ hao nti.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104005.mp3"></audio> 5-Na ɛdeɛn na bɛkyerɛ wo Ɔsomafoɔ eii - ade a ɛyɛ saa ogya yi ɛrebubu biribiara a yɛto ɛtomu.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104006.mp3"></audio> 6-Ɛsipi sɛ ɛyɛ Onyame Allah ogya dareɛ a wasɔ ano.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104007.mp3"></audio> 7-A ɛhye nnipa honam kɔ ka wɔn akoma.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104008.mp3"></audio> 8-Na ɛwɔ wɔn a yɛretwe wɔn aso wɔ mu no so a yato mu.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104009.mp3"></audio> 9-Yɛde odum a ɛtrɛ na ɛwa sɛ neɛ bɛyɛ a wɔntumi mpue mfiri mu </p>',
      ],
      7 => [
        'question' => 'Asembisa 8:Kenkan Suura Al-Fiil na kyerɛaseɛ.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/7970.mp3',
        'answer' => '<p> Suura Al- Fiil ɛne ne nkyerɛaseɛ.<br /> Me hyɛ ase wɔ Onyame din mu ahomɔborɔ hene ɔdɛɛfoɔ hene.<br /> Ɛnti w\'anhunu sɛdeɛ wo wura de yɛɛ Asonofoɔ no 1. Ɛnti wamma wɔn pɔbɔnee no anyɛ kwa 2. Na Ɔsomaa nnoma <span class="c2">(Ababil)</span> ɛbaa wɔn so 3. Na wɔ retotoo aboɔ a ɛfiri ogya mu sii wɔn 4. Ɛna Ɔyɛɛ wɔn tesɛ serɛ a mmoa akɔ so adidie 5. Suura Al-Fiil;1-5<br /> Ɛnkyerɛkyerɛ<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105001.mp3"></audio> 1-Ɛnti W\'anhunu Ɔsomafoɔ ei! Sɛdeɛ wo wura de yɛɛ <span class="c2">(Abraha)</span> ɛne ne yɔnkofoɔ Asonofoɔ bere wɔn ɛpɛɛ sɛ wɔ bubu Ka\'ba ɛdwiri no.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105002.mp3"></audio> 2-Nokware Onyame Allah ama wɔn pɔbɔnee a wɔn abɔ no ayɛ kwa, na wɔn annya wɔn apɛdeɛ ɛne sɛ wɔn bɛdane Nipa afiri Ka\'ba ho, Na wɔn annya biribiara wɔ wɔn pɔbɔnee no mu.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105003.mp3"></audio> 3-Na Onyame somaa nnoma akuokuo baa wɔn so.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105004.mp3"></audio> 4-Wɔ bɛ toto aboɔ ɛfiri dɔteɛ mu a y\'ayɛ no denedene.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105005.mp3"></audio> 5-Ɛna Onyame ayɛ wɔn tesɛ wura a mmoa adidi so ateatea so. </p>',
      ],
      8 => [
        'question' => 'Asembisa:9 Kenkan Suura Quraish na kyerɛaseɛ.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/8070.mp3',
        'answer' => '<p> Amuaye: Suura Quraish ɛne ne nkyerɛaseɛ.<br /> Me hyɛ ase wɔ Onyame din mu ahomɔborɔ hene ɔdɛɛfoɔ hene.<br /> Ɛnam Quraish abusua no ahoban bɔ nti.1 Wɔn ahoban bɔ a ɛwɔ awɔberɛ ne ahuhuroberɛ akwantuo no mu nti. 2 Na wɔnom ɛnsom saa ɛfie haraam yi Awurade.3 Ɔno a ɔmaa wɔn aduane wɔ ɔkɔm bere mu, na ɔmaa wɔn asomdwoeɛ wɔ ɔhuu bere mu.4 Suura Quraish 1-4<br /> Ɛnkyerɛkyerɛ<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106001.mp3"></audio> 1-Neɛ woi ɛrekyerɛ ne awɔbere ne ahohurubere akwantuo a na wɔnim no wɔ wɔn ho dada.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106002.mp3"></audio> 2-Awɔbere akwantuo de kɔ Yamen ne ahohurubere akwantuo de kɔ Sham wɔ asomdwoeɛ mu.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106003.mp3"></audio> 3-Na wɔnom ɛnsom Onyame saa ɛfie haraam yi Awurade, ɔnɔ krɔ pɛ nkoaa, Deɛ ɛyɛmmerɛ ɛma ɔmɔ ɛfa saa akwantuo yi, ɛna ɛnyɛ adeɛ wɔnom ɛbɛsom abosom nom aka nehɔ koraa.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106004.mp3"></audio> 4-Ɔno a ɔmaa wɔn aduane wɔ ɔkɔm bere mu, na ɔmaa wɔn asomdwoeɛ wɔ ɔhuu bere mu, ɛyɛ adeɛ a ɔde ahyɛ Arabofoɔ akuma mu; ɛyɛ nkrɔmueɛ a ɔde akrɔm Masjidul Haram ne ɛmu temammufoɔ no. </p>',
      ],
      9 => [
        'question' => 'Asembisa 10:Kenkan Suura Al-M`aun na kyerɛaseɛ.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/8160.mp3',
        'answer' => '<p> Suura Al-M`aun ɛne ne kyerɛaseɛ.<br /> Me hyɛ ase wɔ Onyame din mu ahomɔborɔ hene ɔdɛɛfoɔ hene.<br /> Enti wahunu deɛ a wɔtwa akatuada atemmuada no so kontompo no 1. Saa <span class="c2">(nipa no)</span> bi ne obi a, ͻpamo agyanka 2 Na ͻnnhyε <span class="c2">(amanfoͻ)</span> sε wͻ’didi a wͻ’ma ahiafoͻ no nso bi.3 Na ɔsɛeɛ ne mpɔnsee wɔ Onyamefrɛfoɔ 4 Wɔn a ɔde wɔn nyamefrɛ di agorɔ 5 Wɔnnom nayɛ yɛkyerɛ 6 Na wɔn na si mmoa ho kwan 7 Suura Al- M`aun 1-7<br /> Ɛnkyerɛkyerɛ<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107001.mp3"></audio> 1-Enti wahunu deɛ a wɔtwa akatua a yɛbɛtua no atemmuada no so kontompo no?!<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107002.mp3"></audio> 2-Ɔno na ɔde fasuo si agyanka ne wɔn ahiadeɛ ntam no.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107003.mp3"></audio> 3-Ɔnkanyan no ho na ɔnkanyan afoforɔ sɛ wɔbɛdidi ama ahiafoɔ bi adi.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107004.mp3"></audio> 4-Na ɔsɛeɛ ne mpɔnsee wɔ Onyamefrɛfoɔ a;<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107005.mp3"></audio> 5-Wɔn a ɔde wɔn nyamefrɛ di agorɔ no, wɔmfa nyamefrɛ no ho agye sɛ ne mmerɛ atwam na wayɛ.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107006.mp3"></audio> 6-Wɔn a wɔyɛ yɛkyerɛ wɔ wɔn nyamefrɛ ne wɔn nyamennwuma mu no, wɔnom nte wɔn nnwuma ho Onyankopɔn <span class="c2">(Allah)</span> nti.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107007.mp3"></audio> 7-Na wɔn si amanfoɔ ho kwan sɛ wɔbɛboa afoforɔ aberɛ wɔn mmoa no mfa ɔhaw biara mmerɛ wɔn. </p>',
      ],
      10 => [
        'question' => 'Asembisa:11 Kenkan Suura Al-Humaza na kyerɛaseɛ.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/8280.mp3',
        'answer' => '<p> Amuaye:Suura Al- Kawsar ɛne ne kyerɛaseɛ.<br /> Me hyɛ ase wɔ Onyame din mu ahomɔborɔ hene ɔdɛɛfoɔ hene.<br /> Ɛsipi sɛ y\'ama wo nsuo a ɛyɛ <span class="c2">(Al-Kawsar)</span>1. Ɛnti som wo wura Nyankopɔn <span class="c2">(yɛ asɔre)</span> na bɔ afɔreɛ ma no.2 Esipi sɛ wotamfo no a ɔresere wo sɛ w\'abusua to atwa no ɔno mmom na no to atwa paa ara. 3 Suura Al-<span class="c6"> Kawsar:</span>1-3<br /> Ɛnkyerɛkyerɛ<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/108001.mp3"></audio> 1-O ɔsomafoɔ ei! esipi sɛ yayɛ wo papa pii, na emu bi ne <span class="c2">(Kauthar)</span> asubɔnten a ɛda ɔsoro aheman mu no.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/108002.mp3"></audio> 2-Ɛnti da Onyankopɔn <span class="c2">(Allah)</span> ase ɛnam saa adomakyɛdeɛ yi nti, wɔ bere a woreyɛ asɔre na worebɔ afɔreɛ de ama ɔno nko ara, ɛmɔ abira mfiri neɛ abosomsomfoɔ ɛyɛ no ho, ɛyɛ wɔn afɔrebɔ wɔbɔ sɛ wɔdebɛpinkyɛn wɔn abosom no ho no.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/108003.mp3"></audio> 3-Ɛsipi sɛ; w\'atamfo no ne neɛ a yɛasi no kwan ama ne werɛ afi papayɔ biara ho kwan a sɛ yɛbɔ ne din a yɛde bɔne na ɛkae no. </p>',
      ],
      11 => [
        'question' => 'Asembisa:12 Kenkan Suura Al-Kaafiruun na kyerɛaseɛ.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/8360.mp3',
        'answer' => '<p> Amuaye:Suura Al-Kaafiruun ɛne ne kyerɛaseɛ.<br /> Me hyɛ ase wɔ Onyame din mu ahomɔborɔ hene ɔdɛɛfoɔ hene.<br /> O ɔsomafoɔ ei! kasɛ!O! mo a moayi mo wura Onyankopɔn <span class="c2">(Allah)</span> boniayɛ e!.1 Mensom m\'obosom a mosom no.2 Na mo nso monsom neɛ mesom.3 Na me nso mensom m\'obosom a mosom no.4 Na mo nso monsom neɛ mesom.5 Mo wɔ mo som a mosom, na me nso me wɔ mesom a mesom.6 Suratul Al Kaafirun 1-6<br /> Ɛnkyerɛkyerɛ<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109001.mp3"></audio> 1-O ɔsomafoɔ ei! kasɛ!O! mo a moayi mo wura Onyankopɔn <span class="c2">(Allah)</span> boniayɛ e!<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109002.mp3"></audio> 2-Mensom m\'obosom a mosom no nnɛ na mensom wɔn daakye biara da.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109003.mp3"></audio> 3-Na mo nso monsom neɛ mesom, ɔno ne Allah baako pɛ no.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109004.mp3"></audio> 4-Na me nso mensom m\'obosom a mosom no.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109005.mp3"></audio> 5-Na mo nso monsom neɛ a mesom, ɔno ne Allah baako pɛ no.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109006.mp3"></audio> 6-Mo wɔ mo som a mo ara ankasa moafiase ama mo ho, na me nso me wɔ mesom a Onyankopɔn <span class="c2">(Allah)</span> no asane ama me. </p>',
      ],
      12 => [
        'question' => 'Asembisa;13 Kenkan Suura An-Nasri na kyerɛaseɛ.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/8470.mp3',
        'answer' => '<p> Amuaye:Suura An-Nasri ɛne ne kyerɛaseɛ.<br /> Me hyɛ ase wɔ Onyame din mu ahomɔborɔ hene ɔdɛɛfoɔ hene.<br /> Sɛ Onyankopɔn <span class="c2">(Allah)</span> mmoa no ba na sɛ Makka mmueɛ no se a.1 Na Wobɛhunu sɛ adasamma rewura <span class="c2">(Islam)</span> asomdwoeɛ som no mu akuo akuo.2 ɛno nti tomtom wo wura Onyankopɔn <span class="c2">(Allah)</span> na hwehwɛ bɔnefakyɛ firi ne hɔ, Ɔno ne nsakraeɛ hene a ɔgye ne nnɔnkɔfoɔ nsakraeɛ tom.<span class="c6">3 Suura Annasr:</span>1-3<br /> Ɛnkyerɛkyerɛ<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/110001.mp3"></audio> 1. Oh Ɔsomafoɔ ei! sɛ Onyankopɔn <span class="c2">(Allah)</span> mmoa no ba ma wo som yi na Ɔde n\'ahoɔden taa akyire a; ɛna Makka mmueɛ no siiɛ.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/110002.mp3"></audio> 2-Wobɛhunu sɛ adasamma rewura <span class="c2">(Islam)</span> asomdwoeɛ som no mu akuo akuo.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/110003.mp3"></audio> 3-Ɛba no saa hunu sɛ, ɛyɛ ahyɛnsodeɛ a ɛrekyerɛ sɛ neɛ wode ɔsomasɛm a yɛde somaa wo no rekɔ n\'awieɛ abɛn, ɛno nti tomtom wo wura Onyankopɔn <span class="c2">(Allah)</span> na da n\'ase, nnaaseɛ wɔ no ɛnam mmoa ne nkunim adomakyɛdeɛ a wayɛ, na hwehwɛ bɔnefakyɛ firi ne hɔ, ɛfiri sɛ; ɔno ne nsakraeɛ hene a ɔgye ne nnɔnkɔfoɔ a wɔsakra nsakraeɛ tom, na ɔde wɔn bɔne kyɛ wɔn. </p>',
      ],
      13 => [
        'question' => 'Asembisa;14 Kenkan Suura Al-Masad na kyerɛaseɛ.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/8550.mp3',
        'answer' => '<p> Amuaye;Suura Al- Masad ɛne ne kyerɛaseɛ.<br /> Me hyɛ ase wɔ Onyame din mu ahomɔborɔ hene ɔdɛɛfoɔ hene.<br /> Abi Lahab nsa mienu aka ne nkuguo na wadi nkuguo nso1. na ne sika ne nimba nyiara en timi mboanu da.2 Atemmuada no ɔbɛwura ogya dɛreɛ mu 3 Ɛne nehokanii <span class="c2">(yere)</span> a wɔsua ogya 4 <span class="c2">(Yɛde nwenehoma a akyimkyim na bɛsɔ ne kɔn atwe no )</span> 5 Suura Al-Masad 1-5<br /> Ɛnkyerɛkyerɛ<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111001.mp3"></audio> Ɔkɔmhyɛni Muhammad <span class="c2">(Allah nhyira ne n\'asomdwoeɛ nka no)</span> wɔfa Abi Lahab a ɔpapa ne Abdul Mutallib nsa aka ne nkuguo ɛnam nkuguo a wadi no wɔ ne nnwumadie mu, ɛmerɛ a na ɔreteetee ɔkɔmhyɛni Muhammad<span class="c2">(Allah nhyira ne n\'asomdwoeɛ nka no)</span> no, nanso ne mmɔdemma no kɔwie nkuguo mu.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111002.mp3"></audio> Biribiara a wanya ɛyɛ ne sika ne nkwadaa ntumi ntwitwa nnye no mfiri mpɔnsee no ho,na ɛntumi ntwe Onyankopɔn<span class="c2">(Allah)</span> ahummɔborɔ mma no.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111003.mp3"></audio> Atemmuada no ɔbɛwura ogya dɛreɛ mu, ɔbɛhunu amane wɔ ogya no anohyeehyeɛ ho.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111004.mp3"></audio> Na ne hokani <span class="c2">(yere)</span> Ummu Jameel a na ɔteetee ɔkomhyɛni no nso bɛwura ogya dɛreɛ no mu; ɔno a na ɔtoto nkasae gu ɔkomhyɛni akwan mu.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111005.mp3"></audio> Yɛde nwenehoma a akyimkyim na bɛsɔ ne kɔn atwe no akɔ to ogya mu. </p>',
      ],
      14 => [
        'question' => 'Asembisa:15 Kenkan Suura Al-Ikhilaas na kyerɛaseɛ.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/8650.mp3',
        'answer' => '<p> Amuaye:Suura Al- F ɛne ne kyerɛaseɛ.<br /> Me hyɛ ase wɔ Onyame din mu ahomɔborɔ hene ɔdɛɛfoɔ hene.<br /> { Kasɛ ɔnɔ Allaah ɔyɛ kropɛ <span class="c2">(1)</span> Allaah na ɔbiara ɛdaa no ɛrehwihwɛ ne mmoa <span class="c2">(2)</span> ɔnne ba ɛna yɛn woo no <span class="c2">(3)</span> Na ɔnni sɛsoɔ biara wɔ n\'abɔdeɛ mu <span class="c2">(4)</span> } <span class="c5">[Suura Al-Ikhilaas 1-4]</span><br /> Ɛnkyerɛkyerɛ<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112001.mp3"></audio> Oh ɔsomafoɔ ei! kasɛ ɔno ne Allah no a Onyame foforɔ biara nni n\'akyi no.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112002.mp3"></audio> Ne nkyɛn na abɔdeɛ nyinaa adesrɛdeɛ kɔ.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112003.mp3"></audio> Na ɔno ne ɔhoteeɛni no a ɔnni yam ba na ɔnni agya no.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112004.mp3"></audio> Na ɔnni sɛsoɔ biara wɔ n\'abɔdeɛ mu. </p>',
      ],
      15 => [
        'question' => 'Kenkan Suura Al- Falaq na kyerɛaseɛ.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/8750.mp3',
        'answer' => '<p> Suura Al- Falaq ɛne ne kyerɛaseɛ.<br /> Me hyɛ ase wɔ Onyame din mu ahomɔborɔ hene ɔdɛɛfoɔ hene.<br /> Oh ɔsomafoɔ ei! ka sɛ me rehwehwɛ ahobanbɔ firi ahemakye wura no hɔ 1. Ɛfiri ade bone biara a wabɔ. Ɛna ahobanbɔ ɛfiri ade bone a ɛwɔ anadwo ɛsum mu. Ɛna ade bone a ɛfiri mmaa wɔn bɔ pɔ toto natasuo gu so. Ɛna ade bɔne a ɛfiri ahoɔyaani ahoɔyaa ho. Suura Al-Falaq 1-5<br /> Ɛnkyerɛkyerɛ<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113001.mp3"></audio> Oh ɔsomafoɔ ei! ka sɛ mesɔ ahemakye wura no mu den na me hwehwɛ ahobanbɔ firi ne nkyɛn.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113002.mp3"></audio> Ɛfa abɔdeɛ mu ɛsane bɔne a ɛsan biara ho.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113003.mp3"></audio> Na mesɔ Allah mu den hwehwɛ ahobanbɔ firi ne nkyɛn firi bɔne biara a ɛpue anadwo ho, sɛ ɛfiri mmoadoma anaa sɛ akorɔmfoɔ ho.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113004.mp3"></audio> Na mesɔ ne mu den hwehwɛ ahobanbɔ firi ne nkyɛn firi bɔne a adaemone nkabrekyerefoɔ yɛ ho, wɔn a wɔbɔ pɔ bɔne tete ntasuo gu so ho.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113005.mp3"></audio> Ɛne ahoɔyaani a ne bo fu nnipa sɛ ɔyɛ wɔnom ho ahoɔyaa ɛfa adomakyɛdeɛ a Allah de adom wɔn ho nti a, wɔn pɛ sɛ adom no firi wɔn nsa na wɔn susu bɔne ma wɔn. </p>',
      ],
      16 => [
        'question' => 'Asembisa:17 Kenkan Suura An-Naas na kyerɛaseɛ.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/8870.mp3',
        'answer' => '<p> Amuaye;Suura An-Naas ɛne ne kyerɛaseɛ.<br /> Me hyɛ ase wɔ Onyame din mu ahomɔborɔ hene ɔdɛɛfoɔ hene.<br /> Oh ɔsomafoɔ ei! ka sɛ me rehwehwɛ ahobanbɔ firi Onipa wura no hɔ. Onipa hene hɔ. Onipa Nyame nkyɛn Ɛfa bonsam bɔne a ɔtoto asu kɔ nnipa so. Ɔtoto asu kɔ nnipa akoma mu. Ɛfiri mmoatia ne Nipa mu Suratul Nas 1-6<br /> Ɛnkyerɛkyerɛ<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114001.mp3"></audio> Oh ɔsomafoɔ ei! ka sɛ mesɔ ahemakye wura no mu den na me hwehwɛ ahobanbɔ firi ne nkyɛn.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114002.mp3"></audio> 2. Ɔma deɛ ɔpɛ biara di adaneɛ wɔ wɔn tam, wɔnom nni ɔhene biara ka no ho.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114003.mp3"></audio> 3. Wɔnom nyame a wɔsom no som pa ara, wɔnom nni obi a ɔfata som pa ara ɛka no ho.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114004.mp3"></audio> 4. Ɛfa bonsam bɔne a ɔtoto asu kɔ nnipa so.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114005.mp3"></audio> 5. Ɔtoto asu kɔ nnipa akoma mu.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114006.mp3"></audio> 6. Kyerɛ sɛ neɛ ɔtoto asu no ɔbɛtumi afiri nnipa mu na ɔbɛtumi afiri mmoatia mu. </p>',
      ],
    ],
    5 => [
      0 => [
        'question' => 'Toa Hadis yi so (Ɛsipi sɛ dwumadie nyina ara gyina nkakyeɛ so) na bobɔ ho nfasoɔ bi?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/9030.mp3',
        'answer' => '<p> Ɛfiri Agyidifoɔ hene nkyɛn ɛyɛ Hafs papa a Ɔno ne Umar khataab ba Onyame kokroko ngye no ntum Ɔkaa sɛ : M\'ate sɛ Onyame somanii Nyame nhyira ne n\'asomdwie nka no Ɔne ne fiefoɔ ɔreka sɛ : <span class="c2">(Nokware dwumadie nyina ara akatua gyina nkankyeɛ so, na Onipa biara wɔ ne nkankyeɛ ho akatua, na Obi a ne batatuo (akwantuo)</span> ɛrekɔ Onyame ne ne Kɔmhyɛni nkyɛn no, ne batatuo no Onyame ne ne Kɔmhyɛni nti, Na Obi nso a ne batatuo yɛ wiase apɛdeɛ nti anaa ɔbaa bi awareɛ nti no, ne batatuo no gyina ne botaɛ so). ɛfiri Buhaari ɛne Muslim mo.<span class="c6"><br /> Mfasode firi Hadis yi mu:</span><br /> Dwumadie biara ɛsɛ sɛ nkankyeɛ bata ho, ɛfiri asɔre <span class="c2">(Salla)</span>, ɛne Akɔmkyene, ɛne Hagyi ɛne dwumadipa a aka.<br /> Nkankyeɛ biara nso ɛsɛ sɛ ɛyɛ Onyame kokroko nko nti.<br /> Hadis 2 </p>',
      ],
      1 => [
        'question' => 'Toa Hadis yi so (Obi a wayɛ ade foforɔ wɔ yɛ som yi mu) na bobɔ ho nfasoɔ bi.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/9090.mp3',
        'answer' => '<p> Yɛ nyaa saa nsɛm yi firi Agyidifoɔ maame Abdullah maame Aishata Onyame ngye no ntum Ɔkaa sɛ: Onyame Somanii Nyame nhyira ne n\'asomdwie nka no aka sɛ: <span class="c2">(Neɛ ɔbɛyɛ biribi wɔ yɛn dwumadie yi mu (Islam som)</span> aberɛ a ɛnka ho no, yɛbɛpo saa adeɛ no. ɛfiri Buhaari ɛne Muslim mo.<span class="c6"><br /> Mfasode firi Hadis yi mu:</span><br /> - Bra a yabra sɛ wode biribi foforɔ bɛba som no mu.<br /> 2. Ɛna yɛpo nsakratomu nnwumadie na yɛnnye nto mu.<span class="c6"><br /> * Ɔkomhyɛni ano asɛm ɛtɔ so mmiɛnsa:</span> </p>',
      ],
      2 => [
        'question' => 'S3. Toa saa asɛm yi so "mmerɛ bi a na yɛte Allah somani ( Allah nhyira ne n\'asomdwoeɛ nka no ) anim", na bobɔ mfasoɔ no bi?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/9160.mp3',
        'answer' => '<p> Yɛ nyaa saa nsɛm yi firi Umar a ɔyɛ Khataab ba nkyɛn Onyame ngye no ntum Ɔkaa sɛ: berɛ a yɛ te Onyame Somanii Nyame nhyira ne n\'asomdwie nka no ɛda bi, prɛko pɛ Ɔbarima bi pue yɛn so a, N\'ataade yɛ fitafita, Ne tirinwii yɛ tuum, Na yɛ nhu akwantuo ahyɛnsodeɛ biara wɔ ne ho, Saa ara nso na yɛ mu biara nnim no, Kɔpim sɛ Ɔtenaa Ɔkɔmhyɛni Nyame nhyira ne n\'asomdwie nka no nkyɛn, Na Ɔde ne kotodwe mienu tweree Ɔkɔmhyɛni kotodwe mienu, Na Ɔde ne nsa mienu too ne serɛ so,<span class="c6"> Na Ɔkaa sɛ:</span> <span class="c3">«Oh Mohammed bɔ me amaneɛ fa Nkramosom ho »</span>,<span class="c6"> Na Ɔkɔmhyɛni ka kyerɛ no sɛ:</span> «Nkramosom ne sɛ wo bɛ di adanseɛ sɛ Onyame biara nni hɔ a ɔfata ɛsom wɔ nokware mu gye Allah nko, na Mohammed yɛ Nyame Somanii, Na w\'ayɛ asɔre <span class="c2">(Salla)</span> wɔ ne berɛ mu, Na w\'ayi Zaka, Na w\'akyere Ramadan akɔmkyene, Na w\'ayɛ Haj dwumadie <span class="c2">(Onyame fie nserahwɛ)</span> sɛ wo nya so tumi a », Ɔkaa sɛ <span class="c3">«w`aka nokware »</span>, Na ɛyɛɛ yɛ nwanwa yie Ɔbusa no, na ɔsan si ne nsɛm so dua,<span class="c6"> Ɔkaa sɛ :</span> Bɔ me amaneɛ ɛfa gyidie ho » Ɔkaa sɛ <span class="c3">«Gyidie yɛ sɛ wo bɛ gye Nyankopɔn adi, ɛne N\'abɔfoɔ, ɛna Ne nwoma ahoroɔ, ɛna N\'aKɔmhyɛfoɔ, ɛna Atɛmmuada, Na afae gye hyɛberɛ mu papa ne bɔne di »</span> Ɔkaa sɛ: <span class="c3">«wa ka nokware »</span> Ɔkaa sɛ : <span class="c3">«Bɔ me amaneɛ ɛfa papayɛ ho »</span> Ɔkaa sɛ: <span class="c3">«ɛne sɛ wo bɛ som Nyame te sɛ wo hunu No, na sɛ wo nhunu No a ɛsipi sɛ Ɔhu wo »</span> Ɔkaa sɛ: <span class="c3">«Bɔ me amaneɛ ɛfa Ɛmmerɛ no ho »</span> Ɔkaa sɛ: <span class="c3">«Nea yɛ busa no, no nni ho nimdie nsene Ɔbusafoɔ no»</span> Ɔkaa sɛ: <span class="c3">«Bɔ me amaneɛ fa ɛho ahyɛnsodeɛ ho »</span>Ɔkaa sɛ: <span class="c3">«Sɛ afinaa bɛ wo ne wura, na wo bɛ hunu wɔn a ɛnni mpaboa hyɛ, wɔn nni ntaare, wɔn nni deɛ ɔbɛdie, sɛ wɔn ayɛ asikafo ɛsisi fie akɛseɛ fɛfɛɛfɛ na wɔn redi akansie wɔ ho»</span> Ɔkaa sɛ: Afae Ɔkɔɔyɛ na me twen nna kakra bi,<span class="c6"> Afae Ɔkɔmhyɛni kaa sɛ:</span> <span class="c3">«Oh Umar Ɛnti wo nim asɛmbusafoɔ no? »</span> Me kaa sɛ : "Onyame ɛne ne Somanii na Ɛnim",<span class="c6"> Ɔkaa sɛ:</span> <span class="c3">«Na ɛsipi sɛ Ɔyɛ Ɔbɔfoɔ gyebra, Ɔbaa mo hɔ bɛ kyerɛ mo mosom»</span>. Ɛfiri Muslim Nhoma mu.<span class="c6"><br /> Mfasode bi firi Hadis yi mu:</span><br /> Ɔbobɔɔ Nkramosom fapem nnum no ;na ɛyɛ:<br /> Adansedie sɛ nokware Nyame biara nni hɔ a ɔfata ɛsom gye Allah Onyame kro pɛ, ɛna nokware Mohammed ɛyɛ Onyame Somafoɔ.<br /> Ɛna salla <span class="c2">(asɔre)</span> ngyinaɛ wɔ ne mmerɛ mu<br /> Ɛna Zakayie <span class="c2">(Ɛntotosoɔ dudu)</span>.<br /> Ɛna Ramadan akɔmkyene<br /> Ɛna Haji dwumadie <span class="c2">(Onyame fie a bone yɛ akyiwade wɔmu)</span>.<br /> Wabubɔ gyidie fapim,<span class="c6"> na ɛyɛ nsia:</span><br /> Gyedie fa Onyankopɔn ho.<br /> Ɛne Ne Abɔfoɔ.<br /> Ɛne Ne Nhoma<br /> Ɛne Ne Akɔmhyɛfoɔ<br /> Ɛne Awieɛda <span class="c2">(Atɛmmuada)</span><br /> Ɛne hyɛberɛ ɛmu papa ne bɔne.<br /> Waka papa fapim nso, na ɛyɛ fapim kro pɛ, na ɛno ne sɛ wo bɛ som Nyame <span class="c2">(Allah)</span> tesɛ deɛ wo hunu No, na sɛ nokware wo nhunu No a ɛsipi sɛ Ɔhu wo.<br /> Ɛmmere sɔreɛ bere no <span class="c2">(Atɛmmuada)</span> Obibiara nnim gye Allah kokroko.<span class="c6"><br /> Hadis a ɛtɔso ɛnan:</span> </p>',
      ],
      3 => [
        'question' => 'Toa Hadis yi so «Agyidifoɔ mu neɛ ne gyidie ahyɛma », Na bobɔ nfasoɔ bi wɔ ho.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/9360.mp3',
        'answer' => '<p> Ɛfiri Abii Saeed papa nkyɛn Nyame ngye no ntum,<span class="c6"> Onyame Somanii Nyame nhyira ne n\'asomdwie nka no aka sɛ:</span> Anoyie: <span class="c3">«Agyidifoɔ mu neɛ ne gyidie ahyɛma yɛ wɔn mu neɛ suban pa nii »</span> Ɛwɔ Tirmizi Nhoma mu na Ɔkaa sɛ : Hadis yi yɛ papa ne nokware.<span class="c6"><br /> Mfasode firi Hadis yi mu:</span><br /> Nkramosom rehyɛ Nipa Suban pa.<br /> Na nokware abɔdeɛ hyɛma ɛfiri gyedie hyɛma mu.<br /> Na nokware gyedie tumi dɔɔso na ɛsote nso.<br /> Hadis a ɛtɔso nnum </p>',
      ],
      4 => [
        'question' => 'Toa Hadis yi so: «Obibiara a Ɔde biribi di nsidie a ɛnyɛ Nyame »na bobɔ ho nfasoɔ bi.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/9440.mp3',
        'answer' => '<p> Ɛfiri Umar ba nkyɛn Onyame ngye wɔn tum,<span class="c6"> sɛ Ɔkɔmhyɛni Nyame nhyira ne n\'asomdwie nka no aka sɛ:</span> «Obibiara a Ɔde biribi adi nsedie a ɛnyɛ Onyame <span class="c2">(Allah)</span>, Nokware wayɛ Nyame bɔniayɛ anaa sɛ mmataho <span class="c2">(hyirk)</span>» Tirmizee na de bae<br /> Mfasode firi Hadis yi mu:<br /> Ɛnfata na ɛnni sɛ yɛde biribiara di nsidie gye Onyankopɔn kokroko no nko.<br /> Nsidie a ɛnyɛ Nyame din nnim na ɛyɛ biribi din no, ɛka mmataho ketewa ho <span class="c2">(Abosomsɛm kuma)</span>.<span class="c6"><br /> Hadis a ɛtɔso ɛnsia :</span> </p>',
      ],
      5 => [
        'question' => 'Toa Hadis yi so: «Mo mu baako biara nni hɔ a ne gyidie ɛbɛhyɛma kɔpim sɛ mɛyɛ ɔdɔfo wɔ ne nkyɛn»na bobɔ ho nfasoɔ bi.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/9510.mp3',
        'answer' => '<p> Ɛfiri Anas nkyɛn Onyame ngye no ntum,<span class="c6"> Onyame Somanii Nyame nhyira ne n\'asomdwie nka no aka sɛ :</span> <span class="c3">«Mo mu baako biara nni hɔ a ne gyidie ɛbɛhyɛma kɔpim sɛ mɛyɛ ɔdɔfo wɔ ne nkyɛn sene n\'awofo ne nemma ne adasamma nyina ara»</span> ɛfiri Buhaari ɛne Muslim mo.<span class="c6"><br /> Nfasode firi Hadis yi mu:</span><br /> Onyame Kɔmhyɛni Nyame nhyira ne n\'asomdwie nka no ho dɔ yɛ nhyɛ ɛsene Nipa nyina ara ho dɔ.<br /> Na saa eyi ɛka neɛ hyɛ gyedie ma ho.<span class="c6"><br /> Hadis a ɛtɔso nson :</span> </p>',
      ],
      6 => [
        'question' => 'Toa Hadis no so «Mo mu baako biara nni hɔ a ne gyidie ɛbɛ hyɛma kɔpim sɛ Ɔbɛ pɛ ama ne nua», na bobɔ ho nfasoɔ bi?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/9580.mp3',
        'answer' => '<p> Ɛfiri Anas nkyɛn Onyame ngye no ntum,<span class="c6"> Onyame Somanii Nyame nhyira ne n\'asomdwie nka no aka sɛ :</span> «Mo mu baako biara nni hɔ a ne gyidie ɛbɛ hyɛma kɔpim sɛ Ɔbɛ pɛ ama ne nua ade a Ɔpɛ ma neho <span class="c2">(ne kra)</span> ɛfiri Buhaari ɛne Muslim mo.<span class="c6"><br /> Nfasode firi Hadis yi mu:</span><br /> Ɛye nhyɛ ma Ɔgyedinii sɛ Ɔpɛ adepa bi ma Agyidifoɔ te sɛ sɛdeɛ ɔpɛ adepa ma nekra.<br /> Na ɛno ka neɛ hyɛ gyedie ma ho.<span class="c6"><br /> Hadis a ɛtɔso nwɔtwe:</span> </p>',
      ],
      7 => [
        'question' => 'Asembisa;8 Toa Hadis yi so «Na me de Neɛ me kra hyɛ Ne nsa dinsi! »na bobɔ ho nfasoɔ bi?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/9650.mp3',
        'answer' => '<p> Amuaye;Ɛfiri Saeed papa nkyɛn Nyame ngye no ntum,<span class="c6"> Sɛ Onyame Somanii Nyame nhyira ne n\'asomdwie nka no aka sɛ:</span> <span class="c3">«Na me de Neɛ me kra hyɛ Ne nsa dinsi! sɛ ɛsipi sɛ Suura yi ne Kuran nkyekyɛmu miɛnsa yɛ pɛ »</span> ɛfiri Bukhaari ho<br /> Mfasode bi firi Hadis yi mu:<br /> Suura Al-Ikhilas gyinabea<br /> Nokware ɛne Koran Nhoma no nkyekyɛmu miɛnsa yɛ pɛ.<span class="c6"><br /> Hadis a ɛtɔso nkron:</span> </p>',
      ],
      8 => [
        'question' => 'Asembisa:9 Toa Hadis no so «Tumi ɛne Ahoɔdene biara nni hɔ gye Onyankopɔn (Allah)», na bobɔ ho nfasoɔ bi?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/9720.mp3',
        'answer' => '<p> Amuaye;Ɛfiri Musa papa nkyɛn Nyame ngye no ntum,<span class="c6"> Onyame Somanii Nyame nhyira ne n\'asomdwie nka no aka sɛ:</span> Tumi ne ahoɔden biara nni hɔ agye Allah nkyɛn yɛ akorade a ɛka ɔsoro aheman mu nkorade no ho. ɛfiri Buhaari ɛne Muslim mo.<span class="c6"><br /> Nfasode firi Hadis yi mu:</span><br /> Saa asɛmfua yi so mfasoɔ ne sɛ; ɛyɛ akorade a ɛka ɔsoro aheman mu nkorade no ho.<br /> Akoa twe ne ho firi ɔno ankasa tumi ne n\'ahoɔden ho, na ɔde atwene Allah okokuroko no nko ara.<span class="c6"><br /> *Ɔkomhyɛni ano asɛm a ɛtɔ so du:</span> </p>',
      ],
      9 => [
        'question' => 'S10. Toa asɛm yi so ("esipi sɛ namkum bi wɔ nipadua no mu")Na bobɔ mfasoɔ a ɛwɔ so no bi?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/9790.mp3',
        'answer' => '<p> Yɛnyaa saa asɛm yi firii Anu\'man a ɔpapa ne Bashir <span class="c2">( Allah nye wɔn tom)</span> ɔkaa sɛɛ: metee sɛ Allah somani no reka sɛ: "Ɛsipi sɛ namkum bi wɔ nipadua no mu a sɛ ɛyɛ yie a nipadua no nyinaa ayɛ yie, na sɛ ɛsɛe a nipadua no nyinaa asɛe, na ɛno ne akoma no". ɛfiri Buhaari ɛne Muslim mo.<span class="c6"><br /> Mfasode bi firi Hadis yi mu:</span><br /> 1. Akoma siesie mu siesie su a apue ne neɛ asuma.<br /> 2. Ahwɛyie ɛfa akoma siesie ho, ɛfiri sɛ ɛno na siesie nnipa.<br /> Ɔkomhyɛni ano asɛm a ɛtɔ so du baako.Hadis a ɛtɔso du miɛnsa </p>',
      ],
      10 => [
        'question' => 'S11. Toa asɛm yi so: "obi a ne kasa a ɛtwa toɔ wɔ wiase ha bɛyɛ Onyankopɔn biara nni hɔ agye Allah"Na bobɔ mfasoɔ a ɛwɔ so no bi.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/9860.mp3',
        'answer' => '<p> Yɛnyaa saa asɛm yi firii Mu\'az a ɔpapa yɛ Jabal <span class="c2">(Allah nye no ntum)</span> ɔkaa sɛ: Allah somani no kaa sɛ: "obi a ne kasa a ɛtwa toɔ bɛyɛ Onyame biara nni hɔ agye Allah no bɛwura ɔsoro aheman mu". Abu Dawuda Nhoma mu,<span class="c6"><br /> Mfasode bi firi Hadis yi mu:</span><br /> Asɛm yi gyinabea <span class="c2">(Onyame biara nni hɔ a ɔfata ɛsom wɔ nokware mu gye Allah nko)</span>, Na nokware Akoa de asɛm yi rewura Ɔturo no mu <span class="c2">(Ɔsoro ahenman)</span>.<br /> Ɛna gyenabea a ɛwɔ Obibiara a N\'asɛm a ɛwitoɔ wɔ wiase yi mu yɛ <span class="c2">(Onyame biara nni hɔ a ɔfata ɛsom wɔ nokware mu gye Allah)</span>.<br /> Hadis a ɛtɔso du mienu. </p>',
      ],
      11 => [
        'question' => '12. Toa asɛm yi so, "Ogyidini nka afoforɔ anim na ɔmmɔ dua" ɛne ɛso mfasoɔ no bi.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/9940.mp3',
        'answer' => '<p> Yɛnyaa saa asɛm yi firii Abdullah ɔpapa ne Mas\'ud <span class="c2">(Allah nye no ntom)</span> ɔkaa sɛ: Allah somani no <span class="c2">( Allah nhyira ne n\'asomdwoeɛ nka no)</span> kaa sɛ: " ogyidini nka afoforɔ anim, na ɔmmɔ dua, na ɔnyɛ amumueɛsɛm na ɔnfa n\'ano nka ahuhusɛm".<span class="c6"> Tirmizee na de bae<br /> Nfasode firi Hadis yi mu:</span><br /> 1. Bra a ɛrebra kasa bɔne ne yera kasa tantan biara.<br /> - Ɛrekyerɛ sɛ ogyidini nsohyɛ wɔ ne tɛkrɛma so.<br /> Hadis a ɛtɔso du miɛnsa </p>',
      ],
      12 => [
        'question' => 'Asembisa:13 Toa Hadis yi so: «Ɛka Onipa Kramosom yiedie ho sɛ »na bobɔ ho nfasoɔ bi.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/10020.mp3',
        'answer' => '<p> Amuaye;Ɛfiri Abi Haraira nkyɛn Onyame ngye no ntum Ɔkaa sɛ: Onyame somanii Nyame nhyira ne n\'asomdwie nka no aka sɛ : <span class="c3">«Ɛka Onipa Kramosom yiedie ho sɛ Ɔgyae ade a ɛnfa ne ho »</span> Yɛnyaayɛ ɛfiri Tirimizii ho ne afoforɔ.<span class="c6"><br /> Nfasode firi Hadis yi mu:</span><br /> Sɛ onipa bɛgyae adeɛ a ɛnfa ne ho, ɛfa ɛsom a ɛnyɛ ne som anaa ne wiase dwumadie bi ho.<br /> Sɛ onipa bɛgyae adeɛ a ɛnhyɛ ne som no ma.<br /> * Ɔkomhyɛni asɛm a ɛtɔ so du nan. </p>',
      ],
      13 => [
        'question' => 'S14. Toa asɛm yi so: "obi a ɔbɛka atwerɛba wɔ Allah nnwoma (Qur\'an) no mu no" Na bobɔ ɛso mfasoɔ no bi.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/10100.mp3',
        'answer' => '<p> Yɛnyaa saa asɛm yi firii Abdullah a ɔpapa ne Mas\'ud: sɛ ɔkomhyɛni Muhammad <span class="c2">( Allah nhyira ne n\'asomdwoeɛ nka no)</span> kaa sɛ: " obi a ɔbɛka atwerɛba afiri Allah nwoma no mu no wɔ ɛho nhyira, na ɛho nhyira yɛ saa du,<span class="c6"> menka sɛ:</span> alif laam meem yɛ atwerɛba, na mmom alif yɛ atwerɛba, na laam nso yɛ atwerɛba na meem nso yɛ atwerɛba".<span class="c6"> Tirmizee na de bae<br /> Mfasode bi firi Hadis yi mu:</span><br /> 1-Quran akenkan gyinabea<br /> 2- ɛna nokware aba biara a, wo bɛ kenkan no wo wɔ nhyira akatua wɔ ho. </p>',
      ],
    ],
    6 => [
      0 => [
        'question' => 'S1- Sɛn na yɛ da Suban adi kyerɛ Nyame kokroko?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/10190.mp3',
        'answer' => '<p> Anuyie1 : Anidie ne Obuo fa Ne ho ahoteɛ nka no Okokroko.<br /> 2 - Yɛ bɛ som no kro pɛ Ɔnni hokanii biara.<br /> 3-Asotie ma Ɔno nko.<br /> 4- Asoɔdene bɔne ngyaeɛ.<br /> woreda otumfoɔ okokuroko no ase ɛnam nkrɔm ne n\'adom a wontumi nkan.<br /> Ɛne Abutare wɔ hyɛberɛ so. </p>',
      ],
      1 => [
        'question' => 'S.2 Kwan bɛn na Obuo ma Ɔsomanii no se teɛ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/10270.mp3',
        'answer' => '<p> N\'akyeredie ɛna N\'anamontuo ho asuasua.<br /> Sotie ma no.<br /> 3- Asoɔdene bɔne ngyaeɛ.<br /> 4- Wogyeatom ɛfa deɛ yabo wo amanieɛ.<br /> Ɛnhyɛ biribi ase nka Ne Sunna ho.<br /> Ne ho dɔ sene wo kra ɛna Nipa nyina ara<br /> Obuo ma No ɛna ne mmoa ɛna ne sunna mmoa. </p>',
      ],
      2 => [
        'question' => 'S:3 Kwan bɛn na Obuo ma Awofoɔ seteɛ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/10360.mp3',
        'answer' => '<p> Sutie ma Awofoɔ mienu wɔ dwuma ɛnyɛ Asoɔdene.<br /> Awofoɔ som <span class="c2">(yɛ dwuma pa ma wɔn )</span>.<br /> Awofoɔ mmoa<br /> Yɛ wɔn apɛdaɛ <span class="c2">(ahiadeɛ)</span> ma wɔn.<br /> Mpaebɔ ma Awofoɔ mienu.<br /> Suban pa kasa ma wɔn; na kasa <span class="c2">(Uff)</span> ɛnsɛ nfata wɔn na ɛno ne kasafi kuma.<br /> Sere w\'anim wɔ Awofoɔ anim na ɛnmuna kum.<br /> Me mma mene so nkyɛn m\'awofoɔ, na me tie wɔn na me nfa kasa ntwa wɔn kasa, na me mbɔ wɔn din prɛko pɛ,<span class="c6"> mmom me ka sɛ :</span> "me papa" "me maame"<br /> Me serɛ kwan firi wɔn hɔ ansa m\'awura me papa ne me maame wɔn hɔ bere a wɔn wɔ Dan mu.<br /> Me fe M\'awofoɔ nsa ne wɔn tiri. </p>',
      ],
      3 => [
        'question' => 'S:4 Kwan bɛn na mɛ sera abusua.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/10490.mp3',
        'answer' => '<p> 1-Abusua ɛnsera ɛyɛ nua barima ne nuabaa, Ɔfafoɔ, ne sewaa ne Abusuafoɔ a aka.<br /> 2-yɛ wɔn papa wɔ kasa ne dwumadie mu na boa wɔn.<br /> 3- Na ɛbi ne sɛ wo bɛ ferɛ wɔn busa wɔn apomudene. </p>',
      ],
      4 => [
        'question' => 'S:5 Kwan bɛn na mɛka me nuanom ne me ndanfofoɔ ho.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/10550.mp3',
        'answer' => '<p> Me dɔ wɔn na me fa wɔn mu nea di mu adanfo.<br /> Na me twe me ho gyae Abonefoɔ adanfofa.<br /> Me kyea me nua nom ɛkyea wɔn nsamu.<br /> Na me kɔ wɔn nserahwɛ sɛ wɔn yare a, na me bɔ mpae serɛ apɔteɛ ma wɔn.<br /> 5-Na me bɔ mpaeɛ ma neɛ bɛ nwansi.<br /> 6-Me gye ne frɛ so sɛ Ɔfrɛ me wɔ badwa ase.<br /> 7- Me ma no afutuo.<br /> 8-Me boa no sɛ Obi sisi no a, na bra no firi asisie ho.<br /> 10- Me pɛ adepa a me pɛ ma me ho, ma me nua kramoni.<br /> 11- Me boa no sɛ Ɔhia me mmoa a.<br /> 12- Me nfa ɔhaw ɛnka no, wɔ kasa anaa dwumadie mu.<br /> 13- Me bɔ ne sumasɛm ho ban.<br /> 14- Me nni no atɛm, me nka N\'akyinsɛm, anaa abonfiyaa, anaa ahoɔyaa, Na me nyɛ ne ho nsokro <span class="c2">(nhwehwɛ N\'anamontuo mu)</span>, anaa me nsisi no. </p>',
      ],
      5 => [
        'question' => 'S6- Ɛdeɛn ne suban a ɛsɛ sɛ wo da no adi ma neɛ te bɛn wo?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/10710.mp3',
        'answer' => '<p> Anuyie1 - Me yɛ neɛ te bɛn me papa wɔ kasa ne dwumadie mu, na me boa no sɛ Ɔhia me mmoa a.<br /> 2- Me ma no tiri nkwa bere a anigye sɛm bɛ to no, wɔ afoofi<span class="c2">(Eid)</span> da anaa awareɛ anaa anigyeɛ foforɔ bi mu.<br /> 3- Me kɔ sera no sɛ Ɔyare a, na me ma no hyɛdene ne yaa kɔ bere a musuo anaa biribi bɛ ka no.<br /> 4- Me ma no Aduane a me yɛ bi kakra mɛtumi.<br /> 5- Me mma ɔhaw nka no wɔ me kasa ne me dwumadie mu.<br /> 6- Me mma mene so nnyɛ dede ɛnha no, anaa N\'anamontuo ho nhwehwɛ mu,na me si ne ho abotare yie. </p>',
      ],
      6 => [
        'question' => 'S7.Ɛdeɛn ne hɔhogyeɛ ne Ahohoɔ suban?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/10800.mp3',
        'answer' => '<p> Anuyie1. Me gye neɛ bɛ frɛ me so wɔ Hɔhogyeɛ mu.<br /> 2.Na sɛ me pɛ sɛ me kɔ sra Obi me rehwehwɛ kwan ne ɛmmerɛ firi ne nkyɛn.<br /> 3.Me resrɛ kwan ansa m\'awura mu.<br /> 4. Me nkyɛre hɔ pii.<br /> 5. Me bra m\'ani ase firi ne fiefoɔ ho.<br /> 6. Me ma ahɔhoɔ akwaaba na me gye no ɔfɛw so wɔ animteɛ mu ɛna nsɛm pa a ɛma akwaaba.<br /> 7. Me de ahɔhoɔ tena tenabea pa.<br /> 8. Na me de Obuo ma No Aduane ne nsuo </p>',
      ],
      7 => [
        'question' => 'S8. Bobɔ suban pa fa Yareɛ ho ɛne Yarefoɔ nsrahwɛ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/10900.mp3',
        'answer' => '<p> Anuyie1. Berɛ a mɛ te yaw bi no ; Me me nsa nifa to bea a ɛyɛ me ya so,<span class="c6"> Na me reka sɛ :</span><span class="c2">( me rehyɛ ase wɔ Onyame din mu)</span> mprɛ nsa,<span class="c6"> Na me reka sɛ :</span> Me Onyame Allah gyinabea a ɛso ne netumi rehwehwɛ ntwutwagyeɛ firi bɔne <span class="c2">(ɔyaw)</span> me te na me bɔ ho kɔkɔ. mprɛ nson<br /> 2. Me pene hyɛberɛ a Onyame ahyehyɛ ama me na me si ho abutare.<br /> 3. Me keka me ho kɔ sra me nua a ɔyare na me bɔ mpae ma no, na me nkyɛ wɔ ne nkyɛn.<br /> 4. Me bɔ mpae serɛ apɔteɛ ma no bere a ɔnserɛɛ me mpaebɔ.<br /> 5. Me de abutare ne mpaebɔ na ɛtu no fo, ne asɔreyɛ ne Ahonidie wɔ deɛ ɔbɛ tumi.<br /> 6.<span class="c6"> Ɔyarefoɔ mpaebɔ:</span> <span class="c3">«Me rehwehwɛ firi Onyame nkunimdini Ahenkonya kɛseɛ wura nkyɛn sɛ Ɔnsa wo Yareɛ »</span> mprɛ nson. </p>',
      ],
      8 => [
        'question' => 'S9: Bobɔ suban wɔ Nimdie hwehwɛ mu?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/10990.mp3',
        'answer' => '<p> Anuyie1: Nkankyeɛ kɔgyee ma Onyame kokroko nko.<br /> 2. Me de nimdie a masua di juma pa.<br /> 3- Me de obuo ma Ɔkyerɛkyerɛni wɔ berɛ ɔwɔhɔ ne berɛ a Ɔnnihɔ.<br /> 4- Me de obuo tena N\'anim.<br /> 5- Me yɛ koom tie no yie, Na me ntwa ne kasa so wɔ berɛ a ɔrekyerɛ adeɛ.<br /> 6- Me busa asɛmbusa wɔ obuo mu.<br /> 7- Me mmɔ ne din nfrɛ no. </p>',
      ],
      9 => [
        'question' => 'S10- Ɛdeɛn ne tenabea suban pa?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/11090.mp3',
        'answer' => '<p> 1- Me kyea wɔn ɛtena tenabea ho.<br /> 2- Me tena tenabea a ɛda hɔ si, me ntu Obi nfiri ne tenabea anaa sɛ mɛ nteta Nipa mienu ntam gye wɔn peneɛ mu.<br /> 3- Me pene ma me yɔnko tena me nkyɛn.<br /> 4- Me ntwa kasa so wɔ tenabea mu.<br /> 5- Me serɛ kwan ɛto wɔn Salam nkyea ansa m\'afiri tenabea hɔ.<br /> 6- Berɛ a asetena bɛ kɔ awieɛ no me bɔ asetena mpaebɔ a ɛrepepa bɔne. wɔ ho tie wo Nyankopon,ne wo ndaase,me de adanse se nokware Nyame biara nni hɔ a ɔfata som gyese wo,me sera bonefakye firi wɔ ho,na me sakyera kɔ wo nkyɛn. </p>',
      ],
      10 => [
        'question' => 'S11- Bobɔ suban pa fa nna ho.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/11180.mp3',
        'answer' => '<p> Anuyie1 - Me da ntɛm.<br /> 2- Me da m\'akyi so.<br /> 3- Me nna me meyam so.<br /> 4- Me da me nifa so, na me de me nsa to me nifa afuno ase.<br /> 5- Me propro me kɛtɛ so ansa mada.<br /> 6- Me Kenkan nna mpaebɔ, ɛfiri Ayatul kursiyi, ɛne Suratul Ihilas,<span class="c6"> ɛne ɛntwetwagyeɛ Sura mienu no mprɛ nsa na me reka sɛ:</span> Anuyie1 Me hyɛ ase wɔ wo din mu me wura me rewo ɛna me resɔre bio.<br /> Me resɔre ahema kye asɔre <span class="c2">(Salla)</span> nti.<br /> 8-<span class="c6"> Na Me dasɔre a Me reka sɛ:</span> Aseda nka Onyame, Onyame a wanyane yɛn berɛ a wakum yɛn akyi, na ne nkyɛn na yɛ bɛ kɔ. </p>',
      ],
      11 => [
        'question' => 'S12- Ɛdeɛn ne Aduane ho Suban pa?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/11290.mp3',
        'answer' => '<p> Anuye-<br /> 1- Me kankye adidie ne adenom sɛ ɛbɛ hyɛ me den wɔ Nyame kokroko som mu.<br /> 2- Ɛnsa mienu hohoroɔ ansa Aduane die.<br /> 3-Me reka sɛ <span class="c2">(Bismillah)</span>, Na me de me nsa nifa adidi wɔ m\'anim, na me ndi Aduane nfinfini anaa Obi anim.<br /> 4-<span class="c6"> Na sɛ me werɛfi a me reka sɛ :</span> <span class="c3">«me rehyɛ ase wɔ Onyame din mu firi ahyaseɛ ne awieɛ »</span>.<br /> 5- M\'ani gye Aduane biara a ɛwɔ hɔ ho, Na me nkasa ntia Aduane no sɛ manni a, sɛ mpo m\'ani angye ho a me gyae to hɔ.<br /> 6- Me di kɔntɔmoa kakra bi na, me nnidi pii.<br /> 7- Me nhu nframa wɔ Aduane ne nsuo mu, na me de sihɔ ma no dwo.<br /> 8- Me ne afoforɔ bomu didi ɛna Abusuafoɔ ne Ahohoɔ.<br /> 9- Me nhyɛ Aduane die ase ngyae me yɔnko a ɔsene me panyin.<br /> 10- Me bɔ Nyame din wɔ bere a me berɛ a mɛ nom nsuo, Na me nom bere a me te hɔ mprɛ nsa.<br /> 11- Me da Onyame ase wɔ bere a m\'awie adidie. </p>',
      ],
      12 => [
        'question' => 'S13- Bobɔ Islam suban wɔ ntaade hyɛ mu?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/11440.mp3',
        'answer' => '<p> Anuyie 1-Me rehyɛ m\'ataade firi nifa, Na m\'ada Onyame ase wɔ ho.<br /> 2- Me nyɛ m\'ataade tintine nsene me naepɔ.<br /> 3- Mmɔfra nhyɛ mmaa ntaade, saa ara nso na mmaa nhyɛ mmɛrima ntaade.<br /> 4. Sɛ mensuasua abonniayɛfoɔ ne amumueɛfoɔ wɔ me ntaade hyɛ mu.<br /> 5. Sɛ mebɔ Allah din berɛ mereworɔ ataade no.<br /> 6. Sɛ mede me nan nifa bɛdi kan ahyɛ me mpaboa, na madi kan aworɔ afiri me benkum. </p>',
      ],
      13 => [
        'question' => 'S14. Bobɔ ammamerɛ a ɛwɔ ade foro mu.( hyɛn ne deɛ ekeka ho).',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/11540.mp3',
        'answer' => '<p> 1. Meka sɛ," bismillah, alhamdulillah". {subhanal lazii sakhara lanaa hazaa wa maa kunnaa lahu mukriniin, wa innaa ilaa rabinaa lamunkalibun". Na ɛsipi sɛ yɛn wura Allah nkyɛn na yɛ bɛ san akɔ. suratul Zukhuruf 13,14<br /> 2. Sɛ merekɔ twam wɔ muslimini bi nkyɛn a mɛto no salaam <span class="c2">(asomdwoeɛ nkyia no)</span>. </p>',
      ],
      14 => [
        'question' => 'S15. Bobɔ ammamerɛ a yɛde tware kwan mu.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/11590.mp3',
        'answer' => '<p> 1. Mehwɛ yie na mebrɛ me ho ase wɔ me nanteɛ mu, na me nante wɔ kwan no nifa so.<br /> 2. Meto neɛ mɛhyia no salaam.<br /> 3. Mebrɛ m\'ani ase, na menhaw obiara.<br /> 4. Mehyɛ afoforɔ ma wɔyɛ papa, na mebra afoforɔ firi bɔne ho.<br /> 5. Meyi adeɛ biara ɛbɛtumi aha onipa firi kwan mu. </p>',
      ],
      15 => [
        'question' => 'S16. Bobɔ ammamerɛ a yɛde wura na yɛde pue firi fie.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/11670.mp3',
        'answer' => '<p> 1.<span class="c6"> Mede me nan benkum na di kan pue na maka sɛ:</span> 1.<span class="c6"> Mede me nan benkum na di kan pue na maka sɛ:</span> "bismillah, tawakaltu ala llah, laa haula walaa kuwwata illa billahi, Allahumma inii \'auzubika an adila aw udala, aw azila aw uzala, aw azlim aw uzlam, aw agyhala aw yugyhala alaya". 2.<span class="c6"> Mede me nan nifa na di kan wura fie na maka sɛ:</span> "bismillahi walagynaa, wa bismillahi kharagynaa, wa alaa rabinaa tawakalnaa".<br /> 3. Na mede dua weɛ na hyɛ aseɛ, na afei makyea fiehɔfoɔ. </p>',
      ],
      16 => [
        'question' => 'S17. Bobɔ ammamerɛ a yɛfa so kɔ agyananbea.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/11730.mp3',
        'answer' => '<p> 1. Mede me nan benkum na di kan wura mu.<br /> 2. Ansa na mɛwura mu a me ka sɛ "bismillah, allahumma inii \'auzubika minal khubsi wal khaba-is".<br /> 3. Menfa adeɛ biara a Allah din wɔ so nnwura hɔ.<br /> 4. Mesie berɛ a mereyɛ me ho yie.<br /> 5. Menkasa wɔ agyananbea hɔ.<br /> 6. Menfa m\'anim anaa m\'akyi nhwɛ beaɛ a yɛde y\'ani hwɛ yɛ asɔre berɛ meredwonsɔ anaa meregya me nan.<br /> 7. Mede me nsa benkum na yi fi firi me ho na menfa me nsa nifa.<br /> 8. Mengya me nan nnwu nnipa akwan anaa nnwunu mu.<br /> 9. Mehohoro me nsa berɛ magya me nan awie.<br /> 10.<span class="c6"> Mede me nan benkum na di kan pue na maka sɛ:</span> "gufraanaka". </p>',
      ],
      17 => [
        'question' => 'S18. Bobɔ amammerɛ a yɛfa so de wura masalakyi mu.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/11860.mp3',
        'answer' => '<p> Mede me nan nifa na di kan wura masalakyi mu,<span class="c6"> na maka sɛ:</span> 1."merehyɛ aseɛ wɔ Allah din mu, oh! Allah bue w\'ahummɔborɔ apono no ma me".<br /> 2. Mentena ase agye meyɛ asɔre <span class="c2">(naafila)</span> mmienu.<br /> 3. Me ntware wɔn a wɔreyɛ asɔre anim, na me mmɔ ade a, ayera ho daworo wɔ masalakyi mu na mentɔ na mentɔn ade wɔ masalakyi mu.<br /> 4.Mede me nan benkum na di kan pue firi masalakyi mu,<span class="c6"> na maka sɛ:</span> "oh! Allah mesrɛ wo w\'adom no bi". </p>',
      ],
      18 => [
        'question' => 'S19. Bobɔ nkyea amammerɛ.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/11930.mp3',
        'answer' => '<p> 1.<span class="c6">Sɛ mehyia muslimini a mede asomdwoeɛ nkyia na bɛhyɛ aseɛ wɔ bere a mereka sɛ:</span> "Allah asomdwoeɛ, n\'ahummɔborɔ ne ne nhyira nka mo" Na me ngyae nkyia, na mentene me nsa nko ara.<br /> 2. Menwenwen hwɛ neɛ merekyia no n\'anim.<br /> 3. Na mede me nsa nifa akyea no.<br /> 4. Sɛ merekyia obi a mede nkyia pa na ɛkyia no, anaa sɛ megye so sɛ neɛ ɔkyia me no pɛpɛɛpɛ.<br /> 5. Menfiti aseɛ nkyia anyeani-boniayɛni, na sɛ ɔkyia me a megye no so sɛneɛ ɔkyia me no pɛpɛɛpɛ.<br /> 6. Na abɔfra na fiti aseɛ kyia ɔpanin, na deɛ ɔte afidie so no na fiti aseɛ kyia neɛ ɔnam fam, na deɛ ɔretwa mu no na fiti aseɛ kyia neɛ ɔte hɔ na dɔm ketewa na fiti aseɛ kyia dɔm beberebe. </p>',
      ],
      19 => [
        'question' => 'S20. Bobɔ akwanserɛ amammerɛ no.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/12020.mp3',
        'answer' => '<p> 1. Mesrɛ kwan <span class="c2">( to salaam)</span> ansa na wawura beaɛ bi.<br /> 2. Mesrɛ kwan mprɛnsa na menfa bi nka ho, na ɛno akyi no na me kɔ.<br /> 3. Mebɔ pono no mu brɛo, na mennyina pono no anim pɛɛ, na mmom megyina pono no nifa anaa no benkum so.<br /> 4. Menwura me papa ne me maame anaa obiara dan mu ansa na maserɛ kwan, ne titiriw ansa na yɛbɛyɛ ahemakye asɔre no, ne awiaberɛ yɛda gye y\'ahome no ne berɛ a yayɛ anadwo asɔre awie akyi no.<br /> 5. Ɛtumi ba sɛ mewura mmeaɛ bi a ɛnyɛ obiara tebea, bi te sɛ; ayaresabea, anaa sɛ dwadiebea aberɛ merenserɛ kwan. </p>',
      ],
      20 => [
        'question' => 'S21. Bobɔ akwan a yɛfa so yɛ brɛo wɔ mmoa so.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/12100.mp3',
        'answer' => '<p> 1. Mema mmoa aduane ne nsuo nom.<br /> 2. Mehunu mmoa mmɔbɔ, na menfa nneɛma wɔntumi nsoa no.<br /> 3. Menfa asotwe ne ɔhaw ahodoɔ mu biara ntwe mmoa aso. </p>',
      ],
      21 => [
        'question' => 'S22. Bobɔ agudie ho ammamerɛ no bi.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/12160.mp3',
        'answer' => '<p> 1. Meyɛ nkankyeɛ sɛ agudie no bɛgyina wɔ sotie ma Allah ne n\'ani bɛgye yɛ ho nti.<br /> 2. Yɛnni agorɔ wɔ asɔre mmerɛ mu.<br /> 3. Yɛnnka mmarima ne mmayewa mmɔ mu wɔ agorɔ no mu.<br /> 4. Mehyɛ agudie ataade a ɛkata m\'adagya so.<br /> 5. Metwe me ho firi agudie a yabra ho, bi te sɛ agudie a yɛbɔ animu ne neɛ woyi adagya kyerɛ ho. </p>',
      ],
      22 => [
        'question' => 'S23. Bobɔ ammamerɛ a ɛwɔ aseresɛm yie so.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/12240.mp3',
        'answer' => '<p> 1. Sɛ aseresɛm no bɛyɛ nokwaresɛm na mmom ɛnyɛ nkontomposɛm.<br /> 2. Aseresɛm a ɛde ne ho firi ɛfɛwdie, ateetee ne ahunahuna ho.<br /> 3. Sɛ womma nsɛmkwaa yie no nnɔso. </p>',
      ],
      23 => [
        'question' => 'Bobɔ nwansie ho ammamerɛ no bi.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/12300.mp3',
        'answer' => '<p> 1. Sɛ wode wo nsa, ataade anaa ntamago bɛkata w\'ano berɛ a worenwansi no.<br /> 2.Sɛ wobɛda Allah ase berɛ a wanwansi awie no.<br /> 3.<span class="c6">Na wo nua anaa wo yɔnko aka sɛ:</span> "Allah nhu wo mmɔbɔ".<span class="c6"><br /> Na sɛ ɔka kyerɛ no a ɔnka sɛ:</span> "Allah ntene mo na ɔnsiesie mo dibea". </p>',
      ],
      24 => [
        'question' => 'S25. Hram ho ammamerɛ no ne deɛn?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/12360.mp3',
        'answer' => '<p> 1. Sɛ wobɛbɔ wo ho ban asi hram no ho kwan.<br /> 2. Sɛ womma wo ne so nka sɛ "aah"aah".<br /> 3. Sɛ wode wo nsa bɛkata w\'ano. </p>',
      ],
      25 => [
        'question' => 'S26. Bobɔ Kur\'ani akenkan ho ammamerɛ.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/12420.mp3',
        'answer' => '<p> 1. Sɛ wobɛkenkan no wɔ berɛ a wode nsukuta ate wo ho akyi.<br /> 2. Sɛ wode obuo ne anidie bɛtena ase.<br /> 3. Mehwehwɛ ntwiywagyeɛ firi Allah nkyɛn ɛfa bonsam ho wɔ akenkan no mfiti aseɛ.<br /> 4. Mede akenkan no kɔ adwendwene mu. </p>',
      ],
    ],
    7 => [
      0 => [
        'question' => 'S1. Bobɔ Suban pa gyinabea ne ho nfasoɔ.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/12500.mp3',
        'answer' => '<p> Ɔkɔmhyɛni Nyame nhyira ne n\'asomdwie nka no aka sɛ: <span class="c3">«Agyidifoɔ mu neɛ wahyɛma wɔ gyedie ne Suban»</span>. Yɛyaayɛ ɛfiri Tirimizii ho <span class="c2">(625)</span>. </p>',
      ],
      1 => [
        'question' => 'Ɛdeɛn nti na ɛsɛ sɛ yɛ de Nkramosom Suban bɔ yɛ bra.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/12530.mp3',
        'answer' => '<p> 1- Ɛnam sɛ ɛyɛ ngyinasoɔ a ɛma Onyame kokroko dɔ yɛn.<br /> 2- Ɛna ngyinasoɔ ma Onyame dɔ Abɔdeɛ nyina ara.<br /> 3- Ɛyɛ ade a ɛmu yɛ duro wɔ ɛnsɛneɛ mu.<br /> 4- Suban pa ɛma dwumadie akatua yɛ mmɔho mmɔho.<br /> 5- Ɛna ɛyɛ ahyɛnsodeɛ ɛrekyerɛ gyidie ahyɛma. </p>',
      ],
      2 => [
        'question' => 'S3- Ɛhe na yɛfa Suban wɔ Islam mu.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/12600.mp3',
        'answer' => '<p> Yɛfa firi Qur\'an mu,<span class="c6"> Onyame kokroko aka sɛ:</span> {Ɛsipi sɛ saa Kuran <span class="c2">(Qur\'an)</span> yi retene kɔ deɛ ɛyɛ kwan tenenee so}. <span class="c5">[ Suuratul Israa\'a: ٩]</span>.<span class="c6"> Ɛna Ɔkɔmhyɛni Sunnah mu nso:</span> berɛ a Onyame Somanii Nyame nhyira ne n\'asomdwie nka no aka sɛ: <span class="c2">(Ɛsipi sɛ yɛ somaa me sɛ me nhyɛ subanpa ma pɛpɛ)</span> Ɛfiri Ahmed Nhoma mu. </p>',
      ],
      3 => [
        'question' => 'S4. Ɛdeɛn ne papayɛ Suban ɛna Ɛho nkyekyɛmu.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/12640.mp3',
        'answer' => '<p> Anuyie.<span class="c6"> Papayɛ :</span> ɛyɛ wo bɛ hwɛ Onyame dwumadie mu ɛberɛ biara, Ɛna dwumadi pa die ɛna papayɛ ma Onyame Abɔdeɛ.<br /> Ɔkɔmhyɛni Nyame nhyira ne n\'asomdwie nka no aka sɛ <span class="c3">«Ɛsipi sɛ Onyankopɔn Allah atwerɛ papa abata biribiara ho »</span> Ɛfiri Muslim Nhoma mu.<span class="c6"><br /> Papayɛ nnidisoɔ bi be ne sɛ:</span><br /> Papayɛ wɔ Onyame kokroko ɛsom mu ɛno ne kroyɔ wɔ Ne som mu.<br /> Papayɛ ma Awofoɔ yɛ kasa pa ɛna dwuma pa ma wɔn.<br /> Papayɛ ma Abusua a ɛbɛn ne akyirikyiria abusua.<br /> Papayɛ ma tebɛn nii<br /> Papayɛ ma Ngyanka ɛne Ahiafo.<br /> Papayɛ ma Nea w\'ayɛ bɔne atia no<br /> Papayɛ wɔ Kasa mu.<br /> Papayɛ wɔ akyenyedie mu.<br /> Papayɛ ma Mmoa </p>',
      ],
      4 => [
        'question' => 'Ɛdeɛn na yɛ Papayɛ adaneɛ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/12780.mp3',
        'answer' => '<p> Papayɛ adaneɛ yɛ mumuyɔ.<span class="c6"><br /> Na mu bi ne sɛ:</span> wobɛgyae gyidie a ɛwɔ Allah okokuroko no som mu.<br /> * Ne asoɔden a yɛyɛ tia awofo.<br /> * Ne woretete abusua ntam.<br /> * Ne ofipamfoɔ bɔne.<br /> * Ne wobɛgyae sɛ woreyɛ onnibie ne ahiafoɔ papa ne deɛ ekeka ho ɛyɛ nsɛm ne nnwuma bɔne ho. </p>',
      ],
      5 => [
        'question' => 'S6. Ahwɛsodeɛ nkrabata ne ne nkyikyɛ mu?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/12860.mp3',
        'answer' => '<p> Anuye-<br /> 1. Ahwɛsodeɛ ɛwɔ sɛ worehwɛ Allah okokuroko no kyɛfa so yie.<span class="c6"><br /> Ne nkyikyɛ :</span> ahwɛsodeɛ a ɛwɔ nyamesom nneyɛɛ mu; firi asɔre yɔ mu, ntosoɔ du yie mu, akɔmkyene mu, ne nsrahwɛ de kɔ Allah fie no mu, ne neɛ ekeka ho wɔ nneɛma a Allah ahyɛ yɛn sɛ yɛnyɛ ho.<br /> 2. Ahwɛsodeɛ a ɛwɔ sɛ worehwɛ abɔdeɛ kyɛfa so yie.<br /> . Ɛfiri worehwɛ Nipa animonyam so yie.<br /> . Ne wɔn agyapadeɛ so.<br /> . Ne wɔn mogya so.<br /> . Ne wɔn sumasɛm, ne adeɛ biara Nnipa de ama wo sɛ hwɛso ma noɔ.<span class="c6"><br /> Okokuroko no kaa sɛ; mmerɛ a ɔrebobɔ nkunimdifoɔ su no:</span> <span class="c2">( Ne wɔn a wɔhwɛ ahwɛsodeɛ ne wɔn bɔhyɛ so yie )</span>.<span class="c6"> Suratul Muminuun :</span>8 </p>',
      ],
      6 => [
        'question' => 'S7. Ahwɛsodeɛ so yie abira bɔ ne sɛn?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/12980.mp3',
        'answer' => '<p> Anoyie: Hwammɔ die, ɛno ne sɛ woresɛe Allah kokuroko ne nnipa kyɛfa.<span class="c6"><br /> Ɔkɔmhyɛni Nyame nhyira ne n\'asomdwie nka no aka sɛ:</span> <span class="c2">(Nyaatwomni ahyɛnsode yɛ mmiɛnsa)</span> -na ɔkaa no wɔ mu sɛ- <span class="c2">(sɛ woma no ahwɛsodeɛ a na wadi wo hwammɔ)</span>. Yatimtim so.Bukhaare ɛne Muslim. </p>',
      ],
      7 => [
        'question' => 'S8. Ɛdeɛn ne nokware su?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/13020.mp3',
        'answer' => '<p> Ɛno ne sɛ woreka biribi pɛpɛɛpɛ sɛ neɛ ɛsiiɛ anaa sɛ neɛ ɛteɛ pɛpɛɛpɛ.<span class="c6"><br /> Ne nkrabata:</span><br /> Wobɛka nokware wɔ wo ne nnipa nkɔmɔ mu.<br /> Wobɛdi nokware wɔ wo bɔhyɛ mu.<br /> Wobɛdi nokware wɔ wo kasayɛ ne wo nnwumadie nyinaa mu.<span class="c6"><br /> Ɔkɔmhyɛni Nyame nhyira ne n\'asomdwie nka no aka sɛ:</span> <span class="c2">( Esipi sɛ; nokware ka tene onipa kɔ kwan pa so, na kwan pa nso tene onipa kɔ suro aheman mu, na esipi sɛ; onipa bi bɛka nokware saa kɔpem sɛ ɔbɛba abɛdane nokwarekani)</span>. Yatimtim so.Bukhaare ɛne Muslim. </p>',
      ],
      8 => [
        'question' => 'S9. Nokware abira bɔ ne deɛn?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/13100.mp3',
        'answer' => '<p> Nkontompo, na ɛno ne sɛ wodane nokware, ɛmu bi ne; woretwa kontompo ato nnipa so, na woredane abɔhyɛ ne woredi adanse kurumuu.<br /> Ɔkɔmhyɛni Nyame nhyira ne n\'asomdwie nka no aka sɛ <span class="c2">(Na esipi sɛ nkontompo tene onipa kɔ bɔne mu, na bɔne nso de onipa kɔ ogya mu, na esipi sɛ ɔdasani bi bɛtwa kontompo saa kɔpem sɛ yɛbɛtwerɛ no wɔ Allah nkyɛn sɛ ɔyɛ kontomponi)</span>. Yatimtim so.Bukhaare ɛne Muslim.<span class="c6"> Ɔkɔmhyɛni Nyame nhyira ne n\'asomdwie nka no aka sɛ:</span> <span class="c2">(Nyaatwomni nsohyɛ yɛ mmiɛnsa)</span>- na ɔkaa no wɔ mu sɛɛ- <span class="c2">(sɛ ɔkasa a ɔtwa kontompo, na ɔhyɛ bɔ a na wadane no)</span>. Yatimtim so.Bukhaare ɛne Muslim. </p>',
      ],
      9 => [
        'question' => 'S10. Bobɔ abotare nkyekyɛmu?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/13140.mp3',
        'answer' => '<p> -Wobɛsi abotare ayɛ sotie ama Allah okokuroko no.<br /> - Wobɛsi abotare wɔ asoɔden ho.<br /> - Wobɛsi abotare wɔ hyɛberɛ a ɛyɛ ya ho, na wada Allah ase wɔ tebea biara mu.<span class="c6"><br /> Na ɔkrɔnkɔnii kɛsie akasɛ:</span> <span class="c2">( Na Allah pɛ abotaresiefoɔ asɛm)</span>. <span class="c5">[Suuratul Aali Imraan ١٤٦]</span>.<span class="c6"> Ɔkɔmhyɛni Nyame nhyira ne n\'asomdwie nka no aka sɛ:</span> Ogyidini asɛm ɛyɛ nwanwa, ɛfiri sɛ n\'asɛm nyinaa yɛ papa, na woi nni hɔ ma obiara agye ogyidini, sɛ ɔnya adepa bi a ɔda Allah ase, na ayɛ papa ama no, na sɛ amaneɛ bi to no a ɔsi abotare na ɛno nso ayɛ papa ama no. Ɛfiri Muslim Nhoma mu. </p>',
      ],
      10 => [
        'question' => 'S11. Ɛdeɛn ade ne Abutare adane?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/13210.mp3',
        'answer' => '<p> Ɛno ne sɛ wo nsi abotare wɔ sotie dwumadie mu, ɛna wo nsi abotare nfiri Asoɔdene dwumadie ho yɛ mpepere ho, ɛne abufuo wɔ hyɛberɛ ho ɛwɔ kasaa anaa sɛ nniyɛ mu.<span class="c6"><br /> Ne nkyekyɛmu bi ne:</span><br /> Wo bɛ pɛ Owuo.<br /> Afono mu bobɔ.<br /> Ataade teteɛ<br /> Wo keka wo yaw ne w\'atenka.<span class="c6"><br /> Wo bɔ ɔsaeɛ mpae atia wo kra<br /> Ɔkɔmhyɛni Nyame nhyira ne n\'asomdwie nka no aka sɛ:</span> "Akatua bata nsɔhwɛ akɛseɛ ho, na esipi sɛ; sɛ Allah dɔ dɔmkuo bi a, ɔsɔ wɔhwɛ, na sɛ obi a ɔbɛgye atom no, Allah bɛgye no ato mu, na obi a ne bo bɛfu no, Allah bo bɛfu no". ɛfiri Tirmiz ɛne Ibn Hibbaan. </p>',
      ],
      11 => [
        'question' => 'S12. Ka mmoa suban.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/13310.mp3',
        'answer' => '<p> Ɛno ne sɛ woreboa nnipa wɔ adeɛ a wɔwɔ mu wɔ nokware ne papa kwan so.<span class="c6"><br /> Mmoa mu ahodoɔ:</span><br /> .Sɛ woreboa ama adepa bi agyina.<br /> .Sɛ woreboa ama ɔbɔneyɛni bi asakra.<br /> .Sɛ woreboa nnipa ne ahiafoɔ ama wɔnom ahyia wɔn ahiadeɛ.<br /> . Sɛ woreboa wɔ papa biara kwan so.<br /> . Sɛ wommoa wɔ bɔne, ɔhaw ne asoɔden kwan so.<span class="c6"><br /> Na ɔkrɔnkɔnii kɛsie akasɛ:</span> <span class="c4">{Na momoa moho wͻ papayε ne Nyamesuro ho, na monhwε na moammoa moho wͻ bͻne ne ͻtan ho. Na monsuro Nyankopͻn. Nokorε sε, Nyankopͻn awerԑtᴐ ano yε den paa 2}</span>. <span class="c5">[Suratul Maaidah 2]</span>.<span class="c6"> Ɔkɔmhyɛni Nyame nhyira ne n\'asomdwie nka no aka sɛ:</span> <span class="c3">«Gyedie nee ɛne gyedienee ɔmɔ ɛtisɛ ɛdae wɔnnom ɛwura ɔmɔ ɛmo kro »</span> Yatimtim so.Bukhaare ɛne Muslim.<span class="c6"> Ɔkɔmhyɛni Nyame nhyira ne n\'asomdwie nka no aka sɛ:</span> "Muslimini nua ne muslimini, ɔnsisiri no, na ɔnyi no mma, na obi a ne nua ahiasɛm bɛyɛ n\'ahiasɛm no, Allah nso bɛba n\'ahiasɛm mu. Na obi a ɔbɛyi muslimini afiri amaneɛ bi mu no, Allah bɛyi no afiri atemmuada amaneɛ no ho, na obi a ɔbɛkata muslimini bi ntwom no, Allah bɛkata ne ntwom atemmuada". Yatimtim so.Bukhaare ɛne Muslim. </p>',
      ],
      12 => [
        'question' => 'S13. Fɛreɛ su gu ahodoɔ sɛn?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/13420.mp3',
        'answer' => '<p> 1.<span class="c6"> Sɛ wobɛfɛre Allah:</span> ɛsi ɛbere a wonyɛ asoɔden ntia ahoteeɛni no.<br /> 2.<span class="c6"> Sɛ wobɛfɛre nnipa:</span> na emu bi ne sɛ wobɛgyae adwaman ne ahuhusɛm ka, ne sɛ woreyi w\'adagya adi.<br /> Allah somani <span class="c2">(Allah nhyira ne n\'asomdwoeɛ nka no)</span> kaa sɛɛ: "gyidie nkrabata yɛ aduosia anaa aduoson, na deɛ wɔ soro paa ne sɛ wobɛka sɛ; Onyame biara nni hɔ agye Allah, na deɛ ɛwɔ ne fam pa ara ne sɛ wobɛyi ɔhaw bi afiri kwan mu. Na fɛreɛ nso yɛ gyidie nkrabata no bi". Ɛfiri Muslim Nhoma mu. </p>',
      ],
      13 => [
        'question' => 'S14. Bobɔ ahummɔborɔ su ahodoɔ no.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/13470.mp3',
        'answer' => '<p> - Sɛ worehu mpaninfoɔ mmɔbɔ na wadi wɔn ni.<br /> - Sɛ worehu nkwadaa ne mmɔfra mmɔbɔ.<br /> - Sɛ worehunu onnibie ne ohiani mmɔbɔ.<br /> - Sɛ worehunu mmoa mmɔbɔ wɔ berɛ a worema wɔn aduane na wonteetee wɔn.<br /> Ne saa nti na ɔkomhyɛni Muhammad <span class="c2">(Allah nhyira ne n\'asomdwoeɛ nka no)</span> reka sɛ: "wobɛhunu agyidifoɔ sɛ neɛ wɔhu wɔn ho wɔn ho mmɔbɔ, na wɔdodɔ wɔn ho te sɛ honam akwaa no, sɛ honam akwaa baako nwinwin no a honam akwaa neɛ aka no nyinaa de kɔdanna ne atiridii gye no so. Yatimtim so.Bukhaare ɛne Muslim.<span class="c6"> Na Onyame somafoɔ no Nyame asomdwie nka no aka sɛ:</span> " Ahummɔborɔfoɔ na ɔhummɔborɔni no bɛ hu wɔn mmɔbɔ, monhu wɔn a wɔwɔ asaase yi so mmɔbɔ, neɛ ɔwɔ soro no nso bɛhu mo mmɔbɔ. Ɛfiri Abu Dawud ,ɛneTirmizi nwoma mu. </p>',
      ],
      14 => [
        'question' => 'S15. Ɔdɔ su gu ahodoɔ sɛn?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/13550.mp3',
        'answer' => '<p> Ɔdɔ a wowɔ ma Allah okokuroko no.<span class="c6"><br /> Na ɔkrɔnkɔnii kɛsie akasɛ:</span> Na Agyidifoɔ wɔ ɔdɔ denden kɛseɛ ma Onyankopɔn. <span class="c5">[ Suuratul Baqara: ١٦٥]</span>.<span class="c6"><br /> Ɔsomanii Nyame nhyira ne n\'asomdwie nka no ho dɔ<br /> Na ɔkrɔnkɔnii kɛsie akasɛ:</span> <span class="c3">«Me dɔ deɛ mekiraa ɛkyɛ nensa mo,mɔ mo biara nneho a negyedie ahyɛ ɛma ɛkwɔpimsɛ mɛdane nedɔfo asene ɛfiri nenba nom ɛne nawofoɔ nom »</span> ɛfiri Bukhaari ho<br /> ɔgyedie nee ɛdɔ,ɛna ɛyɛ ɛdɔ pa ɛma wɔnnom sɛdeɛ wo dɔ wohɔ.<span class="c6"><br /> Ɔkɔmhyɛni Nyame nhyira ne n\'asomdwie nka no aka sɛ:</span> <span class="c3">«ɛnyɛ adeɛ a mɔ mo bi ɛbɛya gyedie ɛkwɔpimsɛ ɔbɛ dɔ nenua ɛtisɛ sɛdeɛ ɔdɔ nehɔ »</span> ɛfiri Bukhaari ho </p>',
      ],
      15 => [
        'question' => 'Asɛmbosa 16: Yekyerɛ Bahyaahya asekyerɛ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/13630.mp3',
        'answer' => '<p> Anuye- ɛyɛ ɛnim ɛbeɛ,ɛfa anigyie mo ɛne awesere anim ɛne ayɛmyɛ ɛna wobɛda wanim ade anigyie mo ɛwɔ abraa wobɛhyia wonua nipa.<br /> ɛna ɛfa sɛ yɛ si netire ase ɛyɛ wobɛ muna woanim akyerɛ wonua nipa ɛfiri adeɛ a mɔ dwane hɔ.<br /> ɛnam ɛwɔ saa adom yi mo na hadiis ɛbaayɛ,na ɛyɛ Abii Huraiya Onyame npenie nka nɔ,<span class="c6">wakasɛ:</span> ɔkomhyane Onyame asomdwie nka nɔ wakakyerɛ me sɛ: <span class="c3">«ɛnyɛ adeɛ ɛfata sɛ wobɛgyae afiri dwumadie pa ɛdi kitikiti koraa,ɛna sanka nokware worehyia wonua ɛfa anigyie anim »</span> Ɛfiri Muslim Nhoma mu.<span class="c6"> Na Onyame somafoɔ no Nyame asomdwie nka no aka sɛ:</span> <span class="c3">«Sɛ wo bɛti wo anim anigyie awen mo ama wonua ɛyɛ nhyira ɛma wo»</span> Tirmizee na de bae </p>',
      ],
      16 => [
        'question' => 'Asɛmbosa 17: Deɛbɛn nayɛ Hasada\'\'Ahuoyaa?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/13690.mp3',
        'answer' => '<p> Anuye- ɛno nayɛ ɛnsusuyɛ mmera biara adum wɔ afofro bi so anaasɛ wobɛpo adum wɔ nakye.<span class="c6"><br /> Onyame kɛsie akasɛ:</span> <span class="c4">{ ɛna ɛfiri mosoɔ ahuoyaa nee ɛwɔ mmerta a ɔreyɛ ahoɔyaa 5}</span>. <span class="c5">[Suuratul Falaq:5]</span>.<br /> ɛna ɛyɛ Anas bun Maalik Onyame npenie nka nɔ,<span class="c6">nokware Onyame somanee nɔ akasɛ Onyame asomdwie nka nɔ:</span> <span class="c3">«Nma ntae mɔ hɔ,ɛna nma mɔnyɛ ahoɔyaa,ɛna nma ndane makye nma mɔhɔ,ɛna mɔndane Onyame nkoa - nua nom »</span> ɛfiri Buhaari ɛne Muslim mo. </p>',
      ],
      17 => [
        'question' => 'Asɛmbosa 18: Deɛbɛn nayɛ Estehizaan \'\'ɛworo\'\'?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/13740.mp3',
        'answer' => '<p> Anuye- ɛno nayɛ sereɛ ɛkyerɛ ɛfiri wonua muslim ɛne abonfia,na ɛnyɛ adeɛ a ɛyɛ ɛfata.<span class="c6"><br /> Onyame kɛsie nɔ abra wɔ saa so wakasɛ:</span> { Mo a moagye adie, εnsεsε nnipa kuo bi bεsere nnipa kuo bi, ebia na <span class="c2">(wͻn a wͻ\'resere wͻn no)</span> kyεn wͻn <span class="c2">(wͻ Nyankopͻn anim)</span>; mmaa nso nhwε na w\'ansere <span class="c2">(wͻn yͻnko nom)</span> mmaa, ebia na wͻ\'kyεn wͻn; na monhwε na moanhwehwε mfomsoͻ amma moho-moho, na monhwε na moanfrε moho mmranee <span class="c2">(bͻne)</span>; Ɛyε bͻne sε yεde akohwi din bi bεfrε obi wͻ akyire yi a <span class="c2">(saa nipa no)</span> anya gyidie, na obi a <span class="c2">(ͻbεte saa asεm yi)</span> na w\'ansakra n\'adwen no, saa nkorͻfoͻ no εm no }. <span class="c5">[ Suuratul Mujadala 11]</span>. </p>',
      ],
      18 => [
        'question' => 'Asɛmbosa 19: kyerɛ Tawaa\'di\'u \'\'Ahobrasie\'\' asekyerɛ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/13780.mp3',
        'answer' => '<p> Anuye- ɛno nayɛ sɛ nipa nhunu nehɔ sɛ ɔyɛ obɛyɛ a ɔhunu nehɔ ɛsene nipa biara,ɛna ɛnyɛ adeɛ a ɔbɔ nipa bi abonfia ɛna ɔnpo nokorɛ.<span class="c6"><br /> Na ɔkrɔnkɔnii kɛsie akasɛ:</span> { Mmͻborͻhunufoͻ Hene no asomfoͻ no ne wͻn a wͻ’de ahobraseε nam asaase soͻ; sε abagyimifoͻ no bi <span class="c2">(de kasa bͻne bi)</span> kasa wͻn ho a,<span class="c6"> deε wͻ’ka nesε:</span> “Asomdweε } <span class="c5">[ Suuratul Furqaan: 63 ]</span>,<span class="c6"> ɛkyerɛ:</span> Ahobrasie nee.<span class="c6"> Na Onyame somafoɔ no Nyame asomdwie nka no aka sɛ:</span> <span class="c3">«ɛna ɔbiara nneho a ɔbɛbra nehɔ ase ama Onayme agye Onyame ɛpɛgya no animuoyam mo. Ɛfiri Muslim Nhoma mu.<span class="c6"> ɛna wakasɛ Onyame asomdwie nka nɔ:</span> «Ɛsipi sɛ Onyankopɔn ahyɛ me nkɔm sɛ mo mbra mo ase, sɛdeɛ ɛbɛ yɛ a Obi nsisi Obi, na Obi nyɛ akɛsesɛm wɔ Obi so »</span> Ɛfiri Muslim Nhoma mu. </p>',
      ],
      19 => [
        'question' => 'Asɛmbosa 20: Deɛbɛn nayɛ akyerewadie akɛsesɛm ahodoɔ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/13840.mp3',
        'answer' => '<p> Anuye- 1- Akɛsesɛm ɛwɔ nokorɛ so,ɛna nayɛ ɛrekyerɛ wo nokorɛ na wapo nengyetom.<br /> 2- Akɛsesɛm ɛwɔ nipa so,ɛna nayɛ wokyerɛ ɔmɔ abonfiya ɛne wopo wɔnnom.<br /> -<span class="c6"> ɔkomhyane Onyame somafoɔ nɔ akasɛ Onyame asomdwie nka nɔ:</span> <span class="c3">«ɛnyɛ adeɛ a ɔbɛwura aljanna mo obiara a ɔwɔ ɛwɔ nakoma mo adeɛ a kitikiti ɛnsɛsoɔ ɛfiri akɛsesɛm »</span> Na abranteɛ akasɛ: Nokorɛ saa abranteɛ yi ɔpɛ sɛ sanka nataadeɛ ɛyɛ fitaa ahotie mo,<span class="c6">ɛna nenpaboa ɛbɛfɛ? wakasɛ:</span> <span class="c3">«Nokorɛ Onyame nayɛ ahuofɛ nee na ɔpɛ ahuofɛ nee,<span class="c6">Akesesɛm:</span> nokorɛ ɛpo,ɛna nipa mo ahomasoɔ »</span> Ɛfiri Muslim Nwoma mu.<br /> -<span class="c6"> Nokorɛ ɛpo:</span> ɔtotwine:<br /> Nipa mo ahomasoɔ: ɔyɛ ahɔmasoɔ wɔnnom so.<br /> Ataadeɛ pa ɛne ɛnpaboa pa ɛnyɛ akesesɛm. </p>',
      ],
      20 => [
        'question' => 'Asɛmbosa 21:Keka akyerewadeɛ kronobo nom bi ahodoɔ \'\'gyehye\'\'?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/13910.mp3',
        'answer' => '<p> Anuye- Gyehye ɛwɔ adeton ɛne aton,ɛno nayɛ sɛ wobɛ seɛ adeton numan nom bi ɛkwan bi so.<br /> - Gyehye ɛwɔ nimdie ɛkyerɛ mo,ɛtisɛ nensɛsoɔ nom bi be adesua nee ɛbɛwia ɛwɔ ɛnsohwɛ mo.<br /> - Gyehye ɛwɔ kasa mo ɛtisɛ adanse kronee ɛne atorɔ.<br /> - ɛne wonhyɛ bohyɛma ɛfa adeɛ a woka ɛne adeɛ a matimtim agyeatom wɔhɔ ne nipa nom.<br /> ɛna ɛwɔ abraa yabra kronobo,nokorɛ Onyame somafoɔ nɔ ɛretwam ɛwɔ ɛduane kakra bi hɔ,ɛna ɔde nensa ɛwura mo, ɛna nensasoa ɛfuuyɛ,<span class="c6">ɛna ɔkaasɛ:</span> <span class="c3">«ɛduane wura deɛbɛn aadeɛ neɛ?»</span> ɛna ɔkaasɛ: ɛyɛ ɔsoro nsuo na aguso oh ɛyɛ Onyame somafoɔ.<span class="c6">ɛna wakaasɛ:</span> <span class="c3">«Na adɛntira na wonfato ɛduane no ɛsoro na nipa biara ahunu? na ɔbiara a ɔbɛbokrono no ɔrenka mehɔ »</span> Ɛfiri Muslim Nwoma mu.<span class="c6"><br /> ɛduane kakra subra:</span>ɛyɛ ɛsam ɛduane ɛtise piles ɛfiri aduane mo. </p>',
      ],
      21 => [
        'question' => 'Asɛmbosa 22: Deɛbɛn adeɛ nayɛ geeba \'\'ayɛkyerɛ\'\'?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/13990.mp3',
        'answer' => '<p> Anuye- ɛyɛ sɛ wobɛka wonua muslim asɛm ɛfa deɛ ɔkyere npɛ ɛwɔ nakye.<span class="c6"><br /> Na ɔkrɔnkɔnii kɛsie akasɛ:</span> { Mo a moagye adie, montwe moho mfiri m’adwen yε mesε <span class="c2">(onya a ͻbεyε)</span> bebrebe no ho; nokorε sε, m’adwen yε me sε <span class="c2">(onya a ͻbεyε)</span> no mu bi yε bͻne. Na monhwε na moantetεtetε <span class="c2">(moho)</span> na monhwε na moanka mo-ho-moho akyiri asεm. Mo mu bi pεsε ͻwe nenua a wawuo nam? Mokyiri saa. Enti monsuro Nyankopͻn. Nokorε sε Nyankopͻn na Ɔgye adwen sakra, na Ɔno ara nso ne Mmͻborͻhunufoͻ Hene 12} <span class="c5">[ Suuratul Hujiraati: 12 ]</span>. </p>',
      ],
      22 => [
        'question' => 'Asɛmbosa 23: Deɛbɛ Asekyerɛ nayɛ nameema \'\'Sɛiyyɛ atorɔ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14030.mp3',
        'answer' => '<p> Anuye- ɛyɛ wobɛfa kasa bi ɛwɔ nipa ɛntɛm ɛfa bone sɛiyyɛ nti wɔnnom ɛntɛm.<br /> -<span class="c6"> ɔkomhyane Onyame somafoɔ nɔ akasɛ Onyame asomdwie nka nɔ:</span> <span class="c3">«ɛnyɛ adeɛ a ɔbɛwura aljanna mo nammaama»</span> Ɛfiri Muslim Nwoma mu. </p>',
      ],
      23 => [
        'question' => 'Asɛmbosa 24: Deɛbɛn nayɛ kasal \'\'Akwɔdworɔ\'\'?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14070.mp3',
        'answer' => '<p> Anuye- ɛyɛ adeɛ a ɛmoyɛdo neyɛ ɛwɔ dwumadie pa ɛdi ɛna ɛnyɛ adeɛ a nipa bi ɛbɛtumi ayɛ.<span class="c6"><br /> ɛna ɛfiri saa no:</span> yɛ akwɔdworɔ ɛwɔ dwumadie ɛfata ɛnhyɛ ɛdi hɔ.<span class="c6"><br /> Na Onyame krɔnkɔnii No akasɛ:</span> { Nokorε sε, nkͻnkͻnsafoͻ no <span class="c2">(adwen ne sε)</span>, wͻ’redaadaa Nyankopͻn, Ɔno nso bεdaadaa wͻn,Sε wͻ’gyina hͻ sε wͻ’refrε Nyame a, wͻ’gyina hͻ wͻ akwadworͻ so, <span class="c2">(wͻ’yε)</span> dekyerε nnipa; sε wͻ’bεkae Nyankopͻn mpo a wͻ’kae no ketewaa bi 142 } <span class="c5">[ Suuratul Nisaai:١٤٢]</span><br /> Na ɛfata ɛma gyedie nee ɔbɛgyae akwadworɔ ɛne aniha ɛne akyekyire,ɛna nkekahɔ nanteɛ wɔ dwumadie mo ɛne akekahɔ ɛne modenbo ɛne adepa wɔ saa nkwa yi mo ɛfa deɛ Onyame kɛsie apene so. </p>',
      ],
      24 => [
        'question' => 'Asɛmbosa 25: Keka gadab \'\'Abufuo\'\' ahodoɔ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14130.mp3',
        'answer' => '<p> Anuye- 1-<span class="c6">Abofuo Aseda:</span> ɛno nayɛ sɛ wobɛyɛ ama Onyame nasɛ wo wieɛ kaffaara yɛ anaasɛ akwonkwɔnsafoɔ anaasɛ ɔmɔ akye nasotwie akyerewadeɛ ɔkrɔnkɔ.<br /> 2-<span class="c6"> Abofuo Abrasie animguasie:</span> ɛno nayɛ abufuo deɛ ɛma nipa ɛdi ɛna ɔbɛka deɛ nfa nehɔ.<span class="c6"><br /> Abufuo animguasie anuadoru:</span><br /> Nsuokuta.<br /> ɛntinasie nasɛ ɛkwɔbasa ɔgyina ho,ɛnasɛ ɔtwire ho a na watina ase.<span class="c6"><br /> Sɛ ɔbɛtimtim ɛfa ɔkomhyane Onyame asomdwie nka nɔ nafutuo ɛwɔ saa so:</span> <span class="c3">«Nma wobunfo »</span>.<br /> Sɛ ɔbɛkuta nekiraa ɛwɔ ɛbufuo ɛkuta.<br /> Yehwehw[ ntwitwagye[ firi Onyankopen he afiri ebonsam a, y\'apo noe no ho.<br /> ɛdee ɛyɛ. </p>',
      ],
      25 => [
        'question' => 'Asɛmbosa 26: Deɛbɛn nayɛ tagyasusu ɛnfiifimo?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14240.mp3',
        'answer' => '<p> Anuye- ɛno nayɛ abeɛ so ɛne wobɛhwehwɛ wɔ nipa ɛntwom ɛne deɛ yɛ nasoma monsɛm.<span class="c6"><br /> ɛfiri akyerewadeɛ ɛsu:</span><br /> Nipa ɛfie nsumayɛ monsɛm wobɛ mano aba abonti.<br /> - Sɛ ɔbaa ɛbɛteɛ ɔbi kasa wɔ abraa ɔnneho nimdie.<span class="c6"><br /> Na ɔkrɔnkɔnii kɛsie akasɛ:</span> <span class="c4">{ Nma mɔnfiifi nsɛm mo }</span> <span class="c5">[ Suuratul Hujiraati: 12 ]</span>. </p>',
      ],
      26 => [
        'question' => 'Asɛmbosa 27: Deɛbɛn nayɛ Israaf \'\'sika sɛiyyɛ\'\'? ɛna deɛbɛn nayɛ Bukhul \'\'Pɛpɛɛ\'\'? ɛna deɛbɛn nayɛ karam \'\'animuoyam\'\'?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14310.mp3',
        'answer' => '<p> Anuye-<span class="c6"> Al Israaf:</span> ɛno nayɛ sika ye ɛwɔ abraa ɛnyɛ ɛkwan pa so,<span class="c6"><br /> ɛnasɛ yɛsinase a:</span> Al Bukhul: ɛno nayɛ ɛkuta mo den ɛwɔ nekyɛfa so.<br /> ɛna nokware ɛno nayɛ adɛntɛmo wɔnnom ɛntɛm,ɛnasɛ ɛbɛyɛ wɔ muslimifoɔ animuoyam mo.<span class="c6"><br /> Na ɔkrɔnkɔnii kɛsie akasɛ:</span> {Ne wͻn a sε wͻ’yi <span class="c2">(wͻn agyapadeε a wͻ’mma no mmoroso)</span> nsεe no kwa, na wͻ’nnyε pεpεε nso, na mmom wͻ’yε no hͻ-ne-hͻ 67} <span class="c5">[ Suuratul Furqaan: 67 ]</span>, </p>',
      ],
      27 => [
        'question' => 'Asɛmbosa 28: Deɛbɛn nayɛ jubna \'\'ɛhuu\'\'? ɛna deɛbɛn nayɛ hyajaa\'a mmodenbo?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14370.mp3',
        'answer' => '<p> Anuye-<span class="c6"> Al Jubna:</span> Sɛ ɔbɛsro afiri adeɛ a ɛnyɛ adeɛ a ɛsɛ ɔsro ɛfiri hɔ.<br /> ɛtisɛ ɛhuu ɛfiri kasa nokware mo na afei ɛnam saa nti nawapo.<span class="c6"><br /> Akwokwodoro:</span> ɛna nayɛ sɛ wobɛma nokware ɛbɛ di animo,ɛna ɛnam saa no ɛtisɛ ɛkwɔ animo wɔ jihaad mmerɛ mo ɛde boa ɛma Islaam Muslimifoɔ.<span class="c6"><br /> ɛna ɛyɛ adeɛ a ɔkomhyane Onyame asomdwie nka nɔ ɛwɔ nempaebo mo ɔkasɛ:</span> <span class="c2">(Me Wura me hwehwɛ ntwutwagyeɛ wɔ wo nkyɛn firi ɛhuu ɛsro ho)</span>.<span class="c6"> Na Onyame somafoɔ no Nyame asomdwie nka no aka sɛ:</span> <span class="c3">«Ahuodenee gyedienee ɔdemo wɔ ɛdɔ ɛwɔ Onyame ho ɛsene gyedienii a oɔmmerɛ,ɛnanso wɔnnom nyinara ɛdemo »</span> Ɛfiri Muslim Nhoma mu. </p>',
      ],
      28 => [
        'question' => 'Asɛmbosa 29: Keka kasa akyerewadeɛ kɛterema nom bi?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14440.mp3',
        'answer' => '<p> Anuye- ɛtisɛ ɛnnomee ɛne adedeɛtɛm.<br /> - ɛna ɛtisɛ asamase kasa \'\' Aboa\'\' anaasɛ ɛtisɛ ɛfiri kasa mo.<br /> - Anaasɛ wobɛka adɛgya kasa ɛfiri adwamae ɛne ɛfee kasa.<br /> - ɛna nokware ɔkomhyane Onyame asomdwie nka nɔ apo ɛwɔ saa so nyinara mo,<span class="c6">na wakasɛ:</span> " ogyidini nka afoforɔ anim, na ɔmmɔ dua, na ɔnyɛ amumueɛsɛm na ɔnfa n\'ano nka ahuhusɛm". ɛfiri Tirmiz ɛne Ibn Hibbaan. </p>',
      ],
      29 => [
        'question' => 'Asɛmbosa 30: Keka ɛngyinasoɔ muslim mmoaboa wɔ subae ɛkyerɛ ɛfa subae pa mo?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14500.mp3',
        'answer' => '<p> Anuye- 1- Mpaebo ɛfa sɛ Onyame ɛma wo agyapadie subae pa ɛna ɔbɛboa wo wɔso.<br /> 2- Onyame kɛsie ɔtumifoɔ ahwɛsoɔ,ɛna nokorɛ ɔnɔ no ɔnim wo ɛna ɔteɛ wo ɛna ɔhunun wo.<br /> 3- Wobɛkae subae pa nhyira ɛna nokorɛ ɛno no ɛyɛ ɛngyinasoɔ sɛ yɛ de wo ɛbɛwura aljanna mo.<br /> 4- Wobɛkae subae bone akɛtua ɛna nokorɛ ɛno no yɛ ɛngyinasoɔ ɛma no sɛ ɔbɛwura amanehunu ɛgyam.<br /> 5- Nokorɛ subae pa ɛde Onyame ɛdɔ ɛba ɛne nabɔdeɛ ɛdɔ,ɛna nokorɛ subae bone ɛde Onyame ɛbufuo ɛba ɛne nabodeɛ abufuo.<br /> 6- ɔkomhyane abakwasɛm akenkae Onyame asomdwie nka nɔ ɛne nasuasua ɛfa hɔ.<br /> 7- Adanfoɔ pa ɛreyeye ɛna atwehɔ ɛfiri nua bone mosoɔ. </p>',
      ],
    ],
    8 => [
      0 => [
        'question' => 'Asɛmbosa 3: Deɛbɛn nayɛ azkaar ɛnfasoɔ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14630.mp3',
        'answer' => '<p> Ɔkɔmhyɛni Nyame nhyira ne n\'asomdwie nka no aka sɛ <span class="c3">«Deɛ ɔtomtom nawurade ɛnsɛsoɔ ɛne deɛ ɔnkaekae nawurade,ɔmɔ ɛtisɛ nkwa ɛne ɛwuo»</span> ɛfiri Bukhaari ho<br /> - Wɛi yɛ ɛfa nokorɛ nipa debrɛ gyinabrɛ nkwa mo ɛfa dodoɔ sɛdeɛ wotomtom Onyame kɛsie. </p>',
      ],
      1 => [
        'question' => 'Asɛmbosa 2:Keka zikir ɛnfasoɔ nom bi?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14670.mp3',
        'answer' => '<p> Anuye- 1- Ahunumobronee npenie.<br /> 2- ɛna ɛpam bonsam shaytaan.<br /> 3- ɛma musliminii ɛyɛ krɔnkɔ ɛfiri mosoɔ ɛhao mo.<br /> 4- ɛna ɛma nɔ ɛya ɛfa hɔ nhyira ɛne akɛtua. </p>',
      ],
      2 => [
        'question' => 'Asɛmbosa 3: Deɛbɛn ne zikir ɛnfasoɔ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14730.mp3',
        'answer' => '<p> Anuye- <span class="c3">«Onyame biara nneho nokorɛ mo agye ɔnyame krɔ pɛ »</span> ɛfiri Tirmiz ɛne Ibn Hibbaan. </p>',
      ],
      3 => [
        'question' => 'Asɛmbosa-Ɛdeɛn na wobɛka ɛfa yaneyɛ ɛfiri ɛnda mo?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14760.mp3',
        'answer' => '<p> Aseda nka Onyame, Onyame a wanyane yɛn berɛ a wakum yɛn akyi, na ne nkyɛn na yɛ bɛ kɔ. Yatimtim so.Bukhaare ɛne Muslim. </p>',
      ],
      4 => [
        'question' => 'Asɛmbosa 5: Deɛbɛn nayɛ adeɛ wobɛka nasɛ woyhɛ adaadeɛ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14790.mp3',
        'answer' => '<p> Anuyie: Aseda nka Onyame a wama me yie adi, na Ɔde ayɛ me adom, bere a ɛnyɛ me tumi bi anaa m\'ahoɔdene bi. Abu Dawud , Tirmizii ne Nasai na wenom de baee. </p>',
      ],
      5 => [
        'question' => 'Asɛmbosa 6: Ɛdeɛn mpaeɛ na yɛ reka sɛ yɛyi ataade a?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14820.mp3',
        'answer' => '<p> Anuyie - Me rehyɛ ase wɔ Onyame din mu. Tirmizee na de bae </p>',
      ],
      6 => [
        'question' => 'Asɛmbosa7. Ɛdeɛn mpaeɛ na yɛ reka sɛ yɛhyɛ ataade foforɔ a?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14850.mp3',
        'answer' => '<p> Anuye- <span class="c3">«Allaahumma lakal hamd anta kasawtaniihi,as\'aluka khayre hii wakhayreh maa swana\'a lahu,wa\'auuzubika minsharrihii washarri maa swana\'a lahu»</span> Rawaawu Abu Dawud ,ɛne deɛ ɔmɔ ɛkahɔ. </p>',
      ],
      7 => [
        'question' => 'S8. Ɛdeɛn mpaeɛ na yɛbɔ ma obi a wahyɛ ataade mono?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14880.mp3',
        'answer' => '<p> Sɛ wohu sɛ wo yɔnko ahyɛ ataade foforɔ a bɔ mpaeɛ ma no,<span class="c6"> na ka sɛ:</span> Allah ma wo nhyɛ nkyɛ na ɔnhyɛ wo anan mu. <span class="c3">«Tubalee wayukhuliful Laahi ta\'aalaa»</span> Abu Dawuda Nhoma mu, </p>',
      ],
      8 => [
        'question' => 'S9. Ka mpaeɛ a yɛbɔ de wura agyananbea. Na ɛhɔ ne agyananbea?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14910.mp3',
        'answer' => '<p> Oh Allah! me rehwehwɛ ntwitwagyeɛ firi wo nkyɛn ɛfa abɔdeɛ bɔne sɛ mmarima anaa sɛ mmaa. Yatimtim so.Bukhaare ɛne Muslim. </p>',
      ],
      9 => [
        'question' => 'S10. Ɛdeɛn mpaeɛ na yɛbɔ de pue firi agyananbea?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14940.mp3',
        'answer' => '<p> Oh Allah! meresrɛ Wo bɔnefakyɛ Ɛfiri Abu Dawud ,ɛneTirmizi nhoma mu. </p>',
      ],
      10 => [
        'question' => 'S11. Ɛdeɛn na wobɛka ansa na wakuta nsuo?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14970.mp3',
        'answer' => '<p> Anuyie - Me hyɛ ase wɔ Onyame din mu. Rawaawu Abu Dawud ,ɛne deɛ ɔmɔ ɛkahɔ. </p>',
      ],
      11 => [
        'question' => 'S12. Ɛdeɛn mpaeɛ na yɛbɔ sɛ yɛkuta nsuo wie a?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15000.mp3',
        'answer' => '<p> Meredi danseɛ sɛɛ Onyankopɔn biara nni hɔ agye Allah baako pɛ no a ɔnni mmataeɛ biara, na meredi danseɛ nso sɛɛ ɔkomhyɛni Muhammad yɛ n\'akoa yɛ no somani Ɛfiri Muslim Nhoma mu. </p>',
      ],
      12 => [
        'question' => 'S13. Ɛdeɛn mpaeɛ na yɛbɔ sɛ yɛrepue afiri fie a?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15020.mp3',
        'answer' => '<p> Mehyɛ aseɛ wɔ Allah din mu, mede me werɛ nyinaa hyɛ no mu, na tumi anaa ahoden biara nni baabiara agye ne nkyɛn. Ɛfiri Abu Dawud ,ɛneTirmizi nhoma mu. </p>',
      ],
      13 => [
        'question' => 'S14. Ɛdeɛn mpaeɛ na yɛbɔ mmerɛ a worewura efie?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15050.mp3',
        'answer' => '<p> Allah din mu na yɛrewura mu, na Allah din mu na yɛpueɛ, na yɛ wura Allah so na yɛde yɛ ho atwene, na afei wato fiehɔfoɔ<span class="c2">(salaam)</span>. Ɛfiri Abu Dawuda Nhoma mu, </p>',
      ],
      14 => [
        'question' => 'S15. Ɛdeɛn mpaeɛ na yɛbɔ mmerɛ a yɛrewura masalakyi. (Masjid)',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15080.mp3',
        'answer' => '<p> Oh Allah! bue w\'ahummɔborɔ apono no ma me.Ɛfiri Muslim Nhoma mu. </p>',
      ],
      15 => [
        'question' => 'S16. Ka mpaeɛ a yɛbɔ de pue firi masalakyi (masjid).',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15110.mp3',
        'answer' => '<p> Oh Allah! meresrɛ w\'adom. </p>',
      ],
      16 => [
        'question' => 'S17. Ɛdeɛn na wobɛka sɛ wote azaan a ( Nyamefrɛ ntiamu )?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15140.mp3',
        'answer' => '<p> Mɛka neɛ ɔfrɛfoɔ no reka no a bi agye sɛ ɔka sɛ; <span class="c2">(monka mo ho mmra mɛyɛ asore, monka mo ho mɛdi nkunim)</span> ɛno deɛ mɛka sɛ: <span class="c2">( tumi ne ahoɔden nni baabiara agye Allah nkyɛn )</span>. Yatimtim so.Bukhaare ɛne Muslim. </p>',
      ],
      17 => [
        'question' => 'S18. Ɛdeɛn na wobɛka wɔ Azaan akyi?.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15170.mp3',
        'answer' => '<p> Anuye- Wo mpaeɛ ma ɔkɔmhyɛne Onyame asomdwie nka no. Ɛfiri Muslim Nhoma mu. Na waka sɛ; Oh Allah! ɔfrɛ a ɛhyɛ ma yi ne asɔre yi wura, ma ɔkomhyɛni Muhammad nyɛ odimafo na dom no, na pagya no kɔ gyinabrɛ a ɛkrɔm a wode ahyɛ no bɔ no so. ɛfiri Buhaari mu.<br /> Na w\'abɔ mpaeɛ wɔ Azaan ɛna Ikaama ntam, na nokware saa no mpaebɔ nsane <span class="c2">(nyɛ kwa)</span>. </p>',
      ],
      18 => [
        'question' => 'S19. Ɛdeɛn ntomtom na wobɛka no anɔpa ne anwummerɛ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15220.mp3',
        'answer' => '<p> Kenkan Ayatul Kursiy Allah - Onyankopɔn foforɔ biara nni hɔ agye ɔno, ɔno na wɔ nkwa daa na ɔhwɛ biribiara so, ɔntonko na ɔnna, nneɛma a ɛwɔ soro ne asaase yi so nyinaa wɔ no, hwan na bɛtumi akasa agye obi wɔ n\'anim agye ɔno ara ma no kwan, ɔnim neɛ ɔwɔ y\'anim ne neɛ ɛwɔ y\'akyi, na wɔntumi mfa biribiara nka ho mfiri ne nimdeɛ mu agye neɛ ɔno ara pɛ, n\'ahennwa trɛ wɔ ɔsoro ne asaase so nyinaa, na wɔn a wɔhwɛ ne mmienu so no ntumi nkyekyere no, na ɔno na ɔwɔ soro na ɔno na so pa ara. <span class="c5">[ Suuratul Baqara: ٢٥٥]</span>.<span class="c6"> Na Kenkan:</span> Me hyɛ ase wɔ Onyame din mu ahomɔborɔ hene ɔdɛɛfoɔ hene. { Kasɛ ɔnɔ Allaah ɔyɛ kropɛ <span class="c2">(1)</span> Allaah na ɔbiara ɛdaa no ɛrehwihwɛ ne mmoa <span class="c2">(2)</span> ɔnne ba ɛna yɛn woo no <span class="c2">(3)</span> Na ɔnni sɛsoɔ biara wɔ n\'abɔdeɛ mu <span class="c2">(4)</span> } Mprɛnsa Me hyɛ ase wɔ Onyame din mu ahomɔborɔ hene ɔdɛɛfoɔ hene. Oh ɔsomafoɔ ei! ka sɛ me rehwehwɛ ntwitwagyeɛ firi ahemakye wura no hɔ 1. Ɛfiri ade bone biara a wabɔ. Ɛna ahobanbɔ ɛfiri ade bone a ɛwɔ anadwo ɛsum mu. Ɛna ade bone a ɛfiri mmaa wɔn bɔ pɔ toto natasuo gu so. Ɛna ade bɔne a ɛfiri ahoɔyaani ahoɔyaa ho. Mprɛnsa Me hyɛ ase wɔ Onyame din mu ahomɔborɔ hene ɔdɛɛfoɔ hene. Oh ɔsomafoɔ ei! ka sɛ me rehwehwɛ ahobanbɔ firi Onipa wura no hɔ. Onipa hene nkyɛn. Onipa Nyame nkyɛn Ɛfa bonsam bɔne a ɔtoto asu kɔ nnipa so. Ɔtoto asu kɔ nnipa akoma mu. Ɛfiri mmoatia ne Nipa mu Mprɛnsa 3- <span class="c3">«Alaahumma anta Rabbii laa ilaaha illaa anta,khalaqtanii wa\'ana \'abaduka,wa\'ana \'alaa \'ahadika wawa\'adika maa ista\'ta\'atu,auuzubika minsharri maa swana\'atu abuu\'a laka bini\'imatika \'allay,wa abuu\'a,wa\'abuu\'au bizanbii,fagfirilee,fa innahuu laa yagfirul zunuub illaa anta»</span> ɛfiri Bukhaari ho </p>',
      ],
      19 => [
        'question' => 'S20-Ɛdeɛn na wɔ reka sɛ wo bɛ da a?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15290.mp3',
        'answer' => '<p> Anuyie1 Me hyɛ ase wɔ wo din mu me wura me rewo ɛna me resɔre bio. Yatimtim so.Bukhaare ɛne Muslim. </p>',
      ],
      20 => [
        'question' => 'S21-Ɛdeɛn na wɔ reka ansa Aduane die?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15320.mp3',
        'answer' => '<p> Anuyie1 - Me hyɛ ase wɔ Onyame din mu.<span class="c6"><br /> Na sɛ wo werɛ fi wɔ ahyaseɛ a ka sɛ:</span><br /> Me hyɛ ase wɔ Onyame din mu firi ahyaseɛ ne awieɛ mu. Rawaawu Abu Dawud ,ɛne deɛ ɔmɔ ɛkahɔ. </p>',
      ],
      21 => [
        'question' => 'S22-Ɛdeɛn na wo reka Aduane die akyi?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15370.mp3',
        'answer' => '<p> Anuyie: Aseda nka Onyame a wama me yie adi, na Ɔde ayɛ me adom, bere a ɛnyɛ me tumi bi anaa m\'ahoɔdene bi. Ɛfiri Abu Dawud ,ɛne Ibin Maagya ne deɛ ɔmɔ ɛkaho. </p>',
      ],
      22 => [
        'question' => 'Ɛdeɛn ne Ahohoɔ mpaebɔ ɛma Aduane wura ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15400.mp3',
        'answer' => '<p> Anuyie: Oh Me wura Allah hyira adom a wo de adom wɔn, Na fa wɔn bɔne kyɛ wɔn na afae hu wɔn mmɔbɔ. Ɛfiri Muslim Nhoma mu. </p>',
      ],
      23 => [
        'question' => 'Ɛdeɛn na Nipa reka sɛ ɔnwensi a?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15430.mp3',
        'answer' => '<p> Anuyie: Aseda nka Onyame Allah.<br /> Na Onua anaa deɛ ka ne ho nka sɛ <span class="c2">(Onyame Allah nhunu wo mmɔbɔ)</span>?<br /> Na sɛ Ɔka saa kyerɛ no a,<span class="c6"> Ɔno nso nka se:</span><span class="c2">( Onyame Allah ntene mo na Ɔnyɛ mo asetena yie mma mo)</span>. ɛfiri Bukhaari ho </p>',
      ],
      24 => [
        'question' => 'Asɛmbosa 25: Deɛbɛn na waka ɛfa wɔ atamoada hɔ ɛne ahotɔ ɛfiri atenasie mo \'\'bonefakyɛ atinasie mpaebo \'\'?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15480.mp3',
        'answer' => '<p> wɔ ho tie wo Nyankopon,ne wo ndaase,me de adanse se nokware Nyame biara nni hɔ a ɔfata som gyese wo,me sera bonefakye firi wɔ ho,na me sakyera kɔ wo nkyɛn. Abu Dawud , Tirmizii ne Nasai na wenom de baee. </p>',
      ],
      25 => [
        'question' => 'Asɛmbosa 26: Deɛbɛn nayɛ adefro mpaebo?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15510.mp3',
        'answer' => '<p> Anuye- Bismillaahi,Wal hamdu Lillaahi <span class="c4">{ Subhaanal Lazii sakhara lanaa haazaa wamaa kunnaa lahu muqriniin 13 wa innaa ilaa rabbanaa lamunqalibuun 14}</span> , <span class="c3">«Alhamdu Lillaahi, Alhamdu Lillaah,Alhamdu Lillaah Allaahu Akbar,Allaahu Akbar,Allaahu Akbar, Subhaanakal Laahumma innii zalamtu nafsii fagfiri lii; fa innahuu laa yagfirulzunuub illaa anta»</span> Rawaawu Abu Dawud ,ɛne deɛ ɔmɔ ɛkahɔ. </p>',
      ],
      26 => [
        'question' => 'S27. Bɔ mpaeɛ a yɛbɔ foro hyɛn ne neɛ ɛkeka ho.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15540.mp3',
        'answer' => '<p> Oh Allah yɛresrɛ wo papa, nyamesuro ne dwumadie a w\'ani gye ho wɔ saa y\'akwantuo yi mu, oh Allah ma saa y\'akwantuo yi mu ɛnyɛ hare na ɛnyɛ merɛ mma yɛn, Oh Allah wo ne yɛ hokani wɔ akwantuo yi mu, na wo nsa na yɛde y\'abusuafoɔ hyɛ, oh Allah merehwehwɛ ntwitwagyeɛ firi wo nkyɛn fa ɔberɛ a ɛwɔ akwantuo yi mu ho, ne awerɛhosɛm bi a ani bɛtumi ahunu ho, ne sɛ yɛbɛkɔ abɛto asiane wɔ yɛ sika ne y\'abusua mu.<br /> Na sɛ Ɔsan n\'akyi a Ɔka nsɛm yi,<span class="c6"> na ɔde aka ho se:</span><br /> "Yasan aba a yɛresakra, yɛresom na yɛreda yɛ wura ase". Ɛfiri Muslim Nhoma mu. </p>',
      ],
      27 => [
        'question' => 'S28. Ɛdeɛn mpaeɛ na ɔkwantuni bɔ de ma ɔtemamuni (neɛ ɔte fie).',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15590.mp3',
        'answer' => '<p> Megyae mo hyɛ Allah no a biribiara a ɛhyɛ ne nsa nnyera no nsa. ɛfiri Ahmed ɛne Ibin Maagya. </p>',
      ],
      28 => [
        'question' => 'S29. Ɛdeɛn mpaeɛ na ɔtemamuni bɔ ma neɛ ɔretu kwan?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15620.mp3',
        'answer' => '<p> Mede wo som hyɛ Allah nsa, w\'ahobanbɔ ne wo nnwumadie awieɛ. ɛfiri Ahmɛd ɛne Tarmidhi nkyɛn. </p>',
      ],
      29 => [
        'question' => 'S30. Ɛdeɛn mpaeɛ na yɛbɔ wura dwa mu?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15650.mp3',
        'answer' => '<p> Onyame biara nni hɔ agye Allah baako pɛ no a ɔnni hokani biara no, ɔno na ahenie wɔ no, ɔno na nnaaseɛ wɔ no, ɔno na ma nkwa na ɔno na ɔkum, ɔno na tease a ɔnnwu da, ne nsa mu na papa wɔ, na ɔno na wɔ tumi wɔ biribiara so". ɛfiri Tirmiz ɛne Ibn Hibbaan. </p>',
      ],
      30 => [
        'question' => 'S31- Bɔ abufuo ho mpaebɔ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15680.mp3',
        'answer' => '<p> <span class="c3">«Auuzubillaahi mina shaytaani rajeem»</span>. Yatimtim so.Bukhaare ɛne Muslim. </p>',
      ],
      31 => [
        'question' => 'Ɛdeɛn na wo reka sɛ Obi yɛ wo papayɛ a?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15710.mp3',
        'answer' => '<p> Anuyie - Onyame mma wo akatua pa na Ɔnhyira wo. Tirmizee na de bae </p>',
      ],
      32 => [
        'question' => 'S41. Ɛdeɛn mpaeɛ na yɛbɔ sɛ wohunu obi a adeɛ ɔteso amaneɛ bi da no so a?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15740.mp3',
        'answer' => '<p> Anuyie - Me hyɛ ase wɔ Onyame din mu. Abu Dawuda Nhoma mu, </p>',
      ],
      33 => [
        'question' => 'S34. Deɛn na wobɛka sɛ wonya adeɛ a ɛma w\'anigye a?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15770.mp3',
        'answer' => '<p> Aseda wɔ Allah a n\'adom nti papa biara hyɛ ma. ɛfiri Bukhaari mo. </p>',
      ],
      34 => [
        'question' => 'S35. Deɛn na wobɛka sɛ adeɛ a wompɛ to wo a?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15800.mp3',
        'answer' => '<p> Aseda wɔ Allah wɔ tebea biara mu. Sahihul Gyaami mu. </p>',
      ],
      35 => [
        'question' => 'S36.Ɔkwan bɛn na yɛfa so to salaam ( asomdwoeɛ nkyea ) na kwan bɛn na yɛgye so?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15830.mp3',
        'answer' => '<p> Muslimini <span class="c2">( kramoni )</span> bɛka sɛ: Allah asomdwoeɛ, n\'ahummɔborɔ ne ne nhyira nka mo.<span class="c6"><br /> Na no nua no agye so sɛ:</span> Allah asomdwoeɛ, n\'ahummɔborɔ ne ne nhyira nka mo nso. ɛfiri Tirmize ɛne Abu Daud ɛne afoforɔ mu. </p>',
      ],
      36 => [
        'question' => 'S38. Mpaeɛ bɛn na yɛbɔ mmerɛ a nsuo retɔ?
  Oh Allah! ma no nyɛ nsuo a mfasoɔ wɔ so.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15870.mp3',
        'answer' => '<p> Oh Onyankopɔn ma nsuo yi nyɛ nfasoɔ ma yɛn. ɛfiri Buhaari mu. </p>',
      ],
      37 => [
        'question' => 'S38.Na mpaeɛ bɛn na yɛbɔ mmerɛ a nsuo atɔ awie?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15900.mp3',
        'answer' => '<p> Yɛnya nsuo wɔ Allah adom ne n\'ahummɔborɔ mu. ɛfiri Buhaari ɛne Muslim mo. </p>',
      ],
      38 => [
        'question' => 'S39. Ka mpaebɔ a yɛbɔ mmerɛ a mframa refa?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15930.mp3',
        'answer' => '<p> Oh Allah! mesrɛ wo papa a ɛwɔ mu na mehwehwɛ ntwitwagyeɛ firi bɔne a ɛwɔ mu ho. Abu Daud ɛne Ibin Maagya </p>',
      ],
      39 => [
        'question' => 'S40. Ka mpaeɛ yɛbɔ sɛ agradaa bɔ mu a?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15960.mp3',
        'answer' => '<p> Ahoteeɛ nka ɔno a <span class="c2">(Allah)</span> agradaa ne abɔfoɔ de ntomtom da n\'aseɛ ɛnam suro a wɔsuro no nti. Muata Malik. </p>',
      ],
      40 => [
        'question' => 'S41. Ɛdeɛn mpaeɛ na yɛbɔ sɛ wohunu obi a amaneɛ bi da no so a?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15990.mp3',
        'answer' => '<p> Aseda wɔ Allah a wasa me yareɛ afiri neɛ ɔde ayɛ wo nsɔhwɛ yi ho, na wakrɔm me nkrɔmo wɔ nneɛma bebree a wabɔ so. Tirmizee na de bae </p>',
      ],
      41 => [
        'question' => 'S42. Mpaeɛ a obi a ɔsuro sɛ ɔde n\'ani (bayie) de haw bɛto biribi so.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16020.mp3',
        'answer' => '<p> Wɔ ɔkomhyɛni ano asɛm mu no; "sɛ mo mu bi hunu biribi firi ɔnua nkyɛn anaa ɔno ankasa ho, anaa wɔ ne sika ho a ɛyɛ no nwanwa a, ɔmɔ mpaeɛ nsrɛ Allah nhyira ma no, ɛfiri sɛ ani <span class="c2">( bayie )</span> wɔ hɔ yi ɛyɛ ampa. ɛfiri Ahmed ɛne Ibin Maagya ne afoforɔ mu. </p>',
      ],
      42 => [
        'question' => 'S43. Ɔkwan bɛn so na wobɛbɔ mpaeɛ ama ɔkomhyɛni (Muhammad) Allah nhyira ne n\'asomdwoeɛ nka no?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16050.mp3',
        'answer' => '<p> "Oh Allah ma wo nhyira nka Muhammad ne n\'asefoɔ, sɛ neɛ wo nhyira kaa Ibrahim ne n\'asefoɔ no, ɛfiri sɛ wo na nkamfoɔ wɔ wo, na wo na animuoyam wɔ wo." Oh Allah hyira Muhammad ne n\'asefoɔ sɛ neɛ wo hyiraa Ibrahim ne n\'asefoɔ, ɛfiri sɛ wo na nkafoɔ wɔ wo na wo na animuonyam wɔ wo". Yatimtim so.Bukhaare ɛne Muslim. </p>',
      ],
    ],
    9 => [
      0 => [
        'question' => 'S 1: Ɛdeɛn ne ɔhyɛ mmera ɛnnum no?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16090.mp3',
        'answer' => '<p> Anuye-<br /> Ade a ɛyɛ nhyɛ<br /> Ade a ɛyɛ Sunna<br /> Ade a ɛyɛ Akyiwade<br /> Ade a yɛ mpɛ ɛyɛ abufo<br /> Ade a y\'ama ho kwan </p>',
      ],
      1 => [
        'question' => 'Kyerɛkyerɛ saa nsɛm mmera num yi mu.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16170.mp3',
        'answer' => '<p> Anuye-<span class="c6"><br /> Dwuma a ɛyɛ nhyɛ:</span>te sɛ Asɔre mperɛ num, ɛna Ramadan akɔmkyene ne Obuo ma Awofoɔ.<br /> Dwuma a ɛyɛ nhyɛ no yɛ ma Ɔyɛfoɔ no nhyira ne deɛ bɛ gyae nso yɛtwe n\'aso.<span class="c6"><br /> Dwuma a yɛ pɛ :</span>te sɛ ntosoɔ asɔre <span class="c2">(Sunan rawatib)</span>, ne anadwo asɔre ɛna Aduane ɛma Ohiani ɛna ɛnkyiya na yɛ frɛ yie nyina ara sɛ Sunnah ne Manduubu.<br /> Mustahab yɛ ma Ɔyɛfoɔ no nhyira na mmom Obi gyae nso Ɔnni asotwe biara.<span class="c6"><br /> Ahwɛyie a ɛho hiayie:</span><br /> Ɛfata ma Kramoni sɛ bere a Ɔbɛ te sɛ dwuma yi yɛ Sunnah no anaasɛ Mustahabu Ɔyɛ ntɛmtɛm di saa dwuma korɔ, na Ɔsuasua Ɔkɔmhyɛni Nyame nhyira ne n\'asomdwie nka no.<span class="c6"><br /> Akyiwade :</span> te sɛ nsanom, Asoɔdene wɔ Awofoɔ so ne Abusua ntam teteɛ.<span class="c6"><br /> Akyiwade dwuma :</span>yɛ ma Obi a Ogyae nhyira na yɛtwe Ɔyɛfoɔ nso aso.<br /> 4- Deɛ yɛ mpɛ <span class="c2">(Almakrooh)</span> te sɛ deɛ wɔ de bɛnkum gye adeɛ san de ma, wo bobɔ w\'ataadeɛ wɔ asɔre yɛ mu.<br /> <span class="c2">(Almakrooh)</span> Obi gyae Almakrooh dwuma a yɛ ma no nhyira mmom Obi a ɔbɛyɛ nso yɛ ntwe n\'aso.<br /> 5- Deɛ y\'ama ho kwan <span class="c2">(Almubaah)</span> te sɛ aduaba die ɛna tee num na yɛ frɛ yie nyina ara sɛ deɛ y\'ama ho kwan <span class="c2">(Gyaaiz, ne Halaal)</span>.<br /> <span class="c2">(Almubaah)</span>yɛ mma Ɔyɛfoɔ nhyira saara nso na neɛ bɛgyae nni nhyira biara. </p>',
      ],
      2 => [
        'question' => 'S33- Adetɔn ne Nipa nsawosoɔ ndwumadie mmera te sɛn?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16320.mp3',
        'answer' => '<p> Anuyie: Adetɔn ɛne nsawosoɔ ahoroɔ nyina ara ahyaseɛ ne sɛ, nokware y\'ama ho kwan ɛgye kakra bi Onyame kokroko ayɛ no akyiwade.<span class="c6"><br /> Na ɔkrɔnkɔnii kɛsie akasɛ:</span> <span class="c2">(Na Onyame ama adetɔn ho kwan (Halaal)</span> ɛna Wayɛ ɛnsiho akyiwade Haram). <span class="c5">[ Suuratul Baqara: ٢٧٥]</span>. </p>',
      ],
      3 => [
        'question' => 'S4. Bobɔ nkutahodie ne dwadie a yabra.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16360.mp3',
        'answer' => '<p> Anuye-<br /> 1. Asisire, na ebi ne sɛ wode mfomsoɔ a ɛwɔ ade a woretɔn no mu besie.<br /> Yɛnyaa saa asɛm yi firii Abu Hurayra <span class="c2">(Allah nye no ntom)</span> nkyɛn, sɛ Allah somani no kɔ too aduane bi a ahɔre gu hɔ, ɛna ɔde ne nsa wuraa mu, ɔyii ne nsa na afɔ,<span class="c6"> ɛdeɛn ni oh aduane wura? Ɔkaa sɛ:</span> bosuo na agu so oh Allah somani.<span class="c6"> Allah somani no kaa sɛ:</span> na adɛn na womma ɛno mma soro sɛ neɛ bɛyɛ a amanfoɔ bɛhunu? "Obi a ɔbɛsisi biara nka me ho". Na ɛdeɛn nti na wo nfa nto Aduane no so, sɛdeɛ Onipa bɛ hunu? Obibiara a, ɔbɛ yɛ asisie nka me ho. Ɛfiri Muslim Nhoma mu.<br /> 2.<span class="c6"> Nsiho:</span> na ebi ne sɛ wobɛbɔ bosea apem afiri obi hɔ na wobɛtua apem mmienu ama no.<br /> Na Ɛntosoɔ no,<span class="c6"> na yɛ Ɛnsiho a ɛyɛ Akyiwade Haram<br /> Na ɔkrɔnkɔnii kɛsie akasɛ:</span> <span class="c2">(Na Onyame ama adetɔn ho kwan (Halaal)</span> ɛna Wayɛ ɛnsiho akyiwade Haram). <span class="c5">[ Suuratul Baqara: ٢٧٥]</span>.<br /> 3.<span class="c6"> Brada toɔ ne fratam:</span> te sɛ meretɔn nufusuo a ɛwɔ aboa no nufu mu anaa meretɔn apatrɛ a ɔda so wɔ nsuom a menyii no.<span class="c6"><br /> Na ɛwɔ ɔkomhyɛni ano asɛm mu sɛ:</span> <span class="c2">( Allah somafoɔ no abra sɛ wode brada toɔ bɛtɔn ade)</span>. Ɛfiri Muslim Nhoma mu. </p>',
      ],
      4 => [
        'question' => 'S5- Bobɔ Onyame adom bi a ɛwɔ wo so.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16460.mp3',
        'answer' => '<p> G1- Nkramosom ho adom, ɛna nokware wo nka aboneɛfoɔ ho.<br /> 2-Ɔkɔmhyɛni Sunnah ho adom, Na nokware wo nka wɔn a ɛyɛ dwumadi foforɔ hyɛ ɛsom no mu <span class="c2">(Bidiya)</span>.<br /> 3- Apɔteɛ ne apomudene ho adom, nsɛmtie, adehwɛ, nanteɛ ɛna foforɔ a aka.<br /> 4- Adidie ne adenom ɛna ntaare.<br /> N\'adom Okokroko wɔ yɛn so yɛ pii yɛ nsisi ɛna yɛ nkae nso.<span class="c6"><br /> Na ɔkrɔnkɔnii kɛsie akasɛ:</span> Na sɛ moka sɛ morekan Allah adomakyɛdeɛ a ɛeɔ mo so a montumi nkan, esipi sɛ ɔno Allah no ɔyɛ bɔnefakyɛhene ahummɔborɔhene. Suratul Nahl 18 </p>',
      ],
      5 => [
        'question' => 'S6. Ɛdeɛn na yɛ nhyɛ wɔ adomakyɛdeɛ mu, na sɛn na wobɛda ɛho ase?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16540.mp3',
        'answer' => '<p> Ɛyɛ nhyɛ sɛ woda ɛho ase; na ɛno ne sɛ wode wo tɛkrɛma bɛtomtom na wada Allah ase bebree, na wahunu sɛ ɔno nko ara na adom wɔ no, na wode saa adomakyɛdeɛ no bɛyɛ adeɛ a Allah ani gye ho, na mmom wonfa nyɛ asoɔden ntia no. </p>',
      ],
      6 => [
        'question' => 'S7.Muslimifoɔ (Nkramofoɔ) afoofi da yɛ sɛn?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16570.mp3',
        'answer' => '<p> Idul fitr<span class="c2">(afoofida ketewa)</span> ne Idul adha<span class="c2">(afoofi da kɛseɛ)</span>.<span class="c6"><br /> Sɛ neɛ ɛwɔ ɔkomhyɛni ano asɛm a Anas kaeɛ no mu; ɔkaa sɛ:</span> Allah somani Muhammad<span class="c2">( ne nhyira ne n\'asomdwoeɛ nka no)</span> kɔɔ Madina no na wɔnom wɔ nannu bi a wɔdi agorɔ wɔ mu,<span class="c6"> na ɔkaa sɛ:</span> ɛdeɛn nannu ni? Wɔnom kaa sɛ: na yɛdi agorɔ wɔ mu wɔ abagyimi berɛ no,<span class="c6"> na Allah somani no kaa sɛ:</span> "esipi sɛ, Allah de deɛ ɛyɛ papa sen nannu yi ahyɛ mo anan mu; donwiberɛ <span class="c2">(salla kɛseɛ)</span> ne anobue da no <span class="c2">( salla ketewa)</span>". Ɛfiri Abu Daud nhoma mu.<br /> Na afoofi da biara a ɛwɔ woi akyi no yɛ nsakratomu. </p>',
      ],
      7 => [
        'question' => 'S8. Bosome bɛn na krɔm pa ara?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16620.mp3',
        'answer' => '<p> Akɔmkyene <span class="c2">(Ramadan)</span> bosome no. </p>',
      ],
      8 => [
        'question' => 'S9. Da bɛn na krɔm pa ara?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16650.mp3',
        'answer' => '<p> Ɛfiada </p>',
      ],
      9 => [
        'question' => 'S10. Da bɛn na ɛkrɔm wɔ afemmu no mu pa ara?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16680.mp3',
        'answer' => '<p> Arafa da no. </p>',
      ],
      10 => [
        'question' => 'S11. Anadwo bɛn na krɔm wɔ afemmu no mu pa ara?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16710.mp3',
        'answer' => '<p> Hyɛberɛ anadwo no <span class="c2">( Lailatul qadr)</span>. </p>',
      ],
      11 => [
        'question' => 'S12. Ɛdeɛn asɛdeɛ na ɛsɛ sɛ woyɛ sɛ wohunu abontensoni baa a?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16740.mp3',
        'answer' => '<p> Ɛsɛ sɛ wobrɛ ani ase.<span class="c6"> Ɔkokuroko no kaa sɛ:</span> " ka kyerɛ agyidifoɔ mmarima no sɛ wɔnom mmrɛ wɔn ani ase". Suratu An Nur 30 </p>',
      ],
      12 => [
        'question' => 'S13.Hwan mo ne nnipa atamfo?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16770.mp3',
        'answer' => '<p> 1. Ɔkra a ane bɔne di ntɔntɔ,<span class="c6"> na ɛno ne sɛ onipa bɛdi ne kra ne n\'akɔnɔdeɛ akyi wɔ berɛ a ɛyɛ asoɔden tia Allah ɔkokuroko no Ɔhoteeɛni no kaa sɛ:</span> "esipi sɛ ɔkra deɛ ɔne bɔne di ntɔntɔ agye neɛ me wura Allah no ahunu no mmɔbɔ, na esipi sɛ me wura Allah no ɔyɛ bɔnefakyɛhene ahummɔborɔhene. Suratu Yusuf 53 2.Bonsam; ɔno ne Adam ba tamfo na ne botaeɛ ne sɛ ɔbɛyera onipa na watoto bɔne agu n\'akoma mu, na wɔde no awura ogya mu,<span class="c6">Okokuroko no kaa sɛ:</span> "na monhwɛ yie na moani bonsam anamɔn akyi, ɛfiri sɛ; ɔno bonsam no ɔyɛ ɔtamfo a ɔda adi pefee de ma mo. <span class="c5">[ Suuratul Baqara: ١٦٨]</span>. 3.<span class="c6"> Abɔneyɛfoɔ kuo:</span> wɔn a wɔhyɛ afoforɔ wɔ bɔne akwan so na wɔn si papa akwan Okokuroko no kaa sɛ: "saa da no ayɔnkoɔ bɛyɛ atamfo ama wɔn ho wɔn ho agye nyamesurofoɔ no". Suratul Zukhruf 67 </p>',
      ],
      13 => [
        'question' => 'Ɛdeɛn ne nsakraeɛ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16820.mp3',
        'answer' => '<p> Nsakraeɛ ne sɛ wobɛsan afiri asoɔden a etia Allah kokuroko no na wayɛ sotie ama no,Okokuroko no kaa sɛ; " Na esipi sɛ, meyɛ bɔnefakyɛhene de ma obia a ɔbɛsakra na wagye na wadi dwuma pa na afei wayɛ ɔtenenii". <span class="c5">[ Suuratul Taaha:٨٢]</span>. </p>',
      ],
      14 => [
        'question' => 'S15. Ɛdeɛbɛn ne nsakraeɛpa mmera a ɛbataho?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16850.mp3',
        'answer' => '<p> 1. Ɛne sɛ wobɛgyae bɔne korɔ no.<br /> 2. Na wanu wo ho wɔ neɛ woyɛɛyɛ no ho.<br /> 3. Na wahyɛ wo ho so sɛ wo nsan nkɔ bɔne no ho bio.<br /> 4. Na wode neɛ wosisirii no noɔ adeɛ bɛsan akɔma noɔ.<span class="c6"><br /> Na ɔkrɔnkɔnii kɛsie akasɛ:</span> <span class="c2">( Ne wɔn a sɛ wɔyɛ amumuesɛm anaa wɔsisiri wɔn kra a wɔkae Allah na wɔsrɛ bɔnefakyɛ firi wɔn bɔne ho, na hwan na de bɔne kyɛ wɔ Allah no akyi? Na wɔnsan nkɔ neɛ wɔyɛɛyɛ no ho bio aberɛ a wɔnom nim)</span>. <span class="c5">[Suuratu Aali Imraan ١٣٥]</span>. </p>',
      ],
      15 => [
        'question' => 'Suura al S16: Ɛdeɛn ne sɛ worebɔ mpaeɛ ama ɔkomhyɛni (Muhammad)?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16920.mp3',
        'answer' => '<p> J: Asekyerɛ ne sɛ worebɔ mpaeɛ aserɛ Allah sɛ ɔnkanfo ne somafoɔ <span class="c2">(Muhammad)</span> wɔ badwa a ɛkrɔm no ase. </p>',
      ],
      16 => [
        'question' => 'S17. Ahoteeɛ wɔ Onyankopɔn kyerɛ sɛn?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16950.mp3',
        'answer' => '<p> J: Asekyerɛ ne sɛ worete ɔhoteeni ɔkokuroko ne ho afiri sinitɔ ne bɔne biara ho. </p>',
      ],
      17 => [
        'question' => 'S18: Aseda nyinaa wɔ Allah kyerɛ sɛn?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16980.mp3',
        'answer' => '<p> Ɛno ne sɛ wobɛtontom Allah kokuroko no bebree na wode mmrane biara ɛhyɛ ma bɛsa no. </p>',
      ],
      18 => [
        'question' => 'S19. Allah yɛ Ɔkɛse pa ara no kyerɛ sɛn?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/17000.mp3',
        'answer' => '<p> Ɛno ne sɛ; ɔno ɔhoteenii no ɔso sen biribiara, ɔyɛ kokuroko, ɔkrɔm na ɔyɛ den sene biribiara. </p>',
      ],
      19 => [
        'question' => 'S20. Tumi ne ahoɔden nni baabiara agye Allah nkyɛn kyerɛ sɛn?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/17030.mp3',
        'answer' => '<p> Asekyerɛ ne sɛ; akoa ntumi nsesa mfiri tebea bi mu nkɔ tebea foforɔ bi mu, ɔnni ahoɔden a wɔde bɛyɛ saa agye Allah nkyɛn. </p>',
      ],
      20 => [
        'question' => 'S21. Mesrɛ bɔne fakyɛ firi Allah nkyɛn kyerɛ sɛn?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/17060.mp3',
        'answer' => '<p> J. Ɛno ne sɛ akoa ɛrehwehwɛ afiri ne wura Allah nkyɛn sɛ ɔbɛpepɛ ne bɔne na wakata ne sinitɔ so. </p>',
      ],
    ],
  ],
];
