<?php
$data = [
  'title' => 'What Muslim Children Must Know',
  'description' => 'A project that contains a simple and easy curriculum for issues that a Muslim must know. It includes issues of belief, jurisprudence, prophetic biography, etiquette, tafsir, hadith, morals, and remembrance of Allah. It is suitable for young children in particular, for all ages, and newcomers to Islam.',
  'source' => 'https://kids.islamenc.com/am/home',
  'author' => 'Yazan Abdul Razzaq Raziq Alghanim',
  'sections' => [
    0 => 'የዐቂዳ ክፍል',
    1 => 'የፊቅህ ክፍል',
    2 => 'የነቢዩ ﷺ የህይወት ታሪክ ክፍል',
    3 => 'የተፍሲር ክፍል',
    4 => 'የሐዲሥ ክፍል',
    5 => 'የኢስላማዊ ስርአት ክፍል',
    6 => 'የስነምግባር ክፍል',
    7 => 'የዱዓእ እና አዝካር ክፍል',
    8 => 'የልዩ ልዩ ክፍል',
  ],
  'data' => [
    1 => [
      0 => [
        'question' => 'ጥ 1፡ ጌታህ ማን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/200.mp3',
        'answer' => '<p> መልስ - ጌታዬ እኔንም የሚንከባከበኝ እና ዓለማትን ሁሉ በጸጋው የሚንከባከበው የሆነው አላህ ነው።<br /> ማስረጃው ተከታዩ የላቀው አላህ ቃል ነው፦ <span class="c4">{ምስጋና ለዓለማት ጌታ ለአላህ የተገባው ነው። 2}</span> <span class="c5">[ሱረቱል ፋቲሓ: 2]</span> </p>',
      ],
      1 => [
        'question' => 'ጥ 2፡ ሃይማኖትህ ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/240.mp3',
        'answer' => '<p> ሃይማኖቴ እስልምና ነው። ኢስላም ማለት፦ ለአላህ ብቻ ሁለመናን ሰጥቶ እርሱን በብቸኝነት ማምለክ፣ ለትዕዛዙ ፍፁም ታዛዥ መሆን <span class="c2">(መጎተት)</span> እና ከሺርክም ይሁን ከሙሽሪኮች ሙሉ በሙሉ መራቅ <span class="c2">(መገለል)</span> ነው።<br /> የላቀው አላህ እንዲህ ብሏል፦ <span class="c4">{አላህ ዘንድ የተወደደው ሃይማኖት እስልምና ነው።...}</span> <span class="c5">[ኣሊ-ዒምራን፡ 19]</span> </p>',
      ],
      2 => [
        'question' => 'ጥ 3፡ ነብይህ ማን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/280.mp3',
        'answer' => '<p> መልስ- ሙሐመድ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን ናቸው።<br /> የላቀዉ አላህ እንዲህ ብሏል፦ <span class="c4">{ሙሐመድ የአላህ መልክተኛ ናቸው...}</span> <span class="c5">[ሱረቱ አል-ፈትሕ፡ 29]</span> </p>',
      ],
      3 => [
        'question' => 'ጥ 4፡ ቃለ ተውሒድ የሚባለው ምንድን ነው እና ትርጓሜውስ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/310.mp3',
        'answer' => '<p> የተውሒድ ቃል የሚባለው "ላኢላሃ ኢላ አላህ" ነው። ትርጉሙም፦ ከአላህ በስተቀር በእውነት ሊመለክ የሚገባው አምላክ የለም ማለት ነው።<br /> የላቀዉ አላህ እንዲህ ብሏል፦ <span class="c4">{እነሆ ከአላህ በስተቀር እውነተኛ አምላክ አለመኖሩን እወቅ...}</span> <span class="c5">[ሱረቱ ሙሐመድ፡ 19]</span> </p>',
      ],
      4 => [
        'question' => 'ጥ 5፡ ልዕለ ኃያሉ አምላካችን አላህ የት ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/350.mp3',
        'answer' => '<p> ሐ - አላህ ሰማይ ላይ ከዓርሹ ከፍ ብሎ ከፍጡራን ሁሉ በላይ ነው ያለው። የላቀው አላህ እንዲህ ብሏል፦ {<span class="c2">(እርሱ)</span> አልረሕማን ነው በዐርሹ ላይ <span class="c2">(ለሱ ክብር በሚስማማ መልኩ)</span> ከፍ አለ።} <span class="c5">[ሱረቱ ጠሃ፡5]</span> እንዲህም ብሏል፦ <span class="c4">{እርሱም ከባሮቹ በላይ ሲሆን አሸናፊ ነው። እርሱም ጥበበኛው ውስጥ ዐዋቂው ነው። 18}</span> <span class="c5">[ሱረቱል አል-አንዓም፡ 18]</span> </p>',
      ],
      5 => [
        'question' => 'ጥ 6፡ መሐመድ የአላህ መልእክተኛ መሆናቸውን መመስከር ማለት ምን ማለት ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/380.mp3',
        'answer' => '<p> መልስ - ትርጉሙ፡- አላህ እሳቸውን አብሳሪና አስፈራሪ አድርጎ ለዓለማት የላካቸው መልዕክተኛው መሆናቸውን መመስከር ማለት ነው።<br /> በዚህ ያመነ የሚከተሉት ነገሮች ግዴታ ይሆኑበታል፦<br /> 1- ያዘዙትን መታዘዝ፤<br /> 2- የተናገሩትን አምኖ መቀበል፤<br /> 3- እርሳቸውን አለማመፅ፤<br /> 4- እሳቸው በደነገጉት ካልሆነ በቀር አላህ አለማምለክ ነው። ይኸውም ሱናቸውን በመከተል እና ቢድዓን በመተው ነው።<br /> የላቀው አላህ እንዲህ ብሏል፦ <span class="c4">{መልክተኛውን የሚታዘዝ ሰው በእርግጥ አላህን ታዘዘ።}</span> <span class="c2">(ሱረቱ-አንኒሳእ፡ 80)</span> ጥራት የተገባው አላህ እንዲህም ብሏል፦ {ከልብ ወለድም አይናገርም። እርሱ <span class="c2">(ንግግሩ)</span> የሚወርረድ ራእይ እንጅ ሌላ አይደለም። 4} <span class="c5">[ሱረቱ-ነጅም 3፡4]</span> ልዕለ ኃያሉ አላህ እንዲህ ብሏል፦ <span class="c4">{ለእናንተ አላህንና የመጨረሻውን ቀን የሚከጅል ለሆነ ሰው፣ አላህንም በብዙ ለሚያወሳ በአላህ መልዕክተኛ መልካም መከተል አልላችሁ።21}</span> <span class="c5">[ሱረቱል አሕዛብ፡ 21]</span> </p>',
      ],
      6 => [
        'question' => 'ጥ 7፡ የላቀው አላህ ለምንድን ነው የፈጠረን?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/480.mp3',
        'answer' => '<p> መልስ - የፈጠረን ተጋሪ ሳናደርግለት እርሱን ብቻ እንድንገዛው ነው።<br /> ለጨዋታ እና ለዛዛታ አልተፈጠርንም።<br /> የላቀዉ አላህ እንዲህ ብሏል፦ {ጂኒንና ሰውንም ሊግገዙኝ እንጅ ለሌላ አልፈጠርኳቸውም። <span class="c2">(56)</span>} <span class="c5">[ሱረቱ-አዝዛሪያት፡ 56]</span> </p>',
      ],
      7 => [
        'question' => 'ጥ 8: ዒባዳ /አምልኮ/ ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/530.mp3',
        'answer' => '<p> ሐ -ከንግግርም ይሁን ከተግባር፤ ድብቅም <span class="c2">(ውስጣዊ)</span> ይሁን ግልጽ አላህ የሚወደውን ሁሉ የተሰጠ ጥቅል የሆነ ስያሜ ነው።<br /> ግልጽ ሲባል፡- በአንደበት ተስቢሕ <span class="c2">(ሱብሐነላህ)</span>፣ ተሕሚድ <span class="c2">(አልሐምዱሊላህ)</span>፣ ተክቢራ <span class="c2">(አላሁ አክበር)</span> እያደረጉ እና ሶላትና ሐጅን እያከናወኑ አላህን ማውሳት ነው።<br /> ድብቅ <span class="c2">(ውስጣዊ)</span> ሲባል፦ ልክ እንደ ተወኩል <span class="c2">(በአላህ መመካት)</span> አላህን መፍራትና እና ተስፋን አላህ ላይ ማድረግን ያሉትን ነው። </p>',
      ],
      8 => [
        'question' => 'ጥ 9፡ ትልቁ ግዴታችን ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/580.mp3',
        'answer' => '<p> መልስ - ትልቁ ግዴታችን፡ የላቀው አላህን ብቸኛ አድርጎ ማምለክ ነው። </p>',
      ],
      9 => [
        'question' => 'ጥ 10፡ የተውሒድ ዓይነቶች ስንት ናቸው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/610.mp3',
        'answer' => '<p> መልስ-1- ተውሒድ አር-ሩቡቢያህ <span class="c2">(የጌትነት አሀዳዊነቱ)</span>፡- አላህ ብቸኛው የሁሉም ፈጣሪ፣ ለጋሽ፣ ባለቤትና ተቆጣጣሪ መሆኑን ማመን ነው።<br /> 2- ተውሒድ አል-ኡሉሂያ <span class="c2">(የአምልኮ አሀዳዊነቱ)</span>፡- በአምልኮ አላህን ብቻ ነጥሎ ማምለክ ነው። ከላቀው አላህ በስተቀር ማንም በሐቅ የሚመለክ የለም።<br /> 3- ተውሒዱል አስማእ ወስሲፋት <span class="c2">(በስምና ባህርያቱ ያለው አሀዳዊነት)</span>፡- በቁርአንና በሐዲሥ በተጠቀሱት የአላህ ስም እና ባህሪያቱ ያለ ምንም ምሳሌ መስጠት፣ ከፍጡራንም ጋ ሳያመሳስሉ እና ውድቅም ሳያደርጉ በቁርኣን እና ሱንና በተጠቀሰው መልኩ አምኖ መቀበል ነው።<br /> ለሶስቱ የተውሒድ ዓይነቶች ማስረጃው ተከታዩ የላቀው አላህ ቃል ነው፦ {<span class="c2">(እርሱ)</span> የሰማያትና የምድር በሁለቱም መካከል ላለው ሁሉ ጌታ ነውና ተገዛው። እርሱን በመገዛትም ላይ ታገስ። ለእርሱ ሞክሼን ታውቃለህን? 65} <span class="c5">[ሱረቱ መርየም፡ 65]</span> </p>',
      ],
      10 => [
        'question' => 'ጥ 11፡ ከባዱ ኃጢአት ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/670.mp3',
        'answer' => '<p> መልስ - በልዕለ ኃያሉ አምላካችን አላህ ላይ ሽርክ መፈፀም <span class="c2">(ማጋራት)</span> ነው።<br /> የላቀዉ አላህ እንዲህ ብሏል፦ {አላህ በእርሱ ማጋራትን በፍጹም አይምርም። ከዚህ ሌላ ያለውንም <span class="c2">(ኀጢአት)</span> ለሚሻው ሰው ይምራል። በአላህም የሚያጋራ ሰው ታላቅን ኀጢአት በእርግጥ ቀጠፈ።} <span class="c5">[ሱረቱ-አንኒሳእ፡ 48]</span> </p>',
      ],
      11 => [
        'question' => 'ጥ 12፡ የሽርክን ምንነትና ዓይነቶቹን ጥቀስ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/710.mp3',
        'answer' => '<p> መልስ- ሽርክ ማለት፦ የትኛውንም አይነት የአምልኮ መገለጫ ከላቀው አላህ ውጭ ላለ አካል አሳልፎ መስጠት ነው።<br /> ዓይነቶቹ፦<br /> ከባዱ ሽርክ ለምሳሌ፡- ከአላህ ውጭ ያለን አካል መማጸን ወይም ከርሱ ውጭ ላለ አካል መስገድ ወይም ከአሸናፊው አላህ ውጭ ላለ አካል እርድ ማቅረብ ነው።<br /> <span class="c2">(ትንሹ)</span> መለስተኛው ሽርክ ለምሳሌ፡- ከአላህ ውጭ ባለ አካል መማል፣ ወይም ክታቦችን <span class="c2">(ሕርዝ)</span> አልያም መሰል ነገራቶችን ጥቅምን ለማምጣት ወይም ጉዳትን ለመከላከል በሚል እምነት ማንጠልጠል፣ ጥቂትም ቢሆን ሪያእ፣ ማለትም <span class="c2">(ለይዩልኝ ብሎ መሥራት)</span> ለምሳሌ ሰዎች እያዩት እንደሆነ አስቦ ሶላትን ማሳመር ይመስል። </p>',
      ],
      12 => [
        'question' => 'ጥ 13፡ ከሀያሉ አምላክ በስተቀር የሩቅ ምስጢርን የሚያውቅ አለን?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/770.mp3',
        'answer' => '<p> መልስ - የሩቅን ምስጢር የሚያውቀው አላህ ብቻ ነው።<br /> የላቀዉ አላህ እንዲህ ብሏል፦ {«በሰማያትና በምድር ያለው ሁሉ ሩቅን ምስጢር አያውቅም። ግን አላህ <span class="c2">(ያውቀዋል)</span>። መቼ እንደሚቀሰቀሱም አያውቁም» በላቸው። 65} <span class="c5">[ሱረቱ-አን\'ነምል፡ 65]</span> </p>',
      ],
      13 => [
        'question' => 'ጥ 14፡ የእምነት ምሰሶዎች (አርካን) ስንት ናቸው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/810.mp3',
        'answer' => '<p> መ - 1- በላቀው አላህ ማመን<br /> 2 - በመላእክቱ ማመን<br /> 3- በመጻሕፍቱ ማመን<br /> 4- በመልዕክተኞቹ ማመን<br /> 5 - በመጨረሻው ቀን ማመን<br /> 6- በቀደር መልካምም ሆነ መጥፎ በሆነ <span class="c2">(የአላህ ቅድመ ውሳኔ)</span> ማመን ናቸው።<br /> ማስረጃውም፡- ጂብሪል ዐለይሂ ሰላም ነቢዩን - የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን - ስለ እምነት የጠየቀበት የታወቀው በሙስሊም ዘገባ ውስጥ የሚገኘው ሶሒሕ ሐዲሥ ይገኝበታል፤ በሐዲሡም ጅብሪል ነብዩን የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈንና ስለ ኢማን ሲጠይቃቸው እንዲህ ብለውታል፦ <span class="c1">“ስለኢማን ንገረኝ!”</span> አላቸው። እርሳቸውም \'በአላህ፣ በመላእክቶቹ፣ በመጻሕፍቱ ፣ በመልእክተኞቹ፣ በመጨረሻው ቀንና ልታምን እና በቀደር ክፉም ሆነ ደግ ልታምን ነው።\' አሉት።" </p>',
      ],
      14 => [
        'question' => 'ጥ 15፡ የእምነትን ምሰሶዎችን አብራራ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/900.mp3',
        'answer' => '<p> መልስ - በላቀው አላህ ማመን፡<br /> § አንተን የፈጠረህ፣ ሲሳይም የሚለግስህ፣ የፍጡራን ሁሉ ባለቤትና ገዥ አላህ መሆኑን ልታምን ነው።<br /> § በእውነት የሚመለከው እርሱው ነው፤ ከእርሱም ውጭ በእውነት ሊመለክ የሚገባው አምላክ የለም።<br /> § እርሱ ታላቅና ምሉዕ የሆነና ምስጋናም ሁሉ የተገባው ነው። ለእርሱም ውብ ስሞችና የላቁ ባህሪያት አሉት። ከፍጡራኑም ምንም ዓይነት ብጤም ሆነ አምሳያ የለውም።<br /> በመላእክቶች ማመን፡<br /> መላዕክት አላህ እርሱን እንዲያመልኩት ከብርሀን የፈጠራቸውና ለትእዛዙ ሙሉ በሙሉ ታዛዥ የሆኑ ፍጥረታት ናቸው።<br /> - ከእነርሱ መካከል ጂብሪል ዐለይሂ ሰላም የሚባል አለ፤ ለነብያት ራዕይን ይዞ የሚወርድ ነው።<br /> በመጻሕፍቱ ማመን፡<br /> ይህን ስንል አላህ ወደ መልእክተኞቹ ያወረዳቸው መጻሕፍቶችን ማለታችን ነው።<br /> በነብዩ ሙሐመድ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን ላይ የወረደውን ቁርኣን።<br /> በዒሳ የአላህ ሰላም በእርሳቸው ላይ ይስፈን ላይ በወረደው ኢንጅል።<br /> በሙሳ የአላህ ሰላም በእርሳቸው ላይ ይስፈን ላይ በወረደው ተውራትን።<br /> በዳውድ የአላህ ሰላም በእርሳቸው ላይ ይስፈን ላይ በወረደው ዘቡር።<br /> በኢብራሂም እና በሙሳ ዓለይሂማ ሰላም ላይ በወረደው ሱሑፍ።<br /> በመልዕክተኞች ማመን፡<br /> ማለት እነዚያ ባርያዎቹን እንዲያስተምሩ፣ በመልካም እና በጀነት እንዲያበስሩ፣ ከክፉና ከእሳትም እንዲያስጠነቅቁ አላህ ወደ ፍጡራኑ የላካቸው መልዕክተኞች ናቸው።<br /> ከመካከላቸው በላጮቹ፡- ኡሉ-ል-ዓዝም ሲሆኑ እነሱም፡-<br /> ኑሕ የአላህ ሰላም በእርሳቸው ላይ ይስፈን<br /> ኢብራሂም የአላህ ሰላም በእርሳቸው ላይ ይስፈን<br /> ሙሳ የአላህ ሰላም በእርሳቸው ላይ ይስፈን<br /> ዒሳ የአላህ ሰላም በእርሳቸው ላይ ይስፈን<br /> ነብዩ ሙሐመድ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን ናቸው።<br /> በመጨረሻው ቀን ማመን፡<br /> ይሀውም ሰዎች ከሞቱ በኋላ በመቃብር ውስጥ፣ በቂያማ ቀን፣ ከሞት በሚነሱበትና ፍርዳቸውንም በሚያገኙበት ቀን፣ የጀነት ሰዎች በመኖሪያቸው የጀሀነም ሰዎችም በመኖሪያቸው የሚሰፍሩበት ነው።<br /> በቀደር ክፉውም ሆነ ደጉን ማመን፡<br /> ቀደር፡- አላህ በአጽናፈ ዓለም ውስጥ የሚሆነውን ነገር ሁሉ እንደሚያውቅ፤ ያንንም በጥብቁ ሰሌዳ <span class="c2">(በለውሐል መሕፉዝ)</span> ላይ እንዳሰፈረው እና መገኘቱም ሆነ መፈጠሩ በእርሱ መሻት የሚከናወን መሆኑን ማመን ነው።<br /> የላቀው አላህ እንዲህ ብሏል፦ <span class="c4">{እኛ ሁሉን ነገር በልክ ፈጠርነው።}</span> <span class="c5">[ሱረቱል ቀመር 49]</span><br /> አራት እርከኖች አሉት፦<br /> የመጀመርያው እርከን፡ ጥራት የተገባው አላህ የሆነውንም የሚሆነውንም ሁሉ አስቀድሞ ጠንቅቆ የሚያውቅ መሆኑ<br /> ማስረጃው ተከታዩ የላቀው አላህ ቃል ነው፦ <span class="c4">{አላህ የሰዓቲቱ ዕውቀት እርሱ ዘንድ ብቻ ነው። ዝናብንም ያወርዳል። በማሕፀኖችም ውስጥ ያለን ሁሉ ያውቃል። ማንኛይቱ ነፍስም ነገ የምትሠራውን አታውቅም። ማንኛይቱ ነፍስም በየትኛው ምድር እንደምትሞት አታውቅም። አላህ ዐዋቂ ውስጠ ዐዋቂ ነው። 34}</span> <span class="c5">[ሉቅማን፡ 34]</span><br /> ሁለተኛው እርከን፡- አስቀድሞ የወሰነውንና የፈረደውን ሁሉ በለውሐል መሕፉዝ የመዘገበው መሆኑን ማመን ነው። በመሆኑም የተከሰተውም ይሁን የሚከሰተውም ሁሉ እርሱ ዘንድ ባለው መጽሐፍ ሰፍሯል።<br /> ማስረጃው ተከታዩ የላቀው አላህ ቃል ነው፦ {የሩቅ ነገርም መክፈቻዎች እርሱ ዘንድ ናቸው። ከእርሱ በቀር ማንም አያውቃቸውም። በየብስና በባሕር ያለውንም ሁሉ ያውቃል። ከቅጠልም አንዲትም አትረግፍም የሚያውቃት ቢሆን እንጅ። ከቅንጣትም በመሬት ጨለማዎች ውስጥ የለም ከእርጥብም ከደረቅም አንድም የለም ግልጽ በሆነው መጽሐፍ ውሰጥ <span class="c2">(የተመዘገበ)</span> ቢሆን እንጅ። 59} <span class="c5">[ሱረቱል አል-አንዓም 59]</span><br /> ሦስተኛው እርከን፡ ነገራቶችን ሁሉ እውን የሚሆኑት በእርሱ መሻት ነው። በመሆኑም በእርሱ ፈቃድ ካልሆነ በቀር ከእርሱም ሆነ ከፍጥረቱ የሚከሰት ምንም ዓይነት ነገር የለም።<br /> ማስረጃው ተከታዩ የላቀው አላህ ቃል ነው፦ {ከናንተ ቀጥተኛ መሆንን ለሻ ሰው <span class="c2">(መገሰጫ ነው)</span>። 28 የዓለማት ጌታ አላህ ካልሻም አትሹም። 29} <span class="c5">[ሱረቱ-አትተክዊር፡28-29]</span><br /> አራተኛው እርከን፡- ነገራቶችን ሁሉ የፈጠረው እርሱ መሆኑን ማመን ነው። ራሳቸውን፣ ባህሪያቸው፣ እንቅስቃሴዎቻቸውና በውስጣቸውም ያለውን ሁሉ የፈጠረው እርሱ ነው።<br /> ማስረጃው ተከታዩ የላቀው አላህ ቃል ነው፦ {<span class="c3">«አላህ እናንተንም የምትሠሩትንም የፈጠረ ሲሆን።»</span> 96} <span class="c5">[ሱረቱ-አስሷፍፋት 96]</span> </p>',
      ],
      15 => [
        'question' => 'ጥ 16፡ ቁርኣን ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/1300.mp3',
        'answer' => '<p> መልስ - ፍጡር ያልሆነ የኃያሉ አላህ ቃል ነው።<br /> የላቀዉ አላህ እንዲህ ብሏል፦ <span class="c4">{"ከአጋሪዎችም አንዱ ጥገኝነትን ቢጠይቅ፥ የአላህን ቃል ይሰማ ዘንድ አስጠጋው፤..."}</span> <span class="c5">[ሱረቱ አትተውባህ፡ 6]</span> </p>',
      ],
      16 => [
        'question' => 'ጥ 17፡ ሱና ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/1330.mp3',
        'answer' => '<p> መልስ - እያንዳንዱ የነብዩ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን ንግግር፣ ወይ ተግባር፣ ወይም እያወቁ ያጸደቁትን፣ ወይ ተፈጥሯዊ ወይም ባህሪያዊ መገለጫቸውን ሁሉ የሚያጠቃልል ነው። </p>',
      ],
      17 => [
        'question' => 'ጥ 18፡ ቢድዓህ ምንድን ነው? እንቀበለዋለንስ ወይ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/1350.mp3',
        'answer' => '<p> መልስ - በነብዩ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን እና በባልደረቦቻቸው ጊዜ ያልነበረ ሰዎች በሃይማኖት ላይ የፈለሰፉት አዲስ ፈሊጥ ሁሉ ቢድዓህ ይባላል።<br /> * ላመጣው ሰው እንመልስለታለን <span class="c2">(እናወግዘዋለን)</span> እንጅ አንቀበለውም።<br /> ምክንያቱም ነቢዩ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን እንዲህ ስላሉ፡- "ቢድዓ <span class="c2">(አዲስ ፈሊጥ)</span> ሁሉ ጥመት ነው።" አቡዳውድ ዘግበውታል።<br /> ለምሳሌ፡-<span class="c6"> በዒባዳ ላይ መጨመር:</span> ውዱእ ላይ ለአራተኛ ጊዜ ማጠብ እና የነብዩን የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን ልደት <span class="c2">(መውሊድ)</span> ማክበርን ፤ ይህ ሁሉ ተግባር ከነብዩ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን ይሁን ከባልደረቦቻቸው የተገኘ ምንም መሰረት የለውም። </p>',
      ],
      18 => [
        'question' => 'ጥ 19፡ የወላእ (ለኢስላም ሲባል የሚደረግ ወዳጅነት) እና የበራእ (ለኢስላም ሲባል የሚደረግ ጠላትነት) እምነትን አብራራ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/1410.mp3',
        'answer' => '<p> መልስ- ወላእ ሲባል፡- ምእመናንን መወዳጀትና መደገፍ ነው።<br /> የላቀዉ አላህ እንዲህ ብሏል፦ <span class="c4">{ምእምንና ምእምናትም ከፊሎቻቸው ለከፊሉ ረዳቶች ናቸው።}</span> <span class="c5">[ሱረቱ አትተውባህ፡ 71]</span><br /> አል በራእ ሲባል ደግሞ፡ ከሓዲያንን የኢስላም ጠላትነታቸውን አውቆ ጠላት አድርጎ መያዝ ነው።<br /> የላቀዉ አላህ እንዲህ ብሏል፦ {በኢብራሂምና በእነዚያ ከእርሱ ጋር በነበሩት <span class="c2">(ምእምናን)</span> መልካም መከተል አለቻችሁ። ለሕዝቦቻቸው <span class="c3">«እኛ ከእናንተ ከአላህ ሌላ ከምትግገዘትም ንጹሖች ነን። በእናንተ ካድን። በአላህ አንድ ብቻ ሲኾን እስከምታምኑ ድረስ በእኛና በእናንተ መካከል ጠብና ጥላቻ ዘወትር ተገለጸ።»</span> ባለ ጊዜ <span class="c2">(መልካም መከተል አለቻችሁ)</span>።} <span class="c5">[ሱረቱል ሙምተሒናህ፡ 4]</span> </p>',
      ],
      19 => [
        'question' => 'ጥ 20፡ አላህ ከእስልምና ውጭ ሌላ ሃይማኖትን ይቀበላልን?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/1480.mp3',
        'answer' => '<p> መልስ - አላህ ከእስልምና በስተቀር ሌላ ሃይማኖትን አይቀበልም።<br /> የላቀዉ አላህ እንዲህ ብሏል፦ <span class="c4">{ከኢስላም ሌላ ሃይማኖትን የሚፈልግ ሰው ፈጽሞ ከርሱ ተቀባይ የለውም። እርሱም በመጨረሻይቱ ዓለም ከከሳሪዎቹ ነው። 85}</span> <span class="c5">[ሱረቱ ኣሊ-ዒምራን፡ 85]</span> </p>',
      ],
      20 => [
        'question' => 'ጥ 21፡ ክህደት በንግግር፣ በተግባር እና በእምነት የሚገለፅ ነው፤ ለእነዚህ ምሳሌ የሚሆኑትን ግለጽ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/1520.mp3',
        'answer' => '<p> መልስ - በንግግር ለምሳሌ፡ ጥራት የተገባው አላህን ወይንም መልዕክተኛው የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈንን መስደብ።<br /> በተግባር ለምሳሌ፡- ቁርኣንን በተግባር ማቃለል ወይም ከአላህ ውጭ ላለ አካል መስገድን።<br /> በእምነት ለምሳሌ፡- ከኃያሉ አምላክ ሌላ ሊመለክ የሚገባው አካል እንዳለ ወይም ጥራት ይገባውና ከላቀው አምላካችን አላህ ጋ ሌላ አምላክ እንዳለ ማመንን። </p>',
      ],
      21 => [
        'question' => 'ጥ 22፡ ኒፋቅ ምንድን ነው? ዓይነቶቹስ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/1570.mp3',
        'answer' => '<p> መልስ-<br /> 1- ከባዱ ኒፋቅ፡- ላይ ላዩን አማኝ መስሎ ክህደትን በውስጥ መደበቅ ነው።<br /> ከእስልምና የሚያስወጣ ሲሆን ከከባዱ የክህደት ዓይነትም ነው።<br /> የላቀዉ አላህ እንዲህ ብሏል፦ <span class="c4">{መናፍቃን በእርግጥ ከእሳት በታችኛው አዘቅት ውስጥ ናቸው። ለእነሱም ረዳትን አታገኝላቸውም። 145}</span> <span class="c5">[ሱረቱ አንኒሳእ፡ 145]</span><br /> 2 -<span class="c6"> መለስተኛ ሙናፊቅነት:</span><br /> እንደ መዋሸት፣ ቃል ኪዳንን ማፍረስ እና እምነት መክዳት ያሉት ናቸው።<br /> ከእስልምና የሚያስወጣ ባይሆንም ባለቤቱን ለቅጣት የሚዳርግ ኃጢአት ነው።<br /> የአላህ መልዕክተኛ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን እንዲህ ብለዋል፦ "የሙናፊቅ ምልክቱ ሶስት ነው፤ ሲናገር ይዋሻል፣ ቃል ሲገባ ቃሉን ያፈርሳል፣ ሲታመን ይክዳል።" ቡኻሪይ እና ሙስሊም ዘግበውታል። </p>',
      ],
      22 => [
        'question' => 'ጥ 23፡ የነቢያትና መልክዕተኞች መደምደሚያ ማን ናቸው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/1680.mp3',
        'answer' => '<p> መልስ - ሙሐመድ ﷺ ናቸው።<br /> የላቀዉ አላህ እንዲህ ብሏል፦ <span class="c4">{ሙሐመድ ከወንዶቻችሁ የአንድም ሰው አባት አይደለም። ግን የአላህ መልክተኛና የነቢዮች መደምደሚያ ነው።...}</span> <span class="c5">[ሱረቱል አሕዛብ፡40]</span> የአላህ መልዕክተኛ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን እንዲህ ብለዋል፦ "እኔ የነብያቶች መደምደሚያ ነኝ፤ ከእኔ በኋላም ነብይ የለም።" አቡዳውድ እና ቲርሚዚይ እንዲሁም ሌሎችም ዘግበውታል። </p>',
      ],
      23 => [
        'question' => 'ጥ 24፡ ሙዕጂዛ (ተአምር) ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/1730.mp3',
        'answer' => '<p> መልስ- ሙዕጂዛ ማለት፡- ከተፈጥሮና ከተለምዶ ውጪ የሆኑ ለእውነተኝነታቸው ማስረጃ ይሆን ዘንድ አላህ ለነቢያቱ የሰጣቸው ተዓምር ነው።<br /> <span class="c2">(ለምሳሌ)</span> ለነብዩ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን ጨረቃ ለሁለት ተሰንጥቆላቸዋል።<br /> ለሙሳ <span class="c2">(ዐለይሂ-ሰላም)</span> ባሕሩን ተከፍሎ አሳልፎ ፈርዖንን እና ጭፍሮቹን ማስጠሙ። </p>',
      ],
      24 => [
        'question' => 'ጥ 25፡ ሶሓቦች እነማን ናቸው? እንውደዳቸውን?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/1780.mp3',
        'answer' => '<p> መልስ- ሶሓባ የሚባለው፡- ነብዩን የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን አማኝ ሆኖ አግኝቷቸው በእስልምና ላይ ሆኖ የሞተ ነው።<br /> ሶሓቦችን እንወዳቸዋለንም ፋናቸውንም እንከተላለን፤ እነርሱ ከነብያት በኋላ ከሰዎች ሁሉ በላጭ ናቸው።<br /> ከመካከላቸው በላጮቹ አራቱ ኸሊፋዎች <span class="c2">(ቅን ምትኮች)</span> ሲሆኑ እነርሱም፡-<br /> አቡበክር አላህ መልካም ሥራቸውን ይውደድላቸው<br /> ዑመር አላህ መልካም ሥራቸውን ይውደድላቸው<br /> ዑሥማን አላህ መልካም ሥራቸውን ይውደድላቸው<br /> ዐሊይ አላህ መልካም ሥራቸውን ይውደድላቸው </p>',
      ],
      25 => [
        'question' => '26፡ የምእመናን እናቶች እነማን ናቸው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/1870.mp3',
        'answer' => '<p> መልስ - የነብዩ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን ሚስቶች ናቸው።<br /> የላቀዉ አላህ እንዲህ ብሏል፦ <span class="c4">{ነቢዩ በምእምናን ከነፍሶቻቸው ይበልጥ ተገቢ ነው። ሚስቶቹም እናቶቻቸው ናቸው።}</span> <span class="c5">[ሱረቱል አሕዛብ፡ 6]</span> </p>',
      ],
      26 => [
        'question' => 'ጥያቄ 27፡ የነብዩ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን ቤተሰቦች በኛ ላይ ያላቸው መብት ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/1910.mp3',
        'answer' => '<p> መልስ - ልንወዳቸውና ልንወዳጃቸው እንዲሁም የሚጠላቸውንም ልንጠላ ነው። ይሁን እንጅ በነርሱ ጉዳይ ድንበር አናልፍም። እነርሱም የነብዩ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን ሚስቶችና ዝርያዎች፣ እንዲሁም አማኝ የሆኑት የሀሺም እና የአል-ሙጠሊብ ልጅ ልጆች ናቸው። </p>',
      ],
      27 => [
        'question' => 'ጥ 28፡ የሙስሊም መሪዎችን በተመለከተ ያለብን ግዴታ ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/1940.mp3',
        'answer' => '<p> መልስ- ግዴታችን፡- አላህንና መልዕክተኛውን እንድናምፅ እስካላዘዙን ድረስ እነርሱን ማክበርና መስማትና መታዘዝ እንዲሁም ለእነርሱ ዱዓእ ማድረግና በድብቅ መምከር ነው። </p>',
      ],
      28 => [
        'question' => 'ጥ 29፡ የምእመናን መኖርያ የት ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/1970.mp3',
        'answer' => '<p> መልስ- መኖርያቸው ጀነት ነው። የላቀው አላህ እንዲህ ብሏል፦ <span class="c4">{አላህ እነዚያን ያመኑትንና መልካም ሥራዎችን የሠሩትን በሥሮቻቸው ወንዞች የሚፈሱባቸውን ገነቶች ያገባቸዋል።...}</span> <span class="c5">[ሱረቱ ሙሐመድ፡ 12]</span> </p>',
      ],
      29 => [
        'question' => 'ጥ 30፡ የከሓዲያን መኖሪያ የት ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2000.mp3',
        'answer' => '<p> መልስ- መኖርያቸው እሳት ነው። የላቀው አላህ እንዲህ ብሏል፦ <span class="c4">{ያችን መቀጣጠያዋ ሰዎችና ድንጋዮች የሆነችውን እሳት ተጠበቁ፤ ለከሓዲዎች ተደግሳለች። 24}</span> <span class="c5">[ሱረቱል በቀራህ፡ 24]</span> </p>',
      ],
      30 => [
        'question' => 'ጥ 31፡ አላህን መፍራት ምንድን ነው? አላህ ላይ ተስፋ ማድረግ ሲባልስ ምንድን ነው? ማስረጃውስ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2020.mp3',
        'answer' => '<p> መልስ- አላህን መፍራት ሲባል፡- አላህን እና ቅጣቱን መፍራት ነው።<br /> ተስፋን አላህ ላይ ማድረግ ሲባል ደግሞ፡ የአላህን ምንዳ፣ ይቅር ባይነት እና ምሕረትን ተስፋ ማድረግ ነው።<br /> ማስረጃው ተከታዩ የላቀው አላህ ቃል ነው፦ {እነዚያ እነርሱ የሚግገዟቸው ማንኛቸውም <span class="c2">(ወደ አላህ)</span> በጣም ቀራቢያቸው ወደ ጌታቸው መቃረቢያን <span class="c2">(ሥራ)</span> ይፈልጋሉ። እዝነቱንም ይከጅላሉ። ቅጣቱንም ይፈራሉ። የጌታህ ቅጣት የሚፈራ ነውና።} <span class="c5">[ሱረቱል ኢስራእ፡ 57]</span> የላቀው አላህ እንዲህ ብሏል፦ {ባሮቼን እኔ መሓሪው አዛኙ እኔው ብቻ መኾኔን ንገራቸው። 49 ቅጣቴም እርሱ አሳማሚ ቅጣት መሆኑን <span class="c2">(ንገራቸው)</span>። 50} <span class="c5">[ሱረቱል ሒጅር፡ 49-50]</span> </p>',
      ],
      31 => [
        'question' => 'ጥ 32፡ የተወሰኑ የአላህን ስም እና ባህሪያቱን ጥቀስ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2070.mp3',
        'answer' => '<p> መልስ- አላህ፣ አር-ረብ፣ አር-ረሕማን፣ አስሰሚዕ፣ አል-በሲር፣ አል-ዓሊም፣ አል-ሓይ፣ አል-ዓዚም እና ሌሎችም እጅግ የተዋቡ ስሞችና የላቁ ባሕርያት አሉት። </p>',
      ],
      32 => [
        'question' => 'ጥ33፡ እነዚህን ስሞች አብራራ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2100.mp3',
        'answer' => '<p> መልስ- አላህ፡- ትርጉሙም ተጋሪ የሌለው ብቸኛው በእውነት የሚመለክ አምላክ ማለት ነው።<br /> አር-ረብ፡- ትርጉሙም ጥራት የተገባው አምላካችን አላህ ብቸኛው የሁሉም ፈጣሪ፣ ባለቤት፣ ሰጪና አስተናባሪው ማለት ነው።<br /> አስ-ሰሚዕ፡- የመስማት ችሎታው ሁሉንም ነገር የሚያካልል እና በዓይነትም በብዛት የተለያዩ የሆኑ ድምፆችን በሙሉ የሚሰማ ማለት ነው።<br /> አል-በሲር፡ ሁሉንም ነገር የሚያይ እና ትንሹም ይሁን ትልቁን ሁሉ የሚመለከት ነው።<br /> አል-ዓሊም፡ እውቀቱ ያለፈውን፣ የአሁኑንና የወደፊቱን ሁሉ ያካለለ ነው።<br /> አር-ረሕማን፡ እዝነቱ ለእያንዳንዱ ህያው ፍጡር ሁሉ የተዘረጋ ሲሆን ፍጡራን ሁሉ በእዝነቱ ስር ናቸው።<br /> አር-ረዛቅ፡- የሰውም፣ የጂንም እና የተንቀሳቃሽ ህያው ሁሉ ሲሳይ እርሱ ዘንድ የሆነ ነው።<br /> አል-ሓይ፡- የማይሞት ህያው የሆነ ነው። ፍጥረታት ሁሉ ሟች ናቸው።<br /> አል-ዓዚም፡ በስሙም በባህሪያቱም እንዲሁም በድርጊቶቹም ፍጹምነት እና ልዕልና ያለው ነው። </p>',
      ],
      33 => [
        'question' => 'ጥ 34፡ የሙስሊም ሊቃውንትን በተመለከተ ያለብን ግዴታ ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2210.mp3',
        'answer' => '<p> መልስ - እንወዳቸዋለን፤ ሸሪዓዊ ህግጋቶችን እና አጋጣሚዎችን በተመለከተ ከእውቀት አኳያ መመለሻችን እናደርጋቸዋለን፤ በጥሩ ነገር ካልሆነ በስተቀር አናነሳቸውም፤ እነርሱን በመጥፎ የሚያነሳቸውም መንገድ የሳተ እንደሆነ እናምናለን።<br /> የላቀዉ አላህ እንዲህ ብሏል፦ <span class="c4">{አላህ ከናንተ እነዚያን ያመኑትንና እነዚያንም ዕውቀትን የተሰጡትን በደረጃዎች ከፍ ያደርጋል። አላህም በምትሰሩት ሁሉ ውስጠ ዐዋቂ ነው። 11}</span> <span class="c5">[ሱረቱ አል-ሙጃዲላህ 11]</span> </p>',
      ],
      34 => [
        'question' => 'ጥ 35- የኃያሉ አላህ ወልዮች እነማን ናቸው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2240.mp3',
        'answer' => '<p> መልስ- እነርሱ ጥንቁቆቹ <span class="c2">(አላህን የሚፈሩ)</span> አማኞች ናቸው።<br /> የላቀዉ አላህ እንዲህ ብሏል፦ {ንቁ! የአላህ ወዳጆች በእነሱ ላይ ፍርሃት የለባቸውም፤ እነሱም አያዝኑም። 62 <span class="c2">(እነሱም)</span> እነዚያ ያመኑትና ይፈሩት የነበሩ ናቸው። 63} <span class="c5">[ሱረቱ ዩኑስ፡ 62-63]</span> </p>',
      ],
      35 => [
        'question' => 'ጥ 36፡ ኢማን ንግግርም ድርጊትም ነውን?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2280.mp3',
        'answer' => '<p> መልስ- ኢማን ንግግር፣ ተግባርም እምነትም ነው። </p>',
      ],
      36 => [
        'question' => 'ጥ 37፡ ኢማን የሚጨምር እና የሚቀንስ ነገር ነውን?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2310.mp3',
        'answer' => '<p> መልስ - ኢማን አላህን በመታዘዝ የሚጨምር እና አላህንም በማመፅ የሚቀንስ ነገር ነው።<br /> የላቀዉ አላህ እንዲህ ብሏል፦ <span class="c4">{ፍጹም ምእምናን እነዚያ አላህ በተወሳ ጊዜ ልቦቻቸው የሚፈሩት፣ በነሱም ላይ አንቀጾቻችን በተነበቡ ጊዜ እምነትን የሚጨምሩላቸው፣ በጌታቸውም ላይ ብቻ የሚመኩት ናቸው። 2}</span> <span class="c5">[ሱረቱል አንፋል፡ 2]</span> </p>',
      ],
      37 => [
        'question' => 'ጥ 38፡ ኢሕሳን ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2350.mp3',
        'answer' => '<p> መልስ - ኢሕሳን ማለት አላህን ልክ እንደምታየው ሆነህ ልታመልከው ነው፤ አንተ ባታየውም እርሱ ያይሀልና። </p>',
      ],
      38 => [
        'question' => 'ጥ 39፡ ሥራ አላህ ሱብሓነሁ ወተዓላ ዘንድ ተቀባይነት የሚያገኘው መቼ ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2370.mp3',
        'answer' => '<p> መልስ - ስራ ተቀባይነት የሚኖረው ተከታዮቹ ሁለት ቅድመ ሁኔታዎች ሲሟሉ ነው፦<br /> 1- ለላቀው አላህ ተብሎ የተሰራ ከሆነ <span class="c2">(ኢኽላስ)</span><br /> 2- እና በነብዩ ﷺ ሱና ከሆነ ነው <span class="c2">(ሙታበዓ)</span> </p>',
      ],
      39 => [
        'question' => 'ጥ 40፡ ተወኩልን በአላህ ላይ ማድረግ ማለት ምን ማለት ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2420.mp3',
        'answer' => '<p> መልስ - ተገቢውን ሰበብ ከማድረስ ጋር ጥቅሞችን ለማምጣት እና ጉዳትን ለመመከት በላቀው አላህ ላይ መመካት ነው።<br /> የላቀዉ አላህ እንዲህ ብሏል፦ <span class="c4">{በአላህም ላይ የሚጠጋ ሰው እርሱ በቂው ነው።...}</span> <span class="c5">[ሱረቱ ጦላቅ፡ 3]</span><br /> <span class="c4">{حَسْبُهُ}</span> ማለት ሌላ ሳያስፈልገው በቂው ነው ማለት ነው። </p>',
      ],
      40 => [
        'question' => 'ጥ 41፡ በመልካም ማዘዝ እና ከመጥፎ መከልከልን በተመለከተ ያለብን ግዴታ ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2470.mp3',
        'answer' => '<p> መልስ- አል-መዕሩፍ <span class="c2">(መልካም)</span> የሚባለው፡- አላህን እንዲታዘዙ መምከር ሲሆን፤ አል-ሙንከር የሚባለው ደግሞ አላህን ከማመፅ እንዲታቀቡ መገሰጽ ነው።<br /> የላቀዉ አላህ እንዲህ ብሏል፦ {ለሰዎች ከተገለጸች ሕዝብ ሁሉ በላጭ ሆናችሁ በጽድቅ ነገር ታዛላችሁ፤ ከመጥፎም ነገር ትከለክላላችሁ፤ በአላህም <span class="c2">(አንድነት)</span> ታምናላችሁ።...} <span class="c5">[ሱረቱ ኣሊ-ዒምራን፡ 110]</span> </p>',
      ],
      41 => [
        'question' => 'ጥ 42፡ አህሉ ሱና ወልጀማዐህ እነማን ናቸው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2510.mp3',
        'answer' => '<p> መልስ - አህሉ ሱና ወልጀማዓህ የሚባሉት ከንግግርም፣ ከተግባርም ይሁን ከእምነት አኳያ ነቢዩ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን እና ባልደረቦቻቸው በነበሩበት አቋም ላይ የሆኑት ናቸው።<br /> አህለ አስ-<span class="c6">ሱንናህ የተባሉት፡ የነቢዩን የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን ሱንና አጥብቀው በመከተላቸው እና ቢድዓን በመራቃቸው ሲሆን፤<br /> ወልጀማዓህ የተባሉት ደግሞ:</span> በእውነት ላይ አንድ ዓይነት አቋም ስላላቸውና በዛም ያልተለያዩ በመሆናቸው ነው። </p>',
      ],
    ],
    2 => [
      0 => [
        'question' => 'ጥ1: ጠሃራ ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2580.mp3',
        'answer' => '<p> መልስ- ጠሃራ <span class="c2">(ንጽህና)</span> ማለት፡- ሐደሥን እና ቆሻሻን ማስወገድ ነው።<br /> ጠሃረቱል ኸበሥ <span class="c2">(ቆሻሻን የማስወገድ ንጽህና)</span>፡- ይህም ማለት ሙስሊሙ በሰውነቱ፣ በልብሱ፣ ወይም በሚሰግድበት ቦታና ዙርያ ያረፈ ነጃሳ ነገርን ማስወገዱ ነው።<br /> ጠሀረቱል ሐደሥ <span class="c2">(ከርኩሰት ለመጽዳት የሚደረግ ንጽህና)</span>፡- ይህም ማለት ውዱእ ማድረግን ወይም ገላ መታጠብን የሚያስገድድ ነው፤ ውሃ በታጣ ወይም መጠቀም ባልተቻለ ጊዜ ደግሞ ተየሙም ማድረግን የሚጠይቅ የንጽህና ዓይነት ነው። </p>',
      ],
      1 => [
        'question' => 'ጥ 2፡ ነጃሳ የነካውን ነገር እንዴት ማጽዳት ይቻላል?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2630.mp3',
        'answer' => '<p> መልስ- ንፁህ እስኪሆን ድረስ በውሃ በማጠብ ይፀዳል።<br /> - ይሁን እንጅ ነጃሳው የውሻ ለሀጭ ከሆነ የመጀመሪያውን በአፈር አድርጎ ሰባት ጊዜ መታጠብ ይጠበቅበታል። </p>',
      ],
      2 => [
        'question' => 'ጥ 3፡ የውዱእ ትሩፋቶችን ግለፅ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2660.mp3',
        'answer' => '<p> መልስ - ነብዩ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን እንዲህ ብለዋል፦ "አንድ ሙስሊም ባሪያ" - ወይም "አማኝ የሆነ ሰው" - "ውዱእ በሚያደርግበት ጊዜ ፊቱን ሲያጥብ በዓይኑ የተመለከተው ኃጢአት ሁሉ ከፊቱ ከውኋው ጋር አብሮ ይፀዳለታል።” - ወይም <span class="c1">“ከመጨረሻው የውሃ ጠብታ ጋር አብሮ ይራገፍለታል።”</span> - <span class="c1">“እጁን ሲታጠብም እንዲሁ እጆቹ እየዳሰሰች የፈፀመችው ኋጢአት ከውኋው ጋር አብሮ ይፀዳለታል።" - ወይም “ከመጨረሻው የውሃ ጠብታ ጋር አብሮ ይራገፍለታል።”</span> - <span class="c1">“እግሩን ሲታጠብም እንዲሁ እግሮቹ ስትራመድ የፈፀመችው ኋጢአት ከውኋው ጋር አብሮ ይፀዳለታል።" - ወይም “ከመጨረሻው የውሃ ጠብታ ጋር አብሮ ይራገፍለታል።”</span> - “ልክ እንደዚሁ እያለ ከኃጢአት ንጹሕ እስኪሆነ ድረስ ይፀዳል።" ሙስሊም ዘግበውታል። </p>',
      ],
      3 => [
        'question' => 'ጥ 4፡ እንዴት ነው ውዱእ የምታደርገው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2690.mp3',
        'answer' => '<p> መልስ - እጆችን ሶስት ጊዜ ማጠብ።<br /> ሶስት ጊዜ መግመጥሞጥ እና ውኋ ወደ አፍንጫ ውስጥ ሳብ አድርጎ አፍንጫን አጥርቶ ውኋውን ወደ ውጭ መመለስ።<br /> አፍን መግመጥሞጥ፡-<span class="c6"> ውሃን በአፍ ውስጥ አስገብቶ ውኋውን ማማታትና ከዚያም መትፋት ነው።<br /> "ኢስቲንሻቅ" ሲባል:</span> ውሃውን በቀኝ እጅ ይዞ በአየር ወደ አፍንጫው ውስጥ መሳብ ነው።<br /> "ኢስቲንሣር" ሲባል ደግሞ: "ኢስቲንሻቅ" ሲያደርጉ ወደ አፍንጫ የሳቡትን ውኋ በግራ እጅ ወደ ውጭ ማስወጣት ነው።<br /> ከዚያም ፊትን ሦስት ጊዜ ማጠብ<br /> ከዚያም እጆችን እስከ ክርኖች ድረስ ሶስት ጊዜ ማጠብ<br /> ከዚያም ጭንቅላትን ማበስ፤ በሁለቱ እጆች ከግንባር ተነስቶ ወደ ማጅራት አብሶ ወደ ግንባር በመመለስ ካበሱ በኋላ ጆሮዎችን ማበስ ነው።<br /> ከዚያም እግርን እስከ ቁርጭምጭሚት ድረስ ሶስት ጊዜ ማጠብ<br /> ይህ የተሟላ የሆነው የውዱእ አደራረግ ሲሆን ይህም ከነቢዩ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን ዑሥማን፣ ዐብዱላህ ቢን ዘይድ እና ሌሎችም ያስተላለፉ እንዲሁም በቡኻሪይ እና ሙስሊም የተዘገበ ሐዲሥ ላይ የተገለጸ ነው። እንዲሁም በቡኻሪይ እና በሌሎችም ዘገባዎች እንዲህ መባሉ ተረጋግጧል፡- <span class="c1">“አንድ አንድ ጊዜም ውዱእ አድርገዋል፤ ሁለት ሁለት ጊዜም ውዱእ አድርገዋል።”</span> ማለትም፡ እያንዳንዱን የውዱእ ክፍል አንድ አንድ ጊዜም ሁለት ሁለት ጊዜም እያጠቡ ውዱእ ያደርጉ ነበር ነው። </p>',
      ],
      4 => [
        'question' => 'ጥ 5፡ የውዱእ ግዴታዎች ምን ምን ናቸው? ቁጥራቸውስ ስንት ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2810.mp3',
        'answer' => '<p> መልስ - እነዚህ የትኛውም ሙስሊም ውዱእ ሲያደርግ አንዱንም ቢተው ያደረገው ውዱእ ትክክል የማይሆነለት ነው።<br /> 1- ፊትን መታጠብ መጉመጥመጥ እና አፍንጫን ጨምሮ ማጠብ ፤<br /> 2- እጅን እስከ ክርኖች ማጠብ፤<br /> 3- ጆሮን ጨምሮ ጭንቅላትን ማበስ፤<br /> 4- እግርን እስከ ቁርጭምጭሚት ድረስ ማጠብ፤<br /> 5-<span class="c6"> በውዱእ አካላት መካከል ያለውን ቅደም ተከተል መጠበቅ:</span> ማለትም ፊትን ማጠብ፤ ከዚያም እጆችን ማጠብ፤ ከዚያም ጭንቅላትን ማበስና ከዚያም እግሮችን ማጠብ ነው።<br /> 6- ማከታተል፡- ማለትም ውዱእ ሲያደርጉ ከአንደኛው የውዱእ አካል ወደ ሌላኛው ሲሸጋገሩ አካላቱ እስኪደርቅ ድረስ ሳይዘገዩ ማከታተል ነው።<br /> - ማለትም ግማሹን የዉዱእ አካላት አዳርሰው ዘግይቶ ከቆይታ በኋላ ወደሌላኛው አካል መሸጋገሩ ዉዱኡ ትክክለኛ እንዳይሆን ያደርገዋል። </p>',
      ],
      5 => [
        'question' => 'ጥ 6፡ የውዱእ ሱናዎች ምን ምን ናቸው? ቁጥራቸውስ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2910.mp3',
        'answer' => '<p> መልስ - የዉዱእ ሱናዎች የሚባሉት፡- ከሰሩት ተጨማሪ አጅር እና ምንዳን የሚያስገኝ ሲሆን ካልሰሩት ግን ወንጀል አይደለም ዉዱኡም ትክክል ነው።<br /> 1 - "ቢስሚላህ" ብሎ በአላህን ስም መጀመር<br /> 2- ሲዋክ መጠቀም <span class="c2">(ጥርስን መፋቅ)</span><br /> 3 - የእጅ መዳፎችን ማጠብ<br /> 4- ጣቶችን ፈልፍሎ ማጠብ<br /> 5- የአካል ክፍሎችን ሲያጥቡ ሁለተኛና ሦስተኛ ጊዜ መድገም<br /> 6- በቀኝ መጀመር<br /> 7- ከዉዱእ በኋላ የሚከተለውን ዚክር ማለት፡-<span class="c6"> "አሽሀዱ አን ላኢላሃ ኢለሏህ ወሕደሁ ላ ሸሪከ ለሁ ወአሽሀዱ አነ ሙሐመደን ዐብዱሁ ወረሱሉህ" ትርጉሙም:</span> ከአላህ በስተቀር በእውነት የሚገዙት አምላክ እንደሌለና ተጋሪ የሌለው ብቸኛ መሆኑን እመስክራለሁ፤ ሙሀመድም የአላህ መልዕክተኛው እና ባሪያው መሆናቸውንም እመስከራለሁ።<br /> 8- ከኋላው ሁለት ረከዓ መስገድ </p>',
      ],
      6 => [
        'question' => 'ጥ 7፡ ውዱእን የሚያበላሹ ስንት ናቸው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3020.mp3',
        'answer' => '<p> መልስ- ከፊት እና ከኋላ ካሉ ሁለቱ ቀዳዳዎች የሚወጣ እንደ ሽንት፣ ሰገራ ወይም ንፋስ ያለ ነገር ሁሉ፤<br /> እንቅልፍ መተኛት፣ እብደት ወይም ራስን መሳት፤<br /> የግመል ሥጋ መብላት፤<br /> ያለግርዶሽ ብልትን ወይም ፊንጢጣን በእጅ መንካት፤ </p>',
      ],
      7 => [
        'question' => 'ጥ 8፡ ተየሙም ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3080.mp3',
        'answer' => '<p> መልስ- ተየሙም ማለት፡- ውሃ ሲጠፋ ወይም መጠቀሙ በማይመችበት ጊዜ አፈር ወይም ሌላ የምድር አካልን በውኋ ምትክ መጠቀም ነው። </p>',
      ],
      8 => [
        'question' => 'ጥ9፡ ተየሙም የሚደረገው እንዴት ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3110.mp3',
        'answer' => '<p> መልስ- አፈሩን አንድ ጊዜ በመዳፍ እጅ መታ አድርጎ የእጆችን ጀርባ እና ፊትን ማበስ ነው። </p>',
      ],
      9 => [
        'question' => 'ጥ10፡ ተየሙም የሚፈርሰው በምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3140.mp3',
        'answer' => '<p> መልስ- ውዱእን የሚያፈርሱ ነገሮች ሁሉ፤<br /> እና ውሃ ከተገኘ </p>',
      ],
      10 => [
        'question' => 'ጥ 11፡ ኹፎች እና ካልሲዎች ምንድን ናቸው? በእነርሱ ላይ ይታበሳልን?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3180.mp3',
        'answer' => '<p> መልስ- ኹፍ የሚባለው፡- እግር ላይ የሚለበስ ሆኖ ከቆዳ የተሰራ ነው።<br /> ካልሲ፡- ከቆዳ ውጪ በሆነ ነገር የተሰራ ሆኖ እግር ላይ የሚለበስ ነው።<br /> እግሮችን በማጠብ ፋንታ እነርሱ ላይ ማበስ የተደነገገ ነው። </p>',
      ],
      11 => [
        'question' => 'ጥ 12 - ኹፎች ላይ ማበስ ጥበቡ ምን እንደሆነ ግለፁ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3230.mp3',
        'answer' => '<p> መልስ - በተለይም በቀዝቃዛ በክረምት እና በጉዞ ወቅት በእግር ላይ የተጠለቀውን ነገር ማውለቁ አስቸጋሪ በሚሆንበት ጊዜ አላህ ለባርያዎቹ የደነገገላቸው ማግራራት እና ማቅለል ነው። </p>',
      ],
      12 => [
        'question' => 'ጥ 13- በኹፍ ላይ ማበሱ ትክክለኛ እንዲሆን መሟላት ያለባቸው ቅድመ ሁኔታዎች ምንድን ናቸው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3260.mp3',
        'answer' => '<p> መልስ-1- ኹፉን የሚለብሰው ጠሃራ ሆኖ ማለትም ከውዱእ በኋላ መሆን አለበት።<br /> 2- ኹፎቹ ጠሃራ መሆን አለባቸው፤ ነጃሳ ላይ ማበስ አይፈቀድምና።<br /> 3- ኹፎቹ ውዱእ ሲደረግ መታጠብ ያለበትን ቦታ የሚሸፍኑ መሆን አለባቸው።<br /> 4- ማበሱ በተወሰነለት የጊዜ ገደብ ውስጥ መሆን አለበት፤ መንገደኛ ላልሆነ ነዋሪ፡ አንድ ቀን ከነሌሊቱ፤ መንገደኛ ደግሞ፡- ሶስት ቀናት ከነሌሊቱ ባለው ጊዜ ውስጥ ማበስ ይችላል። </p>',
      ],
      13 => [
        'question' => 'ጥ 14- በኹፍ ላይ ማበስ አኳኋኑ እንዴት ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3320.mp3',
        'answer' => '<p> መልስ- በኹፍ ላይ የማበስ አኳኋኑን በተመለከተ፡- የእጆቹን ጣቶች በውሃ በመንከር ከእግሩ ጣቶች ጀምሮ ወደ ተረከዙ ማበስ ነው። ሲያብስም የቀኝ እግሩን በቀኝ እጁ የግራ እግሩን ደግሞ በግራ እጁ ነው የሚያብሰው። በሚያብስበት ጊዜ ጣቶቹን ከፈት ያድርግ፤ መደጋገም አይጠበቅበትም። </p>',
      ],
      14 => [
        'question' => 'ጥ 15- በኹፍ ላይ የታበሰን የሚያፈርሰው ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3350.mp3',
        'answer' => '<p> መልስ - 1 -<span class="c6"> በኹፍ ላይ የማበስ ጊዜ ማብቂያው:</span> መንገደኛ ላልሆነ ነዋሪ አንድ ቀን ከነሌሊቱ ለመንገደኛ ደግሞ ሶስት ቀን ከነሌሊቱ ባልነው መሰረት በሸሪዓ የተወሰነውን የማበሻ ጊዜ ካለፈ በኋላ ኹፉ ላይ የማበሻ ጊዜው ያልቃል።<br /> 2 -<span class="c6"> ኹፎቹን ማውለቅ:</span> አንድ ሰው ኹፎቹን ወይም አንዳቸውን ካበሰባቸው በኋላ ካወለቀ በላዩ ላይ ያበሰውም አብሮ ይፈርሳል። </p>',
      ],
      15 => [
        'question' => 'ጥ 16፡ ሰላት ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3390.mp3',
        'answer' => '<p> መልስ- ሰላት፡- በተክቢራ ተጀምሮ በሰላምታ የሚጠናቀቅ በውስጡም ልዩ የሆኑ ንግግሮችንና ተግባራትን ባካተተ መልኩ አላህን ማምለክ ነው። </p>',
      ],
      16 => [
        'question' => 'ጥ 17፡ የሰላት ብይን ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3420.mp3',
        'answer' => '<p> መልስ- ሰላት በሁሉም ሙስሊም ላይ ግዴታ ነው።<br /> የላቀዉ አላህ እንዲህ ብሏል፦ <span class="c4">{ሰላት በምእምናን ላይ በጊዜያት የተወሰነ ግዴታ ነው። 103}</span> <span class="c5">[ሱረቱ-ኒሳእ፡ 103]</span> </p>',
      ],
      17 => [
        'question' => 'ጥ 18፡ አለመስገድ ብይኑ ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3460.mp3',
        'answer' => '<p> መልስ - ሰላትን መተው ክህደት ነው። ነብዩ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን እንዲህ ብለዋል፡- "በእኛና በነሱ መካከል ያለው ቃል ኪዳን ሰላት ነው። <span class="c2">(በመሆኑም)</span> ሰላትን የተወ ሰው በእርግጥ ክዷል።" ኢማሙ አሕመድና ቲርሚዚይ እንዲሁም ሌሎችም ዘግበውታል። </p>',
      ],
      18 => [
        'question' => 'ጥ 19- አንድ ሙስሊም በቀንና በሌሊት የሚሰግደው ስንት ግዴታ ሶላት አለበት? እያንዳንዱ ሶላትስ ስንት ስንት ረከዓዎች አሉት?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3500.mp3',
        'answer' => '<p> መልስ - ሙስሊምበቀንና በሌሊት አምስት ሶላቶችን የመስገድ ግዴታ አለበት። የፈጅር ሶላት ሁለት ረከዓዎች፣ የዙህር ሶላት አራት ረከዓዎች፣ የዐስር ሶላት አራት ረከዓዎች፣ የመግሪብ ሶላት ሶስት ረከዓዎች እና የዒሻ ሶላት አራት ረከዓዎች። </p>',
      ],
      19 => [
        'question' => 'ጥ 20፡ የሶላት ቅድመ መስፈርቶች ስንት ናቸው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3530.mp3',
        'answer' => '<p> መልስ - 1- ሙስሊም መሆን፤ ከካፊር ተቀባይነት የለውም።<br /> 2-<span class="c6"> አእምሮ ጤናማ መሆን:</span> የእብድ ሰላት ትክክል አይደለም።<br /> 3-<span class="c6"> መለየት መቻል:</span> የጨቅላ ህፃን ወይም ጥሩውን ከመጥፎ የማይለይ ሰው ሰላቱ ትክክለኛ አይደለም።<br /> 4 - ኒያ<br /> 5 - የሰላት ወቅቱ መግባት፤<br /> 6 - ከየትኛውም ዓይነት ሐደሥ ነጹህ መሆን፤<br /> 7- ከነጃሳ መፅዳት፤<br /> 8- ሀፍረተ ገላን መሸፈን፤<br /> 9- ቂብላን መቅጣጨት ናቸው። </p>',
      ],
      20 => [
        'question' => 'ጥ 21፡ የሶላት አርካን (ምሰሶዎች) ብዛት ስንት ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3640.mp3',
        'answer' => '<p> መልስ - እንደሚከተለው አሥራ አራት ምሰሶዎች ናቸው፦<br /> አንዱ፡- በተቻለ መጠን መቆም፤<br /> ተክቢረቱል ኢሕራም፡ ይኸውም "አላሁ አክበር" ማለት ነው።<br /> ፋቲሓ <span class="c2">(አልሓምዱ)</span>ን መቅራት፤<br /> ጀርባን ለጥ አድርጎ በመዘርጋት እና ጭንቅላትንም በስትክክል አድርጎ ሩኩዕ ማድረግ <span class="c2">(መጎንበስ)</span>፤<br /> ከሩኩእ መነሳት፤<br /> ተስተካክሎ መቆም፤<br /> ግንባርን፣ አፍንጫን፣ መዳፎችን፣ ሁለቱን ጉልበቶች እና የሁለቱን እግሮች ጣቶችን አስተካክሎ መሬት ላይ አድርጎ ሱጁድ ማድረግ፤<br /> ከሱጁድ ቀና ማለት፤<br /> በሁለቱ ሱጁዶች መካከል መቀመጥ፤<br /> የአቀማመጡ ሱናው፡ ቀኝ እግርን ቀጥ አድርጎ ተክሎ የእግርን ጣቶች ደግሞ ወደ ቂብላ ካቅጣጩ በኋላ በግራ እግር የውስጠኛው ክፍል ላይ መቀመጥ።<br /> መረጋጋት: ይሀውም በእያንዳንዱ ምሰሶም ይሁን ድርጊት ላይ መረጋጋት፤<br /> የመጨረሻው ተሸሁድ፤<br /> ለተሸሁዱ መቀመጥ፤<br /> ወደሁለቱም አቅጣጫ ማሰላመት: ይሀውም ሁለት ጊዜ፡- “አሰላሙ ዐለይኩም ወረሕመቱላህ" እያሉ ነው።<br /> ሩክኖችን - በጠቀስነው መልኩ -<span class="c6"> ማከታተል:</span> ለምሳሌ ሆን ብሎ ሩኩዕ ሳያደርግ ሱጁድ ቢያደርግ ሶላቱ ውድቅ ይሆናል። ተዘናግቶ ከሆነ ግን ተመልሶ ሩኩዕ ካደረገ በኋላ ከዚያም ሱጁድ ያደርጋል። </p>',
      ],
      21 => [
        'question' => 'ጥ 22፡ የሰላት ግዴታዎችን ጥቀስ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3820.mp3',
        'answer' => '<p> መልስ -<span class="c6"> የሰላት ግዴታዎች እንደሚከተለው ስምንት ናቸው:</span><br /> 1- ከተክቢረተል ኢሕራም ውጭ ያሉ ተክቢራዎች፤<br /> 2- ኢማም ለሆነና ብቻውን ለሚሰግድ ሰው "ሰሚዐላሁ ሊመን ሓሚደህ" ማለቱ "ትርጉሙም፦ "አላህ የሚያመሰግኑትን ይሰማል" ነው፤<br /> 3 - "ረበና ወለከል ሓምድ" ይበል ትርጉሙም፡ <span class="c1">“ጌታችን ሆይ! ምስጋና ላንተ ይሁን።”</span> ነው፤<br /> 4 - <span class="c3">«ሱብሓነ ረቢየል ዓዚም»</span> ይበል ትርጉሙም፦ <span class="c1">“ጥራት ይገባው ለታላቁ ጌታዬ" ነው፤<br /> 5 - <span class="c3">«ሱብሓነ ረቢየል አዕላ»</span> ይበል ትርጉሙም “ጥራት ይገባው ለላቀው ጌታዬ”</span> ነው፤<br /> 6 - <span class="c3">«ረቢ-ግ-ፊርሊ»</span> ይበል ትርጉሙም <span class="c1">“ጌታዬ ሆይ！ማረኝ”</span> ነው፤<br /> 7- የመጀመሪያው ተሸሁድ፤<br /> 8- ለመጀመሪያው ተሸሁድ መቀመጥ፤ </p>',
      ],
      22 => [
        'question' => 'ጥ 23፡ የሶላት ሱናዎች ምን ምን ናቸው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3930.mp3',
        'answer' => '<p> መልስ- እንደሚከተለው አስራ አንድ ናቸው፦<br /> 1 -<span class="c6"> ከተክቢረተል ኢሕራም በኋላ እንዲህ ማለት:</span> የመክፈቻውን ዱዓእ <span class="c2">(ዱዓኡል ኢስቲፍታሕ)</span> እንዲህ ማለት፡- <span class="c3">«ሱብሓነከሏሁም ወቢሓምዲከ ወተባረከ ኢስሙከ ወተዓላ ጀዱከ ወላኢላሀ ገይሩክ»</span> <span class="c5">[ትርጉሙም ጥራትና ልቅና ለአንተ ይሁን አምላኬ ሆይ ምስጋናም ለአንተ ይሁን፤ ስምህም የላቀ ነው፤ ግርማህም ከፍ ከፍ ይበል፤ ካንተ በቀርም አምላክ የለም። ማለት ነው]</span><br /> 2 - <span class="c3">«አዑዙ ቢላሂ ሚነ ሸይጧኒ ረጂም»</span> ማለት፤<br /> 3 - ቢስሚላህ፤<br /> 4 - አሚን ማለት፤<br /> 5- ከአል-ፋቲሐ በኋላ ተጨማሪ ሱራን መቅራት፤<br /> 6- የኢማሙ ጮክ ብሎ መቅራት፤<br /> 7- ከምስጋናው <span class="c2">(ሰሚዐሏሁ ሊመን ሓሚደህ ካሉ)</span> በኋላ እንዲህ ማለት፡- ”ሚልኡ ሰማዋቲ ወሚልኡል አርዲ ወሚልኡ ማሺእተ ሚን ሸይኢን ባዕዱ<span class="c1">“ ትርጉሙም: "ምስጋና በሰማያት ሙሉ በምድር ሙሉ ላንተ ይሁን፤ ከዚያም በኋላ በወደደህ ነገር ሙሉም ምስጋና ላንተ ይሁን።"<br /> 8- በሩኩዕ ጊዜ ከሚደረገው ተስቢሕ ወይንም ሁለተኛውና ሦስተኛው ተስቢሕ ከዚያም በላይ መጨመር<br /> 9- በሱጁድ ጊዜ ከአንድ ጊዜ በላይ የሚደረገው ተስቢሕ፤<br /> 10 - በሱጁዶች መካከል ከአንድ ጊዜ በላይ “ረቢ-ግ-ፊርሊ”</span> ማለት:<br /> 11 - በመጨረሻው ተሸሁድ በሳቸውም በቤተሰቦቻቸውም የአላህ ሰላት እና ሰላም እንዲሁም በረካ እንዲሰፍን ከተማፀነ በኋላ ያሻውን ዱዓእ ያድርግ።<br /> አራተኛ፡ ድርጊታዊ የሚባሉ ሱና የሆኑ ድርጊቶች፡-<br /> 1- ተክቢረተል ኢሕራም እያደረጉ እጆችን ወደ ላይ ማንሳት፤<br /> 2 - በሩኩዕም ጊዜ <span class="c2">(እጆችን ማንሳት)</span>፤<br /> 3 - ከሩኩዕ ቀና ሲሉም <span class="c2">(እጆችን ማንሳት)</span>፤<br /> 4- ከዚያም በኋላ እጆችን አስተካክሎ ማስቀመጥ፤<br /> 5- የቀኝ እጅን በግራ እጅ ላይ ደርቦ ማስቀመጥ፤<br /> 6- ሱጁድ ወደሚያደርጉበት ቦታ መመልከት፤<br /> 7- ሲቆም በእግሮች መካከል ከፈት አድርጎ መቆም፤<br /> 8- የሁለቱ እጆች ጣቶችን ፈታ አድርጎ ጉልበትን በመያዝ፤ ጀርባን ቀጥ በማድረግ ጭንቅላትንም በጀርባ ትይዩ አድርጎ ሩኩዕ ማድረግ<span class="c2">(መጎንበስ)</span>፤<br /> 9- የሱጁድ አካላትን በመሬት ላይ አመቻችቶ እያንዳንዱ ክፍል መሬት እንዲነካ በማድረግ ሱጁድ መውረድ፤<br /> 10 -<span class="c6"> አካላትን ማራራቅ:</span> እጆችን ከጎድን፣ ሆድን ከጭኖች፣ ጭኖችን ከተረከዞች መለየት፤ እንዲሁም ጉልበቶችን ከፈት ማድረግ፤ ተረከዞችን ቀጥ አድርጎ መትከል፤ የእግር ጣቶችን ውስጠኛው ክፍል ለያይቶ መሬት ላይ ማድረግ፤ ሁለት እጆችን ጣቶቻቸውን ገጥሞ በመዘርጋት በትከሻ ትይዩ ማድረግ፤<br /> 11- በሁለቱ ሱጁዶች መካከል እና ለመጀመሪያው ተሸሁድ ሲቀመጡ "ኢፍቲራሽ" አድርጎ መቀመጥ እና በሁለተኛው ተሸሁድ ደግሞ "ተወሩክ" በሚባለው አቀማመጥ መቀመጥ፤<br /> 12- በሁለቱ ሱጁዶች መካከል ሲቀመጡ እጆችን ጣቶቻቸውን ገጥሞ በመዘርጋት ጭን ላይ ማድረግ ነው። ምናልባት ትንሿን ጣት እና ቀለበት ጣትን ጨብጦ የመሀል ጣትን ከአውራ ጣት ጋር አብሮ ክብ እንዲሰሩ ማድረግ፤ በተሸሁድም አቀማመጡ እንዲሁ ነው።<br /> 13- አሰላሙ ዐለይኩም ወረሕመቱላህ በሚልበት ጊዜ ወደቀኝና ወደ ግራ መዞር፦ </p>',
      ],
      23 => [
        'question' => 'ጥ 24፡ ሰላትን የሚያበላሹ ነገሮች ብዛት ስንት ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/4210.mp3',
        'answer' => '<p> መልስ- <span class="c2">(1)</span> ከሰላት ቅድመ ሁኔታዎች ወይም ማዕዘናት መካከል አንዱንም ቢሆን መተው፤<br /> <span class="c2">(2)</span> ሆን ብሎ መናገር፤<br /> <span class="c2">(2)</span> ሆን ብሎ መብላት ወይም መጠጣት፤<br /> <span class="c2">(2)</span> ተከታታይ ተደጋጋሚ እንቅስቃሴ፤<br /> <span class="c2">(2)</span> ሆን ብሎ ከሰላት ግዴታዎችን አንዱን መተው፤ </p>',
      ],
      24 => [
        'question' => 'ጥ 25: ሙስሊም የሆነ ግለሰብ የሚሰግደው እንዴት ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/4280.mp3',
        'answer' => '<p> መልስ- የሰላት አፈጻጸም፦<br /> 1- ሳይዛነፉና ሳይዟዟሩ ሙሉ አካልን ወደ ቂብላ <span class="c2">(ማዞር)</span> መቅጣጨት፤<br /> 2- ከዚያም በልቡ ሊሰግደው የፈለገውን ሰላት በቃል መናገር ሳይጠበቅበት በውጡ ማሰብ፤<br /> 3 - ከዚያም "አሏሁ አክበር!" ብሎ ተክቢረተል ኢሕራም ማድረግ፤ ተክቢራውን በሚልበት ጊዜ እጅን በትከሻ ትይዩ ማንሳት፤<br /> 4- ከዚያም የቀኝ እጅን መዳፍ በግራ እጅ የመዳፍ ጀርባ ላይ አጣምሮ ደረት ላይ ማስቀመጥ፤<br /> 5- ከዚያም እንዲህ ብሎ ዱዓኡል ኢስቲፍታሕን ማለት፦ "አላሁመ ባዒድ በይኒ ወበይነ ኸጧያየ ከማ ባዐድተ በይነል-መሽሪቂ ወል-መግሪቢ አሏሁመ ነቂኒ ሚን ኸጧያየ ከማ ዩነቀ-ሥ-ሠውቡል አብየዱ ሚነ ደነስ አላሁመ \'ግሲልኒ ሚን ኸጧያየ ቢሥ-ሠልጂ ወልማኢ ወል-<span class="c6">በረድ" ትርጉሙ፦ "አላህ ሆይ! በምሥራቅና በምዕራብ መካከል እንዳራራቅከው እኔንም ከወንጀሌ አርቀኝ፤ አላህ ሆይ! ነጭ ልብስ ከቆሻሻዎች እንደሚጸዳው እኔንም ከወንጀሌ አጥራኝ፤ አላህ ሆይ! እኔን ከወንጀሌ በውሃ እና በፈሳሹም በደረቁም በረዶ እጠበኝ።"<br /> ወይም እንዲህ ይበል:</span> "ሱብሓነከ አልላሁምመ ረበና ወ ቢሐምዲከ ወተባረከ ኢስሙከ ወተዓላ ጀዱከ ወላኢላሃ ገይሩክ" ትርጉሙ፦ "ጥራት ይገባህ አላህ ሆይ! ምስጋናም ላንተ ነው። ስምህ ከፍ ያለ ግርማህም የላቀ ነው፤ ካንተም በቀር አምላክ የለም።"<br /> 6- ከዚያም እንዲህ በማለት በአላህ ይጠበቅ፦ "አዑዙ ቢላሂ ሚነ ሸይጧኒ-ር-ሯጂም" ትርጉሙ፦ "ከተረገመው ሰይጣን በአላህ እጠበቃለሁ።" 7- ከዚያም ቢስሚላህ ካለ በኋላ ፋቲሓን እንዲህ ብሎ ያንብብ፦ <span class="c3">«ቢስሚልላሂ‐ር‐ረሕማኒ‐ር‐ረሒም»</span> <span class="c5">[ትርጉሙ፡ በአላህ ስም እጅግ በጣም ሩኅሩህ በጣም አዛኝ በሆነው]</span> <span class="c2">(1)</span> <span class="c3">«አልሓምዱ ሊልላሂ ረቢል ዓለሚን»</span> <span class="c2">(ትርጉሙ: ምስጋና ለዓለማት ጌታ ለአላህ የተገባው ነው)</span> <span class="c2">(2)</span> <span class="c3">«አርረሕማን አርረሒም»</span> <span class="c2">(ትርጉሙም: እጅግ በጣም ሩኅሩህ በጣም አዛኝ በሆነው)</span> <span class="c2">(3)</span> <span class="c3">«ማሊኪ የውሚ-ድ-ዲን»</span> <span class="c2">(ትርጉሙ: የፍርዱ ቀን ባለቤት ለሆነው።)</span> <span class="c2">(4)</span> <span class="c3">«ኢይያከ ነዕቡዱ ወኢይያከ ነሰተዒን»</span> <span class="c2">(ትርጉሙ: አንተን ብቻ እንገዛለን አንተንም ብቻ እርዳታን እንለምንሃለን)</span> <span class="c2">(5)</span> <span class="c3">«ኢህዲና‐ስ‐ሲሯጦል ሙስተቂም»</span> <span class="c2">(ትርጉሙም: ቀጥተኛውን መንገድ ምራን)</span> <span class="c2">(6)</span> <span class="c3">«ሲሯጦ‐ል‐ለዚነ አንዓምተ ዓለይሂም ገይሪል መግዱቢ ዓለይሂም ወለድ-ዷሊን»</span> <span class="c2">(ትርጉሙም: የእነዚያ ፀጋህን የዋልክላቸውን ሰዎች መንገድ በነዚያ የተቆጣህባቸውን እና የተሳሳቱትንም አይደሉም።)</span> <span class="c2">(7)</span> <span class="c5">[አል\'ፋቲሓ፡ 1-7]</span><br /> ከዚያም <span class="c3">«አሚን»</span> ይበል፤ ትርጉሙም አላህ ሆይ! ዱዓችንን ተቀበለን ማለት ነው።<br /> 8 - ከዚያም የገራለትን ቁርአን ይቅራ፤ የሱብሒን ሰላት ቁርኣን ንባብ ማርዘሙ መልካም ነው።<br /> 9 - ከዚያም ሩኩዕ ያደርጋል፡ ማለትም አላህን በማላቅ ይጎነበሳል። ወደ ሩኩዕ ሲወርድም ሁለት እጆቹን በትከሻው ትይዩ አድርጎ "አሏሁ አክበር" እያለ ይወርዳል። የአኳኋኑ ሁኔታ ሱና፦ ጀርባውን ለጥ አድርጎ ጭንቅላቱንም በጀርባው ልክ አስተካክሎ የሁለት እጆቹ ጣቶችን ለያይቶ ጉልበቱን መያዝ ነው።<br /> 10 - በሩኩዑ ጊዜ ሶስት ጊዜ እንዲህ ይበል፡ "ሱብሓነ ረቢየል ዓዚም" <span class="c2">(ትርጉሙም፡ ጥራት ይገባህ ታላቁ ጌታየ)</span>፤ "ሱብሓነከሏሁመ ወቢሓምዲከ አሏሁግፊርሊ" <span class="c2">(ትርጉሙም፡ ጥራት ይገባህ ምስጋናም ላንተው ነው፤ መሀርታህን ለግሰኝ።)</span> ቢል በላጭ ነው።<br /> 11 - ከዚያም ከሩኩዕ ሁለት እጆቹን በትከሻው ትይዩ አድርጎ እንዲህ እያለ ቀና ይበል፡ "ሰሚዐልላሁ ሊመን ሐሚደህ" <span class="c2">(ትርጉሙም፡ አላህ የሚያመሰግኑትን ሰሚ ነው።)</span> ኢማሙን ተከትሎ የሚሰግድ "ሰሚዐሏሁ ሊመን ሐሚደህ" ሳይሆን "ረበና ወለከል ሓምድ" <span class="c2">(ትርጉሙም፡ ጌታችን ሆይ! ምስጋናም ላንተ ነው።)</span> ነው የሚለው።<br /> 12 - ከዚያም ቀና ካለ በኋላ እንዲህ ይበል፡ "ረበና ወለከል ሐምድ ሚልኡ ሰማዋቲ ወል አርዲ ወሚልኡ ማሺእተ ሚን ሸይኢን ባዕዱ" <span class="c2">(ትርጉሙም፡ ጌታችን ሆይ! ምስጋና በሰማያትና በምድር ሙሉ ላንተ ይሁን፤ ከዚያም በኋላ አንተ በምትሻው ነገር ሙሉም ላንተ ይሁን።)</span><br /> 13 - ከዚያም ለመጀመርያው ሱጁድ እንዲህ እያለ ይወርዳል፡ "አሏሁ አክበር"፤ ሱጁድ የሚያደርገውም በሰባት የሱጁድ አካላቱ ሲሆን እነርሱም፡ ግንባር አፍንጫን ጨምሮ ፣ ሁለት መዳፎች፣ ሁለት ጉልበቶቹ እና የእግር ጫፎች ናቸው። አካላቱን ከጎኑ ያርቃቸው፤ ክርኖቹንም ምድር ላይ አያንጥፋቸው፤ በእግሩ ጫፍም <span class="c2">(በጣቶቹ)</span> ወደ ቂብላ ይቅጣጭ።<br /> 14 - በሱጁዱም ወቅት ሶስት ጊዜ እንዲህ ይበል፦ "ሱብሓነ ረቢየል አዕላ" <span class="c2">(ትርጉሙም፡ ከፍ ያልከው ጌታየ ሆይ! ጥራት ይገባህ።)</span> እንዲህ ብሎ ቢጨምር ደግሞ ይበልጥ የተሻለ ነው፡ "ሱብሓነከሏሁምመ ረብበና ወቢሓምዲከ አሏሁምመግፊርሊ" <span class="c2">(ትርጉሙም፡ ጥራት ይገባህ ምስጋናም ላንተ ነው ጌታየ! መሀርታህን ለግሰኝ።)</span><br /> 15 - ከዚያም ከሱጁድ "አሏሁ አክበር" እያለ ቀና ይበል።<br /> 16 - ከዚያም በሁለቱ ሱጁዶች መካከል የቀኝ እግሩን ተረከዝ ተክሎ በግራ እግሩ የውስጠኛው ክፍል ላይ ይቀመጥ። የቀኝ እጁን በቀኝ ታፋው ላይ አድርጎ ወደ ጉልበቶቹ አስጠግቶ ያስቀምጣቸው። ትንሿን ጣቱንና የቀለበት ጣቱን አጥፎ ጠቋሚ ጣቱን በዱዓእ ጊዜ ያንቀሳቅስ። የአውራ ጣቱን ጫፍም ከመሀል ጣቱ ጫፍ ጋር አድርጎ እንደ ክብ ነገር ይስራባቸው። የግራ እጁን ደግሞ ጣቶቹን ዘርግቶ በግራ ታፋው ላይ ወደ ጉልበቱ አስጠግቶ ያስቀምጠው።<br /> 17 - በሁለቱ ሱጁዶች መካከል ሲቀመጥ እንዲህ ይበል፦ <span class="c1">“ረቢግፊርሊ ወርሐምኒ ወህዲኒ ወርዙቅኒ ወጅቡርኒ ወዓፊኒ”</span> ትርጉሙ፡ "አላህ ሆይ ይቅር በለኝ ማረኝ ምራኝ ፣ ደግፈኝ ፣ ጠብቀኝ፣ ስጠኝ፣ ከፍም አድርገኝ።"<br /> 18 - ሁለተኛውንም ሱጁድ ንግግሩንም ተግባሩንም ተመሳሳይ በሆነ መልኩ ልክ እንደመጀመርያው ያድርግ። ወደ ሱጁድ በሚወርድበትም ጊዜ "አሏሁ አክበር" ይበል።<br /> 19 - ከዚያም ከሁለተኛው ሱጁድ "አሏሁ አክበር" እያለ ቀና ይበል። የሁለተኛውንም ረከዓህ ንግግሩንም ተግባሩንም ልክ በመጀመርያው ረከዓህ እንዳደረገው ያድርግ። ነገር ግን የመክፈቻ ዱዓ አያደርግም።<br /> 20 - ከዚያም ሁለተኛውንም ረከዓህ እንዳጠናቀቀ "አሏሁ አክበር" እያለ ቀና ይበልና በሁለቱ ሱጁዶች መካከል እንደተቀመጠው ሆኖ ይቀመጥ።<br /> 21 - በዚሁ በተቀመጠበት በሚከተለው መልኩ ተሸሁድን ያነባል፡ <span class="c1">“አትተሒያቱ ሊላሂ ወስሶላዋቱ ወጥጠይባቱ ፣ አስሰላሙ ዐለይከ አይዩሀን-ነቢይዩ ወረሕመቱልላሂ ወበረካትሁ ፤ አስሰላሙ ዐለይና ወዓላ ዒባዲላሂ አስሷሊሒነ ፣ አሽሀዱ አንላኢላሀ ኢልለልላህ ወአሽሀዱ አንነ ሙሐመደን ዐብዱሁ ወረሱሉሁ። አልላሁምመ ሰልሊ ዐላ ሙሐመዲን ወዐላ ኣሊ ሙሐመዲን ከማ ሶልለይተ ዐላ ኢብራሂመ ወዐላ ኣሊ ኢብራሂመ ኢንነከ ሐሚዱን መጂድ። አልላሁምመ ባሪክ ዓላ ሙሐመዲን ወዐላ አሊ ሙሐመዲን ከማ ባረክተ ዐላ ኢብራሂመ ወዓላ አሊ ኢብራሂመ ኢንነከ ሐሚዱን መጂድ። አሏሁማ ኢኒ አዑዙ ቢከ ሚን ዐዛቢል-ቀብሪ ወሚን ዐዛቢ ጀሀነም ወ ሚን ፊቲነቲል-መሕያ ወል-መማቲ ወ ሚን ሸር-ሪ ፊቲናቲል መሲሒ-ድ-ደጃል”</span> ትርጉም ፡- “ክብርና ልዕልና እንዲሁም ሶላቶችና መልካም ነገሮች ሁሉ ለአላህ ናቸው። አንቱ ነቢዩ ሆይ! የአላህ ሰላም፣ እዝነቱና በረከቶች በእርሶ ላይ ይስፈን ፤ ሰላም በእኛና በአላህ ደጋግ ባሮችም ላይ ይስፈን ፤ ከአላህ ሌላ በእውነት የሚመለክ አምላክ እንደሌለ እመሰክራለሁ ፤ ሙሐመድም የአላህ አገልጋይና መልዕክተኛ መሆናቸውን እመሰክራለሁ፤ አላህ ሆይ! ውዳሴህን ለኢብራሂምና ለቤተሰቦቻቸው እንዳወረድክላቸው ሁሉ ለሙሐመድና ለቤተሰቦቻቸው አውርድላቸው፤ አንተ ምስጉንና ኋያል <span class="c2">(የላቅክ)</span> ነህና።አላህ ሆይ! ለኢብራሂምና ለቤተሰቦቻቸው ረድዔትን እንዳወረድክላቸው ሁሉ ለሙሐመድና ለቤተሰቦቻቸውም ረድዔትን አውርድላቸው። አንተ ምስጉንና ኋያል <span class="c2">(የላቅክ)</span> ነህና። አላህ ሆይ! ከቀብር ፈተና፣ ከጀሀነም ፈተና፣ ከህይወትና ሞት ፈተናዎች እንዲሁም ከመሲሒ ደጃልም ፈተና ክፋት በአንተ እጠበቃለሁ።" ከዚያም ከቅርቢቱ ዓለምና ከመጨረሻው ዓለም የፈለገውን መልካም ነገር በዱዓእ አላህን ይማፀናል።<br /> 22 - ከዚያም ወደ ቀኝ እየዞረ እንዲህ ብሎ ያሰላምት "አሰላሙ ዓለይኩም ወራሕመቱሏህ"፤ ወደ ግራ እየዞረም እንዲሁ ይበል።<br /> 23 - ሶላቱ ሶስት ረከዓ ወይም አራት ረከዓህ የሚሰገድበት ከሆነ ደግሞ ተሸሁድ ማለትም "አሽሀዱ አን ላ ኢላሃ ኢለሏህ ወአሽሀዱ አነ ሙሐመደን ዐብዱሁ ወረሱሉህ" የሚለው ድረስ ካለ በኋላ የቀረውን ረከዓ ለመቀጠል ይቆማል።<br /> 24 - ከዚያም "አሏሁ አክበር" እያለ ይቁም እጆቹንም በትከሻው ትይዩ ከፍ ያድርጋቸው።<br /> 25 - ከዚያም ሁለተኛውን ረከዓህ በሰገደበት አኳኋን አድርጎ ሶላቱን ይቀጥል፤ ይሁን እንጂ የሚቀራው ቁርአን ፋቲሓን ብቻ ነው።<br /> 26 - ከዚያም ተወሩክ በሚባለው አኳኋኑም የቀኝ እግሩን ተረከዝ ተክሎ የግራ እግሩን ተረከዝ ደግሞ በተከለው የቀኝ እግሩ ተረከዝ ስር አሾልኮ መቀመጫውን መሬቱ ላይ ያደርጋል። እጆቹን ደግሞ ልክ በመጀመርያው ተሸሁድ ላይ እንዳደረገው አድርጎ በታፋዎቹ ላይ ያስቀመጣቸዋል።<br /> 27 - በዚሁ መቀመጡ ላይ ሙሉ ተሸሁድን ነው የሚቀራው።<br /> 28 - ከዚያም ወደ ቀኝ እየዞረ እንዲህ ብሎ ያሰላምት "አሰላሙ ዐለይኩም ወረሕመቱሏህ"፤ ወደ ግራ እየዞረም እንዲሁ ይበል። </p>',
      ],
      25 => [
        'question' => 'ጥ 6 - ሶላትን ካጠናቀቅክ በኋላ የሚባለው ዚክር ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/4610.mp3',
        'answer' => '<p> መልስ - ሶስት ጊዜ "አስተግፊሩሏህ" ካለ በኋላ<br /> - "አሏሁምመ አንተስ-ሰላም ወሚንከስ-ሰላም ተባረክተ ያ ዘል-ጀላሊ ወል-ኢክራም" <span class="c2">(ትርጉሙም፡<br /> አላህ ሆይ! አንተ "አስ-ሰላም" ነህ። ሰላምም ከአንተው ነው የሚመጣው። የግርማና የልቅና ባለቤት የሆንከው ጌታየ ሆይ ክብርህ ይስፋ።)</span><br /> - "ላ ኢላሀ ኢለላህ ወሕደሁ ላ ሸሪከ ለሁ፡ ለሁል-ሙልኩ ወለሁል-ሐምዱ ወሁወ ዐላ ኩሊ ሸይኢን ቀዲር አሏሁመ ላ ማኒዐ ሊማ አዕጦይተ ወላ ሙዕጢየ ሊማ መናዕተ ወላ የንፈዑ ዘል-ጀዲ ሚንከል-ጀድ"<br /> <span class="c2">(ትርጉሙም፡ ከአላህ በስተቀር በእውነት አምልኮ የሚገባው አምላክ የለም፤ ተጋሪ የለውም። ንግሥናም ምስጋናም የእርሱ ብቻ ነው። እርሱም በነገሩ ሁሉ ላይ ቻይ ነው። አላህ ሆይ! አንተ የሰጠኸውን የሚያቅበው የለም። የከለከልከውንም ማንም ሊሰጥ አይችልም። እድለኝነትም ሊጠቅም አይችልም። እድለኝነትም ካንተው ነው።)</span><br /> - "ላ ኢላሀ ኢለላህ ወሕደሁ ላ ሸሪከ ለሁ፡ ለሁል-ሙልኩ ወለሁል-ሐምዱ ወሁወ ዐላ ኩሊ ሸይኢን ቀዲር ላ ሓውላ ወላ ቁወተን ኢላ ቢላህ ላ ኢላሀ ኢለሏህ ወላ ነዕቡዱ ኢላ ኢያህ ለሁን-ኒዕመቱ ወለሁል-ፈድሉ ወለሁሥ-ሠናኡል ሐሰን ላ ኢላሀ ኢለላህ ሙኽሊሲነ ለሁድ-ዲን ወለው ከሪሀል-ካፊሩን"<br /> <span class="c2">(ትርጉሙም፡ ከአላህ በስተቀር በእውነት አምልኮ የሚገባው አምላክ የለም፤ ተጋሪ የለውም። ንግሥናም ምስጋናም የእርሱ ብቻ ነው። እርሱም በነገሩ ሁሉ ላይ ቻይ ነው። ከአላህ በስተቀር ምንም ሃይልም ብልሀትም የለም። ከአላህ በስተቀር በእውነት የሚመለክ የለም። ከርሱም ሌላ አንገዛም። ችሮታው የርሱ ብቻ ነው። ውዳሴም ለእርሱ ብቻ ነው። ከአላህ በስተቀር ሌላ በእውነት አምልኮ የሚገባ አምላክ የለም። ከሓዲዎች ቢጠሉም (እኛ)</span> ሃይማኖታችንን በኢኽላስ ለርሱ ያጠራን ነን።)<br /> - "ሱብሐነላህ" <span class="c2">(ትርጉሙም፡ አላህ ጥራት ይገባው)</span> ሰላሳ ሶስት ጊዜ፤<br /> - "አልሐምዱሊህ" <span class="c2">(ትርጉሙም፡ ምስጋና ሁሉ ለአላህ የተገባ ነው)</span> ሰላሳ ሶስት ጊዜ፤<br /> - "አላሁ አክበር" <span class="c2">(ትርጉሙም፡ አላህ የላቀ ነው)</span> ሰላሳ ሶስት ጊዜ፤<br /> ከዚያም እንዲህ ብሎ መቶ ይሞላል፦ - "ላ ኢላሀ ኢለላህ ወሕደሁ ላ ሸሪከ ለሁ፡ ለሁል-ሙልኩ ወለሁል-ሐምዱ ወሁወ ዐላ ኩሊ ሸይኢን ቀዲር"<br /> <span class="c2">(ትርጉሙም፡ ከአላህ በስተቀር በእውነት አምልኮ የሚገባው አምላክ የለም፤ ተጋሪ የለውም። ንግሥናም ምስጋናም የእርሱ ብቻ ነው። እርሱም በነገሩ ሁሉ ላይ ቻይ ነው።)</span><br /> - ሱረቱ አል-ኢኽላስን እና ሱረቱል ፈለቅን <span class="c2">("ቁል አዑዙ ቢረቢል ፈለቅ")</span> እና ሱረቱ-ን-ናስን （<span class="c1">“ቁል አዑዙ ቢረቢ-ን-ናስ”</span>) ከፈጅርና ከመግሪብ ሰላት በኋላ ሶስት ሶስት ጊዜ ከሌሎቹ ሶላቶች በኋላ ደግሞ አንድ አንድ ጊዜ መቅራት፤<br /> አየተል ኩርሲይን አንድ ግዜ መቅራት፤ </p>',
      ],
      26 => [
        'question' => 'ጥ 27፡ ከግዴታ ሰላት በፊትና በኋላ የሚሰገዱ ሱናዎች ምን ምን ናቸው? ትሩፋቱስ ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/4730.mp3',
        'answer' => '<p> መልስ - ከፈጅር ሰላት በፊት ሁለት ረከዓዎች፤<br /> ከዝሁር ሰላት በፊት አራት ረከዓዎች፤<br /> ከዝሁር ሰላት በኋላ ሁለት ረከዓዎች፤<br /> ከመግሪብ ሰላት በኋላ ሁለት ረከዓዎች፤<br /> ከዒሻ ሰላት በኋላ ሁለት ረከዓዎች፤<br /> ትሩፋቱን በተመለከተ ነብዩ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን እንዲህ ብለዋል፦ <span class="c1">“በቀንና በሌሊቱ ክፍል አስራ ሁለት ረከዓዎችን ለሰገደ አላህ በጀነት ውስጥ ቤት ይገነባለታል።”</span> ሙስሊም እና አሕመድ እንዲሁም ሌሎችም ዘግበውታል። </p>',
      ],
      27 => [
        'question' => 'ጥ 28፡ የሳምንቱ ምርጥ ቀን ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/4800.mp3',
        'answer' => '<p> መልስ - ጁሙዓ ቀን ነው። ነብዩ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን እንዲህ ብለዋል፦ "ከቀኖቻችሁ በላጩ ጁምዓ ነው። በዚህ ቀን አደም ተፈጠረ፤ በዚህ ቀንም ሞተ፤ በዚህ ቀን ነው የመጨረሻው ቀንድ የሚነፋው፤ በዚህ ቀን ነው በድንጋጤ መሞት የሚከሰተው። በዚያ ቀን በኔ ላይ ሶለዋት አብዙ፤ ምክንያቱም ሶለዋታችሁ ለኔ ይቀርብልኛልና።" "የአላህ መልዕክተኛ ሆይ! አፈር በልቶዎት ሳለ ሰለዋታችን እንዴት ይቀርብሎታል?" አሏቸው፤ እርሳቸውም፦ "አላህ ምድርን የነቢያትን ሥጋ ከመብላት ከልክሏታል።" አቡ ዳውድና ሌሎችም ዘግበውታል። </p>',
      ],
      28 => [
        'question' => 'ጥ 29፡ የጁምአ ሰላት ብያኔ ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/4840.mp3',
        'answer' => '<p> ሐ- በእያንዳንዱ ለአቅመ አዳም የደረሰ ጤነኛ አእምሮ ያለው መንገደኛ ያልሆነ ወንድ ሙስሊም ላይ ሁሉ በነፍስ ወከፍ ግዴታው ነው።<br /> የላቀዉ አላህ እንዲህ ብሏል፦ <span class="c4">{እናንተ ያመናችሁ ሆይ! በዐርብ ቀን ለስግደት ጥሪ በተደረገ ጊዜ ወደ አላህ ማውሳት ኺዱ። መሸጥንም ተዉ። ይህ የምታውቁ ብትኾኑ ለእናንተ በጣም የተሻለ ነወ። 9}</span> <span class="c5">[ሱረቱል ሙናፊቁን፡ 9]</span> </p>',
      ],
      29 => [
        'question' => 'ጥ 30፡ የጁምዓ ሰላት ስንት ረከዓዎች አሉት?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/4880.mp3',
        'answer' => '<p> መልስ - የጁምአ ሰላት ረከዓዎች ብዛት ኢማሙ ጮክ ብለው የሚቀሩባቸው ሁለት ረከዓዎች ሲሆኑ ከሰላት በፊትም ሁለት የታወቁ ኹጥባዎች አሉት። </p>',
      ],
      30 => [
        'question' => 'ጥ 31፡ የጁምዓ ሰላት ማሳለፍ ይፈቀዳልን?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/4910.mp3',
        'answer' => '<p> ሐ - በሸሪዓዊ ዑዝር ካልሆነ በቀር ከጁምዓ ሰላት መቅረት የሚፈቀድ አይደለም። ነብዩ ሶለላሁ ዐለይሂ ወሰለም እንዲህ ብለዋል፡- "በስንፍና ሶስት ጁምዓዎችን ያሳለፈ ሰው አላህ በልቦናው ላይ ያትምበታል።" አቡ ዳውድና ሌሎችም ዘግበውታል። </p>',
      ],
      31 => [
        'question' => 'ጥ 32፡ የጁምዓን ሱና ጥቀስ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/4940.mp3',
        'answer' => '<p> መልስ-<br /> 1 - ገላን መታጠብ፤<br /> 2 - ሽቶ መቀባት፤<br /> 3 - የክት <span class="c2">(መልካም)</span> ልብስን መልበስ፤<br /> 4 - ወደ መስጅድ ቀደም ብሎ መሄድ፤<br /> 5 - በነብዩ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን ላይ ሶለዋት ማብዛት፤<br /> 6 - ሱረቱል ከህፍን መቅራት፤<br /> 7 - ወደ መስጅድ በእግር መሄድ፤<br /> 8- ዱዓእ ተቀባይነት የሚያገኝበትን ሰዓት መጠባበቅ፤ </p>',
      ],
      32 => [
        'question' => 'ጥ 33፡ በጀምዓ መስገድ ያለውን ትሩፋትን ጥቀስ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5050.mp3',
        'answer' => '<p> መልስ - ከዐብደ፤አህ ኢብኑ ዑመር ረዲየሏሁ ዓንሁ በተላለፈ ሐዲሥ የአላህ መልዕክተኛ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን እንዲህ ብለዋል፦ "በጀምዓ የሚሰገድ ሰላት ለብቻ ከሚሰገድ ሰላት በሃያ ሰባት እጥፍ ይበልጣል።" ሙስሊም ዘግበውታል። </p>',
      ],
      33 => [
        'question' => 'ጥ 34፡ በሰላት ውስጥ ኹሹዕን መኖር ማለት ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5080.mp3',
        'answer' => '<p> መልስ - በሰላት ሰአት ልቦና የተጣደ መሆኑ እና አካልም መስከኑ ነው።<br /> የላቀዉ አላህ እንዲህ ብሏል፦ {ምእምናን ፍላጎታቸውን ሁሉ በእርግጥ አገኙ <span class="c2">(ዳኑ)</span>። 1} {እነዚያ እነርሱ በስግደታቸው ውስጥ <span class="c2">(አላህን)</span> ፈሪዎች። 2} <span class="c5">[ሱረቱ አል-ሙእሚኑን፡ 1፣2]</span> </p>',
      ],
      34 => [
        'question' => 'ጥ 35፡ ዘካ ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5120.mp3',
        'answer' => '<p> ሐ - በተወሰነ የጊዜ ገደብ ውስጥ ለተወሰኑ የማህበረሰብ ክፍሎች የሚሰጥ የገንዘብ ግዴታ ነው።<br /> ከእስልምና መሰረቶች መካከል አንዱ ሲሆን ከሀብታሞች ተወስዶ ለድሆች የሚሰጥ የግዴታ ምጽዋት ነው።<br /> የላቀዉ አላህ እንዲህ ብሏል፦ "ዘካንም ስጡ።" <span class="c5">[ሱረቱል በቀራህ፡ 43]</span> </p>',
      ],
      35 => [
        'question' => 'ጥ 36፡ ሙስተሓብ (ግዴታ ባይሆንም የሚበረታታ) የሆነው ምጽዋት ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5170.mp3',
        'answer' => '<p> መልስ - ከዘካ ውጭ የሆነ በማንኛውም ጊዜ በበጎነት የሚደረግ መርዳትን መሰል ምጽዋትን የሚያጠቃልል ነው።<br /> የላቀዉ አላህ እንዲህ ብሏል፦ <span class="c4">{በአላህም መንገድ ለግሱ።}</span> <span class="c5">[ሱረቱል በቀራህ፡ 195]</span> </p>',
      ],
      36 => [
        'question' => 'ጥ 37፡ ጾም ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5210.mp3',
        'answer' => '<p> ሐ- አላህን ማምለክን በማሰብ ጎህ ከሚቀድበት ጊዜ ጀምሮ እስከ ጀንበር መጥለቅ ድረስ ጾምን ከሚያፈርሱ ነገሮች በመታቀብ አላህን ማምለክ ነው። ሁለት ዓይነትም ነው፦<br /> የግዴታ ጾም፡- ከእስልምና ምሰሶዎች አንዱ የሆነውን የረመዷንን ወር መጾምን ይመስል።<br /> የላቀዉ አላህ እንዲህ ብሏል፦ {እናንተ ያመናችሁ ሆይ ጾም በነዚያ ከናንተ በፊት በነበሩት <span class="c2">(ሕዝቦች)</span> ላይ እንደ ተጻፈ በናንተም ላይ ተጻፈ <span class="c2">(ተደነባ)</span> ልትጠነቀቁ ይከጀላልና። 183} <span class="c5">[ሱረቱል በቀራህ፡ 183]</span><br /> ግዴታ ያልሆነ ጾም፡- በየሳምንቱ ሰኞ እና ሐሙስ መጾም እና ከየወሩ ሦስት ቀናትን መጾምን የመሳሰሉ ጾሞችን የሚመለከት ሲሆን ከእንዲህ ዓይነቶቹ በላጩ አያመል ቢድ የሚባሉት <span class="c2">(በሒጅሪ አቆጣጠር የወሩን 13ኛ፣ 14ኛውና 15ኛውን)</span> ቀናት መጾም ነው። </p>',
      ],
      37 => [
        'question' => 'ጥ 38፡ የረመዷንን ወር መፆም ያለውን ትሩፋት ጥቀስ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5270.mp3',
        'answer' => '<p> መልስ- አቡ ሁረይራ <span class="c2">(ረዲየላሁ ዐንሁ)</span> እንዳስተላለፉት የአላህ መልእክተኛ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን እንዲህ ብለዋል፡- "የረመዷንን ወር በእምነት እና ምንዳውን ከአላህ ለማግኘት በማሰብ የጾመ ሰው ያለፈው ኃጢአቱ ይሰረይለታል።" ቡኻሪና ሙስሊም ዘግበውታል። </p>',
      ],
      38 => [
        'question' => 'ጥ 39፡ ከረመዷን ውጭ በፈቃድኝነት ግዴታ ያልሆነ ጾምን መፆም ያለውን ትሩፋት ጥቀስ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5300.mp3',
        'answer' => '<p> መልስ - አቡ ሰዒድ አል-ኹድሪይ አላህ ይውደድላቸውና ባስተላለፉት የአላህ መልእክተኛ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን እንዲህ ብለዋል፡- "ማንኛውም ባርያ በአላህ መንገድ አንድ ቀን ቢፆም አላህ ፊቱን ከጀሀነም የሰባ ክረምት ያህል ያርቅለታል።" ቡኻሪና ሙስሊም ዘግበውታል።<br /> - "ሰባ ክረምት" ሲባል ሰባ ዓመት እንደማለት ነው። </p>',
      ],
      39 => [
        'question' => 'ጥ 40፡- ፆምን ከሚያፈርሱ ነገሮች መካከል የተወሰኑትን ጥቀስ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5330.mp3',
        'answer' => '<p> መልስ-1- ሆን ብሎ መብላትና መጠጣት፤<br /> 2- ሆን ብሎ ማስታወክ፤<br /> 3- ከእስልምና መቀልበስ <span class="c2">(ካፊር መሆን)</span>፤ </p>',
      ],
      40 => [
        'question' => 'ጥ 41፡ የፆም ሱናዎችን ጥቀስ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5380.mp3',
        'answer' => '<p> መልስ-1- ፊጥራን ማፋጠን፤<br /> 2- ሰሑር ማዘግየት፤<br /> 3- በጎ ስራን እና ዒባዳን ማብዛት፤<br /> 4- ፆመኛ ሆኖ ሲዘልፉት "እኔ ፆመኛ ነኝ" ማለት<br /> 5- ፆም በሚፈቱበት ጊዜ ዱዓእ ማድረግ፤<br /> 6- ጾምን በእርጥብ ቴምር ወይም በማንኛውም ቴምር ማፍጠር፤ ካልተገኘ ደግሞ በውኋ ማፍጠር፤ </p>',
      ],
      41 => [
        'question' => 'ጥ 42፡ ሐጅ ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5460.mp3',
        'answer' => '<p> መልስ - ሐጅ ማለት፡- የተወሰነ የአምልኮ ስርአትን፤ በተወሰነ ወቅት ላይ ለማከናወን ወደ ተከበረው የአላህ ቤት ሄዶ አላህን ማምለክ ነው።<br /> የላቀዉ አላህ እንዲህ ብሏል፦ <span class="c4">{ለአላህም በሰዎች ላይ ወደርሱ መኼድን በቻለ ሁሉ ላይ ቤቱን መጎብኘት ግዴታ አለባቸው። የካደም ሰው አላህ ከዓለማት ሁሉ የተብቃቃ ነው። 97}</span> <span class="c5">[ሱረቱ ኣሊ-ዒምራን፡ 97]</span> </p>',
      ],
      42 => [
        'question' => 'ጥ 43፡ የሐጅ (አርካን) ምሰሶዎችን ብዛት ጥቀስ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5500.mp3',
        'answer' => '<p> መልስ-1- ኢሕራም፤<br /> 2- በዐረፋ ላይ መቆም፤<br /> 3- ጠዋፍ አል-ኢፋዷ፤<br /> 4- በሰፋ እና መርዋ መካከል መመላለስ፤ </p>',
      ],
      43 => [
        'question' => 'ጥ 44፡ የሐጅን ትሩፋት ጥቀስ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5560.mp3',
        'answer' => '<p> መልስ- ከአቡ ሁረይራ <span class="c2">(ረዲየላሁ ዐንሁ)</span> እንደተላለፈው "የአላህ መልእክተኛ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን እንዲህ ሲሉ ሰምቻለሁ" ብለው፡- "<span class="c2">(ከሚስቱም ጋር)</span> ግንኙነት ሳይፈፅም ኀጢአትንም ሳይሠራ ከሓጅ የተመለሰ ሰው ልክ እናቱ በወለደችበት ቀን እንደነበረው ሆኖ ይመልለሳል።" ቡኻሪይ እና ሌሎችም ዘግበውታል።<br /> - "ልክ እናቱ በወለደችበት ቀን እንደነበረው ሆኖ ይመልለሳል።" ሲባል ከኃጢአት የጸዳ ሆኖ ማለት ነው። </p>',
      ],
      44 => [
        'question' => 'ጥ 45፡ ዑምራ ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5600.mp3',
        'answer' => '<p> መልስ - ዑምራ ማለት፡- በየተኛውም ወቅት የተወሰነ የአምልኮ ስርአትን ለማከናወን ወደ ተከበረው የአላህ ቤት ሄዶ አላህን ማምለክ ነው። </p>',
      ],
      45 => [
        'question' => 'ጥ 46፡ የዑምራ ምሰሶዎችን ብዛት ጥቀስ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5630.mp3',
        'answer' => '<p> መልስ-1- ኢሕራም፤<br /> 2 - ጠዋፍ ማድረግ፤<br /> 3 - በሰፋ እና መርዋ መካከል መመላለስ፤ </p>',
      ],
      46 => [
        'question' => 'ጥ 47፡ በአላህ መንገድ መታገል ማለት ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5690.mp3',
        'answer' => '<p> መልስ - እስልምናን በማስፋፋት እና ከእስልምና እና ከሙስሊሞችም በመከላከል ረገድ ያቅምን ማድረግ ወይም የእስልምና እና የሙስሊሞችን ጠላቶች መፋለም ነው።<br /> የላቀዉ አላህ እንዲህ ብሏል፦ <span class="c4">{ቀላሎችም ከባዶችም ሆናችሁ ዝመቱ። በአላህም መንገድ በገንዘቦቻችሁ በነፍሶቻችሁም ታገሉ። ይህ የምታውቁ ብትሆኑ ለናንተ በጣም የተሻለ ነው። 41}</span> <span class="c2">(ሱረቱ-ተውባህ፡ 41)</span> </p>',
      ],
    ],
    3 => [
      0 => [
        'question' => 'ጥያቄ 1፡ የነቢያችን ሙሐመድ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈንን የዘር ሀረግ ጥቀስ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5740.mp3',
        'answer' => '<p> መልስ - እሳቸው የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን ሙሐመድ ብን ዐብደላህ ቢን ዐብዱል ሙጦሊብ ቢን ሀሺም ናቸው፤ ሀሺም ከቁረይሽ ዘር ነው፤ ቁረይሾችም ከዐረብ ዝርያዎች ናቸው፤ ዐረቦች ደግሞ የኢስማዒል ዘር ሲሆኑ ኢስማዒል ደግሞ የኢብራሂም ዘር ናቸው። በሳቸውም በነብያችንም በላጭ የሆነው የአላህ ሰላዋትና ሰላም ይስፈንባቸውና። </p>',
      ],
      1 => [
        'question' => 'ጥያቄ 2፡ የነቢያችን የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን እናት ስም ማን ይባላል?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5770.mp3',
        'answer' => '<p> መልስ- አሚና ቢንት ወህብ ትባላለች። </p>',
      ],
      2 => [
        'question' => 'ጥ3: አባታቸው የሞተው መቼ ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5800.mp3',
        'answer' => '<p> መልስ- አባታቸው የሞተው እርሳቸው የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን ገና ሳይወለዱ በእርግዝና ሳሉ ነበር። </p>',
      ],
      3 => [
        'question' => 'ጥ 4፡ ነብዩ ﷺ የተወለዱት መቼ ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5830.mp3',
        'answer' => '<p> መልስ- የዝሆን አመት ተብሎ በተሰየመው አመት በወርሀ ረቢዐል አወል እለተ ሰኞ ነው። </p>',
      ],
      4 => [
        'question' => 'ጥ5: የት ሀገር ተወለዱ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5850.mp3',
        'answer' => '<p> መልስ - በመካ። </p>',
      ],
      5 => [
        'question' => 'ጥ 6፡ ከእናታቸው ውጭ ተንከባካካቢያቸው እና አጥቢያቸው ማን ነበረች?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5880.mp3',
        'answer' => '<p> መልስ - የአባታቸው ባሪያ ኡሙ አይመን፤<br /> - የአጎታቸው አቡ ለሀብ ባርያ ሡወይባህ፤<br /> - ሐሊመቱ-ስ-ሰዕዲያህ፤ </p>',
      ],
      6 => [
        'question' => 'ጥ7: እናታቸው የሞተችው መቼ ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5930.mp3',
        'answer' => '<p> መልስ - በስድስት ዓመታቸው እናታቸው ስትሞት አያታቸው ዐብዱል ሙጦሊብ ይንከባከቧቸው ጀመር። </p>',
      ],
      7 => [
        'question' => 'ጥያቄ 8፡ አያታቸው ዐብዱል ሙጦሊብ ከሞቱ በኋላ የተንከባከባቸው ማን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5960.mp3',
        'answer' => '<p> መልስ- ስምንት አመት ሲሆናቸው አያታቸው ዐብዱል ሙጦሊብ ሞቱና ተንከባካቢያቸው አጎታቸው አቡ ጧሊብ ሆኑ። </p>',
      ],
      8 => [
        'question' => 'ጥ 9፡ ከአጎታቸው ጋር ወደ ሶርያ የተጓዙት መቼ ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5990.mp3',
        'answer' => '<p> መልስ - ከአጎታቸው ጋር ወደ ሶርያ የሄዱት በአሥራ ሁለት ዓመታቸው ነው። </p>',
      ],
      9 => [
        'question' => 'ጥ10፡ ሁለተኛው ጉዟቸው መቼ ነበር?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6020.mp3',
        'answer' => '<p> መልስ - ሁለተኛው ጉዟቸው በኸዲጃ ረዲየሏሁ ዓንሀ ገንዘብ ለመገበያየት ያደረጉት ጉዞ ነበር። እሳቸው የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን ከጉዞ ተመልሰውም እድሜያቸው ሃያ አምስት አመት ሆኖ አገቧት። </p>',
      ],
      10 => [
        'question' => 'ጥ 11፡ ቁረይሾች ካዕባን መልሰው የገነቡት መቼ ነበር?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6050.mp3',
        'answer' => '<p> መልስ - ቁረይሾች ካዕባን እንደገና የገነቡት የሳቸው ዕድሜ ሠላሳ አምስት ሲሆን ነበር።<br /> ሐጀረል አስወድን ማን እንደሚያስቀምጠው በመካከላቸው የሀሳብ ልዪነት በተነሳ ጊዜ እርሳቸውን ፈራጅ አድርገዋቸው ነበር። እርሳቸውም የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን አንዳች ልብስ አምጥተው ከየጎሳው አንድ አንድ ሰው ተውክሎ የልብሱን ጠርዝ እንዲይዝ አዘዙ። ጎሳዎቹም አራት ነበሩ። የእያንዳንዱ ነገድ ተወካይ ጠርዝ ጠርዙን ይዞ ከፍ እንዳደረገላቸው እሳቸውም የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን በእጃቸው ተቀብለው ቦታው ላይ አደረጉት። </p>',
      ],
      11 => [
        'question' => 'ጥ 12፡ አላህ መልዕክተኛው አድርጎ ሲልካቸው እድሜያቸው ስንት ዓመት ነበር? ወደ ማንስ ነው የተላኩት?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6080.mp3',
        'answer' => '<p> መልስ - የአርባ ዓመት ጎልማሳ ነበሩ፤ የተላኩትም ለሰዎች ሁሉ አብሳሪና አስጠንቃቂ ተደርገው ነው። </p>',
      ],
      12 => [
        'question' => 'ጥ13፡ የመጀመሪያ ወሕይ የወረደላቸው በምን መልኩ ነበር?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6110.mp3',
        'answer' => '<p> መልስ - መጀመርያ ወሕይ <span class="c2">(መለኮታዊ ራዕይ)</span> ሲወርድላቸው የነበረው በእውነተኛ ህልም መልኩ ነበር። ምንም ዓይነት ህልም ቢያዩ ልክ እንደ ንጋት ጎህ ፍንትው ብሎ እውን ይሆን ነበር። </p>',
      ],
      13 => [
        'question' => 'ጥ 14፡ ወሕይ ሳይገለጥላቸው በፊት በምን ዓይነት ሁኔታ ላይ ነበሩ? ወሕይ ለመጀመሪያ ጊዜ የተገለጠላቸውስ መቼ ነበር?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6140.mp3',
        'answer' => '<p> መልስ- በሒራእ ዋሻ ውስጥ አላህን ያመልኩ እና ለዛም ብለው ስንቅም ይቋጥሩ ነበር።<br /> በዋሻው ውስጥ አላህን እያመለኩ በነበረበት ጊዜም ነበር ወሕይ የወረደላቸው። </p>',
      ],
      14 => [
        'question' => 'ጥ 15፡ ከቁርኣን ለመጀመሪያ ጊዜ የወረደላቸው ምን የሚለው ነበር?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6180.mp3',
        'answer' => '<p> መልስ- ተከታዩ የላቀው አላህ ቃል ነው፦ {አንብብ በዚያ <span class="c2">(ሁሉን)</span> በፈጠረው ጌታህ ስም። 1 ሰውን ከረጋ ደም በፈጠረው <span class="c2">(ጌታህ ስም)</span>። 2 አንብብ፤ ጌታህ በጣም ቸር ሲሆን፤ 3 ያ በብዕር ያስተማረ። 4 ሰውን ያላወቀውን ሁሉ ያሳወቀ ሲሆን። 5} <span class="c5">[አልዓለቅ፡ 1 - 5]</span> </p>',
      ],
      15 => [
        'question' => 'ጥ 16፡ በመልዕክተኝነታቸው በመጀመሪያ ያመነላቸው ማን ነበር?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6200.mp3',
        'answer' => '<p> መልስ - ከወንዶቹ አቡበከር አስ\'ሲዲቅ፤ ከሴቶች ኸዲጃ ቢንት ኹወይሊድ፤ ከተዳጊዎች ዐልይ ቢን አቢ ጧሊብ፤ ነፃ ከወጡ ባርያዎች መካከል ዘይድ ቢን ሐሪሣህ እና ባሪያ ከሆኑት መካከል ደግሞ ቢላል አል\'ሐበሺይ ናቸው። አላህ ሁሉንም መልካም ስራቸውን ይውደድላቸውና። </p>',
      ],
      16 => [
        'question' => 'ጥ 17፡ ወደ እስልምና ዳዕዋ ሲያደርጉ የነበሩት እንዴት ነበር?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6230.mp3',
        'answer' => '<p> መልስ - ዳዕዋ ሲያደርጉ የነበሩት ለሦስት ዓመታት ያህል በምስጢር የነበረ ሲሆን ከዚያም ዳዕዋውን በይፋ እንዲያደርጉ አላህ አዘዛቸው። </p>',
      ],
      17 => [
        'question' => 'ጥያቄ 18፡ ዳዕዋውን በይፋ ከጀመሩ በኋላ ነቢዩ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን እና በሳቸው ያመኑት ምእመናን በምን ሁኔታ ላይ ነበሩ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6260.mp3',
        'answer' => '<p> መልስ- ሙሽሪኮች ምእመናንን ወደ አቢሲኒያ ነጉሥ እንዲሰደዱ እስኪፈቀድ ደረጃ ድረስ በእርሳቸውና በሙስሊሞች ላይ ግፋቸውን አጧጧፉት።<br /> ሙሽሪኮች ነብዩን የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን ለመጉዳት እና ለመግደል በአንድ ድምፅ ተስማምተውም ነበር። ይሁን እንጅ አላህ እሳቸውን የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን ከሙሽሪኮቹ ለመታደግ አጎታቸው አቡጧሊብን ከለላ አደረገላቸው። </p>',
      ],
      18 => [
        'question' => 'ጥ 19፡- ነብዩ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን መልዕክተኛ ከሆኑ በአሥረኛው ዓመት የሞተው ማን ነበር?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6300.mp3',
        'answer' => '<p> መልስ- አጎታቸው አቡጣሊብ እና ባለቤታቸው ኸዲጃ ረዲየሏሁ ዓንሀ ከዚህ አለም በሞት ተለዩ። </p>',
      ],
      19 => [
        'question' => 'ጥ20፡ ኢስራእ እና ሚዕራጅ ያደረጉት መቼ ነበር?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6330.mp3',
        'answer' => '<p> መልስ - እድሜያቸው ሃምሳ ሲሆን ነበር። ያኔም ነው አምስቱ ሶላቶች በግዴታነት የተደነገጉላቸው።<br /> ኢስራእ ማለት ከመስጅደል ሐረም ወደ መስጅደል አቅሷ ያደረጉት ጉዞ ነው።<br /> ሚዕራጅ ማለት ደግሞ ከአል\'አቅሷ መስጅድ ወደ ሰማይ እስከ ሲድራቲል ሙንታህ ድረስ ያደረጉት ጉዞ ነው። </p>',
      ],
      20 => [
        'question' => 'ጥያቄ 21፡ ነብዩ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን ከመካ ውጪ ያሉ ሰዎችን እንዴት ነበር ዳዕዋ ሲያደርጉላቸው የነበረው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6380.mp3',
        'answer' => '<p> መልስ - ከመዲና የሆኑ አንሷሮች እሳቸው ዘንድ መጥተው በሳቸው አምነው በዳዕዋውም እንደሚተባበሯቸው ቃል እስኪገቡላቸው ድረስ ሰዎች የሚሰባሰቡባቸው በዓላትና አጋጣሚዎችን ጠብቀው ሰዎች ፊት እየቀረቡ ዳዕዋ ያደርጉ ነበር፤ የጧኢፍ ሰዎችንም ዳዕዋ ያደርጉላቸው ነበር። </p>',
      ],
      21 => [
        'question' => 'ጥ 22፡ ነቢዩ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን መካ ውስጥ ዳዕዋ እያደረጉ ለምን ያህል ጊዜ ቆዩ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6410.mp3',
        'answer' => '<p> መልስ - አሥራ ሦስት ዓመታት ነው የቆዩት። </p>',
      ],
      22 => [
        'question' => 'ጥያቄ 23፡ ነቢዩ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን ሂጅራ ያደረጉት ወዴት ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6440.mp3',
        'answer' => '<p> መልስ - ከመካ ወደ መዲና ነው። </p>',
      ],
      23 => [
        'question' => 'ጥ 24፡ በመዲና ውስጥ ለምን ያህል ጊዜ ቆዩ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6470.mp3',
        'answer' => '<p> መልስ - ለአሥር ዓመታት ቆይተዋል። </p>',
      ],
      24 => [
        'question' => 'ጥ 25፡ ከእስልምና ህግጋት መካከል በመዲና ሳሉ የተደነገጉት ምን ምን ናቸው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6490.mp3',
        'answer' => '<p> መልስ - ዘካ፣ ፆም፣ ሐጅ፣ ጂሃድ፣ አዛን እና ሌሎችም የእስልምና ህግጋቶች በመዲና ሳሉ የተደነገጉ ናቸው። </p>',
      ],
      25 => [
        'question' => 'ጥ 26፡ ዋና ዋና የሚባሉት ዘመቻዎቻቸውን ጥቀስ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6520.mp3',
        'answer' => '<p> መልስ - የታላቁ በድር ዘመቻ፤<br /> የኡሑድ ዘመቻ፤<br /> የአሕዛብ ዘመቻ፤<br /> <span class="c2">(ፈትሑ መካ)</span> መካ የተከፈተችበት ዘመቻ፤ </p>',
      ],
      26 => [
        'question' => 'ጥ 27፡ ከቁርኣን መጨረሻ የወረደው ምን የሚለው ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6580.mp3',
        'answer' => '<p> መልስ- ተከታዩ የላቀው አላህ ቃል ነው፦ <span class="c4">{በእርሱም ውስጥ ወደ አላህ የምትመለሱበትንና ከዚያም እነርሱ የማይበደሉ ሲሆኑ ነፍስ ሁሉ የሠራችውን ሥራ የምትሞላበትን ቀን ተጠንቀቁ። 281}</span> <span class="c5">[ሱረቱል በቀራህ፡ 281]</span> </p>',
      ],
      27 => [
        'question' => 'ጥ 28፡ ነብዩ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን መቼ ነው የሞቱት? ዕድሜያቸውስ ስንት ነበር?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6610.mp3',
        'answer' => '<p> መልስ - በአስራ አንደኛው አመተ ሂጅራ በወርሀ ረቢዑል አወል በስልሳ ሶስት አመታቸው አረፉ። </p>',
      ],
      28 => [
        'question' => 'ጥ 29፡ የነቢዩን የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን ሚስቶች ስም ጥቀስ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6640.mp3',
        'answer' => '<p> መልስ-1- ኸዲጃ ቢንት ኹወይሊድ ረዲየላሁ ዐንሃ፤<br /> 2- ሰውዳህ ቢንት ዘምዓህ ረዲየላሁ ዐንሃ፤<br /> 3- ዓኢሻህ ቢንት አቢ በክር አስ\'ሲዲቅ ረዲየላሁ ዐንሃ፤<br /> 4- ሐፍሷ ቢንት ዑመር ረዲየላሁ ዐንሃ፤<br /> 5- ዘይነብ ቢንት ኹዘይማህ ረዲየላሁ ዐንሃ፤<br /> 6- ኡሙ ሰለማህ ሂንድ ቢንት አቢ ኡመያህ ረዲየላሁ ዐንሃ፤<br /> 7- ኡሙ ሐቢባ ረምላህ ቢንት አቢ ሱፍያን ረዲየላሁ ዐንሃ፤<br /> 8- ጁወይሪያህ ቢንት አል\'ሓሪሥ ረዲየላሁ ዐንሃ፤<br /> 9- መይሙናህ ቢንት አል-ሓሪሥ ረዲየላሁ ዐንሃ፤<br /> 10- ሶፊያ ቢንት ሑየይ ረዲየላሁ ዐንሃ፤<br /> 11- ዘይነብ ቢንት ጀሕሽ ረዲየላሁ ዐንሃ፤ </p>',
      ],
      29 => [
        'question' => 'ጥ 30፡ የነብዩ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን ልጆች እነማን ናቸው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6760.mp3',
        'answer' => '<p> መልስ - ሦስቱ ወንዶች ልጆቻቸው፦<br /> አል-ቃሲም፤ የነብዩ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን ቅጽል ስማቸውም በእርሱው ነበር የተሰየመው <span class="c2">(አበል ቃሲም ይባሉ ነበር)</span>።<br /> ዐብደላህ፤<br /> ኢብራሂም፤<br /> ሴት ልጆቻቸው፦<br /> ፋጢማህ፤<br /> ሩቂያህ፤<br /> ኡሙ ኩልሡም፤<br /> ዘይነብ፤<br /> ከኢብራሂም በቀር ሁሉም ልጆቻቸውን ከኸዲጃ <span class="c2">(ረዲየላሁ ዐንሀ)</span> የተወለዱ ናቸው። ከፋጢማህ በቀር ሁሉም እርሳቸው በህይወት እያሉ የሞቱ ሲሆን ፋጢማህ የሞተችው ግን እርሳቸው ከሞቱ ከስድስት ወር በኋላ ነበር። </p>',
      ],
      30 => [
        'question' => 'ጥ 31፡ ከነቢዩ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን የተክለ ሰውነት መገለጫ ባህሪያት ጥቂቱን ጥቀስ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6880.mp3',
        'answer' => '<p> መልስ - ረዥምም አጭርም ያልሆኑ በሰዎች መካከል መካከለኛ ቁመት፤ የአላህ ሶለዋትና ሰላም ይስፈንባቸውና ነጭ ሆኖ ቅላት የጠጣ ፊት ነበራቸው። ወፍራም ፂም፣ ሰፋፊ ዓይኖች፣ ተለቅ ያለ አፍ፣ ፀጉራቸው እጅግ የጠቆረ፣ ትከሻቸው የሰፋ እና ደስ የሚል መአዛ እንዲሁም ከዚህም ውጭ የመልካም ተክለ ሰውነት መገለጫ ባህርይ ነበራቸው። </p>',
      ],
      31 => [
        'question' => 'ጥ 31፡ ነብዩ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን ኡመታቸውን (ህዝባቸውን) የተዉት በምን ሁኔታ ላይ ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6910.mp3',
        'answer' => '<p> መልስ - ነብዩ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን ኡመታቸውን ጥፋ ያለው ካልሆነ በቀር በማይሳሳትበት ነጭ ሆኖ ፍንትው ባለ ግልፅ ማስረጃ ላይ ነው የተውት። የትኛውንም ኸይር ነገር ኡመታቸውን ጠቁመዋል፤ ከየተኛውም ሸር ነገር ደግሞ ኡመታቸውን አስጠንቅቀዋል። </p>',
      ],
    ],
    4 => [
      0 => [
        'question' => 'ጥ 1፡- አል-ፋቲሓን አንብብ እና ተፍሲሩንም አስቀምጥ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6960.mp3',
        'answer' => '<p> መልስ- ሱረቱ አል\'ፋቲሓ እና ተፍሲሩ፡-<br /> {"ቢስሚላሂ-ር-ሯሕማኒ-ር-ሯሒም" "በአላህ ስም እጅግ በጣም ሩኅሩህ በጣም አዛኝ በሆነው።"<span class="c2">(1)</span> <span class="c3">«አልሓምዱ ሊልላሂ ረቢል ዓለሚን»</span> <span class="c2">(ምስጋና ለዓለማት ጌታ ለአላህ የተገባው ነው)</span> <span class="c2">(2)</span> "አር-ሯሕማኒ-ር-ሯሒም" "እጅግ በጣም ርኅሩህ በጣም አዛኝ ለሆነው።"<span class="c2">(3)</span> <span class="c3">«ማሊኪ የውሚ‐ድ‐ዲን»</span> <span class="c2">(ትርጉሙም: የፍርዱ ቀን ባለቤት)</span> <span class="c2">(4)</span> <span class="c3">«ኢይ-ያከ ነዕቡዱ ወኢይያከ ነሰተዒን»</span> <span class="c2">(አንተን ብቻ እንገዛለን አንተንም ብቻ እርዳታን እንለምንሃለን)</span> <span class="c2">(5)</span> <span class="c3">«ኢህዲና‐ስ‐ሲሯጦል ሙስተቂም»</span> <span class="c2">(ትርጉሙም: ቀጥተኛውን መንገድ ምራን)</span> <span class="c2">(6)</span> <span class="c3">«ሲሯጦ‐ል‐ለዚነ አንዓምተ ዓለይሂም ቐይሪል መቕዱቢ ዓለይሂም ወለድዷሊን»</span> <span class="c2">(ትርጉሙም: የእነዚያ ፀጋህን የዋልክላቸውን ሰዎች መንገድ በነዚያ የተቆጣህባቸውን እና የተሳሳቱትንም አይደሉም። 7} <span class="c5">[ሱረትይ አል\'ፋቲሓ፡ 1 - 7]</span><br /> ተፍሲር፡<br /> ሱረቱል ፋቲሓ (የመክፈቻዋ ሱራ)</span> የተባለችበት ምክንያት የአላህ ኪታብ የሚጀረው በእርሷ ስለሆነው ነው።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001001.mp3"></audio> <span class="c4">{"በአላህ ስም እጅግ በጣም ሩኅሩህ በጣም አዛኝ በሆነው።"}</span> ቁርኣንን መቅራቴን በአላህ ስም እጀምራለሁ፤ በላቀው አላህ እታገዝ ዘንድ ስሙን በማውሳት በረካውንም እንዳገኝ።<br /> <span class="c4">{አላህ}</span> ማለት በእውነት የሚመለከው ብቸኛ ማለት ሲሆን ይህ ስያሜ ጥራት ይገባውና ከእርሱ ውጭ ማንም የሚጠራበት አይደለም።<br /> <span class="c4">{አር-ረሕማን}</span> ማለትም ሁሉንም ያካለለ የሰፊ እዝነት ባለቤት ነው።<br /> <span class="c4">{አር-ረሒም}</span> ማለትም ለምእመናኑ ልዩ እዝነት ያለው ነው።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001002.mp3"></audio> 2- <span class="c4">{"ምስጋና ለዓለማት ጌታ ለአላህ የተገባው ነው"}</span> ማለትም የውዳሴናም የፍፁምነትም ዓይነቶች ሁሉ ለአላህ ብቻ የተገባ ነው።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001003.mp3"></audio> 3- <span class="c4">{"እጅግ በጣም ርኅሩህ በጣም አዛኝ ለሆነው።"}</span> ማለትም ሁሉንም ነገር ያካለለ ሰፊ እዝነት ባለቤት እና ለምእመናን በልዩ ሁኔታ የሚደርስ የልዩ እዝነት ባለቤት ነው።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001004.mp3"></audio> 4- <span class="c4">{"የፍርዱ ቀን ባለቤት"}</span> ማለትም የምጽአት ቀን ባለቤቱ እርሱ ነው።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001005.mp3"></audio> 5- <span class="c2">("አንተን ብቻ እንገዛለን አንተንም ብቻ እርዳታን እንለምንሃለን")</span> ማለትም ካንተ ውጭ ሌላን ሳናመልክ በብቸኝነት እናመክልሃለን ፤ አንተን ብቻ እገዛ እንጠይቅሃለን።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001006.mp3"></audio> 6- <span class="c4">{"ቀጥተኛውን መንገድ ምራን"}</span> ማለትም ለእስልምና እና ለሱና መገጠም ነው።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001007.mp3"></audio> 7- <span class="c4">{"የእነዚያ ፀጋህን የዋልክላቸውን ሰዎች መንገድ በነዚያ የተቆጣህባቸውን እና የተሳሳቱትንም አይደሉም።"}</span> ማለትም የክርስቲያኖችንና የአይሁዶችን መንገድ ሳይሆን የነብያትና የአላህ ደጋግ ባሮች መንገድ ምራን ማለት ነው።<br /> ይህንን ከቀሩ በኋላ “አሚን” ማለቱ ሱና ነው። ማለትም የሚወደድ ነው። </p>',
      ],
      1 => [
        'question' => 'ጥ 2፡ ሱረቱል ዘልዘላን ቅራና ተፍሲሩን አስቀምጥ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/7130.mp3',
        'answer' => '<p> መልስ- ሱረቱል ዘልዘላህ እና ተፍሲሩ<br /> በአላህ ስም እጅግ በጣም ሩኅሩህ በጣም አዛኝ በሆነው።<br /> {ምድር <span class="c2">(በኀይል)</span> መንቀጥቀጥዋን በተንቀጠቀጠች ጊዜ፤ 1 * ምድር ሸክሞችዋን ባወጣችም ጊዜ፤ 2 * ሰውም ምን ሆነች? ባለ ጊዜ፤ 3 * በዚያ ቀን ወሬዎችዋን ትናገራለች። 4 * ጌታህ ለእርሷ በማሳወቁ ምክንያት። 5 * በዚያ ቀን ሰዎች ሥራዎቻቸውን <span class="c2">(ምንዳዋን)</span> እንዲያዩ ይደረጉ ዘንድ <span class="c2">(እንደየሥራቸው)</span> የተለያዩ ሆነው <span class="c2">(ከመቆሚያው ስፍራ)</span> ይመለሳሉ። 6 * የብናኝ ክብደት ያክልም መልካምን የሠራ ሰው ያገኘዋል። 7 * የብናኝ ክብደት ያክልም ክፉን የሠራ ሰው ያገኘዋል። 8} <span class="c5">[ሱረቱ-ዘልዘላህ፡ 1-8]</span><br /> ተፍሲር፡<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099001.mp3"></audio> 1- {ምድር <span class="c2">(በኀይል)</span> መንቀጥቀጥዋን በተንቀጠቀጠች ጊዜ፤ 1} ማለትም በዕለተ ትንሳኤ ከሚደርስባት ከባድ እንቅስቃሴ አንፃር ምድር በተንቀጠቀጠች ጊዜ።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099002.mp3"></audio> 2- <span class="c4">{"ምድር ሸክሞችዋን ባወጣችም ጊዜ፤ 2"}</span> ማለትም ምድር በሆዷ ውስጥ ያለውን ሙታንም ሌላውንም ባወጣች ጊዜ።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099003.mp3"></audio> 3- <span class="c4">{"ሰውም ምን ሆነች? ባለ ጊዜ፤ 3"}</span> የሰው ልጅ ግራ ተጋብቶ "ምድር ምን ነክቷት ነው የምትንቀጠቀጠውና የምትናወጠው?!" ይላል።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099004.mp3"></audio> 4- <span class="c4">{"በዚያ ቀን ወሬዎችዋን ትናገራለች። 4"}</span> በዚያ ከባድ ቀን ምድር እርሷ ላይ የተደረገውን መልካምና ክፉውን ሁሉ ምድሪቱ ትዘከዝከዋለች።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099005.mp3"></audio> 5- <span class="c4">{"ጌታህ ለእርሷ በማሳወቁ ምክንያት። 5"}</span> ምክንያቱም አላህ ስላሳወቃትና እንድትናገርም ስላዘዛት ነው።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099006.mp3"></audio> 6- {"በዚያ ቀን ሰዎች ሥራዎቻቸውን <span class="c2">(ምንዳዋን)</span> እንዲያዩ ይደረጉ ዘንድ <span class="c2">(እንደየሥራቸው)</span> የተለያዩ ሆነው <span class="c2">(ከመቆሚያው ስፍራ)</span> ይመለሳሉ። 6"} በዚያ ምድሪቱ በምትናወጥበት ከባድ ቀን ሰዎች በዱኒያ ሳሉ የሰሩትን ሊመለከቱ ቡድን ቡድን እየሆኑ ወደ መተሳሰቢያው መስክ ይወጣሉ።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099007.mp3"></audio> 7- <span class="c4">{"የብናኝ ክብደት ያክልም መልካምን የሠራ ሰው ያገኘዋል። 7"}</span> በመሆኑም የትንሿን ትንኝ ክብደት ያህል እንኳ በጎ የሰራ ሰው ስራውን ፊት ለፊቱ ሆኖ ይመለከተዋል።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099008.mp3"></audio> 8- <span class="c4">{"የብናኝ ክብደት ያክልም ክፉን የሠራ ሰው ያገኘዋል። 8"}</span> በሷው ክብደት ልክ ክፉ ሥራ የሠራም ሰው እንዲሁ ስራውን ፊት ለፊቱ ሆኖ ይመለከተዋል። </p>',
      ],
      2 => [
        'question' => 'ጥያቄ 3፡ ሱረቱ አል\'ዓዲያትን ቅራና ተፍሲሩንም አስቀምጥ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/7270.mp3',
        'answer' => '<p> መልስ- ሱረቱ አል\'ዓዲያት እና ተፍሲሯ፡-<br /> በአላህ ስም እጅግ በጣም ሩኅሩህ በጣም አዛኝ በሆነው።<br /> {እያለከለኩ ሯጮች በሆኑት <span class="c2">(ፈረሶች)</span> እምላለሁ። 1 * <span class="c2">(በሰኮናቸው)</span> እያጋጩ እሳትን አውጪዎች በሆኑትም፤ 2 * በማለዳ ወራሪዎች በሆኑትም፤ 3 * በእርሱ አቧራን በቀሰቀሱትም፤ 4 * በ<span class="c2">(ጠላት)</span> ክቢ መካከል በእርሱ <span class="c2">(በጧት)</span> በተጋፈጡትም እምላለሁ። 5 * ሰው ለጌታው ብርቱ ከሓዲ ነው። 6 * እርሱም በዚህ ላይ መስካሪ ነው። 7 * እርሱም ገንዘብን ለመውደድ በጣም ብርቱ ነው። 8 * <span class="c2">(ሰው)</span> አያውቅምን? በመቃብሮች ያሉት <span class="c2">(ሙታን)</span> በተቀሰቀሱ ጊዜ፤ 9 * በልቦች ውስጥ ያለውም ሁሉ በተገለጸ ጊዜ <span class="c2">(እንዴት እንደሚሆን)</span>። 10 * ጌታቸው በዚያ ቀን በእነርሱ <span class="c2">(ነገር)</span> በእርግጥ ውስጠ አዋቂ ነው። 11} <span class="c5">[ሱረቱ አል\'ዓዲያት: 1-11]</span><br /> ተፍሲር፡<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100001.mp3"></audio> 1- {"እያለከለኩ ሯጮች በሆኑት <span class="c2">(ፈረሶች)</span> እምላለሁ። 1"} አላህ ከሩጫ ብዛት የሚያለከልኩት ድምጽ በሚሰማ በሆኑ ፈረሶች ማለ።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100002.mp3"></audio> 2- {"<span class="c2">(በሰኮናቸው)</span> እያጋጩ እሳትን አውጪዎች በሆኑትም፤ 2"} ቋጥኞችን በኋይለኛው በመምታታቸው ምክንያት በቋጥኙ ላይ ከሚያደርሱት ተጽእኖ አንፃር እሳትን በሚለኩሱ ፈረሶችም ማለ።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100003.mp3"></audio> 3- <span class="c4">{"በማለዳ ወራሪዎች በሆኑትም፤ 3"}</span> በማለዳው ጠላት ላይ የሚበረቱ በሆኑ ፈረሶችም ማለ።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100004.mp3"></audio> 4- <span class="c4">{"በእርሱ አቧራን በቀሰቀሱትም፤ 4"}</span> በሩጫቸው አቧራ የሚቀሰቅሱ በሆኑትም ማለ።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100005.mp3"></audio> 5- {"በ<span class="c2">(ጠላት)</span> ክቢ መካከል በእርሱ <span class="c2">(በጧት)</span> በተጋፈጡትም እምላለሁ። 5"} ፈረሰኞቻቸውም በርካታ በሆኑ ጠላቶች መካከል የሚሰርጉባቸው በሆኑ ማለ።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100006.mp3"></audio> 6- <span class="c4">{"ሰው ለጌታው ብርቱ ከሓዲ ነው። 6<br /> "}</span> ሰውም ጌታው ከርሱ የሚፈልገውን ደግ ነገር ከማድረግ ይነፍጋል።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100007.mp3"></audio> 7- <span class="c4">{"እርሱም በዚህ ላይ መስካሪ ነው። 7<br /> "}</span> መልካምን የሚከለክል መሆኑ ግልጽ በመሆኑ የማይክደው የሚመሰክረው ጉዳይ ነው።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100008.mp3"></audio> 8- <span class="c4">{"እርሱም ገንዘብን ለመውደድ በጣም ብርቱ ነው። 8<br /> "}</span> ለገንዘብም ድንበር ያለፈ ውዴታ ያለው በመሆኑም ንፉግ ነው።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100009.mp3"></audio> 9- {"<span class="c2">(ሰው)</span> አያውቅምን? በመቃብሮች ያሉት <span class="c2">(ሙታን)</span> በተቀሰቀሱ ጊዜ፤ 9"} ይህ በቅርቢቱ ሕይወት የተታለለ ሰው አላህ በመቃብር ውስጥ ያሉትን ሙታንን አስነስቶ ለመተሳሰብና ለፍርድም ከምድር በሚያስወጣቸው ጊዜ ነገሩ እንዳሰበው እንዳልሆነ አያውቅምን?!<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100010.mp3"></audio> 10- {"በልቦች ውስጥ ያለውም ሁሉ በተገለጸ ጊዜ <span class="c2">(እንዴት እንደሚሆን)</span>። 10"} ከሀሳብም ከእምነትም አኳያ በልቦች ውስጥ ያለውም ሌላውም ነገር ጎልቶና ግልፅ ሆኖ ይወጣል።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100011.mp3"></audio> 11- {"ጌታቸው በዚያ ቀን በእነርሱ <span class="c2">(ነገር)</span> በእርግጥ ውስጠ አዋቂ ነው። 11"} ጌታቸው በዚያ ቀን በነርሱ ላይ ዐዋቂ ነው። ከባሮቹ ምንም ነገር የማይደበቅበትና ለነርሱም በስራቸው ምንዳቸውን የሚከፍላቸው ነው። </p>',
      ],
      3 => [
        'question' => 'ጥ 4፡ ሱረቱል ቃሪዓን ቅራና ተፍሲሩንም ግለፅ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/7450.mp3',
        'answer' => '<p> መልስ-<span class="c6"> ሱረቱ አል\'ቃሪዓህ እና ተፍሲሩ:</span><br /> በአላህ ስም እጅግ በጣም ሩኅሩህ በጣም አዛኝ በሆነው።<br /> {ቆርቋሪይቱ <span class="c2">(ጩኸት)</span>፤ 1 * ምን አስደናቂ ቆርቋሪ ናት! 2 * ቆርቋሪይቱም ምን እንደሆነች ምን አሳወቀህ? 3 * ሰዎች እንደ ተበታተነ ቢራቢሮ <span class="c2">(ወይም ኩብኩባ)</span> በሚሆኑበት ቀን፤ 4 * ጋራዎችም እንደ ተነደፈ ሱፍ በሚሆኑበት <span class="c2">(ቀን ልቦችን በድንጋጤ ትቆረቁራለች።)</span> 5 * ሚዛኖቹ የከበዱለት ሰውማ፤ 6 * እርሱ በምትወደድ ኑሮ ውስጥ ይሆናል። 7 * ሚዛኖቹም የቀለሉበት ሰውማ፤ 8 * መኖሪያው ሃዊያህ ናት፤ 9 * እርሷም ምን እንደ ሆነች ምን አሳወቀህ? 10 * <span class="c2">(እርሷ)</span> በጣም ተኳሳ እሳት ናት።} <span class="c5">[ሱረቱል አል\'ቃሪዓህ 1-11]</span><br /> ተፍሲር፡<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101001.mp3"></audio> 1- {"{ቆርቋሪይቱ <span class="c2">(ጩኸት)</span>፤ 1"} ከአስፈሪነቷ አንፃር የሰዎችን ልብ የምታንኳኳ የሆነችው ሰዓት።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101002.mp3"></audio> 2- <span class="c4">{"ምን አስደናቂ ቆርቋሪ ናት! 2"}</span> ከአስፈሪነቷ አንፃር የሰዎችን ልብ የምታንኳኳ የሆነችው ሰዓት ምንድን ነች?!<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101003.mp3"></audio> 3- <span class="c4">{"ቆርቋሪይቱም ምን እንደሆነች ምን አሳወቀህ? 3"}</span> መልእክተኛ ሆይ! ከአስፈሪነቷ አንፃር የሰዎችን ልብ የምታንኳኳ የሆነችው ሰዓት ምንነት ምን የምታውቀው አለ?! እርሷ`ማ የቂያም ቀን ነች።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101004.mp3"></audio> 4- {"ሰዎች እንደ ተበታተነ ቢራቢሮ <span class="c2">(ወይም ኩብኩባ)</span> በሚኾኑበት ቀን፤ 4"} ሰዎች ልባቸው በሚቆረቆርበት ቀን እዚህም እዚያም ተበታትነው እንደተበተነ ቢራቢሮ <span class="c2">(ወይም ኩብኩባ)</span> ይሆናሉ።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101005.mp3"></audio> 5- {"ጋራዎችም እንደ ተነደፈ ሱፍ በሚሆኑበት <span class="c2">(ቀን ልቦችን በድንጋጤ ትቆረቁራለች።)</span> 5"} ተራሮችም ከእንቅስቃሴያቸው ቀላልነት አንፃር እንደ ክፍት ሱፍ ይሆናሉ።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101006.mp3"></audio> 6- <span class="c4">{"ሚዛኖቹ የከበዱለት ሰውማ፤ 6"}</span> መልካም ስራው ከመጥፎ ስራው የሚበልጥ የሆነለት ሰው`ማ።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101007.mp3"></audio> 7- <span class="c4">{"እርሱ በምትወደድ ኑሮ ውስጥ ይሆናል። 7"}</span> ጀነት ውስጥ በተጎናፀፈው አጥጋቢ ህይወት ላይ ነው።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101008.mp3"></audio> 8- <span class="c4">{"ሚዛኖቹም የቀለሉበት ሰውማ፤ 8"}</span> መጥፎ ስራው ከመልካም ስራው የሚበልጥ የሆነበት ሰው`ማ።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101009.mp3"></audio> 9- <span class="c4">{"መኖሪያው ሃዊያህ ናት፤ 9"}</span> በእለተ ትንሳኤ መኖሪያ እና ማረፊያው ጀሀነም ነው።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101010.mp3"></audio> 10- <span class="c4">{"እርሷም ምን እንደ ሆነች ምን አሳወቀህ? 10"}</span> አንተ መልእክተኛ ሆይ! - ምን እንደሆነች ምን አሳወቀህ?!<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101011.mp3"></audio> 11- {"<span class="c2">(እርሷ)</span> በጣም ተኳሳ እሳት ናት።"} እርሷ ትኩሳቷ የበረታ እሳት ነች። </p>',
      ],
      4 => [
        'question' => 'ጥ5፡ ሱረቱ ተካሡርን ቅራና ተፍሲሩንም ግለፅ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/7610.mp3',
        'answer' => '<p> መልስ- ሱረቱ ተካሡር እና ተፍሲሩ፦<br /> በአላህ ስም እጅግ በጣም ሩኅሩህ በጣም አዛኝ በሆነው።<br /> {በብዛት መፎካከር <span class="c2">(ጌታችሁን ከመገዛት)</span> አዘነጋችሁ። 1 * መቃብሮችን እስከ ጎበኛችሁ ድረስ። 2 * ተከልከሉ፤ ወደፊት <span class="c2">(ውጤቱን)</span> ታውቃላችሁ። 3 * ከዚያም ተከልከሉ፤ ወደ ፊት ታውቃላችሁ። 4 * በእውነቱ <span class="c2">(የሚጠብቃችሁን)</span> እርግጠኛ ዕውቀትን ብታውቁ ኖሮ፤ <span class="c2">(ባልዘናጋችሁ ነበር)</span>። 5 * ገሀነምን በርግጥ ታያላችሁ። 6 * ከዚያም እርግጠኛን ማየት ታዩዋታላችሁ። 7 * ከዚያም ከድሎታችሁ ሁሉ በዚያ ቀን ትጠየቃላችሁ። 8} <span class="c5">[ሱረቱ ተካሡር: 1-8]</span><br /> ተፍሲር፡<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102001.mp3"></audio> 1- {"{በብዛት መፎካከር <span class="c2">(ጌታችሁን ከመገዛት)</span> አዘነጋችሁ። 1"} ሰዎች ሆይ! በገንዘብና በልጆች መፎካከራችሁ አላህን ከመገዛት አዘነጋችሁ።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102002.mp3"></audio> 2- <span class="c4">{"መቃብሮችን እስከ ጎበኛችሁ ድረስ። 2"}</span> ሞታችሁ ወደ መቃብራችሁ እስክትገቡ ድረስ አዘነጋችሁ።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102003.mp3"></audio> 3- {"ተከልከሉ፤ ወደፊት <span class="c2">(ውጤቱን)</span> ታውቃላችሁ። 3"} በእርሷ መፎካከራችሁ አላህን ከመታዘዝ ሊያዘናጋችሁ የሚገባ አይደለም። የዚህ መዘናጋታችሁ መጨረሻውን ታዩታላችሁ።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102004.mp3"></audio> 4- <span class="c4">{"ከዚያም ተከልከሉ፤ ወደ ፊት ታውቃላችሁ። 4"}</span> አሁንም ፍፃሜውን ታውቃላችሁ።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102005.mp3"></audio> 5- {"በእውነቱ <span class="c2">(የሚጠብቃችሁን)</span> እርግጠኛ ዕውቀትን ብታውቁ ኖሮ፤ <span class="c2">(ባልዘናጋችሁ ነበር)</span>። 5"} በእርግጥ ወደ አላህ ተመላሾች መሆናችሁንና በሥራችሁንም እንደሚመነዳችሁ በእርግጠኝነት ብታውቁ ኖሮ በገንዘብና በልጆች መፎካከር ላይ አትጠመዱም ነበር።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102006.mp3"></audio> 6- <span class="c4">{"ገሀነምን በርግጥ ታያላችሁ። 6"}</span> በመሀላ አስረግጨ እናገራለሁ በእለተ ትንሣኤ እሳትን ትመለከታላችሁ።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102007.mp3"></audio> 7- <span class="c4">{"ከዚያም እርግጠኛን ማየት ታዩዋታላችሁ። 7"}</span> ከዚያም ያለምንም ጥርጥር በተጨባጭ ትመለከቷታላችሁ።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102008.mp3"></audio> 8- <span class="c4">{"ከዚያም ከድሎታችሁ ሁሉ በዚያ ቀን ትጠየቃላችሁ። 8"}</span> ከዚያም አላህ በዚያን ቀን ከጤናም ከሀብትም ከሌሎችም ፀጋዎች በኩል ስለዋለላችሁ ውለታ ይጠይቃችኋል። </p>',
      ],
      5 => [
        'question' => 'ጥ 6፡ ሱረቱ አል\'ዐስርን ቅራና ተፍሲሩን ግለፅ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/7750.mp3',
        'answer' => '<p> መልስ - ሱረቱል ዐስር እና ተፍሲሯ፦<br /> በአላህ ስም እጅግ በጣም ሩኅሩህ በጣም አዛኝ በሆነው።<br /> <span class="c4">{በጊዚያቱ እምላለሁ፤ 1 * ሰው ሁሉ በእርግጥ በከሳራ ውስጥ ነው። 2 * እነዚያ ያመኑትና መልካሞችን የሠሩት፣ በእውነትም አደራ የተባባሉት፣ በመታገስም አደራ የተባባሉት ብቻ ሲቀሩ። 3}</span> <span class="c5">[ሱረቱል ዐስር: 1-3]</span><br /> ተፍሲር፡<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/103001.mp3"></audio> 1- <span class="c4">{በጊዚያቱ እምላለሁ፤ 1}</span> ጥራት ይገባውና በጊዜያቱ ማለ።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/103002.mp3"></audio> 2- <span class="c4">{ሰው ሁሉ በእርግጥ በከሳራ ውስጥ ነው። 2}</span> ማለትም፡- የሰው ልጆች ሁሉ በውድቀት እና በጥፋት ላይ ናቸው።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/103003.mp3"></audio> 3- <span class="c4">{እነዚያ ያመኑትና መልካሞችን የሠሩት፣ በእውነትም አደራ የተባባሉት፣ በመታገስም አደራ የተባባሉት ብቻ ሲቀሩ። 3}</span> እነዚያ አማኝ ሆነው መልካም ሥራዎችንም የሠሩት፤ ወደ እውነትም የተጣሩ በርሱም ላይ የታገሡት ከኪሳራ የዳኑ ናቸው። </p>',
      ],
      6 => [
        'question' => 'ጥ 7፡ ሱረቱል ሁመዛህን ቅራ እና ተፍሲሯንም አስቀምጥ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/7830.mp3',
        'answer' => '<p> መልስ - ሱረቱል ሁመዛህ እና ተፍሲሯ፦<br /> በአላህ ስም እጅግ በጣም ሩኅሩህ በጣም አዛኝ በሆነው።<br /> {ለሃሜተኛ ለዘላፊ ሁሉ ወዮለት። 1 * ለዚያ ገንዘብን የሰበሰበና የቆጣጠረው <span class="c2">(ያደለበውም)</span> ለሆነ ፤<span class="c2">(ወዮለት)</span>። 2 * ገንዘቡ የሚያዘወትረው መሆኑን ያስባል። 3 * ይከልከል፤ በሰባሪይቱ <span class="c2">(እሳት)</span> ውስጥ በእርግጥ ይጣላል። 4 * ሰባሪይቱም ምን እንደ ሆነች ምን አሳወቀህ? 5 * የተነደደችው የአላህ እሳት ናት። 6 * ያቺ በልቦች ላይ የምትዘልቅ የሆነችው። 7 * እርሷ በእርግጥ በእነርሱ ላይ የተዘጋጀች ናት። 8 * በተዘረጋች አዕማድ ውስጥ <span class="c2">(የተዘጋች ናት)</span>። 9 <span class="c5">[ሱረቱ አል-<span class="c6">ሁመዛህ:</span> 1-9]</span><br /> ተፍሲር፡<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104001.mp3"></audio> 1- <span class="c4">{ለሃሜተኛ ለዘላፊ ሁሉ ወዮለት። 1}</span> ሰዎችን አብዝቶ ለሚያማ እና ለሚዘልፍ ሰው የመከራ እና የስቃይ ቅጣት አለበት።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104002.mp3"></audio> 2- {ለዚያ ገንዘብን የሰበሰበና የቆጣጠረው <span class="c2">(ያደለበውም)</span> ለሆነ ፤<span class="c2">(ወዮለት)</span>። 2} ለዛ ገንዘብ ከመሰብሰብና ከመቁጠር ውጭ ሌላ ሀሳብ ለሌለው ወዮለት።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104003.mp3"></audio> 3- <span class="c4">{ገንዘቡ የሚያዘወትረው መሆኑን ያስባል። 3}</span> የሰበሰበው ገንዘብ ከሞት ያድነዉና በዱንያ ህይወትም የሚያዘወትረው ይመስለዋል።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104004.mp3"></audio> 4- {ይከልከል፤ በሰባሪይቱ <span class="c2">(እሳት)</span> ውስጥ በእርግጥ ይጣላል። 4} ጉዳዩ ይህ አላዋቂ እንዳሰበው አይደለም። ይልቁን ከከባድነቷ አንፃር የተወረወረላትን ሁሉ የምትፈጭና የምትሰባብር ወደሆነችው የጀሀነም እሳት ይወረወራል።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104005.mp3"></audio> 5- <span class="c4">{ሰባሪይቱም ምን እንደ ሆነች ምን አሳወቀህ? 5}</span> የአላህ መልእክተኛ ሆይ! ይህች የተጣለላትን ሁሉ የምትፈጨው እሳት ምንነት ምን አሳወቀህ?!<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104006.mp3"></audio> 6- <span class="c4">{የተነደደችው የአላህ እሳት ናት። 6}</span> እርሷ የምትቀጣጠል የአላህ እሳት ነች።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104007.mp3"></audio> 7- <span class="c4">{ያቺ በልቦች ላይ የምትዘልቅ የሆነችው። 7}</span> በሰዎች አካል ወደ ልባቸው ዘልቃ የምትገባ ነች።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104008.mp3"></audio> 8- <span class="c4">{እርሷ በእርግጥ በእነርሱ ላይ የተዘጋጀች ናት። 8}</span> በውስጧ ለሚሰቃዩባትም የምትቆለፍባቸው ነች።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104009.mp3"></audio> 9- {በተዘረጋች አዕማድ ውስጥ <span class="c2">(የተዘጋች ናት)</span>። 9} ከውስጧም እንዳይወጡ በተዘረጉ ረዣዥም አዕማድ የተዘጋች ነች። </p>',
      ],
      7 => [
        'question' => 'ጥ 8፡ ሱረቱል ፊልን ቅራ እና ተፍሲሯንም አስቀምጥ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/7970.mp3',
        'answer' => '<p> መልስ - ሱረቱል ፊል እና ተፍሲሯ፦<br /> በአላህ ስም እጅግ በጣም ሩኅሩህ በጣም አዛኝ በሆነው።<br /> {በዝሆኑ ባለቤቶች ጌታህ እንዴት እንደሠራ አላወቅህምን? 1 * ተንኮላቸውን በጥፋት ውስጥ <span class="c2">(ከንቱ)</span> አላደረገምን? <span class="c2">(አድርጓል)</span>። 2 * በእነርሱም ላይ መንጎች የሆኑን ዎፎች ላከ። 3 * ከተጠበሰ ጭቃ በሆነ ድንጋይ የምትወረውርባቸው የሆነችን፤ <span class="c2">(አዕዋፍ)</span>። 4 * ቅጠሉ እንደ ተበላ አዝመራም አደረጋቸው። 5} <span class="c5">[ሱረቱል ፊል: 1-5]</span><br /> ተፍሲር፡<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105001.mp3"></audio> 1- <span class="c4">{በዝሆኑ ባለቤቶች ጌታህ እንዴት እንደሠራ አላወቅህምን? 1}</span> አንተ የአላህ መልእክተኛው ሆይ! እነዚያ የዝሆን ባለቤቶች የሆኑት አብርሃና ባልደረቦቹ ካዕባን ለማውደም በፈለጉ ጊዜ ጌታህ እንዴት እንዳደረጋቸው አታውቅምን?!<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105002.mp3"></audio> 2- {ተንኮላቸውን በጥፋት ውስጥ <span class="c2">(ከንቱ)</span> አላደረገምን? <span class="c2">(አድርጓል)</span>። 2} ለማውደም ያቀዱበትን መጥፎ ጥንስሳቸውን ከንቱ አደረገባቸው። ሰዎችን ከካዕባ ከማዘናጋት አንፃር የፈለጉትንም አላገኙ፤ ከተንኮላቸው አንዳች ነገርንም አላተረፉም።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105003.mp3"></audio> 3- <span class="c4">{በእነርሱም ላይ መንጎች የኾኑን ዎፎች ላከ። 3}</span> በእነርሱም ላይ አእዋፍን በቡድን በቡድን አድርጎ ላከባቸው።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105004.mp3"></audio> 4- {ከተጠበሰ ጭቃ በሆነ ድንጋይ የምትወረውርባቸው የኾነችን፤ <span class="c2">(አዕዋፍ)</span>። 4} ከተጠበሰ ሸክላ የሆነን ድንጋይ ትወረውርባቸዋለች።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105005.mp3"></audio> 5- <span class="c4">{ቅጠሉ እንደ ተበላ አዝመራም አደረጋቸው። 5}</span> አላህም በእንስሳት ተበልቶ እንደተጣለ ቅጠል አደረጋቸው። </p>',
      ],
      8 => [
        'question' => 'ጥ 9፡ ሱረቱል ቁረይሽን ቅራ እና ተፍሲሯንም አስቀምጥ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/8070.mp3',
        'answer' => '<p> መልስ- ሱረቱ ቁረይሽ እና ተፍሲሯ፦<br /> በአላህ ስም እጅግ በጣም ሩኅሩህ በጣም አዛኝ በሆነው።<br /> {ቁረይሾችን ለማላመድ<span class="c2">(ባለዝሆኖቹን አጠፋ)</span>። 1 * የብርድና የበጋን ወራት ጉዞ ሊያላምዳቸው ይህንን ሠራ። 2 * ስለዚህ የዚህን ቤት <span class="c2">(የከዕባን)</span> ጌታ ይግገዙ። 3 * ያንን ከረኃብ ያበላቸውን ከፍርሃትም ያረካቸውን <span class="c2">(ጌታ ያምልኩ)</span>። 4} <span class="c2">(ሱረቱ ቁረይሽ፡ 1-4)</span>።<br /> ተፍሲር፡<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106001.mp3"></audio> 1- {ቁረይሾችን ለማላመድ <span class="c2">(ባለዝሆኖቹን አጠፋ)</span>። 1} በክረምት እና በበጋ ወቅት የለመዱትን ጉዞ የተመለከተ ነው።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106002.mp3"></audio> 2- <span class="c4">{የብርድና የበጋን ወራት ጉዞ ሊያላምዳቸው ይህንን ሠራ። 2}</span> በክረምት ወደ የመን እና በበጋ ደግሞ ወደ ሻም የሚያደርጉት ጉዞ ነው።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106003.mp3"></audio> 3- {ስለዚህ የዚህን ቤት <span class="c2">(የከዕባን)</span> ጌታ ይግገዙ። 3} የዚህ የተቀደሰ ቤት ጌታ የሆነውን እና ይህንንም ጉዞ ያገራላቸውን አላህን በርሱም ምንንም ሳያጋሩ እርሱን ብቻ ያምልኩ።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106004.mp3"></audio> 4- {ያንን ከረኃብ ያበላቸውን ከፍርሃትም ያረካቸውን <span class="c2">(ጌታ ያምልኩ)</span>። 4} ያም በዓረቦች ልቦና ውስጥ ባሳፈነው የሐረምን እና የነዋሪዎቹን ክብር በማላቅ ከረሃብ መግቧቸው ከፍርሃትም ያዳናቸው ነው። </p>',
      ],
      9 => [
        'question' => 'ጥ 10፡ ሱረቱል ማዑንን ቅራ እና ተፍሲሯንም አስቀምጥ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/8160.mp3',
        'answer' => '<p> መልስ - ሱረቱል ማዑን እና ተፍሲሯ፦<br /> በአላህ ስም እጅግ በጣም ሩኅሩህ በጣም አዛኝ በሆነው።<br /> {ያንን በምርመራው የሚያስተባብለውን አየህን? <span class="c2">(ዐወቅከውን?)</span> 1 * ይህም ያ የቲምን በኀይል የሚገፈትረው፤ 2 * ድኻንም በማብላት ላይ የማያግባባው ሰው ነው። 3 * ለሚሰግዱ ወዮላቸው፤ 4 * ለእነዚያ እነርሱ ከስግደታቸው ዘንጊዎች ለኾኑት፤ <span class="c2">(ሰጋጆች)</span>። 5 * ለእነዚያ እነርሱ ይዩልኝ ባዮች ለሆኑት። 6 * የዕቃ ትውስትንም <span class="c2">(ሰዎችን)</span> የሚከለክሉ ለሆኑት <span class="c2">(ወዮላቸው)</span>። 7} <span class="c5">[ሱረቱ አል\'ማዑን 1-7]</span><br /> ተፍሲር፡<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107001.mp3"></audio> 1- {ያንን በምርመራው የሚያስተባብለውን አየህን? <span class="c2">(ዐወቅከውን?)</span> 1} የትንሣኤ ቀን ምንዳን ያስተባበለውን አወቅከውን?<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107002.mp3"></audio> 2- <span class="c4">{ይህም ያ የቲምን በኀይል የሚገፈትረው፤ 2}</span> ያ ወላጅ አልባን ከጉዳዩ በኋይል የሚገፈትረው ነው።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107003.mp3"></audio> 3- <span class="c4">{ድኻንም በማብላት ላይ የማያግባባው ሰው ነው። 3}</span> ራሱንም ይሁን ሌሎች ድሆችን እንዲመግቡ አያነሳሳም።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107004.mp3"></audio> 4- <span class="c4">{ለሚሰግዱ ወዮላቸው፤ 4}</span> ጣፋትና ስቃይ ለሰጋጆች ሆነ።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107005.mp3"></audio> 5- {ለእነዚያ እነርሱ ከስግደታቸው ዘንጊዎች ለሆኑት፤ <span class="c2">(ሰጋጆች)</span>። 5} ለነዚያ ምንም ሳያሳስባቸው በሶላታቸው ለሚቀልዱት ሰጋጆች ሆነ።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107006.mp3"></audio> 6- <span class="c4">{ለእነዚያ እነርሱ ይዩልኝ ባዮች ለሆኑት። 6}</span> ለነዚያ ሰላታቸውና ሥራዎቻቸው ለይዩልኝ ይስሙልኝ ለሆኑ፤ ለአላህም ብለው ኢኽላሳቸውን ለማያጠሩ ሰዎች ሆነ።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107007.mp3"></audio> 7- {የዕቃ ትውስትንም <span class="c2">(ሰዎችን)</span> የሚከለክሉ ለሆኑት <span class="c2">(ወዮላቸው)</span>። 7} እናም ሌሎችን ቢረዱበት ምንም ጉዳት በማይደርስባቸው ጉዳይም ሌሎችን ከመርዳት የሚታቀቡ ለሆኑት ወዮላቸው። </p>',
      ],
      10 => [
        'question' => 'ጥ 11፡ ሱረቱል ከውሠርን ቅራ እና ተፍሲሯንም አስቀምጥ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/8280.mp3',
        'answer' => '<p> መልስ - ሱረቱል ከውሠር እና ተፍሲሯ፦<br /> በአላህ ስም እጅግ በጣም ሩኅሩህ በጣም አዛኝ በሆነው።<br /> {እኛ በጣም ብዙ በጎ ነገሮችን ሰጠንህ። 1 * ስለዚህ ለጌታህ ስገድ፤ <span class="c2">(በስሙ)</span> ሰዋም። 2 * ጠይህ <span class="c2">(የሚጠላህ)</span> እርሱ በእርግጥ <span class="c2">(ዘሩ)</span> የተቆረጠው ነው። 3 <span class="c5">[ሱረቱል ከውሠር፡ 1-3]</span><br /> ተፍሲር፡<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/108001.mp3"></audio> 1- <span class="c4">{እኛ በጣም ብዙ በጎ ነገሮችን ሰጠንህ። 1}</span> አንተ የአላህ መልዕክተኛው ሆይ! ብዙ መልካም ነገርን ሰጥተንሀል፤ ከነርሱም በጀነት ውስጥ ያለውን የአል-ከውሠር ወንዝ ይገኝበታል።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/108002.mp3"></audio> 2- {ስለዚህ ለጌታህ ስገድ፤ <span class="c2">(በስሙ)</span> ሰዋም። 2} በመሆኑም በአሏህ የሚያጋሩ ሰዎች ከሚፈፅሙት ሺርክ በተፃራሪው አንተ ደግሞ እርድህንም ሶላትህንም ለርሱ ብቻ በማድረግ ለዚህ ችሮታው አላህን አመስግነው።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/108003.mp3"></audio> 3- {ጠይህ <span class="c2">(የሚጠላህ)</span> እርሱ በእርግጥ <span class="c2">(ዘሩ)</span> የተቆረጠው ነው። 3} አንተን የሚጠላ ነው ከመልካም ነገር ሁሉ የተቆረጠና ቢወሳ እንኳ በክፋት ብቻ የሚወሳው። </p>',
      ],
      11 => [
        'question' => 'ጥ 12፡ ሱረቱል ካፊሩንን ቅራ እና ተፍሲሯንም አስቀምጥ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/8360.mp3',
        'answer' => '<p> መልስ - ሱረቱል ካፊሩን እና ተፍሲሯ፦<br /> በአላህ ስም እጅግ በጣም ሩኅሩህ በጣም አዛኝ በሆነው።<br /> {በላቸው «እናንተ ከሓዲዎች ሆይ! 1 * ያንን የምትግገዙትን <span class="c2">(ጣዖት አሁን)</span> አልግገዛም። 2 * እናንተም እኔ የምግገዛውን <span class="c2">(አምላክም አሁን)</span> ተገዢዎች አይደላችሁም። 3 * እኔም ያንን የተገዛችሁትን <span class="c2">(ወደፊት)</span> ተገዢ አይደለሁም። 4 * እናንተም እኔ የምግገዛውን <span class="c2">(አምላክም አሁን)</span> ተገዢዎች አይደላችሁም። 5 * ለእናንተ ሃይማኖታችሁ አልላችሁ። ለእኔም ሃይማኖቴ አለኝ። 6} <span class="c5">[ሱረቱል ካፊሩን፡ 1-6]</span><br /> ተፍሲር፡<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109001.mp3"></audio> 1- <span class="c4">{በላቸው «እናንተ ከሓዲዎች ሆይ! 1}</span> የአላህ መልዕክተኛ ሆይ! እንዲህ በላቸው፡ እናንተ በአላህ የካዳችሁ ከሀድያን ሆይ!<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109002.mp3"></audio> 2- {«ያንን የምትግገዙትን <span class="c2">(ጣዖት አሁን)</span> አልግገዛም። 2} እኔ አሁንም ይሁን ለወደፊት የምታመልኩትን ጣዖታት የማመልክ አይደለሁም።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109003.mp3"></audio> 3- {«እናንተም እኔ የምግገዛውን <span class="c2">(አምላክም አሁን)</span> ተገዢዎች አይደላችሁም። 3} እናንተም እኔ የማመልከውን ይሀውም አላህ በብቸኝነት አታመልኩም።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109004.mp3"></audio> 4- {«እኔም ያንን የተገዛችሁትን <span class="c2">(ወደፊት)</span> ተገዢ አይደለሁም። 4} እኔም እናንተ የምታመልኳቸውን ጣዖታት አላመልክም።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109005.mp3"></audio> 5- {«እናንተም እኔ የምግገዛውን <span class="c2">(አምላክም አሁን)</span> ተገዢዎች አይደላችሁም። 3} እናንተም እኔ የማመልከውን አላህ በብቸኝነት አታመልኩም።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109006.mp3"></audio> 6- <span class="c4">{«ለእናንተ ሃይማኖታችሁ አልላችሁ። ለእኔም ሃይማኖቴ አለኝ። 6}</span> እናንተም ለራሳችሁ የፈለሰፋችሁት መጤ ሃይማኖት አላችሁ፤ እኔም አላህ ወደኔ ያወረደልኝ ሃይማኖቴ አለኝ። </p>',
      ],
      12 => [
        'question' => 'ጥ 13፡ ሱረቱል ነስርን ቅራ እና ተፍሲሯንም አስቀምጥ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/8470.mp3',
        'answer' => '<p> መልስ -<span class="c6"> ሱረቱል ነስር እና ተፍሲሯ:</span><br /> በአላህ ስም እጅግ በጣም ሩኅሩህ በጣም አዛኝ በሆነው።<br /> {የአላህ እርዳታና <span class="c2">(መካን)</span> መክፈት በመጣ ጊዜ፤ 1 * ሰዎችንም ጭፍሮች እየሆኑ፤ በአላህ ሃይማኖት ውስጥ ሲገቡ ባየህ ጊዜ፤ 2 * ጌታህን ከማመስገን ጋር አጥራው። ምሕረትንም ለምነው። እርሱ ጸጸትን በጣም ተቀባይ ነውና። 3} <span class="c5">[ሱረቱ አል\'ነስር፡ 1-3]</span><br /> ተፍሲር፡<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/110001.mp3"></audio> 1- {የአላህ እርዳታና <span class="c2">(መካን)</span> መክፈት በመጣ ጊዜ፤ 1} የአላህ መልዕክተኛ ሆይ! አላህ እርዳታውን ለግሷችሁ በሃይማኖታችሁ ድልን ባጎናፀፋችሁ፤ ሃይማኖቱንም በረዳና የመካ መከፈትም በተከስተ ጊዜ።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/110002.mp3"></audio> 2- <span class="c4">{ሰዎችንም ጭፍሮች እየሆኑ፤ በአላህ ሃይማኖት ውስጥ ሲገቡ ባየህ ጊዜ፤ 2}</span> ሰዎችንም በቡድን በቡድን እየሆኑ ወደ እስልምና ሲገቡ ባየህ ጊዜ።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/110003.mp3"></audio> 3- <span class="c4">{ጌታህን ከማመስገን ጋር አጥራው። ምሕረትንም ለምነው። እርሱ ጸጸትን በጣም ተቀባይ ነውና። 3}</span> የተላክህበት ተልዕኮ መጠናቀቁን የሚያሳይ ምልክት መሆኑን ተረድተህ ለዋለልህ የድል ፀጋ ምስጋና ለማቅረብ ጌታህን እያመሰገንከው ውዳሴን አቅርብ፤ እነሆ እርሱ የባሮቹን ንስሀ ተቀባይና ባሮቹንም ይቅር ባይ ነውና መሀርታውን ለምነው። </p>',
      ],
      13 => [
        'question' => 'ጥ 14፡ ሱረቱል መሰድን ቅራ እና ተፍሲሯንም አስቀምጥ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/8550.mp3',
        'answer' => '<p> መልስ - ሱረቱል መሰድ እና ተፍሲሯ፦<br /> በአላህ ስም እጅግ በጣም ሩኅሩህ በጣም አዛኝ በሆነው።<br /> {የአቡ ለሀብ ሁለት እጆች ከሰሩ <span class="c2">(ጠፉ፤ እርሱ)</span> ከሰረም። 1 * ከእርሱ ገንዘቡና ያም ያፈራው ሁሉ ምንም አልጠቀመውም። 2 * የመንቀልቀል ባለቤት የሆነችን እሳት በእርግጥ ይገባል። 3 * ሚስቱም <span class="c2">(ትገባለች)</span>፤ እንጨት ተሸካሚ ስትሆን። 4 * በአንገትዋ ላይ ከጭረት የሆነ ገመድ ያለባት ስትሆን። 5} <span class="c5">[ሱረቱ አል\'መሰድ፡ 1-5]</span><br /> ተፍሲር፡<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111001.mp3"></audio> 1- {የአቡ ለሀብ ሁለት እጆች ከሰሩ <span class="c2">(ጠፉ፤ እርሱ)</span> ከሰረም። 1} የነብዩ ﷺ አጎት የሆነው አቡ ለሀብ ቢን ዐብዱል ሙጠሊብ ነብዩን ﷺ አዛ ሲያደርግ የነበረ በመሆኑ ስራው ኪሳራ ሆኖበት እጁ ከሰረ እንቅስቃሴውም ከንቱ ሆነ።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111002.mp3"></audio> 2- <span class="c4">{ከእርሱ ገንዘቡና ያም ያፈራው ሁሉ ምንም አልጠቀመውም። 2}</span> ገንዘቡ እና ልጁ እርሱን የጠቀሙት ምንድን ነው? ቅጣትን ከርሱ ሊያስቀሩለትም ሆነ እዝነትን ሊያመጡለት አልቻሉም።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111003.mp3"></audio> 3- <span class="c4">{የመንቀልቀል ባለቤት የሆነችን እሳት በእርግጥ ይገባል። 3}</span> በትንሳኤ ቀን ነበልባሏ አቃጣይ ወደ ሆነች እሳት ይገባታል።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111004.mp3"></audio> 4- {ሚስቱም <span class="c2">(ትገባለች)</span>፤ እንጨት ተሸካሚ ስትሆን። 4} ነብዩ ሶለሏሁ ዓለይሂ ወሰለምን በመንገዳቸው እሾህ እየጣለች የምታስቸግራቸው ሚስቱ ኡሙ ጀሚልም እንዲሁ ትገባታለች።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111005.mp3"></audio> 5- <span class="c4">{በአንገትዋ ላይ ከጭረት የሆነ ገመድ ያለባት ስትሆን። 5}</span> አንገቷ በተጠማዘዘ ገመድ ተቀፍድዳ ወደ ጀሀነም እሳት ትገባለች። </p>',
      ],
      14 => [
        'question' => 'ጥ 15፡ ሱረቱል ኢኽላስን ቅራ እና ተፍሲሯንም አስቀምጥ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/8650.mp3',
        'answer' => '<p> መልስ - ሱረቱል ኢኽላስ እና ተፍሲሯ፦<br /> በአላህ ስም እጅግ በጣም ሩኅሩህ በጣም አዛኝ በሆነው።<br /> {በል «እርሱ አላህ አንድ ነው። 1 * አሏህ <span class="c2">(የሁሉ)</span> መጠጊያ ነው። 2 * አልወለደም፤ አልተወለደምም። 3 * ለእርሱም አንድም ብጤ የለውም።» 4} <span class="c5">[ሱረቱል ኢኽላስ፡ 1-4]</span><br /> ተፍሲር፡<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112001.mp3"></audio> 1- <span class="c4">{በል «እርሱ አላህ አንድ ነው። 1}</span> የአላህ መልእክተኛ ሆይ! እንዲህ በላቸው፡- እርሱ አላህ ነው፤ ከእርሱ በቀርም ሌላ አምላክ የለም።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112002.mp3"></audio> 2- {«አላህ <span class="c2">(የሁሉ)</span> መጠጊያ ነው። 2} ማለትም፡- የፍጥረታት ሁሉ ፍላጎት ወደ እርሱ ነው።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112003.mp3"></audio> 3- {<span class="c3">«አልወለደም፤ አልተወለደምም። 3} ጥራት ይገባውና ለእርሱ ልጅም ወላጅም የለውም።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112004.mp3"></audio> 4- {«ለእርሱም አንድም ብጤ የለውም።»</span> 4} ከፍጡራኑም ለርሱ ምንም አምሳያ የለውም። </p>',
      ],
      15 => [
        'question' => 'ጥ 16፡ ሱረቱል ፈለቅን ቅራ እና ተፍሲሯንም አስቀምጥ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/8750.mp3',
        'answer' => '<p> መልስ - ሱረቱል ፈለቅ እና ተፍሲሯ፦<br /> በአላህ ስም እጅግ በጣም ሩኅሩህ በጣም አዛኝ በሆነው።<br /> {በል «በተፈልቃቂው ጎህ ጌታ እጠበቃለሁ። 1 * ከፈጠረው ፍጡር ሁሉ ክፋት። 2 * ከሌሊትም ክፋት ባጨለመ ጊዜ፤ 3 * በተቋጠሩ <span class="c2">(ክሮች)</span> ላይ ተፊዎች ከሆኑት <span class="c2">(ደጋሚ)</span> ሴቶችም ክፋት። 4 * ከምቀኛም ክፋት በተመቀኘ ጊዜ፤ <span class="c2">(እጠበቃለሁ በል)</span>።» 5} <span class="c5">[ሱረቱ አልፈለቅ፡ 1-5]</span><br /> ተፍሲር፡<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113001.mp3"></audio> 1- <span class="c4">{በል «በተፈልቃቂው ጎህ ጌታ እጠበቃለሁ። 1}</span> ማለትም፡- አንተ መልእክተኛ -፡ እኔ የማለዳውን ጌታ አጥብቄ እይዛለሁ፤ ጥበቃውንም እሻለሁ።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113002.mp3"></audio> 2- <span class="c4">{«ከፈጠረው ፍጡር ሁሉ ክፋት። 2}</span> ፍጡራንን ከሚያስቸግር ክፋት ሁሉ።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113003.mp3"></audio> 3- <span class="c4">{«ከሌሊትም ክፋት ባጨለመ ጊዜ፤ 3}</span> በሌሊት ከሚጎሉ የአውሬዎችም የሌቦችም ክፋት ለመዳን አሏህን አጥብቄ እይዛለሁ።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113004.mp3"></audio> 4- {«በተቋጠሩ <span class="c2">(ክሮች)</span> ላይ ተፊዎች ከሆኑት <span class="c2">(ደጋሚ)</span> ሴቶችም ክፋት። 4} በቋጠሮ ላይ የሚተፉ ከሆኑት ሴት ደጋሚዎችም ክፋት ለመዳን አላህን አጥብቄ እይዛለሁ።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113005.mp3"></audio> 5- {«ከምቀኛም ክፋት በተመቀኘ ጊዜ፤ <span class="c2">(እጠበቃለሁ በል)</span>።» 5} ሰዎችን በተመቀኘ ጊዜ አሏህ የሰጣቸው ፀጋ እንዲወገድባቸውና ክፋትም እንዲያገኛቸው ከሚመኝ ምቀኛም ለመዳን አላህን አጥብቄ እይዛለሁ፤ ጥበቃውንም እሻለሁ። </p>',
      ],
      16 => [
        'question' => 'ጥ 17: ሱረቱ-ን-ናስን ቅራ እና ተፍሲሯንም አስቀምጥ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/8870.mp3',
        'answer' => '<p> መልስ - ሱረቱ ን-<span class="c6">ናስ እና ተፍሲሯ:</span><br /> በአላህ ስም እጅግ በጣም ሩኅሩህ በጣም አዛኝ በሆነው።<br /> {በል «በሰዎች ፈጣሪ እጠበቃለሁ። 1 * የሰዎች ሁሉ ንጉሥ በሆነው። 2 * የሰዎች አምላክ በሆነው። 3 * ብቅ እልም ባይ ከሆነው ጎትጓች <span class="c2">(ሰይጣን)</span> ክፋት። 4 * ከዚያ በሰዎች ልቦች ውስጥ የሚጎተጉት ከሆነው። 5 * ከጋኔኖችም ከሰዎችም <span class="c2">(ሰይጣናት እጠበቃለሁ በል)</span>።» 6} <span class="c5">[ሱረቱ አን-ናስ፡ 1-6]</span><br /> ተፍሲር፡<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114001.mp3"></audio> 1- <span class="c4">{በል «በሰዎች ፈጣሪ እጠበቃለሁ። 1}</span> አንተ የአሏህ መልዕክተኛ ሆይ! እንዲህ በላቸው፦ የሰዎችን ጌታ አጥብቄ እይዛለሁ፣ ጥበቃውንም እሻለሁ።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114002.mp3"></audio> 2- <span class="c4">{«የሰዎች ሁሉ ንጉሥ በሆነው። 2}</span> እንዳሻው ያደርጋቸዋል፤ ከእርሱም ሌላ ባለቤት የሌላቸው በሆነው።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114003.mp3"></audio> 3- <span class="c4">{«የሰዎች አምላክ በሆነው። 3}</span> በእውነት የሚያመልኩት አምላካቸው፤ ከእርሱም ውጭ ለነርሱ በእውነት የሚያመልኩት አምላክ የሌላቸው በሆነው።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114004.mp3"></audio> 4- {«ብቅ እልም ባይ ከሆነው ጎትጓች <span class="c2">(ሰይጣን)</span> ክፋት። 4} በሰዎች ላይ ሹክሹክታውን ከሚወረውር የሰይጣን ክፋት።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114005.mp3"></audio> 5- <span class="c4">{«ከዚያ በሰዎች ልቦች ውስጥ የሚጎተጉት ከሆነው። 5}</span> ሹክሹክታውን ወደ ሰዎች ልቦና ከሚወረውረው ሰይጣን ክፋት።<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114006.mp3"></audio> 6- {«ከጋኔኖችም ከሰዎችም <span class="c2">(ሰይጣናት እጠበቃለሁ በል)</span>።» 6} ማለትም ጉትጎታው ሰውም ይሁን ጂኒ ከክፋቱ ለመዳን የሰዎችን ጌታ አጥብቄ እይዛለሁ፣ ጥበቃውንም እሻለሁ። </p>',
      ],
    ],
    5 => [
      0 => [
        'question' => 'ጥ 1፡ "ስራዎች የሚለኩት በኒያቸው ነው።" የሚለውን ሐዲሥ ሙላና ከሐዲሡ የምናገኛቸውን የተወሰኑ ቁምነገሮች ጥቀስ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/9030.mp3',
        'answer' => '<p> መልስ - ከአሚረል ሙእሚኒን አቡ ሐፍስ ዑመር ኢብኑል ኸጧብ ረዲየላሁ ዐንሁ በተላለፈ ሐዲሥ እንዲህ ብለዋል፡- "የአላህ መልእክተኛ ሰለላሁ ዓለይሂ ወሰለም እንዲህ ሲሉ ሰምቻለሁ፡- "የትኛውም ድርጊት ዋጋው ከጀርባ ባለመው እሳቤ <span class="c2">(ኒያው)</span> ላይ የተመሰረተ ነው። ማንኛውም ሰው የሚመነዳውም ባለመው ብቻ ነው። ለአላህና ለመልዕክተኛው ሲል የተሰደደ ሰው የተሰደደው ለአላህና ለመልእክተኛው <span class="c2">(ሰለላሁ አለይሂ ወሰለም)</span> ሆኖለታል፤ የዱንያን ጥቅም ለማግኘት ወይም ሴትን ለማጨት ብሎ የተሰደደ ሰውም እንዲሁ መሰደዱ ለተሰደደለት ጉዳይ ነው።" ቡኻሪይ እና ሙስሊም ዘግበውታል።<br /> ከሓዲሡ ከሚወሰዱ ቁምነገሮች መካከል፡<br /> 1- ማንኛውም አምልኮ ሰላትም ሆነ ፆም፣ ሐጅም ይሁን ሌሎች ተግባራት ሁሉ ኒያ ሊኖራቸው የግድ ነው።<br /> 2 - ለላቀው አላህ ብሎ የሚያከናውን ሁሉ ኢኽላሱን ለአሏህ ብቻ ሊያጠራ ይገባል።<br /> * ሁለተኛው ሐዲሥ፡ </p>',
      ],
      1 => [
        'question' => 'ጥያቄ 2፡- “በዚሁ ጉዳያችን አዲስ ፈሊጥ ያመጣ...” የሚለውን ሐዲሥ ሙላና ከሐዲሡ የምናገኛቸውን የተወሰኑ ቁምነገሮችንም ጥቀስ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/9090.mp3',
        'answer' => '<p> መልስ- ከምእመናን እናት ኡሙ ዐብደሏህ ዓኢሻ ረዲየሏሁ ዐንሁማ በተላለፈ ሐዲሥ እንዲህ ብላለች፦ "የአላህ መልእክተኛ ሰለላሁ ዓለይሂ ወሰለም እንዲህ ብለዋል፡- "በዚሁ ጉዳያችን ከእርሱ ያልሆነን አዲስ ፈሊጥ ያመጣ ይዞት የመጣው ፈሊጥ ውድቅ ነው።" ቡኻሪይ እና ሙስሊም ዘግበውታል።<br /> ከሐዲሡ ከሚወሰዱ ቁምነገሮች መካከል፡<br /> 1- በሃይማኖት ውስጥ አዲስ ፈጠራ ማምጣት የተከለከለ መሆኑ።<br /> 2- አዲስ መጤ ስራዎች ተቀባይነት የሌላቸው ውድቅ መሆናቸው።<br /> * ሦስተኛው ሐዲሥ፡ </p>',
      ],
      2 => [
        'question' => 'ጥያቄ 3፡ "ረሱል ሶለሏሁ ዓለይሂ ወሰለም ዘንድ ተቀምጠን ሳለ..." የሚለውን ሐዲሥ ሙላና ከሐዲሡ የምናገኛቸውን የተወሰኑ ቁምነገሮችንም ጥቀስ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/9160.mp3',
        'answer' => '<p> «ከእለታት አንድ ቀን የአላህ መልእክተኛ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን ዘንድ ተቀምጠን ሳለን ልብሱ በጣም ነጭ ፀጉሩ በጣም ጥቁር የሆነ ሰው ብቅ አለ። የመንገደኛ ምልክትም አይታይበትም ከኛ መካከልም የሚያውቀው ሰው የለም። ወደ ነብዩ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን ተጠግቶ ጉልበቱን ከጉልበታቸው አስደግፎ ተቀመጠ። እጁንም ታፋው ላይ አደረገና <span class="c1">“አንተ ሙሐመድ ሆይ! እስኪ ስለ ኢስላም ንገረኝ?”</span> አላቸው። የአላህ መልዕክተኛም የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን ” ኢስላም ማለት ከአላህ በስተቀር በእውነት የሚመለክ አምላክ የለም ሙሐመድም የእርሱ መልዕክተኛ ናቸው ብለህ ልትመሰክር፣ ሶላት <span class="c2">(ስርአቱን አሟልተህ)</span> ልትሰግድ፣ ዘካን ልታወጣ፣ ረመዳንን ልትፆም፣ የጉዞውን ጣጣ ከቻልክ ደሞ ሐጅ ልታደርግ ነው።” አሉት። <span class="c1">“እውነት ብለሃል” አላቸው። “ራሱ ጠይቆ ራሱ ‘ትክክል ነህ’ ይላቸዋል ብለን ተገረምን!”</span>» <span class="c2">(ከዚያም)</span> «<span class="c1">“ስለኢማን ንገረኝ እስኪ!”</span> አላቸው። እርሳቸውም <span class="c1">“በአላህ፣ በመላእክቶቹ፣ በመጽሐፍቶቹ፣ በመልእክተኞቹ፣ በመጨረሻው ቀን ልታምንና በቀደርም ክፉውም ሆነ ደጉን ልታምን ነው።”</span> አሉት። <span class="c1">“እውነት ብለሃል!”</span> አላቸው። <span class="c1">“እስኪ ደሞ ስለ ኢሕሳን ንገረኝ!”</span> አላቸው። እርሳቸውም <span class="c1">“አላህን ልክ እንደምታየው ሆነህ ልታመልከው ነው፤ አንተ ባታየውም እርሱ ያይሃልና።”</span> <span class="c1">“ስለ ሰዓቲቱስ ንገረኝ እስኪ!”</span> አላቸው። እርሳቸውም <span class="c1">“ተጠያቂው ከጠያቂው የተሻለ የሚያውቀው ነገር የለም።”</span> አሉት። <span class="c1">“ስለምልክቶቹ ንገረኝ!”</span> አላቸው። እሳቸውም <span class="c1">“ሴት ባርያ ጌታዋን <span class="c2">(አለቃዋን)</span> መውለዷ፣ ጫማና ልብስ የሌላቸው የሆኑ እረኞች በህንፃ ሲወዳደሩ ታያለህ”</span> አሉትና ሄደ። ከዚያም ለተወሰነ ጊዜ ቆየን የአላህ መልዕክተኛም የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን ዑመር ሆይ! ጠያቂው ማን እንደነበር ታውቃለህ?” አሉኝ። እኔም <span class="c1">“አላህና መልዕክተኛው ይበልጥ ያውቃሉ”</span> አልኩኝ። እርሳቸውም <span class="c1">“ጂብሪል ነው! የዲናችሁን ጉዳይ ሊያስተምራችሁ መጥቶ<span class="c2">(ነው)</span>።”</span> አሉኝ። ሙስሊም ዘግበውታል።<br /> ከሐዲሡ ከሚወሰዱ ቁምነገሮች መካከል፡<br /> 1- አምስቱ የእስልምና መሰረቶች ተወስተዋል። እነርሱም፦<br /> <span class="c1">“ላ ኢላሃ ኢለሏህ ሙሐመዱን ረሱሉሏህ”</span> ብሎ በአሏህ ብቸኛ ተመላኪነትና በነብዩ ሙሐመድ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን የአሏህ መልዕክተኝነት መመስከር።<br /> ሰላትን አሟልቶ መስገድ።<br /> ዘካን መስጠት።<br /> የረመዳንን ወር መፆም።<br /> ወደ ተከበረው የአላህ ቤት ሂዶ ሐጅ ማድረግ።<br /> 2- የእምነት መሰረቶች ስድስት መሆናቸው። ስድስት ሲሆኑ እነርሱም፦<br /> በአላህ ማመን።<br /> በመላዕክቱ።<br /> በመጽሐፍቱ።<br /> በመልዕክተኞቹ።<br /> በመጨረሻው ቀን እና<br /> በክፉዉም በደጉም በቀደር ማመን ናቸው።<br /> 3-<span class="c6"> የኢሕሳን ምሰሶ ተወስቷል፤ እርሱም አንድ ምሰሶ ብቻ ያለው ሲሆን ይኸውም:</span> አሏህን ልክ እንደምታየው ሆነህ ልታመልከው ነው። አንተ ባታየውም እርሱ ያይሀልና።<br /> 4- ዕለተ ትንሣኤ ጊዜው መች እንደሆነ የሚያውቀው የላቀው አላህ ብቻ መሆኑን <span class="c2">(ተገልጿል)</span>።<br /> አራተኛው ሐዲሥ፡ </p>',
      ],
      3 => [
        'question' => 'ጥ 4፡- ‹‹ከሙእሚኖች መካከል ይበልጥ ኢማናቸው የተሟሉት...›› የሚለውን ሐዲሥ ሙላና ከሐዲሡ ከምናገኛቸው ቁምነገሮች የተወሰኑትንም ጥቀስ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/9360.mp3',
        'answer' => '<p> መልስ - ከአቡ ሁረይራ አላህ መልካም ሥራቸውን ይውደድላቸው በተላለፈ ሐዲሥ የአላህ መልዕክተኛ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን እንዲህ ብለዋል፦ <span class="c3">«ከሙእሚኖች መካከል ይበልጥ ኢማናቸው የተሟላው መልካም ሥነ-ምግባር ያላቸው ናቸው።»</span> ቲርሚዚይ ዘግበውታል፤ ሐዲሡንም «ሐሰኑን ሰሒሕ" ብለውታል።<br /> ከሐዲሡ የሚወሰዱ ቁምነገሮች፡<br /> 1- ለመልካም ስነምግባርን ማበረታታት <span class="c2">(ማነሳሳት)</span>፤<br /> 2- የስነምግባር መሟላት የኢማን መሟላት አካል መሆኑ፤<br /> 3- ኢማን የሚጨምርና የሚቀንስ መሆኑ፤<br /> አምስተኛው ሐዲሥ፡ </p>',
      ],
      4 => [
        'question' => 'ጥያቄ 5፡- ‹‹ከአላህ ውጭ ባለ አካል የማለ...›› የሚለውን ሐዲሥ ሙላና ከሐዲሡ ከምናገኛቸው ቁምነገሮች የተወሰኑትንም ጥቀስ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/9440.mp3',
        'answer' => '<p> መልስ - ከኢብኑ ዑመር ረዲየላሁ ዐንሁማ በተላለፈ ሐዲሥ ነብዩ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን እንዲህ ብለዋል፦ "ከአላህ ውጪ ባለ አካል <span class="c2">(በማንም)</span> የማለ በእርግጥም ሽርክን ወይም ክህደትን ፈፅሟል።" ቲርሚዚይ ዘግበውታል።<br /> ከሐዲሡ የሚወሰዱ ቁምነገሮች፡<br /> - በልዑል አምላካችን አላህ ካልሆነ በስተቀር በሌላ መማል እንደማይፈቀድ፤<br /> - ከላቀው አላህ ውጭ ባለ አካል መማል ከትንሹ ሺርክ መሆኑ<br /> ስድስተኛው ሐዲሥ፡ </p>',
      ],
      5 => [
        'question' => 'ጥ 6፡ “እኔ እርሱ ዘንድ ይበልጥ የተወደድኩ እስካልሆንኩ ድረስ እምነቱ አልተሟላም...” የሚለውን ሐዲሥ ሙላና ከሐዲሡ ከምናገኛቸው ቁምነገሮች መካከል የተወሰኑትንም ጥቀስ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/9510.mp3',
        'answer' => '<p> መልስ - ከአነስ ኢብኑ ማሊክ አላህ መልካም ሥራቸውን ይውደድላቸው በተላለፈ ሐዲሥ የአላህ መልዕክተኛ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን እንዲህ ብለዋል፦ «ከአባቱ፣ ከልጁ እና ከመላው የሰው ልጆችም ሁሉ እርሱ ዘንድ ይበልጥ ተወዳጅ የሆንኩት እኔ እስካልሆንኩለት ድረስ ማናችሁም ቢሆን አላመናችሁም።" ቡኻሪይ እና ሙስሊም ዘግበውታል።<br /> ከሐዲሡ ከሚወሰዱ ቁምነገሮች መካከል፡<br /> - ነቢዩ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን ከሰዎች ሁሉ በላይ ይበልጥ ተወዳጅ መሆን እንዳለባቸው፤<br /> - እርሳቸውን ከማንም በላይ መውደዱም ከኢማን ምሉእነት እንደሆነ፤<br /> ሰባተኛው ሐዲሥ </p>',
      ],
      6 => [
        'question' => 'ጥያቄ 7፡- ‹‹ማናችሁም ቢሆን ለወንድሙ እስኪወድ ድረስ ...›› የሚለውን ሐዲሥ ሙላና ከሐዲሡ ከምናገኛቸው ቁምነገሮች መካከልም የተወሰኑትን ጥቀስ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/9580.mp3',
        'answer' => '<p> መልስ - ከአነስ ኢብኑ ማሊክ አላህ መልካም ሥራቸውን ይውደድላቸው በተላለፈ ሐዲሥ የአላህ መልዕክተኛ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን እንዲህ ብለዋል፦ «ማናችሁም ቢሆን ለራሱ የሚወደውን ለወንድሙ እስካልወደደ ድረስ ኢማኑ አልተሟላም።" ቡኻሪይ እና ሙስሊም ዘግበውታል።<br /> ከሐዲሡ ከሚወሰዱ ቁምነገሮች መካከል፡<br /> 1- ማንኛውም አማኝ ለራሱ የሚወደውን ለሌሎች አማኞችም መውደድ እንዳለበት፤<br /> - ያን ማድረጉም ከኢማን ሙሉነት እንደሆነ<br /> ስምንተኛው ሐዲሥ </p>',
      ],
      7 => [
        'question' => 'ጥ 8፡ «ነፍሴ በእጁ በሆነችው ጌታ እምላለሁ!...” የሚለውን ሐዲሥ ሙላና ከሐዲሡ ከምናገኛቸው ቁምነገሮች መካከልም የተወሰኑትን ጥቀስ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/9650.mp3',
        'answer' => '<p> መልስ - ከአቢ ሰዒድ ረዲየሏሁ ዐንሁ በተላለፈ ሐዲሥ የአላህ መልዕክተኛ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን እንዲህ ብለዋል፦ "ነፍሴ በእጁ በሆነችው ጌታ እምላለሁ! <span class="c2">(ሱረቱል ኢኽላስ)</span> የቁርኣን አንድ ሶስተኛውን ታክላለች።" ቡኻሪይ ዘግበውታል።<br /> ከሐዲሡ ከሚወሰዱ ቁምነገሮች መካከል፡<br /> 1- የሱረቱል ኢኽላስን በላጭነት<br /> 2- የቁርኣን አንድ ሶስተኛውን የሚታክል መሆኗ።<br /> ዘጠነኛው ሐዲሥ፡ </p>',
      ],
      8 => [
        'question' => 'ጥያቄ 9፡- “\'ላ ሐውላ ወላ ቁወተን ኢላ ቢላህ\' (ትርጉሙም: በአላህ ካልሆነ በቀር ምንም ሃይልም ሆነ ብልሀት የለም) ...” የሚለውን ሐዲሥ ሙላና ከሐዲሡ ከምናገኛቸው ቁምነገሮች መካከልም የተወሰኑትን ጥቀስ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/9720.mp3',
        'answer' => '<p> መልስ - ከአቢ ሙሳ ረዲየሏሁ ዓንሁ በተላለፈ ሐዲሥ የአላህ መልዕክተኛ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን እንዲህ ብለዋል፦ “\'ላ ሐውላ ወላ ቁወተን ኢላ ቢላህ\' <span class="c2">(ትርጉሙም: በአላህ ካልሆነ በቀር ምንም ኃይልም ሆነ ብልሀት የለም)</span> ማለት ከጀነት ድልቦች መካከል አንዱ ነው።" ቡኻሪይ እና ሙስሊም ዘግበውታል።<br /> ከሐዲሡ ከሚወሰዱ ቁምነገሮች መካከል፡<br /> 1- የዚህ ቃል ትሩፋት እና ከጀነት ድልቦችም አንዱ ስለመሆኑ፤<br /> 2- የትኛውም ባርያ በሀይሉም ይሁን በብልሀት ብቻ ከመተማመን ተቆጥቦ በአላህ ብቻ መደገፍ እንደሚገባው፤<br /> * አስረኛው ሐዲሥ፡ </p>',
      ],
      9 => [
        'question' => '10፡- “አዋጅ! በሰውነት ውስጥ አንድ ቁራጭ ስጋ አለች…” የሚለውን ሐዲሥ ሙላና ከሐዲሡ ከምናገኛቸው ቁምነገሮች መካከልም የተወሰኑትን ጥቀስ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/9790.mp3',
        'answer' => '<p> መልስ - ከአን-ኑዕማን ቢን በሺር አላህ መልካም ሥራቸውን ይውደድላቸው እንደተላለፈው የአላህ መልዕክተኛ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን እንዲህ ሲሉ ሰምቻለሁ ብሏል፡- “አዋጅ! በሰውነት ውስጥ አንዳች ቁራጭ ስጋ አለች። ይህች ቁራጭ ስጋ ከተስተካከለች ሰውነት ሁሉ ይስተካከላል፤ እርሷ ከተበላሸች ደግሞ ሰውነት ሁሉ ይበላሻል።አዋጅ! እርሷም ልብ ነች።" ቡኻሪይ እና ሙስሊም ዘግበውታል።<br /> ከሐዲሡ ከሚወሰዱ ቁምነገሮች መካከል፡<br /> 1- የልብ መስተካከል ውጭም ዉስጥም እንዲስተካከሉ ያደርጋል፤<br /> 2-<span class="c6"> ልብ እንዲስተካከል ትኩረት የመስጠት አስፈላጊነት፤ ምክንያቱም ሰውነት የሚስተካከለው በርሷው ነውና፤<br /> * አስራ አንደኛው ሐዲሥ:</span> </p>',
      ],
      10 => [
        'question' => 'ጥ 11፡ “ከዱኒያ የመሰናበቻ ቃሉ \'ላ ኢላሃ ኢለሏህ\' የሆነ ሰው...” የሚለውን ሐዲሥ ሙላና ከሐዲሡ ከምናገኛቸው ቁምነገሮች መካከልም የተወሰኑትን ጥቀስ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/9860.mp3',
        'answer' => '<p> መልስ - ከሙዓዝ ኢብኑ ጀበል ረዲየሏሁ ዓንሁ በተላለፈ ሐዲሥ የአላህ መልዕክተኛ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን እንዲህ ብለዋል፦ “ከዱኒያ የመሰናበቻ ቃሉ \'ላ ኢላሃ ኢለሏህ\' የሆነ ሰው ጀነት ገባ።" አቡ ዳውድ ዘግበውታል።<br /> ከሐዲሡ ከሚወሰዱ ቁምነገሮች መካከል፡<br /> 1- የ\'ላ ኢላሃ ኢለሏህ\' ትሩፋት፤ ማንኛውም ባርያ ጀነት የሚገባው በርሷው መሆኑ፤<br /> 2-<span class="c6"> ከዱኒያ የመሰናበቻ ቃሉ \'ላ ኢላሃ ኢለሏህ\' የሆነ ሰው ያለው የላቀ ትሩፋት፤<br /> * አስራ ሁለተኛው ሐዲሥ:</span> </p>',
      ],
      11 => [
        'question' => 'ጥ 12፡ “ሙእሚን ዘላፊም ተራጋሚም አይደለም …” የሚለውን ሐዲሥ ሙላና ከሐዲሡ ከምናገኛቸው ቁምነገሮች መካከልም የተወሰኑትን ጥቀስ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/9940.mp3',
        'answer' => '<p> መልስ - ከዐብደላህ ኢብኑ መስዑድ ረዲየሏሁ ዓንሁ በተላለፈ ሐዲሥ የአላህ መልዕክተኛ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን እንዲህ ብለዋል፦ “ሙእሚን ዘላፊ፤ ተራጋሚም አይደለም፤ ወይም ባለጌ አልያም ስድ አይደለም።" ቲርሚዚይ ዘግበውታል።<br /> ከሐዲሡ ከሚወሰዱ ቁምነገሮች መካከል፡<br /> 1 - ውሸት እና አስቀያሚ ንግግሮች ሁሉ የተከለከሉ ስለመሆናቸው፤<br /> -<span class="c6"> ከዚህ መጠንቀቅም ሙእሚን በአንደበቱ የሚላበሰው ባህርይ ስለመሆኑ፤<br /> * አስራ ሶስተኛው ሐዲሥ:</span> </p>',
      ],
      12 => [
        'question' => 'ጥ 13፡ “ከአንድ ሰው እስልምና ማማሩ…” የሚለውን ሐዲሥ ሙላና ከሐዲሡ የምናገኛቸውን የተወሰኑ ጥቅሞቹንም ግለጽ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/10020.mp3',
        'answer' => '<p> መልስ - ከአቡ ሁረይራ አላህ መልካም ሥራቸውን ይውደድላቸው በተላለፈ ሐዲሥ የአላህ መልዕክተኛ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን እንዲህ ብለዋል፦ “የአንድ ሰው እስልምናው ያማረ ለመሆኑ ምልክቱ ከማይመለከተው ነገር መታቀቡ ነው።" ቲርሚዚይና ሌሎችም ዘግበውታል።<br /> ከሐዲሡ ከሚወሰዱ ቁምነገሮች መካከል፡<br /> 1- ማንኛውም ሰው ለዲኑም ለዱኒያውም የማይመለከተውን <span class="c2">(የማይጠቅመውን)</span> ነገር መተው እንዳለበት፤<br /> 2-<span class="c6"> እንቶፈንቶ መተው ከእስልምና ማማር እንደሆነ<br /> * አስራ አራተኛው ሐዲሥ:</span> </p>',
      ],
      13 => [
        'question' => 'ጥ 14፡ “ከአላህ ኪታብ (ከቁርአን) አንዲት እንኳ ሐርፍ የቀራ ሰው...” የሚለውን ሐዲሥ ሙላና ከሐዲሡ የምናገኛቸውን የተወሰኑ ጥቅሞቹንም ግለጽ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/10100.mp3',
        'answer' => '<p> መልስ - ከዐብደላህ ቢን መስዑድ በተላለፈ ሐዲሥ ነቢዩ ሰለላሁ ዐለይሂ ወሰለም እንዲህ ብለዋል፡- “ከአላህ ኪታብ <span class="c2">(ከቁርአን)</span> አንዲት እንኳ ሐርፍ <span class="c2">(ሆሄ)</span> የቀራ ሰው በእርሷ ሐሰና <span class="c2">(መልካምነት)</span> ይመዘገብለታል። አንድ ሐሰና <span class="c2">(መልካምነት)</span> ደግሞ በአስር እጥፍ ነው የሚመነዳው። ይህን ስላችሁ \'አሊፍ ላም-ሚም\' አንድ ሐርፍ ነው እያልኳችሁ አይደለም። \'አሊፍ\' ራሱን የቻለ ሐርፍ ነው። \'ላም\' ራሱን የቻለ ሐርፍ ነው። \'ሚም\' ራሱን የቻለ ሐርፍ ነው።" ቲርሚዚይ ዘግበውታል።<br /> ከሐዲሡ ከሚወሰዱ ቁምነገሮች መካከል፡<br /> 1- ቁርኣንን መቅራት ያለው ትሩፋት፤<br /> 2- በሚቀራው እያንዳንዱ ሐርፍ ሐሰና የሚመዘገብ ስለመሆኑ። </p>',
      ],
    ],
    6 => [
      0 => [
        'question' => 'ጥ 1- ከላቀው አላህ ጋር ሊኖር የሚገባው ስርአት (አደብ) እንዴት ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/10190.mp3',
        'answer' => '<p> መልስ- 1- ጥራት ይገባውና የላቀው አላህን ማላቅ፤<br /> 2- ተጋሪ ሳያደርጉ እርሱን በብቸኝነት ማምለክ፤<br /> 3- እርሱኑ መታዘዝ፤<br /> 4- አለማመፅ፤<br /> 5- ለቁጥር የሚያታክት ለሆነው ችሮታውና ፀጋው ማመስገንና ተገቢውን ሹክር ማድረስ፤<br /> 6- ቀድሞ ለወሰነው ዕጣ ፈንታ መታገስ፤ </p>',
      ],
      1 => [
        'question' => 'ጥ 2፡ ከነቢዩ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን ጋር ሊኖር የሚገባው ስርአት (አደብ) እንዴት ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/10270.mp3',
        'answer' => '<p> መልስ-1- እርሳቸውን መከተል እና እንደ አርአያ አድርጎ መያዝ፤<br /> 2- እርሳቸውን መታዘዝ<br /> 3- እርሳቸውን አለማመፅ<br /> 4- የተናገሩትን አምኖ መቀበል፤<br /> 5- በሱናቸዉ ላይ አዲስ ፈሊጥ አለማምጣት፤<br /> 6- እሳቸውን ከራስም ከሰውም ሁሉ በላይ አስበልጦ መውደድ፤<br /> 7- እሳቸውን ማክበር፣ ማገዝና ሱናቸውን መርዳት፤ </p>',
      ],
      2 => [
        'question' => 'ጥ 3፡ ከወላጆች ጋር ሊኖር የሚገባው ስርአት (አደብ) እንዴት ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/10360.mp3',
        'answer' => '<p> መልስ - 1 - አላህን በማመፅ ላይ እስካልሆነ ድረስ ወላጆችን መታዘዝ፤<br /> 2- ወላጆችን መኸደም <span class="c2">(መንከባከብ)</span>፤<br /> 3 - ወላጆችን ማገዝ፤<br /> 4- የወላጆችን ጉዳይ ማሳካት፤<br /> 5- ለወላጆች ዱዓእ ማድረግ፤<br /> 6- ከእነርሱ ጋር ሲጫወቱ ስርአትን መጠበቅ ይገባል፤ በዚህም መሰረት ከንግግሮች ትንሽ የሆነው <span class="c1">“ኡፍ” ማለት እንኳ አይፈቀድም።<br /> 7- ለወላጆች የፈገግታ ፊትን ማሳየት ለነርሱ ፊትን አለማጨፍገግ፤<br /> 8 - ድምፄን ከወላጆቼ ድምጽ በላይ ከፍ አላደርግም፤ በጥሞና አዳምጣቸዋለሁኝም፤ በንግግራቸው መሀል አላቋረጣቸውምም፤ በስማቸው ነጥየም አልጠራቸውም፤ ይልቁን “አባየ!”</span> “እማየ!” ነው የምላቸው።<br /> 9- አባትና እናቴ ክፍል ውስጥ እያሉ ከመግባቴ በፊት ፈቃዳቸውን እጠይቃለሁ፤<br /> 10- የወላጆቻችንን እጆችና ግንባራቸውን መሳም። </p>',
      ],
      3 => [
        'question' => 'ጥ 4፡ ዝምድናን በመቀጠል በኩል ሊኖር የሚገባው ስርአት (አደብ) እንዴት ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/10490.mp3',
        'answer' => '<p> መልስ - 1 - ወንድምንም እህትንም አጎትንም አክስትንም ሌሎች ዘመዶችንም በመዘየር፤<br /> 2- ለነርሱ በንግግርም ሆነ በተግባር ደግ መሆንና እነርሱንም በመርዳት፤<br /> 3- እነርሱን ማግኘትና ሁኔታቸውንም መጠየቅ፤ </p>',
      ],
      4 => [
        'question' => 'ጥ 5፡ ከወንድሞቼ እና ከባልንጀሮቼ ጋር እንዴት መሆን አለብኝ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/10550.mp3',
        'answer' => '<p> መልስ-1 - የምወዳጀውም የምጎዳኘውም ጥሩ ሰዎች ጋር ነው፤<br /> 2- ከክፉ ሰዎች ጋር ከመጎዳኘትም እርቃለሁ፤<br /> 3- ወንድሞቼ ጋር ሰላምታን እለዋወጣለሁ እጨባበጣለሁም፤<br /> 4- ከታመሙም እጠይቃቸዋለሁ፤ አላህ እንዲያሽራቸውም ዱዓእ አደርግላቸዋለሁ፤<br /> 5- ሲያስነጥሱ "የርሐሙከላህ" ብዬ ዱዓእ አደርግላቸዋለሁ፤<br /> 6- እንድጎበኛቸው ከጠሩኝም ግብዣቸውን እቀበላለሁ፤<br /> 7- ምክር እለግሳቸዋለሁ፤<br /> 8- ሲበደሉ እረዳቸዋለሁ፤ ሲበድሉም አቅባቸዋለሁ፤<br /> 10- ለራሴ የምወደውን ለሙስሊም ወንድሜም እወድለታለሁ፤<br /> 11- እርዳታዬን ሲያስፈልጋቸውም እረዳቸዋለሁ፤<br /> 12- በቃልም ሆነ በተግባር ምንም አላስቸግራቸውም፤<br /> 13 - ምስጢራቸውን እጠብቃለሁ፤<br /> 14- አልሰድባቸው፣ አላማቸው፣ አልንቃቸው፣ አልመቀኛቸው፣ አልሰልላቸው፣ አላታልላቸውም። </p>',
      ],
      5 => [
        'question' => 'ጥ 6፡ ጉርብትናን በተመለከተ ሊኖር የሚገባው ሥነ-ስርአት (አዳብ) እንዴት ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/10710.mp3',
        'answer' => '<p> መልስ-1- ጎረቤቴን በቃልም ሆነ በተግባር በጎ አደርግለታለሁ፤ እርዳታዬ ሲያስፈልገውም እረዳዋለሁ።<br /> 2- በበዓል፣ በትዳር ወይም በሌላ ምክንያት የደስታ ቀን ካለው እንኳን ደስ አለህ እለዋለሁ፤<br /> 3- ከታመመ እጠይቀዋለሁ፤ ከተጎዳም አጽናናዋለሁ፤<br /> 4- ከምሰራው ምግብ በተቻለኝ መጠን አቋድሰዋለሁ፤<br /> 5- በቃልም ሆነ በድርጊት አላስቸግረውም፤<br /> 6- በመሰለል ወይም በሚያስቸግር ድምፅ አልረብሸውም፤ እታገሰዋለሁኝም። </p>',
      ],
      6 => [
        'question' => 'ጥ7፡ እንግዳ ተቀባይነትንና እንግድነትን በተመለከተ ሊኖር የሚገባው ሥነ-ስርአት (አዳብ) እንዴት ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/10800.mp3',
        'answer' => '<p> መልስ-1- በእንግድነት ለጋበዘኝ እቀበለዋለሁ፤<br /> 2- አንድን ሰው መጎብኘት ከፈለግኩኝም ፈቃዳቸውን ጠይቄ ቀጠሮ እይዛለሁ፤<br /> 3- ከመግባቴ በፊትም ፈቃድ እጠይቃለሁ፤<br /> 4- ለጉብኝቴ አልዘገይም፤<br /> 5- የቤቱ አባላት ላይ ከማፍጠጥ ዐይኔን እገድባለሁ፤<br /> 6- እንግድነት ሲመጣብኝም ፈገግታ በተሞላበት ፊት እና በጥሩ የአቀባበል ቃላት መርጬ ባማረ መልኩ እቀበላለሁ፤<br /> 7- እንግዳየንም በተሻለ ቦታ ላይ እንዲቀመጥ አደርጋለሁ፤<br /> 8- የሚበላና የሚጠጣ ነገር እንዲቋደስ አድርጌ አስተናግዳለሁ፤ </p>',
      ],
      7 => [
        'question' => 'ጥ 8፡ ህመምን እና ታካሚዎች መጎብኘትን የተመለከቱ ሥነ ምግባሮችን (አዳቦች) ይጥቀሱ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/10900.mp3',
        'answer' => '<p> መልስ-1-<span class="c6"> ህመም ከተሰማኝ ቀኝ እጄን በሚያመኝ ስፍራ ላይ አድርጌ ሶስት ጊዜ "ቢስሚላህ" ካልኩ በኋላ ሰባት ጊዜ እንዲህ እላለሁ "አዑዙ ቢዒዘቲላሂ ወቁድረቲሂ ሚን ሸሪ ማ አጂዱ ወኡሓዚሩ" (ትርጉሙም:</span> ከማገኘው ክፋት በአላህ ክብር እና ሀይል እጠበቃለሁ እና እጠነቀቃለሁ።"<br /> 2- አላህ በወሰነው ነገር ወድጄ እታገሳለሁ፤<br /> 3- የታመመ ወንድሜን ለመጠየቅ እሯሯጣለሁ ዱዓእም አደርግለታለሁ፤ እርሱ ዘንድ ግን አብዝቼ አልቀመጥም።<br /> 4- ገና ሳይጠይቀኝ ሩቃ አደርግለታለሁ፤<br /> 5- በሚችለው መጠን እንዲታገስ፣ ዱዓእ እንዲያደርግ፣ ሶላቱንም እንዲሰግድና በቻለው ልክ ንፅህናውንም እንዲጠብቅ እመክረዋለሁ፤<br /> 6- ለህመምተኛ የሚደረገው ዱዓእ ሰባት ጊዜ እንዲህ ማለት ነው፡-<span class="c6"> "አስአሉ አላሀ አልዐዚም ረበ አልዐርሺል አልዐዚም አን የሽፊየከ" (ትርጉሙም:</span> ታላቅ የሆነውን እና የዐርሽ ጌታ የሆነውን አላህ እንዲያሽርህ እለምነዋለሁ።" </p>',
      ],
      8 => [
        'question' => 'ጥ 9፡ እውቀትን የመፈለግን ስነምግባር (አዳብ) እንዴት እንደሆነ ጥቀስ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/10990.mp3',
        'answer' => '<p> መልስ-1- ኒያን ለልዕለ ኋያሉ አላህ ብቻ ብሎ ጥርት ማድረግ፤<br /> 2- የተማርኩትን እውቀት እተገብራለሁ፤<br /> 3- ኡስታዜን <span class="c2">(አስተማሪየን)</span> በፊታቸውም በሌሉበትም አከብራቸዋለሁ፤<br /> 4- ከፊት ለፊታቸው ስቀመጥም ስርአት ተላብሼ እቀመጣለሁ፤<br /> 5- በጥሞና አዳምጣቸዋለሁ በሚያስተምሩኝ ጊዜም አላቋርጣቸውም፤<br /> 6- ጥያቄ ካለኝም ጨዋነትን በተላበሰ መልኩ እጠይቃለሁ፤<br /> 7- ስጠራቸውም በስማቸው ነጥየ አልጠራቸውም። </p>',
      ],
      9 => [
        'question' => 'ጥ10፡ አብሮ የመቀማመጥ ስነ ምግባር (አዳቡ) እንዴት ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/11090.mp3',
        'answer' => '<p> መልስ-1- በአብሮነት የተቀማመጡትን ሰዎች ሰላም እላለሁ፤<br /> 2 - በአብሮነት ከተቀማመጡት ሰዎች ጫፍ ላይ ባገኘሁት ክፍት ቦታ እቀመጣለሁ፤ ማንንም ከተቀመጠበት አላስነሳም፤ በሁለት ሰዎች መካከል የምቀመጠውም ከፈቀዱልኝ ብቻ ነው፤<br /> 3- አቀማመጤንም ሌላም ሰው ለመቀመጥ እንዲችል አድርጌ አሰፋለሁ፤<br /> 4- ተቀማማጮቹን በንግግራቸው መሀል አላቋርጣቸውም፤<br /> 5- ከተቀመጡት ሰዎች መካከል መሄድ ካለብኝም ከመሄዴ በፊት አስፈቅዳቸዋለሁ፤<br /> 6- አብሮ የመቀማመጣችን ጊዜው ካለቀም <span class="c2">(የሚከተለውን)</span> የመቀማመጥ ከፋራ ዱዓእ አደርጋለሁ: "ሱብሓነከሏሁመ ወቢሓምዲከ አሽሀዱ አን ላ ኢላሃ ኢላ አንተ አስተግፊሩከ ወአቱቡ ኢለይክ" <span class="c2">(ትርጉሙም: ክብርና ምስጋና ላንተ ይሁን፤ ከአንተ በቀር ሌላ አምላክ እንደሌለም እመሰክራ ለሁ፤ መሀርታህንም እከጅላለሁ ወደ አንተም ተፀፅቻለሁ።)</span> </p>',
      ],
      10 => [
        'question' => 'ጥ 11፡ የመኝታ ስርአትን (አዳብ) ጥቀስ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/11180.mp3',
        'answer' => '<p> መልስ-1 - ቀደም ብዬ እተኛለሁ፤<br /> 2 - የምተኛውም ጡሀራ ላይ ሆኘ ነው፤<br /> 3- በሆዴ ተደፍቼ አልተኛም፤<br /> 4 - ቀኝ እጄንም ከቀኝ ጉንጬ ስር አድርጌ በቀኝ ጎኔ እተኛለሁ፤<br /> 5- አልጋዬን አራግፋለሁ፤<br /> 6- አየተል-ኩርሲይን፣ ሱረቱል ኢኽላስን እና ከአል-<span class="c6">ሙዓዊዘተይንን ሶስት ጊዜ ከቀራሁ በኋላ እንዲህ እላለሁ:</span> 5- "ቢስሚከሏሁመ አሙቱ ወአሕያ" <span class="c2">(ትርጉሙም: አላህ ሆይ! የምኖረውም የምሞተውም በስምህ ነው።)</span><br /> 7- ለፈጅር ሰላት እነቃለሁ፤<br /> 8-<span class="c6"> ከእንቅልፌ በነቃሁም ጊዜ እንዲህ እላለሁ:</span>-<span class="c6"> "አልሐምዱ ሊላሂ አልለዚ አሕያና በዕደ ማ አማተና ወኢለይሂ ኑሹር" (ትርጉሙም:</span> ምስጋና ከሞትን በኋላ ህያው ላደረገን አላህ የተገባ ነው። መመለሻ ወደርሱው ብቻ ነው።" </p>',
      ],
      11 => [
        'question' => 'ጥ 12፡ የአመጋገብ ሥነ-ስርአት (አዳብ) እንዴት ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/11290.mp3',
        'answer' => '<p> መልስ-<br /> 1 - በመብላትና በመጠጣቴ ልዕለ ኃያል የሆነው አላህን መታዘዝን ነው የማስበው፤<br /> 2- ከመመገቤ በፊት እጄን እታጠባለሁ፤<br /> 3- "ቢስሚላህ" ብየ ከመአዱ መሀልም ከሌላ ሰው ፊትም ሳይሆን በፊትለፊቴ ካለው በቀኝ እጄ እበላለሁ፤<br /> 4- "ቢስሚላህ" ማለትን ከረሳሁ ባስታወስኩበት ጊዜ እንዲህ እላለሁ "ቢስሚላሂ አወሊሂ ወአኺሪሂ"<br /> 5- ከምግቡ የተገኘውን እመገባለሁ፤ ምግቡንም አላነውርም፤ ከወደድኩት እበላዋለሁ ባልወደ እንኳ አላነውረውም፤<br /> 6- ጥቂት ጉርሻዎችን እበላለሁ እንጂ አብዝቼ አልመገብም፤<br /> 7- ምግብና መጠጥ ላይ አልተነፍስም፤ እስኪቀዘቅዝ ድረስ ማቆየት ካለብኝ አቆየዋለሁ እንጂ፤<br /> 8- ማእዱን ከቤተሰብና ከእንግዳ ጋር እጋራለሁ፤<br /> 9- ከእኔ ከሚበልጠኝ ሰው ጋር ስቀርብ ቀድሜው መብላት አልጀምርም፤<br /> 10- ስጠጣም "ቢስሚላህ" ብየ ተቀምጬ ሦስት ጊዜ ተጎንጭቼ እጠጣለሁ፤<br /> 11- በልቼ ስጨርስም አላህን አመሰግናለሁ። </p>',
      ],
      12 => [
        'question' => 'ጥ13፡ የአለባበስ ሥነ-ስርአትን (አዳብ) ዘርዝር?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/11440.mp3',
        'answer' => '<p> መልስ - 1 - ልብሴን በቀኝ በኩል ጀምሬ እየለበስኩ አላህን አመሰግነዋለሁ፤<br /> 2- ልብሴን ከቁርጭምጭሚቴ ወደታች አላረዝምም፤<br /> 3- ወንድ ልጆች የሴቶችን ልብስ ሴት ልጆችም የወንዶችን ልብስ አይለብሱም፤<br /> 4- ልብሴ የከሀዲዎችንና የኃጢአተኞችን ልብስ አለመምሰል ይጠበቅበታል፤<br /> 5- ልብስ በሚይወልቁበት ጊዜ "ቢስሚላህ" ማለት፤<br /> 6- ጫማ ሲደረግም መጀመሪያ ላይ በቀኝ በኩል ሲወለቅ ደግሞ በግራ በኩል ነው። </p>',
      ],
      13 => [
        'question' => 'ጥ 14፡ የመጓጓዣ ሥነ-ስርአትን (አዳብ) ይጥቀሱ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/11540.mp3',
        'answer' => '<p> መልስ- "ቢስሚላህ አልሐምዱ ሊላህ" እልና እንዲህ እላለሁ፦ "ሱብሐነ ለዚ ሰኸረ ለና ሀዛ ወማ ኩና ለሁ መቅሪኒን ወኢና ኢላ ረቢና ለሚንቀሊቡን" {«ያ ይህንን የማንችለው ስንሆን ለእኛ ያገራለን ጌታ ጥራት ይገባው። <span class="c2">(13)</span> እኛም በእርግጥ ወደ ጌታችን ተመላሾች፤ነን» <span class="c2">(እንድትሉ)</span>። 14} <span class="c5">[ሱረቱ አዝዙኽሩፍ፡ 13 -14]</span><br /> 2- በሙስሊሞች በኩል ካለፍኩም በኢስላማዊ ሰላምታ አቀርባለሁ፤ </p>',
      ],
      14 => [
        'question' => 'ጥ 15፡ የጉዞ ሥነ-ስርአትን (አዳብ) ይጥቀሱ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/11590.mp3',
        'answer' => '<p> መልስ- 1- የምጓዘው ከመንገዱ በቀኝ በኩል ሆኖ በአረማመዴም ልከኛ እና ትሁት ሆኜ ነው፤<br /> 2- ካገኘሁት ሰው ጋር ሰላምታ እለዋወጣለሁ፤<br /> 3- አይኔንም ዝቅ አደርጋለሁ ማንንም ደግሞ አላስቸግርም፤<br /> 4- በመልካም እያዘዝኩ ከመጥፎም እከለክላለሁ፤<br /> 5- በመንገድ ላይ የማገኘውንም አስቸጋሪ ነገርን አስወግዳለሁ፤ </p>',
      ],
      15 => [
        'question' => 'ጥ 16፡ ወደ ቤት የመግባት እና የመውጣት ሥነ-ስርአትን (አዳብ) ይጥቀሱ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/11670.mp3',
        'answer' => '<p> መልስ- 1- ስወጣም እንዲህ እያልኩ ግራ እግሬን አስቀድሜ ነው፦ "ቢስሚላሂ ተወከልቱ ዐለላሂ ላ ሐውላ ወላ ቁወተ ኢላ ቢላሂ፤ አልላሁመ ኢኒ አዑዙ ቢከ አን አዲለ አው ኡዶለ አው አዚለ አው ኡዘለ አው አዝሊመ አው ኡዝለመ አው አጅሀለ አው ዩጅሀለ ዐለይ" <span class="c2">(ትርጉሙም፡ በአላህ ስም የምመካውም በእርሱው ነው፤ ብልሀትም ይሁን ሀይል በርሱ ብቻ ነው። አላህ ሆይ! ራሴ ከመሳሳት ወይም ሌሎች እንዲሳሳቱ ከማድረግ፤ ከመንዳለጥ ወይም ሌሎች እንዲንዳለጡ ከማድረግ ከመበደል ወይም ሌሎች እንዲበደሉ ከማድረግ፤ ከመጃጃል ወይም ሌሎች እንዲጃጃሉብኝ ከመሆን በአንተው እጠበቃለሁ።)</span> 2- ስገባም እንዲህ እያልኩ ቀኝ እግሬን አስቀድሜ ነው፡ "ቢስሚላሂ ወለጅና ወቢስሚላሂ ኸረጅና ወዐላ ረቢና ተወከልና" <span class="c2">(ትርጉሙም፡ በአላህ ስም ገባን በአላህም ስም ወጣን፤ የምንመካውም በአላህ ነው።)</span><br /> 3- ጥርሴን ሲዋክ በማድርግ እጀምርና ከዚያም ለቤተሰብ አባላቱ ሰላምታ እሰጣለሁ፤ </p>',
      ],
      16 => [
        'question' => 'ጥ 17፡ የመፀዳዳት ሥነ-ስርአትን (አዳብ) ይጥቀሱ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/11730.mp3',
        'answer' => '<p> መልስ-1- ስገባ ቀኝ እግሬን አስቀድሜ እገባለሁ፤<br /> 2- ከመግባቴ በፊትም እንዲህ እላለሁ፡- "ቢስሚላሂ አልላሁማ ኢኒ አዑዙ ቢከ ሚነል-ኩብሢ ወልኸባኢሥ" <span class="c2">(ትርጉሙም፡ በአላህ ስም አላህ ሆይ! ከክፉ ወንድም ሆነ ሴት ጂን በአንተ እጠበቃለሁ።)</span><br /> 3- የአላህ ስም የተጠቀሰበትን ነገር ይዤ አልገባም፤<br /> 4 - ስፀዳዳም እደበቃለሁ፤<br /> 5- በምፀዳዳበት ጊዜ አላወራም፤<br /> 6- ሽንትም ይሁን ሰገራ ስፀዳዳ ወደ ቂብላም አልዞርም ጀርባየንም ለቂብላ አልሰጥም፤<br /> 7- ነጃሳን ለማስወገድ ግራ እጄን እጠቀማለሁ እንጂ ቀኝ እጄን አልጠቀምም፤<br /> 8- ሰዎች በሚጓዙበት መንገድ ወይም ጥላ ስር አልፀዳዳም፤<br /> 9- ከተፀዳዳሁ በኋላ እጄን እታጥባለሁ፤<br /> 10 - ግራ እግሬን አስቀድሜ እወጣለሁ “ጉፍራነክ” እላለሁ፤ </p>',
      ],
      17 => [
        'question' => 'ጥያቄ 18፡ የመስጂድ ስነ ምግባርን (አዳብ) ጥቀስ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/11860.mp3',
        'answer' => '<p> መልስ-1- ወደ መስጂድ ስገባ ቀኝ እግሬን አስቀድሜ እገባለሁ እንዲህም እላለሁ፦ "ቢስሚላህ አልላሁምመ ኢፍተሕሊ አብዋበ ረሕመቲክ" <span class="c2">(ትርጉሙም: በአላህ ስም አላህ ሆይ! የእዝነት ደጆችህን ክፈትልኝ።)</span><br /> 2- ሁለት ረከዓ ሳልሰግድ አልቀመጥም፤<br /> 3- በሰጋጆች መካከል አላልፍም፤ የጠፋ ነገርንም መስጂድ ውስጥ አላውጅም፤ ወይም መስጂድ ውስጥ አልሸጥ አልገበይም፤<br /> 4- ከመስጂድ ስወጣ ግራ እግሬን አስቀድሜ እንዲህ እያልኩ እወጣለሁ፡- "ቢስሚላሂ አልላሁመ ኢኒ አስአሉከ ሚን ፈድሊክ" <span class="c2">(ትርጉሙም: በአላህ ስም፤ አላህ ሆይ! ከችሮታህ እንድትለግሰኝ እማፀንሀለሁ።)</span> </p>',
      ],
      18 => [
        'question' => 'ጥ 19፡ የሰላምታን ሥነ-ስርአት (አዳብ) ጥቀስ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/11930.mp3',
        'answer' => '<p> መልስ 1 - ሙስሊም የሆነን ሰው ሳገኝ በእጄ ምልክት በመስጠት ብቻ አልያም በሌላ መልኩ ሳይሆን <span class="c1">“አስሰላሙ ዐለይኩም ወረሕመቱላሂ ወበረካቱህ”</span> በማለት ሰላምታየን እጀምራለሁ።<br /> 2- ሰላም ለምለው ሰውም ፊቴን ፈገግ አደርግለታለሁ፤<br /> 3- በቀኝ እጄ በመጨባበጥም ሰላምታ እለዋወጣለሁ፤<br /> 4- አንድ ሰው ሰላምታ ቢያቀርብልኝ ከርሱ በተሻለ ሰላምታ አልያም አምሳያዋን እመልስለታለሁ፤<br /> 5- ለከሀዲ ኢስላማዊ ሰላምታን በመስጠት አልጀምርለትም፤ እርሱ ከጀመረ ደግሞ አምሳያዋን እመልስለታለሁ።<br /> 6- ታናሽ ለታላቁ፣ እግረኛው ለሚጋልበው፣ ተቀመጦ ያለው ለሚራመደው፣ ጥቂቶቹ ለብዙዎቹ ሰላምታ ይሰጣጣሉ፤ </p>',
      ],
      19 => [
        'question' => 'ጥ20፡ ፍቃድ የመጠየቅ ሥነ-ስርዓትን (አዳብ) ጥቀስ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/12020.mp3',
        'answer' => '<p> መልስ-1-<span class="c6"> ወደ ቦታው ከመግባቴ በፊት ፈቃድ እጠይቃለሁ:</span><br /> 2- ፍቃድ የምጠይቀው ሶስት ጊዜ ሲሆን ከዚያ በላይ ከቆዩብኝ ትቼ እሄዳለሁ፤<br /> 3- በር ሳንኳኳ በቀስታ ነው፤ አንኳኩቼ ስቆምም በበሩ ፊት ለፊት ሳይሆን ወደ ቀኝ ወይም ወደ ግራ ዞር ብዬ ነው የምቆመው፤<br /> 4- ወደ አባቴ ወይም ወደ እናቴ አልያም ወደ ማንኛውም ሰው ክፍል ውስጥ ፍቃዳቸውን ሳልጠይቅ አልገባም፤ በተለይም ጊዜው ጎህ ከመቅደዱ በፊት፣ እኩለ ቀን ላይ ከዝሁር ሶላት በፊት <span class="c2">(አረፍ በሚሉበት ሰአት)</span> እና ከዒሻ ሶላት በኋላ ከሆነ፤<br /> 5- ሰው መኖርያው አድርጎ ያልያዛቸው ቦታዎች ለምሳሌ፡ ሆስፒታል ወይም ሱቅ ከሆነ ግን ፍቃድ ሳልጠይቅም መግባት እችላለሁ፤ </p>',
      ],
      20 => [
        'question' => 'ጥ 21፡ ለእንስሳት እዝነት ሲባል ሊኖር የሚገባውን ሥነ-ስርዓት (አዳብ) ጥቀስ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/12100.mp3',
        'answer' => '<p> መልስ-1- እንስሳውን እመግበዋለሁ አጠጣዋለሁም፤<br /> 2- ለእንስሳት ርህራሄ ማሳየት እና ማዘን፤ የማይችሉትን አለማሸከም፤<br /> 3- እንስሳትን በምንም አይነት መልኩ ስቃይ ወይም ጉዳት አላደርስባቸውም፤ </p>',
      ],
      21 => [
        'question' => 'ጥ22፡ የስፖርትን ሥነ-ስርዓት (አዳብ) ይጥቀሱ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/12160.mp3',
        'answer' => '<p> መልስ-1- በስፖርታዊ እንቅስቃሴ አላህን በመታዘዝ እና ውዴታውን በመፈለግ ላይ መጠናከርን አስብበታለሁ <span class="c2">(ኒያ አደርጋለሁ)</span>፤<br /> 2- በሶላት ጊዜ አንጫወትም፤<br /> 3- ወንድ ልጆች ከሴት ልጆች ጋር ተቀላቅለው ስፖርታዊ እንቅስቃሴ አያደርጉም፤<br /> 4- ገላየን <span class="c2">(አውራዬን)</span> የሚሸፍን የስፖርት ትጥቅ እለብሳለሁ፤<br /> 5- ከተከለከሉ ስፖርታዊ እንቅስቃሴዎች እጠነቀቃለሁ፤ ማለትም ፊትን መምታት ወይም ሀፍረተ ገላ <span class="c2">(አውራ)</span> መግለጥን ካለባቸው ስፖርታዊ እንቅስቃሴዎች እጠነቀቃለሁ፤ </p>',
      ],
      22 => [
        'question' => 'ጥ23፡ የተወሰኑ የቀልድ ሥነ-ስርዓቶችን (አዳብ) ጥቀስ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/12240.mp3',
        'answer' => '<p> መልስ-1- ለቀልድም ቢሆን አለመዋሸት እውነትን በመናገር መቀለድ፤<br /> 2- ከማፌዝና ከማላገጥ እንዲሁም ሰዎችን ከመጉዳትና ከማስደንገጥ በፀዱ ቀልዶች መቀለድ፤<br /> 3- ቀልድ አለማብዛት፤ </p>',
      ],
      23 => [
        'question' => 'ጥ 24፡ የተወሰኑ የማስነጠስ ሥነ-ስርዓቶችን (አዳብ) ጥቀስ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/12300.mp3',
        'answer' => '<p> መልስ-1- ሲያስነጥሰን እጅን ወይ አንዳች ልብስ ወይም መሀረብ አፍ ላይ ጣል ማድረግ፤<br /> 2- ካስነጠሰን በኋላ "አልሐምዱ ሊላህ" በማለት አላህን ማመስገን፤<br /> 3- ወንድሙ ወይም ባልንጀራው <span class="c1">“የርሐሙከላህ” <span class="c2">(ትርጉሙም: አላህ ይዘንልህ)</span> ይበለው፤<br /> እንደዛ ካሉት፡-<span class="c6"> “የህዲኩሙላሁ ወዩስሊሕ ባለኩም" (ትርጉሙም:</span> አላህ ይምራህ ጉዳይህንም ያስተካክልልህ”</span> ይበል። </p>',
      ],
      24 => [
        'question' => 'ጥ 25፡ የማዛጋት ሥነ-ስርዓቶች (አዳብ) ምን ምን ናቸው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/12360.mp3',
        'answer' => '<p> መልስ-1- ማዛጋትን ለማፈን መሞከር፤<br /> 2- ሲያፋሽጉ "አህ!" "አህ" የሚለውን የማዛጋት ድምፅ ከፍ ማድረግ አይገባም፤<br /> 3- እጅን አፍ ላይ ማድረግ፤ </p>',
      ],
      25 => [
        'question' => 'ጥ 26፡ የተከበረውን ቁርኣን የመቅራት ሥነ-ስርዓቶችን (አዳብ) ይጥቀሱ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/12420.mp3',
        'answer' => '<p> መልስ-- ውዱእ ካደረጉ በኋላ ጡሀራ ሆኖ መቅራት፤<br /> 2- ስርአትን ተላብሶ እና በክብር መቀመጥ፤<br /> 3- መቅራት ስጀምር አላህ ከሰይጣን እንዲጠብቀኝ <span class="c2">(አዑዙ ቢላህ)</span> እላለሁ፤<br /> 4- የምቀራውን ቀርአን አስተነትናለሁ። </p>',
      ],
    ],
    7 => [
      0 => [
        'question' => 'ጥ 1፡ የመልካም ስነምግባርን ትሩፋት ጥቀስ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/12500.mp3',
        'answer' => '<p> መልስ - ነብዩ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን እንዲህ ብለዋል፦ "ከአማኞች መካከል እጅግ የተሟላ ኢማን ያላቸው እነዚያ ይበልጥ መልካም ስነ-ምግባርን የተላበሱት ናቸው።" ቲርሚዚይ እና አሕመድ ዘግበውታል። </p>',
      ],
      1 => [
        'question' => 'ጥያቄ 2፡ ኢስላማዊ ስነ ምግባርን የምንላበሰው ለምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/12530.mp3',
        'answer' => '<p> መልስ-1- ምክንያቱም የላቀው አላህ እንዲወደን ምክንያት ስለሆነ፤<br /> 2- ፍጡራንም እንዲወዱን ምክንያት ስለሆነ፤<br /> 3- የውመል ቂያማ ሚዛን ላይ ከባድ ምንዳ ያለው ስለሆነ፤<br /> 4- ሽልማትና ምንዳ በመልካም ስነምግባር ምክንያት ስለሚበዛ፤<br /> 5- ኢማን የተሟላ ለመሆኑም ምልክት ስለሆነ ነው። </p>',
      ],
      2 => [
        'question' => 'ጥ 3፡ መልካም ሥነ ምግባርን ከየት ነው የምንወስደው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/12600.mp3',
        'answer' => '<p> መልስ- ከተከበረው ቁርኣን ነው። የላቀው አላህ እንዲህ ብሏል፦ <span class="c4">{ይህ ቁርኣን ወደዚያች እርሷ ቀጥተኛ ወደ ሆነችው መንገድ ይመራል።}</span> <span class="c5">[ሱረቱል ኢስራእ፡ 9]</span> እንዲሁም ከነብዩ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን ሱና የአላህ መልዕክተኛ ሰለላሁ ዓለይሂ ወሰለም እንዲህ ብለዋልና፡- "እኔ የተላክሁት የተስተካከለ ስነምግባርን ላሟላ ነው።" አሕመድ ዘግበውታል። </p>',
      ],
      3 => [
        'question' => 'ጥ 4፡ የኢሕሳን ባህርይ ምንድን ነው? መገለጫውስ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/12640.mp3',
        'answer' => '<p> መልስ- ኢሕሳን፡-<span class="c6"> ሁል ጊዜም ቢሆን አላህ ይመለከተኛል ማለትና ለፍጥረታትም በጎ ማድረግ እና መልካም መሆን ነው።<br /> ነብዩ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን እንዲህ ብለዋል፦ “የላቀው አላህ ሁሉም ነገር በመልካም መንገድ እንዲከናወን ወስኗል።" ሙስሊም ዘግበውታል።<br /> ከኢሕሳን መገለጫዎች መካከል:</span><br /> * አላህን ሲያመልኩ ሊኖር የሚገባው ኢሕሳን: ይሀውም በአምልኮ ኢኽላስ መኖር ለርሱ ጥርት ማድረግ ነው።<br /> * ለወላጆች በንግግርም በተግባርም ደግ መሆን ነው።<br /> * ለዘመዶች እና ለቅርብ ቤተሰቦች የሚኖር ኢሕሳን <span class="c2">(በጎነት)</span><br /> * ለጎረቤት የሚደረግ በጎነት<br /> * ወላጅ አባታቸውን ላጡ ህፃናትና ለሚስኪኖች የሚደረግ በጎነት<br /> * ክፉ ለሠራብን ሰው የሚደረግ በጎነት<br /> * በንግግር ወቅት የሚደረግ በጎነት<br /> * በውይይት ወቅት የሚደረግ በጎነት<br /> * ለእንስሳት የሚደረግ በጎነት </p>',
      ],
      4 => [
        'question' => 'ጥ 5፡ የበጎነት (የኢሕሳን) ተቃራኒ ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/12780.mp3',
        'answer' => '<p> መ -የበጎነት ተቃራኒ ክፋት ነው።<br /> * ከነዚህም መካከል፡- አላህን ሲያመልኩ ኢኽላስ በሌለው መልኩ ማምለክ፤<br /> * ወላጆችን ማመፅ፤<br /> * ዝምድናን መቁረጥ<br /> * መጥፎ ጉርብትና<br /> * ለድሆች እና ለሚስኪኖች ሊኖር ከሚገባው ኢሕሳን <span class="c2">(መልካምነት)</span> ማፈግፈግ እና ሌሎችም የክፋት መገለጫዎች ላይ መገኘት ነው። </p>',
      ],
      5 => [
        'question' => 'ጥ6: የአደራ ጠባቂነት (አማና) ዓይነቶች እና መገለጫዎች ምን ምን ናቸው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/12860.mp3',
        'answer' => '<p> መልስ-<br /> 1- የላቀው አላህ መብቶችን የመጠበቅ አደራ፤<br /> መገለጫዎቹ፡- እንደ ሶላት፣ ዘካ፣ ጾም፣ ሐጅ እና ሌሎችንም አላህ በኛው ላይ ግዴታ ያደረጋቸውን ዒባዳዎች የመተግበር አማና፤<br /> 2 -<span class="c6"> የፍጥረታትን ሐቆች የመጠበቅ አማና:</span><br /> · የሰዎችን ክብር<br /> · ገንዘባቸውንም<br /> · ህይወታቸውንም በመጠበቅ<br /> · እንዲሁም ምስጢራቸውንና ሰዎች በአደራ መልኩ የሰጡት ሁሉ በዚሁ የሚጠቃለል ነው።<br /> የላቀው አላህ ስለሚድኑት ሰዎች ባህርያት ሲገልፅ እንዲህ ብሏል:- <span class="c4">{እነዚያም እነርሱ ለአደራዎቻቸውና ለቃል ኪዳናቸው ጠባቂዎች። 8}</span> <span class="c5">[ሱረቱል ሙሚኑን፡ 8]</span> </p>',
      ],
      6 => [
        'question' => 'ጥ7፡ የአደራ ጠባቂነት ተቃራኒው ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/12980.mp3',
        'answer' => '<p> መልስ - ተቃራኒው ከዳተኝነት ሲሆን ይህም ማለት የልዕለ ኋያሉ አላህንም የሰዎችንም ሐቅ መጣስ ነው።<br /> ነብዩ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን እንዲህ ብለዋል፦ "የሙናፊቅ ምልክቱ ሦስት ነው..." - ከነዚህም አንዱ - "አደራ ሲሰጠው ይከዳል።" ቡኻሪና ሙስሊም ዘግበውታል። </p>',
      ],
      7 => [
        'question' => 'ጥ8፡ ሐቀኝነት የሚባለው ባህርይ ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/13020.mp3',
        'answer' => '<p> መልስ - ከእውነታው ጋር የሚገጥመውን ወይም ነገሩን ባለበት ተጨባጭ መናገር ነው።<br /> ከመገለጫዎቹ መካከል፡-<span class="c6"><br /> ከሰዎች ጋር በመነጋገር ላይ የሚኖር ሐቀኝነት:</span><br /> ቃል ኪዳንን ማክበር፤<br /> በእያንዳንዱ ቃልም ይሁን ድርጊት ላይ ሓቀኛ ሆኖ መገኘት፤<br /> ነብዩ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን እንዲህ ብለዋል፦ "እውነት ወደ ጽድቅ ይመራል፤ ጽድቅም ወደ ጀነት ይመራል፤ ሰውም ሓቀኛነት ማንነቱ እስኪሆን ድረስ እውነትን በመናገር ላይ ይቀጥላል።" ቡኻሪና ሙስሊም ዘግበውታል። </p>',
      ],
      8 => [
        'question' => 'ጥ9፡ የሐቀኝነት ተቃራኒው ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/13100.mp3',
        'answer' => '<p> መልስ - ተቃራኒው ውሸት ነው። ይሀውም ከእውነት ጋር ተቃርኖ መገኘት ሲሆን ሰዎችን መዋሸት፣ ቃል ኪዳኖችን ማፍረስ እና የሀሰት ምስክርነትን የመሰሉ ባህርያት ማለት ነው።<br /> ነብዩ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን እንዲህ ብለዋል፦ ውሸት ወደ አመፀኝነት ይመራል፤ አመፀኝነት ደግሞ ወደ <span class="c2">(ጀሀነም)</span> እሳት ይመራል፤ ሰውም ውሸታም ተብሎ አላህ ዘንድ እስኪመዘገብ ድረስ ውሸትን በመናገር ላይ ይቀጥላል።" ቡኻሪና ሙስሊም ዘግበውታል። ነብዩም የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን እንዲህ ብለዋል፦ "የሙናፊቅ ምልክቱ ሦስት ነው..." - ከነዚህም አንዱ - "ሲናገርም ይዋሻል ቃል ሲገባም ቃሉን ያፈርሳል።" ቡኻሪና ሙስሊም ዘግበውታል። </p>',
      ],
      9 => [
        'question' => 'ጥ10: የትዕግስት ዓይነቶች ስንት ናቸው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/13140.mp3',
        'answer' => '<p> መልስ- - የላቀው አላህን በመታዘዝ ላይ የሚደረግ ትዕግስት፤<br /> - አላህን ከማመፅ በመታቀብ ላይ የሚደረግ ትዕግስት፤<br /> - በአሳማሚ የአላህ ውሳኔ ላይ የሚደረግ የሚደረግ ትዕግስት እና በማንኛውም ሁኔታ ሆኖ አላህን ማመስገን ነው።<br /> የላቀዉ አላህ እንዲህ ብሏል፦ <span class="c4">{አላህም ትዕግስተኞችን ይወዳል። 146}</span> <span class="c5">[ሱረቱ ኣሊ-ዒምራን፡ 146]</span> ነብዩም የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን እንዲህ ብለዋል፦ "የሙእሚን ጉዳዩ ምንኛ ድንቅ ነው?! ጉዳዩ ሁሉ ለርሱ መልካም ነው። ይህ ደግሞ የሚሆነው ለሙእሚን ብቻ ነው። መልካምን ባገኘ ጊዜ አላህን ያመሰግናል ያ ነገር ለርሱ መልካም ይሆንለታል። ችግርም ባጋጠመው ጊዜ ይታገሳል ያ ነገር ለርሱ መልካም ይሆንለታል። ሙስሊም ዘግበውታል። </p>',
      ],
      10 => [
        'question' => 'ጥ11፡ የትዕግስት ተቃራኒው ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/13210.mp3',
        'answer' => '<p> መልስ - - ተቃራኒው አላህን በመታዘዝ ላይ ትዕግስት ማጣት፤ አላህን ከማመፅ በመታቀብ ላይ ትዕግስት ማጣት እና አስቀድሞ በተወሰነ እጣፈንታ በቃልም ይሁን በተግባር መበሳጨት ነው።<br /> ከመገለጫዎቹ መካከል፦<br /> § ሞትን መመኘት<br /> § ፊትን መምታት፤<br /> § ልብስን መቅደድ፤<br /> § ፀጉርን መንጨን፤<br /> § ራስን መርገም፤<br /> ነብዩ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን እንዲህ ብለዋል፦ “የምንዳ መጠኑ በመከራው ልክ ነው። የላቀው አላህ ሰዎችን በወደደ ጊዜ ይፈትናቸዋል፤ ወደው ለተቀበሉት የአላህን ውዴታ ሲያተርፉ የተበሳጩት ደግሞ የአላህን ብስጭት ያተርፋሉ።" ቲርሚዚይ እና ኢብኑ ማጃህ ዘግበውታል። </p>',
      ],
      11 => [
        'question' => 'ጥ12፡ የመተባበር ስነምግባርን ይጥቀሱ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/13310.mp3',
        'answer' => '<p> መልስ - ይህ ማለት ትክክለኛ እና መልካም በሆነ ነገር ሰዎች በመካከላቸው መተጋገዛቸው ነው።<br /> የትብብር <span class="c2">(መረዳዳት)</span> መገለጫዎች፦<br /> o መብቶችን ወደ ባለቤታቸው ለመመለስ መተባበር፤<br /> o ጨቋኝን በማቀብ ላይ መተባበር፤<br /> o የሰዎችንም የችግረኞችንም ጉዳይ በማሳካት ላይ መተባበር፤<br /> o በበጎ ነገር ሁሉ መተባበር፤<br /> o በሃጢያት፣ በጥቃት እና በጠላትነት ላይ አለመተባበር ናቸው።<br /> የላቀዉ አላህ እንዲህ ብሏል፦ <span class="c4">{በበጎ ነገርና አላህን በመፍራትም ተረዳዱ። ግን በኃጢአትና ወሰንን በማለፍ አትረዳዱ። አላህንም ፍሩ። አላህ ቅጣተ ብርቱ ነውና። 2}</span> <span class="c5">[ሱረቱል ማኢዳህ፡ 2]</span> ነብዩ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን እንዲህ ብለዋል፦ "ማንኛውም ሙእሚን ከሌላ አማኝ ጋር ያለው ግንኙነት እንደ ህንጻ <span class="c2">(ጡቦች)</span> ነው፤ አንዱ ሌላኛውን ያጠናክራል።" ቡኻሪና ሙስሊም ዘግበውታል። ነብዩም የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን እንዲህ ብለዋል፦ "ሙስሊም ለሙስሊም ወንድሙ ነው። በመሆኑም አያታልለው፣ አይዋሸው፣ ለጠላት አሳልፎ አይስጠው። የሙስሊምን ጉዳይ ለፈፀመ አላህ ጉዳዩን ይፈፅምለታል፤ የወንድሙን ችግር ላስወገደ አላህ በትንሣኤ ቀን ከችግሮቹ አንዱን ያነሳለታል። የሙስሊምን ነውር ለሸፈነ አላህ በትንሣኤ ቀን ነውሩን ይሸፍንለታል።" ቡኻሪና ሙስሊም ዘግበውታል። </p>',
      ],
      12 => [
        'question' => 'ጥ13፡ የዓይነ አፋርነት (ሐያእ) ስነምግባር ዓይነቶች ምን ምን ናቸው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/13420.mp3',
        'answer' => '<p> መልስ-1- ከአላህ ሐያእ ማድረግ ማለት፡- ጥራት ይገባውና እርሱን ባለማመፅ የሚገለፅ ነው።<br /> 2- ከሰዎች ሐያእ ማድረግ ማለት፡- ይህም ጸያፍና ስድ ቃላቶችን በማስወገድ እና ሀፍረተ ገላንም ባለመገላለጥ የሚገለፅ ነው።<br /> የአላህ መልዕክተኛ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን እንዲህ ብለዋል፦ "ኢማን ከሰባ በላይ ቅርንጫፎች አሉት - ወይም ከስልሳ በላይ ቅርንጫፎች አሉት - ከፍተኛው \'ላ ኢላሀ ኢለላህ\' የሚለው ቃል ሲሆን ትንሹ ደግሞ አስቸጋሪ ነገርን ከመንገድ ማስወገድ ነው። ሐያእም የኢማን ቅርንጫፍ ነው።" ሙስሊም ዘግበውታል። </p>',
      ],
      13 => [
        'question' => 'ጥ 14፡ የርህራሄ ባህርይ መገለጫዎችን ጥቀስ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/13470.mp3',
        'answer' => '<p> መልስ- - ለአረጋውያን መራራት እና እነርሱንም ማክበር፤<br /> - ለወጣቶች እና ለልጆች መራራት፤<br /> - ለድሆች፣ ለሚስኪኖች እና ለችግረኞች መራራት፤<br /> - በማብላትና ባለማስቸገርም ለእንስሳት መራራት፤<br /> - ከነዚህም መካከል ነብዩ ሰለላሁ ዓለይሂ ወሰለም እንዲህ ያሉት ይገኝበታል፡- "አማኞች በመካከላቸው ያለው ደግነታቸው፣ ርህራሄያቸው እና መተዛዘናቸው ልክ እንደ አንድ አካል ናቸው። አንዱ አካል ሲሰቃይ መላ ሰውነት የህመም እና የትኩሳት ምላሽ ይሰጣል።" ቡኻሪና ሙስሊም ዘግበውታል። የአላህ መልዕክተኛ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን እንዲህ ብለዋል፦ "አዛኞች እጅግ በጣም አዛኝ የሆነው አላህ ያዝንላቸውል፤ በምድር ላሉት እዘኑ በሰማይ ያለው <span class="c2">(አላህ)</span> ያዝንላችኋል።" አቡዳውድና ቲርሚዚይ ዘግበውታል። </p>',
      ],
      14 => [
        'question' => 'ጥ 15፡ የመዋደድ ባህርይ ዓይነቶች ምን ምን ናቸው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/13550.mp3',
        'answer' => '<p> መልስ - የላቀው አላህን መውደድ።<br /> የላቀዉ አላህ እንዲህ ብሏል፦ {እነዚያ ያመኑትም አላህን በመውደድ <span class="c2">(ከነርሱ)</span> ይበልጥ የበረቱ ናቸው።} <span class="c5">[ሱረቱል በቀራህ 165]</span><br /> የአላህ መልዕክተኛ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈንን መውደድ።<br /> እንዲህ ብለዋል፦ "ነፍሴ በእጁ በሆነችው ጌታ እምላለሁ! ማናችሁም ዘንድ ከአባቱ፣ ከልጁና ከሰው ልጆች ሁሉ ለርሱ ይበልጥ ተወዳጁ እኔ እስካልሆንኩለት ድረስ እምነታችሁ አልተሟላም።" ቡኻሪይ ዘግበውታል።<br /> ምእመናንን መውደድ፤ ለራስህ የምትወደው መልካም ነገርንም ለነርሱም ልትወድላቸው ይገባል።<br /> ነብዩ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን እንዲህ ብለዋል፦ "ማናችሁም ለራሱ የሚወደውን ለወንድሙ እስካልወደደ ድረስ እምነቱ አልተሟላም።" ቡኻሪይ ዘግበውታል። </p>',
      ],
      15 => [
        'question' => 'ጥ16፡ ፈገግታ ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/13630.mp3',
        'answer' => '<p> መልስ - ሰዎችን ሲያገኙ በፍካት ደስታንና አዛኝነትን ፊት ላይ አጉልቶ ማንፀባረቅ ነው።<br /> ሰዎችን የሚያርቃቸው ከሆነው ፊትን የማኮሳተር ተቃራኒ ነው።<br /> የፈገግታን የላቀ ደረጃ በተመለከተ ብዙ ሐዲሦች የመጡ ሲሆን ከነዚህም መካከል ከአቡ ዘር <span class="c2">(ረዲየላሁ ዐንሁ)</span> በተላለፈ ሐዲሥ ነብዩ <span class="c2">(የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን)</span> እንዲህ እንዳሏቸው ገልፀዋል፡- "ወንድምህን በፈገግታ የተሞላ ፊት ማሳየትንም ቢሆን መልካም ነገርን እንደ ቀላል ነገር አድርገህ አትመልከት።" ሙስሊም ዘግበውታል። የአላህ መልዕክተኛ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን እንዲህ ብለዋል፦ "በወንድምህ ፊት ፈገግ ማለትህም ምጽዋት ነው።" ቲርሚዚይ ዘግበውታል። </p>',
      ],
      16 => [
        'question' => 'ጥ17፡ ምቀኝነት ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/13690.mp3',
        'answer' => '<p> መልስ- ምቀኝነት ማለት ፀጋ ከሌሎች እንዲወገድ መመኘት ወይም ሌሎች ፀጋ ማግኘታቸውን መጥላት ነው።<br /> የላቀው አላህ እንዲህ ብሏል፦ {«ከምቀኛም ክፋት በተመቀኘ ጊዜ፤ <span class="c2">(እጠበቃለሁ በል)</span>።»} <span class="c5">[ሱረቱል ፈለቅ፡ 5]</span><br /> አነስ ቢን ማሊክ አላህ መልካም ሥራቸውን ይውደድላቸው እንዳስተላለፉት የአላህ መልእክተኛ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን እንዲህ ብለዋል፦ "እርስ በርሳችሁ አትጠላሉ፣ አትመቀኛኙ፣ ጀርባም አትሰጣጡ፤ የአላህ ባርያ ወንድማማቾች ሁኑ።" ቡኻሪይ እና ሙስሊም ዘግበውታል። </p>',
      ],
      17 => [
        'question' => 'ጥ18፡ መሳለቅ ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/13740.mp3',
        'answer' => '<p> መልስ - መሳለቅ ሙስሊም ወንድምህ ላይ ማፌዝና ማሳነስ ነው። ይህ ደግሞ አይፈቀድም።<br /> የላቀው አላህ ከዚህ ሲከለክለን እንዲህ ብሏል፦ {እናንተ ያመናችሁ ሆይ! ወንዶች ከወንዶች አይቀልዱ። ከእነርሱ የበለጡ ሊኾኑ ይከጀላልና። ሴቶችም ከሴቶች <span class="c2">(አይሳለቁ)</span>። ከእነርሱ የበለጡ ሊሆኑ ይከጀላልና። ነፍሶቻችሁንም አታነውሩ። በመጥፎ ስሞችም አትጠራሩ። ከእምነት በኋላ የማመጽ ስም ከፋ። ያልተጸጸተም ሰው እነዚያ እነርሱ በዳዮቹ ናቸው።11} <span class="c5">[ሱረቱል ሁጁራት፡ 11]</span> </p>',
      ],
      18 => [
        'question' => 'ጥ 19፡ ትሕትናን ምን ማለት ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/13780.mp3',
        'answer' => '<p> መልስ - ትሕትና ማለት የሰው ልጅ ራሱን ከሌሎች የተሻለ አድርጎ ላያይ፤ ሰውንም ላይንቅና እውነታንም ላይገፈትር <span class="c2">(ሊቀበል)</span> ነው።<br /> የላቀዉ አላህ እንዲህ ብሏል፦ <span class="c4">{የአርረሕማንም ባሮች እነዚያ በምድር ላይ በዝግታ የሚሄዱት... ናቸው።}</span> <span class="c5">[ሱረቱል ፉርቃን፡ 63]</span> ማለትም፡ ትሁት ሆነው። የአላህ መልዕክተኛ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን እንዲህ ብለዋል፦ "ማናችሁም ራሱን ለአላህ ብሎ ዝቅ ካደረገ አላህ ከፍ ያደርገዋል።" ሙስሊም ዘግበውታል። በሌላም ሐዲሥ <span class="c2">(የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን)</span> እንዲህም ብለዋል፦ “ማንም ሰው ሌላው ላይ ድንበር እስከማይተላለፍና አንዱ በሌላው ላይም እስከማይመፃደቅ ድረስ እርስ በርሳችሁ ትሑት ትሆኑ ዘንድ አላህ ወደኔ ወሕይ <span class="c2">(መለኮታዊ ራእይ)</span> አውርዶልኛል።" ሙስሊም ዘግበውታል። </p>',
      ],
      19 => [
        'question' => 'ጥ20፡ እርም የሆኑ የትዕቢት ዓይነቶች ምን ምን ናቸው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/13840.mp3',
        'answer' => '<p> መልስ-1- በእውነት ላይ መኩራራት፡ እውነትን መገፍተርና አለመቀበል ነው።<br /> 2- በሰዎች ላይ መኩራራት፡ ሰዎችን ማቃለልና ማንቋሸሽ ነው።<br /> የአላህ መልዕክተኛ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን እንዲህ ብለዋል፦ "በልቡ የሰናፍጭ ቅንጣት የሚያክል ኩራት ያለበት ጀነት አይገባም።" አስከትሎ አንድ ሰው፡- "የሆነ ሰው ልብሱም ጥሩ፣ ጫማውም ጥሩ እንዲሆን ቢወድስ? ሲል እርሳቸውም፦ "አላህ ውብ ነው፤ ውብ ነገርንም ይወዳል። ኩራት ማለት እውነታን መገፍተርና ሰዎችን መናቅ ነው።" ሙስሊም ዘግበውታል።<br /> - እውነታን መገፍተር ማለት እውነትን አለመቀበል ማለት ነው።<br /> - ሰዎችን መናቅ ሲባል ደግሞ ሰዎችን አሳንሶ ማየት ነው።<br /> - ጥሩ ቀሚስ እና ጥሩ ጫማ መልበሱ ኩራት አይደለም። </p>',
      ],
      20 => [
        'question' => 'ጥ21፡ ከተከለከለው የማጭበርበር ዓይነት የተወሰኑትን ይጥቀሱ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/13910.mp3',
        'answer' => '<p> መልስ - በመግዛትና በመሸጥ ላይ ማጭበርበር፡ ይህም የሸቀጦችን እንከን በመደበቅ ሊሆን ይችላል፤<br /> - በመማር ማስተማር ማጭበርበር፡ ተማሪዎች በፈተና ጊዜ መኮረጃቸውን ይመስል፤<br /> - በቃል ማጭበርበር፡ የውሸት ምስክርነትንና ውሸትን ይመስል፤<br /> - ከሰዎች ጋር የተስማሙትን ቃል አለመሙላትን መጥቀስ ይቻላል።<br /> የማጭበርበር ክልከልነትን በተመለከተ የአላህ መልእክተኛ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን በአንድ የእህል ክምር በኩል እያለፉ ሳሉ እጃቸውን ወደ እህሉ አስገቡና ጣቶቻቸው አንዳች እርጥበት ሲያገኘው እንዲህ አሉ፡- <span class="c1">“የእህሉ ባለቤት ሆይ! ይህ ምንድን ነው?”</span> እርሱም፡- "የአላህ መልእክተኛ ሆይ! ዝናብ መትቶት እኮ ነው" አላቸው። እሳቸውም እንዲህ አሉት፦ "<span class="c2">(የእርጥብ ክፍሉን)</span> ሰዎች እንዲያዩት ከክምሩ በላይ በኩል ለምን አላስቀመጥከውም? የሚያጭበረብር ከኛ አይደለም።" ሙስሊም ዘግበውታል።<br /> በሐዲሡ "አስ-ሱብራ" የተባለው የእህል ክምሩ ነው። </p>',
      ],
      21 => [
        'question' => 'ጥ22፡ ሀሜት ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/13990.mp3',
        'answer' => '<p> መልስ - ሙስሊም ወንድምህ በሌለበት ጊዜ በሚጠላው በኩል ማውሳት ነው።<br /> የላቀዉ አላህ እንዲህ ብሏል፦ {ከፊላችሁም ከፊሉን አይማ። አንደኛችሁ የወንድሙን ስጋ የሞተ ኾኖ ሊበላው ይወዳልን? <span class="c2">(መብላቱን)</span> ጠላችሁትም፤ <span class="c2">(ሐሜቱንም ጥሉት)</span>። አላህንም ፍሩ። አላህ ጸጸትን ተቀባይ አዛኝ ነውና። 12} <span class="c5">[ሱረቱል ሑጁራት፡ 12]</span> </p>',
      ],
      22 => [
        'question' => 'ጥ23፡ ሐሜት ምን እንደሆነ ይግለጹ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14030.mp3',
        'answer' => '<p> መልስ - ሀሜት ማለት በሰዎች መካከል ችግር ለመፍጠር ወሬ ማመላለስ ነው።<br /> የአላህ መልዕክተኛ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን እንዲህ ብለዋል፦ "ውሸት አመላላሽ ጀነት አይገባም።" ሙስሊም ዘግበውታል። </p>',
      ],
      23 => [
        'question' => 'ጥ24፡ ስንፍና ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14070.mp3',
        'answer' => '<p> መልስ- መልካም ነገርን ወይም ደግሞ ማድረግ የሚጠበቅበትን ነገር ከማድረግ መስነፍ ነው።<br /> ግዴታ ነገራቶችን ከማድረግ መሰላቸትን እንደምሳሌ መጥቀስ ይቻላል።<br /> የላቀው አላህ እንዲህ ብሏል፦ {መናፍቃን አላህን ያታልላሉ። እርሱም አታላያቸው ነው። <span class="c2">(ይቀጣቸዋል)</span>። ወደ ሶላትም በቆሙ ጊዜ ታካቾች ስዎችን የሚያሳዩ ሆነው ይቆማሉ። አላህንም ጥቂትን እንጅ አያወሱም። 142} <span class="c5">[ሱረቱ-ኒሳእ፡ 142]</span><br /> በመሆኑም ሙእሚን ስልቹነትን፣ መኮፈስንና ስንፍናን ትቶ በዱኒያዊ ጉዳዩም ቢሆን አላህን በሚያስደስት ሥራና እንቅስቃሴ በትጋትና በጥረት ሊጣደፍ ይገባዋል። </p>',
      ],
      24 => [
        'question' => 'ጥ25፡ የቁጣ ዓይነቶች ምን ምን ናቸው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14130.mp3',
        'answer' => '<p> መልስ-1- የተመሰገነ ቁጣ፡- ይሀውም ከሓዲዎች፣ ሙናፊቆችም ሆኑ ሌሎች የአላህን ድንበር ሲጥሱ ለአላህ ተብሎ የሚደረግ ቁጣ ነው።<br /> 2- የተወገዘ ቁጣ፡- ይኸውም አንድ ሰው ማድረግ የማይገባውን እንዲያደርግና እንዲናገር የሚያደርገው የቁጣ ዓይነት ነው።<br /> ለተወገዘው የቁጣ ዓይነት መፍትሄው፦<br /> ውዱእ ማድረግ፤<br /> ቆሞ ከነበረ መቀመጥ፤ ተቀምጦ ከነበረ ደግሞ መጋደም፤<br /> በዚህ ረገድ ነቢዩ <span class="c2">(የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን)</span> ያስተላለፉትን ትእዛዝ መተግበር፡- “አትቆጣ!"<br /> በተናደደ ጊዜ በስሜታዊነት ሌላ ነገር ውስጥ እንዳይገባ ራስን መቆጣጠር፤<br /> "አዑዙ ቢላህ" ብሎ ከተረገመው ሰይጣን ተንኮል በአላህ መጠበቅ፤<br /> ዝምታ። </p>',
      ],
      25 => [
        'question' => 'ጥ26፡ መሰለል ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14240.mp3',
        'answer' => '<p> መልስ - የሰዎችን ነውርና የሚደብቁትንም ነገር መፈላፈልና ማጋለጥ ነው።<br /> ከተከለከሉት መገለጫዎቹ መካከልም፡-<br /> በቤት ውስጥ የሰዎችን የግል ክፍሎች ማየት፤<br /> ሰዎቹ ሳያውቁ ወሬያቸውን ማዳመጥ፤<br /> የላቀዉ አላህ እንዲህ ብሏል፦ <span class="c4">{ነውርንም አትከታተሉ ...}</span> <span class="c5">[ሱረቱል ሑጁራት፡ 12]</span> </p>',
      ],
      26 => [
        'question' => 'ጥ 27፡ አባካኝነት ምንድን ነው? ስስትስ ምንድን ነው? ልግስናስ ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14310.mp3',
        'answer' => '<p> መልስ - አባካኝነት ማለት፡ ገንዘብን ተገቢ ባልሆነ መልኩ ማውጣት ነው።<br /> ተቃራኒው ደግሞ ስስት ሲሆን፡ ገንዘብ ሊወጣበት ለሚገባው ነገር ከማውጣት መታቀብ ነው።<br /> ትክክለኛው ነገር በመካከላቸው ያለው <span class="c2">(ለጋስነት)</span> ነው። ሙስሊም ለጋስ ነው መሆን ያለበት።<br /> የላቀዉ አላህ እንዲህ ብሏል፦ {እነዚያም በለገሱ ጊዜ የማያባክኑ የማይሰስቱትም ናቸው። በዚህም መካከል <span class="c2">(ልግስናቸው)</span> ተክክለኛ የሆኑ ናቸው። 67} <span class="c5">[ሱረቱል ፉርቃን፡ 67]</span> </p>',
      ],
      27 => [
        'question' => 'ጥ28: ፈሪ መሆን ምን ማለት ነው? ጀግንትነስ ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14370.mp3',
        'answer' => '<p> መልስ- ፈሪ መሆን ማለት፡- መፈራት የሌለበትን ነገር መፍራት ነው።<br /> ሐቅን ከመናገር እና ክፋትን ከመከልከል መፍራት ነው።<br /> ጀግንነት ማለት ደግሞ፡- ከእስልምና እና ከሙስሊሞች ለመከላከል በጂሃድ የጦር አውድማዎች ግንባር ቀደም መሆንን የመሳሰሉ እውነታዎች ላይ ፊት ለፊት መሆን ነው።<br /> ነብዩ <span class="c2">(የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን)</span> በዱዓያቸው እንዲህ ብለዋል፡- "አላህ ሆይ! ፈሪ ከመሆን ባንተ እጠበቃለሁ።" የአላህ መልዕክተኛ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን እንዲህ ብለዋል፦ "ጠንካራው አማኝ ከደካማው አማኝ ይልቅ አላህ ዘንድ የተሻለ እና የተወደደ ነው።ምንም እንኳን ሁሉም ዘንድ መልካም ነገር አለ።" ሙስሊም ዘግበውታል። </p>',
      ],
      28 => [
        'question' => 'ጥ 29፡ ከተከለከሉት የምላስ ቃላት መካከል ጥቂቶቹን ጥቀስ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14440.mp3',
        'answer' => '<p> መልስ - ለምሳሌ እርግማን እና ስድብ፤<br /> እገሌ "እንስሳ" ነው ማለት ወይም መሰል የቃል አጠቃቀምን ይመስል፤<br /> ወይም የብልግናና አፀያፊ ነውሮችን መናገር፤<br /> ነቢዩ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን ይህን ሁሉ ከልክለዋል፤ እንዲህም ብለዋል፦ “ሙእሚን ዘላፊ፤ ተራጋሚም፤ ወይም ባለጌ አልያም ስድ አይደለም።" ቲርሚዚይ እና ኢብኑ ሒባን ዘግበውታል። </p>',
      ],
      29 => [
        'question' => 'ጥ 30፡ አንድን ሙስሊም ጥሩ ስነምግባር እንዲላበስ ሊረዱት የሚችሉ ስልቶችን ጥቀስ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14500.mp3',
        'answer' => '<p> መልስ-1- መልካም ስነምግባር እንዲቸርህና በዛ ላይም እገዛውን እንዲለግስህ ዱዓእ ማድረግ፤<br /> 2- ልዕለ ኋያሉ አላህ እንደሚቆጣጠርህ፣ እንደሚሰማህ እና እንደሚያይህ አስበህ ማስተዋል፤<br /> 3- የመልካም ስነምግባርን ምንዳ እና ጀነት ለመግባት ምክንያት መሆኑን ማስታወስ፤<br /> 4- የመጥፎ ስነ ምግባርን መዘዝ እና ወደ እሳትም ለመግባት ምክንያት መሆኑን ማስታወስ፤<br /> 5- መልካም ሥነ ምግባር የአላህንም የፍጡራንንም ውዴታ እንደሚያተርፍልህ፤ በተቃራኒው መጥፎ ሥነ ምግባር ደግሞ የአላህም የፍጡራንም እንደሚያስከትልብህ ማወቅ።<br /> 6- የነቢዩን የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን የህይወት ታሪክ ማንበብ እና ፋናቸውን መከተል፤<br /> 7- ከጥሩ ሰዎች ጋር መቀራረብ እና ከመጥፎ ሰዎች ደግሞ መራቅ ነው። </p>',
      ],
    ],
    8 => [
      0 => [
        'question' => 'ጥ 1፡ የዚክር ትሩፋት ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14630.mp3',
        'answer' => '<p> ነብዩ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን እንዲህ ብለዋል፦ "አላህን የሚያስታውስና አላህን የማያስታውስ ሰው ምሳሌው እንደ ህያዋንና ሙታን ነው።" ቡኻሪይ ዘግበውታል።<br /> - ይህም የሆነበት ምክንያት የሰው ልጅ የህይወት ዋጋ የላቀው አላህን በማስታወሱ ልክ የሚተመን በመሆኑ ነው። </p>',
      ],
      1 => [
        'question' => 'ጥ 2፡- የተወሰኑ የዚክር ጥቅሞችን ጥቀስ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14670.mp3',
        'answer' => '<p> መልስ-1- አርረሕማንን ያስደስታል፤<br /> 2- ሸይጣንን ያባርራል፤<br /> 3- ሙስሊምን ከመጥፎ ነገር ይጠብቀዋል፤<br /> 4- የአላህን ምንዳና ሽልማት ያስገኛል፤ </p>',
      ],
      2 => [
        'question' => 'ጥ3፡ በላጩ ዚክር ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14730.mp3',
        'answer' => '<p> መልስ- በላጩ ዚክር "ላ ኢላሃ ኢለላህ" ነው። ቲርሚዚይ እና ኢብኑ ማጃህ ዘግበውታል። </p>',
      ],
      3 => [
        'question' => 'ጥ4: ከእንቅልፍህ ስትነቃ ምን ትላለህ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14760.mp3',
        'answer' => '<p> መልስ- "አልሐምዱ ሊላሂ አልለዚ አሕያና በዕደ ማ አማታና ወኢለይሂን-ኑሹር።" <span class="c2">(ትርጉሙም: ከሞት በኋላ ህይወት ለሰጠን አላህ ምስጋና የተገባ ነው። መመለሻም ወደርሱው ነው።)</span> ቡኻሪና ሙስሊም ዘግበውታል። </p>',
      ],
      4 => [
        'question' => 'ጥ5: ልብስህን ስትለብስ ምን ትላለህ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14790.mp3',
        'answer' => '<p> መልስ- "አልሐምዱ ሊላሂ አል-ለዚ ካሳኒ ሀዛ አስሠውበ ወረዘቀኒሂ ሚን ገይሪ ሐውሊን ሚኒ ወላ ቁዋህ።" <span class="c2">(ትርጉሙም፡ የኔ አቅም ወይም ብልሀት ሳይታከልበት ይህንን (ልብስ)</span> እንድለብስ ላደረገኝ አላህ ምስጋና ይገባው።) አቡ ዳውድ እና ቲርሚዚይ እንዲሁም ሌሎችም ዘግበውታል። </p>',
      ],
      5 => [
        'question' => 'ጥ6: ልብስህን ስታወልቅ ምን ትላለህ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14820.mp3',
        'answer' => '<p> መልስ- "ቢስሚላህ" <span class="c2">(ትርጉሙም: "በአላህ ስም")</span> ቲርሚዚይ ዘግበውታል። </p>',
      ],
      6 => [
        'question' => 'ጥ 7፡ አዲስ ልብስ ሲለበስ የሚባለው ዱዓእ ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14850.mp3',
        'answer' => '<p> መልስ- "አላሁምመ ለከል-ሐምዱ አንተ ከሰውተኒሂ፤ አስአሉከ ኸይርሂ ወኸይረ ማ ሱኒዐ ለሁ፤ ወአዑዙ ቢከ ሚን ሸሪሂ ወሸሪ ማ ሱነዑ ለህ" (ትርጉሙም፡ አላህ ሆይ አልብሰሀኛልና ምስጋና ላንተ ይሁን። ከመልካምነቱና ከተሰራበት መልካም ነገር እጠይቅሃለሁ። ከክፋቱና ከተሰራበት ክፋትም ጥበቃህን እሻለሁ።} አቡ ዳውድ እና ቲርሚዚይ ዘግበውታል። </p>',
      ],
      7 => [
        'question' => 'ጥ 8፡ አዲስ ልብስ ለለበሰ ሰው የሚደረግለት ዱዓእ ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14880.mp3',
        'answer' => '<p> መልስ - ሌላ ሰው አዲስ ልብስ ለብሶ ካየሀው እንዲህ በማለት ዱዓእ ታደርግለታለህ፡- "ቱብላ ወ ዩኽሊፉል-ላሁ ተዓላ።" <span class="c2">(ትርጉሙም፡ ልብሱ አልቆ አላህ ይተካልህ።)</span> አቡ ዳውድ ዘግበውታል። </p>',
      ],
      8 => [
        'question' => 'ጥ9: ወደ መጸዳጃ ቤት ሲገባ የሚባለውን ዱዓእ ጥቀስ፤ ማለትም የምንጸዳዳበት ስፍራ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14910.mp3',
        'answer' => '<p> መልስ- "አሏሁመ ኢኒ አዑዙ ቢከ ሚነል ኹቡሢ ወልኸባኢሥ" <span class="c2">(ትርጉሙም፡ አላህ ሆይ! እኔ ከውንድና ከሴት ጂኒ ባንተው እጠበቃለሁ።)</span> ቡኻሪና ሙስሊም ዘግበውታል። </p>',
      ],
      9 => [
        'question' => 'ጥ10: ከመጸዳጃ ቤት ሲወጣ የሚባለው ዱዓእ ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14940.mp3',
        'answer' => '<p> መልስ- "ጉፍራነክ" <span class="c2">(ትርጉሙም: "መሀርታህን ለግሰኝ")</span> አቡ ዳውድ እና ቲርሚዚይ ዘግበውታል። </p>',
      ],
      10 => [
        'question' => 'ጥ 11፡ ከውዱእ በፊት ምን ትላለህ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14970.mp3',
        'answer' => '<p> መልስ- "ቢስሚላህ" <span class="c2">(ትርጉሙም "በአላህ ስም")</span> አቡ ዳውድና ሌሎችም ዘግበውታል። </p>',
      ],
      11 => [
        'question' => 'ጥ12፡ ውዱእ ከጨረስን በኋላ የሚባለው ዚክር ምንድነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15000.mp3',
        'answer' => '<p> "አሽሀዱ አን ላ ኢላሀ ኢለላሁ ወሕደሁ ላ ሸሪከ ለሁ ወአሽሀዱ አንነ ሙሐመደን ዐብዱሁ ወረሱሉህ" <span class="c2">(ትርጉሙም፡ ከአላህ በስተቀር በእውነት የሚገዙት አምላክ እንደሌለና ሙሐመድም መልእክተኛው እና ባሪያው መሆናቸውን እመስከራለሁ።)</span> ሙስሊም ዘግበውታል። </p>',
      ],
      12 => [
        'question' => 'ጥ13፡ ከቤት ሲወጡ የሚባለው ዚክር ምንድነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15020.mp3',
        'answer' => '<p> "ቢስሚላሂ ተወከልቱ ዐለላሂ ወላ ሐውላ ወላ ቁወተ ኢላ ቢላህ" <span class="c2">(ትርጉሙም፡ በአላህ ስም፤ በአላህ ተመካሁ። በአላህ ካልሆነ በቀርም ምንም ሃይልም ብልሀትም የለም።)</span> አቡ ዳውድ እና ቲርሚዚይ ዘግበውታል። </p>',
      ],
      13 => [
        'question' => 'ጥ 14፡ ወደ ቤት ሲገቡ የሚባለው ዚክር ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15050.mp3',
        'answer' => '<p> "ቢስሚላሂ ወለጅና ወ ቢስሚላሂ ኸረጅና ወዐላ ረቢና ተወከልና" <span class="c2">(ትርጉሙም፡ በአላህ ስም ገባን፤ በአላህም ስም ወጣን፤ የምንመካውም በአላህ ነው።)</span> ከዚያም ቤተሰቡን ሰላምታ ይስጥ። አቡ ዳውድ ዘግበውታል። </p>',
      ],
      14 => [
        'question' => 'ጥ 15፡ መስጂድ ሲገባ የሚባለው ዱዓእ ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15080.mp3',
        'answer' => '<p> መልስ - "አልላሁምመ ኢፍተሕሊ አብዋበ ረሕመቲክ" <span class="c2">(ትርጉሙም፡ አላህ ሆይ! የምህረትህን በሮች ክፈትልኝ።)</span> ሙስሊም ዘግበውታል። </p>',
      ],
      15 => [
        'question' => 'ጥ 16፡ ከመስጂድ ሲወጣ የሚባለውን ዱዓእ ጥቀስ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15110.mp3',
        'answer' => '<p> መልስ - <span class="c1">“አላሁምመ ኢኒ አስአሉከ ሚን ፈድሊክ”</span> <span class="c2">(ትርጉሙም፡ አላህ ሆይ! ከችሮታህ እማፀንሀለሁ።)</span> ሙስሊም ዘግበውታል። </p>',
      ],
      16 => [
        'question' => 'ጥ 17፡ አዛን ስትሰማ ምን ትላለህ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15140.mp3',
        'answer' => '<p> መልስ - ልክ ሙአዚኑ እንደሚለው እልና "ሐያ ዐለ ሰላህ" እና "ሐያ ዐለል ፈላሕ" ሲል <span class="c1">“ላ ሐውላ ወላ ቁወተ ኢላ ቢላህ”</span> እላለሁ። ቡኻሪና ሙስሊም ዘግበውታል። </p>',
      ],
      17 => [
        'question' => 'ጥ 18፡ ከአዛን በኋላ ምን ትላለህ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15170.mp3',
        'answer' => '<p> መልስ - <span class="c2">(በነቢዩ ሰለላሁ ዐለይሂ ወሰለም ላይ ሶለዋት አወርዳለሁ።)</span> ሙስሊም ዘግበውታል። "አላሁምመ ረብበ ሐዚሂ አድዳዕወቲ አትታማህ፤ ወስ-ሶላቲ አል-ቃኢማህ፤ አቲ ሙሐመዲን አል-ወሲለተ ወልፈዲላህ፤ ወብዐሥሁ መቃመን መሕሙደን አልለዚ ወዐድተህ።" <span class="c2">(ትርጉሙም፡ የዚህ የተሟላ ጥሪና የተቋቋመው ሶላት ጌታ አላህ ሆይ! (ነብዩ)</span> ሙሐመድን "ወሲላ" እና "ፈዲላ" ለግሳቸው፤ ቃል በገባህላቸው በተከበረው ቦታም ቀስቅሳቸው።) ቡኻሪይ ዘግበውታል።<br /> በአዛንና በኢቃማ መካከልም ዱዓ ታደርጋለህ፤ ምክንያቱም በዛ ሰአት የተደረገ ዱዓእ አይመለስምና። </p>',
      ],
      18 => [
        'question' => 'ጥ 19፡ በጠዋት እና ማታ የትኛውን ዚክር ትላለህ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15220.mp3',
        'answer' => '<p> መልስ-1- አያተል-ኩርሲይ እቀራለሁ፡- "አልላሁ ላ ኢላሃ ኢላ ሁወል ሓዩል ቀዩም ላ ታእኹዙሁ ሲነቱን ወላ ነውም፤ ለሁ ማ ፊሰማዋቲ ወማ ፊል አርዲ፤ መንዘለዚ የሽፈዑ ዒንደሁ ኢላ ቢኢዝኒህ፤ ያዕለሙ ማ በይነ አይዲሂም ወማ ኸልፈሁም፤ ወላ ዩሒጡነ ቢሸይኢን ሚን ዒልሚሂ ኢላ ቢማ ሻአ፤ ወሲዐ ኩርሲዩሁ ሰማዋቲ ወልአርድ፤ ወላ የኡዱሁ ሒፍዙሁማ ወሁወል ዓሊዩል ዓዚም።" {አላህ ከእርሱ በቀር ሌላ አምላክ የለም። ሕያው ራሱን ቻይ ነው። ማንገላጀትም እንቅልፍም አትይዘውም። በሰማያት ውስጥና በምድር ውስጥ ያለው ሁሉ የርሱ ብቻ ነው። ያ እርሱ ዘንድ በፈቃዱ ቢሆን እንጅ የሚያማልድ ማነው? <span class="c2">(ከፍጡሮች)</span> በፊታቸው ያለውንና ከኋላቸው ያለውን ሁሉ ያውቃል። በሻውም ነገር እንጂ ከዕውቀቱ በምንም ነገር አያካብቡም <span class="c2">(አያውቁም)</span>። መንበሩ ሰማያትንና ምድርን ሰፋ። ጥበቃቸውም አያቅተውም። እርሱም የሁሉ በላይ ታላቅ ነው።} <span class="c5">[ሱረቱል በቀራህ፡ 255]</span> 2- እንደሚክተለውም <span class="c2">(ሱረቱል ኢኽላስንና ሁለቱን ቁል አዑዙ)</span> እቀራለሁ፡- በአላህ ስም እጅግ በጣም ሩኅሩህ በጣም አዛኝ በሆነው። {በል «እርሱ አላህ አንድ ነው። <span class="c2">(1)</span> አላህ <span class="c2">(የሁሉ)</span> መጠጊያ ነው። <span class="c2">(2)</span> አልወለደም፤ አልተወለደምም። <span class="c2">(3)</span> ለእርሱም አንድም ብጤ የለውም። <span class="c2">(4)</span>} ሦስት ጊዜ። በአላህ ስም እጅግ በጣም ሩኅሩህ በጣም አዛኝ በሆነው። {በል «በተፈልቃቂው ጎህ ጌታ እጠበቃለሁ። <span class="c2">(1)</span> ከፈጠረው ፍጡር ሁሉ ክፋት። <span class="c2">(2)</span> ከሌሊትም ክፋት ባጨለመ ጊዜ። <span class="c2">(3)</span> በተቋጠሩ <span class="c2">(ክሮች)</span> ላይ ተፊዎች ከሆኑት <span class="c2">(ደጋሚ)</span> ሴቶችም ክፋት። <span class="c2">(4)</span> ከምቀኛም ክፋት በተመቀኘ ጊዜ፤ <span class="c2">(እጠበቃለሁ በል)</span>። <span class="c2">(5)</span>} ሦስት ጊዜ። በአላህ ስም እጅግ በጣም ሩኅሩህ በጣም አዛኝ በሆነው። {በል «በተፈልቃቂው ጎህ ጌታ እጠበቃለሁ። <span class="c2">(1)</span> የሰዎች ሁሉ ንጉሥ በሆነው። <span class="c2">(2)</span> የሰዎች አምላክ በሆነው። <span class="c2">(3)</span> ብቅ እልም ባይ ከሆነው ጎትጓች <span class="c2">(ሰይጣን)</span> ክፋት። <span class="c2">(4)</span> ከዚያ በሰዎች ልቦች ውስጥ የሚጎተጉት ከሆነው። <span class="c2">(5)</span> ከጋኔኖችም ከሰዎችም <span class="c2">(ሰይጣናት እጠበቃለሁ በል)</span>። <span class="c2">(6)</span>} ሦስት ጊዜ። "አላሁመ አንተ ረቢ ላ ኢላሃ ኢላ አንተ ኸለቅተኒ ወአነ ዐብዱክ ወ አነ ዐላ አህዲከ ወዋዕዲከ መስተጣዕቱ አዑዙ ቢከ ሚን ሸሪ ሶናዕቱ አቡኡ ለከ ቢኒዕመቲከ ዐለየ ወአቡኡ ቢዘንቢ ፈግፊር ሊ ፈኢነሁ ላ የግፊሩዝ-ዙኑበ ኢላ አንት"<br /> <span class="c2">(ትርጉሙም፡ አላህ ሆይ አንተ ጌታዬ ነህ ከአንተ በቀርም አምልኮ የሚገባው የለም። አንተው ፈጠርከኝ እኔም ባሪያህ ነኝ። ቃል ኪዳንህንና ለአንተ የገባሁትንም ቃል ለመጠበቅ የቻልኩትን ያህል እጥራለሁ። በኔ ላይ ባለህ ችሮታና ኃጢአቴንም የማምን በመሆኔ ከሰራሁት ክፋት በአንተው እጠበቃለሁ። ማረኝ ከአንተ በቀር ኃጢአትን የሚምር የለምና።)</span> ቡኻሪይ ዘግበውታል። </p>',
      ],
      19 => [
        'question' => 'ጥ20፡ ስትተኛ ምን ትላለህ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15290.mp3',
        'answer' => '<p> መልስ - <span class="c1">“አላህ ሆይ! በስምህ እንሞታለን ህያው እንሆናለን።”</span> ቡኻሪና ሙስሊም ዘግበውታል። </p>',
      ],
      20 => [
        'question' => 'ጥ21: ምግብ ከመብላት በፊት የምንለው ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15320.mp3',
        'answer' => '<p> መልስ- "ቢስሚላህ" <span class="c2">(ትርጉሙም፦ "በአላህ ስም" ማለት ነው።)</span><br /> መጀመሪያ ላይ ከረሳህ ደግሞ፡-<br /> "ቢስሚላሂ ፊ አወሊሂ ወአኺሪህ።" <span class="c2">(ትርጉሙም፡ ቢስሚላህ ለመጀመርያው ለመጨረሻውም።)</span> አቡዳውድ እና ቲርሚዚይ ዘግበውታል። </p>',
      ],
      21 => [
        'question' => 'ጥ22፡ ምግብ በልተን የምንለው ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15370.mp3',
        'answer' => '<p> መልስ- "አልሓምዱ ሊላሂ አልለዚ አጥዓመኒ ሀዛ ወረዘቀኒ፤ ሚን ገይሪ ሐውሊን ሚኒ ወላ ቁወህ።" <span class="c2">(ትርጉሙም፡ የኔ ሀይልም ብልሀትም ሳይኖር ይህንን ምግብ ለመገበኝና ለለገሰኝ አላህ ምስጋና ይገባው።)</span> አቡ ዳውድ፣ ኢብኑ ማጃህ እና ሌሎችም ዘግበውታል። </p>',
      ],
      22 => [
        'question' => 'ጥ 23፡ እንግዳው ለጋባዡ የሚያደርግለት ዱዓእ ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15400.mp3',
        'answer' => '<p> "አላሁምመ ባሪክ ለሁም ፊማ ረዘቅተሁም፤ ወግ’ፊር ለሁም ወርሐምሁም።" <span class="c2">(ትርጉሙም፡ አላህ ሆይ! በሰጠሃቸው ነገር በረካ አድርግላቸው። ይቅር በላቸው እዘንላቸውም።)</span> ሙስሊም ዘግበውታል። </p>',
      ],
      23 => [
        'question' => 'ጥ 24፡ አንድ ሰው ሲያስነጥሰው ምንድን ነው የሚለው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15430.mp3',
        'answer' => '<p> መልስ- "አልሐምዱ ሊላህ"<br /> ያኔ ወንድሙ ወይም ባልንጀራው “የርሐሙከላህ” <span class="c2">(አላህ ይዘንልህ)</span> ይበለው።<br /> እንዲህ ካሉት እርሱም፦ "የህዲኩሙላሁ ወ ዩስሊሕ ባላኩም" ብሎ ይመልስ። ቡኻሪይ ዘግበውታል። </p>',
      ],
      24 => [
        'question' => 'ጥ 25፡- ስብሰባችንን ጨርሰህ ስንነሳ የሚባለው (ከፋረቱል መጅሊስ) ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15480.mp3',
        'answer' => '<p> መልስ - "ሱብሐነከላሁመ ወቢሐምዲከ አሽሀዱ አን ላ ኢላሃ ኢላ አንተ አስተግፊሩከ ወአቱቡ ኢለይክ።" <span class="c2">(ትርጉሙም: ክብርና ምስጋና ላንተ ይሁን፤ ከአንተ በቀር ሌላ አምላክ እንደሌለም እመሰክራ ለሁ፤ መሀርታህንም እከጅላለሁ ወደ አንተም ተፀፅቼ እመለሳለሁ።)</span> አቡዳውድ እና ቲርሚዚይ እንዲሁም ሌሎችም ዘግበውታል። </p>',
      ],
      25 => [
        'question' => 'ጥ 26፡ መጓጓዣ ላይ ሲወጣ የሚባለው ዱዓእ ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15510.mp3',
        'answer' => '<p> መልስ- "ቢስሚላህ፤ ወልሐምዱሊላህ፤ ሱብሐነ አልለዚ ሰኸረ ለና ሀዛ ወማ ኩና ለሁ መቅሪኒን <span class="c2">(13)</span> ወኢና ኢላ ረቢና ለሙንቀሊቡን <span class="c2">(14)</span>" <span class="c2">(አልሐምዱሊላህ፤ አልሐምዱሊላህ፤ አልሐምዱሊላህ፤ አላሁ አክበር፤ አላሁ አክበር፤ አላሁ አክበር፤ ሱብሐነከላሁምመ ኢኒ ዘለምቱ ነፍሲ ፈግፊርሊ ፈኢነሁ ላየግፊሩ ዙኑበ ኢላ አንት።" (ትርጉሙም፡ «ያ ይህንን የማንችለው ስንሆን ለእኛ ያገራለን ጌታ ጥራት ይገባው። (13)</span> እኛም በእርግጥ ወደ ጌታችን ተመላሾች፤ነን 14» ምስጋና ለአላህ ይገባው። ምስጋና ለአላህ ይገባው። ምስጋና ለአላህ ይገባው። አላህ ታላቅ ነው። አላህ ታላቅ ነው። አላህ ታላቅ ነው። አላህ ሆይ! ጥራት ይገባህ ነፍሴን በድያለሁ። ማረኝ ከአንተ በቀር ኃጢአትን የሚምር የለምና።) አቡዳውድ እና ቲርሚዚይ ዘግበውታል። </p>',
      ],
      26 => [
        'question' => 'ጥ 27፡ በጉዞ ወቅት የሚባለውን ዱዓእን ጥቅስ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15540.mp3',
        'answer' => '<p> መልስ- "አላሁ አክበር፤ አላሁ አክበር፤ አላሁ አክበር፤ {ሱብሐነ አልለዚ ሰኸረ ለና ሀዛ ወማ ኩና ለሁ መቅሪኒን <span class="c2">(13)</span> ወኢና ኢላ ረቢና ለሙንቀሊቡን <span class="c2">(14)</span>} አልላሁመ ኢንና ነስአሉከ ፊ ሰፈሪና ሀዛ አል-ቢረ ወት-ተቅዋ ወሚነል ዐመሊ ማ ተርዷ አላሁመ ሀውዊን ዐለይና ሰፈሪና ሀዛ ወጥዊ ዓና ባዕደሁ አላሁመ አንታስ-ሷሒቡ ፊስ-ሰፈር ወል-ኸሊፈቱ ፊል-አህሊ አላሁመ ኢንኒ አዑዙ ቢከ ሚን ወዕሣኢ-ሰፈር ወካአባቲል-መንዞር ወሱኢል-ሙንቀለቢ ፊል-ማሊ ወል-አህል" <span class="c2">(ትርጉሙም፡ አላህ ታላቅ ነው። አላህ ታላቅ ነው። አላህ ታላቅ ነው። «ያ ይህንን የማንችለው ስንሆን ለእኛ ያገራለን ጌታ ጥራት ይገባው። (13)</span> እኛም በእርግጥ ወደ ጌታችን ተመላሾች ነን <span class="c2">(14)</span>» አላህ ሆይ! በዚህ ጉዟችን ለበጎነት እና ለመልካምነት አንተንም ለሚያስደስቱን ተግባሮች እንድትገጥመን እንማፀንሃለን። አላህ ሆይ! ይህን ጉዞ አቅልልን እና ርቀቱንም ቅርብ አድርግልን። አላህ ሆይ! በመንገዳችን ያለሀን ረዳታችን እና ለቤተሰቦቻችንም የተውንላቸው አንተን ነው። አላህ ሆይ! ከጉዞ መከራና ከክፉ እይታዎችም ባንተ እጠበቃለሁ። በቤተሰባችንና በንብረታችን ስንመለስ በችግር ውስጥ ከማግኘትም ባንተው እንጠበቃለን።)<br /> ተመልሶም ሲመጣም እንዲሁ ካለ በኋላ ተከታዩንም ያክላል፦<br /> "ኣይቡነ፤ ታኢቡነ፤ ዓቢዱን ሊረቢና ሐሚዱን" <span class="c2">(ትርጉሙም፡ ጌታችንን እያመሰገንን ተፀፃቾችና፤ ተውባ አድራጊዎች፤ ለጌታችን አመስጋኞች ሆነን ተመለስን።)</span> ሙስሊም ዘግበውታል። </p>',
      ],
      27 => [
        'question' => 'ጥ 28፡ መንገደኛ የሆነ ሰው ነዋሪ ለሆነ የሚያደርግለት ዱዓእ ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15590.mp3',
        'answer' => '<p> "አስተውዲዑኩሙላሁ-ል-ለዚ ላ ቱደዪዑ ወዳኢዑሁ" <span class="c2">(ትርጉሙም፡ አደራየን እርሱ ዘንድ የተጣለ አደራ በማይጠፋው አላህ ላይ አድርጌ እሰናበትሀለሁ።)</span> ኢማም አሕመድ እና ኢብኑ ማጃህ ዘግበውታል። </p>',
      ],
      28 => [
        'question' => 'ጥ 29፡ ነዋሪ የሆነ ለመንገደኛው የሚያደርግለት ዱዓእ ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15620.mp3',
        'answer' => '<p> "አስታውዲኡላሀ ዲነክ፤ ወ አማነተክ፤ ወ ኸዋቲመ ዐመሊክ።" <span class="c2">(ትርጉሙም፡ ሀይማኖትህን፣ ደህንነትህንና የሥራ ፍፃሜህን በአላህ ላይ አደራ እተወዋለሁ።)</span> ኢማሙ አሕመድና ቲርሚዚይ ዘግበውታል። </p>',
      ],
      29 => [
        'question' => 'ጥ30: ወደ ገበያ ሲገባ የሚባለው ዱዓእ ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15650.mp3',
        'answer' => '<p> "ላ ኢላሀ ኢለላህ ወሕደሁ ላ ሸሪከ ለሁ፡ ለሁል-ሙልኩ ወለሁል-ሐምዱ ዩሕይ ወዩሚት፤ ወሁወ ሐዩን ላ የሙት፤ ቢየዲሂል-ኸይር ወሁወ ዐላ ኩሊ ሸይኢን ቀዲር።" <span class="c2">(ትርጉሙም፡ ከአላህ በስተቀር በእውነት አምልኮ የሚገባው አምላክ የለም፤ ተጋሪ የለውም። ንግሥናም ምስጋናም የእርሱ ብቻ ነው። ሕያው ያደርጋል፤ ይገድላልም። እርሱም የማይሞት ሕያው ነው። መልካም ሁሉ በእጁ ነው እርሱም በነገሩ ሁሉ ላይ ቻይ ነው።)</span> ቲርሚዚይ እና ኢብኑ ማጃህ ዘግበውታል። </p>',
      ],
      30 => [
        'question' => 'ጥ 31፡ በቁጣ ጊዜ የሚባለውን ዱዓእ ጥቀስ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15680.mp3',
        'answer' => '<p> መልስ- "አዑዙ ቢላሂ ሚነሽሸይጧን አርረጂም" <span class="c2">(ትርጉሙ፡ ከተረገመው ሸይጣን በአላህ እጠበቃለሁ።)</span> ቡኻሪና ሙስሊም ዘግበውታል። </p>',
      ],
      31 => [
        'question' => 'ጥ 32፡ መልካም ላደረገልህ ሰው ምን ትለዋለህ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15710.mp3',
        'answer' => '<p> መልስ- "ጀዛከላሁ ኸይረን" <span class="c2">(ትርጉሙም፡ መልካም ምንዳህን አላህ ይክፈልህ።)</span> ቲርሚዚይ ዘግበውታል። </p>',
      ],
      32 => [
        'question' => 'ጥ 33፡ መጓጓዣ ሲዳከም የሚባለው ዱዓእ ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15740.mp3',
        'answer' => '<p> መልስ- "ቢስሚላህ" <span class="c2">(ትርጉሙም፦ "በአላህ ስም" ማለት ነው።)</span> አቡዳውድ ዘግበውታል። </p>',
      ],
      33 => [
        'question' => 'ጥ34: የሚያስደስትህ ነገር ሲያጋጥምህ ምን ትላለህ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15770.mp3',
        'answer' => '<p> መልስ- "አልሐምዱ ሊላሂ አልለዚ ቢኒዕመቲሂ ተቲሙ አስሷሊሓት" <span class="c2">(ትርጉሙም፡ ያ በጎዎችም በጸጋው የሚሞሉት አላህ ምስጋና መላ ተገባው።)</span> አል-ሐኪም እና ሌሎችም ዘግበውታል። </p>',
      ],
      34 => [
        'question' => 'ጥ 35፡ የሚያስከፋህ ነገር ሲያጋጥምህ ምን ትላለህ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15800.mp3',
        'answer' => '<p> መልስ- "አልሐምዱ ሊላህ ዐላ ኩሊ ሐል" <span class="c2">(ትርጉሙም፡ በሁሉም ሁኔታ ምስጋና ሁሉ ለአላህ የተገባ ነው።)</span> ሰሒሑል ጃሚዕ ላይ ተዘግቧል። </p>',
      ],
      35 => [
        'question' => 'ጥ 36፡ የሰላምታ አሰጣጥ እና ሰላምታን የመመለስ ስርዓት እንዴት ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15830.mp3',
        'answer' => '<p> መልስ- ሙስሊም እንዲህ ነው ሰላምታ የሚያቀርበው፡ "አሰላሙ ዐለይኩም ወረሕመቱላሂ ወበረካቱህ" <span class="c2">(ትርጉሙም፡ የአላህ ሰላም፣ እዝነትና በረከቱ በርሶ ላይ ይስፈን)</span><br /> ለወንድሙም እንዲህ ሲል መለስ ይሰጣል፦ "ወዐለይኩም አስሰላም ወረሕመቱላሂ ወበረካቱህ" <span class="c2">(ትርጉሙም፡ በእርሶም ላይ የአላህ ሰላም፣ እዝነትና በረከቱ ይስፈን)</span> ቲርሚዚይ እና አቡ ዳውድ እንዲሁም ሌሎችም ዘግበውታል። </p>',
      ],
      36 => [
        'question' => 'ጥ 37፡ ዝናብ በሚዘንብ ጊዜ የሚደረገው ዱዓእ ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15870.mp3',
        'answer' => '<p> መልስ- "አሏሁመ ሶይበን ናፊዐን" <span class="c2">(ትርጉሙም፡ አላህ ሆይ! መልካም ቧቧታ አድርገው።)</span> ቡኻሪይ ዘግበውታል። </p>',
      ],
      37 => [
        'question' => 'ጥ 38፡ ዝናብ ከወረደ በኋላ የሚደረገው ዱዓእ ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15900.mp3',
        'answer' => '<p> መልስ- "ሙጢርና ቢፈድሊላሂ ወረሕመቲሂ" <span class="c2">(ትርጉሙም፡ በአላህ እዝነትና ችሮታ ዝናብ አገኘን።)</span> ቡኻሪይ እና ሙስሊም ዘግበውታል። </p>',
      ],
      38 => [
        'question' => 'ጥ 39፡ በንፋስ ጊዜ የሚደረገውን ዱዓእ ጥቀስ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15930.mp3',
        'answer' => '<p> "አልላሁመ ኢኒ አስአሉከ ኸይረሀ ወአዑዙ ቢከ ሚን ሸሪሃ" <span class="c2">(ትርጉሙም፡ አላህ ሆይ! እኔ ኸይሯን እማፀንሃለሁ፤ ከክፋቷም በአንተው እጠበቃለሁ።)</span> አቡ ዳውድ እና ኢብኑ ማጃህ ዘግበውታል። </p>',
      ],
      39 => [
        'question' => 'ጥ 40፡ ነጎድጓድ ሲሰማ የሚደረገውን ዱዓእ ጥቀስ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15960.mp3',
        'answer' => '<p> "ሱብሐነለዚ ዩሰቢሑ ረዕዱ ቢሐምዲሂ ወልመላኢከቱ ሚን ኺፈቲሂ" <span class="c2">(ትርጉሙም፡ ነጎድጓድም እያመሰገነ መላእክትም እርሱን ፈርተው የሚያወድሱት አላህ ጥራት ይገባው።)</span> የኢማሙ ማሊክ ሙወጧእ ላይ ተዘግቧል። </p>',
      ],
      40 => [
        'question' => 'ጥ 41፡ ፊትና ላይ የወደቀ ሰው ስታይ የሚደረገው ዱዓእ ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15990.mp3',
        'answer' => '<p> "አልሐምዱ ሊላሂ አልለዚ ዐፋኒ ሚማ ኢብተላከ ቢሂ፤ ወፈደለኒ ዐላ ከሢረን ሚመን ኸለቀ ተፍዲላ" <span class="c2">(ትርጉሙም፡ በአንተ ላይ ካደረሰብህ ፈተና ያተረፈኝ አላህ ምስጋና ይገባው፤ ከብዙሀኑ ፍጡራኑም በርግጥ አስበለጠኝ።)</span> ቲርሚዚይ ዘግበውታል። </p>',
      ],
      41 => [
        'question' => 'ጥ 42፡ በሰው ዓይን ምክንያት አንዳች ነገር ይደርስበታል ብሎ የሰጋ ሰው የሚያደርገው ዱዓእ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16020.mp3',
        'answer' => '<p> መልስ- በሐዲሥ፡- ‹‹ከእናንተ አንዳችሁ ከወንድሙ ወይም ከራሱ፣ ወይም ከገንዘቡ የሚወደድ ነገርን የተመለከተ <span class="c2">(አላህ በረካ እንዲያደርግለት ዱዓእ ያድርግ)</span> የሰው ዓይን በትክክል ያለ ነገር ነውና።" ኢማም አሕመድ እና ኢብኑ ማጃህ እንዲሁም ሌሎችም ዘግበውታል። </p>',
      ],
      42 => [
        'question' => 'ጥ 43፡ በነብዩ (የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን) ላይ ሶለዋት የምታወርደው እንዴት ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16050.mp3',
        'answer' => '<p> መልስ- "አላሁመ ሰሊ ዐላ ሙሐመዲን ወዓላ ኣሊ ሙሐመዲን ከማ ሰለይተ ዐላ ኢብራሂም ወዐላ ኣሊ ኢብራሂም ወባሪክ ዓለ ሙሐመዲን ወዐላ አሊ ሙሐመዲን ከማ ባራክተ ዐላ ኢብራሂም ወዐላ ኣሊ ኢብራሂመ ኢነከ ሐሚዱን-መጂድ።" <span class="c2">(ትርጉሙም፡ አላህ ሆይ! ሶለዋትህን በሙሐመድና በሙሐመድ ቤተሰብ ላይም አድርግ፤ ልክ በኢብራሂም እና በኢብራሂም ቤተሰቦች ሶለዋት እንዳደርግከው፤ አንተ ምስጉን የተከበርክ ነህና። አላህ ሆይ! በረከትህንም በሙሐመድ እና በመሐመድ ቤተሰቦች ላይም አድርግ ልክ በኢብራሂምና በኢብራሂም ቤተሰቦች እንዳደረግከው፤ አንተ ምስጉን የተከበርክ ነህና።)</span> ቡኻሪና ሙስሊም ዘግበውታል። </p>',
      ],
    ],
    9 => [
      0 => [
        'question' => 'ጥ 1፡ አምስቱ የድንጋጌ ዓይነቶች ምን ምን ናቸው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16090.mp3',
        'answer' => '<p> መልስ-<br /> 1 - ዋጂብ <span class="c2">(ግዴታ)</span><br /> 2- ሙስተሐብ <span class="c2">(የተወደደ)</span><br /> 3- ሐራም <span class="c2">(ፈፅሞ የተከለከለ)</span><br /> 4- መክሩህ <span class="c2">(የተጠላ)</span><br /> 5- ሙባሕ <span class="c2">(የተፈቀደ)</span> </p>',
      ],
      1 => [
        'question' => 'ጥ 2፡ እነዚህ አምስቱ የድንጋጌ ዓይነቶችን አብራራ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16170.mp3',
        'answer' => '<p> መልስ-<br /> 1- ግዴታ <span class="c2">(ዋጂብ)</span>፡- አምስቱ የግዴታ ሰላቶች፣ የረመዳን ፆም እና ወላጆችን ማክበርን ይመስል፤<br /> ዋጂብ <span class="c2">(ግዴታ)</span> ማለት አድራጊው መልካም ምንዳ የሚያገኝበት ሲሆን የተወው ደግሞ ቅጣት ይጠብቀዋል።<br /> 2- ሙስተሐብ <span class="c2">(የሚወደድ)</span>፡- ከግዴታ ሶላት በኋላ የሚሰገዱ ሱናዎች፣ የሌሊት ሶላት፣ ሚስኪን ማብላት እና ሰላምታ መለዋወጥ መሰል ነገራቶችን ሲሆን አንዳንዴም "ሱና" ወይም "መንዱብ" ይባላል።<br /> - ሙስተሓብ የሚባለው ቢሰሩት አጅር የሚያስገኝ ቢተውት የማያስቀጣ ነው።<br /> ጠቃሚ <span class="c2">(አንገብጋቢ)</span> ማስታወሻ፡-<br /> አንድ ሙስሊም የሆነ ጉዳይ ሱና ወይም ሙስተሐብ መሆኑን ሲሰማ ተግባራዊ ለማድረግና የነብዩን <span class="c2">(የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን)</span> ፈለግ ለመከተል መጣደፍ ነው ይገባዋል።<br /> 3- ሙሐረም <span class="c2">(የተከለከለ)</span>፡- አልኮል መጠጣት፣ ወላጆችን ማመፅና ዝምድና መቁረጥን መሰል ተግባራቶችን ነው።<br /> ሙሐረም የሆነ ነገር የተወ ሰው ምንዳ የሚያገኝበት የሰራ ደግሞ የሚቀጣበት ነው።<br /> 4- መኩሩህ <span class="c2">(የተጠላ)</span>፡- በግራ እጅ መስጠትና መቀበል፣ በሶላት ወቅት ልብስን <span class="c2">(ክርን ላይ)</span> መሰብሰብን ይመስል<br /> - መክሩህ ነገርን መተው መልካም ምንዳን ያስገኛል፤ የሠራ ሰው ግን አይቀጣም።<br /> 5- ሙባሕ <span class="c2">(የተፈቀደ)</span>፡ ፖም እንደመብላትና ሻይ እንደመጠጣት አይነቱ ሲሆን "ሐላል" ወይ "ጃኢዝ" ይባላል።<br /> - ሙባሕ ስላደረጉት ምናዳ አያሰጥም፤ ስላላደርጉት አያስቀጣም። </p>',
      ],
      2 => [
        'question' => 'ጥ3: ሽያጭ እና ግብይቶች ብይናቸው ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16320.mp3',
        'answer' => '<p> መልስ - በመሰረቱ ሁሉም ሽያጭ እና ግብይቶች የላቀው አላህ ከከለከላቸው አንዳንድ ዓይነቶች በስተቀር የተፈቀዱ ናቸው።<br /> የላቀዉ አላህ እንዲህ ብሏል፦ <span class="c4">{መሸጥን አላህ ፈቅዷል። አራጣንም እርም አድርጓል።}</span> <span class="c5">[ሱረቱል በቀራህ 275]</span> </p>',
      ],
      3 => [
        'question' => 'ጥ4: አንዳንድ መሸጥ የተከለከሉ የግብይት ዓይነቶችን ጥቀሱ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16360.mp3',
        'answer' => '<p> መልስ-<br /> 1-<span class="c6"> ማጭበርበር:</span> ለምሳሌ የሸቀጥን ነውር መደበቅ፤<br /> የማጭበርበር ክልከልነትን በተመለከተ የአላህ መልእክተኛ የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን በአንድ የእህል ክምር -ማለትም የምግብ ክምር- በኩል እያለፉ ሳሉ እጃቸውን ወደ እህሉ ከተቱና ጣቶቻቸው አንዳች እርጥበት ሲያገኘው እንዲህ አሉ፡- <span class="c1">“የእህሉ ባለቤት ሆይ! ይህ ምንድን ነው ይሄ?”</span> እርሱም፡- "የአላህ መልእክተኛ ሆይ! ዝናብ መትቶት እኮ ነው" አላቸው። እርሳቸውም እንዲህ አሉት፦ "<span class="c2">(የእርጥብ ክፍሉን)</span> ሰዎች እንዲያዩት ከክምሩ በላይ በኩል ለምን አላስቀመጥከውም? የሚያጭበረብር ከኛ አይደለም።" ሙስሊም ዘግበውታል።<br /> 2- አራጣ፡- ለምሳሌ ከሆነ ሰው አንድ ሺህ ተቀብሎ ሲመልስለት ግን ሁለት ሺህ አድርጎ መመለስ ነው።<br /> በእዳው ላይ የተጣለው ጭማሪ አራጣ ነው።<br /> የላቀዉ አላህ እንዲህ ብሏል፦ <span class="c4">{መሸጥን አላህ ፈቅዷል። አራጣንም እርም አድርጓል።}</span> <span class="c5">[ሱረቱል በቀራህ 275]</span><br /> 3- አልገረር ወ አልጀሃላህ፡- ይህ ሲባል በበግ <span class="c2">(በፍየል)</span> ጡት ውስጥ ያለን ወተት አልያም ሳይታደን በባህር ውስጥ ያለን አሳ መሸጥ የመሳሰሉትን የሚያካትት ነው።<br /> በሐዲሥ እንደመጣው፡ <span class="c2">(የአላህ መልእክተኛ ሰለላሁ ዐለይሂ ወሰለም "የገረር" ሽያጭን ከልክለዋል።)</span> ሙስሊም ዘግበውታል። </p>',
      ],
      4 => [
        'question' => 'ጥ 5፡ አላህ ከዋለልህ ፀጋዎች የተወሰኑትን ጥቀስ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16460.mp3',
        'answer' => '<p> መልስ-1- የእስልምና ፀጋ፤ ከከሃዲያን አለመሆንህ፤<br /> 2- የሱና ፀጋ፤ ከቢድዓ ሰዎች አለመሆንህ፤<br /> 3-የጤንነት ፀጋ፤ በመስማትም፣ በማየትም፣ በመራመድም በሌላውም ሁሉ ጤናማ መሆን፤<br /> 4- የመብላት፣ የመጠጣትና የመልበስ ፀጋ፤<br /> ሌሎችም የዋለልን ስፍር ቁጥር የሌላቸው ፀጋዎችም ሁሉ።<br /> የላቀዉ አላህ እንዲህ ብሏል፦ <span class="c4">{የአላህንም ጸጋ ብትቆጥሩ አትዘልቋትም። አላህ በእርግጥ መሓሪ አዛኝ ነውና።}</span> <span class="c5">[ሱረቱ-ነሕል፡18]</span> </p>',
      ],
      5 => [
        'question' => 'ጥ 6፡ ፀጋዎችን በተመለከተ ግዴታችን ምንድን ነው? እንዴትስ ተገቢውን ሹክር እናደርሳለን?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16540.mp3',
        'answer' => '<p> መልስ- ያለብን ግዴታ፡- እርሱ ብቸኛ ፀጋ የሚውል በመሆኑ እርሱን በአንደበት ማመስገንና ማወደስ እነዚህን ፀጋዎች ደግሞ አላህ በሚታመፅበት ሳይሆን እርሱን በሚያስደስት ሁኔታ ማዋል ነው። </p>',
      ],
      6 => [
        'question' => 'ጥ 7፡ የሙስሊሞች በዓላት ምን ምን ናቸው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16570.mp3',
        'answer' => '<p> መልስ - ኢድ አልፈጥር እና ኢድ አል-አድሓ <span class="c2">(አረፋ)</span><br /> አነስ ባስተላለፈው ሐዲሥ የአላህ መልዕክተኛ <span class="c2">(የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን)</span> ወደ መዲና በመጡ ጊዜ ሰዎቹ በደስታ የሚያሳልፏቸው ሁለት ቀናት ነበሯቸው። እርሳቸውም <span class="c2">(የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን)</span>፡- "እነዚህ ሁለት ቀናት ምንድን ናቸው?" ብለው ጠየቁ፡ ሰዎቹም፡- "እኛ በቅድመ-ኢስላም የነበሩን የደስታ ቀናት ናቸው።" ብለው መለሱ። እርሳቸውም <span class="c2">(የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን)</span>፦ "አላህ ከእነርሱ የተሻሉ በሆኑ ሁለት በዓላት ማለትም በዒድ አልፈጥር እና በዒድ አል-አድሓ ለውጦላችኋል።" አቡ ዳውድ ዘግበውታል።<br /> ከእነዚህ ውጭ ያሉት በዓላት ቢድዓ ናቸው። </p>',
      ],
      7 => [
        'question' => 'ጥ8: ከወራት ምርጡ ምን ወር ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16620.mp3',
        'answer' => '<p> መልስ - የረመዳን ወር ነው። </p>',
      ],
      8 => [
        'question' => 'ጥ9: ከቀናት ምርጡ ምን ቀን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16650.mp3',
        'answer' => '<p> መልስ - ጁሙዓህ ቀን ነው። </p>',
      ],
      9 => [
        'question' => 'ጥ 10፡ የዓመቱ ምርጥ ቀን ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16680.mp3',
        'answer' => '<p> መልስ - የዓረፋ ቀን ነው። </p>',
      ],
      10 => [
        'question' => 'ጥ11፡ የአመቱ ምርጥ ምሽት የትኛው ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16710.mp3',
        'answer' => '<p> መልስ- ለይለቱል ቀድር ነው። </p>',
      ],
      11 => [
        'question' => 'ጥ 12፡ ባዕድ ሴት ባየህ ጊዜ ግዴታው ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16740.mp3',
        'answer' => '<p> መልስ፡- ግዴታው እይታን ዝቅ ማድረግ ነው። የላቀው አላህ እንዲህ ብሏል፡- {ለምእመናን ንገራቸው፡- ዓይኖቻቸውን <span class="c2">(ያልተፈቀደን ከማየት)</span> ይከልክሉ።} <span class="c5">[ሱረቱ-ኑር፡ 30]</span> </p>',
      ],
      12 => [
        'question' => '13፡ የሰው ልጅ ጠላቶቹ እነማን ናቸው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16770.mp3',
        'answer' => '<p> 1- በክፋት የምታዝ ነፍስ፡- ይህም የላቀው አላህን በማመፅ በኩል የሰው ልጅ ነፍሱንና ስሜቱ ያዘዘችውን ነገር መከተሉ ነው። ጥራት ይገባውና፡ {ነፍስ ሁሉ ጌታዬ የጠበቃት ካልሆነች በስተቀር በመጥፎ ነገር በእርግጥ አዛዥ ናትና። ጌታዬ በጣም መሓሪ አዛኝ ነው» <span class="c2">(አለ)</span>።} <span class="c5">[ሱረቱ ዩሱፍ፡ 53]</span> 2- ሸይጧን፡- የሰው ልጅን ማጥመምና በክፋት ወስውሶ እሳት የማስገባት ዓላማ ያለው የሰው ልጆች ጠላት ነው። የላቀው አላህ እንዲህ ብሏል፡- <span class="c4">{የሰይጣንንም እርምጃዎች አትከታተሉ። እርሱ ለእናንተ ግልጽ ጠላት ነውና።}</span> <span class="c5">[ሱረቱል በቀራህ 168]</span> 3- መጥፎ ጓደኞች፡- ክፋትን የሚያበረታቱና ከመልካም የሚከለክሉት ናቸው። አላህ እንዲህ ብሏል፡- <span class="c4">{ወዳጆች በዚያ ቀን ከፊላቸው ለከፊሉ ጠላት ነው። አላህን ፈሪዎች ብቻ ሲቀሩ።}</span> <span class="c5">[ሱረቱ ዙኽሩፍ፡ 67]</span> </p>',
      ],
      13 => [
        'question' => 'ጥ 14፡ ተውባ (ንሰሃ) ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16820.mp3',
        'answer' => '<p> መልስ- ተውባ ማለት፡- የላቀው አላህን ከማመፅ እርሱን ወደመታዘዝ መመለስ ነው። የላቀው አላህ እንዲህ ብሏል፡- <span class="c4">{እኔም ለተጸጸተ፣ ላመነም፣ መልካምንም ለሠራ፣ ከዚያም ለተመራ ሰው በእርግጥ መሓሪ ነኝ።}</span> <span class="c5">[ሱረቱ ጠሃ፡ 82]</span> </p>',
      ],
      14 => [
        'question' => 'ጥ 15፡ የትክክለኛ ተውባ ቅድመ ሁኔታዎች ምን ምን ናቸው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16850.mp3',
        'answer' => '<p> መልስ- 1- ከኋጢአት መታቀብ፤<br /> 2 - ስላለፈው ነገር መጸጸት፤<br /> 3- ወደ ኋጢአቱ ላለመመለስ መወሰን፤<br /> 4- የሰዎችን ሐቅ መመለስና የበደልናቸውም ካለ ይቅርታቸውን መጠየቅ።<br /> የላቀዉ አላህ እንዲህ ብሏል፦ {ለእነዚያም መጥፎ ሥራን በሠሩ ወይም ነፍሶቻቸውን በበደሉ ጊዜ አላህን የሚያስታውሱና ለኀጢአቶቻቸው ምሕረትን የሚለምኑ ለሆኑት ከአላህም ሌላ ኀጢአቶችን የሚምር አንድም የለ። <span class="c2">(በስሕተት)</span> በሠሩትም ላይ እነርሱ የሚያውቁ ሲሆኑ የማይዘወትሩ ለሆኑት <span class="c2">(ተደግሳለች)</span>።} <span class="c5">[ሱረቱ ኣል ዒምራን፡ 135]</span> </p>',
      ],
      15 => [
        'question' => 'ጥያቄ 16፡ በነብዩ (የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን) ላይ ሶለዋት ማወረድ ማለት ምን ማለት ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16920.mp3',
        'answer' => '<p> መልስ - ነብዩን <span class="c2">(የአላህ ሰላትና ሰላም በእርሳቸው ላይ ይስፈን)</span> የላቀው አላህ በላይኛው ቀበሌ እንዲያወድሳቸው አላህን መማፀን ማለት ነው። </p>',
      ],
      16 => [
        'question' => 'ጥ 17- "ሱብሐነላህ" (አላህ ጥራት ይገባው) ማለት ምን ማለት ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16950.mp3',
        'answer' => '<p> መልስ - "ሱብሐነላህ" ማለት የላቀው አላህ ከእንከን፣ ከስህተትና ከመጥፎ ነገር ሁሉ ማጥራት ማለት ነው። </p>',
      ],
      17 => [
        'question' => 'ጥ 18 - "አልሐምዱሊላህ" (ምስጋና ለአላህ ይገባው) ማለት ምን ማለት ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16980.mp3',
        'answer' => '<p> መልስ - የላቀው አላህን ማመስገንና እርሱንም በሁሉም የፍጹምነት ባህሪያት መግለፅ ነው። </p>',
      ],
      18 => [
        'question' => 'ጥ 19 - "አላሁ አክበር" (አላህ ከፍ ያለ ነው) ማለት ምን ማለት ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/17000.mp3',
        'answer' => '<p> መልስ- ማለት ጥራት የተገባው አምላካችን አላህ ከሁሉም በላይ፣ ይበልጥ ታላቅ፣ ልዑልና ሁሉንም አሸናፊ ነው ማለት ነው። </p>',
      ],
      19 => [
        'question' => 'ጥ 20፡ “ላ ሐውላ ወላ ቁወተ ኢላ ቢላህ" (በአላህ ካልሆነ በቀር ምንም ሃይልም ሆነ ብልሀት የለም) ማለት ምን ማለት ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/17030.mp3',
        'answer' => '<p> መልስ - ትርጉሙ፡- በአላህ ካልሆነ በቀር ባርያው ከአንዱ ሁኔታ ወደ ሌላ የሚለወጥበት ብልሀትም ይሁን በዚሁ ላይ ችሎታም የለውም። </p>',
      ],
      20 => [
        'question' => 'ጥ 21፡ "አስታግፊሩላህ" (አላህን መሀርታ እጠይቃለሁ) ማለት ትርጉሙ ምንድን ነው?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/17060.mp3',
        'answer' => '<p> መልስ - ማለትም፡- ባሪያው አላህ ኃጢአቱን እንዲሰርዝለትና ጥፋቱን እንዲሸፍንለት ጌታውን መማፀኑ ነው። </p>',
      ],
    ],
  ],
];
