<?php
$data = [
  'title' => 'What Muslim Children Must Know',
  'description' => 'A project that contains a simple and easy curriculum for issues that a Muslim must know. It includes issues of belief, jurisprudence, prophetic biography, etiquette, tafsir, hadith, morals, and remembrance of Allah. It is suitable for young children in particular, for all ages, and newcomers to Islam.',
  'source' => 'https://kids.islamenc.com/as/home',
  'author' => 'Yazan Abdul Razzaq Raziq Alghanim',
  'sections' => [
    0 => 'আক্বীদাহ বিভাগ',
    1 => 'ফিকহ বিভাগ',
    2 => 'নবীৰ জীৱনী বিভাগ',
    3 => 'তাফছীৰ বিভাগ',
    4 => 'হাদীছ বিভাগ',
    5 => 'ইছলামী শিষ্টাচাৰ বিভাগ',
    6 => 'নৈতিক বিভাগ',
    7 => 'জিকৰ-আজকাৰ বা দুআ বিভাগ',
    8 => 'বিবিধ বিভাগ',
  ],
  'data' => [
    1 => [
      0 => [
        'question' => 'প্ৰশ্ন নং ১- তোমাৰ ৰব্ব বা প্ৰতিপালক কোন?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/200.mp3',
        'answer' => '<p> উত্তৰ- মোৰ প্ৰতিপালক হৈছে আল্লাহ, যিয়ে মোক আৰু গোটেই বিশ্বজগতক তেওঁৰ নিয়ামতেৰে প্ৰতিপালন কৰি আছে।<br /> ইয়াৰ প্ৰমাণ হৈছে আল্লাহৰ এই বাণীঃ সকলো ধৰণৰ হামদ <span class="c2">(প্ৰশংসা)</span> বিশ্বজগতৰ ৰব্ব <span class="c2">(প্ৰতিপালক)</span> আল্লাহৰ বাবে <span class="c2">(ছুৰা আল-ফাতিহাঃ ২)</span> </p>',
      ],
      1 => [
        'question' => 'প্ৰশ্ন নং ২- তোমাৰ দ্বীন বা ধৰ্ম কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/240.mp3',
        'answer' => '<p> উত্তৰ- মোৰ দ্বীন বা ধৰ্ম হৈছে ইছলাম। ইছলামৰ অৰ্থ হৈছে, আল্লাহক একক বুলি মানি তেওঁৰ ওচৰত আত্মসমৰ্পন কৰা, বিনয়ী হৈ তেওঁৰ আনুগত্য কৰা, মুশ্বৰিক আৰু শ্বিৰ্কৰ পৰা বিৰত থকা।<br /> আল্লাহে কৈছেঃ নিশ্চয় ইছলামেই হৈছে আল্লাহৰ ওচৰত একমাত্ৰ <span class="c2">(পছন্দনীয়)</span> দ্বীন। <span class="c2">(ছুৰা আলে-ইমৰাণঃ ১৯)</span> </p>',
      ],
      2 => [
        'question' => 'প্ৰশ্ন নং ৩- তোমাৰ নবী কোন?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/280.mp3',
        'answer' => '<p> উত্তৰ- মুহাম্মদ চাল্লাল্লাহু আলাইহি অছাল্লাম<br /> আল্লাহে কৈছেঃ মুহাম্মদ হৈছে আল্লাহৰ ৰাছুল... <span class="c2">(ছুৰা আল-ফাতাহঃ ২৯)</span> </p>',
      ],
      3 => [
        'question' => 'প্ৰশ্ন নং ৪- তাওহীদৰ কলিমা উল্লেখ কৰা, আৰু ইয়াৰ অৰ্থ কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/310.mp3',
        'answer' => '<p> উত্তৰ- কলিমা তাওহীদ হৈছে <span class="c1">“লা ইলাহা ইল্লাল্লাহ”</span> আৰু ইয়াৰ অৰ্থ হৈছে, আল্লাহৰ বাহিৰে ইবাদতৰ যোগ্য আন কোনো সত্য উপাস্য নাই।<br /> আল্লাহে কৈছেঃ জানি থোৱা যে, নিশ্চয় আল্লাহৰ বাহিৰে আন কোনো সত্য ইলাহ নাই। <span class="c2">(ছুৰা মুহাম্মদঃ ১৯)</span> </p>',
      ],
      4 => [
        'question' => 'প্ৰশ্ন নং ৫- সৰ্বশক্তিমান আল্লাহ ক\'ত আছে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/350.mp3',
        'answer' => '<p> উত্তৰ- আল্লাহ আকাশত আৰছৰ ওপৰত আছে তথা সকলো সৃষ্টিৰ ওপৰত আছে। যেনে আল্লাহ তাআলাই কৈছেঃ পৰম কৰুণাময় <span class="c2">(ৰহমান)</span> আৰছৰ ওপৰত উঠিছে। <span class="c2">(ছুৰা ত্বা-হাঃ ৫)</span> আৰু কৈছেঃ আৰু তেৱেঁই নিজ বান্দাসকলৰ ওপৰত পূৰ্ণ নিয়ন্ত্ৰণকাৰী, আৰু তেওঁ প্ৰজ্ঞাময়, সম্যক অৱহিত। <span class="c2">(ছুৰা আল-আনআমঃ ১৮)</span> </p>',
      ],
      5 => [
        'question' => 'প্ৰশ্ন নং ৬- মুহাম্মদ চাল্লাল্লাহু আলাইহি অছাল্লাম আল্লাহৰ ৰাছুল, এই সাক্ষ্য দিয়াৰ অৰ্থ কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/380.mp3',
        'answer' => '<p> উত্তৰ- ইয়াৰ অৰ্থ হৈছেঃ নিশ্চয় আল্লাহে তেখেতক বিশ্বজগতৰ বাবে সুসংবাদ প্ৰদানকাৰী আৰু সতৰ্ককাৰী হিচাপে প্ৰেৰণ কৰিছে।<br /> গতিকে অনিবাৰ্য হৈছেঃ<br /> ১- তেখেতৰ আদেশৰ অনুসৰণ কৰা।<br /> ২- তেখেতে দিয়া সংবাদক সত্য বুলি বিশ্বাস কৰা।<br /> ৩- তেখেতৰ অবাধ্যতা নকৰা।<br /> ৪- চৰীয়ত মুতাবিক আল্লাহৰ ইবাদত কৰা, অৰ্থাৎ ছুন্নতৰ অনুসৰণ কৰা আৰু বিদআত পৰিত্যাগ কৰা।<br /> যেনেঃ আল্লাহ তাআলাই কৈছেঃ যিয়ে ৰাছুলৰ আনুগত্য কৰে, তেওঁ প্ৰকৃততে আল্লাহৰ অনুসৰণ কৰে। <span class="c2">(ছুৰা নিছাঃ ৮০)</span>, পৱিত্ৰ আল্লাহে আৰু কৈছেঃ আৰু তেওঁ মনে সজা কথা নকয়। এয়া হৈছে কেৱল অহী, যিটো তেওঁৰ প্ৰতি অহীৰূপে প্ৰেৰণ কৰা হয়, <span class="c2">(ছুৰা আন-নাজমঃ ৩-৪)</span> সৰ্বশক্তিমান আল্লাহে আৰু কৈছেঃ অৱশ্যে তোমালোকৰ বাবে আছে আল্লাহৰ ৰাছুলৰ মাজত উত্তম আদৰ্শ, সেই ব্যক্তিৰ বাবে যিয়ে আশা কৰে আল্লাহ আৰু শেষ দিৱসৰ আৰু যিয়ে আল্লাহক বেছি বেছি স্মৰণ কৰে। <span class="c2">(ছুৰা আল-আহঝাবঃ ২১)</span> </p>',
      ],
      6 => [
        'question' => 'প্ৰশ্ন নং ৭- মহান আল্লাহে আমাক কিয় সৃষ্টি কৰিছে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/480.mp3',
        'answer' => '<p> উত্তৰ- আমাক একমাত্ৰ তেওঁৰ ইবাদতৰ বাবে সৃষ্টি কৰিছে, যাৰ কোনো অংশীদাৰ নাই।<br /> খেল-ধেমালিৰ উদ্দেশ্যে সৃষ্টি কৰা নাই।<br /> আল্লাহে কৈছেঃ আৰু মই জিন আৰু মানুহক কেৱল এইকাৰণেই সৃষ্টি কৰিছোঁ যে, সিহঁত কেৱল মোৰেই ইবাদত কৰিব। <span class="c2">(ছুৰা আজ-জাৰিয়াতঃ ৫৬)</span> </p>',
      ],
      7 => [
        'question' => 'প্ৰশ্ন নং ৮- ইবাদত কাক বোলে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/530.mp3',
        'answer' => '<p> ইবাদত হৈছে এনেকুৱা এটা অৰ্থপূৰ্ণ নাম, যাৰ দ্বাৰা প্ৰকাশ্য-অপ্ৰকাশ্য প্ৰত্যেক সেই কথা আৰু কৰ্মক বুজায় যিটোক আল্লাহে ভাল পায় তথা যাৰ দ্বাৰা তেওঁ সন্তুষ্ট হয়।<br /> প্ৰকাশ্য ইবাদত যেনে- মৌখিকভাৱে আল্লাহক স্মৰণ কৰা, তাছবীহ <span class="c2">(ছুবহানাল্লাহ পঢ়া)</span>, তাহমীদ <span class="c2">(আলহাম্দুলিল্লাহ পঢ়া)</span>, তাকবীৰ <span class="c2">(আল্লাহু আকবাৰ)</span> পাঠ কৰা, নামাজ আদায় কৰা, হজ্জ কৰা আদি।<br /> অপ্ৰকাশ্য ইবাদত যেনে- ভৰসা কৰা, ভয় কৰা, আশা কৰা আদি। </p>',
      ],
      8 => [
        'question' => 'প্ৰশ্ন নং ৯- আমাৰ ওপৰত থকা আটাইতকৈ ডাঙৰ কৰ্তব্যটো কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/580.mp3',
        'answer' => '<p> উত্তৰ- আমাৰ ওপৰত থকা আটাইতকৈ ডাঙৰ কৰ্তব্যটো হৈছে আল্লাহৰ তাওহীদ বা তেওঁৰ একত্ববাদ স্বীকাৰ কৰা। </p>',
      ],
      9 => [
        'question' => 'প্ৰশ্ন নং ১০- তাওহীদৰ প্ৰকাৰসমূহ কি কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/610.mp3',
        'answer' => '<p> উত্তৰ- ১- তাওহীদুৰ ৰুবুবিয়্যাহঃ অৰ্থাৎ আল্লাহৰ প্ৰতি এই বুলি ঈমান পোষণ কৰা যে, তেৱেঁই হৈছে সৃষ্টিকৰ্তা, জীৱিকাদাতা, মালিক তথা নিয়ন্ত্ৰণকাৰী, তেওঁ একক তেওঁৰ কোনো অংশীদাৰ নাই।<br /> ২- তাওহীদুল উলুহিয়্যাহঃ একমাত্ৰ আল্লাহৰেই ইবাদত কৰা, আল্লাহৰ বাহিৰে আন কাৰো ইবাদত নকৰা।<br /> ৩- তাওহীদুল আছমা অচ-চিফাতঃ কোৰআন আৰু হাদীছত বৰ্ণিত আল্লাহৰ নাম আৰু গুণাৱলীসমূহৰ প্ৰতি ঈমান পোষণ কৰা, কোনো ধৰণৰ উপমা, সাদৃশ্যতা আৰু অস্বীকাৰ নকৰাকৈ।<br /> তাওহীদৰ উক্ত এই তিনি প্ৰকাৰৰ প্ৰমাণ হৈছে আল্লাহ তাআলাৰ এই বাণীঃ তেৱেঁই আকাশসমূহ, পৃথিৱী আৰু এই দুয়োৰে মাজত যি যি আছে সেই সকলোৰে ৰব্ব। সেয়ে কেৱল আপুনি তেওঁৰেই ইবাদত কৰক আৰু তেওঁৰ ইবাদতত ধৈৰ্য্য ধাৰণ কৰক। আপুনি তেওঁৰ সমনাম গুণ সম্পন্ন কাৰোবাক জানেনে? <span class="c2">(ছুৰা মাৰয়ামঃ ৬৫)</span> </p>',
      ],
      10 => [
        'question' => 'প্ৰশ্ন নং ১১- আটাইতকৈ ডাঙৰ গুনাহটো কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/670.mp3',
        'answer' => '<p> উত্তৰ- আল্লাহৰ সৈতে শ্বিৰ্ক কৰা।<br /> আল্লাহে কৈছেঃ নিশ্চয় আল্লাহে তেওঁৰ লগত অংশী স্থাপন কৰাক ক্ষমা নকৰে। ইয়াৰ বাহিৰে অন্যান্য অপৰাধসমূহ যাক ইচ্ছা ক্ষমা কৰে আৰু যিয়ে আল্লাহৰ লগত আনক অংশী কৰে সি নিশ্চয় মহাপাপ ৰচনা কৰে। <span class="c2">(ছুৰা আন-নিছাঃ ৪৮)</span> </p>',
      ],
      11 => [
        'question' => 'প্ৰশ্ন নং ১২- শ্বিৰ্ক আৰু ইয়াৰ প্ৰকাৰসমূহ উল্লেখ কৰা?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/710.mp3',
        'answer' => '<p> উত্তৰ- শ্বিৰ্ক হৈছে ইবাদতৰ যিকোনো এটা প্ৰকাৰ আল্লাহৰ বাহিৰে আনৰ বাবে কৰা।<br /> ইয়াৰ প্ৰকাৰসমূহঃ<br /> শ্বিৰ্কে আকবাৰ বা ডাঙৰ শ্বিৰ্কঃ উদাহৰণস্বৰূপে আল্লাহৰ বাহিৰে আনৰ ওচৰত দুআ কৰা, অথবা আল্লাহৰ বাহিৰে আনৰ সন্মুখত ছাজদাহ কৰা, নাইবা আল্লাহৰ বাহিৰে আনৰ উদ্দেশ্যে জীৱ-জন্তু জবেহ কৰা।<br /> শ্বিৰ্কে আচগৰ বা সৰু শ্বিৰ্কঃ উদাহৰণস্বৰূপে আল্লাহৰ বাহিৰে আনৰ শপত খোৱা, অথবা তাবিজ ব্যৱহাৰ কৰা অৰ্থাৎ কোনো ক্ষয়-ক্ষতিৰ পৰা ৰক্ষা পাবলৈ নাইবা কোনো উপকাৰ সাধন কৰিবলৈ কোনো বস্তু ওলোমাই ৰখা। এইদৰে ৰিয়াও হৈছে শ্বিৰ্কে আচগৰ, <span class="c2">(লোকক দেখুৱাবলৈ কৰা আমলক ৰিয়া বোলে)</span> উদাহৰণস্বৰূপে মানুহক দেখুৱাবলৈ উত্তমভাৱে নামাজ আদায় কৰা। </p>',
      ],
      12 => [
        'question' => 'প্ৰশ্ন নং ১৩- আল্লাহৰ বাহিৰে আন কোনোবাই গায়েব জানেনে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/770.mp3',
        'answer' => '<p> উত্তৰ- একমাত্ৰ আল্লাহৰ বাহিৰে আন কোনেও গায়েব নাজানে।<br /> আল্লাহে কৈছেঃ কোৱা, ‘আল্লাহৰ বাহিৰে আকাশসমূহ আৰু পৃথিৱীৰ কোনেও গায়েব নাজানে। আনকি সিহঁতে উপলব্ধিও কৰিব নোৱাৰে যে সিহঁতক কেতিয়া উত্থিত কৰা হ’ব’। <span class="c2">(ছুৰা আন-নামলঃ ৬৫)</span> </p>',
      ],
      13 => [
        'question' => 'প্ৰশ্ন নং ১৪- ঈমানৰ আৰকান কেইটা আৰু কি কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/810.mp3',
        'answer' => '<p> উত্তৰ- ঈমানৰ আৰকান হৈছে ছয়টা। যেনে- ১- আল্লাহৰ প্ৰতি ঈমান পোষণ কৰা।<br /> ২- ফিৰিস্তাসকলৰ প্ৰতি ঈমান পোষণ কৰা।<br /> ৩- অৱতীৰ্ণ হোৱা কিতাবসমূহৰ প্ৰতি ঈমান পোষণ কৰা।<br /> ৪- তেওঁ প্ৰেৰণ কৰা ৰাছুলসকলৰ প্ৰতি ঈমান পোষণ কৰা।<br /> ৫- শেষ দিৱসৰ প্ৰতি ঈমান পোষণ কৰা।<br /> ৬- ভাগ্যৰ মঙ্গল অমঙ্গলৰ প্ৰতি ঈমান পোষণ কৰা।<br /> ইয়াৰ প্ৰমাণ হৈছে মুছলিমসকলৰ মাজত বিখ্যাত সেই হাদীছে জিব্ৰীল, যিটো হাদীছত উল্লেখ আছে যে, জিব্ৰীল আলাইহিচ্ছালামে নবী চাল্লাল্লাহু আলাইহি অছাল্লামক কৈছিলঃ তাৰ পিছত তেওঁ ক’লে, <span class="c1">“মোক ঈমান সম্পৰ্কে জ্ঞান দিয়ক”</span>।<br /> তেখেতে <span class="c2">(ৰাছুলুল্লাহ চাল্লাল্লাহু আলাইহি অছাল্লামে)</span> ক’লে: <span class="c1">“সেয়া হৈছে এই যে- আল্লাহ, তেওঁৰ ফিৰিস্তা, তেওঁৰ কিতাবসমূহ, তেওঁৰ ৰাছুলসকল আৰু আখিৰাতৰ ওপৰত ঈমান পোষণ কৰা, লগতে তাকদীৰৰ <span class="c2">(ভাগ্যৰ)</span> ভাল-বেয়াৰ ওপৰত বিশ্বাস স্থাপন কৰা।”</span> </p>',
      ],
      14 => [
        'question' => 'প্ৰশ্ন নং ১৫- ঈমানৰ আৰকানসমূহৰ ব্যাখ্যা কৰা।',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/900.mp3',
        'answer' => '<p> উত্তৰ- আল্লাহৰ প্ৰতি ঈমান পোষণ কৰা।<br /> আল্লাহৰ প্ৰতি এই বুলি ঈমান পোষণ কৰা যে, তেৱেঁই তোমাক সৃষ্টি কৰিছে আৰু তেৱেঁই তোমাক জীৱিকা প্ৰদান কৰিছে। একমাত্ৰ তেৱেঁই গোটেই সৃষ্টিজগতৰ মালিক আৰু পৰিচালক তথা নিয়ন্ত্ৰণকাৰী।<br /> তেৱেঁই ইবাদতৰ যোগ্য, তেওঁৰ বাহিৰে আন কোনো সত্য উপাস্য নাই।<br /> তেৱেঁই মহান, সৰ্বোচ্চ তথা পূৰ্ণাংগ সত্ত্বা, সকলো প্ৰকাৰ প্ৰশংসা একমাত্ৰ তেওঁৰেই। তেওঁৰ বাবে আছে সুন্দৰ সুন্দৰ নাম আৰু উচ্চ গুণবিশিষ্ট চিফাত। তেওঁৰ কোনো সমকক্ষ নাই তথা অংশীদাৰো নাই। তেওঁক একোৰেই তুলনা কৰিব নোৱাৰি।<br /> ফিৰিস্তাসকলৰ প্ৰতি ঈমান<br /> তেওঁলোক হৈছে আল্লাহৰ এটা সৃষ্টি, আল্লাহে তেওঁলোকক নূৰেৰে সৃষ্টি কৰিছে। তথা তেওঁলোকক তেওঁৰ ইবাদতৰ বাবে আৰু তেওঁৰ নিৰ্দেশ মতে পূৰ্ণাংগ আনুগত্য কৰিবলৈ সৃষ্টি কৰিছে।<br /> তেওঁলোকৰ মাজৰ এজন হৈছে জিব্ৰীল আলাইহিচ্ছালাম, তেওঁ নবীসকলৰ প্ৰতি অহীলৈ অৱতৰণ কৰিছিল।<br /> ঐশী গ্ৰন্থসমূহৰ প্ৰতি ঈমান<br /> ইয়াৰ দ্বাৰা সেইসমূহ গ্ৰন্থক বুজোৱা হৈছে যিবোৰ গ্ৰন্থক আল্লাহে ৰাছুলসকলৰ ওপৰত অৱতীৰ্ণ কৰিছিল।<br /> যেনে- কোৰআন অৱতীৰ্ণ কৰিছিল মুহাম্মদ চাল্লাল্লাহু আলাইহি অছাল্লামৰ ওপৰত।<br /> ইঞ্জীল অৱতীৰ্ণ কৰিছিল ঈছা আলাইহিচ্ছালামৰ ওপৰত।<br /> তাওৰাত অৱতীৰ্ণ কৰিছিল মুছা আলাইহিচ্ছালামৰ ওপৰত।<br /> ঝাবূৰ অৱতীৰ্ণ কৰিছিল দাঊদ আলাইহিচ্ছালামৰ ওপৰত।<br /> ইয়াৰ ওপৰিও ইব্ৰাহীম আৰু মুছা আলাইহিমাচ্ছালামৰ ওপৰত অৱতীৰ্ণ কৰিছিল ছহিফাসমূহ।<br /> ৰাছুলসকলৰ প্ৰতি ঈমান<br /> তেওঁলোকক আল্লাহে তেওঁৰ বান্দাসকলৰ ওচৰলৈ প্ৰেৰণ কৰিছিল, যাতে তেওঁলোকে সিহঁতক শিক্ষা প্ৰদান কৰে, লগতে জান্নাত আৰু কল্যাণৰ সুসংবাদ দিয়ে, আৰু যাতে সিহঁতক বেয়া কৰ্ম আৰু জাহান্নামৰ পৰা সতৰ্ক কৰে।<br /> তেওঁলোকৰ মাজত সৰ্বোত্তম হৈছে, দৃঢ়প্ৰতিজ্ঞ ৰাছুলসকল। তেওঁলোক হৈছেঃ<br /> নূহ আলাইহিচ্ছালাম।<br /> ইব্ৰাহীম আলাইহিচ্ছালাম।<br /> মুছা আলাইহিচ্ছালাম।<br /> ঈছা আলাইহিচ্ছালাম।<br /> মুহাম্মদ চাল্লাল্লাহু আলাইহি অছাল্লাম।<br /> শেষ দিৱসৰ প্ৰতি ঈমানঃ<br /> ইয়াৰ দ্বাৰা মৃত্যুৰ পিছৰ জীৱন যেনে, কবৰ, কিয়ামত দিৱস, পুনৰুত্থান আৰু হিচাপ-নিকাচ দিৱস আদিক বুজোৱা হৈছে, য\'ত ফয়চালা হোৱাৰ পিছত জান্নাতীসকলে জান্নাতত আৰু জাহান্নামীসকলে জাহান্নামত অৱস্থান কৰিব।<br /> ভাগ্যৰ মঙ্গল অমঙ্গলৰ প্ৰতি ঈমান পোষণ কৰাঃ<br /> এই বিশ্বাস পোষণ কৰা যে, বিশ্বজগতত সংঘটিত হোৱা প্ৰতিটো বস্তু সম্পৰ্কে নিশ্চয় আল্লাহ অৱগত, আৰু তেওঁ এইবোৰ লাওহে মাহফুজত লিপিবদ্ধ কৰি ৰাখিছে, তথা এইবোৰ তেওঁৰ ইচ্ছামতেই অস্তিত্ব লাভ কৰে আৰু সৃষ্টি হয়।<br /> আল্লাহ তাআলাই কৈছেঃ নিশ্চয় আমি প্ৰতিটো বস্তু তাকদীৰ অনুসৰি সৃষ্টি কৰিছোঁ। <span class="c2">(ছুৰা আল-ক্বামাৰঃ ৪৯)</span><br /> তাকদীৰৰ প্ৰতি ঈমানৰ ভিতৰত চাৰিটা বিষয় অন্তৰ্ভুক্ত আছেঃ<br /> প্ৰথম: এই কথাৰ প্ৰতি ঈমান পোষণ কৰা যে, আল্লাহ তাআলা সৰ্ব বিষয়ে সৰ্বজ্ঞ। প্ৰতিটো বস্তুৰ পূৰ্বৰ পৰাই তেওঁ সেই বিষয়ে অৱগত, সেই বস্তুটো অস্তিত্বলৈ অহাৰ পূৰ্বেও তেওঁ অৱগত আছিল আৰু অস্তিত্বলৈ অহাৰ পিছতো তেওঁ অৱগত।<br /> ইয়াৰ প্ৰমাণ হৈছে আল্লাহৰ এই বাণীঃ নিশ্চয় আল্লাহ, তেওঁৰ ওচৰতেই আছে কিয়ামতৰ সঠিক জ্ঞান, তেৱেঁই বৰষুণ অৱতীৰ্ণ কৰে আৰু তেৱেঁই জানে মাতৃগৰ্ভত যি আছে। কোনোৱেই নাজানে অহা কালি সি কি উপাৰ্জন কৰিব আৰু কোনোৱেই নাজানে কোন ঠাইত তাৰ মৃত্যু ঘটিব। নিশ্চয় আল্লাহ সৰ্বজ্ঞ, সম্যক অৱহিত। <span class="c2">(ছুৰা লুক্বমানঃ ৩৪)</span><br /> দ্বিতীয়ঃ নিশ্চয় আল্লাহে প্ৰতিটো বস্তু সম্পৰ্কে লাওহে মাহফুজত লিখি ৰাখিছে। প্ৰতিটো বস্তু যিটো অস্তিত্ব লাভ কৰিছে আৰু যিটো ভৱিষ্যতে অস্তিত্ব লাভ কৰিব সেই সকলোবোৰ আল্লাহে তেওঁৰ ওচৰত থকা গ্ৰন্থত লিপিবদ্ধ কৰি ৰাখিছে।<br /> ইয়াৰ প্ৰমাণ হৈছে আল্লাহৰ এই বাণীঃ আৰু গায়েবৰ চাবি-কাঠি আছে তেওঁৰেই ওচৰত, তেওঁৰ বাহিৰে কোনেও সেয়া নাজানে। স্থল আৰু সাগৰৰ অন্ধকাৰসমূহত যি আছে সেয়া কেৱল তেৱেঁই অৱগত, তেওঁৰ অজানিতে গছৰ এটা পাতো নসৰে। মাটিৰ অন্ধাকাৰত এনে কোনো শস্যকণাও অংকুৰিত নহয় অথবা ৰসযুক্ত নাইবা শুকান এনে কোনো বস্তু নাই যিটো স্পষ্ট কিতাবত নাই। <span class="c2">(ছুৰা আল-আনআমঃ ৫৯)</span><br /> তৃতীয়ঃ এই কথাৰ প্ৰতি বিশ্বাস পোষণ কৰা যে, বিশ্বজগতত সংঘটিত হোৱা প্ৰতিটো ঘটনা আল্লাহৰ ইচ্ছাতেই সংঘটিত হয়। একোৱেই তেওঁৰ ইচ্ছাৰ বাহিৰে সংঘটিত নহয়। সেইটো তেওঁৰ নিজৰ কাৰ্যসম্পৰ্কীয় বিষয় হওক অথবা তেওঁৰ সৃষ্টিৰ কাৰ্যসম্পৰ্কীয় বিষয় হওক।<br /> ইয়াৰ প্ৰমাণ হৈছে আল্লাহৰ এই বাণীঃ সেই ব্যক্তিৰ বাবে, তোমালোকৰ মাজৰ যিয়ে সৰল পথত চলিব বিচাৰে। তোমালোকে ইচ্ছা কৰিব নোৱাৰা, যেতিয়ালৈকে বিশ্বজগতৰ প্ৰতিপালক আল্লাহে ইচ্ছা নকৰে। <span class="c2">(ছুৰা আত-তাকৱীৰঃ ২৮-২৯)</span><br /> চতুৰ্থঃ এই কথাৰ প্ৰতি ঈমান পোষণ কৰা যে, সমগ্ৰ সৃষ্টিজগৎ, আৰু সিহঁতৰ সত্ত্বা, গুণ আৰু কৰ্ম তৎপৰতাসহ প্ৰতিটো বস্তু আল্লাহৰে সৃষ্টি।<br /> ইয়াৰ প্ৰমাণ হৈছে আল্লাহৰ এই বাণীঃ ‘অথচ আল্লাহেই সৃষ্টি কৰিছে তোমালোকক আৰু তোমালোকে যি তৈয়াৰ কৰা সেইটোকো তেৱেঁই সৃষ্টি কৰিছে’। <span class="c2">(ছুৰা আচ-চা-ফফা-তঃ ৯৬)</span> </p>',
      ],
      15 => [
        'question' => 'প্ৰশ্ন নং ১৬- কোৰআনৰ পৰিচয় কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/1300.mp3',
        'answer' => '<p> উত্তৰ- কোৰআন হৈছে আল্লাহৰ বাণী, কোৰআন আল্লাহৰ সৃষ্টি নহয়।<br /> আল্লাহে কৈছেঃ আৰু মুশ্বৰিকসকলৰ কোনোবাই যদি তোমাৰ ওচৰত আশ্ৰয় বিচাৰে, তেন্তে তুমি তাক আশ্ৰয় দিয়া, যাতে সি আল্লাহৰ বাণী শুনিব পাৰে। <span class="c2">(ছুৰা আত-তাওবাহঃ ৬)</span> </p>',
      ],
      16 => [
        'question' => 'প্ৰশ্ন নং ১৭- ছুন্নাহ বা হাদীছ কাক বোলে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/1330.mp3',
        'answer' => '<p> উত্তৰ- নবী চাল্লাল্লাহু আলাইহি অছাল্লামৰ প্ৰতিটো কথা, কৰ্ম, মৌনতা আৰু শাৰীৰিক আৰু চাৰিত্ৰিক গুণক ছুন্নাহ বা হাদীছ বোলে। </p>',
      ],
      17 => [
        'question' => 'প্ৰশ্ন নং ১৮- বিদআত কি? ইয়াক আমি গ্ৰহণ কৰিমনে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/1350.mp3',
        'answer' => '<p> উত্তৰ- দ্বীনৰ মাজত মানুহে প্ৰৱৰ্তন কৰা প্ৰতিটো আমলক বিদআত বোলে, যিটো আমল নবী চাল্লাল্লাহু আলাইহি অছাল্লামৰ যুগত তথা চাহাবাসকলৰ যুগত নাছিল।<br /> ইয়াক আমি গ্ৰহণ নকৰোঁ, বৰং প্ৰত্যাখ্যানহে কৰিম।<br /> কিয়নো নবী চাল্লাল্লাহু আলাইহি অছাল্লামে কৈছেঃ প্ৰত্যেক বিদআতেই হৈছে ভ্ৰষ্টতা। ইয়াক আবু দাউদে বৰ্ণনা কৰিছে<br /> উদাহৰণস্বৰূপে কোনো নিৰ্ধাৰিত ইবাদতৰ সংখ্যা বৃদ্ধি কৰা, যেনে- অজু কৰাৰ সময়ত তিনিবাৰৰ ঠাইত চাৰিবাৰকৈ ধোৱা।নবী চাল্লাল্লাহু আলাইহি অছাল্লামৰ জন্ম দিৱস উৎযাপন কৰা, যিটো নবী চাল্লাল্লাহু আলাইহি অছাল্লাম আৰু চাহাবাসকলৰ পৰা প্ৰমাণিত নহয়। </p>',
      ],
      18 => [
        'question' => 'প্ৰশ্ন নং ১৯- আল-অলা অল বাৰা আক্বীদাহ কাক কয়?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/1410.mp3',
        'answer' => '<p> উত্তৰ- আল-অলা হৈছে মুমিনসকলক মুহাব্বত কৰা আৰু তেওঁলোকক সহায় কৰা।<br /> আল্লাহে কৈছেঃ মুমিন পুৰুষসকল পৰস্পৰে পৰস্পৰৰ আৰু মুমিনা নাৰীসকল পৰস্পৰে পৰস্পৰৰ বন্ধু। <span class="c2">(ছুৰা আত-তাওবাহঃ ৭১)</span><br /> অল-বাৰা হৈছে কাফিৰ আৰু সিহঁতৰ শত্ৰুতাক ঘৃণা কৰা।<br /> আল্লাহে কৈছেঃ নিশ্চয় তোমালোকৰ বাবে ইব্ৰাহীম আৰু তেওঁৰ লগত যিসকল আছিল তেওঁলোকৰ মাজত উত্তম আদৰ্শ আছে। যেতিয়া তেওঁলোকে নিজ সম্প্ৰদায়ক কৈছিল, ‘তোমালোকৰ লগত আৰু তোমালোকে আল্লাহৰ পৰিবৰ্তে যিসকলৰ উপাসনা কৰা সেইসকলৰ পৰা আমি সম্পৰ্কমুক্ত। আমি তোমালোকক অস্বীকাৰ কৰোঁ। আমাৰ আৰু তোমালোকৰ মাজত চিৰকালৰ বাবে শত্ৰুতা আৰু বিদ্বেষ সৃষ্টি হ’ল; যেতিয়ালৈকে তোমালোকে এক আল্লাহৰ প্ৰতি ঈমান পোষণ নকৰিবা’। <span class="c2">(ছুৰা আল-মুমতাহিনাহঃ ৪)</span> </p>',
      ],
      19 => [
        'question' => 'প্ৰশ্ন নং ২০- আল্লাহে ইছলামৰ বাহিৰে আন কোনো ধৰ্ম গ্ৰহণ কৰিবনে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/1480.mp3',
        'answer' => '<p> উত্তৰ- আল্লাহে ইছলামৰ বাহিৰে আন কোনো ধৰ্ম গ্ৰহণ নকৰিব।<br /> আল্লাহে কৈছেঃ আৰু যিয়ে ইছলামৰ বাহিৰে বেলেগ কোনো ধৰ্ম অনুসন্ধান কৰিব, তাৰ পৰা সেই ধৰ্ম কেতিয়াও গ্ৰহণ কৰা নহ\'ব, আৰু সি পৰকালত ক্ষতিগ্ৰস্তসকলৰ অন্তৰ্ভুক্ত হ\'ব। <span class="c2">(ছুৰা আলে-ইমৰাণঃ ৮৫)</span> </p>',
      ],
      20 => [
        'question' => 'প্ৰশ্ন নং ২১- কুফৰ কেতিয়াবা কথা, কৰ্ম আৰু বিশ্বাসৰ দ্বাৰাও হয়, ইয়াৰ প্ৰতিটোৰ উদাহৰণ দিয়া?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/1520.mp3',
        'answer' => '<p> উত্তৰ- কথাৰ দ্বাৰা কুফৰঃ যেনে- আল্লাহ আৰু তেওঁৰ ৰাছুলক গালি-শপনি পাৰা।<br /> কৰ্মৰ দ্বাৰা কুফৰঃ যেনে- কোৰআনক অপমান কৰা অথবা আল্লাহৰ বাহিৰে আনক ছাজদাহ কৰা।<br /> বিশ্বাসৰ দ্বাৰা কুফৰঃ যেনে- এই বিশ্বাস পোষণ কৰা যে, আল্লাহৰ বাহিৰেও কোনোবা ইবাদতৰ যোগ্য আছে অথবা এই বিশ্বাস পোষণ কৰা যে, আল্লাহৰ সৈতে বেলেগ কোনো সৃষ্টিকৰ্তাও জৰিত হৈ আছে। </p>',
      ],
      21 => [
        'question' => 'প্ৰশ্ন নং ২২- নিফাক কি আৰু ইয়াৰ প্ৰকাৰসমূহ কি কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/1570.mp3',
        'answer' => '<p> উত্তৰ-<br /> ১- ডাঙৰ নিফাকঃ অন্তৰত কুফৰ গোপন ৰাখি ঈমান প্ৰকাশ কৰা।<br /> ইয়াৰ ফলত ব্যক্তি ইছলামৰ পৰা বহিষ্কৃত হয়। এইটোৱেই হৈছে ডাঙৰ কুফৰ।<br /> আল্লাহে কৈছেঃ নিশ্চয় মুনাফিকসকলে জাহান্নামৰ সৰ্বনিম্ন স্তৰত থাকিব আৰু সিহঁতৰ বাবে তুমি কেতিয়াও কোনো সহায়ক নাপাবা। <span class="c2">(ছুৰা আন-নিছাঃ ১৪৫)</span><br /> ২- সৰু নিফাকঃ<br /> উদাহৰণস্বৰূপে মিছা কথা কোৱা, প্ৰতিশ্ৰুতি ভংগ কৰা, বিশ্বাসঘাতকতা কৰা।<br /> ইয়াৰ ফলত যদিও ব্যক্তি ইছলামৰ পৰা বহিষ্কৃত নহয়, কিন্তু এইবোৰ হৈছে পাপকৰ্ম, ইয়াৰ ফলত ব্যক্তি শাস্তিৰ সন্মুখীন হ\'ব।<br /> আল্লাহৰ ৰাছুল চাল্লাল্লাহু আলাইহি অছাল্লামে কৈছেঃ মুনাফিকৰ প্ৰতীক হৈছে তিনিটাঃ কথা ক\'লে মিছা কথা কয়, প্ৰতিশ্ৰুতি কৰিলে ভংগ কৰে, আমানত ৰাখিলে বিশ্বাসঘাতকতা কৰে। ইয়াক বুখাৰী আৰু মুছলিমে বৰ্ণনা কৰিছে। </p>',
      ],
      22 => [
        'question' => 'প্ৰশ্ন নং ২৩- সৰ্বশেষ নবী তথা ৰাছুল কোন?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/1680.mp3',
        'answer' => '<p> উত্তৰ- মুহাম্মদ চাল্লাল্লাহু আলাইহি অছাল্লাম<br /> আল্লাহে কৈছেঃ মুহাম্মদ তোমালোকৰ মাজৰ কোনো পুৰুষৰে পিতৃ নহয়, বৰং তেওঁ হৈছে আল্লাহৰ ৰাছুল আৰু সৰ্বশেষ নবী। <span class="c2">(ছুৰা আল-আহঝাবঃ ৪০)</span> আৰু আল্লাহৰ ৰাছুল চাল্লাল্লাহু আলাইহি অছাল্লামে কৈছেঃ মই হৈছোঁ সৰ্বশেষ নবী আৰু মোৰ পিছত আন কোনো নবী নাহিব। আবু দাউদ আৰু তিৰমিজীয়ে বৰ্ণনা কৰিছে। </p>',
      ],
      23 => [
        'question' => 'প্ৰশ্ন নং ২৪- মুজিঝা কাক বোলে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/1730.mp3',
        'answer' => '<p> উত্তৰ- আল্লাহে তেওঁৰ নবীসকলৰ সত্যতা প্ৰমাণ কৰিবলৈ দেখুৱা অস্বাভাৱিক ঘটনাক মুজিঝা বোলে। উদাহৰণস্বৰূপেঃ<br /> নবী চাল্লাল্লাহু আলাইহি অছাল্লামৰ বাবে চন্দ্ৰ দ্বিখণ্ডিত কৰা।<br /> আৰু মুছা আলাইহিচ্ছালামৰ বাবে সাগৰক দুই ভাগত বিভক্ত কৰা, ফিৰআউন আৰু তাৰ সেনাবাহিনীক সাগৰত ডুবাই মৰা। </p>',
      ],
      24 => [
        'question' => 'প্ৰশ্ন নং ২৫- চাহাবা কাক বোলে? আমি তেওঁলোকক ভাল পাব লাগেনে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/1780.mp3',
        'answer' => '<p> উত্তৰ- যিয়ে মুমিন অৱস্থাত নবী চাল্লাল্লাহু আলাইহি অছাল্লামক লগ কৰিছে তথা ইছলামত থকা অৱস্থাত মৃত্যুবৰণ কৰিছে তেওঁক চাহাবী বোলে।<br /> আমি তেওঁলোকক ভাল পাওঁ আৰু তেওঁলোকক অনুসৰণ কৰোঁ। নবীসকলৰ পিছত তেওঁলোকেই হৈছে সৰ্বোত্তম তথা কল্যাণকৰ ব্যক্তি।<br /> তেওঁলোকৰ মাজত সৰ্বোত্তম হৈছে, চাৰি খলিফা।<br /> আবু বকৰ ৰাদ্বিয়াল্লাহু আনহু<br /> ওমৰ ৰাদ্বিয়াল্লাহু আনহু<br /> উছমান ৰাদ্বিয়াল্লাহু আনহু<br /> আলী ৰাদ্বিয়াল্লাহু আনহু </p>',
      ],
      25 => [
        'question' => 'প্ৰশ্ন নং ২৬- উম্মাহাতুল মুমিনীন কাক কোৱা হয়?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/1870.mp3',
        'answer' => '<p> উত্তৰ- নবী চাল্লাল্লাহু আলাইহি অছাল্লামৰ স্ত্ৰীসকলক উম্মাহাতুল মুমিনীন বুলি কোৱা হয়।<br /> আল্লাহে কৈছেঃ মুমিনসকলৰ ওচৰত নবী হৈছে তেওঁলোকৰ নিজতকৈও অধিক ঘনিষ্ঠ, আৰু তেওঁৰ স্ত্ৰীসকল হৈছে তেওঁলোকৰ মাতৃ। <span class="c2">(ছুৰা আল-আহঝাবঃ ৬)</span> </p>',
      ],
      26 => [
        'question' => 'প্ৰশ্ন নং ২৭- নবী চাল্লাল্লাহু আলাইহি অছাল্লামৰ পৰিয়ালৰ প্ৰতি আমাৰ কৰ্তব্য কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/1910.mp3',
        'answer' => '<p> উত্তৰ- আমি তেওঁলোকক ভাল পাওঁ আৰু তেওঁলোকক মুহাব্বত কৰোঁ, আৰু যিয়ে তেওঁলোকৰ প্ৰতি বিদ্বেষ পোষণ কৰে আমি তাক ঘৃণা কৰোঁ। তেওঁলোকৰ ক্ষেত্ৰত আমি সীমালংঘন নকৰোঁ। আহলে বাইত হৈছে তেওঁৰ স্ত্ৰীসকল, তেওঁৰ বংশধৰ, লগতে বনু হাশ্বিম আৰু বনুল মুত্তালিবৰ মুমিনসকল। </p>',
      ],
      27 => [
        'question' => 'প্ৰশ্ন নং ২৮- মুছলিম শাসকৰ প্ৰতি আমাৰ কৰ্তব্য কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/1940.mp3',
        'answer' => '<p> উত্তৰ- তেওঁলোকৰ প্ৰতি আমাৰ কৰ্তব্য হৈছে, তেওঁলোকক সন্মান কৰা। গুনাহৰ বাহিৰে তেওঁলোকৰ সকলো আদেশ মানি চলা। তেওঁলোকৰ বিৰুদ্ধে বিদ্ৰোহ নকৰা, গোপনে তেওঁলোকৰ বাবে দুআ কৰা আৰু সুপৰামৰ্শ দিয়া। </p>',
      ],
      28 => [
        'question' => 'প্ৰশ্ন নং ২৯- মুমিনসকলৰ প্ৰকৃত বাসস্থান কোনটো?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/1970.mp3',
        'answer' => '<p> উত্তৰ- জান্নাত, মহান আল্লাহে কৈছেঃ নিশ্চয় যিসকলে ঈমান আনিছে আৰু সৎকৰ্ম কৰিছে আল্লাহে তেওঁলোকক জান্নাতত প্ৰৱেশ কৰাব, যাৰ পাদদেশত নদীসমূহ প্ৰবাহিত; <span class="c2">(ছুৰা মুহাম্মদঃ ১২)</span> </p>',
      ],
      29 => [
        'question' => 'প্ৰশ্ন নং ৩০- কাফিৰসকলৰ প্ৰকৃত বাসস্থান কোনটো?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2000.mp3',
        'answer' => '<p> উত্তৰ- জাহান্নাম, মহান আল্লাহে কৈছেঃ এতেকে সেই জুইৰ পৰা বাচিবলৈ ব্যৱস্থা কৰা, যাৰ ইন্ধন হ’ব মানুহ আৰু শিল, যিটো প্ৰস্তুত কৰা হৈছে কাফিৰসকলৰ বাবে। <span class="c2">(ছুৰা আল-বাক্বাৰাহঃ ২৪)</span> </p>',
      ],
      30 => [
        'question' => 'প্ৰশ্ন নং ৩১- খাওফ কি? আৰু আৰ-ৰাজা কি? আৰু ইয়াৰ প্ৰমাণ কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2020.mp3',
        'answer' => '<p> উত্তৰ- আল্লাহ আৰু তেওঁৰ শাস্তিক ভয় কৰাকে খাওফ বোলে।<br /> আল্লাহৰ ছোৱাব, তেওঁৰ মাগফিৰাত আৰু ৰহমত আশা কৰাক আৰ-ৰাজা বোলে।<br /> ইয়াৰ প্ৰমাণ হৈছে আল্লাহৰ এই বাণীঃ সিহঁতে যিবোৰক আহ্বান কৰে সিহঁত নিজেই সিহঁতৰ প্ৰতিপালকৰ নৈকট্য লাভৰ উপায় সন্ধান কৰে যে, সিহঁতৰ মাজত কোন কিমান তেওঁৰ নিকটৱৰ্তী হ’ব পাৰে, আৰু সিহঁতে তেওঁৰ দয়া প্ৰত্যাশা কৰে আৰু তেওঁৰ শাস্তিক ভয় কৰে। নিশ্চয় তোমাৰ প্ৰতিপালকৰ শাস্তি অতি ভয়াৱহ। <span class="c2">(ছুৰা আল-ইছৰাঃ ৫৭)</span> আল্লাহ তাআলাই আৰু কৈছেঃ মোৰ বান্দাসকলক জনাই দিয়া যে, নিশ্চয় মই পৰম ক্ষমাশীল, পৰম দয়ালু। লগতে নিশ্চয় মোৰ শাস্তিয়েই হৈছে যন্ত্ৰণাদায়ক শাস্তি। <span class="c2">(ছুৰা আল-হিজৰঃ ৪৯, ৫০)</span> </p>',
      ],
      31 => [
        'question' => 'প্ৰশ্ন নং ৩২- আল্লাহৰ কেইটামান নাম আৰু চিফাত (গুণগত নাম) উল্লেখ কৰা?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2070.mp3',
        'answer' => '<p> উত্তৰ- আল্লাহ, আৰ-ৰাব্ব, আৰ-ৰাহমান, আচ-ছামী, আল-বাচীৰ, আল-আলীম, আৰ-ৰাজ্জাক্ব, আল-হাই, আল-আজীম--ইত্যাদি হৈছে তেওঁৰ সুন্দৰ নাম আৰু উচ্চমানৰ গুণ। </p>',
      ],
      32 => [
        'question' => 'প্ৰশ্ন নং ৩৩- এইবোৰ নামৰ ব্যাখ্যা কৰা?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2100.mp3',
        'answer' => '<p> উত্তৰ- আল্লাহৰ অৰ্থ হৈছে প্ৰকৃত সত্য উপাস্য। তেওঁ একক তথা অদ্বিতীয়, তেওঁৰ কোনো অংশীদাৰ নাই।<br /> আৰ-ৰাব্বঃ ইয়াৰ অৰ্থ হৈছে প্ৰতিপালক, একক সৃষ্টিকৰ্তা তথা মালিক, জীৱিকাদাতা আৰু নিয়ন্ত্ৰণকাৰী।<br /> আচ-ছামীঃ ইয়াৰ অৰ্থ হৈছে যাৰ শ্ৰৱণশক্তিয়ে সকলোকে আগুৰি আছে, ভিন ভিন তথা বিভিন্ন প্ৰকাৰৰ শব্দ হোৱা সত্তেও তেওঁ সকলো শব্দকে শুনা পায়।<br /> আল-বাচীৰঃ ইয়াৰ অৰ্থ হৈছে যিয়ে সকলো দেখা পায়। সৰু হওক বা ডাঙৰ প্ৰতিটো বস্তু তেওঁ দেখা পায়।<br /> আল-আলীমঃ ইয়াৰ অৰ্থ হৈছে, যাৰ জ্ঞানে অতীত, বৰ্তমান আৰু ভৱিষ্য়তৰ সকলো বস্তুকে নিজৰ জ্ঞানৰ দ্বাৰা পৰিবেষ্টন কৰি আছে।<br /> আৰ-ৰহমানঃ ইয়াৰ অৰ্থ হৈছে, যাৰ ৰহমতে সকলো সৃষ্টি জীৱকে সামৰি লৈছে, এতেকে প্ৰতিজন বান্দা আৰু প্ৰতিটো সৃষ্টি তেওঁৰ ৰহমতৰ অধীনস্থ।<br /> আৰ-ৰাজ্জাক্বঃ ইয়াৰ অৰ্থ হৈছে, যাৰ হাতত আছে মানৱ, জীন আৰু সকলো পশু-পক্ষীকে আদি কৰি গোটেই সৃষ্টিজগতৰ জীৱিকা।<br /> আল-হাইঃ অমৰ সত্ত্বা, যিয়ে কেতিয়াও মৃত্যুবৰণ নকৰিব। কিন্তু ইয়াৰ বিপৰীতে প্ৰতিটো সৃষ্টিয়েই মৃত্যুবৰণ কৰিব।<br /> আল-আজীমঃ ইয়াৰ অৰ্থ হৈছে, যাৰ নাম, গুণাৱলী আৰু কৰ্মত আছে পূৰ্ণাংগতা তথা পৰিপূৰ্ণতা আৰু মহানতা। </p>',
      ],
      33 => [
        'question' => 'প্ৰশ্ন নং ৩৪- মুছলিম উলামাসকলৰ প্ৰতি আমাৰ কৰ্তব্য কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2210.mp3',
        'answer' => '<p> উত্তৰ- আমি তেওঁলোকক মুহাব্বত কৰোঁ, লগতে শ্বাৰয়ী সমস্যা সমাধানৰ বাবে আমি তেওঁলোকৰ ওচৰলৈ যাওঁ। আমি তেওঁলোকক উত্তমৰূপে স্মৰণ কৰোঁ। আনহাতে যিসকলে তেওঁলোকৰ প্ৰতি বেয়া ভাষা ব্যৱহাৰ কৰে, সিহঁত সঠিক পথৰ পৰা আঁতৰি গৈছে।<br /> আল্লাহে কৈছেঃ তোমালোকৰ ভিতৰত যিসকলে ঈমান আনিছে আৰু যিসকলক জ্ঞান দান কৰা হৈছে, আল্লাহে তেওঁলোকক উচ্চ মৰ্যাদা প্ৰদান কৰিব, আৰু তোমালোকে যি কৰা সেই বিষয়ে আল্লাহ সবিশেষ অৱহিত। <span class="c2">(ছুৰা আল-মুজাদালাহঃ ১১)</span> </p>',
      ],
      34 => [
        'question' => 'প্ৰশ্ন নং ৩৫- কোনসকল লোক আল্লাহৰ অলী?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2240.mp3',
        'answer' => '<p> উত্তৰ- মুমিন মুত্তাক্বী লোকসকল হৈছে আল্লাহৰ অলী।<br /> আল্লাহে কৈছেঃ জানি থোৱা! আল্লাহৰ অলীসকলৰ কোনো ভয় নাই আৰু তেওঁলোক চিন্তিতও নহ\'ব। তেওঁলোকে ঈমান আনিছে আৰু তেওঁলোকে তাক্বৱা অৱলম্বন কৰিছিল। <span class="c2">(ছুৰা ইউনুছঃ ৬২,৬৩)</span> </p>',
      ],
      35 => [
        'question' => 'প্ৰশ্ন নং ৩৬- কেৱল কথা আৰু কৰ্মৰ নামেই ঈমান নেকি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2280.mp3',
        'answer' => '<p> উত্তৰ- নহয়, ঈমান হৈছে কথা, কৰ্ম আৰু বিশ্বাস আদিৰ সমষ্টিৰ নাম। </p>',
      ],
      36 => [
        'question' => 'প্ৰশ্ন নং ৩৭- ঈমান বৃদ্ধি আৰু হ্ৰাস হয়নে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2310.mp3',
        'answer' => '<p> উত্তৰ- হয়, আনুগত্যৰ দ্বাৰা ঈমান বৃদ্ধি হয় আৰু গুনাহৰ ফলত হ্ৰাস হয়।<br /> আল্লাহে কৈছেঃ প্ৰকৃত মুমিন হৈছে সেইসকল লোক, যিসকলৰ হৃদয় আল্লাহক স্মৰণ কৰা হ’লে কম্পিত হয় আৰু তেওঁৰ আয়াতসমূহ সিহঁতৰ ওচৰত তিলাৱত কৰা হ’লে সেয়া সিহঁতৰ ঈমান বৃদ্ধি কৰে, আৰু সিহঁতে কেৱল নিজ প্ৰতিপালকৰ ওপৰতেই ভৰসা কৰে। <span class="c2">(ছুৰা আল-আনফালঃ ২)</span> </p>',
      ],
      37 => [
        'question' => 'প্ৰশ্ন নং ৩৮- ইহছান কাক বোলে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2350.mp3',
        'answer' => '<p> উত্তৰ- ইহছান হৈছে, তুমি আল্লাহৰ ইবাদত এনেকৈ কৰা যেনিবা তুমি তেওঁক দেখি আছা, আৰু যদি এইটো অনুভূতি নাহে তেন্তে এইটো অনুভৱ কৰা যে, নিশ্চয় তেওঁ তোমাক দেখি আছে। </p>',
      ],
      38 => [
        'question' => 'প্ৰশ্ন নং ৩৯- আমল কেতিয়া আল্লাহৰ ওচৰত গৃহীত হয়?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2370.mp3',
        'answer' => '<p> উত্তৰ- আমলত দুটা চৰ্ত থাকিলে সেই আমল গৃহীত হয়।<br /> ১- যদি আমলটো নিৰ্ভেজালভাৱে আল্লাহৰ উদ্দেশ্যে কৰা হয়।<br /> ২- আৰু সেই আমলটো যদি নবী চাল্লাল্লাহু আলাইহি অছাল্লামৰ পদ্ধতি মুতাবিক হয়। </p>',
      ],
      39 => [
        'question' => 'প্ৰশ্ন নং ৪০- আল্লাহৰ ওপৰত তাৱাক্কুল কৰা মানে কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2420.mp3',
        'answer' => '<p> উত্তৰ- অৰ্থাৎ উপকাৰ সাধন কৰিবলৈ বা ক্ষয়-ক্ষতিৰ পৰা ৰক্ষা পাবলৈ উপায় অৱলম্বন কৰাৰ পিছত আল্লাহৰ ওপৰত ভৰসা কৰা।<br /> আল্লাহে কৈছেঃ যিয়ে আল্লাহৰ ওপৰত তাৱাক্কুল কৰিব, তাৰ বাবে আল্লাহেই যথেষ্ট। <span class="c2">(ছুৰা আত-তালাক্বঃ ৩)</span><br /> আয়াতত উল্লেখিত <span class="c2">(حَسْبُهُ)</span> শব্দৰ অৰ্থ হৈছে যথেষ্ট হোৱা। </p>',
      ],
      40 => [
        'question' => 'প্ৰশ্ন নং ৪১- সৎকৰ্মৰ আদেশ আৰু অসৎকৰ্মৰ পৰা নিষেধ কৰাৰ ক্ষেত্ৰত আমাৰ কৰ্তব্য কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2470.mp3',
        'answer' => '<p> উত্তৰ- আল্লাহৰ আনুগত্য কৰিবলৈ দিয়া প্ৰতিটো নিৰ্দেশেই হৈছে আমৰ বিল-মাৰুফ। আনহাতে আল্লাহৰ অবাধ্যতাৰ পৰা বিৰত থাকিবলৈ দিয়া প্ৰতিটো নিষেধাজ্ঞাই হৈছে নাহি আনিল মুনকাৰ।<br /> আল্লাহে কৈছেঃ তোমালোকেই শ্ৰেষ্ঠ উম্মত, মানৱজাতিৰ <span class="c2">(হিদায়তৰ)</span> বাবে <span class="c2">(তোমালোকক)</span> উলিওৱা হৈছে, <span class="c2">(কাৰণ)</span> তোমালোকে সৎকৰ্মৰ আদেশ দিয়া আৰু অসৎকৰ্মৰ পৰা নিষেধ কৰা লগতে আল্লাহৰ প্ৰতি বিশ্বাস স্থাপন কৰা। <span class="c2">(ছুৰা আলে-ইমৰাণঃ ১১০)</span> </p>',
      ],
      41 => [
        'question' => 'প্ৰশ্ন নং ৪২- আহলুচ ছুন্নাহ অল-জামাআহ কাক বোলে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2510.mp3',
        'answer' => '<p> উত্তৰ- তেওঁলোক হৈছে সেইসকল লোক, যিসকলে নবী চাল্লাল্লাহু আলাইহি অছাল্লাম আৰু তেওঁৰ চাহাবাসকলৰ কথা, কৰ্ম আৰু বিশ্বাসৰ ওপৰত প্ৰতিষ্ঠিত।<br /> নবী চাল্লাল্লাহু আলাইহি অছাল্লামৰ ছুন্নতৰ অনুসৰণ কৰাৰ কাৰণে আৰু বিদআত পৰিত্যাগ কৰাৰ কাৰণে তেওঁলোকক আহলুচ ছুন্নাহ নামকৰণ কৰা হৈছে।<br /> আৰু জামাআত কোৱাৰ কাৰণ হৈছে, তেওঁলোক সত্যৰ ওপৰত জামাতবদ্ধ তথা একত্ৰিত, আৰু এইক্ষেত্ৰত তেওঁলোক বিভক্ত হোৱা নাই। </p>',
      ],
    ],
    2 => [
      0 => [
        'question' => 'প্ৰশ্ন নং ১- তাহাৰাহ বা পৱিত্ৰতাৰ সংজ্ঞা কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2580.mp3',
        'answer' => '<p> উত্তৰ- তাহাৰাতৰ অৰ্থ হৈছে অনুভূতিসূচক অপৱিত্ৰতাৰ পৰা মুক্তি লাভ কৰা তথা ময়লা-আৱৰ্জনা দূৰ কৰা।<br /> ময়লা-আৱৰ্জনাৰ পৰা পৱিত্ৰতা অৰ্জনৰ অৰ্থ হৈছে, মুছলিম ব্যক্তিৰ শৰীৰত লগা অপৱিত্ৰতা, কাপোৰ অথবা কোনো স্থান নাইবা নামাজ পঢ়া ঠাইত থকা ময়লা-আৱৰ্জনা চাফ কৰাক তাহাৰাতুল খাবাছ বোলে।<br /> তাহাৰাতুল হাদাছ বা অনুভূতিসূচক পৱিত্ৰতা, এইটো অৰ্জন হয় অজু, গোছল আৰু পৱিত্ৰ পানীৰ জৰিয়তে, নাইবা পানী নাপালে অথবা পানী ব্যৱহাৰ কৰিবলৈ অপাৰগ হ\'লে তায়াম্মুমৰ দ্বাৰা অৰ্জন কৰিব পাৰি। </p>',
      ],
      1 => [
        'question' => 'প্ৰশ্ন নং ২- নাপাকী বা ময়লা-আৱৰ্জনা লাগিলে কেনেকৈ পৱিত্ৰতা অৰ্জন কৰিব পাৰি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2630.mp3',
        'answer' => '<p> উত্তৰ- নাপাকী বা ময়লা-আৱৰ্জনা দূৰ নোহোৱালৈকে পানীৰে ধুই পৱিত্ৰতা অৰ্জন কৰিব পাৰি।<br /> আনহাতে কুকুৰে কোনো বাচন-বৰ্তনত মুখ দিলে সেইটোক সাতবাৰ ধুব লাগিব, আৰু প্ৰথমবাৰ মাটিৰে ঘহিঁব লাগিব। </p>',
      ],
      2 => [
        'question' => 'প্ৰশ্ন নং ৩- অজুৰ ফজিলত কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2660.mp3',
        'answer' => '<p> উত্তৰ- নবী চাল্লাল্লাহু আলাইহি অছাল্লামে কৈছেঃ "যেতিয়া কোনো মুছলিম- বা মুমিন- ব্যক্তিয়ে অজু কৰে, সেই সময়ত তেওঁ যেতিয়া নিজৰ মুখ ধয়, তেতিয়া তেওঁৰ মুখমণ্ডলৰ পৰা অজুৰ পানীৰ সৈতে অথবা পানীৰ শেষ বিন্দুৰ সৈতে প্ৰত্যেক সেই গুনাহ নিগৰি পৰে যিটো তেওঁ নিজৰ দুচকুৰে কৰিছিল।", আৰু যেতিয়া তেওঁ দুহাত ধয়, তেতিয়া তেওঁৰ দুই হাতৰ পৰা অজুৰ পানীৰ সৈতে অথবা পানীৰ শেষ বিন্দুৰ সৈতে প্ৰত্যেক সেই গুনাহ সৰি পৰে যিটো তেওঁ নিজৰ দুহাতেৰে কৰিছিল। এইদৰে যেতিয়া তেওঁ নিজৰ দুই ভৰি ধয়, তেতিয়া তেওঁৰ দুয়ো ভৰিৰ পৰা অজুৰ পানীৰ সৈতে অথবা পানীৰ শেষ বিন্দুৰ সৈতে ভৰিৰে খোজকাঢ়ি কৰা প্ৰতিটো পাপ সৰি পৰে। অৱশেষত তেওঁ সকলো গুনাহৰ পৰা পৱিত্ৰ হৈ ওলাই আহে।" ইয়াক মুছলিমে বৰ্ণনা কৰিছে। </p>',
      ],
      3 => [
        'question' => 'প্ৰশ্ন নং ৪- অজু কেনেকৈ কৰিবা?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2690.mp3',
        'answer' => '<p> উত্তৰ- হাতৰ সৰু গাঁঠিলৈকে তিনিবাৰ ধুব লাগিব।<br /> কুলি কৰিব লাগিব আৰু নাকত পানী সোমোৱাই নাক পৰিস্কাৰ কৰিব লাগিব। তিনিবাৰকৈ।<br /> মুখ গহ্বৰত পানীলৈ অলপ সময় ঘূৰাই তাৰ পিছত উলিয়াই দিয়াক মাজমাজাহ বোলে।<br /> সোঁ হাতৰ সহায়ত উশাহৰ সৈতে নাকৰ ভিতৰ ভাগলৈ পানী টানি লোৱাক ইস্তিনশ্বাক্ব বোলে।<br /> ইয়াৰ পিছত বাওঁ হাতেৰে সেই পানী নাকৰ পৰা উলিয়াই অনাক ইস্তিনছাৰ বোলে।<br /> ইয়াৰ পিছত তিনিবাৰ মুখমণ্ডল ধুব লাগে।<br /> ইয়াৰ পিছত তিনিবাৰ কিলাকুটিলৈকে দুয়ো হাত ধুব লাগে।<br /> ইয়াৰ পিছত মূৰৰ আগফালৰ পৰা পিছফাললৈকে মূৰ মছেহ কৰিব লাগে, লগতে কাণ মছেহ কৰিব লাগে।<br /> ইয়াৰ পিছত দুয়ো ভৰিৰ সৰুগাঁঠিলৈকে তিনিবাৰ ধুব লাগে।<br /> এইটোৱে হৈছে সম্পূৰ্ণ অজু। বুখাৰী আৰু মুছলিমৰ কেইবাটাও হাদীছৰ দ্বাৰা এইটো প্ৰমাণিত। তেখেত চাল্লাল্লাহু আলাইহি অছাল্লামৰ পৰা উছমান ৰাদ্বিয়াল্লাহু আনহু আৰু আব্দুল্লাহ বিন ঝায়েদ ৰাদ্বিয়াল্লাহু আনহুৱে বৰ্ণনা কৰিছে। বুখাৰী আদি গ্ৰন্থত এইটোও বৰ্ণিত হৈছে যে, তেখেতে চাল্লাল্লাহু আলাইহি অছাল্লামে এবাৰ এবাৰকৈও অজু কৰিছিল আৰু দুবাৰ দুবাৰকৈও অজু কৰিছিল। অৰ্থাৎ অজুৰ অংগবোৰ এবাৰ এবাৰকৈও ধুইছিল আৰু দুবাৰ দুবাৰকৈও ধুইছিল। </p>',
      ],
      4 => [
        'question' => 'প্ৰশ্ন নং ৫- অজুৰ ফৰজ কেইটা আৰু কি কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2810.mp3',
        'answer' => '<p> উত্তৰ- অজুৰ ফৰজসমূহ হৈছে এনেকুৱা বাধ্যতামূলক কাৰ্য্য যিবোৰৰ এটা বাদ পৰিলেই অজু নহ\'ব। সেইবোৰ হৈছে-<br /> ১- মুখমণ্ডল ধোৱা। কুলি কৰা আৰু নাকত পানী দিয়াটোও ইয়াৰেই অন্তৰ্ভুক্ত।<br /> ২- কিলাকুটিলৈকে দুয়ো হাত ধোৱা।<br /> ৩- মূৰ মছেহ কৰা। কাণ মছেহ কৰা ইয়াৰেই অন্তৰ্ভুক্ত।<br /> ৪- সৰুগাঁঠিলৈকে দুয়ো ভৰি ধোৱা।<br /> ৫- অংগবোৰ ধোৱাৰ ক্ষেত্ৰত ধাৰাবাহিকতা বজায় ৰখা। যেনে- মুখমণ্ডল, তাৰ পিছত দুয়ো হাত, তাৰ পিছত মূৰ মছেহ আৰু তাৰ পিছত দুয়ো ভৰি ধোৱা।<br /> ৬- একেলেঠাৰিয়ে অজু কৰা। অংগবোৰ ধোৱাৰ ক্ষেত্ৰত যাতে বেছি পলম নহয়। অৰ্থাৎ এটা অংগ ধোৱাৰ পিছত আনটো অংগ ধোৱাৰ মাজত, ধুই লোৱা অংগটো শুকাই যাব পৰা ব্যৱধান নকৰা।<br /> উদাহৰণস্বৰূপে, কোনোবাই আধা অজু কৰি, বাকীখিনি যদি পিছত কেতিয়াবা সম্পূৰ্ণ কৰে, তেন্তে তাৰ অজু নহ\'ব। </p>',
      ],
      5 => [
        'question' => 'প্ৰশ্ন নং ৬- অজুৰ ছুন্নত কেইটা আৰু কি কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2910.mp3',
        'answer' => '<p> উত্তৰ- অজুৰ ছুন্নতসমূহ হৈছে এনেকুৱা কিছুমান কৰ্ম যিবোৰ কৰিলে অধিক ছোৱাব লাভ হয়, আৰু যদি বাদ পৰি যায় তেন্তে কোনো গুনাহ নহয়, অজু সঠিক হ\'ব।<br /> ১- বিছমিল্লাহ কোৱা।<br /> ২- মিছৱাক কৰা।<br /> ৩- সৰুগাঁঠিলৈকে হাত ধোৱা।<br /> ৪- আঙুলি খিলাল কৰা।<br /> ৫- দ্বিতীয়বাৰ আৰু তৃতীয়বাৰ অজুৰ অংগবোৰ ধোৱা।<br /> ৬- সোঁ ফালৰ পৰা আৰম্ভ কৰা।<br /> ৭- অজু কৰাৰ পিছত দুআ পাঠ কৰা। <span class="c2">(আশ্বহাদু আল লা ইলাহা ইল্লাল্লাহু অহদাহু লা শ্বাৰীকা লাহু, ওৱা আশ্বহাদু আন্না মুহাম্মাদান আব্দুহু ওৱা ৰাছুলুহু)</span> অৰ্থঃ মই সাক্ষ্য দিওঁ যে, আল্লাহৰ বাহিৰে আন কোনো সত্য ইলাহ নাই, তেওঁৰ কোনো অংশীদাৰ নাই, মই আৰু সাক্ষ্য দিওঁ যে, মুহাম্মদ চাল্লাল্লাহু আলাইহি অছাল্লাম তেওঁৰ বান্দা আৰু ৰাছুল।<br /> ৮- অজু কৰাৰ পিছত দুই ৰাকাত ছুন্নত পঢ়া। </p>',
      ],
      6 => [
        'question' => 'প্ৰশ্ন নং ৭- কি কি কাৰণত অজু ভংগ হয়?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3020.mp3',
        'answer' => '<p> উত্তৰ- আগফালৰ আৰু পিছফালৰ লজ্জাস্থানৰ পৰা কিবা ওলালে অজু ভংগ হয়। শৌচ, প্ৰস্ৰাৱ অথবা বায়ু।<br /> টোপনি গ\'লে,মানসিক সন্তোলন হেৰুৱালে,অচেতন হৈ পৰিলে।<br /> উটৰ মাংস ভক্ষণ কৰিলে।<br /> অন্তৰাল নোহোৱাকৈ প্ৰত্যক্ষভাৱে আগফালৰ বা পিছফালৰ লজ্জাস্থান স্পৰ্শ কৰিলে। </p>',
      ],
      7 => [
        'question' => 'প্ৰশ্ন নং ৮- তায়াম্মুম কাক বোলে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3080.mp3',
        'answer' => '<p> উত্তৰ- পানী নাথাকিলে অথবা পানী ব্যৱহাৰ কৰিবলৈ অপাৰগ হ\'লে পৱিত্ৰ মাটিৰ দ্বাৰা পৱিত্ৰতা অৰ্জন কৰাকে তায়াম্মুম বোলে। </p>',
      ],
      8 => [
        'question' => 'প্ৰশ্ন নং ৯- তায়াম্মুম কেনেকৈ কৰিবা?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3110.mp3',
        'answer' => '<p> উত্তৰ- দুয়ো হাতৰ তলুৱাৰে মাটিত এবাৰ জোৰকৈ আঘাত কৰিব লাগে আৰু তাৰ দ্বাৰা মুখমণ্ডল আৰু দুয়ো হাতৰ পৃষ্ঠভাগত এবাৰ মছেহ কৰিব লাগে। </p>',
      ],
      9 => [
        'question' => 'প্ৰশ্ন নং ১০- তায়াম্মুম ভংগ হোৱাৰ কাৰণসমূহ কি কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3140.mp3',
        'answer' => '<p> উত্তৰ- অজু ভংগ হোৱাৰ যিবোৰ কাৰণ আছে, সেইবোৰ কাৰণতেই তায়াম্মুম ভংগ হয়।<br /> ইয়াৰ ওপৰিও যদি পানী উপলব্ধ হয়, তেতিয়াও তায়াম্মুম ভংগ হয়। </p>',
      ],
      10 => [
        'question' => 'প্ৰশ্ন নং ১১- খুফফাইন আৰু জাওৰাবাইন কাক বোলে? এই দুটাৰ ওপৰত মছেহ কৰিব পাৰিনে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3180.mp3',
        'answer' => '<p> উত্তৰ- চামৰাৰে প্ৰস্তুত কৰা ভৰিত পিন্ধা মোজাক খুফফাইন বোলে।<br /> আনহাতে চামৰাৰ বাহিৰে বেলেগ উপকৰণেৰে তৈয়াৰ কৰা মোজাক জাওৰাবাইন বোলে।<br /> ভৰি ধোৱাৰ পৰিবৰ্তে এই দুয়োটাৰে ওপৰত মছেহ কৰাটো চৰীয়ত সন্মত। </p>',
      ],
      11 => [
        'question' => 'প্ৰশ্ন নং ১২- খুফফাইনৰ ওপৰত মছেহ কৰাৰ ৰহস্য কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3230.mp3',
        'answer' => '<p> উত্তৰ- ইয়াৰ প্ৰকৃত উদ্দেশ্য হৈছে বান্দাসকলক সুবিধা প্ৰদান কৰা তথা তেওঁলোকক সহজ কৰি দিয়া। বিশেষকৈ শীতৰ সময়ত আৰু ভ্ৰমণত থকা অৱস্থাত, সেই সময়ত ভৰিৰ পৰা মোজা খোলাটো কষ্টকৰ হয়। </p>',
      ],
      12 => [
        'question' => 'প্ৰশ্ন নং ১৩- খুফফাইনৰ ওপৰত সঠিকভাৱে মছেহ কৰাৰ চৰ্তসমূহ কি কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3260.mp3',
        'answer' => '<p> উত্তৰ- ১- পৱিত্ৰতা অৰ্জন কৰাৰ পিছত পিন্ধিব লাগিব, অৰ্থাৎ অজু কৰাৰ পিছত।<br /> ২- ভৰিত পিন্ধা মোজাযোৰ পৱিত্ৰ হ\'ব লাগিব। অপৱিত্ৰ মোজাৰ ওপৰত মছেহ কৰা বৈধ নহয়।<br /> ৩- সেই মোজাৰে ধুবলগীয়া অজুৰ ফৰজ অংশখিনি ঢাকি থকা হ\'ব লাগিব।<br /> ৪- নিৰ্দিষ্ট ম্যাদৰ মাজতেই মছেহ কৰিব লাগিব। স্ব-স্থানত বসবাস কৰা লোকৰ বাবে এদিন এৰাতি, আৰু ভ্ৰমণকাৰীৰ বাবে তিনিদিন তিনি ৰাতি। </p>',
      ],
      13 => [
        'question' => 'প্ৰশ্ন নং ১৪- খুফফাইনৰ ওপৰত মছেহ কৰাৰ পদ্ধতি কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3320.mp3',
        'answer' => '<p> উত্তৰ- মছেহ কৰাৰ পদ্ধতি হৈছেঃ প্ৰথমে দুয়ো হাতৰ আঙুলিবোৰ পানীৰে তিয়াই লব লাগিব, তাৰ পিছত ভৰিৰ আঙুলিৰ পৰা ভৰিৰ সম্পূৰ্ণ পতা মছেহ কৰিব। সোঁ হাতেৰে সোঁ ভৰি মছেহ কৰিব আৰু বাওঁ হাতেৰে বাও ভৰি মছেহ কৰিব। মছেহ কৰাৰ সময়ত হাতৰ আঙুলিবোৰ যাতে ফাক হৈ থাকে। দ্বিতীয়বাৰ মছেহ কৰাৰ প্ৰয়োজন নাই। </p>',
      ],
      14 => [
        'question' => 'প্ৰশ্ন নং ১৫- খুফফাইনৰ ওপৰত কৰা মছেহ কি কি কাৰণত ভংগ হয়?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3350.mp3',
        'answer' => '<p> উত্তৰ- ১- মছেহৰ ম্যাদ শেষ হ\'লে। চৰীয়তে নিৰ্ধাৰণ কৰা ম্যাদ শেষ হোৱাৰ পিছত খুফফাইনৰ ওপৰত মছেহ কৰা বৈধ নহয়। স্ব-স্থানত থকা লোকৰ বাবে এদিন এৰাতি আৰু ভ্ৰমণকাৰীৰ বাবে তিনিদিন তিনি ৰাতি।<br /> ২- খুফফাইন বা মোজা খুলিলে। যদি কোনোবাই মছেহ কৰাৰ পিছত মোজা খুলি পেলায় বা এটা মোজাও যদি খুলে তেন্তে তাৰ মছেহ বাতিল হ\'ব। </p>',
      ],
      15 => [
        'question' => 'প্ৰশ্ন নং ১৬- চালাতৰ অৰ্থ কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3390.mp3',
        'answer' => '<p> উত্তৰ- চালাত হৈছে কিছুমান বিশেষ কথা আৰু কৰ্মৰ দ্বাৰা আল্লাহৰ ইবাদত কৰাৰ নাম। যিটো ইবাদত তাকবীৰৰ দ্বাৰা আৰম্ভ হয় আৰু ছালামৰ দ্বাৰা সম্পন্ন হয়। </p>',
      ],
      16 => [
        'question' => 'প্ৰশ্ন নং ১৭- চালাতৰ বিধান কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3420.mp3',
        'answer' => '<p> উত্তৰ- চালাত আদায় কৰাটো প্রতিজন মুছলিমৰ ওপৰত অনিবাৰ্য।<br /> আল্লাহে কৈছেঃ <span class="c1">“নিশ্চিতভাৱে নির্ধাৰিত সময়ত ছালাত আদায় কৰাটো মুমিনৰ ওপৰত ফৰজ।”</span> <span class="c2">(ছুৰা আন-নিছাঃ ১০৩)</span> </p>',
      ],
      17 => [
        'question' => 'প্ৰশ্ন নং ১৮- চালাত পৰিত্যাগ কৰাৰ বিধান কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3460.mp3',
        'answer' => '<p> উত্তৰ- চালাত পৰিত্যাগ কৰাটো হৈছে কুফৰ। নবী চাল্লাল্লাহু আলাইহি অছাল্লামে কৈছেঃ মুছলিম আৰু অমুছলিমৰ মাজত <span class="c2">(মুক্তিৰ)</span> যি প্ৰতিশ্ৰুতি আছে, সেয়া হৈছে চালাত। এতেকে যিয়ে ইয়াক পৰিত্যাগ কৰে, সি কুফৰী কৰে। এই হাদীছটোক আহমদ আৰু তিৰমিজীয়ে বৰ্ণনা কৰিছে। </p>',
      ],
      18 => [
        'question' => 'প্ৰশ্ন নং ১৯- দিনে ৰাতি কেই ওৱাক্ত চালাত মুছলিমৰ ওপৰত অনিবাৰ্য? আৰু প্ৰতিটো চালাতৰ ৰাকাত সংখ্যা কিমান?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3500.mp3',
        'answer' => '<p> উত্তৰ- দিনে ৰাতি পাঁচ ওৱাক্ত চালাত বাধ্যতামূলক। ফজৰৰ চালাত দুই ৰাকাত। জোহৰৰ চালাত চাৰি ৰাকাত। আচৰৰ চালাত চাৰি ৰাকাত। মাগৰিবৰ চালাত তিনি ৰাকাত। ঈশ্বাৰ চালাত চাৰি ৰাকাত। </p>',
      ],
      19 => [
        'question' => 'প্ৰশ্ন নং ২০- চালাতৰ চৰ্তসমূহ কি কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3530.mp3',
        'answer' => '<p> উত্তৰ- ১- মুছলিম হ\'ব লাগিব। কাফিৰৰ চালাত গৃহীত নহয়।<br /> ২- বিবেক সম্পন্ন হ\'ব লাগিব। মানসিক সন্তোলন হেৰুৱা ব্যক্তিৰ চালাত সঠিক নহয়।<br /> ৩- পাৰ্থক্য কৰিব পৰা বয়সত উপনীত হ\'ব লাগিব। এতেকে পাৰ্থক্য কৰিব নোৱাৰা শিশুৰ চালাত শুদ্ধ নহয়।<br /> ৪- নিয়ত<br /> ৫- চালাতৰ সময় হ\'ব লাগিব।<br /> ৬- অনুভূতিসূচক অপৱিত্ৰতাৰ পৰা পৱিত্ৰতা অৰ্জন কৰিব লাগিব।<br /> ৭- বাহ্যিক অপৱিত্ৰতাৰ পৰা পৱিত্ৰতা অৰ্জন কৰিব লাগিব।<br /> ৮- অত্যাৱশ্যকীয় ঢাকি ৰাখিবলগীয়া অংগখিনি ঢাকিব লাগিব।<br /> ৯- কিবলামুখী হ\'ব লাগিব। </p>',
      ],
      20 => [
        'question' => 'প্ৰশ্ন নং ২১- চালাতৰ আৰকান কেইটা আৰু কি কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3640.mp3',
        'answer' => '<p> উত্তৰ- চালাতৰ আৰকান হৈছে ১৪ টা। ক্ৰমেঃ<br /> সক্ষম ব্যক্তিৰ বাবে ফৰজ চালাতত থিয় হোৱা।<br /> তাকবীৰে তাহৰীমা কোৱা, অৰ্থাৎ আল্লাহু আকবাৰ বুলি কোৱা।<br /> ছুৰা আল-ফাতিহা পাঠ কৰা।<br /> ৰূকু কৰা। ৰূকু কৰাৰ সময়ত পিঠি আৰু মূৰ যাতে সমতল থাকে।<br /> ৰূকুৰ পৰা উঠা।<br /> ৰূকুৰ পৰা পোন হৈ থিয় হোৱা।<br /> ছাজদাহ কৰা। ছাজদাহ কৰাৰ সময়ত কপাল, নাক, দুয়ো হাত, দুয়ো আঠু আৰু ভৰিৰ আঙুলিবোৰ যাতে মাটিত স্পৰ্শ কৰে।<br /> ছাজদাৰ পৰা উঠা।<br /> দুই ছাজদাৰ মাজত বৈঠক কৰা।<br /> ছুন্নত পদ্ধতি হৈছেঃ সোঁ ভৰি কিবলামুখীকৈ থিয় কৰাই বাওঁ ভৰি পাৰি তাৰ ওপৰত বহা।<br /> ধীৰস্থিৰতা, প্ৰতিটো ৰুকন ধীৰ স্থিৰতাৰ সৈতে আদায় কৰা।<br /> শেষ তাশ্বাহহুদ।<br /> শেষ তাশ্বাহহুদৰ বৈঠক।<br /> দুয়োফালে আচ্ছালামু আলাইকুম অৰাহমাতুল্লাহ বুলিকৈ ছালাম ফিৰোৱা।<br /> আমি বৰ্ণনা কৰাৰ দৰে ধাৰাবাহিকতা বজায় ৰখা। যদি কোনোবাই জানি বুজি ৰূকুৰ আগত ছাজদাহ কৰে তেন্তে তাৰ চালাত বাতিল হ\'ব। আনহাতে যদি ভুলতে কৰে তেন্তে পুনৰ ৰূকু কৰি তাৰ পিছত ছাজদাহ কৰিব লাগিব। </p>',
      ],
      21 => [
        'question' => 'প্ৰশ্ন নং ২২- চালাতৰ ওৱাজিবাতসমূহ উল্লেখ কৰা?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3820.mp3',
        'answer' => '<p> উত্তৰ- চালাতৰ ওৱাজিবাত হৈছে ৮টা। যেনে-<br /> ১- তাকবীৰে তাহৰীমাৰ বাহিৰে অন্যান্য তাকবীৰসমূহ।<br /> ২- "ছামিআল্লাহু লিমান হামিদা" কোৱা, ইমাম হওক বা অকলশৰীয়া ব্যক্তি।<br /> ৩- "ৰাব্বানা অলাকাল হাম্দ" কোৱা।<br /> ৪- ৰূকুত কমেও এবাৰ "ছুবহানা ৰাব্বিয়াল আজীম" পাঠ কৰা।<br /> ৫- ছাজদাত কমেও এবাৰ "ছুবহানা ৰাব্বিয়াল আ\'লা" পাঠ কৰা।<br /> ৬- দুই ছাজদাৰ মাজত "ৰাব্বিগ ফিৰলী" পাঠ কৰা।<br /> ৭- প্ৰথম তাশ্বাহহুদ।<br /> ৮- প্ৰথম তাশ্বাহহুদৰ বাবে বৈঠক কৰা। </p>',
      ],
      22 => [
        'question' => 'প্ৰশ্ন নং ২৩- চালাতৰ ছুন্নতসমূহ কি কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3930.mp3',
        'answer' => '<p> উত্তৰ- চালাতৰ ১১ টা ছুন্নত আছে। যেনে-<br /> ১- তাকবীৰে তাহৰীমাৰ পিছতঃ "ছুবহানাকা আল্লাহুম্মা অবিহামদিকা, অতাবাৰাকাছমুকা, অতাআলা জাদ্দুকা, অলা-ইলাহা গাইৰুকা," পাঠ কৰা। ইয়াক দুআ উল ইস্তিফতাহ বুলি কোৱা হয়।<br /> ২- আউজুবিল্লাহ পাঠ কৰা।<br /> ৩- বিছমিল্লাহ পাঠ কৰা।<br /> ৪- আমীন কোৱা।<br /> ৫- ছুৰা ফাতিহাৰ পিছত যিকোনো ছুৰা পাঠ কৰা।<br /> ৬- ইমামে উচ্চস্বৰে কিৰাআত কৰা।<br /> ৭- তাহমীদ <span class="c2">(ৰাব্বানা অলাকাল হাম্দ)</span> পাঠ কৰাৰ পিছত এই দুআ কোৱাঃ "মিলআচ ছামাৱাতি, অমিলআল আৰজ, অমিলআ মা শ্বি\'তা মিন শ্বাইয়িম বাদ"।<br /> ৮- ৰুকত একাধিকবাৰ তাছবীহ পাঠ কৰা, অৰ্থাৎ দ্বিতীয় আৰু তৃতীয়বাৰ বা তাতকৈও অধিকবাৰ পাঠ কৰা।<br /> ৯- ছাজদাত একাধিকবাৰ তাছবীহ পাঠ কৰা।<br /> ১০- দুই ছাজদাৰ মাজত একাধিকবাৰ "ৰাব্বিগ ফিৰলী" পাঠ কৰা।<br /> ১১- শেষ বৈঠকত দৰূদে ইব্ৰাহীম পাঠ কৰা, আৰু তাৰ পিছত অন্যান্য়া দুআ পাঠ কৰা।<br /> কৰ্মগত ছুন্নতসমূহ। ইয়াক আৰবীত হাইআত বোলে।<br /> ১- তাকবাৰে তাহৰীমাৰ সৈতে দুয়ো হাত উত্তোলন কৰা বা ৰাফউল য়াদাইন কৰা।<br /> ২- ৰূকু কৰাৰ সময়ত ৰাফউল য়াদাইন কৰা।<br /> ৩- ৰূকুৰ পৰা উঠি ৰাফউল য়াদাইন কৰা।<br /> ৪- ইয়াৰ পিছত দুয়ো হাত এৰি দিয়া।<br /> ৫- সোঁ হাত বাওঁ হাতৰ ওপৰত ৰখা।<br /> ৬- ছাজদাৰ ঠাইত দৃষ্টি ৰখা।<br /> ৭- থিয় হৈ থকা অৱস্থাত দুয়ো ভৰিৰ মাজত ব্যৱধান ৰখা।<br /> ৮- ৰূকু কৰাৰ সময়ত হাতৰ আঙুলিবোৰৰ মাজত ফাক ৰাখি মজবুতভাৱে আঠু ধাৰণ কৰা। লগতে পিঠি আৰু মূৰ সমতল কৰি ৰখা।<br /> ৯- ছাজদাৰ অংগবোৰ মাটিত পৰিপূৰ্ণৰূপে স্পৰ্শ কৰা, এটাও যাতে মাটিত স্পৰ্শ নোহোৱাকৈ নাথাকে।<br /> ১০- লক্ষ্য ৰাখিব লাগিব যে, কাষৰ সৈতে যাতে বাহু লাগি নাথাকে, উৰুৰ সৈতে যাতে পেট লাগি নাথাকে আৰু উৰু যাতে কলাফুলৰ সৈতে লাগি নাথাকে। দুয়ো আঠুৰ মাজত ব্যৱধান ৰাখিব লাগিব। ভৰি দুখন থিয় হৈ থাকিব লাগিব। দুয়ো ভৰিৰ আঙুলিবোৰৰ নিম্নাংশ মাটিত ৰাখিব লাগিব। দুয়ো হাত দুয়ো কান্ধ বৰাবৰ ৰাখিব লাগিব, হাতৰ আঙুলিবোৰ মিলাই ৰাখিব লাগিব।<br /> ১১- দুই ছাজদাৰ মাজৰ বৈঠকত আৰু প্ৰথম তাশ্বাহহুদত বাওঁ ভৰি পাৰি বহিব লাগে, আনহাতে দ্বিতীয় তাশ্বাহহুদত তাৱাৰ্ৰুক কৰিব লাগে।<br /> ১২- তাশ্বাহহুদ আৰু দুই ছাজদাৰ মাজত দুয়ো হাত প্ৰসাৰিত কৰি উৰুৰ ওপৰত ৰাখিব লাগে, লগতে আঙুলিবোৰ সংযুক্ত ৰাখিব লাগে, কিন্তু তাশ্বাহহুদৰ সময়ত সোঁ হাতৰ কনিষ্ঠা আৰু অনামিকা আঙুলিৰে মুঠি বান্ধি, মধ্যমা আৰু বৃদ্ধাঙ্গুলিৰে গোলাকাৰ বনাই তৰ্জনী আঙুলিৰে দুআ কৰাৰ সময়ত ইংগিত কৰিব লাগে।<br /> ১৩- ছালাম ফিৰোৱাৰ সময়ত সোঁফালে আৰু বাওঁফালে মুখ কৰা। </p>',
      ],
      23 => [
        'question' => 'প্ৰশ্ন নং ২৪- কি কি কাৰণত চালাত বাতিল হয়?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/4210.mp3',
        'answer' => '<p> উত্তৰ- ১- কোনো ৰুকন অথবা চালাতৰ কোনো চৰ্ত পৰিত্যাগ কৰিলে।<br /> ২- জানি বুজি কথা ক\'লে।<br /> ৩- পানাহাৰ কৰিলে।<br /> ৪- সঘনাই তথা একেৰাহে অনৰ্থক গতিবিধি কৰিলে।<br /> ৫- চালাতৰ কোনো এটা ওৱাজিব জানি বুজি পৰিত্যাগ কৰিলে। </p>',
      ],
      24 => [
        'question' => 'প্ৰশ্ন নং ২৫- মুছলিম এজনে কেনেকৈ নামাজ পঢ়িব?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/4280.mp3',
        'answer' => '<p> উত্তৰ- নামাজৰ পদ্ধতিঃ<br /> ১- সম্পূৰ্ণৰূপে কিবলামুখী হোৱা, কোনো ধৰণৰ বিচ্যুতি আৰু কিবলাৰ পৰা আঁতৰি নোযোৱাকৈ।<br /> ২- ইয়াৰ পিছত মৌখিকভাৱে উচ্চাৰণ নকৰাকৈ অন্তৰৰ সংকল্পৰে নিয়্য়ত কৰা।<br /> ৩- ইয়াৰ পিছত "আল্লাহু আকবাৰ" বুলি কৈ তাকবীৰে তাহৰীমা বান্ধিব। তাকবীৰ দিয়াৰ সময়ত দুয়ো হাত কান্ধলৈকে উত্তোলন কৰিব।<br /> ৪- ইয়াৰ পিছত সোঁহাতৰ মণিবদ্ধ বাওঁহাতৰ মণিবদ্ধৰ ওপৰত ৰাখি বুকুৰ ওপৰত ৰাখিব লাগিব।<br /> ৫- তাৰ পিছত এইদৰে দুআ-এ-ইস্তিফতাহ পাঠ কৰি ক\'বঃ আল্লাহুম্মা বা-ঈদ বাইনি অবাইনা খাতা-ইয়াইয়া, কামা বাআদ্তা বাইনাল মাশ্বৰিক্বি অল মাগৰিব; আল্লাহুম্মা নাক্কিনি মিন খাতা-ইয়াইয়া কামা ইউনাক্কাছ্ ছাওবুল আব-ইয়াজু মিনাদ্দানাছ, আল্লাহুম্মাগছিলনি মিন খাতা-ইয়াইয়া বিল মা-য়ি, অচ্ছালজি, অল বাৰ্দ।<br /> অথবা এইটো পঢ়িব লাগে- "ছুবহানাকা আল্লাহুম্মা অবিহামদিকা, অতাবাৰাকাছমুকা, অতাআলা জাদ্দুকা, অলা-ইলাহা গাইৰুকা,"<br /> ৬- তাৰ পিছত এইদৰে তাআওউজ পঢ়িবঃ আউজু বিল্লা-হি মিনাশ্ব শ্বাইত্বনিৰ ৰাজীম। অৰ্থঃ মই অভিশপ্ত চয়তানৰ পৰা আল্লাহৰ আশ্ৰয় প্ৰাৰ্থনা কৰোঁ ৭- ইয়াৰ পিছত বিছমিল্লাহ পঢ়ি ছুৰা ফাতিহা পাঠ কৰিবঃ বিছমিল্লাহিৰ ৰহমানিৰ ৰাহীম। <span class="c2">(১)</span> আলহামদুলিল্লা-হি ৰাব্বিল আলামীন। <span class="c2">(২)</span> আৰ-ৰহমানিৰ ৰাহীম। <span class="c2">(৩)</span> মা-লিকি ইয়াওমিদ্দীন। <span class="c2">(৪)</span> ইয়্যাকানা’বুদু ওৱা ইয়্যাকানাছতাঈন। <span class="c2">(৫)</span> ইহদিনাছ চিৰাত্বল মুস্তাক্বীম। <span class="c2">(৬)</span> চিৰাত্বল লাজীনা আনআমতা আলাইহিম, গাইৰিল মাগদ্বুবি আলাইহিম অলাজ দ্বল্লীন। <span class="c2">(৭)</span> <span class="c2">(ছুৰা আল-ফাতিহাঃ ১-৭)</span><br /> ইয়াৰ পিছত ক\'ব <span class="c2">(আমীন)</span> অৰ্থাৎ হে আল্লাহ! তুমি কবুল কৰা।<br /> ৮- ইয়াৰ পিছত কোৰআনৰ পৰা কিছু তিলাৱত কৰিব। বিশেষকৈ ফজৰৰ চালাতত দীৰ্ঘ তিলাৱত কৰিব লাগে।<br /> ৯- ইয়াৰ পিছত ৰূকু কৰিব। অৰ্থাৎ আল্লাহৰ সন্মানাৰ্থে পিঠি বেকা কৰি হালিব লাগিব। ৰূকু কৰাৰ সময়ত তাকবীৰ ক\'ব লাগিব আৰু দুয়ো হাত কান্ধলৈকে উত্তোলন কৰিব লাগিব। ছুন্নত হৈছে, পিঠি আৰু মূৰ সমতলকৈ ৰখা আৰু হাতৰ আঙুলিবোৰ ফাক ৰাখি মজবুতভাৱে আঠু ধাৰণ কৰা।<br /> ১০- ৰূকুত "ছুবহানা ৰাব্বিয়াল আজীম" তিনিবাৰ পঢ়িব লাগে। ইয়াৰ ওপৰিও যদি "ছুবহানাকা আল্লাহুম্মা অবিহামদিকা, আল্লাহুম্মাগফিৰলী" পঢ়ে তেন্তে উত্তম।<br /> ১১- ইয়াৰ পিছত "ছামিআল্লাহু লিমান হামিদাহ" বুলি কৈ ৰূকুৰ পৰা মূৰ উঠাব, আৰু তেতিয়া দুয়ো হাত কান্ধলৈকে উত্তোলন কৰিব। মুক্তাদিয়ে "ছামিআল্লাহু লিমান হামিদাহ" কোৱাৰ প্ৰয়োজন নাই, মুক্তাদিয়ে ইয়াৰ পৰিবৰ্তে কেৱল "ৰাব্বানা অলাকাল হাম্দ" ক\'লেই হ\'ব।<br /> ১২- মূৰ উঠোৱাৰ পিছত এই দুআ ক\'বঃ ৰাব্বানা অলাকাল হাম্দ, মিলআচ ছামাৱাতি, অমিলআল আৰজ, অমিলআ মা শ্বি\'তা মিন শ্বাইয়িম বাদ।<br /> ১৩- ইয়াৰ পিছত প্ৰথম ছাজদাহ কৰিব আৰু ছাজদাহ কৰাৰ সময়ত আল্লাহু আকবাৰ বুলি ক\'ব। সাতটা অংগৰে ছাজদাহ কৰিবঃ কপাল আৰু নাক, দুই হাত, দুই আঠু, দুই চৰণ। দুয়ো বাহু কাষৰ পৰা আঁতৰত ৰাখিব লাগিব, দুয়ো হাত কিলাকুটিলৈকে যাতে মাটিত প্ৰসাৰিত নহয়। লগতে আঙুলিবোৰ যাতে কিবলামুখী থাকে।<br /> ১৪- ছাজদাত "ছুবহানা ৰাব্বিয়াল আ\'লা" তিনিবাৰ পঢ়িব। ইয়াৰ ওপৰিও যদি "ছুবহানাকা আল্লাহুম্মা অবিহামদিকা, আল্লাহুম্মাগফিৰলী" পঢ়ে তেন্তে উত্তম।<br /> ১৫- ইয়াৰ পিছত "আল্লাহু আকবাৰ" বুলি কৈ ছাজদাৰ পৰা মূৰ তুলিব।<br /> ১৬-ইয়াৰ পিছত দুই ছাজদাৰ মাজত বাওঁ ভৰি পাৰি তাৰ ওপৰত বহিব, সোঁ ভৰি থিয়কৈ ৰাখিব, তাৰ পিছত সোঁ হাত সোঁ উৰুৰ ওপৰত আঠুৰ কাষত ৰাখিব। লগতে কনিষ্ঠা আৰু অনামিকা আঙুলিৰে মুঠি বান্ধি, বৃদ্ধাঙ্গুলি আৰু মধ্যমা আঙুলিৰে গোলাকাৰ ৰিং বনাই তৰ্জনী আঙুলিৰে ইংগিত কৰিব। ইপিনে বাওঁ উৰুৰ ওপৰত আঠুৰ কাষত বাওঁহাত ৰাখিব, আঙুলিবোৰ যাতে প্ৰসাৰিত হৈ থাকে।<br /> ১৭- দুই ছাজদাৰ মাজৰ বৈঠকত এই দুআ পঢ়িবঃ ৰাব্বিগ ফিৰলী, অৰহামনী, অহদিনী, অৰঝুকনী, অজবুৰনী, ওৱা আ-ফিনী।<br /> ১৮- ইয়াৰ পিছত আল্লাহু আকবাৰ বুলি কৈ দ্বিতীয় ছাজদাহ কৰিব, প্ৰথম ছাজদাত যি যি কৈছিল ইয়াতো তাকেই ক\'ব।<br /> ১৯- তাৰ পিছত আল্লাহু আকবাৰ বুলি কৈ দ্বিতীয় ছাজদাৰ পৰা উঠি থিয় হ\'ব আৰু দ্বিতীয় ৰাকাত পঢ়িব, প্ৰথম ৰাকাতত যেনেকৈ কৰিছিল আৰু যি যি কৈছিল সেইবোৰেই দ্বিতীয় ৰাকাতত কৰিব। কেৱল দুআ-এ-ইস্তিফতাহ পাঠ কৰাৰ প্ৰয়োজন নাই।<br /> ২০- দ্বিতীয় ৰাকাতৰ শেষৰ ছাজদাৰ পৰা আল্লাহু আকবাৰ বুলি কৈ উঠিব আৰু দুই ছাজদাৰ মাজত যেনেকৈ বহিছিল সেইদৰে ইয়াত বৈঠক কৰিব লাগিব।<br /> ২১- এই বৈঠকত তাশ্বাহহুদ পাঠ কৰিব লাগিব। এতেকে এই দুআ পাঠ কৰিবঃ <span class="c2">("আত্তাহিয়্যাতু লিল্লা-হি অচ্ছালাৱাতু অত-তায়্যিবাতু, আচ্ছালামু আলাইকা আইয়্যুহান নাবীয়্যু অৰাহমাতুল্লাহি অবাৰাকাতুহ, আচ্ছালামু আলাইনা ৱাআলা ইবাদিল্লাহিচ্ছলিহীন, আশ্বহাদু আন-লা ইলা-হা ইল্লাল্লাহু, ৱা আশ্বহাদু আন্না মুহাম্মাদান আব্দুহু অৰাছুলুহ।" "আল্লা-হম্মা চল্লি আলা মুহাম্মদ, ৱা আলা আলি মুহাম্মদ, কামা চাল্লাইতা আলা ইব্ৰাহীম, ৱা আলা আলি ইব্ৰাহীম, ইন্নাকা হামীদুম মাজীদ। আল্লা-হম্মা বা-ৰিক আলা মুহাম্মদ, ৱা আলা আলি মুহাম্মদ, কামা বা-ৰাকতা আলা ইব্ৰাহীম, ৱা আলা আলি ইব্ৰাহীম, ইন্নাকা হামীদুম মাজীদ।" "আউজুবিল্লাহি মিন আজাবি জাহান্নাম, অমিন আজাবিল কবৰ, অমিন ফিতনাতিল মাহয়া অলমামাত, অমিন ফিতনাতিল মাছীহিদ দাজ্জাল।")</span> ইয়াৰ পিছত পৃথিৱী আৰু আখিৰাতৰ কল্যাণ কামনা কৰি নিজৰ পছন্দ অনুযায়ী আল্লাহৰ ওচৰত দুআ কৰিব।<br /> ২২- ইয়াৰ পিছত সোঁফালে "আচ্ছালামু আলাইকুম অৰাহমাতুল্লাহ" আৰু বাওঁ ফালেও এই বুলি কৈ ছালাম ফিৰাব।<br /> ২৩- আৰু যদি চালাত তিনি ৰাকাতবিশিষ্ট নাইবা চাৰি ৰাকাত বিশিষ্ট হয় তেন্তে কেৱল "আশ্বহাদু আন-লা ইলা-হা ইল্লাল্লাহু, ৱা আশ্বহাদু আন্না মুহাম্মাদান আব্দুহু অৰাছুলুহ", লৈকেই পঢ়িব লাগিব।<br /> ২৪- ইয়াৰ পিছত আল্লাহু আকবাৰ বুলি কৈ থিয় হ\'ব আৰু দুয়ো হাত কান্ধ বৰাবৰ উত্তোলন কৰিব।<br /> ২৫- ইয়াৰ পিছত পঢ়িবলগীয়া ৰাকাত কেইটা দ্বিতীয় ৰাকাতৰ দৰেই আদায় কৰিব। কিন্তু কেৱল ছুৰা ফাতিহাৰ বাহিৰে অন্য কোনো ছুৰা মিলোৱাৰ প্ৰয়োজন নাই।<br /> ২৬- ইয়াৰ পিছত শেষ বৈঠকত তাৱাৰ্ৰুক কৰিব। অৰ্থাৎ সোঁ ভৰি থিয় কৰাই বাওঁ ভৰিক সোঁ ভৰিৰ কলাফুলিৰ তলেৰে পাৰ কৰাই মাটিত বহিব। লগতে দুয়ো হাত দুয়ো উৰুৰ ওপৰত ৰাখিব, যেনেকৈ প্ৰথম তাশ্বাহহুদৰ বৈঠকত ৰাখিছিল।<br /> ২৭- এই বৈঠকত সম্পূৰ্ণ তাশ্বাহহুদ পাঠ কৰিব।<br /> ২৮- ইয়াৰ পিছত সোঁফালে "আচ্ছালামু আলাইকুম অৰাহমাতুল্লাহ" আৰু বাওঁ ফালেও এই বুলি কৈ ছালাম ফিৰাব। </p>',
      ],
      25 => [
        'question' => 'প্ৰশ্ন নং ২৬- নামাজৰ ছালাম ফিৰোৱাৰ পিছত কি কি দুআ পঢ়িব লাগে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/4610.mp3',
        'answer' => '<p> উত্তৰ- আস্তাগফিৰুল্লাহ <span class="c2">(মই আল্লাহৰ ওচৰত ক্ষমা বিচাৰোঁ)</span> তিনিবাৰ ক\'ব।<br /> আল্লাহুম্মা আন্তাছ ছালাম, অমিনকাছ ছালাম, তাবাৰাকতা ইয়া যাল-জালালি অল-ইকৰাম। <span class="c2">(হে আল্লাহ তুমিয়েই শান্তিময়, আৰু তোমাৰ পৰাই শান্তি বৰ্ষণ হয়, হে মহিমাময় আৰু মহানুভৱ! তুমি মহা বৰকতময়।)</span><br /> লা ইলা-হা ইল্লাল্লা-হু অহদাহু লা শ্বাৰীকা লাহু, লাহুল মুল্কু অলাহুল হাম্দু, অহুৱা আলা কুল্লি শ্বাইয়িন ক্বাদীৰ। আল্লাহুম্মা লা মানিআ লিমা আ\'ত্বাইতা, অলা মু\'ত্বিয়া লিমা মানা\'তা। অলা য়ানফাউ যাল-জাদ্দি মিনকাল জাদ্দু। <span class="c2">(আল্লাহৰ বাহিৰে আন কোনো সত্য উপাস্য নাই। তেওঁ একক, তেওঁৰ কোনো অংশীদাৰ নাই। ৰাজত্ব তেওঁৰেই আৰু প্ৰশংসাও কেৱল তেওঁৰেই। তেওঁ সকলো ক্ষেত্ৰতে ক্ষমতাৱান। হে আল্লাহ! তুমি যিটো দিব বিচৰা সেইটো কোনেও ৰোধ কৰিব নোৱাৰে আৰু তুমি যিটোক বাধা দিয়া সেইটো কোনেও প্ৰদান কৰিব নোৱাৰে। লগতে কোনো মৰ্যাদাৱানৰ মৰ্যাদাই তোমাৰ ওচৰত কোনো উপকাৰ কৰিব নোৱাৰে।<br /> লা ইলা-হা ইল্লাল্লা-হু অহদাহু লা শ্বাৰীকা লাহু, লাহুল মুল্কু অলাহুল হাম্দু, অহুৱা আলা কুল্লি শ্বাইয়িন ক্বাদীৰ। লা হাওলা অলা কুওৱাতা ইল্লা বিল্লাহ। অলা না\'বুদু ইল্লা ইয়্যাহ, লাহুন নি\'মাহ, অলাহুল ফজল, অলাহুচ ছানা উল হাছান, লা ইলা-হা ইল্লাল্লা-হু মুখলিচীনা লাহুদ দ্বীন, অলাও কাৰিহাল কাফিৰূন। (আল্লাহৰ বাহিৰে আন কোনো সত্য উপাস্য নাই। তেওঁ একক, তেওঁৰ কোনো অংশীদাৰ নাই। ৰাজত্ব তেওঁৰেই আৰু প্ৰশংসাও কেৱল তেওঁৰেই। তেওঁ সকলো ক্ষেত্ৰতে ক্ষমতাৱান। সৰ্বশক্তিমান আল্লাহৰ বাহিৰে আন কাৰো শক্তি নাই তথা ক্ষমতাও নাই। আমি একমাত্ৰ তেওঁৰেই ইবাদত কৰোঁ। নিয়ামত একমাত্ৰ তেওঁৰেই আৰু তেওঁৰেই অনুগ্ৰহ আৰু উত্তম প্ৰশংসা তেওঁৰ বাবেই নিৰ্দিষ্ট। আল্লাহৰ বাহিৰে আন কোনো সত্য উপাস্য নাই। যাৱতীয় ইবাদত নিৰ্ভেজালভাৱে একমাত্ৰ তেওঁৰেই প্ৰাপ্য, যদিও কাফিৰসকলে অপছন্দ কৰে।<br /> ছুবহানাল্লাহ (আল্লাহ অতি পৱিত্ৰ)</span> ৩৩ বাৰ পঢ়িব।<br /> আলহাম্দুলিল্লাহ <span class="c2">(যাৱতীয় প্ৰশংসা আল্লাহৰ বাবে)</span> ৩৩ বাৰ পঢ়িব।<br /> আল্লাহু আকবাৰ <span class="c2">(আল্লাহ মহান)</span> ৩৩ বাৰ পঢ়িব।<br /> ইয়াৰ পিছত এশ সম্পূৰ্ণ কৰিবলৈ এই দুআ পঢ়িবঃ লা ইলা-হা ইল্লাল্লা-হু অহদাহু লা শ্বাৰীকা লাহু, লাহুল মুল্কু অলাহুল হাম্দু, অহুৱা আলা কুল্লি শ্বাইয়িন ক্বাদীৰ। <span class="c2">(আল্লাহৰ বাহিৰে আন কোনো সত্য উপাস্য নাই। তেওঁ একক, তেওঁৰ কোনো অংশীদাৰ নাই। ৰাজত্ব তেওঁৰেই আৰু প্ৰশংসাও কেৱল তেওঁৰেই। তেওঁ সকলো ক্ষেত্ৰতে ক্ষমতাৱান।)</span><br /> ফজৰ আৰু মাগৰিবৰ পিছত ছুৰা ইখলাচ, ছুৰা ফালাক্ব আৰু নাছ তিনিবাৰকৈ পঢ়িব। জোহৰ, আচৰ আৰু ঈশ্বাৰ পিছত এবাৰকৈ পঢ়িব।<br /> এবাৰ আয়াতুল কুৰ্ছী পাঠ কৰিব। </p>',
      ],
      26 => [
        'question' => 'প্ৰশ্ন নং ২৭- ছুনান ৰাৱাতিব কি? আৰু ইয়াৰ ফজিলত কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/4730.mp3',
        'answer' => '<p> উত্তৰ- দুই ৰাকাত ফজৰৰ আগত।<br /> চাৰি ৰাকাত জোহৰৰ আগত।<br /> দুই ৰাকাত জোহৰৰ পিছত।<br /> দুই ৰাকাত মাগৰিবৰ পিছত।<br /> দুই ৰাকাত ঈশ্বাৰ পিছত।<br /> ইয়াৰ ফজিলত সম্পৰ্কে নবী চাল্লাল্লাহু আলাইহি অছাল্লামে কৈছেঃ যি ব্যক্তিয়ে দিনে ৰাতি ১২ ৰাকাত নফল <span class="c2">(ছুন্নত)</span> চালাত আদায় কৰে, আল্লাহে তেওঁৰ বাবে জান্নাতত এটি ঘৰ নিৰ্মাণ কৰে। মুছলিম আৰু আহমদে হাদীছটো বৰ্ণনা কৰিছে। </p>',
      ],
      27 => [
        'question' => 'প্ৰশ্ন নং ২৮- সপ্তাহৰ উত্তম দিন কোনটো?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/4800.mp3',
        'answer' => '<p> উত্তৰ- সপ্তাহৰ উত্তম দিন হৈছে শুক্ৰবাৰ। নবী চাল্লাল্লাহু আলাইহি অছাল্লামে কৈছেঃ তোমালোকৰ দিনসমূহৰ মাজত সৰ্বোৎকৃষ্ট দিন হৈছে জুমুআৰ দিন। এই দিৱসতেই আদম আলাইহিচ্ছালামক সৃষ্টি কৰা হৈছে আৰু এই দিৱসতেই শিঙাত ফুঁ দিয়া হ\'ব। এই দিৱসতেই সকলো সৃষ্টি অচেতন হৈ পৰিব। গতিকে এইদিনা তোমালোকে মোৰ প্ৰতি অধিক পৰিমাণে দৰূদ পাঠ কৰিবা, কাৰণ তোমালোকে পাঠ কৰা দৰূদ মোৰ ওচৰত উপস্থাপন কৰা হয়। বৰ্ণনাকাৰীয়ে কৈছেঃ প্ৰশ্ন কৰা হ\'ল, হে আল্লাহৰ ৰাছুল! আপোনাৰ শৰীৰ দেখোন গেলি-পচি যাব অৰ্থাৎ ক্ষয়প্ৰাপ্ত হ\'ব, তেনে অৱস্থাত আমাৰ দৰূদ আপোনাৰ ওচৰত কেনেকৈ উপস্থাপন কৰা হ\'ব? তেতিয়া তেখেতে ক\'লেঃ নিশ্চয় আল্লাহে নবীসকলৰ শৰীৰক <span class="c2">(বিনষ্ট কৰিবলৈ)</span> মাটিৰ বাবে হাৰাম কৰি দিছে। ইয়াক আবু দাউদে বৰ্ণনা কৰিছে। </p>',
      ],
      28 => [
        'question' => 'প্ৰশ্ন নং ২৯- জুমুআৰ চালাতৰ বিধান কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/4840.mp3',
        'answer' => '<p> উত্তৰ- ফৰজে আঈন। অৰ্থাৎ প্ৰত্যেক প্ৰাপ্তবয়স্ক, বিবেক সম্পন্ন, স্ব-স্থানত বসবাস কৰা মুছলিম পুৰুষৰ ওপৰত অনিবাৰ্য।<br /> আল্লাহে কৈছেঃ হে ঈমান্দাৰসকল! জুমুআৰ দিনা যেতিয়া ছালাতৰ বাবে আহ্বান কৰা হয়, তেতিয়া তোমালোকে আল্লাহৰ স্মৰণৰ ফালে ধাৱিত হোৱা আৰু বেচা-কিনা বন্ধ কৰা। এইটোৱে তোমালোকৰ বাবে সৰ্বোত্তম, যদি তোমালোকে উপলব্ধি কৰা। <span class="c2">(ছুৰা আল-জুমুআহঃ ৯)</span> </p>',
      ],
      29 => [
        'question' => 'প্ৰশ্ন নং ৩০- জুমুআৰ চালাতৰ ৰাকাত সংখ্যা কিমান?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/4880.mp3',
        'answer' => '<p> উত্তৰ- জুমুআৰ চালাত হৈছে দুই ৰাকাত, য\'ত ইমামে উচ্চস্বৰে কিৰাআত কৰিব লাগে। ইয়াৰ আগতে দুটা খুতবা দিব লাগে। </p>',
      ],
      30 => [
        'question' => 'প্ৰশ্ন নং ৩১- জুমুআৰ চালাত এৰি দিয়া জায়েজ আছেনে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/4910.mp3',
        'answer' => '<p> উত্তৰ- শ্বাৰয়ী কাৰণ নোহোৱাকৈ জুমুআৰ চালাত এৰি দিয়া বৈধ নহয়। নবী চাল্লাল্লাহু আলাইহি অছাল্লামে কৈছেঃ যিয়ে অৱহেলা কৰি তিনিটা জুমুআহ পৰিত্যাগ কৰে, আল্লাহে তাৰ অন্তৰত মোহৰ মাৰি দিয়ে। ইয়াক আবু দাউদে বৰ্ণনা কৰিছে। </p>',
      ],
      31 => [
        'question' => 'প্ৰশ্ন নং ৩২- জুমুআৰ দিনৰ ছুন্নতসমূহ কি কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/4940.mp3',
        'answer' => '<p> উত্তৰ-<br /> ১- গোছল কৰা।<br /> ২- সুগন্ধি ব্যৱহাৰ কৰা।<br /> ৩- উত্তম কাপোৰ পৰিধান কৰা।<br /> ৪- সোনকালে মছজিদত যোৱা।<br /> ৫- বেছি বেছি নবীৰ প্ৰতি দৰূদ পাঠ কৰা।<br /> ৬- ছুৰা কাহাফ তিলাৱত কৰা।<br /> ৭- খোজকাঢ়ি মছজিদলৈ যোৱা।<br /> ৮- দুআ কবুল হোৱাৰ সময় অনুসন্ধান কৰা। </p>',
      ],
      32 => [
        'question' => 'প্ৰশ্ন নং ৩৩- জামাতত চালাত আদায় কৰাৰ ফজিলত উল্লেখ কৰা?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5050.mp3',
        'answer' => '<p> উত্তৰ- আব্দুল্লাহ বিন ওমৰ ৰাদ্বিয়াল্লাহু আনহুমাৰ পৰা বৰ্ণিত, ৰাছুলুল্লাহ চাল্লাল্লাহু আলাইহি অছাল্লামে কৈছেঃ জামাআতৰ চালাত অকলশৰীয়া চালাততকৈ ২৭ গুণ উত্তম। ইয়াক মুছলিমে বৰ্ণনা কৰিছে। </p>',
      ],
      33 => [
        'question' => 'প্ৰশ্ন নং ৩৪- চালাতত খুশ্বু কাক বোলে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5080.mp3',
        'answer' => '<p> উত্তৰ- মনোযোগ সহকাৰে ধীৰ স্থিৰে আদায় কৰাক খুশ্বু বোলে।<br /> আল্লাহে কৈছেঃ নিশ্চয় মুমিনসকল সফলকাম হৈছে। যিসকলে নিজৰ ছালাতত ভীতি-অৱনত। <span class="c2">(ছুৰা আল-মুমিনূনঃ ১-২)</span> </p>',
      ],
      34 => [
        'question' => 'প্ৰশ্ন নং ৩৫- জাকাত কাক বোলে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5120.mp3',
        'answer' => '<p> উত্তৰ- জাকাত হৈছে এনেকুৱা এটা ওৱাজিব হক, যিটো নিৰ্দিষ্ট পৰিমাণ সম্পদৰ পৰা এটা নিৰ্দিষ্ট অংশ কিছুমান নিৰ্দিষ্ট লোকৰ বাবে নিৰ্দিষ্ট সময়ত উলিয়াব লাগে।<br /> এইটো ইছলামৰ এটা ৰুকন তথা ওৱাজিব চাদাক্বাহ, যিটো ধনী লোকৰ পৰা সংগ্ৰহ কৰি দুখীয়া দৰিদ্ৰ লোকৰ মাজত বিতৰণ কৰি দিয়া হয়।<br /> আল্লাহে কৈছেঃ আৰু জাকাত প্ৰদান কৰা। <span class="c2">(ছুৰা আল-বাক্বাৰাহঃ ৪৩)</span> </p>',
      ],
      35 => [
        'question' => 'প্ৰশ্ন নং ৩৬- মুস্তাহাব চাদাক্বাহ কাক বোলে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5170.mp3',
        'answer' => '<p> উত্তৰ- জাকাতৰ বাহিৰে প্ৰদান কৰা প্ৰতিটো দানেই হৈছে চাদাক্বাহ। উদাহৰণস্বৰূপে কল্যাণৰ উদ্দেশ্যে যিকোনো বস্তু যিকোনো সময়ত দান কৰাটোৱে হৈছে চাদাক্বাহ।<br /> আল্লাহে কৈছেঃ আৰু তোমালোকে আল্লাহৰ পথত ব্যয় কৰা। <span class="c2">(ছুৰা আল-বাক্বাৰাহঃ ১৯৫)</span> </p>',
      ],
      36 => [
        'question' => 'প্ৰশ্ন নং ৩৭- চিয়াম কাক বোলে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5210.mp3',
        'answer' => '<p> উত্তৰ- আল্লাহৰ ইবাদতৰ নিয়ত কৰি ফজৰ উদয় হোৱাৰ পৰা সূৰ্যাস্তলৈকে ৰোজা ভংগ হোৱাৰ কাৰণসমূহৰ পৰা বিৰত থকাকে চিয়াম বোলে। চিয়াম হৈছে দুই প্ৰকাৰঃ<br /> অনিবাৰ্য চিয়ামঃ যেনে- ৰমজান মাহৰ চিয়াম, আৰু এইটো ইছলামৰ এটা ৰুকন।<br /> আল্লাহে কৈছেঃ হে ঈমান্দাৰসকল! তোমালোকৰ ওপৰত চিয়াম ফৰজ কৰা হৈছে যেনেকৈ তোমালোকৰ পূৰ্বৱৰ্তীসকলৰ ওপৰত ফৰজ কৰা হৈছিল, যাতে তোমালোকে তাক্বৱা অৱলম্বন কৰা। <span class="c2">(ছুৰা আল-বাক্বাৰাহঃ ১৮৩)</span><br /> অন্যান্য চিয়ামঃ যেনে- প্ৰতি সপ্তাহৰ সোমবাৰ আৰু বৃহস্পতিবাৰৰ চিয়াম। প্ৰতি মাহৰ তিনিটা চিয়াম, উত্তম হৈছে প্ৰতি চন্দ্ৰ মাহৰ ১৩, ১৪, ১৫ তাৰিখে পালন কৰা। ইয়াক আয়্যামে বীদ্ব বুলি কোৱা হয়। </p>',
      ],
      37 => [
        'question' => 'প্ৰশ্ন নং ৩৮- ৰমজান মাহৰ ৰোজাৰ ফজিলত উল্লেখ কৰা?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5270.mp3',
        'answer' => '<p> উত্তৰ- আবু হুৰাইৰাহ ৰাদ্বিয়াল্লাহু আনহুৰ পৰা বৰ্ণিত, ৰাছুলুল্লাহ চাল্লাল্লাহু আলাইহি অছাল্লামে কৈছেঃ যি ব্যক্তিয়ে ঈমানৰ সৈতে ছোৱাবৰ আশাত ৰমজান মাহৰ চওম পালন কৰে, সেই ব্যক্তিৰ অতীতৰ গুনাহসমূহ মাফ কৰি দিয়া হয়। মুত্তাফাক্ব আলাইহ </p>',
      ],
      38 => [
        'question' => 'প্ৰশ্ন নং ৩৯- ৰমজানৰ বাহিৰে নফল চওমৰ ফজিলত বৰ্ণনা কৰা?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5300.mp3',
        'answer' => '<p> উত্তৰ- আবু ছাঈদ আল-খুদৰী ৰাদ্বিয়াল্লাহু আনহুৰ পৰা বৰ্ণিত, ৰাছুলুল্লাহ চাল্লাল্লাহু আলাইহি অছাল্লামে কৈছেঃ যিজন বান্দাই আল্লাহৰ পথত এদিন ৰোজা পালন কৰে, সেই এদিনৰ বিনিময়ত আল্লাহে তাক জাহান্নামৰ পৰা সত্তৰ বছৰ দূৰত আঁতৰাই দিয়ে। মুত্তাফাক্ব আলাইহ<br /> হাদীছত উল্লিখিত <span class="c2">(سبعين خريفًا)</span> অৰ্থাৎ সত্তৰ বছৰ। </p>',
      ],
      39 => [
        'question' => 'প্ৰশ্ন নং ৪০- ৰোজা ভংগ হোৱাৰ কেইটামান কাৰণ উল্লেখ কৰা?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5330.mp3',
        'answer' => '<p> উত্তৰ- ১- জানি বুজি কিবা খোৱা।<br /> ২- জানি বুজি বমি কৰা।<br /> ৩- মুৰতাদ হোৱা বা ইছলামৰ পৰা আঁতৰি যোৱা। </p>',
      ],
      40 => [
        'question' => 'প্ৰশ্ন নং ৪১- ৰোজাৰ ছুন্নতসমূহ কি কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5380.mp3',
        'answer' => '<p> উত্তৰ- ১- ইফতাৰ কৰাত পলম নকৰা।<br /> ২- ছাহৰি খোৱা, তথা শেষ সময়ত খোৱা।<br /> ৩- ইবাদত তথা কল্যাণকৰ আমল বেছি বেছি কৰা।<br /> ৪- ৰোজাদাৰক যদি কোনোবাই গালি পাৰে তেন্তে এই বুলি কোৱা যে, মই ৰোজা লৈছোঁ।<br /> ৫- ইফতাৰৰ সময়ত দুআ কৰা।<br /> ৬- খেজুৰৰ দ্বাৰা ইফতাৰ কৰা, যদি খেজুৰ নাথাকে তেন্তে পানীৰে কৰা। </p>',
      ],
      41 => [
        'question' => 'প্ৰশ্ন নং ৪২- হজ্জ কাক বোলে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5460.mp3',
        'answer' => '<p> উত্তৰ- হজ্জ হৈছে আল্লাহৰ উদ্দেশ্যে কৰা এটা ইবাদত, যিটো পালন কৰিবলৈ বাইতুল্লাহিল হাৰামত গৈ কিছুমান নিৰ্দিষ্ট আমল নিৰ্দিষ্ট সময়ত আদায় কৰা হয়।<br /> আল্লাহে কৈছেঃ মানুহৰ মাজৰ পৰা তাত যাবলৈ যাৰ সামৰ্থ আছে, আল্লাহৰ উদ্দেশ্যে সেই ঘৰৰ হজ্জ কৰা তাৰ বাবে জৰুৰী কৰ্তব্য। আনহাতে যিয়ে কুফৰী কৰিব সি জানি থোৱা উচিত, নিশ্চয় আল্লাহ সৃষ্টিজগতৰ মুখাপেক্ষী নহয়। <span class="c2">(ছুৰা আলে-ইমৰাণঃ ৯৭)</span> </p>',
      ],
      42 => [
        'question' => 'প্ৰশ্ন নং ৪৩- হজ্জৰ আৰকান কেইটা আৰু কি কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5500.mp3',
        'answer' => '<p> উত্তৰ- ১-ইহৰাম।<br /> ২- আৰাফাত অৱস্থান কৰা।<br /> ৩- তাৱাফে ইফাজাহ কৰা।<br /> ৪- চাফা আৰু মাৰৱাৰ মাজত ছায়ী কৰা। </p>',
      ],
      43 => [
        'question' => 'প্ৰশ্ন নং ৪৪- হজ্জৰ ফজিলত কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5560.mp3',
        'answer' => '<p> উত্তৰ- আবু হুৰাইৰাহ ৰাদ্বিয়াল্লাহু আনহুৰ পৰা বৰ্ণিত, তেওঁ কৈছে মই ৰাছুলুল্লাহ চাল্লাল্লাহু আলাইহি অছাল্লামৰ পৰা শুনিছোঁ, তেখেতে কৈছেঃ যি ব্যক্তিয়ে হজ্জ পালন কৰিলে আৰু <span class="c2">(সেই হজ্জ কৰা সময়ত)</span> কোনো ধৰণৰ অশ্লীল কৰ্ম কৰা নাই আৰু পাপকৰ্মও কৰা নাই, এনেকুৱা ব্যক্তি ঠিক সেইদিনৰ দৰে <span class="c2">(নিষ্পাপ হৈ)</span> ঘৰলৈ উভতিব, যিদিনা তাৰ মাকে তাক প্ৰসৱ কৰিছিল। <span class="c2">(বুখাৰীয়ে বৰ্ণনা কৰিছে)</span><br /> <span class="c2">(كيوم ولدته أمه)</span> অৰ্থাৎ নিষ্পাপ হৈ উভতিব। </p>',
      ],
      44 => [
        'question' => 'প্ৰশ্ন নং ৪৫- ওমৰাহ কাক বোলে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5600.mp3',
        'answer' => '<p> উত্তৰ- ওমৰাহ হৈছে আল্লাহৰ উদ্দেশ্যে কৰা এটা ইবাদত, যিটো পালন কৰিবলৈ বাইতুল্লাহিল হাৰামত গৈ কিছুমান নিৰ্দিষ্ট আমল পালন কৰা হয়। এইটো পালন কৰিবলৈ কোনো নিৰ্দিষ্ট সময় নাই। যিকোনো সময়তে পালন কৰিব পাৰি। </p>',
      ],
      45 => [
        'question' => 'প্ৰশ্ন নং ৪৬- ওমৰাৰ আৰকান কেইটা আৰু কি কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5630.mp3',
        'answer' => '<p> উত্তৰ- ১- ইহৰাম।<br /> ২- বাইতুল্লাহৰ তাৱাফ কৰা।<br /> ৩- চাফা আৰু মাৰৱাৰ মাজত ছায়ী কৰা। </p>',
      ],
      46 => [
        'question' => 'প্ৰশ্ন নং ৪৭- আল্লাহৰ পথত জিহাদ কৰাৰ অৰ্থ কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5690.mp3',
        'answer' => '<p> উত্তৰ- ইছলাম প্ৰচাৰ কৰিবলৈ সৰ্বতো প্ৰকাৰে চেষ্টা কৰা, ইছলাম আৰু মুছলিমৰ হৈ প্ৰতিৰক্ষা কৰা তথা ইছলামৰ শত্ৰুৰ সৈতে যুদ্ধ কৰা।<br /> আল্লাহে কৈছেঃ অভিযানলৈ ওলাই পৰা, পাতল অৱস্থাতেই হওক নাইবা গধূৰ অৱস্থাত আৰু জিহাদ কৰা আল্লাহৰ পথত তোমালোকৰ সম্পদ আৰু জীৱনৰ দ্বাৰা। এইটোৱে তোমালোকৰ বাবে উত্তম, যদি তোমালোকে জানিলাহেঁতেন! <span class="c2">(ছুৰা আত-তাওবাহঃ ৪১)</span> </p>',
      ],
    ],
    3 => [
      0 => [
        'question' => 'প্ৰশ্ন নং ১- আমাৰ প্ৰিয় নবী মুহাম্মদ চাল্লাল্লাহু আলাইহি অছাল্লামৰ বংশবৃক্ষ কোৱাচোন?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5740.mp3',
        'answer' => '<p> উত্তৰ- মুহাম্মদ বিন আব্দুল্লাহ বিন আব্দুল মুত্তালিব বিন হাশ্বিম, হাশ্বিম হৈছে কুৰাইশ্বৰ বংশধৰ আৰু কুৰাইশ্ব হৈছে আৰবৰ মূল বাসিন্দা আৰু আৰব হৈছে ইছমাঈল আলাইহিচ্ছালামৰ বংশধৰ আৰু ইছমাঈল আলাইহিচ্ছালাম হৈছে ইব্ৰাহীম আলাইহিচ্ছালামৰ পুত্ৰ। দৰূদ আৰু ছালাম বৰ্ষিত হওক ইব্ৰাহীম আলাইহিচ্ছালাম আৰু আমাৰ প্ৰিয় নবীৰ ওপৰত। </p>',
      ],
      1 => [
        'question' => 'প্ৰশ্ন নং ২- আমাৰ প্ৰিয় নবীৰ মাকৰ নাম কি আছিল?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5770.mp3',
        'answer' => '<p> উত্তৰ- আমিনাহ বিন্তে অহাব। </p>',
      ],
      2 => [
        'question' => 'প্ৰশ্ন নং ৩- তেখেত চাল্লাল্লাহু আলাইহি অছাল্লামৰ পিতাৰ মৃত্যু কেতিয়া হৈছিল?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5800.mp3',
        'answer' => '<p> উত্তৰ- তেখেত চাল্লাল্লাহু আলাইহি অছাল্লাম <span class="c2">(মাকৰ)</span> গৰ্ভত থকা অৱস্থাতেই তেখেতৰ পিতাৰ মৃত্যু হৈছিল। </p>',
      ],
      3 => [
        'question' => 'প্ৰশ্ন নং ৪- নবী চাল্লাল্লাহু আলাইহি অছাল্লামৰ জন্ম কেতিয়া হৈছিল?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5830.mp3',
        'answer' => '<p> উত্তৰ- আমুল ফীল বা হাতীৰ বছৰত সোমবাৰৰ দিনা ৰবীউল আওৱাল মাহত তেখেতৰ জন্ম হৈছিল। </p>',
      ],
      4 => [
        'question' => 'প্ৰশ্ন নং ৫- কোনটো চহৰত তেখেতৰ জন্ম হৈছিল?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5850.mp3',
        'answer' => '<p> উত্তৰ- মক্কাত </p>',
      ],
      5 => [
        'question' => 'প্ৰশ্ন নং ৬- তেখেতৰ মাকৰ বাহিৰে তেখেতক কোনে কোনে স্তন্যপান কৰোৱাইছিল আৰু লালন-পালন কৰিছিল?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5880.mp3',
        'answer' => '<p> উত্তৰ- তেখেতৰ পিতৃৰ দাসী উম্মে আইমান।<br /> তেখেতৰ খুৰা আবু লাহাবৰ দাসী, ছুৱাইবাহ।<br /> হালীমা আচ-ছা’দিয়্যাহ </p>',
      ],
      6 => [
        'question' => 'প্ৰশ্ন নং ৭- তেখেতৰ মাকৰ ইন্তেকাল কেতিয়া হৈছিল?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5930.mp3',
        'answer' => '<p> উত্তৰ- ছয় বছৰ বয়সত তেখেতৰ মাকৰ ইন্তেকাল হৈছিল। ইয়াৰ পিছত তেখেতৰ দাদা <span class="c2">(ককা)</span>ই তেখেতক ভৰণ পোষণ দিছিল। </p>',
      ],
      7 => [
        'question' => 'প্ৰশ্ন নং ৮- তেখেতৰ দাদা (ককা)ৰ মৃত্যুৰ পিছত তেখেতক কোনে লালন-পালন কৰিছিল?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5960.mp3',
        'answer' => '<p> উত্তৰ- ৮ বছৰ বয়সত তেখেতৰ দাদা<span class="c2">(ককা)</span>ৰ মৃত্যু হৈছিল। ইয়াৰ পিছত তেখেতৰ খুৰা আবু তালিবে তেখেতৰ লালন-পালনৰ দায়িত্ব লৈছিল। </p>',
      ],
      8 => [
        'question' => 'প্ৰশ্ন নং ৯- তেখেতৰ খুৰাৰ সৈতে ছিৰিয়ালৈ কেতিয়া ভ্ৰমণ কৰিছিল?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5990.mp3',
        'answer' => '<p> উত্তৰ- ১২ বছৰ বয়সত তেখেতে খুৰাৰ সৈতে ছিৰিয়ালৈ ভ্ৰমণ কৰিছিল। </p>',
      ],
      9 => [
        'question' => 'প্ৰশ্ন নং ১০- দ্বিতীয়বাৰ কেতিয়া ভ্ৰমণ কৰিছিল?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6020.mp3',
        'answer' => '<p> তেখেতৰ দ্বিতীয় ভ্ৰমণ আছিল যেতিয়া তেখেতে খাদীজা ৰাদ্বিয়াল্লাহু আনহাৰ সম্পদলৈ ব্যৱসায়ৰ বাবে গৈছিল। সেই ভ্ৰমণৰ পৰা উভতি আহি তেখেতে বিয়া কৰাইছিল। তেতিয়া তেখেতৰ বয়স আছিল ২৫ বছৰ। </p>',
      ],
      10 => [
        'question' => 'প্ৰশ্ন নং ১১- কুৰাইশ্বসকলে কেতিয়া কা\'বা পুনঃনিৰ্মাণ কৰিছিল?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6050.mp3',
        'answer' => '<p> উত্তৰ- কুৰাইশ্বে যেতিয়া কা\'বা পুনঃনিৰ্মাণ কৰিছিল তেতিয়া তেখেতৰ বয়স আছিল ৩৫ বছৰ।<br /> সেই সময়ত হাজৰে আছৱাদ ৰখাকলৈ লোকসকলৰ মাজত মতানৈক্য হোৱাত তেখেতে ইয়াৰ সমাধান দিছিল। সেইটোক এটা কাপোৰৰ মাজত ৰাখি প্ৰতিটো গোত্ৰক কাপোৰটো দাঙি নিবলৈ নিৰ্দেশ দিছিল। সেই সময়ত তাত চাৰিটা গোত্ৰ আছিল, যেতিয়া তেওঁলোকে সেইটোক দাঙি আনিলে তেতিয়া তেখেত চাল্লাল্লাহু আলাইহি অছাল্লামে নিজ হাতে সেইটোক স্থাপন কৰিছিল। </p>',
      ],
      11 => [
        'question' => 'প্ৰশ্ন নং ১২- নবুওৱত লাভ কৰাৰ সময়ত তেখেতৰ বয়স কিমান আছিল? আৰু কোনসকল লোকৰ প্ৰতি তেখেতক প্ৰেৰণ কৰা হৈছে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6080.mp3',
        'answer' => '<p> উত্তৰ- নবুওৱত লাভ কৰাৰ সময়ত তেখেতৰ বয়স আছিল ৪০ বছৰ, আৰু তেখেতক গোটেই মানৱজাতিৰ প্ৰতি সুসংবাদদাতা আৰু সতৰ্ককাৰী হিচাপে প্ৰেৰণ কৰা হৈছে। </p>',
      ],
      12 => [
        'question' => 'প্ৰশ্ন নং ১৩- প্ৰথম অৱস্থাত অহীৰ ধৰণ কেনেকুৱা আছিল?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6110.mp3',
        'answer' => '<p> উত্তৰ- সত্য সপোনৰ দ্বাৰা অহীৰ আৰম্ভণি হৈছিল। তেখেতে দেখা প্ৰতিটো সপোন পুৱাৰ কিৰণৰ নিচিনা বাস্তৱত পৰিণত হৈছিল। </p>',
      ],
      13 => [
        'question' => 'প্ৰশ্ন নং ১৪- অহীৰ পূৰ্বে তেখেতৰ অৱস্থা কেনেকুৱা আছিল? আৰু সৰ্বপ্ৰথম তেখেতৰ ওপৰত অহী কেতিয়া অৱতীৰ্ণ হৈছিল?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6140.mp3',
        'answer' => '<p> উত্তৰ- অহী অৱতীৰ্ণ হোৱাৰ পূৰ্বে তেওঁ নিজৰ লগত প্ৰয়োজনীয় বস্তুলৈ গাৰে হিৰাত গৈ আল্লাহৰ ইবাদত কৰিছিল।<br /> গাৰে হিৰাত ইবাদত কৰি থকা অৱস্থাতেই তেওঁৰ ওপৰত <span class="c2">(প্ৰথমবাৰ)</span> অহী নাজিল হৈছিল। </p>',
      ],
      14 => [
        'question' => 'প্ৰশ্ন নং ১৫- সৰ্বপ্ৰথম কোৰআনৰ কোনটো অংশ তেখেতৰ ওপৰত অৱতীৰ্ণ হৈছিল?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6180.mp3',
        'answer' => '<p> আল্লাহৰ এই বাণীঃ পঢ়া তোমাৰ প্ৰতিপালকৰ নামত, যিজনে সৃষ্টি কৰিছে, তেওঁ মানুহক আলাক্বাৰ পৰা সৃষ্টি কৰিছে। পঢ়া, কাৰণ তোমাৰ প্ৰতিপালক মহামহিম। যিজনে কলমৰ সহায়ত শিক্ষা দিছে। তেওঁ মানুহক এনে শিক্ষা দিছে, যিটো মানুহে জনা নাছিল। <span class="c2">(ছুৰা আলাক্বঃ ১-৫)</span> </p>',
      ],
      15 => [
        'question' => 'প্ৰশ্ন নং ১৬- তেখেতৰ ৰিছালতৰ ওপৰত সৰ্বপ্ৰথম কোনে ঈমান আনিছিল?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6200.mp3',
        'answer' => '<p> উত্তৰ- পুৰুষসকলৰ মাজৰ পৰা আবু বকৰ চিদ্দীক্ব,নাৰীসকলৰ মাজৰ পৰা খাদীজাহ বিন্তে খুৱাইলিদ, শিশুসকলৰ মাজৰ পৰা আলী বিন আবি তালিব, আজাদকৃত দাসসকলৰ মাজৰ পৰা ঝায়েদ বিন হাৰিছা, লগতে দাসসকলৰ মাজৰ পৰা বিলাল হাবশ্বী ৰাদ্বিয়াল্লাহু আনহুম, প্ৰমুখসকলে। </p>',
      ],
      16 => [
        'question' => 'প্ৰশ্ন নং ১৭- ইছলাম কেনেকৈ প্ৰচাৰ হৈছিল?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6230.mp3',
        'answer' => '<p> উত্তৰ- প্ৰথম তিনি বছৰলৈকে গোপনে ইছলাম প্ৰচাৰ কৰা হৈছিল, তাৰ পিছত তেখেতে প্ৰকাশ্যভাৱে ইছলামৰ পিনে আহ্বান কৰিবলৈ নিৰ্দেশ দিছিল। </p>',
      ],
      17 => [
        'question' => 'প্ৰশ্ন নং ১৮- প্ৰকাশ্যভাৱে ইছলামৰ পিনে আহ্বান কৰাৰ পিছত নবী চাল্লাল্লাহু আলাইহি অছাল্লাম আৰু তেখেতৰ প্ৰতি ঈমান পোষণ কৰা লোকসকলৰ অৱস্থা কি হৈছিল?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6260.mp3',
        'answer' => '<p> উত্তৰ- মুশ্বৰিকসকলে তেখেতক আৰু মুছলিমসকলক নিৰ্যাতন কৰা আৰম্ভ কৰিছিল, অৱশেষত তেখেতে মুমিনসকলক হাবশ্বাহ <span class="c2">(আবিচিনিয়া)</span>লৈ হিজৰত কৰাৰ অনুমতি প্ৰদান কৰিছিল।<br /> মুশ্বৰিকসকলে নিৰ্যাতন কৰিবলৈ আৰু নবী চাল্লাল্লাহু আলাইহি অছাল্লামক হত্যা কৰিবলৈ একত্ৰিত হৈছিল। কিন্তু আল্লাহে তেখেতক ৰক্ষা কৰিছিল আৰু তেখেতৰ খুৰা আবু তালিবৰ জৰিয়তে তেখেতক সিহঁতৰ পৰা সুৰক্ষা প্ৰদান কৰিছিল। </p>',
      ],
      18 => [
        'question' => 'প্ৰশ্ন নং ১৯- তেখেতেৰ নবুওৱতৰ দহ নং বছৰত কোনে মৃত্যুবৰণ কৰিছিল?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6300.mp3',
        'answer' => '<p> উত্তৰ- তেখেতৰ খুৰা আবু তালিব আৰু তেখেতৰ স্ত্ৰী খাদীজাহ ৰাদ্বিয়াল্লাহু আনহা মৃত্যুবৰণ কৰিছিল। </p>',
      ],
      19 => [
        'question' => 'প্ৰশ্ন নং ২০- ইছৰা আৰু মিৰাজ কেতিয়া সংঘটিত হৈছিল?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6330.mp3',
        'answer' => '<p> উত্তৰ- তেখেতৰ পঞ্চাছ বছৰ বয়সত ইছৰা আৰু মিৰাজ সংঘটিত হৈছিল। আৰু তেতিয়াই পাঁচ ওৱাক্ত চালাত ফৰজ কৰা হৈছিল।<br /> মছজিদে হাৰামৰ পৰা মছজিদে আকচালৈ যোৱাক ইছৰা বুলি কোৱা হয়।<br /> আৰু মছজিদে আকচাৰ পৰা আকাশলৈ তথা ছিদৰাতুল মুনতাহালৈ যোৱাক মিৰাজ বুলি কোৱা হয়। </p>',
      ],
      20 => [
        'question' => 'প্ৰশ্ন নং ২১- মক্কাৰ বাহিৰত থকা লোকসকলক তেখেত চাল্লাল্লাহু আলাইহি অছাল্লামে কেনেকৈ আহ্বান কৰিছিল?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6380.mp3',
        'answer' => '<p> উত্তৰ- তেখেতে নিজেই তায়েফৰ অধিবাসীসকলক ইছলামৰ পিনে আহ্বান কৰিছিল, লগতে বিভিন্ন বতৰত যেতিয়া মানুহ একত্ৰিত হৈছিল তেতিয়া তেখেতে নিজেই গৈ মানুহক আহ্বান কৰিছিল। অৱশেষত মদীনাৰ পৰা আনচাৰসকলৰ এটা দল আহিছিল আৰু তেওঁলোকে নবী চাল্লাল্লাহু আলাইহি অছাল্লামৰ ওপৰত ঈমান আনিছিল, লগতে তেখেতক সহায় কৰিবলৈ প্ৰতীজ্ঞাবদ্ধ হৈছিল। </p>',
      ],
      21 => [
        'question' => 'প্ৰশ্ন নং ২২- মক্কাত নবী চাল্লাল্লাহু আলাইহি অছাল্লামে কিমান বছৰ ইছলামৰ প্ৰতি আহ্বান কৰিছিল?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6410.mp3',
        'answer' => '<p> উত্তৰ- ১৩ বছৰ। </p>',
      ],
      22 => [
        'question' => 'প্ৰশ্ন নং ২৩- নবী চাল্লাল্লাহু আলাইহি অছাল্লামে ক\'লৈ হিজৰত কৰিছিল?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6440.mp3',
        'answer' => '<p> উত্তৰ- মক্কাৰ পৰা মদীনালৈ। </p>',
      ],
      23 => [
        'question' => 'প্ৰশ্ন নং ২৪- মদীনাত কিমান বছৰ আছিল?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6470.mp3',
        'answer' => '<p> উত্তৰ- ১০ বছৰ। </p>',
      ],
      24 => [
        'question' => 'প্ৰশ্ন নং ২৫- ইছলামী চৰীয়তৰ কোন কোনটো বিধান মদীনাত ফৰজ হৈছিল?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6490.mp3',
        'answer' => '<p> উত্তৰ- জাকাত, চিয়াম, হজ্জ, জিহাদ, আজান ইত্যাদি ইছলামী চৰীয়তৰ বিধান ফৰজ হৈছিল। </p>',
      ],
      25 => [
        'question' => 'প্ৰশ্ন নং ২৬- তেখেত চাল্লাল্লাহু আলাইহি অছাল্লামৰ গুৰুত্বপূৰ্ণ যুদ্ধসমূহ কি কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6520.mp3',
        'answer' => '<p> উত্তৰ- বদৰৰ যুদ্ধ।<br /> উহুদৰ যুদ্ধ।<br /> আহঝাব বা খন্দকৰ যুদ্ধ।<br /> মক্কা বিজয়ৰ যুদ্ধ। </p>',
      ],
      26 => [
        'question' => 'প্ৰশ্ন নং ২৭- কোৰআনৰ কোনটো আয়াত শেষত অৱতীৰ্ণ হৈছিল?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6580.mp3',
        'answer' => '<p> আল্লাহৰ এই বাণীঃ আৰু তোমালোকে সেই দিৱসৰ তাক্বৱা অৱলম্বন কৰা, যিদিনা তোমালোকক আল্লাহৰ পিনে ওভতাই লোৱা হ\'ব। তাৰ পিছত প্ৰত্যেক ব্যক্তিয়ে যি উপাৰ্জন কৰিছে, সেয়া সিহঁতক পৰিপূৰ্ণৰূপে প্ৰদান কৰা হ’ব আৰু সিহঁতক অন্যায় কৰা নহ’ব। <span class="c2">(ছুৰা আল-বাক্বাৰাহঃ ২৮১)</span> </p>',
      ],
      27 => [
        'question' => 'প্ৰশ্ন নং ২৮- নবী চাল্লাল্লাহু আলাইহি অছাল্লামে কেতিয়া মৃত্যুবৰণ কৰিছিল? আৰু সেই সময়ত তেখেতৰ বয়স কিমান আছিল?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6610.mp3',
        'answer' => '<p> উত্তৰ- ১১ হিজৰীৰ ৰবীউল আওৱাল মাহত তেখেতৰ মৃত্যু হৈছিল। মৃত্যুৰ সময়ত তেখেতৰ বয়স আছিল ৬৩ বছৰ। </p>',
      ],
      28 => [
        'question' => 'প্ৰশ্ন নং ২৯- নবী চাল্লাল্লাহু আলাইহি অছাল্লামৰ স্ত্ৰীসকলৰ নাম উল্লেখ কৰা?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6640.mp3',
        'answer' => '<p> উত্তৰ- ১- খাদীজাহ বিন্তে খুৱাইলিদ ৰাদ্বিয়াল্লাহু আনহা।<br /> ২- ছাওদাহ বিন্তে ঝামআহ ৰাদ্বিয়াল্লাহু আনহা।<br /> ৩- আঈশ্বা বিন্তে আবি বকৰ চিদ্দীক্ব -ৰাদ্বিয়াল্লাহু আনহা।<br /> ৪- হাফচাহ বিন্তে ওমৰ ৰাদ্বিয়াল্লাহু আনহা।<br /> ৫- ঝাইনাব বিন্তে খুঝাইমাহ ৰাদ্বিয়াল্লাহু আনহা।<br /> ৬- উম্মু ছালামাহ হিন্দ বিন্তে আবি উমায়্যাহ ৰাদ্বিয়াল্লাহু আনহা।<br /> ৭- উম্মু হাবীবাহ ৰামলাহ বিন্তে আবি ছুফিয়ান ৰাদ্বিয়াল্লাহু আনহা।<br /> ৮- জুৱাইৰিয়া বিন্তুল হাৰিছ ৰাদ্বিয়াল্লাহু আনহা।<br /> ৯- মাইমূনাহ বিন্তুল হাৰিছ ৰাদ্বিয়াল্লাহু আনহা।<br /> ১০- চাফিয়্যা বিন্তে হুয়্যি ৰাদ্বিয়াল্লাহু আনহা।<br /> ১১- ঝাইনাব বিন্তে জাহাশ্ব ৰাদ্বিয়াল্লাহু আনহা। </p>',
      ],
      29 => [
        'question' => 'প্ৰশ্ন নং ৩০- নবী চাল্লাল্লাহু আলাইহি অছাল্লামৰ সন্তান-সন্ততি কেইজন আছিল?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6760.mp3',
        'answer' => '<p> উত্তৰ- তিনিজন পুত্ৰ সন্তান আছিল<br /> আল-কাছিম, আৰু এই নামৰ দ্বাৰাই তেখেতে উপনাম গ্ৰহণ কৰিছিল।<br /> আব্দুল্লাহ।<br /> ইব্ৰাহীম।<br /> কন্যা সন্তান আছিল যেনে-<br /> ফাতিমা<br /> ৰুকাইয়্যা<br /> উম্মু কুলছুম<br /> ঝাইনাব<br /> ইব্ৰাহীমৰ বাহিৰে সকলো সন্তানেই আছিল খাদীজাহ ৰাদ্বিয়াল্লাহু আনহাৰ পৰা। তেখেতৰ সকলো সন্তানেই তেখেতৰ জীৱনকালতেই মৃত্যুবৰণ কৰিছে, কেৱল ফাতিমা ৰাদ্বিয়াল্লাহু আনহাৰ বাহিৰে। তেওঁ তেখেতৰ মৃত্যুৰ ছয় মাহ পিছত মৃত্যুবৰণ কৰিছে। </p>',
      ],
      30 => [
        'question' => 'প্ৰশ্ন নং ৩১- নবী চাল্লাল্লাহু আলাইহি অছাল্লামৰ কেইটামান শাৰীৰিক বৈশিষ্ট্য বৰ্ণনা কৰা?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6880.mp3',
        'answer' => '<p> উত্তৰ- নবী চাল্লাল্লাহু আলাইহি অছাল্লাম গড় উচ্চতা সম্পন্ন ব্যক্তি আছিল, বেছি চাপৰো নাছিল আৰু বেছি ওখও নাছিল। তেখেতৰ গাৰ ৰং ৰঙা মিশ্ৰিত শুভ্ৰ আছিল। তেখেতৰ ঘন দাড়ি আৰু প্ৰশস্ত চকু আছিল, লগতে তেখেত বহল মুখৰ অধিকাৰী আছিল। তেখেতৰ চুলিবোৰ আছিল অত্যন্ত ক\'লা। কান্ধ দুখন আছিল বহল, শৰীৰৰ পৰা সুখদায়ক গোন্ধ বিয়পিছিল, ইত্যাদি আৰু বহুতো সুন্দৰ সুন্দৰ শাৰীৰিক বৈশিষ্ট্য আছিল। </p>',
      ],
      31 => [
        'question' => 'প্ৰশ্ন নং ৩২- নবী চাল্লাল্লাহু আলাইহি অছাল্লামে তেখেতৰ উম্মতক কিহৰ ওপৰত এৰি থৈ গৈছে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6910.mp3',
        'answer' => '<p> উত্তৰ- তেখেতে নিজৰ উম্মতক আলোকিত দ্বীনৰ ওপৰত এৰি থৈ গৈছে, যাৰ ৰাতিও দিনৰ দৰে উজ্জ্বল। ইয়াৰ পৰা কেৱল ধ্বংসকাৰী ব্যক্তিহে বিপথগামী হ\'ব। এনেকুৱা কোনো কল্যাণ নাই যিটোৰ প্ৰতি তেখেতে দিশ-নিৰ্দেশনা দিয়া নাই আৰু এনেকুৱা কোনো বেয়া কৰ্ম নাই, যিটোৰ পৰা তেখেতে নিষেধ কৰা নাই। </p>',
      ],
    ],
    4 => [
      0 => [
        'question' => 'প্ৰশ্ন নং ১- ছুৰা আল-ফাতিহা পাঠ কৰা আৰু ইয়াৰ ব্যাখ্যা কৰা?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6960.mp3',
        'answer' => '<p> উত্তৰ- ছুৰা আল-ফাতিহা আৰু ইয়াৰ তাফছীৰঃ<br /> বিছমিল্লাহিৰ ৰহমানিৰ ৰাহীম। <span class="c2">(১)</span> {<span class="c2">(আৰম্ভ কৰিছোঁ)</span> পৰম কৰুণাময় পৰম দয়ালু আল্লাহৰ নামত।} আলহামদুলিল্লা-হি ৰাব্বিল আলামীন। <span class="c2">(২)</span> {সকলো ধৰণৰ হামদ <span class="c2">(প্ৰশংসা)</span> বিশ্বজগতৰ ৰব আল্লাহৰ বাবে।} আৰ-ৰহমানিৰ ৰাহীম। <span class="c2">(৩)</span> <span class="c4">{যিজন পৰম কৰুণাময়, পৰম দয়ালু।}</span> মা-লিকি ইয়াওমিদ্দীন। <span class="c2">(৪)</span> <span class="c4">{বিচাৰ দিৱসৰ মালিক।}</span> ইয়্যাকানা’বুদু ওৱা ইয়্যাকানাছতাঈন। <span class="c2">(৫)</span> <span class="c4">{আমি কেৱল তোমাৰেই ইবাদত কৰোঁ, আৰু তোমাৰ ওচৰতেই সহায় প্ৰাৰ্থনা কৰোঁ।}</span> ইহদিনাছ চিৰাত্বল মুস্তাক্বীম। <span class="c2">(৬)</span> <span class="c4">{আমাক সৰল পথৰ হিদায়ত দিয়া।}</span> চিৰাত্বল লাজীনা আনআমতা আলাইহিম, গাইৰিল মাগদ্বুবি আলাইহিম অলাদ্ব দ্বল্লীন। <span class="c2">(৭)</span> {তেওঁলোকৰ পথ, যিসকলক তুমি নিয়ামত <span class="c2">(অনুগ্ৰহ)</span> প্ৰদান কৰিছা, সিহঁতৰ নহয়, যিসকলৰ ওপৰত তোমাৰ ক্ৰোধ আপতিত হৈছে আৰু সিহঁতৰো নহয় যিসকল পথভ্ৰষ্ট হৈছে।} <span class="c2">(ছুৰা আল-ফাতিহাঃ ১-৭)</span><br /> তাফছীৰ<br /> ছুৰা আল-ফাতিহা <span class="c2">(আৰম্ভণি)</span> এই নামেৰে নামকৰণ কৰাৰ কাৰণ হৈছে, ইয়াৰ দ্বাৰাই আল্লাহৰ কিতাবৰ আৰম্ভণি হয়।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001001.mp3"></audio> 1- <span class="c2">(بِسْمِ اللَّهِ الرَّحْمَنِ الرَّحِيمِ)</span> অৰ্থাৎ মই আল্লাহৰ নামৰ বৰকতলৈ তেওঁৰ সহায় প্ৰাৰ্থনা কৰি তেওঁৰ নামৰ দ্বাৰা কোৰআন তিলাৱত আৰম্ভ কৰিলোঁ।<br /> <span class="c2">(الله)</span> অৰ্থাৎ সত্য উপাস্য, পৱিত্ৰ মহান আল্লাহৰ বাহিৰে আন কাৰো বাবে এই নাম প্ৰযোজ্য নহয়।<br /> <span class="c2">(الرَّحْمَن)</span> অৰ্থাৎ প্ৰশস্ত ৰহমতৰ অধিকাৰী, যি ৰহমতে প্ৰতিটো বস্তুকে পৰিবেষ্টন কৰি আছে।<br /> <span class="c2">(الرَّحِيم)</span> অৰ্থাৎ মুমিনসকলৰ প্ৰতি দয়ালু।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001002.mp3"></audio> ২- <span class="c2">(الْحَمْدُ لِلَّهِ رَبِّ الْعَالَمِينَ)</span> অৰ্থাৎ সকলো প্ৰকাৰৰ প্ৰশংসা তথা পৰিপূৰ্ণতা একমাত্ৰ আল্লাহৰ বাবে।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001003.mp3"></audio> ৩- <span class="c2">(الرَّحْمَنِ الرَّحِيمِ)</span> অৰ্থাৎ প্ৰশস্ত ৰহমতৰ অধিকাৰী, যি ৰহমতে সকলো বস্তুকে পৰিবেষ্টন কৰি আছে। লগতে এনেকুৱা ৰহমতৰো অধিকাৰী যিটো কেৱল মুমিনসকলে লাভ কৰিব।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001004.mp3"></audio> ৪- <span class="c2">(مَالِكِ يَوْمِ الدِّينِ)</span> অৰ্থাৎ কিয়ামত দিৱসৰ মালিক।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001005.mp3"></audio> ৫- <span class="c2">(إِيَّاكَ نَعْبُدُ وَإِيَّاكَ نَسْتَعِينُ)</span> অৰ্থাৎ আমি একমাত্ৰ তোমাৰেই ইবাদত কৰোঁ, আৰু একমাত্ৰ তোমাৰ ওচৰতেই সহায় প্ৰাৰ্থনা কৰোঁ।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001006.mp3"></audio> ৬- <span class="c2">(اهْدِنَا الصِّرَاطَ الْمُسْتَقِيمَ)</span> অৰ্থাৎ ইছলাম আৰু সঠিক পথৰ হিদায়ত দিয়া।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001007.mp3"></audio> ৭- <span class="c2">(صِرَاطَ الَّذِينَ أَنْعَمْتَ عَلَيْهِمْ غَيْرِ الْمَغْضُوبِ عَلَيْهِمْ وَلَا الضَّالِّينَ)</span> অৰ্থাৎ নবী আৰু তেওঁলোকৰ অনুসাৰী আল্লাহৰ নেক বান্দাসকলৰ পথ।ইয়াহুদী আৰু খৃষ্টানসকলৰ পথ নহয়।<br /> -এই ছুৰা পাঠ কৰাৰ পিছত আমীন কোৱা ছুন্নত। আমীনৰ অৰ্থ হৈছেঃ হে আল্লাহ! কবূল কৰা। </p>',
      ],
      1 => [
        'question' => 'প্ৰশ্ন নং ২- ছুৰা আজ-ঝালঝালাহ পাঠ কৰা আৰু ইয়াৰ ব্যাখ্যা কৰা?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/7130.mp3',
        'answer' => '<p> উত্তৰ- ছুৰা আজ-ঝালঝালাহ আৰু ইয়াৰ তাফছীৰঃ<br /> <span class="c2">(আৰম্ভ কৰিছোঁ)</span> পৰম কৰুণাময় পৰম দয়ালু আল্লাহৰ নামত।<br /> ইজা ঝুলঝিলাতিল আৰযু ঝিল ঝা-লাহা। <span class="c2">(১)</span> <span class="c4">{পৃথিৱী যেতিয়া প্ৰবল কম্পনত প্ৰকম্পিত হ’ব,}</span> ওৱা আখৰাজাতিল আৰযু আছক্বা-লাহা। <span class="c2">(২)</span> <span class="c4">{আৰু পৃথিৱীয়ে তাৰ ভিতৰত থকা বোজাবোৰ উলিয়াই দিব,}</span> অক্বা-লাল ইনছানু মা-লাহা। <span class="c2">(৩)</span> <span class="c4">{আৰু মানুহে ক’ব, ইয়াৰ কি হ’ল?}</span> ইয়াওমা ইজিন তুহাদ্দিছু আখবা-ৰাহা। <span class="c2">(৪)</span> <span class="c4">{সেইদিনা পৃথিৱীয়ে তাৰ বৃত্তান্ত বৰ্ণনা কৰিব,}</span> বি আন্না ৰাব্বাকা আওহা-লাহা। <span class="c2">(৫)</span> <span class="c4">{কাৰণ তোমাৰ প্ৰতিপালকে তাক নিৰ্দেশ দিছে,}</span> ইয়াওমা-ইজিঁ য়াচদুৰুন না-ছু আশ্বতা-তাল, লিউৰাও আ\'মালাহুম। <span class="c2">(৬)</span> <span class="c4">{সেইদিনা মানুহে ভিন্ ভিন্ দলত ওলাই আহিব যাতে সিহঁতক সিহঁতৰ কৃতকৰ্মবোৰ দেখুৱাব পৰা যায়,}</span> ফামাইঁ য়া\'মাল মিছক্বা-লা জাৰ্ৰাতিন খাইৰাইঁ য়াৰাহ। <span class="c2">(৭)</span> <span class="c4">{এতেকে যিয়ে অণু পৰিমাণ সৎকৰ্ম কৰিছে সেয়া সি দেখিবলৈ পাব।}</span> অমাইঁ য়া\'মাল মিছক্বা-লা জাৰ্ৰাতিন শ্বাৰ্ৰাইঁ য়াৰাহ। <span class="c2">(৮)</span> <span class="c4">{আৰু যিয়ে অণু পৰিমাণ অসৎকৰ্ম কৰিছে সেয়াও সি দেখিবলৈ পাব।}</span> <span class="c2">(ছুৰা আজ-ঝালঝালাহঃ ১-৮)</span><br /> তাফছীৰ<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099001.mp3"></audio> ১- <span class="c2">(إِذَا زُلْزِلَتِ الْأَرْضُ زِلْزَالَهَا)</span> যেতিয়া পৃথিৱী প্ৰবলভাৱে প্ৰকম্পিত হ\'ব, আৰু কিয়ামতৰ দিনা তাৰ যাৱতীয় সংবাদ বৰ্ণনা কৰিব।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099002.mp3"></audio> ২- <span class="c2">(وَأَخْرَجَتِ الْأَرْضُ أَثْقَالَهَا)</span> আৰু পৃথিৱীয়ে তাৰ গৰ্ভত থকা মৃত ব্যক্তি আৰু অন্যান্য বস্তুবোৰ উলিয়াই দিব।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099003.mp3"></audio> ৩- <span class="c2">(وَقَالَ الْإِنْسَانُ مَا لَهَا)</span> আৰু মানুহে হয়ৰান পৰেচান হৈ ক\'বঃ পৃথিৱীৰ আকৌ কি হ\'ল, কিয় ইমান প্ৰবলভাৱে কঁপি আছে?<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099004.mp3"></audio> ৪- <span class="c2">(يَوْمَئِذٍ تُحَدِّثُ أَخْبَارَهَا)</span> সেই ভীষণ দিৱসত পৃথিৱীয়ে কৈ দিব যে, তাৰ ওপৰত <span class="c2">(মানুহে বসবাস কৰি)</span> কি কি ভাল-বেয়া কৰ্ম কৰিছিল।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099005.mp3"></audio> ৫- <span class="c2">(بِأَنَّ رَبَّكَ أَوْحَى لَهَا)</span> কাৰণ আল্লাহেই ভালকৈ জানে আৰু তেৱেঁই ইয়াৰ নিৰ্দেশ দিছে।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099006.mp3"></audio> ৬- <span class="c2">(يَوْمَئِذٍ يَصْدُرُ النَّاسُ أَشْتَاتًا لِيُرَوْا أَعْمَالَهُمْ)</span> সেই ভীষণ দিনটোত যেতিয়া পৃথিৱীক বাৰে বাৰে প্ৰবলভাৱে কপোৱা হ\'ব। মানুহে হিচাপ- নিকাচৰ স্থানৰ পৰা দলবদ্ধভাৱে ওলাই আহিব। যাতে পৃথিৱীত কৰা নিজৰ নিজৰ আমলসমূহ প্ৰত্যক্ষ কৰিব পাৰে।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099007.mp3"></audio> ৭- <span class="c2">(فَمَنْ يَعْمَلْ مِثْقَالَ ذَرَّةٍ خَيْرًا يَرَهُ)</span> কোনোবাই যদি সৰু পৰুৱাৰ সমানো নেক আমল কৰিছে তেন্তে তেওঁ সেইটো সেইদিনা নিজৰ সন্মুখত দেখা পাব।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099008.mp3"></audio> ৮- <span class="c2">(وَمَنْ يَعْمَلْ مِثْقَالَ ذَرَّةٍ شَرًّا يَرَهُ)</span> আনহাতে যদি কোনোবাই সেই পৰিমাণ বেয়া কৰ্ম কৰিছে তেন্তে সিও সেইটো সেইদিনা নিজৰ সন্মুখত দেখা পাব। </p>',
      ],
      2 => [
        'question' => 'প্ৰশ্ন নং ৩- ছুৰা আল-আদিয়াত পাঠ কৰা আৰু ইয়াৰ ব্যাখ্যা কৰা?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/7270.mp3',
        'answer' => '<p> উত্তৰ- ছুৰা আল-আদিয়াত আৰু ইয়াৰ তাফছীৰঃ<br /> <span class="c2">(আৰম্ভ কৰিছোঁ)</span> পৰম কৰুণাময় পৰম দয়ালু আল্লাহৰ নামত।<br /> অল আ-দিয়া-তি দ্বাবহা। <span class="c2">(১)</span> <span class="c4">{শপত ঊৰ্ধ্বশ্বাসত দৌৰি যোৱা ঘোঁৰাবোৰৰ,}</span> ফাল মূৰিয়া-তি ক্বাদহা। <span class="c2">(২)</span> <span class="c4">{যিবোৰে ক্ষুৰৰ আঘাতত ফিৰিঙতি উৰুৱায়,}</span> ফাল মুগীৰা-তি ছুবহা। <span class="c2">(৩)</span> <span class="c4">{যিবোৰে প্ৰভাতকালত আক্ৰমণ কৰে,}</span> ফাআছাৰনা বিহি নাক্বআ। <span class="c2">(৪)</span> <span class="c4">{ফলত সিহঁতে ইয়াৰ দ্বাৰা ধূলি উৰুৱায়;}</span> ফাৱাছাত্বনা বিহি জামআ। <span class="c2">(৫)</span> <span class="c4">{আৰু ইয়াৰ দ্বাৰা শত্ৰু দলৰ অভ্যন্তৰত সোমাই পৰে।}</span> ইন্নাল ইংছা-না লিৰাব্বিহি লাকানূদ। <span class="c2">(৬)</span> <span class="c4">{নিশ্চয় মানুহ তাৰ প্ৰতিপালকৰ প্ৰতি অতিকৈ অকৃতজ্ঞ,}</span> অইন্নাহু আলা জালিকা লাশ্বাহীদ। <span class="c2">(৭)</span> <span class="c4">{নিশ্চয় সি এই বিষয়ে সাক্ষী,}</span> অইন্নাহু লিহুব্বিল খাইৰি লাশ্বাদীদ। <span class="c2">(৮)</span> <span class="c4">{আৰু নিশ্চয় সি ধন-সম্পদৰ লোভত প্ৰবল।}</span> আফালা য়া\'লামু ইজা বু\'ছিৰা মা ফিল কুবূৰ। <span class="c2">(৯)</span> <span class="c4">{সি নাজানে নেকি যে, কবৰত যি আছে সেয়া উত্থিত হ’ব,}</span> অহুচ্ছিলা মা ফিচ্ছুদূৰ। <span class="c2">(১০)</span> {আৰু অন্তৰত যি আছে সেয়া প্ৰকাশিত হ’ব?) ইন্না ৰাব্বাহুম বিহিম ইয়াওমা ইজিল লাখাবীৰ। <span class="c2">(১১)</span> <span class="c4">{নিশ্চয় সিহঁতৰ প্ৰতিপালক সেইদিনা সিহঁতৰ অৱস্থা সম্পৰ্কে সবিশেষ অৱহিত।}</span> <span class="c2">(ছুৰা আল-আদিয়াতঃ ১-১১)</span><br /> তাফছীৰ<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100001.mp3"></audio> ১- <span class="c2">(وَالْعَادِيَاتِ ضَبْحًا)</span> আল্লাহ তাআলাই সেই ঘোঁৰাৰ শপত কৰিছে, যাৰ তীব্ৰ দৌৰৰ কাৰণে তাৰ উশাহৰ শব্দ শুনা যায়।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100002.mp3"></audio> ২- <span class="c2">(فَالْمُورِيَاتِ قَدْحًا)</span> আৰু সেই ঘোঁৰাৰ শপত কৰিছে, যি ঘোঁৰাই শিলৰ ওপৰত দৌৰাৰ ফলত তাৰ ক্ষুৰৰ আঘাতত ফিৰিঙতি ওলায়।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100003.mp3"></audio> ৩- <span class="c2">(فَالْمُغِيرَاتِ صُبْحًا)</span> আৰু সেইবোৰ ঘোঁৰাৰ শপত কৰিছে, যিবোৰে প্ৰভাতকালত শত্ৰুৰ ওপৰত আক্ৰমণ কৰে।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100004.mp3"></audio> ৪- <span class="c2">(فَأَثَرْنَ بِهِ نَقْعًا)</span> আকৌ যিবোৰে দৌৰৰ জৰিয়তে ধূলি উৰুৱায়।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100005.mp3"></audio> ৫-<span class="c2">(فَوَسَطْنَ بِهِ جَمْعًا)</span> আকৌ যিবোৰে আৰোহীৰ সৈতে শত্ৰু দলৰ অভ্যন্তৰত সোমাই যায়।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100006.mp3"></audio> ৬- <span class="c2">(إِنَّ الْإِنْسَانَ لِرَبِّهِ لَكَنُودٌ)</span> বাস্তৱত মানুহে সেই পূণ্য কৰ্মৰ পৰা বহু দূৰত অৱস্থান কৰে যিটো তাৰ প্ৰতিপালকে তাৰ পৰা বিচাৰে।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100007.mp3"></audio> ৭- <span class="c2">(وَإِنَّهُ عَلَى ذَلِكَ لَشَهِيدٌ)</span> আৰু সি পূণ্যৰ কামৰ পৰা পিছুৱাই থকাৰ বাবে সি নিজেই তাৰ সাক্ষী। এয়া ইমান স্পষ্ট কথা যে ইয়াক অস্বীকাৰ কৰিব নোৱাৰি।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100008.mp3"></audio> ৮- <span class="c2">(وَإِنَّهُ لِحُبِّ الْخَيْرِ لَشَدِيدٌ)</span> আৰু সি ধনৰ প্ৰবল লোভত পৰিছে, এই বিষয়ে সি কৃপণালিও কৰে।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100009.mp3"></audio> ৯- <span class="c2">(أَفَلَا يَعْلَمُ إِذَا بُعْثِرَ مَا فِي الْقُبُورِ)</span> পাৰ্থিৱ জীৱনৰ প্ৰৱঞ্চনাত পৰা ব্যক্তিয়ে নাজানে নেকি যে, যেতিয়া আল্লাহে কবৰত থকা মৃতসকলক জীৱিত কৰিব আৰু তেওঁলোকক হিচাপ- নিকাচ আৰু পৰিণামৰ বাবে ভূমিৰ পৰা উত্থিত কৰিব। কিন্তু বিষয়টো তেনেকুৱা নহয় যিদৰে সিহঁতে ভাবিছে?<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100010.mp3"></audio> ১০- <span class="c2">(وَحُصِّلَ مَا فِي الصُّدُورِ)</span> আৰু অন্তৰৰ মাজত যি নিয়ত আৰু আস্থা আছে তাক প্ৰকাশ কৰা হ\'ব,<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100011.mp3"></audio> ১১- <span class="c2">(إِنَّ رَبَّهُمْ بِهِمْ يَوْمَئِذٍ لَخَبِيرٌ)</span> নিশ্চয় সিহঁতৰ প্ৰতিপালক সেই দিৱসৰ অৱস্থা সম্পৰ্কে সম্পূৰ্ণ অৱহিত। আল্লাহৰ পৰা বান্দাৰ কোনো কথাই লুকাই নাথাকিব আৰু আল্লাহে সিহঁতক সেইবোৰৰ প্ৰতিদান দিব। </p>',
      ],
      3 => [
        'question' => 'প্ৰশ্ন নং ৪- ছুৰা আল-ক্বাৰিআহ পাঠ কৰা আৰু ইয়াৰ ব্যাখ্যা কৰা?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/7450.mp3',
        'answer' => '<p> উত্তৰ- ছুৰা আল-ক্বাৰিআহ আৰু ইয়াৰ তাফছীৰঃ<br /> <span class="c2">(আৰম্ভ কৰিছোঁ)</span> পৰম কৰুণাময় পৰম দয়ালু আল্লাহৰ নামত।<br /> আল-ক্বাৰিআহ। <span class="c2">(১)</span> <span class="c4">{ভীতিপ্ৰদ মহা বিপদ।}</span> মাল ক্বাৰিআহ। <span class="c2">(২)</span> <span class="c4">{ভীতিপ্ৰদ মহা বিপদ কি।}</span> অমা আদৰা-কা মাল ক্বাৰিআহ। <span class="c2">(৩)</span> <span class="c4">{ভীতিপ্ৰদ মহা বিপদ সম্পৰ্কে তুমি কি জানা?}</span> ইয়াওমা য়াকূনুন না-ছু কালফাৰাশ্বিল মাবছূছ। <span class="c2">(৪)</span> <span class="c4">{সেইদিনা মানুহ হ’ব বিক্ষিপ্ত কীট-পতঙ্গৰ দৰে।}</span> অতাকূনুল জিবালু কাল ইহনিল মাংফূশ্ব। <span class="c2">(৫)</span> <span class="c4">{আৰু পৰ্বতসমূহ হ’ব ধূনা ৰঙীন ঊণৰ দৰে।}</span> ফা আম্মা মাং ছাকুলাত মাৱাঝীনুহ। <span class="c2">(৬)</span> <span class="c4">{এতেকে যাৰ তৰ্জুসমূহ গধুৰ হ’ব,}</span> ফাহুৱা ফী ঈশ্বাতিৰ ৰা-দ্বিয়াহ। <span class="c2">(৭)</span> <span class="c4">{তেওঁ থাকিব সন্তোষজনক জীৱনত;}</span> ওৱা আম্মা মান খাফ্ফাত মাৱাঝীনূহ। <span class="c2">(৮)</span> <span class="c4">{আৰু যাৰ তৰ্জুসমূহ পাতল হ’ব,}</span> ফা উম্মুহূ হা-ৱিয়াহ। <span class="c2">(৯)</span> <span class="c4">{তাৰ ঠিকনা হ’ব ‘হা-ৱিয়াহ’।}</span> অমা আদৰা-কা মা-হিয়াহ। <span class="c2">(১০)</span> <span class="c4">{আৰু তুমি কি জানা সেইটোনো কি?}</span> না-ৰুন হামিয়াহ। <span class="c2">(১১)</span> <span class="c4">{এইটো হৈছে এটা অত্যন্ত উত্তপ্ত অগ্নিকুণ্ড।}</span> <span class="c2">(ছুৰা আল-ক্বাৰিআহঃ ১-১১)</span><br /> তাফছীৰ<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101001.mp3"></audio> ১- <span class="c2">(الْقَارِعَةُ)</span> সেই ভয়াৱহ সময়, যিয়ে মানুহৰ অন্তৰক কম্পিত কৰিব।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101002.mp3"></audio> ২- <span class="c2">(مَا الْقَارِعَةُ)</span> মানুহৰ অন্তৰ কপোৱা সেই ভয়াৱহ সময়টোনো কি?<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101003.mp3"></audio> ৩- <span class="c2">(وَمَا أَدْرَاكَ مَا الْقَارِعَةُ)</span> হে ৰাছুল আপোনাক কিহে জনাব যে অন্তৰ কপোৱা সেই সময়টোনো কি? নিশ্চিতৰূপে সেয়া হৈছে ক্বিয়ামত দিৱস।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101004.mp3"></audio> ৪- <span class="c2">(يَوْمَ يَكُونُ النَّاسُ كَالْفَرَاشِ الْمَبْثُوثِ)</span> যিদিনাখন অন্তৰবোৰ ভীতিপ্ৰদ হ\'ব, সেইদিনা মানুহ বিক্ষিপ্ত কীট- পতঙ্গৰ দৰে হ\'ব।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101005.mp3"></audio> ৫- <span class="c2">(وَتَكُونُ الْجِبَالُ كَالْعِهْنِ الْمَنْفُوشِ)</span> আৰু পৰ্বতবোৰ ধূনা ঊণৰ দৰে পাতল আৰু তীব্ৰ গতিত চলিবলৈ ধৰিব।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101006.mp3"></audio> ৬- <span class="c2">(فَأَمَّا مَنْ ثَقُلَتْ مَوَازِينُهُ)</span> এতেকে যাৰ ভাল কৰ্ম, বেয়া কৰ্মতকৈ অধিক হ\'ব।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101007.mp3"></audio> ৭- <span class="c2">(فَهُوَ فِي عِيشَةٍ رَاضِيَةٍ)</span> তেওঁ জান্নাতত সন্তুষ্টজনক আনন্দ লাভ কৰিব।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101008.mp3"></audio> ৮- <span class="c2">(وَأَمَّا مَنْ خَفَّتْ مَوَازِينُهُ)</span> আৰু যাৰ বেয়া কৰ্ম, ভাল কৰ্মতকৈ অধিক হ\'ব।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101009.mp3"></audio> ৯- <span class="c2">(فَأُمُّهُ هَاوِيَةٌ)</span> ফলত ক্বিয়ামতৰ দিনা তাৰ ঠিকনা তথা বাসস্থান হ\'ব জাহান্নাম।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101010.mp3"></audio> ১০- <span class="c2">(وَمَا أَدْرَاكَ مَا هِيَهْ)</span> হে ৰাছুল, আপুনি কি জানে সেইটোনো কি?<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101011.mp3"></audio> ১১- <span class="c2">(نَارٌ حَامِيَةٌ)</span> সেয়া হৈছে অত্যন্ত উত্তপ্ত অগ্নিকুণ্ড। </p>',
      ],
      4 => [
        'question' => 'প্ৰশ্ন নং ৫- ছুৰা আত-তাকাছুৰ পাঠ কৰা আৰু ইয়াৰ ব্যাখ্যা কৰা?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/7610.mp3',
        'answer' => '<p> উত্তৰ- ছুৰা আত-তাকাছুৰ আৰু ইয়াৰ তাফছীৰঃ<br /> <span class="c2">(আৰম্ভ কৰিছোঁ)</span> পৰম কৰুণাময় পৰম দয়ালু আল্লাহৰ নামত।<br /> আলহাকুমুত তাকাছুৰ। <span class="c2">(১)</span> <span class="c4">{প্ৰাচুৰ্যৰ প্ৰতিযোগিতায় তোমালোকক অমনোযোগী কৰি ৰাখিছে।}</span> হাত্তা ঝুৰতুমুল মাক্বা-বিৰ। <span class="c2">(২)</span> <span class="c4">{যেতিয়ালৈকে তোমালোকে কবৰত উপনীত নোহোৱা।}</span> কাল্লা ছাওফা তা\'লামূন। <span class="c2">(৩)</span> <span class="c4">{কেতিয়াও নহয়, অতি সোনকালে তোমালোকে জানিবলৈ পাবা।}</span> ছুম্মা কাল্লা ছাওফা তা\'লামূন। <span class="c2">(৪)</span> <span class="c4">{আকৌ কেতিয়াও নহয়, অতি সোনকালে তোমালোকে জানিবলৈ পাবা।}</span> কাল্লা লাও তা\'লামূনা ইলমাল য়াক্বীন। <span class="c2">(৫)</span> <span class="c4">{কেতিয়াও নহয়, যদি তোমালোকে নিশ্চিতভাৱে জানিলাহেঁতেন।}</span> লাতাৰাওন্নাল জাহীম। <span class="c2">(৬)</span> {নিশ্চয় তোমালোকে জাহীম <span class="c2">(জাহান্নাম)</span> দেখিবলৈ পাবা।} ছুম্মা লাতাৰাওন্নাহা আইনাল য়াক্বীন। <span class="c2">(৭)</span> <span class="c4">{আকৌ, নিশ্চয় তোমালোকে ইয়াক পতিয়ন যোৱাকৈ দেখিবা।}</span> ছুম্মা লাতুছ আলুন্না ইয়াওমা ইজিন আনিন নায়ীম। <span class="c2">(৮)</span> <span class="c4">{তাৰ পিছত সেইদিনা অৱশ্যই তোমালোকক নিয়ামত সম্পৰ্কে প্ৰশ্ন কৰা হ’ব।}</span> <span class="c2">(ছুৰা আত-তাকাছুৰঃ ১-৮)</span><br /> তাফছীৰ<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102001.mp3"></audio> ১- <span class="c2">(أَلْهَاكُمُ التَّكَاثُرُ)</span> হে মানৱ, তোমালোকৰ ধন, সন্তানৰ অহংকাৰে তোমালোকক আল্লাহৰ ইবাদতৰ পৰা অমনোযোগী কৰি তুলিছে।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102002.mp3"></audio> ২- <span class="c2">(حَتَّى زُرْتُمُ الْمَقَابِرَ)</span> তোমালোকৰ মৃত্যু নহালৈকে তথা তোমালোক কবৰত উপনীত নোহোৱালৈকে <span class="c2">(তোমালোকৰ এই অমনোযোগিতা)</span> থাকিয়ে যাব।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102003.mp3"></audio> ৩- <span class="c2">(كَلَّا سَوْفَ تَعْلَمُونَ)</span> ধন, সন্তানৰ গৌৰৱৰ কাৰণে আল্লাহৰ ইবাদতৰ পৰা তোমালোকে অমনোযোগী হ\'ব নালাগিছিল। তোমালোকে এই অমনোযোগিতাৰ পৰিণাম নিশ্চয় জানিবলৈ পাবা।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102004.mp3"></audio> ৪- <span class="c2">(ثُمَّ كَلَّا سَوْفَ تَعْلَمُونَ)</span> তাৰ পিছত তুমি অতি সোনকালে ইয়াৰ পৰিণামৰ বিষয়ে অৱগত হ\'বা।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102005.mp3"></audio> ৫- <span class="c2">(كَلَّا لَوْ تَعْلَمُونَ عِلْمَ الْيَقِينِ)</span> সত্য কথাটো হৈছে যদি তোমালোকে বিশ্বাস কৰিলাহেঁতেন যে, তোমালোকে পুনৰ জীৱিত হৈ আল্লাহৰ আগত থিয় হ\'ব লাগিব। আৰু তেওঁ তোমালোকক তোমালোকৰ কৰ্মৰ পৰিণাম দিব। তেন্তে তোমালোকে ধন, সন্তানৰ অহংকাৰ কৰি আল্লাহৰ প্ৰতি অমনোযোগী নহ\'লাহেঁতেন।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102006.mp3"></audio> ৬- <span class="c2">(لَتَرَوُنَّ الْجَحِيمَ)</span> আল্লাহৰ শপত! তোমালোকে ক্বিয়ামতৰ দিনা নিশ্চয় জাহান্নাম দেখিবলৈ পাবা।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102007.mp3"></audio> ৭- <span class="c2">(ثُمَّ لَتَرَوُنَّهَا عَيْنَ الْيَقِينِ)</span> আকৌ, তোমালোকে ইয়াক নিশ্চিতৰূপে দেখিবলৈ পাবা। ইয়াত কোনো সন্দেহ নাই।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102008.mp3"></audio> ৮- <span class="c2">(ثُمَّ لَتُسْأَلُنَّ يَوْمَئِذٍ عَنِ النَّعِيمِ)</span> তাৰ পিছত সিদিনাখন আল্লাহে তোমালোকক স্বাস্থ্য আৰু ধন- সম্পত্তি আদি অনুগ্ৰহসমূহৰ বিষয়ে নিশ্চয় সোধ-পোচ কৰিব, যিবোৰ তেওঁ তোমালোকক দান কৰিছিল। </p>',
      ],
      5 => [
        'question' => 'প্ৰশ্ন নং ৬- ছুৰা আল-আচৰ পাঠ কৰা আৰু ইয়াৰ ব্যাখ্যা কৰা?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/7750.mp3',
        'answer' => '<p> উত্তৰ- ছুৰা আল-আচৰ আৰু ইয়াৰ তাফছীৰঃ<br /> <span class="c2">(আৰম্ভ কৰিছোঁ)</span> পৰম কৰুণাময় পৰম দয়ালু আল্লাহৰ নামত।<br /> অল আচ্ৰ। <span class="c2">(১)</span> <span class="c4">{সময়ৰ শপত,}</span> ইন্নাল ইংছানা লাফী খুছ্ৰ। <span class="c2">(২)</span> <span class="c4">{নিশ্চয় মানুহ ক্ষতিগ্ৰস্থতাত নিপতিত,}</span> ইল্লাল লাজীনা আ-মানু ৱাআমিলুচ চা-লিহা-তি অতাৱা চাওবিল হাক্কি অতাৱা চাওবিচ চাবৰি। <span class="c2">(৩)</span> {কিন্তু তেওঁলোকৰ বাহিৰে, যিসকলে ঈমান আনিছে আৰু সৎকৰ্ম কৰিছে লগতে <span class="c2">(যিসকলে)</span> পৰস্পৰক সত্যৰ উপদেশ দিয়ে আৰু ধৈৰ্য্য ধাৰণ কৰিবলৈ উৎসাহ দিয়ে।} <span class="c2">(ছুৰা আল-আচৰঃ ১-৩)</span><br /> তাফছীৰ<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/103001.mp3"></audio> ১- <span class="c2">(وَالْعَصْرِ)</span> আল্লাহ তাআলাই সময়ৰ শপত কৰিছে।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/103002.mp3"></audio> ২- <span class="c2">(إِنَّ الْإِنْسَانَ لَفِي خُسْرٍ)</span> নিশ্চয় মানুহ ক্ষতি আৰু ধ্বংসৰ পথত লিপ্ত।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/103003.mp3"></audio> ৩- <span class="c2">(إِلَّا الَّذِينَ آمَنُوا وَعَمِلُوا الصَّالِحَاتِ وَتَوَاصَوْا بِالْحَقِّ وَتَوَاصَوْا بِالصَّبْرِ)</span> কিন্তু যিসকলে আল্লাহ আৰু ৰাছুলৰ প্ৰতি ঈমান আনিছে আৰু সৎকৰ্ম কৰিছে আৰু এজনে আনজনক সত্যৰ উপদেশ দিয়ে আৰু পৰস্পৰক সত্য পথৰ প্ৰতি ধৈৰ্য্য ধাৰণ কৰিবলৈ উপদেশ দিয়ে। এতেকে এই বৈশিষ্ট্যৰ গৰাকীয়ে পৃথিৱী আৰু পৰকালৰ জীৱনত সফলতা লাভ কৰিব। </p>',
      ],
      6 => [
        'question' => 'প্ৰশ্ন নং ৭- ছুৰা আল-হুমাঝাহ পাঠ কৰা আৰু ইয়াৰ ব্যাখ্যা কৰা?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/7830.mp3',
        'answer' => '<p> উত্তৰ- ছুৰা আল-হুমাঝাহ আৰু ইয়াৰ তাফছীৰঃ<br /> <span class="c2">(আৰম্ভ কৰিছোঁ)</span> পৰম কৰুণাময় পৰম দয়ালু আল্লাহৰ নামত।<br /> অয়লুল্লিকুল্লি হুমাঝাতিল লুমাঝাহ। <span class="c2">(১)</span> <span class="c4">{দুৰ্ভোগ প্ৰত্যেক সেই ব্যক্তিৰ বাবে যিয়ে সন্মুখত আৰু অনুপস্থিতিত পৰনিন্দা কৰে।}</span> আল্লাজী জামাআ মালাওঁ ৱাআদ্দাদাহ। <span class="c2">(২)</span> <span class="c4">{যিয়ে সম্পদ জমা কৰে আৰু বাৰে বাৰে গণনা কৰে।}</span> য়াহছাবু আন্না মা-লাহু আখলাদাহ। <span class="c2">(৩)</span> <span class="c4">{সি ধাৰণা কৰে যে, তাৰ সম্পদে তাক চিৰজীৱি কৰি ৰাখিব।}</span> কাল্লা লায়ুমবাজান্না ফিল হুত্বামাহ। <span class="c2">(৪)</span> <span class="c4">{কেতিয়াও নহয়, নিশ্চয় সি হুতামাত নিক্ষিপ্ত হ’ব।}</span> অমা আদৰা-কা মাল হুত্বামাহ। <span class="c2">(৫)</span> <span class="c4">{আৰু তুমি জানানে, হুতামা কি?}</span> না-ৰুল্লা-হিল মূ-ক্বাদাহ। <span class="c2">(৬)</span> <span class="c4">{ই হৈছে আল্লাহৰ প্ৰজ্বলিত জুই।}</span> আল-লাতী তাত্তালিউ আলাল আফ ইদাহ। <span class="c2">(৭)</span> <span class="c4">{যিয়ে হৃদপিণ্ডক গ্ৰাস কৰিব।}</span> ইন্নাহা আলাইহিম মু\'চাদাহ। <span class="c2">(৮)</span> <span class="c4">{নিশ্চয় ই সিহঁতক আৱদ্ধ কৰি ৰাখিব।}</span> ফী আমাদিম মুমাদ্দাদাহ। <span class="c2">(৯)</span> <span class="c4">{ওখ ওখ স্তম্ভসমূহত।}</span> <span class="c2">(ছুৰা আল-হুমাঝাহঃ ১-৯)</span><br /> তাফছীৰ<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104001.mp3"></audio> ১- <span class="c2">(وَيْلٌ لِكُلِّ هُمَزَةٍ لُمَزَةٍ)</span> বিনাশ আৰু কঠোৰ শাস্তি সেইসকল লোকৰ বাবে, যিসকলে মানুহৰ বহুত পৰিমাণে পৰচৰ্চা কৰে আৰু বেয়া ব্যৱহাৰ কৰি ফুৰে।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104002.mp3"></audio> ২- <span class="c2">(الَّذِي جَمَعَ مَالًا وَعَدَّدَهُ)</span> যাৰ একমাত্ৰ উদ্দেশ্য হৈছে ধন জমা কৰা আৰু সেয়া বাৰে বাৰে গণনা কৰি ৰখা। ইয়াৰ বাহিৰে তাৰ আৰু আন কোনো উদ্দেশ্য নাই।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104003.mp3"></audio> ৩- <span class="c2">(يَحْسَبُ أَنَّ مَالَهُ أَخْلَدَهُ)</span> সি ভাবে যে, তাৰ ধন-সম্পদ, যিবোৰ সি জমা কৰিছে, সেইবোৰে তাক মৃত্যুৰ পৰা বচাব আৰু সি পৃথিৱীত অমৰ হৈ থাকিব।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104004.mp3"></audio> ৪- <span class="c2">(كَلَّا لَيُنْبَذَنَّ فِي الْحُطَمَةِ)</span> বিষয়টো তেনেকুৱা নহয় যিদৰে এই মূৰ্খই ভাবিছে। নিশ্চয় তাক জাহান্নামৰ জুইত নিক্ষেপ কৰা হ\'ব। যি জুয়ে তাৰ মাজত নিক্ষেপ কৰা সকলো বস্তুকে ধূলি কণাত পৰিণত কৰে।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104005.mp3"></audio> ৫- <span class="c2">(وَمَا أَدْرَاكَ مَا الْحُطَمَةُ)</span> হে ৰাছুল, আপোনাক কিহে জনাব যে, সেই অগ্নি কি?<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104006.mp3"></audio> ৬- <span class="c2">(نَارُ اللَّهِ الْمُوقَدَةُ)</span> সেয়া হৈছে আল্লাহৰ অতি উত্তপ্ত অগ্নি।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104007.mp3"></audio> ৭- <span class="c2">(الَّتِي تَطَّلِعُ عَلَى الْأَفْئِدَةِ)</span> যিয়ে মানুহৰ শৰীৰ অতিক্ৰম কৰি তাৰ অন্তৰলৈ ঢুকি পাব।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104008.mp3"></audio> ৮- <span class="c2">(إِنَّهَا عَلَيْهِمْ مُؤْصَدَةٌ)</span> ইয়াৰ ভিতৰত সিহঁতক বন্ধ কৰি শাস্তি দিয়া হ\'ব।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104009.mp3"></audio> ৯- <span class="c2">(فِي عَمَدٍ مُمَدَّدَةٍ)</span> দীঘল দীঘল স্তম্ভৰ সৈতে, যাতে ওলাব নোৱাৰে। </p>',
      ],
      7 => [
        'question' => 'প্ৰশ্ন নং ৮- ছুৰা আল-ফীল পাঠ কৰা আৰু ইয়াৰ ব্যাখ্যা কৰা?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/7970.mp3',
        'answer' => '<p> উত্তৰ- ছুৰা আল-ফীল আৰু ইয়াৰ তাফছীৰঃ<br /> <span class="c2">(আৰম্ভ কৰিছোঁ)</span> পৰম কৰুণাময় পৰম দয়ালু আল্লাহৰ নামত।<br /> আলাম তাৰা কাইফা ফাআলা ৰাব্বুকা বিআচহা-বিল ফীল। <span class="c2">(১)</span> <span class="c4">{তুমি দেখা নাইনে, তোমাৰ প্ৰতিপালকে হাতীৰ অধিপতিসকলৰ লগত কি কৰিছিল?}</span> আলাম য়াজআল কাইদাহুম ফী তাদ্বলীল। <span class="c2">(২)</span> <span class="c4">{তেওঁ সিহঁতৰ ষঢ়যন্ত্ৰ ব্যৰ্থতাত পৰ্যবসিত কৰা নাইনে?}</span> ৱাআৰছালা আলাইহিম ত্বইৰান আবা-বীল। <span class="c2">(৩)</span> <span class="c4">{আৰু সিহঁতৰ বিৰুদ্ধে তেওঁ জাকে জাকে চৰাই পঠিওৱা নাছিলনে?}</span> তাৰমীহিম বিহিজা-ৰাতিম মিন ছিজ্জীল। <span class="c2">(৪)</span> <span class="c4">{যিসকলে সিহঁতৰ ওপৰত পকা টান মাটিৰ শিলগুটি নিক্ষেপ কৰিছিল।}</span> ফাজাআলাহুম কাআচফিম মা\'কূল। <span class="c2">(৫)</span> <span class="c4">{ফলত তেওঁ সিহঁতক ভক্ষিত তৃণ-সদৃশ কৰিছিল।}</span> <span class="c2">(ছুৰা আল-ফীলঃ ১-৫)</span><br /> তাফছীৰ<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105001.mp3"></audio> ১- <span class="c2">(أَلَمْ تَرَ كَيْفَ فَعَلَ رَبُّكَ بِأَصْحَابِ الْفِيلِ)</span> হে ৰাছুল, আপুনি নাজানে নেকি আপোনাৰ প্ৰতিপালকে আব্ৰাহা আৰু তাৰ হাতী অধিপতি সৈন্যৰ সৈতে কি কৰিছিল, যেতিয়া সিহঁতে কা\'বা ঘৰ ভাঙিবলৈ সংকল্প কৰিছিল।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105002.mp3"></audio> ২- <span class="c2">(أَلَمْ يَجْعَلْ كَيْدَهُمْ فِي تَضْلِيلٍ)</span> আল্লাহ তাআলাই সিহঁতৰ কা\'বা ধ্বংস কৰাৰ চক্ৰান্তক বিফল কৰি দিছিল। ফলত সিহঁতে মানুহক কা\'বাৰ পৰা বিমুখ কৰাৰ যি সংকল্প লৈছিল, তাত সিহঁতে সফলতা পোৱা নাছিল আৰু নিৰাশ হৈ উভতিছিল।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105003.mp3"></audio> ৩- <span class="c2">(وَأَرْسَلَ عَلَيْهِمْ طَيْرًا أَبَابِيلَ)</span> আৰু সিহঁতৰ প্ৰতি জাকে জাকে চৰাই প্ৰেৰণ কৰিছিল।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105004.mp3"></audio> ৪- <span class="c2">(تَرْمِيهِمْ بِحِجَارَةٍ مِنْ سِجِّيلٍ)</span> যিবোৰে সিহঁতৰ ওপৰত পকা টান মাটিৰ শিলগুটি নিক্ষেপ কৰিছিল।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105005.mp3"></audio> ৫- <span class="c2">(فَجَعَلَهُمْ كَعَصْفٍ مَأْكُولٍ)</span> ফলত সিহঁতক সেই ভক্ষিত তৃণ সদৃশ কৰিছিল, যিবোৰ জন্তুয়ে খায় আৰু ভৰিৰে মোহাৰি চেপেটা কৰে। </p>',
      ],
      8 => [
        'question' => 'প্ৰশ্ন নং ৯- ছুৰা কুৰাইশ্ব পাঠ কৰা আৰু ইয়াৰ ব্যাখ্যা কৰা?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/8070.mp3',
        'answer' => '<p> উত্তৰ- ছুৰা কুৰাইশ্ব আৰু ইয়াৰ তাফছীৰঃ<br /> <span class="c2">(আৰম্ভ কৰিছোঁ)</span> পৰম কৰুণাময় পৰম দয়ালু আল্লাহৰ নামত।<br /> লি ঈলাফি কুৰাইশ্ব। <span class="c2">(১)</span> <span class="c4">{যিহেতু ক্বুৰাইছসকল অভ্যস্ত,}</span> ঈলাফিহিম ৰিহলাতাশ্ব শ্বিতা-য়ি অচ-চাইফ। <span class="c2">(২)</span> <span class="c4">{শীত আৰু গ্ৰীষ্মকালৰ ভ্ৰমণত সিহঁতৰ আসক্তি আছে।}</span> ফাল য়া\'বুদু ৰাব্বা হাজাল বাইত। <span class="c2">(৩)</span> <span class="c4">{এতেকে সিহঁতে যেন এই ঘৰৰ প্ৰতিপালকৰ ইবাদত কৰে।}</span> আল্লাজী আত্ব আমাহুম মিং জূ-ইওঁ ওৱা আ-মানাহুম মিন খাওফ। <span class="c2">(৪)</span> <span class="c4">{যিজনে সিহঁতক ক্ষুধা অৱস্থাত খাদ্য প্ৰদান কৰিছে আৰু সন্ত্ৰাসৰ পৰা নিৰাপত্তা দিছে।}</span> <span class="c2">(ছুৰা কুৰাইশ্বঃ ১-৪)</span><br /> তাফছীৰ<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106001.mp3"></audio> ১- <span class="c2">(لِإِيلَافِ قُرَيْشٍ)</span> ইয়াৰ দ্বাৰা বুজোৱা হৈছে যে, কুৰাইশ্বসকলে শীত আৰু গ্ৰীষ্মকালৰ ভ্ৰমণক অভ্যাসত পৰিণত কৰিছিল।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106002.mp3"></audio> ২- <span class="c2">(إِيلَافِهِمْ رِحْلَةَ الشِّتَاءِ وَالصَّيْفِ)</span> শান্তি তথা নিৰাপত্তাৰ সৈতে, শীতকালত ইয়ামানলৈ আৰু গ্ৰীষ্মকালত ছিৰিয়ালৈ ভ্ৰমণ কৰিছিল।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106003.mp3"></audio> ৩- <span class="c2">(فَلْيَعْبُدُوا رَبَّ هَذَا الْبَيْتِ)</span> এতেকে সিহঁতে কেৱল সন্মানিত ঘৰৰ প্ৰতিপালক আল্লাহৰ ইবাদত কৰা উচিত। যিয়ে সিহঁতৰ বাবে এই ভ্ৰমণ দুটাক অতি সহজ কৰি দিছে, সিহঁতে তেওঁৰ লগত আন কাকো অংশীদাৰ স্থাপন কৰা উচিত নহয়।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106004.mp3"></audio> ৪- <span class="c2">(الَّذِي أَطْعَمَهُمْ مِنْ جُوعٍ وَآمَنَهُمْ مِنْ خَوْفٍ)</span> যিয়ে সিহঁতক ভোকৰ সময়ত খাদ্য খুওৱাইছে আৰু ভয়ৰ পৰা নিৰাপত্তা প্ৰদান কৰিছে। কিয়নো তেওঁ আৰববাসীসকলৰ অন্তৰত কা\'বা ঘৰৰ সন্মান আৰু তাৰ অধিবাসীসকলৰ সন্মান ৰাখি দিছে। </p>',
      ],
      9 => [
        'question' => 'প্ৰশ্ন নং ১০- ছুৰা আল-মাঊন পাঠ কৰা আৰু ইয়াৰ ব্যাখ্যা কৰা?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/8160.mp3',
        'answer' => '<p> উত্তৰ- ছুৰা আল-মাঊন আৰু ইয়াৰ তাফছীৰঃ<br /> <span class="c2">(আৰম্ভ কৰিছোঁ)</span> পৰম কৰুণাময় পৰম দয়ালু আল্লাহৰ নামত।<br /> আৰা আইতাল লাজী য়ুকাজ জিবুবিদ্দীন। <span class="c2">(১)</span> তুমি তাক দেখিছানে যিয়ে হিচাপ প্ৰতিদানক অস্বীকাৰ কৰে? ফাজালিকাল লাজী য়াদুওউল য়াতীম। <span class="c2">(২)</span> সেইজনেই সি, যিয়ে অনাথক কঠোৰভাৱে খেদি পঠিয়ায়, অলা য়াহুজদ্বু আলা ত্বআমিল মিছকীন। <span class="c2">(৩)</span> আৰু সি দুখীয়াক খানা খুৱাবলৈ উৎসাহ নিদিয়ে। ফাৱাইলুল লিল মুচাল্লীন। <span class="c2">(৪)</span> এতেকে ধ্বংস সেইসকল ছালাত আদায়কাৰীৰ বাবে, আল্লাজীনাহুম আং চালাতিহিম ছা-হূন। <span class="c2">(৫)</span> যিসকলে ছালাতত অমনোযোগী, আল্লাজীনাহুম য়ুৰা-ঊন। <span class="c2">(৬)</span> যিসকলে আনক দেখুৱাবলৈহে <span class="c2">(চালাত আদায়)</span> কৰে, অয়ামনাঊনাল মা-ঊন। <span class="c2">(৭)</span> আৰু সৰু-সুৰা গৃহসামগ্ৰী প্ৰদানত বাধা দিয়ে। <span class="c2">(ছুৰা আল-মাঊনঃ ১-৭)</span><br /> তাফছীৰ<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107001.mp3"></audio> ১- <span class="c2">(أَرَأَيْتَ الَّذِي يُكَذِّبُ بِالدِّينِ)</span> আপুনি সেইজনক চিনি পায়নে, যিয়ে ক্বিয়ামত দিৱসৰ প্ৰতিদানক অস্বীকাৰ কৰে?<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107002.mp3"></audio> ২- <span class="c2">(فَذَلِكَ الَّذِي يَدُعُّ الْيَتِيمَ)</span> সিয়েই সেই ব্যক্তি, যিয়ে প্ৰয়োজনৰ সময়ত উপস্থিত হোৱা অনাথক কঠোৰ ব্যৱহাৰ কৰি খেদি পঠিয়ায়।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107003.mp3"></audio> ৩- <span class="c2">(وَلَا يَحُضُّ عَلَى طَعَامِ الْمِسْكِينِ)</span> আৰু ভিখাৰীক খাদ্য খুৱাবলৈ নিজকো উদ্বদ্ধ নকৰে, আনকি বেলেগকো প্ৰেৰণা নিদিয়ে।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107004.mp3"></audio> ৪- <span class="c2">(فَوَيْلٌ لِلْمُصَلِّينَ)</span> ধ্বংস আৰু শাস্তি সেইসকল নামাজীৰ বাবে,<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107005.mp3"></audio> ৫- <span class="c2">(الَّذِينَ هُمْ عَنْ صَلَاتِهِمْ سَاهُونَ)</span> যিসকলে নিজৰ ছালাতত অমনোযোগী, চালাতৰ প্ৰতি কোনো ভ্ৰূক্ষেপ নকৰে, আনকি নামাজৰ সময় পাৰ হৈ যায়।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107006.mp3"></audio> ৬- <span class="c2">(الَّذِينَ هُمْ يُرَاءُونَ)</span> যিসকলে চালাত আৰু অন্যান্য নেক আমল মানুহক দেখুৱাবলৈহে কৰে। আল্লাহৰ বাবে নিৰ্ভেজালভাৱে নকৰে।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107007.mp3"></audio> ৭- <span class="c2">(وَيَمْنَعُونَ الْمَاعُونَ)</span> আৰু সেইবোৰ বস্তুৰ জৰিয়তে আনক সহযোগ কৰাত কুণ্ঠাবোধ কৰে যাৰ দ্বাৰা সহযোগ কৰাত কোনো ক্ষতি নাই। </p>',
      ],
      10 => [
        'question' => 'প্ৰশ্ন নং ১১- ছুৰা আল-কাওছাৰ পাঠ কৰা আৰু ইয়াৰ ব্যাখ্যা কৰা?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/8280.mp3',
        'answer' => '<p> উত্তৰ- ছুৰা আল-কাওছাৰ আৰু ইয়াৰ তাফছীৰঃ<br /> <span class="c2">(আৰম্ভ কৰিছোঁ)</span> পৰম কৰুণাময় পৰম দয়ালু আল্লাহৰ নামত।<br /> ইন্না আ\'ত্বইনাকাল কাওছাৰ। <span class="c2">(১)</span> <span class="c4">{নিশ্চয় আমি তোমাক আল-কাউছাৰ প্ৰদান কৰিছোঁ।}</span> ফাচাল্লি লিৰাব্বিকা অনহাৰ। <span class="c2">(২)</span> <span class="c4">{এতেকে তুমি তোমাৰ প্ৰতিপালকৰ উদ্দেশ্যে ছালাত আদায় কৰা আৰু কুৰবানী কৰা।}</span> ইন্না শ্বা-নিআকা হুৱাল আবতাৰ। <span class="c2">(৩)</span> <span class="c4">{নিশ্চয় তোমাৰ প্ৰতি বিদ্বেষ পোষণকাৰীয়েই হৈছে নিৰ্বংশ।}</span> <span class="c2">(ছুৰা আল-কাওছাৰঃ ১-৩)</span><br /> তাফছীৰ<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/108001.mp3"></audio> ১- <span class="c2">(إِنَّا أَعْطَيْنَاكَ الْكَوْثَرَ)</span> হে ৰাছুল! আমি আপোনাক প্ৰচুৰ কল্যাণ প্ৰদান কৰিছোঁ। তাৰ মাজৰ এটা অন্যতম হৈছে জান্নাতৰ নদী আল-কাউছাৰ।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/108002.mp3"></audio> ২- <span class="c2">(فَصَلِّ لِرَبِّكَ وَانْحَرْ)</span> গতিকে এই অনুগ্ৰহ বা অৱদানৰ প্ৰতি আল্লাহৰ কৃতজ্ঞতা পালন কৰি কেৱল তাৰ বাবেই ছালাত আদায় কৰক আৰু কুৰবানী কৰক। যিহেতু সাধাৰণ মুশ্বৰিকসকলে সিহঁতৰ মূৰ্তিবোৰৰ বাবে কুৰবানী বা জন্তু বলিদান কৰি সিহঁতৰ নৈকট্য লাভ কৰাত উঠি পৰি লাগি থাকে।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/108003.mp3"></audio> ৩- <span class="c2">(إِنَّ شَانِئَكَ هُوَ الْأَبْتَرُ)</span> নিঃসন্দেহে ৰাছুলৰ সৈতে বিদ্বেষ ৰখা ব্যক্তিয়েই সকলো প্ৰকাৰৰ কল্যাণৰ পৰা বঞ্চিত হ\'ব। </p>',
      ],
      11 => [
        'question' => 'প্ৰশ্ন নং ১২- ছুৰা আল-কাফিৰূন পাঠ কৰা আৰু ইয়াৰ ব্যাখ্যা কৰা?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/8360.mp3',
        'answer' => '<p> উত্তৰ- ছুৰা আল-কাফিৰূন আৰু ইয়াৰ তাফছীৰঃ<br /> <span class="c2">(আৰম্ভ কৰিছোঁ)</span> পৰম কৰুণাময় পৰম দয়ালু আল্লাহৰ নামত।<br /> ক্বুল ইয়া আইয়্যুহাল কাফিৰূন। <span class="c2">(১)</span> <span class="c4">{কোৱা, ‘হে কাফিৰসকল !}</span> লা আ\'বুদু মা তা\'বুদূন। <span class="c2">(২)</span> <span class="c4">{তোমালোকে যাৰ ইবাদত কৰা, মই তাৰ ইবাদত নকৰোঁ,}</span> অলা আংতুম আ-বিদূনা মা-আ\'বুদ। <span class="c2">(৩)</span> <span class="c4">{আৰু মই যাৰ ইবাদত কৰোঁ তোমালোকেও তাৰ ইবাদতকাৰী নহয়।}</span> অলা আনা আ-বিদুম মা-আবাত্তুম। <span class="c2">(৪)</span> <span class="c4">{আৰু মই তাৰ ইবাদতকাৰী নহয় যাৰ ইবাদত তোমালোকে কৰা।}</span> অলা আংতুম আ-বিদূনা মা-আ\'বুদ। <span class="c2">(৫)</span> <span class="c4">{আৰু মই যাৰ ইবাদত কৰোঁ তোমালোকেও তাৰ ইবাদতকাৰী নহয়।}</span> লাকুম দীনুকুম অলিয়া দ্বীন। <span class="c2">(৬)</span> <span class="c4">{তোমালোকৰ দ্বীন তোমালোকৰ বাবে, আৰু মোৰ দ্বীন মোৰ বাবে।}</span> <span class="c2">(ছুৰা আল-কাফিৰূনঃ ১-৬)</span><br /> তাফছীৰ<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109001.mp3"></audio> ১- <span class="c2">(قُلْ يَا أَيُّهَا الْكَافِرُونَ)</span> হে ৰাছুল, কওক, হে আল্লাহক অস্বীকাৰকাৰীসকল!<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109002.mp3"></audio> ২- <span class="c2">(لَا أَعْبُدُ مَا تَعْبُدُونَ)</span> যিবোৰ মূৰ্ত্তিক তোমালোকে পূজা কৰা, সেইবোৰক মই পূজা নকৰোঁ আৰু ভৱিষ্যতেও নকৰোঁ।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109003.mp3"></audio> ৩- <span class="c2">(وَلَا أَنْتُمْ عَابِدُونَ مَا أَعْبُدُ)</span> আৰু তোমালোকেও তেওঁৰ ইবাদত নকৰা, যাৰ ইবাদত মই কৰোঁ, আৰু সেইজন হৈছে একমাত্ৰ আল্লাহ।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109004.mp3"></audio> ৪- <span class="c2">(وَلَا أَنَا عَابِدٌ مَا عَبَدْتُمْ)</span> আৰু তোমালোকে যিবোৰ মূৰ্তিক পূজা কৰা, সেইবোৰৰ মই ইবাদতকাৰী নহয়।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109005.mp3"></audio> ৫- <span class="c2">(وَلَا أَنْتُمْ عَابِدُونَ مَا أَعْبُدُ)</span> আৰু তোমালোকেও তেওঁৰ ইবাদত নকৰা, যাৰ ইবাদত মই কৰোঁ, আৰু সেইজন হৈছে একমাত্ৰ আল্লাহ।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109006.mp3"></audio> ৬- <span class="c2">(لَكُمْ دِينُكُمْ وَلِيَ دِينِ)</span> তোমালোকৰ বাবে তোমালোকৰ ধৰ্ম, যিটো তোমালোকে নিজৰ বাবে নিজেই সাজি লৈছা আৰু মোৰ কাৰণে মোৰ ধৰ্ম, যিটো আল্লাহে মোৰ প্ৰতি অৱতীৰ্ণ কৰিছে। </p>',
      ],
      12 => [
        'question' => 'প্ৰশ্ন নং ১৩- ছুৰা আন-নাচৰ পাঠ কৰা আৰু ইয়াৰ ব্যাখ্যা কৰা?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/8470.mp3',
        'answer' => '<p> উত্তৰ- ছুৰা আন-নাচৰ আৰু ইয়াৰ তাফছীৰঃ<br /> <span class="c2">(আৰম্ভ কৰিছোঁ)</span> পৰম কৰুণাময় পৰম দয়ালু আল্লাহৰ নামত।<br /> ইযা জা-আ নাচৰুল্লা-হি অল-ফাত্হ। <span class="c2">(১)</span> <span class="c4">{যেতিয়া আল্লাহৰ সহায় আৰু বিজয় আহিব,}</span> অৰাআইতান না-ছা য়াদখুলূনা ফী দীনিল্লা-হি আফৱাজা। <span class="c2">(২)</span> <span class="c4">{আৰু তুমি মানুহক দলে দলে আল্লাহৰ দ্বীনত প্ৰৱেশ কৰোঁতে দেখিবা,}</span> ফাছাব্বিহ বিহামদি ৰাব্বিকা অছতাগফিৰহু, ইন্নাহু কা-না তাওৱাবা। <span class="c2">(৩)</span> <span class="c4">{তেতিয়া তুমি তোমাৰ প্ৰতিপালকৰ প্ৰশংসা সহকাৰে তেওঁৰ পৱিত্ৰতা আৰু মহিমা ঘোষণা কৰিবা আৰু তেওঁৰ ওচৰত ক্ষমা প্ৰাৰ্থনা কৰিবা, নিশ্চয় তেওঁ তাওবা গ্ৰহণকাৰী।}</span> <span class="c2">(ছুৰা আন-নাচৰঃ ১-৩)</span><br /> তাফছীৰ<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/110001.mp3"></audio> ১- <span class="c2">(إِذَا جَاءَ نَصْرُ اللَّهِ وَالْفَتْحُ)</span> হে ৰাছুল! যেতিয়া আপোনাৰ দ্বীনৰ বাবে আল্লাহৰ সহায় আহি যাব, আৰু মক্কা বিজয় হৈ যাব।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/110002.mp3"></audio> ২- <span class="c2">(وَرَأَيْتَ النَّاسَ يَدْخُلُونَ فِي دِينِ اللَّهِ أَفْوَاجًا)</span> আৰু আপুনি মানুহক দলে দলে ইছলামত প্ৰৱেশ হোৱা দেখিবলৈ পাব।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/110003.mp3"></audio> ৩- <span class="c2">(فَسَبِّحْ بِحَمْدِ رَبِّكَ وَاسْتَغْفِرْهُ إِنَّهُ كَانَ تَوَّابًا)</span> তেতিয়া আপুনি জানি লব যে, এয়া সেই মিচনৰ সমাপ্তিৰ নিকটৱৰ্তীৰ ইংগিতহে, যাৰ সৈতে আপোনাক প্ৰেৰিত কৰা হৈছিল। আপুনি সহায় আৰু বিজয় প্ৰাপ্ত হোৱাৰ বাবে কৃতজ্ঞতা পালনাৰ্থে আপোনাৰ প্ৰতিপালকৰ প্ৰশংসা আৰু পৱিত্ৰতা বৰ্ণনা কৰক। লগতে তেওঁৰ ওচৰত ক্ষমা প্ৰৰ্থনা কৰক। নিশ্চয় তেওঁ তাওবা কবুলকাৰী, বান্দাৰ তাওবা কবূল কৰে আৰু তেওঁলোকৰ প্ৰতি ক্ষমাশীল। </p>',
      ],
      13 => [
        'question' => 'প্ৰশ্ন নং ১৪- ছুৰা আল-মাছাদ পাঠ কৰা আৰু ইয়াৰ ব্যাখ্যা কৰা?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/8550.mp3',
        'answer' => '<p> উত্তৰ- ছুৰা আল-মাছাদ আৰু ইয়াৰ তাফছীৰঃ<br /> <span class="c2">(আৰম্ভ কৰিছোঁ)</span> পৰম কৰুণাময় পৰম দয়ালু আল্লাহৰ নামত।<br /> তাব্বাত য়াদা আবি লাহাব। <span class="c2">(১)</span> <span class="c4">{ধ্বংস হওক আবু লাহাবৰ দুয়ো হাত আৰু সি নিজেও ধ্বংস হৈছে।}</span> মা আগনা আনহু মা-লুহু অমা কাছাব। <span class="c2">(২)</span> <span class="c4">{তাৰ ধন-সম্পদ আৰু তাৰ উপাৰ্জন, তাৰ কোনো কামত নাহিল।}</span> ছায়াচলা না-ৰান যা-তা লাহাব। <span class="c2">(৩)</span> <span class="c4">{অতিশীঘ্ৰেই সি লেলিহান জুইত পতিত হ’ব।}</span> অমৰাআতুহু হাম্মা-লাতাল হাত্বাব। <span class="c2">(৪)</span> <span class="c4">{আৰু তাৰ স্ত্ৰীও- যিজনীয়ে ইন্ধন বহন কৰে,}</span> ফী জীদিহা হাবলুম মিম মাছাদ। <span class="c2">(৫)</span> <span class="c4">{তাইৰ ডিঙিত থাকিব পকোৱা টান ৰছী।}</span> <span class="c2">(ছুৰা আল-মাছাদঃ ১-৫)</span><br /> তাফছীৰ<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111001.mp3"></audio> ১- <span class="c2">(تَبَّتْ يَدَا أَبِي لَهَبٍ وَتَبَّ)</span> নবী চাল্লাল্লাহু আলাইহি অছাল্লামৰ খুৰা আবু লাহাব বিন আব্দুল মুত্তালিবৰ দুয়ো হাত ক্ষতিগ্ৰস্ত হৈছে, কাৰণ তাৰ আমল হৈছে নিকৃষ্ট, আৰু তাৰ সকলো প্ৰচেষ্টা বিফল হৈছে। যেতিয়া সি নবী চাল্লাল্লাহু আলাইহি অছাল্লামক কষ্ট দিব বিচাৰিছিল।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111002.mp3"></audio> ২- <span class="c2">(مَا أَغْنَى عَنْهُ مَالُهُ وَمَا كَسَبَ)</span> ধন, সন্তান কোনো বস্তুই তাৰ কোনো উপকাৰত অহা নাই আৰু শাস্তিৰ পৰা ৰক্ষা কৰিব পৰা নাই। লগতে তাক দয়াৰ পাত্ৰও বনাব পৰা নাই।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111003.mp3"></audio> ৩- <span class="c2">(سَيَصْلَى نَارًا ذَاتَ لَهَبٍ)</span> সি অনতিপলমে ক্বিয়ামতৰ দিনা লেলিহান জুইত প্ৰৱেশ কৰিব আৰু জ্বলি থাকিব।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111004.mp3"></audio> ৪- <span class="c2">(وَامْرَأَتُهُ حَمَّالَةَ الْحَطَبِ)</span> আৰু তাৰ স্ত্ৰী উম্মে জামিলেও তাৰ ভিতৰত প্ৰৱেশ কৰিব। আল্লাহৰ ৰাছুলক তাই ৰাস্তাৰ মাজত কাইট মেলি কষ্ট দিছিল।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111005.mp3"></audio> ৫- <span class="c2">(فِي جِيدِهَا حَبْلٌ مِنْ مَسَدٍ)</span> তাইৰ ডিঙিত শক্তিশালী পকোৱা টান ৰছী থাকিব, যিটো তাইৰ ডিঙিত লগাই চোঁচৰাই অগ্নিৰ ফালে লৈ যোৱা হ\'ব। </p>',
      ],
      14 => [
        'question' => 'প্ৰশ্ন নং ১৫- ছুৰা আল-ইখলাচ পাঠ কৰা আৰু ইয়াৰ ব্যাখ্যা কৰা?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/8650.mp3',
        'answer' => '<p> উত্তৰ- ছুৰা আল-ইখলাচ আৰু ইয়াৰ তাফছীৰঃ<br /> <span class="c2">(আৰম্ভ কৰিছোঁ)</span> পৰম কৰুণাময় পৰম দয়ালু আল্লাহৰ নামত।<br /> ক্বুল হুৱাল্লা-হু আহাদ। <span class="c2">(১)</span> <span class="c4">{কোৱা, ‘তেওঁ আল্লাহ, এক-অদ্বিতীয়,}</span> আল্লা-হুচ চামাদ। <span class="c2">(২)</span> <span class="c4">{আল্লাহ অমুখাপেক্ষী।}</span> লাম য়ালিদ অলাম ইউলাদ। <span class="c2">(৩)</span> <span class="c4">{তেওঁ কাকো জন্ম দিয়া নাই আৰু তেৱোঁ জন্ম লোৱা নাই,}</span> অলাম য়াকুল্লাহু কুফুআন আহাদ। <span class="c2">(৪)</span> <span class="c4">{আৰু তেওঁৰ সমতুল্য কোনো নাই’।}</span> <span class="c2">(ছুৰা আল-ইখলাচঃ ১-৪)</span><br /> তাফছীৰ<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112001.mp3"></audio> ১- <span class="c2">(قُلْ هُوَ اللَّهُ أَحَدٌ)</span> হে ৰাছুল, আপুনি কৈ দিয়ক, আল্লাহেই হৈছে একমাত্ৰ সত্য উপাস্য, তেওঁৰ বাহিৰে কোনো সত্য উপাস্য নাই।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112002.mp3"></audio> ২- <span class="c2">(اللَّهُ الصَّمَدُ)</span> তেওঁৰ ওচৰতে সকলো সৃষ্টিয়ে নিজৰ নিজৰ প্ৰয়োজনবোৰ উত্থাপন কৰে।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112003.mp3"></audio> ৩- <span class="c2">(لَمْ يَلِدْ وَلَمْ يُولَدْ)</span> এতেকে সেই পৱিত্ৰ সত্ত্বা আল্লাহৰ কোনো সন্তান নাই আৰু পিতাও নাই।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112004.mp3"></audio> ৪- <span class="c2">(وَلَمْ يَكُنْ لَهُ كُفُوًا أَحَدٌ)</span> আৰু সৃষ্টিৰ মাজত তেওঁৰ সমপৰ্যায়ৰ কোনো নাই। </p>',
      ],
      15 => [
        'question' => 'প্ৰশ্ন নং ১৬- ছুৰা আল-ফালাক্ব পাঠ কৰা আৰু ইয়াৰ ব্যাখ্যা কৰা?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/8750.mp3',
        'answer' => '<p> উত্তৰ- ছুৰা আল-ফালাক্ব আৰু ইয়াৰ তাফছীৰঃ<br /> <span class="c2">(আৰম্ভ কৰিছোঁ)</span> পৰম কৰুণাময় পৰম দয়ালু আল্লাহৰ নামত।<br /> ক্বুল আউজু বিৰাব্বিল ফালাক্ব। <span class="c2">(১)</span> <span class="c4">{কোৱা, মই আশ্ৰয় বিচাৰোঁ ঊষাৰ প্ৰতিপালকৰ।}</span> মিং শ্বাৰ্ৰি মা খালাক্ব। <span class="c2">(২)</span> <span class="c4">{তেওঁ যি সৃষ্টি কৰিছে তাৰ অনিষ্টৰ পৰা,}</span> অমিং শ্বাৰ্ৰি গা-ছিক্বিন ইযা অক্বাব। <span class="c2">(৩)</span> <span class="c4">{আৰু ৰাতিৰ অন্ধকাৰৰ অনিষ্টৰ পৰা, যেতিয়া ই গভীৰ হয়,}</span> অমিং শ্বাৰ্ৰিন নাফফা-ছা-তি ফিল উক্বাদ। <span class="c2">(৪)</span> <span class="c4">{আৰু সেইসকল নাৰীৰ অনিষ্টৰ পৰা যিসকলে গাঁঠিত ফুঁ দিয়ে,}</span> অমিং শ্বাৰ্ৰি হা-ছিদিন ইযা হাছাদ। <span class="c2">(৫)</span> <span class="c4">{আৰু হিংসুকৰ অনিষ্টৰ পৰা, যেতিয়া সি হিংসা কৰে।}</span> <span class="c2">(ছুৰা ফালাক্বঃ ১-৫)</span><br /> তাফছীৰ<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113001.mp3"></audio> ১- <span class="c2">(قُلْ أَعُوذُ بِرَبِّ الْفَلَقِ)</span> হে ৰাছুল , কৈ দিয়ক যে মই প্ৰভাতৰ প্ৰতিপালকক দৃঢ়ভাৱে আকোঁৱালি লৈছোঁ আৰু তেওঁৰেই আশ্ৰয় বিচাৰোঁ।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113002.mp3"></audio> ২- <span class="c2">(مِنْ شَرِّ مَا خَلَقَ)</span> কষ্টদায়ক সৃষ্টিৰ অনিষ্টৰ পৰা।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113003.mp3"></audio> ৩- <span class="c2">(وَمِنْ شَرِّ غَاسِقٍ إِذَا وَقَبَ)</span> আৰু মই আল্লাহৰ আশ্ৰয় বিচাৰোঁ সেইবোৰ কষ্টদায়ক বস্তুৰ পৰা, যিবোৰ ৰাতিত ওলায়। যেনে- কীট- পতংগ আৰু চোৰ আদি।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113004.mp3"></audio> ৪- <span class="c2">(وَمِنْ شَرِّ النَّفَّاثَاتِ فِي الْعُقَدِ)</span> আৰু আল্লাহৰ আশ্ৰয় বিচাৰিছোঁ যাদুকৰ মহিলাৰ অনিষ্টৰ পৰা, যিসকলে গাঁঠিত ফুঁ দিয়ে।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113005.mp3"></audio> ৫- <span class="c2">(وَمِنْ شَرِّ حَاسِدٍ إِذَا حَسَدَ)</span> আৰু আল্লাহৰ আশ্ৰয় বিচাৰোঁ হিংসুকৰ অনিষ্টৰ পৰা যেতিয়া সি আল্লাহে মানুহক প্ৰদান কৰা নিয়ামতবোৰ দেখি হিংসা কৰে তথা সেইবোৰ বিনষ্ট হোৱাৰ কামনা কৰে আৰু তাক কষ্ট দিয়াৰ প্ৰচেষ্টা কৰে। </p>',
      ],
      16 => [
        'question' => 'প্ৰশ্ন নং ১৭- ছুৰা আন-নাছ পাঠ কৰা আৰু ইয়াৰ ব্যাখ্যা কৰা?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/8870.mp3',
        'answer' => '<p> উত্তৰ- ছুৰা আন-নাছ আৰু ইয়াৰ তাফছীৰঃ<br /> <span class="c2">(আৰম্ভ কৰিছোঁ)</span> পৰম কৰুণাময় পৰম দয়ালু আল্লাহৰ নামত।<br /> ক্বুল আউজু বিৰাব্বিন না-ছ। <span class="c2">(১)</span> <span class="c4">{কোৱা, মই আশ্ৰয় বিচাৰোঁ মানুহৰ প্ৰতিপালকৰ।}</span> মালিকিন না-ছ। <span class="c2">(২)</span> <span class="c4">{মানুহৰ অধিপতিৰ,}</span> ইলাহিন না-ছ। <span class="c2">(৩)</span> <span class="c4">{মানুহৰ ইলাহৰ ওচৰত,}</span> মিং শ্বাৰ্ৰিল অছৱা-ছিল খান্না-ছ। <span class="c2">(৪)</span> <span class="c4">{আত্মগোপনকাৰী কুমন্ত্ৰণাদাতাৰ অনিষ্টৰ পৰা,}</span> আল্লাজী য়ুৱাছৱিছু ফি চুদূৰিন না-ছ। <span class="c2">(৫)</span> <span class="c4">{যিয়ে মানুহৰ মনত কুমন্ত্ৰণা দিয়ে,}</span> মিনাল জিন্নাতি অন্না-ছ। <span class="c2">(৬)</span> <span class="c4">{জিনৰ মাজৰ পৰা আৰু মানুহৰ মাজৰ পৰা।}</span> <span class="c2">(ছুৰা আন-নাছঃ ১-৬)</span><br /> তাফছীৰ<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114001.mp3"></audio> ১- <span class="c2">(قُلْ أَعُوذُ بِرَبِّ النَّاسِ)</span> হে ৰাছুল , কৈ দিয়ক যে, মই মানুহৰ প্ৰতিপালকক দৃঢ়ভাৱে আকোঁৱালি লৈছোঁ আৰু তেওঁৰেই আশ্ৰয় বিচাৰোঁ।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114002.mp3"></audio> ২- <span class="c2">(مَلِكِ النَّاسِ)</span> যিয়ে সকলো মানুহৰ অধিপতি। সিহঁতক যেনেকৈ বিচাৰে প্ৰয়োগ কৰে। তেওঁৰ বাহিৰে সিহঁতৰ আন কোনো অধিপতি নাই।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114003.mp3"></audio> ৩- <span class="c2">(إِلَهِ النَّاسِ)</span> তেৱেঁই সিহঁতৰ সত্য উপাস্য। তেওঁৰ বাহিৰে সিহঁতৰ আন কোনো সত্য উপাস্য নাই।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114004.mp3"></audio> ৪- <span class="c2">(مِنْ شَرِّ الْوَسْوَاسِ الْخَنَّاسِ)</span> চয়তানৰ অপৰাধৰ পৰা, যিয়ে মানুহক কুমন্ত্ৰণা দিয়ে।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114005.mp3"></audio> ৫- <span class="c2">(الَّذِي يُوَسْوِسُ فِي صُدُورِ النَّاسِ)</span> যিয়ে মানুহৰ অন্তৰত কুভাৱনা উদ্ভৱ কৰায়।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114006.mp3"></audio> ৬- <span class="c2">(مِنَ الْجِنَّةِ وَالنَّاسِ)</span> কুমন্ত্ৰণা প্ৰদানকাৰী মানুহৰ মাজৰ পৰাও হয় আৰু জিন জাতিৰ পৰাও হয়। </p>',
      ],
    ],
    5 => [
      0 => [
        'question' => 'প্ৰশ্ন নং ১- এই হাদীছটো সম্পূৰ্ণ কৰা (إنما الأعمال بالنيات ...) আৰু ইয়াৰ কেইটামান গুৰুত্বপূৰ্ণ উপকাৰিতা উল্লেখ কৰা?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/9030.mp3',
        'answer' => '<p> উত্তৰ- আমীৰুল মুমিনীন আবু হাফচ ওমৰ ইবনুল খাত্তাব ৰাদ্বিয়াল্লাহু আনহুৰ পৰা বৰ্ণিত, তেওঁ কৈছে মই ৰাছুলুল্লাহ চাল্লাল্লাহু আলাইহি অছাল্লামক কোৱা শুনিছোঁঃ “সকলো কাম <span class="c2">(ৰ প্রাপ্য)</span> হ’ব নিয়্যত অনুযায়ী, আৰু মানুহে তাৰ নিয়্যত অনুযায়ী প্রতিফল পাব। গতিকে যিয়ে আল্লাহ আৰু তেওঁৰ ৰাছুলৰ উদ্দেশ্যে হিজৰত কৰিব, তাৰ হিজৰত সেই উদ্দেশ্যেই গৃহীত হ\'ব। আনহাতে যিয়ে পাৰ্থিৱ লাভৰ আশাত অথবা কোনো মহিলাক বিবাহ কৰাৰ উদ্দেশ্যে হিজৰত কৰিব, তেন্তে তাৰ হিজৰত সেই উদ্দেশ্যেই কবূল হ’ব, যি উদ্দেশ্যত সি হিজৰত কৰিছে’। ইয়াক বুখাৰী আৰু মুছলিমে বৰ্ণনা কৰিছে।<br /> হাদীছৰ পৰা সংগৃহীত উপকাৰিতাসমূহঃ<br /> ১- প্ৰতিটো আমলৰ বাবে নিয়্যত জৰুৰী, নামাজ, ৰোজা, হজ্জ আদি আমলৰ বাবে।<br /> ২- নিৰ্ভেজালভাৱে ইখলাচৰ সৈতে একমাত্ৰ আল্লাহৰ বাবে নিয়্যত কৰা অনিবাৰ্য।<br /> দ্বিতীয় হাদীছ </p>',
      ],
      1 => [
        'question' => 'প্ৰশ্ন নং ২- এই হাদীছটো সম্পূৰ্ণ কৰা (من أحدث في أمرنا هذا ...) আৰু ইয়াৰ কেইটামান গুৰুত্বপূৰ্ণ উপকাৰিতা উল্লেখ কৰা?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/9090.mp3',
        'answer' => '<p> উত্তৰ- উম্মুল মুমিনীন উম্মু আব্দিল্লাহ আয়িশ্বাহ ৰাদ্বিয়াল্লাহু আনহাই বৰ্ণনা কৰি কৈছেঃ ৰাছুলুল্লাহ চাল্লাল্লাহু আলাইহি অছাল্লামে কৈছেঃ যিয়ে আমাৰ দ্বীনৰ মাজত এনে কোনো নতুন বিষয় সংযুক্ত কৰিব যিটো তাৰ অংশ নহয়, সেইটো প্ৰত্যাখ্যাত। <span class="c2">(অৰ্থাৎ সেইটো গ্ৰহণযোগ্য নহ’ব)</span>। ইয়াক বুখাৰী আৰু মুছলিমে বৰ্ণনা কৰিছে।<br /> হাদীছৰ পৰা সংগৃহীত উপকাৰিতাসমূহঃ<br /> ১- দ্বীনৰ মাজত বিদআত সৃষ্টি কৰিবলৈ নিষেধ কৰা হৈছে।<br /> ২- এই কথা নিশ্চিত যে, বিদআতী আমল প্ৰত্যাখ্যাত অগ্ৰহণযোগ্য।<br /> তৃতীয় হাদীছ </p>',
      ],
      2 => [
        'question' => 'প্ৰশ্ন নং ৩- এই হাদীছটো সম্পূৰ্ণ কৰা (بينما نحن جلوس عند رسول الله ﷺ ...) আৰু ইয়াৰ কেইটামান গুৰুত্বপূৰ্ণ উপকাৰিতা উল্লেখ কৰা?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/9160.mp3',
        'answer' => '<p> উত্তৰ- ওমৰ ৰাদ্বিয়াল্লাহু ‘আনহুৰ পৰা বৰ্ণিত, তেওঁ কৈছে, এদিনাখন আমি ৰাছুলুল্লাহ চাল্লাল্লাহু ‘আলাইহি অছাল্লামৰ ওচৰত বহি আছিলোঁ, ঠিক সেই সময়তে হঠাৎ এজন ব্যক্তি আমাৰ সন্মুখত আহি উপস্থিত হ\'ল, যাৰ কাপোৰ আছিল অতিকৈ বগা, চুলিবোৰ আছিল ভীষণ ক’লা; তাৰ ওপৰত ভ্ৰমণৰ কোনো লক্ষণ পৰিলক্ষিত হোৱা নাছিল। আমাৰ মাজৰ কোনেও তেওঁক চিনিও পোৱা নাছিল। তেওঁ নবী চাল্লাল্লাহু ‘আলাইহি অছাল্লামৰ ওচৰত আহি বহিল, নিজৰ আঠু তেখেতৰ আঠুৰ লগত মিলাই নিজৰ হাত তেখেতৰ <span class="c2">(অথবা নিজৰেই)</span> উৰুত ৰাখি ক’লে: <span class="c1">“হে মুহাম্মদ, মোক ইছলাম সম্পৰ্কে জ্ঞান দিয়ক”</span>। ৰাছুলুল্লাহ চাল্লাল্লাহু আলাইহি অছাল্লামে ক’লে: <span class="c1">“ইছলাম হৈছে- তুমি সাক্ষ্য দিয়া যে, আল্লাহৰ বাহিৰে আন কোনো সত্য ইলাহ নাই আৰু মুহাম্মদ <span class="c2">(চাল্লাল্লাহু ‘আলাইহি অছাল্লাম)</span> আল্লাহৰ ৰাছুল, ছালাত প্ৰতিষ্ঠা কৰা, যাকাত প্ৰদান কৰা, ৰমজান মাহৰ চওম পালন কৰা আৰু যদি সামৰ্থ থাকে তেন্তে <span class="c2">(আল্লাহৰ)</span> ঘৰৰ হজ্জ কৰা।”</span> তেওঁ <span class="c2">(লোকজনে)</span> ক’লে: <span class="c1">“আপুনি ঠিকেই কৈছে”</span>। <span class="c2">(বৰ্ণনাকাৰীয়ে কৈছে)</span> আমি বিস্মিত হ’লোঁ, তেওঁ নিজেই তেখেতক প্ৰশ্ন কৰি আছে আকৌ নিজেই তেখেতৰ উত্তৰক সঠিক বুলি সমৰ্থন কৰি আছে। তাৰ পিছত তেওঁ ক’লে, <span class="c1">“মোক ঈমান সম্পৰ্কে জ্ঞান দিয়ক”</span>। তেখেতে <span class="c2">(ৰাছুলুল্লাহ চাল্লাল্লাহু আলাইহি অছাল্লামে)</span> ক’লে: <span class="c1">“সেয়া হৈছে এই যে- আল্লাহ, তেওঁৰ ফিৰিস্তা, তেওঁৰ কিতাবসমূহ, তেওঁৰ ৰাছুলসকল আৰু আখিৰাতৰ ওপৰত ঈমান পোষণ কৰা, লগতে তাকদীৰৰ <span class="c2">(ভাগ্যৰ)</span> ভাল-বেয়াৰ ওপৰত বিশ্বাস স্থাপন কৰা।”</span> তেওঁ ক’লে: <span class="c1">“আপুনি ঠিকেই কৈছে”</span>। তাৰ পিছত ক’লে: <span class="c1">“মোক ইহছান সম্পৰ্কে জ্ঞান দিয়ক”</span>। তেখেতে ক’লে: <span class="c1">“সেয়া হৈছে এই যে- তুমি এনেকৈ আল্লাহৰ ইবাদত কৰা যেনিবা তুমি আল্লাহক দেখি আছা, আৰু যদি তুমি তেওঁক দেখিবলৈ নোপোৱা <span class="c2">(অথবা যদি এইটো কল্পনা কৰিব নোৱাৰা)</span> তেন্তে তুমি জানি থোৱা তেওঁ নিশ্চয় তোমাক দেখি আছে”</span>। তেওঁ ক’লে: <span class="c1">“মোক কিয়ামত সম্পৰ্কে জ্ঞান দিয়ক”</span>। তেখেতে ক’লে: <span class="c1">“যাক প্ৰশ্ন কৰা হৈছে তেওঁ প্ৰশ্নকাৰীতকৈ বেছি একো নাজানে”</span>। তেওঁ ক’লে: <span class="c1">“তেন্তে তাৰ লক্ষণ সম্পৰ্কে জ্ঞান দিয়ক”</span>। তেখেতে ক’লে: <span class="c1">“সেয়া হৈছে এই যে- দাসীয়ে নিজৰ মালিকক জন্ম দিব, সম্পদ আৰু বস্ত্ৰহীন গৰখীয়াসকলেও ওখ ওখ অট্টালিকাৰ দম্ভ কৰিব”</span>। এই কথোপকথনৰ পিছত সেই ব্যক্তিজন গুচি গ’ল, কিন্তু মই আৰু কিছুসময় বহি থাকিলোঁ। তেতিয়া তেখেতে <span class="c2">(ৰাছুলুল্লাহ চাল্লাল্লাহু আলাইহি অছাল্লামে)</span> মোক ক’লে: <span class="c1">“হে ওমৰ! প্ৰশ্নকাৰীজন কোন আছিল,<span class="c6"> আপুনি জানেনে? মই ক\'লোঁ:</span> “আল্লাহ আৰু তেওঁৰ ৰাছুলেহে অধিক ভালকৈ জানে”</span>। তেখেতে ক’লে: <span class="c1">“তেওঁ আছিল জিব্ৰীল <span class="c2">(আলাইহিচ্ছালাম)</span>। আপোনালোকক আপোনালোকৰ দ্বীন শিক্ষা দিবলৈ আপোনালোকৰ ওচৰলৈ আহিছিল।”</span> ইয়াক মুছলিমে বৰ্ণনা কৰিছে।<br /> হাদীছৰ পৰা সংগৃহীত উপকাৰিতাসমূহঃ<br /> ১- ইছলামৰ পাঁচটা আৰকান উল্লেখ কৰা হৈছে। যেনে-<br /> এই কথাৰ সাক্ষ্য দান কৰা যে, আল্লাহৰ বাহিৰে আন কোনো সত্য ইলাহ <span class="c2">(উপাস্য)</span> নাই আৰু মুহাম্মদ <span class="c2">(চাল্লাল্লাহু আলাইহি অছাল্লাম)</span> হৈছে আল্লাহৰ ৰাছুল।<br /> চালাত প্ৰতিষ্ঠা কৰা।<br /> জাকাত প্ৰদান কৰা।<br /> ৰমজান মাহৰ ৰোজা ৰখা।<br /> বাইতুল্লাহৰ হজ্জ কৰা।<br /> ২- ঈমানৰ আৰকান উল্লেখ কৰা হৈছে, ঈমানৰ আৰকান হৈছে ছয়টাঃ<br /> আল্লাহৰ প্ৰতি ঈমান।<br /> ফিৰিস্তাসকলৰ প্ৰতি ঈমান।<br /> তেওঁ অৱতীৰ্ণ কৰা গ্ৰন্থসমূহৰ প্ৰতি ঈমান।<br /> তেওঁৰ প্ৰেৰিত ৰাছুলসকলৰ প্ৰতি ঈমান।<br /> শেষ দিৱসৰ প্ৰতি ঈমান।<br /> তাক্বদীৰ বা ভাগ্যৰ মঙ্গল অমঙ্গলৰ প্ৰতি ঈমান।<br /> ৩- এহছানৰ ৰুকন উল্লেখ কৰা হৈছে। এহছানৰ এটাই ৰুকন, সেইটো হৈছেঃ আল্লাহৰ ইবাদত এনেকৈ কৰক যেনিবা আপুনি আল্লাহক দেখি আছে। আৰু যদি এইটো অনুভৱ নহয় তেন্তে মনত ৰাখিব লাগিব যে, আল্লাহে আপোনাক দেখি আছে।<br /> ৪- কিয়ামতৰ সঠিক সময় সম্পৰ্কে আল্লাহৰ বাহিৰে আন কোনেও নাজানে।<br /> চতুৰ্থ হাদীছ </p>',
      ],
      3 => [
        'question' => 'প্ৰশ্ন নং ৪- এই হাদীছটো সম্পূৰ্ণ কৰা (أكمل المؤمنين إيماناً) আৰু ইয়াৰ কেইটামান গুৰুত্বপূৰ্ণ উপকাৰিতা উল্লেখ কৰা?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/9360.mp3',
        'answer' => '<p> উত্তৰ- আবু হুৰাইৰাহ ৰাদ্বিয়াল্লাহু আনহুৰ পৰা বৰ্ণিত, তেওঁ ৰাছুলুল্লাহ চাল্লাল্লাহু আলাইহি অছাল্লামৰ পৰা বৰ্ণনা কৰি কৈছে, ৰাছুলুল্লাহ চাল্লাল্লাহু আলাইহি অছাল্লামে কৈছেঃ মুমিনসকলৰ মাজত পৰিপূৰ্ণ মুমিন হৈছে সেই ব্যক্তি, যাৰ চৰিত্ৰ তেওঁলোকৰ মাজত সৰ্বোত্তম। হাদীছটো তিৰিমিজীয়ে বৰ্ণনা কৰিছে আৰু কৈছেঃ হাদীছটো হাছান ছহীহ।<br /> হাদীছৰ পৰা সংগৃহীত উপকাৰিতাসমূহঃ<br /> ১- উত্তম চৰিত্ৰৰ প্ৰতি উৎসাহ প্ৰদান কৰা হৈছে।<br /> ২- লগতে হাদীছটোৱে প্ৰমাণ কৰে যে, পৰিপূৰ্ণ চৰিত্ৰ হৈছে পৰিপূৰ্ণ ঈমানৰ প্ৰতীক।<br /> ৩- লগতে এই কথাও প্ৰমাণিত হয় যে, ঈমান বৃদ্ধি হয় আৰু হ্ৰাস পায়।<br /> পঞ্চম হাদীছ </p>',
      ],
      4 => [
        'question' => 'প্ৰশ্ন নং ৫- এই হাদীছটো সম্পূৰ্ণ কৰা (من حلف بغير الله ...) আৰু ইয়াৰ কেইটামান গুৰুত্বপূৰ্ণ উপকাৰিতা উল্লেখ কৰা?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/9440.mp3',
        'answer' => '<p> উত্তৰ- ইবনে ওমৰ ৰাদ্বিয়াল্লাহু আনহুমাৰ পৰা বৰ্ণিত, নবী চাল্লাল্লাহু আলাইহি অছাল্লামে কৈছেঃ যি ব্যক্তিয়ে আল্লাহৰ বাহিৰে আনৰ নামত শপত কৰিছে, সি দৰাচলতে কুফৰী কৰিছে অথবা শ্বিৰ্ক কৰিছে। ইয়াক তিৰমিজীয়ে বৰ্ণনা কৰিছে<br /> হাদীছৰ পৰা সংগৃহীত উপকাৰিতাসমূহঃ<br /> ১-আল্লাহৰ বাহিৰে আনৰ শপত খোৱা বৈধ নহয়।<br /> ২-আল্লাহৰ বাহিৰে আনৰ শপত খোৱাটো হৈছে শ্বিৰ্কে আচগৰ বা সৰু শ্বিৰ্ক।<br /> ষষ্ঠ হাদীছ </p>',
      ],
      5 => [
        'question' => 'প্ৰশ্ন নং ৬- এই হাদীছটো সম্পূৰ্ণ কৰা (لا يؤمن أحدكم حتى أكون أحب إليه ...) আৰু ইয়াৰ কেইটামান গুৰুত্বপূৰ্ণ উপকাৰিতা উল্লেখ কৰা?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/9510.mp3',
        'answer' => '<p> উত্তৰ- আনাছ ৰাদ্বিয়াল্লাহু আনহুৰ পৰা বৰ্ণিত, ৰাছুলুল্লাহ চাল্লাল্লাহু আলাইহি অছাল্লামে কৈছেঃ তোমালোকৰ মাজৰ কোনেও তেতিয়ালৈকে প্রকৃত মুমিন হ’ব নোৱাৰিব যেতিয়ালৈকে তাৰ ওচৰত মই তাৰ সন্তান, তাৰ পিতা আৰু সকলো মানুহতকৈ অধিক প্রিয়পাত্র নহওঁ। ইয়াক বুখাৰী আৰু মুছলিমে বৰ্ণনা কৰিছে।<br /> হাদীছৰ পৰা সংগৃহীত উপকাৰিতাসমূহঃ<br /> ১- সকলোতকৈ অধিক নবী চাল্লাল্লাহু আলাইহি অছাল্লামক মুহাব্বত কৰাটো জৰুৰী।<br /> ২- এইটো হৈছে পৰিপূৰ্ণ ঈমানৰ প্ৰতীক।<br /> সপ্তম হাদীছ </p>',
      ],
      6 => [
        'question' => 'প্ৰশ্ন নং ৭- এই হাদীছটো সম্পূৰ্ণ কৰা (لا يؤمن أحدكم حتى يحب لأخيه) আৰু ইয়াৰ কেইটামান গুৰুত্বপূৰ্ণ উপকাৰিতা উল্লেখ কৰা?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/9580.mp3',
        'answer' => '<p> উত্তৰ- আনাছ ৰাদ্বিয়াল্লাহু আনহুৰ পৰা বৰ্ণিত, ৰাছুলুল্লাহ চাল্লাল্লাহু আলাইহি অছাল্লামে কৈছেঃ তোমালোকৰ মাজৰ কোনেও তেতিয়ালৈকে প্ৰকৃত মুমিন হ\'ব নোৱাৰিব, যেতিয়ালৈকে সি নিজৰ বাবে যিটো পছন্দ কৰে সেইটো তাৰ ভাতৃৰ বাবে পছন্দ নকৰিব। ইয়াক বুখাৰী আৰু মুছলিমে বৰ্ণনা কৰিছে।<br /> হাদীছৰ পৰা সংগৃহীত উপকাৰিতাসমূহঃ<br /> ১- মুমিনৰ উচিত, তেওঁ নিজৰ বাবে যিটো কল্যাণ পছন্দ কৰে সেইটো যেন তেওঁ মুমিন ভাতৃৰ বাবেও পছন্দ কৰে।<br /> ২- এইটো হৈছে পৰিপূৰ্ণ ঈমানৰ প্ৰতীক।<br /> অষ্টম হাদীছ </p>',
      ],
      7 => [
        'question' => 'প্ৰশ্ন নং ৮- এই হাদীছটো সম্পূৰ্ণ কৰা (...والذي نفسي بيده) আৰু ইয়াৰ কেইটামান গুৰুত্বপূৰ্ণ উপকাৰিতা উল্লেখ কৰা?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/9650.mp3',
        'answer' => '<p> উত্তৰ- আবু ছাঈদ খুদৰী ৰাদ্বিয়াল্লাহু আনহুৰ পৰা বৰ্ণিত, ৰাছুলুল্লাহ চাল্লাল্লাহু আলাইহি অছাল্লামে কৈছেঃ শপত সেই সত্ত্বাৰ, যাৰ হাতত মোৰ প্ৰাণ আছে! নিশ্চয় এইটো এক তৃতীয়াংশ কোৰআনৰ সমান। বুখাৰীয়ে বৰ্ণনা কৰিছে।<br /> হাদীছৰ পৰা সংগৃহীত উপকাৰিতাসমূহঃ<br /> ১- ছুৰা ইখলাচৰ ফজিলত।<br /> ২- এই ছুৰাটো এক তৃতীয়াংশ কোৰআনৰ সমান।<br /> নৱম হাদীছ </p>',
      ],
      8 => [
        'question' => 'প্ৰশ্ন নং ৯- এই হাদীছটো সম্পূৰ্ণ কৰা (...لا حول ولا قوة إلا بالله) আৰু ইয়াৰ কেইটামান গুৰুত্বপূৰ্ণ উপকাৰিতা উল্লেখ কৰা?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/9720.mp3',
        'answer' => '<p> উত্তৰ- আবু মুছা ৰাদ্বিয়াল্লাহু আনহুৰ পৰা বৰ্ণিত, ৰাছুলুল্লাহ চাল্লাল্লাহু আলাইহি অছাল্লামে কৈছেঃ লা হাওলা অলা কুউৱাতা ইল্লা বিল্লাহ হৈছে জান্নাতৰ এটা ধন-ভাণ্ডাৰ। ইয়াক বুখাৰী আৰু মুছলিমে বৰ্ণনা কৰিছে।<br /> হাদীছৰ পৰা সংগৃহীত উপকাৰিতাসমূহঃ<br /> ১- এই দুআটোৰ গুৰুত্ব বুজোৱা হৈছে, লগতে এইটো হৈছে জান্নাতৰ এটা সম্পদ।<br /> ২- বান্দাই নিজৰ শক্তি-সামৰ্থক নত কৰি একমাত্ৰ আল্লাহৰ ওপৰত ভৰসা কৰা উচিত।<br /> দশম হাদীছ </p>',
      ],
      9 => [
        'question' => 'প্ৰশ্ন নং ১০- এই হাদীছটো সম্পূৰ্ণ কৰা (ألا إن في الجسد مضغة) আৰু ইয়াৰ কেইটামান গুৰুত্বপূৰ্ণ উপকাৰিতা উল্লেখ কৰা?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/9790.mp3',
        'answer' => '<p> উত্তৰ- নু\'মান ইবনে বাশ্বিৰ ৰাদ্বিয়াল্লাহু আনহুৰ পৰা বৰ্ণিত, তেওঁ কৈছে মই ৰাছুলুল্লাহ চাল্লাল্লাহু আলাইহি অছাল্লামৰ পৰা শুনিছোঁ, তেখেতে কৈছেঃ জানি থোৱা! নিশ্চয় শৰীৰত এনেকুৱা এটুকুৰা মাংস আছে, যদি সেইটো ঠিকে থাকে তেন্তে গোটেই শৰীৰ ঠিকেই থাকে আৰু যদি সেইটো বেয়া হয় তেন্তে গোটেই শৰীৰ বেয়া হৈ যায়। জানি থোৱা! সেইটো হৈছে অন্তৰ। ইয়াক বুখাৰী আৰু মুছলিমে বৰ্ণনা কৰিছে।<br /> হাদীছৰ পৰা সংগৃহীত উপকাৰিতাসমূহঃ<br /> ১- অন্তৰৰ সংশোধনেই হৈছে আভ্যন্তৰীণ আৰু বাহ্যিক সংশোধন।<br /> ২- অন্তৰৰ সংশোধন খুবেই গুৰুত্বপূৰ্ণ, কাৰণ ইয়াৰ দ্বাৰাই মানুহৰ সংশোধন হয়।<br /> একাদশ হাদীছ </p>',
      ],
      10 => [
        'question' => 'প্ৰশ্ন নং ১১- এই হাদীছটো সম্পূৰ্ণ কৰা (من كان آخر كلامه من الدنيا: لا إله إلا الله) আৰু ইয়াৰ কেইটামান গুৰুত্বপূৰ্ণ উপকাৰিতা উল্লেখ কৰা?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/9860.mp3',
        'answer' => '<p> উত্তৰ- মাআজ ইবনে জাবাল ৰাদ্বিয়াল্লাহু আনহুৰ পৰা বৰ্ণিত, ৰাছুলুল্লাহ চাল্লাল্লাহু আলাইহি অছাল্লামে কৈছেঃ যি ব্যক্তিৰ সৰ্বশেষ কথা লা ইলা-হা ইল্লাল্লাহ হ\'ব <span class="c2">(আল্লাহৰ বাহিৰে আন কোনো সত্য ইলাহ নাই,)</span> তেওঁ জান্নাতত প্ৰৱেশ কৰিব। ইয়াক আবু দাউদে বৰ্ণনা কৰিছে<br /> হাদীছৰ পৰা সংগৃহীত উপকাৰিতাসমূহঃ<br /> ১- লা ইলা-হা ইল্লাল্লাহৰ ফজিলত। ইয়াৰ ফলত বান্দা জান্নাতত প্ৰৱেশ কৰিব।<br /> ২- লগতে পাৰ্থিৱ জীৱনৰ সৰ্বশেষ বাক্য "লা ইলা-হা ইল্লাল্লাহ" হোৱাৰ ফজিলত।<br /> দ্বাদশ হাদীছ </p>',
      ],
      11 => [
        'question' => 'প্ৰশ্ন নং ১২- এই হাদীছটো সম্পূৰ্ণ কৰা (ليس المؤمن بالطعان، ولا اللعان) আৰু ইয়াৰ কেইটামান গুৰুত্বপূৰ্ণ উপকাৰিতা উল্লেখ কৰা?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/9940.mp3',
        'answer' => '<p> উত্তৰ- আব্দুল্লাহ ইবনে মাছউদ ৰাদ্বিয়াল্লাহু আনহুৰ পৰা বৰ্ণিত, ৰাছুলুল্লাহ চাল্লাল্লাহু আলাইহি অছাল্লামে কৈছেঃ মুমিন কেতিয়াও পৰনিন্দাকাৰী, অভিশাপকাৰী নহয়, লগতে অভদ্ৰ ভাষা প্ৰয়োগকাৰী আৰু অসংযতও নহয়। ইয়াক তিৰমিজীয়ে বৰ্ণনা কৰিছে<br /> হাদীছৰ পৰা সংগৃহীত উপকাৰিতাসমূহঃ<br /> ১- প্ৰতিটো বেয়া ভাষা আৰু অসংযত কথাৰ পৰা নিষেধ কৰা হৈছে।<br /> ২- এইটো হৈছে মুমিনৰ ভাষাগত বৈশিষ্ট্য।<br /> ত্ৰয়োদশ হাদীছ </p>',
      ],
      12 => [
        'question' => 'প্ৰশ্ন নং ১৩- এই হাদীছটো সম্পূৰ্ণ কৰা (من حسن إسلام المرء) আৰু ইয়াৰ কেইটামান গুৰুত্বপূৰ্ণ উপকাৰিতা উল্লেখ কৰা?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/10020.mp3',
        'answer' => '<p> উত্তৰ- আবু হুৰাইৰাহ ৰাদ্বিয়াল্লাহু আনহুৰ পৰা বৰ্ণিত, তেওঁ ৰাছুলুল্লাহ চাল্লাল্লাহু আলাইহি অছাল্লামৰ পৰা বৰ্ণনা কৰি কৈছে, ৰাছুলুল্লাহ চাল্লাল্লাহু আলাইহি অছাল্লামে কৈছেঃ <span class="c1">“কোনো ব্যক্তিৰ ইছলাম গ্ৰহণ কৰাৰ অন্যতম সৌন্দৰ্য হৈছে, অনৰ্থক অপ্ৰয়োজনীয় বিষয় পৰিত্যাগ কৰা।”</span> <span class="c2">(তিৰমিজী)</span><br /> হাদীছৰ পৰা সংগৃহীত উপকাৰিতাসমূহঃ<br /> ১- বেলেগ ধৰ্মীয় আৰু পাৰ্থিৱ জীৱনৰ অনৰ্থক, অপ্ৰয়োজনীয় বিষয়বোৰ পৰিত্যাগ কৰা উচিত।<br /> ২- অপ্ৰয়োজনীয় তথা অনৰ্থক বিষয় পৰিত্যাগ কৰাটো হৈছে পৰিপূৰ্ণৰূপে ইছলাম গ্ৰহণ কৰাৰ প্ৰতীক।<br /> চতুৰ্দশ হাদীছ </p>',
      ],
      13 => [
        'question' => 'প্ৰশ্ন নং ১৪- এই হাদীছটো সম্পূৰ্ণ কৰা (من قرأ حرفاً من كتاب الله) আৰু ইয়াৰ কেইটামান গুৰুত্বপূৰ্ণ উপকাৰিতা উল্লেখ কৰা?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/10100.mp3',
        'answer' => '<p> উত্তৰ- আব্দুল্লাহ ইবনে মাছউদ ৰাদ্বিয়াল্লাহু আনহুৰ পৰা বৰ্ণিত, নবী চাল্লাল্লাহু আলাইহি অছাল্লামে কৈছেঃ আল্লাহৰ কিতাবৰ পৰা যিয়ে এটা হৰফ <span class="c2">(আখৰ)</span> পাঠ কৰিব, ইয়াৰ ফলত তেওঁ এটা ছোৱাব পাব। লগতে প্ৰতিটো ছোৱাব দহগুণ বৃদ্ধি কৰি প্ৰদান কৰা হ\'ব। মই এইটো নকওঁ যে, আলিফ, লাম, মীম হৈছে এটা হৰফ। বৰং আলিফ হৈছে এটা হৰফ, লাম হৈছে এটা হৰফ আৰু মীম হৈছে এটা হৰফ। ইয়াক তিৰমিজীয়ে বৰ্ণনা কৰিছে<br /> হাদীছৰ পৰা সংগৃহীত উপকাৰিতাসমূহঃ<br /> ১- কোৰআন তিলাৱত কৰাৰ ফজিলত।<br /> ২- প্ৰতিটো আখৰৰ বিনিময়ত আপোনাৰ বাবে আছে ছোৱাব। </p>',
      ],
    ],
    6 => [
      0 => [
        'question' => 'প্ৰশ্ন নং ১- মহান আল্লাহৰ সৈতে শিষ্টাচাৰ কেনেকুৱা হ\'ব লাগে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/10190.mp3',
        'answer' => '<p> উত্তৰ- ১- মহান পৱিত্ৰ আল্লাহক সন্মান কৰিব লাগে।<br /> ২- একমাত্ৰ তেওঁৰেই ইবাদত কৰিব লাগে, তেওঁৰ কোনো অংশীদাৰ নাই।<br /> ৩- তেওঁৰ আনুগত্য কৰিব লাগে।<br /> ৪- তেওঁৰ অবাধ্যতাৰ পৰা বিৰত থাকিব লাগে।<br /> ৫- তেওঁৰ অগণন নিয়ামত আৰু অনুগ্ৰহৰ বাবে তেওঁৰ কৃতজ্ঞতা প্ৰকাশ কৰিব লাগে আৰু তেওঁক প্ৰশংসা কৰিব লাগে।<br /> ৬- তেওঁ নিৰ্ধাৰণ কৰা তাক্বদীৰৰ ওপৰত ধৈৰ্য্য ধাৰণ কৰিব লাগে। </p>',
      ],
      1 => [
        'question' => 'প্ৰশ্ন নং ২- ৰাছুল চাল্লাল্লাহু আলাইহি অছাল্লামৰ সৈতে শিষ্টাচাৰ কেনেকুৱা হ\'ব লাগে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/10270.mp3',
        'answer' => '<p> উত্তৰ- ১- তেওঁক অনুকৰণ আৰু অনুসৰণ কৰিব লাগে।<br /> ২- তেওঁৰ আনুগত্য কৰিব লাগে।<br /> ৩- তেওঁৰ অবাধ্যতাৰ পৰা বিৰত থাকিব লাগে।<br /> ৪- তেওঁ প্ৰদান কৰা সংবাদসমূহক সত্য বুলি বিশ্বাস কৰিব লাগে।<br /> ৫- তেওঁৰ ছুন্নত এৰি বিদআত সৃষ্টি কৰিব নালাগে।<br /> ৬- নিজতকৈ তথা সকলোতকৈ অধিক তেওঁক মুহাব্বত কৰিব লাগে।<br /> ৭- তেওঁক সন্মান কৰিব লাগে, সহায়-সহযোগিতা কৰিব লাগে, লগতে তেওঁৰ ছুন্নতক সহায় কৰিব লাগে। </p>',
      ],
      2 => [
        'question' => 'প্ৰশ্ন নং ৩- পিতৃ-মাতৃৰ সৈতে শিষ্টাচাৰ কেনেকুৱা হ\'ব লাগে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/10360.mp3',
        'answer' => '<p> উত্তৰ- ১- গুনাহৰ বাহিৰে অন্যান্য সকলো ক্ষেত্ৰতে পিতৃ-মাতৃৰ কথা মানি চলা।<br /> ২- পিতৃ-মাতৃৰ খিদমত <span class="c2">(সেৱা)</span> কৰা।<br /> ৩- তেওঁলোকক সহায় কৰা।<br /> ৪- তেওঁলোকৰ প্ৰয়োজন পূৰণ কৰা।<br /> ৫- তেওঁলোকৰ বাবে দুআ কৰা।<br /> ৬- কথা কওঁতে আদবৰ সৈতে কথা কোৱা। আনকি \'উফ\' বা \'ধেৎ\' শব্দ কোৱাটোও বৈধ নহয়।<br /> ৭- পিতৃ-মাতৃৰ সৈতে হাঁহিমুখে কথা কোৱা। মুখত যাতে কোনো প্ৰকাৰ বিৰক্তি ভাৱ নাথাকে।<br /> ৮- পিতৃ-মাতৃৰ সৈতে কথা কোৱাৰ সময়ত তেওঁলোকৰ মাতৰ ওপৰত নিজৰ মাত যাতে উচ্চ নহয় আৰু তেওঁলোকৰ কথা মনোযোগ সহকাৰে শুনিব লাগে, তেওঁলোকৰ কথা কাটিব নালাগে। লগতে তেওঁলোকক নাম ধৰি মাতিব নালাগে, বৰং আম্মা, আব্বা বুলি মাতিব লাগে।<br /> ৯- পিতৃ-মাতৃ কোঠাৰ ভিতৰত থাকিলে, অনুমতি লৈ প্ৰৱেশ কৰিব লাগে।<br /> ১০- পিতৃ-মাতৃৰ হাতত আৰু মূৰত চুমা খাব লাগে। </p>',
      ],
      3 => [
        'question' => 'প্ৰশ্ন নং ৪- আত্মীয়তাৰ সম্পৰ্ক কেনেকৈ বজায় ৰাখিব লাগে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/10490.mp3',
        'answer' => '<p> উত্তৰ- ১- সাক্ষাতৰ মাধ্যমত আত্মীয়তাৰ সম্পৰ্ক বজায় ৰখা, যেনে- ভাই, ভনী, খুৰা, পেহী, মামা, মাহী আৰু অন্যান্য আত্মীয়সকলক সাক্ষাৎ কৰা।<br /> ২- কথা, কৰ্ম আৰু সহায়-সহযোগিতাৰ দ্বাৰা তেওঁলোকক উপকাৰ কৰা।<br /> ৩- এইদৰে তেওঁলোকক ফোন কৰি খা-খবৰ লোৱা আৰু অৱস্থা সম্পৰ্কে সোধ-পোচ কৰা। </p>',
      ],
      4 => [
        'question' => 'প্ৰশ্ন নং ৫- বন্ধুবৰ্গ আৰু ভাতৃবৰ্গৰ সৈতে কেনেকুৱা ব্যৱহাৰ হ\'ব লাগে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/10550.mp3',
        'answer' => '<p> প্ৰশ্ন নং ১- তেওঁলোকক মুহাব্বত কৰিব লাগে, আৰু সৎলোকৰ সংগ অৱলম্বন কৰিব লাগে।<br /> ২- অসৎলোকৰ সংগ ত্যাগ কৰিব লাগে আৰু সিহঁতৰ পৰা আঁতৰি থাকিব লাগে।<br /> ৩- তেওঁলোকক ছালাম কৰিব লাগে আৰু মুচাফাহা কৰিব লাগে।<br /> ৪- তেওঁলোক বেমাৰত পৰিলে শুশ্ৰূষা কৰিব লাগে আৰু আৰোগ্যৰ বাবে দুআ কৰিব লাগে।<br /> ৫- হাঁচি কৰিলে হাঁচিৰ দুআৰ উত্তৰ দিব লাগে।<br /> ৬- নিমন্ত্ৰণ দিলে তেওঁলোকৰ নিমন্ত্ৰণ গ্ৰহণ কৰিব লাগে।<br /> ৭- তেওঁলোকৰ শুভাকাংক্ষী হ\'ব লাগে আৰু সদুপদেশ দিব লাগে।<br /> ৮- নিৰ্যাতিত হ\'লে সহায় কৰা, আৰু অন্যায়-অত্যাচাৰৰ পৰা বিৰত ৰখা।<br /> ৯- মুছলিম ভাতৃৰ বাবেও সেইটোৱে পছন্দ কৰা যিটো নিজৰ বাবে পছন্দনীয়।<br /> ১০- সহায়ৰ প্ৰয়োজন হ\'লে সহায় কৰা।<br /> ১১- কথা বা কৰ্ম যিকোনো উপায়েৰেই নহওক কিয় কষ্ট নিদিয়া।<br /> ১২- তেওঁলোকৰ গোপনীয়তা ৰক্ষা কৰা।<br /> ১৩- গালি পাৰিব নালাগে, সমালোচনা কৰিব নালাগে, হেও প্ৰতিপন্ন কৰিব নালাগে, ঈৰ্ষা কৰিব নালাগে, গোপন তথ্য খুচৰিব নালাগে, লগতে প্ৰৱঞ্চনা কৰিব নালাগে। </p>',
      ],
      5 => [
        'question' => 'প্ৰশ্ন নং ৬- প্ৰতিৱেশীৰ সৈতে কেনেকুৱা শিষ্টাচাৰ হ\'ব লাগে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/10710.mp3',
        'answer' => '<p> উত্তৰ- ১- কথা আৰু কৰ্মৰ দ্বাৰা প্ৰতিৱেশীৰ সৈতে ভাল ব্যৱহাৰ কৰিব লাগে, আৰু যদি সহায়ৰ প্ৰয়োজন হয় তেন্তে সহায় কৰিব লাগে।<br /> ২- ঈদ অথবা বিবাহ আদি আনন্দৰ সময়ত শুভেচ্ছা জ্ঞাপন কৰিব লাগে।<br /> ৩- বেমাৰত পৰিলে শুশ্ৰূষা কৰিব লাগে, দুখ-কষ্টত সান্ত্বনা দিব লাগে।<br /> ৪- সাধ্যানুসাৰে ঘৰত আয়োজন কৰা ভাল খাদ্য তথা আঞ্জা তেওঁলোকক দিব লাগে।<br /> ৫- কথা বা কৰ্মৰ দ্বাৰা তেওঁলোকক কষ্ট দিব নালাগে।<br /> ৬- উচ্চ শব্দ আদিৰ দ্বাৰা তেওঁলোকক আমনি কৰিব নালাগে, তথা তেওঁলোকৰ গোপনীয়তা খুচৰি ফুৰিব নালাগে, লগতে ধৈৰ্য্য ধাৰণ কৰিব লাগে। </p>',
      ],
      6 => [
        'question' => 'প্ৰশ্ন নং ৭- অতিথি আৰু অতিথি আপ্যায়নৰ শিষ্টাচাৰ কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/10800.mp3',
        'answer' => '<p> উত্তৰ- ১- নিমন্ত্ৰণ কৰিলে নিমন্ত্ৰণ গ্ৰহণ কৰিব লাগে।<br /> ২- কাৰোবাক সাক্ষাৎ কৰিবলৈ হ\'লে তেওঁৰ পৰা অনুমতি আৰু সময় লব লাগে।<br /> ৩- প্ৰৱেশৰ পূৰ্বে অনুমতিলৈ প্ৰৱেশ কৰিব লাগে।<br /> ৪- সাক্ষাতৰ সময়ত অনৰ্থক বেছি সময় কটাব নালাগে।<br /> ৫- ঘৰৰ অন্যান্য সদস্যৰ পৰা দৃষ্টি সংযত ৰাখিব লাগে।<br /> ৬- আন্তৰিকতাৰে হাঁহিমুখে উত্তম বাক্যৰ দ্বাৰা অতিথিক আঁদৰিব লাগে।<br /> ৭- অতিথিক উত্তম ঠাইত বহুৱাব লাগে।<br /> ৮- পানাহাৰ আদিৰে অতিথিক আপ্যায়ন কৰিব লাগে। </p>',
      ],
      7 => [
        'question' => 'প্ৰশ্ন নং ৮- বেমাৰ আৰু বেমাৰীক সাক্ষাৎ কৰাৰ শিষ্টাচাৰ উল্লেখ কৰা?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/10900.mp3',
        'answer' => '<p> উত্তৰ- ১- বিষ অনুভৱ কৰিলে সেই ঠাইত সোঁহাত ৰাখি তিনিবাৰ বিছমিল্লাহ পঢ়িব লাগে, আৰু তাৰ পিছত এই দুআ সাতবাৰ পঢ়িব লাগেঃ আউজু বিইঝঝাতিল্লাহি অক্বুদৰাতিহি মিং শ্বাৰ্ৰি মা আজিদু ওৱা উহাজিৰ।<br /> ২- আল্লাহে নিৰ্ধাৰণ কৰা তাক্বদীৰৰ ওপৰত সন্তুষ্ট হ\'ব লাগে আৰু ধৈৰ্য্য ধাৰণ কৰিব লাগে।<br /> ৩- বেমাৰী ভাতৃক সোনকালে সাক্ষাৎ কৰিবলৈ যাব লাগে আৰু তেওঁৰ বাবে দুআ কৰিব লাগে, লগতে তেওঁৰ ওচৰত বেছি সময় বহি বিৰক্ত কৰিব নালাগে।<br /> ৪- দুআ পঢ়ি ফুঁৱাই দিব লাগে।<br /> ৫- ধৈৰ্য্য, দুআ আৰু নামাজৰ উপদেশ দিব লাগে, লগতে সক্ষম অনুযায়ী পৱিত্ৰতা অৰ্জনৰ উপদেশ দিব লাগে।<br /> ৬- এই দুআ সাতবাৰ পঢ়ি বেমাৰীক ফুঁৱাই দিব লাগে। আছআলুল লা-হাল আজীম, ৰাব্বাল আৰশ্বিল আজীম, আঁইয়াশ্বফীক। </p>',
      ],
      8 => [
        'question' => 'প্ৰশ্ন নং ৯- ইল্ম অৰ্জন কৰাৰ শিষ্টাচাৰ উল্লেখ কৰা?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/10990.mp3',
        'answer' => '<p> উত্তৰ- ১- ইখলাচৰ সৈতে আল্লাহৰ উদ্দেশ্যে নিয়ত কৰা।<br /> ২- শিকি লোৱা ইল্মৰ দ্বাৰা আমল কৰা।<br /> ৩- শিক্ষকক সন্মান কৰা, তেওঁৰ উপস্থিতি আৰু অনুপস্থিতিত তেওঁক শ্ৰূদ্ধা কৰা।<br /> ৪- তেওঁৰ সন্মুখত ভদ্ৰভাৱে বহা।<br /> ৫- তেওঁ পঢ়োৱাৰ সময়ত মনোযোগ সহকাৰে শুনা।<br /> ৬- ভদ্ৰতাৰে প্ৰশ্ন কৰা।<br /> ৭- শিক্ষকক নাম ধৰি মাতিব নালাগে। </p>',
      ],
      9 => [
        'question' => 'প্ৰশ্ন নং ১০- বৈঠকৰ শিষ্টাচাৰ কি কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/11090.mp3',
        'answer' => '<p> উত্তৰ- ১- বৈঠকত থকা লোকসকলক ছালাম কৰা।<br /> ২- বৈঠকৰ শেষৰ ফালে বহিব লাগে, বেলেগক উঠাই বহিব নালাগে, লগতে দুজন ব্যক্তিৰ মাজত বহিবলৈ অনুমতি লৈ বহিব লাগে।<br /> ৩- বৈঠক প্ৰশস্ত কৰিব লাগে, যাতে আনেও বহিব পাৰে।<br /> ৪- বৈঠকৰ আলোচনাত বাধা সৃষ্টি কৰিব পৰা কোনো কাম কৰিব নালাগে।<br /> ৫- বৈঠকৰ পৰা গুচি যাবলৈ অনুমতি লব লাগে আৰু ছালাম কৰিব লাগে।<br /> ৬- বৈঠক শেষ হোৱাৰ পিছত বৈঠকৰ কাফফাৰাৰ দুআ পাঠ কৰিব লাগে। ছুবাহানাকা আল্লাহুম্মা অবিহামদিকা, আশ্বহাদু আল লা ইলা-হা ইল্লা আনতা, আছতাগফিৰুকা ওৱা আতুবু ইলাইক। </p>',
      ],
      10 => [
        'question' => 'প্ৰশ্ন নং ১১- টোপনিৰ শিষ্টাচাৰসমূহ উল্লেখ কৰা?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/11180.mp3',
        'answer' => '<p> উত্তৰ- ১- সোনকালে শোৱা।<br /> ২- পৱিত্ৰতা অৰ্জন কৰি শোৱা।<br /> ৩- ওলোটাকৈ বা পেট তলফালে ৰাখি নোশোৱা।<br /> ৪- সোঁহাত সোঁ গালৰ তলত ৰাখি সোঁ কাতিত শোৱা।<br /> ৫- শোৱাৰ আগত বিছনা জোকাৰি পৰিস্কাৰ কৰা।<br /> ৬- টোপনি যোৱাৰ দুআ পাঠ কৰা, আয়াতুল কুৰ্ছী, লগতে ছুৰা ইখলাচ, ছুৰা ফালাক্ব আৰু ছুৰা নাছ তিনিবাৰকৈ পাঠ কৰা। টোপনি যোৱাৰ দুআ হৈছেঃ বিছমিকা আল্লা-হুম্মা আমূতু ওৱা আহয়া।<br /> ৭- ফজৰৰ চালাতৰ বাবে উঠা।<br /> ৮- টোপনিৰ পৰা উঠি এই দুআ পাঠ কৰাঃ আলহাম্দুলিল্লা-হিল লাজী আহয়া-না বাদামা আমা-তানা ৱা ইলাইহিন নুশ্বূৰ। </p>',
      ],
      11 => [
        'question' => 'প্ৰশ্ন নং ১২- ভোজন কৰাৰ শিষ্টাচাৰ কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/11290.mp3',
        'answer' => '<p> উত্তৰ-<br /> ১- আল্লাহৰ আনুগত্যৰ তাক্বৱা অৱলম্বন কৰি পানাহাৰ কৰাৰ নিয়ত কৰা।<br /> ২- পানাহাৰ কৰাৰ পূৰ্বে দুয়ো হাত ভালকৈ ধুই লোৱা।<br /> ৩- বিছমিল্লাহ কোৱা, আৰু সোঁহাতেৰে নিজৰ কাষৰ পৰা খোৱা। থালৰ মাজৰ পৰা খাব নালাগে অথবা আনৰ সন্মুখৰ পৰাও খাব নালাগে।<br /> ৪- বিছমিল্লাহ কোৱা পাহৰি গ\'লে, "বিছমিল্লা-হি আওৱালিহি ওৱা আ-খিৰিহি" বুলি কোৱা।<br /> ৫- উপিস্থিত ভোজনকলৈ সন্তুষ্ট হ\'ব লাগে, কোনো খুঁত উলিয়াব নালাগে। পছন্দ হ\'লে খাব লাগে, নহ\'লে থৈ দিব লাগে।<br /> ৬- মুখত কমকৈ লৈ চোবাব লাগে, বেছি লব নালাগে।<br /> ৭- খাদ্য দ্ৰৱ্য বা পানীয় গৰম থাকিলে তাত ফুঁৱাব নালাগে, বৰং ঠাণ্ডা হ\'বলৈ এৰি দিব লাগে।<br /> ৮- ঘৰৰ সকলো সদস্যই অথবা অতিথিৰ লগত একেলগে মিলি ভোজন কৰিব লাগে।<br /> ৯- ডাঙৰে আৰম্ভ কৰাৰ আগতে সৰুৱে খোৱা আৰম্ভ কৰিব নালাগে।<br /> ১০- পানী পান কৰাৰ সময়ত বিছমিল্লাহ ক\'ব লাগে, লগতে বহি সেৱন কৰিব লাগে আৰু তিনিবাৰত সেৱন কৰিব লাগে।<br /> ১১- ভোজন শেষ কৰি আলহাম্দুলিল্লাহ ক\'ব লাগে। </p>',
      ],
      12 => [
        'question' => 'প্ৰশ্ন নং ১৩- পোছাক পৰিধান কৰাৰ নিয়ম কি কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/11440.mp3',
        'answer' => '<p> উত্তৰ- ১- পোছাক পৰিধান কৰোঁতে সোঁফালেৰে আৰম্ভ কৰা, আৰু ইয়াৰ পিছত আলহাম্দুলিল্লাহ কোৱা।<br /> ২- কাপোৰ যাতে ভৰিৰ সৰুগাঁঠিৰ তলত নাহে।<br /> ৩- ল\'ৰাই ছোৱালীৰ কাপোৰ পিন্ধা নিষিদ্ধ আৰু ছোৱালীয়ে ল\'ৰাৰ কাপোৰ পিন্ধা নিষিদ্ধ।<br /> ৪- কাফিৰ ফাছিক্বৰ লিবাছৰ সাদৃশ্যতা গ্ৰহণ নকৰা।<br /> ৫- কাপোৰ খোলাৰ সময়ত বিছমিল্লাহ কোৱা।<br /> ৬- জোতা, ছেণ্ডেল পিন্ধাৰ সময়ত প্ৰথমে সোঁ ভৰিৰটো পিন্ধিব লাগে আৰু খোলাৰ সময়ত প্ৰথমে বাওঁ ভৰিৰটো খুলিব লাগে। </p>',
      ],
      13 => [
        'question' => 'প্ৰশ্ন নং ১৪- পৰিবহণৰ শিষ্টাচাৰ উল্লেখ কৰা?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/11540.mp3',
        'answer' => '<p> উত্তৰ- ১- বাহনত উঠি এই দুআ ক\'ব লাগে, বিছমিল্লাহ, আলহাম্দুলিল্লাহ, ছুবহা-নাল লাজী ছাখখাৰা লানা হা-জা অমা কুন্না লাহু মুক্বৰিনীন। ওৱা ইন্না ইলা ৰাব্বিনা লামুংকালিবূন। <span class="c2">(ছুৰা আজ-ঝুখৰূফঃ ১৩,১৪)</span><br /> ২- পথত কোনো মুছলিমক লগ পালে ছালাম দিয়া। </p>',
      ],
      14 => [
        'question' => 'প্ৰশ্ন নং ১৫- পথৰ শিষ্টাচাৰ উল্লেখ কৰা?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/11590.mp3',
        'answer' => '<p> উত্তৰ- মধ্যম পন্থাৰে তথা বিনম্ৰতাৰে খোজকাঢ়িব লাগে, আৰু পথৰ বাওঁফালেৰে খোজকাঢ়িব লাগে।<br /> ২- পথত লগ পোৱা লোকক ছালাম দিয়া।<br /> ৩- দৃষ্টি সংযত ৰাখি খোজকাঢ়িব লাগে, লগতে কাকো কষ্ট দিব নালাগে।<br /> ৪- সৎকৰ্মৰ আদেশ আৰু অসৎকৰ্মৰ পৰা নিষেধ কৰিব লাগে।<br /> ৫- পথৰ পৰা কষ্টদায়ক বস্তু আঁতৰাই দিব লাগে। </p>',
      ],
      15 => [
        'question' => 'প্ৰশ্ন নং ১৬- ঘৰত প্ৰৱেশ কৰা আৰু ওলোৱাৰ নিয়ম উল্লেখ কৰা?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/11670.mp3',
        'answer' => '<p> উত্তৰ- ১- ওলোৱাৰ সময়ত বাওঁ ভৰি উলিয়াব লাগে আৰু এই দুআ পাঠ কৰিব লাগেঃ বিছমিল্লাহি তাৱাক্কালতু আলাল্লাহ, লা হাওলা অলা কুওৱাতা ইল্লা বিল্লাহ, আল্লা-হুম্মা ইন্নি আউজুবিকা আন আজিল্লা আও উজাল্লা, আও আঝিল্লা আও উঝাল্লা, আও আজলামা আও উজলামা, আও আজহালা আও ইউজহালা আলাইয়্যা। ২- ঘৰত প্ৰৱেশ কৰাৰ সময়ত সোঁ ভৰি আগত দিব লাগে আৰু এই দুআ পঢ়িব লাগেঃ বিছমিল্লা-হি অলাজনা, অবিছমিল্লা-হি খাৰাজনা, ওৱা আলা ৰাব্বিনা তাৱাক্কালনা।<br /> ৩- মিছৱাক কৰি প্ৰৱেশ কৰিব লাগে আৰু তাৰ পিছত ঘৰৰ মানুহক ছালাম দিব লাগে। </p>',
      ],
      16 => [
        'question' => 'প্ৰশ্ন নং ১৭- শৌচ-প্ৰস্ৰাৱ কৰাৰ নিয়ম-নীতি উল্লেখ কৰা?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/11730.mp3',
        'answer' => '<p> উত্তৰ- ১- শৌচালয়ত প্ৰৱেশ কৰাৰ সময়ত প্ৰথমে বাওঁ ভৰি দিব লাগে।<br /> ২- প্ৰৱেশ কৰাৰ পূৰ্বে এই দুআ পাঠ কৰিব লাগেঃ বিছমিল্লাহ, আল্লা-হুম্মা ইন্নি আউজুবিকা মিনাল খুবছি অল খাবা-ইছ।<br /> ৩- আল্লাহৰ নাম থকা কোনো বস্তু লৈ প্ৰৱেশ কৰিব নালাগে।<br /> ৪- প্ৰস্ৰাৱ-পায়খানা কৰাৰ সময়ত পৰ্দা কৰিব লাগে।<br /> ৫- প্ৰস্ৰাৱ-পায়খানা কৰাৰ সময়ত কথা ক\'ব নালাগে।<br /> ৬- শৌচ-প্ৰস্ৰাৱ কৰাৰ সময়ত কিবলামুখী হৈ অথবা কিবলাক পিছমোৱা কৰি বহিব নালাগে।<br /> 7- বাওঁ হাতেৰে অপৱিত্ৰতা দূৰ কৰিব লাগে, সোঁহাতেৰে নহয়।<br /> ৮- পথৰ দাঁতিত অথবা ছাঁযুক্ত গছৰ তলত মল ত্যাগ কৰিব নালাগে।<br /> ৯- প্ৰস্ৰাৱ-পায়খানাৰ পৰা আহি দুয়ো হাত ভালকৈ ধুব লাগে।<br /> ১০- শৌচালয়ৰ পৰা ওলোৱাৰ সময়ত এই দুআ পঢ়িব লাগে "গুফৰা-নাকা"। </p>',
      ],
      17 => [
        'question' => 'প্ৰশ্ন নং ১৮- মছজিদৰ শিষ্টাচাৰসমূহ উল্লেখ কৰা?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/11860.mp3',
        'answer' => '<p> উত্তৰ- ১- মছজিদত প্ৰৱেশ কৰাৰ সময়ত সোঁ ভৰি আগতে দিব লাগে আৰু এই দুআ পঢ়িব লাগেঃ বিছমিল্লাহ, আল্লা-হুম্মাফ তাহলী আবওৱাবা ৰাহমাতিক।<br /> ২- দুই ৰাকাত নপঢ়াকৈ বহিব নালাগে।<br /> ৩- নামাজ পঢ়ি থকা ব্যক্তিৰ সন্মুখেৰে পাৰ হ\'ব নালাগে। লগতে হেৰুৱা বস্তুৰ ঘোষণা কৰিব নালাগে। এইদৰে কিনা-বেচাও কৰিব নালাগে।<br /> ৪- মছজিদৰ পৰা ওলোৱাৰ সময়ত বাওঁ ভৰি আগতে উলিয়াব লাগে আৰু এই দুআ পঢ়িব লাগেঃ আল্লা-হুম্মা ইন্নি আছআলুকা মিন ফাজলিক। </p>',
      ],
      18 => [
        'question' => 'প্ৰশ্ন নং ১৯- ছালামৰ শিষ্টাচাৰসমূহ উল্লেখ কৰা?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/11930.mp3',
        'answer' => '<p> উত্তৰ- কোনো মুছলিমক লগ পালে প্ৰথমে এইদৰে ছালাম দিব লাগে, <span class="c2">(আচ্ছালামু আলাইকুম অৰাহমাতুল্লাহি অবাৰাকাতুহ)</span>, অকল হাতেৰে ইংগিত কৰিব নালাগে।<br /> ২- হাঁহিমুখে ছালাম কৰা।<br /> ৩- সোঁহাতেৰে মুচাফাহা কৰা।<br /> ৪- যদি কোনোবাই ছালাম কৰে তেন্তে তেওঁৰ ছালামৰ উত্তৰ উত্তমভাৱে দিয়া উচিত অথবা অনুৰূপ উত্তৰ দিয়া উচিত।<br /> ৫- অমুছলিমক প্ৰথমে ছালাম দিব নালাগে, যদি অমুছলিমে ছালাম দিয়ে তেন্তে ওৱা আলাইকুম বুলি ক\'ব লাগে।<br /> ৬- সৰুৱে ডাঙৰক ছালাম দিব লাগে, বাহনত যোৱা ব্যক্তিয়ে খোজকাঢ়ি যোৱা ব্যক্তিক ছালাম দিব লাগে, আৰু খোজকাঢ়ি যোৱা ব্যক্তিয়ে বহি থকা ব্যক্তিক ছালাম দিব লাগে, এইদৰে কম সংখ্যক লোকে বেছি সংখ্যক লোকক ছালাম দিব লাগে। </p>',
      ],
      19 => [
        'question' => 'প্ৰশ্ন নং ২০- অনুমতি লোৱাৰ শিষ্টাচাৰবোৰ উল্লেখ কৰা?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/12020.mp3',
        'answer' => '<p> উত্তৰ- ১- ঘৰত প্ৰৱেশ কৰাৰ আগত অনুমতি লোৱা।<br /> ২- সৰ্বোচ্চ তিনিবাৰ অনুমতি বিচাৰিব লাগে, যদি কোনো উত্তৰ পোৱা নাযায় তেন্তে গুচি যাব লাগে।<br /> ৩- গৃহত প্ৰৱেশ কৰাৰ সময়ত বেল বজাব লাগে নাইবা দুৱাৰত টোকাৰিব লাগে। দুৱাৰৰ সন্মুখত থিয় হ\'ব নালাগে, বৰং সোঁফালে বা বাওঁফালে থিয় হ\'ব লাগে।<br /> ৪- পিতৃ-মাতৃ অথবা আন কাৰোবাৰ কোঠাত প্ৰৱেশ কৰিবলৈ হ\'লে অনুমতি লৈ প্ৰৱেশ কৰিব লাগে, বিশেষকৈ ফজৰৰ আগত, দুপৰীয়া বিশ্ৰাম লোৱাৰ সময়ত আৰু ঈশ্বাৰ চালাতৰ পিছত।<br /> ৫- ৰাজহুৱা ঠাইত অথবা মানুহে বাস নকৰা ঘৰত অনুমতি নোলোৱাকৈ প্ৰৱেশ কৰিব পাৰি। উদাহৰণস্বৰূপে হস্পিটেল, শ্বপিং মল আদিত। </p>',
      ],
      20 => [
        'question' => 'প্ৰশ্ন নং ২১- জীৱ-জন্তুৰ সৈতে কেনেকুৱা আচৰণ কৰিব লাগে উল্লেখ কৰা?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/12100.mp3',
        'answer' => '<p> উত্তৰ- ১- জীৱ-জন্তুৰ বাবে খাদ্য যোগান ধৰিব লাগে আৰু পানীৰ ব্যৱস্থা কৰিব লাগে।<br /> ২- জীৱ-জন্তুৰ প্ৰতি দয়া কৰিব লাগে, আৰু সিহঁতৰ ওপৰত এনেকুৱা বোজা বহন কৰাব নালাগে যিটো বহন কৰিবলৈ সি সক্ষম নহয়।<br /> ৩- জীৱ-জন্তুক কোনো ধৰণৰ শাস্তি বিহিব নালাগে তথা কোনো প্ৰকাৰ নিৰ্যাতন কৰিব নালাগে। </p>',
      ],
      21 => [
        'question' => 'প্ৰশ্ন নং ২২- খেলা-ধূলাৰ শিষ্টাচাৰসমূহ উল্লেখ কৰা?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/12160.mp3',
        'answer' => '<p> উত্তৰ- ১- আল্লাহৰ আনুগত্য আৰু তেওঁৰ সন্তুষ্টিৰ বাবে তাক্বৱা অৱলম্বন কৰি খেলা-ধূলা কৰা।<br /> ২- নামাজৰ সময়ত খেলা-ধূলা নকৰা।<br /> ৩- ল’ৰাসকলে ছোৱালীসকলৰ লগত খেলা-ধূলা কৰিব নালাগে।<br /> ৪- আওৰাহ ঢাকিব পৰা কাপোৰ পৰিধান কৰি খেলা-ধূলা কৰা। <span class="c2">(আওৰাহ হৈছে শৰীৰ সেই অত্যাৱশ্যকীয় অংগসমূহ যিবোৰক ঢাকি ৰাখিবলৈ চৰীয়তে নিৰ্দেশ দিছে)</span><br /> ৫- নিষিদ্ধ খেলৰ পৰা আঁতৰি থকা, যেনে- মুখত আঘাত কৰা খেল অথবা আওৰাহ উন্মোচিত হোৱা খেল আদি। </p>',
      ],
      22 => [
        'question' => 'প্ৰশ্ন নং ২৩- মস্কৰা বা ধেমালি কৰাৰ শিষ্টাচাৰ উল্লেখ কৰা?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/12240.mp3',
        'answer' => '<p> উত্তৰ- ১- সততাৰ সৈতে ধেমালি কৰা, মিছা কথাৰ মাধ্যমত নহয়।<br /> ২- এনেকুৱা ধেমালি হ\'ব লাগে, য\'ত ইতিকিং কৰা, বিদ্ৰূপ কৰা, কষ্ট দিয়া আৰু ভয়-ভাবুকি দিয়া আদি যাতে নাথাকে।<br /> ৩- অধিক ধেমালি নকৰা। </p>',
      ],
      23 => [
        'question' => 'প্ৰশ্ন নং ২৪- হাঁচিৰ শিষ্টাচাৰসমূহ উল্লেখ কৰা?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/12300.mp3',
        'answer' => '<p> উত্তৰ- ১-হাঁচি কৰাৰ সময়ত হাত অথবা কাপোৰ নাইবা ৰোমাল আদি নাকত ধৰিব লাগে।<br /> ২- হাঁচি কৰাৰ পিছত "আলহাম্দুলিল্লাহ" ক\'ব লাগে।<br /> ৩- তেওঁৰ ওচৰত থকা ব্যক্তিয়ে "য়াৰহামুকাল্লাহ" ক\'ব লাগে।<br /> য়াৰহামুকাল্লাহ কোৱা ব্যক্তিক এইদৰে দুআ দিব লাগেঃ "য়াহদিকুমুল্লাহু ৱা ইউচলিহ বা-লাকুম"। </p>',
      ],
      24 => [
        'question' => 'প্ৰশ্ন নং ২৫- হামি কঢ়াৰ শিষ্টাচাৰ কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/12360.mp3',
        'answer' => '<p> উত্তৰ- ১- সক্ষম অনুযায়ী হামি বন্ধ কৰাৰ চেষ্টা কৰা।<br /> ২- হামি কৰাৰ সময়ত জোৰে শব্দ নকৰা।<br /> ৩- মুখৰ ওপৰত হাত ৰখা। </p>',
      ],
      25 => [
        'question' => 'প্ৰশ্ন নং ২৬- কোৰআন তিলাৱত কৰাৰ শিষ্টাচাৰ উল্লেখ কৰা।',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/12420.mp3',
        'answer' => '<p> উত্তৰ- ১- অজু কৰি তিলাৱত কৰিব লাগে।<br /> ২- আদব সহকাৰে ভদ্ৰতাৰে বহিব লাগে।<br /> ৩- তিলাৱত আৰম্ভ কৰাৰ আগত আউজুবিল্লা-হি মিনাশ্ব শ্বাইত্বনিৰ ৰাজীম পাঠ কৰিব লাগে।<br /> ৪- তিলাৱত কৰা আয়াতখিনি অৰ্থ সহকাৰে বুজাৰ চেষ্টা কৰিব লাগে। </p>',
      ],
    ],
    7 => [
      0 => [
        'question' => 'প্ৰশ্ন নং ১- উত্তম চৰিত্ৰৰ ফজিলত কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/12500.mp3',
        'answer' => '<p> উত্তৰ- নবী চাল্লাল্লাহু আলাইহি অছাল্লামে কৈছেঃ মুমিনসকলৰ মাজত পূৰিপূৰ্ণ ঈমানৰ অধিকাৰী সেইজন, তেওঁলোকৰ মাজত যাৰ চৰিত্ৰ সৰ্বোত্তম। <span class="c2">(তিৰমিজী আৰু আহমদে বৰ্ণনা কৰিছে)</span> </p>',
      ],
      1 => [
        'question' => 'প্ৰশ্ন নং ২- ইছলামী নৈতিকতাৰ আমাক কিয় প্ৰয়োজন?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/12530.mp3',
        'answer' => '<p> উত্তৰ- ইছলামী নৈতিকতা এইকাৰণেই প্ৰয়োজন যে, ১- এই নৈতিকতাই আল্লাহক মুহাব্বত কৰা শিকায়।<br /> ২- সৃষ্টিক মুহাব্বত কৰা শিকায়।<br /> ৩- আৰু এই নৈতিকতা মীঝানত হ\'ব অধিক গধূৰ।<br /> ৪- উত্তম চৰিত্ৰ তথা নৈতিকতাৰ ফলত ছোৱাব বৃদ্ধি হয়।<br /> ৫- নৈতিকতা তথা উত্তম চৰিত্ৰ হৈছে পৰিপূৰ্ণ ঈমানৰ প্ৰতীক। </p>',
      ],
      2 => [
        'question' => 'প্ৰশ্ন নং ৩- উত্তম চৰিত্ৰ তথা নৈতিকতা আমি ক\'ৰ পৰা গ্ৰহণ কৰিম?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/12600.mp3',
        'answer' => '<p> উত্তৰ- আল-কোৰআনুল কাৰীমৰ পৰা। যেনে- আল্লাহ তাআলাই কৈছেঃ নিশ্চয় এই কোৰআনে সৰল তথা সুদৃঢ় পথৰ পিনে হিদায়ত কৰে। <span class="c2">(ছুৰা আল-ইছৰাঃ ৯)</span> আৰু প্ৰিয় নবী চাল্লাল্লাহু আলাইহি অছাল্লামৰ হাদীছৰ পৰা, যেনে তেখেতে কৈছেঃ নিশ্চয় মই নৈতিকতাক পূৰ্ণতা প্ৰদান কৰিবলৈ নবী হিচাপে আগমন কৰিছোঁ। ইয়াক ইমাম আহমদে বৰ্ণনা কৰিছে। </p>',
      ],
      3 => [
        'question' => 'প্ৰশ্ন নং ৪- এহছান বা উপকাৰিতাৰ গুণ কি, আৰু ইয়াৰ কেইটামান উদাহৰণ দিয়া?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/12640.mp3',
        'answer' => '<p> উত্তৰ- এহছানৰ অৰ্থ হৈছে এই অনুভূতি পোষণ কৰা যে, সদায় আল্লাহে দেখি আছে, লগতে সৃষ্টিৰ উপকাৰ কৰা তথা কল্যাণ কৰাকো এহছান বোলে।<br /> যেনে- নবী চাল্লাল্লাহু আলাইহি অছাল্লামে কৈছেঃ নিশ্চয় আল্লাহে প্ৰতিটো বিষয়তে তোমালোকৰ ওপৰত এহছান অনিবাৰ্য কৰিছে। ইয়াক মুছলিমে বৰ্ণনা কৰিছে।<br /> উদাহৰণস্বৰূপে এহছান যেনে-<br /> আল্লাহৰ ইবাদতৰ ক্ষেত্ৰত এহছান, অৰ্থাৎ নিৰ্ভেজালভাৱে ইখলাচৰ সৈতে তেওঁৰ ইবাদত কৰা।<br /> পিতৃ-মাতৃৰ প্ৰতি এহছান, কথা আৰু কৰ্মৰ দ্বাৰা।<br /> আত্মীয়-স্বজনৰ সৈতে উত্তম ব্যৱহাৰ কৰিব লাগে।<br /> প্ৰতিৱেশীৰ সৈতে উত্তম ব্যৱহাৰ কৰিব লাগে।<br /> অনাথ আৰু দুখীয়া-দৰিদ্ৰৰ প্ৰতি উত্তম ব্যৱহাৰ কৰিব লাগে।<br /> আপোনাক দুখ দিয়া লোকৰ প্ৰতিও উত্তম ব্যৱহাৰ কৰিব লাগে।<br /> কথা-বতৰাৰ ক্ষেত্ৰতো উত্তম ব্যৱহাৰ কৰিব লাগে।<br /> বাদ-বিবাদৰ ক্ষেত্ৰতো উত্তম ব্যৱহাৰ কৰিব লাগে।<br /> জীৱ-জন্তুৰ প্ৰতি উত্তম ব্যৱহাৰ কৰিব লাগে। </p>',
      ],
      4 => [
        'question' => 'প্ৰশ্ন নং ৫- এহছানৰ বিপৰীত শব্দ কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/12780.mp3',
        'answer' => '<p> উত্তৰ- এহছানৰ বিপৰীত হৈছে ইছাআহ <span class="c2">(কষ্ট দিয়া)</span>।<br /> উদাহৰণস্বৰূপেঃ ইখলাচৰ সৈতে আল্লাহৰ ইবাদত নকৰা।<br /> পিতৃ-মাতৃৰ অবাধ্যতা কৰা।<br /> আত্মীয়তাৰ সম্পৰ্ক বিচ্ছিন্ন কৰা।<br /> প্ৰতিৱেশীক কষ্ট দিয়া।<br /> কথা আৰু কৰ্মৰ দ্বাৰা ফকীৰ মিছকীন তথা দুখীয়া-দৰিদ্ৰক কষ্ট দিয়া। </p>',
      ],
      5 => [
        'question' => 'প্ৰশ্ন নং ৬- আমানত বা সততা আৰু ইয়াৰ ধৰণ কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/12860.mp3',
        'answer' => '<p> উত্তৰ-<br /> ১- আল্লাহৰ অধিকাৰ সংৰক্ষণ কৰাৰ ক্ষেত্ৰত আমানত।<br /> উদাহৰণস্বৰূপে- সততা বা আমানতৰ সৈতে ইবাদত আদায় কৰা, যেনে- চালাত, জাকাত, চিয়াম, হজ্জ আদি ইবাদত যিবোৰ আল্লাহে আমাৰ ওপৰত ফৰজ কৰিছে।<br /> ২- সৃষ্টিৰ অধিকাৰ সংৰক্ষণ কৰাৰ ক্ষেত্ৰত আমানত।<br /> উদাহৰণস্বৰূপে- মানুহৰ মান-সন্মান ৰক্ষা কৰা।<br /> সিহঁতৰ ধন-সম্পদ<br /> সিহঁতৰ তেজ<br /> আৰু সিহঁতৰ গোপনীয়তা, লগতে মানুহে বিশ্বাস কৰি আপোনাক দিয়া সকলো প্ৰকাৰ দায়িত্ব সততাৰে ৰক্ষা কৰা।<br /> মহান আল্লাহে সফল লোকৰ গুণাগুন বৰ্ণনা কৰি কৈছেঃ আৰু <span class="c2">(তেওঁলোক হৈছে বিশ্বস্ত)</span> যিসকলে নিজৰ আমানত আৰু প্ৰতিশ্ৰুতি ৰক্ষা কৰে, <span class="c2">(ছুৰা আল-মুমিনূনঃ ৮)</span> </p>',
      ],
      6 => [
        'question' => 'প্ৰশ্ন নং ৭- বিশ্বস্ততাৰ বিপৰীত কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/12980.mp3',
        'answer' => '<p> উত্তৰ- বিশ্বাসঘাতকতা, অৰ্থাৎ আল্লাহৰ অধিকাৰ আৰু মানুহৰ অধিকাৰ খৰ্ব কৰা।<br /> যেনে- নবী চাল্লাল্লাহু আলাইহি অছাল্লামে কৈছেঃ মুনাফিকৰ চিহ্ন হৈছে তিনিটা, তাৰে এটা হৈছে আমানত ৰাখিলে বিশ্বাসঘাতকতা কৰা। মুত্তাফাক্ব আলাইহ </p>',
      ],
      7 => [
        'question' => 'প্ৰশ্ন নং ৮- সত্যতা কাক বোলে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/13020.mp3',
        'answer' => '<p> উত্তৰ- সত্যতা হৈছে বাস্তৱৰ লগত মিল থকা কোনো সংবাদ বা সঁচা কথা কোৱা।<br /> উদাহৰণস্বৰূপেঃ<br /> মানুহৰ সৈতে সত্য কথা কোৱা, অৰ্থাৎ মিছা কথা নোকোৱা।<br /> সঁচা প্ৰতিশ্ৰুতি কৰা।<br /> প্ৰতিটো কথা-কৰ্ম সততাৰে কৰা।<br /> যেনে- নবী চাল্লাল্লাহু আলাইহি অছাল্লামে কৈছেঃ নিশ্চয় সত্যতাই নেকীৰ পথ দেখুৱায়, আৰু নেকীয়ে জান্নাতৰ ফালে লৈ যায়। কোনো ব্যক্তিয়ে যেতিয়া সদায় সত্য কথা কয় তেতিয়া তাৰ নাম সত্যবাদী হিচাপে লিপিবদ্ধ কৰা হয়। মুত্তাফাক্ব আলাইহ </p>',
      ],
      8 => [
        'question' => 'প্ৰশ্ন নং ৯- সত্যৰ বিপৰীত কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/13100.mp3',
        'answer' => '<p> উত্তৰ- সত্যৰ বিপৰীত হৈছে মিছা, অৰ্থাৎ বাস্তৱৰ বিপৰীত। যেনে- মানুহৰ লগত মিছা কথা কোৱা, প্ৰতিশ্ৰুতি ভঙ্গ কৰা, মিছা সাক্ষী দিয়া।<br /> যেনে- নবী চাল্লাল্লাহু আলাইহি অছাল্লামে কৈছেঃ আনহাতে মিছাই পাপকৰ্মৰ পথ দেখুৱায়, আৰু পাপকৰ্মই মানুহক জাহান্নামৰ ফালে লৈ যায়, কোনোবাই যেতিয়া অধিক মিছা কথা কয়, অৱশেষত আল্লাহৰ ওচৰত তাক মিছলীয়া বুলি লিপিবদ্ধ কৰা হয়। মুত্তাফাক্ব আলাইহ নবী চাল্লাল্লাহু আলাইহি অছাল্লামে আৰু কৈছেঃ মুনাফিকৰ চিহ্ন হৈছে তিনিটা, তাত তেখেতে উল্লেখ কৰিছে, "কথা ক\'লে মিছা কথা কয় আৰু প্ৰতিশ্ৰুতি দিলে ভংগ কৰে।" মুত্তাফাক্ব আলাইহ </p>',
      ],
      9 => [
        'question' => 'প্ৰশ্ন নং ১০- ধৈৰ্য্যৰ প্ৰকাৰসমূহ উল্লেখ কৰা?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/13140.mp3',
        'answer' => '<p> উত্তৰ- আল্লাহৰ আনুগত্যৰ ক্ষেত্ৰত ধৈৰ্য্য ধাৰণ কৰা।<br /> গুনাহ পৰিত্যাগ কৰাৰ ক্ষেত্ৰত ধৈৰ্য্য ধাৰণ কৰা।<br /> কষ্টদায়ক ঘটনাৰ ক্ষেত্ৰত তাক্বদীৰৰ ওপৰত ধৈৰ্য্য ধাৰণ কৰা। লগতে সৰ্বাৱস্থাতেই আল্লাহৰ প্ৰশংসা কৰা।<br /> আল্লাহে কৈছেঃ আল্লাহে ধৈৰ্য্যশীলসকলক পছন্দ কৰে। <span class="c2">(ছুৰা আলে-ইমৰাণঃ ১৪৬)</span> আৰু নবী চাল্লাল্লাহু আলাইহি অছাল্লামে কৈছেঃ মুমিনৰ অৱস্থা বৰ অদ্ভুত। নিশ্চয় মুমিনৰ প্ৰতিটো কামেই তেওঁৰ বাবে কল্যাণকৰ। মুমিনৰ বাহিৰে আন কাৰো বাবে এই কল্যাণৰ ব্যৱস্থা নাই। মুমিন ব্যক্তি সুখী হ\'লে <span class="c2">(আল্লাহৰ)</span> কৃতজ্ঞতা প্ৰকাশ কৰে, এইটো তেওঁৰ বাবে কল্যাণকৰ। আনহাতে দুখ-কষ্টত আক্ৰান্ত হ\'লে ধৈৰ্য্য ধাৰণ কৰে, এইটোও তেওঁৰ বাবেই কল্যাণকৰ। ইয়াক মুছলিমে বৰ্ণনা কৰিছে। </p>',
      ],
      10 => [
        'question' => 'প্ৰশ্ন নং ১১- ধৈৰ্য্যৰ বিপৰীত কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/13210.mp3',
        'answer' => '<p> উত্তৰ- আনুগত্যৰ ক্ষেত্ৰত ধৈৰ্য্য ধাৰণ নকৰা, পাপকৰ্ম পৰিত্যাগ কৰাৰ ক্ষেত্ৰত ধৈৰ্য্য ধাৰণ নকৰা, ভাগ্যৰ ওপৰত অতিষ্ঠ হৈ কথা অথবা কৰ্মৰ দ্বাৰা অসন্তুষ্টি প্ৰকাশ কৰা।<br /> উদাহৰণস্বৰূপেঃ<br /> মৃত্যু কামনা কৰা।<br /> গালত চৰিওৱা।<br /> কাপোৰ ফালি পেলোৱা।<br /> চুলিবোৰ আউল-বাউল কৰা।<br /> নিজৰ ধ্বংসৰ বাবে বদ-দুআ কৰা।<br /> যেনে- নবী চাল্লাল্লাহু আলাইহি অছাল্লামে কৈছেঃ বিপদ যিমান মাৰাত্মক হয়, প্ৰতিদানো সিমানেই মহান হয়। আল্লাহে যেতিয়া কোনো সম্প্ৰদায়ক পছন্দ কৰে তেতিয়া তেওঁলোকক <span class="c2">(বিপদগ্ৰস্ত কৰি)</span> পৰীক্ষা কৰে। যিয়ে তাত সন্তুষ্ট থাকে, তেওঁ <span class="c2">(আল্লাহৰ)</span> সন্তুষ্টি অৰ্জন কৰে। আনহাতে যিয়ে অসন্তুষ্ট হয়, সি <span class="c2">(আল্লাহৰ)</span> অসন্তুষ্টি অৰ্জন কৰে। তিৰমিজী আৰু ইবনে মাজাহে বৰ্ণনা কৰিছে। </p>',
      ],
      11 => [
        'question' => 'প্ৰশ্ন নং ১২- সহায়-সহযোগিতা কেনে ধৰণৰ হ\'ব লাগে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/13310.mp3',
        'answer' => '<p> উত্তৰ- মানুহে পৰস্পৰে পৰস্পৰক সত্য আৰু কল্যাণৰ দিশত সহায়-সহযোগিতা কৰিব লাগে।<br /> সহায়-সহযোগিতাৰ উদাহৰণ যেনে-<br /> প্ৰাপ্য অধিকাৰ পুনৰুদ্ধাৰ কৰি দিয়াত সহায় কৰা।<br /> জালিমৰ অন্যায়-অত্যাচাৰ ৰোধ কৰাত সহায় কৰা।<br /> দুখীয়া-দৰিদ্ৰ তথা অভাৱী মানুহৰ প্ৰয়োজন পূৰণত সহায় কৰা।<br /> প্ৰতিটো কল্যাণকৰ কামত সহায় কৰা।<br /> হিংসা, বিদ্বেষ, শত্ৰুতা আৰু গুনাহ তথা পাপকৰ্মত সহায় নকৰা।<br /> আল্লাহে কৈছেঃ সৎকৰ্ম আৰু তাক্বৱাৰ বিষয়ত তোমালোকে পৰস্পৰক সহায়-সহযোগিতা কৰিবা আৰু পাপকৰ্ম তথা সীমালংঘনত এজনে আনজনক সহায়-সহযোগিতা নকৰিবা, লগতে আল্লাহৰ তাক্বৱা অৱলম্বন কৰা। নিশ্চয় আল্লাহ শাস্তি প্ৰদানত অতি কঠোৰ। <span class="c2">(ছুৰা আল-মায়িদাহঃ ২)</span> যেনে- নবী চাল্লাল্লাহু আলাইহি অছাল্লামে কৈছেঃ এজন মুমিন আন এজন মুমিনৰ বাবে দেৱালস্বৰূপ, যাৰ এটা অংশই আন এটা অংশক সুদৃঢ় কৰি ৰাখে। মুত্তাফাক্ব আলাইহ নবী চাল্লাল্লাহু আলাইহি অছাল্লামে আৰু কৈছেঃ এজন মুছলিম হৈছে আন এজন মুছলিমৰ ভাই। গতিকে তেওঁ তাৰ অন্যায় কৰিব নালাগে আৰু তাক অন্যায়কাৰীৰ হাতত অৰ্পন কৰিবও নালাগে। যিয়ে নিজৰ ভাতৃৰ অভাৱ পূৰণ কৰিব, আল্লাহে তাৰ অভাৱ পূৰণ কৰিব। যিয়ে <span class="c2">(পৃথিৱীত)</span> কোনো মুছলিমৰ বিপদ দূৰ কৰিব, আল্লাহে কিয়ামতৰ দিনা তাৰ বিপদ দূৰ কৰি দিব। যিয়ে কোনো মুছলিম ব্যক্তিৰ দোষ গোপন কৰিব, আল্লাহে কিয়ামতৰ দিনা তাৰ দোষ গোপন ৰাখিব। মুত্তাফাক্ব আলাইহ </p>',
      ],
      12 => [
        'question' => 'প্ৰশ্ন নং ১৩- হায়া বা লাজ কিহৰ পৰা কৰিব লাগে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/13420.mp3',
        'answer' => '<p> উত্তৰ- ১- আল্লাহৰ পৰা হায়া কৰিব লাগেঃ অৰ্থাৎ পৱিত্ৰ আল্লাহৰ পৰা হায়া কৰি গুনাহৰ পৰা বিৰত থাকিব লাগে।<br /> ২- মানুহৰ পৰা হায়া কৰিব লাগেঃ অৰ্থাৎ মানুহৰ সৈতে বেয়া ভাষা প্ৰয়োগ কৰিব নালাগে আৰু মানুহৰ সন্মুখত আওৰাহ <span class="c2">(শৰীৰৰ যিখিনি অংগ ঢাকি ৰখা অনিবাৰ্য)</span> উন্মোচন কৰিব নালাগে।<br /> আল্লাহৰ ৰাছুল চাল্লাল্লাহু আলাইহি অছাল্লামে কৈছেঃ ঈমানৰ ষাটি অথবা সত্তৰটাৰো অধিক শাখা-প্ৰশাখা আছে। ইয়াৰ সৰ্বোচ্চ শাখাটো হৈছে লা ইলা-হা ইল্লাল্লাহ <span class="c2">(অৰ্থাৎ আল্লাহৰ বাহিৰে আন কোনো সত্য উপাস্য নাই)</span>, আনহাতে সৰ্বনিম্ন শাখাটো হৈছেঃ পথৰ পৰা কষ্টদায়ক বস্তু আঁতৰাই দিয়া। আৰু হায়া বা লাজ হৈছে ঈমানৰ এটা অন্যতম শাখা। ইয়াক মুছলিমে বৰ্ণনা কৰিছে। </p>',
      ],
      13 => [
        'question' => 'প্ৰশ্ন নং ১৪- উদাহৰণৰ সৈতে দয়া কৰাৰ বিষয়ে উল্লেখ কৰা?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/13470.mp3',
        'answer' => '<p> উত্তৰ- যেনে- বৃদ্ধলোকক সন্মান কৰা তথা তেওঁলোকৰ প্ৰতি দয়া কৰা।<br /> সৰুৰ প্ৰতি তথা শিশুৰ প্ৰতি দয়া কৰা।<br /> দুখীয়া-দৰিদ্ৰ আৰু অভাৱীৰ প্ৰতি দয়া কৰা।<br /> জীৱ-জন্তুৰ প্ৰতি দয়া কৰা, সিহঁতৰ বাবে খাদ্যৰ যোগান ধৰা আৰু সিহঁতক কষ্ট নিদিয়া।<br /> এইক্ষেত্ৰত নবী চাল্লাল্লাহু আলাইহি অছাল্লামে কৈছেঃ পাৰস্পৰিক দয়া, ভালপোৱা আৰু সহানুভূতি প্ৰদৰ্শনৰ ক্ষেত্ৰত তুমি মুমিনসকলক এটা শৰীৰৰ দৰে দেখিবলৈ পাবা। যেতিয়া শৰীৰৰ এটা অংগ ৰোগাক্ৰান্ত হয়, তেতিয়া শৰীৰৰ প্ৰতিটো অংগ প্ৰত্যংগই ৰাতি জাগৰণ কৰে তথা জ্বৰত ভোগে। মুত্তাফাক্ব আলাইহ আৰু আল্লাহৰ ৰাছুল চাল্লাল্লাহু আলাইহি অছাল্লামে কৈছেঃ দয়াশীলসকলৰ ওপৰত কৰুণাময় আল্লাহে দয়া কৰে। তোমালোকে পৃথিৱীবাসীসকলৰ ওপৰত দয়া কৰা, তেতিয়াহে সেই সত্ত্বাই তোমালোকৰ ওপৰত দয়া কৰিব যিজন আকাশত আছে। ইয়াক আবু দাউদ আৰু তিৰমিজীয়ে বৰ্ণনা কৰিছে। </p>',
      ],
      14 => [
        'question' => 'প্ৰশ্ন নং ১৫- মুহাব্বতৰ প্ৰকাৰসমূহ কি কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/13550.mp3',
        'answer' => '<p> উত্তৰ- আল্লাহৰ সৈতে মুহাব্বত কৰা।<br /> আল্লাহে কৈছেঃ আৰু যিসকলে ঈমান আনিছে তেওঁলোকে আল্লাহক অত্যন্ত ভাল পায়। <span class="c2">(ছুৰা আল-বাক্বাৰাহঃ ১৬৫)</span><br /> ৰাছুলক মুহাব্বত কৰা<br /> তেখেতে কৈছেঃ শপত সেই সত্ত্বাৰ, যাৰ হাতত মোৰ প্ৰাণ আছে, তোমালোকৰ মাজৰ কোনেও তেতিয়ালৈকে প্ৰকৃত মুমিন হ\'ব নোৱাৰিব, যেতিয়ালৈকে মই তাৰ ওচৰত তাৰ পিতৃতকৈ আৰু সন্তানতকৈও অধিক প্ৰিয় নহওঁ। বুখাৰীয়ে বৰ্ণনা কৰিছে।<br /> মুমিনসকলক মুহাব্বত কৰা, লগতে নিজৰ বাবে যিটো পছন্দনীয় সেইটো তেওঁলোকৰ বাবেও পছন্দ কৰা।<br /> যেনে- নবী চাল্লাল্লাহু আলাইহি অছাল্লামে কৈছেঃ “তোমালোকৰ মাজৰ কোনেও তেতিয়ালৈকে প্ৰকৃত মুমিন হ’ব নোৱাৰিব যেতিয়ালৈকে তেওঁ নিজৰ বাবে যিটো পছন্দ কৰে সেইটো আনৰ বাবেও পছন্দ নকৰিব।’ বুখাৰীয়ে বৰ্ণনা কৰিছে। </p>',
      ],
      15 => [
        'question' => 'প্ৰশ্ন নং ১৬- প্ৰফুল্লতা কাক বোলে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/13630.mp3',
        'answer' => '<p> উত্তৰ- অৰ্থাৎ মানুহৰ সৈতে সাক্ষাৎ কৰাৰ সময়ত আনন্দ-স্ফূৰ্তিৰ সৈতে মিছিকিয়া হাঁহিমুখে সাক্ষাৎ কৰা।<br /> এইটো হৈছে মানুহৰ সন্মুখত বিৰক্তি ভাৱ প্ৰকাশৰ বিপৰীত, যাৰ ফলত মানুহ আঁতৰি যায়।<br /> হাঁহিমুখে সাক্ষাৎ কৰাৰ ফজিলত সম্পৰ্কে হাদীছত আহিছে, আবু জৰ ৰাদ্বিয়াল্লাহু আনহুৰ পৰা বৰ্ণিত, তেওঁ কৈছেঃ মোক নবী চাল্লাল্লাহু আলাইহি অছাল্লামে কৈছেঃ কোনো সৎকৰ্মকেই তুমি তুচ্ছ জ্ঞান নকৰিবা। যদিও সেইটো তোমাৰ <span class="c2">(মুছলিম)</span> ভাতৃৰ সৈতে হাঁহিমুখে সাক্ষাৎ কৰাই নহওক কিয়। ইয়াক মুছলিমে বৰ্ণনা কৰিছে। আল্লাহৰ ৰাছুল চাল্লাল্লাহু আলাইহি অছাল্লামে আৰু কৈছেঃ হাঁহিমুখে তোমাৰ ভাতৃৰ সৈতে সাক্ষাৎ কৰাটোও হৈছে এটা চাদাক্বাহ। ইয়াক তিৰমিজীয়ে বৰ্ণনা কৰিছে </p>',
      ],
      16 => [
        'question' => 'প্ৰশ্ন নং ১৭- হাছাদ (ঈৰ্ষা) কাক বোলে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/13690.mp3',
        'answer' => '<p> উত্তৰ- আনৰ ওপৰত হোৱা নিয়ামতক অপছন্দ কৰা অথবা সেই নিয়ামতৰ ধ্বংস কামনা কৰা।<br /> যেনে- পৱিত্ৰ কোৰআনত আছেঃ "আৰু <span class="c2">(মই আশ্ৰয় বিচাৰোঁ)</span> হিংসুকৰ অনিষ্টৰ পৰা, যেতিয়া সি হিংসা কৰে।" <span class="c2">(ছুৰা আল-ফালাক্বঃ ৫)</span><br /> আনাছ বিন মালিক ৰাদ্বিয়াল্লাহু আনহুৰ পৰা বৰ্ণিত, ৰাছুলুল্লাহ চাল্লাল্লাহু আলাইহি অছাল্লামে কৈছেঃ তোমালোকে পৰস্পৰে বিদ্বেষ পোষণ নকৰিবা, পৰস্পৰে হিংসা নকৰিবা, এজনে আনজনৰ পৰা পৃথক হৈ নাযাবা। হে আল্লাহৰ বান্দাসকল! পৰস্পৰে ভাতৃ হৈ যোৱা। ইয়াক বুখাৰী আৰু মুছলিমে বৰ্ণনা কৰিছে। </p>',
      ],
      17 => [
        'question' => 'প্ৰশ্ন নং ১৮- ইতিকিং কৰা কাক বোলে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/13740.mp3',
        'answer' => '<p> উত্তৰ- কাৰোবাক হেও প্ৰতিপন্ন কৰিবলৈ ঠাট্টা-বিদ্ৰূপ কৰা। এইটো বৈধ নহয়।<br /> ইয়াৰ নিষিদ্ধতা সম্পৰ্কে আল্লাহ তাআলাই কৈছেঃ হে ঈমান্দাৰসকল! কোনো মুমিন সম্প্ৰদায়ে যেন আন কোনো মুমিন সম্প্ৰদায়ৰ উপহাস নকৰে, কিয়নো যিসকলক উপহাস কৰা হৈছে তেওঁলোকে উপহাসকাৰী সকলতকৈ উত্তম হ’ব পাৰে; আৰু নাৰীসকলেও যেন আন আন নাৰীসকলক উপহাস নকৰে, কিয়নো যিসকলৰ উপহাস কৰা হৈছে তেওঁলোকে উপহাসকাৰীণী বিলাকতকৈও উত্তম হ’ব পাৰে। লগতে তোমালোকে ইজনে সিজনৰ প্ৰতি দোষাৰোপ নকৰিবা আৰু এজনে আনজনক বেয়া নামেৰে নামাতিবা; ঈমানৰ পিছত বেয়া নাম অতি নিকৃষ্ট। এতেকে <span class="c2">(জানি থোৱা)</span> যিসকলে তাওবা নকৰে সিহঁতেই যালিম। <span class="c2">(ছুৰা আল-হুজুৰাতঃ ১১)</span> </p>',
      ],
      18 => [
        'question' => 'প্ৰশ্ন নং ১৯- তাৱাজু কাক বোলে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/13780.mp3',
        'answer' => '<p> উত্তৰ- মানুহতকৈ নিজকে ডাঙৰ বুলি নভবা, লগতে মানুহক হেও প্ৰতিপন্ন নকৰা আৰু সত্যক অস্বীকাৰ নকৰা।<br /> আল্লাহে কৈছেঃ আৰু ৰহমানৰ প্ৰকৃত বান্দা হৈছে তেওঁলোকেই, যিসকলে পৃথিৱীত অত্যন্ত বিনম্ৰভাৱে চলাফুৰা কৰে। <span class="c2">(ছুৰা আল-ফুৰক্বানঃ ৬৩)</span> অৰ্থাৎ বিনীত হৈ। আৰু আল্লাহৰ ৰাছুল চাল্লাল্লাহু আলাইহি অছাল্লামে কৈছেঃ আৰু যিয়ে আল্লাহৰ বাবে বিনয়ী হয়, আল্লাহে তাৰ মৰ্যাদা উন্নীত কৰি দিয়ে। ইয়াক মুছলিমে বৰ্ণনা কৰিছে। তেখেত চাল্লাল্লাহু আলাইহি অছাল্লামে কৈছেঃ মহান আল্লাহে মোৰ ওচৰলৈ এই বিষয়ে অহী প্ৰেৰণ কৰিছে যে, তোমালোকে বিনয়ী হোৱা, যাতে কোনেও কাৰো ওপৰত অন্যায় নকৰে আৰু অহংকাৰো নকৰে। ইয়াক মুছলিমে বৰ্ণনা কৰিছে। </p>',
      ],
      19 => [
        'question' => 'প্ৰশ্ন নং ২০- নিষিদ্ধ অহংকাৰৰ প্ৰকাৰসমূহ কি কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/13840.mp3',
        'answer' => '<p> উত্তৰ- ১- সত্যৰ প্ৰতি অহংকাৰ কৰা, অৰ্থাৎ সত্যক প্ৰত্যাখ্যান কৰা আৰু সত্য গ্ৰহণ নকৰা।<br /> ২- মানুহৰ প্ৰতি অহংকাৰ কৰা, অৰ্থাৎ মানুহক হেও প্ৰতিপন্ন কৰা তথা সিহঁতক নিম্নমানৰ বুলি ভবা।<br /> আল্লাহৰ ৰাছুল চাল্লাল্লাহু আলাইহি অছাল্লামে কৈছেঃ যাৰ অন্তৰত অণু পৰিমাণ অহংকাৰ থাকিব, সি জান্নাতত প্ৰৱেশ কৰিব নোৱাৰিব। এই কথা শুনি এজনে সুধিলেঃ <span class="c2">(হে আল্লাহৰ ৰাছুল!)</span> মানুহে পছন্দ কৰে তেওঁ পিন্ধা কাপোৰযোৰ উত্তম হওক তথা তেওঁৰ জোতাযোৰ উত্তম হওক, <span class="c2">(এইটোও অহংকাৰ নেকি?)</span> তেখেতে ক\'লেঃ নিশ্চয় আল্লাহ সৌন্দৰ্যময় আৰু তেওঁ সৌন্দৰ্যক পছন্দ কৰে। আনহাতে অহংকাৰ হৈছে সত্যক প্ৰত্যাখ্যান কৰা আৰু মানুহক হেও প্ৰতিপন্ন কৰা। ইয়াক মুছলিমে বৰ্ণনা কৰিছে।<br /> بَطَرُ الحَقِّ অৰ্থাৎ সত্য প্ৰত্যাখ্যান কৰা।<br /> غَمْطُ النَّاسِ অৰ্থাৎ মানুহক হেও প্ৰতিপন্ন কৰা।<br /> উত্তম কাপোৰ পিন্ধা আৰু উত্তম জোতা পিন্ধাটো অহংকাৰ নহয়। </p>',
      ],
      20 => [
        'question' => 'প্ৰশ্ন নং ২১- কেইটামান নিষিদ্ধ প্ৰতাৰণাৰ প্ৰকাৰ উল্লেখ কৰা?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/13910.mp3',
        'answer' => '<p> উত্তৰ- কিনা বেচাত প্ৰতাৰণা কৰা, অৰ্থাৎ বিক্ৰী কৰিবলৈ লোৱা বস্তুৰ দোষ গোপন ৰখা।<br /> শিক্ষা অৰ্জনৰ ক্ষেত্ৰত প্ৰতাৰণা কৰা। উদাহৰণস্বৰূপে পৰীক্ষাত নকল কৰা।<br /> কথা-বতৰাত প্ৰতাৰণা কৰা। যেনে- মিছা কথা কোৱা তথা মিছা সাক্ষী দিয়া।<br /> মানুহৰ লগত হোৱা চুক্তি ভংগ কৰা।<br /> ঠগ-প্ৰৱঞ্চনা তথা প্ৰতাৰণা নিষিদ্ধ সম্পৰ্কে হাদীছত আহিছে, এবাৰ ৰাছুলুল্লাহ চাল্লাল্লাহু আলাইহি অছাল্লামে <span class="c2">(বজাৰৰ এটি)</span> খাদ্য সম্ভাৰৰ ওচৰেৰে অতিক্ৰম কৰি আছিল, হঠাৎ তেখেতে সেই খাদ্য সম্ভাৰৰ মাজত হাত সোমোৱাই দিলে, আৰু তেখেতে গম পালে যে, ভিতৰৰ বস্তুখিনি সেমেকি আছে তথা তিতি আছে। তেখেতে ক\'লেঃ "হে খাদ্য সামগ্ৰীৰ গৰাকী! এইটো কি কথা?" তেওঁ ক\'লেঃ "হে আল্লাহৰ ৰাছুল! বৰষুণৰ ফলত এনেকুৱা হৈছে।" তেখেতে ক\'লেঃ "তুমি ইয়াক ওপৰত কিয় নাৰাখিলা,<span class="c6"> যাতে মানুহে চাব পাৰে? শুনা! যিয়ে প্ৰতাৰণা কৰে সি আমাৰ অন্তৰ্ভুক্ত নহয়।" ইয়াক মুছলিমে বৰ্ণনা কৰিছে।<br /> الصُّبْرَة:</span> হাদীছত বৰ্ণিত এই শব্দটোৰ অৰ্থ হৈছেঃ খাদ্য সামগ্ৰীৰ স্তূপ। </p>',
      ],
      21 => [
        'question' => 'প্ৰশ্ন নং ২২- গীবত কাক বোলে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/13990.mp3',
        'answer' => '<p> উত্তৰ- কোনো মুছলিম ভাতৃৰ অনুপস্থিতিত তাৰ বিষয়ে এনেকুৱা কথা কোৱা যিটোক সি অপছন্দ কৰে।<br /> আল্লাহে কৈছেঃ আৰু এজনে আনজনৰ গীবত নকৰিবা। তোমালোকৰ মাজৰ কোনোবাই তাৰ মৃত ভাতৃৰ মাংস খোৱোটো পছন্দ কৰিবনে? নিশ্চয় তোমালোকে তাক অপছন্দ কৰা। গতিকে তোমালোকে আল্লাহৰ তাক্বৱা অৱলম্বন কৰা; নিশ্চয় আল্লাহ তাওবা কবুলকাৰী, পৰম দয়ালু। <span class="c2">(ছুৰা আল-হুজুৰাতঃ ১২)</span> </p>',
      ],
      22 => [
        'question' => 'প্ৰশ্ন নং ২৩- চুগলি কৰা বা খলুৱাগিৰি কৰা কাক বোলে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14030.mp3',
        'answer' => '<p> উত্তৰ- মানুহৰ মাজত জগৰ লগাবলৈ অ\'ৰ কথা ত\'ত লগাই ফুৰাক চুগলি কৰা বা খলুৱাগিৰি কৰা বোলে।<br /> আল্লাহৰ ৰাছুল চাল্লাল্লাহু আলাইহি অছাল্লামে কৈছেঃ অ\'ৰ কথা ত\'ত লগাই ফুৰা ব্যক্তি জান্নাতত প্ৰৱেশ নকৰিব। ইয়াক মুছলিমে বৰ্ণনা কৰিছে। </p>',
      ],
      23 => [
        'question' => 'প্ৰশ্ন নং ২৪- অৱহেলা কাক কয়?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14070.mp3',
        'answer' => '<p> উত্তৰ- কল্যাণকৰ কামক গধূৰ অনুভৱ কৰা, তথা মানুহৰ কোনো অত্যাৱশ্যকীয় কামত লেহেমীয়া কৰা।<br /> উদাহৰণস্বৰূপেঃ ধৰ্মীয় অনিবাৰ্যমূলক কামত অৱহেলা কৰা।<br /> আল্লাহ তাআলাই কৈছেঃ নিশ্চয় মুনাফিকসকলে আল্লাহৰ লগত প্ৰতাৰণা কৰে, প্ৰকৃততে তেৱেঁই সিহঁতক প্ৰতাৰিত কৰে, আৰু যেতিয়া সিহঁতে ছালাতত থিয় হয় তেতিয়া অলসতাভাৱে থিয় হয়, কেৱল লোকক দেখুৱাবলৈ। আল্লাহক সিহঁতে অতিকৈ কম স্মৰণ কৰে। <span class="c2">(ছুৰা আন-নিছাঃ ১৪২)</span><br /> গতিকে মুমিনৰ কৰ্তব্য হৈছে অলসতা, অৱহেলা, এলাহ ভাৱ পৰিত্যাগ কৰা, আৰু এই পাৰ্থিৱ জীৱনত কঠোৰ পৰিশ্ৰম আৰু অধ্যৱসায়ৰ সৈতে এনেকুৱা আমল কৰিব লাগে, যি আমলত আল্লাহ সন্তুষ্ট হ\'ব। </p>',
      ],
      24 => [
        'question' => 'প্ৰশ্ন নং ২৫- ক্ৰোধৰ প্ৰকাৰসমূহ উল্লেখ কৰা?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14130.mp3',
        'answer' => '<p> উত্তৰ- ১- প্ৰশংসনীয় ক্ৰোধঃ কাফিৰ, মুনাফিক, ভণ্ড, বা আন কোনো লোকে আল্লাহৰ কোনো সীমা উলংঘা কৰাৰ ফলত জন্ম হোৱা ক্ৰোধ হৈছে প্ৰশংসনীয় ক্ৰোধ।<br /> ২- অপছন্দনীয় ক্ৰোধঃ যি ক্ৰোধে মানুহক এনেকুৱা কথা বা কাম কৰিবলৈ বাধ্য কৰায়, যিটো কৰা তাৰ বাবে উচিত নহয়।<br /> অপছন্দনীয় ক্ৰোধৰ চিকিৎসাঃ<br /> অজু কৰা।<br /> থিয় হৈ থাকিলে বহিব লাগে আৰু বহি থাকিলে শুব লাগে।<br /> লগতে এইক্ষেত্ৰত নবী চাল্লাল্লাহু আলাইহি অছাল্লামৰ উপদেশৰ প্ৰতি আমল কৰিব লাগে। তেখেতে কৈছেঃ <span class="c2">(খং নকৰিবা)</span>।<br /> ক্ৰোধৰ সময়ত নিজকে নিয়ন্ত্ৰণ কৰা।<br /> আউজু বিল্লা-হি মিনাশ্ব শ্বাইত্বনিৰ ৰাজীম। <span class="c2">(মই অভিশপ্ত চয়তানৰ পৰা আল্লাহৰ আশ্ৰয় প্ৰাৰ্থনা কৰোঁ)</span> এই দুআ পাঠ কৰা।<br /> মৌনতা অৱলম্বন কৰা। </p>',
      ],
      25 => [
        'question' => 'প্ৰশ্ন নং ২৬- তাজাচ্ছুছ কাক বোলে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14240.mp3',
        'answer' => '<p> উত্তৰ- মানুহৰ দোষ-ত্ৰুটি খুচৰি ফুৰা আৰু সিহঁতৰ গোপন তথ্য লোক-সমাজত উন্মোচিত কৰাক তাজাচ্ছুছ বোলে।<br /> নিষিদ্ধ তাজাচ্ছুছ বা চোৰাংচোৱাগিৰি যেনে-<br /> মানুহৰ ঘৰৰ মাজৰ গোপন তথ্য খুচৰি ফুৰা।<br /> মানুহে নজনাকৈ লুকাই লুকাই মানুহৰ কথা শ্ৰৱণ কৰা।<br /> আল্লাহে কৈছেঃ আৰু তোমালোকে মানুহৰ দোষ-ত্ৰুটি খুচৰি নুফুৰিবা। <span class="c2">(ছুৰা আল-হুজুৰাতঃ ১২)</span> </p>',
      ],
      26 => [
        'question' => 'প্ৰশ্ন নং ২৭- অপচয় কাক বোলে? কৃপণতা কাক কয়? আৰু উদাৰতা কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14310.mp3',
        'answer' => '<p> ইছৰাফ বা অপচয় হৈছে অপ্ৰয়োজনত ধন-সম্পদ ব্যয় কৰা।<br /> আনহাতে কৃপণতা হৈছে প্ৰয়োজনতো ধন-সম্পদ ব্যয় নকৰা।<br /> কিন্তু উত্তম পন্থা হৈছে এই দুয়োৰে মধ্যৱৰ্তী পথ। লগতে মুছলিম ব্যক্তি উদাৰ হোৱা উচিত।<br /> আল্লাহে কৈছেঃ তেওঁলোকে যেতিয়া ব্যয় কৰে, তেতিয়া অপব্যয় নকৰে, আৰু কৃপণতাও নকৰে, বৰং তেওঁলোকে এই দুয়োৰে মধ্যৱৰ্তী পন্থা অৱলম্বন কৰে। <span class="c2">(ছুৰা আল-ফুৰক্বানঃ ৬৭)</span> </p>',
      ],
      27 => [
        'question' => 'প্ৰশ্ন নং ২৮- কাপুৰুষতা কি? আৰু সাহসিকতা কাক বোলে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14370.mp3',
        'answer' => '<p> উত্তৰ- কাপুৰুষতা হৈছে, যাক দেখি ভয় কৰিব নালাগে তাক দেখি ভয় কৰা।<br /> উদাহৰণস্বৰূপে সত্য কথা কওঁতে ভয় কৰা আৰু বাতিলৰ বিৰোধিতা কৰিবলৈ ভয় কৰা।<br /> সাহসিকতা হৈছে, সত্যৰ সৈতে আগুৱাই যোৱা। যেনে- ইছলাম আৰু মুছলিমৰ হৈ প্ৰতিৰক্ষাৰ বাবে সংগ্ৰাম কৰা।<br /> এইকাৰণেই নবী চাল্লাল্লাহু আলাইহি অছাল্লামে দুআ কৰি কৈছিলঃ হে আল্লাহ! মই কাপুৰুষতাৰ পৰা তোমাৰ ওচৰত আশ্ৰয় প্ৰাৰ্থনা কৰোঁ। আৰু আল্লাহৰ ৰাছুল চাল্লাল্লাহু আলাইহি অছাল্লামে কৈছেঃ আল্লাহৰ দৃষ্টিত দুৰ্বল মুমিনতকৈ শক্তিশালী মুমিন উত্তম তথা অধিক পছন্দনীয়, প্ৰতিটো কল্যাণকৰ ক্ষেত্ৰতেই। ইয়াক মুছলিমে বৰ্ণনা কৰিছে। </p>',
      ],
      28 => [
        'question' => 'প্ৰশ্ন নং ২৯- এনেকুৱা কেইটিমান মৌখিক বিষয় উল্লেখ কৰা যিবোৰ কোৱা নিষিদ্ধ?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14440.mp3',
        'answer' => '<p> উদাহৰণস্বৰূপে অভিশাপ কৰা, গালি-শপনি দিয়া।<br /> কাৰোবাক জানুৱাৰ বুলি কোৱা, অথবা এইধৰণৰ কোনো শব্দ প্ৰয়োগ কৰা।<br /> অশ্লীল তথা নিকৃষ্ট ভাষা ব্যৱহাৰ কৰা।<br /> উক্ত সকলো বিষয়ে নবী চাল্লাল্লাহু আলাইহি অছাল্লামে নিষেধাজ্ঞা জাৰি কৰিছে, তেখেতে কৈছেঃ মুমিন কেতিয়াও পৰনিন্দাকাৰী, অভিশাপকাৰী নহয়, লগতে অভদ্ৰ ভাষা প্ৰয়োগকাৰী আৰু অসংযতও নহয়। তিৰমিজী আৰু ইবনে হিব্বানে বৰ্ণনা কৰিছে। </p>',
      ],
      29 => [
        'question' => 'প্ৰশ্ন নং ৩০- এনেকুৱা কেইটিমান উপায় উল্লেখ কৰা, যাৰ ফলত এজন মুছলিমৰ বাবে উত্তম চৰিত্ৰ অৱলম্বন কৰাত সহায়ক হ\'ব?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14500.mp3',
        'answer' => '<p> উত্তৰ- এই দুআ কৰা যে, আল্লাহে যেন তোমাক উত্তম চৰিত্ৰ গ্ৰহণ কৰাৰ তাওফীক দান কৰে আৰু এইক্ষেত্ৰত তোমাক সহায় কৰে।<br /> ২- এই কথা মনত ৰখা যে, আল্লাহে সদায় তোমাক প্ৰত্যক্ষ কৰি আছে। তেওঁ তোমাৰ বিষয়ে অৱগত, তেওঁ তোমাৰ সকলো কথা শুনে আৰু তোমাক দেখি আছে।<br /> ৩- উত্তম চৰিত্ৰৰ ছোৱাব মনত ৰাখিবা, লগতে এই কথা স্মৰণ কৰিবা যে উত্তম চৰিত্ৰ হৈছে জান্নাতত প্ৰৱেশৰ কাৰণ।<br /> ৪- এইদৰে বেয়া চৰিত্ৰৰ পৰিণাম মনত ৰাখিবা, লগতে এই কথাও মনত ৰাখিবা যে, এইটো হৈছে জাহান্নামত যোৱাৰ কাৰণ।<br /> ৫- উত্তম চৰিত্ৰৰ ফলত আল্লাহৰ মুহাব্বত আৰু মানুহৰ মুহাব্বত অৰ্জন হয়। আনহাতে বেয়া চৰিত্ৰৰ ফলত আল্লাহৰ ঘৃণা আৰু মানুহৰ ঘৃণা অৰ্জিত হয়।<br /> ৬- নবী চাল্লাল্লাহু আলাইহি অছাল্লামৰ জীৱনী অধ্যয়ন কৰা আৰু তাৰ অনুসৰণ কৰা।<br /> ৭- সৎলোকৰ সংগ অৱলম্বন কৰা, আৰু অসৎলোকৰ পৰা আঁতৰি থকা। </p>',
      ],
    ],
    8 => [
      0 => [
        'question' => 'প্ৰশ্ন নং ১- জিকৰ বা আল্লাহক স্মৰণৰ ফজিলত কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14630.mp3',
        'answer' => '<p> উত্তৰ- নবী চাল্লাল্লাহু আলাইহি অছাল্লামে কৈছেঃ যি ব্যক্তিয়ে জিকৰ-আজকাৰ পাঠ কৰে আৰু যিয়ে পাঠ নকৰে, সিহঁতৰ উদাহৰণ হৈছে মৃত আৰু জীৱিতৰ দৰে। বুখাৰীয়ে বৰ্ণনা কৰিছে।<br /> কাৰণ মানুহৰ জীৱনৰ মূল্য এই কথাৰ ওপৰত নিৰ্ভৰ কৰে যে, তেওঁ কিমান সঘনাই মহান আল্লাহক স্মৰণ কৰে। </p>',
      ],
      1 => [
        'question' => 'প্ৰশ্ন নং ২- জিকৰ-আজকাৰ কৰাৰ উপকাৰিতা কি কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14670.mp3',
        'answer' => '<p> উত্তৰ- ১- মহান কৰুণাময় <span class="c2">(আল্লাহ)</span> সন্তুষ্ট হয়।<br /> ২- চয়তান বিতাৰিত হয়।<br /> ৩- মুছলিম ব্যক্তি অনিষ্টৰ পৰা সুৰক্ষিত থাকে।<br /> ৪- ইয়াৰ ফলত ছোৱাব তথা নেকী অৰ্জন হয়। </p>',
      ],
      2 => [
        'question' => 'প্ৰশ্ন নং ৩- সৱাতোকৈ উত্তম জিকৰ কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14730.mp3',
        'answer' => '<p> উত্তৰ- লা ইলা-হা ইল্লাল্লাহ। <span class="c2">(আল্লাহৰ বাহিৰে আন কোনো সত্য ইলাহ নাই)</span>। তিৰমিজী আৰু ইবনে মাজাহে বৰ্ণনা কৰিছে। </p>',
      ],
      3 => [
        'question' => 'প্ৰশ্ন নং ৪- টোপনিৰ পৰা উঠি কি দুআ পঢ়িব লাগে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14760.mp3',
        'answer' => '<p> উত্তৰ- আলহাম্দুলিল্লা-হিল লাজী আহয়া-না বা\'দামা আমা-তানা ৱা ইলাইহিন নুশ্বূৰ। <span class="c2">(সকলো ধৰণৰ প্ৰশংসা আল্লাহৰ বাবে, যিয়ে আমাক মৃত্যুৰ পিছত জীৱিত কৰিলে, আৰু তেওঁৰ ওচৰতেই পুনৰ্জীৱিত হৈ যাব লাগিব।)</span> মুত্তাফাক্ব আলাইহ </p>',
      ],
      4 => [
        'question' => 'প্ৰশ্ন নং ৫- কাপোৰ পিন্ধাৰ সময়ত কোনটো দুআ পঢ়িব লাগে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14790.mp3',
        'answer' => '<p> উত্তৰ- আলহামদু লিল্লা-হিল লাজী, কাছা-নী, হা-জাছ ছাওবা, অৰাঝাক্বানীহি মিন গাইৰি হাওলিম মিন্নী অলা কুওৱাহ। <span class="c2">(সকলো ধৰণৰ প্ৰশংসা একমাত্ৰ আল্লাহৰ বাবে, যিয়ে মোক এইটো কাপোৰ পৰিধান কৰাৰ তাওফীক দিছে। মোৰ ফালৰ পৰা বিনা কোনো শক্তি আৰু ক্ষমতাৰে তেওঁ মোক প্ৰদান কৰিছে।)</span> আবু দাউদ আৰু তিৰমিজীয়ে বৰ্ণনা কৰিছে। </p>',
      ],
      5 => [
        'question' => 'প্ৰশ্ন নং ৬- কাপোৰ খোলাৰ সময়ত কোনটো দুআ পঢ়িব লাগে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14820.mp3',
        'answer' => '<p> উত্তৰ- বিছমিল্লাহ। ইয়াক তিৰমিজীয়ে বৰ্ণনা কৰিছে </p>',
      ],
      6 => [
        'question' => 'প্ৰশ্ন নং ৭- নতুন কাপোৰ পিন্ধাৰ দুআ কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14850.mp3',
        'answer' => '<p> আল্লা-হুম্মা লাকাল হামদু আনতা কাছাওতানীহি, আছআলুকা খাইৰাহু অখাইৰা মা চুনিআ লাহ, ওৱা আউজুবিকা মিন শ্বাৰ্ৰিহী অশ্বাৰ্ৰি মা চুনিআ লাহ। (হে আল্লাহ! প্ৰশংসা একমাত্ৰ তোমাৰ বাবেই, তুমিয়েই মোক পৰিধান কৰোৱাইছা, মই তোমাৰ পৰা ইয়াৰ কল্যাণ কামনা কৰোঁ আৰু সেই কল্যাণ কামনা কৰোঁ যিটোৰ বাবে ইয়াক তৈয়াৰ কৰা হৈছে। লগতে ইয়াৰ অনিষ্টতাৰ পৰা আৰু যি উদ্দেশ্যে ইয়াক তৈয়াৰ কৰা হৈছে তাৰ অনিষ্টৰ পৰা মই তোমাৰ আশ্ৰয় বিচাৰোঁ। ইয়াক আবু দাউদ আৰু তিৰমিজীয়ে বৰ্ণনা কৰিছে। </p>',
      ],
      7 => [
        'question' => 'প্ৰশ্ন নং ৮- নতুন কাপোৰ পৰিধানকাৰীক কি দুআ দিব লাগে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14880.mp3',
        'answer' => '<p> উত্তৰ- যদি তুমি কাৰোবাক নতুন কাপোৰ পৰিহিত অৱস্থাত দেখা তেন্তে তাক এই দুআ পাঠ কৰি দুআ দিব লাগেঃ তুবলি ৱা ইউখলিফুল্লা-হু তাআলা। <span class="c2">(তুমি ইয়াক পূৰণি কৰা, ইয়াৰ ঠাইত আল্লাহে তোমাক আৰু অধিক দিয়ক।)</span> ইয়াক আবু দাউদে বৰ্ণনা কৰিছে </p>',
      ],
      8 => [
        'question' => 'প্ৰশ্ন নং ৯- শৌচালয়ত প্ৰৱেশ কৰাৰ সময়ত কোনটো দুআ পঢ়িব লাগে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14910.mp3',
        'answer' => '<p> উত্তৰ- আল্লা-হুম্মা ইন্নি আউজুবিকা মিনাল খুবছি অল খাবা-ইছ। <span class="c2">(হে আল্লাহ! মই দুষ্ট পুৰুষ জিনৰ পৰা আৰু দুশ্চৰিত্ৰা নাৰী জিনৰ (অনিষ্টৰ)</span> পৰা তোমাৰ আশ্ৰয় বিচাৰোঁ। মুত্তাফাক্ব আলাইহ </p>',
      ],
      9 => [
        'question' => 'প্ৰশ্ন নং ১০- শৌচালয়ৰ পৰা ওলোৱাৰ সময়ত কোনটো দুআ পঢ়িব লাগে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14940.mp3',
        'answer' => '<p> উত্তৰ- গুফৰা-নাকা। <span class="c2">(তোমাৰ ক্ষমাৰ প্ৰাৰ্থী)</span> ইয়াক আবু দাউদ আৰু তিৰমিজীয়ে বৰ্ণনা কৰিছে। </p>',
      ],
      10 => [
        'question' => 'প্ৰশ্ন নং ১১- অজুৰ আগত কি দুআ পঢ়িব লাগে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14970.mp3',
        'answer' => '<p> উত্তৰ- বিছমিল্লাহ। ইয়াক আবু দাউদে বৰ্ণনা কৰিছে। </p>',
      ],
      11 => [
        'question' => 'প্ৰশ্ন নং ১২- অজুৰ শেষত কোনটো দুআ পঢ়িব লাগে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15000.mp3',
        'answer' => '<p> <span class="c2">(আশ্বহাদু আল লা ইলাহা ইল্লাল্লাহু অহদাহু লা শ্বাৰীকা লাহু, ওৱা আশ্বহাদু আন্না মুহাম্মাদান আব্দুহু ওৱা ৰাছুলুহু)</span> অৰ্থঃ মই সাক্ষ্য দিওঁ যে, আল্লাহৰ বাহিৰে আন কোনো সত্য ইলাহ নাই, তেওঁৰ কোনো অংশীদাৰ নাই, মই আৰু সাক্ষ্য দিওঁ যে, মুহাম্মদ চাল্লাল্লাহু আলাইহি অছাল্লাম তেওঁৰ বান্দা আৰু ৰাছুল। ইয়াক মুছলিমে বৰ্ণনা কৰিছে। </p>',
      ],
      12 => [
        'question' => 'প্ৰশ্ন নং ১৩- ঘৰৰ পৰা ওলোৱাৰ সময়ত কোনটো দুআ পঢ়িব লাগে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15020.mp3',
        'answer' => '<p> উত্তৰ- বিছমিল্লাহ, তাৱাক্কালতু আলাল্লাহ, অলা হাওলা অলা কুওৱাতা ইল্লা বিল্লাহ। <span class="c2">(আৰম্ভ কৰিছোঁ, আল্লাহৰ নামত। মই আল্লাহৰ ওপৰত ভৰসা কৰিলোঁ, আল্লাহৰ সহায় অবিহনে কোনো বস্তুৰ অনিষ্টৰ পৰা ৰক্ষা পোৱা টান আৰু কিবা কৰাৰো ক্ষমতা নাই।)</span> ইয়াক আবু দাউদ আৰু তিৰমিজীয়ে বৰ্ণনা কৰিছে। </p>',
      ],
      13 => [
        'question' => 'প্ৰশ্ন নং ১৩- ঘৰত প্ৰৱেশ কৰাৰ সময়ত কোনটো দুআ পঢ়িব লাগে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15050.mp3',
        'answer' => '<p> উত্তৰ- বিছমিল্লাহি অলাজনা, অবিছমিল্লাহি খাৰাজনা, ওৱা আলাল্লা-হি ৰাব্বিনা তাৱাক্কালনা। <span class="c2">(আল্লাহৰ নামত আমি প্ৰৱেশ কৰিলোঁ, আৰু আল্লাহৰ নামতেই আমি ওলাইছিলোঁ, আৰু আমি আমাৰ প্ৰতিপালক আল্লাহৰ ওপৰতেই ভৰসা কৰোঁ।)</span> এই দুআ কোৱাৰ পিছত পৰিয়ালক ছালাম কৰিব লাগে। ইয়াক আবু দাউদে বৰ্ণনা কৰিছে </p>',
      ],
      14 => [
        'question' => 'প্ৰশ্ন নং ১৫- মছজিদত প্ৰৱেশ কৰাৰ সময়ত পঢ়িবলগীয়া দুআটো কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15080.mp3',
        'answer' => '<p> উত্তৰ- আল্লা-হুম্মাফ তাহলী, আবৱাবা ৰাহমাতিক। <span class="c2">(হে আল্লাহ! মোৰ বাবে তোমাৰ অনুগ্ৰহৰ দুৱাৰসমূহ খুলি দিয়া।)</span> হাদীছটো মুছলিমে বৰ্ণনা কৰিছে। </p>',
      ],
      15 => [
        'question' => 'প্ৰশ্ন নং ১৬- মছজিদৰ পৰা ওলোৱাৰ সময়ত কোনটো দুআ পঢ়িব লাগে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15110.mp3',
        'answer' => '<p> উত্তৰ- আল্লা-হুম্মা ইন্নি আছআলুকা মিন ফাদ্বলিক। <span class="c2">(হে আল্লাহ! মই তোমাৰ ওচৰত তোমাৰ অনুগ্ৰহ বিচাৰোঁ।)</span> হাদীছটো মুছলিমে বৰ্ণনা কৰিছে। </p>',
      ],
      16 => [
        'question' => 'প্ৰশ্ন নং ১৭- আজানৰ উত্তৰ কেনেকৈ দিব লাগে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15140.mp3',
        'answer' => '<p> উত্তৰ- মুআজ্জিনে যিবোৰ বাক্য কয়, সেইবোৰ বাক্যই ক\'ব লাগে। কেৱল "হাই আলাচ্ছলাহ" আৰু "হাই আলাল ফালাহ"ৰ বিপৰীতে "লা হাওলা অলা কুওৱাতা ইল্লা বিল্লাহ" ক\'ব লাগে। মুত্তাফাক্ব আলাইহ </p>',
      ],
      17 => [
        'question' => 'প্ৰশ্ন নং ১৮- আজানৰ পিছত কি পঢ়িব লাগে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15170.mp3',
        'answer' => '<p> উত্তৰ- নবী চাল্লাল্লাহু আলাইহি অছাল্লামৰ ওপৰত দৰূদ পঢ়িব লাগে। ইয়াক মুছলিমে বৰ্ণনা কৰিছে। আৰু তাৰ পিছত এই দুআ পঢ়িব লাগে। আল্লা-হুম্মা ৰাব্বা হা-জিহিত দা\'ৱাতিত তা-ম্মাহ, অচ্ছলা-তিল ক্বা-য়িমাহ, আ-তি মুহাম্মাদানিল অছীলাহ, অল-ফাজীলাহ, অবআছহু মাক্বা-মাম মাহমূদানিল লাজী ওৱা আত্তাহ। <span class="c2">(হে আল্লাহ! তুমিয়েই এই পূৰ্ণ দুআ আৰু প্ৰতিষ্ঠিত চালাতৰ প্ৰতিপালক, গতিকে মুহাম্মদ চাল্লাল্লাহু আলাইহি অছাল্লামক বিশেষ নৈকট্য আৰু বিশেষ অনুগ্ৰহ প্ৰদান কৰা। তেওঁক মাক্বামে মাহমূদ (প্ৰশংসিত ঠাইত)</span> থিয় কৰোৱা। যি ঠাইৰ প্ৰতিশ্ৰুতি তুমি তেওঁক প্ৰদান কৰিছা।) বুখাৰী<br /> আজান আৰু ইক্বামতৰ মধ্যৱৰ্তী সময়ত দুআ কৰিব লাগে। কাৰণ এই সময়ত কৰা দুআক প্ৰত্যাখ্যান কৰা নহয়। </p>',
      ],
      18 => [
        'question' => 'প্ৰশ্ন নং ১৯- পুৱা-গধূলি পঢ়িবলগীয়া দুআসমূহ কি কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15220.mp3',
        'answer' => '<p> উত্তৰ- ১- আয়াতুল কুৰছী পাঠ কৰা। আল্লাহ, তেওঁৰ বাহিৰে আন কোনো সত্য ইলাহ নাই। তেওঁ চিৰঞ্জীৱ, সকলো সত্তাৰ ধাৰক। তেওঁক কলাঘূমটিও স্পৰ্শ কৰিব নোৱাৰে আৰু টোপনিও নহয়। আকাশমণ্ডলত যি আছে আৰু পৃথিৱীত যি আছে সকলো তেওঁৰেই। কোন সেইজন, যিয়ে তেওঁৰ অনুমতিবিনে তেওঁৰ ওচৰত ছুপাৰিছ কৰিব? সিহঁতৰ সন্মুখত আৰু পিছত যি আছে সকলো তেওঁ জানে; আৰু যি তেওঁ ইচ্ছা কৰে তাৰ বাহিৰে তেওঁৰ জ্ঞানৰ একোৱেই সিহঁতে পৰিবেষ্টন কৰিব নোৱাৰে। তেওঁৰ কুৰছী আকাশমণ্ডল আৰু পৃথিৱীক পৰিব্যপ্ত কৰি আছে; আৰু এই দুটাৰ ৰক্ষণাবেক্ষণ তেওঁৰ বাবে বোজা নহয়; আৰু তেওঁ সুউচ্চ, সুমহান। <span class="c2">(ছুৰা আল-বাক্বাৰাহঃ ২৫৫)</span> ২- তাৰ পিছত পঢ়িব লাগে। বিছমিল্লা-হিৰ ৰহমা-নিৰ ৰাহীম। ক্বুল হুৱাল্লা-হু আহাদ। <span class="c2">(১)</span> <span class="c4">{কোৱা, ‘তেওঁ আল্লাহ, এক-অদ্বিতীয়,}</span> আল্লা-হুচ চামাদ। <span class="c2">(২)</span> <span class="c4">{আল্লাহ অমুখাপেক্ষী।}</span> লাম য়ালিদ অলাম ইউলাদ। <span class="c2">(৩)</span> <span class="c4">{তেওঁ কাকো জন্ম দিয়া নাই আৰু তেৱোঁ জন্ম লোৱা নাই,}</span> অলাম য়াকুল্লাহু কুফুআন আহাদ। <span class="c2">(৪)</span> <span class="c4">{আৰু তেওঁৰ সমতুল্য কোনো নাই’।}</span> তিনিবাৰ বিছমিল্লা-হিৰ ৰহমা-নিৰ ৰাহীম। <span class="c2">(আৰম্ভ কৰিছোঁ)</span> পৰম কৰুণাময় পৰম দয়ালু আল্লাহৰ নামত। ক্বুল আউজু বিৰাব্বিল ফালাক্ব। <span class="c2">(১)</span> <span class="c4">{কোৱা, মই আশ্ৰয় বিচাৰোঁ ঊষাৰ প্ৰতিপালকৰ।}</span> মিং শ্বাৰ্ৰি মা খালাক্ব। <span class="c2">(২)</span> <span class="c4">{তেওঁ যি সৃষ্টি কৰিছে তাৰ অনিষ্টৰ পৰা,}</span> অমিং শ্বাৰ্ৰি গা-ছিক্বিন ইযা অক্বাব। <span class="c2">(৩)</span> <span class="c4">{আৰু ৰাতিৰ অন্ধকাৰৰ অনিষ্টৰ পৰা, যেতিয়া ই গভীৰ হয়,}</span> অমিং শ্বাৰ্ৰিন নাফফা-ছা-তি ফিল উক্বাদ। <span class="c2">(৪)</span> <span class="c4">{আৰু সেইসকল নাৰীৰ অনিষ্টৰ পৰা যিসকলে গাঁঠিত ফুঁ দিয়ে,}</span> অমিং শ্বাৰ্ৰি হা-ছিদিন ইযা হাছাদ। <span class="c2">(৫)</span> <span class="c4">{আৰু হিংসুকৰ অনিষ্টৰ পৰা, যেতিয়া সি হিংসা কৰে।}</span> তিনিবাৰ বিছমিল্লা-হিৰ ৰহমা-নিৰ ৰাহীম। <span class="c2">(আৰম্ভ কৰিছোঁ)</span> পৰম কৰুণাময় পৰম দয়ালু আল্লাহৰ নামত। ক্বুল আউজু বিৰাব্বিন না-ছ। <span class="c2">(১)</span> <span class="c4">{কোৱা, মই আশ্ৰয় বিচাৰোঁ মানুহৰ প্ৰতিপালকৰ।}</span> মালিকিন না-ছ। <span class="c2">(২)</span> <span class="c4">{মানুহৰ অধিপতিৰ,}</span> ইলাহিন না-ছ। <span class="c2">(৩)</span> <span class="c4">{মানুহৰ ইলাহৰ ওচৰত,}</span> মিং শ্বাৰ্ৰিল অছৱা-ছিল খান্না-ছ। <span class="c2">(৪)</span> <span class="c4">{আত্মগোপনকাৰী কুমন্ত্ৰণাদাতাৰ অনিষ্টৰ পৰা,}</span> আল্লাজী য়ুৱাছৱিছু ফি চুদূৰিন না-ছ। <span class="c2">(৫)</span> <span class="c4">{যিয়ে মানুহৰ মনত কুমন্ত্ৰণা দিয়ে,}</span> মিনাল জিন্নাতি অন্না-ছ। <span class="c2">(৬)</span> <span class="c4">{জিনৰ মাজৰ পৰা আৰু মানুহৰ মাজৰ পৰা।}</span> তিনিবাৰ ৩- আল্লা-হুম্মা আনতা ৰাব্বী, লা ইলা-হা ইল্লা আনতা, খালাকতানী ৱা আনা আব্দুকা, ৱা আনা আলা আহদিকা, ৱা ৱা\'দিকা মাচ-তাত্বা\'তু। আউজুবিকা মিন শ্বাৰ্ৰি মা চানা\'তু। আবুওলাকা বিনি\'মাতিকা আলাইয়্য়া, ৱা আবুও বিজান্বী, ফাগফিৰলী, ফা ইন্নাহু লা য়াগফিৰুজ জুনূবা ইল্লা আনতা। <span class="c2">(হে আল্লাহ! তুমিয়েই মোৰ ৰব্ব। তোমাৰ বাহিৰে আন কোনো সত্য উপাস্য নাই। তুমিয়েই মোক সৃষ্টি কৰিছা, মই তোমাৰ বান্দা। মই তোমাৰ প্ৰতিশ্ৰুতিৰ ওপৰত সাধ্যানুসাৰে প্ৰতিষ্ঠিত। মই যি কৰিছোঁ তাৰ অন্যায়ৰ পৰা মই তোমাৰ ওচৰত আশ্ৰয় বিচাৰোঁ। তুমি মোক যি নিয়ামত প্ৰদান কৰিছা তাৰ বাবে মই তোমাৰ কৃতজ্ঞ। মই মোৰ গুনাহ কবুল কৰিছোঁ। গতিকে তুমি মোক ক্ষমা কৰি দিয়া, কাৰণ নিশ্চিতভাৱে তোমাৰ বাহিৰে আন কোনেও গুনাহ ক্ষমা কৰিব নোৱাৰে।)</span> বুখাৰীয়ে বৰ্ণনা কৰিছে। </p>',
      ],
      19 => [
        'question' => 'প্ৰশ্ন নং ২০- শোৱাৰ সময়ত কোনটো দুআ পঢ়িব লাগে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15290.mp3',
        'answer' => '<p> উত্তৰ- বিছমিকা আল্লা-হুম্মা আমূতু ওৱা আহয়া। <span class="c2">(হে আল্লাহ! মই তোমাৰ নামতে মৃত্যুবৰণ কৰোঁ আৰু তোমাৰ নামতে জীৱিত হওঁ।)</span> মুত্তাফাক্ব আলাইহ </p>',
      ],
      20 => [
        'question' => 'প্ৰশ্ন নং ২১- পানাহাৰ কৰাৰ আগত কোনটো দুআ পঢ়িব লাগে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15320.mp3',
        'answer' => '<p> উত্তৰ- বিছমিল্লাহ।<br /> পানাহাৰ কৰাৰ আগত যদি এইটো ক\'বলৈ পাহৰি যোৱা তেন্তে এইটো দুআ পঢ়িব লাগেঃ<br /> বিছমিল্লাহি ফি আওৱালিহি ৱা আখিৰিহ। <span class="c2">(আৰম্ভণি আৰু শেষত আল্লাহৰ নামতেই পানাহাৰ কৰোঁ)</span> ইয়াক আবু দাউদ আৰু তিৰমিজীয়ে বৰ্ণনা কৰিছে। </p>',
      ],
      21 => [
        'question' => 'প্ৰশ্ন নং ২২- পানাহাৰ শেষ কৰি কি দুআ পঢ়িব লাগে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15370.mp3',
        'answer' => '<p> উত্তৰ- আলহামদু লিল্লা-হিল লাজী, আত্বআমানী হা-জা অৰাঝাক্বানীহি মিন গাইৰি হাওলিম মিন্নী অলা কুওৱাহ। <span class="c2">(সকলো ধৰণৰ প্ৰশংসা একমাত্ৰ আল্লাহৰ বাবে, যিয়ে মোক এই খাদ্য খোৱাৰ তাওফীক দিছে। মোৰ ফালৰ পৰা বিনা কোনো শক্তি আৰু ক্ষমতাৰে তেওঁ মোক প্ৰদান কৰিছে।)</span> আবু দাউদ আৰু ইবনে মাজাহে বৰ্ণনা কৰিছে। </p>',
      ],
      22 => [
        'question' => 'প্ৰশ্ন নং ২৩- অতিথিয়ে গৃহস্থক কি দুআ দিব লাগে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15400.mp3',
        'answer' => '<p> উত্তৰ- আল্লা-হুম্মা বা-ৰিক লাহুম ফীমা ৰাঝাকতাহুম, অগফিৰ লাহুম অৰহামহুম। <span class="c2">(হে আল্লাহ! তুমি তেওঁলোকক যি প্ৰদান কৰিছা, তাত তুমি বৰকত দিয়া, লগতে তেওঁলোকক ক্ষমা কৰি দিয়া আৰু তেওঁলোকৰ ওপৰত ৰহম কৰা।)</span> ইয়াক মুছলিমে বৰ্ণনা কৰিছে। </p>',
      ],
      23 => [
        'question' => 'প্ৰশ্ন নং ২৪- হাঁচি কৰিলে কি ক\'ব লাগে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15430.mp3',
        'answer' => '<p> উত্তৰ- আলহাম্দুলিল্লাহ। <span class="c2">(সকলো ধৰণৰ প্ৰশংসা কেৱল আল্লাহৰ বাবে।)</span><br /> আৰু তেওঁৰ ওচৰত থকা ব্যক্তিয়ে "য়াৰহামুকাল্লাহ" ক\'ব লাগে।<br /> য়াৰহামুকাল্লাহ কোৱা ব্যক্তিক এইদৰে দুআ দিব লাগেঃ "য়াহদিকুমুল্লাহু ৱা ইউচলিহ বা-লাকুম"। বুখাৰীয়ে বৰ্ণনা কৰিছে। </p>',
      ],
      24 => [
        'question' => 'প্ৰশ্ন নং ২৫- কোনো বৈঠকৰ শেষত পঢ়িবলগীয়া দুআটোনো কি, যাক কাফফাৰাতুল মাজলিছ বোলে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15480.mp3',
        'answer' => '<p> উত্তৰ- ছুবাহানাকা আল্লাহুম্মা অবিহামদিকা, আশ্বহাদু আল লা ইলা-হা ইল্লা আনতা, আছতাগফিৰুকা ওৱা আতুবু ইলাইক। আবু দাউদ আৰু তিৰমিজীয়ে বৰ্ণনা কৰিছে। </p>',
      ],
      25 => [
        'question' => 'প্ৰশ্ন নং ২৬- বাহনত আৰোহণ কৰাৰ দুআ কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15510.mp3',
        'answer' => '<p> উত্তৰ- বিছমিল্লাহ, অলহাম্দুলিল্লাহ। ছুবহা-নাল লাজী ছাখখৰা লানা হা-জা অমা কুন্না লাহু মুক্বৰিনীন। ৱা ইন্না ইলা ৰাব্বিনা লামুংক্বালিবূন। আলহাম্দুলিল্লাহ, আলহাম্দুলিল্লাহ, আলহাম্দুলিল্লাহ, আল্লাহু আকবাৰ, আল্লাহু আকবাৰ, আল্লাহু আকবাৰ, ছুবহা-নাকা আল্লা-হুম্মা ইন্নি জালামতু নাফছী ফাগফিৰলী, ফা ইন্নাহু লা য়াগফিৰুজ জুনূবা ইল্লা আনতা। ইয়াক আবু দাউদ আৰু তিৰমিজীয়ে বৰ্ণনা কৰিছে। </p>',
      ],
      26 => [
        'question' => 'প্ৰশ্ন নং ২৭- ভ্ৰমণৰ দুআ কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15540.mp3',
        'answer' => '<p> উত্তৰ- আল্লাহু আকবাৰ, আল্লাহু আকবাৰ, আল্লাহু আকবাৰ, ছুবহা-নাল লাজী ছাখখৰা লানা হা-জা অমা কুন্না লাহু মুক্বৰিনীন। ৱা ইন্না ইলা ৰাব্বিনা লামুংক্বালিবূন। আল্লা-হুম্মা ইন্না নাছআলুকা ফী ছাফাৰিনা হা-জাল বিৰ্ৰা অত-তাক্বৱা, অমিনাল আমালি মা তাৰদ্বা, আল্লা-হুম্মা হাওৱিন আলাইনা ছাফাৰানা হা-জা, অত্বৱি আন্না বু\'দাহ, আল্লা-হুম্মা আনতাচ চা-হিবু ফিচ ছফৰ, অলখালীফাতু ফিল আহল, আল্লা-হুম্মা ইন্নি আউজুবিকা মিন অ\'ছা-য়িচ ছফৰ, অকাআবাতিল মানজাৰ, অছুয়িল মুনকালাবি ফিল মা-লি অল আহল।<br /> ওভোতাৰ সময়তো এইটো দুআই পঢ়িব লাগে, কেৱল অতিৰিক্ত এইখিনি পঢ়িব লাগিবঃ<br /> আ-য়িবূনা, তা-য়িবূনা, আ-বিদূনা, লিৰাব্বিনা হা-মিদূন। ইয়াক মুছলিমে বৰ্ণনা কৰিছে। </p>',
      ],
      27 => [
        'question' => 'প্ৰশ্ন নং ২৮- মুক্বীমৰ বাবে মুছাফিৰৰ দুআ কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15590.mp3',
        'answer' => '<p> উত্তৰ- আছতাওদিউকুমুল্লা-হুল লাজী লা তাদ্বীউ অদায়িউহু। আহমদ আৰু ইবনে মাজাহে বৰ্ণনা কৰিছে। </p>',
      ],
      28 => [
        'question' => 'প্ৰশ্ন নং ২৯- মুছাফিৰৰ বাবে মুক্বীমৰ দুআ কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15620.mp3',
        'answer' => '<p> উত্তৰ- আছতাওদিউল্লা-হা দ্বীনাকা, ৱাআমানাতাকা, অখাৱাতীমা আমালিক। আহমদ আৰু তিৰমিজীয়ে বৰ্ণনা কৰিছে। </p>',
      ],
      29 => [
        'question' => 'প্ৰশ্ন নং ৩০- বজাৰত প্ৰৱেশ কৰাৰ সময়ত পঢ়িবলগীয়া দুআটো কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15650.mp3',
        'answer' => '<p> উত্তৰ- লা ইলা-হা ইল্লাল্লা-হু অহদাহু লা শ্বাৰীকা লাহু, লাহুল মুল্কু, অলাহুল হাম্দু, ইউহয়ী অয়ুমীতু, অহুৱা হাইয়্যুন লা য়ামূতু, বিয়াদিহিল খাইৰু, অহুৱা আলা কুল্লি শ্বাইয়িন ক্বাদীৰ। তিৰমিজী আৰু ইবনে মাজাহে বৰ্ণনা কৰিছে। </p>',
      ],
      30 => [
        'question' => 'প্ৰশ্ন নং ৩১- ক্ৰোধৰ সময়ত কোনটো দুআ পঢ়িব লাগে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15680.mp3',
        'answer' => '<p> উত্তৰ- আউজু বিল্লা-হি মিনাশ্ব শ্বাইত্বনিৰ ৰাজীম। অৰ্থঃ মই অভিশপ্ত চয়তানৰ পৰা আল্লাহৰ আশ্ৰয় প্ৰাৰ্থনা কৰোঁ। মুত্তাফাক্ব আলাইহ </p>',
      ],
      31 => [
        'question' => 'প্ৰশ্ন নং ৩২- কোনোবাই কিবা উপকাৰ কৰিলে তাক কি দুআ দিব লাগে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15710.mp3',
        'answer' => '<p> উত্তৰ- জাঝাকাল্লা-হু খাইৰা। ইয়াক তিৰমিজীয়ে বৰ্ণনা কৰিছে </p>',
      ],
      32 => [
        'question' => 'প্ৰশ্ন নং ৩৩- বাহন খুন্দিয়ালে কি দুআ ক\'ব লাগে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15740.mp3',
        'answer' => '<p> উত্তৰ- বিছমিল্লাহ। ইয়াক আবু দাউদে বৰ্ণনা কৰিছে </p>',
      ],
      33 => [
        'question' => 'প্ৰশ্ন নং ৩৪- আনন্দদায়ক কিবা অৰ্জন হ\'লে কি ক\'ব লাগে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15770.mp3',
        'answer' => '<p> উত্তৰ- আলহাম্দুলিল্লাহিল লাজী বিনি\'মাতিহি তাতিম্মুচ চ-লিহাত। <span class="c2">(সকলো ধৰণৰ প্ৰশংসা কেৱল আল্লাহৰ বাবে যাৰ অনুগ্ৰহৰে সকলো নেক আমল সম্পূৰ্ণ হয়)</span> <span class="c2">(হাকিমে বৰ্ণনা কৰিছে)</span> </p>',
      ],
      34 => [
        'question' => 'প্ৰশ্ন নং ৩৫- অপছন্দনীয় কিবা ঘটিলে কি ক\'ব লাগে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15800.mp3',
        'answer' => '<p> উত্তৰ- আল-হাম্দুলিল্লাহি আলা কুল্লি হা-ল। <span class="c2">(সকলো অৱস্থাতে প্ৰশংসা কেৱল আল্লাহৰ বাবেই)</span> ছহীহুল জামে। </p>',
      ],
      35 => [
        'question' => 'প্ৰশ্ন নং ৩৬- ছালাম কেনেকৈ দিব লাগে আৰু ছালামৰ উত্তৰ কেনেকৈ দিব লাগে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15830.mp3',
        'answer' => '<p> উত্তৰ- ছালাম এনেকৈ দিব লাগেঃ আচ্ছালামু আলাইকুম অৰাহমাতুল্লাহি অবাৰাকাতুহ।<br /> উত্তৰ দিবলৈ এনেকৈ ক\'ব লাগেঃ ৱা আলাইকুমুচ্ছালাম অৰাহমাতুল্লাহি অবাৰাকাতুহ। তিৰমিজী আৰু আবু দাঊদ। </p>',
      ],
      36 => [
        'question' => 'প্ৰশ্ন নং ৩৭- বৰষুণৰ সময়ত কি দুআ ক\'ব লাগে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15870.mp3',
        'answer' => '<p> উত্তৰ- আল্লা-হুম্মা চায়্যিবান না-ফিআহ। বুখাৰী </p>',
      ],
      37 => [
        'question' => 'প্ৰশ্ন নং ৩৮- বৰষুণ হৈ যোৱাৰ পিছত কি দুআ ক\'ব লাগে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15900.mp3',
        'answer' => '<p> উত্তৰ- মুতিৰনা বিফাজলিল্লাহি অৰাহমাতিহ। বুখাৰী আৰু মুছলিম। </p>',
      ],
      38 => [
        'question' => 'প্ৰশ্ন নং ৩৯- বতাহ চলিলে কি দুআ পঢ়িব লাগে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15930.mp3',
        'answer' => '<p> উত্তৰ- আল্লা-হুম্মা ইন্নি আছআলুকা খাইৰাহা, ৱা আউজুবিকা মিন শ্বাৰ্ৰিহা। <span class="c2">(হে আল্লাহ! মই তোমাৰ ওচৰত ইয়াৰ কল্যাণ কামনা কৰোঁ আৰু ইয়াৰ অনিষ্টৰ পৰা তোমাৰ আশ্ৰয় প্ৰাৰ্থনা কৰোঁ)</span> আবু দাঊদ আৰু ইবনে মাজাহ। </p>',
      ],
      39 => [
        'question' => 'প্ৰশ্ন নং ৪০- বজ্ৰগৰ্জন শুনিলে কি দুআ ক\'ব লাগে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15960.mp3',
        'answer' => '<p> উত্তৰ- ছুবহা-নাল লাজী য়ুছাব্বিহুৰ ৰা\'দু বিহামদিহি অল মালা-য়িকাতু মিন খীফাতিহ। মুআত্তা মালিক </p>',
      ],
      40 => [
        'question' => 'প্ৰশ্ন নং ৪১- অসুস্থ ব্যক্তিক দেখিলে কি দুআ ক\'ব লাগে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15990.mp3',
        'answer' => '<p> উত্তৰ- আলহাম্দুলিল্লাহিল লাজী আ-ফানী মিম্মাবতালা-কা বিহি, অফাজ্জালানী আলা কাছী-ৰিম মিম্মান খালাক্বা তাফজীলা। ইয়াক তিৰমিজীয়ে বৰ্ণনা কৰিছে </p>',
      ],
      41 => [
        'question' => 'প্ৰশ্ন নং ৪২- নজৰ লগা বা বেয়া দৃষ্টিৰ আশংকা কৰিলে কি কৰিব লাগে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16020.mp3',
        'answer' => '<p> উত্তৰ- হাদীছত আহিছেঃ যদি তোমালোকৰ ভাতৃৰ, অথবা নিজৰে নাইবা বেলেগৰ কোনো সম্পদ মনোমোহা লাগে তেন্তে তাৰ বাবে বৰকতৰ দুআ কৰিবা। কাৰণ নিশ্চয় বেয়া দৃষ্টি <span class="c2">(নজৰে বদ)</span> হৈছে সত্য। আহমদ আৰু ইবনে মাজাহে বৰ্ণনা কৰিছে। </p>',
      ],
      42 => [
        'question' => 'প্ৰশ্ন নং ৪৩- নবী চাল্লাল্লাহু আলাইহি অছাল্লামৰ ওপৰত দৰূদ কেনেকৈ পঢ়িব লাগে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16050.mp3',
        'answer' => '<p> উত্তৰ- "আল্লা-হম্মা চল্লি আলা মুহাম্মদ, ৱা আলা আলি মুহাম্মদ, কামা চাল্লাইতা আলা ইব্ৰাহীম, ৱা আলা আলি ইব্ৰাহীম, ইন্নাকা হামীদুম মাজীদ। আল্লা-হম্মা বা-ৰিক আলা মুহাম্মদ, ৱা আলা আলি মুহাম্মদ, কামা বা-ৰাকতা আলা ইব্ৰাহীম, ৱা আলা আলি ইব্ৰাহীম, ইন্নাকা হামীদুম মাজীদ।" মুত্তাফাক্ব আলাইহ </p>',
      ],
    ],
    9 => [
      0 => [
        'question' => 'প্ৰশ্ন নং ১- পাঁচ প্ৰকাৰ দায়িত্বমূলক বিধি-বিধান কি কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16090.mp3',
        'answer' => '<p> উত্তৰ-<br /> ১- ওৱাজিব।<br /> ২- মুস্তাহাব।<br /> ৩- হাৰাম।<br /> ৪- মাকৰূহ।<br /> ৫- মুবাহ। </p>',
      ],
      1 => [
        'question' => 'প্ৰশ্ন নং ২- এই পাঁচ প্ৰকাৰ বিধি-বিধানৰ ব্যাখ্যা কৰা?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16170.mp3',
        'answer' => '<p> উত্তৰ-<br /> ১- ওৱাজিব- যেনে- পাঁচ ওৱাক্ত চালাত, ৰমজান মাহৰ ৰোজা, পিতৃ-মাতৃৰ সৈতে সদ্ব্যৱহাৰ কৰা আদি।<br /> - ওৱাজিব হৈছে এনেকুৱা কৰ্ম যিটো কৰিলে ছোৱাব পোৱা যায় আৰু পৰিত্যাগ কৰিলে শাস্তিৰ সন্মুখীন হ\'বলগীয়া হয়।<br /> ২-মুস্তাহাবঃ যেনে- ফৰজ নামাজৰ আগৰ আৰু পিছৰ ছুন্নতসমূহ, তাহাজ্জুদ, আনক পানাহাৰ কৰোৱা, ছালাম দিয়া আদি। মুস্তাহাবক ছুন্নত আৰু মানুদূব বুলিও কোৱা হয়।<br /> মুস্তাহাব হৈছে এনেকুৱা কৰ্ম যিটো কৰিলে ছোৱাব পোৱা যায়, কিন্তু নকৰিলে শাস্তি নাই।<br /> বিঃদ্ৰঃ<br /> কোনো কৰ্মৰ বিষয়ে ছুন্নত বা মুস্তাহাব বুলি শুনিলে এজন মুছলিমৰ কৰ্তব্য হৈছে সেই কৰ্ম ততাতৈয়াকৈ কৰা আৰু নবী চাল্লাল্লাহু আলাইহি অছাল্লামৰ অনুসৰণ কৰা।<br /> ৩- হাৰামঃ যেনে- মাদক দ্ৰৱ্য সেৱন কৰা, পিতৃ-মাতৃৰ অবাধ্য হোৱা, আত্মীয়তাৰ সম্পৰ্ক ছিন্ন কৰা।<br /> -হাৰাম হৈছে এনেকুৱা কৰ্ম যিটো পৰিত্যাগ কৰিলে ছোৱাব পোৱা যায় আৰু কৰিলে শাস্তিৰ সন্মুখীন হ\'বলগীয়া হয়।<br /> ৪- মাকৰূহঃ যেনে- বাওঁ হাতেৰে আদান-প্ৰদান কৰা, চালাতত কাপোৰ ধৰি ৰখা।<br /> -মাকৰূহ হৈছে এনেকুৱা কৰ্ম যিটো পৰিত্যাগ কৰিলে ছোৱাব পোৱা যায়, কৰিলে শাস্তি নাই।<br /> ৫- মুবাহঃ যেনে- ফলমূল খোৱা, চাহ-বিস্কুট খোৱা আদি। মুবাহক জায়েজ আৰু হালাল বুলিও কোৱা হয়।<br /> -মুবাহ হৈছে এনেকুৱা কৰ্ম যিটো পৰিত্যাগ কৰিলে ছোৱাব পোৱা নাযায় আৰু কৰিলেও শাস্তি নাই। </p>',
      ],
      2 => [
        'question' => 'প্ৰশ্ন নং ৩- ক্ৰয়-বিক্ৰয় আৰু লেনদেনৰ বিধান কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16320.mp3',
        'answer' => '<p> উত্তৰ- সকলো প্ৰকাৰ ক্ৰয়-বিক্ৰয় আৰু লেনদেনৰ মূল হৈছে হালাল। কিন্তু ইয়াৰে কেইটামান প্ৰকাৰক আল্লাহে হাৰাম কৰিছে।<br /> আল্লাহে কৈছেঃ আল্লাহে ব্যৱসায়-বাণিজ্যক হালাল কৰিছে আৰু সুতক হাৰাম কৰিছে। <span class="c2">(ছুৰা আল-বাক্বাৰাহঃ ২৭৫)</span> </p>',
      ],
      3 => [
        'question' => 'প্ৰশ্ন নং ৪- কেইটামান হাৰাম লেনদেন আৰু হাৰাম ব্যৱসায়ৰ বিষয়ে উল্লেখ কৰা?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16360.mp3',
        'answer' => '<p> উত্তৰ-<br /> ১- প্ৰতাৰণা কৰা বা ঠগোৱাঃ বিক্ৰী কৰিবলগীয়া বস্তুৰ দোষ গোপন ৰখা।<br /> আবু হুৰাইৰাহ ৰাদ্বিয়াল্লাহু আনহুৰ পৰা বৰ্ণিত, এবাৰ ৰাছুলুল্লাহ চাল্লাল্লাহু আলাইহি অছাল্লামে <span class="c2">(বজাৰৰ এটি)</span> খাদ্য সম্ভাৰৰ ওচৰেৰে অতিক্ৰম কৰি আছিল, হঠাৎ তেখেতে সেই খাদ্য সম্ভাৰৰ মাজত হাত সোমোৱাই দিলে, আৰু তেখেতে গম পালে যে, ভিতৰৰ বস্তুখিনি সেমেকি আছে তথা তিতি আছে। তেখেতে ক\'লেঃ "হে খাদ্য সামগ্ৰীৰ গৰাকী! এইটো কি কথা?" তেওঁ ক\'লেঃ "হে আল্লাহৰ ৰাছুল! বৰষুণৰ ফলত এনেকুৱা হৈছে।" তেখেতে ক\'লেঃ "তুমি ইয়াক ওপৰত কিয় নাৰাখিলা, যাতে মানুহে চাব পাৰে? শুনা! যিয়ে প্ৰতাৰণা কৰে সি আমাৰ অন্তৰ্ভুক্ত নহয়।" ইয়াক মুছলিমে বৰ্ণনা কৰিছে।<br /> ২- সুতঃ যেনে- ঋণ হিচাপে কাৰোবাৰ পৰা এহেজাৰ টকা লৈ ওভোতাই দিয়াৰ সময়ত দুহেজাৰ টকা দিয়া।<br /> এই অতিৰিক্ত টকাখিনি হৈছে সুত।<br /> আল্লাহে কৈছেঃ আল্লাহে ব্যৱসায়-বাণিজ্যক হালাল কৰিছে আৰু সুতক হাৰাম কৰিছে। <span class="c2">(ছুৰা আল-বাক্বাৰাহঃ ২৭৫)</span><br /> ৩- আল-গাৰাৰ <span class="c2">(অনিশ্চয়তা, আশংকা)</span> আৰু জাহালাহ <span class="c2">(অজ্ঞানতা)</span>- যেনে- ছাগলীৰ স্তনত থকা অৱস্থাতেই গাখীৰ আনুমানিকভাৱে বিক্ৰী কৰা, অথবা পানীত থকা মাছ আনুমানিকভাৱে বিক্ৰী কৰা।<br /> হাদীছত আহিছেঃ ৰাছুলুল্লাহ চাল্লাল্লাহু আলাইহি অছাল্লামে অনিশ্চয়তামূলক ক্ৰয়-বিক্ৰয় নিষিদ্ধ কৰিছে। ইয়াক মুছলিমে বৰ্ণনা কৰিছে। </p>',
      ],
      4 => [
        'question' => 'প্ৰশ্ন নং ৫- আল্লাহে তোমাৰ ওপৰত কৰা কেইটিমান নিয়ামতৰ বিষয়ে উল্লেখ কৰা?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16460.mp3',
        'answer' => '<p> উত্তৰ- ১- ইছলামৰ নিয়ামত, কাৰণ মই অমুছলিম নহয়।<br /> ২- ছুন্নতৰ নিয়ামত, কাৰণ মই বিদআতী নহয়।<br /> ৩- সুস্থতাৰ নিয়ামতঃ কাৰণ মই শুনিব পাৰোঁ, দেখিব পাৰোঁ আৰু খোজকাঢ়িব পাৰোঁ।<br /> ৪- পানাহাৰ আৰু পোছাক-পৰিচ্ছদৰ নিয়ামত।<br /> আমাৰ ওপৰত আল্লাহৰ অসংখ্য নিয়ামত আছে, যিবোৰক গণনা কৰি শেষ কৰিব নোৱাৰি।<br /> আল্লাহে কৈছেঃ আৰু তোমালোকে আল্লাহৰ অনুগ্ৰহ গণিলে কেতিয়াও তাৰ সংখ্যা নিৰ্ণয় কৰিব নোৱাৰিবা। নিশ্চয় আল্লাহ ক্ষমাপৰায়ণ, পৰম দয়ালু। <span class="c2">(ছুৰা আন-নাহলঃ ১৮)</span> </p>',
      ],
      5 => [
        'question' => 'প্ৰশ্ন নং ৬- আমি লাভ কৰা নিয়ামতৰ প্ৰতি আমাৰ কৰ্তব্য কি? আৰু ইয়াৰ বাবে কৃতজ্ঞতা কেনেকৈ প্ৰকাশ কৰিব লাগে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16540.mp3',
        'answer' => '<p> উত্তৰ- আমাৰ কৰ্তব্য হৈছে আল্লাহৰ কৃতজ্ঞতা প্ৰকাশ কৰা, আল্লাহৰ গুণগানৰ মাধ্যমত তথা তেওঁৰ প্ৰশংসা কৰাৰ মাধ্যমত। একমাত্ৰ তেৱেঁই সৰ্বোচ্চ মৰ্যাদাৰ অধিকাৰী। লগতে এইবোৰ নিয়ামত মহান আল্লাহে সন্তুষ্ট হোৱা শিতানত ব্যৱহাৰ কৰিব লাগে, কোনো পাপকৰ্মত ব্যৱহাৰ কৰিব নালাগে। </p>',
      ],
      6 => [
        'question' => 'প্ৰশ্ন নং ৭- মুছলিমসকলৰ উৎসৱ কেইটা আৰু কি কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16570.mp3',
        'answer' => '<p> উত্তৰ- মুছলিমসকলৰ উৎসৱ হৈছে দুটা। ঈদুল ফিতৰ আৰু ঈদুল আজহা।<br /> যেনে- আনাছ ৰাদ্বিয়াল্লাহু আনহুৱে বৰ্ণনা কৰা হাদীছত আহিছে, তেওঁ কৈছেঃ নবী চাল্লাল্লাহু আলাইহি অছাল্লামে মদীনাত আহি দেখিলে সিহঁতে দুটা দিন উৎসৱ হিচাপে পালন কৰে, সেইদিনা সিহঁতে খেল-ধূলা কৰে। এই দেখি তেখেতে সুধিলেঃ "এই দিৱস দুটা তোমালোকে কিয় উৎযাপন কৰা?" সিহঁতে ক\'লেঃ "এই দিৱস দুটা আমি অজ্ঞতা যুগৰ পৰাই পালন কৰি আহিছোঁ।" তেতিয়া ৰাছুলুল্লাহ চাল্লাল্লাহু আলাইহি অছাল্লামে ক\'লেঃ শুনা! আল্লাহে তোমালোকক এই দিৱস দুটাৰ পৰিবৰ্তে ইয়াতকৈও উত্তম দুটা দিৱস প্ৰদান কৰিছে। সেই দুটা হৈছেঃ ঈদুল আজহা আৰু ঈদুল ফিতৰ। আবু দাঊদ।<br /> এই দুটা উৎসৱৰ বাহিৰে বাকী যিমানবোৰ উৎসৱ পালন কৰা হয় সেই আটাইবোৰ হৈছে বিদআত। </p>',
      ],
      7 => [
        'question' => 'প্ৰশ্ন নং ৮- আটাইতকৈ উত্তম মাহ কোনটো?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16620.mp3',
        'answer' => '<p> উত্তৰ- ৰমজান মাহ। </p>',
      ],
      8 => [
        'question' => 'প্ৰশ্ন নং ৯- আটাইতকৈ উত্তম দিন কোনটো?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16650.mp3',
        'answer' => '<p> উত্তৰ- শুক্ৰবাৰ। </p>',
      ],
      9 => [
        'question' => 'প্ৰশ্ন নং ১০- বছৰৰ আটাইতকৈ উত্তম দিন কোনটো?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16680.mp3',
        'answer' => '<p> উত্তৰ- আৰাফাৰ দিন। </p>',
      ],
      10 => [
        'question' => 'প্ৰশ্ন নং ১১- বছৰৰ আটাইতকৈ উত্তম ৰাতি কোনটো?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16710.mp3',
        'answer' => '<p> উত্তৰ- লাইলাতুল ক্বদৰ। </p>',
      ],
      11 => [
        'question' => 'উত্তৰ- ১২- গায়েৰ মাহৰাম নাৰী দেখিলে কি কৰিব লাগে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16740.mp3',
        'answer' => '<p> উত্তৰ- দৃষ্টি সংযত কৰিব লাগে। যেনে- আল্লাহ তাআলাই কৈছেঃ মুমিনসকলক কৈ দিয়া, সিহঁতে যেন নিজৰ দৃষ্টি সংযত ৰাখে। <span class="c2">(ছুৰা আন-নূৰঃ ৩০)</span> </p>',
      ],
      12 => [
        'question' => 'প্ৰশ্ন নং ১৩- মানুহৰ প্ৰকৃত শত্ৰু কোন?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16770.mp3',
        'answer' => '<p> উত্তৰ- ১- বেয়া কৰ্মৰ ফালে ধাৱিত হোৱা মন। মানুহৰ মন যেতিয়া বেয়া কৰ্মৰ ফালে ধাৱিত হয়, তেতিয়া মানুহে নিজৰ ব্যক্তিগত ইচ্ছাৰে আল্লাহৰ অবাধ্যতাত মনৰ সেই নিৰ্দেশক অনুসৰণ কৰে। নিশ্চয় মানুহৰ নফচে বেয়া কামৰ নিৰ্দেশ দিয়াটোৱে স্বাভাৱিক, কিন্তু সেই ব্যক্তিৰ কথা সুকীয়া, যাৰ প্ৰতি মোৰ প্ৰতিপালকে দয়া কৰে। নিশ্চয় মোৰ প্ৰতিপালক ক্ষমাশীল, পৰম দয়ালু। <span class="c2">(ছুৰা ইউছুফঃ ৫৩)</span> ২- চয়তানঃ চয়তান হৈছে আদম সন্তানৰ প্ৰকৃত শত্ৰু। চয়তানৰ উদ্দেশ্য হৈছে মানুহক বিভ্ৰান্ত কৰা আৰু সিহঁতক বেয়া কৰ্মৰ কুমন্ত্ৰণা দিয়া আৰু জাহান্নামত প্ৰৱেশ কৰোৱা। যেনে- আল্লাহ তাআলাই কৈছেঃ তোমালোকে চয়তানৰ পদাংক অনুসৰণ নকৰিবা। নিশ্চয় সি তোমালোকৰ প্ৰকাশ্য শত্ৰু। <span class="c2">(ছুৰা আল-বাক্বাৰাহঃ ১৬৮)</span> ৩- বেয়া সংগীঃ যিসকলে বেয়া কৰ্মৰ প্ৰৰোচনা দিয়ে আৰু সৎকৰ্মৰ পৰা বিৰত ৰাখে। যেনে- আল্লাহ তাআলাই কৈছেঃ সেইদিনা অন্তৰঙ্গ বন্ধুসকলেও ইজনে সিজনৰ শত্ৰু হৈ পৰিব, কেৱল মুত্তাক্বীসকলৰ বাহিৰে। <span class="c2">(ছুৰা আজ-ঝুখৰূফঃ ৬৭)</span> </p>',
      ],
      13 => [
        'question' => 'প্ৰশ্ন নং ১৪- তাওবা কাক বোলে?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16820.mp3',
        'answer' => '<p> উত্তৰ- গুনাহ পৰিত্যাগ কৰি আল্লাহৰ আনুগত্যৰ ফালে উভতি অহাকে তাওবা বোলে। আল্লাহ তাআলাই কৈছেঃ আৰু নিশ্চয় মই সেই ব্যক্তিৰ প্ৰতি ক্ষমাশীল, যিয়ে তাওবা কৰে, ঈমান পোষণ কৰে, সৎকৰ্ম কৰে আৰু তাৰ পিছত সৎপথত অবিচল থাকে। <span class="c2">(ছুৰা ত্বা-হাঃ ৮২)</span> </p>',
      ],
      14 => [
        'question' => 'প্ৰশ্ন নং ১৫- সঠিক তাওবাৰ চৰ্তসমূহ কি কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16850.mp3',
        'answer' => '<p> উত্তৰ- ১- পৰিপূৰ্ণৰূপে গুনাহ পৰিত্যাগ কৰা।<br /> ২- যি হৈছে তাৰ প্ৰতি লজ্জিত হোৱা।<br /> ৩- পুনৰ যাতে নহয় তাৰ বাবে প্ৰতিজ্ঞাবদ্ধ হোৱা।<br /> ৪- কাৰোবাৰ প্ৰাপ্য অধিকাৰ আত্মসাৎ কৰিলে সেইটো ওভোতাই দিয়া, আৰু কাৰো অন্যায় কৰিলে তাৰ পৰা ক্ষমা বিচৰা।<br /> আল্লাহে কৈছেঃ আৰু যিসকলে কোনো অশ্লীল কাম কৰিলে বা নিজৰ প্ৰতি অন্যায় কৰিলে আল্লাহক স্মৰণ কৰে আৰু নিজৰ পাপ কাৰ্যৰ বাবে ক্ষমা প্ৰাৰ্থনা কৰে। আল্লাহৰ বাহিৰে আন কোনে পাপ ক্ষমা কৰিব? আৰু সিহঁতে যিটো কৰি পেলাইছে সেইটো জানি বুজি পুনৰ নকৰে। <span class="c2">(ছুৰা আলে-ইমৰাণঃ ১৩৫)</span> </p>',
      ],
      15 => [
        'question' => 'প্ৰশ্ন নং ১৬- নবীৰ প্ৰতি দৰূদ পাঠ কৰাৰ অৰ্থ কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16920.mp3',
        'answer' => '<p> ইয়াৰ অৰ্থ হৈছে আল্লাহৰ ওচৰত দুআ কৰা, যাতে আল্লাহে ৰছুলুল্লাহ চাল্লাল্লাহু আলাইহি অছাল্লামৰ নাম সৰ্বোচ্চ সভাত <span class="c2">(আল-মালায়িল আ\'লাত)</span> উন্নীত কৰে। </p>',
      ],
      16 => [
        'question' => 'প্ৰশ্ন নং ১৭- ছুবহা-নাল্লাহৰ অৰ্থ কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16950.mp3',
        'answer' => '<p> উত্তৰ- মহান আল্লাহক সকলো প্ৰকাৰ দোষ-ত্ৰুটি আৰু অপৱিত্ৰতাৰ পৰা পৱিত্ৰ ঘোষণা কৰা। </p>',
      ],
      17 => [
        'question' => 'প্ৰশ্ন নং ১৮- আলহামদুলিল্লাহৰ অৰ্থ কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16980.mp3',
        'answer' => '<p> উত্তৰ- ইয়াৰ অৰ্থ হৈছে, সকলো প্ৰকাৰ প্ৰশংসা একমাত্ৰ আল্লাহৰ বাবে, লগতে সকলো প্ৰকাৰ উত্তম তথা পূৰ্ণাংগ গুণ তেওঁৰ বাবে নিৰ্দিষ্ট কৰা। </p>',
      ],
      18 => [
        'question' => 'প্ৰশ্ন নং ১৯- আল্লাহু আকবাৰৰ অৰ্থ কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/17000.mp3',
        'answer' => '<p> উত্তৰ- অৰ্থাৎ তেওঁ সকলোতকৈ মহান, সকলোতকৈ ডাঙৰ, সকলোতকৈ মৰ্যাদাৱান, সৰ্বোচ্চ মহান সত্ত্বা। </p>',
      ],
      19 => [
        'question' => 'প্ৰশ্ন নং ২০- লা হাওলা অলা কুওৱাতা ইল্লা বিল্লাহৰ অৰ্থ কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/17030.mp3',
        'answer' => '<p> উত্তৰ- ইয়াৰ অৰ্থ হৈছেঃ আল্লাহৰ শক্তি আৰু ক্ষমতা অবিহনে বান্দাই কেতিয়াও এটা অৱস্থাৰ পৰা আন এটা অৱস্থালৈ স্থানান্তৰ হ\'ব নোৱাৰে। </p>',
      ],
      20 => [
        'question' => 'প্ৰশ্ন নং ২১- আস্তাগফিৰুল্লাহৰ অৰ্থ কি?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/17060.mp3',
        'answer' => '<p> উত্তৰ- অৰ্থাৎ বান্দাৰ ফালৰ পৰা আল্লাহৰ ওচৰত এইটো প্ৰাৰ্থনা কৰা যে, তেওঁ যেন তাৰ গুনাহসমূহ ক্ষমা কৰি দিয়ে আৰু তাৰ দোষ-ত্ৰুটিবোৰৰ ওপৰত পৰ্দা আঁৰি দিয়ে। </p>',
      ],
    ],
  ],
];
