<?php
$data = [
  'title' => 'What Muslim Children Must Know',
  'description' => 'A project that contains a simple and easy curriculum for issues that a Muslim must know. It includes issues of belief, jurisprudence, prophetic biography, etiquette, tafsir, hadith, morals, and remembrance of Allah. It is suitable for young children in particular, for all ages, and newcomers to Islam.',
  'source' => 'https://kids.islamenc.com/az/home',
  'author' => 'Yazan Abdul Razzaq Raziq Alghanim',
  'sections' => [
    0 => 'Əqidə qismi',
    1 => 'Fiqh bölümü',
    2 => 'Peyğəmbərin (Allahın salavatı və salamı onun üzərinə olsun) həyatı.',
    3 => 'Təfsir bölümü',
    4 => 'Hədis bölümü',
    5 => 'İslam ədəbləri bölümü',
    6 => 'Əxlaq bölümü',
    7 => 'Dualar və zikrlər qismi',
    8 => 'Müxtəlif məsələlər bölümü:',
  ],
  'data' => [
    1 => [
      0 => [
        'question' => 'Sual 1: Rəbbin kimdir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/200.mp3',
        'answer' => '<p> Cavab: Mənim Rəbbim - mənim və bütün məxluqatın, Öz neməti ilə, qayğısına qalan Allahdır.<br /> Dəlil isə,<span class="c6"> Uca Allahın bu sözləridir:</span> ﴾Həmd olsun aləmlərin Rəbbi Allaha﴿. <span class="c2">(əl-Fatihə surəsi,<span class="c6"> ayə:</span> 2)</span>. </p>',
      ],
      1 => [
        'question' => 'Sual 2: Dinin nədir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/240.mp3',
        'answer' => '<p> Cavab: Dinim - İslamdır.<span class="c6"> İslam:</span> Tək Allaha ibadət etməklə Ona təslim olmaq, itaətlə Ona boyun əymək, Uca Allaha şərik qoşmaqdan və Ona şərik qoşan insanlardan uzaq olmaqdır.<span class="c6"><br /> Uca Allah buyurur:</span> ﴾Həqiqətən, Allah dərgahında <span class="c2">(qəbul olunan)</span> din, İslamdır!﴿. <span class="c2">(Ali-İmran surəsi,<span class="c6"> ayə:</span> 19)</span>. </p>',
      ],
      2 => [
        'question' => 'Sual 3: Peyğəmbərin kimdir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/280.mp3',
        'answer' => '<p> Cavab: Muhəmməd <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span>.<span class="c6"><br /> Uca Allah buyurur:</span> ﴾Muhəmməd Allahın Elçisidir﴿. <span class="c2">(əl-Fəth surəsi,<span class="c6"> ayə:</span> 29)</span>. </p>',
      ],
      3 => [
        'question' => 'Sual 4: Tövhid kəlməsini zikr et! Bu kəlmənin mənası nədir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/310.mp3',
        'answer' => '<p> Cavab: Tövhid kəlməsi: "Lə İləhə illə Allah" - dır.<span class="c6"> Mənası isə:</span> "Allah­dan başqa ibadətə layiq haqq məbud yoxdur".<span class="c6"><br /> Uca Allah buyurur:</span> ﴾Bil ki, Allahdan başqa <span class="c2">(ibadətə layiq olan)</span> heç bir məbud yoxdur﴿. <span class="c2">(Muhəmməd surəsi,<span class="c6"> ayə:</span> 19)</span>. </p>',
      ],
      4 => [
        'question' => 'Sual 5: İzzət və Cəlal sahibi Olan Allah haradadır?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/350.mp3',
        'answer' => '<p> Cavab: Allah səmada, bütün məxluqatın fovqündə, ərşin üzərindədir.<span class="c6"> Bu haqqda Uca Allah belə buyurur:</span> ﴾Ər-Rəhman Ərşə ucaldı﴿. <span class="c2">(Ta ha surəsi,<span class="c6"> ayə:</span> 5)</span>.<span class="c6"> Həmçinin Uca Allah buyurur:</span> ﴾O Öz qulları üzərində mütləq hakimiyyət sahibidir. O, Müdrikdir, <span class="c2">(hər şeydən)</span> Xəbərdardır﴿. <span class="c2">(əl-Ənam surəsi,<span class="c6"> ayə:</span> 18)</span>. </p>',
      ],
      5 => [
        'question' => 'Sual 6: "Muhəmməd Allahın elçisidir" şəhadətinin mənası nədir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/380.mp3',
        'answer' => '<p> Cavab: Mənası odur ki: Allah onu bütün insanlara müjdələyən və xəbərdarlıq edən elçi kimi göndərmişdir.<span class="c6"><br /> Üzərimizə vacib olan:</span><br /> 1- Əmrlərinə itaət etmək.<br /> 2- Xəbər verdiyi şeyləri təsdiqləmək.<br /> 3- Ona asi olmamaq.<br /> 4- Uca Allaha yalnız Onun qoyduğu şəriətlə ibadət olunur. Bu isə, sünnədən sarılıb, bidətdən uzaq durmaq deməkdir.<span class="c6"><br /> Uca Allah buyurur:</span> ﴾Kim Peyğəmbərə itaət edərsə, Allaha itaət etmiş olar﴿. <span class="c2">(ən-Nisa surəsi,<span class="c6"> ayə:</span> 80)</span>, həmçinin,<span class="c6"> Uca Allah buyurur:</span> ﴾O, öz istəyi ilə danışmır. Bu, ona təlqin edilən bir vəhydir﴿. <span class="c2">(ən-Nəcm surəsi,<span class="c6"> ayə:</span> 3 - 4)</span>.<span class="c6"> İzzət və Cəlal sahibi Olan Allah digər ayədə belə buyurur:</span> ﴾Allahın Elçisi sizlərə – Allaha və Axirət gününə ümidini bağlayanlara və Allahı çox zikr edənlərə gözəl nümunədir﴿. <span class="c2">(əl-Əhzab surəsi,<span class="c6"> ayə:</span> 21)</span>. </p>',
      ],
      6 => [
        'question' => 'Sual 7: Uca Allah bizi nə üçün yaratmışdır?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/480.mp3',
        'answer' => '<p> Cavab: Uca Allah bizi, Ona heç bir şeyi şərik qoşmadan, yalnız Ona ibadət etmək üçün yaratmışdır.<br /> Əyləncə və faydasız şeylərə vaxt keçirmək üçün yaratmamışdır.<span class="c6"><br /> Uca Allah buyurur:</span> ﴾Mən cinləri və insanları ancaq Mənə ibadət etmək üçün yaratdım﴿. <span class="c2">(əz-Zəriyət surəsi,<span class="c6"> ayə:</span> 56)</span>. </p>',
      ],
      7 => [
        'question' => 'Sual 8: İbadət nədir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/530.mp3',
        'answer' => '<p> Cavab: İbadət - Uca Allahın sevib razı qaldığı, zahirdə və batində olan hər bir söz və əməllərin ümumi adıdır.<span class="c6"><br /> Zahirdə olan ibadət növlərinə misal:</span> Sübhənallah, Əlhəmdulləh, Allahu Əkbər demək kimi, Allahı dil ilə zikr etmək, namaz qılmaq, Həcc etmək və s.<span class="c6"><br /> Batində olan ibadət növlərinə misal:</span> təvvəkül, qorxu, ümid etmək və s. </p>',
      ],
      8 => [
        'question' => 'Sual 9: Bizə ən vacib olan nədir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/580.mp3',
        'answer' => '<p> Cavab: Bizə ən vacib olan, Uca Allahın tövhididir <span class="c2">(yəni: tək Ona ibadət etməkdir)</span>. </p>',
      ],
      9 => [
        'question' => 'Sual 10: Tövhidin növləri hansılardır?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/610.mp3',
        'answer' => '<p> Cavab: 1- Rububiyyət tövhidi. Bu, Uca Allahın, tək, heç bir şəriki olmayan, yaradan, ruzi verən, yerin göyün mülkünə sahib olan və işləri idarə edən olmasına iman etməkdir.<br /> 2- Uluhiyyət tövhidi. Bu, Uca Allahdan başqasına ibadət etməməklə, ibadətdə Onu təkliyini qəbul etməkdir<br /> 3-<span class="c6"> Adlar və sifətlər tövhidi:</span> Bu, Uca Allahın Kitab və sünnədə varid olan ad və sifətlərinə heç bir <span class="c2">(təhrif)</span> yozum vermədən, <span class="c2">(təatil)</span> inkar etmədən, <span class="c2">(təşbih)</span> oxşatmadan və <span class="c2">(təmsil)</span> bənzətmədən Allaha layiq olan bir şəkildə iman etməkdir.<br /> Üç növ tövhidin dəlilinə gəldikdə isə,<span class="c6"> Uca Allah belə buyurur:</span> ﴾O, göylərin, yerin və onların arasında olanların Rəbbidir! Elə isə yalnız Ona ibadət et və Ona ibadətdə səbirli ol! Heç Ona oxşarını tanıyırsanmı?!﴿. <span class="c2">(Məryəm surəsi,<span class="c6"> ayə:</span> 65)</span>. </p>',
      ],
      10 => [
        'question' => 'Sual 11: Ən böyük günah hansıdır?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/670.mp3',
        'answer' => '<p> Cavab: Uca Allaha şərik qoşmaq.<span class="c6"><br /> Uca Allah buyurur:</span> ﴾Şübhəsiz ki, Allah Özünə şərik qoşulmasını bağışlamaz, bundan başqa <span class="c2">(günahları)</span> isə dilədiyi kimsəyə bağışlayar. Allaha şərik qoşan kəs iftira atmaqla böyük bir günah etmiş olur﴿. <span class="c2">(ən-Nisa surəsi,<span class="c6"> ayə:</span> 48)</span>. </p>',
      ],
      11 => [
        'question' => 'Sual 12: Allaha şərik qoşmağın (şirkin) nə olduğunu və onun növlərini zikr et!',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/710.mp3',
        'answer' => '<p> Cavab: Allaha şərik qoşmaq - ibadətin hər hansı bir növünü Uca Allahdan qeyrisinə sərf etməkdir.<span class="c6"><br /> Növləri isə bunlardır:</span><br /> 1- Böyük şirk.<span class="c6"> Misal olaraq:</span> Uca və Pak Olan Allahdan qeyrisinə dua və ya səcdə etmək, yaxud İzzət və Qüdrət sahibi Olan Allahdan başqasına qurban kəsmək.<br /> 2- Kiçik şirk.<span class="c6"> Misal olaraq:</span> Uca Allahdan qeyrisinə and içmək, ovsun taxmaq -<span class="c6"> Ovsun:</span> insanın, hər hansı bir xeyri cəlb etmək və ya hər hansı bir zərərdən qorunmaq üçün üzərindən asdığı bir şeydir. Həmçinin kiçik şirkə misal riyadır,<span class="c6"> məsələn:</span> namaz qılarkən insanların ona baxdığını bildikdə, namazını gözəlləşdirməsi. </p>',
      ],
      12 => [
        'question' => 'Sual 13: Qeybi Uca Allahdan başqa kimsə bilirmi?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/770.mp3',
        'answer' => '<p> Cavab: Tək Uca Allahdan başqa heç kimsə qeybi bilmir<br /> Uca Allah buyurur: ﴾De: “Allahdan başqa göylərdə və yerdə olanların heç biri qeybi bilməz. Onlar nə zaman diriləcəklərini belə bilmirlər﴿. <span class="c2">(ən-Nəml surəsi,<span class="c6"> ayə:</span> 65)</span>. </p>',
      ],
      13 => [
        'question' => 'Sual 14: İmanın rükunlarını sadala',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/810.mp3',
        'answer' => '<p> Cavab: 1- Uca Allaha iman etmək.<br /> 2- Mələklərinə iman etmək.<br /> 3- Kitablarına iman etmək.<br /> 4- Elçilərinə iman etmək.<br /> 5- Axirət gününə iman etmək.<br /> 6- Qədərin xeyrinə və şərinə iman etmək.<br /> Buna dəlil, İmam Müslimin Səhih əsərində rəvayət etdiyi Cəbrailin <span class="c2">(Allahın ona salamı olsun)</span> məşhur hədisidir. Belə ki, Cəbrail <span class="c2">(Allahın ona salamı olsun)</span> Peyğəmbərdən <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> iman barədə soruşaraq belə demişdir: "Mənə iman haqqında xəbər ver". Peyğəmbər <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> ona belə cavab verdi: "İman sənin, Allaha, Onun mələklərinə, kitablarına, elçilərinə, Axirət gününə və qədərin xeyrinə və şərinə iman gətirməyindir". </p>',
      ],
      14 => [
        'question' => 'Sual 15: İmanın rükunlarını şərh et.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/900.mp3',
        'answer' => '<p> Cavab: 1-<span class="c6"> Uca Allaha iman:</span><br /> Səni yaradanın, sənə ruzi verənin Allahın olduğuna və həmçinin Onun, yerin, göyün sahibi və bütün məxluqatı tək idarə edəni olduğuna iman etməndir.<br /> O, ibadət olunan İlahdır, Ondan başqa ibadət olunmağa haqqı olan məbud yoxdur.<br /> O ən əzəmətli, ən böyük və hər bir işində kamil olan Uca Allahdır. Bütün həmd-sənalar, ən gözəl ad və sifətlər yalnız Ona məxsusdur. Onun heç bir şəriki, oxşarı və bənzəri yoxdur. O, bütün bunlardan Pak və Ucadır.<br /> 2-<span class="c6"> Mələkərə iman:</span><br /> Mələkər - Allahın nurdan, Ona ibadət etmək və Onun əmrlərinə boyun əyərək, tam şəkildə yerinə yetirmək üçün yaratdığı məxluqlardır.<br /> Bu mələklərdən biri də Peyğəmbərlərə vəhy gətirən Cəbraildir <span class="c2">(Allahın ona salamı olsun)</span>.<br /> 3-<span class="c6"> Kitablara iman:</span><br /> Onlar - Uca Allahın elçilərə nazil etdiyi kitablardır.<br /> -<span class="c6"> Quran:</span> Muhəmmədə <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> nazil edilmişdir.<br /> -<span class="c6"> İncil:</span> İsaya <span class="c2">(Allahın ona salamı olsun)</span> nazil edilmişdir.<br /> -<span class="c6"> Tövrat:</span> Musaya <span class="c2">(Allahın ona salamı olsun)</span> nazil edilmişdir.<br /> -<span class="c6"> Zəbur:</span> Davuda <span class="c2">(Allahın ona salamı olsun)</span> nazil edilmişdir.<br /> -<span class="c6"> İbrahim və Musanın səhifələri:</span> İbrahim və Musaya nazil edilmişdir.<br /> 4-<span class="c6"> Elçilərə iman:</span><br /> Onlar, Uca Allahın, qullarını öyrətmək, onları xeyir və Cənnətlə müjdələmək, həmçinin şər və Cəhənnəm əzabı ilə qorxutmaq üçün göndərdiyi elçilərdir.<span class="c6"><br /> Elçilərin ən fəzilətliləri:</span> "Ulul azm" adlanan, möhkəm iradə sahibləri olanlardır.<span class="c6"> Onlar:</span><br /> 1- Nuh <span class="c2">(Allahın ona salamı olsun)</span>.<br /> 2- İbrahim <span class="c2">(Allahın ona salamı olsun)</span>.<br /> 3- Musa <span class="c2">(Allahın ona salamı olsun)</span>.<br /> 4- İsa <span class="c2">(Allahın ona salamı olsun)</span>.<br /> 5- Muhəmməd <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span>.<br /> 5-<span class="c6"> Axirət gününə iman:</span><br /> Axirət günü, insanın öldükdən sonra qəbirdə qaldığı, qiyamət saatının qopduğu, məxluqatın yenidən diriləcəyi, onların haqq-hesab olunacağı, Cənnət əhlinin Cənnətdə öz mənzillərində, Cəhənnəm əhlinin də, Cəhənnəmdə öz mənzillərində yerləşdikləri gündür.<br /> 6-<span class="c6"> Qədərin xeyrinə və şərinə iman:</span><br /> Qədər: Uca Allahın kainatda baş verən hər bir şeyi bilməsinə, baş vermiş şeyin əvvəlcədən lövhi-məhfuzda yazılmasına və onun Allahın istəyi və xəlq etməsi ilə baş verdiyinə iman etməkdir.<span class="c6"><br /> Uca Allah belə buyurur:</span> ﴾Biz, həqiqətən də, hər şeyi qədərincə yaratdıq﴿. <span class="c2">(əl-Qəmər surəsi,<span class="c6"> ayə:</span> 49)</span>.<br /> -<span class="c6"> Qədərə imanın dörd mərtəbəsi vardır:</span><br /> Birinci: Uca Allahın elminə iman etmək. Bu, Allahın hər hansı bir işin həm baş verməzdən əvvəl, həm də baş verdikdən sonra daxil olmaqla əzəldən hər bir şeyi bilməsinə iman etməkdir.<br /> Buna dəlil isə,<span class="c6"> Uca Allahın bu sözləridir:</span> ﴾Həqiqətən, o Saat haqqında elm yalnız Allahdadır. Yağışı O yağdırır və bətnlərdə olanı O bilir. Heç kəs sabah nə qazanacağını bilə bilməz; heç kəs harada öləcəyini də bilməz. Allah isə, şübhəsiz ki, Biləndir, Xəbərdardır.﴿. <span class="c2">(Loğman surəsi,<span class="c6"> ayə:</span> 34)</span>.<span class="c6"><br /> İkinci:</span> Allahın yazısına iman etmək. Bu, Uca Allahın, insanın qədərini onun dünyaya göz açmazdan öncə lövhi-məhfuzda yazıldığına və baş verən və baş verəcək hər bir şeyin Allah yanındakı kitabda əvvəlcədən yazılmış olduğuna iman etməkdir.<br /> Buna dəlil isə,<span class="c6"> Uca Allahın bu sözləridir:</span> ﴾Qeybin açarları Onun yanındadır, Onları yalnız O bilir. O, quruda və dənizdə nələr olduğunu bilir. Onun xəbəri olmadan yerə düşən bir yarpaq belə yoxdur. Yerin qaranlıqlarında elə bir toxum, elə bir yaş və elə bir quru <span class="c2">(şey)</span> yoxdur ki, açıq-aydın Yazıda <span class="c2">(Lövhi-Məhfuzda)</span> olmasın﴿. <span class="c2">(əl-Ənam surəsi,<span class="c6"> ayə:</span> 59)</span>.<span class="c6"><br /> Üçüncü:</span> Allahın istəyinə iman etmək. Bu, baş verən hər bir şeyin Allahın istəyi ilə baş verdiyinə, istər Allahın etdiyi işlər, istərsə də məxluqatın etdiyi əməllər Uca Allahın istəyi ilə baş verdiyinə iman etməkdir.<br /> Buna dəlil isə,<span class="c6"> Uca Allahın bu sözləridir:</span> ﴾Sizlərdən doğru <span class="c2">(yolda)</span> olmaq istəyənlər üçün. Aləmlərin Rəbbi Allah istəməyincə, siz istəyə bilməzsiniz!﴿. <span class="c2">(ət-Təkvir surəsi,<span class="c6"> ayə:</span> 28, 29)</span>.<span class="c6"><br /> Dördüncü:</span> Allahın yaratdığına iman etmək. Bu, bütün varlıqları Allahın yaratdığına və eyni ilə Allahın, onların kimliklərini, sifətlərini, hərəkətlərini və onlarda olan hər bir şeyi yaratmasına iman etməkdir.<br /> Buna dəlil isə,<span class="c6"> Uca Allahın bu sözləridir:</span> ﴾<span class="c1">“Axı sizi də, sizin düzəltdiklərinizi də Allah yaratmışdır”</span>﴿. <span class="c2">(əs-Saffat surəsi,<span class="c6"> ayə:</span> 96)</span>. </p>',
      ],
      15 => [
        'question' => 'Sual 16: Quranın tərifi nədir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/1300.mp3',
        'answer' => '<p> Cavab: Quran - Uca Allahın kəlamıdır, məxluq deyildir.<span class="c6"><br /> Uca Allah buyurur:</span> ﴾Əgər müşriklərdən biri səndən aman diləsə, ona aman ver ki, Allahın sözünü eşitsin﴿. <span class="c2">(ət-Tovbə surəsi,<span class="c6"> ayə:</span> 6)</span>. </p>',
      ],
      16 => [
        'question' => 'Sual 17: Sünnət nədir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/1330.mp3',
        'answer' => '<p> Cavab: Peyğəmbərin <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> dediyi, etdiyi yaxud görüb <span class="c2">(inkar etməyərək)</span> susduğu hər bir şey və həmçinin Peyğəmbərin <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> yaradılış və əxlaqi sifətlərinə sünnət deyilir. </p>',
      ],
      17 => [
        'question' => 'Sual 18: Bidət nədir və onu qəbul etməliyikmi?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/1350.mp3',
        'answer' => '<p> Cavab: Bidət - Peyğəmbərin <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> və səhabələrin zamanında dindən olmayan və insanların sonradan dinə gətirdikləri hər bir yenilikdir.<br /> Biz bidəti qəbul etmirik, əksinə onu rədd edirik.<br /> Çünki Peyğəmbər <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> bu barədə belə buyurmuşdur: "Hər bir bidət zəlalətdir". Hədisi Əbu Davud rəvayət etmişdir.<span class="c6"><br /> Buna misal:</span> İbadətdə artıq əməllərə yol vermək.<span class="c6"> Məsələn:</span> Dəstəmaz alarkən əzaları üç dəfədən artıq yumaq və ya Peyğəmbərin <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> doğum gününü qeyd etmək. Çünki bu barədə nə Peyğəmbərdən <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span>, nə də səhabələrdən bir şey varid olmamışdır. </p>',
      ],
      18 => [
        'question' => 'Sual 19: Əl-Vələ vəl-bəra (dostluq və düşmənçilik) əqidəsini zikr et!',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/1410.mp3',
        'answer' => '<p> Cavab: Əl-Vələ - möminləri sevmək və onlara yardım etməkdir.<span class="c6"><br /> Uca Allah buyurur:</span> ﴾Mömin kişilərlə mömin qadınlar bir-birinin dostlarıdır﴿. <span class="c2">(ət-Tovbə surəsi,<span class="c6"> ayə:</span> 71)</span>.<br /> Əl-Bəra əqidəsi isə, kafirlərə nifrət bəsləmək və onlarla düşmən olmaqdır.<span class="c6"><br /> Uca Allah buyurur:</span> ﴾İbrahim və onunla birlikdə olanlarda sizin üçün gözəl bir nümunə vardır.<span class="c6"> Onlar öz qövmünə dedilər:</span> <span class="c1">“Həqiqətən, biz sizdən və sizin Allahdan başqa tapındığınız şeylərdən uzağıq. Biz sizi inkar edirik. Siz bir olan Allaha iman gətirincəyə qədər bizimlə sizin aranızda daim ədavət və nifrət olacaqdır!”</span>﴿. <span class="c2">(əl-Mumtəhinə surəsi,<span class="c6"> ayə:</span> 4)</span>. </p>',
      ],
      19 => [
        'question' => 'Sual 20: Uca Allah İslamdan başqa bir din qəbul edirmi?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/1480.mp3',
        'answer' => '<p> Cavab: Xeyr, Uca Allah İslamdan başqa heç bir din qəbul etmir.<span class="c6"><br /> Uca Allah buyurur:</span> ﴾İslamdan başqa bir din axtaran şəxsdən, o <span class="c2">(din)</span> heç vaxt qəbul olunmaz və o, axirətdə ziyana uğrayanlardan olar﴿. <span class="c2">(Ali-İmran surəsi,<span class="c6"> ayə:</span> 85)</span>. </p>',
      ],
      20 => [
        'question' => 'Sual 21: Küfr, həm söz, həm əməl, həm də ki, etiqad ilə olur. Buna misal gətir!',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/1520.mp3',
        'answer' => '<p> Cavab: Sözdə küfrə misal: Pak Olan Allahı və ya Elçisini <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> söymək.<span class="c6"><br /> Əməldə misal:</span> Qurana qarşı hörmətsizlik etmək, yaxud da, Uca Allahdan qeyrisinə səcdə etmək.<span class="c6"><br /> Etiqada misal:</span> Uca Allahdan başqa hər hansı bir məxluqun ibadətə layiq olduğunu, yaxud da Uca Allahdan başqa hər hansı bir yaradanın olduğunu etiqad etmək. </p>',
      ],
      21 => [
        'question' => 'Sual 22: Nifaq nədir və onun neçə növü vardır?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/1570.mp3',
        'answer' => '<p> Cavab:<br /> 1-<span class="c6"> Böyük nifaq:</span> küfrü gizlədib, imanı göstərməkdir.<br /> Nifaqın bu növü insanı İslamdan xaric edir və bu növ nifaq, böyük küfrdür.<span class="c6"><br /> Uca Allah buyurur:</span> ﴾Həqiqətən, münafiqlər Odun ən aşağı təbəqəsində olacaqlar və sən onlara heç bir köməkçi tapa bilməzsən﴿. <span class="c2">(ən-Nisa surəsi,<span class="c6"> ayə:</span> 145)</span>.<br /> 2-<span class="c6"> Kiçik nifaq:</span><br /> Buna misal: Yalan danışmaq, verilən vədə xilaf çıxmaq və əmanətə xəyanət etmək.<br /> Nifaqın bu növü insanı İslamdan xaric etmir, lakin bunu edən insan günah qazanır və o, əzab olunmağa layiqdir.<br /> Allahın Elçisi <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> buyurur: "Münafiqin əlaməti üçdür: Danışdığı zaman yalan danışar. Vəd verdiyi zaman vədinə xilaf çıxar. Ona əmanət edildiyi zaman əmanətə xəyanət edər". Hədisi əl-Buxari və Müslim rəvayət etmişdir. </p>',
      ],
      22 => [
        'question' => 'Sual 23: Peyğəmbərlərin və elçilərin sonuncusu kimdir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/1680.mp3',
        'answer' => '<p> Cavab: O, Muhəmməddir <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span>.<span class="c6"><br /> Uca Allah buyurur:</span> ﴾Muhəmməd aranızdakı kişilərdən heç birinin atası deyildir. Lakin o, Allahın Elçisi və peyğəmbərlərin sonuncusudur﴿. <span class="c2">(əl-Əhzab surəsi,<span class="c6"> ayə:</span> 40)</span>. Allahın Elçisi <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> isə belə buyurur: "Mən peyğəmbərlərin sonuncusuyam. Məndən sonra peyğəmbər yoxdur". Hədisi Əbu Davud, ət-Tirmizi və başqaları rəvayət etmişdir. </p>',
      ],
      23 => [
        'question' => 'Sual 24: Möcüzə nədir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/1730.mp3',
        'answer' => '<p> Cavab: Möcüzə - Uca Allahın, peyğəmbərlərinə özlərinin doğruluğunu isbat etmək üçün onlara bəxş etdiyi fövqəltəbii hallardır.<span class="c6"> Məsələn:</span><br /> - Peyğəmbər <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> üçün ayın iki yerə bölünməsi.<br /> - Musa <span class="c2">(Allahın ona salamı olsun)</span> üçün dənizin iki yerə ayrılması, <span class="c2">(Musanın ardınca gələn)</span> Firon və onun qoşununun dənizdə qərq olmaları. </p>',
      ],
      24 => [
        'question' => 'Sual 25: Səhabələr kimlərdir və mən onları sevməliyəmmi?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/1780.mp3',
        'answer' => '<p> Cavab: Səhabə - Peyğəmbəri <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> görüb, ona iman gətirən və İslamda olaraq vəfat edən kimsəyə deyilir.<br /> - Biz onları sevir və onları özümüzə nümunə götürürük. Onlar, peyğəmbərlərdən sonra insanların ən fəzilətliləridir.<span class="c6"><br /> Səhabələrin ən fəzilətli olanları:</span> dörd xəlifədir:<br /> Əbu Bəkr <span class="c2">(Allah ondan razı olsun)</span>.<br /> Ömər <span class="c2">(Allah ondan razı olsun)</span>.<br /> Osman <span class="c2">(Allah ondan razı olsun)</span>.<br /> Əli <span class="c2">(Allah ondan razı olsun)</span>. </p>',
      ],
      25 => [
        'question' => 'Sual 26: Möminlərin anaları kimlərdir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/1870.mp3',
        'answer' => '<p> Cavab: Onlar - Peyğəmbərin <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> xanımlarıdır.<span class="c6"><br /> Uca Allah buyurur:</span> ﴾Peyğəmbər möminlərə onların özlərindən daha yaxındır. Zövcələri isə möminlərin analarıdır﴿. <span class="c2">(əl-Əhzab surəsi,<span class="c6"> ayə:</span> 6)</span>. </p>',
      ],
      26 => [
        'question' => 'Sual 27: Peyğəmbərin (Allahın salavatı və salamı onun üzərinə olsun) əhli beytinin üzərimizdə olan haqqı nədir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/1910.mp3',
        'answer' => '<p> Cavab: Onları sevməyimiz, onları özümüzə dost bilməyimiz, onlara nifrət edənlərə nifrət etməyimiz və onlara olan sevgi, məhəbbət, qayğı və ehtiramımızda ifrata varmamağımızdır. Onlar peyğəmbərimizin xanımları, onun zürriyyəti, Bəni-Haşim və Bəni əl-Muttalibdən olan möminlərdir. </p>',
      ],
      27 => [
        'question' => 'Sual 28: Müsəlman əmrlərinin üzərimizdə olan haqları nədir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/1940.mp3',
        'answer' => '<p> Cavab: Müsəlman əmrlərinin üzərimizdə olan haqları, onlara ehtiram etməyimiz, Allaha asi olmayan işlərdə onlara itaət edib, əmrlərinə tabe olmağımız, onlara qarşı üsyana qalxmamağımız, onlar üçün Allaha dua etməyimiz və gizlində onlara nəsihət etməyimizdir. </p>',
      ],
      28 => [
        'question' => 'Sual 29: Möminlərin yurdu haradır?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/1970.mp3',
        'answer' => '<p> Cavab: Cənnət.<span class="c6"> Uca Allah buyurur:</span> ﴾Allah iman gətirib yaxşı işlər görənləri <span class="c2">(ağacları)</span> altından çaylar axan Cənnət bağlarında yerləşdirər﴿. <span class="c2">(Muhəmməd surəsi,<span class="c6"> ayə:</span> 12)</span>. </p>',
      ],
      29 => [
        'question' => 'Sual 30: Kafirlərin yurdu haradır?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2000.mp3',
        'answer' => '<p> Cavab: Cəhənnəm.<span class="c6"> Uca Allah buyurur:</span> ﴾Yanacağı insanlardan və daşlardan olan, kafirlər üçün hazırlanmış oddan <span class="c2">(Cəhənnəmdən)</span> çəkinin!﴿. <span class="c2">(əl-Bəqərə surəsi,<span class="c6"> ayə:</span> 24)</span>. </p>',
      ],
      30 => [
        'question' => 'Sual 31: Qorxu nədir? Ümid nədir? Bunun dəlili nədir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2020.mp3',
        'answer' => '<p> Cavab: Qorxu - Uca Allahdan və Onun əzabından qorxmaqdır.<br /> Ümid isə, Uca Allahın savabına, Onun bağışlamasına və rəhmətinə ümid bəsləməkdir.<br /> Dəlil isə,<span class="c6"> Uca Allahın bu sözləridir:</span> ﴾Onların yalvardıqları tanrıların özləri də Rəbbinə – hansı daha yaxın olacaq deyə vəsilə axtarırlar, Onun rəhmətini umurlar, əzabından qorxurlar. Həqiqətən, Rəbbinin əzabından qorunmaq gərəkdir﴿. <span class="c2">(əl-İsra surəsi,<span class="c6"> ayə:</span> 57)</span>.<span class="c6"> Uca Allah buyurur:</span> ﴾Qullarıma xəbər ver ki, Mən, Bağışlayanam, Rəhmliyəm.Əzabım isə üzücü əzabdır﴿. <span class="c2">(əl-Hicr surəsi,<span class="c6"> ayə:</span> 49 - 50)</span>. </p>',
      ],
      31 => [
        'question' => 'Sual 32: Uca Allahın bəzi ad və sifətlərini zikr et!',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2070.mp3',
        'answer' => '<p> Cavab: Allah, ər-Rəbb, ər-Rahmən, əs-Səmi\', əl-Bəsir, əl-Alim, ər-Razzəq, əl-Həyy, əl-Azim və s. bu kimi Uca Allahın gözəl ad və uca sifətlərini zikr etmək olar. </p>',
      ],
      32 => [
        'question' => 'Sual 33: Bu adları şərh et.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2100.mp3',
        'answer' => '<p> Cavab: Allah.<span class="c6"> Bu adın mənası:</span> Onun heç bir şəriki olmayan, haqq olaraq ibadət olunan İlah deməkdir.<br /> ər-Rəbb.<span class="c6"> Yəni:</span> Yaradan, sahib olan, ruzi verən və idarə edən tək Pak olan Allah.<br /> əs-<span class="c6">Səmi:</span> Eşitməyi hər bir şeyti əhatə edəndir.O, müxtəlifliyindən və növündən aslı olmayaraq bütün səsləri eşidəndir.<br /> əl-<span class="c6">Bəsir:</span> O, hər bir şeyi görəndir. O, böyük və kiçikliyindən aslı olmayaraq hər bir şeyi görür.<br /> əl-<span class="c6">Alim:</span> Uca Allahın elmi, hər bir şeyi keçmişi, indisi və gələcəyi ilə birlikdə əhatə etmişdir.<br /> ər-<span class="c6">Rahmən:</span> Onun rəhməti hər bir məxluqu və canlını əhatə etmişdir. Bütün qullar və məxluqat Onun rəhməti altındadır.<br /> ər-<span class="c6">Razzəq:</span> İnsan, cin və hə bir canlı daxil olmaqla bütün məxluqatın ruzisini Öz üzərinə götürən Uca Allahdır.<br /> əl-<span class="c6">Həyy:</span> O, heç vaxt ölməz, diri olan Uca Allahdır. Yaratdığı hər bir məxluq isə öləcəkdir.<br /> əl-<span class="c6">Azim:</span> O, adlarında, sifətlərində və fellərində bütün kamilliyi və əzəməti Özündə cəm edən Uca Allahdır. </p>',
      ],
      33 => [
        'question' => 'Sual 34: Müsəlman alimlərinin üzərimizdə olan haqqlar nələrdir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2210.mp3',
        'answer' => '<p> Cavab: Biz onlara sevgi bəsləyirik. Şəri və müasir məsələrdə şəriətin hökmünü bilmək üçün onlara müraciət edirik və daima onları xeyirlə anırıq. Onlara dil uzadanlar isə, haqq yoldan azan kəslərdir.<span class="c6"><br /> Uca Allah buyurur:</span> ﴾Allah sizdən iman gətirənlərin və özlərinə elm verilmiş kimsələrin dərəcələrini ucaldır. Allah nə etdiklərinizdən xəbərdardır.﴿. <span class="c2">(əl-Mucadilə surəsi,<span class="c6"> ayə:</span> 11)</span>. </p>',
      ],
      34 => [
        'question' => 'Sual 35: Uca Allahın övliyaları (dostları) kimlərdir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2240.mp3',
        'answer' => '<p> Cavab: Onlar - Allahdan qorxan, təqva sahibi olan möminlərdir.<span class="c6"><br /> Uca Allah buyurur:</span> ﴾Şübhəsiz ki, Allahın dostlarının heç bir qorxusu yoxdur və onlar kədərlənməyəcəklər.Onlar iman gətirmiş və <span class="c2">(Allahdan)</span> qorxmuşlar﴿. <span class="c2">(Yunus surəsi,<span class="c6"> ayə:</span> 62 - 63)</span>. </p>',
      ],
      35 => [
        'question' => 'Sual 36: İman söz və əməldir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2280.mp3',
        'answer' => '<p> Cavab: İman - söz, əməl və etiqaddır. </p>',
      ],
      36 => [
        'question' => 'Sual: İman artır və azalır?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2310.mp3',
        'answer' => '<p> Cavab: İman itaətlə artır və asiliklə azalır.<span class="c6"><br /> Uca Allah buyurur:</span> ﴾Möminlər ancaq o kəslərdir ki, Allah anıldığı zaman onların qəlbi qorxuya düşər, Onun ayələri onlara oxunduqda imanları artar, yalnız öz Rəbbinə təvəkkül edər﴿. <span class="c2">(əl-Ənfal surəsi,<span class="c6"> ayə:</span> 2)</span>. </p>',
      ],
      37 => [
        'question' => 'Sual 38: Ehsan nədir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2350.mp3',
        'answer' => '<p> Cavab: Ehsan - sənin Allaha sanki Onu görürmüşsən kimi ibadət etməndir. Lakin sən Onu görməsən də, <span class="c2">(şübhəsiz)</span> ki, O səni görür! </p>',
      ],
      38 => [
        'question' => 'Sual 39: Əməllər Pak Olan Allah qatında nə vaxt qəbul olunur?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2370.mp3',
        'answer' => '<p> Cavab: İki şərt əsasında:<br /> 1- Əgər əməl, xalis olaraq Uca Allahın rizası üçün edilərsə.<br /> 2- Əgər əməl, Peyğəmbərin <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> sünnətinə müvafiq olarsa. </p>',
      ],
      39 => [
        'question' => 'Sual 40: Uca Allaha təvəkkül etmək nə deməkdir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2420.mp3',
        'answer' => '<p> Cavab: Bu, səbəblərdən yapışmaqla, xeyirlərə çatmaq və zərərlərdən qorunmaqda işləri Uca Allaha həvalə etməkdir.<span class="c6"><br /> Uca Allah buyurur:</span> ﴾Kim Allaha təvəkkül etsə, <span class="c2">(Allah)</span> ona kifayət edər﴿. <span class="c2">(ət-Talaq surəsi,<span class="c6"> ayə:</span> 3)</span>.<br /> ﴾Allah ona kifayət edər﴿,<span class="c6"> yəni:</span> Allah ona bəs edər. </p>',
      ],
      40 => [
        'question' => 'Sual 41: Yaxşılığı əmr etmək və pislikdən çəkindirmək vacibliyi nə deməkdir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2470.mp3',
        'answer' => '<p> Cavab: Yaxşılığı əmr etmək - İzzət və Qüdrət sahibi Olan Allaha itaət olan hər bir şeyi əmr etmək anlamıdır. Pislikdən çəkindirmək isə, İzzət və Qüdrət sahibi Olan Allaha asilik hesab olunan hər bir şeyi qadağan etmək anlamıdır.<span class="c6"><br /> Uca Allah buyurur:</span> ﴾Siz insanlar arasında üzə çıxarılmış ən xeyirli ümmətsiniz. Siz yaxşı işlər görməyi əmr edir, pis əməlləri qadağan edir və Allaha iman gətirirsiniz﴿. <span class="c2">(Ali-İmran surəsi,<span class="c6"> ayə:</span> 110)</span>. </p>',
      ],
      41 => [
        'question' => 'Sual 42: Əhli Sünnət val-Cəmaat kimlərdir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2510.mp3',
        'answer' => '<p> Cavab: Onlar, söz, əməl və etidaqda Peyğəmbərin <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> və onun səhabələrinin yoluna tabe olan kimsələrdir.<span class="c6"><br /> Onların "Əhli Sünnət" adlanmalarının səbəbi:</span> Peyğəmbərin <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> sünnətinə tabe olub, bidətdən uzaq olduqlarına görədir.<br /> "Val-<span class="c6">Cəmaat" adlanmalarının səbəbi isə:</span> haqq üzərində cəm olub, onda ixtilafa düşmədiklərinə görədir. </p>',
      ],
    ],
    2 => [
      0 => [
        'question' => 'Sual 1: Təharətin (təmizliyin) tərifi nədir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2580.mp3',
        'answer' => '<p> Cavab: Təharət - hədəsin <span class="c2">(təharətin şərt olduğu ibadətləri yerinə yetirməyə mane olan vəsf)</span> aradan qaldırılması və natəmiz bir şeyin yox olmasıdır.<br /> Natəmiz bir şeyin təmizlənməsi,<span class="c6"> yəni:</span> müsəlmanın onun bədənindən, paltarından, bir məkandan və ya namaz qıldığı yerdən nəcasəti aradan qaldırması deməkdir.<br /> Hədəsi<span class="c2">(təharətin şərt olan ibadətləri yerinə yetirməyə mane olan vəsf)</span> aradan qaldırmaq,<span class="c6"> yəni:</span> təmiz su ilə dəstəmaz, yaxud qüsl almaqla, su olmadıqda və ya üzürlü səbəbə görə sudan istifadə etmək mümkün olmadıqda təyəmmüm etməklə olur. </p>',
      ],
      1 => [
        'question' => 'Sual 2: Nəcasət dəyən yer necə təmizlənməlidir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2630.mp3',
        'answer' => '<p> Cavab: Həmin yer nəcasətdən təmizlənənə qədər su ilə yuyulmalıdır.<br /> Amma itin su içdiyi qabın təmizlənməsinə gəldikdə isə, həmin qab, yeddi dəfə yuyulmalı, bunların birincisi isə torpaqla olmalıdır. </p>',
      ],
      2 => [
        'question' => 'Sual 3: Dəstəmazın fəziləti nədir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2660.mp3',
        'answer' => '<p> Cavab: Peyğəmbər <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> buyurur: "Müsəlman <span class="c2">(yaxud mömin)</span> bir bəndə dəstəmaz aldığı zaman üzünü yu­duq­da, gözləri ilə gördüyü hər bir günah su ilə, <span class="c2">(yaxud suyun son damlasıyla)</span> bəra­bər üzün­dən çıxar. Əllərini yuduqda, əlləri ilə etdiyi hər bir günah su ilə, <span class="c2">(ya­xud suyun son damlasıyla)</span> bərabər əllərindən çıxar. Ayaq­larını yuduqda, ayaq­ları ilə getdiyi hər bir günah su ilə, <span class="c2">(ya­xud suyun son dam­lasıyla)</span> bərabər ayaq­larından çıxar. Nəhayət, o bəndə günahlardan tə­miz­lənmiş halda çıxar". Bu hədisi Müslim rəvayət etmişdir. </p>',
      ],
      3 => [
        'question' => 'Sual 4: Sən necə dəstəmaz alırsan?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2690.mp3',
        'answer' => '<p> Cavab: Əllər üç dəfə yuyulur.<br /> Üç dəfə madmada, istinşaq və istinsar etmək.<br /> Madmada,<span class="c6"> yəni:</span> suyu ağızda dövr etdirdikdən sonra ifraz etmək.<br /> İstinşaq,<span class="c6"> yəni:</span> sağ əli ilə suyu, hava ilə birgə buruna çəkmək.<br /> İstinsar,<span class="c6"> yəni:</span> suyu burnuna çəkdikdən sonra, sol əli ilə suyu burnundan ifraz etmək.<br /> Sonra üzü üç dəfə yumaq.<br /> Sonra əlləri üç də­fə dirsəklərə qədər yumaq.<br /> Sonra əllərini irəli-geri aparıb gətirməklə başa <span class="c2">(bir dəfə)</span> məsh çəkmək. Sonra qularlara <span class="c2">(bir dəfə)</span> məsh çəkmək.<br /> Bundan sonra isə ayaqları topuqlara qədər üç dəfə yumaq.<br /> Dəstəmazın belə alınması daha kamildir. Çünki əl-Buxari və Müslimdə, Osman ibn Əffanın və Abdullah bin Zeydin və həmçinin başqalarından rəvayət etdikləri hədisdə, Peyğəmbərin <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> belə dəstəmaz aldığı rəvayət edilmişdir. Buxarının və başqalarının rəvayət etdikləri hədisdə, Peyğəmbər <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> dəstəmazı bir dəfə, başqa rəvayətdə isə iki dəfə aldığı rəvayət edilmişdir.<span class="c6">Yəni:</span> Bir rəvayətdə Peyğəmbər <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> dəstəmaz əzalarını bir dəfə yumuşdur, başqa rəvayətdə isə iki dəfə yumuşdur. </p>',
      ],
      4 => [
        'question' => 'Sual 5: Dəstəmazın fərzləri hansılardır? Onları sadala.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2810.mp3',
        'answer' => '<p> Cavab: Dəstəmazın fərzləri o əməllərdir ki, müsəlman onlardan hər hansı biri tərk edilərsə, onun dəstəmazı səhih sayılmaz.<br /> 1- Ağız və burun daxil olmaqla üzü yumaq.<br /> 2- Əlləri dirsəklərə qədər<span class="c2">(dirsəklər daxil olmaqla)</span> yumaq.<br /> 3- Qulaqlar daxil olmaqla başa məsh çəkmək.<br /> 4- Ayaqları topuqlara qədər yumaq.<br /> 5- Bu əzaları tərtiblə yumaq.<span class="c6"> Yəni:</span> Dəstəmaz alarkən birinci üz, sonra əllər, sonra başa məsh çəkmək, daha sonra isə ayaqlar yuyulmalıdır.<br /> 6- Ardıcıllıq.<span class="c6"> Yəni:</span> Dəstəmaz alarkən fasilə vermədən, əzalardan dəstəmazın suyu qurumazdan öncə dəstəmaz əzalarını yuyub qurtarmaq.<span class="c6"><br /> Məsələn:</span> Əgər dəstəmazı yarıya qədər alıb, qalan yarısını isə başqa vaxt alarsa, bu zaman dəstəmaz səhih sayılmaz. </p>',
      ],
      5 => [
        'question' => 'Sual 6: Dəstəmazın sünnətləri hansılardır? Onları sadala.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/2910.mp3',
        'answer' => '<p> Cavab: Əgər insan dəstəmaz alarkən, dəstəmazın sünnətlərini edərsə, əlavə savab qazanar, əgər bu sünnətləri tərk edərsə, günah qazanmaz və dəstəmazı da doğru sayılar. Dəstəmazın sünnətlərinin sayı səkkizdir.<span class="c6"> Bunlar aşağıdakılardır:</span><br /> 1- Dəstəmaza başlamazdan öncə bəsmələ - "Bismilləh" demək.<br /> 2- Misvakdan istifadə etmək.<br /> 3- Əlləri biləklərə qədər yumaq.<br /> 4- Barmaqların arasını yumaq.<br /> 5- Dəstəmaz əzalarını iki və ya üç dəfə yumaq.<br /> 6- Dəstəmaz alarkən sağdan başlamaq.<br /> 7-<span class="c6"> Dəstəmazdan sonra zikr etmək:</span> <span class="c5">[Əşhədu ən lə iləhə illəllahu vahdəhu lə şərikə ləhu va əşhədu ənnə Muhəmmədən abduhu va Rasuluhu]</span> <span class="c3">«Mən şahidlik edirəm ki, Allahdan başqa haqq məbud yox­dur. O təkdir. Onun şəri­ki yoxdur. Həmçinin şahidlik edirəm ki, Muhəmməd Onun qulu və elçisi­dir!»</span>.<br /> 8- Bundan sonra iki rükət namaz qılmaq. </p>',
      ],
      6 => [
        'question' => 'Sual 7: Dəstəmazı pozan amilləri bir-bir say.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3020.mp3',
        'answer' => '<p> Cavab: Öndən və arxadan çıxan hər bir şey dəstəmazı pozur.<span class="c6"> Yəni:</span> yel də daxil olmaqla, kiçik və ya böyük təharətə çıxmaq insanın dəstəmazını batil edir.<br /> Yuxu, insanın dəli olması, yaxud özündən getməsi.<br /> Dəvə əti yemək.<br /> Heç bir maneə olmadan ön və ya arxa övrətə toxunmaq. </p>',
      ],
      7 => [
        'question' => 'Sual 8: Təyəmmüm nədir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3080.mp3',
        'answer' => '<p> Təyəmmüm: Su tapmadıqda və ya sudan istifadə etməyə qadir olmadıqda, təmizlənmək üçün pak torpaq və ya yer üzünün pak əşyalarından istifadə etmək. </p>',
      ],
      8 => [
        'question' => 'Sual 9: Təyəmmüm necə edilir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3110.mp3',
        'answer' => '<p> Cavab: Təyəmmüm, iki əlin ovuc nahiyəsi ilə bir dəfə torağa vurduqdan sonra, onları üzə və əlin üst nahiyəsinə <span class="c2">(əvvəlcə sol əlin ovcunu sağ əlin üstünə, sonra sağ əlin ovucunu sol əlin üstünə)</span> bir dəfə sürtməklə edilir. </p>',
      ],
      9 => [
        'question' => 'Sual 10: Təyəmmümü pozan amillər hansılardır?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3140.mp3',
        'answer' => '<p> Cavab: 1- Dəstəmazı pozan hər bir amil.<br /> 2- Suyun mövcud olması. </p>',
      ],
      10 => [
        'question' => 'Sual 11: Xüf və corab nədir və onların üzərinə məsh edilirmi?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3180.mp3',
        'answer' => '<p> Cavab: Xüf - dəridən hazırlanır və ayağa geyinilir.<br /> Corab isə, dəridən olmayan ayağa geyinilən geyimdir.<br /> Ayaqları yumaq əvəzinə xüf və corablar üzərinə məsh etmək caizdir. </p>',
      ],
      11 => [
        'question' => 'Sual 12: Xüflara məsh etməyin hikmətini zikr et!',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3230.mp3',
        'answer' => '<p> Cavab: Soyuq və qış aylarında və həmçinin səfərdə olarkən ayaqları çıxarıb yumaq çətin və məşəqqətli olduğuna görə insanlar üçün bir asanlıq və rahatlıqdır. </p>',
      ],
      12 => [
        'question' => 'Sual 13: Xüflərə məsh etməyin doğru olma şərtləri hansılardır?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3260.mp3',
        'answer' => '<p> Cavab: 1- Xüflərin təharətdən sonra geyinilməsi.<span class="c6"> Yəni:</span> Xüflərin dəstəmaz aldıqdan sonra geyinilməsi.<br /> 2- Xüflərin təmiz olması. Nəcasətə bulaşmış xüfə isə məsh etmək caiz deyildir.<br /> 3- Xüflərin, dəstəmazda yuyulması fərz olan ayaq nahiyəsini tam şəkildə örtməsi.<br /> 4- Xüf və corablara edilən məshin, şəriətin icazə verdiyi müddət ərzində edilməsi. Şəriət bu müddətin, səfərdə olmuyan şəxs üçün bir gün və bir gecə, müsafir kimsə üçün isə üç gün və üç gecə olduğunu təyin etmişdir. </p>',
      ],
      13 => [
        'question' => 'Sual 14: Xüflərə necə məsh edilir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3320.mp3',
        'answer' => '<p> Cavab: Xüflərə məsh etmə qaydası belədir: Dəstəmaz alarkən iki yaş əlin barmaqlarını, iki ayaq barmaqlarının üzərinə qoyaraq baldır nahiyəsinə qədər yuxarı çəkilir. Sağ ayağa, sağ əl ilə, sol ayağa isə sol əli ilə məsh edilir. Məsh edərkən əl barmaqlar bir-birindən aralı tutulmalı və məsh bir dəfədən artıq edilməməlidir. </p>',
      ],
      14 => [
        'question' => 'Sual 15: Xüflərə məshi pozan amillər hansılardır?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3350.mp3',
        'answer' => '<p> Cavab: 1- Məsh müddətinin bitməsi. Şəriətin icazə verdiyi məsh müddəti bitdikdən sonra xüflərə məsh etmək caiz deyildir. Bu müddət, muqim <span class="c2">(səfərdə olmuyan)</span> kimsə üçün bir gün və bir gecə, müsafir olan şəxs üçün isə üç gün və üç gecədir.<br /> 2- Xüflərin ayaqdan çıxarılması. Əgər insan xüflərin və ya corabların üzərinə məsh etdikdən sonra xüf və ya corabları ayağından çıxararsa, yenidən dəstəmaz almaq istədikdə xüf və ya corabların üzərinə məsh edə bilməz. </p>',
      ],
      15 => [
        'question' => 'Sual 16: Namaz sözünün mənası nədir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3390.mp3',
        'answer' => '<p> Cavab: Namaz - Xususi söz və əməllərdən ibarət, təkbir <span class="c2">(Allahu əkbər sözü)</span> ilə başlayıb, salam <span class="c2">(əs-Sələmu aleykum va rahmatullah sözü)</span> ilə qurtaran, Allaha edilən bir ibadətin adıdır. </p>',
      ],
      16 => [
        'question' => 'Sual 17: Namazın hökmü nədir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3420.mp3',
        'answer' => '<p> Cavab: Namaz qılmaq hər bir müsəlmana vacibdir.<span class="c6"><br /> Uca Allah buyurur:</span> ﴾Həqiqətən namaz möminlərə müəyyən olunmuş vaxtlarda vacib edilmişdir﴿. <span class="c2">(ən-Nisa surəsi,<span class="c6"> ayə:</span> 103)</span>. </p>',
      ],
      17 => [
        'question' => 'Sual 18: Namazı tərk etməyin hökmü nədir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3460.mp3',
        'answer' => '<p> Cavab: Namazı tərk etməyin hökmü küfürdür. Çünki bu barədə Peyğəmbər <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> belə buyurmuşdur:<br /> "Bizimlə onlar arasındakı əhd namazdır. Kim namazı tərk etsə, artıq küfr etmişdir".<br /> Hədisi İmam Əhməd, ət-Tirmizi və başqaları rəvayət etmişdir. </p>',
      ],
      18 => [
        'question' => 'Sual 19: Bir gecə və gündüz ərzində müsəlmana necə vaxt namaz qılmaq fərzdir və hər bir namaz necə rükətdən ibarətdir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3500.mp3',
        'answer' => '<p> Cavab: Müsəlmana bir gecə və gündüz ərzində beş vaxt namaz qılmaq fərz edilmişdir.<span class="c6"> Bu namazlar isə bunlardır:</span> Fəcr namazı, iki rükətdir. Zöhr namazı, dörd rükətdir. Əsr namazı, dörd rükətdir. Məğrib namazı, üç rükətdir. İşa namazı, dörd rükətdir. </p>',
      ],
      19 => [
        'question' => 'Sual 20: Namazın şərtlərini sadala!',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3530.mp3',
        'answer' => '<p> Cavab: 1- İslam<span class="c2">(müsəlman olmaq)</span>. Kafirdən namaz qəbul olunmaz.<br /> 2- Ağıllı olmaq. Dəlidən namaz qəbul edilməz.<br /> 3- Halalı haramdan, yaxşını pisdən ayırmağa qadir olmaq. Bu seçimi edə bilməyən azyaşlıdan namaz qəbul edilməz.<br /> 4- Niyyət etmək.<br /> 5- Namaz vaxtının daxil olması.<br /> 6- Dəstəmazlı olmaq.<br /> 7- Bədən və ya paltarın nəcasətdən təmiz olması.<br /> 8- Övrətin örtülməsi.<br /> 9- Qibləyə yönəlmək. </p>',
      ],
      20 => [
        'question' => 'Sual 21: Namazın rükunlarını say!',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3640.mp3',
        'answer' => '<p> Cavab: Namazın on dörd rükunu vardır.<span class="c6"> Bunlar aşağıdakılardır:</span><br /> 1- Ayaq üstə dayanmağa qadir olan insanın namazda ayaq üstə durması.<br /> 2- Təkbiratu-l-ehram. Yəni,<span class="c6"> namazın əvvəlində:</span> <span class="c3">«الله أكبر»</span> "Allahu Əkbər" demək.<br /> 3- əl-Fatihə surəsini oxumaq.<br /> 4- Rüku etmək. Rüku edərkən bel düz tutulmalı və baş isə bel ilə bərabər səviyyədə edilməlidir.<br /> 5- Rükudan qalxmaq.<br /> 6- Rükudan qalxdıqdan sonra beli düz tutmaq.<br /> 7- Səcdə etmək. Səcdə edərkən alnı, burnu, iki ovucu, iki dizləri və iki ayağın barmaqlarını yerə birləşdirmək.<br /> 8- Səcdədən qalxmaq.<br /> 9- İki səcdə arasında oturmaq.<br /> Bu halda sünnət, sol ayağı yerə qoyaraq onun üzərində oturmaq, sağ ayağı isə dik tutub, qibləyə tərəf yönəltməkdir.<br /> 10- Arxayınlıqla etmək. Bu, hər bir feli rüknu icra edərkən tələsmədən sakit halda yerinə yetirməkdir.<br /> 11- Axırıncı təşəhhüd duasını oxumaq.<br /> 12- Axırıncı təşəhhüd duası üçün oturmaq.<br /> 13- Sağ və sol tərəfə "əs-Sələmu aleykum va rahmatullah" deyərək salam vermək.<br /> 14- Bu rüknların hamısı tərtiblə, yəni, bir-birinin ardınca-yuxarıda qeyd etdiyimiz kimi etmək. Əgər qəsdən rüku etməzdən öncə səcdə edərsə, həmən rükət batil olar. Əgər səhvən edərsə, bu zaman qalxıb rükü etməli, sonra isə səcdə etməlidir. </p>',
      ],
      21 => [
        'question' => 'Sual 22: Namazın vaciblərini zikr et!',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3820.mp3',
        'answer' => '<p> Cavab: Namazın səkkiz vacibi vardır.<span class="c6"> Bunlar aşağıdakılardır:</span><br /> 1- Təkbiratu-l-ehramdan başqa olan təkbirlər.<br /> 2-<span class="c6"> İmam və tək namaz qılan insanın başını rükudan qaldırdıqda:</span> <span class="c3">«سمع الله لمن حمده»</span> <span class="c5">[Səmi Allahu limən həmidəh]</span> "Allah Ona həmd edəni eşitdi!" - zikrini demək.<br /> 3- <span class="c3">«ربنا ولك الحمد»</span> <span class="c5">[Rabbənə va ləkə-l-həmd]</span>, "Ey Rəbbimiz! Sənə həmd olsun" - zikrini demək.<br /> 4-<span class="c6"> Rükuda bir dəfə:</span> <span class="c3">«سبحان ربي العظيم»</span> <span class="c5">[Subhənə rabbiyəl-azim]</span>, "Böyük Rəbbim pak və müqəddəsdir!" - zikrini demək.<br /> 5-<span class="c6"> Səcdədə bir dəfə:</span> <span class="c3">«سبحان ربي الأعلى»</span> <span class="c5">[Subhənə Rabbiyə-l-Əla]</span>, "Ən Uca Rəbbim pak və müqəddəsdir!" - zikrini demək.<br /> 6-<span class="c6"> İki səcdə arasında:</span> <span class="c3">«رب اغفر لي»</span> <span class="c5">[Rabbi-ğ-fir li]</span> "Rəbbim, məni bağışla! Rəbbim, məni bağışla!" - zikrini demək.<br /> 7- Birinci təşəhhüd duasını oxumaq.<br /> 8- Birinci təşəhhüd duası üçün oturmaq. </p>',
      ],
      22 => [
        'question' => 'Sual 23: Namazın sünnətləri hansılardır?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/3930.mp3',
        'answer' => '<p> Cavab: Namazın on bir sünnəti var.<span class="c6"> Bunlar aşağıdakılardır:</span><br /> 1- Təkbiratu-l-ehram etdikdən sonra <span class="c3">«سبحانك اللهم وبحمدك، وتبارك اسمك، وتَعَالَىٰ جدك، ولا إله غيرك»</span> <span class="c5">[Subhənəkə Allahummə va bihəmdi­kə va təbarəkə-s-mukə və təalə cəddukə va lə iləhə ğayrukə]</span> "Allahım! Sən pak və müqəddəssən. Sənə həmd olsun. Sənin adın mübarək, əzəmə­tin ucadır. Səndən başqa məbud yoxdur!" - zikrini demək. Bu duaya "İstiftah" <span class="c2">(açılış)</span> duası deyilir.<br /> 2- əl-Fatihə surəsini oxumazdan əvvəl <span class="c3">«أعوذ بالله من الشيطان الرجيم»</span> <span class="c5">[Əuzu billəhi minəş-şeytanir-ra­cim]</span> "Lənətlənmiş şeytandan Allaha sığını­ram!" - zikrini demək.<br /> 3- <span class="c3">«بسم الله الرحمن الرحيم»</span> <span class="c5">[Bismilləhi-r-rahmənir-rahim]</span> "Mərhəmətli və Rəhmli Allahın adı ilə" ayəsini oxumaq.<br /> 4- əl-Fatihə surəsini oxuduqdan sonra "Amin" demək.<br /> 5- əl-Fatihə surəsini oxuyub qurtardıqdan sonra hər hansı bir surəni oxumaq.<br /> 6- İmamın qiraəti səslə oxuması.<br /> 7- Rükudan qaxıb <span class="c3">«ربنا ولك الحمد»</span> <span class="c5">[Rabbənə va ləkə-l-həmd]</span>, "Ey Rəbbimiz! Sənə həmd olsun" - zikrini dedikdən sonra <span class="c3">«ملء السَّمٰوات وملء الأرض، وملء ما شئت من شيء بعد»</span> <span class="c5">[Milə-s-səməvati va milə-l-ardi va milə mə şi\'tə min şeyin bədu]</span> "Göylər dolusu, yer dolusu və bundan sonra dilədiyin şeylər dolusu <span class="c2">(Sənə həmd ol­sun)</span>".<br /> 8- Rükuda bir dəfədən artıq zikr etmək.<span class="c6"> Yəni:</span> Rükuda iki, üç və yaxud daha çox sayda zikr etmək.<br /> 9- Səcdədə bir dəfədən artıq zikr etmək.<br /> 10-<span class="c6"> İki səcdə arasında bir dəfədən artıq:</span> <span class="c3">«رب اغفر لي»</span> <span class="c5">[Rabbi-ğ-fir li]</span> "Rəbbim, məni bağışla!" - zikrini demək.<br /> 11- Axırıncı təşəhhüddə Peyğəmbərə <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> və Onun ailəsinə salavat və xeyir dua etmək və ondan sonra dua etmək.<br /> Hərəkətlə olan sünnətlər. Buna namazın zahiri görnüşüdə deyilir.<span class="c6"> Bunlar aşağıdakılardır:</span><br /> 1- Əlləri təkbiratu-l-ehramda qaldırmaq.<br /> 2- Əlləri rüku etdikdə qaldırmaq.<br /> 3- Əlləri rükudan qalxdıqda qaldırmaq.<br /> 4- Rükudan qalxdıqdan sonra əlləri aşağı salmaq.<br /> 5- Sağ əli sol əlin üzərinə qoymaq.<br /> 6- Səcdə yerinə baxmaq.<br /> 7- Qiyamda olan zaman iki ayaqların arasını ayırmaq.<br /> 8- Rükuda olduqda iki əlin barmaqlarını aralayıb dizləri əllər ilə tutmaq, rüku halında başı və beli bir səviyyədə düz tutmaq.<br /> 9- Səcdə əzalarını yerə birləşdirmək.<br /> 10- Qollarını yanından, qarnını budlardan, budları baldırlardan, baldırlar dizlərindən aralı tutmaq. Səcdədə olarkən ayaqları dik tutmaq, ayaq barmaqlarını yerə birləşdirərək, barmaqların arasını açıq saxlamaq və əl­lə­ri­ni çiyinləri bərabərinə qoyub, barmaqların arasını aralı və qibləyə tərəf düz tutaraq saxlamaq.<br /> 11- İki səcdə arasında və birinci təşəhhüddə, sol ayağı yerə sərərək onun üzərində oturmaq, sağ ayağı isə dik tutub, qibləyə tərəf yönəldilmiş halda sol ayağı üstündə oturmaq. Axırıncı təşəhhüddə isə sağ ayağını dik tutub, barmaqlarını isə qibləyə yönəldilmiş halda saxlayaraq, sol ayağını sağ tərəfindən çıxarıb, sol ombasının üzərində oturmaq.<br /> 12- İki səcdə arasında və həmçinin təşəhhüd duasını oxuduqda əlləri, barmaqların arasını aralı və qibləyə tərəf düz tutaraq saxlamaq, təşəhhüd duasını oxuduqda isə adsız və çeçələ barmağını qatlayıb baş barmaqla orta barmağını dairəvi halqa halında saxlayıb, Allahı zikr etdikdə şəhadət barmağı ilə işarə etmək.<br /> 13- Salam verdikdə üzü sağ və sol tərəfə çevirmək. </p>',
      ],
      23 => [
        'question' => 'Sual 24: Namazı batil edən amilləri sadala!',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/4210.mp3',
        'answer' => '<p> Cavab: <span class="c2">(1)</span> Namazın hər hansı bir rüknunu və yə şərtlərindən hər hansı bir şərtini tərk etmək.<br /> <span class="c2">(2)</span> Namazda qəsdən danışmaq.<br /> <span class="c2">(3)</span> Namazda yemək və içmək.<br /> <span class="c2">(4)</span> Namazda ardıcıl çoxlu hərəkət etmək.<br /> <span class="c2">(5)</span> Namazın vaciblərindən hər hansı birini qəsdən tərk etmək. </p>',
      ],
      24 => [
        'question' => 'Sual 25: Müsəlman necə namaz qılmalıdır?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/4280.mp3',
        'answer' => '<p> Cavab: Namazın qılınma qaydası.<br /> 1- Sağa, sola və ya arxaya çevrilmədən, bütün bədəni ilə qibləyə tərəf yönəlmək.<br /> 2- Sonra qılmaq istədiyi namaz üçün dil ilə deyil, qəlbi ilə niyyət etməlidir.<br /> 3- Sonra təkbiratu-l-ehram edərək <span class="c2">(الله أكبر)</span> "Allahu Əkbər" deyib, əl­lə­ri­ni çiyinləri bərabərində qaldırmalıdır.<br /> 4- Sonra sağ əlini sol əlinin üstünə qoyaraq, sinəsinin üzərində tutmalıdır.<br /> 5-<span class="c6"> Sonra İstiftəh duasını oxuyaraq deyir:</span> <span class="c3">«اللهم باعد بيني وبين خطاياي كما باعدت بين المشرق والمغرب، اللهم نقني من خطاياي كما يُنقى الثوب الأبيض من الدنس، اللهم اغسلني من خطاياي بالماء والثلج والبرد»</span> <span class="c5">[Allahummə bəid beyni va beynə xata­yəyə kəmə bəadtə beynə-l-məşriqi va-l-məğribi, Allahummə nəqqini min xata­yəyə kəmə yunəqqa-s-saubul-əbyədu min­ə-d-dənəsi. Allahummə-ğ-silni min xatayəyə bi-s-səlci va-l-məi va-l-bəradi]</span> "Allahım! Məğriblə məşriqin arasını uzaqlaşdırdığın kimi məni də günahlarımdan uzaqlaşdır! Allahım! Ağ paltar kirdən təmiz­ləndiyi kimi məni də günahlarımdan təmizlə! Allahım! Mənim günahlarımı qar, su və dolu ilə yu!".<span class="c6"><br /> Yaxud da:</span> <span class="c3">«سبحانك اللهم وبحمدك، وتبارك اسمك، وتَعَالَىٰ جدك، ولا إله غيرك»</span> <span class="c5">[Subhənəkə Allahummə va bihəmdi­kə va təbarəkə-s-mukə və təalə cəddukə va lə iləhə ğayrukə]</span> "Pak və müqəddəs<span class="c2">(nöqsansız)</span> və Həmd sahibi olan Allahım! Adın mübarək, və əzəmətin ucadır, Səndən başqa ibadətə və itaətə layiq haqq məbud yoxdur!".<br /> 6-<span class="c6"> Sonra Şeytanın şərindən Allaha sığınaraq belə deyir:</span> <span class="c3">«أعوذ بالله من الشيطان الرجيم»</span> <span class="c5">[Əuzu billəhi minəş-şeytanir-ra­cim]</span> "Lənətlənmiş şeytandan Allaha sığını­ram!". 7- Sonra <span class="c3">«بسم الله الرحمن الرحيم»</span> <span class="c5">[Bismilləhi-r-rahmənir-rahim]</span> "Mərhəmətli və Rəhmli Allahın adı ilə" deyərək əl-<span class="c6">Fatihə surəsini oxuyur:</span> 1- <span class="c3">«بسم الله الرحمن الرحيم»</span> <span class="c5">[Bismilləhi-r-rahmənir-rahim]</span> ﴾Mərhəmətli və Rəhmli Allahın adı ilə﴿. 2- <span class="c3">«الْحَمْدُ للّهِ رَبِّ الْعَالَمِينَ»</span> <span class="c5">[Əlhəmdu lilləhi Rabbil-aləmin]</span> ﴾Həmd olsun aləmlərin Rəbbi Allaha,﴿. 3- <span class="c3">«الرَّحْمـنِ الرَّحِيمِ»</span> <span class="c5">[ər-Rahmənir-Rahim]</span> ﴾Mərhəmətli və Rəhmliyə,﴿. 4- <span class="c3">«مَالِكِ يَوْمِ الدِّينِ»</span> <span class="c5">[Məliki yəumid-din]</span> ﴾Haqq-hesab gününün Hökmdarına!﴿. 5- <span class="c3">«يَّاكَ نَعْبُدُ وإِيَّاكَ نَسْتَعِينُ»</span> <span class="c5">[İyyəkə nə\'budu va iyyəkə nəstəin]</span> ﴾Biz yalnız Sənə ibadət edir və yalnız Səndən kömək diləyirik.﴿. 6- <span class="c3">«اهدِنَــــا الصِّرَاطَ المُستَقِيمَ»</span> <span class="c5">[İhdinəs-siratəl-mustəqim]</span> ﴾Bizi doğru yola yönəlt –﴿. 7- <span class="c3">«صِرَاطَ الَّذِينَ أَنعَمتَ عَلَيهِمْ غَيرِ المَغضُوبِ عَلَيهِمْ وَلاَ الضَّالِّينَ»</span> <span class="c5">[Siratal-ləzinə ən-amtə aleyhim ğayril-mağdubi aleyhim vala-ddallin]</span> ﴾nemət bəxş etdiyin şəxslərin yoluna, qəzəbə uğramışların və azmışların <span class="c2">(yoluna)</span> deyil!﴿. <span class="c2">(əl-Fatihə surəsi,<span class="c6"> ayə:</span> 1-7)</span>.<br /> əl-Fatihə surəsini oxuyub qurtardıqdan sonra <span class="c3">«آمين»</span> <span class="c5">[Amin]</span>.<span class="c6"> Yəni:</span> Allahım cavab ver!- deyir.<br /> 8- Sonra Qurandan müyəssər olanı oxuyur. Fəcr namazının qiraətini isə uzun edir.<br /> 9- Sonra rüku edir.<span class="c6"> Yəni:</span> Uca Allaha təzim əlaməti olaraq belini Allah üçün əyir. Rüku edərkən təkbir edib, <span class="c2">(الله أكبر)</span> "Allahu Əkbər" deyib, əl­lə­ri­ni çiyinləri bərabərində qaldırmalıdır. Bu vəziyyətdə oldarkən, iki əlin barmaqlarını aralayıb dizləri üzərinə qoymaq, rüku halında başı və beli bir səviyyədə düz tutmaq sünnədir.<br /> 10-<span class="c6"> Rükuda üç dəfə:</span> <span class="c3">«سبحان ربي العظيم»</span> <span class="c5">[Subhənə rabbiyəl-azim]</span>, "Böyük Rəbbim pak və müqəddəsdir!" - zikrini deməlidir. Bu zikri dedikdən sonra <span class="c3">«سبحانك اللهم ربنا وبحمدك، اللهم اغفر لي»</span> <span class="c5">[Subhənəkə Allahummə Rabbənə va bihəmdikə, Alla­humməğ-firli]</span>, "Allahım! Sən pak və müqəddəssən. Ey Rəbbimiz! Sə­nə həmd olsun. Allahım, məni bağışla!"- zikrini deməsi yaxşıdır.<br /> 11- Sonra <span class="c3">«سمع الله لمن حمده»</span> <span class="c5">[Səmi Allahu limən həmidəh]</span> "Allah Ona həmd edəni eşitdi!" - zikrini deyərək başını rükudan qaldırır. Bu zaman əl­lə­ri­ni çiyinləri bərabərində qaldırmalıdır. İmamın arxasında namaz qılan kimsə isə <span class="c5">[Səmi Allahu limən həmidəh]</span> zikrini demir, o, bu zikrin əvəzinə <span class="c3">«ربنا ولك الحمد»</span> <span class="c5">[Rabbənə və ləkəl-həmd]</span> "Ey Rəb­bi­miz! Sənə həmd olsun!"- zikrini deməlidir.<br /> 12- Rükudan qalxıb belini düz tutduqdan sonra <span class="c3">«ربنا ولك الحمد، ملء السماوات والأرض، وملء ما شئت من شيء بعد»</span> <span class="c5">[Rabbənə va ləkəl-həmd. Miləs-səməvati va miləl-ardi va milə mə şitə min şeyin bə\'du]</span> "Ey Rəbbimiz! Sənə həmd olsun. Göylər dolusu, yer dolusu və bundan sonra dilədiyin şeylər dolusu <span class="c2">(Sənə həmd ol­sun)</span>"- zikrini deməlidir.<br /> 13- Sonra <span class="c2">(الله أكبر)</span> "Allahu Əkbər" deyərək birinci səcdəni etməlidir. Səcdə yeddi əza üzərində edilməlidir.<span class="c6"> Bu əzalar aşağıdakılardır:</span> Alın, burun, iki əl, iki diz, ayaq barmaqlarının ucları. Səcdə edərkən qollarını yanından ayırmalı, dirsəklərini yerə sərməməli və barmaqlarının ön hissələrini qibləyə tərəf yönəltməlidir.<br /> 14-<span class="c6"> Səcdədə üç dəfə:</span> <span class="c3">«سبحان ربي الأعلى»</span> <span class="c5">[Subhənə Rabbiyəl-Əla]</span> "Ən Uca Rəbbim pak və müqəddəsdir!" - zikrini deməlidir. Bu zikri dedikdən sonra <span class="c3">«سبحانك اللهم ربنا وبحمدك، اللهم اغفر لي»</span> <span class="c5">[Subhənəkə Allahummə Rabbənə va bihəmdikə, Alla­humməğ-firli]</span>, "Allahım! Sən pak və müqəddəssən. Ey Rəbbimiz! Sə­nə həmd olsun. Allahım, məni bağışla!"- zikrini deməsi yaxşıdır.<br /> 15- Sonra <span class="c2">(الله أكبر)</span> "Allahu Əkbər" deyərək başını səcdədən qaldırır.<br /> 16- Sonra iki səcdə arasında sol ayağı üzərində oturur, sağ ayağını düz tutur, sağ əlini sağ budunun dizinə yaxın məsafədə qoyur, adsız və çeçələ barmağını qatlayıb, şəhadət barmağını dua etdikdə qaldırır və hərəkət etdirir, baş barmaqla orta barmağını dairəvi halda saxlayıb və sol əlinin barmaqlarının arasını aralı qoyaraq sol budunun dizinə yaxın məsafədə tutmalıdır.<br /> 17-<span class="c6"> Və iki səcdə arasında oturaraq belə deyir:</span> <span class="c3">«رب اغفر لي، وارحمني، واهدني، وارزقني، واجبرني، وعافني»</span> <span class="c5">[Rabbiğ-fir li, var-həmni, vahdini, var-zuqni, vac-burni, va afini]</span> "Rəbbim, məni bağışla, mənə rəhm et, məni doğru yo­la yönəlt, mənə ruzi yetir, mənə lütf et və mənə salamatlıq ver!".<br /> 18- Sonra birinci səcdəni etdiyi kimi ikinci səcdəni də edir, birinci səcdədə dediyi zikrləri və etdiyi hərəkətləri eyni ilə ikinci səcdədə də təkrar edir və səcdə etdikdə təkbir yəni "Allahu Əkbər"- deyir.<br /> 19- Sonra "Allahu Əkbər" deyərək, ikinci rükətdən ayağa qalxır. İkinci rükəti də birinci rükəti qıldığı kimi qılır. İstiftah <span class="c2">(açılış)</span> duası müstəsna olmaqla, birinci rükətdə dediyi zikrləri və etdiyi hərəkətləri eyni ilə ikinci rükətdə də təkrar edir.<br /> 20- İkinci rükəti qurtardıqdan sonra "Allahu Əkbər" deyərək, iki səcdə arasında oturduğu kimi təşəhhüd duasını oxumaq üçün oturur.<br /> 21-<span class="c6"> Bu oturuşda təşəhhüd duasını oxuyaraq belə deyir:</span> <span class="c3">«التحيات لله والصلوات والطيبات، السلام عليك أيها النبي ورحمة الله وبركاته، السلام علينا وعلى عباد الله الصالحين، أشهد أن لا إله إلا الله، وأشهد أن محمداً عبده ورسوله، اللهم صلِّ على محمد وعلى آل محمد، كما صليت على إبراهيم وعلى آل إبراهيم، إنك حميد مجيد، وبارك على محمد وعلى آل محمد، كما باركت على إبراهيم وعلى آل إبراهيم، إنك حميد مجيد»</span> <span class="c5">[ət Təhiyyətu lilləhi, va-s-saləvatu, va-t-tayyibətu, əs Sələmu aleykə əyyuhə-n-nəbiyyu va rahmətullahi va bərakətuhu, əsSələmu aleynə va alə ibədi-l-ləhi-s-Sali­hin. Əşhədu əllə iləhə illəllahu va əşhədu ənnə Muhəmmədən abduhu va rasuluhu. Allahummə salli alə Muhəmmədin va alə əəli Muhəmməd, kəmə salleytə alə İbra­himə va alə əəli İbrahimə, innəkə həmi­dun məcid. Allahummə bərik alə Muhəm­mədin va alə əəli Muhəmməd, kəmə bərak­tə alə İbrahimə va alə əəli İbrahimə, innəkə həmidun məcid]</span> "Salamlar, dualar və gözəl şeylər Allaha aiddir. Ey Peyğəmbər, sənə salam olsun, Allahın mərhəməti və Onun bərəkəti <span class="c2">(olsun)</span>! Bizə və Allahın əməlisaleh qul­larına salam ol­sun! Mən şahidlik edirəm ki, Allahdan başqa məbud yoxdur və şahid­lik edirəm ki, Muhəm­məd Onun qulu və elçisi­dir. Allahım! İbrahimə və İbrahimin ailə­sinə xeyir-dua verdiyin kimi, Muhəmmədə və Muhəmmədin ailəsinə də xeyir-dua ver! Şüb­həsiz ki, Sən Tərifəlayiqsən, Şan-şöh­rətlisən! Allahım! İbrahimə və İbrahimin ailəsinə bərə­kət verdiyin kimi, Muhəmmədə və Muhəmmə­din ailəsinə də bərəkət ver! Şübhəsiz ki, Sən Tərifəlayiqsən, Şan-şöh­rətlisən!". <span class="c3">«أعوذ بالله من عذاب جهنم، ومن عذاب القبر، ومن فتنة المحيا والممات، ومن فتنة المسيح الدجال»</span> <span class="c5">[Əuzu biLləhi min əzabi Cəhənnəmə va min əzabil-qabri va min fitnətil-məhyə val-məmati va min şərri fitnətil-məsihid-dəccal]</span> "Cəhənnəm əzabından, qəbir əzabından, həyatın və ölümün fitnəsindən, məsih dəccalın fitnəsinin şərindən Allaha pənah aparıram!". Sonra Rəbbindən dilədiyi dünya və axirət xeyirlərini istəyərək dua edir.<br /> 22- Sonra sağ və sol tərəfə <span class="c3">«السَّلام عليكم ورحمة الله»</span> <span class="c5">[əs-Sələmu aleykum va rahmatullah]</span> "Allahın salamı və rəhməti sizin üzərinizə olsun" deyərək salam verib namazı sona çatdırır.<br /> 23- Əgər namaz üç və ya dörd rükətli namazdırsa, birinci təşəhhüdü <span class="c3">«أشهد أن لا إله إلا الله، وأشهد أن محمداً عبده ورسوله»</span> <span class="c5">[Əşhədu əllə iləhə illəllahu va əşhədu ənnə Muhəmmədən abduhu va rasuluhu]</span> "Mən şahidlik edirəm ki, Allahdan başqa haqq məbud yoxdur və şahid­lik edirəm ki, Muhəm­məd Onun qulu və elçisi­dir"- hissəsinə qədər oxumalıdır.<br /> 24- Sonra "Allahu Əkbər" deyərək qiyama qalxır. Bu zaman əl­lə­ri­ni çiyinləri bərabərində qaldırmalıdır.<br /> 25- Sonra namazının qalan hissəsini isə ikinci rükəti qıldığı kimi qılmalıdır. Lakin üçüncü və dördüncü rükətlərdə əl-Fatihə surəsindən sonra heç bir surə oxumur.<br /> 26- Sonra Təvərrük oturuşu oturaraq, sağ ayağını düz tutur, sol ayağını isə sağ baldırının altından kənara çıxararaq, sol ombası üstündə oturur, birinci təşəhhüddə oturduğu kimi iki əlini, iki budunun üstünə qoyur.<br /> 27- Bu oturuşda isə təşəhhüd duasını axıra qədər oxuyur.<br /> 28- Sonra sağ və sol tərəfə <span class="c3">«السَّلام عليكم ورحمة الله»</span> <span class="c5">[əs-Sələmu aleykum va rahmatullah]</span> "Allahın salamı və rəhməti sizin üzərinizə olsun" deyərək salam verib namazı sona çatdırır. </p>',
      ],
      25 => [
        'question' => 'Sual 26: Salam verib namazı bitirdikdən sonra hansı zikrlər deyirsən?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/4610.mp3',
        'answer' => '<p> Cavab: Üç dəfə <span class="c3">«أَسْـتَغْفِرُ الله»</span> <span class="c5">[Əstəğfirul-lah]</span> "Allahdan bağışlanma diləyirəm!".<br /> - <span class="c3">«اللّهُـمَّ أَنْـتَ السَّلامُ، وَمِـنْكَ السَّلام، تَبارَكْتَ يا ذا الجَـلالِ وَالإِكْـرام»</span> <span class="c5">[Allahummə ən­tə-s-sələmu va minkə-s-sələmu, təbəraktə yə zə-l-cələli va-l-ikram]</span> "Allahım! Salam Sənsən və əmin-aman­lıq Səndəndir. Ey əzəmət və ehtiram sahibi! Sən xeyirxahsan".<br /> - <span class="c3">«لا إلهَ إلاّ اللّهُ وحدَهُ لا شريكَ لهُ، لهُ المُـلْكُ ولهُ الحَمْد، وهوَ على كلّ شَيءٍ قَدير، اللّهُـمَّ لا مانِعَ لِما أَعْطَـيْت، وَلا مُعْطِـيَ لِما مَنَـعْت، وَلا يَنْفَـعُ ذا الجَـدِّ مِنْـكَ الجَـد»</span> <span class="c5">[Lə iləhə illə-l-lahu vahdəhu lə şərikə ləh. Ləhu-l-mulku va ləhul-həmdu va huvə alə kulli şeyin qadir. Allahummə, lə mənia limə ə\'taytə va lə mu\'tiyə limə məna\'tə va lə yənfəu zə-l-cəddi minkə-l-cəddu]</span> "Allahdan başqa məbud yoxdur, O tək­dir, Onun şəri­ki yoxdur. Mülk Onundur və həmd Onadır! O hər şeyə Qadirdir! Allahım! Sənin verdiyinə mane olacaq, mane olduğunu da verəcək <span class="c2">(bir kəs)</span> yoxdur. Heç bir hörmət sahibinə Sənin yanında hör­məti fayda ver­məz".<br /> - <span class="c3">«لا إلهَ إلاّ الله، وحدَهُ لا شريكَ لهُ، لهُ الملكُ ولهُ الحَمد، وهوَ على كلّ شيءٍ قدير، لا حَـوْلَ وَلا قـوَّةَ إِلاّ بِاللهِ، لا إلهَ إلاّ الله، وَلا نَعْـبُـدُ إِلاّ إيّـاه، لَهُ النِّعْـمَةُ وَلَهُ الفَضْل وَلَهُ الثَّـناءُ الحَـسَن، لا إلهَ إلاّ الله مخْلِصـينَ لَـهُ الدِّينَ وَلَوْ كَـرِهَ الكـافِرون»</span>.<br /> <span class="c5">[Lə iləhə illə-l-lahu vahdəhu lə şərikə ləhu. Ləhu-l-mulku va ləhu-l-həmdu va huvə alə kulli şeyin qadir. Lə havlə va lə quvvatə illə billəhi. Lə iləhə illə-l-lahu, va lə nə\'budu illə iyyəh. Ləhu-n-ni\'mətu va lə­hu-l-fədlu va ləhu-s-sənəu-l-həsənu. Lə iləhə illə-l-lahu muxlisınə ləhu-d-dinə va lov kəri­hə-l-kəfirun]</span> "Allahdan başqa məbud yoxdur, O tək­dir, Onun şəri­ki yoxdur. Mülk Onundur və həmd Onadır! O hər şeyə Qadirdir! Qüdrət və güc yalnız Allahdadir! Allahdan başqa mə­bud yoxdur. Biz yalnız Ona ibadət edirik. Nemət Onun­dur, lütf Onundur və gözəl tərif Onadır. Allahdan başqa məbud yoxdur. Kafirlərə xoş gəlməsə də, biz dini yalnız Ona məxsus edi­rik!".<br /> Otuz üç dəfə <span class="c3">«سُـبْحانَ اللهِ»</span> <span class="c5">[Subhənə-l-lah]</span> "Allah pak və müqəddəsdir".<br /> Otuz üç dəfə <span class="c3">«الحَمْـدُ لله»</span> <span class="c5">[Əl-həmdu lilləh]</span> "Həmd Allahadır".<br /> Otuz üç dəfə <span class="c3">«اللهُ أكْـبَر»</span> <span class="c5">[Allahu Əkbər]</span> "Allah Böyükdür".<span class="c6"><br /> Yüzün tamamında isə belə deyir:</span> - <span class="c3">«لا إله إلا الله وحده لا شريك له، له الملك وله الحمد، وهو على كل شيء قدير»</span> <span class="c5">[Lə iləhə illə-l-lahu vahdəhu lə şərikə ləh. Ləhu-l-mulku va ləhul-həmdu va huvə alə kulli şeyin qadir]</span> "Allahdan başqa məbud yoxdur, O tək­dir, Onun şəri­ki yoxdur. Mülk Onundur və həmd Onadır! O hər şeyə Qadirdir!".<br /> Fəcr və məğrib namazdan sonra üç dəfə, zöhr, əsr və işa namazlarından sonra isə bir dəfə əl-İxlas, əl-Fələq və ən-Nas surələrini oxuyur.<br /> Sonra isə bir dəfə "Ayətul-kursi" ayəsi­ni oxuyur. </p>',
      ],
      26 => [
        'question' => 'Sual 27: Ratibə sünnət hesab edilən namazlar hansılardır və bu namazları qılanlar üçün hansı fəzilət vardır?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/4730.mp3',
        'answer' => '<p> Cavab: Fəcr namazından öncə iki rükət.<br /> Zöhr namazından öncə dörd rükət.<br /> Zöhr namazından sonra iki rükət.<br /> Məğrib namazından sonra iki rükət.<br /> İşa namazından sonra iki rükət.<br /> Bu namazların fəzilətinə gəldikdə isə, Peyğəmbərin <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> belə dediyi rəvayət olunur: "Kim bir gecə və gün ərzində, könüllü olaraq on iki rükət sünnət namaz qılarsa, Allah onun üçün Cənnətdə ev tikər". Hədisi Müslim, İmam Əhməd və başqaları rəvayət etmişdir. </p>',
      ],
      27 => [
        'question' => 'Sual 28: Həftə günləri içərisində ən əfzəl gün hansdır?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/4800.mp3',
        'answer' => '<p> Cavab: Cümə günü. Bu barədə Peyğəmbər <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> belə buyurmuşdur: "Şübhəsiz ki, cümə günü sizin ən fəzilətli günlərinizdəndir. Adəm o gündə yaradılmış və ruhu o gündə alınmışdır. Sura üfürülmə və insanların <span class="c2">(dəhşətli səsin qorxusundan)</span> bayılması o gündə olacaqdır. Cümə günü mənə çox-çox salavat gətirin, çünki sizin salavatınız mənə arz olunur".<span class="c6"> Səhabələr:</span> Ey Allahın Elçisi, cəsədin çürüdüyü halda salavatımız sənə necə ərz oluna bilər? - deyə sual verdilər. Peyğəmbər <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> də onlara belə cavab verdi: "İzzət və Cəlal sahibi Olan Allah Peyğəmbərlərin cəsədlərini torpağa haram etdi <span class="c2">(torpaq onların cəsədini yeməz)</span>". Hədisi Əbu Davud və başqaları rəvayət etmişdir. </p>',
      ],
      28 => [
        'question' => 'Sual 29: Cümə namazının hökmü nədir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/4840.mp3',
        'answer' => '<p> Cavab: Cümə namazı hər bir həddi-büluğa çatmış kişi, ağıl sahibi və səfərdə olmuyan müsəlmana fərzu-ayındır.<span class="c6"><br /> Uca Allah buyurur:</span> ﴾Ey iman gətirənlər! Cümə günü namaza çağırılanda Allahı yad etməyə tələsin və ticarəti dayandırın. Bilsəniz, bu sizin üçün nə qədər xeyirlidir!﴿. <span class="c2">(əl-Cumuə surəsi,<span class="c6"> ayə:</span> 9)</span>. </p>',
      ],
      29 => [
        'question' => 'Sual 30: Cümə namazı necə rükətdən ibarətdir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/4880.mp3',
        'answer' => '<p> Cavab: Cümə namazı iki rükətdən ibarətdir. İmam bu iki rükətin hər ikisində də qiraəti səslə oxumalı və bu iki rükət namazdan öncə iki hissədən ibarət xütbə verməlidir. </p>',
      ],
      30 => [
        'question' => 'Sual 31: Cümə namazını buraxmaq caizdirmi?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/4910.mp3',
        'answer' => '<p> Cavab: Şəri üzr olmadan cümə namazını buraxmaq caiz deyildir. Bu barədə Peyğəmbər <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> belə demişdir: "Kim tənbəllik səbəbilə cümə namazını üç dəfə tərk edərsə, Allah onun qəlbini möhürləyər". Hədisi Əbu Davud və başqaları rəvayət etmişdir. </p>',
      ],
      31 => [
        'question' => 'Sual 32: Cümə gününün sünnətlərini zikr et!',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/4940.mp3',
        'answer' => '<p> Cavab:<br /> 1- Cümə qüsulu almaq.<br /> 2- Ətirlənmək.<br /> 3- Gözəl libas geyinmək.<br /> 4- Məscidə erkən getmək.<br /> 5- Peyğəmbərə <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> çoxlu salavat gətirmək.<br /> 6- Kəhf surəsini oxumaq.<br /> 7- Məscidə piyada getmək.<br /> 8- Duaların qəbul olunan saatını axtarmaq. </p>',
      ],
      32 => [
        'question' => 'Sual 33: Camaat namazının fəzilətini zikr et!',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5050.mp3',
        'answer' => '<p> Cavab: Abdullah ibn Ömər <span class="c2">(Allah ondan razı olsun)</span> Allahın Elçisinin <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> belə dediyini rəvayət edir: "Camaat namazı fərdi şəkildə qılınan namazdan iyirmi yeddi dərəcə üstündür". Bu hədisi Müslim rəvayət etmişdir. </p>',
      ],
      33 => [
        'question' => 'Sual 34: Namazda "xüşu" nə deməkdir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5080.mp3',
        'answer' => '<p> Cavab: Namazda xüşu - namaz qılarkən insanın qəlbinin Allaha bağlaması və bədən əzalarının sükunət halında olması deməkdir.<span class="c6"><br /> Uca Allah buyurur:</span> ﴾Möminlər, həqiqətən də, nicat tapmışlar; o kəslər ki, namazlarında mütidirlər﴿. <span class="c2">(əl-Muminun surəsi,<span class="c6"> ayə:</span> 1 - 2)</span>. </p>',
      ],
      34 => [
        'question' => 'Sual 35: Zəkatın tərifi nədir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5120.mp3',
        'answer' => '<p> Cavab: Zəkat: cəmiyyətdə xüsusi insanlara, xüsusi maldan və xüsusi vaxtda verilməsi vacib sayılan bir haqdır.<br /> Zəkat İslamın rükunlarından biridir və zənginlərdən alınıb, yoxsullara verilən vacib bir sədəqədir.<span class="c6"><br /> Uca Allah buyurur:</span> ﴾... zəkat verin ...﴿. <span class="c2">(əl-Bəqərə surəsi,<span class="c6"> ayə:</span> 43)</span> </p>',
      ],
      35 => [
        'question' => 'Sual 36: Müstəhəb sədəqə nədir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5170.mp3',
        'answer' => '<p> Cavab: İnsanın öz malından zəkatdan başqa Allah yolunda xərclədiyi hər bir şey müstəhəb sədəqədir.<span class="c6"> Məsələn:</span> İnsanın hər hansı bir vaxtda, hər hansı bir xeyir iş üçün malından Allah yolunda xərcləməsi.<span class="c6"><br /> Uca Allah buyurur:</span> ﴾<span class="c2">(Malınızdan)</span> Allah yolunda xərcləyin﴿. <span class="c2">(əl-Bəqərə surəsi,<span class="c6"> ayə:</span> 195)</span>. </p>',
      ],
      36 => [
        'question' => 'Sual 37: Orucun tərifi nədir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5210.mp3',
        'answer' => '<p> Cavab: Oruc - Allaha ibadət niyyətilə sübh namazının girən vaxtından, günəş batana qədər yeməkdən, içməkdən və s. orucu batil edən amillərdən imtina etməkdir.<span class="c6"> Oruc iki növdən ibrətdir:</span><br /> Vacib olan oruc.<span class="c6"> Məsələn:</span> Ramazan ayının orucu. Bu oruc, İslamın ərkanlarından biridir.<span class="c6"><br /> Uca Allah buyurur:</span> ﴾Ey iman gətirənlər! Siz-dən əvvəlkilərə vacib edildiyi kimi, sizə də oruc tutmaq vacib edildi ki, bəlkə <span class="c2">(pis əməllərdən)</span> çəkinəsiniz﴿. <span class="c2">(əl-Bəqərə surəsi,<span class="c6"> ayə:</span> 183)</span>.<br /> Vacib olmayan oruc.<span class="c6"> Məsələn:</span> Hər həftənin birinci və dördüncü günü oruc tutmaq. Hər ayda üç gün oruc tutmaq. Ən əfzəli isə hər qəməri ayının <span class="c2">(13, 14, 15)</span> oruc tutmaqdır. </p>',
      ],
      37 => [
        'question' => 'Sual 38: Ramazan ayının orucunun fəzilətini qeyd et.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5270.mp3',
        'answer' => '<p> Cavab: Əbu Hureyra <span class="c2">(Allah ondan razı olsun)</span> Allahın Elçisinin <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> belə dediyini rəvayət edir: "Kim imanla və savabını AlIahdan umaraq Ramazan orucunu tutarsa, keçmiş günahları bağışlanar". Hədisi əl-Buxari və Müslim rəvayət etmişdir. </p>',
      ],
      38 => [
        'question' => 'Sual 39: Ramazan orucundan savayı nafilə oruc tutmağın fəzilətini zikr et!',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5300.mp3',
        'answer' => '<p> Cavab: Əbu Səid əl-Xudri <span class="c2">(Allah ondan razı olsun)</span> Allahın Elçisinin <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> belə dediyini rəvayət edir: "Kim Allah yolunda bir gün oruc tutarsa, Allah, o günün orucu ilə cəhhənəm atəşini onun vücudundan yetmiş payız uzaqlaşdırar". Hədisi əl-Buxari və Müslim rəvayət etmişdir.<br /> "Yetmiş payız",<span class="c6"> yəni:</span> "Yetmiş il" </p>',
      ],
      39 => [
        'question' => 'Sual 40: Orucu pozan bəzi amilləri zikr et!',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5330.mp3',
        'answer' => '<p> Cavab: 1- Qəsdən yemək və içmək.<br /> 2- Qəsdən qaytarmaq.<br /> 3- İslam dinindən çıxmaq. </p>',
      ],
      40 => [
        'question' => 'Sual 41: Orucun sünnətləri hansılardır?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5380.mp3',
        'answer' => '<p> Cavab: 1- İftarı tezləşdirmək.<br /> 2- Səhur etmək və səhuru gecləşdirmək.<br /> 3- Saleh əməlləri və ibadəti çoxaltmaq.<br /> 4-<span class="c6"> Oruc tutanı təhqir edən kimsəyə:</span> "Mən orucam"- demək.<br /> 5- İftar vaxtı dua etmək.<br /> 6- Yaş, yaxud quru xurma ilə. Əgər bunları tapmasa, o zaman su ilə iftar etmək. </p>',
      ],
      41 => [
        'question' => 'Sual 42: Həccin tərifi nədir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5460.mp3',
        'answer' => '<p> Cavab: Həcc - məlum ayinləri yerinə yetirmək üçün və həcc üçün təyin olunan vaxtda Allaha ibadət məqsədi ilə Məkkeyi-Mükərrəmədə yerləşən Allahın evi Kəbəni ziyarət etməkdir.<span class="c6"><br /> Uca Allah buyurur:</span> ﴾Evi <span class="c2">(Kəbəni)</span> ziyarət etmək insanların – yoluna gücü çatan hər kəsin – Allah qarşısında borcudur. Kim <span class="c2">(bunu)</span> inkar edərsə, <span class="c2">(bilsin ki,)</span> Allahın aləmlərə ehtiyacı yoxdur.﴿. <span class="c2">(Ali-İmran surəsi,<span class="c6"> ayə:</span> 97)</span>. </p>',
      ],
      42 => [
        'question' => 'Sual 43: Həccin ərkanlarını say.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5500.mp3',
        'answer' => '<p> 1- İhram <span class="c2">(niyyət etmək)</span>.<br /> 2- Ərəfədə dayanmaq.<br /> 3- İfadə təvafı.<br /> 4- Səfa və Mərva arasında səy etmək. </p>',
      ],
      43 => [
        'question' => 'Sual 44: Həccin fəziləti nədir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5560.mp3',
        'answer' => '<p> Cavab: Əbu Hureyra <span class="c2">(Allah ondan razı olsun)</span> deyir ki, Allahın Elçisinin <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> belə dediyini eşitdim: "Kim qadınla yaxınlıq etmədən və söyüş söyüb pis sözlər danışmadan həcc edərsə, həccdən anadan doğulduğu kimi <span class="c2">(günahsız)</span> qayıdar". Hədisi əl-Buxari və başqaları rəvayət etmişdir.<br /> "Anadan doğulduğu kimi <span class="c2">(günahsız)</span> qayıdar",<span class="c6"> yəni:</span> həccdən günahları bağışlanmış halda qayıdar. </p>',
      ],
      44 => [
        'question' => 'Sual 45: Ümrənin tərifi nədir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5600.mp3',
        'answer' => '<p> Cavab: Ümrə - ilin hər bir vaxtında məlum ayinləri yerinə yetirmək üçün Allaha ibadət məqsədi ilə Məkkeyi-Mükərrəmədə yerləşən Allahın evi Kəbəni ziyarət etməkdir. </p>',
      ],
      45 => [
        'question' => 'Sual 46: Ümrənin ərkanlarını say.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5630.mp3',
        'answer' => '<p> 1- İhram <span class="c2">(niyyət etmək)</span>.<br /> 2- Kəbəni tavaf etmək.<br /> 3- Səfa və Mərva arasında səy etmək. </p>',
      ],
      46 => [
        'question' => 'Sual 47: Allah yolunda cihad nədir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5690.mp3',
        'answer' => '<p> Cavab: Cihad - İslamı yaymaqda, İslamı və müsəlmanları müdafiə etməkdə, həmçinin İslama və müsəlmanlara düşmənçilik edənlərlə qarşı döyüşdə, səy və güc sərf etmək.<span class="c6"><br /> Uca Allah buyurur:</span> ﴾... malınız və canınızla Allah yolunda cihad edin! Biləsiniz ki, bu sizin üçün daha xeyirlidir﴿. <span class="c2">(ət-Tovbə surəsi,<span class="c6"> ayə:</span> 41)</span>. </p>',
      ],
    ],
    3 => [
      0 => [
        'question' => 'Sual 1: Peyğəmbərimiz Muhəmmədin (Allahın salavatı və salamı onun üzərinə olsun) nəsəbi nədir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5740.mp3',
        'answer' => '<p> Cavab: O, Muhəmməd bin Abdullah bin Abdulmüttəlib bin Haşimdir. Haşim, Qureyş qəbiləsindəndir. Qureyş qəbiləsi isə Ərəb millətindəndir. Ərəb milləti isə İsmail zürriyyətindəndir. İsmail isə İbrahim peyğəmbərin - Ona və Peyğəmbərimizə Allahın salavatı və salamı onun üzərinə olsun - oğludur. </p>',
      ],
      1 => [
        'question' => 'Sual 2: Peyğəmbərimizin (Allahın salavatı və salamı onun üzərinə olsun) anasının adı nədir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5770.mp3',
        'answer' => '<p> Cavab: Əminə bint Vəhb. </p>',
      ],
      2 => [
        'question' => 'Sual 3: Atası nə zaman vəfat etmişdir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5800.mp3',
        'answer' => '<p> Cavab: Peyğəmbərimizin <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> atası, Peyğəmbərimiz <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> doğulmazdan öncə, anasının bətnində olarkən, Mədinədə vəfat etmişdir. </p>',
      ],
      3 => [
        'question' => 'Sual 4: Peyğəmbərimiz (Allahın salavatı və salamı onun üzərinə olsun) nə zaman dünyaya gəlmişdir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5830.mp3',
        'answer' => '<p> Cavab: Fil ilinin Rabi əl-Əvval ayında, həftənin birinci günündə dünyaya göz açmışdır. </p>',
      ],
      4 => [
        'question' => 'Sual 5: Peyğəmbərimiz (Allahın salavatı və salamı onun üzərinə olsun) hansı şəhərdə dünyaya gəlmişdir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5850.mp3',
        'answer' => '<p> Cavab: Məkkə şəhərində. </p>',
      ],
      5 => [
        'question' => 'Sual 6: Anasından savayı süd anaları və ona dayəlik edən qadınlar kimlərdir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5880.mp3',
        'answer' => '<p> Cavab: Atasının kənizlikdən azad etdiyi Ummu Əymən.<br /> - Əmisi Əbu Ləhəbin kənizlikdən azad etdiyi Suveybə.<br /> - Həlimə əs-Sə\'diyyə. </p>',
      ],
      6 => [
        'question' => 'Sual 7: Peyğəmbərimizin (Allahın salavatı və salamı onun üzərinə olsun) anası nə zaman vəfat etmişdir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5930.mp3',
        'answer' => '<p> Cavab: Onun altı yaşı olarkən anası vəfat etmişdir. Bundan sonra onu babası Abdulmuttalib himayə etmişdir. </p>',
      ],
      7 => [
        'question' => 'Sual 8: Babası Abdul-Muttalib vəfat etdikdəkən sonra ona kim himayədarlıq etmişdir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5960.mp3',
        'answer' => '<p> Cavab: Babası Abdul-Muttalib onun səkkiz yaşında olarkən vəfat etmişdir. Bunda sonra ona əmisi Abu Talib himayədarlıq etmişdir. </p>',
      ],
      8 => [
        'question' => 'Sual 9: Əmisi ilə birgə Şama nə zaman səfər etmişdir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/5990.mp3',
        'answer' => '<p> Cavab: Əmisi ilə birgə Şama on iki yaşında ikən səfər etmişdir. </p>',
      ],
      9 => [
        'question' => 'Sual 10: İkinci səfəri nə zaman olmuşdur?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6020.mp3',
        'answer' => '<p> Cavab: İkinci səfəri isə Xədicənin <span class="c2">(Allah ondan razı olsun)</span> malı ilə ticarə edərkən olmuşdur. Bu səfərindən geri döndükdən sonra Xədicə <span class="c2">(Allah ondan razı olsun)</span> ilə ailə həyatı qurmuşdur. Peyğəmbərimizin <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> o zaman iyirmi beş yaşı var idi. </p>',
      ],
      10 => [
        'question' => 'Sual 11: Qureyş qəbiləsi Kəbəni nə zaman yenidən inşa etmişdir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6050.mp3',
        'answer' => '<p> Cavab: Qureyş qəbiləsi Kəbəni Peyğəmbərimizin <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> otuz beş yaşı olarkən yenidən inşa etmişdir.<br /> Qureyş qəbiləsi Kəbəni yenidən inşa etdikdən sonra öz aralarında hansı qəbilənin "əl-Həcərul-Əsvəd" daşını Kəbədəki yerinə qoyacağı barədə ixtilaf etdilər və nəhayət aralarında Peyğəmbərimizin <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> bu iş barəsində hökm vermələrinə razı oldular. Peyğəmbərimiz də <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> "əl-Həcərul-Əsvəd" daşını bir paltar içərisinə qoyub, hər bir qəbiləyə o paltarın bir tərəfindən qaldırıb, Kəbədəki yerinə yaxınlaşdırmağı əmr etdi. Onlar o zaman dörd qəbilədən idarət idilər. Onlar "əl-Həcərul-Əsvəd" daşını qaldırıb Kəbədəki yerinə yaxınlaşdırdıqları zaman Peyğəmbərimiz <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> öz şərəfli əlləri ilə "əl-Həcərul-Əsvəd" daşını paltardan götürüb Kəbədəki yerinə qoydu. </p>',
      ],
      11 => [
        'question' => 'Sual 12: Neçə yaşında olarkən ona peyğəmbərlik verilmişdir və o kimlərə peyğəmbər göndərilmişdir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6080.mp3',
        'answer' => '<p> Cavab: Ona qırx yaşında peyğəmbərlik verilmişdir və o, bütün insanlara müjdələyən və xəbərdarlıq edən bir peyğəmbər olaraq göndərilmişdir. </p>',
      ],
      12 => [
        'question' => 'Sual 13: İlk vəhy necə nazil olmuşdur?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6110.mp3',
        'answer' => '<p> Cavab: İlk vəhy doğru yuxular görmək vasitəsi ilə nazil olmuşdur. </p>',
      ],
      13 => [
        'question' => 'Sual 14: Ona vəhy nazil edilməzdən öncə halı necə idi və ilk dəfə ona vəhy nə zaman nazil edilmişdir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6140.mp3',
        'answer' => '<p> Cavab: Ona vəhy nazil edilməzdən öncə özü ilə azüqə götürərək Hira mağarasına gedər və orada Allaha ibadət edərdi.<br /> İlk dəfə vəhy, o, Hira mağarasında ibadət edərkən nazil edilmişdir. </p>',
      ],
      14 => [
        'question' => 'Sual 15: Qurandan ən birinci hansı ayələr nazil edilmişdir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6180.mp3',
        'answer' => '<p> Cavab: Uca Allahın bu sözləri: 1. ﴾ٱقۡرَأۡ بِٱسۡمِ رَبِّكَ ٱلَّذِي خَلَقَ<span class="c4">﴿ <span class="c5">[İqra bi-ismi Rabbikəl-ləzi xaləq]</span> "Yaradan Rəbbinin adı ilə oxu!". 2 ﴾</span>خَلَقَ ٱلۡإِنسَـنَ مِنۡ عَلَقٍ<span class="c4">﴿ <span class="c5">[Xaləqa-l-insənə min aləq]</span> "O, insanı qan laxtasından yaratdı". 3 ﴾</span>ٱقۡرَأۡ وَرَبُّكَ ٱلۡأَكۡرَمُ﴿ <span class="c5">[İqra va Rabbukə-l-Əkram]</span> "Oxu! Sənin Rəbbin <span class="c2">(müqayisəsiz)</span> səxavətə malikdir." 4 ﴾ٱلَّذِي عَلَّمَ بِٱلۡقَلَمِ﴿ <span class="c5">[Əlləzi alləmə bil-qaləm]</span> "O, qələmlə <span class="c2">(yazmağı)</span> öy­rət­di". 5 ﴾عَلَّمَ ٱلۡإِنسَـنَ مَا لَمۡ يَعۡلَمۡ﴿ <span class="c5">[Alləmə-l-insənə mə ləm ya\'ləm]</span> "İnsana bilmədiklərini öy­rətdi". <span class="c2">(əl-<span class="c6">Aləq surəsi:</span> ayə: 1-5)</span>. </p>',
      ],
      15 => [
        'question' => 'Sual 16: Onun risaləsinə ilk öncə kim iman gətirmişdir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6200.mp3',
        'answer' => '<p> Cavab: Kişilərdən: Əbu Bəkir əs-Siddiq,<span class="c6"> qadınlardan:</span> Xədicə bint Xuveylid,<span class="c6"> uşadlardan:</span> Əli bin Əbi Talib,<span class="c6"> azad etdiyi kölələrdən:</span> Zeyd bin Hərisə və qullardan isə Bilal əl-Həbəşi <span class="c2">(Allah onlardan və bütün səhabələrdən razı olsun)</span> iman gətirmişdir. </p>',
      ],
      16 => [
        'question' => 'Sual 17: İslama dəvət necə aparılırdı?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6230.mp3',
        'answer' => '<p> Cavab: Peyğəmbərimiz <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> İslama üç il gizli dəvət etmiş, bu müddətdən sonra isə Uca Allah ona, dəvəti açıq-aşkar etməyi əmr etmişdir. </p>',
      ],
      17 => [
        'question' => 'Sual 18: Peyğəmbərimiz (Allahın salavatı və salamı onun üzərinə olsun) və Ona iman gətirənlər İslama açıq-aşkar dəvət etdikdən sonra hansı müsibətlərlə məruz qalmışdılar?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6260.mp3',
        'answer' => '<p> Cavab: Peyğəmbərimiz <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> və Ona iman gətirənlər İslama açıq-aşkar dəvət etdikdən sonra Peyğəmbərimiz <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> və müsəlmanlar müşriklər tərəfindən şiddətli əzab-əziyyətə məruz qaldılar. Müşriklərin müsəlmanlara etdikləri əzab-əziyyətin şiddətini görən Peyğəmbər <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> müsəlmanlara Həbəşistana, Nəcaşinin yanına hicrət etməyə icazə verdi.<br /> Müşriklər Peyğəmbərə <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> o qədər əziyyət verdilər ki, hətta öz aralarında onu öldürmək qərarına gəldilər. Lakin Allah onu müşriklərin şərindən qorudu və Onu əmisi Əbu Talib vasitəsi ilə onların qurduqları hiylədən himayə etdi. </p>',
      ],
      18 => [
        'question' => 'Sual 19: Peyğəmbərliyin onuncu ilində kim vəfat etmişdir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6300.mp3',
        'answer' => '<p> Cavab: Onun əmisi Əbu Talib və zövcəsi Xədicə <span class="c2">(Allah ondan razı olsun)</span> vəfat etmişdirlər. </p>',
      ],
      19 => [
        'question' => 'Sual 20: İsra və Merac nə vaxt olmuşdur?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6330.mp3',
        'answer' => '<p> Cavab: İsra və Merac Peyğəmbərimizin <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> əlli yaşında olmuşdur. O gecə Uca Allah, Peyğəmbərimizə <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> beş vaxt namaz qılmağı fərz etmişdir.<span class="c6"><br /> İsra:</span> Məscidül-Haramdan Məscidül-Aqsaya olmuşdur.<span class="c6"><br /> Merac:</span> Məscidül-Aqsadan səmaya, Sidrətül-Müntəhaya olmuşdur. </p>',
      ],
      20 => [
        'question' => 'Sual 21: Peyğəmbərimiz (Allahın salavatı və salamı onun üzərinə olsun) Məkkə xaricindən olan insanları İslama necə dəvət edərdi?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6380.mp3',
        'answer' => '<p> Cavab: Peyğəmbər <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span>, Mədinə əhlindən olan Ənsarlar gəlib Peyğəmbərimizə <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> iman gətirib Ona, Mədinəyə gələcəyi təqdirdə dəvətinə yardım edəcəkllərinə dair beyət edənə qədər, Taif əhlini və həmçinin Həcc mövsümündə və insanların toplaşdığı yerlərdə insanları İslama dəvət edərdi. </p>',
      ],
      21 => [
        'question' => 'Sual 22: Peyğəmbər (Allahın salavatı və salamı onun üzərinə olsun) Məkkədə necə il İsalama dəvət etdi?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6410.mp3',
        'answer' => '<p> Cavab: On üç il. </p>',
      ],
      22 => [
        'question' => 'Sual 23: Peyğəmbər (Allahın salavatı və salamı onun üzərinə olsun) hara hicrət etmişdir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6440.mp3',
        'answer' => '<p> Cavab: Məkkədən Mədinəyə. </p>',
      ],
      23 => [
        'question' => 'Sual 24: Peyğəmbər (Allahın salavatı və salamı onun üzərinə olsun) Mədinədə necə il qalmışdır?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6470.mp3',
        'answer' => '<p> Cavab: On il. </p>',
      ],
      24 => [
        'question' => 'Sual 25: Mədinədə olduğu müddət ərzində ona İslam şəriətindən hansı hökmlər fərz edildi?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6490.mp3',
        'answer' => '<p> Cavab: Ona İslam şəriətindən: zəkat, oruc, həcc, cihad, azan və s. hökmlər fərz edildi. </p>',
      ],
      25 => [
        'question' => 'Sual 26: Peyğəmbərin (Allahın salavatı və salamı onun üzərinə olsun) ən mühüm döyüşləri hansılardır?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6520.mp3',
        'answer' => '<p> Cavab: Böyük Bədir döyüşü.<br /> Uhud döyüşü.<br /> Əhzab döyüşü.<br /> Məkkənin fəthi döyüşü. </p>',
      ],
      26 => [
        'question' => 'Sual 27: Qurandan ən axırıncı hansı ayə nazil edilmişdir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6580.mp3',
        'answer' => '<p> Cavab: Uca Allahın bu sözləri: ﴾Allahın dərgahına qaytarılacağınız gündən qorxun! Sonra hər kəsə qazandığının əvəzi büsbütün veriləcək və onlara zülm olunmayacaqdır﴿. <span class="c2">(əl-Bəqərə surəsi,<span class="c6"> ayə:</span> 281)</span>. </p>',
      ],
      27 => [
        'question' => 'Sual 28: Peyğəmbərimiz (Allahın salavatı və salamı onun üzərinə olsun) nə vaxt vəfat etmişdir və o zaman necə yaşı var idi?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6610.mp3',
        'answer' => '<p> Cavab: Hicrətin on birinci ilinin, Rabi əl-Əvval ayında, altımış üç yaşında vəfat etmişdir. </p>',
      ],
      28 => [
        'question' => 'Sual 29: Peyğəmbərin (Allahın salavatı və salamı onun üzərinə olsun) zövcələrinin adlarını zikir et.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6640.mp3',
        'answer' => '<p> Cavab: 1- Xədicə bint Xuveylid <span class="c2">(Allah ondan razı olsun)</span>.<br /> 2- Söudə bint Zəm\'ah <span class="c2">(Allah ondan razı olsun)</span>.<br /> 3- Aişə bint Əbu Bəkr əs-Sıddiq <span class="c2">(Allah ondan razı olsun)</span>.<br /> 4- Hafsa bint Ömər <span class="c2">(Allah ondan razı olsun)</span>.<br /> 5- Zeynəb bint Xuzeymə <span class="c2">(Allah ondan razı olsun)</span>.<br /> 6- Ummu Sələmə Hind bint Əbi Umeyyə <span class="c2">(Allah ondan razı olsun)</span>.<br /> 7- Ummu Həbiybə Ramlə bint Əbi Sufyan <span class="c2">(Allah ondan razı olsun)</span>.<br /> 8- Cuveyriyyə bint əl-Həris <span class="c2">(Allah ondan razı olsun)</span>.<br /> 9- Meymunə bint əl-Həris <span class="c2">(Allah ondan razı olsun)</span>.<br /> 10- Safiyyə bint Huyyey <span class="c2">(Allah ondan razı olsun)</span>.<br /> 11- Zeynəb bint Cahş <span class="c2">(Allah ondan razı olsun)</span>. </p>',
      ],
      29 => [
        'question' => 'Sual 30: Peyğəmbərin (Allahın salavatı və salamı onun üzərinə olsun) övladlarının adlarını sadala.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6760.mp3',
        'answer' => '<p> Cavab: Oğlanlardan üç övladı olub<br /> əl-Qasim. Bu ad, Peyğəmbərin <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> künyəsı idi.<br /> Abdullah.<br /> İbrahim.<span class="c6"><br /> Qızlardan isə:</span><br /> Fatimə.<br /> Ruqiyyə.<br /> Ummu Kulsum.<br /> Zeynəb.<br /> İbrahimdən başqa bütün övladları Xədicədən <span class="c2">(Allah ondan razı olsun)</span> dünyaya gəlmişdir. Fatimədən başqa bütün övladları onun sağlığında ikən vəfat etmişdirlər. Fatimə isə Peyğəmbər <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> dünyasını dəyişdikdən altı ay sonra vəfat etmişdir. </p>',
      ],
      30 => [
        'question' => 'Sual 31: Peyğəmbərin (Allahın salavatı və salamı onun üzərinə olsun) bəzi yaradılış vəsflərini qeyd et.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6880.mp3',
        'answer' => '<p> Cavab: Peyğəmbər <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> nə hündür boy, nə də qısa boy idi, əksinə bunların arasında orta boyu olan biri idi. Vücudu qırmızıya çalan açıq bəyaz rəngdə idi. Saqqalı sıx, gözləri iri, iri ağızlı, saçları zil qara, çiyinləri geniş, gözəl qoxulu və s. bu kimi gözəl yaradılış xüsusiyətlərini özündə cəm etmiş bir insan idi. </p>',
      ],
      31 => [
        'question' => 'Sual 31: Peyğəmbər (Allahın salavatı və salamı onun üzərinə olsun) ümmətini nəyin üzərində tərk edib getmişdir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6910.mp3',
        'answer' => '<p> Cavab: Peyğəmbər <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> öz ümmətini, gecəsi gündüzü kimi nurlu bir yol üzərində tərk edib getdi. Onun qoyduğu yol elə bir yoldur ki, bu yoldan yalnız həlak olan kimsələr azar. O ümmətini bütün xeyirlərə yönəldib və bütün şərlərdən çəkindirərək axirətə köçüb. </p>',
      ],
    ],
    4 => [
      0 => [
        'question' => 'Sual 1: əl-Fatihə surəsini oxu və onu təfsir et.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/6960.mp3',
        'answer' => '<p> Cavab: əl-<span class="c6">Fatihə surəsi və onun təfsiri:</span><br /> 1- <span class="c3">«بسم الله الرحمن الرحيم»</span> <span class="c5">[Bismilləhi-r-rahmənir-rahim]</span> "Mərhəmətli və Rəhmli Allahın adı ilə!". 2- <span class="c3">«الْحَمْدُ للّهِ رَبِّ الْعَالَمِينَ»</span> <span class="c5">[Əlhəmdu lilləhi Rabbil-aləmin]</span> ﴾Həmd olsun aləmlərin Rəbbi Allaha﴿. 3- <span class="c3">«الرَّحْمـنِ الرَّحِيمِ»</span> <span class="c5">[ər-Rahmənir-Rahim]</span> ﴾Mərhəmətli və Rəhmliyə﴿. 4- <span class="c3">«مَالِكِ يَوْمِ الدِّينِ»</span> <span class="c5">[Məliki yəumid-din]</span> ﴾Haqq-hesab gününün Hökmdarına!﴿. 5- <span class="c3">«إِيَّاكَ نَعْبُدُ وَإِيَّاكَ نَسْتَعِينُ»</span> <span class="c5">[İyyəkə nə\'budu va iyyəkə nəstəin]</span> ﴾Biz yalnız Sənə ibadət edir və yalnız Səndən kömək diləyirik﴿. 6- <span class="c3">«اهدِنَــــا الصِّرَاطَ المُستَقِيمَ»</span> <span class="c5">[İhdinəs-siratəl-mustəqim]</span> ﴾Bizi doğru yola yönəlt﴿. 7- <span class="c3">«صِرَاطَ الَّذِينَ أَنعَمتَ عَلَيهِمْ غَيرِ المَغضُوبِ عَلَيهِمْ وَلاَ الضَّالِّينَ»</span> <span class="c5">[Siratal-ləzinə ən-amtə aleyhim ğayril-mağdubi aleyhim vala-ddallin]</span> ﴾nemət bəxş etdiyin şəxslərin yoluna, qəzəbə uğramışların və azmışların <span class="c2">(yoluna)</span> deyil!﴿. <span class="c2">(əl-Fatihə surəsi,<span class="c6"> ayə:</span> 1-7)</span>.<span class="c6"><br /> Təfsir:</span><br /> əl-Fatihə surəsi, Qurani Kərimi açan ilk surə olduğu üçün, bu surəyə əl-Fatihə surəsi adı verilmişdir.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001001.mp3"></audio> 1- <span class="c3">«بسم الله الرحمن الرحيم»</span> <span class="c5">[Bismilləhi-r-rahmənir-rahim]</span> "Mərhəmətli və Rəhmli Allahın adı ilə".<span class="c6"> Yəni:</span> Uca Allahın adını çəkərək, Ondan yardım diləyərək, Allahın adını zikr edərək və Ondan xeyir-bərəkət umaraq Qurani Kərimi oxumağa başlayıram.<br /> ﴾الله<span class="c4">﴿ "Allah".<span class="c6"> Yəni:</span> İbadət olunmağa haqlı olan. Bu ad, Pak Olan Allahından başqası bu ad ilə adlandırılmaz.<br /> ﴾</span>الرَّحْمَن<span class="c4">﴿ "ər-Rahmən".<span class="c6"> Yəni:</span> Rəhməti hər bir şeyi əhatə edən, geniş rəhmət və mərhəmət sahibi.<br /> ﴾</span>الرَّحِيم﴿ "ər-Rahim".<span class="c6"> Yəni:</span> Möminlərə qarşı rəhimli və mərhəmətli olan.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001002.mp3"></audio> 2- <span class="c3">«الْحَمْدُ للّهِ رَبِّ الْعَالَمِينَ»</span> <span class="c5">[Əlhəmdu lilləhi Rabbil-aləmin]</span> ﴾Həmd olsun aləmlərin Rəbbi Allaha﴿.<span class="c6"> Yəni:</span> Bütün təriflər, həmd-sənalar və bütün kamillik sifətləri yalnız Uca Allaha məxsusdur.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001003.mp3"></audio> 3- <span class="c3">«الرَّحْمـنِ الرَّحِيمِ»</span> <span class="c5">[ər-Rahmənir-Rahim]</span> ﴾Mərhəmətli və Rəhmliyə﴿.<span class="c6"> Yəni:</span> Rəhməti hər bir şeyi əhatə edən geniş rəhmət və mərhəmət sahibidir. Mömin qullarına isə rəhimli və mərhəmətli olandır.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001004.mp3"></audio> 4- <span class="c3">«مَالِكِ يَوْمِ الدِّينِ»</span> <span class="c5">[Məliki yəvmid-din]</span> ﴾Haqq-hesab gününün Hökmdarına!﴿.<span class="c6"> Yəni:</span> O gün, Qiyamət günüdür.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001005.mp3"></audio> 5- <span class="c3">«إِيَّاكَ نَعْبُدُ وإِيَّاكَ نَسْتَعِينُ»</span> <span class="c5">[İyyəkə nəabudu va iyyəkə nəstəin]</span> ﴾Biz yalnız Sənə ibadət edir və yalnız Səndən kömək diləyirik!﴿.<span class="c6"> Yəni:</span> İbadətin bütün növlərini yalnız tək Sənə edirik, hər bir işimizdə də, tək Səndən yardım diləyirik.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001006.mp3"></audio> 6- <span class="c3">«اهْدِنَا الصِّرَاطَ الْمُسْتَقِيمَ»</span> <span class="c5">[İhdinəs-siratəl-mustəqim]</span> ﴾Bizi doğru yola yönəlt﴿.<span class="c6"> Yəni:</span> Bu yol - İslama və Sünnətə yönəldən yoldur.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001007.mp3"></audio> 7- <span class="c3">«صِرَاطَ الَّذِينَ أَنعَمتَ عَلَيهِمْ غَيرِ المَغضُوبِ عَلَيهِمْ وَلاَ الضَّالِّينَ»</span> <span class="c5">[Siratal-ləzinə ən-amtə aleyhim ğayril-mağdubi aleyhim vala-ddallin]</span> ﴾nemət bəxş etdiyin şəxslərin yoluna, qəzəbə uğramışların və azmışların <span class="c2">(yoluna)</span> deyil!﴿.<span class="c6"> Yəni:</span> Bizi, yəhudi və nəsranilərin yoluna deyil, əksinə, Peyğəmbərlərin və onların ardınca gedən Allahın saleh qullarının yoluna yönəlt.<br /> əl-Fatihə surəsini oxuyub qurtardıqdan sonra <span class="c3">«آمين»</span> <span class="c5">[Amin]</span>.<span class="c6"> Yəni:</span> Allahım, dualarımıza cavab ver! - demək sünnətdir. </p>',
      ],
      1 => [
        'question' => 'Sual 2: əz-Zəlzələ surəsini oxu və onu təfsir et.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/7130.mp3',
        'answer' => '<p> Cavab: əz-<span class="c6">Zəlzələ surəsi və onun təfsiri:</span><br /> <span class="c3">«بسم الله الرحمن الرحيم»</span> <span class="c5">[Bismilləhi-r-rahmənir-rahim]</span> ﴾Mərhəmətli və Rəhmli Allahın adı ilə!﴿.<br /> 1- <span class="c3">«إِذَا زُلْزِلَتِ الْأَرْضُ زِلْزَالَهَا»</span> <span class="c5">[İzə zulzilətil-ardu zilzələhə]</span> ﴾Yer titrəyib lərzəyə gələ­cəyi zaman﴿. 2- <span class="c3">«وَأَخْرَجَتِ الْأَرْضُ أَثْقَالَهَا»</span> <span class="c5">[Va əxracəti-l-ardu əsqaləhə]</span> ﴾Yer öz yükünü bayıra atacağı﴿. 3- <span class="c3">«وَقَالَ الْإِنْسَانُ مَا لَهَا»</span> <span class="c5">[Va qalə-l-insənu mə ləhə]</span> ﴾və insan: <span class="c1">“Ona nə olub?”</span>–deyəcəyi zaman﴿. 4- <span class="c3">«يَوْمَئِذٍ تُحَدِّثُ أَخْبَارَهَا»</span> <span class="c5">[youmə-izin tuhəddisu axbərahə]</span> ﴾həmin gün yer öz əhvalatlarını da­­nışacaqdır﴿. 5- <span class="c3">«بِأَنَّ رَبَّكَ أَوْحَى لَهَا»</span> <span class="c5">[Bi-ənnə Rabbəkə əuhə ləhə]</span> ﴾Çünki Rəbbin ona vəhy edəcəkdir﴿. 6- <span class="c3">«يَوْمَئِذٍ يَصْدُرُ النَّاسُ أَشْتَاتًا لِيُرَوْا أَعْمَالَهُمْ»</span> <span class="c5">[Youmə-izin yasduru-nnəsu əştətən liyurau ə\'mələhum]</span> ﴾O gün insanlar əməllərinin onlara göstərilməsi üçün dəstə-dəstə gələcəklər﴿. 7- <span class="c3">«فَمَنْ يَعْمَلْ مِثْقَالَ ذَرَّةٍ خَيْرًا يَرَهُ»</span> <span class="c5">[Fəmən yə\'məl misqalə zərratin xayran yarah]</span> ﴾Zərrə qədər yaxşılıq edən <span class="c2">(əvəzini)</span> alacaqdır﴿. 8- <span class="c3">«وَمَنْ يَعْمَلْ مِثْقَالَ ذَرَّةٍ شَرًّا يَرَهُ»</span> <span class="c5">[Vamən yə\'məl misqalə zərratin şərran yarah]</span> ﴾Zərrə qədər pislik edən də<span class="c2">(əvəzini)</span> alacaqdır﴿. <span class="c2">(əz-Zəlzələ surəsi,<span class="c6"> ayə:</span> 1-8)</span>.<span class="c6"><br /> Təfsir:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099001.mp3"></audio> 1- <span class="c3">«إِذَا زُلْزِلَتِ الْأَرْضُ زِلْزَالَهَا»</span> <span class="c5">[İzə zulziləti-l-ardu zilzələhə]</span> ﴾Yer titrəyib lərzəyə gələ­cəyi zaman﴿.<span class="c6"> Yəni:</span> Qiyamət günü yer üzünün şiddətli bir halda lərzəyə gələ­cəyi zaman.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099002.mp3"></audio> 2- <span class="c3">«وَأَخْرَجَتِ الْأَرْضُ أَثْقَالَهَا»</span> <span class="c5">[Va əzracəti-l-ardu əzqaləhə]</span> ﴾Yer öz yükünü bayıra atacağı﴿.<span class="c6"> Yəni:</span> Yer bətnindəki ölüləri və onlardan başqa olan hər bir şeyi çıxardıb bayıra atacağı zaman.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099003.mp3"></audio> 3- <span class="c3">«وَقَالَ الْإِنْسَانُ مَا لَهَا»</span> <span class="c5">[Va qaləl-insənu mə ləhə]</span> ﴾və insan: <span class="c1">“Ona nə olub?”</span>–deyəcəyi zaman﴿.<span class="c6"> Yəni:</span> İnsan təəccüblə: "Bu yerə nə olub ki, lərzəyə gəlib, sakit dayanmır?"- deyəcəkdir.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099004.mp3"></audio> 4- <span class="c3">«يَوْمَئِذٍ تُحَدِّثُ أَخْبَارَهَا»</span> <span class="c5">[Yəumə-izin tuhəddisu axbərahə]</span> ﴾həmin gün yer öz əhvalatlarını da­­nışacaqdır﴿.<span class="c6"> Yəni:</span> O əzəmətli gündə, yer öz üzərində baş vermiş bütün xeyir və şər əməllər barədə xəbər verəcəkdir.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099005.mp3"></audio> 5- <span class="c3">«بِأَنَّ رَبَّكَ أَوْحَى لَهَا»</span> <span class="c5">[Bi-ənnə Rabbəkə əvhə ləhə]</span> ﴾Çünki Rəbbin ona vəhy edəcəkdir!﴿.<span class="c6"> Yəni:</span> Çünki Allah bunu ona bildirmiş və əmr etmişdir.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099006.mp3"></audio> 6- <span class="c3">«يَوْمَئِذٍ يَصْدُرُ النَّاسُ أَشْتَاتًا لِيُرَوْا أَعْمَالَهُمْ»</span> <span class="c5">[Yəumə-izin yasduru-nnəsu eştətən liyurav əamələhum]</span> ﴾O gün insanlar əməllərinin onlara göstərilməsi üçün dəstə-dəstə gələcəklər!﴿.<span class="c6"> Yəni:</span> Yer lərzəyə gələcəyi o əzəmətli gün insanlar dünyada etdikləri əməllərinin onlara göstərilməsi üçün dəstə-dəstə haqq-hesaba çəkiləcəkləri yerə gələcəklər.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099007.mp3"></audio> 7- <span class="c3">«فَمَنْ يَعْمَلْ مِثْقَالَ ذَرَّةٍ خَيْرًا يَرَهُ»</span> <span class="c5">[Fəmən yəaməl misqalə zərratin xayran yarah]</span> ﴾Zərrə qədər yaxşılıq edən <span class="c2">(əvəzini)</span> alacaqdır﴿.<span class="c6"> Yəni:</span> Kim bu dünyada ən kiçik qarışqa boyda xeyir və yaxşı iş etmişdirsə, Qiyamət günü onun mükafatını öz qarşısında görəcəkdir.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099008.mp3"></audio> 8- <span class="c3">«وَمَنْ يَعْمَلْ مِثْقَالَ ذَرَّةٍ شَرًّا يَرَهُ»</span> <span class="c5">[Vamən yəaməl misqalə zərratin şərran yarah]</span> ﴾Zərrə qədər pislik edən də<span class="c2">(əvəzini)</span> alacaqdır﴿.<span class="c6"> Yəni:</span> Kim bu dünyada ən kiçik qarışqa boyda şər və pis iş etmişdirsə, Qiyamət günü onun cəzasını öz qarşısında görəcəkdir. </p>',
      ],
      2 => [
        'question' => 'Sual 3: əl-Adiyat surəsini oxu və onu təfsir et.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/7270.mp3',
        'answer' => '<p> Cavab: əl-<span class="c6">Adiyat surəsi və onun təfsiri:</span><br /> <span class="c3">«بسم الله الرحمن الرحيم»</span> <span class="c5">[Bismilləhi-r-rahmənir-rahim]</span> ﴾Mərhəmətli və Rəhmli Allahın adı ilə!﴿.<br /> 1- <span class="c3">«وَالْعَادِيَاتِ ضَبْحًا»</span> <span class="c5">[Val-adiyəti dabhə]</span> ﴾And olsun tövşüyə-tövşüyə çapanlara!﴿. 2- <span class="c3">«فَالْمُورِيَاتِ قَدْحًا»</span> <span class="c5">[Fəl-muriyəti qadhə]</span> ﴾And olsun <span class="c2">(dırnaqları ilə)</span> qığılcım çıxaranlara!﴿. 3- <span class="c3">«فَالْمُغِيرَاتِ صُبْحًا»</span> <span class="c5">[Fəl-muğirati subhə]</span> ﴾And olsun sübh çağı həmlə edənlərə ki,﴿. 4- <span class="c3">«فَأَثَرْنَ بِهِ نَقْعًا»</span> <span class="c5">[Fə-əsərnə bihi nəqaə]</span> ﴾hücuma keçib tozanaq qaldıraraq﴿. 5- <span class="c3">«فَوَسَطْنَ بِهِ جَمْعًا»</span> <span class="c5">[Fə-vasatnə bihi cəmaə]</span> ﴾qoşunun içərisinə soxulurlar﴿. 6- <span class="c3">«إِنَّ الْإِنْسَانَ لِرَبِّهِ لَكَنُودٌ»</span> <span class="c5">[İnnə-l-insənə lirabbihi ləkənud]</span> ﴾Həqiqətən, insan Rəbbinə qarşı yaman nankordur﴿. 7- <span class="c3">«وَإِنَّهُ عَلَى ذَلِكَ لَشَهِيدٌ»</span> <span class="c5">[Va-innəhu alə zəlikə ləşəhid]</span> ﴾Özü də bunun şahididir﴿. 8- <span class="c3">«وَإِنَّهُ لِحُبِّ الْخَيْرِ لَشَدِيدٌ»</span> <span class="c5">[Va-innəhu lihubbi-lxayri ləşədid]</span> ﴾Həqiqətən, o, var-dövlətə çox hərisdir﴿. 9- <span class="c3">«أَفَلَا يَعْلَمُ إِذَا بُعْثِرَ مَا فِي الْقُبُورِ»</span> <span class="c5">[Əfələ yə\'ləmu izə bu\'sira mə fi-lqubur]</span> ﴾Məgər o bilmir ki, qəbirlərdə olanlar çıxardılacağı﴿. 10- <span class="c3">«وَحُصِّلَ مَا فِي الصُّدُورِ»</span> <span class="c5">[Va hussilə mə fi-ssudur]</span> ﴾və kökslərdə olanlar aşkar ediləcəyi zaman﴿. 11- <span class="c3">«إِنَّ رَبَّهُمْ بِهِمْ يَوْمَئِذٍ لَخَبِيرٌ»</span> <span class="c5">[İnnə Rabbəhum bihim youmə-izin ləxabir]</span> ﴾məhz o gün Rəbbi onlardan xəbərdar olacaqdır?﴿. <span class="c2">(əl-Adiyat surəsi,<span class="c6"> ayə:</span> 1-11)</span>.<span class="c6"><br /> Təfsir:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100001.mp3"></audio> 1- <span class="c3">«وَالْعَادِيَاتِ ضَبْحًا»</span> <span class="c5">[Val-adiyəti dabhə]</span> ﴾And olsun tövşüyə-tövşüyə çapanlara!﴿.<span class="c6"> Yəni:</span> Uca Allah, bərk qaçdıqlarına görə nəfəslərinin səsi eşidilən atlara and içir.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100002.mp3"></audio> 2- <span class="c3">«فَالْمُورِيَاتِ قَدْحًا»</span> <span class="c5">[Fəl-muriyəti qadhə]</span> ﴾And olsun <span class="c2">(dırnaqları ilə)</span> qığılcım çıxaranlara!﴿.<span class="c6"> Yəni:</span> Uca Allah, həmçinin, dırnaqlarını şiddətlə daşlara vurub qığılcım çıxaran atlara and içir.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100003.mp3"></audio> 3- <span class="c3">«فَالْمُغِيرَاتِ صُبْحًا»</span> <span class="c5">[Fəl-muğirati subhə]</span> ﴾And olsun sübh çağı həmlə edənlərə ki,﴿.<span class="c6"> Yəni:</span> Uca Allah, sübh vaxtı düşmənlərə həmlə edən atlara and içir.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100004.mp3"></audio> 4- <span class="c3">«فَأَثَرْنَ بِهِ نَقْعًا»</span> <span class="c5">[Fə-əsərnə bihi nəqaə]</span> ﴾hücuma keçib tozanaq qaldıraraq﴿.<span class="c6"> Yəni:</span> Qaçışları ilə tozanaq qaldıran atlara.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100005.mp3"></audio> 5- <span class="c3">«فَوَسَطْنَ بِهِ جَمْعًا»</span> <span class="c5">[Fə-vasatnə bihi cəma]</span> ﴾qoşunun içərisinə soxulurlar﴿.<span class="c6"> Yəni:</span> Süvarilərlə birğə düşmən dəstəsinin içərisinə soxulan atlara.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100006.mp3"></audio> 6- <span class="c3">«إِنَّ الْإِنْسَانَ لِرَبِّهِ لَكَنُودٌ»</span> <span class="c5">[İnnə-l-insənə lirabbihi ləkənud]</span> ﴾Həqiqətən, insan Rəbbinə qarşı yaman nankordur﴿.<span class="c6"> Yəni:</span> İnsan, Rəbbi ondan istədiyi xeyrə qarşı çox nankordur.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100007.mp3"></audio> 7- <span class="c3">«وَإِنَّهُ عَلَى ذَلِكَ لَشَهِيدٌ»</span> <span class="c5">[Va-innəhu alə zəlikə ləşəhid]</span> ﴾Özü də bunun şahididir﴿.<span class="c6"> Yəni:</span> O, özünün xeyirə xəsis olmasına şahiddir. Bunun açıq-aydın bir şey olduğuna görə, bunu heç özüdə inkar edə bilməz.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100008.mp3"></audio> 8- <span class="c3">«وَإِنَّهُ لِحُبِّ الْخَيْرِ لَشَدِيدٌ»</span> <span class="c5">[Va-innəhu lihubbi-lxayri ləşədid]</span> ﴾Həqiqətən, o, var-dövlətə çox hərisdir﴿.<span class="c6"> Yəni:</span> İnsan mal-dövlətə həddən artıq həris olduğu üçün, onu xərcləməyə xəsislik edir.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100009.mp3"></audio> 9- <span class="c3">«أَفَلَا يَعْلَمُ إِذَا بُعْثِرَ مَا فِي الْقُبُورِ»</span> <span class="c5">[Əfələ yəaləmu izə busira mə fi-lqubur]</span> ﴾Məgər o bilmir ki, qəbirlərdə olanlar çıxardılacağı﴿.<span class="c6"> Yəni:</span> Məgər dünya həyatına aldanmış o insan bilmir ki, Allah qəbirlərdəki ölüləri dirildəcəyi və onları haqq-hesaba çəkmək və etdikləri əməllərin əvəzini vermək üçün qəbirlərindən çıxaracağı zaman, iş heç də onun düşündüyü kimi olmayacaqdır?!<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100010.mp3"></audio> 10- <span class="c3">«وَحُصِّلَ مَا فِي الصُّدُورِ»</span> <span class="c5">[Va hussilə mə fi-ssudur]</span> ﴾və kökslərdə olanlar aşkar ediləcəyi zaman﴿.<span class="c6"> Yəni:</span> Qəlblərdə olan niyyətlərin, etiqadların və s. bu kimi başqa şeylərin üzə çıxarılıb, bəyan ediləcəyi zaman.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100011.mp3"></audio> 11- <span class="c3">«إِنَّ رَبَّهُمْ بِهِمْ يَوْمَئِذٍ لَخَبِيرٌ»</span> <span class="c5">[İnnə Rabbəhum bihim yəumə-izin ləxabir]</span> ﴾məhz o gün Rəbbi onlardan xəbərdar olacaqdır?﴿.<span class="c6"> Yəni:</span> Həmin gün Rəbbi onlara dünyada ikən etdikləri bütün əməllər barədə xəbər verəcək. Qullarının əməllərindən heç bir şey Ona gizli qalmaz. O, hər bir kəsin etdiyi əməlin əvəzini verəcəkdir. </p>',
      ],
      3 => [
        'question' => 'Sual 4: əl-Qariə surəsini oxu və onu təfsir et.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/7450.mp3',
        'answer' => '<p> Cavab: əl-<span class="c6">Qariə surəsi və onun təfsiri:</span><br /> <span class="c3">«بسم الله الرحمن الرحيم»</span> <span class="c5">[Bismilləhi-r-rahmənir-rahim]</span> ﴾Mərhəmətli və Rəhmli Allahın adı ilə!﴿.<br /> 1- <span class="c3">«الْقَارِعَةُ»</span> <span class="c5">[əl-Qariəh]</span> ﴾<span class="c2">(Qəlbləri)</span> Qorxuya salan!﴿. 2- <span class="c3">«مَا الْقَارِعَةُ»</span> <span class="c5">[Mə-lqariəh]</span> ﴾<span class="c2">(Qəlbləri)</span> Qorxuya salan nədir?﴿. 3- <span class="c3">«وَمَا أَدْرَاكَ مَا الْقَارِعَةُ»</span> <span class="c5">[Vamə ədrakə mə-lqariəh]</span> ﴾Sən haradan biləsən ki, <span class="c2">(qəlbləri)</span> Qorxuya salan nədir?﴿. 4- <span class="c3">«يَوْمَ يَكُونُ النَّاسُ كَالْفَرَاشِ الْمَبْثُوثِ»</span> <span class="c5">[Youmə yəkunu-nnəsu kəlfəraşi-lməbsus]</span> ﴾O gün insanlar <span class="c2">(ətrafa )</span>səpələnmiş pərvanələr tək olacaqlar﴿. 5- <span class="c3">«وَتَكُونُ الْجِبَالُ كَالْعِهْنِ الْمَنْفُوشِ»</span> <span class="c5">[Va təkunu-lcibəlu kəlihni-lmənfuş]</span> ﴾Dağlar isə didilmiş yun görkəmi alacaqdır﴿. 6- <span class="c3">«فَأَمَّا مَنْ ثَقُلَتْ مَوَازِينُهُ»</span> <span class="c5">[Fə-əmmə mən səqulət məvazinuh]</span> ﴾<span class="c2">(O gün)</span> kimin tərəziləri ağır gələrsə﴿. 7- <span class="c3">«فَهُوَ فِي عِيشَةٍ رَاضِيَةٍ»</span> <span class="c5">[Fəhuva fi iyşətin radiyəh]</span> ﴾xoşbəxt güzəran sürəcək﴿. 8- <span class="c3">«وَأَمَّا مَنْ خَفَّتْ مَوَازِينُهُ»</span> <span class="c5">[Və əmmə mən xaffət məvazinuh]</span> ﴾Kimin tərəziləri yüngül gələrsə,﴿. 9- <span class="c3">«فَأُمُّهُ هَاوِيَةٌ»</span> <span class="c5">[Fə-ummuhu haviyəh]</span> ﴾anası <span class="c2">(sığınacağı yer)</span> Haviyə olacaqdır﴿. 10- <span class="c3">«وَمَا أَدْرَاكَ مَا هِيَهْ»</span> <span class="c5">[Və mə ədrakə mə hiyəh]</span> ﴾Sən haradan biləsən ki, o nədir?﴿. 11- <span class="c3">«نَارٌ حَامِيَةٌ»</span> <span class="c5">[Nərun həmiyəh]</span> ﴾O, çox qızmar bir oddur!﴿. <span class="c2">(əl-Qariə surəsi,<span class="c6"> ayə:</span> 1-11)</span>.<span class="c6"><br /> Təfsir:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101001.mp3"></audio> 1- <span class="c3">«الْقَارِعَةُ»</span> <span class="c5">[əl-Qariəh]</span> ﴾<span class="c2">(Qəlbləri)</span> Qorxuya salan!﴿.<span class="c6"> Yəni:</span> Öz dəhşətli vahiməsi ilə insanların qəlbini qorxuya salan qiyamət saatı.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101002.mp3"></audio> 2- <span class="c3">«مَا الْقَارِعَةُ»</span> <span class="c5">[Mə-lqariəh]</span> ﴾<span class="c2">(Qəlbləri)</span> Qorxuya salan nədir?﴿.<span class="c6"> Yəni:</span> Öz dəhşətli vahiməsi ilə insanların qəlbini qorxuya salan bu qiyamət saatı nədir?!<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101003.mp3"></audio> 3- <span class="c3">«وَمَا أَدْرَاكَ مَا الْقَارِعَةُ»</span> <span class="c5">[Vamə ədrakə mə-lqariəh]</span> ﴾Sən haradan biləsən ki, <span class="c2">(qəlbləri)</span> Qorxuya salan nədir?﴿.<span class="c6"> Yəni:</span> Ey Peyğəmbər! Dəhşətli vahiməsi ilə insanların qəlbini qorxuya salan o saatın nə olduğunu sən nə bilirsən?! Şübhəsiz ki, o, Qiyamət günüdür.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101004.mp3"></audio> 4- <span class="c3">«يَوْمَ يَكُونُ النَّاسُ كَالْفَرَاشِ الْمَبْثُوثِ»</span> <span class="c5">[Youmə yəkunu-nnəsu kəlfəraşi-lməbsus]</span> ﴾O gün insanlar <span class="c2">(ətrafa )</span>səpələnmiş pərvanələr tək olacaqlar﴿.<span class="c6"> Yəni:</span> O gün insanların qəlbinə dəhşətli qorxu düşəcək və insanlar bu dəhşətin və vahimənin qorxusundan sanki hər tərəfə səpələnəcək kəpənək kimi olacaqlar.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101005.mp3"></audio> 5- <span class="c3">«وَتَكُونُ الْجِبَالُ كَالْعِهْنِ الْمَنْفُوشِ»</span> <span class="c5">[Va təkunul-cibəlu kəlihnil-mənfuş]</span> ﴾Dağlar isə didilmiş yun görkəmi alacaqdır﴿.<span class="c6"> Yəni:</span> Dağlar sürətli hərəkət etməsi ilə sanki əyrilmiş yun kimi olacaqdır!<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101006.mp3"></audio> 6- <span class="c3">«فَأَمَّا مَنْ ثَقُلَتْ مَوَازِينُهُ»</span> <span class="c5">[Fə-əmmə mən səqulət məvazinuh]</span> ﴾<span class="c2">(O gün)</span> kimin tərəziləri ağır gələrsə﴿.<span class="c6"> Yəni:</span> O gün yaxşı əmələri pis əməllərdən ağır gələn olan kimsə.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101007.mp3"></audio> 7- <span class="c3">«فَهُوَ فِي عِيشَةٍ رَاضِيَةٍ»</span> <span class="c5">[Fəhuva fi işətin radiyəh]</span> ﴾xoşbəxt güzəran sürəcək﴿.<span class="c6"> Yəni:</span> Cənnətdə razı qalacağı xoş güzəran içində olacaqdır.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101008.mp3"></audio> 8- <span class="c3">«وَأَمَّا مَنْ خَفَّتْ مَوَازِينُهُ»</span> <span class="c5">[Və əmmə mən xaffət məvazinuh]</span> ﴾Kimin tərəziləri yüngül gələrsə,﴿.<span class="c6"> Yəni:</span> O gün pis əmələri yaxşı əməllərdən ağır gələn kimsə isə.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101009.mp3"></audio> 9- <span class="c3">«فَأُمُّهُ هَاوِيَةٌ»</span> <span class="c5">[Fə-ummuhu haviyəh]</span> ﴾anası <span class="c2">(sığınacağı yer)</span> Haviyə olacaqdır﴿.<span class="c6"> Yəni:</span> Qiyamət günü qərar tutacağı yer - Cəhənnəm olacaqdır.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101010.mp3"></audio> 10- <span class="c3">«وَمَا أَدْرَاكَ مَا هِيَهْ»</span> <span class="c5">[Və mə ədrakə mə hiyəh]</span> ﴾Sən haradan biləsən ki, o nədir?﴿.<span class="c6"> Yəni:</span> Ey Peyğəmbər! Sən nə bilirsən ki, nədir o?<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101011.mp3"></audio> 11- <span class="c3">«نَارٌ حَامِيَةٌ»</span> <span class="c5">[Nərun həmiyəh]</span> ﴾O, çox qızmar bir oddur!﴿.<span class="c6"> Yəni:</span> O, hərarəti olduqca şiddətli olan atəşdir. </p>',
      ],
      4 => [
        'question' => 'Sual 5: ət-Təkasur surəsini oxu və onu təfsir et.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/7610.mp3',
        'answer' => '<p> Cavab: ət-<span class="c6">Təkasur surəsi və onun təfsiri:</span><br /> <span class="c3">«بسم الله الرحمن الرحيم»</span> <span class="c5">[Bismilləhi-r-rahmənir-rahim]</span> ﴾Mərhəmətli və Rəhmli Allahın adı ilə!﴿.<br /> 1- <span class="c3">«أَلْهَاكُمُ التَّكَاثُرُ»</span> <span class="c5">[Əl-həkumu-ttəkəsur]</span> ﴾Çoxluğa hərisliyiniz başınızı o qədər qatdı ki,﴿. 2- <span class="c3">«حَتَّى زُرْتُمُ الْمَقَابِرَ»</span> <span class="c5">[Həttə zurtumu-lməkabir]</span> ﴾<span class="c2">(gömülməklə)</span> qəbirləri ziyarət etdiniz﴿. 3- <span class="c3">«كَلَّا سَوْفَ تَعْلَمُونَ»</span> <span class="c5">[Kəllə soufə tə\'ləmun]</span> ﴾Yox-yox! Siz <span class="c2">(aqibətinizi)</span> hökmən biləcəksiniz!﴿. 4- <span class="c3">«ثُمَّ كَلَّا سَوْفَ تَعْلَمُونَ»</span> <span class="c5">[Summə kəllə soufə tə\'ləmun]</span> ﴾Bir də yox! Siz <span class="c2">(aqibətinizi)</span> tezliklə biləcəksiniz!﴿. 5- <span class="c3">«كَلَّا لَوْ تَعْلَمُونَ عِلْمَ الْيَقِينِ»</span> <span class="c5">[Kəllə lou tə\'ləmunə ilmə-lyəqin]</span> ﴾Xeyr! Kaş ki, yəqin biləydiniz﴿. 6- <span class="c3">«لَتَرَوُنَّ الْجَحِيمَ»</span> <span class="c5">[Lətəravunnə-lcəhim]</span> ﴾Siz Cəhənnəmi mütləq görəcəksiniz!﴿. 7- <span class="c3">«ثُمَّ لَتَرَوُنَّهَا عَيْنَ الْيَقِينِ»</span> <span class="c5">[Summə lətəravunnəhə aynə-lyəqin]</span> ﴾Onu həqiqətən öz gözünüzlə mütləq görəcəksiniz!﴿. 8- <span class="c3">«ثُمَّ لَتُسْأَلُنَّ يَوْمَئِذٍ عَنِ النَّعِيمِ»</span> <span class="c5">[Summə lətus-əlunnə youmə-izin ani-nnəaim]</span> ﴾Sonra, o gün nemətlər barəsində hökmən sorğu-suala tutulacaqsınız﴿. <span class="c2">(ət-Təkasur surəsi,<span class="c6"> ayə:</span> 1-8)</span>.<span class="c6"><br /> Təfsir:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102001.mp3"></audio> 1- <span class="c3">«أَلْهَاكُمُ التَّكَاثُرُ»</span> <span class="c5">[Əl-həkumu-ttəkəsur]</span> ﴾Çoxluğa hərisliyiniz başınızı o qədər qatdı ki,<span class="c6">﴿ Yəni:</span> Ey insanlar! Mal-dövlət və övladlarla fəxr etmək sizi Allaha itaət etməkdən yayındırdı.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102002.mp3"></audio> 2- <span class="c3">«حَتَّى زُرْتُمُ الْمَقَابِرَ»</span> <span class="c5">[Həttə zurtumu-lməkabir]</span> ﴾<span class="c2">(gömülməklə)</span> qəbirləri ziyarət etdiniz﴿.<span class="c6"> Yəni:</span> Hətta ölüb qəbirlərinizə girənədək, bu hal üzərində davam etdiniz.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102003.mp3"></audio> 3- <span class="c3">«كَلَّا سَوْفَ تَعْلَمُونَ»</span> <span class="c5">[Kəllə səufə tə\'ləmun]</span> ﴾Yox-yox! Siz <span class="c2">(aqibətinizi)</span> hökmən biləcəksiniz!﴿.<span class="c6"> Yəni:</span> Siz dünya malı ilə fəxr edib Allahın itaətindən yayınmamalıydınız. Siz bu bihudə məşğuliyyətin pis aqibətini mütləq biləcəksiniz.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102004.mp3"></audio> 4- <span class="c3">«ثُمَّ كَلَّا سَوْفَ تَعْلَمُونَ»</span> <span class="c5">[Summə kəllə soufə tə\'ləmun]</span> ﴾Bir də yox! Siz <span class="c2">(aqibətinizi)</span> tezliklə biləcəksiniz!﴿.<span class="c6"> Yəni:</span> Siz bunun aqibətini mütləq biləcəksiniz.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102005.mp3"></audio> 5- <span class="c3">«كَلَّا لَوْ تَعْلَمُونَ عِلْمَ الْيَقِينِ»</span> <span class="c5">[Kəllə ləu tə\'ləmunə ilməl-yəqin]</span> ﴾Xeyr! Kaş ki, yəqin biləydiniz﴿.<span class="c6"> Yəni:</span> Doğrusu, əgər siz dirilib Allahın hüzuruna qayıdacağınızı və Onun sizə əməllərinizin əvəzini verəcəyini yəqin bilsəydiniz, mal-dövlət və oğul-uşaqla fəxr etməklə məşğul olmazdınız.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102006.mp3"></audio> 6- <span class="c3">«لَتَرَوُنَّ الْجَحِيمَ»</span> <span class="c5">[Lətəravunnəl-cəhim]</span> ﴾Siz Cəhənnəmi mütləq görəcəksiniz!﴿.<span class="c6"> Yəni:</span> Allaha and olsun ki, Qiyamət günü Cəhənnəmi görəcəksiniz.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102007.mp3"></audio> 7- <span class="c3">«ثُمَّ لَتَرَوُنَّهَا عَيْنَ الْيَقِينِ»</span> <span class="c5">[Summə lətəravunnəhə aynəl-yəqin]</span> ﴾Onu həqiqətən öz gözünüzlə mütləq görəcəksiniz!﴿.<span class="c6"> Yəni:</span> Qiyamət günü Cəhənnəmi yəqinliklə və buna heç bir şübhə olmadan görəcəksiniz.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102008.mp3"></audio> 8- <span class="c3">«ثُمَّ لَتُسْأَلُنَّ يَوْمَئِذٍ عَنِ النَّعِيمِ»</span> <span class="c5">[Summə lətus-əlunnə youmə-izin ani-nnəaim]</span> ﴾Sonra, o gün nemətlər barəsində hökmən sorğu-suala tutulacaqsınız﴿.<span class="c6"> Yəni:</span> Sonra, o gün Allah, sizə bəxş etdiyi sağlamlıq, var-dövlət və başqa bu kimi nemətlər barədə sizdən soruşacaqdır. </p>',
      ],
      5 => [
        'question' => 'Sual 6: əl-Asr surəsini oxu və onu təfsir et.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/7750.mp3',
        'answer' => '<p> Cavab: əl-<span class="c6">Asr surəsi və onun təfsiri:</span><br /> <span class="c3">«بسم الله الرحمن الرحيم»</span> <span class="c5">[Bismilləhi-r-rahmənir-rahim]</span> ﴾Mərhəmətli və Rəhmli Allahın adı ilə!﴿.<br /> 1- <span class="c3">«وَالْعَصْرِ»</span> <span class="c5">[Vəl-asr]</span> ﴾And olsun axşam çağına!﴿. 2- <span class="c3">«إِنَّ الْإِنْسَانَ لَفِي خُسْرٍ»</span> <span class="c5">[İnnə-l-insənə ləfi xusr]</span> ﴾Həqiqətən, insan ziyan içərisindədir﴿. 3- <span class="c3">«إِلَّا الَّذِينَ آمَنُوا وَعَمِلُوا الصَّالِحَاتِ وَتَوَاصَوْا بِالْحَقِّ وَتَوَاصَوْا بِالصَّبْرِ»</span> <span class="c5">[İllə-lləzinə əmənu va amilu-ssalihəti va təvasau bilhaqqi va təvasau bi-ssabr]</span> ﴾Yalnız iman gətirib yaxşı işlər görənlər, bir-birinə haqqı məsləhət görənlər­­ və bir-birinə səbrli olmağı məsləhət edənlərdən başqa!﴿. <span class="c2">(əl-Asr surəsi,<span class="c6"> ayə:</span> 1-3)</span>.<span class="c6"><br /> Təfsir:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/103001.mp3"></audio> 1- <span class="c3">«وَالْعَصْرِ»</span> <span class="c5">[Val-asr]</span> ﴾And olsun axşam çağına!﴿.<span class="c6"> Yəni:</span> Uca Allah zamana and içir.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/103002.mp3"></audio> 2- <span class="c3">«إِنَّ الْإِنْسَانَ لَفِي خُسْرٍ»</span> <span class="c5">[İnnə-l-insənə lefi xusr]</span> ﴾Həqiqətən, insan ziyan içərisindədir﴿.<span class="c6"> Yəni:</span> Bütün insanlar xüsran və həlak içindədir.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/103003.mp3"></audio> 3- <span class="c3">«إِلَّا الَّذِينَ آمَنُوا وَعَمِلُوا الصَّالِحَاتِ وَتَوَاصَوْا بِالْحَقِّ وَتَوَاصَوْا بِالصَّبْرِ»</span> <span class="c5">[İllə-lləzine əmənu va amilu-ssalihəti va təvasau bilhaqqi va təvasau bi-ssabr]</span> ﴾Yalnız iman gətirib yaxşı işlər görənlər, bir-birinə haqqı məsləhət görənlər­­ və bir-birinə səbrli olmağı məsləhət edənlərdən başqa!﴿.<span class="c6"> Yəni:</span> Yalnız iman gətirib saleh əməl edən, bununla yanaşı, digərlərini haqqa və səbrə dəvət edən kimsələrdən başqa. Məhz belə kimsələr xüsrandan və həlakdan nicat tapan kimsələrdir. </p>',
      ],
      6 => [
        'question' => 'Sual 7: əl-Huməzə surəsini oxu və onu təfsir et.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/7830.mp3',
        'answer' => '<p> Cavab: əl-<span class="c6">Huməzə surəsi və onun təfsiri:</span><br /> <span class="c3">«بسم الله الرحمن الرحيم»</span> <span class="c5">[Bismilləhi-r-rahmənir-rahim]</span> ﴾Mərhəmətli və Rəhmli Allahın adı ilə!﴿.<br /> 1- <span class="c3">«وَيْلٌ لِكُلِّ هُمَزَةٍ لُمَزَةٍ»</span> <span class="c5">[Vaylul-likulli huməzətin luməzəh]</span> ﴾Hər bir qeybət edənin, tə­nə vura­nın vay halına!﴿. 2- <span class="c3">«الَّذِي جَمَعَ مَالًا وَعَدَّدَهُ»</span> <span class="c5">[Əlləzi cəməa məələn va addədəh]</span> ﴾O şəxs ki, mal-dövlət toplayıb onu <span class="c2">(təkrar-təkrar)</span> sayır﴿. 3- <span class="c3">«يَحْسَبُ أَنَّ مَالَهُ أَخْلَدَهُ»</span> <span class="c5">[Yəhsəbu ənnə mələhu axlədəh]</span> ﴾və elə güman edir ki, var-dövləti onu əbədi yaşadacaqdır﴿. 4- <span class="c3">«كَلَّا لَيُنْبَذَنَّ فِي الْحُطَمَةِ»</span> <span class="c5">[Kəllə ləyunbəzənnəh fi-lhutaməh]</span> ﴾Xeyr! O, mütləq Hütəməyə atılacaqdır﴿. 5- <span class="c3">«وَمَا أَدْرَاكَ مَا الْحُطَمَةُ»</span> <span class="c5">[Vamə ədrakə mə-lhutaməh]</span> ﴾Sən haradan biləsən ki, Hütəmə nədir?﴿. 6- <span class="c3">«نَارُ اللَّهِ الْمُوقَدَةُ»</span> <span class="c5">[Nəru Allahi-lmuqadəh]</span> ﴾<span class="c2">(Bu,)</span> Allahın qaladığı Oddur﴿. 7- <span class="c3">«الَّتِي تَطَّلِعُ عَلَى الْأَفْئِدَةِ»</span> <span class="c5">[Əlləti tattaliu alə-l-əf-ideh]</span> ﴾<span class="c2">(O Od)</span> ki, <span class="c2">(qalxıb)</span> ürəklərə çatacaq﴿. 8- <span class="c3">«إِنَّهَا عَلَيْهِمْ مُؤْصَدَةٌ»</span> <span class="c5">[İnnəhə aleyhim musadəh]</span> ﴾Həqiqətən, o <span class="c2">(Od)</span> onların üzərində qapanacaqdır﴿. 9- <span class="c3">«فِي عَمَدٍ مُمَدَّدَةٍ»</span> <span class="c5">[Fi amədin muməddədəh]</span> ﴾<span class="c2">(Özləri də orada)</span> yüksək dirəklərə <span class="c2">(bağlanmış olacaqlar)</span>﴿. <span class="c2">(əl-Huməzə surəsi,<span class="c6"> ayə:</span> 1-9)</span>.<span class="c6"><br /> Təfsir:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104001.mp3"></audio> 1- <span class="c3">«وَيْلٌ لِكُلِّ هُمَزَةٍ لُمَزَةٍ»</span> <span class="c5">[Vaylul-likulli huməzətin luməzəh]</span> ﴾Hər bir qeybət edənin, tə­nə vura­nın vay halına!﴿.<span class="c6"> Yəni:</span> İnsanların qeybətini edənlərin və onlara tənə vuranların halına vay və şiddətli əzab olsun.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104002.mp3"></audio> 2- <span class="c3">«الَّذِي جَمَعَ مَالًا وَعَدَّدَهُ»</span> <span class="c5">[Əlləzi cəməa məələn va addədəh]</span> ﴾O şəxs ki, mal-dövlət toplayıb onu <span class="c2">(təkrar-təkrar)</span> sayır﴿.<span class="c6"> Yəni:</span> Onun dərdi-səri yalnız var-dövlət yığıb və onu dönə-dönə saymaqdır. Bundan başqa onun heç bir dərdi-səri yoxdur.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104003.mp3"></audio> 3- <span class="c3">«يَحْسَبُ أَنَّ مَالَهُ أَخْلَدَهُ»</span> <span class="c5">[Yəhsəbu ənnə mələhu axlədəh]</span> ﴾və elə güman edir ki, var-dövləti onu əbədi yaşadacaqdır﴿.<span class="c6"> Yəni:</span> O elə güman edir ki, yığdığı var-dövləti onu ölümdən xilas edəcək və o dünya həyatında əbədi yaşayacaqdır.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104004.mp3"></audio> 4- <span class="c3">«كَلَّا لَيُنْبَذَنَّ فِي الْحُطَمَةِ»</span> <span class="c5">[Kəllə ləyunbəzənnəh fi-lhutaməh]</span> ﴾Xeyr! O, mütləq Hütəməyə atılacaqdır﴿.<span class="c6"> Yəni:</span> Bu iş heç də o cahilin təsəvvür etdiyi kimi deyil. Əlbəttə o, əzabın şiddətindən dolayı içərisinə atılan hər şeyi parçalayıb məhv edən Cəhənnəm oduna atılacaqdır.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104005.mp3"></audio> 5- <span class="c3">«وَمَا أَدْرَاكَ مَا الْحُطَمَةُ»</span> <span class="c5">[Vamə ədrakə mə-lhutaməh]</span> ﴾Sən haradan biləsən ki, Hütəmə nədir?﴿.<span class="c6"> Yəni:</span> Ey Peyğəmbər! İçərisinə atılan hər şeyi parçalayıb məhv edən Cəhənnəm odunun nə olduğunu sən nə bilirsən?!<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104006.mp3"></audio> 6- <span class="c3">«نَارُ اللَّهِ الْمُوقَدَةُ»</span> <span class="c5">[Nəru Allahi-lmuqadəh]</span> ﴾<span class="c2">(Bu,)</span> Allahın qaladığı Oddur﴿.<span class="c6"> Yəni:</span> O, Allahın, hərarəti şiddətli olan yanar odudur.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104007.mp3"></audio> 7- <span class="c3">«الَّتِي تَطَّلِعُ عَلَى الْأَفْئِدَةِ»</span> <span class="c5">[Əlləti tattaliu aləl-əfidəh]</span> ﴾<span class="c2">(O Od)</span> ki, <span class="c2">(qalxıb)</span> ürəklərə çatacaq﴿.<span class="c6"> Yəni:</span> O Od ki, hərarəti insanların cisimlərini yandırıb, sonra onların ürəklərə çatacaqdır.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104008.mp3"></audio> 8- <span class="c3">«إِنَّهَا عَلَيْهِمْ مُؤْصَدَةٌ»</span> <span class="c5">[İnnəhə aleyhim musadəh]</span> ﴾Həqiqətən, o <span class="c2">(Od)</span> onların üzərində qapanacaqdır﴿.<span class="c6"> Yəni:</span> Cəhənnəmin qapıları içərisində əzab olunanların üzünə bağlı olacaqdır.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104009.mp3"></audio> 9- <span class="c3">«فِي عَمَدٍ مُمَدَّدَةٍ»</span> <span class="c5">[Fi amədin muməddədəh]</span> ﴾<span class="c2">(Özləri də orada)</span> yüksək dirəklərə <span class="c2">(bağlanmış olacaqlar)</span>﴿.<span class="c6"> Yəni:</span> Onlar Cəhənnəmdən çıxa bilməsinlər deyə, hündür dirəklərə bağlanmış halda olacaqlar. </p>',
      ],
      7 => [
        'question' => 'Sual 8: əl-Fil surəsini oxu və onu təfsir et.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/7970.mp3',
        'answer' => '<p> Cavab: əl-<span class="c6">Fil surəsi və onun təfsiri:</span><br /> <span class="c3">«بسم الله الرحمن الرحيم»</span> <span class="c5">[Bismilləhi-r-rahmənir-rahim]</span> ﴾Mərhəmətli və Rəhmli Allahın adı ilə!﴿.<br /> 1- <span class="c3">«أَلَمْ تَرَ كَيْفَ فَعَلَ رَبُّكَ بِأَصْحَابِ الْفِيلِ»</span> <span class="c5">[Ələm təra keyfə fəalə Rabbukə bi-ashəbi-lfil]</span> ﴾Rəbbinin fil sahiblərinə nələr etdi­yini görmədinmi?﴿. 2- <span class="c3">«أَلَمْ يَجْعَلْ كَيْدَهُمْ فِي تَضْلِيلٍ»</span> <span class="c5">[Ələm yəcəal keydəhum fi tadlil]</span> ﴾Məgər <span class="c2">(Rəbbin)</span> onların hiyləsini dolaşığa salmadımı?﴿. 3- <span class="c3">«وَأَرْسَلَ عَلَيْهِمْ طَيْرًا أَبَابِيلَ»</span> <span class="c5">[Va ərsələ aleyhim tayran əbəbil]</span> ﴾Onların üzərinə qatar-qatar quşlar göndərdi﴿. 4- <span class="c3">«تَرْمِيهِمْ بِحِجَارَةٍ مِنْ سِجِّيلٍ»</span> <span class="c5">[Tərmihim bihicəratin min siccil]</span> ﴾<span class="c2">(O quşlar ki,)</span> onların üstünə <span class="c2">(odda bişmiş)</span> bərk gildən daşlar yağdırdı﴿. 5- <span class="c3">«فَجَعَلَهُمْ كَعَصْفٍ مَأْكُولٍ»</span> <span class="c5">[Fəcəaləhum kəasfin mə\'kul]</span> ﴾<span class="c2">(Allah)</span> onları sanki yeyilmiş əkin yarpağına döndərdi﴿. <span class="c2">(əl-Fil surəsi,<span class="c6"> ayə:</span> 1-5)</span>.<span class="c6"><br /> Təfsir:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105001.mp3"></audio> 1- <span class="c3">«أَلَمْ تَرَ كَيْفَ فَعَلَ رَبُّكَ بِأَصْحَابِ الْفِيلِ»</span> <span class="c5">[Ələm təra keyfə fəalə Rabbukə bi-ashəbi-lfil]</span> ﴾Rəbbinin fil sahiblərinə nələr etdi­yini görmədinmi?﴿.<span class="c6"> Yəni:</span> Ey Peyğəmbər! Məğər Rəbbinin Əbrəhəyə və onun qoşunu olan fil sahiblərinə, Kəbəni dağıtmaq üçün gəldikləri zaman nələr etdiyini görmədinmi?!<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105002.mp3"></audio> 2- <span class="c3">«أَلَمْ يَجْعَلْ كَيْدَهُمْ فِي تَضْلِيلٍ»</span> <span class="c5">[Ələm yəcəal keydəhum fi tadli]</span> ﴾Məgər <span class="c2">(Rəbbin)</span> onların hiyləsini dolaşığa salmadımı?﴿.<span class="c6"> Yəni:</span> Allah onların pis tədbirini puça çıxartdı və beləliklə də, onlar nə insanları Kəbədən uzaqlaşdırmaq istəklərinə, nə də ona aid başqa bir şeyə nail oldular.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105003.mp3"></audio> 3- <span class="c3">«وَأَرْسَلَ عَلَيْهِمْ طَيْرًا أَبَابِيلَ»</span> <span class="c5">[Va ərsələ aleyhim tayran əbəbil]</span> ﴾Onların üzərinə qatar-qatar quşlar göndərdi﴿.<span class="c6"> Yəni:</span> Onların üstünə dəstə-dəstə quşlar göndərdi.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105004.mp3"></audio> 4- <span class="c3">«تَرْمِيهِمْ بِحِجَارَةٍ مِنْ سِجِّيلٍ»</span> <span class="c5">[Tərmihim bihicəratin min siccil]</span> ﴾<span class="c2">(O quşlar ki,)</span> onların üstünə <span class="c2">(odda bişmiş)</span> bərk gildən daşlar yağdırdı﴿.<span class="c6"> Yəni:</span> O quşlar onların üstünə odda bişmiş bərk gildən daşlar yağdırdı.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105005.mp3"></audio> 5- <span class="c3">«فَجَعَلَهُمْ كَعَصْفٍ مَأْكُولٍ»</span> <span class="c5">[Fəcəaləhum kəasfin mekul]</span> ﴾<span class="c2">(Allah)</span> onları sanki yeyilmiş əkin yarpağına döndərdi﴿.<span class="c6"> Yəni:</span> Allah onları heyvanların yeyib, ayaqları altında tapdaladığı əkin yarpağına döndərdi. </p>',
      ],
      8 => [
        'question' => 'Sual 9: Qureyş surəsini oxu və onu təfsir et.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/8070.mp3',
        'answer' => '<p> Cavab: Qureyş surəsi və onun təfsiri:<br /> <span class="c3">«بسم الله الرحمن الرحيم»</span> <span class="c5">[Bismilləhi-r-rahmənir-rahim]</span> ﴾Mərhəmətli və Rəhmli Allahın adı ilə!﴿.<br /> 1- <span class="c3">«لِإِيلَافِ قُرَيْشٍ»</span> <span class="c5">[Li-iləfi qurayş]</span> ﴾Qureyşin birliyi xatirinə,﴿. 2- <span class="c3">«إِيلَافِهِمْ رِحْلَةَ الشِّتَاءِ وَالصَّيْفِ»</span> <span class="c5">[İləfihim rihlətə-şşitə-i va-ssayf]</span> ﴾Onların qış və yay səfər­lə­rindəki birliyi xatirinə﴿. 3- <span class="c3">«فَلْيَعْبُدُوا رَبَّ هَذَا الْبَيْتِ»</span> <span class="c5">[Fəlyə\'budu Rabbə həzə-lbeyt]</span> ﴾Qoy onlar bu Evin Rəb­bi­nə ibadət etsinlər.﴿. 4- <span class="c3">«الَّذِي أَطْعَمَهُمْ مِنْ جُوعٍ وَآمَنَهُمْ مِنْ خَوْفٍ»</span> <span class="c5">[Əlləzi ətaməhum min cuin va əmənəhum min xouf]</span> ﴾<span class="c2">(Allah)</span> onlara aclıqdan <span class="c2">(sonra)</span> yemək verdi və qorxudan <span class="c2">(sonra)</span> əmin-amanlıq bəxş etdi.﴿. <span class="c2">(Qureyş surəsi,<span class="c6"> ayə:</span> 1-4)</span>.<span class="c6"><br /> Təfsir:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106001.mp3"></audio> 1- <span class="c3">«لِإِيلَافِ قُرَيْشٍ»</span> <span class="c5">[Li-iləfi qurayş]</span> ﴾Qureyşin birliyi xatirinə,﴿.<span class="c6"> Yəni:</span> Bu ayədə qəsd olunan, Qureyşin vərdiş etdiyi qış və yay səfərləridir.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106002.mp3"></audio> 2- <span class="c3">«إِيلَافِهِمْ رِحْلَةَ الشِّتَاءِ وَالصَّيْفِ»</span> <span class="c5">[İləfihim rihlətə-şşitə-i va-ssayf]</span> ﴾Onların qış və yay səfər­lə­rindəki birliyi xatirinə﴿.<span class="c6"> Yəni:</span> Əmin-amanlıqla, heç kimsədən qorxmadan, qışda Yəmənə, yayda isə Şama etdikləri səfərlər.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106003.mp3"></audio> 3- <span class="c3">«فَلْيَعْبُدُوا رَبَّ هَذَا الْبَيْتِ»</span> <span class="c5">[Fəlyə\'abudu Rabbə həzə-lbeyt]</span>﴾Qoy onlar bu Evin Rəb­bi­nə ibadət etsinlər.﴿.<span class="c6"> Yəni:</span> Qoy onlar bu səfərləri onlar üçün asanlaşdıran və toxunulmaz evin Rəbbi olan Tək Allaha ibadət etsinlər və heç kəsi Ona şərik qoşmasınlar.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106004.mp3"></audio> 4- <span class="c3">«الَّذِي أَطْعَمَهُمْ مِنْ جُوعٍ وَآمَنَهُمْ مِنْ خَوْفٍ»</span> <span class="c5">[Əlləzi ətaməhum min cuin va əmənəhum min xauf]</span> ﴾<span class="c2">(Allah)</span> onlara aclıqdan <span class="c2">(sonra)</span> yemək verdi və qorxudan <span class="c2">(sonra)</span> əmin-amanlıq bəxş etdi.﴿.<span class="c6"> Yəni:</span> Uca Allah digər ərəb qəbilələrinin qəlbinə Kəbə evini və Onun sakinlərini təzim etməyi salaraq, onlara aclıqdan sonra yemək verdi və qorxudan sonra əmin-amanlıq bəxş etdi. </p>',
      ],
      9 => [
        'question' => 'Sual 10: əl-Maun surəsini oxu və onu təfsir et.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/8160.mp3',
        'answer' => '<p> Cavab: əl-<span class="c6">Maun surəsi və onun təfsiri:</span><br /> <span class="c3">«بسم الله الرحمن الرحيم»</span> <span class="c5">[Bismilləhi-r-rahmənir-rahim]</span> ﴾Mərhəmətli və Rəhmli Allahın adı ilə!﴿.<br /> 1- <span class="c3">«أَرَأَيْتَ الَّذِي يُكَذِّبُ بِالدِّينِ»</span> <span class="c5">[Əra-əytə-llezi yukəzzibu bi-ddin]</span> ﴾Dini yalan sayan o kim­sə­ni gör­dünmü?﴿. 2- <span class="c3">«فَذَلِكَ الَّذِي يَدُعُّ الْيَتِيمَ»</span> <span class="c5">[Fəzəlikə-lləzi yədu-ul-yətim]</span> ﴾O elə adamdır ki, yetimi qovar﴿. 3- <span class="c3">«وَلَا يَحُضُّ عَلَى طَعَامِ الْمِسْكِينِ»</span> <span class="c5">[Valə yəhuddu alə təami-lmiskin]</span> ﴾və <span class="c2">(heç kəsi)</span> kasıba əl tutmağa sövq etməz.﴿. 4- <span class="c3">«فَوَيْلٌ لِلْمُصَلِّينَ»</span> <span class="c5">[Fəvaylun lil-musallin]</span> ﴾vay halına namaz qılanların –﴿. 5- <span class="c3">«الَّذِينَ هُمْ عَنْ صَلَاتِهِمْ سَاهُونَ»</span> <span class="c5">[Əlləzinə hum an salətihim səhun]</span> ﴾o şəxslərin ki, onlar namazlarında səhlənkardırlar﴿. 6- <span class="c3">«الَّذِينَ هُمْ يُرَاءُونَ»</span> <span class="c5">[Əlləzinə hum yuraun]</span> ﴾Onlar riyakardırlar﴿. 7- <span class="c3">«وَيَمْنَعُونَ الْمَاعُونَ»</span> <span class="c5">[Va yəmnəunə-lməun]</span> ﴾və az bir şey verməkdən belə imtina edirlər﴿. <span class="c2">(əl-Maun surəsi,<span class="c6"> ayə:</span> 1-7)</span>.<span class="c6"><br /> Təfsir:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107001.mp3"></audio> 1- <span class="c3">«أَرَأَيْتَ الَّذِي يُكَذِّبُ بِالدِّينِ»</span> <span class="c5">[Əra-əytə-llezi yukəzzibu bi-ddin]</span> ﴾Dini yalan sayan o kim­sə­ni gör­dünmü?﴿.<span class="c6"> Yəni:</span> Qiyamət günü haqq-hesabı yalan sayan o kimsəni tanıdınmı?!<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107002.mp3"></audio> 2- <span class="c3">«فَذَلِكَ الَّذِي يَدُعُّ الْيَتِيمَ»</span> <span class="c5">[Fəzəlikə-lləzi yedu-ul-yətim]</span> ﴾O elə adamdır ki, yetimi qovar﴿.<span class="c6"> Yəni:</span> O, ehtiyacı olan yetimi şiddətlə qovan kimsədir.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107003.mp3"></audio> 3- <span class="c3">«وَلَا يَحُضُّ عَلَى طَعَامِ الْمِسْكِينِ»</span> <span class="c5">[Valə yəhuddu alə təami-lmiskin]</span> ﴾və <span class="c2">(heç kəsi)</span> kasıba əl tutmağa sövq etməz.﴿.<span class="c6"> Yəni:</span> O, nə özü fəqiri yedirdər, nə də özgəsini fəqir yedirtməyə təşviq edər.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107004.mp3"></audio> 4- <span class="c3">«فَوَيْلٌ لِلْمُصَلِّينَ»</span> <span class="c5">[Fəvaylun lil-musallin]</span> ﴾vay halına namaz qılanların –﴿.<span class="c6"> Yəni:</span> Həlak və əzab olsun o namaz qılanların halına ki,<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107005.mp3"></audio> 5- <span class="c3">«الَّذِينَ هُمْ عَنْ صَلَاتِهِمْ سَاهُونَ»</span> <span class="c5">[Əlləzinə hum an salətihim səhun]</span> ﴾o şəxslərin ki, onlar namazlarında səhlənkardırlar﴿.<span class="c6"> Yəni:</span> Onlar öz namazlarından qafildirlər, namazlarına laqeyid yanaşarlar, səhlənkarlıqları üzündən namazlarını vaxtlı-vaxtında deyil, əksinə, vaxtı çıxdıqdan sonra qılarlar.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107006.mp3"></audio> 6- <span class="c3">«الَّذِينَ هُمْ يُرَاءُونَ»</span> <span class="c5">[Əlləzinə hum yuraun]</span> ﴾Onlar riyakardırlar﴿.<span class="c6"> Yəni:</span> Onlar namazlarını və əməllərini ixlaslı olaraq Allah üçün deyil, insanlar görsün deyə edərlər.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107007.mp3"></audio> 7- <span class="c3">«وَيَمْنَعُونَ الْمَاعُونَ»</span> <span class="c5">[Va yəmnəunəl-məun]</span> ﴾və az bir şey verməkdən belə imtina edirlər﴿.<span class="c6"> Yəni:</span> Özləri üçün heç bir zərər və ya əziyyət olmadıqda belə, başqalarına yardım edilməsinə məne olarlar. </p>',
      ],
      10 => [
        'question' => 'Sual 11: əl-Kövsər surəsini oxu və onu təfsir et.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/8280.mp3',
        'answer' => '<p> Cavab: əl-<span class="c6">Kövsər surəsi və onun təfsiri:</span><br /> <span class="c3">«بسم الله الرحمن الرحيم»</span> <span class="c5">[Bismilləhi-r-rahmənir-rahim]</span> ﴾Mərhəmətli və Rəhmli Allahın adı ilə!﴿.<br /> 1- <span class="c3">«إِنَّا أَعْطَيْنَاكَ الْكَوْثَرَ»</span> <span class="c5">[İnnə əataynəkə-l-kəusər]</span> ﴾Həqiqətən, Biz Kovsəri sənə bağışladıq﴿. 2- <span class="c3">«فَصَلِّ لِرَبِّكَ وَانْحَرْ»</span> <span class="c5">[Fəsalli lirabbikə vanhər]</span> ﴾Sən də Rəbbin üçün namaz qıl və qurban kəs!﴿. 3- <span class="c3">«إِنَّ شَانِئَكَ هُوَ الْأَبْتَرُ»</span> <span class="c5">[İnnə şəni-əkə huva-l-əbtər]</span> ﴾Doğrusu, sənə ədavət bəsləyənin özü sonsuzdur﴿. <span class="c2">(əl-Kovsər surəsi,<span class="c6"> ayə:</span> 1-3)</span>.<span class="c6"><br /> Təfsir:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/108001.mp3"></audio> 1- <span class="c3">«إِنَّا أَعْطَيْنَاكَ الْكَوْثَرَ»</span> <span class="c5">[İnnə əataynəkə-l-kəvsər]</span> ﴾Həqiqətən, Biz Kovsəri sənə bağışladıq﴿.<span class="c6"> Yəni:</span> Ey Peyğəmbər! Həqiqətən, Biz sənə Cənnətdəki Kövsər irmağı olmaqla bol-bol nemətlər verdik!<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/108002.mp3"></audio> 2- <span class="c3">«فَصَلِّ لِرَبِّكَ وَانْحَرْ»</span> <span class="c5">[Fəsalli lirabbikə vanhər]</span> ﴾Sən də Rəbbin üçün namaz qıl və qurban kəs!﴿.<span class="c6"> Yəni:</span> Bu nemətə görə Allaha şükür et! Sən müşriklərin qurban kəsib öz bütlərinə yaxınlaşması əməlinə müxalif olaraq, yalnız Allah üçün namaz qıl və yalnız Onun üçün qurban kəs!<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/108003.mp3"></audio> 3- <span class="c3">«إِنَّ شَانِئَكَ هُوَ الْأَبْتَرُ»</span> <span class="c5">[İnnə şəni-əkə huva-l-əbtər]</span> ﴾Doğrusu, sənə ədavət bəsləyənin özü sonsuzdur﴿.<span class="c6"> Yəni:</span> Doğrusu sənə qəzəb bəsləyən kimsə özü bütün xeyrilərdən məhrum və unudulmuş bir kimsədir. Əgər o, insanlar arasında yad edilərsə, o zaman pisliklərlə yad edilər. </p>',
      ],
      11 => [
        'question' => 'Sual 12: əl-Kafirun surəsini oxu və onu təfsir et.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/8360.mp3',
        'answer' => '<p> Cavab: əl-<span class="c6">Kafirun surəsi və onun təfsiri:</span><br /> <span class="c3">«بسم الله الرحمن الرحيم»</span> <span class="c5">[Bismilləhi-r-rahmənir-rahim]</span> ﴾Mərhəmətli və Rəhmli Allahın adı ilə!﴿.<br /> 1- <span class="c3">«قُلْ يَا أَيُّهَا الْكَافِرُونَ»</span> <span class="c5">[Qul yə əyyuhə-l-kəfirun]</span> ﴾De: “Ey kafirlər!﴿. 2- <span class="c3">«لَا أَعْبُدُ مَا تَعْبُدُونَ»</span> <span class="c5">[Lə ə\'budu mə tə\'budun]</span> ﴾De: “Ey kafirlər!".Mən sizin ibadət etdik­lə­rinizə iba­dət etmərəm﴿. 3- <span class="c3">«وَلَا أَنْتُمْ عَابِدُونَ مَا أَعْبُدُ»</span> <span class="c5">[Valə əntum abidunə mə ə\'bud]</span> ﴾Siz də mənim ibadət et­di­yimə iba­dət edən deyilsi­niz﴿. 4- <span class="c3">«وَلَا أَنَا عَابِدٌ مَا عَبَدْتُمْ»</span> <span class="c5">[Valə ənə abidummə abədtum]</span> ﴾Mən sizin ibadət etdik­lə­rinizə iba­dət edən deyiləm﴿. 5- <span class="c3">«وَلَا أَنْتُمْ عَابِدُونَ مَا أَعْبُدُ»</span> <span class="c5">[Valə əntum abidunə mə ə\'bud]</span> ﴾Siz də mənim ibadət et­di­yimə iba­dət edən deyilsi­niz﴿. 6- <span class="c3">«لَكُمْ دِينُكُمْ وَلِيَ دِينِ»</span> <span class="c5">[Ləkum dinukum valiyə din]</span> ﴾Sizin dininiz sizə, mənim dinim də mənədir!﴿. <span class="c2">(əl-Kafirun surəsi,<span class="c6"> ayə:</span> 1-6)</span>.<span class="c6"><br /> Təfsir:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109001.mp3"></audio> 1- <span class="c3">«قُلْ يَا أَيُّهَا الْكَافِرُونَ»</span> <span class="c5">[Qul yə əyyuhə-l-kəfirun]</span> ﴾De: “Ey kafirlər!﴿.<span class="c6"> Yəni:</span> Ey Peyğəmbər! De: Ey Allaha küfr edən kafirlər!<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109002.mp3"></audio> 2- <span class="c3">«لَا أَعْبُدُ مَا تَعْبُدُونَ»</span> <span class="c5">[Lə ə\'budu mə tə\'budun]</span> ﴾De: “Ey kafirlər!".Mən sizin ibadət etdik­lə­rinizə iba­dət etmərəm﴿.<span class="c6"> Yəni:</span> Mən nə indi, nədə ki, gələcəkdə sizin Allahı qoyub ibadət etdiyiniz bütlərə ibadət etmərəm.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109003.mp3"></audio> 3- <span class="c3">«وَلَا أَنْتُمْ عَابِدُونَ مَا أَعْبُدُ»</span> <span class="c5">[Valə əntum abidunə mə ə\'bud]</span> ﴾Siz də mənim ibadət et­di­yimə iba­dət edən deyilsi­niz﴿.<span class="c6"> Yəni:</span> Siz də mənim ibadət etdiyim, Tək olan Allaha ibadət edən deyilsiniz.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109004.mp3"></audio> 4- <span class="c3">«وَلَا أَنَا عَابِدٌ مَا عَبَدْتُمْ»</span> <span class="c5">[Valə ənə abidummə abədtum]</span> ﴾Mən sizin ibadət etdik­lə­rinizə iba­dət edən deyiləm﴿.<span class="c6"> Yəni:</span> Mən də sizin ibadət etdiyiniz bütlərə ibadət edən deyiləm.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109005.mp3"></audio> 5- <span class="c3">«وَلَا أَنْتُمْ عَابِدُونَ مَا أَعْبُدُ»</span> <span class="c5">[Valə əntum abidunə mə ə\'bud]</span> ﴾Siz də mənim ibadət et­di­yimə iba­dət edən deyilsi­niz﴿. Siz də mənim ibadət etdiyim, Tək olan Allaha ibadət edən deyilsiniz.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109006.mp3"></audio> 6- <span class="c3">«لَكُمْ دِينُكُمْ وَلِيَ دِينِ»</span> <span class="c5">[Ləkum dinukum valiyə din]</span> ﴾Sizin dininiz sizə, mənim dinim də mənədir!﴿.<span class="c6"> Yəni:</span> Sizin özünüzdən ixtira etdiyiniz dininiz var, mənim də Allahın mənə nazil etdiyi dinim vardır. </p>',
      ],
      12 => [
        'question' => 'Sual 13: ən-Nasr surəsini oxu və onu təfsir et.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/8470.mp3',
        'answer' => '<p> Cavab: ən-<span class="c6">Nasr surəsi və onun təfsiri:</span><br /> <span class="c3">«بسم الله الرحمن الرحيم»</span> <span class="c5">[Bismilləhi-r-rahmənir-rahim]</span> ﴾Mərhəmətli və Rəhmli Allahın adı ilə!﴿.<br /> 1- <span class="c3">«إِذَا جَاءَ نَصْرُ اللَّهِ وَالْفَتْحُ»</span> <span class="c5">[İzə cə-ə nasruAllahi val-fəth]</span> ﴾Allahın köməyi və qələbə gəldiyi zaman﴿. 2- <span class="c3">«وَرَأَيْتَ النَّاسَ يَدْخُلُونَ فِي دِينِ اللَّهِ أَفْوَاجًا»</span> <span class="c5">[Va raəytə-nnəsə yədxulunə fi dinilləhi əfvacə]</span> ﴾insanların dəstə-dəstə Allahın dininə girdiklərini gördükdə﴿. 3- <span class="c3">«فَسَبِّحْ بِحَمْدِ رَبِّكَ وَاسْتَغْفِرْهُ إِنَّهُ كَانَ تَوَّابًا»</span> <span class="c5">[Fəsəbbih bihəmdi Rabbikə vastəğfirhu innəhu kənə təuvvəbə]</span> ﴾həmd ilə Rəbbini təriflə və Ondan bağışlanmağını dilə. Həqiqətən, O, tövbələri qəbul edəndir!﴿. <span class="c2">(ən-Nasr surəsi,<span class="c6"> ayə:</span> 1-3)</span>.<span class="c6"><br /> Təfsir:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/110001.mp3"></audio> 1- <span class="c3">«إِذَا جَاءَ نَصْرُ اللَّهِ وَالْفَتْحُ»</span> <span class="c5">[İzə cə-ə nasruAllahi val-fəth]</span> ﴾Allahın köməyi və qələbə gəldiyi zaman﴿.<span class="c6"> Yəni:</span> Ey Peyğəmbər! Sənin dininə Allahın köməyi və izzəti gəldiyi, həmçinin Məkkənin fəthi baş verdiyi zaman,<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/110002.mp3"></audio> 2- <span class="c3">«وَرَأَيْتَ النَّاسَ يَدْخُلُونَ فِي دِينِ اللَّهِ أَفْوَاجًا»</span> <span class="c5">[Va raəytə-nnəsə yədxulunə fi dinilləhi əfvacə]</span> ﴾insanların dəstə-dəstə Allahın dininə girdiklərini gördükdə﴿.<span class="c6"> Yəni:</span> İnsanların dəstə-dəstə İslamı qəbul etdiklərini gör­düyün zaman".<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/110003.mp3"></audio> 3- <span class="c3">«فَسَبِّحْ بِحَمْدِ رَبِّكَ وَاسْتَغْفِرْهُ إِنَّهُ كَانَ تَوَّابًا»</span> <span class="c5">[Fəsəbbih bihəmdi Rabbikə vastəğfirhu innəhu kənə təuvvəbə]</span> ﴾həmd ilə Rəbbini təriflə və Ondan bağışlanmağını dilə. Həqiqətən, O, tövbələri qəbul edəndir!﴿.<span class="c6"> Yəni:</span> Bil ki, bu sənin göndərildiyin peyğəmbərlik risalətinin sona yetməsinin yaxınlaşdığına işarə edən bir əlamətidir. Elə isə bu qələbəyə və zəfərə şükr edərək, həmd ilə Rəbbinə təriflər et və Ondan bağışlanmanı dilə. Həqiqətən, O, tövbələri qəbul edəndir. O, qullarının tövbəsini qəbul edib onları bağışlayandır. </p>',
      ],
      13 => [
        'question' => 'Sual 14: əl-Məsəd surəsini oxu və onu təfsir et.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/8550.mp3',
        'answer' => '<p> Cavab: əl-<span class="c6">Məsəd surəsi və onun təfsiri:</span><br /> <span class="c3">«بسم الله الرحمن الرحيم»</span> <span class="c5">[Bismilləhi-r-rahmənir-rahim]</span> ﴾Mərhəmətli və Rəhmli Allahın adı ilə!﴿.<br /> 1- <span class="c3">«تَبَّتْ يَدَا أَبِي لَهَبٍ وَتَبَّ»</span> <span class="c5">[Təbbət yədə əbi ləhəbin vatəbb]</span> ﴾Əbu Ləhəbin əlləri quru­sun, qu­rudu da!﴿. 2- <span class="c3">«مَا أَغْنَى عَنْهُ مَالُهُ وَمَا كَسَبَ»</span> <span class="c5">[Mə əğnə anhu məluhu vamə kəsəb]</span> ﴾Nə var-dövləti, nə də qazandıqları onu qurtara bilməyəcək﴿. 3- <span class="c3">«سَيَصْلَى نَارًا ذَاتَ لَهَبٍ»</span> <span class="c5">[Səyaslə nəran zətə ləhəb]</span> ﴾O, alovlanan oda atılacaqdır﴿. 4- <span class="c3">«وَامْرَأَتُهُ حَمَّالَةَ الْحَطَبِ»</span> <span class="c5">[Vamraətuhu həmmələtə-l-hətab]</span> ﴾Onun odun şələsi daşıyan arvadı da﴿. 5- <span class="c3">«فِي جِيدِهَا حَبْلٌ مِنْ مَسَدٍ»</span> <span class="c5">[Fi cidihə hablun min məsəd]</span> ﴾Arvadının boynunda xurma liflərindən kəndir olacaqdır﴿. <span class="c2">(əl-Məsəd surəsi,<span class="c6"> ayə:</span> 1-5)</span>.<span class="c6"><br /> Təfsir:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111001.mp3"></audio> 1- <span class="c3">«تَبَّتْ يَدَا أَبِي لَهَبٍ وَتَبَّ»</span> <span class="c5">[Təbbət yədə əbi ləhəbin vatəbb]</span> ﴾Əbu Ləhəbin əlləri quru­sun, qu­rudu da!﴿.<span class="c6"> Yəni:</span> Peyğəmbərin <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> əmisi Əbu Ləhəb bin Abdul-Muttəlibin Peyğəmbərə <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> əziyyət verdiyinə görə səyləri boşa çıxdı və hər iki əli qurudu.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111002.mp3"></audio> 2- <span class="c3">«مَا أَغْنَى عَنْهُ مَالُهُ وَمَا كَسَبَ»</span> <span class="c5">[Mə əğnə anhu məluhu vamə kəsəb]</span> ﴾Nə var-dövləti, nə də qazandıqları onu qurtara bilməyəcək﴿.<span class="c6"> Yəni:</span> Ona topladığı hansı var-dövləti və ya hansı oğul-uşağı fayda verdi? Əksinə, topladığı nə var-dövləti, nədə ki, oğul-uşağı fayda vermədi və bunların heç bir onu Allahın rəhmətinə müvəffəq etmədi.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111003.mp3"></audio> 3- <span class="c3">«سَيَصْلَى نَارًا ذَاتَ لَهَبٍ»</span> <span class="c5">[Səyaslə nəran zətə ləhəb]</span> ﴾O, alovlanan oda atılacaqdır﴿.<span class="c6"> Yəni:</span> O, Qiyamət günü hərarətindən əzab çəkəcək alovlu atəşə girəcəkdir.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111004.mp3"></audio> 4- <span class="c3">«وَامْرَأَتُهُ حَمَّالَةَ الْحَطَبِ»</span> <span class="c5">[Vamraətuhu həmmələtə-l-hətab]</span> ﴾Onun odun şələsi daşıyan arvadı da﴿.<span class="c6"> Yəni:</span> Peyğəmbərin <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> yolunun üzərinə tikanlar atmaqla Peyğəmbərə <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> əziyyət verən Əbu Ləhəbin arvadı Ummu Cəmil də, əri ilə birgə Cəhənnəm oduna girəcəkdir.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111005.mp3"></audio> 5- <span class="c3">«فِي جِيدِهَا حَبْلٌ مِنْ مَسَدٍ»</span> <span class="c5">[Fi cidihə hablun min məsəd]</span> ﴾Arvadının boynunda xurma liflərindən kəndir olacaqdır﴿.<span class="c6"> Yəni:</span> Arvadı Ummu Cəmilin boynunda xurma liflərindən möhkəm kəndir olacaq və o, həmən kəndirlə Cəhənnəmə sürüklənəcəkdir. </p>',
      ],
      14 => [
        'question' => 'Sual 15: əl-İxlas surəsini oxu və onu təfsir et.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/8650.mp3',
        'answer' => '<p> Cavab: əl-<span class="c6">İxlas surəsi və onun təfsiri:</span><br /> <span class="c3">«بسم الله الرحمن الرحيم»</span> <span class="c5">[Bismilləhir-rahmənir-rahim]</span> ﴾Mərhəmətli və Rəhmli Allahın adı ilə!﴿.<br /> 1- <span class="c3">«قُلْ هُوَ اللَّهُ أَحَدٌ»</span> <span class="c5">[Qul huvallahu əhəd]</span> ﴾De: <span class="c1">“O Allah Təkdir!﴿. 2- <span class="c3">«اللَّهُ الصَّمَدُ»</span> <span class="c5">[Allahu-s-saməd]</span> ﴾Allah Möhtac deyildir﴿. 3- <span class="c3">«لَمْ يَلِدْ وَلَمْ يُولَدْ»</span> <span class="c5">[Ləm yəlid valəm yuləd]</span> ﴾O, nə doğub, nə doğulub,﴿. 4- <span class="c3">«وَلَمْ يَكُنْ لَهُ كُفُوًا أَحَدٌ»</span> <span class="c5">[Valəm yəkun ləhu kufuvan əhəd]</span> ﴾Onun bənzəri də yoxdur”</span>﴿. <span class="c2">(əl-İxlas surəsi,<span class="c6"> ayə:</span> 1-4)</span>.<span class="c6"><br /> Təfsir:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112001.mp3"></audio> 1- <span class="c3">«قُلْ هُوَ اللَّهُ أَحَدٌ»</span> <span class="c5">[Qul huvallahu əhəd]</span> ﴾De: <span class="c1">“O Allah Təkdir!﴿.<span class="c6"> Yəni:</span> Ey Peyğəmbər! De: O Allah Təkdir və Ondan başda heç bir ilah yoxdur.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112002.mp3"></audio> 2- <span class="c3">«اللَّهُ الصَّمَدُ»</span> <span class="c5">[Allahus-saməd]</span> ﴾Allah Möhtac deyildir﴿.<span class="c6"> Yəni:</span> Bütün məxluqatın ehtiyacı Ona tərəf qaldırılır.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112003.mp3"></audio> 3- <span class="c3">«لَمْ يَلِدْ وَلَمْ يُولَدْ»</span> <span class="c5">[Ləm yəlid valəm yuləd]</span> ﴾O, nə doğub, nə doğulub,﴿.<span class="c6"> Yəni:</span> Uca Allahın nə övladı, nədə ki, atası vardır.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112004.mp3"></audio> 4- <span class="c3">«وَلَمْ يَكُنْ لَهُ كُفُوًا أَحَدٌ»</span> <span class="c5">[Valəm yəkun ləhu kufuvan əhəd]</span> ﴾Onun bənzəri də yoxdur”</span>﴿.<span class="c6"> Yəni:</span> Məxluqatından Ona bənzər kimsə yoxdur. </p>',
      ],
      15 => [
        'question' => 'Sual 16: əl-Fələq surəsini oxu və onu təfsir et.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/8750.mp3',
        'answer' => '<p> Cavab: əl-<span class="c6">Fələq surəsi və onun təfsiri:</span><br /> <span class="c3">«بسم الله الرحمن الرحيم»</span> <span class="c5">[Bismilləhir-rahmənir-rahim]</span> ﴾Mərhəmətli və Rəhmli Allahın adı ilə!﴿.<br /> 1- <span class="c3">«قُلْ أَعُوذُ بِرَبِّ الْفَلَقِ»</span> <span class="c5">[Qul əuzu birabbi-l-fələq]</span> ﴾De: Sığınıram sübhün Rəb­binə!﴿ 2- <span class="c3">«مِنْ شَرِّ مَا خَلَقَ»</span> <span class="c5">[Min şərri mə xaləq]</span> ﴾Məxluqatının şərindən﴿ 3- <span class="c3">«وَمِنْ شَرِّ غَاسِقٍ إِذَا وَقَبَ»</span> <span class="c5">[Vamin şərri ğasiqin izə vaqab]</span> ﴾Çökən zülmətin şərindən﴿ 4- <span class="c3">«وَمِنْ شَرِّ النَّفَّاثَاتِ فِي الْعُقَدِ»</span> <span class="c5">[Vamin şərri-n-nəffəsəti fi-l-uqad]</span> ﴾Düyünlərə üfürən <span class="c2">(cadugər)</span> qa­dın­la­rın şərindən﴿ 5- <span class="c3">«وَمِنْ شَرِّ حَاسِدٍ إِذَا حَسَدَ»</span> <span class="c5">[Vamin şərri həsidin izə həsəd]</span> ﴾Və həsəd apardığı zaman pa­xı­lın şə­rindən!﴿ <span class="c2">(əl-<span class="c6">Fələq surəsi:</span> 1-5)</span>.<span class="c6"><br /> Təfsir:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113001.mp3"></audio> 1- <span class="c3">«قُلْ أَعُوذُ بِرَبِّ الْفَلَقِ»</span> <span class="c5">[Qul əuzu birabbi-l-fələq]</span> ﴾De: “Sığınıram sübhün Rəb­binə!﴿.<span class="c6"> Yəni:</span> Ey Peyğəmbər! De: "Pənah aparıram sübhün Rəbbinə və Ondan kömək diləyirəm!<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113002.mp3"></audio> 2- <span class="c3">«مِنْ شَرِّ مَا خَلَقَ»</span> <span class="c5">[Min şərri mə xaləq]</span> ﴾Xəlq etdiklərinin şərindən﴿.<span class="c6"> Yəni:</span> Zərər verən məxluqatının şərindən.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113003.mp3"></audio> 3- <span class="c3">«وَمِنْ شَرِّ غَاسِقٍ إِذَا وَقَبَ»</span> <span class="c5">[Vamin şərri ğasiqin izə vaqab]</span> ﴾Çökən zülmətin şərindən﴿.<span class="c6"> Yəni:</span> Gecələr zühur edən heyvanlar, oğrular və s. bu kimi zərərli məxluqların şərindən Allaha sığınıram.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113004.mp3"></audio> 4- <span class="c3">«وَمِنْ شَرِّ النَّفَّاثَاتِ فِي الْعُقَدِ»</span> <span class="c5">[Vamin şərri-n-nəffəsəti fi-l-uqad]</span> ﴾Düyünlərə üfürən <span class="c2">(cadugər)</span> qa­dın­la­rın şərindən﴿.<span class="c6"> Yəni:</span> Düyünlərə üfürən sehribaz qadınların şərindən Allaha sığınıran.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113005.mp3"></audio> 5- <span class="c3">«وَمِنْ شَرِّ حَاسِدٍ إِذَا حَسَدَ»</span> <span class="c5">[Vamin şərri həsidin izə həsəd]</span> ﴾Və həsəd apardığı zaman pa­xı­lın şə­rindən!﴿.<span class="c6"> Yəni:</span> Allahın insanlara bəxş etdiyi nemətlərə görə onlara həsəd edib, qəzəblənən, Allahın onlara bəxş etdiyi nemətlərdən məhrum olunmalarını və onların başlarına pis bir şeyin gəlməsini istəyən, paxılların şərindən Allaha sığınıram. </p>',
      ],
      16 => [
        'question' => 'Sual 17: ən-Nəs surəsini oxu və onu təfsir et.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/8870.mp3',
        'answer' => '<p> Cavab: ən-<span class="c6">Nəs surəsi və onun təfsiri:</span><br /> <span class="c3">«بسم الله الرحمن الرحيم»</span> <span class="c5">[Bismilləhi-r-rahmənir-rahim]</span> ﴾Mərhəmətli və Rəhmli Allahın adı ilə!﴿.<br /> 1- <span class="c3">«قُلْ أَعُوذُ بِرَبِّ النَّاسِ»</span> <span class="c5">[Qul əuzu birabbi-n-nəs]</span> ﴾De: “Sığınıram insanların Rəbbinə,﴿. 2- <span class="c3">«مَلِكِ النَّاسِ»</span> <span class="c5">[Məliki-n-nəs]</span> ﴾insanların Hökmdarına,﴿. 3- <span class="c3">«إِلَهِ النَّاسِ»</span> <span class="c5">[İləhi-n-nəs]</span> ﴾insanların məbuduna!﴿. 4- <span class="c3">«مِنْ شَرِّ الْوَسْوَاسِ الْخَنَّاسِ»</span> <span class="c5">[Min şərri-l-vasvasi-l-xannəs]</span> ﴾Vəsvəsə verənin, <span class="c2">(Allahın adı çəkiləndə isə hövlündən)</span> geri çəkilən <span class="c2">(şeytanın)</span> şərindən﴿. 5- <span class="c3">«الَّذِي يُوَسْوِسُ فِي صُدُورِ النَّاسِ»</span> <span class="c5">[Əlləzi yuvasvisu fi suduri-n-nas]</span> ﴾<span class="c2">(O şeytan)</span> ki, insanların ürəklərinə vəsvəsə salır,﴿. 6- <span class="c3">«مِنَ الْجِنَّةِ وَالنَّاسِ»</span> <span class="c5">[Minə-l-cinnəti va-n-nəs]</span> ﴾cinlərdən də <span class="c2">(olur)</span>, insanlardan da!﴿. <span class="c2">(ən-<span class="c6">Nəs surəsi:</span> 1-6)</span>.<span class="c6"><br /> Təfsir:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114001.mp3"></audio> 1- <span class="c3">«قُلْ أَعُوذُ بِرَبِّ النَّاسِ»</span> <span class="c5">[Qul əuzu birabbi-n-nəs]</span> ﴾De: “Sığınıram insanların Rəbbinə,﴿.<span class="c6"> Yəni:</span> Ey Peyğəmbər! De: "Pənah aparıram insanların Rəbbinə və Ondan kömək diləyirəm!<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114002.mp3"></audio> 2- <span class="c3">«مَلِكِ النَّاسِ»</span> <span class="c5">[Məliki-n-nəs]</span> ﴾insanların Hökmdarına,﴿.<span class="c6"> Yəni:</span> İnsanları, Öz istəyinə müvafiq olaraq idərə Edənə və insanların Ondan başqa ixtiyar sahibi olmayana.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114003.mp3"></audio> 3- <span class="c3">«إِلَهِ النَّاسِ»</span> <span class="c5">[İləhi-n-nəs]</span> ﴾insanların məbuduna!﴿.<span class="c6"> Yəni:</span> İnsanların haqq olan məbuduna. Çünki insanların Ondan başqa haqq məbudu yoxdur.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114004.mp3"></audio> 4- <span class="c3">«مِنْ شَرِّ الْوَسْوَاسِ الْخَنَّاسِ»</span> <span class="c5">[Min şərri-l-vasvasi-l-xannəs]</span> ﴾Vəsvəsə verənin, <span class="c2">(Allahın adı çəkiləndə isə hövlündən)</span> geri çəkilən <span class="c2">(şeytanın)</span> şərindən﴿.<span class="c6"> Yəni:</span> İnsanlara vəsvəsəsini verən Şeytanın şərindən.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114005.mp3"></audio> 5- <span class="c3">«الَّذِي يُوَسْوِسُ فِي صُدُورِ النَّاسِ»</span> <span class="c5">[Əlləzi yuvasvisu fi suduri-n-nas]</span> ﴾<span class="c2">(O şeytan)</span> ki, insanların ürəklərinə vəsvəsə salır﴿.<span class="c6"> Yəni:</span> Vəsvəsini insanların qəlblərinə atan şeytanın şərindən.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114006.mp3"></audio> 6- <span class="c3">«مِنَ الْجِنَّةِ وَالنَّاسِ»</span> <span class="c5">[Minə-l-cinnəti va-n-nəs]</span> ﴾cinlərdən də <span class="c2">(olur)</span>, insanlardan da!﴿.<span class="c6"> Yəni:</span> Vəsvəsə verən o şeytan, cinlərdən də olur, insanlardan da. </p>',
      ],
    ],
    5 => [
      0 => [
        'question' => 'Sual 1: «Əməllər niyyətlərə görədir. Hər kəsə yalnız niyyət etdiyi şey vardır ...» hədisini tamamla və bu hədisin bəzi faydalarını zikr et!',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/9030.mp3',
        'answer' => '<p> Cavab: Möminlərin əmiri Əbul-Həfs Ömər ibn əl Xattab <span class="c2">(Uca Allah ondan razı olsun)</span> demişdir: Mən Allah Rəsulunun <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> belə dediyini eşitdim: "Əməllər niyyətlərə görədir. Hər kəsə yalnız niyyət etdiyi şey vardır. Kimin hicrəti Allah və Onun Rəsulu üçündürsə, onun hicrəti Allaha və Onun Rəsuluna aiddir. Kimin də hicrəti, əldə edəcəyi dünya malına və ya evlənəcəyi qadına görədirsə, onun hicrəti, hicrət etdiyi şeyə aiddir". Hədisi əl-Buxari və Müslim rəvayət etmişdir.<span class="c6"><br /> Hədisdən çıxan faydalar:</span><br /> 1-<span class="c6"> Əməllərin:</span> namaz, oruc, həcc və s. bu kimi hansı əməl olmasından aslı olmayaraq, hər bir əməli etmək üçün niyyət lazımdır.<br /> 2- Niyyət, ixlasla, Uca Allahın rızasını qazanmaq üçün olmalıdır.<span class="c6"><br /> İkinci hədis:</span> </p>',
      ],
      1 => [
        'question' => 'Sual 2: «Kim bizim bu işimizdə (dinimizdə) olmayan bir yenilik edərsə ...» hədisini tamamla və bu hədisin bəzi faydalarını zikr et!',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/9090.mp3',
        'answer' => '<p> Cavab: Möminlərin anası Aişə <span class="c2">(Allah ondan razı olsun)</span> rəvayət edir ki, Allah Rəsulu <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> belə demişdir: «Kim bizim bu işimizdə <span class="c2">(dinimizdə)</span> onda olmayan bir yenilik edərsə o, rədd olunar». Hədisi əl-Buxari və Müslim rəvayət etmişdir.<span class="c6"><br /> Hədisdən çıxan faydalar:</span><br /> 1- Dində bidət - yenilik çıxarmağın qadağan olması.<br /> 2- Bidət əməllər rədd olunar, qəbul edilməz.<span class="c6"><br /> Üçüncü hədis:</span> </p>',
      ],
      2 => [
        'question' => 'Sual 3: «Bir gün Peyğəmbərin (Allahın salavatı və salamı onun üzərinə olsun) hüzurunda oturmuşduq ...» hədisini tamamla və bu hədisin bəzi faydalarını zikr et!',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/9160.mp3',
        'answer' => '<p> Ömər ibn Xəttab <span class="c2">(Allah ondan razı olsun)</span> rəvayət edir ki, bir gün Peyğəmbərin <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> hüzuruda oturmuşduq, bu zaman paltarı ağappaq, saçları zil qara, üzərində heç bir səfər əlaməti olmayan və aramızda heç kəsin tanımadığı bir adam gəlib, Peyğəmbərin <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> yanında oturub, iki dizini onun dizlərinə söykəyib,<span class="c6"> əllərini dizlərinin üstünə qoyub dedi:</span> <span class="c3">«Ey Muhəmməd! Mənə İslam haqqında xəbər ver»</span>. Peyğəmbər <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span>: <span class="c3">«İslam, Allahdan başqa ibadətə layiq haqq ilah olmadığına və Muhəmmədin Allahın Rəsulu olduğuna şəhadət etməyin, namaz qılmağın, zəkat verməyin, ramazan orucunu tutmağın, imkan olduqda isə Allahın evi - Kəbəni ziyarət edərək həcc etməyindir»</span> deyə buyurdu. <span class="c2">(Adam:)</span> <span class="c3">«Doğru söylədin»</span> dedi. <span class="c2">(Ömər)</span> dedi ki, biz o adama təəccüb etdik. Həm sual verir, həm də onun söylədiklərinin doğru olduğunu təsdiqləyirdi.<span class="c6"> O yenə:</span> <span class="c3">«Mənə iman haqqında xəbər ver»</span> deyərək soruşdu. Peyğəmbər <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span>: «<span class="c2">(İman)</span> Allaha, mələklərinə, kitablarına, peyğəmbərlərinə, axirət gününə, qədərin xeyir və şərinin Allahdan olmasına inanmağındır» deyə buyurdu. <span class="c2">(Adam:)</span> <span class="c3">«Doğru söylədin. Mənə ehsan haqqında xəbər ver»</span> dedi. Peyğəmbər <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span>: «<span class="c2">(Ehsan)</span> Allaha, Onu görürmüş kimi ibadət etməyindir. Sən Onu görməsən də, O, səni görür» deyə buyurdu. <span class="c2">(Adam:)</span> <span class="c3">«Mənə Qiyamət haqqında xəbər ver!»</span> dedi. Peyğəmbər <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span>: <span class="c3">«Bu haqda soruşulan soruşandan çox bilmir»</span> deyə buyurdu. <span class="c2">(Adam:)</span> <span class="c3">«Onda mənə onun əlamətləri haqqında xəbər ver»</span> dedi. Peyğəmbər <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span>: <span class="c3">«Qul qadının öz ağasını doğduğunu, ayaq yalın, çılpaq çobanların hündür bina tikməkdə bir-birləri ilə yarışdıqlarını görəcəksən»</span> deyə buyurdu. <span class="c2">(Ömər)</span> dedi ki, sonra o adam çıxıb getdi. Bir müddətdən sonra Peyğəmbər <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> mənə belə dedi: <span class="c3">«Ey Ömər! O sual verənin kim olduğunu bilirsənmi?»</span>.<span class="c6"> Mən:</span> Allah və Rəsulu daha yaxşı bilir deyə cavab verdim. Peyğəmbər <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span>: <span class="c3">«O Cəbrail idi. Sizə dininizi öyrətməyə gəlmişdir»</span> dedi. Bu hədisi Müslim rəvayət etmişdir.<span class="c6"><br /> Hədisdən çıxan bəzi faydalar:</span><br /> 1- İslamın beş əsasının qeyd edilməsi.<span class="c6"> Bunlar aşağıdakılardır:</span><br /> Allahdan başqa ibadətə layiq haqq məbud olmadığına və Muhəmmədin Allahın Elçisi olduğuna şəhadət vermək.<br /> Namaz qılmaq.<br /> Zəkat vermək.<br /> Ramazan orucunu tutmaq.<br /> Allahın evi - Kəbəni həcc etmək.<br /> 2- İmanın əsaslarının zikr olunması.<span class="c6"> Onların sayı altıdır:</span><br /> Allaha iman.<br /> Mələklərinə iman.<br /> Kitablarına iman.<br /> Elçilərinə iman.<br /> Axirət gününə iman.<br /> Qədərin xeyrinə və şərinə iman.<br /> 3- Ehsanın rükununu say. Ehsanın bir rükunu vardır, bu, sənin, Allaha, Onu görürmüş kimi ibadət etməyindir. Sən Onu görməsəndə, O, səni görür.<br /> 4- Qiyamət saatının qopacaq vaxtını Uca Allahdan başqa kimsə bilmir.<span class="c6"><br /> Dördüncü hədis:</span> </p>',
      ],
      3 => [
        'question' => 'Sual 4: «Möminlərin ən kamil iman sahib olanı ...» hədisini tamamla və bu hədisdən bəzi faydaları zikr et!',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/9360.mp3',
        'answer' => '<p> Cavab: Əbu Hureyra <span class="c2">(Allah ondan razı olsun)</span> Peyğəmbərin <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> belə dediyini rəvayət edir: <span class="c3">«Möminlərin ən kamil imana sahib olanı, gözəl əxlaqa sahib olanlarıdır»</span>. Hədisi ət-Tirmizi rəvayət etmiş və hədisə "Həsən Səhih" hökmü vermişdir.<span class="c6"><br /> Hədisdən çıxan faydalar:</span><br /> 1- Gözəl əxlaqlı olmağa təşviq etmək.<br /> 2- Kamil əxlaq kamil imandandır.<br /> 3- İman artır və azalır.<span class="c6"><br /> Beşinci hədis:</span> </p>',
      ],
      4 => [
        'question' => 'Sual 5: «Kim Allahdan başqasına and içərsə ...» hədisini tamamla və bu hədisdən bəzi faydaları zikr et!',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/9440.mp3',
        'answer' => '<p> Cavab: İbn Ömər <span class="c2">(Allah ondan və atasından razı olsun)</span> Peyğəmbərin <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> belə dediyini rəvayət edir: <span class="c3">«Kim Allahdan başqasına and içərsə, atrıq küfür etmiş yaxud şərik qoşmuşdur»</span>. Hədisi ət-Tirmizi rəvayət etmişdir.<span class="c6"><br /> Hədisdən çıxan faydalar:</span><br /> 1- Uca Allahdan başqasına and içmək icazəli deyil.<br /> 2- Uca Allahdan başqasına and içmək kiçik şirkdir.<span class="c6"><br /> Altıncı hədis:</span> </p>',
      ],
      5 => [
        'question' => 'Sual 6: «Sizdən biri məni çox sevmədikcə, iman gətirmiş olmaz ...» hədisini tamamla və bu hədisdən bəzi faydaları zikr et!',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/9510.mp3',
        'answer' => '<p> Cavab: Ənəs <span class="c2">(Allah ondan razı olsun)</span> Peyğəmbərin <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> belə dediyini rəvayət edir: <span class="c3">«Sizdən biri məni, valideynindən, övladından və bütün insanlardan çox sevmədikcə, iman gətirmiş olmaz»</span>. Hədisi əl-Buxari və Müslim rəvayət etmişdir.<span class="c6"><br /> Hədisdən çıxan bəzi faydalar:</span><br /> 1- Peyğəmbəri <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> bütün insanlardan çox sevməyin vacib olması.<br /> 2- Peyğəmbəri <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> bütün insanlardan çox sevmək imanın kamilliyindəndir.<span class="c6"><br /> Yeddinci hədis:</span> </p>',
      ],
      6 => [
        'question' => 'Sual 7: «Sizdən biri özü üçün istədiyini qardaşı üçün istəmədikcə ...» hədisini tamamla və bu hədisdən bəzi faydaları zikr et!',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/9580.mp3',
        'answer' => '<p> Cavab: Ənəs <span class="c2">(Allah ondan razı olsun)</span> Peyğəmbərin <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> belə dediyini rəvayət edir: <span class="c3">«Sizdən biri özü üçün istədiyini qardaşı üçün istəmədikcə iman etmiş olmaz»</span>. Hədisi əl-Buxari və Müslim rəvayət etmişdir.<span class="c6"><br /> Hədisdən çıxan bəzi faydalar:</span><br /> 1- Mömin bir kimsəyə özü üçün istədiyi xeyri diğər möminlər üçün də istəməsi vacibdir.<br /> 2- Və bu imanın kamilliyindəndir.<span class="c6"><br /> Səkkizinci hədis:</span> </p>',
      ],
      7 => [
        'question' => 'Sual 8: «Nəfsim əlində Olana and olsun ...» hədisini tamamla və bu hədisdən bəzi faydaları zikr et!',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/9650.mp3',
        'answer' => '<p> Cavab: Əbu Səid <span class="c2">(Allah ondan razı olsun)</span> Peyğəmbərin <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> belə dediyini rəvayət edir: <span class="c3">«Nəfsim əlində Olana and olsun ki, İxlas surəsi Quranın üçdə birinə bərabərdir»</span>. Hədisi əl-Buxari rəvayət etmişdir.<span class="c6"><br /> Hədisdən çıxan bəzi faydalar:</span><br /> 1- İxlas surəsinin fəziləti.<br /> 2- Və onun Quranın üçdə birinə bərabər olması.<span class="c6"><br /> Doqquzuncu hədis:</span> </p>',
      ],
      8 => [
        'question' => 'Sual 9: «Lə həulə və lə quvvətə illə billəh ...» hədisini tamamla və bu hədisdən bəzi faydaları zikr et!',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/9720.mp3',
        'answer' => '<p> Cavab: Əbu Musa <span class="c2">(Allah ondan razı olsun)</span> Peyğəmbərin <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> belə dediyini rəvayət edir: «Ləə həulə və ləə quvvətə illə billəh <span class="c5">[Qüdrət və güc yalnız Allahdadir!]</span> <span class="c2">(zikri)</span> Cənnət xəzinə­lərindən bir xəzinədir». Hədisi əl-Buxari və Müslim rəvayət etmişdir.<span class="c6"><br /> Hədisdən çıxan bəzi faydalar:</span><br /> 1- <span class="c3">«Lə həulə və lə quvvətə illə billəh»</span> kəlməsinin fəziləti və onun Cənnət xəzinələrindən bir xəzinə olması.<br /> 2- Qul, öz güc və qüvvətinə deyil, yalnız Tək olan Uca Allaha etimad etməsi.<span class="c6"><br /> Onuncu hədis:</span> </p>',
      ],
      9 => [
        'question' => 'Sual 10: «Agah olun! İnsan bədəndə bir ət parçası var ki, ...» hədisini tamamla və bu hədisin bəzi faydalarını zikr et!',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/9790.mp3',
        'answer' => '<p> Cavab: Nu\'mən bin Bəşir <span class="c2">(Allah ondan və atsından razı olsun)</span> rəvayət edir ki, Mən Peyğəmbərin <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> belə dediyini eşitdim: <span class="c3">«Agah olun! İnsan bədəndə bir ət parçası var ki, əgər o<br /> islah edilərsə, bütün bədən islah olar, yox, əgər o korlanarsa, bütün<br /> bədən korlanar. Bilin ki, bu ət parçası qəlbdir»</span>. Hədisi əl-Buxari və Müslim rəvayət etmişdir.<span class="c6"><br /> Hədisdən çıxan bəzi faydalar:</span><br /> 1- Qəlbin islahı, insanın xaricinin və daxilinin islah olması deməkdir.<br /> 2- Qəlbin islahına diqqət vermək. Çünki qəlbin islah olmasının, insanın islah olmasına təsiri vardır.<span class="c6"><br /> On birinci hədis:</span> </p>',
      ],
      10 => [
        'question' => 'Sual 11: «Kimin dünyada sonuncu kəlməsi Ləə iləhə illə-l-lah olarsa ...» hədisini tamamla və bu hədisin bəzi faydalarını zikr et!',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/9860.mp3',
        'answer' => '<p> Cavab: Muaz bin Cəbəl <span class="c2">(Allah ondan razı olsun)</span> Peyğəmbərin <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> belə dediyini rəvayət edir: "Kim sonuncu kəlməsi Ləə iləhə illə-l-lah olarsa Cənnətə girər". Hədisi Əbu Davud rəvayət etmişdir.<span class="c6"><br /> Hədisdən çıxan bəzi faydalar:</span><br /> 1- Ləə iləhə illə-l-lah kəlməsinin fəziləti və qulun bu kəlmə səbəbi ilə Cənnətə girməsi.<br /> 2- İnsanın dünyada sonuncu kəlməsinin Lə iləhə illə-l-lah kəlməsi olmasının fəziləti.<span class="c6"><br /> On ikinci hədis:</span> </p>',
      ],
      11 => [
        'question' => 'Sual 12: «Mömin tənə etməz, lənət etməz ...» hədisini tamamla və bu hədisin bəzi faydalarını zikr et!',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/9940.mp3',
        'answer' => '<p> Cavab: Abdullah ibn Məs\'ud <span class="c2">(Allah ondan razı olsun)</span> Peyğəmbərin <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> belə dediyini rəvayət edir: <span class="c3">«Mömin tənə etməz, lənət etməz, pis və ədəbsiz sözlər söyləməz»</span>. Hədisi ət-Tirmizi rəvayət etmişdir.<span class="c6"><br /> Hədisdən çıxan bəzi faydalar:</span><br /> 1- Hər bir batil və nəlayiq söz söyləməkdən çəkinmək.<br /> 2- Mömin kimsənin batil və nəlayiq söz söyləməkdən çəkinməsi, onun dilində olan mömin sifətlərindəndir.<span class="c6"><br /> On üçüncü hədis:</span> </p>',
      ],
      12 => [
        'question' => 'Sual 13: «İnsanın İslamının gözəlliyindəndir ...» hədisini tamamla və bu hədisdən bəzi faydaları zikr et!',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/10020.mp3',
        'answer' => '<p> Cavab: Əbu Hureyra <span class="c2">(Allah ondan razı olsun)</span> Peyğəmbərin <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> belə dediyini rəvayət edir: <span class="c3">«İnsanın, özünə aid olmayan şeyləri tərk etməsi, onun İslamının gözəlliyindəndir»</span>. Hədisi ət-Tirmizi və başqaları rəvayət etmişdir.<span class="c6"><br /> Hədisdən çıxan bəzi faydalar:</span><br /> 1- İnsanın, ona aid olmayan, başqasının dini və dünya işlərini tərk etməsi.<br /> 2- İnsanın, özünə aid olmayan şeyləri tərk etməsi, onun İslamının kamilliyindəndir.<span class="c6"><br /> On dördüncü hədis:</span> </p>',
      ],
      13 => [
        'question' => 'Sual 14: «Kim Allahın kitabından bir hərf oxuyarsa ...» hədisini tamamla və bu hədisdən bəzi faydaları zikr et!',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/10100.mp3',
        'answer' => '<p> Cavab: Abdullah ibn Məsud <span class="c2">(Allah ondan razı olsun)</span> Peyğəmbərin <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> belə dediyini rəvayət edir: «Kim Allahın kitabından bir hərf oxuyarsa ona bir həsənə <span class="c2">(savab, yaxşılıq)</span> vardır. Hər bir həsənə üçün isə, on mislində savab vardır. Mən demirəm ki, "Əlif, Ləm, Mim" bir hərfdir! Lakin "Əlif" bir hərf, "Ləm" bir hərf və "Mim" bir hərfdir». Hədisi ət-Tirmizi rəvayət etmişdir.<span class="c6"><br /> Hədisdən çıxan bəzi faydalar:</span><br /> 1- Quran oxumağın fəziləti.<br /> 2- Qurandan oxuduğun hər bir hərf üçün sənə savablar vardır. </p>',
      ],
    ],
    6 => [
      0 => [
        'question' => 'Sual 1: Uca Allaha qarşı olan ədəb necə olur?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/10190.mp3',
        'answer' => '<p> Cavab 1: Uca Allahı təzim etməklə.<br /> 2- Ona heç bir şeyi şərik qoşmadan yalnız Ona ibadət etməklə.<br /> 3- Ona itaət etməklə.<br /> 4- Asilikləri tərk etməklə.<br /> 5- Uca Allahın insana bəxş etdiyi saymaqla tükənməz olan lütfünə və nemətlərinə görə Ona şükür və həmd-səna etməklə.<br /> 6- Uca Allahın insan üçün yazdığı qədərə səbr etməklə. </p>',
      ],
      1 => [
        'question' => 'Sual 2: Peyğəmbərə (Allahın salavatı və salamı onun üzərinə olsun) qarşı olan ədəb necə olur?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/10270.mp3',
        'answer' => '<p> Cavab 1: Ona tabe olmaq və onun ardınca getməklə.<br /> 2- Ona itaət etməklə.<br /> 3- Ona asi olmağı tərk etməklə.<br /> 4- Onun verdiyi xəbərləri təsdiqləməklə.<br /> 5- Onun sünnətinə ziyadələr edərək bidətə yol verməməklə.<br /> 6- Onu öz nəsfindən və bütün insanlardan çox sevməklə.<br /> 7- Ona hörmət etməklə və həmçinin, ona və onun sünnətinə yardım etməklə. </p>',
      ],
      2 => [
        'question' => 'Sual 3: Valideyinlər qarşı olan ədəb necə olur?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/10360.mp3',
        'answer' => '<p> 1- Asilik olmayan işlərdə valideyinlərə itaət etməklə.<br /> 2- Valideyinlərin xidmətində durmaqla.<br /> 3- Onlara yardım etməklə.<br /> 4- Onların ehtiyaclarını ödəməklə.<br /> 5- Onlar üçün dua etməklə.<br /> 6- Onlarla mülayim davranmaq və hətta onlara sözlərin ən kiçiyini olan"Uf" sözünü də olsa belə deməmək.<br /> 7- Valideyinlərin üzünə təbəssüm etmək və onlarla qaşqabaqlı olmamaqla.<br /> 8- Səsimi valideyinlərin səsindən yüksək qaldırmıram, onları diqqətlə dinləyirəm, onlar danışarkən sözlərini kəsmirəm, onları adları ilə çağırmıram, əksinə,<span class="c6"> onlara:</span> "Atam", "Anam" deyərək müraciət edirəm.<br /> 9- Əgər atam və anam otaqdadırsa bu zaman onlardan icazə almadan otağa daxil olmuram.<br /> 10- Valideyinlərin əlindən və başından öpmək. </p>',
      ],
      3 => [
        'question' => 'Sual 4: Qohumluq əlaqələrini necə birləşdirim?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/10490.mp3',
        'answer' => '<p> Cavab: 1- Qardaş, bacı, əmi, bibi, dayı, xala və s. qalan qohumları ziyarət etmək.<br /> 2- Onlara söz və əməllə yaxşılıq və kömək etmək.<br /> 3- Onlarla telefon və ya başqa vasitələrlə əlaqə saxlamaq və onlarla hal-əhval tutmaq. </p>',
      ],
      4 => [
        'question' => 'Sual 5: Qardaşlarım və dostlarımla necə olmalıyam?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/10550.mp3',
        'answer' => '<p> Cavab: 1- Onları sevirəm və nümunəvi dostlarla yoldaşlıq edirəm.<br /> 2- Pis dostları tərk edib, onlardan uzaq oluram.<br /> 3- Qardaşlarıma salam verib, onlarla əl ilə görüşürəm.<br /> 4- Onlar xəstələndikləri zaman onları ziyarət edib, onların şəfa tapmaları üçün dua edirəm.<br /> 5- Asqırdıqları zaman onlara <span class="c3">«يرحمك الله»</span> "Yərhəmuk Allah" deyirəm.<br /> 6- Məni onu ziyarət etməyə çağırdıqda, dəvətinə icabət edirəm.<br /> 7- Ona nəsihət edirəm.<br /> 8- Ona zülm olunduqda yardım edirəm və onun da başqalarına zülm etməsinə mane oluram.<br /> 9- Özüm üçün istədiyimi müsəlman qardaşım üçün də istəyirəm.<br /> 10- Köməyimə ehtiyacı olduqda, ona yardım edirəm.<br /> 11- Ona söz və ya əməlimlə əziyyət vermirəm.<br /> 12- Onun sirrini qoruyuram.<br /> 13- Onu söymürəm, onun qeybətini etmirəm, onu alçatmıram, ona həsəd aparmıram, onun eyiblərini axtarmıram və onu aldatmıram. </p>',
      ],
      5 => [
        'question' => 'Sual 6: Qonşuluq ədəbləri hansılardır?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/10710.mp3',
        'answer' => '<p> Cavab: 1- Qonşuma söz və əməllə yaxşılıq edirəm, köməyimə ehtiyacı olduqda isə ona yardım edirəm.<br /> 2- Bayram, evlilik və s. bu kimi sevincli günlər münasibəti ilə onu təbrik edirəm.<br /> 3- Xəstələndikdə onu ziyarət edirəm, ölüm və ya bədbəxt hadisə baş verdikdə isə ona başsağlığı verirəm.<br /> 4- Hazırladığım yeməklərdən imkan daxilində ona da göndərirəm.<br /> 5- Ona söz və ya əməlimlə əziyyət vermirəm.<br /> 6- Səsi yüksəyə qaldıraraq qonşumu narahat etmirəm, onun eyiblərini axtarmıram və onda xoşlamadığım bir şey gördükdə isə səbir edirəm. </p>',
      ],
      6 => [
        'question' => 'Sual 7: Qonaqlıq və qonaq ədəbləri hansılardır?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/10800.mp3',
        'answer' => '<p> Cavab: 1- Məni qonaqlığa dəvət edənin dəvətinə icabət edirəm.<br /> 2- Bir kimsəni ziyarət etmək istədikdə, əvvəlcədən ondan icazə alır və nə zaman gələcəyimi qabaqcadan ona bildirirəm.<br /> 3- Onun yanına daxil olmazdan öncə icazə alıram.<br /> 4- Onu ziyarət etdikdə <span class="c2">(evində)</span> çox oturmuram.<br /> 5- Evinə daxil olduqda, gözlərimi ailəsinin fərdlərinə baxmaqdan qoruyuram.<br /> 6- Evimə qonaq gəldikdə isə onu gözəl şəkildə, gülər üzlə və gözəl bir tərzdə salamlayaraq qarşılayıram.<br /> 7- Qonağı evimin ən yaxşı yerində əyləşdirirəm.<br /> 8- Qonağa yemək və içmək təklif edərək ona ehtiram göstərirəm </p>',
      ],
      7 => [
        'question' => 'Xəstə və xəstələri ziyarət etmə ədəblərini zikr et:',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/10900.mp3',
        'answer' => '<p> Cavab: 1- Ağrı hiss etdikdə,<span class="c6"> əlimi bədənimin ağrıyan yerinə qoyub üç dəfə:</span> <span class="c3">«بسم الله»</span> <span class="c5">[Bismilləh!]</span> "Allahın adı ilə!", sonra isə,<span class="c6"> yeddi dəfə:</span> <span class="c3">«أعوذ بعزة الله وقدرته من شر ما أجد وأحاذر»</span> <span class="c5">[Əuzu bi izzətilləhi və qudratihi min şərri mə əcidu və uhaziru]</span> "Duyduğum və həzər etdiyimin şərindən Allaha və Onun qüdrətinə sığınıram!" deyirəm.<br /> 2- Allahın mənim üçün təqdir etdiyindən razı qalıb, səbir edirəm.<br /> 3- Xəstə qardaşımı ziyarət etməyə tələsirəm, ziyarət etdikdə onun üçün dua edirəm və onu ziyarət etdikdən sonra yanında çox oturmaqla ona əziyyət vermirəm.<br /> 4- Məndən tələb etmədən onun üçün ruqiyyə <span class="c2">(ovsun)</span> oxuyuram.<br /> 5- Ona səbirli olmağı, Allaha dua etməyi, namazı və bacardığı qədər təharətli olmağı tövsiyə edirəm.<br /> 6-<span class="c6"> Xəstə üçün edilən dua:</span> <span class="c3">«أسأل الله العظيم رب العرش العظيم أن يشفيك»</span> <span class="c5">[Əs\'əlullahəl-aziymə Rabbəl-arşil-aziymi ən yəşfiyəkə]</span> "Böyük Ərşin Rəbbi olan Əzəmətli Allahdan sənə şəfa verməsini diləyirəm!" <span class="c2">(bu dua yeddi dəfə edilir)</span>. </p>',
      ],
      8 => [
        'question' => 'Sual 9: Elm öyrənmək ədəblərini zikr et!',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/10990.mp3',
        'answer' => '<p> 1- Elmi xalis niyyətlə Uca Allah üçün öyrənmək.<br /> 2- Öyrəndiyim elmə əməl edirəm.<br /> 3- Müəllimin yanında və ya ondan uzaqda olduqda ona hörmət və ehtiram edirəm.<br /> 4- Onun qarşısında ədəblə otururam.<br /> 5- Onu diqqətlə dinləyirəm və dərs əsnasında sözünü kəsmirəm.<br /> 6- Ona sual verdikdə, sualı ədəblə verirəm.<br /> 7- Onu adı ilə çağırmıram. </p>',
      ],
      9 => [
        'question' => 'Sual 10: Məclis ədəbləri hansılardır?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/11090.mp3',
        'answer' => '<p> 1- Məclis əhlinə salam verirəm.<br /> 2- Məclisə gəldikdə, bir kimsəni yerindən qaldırıb onun yerində və ya icazə almadan iki nəfərin arasında əyləşmirəm, əksinə, məclisin gəlib çatdığım bitdiyi yerində əyləşirəm.<br /> 3- Başqasının əyləşməsi üçün yer təşkil etməyə çalışıram<br /> 4- Öz müdaxiləmlə məclisdə danışanın sözünü kəsmirəm.<br /> 5- Məclidən qalxıb getmək istədikdə, məclis əhlindən icazə almadan və onlarla sağollaşmadan getmirəm.<br /> 6- Məclis bitdikdə isə məclisin kəffarə duasını oxuyuram. <span class="c3">«سبحانك اللهم وبحمدك، أشهد أن لا إله إلا أنت، أستغفرك وأتوب إليك»</span> <span class="c5">[Subhanəkə Allahummə və bihəm­dik, əşhədu ən lə ilahə illə ənt, əstəğfirukə və ətubu ileyk]</span> "Allahım! Sən pak və müqəddəssən! Sənə həmd olsun! Mən şahidlik edirəm ki, Sən­dən başqa məbud yoxdur. Səndən bağışlan­ma diləyir və Sənə tövbə edirəm!". </p>',
      ],
      10 => [
        'question' => 'Sual 11: Yatmaq ədəblərini zikr et!',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/11180.mp3',
        'answer' => '<p> Cavab: 1-Tez yatıram.<br /> 2- Dəstəmazlı olaraq yatıram.<br /> 3- Üzü üstə yatmıram.<br /> 4- Sağ tərəfim üzərində və sağ əlimi sağ yanağımın altına qoyaraq yatıram.<br /> 5- Çarpayıma daxil olmazdan əvvəl çarpayımı əlim ilə təmizləyirəm.<br /> 6- Kürsü ayəsini bir dəfə, İxlas, Fələq və Nəs surələrini isə üç dəfə oxuyaraq yatağa girərkən edilən zikrləri oxuyuram və <span class="c3">«باسمك اللهم أموت وأحيا»</span> <span class="c5">[Bismikə, Allahummə əmutu va əhyə]</span> "Allahım! Sənin adınla ölür və dirili­rəm!" deyirəm.<br /> 7- Fəcr namazına oyanıram.<br /> 8-<span class="c6"> Yuxudan oyandıqdan sonra bu zikri edirəm:</span> <span class="c3">«الحمد لله الذي أحيانا بعدما أماتنا وإليه النشور»</span> <span class="c5">[Əlhəmdulilləhi-l-ləzi əhyənə bə\'də mə əmətənə və ileyhi-n-nuşur]</span> "Bizi öldürdükdən sonra dirildən Allaha həmd olsun. <span class="c2">(Ölüb dirildikdən sonra isə)</span> qayı­dış Onadır". </p>',
      ],
      11 => [
        'question' => 'Sual 12: Yemək ədəbləri hansılardır?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/11290.mp3',
        'answer' => '<p> Cavab:<br /> 1- Yemək və içməyimlə, Uca Allaha ibadət etməyə taqətim olsun deyə niyyət edirəm.<br /> 2- Yeməkdən öncə əllərimi yuyuram.<br /> 3-<span class="c6"> Yeməyə başlayarkən:</span> <span class="c3">«بسم الله»</span> <span class="c5">[Bismilləh]</span> "Allahın adı ilə" deyib, qabın ortasından və ya başqasının qabağından deyil, əksinə, yeməyin mənə yaxın olan hissəsindən yeyirəm.<br /> 4-<span class="c6"> Əgər yeməyin əvvəlində:</span> <span class="c5">[Bismilləh]</span> deməyi unutsam,<span class="c6"> yemək əsnasında xatırladığım zaman:</span> <span class="c3">«بسم الله أولَه وآخرَه»</span> <span class="c5">[Bismilləh əvvləhu va əxirahu]</span> deyirəm.<br /> 5- Mövcud olan yeməyə qane oluram, yeməyi pisləmirəm, yemək xoşuma gələrsə yeyirəm, xoşuma gəlmədikdə isə tərk edirəm.<br /> 6- Yeməkdən çox deyil, əksinə, bir neçə tikə yeməklə kifayətlənirəm.<br /> 7- Yemək və içməyə üfürmürəm, əgər istidirsə soyuyana qədər gözləyirəm.<br /> 8- Yeməyi tək yemirəm, ailə və ya qonaqla birgə yeyirəm.<br /> 9- Əgər yanımda əyləşən insan yaşda məndən böyükdürsə, əlimi ondan qabağ yeməyə uzatmıram.<br /> 10- Su və ya başqa halal içkilərdən içdiyim zaman <span class="c5">[Bismilləh]</span> deyərək, oturaq vəziyyətdə, üç dəfəyə içirəm.<br /> 11- Yemək yeyib qurtardıqdan sonra <span class="c3">«الحمد لله»</span> <span class="c5">[Əlhəmdulləh]</span> "Allaha həmd olsun" deyirəm. </p>',
      ],
      12 => [
        'question' => 'Sual 13: Geyim ədəblərini say.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/11440.mp3',
        'answer' => '<p> 1- Paltarımı sağ tərəfdən geyinməklə başlayıram və bu libası mənə bəxş etdiyinə görə Allaha həmd edirəm.<br /> 2- Paltarımı iki topuqdan aşağı düşənə qədər uzatmıram.<br /> 3- Oğlan uşaqları qız paltarları, qız uşaqlarıda oğlan paltarları geyinməməlidir.<br /> 4- Paltar geyindikdə kafirlərə və ya fasiqlərə oxşamamaq.<br /> 5- Paltar çıxardıqda isə <span class="c5">[Bismilləh]</span> demək.<br /> 6- Ayaqqabın sağ ayaqdan başlayaraq geyinmək, çıxartdıqda isə sol ayaqdan başlayaraq çıxarmaq. </p>',
      ],
      13 => [
        'question' => 'Sual 14: Minik ədəblərini zikr et!',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/11540.mp3',
        'answer' => '<p> Cavab: 1-<span class="c6"> Bunları deyirəm:</span> <span class="c3">«بسم الله، الحمد لله»</span> <span class="c5">[Bismilləh, Əlhəmdulləh]</span> "Allahın adi ilə, Allaha həmd olsun". <span class="c3">«سُبْحَانَ الَّذِي سَخَّرَ لَنَا هَذَا وَمَا كُنَّا لَهُ مُقْرِنِينَ»</span> <span class="c5">[Subhənə-lləzi saxxara lənə həzə vamə kunnə ləhu muqrinin]</span> ﴾Bunu bizə tabe edən <span class="c5">[Allah]</span> pak və müqəd­dəsdir! <span class="c2">(Əgər Allahın köməyi olmasaydı)</span> bizim onlara gücümüz çatmazdı﴿. <span class="c3">«وَإِنَّا إِلَى رَبِّنَا لَمُنْقَلِبُونَ»</span> <span class="c5">[Va-innə ilə Rabbinə ləmunqalibun]</span> ﴾Həqiqətən, biz <span class="c2">(öləndən sonra)</span> Rəbbimizin hüzuruna qayıdacağıq﴿. <span class="c2">(əz-<span class="c6">Zuxruf:</span> 13 - 14)</span>.<br /> 2- Müsəlman yanından keçdikdə ona salam verirəm. </p>',
      ],
      14 => [
        'question' => 'Sual 15: Yolun ədəblərini zikr et!',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/11590.mp3',
        'answer' => '<p> Cavab: 1- Gəzərkən təvazokarlıqla gəzirəm və yolun sağ tərəfi gedirəm.<br /> 2- Qarşıma çıxan insanlara salam verirəm.<br /> 3- Gözlərin naməhrəmə baxmaqdan qoruyuram və kimsəyə əziyyət vermirəm.<br /> 4- Yaxşılığı əmr edib, pislikdən çəkindirirəm.<br /> 5- Yolda insanlara əziyyət verən maneələri yoldan uzaqlaşdırıram. </p>',
      ],
      15 => [
        'question' => 'Sual 16: Evə daxil olma və evdən çıxma ədəblərini zikr et!',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/11670.mp3',
        'answer' => '<p> Cavab: 1-<span class="c6"> Evdən sol ayağımla çıxıb və:</span> <span class="c3">«بسم الله، توكلت على الله، لا حول ولا قوة إلا بالله، اللهم إني أعوذ بك أن أَضلَّ أو أُضلَّ، أو أَزلَّ أو أُزلَّ، أو أَظلمَ أو أُظلمَ، أو أَجهلَ أو يُجهل علي»</span>. <span class="c5">[Bismilləh, təvakkəltu aləllahi va lə havlə va lə quvvatə illə billəh. Allahummə inni əuzu bikə ən ədıllə, av udallə, av əzillə, av uzəllə, av azlimə, av uzləmə, av əchələ, av yuchələ aleyyə]</span> "Allahın adı ilə! Allaha təvəkkül etdim. Qüdrət və güc yalnız Allahdadir! Allahım! Doğru yoldan azmaqdan və ya azdırılmaq­dan, çaşmaqdan və ya çaşdırılmaq­dan, zülm etməkdən və ya zülmə məruz qal­maq­dan, cahil olmaqdan və ya mənə qarşı ca­hillik edilməsindən Sənə sığınıram" zikrini deyirəm. 2-<span class="c6"> Evə sağ ayağımla daxil olub və:</span> <span class="c3">«بسم الله ولجنا، وبسم الله خرجنا، وعلى ربنا توكلنا»</span> <span class="c5">[Bismilləhi valəcnə va bismilləhi xaracnə va alə Rabbinə təvakkəlnə]</span> "Allahın adı ilə girdik, Allahın adı ilə çıxdıq və Rəb­bimizə təvəkkül etdik!" zikrini deyirəm.<br /> 3- Evə daxil olduqda ilk öncə misvakdan istifadə edirəm və sonra isə ev əhlinə salam verirəm. </p>',
      ],
      16 => [
        'question' => 'Ayaqyolu ədəblərini zikr et!',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/11730.mp3',
        'answer' => '<p> Cavab: 1-<span class="c6"> Ayaqyoluna sol ayağımla daxil oluram:</span><br /> 2-<span class="c6"> Və daxil olmazdan əvvəl belə deyirəm:</span> <span class="c3">«بسم الله، اللهم إني أعوذ بك من الخبث والخبائث»</span> <span class="c5">[Bismilləh, Allahummə inni əuzu bikə minəl-xubsi val-xabəisi]</span> "Allahın adı ilə, Allahım, pislikdən və pis əməllərdən <span class="c2">(erkək və dişi cinlərdən)</span> Sənə sığınıram!".<br /> 3- Ayaqyoluna üzərimdə Allahın adı olan bir şeylə daxil olmuram.<br /> 4- Zəruri ehtiyacımı ödədiyim zaman özümü insanların məni görməsindən qoruyuram.<br /> 5- Zəruri ehtiyacımı ödədiyim zaman danışmıram.<br /> 6- Böyük və kiçik təharətə etdiyim zaman ön və arxamı qibləyə tərəf çevirmirəm.<br /> 7- Nəcasətdən təmizləndiyim zaman sağ əlimlə deyil, əksinə, sol əlimlə təmizlənirəm.<br /> 8- Zəruri ehtiyacımı insanların yolu üzərində və ya istirahət etdikləri kölgəliklərdə etmirəm.<br /> 9- Zəruri ehtiyacımı ödədikdən sonra əllərimi yuyuram.<br /> 10-<span class="c6"> Ayaqyolundan çıxarkən sağ ayağımla çıxıb:</span> <span class="c3">«غفرانك»</span> <span class="c5">[Ğufranəkə]</span> "<span class="c2">(Allahım!)</span> Məni bağışla!" deyirəm. </p>',
      ],
      17 => [
        'question' => 'Sual 18: Məscid ədəblərini zikr et!',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/11860.mp3',
        'answer' => '<p> Cavab: 1-<span class="c6"> Məscidə sağ ayağımla daxil olaraq belə deyirəm:</span> <span class="c3">«بسم الله، اللهم افتح لي أبواب رحمتك»</span> <span class="c5">[Bismilləh, Allahumməftəh liy əbvabə rahmətik]</span> "Allahın adı ilə! Allahım! Öz mərhəmət qapılarını mənim üçün aç!".<br /> 2- Oturmazdan öncə iki rükət namaz qılıram.<br /> 3- Namaz qılanın qarşısından keçmirəm, itmiş əşyaları məsciddə axtarmıram və həmçinin məsciddə alış-veriş etmirəm.<br /> 4-<span class="c6"> Məsciddən sol ayağımla çıxıb:</span> <span class="c3">«اللهم إني أسألك من فضلك»</span> <span class="c5">[Allahummə inni əsəlukə min fadlikə]</span> "Allahım! Sənin lütfündən di­ləyirəm!" deyirəm. </p>',
      ],
      18 => [
        'question' => 'Sual 19: Salam ədəblərini zikr et!',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/11930.mp3',
        'answer' => '<p> Cavab: 1- Hər hansı bir müsəlmanla qarşılaşdığım zaman,<span class="c6"> onunla ilk öncə:</span> <span class="c3">«السلام عليكم ورحمة الله وبركاته»</span> <span class="c5">[Əssələmu aleykum və rahmətullahi va bərakətuh]</span> deyərək salam ilə başlyıram, onunla salamlaşdıqda, bu salamdan başqa salamla və həmçinin yalnız əl ilə işarə edərək salamlaşmıram.<br /> 2- Salam verdiyim kimsənin üzünə təbəssüm edirəm.<br /> 3- Onunla sağ əlimlə görüşürəm.<br /> 4- Bir kimsə mənə salam verdiyi zaman onu salamını daha gözəl şəkildə alıram və ya eynilə sahibinə qaytarıram.<br /> 5- Kafirə salam verməklə başlamıram, əgər o mənə salam verməklə başlayarsa, bu zaman verdiyi salamın eynilə cavabını qaytarıram.<br /> 6- Kiçik böyükə, minikdə olan piyadaya, gedən oturana və az da çoxa salam verir. </p>',
      ],
      19 => [
        'question' => 'Sual 20: İcazə alma ədəblərini zikr et!',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/12020.mp3',
        'answer' => '<p> Cavab: 1- Bir yerə daxil olmazdan öncə icazə alıb sonra daxil oluram.<br /> 2- Bir yerə daxil olmaq üçün yalnız üç dəfə icazə alıram, əgər üç dəfə icazə aldıqdan sonra icazə verməsələr, geri dönürəm.<br /> 3- Qapını asta döyürəm, qapının qabağında deyil, əksinə, qapının sağ və ya sol tərəfində dayanıram.<br /> 4- Ata, anamın və ya hər hansı evə icazə almadan daxil olmuram, xüsusəndə fəcr namazından öncə və zöhr və işa namazından sonra.<br /> 5- Xəstəxana və ya ticarət mərkəzi kimi daimi yaşayış yerləri olmayan məkanlara icazəsiz daxil olmaq olar </p>',
      ],
      20 => [
        'question' => 'Heyvanla mülayim davranmağın ədəblərini zikr et!',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/12100.mp3',
        'answer' => '<p> Cavab: 1- Heyvana yemək və içmək verirəm.<br /> 2- Heyvana qarşı rəhmli və şəfqətli olmaq və heyvanı taqəti çatmayan şeylə yükləməmək.<br /> 3- Heç bir əzab və əziyyət növü ilə heyvana əziyyət vermirəm. </p>',
      ],
      21 => [
        'question' => 'Sual 22: İdman ədəblərini zikr et!',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/12160.mp3',
        'answer' => '<p> Cavab: 1- İdman edərkən, Allaha itaət etməyə və Onun razılığını qazanmağa güclü bir müsəlman olmaq üçün niyyət edirəm.<br /> 2- Namaz vaxtı idmanla məşğul olmuram.<br /> 3- Oğlanlar qızlarla birlikdə idmanla məşğul olmurlar.<br /> 4- İdman edərkən övrət yerini örtən paltarlardan istifadə edirəm.<br /> 5- Üzə vurmaq və ya övrət yerləri açılan idman növləri kimi haram olan idman növlərindən çəkinirəm. </p>',
      ],
      22 => [
        'question' => 'Sual 23: Bəzi zarafat ədəblərini zikr et!',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/12240.mp3',
        'answer' => '<p> 1- Zarafat etdikdə yalanla deyil, əksinə, doğru bir şeylə zarafat ertmək.<br /> 2-<span class="c6"> Zarafat:</span> ələ salmaq, istehza etmək, əziyyət vermək və qorxutmaq kimi başqasını aşağılayan əməllərdən uzaq olmalıdır.<br /> 3- Zarafatı çoxaltmamaq. </p>',
      ],
      23 => [
        'question' => 'Sual 24: Asqırmaq ədəblərini zikr et!',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/12300.mp3',
        'answer' => '<p> Cavab: 1- Asqırdıqda ağzı əl, dəsmal və ya paltar ilə tutmaq.<br /> 2- Asqırdıqdan sonra <span class="c3">«الحمد لله»</span> <span class="c5">[Əlhəmdulləh]</span> "Allaha həmd olsun!" demək.<br /> 3-<span class="c6"> Qardaşı və ya dostu isə ona:</span> <span class="c3">«يرحمك الله»</span> <span class="c5">[Yərhəmukəllah]</span> "Allah sənə rəhm etsin!" desin.<br /> O da <span class="c5">[Yərhəmukəllah]</span> deyənə: <span class="c3">«يهديكم الله ويصلح بالكم»</span> <span class="c5">[Yəhdiykumullahu və yuslihu bəələkum]</span> "Allah sizi doğru yola yönəltsin və işinizi avand etsin!" desin. </p>',
      ],
      24 => [
        'question' => 'Sual 25: Əsnəmək ədəbləri hansılardır?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/12360.mp3',
        'answer' => '<p> Cavab: 1- Əsnəməyin qarşısını almağa çalışmaq.<br /> 2- Əsnədikdə "Ah" deyərək səsi qaldırmamaq.<br /> 3- Əsnəyərkən ağzı əl ilə tutmaq. </p>',
      ],
      25 => [
        'question' => 'Sual 26: Tilavət ədəblərini zikr et!',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/12420.mp3',
        'answer' => '<p> Cavab: 1- Quran oxuyarkən dəstəmazlı olmaq.<br /> 2- Quran oxuyarkən ədəbli və vüqarlı <span class="c2">(təmkinli)</span> halda oturmaq.<br /> 3- Quran oxumaqa başlamazdan əvvəl "isitiazə" - <span class="c3">«أعوذ بالله من الشيطان الرجيم»</span> <span class="c5">[Əuzu billəhi minş-şeytanir-racim]</span> "Daşlanmış şeytanın şərindən Allaha sığınıram!" demək.<br /> 4- Quran oxuyarkən ayələri tədəbbür edirəm. </p>',
      ],
    ],
    7 => [
      0 => [
        'question' => 'Sual 1: Gözəl əxlaqın fəzilətini zikr et!',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/12500.mp3',
        'answer' => '<p> Peyğəmbər <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> belə buyurmuşdur: "Möminlərin ən kamil imanlısı, gözəl əxlaqa sahib olanlarıdır". Bu hədisi ət-Tirmizi və İmam Əhməd rəvayət etmişdir. </p>',
      ],
      1 => [
        'question' => 'Sual 2: Biz özümüzü nə üçün İslam əxlaqı ilə tərbiyə etməliyik?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/12530.mp3',
        'answer' => '<p> Cavab: 1- Çünki İslam əxlaqı, Uca Allahın məhəbbətini qazanmağa səbəbdir.<br /> 2- Həmçinin insanların məhəbbətini qazanmağa səbəbdir.<br /> 3- Gözəl əxlaq qiyamət günü tərəzidə ən ağır gələn əməllərdən olacaqdır.<br /> 4- Gözəl əxlaq sayəsində insanın savab və əcri qat-qat artır.<br /> 5- Gözəl əxlaq - kamil imanın əlamətidir. </p>',
      ],
      2 => [
        'question' => 'Sual 3: Biz əxlaqı haradan öyrənməliyik?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/12600.mp3',
        'answer' => '<p> Cavab: Qurani-Kərimdən.<span class="c6"> Uca Allah buyurur:</span> ﴾Həqiqətən, bu Quran <span class="c2">(insanları)</span> ən doğru yola yönəldir﴿. <span class="c2">(əl-İsra surəsi,<span class="c6"> ayə:</span> 9)</span>. Biz əxlaqı həmçinin Peyğəmbərin <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> sünnətindən öyrənirik. Peyğəmbər <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> belə demişdir: "Mən, gözəl əxlaqı tamamlamaq üçün göndərildim". Hədisi İmam Əhməd rəvayət etmişdir. </p>',
      ],
      3 => [
        'question' => 'Sual 4: Ehsan əxlaqı nədir və onun növləri hansılardır?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/12640.mp3',
        'answer' => '<p> Cavab: Ehsan: Daima Uca Allahın səni gördüyünü bilmək və məxluqata xeyir və yaxşılıq etməkdir.<br /> Peyğəmbər <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> belə buyurmuşdur: "Allah hər bir şeydə ehsanı əmr etmişdir". Hədisi Müslim rəvayət etmişdir.<span class="c6"><br /> Ehsanın bəzi növləri:</span><br /> - Allaha ibadət etdikdə olan ehsan. Bu, ibadəti ixlasla Uca Allaha etməklə olur.<br /> - Valideyinlərə söz və əməl ilə olan ehsan.<br /> - Qohum-əqrabaya olan ehsan.<br /> - Qonşuya olan ehsan.<br /> - Yetimlərə və miskinlərə olan ehsan.<br /> - Sənə pislik edən kimsəyə qarşı olan ehsan.<br /> - Danışıqda olan ehsan.<br /> - Mübahisə edərkən olan ehsan.<br /> - Heyvana qarşı olan ehsan. </p>',
      ],
      4 => [
        'question' => 'Sual 5: Ehsanın ziddi nədir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/12780.mp3',
        'answer' => '<p> Cavab: Ehsanın ziddi pislikdir.<span class="c6"><br /> Bu pisliklərdən biridə:</span> - Uca Allaha ixlasla ibadət etməyi tərk etmək.<br /> - Valideyinlərin üzünə ağ olmaq.<br /> - Qohumluq əlaqələrini kəsmək.<br /> - Qonşu ilə pis münasibətdə olmaq.<br /> - Fəqirlərə və yoxsullara ehsanı tərk etmək və onlara qarşı pis münasibətdə olmaq. </p>',
      ],
      5 => [
        'question' => 'Sual 6: Əmanətin növləri hansılardır və bunu misal çəkərək izah et?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/12860.mp3',
        'answer' => '<p> Cavab:<br /> 1- Uca Allahın haqlarını qorumaqda olan əmanət.<span class="c6"><br /> Buna misal:</span> Namaz, zəkat, oruc, həcc və s. bu kimi Uca Allahın bizə vacib etdiyi ibadətləri lazımı qaydada yerinə yetirmək.<br /> 2- Məxluqatın haqlarını qorumaqda olan əmanət.<span class="c6"> Buna misal olaraq aşağıdakıları çəkmək olar:</span><br /> - İnsanların namus və heysiyyatını qorumaq.<br /> - İnsanların mallarını qorumaq.<br /> - İnsanların qanlarını qorumaq.<br /> - İnsanların sirlərini və həmçinin sənə əmanət etdikləri hər bir şeyi qorumaq.<span class="c6"><br /> Uca Allah nicat tapan kimsələrin sifətlərini vəsf edərək belə buyurur:</span> ﴾O <span class="c2">(mömin)</span> kəslər ki, əmanətlərini və vədlərini qoruyurlar﴿. <span class="c2">(Muminun surəsi,<span class="c6"> ayə:</span> 8)</span>. </p>',
      ],
      6 => [
        'question' => 'Sual 7: Əmanətin ziddi nədir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/12980.mp3',
        'answer' => '<p> Cavab: Əmanətin ziddi xəyanətdir.<span class="c6"> Xəyanət:</span> Uca Allahın və insanların hüquqlarını zay etməkdir.<br /> Peyğəmbər <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> buyurur: "Münafiqin əlaməti üçdür: Danışdığı zaman yalan danışar. Vəd verdiyi zaman <span class="c2">(vədinə)</span> xilaf çıxar. Ona əmanət verildikdə isə əmanətə xəyanət edər". Hədisi əl-Buxari və Müslim rəvayət etmişdir. </p>',
      ],
      7 => [
        'question' => 'Sual 8: Sadiq olmağın əxlaqı nədir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/13020.mp3',
        'answer' => '<p> Cavab: Sadiq olmağın əxlaqı: Baş vermiş bir hadisəni və ya hər hansı bir şeyi olduğu kimi xəbər verməkdir.<span class="c6"><br /> Buna aşağıdakıları misal çəkmək olar:</span><br /> - İnsanlarla danışdıqda doğru danışmaq.<br /> - Vəd verdikdə vədə sadiq qalmaq.<br /> - Hər bir söz və əməldə dürüst olmaq.<br /> Peyğəmbər <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> buyurur: "Doğruluq <span class="c2">(insanı)</span> yaxşı işlərə yönəldər. Yaxşı işlər isə <span class="c2">(insanı)</span> Cənnətə aparar. Kişi o qədər doğru danışar ki, <span class="c2">(Allah yanında)</span> doğru danışanlardan olar". Hədisi əl-Buxari və Müslim rəvayət etmişdir. </p>',
      ],
      8 => [
        'question' => 'Sual 9: Sadiqliyin ziddi nədir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/13100.mp3',
        'answer' => '<p> Cavab: Sadiqliyin ziddi, yalandır.<span class="c6"> Yalan:</span> Həqiqətin əksidir.<span class="c6"> Buna misal olaraq:</span> İnsanlara yalan danışmağı, onları aldatmağı, verdiyi vədlərə xilaf çıxmağ, yalandan şahidlik etməyi və s. bu kimi əməlləri misal çəkmək olar.<br /> Peyğəmbər <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> belə buyurmuşdur: "Yalan isə <span class="c2">(insanı)</span> günah işlərə yönəldər. Günah işlər də <span class="c2">(insanı)</span> Cəhənnəmə aparar. İnsan o qədər yalan danışar ki, <span class="c2">(Allah yanında)</span> yalan danışanlardan olar". Hədisi əl-Buxari və Müslim rəvayət etmişdir. Peyğəmbər <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> bu barədə belə demişdir: "Münafiqin əlaməti üçdür: Danışdığı zaman yalan danışar. Vəd verdiyi zaman <span class="c2">(vədinə)</span> xilaf çıxar. Ona əmanət verildikdə isə əmanətə xəyanət edər". Hədisi əl-Buxari və Müslim rəvayət etmişdir. </p>',
      ],
      9 => [
        'question' => 'Sual 10: Səbrin növləri hansılardır?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/13140.mp3',
        'answer' => '<p> Cavab: Səbrin üç növü vardır.<span class="c6"> Bunlar aşağıdakılardır:</span> 1- Uca Allaha itaətdə səbr etmək.<br /> 2- Asiliklərə səbr etmək.<br /> 3- Allahın acı qədərlərinə səbr etmək və hər bir halda Allaha həmd-səna etmək.<span class="c6"><br /> Uca Allah buyurur:</span> ﴾Allah səbr edənləri sevir!﴿ <span class="c2">(Ali-İmran surəsi,<span class="c6"> ayə:</span> 146)</span>. Peyğəmbər <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> bu barədə belə demişdir: "Möminin işi təəccüblüdür. Çünki hər işi onun üçün bir xeyirdir. Bu, başqasına deyil, yalnız möminə aiddir. Əgər ona razı qaldığı şey gəlsə, şükür edər, bu onun üçün xeyirli olar. Əgər bir zərər gələrsə səbr edər, bu da onun üçün xeyirli olar". Bu hədisi Müslim rəvayət etmişdir. </p>',
      ],
      10 => [
        'question' => 'Sual 11: Səbrin ziddi nədir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/13210.mp3',
        'answer' => '<p> Cavab: Səbirin ziddi: Həm itaətdə, həm də asiliklərə qarşı səbrsizlik etmək və Allahın qədərlərinə qarşı söz və əməl ilə qəzəblənmək.<span class="c6"><br /> Səbrin ziddinin növlərindən bəziləri aşağıdakılardır:</span><br /> - Ölümü arzulamaq.<br /> - Üzə vurmaq.<br /> - Paltarı cırmaq <span class="c2">(yırtmaq)</span>.<br /> - Saçı yolmaq.<br /> - Özünə bəd dua etmək.<br /> Peyğəmbər <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> buyurur: "Cəzanın böyüklüyü, bəlanın böyüklüyünə görədir. Əgər Allah bir qövmü sevərsə, onları imtahana çəkər. Kim razı olarsa, onun üçün razılıq vardır. Kim də qəzəblənərsə, onun üçün qəzəb vardır". Hədisi ət-Tirmizi və İbn Məca rəvayət etmişdir. </p>',
      ],
      11 => [
        'question' => 'Sual 12: Yardımlaşmağın əxlaqını zikr et!',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/13310.mp3',
        'answer' => '<p> Cavab: Bu, insanların öz aralarında haqq və xeyir işlərdə yardımlaşmasıdır.<span class="c6"><br /> Buna nümunə olaraq aşağıdakıları misal çəkmək olar:</span><br /> - Haqqları yerinə yetirmək üçün yardımlaşmaq.<br /> - Məzluma kömək etmək üçün yardımlaşmaq.<br /> - İnsanların və miskinləri ehtiyaclarını ödəmək üçün yardımlaşmaq.<br /> - Hər bir xeyir əməldə yardımlaşmaq.<br /> - Günah,<span class="c6"> əziyyət və düşmənçilik etmək kimi işlərində yardımlaşmamaq<br /> Uca Allah buyurur:</span> ﴾Yaxşılıq etməkdə və Allahdan qorxmaqda bir-birinizə yardım edin. Günah işlər görməkdə və düşmənçilikdə bir-birinizə köməkçi olmayın. Allahdan qorxun. Həqiqətən, Allah şiddətli cəza verəndir.﴿ <span class="c2">(əl-Maidə surəsi,<span class="c6"> ayə:</span> 2)</span>. Peyğəmbər <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> buyurur: "Möminlər bina kimidir. Biri, digərini gücləndirər". Hədisi əl-Buxari və Müslim rəvayət etmişdir. Peyğəmbər <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> bu barədə belə demişdir: "Müsəlman müsəlmanın qardaşıdır, ona zülm etməz, onu köməksiz qoymaz. Kim qardaşının ehtiyacını ödəyərsə, Allah da onun ehtiyacını ödəyər. Kim bir müsəlmanı sıxıntıdan qurtararsa, Allah da onun Qiyamət gününün sıxıntılarından qurtarar. Kim bir müsəlmanın eybini örtərsə, Allah da Qiyamət günü onun eyiblərini örtər". Hədisi əl-Buxari və Müslim rəvayət etmişdir. </p>',
      ],
      12 => [
        'question' => 'Sual 12: Həyanın növləri hansılardır?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/13420.mp3',
        'answer' => '<p> Cavab: Həyanın növləri aşağıdakılardır: 1- Allahdan həya etmək. Bu, Uca Allaha qarşı asilik etməməklə olur.<br /> 2- İnsanlardan həya etmək. Bu, insanlarla pis və ədəbsiz sözlərlə danışmağı tərk etməklə və insanlar yanında övrət yerini açmamaqla olur.<br /> Allahın Elçisi <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> buyurur: "İman yetmişdən çox şöbədən ibarətdir. İmanın ən yüksək mərtəbəsi - Lə iləhə illəllah sözüdür. Ən aşağı dərəcəsi isə yolda əziyyət verən maneəni uzaqlaşdırmaqdır. Həya da imanın şöbəsin­dəndir".<span class="c6"> Başqa bir hədis­də isə:</span> «İman altmışdan artıq şöbədən ibarətdir". Bu hədisi Müslim rəvayət etmişdir. </p>',
      ],
      13 => [
        'question' => 'Sual 14: Mərhəmətin növlərini zikr et!',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/13470.mp3',
        'answer' => '<p> Cavab: Mərhəmətin növləri aşağıdakılardır: -Yaşlı insanlara mərhəmət göstərmək və hörmət etmək.<br /> - Kiçiklərə mərhəmət və şəfqət göstərmək.<br /> - Yoxsullara və ehtiyac sahibi insanlara mərhəmət göstərmək.<br /> - Heyvana yemək vermək və ona əziyyət verməməklə mərhəmət etmək.<br /> Bu Peyğəmbər <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> belə demişdir: "Sən möminlərin bir-birilərinə mərhəmət göstərməkdə, bir-birilərini sevməkdə və bir-birilərinə can yandırmaqda bir bədən kimi olduğunu görürsən. Belə ki, <span class="c2">(bədənin)</span> bir əzasına xəstəlik üz verdikdə bütün bədən yuxusuzluqdan və qızdırmadan əziyyət çəkir". Hədisi əl-Buxari və Müslim rəvayət etmişdir. Allahın Elçisi <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> buyurur: "Rəhm edənlərə<span class="c2">(mərhəmətli olanlara)</span>, Rəhman olan Allah rəhm edər. Yer üzündə olanlara rəhm edin ki, səmada Olan da sizə rəhm etsin". Hədisi Əbu Davud və ət-Tirmizi rəvayət etmişdir. </p>',
      ],
      14 => [
        'question' => 'Sual 15: Sevginin növləri hansılardır?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/13550.mp3',
        'answer' => '<p> Cavab: Uca Allaha qarşı olan sevgi.<span class="c6"><br /> Uca Allah buyurur:</span> ﴾İman gətirənlərin isə Allaha olan sevgisi daha güclüdür﴿. <span class="c2">(əl-Bəqərə surəsi,<span class="c6"> ayə:</span> 165)</span>.<br /> Allahın Elçisinə <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> qarşı olan sevgi.<br /> Bu barədə Peyğəmbər <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> belə demişdir: "Nəfsim əlində olan Allaha and olsun ki, sizdən biri məni atasından və övladından çox sevmədikcə iman gətirmiş olmaz". Hədisi əl-Buxari rəvayət etmişdir.<br /> Möminlərə qarşı olan sevgi. Bu, öz nəfsinə xeyri istədiyin kimi möminlərə də istəməklə olur.<br /> Peyğəmbər <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> buyurur: "Sizdən biri öz nəfsinə istədiyini qardaşına istəmədikcə iman gətirmiş olmaz". Hədisi əl-Buxari rəvayət etmişdir. </p>',
      ],
      15 => [
        'question' => 'Sual 16: Təbəssümün tərifi nədir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/13630.mp3',
        'answer' => '<p> Cavab: Təbəssüm: Gülərüz olmaqla yanaşı insanlarla qarşılaşdıqda onları fərəh, mehribanlıq və sevinclə qarşılamaqdır.<br /> Təbəssüm - insanların nifrətinə səbəb olacaq dərəcədə insanları qaşqabağlı bir halda qarşılamağın tam əksidir.<br /> Təbəssüm barədə Peyğəmbərdən <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> bəzi hədislər varid olmuşdur. Əbu Zərr <span class="c2">(Allah ondan razı olsun)</span> Peyğəmbərin <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> belə dediyini rəvayət edir: "Yaxşı əməllərdən heç birini küçümsəmə, hətta qardaşınla qarşılaşdığın zaman onun gülərüz qarşılamağını belə". Bu hədisi Müslim rəvayət etmişdir. Peyğəmbər <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> buyurmuşdur: "Qardaşının üzünə təbəssüm etməkdə sənin üçün bir sədəqə vardır". Hədisi ət-Tirmizi rəvayət etmişdir. </p>',
      ],
      16 => [
        'question' => 'Sual 16: Həsəd nədir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/13690.mp3',
        'answer' => '<p> Cavab: Həsəd: Başqasında olan hər hansı bir nemətin getməsini arzulamaq yaxud da hər hansı bir nemətin başqasında olmasını istəməmək.<span class="c6"><br /> Uca Allah buyurur:</span> ﴾Və həsəd apardığı zaman pa­xı­lın şə­rindən!﴿. <span class="c2">(əl-Fələq surəsi,<span class="c6"> ayə:</span> 5)</span>.<br /> Ənəs ibn Malik <span class="c2">(Allah ondan razı olsun)</span> Peyğəmbərin <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> belə dediyini rəvayət edir: "Bir-birinizə nifrət etməyin, bir-birinizə həsəd aparmayın, bir-birinizə arxa çevirməyin. Ey Allahın qulları, qardaş olun!". Hədisi əl-Buxari və Müslim rəvayət etmişdir. </p>',
      ],
      17 => [
        'question' => 'Sual 18: İstehza nədir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/13740.mp3',
        'answer' => '<p> Cavab: İstehza: müsəlman qardaşını ələ salmaq və onu aşağılamaqdır. Bu əməl, qadağan olunan əməldir.<span class="c6"><br /> Uca Allah bunun qadağan olunması barədə belə buyurur:</span> ﴾Ey iman gətirənlər! Bir camaat digərini məsxərəyə qoymasın. Ola bilər ki, bunlar onlardan daha yaxşı olsunlar. Qadınlar da qadınları <span class="c2">(lağa qoymasınlar)</span>. Ola bilər ki, bunlar onlardan daha yaxşı olsunlar. Bir-birinizə tənə vurmayın və bir-birinizi pis ləqəblərlə çağırmayın. İman gətirdikdən sonra fəsadçı adlanmaq necə də pisdir. Məhz tövbə etməyənlər zalımlardır﴿. <span class="c2">(əl-Hucurat surəsi,<span class="c6"> ayə:</span> 11)</span>. </p>',
      ],
      18 => [
        'question' => 'Sual 19: Təvazökarlığın tərifi nədir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/13780.mp3',
        'answer' => '<p> Cavab: Təvazökarlıq - İnsanın özünü başqalarından üstün görməməsi, insanları alçaltmaması və haqqı inkar etməməsidir.<span class="c6"><br /> Uca Allah buyurur:</span> ﴾Ər-Rəhmanın qulları o kəslərdir ki, onlar yer üzündə təvazökarlıqla gəzər﴿. <span class="c2">(əl-Furqan surəsi,<span class="c6"> ayə:</span> 63)</span>.<span class="c6"> Yəni:</span> Yer üzündə təvazökarlıqla gəzərlər. Allahın Elçisi <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> bu barədə buyurur: "Kim Allah üçün təvazökarlıq edərsə Allah onu ucaldar". Bu hədisi Müslim rəvayət etmişdir. Peyğəmbər <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> buyurub: "Allah mənə vəhy edərək buyurmuşdur ki, təvazökar olun, bir-birinizə qarşı öyünməyin və bir-birinizə qarşı azğınlıq etməyin". Bu hədisi Müslim rəvayət etmişdir. </p>',
      ],
      19 => [
        'question' => 'Sual 20: Haram olan təkəbbürlüyün növləri hansılardır?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/13840.mp3',
        'answer' => '<p> Cavab: 1- Haqqa qarşı təkəbbürlü olmaq. Bu, haqqı inkar etmək və haqqı qəbul etməməklə olur.<br /> 2- İnsanlara qarşı təkəbbürlü olmaq. Bu, insanlara xor, alçaq nəzərlə, saymazcasına davranmaqla olur.<br /> Allahın Elçisi <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> buyurur: "Qəlbində misqal zərrəsi qədər kibir olan kimsə Cənnətə girməyəcəkdir". Bu zaman bir kişi Peyğəmbərə <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span>: "İnsan paltarının və ayaqqabısının gözəl olmasını istəyir" dedi. Bunun cavabında Peyğəmbər <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> ona belə dedi: "Allah gözəldir, gözəlliyi sevər. Kibir, haqqı inkar etmək və insanlara xor baxmaqdır". Bu hədisi Müslim rəvayət etmişdir.<br /> - Haqqı inkar etmək,<span class="c6"> yəni:</span> haqqı qəbul etməməkdir.<br /> - İnsanlara xor baxmaq,<span class="c6"> yəni:</span> İnsanlara alçaq nəzərlə, saymazcasına müamilə etməkdir.<br /> - İnsan paltarının və ayaqqabısının gözəl olmasını istəməsi, heç də insanın təkəbbürlü olması anlamında deyil. </p>',
      ],
      20 => [
        'question' => 'Sual 21: Haram olan aldatmanın bəzi növlərini zikr et!',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/13910.mp3',
        'answer' => '<p> Cavab: Alış-verişdə insanları aldatmaq. Bu, malın qüsurunu gizlətməklə olur.<br /> Tədris zamanı aldatmaq. Burada, tələbələrin imtahanlarda köçürmələrini misal çəkmək olar.<br /> Sözdə aldatmaq.<span class="c6"> Məsələn:</span> Yalandan şahidlik etmək.<br /> Dediyin sözə vəfalı olmamaq və insanlarla bağladığın əhdi yerinə yetirməmək.<br /> Alış-verişdə insanları aldatmaq barədə rəvayət edilən hədisdə rəvayət edilir ki, Peyğəmbər <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> bazarda bir buğda yığımının yanından keçərkən əlini o buğda yığımının içinə saldı. Peyğəmbərin <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> barmaqları yaş olduqda: "Ey buğda sahibi bu nədir?"- deyə soruşdu.<span class="c6"> Buğda sahibi də:</span> "Ey Allahın Elçisi, yağışa görə islanmışdır"- deyə cavab verdi. Peyğəmbər <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> ona: "İslanmış buğdanı insanların görmələri üçün üstə qoya bilməzdin? Bizi aldatan bizdən deyildir"- dedi. Bu hədisi Müslim rəvayət etmişdir.<br /> Hədisdə keçən الصُّبْرَة sözü, buğda yığımı və ya topası mənasını verir. </p>',
      ],
      21 => [
        'question' => 'Sual 22: Qeybət nədir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/13990.mp3',
        'answer' => '<p> Cavab: Qeybət: Qardaşın yanında olmadığı zaman onun barəsində xoşlamadığı bir şeyi danışmağındır.<span class="c6"><br /> Uca Allah buyurur:</span> ﴾... bir-birinizin qeybətini qırmayın. Sizdən biriniz ölmüş qardaşının ətini yemək istəyərmi? Siz ki, bundan iyrənirsiniz. Allahdan qorxun! Həqiqətən, Allah tövbələri qəbul edəndir, Rəhmlidir﴿ <span class="c2">(əl-Hucurat surəsi,<span class="c6"> ayə:</span> 12)</span>. </p>',
      ],
      22 => [
        'question' => 'Sual 23: Nəmmamlıq nədir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14030.mp3',
        'answer' => '<p> Cavab? Nəmmamlıq: İnsanların arasını vurmaq məqsədi ilə arada söz gəzdirmək.<br /> Allahın Elçisi <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> buyurur: "Nəmmam Cənnətə girməz". Bu hədisi Müslim rəvayət etmişdir. </p>',
      ],
      23 => [
        'question' => 'Sual 24: Tənbəllik nədir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14070.mp3',
        'answer' => '<p> Cavab: Tənbəllik: Xeyir işi etməyə və ya insanın etməsi vacib olan bir əməli etməyə səhlənkar yanaşmasıdır.<br /> Buna, Uca Allahın vacib etdiyi əməllərə tənbəlliklə yanaşmağı misal çəkmək olar.<span class="c6"><br /> Uca Allah buyurur:</span> ﴾Münafiqlər, həqiqətən də, Allahı aldatmağa çalışırlar. Halbuki <span class="c2">(Allah)</span> onları aldadır. Onlar namaza durarkən könülsüz qalxar, özlərini camaata göstərər və Allahı olduqca az yad edərlər﴿. <span class="c2">(ən-Nisa surəsi,<span class="c6"> ayə:</span> 142)</span>.<span class="c6"><br /> Mömin:</span> tənbəllikdən, səhlənkarlıqdan, hərəkətsizlikdən və s. bu kimi xoşagəlməz sifətlərdən uzaq olmalı və bu dünyada Uca Allahın razı qalacağı işlərdə ciddi olaraq səy göstərməlidir. </p>',
      ],
      24 => [
        'question' => 'Sual 25: Qəzəbin növlərini zikr et!',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14130.mp3',
        'answer' => '<p> Cavab: Qəzəbin iki növü vardır. 1- Təqdirəlayiq qəzəb. Bu, kafirlərin, münafiqlərin və onlardan qeyrilərinin Uca Allahın haram etydiyi əməlləri edərkən, Allah üçün qəzəblənməkdir.<br /> 2- Məzəmmət olunan <span class="c2">(qınalınan)</span> qəzəb. Bu qəzəb, insanı deyilməsi və edilməsi qadağan olan sözü deməyə və qadağan olan əməli etməyə vadar edən qəzəbdir.<span class="c6"><br /> Məzəmmət olunan qəzəbin müalicəsi:</span><br /> 1- Dəstəmaz almaq.<br /> 2- Ayaq üstədirsə oturmaq, oturmuş haldadırsa uzanmaq.<br /> 3- Peyğəmbərin <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> bu barədə olan "Qəzəblənmə" vəsiyyətinə əməl etmək.<br /> 4- Qəzəbləndikdə öz nəfsinə hakim olmaq.<br /> 5- <span class="c3">«أعوذ بالله من الشيطان الرجيم»</span> <span class="c5">[Əuzu billəhi minəş-şeytanir-ra­cim]</span> "Lənətlənmiş şeytandan Allaha sığını­ram!" deyərək, şeytandan Allaha sığınmaq.<br /> 6- Susmaq. </p>',
      ],
      25 => [
        'question' => 'Sual 26: Cəsusluq etmək nədir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14240.mp3',
        'answer' => '<p> Cavab: Cəsusluq etmək, insanların ayıblarını və sirlərini axtarıb araşdırmaq.<span class="c6"><br /> Cəsusluğun haram olan növlərindən bəziləri aşağıdakılardır:</span><br /> - İnsanların evlərində olan eyibləri axtarıb araşdırmaq.<br /> - Bir toplumun onlardan xəbərsiz danışıqlarına qulaq asmaq.<span class="c6"><br /> Uca Allah buyurur:</span> ﴾Bir-birinizi güdməyin﴿. <span class="c2">(əl-Hucurat surəsi,<span class="c6"> ayə:</span> 12)</span>. </p>',
      ],
      26 => [
        'question' => 'Sual 27: İsrafçılıq, xəsislik və səxavət nədir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14310.mp3',
        'answer' => '<p> Cavab: İsrafçılıq: Malı lazımsız yerə xərcləməkdir.<br /> Bunun əksi isə xəsislik.<span class="c6"> Xəsislik:</span> Malı lazım olan yerə xərcləməməkdir.<br /> Doğru mövqe isə bunların arasında orta bir yol tutmaqdır, belə ki, müsəlman səxavətli olmalıdır.<span class="c6"><br /> Uca Allah buyurur:</span> ﴾Onlar <span class="c2">(mallarını )</span>xərclədikdə nə israfçılıq, nə də xəsislik edər, bunların arasında orta bir yol tutarlar﴿. <span class="c2">(əl-Furqan surəsi,<span class="c6"> ayə:</span> 67)</span>. </p>',
      ],
      27 => [
        'question' => 'Sual 28: Qorxaqlıq və şücaət nədir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14370.mp3',
        'answer' => '<p> Cavab: Qorxaqlıq, qoxulması lazım olmayan bir şeydən qorxmaqdır.<span class="c6"><br /> Məsələn:</span> Haqq sözü deməkdən və pisliyi inkar etməkdən qorxmaqdır.<span class="c6"><br /> Şücaət:</span> Haqqı müdafiə etməkdir.<span class="c6"> Məsələn:</span> İslamı və müsəlmanları müdafə etmək məqsədi ilə cihad meydanlarına atılmaq.<br /> Peyğəmbər <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> duasında belə deyərdi: <span class="c3">«اللَّهُمَّ إنِّي أعوذُ بكَ من الجُبنِ...»</span> <span class="c5">[Allahummə, inni əuzu bikə minəl-cubni]</span> "Allahım, qorxaqlıqdan Sənə sığınıram!" Allahın Elçisi <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> buyurur: "Qüvvətli mömin, zəif mömindən daha xeyirli və Allaha daha sevimlidir. Hər ikisində də xeyir vardır". Bu hədisi Müslim rəvayət etmişdir. </p>',
      ],
      28 => [
        'question' => 'Sual 29: Bəzi haram olan sözləri zikr et!',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14440.mp3',
        'answer' => '<p> Cavab: Məsələn: Lənət etmək və söyüş söymək.<br /> Başqasına "heyvan" yaxud buna oxşar kobud sözlər demək.<br /> Ayıb yerləri bildirən əxlaqsız və ədəbsiz sözlər söyləmək.<br /> Peyğəmbər <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> bütün bunlardan çəkindirərək belə demişdir: <span class="c3">«Mömin tənə etməz, lənət etməz, pis və ədəbsiz sözlər söyləməz»</span> Hədisi ət-Tirmizi və İbn Hibbən rəvayət etmişdir. </p>',
      ],
      29 => [
        'question' => 'Sual 30: Müsəlmana gözəl əxlaqa sahib olmağa yardım edən bəzi səbəbləri zikr et!',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14500.mp3',
        'answer' => '<p> Cavab: 1- Dua etmək. Belə ki, insan, Allaha, onu gözəl əxlaqla nemətləndirməsi və bu işdə ona yardımçı olması üçün dua etməlidir.<br /> 2- İnsan hər zaman Uca Allahın onu gördüyünü, daima ondan agah olduğunu və onu eşidib halından xəbərdar olduğunu bilməsi.<br /> 3- Uca Allahın gözəl əxlaq sahibinə verəcəyi savabı və gözəl əxlaqın Cənnətə girmək üçün bir səbəb olmasını xatırlamaq.<br /> 4- Pis əxlaqın pis sonluqla bitəcəyini və pis əxlaqa sahib olmağın Cəhənnəmə girmək üçün bir səbəb olmasını xatırlamaq.<br /> 5- Gözəl əxlaq, Uca Allahın və insanların məhəbbətini, pis əxlaq isə Uca Allahın və insanların qəzəbini qazanmağa səbəbdir.<br /> 6- Peyğəmbərin <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> həyatını oxumaq və Onu özünə nümunə götürmək.<br /> 7- Yaxşı insanlarla dostluq etmək, pis insanlardan uzaq olmaq. </p>',
      ],
    ],
    8 => [
      0 => [
        'question' => 'Sual 1: Zikrin fəziləti nədir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14630.mp3',
        'answer' => '<p> Cavab: Peyğəmbər <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> buyurur: "Rəbbini zikr edənlə zikr etməyənin məsəli, diri ilə ölünün məsəlinə bənzəyər". Hədisi əl-Buxari rəvayət etmişdir.<br /> Çünki insan həyatının qimyəti, onun Uca Rəbbini zikr etdiyi miqdarı qədərdir. </p>',
      ],
      1 => [
        'question' => 'Sual 2: Zikrin bəzi faydalarını söylə.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14670.mp3',
        'answer' => '<p> Cavab: 1- ər-Rəhman Olan Allahın razılığı qazanılır.<br /> 2- Şeytanı qovur.<br /> 3- Müsəlmanı şərlərdən qoruyur.<br /> 4- Çoxlu əcr və savab hasil olur. </p>',
      ],
      2 => [
        'question' => 'Sual 3: Ən əfzəl zikr hansıdır?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14730.mp3',
        'answer' => '<p> Cavab: <span class="c3">«لا إله إلا الله»</span> <span class="c5">[Lə iləhə illə-l-lahu]</span> "Allah­dan başqa ibadətə layiq haqq məbud yoxdur". Hədisi ət-Tirmizi və İbn Məca rəvayət etmişdir. </p>',
      ],
      3 => [
        'question' => 'Sual 4: Yuxudan oyanarkən nə deyirsən?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14760.mp3',
        'answer' => '<p> Cavab: <span class="c3">«الحمد لله الذي أحيانا بعدما أماتنا وإليه النشور»</span> <span class="c5">[Əlhəmdulilləhi-l-ləzi əhyənə bədə mə əmətənə və ileyhi-n-nuşur]</span> "Bizi öldürdükdən sonra dirildən Allaha həmd olsun. <span class="c2">(Ölüb dirildikdən sonra isə)</span> qayı­dış Onadır". Hədisi əl-Buxari və Müslim rəvayət etmişdir. </p>',
      ],
      4 => [
        'question' => 'Sual 5: Paltarını geyinərkən nə deyirsən?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14790.mp3',
        'answer' => '<p> Cavab: <span class="c3">«الحمد لله الذي كساني هذا الثوب ورزقنيه من غير حول مني ولا قوة»</span> [Əlhəmdulilləhi-l-ləzi kəsəni həzə <span class="c2">(əs soubə)</span> va razəqanihi min ğayri havlin minni va lə quvvətin] "Bunu <span class="c2">(bu paltarı)</span> mənə geyindirən və özüm heç bir qüdrət və güc sərf etmədən onu mənə bəxş edən Allaha həmd olsun!". Hədisi Əbu Davud, ət-Tirmizi və başqaları rəvayət etmişdir. </p>',
      ],
      5 => [
        'question' => 'Sual 6: Paltarı çıxartdığın zaman nə deyirsən?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14820.mp3',
        'answer' => '<p> Cavab: <span class="c3">«بسم الله»</span> <span class="c5">[Bismilləh]</span> "Allahın adı ilə!". Hədisi ət-Tirmizi rəvayət etmişdir. </p>',
      ],
      6 => [
        'question' => 'Sual 7: Təzə paltar geyinərkən edilən dua hansıdır:',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14850.mp3',
        'answer' => '<p> Cavab: <span class="c3">«اللهم لك الحمد أنت كسوتنيه، أسألك خيره وخير ما صنع له، وأعوذ بك من شره وشر ما صنع له»</span> <span class="c5">[Allahummə, ləkə-l-həmdu əntə kə­sovtənihi, əs\'əlukə min xayrihi va xayri mə sunia ləhu va əuzu bikə min şərrihi va şərri mə sunia ləhu]</span> "Allahım, Həmd Sənədir! Bunu mənə Sən geyindirdin. Onun xeyrini və onun istifadə­si­nin xeyrini Səndən dilə­yirik! Onun şərindən və onun istifadəsinin şərindən Sənə sığınırıq!". Hədisi Əbu Davud və ət-Tirmizi rəvayət etmişdir. </p>',
      ],
      7 => [
        'question' => 'Sual 8: Təzə paltar geyinən üçün edilən dua hansıdır?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14880.mp3',
        'answer' => '<p> Cavab: Təzə paltar geyinən bir kimsə gördükdə onun üçün dua edib,<span class="c6"> belə deyirsən:</span> <span class="c3">«تُبْلِي ويُخلف الله تعالى»</span> <span class="c5">[Tubli və yuxlifullahu təalə]</span> "<span class="c2">(Bunu)</span> köhnəldəsən, Uca Allah da yeni­sini versin!". Hədisi Əbu Davud rəvayət etmişdir. </p>',
      ],
      8 => [
        'question' => 'Sual 9: Ayaqyoluna girərkən edilən dua hansıdır?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14910.mp3',
        'answer' => '<p> Cavab: <span class="c3">«اللهم إني أعوذ بك من الخبث والخبائث»</span> <span class="c5">[Allahummə inni əuzu bikə minə-l-xubsi va-l-xabəis]</span> "Allahım, pislikdən və pis əməllərdən <span class="c2">(erkək və dişi cinlərdən)</span> Sənə sığınıram!". Hədisi əl-Buxari və Müslim rəvayət etmişdir. </p>',
      ],
      9 => [
        'question' => 'Sual 10: Ayaqyolundan çıxarkən edilən dua hansıdır?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14940.mp3',
        'answer' => '<p> Cavab: <span class="c3">«غفرانك»</span> <span class="c5">[Ğufranəkə]</span> "<span class="c2">(Allahım!)</span> Məni bağışla!". Hədisi Əbu Davud və ət-Tirmizi rəvayət etmişdir. </p>',
      ],
      10 => [
        'question' => 'Sual 11: Dəstəmazdan öncə nə deyirsən?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/14970.mp3',
        'answer' => '<p> Cavab: <span class="c3">«بسم الله»</span> <span class="c5">[Bismilləh]</span> "Allahın adı ilə!". Hədisi Əbu Davud və başqaları rəvayət etmişdir. </p>',
      ],
      11 => [
        'question' => 'Sual 12: Dəstəmazdan sonra edilən zikr hansıdır?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15000.mp3',
        'answer' => '<p> Cavab: <span class="c3">«أشهد أن لا إله إلا الله وحده لا شريك له، وأشهد أن محمدا عبده ورسوله»</span> <span class="c5">[Əşhədu ən lə iləhə illəllahu vahdəhu lə şərikə ləhu va əşhədu ənnə Muhəmmədən abduhu va Rasuluhu]</span> "Mən şahidlik edirəm ki, Allahdan başqa ibadətə layiq haqq məbud yox­dur, O təkdir, Onun şəri­ki yoxdur və şahid­lik edirəm ki, Muhəm­məd Onun qulu və elçisi­dir!". Bu hədisi Müslim rəvayət etmişdir. </p>',
      ],
      12 => [
        'question' => 'Sual 13: Evdən çıxarkən edilən zikr hansıdır?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15020.mp3',
        'answer' => '<p> Cavab: <span class="c3">«بسم الله، توكلت على الله، ولا حول ولا قوة إلا بالله»</span> <span class="c5">[Bismilləh, təvakkəltu aləllahi va lə havlə va lə quvvatə illə billəhi]</span> "Allahın adı ilə! Allaha təvəkkül etdim. Qüdrət və güc yalnız Allahdadir!". Hədisi Əbu Davud və ət-Tirmizi rəvayət etmişdir. </p>',
      ],
      13 => [
        'question' => 'Sual 14: Evə daxil olarkən edilən zikr hansıdır?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15050.mp3',
        'answer' => '<p> Cavab: <span class="c3">«بسم الله ولجنا، وبسم الله خرجنا، وعلى الله ربنا توكلنا»</span> <span class="c5">[Bismilləhi valəcnə va bismilləhi xaracnə va alə Rabbinə təvakkəlnə]</span> "Allahın adı ilə girdik, Allahın adı ilə çıxdıq və Rəb­bimizə təvəkkül etdik!" <span class="c2">(Bu zikri etdikdən)</span> sonra <span class="c2">(evə daxil olan şəxs)</span> ailəsinə salam versin". Hədisi Əbu Davud rəvayət etmişdir. </p>',
      ],
      14 => [
        'question' => 'Sual 15: Məscidə daxil olarkən edilən dua hansıdır?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15080.mp3',
        'answer' => '<p> Cavab: <span class="c3">«اللهم افتح لي أبواب رحمتك»</span> <span class="c5">[Allahumməftəh liy əbvabə rahmətikə]</span> "Allahım! Öz mərhəmət qapılarını mənim üçün aç!". Hədisi Müslim rəvayət etmişdir. </p>',
      ],
      15 => [
        'question' => 'Sual 16: Məsciddən çıxarkən edilən duanı zikr et!',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15110.mp3',
        'answer' => '<p> Cavab: <span class="c3">«اللهم إني أسألك من فضلك»</span> <span class="c5">[Allahummə inni əsəlukə min fadlıkə]</span> "Allahım! Sənin lütfündən di­ləyirəm". Hədisi Müslim rəvayət etmişdir. </p>',
      ],
      16 => [
        'question' => 'Sual 17: Azan səsini eşitdikdə nə deyirsən?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15140.mp3',
        'answer' => '<p> Cavab: Azan səsini eşitdikdə müəzzinin dedikləri təkrarlayıram.<span class="c6"> Yalnız:</span> <span class="c3">«حي على الصلاة»</span> و<span class="c3">«حي على الفلاح»</span> <span class="c5">[Hayyə alə-s-saləti! Hayyə alə-l-fələhi]</span> "Namaza tələsin!», <span class="c3">«Nicat tapmağa tələsin!" sözlərinin əvəzinə: «لا حول ولا قوة إلا بالله»</span> <span class="c5">[Lə həulə va lə quvvətə illə billəhi]</span> "Qüdrət və güc yalnız Allahdadir!» deyirəm. Hədisi əl-Buxari və Müslim rəvayət etmişdir. </p>',
      ],
      17 => [
        'question' => 'Sual 18: Azan bitdikdən sonra nə deyirsən?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15170.mp3',
        'answer' => '<p> Cavab: Peyğəmbərə <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> sala­vat gətirirəm. Bu hədisi Müslim rəvayət etmişdir. və <span class="c3">«اللهم رب هذه الدعوة التامة، والصلاة القـائـمـة، آت محـمـدًا الـوسـيلة والفـضـيلـة، وابـعثه مقامًا محمودًا الذي وعدته»</span> <span class="c5">[Allahummə Rabbə həzihi-d-də\'vati-t-təmməti va-s-saləti-l qaiməti əti Muhəmmədəni-l-vasilətə va-l-fadılətə, vəbashu məqa­mən məhmudəni-l-ləzi va\'adtəhu]</span> "Bu tam dəvətin və qılınacaq namazın Rəbbi olan Allahım! Muhəmmədə vasitəçilik haqqı və fəzilət ver. Onu vəd etdiyin təriflənən mə­qama çatdır" deyirəm. Hədisi əl-Buxari rəvayət etmişdir.<br /> Azanla iqamə arasında dua edirəm. Çünki azanla iqamə arasında edilən dua geri çevrilməz. </p>',
      ],
      18 => [
        'question' => 'Sual 19: Səhər və axşam zikrlərdən hansılarını edirsən?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15220.mp3',
        'answer' => '<p> Cavab: 1-<span class="c6"> Kürsü ayəsini oxuyuram:</span> <span class="c3">«اللَّهُ لَا إِلَهَ إِلَّا هُوَ الْحَيُّ الْقَيُّومُ لَا تَأْخُذُهُ سِنَةٌ وَلَا نَوْمٌ لَهُ مَا فِي السَّمَاوَاتِ وَمَا فِي الْأَرْضِ مَنْ ذَا الَّذِي يَشْفَعُ عِنْدَهُ إِلَّا بِإِذْنِهِ يَعْلَمُ مَا بَيْنَ أَيْدِيهِمْ وَمَا خَلْفَهُمْ وَلَا يُحِيطُونَ بِشَيْءٍ مِنْ عِلْمِهِ إِلَّا بِمَا شَاءَ وَسِعَ كُرْسِيُّهُ السَّمَاوَاتِ وَالْأَرْضَ وَلَا يَئُودُهُ حِفْظُهُمَا وَهُوَ الْعَلِيُّ الْعَظِيمُ»</span> <span class="c5">[Allahu lə iləhə illə huva-l-hayyu-l-Qayyum lə təxuzuhu sinətun va lə naum ləhu mə fi-s-səməvati va mə fi-l-ardı mən zə-l-ləzi yəşfəu indəhu illə bi iznihi yaləmu mə beynə əydihim va mə xalfəhum va lə yuhıtunə bişeyin min ilmihi illə bimə şəə vasia kursiyyuhu-s-səməvati va-l-ardı va lə yəuduhu hıfzıhumə va huva-l-Aliyyul-Azım]</span> ﴾Allah, Ondan başqa ilah yoxdur, <span class="c2">(əbədi)</span> Yaşayandır, <span class="c2">(bütün yaratdıqlarının)</span> Qəyyumudur. Onu nə mürgü, nə də yuxu tutar. Göylərdə və yerdə nə varsa, Ona məxsusdur. Onun izni olmadan Onun yanında kim havadarlıq edə bilər? O, <span class="c2">(məxluqatın)</span> gələcəyini və keçmişini bilir. Onlar Onun elmindən, Onun istədiyindən başqa heç bir şey qavraya bilməzlər. Onun Kürsüsü göyləri və yeri əhatə edir. Bunları qoruyub saxlamaq Ona ağır gəlmir. O, Ucadır, Uludur﴿. <span class="c2">(əl-Bəqərə surəsi,<span class="c6"> ayə:</span> 255)</span>. <span class="c3">«بسم الله الرحمن الرحيم»</span> <span class="c5">[Bismilləhi-r-rahmənir-rahim]</span> ﴾Mərhəmətli və Rəhmli Allahın adı ilə﴿. 1- <span class="c3">«قُلْ هُوَ اللَّهُ أَحَدٌ»</span> <span class="c5">[Qul huvallahu əhəd]</span> ﴾De: <span class="c1">“O Allah Təkdir!﴿. 2- <span class="c3">«اللَّهُ الصَّمَدُ»</span> <span class="c5">[Allahu-s-saməd]</span> ﴾Allah Möhtac deyildir﴿. 3- <span class="c3">«لَمْ يَلِدْ وَلَمْ يُولَدْ»</span> <span class="c5">[Ləm yəlid valəm yuləd]</span> ﴾O, nə doğub, nə doğulub,﴿. 4- <span class="c3">«وَلَمْ يَكُنْ لَهُ كُفُوًا أَحَدٌ»</span> <span class="c5">[Valəm yəkun ləhu kufuvan əhəd]</span> ﴾Onun bənzəri də yoxdur”</span>﴿. Üç dəfə. <span class="c3">«بسم الله الرحمن الرحيم»</span> <span class="c5">[Bismilləhi-r-rahmənir-rahim]</span> ﴾Mərhəmətli və Rəhmli Allahın adı ilə﴿. 1- <span class="c3">«قُلْ أَعُوذُ بِرَبِّ الْفَلَقِ»</span> <span class="c5">[Qul əuzu birabbi-l-fələq]</span> ﴾De: Sığınıram sübhün Rəb­binə!﴿ 2- <span class="c3">«مِنْ شَرِّ مَا خَلَقَ»</span> <span class="c5">[Min şərri mə xaləq]</span> ﴾Məxluqatının şərindən﴿ 3- <span class="c3">«وَمِنْ شَرِّ غَاسِقٍ إِذَا وَقَبَ»</span> <span class="c5">[Vamin şərri ğasiqin izə vaqab]</span> ﴾Çökən zülmətin şərindən﴿ 4- <span class="c3">«وَمِنْ شَرِّ النَّفَّاثَاتِ فِي الْعُقَدِ»</span> <span class="c5">[Vamin şərri-n-nəffəsəti fi-l-uqad]</span> ﴾Düyünlərə üfürən <span class="c2">(cadugər)</span> qa­dın­la­rın şərindən﴿ 5- <span class="c3">«وَمِنْ شَرِّ حَاسِدٍ إِذَا حَسَدَ»</span> <span class="c5">[Vamin şərri həsidin izə həsəd]</span> ﴾Və həsəd apardığı zaman pa­xı­lın şə­rindən!﴿ Üç dəfə. <span class="c3">«بسم الله الرحمن الرحيم»</span> <span class="c5">[Bismilləhi-r-rahmənir-rahim]</span> ﴾Mərhəmətli və Rəhmli Allahın adı ilə﴿. 1- <span class="c3">«قُلْ أَعُوذُ بِرَبِّ النَّاسِ»</span> <span class="c5">[Qul əuzu birabbi-n-nəs]</span> ﴾De: “Sığınıram insanların Rəbbinə,﴿. 2- <span class="c3">«مَلِكِ النَّاسِ»</span> <span class="c5">[Məliki-n-nəs]</span> ﴾insanların Hökmdarına,﴿. 3- <span class="c3">«إِلَهِ النَّاسِ»</span> <span class="c5">[İləhi-n-nəs]</span> ﴾insanların məbuduna!﴿. 4- <span class="c3">«مِنْ شَرِّ الْوَسْوَاسِ الْخَنَّاسِ»</span> <span class="c5">[Min şərri-l-vasvasi-l-xannəs]</span> ﴾Vəsvəsə verənin, <span class="c2">(Allahın adı çəkiləndə isə hövlündən)</span> geri çəkilən <span class="c2">(şeytanın)</span> şərindən﴿. 5- <span class="c3">«الَّذِي يُوَسْوِسُ فِي صُدُورِ النَّاسِ»</span> <span class="c5">[Əlləzi yuvasvisu fi suduri-n-nas]</span> ﴾<span class="c2">(O şeytan)</span> ki, insanların ürəklərinə vəsvəsə salır,﴿. 6- <span class="c3">«مِنَ الْجِنَّةِ وَالنَّاسِ»</span> <span class="c5">[Minə-l-cinnəti va-n-nəs]</span> ﴾cinlərdən də <span class="c2">(olur)</span>, insanlardan da!﴿. Üç dəfə. <span class="c3">«اللهم أنت ربي لا إله إلا أنت، خلقتني وأنا عبدك، وأنا على عهدك ووعدك ما استطعت، أعوذ بك من شر ما صنعت، أبوء لك بنعمتك علي، وأبوء بذنبي، فاغفر لي، فإنه لا يغفر الذنوب إلا أنت»</span> <span class="c5">[Allahummə, əntə rabbi lə iləhə illə əntə, xaləqtəni va ənə abdukə, va ənə alə ah­dikə va vadikə mə-s-tətatu, əuzu bikə min şərri mə sanə\'tu. Əbuu ləkə bini\'məti­kə aleyyə, va əbuu bizənbi. Fəğfir li fə­ innə­hu lə yəğfiru-z-zunubə illə əntə]</span> "Allahım! Sən mənim Rəbbimsən. Səndən başqa ibadətə və itaətə layiq haqq məbud yoxdur. Məni Sən yaratdın və mən Sənin qulunam. Sənə verdiyim vədi və əhdi bacardıqca yerinə yetirəcəyəm. Sənin yaratdıqlarının şərindən Sənə sığınıram. Mənə verilən neməti Sənə qaytarıram və öz günahlarımı etiraf edirəm. Məni bağışla. Səndən başqa günahları bağışlayan yoxdur!". Hədisi əl-Buxari rəvayət etmişdir. </p>',
      ],
      19 => [
        'question' => 'Sual 20: Yatmazdan öncə nə deyirsən?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15290.mp3',
        'answer' => '<p> Cavab: <span class="c3">«باسمك اللهم أموت وأحيا»</span> <span class="c5">[Bismikə, Allahummə əmutu va əhyə]</span> "Allahım! Sənin adınla ölür və dirili­rəm!". Hədisi əl-Buxari və Müslim rəvayət etmişdir. </p>',
      ],
      20 => [
        'question' => 'Sual 21: Yeməkdən əvvəl nə deyirsən?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15320.mp3',
        'answer' => '<p> Cavab: <span class="c3">«بسم الله»</span> <span class="c5">[Bismilləh]</span> "Allahın adı ilə!".<span class="c6"><br /> Əgər yeməyin əvvəlində deməyi unutsan:</span><br /> <span class="c3">«بسم الله في أوله وآخره»</span> <span class="c5">[Bismi-l-ləh fi əvvalihi va əxirihi]</span> "Əvvəlində də, axırında da Allahın adı ilə!" de. Hədisi Əbu Davud və ət-Tirmizi rəvayət etmişdir. </p>',
      ],
      21 => [
        'question' => 'Sual 22: Yeməkdən sonra hansı duanı edirsən?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15370.mp3',
        'answer' => '<p> Cavab: <span class="c3">«الحمد لله الذي أطعمني هذا، ورزقنيه، من غير حول مني ولا قوة»</span> <span class="c5">[Əlhəmdu lilləhi-l-ləzi ət\'aməni həzə va razəqanihi min ğayri havlin min­ni va lə quvvatin]</span> "Bunu mənə yedirdən və özüm heç bir qüdrət və güc sərf etmədən onu mənə bəxş edən Allaha həmd olsun!". Hədisi Əbu Davud və İbn Məca rəvayət etmişdir. </p>',
      ],
      22 => [
        'question' => 'Sual 23: Qonağın ona yemək verən üçün etdiyi dua hansıdır?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15400.mp3',
        'answer' => '<p> Cavab: <span class="c3">«اللـهم بـارك لهـم فيما رزقتهـم، واغـفر لهم وارحمهم»</span> <span class="c5">[Allahummə bərik ləhum fimə ra­zəqtəhum vəğfir ləhum vərhəmhum]</span> "Allahım! Onlara verdiyin ruzini bərəkətli et, onları bağışla və onlara rəhm et!" Bu hədisi Müslim rəvayət etmişdir. </p>',
      ],
      23 => [
        'question' => 'Sual 24: İnsan asqırdığı zaman nə deməlidir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15430.mp3',
        'answer' => '<p> Cavab: <span class="c3">«الحمد لله»</span> <span class="c5">[Əlhəmdulilləh]</span> "Allaha həmd olsun".<br /> Qardaşı və ya dostu isə,<span class="c6"> ona:</span> <span class="c3">«يرحمك الله»</span> <span class="c5">[Yərhəmukəllah]</span> "Allah sənə rəhm etsin!" deməlidir.<br /> O da, <span class="c5">[Yərhəmukəllah]</span> deyənə: <span class="c3">«يهديكم الله ويصلح بالكم»</span> <span class="c5">[Yəhdiykumullahu və yuslihu bələkum]</span> "Allah sizi doğru yola yönəltsin və işinizi avand etsin!" deməlidir. Hədisi əl-Buxari rəvayət etmişdir. </p>',
      ],
      24 => [
        'question' => 'Sual 25: Məclisdən qalxdıqda və ya məclis sona çatdıqda edilən "Məclisin kəffarəsi" duası hansıdır?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15480.mp3',
        'answer' => '<p> Cavab: "Məclisin kəffarəsi" duası aşağıdakldır: <span class="c3">«سبحانك اللهم وبحمدك، أشهد أن لا إله إلا أنت، أستغفرك وأتوب إليك»</span> <span class="c5">[Subhanəkə Allahummə və bihəm­dik, əşhədu ən lə ilahə illə ənt, əstəğfirukə və ətubu ileyk]</span> "Allahım! Sən pak və müqəddəssən! Sənə həmd olsun! Mən şahidlik edirəm ki, Sən­dən başqa ibadətə layiq məbud yoxdur. Səndən bağışlan­ma diləyir və Sənə tövbə edirəm!". Hədisi Əbu Davud, ət-Tirmizi və başqaları rəvayət etmişdir. </p>',
      ],
      25 => [
        'question' => 'Sual 26: Minik vasitəsinə minərkən edilən dua hansıdır?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15510.mp3',
        'answer' => '<p> Cavab: بسم الله، والحمد لله <span class="c4">﴿سُبْحَانَ الَّذِي سَخَّرَ لَنَا هَذَا وَمَا كُنَّا لَهُ مُقْرِنِينَ. وَإِنَّا إِلَى رَبِّنَا لَمُنْقَلِبُونَ﴾</span>، <span class="c3">«الحمد لله، الحمد لله، الحمد لله، الله أكبر، الله أكبر، الله أكبر، سبحانك اللهم إني ظلمت نفسي فاغفر لي؛ فإنه لا يغفر الذنوب إلا أنت»</span> <span class="c5">[Bismilləh. Əlhəmdulilləh. Subha­nəl-ləzi səxxara lənə həzə və mə kunnə lə­hu muqrinin. Və innə ilə Rabbinə ləmun­qalibun. Əlhəmdulilləh, əlhəmdulilləh, əl­həmdulilləh. Allahu Əkbər, Allahu Əkbər, Allahu Əkbər. Subhanəkə Allahummə in­niy zaləmtu nəfsiy fəğfir liy, fəinnəhu lə yəğfiruz-zunubə illə ənt]</span> "Allahın adı ilə! Allaha həmd olsun! ﴾Bunu bizə tabe edən <span class="c5">[Allah]</span> pak və müqəd­dəsdir. <span class="c5">[Yoxsa]</span> bizim ona gücümüz çat­mazdı. Şübhəsiz ki, biz Rəbbimi­zə qayıdacağıq﴿. Allaha həmd olsun! Allaha həmd olsun! Allaha həmd olsun! Allah ən Böyükdür, Allah ən Böyükdür, Allah ən Böyükdür. Allahım, Sən pak və müqəddəssən! Mən özümə zülm etdim. Məni bağışla! Şübhəsiz ki, günahları ancaq Sən bağışlayırsan". Hədisi Əbu Davud və ət-Tirmizi rəvayət etmişdir. </p>',
      ],
      26 => [
        'question' => 'Sual 27: Səfər duasını zikr et!',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15540.mp3',
        'answer' => '<p> Cavab: الله أكبر، الله أكبر، الله أكبر <span class="c4">﴿سُبْحَانَ الَّذِي سَخَّرَ لَنَا هَذَا وَمَا كُنَّا لَهُ مُقْرِنِينَ. وَإِنَّا إِلَى رَبِّنَا لَمُنْقَلِبُونَ﴾</span>، اللهم إنا نسألك في سفرنا هذا البر والتقوى ومن العمل ما ترضى، اللهم هون علينا سفرنا هذا، واطو عنا بعده، اللهم أنت الصاحب في السفر، والخليفة في الأهل، اللهم إني أعوذ بك من وعثاء السفر، وكآبة المنظر، وسوء المنقلب، في المال والأهل» <span class="c5">[Allahu Əkbər, Allahu Əkbər, Allahu Əkbər. ﴾Subhanəl-ləzi səxxara lənə həzə və mə kunnə ləhu muqrinin. Və innə ilə Rabbinə ləmunqalibun﴿ Alla­hummə in­nə nəs­əlukə fi səfərinə həzə əl-birra vət-təqva, və minəl aməli mə tərda. Allahum­mə həvvin aleynə səfəranə həzə vətvi an­nə budəhu. Allahummə əntəs-sahibu fis-səfəri vəl-xaliyfətu fil-əhli. Allahummə inniy əuzu bikə min vəsais-səfəri və kə­a­bətil-mənzari və suil-munqaləbi fil-mali vəl-əhl]</span> "Allah ən Böyükdür, Allah ən Böyük­dür, Allah ən Böyükdür. <span class="c3">«Bunu bizə tabe edən <span class="c5">[Allah]</span> pak və müqəd­dəsdir. <span class="c5">[Yoxsa]</span> bizim ona gücümüz çat­mazdı. Şübhəsiz ki, biz Rəb­bimi­zə qayıdacağıq»</span>. Allahım! Bu səfərimiz­də Səndən yaxşı­lıq, Allah qorxusu və razı qalaca­ğın əməl diləyirik. Alla­hım! Bu səfərimizi bi­zim üçün rahat et və onun uzaq­lığını bizə ya­xın et. Allahım! Səfərdə dost və ailə­miz üçün hami Sənsən. Allahım! Səfərin ağırlığın­dan, məyus edən mənzərədən, malda və ailədə xo­şa­gəl­məz dəyişik­likdən Sənə pənah aparıram".<br /> Səfərdən qayıdanda isə,<span class="c6"> həmin duanı oxuyub aşağıdakı sözləri də buna əlavə etmək lazım­dır:</span><br /> <span class="c3">«آيبون، تائبون، عابدون، لربنا حامدون»</span> <span class="c5">[Ayibunə, taibunə, abidunə, li Rabbinə hamidun]</span> "<span class="c2">(Biz)</span> geri dönənlər, tövbə edənlər, ibadət edənlər, Rəbbimizə həmd edənlərik!". Bu hədisi Müslim rəvayət etmişdir. </p>',
      ],
      27 => [
        'question' => 'Sual 28: Vidalaşdıqda müsafirin sakinlər üçün etdiyi dua hansıdır?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15590.mp3',
        'answer' => '<p> Cavab: <span class="c3">«أستودعكم الله الذي لا تضيع ودائعه»</span> <span class="c5">[Əstəudiukumu-llahəl-ləzi lə tə­dıyu vədaiuhu]</span> "Sizi <span class="c2">(Özünə həvalə edilmiş)</span> əmanətləri itməyən Allaha əmanət edirəm!". Hədisi ət-Tirmizi və İbn Məca rəvayət etmişdir. </p>',
      ],
      28 => [
        'question' => 'Sual 29: Vidalaşdıqda sakinlərin müsafir üçün etdiyi dua hansıdır?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15620.mp3',
        'answer' => '<p> Cavab: <span class="c3">«أستودع الله دينك، وأمانتك، وخواتيم عملك»</span> <span class="c5">[Əstəudiu-llahə diynəkə və əmanə­təkə və xavatiymə aməlikə]</span> "Sənin dinini, sədaqətini və əməllərinin aqibətini Allaha əmanət edirəm!". Hədisi İmam Əhməd, ət-Tirmizi və başqaları rəvayət etmişdir. </p>',
      ],
      29 => [
        'question' => 'Sual 15: Bazara girərkən edilən dua hansıdır?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15650.mp3',
        'answer' => '<p> Cavab: <span class="c3">«لا إله إلا الله وحده لا شريك له، له الملك، وله الحمد، يحيي ويميت، وهو حي لا يموت، بيده الخير، وهو على كل شيء قدير»</span> <span class="c5">[Lə ilahə illəllahu vəhdahu lə şəri­kə ləhu, ləhul-mulku və ləhul-həmdu, yuhyi və yumiytu və huvə həyyun lə yə­mutu, biyədi­hil-xayru və huvə alə kulli şeyin qadir]</span> "Allahdan başqa haqq məbud yoxdur, O tək­dir, Onun şəri­ki yoxdur. Mülk Onundur və həmd Onadır! Dirildir və öldürür. O, diridir və ölməzdir. Xeyir onun əlindədir və O hər şeyə Qadirdir!". Hədisi ət-Tirmizi və İbn Məca rəvayət etmişdir. </p>',
      ],
      30 => [
        'question' => 'Sual 31: Qəzəbləndikdə deyilən duanı zikr et!',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15680.mp3',
        'answer' => '<p> Cavab: <span class="c3">«أعوذ بالله من الشيطان الرجيم»</span> <span class="c5">[Əuzu billəhi minəş-şeytanir-ra­cim]</span> "Lənətlənmiş şeytandan Allaha sığını­ram!". Hədisi əl-Buxari və Müslim rəvayət etmişdir. </p>',
      ],
      31 => [
        'question' => 'Sual 32: Sənə yaxşılıq edən şəxsə necə dua edirsən?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15710.mp3',
        'answer' => '<p> Cavab: <span class="c3">«جزاك الله خيرا»</span> <span class="c5">[Cəzakəllahu xayran]</span> "Allah səni xeyirlə mükafatlandırsın!". Hədisi ət-Tirmizi rəvayət etmişdir. </p>',
      ],
      32 => [
        'question' => 'Sual 33: Minik vasitəsi büdrədikdə edilən dua hansıdır?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15740.mp3',
        'answer' => '<p> Cavab: <span class="c3">«بسم الله»</span> <span class="c5">[Bismilləh]</span> "Allahın adı ilə!". Hədisi Əbu Davud rəvayət etmişdir. </p>',
      ],
      33 => [
        'question' => 'Sual 34: Sevindirici hal ilə rastlaşdıqda nə deyirsən?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15770.mp3',
        'answer' => '<p> Cavab:<span class="c3">«الحمد لله الذي بنعمته تتم الصالحات»</span> <span class="c5">[Əlhəmdu-lilləhil-ləzi bini\'mətihi tətim­mus-salihat]</span> "Neməti sayəsində yaxşı işlər tamamlanan Allaha həmd olsun!". Hədisi Hakim və başqaları rəvayət etmişdir. </p>',
      ],
      34 => [
        'question' => 'Sual 35: Xoşagəlməyən hadisə ilə rastlaşdıqda nə deyirsən?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15800.mp3',
        'answer' => '<p> Cavab: <span class="c3">«الحمد لله على كل حال»</span> <span class="c5">[Əlhəmdulilləhi alə kulli hal]</span> "Hər bir halda Allaha həmd olsun!". Səhihul-Cəmi. </p>',
      ],
      35 => [
        'question' => 'Sual 36: Salam vermək və salam qaytarmaq qaydası necədir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15830.mp3',
        'answer' => '<p> Cavab: Müsəlman deyir: <span class="c3">«السَّلَامُ عَلَيْكُمْ وَرَحْمَةُ اللَّهِ وَبَرَكَاتُهُ»</span> <span class="c5">[Əssələmu aleykum va rahmətullahi va bərakətuhu]</span> "Allahın salamı, rəhməti və bərəkəti sizin üzərinizə olsun!".<span class="c6"><br /> Qardaşı da ona cavab verərək buyurur:</span> <span class="c3">«وَعَلَيْكُمُ السَّلَامُ وَرَحْمَةُ اللهِ وَبَرَكَاتُهُ»</span> <span class="c5">[Va aleykum-s-sələm və rahmətullahi va bərakətuhu]</span> "Sizin də üzərinizə Allahın salamı, rəhməti və bərəkəti olsun!". Hədisi Əbu Davud, ət-Tirmizi və başqaları rəvayət etmişdir. </p>',
      ],
      36 => [
        'question' => 'Sual 37: Yağış yağarkən edilən dua hansıdır?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15870.mp3',
        'answer' => '<p> Cavab: <span class="c3">«اللهم صيباً نافعاً»</span> <span class="c5">[Allahummə sayyibən nafi\'an]</span> "Allahım! <span class="c2">(Bu yağışı)</span> bol, faydalı et!". Hədisi əl-Buxari rəvayət etmişdir. </p>',
      ],
      37 => [
        'question' => 'Sual 38: Yağış yağdıqdan sonra edilən dua hansıdır?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15900.mp3',
        'answer' => '<p> Cavab: <span class="c3">«مطرنا بفضل الله ورحمته»</span> <span class="c5">[Mutirnə bi fadli-l-ləhi va rahmətihi]</span> "Allahın lütfü və mərhəməti ilə bizə yağmur endirildi". əl-Buxari və Müslim. </p>',
      ],
      38 => [
        'question' => 'Sual 39: Külək əsərkən edilən dua zikr et!',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15930.mp3',
        'answer' => '<p> Cavab: <span class="c3">«اللهم إني أسألك خيرها وأعوذ بك من شرها»</span> <span class="c5">[Allahummə inniy əs\'əlukə xayrahə və əuzu bikə min şərrihə]</span> "Allahım! Səndən onun <span class="c2">(küləyin)</span> xeyri­ni diləyirəm və onun şərindən Sənə sığını­ram!". Hədisi Əbu Davud və İbn Məca rəvayət etmişdir. </p>',
      ],
      39 => [
        'question' => 'Sual 40: Göy guruldayarkən edilən dua hansıdır?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15960.mp3',
        'answer' => '<p> Cavab: <span class="c3">«سبحان الذي يسبح الرعد بحمده والملائكة من خيفته»</span> <span class="c5">[Subhənə-l-ləzi yusəbbihu-r-r\'adu bi­həmdihi va-l-mələikətu min xiyfətihi]</span> "Göy gurultusunun həmd edərək, məl­əklərin isə qorxusundan şəninə təriflər dediyi <span class="c2">(Allah)</span> pak və müqəddəsdir!". Hədisi İmam Malik "Muvatta" kitabında rəvayət etmişdir. </p>',
      ],
      40 => [
        'question' => 'Sual 41: Müsibətə düçar olmuş kimsəni görərkən edilən dua hansıdır?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/15990.mp3',
        'answer' => '<p> Cavab: <span class="c3">«الحمد لله الذي عافاني مما ابتلاك به، وفضلني على كثيراً ممن خلق تفضيلاً»</span> <span class="c5">[Əlhəmdu lilləhi-lləzi afəniy mim­məbtəlakə bihi və fəddaləniy alə kəsiyrin mimmən xaləqa təfdiylən]</span> "Sənə üz vermiş müsibətdən məni sala­mat edən və məni yaratdıqlarının çoxun­dan fə­zilətli edərək üstün tutan Allaha həmd olsun!". Hədisi ət-Tirmizi rəvayət etmişdir. </p>',
      ],
      41 => [
        'question' => 'Sual 42: Özünün göz dəyməsi ilə bir kimsəyə zərər toxunmasından qorxan kimsə hansı duanı oxumalıdır?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16020.mp3',
        'answer' => '<p> Cavab: Peyğəmbər <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> demişdir: "Sizdən biriniz qardaşında, özündə yaxud malında xoşuna gəldiyi bir şey gördüyü zaman onun mübarəkli olması üçün dua etsin <span class="c2">(maşallah, Bərəkallah kimi sözlər söyləsin)</span>. Cünki göz dəyməsi haqqdır". Hədisi İmam Əhməd, İbn Məcə və başqları rəvayət etmişdir. </p>',
      ],
      42 => [
        'question' => 'Sual 43: Peyğəmbərə (Allahın salavatı və salamı onun üzərinə olsun) necə salavat oxuyursan?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16050.mp3',
        'answer' => '<p> Cavab: Peyğəmbərə <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> salavat aşağıdakı kimi oxuyuram: <span class="c3">«اللَّهُمَّ صَلِّ عَلَى مُحَمَّدٍ وَعَلَى آلِ مُحَمَّدٍ، كَمَا صَلَّيْتَ عَلَى إِبْرَاهِيمَ، وَعَلَى آلِ إِبْرَاهِيمَ، إِنَّكَ حَمِيدٌ مَجِيدٌ، اللَّهُمَّ بَارِكْ عَلَى مُحَمَّدٍ وَعَلَى آلِ مُحَمَّدٍ، كَمَا بَارَكْتَ عَلَى إِبْرَاهِيمَ، وَعَلَى آلِ إِبْرَاهِيمَ إِنَّكَ حَمِيدٌ مَجِيدٌ»</span> <span class="c5">[Allahummə salli alə Muhəmmədin va alə əəli Muhəmməd, kəmə salleytə alə İbra­himə va alə əəli İbrahimə, innəkə həmi­dun məcid. Allahummə bərik alə Muhəm­mədin va alə əəli Muhəmməd, kəmə bərak­tə alə İbrahimə va alə əəli İbrahimə, innəkə həmidun məcid]</span> "Allahım! İbrahimə və İbrahimin ailə­sinə xeyir-dua verdiyin kimi, Muhəmmədə və Muhəmmədin ailəsinə də xeyir-dua ver! Şüb­həsiz ki, Sən Tərifəlayiqsən, Şan-şöh­rətlisən! Allahım! İbrahimə və İbrahimin ailəsinə bərə­kət verdiyin kimi, Muhəmmədə və Muhəmmə­din ailəsinə də bərəkət ver! Şübhəsiz ki, Sən Tərifəlayiqsən, Şan-şöh­rətlisən!". Hədisi əl-Buxari və Müslim rəvayət etmişdir. </p>',
      ],
    ],
    9 => [
      0 => [
        'question' => 'Sual 1: Beş təklifi hökm hansılardır?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16090.mp3',
        'answer' => '<p> Cavab:<br /> 1- Vacib.<br /> 2- Müstəhəb.<br /> 3- Haram.<br /> 4- Məkruh.<br /> 5- Mübah. </p>',
      ],
      1 => [
        'question' => 'Sual 2: Beş təklifi hökmü şərh et.',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16170.mp3',
        'answer' => '<p> Cavab:<br /> 1- Vacib.<span class="c6"> Buna misal:</span> Beş vaxt namaz, ramazan orucu, valideyinlərə yaxşılıq etmək.<br /> - Vacibin hökmü. Vacibi edən kimsə savab, tərk edən kimsə isə günah qazanır.<br /> 2- Müstəhəb.<span class="c6"> Buna misal:</span> Fərz namazlardan əvvəl və sonra qılınan ratibə olan sünnət namazları, gecə namazları, yemək yedizdirmək və salam vermək. Bunlara həm sünnət, həm də məndub deyilir.<br /> - Müstəhəbin hökmü. Müstəhəbi edən kimsə savab qazanır, tərk edən kimsə isə günah qazanmır.<span class="c6"><br /> Mühüm qeyd:</span><br /> Müsəlman bir kimsə şəri əhkamlardan hər hansı bir əməlin sünnət və ya müstəhəb olduğunu eşitdikdə, bu zaman o, Peyğəmbərə <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> tabe olaraq o əməli etməyə tələsməlidir.<br /> 3- Haram.<span class="c6"> Buna misal:</span> Spirtli içki içmək, valideyinlərin üzünə ağ olmaq və qohumluq əlqələrini kəsmək.<br /> - Haramın hökmü. Haramı tərk edən kimsə savab, edən kimsə isə günah qazanır.<br /> 4- Məkruh.<span class="c6"> Buna misal:</span> Sol əl ilə almaq-vermək və namazda paltarı qatlamaq.<br /> -<span class="c6"> Məkruhun hökmü:</span> Məkruhu tərk edən kimsə savab qazanır, məkruhu edən kimsə isə günah qazanmır.<br /> 5- Mübah.<span class="c6"> Buna misal:</span> Alma yemək, çay içmək. Bunlara həm caiz, həm də halal deyilir.<br /> -<span class="c6"> Mübahın hökmü:</span> Mübahı tərk edən savab, edən isə, günah qazanmır. </p>',
      ],
      2 => [
        'question' => 'Sual 3: Alış-verişin və müamilələrin hökmü nədir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16320.mp3',
        'answer' => '<p> Cavab: Uca Allahın bəzi haram etdiyi alış-veriş və müamilələr müstəsna olmaqla, hər bir alış-verişin və müamilələrin əsli halaldır.<span class="c6"><br /> Uca Allah buyurur:</span> ﴾Allah alış-verişi halal, sələmçiliyi isə haram etmişdir﴿. <span class="c2">(əl-Bəqərə surəsi,<span class="c6"> ayə:</span> 275)</span>. </p>',
      ],
      3 => [
        'question' => 'Sual 4: Bəzi haram olan alış-verişlərin və müamilələrin növlərini zikr et!',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16360.mp3',
        'answer' => '<p> Cavab:<br /> 1- Aldatmaq. Bura həmçinin müştəridən malın eyibini gizlətmək də daxildir.<br /> Əbu Hureyrə <span class="c2">(Allah ondan razı olsun)</span> rəvayət edir ki, Peyğəmbər <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> bazarda bir buğda yığımının yanından keçərkən əlini o buğda yığımının içinə saldı. Peyğəmbərin <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> barmaqları yaş olduqda: "Ey buğda sahibi bu nədir?"- deyə soruşdu.<span class="c6"> Buğda sahibi də:</span> "Ey Allahın Elçisi yağışa görə islanmışdır"- deyə cavab verdi. Peyğəmbər <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> ona: "İslanmış buğdanı insanların görmələri üçün üstə qoya bilməzdin? Bizi aldatan bizdən deyildir"- dedi. Bu hədisi Müslim rəvayət etmişdir.<br /> 2- Sələm <span class="c2">(faiz)</span> almaq. Bura həmçinin bir insandan min dinar borc alıb, iki min dinar qaytarmaq da daxildir.<br /> Qaytardıqda artıq verilən pul, haram olunan sələmdir.<span class="c6"><br /> Uca Allah buyurur:</span> ﴾Allah alış-verişi halal, sələmçiliyi isə haram etmişdir﴿. <span class="c2">(əl-Bəqərə surəsi,<span class="c6"> ayə:</span> 275)</span>.<br /> 3- Aldanmaq və cəhalət. Bura qoyunun sağılmamış südünü satmaq, ovlanmamış, suda üzən balığı satmaqda daxildir.<br /> Peyğəmbərin <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> "Əldə olmayan malı satmağı qadağan etmişdir". Bu hədisi Müslim rəvayət etmişdir. </p>',
      ],
      4 => [
        'question' => 'Sual 5: Allahın sənə bəxş etdiyi bəzi nemətlərini zikr et!',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16460.mp3',
        'answer' => '<p> Cavab: 1- İslam neməti və sənin küfr əhlindən olmamağın.<br /> 2- Sünnət neməti və sənin bidət əhlindən olmamağın.<br /> 3- Eşitmək, görmək, gəzmək və s. bu kimi, sağlam səhhət və can sağlığı neməti.<br /> 4- Yemək, içmək və libas neməti.<br /> Uca Allahın üzərimizdə olan nemətləri çoxdur və bu nemətlərin saydıqca qurtarmaz.<span class="c6"><br /> Uca Allah buyurur:</span> ﴾Əgər Allahın nemətlə­ri­ni saymalı olsanız, onları sa­yıb qur­ta­ra bil­məz­si­niz. Həqi­qə­tən, Allah Bağışlayandır, Rəhm­­li­dir﴿. <span class="c2">(ən-Nəhl surəsi,<span class="c6"> ayə:</span> 18)</span>. </p>',
      ],
      5 => [
        'question' => 'Sual 6: Bizə bəxş edilən nemətlərə görə üzərimizə vacib olan nədir və bu nemətlərə görə Uca Allaha necə şükür etməliyik?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16540.mp3',
        'answer' => '<p> Cavab: Bizə bəxş edilən nemətlərə görə üzərimizə vacib olan, dil ilə yalnız Uca Allaha həmd-sənalar və şükür etmək və bu nemətləri Uca Allaha asiliklərdə deyil, əksinə, Onun sevib razı qaldığı yerlərə sərf etməkdir. </p>',
      ],
      6 => [
        'question' => 'Sual 7: Müsəlmanların bayramları hansılardır?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16570.mp3',
        'answer' => '<p> Cavab: Ramazan bayramı və Qurban bayramı.<br /> Ənəs bin Malik <span class="c2">(Allah ondan razı olsun)</span> rəvayət edir ki, Peyğəmbər <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> Mədinəyə gəldikdə Mədinə əhlinin əylənib oynadıqları iki günləri vardı. Peyğəmbər <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span>: "Bu nə iki gündür?" deyə soruşdu.<span class="c6"> Onlar:</span> Biz cahiliyyə dövründə bu iki gündə əylənirdik dedilər. Bunun üzərinə Peyğəmbər <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span>: "Şüphəsiz ki, Allah sizə bu iki günün yerinə daha xeyirlisini, Qurban ve Fitr günlərini <span class="c2">(Qurban və Ramazan Bayramlarını)</span> verdi" buyurdu. Hədisi Əbu Davud rəvayət etmişdir.<br /> Bu iki bayramdan başqa olan bayramlar bidət bayramlardır. </p>',
      ],
      7 => [
        'question' => 'Sual 8: Ayların ən fəzilətlisi hansıdır?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16620.mp3',
        'answer' => '<p> Cavab: Ramazan ayı. </p>',
      ],
      8 => [
        'question' => 'Sual 9: Günlərin ən fəzilətlisi hansıdır?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16650.mp3',
        'answer' => '<p> Cavab: Cümə günü. </p>',
      ],
      9 => [
        'question' => 'Sual 10: İlin ən fəzilətli günü hansıdır?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16680.mp3',
        'answer' => '<p> Cavab: Ərafa günü. </p>',
      ],
      10 => [
        'question' => 'Sual 11: İlin ən fəzilətli gecəsi hansıdır?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16710.mp3',
        'answer' => '<p> Cavab: Qədir gecəsi. </p>',
      ],
      11 => [
        'question' => 'Sual 12: Əcnəbi qadınla rastlaşdıqda vacib olan nədir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16740.mp3',
        'answer' => '<p> Cavab: Əcnəbi qadınla rastlaşdıqda vacib olan, gözü qadına baxmaqdan qorumaqdır.<span class="c6"> Bu barədə Uca Allah belə buyurur:</span> ﴾Mömin kişilərə de ki, <span class="c2">(harama baxmayıb)</span> gözlərini aşağı diksinlər﴿. <span class="c2">(ən-Nur surəsi,<span class="c6"> ayə:</span> 30)</span>. </p>',
      ],
      12 => [
        'question' => 'Sual 13: İnsanın düşmənləri kimlərdir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16770.mp3',
        'answer' => '<p> Cavab: 1- Pislikləri əmr edən nəfs. Bu, insanın, Uca Allaha ası olmaqda nəfsinin istəklərinə və öz havasına tabe olduqda baş verir.<span class="c6"> Uca Allah bu barədə belə buyurur:</span> ﴾Rəbbimin rəhm etdiyi kəs istisna olmaqla, nəfs <span class="c2">(adama)</span> pis işləri əmr edər. Həqiqətən, Rəbbim Bağışlayandır, Rəhm­­lidir﴿. <span class="c2">(Yusuf surəsi,<span class="c6"> ayə:</span> 53)</span>. 2- Şeytan - Adəm övladının düşmənidir. Onun məqsədi - insanı azdırmaq, şər işlərdə ona vəsvəsə vermək və onu Cəhənnəmə salmaqdır.<span class="c6"> Uca Allah bu barədə belə buyurur:</span> ﴾Şeytanın addım izləri ilə getməyin! O, sizin açıq-aşkar düşməninizdir﴿. <span class="c2">(əl-Bəqərə surəsi,<span class="c6"> ayə:</span> 168)</span>. 3-<span class="c6"> Pis yoldaşlar:</span> O kəslərdir ki, insanı şər əməllərə təhrik edir və xeyir əməllərə mane olur.<span class="c6"> Uca Allah buyurur:</span> ﴾O gün müttəqilərdən başqa <span class="c2">(bütün)</span> dostlar bir-birinə düşmən kəsiləcəklər﴿. <span class="c2">(əz-Zuxruf surəsi,<span class="c6"> ayə:</span> 67)</span>. </p>',
      ],
      13 => [
        'question' => 'Sual 14: Tövbə nədir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16820.mp3',
        'answer' => '<p> Cavab: Tövbə, Uca Allaha qarşı asilik etməkdən əl çəkib, Uca Allahın itaətinə qayıtmaqdır.<span class="c6"> Uca Allah buyurur:</span> ﴾Mən, həqiqətən də, tövbə edib, iman gətirib yaxşı işlər görən, sonra da doğru yolu tutanları bağışlayıram﴿. <span class="c2">(Ta ha surəsi,<span class="c6"> ayə:</span> 82)</span>. </p>',
      ],
      14 => [
        'question' => 'Sual 15: Düzgün tövbənin şərtləri hansılardır?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16850.mp3',
        'answer' => '<p> Cavab: 1- Günahı tərk etmək.<br /> 2- Etdiklərindən peşman olmaq.<br /> 3- Gələcəkdə bir daha həmin günaha qayıtmayacağına qətiyyətlə əzm etmək.<br /> 4- Haqq sahiblərinin və zülm etdiyi kimsələrin haqqlarını qaytarmaq.<span class="c6"><br /> Uca Allah buyurur:</span> ﴾O kəslər ki, bir pis iş gördükdə, yaxud özlərinə zülm etdikdə Allahı xatırlayıb günahlarının bağışlanmasını diləyərlər, – günahları Allahdan başqa kim bağışlaya bilər? – onlar bilə-bilə etdiklərinə görə israr etməzlər﴿. <span class="c2">(Ali-İmran surəsi,<span class="c6"> ayə:</span> 135)</span>. </p>',
      ],
      15 => [
        'question' => 'Sual 16: Peyğəmbərə (Allahın salavatı və salamı onun üzərinə olsun) salavat gətirmək sözünün mənası nədir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16920.mp3',
        'answer' => '<p> Cavab: Peyğəmbərə <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> salavat gətirmək sözünün mənası, sənin, Uca Allaha, Peyğəmbəri <span class="c2">(Allahın salavatı və salamı onun üzərinə olsun)</span> ali səmada mələklər yanında öyüb tərifləməsi üçün dua etməyindir. </p>',
      ],
      16 => [
        'question' => 'Sual 17: «سبحان الله» [Sübhənallah] sözünün mənası nədir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16950.mp3',
        'answer' => '<p> Cavab: <span class="c3">«سبحان الله»</span> <span class="c5">[Sübhənallah]</span> sözünün mənası, Uca Allahın bütün naqislik və eyib sifətlərdən uzaq və uca olmasıdır. </p>',
      ],
      17 => [
        'question' => 'Sual 18: «الحمد لله» [Əlhəmdulilləh] sözünün mənası nədir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/16980.mp3',
        'answer' => '<p> Cavab: Mənası: Uca Allaha həmd-sənalar etmək və Onu bütün kamillik sifətləri ilə vəsf etməkdir. </p>',
      ],
      18 => [
        'question' => 'Sual 19: «الله أكبر» [Allahu Əkbər] sözünün mənası nədir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/17000.mp3',
        'answer' => '<p> Cavab: Yəni: Pak Olan Allahın hər bir şeydən böyük olduğu, Onun hər bir şeydən əzəmətli və hər bir şeydən izzətli olduğu deməkdir. </p>',
      ],
      19 => [
        'question' => 'Sual 20: «لا حول ولا قوة إلا بالله» [Lə haulə va lə quvvatə illə billəh] sözünün mənası nədir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/17030.mp3',
        'answer' => '<p> Cavab: Onun mənası: qul, Allahın güc və qüvvəti olmadan, ozünü bir haldan başqa bir hala əsla dəyişə bilməz. </p>',
      ],
      20 => [
        'question' => 'Sual 21: «أستغفر الله» [Əstəğfirullah] sözünün mənası, nədir?',
        'audio' => 'https://kids.islamenc.com/assets/audios/ar/17060.mp3',
        'answer' => '<p> Cavab: Yəni: Qulun, Uca Rəbbindən onun günahlarının silinməsini və Ondan eyiblərinin üstünü örtməsini diləməsidir. </p>',
      ],
    ],
  ],
];
