<?php
$data = [
    'title' => 'What Muslim Children Must Know',
    'description' => 'A project that contains a simple and easy curriculum for issues that a Muslim must know. It includes issues of belief, jurisprudence, prophetic biography, etiquette, tafsir, hadith, morals, and remembrance of Allah. It is suitable for young children in particular, for all ages, and newcomers to Islam.',
    'source' => 'https://kids.islamenc.com/bn/home',
    'author' => 'Yazan Abdul Razzaq Raziq Alghanim',
    'sections' => [
        0 => 'আকীদাহ অংশ',
        1 => 'ফিকহ অংশ',
        2 => 'সীরাতে নববী (নবীর জীবনচরিত) অংশ',
        3 => 'তাফসীর অংশ',
        4 => 'হাদীস অংশ',
        5 => 'ইসলামী আদব (শিষ্টাচার) অংশ',
        6 => 'আখলাক (চরিত্র) অংশ',
        7 => 'দু‘আ ও যিকিরসমগ্র অংশ',
        8 => 'বিবিধ অংশ',
    ],
    'data' => [
        1 => [
            0 => [
                'question' => 'প্রশ্ন ১: তোমার রব কে?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/200.mp3',
                'answer' => '<p> উত্তর: আমার রব আল্লাহ,<span class="c6"> যিনি আমাকে এবং সমগ্র জগতকে তাঁর নি‘আমাত দ্বারা প্রতিপালন করেন।<br /> এর দলীল :</span> আল্লাহ তা‘আলার বাণী: الْحَمْدُ لِلَّهِ رَبِّ الْعَالَمِينَ <span class="c1">“আর সকল প্রশংসা আল্লাহর জন্য, যিনি সৃষ্টিকুলের রব।”</span> <span class="c5">[সূরা আল-ফাতিহা,<span class="c6"> আয়াত:</span> ০২]</span> </p>',
            ],
            1 => [
                'question' => 'প্রশ্ন ২: তোমার দীন কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/240.mp3',
                'answer' => '<p> উত্তর: আমার দীন ইসলাম। আর ইসলাম হচ্ছে: তাওহীদের সাথে আল্লাহর গোলামী করা,<span class="c6"> অনুকরণ করার মাধ্যমে তার আনুগত্য করা এবং শিরক ও মুশরিক থেকে মুক্ত থাকা।<br /> আল্লাহ তা‘আলা বলেছেন:</span> إِنَّ الدِّينَ عِنْدَ اللَّهِ الْإِسْلَامُ <span class="c1">“নিশ্চয় আল্লাহর কাছে একমাত্র মনোনীত দীন হচ্ছে ইসলাম...।”</span> <span class="c5">[সূরা আলে-ইমরান,<span class="c6"> আয়াত:</span> ১৯]</span> </p>',
            ],
            2 => [
                'question' => 'প্রশ্ন ৩: তোমার নবী কে?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/280.mp3',
                'answer' => '<p> উত্তর: আমার নবী মুহাম্মাদ সাল্লাল্লাহু আলাইহি ওয়াসাল্লাম।<br /> আল্লাহ তা‘আলা বলেছেন: مُّحَمَّدٌ رَّسُولُ ٱللَّهِۚ <span class="c1">“মুহাম্মাদ আল্লাহর রাসূল...”</span> <span class="c5">[সূরা আল-ফাতহ,<span class="c6"> আয়াত:</span> ২৯]</span> </p>',
            ],
            3 => [
                'question' => 'প্রশ্ন ৪: তাওহীদের কালিমাটি উল্লেখ কর। এবং এর অর্থ কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/310.mp3',
                'answer' => '<p> উত্তর: তাওহীদের কালিমা হচ্ছে: لا إله إلا الله বা আল্লাহ ব্যতীত কোনো প্রকৃত ইলাহ নেই,<span class="c6"> এ কথার অর্থ:</span> আল্লাহ ছাড়া প্রকৃত কোন মা‘বূদ নেই।<br /> আল্লাহ তা‘আলা বলেছেন: فَاعْلَمْ أَنَّهُ لَا إِلَهَ إِلَّا اللَّهُ <span class="c1">“জেনে রেখ, আল্লাহ্ ব্যতীত অন্য কোন সত্য মাবুদ নেই...।”</span> <span class="c5">[সূরা মুহাম্মাদ,<span class="c6"> আয়াত:</span> ১৯]</span> </p>',
            ],
            4 => [
                'question' => 'প্রশ্ন ৫: আল্লাহ (‘আয্যা ওয়া জাল্লা) কোথায়?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/350.mp3',
                'answer' => '<p> উত্তর: আল্লাহ তা‘আলা আসমানে, ‘আরশের উপরে,<span class="c6"> সকল মাখলূকাতের উপর। আল্লাহ তা‘আলা বলেছেন:</span> الرَّحْمَنُ عَلَى الْعَرْشِ اسْتَوَى <span class="c1">“রহমান ‘আরশের উপর উঠেছেন।”</span> <span class="c5">[সূরা ত্ব-হা,<span class="c6"> আয়াত:</span> ০৫]</span> তিনি আরও বলেছেন: وَهُوَ ٱلۡقَاهِرُ فَوۡقَ عِبَادِهِۦۚ وَهُوَ ٱلۡحَكِيمُ ٱلۡخَبِيرُ <span class="c1">“আর তিনিই আপন বান্দাদের উপর পূর্ণ নিয়ন্ত্রণকারী,আর তিনি প্রজ্ঞাময়, সম্যক অবহিত।”</span> <span class="c5">[সূরা আল-আন‘আম,<span class="c6"> আয়াত:</span> ১৮]</span> </p>',
            ],
            5 => [
                'question' => 'প্রশ্ন ৬: ‘মুহাম্মাদ আল্লাহর রসূল’ এ সাক্ষ্য প্রদানের অর্থ কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/380.mp3',
                'answer' => '<p> উত্তর: এর অর্থ: আল্লাহ তা‘আলা জগতের জন্য তাকে সুসংবাদদাতা এবং সতর্ককারী হিসেবে প্রেরণ করেছেন।<br /> সুতরাং আমাদের ওয়াজিব হবে:<br /> ১. তিনি যা আদেশ করেছেন, তার আনুগত্য করা।<br /> ২. তিনি যেসব সংবাদ দিয়েছেন, তা মনে প্রাণে বিশ্বাস করা।<br /> ৩. তার অবাধ্য না হওয়া।<br /> ৪. তিনি যা শরী‘আত সম্মত করেছেন,<span class="c6"> তার বাইরে আল্লাহর ইবাদাত না করা। আর এটি হচ্ছে:</span> সুন্নাহকে অনুসরণ ও বিদ‘আতকে বিসর্জন দেওয়ার মাধ্যমে।<br /> আল্লাহ বলেছেন: مَنْ يُطِعِ الرَّسُولَ فَقَدْ أَطَاعَ اللَّهَ <span class="c1">“যে ব্যক্তি রাসূলের আনুগত্য করে, সে আল্লাহরই আনুগত্য করবে।...”</span> <span class="c5">[সূরা আন-নিসা,<span class="c6"> আয়াত:</span> ৮০]</span>,<span class="c6"> আল্লাহ সুবহানাহু ওয়া তা‘আলা আরো বলেছেন:</span> وَمَا يَنْطِقُ عَنِ الْهَوَى 3 إِنْ هُوَ إِلَّا وَحْيٌ يُوحَى <span class="c1">“আর তিনি নিজের পক্ষ হতে কোন কথা বলেন না, তা কেবলই ওহী যা তার প্রতি প্রেরণ করা হয়েছিল।”</span> <span class="c5">[সূরা আন-নাজম,<span class="c6"> আয়াত:</span> ৩-৪]</span> আল্লাহ জাল্লা শানুহু বলেছেন: لَقَدْ كَانَ لَكُمْ فِي رَسُولِ اللَّهِ أُسْوَةٌ حَسَنَةٌ لِمَنْ كَانَ يَرْجُو اللَّهَ وَالْيَوْمَ الْآخِرَ وَذَكَرَ اللَّهَ كَثِيرًا <span class="c1">“অবশ্যই তোমাদের জন্য রাসূলুল্লাহর মধ্যে রয়েছে উত্তম আদর্শ, তাদের জন্য যারা আল্লাহ ও পরকাল প্রত্যাশা করে এবং আল্লাহকে অধিক স্মরণ করে।”</span> <span class="c5">[সূরা আল-আহযাব,<span class="c6"> আয়াত:</span> ২১]</span> </p>',
            ],
            6 => [
                'question' => 'প্রশ্ন ৭: আল্লাহ তা‘আলা আমাদেরকে কেন সৃষ্টি করেছেন?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/480.mp3',
                'answer' => '<p> উত্তর: আমাদেরকে তিনি শুধুমাত্র তাঁর ইবাদাতের জন্য সৃষ্টি করেছেন, তাঁর কোন শরীক নেই।<br /> খেল-<span class="c6">তামাশার জন্য নয়।<br /> আল্লাহ তা‘আলা বলেছেন:</span> وَمَا خَلَقْتُ الْجِنَّ وَالْإِنْسَ إِلَّا لِيَعْبُدُونِ <span class="c1">“আমি সৃষ্টি করেছি জিন এবং মানুষকে এজন্যেই যে, তারা কেবল আমার ইবাদাত করবে।”</span> <span class="c5">[সূরা আয-যারিয়াত,<span class="c6"> আয়াত:</span> ৫৬]</span> </p>',
            ],
            7 => [
                'question' => 'প্রশ্ন ৮: ইবাদত কাকে বলে?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/530.mp3',
                'answer' => '<p> উত্তর: প্রকাশ্য ও গোপনীয় যে সব আমল ও কথাকে আল্লাহ ভালোবাসেন এবং যার প্রতি আল্লাহ খুশি হন,<span class="c6"> তার সামগ্রীক নাম।<br /> প্রকাশ্য ইবাদত:</span> যেমন: তাসবীহ, তাকবীর ও তাহমীদের মাধ্যমে মুখ দিয়ে আল্লাহর যিকির করা,<span class="c6"> সালাত আদায় করা এবং হজ করা।<br /> গোপনীয় ইবাদত:</span> যেমন: তাওয়াক্কুল, ভয় করা এবং আশা করা। </p>',
            ],
            8 => [
                'question' => 'প্রশ্ন ৯: আমাদের ওপর মহা দায়িত্ব কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/580.mp3',
                'answer' => '<p> উত্তর: আমাদের ওপর মহা দায়িত্ব হচ্ছে: আল্লাহ তা‘আলার তাওহীদ। </p>',
            ],
            9 => [
                'question' => 'প্রশ্ন ১০: তাওহীদের প্রকারগুলো কী কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/610.mp3',
                'answer' => '<p> উত্তর: ১) তাওহীদুর রুবূবিয়্যাহ: আর তা হলো এ কথার বিশ্বাস করা যে, আল্লাহ তা‘আলাই সৃষ্টিকর্তা, রিযিকদাতা, মালিক এবং পরিচালক, তিনি একক,<span class="c6"> তার কোন শরীক নেই।<br /> ২) তাওহীদুল উলূহিয়্যাহ:</span> আর তা হলো ইবাদাতে আল্লাহকে একক গণ্য করা,<span class="c6"> সুতরাং আল্লাহ তা‘আলা ছাড়া অন্য কারো ইবাদাত করা যাবে না।<br /> ৩) তাওহীদুল আসমা ওয়াস সিফাত:</span> আর তা হলো: কোন ধরণের নমুনা নির্ধারণ,<span class="c6"> সাদৃশ্য প্রদান ও নিষ্ক্রিয়করণ ব্যতীত কুরআন ও সুন্নাহতে আগত আল্লাহ তা‘আলার নামসমূহ ও গুণাবলীর প্রতি ঈমান আনা।<br /> তিন প্রকার তাওহীদের দলীল:</span> আল্লাহ তা‘আলার বাণী: رَّبُّ ٱلسَّمَـوَ ⁠تِ وَٱلۡأَرۡضِ وَمَا بَيۡنَهُمَا فَٱعۡبُدۡهُ وَٱصۡطَبِرۡ لِعِبَـدَتِهِۦۚ هَلۡ تَعۡلَمُ لَهُۥ سَمِيًّا <span class="c1">“তিনি আসমানসমূহ, যমীন ও তাদের অন্তর্বর্তী যা কিছু আছে, সে সবের রব। কাজেই তাঁরই ইবাদাত করুন এবং তাঁর ইবাদাতে ধৈর্যশীল থাকুন, আপনি কি তাঁর সমনাম ও গুণ সম্পন্ন কাউকেও জানেন?”</span> <span class="c5">[সূরা মারইয়াম,<span class="c6"> আয়াত:</span> ৬৫]</span> </p>',
            ],
            10 => [
                'question' => 'প্রশ্ন ১১: সবচেয়ে মারাত্মক গোনাহ কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/670.mp3',
                'answer' => '<p> উত্তর: আল্লাহ তা‘আলার সাথে শিরক করা।<br /> আল্লাহ তা‘আলা বলেছেন: إِنَّ اللَّهَ لَا يَغْفِرُ أَنْ يُشْرَكَ بِهِ وَيَغْفِرُ مَا دُونَ ذَلِكَ لِمَنْ يَشَاءُ وَمَنْ يُشْرِكْ بِاللَّهِ فَقَدِ افْتَرَى إِثْمًا عَظِيمًا <span class="c1">“নিশ্চয় আল্লাহ তাঁর সাথে শরীক করাকে ক্ষমা করেন না। তিনি ক্ষমা করেন এ ছাড়া অন্যান্য পাপ, যার জন্য তিনি চান। আর যে আল্লাহর সাথে শরীক করে সে অবশ্যই মহাপাপ রটনা করে।”</span> <span class="c5">[সূরা আন-নিসা,<span class="c6"> আয়াত:</span> ৪৮]</span> </p>',
            ],
            11 => [
                'question' => 'প্রশ্ন ১২: শিরক ও তার প্রকাগুলো কি? বল।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/710.mp3',
                'answer' => '<p> উত্তর: শিরক হচ্ছে: ইবাদতের প্রকারসমূহ যে কোন একটি ইবাদত গাইরুল্লাহর জন্য করা।<br /> শিরকের প্রকারভেদ:<br /> শিরকে আকবার <span class="c2">(বড় শিরক)</span>: যেমন: আল্লাহ তা‘আলা ছাড়া অন্য ডাকা, আল্লাহ সুবাহানাহু ওয়া তা‘আলা ছাড়া অন্যকে সিজদাহ করা অথবা আল্লাহ আয্যা ও জাল্লা ছাড়া অন্য কারো উদ্দেশ্যে যবাই করা।<br /> শিরকে আসগার <span class="c2">(ছোট শিরক)</span>: যেমন: আল্লাহ ব্যতীত অন্য কারো নামে শপথ করা, তামীমাহ <span class="c2">(তাবিজ)</span> ঝুলানো, অর্থাৎ, কল্যাণ লাভ বা অকল্যাণ প্রতিরোধে মানুষ যে সব বস্তু ঝুলায়।আর সামান্য লৌকিকতা <span class="c2">(রিয়া)</span>,<span class="c6"> যেমন:</span> কোন ব্যক্তি তার সালাতকে সুন্দর করে, এ কারণে যে মানুষ তার দিক তাকাচ্ছে। </p>',
            ],
            12 => [
                'question' => 'প্রশ্ন ১৩: আল্লাহ তা‘আলা ব্যতীত আর কেউ কী গায়েব (অদৃশ্যের খবর) জানে?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/770.mp3',
                'answer' => '<p> উত্তর: একমাত্র আল্লাহ তা‘আলা ব্যতীত আর কেউই গায়েব <span class="c2">(অদৃশ্যের খবর)</span> জানে না।<br /> আল্লাহ তা‘আলা বলেছেন: قُل لَّا يَعۡلَمُ مَن فِي ٱلسَّمَـوَ ⁠تِ وَٱلۡأَرۡضِ ٱلۡغَيۡبَ إِلَّا ٱللَّهُۚ وَمَا يَشۡعُرُونَ أَيَّانَ يُبۡعَثُونَ “বলুন! ‘আল্লাহ্ ব্যতীত আসমান ও জমিনের কেউই গায়েব জানে না এবং তারা উপলব্ধিও করেনা কখন তাদেরকে উত্থিত করা হবে।’ <span class="c5">[সূরা আন-নামল,<span class="c6"> আয়াত:</span> ৬৫]</span> </p>',
            ],
            13 => [
                'question' => 'প্রশ্ন ১৪: ঈমানের রুকনসমূহ কয়টি?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/810.mp3',
                'answer' => '<p> উত্তর: ১. আল্লাহ তা‘আলার প্রতি ঈমান।<br /> ২. তাঁর ফিরিশতাগণের প্রতি ঈমান।<br /> ৩. তাঁর <span class="c2">(আসমানী)</span> কিতাবসমূহের প্রতি ঈমান।<br /> ৪. তাঁর রাসূলগণের প্রতি ঈমান।<br /> ৫. আখিরাত বা শেষ দিবসের প্রতি ঈমান।<br /> ৬.<span class="c6"> তাকদীরের ভালো ও মন্দের প্রতি ঈমান আনা।<br /> দলীল:</span> ইমাম মুসলিম বর্ণিত হাদীসে জিবরীল <span class="c2">(আলাইহিস সালাম)</span>,<span class="c6"> যেখানে জিবরীল নবী সাল্লাল্লাহু আলাইহি ওয়াসাল্লামকে জিজ্ঞাসা করেছিলেন:</span> <span class="c3">«فَأَخْبِرْنِي عَنِ الْإِيمَانِ،<span class="c6"> قَالَ:</span> أَنْ تُؤْمِنَ بِاللهِ، وَمَلَائِكَتِهِ، وَكُتُبِهِ، وَرُسُلِهِ، وَالْيَوْمِ الْآخِرِ، وَتُؤْمِنَ بِالْقَدَرِ خَيْرِهِ وَشَرِّهِ»</span>.<br /> <span class="c1">“আপনি ঈমান সম্পর্কে আমাকে সংবাদ দিন। তখন তিনি বললেন: ‘তুমি আল্লাহর প্রতি, তাঁর মালায়েকা, কিতাবসমূহ, রাসূলগণ, আখিরাত দিবস ও তাকদীরের ভালো-মন্দের প্রতি ঈমান আনবে।”</span> </p>',
            ],
            14 => [
                'question' => 'প্রশ্ন ১৫: ঈমানের রুকনগুলোর ব্যাখ্যা কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/900.mp3',
                'answer' => '<p> উত্তর: আল্লাহ তা‘আলার প্রতি ঈমান আনা:<br /> তুমি এ কথা বিশ্বাস করবে যে, আল্লাহ তা‘আলাই তোমাকে সৃষ্টি করেছেন, তিনিই তোমাকে রিযিক দিয়েছেন। আর তিনিই সমস্ত মাখলূকের একমাত্র <span class="c2">(একচ্ছত্র)</span> মালিক ও মহাপরিচালক।<br /> আর তিনিই মা‘বূদ <span class="c2">(উপাস্য)</span>, তিনি ছাড়া কোন প্রকৃত মা‘বূদ নেই।<br /> আর তিনিই বড় মহান,<span class="c6"> পরিপূর্ণ যার জন্যই সকল প্রশংসা। তাঁর রয়েছে সুন্দর নামসমূহ ও সুউচ্চ সিফাত বা গুণাবলী। তাঁর কোন সমকক্ষ নেই এবং কোন কিছুই তাঁর সমতুল্য নয়। তিনি পবিত্র।<br /> ফিরিশগণের প্রতি ঈমান:</span><br /> ফিরিশতাগণ সৃষ্ট। আল্লাহ তা‘আলা তাদেরকে নূর থেকে সৃষ্টি করেছেন, তাঁর ইবাদাত করা ও আদেশের পরিপূর্ণ আনুগত্য করার জন্য।<br /> - তাদের মধ্যে অন্যতম জিবরীল আলাইহিস সালাম,<span class="c6"> যিনি নবীদের নিকট অহী নিয়ে অবতরণ করেন।<br /> কিতাবসমূহের প্রতি ঈমান:</span><br /> যে কিতাবগুলো আল্লাহ তাঁর রাসূলগণের ওপর নাযিল করেছেন।<br /> -<span class="c6"> যেমন:</span> কুরআন: মুহাম্মাদ সাল্লাল্লাহু আলাইহি ওয়াসাল্লামের ওপর।<br /> -<span class="c6"> ইনজিল:</span> ঈসা আলাইহিস সালামের উপর।<br /> -<span class="c6"> তাওরাত:</span> মূসা আলাইহিস সালামের উপরে।<br /> -<span class="c6"> যাবূর:</span> দাঊদ আলাইহিস সালামের উপরে।<br /> সুহুফে ইবরাহীম এবং মূসা: ইবরাহীম ও মূসা আলাইহিমাস সালামের উপর।<br /> রাসূলগণের প্রতি ঈমান:<br /> তারা হচ্ছেন যাদেরকে আল্লাহ তা‘আলা তাঁর বান্দাদের নিকট প্রেরণ করেছেন, তাদের শিক্ষা দেওয়া, জান্নাত ও কল্যাণের সুসংবাদ দেওয়া এবং তাদেরকে মন্দ ও জাহান্নাম থেকে সতর্ক করার জন্য।<br /> -<span class="c6"> নবীদের অন্যতম হচ্ছেন:</span> উলুল ‘আঝম প্রত্যয়ীগণ <span class="c2">(দৃঢ় সিদ্ধান্তে অধিকারী)</span>,<span class="c6"> তারা হচ্ছেন:</span><br /> নূহ আলাইহিস সালাম,<br /> ইবরাহীম আলাইহিস সালাম,<br /> মূসা আলাইহিস সালাম,<br /> ঈসা আলাইহিস সালাম,<span class="c6"><br /> এবং মুহাম্মাদ সাল্লাল্লাহু আলাইহি ওয়া সাল্লাম।<br /> আখিরাত দিবসের প্রতি ঈমান:</span><br /> এটি হচ্ছে: মৃত্যুর পর কবরে, কিয়ামাতের দিবসে এবং পুনরুত্থান ও হিসাবের দিবসে যা হবে,<span class="c6"> সেখানে জান্নাতীগণ তাদের স্থানে আর জাহান্নামীগণ জাহান্নামে তাদের স্থানে অবস্থান করবে।<br /> তাকাদীরের ভালো ও মন্দের প্রতি ঈমান আনা:</span><br /> তাকদীর: এটি হচ্ছে এ ব্যাপারে দৃঢ় বিশ্বাস করা যে, বিশ্বজগতে ঘটিত সবকিছু আল্লাহ জানেন, আর তিনি তা লাউহে মাহফূযে লিখে রেখেছেন,<span class="c6"> আর তিনি সেগুলোকে অস্তিত্বে আনা এবং সৃষ্টি করাকে চেয়েছেন।<br /> আল্লাহ তা‘আলা বলেছেন:</span> إِنَّا كُلَّ شَيْءٍ خَلَقۡنَـٰهُ بِقَدَر <span class="c1">“নিশ্চয় আমরা প্ৰত্যেক কিছু সৃষ্টি করেছি নির্ধারিত পরিমাপে।”</span> <span class="c5">[সূরা আল-ক্বমার,<span class="c6"> আয়াত:</span> ৪৯]</span>।<br /> -<span class="c6"> তাকদীরের প্রতি ঈমানের চারটি স্তর রয়েছে:</span><br /> প্রথম স্তর: আল্লাহ তা‘আলার ইলম: এর মধ্যে রয়েছে -<span class="c6"> প্রতিটি বস্তু অস্তিত্বশীল হওয়ার আগে এবং পরে উক্ত বস্তু সম্পর্কে আল্লাহ তা‘আলার পূর্ব জ্ঞান।<br /> এর দলীল আল্লাহ তা‘আলার বাণী:</span> إِنَّ اللَّهَ عِنْدَهُ عِلْمُ السَّاعَةِ وَيُنَزِّلُ الْغَيْثَ وَيَعْلَمُ مَا فِي الْأَرْحَامِ وَمَا تَدْرِي نَفْسٌ مَاذَا تَكْسِبُ غَدًا وَمَا تَدْرِي نَفْسٌ بِأَيِّ أَرْضٍ تَمُوتُ إِنَّ اللَّهَ عَلِيمٌ خَبِيرٌ <span class="c1">“নিশ্চয় আল্লাহর নিকট কিয়ামাতের জ্ঞান রয়েছে। আর তিনি বৃষ্টি বর্ষণ করেন এবং জরায়ূতে যা আছে, তা তিনি জানেন। আর কেউ জানে না আগামীকাল সে কী অর্জন করবে এবং কেউ জানে না কোন্ স্থানে সে মারা যাবে। নিশ্চয় আল্লাহ সর্বজ্ঞ, সম্যক অবহিত।”</span> <span class="c5">[সূরা লুকমান,<span class="c6"> আয়াত:</span> ৩৪]</span>।<br /> দ্বিতীয় স্তর: আল্লাহ তা‘আলা সেগুলোকে লাউহে মাহফূযে লিপিবদ্ধ করেছেন। সুতরাং যা কিছু ঘটেছে এবং ভবিষ্যতে ঘটবে,<span class="c6"> তা তাঁর কাছে কিতাবে লিখিত রয়েছে।<br /> এর দলীল আল্লাহ তা‘আলার বাণী:</span> وَعِنْدَهُ مَفَاتِحُ الْغَيْبِ لَا يَعْلَمُهَا إِلَّا هُوَ وَيَعْلَمُ مَا فِي الْبَرِّ وَالْبَحْرِ وَمَا تَسْقُطُ مِنْ وَرَقَةٍ إِلَّا يَعْلَمُهَا وَلَا حَبَّةٍ فِي ظُلُمَاتِ الْأَرْضِ وَلَا رَطْبٍ وَلَا يَابِسٍ إِلَّا فِي كِتَابٍ مُبِينٍ <span class="c1">“আর গায়েবের চাবি তাঁরই কাছে রয়েছে, তিনি ছাড়া অন্য কেউ তা জানে না। স্থল ও সমুদ্রের অন্ধকারসমূহে যা কিছু আছে তা তিনিই অবগত রয়েছেন, তাঁর অজানায় একটি পাতাও পড়ে না। মাটির অন্ধকারে এমন কোন শস্যকণাও অংকুরিত হয় না বা রসযুক্ত কিংবা শুষ্ক এমন কোন বস্তু নেই যা সুস্পষ্ট কিতাবে নেই।”</span> <span class="c5">[সূরা আল-আন‘আম,<span class="c6"> আয়াত:</span> ৫৯]</span><br /> তৃতীয় স্তর: প্রতিটি বস্তু আল্লাহর চাওয়াতেই সংঘটিত হয়,<span class="c6"> কোন বস্তু বা সৃষ্ট তাঁর চাওয়া ছাড়া সংঘটিত হয় না।<br /> এর দলীল আল্লাহ তা‘আলার বাণী:</span> لِمَنْ شَاءَ مِنْكُمْ أَنْ يَسْتَقِيمَ وَمَا تَشَاءُونَ إِلَّا أَنْ يَشَاءَ اللَّهُ رَبُّ الْعَالَمِينَ <span class="c1">“তোমাদের মধ্যে যে সরল পথে চলতে চায়, তার জন্য। আর তোমরা ইচ্ছে করতে পার না, যদি না সৃষ্টিকুলের রব আল্লাহ ইচ্ছে করেন।”</span> <span class="c5">[সূরা আত-<span class="c6">তাকভীর:</span> ২৮-২৯]</span><br /> চতুর্থ স্তর: এ ব্যাপারে ঈমান আনা যে, সমগ্র সৃষ্টিজগত মাখলূক, যাকে আল্লাহ তা‘আলা সৃষ্টি করেছেন। তিনি এগুলোর সত্তা, বৈশিষ্ট্য,<span class="c6"> নড়াচড়া এবং জগতের মধ্যে বিদ্যমান সব কিছুই সৃষ্টি করেছেন।<br /> এর দলীল আল্লাহ তা‘আলার বাণী:</span> وَاللَّهُ خَلَقَكُمْ وَمَا تَعْمَلُونَ <span class="c1">“অথচ আল্লাহ্ই তোমাদেরকে এবং তোমরা যা কর তা সৃষ্টি করেছেন।”</span> <span class="c5">[সূরা আস-<span class="c6">সফফাত:</span> ৯৬]</span> </p>',
            ],
            15 => [
                'question' => 'প্রশ্ন ১৬: কুরআনের পরিচয় কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1300.mp3',
                'answer' => '<p> উত্তর: এটি হচ্ছে আল্লাহ তা‘আলার কালাম,<span class="c6"> যা মাখলূক নয়।<br /> আল্লাহ তা‘আলা বলেছেন:</span> وَإِنْ أَحَدٌ مِنَ الْمُشْرِكِينَ اسْتَجَارَكَ فَأَجِرْهُ حَتَّى يَسْمَعَ كَلَامَ اللَّهِ ... <span class="c1">“আর যদি মুশরিকদের কেউ তোমার কাছে আশ্রয় চায়, তাহলে তাকে আশ্রয় দাও, যাতে সে আল্লাহর কালাম শুনতে পায়...।”</span> <span class="c5">[সূরা আত-<span class="c6">তাওবাহ:</span> ০৬]</span>। </p>',
            ],
            16 => [
                'question' => 'প্রশ্ন ১৭: সুন্নাহ কি?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1330.mp3',
                'answer' => '<p> উত্তর: সুন্নাহ হচ্ছে: নবী সাল্লাল্লাহু আলাইহি ওয়া সাল্লামের প্রতিটি কথা, কাজ, মৌন সম্মতি এবং সৃষ্টিগত ও চারিত্রিক বৈশিষ্ট্য। </p>',
            ],
            17 => [
                'question' => 'প্রশ্ন ১৮: বিদ‘আত কি? আমরা কী তা গ্রহণ করব?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1350.mp3',
                'answer' => '<p> উত্তর: দীনের মধ্যে মানুষ যা নতুন করে তৈরী করেছে; নবী সাল্লাল্লাহু আলাইহি ওয়া সাল্লাম ও সাহাবীগণের যুগে তা ছিল না, এমন প্রতিটি কাজ।<br /> *আমরা বিদ‘আতকে প্রত্যাখ্যান করব,<span class="c6"> গ্রহণ করব না।<br /> কেননা নবী আলাইহিস সালাতু ওয়াসসালাম বলেছেন:</span> كل بدعة ضلالة <span class="c1">“প্রত্যেক বিদ‘আত গোমরাহী।”</span> এটি আবূ দাঊদ বর্ণনা করেছেন।<br /> বিদ‘আতের উদাহরণ: ইবাদাতের মধ্যে কোন কিছু বৃদ্ধি করা,<span class="c6"> যেমন:</span> ওযুর মধ্যে বৃদ্ধি করা তথা: <span class="c2">(অঙ্গসমূহ)</span> চতুর্থবার ধৌত করা, নবী সাল্লাল্লাহু আলাইহি ওয়া সাল্লামের জন্মদিনে অনুষ্ঠান করা; যেহেতু এগুলো নবী সাল্লাল্লাহু আলাইহি ওয়া সাল্লাম ও তাঁর সাহাবীদের থেকে বর্ণিত নয়। </p>',
            ],
            18 => [
                'question' => 'প্রশ্ন ১৯: মিত্রতা ও শত্রুতা (الولاء والبراء) এর আকীদা বর্ণনা কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1410.mp3',
                'answer' => '<p> মিত্রতা <span class="c2">(الولاء)</span>: এটি হচ্ছে: মুমিনদেরকে ভালোবাসা এবং তাদের সহযোগিতা করা।<br /> আল্লাহ তা‘আলা বলেছেন: وَالْمُؤْمِنُونَ وَالْمُؤْمِنَاتُ بَعْضُهُمْ أَوْلِيَاءُ بَعْضٍ ... <span class="c1">“আর মুমিন পুরুষ ও মুমিন নারী একে অপরের বন্ধু...।”</span> <span class="c5">[সূরা আত-<span class="c6">তাওবাহ:</span> ৭১]</span><br /> শত্রুতা <span class="c2">(البراء)</span>: এটি হচ্ছে: কাফিরদের ঘৃণা করা এবং তাদের সাথে শত্রুতা করা।<br /> আল্লাহ তা‘আলা বলেছেন: قَدْ كَانَتْ لَكُمْ أُسْوَةٌ حَسَنَةٌ فِي إِبْرَاهِيمَ وَالَّذِينَ مَعَهُ إِذْ قَالُوا لِقَوْمِهِمْ إِنَّا بُرَآءُ مِنْكُمْ وَمِمَّا تَعْبُدُونَ مِنْ دُونِ اللَّهِ كَفَرْنَا بِكُمْ وَبَدَا بَيْنَنَا وَبَيْنَكُمُ الْعَدَاوَةُ وَالْبَغْضَاءُ أَبَدًا حَتَّى تُؤْمِنُوا بِاللَّهِ وَحْدَهُ <span class="c1">“অবশ্যই তোমাদের জন্য ইবরাহীম ও তার সাথে যারা ছিল তাদের মধ্যে রয়েছে উত্তম আদর্শ। যখন তারা তাদের সম্প্রদায়কে বলেছিল, ‘তোমাদের সঙ্গে এবং তোমরা আল্লাহর পরিবর্তে যার ‘ইবাদাত কর তা হতে আমরা সম্পর্কমুক্ত। আমরা তোমাদেরকে অস্বীকার করি। তোমাদের ও আমাদের মধ্যে সৃষ্টি হল শক্ৰতা ও বিদ্বেষ চিরকালের জন্য; যতক্ষণ না তোমরা এক আল্লাহতে ঈমান আন।”</span> <span class="c5">[সূরা আল-<span class="c6">মুমতাহিনাহ:</span> ৪]</span> </p>',
            ],
            19 => [
                'question' => 'প্রশ্ন ২০: আল্লাহ কী ইসলাম ছাড়া অন্য কোন ধর্মকে গ্রহণ করবেন?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1480.mp3',
                'answer' => '<p> উত্তর: ইসলাম ছাড়া আল্লাহ অন্য কোন দীন বা ধর্মকে গ্রহণ করবেন না।<br /> আল্লাহ তা‘আলা বলেছেন: وَمَن یَبتَغِ غَیرَ ٱلإِسلَـٰمِ دِینا فَلَن یُقبَلَ مِنهُ وَهُوَ فِی ٱلـَٔاخِرَةِ مِنَ ٱلخَـٰسِرِینَ <span class="c1">“আর কেউ ইসলাম ব্যতীত অন্য কোন দ্বীন গ্রহণ করতে চাইলে তা কখনো তার পক্ষ থেকে কবুল করা হবে না এবং সে হবে আখিরাতে ক্ষতিগ্রস্তদের অন্তর্ভুক্ত।”</span> <span class="c5">[সূরা আলে-<span class="c6">ইমরান:</span> ৮৫]</span> </p>',
            ],
            20 => [
                'question' => 'প্রশ্ন ২১: কথা, কাজ ও আকীদাহ-বিশ্বাস দ্বারা কুফর হয়, এর উদাহরণ দাও।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1520.mp3',
                'answer' => '<p> উত্তর: কথার উদাহরণ: মহাপবিত্র আল্লাহ গালি দেয়া এবং তাঁর রাসূল সাল্লাল্লাহু আলাইহি ওয়া সাল্লামকে গালি-<span class="c6">গালাজ করা।<br /> কাজের উদাহরণ:</span> <span class="c2">(কুরআনের)</span> মুসহাফকে অসম্মান করা অথবা আল্লাহ তা‘আলা ব্যতীত অন্য কাউকে সিজদাহ করা।<br /> বিশ্বাসের উদাহরণ: এমন বিশ্বাস করা যে, আল্লাহ তা‘আলা ছাড়াও কেউ ইবাদাতের উপযুক্ত রয়েছে অথবা আল্লাহ তা‘আলার সাথে অন্য কোন সৃষ্টিকর্তা আছে। </p>',
            ],
            21 => [
                'question' => 'প্রশ্ন ২২: নিফাক কি এবং এর প্রকারগুলো কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1570.mp3',
                'answer' => '<p> উত্তর:<br /> ১- বড় নিফাক <span class="c2">(النفاق الأكبر)</span>: এটি হচ্ছে: অন্তরে কুফুরী গোপন রেখে ঈমান প্রকাশ করা।<br /> আর এটি ইসলাম থেকে মানুষকে বের করে দেয়। আর এটিই একটি বড় কুফর।<br /> আল্লাহ তা‘আলা বলেছেন: إِنَّ ٱلمُنَـٰفِقِینَ فِی ٱلدَّركِ ٱلأَسفَلِ مِنَ ٱلنَّارِ وَلَن تَجِدَ لَهُم نَصِیرًا <span class="c1">“মুনাফিকরা তো জাহান্নামের নিম্নতমস্তরে থাকবে এবং তাদের জন্য আপনি কখনো কোন সহায় পাবেন না।”</span> <span class="c5">[সূরা আন-নিসা,<span class="c6"> আয়াত:</span> ১৪৫]</span><br /> ২- ছোট নিফাক <span class="c2">(النفاق الأصغر)</span>:<br /> যেমন: মিথ্যাকথা বলা, ওয়াদার খেলাফ করা এবং আমানতের খিয়ানত করা।<br /> এ ধরণের নিফাক ইসলাম থেকে বের করে দেয় না। এটি গোনাহের কাজ,<span class="c6"> আর যার মধ্যে এটি থাকবে তাকে শাস্তির সম্মুখীন হতে হবে।<br /> রাসূলুল্লাহ্ সাল্লাল্লাহু আলাইহি ওয়াসাল্লাম বলেছেন:</span> آية المنافق ثلاث: إذا حدث كذب، وإذا وعد أخلف، وإذا اؤتمن خان <span class="c1">“মুনাফিকদের নিদর্শন তিনটি : যখন সে কথা বলবে মিথ্যা বলবে, যখন সে ওয়াদা করবে ভঙ্গ করবে আর যখন তাকে আমানতদার মানা হবে খিয়ানত করবে।”</span> এটি বুখারী ও মুসলিম বর্ণনা করেছেন। </p>',
            ],
            22 => [
                'question' => 'প্রশ্ন ২৩: সর্বশেষ নবী ও রাসূল কে?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1680.mp3',
                'answer' => '<p> উত্তর: তিনি হচ্ছেন: নবী মুহাম্মাদ সাল্লাল্লাহু আলাইহি ওয়াসাল্লাম।<br /> আল্লাহ তা‘আলা বলেছেন: مَا كَانَ مُحَمَّدٌ أَبَا أَحَدٍ مِنْ رِجَالِكُمْ وَلَكِنْ رَسُولَ اللَّهِ وَخَاتَمَ النَّبِيِّينَ <span class="c1">“মুহাম্মাদ তোমাদের কোনো পুরুষের পিতা নন; তবে আল্লাহর রাসূল ও সর্বশেষ নবী। আর আল্লাহ সকল বিষয়ে সর্বজ্ঞ।”</span> <span class="c5">[সূরা আল-<span class="c6">আহযাব:</span> ৪০]</span> রাসূলুল্লাহ্ সাল্লাল্লাহু আলাইহি ওয়াসাল্লাম বলেছেন: وأنا خاتم النبيين لا نبي بعدي <span class="c1">“আমিই সর্বশেষ নবী, আমার পরে আর কোন নবী নেই।”</span> এটি আবূ দাউদ, তিরমিযী ও অন্যান্যরা বর্ণনা করেছেন। </p>',
            ],
            23 => [
                'question' => 'প্রশ্ন ২৪: মু‘জিযা কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1730.mp3',
                'answer' => '<p> উত্তর: মু‘জিযা: নবুওয়তের সত্যতা প্রমাণে আল্লাহ তা‘আলা তাঁর নবীদেরকে সাধারণ নিয়মের বাইরে যা দান করেছেন। যেমন:<br /> - নবী সাল্লাল্লাহু আলাইহি ওয়াসাল্লামকে চন্দ্র দ্বিখণ্ডিত হওয়া প্রদান করা।<br /> - মূসা আলাইহিস সালামের জন্য সমুদ্রকে বিদীর্ণ করা, ফিরআউন ও তার সহযাত্রীদেরকে ডুবিয়ে ফেলা। </p>',
            ],
            24 => [
                'question' => 'প্রশ্ন ২৫: সাহাবী কারা? আমি কী তাদেরকে ভালোবাসবো?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1780.mp3',
                'answer' => '<p> উত্তর: সাহাবী: প্রত্যেক এমন ব্যক্তি, যিনি নবী সাল্লাল্লাহু আলাইহি ওয়াসাল্লামকে তার প্রতি ঈমান অবস্থায় দেখেছেন এবং ইসলামের উপরে <span class="c2">(থাকা অবস্থায়)</span> মারা গিয়েছেন।<br /> - আমরা তাদেরকে ভালোবসাবো এবং অনুসরণ করবো,<span class="c6"> নবীগণের পরে তারাই অতি উত্তম ও সম্মানি মানুষ।<br /> তাদের মধ্যে সবচেয়ে উত্তম হচ্ছেন:</span> চার খলীফা:<br /> আবূ বাকর রাদিয়াল্লাহু ‘আনহু,<br /> উমার রাদিয়াল্লাহু আনহু,<br /> উছমান রাদিয়াল্লাহু ‘আনহু এবং<br /> আলী রাদিয়াল্লাহু ‘আনহু। </p>',
            ],
            25 => [
                'question' => 'প্রশ্ন ২৬: উম্মাহাতুল মুমিনীন (মুমিনদের মাতাগণ) কারা?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1870.mp3',
                'answer' => '<p> উত্তর: তারা নবী সাল্লাল্লাহু আলাইহি ওয়া সাল্লামের স্ত্রীগণ।<br /> আল্লাহ তা‘আলা বলেছেন: ٱلنَّبِيُّ أَوۡلَى بِٱلۡمُؤۡمِنِينَ مِنۡ أَنفُسِهِمۡۖ وَأَزۡوَجُهُۥٓ أُمَّهَتُهُمۡۗ <span class="c1">“নবী মুমিনদের কাছে তাদের নিজেদের চেয়েও ঘনিষ্টতর<span class="c2">(১)</span> এবং তার স্ত্রীগণ তাদের মা।”</span> <span class="c5">[সূরা আল-আহযাব,<span class="c6"> আহযাব:</span> ০৬]</span> </p>',
            ],
            26 => [
                'question' => 'প্রশ্ন ২৭: আমাদের উপরে নবী সাল্লাল্লাহু আলাইহি ওয়াসাল্লামের পরিবার-পরিজনের হক কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1910.mp3',
                'answer' => '<p> উত্তর: আমরা তাদের মুহাব্বাত করব, তাদের আন্তরিকভাবে গ্রহণ করব, তাদের সাথে যারা শত্রুতা করে,<span class="c6"> আমরাও তাদের সাথে শত্রুতা করব। তারা হচ্ছেন:</span> রাসূল সাল্লাল্লাহু আলাইহি ওয়াসাল্লামের স্ত্রীগণ, তার সন্তান-সন্ততি, বনূ হাশিম এবং বনূ মুত্তালিবের বংশের মুমিনগণ। </p>',
            ],
            27 => [
                'question' => 'প্রশ্ন ২৮: মুসলিমদের শাসকবৃন্দের প্রতি আমাদের কর্তব্য কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1940.mp3',
                'answer' => '<p> উত্তর: আমাদের কর্তব্য: তাদেরকে সম্মান করা, তাদের আদেশ শোনা, পাপাচারের বিষয় ব্যতীত তাদের আনুগত্য করা, তাদের বিরুদ্ধে বিদ্রোহ না করা, তাদের জন্য দু‘আ করা এবং গোপনে তাদেরকে নসীহত করা। </p>',
            ],
            28 => [
                'question' => 'প্রশ্ন ২৯: মুমিনদের স্থায়ী বাসস্থান কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1970.mp3',
                'answer' => '<p> উত্তর: মুমিনদের স্থায়ী বাসস্থান হলো জান্নাত। আল্লাহ তা‘আলা বলেছেন: إِنَّ اللَّهَ يُدْخِلُ الَّذِينَ آمَنُوا وَعَمِلُوا الصَّالِحَاتِ جَنَّاتٍ تَجْرِي مِنْ تَحْتِهَا الْأَنْهَارُ ... <span class="c1">“নিশ্চয় যারা ঈমান আনে এবং সৎকর্ম করে আল্লাহ তাদেরকে প্রবেশ করাবেন এমন জান্নাতে, যার পাদদেশে নহরসমূহ প্রবাহিত...।”</span> <span class="c5">[সূরা মুহাম্মাদ,<span class="c6">আয়াত:</span> ১২]</span> </p>',
            ],
            29 => [
                'question' => 'প্রশ্ন ২৯: কাফিরদের স্থায়ী বাসস্থান কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2000.mp3',
                'answer' => '<p> উত্তর: কাফিরদের স্থায়ী বাসস্থান জাহান্নাম। আল্লাহ তা‘আলা বলেছেন: فَاتَّقُوا النَّارَ الَّتِي وَقُودُهَا النَّاسُ وَالْحِجَارَةُ أُعِدَّتْ لِلْكَافِرِينَ <span class="c1">“সুতরাং তোমরা সে আগুন থেকে বাঁচার ব্যবস্থা কর, যার ইন্ধন হবে মানুষ ও পাথর, যা প্রস্তুত করে রাখা হয়েছে কাফেরদের জন্য।”</span> <span class="c5">[সূরা আল-বাকারাহ,<span class="c6"> আয়াত:</span> ২৪]</span> </p>',
            ],
            30 => [
                'question' => 'প্রশ্ন ২৪: ভয় কী? আশা কী? এদের দলীল কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2020.mp3',
                'answer' => '<p> উত্তর: ভয়: আল্লাহ তা‘আলাকে এবং তাঁর আযাবকে ভয় করা।<br /> আশা: এটি হচ্ছে আল্লাহর সাওয়াব,<span class="c6"> ক্ষমা ও রহমতের আশা করা।<br /> এর দলীল হলো আল্লাহ তা‘আলার বাণী:</span> أُولَئِكَ الَّذِينَ يَدْعُونَ يَبْتَغُونَ إِلَى رَبِّهِمُ الْوَسِيلَةَ أَيُّهُمْ أَقْرَبُ وَيَرْجُونَ رَحْمَتَهُ وَيَخَافُونَ عَذَابَهُ إِنَّ عَذَابَ رَبِّكَ كَانَ مَحْذُورًا <span class="c1">“তারা যাদেরকে ডাকে তারাই তো তাদের রবের নৈকট্য লাভের উপায় সন্ধান করে যে, তাদের মধ্যে কে কত নিকটতর হতে পারে, আর তারা তাঁর দয়া প্রত্যাশা করে এবং তাঁর শাস্তিকে ভয় করে। নিশ্চয় আপনার রবের শাস্তি ভয়াবহ।”</span> <span class="c5">[সূরা আল-<span class="c6">ইসরা:</span> ৫৭]</span> আল্লাহ তা‘আলা আরো বলেছেন: نَبِّئْ عِبَادِي أَنِّي أَنَا الْغَفُورُ الرَّحِيمُ 49 وَأَنَّ عَذَابِي هُوَ الْعَذَابُ الْأَلِيمُ <span class="c1">“আমার বান্দাদেরকে জানিয়ে দিন যে, নিশ্চয় আমিই পরম ক্ষমাশীল, পরম দয়ালু। আর নিশ্চয় আমার শাস্তিই যন্ত্রণাদায়ক শাস্তি।”</span> <span class="c5">[সূরা আল-<span class="c6">হিজর:</span> ৪৯-৫০]</span> </p>',
            ],
            31 => [
                'question' => 'প্রশ্ন ৩২: আল্লাহ তা‘আলার কতিপয় নাম ও সিফাত উল্লেখ কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2070.mp3',
                'answer' => '<p> উত্তর: আল্লাহ <span class="c2">(الله)</span>, রব <span class="c2">(الرب)</span>, রহমান <span class="c2">(الرحمن)</span> <span class="c2">(দয়াময়)</span>, মহাশ্রবণকারী <span class="c2">(السميع)</span>, মহাদ্রষ্টা <span class="c2">(البصير)</span>, মহাজ্ঞানী <span class="c2">(العليم)</span>, রিযিকদাতা <span class="c2">(الرزاق)</span>, চিরঞ্জীব <span class="c2">(الحي)</span>, সুমহান <span class="c2">(العظيم)</span>... এছাড়াও আল্লাহ তা‘আলার আরো সুন্দর নাম ও উচ্চ গুণাবলী রয়েছে। </p>',
            ],
            32 => [
                'question' => 'প্রশ্ন ৩৩: এ নামসমূহের ব্যাখ্যা কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2100.mp3',
                'answer' => '<p> উত্তর: আল্লাহ <span class="c2">(الله)</span>: এর অর্থ হচ্ছে: প্রকৃত উপাস্য, তিনি একক, তাঁর কোন শরীক নেই।<br /> রব <span class="c2">(الرب)</span>: তথা: সৃষ্টিকর্তা, মালিক, রিযিকদাতা ও পরিচালনাকারী তিনি একক, সুমহান সত্তা।<br /> মহাশ্রবণকারী <span class="c2">( السميع)</span>: যার শ্রবণ সব কিছুকে পরিব্যপ্ত করেছে, বিচিত্রতা ও বিভিন্নতা থাকা সত্তেও যিনি প্রতিটি শব্দই শুনেন।<br /> মহাদ্রষ্টা <span class="c2">(البصير)</span>: যিনি প্রতিটি জিনিস দেখেন, এবং প্রতিটি বস্তু ছোট হোক অথবা বড় তিনি তা প্রত্যক্ষ করেন।<br /> মহাজ্ঞানী <span class="c2">(العليم)</span>: তিনি হচ্ছেন এমন সত্তা, যার জ্ঞান অতীত, বর্তমান ও ভবিষ্যতের প্রতিটি বস্তুকেই আয়ত্ব করেছে।<br /> রহমান <span class="c2">(الرحمن)</span>: যার রহমত প্রতিটি মাখলূক ও জীবকে পরিব্যপ্ত করেছে। সুতরাং সকল বান্দা ও মাখলূক তার রহমতের আওতায়।<br /> রিযিকদাতা <span class="c2">(الرزاق)</span>: যার ওপর সমস্ত প্রাণী, মানুষ, জীন ও সমস্ত মাখলূকের রিযিকের দায়িত্ব<br /> চিরঞ্জীব <span class="c2">(الحي)</span>: এমন চিরঞ্জীব, যিনি কখনো মরবেন না। আর সমস্ত সৃষ্টি মরবে।<br /> সুমহান <span class="c2">(العظيم)</span>: যার নাম, গুণাবলী ও কর্মসমূহে রয়েছে সম্পূর্ণ পরিপূর্ণতা ও পরিপূর্ণ মহত্ব। </p>',
            ],
            33 => [
                'question' => 'প্রশ্ন ৩৪: মুসলিম আলিমদের প্রতি আমাদের কর্তব্য কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2210.mp3',
                'answer' => '<p> উত্তর: আমরা তাদের ভালোবাসবো, মাসআলা ও শরয়ী সমসাময়িক বিষয়ে তাদের শরণাপন্ন হব, তাদের ভালো দিকগুলো তুলে ধরব। আর যে এগুলো ছাড়া তাদের মন্দগুলো আলোচনা করবে,<span class="c6"> সে বিপথের ওপর আছে।<br /> আল্লাহ তা‘আলা বলেছেন:</span> يَرۡفَعِ ٱللَّهُ ٱلَّذِينَ ءَامَنُوا مِنكُمۡ وَٱلَّذِينَ أُوتُوا ٱلۡعِلۡمَ دَرَجَـٰتۚ وَٱللَّهُ بِمَا تَعۡمَلُونَ خَبِير <span class="c1">“তোমাদের মধ্যে যারা ঈমান এনেছে এবং যাদেরকে জ্ঞান দান করা হয়েছে আল্লাহ্ তাদেরকে মর্যাদায় উন্নত করবেন; আর তোমরা যা কর আল্লাহ সে সম্পর্কে সবিশেষ অবহিত।”</span> <span class="c5">[সূরা আল-মুজাদালাহ,<span class="c6"> আয়াত:</span> ১১]</span> </p>',
            ],
            34 => [
                'question' => 'প্রশ্ন ৩৫: আল্লাহর ওলী কারা?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2240.mp3',
                'answer' => '<p> উত্তর: মুমিন মুত্তাকীগণ।<br /> আল্লাহ তা‘আলা বলেছেন: أَلَا إِنَّ أَوْلِيَاءَ اللَّهِ لَا خَوْفٌ عَلَيْهِمْ وَلَا هُمْ يَحْزَنُونَ الَّذِينَ آمَنُوا وَكَانُوا يَتَّقُونَ “জেনে রাখা আল্লাহর বন্ধুদের কোন ভয় নেই এবং তারা চিন্তিতও হবে না। যারা ঈমান এনেছে এবং তাকওয়া অবলম্বন করত।“ <span class="c5">[সূরা ইউনুস,<span class="c6"> আয়াত:</span> ৬২-৬৩]</span> </p>',
            ],
            35 => [
                'question' => 'প্রশ্ন ৩৬: ঈমান কী কথা ও কাজ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2280.mp3',
                'answer' => '<p> উত্তর: ঈমান হচ্ছে কথা, কাজ ও দৃঢ় বিশ্বাস। </p>',
            ],
            36 => [
                'question' => 'প্রশ্ন ৩৭: ঈমান কী বাড়ে এবং কমে?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2310.mp3',
                'answer' => '<p> উত্তর: ঈমান নেককাজের মাধ্যমে বাড়ে এবং পাপের মাধ্যমে কমে যায়।<br /> আল্লাহ তা‘আলা বলেছেন: إِنَّمَا الْمُؤْمِنُونَ الَّذِينَ إِذَا ذُكِرَ اللَّهُ وَجِلَتْ قُلُوبُهُمْ وَإِذَا تُلِيَتْ عَلَيْهِمْ آيَاتُهُ زَادَتْهُمْ إِيمَانًا وَعَلَى رَبِّهِمْ يَتَوَكَّلُونَ <span class="c1">“মুমিন তো তারাই, যাদের অন্তরসমূহ কেঁপে উঠে যখন আল্লাহকে স্মরণ করা হয়। আর যখন তাদের উপর তাঁর আয়াতসমূহ পাঠ করা হয় তখন তা তাদের ঈমান বৃদ্ধি করে এবং যারা তাদের রবের উপরই ভরসা করে।”</span> <span class="c5">[সূরা আল-আনফাল,<span class="c6"> আয়াত:</span> ০২]</span> </p>',
            ],
            37 => [
                'question' => 'প্রশ্ন ৩৮: ইহসান কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2350.mp3',
                'answer' => '<p> উত্তর: ইহসান হচ্ছে: তুমি আল্লাহর ইবাদাত করবে, যেন তুমি তাঁকে দেখতে পাচ্ছ, তবে যদি তুমি তাঁকে দেখ, তিনি অবশ্যই তোমাকে দেখছেন। </p>',
            ],
            38 => [
                'question' => 'প্রশ্ন ৩৯: আমলসমূহ কখন আল্লাহ সুবহানাহু ওয়া তা‘আলার কাছে গ্রহণযোগ্য হয়?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2370.mp3',
                'answer' => '<p> উত্তর: দুটি শর্তে:<br /> ১- যখন আমলসমূহ শুধুমাত্র আল্লাহ তা‘আলার সন্তুষ্টির জন্য হয়।<br /> ২- আর যখন তা নবী সাল্লাল্লাহু আলাইহি ওয়াসাল্লামের সুন্নাহ অনুযায়ী হবে। </p>',
            ],
            39 => [
                'question' => 'প্রশ্ন ৪০: আল্লাহ তা‘আলার উপর তাওয়াক্কুলের অর্থ কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2420.mp3',
                'answer' => '<p> উত্তর: এর অর্থ হচ্ছে: উপকরণ গ্রহণ করার সাথে সাথে উপকার লাভ ও ক্ষতি প্রতিরোধ করাতে আল্লাহর ওপর ভরসা করা।<br /> আল্লাহ তা‘আলা বলেছেন: وَمَنْ يَتَوَكَّلْ عَلَى اللَّهِ فَهُوَ حَسْبُهُ... <span class="c1">“আর যে আল্লাহর ওপর ভরসা করে তিনিই তার জন্য যথেষ্ট...।”</span> <span class="c5">[সূরা আত-ত্বলাক,<span class="c6"> আয়াত:</span> ০৩]</span><br /> حَسْبُهُ অর্থ: كافيه তথা: যথেষ্ট। </p>',
            ],
            40 => [
                'question' => 'প্রশ্ন ৪১: সৎকাজের আদেশ ও অসৎকাজের নিষেধের ব্যাপারে দায়িত্ব কি?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2470.mp3',
                'answer' => '<p> সৎকাজ <span class="c2">(المعروف:)</span>: এটি হচ্ছে, প্রতিটি ইবাদত আল্লাহ তা‘আলার জন্য করার আদেশ। আর অসৎকাজ <span class="c2">(المنكر)</span>: এটি হচ্ছে: আল্লাহর জন্য প্রতিটি মন্দ কাজ থেকে বারণ করা।<br /> আল্লাহ তা‘আলা বলেছেন: كُنتُمۡ خَيۡرَ أُمَّةٍ أُخۡرِجَتۡ لِلنَّاسِ تَأۡمُرُونَ بِٱلۡمَعۡرُوفِ وَتَنۡهَوۡنَ عَنِ ٱلۡمُنكَرِ وَتُؤۡمِنُونَ بِٱللَّهِۗ ... <span class="c1">“তোমরাই শ্রেষ্ঠ উম্মত, মানব জাতির জন্য যাদের বের করা হয়েছে; তোমরা সৎকাজের নির্দেশ দিবে, অসৎকাজে নিষেধ করবে এবং আল্লাহর উপর ঈমান আনবে...।”</span> <span class="c5">[সূরা আলে-ইমরান,<span class="c6"> আয়াত:</span> ১১০]</span> </p>',
            ],
            41 => [
                'question' => 'প্রশ্ন ৪২: আহলুস সুন্নাহ ওয়াল জামা‘আত কারা?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2510.mp3',
                'answer' => '<p> উত্তর: তারা হচ্ছেন, কথা, কাজ ও আকীদাহর <span class="c2">(বিশ্বাসের)</span> দিক থেকে রাসূল সাল্লাল্লাহু আলাইহি ওয়াসাল্লাম ও তার সাহাবীগণ যার ওপর ছিলেন,<span class="c6"> তারা তার উপরেই থাকেন।<br /> তাদের আহলুস সুন্নাহ নামকরণ করা হয়; কারণ তারা নবী সাল্লাল্লাহু আলাইহি ওয়াসাল্লামের সুন্নাতের অনুসরণ করেন এবং বিদ‘আতকে পরিহার করেন।<br /> ওয়াল জামা‘আহ:</span> কেননা তারা হকের উপর একত্রিত এবং তাতে পরষ্পর আলাদা হননি। </p>',
            ],
        ],
        2 => [
            0 => [
                'question' => 'প্রশ্ন ১: ত্বহারাত (পবিত্রতা) এর সংজ্ঞা দাও।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2580.mp3',
                'answer' => '<p> উত্তর: ত্বহারাত <span class="c2">(পবিত্রতা)</span>: এটি হচ্ছে অপবিত্রতা দূর করা এবং নাপাকী বিলুপ্ত হওয়া।<br /> নাপাকী থেকে পবিত্রতা: এটি হচ্ছে: কোন মুসলিম কর্তৃক তার শরীর, কাপড়,<span class="c6"> জায়গা অথবা তার সালাত আদায়ের স্থানে পতিত নাপাকীকে দূরা করা।<br /> অপবিত্রতা থেকে পবিত্রতা:</span> এটি পবিত্র পানি দ্বারা অযু বা গোসল অথবা যে পানি পায় না বা পানি ব্যবহারে অপারগ হয়, তার জন্য তায়াম্মুমের মাধ্যমে অর্জিত হয়। </p>',
            ],
            1 => [
                'question' => 'প্রশ্ন ২: নাপাকী পতিত হওয়া বস্তুকে কিভাবে পবিত্র করা হয়?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2630.mp3',
                'answer' => '<p> উত্তর: পবিত্র হওয়া পর্যন্ত পানি দিয়ে ধোয়ার মাধ্যমে।<br /> - আর যদি কুকুর মুখ দিয়ে থাকে; তাহলে সাতবার ধুতে হয় যার প্রথমবার মাটি দ্বারা। </p>',
            ],
            2 => [
                'question' => 'প্রশ্ন ৩: অযুর ফযীলত কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2660.mp3',
                'answer' => '<p> উত্তর: নবী আলাইহিস সালাতু ওয়াসসালাম বলেছেন: <span class="c3">«إذا توضأ العبد المسلم»</span> - أو <span class="c3">«المؤمن»</span>- <span class="c3">«فغسل وجهه؛ خرج من وجهه كل خطيئةٍ نظر إليها بعينيه مع الماء»</span> - أو <span class="c3">«مع آخر قطر الماء»</span> - <span class="c3">«فإذا غسل يديه؛ خرج من يديه كل خطيئة كان بطشتها يداه مع الماء»</span> -أو <span class="c3">«مع آخر قطر الماء»</span> - <span class="c3">«فإذا غسل رجليه؛ خرجت كل خطيئة مشتها رجلاه مع الماء»</span> -أو <span class="c3">«مع آخر قطر الماء»</span> - <span class="c3">«حتى يخرج نقيا من الذنوب»</span>. <span class="c1">“যখন কোনো মুসলিম কিংবা কোনো মুমিন বান্দা অযু করে অতঃপর সে তার চেহারা ধৌত করে, তখন তার চেহারা হতে পানির সাথে অথবা পানির শেষ বিন্দুর সাথে সে সকল গুনাহ বের হয়ে যায় যার দিকে তার দু’চোখের দৃষ্টি পড়েছিল। আর যখন সে তার দু’হাত ধৌত করে, তখন দু’হাত থেকে পানির সাথে অথবা পানির শেষ বিন্দুর সাথে সেসব গুনাহ বের হয়ে যায় যেগুলো তার দু’হাত করেছিল। অতঃপর যখন সে তার দু’পা ধৌত করে তখন তার দু’পা থেকে পানির সাথে অথবা পানির শেষ বিন্দুর সাথে সেসব গুনাহ বের হয়ে যায় যেগুলোর দিকে তার দু’পা অগ্রসর হয়েছিল। ফলে <span class="c2">(অযুর শেষে)</span> লোকটি সমুদয় গুনাহ থেকে সম্পূর্ণভাবে মুক্ত হয়ে যায়।”</span> এটি মুসলিম বর্ণনা করেছেন। </p>',
            ],
            3 => [
                'question' => 'প্রশ্ন ৪: তুমি কীভাবে অযু করবে?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2690.mp3',
                'answer' => '<p> উত্তর: হাতের কব্জি তিনবার ধোয়া।<br /> তিনবার করে কুলি করবে,<span class="c6"> তিনবার নাকে পানি দিবে এবং তিনবার নাক ঝেঁড়ে ফেলবে।<br /> কুলি করা:</span> মুখের মধ্যে পানি নিয়ে, তা ঘোরানো-<span class="c6">ফিরানো এবং নড়াচড়া করিয়ে ফেলে দেওয়া।<br /> নাকে পানি দেওয়া:</span> ডান হাতের সাহায্যে নাকের মধ্যে বাতাসের মাধ্যমে পানি প্রবেশ করিয়ে টেনে নেওয়া।<br /> নাক ঝাঁড়া: নাকে পানি দেওয়ার পরে বাম হাতের সাহায্যে নাক থেকে পানি বের করে ফেলা।<br /> তারপরে চেহারা তিনবার ধোয়া।<br /> তারপরে দুই হাত কনুই পর্যন্ত তিনবার ধোয়া।<br /> তারপরে হাত সামনে থেকে পিছনে এবং পিছন থেকে সামনে নিয়ে মাথা মাসেহ করা ও দুই মাসেহ করা।<br /> তারপর টাখনু পর্যন্ত দুই পা তিনবার ধুইবে।<br /> অযুর পূর্ণতা এমনই। বুখারী ও মুসলিমে বিদ্যমান একাধিক হাদীসে নবী সাল্লাল্লাহু আলাইহি ওয়াসাল্লাম থেকে সাব্যস্ত হয়েছে,<span class="c6"> যা উছমান ও আব্দুল্লাহ ইবনু যাইদসহ অন্যান্যরা বর্ণনা করেছেন। বুখারী ও অন্যান্য কিতাবে আরো সাব্যস্ত সূত্রে বর্ণিত হয়েছে যে:</span> "أنه توضأ مرة مرة،<span class="c6"> وأنه توضأ مرتين مرتين" بمعنى:</span> أنه يغسل كل عضو من أعضاء الوضوء مرة، أو مرتين.<span class="c1">“রাসূল <span class="c2">(সা.)</span> একবার একবার করে অযু করে করেছেন, আবার দুইবার দুইবার করে অযু করেছেন।”</span> অর্থাৎ তিনি তার অযুর অঙ্গ-প্রত্যঙ্গসমূহের প্রতিটি অঙ্গকে একবার অথবা দুইবার করে ধৌত করেছেন। </p>',
            ],
            4 => [
                'question' => 'প্রশ্ন ৫: অযুর ফরয কী এবং এদের সংখ্যা কতটি?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2810.mp3',
                'answer' => '<p> উত্তর: যে কাজগুলোর কোন একটি বাদ গেলে একজন মুসলিমের অযু শুদ্ধ হয় না।<br /> ১. মুখ ধোয়া, কুলি করা এবং নাকে পানি দেওয়াও এর অন্তর্ভুক্ত।<br /> ২. দুই হাত কনুই পর্যন্ত ধোয়া।<br /> ৩. মাথা মাসেহ করা, কান এর অন্তর্ভুক্ত।<br /> ৪. টাখনু পর্যন্ত দুই পা ধোয়া।<br /> ৫. অঙ্গসমূহের ধারাবাহিকতা রক্ষা করা,<span class="c6"> যেমন:</span> মুখ ধোয়া, তারপর দুইহাত, তারপর মাথা মাসেহ করা এবং তারপর দুই পা ধোয়া।<br /> ৬.<span class="c6"> নিরবিচ্ছিন্নতা বজায় রাখা:</span> অযুর ক্ষেত্রে এটি হচ্ছে কোন ধরণের বিচ্ছিন্নতা ছাড়া লাগাতার সময়ের মধ্যে সম্পাদন করা, যাতে অঙ্গসমূহ পানি থেকে শুকিয়ে না যায়।<br /> -<span class="c6"> যেমন:</span> কোন এক সময়ে অর্ধেক অযু করা, আর অন্য সময়ে তা পূর্ণ করা। এতে উক্ত ব্যক্তির অযু সঠিক হবে না। </p>',
            ],
            5 => [
                'question' => 'প্রশ্ন ৬: অযুর সুন্নাতসমূহ কী এবং এদের সংখ্যা কতটি?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2910.mp3',
                'answer' => '<p> উত্তর: অযুর সুন্নাতসমূহ: এগুলো হচ্ছে, যদি অযুকারী তা করে, তাহলে বেশী বিনিময় ও সাওয়াব পাবে। আর যদি ছেড়ে দেয়, তাহলে তার কোন গুনাহ হবে না এবং তার অযু সহীহ।<br /> ১.<span class="c6"> তাসমিয়াহ:</span> বিসমিল্লাহ বলা।<br /> ২. মিসওয়াক করা।<br /> ৩. হাত কব্জি পর্যন্ত ধোয়া।<br /> ৪. আঙ্গুল খিলাল করা।<br /> ৫. অঙ্গসমূহকে দ্বিতীয় বা তৃতীয়বার ধোয়া।<br /> ৬. ডানদিক থেকে শুরু করা।<br /> ৭. অযুর পরে দু‘আ <span class="c2">(যিকর)</span> করা: أشْهَدُ أنْ لا إلهَ إِلَّا اللهُ وَحْدَهُ لا شَرِيكَ لَهُ، وأشهدُ أنَّ مُحَمَّدًا عَبْدُهُ وَرَسُولُهُ <span class="c1">“আমি সাক্ষ্য দিচ্ছি যে, আল্লাহ ছাড়া কোনো সত্য ইলাহ নেই, তিনিই একক যার কোন শরীক নেই। আমি আরো সাক্ষ্য দিচ্ছি যে, মুহাম্মাদ সাল্লাল্লাহু আলাইহি ওয়াসাল্লাম আল্লাহর রাসূল।”</span><br /> ৮. অযুর পর দুই রাকাত সালাত আদায় করা। </p>',
            ],
            6 => [
                'question' => 'প্রশ্ন ৮: অযু নষ্টের কারণগুলো উল্লেখ কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3020.mp3',
                'answer' => '<p> উত্তর: সামনের ও পিছনের রাস্তা দিয়ে কোন কিছু বের হওয়া,<span class="c6"> যেমন:</span> প্রসাব, পায়খানা এবং বায়ূ।<br /> ঘুম, জ্ঞান বিলোপ অথবা পাগল হওয়া।<br /> উটের গোশত খাওয়া।<br /> কোন ধরণের আবরণ ছাড়া হাত দিয়ে প্রসাব বা পায়খানার রাস্তা স্পর্শ করা। </p>',
            ],
            7 => [
                'question' => 'প্রশ্ন ৮: তায়াম্মুম কাকে বলে?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3080.mp3',
                'answer' => '<p> উত্তর: তায়াম্মুম: পানি না পাওয়া গেলে অথবা পানি ব্যবহারে অপারগ হলে, <span class="c2">(পবিত্রতার জন্য)</span> জমিন থেকে নেওয়া ধুলো অথবা মাটি ব্যবহার করা। </p>',
            ],
            8 => [
                'question' => 'প্রশ্ন ৯: তুমি কীভাবে তায়াম্মুম করবে?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3110.mp3',
                'answer' => '<p> উত্তর: হাতের তালু দ্বারা জমিনের উপরে একবার হাত মেরে চেহারা এবং বাইরের দিকে কব্জি পর্যন্ত হাত একবার মাসেহ করতে হবে। </p>',
            ],
            9 => [
                'question' => 'প্রশ্ন ১০: তায়াম্মুম ভঙ্গের কারণ কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3140.mp3',
                'answer' => '<p> উত্তর: অযুভঙ্গকারী প্রত্যেকটি বিষয়।<br /> আর যখন পানি পাওয়া যায়। </p>',
            ],
            10 => [
                'question' => 'প্রশ্ন ১১: চামড়ার মোজাদ্বয় (الخفين) ও অন্যান্য মোজাদ্বয় (الجوربين) বলতে কী বোঝায়? তাদের উপরে কী মাসেহ করা যায়?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3180.mp3',
                'answer' => '<p> উত্তর: চামড়ার মোজাদ্বয় <span class="c2">(الخفين)</span>: চামড়ার তৈরী যা পায়ে পরিধান করা হয়।<br /> সাধারণ <span class="c2">(অন্যান্য)</span> মোজাদ্বয় <span class="c2">(الجوربين)</span>: চামড়ার তৈরী নয়, এমন যা পায়ে পরিধান করা হয়।<br /> দুই পা ধোয়ার পরিবর্তে মাসেহ করা জায়িয। </p>',
            ],
            11 => [
                'question' => 'প্রশ্ন ১২: মোজাদ্বয়ের উপরে মাসেহ করার হিকমাত বর্ণনা কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3230.mp3',
                'answer' => '<p> উত্তর: বান্দার উপরে হুকুম সহজ ও হালকা করা। বিশেষভাবে যখন ঠান্ডা, শীত এবং সফরের সময় হয়। যখন পায়ের পরিধেয় বস্তু খুলে ফেলা কঠিন হয়ে পড়ে। </p>',
            ],
            12 => [
                'question' => 'প্রশ্ন ১৩: মোজাদ্বয়ের উপরে মাসেহ বৈধ হওয়ার শর্তসমূহ কী কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3260.mp3',
                'answer' => '<p> উত্তর: ১. মোজাদ্বয় পবিত্র অবস্থা তথা অযুর পরে পরতে হবে।<br /> ২- মোজা পবিত্র হতে হবে। সুতরাং নাপাক মোজার ওপর মাসেহ করা শুদ্ধ হবে না।<br /> ৩. অযুতে ধোয়া ফরয, এমন অংশটি মোজা দ্বারা ঢাকা থাকতে হবে।<br /> ৪. মাসেহটি নির্দিষ্ট সময়ের মধ্যে হতে হবে,<span class="c6"> যথা:</span> মুসাফির নয় এমন মুকিমের জন্য: একদিন ও একরাত,<span class="c6"> আর মুসাফিরের জন্য:</span> তিনদিন ও তিনরাত। </p>',
            ],
            13 => [
                'question' => 'প্রশ্ন ১৪: মোজাদ্বয়ের উপর মাসেহ করার পদ্ধতি কি?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3320.mp3',
                'answer' => '<p> উত্তর: মাসেহ করার নিয়ম হচ্ছে: দু হাতের আঙ্গুলসমূহ পানিতে ভিজিয়ে দু পায়ের আঙ্গুলের উপর রাখবে। তারপর পায়ের নলা পর্যন্ত টেনে নিয়ে আসবে। ডান পা ডান হাত এবং বাম পা বাম হাত দ্বারা মাসেহ করবে। মাসেহ করার সময়ে আঙ্গুলসমূহ ফাঁকা রাখবে, এবং বারবার মাসেহ করবে না। </p>',
            ],
            14 => [
                'question' => 'প্রশ্ন ১৫: কোন বস্তু মোজাদ্বয়ের উপর মাসেহ বিনষ্ট করে?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3350.mp3',
                'answer' => '<p> উত্তর: ১. মাসেহের সময় শেষ হওয়া। সুতরাং শরী‘আত কর্তৃক নির্ধারিত সময় শেষ হওয়ার পরে মাসেহ করা বৈধ হবে না। মুকিমের জন্য একদিন ও একরাত আর মুসাফিরের জন্য তিনদিন তিনরাত।<br /> ২.<span class="c6"> মোজা খুলে ফেলা:</span> যদি কোন ব্যক্তি তার মোজাদ্বয় অথবা যে কোন একটি মোজা খুলে ফেলে, তাহলে বাতিল। </p>',
            ],
            15 => [
                'question' => 'প্রশ্ন ১৬: সালাতের অর্থ কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3390.mp3',
                'answer' => '<p> উত্তর: সালাত: এটি হচ্ছে নির্দিষ্ট কথা ও কাজসমূহের মাধ্যমে আল্লাহর ইবাদাত করা, যার শুরু হয় তাকবীরের মাধ্যমে এবং শেষ হয় সালামের মাধ্যমে। </p>',
            ],
            16 => [
                'question' => 'প্রশ্ন ১৭: সালাতের হুকুম কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3420.mp3',
                'answer' => '<p> উত্তর: প্রতিটি মুসলিমের উপরে সালাত আদায় করা ফরয।<br /> আল্লাহ তা‘আলা বলেন, إِنَّ الصَّلَاةَ كَانَتْ عَلَى الْمُؤْمِنِينَ كِتَابًا مَوْقُوتًا <span class="c1">“নিশ্চয় সালাত মুমিনদের ওপর ওয়াক্তের মধ্যে আদায় করা ফরয।”</span> <span class="c5">[সূরা আন-নিসা,<span class="c6"> আয়াত:</span> ১০৩]</span> </p>',
            ],
            17 => [
                'question' => 'প্রশ্ন ১৮: সালাত পরিত্যাগের হুকুম কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3460.mp3',
                'answer' => '<p> উত্তর: সালাত পরিত্যাগ করা কুফুরী। নবী সাল্লাল্লাহু আলাইহি ওয়াসাল্লাম বলেছেন:<br /> العهد الذي بيننا وبينهم الصلاة، فمن تركها فقد كفر <span class="c1">“তাদের ও আমাদের মধ্যে প্রতিশ্রুতি হচ্ছে সালাত। যে তা পরিত্যাগ করল, সে কুফুরী করল।”</span><br /> এটি আহমাদ ও তিরমিযী রহ. সহ অন্যান্যরা. বর্ণনা করেছেন। </p>',
            ],
            18 => [
                'question' => 'প্রশ্ন ১৯: রাত ও দিনে মুসলিমের উপরে কত রাকাত সালাত ফরয? আর প্রতিটি সালাতের রাকাত সংখ্যা কত?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3500.mp3',
                'answer' => '<p> উত্তর: দিন ও রাতে মোট পাঁচ ওয়াক্ত সালাত। ফজর: দুই রাকাত,<span class="c6"> যোহর:</span> চার রাকাত,<span class="c6"> আসর:</span> চার রাকাত,<span class="c6"> মাগরিব:</span> তিন রাকাত এবং ইশা: চার রাকাত। </p>',
            ],
            19 => [
                'question' => 'প্রশ্ন ২০: সালাতের শর্তসমূহ উল্লেখ কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3530.mp3',
                'answer' => '<p> উত্তর: ১-<span class="c6"> মুসলিম হওয়া:</span> সুতরাং কাফির ব্যক্তির সালাত শুদ্ধ নয়।<br /> ২-<span class="c6"> বিবেক সম্পন্ন হওয়া:</span> পাগলের সালাত শুদ্ধ নয়।<br /> ৩- ভালো-<span class="c6">মন্দের পার্থক্য করার ক্ষমতা থাকা:</span> সুতরাং ছোট মানুষ <span class="c2">(নাবালক)</span> যার ভালো মান্দের বিচার শক্তি নেই, তার ওপর সালাত ফরয নয়।<br /> ৪- নিয়ত করা।<br /> ৫- ওয়াক্ত হওয়া<br /> ৬- অপবিত্রতা দূর করে পবিত্রতা অর্জন করা।<br /> ৭- নাপাকী থেকে পবিত্রতা অর্জন করা।<br /> ৮- সতর ঢাকা।<br /> ৯- কিবলামুখী হওয়া। </p>',
            ],
            20 => [
                'question' => 'প্রশ্ন ২১: সালাতের রুকনসমূহ সংখ্যা কত?।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3640.mp3',
                'answer' => '<p> উত্তর: মোট চৌদ্দটি রুকন,<span class="c6"> যেমন:</span><br /> ১। সক্ষম ব্যক্তির জন্য ফরয সালাতে দন্ডায়মান হওয়া।<br /> ২। তাকবীরে তাহরীমা বলা,<span class="c6"> আর তা হচ্ছে:</span> <span class="c1">“আল্লাহু আকবার”</span>।<br /> ৩। সূরা ফাতিহা পড়া।<br /> ৪। রুকু করা: রুকুর সময় পিঠ সমান রাখা অবস্থায় টান টান রাখবে এবং মাথাকে তার বরাবর রাখবে।<br /> ৫। রুকু থেকে উঠা।<br /> ৬। দাঁড়ানো অবস্থায় স্থীর হওয়া।<br /> ৭। সিজদা করা: স্বীয় কপাল, নাক, দুই হাতের তালু,<span class="c6"> দুই পায়ের আঙ্গুলসমূহের অগ্রভাগ জমিনে তার সিজদার স্থানে রাখা।<br /> ৮। সিজদা থেকে উঠা।<br /> ৯। দুই সিজদার মাঝখানে বসা।<br /> আর সুন্নাহ হচ্ছে:</span> <span class="c2">(মুসল্লী)</span> তার বাম পায়ের উপরে ইফতিরাশী বৈঠক করবে,<span class="c6"> আর ডান পা উচু করে রাখবে এবং তা কিবলামূখী করে রাখবে।<br /> ১০। ধীরস্থিরতা:</span> এটি হচ্ছে: প্রতিটি কর্ম সংক্রান্ত রুকনে স্থীরতা অবলম্বন করা।<br /> ১১। শেষ তাশাহহুদ পাঠ করা।<br /> ১২। তাশাহহুদের জন্য বসা।<br /> ১৩। দুই সালাম দেওয়া: এটি হচ্ছে: <span class="c1">“আস-সালামু আলাইকুম ওয়া রহমাতুল্লাহ”</span> বাক্যটি দুইবার বলা।<br /> ১৪। রুকনসমূহের ধারাবাহিকতা বজায় রাখা- যেমনটি আমরা উল্লেখ করেছি-। সুতরাং যদি কেউ ইচ্ছাকৃতভাবে রুকুর আগে সিজদা করে, তাহলে সালাত বাতিল হয়ে যাবে। আর যদি ভুলে করে, তাহলে তাকে অবশ্যই রুকুতে ফিরে যেতে হবে এবং তারপর সিজদা করবে। </p>',
            ],
            21 => [
                'question' => 'প্রশ্ন ২২: সালাতের ওয়াজিবসমূহ কী কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3820.mp3',
                'answer' => '<p> উত্তর: সালাতের ওয়াজিব আটটি,<span class="c6"> যেমন:</span><br /> ১- তাকবীরে তাহরীমা ব্যতীত সকল তাকবীর।<br /> ২- ইমাম ও একাকী সালাত আদায়কারী উভয়ের ক্ষেত্রে <span class="c1">“সামি‘আল্লাহু লিমান হামিদাহ”</span> <span class="c2">(سمع الله لمن حمده)</span> বলা।<br /> ৩- <span class="c1">“রব্বানা- ওয়া লাকাল হামদ”</span> <span class="c2">(ربنا ولك الحمد)</span> বলা।<br /> ৪- রুকুতে কমপক্ষে একবার <span class="c1">“সুবহানা রব্বিয়াল ‘আযীম”</span> <span class="c2">(سبحان ربي العظيم)</span> বলা।<br /> ৫- সিজদাতে কমপক্ষে একবার <span class="c1">“সুবহানা রব্বিয়াল ‘আলা”</span> <span class="c2">(سبحان ربي الأعلى)</span> বলা।<br /> ৬- দুই সিজদার মাঝখানে <span class="c1">“রব্বিগফিরলী”</span> <span class="c2">(رب اغفر لي)</span> বলা।<br /> ৭- প্রথম তাশাহহুদ।<br /> ৮-<span class="c6"> প্রথম তাশাহুদের জন্য বসা:</span> </p>',
            ],
            22 => [
                'question' => 'প্রশ্ন ২৩: সালাতের সুন্নাহগুলো কি?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3930.mp3',
                'answer' => '<p> উত্তর: সালাতে সুন্নাহ এগারোটি,<span class="c6"> যেমন:</span><br /> ১- তাকবীরে তাহরিমার পরে سبحانك اللهم وبحمدك، وتبارك اسمك، وتَعَالَىٰ جدك، ولا إله غيرك <span class="c1">“হে আল্লাহ! আপনার প্রশংসা ও পবিত্রতা ঘোষণা করছি, আপনার নাম কতইনা বরকতময়, আপনার সম্মান কতইনা উর্ধ্বে, আপনি ছাড়া কোন <span class="c5">[প্রকৃত]</span> ইলাহ নেই।”</span> একে ইস্তিফতাহ <span class="c2">(সূচনা)</span>-এর দু‘আ বলা হয়।<br /> ২- তা‘আউয়ুয <span class="c2">(আ‘ঊযুবিল্লাহ)</span> পড়া।<br /> ৩- বিসমিল্লাহ পড়া।<br /> ৪- ‘আমীন” বলা।<br /> ৫- সূরা ফাতিহার পরে অন্য একটি সূরা পড়া।<br /> ৬- ইমামের জন্য কিরাআত জোরে পড়া।<br /> ৭- রুকু থেকে উঠে সামি‘আল্লাহু লিমান হামিদাহ বলার পরে "ملء السَّمٰوات، وملء الأرض، وملء ما شئت من شيء بعد" <span class="c2">(আপনার প্রশংসা)</span> আসমানসমূহ পূর্ণ, যমীনসমূহ পূর্ণ, এর পরেও আপনি যে সমস্ত বস্তু চান, সেসবও পূর্ণ।” এ দু‘আ পড়া।<br /> ৮-<span class="c6"> রুকুতে একবারের অতিরিক্ত তাসবীহ তথা:</span> দ্বিতীয় ও তৃতীয়বার তাসবীহ পড়া, এবং এর থেকে বৃদ্ধি।<br /> ৯- একবার থেকে সিজদাতে অতিরিক্ত তাসবীহ পড়া।<br /> ১০- দুই সিজদার মাঝখানে <span class="c1">“রব্বিগফিরলী”</span> <span class="c2">(رب اغفر لي)</span> একাধিকবার পড়া।<br /> ১১- শেষ বৈঠকে নবী ও তার পরিবার-পরিজন আলাইহিমুস সালামের জন্য শান্তি ও বরকতের জন্য দু‘আ <span class="c2">(দরুদ)</span> করা এবং এর পরে অন্যান্য দু‘আ <span class="c2">(দু‘আ মাছুরা)</span> পড়া।<br /> চতুর্থত: কর্ম সংক্রান্ত সুন্নাহ,<span class="c6"> একে অবস্থাগত সুন্নাহ বলা হয়:</span><br /> ১- তাকবীরে তাহরিমার সাথে রফ‘উল ইয়াদাইন <span class="c2">(দুই হাত উত্তোলন)</span> করা।<br /> ২- রুকুর সময়ে <span class="c2">(হাত উত্তোলন)</span>।<br /> ৩- রুকু থেকে উঠার সময়ে <span class="c2">(হাত উত্তোলন)</span> করা।<br /> ৪- উভয় অবস্থায় এর পরে হাত নামিয়ে ফেলা।<br /> ৫- ডানহাতকে বামহাতের উপরে রাখা।<br /> ৬- সিজদার স্থানে দৃষ্টি নিবদ্ধ রাখা।<br /> ৭- দাঁড়ানো অবস্থায় দুই পায়ের মাঝখানে ফাঁকা রাখা।<br /> ৮- আঙ্গুলগুলো ফাঁকা রেখে রুকুতে দুই হাত দ্বারা দুই হাঁটু ধরে রাখা এবং পিঠ সোজা রেখে মাথা তার বরাবর রাখা।<br /> ৯- সিজদার অঙ্গসমূহ মাটিতে রাখা এবং সিজদার স্থান সরাসরি জমিনে রাখা।<br /> ১০- সিজদার সময়ে দুই পার্শ্ব থেকে দুই বাহুকে, পেটকে উরুদ্বয় থেকে এবং উরুদ্বয়কে দুই গোছা থেকে আলাদা রাখা। আবার দুই হাঁটুর মধ্যে ফাঁকা রাখা, পা দুটিকে দাঁড় করিয়ে রাখা, আবার পায়ের আঙ্গুলসমূহের ভিতরের দিক যমীনের উপরে আলাদা আলাদা রাখা আর আঙ্গুলসমূহ বন্ধ রেখে হাত দুটিকে কাঁধ বরাবর বিছিয়ে রাখা।<br /> ১১- দুই সিজদার মাঝখানে এবং প্রথম তাশাহহুদের বৈঠকে ইফতিরাশী বৈঠক করা আর দ্বিতীয় বৈঠকে তাওয়াররুক করা।<br /> ১২- দুই সিজদার মাঝখানে আঙ্গুলসমূহকে বন্ধ রেখে উরুদ্বয়ের উপরে হাত দুটিকে বিছিয়ে রাখা। অনুরূপভাবে তাশাহহুদের মধ্যেও, তবে তাশাহহুদের ক্ষেত্রে ডানহাতের মধ্যমা ও বৃদ্ধাঙ্গুলিকে গোল করে কনিষ্ট ও অনামিকা আঙ্গুলদ্বয় বন্ধ রেখে শাহাদাত আঙ্গুলের মাধ্যমে ইশারা করতে হবে।<br /> ১৩- সালামের সময়ে ডানে বামে মুখ ঘোরানো। </p>',
            ],
            23 => [
                'question' => 'প্রশ্ন ২৪: সালাত ভঙ্গকারী বিষয়সমূহ উল্লেখ কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4210.mp3',
                'answer' => '<p> উত্তর: <span class="c2">(১)</span> কোন রুকন অথবা শর্তসমূহের কোন একটি ত্যাগ করা।<br /> <span class="c2">(২)</span> ইচ্ছাপূর্বক কথা বলা।<br /> <span class="c2">(৩)</span> খাওয়া অথবা পান করা।<br /> <span class="c2">(৪)</span> অনবরত অতিরিক্ত নড়াচড়া করা।<br /> <span class="c2">(৫)</span> ইচ্ছাপূর্বক সালাতের কোন ওয়াজিব পরিত্যাগ করা। </p>',
            ],
            24 => [
                'question' => 'প্রশ্ন ২৫: মুসলিম কীভাবে সালাত আদায় করবে?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4280.mp3',
                'answer' => '<p> উত্তর: সালাত আদায়ের পদ্ধতি:<br /> ১- কোন দিকে ঘোরা বা তাকানো ব্যতীত সমস্ত শরীরকে কিবলামুখী করা।<br /> ২- মুখে নিয়ত উচ্চারণ করা ছাড়া, যে সালাত আদায় করতে ইচ্ছুক, অন্তরে সেই সালাত আদায়ের নিয়ত করা।<br /> ৩- তারপরে তাকবীরে তাহরীমা তথা <span class="c1">“আল্লাহু আকবার”</span> বলবে। এবং দুই হাত তাকবীরের সময় কাঁধ বরাবর উত্তোলন করবে।<br /> ৪- তারপরে ডান হাতের তালু তার বাম হাতের কব্জির উপরে রেখে বুকের উপরে বাঁধবে।<br /> ৫- তারপরে ইস্তিফতাহ <span class="c2">(সূচনার)</span> দু‘আ পড়বে: <span class="c3">«اللهمَّ باعِدْ بينِي وبينَ خَطايايَ كما باعَدتَّ بينَ المشرقِ والمَغرب، اللهمَّ نقِّني من خطايايَ كما يُنقَّى الثَّوبُ الأبيضُ منَ الدَّنَس، اللهمَّ اغسِلْنِي من خَطَايايَ بالثَّلجِ والماءِ والبَرَد»</span>. <span class="c1">“হে আল্লাহ্! আমার এবং আমার গুনাহের মধ্যে এমন ব্যবধান করে দিন যেমন ব্যবধান করেছেন পূর্ব ও পশ্চিমের মধ্যে। হে আল্লাহ্ আমাকে আমার গুনাহ হতে এমনভাবে পবিত্র করুন যেমন সাদা কাপড় ময়লা থেকে পরিষ্কার হয়। হে আল্লাহ্ আমার গোনাহকে বরফ, পানি ও শিশির দ্বারা ধৌত করে দিন।”</span><br /> অথবা বলবে: <span class="c3">«سُبْحَانَكَ اللَّهُمَّ وَبِحَمْدِكَ، وَتَبَارَكَ اسْمُكَ، وَتَعَالَى جَدُكَ، وَلاَ إِلَهَ غَيْرك»</span> <span class="c1">“হে আল্লাহ! আপনার প্রশংসা ও পবিত্রতা ঘোষণা করি, আপনার নাম কতইনা বরকতময়, আপনার সম্মান কতইনা উর্ধ্বে, আপনি ছাড়া কোন <span class="c5">[প্রকৃত]</span> ইলাহ নেই।”</span><br /> ৬-<span class="c6"> তারপরে তা‘আউয বলবে:</span> তথা <span class="c3">«أعوذ بالله من الشيطان الرجيم»</span> <span class="c1">“আমি বিতাড়িত শয়তান থেকে আল্লাহর নিকট আশ্রয় চাই।”</span> ৭-<span class="c6"> তারপরে বিসমিল্লাহ পড়ে সূরা ফাতিহা করবে:</span> بِسْمِ اللهِ الرَّحْمنِ الرَّحِيمِ রহমান ও রহীম আল্লাহর নামে <span class="c2">(১)</span> الْحَمْدُ للّهِ رَبِّ الْعَالَمِينَ <span class="c1">“সকল প্রশংসা সৃষ্টিকুলের রব আল্লাহরই প্ৰাপ্য। <span class="c2">(২)</span> الرَّحْمـنِ الرَّحِيمِ “পরম করুণাময়, অতি দয়ালু।”</span> <span class="c2">(৩)</span> مَالِكِ يَوْمِ الدِّينِ <span class="c1">“বিচার দিবসের মালিক।”</span><span class="c2">(৪)</span> إِيَّاكَ نَعْبُدُ وإِيَّاكَ نَسْتَعِينُ <span class="c1">“আমরা শুধু আপনারই ‘ইবাদাত করি, এবং শুধু আপনারই সাহায্য প্রার্থনা করি।”</span> <span class="c2">(৫)</span> اهدِنَــــا الصِّرَاطَ المُستَقِيمَ <span class="c1">“আমাদেরকে সরল-সুদৃঢ় পথের হিদায়াত দিন।”</span> <span class="c2">(৬)</span> صِرَاطَ الَّذِينَ أَنعَمتَ عَلَيهِمْ غَيرِ المَغضُوبِ عَلَيهِمْ وَلاَ الضَّالِّينَ <span class="c1">“তাদের পথ, যাদেরকে আপনি নি‘আমাত দিয়েছেন, যাদের উপর আপনার ক্রোধ আপতিত হয়নি এবং যারা পথভ্রষ্টও নয়।”</span> <span class="c2">(৭)</span> <span class="c5">[আল-<span class="c6">ফাতিহা:</span> ১-৭]</span><br /> তারপরে সে বলবে: <span class="c1">“আমীন।” হে আল্লাহ, আপনি কবুল করুন।<br /> ৮- তারপর কুরআনের যেখান থেকে সহজ, তা পাঠ করবে। এবং ফজরের সালাতে কিরাআত দীর্ঘ করবে।<br /> ৯- তারপরে রুকু করবে,<span class="c6"> অর্থ্যাৎ:</span> আল্লাহ তা‘আলার সম্মানার্থে পিঠ ঝুকিয়ে দেবে, রুকুর সময়ে তাকবীর বলবে,<span class="c6"> আর তার দুই হাত কাঁধ বরাবর উত্তোলন করবে। আর সুন্নাহ হচ্ছে:</span> সে তার পিঠকে সোজা করবে, মাথাকে পিঠের বরাবর রাখবে এবং আঙ্গুলগুলো আলাদা রেখে তার দুই হাঁটুর উপরে তার হাতদ্বয় রাখবে।<br /> ১০-<span class="c6"> এরপর রুকুতে বলবে:</span> “সুবহানা রব্বিয়াল ‘আযীম”</span> <span class="c2">(তিনবার)</span>, আর যদি দু‘আ হিসেবে <span class="c1">“সুবহানাকাল্লাহুম্মা ওয়াবিহামদিকা আল্লাহুম্মাগফিরলী”</span> বৃদ্ধি করে, তবে তা উত্তম।<br /> ১১-<span class="c6"> এরপরে রুকু থেকে মাথা উঠানোর সময়ে বলবে:</span> <span class="c1">“সামি‘আল্লাহু লিমান হামিদাহ”</span> <span class="c2">(سمع الله لمن حمده)</span>, এবং তার দুইহাত এ সময়ে কাঁধ বরাবর থাকবে। মুক্তাদী <span class="c1">“সামি‘আল্লাহু লিমান হামিদাহ”</span> বলবে না,<span class="c6"> এর পরিবর্তে সে বলবে:</span> <span class="c1">“রব্বানা- ওয়া লাকাল হামদ”</span> <span class="c2">(ربنا ولك الحمد)</span>।<br /> ১২- তারপরে রুকু থেকে উঠে ربنا ولك الحمد، ملء السماوات والأرض، وملء ما شئت من شيء بعد <span class="c5">[রব্বানা ওয়া লাকাল হামদ, মিল-আস সামাওয়াতি ওয়াল আরদ্বি, ওয়া মিল-আ মা শি‘তা মিম বা‘দু]</span> <span class="c1">“<span class="c2">(আপনার প্রশংসা)</span> আসমানসমূহ পূর্ণ, যমীনসমূহ পূর্ণ, এর পরেও আপনি যে সমস্ত বস্তু পরিমাণ চান, সেসবও পূর্ণ।”</span> এ দু‘আ পড়বে।<br /> ১৩- তারপরে প্রথম সিজদা করবে, তার সিজদাতে <span class="c2">(যাওয়ার সময়)</span> বলবে: <span class="c1">“আল্লাহু আকবার”</span>। সাতটি অঙ্গের উপর সিজদা করবে: কপাল ও নাক, হাতের তালুদ্বয়, হাঁটুদ্বয়, দুই পায়ের অগ্রভাগ। তার বাহুদ্বয় পার্শ্ব থেকে আলাদা রাখবে, স্বীয় বাহুকে যমীনের উপর বিছিয়ে রাখবে না এবং তার আঙ্গুলের মাথা কিবলামুখী করে রাখবে।<br /> ১৪-<span class="c6"> সিজদার মধ্যে সে তিনবার বলবে:</span> <span class="c1">“সুবহানা রব্বিয়াল আ‘লা”</span>, আর যদি দু‘আ হিসেবে <span class="c1">“সুবহানাকাল্লাহুম্মা ওয়াবিহামদিকা আল্লাহুম্মাগফিরলী”</span> বৃদ্ধি করে, তবে তা উত্তম।<br /> ১৫- তারপরে সিজদা থেকে <span class="c1">“আল্লাহু আকবার”</span> বলে উঠে দাঁড়াবে।<br /> ১৬- তারপরে তার বাম পায়ের উপরে ভর করে বসবে, আর ডান পা উচুঁ করে রাখবে। তার ডান হাত স্বীয় ডান হাঁটুর দিকে উরুর শেষ প্রান্তে রাখবে। কনিষ্ট ও অনামিকা আঙ্গুলদ্বয় আঁটকে রাখবে এবং শাহাদাত আঙ্গুল দু‘আর সময়ে নাড়াতে থাকবে, মধ্যমা আঙ্গুলের সাথে বৃদ্ধাঙ্গুলিকে বৃত্তের ন্যায় সংযুক্ত রাখবে। এবং বাম হাত স্বীয় বাম হাঁটুর দিকে উরুর শেষ প্রান্তে আঙ্গুলগুলো বিছিয়ে রাখবে।<br /> ১৭-<span class="c6"> আর দুই সিজদার মাঝখানে বৈঠকে বলবে:</span> رب اغفر لي، وارحمني، واهدني، وارزقني، واجبرني، وعافني<span class="c5">[রব্বিগফিরলী, ওয়ারহামনী, ওহদিনী, ওয়ারযুকনী, ওয়াজবুরনী ও ‘আ-ফিনী]</span>, <span class="c1">“হে আমার রব! আমাকে ক্ষমা করুন, আমাকে রহমত করুন, আমাকে হিদায়াত দিন, আমাকে রিযিক দিন, আমাকে বিপদমুক্ত করুন এবং আমাকে ক্ষমা করুন।”</span><br /> ১৮- তারপরে প্রথম সিজদাতে বলা দু‘আ ও কাজগুলির ন্যায় দ্বিতীয় সিজদা করবে,এবং সিজদার সময়ে তাকবীর বলবে।<br /> ১৯- তারপরে <span class="c1">“আল্লাহু আকবার”</span> বলে দ্বিতীয় সিজদা থেকে উঠে দাঁড়াবে। এরপরে কথা ও কাজে প্রথম রাকাতের ন্যায় দ্বিতীয় রাকাতও আদায় করবে, তবে ইস্তিফতাহের দু‘আ পড়বে না।<br /> ২০-<span class="c6"> দ্বিতীয় রাকাতের শেষে বলবে:</span> <span class="c1">“আল্লাহু আকবার”</span>, আর সে দুই সিজদার মাঝখানে যেমন বৈঠক করেছিল, ঠিক অনুরুপ বৈঠক করবে।<br /> ২১-<span class="c6"> এবং এ বৈঠকে সে তাশাহহুদ পাঠ করবে। এভাবে বলবে:</span> "التحيات لله، والصلوات والطيبات، السلام عليك أيها النبي ورحمة الله وبركاته، السلام علينا وعلى عباد الله الصالحين، أشهد أن لا إله إلا الله، وأشهد أن محمدًا عبده ورسوله، اللهم صَلِّ على محمد، وعلى آل محمد، كما صليت على إبراهيم، وعلى آل إبراهيم إنك حميد مجيد، اللهم بارك على محمد وعلى آل محمد، كما باركت على إبراهيم وعلى آل إبراهيم، إنك حميد مجيد أعوذ بالله من عذاب جهنم، ومن عذاب القبر، ومن فتنة المحيا والممات، ومن فتنة المسيح الدجال " <span class="c1">“মৌখিক, শারিরীক ও আর্থিক সমস্ত ইবাদাত আল্লাহর জন্যই নিবেদিত। হে নবী! আপনার উপরে সালাম, আল্লাহর রহমত ও বরকত নাযিল হোক। আমাদের উপরে এবং আল্লাহর নেককার বান্দাদের উপরে সালাম বর্ষিত হোক। আমি সাক্ষ্য দিচ্ছি যে, আল্লাহ ছাড়া কোন প্রকৃত ইলাহ নেই। এবং আমি আরো সাক্ষ্য দিচ্ছি যে, মুহাম্মাদ আল্লাহর বান্দা ও রাসূল। হে আল্লাহ! মুহাম্মাদের উপরে এবং মুহাম্মাদের পরিবারের উপরে সালাত <span class="c2">(রহমত)</span> বর্ষণ করুন, যেভাবে ইবরাহীম ও ইবরাহীমের পরিবারের উপরে আপনি সালাত <span class="c2">(রহমত)</span> বর্ষণ করেছিলেন। নিশ্চয় আপনি প্রশংসিত মর্যাদাবান। হে আল্লাহ! মুহাম্মাদের উপরে এবং মুহাম্মাদের পরিবারের উপরে বরকত নাযিল করুন, যেভাবে ইবরাহীম ও ইবরাহীমের পরিবারের উপরে আপনি বরকত নাযিল করেছিলেন। নিশ্চয় আপনি প্রশংসিত মর্যাদাবান। আমি আল্লাহর কাছে আশ্রয় চাচ্ছি জাহান্নামের আযাব থেকে, কবরের আযাব থেকে, জীবন-মৃত্যুর ফিতনা থেকে এবং মাসীহ দাজ্জালের ফিতনা থেকে।”</span> তারপরে স্বীয় রবের কাছে নিজের পছন্দ মত দুনিয়া ও আখিরাত উভয় স্থানের জন্য কল্যাণকর দু‘আ করবে।<br /> ২২- তারপরে <span class="c1">“আস-সালামু আলাইকুম ওয়া রহমাতুল্লাহ”</span> বলে ডানদিকে সালাম ফিরাবে এবং বামদিকেও অনুরূপ <span class="c2">(সালাম)</span> ফিরাবে।<br /> ২৩- যদি সালাত তিন অথবা চার রাকাত বিশিষ্ট হয়ে থাকে, তাহলে সে প্রথম তাশাহহুদের উপরে সীমিত রাখবে, তথা أشهد أن لا إله إلا الله، وأشهد أن محمداً عبده ورسوله <span class="c1">“আশহাদু… ওয়া রসূলুহু”</span>, <span class="c1">“আমি সাক্ষ্য দিচ্ছি যে, আল্লাহ ছাড়া কোন প্রকৃত ইলাহ নেই, এবং আরো সাক্ষ্য দিচ্ছি যে, মুহাম্মাদ আল্লাহর বান্দা ও তাঁর রাসূল।”</span><br /> ২৪- তারপরে <span class="c1">“আল্লাহু আকবার”</span> বলে উঠে দাঁড়াবে। এবং ঐ সময়ে তার দুই হাত কাঁধ বরাবর উত্তোলন করবে।<br /> ২৫- তারপরে দ্বিতীয় রাকাতের ন্যায় বাকী রাকাতগুলো আদায় করবে, তবে শুধু সূরা ফাতিহাটুকু পড়বে।<br /> ২৬- তারপরে তাওয়াররুক পদ্ধতিতে বৈঠক করবে,<span class="c6"> তথা:</span> নিতম্বের উপরে ভর করে বাম পা ডান পায়ের নিচ দিয়ে বের করে বসবে, তারপরে প্রথম তাশাহহুদে তার দুই হাত যেভাবে উরুর উপরে রেখেছিল, সেভাবে রাখবে।<br /> ২৭- এ বৈঠকে পুরো তাশাহহুদ পড়বে।<br /> ২৮- তারপরে <span class="c1">“আস-সালামু আলাইকুম ওয়া রহমাতুল্লাহ”</span> বলে ডানদিকে সালাম ফিরাবে এবং বামদিকেও অনুরূপ <span class="c2">(সালাম)</span> ফিরাবে। </p>',
            ],
            25 => [
                'question' => 'প্রশ্ন ২৬: সালাতে সালাম ফিরানোর পরে তুমি কী কী দু‘আ পড়বে?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4610.mp3',
                'answer' => '<p> উত্তর: তিনবার <span class="c3">«أَسْـتَغْفِرُ الله»</span> তথা আস্তাগফিরুল্লাহ বলবে।<br /> <span class="c3">«اللَّهُمَّ أَنْتَ السَّلامُ وَمِنْكَ السَّلامُ، تَبَارَكْتَ يَا ذَا الْجَلالِ وَالإِكْرَامِ»</span> <span class="c1">“হে আল্লাহ আপনি শান্তি, আপনার থেকেই শান্তি, আপনি রবকতময়, হে মহিমান্বিত ও সম্মানের অধিকারী।”</span><br /> لا إلهَ إلاّ اللّهُ وحدَهُ لا شريكَ لهُ، لهُ المُـلْكُ ولهُ الحَمْد، وهوَ على كلّ شَيءٍ قَدير، اللّهُـمَّ لا مانِعَ لِما أَعْطَـيْت، وَلا مُعْطِـيَ لِما مَنَـعْت، وَلا يَنْفَـعُ ذا الجَـدِّ مِنْـكَ الجَـد <span class="c1">“আল্লাহ ব্যতীত কোন সত্য ইলাহ নেই তিনি একক। তাঁর কোন শরীক নেই। <span class="c5">[বিশাল]</span> রাজত্ব তাঁরই। প্রশংসা তাঁরই। তিনি সবকিছুর উপর ক্ষমতাবান। হে আল্লাহ! আপনি যা দান করেন, তা রোধ করার ক্ষমতা কারো নেই, আর আপনি যা রোধ করেন, তা প্রদানকারী কেউই নেই। কোন সম্পদশালীর সম্পদ আপনার কোন উপকার করতে পারে না।”</span><br /> لا إلهَ إلاّ الله، وحدَهُ لا شريكَ لهُ، لهُ الملكُ ولهُ الحَمد، وهوَ على كلّ شيءٍ قدير، لا حَـوْلَ وَلا قـوَّةَ إِلاّ بِاللهِ، لا إلهَ إلاّ الله، وَلا نَعْـبُـدُ إِلاّ إيّـاه، لَهُ النِّعْـمَةُ وَلَهُ الفَضْل وَلَهُ الثَّـناءُ الحَـسَن، لا إلهَ إلاّ الله مخْلِصـينَ لَـهُ الدِّينَ وَلَوْ كَـرِهَ الكـافِرون <span class="c1">““আল্লাহ ব্যতীত কোন সত্য ইলাহ নেই তিনি একক। তাঁর কোন শরীক নেই। <span class="c5">[বিশাল]</span> রাজত্ব তাঁরই। প্রশংসা তাঁরই। তিনি সবকিছুর উপর ক্ষমতাবান। আল্লাহর সাহায্য ছাড়া পাপ থেকে ফিরার এবং সৎকাজ করার শক্তি নেই। আল্লাহ ব্যতীত কোন সত্য উপাস্য নেই। তাকে ছাড়া আমরা আর কারো ইবাদত করি না, তাঁরই যাবতীয় নি‘আমাত, তাঁরই যাবতীয় অনুগ্রহ এবং তাঁরই যাবতীয় সু-প্রশংসা। আল্লাহ ছাড়া কোন সত্য উপাস্য নেই। আমরা বিশুদ্ধ চিত্তে তাঁরই ইবাদত করি, যদিও কাফেররা তা অপছন্দ করে।”</span><br /> سُـبْحانَ اللهِ তথা: <span class="c1">“সুবহানাল্লাহ”</span> তেত্রিশ বার।<br /> الحَمْـدُ لله তথা: <span class="c1">“আলহামদুলিল্লাহ”</span> তেত্রিশ বার।<br /> اللهُ أكْـبَر তথা: <span class="c1">“আল্লাহু আকবার”</span> তেত্রিশ বার।<br /> এরপরে একশত বার পূরণার্থে পড়বে: لا إله إلا الله وحده لا شريك له، له الملك وله الحمد، وهو على كل شيء قدير <span class="c1">““আল্লাহ ব্যতীত কোন সত্য ইলাহ নেই তিনি একক। তাঁর কোন শরীক নেই। <span class="c5">[বিশাল]</span> রাজত্ব তাঁরই। প্রশংসা তাঁরই। তিনি সবকিছুর উপর ক্ষমতাবান।”</span><br /> - ফজর ও মাগরিবের পরে সূরা আল-ইখলাস, সূরা আল-ফালাক ও সূরা আন-নাস তিনবার আর অন্যান্য সালাতের পরে একবার করে পাঠ করবে।<br /> - এবং একবার আয়াতুল কুরসী পাঠ করবে। </p>',
            ],
            26 => [
                'question' => 'প্রশ্ন ২৭: সুনানে রাতিবাহ কাকে বলে? এর ফযীলত কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4730.mp3',
                'answer' => '<p> উত্তর: ফজরের পূর্বে দুই রাকাত ।<br /> যোহরের আগে চার রাকাত।<br /> যোহরের পরে দুই রাকাত।<br /> মাগরিবের পরে দুই রাকাত।<br /> ইশার পরে দুই রাকাত।<br /> এর ফযীলত সম্পর্কে নবী সাল্লাল্লাহু আলাইহি ওয়া সাল্লাম বলেছেন: من صلى في اليوم والليلة اثنتي عشرة ركعة تطوعاً بنى الله له بيتاً في الجنة <span class="c1">“যে ব্যক্তি দিন-রাতে ১২ রাকাত <span class="c2">(অতিরিক্ত)</span> সালাত আদায় করবে, আল্লাহ তার জন্য জান্নাতে একটি বাড়ী তৈরী করবেন।”</span> ইমাম আহমাদ, মুসলিম ও অন্যান্যরা এটি বর্ণনা করেছেন। </p>',
            ],
            27 => [
                'question' => 'প্রশ্ন ২৮: সপ্তাহের সর্বোত্তম দিন কোনটি?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4800.mp3',
                'answer' => '<p> উত্তর: জুমু‘আর দিন। নবী সাল্লাল্লাহু আলাইহি ওয়া সাল্লাম বলেছেন: إن من أفضل أيامكم يوم الجمعة فيه خلق آدم وفيه قبض وفيه النفخة وفيه الصعقة فأكثروا علي من الصلاة فيه فإن صلاتكم معروضة علي তোমাদের দিনসমূহের মধ্যে সর্বোত্তম দিন হচ্ছে জুমু‘আর দিন। এ দিনে আদম আলাইহিস সালামকে সৃষ্টি করা হয়েছিল, এ দিনে তার রূহ কবয করা হয়েছিল, এ দিনেই শিঙ্গাতে ফুঁক দেওয়া হবে,<span class="c6"> আর এ দিনেই বিকট শব্দ করা হবে। সুতরাং তোমরা আমার উপরে বেশী বেশী করে দরুদ পড়; কেননা তোমাদের দরুদ আমার কাছে পেশ করা করা হয়ে থাকে।” রাবী বলেছেন:</span> তারা বললেন: হে আল্লাহর রাসূল! আপনি মারা গেলে আপনার কাছে কিভাবে দরুদ পেশ করা হবে -<span class="c6"> তারা বললেন:</span> মাটিতে মিশে যাবেন-<span class="c6">? তখন তিনি বললেন:</span> إن الله عَزَّ وَجَلَّ حرم على الأرض أجساد الأنبياء <span class="c1">“নিশ্চয় আল্লাহ আয্যা ওয়া জাল্লা নবীদের দেহ গ্রাস করাকে যমীনের উপরে হারাম করে দিয়েছেন।”</span> এটি আবূ দাঊদ ও অন্যরা বর্ণনা করেছেন। </p>',
            ],
            28 => [
                'question' => 'প্রশ্ন ২৯: জুমু‘আর সালাতের হুকুম কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4840.mp3',
                'answer' => '<p> উত্তর: মুকীম, জ্ঞানসম্পন্ন,<span class="c6"> বালেগ প্রতিটি মুসলিমের জন্য ফরযে আইন।<br /> আল্লাহ তা‘আলা বলেছেন:</span> يَٓأَيُّهَا ٱلَّذِينَ ءَامَنُوٓاْ إِذَا نُودِيَ لِلصَّلَوةِ مِن يَوۡمِ ٱلۡجُمُعَةِ فَٱسۡعَوۡاْ إِلَى ذِكۡرِ ٱللَّهِ وَذَرُواْ ٱلۡبَيۡعَۚ ذَلِكُمۡ خَيۡرٞ لَّكُمۡ إِن كُنتُمۡ تَعۡلَمُونَ <span class="c1">“হে ঈমানদারগণ ! জুমু’আর দিনে যখন সালাতের জন্য ডাকা হয়, তখন তোমরা আল্লাহর স্বরণে ধাবিত হও এবং কেনা-বেচা ত্যাগ কর, এটাই তোমাদের জন্য সর্বোত্তম, যদি তোমরা জানতে।”</span> <span class="c5">[সূরা আল-মুনাফিকুন,<span class="c6"> আয়াত:</span> ০৯]</span> </p>',
            ],
            29 => [
                'question' => 'প্রশ্ন ৩০: জুমু‘আর সালাতের রাকাত সংখ্যা কত?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4880.mp3',
                'answer' => '<p> উত্তর: জুমু‘আর সালাত হচ্ছে দুই রাকাত। এতে ইমাম কিরাআত জোরে পড়বেন, যার আগে তিনি দুটি খুতবা প্রদান করবেন। </p>',
            ],
            30 => [
                'question' => 'প্রশ্ন ৩১: জুমু‘আর সালাতে অনুপস্থিত থাকা জায়িয আছে কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4910.mp3',
                'answer' => '<p> উত্তর: শরয়ী উযর ব্যতীত জুমু‘আর সালাতে অনুপস্থিত থাকা জায়িয নেই। এ মর্মে নবী সাল্লাল্লাহু আলাইহি ওয়াসাল্লামের বক্তব্য এসেছে: من ترك ثلاث جمع تهاونا بها؛ طبع الله على قلبه <span class="c1">“যে ব্যক্তি তিনটি জুমু‘আহ অলসতা বশত পরিত্যাগ করে; তাহলে আল্লাহ তার অন্তরের উপর মোহর মেরে দেন।”</span> এটি আবূ দাঊদ ও অন্যরা বর্ণনা করেছেন। </p>',
            ],
            31 => [
                'question' => 'প্রশ্ন ৩২: জুমু‘আর দিনের সুন্নাতগুলো উল্লেখ কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4940.mp3',
                'answer' => '<p> উত্তর:<br /> ১- গোসল করা।<br /> ২- সুগন্ধি মাখা।<br /> ৩- সুন্দর কাপড় পরিধান করা।<br /> ৪- সকাল সকাল মসজিদে গমন করা।<br /> ৫- নবী সাল্লাল্লাহু আলাইহি ওয়া সাল্লামের উপর বেশী বেশী দরুদ পাঠ করা।<br /> ৬- সূরা কাহফ তিলাওয়াত করা।<br /> ৭- হেঁটে মসজিদে গমন করা।<br /> ৮- দু‘আ কবুল হওয়ার সময়ের অন্বেষণ করা। </p>',
            ],
            32 => [
                'question' => 'প্রশ্ন ৩৩: জুমু‘আর সালাতের ফযীলত উল্লেখ কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5050.mp3',
                'answer' => '<p> উত্তর: আব্দুল্লাহ ইবনু উমার রদিয়াল্লাহু আনহুমা থেকে বর্ণিত,<span class="c6"> রাসূলুল্লাহ সাল্লাল্লাহু আলাইহি ওয়াসাল্লাম বলেছেন:</span> صلاة الجماعة أفضل من صلاة الفذ بسبع وعشرين درجة <span class="c1">“জামা‘আতে সালাত একা আদায়কৃত সালাত থেকে মার্যাদার সাতাশগুণ উত্তম।”</span> এটি সহীহ মুসলিম বর্ণনা করেছেন। </p>',
            ],
            33 => [
                'question' => 'প্রশ্ন ৩৪: সালাতে খুশুর অর্থ কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5080.mp3',
                'answer' => '<p> উত্তর: এটি হচ্ছে: সালাতে মনোনিবেশ করা এবং সকল অঙ্গ-<span class="c6">প্রত্যঙ্গ স্থির রাখা।<br /> আল্লাহ তা‘আলা বলেছেন:</span> قَدْ أَفْلَحَ الْمُؤْمِنُونَ <span class="c1">“অবশ্যই মুমিনগণ সফল হয়েছে।”</span> الَّذِينَ هُمْ فِي صَلَاتِهِمْ خَاشِعُونَ <span class="c1">“যারা নিজদের সালাতে বিনয়াবনত।”</span> <span class="c5">[সূরা আল-মু’মিনূন.<span class="c6">আয়াত:</span> ১-২]</span> </p>',
            ],
            34 => [
                'question' => 'প্রশ্ন ৩৫: যাকাতের সংজ্ঞা দাও।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5120.mp3',
                'answer' => '<p> উত্তর: নির্দিষ্ট সময়ে, বিশেষ লোকের জন্য বিশেষ সম্পদে আবশ্যক <span class="c2">(ফরয)</span> অধিকার।<br /> - এটি ইসলামের রুকনসমূহের মধ্যে একটি অন্যতম রুকন। আবশ্যক দান, যা ধনীদের কাছ থেকে গ্রহণ করা হয়,<span class="c6"> আর ফকীরদের মধ্যে বণ্টন করা হয়।<br /> আল্লাহ তা‘আলা বলেছেন:</span> وَآتُوا الزَّكَاةَ <span class="c1">“এবং তোমরা যাকাত আদায় কর”</span> <span class="c5">[সূরা আল-বাকারাহ,<span class="c6"> আয়াত:</span> ৪৩]</span> </p>',
            ],
            35 => [
                'question' => 'প্রশ্ন ৩৬: মুস্তাহাব সদকা কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5170.mp3',
                'answer' => '<p> উত্তর: এগুলো যাকাত ছাড়া অন্যান্য দান <span class="c2">(সদকা)</span>,<span class="c6"> যেমন:</span> যে কোন সময়ে ভালো উদ্দেশ্যে দান-<span class="c6">সদকা করা।<br /> আল্লাহ তা‘আলা বলেছেন:</span> وَأَنْفِقُوا فِي سَبِيلِ اللَّهِ <span class="c1">“এবং তোমরা আল্লাহর রাস্তায় ব্যয় কর।”</span> <span class="c5">[সূরা আল-বাকারাহ,<span class="c6"> আয়াত:</span> ১৯৫]</span> </p>',
            ],
            36 => [
                'question' => 'প্রশ্ন ৩৭: সিয়ামের পরিচয় দাও।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5210.mp3',
                'answer' => '<p> উত্তর: সিয়াম হচ্ছে: নিয়তের সাথে ফজর উদিত হওয়া থেকে সূর্যাস্ত পর্যন্ত সিয়াম ভঙ্গকারী বিষয়সমূহ থেকে বিরত থাকার মাধ্যমে আল্লাহ তা‘আলার ইবাদাত করা।<br /> সিয়াম দুই প্রকার:<br /> ফরয <span class="c2">(আবশ্যক)</span> সিয়াম: যেমন রমাদ্বান মাসের সিয়াম,<span class="c6"> এটি ইসলামের রুকনসমুহ হতে একটি রুকন।<br /> আল্লাহ তা‘আলা বলেছেন:</span> يَا أَيُّهَا الَّذِينَ آمَنُوا كُتِبَ عَلَيْكُمُ الصِّيَامُ كَمَا كُتِبَ عَلَى الَّذِينَ مِنْ قَبْلِكُمْ لَعَلَّكُمْ تَتَّقُونَ <span class="c1">“হে মুমিনগণ ! তোমাদের জন্য সিয়ামের বিধান দেওয়া হল, যেমন বিধান তোমাদের পূর্ববর্তীদেরকে দেওয়া হয়েছিল, যাতে তোমরা তাকওয়ার অধিকারী হতে পার।”</span> <span class="c2">(১৮৩)</span> <span class="c5">[সূরা আল-বাকারাহ,<span class="c6"> আয়াত:</span> ১৮৩]</span><br /> আবশ্যক নয় এমন সিয়াম: যেমন: প্রতি সপ্তাহে সোমবার ও বৃহষ্পতিবারে সিয়াম পালন করা, প্রতি মাসে তিনদিন সিয়াম পালন করা আর এক্ষেত্রে সবচেয়ে উত্তম হচ্ছে আইয়ামে বীদ তথা প্রতি চন্দ্র মাসের ১৩, ১৪ ও ১৫ তারিখে সিয়াম পালন। </p>',
            ],
            37 => [
                'question' => 'প্রশ্ন ৩৮: রমাদ্বান মাসে সিয়াম পালনের ফযীলত উল্লেখ কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5270.mp3',
                'answer' => '<p> উত্তর: আবূ হুরায়রা রাদিয়াল্লাহু ‘আনহু সূত্রে বর্ণিত,<span class="c6"> রাসূলুল্লাহ সাল্লাল্লাহু আলাইহি ওয়াসাল্লাম বলেছেন:</span> من صام رمضان إيمانا ً واحتساباً؛ غُفِر له ما تقدم من ذنبه <span class="c1">“যে ব্যক্তি ঈমান ও সাওয়াবের আশায় রমাদ্বানের সিয়াম পালন করে, তার অতীতের গুনাহসমূহ মাফ করে দেওয়া হয়।”</span> মুত্তাফাকুন ‘আলাইহি। </p>',
            ],
            38 => [
                'question' => 'প্রশ্ন ৩৯: রমাদ্বান ব্যতীত অন্য সময়ে নফল সিয়ামের ফযীলত উল্লেখ কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5300.mp3',
                'answer' => '<p> উত্তর: আবূ সা‘ঈদ আল-খুদরী রদিয়াল্লাহু আনহু থেকে বর্ণিত,<span class="c6"> তিনি বলেছেন:</span> রাসূলুল্লাহ সাল্লাল্লাহু আলাইহি ওয়াসাল্লাম বলেছেন: ما من عبد يصوم يومًا في سبيل الله، إلا باعد الله بذلك اليوم وجهه عن النار سبعين خريفًا <span class="c1">“যে কোন বান্দা আল্লাহর রাস্তায় একদিন সিয়াম পালন করবে, তার বিনিময়ে আল্লাহ তার চেহারাকে জাহান্নাম থেকে সত্তর বছরের দূরত্বে অবস্থান করাবেন।”</span> মুত্তাফাকুন ‘আলাইহি।<br /> سبعين خريفًا <span class="c2">(সাব‘ঈনা খরীফা)</span> শব্দটির অর্থ: সত্তর বছর। </p>',
            ],
            39 => [
                'question' => 'প্রশ্ন ৪০: সিয়াম ভঙ্গের কতিপয় কারণ উল্লেখ কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5330.mp3',
                'answer' => '<p> উত্তর: ১- ইচ্ছাকৃতভাবে পানাহার করা।<br /> ২- ইচ্ছাকৃতভাবে বমি করা।<br /> ৩- ইসলাম থেকে মুরতাদ হয়ে যাওয়া। </p>',
            ],
            40 => [
                'question' => 'প্রশ্ন ৪১: সিয়ামের সুন্নাতসমূহ কী কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5380.mp3',
                'answer' => '<p> উত্তর: ১- দ্রুত ইফতার করা।<br /> ২- সাহরী খাওয়া এবং তাতে বিলম্ব করা।<br /> ৩- উত্তম কাজ ও ইবাদাতের পরিমাণ বাড়িয়ে দেওয়া।<br /> ৪-<span class="c6"> কেউ গালি দিলে এ কথা বলা:</span> আমি সিয়াম পালনকারী।<br /> ৫- ইফতারের সময়ে দু‘আ করা।<br /> ৬- তাজা খেজুর দ্বারা অথবা শুকনা খেজুর দ্বারা ইফতার করা, যদি তা না পাওয়া যায়, তবে পানি দ্বারা <span class="c2">(শুরু করা)</span>। </p>',
            ],
            41 => [
                'question' => 'প্রশ্ন ৪২: হজ্জের পরিচয় দাও।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5460.mp3',
                'answer' => '<p> উত্তর: হজ্জ হচ্ছে: নির্দিষ্ট সময়ে, নির্দিষ্ট আমলের দ্বারা বাইতুল হারামের <span class="c2">(যিয়ারত করার)</span> প্রতি ইচ্ছা পোষন করার মাধ্যমে আল্লাহ তা‘আলার ইবাদাত পালন করা।<br /> আল্লাহ তা‘আলা বলেছেন: وَلِلَّهِ عَلَى النَّاسِ حِجُّ الْبَيْتِ مَنِ اسْتَطَاعَ إِلَيْهِ سَبِيلًا وَمَنْ كَفَرَ فَإِنَّ اللَّهَ غَنِيٌّ عَنِ الْعَالَمِينَ <span class="c1">“এবং সামর্থ্যবান মানুষের উপর আল্লাহর জন্য বায়তুল্লাহর হজ্জ করা ফরয। আর যে কুফরী করে, তবে আল্লাহ তো নিশ্চয় সৃষ্টিকুল থেকে অমুখাপেক্ষী।”</span> <span class="c5">[সূরা আলে-ইমরান,<span class="c6"> আয়াত:</span> ৯৭]</span> </p>',
            ],
            42 => [
                'question' => 'প্রশ্ন ৪৩: হজ্জের রুকনসমূহ উল্লেখ কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5500.mp3',
                'answer' => '<p> উত্তর: ০১- ইহরাম।<br /> ০২- আরাফায় অবস্থান করা।<br /> ০৩- তাওয়াফে ইফাদ্বাহ করা।<br /> ০৪- সাফা ও মারওয়ার মধ্যে সা‘ঈ করা। </p>',
            ],
            43 => [
                'question' => 'প্রশ্ন ৪৪: হজ্জের ফযীলত কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5560.mp3',
                'answer' => '<p> উত্তর: আবূ হুরায়রা রাদিয়াল্লাহু আনহু থেকে বর্ণিত, তিনি বলেন,<span class="c6"> আমি রাসূলুল্লাহ সাল্লাল্লাহু আলাইহি ওয়াসাল্লামকে বলতে শুনেছি:</span> من حج لله فلم يرفث ولم يفسق؛ رجع كيوم ولدته أمهمن حج لله فلم يرفث ولم يفسق؛ رجع كيوم ولدته أمه <span class="c1">“যে ব্যক্তি হজ পালন করল এবং <span class="c2">(তাতে)</span> কোনো অশ্লীল কাজ করল না ও পাপাচার করল না, সে ব্যক্তি ঠিক ঐ দিনকার মত <span class="c2">(নিষ্পাপ হয়ে)</span> বাড়ি ফিরবে, যেদিন তার মা তাকে প্রসব করেছিল।”</span> বুখারী ও অন্যান্য মুহাদ্দিসগণ এটি বর্ণনা করেছেন।<br /> <span class="c1">“যেমন তার মাতা তাকে প্রসব করার দিনে <span class="c2">(নিষ্পাপ)</span> ছিল।”</span> এর অর্থ হচ্ছে: কোন পাপ ছাড়া তথা নিষ্পাপ। </p>',
            ],
            44 => [
                'question' => 'প্রশ্ন ৪৫: উমরাহর পরিচয় দাও।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5600.mp3',
                'answer' => '<p> উত্তর: অনির্দিষ্ট সময়ে, নির্দিষ্ট আমলের দ্বারা বাইতুল হারামের <span class="c2">(যিয়ারত করার)</span> প্রতি ইচ্ছা পোষন করার মাধ্যমে আল্লাহ তা‘আলার ইবাদাত পালন করা। </p>',
            ],
            45 => [
                'question' => 'প্রশ্ন ৫৬: উমরাহর রুকনসমূহ কী কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5630.mp3',
                'answer' => '<p> উত্তর: ০১- ইহরাম।<br /> ০২- বাইতুল্লাহর তাওয়াফ করা।<br /> ০৩- সাফা ও মারওয়ার মধ্যে সা‘ঈ করা। </p>',
            ],
            46 => [
                'question' => 'প্রশ্ন ৪৭: আল্লাহর রাস্তায় জিহাদ কাকে বলে?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5690.mp3',
                'answer' => '<p> উত্তর: ইসলাম প্রচার-প্রসারে শ্রম ও প্রচেষ্টা ব্যয় করা,<span class="c6"> ইসলাম ও মুসলিমদের প্রতিরক্ষা নিশ্চিত করা অথবা ইসলাম ও মুসলিমদের শত্রুর সাথে যুদ্ধে লিপ্ত হওয়া।<br /> আল্লাহ তা‘আলা বলেছেন:</span> وَجَاهِدُوا بِأَمْوَالِكُمْ وَأَنْفُسِكُمْ فِي سَبِيلِ اللَّهِ ذَلِكُمْ خَيْرٌ لَكُمْ إِنْ كُنْتُمْ تَعْلَمُونَ <span class="c1">“আর তোমরা তোমাদের সম্পদ ও জীবন দিয়ে আল্লাহর রাস্তায় জিহাদ কর। সেটিই তোমাদের জন্য উত্তম, যদি তোমরা তা জেনে থাক।”</span> <span class="c5">[সূরা আত-তাওবাহ,<span class="c6"> আয়াত:</span> ৪১]</span>। </p>',
            ],
        ],
        3 => [
            0 => [
                'question' => 'প্রশ্ন ০১: আমাদের নবী মুহাম্মাদ সাল্লাল্লাহু আলাইহি ওয়াসাল্লামের বংশ পরিচয় কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5740.mp3',
                'answer' => '<p> তিনি হচ্ছেন মুহাম্মাদ ইবনু আব্দিল্লাহ ইবনু আব্দিল মুত্তালিব ইবনু হাশিম, আর হাশিম ছিলেন কুরাইশের মধ্য হতে, কুরাইশ আরবদের মধ্য হতে আর আরব ইবরাহীম খলীলের পুত্র ইসমাঈলের বংশধর। তার উপরে এবং আমাদের নবীর উপরে আল্লাহর সর্বোত্তম সালাত ও সালাম বর্ষিত হোক। </p>',
            ],
            1 => [
                'question' => 'প্রশ্ন ০২: আমাদের নবী (সাল্লাল্লাহু আলাইহি ওয়াসাল্লাম) এর মাতার নাম কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5770.mp3',
                'answer' => '<p> উত্তর: আমিনাহ বিনতু ওয়াহাব। </p>',
            ],
            2 => [
                'question' => 'প্রশ্ন ০৩: তার পিতা কখন মারা যান?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5800.mp3',
                'answer' => '<p> উত্তর: তিনি গর্ভে থাকা অবস্থায় তার জন্ম গ্রহণের আগেই তার পিতা মদীনাতে মারা যান। </p>',
            ],
            3 => [
                'question' => 'প্রশ্ন ০৪: নবী সাল্লাল্লাহু আলাইহি ওয়াসাল্লাম কখন জন্মগ্রহণ করেন?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5830.mp3',
                'answer' => '<p> উত্তর: হস্তির বছরে, রবীউল আওয়াল মাসের সোমবারে। </p>',
            ],
            4 => [
                'question' => 'প্রশ্ন ০৫: তিনি কোন স্থানে জন্মগ্রহণ করেন?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5850.mp3',
                'answer' => '<p> উত্তর: মক্কায়। </p>',
            ],
            5 => [
                'question' => 'প্রশ্ন ০৬: মা ছাড়া তাকে কারা কারা দুধপান ও লালন পালন করিয়েছেন?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5880.mp3',
                'answer' => '<p> উত্তর: তার পিতার মুক্ত দাসী উম্মু আয়মান,<br /> তার চাচা আবু লাহাবের মুক্ত দাসী ছুওয়াইবাহ<br /> এবং হালীমাহ আস-সা‘দিয়্যাহ। </p>',
            ],
            6 => [
                'question' => 'প্রশ্ন ০৭: তার মাতা কখন মারা যান?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5930.mp3',
                'answer' => '<p> উত্তর: তার বয়স যখন ছয় বছর, তখন তার মা মারা যান। অতপর তার দাদা আব্দুল মুত্তালিব তার দায়িত্ব গ্রহণ করেন। </p>',
            ],
            7 => [
                'question' => 'প্রশ্ন ০৮: তার দাদা আব্দুল মুত্তালিব মারা যাওয়ার পরে কে তার দায়িত্ব গ্রহণ করেন?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5960.mp3',
                'answer' => '<p> উত্তর: তার বয়স যখন আট বছর, তখন তার দাদা আব্দুল মুত্তালিব মারা যান। আর তখন তার চাচা আবু ত্বালিব তার দায়িত্ব গ্রহণ করেন। </p>',
            ],
            8 => [
                'question' => 'প্রশ্ন ০৯: তিনি কখন তার চাচার সাথে শামে (সিরিয়াতে) সফর করেছিলেন?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5990.mp3',
                'answer' => '<p> উত্তর: তিনি তার চাচার সাথে শামে <span class="c2">(সিরিয়াতে)</span> সফর করেছিলেন, যখন তার বয়স বারো বছর। </p>',
            ],
            9 => [
                'question' => 'প্রশ্ন ১০: তিনি দ্বিতীয়বার কখন সফর করেছিলেন?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6020.mp3',
                'answer' => '<p> উত্তর: খাদীজা রদিয়াল্লাহু আনহার বানিজ্যিক সম্পদ নিয়ে তিনি সেখানে দ্বিতীয়বার সফর করেন। সেখান থেকে ফেরার পরেই তিনি খাদীজা রদিয়াল্লাহু আনহাকে বিবাহ করেন। তখন তার বয়স ছিল পঁচিশ বছর। </p>',
            ],
            10 => [
                'question' => 'প্রশ্ন ১১: কুরাইশরা কখন কা‘বা গৃহকে পুনরায় নির্মাণ করেছিল?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6050.mp3',
                'answer' => '<p> উত্তর: কুরাইশরা কা‘বা গৃহকে পুনরায় নির্মাণ করেছিল, যখন তার বয়স পয়ত্রিশ বছর ছিল।<br /> এ সময়ে হাজারে আসওয়াদ স্থাপন করা নিয়ে নিজেদের মধ্যে বিরোধ হলে কুরাইশরা তাকে সালিশ মেনেছিল। তখন তিনি এটিকে একটি কাপড়ের মধ্যে রেখে, কুরাইশদের সকল গোত্রকে উক্ত কাপড়ের কোনা ধরতে পরামর্শ দিয়েছিলেন। আর তারাও মোট চারটি গোত্রে বিভক্ত ছিল। যখন তারা কাপড় ধরে সেটিকে উঁচু করল, তখন তিনি <span class="c2">(সাল্লাল্লাহু আলাইহি ওয়াসাল্লাম)</span> নিজে হাতে সেটিকে যথার্থ স্থানে স্থাপন করেন। </p>',
            ],
            11 => [
                'question' => 'প্রশ্ন ১২: নবুওয়ত প্রাপ্তির সময়ে তার বয়স কত ছিল? এবং তিনি কাদের প্রতি প্রেরিত হয়েছিলেন?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6080.mp3',
                'answer' => '<p> উত্তর: তার বয়স তখন চল্লিশ বছর ছিল। তিনি সকল মানুষের কাছে সতর্ককারী ও সুসংবাদদাতা হিসেবে প্রেরিত হয়েছেন। </p>',
            ],
            12 => [
                'question' => 'প্রশ্ন ১৩: প্রথম অহী কিসের মাধ্যমে শুরু হয়েছিল?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6110.mp3',
                'answer' => '<p> উত্তর: সত্য স্বপ্ন, তিনি যে স্বপ্নই দেখতেন, তা সকালের মতই প্রতিফলিত হত। </p>',
            ],
            13 => [
                'question' => 'প্রশ্ন ১৪: অহী নাযিলের পূর্বে তার অবস্থা কেমন ছিল? আর কখন তার উপরে প্রথমবারের মত অহী নাযিল হয়েছিল?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6140.mp3',
                'answer' => '<p> উত্তর: তিনি খাদ্য সামগ্রী নিয়ে হেরা গুহাতে যেয়ে আল্লাহর ইবাদাত করতেন।<br /> আর এরপরে তার কাছে অহী নাযিল হয়, তখনও তিনি গুহার মধ্যে ইবাদাত করছিলেন। </p>',
            ],
            14 => [
                'question' => 'প্রশ্ন ১৫: তার উপরে কুরআনের সর্বপ্রথম কোন আয়াত নাযিল হয়েছিল?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6180.mp3',
                'answer' => '<p> উত্তর: আল্লাহ তা‘আলা বলেছেন: ٱقۡرَأۡ بِٱسۡمِ رَبِّكَ ٱلَّذِي خَلَقَ <span class="c1">“পড়ুন আপনার রবের নামে, যিনি সৃষ্টি করেছেন <span class="c2">(১)</span>–”</span> خَلَقَ ٱلۡإِنسَـنَ مِنۡ عَلَقٍ <span class="c1">“সৃষ্টি করেছেন মানুষকে জমাটবদ্ধ রক্ত হতে <span class="c2">(২)</span>”</span> ٱقۡرَأۡ وَرَبُّكَ ٱلۡأَكۡرَمُ 3 <span class="c1">“পড়ুন, আর আপনার রব মহামহিমান্বিত। <span class="c2">(৩)</span>”</span> ٱلَّذِي عَلَّمَ بِٱلۡقَلَمِ 4 <span class="c1">“যিনি কলমের সাহায্যে শিক্ষা দিয়েছেন। <span class="c2">(৪)</span>”</span> عَلَّمَ ٱلۡإِنسَـنَ مَا لَمۡ يَعۡلَمۡ 5 <span class="c1">“শিক্ষা দিয়েছেন মানুষকে যা সে জানত না। <span class="c2">(৫)</span>”</span> <span class="c5">[সূরা আল-<span class="c6">‘আলাক:</span> ১-৫]</span> </p>',
            ],
            15 => [
                'question' => 'প্রশ্ন ১৬: তার রিসালাতের উপরে সর্বপ্রথম কে ঈমান এনেছিলেন?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6200.mp3',
                'answer' => '<p> উত্তর: পুরুষদের মধ্য হতে: আবূূূূূূূূূূূ বাকর,<span class="c6"> নারীদের মধ্য হতে:</span> খাদীজাহ বিনতু খুওয়াইলিদ,<span class="c6"> বালকদের মধ্য হতে:</span> আলী ইবনু আবী ত্বালিব,<span class="c6"> মুক্তদাসদের মধ্য হতে:</span> যাইদ ইবনু হারিছাহ,<span class="c6"> দাসদের মধ্য হতে:</span> বিলাল হাবশী রদিয়াল্লাহু আনহুম আজমা‘ঈন সহ আরো অনেকে। </p>',
            ],
            16 => [
                'question' => 'প্রশ্ন ১৭: ইসলামের দিকে দাও‘আতের অবস্থা (তখন) কেমন ছিল?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6230.mp3',
                'answer' => '<p> উত্তর: প্রায় তিন বছর পর্যন্ত দাও‘আত গোপনীয় ছিল। তারপর রাসূল সাল্লাল্লাহু আলাইহি ওয়াসাল্লামকে প্রকাশ্যে দাও‘আত দেওয়ার নির্দেশ দেওয়া হয়। </p>',
            ],
            17 => [
                'question' => 'প্রশ্ন ১৮: নবী সাল্লাল্লাহু আলাইহি ওয়াসাল্লাম ও যারা ঈমান এনেছিল, দাও‘আত প্রকাশ্যে আসার পরে তাদের অবস্থা কেমন ছিল?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6260.mp3',
                'answer' => '<p> উত্তর: তাকে এবং মুসলিমদের উপরে অত্যাচারের ব্যাপারে মুশরিকরা অত্যন্ত বাড়াবাড়ি করেছিল; এমনকি এ কারণে তিনি মুমিনদেরকে হাবশাতে নাজাশীর কাছে হিজরতের আদেশ দিয়েছিলেন।<br /> মুশরিকরা তাকে কষ্ট দেওয়া ও হত্যা করার ব্যাপারে একমত হয়েছিল, তখন আল্লাহ তা‘আলা তাকে রক্ষা করলেন এবং তার চাচা আবু ত্বালিবের মাধ্যমে তাকে নিরাপত্তা বেষ্টনীতে ঘিরে রাখলেন; যাতে করে তিনি তাকে নিরাপদ রাখতে পারেন। </p>',
            ],
            18 => [
                'question' => 'প্রশ্ন ১৯: নবী সাল্লাল্লাহু আলাইহি ওয়াসাল্লামের নবুওয়তের দশম বছরে কে কে মারা যান?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6300.mp3',
                'answer' => '<p> উত্তর: তার চাচা আবু ত্বালিব ও তার স্ত্রী খাদীজাহ রদিয়াল্লাহু আনহা মারা যান। </p>',
            ],
            19 => [
                'question' => 'প্রশ্ন ২০: ইসরা ও মি‘রাজ কখন সংঘটিত হয়েছিল?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6330.mp3',
                'answer' => '<p> উত্তর: যখন রাসূলের বয়স পঞ্চাশ বছর ছিল এবং তখন তার উপরে পাঁচ ওয়াক্ত সালাত ফরয করা হয়।<br /> ইসরা: মাসজিদে হারাম থেকে মাসজিদে আকসা পর্যন্ত <span class="c2">(রাতে ভ্রমন করা)</span>।<br /> মি‘রাজ: মাসজিদে আকসা থেকে আসমান, <span class="c2">(সেখান থেকে)</span> সিদরাতুল মুনতাহা পর্যন্ত। </p>',
            ],
            20 => [
                'question' => 'প্রশ্ন ২১: মক্কার বাইরে নবী সাল্লাল্লাহু আলাইহি ওয়াসাল্লাম মানুষকে কিভাবে দাও‘আত দিতেন?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6380.mp3',
                'answer' => '<p> উত্তর: তিনি তায়েফের অধিবাসীদের কাছে দাও‘আত দিতেন এবং মানুষের একত্রিত হওয়ার স্থান ও বিভিন্ন মওসুমে তিনি নিজেকে <span class="c2">(দা‘ঈ হিসেবে)</span> পেশ করতেন। এভাবে একদিন মদীনার আনসারগণ আসলেন, এরপরে তারা নবী সাল্লাল্লাহু আলাইহি ওয়াসাল্লামের উপরে ঈমান আনলেন আর তাকে সাহায্য-সহযোগিতা করার ব্যাপারে বাই‘আত গ্রহণ করেন। </p>',
            ],
            21 => [
                'question' => 'প্রশ্ন ২২: নবী সাল্লাল্লাহু আলাইহি ওয়াসাল্লাম মক্কাতে কত বছর দাও‘আত দিয়েছিলেন?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6410.mp3',
                'answer' => '<p> উত্তর: তিনি তেরো বছর যাবত দাও‘আত দিয়েছিলেন। </p>',
            ],
            22 => [
                'question' => 'প্রশ্ন ২৩: নবী সাল্লাল্লাহু আলাইহি ওয়াসাল্লাম কোথায় হিজরত করেছিলেন?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6440.mp3',
                'answer' => '<p> উত্তর: মক্কা থেকে মদীনায়। </p>',
            ],
            23 => [
                'question' => 'প্রশ্ন ২৪: তিনি মদীনাতে কতদিন ছিলেন?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6470.mp3',
                'answer' => '<p> উত্তর: দশ বছর। </p>',
            ],
            24 => [
                'question' => 'প্রশ্ন ২৫: মদীনাতে ইসলামী শরী‘আতের কী কী বিধান তার উপর ফরয করা হয়?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6490.mp3',
                'answer' => '<p> উত্তর: <span class="c2">(মদীনাতে)</span> তার উপরে যাকাত, সিয়াম,হজ্জ, জিহাদ, আযান ও শরী‘আতের অন্যান্য বিধান ফরয করা হয়। </p>',
            ],
            25 => [
                'question' => 'প্রশ্ন ২৬: নবী সাল্লাল্লাহু আলাইহি ওয়াসাল্লামের সবচেয়ে গুরুত্বপূর্ণ যুদ্ধ কী কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6520.mp3',
                'answer' => '<p> উত্তর: বদরের বড় যুদ্ধ,<br /> উহুদের যুদ্ধ,<br /> আহযাবের যুদ্ধ,<br /> এবং মক্কা বিজয়ের যুদ্ধ। </p>',
            ],
            26 => [
                'question' => 'প্রশ্ন ২৭: কুরআনের সর্বশেষ কোন আয়াত নাযিল হয়েছিল?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6580.mp3',
                'answer' => '<p> উত্তর: আল্লাহ তা‘আলার বাণী: وَٱتَّقُوا يوۡمًا تُرۡجَعُونَ فِيهِ إِلَى ٱللَّهِۖ ثُمَّ تُوَفَّى كُلُّ نَفۡسٍ مَّا كَسَبَتۡ وَهُمۡ لَا يُظۡلَمُونَ <span class="c1">“আর তোমরা সেই দিনের ব্যাপারে সতর্ক হও, যেদিন তোমাদেরকে আল্লাহর দিকে ফিরিয়ে নেওয়া হবে। তারপর প্রত্যেককে সে যা অর্জন করেছে তা পুরোপুরি প্রদান করা হবে। আর তাদেরকে যুলুম করা হবে না।”</span> <span class="c5">[সূরা আল-<span class="c6">বাকারাহ:</span> ২৮১]</span> </p>',
            ],
            27 => [
                'question' => 'প্রশ্ন ২৮: নবী সাল্লাল্লাহু আলাইহি ওয়াসাল্লাম কখন মারা গিয়েছিলেন এবং তার বয়স কত ছিল?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6610.mp3',
                'answer' => '<p> উত্তর: তিনি ১১ হিজরীর রবী‘উল আওয়াল মাসে মারা গিয়েছিলেন। তখন তার বয়স ছিল তেষট্টি বছর। </p>',
            ],
            28 => [
                'question' => 'প্রশ্ন ২৯: নবী সাল্লাল্লাহু আলাইহি ওয়াসাল্লামের স্ত্রীদের নাম উল্লেখ কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6640.mp3',
                'answer' => '<p> উত্তর: ১- খাদীজাহ বিনতু খুওয়াইলিদ রদিয়াল্লাহু আনহা।<br /> ২- সাওদাহ বিনতু যাম‘আহ রদিয়াল্লাহু আনহা।<br /> ৩- আয়িশাহ বিনতু আবী বাকর রদিয়াল্লাহু আনহা।<br /> ৪- হাফসাহ বিনতু ‘উমার রদিয়াল্লাহু আনহা।<br /> ৫- যাইনাব বিনতু খুযাইমাহ রদিয়াল্লাহু আনহা।<br /> ৬- উম্মু সালামাহ হিনদা বিনতু আবী উমাইয়াহ রদিয়াল্লাহু আনহা।<br /> ৭- উম্মু হাবীবাহ রামলাহ বিনতু আবী সুফিয়ান রদিয়াল্লাহু আনহা।<br /> ৮- জুয়াইরিয়াহ বিনতুল হারিছ রদিয়াল্লাহু আনহা।<br /> ৯- মাইমূনাহ বিনতুল হারিছ রদিয়াল্লাহু আনহা।<br /> ১০- সফিইয়াহ বিনতু হুওয়াই রদিয়াল্লাহু আনহা।<br /> ১১- যাইনাব বিনতু জাহাশ রদিয়াল্লাহু আনহা। </p>',
            ],
            29 => [
                'question' => 'প্রশ্ন ৩০: নবী সাল্লাল্লাহু আলাইহি ওয়াসাল্লামের সন্তানগণ কারা ছিলেন?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6760.mp3',
                'answer' => '<p> উত্তর: ছেলে সন্তান তিনজন:<br /> আল-কাসিম, তার নামেই রাসূলের উপনাম ছিল,<span class="c6"><br /> আব্দুল্লাহ<br /> এবং ইবরাহীম।<br /> কন্যা সন্তান:</span><br /> ফাতিমাহ,<br /> রুকাইয়াহ,<br /> উম্মু কালছূম<br /> এবং যাইনাব।<br /> ইবরাহীম ব্যতীত তার প্রতিটি সন্তানই খাদীজাহ রদিয়াল্লাহু আনহার গর্ভ হতে জন্ম গ্রহণ করেছিল, আর ফাতিমাহ ছাড়া সকলেই তার পূর্বেই মারা গিয়েছেন, আর ফাতিমাহ <span class="c2">(তার ওফাতের)</span> ছয়মাস পরে মারা গিয়েছিলেন। </p>',
            ],
            30 => [
                'question' => 'প্রশ্ন ৩১: নবী সাল্লাল্লাহু আলাইহি ওয়াসাল্লামের সৃষ্টিগত কয়েকটি বৈশিষ্ট্য বর্ণনা কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6880.mp3',
                'answer' => '<p> উত্তর: রাসূল সাল্লাল্লাহু আলাইহি ওয়াসাল্লাম খাটোও ছিলেন না, আবার খুব লম্বাও ছিলেন না; বরং উভয়ের মাঝামাঝি ছিলেন। রাসূল সাল্লাল্লাহু আলাইহি ওয়াসাল্লাম লাল মিশ্রিত সাদা বর্ণের ছিলেন। তার দাঁড়ি ঘন ছিল। চোখ দুটি প্রশস্ত, বড় গাল বিশিষ্ট, চুল কুচকুচে কালো, কাঁধদুটি প্রশস্ত ও সুন্দর ঘ্রাণবিশিষ্ট ছিলেন। এ ছাড়াও আরো অনেক সুন্দর বৈশিষ্ট্য ছিল। </p>',
            ],
            31 => [
                'question' => 'প্রশ্ন ৩১: নবী সাল্লাল্লাহু আলাইহি ওয়াসাল্লাম তার উম্মাতকে কীসের উপরে রেখে গেছেন?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6910.mp3',
                'answer' => '<p> উত্তর: তার উম্মাতকে তিনি শুভ্র পথের <span class="c2">(সুষ্পষ্ট দলিলের)</span> উপরে রেখে গেছেন, যার রাত তার দিনের মতই, ধংসে নিপতিত ব্যক্তি ছাড়া কেউই সেখান থেকে বিচ্যুত হয় না, উম্মাতের জন্য প্রতিটি কল্যাণের কথাই তিনি ইঙ্গিত করেছেন, আর প্রতিটি অকল্যাণ থেকেও সতর্ক করেছেন। </p>',
            ],
        ],
        4 => [
            0 => [
                'question' => 'প্রশ্ন ০১: সূরা ফাতিহা পাঠ কর এবং তা ব্যাখ্যা কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6960.mp3',
                'answer' => '<p> উত্তর: সূরা ফাতিহা এবং তার ব্যাখ্যা:<br /> بِسْمِ اللهِ الرَّحْمنِ الرَّحِيمِ <span class="c1">“রহমান ও রহীম আল্লাহর নামে।”</span> <span class="c2">(১)</span> الْحَمْدُ للّهِ رَبِّ الْعَالَمِينَ <span class="c1">“সকল প্রশংসা সৃষ্টিকুলের রব আল্লাহরই প্ৰাপ্য।”</span> <span class="c2">(২)</span> الرَّحْمـنِ الرَّحِيمِ <span class="c1">“পরম করুণাময়, অতি দয়ালু।”</span> <span class="c2">(৩)</span> مَالِكِ يَوْمِ الدِّينِ <span class="c1">“বিচার দিনের মালিক।”</span> <span class="c2">(৪)</span> إِيَّاكَ نَعْبُدُ وَإِيَّاكَ نَسْتَعِينُ <span class="c1">“আমরা শুধু আপনারই ‘ইবাদাত করি, এবং শুধু আপনারই সাহায্য প্রার্থনা করি”</span> <span class="c2">(৫)</span> اهدِنَــــا الصِّرَاطَ المُستَقِيمَ <span class="c1">“আমাদেরকে সরল-সুদৃঢ় পথের হিদায়াত দিন।”</span> <span class="c2">(৬)</span> صِرَاطَ الَّذِينَ أَنعَمتَ عَلَيهِمْ غَيرِ المَغضُوبِ عَلَيهِمْ وَلاَ الضَّالِّينَ <span class="c1">“তাদের পথ, যাদেরকে আপনি নি‘আমাত দিয়েছেন, যাদের উপর আপনার ক্রোধ আপতিত হয়নি এবং যারা পথভ্রষ্টও নয়।”</span> <span class="c2">(৭)</span> <span class="c5">[আল-<span class="c6">ফাতিহা:</span> ১-৭]</span><br /> তাফসীর:<br /> সূরাটির নাম আল-ফাতিহা; যেহেতু এর দ্বারা আল্লাহর কিতাব শুরু করা হয়েছে।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001001.mp3"></audio> ১- بِسْمِ اللهِ الرَّحْمنِ الرَّحِيمِ <span class="c1">“রহমান ও রহীম আল্লাহর নামে”</span> অর্থাৎ আমি কুরআন পাঠ শুরু করছি আল্লাহ তা‘আলার নামে, তাঁর সাহায্য কামনা এবং তাঁর নাম উচ্চারণের মাধ্যমে বরকত লাভের আশায়।<br /> الله <span class="c1">“আল্লাহ” তথা: প্রকৃত ইবাদাতপ্রাপ্তির হকদার, আর আল্লাহ ছাড়া অন্য কাউকে এ নামে নামকরণ করা যায় না।<br /> <span class="c4">{الرَّحْمَن}</span> বা “আর-রহমান”</span> তথা: প্রশস্ত রহমতের মালিক, যে রহমত সকল কিছুকে পরিবেষ্টিত করেছে।<br /> <span class="c4">{الرَّحِيم}</span> <span class="c1">“আর-<span class="c6">রহীম” তথা:</span> মুমিনদের জন্য বিশেষ রহমতের মালিক।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001002.mp3"></audio> ২- الْحَمْدُ للّهِ رَبِّ الْعَالَمِينَ “সকল প্রশংসা সৃষ্টিকুলের রব আল্লাহরই প্ৰাপ্য।”</span> অর্থাৎ সকল প্রকার প্রশংসা এবং পূর্ণতা শুধুমাত্র আল্লাহ তা‘আলার জন্যই নির্দিষ্ট।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001003.mp3"></audio> ৩- الرَّحْمـنِ الرَّحِيمِ <span class="c1">“পরম করুণাময়, অতি দয়ালু।”</span> অর্থাৎ প্রশস্ত রহমতের মালিক, যে রহমত সকল কিছুকে পরিবেষ্টিত করেছে এবং মুমিনদের কাছে বিশেষভাবে পৌঁছানো রহমতের মালিক।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001004.mp3"></audio> ৪- مَالِكِ يَوْمِ الدِّينِ <span class="c1">“বিচার দিনের মালিক।”</span>: এটি হচ্ছে কিয়ামাতের দিন।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001005.mp3"></audio> ৫- إِيَّاكَ نَعْبُدُ وَإِيَّاكَ نَسْتَعِينُ <span class="c1">“আমরা শুধু আপনারই ‘ইবাদাত করি, এবং শুধু আপনারই সাহায্য প্রার্থনা করি।”</span> অর্থাৎ একমাত্র আপনারই ইবাদাত করি, আর আপনার কাছেই শুধু সাহায্য চাই।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001006.mp3"></audio> ৬- اهدِنَــــا الصِّرَاطَ المُستَقِيمَ <span class="c1">“আমাদেরকে সরল-সুদৃঢ় পথের হিদায়াত দিন।”</span>: এটা হচ্ছে: ইসলাম ও সুন্নাহর দিকে হিদায়াত <span class="c2">(পথের দিশা)</span>।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001007.mp3"></audio> ৭- صِرَاطَ الَّذِينَ أَنعَمتَ عَلَيهِمْ غَيرِ المَغضُوبِ عَلَيهِمْ وَلاَ الضَّالِّينَ <span class="c1">“তাদের পথ, যাদেরকে আপনি নি‘আমাত দিয়েছেন, যাদের উপর আপনার ক্রোধ আপতিত হয়নি এবং যারা পথভ্রষ্টও নয়।”</span> তথা: নবীগণ ও তাদের অনুসারী আল্লাহর সৎ বান্দাদের পথ, যেটি ইহুদী ও নাসারাদের পথ নয়।<br /> - এ সূরাটি পাঠ করার পরে <span class="c1">“আমীন” বলা সুন্নাত। “হে আল্লাহ আমাদের দু‘আ কবুল করুন।”</span> </p>',
            ],
            1 => [
                'question' => 'প্রশ্ন ২: সূরা যিলযাল পাঠ কর এবং তা ব্যাখ্যা কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7130.mp3',
                'answer' => '<p> উত্তর: সূরা যিলযাল এবং তার ব্যাখ্যা:<br /> بِسْمِ اللهِ الرَّحْمنِ الرَّحِيمِ রহমান ও রহীম আল্লাহর নামে।<br /> إِذَا زُلْزِلَتِ الْأَرْضُ زِلْزَالَهَا: <span class="c1">“যখন প্ৰবল কম্পনে যমীন প্ৰকম্পিত করা হবে, <span class="c2">(১)</span> وَأَخْرَجَتِ الْأَرْضُ أَثْقَالَهَا: আর যমীন তার ভার বের করে দেবে, <span class="c2">(২)</span> وَقَالَ الْإِنْسَانُ مَا لَهَا: আর মানুষ বলবে, ‘এর কী হল?’ <span class="c2">(৩)</span> يَوْمَئِذٍ تُحَدِّثُ أَخْبَارَهَا: সেদিন যমীন তার বৃত্তান্ত বৰ্ণনা করবে, <span class="c2">(৪)</span> بِأَنَّ رَبَّكَ أَوْحَى لَهَا: কারণ আপনার রব তাকে নির্দেশ দিয়েছেন, <span class="c2">(৫)</span> يَوْمَئِذٍ يَصْدُرُ النَّاسُ أَشْتَاتًا لِيُرَوْا أَعْمَالَهُمْ: সেদিন মানুষ ভিন্ন ভিন্ন দলে বের হবে; যাতে তাদেরকে তাদের কৃতকর্ম দেখান যায়, <span class="c2">(৬)</span> فَمَنْ يَعْمَلْ مِثْقَالَ ذَرَّةٍ خَيْرًا يَرَهُ: “কেউ অণু পরিমাণ সৎকাজ করলে সে তা দেখতে পাবে। <span class="c2">(৭)</span> وَمَنْ يَعْمَلْ مِثْقَالَ ذَرَّةٍ شَرًّا يَرَهُ: আর কেউ অণু পরিমাণ অসৎকাজ করলে সে তাও দেখবে।”</span> <span class="c2">(৮)</span> <span class="c5">[সূরা যিলযাল: ১-৮]</span><br /> তাফসীর:<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099001.mp3"></audio> ১-<span class="c6"> إِذَا زُلْزِلَتِ الْأَرْضُ زِلْزَالَهَا:</span> <span class="c1">“যখন প্ৰবল কম্পনে যমীন প্ৰকম্পিত করা হবে,”</span>: যখন প্রচণ্ডভাবে যমীনকে নাড়ানো <span class="c2">(প্রকম্পিত করা)</span> হবে, যা কিয়ামাতের দিনে সংঘটিত হবে।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099002.mp3"></audio> ২-<span class="c6"> وَأَخْرَجَتِ الْأَرْضُ أَثْقَالَهَا:</span> <span class="c1">“আর যমীন তার ভার বের করে দেবে,”</span>: অর্থাৎ যমীন তা অভ্যন্তরে থাকা মৃতব্যক্তি ও অন্যান্য সকল বস্তু বের করে দেবে।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099003.mp3"></audio> ৩-<span class="c6"> وَقَالَ الْإِنْسَانُ مَا لَهَا:</span> আর মানুষ বলবে,<span class="c6"> ‘এর কী হল?’:</span> মানুষ তখন দিশেহারা হয়ে বলবে: যমীনের কী হল যে, এটা এমন অস্থির ও নড়াচড়া করছে?<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099004.mp3"></audio> ৪-<span class="c6"> وَقَالَ الْإِنْسَانُ مَا لَهَا:</span> আর মানুষ বলবে,<span class="c6"> ‘এর কী হল?’:</span> সেই মহাদিনে যমীন তার উপরে কৃত সকল ভালো-মন্দের ব্যাপারে সংবাদ দিয়ে দেবে।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099005.mp3"></audio> ৫-<span class="c6"> بِأَنَّ رَبَّكَ أَوْحَى لَهَا:</span> <span class="c1">“কারণ আপনার রব তাকে নির্দেশ দিয়েছেন,<span class="c6"> “:</span> যেহেতু আল্লাহ তাকে তা জানিয়ে দিবেন এবং তা প্রকাশের জন্য তাকে আদেশ দিবেন।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099006.mp3"></audio> ৬-<span class="c6"> يَوْمَئِذٍ يَصْدُرُ النَّاسُ أَشْتَاتًا لِيُرَوْا أَعْمَالَهُمْ:</span> “সেদিন মানুষ ভিন্ন ভিন্ন দলে বের হবে; যাতে তাদেরকে তাদের কৃতকর্ম দেখান যায়,<span class="c6">“:</span> সেই মহাদিনে যমীন যখন প্রকম্পিত হবে, মানুষ তার হিসাবের স্থান থেকে বিভিন্ন দলে দলে বের হয়ে যাবে, যাতে তারা দুনিয়াতে যা কাজ করেছিল তা পরষ্পরকে প্রদর্শন করতে পারে।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099007.mp3"></audio> ৭-<span class="c6"> فَمَنْ يَعْمَلْ مِثْقَالَ ذَرَّةٍ خَيْرًا يَرَهُ:</span> “কেউ অণু পরিমাণ সৎকাজ করলে সে তা দেখতে পাবে,<span class="c6">“:</span> সুতরাং যার একেবারে ক্ষুদ্র একটি পিঁপড়া পরিমাণ ভালো এবং নেকীর কাজ থাকে, সে তার সামনে তা দেখতে পাবে।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099008.mp3"></audio> ৮-<span class="c6"> وَمَنْ يَعْمَلْ مِثْقَالَ ذَرَّةٍ شَرًّا يَرَهُ:</span> “আর কেউ অণু পরিমাণ অসৎকাজ করলে সে তাও দেখবে।”</span>: আর যে ব্যক্তির উক্ত পরিমাণ কোন মন্দকাজ থাকবে, সে তার সামনে সেটিকে দেখতে পাবে। </p>',
            ],
            2 => [
                'question' => 'প্রশ্ন ৩: সূরা আল-‘আদি‘আত পাঠ কর এবং তা ব্যাখ্যা কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7270.mp3',
                'answer' => '<p> উত্তর: সূরা আল-<span class="c6">‘আদি‘আত এবং তার ব্যাখ্যা:</span><br /> بِسْمِ اللهِ الرَّحْمنِ الرَّحِيمِ রহমান ও রহীম আল্লাহর নামে।<br /> وَالْعَادِيَاتِ ضَبْحًا: <span class="c1">“শপথ ঊর্ধশ্বাসে ধাবমান অশ্বরাজির। <span class="c2">(১)</span> فَالْمُورِيَاتِ قَدْحًا: অতঃপর যারা ক্ষুরের আঘাতে অগ্নিস্ফুলিঙ্গের বিচ্ছুরন ঘটায়। <span class="c2">(২)</span> فَالْمُغِيرَاتِ صُبْحًا: অতঃপর যারা অভিযান চালায় প্রভাতকালে। <span class="c2">(৩)</span> فَأَثَرْنَ بِهِ نَقْعًا: ফলে তারা তা দ্বারা ধূলি উৎক্ষিপ্ত করে। <span class="c2">(৪)</span> فَوَسَطْنَ بِهِ جَمْعًا: তারপরে তা দ্বারা তারা শত্রুদের অভ্যন্তরে ঢুকে পড়ে। <span class="c2">(৫)</span> إِنَّ الْإِنْسَانَ لِرَبِّهِ لَكَنُودٌ: নিশ্চয় মানুষ তার রবের প্রতি অত্যন্ত অকৃতজ্ঞ। <span class="c2">(৬)</span> وَإِنَّهُ عَلَى ذَلِكَ لَشَهِيدٌ: আর নিশ্চয় সে নিজেই এ বিষয়ের সাক্ষী। <span class="c2">(৭)</span> وَإِنَّهُ لِحُبِّ الْخَيْرِ لَشَدِيدٌ: আর সে নিশ্চয় ধন-সম্পদের আসক্তিতে প্রবল। <span class="c2">(৮)</span> أَفَلَا يَعْلَمُ إِذَا بُعْثِرَ مَا فِي الْقُبُورِ: তবে কি সে জানে না, যখন কবরে যা আছে তা উত্থিত হবে। <span class="c2">(৯)</span> وَحُصِّلَ مَا فِي الصُّدُورِ: আর অন্তরে যা আছে তা প্রকাশ করা হবে। <span class="c2">(১০)</span> إِنَّ رَبَّهُمْ بِهِمْ يَوْمَئِذٍ لَخَبِيرٌ: নিশ্চয় তাদের রব সেদিন তাদের ব্যাপারে সবিশেষ অবহিত।”</span> <span class="c2">(১১)</span> <span class="c5">[সূরা আল-<span class="c6">‘আদি‘আত:</span> ১-১১]</span><br /> তাফসীর:<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100001.mp3"></audio> ১-<span class="c6"> وَالْعَادِيَاتِ ضَبْحًا:</span> <span class="c1">“শপথ ঊর্ধশ্বাসে ধাবমান অশ্বরাজির।”</span>: আল্লাহ তা‘আলা এমন ঘোড়ার কসম করেছেন, যা এমনভাবে ছুটে চলে, যাতে তারা তাদের নিজেদের ক্ষিপ্রতার সাথে ছুটে চলার শব্দ শুনতে পায়।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100002.mp3"></audio> ২-<span class="c6"> فَالْمُورِيَاتِ قَدْحًا:</span> <span class="c1">“অতঃপর যারা ক্ষুরের আঘাতে অগ্নিস্ফুলিঙ্গের বিচ্ছুরন ঘটায়।”</span>: তিনি আরো এমন ঘোড়ার শপথ করেছেন, যারা তাদের পা সজোরে পাথরের উপরে পড়ায় ক্ষুরের মাধ্যমে সেখানে আগুন জ্বালিয়ে দেয়।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100003.mp3"></audio> ৩-<span class="c6"> فَالْمُغِيرَاتِ صُبْحًا:</span> <span class="c1">“অতঃপর যারা অভিযান চালায় প্রভাতকালে।”</span> তিনি এরপরে এমন ঘোড়ার কসম করেছেন, যারা ভোরে শত্রুদের উপরে আক্রমন চালায়।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100004.mp3"></audio> ৪-<span class="c6"> فَأَثَرْنَ بِهِ نَقْعًا:</span> <span class="c1">“ফলে তারা তা দ্বারা ধূলি উৎক্ষিপ্ত করে।”</span>: যারা তাদের ছুটে চলার মাধ্যমে ধূলিকণা উড়িয়ে দেয়।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100005.mp3"></audio> ৫-<span class="c6"> فَوَسَطْنَ بِهِ جَمْعًا:</span> <span class="c1">“তারপরে তা দ্বারা তারা শত্রুদের অভ্যন্তরে ঢুকে পড়ে।“: যারা তাদের আরোহীদের নিয়ে শত্রুদের মধ্যভাগে প্রবেশ করে।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100006.mp3"></audio> ৬-<span class="c6"> إِنَّ الْإِنْسَانَ لِرَبِّهِ لَكَنُودٌ:</span> “নিশ্চয় মানুষ তার রবের প্রতি অত্যন্ত অকৃতজ্ঞ।”</span>: নিশ্চিতভাবে মানুষ তার রব তার জন্য যে কল্যাণের বস্তু নিহিত রেখেছে, তা অস্বীকারকারী।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100007.mp3"></audio> ৭-<span class="c6"> وَإِنَّهُ عَلَى ذَلِكَ لَشَهِيدٌ:</span> <span class="c1">“আর নিশ্চয় সে নিজেই এ বিষয়ের সাক্ষী।”</span>: উক্ত কল্যাণ অস্বীকারের ব্যাপারে সে নিজেই প্রত্যক্ষদর্শী। আর এটি অত্যন্ত স্পষ্ট হওয়ার কারণে সে তা প্রত্যাখ্যানও করতে পারে না।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100008.mp3"></audio> ৮-<span class="c6"> وَإِنَّهُ لِحُبِّ الْخَيْرِ لَشَدِيدٌ:</span> <span class="c1">“আর সে নিশ্চয় ধন-সম্পদের আসক্তিতে প্রবল।”</span>: আর তার সম্পত্তির প্রতি আসক্তির কারণে তা নিয়ে কৃপণতা করে।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100009.mp3"></audio> ৯-<span class="c6">أَفَلَا يَعْلَمُ إِذَا بُعْثِرَ مَا فِي الْقُبُورِ:</span> <span class="c1">“তবে কি সে জানে না, যখন কবরে যা আছে তা উত্থিত হবে।”</span>: দুনিয়া নিয়ে ধোকায় পড়ে থাকা এ মানুষ কি জানে না যে, যখন আল্লাহ তা‘আলা কবরে থাকা সকল বস্তুকে উত্থিত করবেন এবং তাদেরকে হিসাব ও প্রতিদান দেওয়ার জন্য যমীন থেকে বের করে আনবেন, তখন তারা যেমন ধারণা করেছিল প্রকৃত বিষয় কখনোই তেমন হবে না।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100010.mp3"></audio> ১০-<span class="c6">وَحُصِّلَ مَا فِي الصُّدُورِ:</span> <span class="c1">“আর অন্তরে যা আছে তা প্রকাশ করা হবে।”</span>: প্রকাশিত হবে এবং বর্ণিত হবে, নিয়ত, বিশ্বাস ও অন্যান্য যা কিছু তাদের অন্তরে রয়েছে।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100011.mp3"></audio> ১১-<span class="c6">إِنَّ رَبَّهُمْ بِهِمْ يَوْمَئِذٍ لَخَبِيرٌ:</span> <span class="c1">“নিশ্চয় তাদের রব সেদিন তাদের ব্যাপারে সবিশেষ অবহিত।”</span>: নিশ্চয়ই তাদের রব তাদের উক্ত দিনের ব্যাপারে সম্যক অবহিত। তাঁর কাছে স্বীয় বান্দার কোন কিছুই গোপন নেই, আর সে অনুযায়িই তিনি তাদেরকে অচিরেই পুরষ্কৃত করবেন। </p>',
            ],
            3 => [
                'question' => 'প্রশ্ন ৪: সূরা আল-ক্বারি‘আহ পাঠ কর এবং তা ব্যাখ্যা কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7450.mp3',
                'answer' => '<p> উত্তর: সূরা আল-<span class="c6">ক্বারি‘আহ এবং তার ব্যাখ্যা:</span><br /> بِسْمِ اللهِ الرَّحْمنِ الرَّحِيمِ রহমান ও রহীম আল্লাহর নামে।<br /> الْقَارِعَةُ: <span class="c1">“ভীতিপ্ৰদ মহা বিপদ <span class="c2">(১)</span> مَا الْقَارِعَةُ : ভীতিপ্ৰদ মহা বিপদ কী? <span class="c2">(২)</span> وَمَا أَدْرَاكَ مَا الْقَارِعَةُ: আর ভীতিপ্ৰদ মহা বিপদ সম্পর্কে আপনাকে কিসে জানাবে? <span class="c2">(৩)</span> يَوْمَ يَكُونُ النَّاسُ كَالْفَرَاشِ الْمَبْثُوثِ: সেদিন মানুষ হবে বিক্ষিপ্ত পতঙ্গের মত। <span class="c2">(৪)</span> وَتَكُونُ الْجِبَالُ كَالْعِهْنِ الْمَنْفُوشِ: আর পর্বতসমূহ হবে ধুনিত রঙ্গিন পশমের মত। <span class="c2">(৫)</span> فَأَمَّا مَنْ ثَقُلَتْ مَوَازِينُهُ: অতঃপর যার পাল্লাসমূহ ভারী হবে। <span class="c2">(৬)</span> فَهُوَ فِي عِيشَةٍ رَاضِيَةٍ: সে তো থাকবে সন্তোষজনক জীবনে। <span class="c2">(৭)</span> وَأَمَّا مَنْ خَفَّتْ مَوَازِينُهُ: আর যার পাল্লাসমূহ হালকা হবে। <span class="c2">(৮)</span> فَأُمُّهُ هَاوِيَةٌ: তার স্থান হবে ‘হাওয়িয়াহ’। <span class="c2">(৯)</span> وَمَا أَدْرَاكَ مَا هِيَهْ: আর আপনাকে কিসে জানাবে সেটা কী? <span class="c2">(১০)</span> نَارٌ حَامِيَةٌ: অত্যন্ত উত্তপ্ত আগুন।”</span> <span class="c2">(১১)</span> <span class="c5">[সূরা আল-<span class="c6">ক্বারি‘আহ:</span> ১-১১]</span><br /> তাফসীর:<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101001.mp3"></audio> ১-<span class="c6"> الْقَارِعَةُ:</span> <span class="c1">“ভীতিপ্ৰদ মহাবিপদ।”</span>: যখন তার ভয়াবহতার কারণে মানুষের হৃদয়সমূহ আঘাতপ্রাপ্ত হবে?<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101002.mp3"></audio> ২-<span class="c6"> مَا الْقَارِعَةُ :</span> <span class="c1">“ভীতিপ্ৰদ মহাবিপদ কী?”</span>: সেই সময়টি আসলে কী, যখন তার ভয়াবহতার কারণে মানুষের হৃদয়সমূহ আঘাতপ্রাপ্ত হবে?<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101003.mp3"></audio> ৩-<span class="c6"> وَمَا أَدْرَاكَ مَا الْقَارِعَةُ:</span> <span class="c1">“আর ভীতিপ্ৰদ মহাবিপদ সম্পর্কে আপনাকে কিসে জানাবে?”</span>: হে রাসূল! কোন বস্তু আপনাকে সে বিষয়ে অবহিত করবে যে, সেই সময়টি আসলে কী, যখন তার ভয়বহতার কারণে মানুষের হৃদয়সমূহ কেপে উঠবে? নিশ্চিতভাবে সেটি হচ্ছে কিয়ামাতের দিন।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101004.mp3"></audio> ৪-<span class="c6"> يَوْمَ يَكُونُ النَّاسُ كَالْفَرَاشِ الْمَبْثُوثِ:</span> <span class="c1">“সেদিন মানুষ হবে বিক্ষিপ্ত পতঙ্গের মত।”</span>: সেটি এমন একটি দিন, যেদিন মানুষের অন্তরসমূহ প্রকম্পিত হতে থাকবে আর তারা তেমনি হবে, যেমনভাবে কীট-প্রত্যঙ্গগুলো এখানে সেখানে বিচ্ছিন্ন-বিক্ষিপ্ত আকারে ছড়িয়ে ছিটিয়ে পড়ে।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101005.mp3"></audio> ৫-<span class="c6"> وَتَكُونُ الْجِبَالُ كَالْعِهْنِ الْمَنْفُوشِ:</span> <span class="c1">“আর পর্বতসমূহ হবে ধুনিত রঙ্গিন পশমের মত।”</span>: সেদিন দ্রুত চলাচল ও নড়াচড়ার কারণে পাহাড়-পর্বতসমূহ ধুনাই করা পশমের ন্যায় হয়ে যাবে।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101006.mp3"></audio> ৬-<span class="c6"> فَأَمَّا مَنْ ثَقُلَتْ مَوَازِينُهُ:</span> <span class="c1">“অতঃপর যার পাল্লাসমূহ ভারী হবে।”</span>: তখন যার সৎকাজসমূহ তার পাপকাজের উপরে প্রাধান্য পাবে।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101007.mp3"></audio> ৭-<span class="c6"> فَهُوَ فِي عِيشَةٍ رَاضِيَةٍ:</span> <span class="c1">“সে তো থাকবে সন্তোষজনক জীবনে।”</span>: সে এক সন্তোষজনক জীবনের মধ্যে থাকবে, যা সে জান্নাতে লাভ করবে।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101008.mp3"></audio> ৮-<span class="c6"> وَأَمَّا مَنْ خَفَّتْ مَوَازِينُهُ:</span> <span class="c1">“আর যার পাল্লাসমূহ হালকা হবে।”</span>: পক্ষান্তরে যার পাপকাজ তার সৎকাজের উপরে প্রাধান্য পাবে।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101009.mp3"></audio> ৯-<span class="c6"> فَأُمُّهُ هَاوِيَةٌ:</span> <span class="c1">“তার স্থান হবে ‘হাওয়িয়াহ’।”</span>: কিয়ামাতের দিনে তার অবস্থান ও বাসস্থান হবে জাহান্নাম।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101010.mp3"></audio> ১০-<span class="c6"> وَمَا أَدْرَاكَ مَا هِيَهْ:</span> <span class="c1">“আর আপনাকে কিসে জানাবে সেটা কী?”</span>: হে রাসূল! সেটি আসলে কী এ ব্যাপারে আপনাকে কোন বস্তু অবহিত করবে?<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101011.mp3"></audio> ১১-<span class="c6"> نَارٌ حَامِيَةٌ:</span> <span class="c1">“অত্যন্ত উত্তপ্ত আগুন।”</span>: সেটি হচ্ছে চূড়ান্ত উত্তপ্ত আগুন। </p>',
            ],
            4 => [
                'question' => 'প্রশ্ন ৫: সূরা আত-তাকাছুর পাঠ কর এবং তা ব্যাখ্যা কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7610.mp3',
                'answer' => '<p> উত্তর: সূরা আত-<span class="c6">তাকাছুর এবং তার ব্যাখ্যা:</span><br /> بِسْمِ اللهِ الرَّحْمنِ الرَّحِيمِ রহমান ও রহীম আল্লাহর নামে।<br /> أَلْهَاكُمُ التَّكَاثُرُ <span class="c1">“প্রাচুর্যের প্রতিযোগিতা তোমাদেরকে মোহাবিষ্ট করে রাখে। <span class="c2">(১)</span> حَتَّى زُرْتُمُ الْمَقَابِرَ যতক্ষণ না তোমরা কবরের সাক্ষাত পাও। <span class="c2">(২)</span> كَلَّا سَوْفَ تَعْلَمُونَ কখনোই না, তোমরা অচিরেই জানতে পারবে। <span class="c2">(৩)</span> ثُمَّ كَلَّا سَوْفَ تَعْلَمُونَ অতপর কখনোই না, তোমরা অচিরেই জানতে পারবে। <span class="c2">(৪)</span> كَلَّا لَوْ تَعْلَمُونَ عِلْمَ الْيَقِينِ কখনোই নয়, যদি তোমরা নিশ্চিত জ্ঞানে জ্ঞান রাখতে। <span class="c2">(৫)</span> لَتَرَوُنَّ الْجَحِيمَ অবশ্যই তোমরা জাহান্নাম দেখতে পাবে। <span class="c2">(৬)</span> ثُمَّ لَتَرَوُنَّهَا عَيْنَ الْيَقِينِ তারপর তোমরা সেটি দেখতে পাবে চাক্ষুস প্রত্যয়ে। <span class="c2">(৭)</span> ثُمَّ لَتُسْأَلُنَّ يَوْمَئِذٍ عَنِ النَّعِيمِ তারপর সেদিন তোমরা অবশ্যই নি‘আমাত সম্পর্কে জিজ্ঞাসিত হবে।”</span> <span class="c2">(৮)</span> <span class="c5">[সূরা আত-<span class="c6">তাকাছুর:</span> ১-৮]</span><br /> তাফসীর:<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102001.mp3"></audio> ১- أَلْهَاكُمُ التَّكَاثُرُ <span class="c1">“প্রাচুর্যের প্রতিযোগিতা তোমাদেরকে মোহাবিষ্ট করে রাখে।”</span>: হে মানুষ, তোমাদের সন্তান-সন্ততি ও ধন-সম্পদ নিয়ে পারষ্পারিক গর্ববোধ আল্লাহর আনুগত্য থেকে তোমাদেরকে ব্যস্ত করে রেখেছে।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102002.mp3"></audio> ২- حَتَّى زُرْتُمُ الْمَقَابِرَ <span class="c1">“যতক্ষণ না তোমরা কবরের সাক্ষাত পাও।”</span>: তথা যতক্ষণ না তোমরা মারা যাবে এবং তোমাদের কবরে প্রবেশ করবে।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102003.mp3"></audio> ৩- كَلَّا سَوْفَ تَعْلَمُونَ <span class="c1">“কখনোই না, তোমরা অচিরেই জানতে পারবে।”</span>: এ সকল বিষয়ে পারষ্পারিক গর্ব তোমাদেরকে আল্লাহর আনুগত্য হতে ব্যস্ত করে রেখেছে, অচিরেই তোমরা জানতে পারবে উক্ত বিষয়ে ব্যস্ত থাকার পরিণাম সম্পর্কে।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102004.mp3"></audio> ৪- ثُمَّ كَلَّا سَوْفَ تَعْلَمُونَ <span class="c1">“অতপর কখনোই না, তোমরা অচিরেই জানতে পারবে।”</span>: তারপরে তোমরা তার পরিণাম সম্পর্কে অচিরেই জানতে পারবে।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102005.mp3"></audio> ৫- كَلَّا لَوْ تَعْلَمُونَ عِلْمَ الْيَقِينِ <span class="c1">“কখনোই নয়, যদি তোমরা নিশ্চিত জ্ঞানে জ্ঞান রাখতে।”</span>: প্রকৃতপক্ষে তোমরা যদি নিশ্চিতভাবে জানতে যে, তোমাদেরকে আল্লাহর কাছে ফিরে যেতে হবে। আর আল্লাহ তা‘আলা তোমাদেরকে তোমাদের সম্পদ ও সন্তান-সন্তুতি নিয়ে পরষ্পরে গর্বে মশগুল থাকার কারণে তোমাদের উক্ত কাজের বিনিময়ে প্রতিদান দিবেন।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102006.mp3"></audio> ৬- لَتَرَوُنَّ الْجَحِيمَ <span class="c1">“অবশ্যই তোমরা জাহান্নাম দেখতে পাবে।”</span>: আর আল্লাহর কসম, অবশ্যই তোমরা কিয়ামাতের দিনে <span class="c2">(জাহান্নামের)</span> আগুন প্রত্যক্ষ করবে।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102007.mp3"></audio> ৭- ثُمَّ لَتَرَوُنَّهَا عَيْنَ الْيَقِينِ <span class="c1">“তারপর তোমরা সেটি দেখতে পাবে চাক্ষুস প্রত্যয়ে।”</span>: তারপরে অবশ্যই তোমরা নিশ্চিত বিশ্বাসের সাথে তা প্রত্যক্ষ করবে, যাতে কোন সন্দেহ নেই।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102008.mp3"></audio> ৮- ثُمَّ لَتُسْأَلُنَّ يَوْمَئِذٍ عَنِ النَّعِيمِ <span class="c1">“তারপর সেদিন তোমরা অবশ্যই নি‘আমাত সম্পর্কে জিজ্ঞাসিত হবে।”</span>: তারপরে আল্লাহ তা‘আলা সেদিনে তোমাদেরকে অবশ্যই তিনি তোমাদেরকে যে সব নি‘আমাত দিয়েছেন,<span class="c6"> যেমন:</span> সুস্থতা, ধন-সম্পদ ও ইত্যাদির ব্যাপারে জিজ্ঞাসাবাদ করবেন। </p>',
            ],
            5 => [
                'question' => 'প্রশ্ন ৩: সূরা আল-‘আসর পাঠ কর এবং তা ব্যাখ্যা কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7750.mp3',
                'answer' => '<p> উত্তর: সূরা আল-<span class="c6">‘আসর এবং তার ব্যাখ্যা:</span><br /> بِسْمِ اللهِ الرَّحْمنِ الرَّحِيمِ রহমান ও রহীম আল্লাহর নামে।<br /> وَالْعَصْرِ: <span class="c1">“সময়ের শপথ,”</span> <span class="c2">(১)</span> إِنَّ الْإِنْسَانَ لَفِي خُسْرٍ: <span class="c1">“নিশ্চয়ই মানুষ ক্ষতির মাঝে নিপতিত,”</span> <span class="c2">(২)</span> إِلَّا الَّذِينَ آمَنُوا وَعَمِلُوا الصَّالِحَاتِ وَتَوَاصَوْا بِالْحَقِّ وَتَوَاصَوْا بِالصَّبْرِ: <span class="c1">“কিন্তু তারা নয়, যারা ঈমান এনেছে এবং সৎকাজ করেছে আর পরস্পরকে উপদেশ দিয়েছে হকের এবং উপদেশ দিয়েছে সবরের।”</span> <span class="c2">(৩)</span> <span class="c5">[সূরা আল-<span class="c6">‘আসর:</span> ১-৩]</span><br /> তাফসীর:<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/103001.mp3"></audio> ১-<span class="c6"> وَالْعَصْرِ:</span> <span class="c1">“সময়ের শপথ,”</span>: আল্লাহ সুবহানাহু ওয়া তা‘আলা সময়ের শপথ করেছেন।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/103002.mp3"></audio> ২-<span class="c6"> إِنَّ الْإِنْسَانَ لَفِي خُسْرٍ:</span> <span class="c1">“নিশ্চয়ই মানুষ ক্ষতির মাঝে নিপতিত,”</span> তথা: প্রতিটি মানুষই ক্ষতি ও ধংসের মধ্যে নিপতিত রয়েছে।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/103003.mp3"></audio> ৩-<span class="c6"> إِلَّا الَّذِينَ آمَنُوا وَعَمِلُوا الصَّالِحَاتِ وَتَوَاصَوْا بِالْحَقِّ وَتَوَاصَوْا بِالصَّبْرِ:</span> <span class="c1">“কিন্তু তারা নয়, যারা ঈমান এনেছে এবং সৎকাজ করেছে আর পরস্পরকে উপদেশ দিয়েছে হকের এবং উপদেশ দিয়েছে সবরের।”</span>: তবে যারা ঈমান এনেছে এবং ভালোকাজ করেছে, এবং সেই সাথে হকের দিকে দাও‘আত দিয়েছে এবং তার উপরে ধৈর্য ধারন করেছে, তারা এসব ক্ষতি থেকে পরিত্রাণপ্রাপ্ত। </p>',
            ],
            6 => [
                'question' => 'প্রশ্ন ৭: সূরা আল-হুমাযাহ পাঠ কর এবং তা ব্যাখ্যা কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7830.mp3',
                'answer' => '<p> উত্তর: সূরা আল-<span class="c6">হুমাযাহ এবং তার ব্যাখ্যা:</span><br /> بِسْمِ اللهِ الرَّحْمنِ الرَّحِيمِ রহমান ও রহীম আল্লাহর নামে।<br /> وَيْلٌ لِكُلِّ هُمَزَةٍ لُمَزَةٍ <span class="c1">“দুর্ভোগ প্রত্যেকের, যে পিছনে ও সামনে লোকের নিন্দা করে। <span class="c2">(১)</span> الَّذِي جَمَعَ مَالًا وَعَدَّدَهُ যে সম্পদ জমায় ও তা বার বার গণনা করে। <span class="c2">(২)</span> يَحْسَبُ أَنَّ مَالَهُ أَخْلَدَهُ সে ধারণা করে যে, তার সম্পদ তাকে অমর করে রাখবে। <span class="c2">(৩)</span> كَلَّا لَيُنْبَذَنَّ فِي الْحُطَمَةِ কখনও না, সে অবশ্যই নিক্ষিপ্ত হবে হুতামায়। <span class="c2">(৪)</span> وَمَا أَدْرَاكَ مَا الْحُطَمَةُ আর হুতামা সম্পর্কে আপনাকে কোন বস্তু অবহিত করবে? <span class="c2">(৫)</span> نَارُ اللَّهِ الْمُوقَدَةُ এটা আল্লাহর প্রজ্বলিত আগুন। <span class="c2">(৬)</span> الَّتِي تَطَّلِعُ عَلَى الْأَفْئِدَةِ যা হৃদয়কে গ্ৰাস করবে। <span class="c2">(৭)</span> إِنَّهَا عَلَيْهِمْ مُؤْصَدَةٌ নিশ্চয় এটা তাদেরকে পরিবেষ্টন করে রাখবে। <span class="c2">(৮)</span> فِي عَمَدٍ مُمَدَّدَةٍ দীর্ঘায়িত স্তম্ভসমূহে। <span class="c2">(৯)</span>”</span> <span class="c5">[সূরা আল-<span class="c6">হুমাযাহ:</span> ১-৯]</span><br /> তাফসীর:<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104001.mp3"></audio> ১- وَيْلٌ لِكُلِّ هُمَزَةٍ لُمَزَةٍ <span class="c1">“দুর্ভোগ প্রত্যেকের, যে পিছনে ও সামনে লোকের নিন্দা করে।”</span> : ধ্বংস ও শক্ত আযাব রয়েছে ঐ সমস্ত লোকের জন্য যারা বেশী বেশী মানুষদের গীবত করে এবং তাদের ব্যাপারে কথা আরোপ করে।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104002.mp3"></audio> ২- الَّذِي جَمَعَ مَالًا وَعَدَّدَهُ <span class="c1">“যে সম্পদ জমায় ও তা বার বার গণনা করে।”</span>: যার মূল চিন্তাই হচ্ছে ধন-সম্পদ জমা করা এবং তা গুণে রাখা, আর এছাড়া তার অন্য কোন চিন্তাও থাকে না।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104003.mp3"></audio> ৩- يَحْسَبُ أَنَّ مَالَهُ أَخْلَدَهُ <span class="c1">“সে ধারণা করে যে, তার সম্পদ তাকে অমর করে রাখবে।”</span>: সে ধারণা করে যে তার জমা করা সম্পদ তাকে মৃত্যু থেকে নিষ্কৃতি দেবে, আর তাতে সে দুনিয়াতে স্থায়ী হয়ে থাকবে।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104004.mp3"></audio> ৪- كَلَّا لَيُنْبَذَنَّ فِي الْحُطَمَةِ <span class="c1">“কখনও না, সে অবশ্যই নিক্ষিপ্ত হবে হুতামায়।”</span>: এ মূর্খ যেমন চিন্তা করে, প্রকৃত বিষয় কখনো তেমন নয়, বরং অবশ্যই তাকে নিক্ষেপ করা হবে জাহান্নামের আগুনে, যে আগুন তার প্রচন্ড শক্তিবলে তার মধ্যে নিক্ষিপ্ত প্রতিটি বস্তুকে ভেঙ্গে চুরে পিষে ফেলবে।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104005.mp3"></audio> ৫- وَمَا أَدْرَاكَ مَا الْحُطَمَةُ <span class="c1">“আর হুতামা সম্পর্কে আপনাকে কোন বস্তু অবহিত করবে?”</span>: হে রাসূল, আপনাকে কোন বস্তু অবহিত করবে যে, স্বীয় অভ্যন্তরে নিক্ষিপ্ত প্রতিটি বস্তুকে ধ্বংস করে ফেলা এ আগুন প্রকৃতপক্ষে কেমন?<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104006.mp3"></audio> ৬- نَارُ اللَّهِ الْمُوقَدَةُ <span class="c1">“এটা আল্লাহর প্রজ্বলিত আগুন।”</span>: নিশ্চয় এটি হচ্ছে আল্লাহ তা‘আলার জ্বলন্ত আগুন।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104007.mp3"></audio> ৭- الَّتِي تَطَّلِعُ عَلَى الْأَفْئِدَةِ <span class="c1">“যা হৃদয়কে গ্ৰাস করবে।”</span>: যা মানুষের শরীর থেকে অন্তরের মধ্যে প্রবেশ করবে।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104008.mp3"></audio> 8- إِنَّهَا عَلَيْهِمْ مُؤْصَدَةٌ <span class="c1">“নিশ্চয় এটা তাদেরকে পরিবেষ্টন করে রাখবে।”</span>: নিশ্চয় এটি শাস্তিপ্রাপ্তদেরকে তালাবদ্ধ করে আটকে রাখবে।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104009.mp3"></audio> ৯- فِي عَمَدٍ مُمَدَّدَةٍ <span class="c1">“দীর্ঘায়িত স্তম্ভসমূহে।”</span>: প্রলম্বিত সুদীর্ঘ খুঁটিসমূহের মাধ্যমে, যাতে তারা সেখান থেকে বের হতে না পারে। </p>',
            ],
            7 => [
                'question' => 'প্রশ্ন 8: সূরা আল-ফীল পাঠ কর এবং তা ব্যাখ্যা কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7970.mp3',
                'answer' => '<p> উত্তর: সূরা আল-<span class="c6">ফীল এবং তার ব্যাখ্যা:</span><br /> بِسْمِ اللهِ الرَّحْمنِ الرَّحِيمِ রহমান ও রহীম আল্লাহর নামে।<br /> أَلَمْ تَرَ كَيْفَ فَعَلَ رَبُّكَ بِأَصْحَابِ الْفِيلِ <span class="c1">“আপনি কি দেখেননি, আপনার রব হাতির অধিপতিদের প্রতি কী করেছিলেন? <span class="c2">(১)</span> أَلَمْ يَجْعَلْ كَيْدَهُمْ فِي تَضْلِيلٍ তিনি কি তাদের কৌশল ব্যর্থতায় পর্যবসিত করে দেননি? <span class="c2">(২)</span> وَأَرْسَلَ عَلَيْهِمْ طَيْرًا أَبَابِيلَ আর তাদের বিরুদ্ধে তিনি ঝাঁকে ঝাঁকে পাখি পাঠান। <span class="c2">(৩)</span> تَرْمِيهِمْ بِحِجَارَةٍ مِنْ سِجِّيلٍ যারা তাদের উপর শক্ত পোড়ামাটির কঙ্কর নিক্ষেপ করে। <span class="c2">(৪)</span> فَجَعَلَهُمْ كَعَصْفٍ مَأْكُولٍ অতঃপর তিনি তাদেরকে ভক্ষিত তৃণ-সদৃশ করেন।”</span> <span class="c2">(৫)</span> <span class="c5">[সূরা আল-<span class="c6">ফীল:</span> ১-৫]</span><br /> তাফসীর:<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105001.mp3"></audio> ১- أَلَمْ تَرَ كَيْفَ فَعَلَ رَبُّكَ بِأَصْحَابِ الْفِيلِ <span class="c1">“আপনি কি দেখেননি, আপনার রব হাতির অধিপতিদের প্রতি কী করেছিলেন?”</span>: হে রাসূল, আপনি কি জানেন না যে, আপনার রব আবরাহা এবং তার সহচর তথা হাতির অধিপতিরা যখন তারা কা‘বাকে ধ্বংস করার ইচ্ছা করেছিল, তাদের সাথে কী <span class="c2">(আচরণ)</span> করেছিলেন?<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105002.mp3"></audio> ২- أَلَمْ يَجْعَلْ كَيْدَهُمْ فِي تَضْلِيلٍ <span class="c1">“তিনি কি তাদের কৌশল ব্যর্থতায় পর্যবসিত করে দেননি?“: তাদের কা‘বা ধ্বংস করার উক্ত জঘন্য প্রচেষ্টাকে আল্লাহ তা‘আলা ব্যর্থতায় পর্যবসিত করে দিয়েছেন। সুতরাং তারা মানুষকে কা‘বা থেকে ফিরিয়ে রাখার যে আশা করেছিল, তা ব্যহত হয়েছিল, এমনকি তারা সামান্যতম সফলও হতে পারেনি।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105003.mp3"></audio> ৩- وَأَرْسَلَ عَلَيْهِمْ طَيْرًا أَبَابِيلَ “আর তাদের বিরুদ্ধে তিনি ঝাঁকে ঝাঁকে পাখি পাঠান।”</span>: এবং তিনি তাদের উপরে ঝাঁক ঝাঁক পাখি প্রেরণ করেছিলেন।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105004.mp3"></audio> ৪- تَرْمِيهِمْ بِحِجَارَةٍ مِنْ سِجِّيلٍ <span class="c1">“যারা তাদের উপর শক্ত পোড়ামাটির কঙ্কর নিক্ষেপ করে।”</span>: পাখিরা তাদের উপরে পাথরাকৃতির <span class="c2">(শক্ত)</span> মাটির কঙ্কর নিক্ষেপ করেছিল।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105005.mp3"></audio> ৫- فَجَعَلَهُمْ كَعَصْفٍ مَأْكُولٍ <span class="c1">“অতঃপর তিনি তাদেরকে ভক্ষিত তৃণ-সদৃশ করেন।”</span>: সুতরাং আল্লাহ তাদেরকে এমন রোপিত বৃক্ষের পাতা এবং শীষের ন্যায় করে ধ্বংস করেছেন, যাকে পশুপ্রাণী খেয়ে ফেলেছে। </p>',
            ],
            8 => [
                'question' => 'প্রশ্ন ৯: সূরা কুরাইশ পাঠ কর এবং তা ব্যাখ্যা কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8070.mp3',
                'answer' => '<p> উত্তর: সূরা কুরাইশ ও তার ব্যাখ্যা:<br /> بِسْمِ اللهِ الرَّحْمنِ الرَّحِيمِ রহমান ও রহীম আল্লাহর নামে।<br /> لِإِيلَافِ قُرَيْشٍ <span class="c1">“কুরাইশের আসক্তির কারণে, <span class="c2">(১)</span> إِيلَافِهِمْ رِحْلَةَ الشِّتَاءِ وَالصَّيْفِ তাদের আসক্তি আছে শীত ও গ্ৰীষ্মে সফরের। <span class="c2">(২)</span> فَلْيَعْبُدُوا رَبَّ هَذَا الْبَيْتِ অতএব, তারা যেন ইবাদাত করে এ ঘরের রবের। <span class="c2">(৩)</span> الَّذِي أَطْعَمَهُمْ مِنْ جُوعٍ وَآمَنَهُمْ مِنْ خَوْفٍ যিনি তাদেরকে ক্ষুধায় খাদ্য দিয়েছেন এবং ভীতি থেকে তাদেরকে নিরাপদ করেছেন।”</span> <span class="c2">(৪)</span> <span class="c5">[সূরা কুরাইশ: ১-৪]</span><br /> তাফসীর:<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106001.mp3"></audio> ১- لِإِيلَافِ قُرَيْشٍ <span class="c1">“কুরাইশের আসক্তির কারণে,”</span> : এর দ্বারা উদ্দেশ্যে হচ্ছে- তাদের শীতকাল ও গ্রীষ্মকালে সফরের প্রতি যে অত্যন্ত আকর্ষণ ছিল।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106002.mp3"></audio> ২-<span class="c6">إِيلَافِهِمْ رِحْلَةَ الشِّتَاءِ وَالصَّيْفِ তাদের আসক্তি আছে শীত ও গ্ৰীষ্মে সফরের:</span> নিরাপত্তার সাথে শীতকালে ইয়ামেনে একটি সফর আর গ্রীষ্মকালে শামে আরেকটি সফর করা।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106003.mp3"></audio> ৩- فَلْيَعْبُدُوا رَبَّ هَذَا الْبَيْتِ <span class="c1">“অতএব, তারা ইবাদাত করুক এ ঘরের রবের।”</span>: তারা যেন শুধুমাত্র এ পবিত্র ঘরের রবের ইবাদাত করে, যিনি তাদের জন্য এ সফরকে সহজ করে দিয়েছেন এবং তার সাথে যেন শিরক না করে।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106004.mp3"></audio> ৪- الَّذِي أَطْعَمَهُمْ مِنْ جُوعٍ وَآمَنَهُمْ مِنْ خَوْفٍ <span class="c1">“যিনি তাদেরকে ক্ষুধায় খাদ্য দিয়েছেন এবং ভীতি থেকে তাদেরকে নিরাপদ করেছেন।”</span>: আরবদের অন্তরে হারাম শরীফের যে মর্যাদাবোধ এবং তাদের অবস্থানের মর্যাদার মাধ্যমে যিনি তাদেরকে ক্ষুধার সময়ে খাদ্য দিয়েছেন আর তাদেরকে ভীতির সময়ে নিরাপদ রেখেছেন। </p>',
            ],
            9 => [
                'question' => 'প্রশ্ন ১০: সূরা আল-মা‘ঊন পাঠ কর এবং তা ব্যাখ্যা কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8160.mp3',
                'answer' => '<p> উত্তর: সূরা আল-<span class="c6">মা‘ঊন এবং তার ব্যাখ্যা:</span><br /> بِسْمِ اللهِ الرَّحْمنِ الرَّحِيمِ রহমান ও রহীম আল্লাহর নামে।<br /> أَرَأَيْتَ الَّذِي يُكَذِّبُ بِالدِّينِ <span class="c1">“আপনি কি দেখেছেন তাকে, যে দ্বীনকে অস্বীকার করে? <span class="c2">(১)</span> فَذَلِكَ الَّذِي يَدُعُّ الْيَتِيمَ সে তো সে-ই, যে ইয়াতীমকে রূঢ়ভাবে তাড়িয়ে দেয়। <span class="c2">(২)</span> وَلَا يَحُضُّ عَلَى طَعَامِ الْمِسْكِينِ আর সে উদ্বুদ্ধ করে না মিসকীনদের খাদ্য দানে। <span class="c2">(৩)</span> فَوَيْلٌ لِلْمُصَلِّينَ কাজেই দুর্ভোগ সে সালাত আদায়কারীদের, <span class="c2">(৪)</span> الَّذِينَ هُمْ عَنْ صَلَاتِهِمْ سَاهُونَ যারা তাদের সালাত সম্বন্ধে উদাসীন, <span class="c2">(৫)</span> الَّذِينَ هُمْ يُرَاءُونَ যারা লোক দেখানোর জন্য তা করে, <span class="c2">(৬)</span> وَيَمْنَعُونَ الْمَاعُونَ এবং মাউন প্ৰদান করতে বিরত থাকে।”</span> <span class="c2">(৭)</span> <span class="c5">[সূরা আল-<span class="c6">মা‘ঊন:</span> ১-৭]</span><br /> তাফসীর:<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107001.mp3"></audio> ১- أَرَأَيْتَ الَّذِي يُكَذِّبُ بِالدِّينِ <span class="c1">“আপনি কি দেখেছেন তাকে, যে দ্বীনকে অস্বীকার করে?”</span>: আপনি কি চেনেন ঐ ব্যক্তিকে যে কিয়ামাতের দিনের প্রতিদানকে অস্বীকার করে?<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107002.mp3"></audio> ২- فَذَلِكَ الَّذِي يَدُعُّ الْيَتِيمَ <span class="c1">“সে তো সে-ই, যে ইয়াতীমকে রূঢ়ভাবে তাড়িয়ে দেয়।”</span>: সে হচ্ছে এমন ব্যক্তি যে ইয়াতিমকে তার প্রয়োজন থেকে কঠোরতার দ্বারা বিদূরিত করে।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107003.mp3"></audio> ৩- وَلَا يَحُضُّ عَلَى طَعَامِ الْمِسْكِينِ <span class="c1">“আর সে উদ্বুদ্ধ করে না মিসকীনদের খাদ্য দানে।”</span>: দরিদ্রকে খাবার দেওয়ার ব্যাপারে সে নিজেকেও যেমন উৎসাহিত করে না, আবার অন্যকেও সে ব্যাপারে উৎসাহিত করে না।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107004.mp3"></audio> ৪- فَوَيْلٌ لِلْمُصَلِّينَ <span class="c1">“কাজেই দুর্ভোগ সে সালাত আদায়কারীদের,”</span>: সালাত আদায়কারীদের জন্য রয়েছে ধ্বংস ও আযাব।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107005.mp3"></audio> ৫- الَّذِينَ هُمْ عَنْ صَلَاتِهِمْ سَاهُونَ <span class="c1">“যারা তাদের সালাত সম্বন্ধে উদাসীন,”</span>: যারা সালাত সম্পর্কে অমনোযোগী, তারা সালাতের ওয়াক্ত চলে যায় অথচ তারা কোন ভ্রুক্ষেপ করে না।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107006.mp3"></audio> ৬- الَّذِينَ هُمْ يُرَاءُونَ <span class="c1">“যারা লোক দেখানোর জন্য তা করে,”</span>: যারা তাদের সালাত ও আমলগুলো প্রদর্শন করে থাকে, তারা আমলের ক্ষেত্রে আল্লাহর জন্য ইখলাস রক্ষা করে না।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107007.mp3"></audio> ৭- وَيَمْنَعُونَ الْمَاعُونَ <span class="c1">“এবং মাউন প্ৰদান করতে বিরত থাকে।”</span>: তারা অন্যদেরকে এমন সাহায্য প্রদান করা থেকে বিরত থাকে, যা প্রদানে তাদের কোন ক্ষতি হয় না। </p>',
            ],
            10 => [
                'question' => 'প্রশ্ন ১১: সূরা আল-কাউছার পাঠ কর এবং তা ব্যাখ্যা কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8280.mp3',
                'answer' => '<p> উত্তর: সূরা আল-<span class="c6">কাউছার এবং তার ব্যাখ্যা:</span><br /> بِسْمِ اللهِ الرَّحْمنِ الرَّحِيمِ রহমান ও রহীম আল্লাহর নামে।<br /> إِنَّا أَعْطَيْنَاكَ الْكَوْثَرَ <span class="c1">“নিশ্চয় আমরা আপনাকে কাউছার দান করেছি। <span class="c2">(১)</span> فَصَلِّ لِرَبِّكَ وَانْحَرْ কাজেই আপনি আপনার রবের উদ্দেশ্যে সালাত আদায় করুন এবং কুরবানী করুন। <span class="c2">(২)</span> إِنَّ شَانِئَكَ هُوَ الْأَبْتَرُ নিশ্চয় আপনার প্রতি বিদ্বেষ পোষণকারীই তো নির্বংশ।”</span> <span class="c2">(৩)</span> <span class="c5">[সূরা আল-<span class="c6">কাউছার:</span> ১-৩]</span><br /> তাফসীর:<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/108001.mp3"></audio> ১- إِنَّا أَعْطَيْنَاكَ الْكَوْثَرَ <span class="c1">“নিশ্চয় আমরা আপনাকে কাউছার দান করেছি।”</span>: হে রাসূল, আমি আপনাকে দিয়েছি অসংখ্য কল্যাণ,<span class="c6"> এর মধ্যে অন্যতম হচ্ছে:</span> জান্নাতের মধ্যে কাউছারের নহর।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/108002.mp3"></audio> ২- فَصَلِّ لِرَبِّكَ وَانْحَرْ <span class="c1">“কাজেই আপনি আপনার রবের উদ্দেশ্যে সালাত আদায় করুন এবং কুরবানী করুন।”</span>: সুতরাং মুশরিকরা যেভাবে মূর্তির উদ্দেশ্যে যবেহের মাধ্যমে নৈকট্য লাভ করার প্রচেষ্টা চালায়, তার বিপরীতে শুধুমাত্র তাঁর উদ্দেশ্যেই সালাত আদায় ও যবেহ করার মাধ্যমে আল্লাহর এ সব নি‘আমাতের উপরে শুকরিয়া আদায় করুন।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/108003.mp3"></audio> ৩- إِنَّ شَانِئَكَ هُوَ الْأَبْتَرُ <span class="c1">“নিশ্চয় আপনার প্রতি বিদ্বেষ পোষণকারীই তো নির্বংশ।”</span>: অবশ্যই আপনার শত্রু সব ধরণের কল্যাণ থেকে বঞ্চিত, সে বিস্মৃত হবে, যদিও তাকে স্মরণ করা হয়, তবে মন্দত্বের মাধ্যমেই তাকে স্মরণ করা হবে। </p>',
            ],
            11 => [
                'question' => 'প্রশ্ন ১২: সূরা আল-কাফিরূন পাঠ কর এবং তা ব্যাখ্যা কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8360.mp3',
                'answer' => '<p> উত্তর: সূরা আল-<span class="c6">কাফিরূন এবং তার ব্যাখ্যা:</span><br /> بِسْمِ اللهِ الرَّحْمنِ الرَّحِيمِ রহমান ও রহীম আল্লাহর নামে।<br /> قُلْ يَا أَيُّهَا الْكَافِرُونَ <span class="c1">“বলুন, হে কাফিররা! <span class="c2">(১)</span> لَا أَعْبُدُ مَا تَعْبُدُونَ আমি তার ইবাদাত করি না যার ইবাদাত তোমরা কর, <span class="c2">(২)</span> وَلَا أَنْتُمْ عَابِدُونَ مَا أَعْبُدُ এবং তোমরাও তার ইবাদতকারী নও যার ইবাদাত আমি করি, <span class="c2">(৩)</span> وَلَا أَنَا عَابِدٌ مَا عَبَدْتُمْ এবং আমি ইবাদতকারী নই তার যার ইবাদাত তোমরা করে আসছ। <span class="c2">(৪)</span> وَلَا أَنْتُمْ عَابِدُونَ مَا أَعْبُدُ এবং তোমরাও তার ইবাদতকারী নও যার ইবাদাত আমি করি, <span class="c2">(৫)</span> لَكُمْ دِينُكُمْ وَلِيَ دِينِ তোমাদের দ্বীন তোমাদের, আর আমার দ্বীন আমার।”</span> <span class="c2">(৬)</span> <span class="c5">[সূরা আল-<span class="c6">কাফিরূন:</span> ১-৬]</span><br /> তাফসীর:<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109001.mp3"></audio> ১- قُلْ يَا أَيُّهَا الْكَافِرُونَ <span class="c1">“বলুন, হে কাফিররা!”</span>: হে রাসূল,<span class="c6"> আপনি বলুন:</span> হে আল্লাহকে অস্বীকারকারী কাফিরগণ!<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109002.mp3"></audio> ২- لَا أَعْبُدُ مَا تَعْبُدُونَ <span class="c1">“আমি তার ইবাদাত করি না যার ইবাদাত তোমরা কর,”</span>: তোমরা যে সমস্ত মূর্তিপুজার ইবাদাত কর, বর্তমানেও আমি তাদের ইবাদাত করি না আর ভবিষ্যতেও করব না।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109003.mp3"></audio> ৩- وَلَا أَنْتُمْ عَابِدُونَ مَا أَعْبُدُ এবং তোমরাও তার ইবাদতকারী নও যার ইবাদত আমি করি,<span class="c6"> :</span> আবার তোমরাও আমি যার ইবাদাত করি, সেই এক আল্লাহর ইবাদাতকারী নও।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109004.mp3"></audio> ৪-<span class="c6"> وَلَا أَنَا عَابِدٌ مَا عَبَدْتُمْ এবং আমি ইবাদতকারী নই তার যার ইবাদাত তোমরা করে আসছ। :</span> আর তোমরা যে সকল মূর্তিপূজার ইবাদাত করেছ, আমি সেগুলোর ইবাদাতকারী নই।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109005.mp3"></audio> ৫- وَلَا أَنْتُمْ عَابِدُونَ مَا أَعْبُدُ এবং তোমরাও তার ইবাদতকারী নও যার ইবাদত আমি করি,<span class="c6"> :</span> আবার তোমরাও আমি যার ইবাদাত করি, সেই এক আল্লাহর ইবাদাতকারী নও।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109006.mp3"></audio> ৬- لَكُمْ دِينُكُمْ وَلِيَ دِينِ <span class="c1">“তোমাদের দ্বীন তোমাদের, আর আমার দ্বীন আমার।”</span>: তোমাদের জন্য সেই দীনই থাকুক, যা তোমরা নিজেদের জন্য তৈরী করেছ। আর আমার জন্য রয়েছে সেই দীন, যা আল্লাহ আমার উপরে নাযিল করেছেন। </p>',
            ],
            12 => [
                'question' => 'প্রশ্ন ১৩: সূরা আন-নাসর পাঠ কর এবং তা ব্যাখ্যা কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8470.mp3',
                'answer' => '<p> উত্তর: সূরা আল-<span class="c6">নাসর এবং তার ব্যাখ্যা:</span><br /> بِسْمِ اللهِ الرَّحْمنِ الرَّحِيمِ রহমান ও রহীম আল্লাহর নামে।<br /> إِذَا جَاءَ نَصْرُ اللَّهِ وَالْفَتْحُ <span class="c1">“যখন আসবে আল্লাহর সাহায্য ও বিজয় <span class="c2">(১)</span> وَرَأَيْتَ النَّاسَ يَدْخُلُونَ فِي دِينِ اللَّهِ أَفْوَاجًا আর আপনি মানুষকে দলে দলে আল্লাহর দ্বীনে প্রবেশ করতে দেখবেন। <span class="c2">(২)</span> فَسَبِّحْ بِحَمْدِ رَبِّكَ وَاسْتَغْفِرْهُ إِنَّهُ كَانَ تَوَّابًا তখন আপনি আপনার রবের প্ৰশংসাসহ তার পবিত্রতা ও মহিমা ঘোষণা করুন এবং তার কাছে ক্ষমা প্রার্থনা করুন, নিশ্চয় তিনি তাওবা কবুলকারী।”</span> <span class="c2">(৩)</span> <span class="c5">[সূরা আন-<span class="c6">নাসর:</span> ১-৩]</span><br /> তাফসীর:<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/110001.mp3"></audio> ১- إِذَا جَاءَ نَصْرُ اللَّهِ وَالْفَتْحُ <span class="c1">“যখন আসবে আল্লাহর সাহায্য ও বিজয়।”</span> : হে রাসূল, যখন আপনার দীনের ব্যাপারে আল্লাহর পক্ষ থেকে সাহায্য ও সহযোগিতা আসবে আর মক্কা বিজয় সংঘটিত হবে।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/110002.mp3"></audio> ২- وَرَأَيْتَ النَّاسَ يَدْخُلُونَ فِي دِينِ اللَّهِ أَفْوَاجًا <span class="c1">“আর আপনি মানুষকে দলে দলে আল্লাহ্র দ্বীনে প্রবেশ করতে দেখবেন।”</span>: আপনি দলের পরে দল মানুষকে ইসলামে প্রবেশ করতে দেখবেন।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/110003.mp3"></audio> ৩- فَسَبِّحْ بِحَمْدِ رَبِّكَ وَاسْتَغْفِرْهُ إِنَّهُ كَانَ تَوَّابًا <span class="c1">“তখন আপনি আপনার রবের প্ৰশংসাসহ তার পবিত্রতা ও মহিমা ঘোষণা করুন এবং তার কাছে ক্ষমা প্রার্থনা করুন, নিশ্চয় তিনি তাওবা কবুলকারী।”</span>: সুতরাং আপনি জেনে রাখুন, সেটি হচ্ছে আপনাকে যে দায়িত্ব সহকারে প্রেরণ করা হয়েছিল, সে দায়িত্ব সমাপ্ত হওয়ার আলামত। আর তাই আপনি আপনার রবের তাসবীহ পাঠ করুন এবং তাঁর সাহায্য ও বিজয় দানের নি‘আমাতের কারণে শুকরিয়া জ্ঞাপন করুন। আর আপরি তাঁর কাছ থেকে মাগফিরাত কামনা করুন। তিনিই বান্দার তাওবা কবূল করেন এবং তাদেরকে ক্ষমা করেন। </p>',
            ],
            13 => [
                'question' => 'প্রশ্ন ১৪: সূরা আল-মাসাদ (সূরা লাহাব) পাঠ কর এবং তা ব্যাখ্যা কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8550.mp3',
                'answer' => '<p> উত্তর: সূরা আল-মাসাদ <span class="c2">(সূরা লাহাব)</span> এবং তার ব্যাখ্যা:<br /> بِسْمِ اللهِ الرَّحْمنِ الرَّحِيمِ রহমান ও রহীম আল্লাহর নামে।<br /> تَبَّتْ يَدَا أَبِي لَهَبٍ وَتَبَّ <span class="c1">“ধ্বংস হোক আবু লাহাবের দুহাত এবং ধ্বংস হয়েছে সে নিজেও। <span class="c2">(১)</span> مَا أَغْنَى عَنْهُ مَالُهُ وَمَا كَسَبَ তার ধন-সম্পদ ও তার উপার্জন তার কোন কাজে আসেনি। <span class="c2">(২)</span> سَيَصْلَى نَارًا ذَاتَ لَهَبٍ অচিরে সে দগ্ধ হবে লেলিহান আগুনে, <span class="c2">(৩)</span> وَامْرَأَتُهُ حَمَّالَةَ الْحَطَبِ আর তার স্ত্রীও- যে ইন্ধন বহন করে, <span class="c2">(৪)</span> فِي جِيدِهَا حَبْلٌ مِنْ مَسَدٍ তার গলায় পাকানো রশি।”</span><span class="c2">(৫)</span> <span class="c5">[সূরা আল-<span class="c6">মাসাদ:</span> ১-৫]</span><br /> তাফসীর:<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111001.mp3"></audio> ১- تَبَّتْ يَدَا أَبِي لَهَبٍ وَتَبَّ <span class="c1">“ধ্বংস হোক আবু লাহাবের দুহাত এবং ধ্বংস হয়েছে সে নিজেও।”</span> : রাসূল সাল্লাল্লাহু আলাইহি ওয়াসাল্লামের চাচা আবু লাহাব ইবনু আব্দিল মুত্তালিবের দুটি হাত তার আমলের কারণে ধ্বংস হয়েছে; যেহেতু সে নবী সাল্লাল্লাহু আলাইহি ওয়াসাল্লামকে কষ্ট দিত; কিন্তু তার সকল প্রচেষ্টা ব্যর্থ হয়েছিল।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111002.mp3"></audio> ২- مَا أَغْنَى عَنْهُ مَالُهُ وَمَا كَسَبَ <span class="c1">“তার ধন-সম্পদ ও তার উপার্জন তার কোন কাজে আসেনি।”</span>: কোন বস্তু তাকে উক্ত ধ্বংস থেকে রক্ষা করবে- তার সম্পদ ও সন্তান? না, তারা কখনোই তার আযাব বা শাস্তিকে ফেরাতে পারবে না। আর তার জন্য কোন রহমতও নিয়ে আসতে পারবে না।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111003.mp3"></audio> ৩- سَيَصْلَى نَارًا ذَاتَ لَهَبٍ <span class="c1">“অচিরে সে দগ্ধ হবে লেলিহান আগুনে,”</span>: সে কিয়ামাতের দিন প্রজ্জ্বলিত শিখাবিশিষ্ট আগুনে প্রবেশ করবে, যার উত্তাপ হবে প্রচণ্ড।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111004.mp3"></audio> ৪- وَامْرَأَتُهُ حَمَّالَةَ الْحَطَبِ <span class="c1">“আর তার স্ত্রীও- যে ইন্ধন বহন করে,”</span>: আর তার স্ত্রী উম্মু জামীলও সেখানে প্রবেশ করবে, কেননা সেও নবী সাল্লাল্লাহু আলাইহি ওয়াসাল্লামকে পথে কাঁটা বিছিয়ে রেখে কষ্ট দিত।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111005.mp3"></audio> ৫- فِي جِيدِهَا حَبْلٌ مِنْ مَسَدٍ <span class="c1">“তার গলায় পাকানো রশি।”</span>: তার ঘাড়/গলাতে ভালভাবে পাকানো রশি থাকবে, যার মাধ্যমে তাকে জাহান্নামের আগুনের দিকে টেনে নিয়ে যাওয়া হবে। </p>',
            ],
            14 => [
                'question' => 'প্রশ্ন ১৫: সূরা আল-ইখলাস পাঠ কর এবং তা ব্যাখ্যা কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8650.mp3',
                'answer' => '<p> উত্তর: সূরা আল-<span class="c6">ইখলাস এবং তার ব্যাখ্যা:</span><br /> بِسْمِ اللهِ الرَّحْمنِ الرَّحِيمِ রহমান ও রহীম আল্লাহর নামে।<br /> قُلْ هُوَ اللَّهُ أَحَدٌ বলুন, তিনি আল্লাহ, এক-অদ্বিতীয়, <span class="c2">(১)</span> اللَّهُ الصَّمَدُ আল্লাহ হচ্ছেন সামাদ <span class="c2">(তিনি কারো মুখাপেক্ষী নন, সকলেই তাঁর মুখাপেক্ষী)</span>; <span class="c2">(২)</span> لَمْ يَلِدْ وَلَمْ يُولَدْ তিনি কাউকেও জন্ম দেননি এবং তাকেও জন্ম দেয়া হয়নি, <span class="c2">(৩)</span> وَلَمْ يَكُنْ لَهُ كُفُوًا أَحَدٌ এবং তাঁর সমতুল্য কেউই নেই।” <span class="c2">(৪)</span> <span class="c5">[সূরা আল-<span class="c6">ইখলাস:</span> ১-৪]</span><br /> তাফসীর:<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112001.mp3"></audio> ১- قُلْ هُوَ اللَّهُ أَحَدٌ <span class="c1">“বলুন, তিনি আল্লাহ, এক-অদ্বিতীয়,”</span>: হে রাসূল,<span class="c6"> আপনি বলুন:</span> তিনিই আল্লাহ, যিনি ছাড়া কোন প্রকৃত ইলাহ নেই।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112002.mp3"></audio> ২- اللَّهُ الصَّمَدُ <span class="c1">“আল্লাহ হচ্ছেন সামাদ <span class="c2">(তিনি কারো মুখাপেক্ষী নন, সকলেই তাঁর মুখাপেক্ষী)</span>;”</span>: যার কাছে সৃষ্টিজগতের প্রয়োজনসমূহ উপস্থিত করা হয়।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112003.mp3"></audio> ৩- لَمْ يَلِدْ وَلَمْ يُولَدْ <span class="c1">“তিনি কাউকেও জন্ম দেননি এবং তাকেও জন্ম দেয়া হয়নি,”</span>: সুমহান পবিত্র সত্তা তিনি, যার কোন সন্তানও নেই আর নেই কোন পিতাও।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112004.mp3"></audio> ৪- وَلَمْ يَكُنْ لَهُ كُفُوًا أَحَدٌ <span class="c1">“এবং তাঁর সমতুল্য কেউই নেই।”</span>: আর তার সৃষ্টির মধ্য হতে কোন বস্তুই তাঁর মত নয়। </p>',
            ],
            15 => [
                'question' => 'প্রশ্ন ১৬: সূরা আল-ফালাক পাঠ কর এবং তা ব্যাখ্যা কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8750.mp3',
                'answer' => '<p> উত্তর: সূরা আল-<span class="c6">ফালাক এবং তার ব্যাখ্যা:</span><br /> بِسْمِ اللهِ الرَّحْمنِ الرَّحِيمِ রহমান ও রহীম আল্লাহর নামে।<br /> قُلْ أَعُوذُ بِرَبِّ الْفَلَقِ <span class="c1">“বলুন, আমি আশ্রয় প্রার্থনা করছি ঊষার রবের <span class="c2">(১)</span> مِنْ شَرِّ مَا خَلَقَ তিনি যা সৃষ্টি করেছেন তার অনিষ্ট হতে, <span class="c2">(২)</span> وَمِنْ شَرِّ غَاسِقٍ إِذَا وَقَبَ আর অনিষ্ট হতে রাতের অন্ধকারের, যখন তা গভীর হয়, <span class="c2">(৩)</span> وَمِنْ شَرِّ النَّفَّاثَاتِ فِي الْعُقَدِ আর অনিষ্ট হতে সমস্ত নারীদের, যারা গিরায় ফুক দেয়, <span class="c2">(৪)</span> وَمِنْ شَرِّ حَاسِدٍ إِذَا حَسَدَ আর অনিষ্ট হতে হিংসুকের, যখন সে হিংসা করে।”</span> <span class="c2">(৫)</span> <span class="c5">[সূরা আল-<span class="c6">ফালাক:</span> ১-৫]</span><br /> তাফসীর:<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113001.mp3"></audio> ১- قُلْ أَعُوذُ بِرَبِّ الْفَلَقِ <span class="c1">“বলুন, আমি আশ্রয় প্রার্থনা করছি ঊষার রবের।”</span>: হে রাসূল,<span class="c6"> আপনি বলুন:</span> আমি সকালের রবের কাছে আশ্রয় ও নিরাপত্তা চাচ্ছি।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113002.mp3"></audio> ২- مِنْ شَرِّ مَا خَلَقَ <span class="c1">“তিনি যা সৃষ্টি করেছেন তার অনিষ্ট হতে,”</span>: মাখলূকের মধ্য থেকে যে সব বস্তু কষ্ট দেয়, তার অকল্যাণ থেকে।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113003.mp3"></audio> ৩- وَمِنْ شَرِّ غَاسِقٍ إِذَا وَقَبَ <span class="c1">“আর অনিষ্ট হতে রাতের অন্ধকারের, যখন তা গভীর হয়,”</span>: এছাড়াও আমি আল্লাহর কাছে আশ্রয় প্রার্থনা করছি এমন সব অকল্যাণ থেকে, যার অনিষ্টতা রাতে প্রকাশ পায়,<span class="c6"> যেমন:</span> চোর ও বিভিন্ন প্রাণী হতে আগত অকল্যাণ।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113004.mp3"></audio> ৪- وَمِنْ شَرِّ النَّفَّاثَاتِ فِي الْعُقَدِ <span class="c1">“আর অনিষ্ট হতে সমস্ত নারীদের, যারা গিরায় ফুক দেয়,”</span>: আমি আল্লাহর কাছে আরো আশ্রয় প্রার্থনা করছি এমন সব যাদু হতে, যা গিঁরাতে ফুঁক দিয়ে করা হয়।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113005.mp3"></audio> ৫- وَمِنْ شَرِّ حَاسِدٍ إِذَا حَسَدَ <span class="c1">“আর অনিষ্ট হতে হিংসুকের, যখন সে হিংসা করে।”</span> : এবং এমন সকল হিংসুক-বিদ্বেষ পোষণকারী হতে, যারা মানুষের প্রতি আল্লাহ প্রদত্ত নি‘আমাতের ব্যাপারে হিংসা করতে থাকে, তাদের থেকে উক্ত নি‘আমাতের বিলুপ্তি কামনা করে এবং তাদের কষ্টে নিপতিত করে। </p>',
            ],
            16 => [
                'question' => 'প্রশ্ন ১৭: সূরা আন-নাস পাঠ কর এবং তা ব্যাখ্যা কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8870.mp3',
                'answer' => '<p> উত্তর: সূরা আন-<span class="c6">নাস এবং তার ব্যাখ্যা:</span><br /> بِسْمِ اللهِ الرَّحْمنِ الرَّحِيمِ রহমান ও রহীম আল্লাহর নামে।<br /> قُلْ أَعُوذُ بِرَبِّ النَّاسِ <span class="c1">“বলুন, আমি আশ্রয় প্রার্থনা করছি মানুষের রবের, <span class="c2">(১)</span> مَلِكِ النَّاسِ মানুষের অধিপতির, <span class="c2">(২)</span> إِلَهِ النَّاسِ মানুষের ইলাহের কাছে, <span class="c2">(৩)</span> مِنْ شَرِّ الْوَسْوَاسِ الْخَنَّاسِ আত্মগোপনকারী কুমন্ত্রণাদাতার অনিষ্ট হতে, <span class="c2">(৪)</span> الَّذِي يُوَسْوِسُ فِي صُدُورِ النَّاسِ যে কুমন্ত্রণা দেয় মানুষের অন্তরে, <span class="c2">(৫)</span> مِنَ الْجِنَّةِ وَالنَّاسِ জিনের মধ্য থেকে এবং মানুষের মধ্য থেকে।”</span> <span class="c2">(৬)</span> <span class="c5">[সূরা আন-<span class="c6">নাস:</span> ১-৬]</span><br /> তাফসীর:<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114001.mp3"></audio> ১- قُلْ أَعُوذُ بِرَبِّ النَّاسِ <span class="c1">“বলুন, আমি আশ্রয় প্রার্থনা করছি মানুষের রবের।”</span>: হে রাসূল,<span class="c6"> আপনি বলুন:</span> আমি মানুষের রবের কাছে আশ্রয় ও নিরাপত্তা চাচ্ছি।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114002.mp3"></audio> ২- مَلِكِ النَّاسِ <span class="c1">“মানুষের অধিপতির,”</span>: যিনি তাদেরকে যেভাবে ইচ্ছা পরিচালনা করেন এবং তিনি ছাড়া আর কোন নিরঙ্কুশ মালিক নেই।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114003.mp3"></audio> ৩- إِلَهِ النَّاسِ <span class="c1">“মানুষের ইলাহের কাছে,”</span>: তথা তাদের প্রকৃত মা‘বূদের কাছে, যিনি ছাড়া তাদের সত্য কোন মা‘বূদ নেই।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114004.mp3"></audio> ৪- مِنْ شَرِّ الْوَسْوَاسِ الْخَنَّاسِ <span class="c1">“আত্মগোপনকারী কুমন্ত্রণাদাতার অনিষ্ট হতে,”</span>: এমন শয়তানের অকল্যাণ থেকে থেকে, যে মানুষের মধ্যে কুমন্ত্রণা দেয়।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114005.mp3"></audio> ৫- الَّذِي يُوَسْوِسُ فِي صُدُورِ النَّاسِ <span class="c1">“যে কুমন্ত্রণা দেয় মানুষের অন্তরে,”</span>: যে মানুষের অন্তরের মধ্যে কুমন্ত্রণা প্রবেশ করায়।<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114006.mp3"></audio> ৬- مِنَ الْجِنَّةِ وَالنَّاسِ <span class="c1">“জিনের মধ্য থেকে এবং মানুষের মধ্য থেকে।”</span>: তথা: কুমন্ত্রণাদানকারী মানুষ অথবা জিন উভয়ের মধ্য হতেই হতে পারে। </p>',
            ],
        ],
        5 => [
            0 => [
                'question' => 'প্রশ্ন ১: إنما الأعمال بالنيات “সব কাজ (এর প্রাপ্য) হবে নিয়্যাত অনুযায়ী।” হাদীসটি পূর্ণ কর এবং হাদীসটির কিছু শিক্ষা উল্লেখ কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9030.mp3',
                'answer' => '<p> উত্তর: আমীরুল মুমিনীন আবু হাফস উমার ইবনুল খাত্তাব রদিয়াল্লাহু আনহু বলেছেন: আমি রাসূলুল্লাহ সাল্লাল্লাহু আলাইহি ওয়াসাল্লামকে বলতে শুনেছি: <span class="c3">«إنما الأعمال بالنيات، وإنما لكل امرئ ما نوى، فمن كانت هجرته إلى الله ورسوله؛ فهجرته إلى الله ورسوله، ومن كانت هجرته لدنيا يصيبها، أو امرأة ينكحها؛ فهجرته إلى ما هاجر إليه»</span>: <span class="c1">“সব কাজ <span class="c2">(এর প্রাপ্য)</span> হবে নিয়্যাত অনুযায়ী। আর মানুষ তার নিয়্যাত অনুযায়ী প্রতিফল পাবে। কাজেই যার হিজরত হবে আল্লাহ ও তাঁর রাসূলের উদ্দেশ্যে, তার হিজরত আল্লাহ ও তাঁর রাসূলের উদ্দেশ্যে হয়েছে বলেই ধরা হবে। আর যার হিজরত হয় দুনিয়া অর্জনের জন্য বা কোন নারীকে বিবাহ করার উদ্দেশ্যে, তার হিজরত সে উদ্দেশ্যেই হবে যে উদ্দেশ্যে সে হিজরত করেছে।”</span> এটি সহীহ বুখারী ও মুসলিম বর্ণনা করেছেন।<br /> হাদীসের শিক্ষা:<br /> ১- প্রতিটি কাজের জন্য নিয়্যাত করা আবশ্যক,<span class="c6"> যেমন:</span> সালাত, সিয়াম, হজ্জসহ অন্যান্য আমল বা কাজসমূহ।<br /> ২-<span class="c6"> নিরেট আল্লাহ তা‘আলার জন্য নিয়্যাতটি পরিশুদ্ধ করা আবশ্যক।<br /> * দ্বিতীয় হাদীস:</span> </p>',
            ],
            1 => [
                'question' => 'প্রশ্ন ২: من أحدث في أمرنا هذا “যে ব্যক্তি আমাদের এ কাজের মধ্যে কোন নতুন বিষয় প্রবেশ করাবে...” হাদীসটি পূর্ণ কর এবং এর কতিপয় শিক্ষা উল্লেখ কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9090.mp3',
                'answer' => '<p> উত্তর: উম্মুল মুমিনীন উম্মু আব্দিল্লাহ আয়িশাহ রদিয়াল্লাহু আনহা বলেছেন: রাসূলুল্লাহ সাল্লাল্লাহু আলাইহি ওয়াসাল্লাম বলেছেন: من أحدث في أمرنا هذا ما ليس منه، فهو ردٌّ <span class="c1">“যে ব্যক্তি আমাদের এ দীনের মধ্যে নতুন কোন বিষয় প্রবেশ করাবে, যা তাতে নেই তা প্রত্যাখ্যাত।”</span> এটি বুখারী ও মুসলিম বর্ণনা করেছেন।<br /> হাদীসের শিক্ষা:<br /> ১- দীনের মধ্যে বিদ‘আত সৃষ্টি করা থেকে নিষেধাজ্ঞা।<br /> ২- আর প্রতিটি নবসৃষ্ট <span class="c2">(বিদ‘আত)</span> আমলসমূহ অগ্রহণযোগ্য ও প্রত্যাখ্যাত।<br /> * তৃতীয় হাদীস: </p>',
            ],
            2 => [
                'question' => 'প্রশ্ন ৩: بينما نحن جلوس عند رسول الله ﷺ ...“একদা আমরা রাসূলুল্লাহ সাল্লাল্লাহু আলাইহি ওয়াসাল্লামের কাছে বসা ছিলাম...” হাদীসটি পূর্ণ কর এবং এর কতিপয় শিক্ষা উল্লেখ কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9160.mp3',
                'answer' => '<p> উত্তর: عن عمر بن الخطاب رَضِيَ اللَّهُ عَنْهُ قال : بينما نحن جلوس عند رسول الله ﷺ ذات يوم، إذ طلع علينا رجل شديد بياض الثياب، شديد سواد الشعر، لا يرى عليه أثر السفر، ولا يعرفه منا أحد، حتى جلس إلى النبي ﷺ ، فأسند ركبته إلى ركبتيه ، ووضع كفيه على فخذيه،<span class="c6"> وقال:</span> <span class="c3">«يا محمد أخبرني عن الإسلام»</span>،<span class="c6"> فقال له:</span> <span class="c3">«الإسلام: أن تشهد أن لا إله إلا الله، وأن محمدًا رسول الله، وتقيم الصلاة، وتؤتي الزكاة، وتصوم رمضان، وتحج البيت إن استطعت إليه سبيلًا»</span>،<span class="c6"> قال :</span> <span class="c3">«صدقت»</span>، فعجبنا له يسأله ويصدقه،<span class="c6"> قال:</span> <span class="c3">«أخبرني عن الإيمان»</span> قال: <span class="c3">«أن تؤمن بالله، وملائكته، وكتبه، ورسله، واليوم الآخر، وتؤمن بالقدر؛ خيره وشره»</span>،<span class="c6"> قال:</span> <span class="c3">«صدقت»</span>،<span class="c6"> قال :</span> <span class="c3">«فأخبرني عن الإحسان»</span>،<span class="c6"> قال:</span> <span class="c3">«أن تعبد الله كأنك تراه، فإن لم تكن تراه، فإنه يراك»</span>،<span class="c6"> قال:</span> <span class="c3">«فأخبرني عن الساعة»</span>،<span class="c6"> قال:</span> <span class="c3">«ما المسؤول بأعلم من السائل»</span>،<span class="c6"> قال:</span> <span class="c3">«فأخبرني عن أماراتها»</span>،<span class="c6"> قال:</span> <span class="c3">«أن تلد الأمة ربتها، وأن ترى الحفاة العراة العالة رعاء الشاء، يتطاولون في البنيان»</span> ثم انطلق فلبث مليًّا،<span class="c6"> ثم قال:</span> <span class="c3">«يا عمر! أتدري من السائل؟»</span>،<span class="c6"> قلت:</span> "الله ورسوله أعلم"،<span class="c6"> قال:</span> <span class="c3">«فإنه جبريل، أتاكم يعلمكم دينكم»</span><span class="c1">“উমার ইবনুল খাত্তাব রাদিয়াল্লাহু আনহুমা থেকে বর্ণিত, তিনি বলেন, একদা আমরা রাসূলুল্লাহ সাল্লাল্লাহু আলাইহি ওয়া সাল্লাম-এর নিকট উপস্থিত ছিলাম। এমন সময় এক ব্যক্তি আমাদের সামনে আবির্ভূত হলো। তার পরনের কাপড়-চোপড় ছিল ধবধবে সাদা এবং মাথার চুলগুলো ছিল মিচমিচে কালো। সফর করে আসার কোনো চিহ্নও তার মধ্যে দেখা যায়নি। আমাদের কেউই তাকে চিনেও না। অবশেষে সে নবী সাল্লাল্লাহু আলাইহি ওয়া সাল্লাম এর সামনে বসলো। সে তার হাটুদ্বয় নবী সাল্লাল্লাহু আলাইহি ওয়া সাল্লাম এর হাটুদ্বয়ের সাথে মিলিয়ে দিলো এবং দুই হাতের তালু তার <span class="c2">(অথবা নিজের)</span> উরুর উপর রাখলো এবং বলল, হে মুহাম্মাদ! আমাকে ইসলাম সম্বন্ধে বলুন। রাসূলুল্লাহ সাল্লাল্লাহু আলাইহি ওয়া সাল্লাম বললেনঃ ইসলাম হচ্ছে এই– তুমি সাক্ষ্য দিবে যে, আল্লাহ ছাড়া প্রকৃতপক্ষে কোন ইলাহ <span class="c2">(মাবূদ)</span> নেই, এবং মুহাম্মাদ আল্লাহর রাসূল, সালাত কায়িম করবে, যাকাত আদায় করবে, রমযানের সওম পালন করবে এবং যদি পথ অতিক্রম করার সামর্থ্য হয় তখন বাইতুল্লাহর হজ্জ করবে। সে বললো, আপনি সত্যই বলেছেন।বর্ণনাকারী উমর বলেন, আমরা তার কথা শুনে আশ্চর্যাম্বিত হলাম। কেননা সে <span class="c2">(অজ্ঞের ন্যায়)</span> প্রশ্ন করছে আর <span class="c2">(বিজ্ঞের ন্যায়)</span> সমর্থন করছে। এরপর সে বললো, আমাকে ঈমান সম্পর্কে বলুন। রাসূলুল্লাহ সাল্লাল্লাহু আলাইহি ওয়া সাল্লাম বললেনঃ ঈমান এই যে, তুমি আল্লাহ, তার ফেরেশতাকুল, তার কিতাবসমূহ, তার প্রেরিত নবীগণ ও শেষ দিনের উপর ঈমান রাখবে এবং তুমি তাকদীর ও এর ভালো ও মন্দের প্রতিও ঈমান রাখবে। সে বললো, আপনি সত্যই বলেছেন। এবার সে বললো, আমাকে ইহসান সম্পর্কে বলুন। রাসূলুল্লাহ সাল্লাল্লাহু আলাইহি ওয়া সাল্লাম বললেনঃ ইহসান এই যে, তুমি এমনভাবে আল্লাহর ইবাদাত করবে যেন তুমি তাকে দেখছো, যদি তাকে না দেখে থাক,<span class="c6"> তাহলে তিনি অবশ্যই তোমাকে দেখছেন বলে অনুভব করবে।<br /> এবার সে জিজ্ঞেস করলো:</span> আমাকে কিয়ামাত সম্বন্ধে বলুন। রাসূলুল্লাহ সাল্লাল্লাহু আলাইহি ওয়া সাল্লাম বললেনঃ এ ব্যাপারে জিজ্ঞাসাকারীর চেয়ে জিজ্ঞাসিত ব্যক্তি বেশি কিছু জানে না। অতপর সে বলল, তাহলে আমাকে এর কিছু নির্দশন বলুন। তিনি বললেন, দাসী তার মনিবকে প্রসব করবে এবং <span class="c2">(এককালের)</span> নগ্নপদ, বস্ত্রহীন, দরিদ্র, বকরীর রাখালদের বড় দালান-কোঠা নির্মাণের প্রতিযোগিতায় গৰ্ব-অহংকারে মত্ত দেখতে পাবে। বর্ণনাকারী উমার বলেন, এরপর লোকটি চলে গেলো। আমি বেশ কিছুক্ষণ অপেক্ষা করলাম। তারপর রাসূলুল্লাহ সাল্লাল্লাহু আলাইহি ওয়া সাল্লাম আমাকে বললেন, হে উমার! তুমি জান, এ প্রশ্নকারী কে? আমি আরয করলাম, আল্লাহ ও তার রাসূলই অধিক জ্ঞাত আছেন। রাসূলুল্লাহ সাল্লাল্লাহু আলাইহি ওয়া সাল্লাম বললেন, তিনি জিবরীল। তোমাদের কাছে তিনি তোমাদের দীন শিক্ষা দিতে এসেছিলেন।”</span> এটি মুসলিম বর্ণনা করেছেন।<br /> হাদীসের শিক্ষা:<br /> ১-<span class="c6"> ইসলামের রুকনসমূহের উল্লেখ করা হয়েছে। এর সংখ্যা পাঁচটি:</span><br /> এ কথার সাক্ষ্য দেওয়া যে, আল্লাহ ছাড়া কোনো সত্য ইলাহ নেই এবং মুহাম্মাদ আল্লাহর রাসূল।<br /> সালাত কায়িম করা।<br /> যাকাত আদায় করা।<br /> রমাদানের সিয়াম পালন করা।<br /> আল্লাহর ঘর হারামে হজ্জ পালন করা।<br /> ২-<span class="c6"> ঈমানের রুকনসমূহ উল্লেখ করা হয়েছে। এর সংখ্যা ছয়টি:</span><br /> আল্লাহর প্রতি ঈমান।<br /> তাঁর ফিরিশতাদের প্রতি ঈমান।<br /> তাঁর কিতাবসমূহের প্রতি ঈমান।<br /> তাঁর রাসূলগণের প্রতি ঈমান।<br /> শেষদিন তথা আখিরাতের প্রতি ঈমান।<br /> আর তাকদীরের ভালো ও মন্দের প্রতি ঈমান।<br /> ৩- ইহসানের রুকনের বর্ণনা, এটির সংখ্যা একটি,<span class="c6"> তা হচ্ছে:</span> তুমি আল্লাহর ইবাদাত এমনভাবে করবে যেন তুমি তাকে দেখতে পাচ্ছ, আর যদি তুমি তাকে দেখতে নাও পার, তবুও তিনি তোমাকে দেখছেন।<br /> ৪-<span class="c6"> আল্লাহ তা‘আলা ব্যতীত কিয়ামাতের সময় আর কেউই জানে না।<br /> * চতুর্থ হাদীস:</span> </p>',
            ],
            3 => [
                'question' => 'প্রশ্ন ৪: أكمل المؤمنين إيماناً ... “ঈমানের দিক দিয়ে পরিপূর্ণ মুমিন হচ্ছে...।” হাদীসটি পূর্ণ কর এবং হাদীসটির কিছু শিক্ষা উল্লেখ কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9360.mp3',
                'answer' => '<p> উত্তর: আবূ হুরাইরাহ রাদিয়াল্লাহু আনহু থেকে বর্ণিত,<span class="c6"> তিনি বলেছেন:</span> রাসূলুল্লাহ সাল্লাল্লাহু আলাইহি ওয়াসাল্লাম বলেছেন: أكمل المؤمنين إيماناً: أحسنهم خلقاً তথা: <span class="c1">“ঈমানের দিক দিয়ে পরিপূর্ণ মু’মিন, তাদের মধ্যে যে চরিত্রের দিক দিয়ে সবচেয়ে সুন্দর।”</span> এটি তিরমিযী বর্ণনা করেছেন এবং তিনি বলেছেন: <span class="c5">[এটি একটি]</span> হাসান সহীহ হাদীছ।<br /> হাদীসের শিক্ষা:<br /> ১- উত্তম চরিত্রের উপরে গুরুত্বারোপ করা।<br /> ২- উত্তম চরিত্র উত্তম ঈমানেরই অংশ।<br /> ৩-<span class="c6"> ঈমান বাড়ে এবং কমে।<br /> * পঞ্চম হাদীস:</span> </p>',
            ],
            4 => [
                'question' => 'প্রশ্ন ৫: من حلف بغير الله “যে ব্যক্তি গাইরুল্লাহর নামে শপথ করল...” হাদীসটি পূর্ণ কর এবং এর কতিপয় শিক্ষা উল্লেখ কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9440.mp3',
                'answer' => '<p> উত্তর: ইবনু ‘উমার রদিয়াল্লাহু ‘আনহু সূত্রে বর্ণিত,<span class="c6"> রসূলুল্লাহ সাল্লাল্লাহু আলাইহি ওয়াসাল্লাম বলেছেন:</span> من حلف بغير الله؛<span class="c6"> فقد كفر أو أشرك তথা:</span> <span class="c1">“যে ব্যক্তি গাইরুল্লাহর নামে শপথ করল, সে কুফুরী অথবা শির্ক করল।”</span> এটি তিরমিযী বর্ণনা করেছেন।<br /> হাদীসের শিক্ষা:<br /> - আল্লাহ তা‘আলা ছাড়া অন্য কারো নামে শপথ করা জায়িয নেই।<br /> -<span class="c6"> আল্লাহ ব্যতীত অন্য কারো নামে শপথ করা ছোট শিরকের অন্তর্ভুক্ত।<br /> *ষষ্ঠ হাদীস:</span> </p>',
            ],
            5 => [
                'question' => 'প্রশ্ন ৬:.لا يؤمن أحدكم حتى أكون أحب إليه “তোমাদের কেউ প্রকৃত মুমিন হতে পারবে না, যতক্ষণ না আমি তার কাছে সবচেয়ে প্রিয়...” হাদীসটি পূর্ণ কর এবং এর কতিপয় শিক্ষা উল্লেখ কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9510.mp3',
                'answer' => '<p> উত্তর: আনাস রদিয়াল্লাহু আনহু থেকে বর্ণিত,<span class="c6"> তিনি বলেছেন:</span> রাসূলুল্লাহ সাল্লাল্লাহু আলাইহি ওয়াসাল্লাম বলেছেন: لا يؤمن أحدكم حتى أكون أحب إليه من والده، وولده، والناس أجمعين <span class="c1">“তোমাদের কেউ প্রকৃত মুমিন হতে পারবে না, যতক্ষণ না আমি তার নিকট তার পিতা, তার সন্তান ও সব মানুষ অপেক্ষা সবচেয়ে প্রিয়পাত্র হই।”</span> এটি বুখারী ও মুসলিম বর্ণনা করেছেন।<br /> হাদীসের শিক্ষা:<br /> - নবী সাল্লাল্লাহু আলাইহি ওয়া সাল্লামকে সমস্ত মানুষ থেকে বেশী মুহাব্বাত করা আবশ্যক।<br /> -<span class="c6"> আর এটা ঈমানের পূর্ণতার অন্তর্ভুক্ত।<br /> *সপ্তম হাদীস:</span> </p>',
            ],
            6 => [
                'question' => 'প্রশ্ন ৭: لا يؤمن أحدكم حتى يحب لأخيه তথা: “তোমাদের কেউ প্রকৃত মুমিন হতে পারবে না, যতক্ষণ না সে তার ভাইয়ের জন্য সেটাই পছন্দ করবে...” হাদীসটি পূর্ণ কর এবং এর কতিপয় শিক্ষা উল্লেখ কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9580.mp3',
                'answer' => '<p> উত্তর: আনাস রদিয়াল্লাহু আনহু থেকে বর্ণিত,<span class="c6"> তিনি বলেছেন:</span> রাসূলুল্লাহ সাল্লাল্লাহু আলাইহি ওয়াসাল্লাম বলেছেন: لا يؤمن أحدكم؛ حتى يحب لأخيه ما يحب لنفسه <span class="c1">“তোমাদের কেউ প্রকৃত মুমিন হতে পারবে না, যতক্ষণ না সে তার ভাইয়ের জন্য সেটাই পছন্দ করবে, যা তার নিজের জন্য পছন্দ করে।”</span> এটি বুখারী ও মুসলিম বর্ণনা করেছেন।<br /> হাদীসের শিক্ষা:<br /> ১- মুমিনের উপরে আবশ্যক হচ্ছে যে, সে তার নিজের জন্য যে উত্তম বিষয়সমূহ পছন্দ করবে, তা অন্য মুমিনদের জন্যও পছন্দ করবে।<br /> -<span class="c6"> আর এটা ঈমানের পূর্ণতার অন্তর্ভুক্ত।<br /> * অষ্টম হাদীস:</span> </p>',
            ],
            7 => [
                'question' => 'প্রশ্ন ১: والذي نفسي بيده “ঐ সত্তার কসম, যার হাতে আমার প্রাণ...” হাদীসটি পূর্ণ কর এবং হাদীসটির কিছু শিক্ষা উল্লেখ কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9650.mp3',
                'answer' => '<p> উত্তর: আবূ সা‘ঈদ রদিয়াল্লাহু ‘আনহু সূত্রে বর্ণিত,<span class="c6"> রাসূলুল্লাহ সাল্লাল্লাহু আলাইহি ওয়াসাল্লাম বলেছেন:</span> <span class="c3">«والذي نفسي بيده! إنها لتعدل تعدل ثلث القرآن»</span> <span class="c1">“ঐ সত্তার কসম, যার হাতে আমার প্রাণ, নিশ্চয় সেটি <span class="c2">(সূরা আল-ইখলাস)</span> কুরআনের এক-তৃতীয়াংশের সমান।”</span> এটি বুখারী বর্ণনা করেছেন।<br /> হাদীসের শিক্ষা:<br /> ১- সূরা আল-ইখলাসের ফযীলত।<br /> ২-<span class="c6"> আর সেটি কুরআনের তিন ভাগের একভাগের সমান।<br /> * নবম হাদীস:</span> </p>',
            ],
            8 => [
                'question' => 'প্রশ্ন ৯: لا حول ولا قوة إلا بالله “আল্লাহর নিকটে ছাড়া কোন উপায় অথবা শক্তি নেই।” হাদীসটি পূর্ণ কর এবং এর কতিপয় শিক্ষা উল্লেখ কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9720.mp3',
                'answer' => '<p> উত্তর: আবূ মূসা রদিয়াল্লাহু আনহু থেকে বর্ণিত,<span class="c6"> তিনি বলেছেন:</span> রাসূলুল্লাহ সাল্লাল্লাহু আলাইহি ওয়াসাল্লাম বলেছেন: <span class="c3">«لا حول ولا قوة إلا بالله كنز من كنوز الجنة»</span> <span class="c1">“আল্লাহর নিকটে ছাড়া কোন উপায় অথবা শক্তি নেই।’ এ কথাটি জান্নাতের সঞ্চিত ধনভান্ডারসমূহের মধ্যে একটি।”</span> এটি বুখারী ও মুসলিম বর্ণনা করেছেন।<br /> হাদীসের শিক্ষা:<br /> ১-<span class="c6"> لا حول ولا قوة إلا بالله এ বাক্যটির ফযীলত হচ্ছে:</span> এটি জান্নাতের সঞ্চিত ধনভান্ডারসমূহের মধ্যে একটি।<br /> ২-<span class="c6"> এটি বান্দাকে তার নিজস্ব ক্ষমতা ও উপায় অবলম্বন থেকে মুক্ত করে এবং তার নির্ভরতা শুধুমাত্র আল্লাহর উপরেই নির্দিষ্ট হয়ে যায়।<br /> * দশম হাদীস:</span> </p>',
            ],
            9 => [
                'question' => 'প্রশ্ন ১০: ألا إن في الجسد مضغة “নিশচয় শরীরের মধ্যে একটি মাংসের টুকরা রয়েছে...” হাদীসটি পূর্ণ কর এবং এর কতিপয় শিক্ষা উল্লেখ কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9790.mp3',
                'answer' => '<p> উত্তর: নু‘মান ইবনু বাশীর রদিয়াল্লাহু আনহুমা থেকে বর্ণিত,<span class="c6"> তিনি বলেছেন:</span> আমি রাসূলুল্লাহ সাল্লাল্লাহু আলাইহি ওয়াসাল্লামকে বলতে শুনেছি: <span class="c3">«ألا وإن في الجسد مضغة إذا صلحت صلح الجسد كله، وإذا فسدت فسد الجسد كله، ألا وهي القلب»</span><br /> <span class="c1">“নিশ্চয় শরীরের মধ্যে একটি মাংসের টুকরা রয়েছে, যখন সেটি ভাল হয়ে যায়, তখন সমস্ত শরীরই ভাল হয়ে যায়। আর যখন সেটি নষ্ট হয়ে যায়,<span class="c6"> তখন সমস্ত শরীরই নষ্ট হয়ে যায়। সেটি হচ্ছে:</span> ক্বলব।”</span> এটি বুখারী ও মুসলিম বর্ণনা করেছেন।<br /> হাদীসের শিক্ষা:<br /> ১- ক্বলব বা অন্তর ভাল হয়ে গেলে অভ্যন্তরীণ ও বাহ্যিক উভয় দিকই ভাল হয়ে যায়।<br /> ২-<span class="c6"> কলব বা অন্তরের পরিশুদ্ধিতার উপরে গুরুত্বারোপ করা; কেননা এতে মানুষের পরিশুদ্ধিতা নির্ভর করে।<br /> * একাদশ হাদীস:</span> </p>',
            ],
            10 => [
                'question' => 'প্রশ্ন ১১: من كان آخر كلامه من الدنيا: لا إله إلا الله তথা: “যার শেষ কথা হবে: ‘আল্লাহ ছাড়া কোন প্রকৃত ইলাহ নেই’...” হাদীসটি পূর্ণ কর এবং এর কতিপয় শিক্ষা উল্লেখ কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9860.mp3',
                'answer' => '<p> উত্তর: মু‘আয ইবনু জাবাল রদিয়াল্লাহু আনহু থেকে বর্ণিত,<span class="c6"> তিনি বলেছেন:</span> রাসূলুল্লাহ সাল্লাল্লাহু আলাইহি ওয়াসাল্লাম বলেছেন: <span class="c3">«من كان آخر كلامه: لا إله إلا الله؛ دخل الجنة»</span> <span class="c1">“যার শেষ কথা হবে “লা-ইলাহা ইল্লাল্লাহ’ <span class="c2">(আল্লাহ ছাড়া কোনো সত্য মাবুদ নেই)</span>, সে জান্নাতে প্রবেশ করবে।”</span> এটি আবূ দাঊদ বর্ণনা করেছেন।<br /> হাদীসের শিক্ষা:<br /> ১- لا إله إلا الله <span class="c1">“আল্লাহ ছাড়া কোন সত্য ইলাহ নেই”</span>- একথার ফযীলত। আর বান্দা এ কথা দ্বারাই জান্নাতে প্রবেশ করবে।<br /> ২- এবং যে ব্যক্তির দুনিয়াতে শেষ কালিমা হবে ‘লা ইলাহা ইল্লাল্লাহ’ -<span class="c6"> তার ফযীলত।<br /> * দ্বাদশ হাদীস:</span> </p>',
            ],
            11 => [
                'question' => 'প্রশ্ন ১২: ليس المؤمن بالطعان، ولا اللعان “মুমীন খোঁটা বা অপবাদ দানকারী, অধিক অভিশাপ প্রদানকারী...” হাদীসটি পূর্ণ কর এবং এর কতিপয় শিক্ষা উল্লেখ কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9940.mp3',
                'answer' => '<p> উত্তর: আব্দুল্লাহ ইবনু মাসঊদ রদিয়াল্লাহু আনহু থেকে বর্ণিত হয়েছে যে, তিনি বলেছেন,<span class="c6"> রাসূলুল্লাহ সাল্লাল্লাহু আলাইহি ওয়াসাল্লাম বলেছেন:</span> <span class="c3">«ليس المؤمن بالطعان، ولا اللعان، ولا الفاحش، ولا البذيء»</span><br /> <span class="c1">“মুমীন খোঁটা বা অপবাদ দানকারী, অধিক অভিশাপ প্রদানকারী, নির্লজ্জ ও অশ্লীল-ভাষী হয় না।”</span> এটি তিরমিযী বর্ণনা করেছেন।<br /> হাদীসের শিক্ষা:<br /> ১- অনর্থক ও মন্দ কথা বলা থেকে নিষেধাজ্ঞা।<br /> ২-<span class="c6"> এগুলো ত্যাগ করা মুমিনের ভাষাগত বা জিহ্বার বৈশিষ্ঠ্য।<br /> * ত্রয়োদশ হাদীস:</span> </p>',
            ],
            12 => [
                'question' => 'প্রশ্ন ১৩: من حسن إسلام المرء “কোন ব্যক্তির ইসলামের সৌন্দর্য.হচ্ছে...” হাদীসটি পূর্ণ কর এবং এর কতিপয় শিক্ষা উল্লেখ কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10020.mp3',
                'answer' => '<p> উত্তর: আবূ হুরাইরাহ রদিয়াল্লাহু আনহু থেকে বর্ণিত,<span class="c6"> তিনি বলেছেন:</span> রাসূলুল্লাহ সাল্লাল্লাহু আলাইহি ওয়াসাল্লাম বলেছেন: <span class="c3">«من حسن إسلام المرء: تركُه ما لا يعنيه»</span> <span class="c1">“কোন ব্যক্তির ইসলামের সৌন্দর্য হচ্ছে: স্বীয় অনর্থক কাজ ত্যাগ করা।”</span> তিরিমিযীসহ অন্যান্যরা হাদীসটি বর্ণনা করেছেন।<br /> হাদীসের শিক্ষা:<br /> ১- মানুষের জন্য তার দীনের বহির্ভুত ও দুনিয়ার লাভ নেই এমন বিষয়সমূহ পরিত্যাগ করা উচিত।<br /> ২-<span class="c6"> অনর্থক বিষয়সমূহ পরিত্যাগ করা ইসলামের পূর্ণতার মধ্য গণ্য।<br /> * চতুর্দশ হাদীস:</span> </p>',
            ],
            13 => [
                'question' => 'প্রশ্ন ১৪: من قرأ حرفاً من كتاب الله “যে ব্যক্তি আল্লাহর কিতাবের একটি হরফ পাঠ করবে...” হাদীসটি পূর্ণ কর এবং এর কতিপয় শিক্ষা উল্লেখ কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10100.mp3',
                'answer' => '<p> উত্তর: আব্দুল্লাহ ইবনু মাস‘ঊদ রদিয়াল্লাহু আনহু বলেছেন,<span class="c6"> নবী সাল্লাল্লাহু আলাইহি ওয়াসাল্লাম বলেছেন:</span> <span class="c3">«مَن قرأ حرفًا من كتاب الله فله به حسنة، والحسنة بعشر أمثالها،<span class="c6"> لا أقول:</span> ألف لام ميم حرف، وَلَكِنْ ألفٌ حرفٌ، ولامٌ حرفٌ، وميمٌ حرفٌ»</span> <span class="c1">“যে ব্যক্তি আল্লাহ কিতাব থেকে একটি হরফ পাঠ করবে,<span class="c6"> তার জন্য একটি সওয়াব রয়েছে। আর একটি সওয়াব দশটির সমান। আমি বলছি না:</span> الم একটি হরফ। বরং আলিফ একটি হরফ, লাম একটি হরফ এবং মীম একটি হরফ।”</span> এটি তিরমিযী বর্ণনা করেছেন।<br /> হাদীসের শিক্ষা:<br /> ১- কুরআন তিলাওয়াতের ফযীলত।<br /> ২- তুমি যতটুকু তিলাওয়াত করবে, তার প্রতিটি হরফের জন্যই তোমার সাওয়াব বরাদ্দ হবে। </p>',
            ],
        ],
        6 => [
            0 => [
                'question' => 'প্রশ্ন ০১: আল্লাহ তা‘আলার সাথে আদব (শিষ্টাচার) কেমন হবে?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10190.mp3',
                'answer' => '<p> উত্তর: ০১- আল্লাহ সুবহানাহু ওয়া তা‘আলাকে যথার্থ মর্যাদা দেওয়া।<br /> ০২- একনিষ্টভাবে আল্লাহ তা‘আলার ইবাদাত করা, তিনি একক, যার কোন শরীক নেই।<br /> ০৩- তাঁর আনুগত্য করা।<br /> ০৪- তাঁর অবাধ্যতা থেকে বিরত থাকা।<br /> ০৫- আল্লাহর অসংখ্য নি‘আমাত ও অনুগ্রহের উপরে প্রশংসা ও শুকরিয়া আদায় করা।<br /> ০৬- তাঁর প্রদত্ত তাকদীরের উপরে সবর করা। </p>',
            ],
            1 => [
                'question' => 'প্রশ্ন ০২: রসূল সাল্লাল্লাহু আলাইহি ওয়াসাল্লামের প্রতি আদব (শিষ্টাচার) কেমন হবে?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10270.mp3',
                'answer' => '<p> উত্তর ০১: তার অনুসরণ ও অনুকরণ করা।<br /> ০২- তার আনুগত্য করা।<br /> ০৩- তার অবাধ্য না হওয়া।<br /> ০৪- তিনি যেসব সংবাদ দিয়েছেন, তা মনে প্রানে বিশ্বাস করা।<br /> ০৫- তার সুন্নাতের মধ্যে কোন কিছু বৃদ্ধি করে বিদ‘আত তৈরী না করা।<br /> ০৬- নিজের থেকে এবং সকল মানুষ থেকে তাকে অধিক মহব্বত করা।<br /> ০৭- তার সম্মান করা, সাহায্য করা এবং তার সুন্নাতের সহযোগিতা করা। </p>',
            ],
            2 => [
                'question' => 'প্রশ্ন ০৩: পিতামাতার সাথে আদব রক্ষা কিভাবে হবে?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10360.mp3',
                'answer' => '<p> উত্তর: ০১- <span class="c2">(আল্লাহ ও রাসূলের)</span> অবাধ্যতা ছাড়া পিতামাতার অনুগত হওয়া।<br /> ০২- পিতামাতার খিদমত করা।<br /> ০৩- পিতামাতাকে সহযোগিতা করা।<br /> ০৪- পিতামাতার প্রয়োজন পূর্ণ করা।<br /> ০৫- তাদের জন্য দু‘আ করা।<br /> ০৬- কথার মধ্যে আদব রক্ষা করা, তাদেরকে উফ্ শব্দটিও না বলা, যেটি সবচেয়ে অল্প কথা।<br /> ০৭- পিতামাতার মুখে হাঁসি ফোটানো, আমি তাদের প্রতি ভ্রুকুটি করব না।<br /> ০৮-<span class="c6"> আমি আমার কণ্ঠকে পিতামাতার কণ্ঠের উপরে উঁচু করব না। তাদের দিকে মনোযোগ দেব। তাদের কথার মাঝে কথা বলব না। তাদেরকে নাম ধরে ডাকব না। বরং আমি বলব:</span> <span class="c1">“আমার পিতা” বা “আমার মা।”</span><br /> ০৯: তারা ঘরে অবস্থান করার সময়ে তাদের কাছে প্রবেশ করলে অনুমতি নেব।<br /> ১০- পিতামাতার হাত ও মাথা চুম্বন করব। </p>',
            ],
            3 => [
                'question' => 'প্রশ্ন ০৪: আমি কীভাবে আত্মীয়তার সম্পর্ক বজায় রাখব?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10490.mp3',
                'answer' => '<p> উত্তর: ০১- ভাই, বোন, চাচা, ফুফু, মামা ও খালাসহ অন্যান্য নিকটাত্মীয়দের সাক্ষাৎ করা।<br /> ০২- কথা ও কাজের দ্বারা তাদের প্রতি সুন্দর আচরণ ও সহযোগিতা করা।<br /> ০৩- এর মধ্যে অন্যতম হচ্ছে- তাদের সাথে যোগাযোগ রক্ষা করা এবং তাদের অবস্থা সম্পর্কে খোঁজ-খবর নেওয়া। </p>',
            ],
            4 => [
                'question' => 'প্রশ্ন ০৫: আমি আমার ভাই ও বন্ধুদের কাছে কেমন হব?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10550.mp3',
                'answer' => '<p> উত্তর: ০১- আমি উত্তম মানুষদের ভালোবাসব এবং তাদের সঙ্গী হব।<br /> ০২- আমি খারাপ মানুষের সংসর্গ থকে দূরে থাকব এবং তা পরিহার করব।<br /> ০৩- আমি আমার ভাইদেরকে সালাম প্রদান করব এবং তাদের সাথে মুসাফাহা করব।<br /> ০৪- তারা অসুস্থ হলে আমি তাদেরকে দেখতে যাব এবং তাদের সুস্থতার জন্য দু‘আ করব।<br /> ০৫- হাঁচির জবাব দেব।<br /> ০৬- তাদের সাক্ষাতের জন্য আহবান জানালে আমি তাদের আহবানে সাড়া দেব।<br /> ০৭- তাদের কাছে নসীহত পেশ করব।<br /> ০৮- সে অত্যাচারিত হলে তাকে সাহায্য করব এবং তাকেও জুলুম করা থেকে বিরত রাখব।<br /> ১০- আমি আমার মুসলিম ভাইয়ের জন্য তাই পছন্দ করব, যা আমি আমার নিজের জন্য পছন্দ করি।<br /> ১১- আমার সহযোগিতার প্রয়োজন হলে আমি তাদের সহযোগিতা করব।<br /> ১২- কথা বা কাজ দ্বারা আমি তাদেরকে কষ্ট দেব না।<br /> ১৩- তার গোপনীয়তা রক্ষা করব।<br /> ১৪- আমি তাকে গালি দেব না, গীবত করব না, ছোট মনে করব না, হিংসা করব না, তার গোপন কথা তালাশ করব না এবং তাকে ধোঁকা দেব না। </p>',
            ],
            5 => [
                'question' => 'প্রশ্ন ০৬: প্রতিবেশীর প্রতি আদব কী কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10710.mp3',
                'answer' => '<p> উত্তর ০১: কথা ও কাজের দ্বারা প্রতিবেশীর সাথে উত্তম আচরণ করব আর আমার সহযোগিতার প্রয়োজন হলে তাকে সহযোগিতা করব।<br /> ০২- ঈদ অথবা বিবাহের ন্যায় আনন্দ অনুষ্ঠানে তাকে আমি অভিবাদন জানাব।<br /> ০৩- অসুস্থ হলে আমি দেখতে যাব এবং বিপদগ্রস্ত হলে আমি সমবেদনা জানাব।<br /> ০৪- সাধ্যমত আমার তৈরী করা খাবার তাকে পাঠিয়ে দেব।<br /> ০৫- কথা অথবা কাজের মাধ্যমে তাকে কোন কষ্ট দেব না।<br /> ০৬- উঁচু আওয়াজে তাকে বিরক্ত করব না, দোষ অন্বেষণ করব না এবং তার ব্যাপারে ধৈর্য ধারণ করব। </p>',
            ],
            6 => [
                'question' => 'প্রশ্ন ০৭: অতিথী ও আতিথেয়তার আদবগুলো কী কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10800.mp3',
                'answer' => '<p> উত্তর: ০১- কেউ আতিথেয়তার আহ্বান করলে আমি তাতে সাড়া দেব।<br /> ০২-কারো সাক্ষাৎ করতে চাইলে তার থেকে অনুমতি ও সময় চেয়ে নেব।<br /> ০৩- কারো বাড়িতে বা আবাসে প্রবেশের আগে অনুমতি নিব।<br /> ০৪- সাক্ষাৎকে বিলম্ব করব না।<br /> ০৫- তার পরিবারের লোকদের <span class="c2">(বিশেষত নারী)</span> থেকে দৃষ্টি অবনমিত রাখবো।<br /> ০৬- সুন্দর ভাষা ও হাঁসিমুখে অতিথিদেরকে স্বাগত জানাব এবং তাদেরকে সুন্দরভাবে অভিবাদন জানাব।<br /> ০৭- অতিথিদেরকে সুন্দর স্থানে বসাব।<br /> ০৮- খাদ্য ও পানীয়ের মাধ্যমে আতিথেয়তা করব। </p>',
            ],
            7 => [
                'question' => 'প্রশ্ন ০৮: অসুস্থতা ও অসুস্থ ব্যক্তির সাক্ষাতের আদব উল্লেখ কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10900.mp3',
                'answer' => '<p> উত্তর ০১- যখন আমি কোন স্থানে ব্যথা অনুভব করব, তখন সেখানে আমার ডানহাত রেখে তিনবার <span class="c1">“বিসমিল্লাহ”</span> বলব,<span class="c6"> এরপরে সাতবার এ দু‘আটি পড়ব:</span> أعوذ بعزة الله وقدرته من شر ما أجد وأحاذر» <span class="c1">“আল্লাহর ইযযত ও কুদরতের দ্বারা আমি যে কষ্ট এবং ভয় পাচিছ তার অনিষ্ঠতা থেকে আশ্রয় আল্লাহর কাছে আশ্রয় প্রার্থনা করছি।”</span><br /> ০২- আল্লাহ তা‘আলা যা ভাগ্যে রেখেছেন, তাতে সন্তুষ্ট থাকব এবং সবর করব।<br /> ০৩- আমি আমার অসুস্থ ভাইকে দ্রুত দেখতে যাব, তার জন্য দু‘আ করব কিন্তু তার কাছে দীর্ঘক্ষণ বসে থাকব না।<br /> ০৪- সে আমার কাছে না চাইলেও আমি তাকে ঝাঁড়ফুক করব।<br /> ০৫- আমি তাকে দু‘আ, সবর, সালাত ও সাধ্যমত পবিত্র অবস্থায় থাকার পরামর্শ দেব।<br /> ০৬-<span class="c6"> অসুস্থ ব্যাক্তির জন্য দু‘আ:</span> <span class="c3">«أسأل الله العظيم رب العرش العظيم أن يشفيك»</span> <span class="c1">“আমি মহান আরশের রব মহাসম্মানিত আল্লাহর কাছে প্রার্থনা করছি যেন তিনি তোমাকে/আপনাকে সুস্থ করে দেন।”</span> <span class="c5">[সাতবার]</span>। </p>',
            ],
            8 => [
                'question' => 'প্রশ্ন ০৯: ইলম অন্বেষণের আদবসমূহ বর্ণনা কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10990.mp3',
                'answer' => '<p> উত্তর: ০১- আল্লাহ তা‘আলার জন্য ইখলাস সহকারে <span class="c2">(শিক্ষা করব)</span>।<br /> ০২- যে ইলম শিখলাম সে অনুযায়ী আমল করব।<br /> ০৩- শিক্ষককে তার উপস্থিতি ও অনুপস্থিতিতে সম্মান এবং সমীহ করব।<br /> ০৪- তার সামনে আদবের সাথে বসব।<br /> ০৫- আমি চুপ করে তার কথা শুনব এবং তার পাঠদানের মধ্যে কথা বলব না।<br /> ০৬- প্রশ্ন করার মাধ্যমে তার কাছ থেকে জেনে নেব।<br /> ০৭- তাকে নাম ধরে ডাকব না। </p>',
            ],
            9 => [
                'question' => 'প্রশ্ন ১০: মজলিসের আদবসমূহ কী কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11090.mp3',
                'answer' => '<p> উত্তর: ০১- আমি মজলিসে বসে থাকা ব্যক্তিদেরকে সালাম দেব।<br /> ০২- যেখানে মজলিস শেষ হবে, সেখানে বসব। বসার স্থান থেকে কাউকে উঠিয়ে দেব না আবার অনুমতি ছাড়া কোন দুজনের মধ্যেও বসব না।<br /> ০৩- অন্যরা যেন বসতে পারে, সেজন্য আমি মজলিসে জায়গা করে দেব।<br /> ০৪- মজলিসের কথার মধ্যে ব্যাঘাত ঘটাব না।<br /> ০৫- মজলিস থেকে বিদায় নেওয়ার আগে আমি অনুমতি নেব এবং সালাম প্রদান করব।<br /> ০৬- যখন মজলিস শেষ হবে, তখন আমি মজলিসের কাফফারার দু‘আ করব। سُبْحانَكَ اللَّهُمَّ وبِحَمْدِكَ، أشْهَدُ أنْ لا إلهَ إِلاَّ أنْتَ، أسْتَغْفِرُكَ وأتُوبُ إِلَيْكَ <span class="c1">“হে আল্লাহ! আপনি পবিত্র এবং সমস্ত প্রশংসা আপনার জন্য। আমি সাক্ষ্য দেই যে, আপনি ব্যতীত আর কোন মা‘বূদ নেই, আপনার কাছে আমি ক্ষমা প্রার্থনা করি এবং আপনি দিকেই প্রত্যাবর্তন করি’।”</span> </p>',
            ],
            10 => [
                'question' => 'প্রশ্ন ১১: ঘুমের আদবসমূহ উল্লেখ কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11180.mp3',
                'answer' => '<p> উত্তর: ০১- আমি দ্রুত ঘুমাবো।<br /> ০২- পবিত্র অবস্থায় ঘুমাবো।<br /> ০৩- পেটের উপরে ভর করে ঘুমাব না।<br /> ০৪- আমি আমার ডান পাশের উপরে এবং আমার ডান হাত আমার ডান গালের নিচে রাখব।<br /> ০৫- বিছানা ঝেড়ে নেব।<br /> ০৬- আয়াতুল কুরসী, সূরা ইখলাস,<span class="c6"> সূরা ফালাক ও সূরা নাস তিনবার পড়ব এবং ঘুমানোর যিকিরসমূহ পাঠ করব। আর বলব:</span> <span class="c3">«باسمك اللهم أموت وأحيا»</span>.<br /> <span class="c1">“হে আল্লাহ, আমি আপনার নামেই মৃত্যবরণ করি আর আপনার নামেই জীবিত হই।”</span><br /> ০৭- আমি ফজরের সালাতের জন্য জাগ্রত হব।<br /> ০৮-<span class="c6"> ঘুম থেকে জাগ্রত হওয়ার পরে বলব:</span> <span class="c3">«الحمد لله الذي أحيانا بعدما أماتنا وإليه النشور»</span>.<br /> <span class="c1">“সকল প্রশংসা তাঁরই, যিনি আমাদেরকে মৃত্যুর পরে জীবিত করেছেন, আর তার কাছেই প্রত্যাবর্তন।”</span> </p>',
            ],
            11 => [
                'question' => 'প্রশ্ন ১২: খাবারের আদবসমূহ কী কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11290.mp3',
                'answer' => '<p> উত্তর:<br /> ০১- পানাহারের মাধ্যমে আল্লাহ তা‘আলার আনুগত্যের ব্যাপারে শক্তি অর্জন করার নিয়ত করব।<br /> ০২- খাবার আগে দুই হাত ধোয়া।<br /> ০৩- আমি <span class="c1">“বিসমিল্লাহ”</span> বলে ডান হাত দিয়ে আমার কাছে থাকা খাবার খাব, প্লেটের মাঝ থেকে অথবা অন্যের সামনে থেকে নিয়ে খাব না।<br /> ০৪- যদি শুরুতে <span class="c1">“বিসমিল্লাহ”</span> বলতে ভুলে যাই,<span class="c6"> তাহলে বলব:</span> " بسم الله أوله وآخره " <span class="c2">(বিসমিল্লাহি আওয়ালাহু ওয়া আখিরাহ)</span> <span class="c1">“শুরু ও শেষ <span class="c2">(করছি)</span> আল্লাহর নামের মাধ্যমেই।”</span><br /> ০৫- উপস্থিত খাবার নিয়ে সন্তুষ্ট থাকব, খাবারের দোষ অন্বেষণ করব না, যদি ভাল লাগে, তাহলে খাব। আর যদি না ভাল লাগে, তাহলে তা রেখে দেব।<br /> ০৬- অল্প করে খাব, অধিক পরিমাণে খাব না।<br /> ০৭- খাদ্য ও পানীয়তে ফুঁ দেওয়া থেকে বিরত থাকব আর <span class="c2">(গরম হলে)</span> তা ঠান্ডা হওয়া পর্যন্ত রেখে অপেক্ষা করব।<br /> ০৮- পরিবার ও অতিথিদের সাথে একত্রে খাবারে শরীক হব।<br /> ০৯- আমার থেকে বড় ব্যক্তি শুরু করার আগে আমি খাওয়া শুরু করব না।<br /> ১০- আমি পান করার সময়ে আল্লাহর নাম নেব এবং বসে তিনবারে তা পান করব।<br /> ১১- খাবার শেষ করে আমি আল্লাহ তা‘আলার প্রশংসা করব। </p>',
            ],
            12 => [
                'question' => 'প্রশ্ন ১৩: পোশাক পরিধানের কতিপয় আদব উল্লেখ কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11440.mp3',
                'answer' => '<p> উত্তর: ০১- আমি ডান দিক থেকে আমার কাপড় পরা শুরু করব আর আল্লাহর প্রশংসা করব।<br /> ০২- আমি দুই টাখনুর নিচে কাপড়কে প্রলম্বিত করব না।<br /> ০৩- ছেলেরা মেয়েদের পোষাক এবং মেয়েরা ছেলেদের পোষাক পরবে না।<br /> ০৪- কাফির অথবা ফাসিক ব্যক্তিদের সাথে কাপড়ের সাদৃশ্য রাখব না।<br /> ০৫- কাপড় খোলার সময়ে আল্লাহর নাম স্মরণ করব।<br /> ০৬- জুতা/সেন্ডেল পরিধানের সময়ে আগে ডান পা এবং পরে বাম পা প্রবেশ করাব। </p>',
            ],
            13 => [
                'question' => 'প্রশ্ন ১৪: আরোহণের আদবসমূহ কী কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11540.mp3',
                'answer' => '<p> উত্তর: ০১-<span class="c6"> আমি বলব:</span> <span class="c1">“বিসমিল্লাহি আল-হামদুলিল্লাহ”</span>, <span class="c1">“আমি আল্লাহর নামে শুরু করছি, আর সকল প্রশংসা আল্লাহর জন্যই নিবেদিত।”</span> سُبْحَانَ الَّذِي سَخَّرَ لَنَا هَذَا وَمَا كُنَّا لَهُ مُقْرِنِينَ <span class="c1">“সুমহান পবিত্র সত্তা তিনি, যিনি এগুলোকে আমাদের বশীভূত করে দিয়েছেন, আর আমরা সমর্থ ছিলাম না এদেরকে বশীভূত করতে।”</span> وَإِنَّا إِلَى رَبِّنَا لَمُنْقَلِبُونَ <span class="c1">“আর নিশ্চয় আমরা আমাদের রবের কাছেই প্রত্যাবর্তনকারী।”</span> <span class="c5">[সূরা আয-<span class="c6">যুখরুফ:</span> ১৩-১৪]</span><br /> ০২- আমি যখন কোন মুসলিমের পাশ দিয়ে অতিক্রম করব, তখন তাকে সালাম দেব। </p>',
            ],
            14 => [
                'question' => 'প্রশ্ন ১৫: রাস্তার আদবসমূহ কী কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11590.mp3',
                'answer' => '<p> উত্তর: ০১- রাস্তার ডান দিক দিয়ে এবং ভারসাম্য বজায় রেখে বিনয়ের সাথে চলব।<br /> ০২- যার সাথে আমার সাক্ষাৎ হবে, তাকে সালাম প্রদান করব।<br /> ০৩- আমার চোখকে অবনমিত রাখব আর কাউকে কষ্ট দেব না।<br /> ০৪- সৎ কাজে আদেশ ও অসৎ কাজে মানুষকে নিষেধ করব।<br /> ০৫- রাস্তা থেকে কষ্টকর বস্তু সরিয়ে ফেলব। </p>',
            ],
            15 => [
                'question' => 'প্রশ্ন ১৬: বাড়ীতে প্রবেশ করা ও বের হওয়ার আদবগুলো কী কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11670.mp3',
                'answer' => '<p> উত্তর: ০১-<span class="c6"> বাম পা দিয়ে বের হব আর বলব:</span> بسم الله، توكلت على الله، لا حول ولا قوة إلا بالله، اللهم إني أعوذ بك أن أضل أو أضل، أو أزل أو أزل، أو أظلم أو أظلم، أو أجهل أو يجهل علي <span class="c1">“আল্লাহর নামে শুরু করলাম। আল্লাহর উপরেই ভরসা করলাম। আল্লাহর পক্ষ হতে আসা ব্যতীত কোন সাহায্য ও শক্তি নেই। হে আল্লাহ! নিশ্চয় আমি তোমার কাছে আশ্রয় প্রার্থনা করছি, যেন আমি কাউকে পথভ্রষ্ট না করি আর নিজেও পথভ্রষ্ট না হই, আমি যেন কাউকে বিচ্যুত না করি আর নিজেও বিচ্যুত না হই। আমি কারো উপরে জুলুম না করি আর আমিও যেন জুলুুমের শিকার না হই। আর আমি যেন কাউকে অজ্ঞতার মধ্যে নিক্ষেপ না করি আর নিজেও অজ্ঞতার মধ্যে নিক্ষিপ্ত না হই।”</span> ০২- ডান পা দিয়ে বাড়িতে প্রবেশ করব,<span class="c6"> আর বলব:</span> بسم الله ولجنا، وبسم الله خرجنا، وعلى ربنا توكلنا <span class="c1">“আল্লাহর নামেই আমরা প্রবেশ করেছি, আল্লাহর নামেই আমরা বের হয়েছি আর আমাদের রবের উপরেই আমরা তাওয়াক্কুল <span class="c2">(ভরসা)</span> করেছি।”</span><br /> ০৩- মিসওয়াকের মাধ্যমে <span class="c2">(বাড়ির কাজ)</span> শুরু করব তারপরে পরিবারের লোকদেরকে সালাম প্রদান করব। </p>',
            ],
            16 => [
                'question' => 'প্রশ্ন ১৭: পায়খানা-প্রসাব করার আদবসমূহ উল্লেখ কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11730.mp3',
                'answer' => '<p> উত্তর: ০১- বাম পা দিয়ে প্রবেশ করব।<br /> ০২-<span class="c6"> প্রবেশের আগে বলব:</span> بسم الله، اللهم إني أعوذ بك من الخبث والخبائث <span class="c1">“হে আল্লাহ! আমি আপনার নিকট অপবিত্র নর জিন্ন ও নারী জিন্ন থেকে আশ্রয় চাই।”</span><br /> ০৩- আল্লাহর নাম <span class="c2">(যিকর)</span> রয়েছে এমন কিছু সাথে নিয়ে প্রবেশ করব না।<br /> ০৪- প্রয়োজন মেটানোর সময়ে আমি নিজেকে আড়াল করে নেব।<br /> ০৫- প্রয়োজন মেটানোর <span class="c2">(প্রসাব-পায়খানার)</span> সময়ে কথা বলব না।<br /> ০৬- পায়খানা-প্রসাব করার সময় কিবলাকে সামনে অথবা পিছনে রেখে বসব না।<br /> ০৭- অপবিত্রতা দূর করার সময়ে বাম হাত ব্যবহার করব, ডান হাত ব্যবহার করব না।<br /> ০৮- মানুষ ছায়া গ্রহণ করে এমন স্থান অথবা তাদের যাতায়াতের পথে প্রসাব-পায়খানা করব না।<br /> ০৯- প্রসাব-পায়খানার পরে হাত ধুয়ে ফেলব।<br /> ১০- <span class="c2">(ইস্তিনজা থেকে)</span> বাম পা দিয়ে বের হব আর বলব: <span class="c1">“غفرانك” “আপনার ক্ষমা <span class="c2">(চাচ্ছি)</span>।”</span> </p>',
            ],
            17 => [
                'question' => 'প্রশ্ন ১৮: মসজিদের আদবসমূহ উল্লেখ কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11860.mp3',
                'answer' => '<p> উত্তর: ০১- আমি ডান পা দিয়ে মসজিদে প্রবেশ করব,<span class="c6"> আর বলব:</span> <span class="c3">«بسم الله، اللهم افتح لي أبواب رحمتك»</span> <span class="c1">“আল্লাহর নামে প্রবেশ করছি, হে আল্লাহ তুমি আমার জন্য তোমার রহমাতের দরজাসমূহ খুলে দাও।”</span><br /> ০২- দু রাকাত সালাত আদায় না করে বসব না।<br /> ০৩- কোন মুসল্লির সামনে দিয়ে অতিক্রম করব না, মসজিদে হারানো বস্তুর ঘোষনা দেব না এবং সেখানে ক্রয়-বিক্রয় করব না।<br /> ০৪-<span class="c6"> মসজিদ থেকে বাম পা দিয়ে বের হব আর বলব:</span> <span class="c3">« اللَّهُمَّ إنِّي أسألُكَ مِنْ فَضْلِك»</span> <span class="c1">“হে আল্লাহ আমি আপনার কাছে আপনার অনুগ্রহ প্রার্থনা করছি।”</span> </p>',
            ],
            18 => [
                'question' => 'প্রশ্ন ১৯: সালামের আদবসমূহ উল্লেখ কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11930.mp3',
                'answer' => '<p> উত্তর: ০১- কোন মুসলিমের সাথে দেখা হলে সালাম দিয়ে শুরু করব,<span class="c6"> এভাবে বলব:</span> <span class="c1">“আস-সালামু আলাইকুম ওয়া রহমাতুল্লাহি ওয়া বারাকাতুহু”</span>, সালাম না দিয়ে শুধু হাতের দ্বারা ইশারা করব না।<br /> ০২- যাকে সালাম দেব তার দিকে হাঁসিমুখে তাকাব।<br /> ০৩- আমার ডান হাত দিয়ে মুসাফাহা করব।<br /> ০৪- যখন আমাকে কেউ অভিবাদন জানাবে, তখন আমিও তাকে অনুরূপ বাক্যে অথবা তার থেকে উত্তম বাক্যে অভিবাদন জানাব।<br /> ০৫- আমি কাফির ব্যক্তিকে প্রথমে সালাম দেব না, আর যদি সে সালাম দেয়, তাহলে তার অনুরূপ সালামের জবাব দেব।<br /> ০৬- <span class="c2">(সালামের সাধারণ নিয়ম হচ্ছে)</span> ছোটরা বড়দেরকে সালাম দেবে, আরোহণকারী ব্যক্তি হেঁটে চলা ব্যক্তিকে সালাম দেবে, হেঁটে চলা ব্যক্তি বসে থাকা ব্যক্তিকে সালাম দেবে আর অল্প সংখ্যক লোক বেশী সংখ্যক লোককে সালাম দেবে। </p>',
            ],
            19 => [
                'question' => 'প্রশ্ন ২০: অনুমতির আদবসমূহ উল্লেখ কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12020.mp3',
                'answer' => '<p> উত্তর: ০১- কোন স্থানে প্রবেশের আগে আমি অনুমতি নেব।<br /> ০২- আমি তিনবার পর্যন্ত অনুমতি চাইব, এর থেকে বেশীবার নয়, অন্যথায় ফিরে আসব।<br /> ০৩- ভদ্রতার সাথে দরজাতে করাঘাত করব, দরজার একবারে সামনে দাঁড়াব না, বরং ডান অথবা বামদিকে সরে দাঁড়াব।<br /> ০৪- অনুমতি নেওয়ার আগে পিতা-মাতা অথবা কারো কামরায় প্রবেশ করব না। বিশেষভাবে ফজরের আগে, দুপুরে বিশ্রাম নেওয়ার সময়ে এবং ইশার সালাতের পরে।<br /> ০৫- তবে বাসস্থান ছাড়া অন্য স্থানসমূহ যেমন- হাসপাতাল অথবা বাজার ইত্যাদিতে অনুমতি ছাড়া প্রবেশ করা যাবে। </p>',
            ],
            20 => [
                'question' => 'প্রশ্ন ২১: প্রাণীর সাথে আচার আচরণের আদবসমূহ উল্লেখ কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12100.mp3',
                'answer' => '<p> উত্তর: ০১- আমি তাদেরকে খাওয়াব এবং পানি পান করতে দেব।<br /> ০২- প্রাণীর প্রতি সহানুভূতি ও দয়া দেখাব, তাদের সাধ্যের বাইরে এমন কোন বোঝা তাদের উপরে চাপাব না।<br /> ০৩- প্রাণীদেরকে কোন ধরণের কষ্ট বা শাস্তি দেব না। </p>',
            ],
            21 => [
                'question' => 'প্রশ্ন ২২: খেলাধুলার আদবসমূহ উল্লেখ কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12160.mp3',
                'answer' => '<p> উত্তর: ০১- খেলাধুলার দ্বারা আমি আল্লাহর আনুগত্য ও সন্তুষ্টি লাভের শক্তি অর্জন করার নিয়ত করব।<br /> ০২- আমরা সালাতের সময়ে খেলা করব না।<br /> ০৩- ছেলেরা মেয়েদের সাথে কোন খেলাতে অংশগ্রহণ করব না।<br /> ০৪- আমার সতর ঢাকা থাকবে এমন পোষাক পরে খেলাধুলা করব।<br /> ০৫- হারাম খেলাধুলা থেকে বিরত থাকব,<span class="c6"> যেমন:</span> চেহারাতে আঘাত করা অথবা সতর উন্মুক্ত করা হয়, এমন খেলাধুলা। </p>',
            ],
            22 => [
                'question' => 'প্রশ্ন ২৩: হাঁসি-ঠাট্টার কতিপয় আদব উল্লেখ কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12240.mp3',
                'answer' => '<p> উত্তর: ০১- মিথ্যা পরিহার করে সত্যের মধ্যে থেকে হাঁসি ঠাট্টা করা।<br /> ০২- কাউকে তুচ্ছ-তাচ্ছিল্য করা, কাউকে কষ্ট দেওয়া অথবা ভয়-ভীতি প্রদর্শন মুক্ত হাাঁসি-ঠাট্টা করা।<br /> ০৩- হাঁসি-ঠাট্টার ব্যাপারে বাড়াবাড়ি <span class="c2">(অতিরঞ্জিত)</span> না করা। </p>',
            ],
            23 => [
                'question' => 'প্রশ্ন ০৪: হাঁচির আদবসমূহ উল্লেখ কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12300.mp3',
                'answer' => '<p> উত্তর: ০১- হাঁচির সময়ে মুখে হাত, কাপড় অথবা রুমাল দেওয়া।<br /> ০২- হাঁচির শেষে <span class="c1">“আল-হামদুলিল্লাহ”</span> বলে আল্লাহর প্রশংসা করা।<br /> ০৩- <span class="c2">(হাঁচিদাতার উত্তরে)</span> তার ভাই অথবা সাথীরা বলবে: <span class="c1">“يرحمك الله”</span> তথা: আল্লাহ তোমার উপরে রহমত করুন।<br /> ০৪- তার জন্য উক্ত দু‘আ করা হলে,<span class="c6"> সে বলবে:</span> <span class="c1">“يهديكم الله ويصلح بالكم”</span> তথা: আল্লাহ তোমাকে হিদায়াত দিন এবং তোমার অন্তরকে সংশোধন করে দিন। </p>',
            ],
            24 => [
                'question' => 'প্রশ্ন ২৫: হাই তোলার আদব কী কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12360.mp3',
                'answer' => '<p> উত্তর: ০১- হাই প্রতিরোধের চেষ্টা করা।<br /> ০২- খুব জোরে “আহ” “আহ” শব্দ না করা।<br /> ০৩- মুখের উপরে হাত দেওয়া। </p>',
            ],
            25 => [
                'question' => 'প্রশ্ন ২৬: তিলাওয়াতের আদবসমূহ উল্লেখ কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12420.mp3',
                'answer' => '<p> উত্তর: ০১- অযু করে পবিত্র অবস্থায় কুরআন তিলাওয়াত করা।<br /> ০২- আদব ও সম্মানের সাথে বসা।<br /> ০৩- তিলাওয়াতের শুরুতে শয়তান থেকে আল্লাহর কাছে আশ্রয় চাওয়া।<br /> ০৪- কুরআন পাঠ করার সময়ে গভীর চিন্তা-ভাবনা করা। </p>',
            ],
        ],
        7 => [
            0 => [
                'question' => 'প্রশ্ন ০১: উত্তম চরিত্রের ফযীলত উল্লেখ কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12500.mp3',
                'answer' => '<p> উত্তর: নবী ‘আলাইহিস সালাতু ওয়াসসালাম বলেছেন: أكمل المؤمنين إيماناً: أحسنهم خلقاً <span class="c1">“ঈমানের দিক দিয়ে পরিপূর্ণ মু’মিন, তাদের মধ্যে যে চরিত্রের দিক দিয়ে সবচেয়ে সুন্দর।”</span> এটি তিরিমিযী ও আহমাদ বর্ণনা করেছেন। </p>',
            ],
            1 => [
                'question' => 'প্রশ্ন ০২: আমরা কেন ইসলামী আখলাক মেনে চলব?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12530.mp3',
                'answer' => '<p> উত্তর: ০১- কেননা এটা আল্লাহ তা‘আলার মুহাব্বাতের কারণ।<br /> ০২- এবং সৃষ্টিজগতের ভালবাসার কারণ।<br /> ০৩- এটি মীযানে সবচেয়ে বেশী ভারী বস্তু।<br /> ০৪- আমলের পুরষ্কার ও সওয়াব উত্তম চরিত্রের মাধ্যমে বৃদ্ধি পায়।<br /> ০৫- ঈমানের পূর্ণতার আলামত। </p>',
            ],
            2 => [
                'question' => 'প্রশ্ন ০৩: আমরা কোথা থেকে আখলাক গ্রহণ করব?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12600.mp3',
                'answer' => '<p> উত্তর: আল-কুরআনুল কারীম থেকে,<span class="c6"> আল্লাহ তা‘আলা বলেছেন:</span> إِنَّ هَذَا الْقُرْآَنَ يَهْدِي لِلَّتِي هِيَ أَقْوَمُ <span class="c1">“নিশ্চয় এ কুরআন হিদায়াত করে সে পথের দিকে যা সরল-সুদৃঢ়।”</span> <span class="c5">[সূরা আল-<span class="c6">ইসরা:</span> ০৯]</span> এবং সুন্নাতে নববী থেকে,<span class="c6"> এমনকি আল্লাহর রাসূল সাল্লাল্লাহু আলাইহি ওয়াসাল্লাম বলেছেন:</span> إنَّما بُعِثْتُ لِأُتَمِّمَ صالحَ الأَخلاقِ <span class="c1">“আমি তো প্রেরিত হয়েছি উত্তম চরিত্রের পূর্ণতা দান করার জন্যে।”</span> এটি আহমাদ বর্ণনা করেছেন। </p>',
            ],
            3 => [
                'question' => 'প্রশ্ন ০৪: ইহসান কী এবং সূরতগুলো কী কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12640.mp3',
                'answer' => '<p> উত্তর: ইহসান: সর্বদা আল্লাহ তা‘আলার তত্ত্বাবধানের খেয়াল রাখা,<span class="c6"> কল্যাণে নিয়োজিত থাকার পাশাপাশি মাখলূকের সাথে উত্তম আচরণ করা।<br /> নবী সাল্লাল্লাহু আলাইহি ওয়া সাল্লাম বলেছেন:</span> إِنَّ اللَّهَ كَتَبَ الْإِحْسَانَ عَلَى كُلِّ شَيْءٍ <span class="c1">“নিশ্চয় আল্লাহ প্রতিটি বস্তুর উপরে ইহসানকে ওয়াজিব হিসেবে লিপিবদ্ধ করে দিয়েছেন।”</span> এটি মুসলিম বর্ণনা করেছেন।<br /> ইহসানের কতিপয় সূরতসমূহ:<br /> - আল্লাহ তা‘আলার ইবাদাতের ক্ষেত্রে ইহসান,<span class="c6"> আর এটি হচ্ছে:</span> ইবাদাতের ক্ষেত্রে ইখলাস নিশ্চিত করা।<br /> - পিতা-মাতার প্রতি ইহসান, এটি কথা ও কাজের <span class="c2">(নম্রতার)</span> মাধ্যমে।<br /> - আত্মীয়-স্বজনদের প্রতি ইহসান।<br /> - প্রতিবেশীর প্রতি ইহসান করা।<br /> - ইয়াতিম-মিসকীনদের প্রতি ইহসান।<br /> - তোমার সাথে খারাপ আচরণকারীর সাথে ইহসান।<br /> - কথার মধ্যে ইহসান।<br /> - বিতর্কের মধ্যে ইহসান।<br /> - প্রাণীদের প্রতি ইহসান করা। </p>',
            ],
            4 => [
                'question' => 'প্রশ্ন ০৫: ইহসানের বিপরীত কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12780.mp3',
                'answer' => '<p> উত্তর: ইহসানের বিপরীত হচ্ছে: খারাপ আচরণ করা।<br /> * যার মধ্যে অন্যতম হচ্ছে: আল্লাহ তা‘আলার ইবাদাতের ক্ষেত্রে ইখলাস নষ্ট করা।<br /> * পিতামাতার নাফরমানি করা।<br /> * আত্মীয়তার সম্পর্ক নষ্ট করা।<br /> * প্রতিবেশীদের সাথে খারাপ আচরণ করা।<br /> * ফকীর-মিসকীনদের সাথে ভাল ব্যবহার না করা, এছাড়াও অন্যান্য খারাপ কথা ও কাজ। </p>',
            ],
            5 => [
                'question' => 'প্রশ্ন ০৬: আমানত কত প্রকার এবং এর সূরতগুলো কী কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12860.mp3',
                'answer' => '<p> উত্তর:<br /> ০১-<span class="c6"> আল্লাহ তা‘আলার হকসমূহ সংরক্ষণের আমানত।<br /> সূরত:</span> সালাত, যাকাত, সিয়াম ও হজ্জসহ যেসব ইবাদাত তিনি আমাদের উপরে ফরয করেছেন, তা আদায়ের ক্ষেত্রে আমানত রক্ষা করা।<br /> ০২- বান্দার হক সংরক্ষণের আমানত।<br /> - মানুষের সম্মান রক্ষা করা।<br /> - তাদের ধন-সম্পদ <span class="c2">(রক্ষা করা)</span>।<br /> - তাদের রক্ত বা জান <span class="c2">(রক্ষা করা)</span>।<br /> -<span class="c6"> তাদের গোপন বিষয়সমূহ এবং তোমার কাছে রাখা মানুষের সমুদয় আমানত রক্ষা করা।<br /> সফল বান্দাদের সিফাত বর্ণনা করে আল্লাহ তা‘আলা বলেছেন:</span> وَالَّذِينَ هُمْ لِأَمَانَاتِهِمْ وَعَهْدِهِمْ رَاعُونَ <span class="c1">“আর যারা নিজদের আমানতসমূহ ও অঙ্গীকারে যত্নবান।”</span> <span class="c5">[সূরা আল-<span class="c6">মুমিনূন:</span> ০৮]</span> </p>',
            ],
            6 => [
                'question' => 'প্রশ্ন ০৭: আমানতের বিপরীত কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12980.mp3',
                'answer' => '<p> উত্তর: খিয়ানত,<span class="c6"> তা হচ্ছে:</span> আল্লাহ তা‘আলার হক এবং বান্দাদের হকসমূহ নষ্ট করা।<br /> নবী আলাইহিস সালাতু ওয়াসসালাম বলেছেন: <span class="c3">«آيَةُ المُنافِقِ ثَلاثٌ»</span> <span class="c1">“মুনাফিকের আলামত তিনটি”</span> তার মধ্যে তিনি উল্লেখ করেছেন: <span class="c3">«وإذا اؤْتُمِنَ خانَ»</span> <span class="c1">“যখন আমানত রাখা হয়, তখন সে তা খিয়ানত করে।”</span> মুত্তাফাকুন ‘আলাইহি। </p>',
            ],
            7 => [
                'question' => 'প্রশ্ন ০৮: সত্যবাদিতা (এর গুণ) কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13020.mp3',
                'answer' => '<p> উত্তর: কোন বস্তুর প্রকৃত অবস্থা অথবা কোন ঘটনার বাস্তবতার অনুকূলে সংবাদ প্রদান করা।<br /> এর সূরত হচ্ছে:<br /> মানুষের সাথে কথা বলার ক্ষেত্রে সত্য বলা।<br /> ওয়াদার ক্ষেত্রে সত্যবাদিতা রক্ষা করা।<br /> প্রতিটি কথা ও কাজে সত্যবাদিতা রক্ষা করা।<br /> নবী আলাইহিস সালাতু ওয়াসসালাম বলেছেন: إنَّ الصِّدقَ يَهْدي إلى البِرِّ، وإنَّ البِرَّ يَهْدي إلى الجنَّةِ، وإنَّ الرَّجلَ لَيَصْدُقُ حتَّى يكونَ صِدِّيقًا <span class="c1">“সত্যবাদিতা কল্যাণের পথ দেখায়, কল্যাণ জান্নাতের পথ দেখায়। এক ব্যক্তি সত্য বলতে থাকে, এক পর্যায়ে সে আল্লাহর কাছে সত্যবাদী হিসেবে পরিগণিত হয়ে থাকে।”</span> মুত্তাফাকুন ‘আলাইহি। </p>',
            ],
            8 => [
                'question' => 'প্রশ্ন ০৯: সত্যবাদিতার বিপরীত কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13100.mp3',
                'answer' => '<p> উত্তর: মিথ্যা,<span class="c6"> যা বাস্তবতার বিপরীত। যার মধ্যে রয়েছে:</span> মানুষের সাথে মিথ্যা বলা,<span class="c6"> ওয়াদাকৃত বিষয়ের খেলাফ করা এবং মিথ্যা সাক্ষ্য দেওয়া।<br /> নবী সাল্লাল্লাহু আলাইহি ওয়া সাল্লাম বলেছেন:</span> وإنَّ الكذِبَ يَهْدي إلى الفُجورِ، وإنَّ الفُجورَ يَهْدي إلى النَّارِ، وإنَّ الرَّجلَ لَيَكذِبُ حتَّى يُكتَبَ عندَ اللهِ كذَّابًا <span class="c1">“নিশ্চয় মিথ্যা পাপাচারের পথ দেখায়, পাপাচার <span class="c2">(জাহান্নামের)</span> আগুনের পথ দেখায়। একজন ব্যক্তি মিথ্যা বলতে থাকে, যতক্ষণ না সে আল্লাহর কাছে মিথ্যুক হিসেবে পরিগণিত হয়ে থাকে।”</span> মুত্তাফাকুন ‘আলাইহি। নবী আলাইহিস সালাতু ওয়াসসালাম বলেছেন: <span class="c1">“মুনাফিকের আলামত তিনটি”</span> যার মধ্যে তিনি উল্লেখ করেছেন: <span class="c3">«إذا حدَّثَ كَذَبَ، وإذا وَعَدَ أَخلَفَ»</span> <span class="c1">“যখন সে কথা বলে, তখন মিথ্যা বলে, আর ওয়াদা করলে তার খেলাফ করে।”</span> মুত্তাফাকুন ‘আলাইহি। </p>',
            ],
            9 => [
                'question' => 'প্রশ্ন ১০: সবরের প্রকারসমূহ উল্লেখ কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13140.mp3',
                'answer' => '<p> উত্তর: - আল্লাহ তা‘আলার আনুগত্যের উপরে সবর করা।<br /> - পাপাচার থেকে সবর করা।<br /> - তাকদীরের নির্ধারিত কষ্টের উপরে সবর করা, আর সকল অবস্থায় আল্লাহর প্রশংসা করা।<br /> আল্লাহ তা‘আলা বলেন, وَٱللَّهُ يُحِبُّ ٱلصَّـبِرِينَ <span class="c1">“আর আল্লাহ সবরকারীদেরকে পছন্দ করেন।”</span> <span class="c5">[সূরা আলে-<span class="c6">ইমরান:</span> ১৪৬]</span> নবী আলাইহিস সালাতু ওয়াসসালাম বলেছেন: عجَبًا لأمْرِ المؤمنِ إنَّ أمْرَه كلَّهُ خيرٌ، وليس ذلك لأحدٍ إلَّا للمؤمنِ؛ إنْ أصابَتْهُ سَرَّاءُ شكَرَ فكان خيرًا له، وإنْ أصابَتْهُ ضَرَّاءُ صبَرَ فكان خيرًا له <span class="c1">“মুমিনের ব্যাপারটাই আশ্চর্যজনক। তার প্রতিটি কাজই তার জন্য ভালো। এটা মু’মিন ব্যতীত অন্য কারো জন্য নয়। যদি তাকে কল্যাণ স্পর্শ করে সে আল্লাহর শোকর আদায় করে। ফলে এটা তার জন্য মঙ্গলময় হয়। আর যদি তাকে ক্ষতি স্পর্শ করে সে ধৈর্য ধারণ করে। ফলে এটাও তার জন্য মঙ্গলময় হয়।”</span> এটি মুসলিম বর্ণনা করেছেন। </p>',
            ],
            10 => [
                'question' => 'প্রশ্ন ১১: সবরের বিপরীত কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13210.mp3',
                'answer' => '<p> উত্তর: এর বিপরীত হচ্ছে- আল্লাহর আনুগত্যের ব্যাপারে সবর না করা,<span class="c6"> পাপাচার থেকে বিরত থেকে সবর না করা এবং কথা ও কাজের মাধ্যমে তাকদীরের ব্যাপারে অসন্তুষ্ট হওয়া।<br /> সবরের কতিপয় সূরত হচ্ছে:</span><br /> * মৃত্যু কামনা করা।<br /> * গালে আঘাত করা।<br /> * কাপড়-<span class="c6">চোপড় ছিড়ে ফেলা।<br /> * চুল এলোমেলো করে রাখা।<br /> * নিজের ধংসের জন্য দু‘আ করা।<br /> নবী আলাইহিস সালাতু ওয়াসসালাম বলেছেন:</span> الْجَزَاءِ مَعَ عِظَمِ الْبَلَاءِ وَإِنَّ اللَّهَ إِذَا أَحَبَّ قَوْمًا ابْتَلَاهُمْ، فَمَنْ رَضِيَ فَلَهُ الرِّضَا، وَمَنْ سَخِطَ فَلَهُ السَّخَطُ “বিপদের কাঠিন্যতার সাথে পুরষ্কার আসে। আর নিশ্চয় আল্লাহ তা‘আলা কোন জাতীকে ভালবাসলে, তাদের উপরে বিপদ দিয়ে থাকেন। যে ব্যক্তি তাতে সন্তুষ্ট থাকতে পারে, তার জন্য থাকে <span class="c2">(আল্লাহর)</span> সন্তুষ্টি। আর যে ব্যক্তি তাতে অসন্তুষ্ট হয়, তার জন্য থাকে <span class="c2">(আল্লাহর)</span> অসন্তুষ্টি। এটি তিরমিযী ও ইবন মাজাহ বর্ণনা করেছেন। </p>',
            ],
            11 => [
                'question' => 'প্রশ্ন ১২: পরষ্পর সহযোগিতার গুণ সম্পর্কে বর্ণনা কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13310.mp3',
                'answer' => '<p> উত্তর: মানুষেরা নিজেদের মধ্যে একে অপরকে উত্তম ও কল্যাণের ব্যাপারে সহযোগিতা করা।<br /> সহযোগিতার সূরতসমূহ:<br /> - অধিকার বণ্টনে সহযোগিতা করা।<br /> - জালিমের অত্যাচার রোধে সহযোগিতা করা।<br /> - মিসকীন ও সাধারণ মানুষের প্রয়োজনসমূহ পূরণে সহযোগিতা করা।<br /> - প্রতিটি ভালো কাজে সহযোগিতা করা।<br /> - কাউকে কষ্ট দেওয়া,<span class="c6"> পাপাচার এবং সীমালঙ্ঘনে কারো সহযোগিতা না করা।<br /> আল্লাহ তা‘আলা বলেছেন:</span> وَتَعَاوَنُوا عَلَى الْبِرِّ وَالتَّقْوَى وَلَا تَعَاوَنُوا عَلَى الْإِثْمِ وَالْعُدْوَانِ وَاتَّقُوا اللَّهَ إِنَّ اللَّهَ شَدِيدُ الْعِقَابِ <span class="c1">“তোমরা নেককাজ এবং তাকওয়ার ব্যাপারে পরস্পর পরস্পরকে সাহায্য কর। তবে সীমা লঙ্ঘন পাপাচারের ক্ষেত্রে একে অপরকে সাহায্য করো না।”</span> <span class="c5">[সূরা আল-<span class="c6">মায়েদা:</span> ০২]</span> নবী আলাইহিস সালাতু ওয়াসসালাম বলেছেন: المُؤْمِنُ لِلْمُؤْمِنِ كالْبُنْيانِ؛ يَشُدُّ بَعْضُه بَعْضًا <span class="c1">“মুমিন অন্য মুমিনের জন্য একটি ইমারতের মত, যার একটি অংশ অন্য অংশকে দৃঢ়তা দান করে।”</span> মুত্তাফাকুন ‘আলাইহি। নবী আলাইহিস সালাতু ওয়াসসালাম বলেছেন: المُسْلِمُ أَخُو المُسْلِمِ، لا يَظلِمُه، ولا يُسْلِمُه، ومَن كان في حاجةِ أَخِيهِ، كان اللهُ في حاجَتِه، ومَن فَرَّجَ عن مُسْلِمٍ كُرْبَةً، فَرَّجَ اللهُ عَنهُ كُرْبَةً مِن كُرُباتِ يَومِ القِيامةِ، ومَن سَتَرَ مُسْلِمًا، سَتَرَهُ اللهُ يَومَ القِيامةِ <span class="c1">“এক মুসলিম অন্য মুসলিমের ভাই। সে তার উপর জুলুম করবে না এবং তাকে যালিমের হাতে সোপর্দ করবে না। যে কেউ তার ভাইয়ের অভাব পূরণ করবে,আল্লাহ তার অভাব পূরণ করবেন। যে ব্যক্তি তার মুসলিম ভাইয়ের বিপদ দুর করবে, আল্লাহ তা‘আলা কিয়ামাতের দিন তার বিপদসমূহ দূর করবেন। যে ব্যক্তি কোন মুসলিমের দোষ ঢেকে রাখবে, আল্লাহ কিয়ামাতের দিন তার দোষ ঢেকে রাখবেন।”</span> মুত্তাফাকুন ‘আলাইহি। </p>',
            ],
            12 => [
                'question' => 'প্রশ্ন ১৩: লজ্জাশীলতার প্রকারসমূহ কী কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13420.mp3',
                'answer' => '<p> উত্তর: ০১-<span class="c6"> আল্লাহর থেকে লজ্জা:</span> আল্লাহ সুবহানাহু ওয়া তা‘আলার নাফারমানী না করার মাধ্যমে লজ্জা করা।<br /> ০২-<span class="c6"> মানুষ থেকে লজ্জা:</span> যার মধ্যে রয়েছে- অশ্লীল আলাপ,<span class="c6"> বাজে কথা ও গোপনস্থান উন্মুক্ত করা পরিত্যাগ করা।<br /> রাসূলুল্লাহ্ সাল্লাল্লাহু আলাইহি ওয়া সাল্লাম বলেছেন:</span> <span class="c3">«الإِيمانُ بِضْعٌ وسَبعونَ»</span> -<span class="c6"> أو:</span> <span class="c3">«بِضْعٌ وسِتُّونَ»</span> - <span class="c3">«شُعْبةً،<span class="c6"> أَعْلَاها:</span> قَوْلُ: لا إِلَهَ إلَّا اللهُ.<span class="c6"> وأَدْناها:</span> إِماطةُ الأَذَى عنِ الطَّريقِ. والحَياءُ شُعْبةٌ مِنَ الإِيمانِ»</span> <span class="c1">“ঈমানের সত্তর অথবা ষাটের বেশি শাখা রয়েছে। তার মধ্যে সর্বোত্তম <span class="c2">(শাখা)</span> ‘লা ইলাহা ইল্লাল্লাহ’ বলা এবং সর্বনিম্ন <span class="c2">(শাখা)</span> রাস্তা থেকে কষ্টদায়ক জিনিস <span class="c2">(পাথর কাঁটা ইত্যাদি)</span> দূরীভূত করা। আর লজ্জা ঈমানের একটি শাখা।”</span> এটি মুসলিম বর্ণনা করেছেন। </p>',
            ],
            13 => [
                'question' => 'প্রশ্ন ১৪: রহমত গুণটির প্রকার উল্লেখ কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13470.mp3',
                'answer' => '<p> উত্তর: - বড়দের প্রতি রহমত করা,<span class="c6"> তথা:</span> তাদের সম্মান করা।<br /> - শিশু ও বয়সে ছোটদের প্রতি রহমত করা।<br /> - অভাবী, ফকীর ও মিসকীনদের প্রতি রহমত করা।<br /> -<span class="c6"> পশুদের খাবার দেওয়া ও তাদেরকে কষ্ট না দিয়ে রহমত করা।<br /> যার ব্যাপারে আল্লাহর রাসূল সাল্লাল্লাহু আলাইহি ওয়াসাল্লামের কথা:</span> تَرَى المُؤْمِنينَ في تَراحُمِهِم وتَوادِّهِم وتَعاطُفِهِم كمَثَلِ الجَسَدِ، إذا اشتَكَى عُضْوٌ تَداعَى لهُ سائِرُ جَسَدِهِ بالسَّهَرِ والحُمَّى <span class="c1">“পারস্পরিক দয়া, ভালোবাসা ও সহানুভূতি প্রদর্শনের ক্ষেত্রে মুমিনদের উদাহরণ একটি দেহের মতো। যখন শরীরের একটি অঙ্গ রোগাক্রান্ত হয়, তখন শরীরের সকল অঙ্গ-প্রত্যঙ্গ অনিদ্রা এবং জ্বরে অংশ নেয়।”</span> মুত্তাফাকুন ‘আলাইহি। রাসূলুল্লাহ্ সাল্লাল্লাহু আলাইহি ওয়া সাল্লাম বলেছেন: الرَّاحِمونَ يَرحَمُهُمُ الرَّحمنُ، ارْحَمُوا أهْلَ الأَرضِ، يَرحَمُكُمْ مَن في السَّماءِ <span class="c1">“রহমান দয়াশীলদের প্রতি দয়া করেন। তোমরা জমিনবাসীদের প্রতি দয়া কর, আসমানের অধিবাসী তোমাদের প্রতি দয়া করবেন।”</span> এটি আবূ দাঊদ ও তিরমিযী বর্ণনা করেছেন। </p>',
            ],
            14 => [
                'question' => 'প্রশ্ন ১৩: মুহাব্বাত বা ভালোবাসার প্রকারসমূহ কী কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13550.mp3',
                'answer' => '<p> উত্তর: আল্লাহ তা‘আলার ভালোবাসা।<br /> আল্লাহ তা‘আলা বলেছেন: وَالَّذِينَ آَمَنُوا أَشَدُّ حُبًّا لِلَّهِ <span class="c1">“পক্ষান্তরে যারা ঈমান এনেছে তারা আল্লাহকে সর্বাধিক ভালবাসে।”</span> <span class="c5">[সূরা আল-<span class="c6">বাকারাহ:</span> ১৬৫]</span><br /> রাসূল সাল্লাল্লাহু আলাইহি ওয়াসাল্লামের ভালোবাসা।<br /> তিনি বলেছেন: والَّذي نَفْسي بِيَدِه، لا يُؤمِنُ أحدُكم حتَّى أكونَ أحبَّ إليهِ مِن والِدِه ووَلَدِه ‘‘তোমাদের মথ্যে ততক্ষণ পর্যন্ত কেউ ঈমানদার হতে পারবে না, যতক্ষণ না আমি তার কাছে তার সন্তান-সন্ততি, পিতা-মাতা এবং সমস্ত মানুষের চেয়ে অধিক প্রিয় হই।’’ এটি বুখারী বর্ণনা করেছেন।<br /> মুমিনদেরকে ভালোবাসা এবং তাদের কল্যাণকে পছন্দ করা,<span class="c6"> যেভাবে তুমি নিজের কল্যাণ পছন্দ করে থাক।<br /> নবী আলাইহিস সালাতু ওয়াসসালাম বলেছেন:</span> لَا يُؤْمِنُ أَحَدُكُمْ حَتَّى يُحِبَّ لِأَخِيهِ مَا يُحِبُّ لِنَفْسِهِ <span class="c1">“তোমাদের কেউ প্রকৃত মুমিন হতে পারবে না, যতক্ষণ না সে তার ভাইয়ের জন্য সেটাই পছন্দ করবে, যা তার নিজের জন্য পছন্দ করে।”</span> এটি বুখারী বর্ণনা করেছেন। </p>',
            ],
            15 => [
                'question' => 'প্রশ্ন ১৬: প্রফুল্লতার সংজ্ঞা দাও।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13630.mp3',
                'answer' => '<p> উত্তর: মানুষের সাথে সাক্ষাতের সময়ে মুখে হাঁসি-খুশি ভাব, আনন্দ, মুচকি হাঁসি, কোমলতা এবং প্রফুল্লতা প্রকাশ করা।<br /> এটি মানুষকে বিরক্তকারী তাদের মুখের উপরে এ জাতীয় ভ্রূকুটি না করার মাধ্যমে।<br /> এর ফযীলতের ব্যাপারে হাদীসের মধ্যে এসেছে, আবু যার রাদিয়াল্লাহু আনহু বলেছেন,<span class="c6"> আমাকে নবী সাল্লাল্লাহু আলাইহি ওয়া সাল্লাম বলেছেন:</span> لا تَحْقِرَنَّ مِنَ المَعرُوفِ شَيْئًا، ولو أَنْ تَلْقَى أخاكَ بِوَجْهٍ طَلْقٍ <span class="c1">“তুমি পুণ্যের কোনো কাজকে তুচ্ছ মনে করো না। যদিও সেটি তোমার <span class="c2">(মুসলিম)</span> ভাইয়ের সঙ্গে হাঁসিমুখে সাক্ষাত করা হয়।”</span> এটি মুসলিম বর্ণনা করেছেন। রাসূলুল্লাহ্ সাল্লাল্লাহু আলাইহি ওয়া সাল্লাম বলেছেন: تَبَسُّمُكَ فِي وَجْهِ أَخِيكَ لَكَ صَدَقَةٌ “তোমার ভাইয়ের সামনে মুচকি হাসি দেওয়া তোমার জন্য সাদকা।“ এটি তিরমিযী বর্ণনা করেছেন। </p>',
            ],
            16 => [
                'question' => 'প্রশ্ন ১৭: হিংসা কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13690.mp3',
                'answer' => '<p> উত্তর: অন্য কোন ব্যক্তির উপরে থাকা নি‘আমাতের বিলুপ্তি কামনা করা অথবা অন্য কোন ব্যক্তির কাছে নি‘আমাত থাকাকে অপছন্দ করা।<br /> আল্লাহ তা‘আলা বলেছেন: وَمِنْ شَرِّ حَاسِدٍ إِذَا حَسَدَ <span class="c1">“আর প্রতিটি হিংসুক থেকে, যখন সে হিংসা করে।”</span> <span class="c5">[সূরা আল-<span class="c6">ফালাক:</span> ০৫]</span><br /> আনাস ইবনু মালিক রদিয়াল্লাহু ‘আনহু সূত্রে বর্ণিত,<span class="c6"> রাসূলুল্লাহ সাল্লাল্লাহু আলাইহি ওয়াসাল্লাম বলেছেন:</span> لا تَباغَضُوا، ولا تَحاسَدُوا، ولا تَدابَرُوا، وكُونوا -عِبادَ اللهِ- إخوانًا <span class="c1">“তোমরা পরষ্পরে শত্রুতা করবে না, হিংসা করবে না, কারো পিছনে লেগে থাকবে না। বরং আল্লাহর বান্দা হিসেবে পরষ্পর ভাই হয়ে থাকবে।”</span> এটি বুখারী ও মুসলিম বর্ণনা করেছেন। </p>',
            ],
            17 => [
                'question' => 'প্রশ্ন ১৮: তাচ্ছিল্য করা কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13740.mp3',
                'answer' => '<p> উত্তর: এটি হচ্ছে- তোমার কোন মুসলিম ভাইকে নিয়ে হাঁসি-<span class="c6">তামাশা করা এবং তাকে তুচ্ছ জ্ঞান করা। আর এটি বৈধ নয়।<br /> এ ব্যাপারে নিষেধ করে আল্লাহ তা‘আলা বলেছেন:</span> يَا أَيُّهَا الَّذِينَ آَمَنُوا لَا يَسْخَرْ قَومٌ مِنْ قَوْمٍ عَسَى أَنْ يَكُونُوا خَيْرًا مِنْهُمْ وَلَا نِسَاءٌ مِنْ نِسَاءٍ عَسَى أَنْ يَكُنَّ خَيْرًا مِنْهُنَّ وَلَا تَلْمِزُوا أَنْفُسَكُمْ وَلَا تَنَابَزُوا بِالْأَلْقَابِ بِئْسَ الِاسْمُ الْفُسُوقُ بَعْدَ الْإِيمَانِ وَمَنْ لَمْ يَتُبْ فَأُولَئِكَ هُمُ الظَّالِمُونَ <span class="c1">“হে ঈমানদারগণ ! কোন মুমিন সম্প্রদায় যেন অপর কোন মুমিন সম্প্রদায়কে উপহাস না করে; কেননা যাদেরকে উপহাস করা হচ্ছে তারা উপহাসকারীদের চেয়ে উত্তম হতে পারে এবং নারীরা যেন অন্য নারীদেরকে উপহাস না করে; কেননা যাদেরকে উপহাস করা হচ্ছে তারা উপহাসকারিণীদের চেয়ে উত্তম হতে পারে। আর তোমরা একে অন্যের প্ৰতি দোষারোপ করো না এবং তোমরা একে অন্যকে মন্দ নামে ডেকো না; ঈমানের পর মন্দ নাম অতি নিকৃষ্ট। আর যারা তাওবা করে না তারাই তো যালিম।”</span> <span class="c5">[সূরা আল-<span class="c6">হুজুরাত:</span> ১১]</span> </p>',
            ],
            18 => [
                'question' => 'প্রশ্ন ১৯: বিনয়ের সংজ্ঞা দাও।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13780.mp3',
                'answer' => '<p> উত্তর: এটি হচ্ছে- মানুষ নিজেকে অন্যের উপরে শ্রেষ্ট ভাববে না,<span class="c6"> যার ফলে সে মানুষকে তাচ্ছিল্যও করবে না এবং সত্যকে প্রত্যাখ্যান করবে না।<br /> আল্লাহ তা‘আলা বলেছেন:</span> وَعِبَادُ الرَّحْمَنِ الَّذِينَ يَمْشُونَ عَلَى الْأَرْضِ هَوْنًا <span class="c1">“আর রহমানের বান্দা, যারা যমীনের উপরে ধীরে সুস্থে চলাফেরা করে।”</span> <span class="c5">[সূরা আল-<span class="c6">ফুরকান:</span> ৬৩]</span> তথা: নম্রতা সহকারে বিনয়ী হয়ে। রাসূলুল্লাহ্ সাল্লাল্লাহু আলাইহি ওয়া সাল্লাম বলেছেন: وما تَواضَعَ أحَدٌ للهِ إلَّا رَفَعَهُ اللهُ <span class="c1">“যে ব্যক্তি আল্লাহর জন্য বিনয় অবলম্বন করবে আল্লাহ তার মর্যাদা বৃদ্ধি করবে।”</span> এটি মুসলিম বর্ণনা করেছেন। রাসূল সাল্লাল্লাহু আলাইহি ওয়াসাল্লাম বলেছেন: إنَّ اللهَ أَوْحى إليَّ أنْ تَواضَعُوا، حتَّى لا يَفخَرَ أحَدٌ على أحَدٍ، ولا يَبْغيَ أحَدٌ على أحَدٍ <span class="c1">“আল্লাহ তা‘আলা আমার নিকট অহী পাঠিয়েছেন যে, তোমরা পরষ্পর বিনয়ী হও, যেন কেউ কারো উপরে অহংকার না করে এবং সীমালঙ্ঘনও না করে।”</span> এটি মুসলিম বর্ণনা করেছেন। </p>',
            ],
            19 => [
                'question' => 'প্রশ্ন ২০: হারাম অহংকারের প্রকারসমূহ কী কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13840.mp3',
                'answer' => '<p> উত্তর: ০১- সত্যের উপরে অহংকার প্রকাশ,<span class="c6"> এটি হচ্ছে:</span> সত্যকে প্রত্যাখ্যান করা এবং তা গ্রহণ না করা।<br /> ০২- মানুষের উপরে অহংকার প্রকাশ,<span class="c6"> এটি হচ্ছে:</span> তাদেরকে তুচ্ছ-<span class="c6">তাচ্ছিল্য করা এবং তাদেরকে অপমানিত করা।<br /> রাসূলুল্লাহ্ সাল্লাল্লাহু আলাইহি ওয়া সাল্লাম বলেছেন:</span> لا يَدخُلُ الجَنَّةَ مَن كان في قَلبِه مِثْقالُ ذَرَّةٍ مِن كِبْرٍ <span class="c1">“যার অন্তরে অণু পরিমাণও অহংকার থাকবে, সে জান্নাতে প্রবেশ করবে না।”</span> فقال رَجُلٌ: إنَّ الرَّجُلَ يُحِبُّ أن يَكونَ ثَوبُه حسَنًا، ونَعْلُه حسَنةً؟<span class="c6"> قال:</span> <span class="c1">“তখন একজন বললেন: নিশ্চয় একজন মানুষ চায় যে, তার কাপড়টি সুন্দর হোক,<span class="c6"> তার জুতাটি সুন্দর হোক। তখন তিনি বললেন:</span> إنَّ اللهَ جَميلٌ يُحِبُّ الجَمالَ،<span class="c6"> الكِبْرُ:</span> بَطَرُ الحَقِّ، وَغَمْطُ النَّاسِ “নিশ্চয় আল্লাহ সুন্দর,<span class="c6"> এবং তিনি সৌন্দর্যকে পছন্দ করেন। অহংকার হচ্ছে:</span> সত্যকে প্রত্যাখ্যান করা এবং মানুষকে তাচ্ছিল্য করা।”</span> এটি মুসলিম বর্ণনা করেছেন।<br /> -<span class="c6"> بَطَرُ الحَقِّ শব্দের অর্থ:</span> সত্য বা হক প্রত্যাখ্যান করা।<br /> -<span class="c6"> غَمْطُ النَّاسِ শব্দের অর্থ:</span> তাদেরকে তাচ্ছিল্য করা।<br /> - সুন্দর কাপড় বা জুতা অহংকার নয়। </p>',
            ],
            20 => [
                'question' => 'প্রশ্ন ২১: নিষিদ্ধ ধোকার কতিপয় প্রকার উল্লেখ কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13910.mp3',
                'answer' => '<p> উত্তর: - কেনাবেচার মধ্যে ধোকাবাজি,<span class="c6"> আর তা হচ্ছে:</span> পণ্যের দোষ গোপন করা।<br /> - জ্ঞান অর্জনে ধোকাবাজি,<span class="c6"> যেমন:</span> শিক্ষার্থীদের পরীক্ষায় অসদুপায় অবলম্বন করা।<br /> - কথার মধ্যে ধোকাবাজি,<span class="c6"> যেমন:</span> মিথ্যা ও প্রতারণামূলক সাক্ষ্য দেওয়া।<br /> - তুমি যা বলেছ অথবা মানুষের সাথে একমত হয়ে চুক্তি করেছ,<span class="c6"> এমন বিষয় পূর্ণ না করা।<br /> ধোঁকা দেওয়া থেকে নিষেধাজ্ঞা সংক্রান্ত একটি হাদীস রয়েছে:</span>.<br /> أنَّ رسولَ اللهِ ﷺ مرَّ على صُبْرةِ طعامٍ، فأَدخَلَ يدَه فيها، فنالَتْ أصابعُه بَلَلًا،<span class="c6"> فقال:</span> <span class="c3">«ما هذا يا صاحِبَ الطَّعامِ؟»</span> قال: أصابَتْهُ السَّماءُ يا رسولَ اللهِ.<span class="c6"> قال:</span> রাসূলুল্লাহ সাল্লাল্লাহু আলাইহি ওয়াসাল্লাম একদিন একটি খাদ্য শস্যের স্তুপের পাশ দিয়ে পথ অতিক্রম করলেন। তিনি স্তুপের ভেতর হাত প্রবেশ করালে তার হাতের আঙ্গুলগুলো ভিজে গেল। তিনি বললেন: হে স্তুপের মালিক! এ কি ব্যাপার? লোকটি বলল: হে আল্লাহর রাসূল! এতে বৃষ্টির পানি লেগেছে। তিনি বললেন: <span class="c3">«أفلا جَعَلْتَه فَوقَ الطَّعامِ كَيْ يَراهُ النَّاسُ؟ مَن غَشَّ فليس مِنِّي»</span> <span class="c1">“সেগুলো তুমি স্তুপের ওপরে রাখলে না কেন? তাহলে লোকেরা দেখে নিতে পারতো। জেনে রাখো, যে ব্যক্তি ধোকাবাজি করে, আমার সাথে তার কোন সম্পর্ক নেই।”</span> এটি মুসলিম বর্ণনা করেছেন।<br /> الصُّبْرَة শব্দের অর্থ: খাদ্য-শস্যের স্তুপ। </p>',
            ],
            21 => [
                'question' => 'প্রশ্ন ২২: গীবত কাকে বলে?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13990.mp3',
                'answer' => '<p> উত্তর: অনুপস্থিত থাকা অবস্থায় কোন মুসলিম ভাইয়ের এমন ত্রুটি উল্লেখ করা,<span class="c6"> যা সে অপছন্দ করে।<br /> আল্লাহ তা‘আলা বলেছেন:</span> وَلَا يَغْتَبْ بَعْضُكُمْ بَعْضًا أَيُحِبُّ أَحَدُكُمْ أَنْ يَأْكُلَ لَحْمَ أَخِيهِ مَيْتًا فَكَرِهْتُمُوهُ وَاتَّقُوا اللَّهَ إِنَّ اللَّهَ تَوَّابٌ رَحِيمٌ <span class="c1">“এবং একে অন্যের গীবত করবে না। তোমাদের মধ্যে কি কেউ তার মৃত ভাইয়ের গোশত খেতে চাইবে? বস্তুত তোমরা তো একে ঘৃণ্যই মনে কর। আর তোমরা আল্লাহর তাকওয়া অবলম্বন কর; নিশ্চয় আল্লাহ্ তওবা গ্রহণকারী, পরম দয়ালু।”</span> <span class="c5">[সূরা আল-<span class="c6">হুজুরাত:</span> ১২]</span> </p>',
            ],
            22 => [
                'question' => 'প্রশ্ন ২৩: চোগলখোরীর পরিচয় দাও।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14030.mp3',
                'answer' => '<p> উত্তর: ঝগড়া বাধানোর নিমিত্তে মানুষের মধ্যে কথা ছড়িয়ে দেওয়া।<br /> রাসূলুল্লাহ্ সাল্লাল্লাহু আলাইহি ওয়া সাল্লাম বলেছেন: <span class="c3">«لا يَدخُلُ الجَنَّةَ نَمَّامٌ»</span> <span class="c1">“চোগলখোর জান্নাতে প্রবেশ করবে না।”</span> এটি মুসলিম বর্ণনা করেছেন। </p>',
            ],
            23 => [
                'question' => 'প্রশ্ন ২৪: অলসতা কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14070.mp3',
                'answer' => '<p> উত্তর: কল্যাণকর কাজ এবং মানুষের উপরে যা করা আবশ্যক তা পালনে ঢিলেমি করা।<br /> এর মধ্যে অন্যতম: ফরযসমূহ পালনে অলসতা করা।<br /> আল্লাহ তা‘আলা বলেছেন: إِنَّ الْمُنَافِقِينَ يُخَادِعُونَ اللَّهَ وَهُوَ خَادِعُهُمْ وَإِذَا قَامُوا إِلَى الصَّلَاةِ قَامُوا كُسَالَى يُرَاءُونَ النَّاسَ وَلَا يَذْكُرُونَ اللَّهَ إِلَّا قَلِيلً <span class="c1">“নিশ্চয় মুনাফিকরা আল্লাহকে ধোঁকা দেয়। আর তিনি তাদেরকে ধোঁকায় ফেলেন। আর যখন তারা সালাতে দাঁড়ায় তখন অলসভাবে দাঁড়ায়, তারা লোকদেরকে দেখায় এবং তারা আল্লাহকে কমই স্মরণ করে।”</span> <span class="c5">[সূরা আন-<span class="c6">নিসা:</span> ১৪২]</span><br /> সুতরাং মুমিনের উচিত অলসতা, দূর্বলতা ও বসে থাকার মনোভাব ত্যাগ করা, আর আল্লাহ তা‘আলা সন্তুষ্ট হন এমন কাজে, আন্দোলনে, চেষ্টা-প্রচেষ্টা এবং শ্রমদানে প্রবৃত্ত হওয়া। </p>',
            ],
            24 => [
                'question' => 'প্রশ্ন ২৫: রাগের প্রকারভেদ উল্লেখ কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14130.mp3',
                'answer' => '<p> উত্তর: ০১-<span class="c6"> প্রশংসিত রাগ:</span> এটি হচ্ছে- আল্লাহর জন্য রাগ, যখন কাফির, মুনাফিক অথবা অন্যান্যরা আল্লাহ সুবহানাহু ওয়া তা‘আলার সম্মান নষ্ট করে।<br /> ০২-<span class="c6"> নিন্দনীয় রাগ:</span> এটি হচ্ছে এমন রাগ, যা মানুষকে এমন কাজ ও কথার প্রতি ধাবিত করে,<span class="c6"> যা তার জন্য শোভা পায় না।<br /> নিন্দনীয় রাগের চিকিৎসা:</span><br /> অযু করা।<br /> দাঁড়িয়ে থাকলে বসে পড়া,<span class="c6"> বসে থাকলে শুয়ে পড়া।<br /> أن يَلتزِمَ بوصيَّةِ النَّبيِّ ﷺ في ذلك:</span> <span class="c3">«لا تَغضَبْ»</span>. <span class="c1">“তুমি রাগ করবে না”</span> নবী সাল্লাল্লাহু আলাইহি ওয়াসাল্লামের এ কথাটিকে সর্বদা অনুশীলন করা।<br /> অন্তরকে রাগান্বিত হওয়ার দিকে ধাবিত হওয়ার সময়ে নিয়ন্ত্রন করবে।<br /> বিতাড়িত শয়তান থেকে আল্লাহর নিকট আশ্রয় চাইতে হবে।<br /> চুপ থাকতে হবে। </p>',
            ],
            25 => [
                'question' => 'প্রশ্ন ২৬: তাজাসসুস (গোয়েন্দাগিরি) কাকে বলে?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14240.mp3',
                'answer' => '<p> উত্তর: মানুষের দোষ-<span class="c6">ত্রুটি এবং গোপনীয়তা খুঁজে বেড়ানো এবং তা প্রকাশ করে দেওয়া।<br /> এর হারাম সূরত হচ্ছে:</span><br /> - মানুষের ঘরে তাদের গোপন বিষয় অনুসন্ধান করা।<br /> - কোন দল বা ব্যক্তি বিশেষের কথা তাদের অজ্ঞাতসারে <span class="c2">(আঁড়ি পেতে)</span> শোনা।<br /> আল্লাহ তা‘আলা বলেছেন: وَلَا تَجَسَّسُوا ... <span class="c1">“তোমরা গোয়েন্দাগিরি করো না...”</span> <span class="c5">[সূরা আল-<span class="c6">হুজুরাত:</span> ১২]</span> </p>',
            ],
            26 => [
                'question' => 'প্রশ্ন ২৭: অপচয় কী? কৃপণতা কাকে বলে? দানশীলতা কাকে বলে?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14310.mp3',
                'answer' => '<p> উত্তর: -<span class="c6"> অপচয়:</span> কোন সম্পদকে তার ন্যায্য খাতের বাইরে ব্যয় করা।<br /> এর সম্পূর্ণ বিপরীত হচ্ছে কৃপণতা: এটি হচ্ছে- সম্পদকে তার ন্যায্য খাতে ব্যায় না করে গচ্ছিত রাখা।<br /> সঠিক পন্থা হচ্ছে উধার পন্থা,<span class="c6"> আর মুসলিম হবে সম্মানী।<br /> আল্লাহ তা‘আলা বলেছেন:</span> وَٱلَّذِينَ إِذَاۤ أَنفَقُوا لَمۡ يُسۡرِفُوا وَلَمۡ يَقۡتُرُوا وَكَانَ بَيۡنَ ذَ لِكَ قَوَامًا <span class="c1">“এবং যখন তারা ব্যয় করে তখন অপব্যয় করে না, কৃপনতাও করে না, আর তাদের পন্থা হয় এতদুভয়ের মধ্যবর্তী।”</span> <span class="c5">[সূরা আল-ফুরকান,<span class="c6"> আয়াত:</span> ৬৭]</span> </p>',
            ],
            27 => [
                'question' => 'প্রশ্ন ২৮: কাপুরুষতা কাকে বলে? আর সাহসিকতা কাকে বলে?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14370.mp3',
                'answer' => '<p> উত্তর: কাপুরুষতা: ভয় পাওয়া উচিত নয়,<span class="c6"> এমন বিষয়ে ভয় পাওয়া।<br /> যেমন:</span> সত্য বলা অথবা অন্যায়কে অস্বীকার করতে ভয় পাওয়া।<br /> সাহসিকতা: সত্যের উপরে অগ্রসর হওয়া। এর মধ্যে অন্যতম হচ্ছে: জিহাদের ময়দানে এবং ইসলাম ও মুসলিমদেরকে রক্ষা করার জন্য অগ্রসর হওয়া।<br /> নবী সাল্লাল্লাহু আলাইহি ওয়াসাল্লাম তার দু‘আর মধ্যে বলতেন: اللَّهُمَّ إنِّي أعوذُ بكَ من الجُبنِ <span class="c1">“হে আল্লাহ আমি আপনার কাছে কাপুরুষতা থেকে আশ্রয় প্রার্থনা করছি।”</span> রাসূলুল্লাহ্ সাল্লাল্লাহু আলাইহি ওয়া সাল্লাম বলেছেন: المؤمنُ القويُّ خيرٌ وأحبُّ إلى اللهِ مِن المؤمنِ الضَّعيفِ، وفي كُلٍّ خيرٌ <span class="c1">“দূর্বল মুমিন অপেক্ষা শক্তিশালী মুমিন আল্লাহর কাছে অধিকতর প্রিয় এবং উত্তম, তবে সবার মধ্যেই কল্যাণ রয়েছে।”</span> এটি সহীহ মুসলিম বর্ণনা করেছেন। </p>',
            ],
            28 => [
                'question' => 'প্রশ্ন ২৯: হারাম কতিপয় কথা-বার্তার পরিচয় উল্লেখ কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14440.mp3',
                'answer' => '<p> উত্তর: যেমন: - অভিশাপ দেওয়া এবং গালি দেওয়া।<br /> - কোন মানুষ কর্তৃক <span class="c2">(অন্যকে)</span> <span class="c1">“জানোয়ার” বা অনুরূপ কোন কথা বলা।<br /> -<span class="c6"> অথবা কোন অশ্লীল ও নির্লজ্জ কথা উল্লেখ করা।<br /> নবী সাল্লাল্লাহু আলাইহি ওয়া সাল্লাম এগুলোর প্রত্যেকটি থেকে নিষেধ করেছেন। তিনি বলেছেন:</span> ليس المؤْمِنُ بالطَّعَّانِ، ولا اللَّعَّانِ، ولا الفاحِشِ، ولا البَذيءِ “মুমীন খোঁটা দানকারী, অভিশাপ-কারী, নির্লজ্জ ও অশ্লীল-ভাষী হয় না।”</span> এটি তিরমিযী ও ইবনু হিব্বান বর্ণনা করেছেন। </p>',
            ],
            29 => [
                'question' => 'প্রশ্ন ৩০: মুসলিম ব্যক্তিকে উত্তম চরিত্রের গুণে গুণান্বিত করে এমন কারণসমূহ উল্লেখ কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14500.mp3',
                'answer' => '<p> উত্তর: ০১- এ মর্মে দু‘আ করা যেন আল্লাহ তোমাকে উত্তম চরিত্র দান করেন এবং এ ব্যাপারে তোমাকে সহযোগিতা করেন।<br /> ০২- আল্লাহ তা‘আলার তত্ত্বাবধানের খেয়াল রাখা, এবং <span class="c2">(এ চিন্তা করা)</span> তিনি তোমাকে জানেন, দেখেন এবং তোমার কথা শুনেন।<br /> ০৩- উত্তম চরিত্রের সওয়াব স্মরণ করা, এটি জান্নাতে প্রবেশের কারণ।<br /> ০৪- খারাপ চরিত্রের পরিণতি সম্পর্কে স্মরণ করা, এটি জাহান্নামে প্রবেশের কারণ।<br /> ০৫- উত্তম চরিত্রের কারণে আল্লাহর মুহাব্বাত এবং তাঁর সৃষ্টির মুহাব্বাত অর্জিত হয়। অনুরূপ খারাপ বা মন্দ চরিত্রের কারণে আল্লাহর অসন্তুষ্টি এবং তাঁর সৃষ্টির অসন্তুষ্টি অর্জিত হয়।<br /> ০৬- রাসূল সাল্লাল্লাহু আলাইহি ওয়া সাল্লামের সীরাত অধ্যয়ন এবং তার অনুসরণ করা।<br /> ০৭- উত্তম মানুষদের সঙ্গ গ্রহণ করা এবং মন্দ মানুষদের সঙ্গ থেকে দূরে থাকা। </p>',
            ],
        ],
        8 => [
            0 => [
                'question' => 'প্রশ্ন ০১: যিকিরের ফযীলত কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14630.mp3',
                'answer' => '<p> উত্তর: নবী সাল্লাল্লাহু আলাইহি ওয়া সাল্লাম বলেছেন: مثل الذي يذكر ربه والذي لا يذكر ربه، مثل الحي والميت <span class="c1">“যে ব্যক্তি তার রবের যিকির করে এবং যে তা করে না, তাদের উদাহরণ জীবিত ও মৃত ব্যক্তির মত।”</span> এটি সহীহ বুখারী বর্ণনা করেছেন।<br /> - এটা এ কারণে যে, মানুষের জীবনের মূল্য আল্লাহ তা‘আলার যিকির অনুযায়ী হয়। </p>',
            ],
            1 => [
                'question' => 'প্রশ্ন ০২: যিকিরের কতিপয় উপকারীতা উল্লেখ কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14670.mp3',
                'answer' => '<p> উত্তর: ০১- রহমান সন্তুষ্ট হন।<br /> ০২- শয়তান বিতাড়িত হয়।<br /> ০৩- মুসলিমকে খারাবী থেকে রক্ষা করে।<br /> ০৪- এর দ্বারা পুরষ্কার ও সাওয়াব অর্জিত হয়। </p>',
            ],
            2 => [
                'question' => 'প্রশ্ন ০৩: সবচেয়ে উত্তম যিকির কোনটি?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14730.mp3',
                'answer' => '<p> উত্তর: لا إله إلا الله <span class="c1">“লা- ইলাহা ইল্লাল্লাহ”</span> বলা,<span class="c6"> এর অর্থ:</span> <span class="c1">“আল্লাহ ছাড়া কোন প্রকৃত ইলাহ নেই।”</span> এটি তিরমিযী ও ইবন মাজাহ বর্ণনা করেছেন। </p>',
            ],
            3 => [
                'question' => 'প্রশ্ন ০৪: ঘুম থেকে উঠে তুমি কী বলবে?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14760.mp3',
                'answer' => '<p> الحمد لله الذي أحيانا بعدما أماتنا وإليه النشور <span class="c1">“সকল প্রশংসা তাঁরই, যিনি আমাদেরকে মৃত্যুর পরে জীবিত করেছেন, আর তার কাছেই প্রত্যাবর্তন।”</span> মুত্তাফাকুন ‘আলাইহি। </p>',
            ],
            4 => [
                'question' => 'প্রশ্ন ০৫: তুমি যখন কাপড় পরিধান করবে, তখন কী বলবে?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14790.mp3',
                'answer' => '<p> উত্তর: الحمد لله الذي كساني هذا الثوب ورزقنيه من غير حول مني ولا قوة “সকল প্রশংসা আল্লাহর জন্য, যিনি আমাকে এই পোষাক পরিয়েছেন এবং আমাকে তা দান করেছেন আমার থেকে কোন প্রচেষ্টা ও শক্তি ছাড়াই। এটি আবূ দাউদ, তিরমিযী ও অন্যান্যরা বর্ণনা করেছেন। </p>',
            ],
            5 => [
                'question' => 'প্রশ্ন ০৬: তুমি কাপড় খোলার সময়ে কী বলবে?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14820.mp3',
                'answer' => '<p> উত্তর: <span class="c1">“বিসমিল্লাহ”</span> <span class="c2">(বলব)</span>। এটি তিরমিযী বর্ণনা করেছেন। </p>',
            ],
            6 => [
                'question' => 'প্রশ্ন ০৭: নতুন কাপড় পরিধানের দু‘আটি কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14850.mp3',
                'answer' => '<p> উত্তর: اللهم لك الحمد أنت كسوتنيه، أسألك خيره وخير ما صنع له، وأعوذ بك من شره وشر ما صنع له <span class="c1">“হে আল্লাহ! সকল প্রশংসা আপনার। এটি আপনি আমাকে পরিয়েছেন। আমি আপনার নিকটে এর মধ্যে নিহিত কল্যাণ এবং যে উদ্দেশ্যে এটা বানানো হয়েছে তার কল্যাণ প্রার্থনা করছি। আর এর মধ্যে নিহিত ক্ষতি এবং যে উদ্দেশ্যে এটা বানানো হয়েছে তার অকল্যাণ হতে আপনার আশ্রয় চাচ্ছি।”</span> এটি আবূ দাঊদ ও তিরমিযী বর্ণনা করেছেন। </p>',
            ],
            7 => [
                'question' => 'প্রশ্ন ০৮: নতুন কাপড় পরিহিত ব্যক্তির জন্য কী দু‘আ করতে হয়?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14880.mp3',
                'answer' => '<p> উত্তর: যখন তুমি অন্য কাউকে নতুন কাপড় পরতে দেখবে,<span class="c6"> তার জন্য এ দু‘আ করবে:</span> تُبْلَى وَيُخْلِفُ اللَّهُ تَعَالَى <span class="c1">“এ কাপড় যেন পুরাতন হয় এবং আল্লাহ তা‘আলা যেন এর পরিবর্তে নতুন কাপড় দান করেন।”</span> এটি আবূ দাঊদ বর্ণনা করেছেন। </p>',
            ],
            8 => [
                'question' => 'প্রশ্ন ০৯: বাথরুমে -প্রাকৃতিক প্রয়োজন মেটানোর স্থানে- প্রবেশের সময় কী দু‘আ করতে হবে?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14910.mp3',
                'answer' => '<p> উত্তর: اللهم إني أعوذ بك من الخبث والخبائث <span class="c1">“হে আল্লাহ! আমি আপনার নিকট অপবিত্র নর ও নারী জিন্ন থেকে আশ্রয় চাই।”</span> মুত্তাফাকুন ‘আলাইহি। </p>',
            ],
            9 => [
                'question' => 'প্রশ্ন ১০: বাথরুম থেকে বের হওয়ার দু‘আ কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14940.mp3',
                'answer' => '<p> উত্তর: غفرانك <span class="c2">(গুফরা-নাকা)</span> <span class="c1">“আপনার ক্ষমা <span class="c2">(চাই)</span>”</span> বলা। এটি আবূ দাঊদ ও তিরমিযী বর্ণনা করেছেন। </p>',
            ],
            10 => [
                'question' => 'প্রশ্ন ১১: অযুর আগে তুমি কী বলবে?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14970.mp3',
                'answer' => '<p> উত্তর: <span class="c1">“বিসমিল্লাহ”</span> <span class="c2">(বলব)</span>। এটি আবূ দাঊদ ও অন্যরা বর্ণনা করেছেন। </p>',
            ],
            11 => [
                'question' => 'প্রশ্ন ১২: অযু শেষ করে কোন যিকির করতে হয়?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15000.mp3',
                'answer' => '<p> উত্তর: أشْهَدُ أنْ لا إلهَ إِلَّا اللهُ وَحْدَهُ لا شَرِيكَ لَهُ، وأشهدُ أنَّ مُحَمَّدًا عَبْدُهُ وَرَسُولُهُ <span class="c1">“আমি সাক্ষ্য দিচ্ছি যে, আল্লাহ ছাড়া কোনো সত্য ইলাহ নেই। আমি আরো সাক্ষ্য দিচ্ছি যে, মুহাম্মাদ সাল্লাল্লাহু আলাইহি ওয়াসাল্লাম আল্লাহর বান্দা ও তার রাসূল।”</span> এটি মুসলিম বর্ণনা করেছেন। </p>',
            ],
            12 => [
                'question' => 'প্রশ্ন ১৩: ঘর থেকে বের হওয়ার সময় কোন দু‘আ পড়তে হয়?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15020.mp3',
                'answer' => '<p> উত্তর: بسم الله، توكلت على الله، ولا حول ولا قوة إلا بالله <span class="c1">“আল্লাহর নামে <span class="c2">(বের হচ্ছি)</span>, আমি আল্লাহর উপরেই ভরসা করেছি, আল্লাহর কাছে ছাড়া কোন শক্তি অথবা উপায় নেই।”</span> এটি আবূ দাঊদ ও তিরমিযী বর্ণনা করেছেন। </p>',
            ],
            13 => [
                'question' => 'প্রশ্ন ১৪: ঘরে প্রবেশ করার সময়ে কোন দু‘আ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15050.mp3',
                'answer' => '<p> উত্তর: بسم الله ولجنا، وبسم الله خرجنا، وعلى الله ربنا توكلنا <span class="c1">“আল্লাহর নামে আমরা প্রবেশ করেছি,আল্লাহর নামেই বের হয়েছি, আর আমাদের রব আল্লাহর উপরেই আমরা ভরসা করেছি।”</span> তারপরে পরিবারের সদস্যদেরকে সালাম দেবে। এটি আবূ দাঊদ বর্ণনা করেছেন। </p>',
            ],
            14 => [
                'question' => 'প্রশ্ন ১৫: মসজিদে প্রবেশের দু‘আ কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15080.mp3',
                'answer' => '<p> উত্তর: اللهم افتح لي أبواب رحمتك <span class="c1">“হে আল্লাহ, আমার জন্য আপনার রহমতের দরজাসমূহ খুলে দিন।”</span> হাদীসটি মুসলিম বর্ণনা করেছেন। </p>',
            ],
            15 => [
                'question' => 'প্রশ্ন ১৬: মসজিদ থেকে বের হওয়ার দু‘আ কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15110.mp3',
                'answer' => '<p> উত্তর: اللهم إني أسألك من فضلك <span class="c1">“হে আল্লাহ, নিশ্চয় আমি আপনার অনুগ্রহ চাচ্ছি।”</span> </p>',
            ],
            16 => [
                'question' => 'প্রশ্ন ১৭: আযান শ্রবণ করলে তুমি কী বলবে?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15140.mp3',
                'answer' => '<p> উত্তর: আমি মুয়াযযিন যা বলে, তাই বলব। তবে যখন মুয়াযযিন حي على الصلاة <span class="c2">(সালাতের দিকে এসো)</span> এবং حي على الفلاح <span class="c2">(কল্যাণের দিকে এসো)</span> বলবে,<span class="c6"> তখন আমি বলব:</span> لا حول ولا قوة إلا بالله <span class="c2">(আল্লাহর কাছে ছাড়া কোন শক্তি এবং উপায় নেই)</span>। মুত্তাফাকুন ‘আলাইহি। </p>',
            ],
            17 => [
                'question' => 'প্রশ্ন ১৮: আযানের পরে তুমি কী বলবে?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15170.mp3',
                'answer' => '<p> উত্তর: নবী সাল্লাল্লাহু আলাইহি ওয়া সাল্লামের উপরে দরুদ পাঠ করবে। এটি মুসলিম বর্ণনা করেছেন। আরো বলব: اللهم رب هذه الدعوة التامة، والصلاة القـائـمـة، آت محـمـدًا الـوسـيلة والفـضـيلـة، وابـعثه مقامًا محمودًا الذي وعدته “হে আল্লাহ! এই পরিপূর্ণ আহবান ও প্রতিষ্ঠিত সালাতের রব! আপনি রসূলুল্লাহ সাল্লাল্লাহু আলাইহি ওয়াসাল্লামকে নৈকট্য ও মর্যাদা দান করুন এবং তাকে আপনার ওয়াদাকৃত প্রশংসিত স্থানে পৌঁছিয়ে দিন।" সহীহ বুখারী।<br /> আযান ও ইকামাতের মাঝখানে দু‘আ করব; কেননা এই দু‘আ ফেরত দেওয়া হয় না। </p>',
            ],
            18 => [
                'question' => 'প্রশ্ন ১৯: সকাল-সন্ধ্যায় তুমি কোন কোন দু‘আ পড়বে?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15220.mp3',
                'answer' => '<p> উত্তর: ০১-<span class="c6"> আয়াতুল কুরসী পড়ব:</span> اللَّهُ لَا إِلَهَ إِلَّا هُوَ الْحَيُّ الْقَيُّومُ لَا تَأْخُذُهُ سِنَةٌ وَلَا نَوْمٌ لَهُ مَا فِي السَّمَاوَاتِ وَمَا فِي الْأَرْضِ مَنْ ذَا الَّذِي يَشْفَعُ عِنْدَهُ إِلَّا بِإِذْنِهِ يَعْلَمُ مَا بَيْنَ أَيْدِيهِمْ وَمَا خَلْفَهُمْ وَلَا يُحِيطُونَ بِشَيْءٍ مِنْ عِلْمِهِ إِلَّا بِمَا شَاءَ وَسِعَ كُرْسِيُّهُ السَّمَاوَاتِ وَالْأَرْضَ وَلَا يَئُودُهُ حِفْظُهُمَا وَهُوَ الْعَلِيُّ الْعَظِيمُ <span class="c1">“আল্লাহ, তিনি ছাড়া কোন <span class="c2">(সত্য)</span> ইলাহ নেই, তিনি চিরঞ্জীব, সুপ্রতিষ্ঠিত ধারক। তাঁকে তন্দ্রা ও নিদ্রা স্পর্শ করে না। তাঁর জন্যই আসমানসমূহে যা রয়েছে তা এবং যমীনে যা আছে তা। কে সে, যে তাঁর নিকট সুপারিশ করবে তাঁর অনুমতি ছাড়া? তিনি জানেন যা আছে তাদের সামনে এবং যা আছে তাদের পেছনে। আর তারা তাঁর জ্ঞানের সামান্য পরিমাণও আয়ত্ব করতে পারে না, তবে তিনি যা চান তা ছাড়া। তাঁর কুরসী আসমানসমূহ ও যমীন পরিব্যাপ্ত করে আছে এবং এ দু’টোর সংরক্ষণ তাঁর জন্য বোঝা হয় না। আর তিনি সুউচ্চ, মহান।”</span> <span class="c5">[সূরা আল-বাকারাহ,<span class="c6"> আয়াত:</span> ২৫৫]</span> ০২-<span class="c6"> আরো পড়ব:</span> بِسۡمِ ٱللَّهِ ٱلرَّحۡمَـٰنِ ٱلرَّحِيمِ রহমান রহীম আল্লাহর নামে শুরু করছি। قُلْ هُوَ اللَّهُ أَحَدٌ <span class="c1">“বলুন, তিনি আল্লাহ, এক-অদ্বিতীয়, <span class="c2">(১)</span> اللَّهُ الصَّمَدُ আল্লাহ হচ্ছেন সামাদ <span class="c2">(তিনি কারো মুখাপেক্ষী নন, সকলেই তাঁর মুখাপেক্ষী)</span>; <span class="c2">(২)</span> لَمْ يَلِدْ وَلَمْ يُولَدْ তিনি কাউকেও জন্ম দেননি এবং তাকেও জন্ম দেয়া হয়নি, <span class="c2">(৩)</span> وَلَمْ يَكُنْ لَهُ كُفُوًا أَحَدٌ এবং তাঁর সমতুল্য কেউই নেই।”</span> <span class="c2">(৪)</span> তিনবার। بِسْمِ اللهِ الرَّحْمنِ الرَّحِيمِ রহমান ও রহীম আল্লাহর নামে। قُلْ أَعُوذُ بِرَبِّ الْفَلَقِ <span class="c1">“বলুন, আমি আশ্রয় প্রার্থনা করছি ঊষার রবের <span class="c2">(১)</span> مِنْ شَرِّ مَا خَلَقَ তিনি যা সৃষ্টি করেছেন তার অনিষ্ট হতে, <span class="c2">(২)</span> وَمِنْ شَرِّ غَاسِقٍ إِذَا وَقَبَ আর অনিষ্ট হতে রাতের অন্ধকারের, যখন তা গভীর হয়, <span class="c2">(৩)</span> وَمِنْ شَرِّ النَّفَّاثَاتِ فِي الْعُقَدِ আর অনিষ্ট হতে সমস্ত নারীদের, যারা গিরায় ফুক দেয়, <span class="c2">(৪)</span> وَمِنْ شَرِّ حَاسِدٍ إِذَا حَسَدَ আর অনিষ্ট হতে হিংসুকের, যখন সে হিংসা করে।”</span> <span class="c2">(৫)</span> তিনবার। بِسْمِ اللهِ الرَّحْمنِ الرَّحِيمِ রহমান ও রহীম আল্লাহর নামে। قُلْ أَعُوذُ بِرَبِّ النَّاسِ <span class="c1">“বলুন, আমি আশ্রয় প্রার্থনা করছি মানুষের রবের, <span class="c2">(১)</span> مَلِكِ النَّاسِ মানুষের অধিপতির, <span class="c2">(২)</span> إِلَهِ النَّاسِ মানুষের ইলাহের কাছে, <span class="c2">(৩)</span> مِنْ شَرِّ الْوَسْوَاسِ الْخَنَّاسِ আত্মগোপনকারী কুমন্ত্রণাদাতার অনিষ্ট হতে, <span class="c2">(৪)</span> الَّذِي يُوَسْوِسُ فِي صُدُورِ النَّاسِ যে কুমন্ত্রণা দেয় মানুষের অন্তরে, <span class="c2">(৫)</span> مِنَ الْجِنَّةِ وَالنَّاسِ জিনের মধ্য থেকে এবং মানুষের মধ্য থেকে।”</span> <span class="c2">(৬)</span> তিনবার। ০৩- اللهم أنت ربي لا إله إلا أنت، خلقتني وأنا عبدك، وأنا على عهدك ووعدك ما استطعت، أعوذ بك من شر ما صنعت، أبوء لك بنعمتك علي، وأبوء بذنبي، فاغفر لي، فإنه لا يغفر الذنوب إلا أنت <span class="c1">“হে আল্লাহ! আপনি আমার রব। আপনি ছাড়া আর কোন সত্য উপাস্য নেই। আপনিই আমাকে সৃষ্টি করেছেন, আমি আপনার বান্দা। আমি আপনার প্রতিশ্রুতি ও অঙ্গীকারের উপর যথাসাধ্য প্রতিষ্ঠিত আছি। আমি যা করেছি তার মন্দ থেকে আপনার নিকট আশ্রয় চাচ্ছি। আমার উপর আপনার যে নি‘আমাত রয়েছে তা আমি স্বীকার করছি এবং আমার অপরাধও আমি স্বীকার করছি। সুতরাং আপনি আমাকে ক্ষমা করেন। আপনি ছাড়া আর কেউ পাপ মার্জনা করার নাই।”</span> এটি বুখারী বর্ণনা করেছেন। </p>',
            ],
            19 => [
                'question' => 'প্রশ্ন ২০: ঘুমের সময়ে তুমি কী পড়বে?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15290.mp3',
                'answer' => '<p> উত্তর: باسمك اللهم أموت وأحيا <span class="c1">“হে আল্লাহ, আমি আপনার নামেই মৃত্যবরণ করি আর আপনার নামেই জীবিত হই।”</span> মুত্তাফাকুন ‘আলাইহি। </p>',
            ],
            20 => [
                'question' => 'প্রশ্ন ২১: খাবার শুরুর আগে তুমি কী বলবে?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15320.mp3',
                'answer' => '<p> উত্তর: <span class="c1">“বিসমিল্লাহ।”</span><br /> যদি তুমি শুরুতে ভুলে যাও,<span class="c6"> তাহলে বলবে:</span><br /> بسم الله في أوله وآخره <span class="c1">“আল্লাহর নামেই শুরু করছি প্রথমে এবং শেষে।”</span> এটি আবূ দাঊদ ও তিরমিযী বর্ণনা করেছেন। </p>',
            ],
            21 => [
                'question' => 'প্রশ্ন ২২: খাওয়া শেষ করে তুমি কী বলবে?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15370.mp3',
                'answer' => '<p> উত্তর: الحمد لله الذي أطعمني هذا ورزقنيه من غير حول مني ولا قوة <span class="c1">“সকল প্রশংসা আল্লাহর জন্য, যিনি আমাকে এ খাদ্য খাওয়ালেন এবং আমাকে তা দান করেছেন আমার থেকে কোন প্রচেষ্টা ও শক্তি ছাড়াই।”</span> এটি আবূ দাউদ, ইবন মাজাহ ও অন্যান্যরা বর্ণনা করেছেন। </p>',
            ],
            22 => [
                'question' => 'প্রশ্ন ২৩: মেজবানের জন্য মেহমান কী দু‘আ করবে?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15400.mp3',
                'answer' => '<p> উত্তর: اللـهم بـارك لهـم فيما رزقتهـم، واغـفر لهم وارحمهم <span class="c1">“হে আল্লাহ, আপনি তাদেরকে যে রিযিক দিয়েছেন, তার মধ্যে বরকত দিন। তাদেরকে ক্ষমা করুন এবং তাদেরকে রহম করুন।”</span> এটি মুসলিম বর্ণনা করেছেন। </p>',
            ],
            23 => [
                'question' => 'প্রশ্ন ২৪: কেউ হাঁচি দিলে কী বলবে?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15430.mp3',
                'answer' => '<p> উত্তর: الحمد لله <span class="c1">“যাবতীয় প্রশংসা আল্লাহর জন্যই।”</span><br /> <span class="c2">(হাঁচিদাতার উত্তরে)</span> তার ভাই অথবা সাথীরা বলবে: <span class="c1">“يرحمك الله”</span> <span class="c1">“আল্লাহ তোমার উপরে রহমত করুন।”</span><br /> তার জন্য উক্ত দু‘আ করা হলে,<span class="c6"> সে বলবে:</span> <span class="c1">“يهديكم الله ويصلح بالكم”</span> <span class="c1">“আল্লাহ তোমাদেরকে হিদায়াত দিন এবং তোমাদের অন্তরকে সংশোধন করে দিন।”</span> এটি সহীহ বুখারী বর্ণনা করেছেন। </p>',
            ],
            24 => [
                'question' => 'প্রশ্ন ২৫: কোন মজলিস শেষ করে দাঁড়ানো অথবা সমাপ্ত করে উঠার সময়ে ‘মজলিসের কাফফারা দু‘আ’ হিসেবে কী পড়বে?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15480.mp3',
                'answer' => '<p> উত্তর: سُبْحانَكَ اللَّهُمَّ وبِحَمْدِكَ، أشْهَدُ أنْ لا إلهَ إِلاَّ أنْتَ، أسْتَغْفِرُكَ وأتُوبُ إِلَيْكَ <span class="c1">“হে আল্লাহ! আপনি পবিত্র এবং সমস্ত প্রশংসা আপনার জন্য। আমি সাক্ষ্য দেই যে, আপনি ব্যতীত আর কোন মা‘বূদ নেই, আপনার কাছে আমি ক্ষমা প্রার্থনা করি এবং আপনি দিকেই প্রত্যাবর্তন করি’।”</span> এটি আবূ দাউদ, তিরমিযী ও অন্যান্যরা বর্ণনা করেছেন। </p>',
            ],
            25 => [
                'question' => 'প্রশ্ন ২৬: যানবাহনে আরোহণের দু‘আ কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15510.mp3',
                'answer' => '<p> উত্তর: بسم الله، والحمد لله <span class="c4">﴿سُبْحَانَ الَّذِي سَخَّرَ لَنَا هَذَا وَمَا كُنَّا لَهُ مُقْرِنِينَ 13 وَإِنَّا إِلَى رَبِّنَا لَمُنْقَلِبُونَ 14﴾</span>، <span class="c3">«الحمد لله، الحمد لله، الحمد لله، الله أكبر، الله أكبر، الله أكبر، سبحانك اللهم إني ظلمت نفسي فاغفر لي؛ فإنه لا يغفر الذنوب إلا أنت»</span> <span class="c1">“আল্লাহর নামে শুরু করছি, সকল প্রশংসা আল্লাহরই। সুমহান পবিত্র সত্তা তিনি, যিনি এগুলোকে আমাদের বশীভূত করে দিয়েছেন, আর আমরা সমর্থ ছিলাম না এদেরকে বশীভূত করতে। আর আমাদেরকে অবশ্যই আমাদের রবের কাছে ফিরে যেতে হবে। সকল প্রশংসা আল্লাহরই। সকল প্রশংসা আল্লাহরই। সকল প্রশংসা আল্লাহরই। আল্লাহ সবচেয়ে বড়। আল্লাহ সবচেয়ে বড়। আল্লাহ সবচেয়ে বড়। হে সুমহান সত্তা আল্লাহ, নিশ্চয় আমি আমার উপরে জুলুম করে ফেলেছি, সুতরাং আপনি আমাকে ক্ষমা করুন; যেহেতু আপনি ব্যতীত আর কেউই পাপ ক্ষমা করতে পারে না।”</span> এটি আবূ দাঊদ ও তিরমিযী বর্ণনা করেছেন। </p>',
            ],
            26 => [
                'question' => 'প্রশ্ন ২৭: সফরের দু‘আ কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15540.mp3',
                'answer' => '<p> উত্তর: <span class="c3">«الله أكبر، الله أكبر، الله أكبر <span class="c4">﴿سُبْحَانَ الَّذِي سَخَّرَ لَنَا هَذَا وَمَا كُنَّا لَهُ مُقْرِنِينَ 13 وَإِنَّا إِلَى رَبِّنَا لَمُنْقَلِبُونَ 14﴾</span>، اللهم إنا نسألك في سفرنا هذا البر والتقوى ومن العمل ما ترضى، اللهم هون علينا سفرنا هذا، واطو عنا بعده، اللهم أنت الصاحب في السفر، والخليفة في الأهل، اللهم إني أعوذ بك من وعثاء السفر، وكآبة المنظر، وسوء المنقلب، في المال والأهل»</span> "আল্লাহ সবচেয়ে বড়। আল্লাহ সবচেয়ে বড়। আল্লাহ সবচেয়ে বড়। সুমহান পবিত্র সত্তা তিনি, যিনি এগুলোকে আমাদের বশীভূত করে দিয়েছেন, আর আমরা সমর্থ ছিলাম না এদেরকে বশীভূত করতে। আর আমাদেরকে অবশ্যই আমাদের রবের কাছে ফিরে যেতে হবে। হে আল্লাহ! আমাদের এই সফরে আমরা আপনার নিকটে কল্যাণ, তাকওয়া এবং আপনি সন্তুষ্ট হন এমন কাজের তাওফীক চাচ্ছি। হে আল্লাহ! আমাদের এই সফর আমাদের জন্য সহজ করে দিন এবং এর দুরত্ব কমিয়ে দিন। হে আল্লাহ! আপনিই সফরসঙ্গী এবং পরিবারের দায়িত্বশীল। হে আল্লাহ! আপনার নিকটে আশ্রয় প্রার্থনা করি সফরের কষ্ট, দুঃখজনক দৃশ্য এবং ফিরে এসে পরিবার ও ধন-<span class="c6">সম্পদের ক্ষতিকর পরিবর্তন থেকে।"<br /> সফর থেকে ফিরে এসে এ কথার সাথে বৃদ্ধি করে বলবে:</span><br /> آيبون، تائبون، عابدون، لربنا حامدون <span class="c1">“<span class="c2">(আমরা)</span> প্রত্যাবর্তনকারী, তাওবাকারী, ইবাদতকারী এবং আমাদের রবের প্রশংসাকারী।”</span> এটি সহীহ মুসলিম বর্ণনা করেছেন। </p>',
            ],
            27 => [
                'question' => 'প্রশ্ন ২৮: মুকীমের জন্য মুসাফির কী দু‘আ করবে?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15590.mp3',
                'answer' => '<p> উত্তর: أستودعكم الله الذي لا تضيع ودائعه <span class="c1">“আমি আপনাদেরকে সেই আল্লাহর নিকট আমানত রাখছি যার আমানাতগুলো নষ্ট হয় না।”</span> এটি আহমাদ ও ইবন মাযাহ বর্ণনা করেছেন। </p>',
            ],
            28 => [
                'question' => 'প্রশ্ন ২৯: মুসাফিরের জন্য মুকীম কী দু‘আ করবে?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15620.mp3',
                'answer' => '<p> উত্তর: أستودع الله دينك، وأمانتك، وخواتيم عملك <span class="c1">“আপনার দীন, আপনার আমানত এবং তোমার আমলের পরিণাম আল্লাহর কাছে আমানত রাখলাম।”</span> এটি আহমাদ ও তিরমিযী বর্ণনা করেছেন। </p>',
            ],
            29 => [
                'question' => 'প্রশ্ন ৩০: বাজারে প্রবেশের দু‘আ কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15650.mp3',
                'answer' => '<p> উত্তর: لا إله إلا الله وحده لا شريك له، له الملك، وله الحمد، يحيي ويميت، وهو حي لا يموت، بيده الخير، وهو على كل شيء قدير <span class="c1">“আল্লাহ ছাড়া কোন সত্য ইলাহ নেই। তিনি একক, তাঁর কোন শরীক নেই। রাজত্ব তাঁরই, প্রশংসাও তাঁর। তিনিই জীবন দান করেন, তিনিই মৃত্যু দেন। তিনি চিরঞ্জীব, যিনি কখনো মৃত্যুবরণ করবেন না। তাঁর হাতেই সমগ্র কল্যাণ। আর তিনি প্রতিটি বস্তুর উপরেই ক্ষমতাবান।”</span> এটি তিরমিযী ও ইবন মাজাহ বর্ণনা করেছেন। </p>',
            ],
            30 => [
                'question' => 'প্রশ্ন ৩১: রাগ হলে কোন দু‘আ পড়তে হয়, উল্লেখ কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15680.mp3',
                'answer' => '<p> উত্তর: أعوذ بالله من الشيطان الرجيم <span class="c1">“আমি বিতাড়িত শয়তান থেকে আল্লাহর নিকট আশ্রয় চাই।”</span> মুত্তাফাকুন ‘আলাইহি। </p>',
            ],
            31 => [
                'question' => 'প্রশ্ন ৩২: কোন ব্যক্তি তোমার সাথে ভালো আচরণ করলে তুমি তাকে কী বলবে?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15710.mp3',
                'answer' => '<p> উত্তর: جزاك الله خيرا <span class="c1">“আল্লাহ আপনাকে উত্তম বিনিময় প্রদান করুন।”</span> এটি তিরমিযী বর্ণনা করেছেন। </p>',
            ],
            32 => [
                'question' => 'প্রশ্ন ৩৩: যানবাহন থেকে নামার সময়ে কী দু‘আ পড়তে হয়?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15740.mp3',
                'answer' => '<p> উত্তর: <span class="c1">“বিসমিল্লাহ।”</span> এটি আবূ দাঊদ বর্ণনা করেছেন। </p>',
            ],
            33 => [
                'question' => 'প্রশ্ন ৩৪: কোন আনন্দদায়ক বস্তু অর্জিত হলে তুমি কী বলবে?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15770.mp3',
                'answer' => '<p> উত্তর: الحمد لله الذي بنعمته تتم الصالحات <span class="c1">“সকল প্রশংসা আল্লাহর জন্যে, যাঁর অনুগ্রহে ভালো কাজসমূহ পূর্ণতা লাভ করে।”</span> হাকিম ও অন্যান্য মুহাদ্দিসগণ এটি বর্ণনা করেছেন। </p>',
            ],
            34 => [
                'question' => 'প্রশ্ন ৩৫: তোমার কাছে অপছন্দনীয় এমন কিছুর সম্মুখীন হলে তুমি কী বলবে?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15800.mp3',
                'answer' => '<p> الحمد لله على كل حال <span class="c1">“সর্বাবস্থায় আল্লাহর জন্য সকল প্রশংসা।”</span> সহীহুল জামি‘। </p>',
            ],
            35 => [
                'question' => 'প্রশ্ন ৩৬: সালাম দেওয়া এবং এর উত্তরের পদ্ধতি কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15830.mp3',
                'answer' => '<p> উত্তর: মুসলিম ব্যক্তি বলবে: السَّلَامُ عَلَيْكُمْ وَرَحْمَةُ اللَّهِ وَبَرَكَاتُهُ <span class="c1">“আপনার উপরে আল্লাহর পক্ষ থেকে শান্তি, রহমত ও তাঁর বরকত নাযিল হোক।”</span><br /> তার জবাবে তার ভাই বলবে: وَعَلَيْكُمُ السَّلَامُ وَرَحْمَةُ اللهِ وَبَرَكَاتُهُ <span class="c1">“আপনার উপরেও আল্লাহর পক্ষ থেকে শান্তি, রহমত ও তাঁর বরকত নাযিল হোক।”</span> এটি তিরমিযী, আবূ দাউদ ও অন্যান্যরা বর্ণনা করেছেন। </p>',
            ],
            36 => [
                'question' => 'প্রশ্ন ৩৭: বৃষ্টি পড়ার সময় কোন দু‘আ পড়তে হয়?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15870.mp3',
                'answer' => '<p> উত্তর: اللهم صيباً نافعاً <span class="c1">“হে আল্লাহ, আমাদেরকে উপকারী মুষলধারে প্রবাহমান বৃষ্টি দান করুন।”</span> সহীহ বুখারী। </p>',
            ],
            37 => [
                'question' => 'প্রশ্ন ৩৮: বৃষ্টির শেষে কোন দু‘আ পড়তে হয়?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15900.mp3',
                'answer' => '<p> উত্তর: مطرنا بفضل الله ورحمته <span class="c1">“আল্লাহর অনুগ্রহে এবং রহমতে আমাদেরকে বৃষ্টি দেওয়া হয়েছে।”</span> সহীহ বুখারী ও মুসলিম। </p>',
            ],
            38 => [
                'question' => 'প্রশ্ন ৩৯: বাতাসের (প্রবাহিত হওয়ার) দু‘আ উল্লেখ কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15930.mp3',
                'answer' => '<p> উত্তর: اللهم إني أسألك خيرها وأعوذ بك من شرها <span class="c1">“হে আল্লাহ আমি আপনার কাছে এর কল্যাণসমূহ প্রার্থনা করছি এবং অকল্যাণ থেকে আপনার কাছে আশ্রয় চাচ্ছি।”</span> এটি আবু দাউদ ও ইবন মাজাহ বর্ণনা করেছেন। </p>',
            ],
            39 => [
                'question' => 'প্রশ্ন ৪০: বজ্রধ্বনির সময়ের দু‘আ উল্লেখ কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15960.mp3',
                'answer' => '<p> উত্তর: سبحان الذي يسبح الرعد بحمده والملائكة من خيفته <span class="c1">“আর রা\'দ <span class="c2">(বজ্রধ্বনি)</span> তাঁর সপ্রশংস মহিমা ও পবিত্রতা ঘোষণা করে এবং ফেরেশতাগণও সেটাই করে তার ভয়ে।”</span> মু’য়াত্তা মালিক। </p>',
            ],
            40 => [
                'question' => 'প্রশ্ন ৪১: কোন কষ্টে নিপতিত ব্যক্তিকে দেখলে কী দু‘আ পড়তে হয়?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15990.mp3',
                'answer' => '<p> উত্তর: الحمد لله الذي عافاني مما ابتلاك به، وفضلني على كثيراً ممن خلق تفضيلاً <span class="c1">“সকল প্রশংসা আল্লাহর জন্যই। যিনি আপনাকে যা দ্বারা পরীক্ষা করেছেন তা থেকে মুক্ত রেখেছেন। আর তিনি যা সৃষ্টি করেছেন, তাদের অধিকাংশ থেকে আমাকে মর্যাদাবান করেছেন।”</span> এটি তিরমিযী বর্ণনা করেছেন। </p>',
            ],
            41 => [
                'question' => 'প্রশ্ন ৪২: যদি কোন ব্যক্তি আশঙ্কা করে যে, কারো উপরে তার নজর লাগতে পারে, তাহলে সে কী দু‘আ পড়বে?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16020.mp3',
                'answer' => '<p> উত্তর: হাদীসে এসেছে: إذا رأى أحدكم من أخيه أو من نفسه، أو من ماله ما يعجبه، <span class="c5">[فليدع له بالبركة]</span> فإن العين حق <span class="c1">“তোমাদের কেউ যখন তার ভাইয়ের কাছে, অথবা নিজের কাছে অথবা তার সম্পদে এমন কিছু দেখতে পায়, যা তার কাছে পছন্দনীয় হয় <span class="c5">[সে যেন তার জন্য বরকতের দু‘আ করে]</span>, কেননা নজর লাগা সত্য।”</span> এটি আহমাদ, ইবন মাজাহ ও অন্যান্যরা বর্ণনা করেছেন। </p>',
            ],
            42 => [
                'question' => 'প্রশ্ন ৪৩: নবী সাল্লাল্লাহু আলাইহি ওয়াসাল্লামের উপরে তুমি কীভাবে দরুদ পাঠ করবে?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16050.mp3',
                'answer' => '<p> اللَّهُمَّ صَلِّ عَلَى مُحَمَّدٍ وَعَلَى آلِ مُحَمَّدٍ، كَمَا صَلَّيْتَ عَلَى إِبْرَاهِيمَ، وَعَلَى آلِ إِبْرَاهِيمَ، إِنَّكَ حَمِيدٌ مَجِيدٌ، اللَّهُمَّ بَارِكْ عَلَى مُحَمَّدٍ وَعَلَى آلِ مُحَمَّدٍ، كَمَا بَارَكْتَ عَلَى إِبْرَاهِيمَ، وَعَلَى آلِ إِبْرَاهِيمَ إِنَّكَ حَمِيدٌ مَجِيدٌ <span class="c1">“হে আল্লাহ! আপনি মুহাম্মাদের উপর এবং মুহাম্মাদের বংশধরদের উপর রহমত বর্ষণ করুন, যেরূপ আপনি ইবরাহীম ও ইবরাহীমের বংশধরদের উপর রহমত বর্ষণ করেছেন। নিশ্চয়ই আপনি অতি প্রশংসিত, অত্যন্ত মর্যাদার অধিকারী। হে আল্লাহ! আপনি মুহাম্মাদের উপর এবং মুহাম্মাদের বংশধরদের উপর বরকত বর্ষণ করুন, যেরূপ আপনি ইবরাহীম ও ইবরাহীমের বংশধরদের উপর বরকত বর্ষণ করেছেন। নিশ্চয়ই আপনি অতি প্রশংসিত, অত্যন্ত মর্যাদার অধিকারী।”</span> মুত্তাফাকুন ‘আলাইহি। </p>',
            ],
        ],
        9 => [
            0 => [
                'question' => 'প্রশ্ন ০১: শরীয়ত প্রদত্ত পাঁচ ধরণের হুকুমসমূহ কী কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16090.mp3',
                'answer' => '<p> উত্তর:<br /> ০১- ফরয।<br /> ০২- মুস্তাহাব।<br /> ০৩- হারাম।<br /> ০৪- মাকরূহ।<br /> ০৫- মুবাহ। </p>',
            ],
            1 => [
                'question' => 'প্রশ্ন ০২: এ পাঁচ ধরণের হুকুমের ব্যাখ্যা কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16170.mp3',
                'answer' => '<p> উত্তর:<br /> ০১-<span class="c6"> ফরয:</span> যেমন: পাঁচ ওয়াক্ত সালাত, রমাদানের সিয়াম পালন এবং পিতামাতার সাথে উত্তম আচরণ করা।<br /> - ফরয পালনকারীকে সাওয়াব দেওয়া হবে এবং পরিত্যাগকারীকে শাস্তি দেওয়া হবে।<br /> -<span class="c6"> মুস্তাহাব:</span> যেমন পাঁচ ওয়াক্ত ফরয সালাতের আগের ও পরের সুন্নাতসমূহ, কিয়ামুল্লাইল, খাবার খাওয়ানো,<span class="c6"> সালাম দেওয়া। এর অন্য নাম:</span> সুন্নাত এবং মানদূব।<br /> -<span class="c6"> মুস্তাহাব পালনকারী সাওয়াবপ্রাপ্ত হবে; তবে পরিত্যাগকারীকে শাস্তি দেওয়া হবে না।<br /> গুরুত্বপূর্ণ একটি নির্দেশনা:</span><br /> মুসলিমের জন্য কর্তব্য হচ্ছে, যখনই সে শুনবে যে, এ কাজটি সুন্নাত অথবা মুস্তাহাব, তখনই সে পালনের চেষ্টা করবে এবং নবী সাল্লাল্লাহু আলাইহি ওয়াসাল্লামকে অনুসরণ করবে।<br /> ০৩-<span class="c6"> হারাম:</span> যেমন: মদ পান করা, পিতা-মাতার অবাধ্য হওয়া এবং আত্মীয়তার সম্পর্ক ছিন্ন করা।<br /> - এর পরিত্যাগকারী সাওয়াব পাবে, আর তা সম্পাদনকারীকে শাস্তি দেওয়া হবে।<br /> ৪-<span class="c6"> মাকরূহ:</span> যেমন বাম হাত দিয়ে কোন কিছু ধরা অথবা প্রদান করা। সালাতের মধ্যে কাপড় গুটিয়ে রাখা।<br /> - মাকরূহ সম্পাদনকারীকে শাস্তি দেওয়া হবে না, তবে তা পরিত্যাগকারীকে সাওয়াব দেওয়া হবে।<br /> ৫-<span class="c6"> মুবাহ:</span> যেমন: চা পান করা এবং আপেল খাওয়া। একে জায়িয এবং হালাল বলে।<br /> - মুবাহ সম্পাদনকারীকে শাস্তি দেওয়া হবে না, আবার তা পরিত্যাগকারীকে সাওয়াবও দেওয়া হবে না। </p>',
            ],
            2 => [
                'question' => 'প্রশ্ন ০৩: ক্রয়-বিক্রয় ও মু‘আমালাতের হুকুম কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16320.mp3',
                'answer' => '<p> উত্তর: ক্রয়-বিক্রয় এবং মু‘আমালাতের ক্ষেত্রে মূলনীতি হচ্ছে,<span class="c6"> তা হালাল হওয়া; তবে আল্লাহ কর্তৃক হারামকৃত কতিপয় প্রকার ছাড়া।<br /> আল্লাহ তা‘আলা বলেছেন:</span> وَأَحَلَّ اللَّهُ الْبَيْعَ وَحَرَّمَ ٱلرِّبَوٰاۚ <span class="c1">“আল্লাহ ব্যবসাকে হালাল এবং সূদকে হারাম করেছেন।”</span> <span class="c5">[সূরা আল-<span class="c6">বাকারাহ:</span> ২৭৫]</span> </p>',
            ],
            3 => [
                'question' => 'প্রশ্ন ৪: কতিপয় হারাম ক্রয়-বিক্রয় ও মু‘আমালাতের কথা উল্লেখ কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16360.mp3',
                'answer' => '<p> উত্তর:<br /> ০১- ধোঁকা,<span class="c6"> যার মধ্যে রয়েছে:</span> পণ্যের ত্রুটি গোপন করা।<br /> আবু হুরাইরাহ রদিয়াল্লাহু আনহু হতে বর্ণিত,<span class="c6"> রাসূলুল্লাহ সাল্লাল্লাহু আলাইহি ওয়াসাল্লাম একদিন একটি খাদ্য শস্যের স্তুপের পাশ দিয়ে পথ অতিক্রম করলেন। তিনি স্তুপের ভেতর হাত প্রবেশ করালে তার হাতের আঙ্গুলগুলো ভিজে গেল। তিনি বললেন:</span> হে স্তুপের মালিক! এ কি ব্যাপার? লোকটি বলল: হে আল্লাহর রাসূল! এতে বৃষ্টির পানি লেগেছে। তিনি বললেন: <span class="c3">«أفلا جعلته فوق الطَّعام كي يراه النَّاس؟ من غشَّ فليس منِّي»</span> <span class="c1">“সেগুলো তুমি স্তুপের ওপরে রাখলে না কেন? তাহলে লোকেরা দেখে নিতো। জেনে রাখো, যে ব্যক্তি ধোকাবাজি করে, আমার সাথে তার কোন সম্পর্ক নেই।”</span> এটি মুসলিম বর্ণনা করেছেন।<br /> ০২-<span class="c6"> সূদ:</span> এর মধ্যে অন্যতম হচ্ছে- আমি কোন ব্যক্তির কাছ থেকে একহাজার <span class="c2">(টাকা-পয়সা)</span> ঋণ গ্রহণ করব এ শর্তের ভিত্তিতে যে, আমি তাকে দুইহাজার ফেরত দেব।<br /> এই বর্ধিত অংশই হারামকৃত সূদ।<br /> আল্লাহ তা‘আলা বলেন, وَأَحَلَّ اللَّهُ الْبَيْعَ وَحَرَّمَ ٱلرِّبَوٰاۚ <span class="c1">“আল্লাহ ব্যবসাকে হালাল এবং সূদকে হারাম করেছেন।”</span> <span class="c5">[সূরা আল-<span class="c6">বাকারাহ:</span> ২৭৫]</span><br /> ০৩- প্রতারণা বা অজ্ঞতা <span class="c2">(সহকারে বিক্রয়)</span>: যেমন: ওলানে থাকা অবস্থায় দুধ বিক্রয় করা অথবা মাছ না ধরে পানিতে বিক্রয় করা।<br /> হাদীসের মধ্যে রয়েছে: نهى رسول الله ﷺ عن بيع الغرر <span class="c1">“আল্লাহর রাসূল সাল্লাল্লাহু আলাইহি ওয়া সাল্লাম প্রতারণামূলক ক্রয়-বিক্রয় হতে নিষেধ করেছেন।”</span> এটি মুসলিম বর্ণনা করেছেন। </p>',
            ],
            4 => [
                'question' => 'প্রশ্ন ০৫: তোমার উপরে বিদ্যমান আল্লাহর কতিপয় নি‘আমাত উল্লেখ কর।',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16460.mp3',
                'answer' => '<p> উত্তর: ০১- ইসলামের নি‘আমাত। আর তা হচ্ছে- তুমি কাফিরদের অন্তর্ভুক্ত নও।<br /> ০২- সুন্নাহর নি‘আমাত,<span class="c6"> তা হচ্ছে:</span> তুমি বিদ‘আতীদের অন্তর্ভুক্ত নও।<br /> ০৩- সুস্থতার ও নিরাপত্তার নি‘আমাত,<span class="c6"> যেমন:</span> শ্রবণশক্তি, দৃষ্টিশক্তি, হাঁটাচলা করার ক্ষমতা সহ আরো অন্যান্য নি‘আমাতসমূহ।<br /> ০৪- খাদ্য, পানীয় এবং পোষাকের নি‘আমাত।<br /> আল্লাহর নি‘আমাত আমাদের উপরে এত বেশী যে,<span class="c6"> তা গণনা করা সম্ভব নয়।<br /> আল্লাহ তা‘আলা বলেছেন:</span> وإن تَعُدُّوا نِعۡمَةَ ٱللَّهِ لَا تُحۡصُوهَاۗ إِنَّ ٱللَّهَ لَغَفُورٌ رَحِيمٌ <span class="c1">“আর তোমরা আল্লাহ্র অনুগ্রহ গুণলে তার সংখ্যা নির্ণয় করতে পারবে না। নিশ্চয় আল্লাহ্ ক্ষমাপরায়ণ, পরম দয়ালু।”</span> <span class="c5">[সূরা আন-<span class="c6">নাহল:</span> ১৮]</span> </p>',
            ],
            5 => [
                'question' => 'প্রশ্ন ০৬: নি‘আমাতের ক্ষেত্রে কর্তব্য কী? আর তুমি কীভাবে তার শুকরিয়া আদায় করবে?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16540.mp3',
                'answer' => '<p> উত্তর: কর্তব্য: শুকরিয়া আদায় করা, তা হবে- আল্লাহর প্রশংসা ও মুখে তাঁর গুণগান করা দ্বারা, এসব অনুগ্রহ শুধুমাত্র আল্লাহর একক দান। এবং এসব নি‘আমাতকে আল্লাহ যে পন্থায় খুশি হন, সে পন্থায় ব্যবহার করা, তাঁর অবাধ্যতায় ব্যবহার না করা। </p>',
            ],
            6 => [
                'question' => 'প্রশ্ন ০৭: মুসলিমদের ঈদগুলো কী কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16570.mp3',
                'answer' => '<p> উত্তর: ঈদুল ফিত্বর এবং ঈদুল আদ্বহা।<br /> -<span class="c6"> যেমনটি আনাস রদিয়াল্লাহু আনহুর হাদীসের মধ্যে এসেছে:</span> قَدِمَ رَسُولُ اللَّهِ ﷺ الْمَدِينَةَ وَلَهُمْ يَوْمَانِ يَلْعَبُونَ فِيهِمَا،<span class="c6"> فَقَالَ:</span> <span class="c3">«مَا هَذَانِ الْيَوْمَانِ؟»</span>،<span class="c6"> قَالُوا:</span> كُنَّا نَلْعَبُ فِيهِمَا فِي الْجَاهِلِيَّةِ،<span class="c6"> فَقَالَ رَسُولُ اللَّهِ ﷺ :</span> রাসূলুল্লাহ সাল্লাল্লাহু আলাইহি ওয়াসাল্লাম মদীনাতে এসে দেখলেন যে, তাদের দুটি দিন রয়েছে,<span class="c6"> যেদিন তারা খেলাধুলা করে। তিনি জিজ্ঞেস করলেন:</span> এ দুটি দিন কিসের? তারা বলল: জাহিলী যুগে আমরা এদিনগুলোতে খেলাধুলা করতাম। তখন রাসূলুল্লাহ সাল্লাল্লাহু আলাইহি ওয়াসাল্লাম বললেন: إِنَّ اللَّهَ قَدْ أَبْدَلَكُمْ بِهِمَا خَيْرًا مِنْهُمَا: يَوْمَ الْأَضْحَى، وَيَوْمَ الْفِطْرِ <span class="c1">“আল্লাহ তোমাদের এ দুটি দিনের পরিবর্তে উত্তম দুটি দিন নির্দিষ্ট করেছেন। তা হলো, ঈদুল আদ্বহা এবংঈদুল ফিত্বরের দিন।”</span> এটি বর্ণনা করেছেন আবূ দাঊদ।<br /> এ দুটি দিন ছাড়া অন্যান্য সকল ঈদ বিদ‘আত বলে গণ্য হবে। </p>',
            ],
            7 => [
                'question' => 'প্রশ্ন ০৮: সবচেয়ে উত্তম মাস কোনটি?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16620.mp3',
                'answer' => '<p> উত্তর: রমাদান মাস। </p>',
            ],
            8 => [
                'question' => 'প্রশ্ন ০৯: সবচেয়ে উত্তম দিন কোনটি?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16650.mp3',
                'answer' => '<p> উত্তর: জুমু‘আর দিন। </p>',
            ],
            9 => [
                'question' => 'প্রশ্ন ১০: বছরের সবচেয়ে উত্তম দিন কোনটি?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16680.mp3',
                'answer' => '<p> উত্তর: ‘আরাফার দিন। </p>',
            ],
            10 => [
                'question' => 'প্রশ্ন ১১: বছরের সবচেয়ে উত্তম রাত কোনটি?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16710.mp3',
                'answer' => '<p> উত্তর: লাইলাতুল কদর। </p>',
            ],
            11 => [
                'question' => 'প্রশ্ন ১২: কোন অপরিচিত নারী দেখলে তোমার কর্তব্য কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16740.mp3',
                'answer' => '<p> উত্তর: চোখ অবনমিত রাখা। আল্লাহ তা‘আলা বলেছেন: قُلْ لِلْمُؤْمِنِينَ يَغُضُّوا مِنْ أَبْصَارِهِمْ <span class="c1">“মুমিন পুরুষদেরকে বল, তারা তাদের দৃষ্টিকে সংযত রাখবে।”</span> <span class="c5">[সূরা আন-<span class="c6">নূর:</span> ৩০]</span> </p>',
            ],
            12 => [
                'question' => 'প্রশ্ন ১৩: মানুষের শত্রু কারা?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16770.mp3',
                'answer' => '<p> ০১-<span class="c6"> অন্যায়কাজের আদেশ দানকারী নফস:</span> আর এটি হচ্ছে- মানুষের মন ও প্রবৃত্তি যা চায়,<span class="c6"> আল্লাহর অবাধ্যতায় সেগুলোর অনুসরণ করা। আল্লাহ তা‘আলা বলেছেন:</span> إِنَّ ٱلنَّفۡسَ لَأَمَّارَةُۢ بِٱلسُّوۤءِ إِلَّا مَا رَحِمَ رَبِّيۚ إِنَّ رَبِّي غَفُورٌ رَّحِيمٌ <span class="c1">“নিশ্চয় মানুষের নাফস খারাপ কাজের নির্দেশ দিয়েই থাকে, কিন্তু সে নয়, যার প্রতি আমার রব দয়া করেন।”</span> <span class="c5">[সূরা ইউসুফ: ৫৩]</span> ০২-<span class="c6"> শয়তান:</span> সে হচ্ছে বনী আদামের শত্রু। তার উদ্দেশ্যই হচ্ছে মানুষকে পথভ্রষ্ট করা,<span class="c6"> তাকে অন্যায় কাজের কুমন্ত্রণা দেওয়া এবং তাকে আগুনে প্রবেশ করানো। আল্লাহ তা‘আলা বলেছেন:</span> وَلَا تَتَّبِعُوا خُطُوَ ٰ⁠تِ ٱلشَّيطَـٰنِۚ إِنَّهُۥ لَكُمۡ عَدُوٌّ مُّبِينٌ <span class="c1">“আর তোমরা শয়তানের পদাংক অনুসরণ করবে না। নিশ্চয় সে তোমাদের প্রকাশ্য শত্রু।”</span> <span class="c5">[সূরা আল-<span class="c6">বাকারাহ:</span> ১৬৮]</span> ০৩-<span class="c6"> খারাব সাথী:</span> যারা তাদেরকে মন্দকাজে উৎসাহিত করে এবং কল্যাণের পথে বাধা দেয়। আল্লাহ তা‘আলা বলেছেন: الْأَخِلَّاءُ يَوْمَئِذٍ بَعْضُهُمْ لِبَعْضٍ عَدُوٌّ إِلَّا الْمُتَّقِينَ <span class="c1">“বন্ধুরা সেদিন হয়ে পড়বে একে অন্যের শত্ৰু, মুত্তাকীরা ছাড়া।”</span> <span class="c5">[সূরা আয-<span class="c6">যুখরুফ:</span> ৬৭]</span> </p>',
            ],
            13 => [
                'question' => 'প্রশ্ন ১৪: তাওবাহ কাকে বলে?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16820.mp3',
                'answer' => '<p> উত্তর: তাওবাহ: আল্লাহর অবাধ্যতা থেকে তাঁর আনুগত্যের দিকে ফিরে আসা। আল্লাহ তা‘আলা বলেছেন: وَإِنِّي لَغَفَّارٌ لِّمَن تَابَ وَءَامَنَ وَعَمِلَ صَـٰلِحًا ثُمَّ ٱهۡتَدَىٰ <span class="c1">“আর অবশ্যই আমি তার প্রতি অতিশয় ক্ষমাশীল, যে তাওবা করে, ঈমান আনে এবং সৎকর্ম করে অতঃপর সৎ পথে চলতে থাকে।”</span> <span class="c5">[সূরা ত্ব-<span class="c6">হা:</span> ৮২]</span> </p>',
            ],
            14 => [
                'question' => 'প্রশ্ন ১৫: বিশুদ্ধ তাওবার শর্ত কী কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16850.mp3',
                'answer' => '<p> উত্তর: ০১- পাপ থেকে ফিরে থাকা।<br /> ০২- অনুতপ্ত হওয়া।<br /> ০৩- পুনরায় না করার উপরে দৃঢ় প্রতিজ্ঞা করা।<br /> ০৪- অধিকার এবং অন্যায়ভাবে গৃহীত সম্পত্তি তার হকদারের কাছে ফিরিয়ে দেওয়া।<br /> আল্লাহ তা‘আলা বলেন, وَٱلَّذِينَ إِذَا فَعَلُوا فَـٰحِشَةً أَوۡ ظَلَمُوۤا أَنفُسَهُمۡ ذَكَرُوا ٱللَّهَ فَٱسۡتَغۡفَرُوا لِذُنُوبِهِمۡ وَمَن يَغۡفِرُ ٱلذُّنُوبَ إِلَّا ٱللَّهُ وَلَمۡ يصِرُّوا عَلَىٰ مَا فَعَلُوا وَهُمۡ يَعۡلَمُونَ <span class="c1">“আর যারা কোন অশ্লীল কাজ করে ফেললে বা নিজেদের প্রতি যুলুম করলে আল্লাহকে স্মরণ করে এবং নিজেদের পাপের জন্য ক্ষমা প্রার্থনা করে। আল্লাহ ছাড়া আর কে পাপ ক্ষমা করবে? এবং তারা যা করে ফেলে, জেনে-বুঝে তারা তা পুনরায় করতে থাকে না।”</span> <span class="c5">[সূরা আলে-ইমরান,<span class="c6"> আয়াত:</span> ১৩৫]</span> </p>',
            ],
            15 => [
                'question' => 'প্রশ্ন ১৬: নবী সাল্লাল্লাহু আলাইহি ওয়াসাল্লামের উপরে দরুদ পাঠ করার অর্থ কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16920.mp3',
                'answer' => '<p> উত্তর: এর অর্থ হচ্ছে: তুমি আল্লাহর কাছে দু‘আ করবে যে, তিনি যেন তাঁর ফেরেশতাদের কাছে নবী সাল্লাল্লাহু আলাইহি ওয়াসাল্লামের প্রশংসা করেন। </p>',
            ],
            16 => [
                'question' => 'প্রশ্ন ১৭: سبحان الله (সুবহানাল্লাহ) শব্দের অর্থ কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16950.mp3',
                'answer' => '<p> উত্তর: তাসবীহ <span class="c2">(করা)</span>,<span class="c6"> আর তা হচ্ছে:</span> আল্লাহ সুবহানাহু ওয়া তা‘আলাকে সকল ধরণের মন্দ, দোষ-ত্রুটি ও মর্যাদা ক্ষুণ্ণকারী বিষয় থেকে মুক্ত ঘোষণা করা। </p>',
            ],
            17 => [
                'question' => 'প্রশ্ন ১৮: الحمد لله (আল-হামদুলিল্লাহ) শব্দের অর্থ কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16980.mp3',
                'answer' => '<p> উত্তর: আল্লাহ তা‘আলার প্রশংসা করা। আর তাঁকে সব ধরণের পূর্ণতার গুণে গুণান্বিত করা। </p>',
            ],
            18 => [
                'question' => 'প্রশ্ন ১৯: الله أكبر (আল্লাহু আকবার) শব্দের অর্থ কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/17000.mp3',
                'answer' => '<p> উত্তর: আল্লাহ সুবহানাহু ওয়া তা‘আলা সকল বস্তু থেকে বড়, মর্যাদাবান, সম্মানিত এবং সবচেয়ে বেশী ইজ্জতওয়ালা। </p>',
            ],
            19 => [
                'question' => 'প্রশ্ন ২০: لا حول ولا قوة الا بالله (লা হাউলা ওয়ালা কুওয়াতা ইল্লা- বিল্লাহ) এর অর্থ কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/17030.mp3',
                'answer' => '<p> উত্তর: এর অর্থ: আল্লাহর ক্ষমতা ছাড়া বান্দার এক অবস্থা থেকে অন্য অবস্থায় যাওয়ার কোন উপায় নেই এবং কোন শক্তিও নেই। </p>',
            ],
            20 => [
                'question' => 'প্রশ্ন ১৭: أستغفر الله (আস্তাগফিরুল্লাহ) শব্দের অর্থ কী?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/17060.mp3',
                'answer' => '<p> উত্তর: আল্লাহর কাছে বান্দার গোনাহ মাফ ও তার নিজের দোষ-ত্রুটি গোপন রাখার আবেদন করা। </p>',
            ],
        ],
    ],
];
