<?php
$data = [
    'title' => 'What Muslim Children Must Know',
    'description' => 'A project that contains a simple and easy curriculum for issues that a Muslim must know. It includes issues of belief, jurisprudence, prophetic biography, etiquette, tafsir, hadith, morals, and remembrance of Allah. It is suitable for young children in particular, for all ages, and newcomers to Islam.',
    'source' => 'https://kids.islamenc.com/bs/home',
    'author' => 'Yazan Abdul Razzaq Raziq Alghanim',
    'sections' => [
        0 => 'Oblast islamskog vjerovanja (akida)',
        1 => 'Oblast islamskog prava (fikh)',
        2 => 'Oblast sire (životopisa) Poslanika, sallallahu alejhi ve sellem',
        3 => 'Oblast tumačenja Kur\'ana (tefsir)',
        4 => 'Oblast hadisa',
        5 => 'Oblast o islamskom ponašanju (odnosu prema drugima)',
        6 => 'Oblast lijepog ponašanja (ahlaka)',
        7 => 'Oblast o dovama i zikrovima',
        8 => 'Razno',
    ],
    'data' => [
        1 => [
            0 => [
                'question' => 'Pitanje br. 1: Ko je tvoj Gospodar?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/200.mp3',
                'answer' => '<p> Odgovor: Moje Gospodar je Allah, Onaj koji se brine o meni i o svim stvorenjima i koji nas blagodatima obasipa.<span class="c6"><br /> Dokaz ovome su riječi Uzvišenog Allaha koji kaže:</span> "Hvala Allahu, Gospodaru svjetova." <span class="c2">(El-Fatiha, 2)</span>. </p>',
            ],
            1 => [
                'question' => 'Pitanje br. 2: Koja je tvoja vjera?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/240.mp3',
                'answer' => '<p> Odgovor: Moja vjera je islam koji označava predanost Allahu kroz iskazivanje Njegove jednoće, pokornost Njemu u onome što nam je propisao i odricanje od širka <span class="c2">(mnogoboštva)</span> i njegovih zagovornika.<span class="c6"><br /> Uzvišeni Allah veli:</span> "Allahu je prava vjera jedino – islam." <span class="c2">(Ali \'Imran, 19)</span>. </p>',
            ],
            2 => [
                'question' => 'Pitanje br. 3: Ko je tvoj vjerovjesnik?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/280.mp3',
                'answer' => '<p> Odgovor: Muhammed, sallallahu alejhi ve sellem.<span class="c6"><br /> Kaže Uzvišeni Allah:</span> "Muhammed je Allahov poslanik..." <span class="c2">(El-Feth, 29)</span>. </p>',
            ],
            3 => [
                'question' => 'Pitanje br. 4: Kako glase riječi kojima se iskazuje Allahova jednoća i šta je značenje tih riječi?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/310.mp3',
                'answer' => '<p> Odgovor: Te riječi glase: <span class="c2">(La ilahe illellah)</span>,<span class="c6"> a njihovo značenje je:</span> Nema istinskog božanstva koje zaslužuje obožavanje osim Allaha Uzvišenog.<span class="c6"><br /> Uzvišeni Allah kaže:</span> "Znaj da nema istinskog boga osim Allaha." <span class="c2">(Muhammed, 19)</span>. </p>',
            ],
            4 => [
                'question' => 'Pitanje br. 5: Gdje je Allah Uzvišeni?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/350.mp3',
                'answer' => '<p> Odgovor: Allah je iznad nebesa, iznad Arša, iznad svih stvorenja.<span class="c6"> U vezi sa tim On je kazao:</span> "Svemilosni, Koji se nad Aršom uzvisio." <span class="c2">(Tā hā, 5)</span>.<span class="c6"> Na drugom mjestu kaže Allah:</span> "A On je iznad robova Svojih, Svepotčinitelj, i On je Mudri, Onaj Koji sve u potpunosti zna" <span class="c2">(El-En\'am, 18)</span>. </p>',
            ],
            5 => [
                'question' => 'Pitanje br. 6: Koje je značenje riječi da je Muhammed Allahov poslanik?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/380.mp3',
                'answer' => '<p> Odgovor: To znači da ga je Uzvišeni Allah poslao svim svjetovima, da donosi radosne vijesti i da upozorava <span class="c2">(na Allahovu kaznu)</span>.<br /> U pogledu toga,<span class="c6"> ljudima je obaveza sljedeće:</span><br /> 1- Pokornost u onome što je naredio.<br /> 2. Vjerovanje u ono što nam je prenio i o čemu nas je obavijestio.<br /> 3. Ostavljanje neposlušnosti prema njemu.<br /> 4. Allaha obožavati samo onako kako je on pojasnio, što znači da slijedimo njegov sunnet i da se klonimo novotarija u pogledu vjere i vjerskih propisa.<span class="c6"><br /> Allah Uzvišeni je rekao:</span> "Onaj ko se pokorava Poslaniku pokorava se i Allahu." <span class="c2">(En-Nisa, 80)</span>.<span class="c6"> Na drugom mjestu stoji:</span> "On ne govori po hiru svome - to je samo Objava koja mu se obznanjuje." <span class="c2">(En-Nedžm, 3-4)</span>. Također,<span class="c6"> kaže Uzvišeni:</span> "Vi u Allahovom Poslaniku imate divan uzor za onoga koji se nada Allahovoj milosti i nagradi na onome svijetu, i koji često Allaha spominje." <span class="c2">(El-Ahzab, 21)</span>. </p>',
            ],
            6 => [
                'question' => 'Pitanje br. 7: Zbog čega nas je Allah stvorio?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/480.mp3',
                'answer' => '<p> Odgovor: Allah nas je stvorio kako bismo samo Njega jedinog, koji nema sudruga, obožavali.<br /> Nije nas stvorio kako bismo se igrali i zabavljali.<span class="c6"><br /> Uzvišeni Allah veli:</span> "Nisam stvorio ni džinne ni ljude osim da samo Mene obožavaju." <span class="c2">(Ez-Zarijat, 56)</span>. </p>',
            ],
            7 => [
                'question' => 'Pitanje br. 8: Šta je ibadet?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/530.mp3',
                'answer' => '<p> Odgovor: Ibadet je sveobuhvatni naziv za sve ono što Allah voli i čime je zadovoljan, bilo da se radi o riječima ili djelima, skrivenim ili vidljivim.<span class="c6"><br /> Primjer vidljivih ibadeta:</span> spominjanje Allaha putem tesbiha <span class="c2">(slavljenje)</span>, tahmida <span class="c2">(zahvale Allahu)</span>, donošenja tekbira, namaza, hadža i tako dalje.<span class="c6"><br /> Primjer skrivenih ibadeta:</span> oslonac na Allaha, strah, nada i slično tome. </p>',
            ],
            8 => [
                'question' => 'Pitanje br. 9: Koja je naša najveća obaveza?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/580.mp3',
                'answer' => '<p> Odgovor: Naša najveća obaveza je iskazivanje jednoće Uzvišenog Allaha. </p>',
            ],
            9 => [
                'question' => 'Pitanje br. 10: Koje su vrste tevhida (iskazivanja Allahove jednoće)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/610.mp3',
                'answer' => '<p> Odgovor:<br /> 1- Tevhīdur-rubūbijje-potvrđivanje jednoće u stvaranju, što označava da vjerujemo da je Allah Tvorac, Opskrbitelj, Vladar, Upravitelj, Jedan jedini Koji nema sudruga.<br /> 2- Tevhīdul-ulūhijje-potvrđivanje jednoće u Božanstvenosti, tj. izdvajanje Allaha u obožavanju, iz čega proističe da se niko osim Njega ne smije obožavati.<br /> 3- Tevhidul-esmai ves-sifat-vjerovanje u Allahova imena i svojstva koja su nam prenesena u Kur\'anu i sunnetu, bez poistovjećivanja i poređenja, te bez shvatanja da je Allah lišen svojstava.<span class="c6"><br /> Uporište za ovu podjelu nalazimo u ajetu:</span> "On je Gospodar nebesa i Zemlje i onoga što je između njih, zato samo Njega obožavaj i u tome budi istrajan! Znaš li da ime Njegovo ima iko?" <span class="c2">(Merjem, 65)</span>. </p>',
            ],
            10 => [
                'question' => 'Pitanje br. 11: Koji je najveći grijeh?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/670.mp3',
                'answer' => '<p> Odgovor: Najveći grijeh je širk <span class="c2">(pripisivanje sudruga)</span> Allahu.<span class="c6"><br /> Uzvišeni Allah veli:</span> "Allah neće oprostiti da Mu se neko drugi smatra ravnim, a oprostiće manje grijehove od toga kome On hoće. A onaj ko drugog smatra Allahu ravnim čini, izmišljajući laž, grijeh veliki." <span class="c2">(En-Nisa, 48)</span>. </p>',
            ],
            11 => [
                'question' => 'Pitanje br. 12: Šta je to širk i koje su njegove vrste?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/710.mp3',
                'answer' => '<p> Odgovor: Širk je usmjeravanje nekog ibadeta nekome drugome mimo Allahu.<span class="c6"><br /> Vrste širka:</span><br /> Veliki širk: <br /> Primjeri: dozivanje nekoga mimo Allaha, sedžda nekome mimo Njega, prinošenje žrtve radi nekog drugog mimo Njega.<br /> Mali širk,<span class="c6"> kao što je:</span> zaklinjanje nečim mimo Allaha, nošenje hamajlija s ciljem pribavljanja koristi i uklanjanja štete, pretvaranje u manjem omjeru,<span class="c6"> kao na primjer:</span> uljepšavanje namaza da bi nas neko vidio kako lijepo klanjamo i tako dalje. </p>',
            ],
            12 => [
                'question' => 'Pitanje br. 13: Da li iko mimo Allaha poznaje gajb (nevidljivi svijet)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/770.mp3',
                'answer' => '<p> Odgovor: Niko mimo Allaha ne poznaje gajb.<span class="c6"><br /> Uzvišeni Allah veli:</span> "Reci: \'Niko, osim Allaha, ni na nebu ni na Zemlji, ne zna što će se dogoditi; i oni ne znaju kada će oživljeni biti.\'" <span class="c2">(En-Neml, 65)</span>. </p>',
            ],
            13 => [
                'question' => 'Pitanje br. 14: Spomeni temelje vjerovanja!',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/810.mp3',
                'answer' => '<p> Odgovor: 1. Vjerovanje u Allaha Uzvišenog.<br /> 2. Vjerovanje u Njegove meleke.<br /> 3. Vjerovanje u Njegove knjige.<br /> 4. Vjerovanje u Njegove poslanike.<br /> 5. Vjerovanje u Sudnji dan.<br /> 6. Vjerovanje u odredbu dobra i zla.<br /> Uporište za spomenuto nalazimo u poznatom hadisu Džibrila kojeg bilježi Muslim. U njemu se spominje da je Džibril rekao Vjerovjesniku,<span class="c6"> sallallahu alejhi ve sellem:</span> "Kaži mi nešto o imanu.<span class="c6">" On mu reče:</span> \'Iman je da vjeruješ u Allaha, u Njegove meleke, knjige, poslanike, u Sudnji dan i da je dobro i zlo određeno.\'" </p>',
            ],
            14 => [
                'question' => 'Pitanje br. 15: Pojasni nam temelje vjerovanja!',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/900.mp3',
                'answer' => '<p> Odgovor: 1.<span class="c6"> Vjerovanje u Allaha Uzvišenog:</span><br /> Vjerovanje da je Allah tvoj Gospodar i Opskrbitelj, da je jedini Vladar i Upravitelj stvorenja.<br /> On je istinski Bog i jedini koji zaslužuje da bude obožavan.<br /> On je Veličanstveni i Veliki, posjeduje savršenstvo i Njemu pripada sva zahvala. Također posjeduje najljepša imena i savršena svojstva, Njemu nema ravnoga i niko Mu sličan nije.<span class="c6"><br /> Vjerovanje u meleke:</span><br /> Oni su Allahova stvorenja koja su stvorena od svjetlosti i cilj njihovog stvaranja jeste da Mu stalno i potpuno budu u pokornosti i ibadetu.<br /> Jedan od meleka je Džibril koji je donosio objave vjerovjesnicima.<span class="c6"><br /> Vjerovanje u knjige:</span><br /> To su knjige koje je Allah objavio Svojim poslanicima.<span class="c6"><br /> Kur\'an:</span> objavljen Muhammedu, sallallahu alejhi ve sellem.<span class="c6"><br /> Indžil:</span> objavljen Isau, alejhisselam.<span class="c6"><br /> Tevrat:</span> objavljen Musau, alejhisselam.<span class="c6"><br /> Zebur:</span> objavljen Davudu, alejhisselam.<br /> Listovi koji su objavljeni Ibrahimu i Musau.<span class="c6"><br /> Vjerovanje u poslanike:</span><br /> Njih je Allah poslao Svojim robovima kako bi ih podučili, donijeli im radosnu vijest da Džennet čeka onoga ko bude činio dobro, te da upozore na Vatru one koji čine zlo.<br /> Najbolji među njima su "ulul-\'azm", tj. posebno odabrani poslanici,<span class="c6"> a njihova imena su:</span><br /> Nuh alejhisselam.<br /> Ibrahim alejhisselam.<br /> Musa alejhisselam.<br /> Isa alejhisselam.<br /> Muhammed, sallallahu alejhi ve sellem.<br /> Vjerovanje u Sudnji dan<br /> Život koji dolazi nakon smrti, u kaburu i na onome svijetu kada će stvorenja biti oživljena i za djela obračunata, a sve s ciljem da džennetlije vječno budu u Džennetu, a džehennemlije vječno u Vatri.<span class="c6"><br /> Vjerovanje u odredbu dobra i zla:</span><br /> Čvrsto uvjerenje da Allah poznaje sve što se događa, da je ta dešavanja zapisao u Ploči pomno čuvanoj <span class="c2">(Levhil mahfuzu)</span>, da je htio da se dese i da je sve to stvorio.<span class="c6"><br /> Allah Uzvišeni kaže:</span> "Mi sve s odredbom stvaramo." <span class="c2">(El-Kamer, 49)</span>.<span class="c6"><br /> Ova odredba sadrži četiri nivoa:</span><br /> Prvi: Allahovo znanje, u šta se ubraja i Njegovo znanje koje prethodi svemu što se dešava, prije nego se desi, a i nakon što se desi.<span class="c6"><br /> Dokaz za to su riječi Uzvišenog Allaha:</span> "Samo Allah zna kad će Smak svijeta nastupiti, samo On spušta kišu i samo On zna šta je u matericama, a čovjek ne zna šta će sutra zaraditi i ne zna čovjek u kojoj će zemlji umrijeti; Allah, uistinu, sve zna i o svemu je obaviješten." <span class="c2">(Lukman, 34)</span>.<span class="c6"><br /> Drugi:</span> Allah Uzvišeni zapisao je u Ploči pomno čuvanoj <span class="c2">(Levhil mahfuzu)</span> sve ono što se desilo i što će se desiti.<span class="c6"><br /> Dokaz ovome su Allahove riječi u kojima kaže:</span> "U Njega su ključevi svih tajni, samo ih On zna, i On jedini zna šta je na kopnu i šta je u moru, i nijedan list ne opadne, a da On za njega ne zna; i nema zrna u tminama Zemlje niti ičega svježeg niti ičega suhog, ničega što nije u jasnoj Knjizi." <span class="c2">(El-En\'am, 59)</span>.<span class="c6"><br /> Treći:</span> Sve se dešava Allahovom voljom. Sve što On uradi, ili pak urade Njegova stvorenja, desilo se prema Njegovoj volji.<span class="c6"><br /> Dokaz ovome su Allahove riječi u kojima kaže:</span> "Onome od vas koji hoće da je na Pravome putu, a vi ne možete ništa htjeti ako to Allah, Gospodar svjetova, neće!" <span class="c2">(Et-Tekvir, 28-29)</span>.<span class="c6"><br /> Četvrti:</span> Vjerovanje da je sve što postoji Allah stvorio: bića, svojstva, pokrete i sve ostalo.<span class="c6"><br /> Dokaz ovome su Allahove riječi u kojima kaže:</span> "Allah stvara i vas i ono što radite." <span class="c2">(Es-Saffat, 96)</span>. </p>',
            ],
            15 => [
                'question' => 'Pitanje br. 16: Koja je definicija Kur\'ana?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1300.mp3',
                'answer' => '<p> Odgovor: Allahov govor koji nije stvoren.<span class="c6"><br /> Uzvišeni Allah veli:</span> ”Ako te neki od mnogobožaca zamoli za zaštitu, ti ga zaštiti da bi saslušao Allahove riječi.” <span class="c2">(Et-Tevba, 6)</span>. </p>',
            ],
            16 => [
                'question' => 'Pitanje br. 17: Šta je to sunnet?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1330.mp3',
                'answer' => '<p> Odgovor: Sve ono što je Poslanik, sallallahu alejhi ve sellem, rekao, uradio, odobrio, a i svako svojstvo koje posjeduje, bilo da je vezano za njegov izgled ili ponašanje. </p>',
            ],
            17 => [
                'question' => 'Pitanje br. 18: Šta je to novotarija i da li je možemo prihvatiti?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1350.mp3',
                'answer' => '<p> Odgovor: Sve ono što su ljudi uveli u vjeru, a nije bilo prisutno u vrijeme Vjerovjesnika, sallallahu alejhi ve sellem, i njegovih ashaba.<br /> Novotariju ni u kom slučaju ne prihvatamo, već je odbacujemo.<span class="c6"><br /> Dokaz ovome je hadis u kojem stoji:</span> "Svaka novotarija je zabluda." Bilježi ga Ebu Davud.<br /> Primjer novotarije jeste dodavanje na neki ibadet, kao na primjer da se tokom abdesta dijelovi tijela peru četiri puta, ili proslavljanje rođenja Poslanika <span class="c2">(mevlud)</span>. Takvo nešto nije preneseno ni od Poslanika, sallallahu alejhi ve sellem, niti od ashaba. </p>',
            ],
            18 => [
                'question' => 'Pitanje br. 19: Šta označava princip el-vela vel-bera?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1410.mp3',
                'answer' => '<p> Odgovor: El-Vela je ljubav prema vjernicima i njihovo pomaganje.<span class="c6"><br /> Uzvišeni Allah veli:</span> "A vjernici i vjernice su prijatelji jedni drugima..." <span class="c2">(Et-Tevba, 71)</span>.<br /> El-Bera je prezir prema nevjernicima i neprijateljstvo spram njih.<span class="c6"><br /> Uzvišeni Allah veli:</span> "Divan uzor za vas je Ibrahim i oni koji su uz njega bili kada su narodu svome rekli: \'Mi s vama nemamo ništa, a ni sa onima kojima se, umjesto Allahu, klanjate; mi vas se odričemo, i neprijateljstvo i mržnja će između nas ostati sve dok ne budete u Allaha, Njega jedinog, vjerovali!\'" <span class="c2">(El-Mumtehina, 4)</span>. </p>',
            ],
            19 => [
                'question' => 'Pitanje br. 20: Da li će Allah prihvatiti vjeru mimo islama?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1480.mp3',
                'answer' => '<p> Odgovor: Allah neće prihvatiti vjeru mimo islama.<span class="c6"><br /> Uzvišeni Allah veli:</span> "A onaj koji želi neku drugu vjeru osim islama, neće mu biti primljena, i on će na onome svijetu nastradati." <span class="c2">(Ali \'Imran, 85)</span>. </p>',
            ],
            20 => [
                'question' => 'Pitanje br. 21: Nevjerstvo nekada biva riječima, nekada djelima, a nekada ubjeđenjem. Navedi primjer!',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1520.mp3',
                'answer' => '<p> Odgovor: Primjer za nevjerstvo riječima jeste psovanje i vrijeđanje Allaha i Njegovog poslanika, sallallahu alejhi ve sellem.<br /> Primjer za nevjerstvo djelima jeste omalovažavanje mushafa ili sedžda nekome drugom mimo Allaha.<span class="c6"><br /> Primjer za nevjerstvo ubjeđenjem:</span> Ubjeđenje da postoji neko pored Allaha ko zaslužuje da mu se čini ibadet ili da postoji drugi tvorac mimo Njega. </p>',
            ],
            21 => [
                'question' => 'Pitanje br. 22: Šta je to licemjerstvo i koje su njegove vrste?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1570.mp3',
                'answer' => '<p> Odgovor:<br /> 1-<span class="c6"> Veliko licemjerstvo:</span> skrivanje nevjerstva, a ispoljavanje vjerovanja.<br /> Ovakva vrsta licemjerstva smatra se velikim nevjerstvom i kao takva izvodi van okvira islama.<span class="c6"><br /> Uzvišeni Allah veli:</span> "Licemjeri će na samome dnu Džehennema biti i ti im nećeš zaštitnika naći." <span class="c2">(En-Nisa, 145)</span>.<br /> 2-<span class="c6"> Malo licemjerstvo:</span><br /> Primjer tome je laž, kršenje obećanja, pronevjera emaneta i tome slično.<br /> Ovakva vrsta licemjerstva ne izvodi van okvira islama, ali je grijeh zbog kojeg je njegov počinilac izložen kazni.<br /> Allahov poslanik, sallallahu alejhi ve sellem,<span class="c6"> je rekao:</span> <span class="c1">“Tri su znaka licemjera: kada govori – laže, i kada obeća – ne ispuni, i kada mu se nešto povjeri – iznevjeri.”</span> Buhari i Muslim. </p>',
            ],
            22 => [
                'question' => 'Pitanje br. 23: Ko je pečat svih vjerovjesnika i poslanika?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1680.mp3',
                'answer' => '<p> Odgovor: To je Muhammed, sallallahu alejhi ve sellem.<span class="c6"><br /> Uzvišeni Allah veli:</span> "Muhammed nije otac nijednom od vaših ljudi, nego je Allahov poslanik i pečat, posljednji vjerovjesnik..." <span class="c2">(El-Ahzab, 40)</span>. Poslanik, sallallahu alejhi ve sellem,<span class="c6"> je rekao:</span> "Ja sam pečat vjerovjesnika i nakon mene nema vjerovjesnika.<span class="c6">" Bilježi:</span> Ebu Davud, Tirmizi i dr. </p>',
            ],
            23 => [
                'question' => 'Pitanje br. 24: Šta je to mu\'džiza?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1730.mp3',
                'answer' => '<p> Odgovor: Mu\'džiza je nadnaravno djelo koje nije uobičajeno, a koje Allah daje Svojim vjerovjesnicima kao dokaz njihove istinitosti.<span class="c6"> Primjer tome je:</span><br /> - rascjepljenje Mjeseca vjerovjesniku Muhammedu, sallallahu alejhi ve sellem.<br /> - rascjepljenje mora Musau, alejhisselam, te utapanje faraona i njegove vojske. </p>',
            ],
            24 => [
                'question' => 'Pitanje br. 25: Ko su ashabi i da li ih trebamo voljeti?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1780.mp3',
                'answer' => '<p> Odgovor: Ashabi su ljudi koji su sreli Poslanika, sallallahu alejhi ve sellem, kao vjernici i koji su umrli nakon toga kao muslimani.<br /> Obaveza nam je da ih volimo i da nam budu uzori. Oni su najbolji ljudi nakon vjerovjesnika.<span class="c6"><br /> Najbolji od njih su četverica halifa:</span><br /> Ebu Bekr, neka je Allah zadovoljan sa njim.<br /> Omer, neka je Allah zadovoljan sa njim.<br /> Osman, neka je Allah zadovoljan sa njim.<br /> Alija, neka je Allah zadovoljan sa njim. </p>',
            ],
            25 => [
                'question' => 'Pitanje br. 26: Ko su majke vjernika?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1870.mp3',
                'answer' => '<p> Odgovor: To su supruge Vjerovjesnika, sallallahu alejhi ve sellem.<span class="c6"><br /> Uzvišeni Allah veli:</span> "Vjerovjesnik treba biti preči vjernicima nego oni sami sebi, a žene njegove su - kao majke njihove." <span class="c2">(El-Ahzab, 6)</span>. </p>',
            ],
            26 => [
                'question' => 'Pitanje br. 26: Koje pravo kod nas ima porodica Vjerovjesnika, sallallahu alejhi ve sellem?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1910.mp3',
                'answer' => '<p> Odgovor: Mi ih volimo i prijateljski se prema njima odnosimo, te preziremo one koji njih preziru. Osim toga, ne pretjerujemo u našoj ljubavi prema njima. U porodicu Poslanika ubrajaju se njegove supruge, potomstvo i vjernici od Hašimija i potomaka Muttaliba. </p>',
            ],
            27 => [
                'question' => 'Pitanje br. 28: Koje su naše obaveze prema predstavnicima muslimana?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1940.mp3',
                'answer' => '<p> Odgovor: Trebamo im iskazivati poštovanje, slušati ih i biti im pokorni u onome što nije grijeh, ne trebamo se boriti protiv njih na bilo koji način, trebamo upućivati dove za njihovo dobro i privatno ih savjetovati. </p>',
            ],
            28 => [
                'question' => 'Pitanje br. 29: Koje je stanište vjernika?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1970.mp3',
                'answer' => '<p> Odgovor: Džennet.<span class="c6"> Allah Uzvišeni kaže:</span> "Allah će one koji vjeruju i dobra djela čine uvesti u džennetske bašče kroz koje rijeke teku..." <span class="c2">(Muhammed, 12)</span>. </p>',
            ],
            29 => [
                'question' => 'Pitanje br. 30: Koje je stanište nevjernika?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2000.mp3',
                'answer' => '<p> Odgovor: Vatra.<span class="c6"> Allah Uzvišeni kaže:</span> "Čuvajte se Vatre za nevjernike pripremljene, čije će gorivo biti ljudi i kamenje." <span class="c2">(El-Bekare, 24)</span>. </p>',
            ],
            30 => [
                'question' => 'Pitanje br. 31: Šta su to strah i nada i koji dokaz upućuje na to?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2020.mp3',
                'answer' => '<p> Odgovor: Strah predstavlja da se čovjek boji Allaha i Njegove kazne.<br /> Nada predstavlja to da se čovjek nada Allahovoj nagradi, oprostu i milosti.<span class="c6"><br /> Dokaz za to su riječi Uzvišenog:</span> "Oni kojima se oni mole sami traže načina kako će se što više Gospodaru svome približiti, i nadaju se milosti Njegovoj i plaše se kazne Njegove. A kazne Gospodara tvoga svako se treba čuvati." <span class="c2">(El-Isra, 57)</span>. Također,<span class="c6"> Uzvišeni je rekao:</span> "Kaži robovima Mojim da sam Ja, zaista, Onaj koji prašta i da sam milostiv, ali da je i kazna Moja, doista, bolna kazna!" <span class="c2">(El-Hidžr, 49-50)</span>. </p>',
            ],
            31 => [
                'question' => 'Pitanje br. 32: Navedi neka Allahova imena i svojstva!',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2070.mp3',
                'answer' => '<p> Odgovor: Allah, Er-Rabb <span class="c2">(Gospodar)</span>, Er-Rahmanu <span class="c2">(Milostivi)</span>, Es-Semi\'u <span class="c2">(Onaj koji sve čuje)</span>, El-Basiru <span class="c2">(Onaj koji sve vidi)</span>, El-\'Alimu <span class="c2">(Onaj koji sve zna)</span>, Er-Rezzaku <span class="c2">(Opskrbitelj)</span>, El-Hajju <span class="c2">(Živi)</span>, El-\'Azimu <span class="c2">(Veličanstveni)</span>, i mnoga druga lijepa imena i savršena svojstva. </p>',
            ],
            32 => [
                'question' => 'Pitanje br. 33: Pojasni značenja ovih imena!',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2100.mp3',
                'answer' => '<p> Odgovor: Allah: Bog Koji se istinski obožava, samo On, Jedan jedini, Koji nema sudruga.<br /> Er-Rabb <span class="c2">(Gospodar)</span>: Jedini Tvorac, Vladar, Opskrbitelj i Upravitelj.<br /> Es-<span class="c6">Semi\'u:</span> Onaj Koji sve čuje, čuje svaki glas ponaosob, bez obzira na raznovrsnost i različitost istih.<br /> El-<span class="c6">Basiru:</span> Onaj Koji sve vidi, bilo malo ili veliko.<br /> El-<span class="c6">\'Alimu:</span> Onaj čije znanje obuhvata sve iz prošlosti, sadašnjosti i budućnosti.<br /> Er-Rahmanu <span class="c2">(Milostivi)</span>: Onaj čija milost obuhvata sve stvoreno i živo, i svi ljudi i sva stvorenja su pod Njegovom milošću.<br /> Er-Rezzaku <span class="c2">(Opskrbitelj)</span>: Onaj Koji daje opskrbu svim stvorenjima: ljudima, džinima i svima ostalima.<br /> El-Hajju <span class="c2">(Živi)</span>: Onaj Koji ne umire, a stvorenja umiru.<br /> El-\'Azimu <span class="c2">(Veličanstveni)</span>: Onaj Koji posjeduje svaku savršenost i uzvišenost, u Svojim imenima, svojstvima i djelima. </p>',
            ],
            33 => [
                'question' => 'Pitanje br. 34: Koje su naše obaveze prema muslimanskim učenjacima?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2210.mp3',
                'answer' => '<p> Odgovor: Volimo ih i obraćamo im se u vezi sa onim što nas zanima o vjerskim pitanjima. Spominjemo ih samo po dobru, a onaj ko ih bude spominjao po zlu, ne slijedi pravi put.<span class="c6"><br /> Uzvišeni Allah veli:</span> "Allah će na visoke stepene uzdignuti one među vama koji vjeruju i kojima je dato znanje. - A Allah dobro zna ono što radite." <span class="c2">(El-Mudžadela, 11)</span>. </p>',
            ],
            34 => [
                'question' => 'Pitanje br. 35: Ko su Allahove evlije?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2240.mp3',
                'answer' => '<p> Odgovor: To su bogobojazni vjernici.<span class="c6"><br /> Uzvišeni Allah veli:</span> "I neka se ničega ne boje i ni za čim neka ne tuguju Allahovi štićenici, oni koji budu vjerovali i koji se budu Allaha bojali." <span class="c2">(Junus, 62-63)</span>. </p>',
            ],
            35 => [
                'question' => 'Pitanje br. 36: Da li se u vjerovanje ubrajaju riječi i djela?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2280.mp3',
                'answer' => '<p> Odgovor: Vjerovanje obuhvata riječ, djelo i ubjeđenje. </p>',
            ],
            36 => [
                'question' => 'Pitanje br. Da li se vjerovanje (iman) povećava i smanjuje?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2310.mp3',
                'answer' => '<p> Odgovor: Vjerovanje se povećava pokornošću <span class="c2">(činjenjem dobrih djela)</span>, a smanjuje griješenjem.<span class="c6"><br /> Uzvišeni Allah veli:</span> "Pravi su vjernici samo oni čija se srca strahom ispune kad se Allah spomene, a kad im se ajeti Njegovi uče, vjerovanje im povećaju i samo se na Gospodara svoga oslanjaju." <span class="c2">(El-Enfal, 2)</span>. </p>',
            ],
            37 => [
                'question' => 'Pitanje br. 38: Šta je to ihsan?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2350.mp3',
                'answer' => '<p> Odgovor: Ihsan je da obožavaš Allaha kao da Ga vidiš. a ako ti Njega ne vidiš, On tebe vidi. </p>',
            ],
            38 => [
                'question' => 'Pitanje br. 39: Kada djela bivaju prihvaćena kod Allaha Uzvišenog?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2370.mp3',
                'answer' => '<p> Odgovor: Djela se prihvataju uz dva uslova:<br /> 1- Ako je iskreno u ime Allaha i radi Njegovog Lica.<br /> 2- Ako je u skladu sa sunnetom Vjerovjesnika, sallallahu alejhi ve sellem. </p>',
            ],
            39 => [
                'question' => 'Pitanje br. 40: Šta je to tevekkul (oslonac) u Allaha?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2420.mp3',
                'answer' => '<p> Odgovor: To je oslanjanje na Allaha, vjerujući da samo On daje korist i otklanja štetu, uz činjenje onoga što je u našoj moći.<span class="c6"><br /> Uzvišeni Allah veli:</span> "Onome koji se u Allaha uzda, On mu je dosta." <span class="c2">(Et-Talak, 3)</span>.<span class="c6"><br /> Riječi:</span> "On mu je dosta", znače da mu je Allah dovoljan. </p>',
            ],
            40 => [
                'question' => 'Pitanje br. 41: Šta označava obaveza naređivanja dobra i zabranjivanja zla?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2470.mp3',
                'answer' => '<p> Odgovor: Dobro <span class="c2">(ma\'ruf)</span> je sve ono u čemu je pokornost Allahu, a zlo <span class="c2">(munker)</span> je sve ono u čemu je griješenje prema Njemu.<span class="c6"><br /> Uzvišeni Allah veli:</span> "Vi ste narod najbolji od svih koji se ikada pojavio: tražite da se čine dobra djela, a od nevaljalih odvraćate, i u Allaha vjerujete." <span class="c2">(Ali \'Imran, 110)</span>. </p>',
            ],
            41 => [
                'question' => 'Pitanje br. 42: Ko su sljedbenici sunneta i džemata (ehlus-sunne vel-džema\'a)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2510.mp3',
                'answer' => '<p> Odgovor: To su svi oni koji slijede riječi, djela i vjerovanje na način kako su to činili Vjerovjesnik, sallallahu alejhi ve sellem, i njegovi ashabi.<br /> Nazvani su sljedbenicima sunneta jer praktikuju vjerovjesničku praksu i ne rade novotarije u vjeri.<br /> Nazvani su džematom jer su okupljeni u slijeđenju istine i ne razilaze se u pogledu nje. </p>',
            ],
        ],
        2 => [
            0 => [
                'question' => 'Pitanje br. 1: Koja je definicija tahareta (čistoće)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2580.mp3',
                'answer' => '<p> Odgovor: Taharet je uklanjanje pravne <span class="c2">(apstraktne)</span> i stvarne nečistoće i prljavštine.<br /> Uklanjanje stvarne prljavštine biva na način da musliman ukloni nečistoću koja se nalazi na njegovom tijelu, odjeći i mjestu gdje će obaviti namaz.<br /> Uklanjanje pravne <span class="c2">(apstraktne)</span> biva putem abdesta i kupanja čistom vodom, ili pak tejemmumom u slučaju kada nema vode ili kada se ona ne može koristiti. </p>',
            ],
            1 => [
                'question' => 'Pitanje br. 2: Kako očistiti ono na čemu se nalazi nečista materija?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2630.mp3',
                'answer' => '<p> Odgovor: Pranjem sa vodom sve dok se ne očisti.<br /> Ono što je lizao pas, treba oprati sedam puta, a prvi put sa zemljom. </p>',
            ],
            2 => [
                'question' => 'Pitanje br. 3: Koja je vrijednost abdesta?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2660.mp3',
                'answer' => '<p> Odgovor: Vjerovjesnik, sallallahu alejhi ve sellem,<span class="c6"> je rekao:</span> “Kada čovjek musliman, ili mu\'min, uzima abdest pa opere svoje lice, spadnu sa njega zajedno s vodom ili sa posljednjom kapi vode svi grijesi njegovih očiju; a kada sapere svoje ruke, s njih spadnu zajedno s vodom ili sa posljednjom kapi vode svi njegovi grijesi koje je rukama počinio; a kada opere svoje noge, s njih spadnu svi grijesi koje je počinio hodajući na njima, zajedno s vodom, ili posljednjom kapi vode, tako da ostane posve čist od grijeha." Hadis bilježi Muslim. </p>',
            ],
            3 => [
                'question' => 'Pitanje br. 4: Kako se abdesti?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2690.mp3',
                'answer' => '<p> Odgovor: Pranje šaka tri puta.<br /> Pranje usta, ubacivanje vode u nos i njeno izbacivanje, tri puta.<br /> Pranje usta označava ubacivanje vode u usnu šupljinu, njeno pranje, te izbacivanje vode iz nje.<br /> Ubacivanje vode u nos biva tako da vodu treba ušmrkati u nosnu šupljinu, korištenjem dlana desne šake.<br /> Izbacivanje vode iz nosa biva na način da vodu treba išmrkati, korištenjem lijeve šake.<br /> Zatim se pere lice tri puta.<br /> Nakon lica peru se obje ruke po tri puta, od vrhova prstiju do iznad laktova.<br /> Poslije toga vlažnim šakama potire se glava, na način da se krene od čela pa do potiljka, a onda nazad, te se nakon toga potiru uši.<br /> Na kraju se peru stopala, oba po tri puta, i to od vrhova prstiju do iznad nožnih članaka.<br /> Ovo je najpotpuniji način i on je ustanovljen potvrđenim predajama od Poslanika, sallallahu alejhi ve sellem, koje od njega prenose Osman, Abdullah b. Zejd i drugi, a bilježe ih Buharija i Muslim. Također, postoje predaje koje bilježi Buharija, a i neki drugi, da je tokom abdesta Poslanik, sallallahu alejhi ve sellem, nekada dijelove tijela prao po jednom, a nekada po dva puta. </p>',
            ],
            4 => [
                'question' => 'Pitanje br. 5: Koji su farzovi abdesta?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2810.mp3',
                'answer' => '<p> Odgovor: To su postupci tokom abdesta koje je obaveza učiniti, a ukoliko se izostavi samo jedan, abdest neće biti valjan.<br /> 1- Pranje lica, u šta se ubraja pranje usta i nosa.<br /> 2- Pranje ruku do iznad laktova.<br /> 3- Potiranje glave, u šta ulazi i potiranje ušiju.<br /> 4- Pranje stopala do iznad nožnih članaka.<br /> 5- Propisani redoslijed u samome pranju, na način da se prvo opere lice, pa ruke, zatim se potire po glavi, a onda se peru noge.<br /> 6- Kontinuitet u pranju dijelova tijela, to jeste pranje dijelova tijela bez prekida. Drugim riječima, između pranja prethodnog i sljedećeg dijela tijela ne smije proći mnogo vremena u kojem bi se prethodno oprani dio osušio.<br /> Primjer tome jes da se abdest uzme do pola, a onda se isti nastavi nakon što prođe mnogo vremena. Takav abdest nije valjan. </p>',
            ],
            5 => [
                'question' => 'Pitanje br. 6: Koji su to sunneti abdesta?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2910.mp3',
                'answer' => '<p> Odgovor: Sunneti abdesta su postupci tokom abdesta koji ukoliko se urade, propisana je nagrada, a ukoliko se izostave, čovjek neće imati grijeh, iz čega proističe da je abdest valjan i bez njih.<br /> 1- Izgovaranje bismille na početku abdesta.<br /> 2- Korištenje misvaka.<br /> 3- Pranje šaka <span class="c2">(na početku abdesta)</span>.<br /> 4. Trljanje između prstiju.<br /> 5- Pranje drugi i treći put.<br /> 6- Otpočinjanje sa desnom stranom.<br /> 7-<span class="c6"> Zikr nakon abdesta:</span> Ešhedu en la ilahe illallahu vahdehu la šerike lehu, ve ešhedu enne Muhammeden abduhu ve resuluhu/Svjedočim da nema drugog istinskog boga osim Allaha, Jedinog. On nema sudruga. I svjedočim da je Muhammed Njegov rob i poslanik.<br /> 8- Dva rek\'ata nakon abdesta. </p>',
            ],
            6 => [
                'question' => 'Pitanje br. 7: Šta kvari abdest?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3020.mp3',
                'answer' => '<p> Odgovor: Ono što izlazi na dva otvora, preko spolnog organa i analnog otvora, bilo da se radi o mokraći, izmetu ili vjetru.<br /> San, gubljenje pameti ili svijesti.<br /> Jedenje mesa kamile.<br /> Izravno dodirivanje spolnog organa ili analnog otvora sa šakom, bez bilo kakvog zastora. </p>',
            ],
            7 => [
                'question' => 'Pitanje br. 8: Šta je to tejemmum?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3080.mp3',
                'answer' => '<p> Odgovor: Tejemmum je korištenje zemlje ili nečega drugoga što je na njenoj površini u slučaju kada nema vode ili ju čovjek ne može koristiti. </p>',
            ],
            8 => [
                'question' => 'Pitanje br. 8: Kako se uzima tejemmum?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3110.mp3',
                'answer' => '<p> Tejemmum se uzima tako što se dlanovima jedanput udari po zemlji, a onda se potare po licu i vanjskom dijelu šaka, također jedanput. </p>',
            ],
            9 => [
                'question' => 'Pitanje br. 10: Šta kvari tejemmum?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3140.mp3',
                'answer' => '<p> Odgovor: Sve ono što kvari abdest.<br /> Dolazak <span class="c2">(pronalazak)</span> vode. </p>',
            ],
            10 => [
                'question' => 'Pitanje br. 11: Šta su to mestve i čarape, i da li se može potirati po njima?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3180.mp3',
                'answer' => '<p> Odgovor: Mestve su vrsta obuće napravljene od kože koja se oblači na stopala.<br /> Čarape su ono što se oblači na noge, a nije napravljeno od kože.<br /> Umjesto pranja nogu, može se potirati po mestvama ili po čarapama. </p>',
            ],
            11 => [
                'question' => 'Pitanje br. 12: Koja je mudrost potiranja po mestvama?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3230.mp3',
                'answer' => '<p> Odgovor: Olakšavanje ljudima, posebno u vrijeme hladnoće i putovanja, jer je u tim slučajevima otežano skidanje mestvi i pranje nogu. </p>',
            ],
            12 => [
                'question' => 'Pitanje br. 13: Koji su uslovi ispravnosti potiranja po mestvama?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3260.mp3',
                'answer' => '<p> Odgovor: 1- Mestve treba obući nakon abdesta.<br /> 2- Mestve trebaju biti čiste, jer nije dozvoljeno potiranje po nečistim mestvama.<br /> 3- Mestve trebaju prekrivati dio tijela koji je obaveza oprati tokom abdesta <span class="c2">(cijela stopala do iznad članaka)</span>.<br /> 4- Potiranje treba biti tokom određenog vremena. Za onoga ko nije putnik potiranje traje dan i noć <span class="c2">(24 sata)</span>, a za putnika traje tri dana i noći <span class="c2">(72 sata)</span>. </p>',
            ],
            13 => [
                'question' => 'Pitanje br. 14: Kako se potire po mestvama ili čarapama?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3320.mp3',
                'answer' => '<p> Vlažne prste na rukama treba staviti na nožne prste, a onda ih povući prema potkoljenici, desnu nogu potirući desnom, a lijevu lijevom šakom. Prsti trebaju biti rašireni i proces potiranja ne treba ponavljati. </p>',
            ],
            14 => [
                'question' => 'Pitanje br. 15: Šta kvari potiranje po mestvama?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3350.mp3',
                'answer' => '<p> Odgovor: 1- Istek vremena kada je dozvoljeno potiranje. Dakle, nije dozvoljeno potirati nakon isteka dana i noći za onoga ko nije putnik, odnosno tri dana i tri noći za putnika.<br /> 2- Skidanje mestvi. Nakon što čovjek skine mestve ili jednu od njih, nakon što je potirao po njima, u tom slučaju prekida mu se pravo na potiranje. </p>',
            ],
            15 => [
                'question' => 'Pitanje br. 16: Šta označava namaz?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3390.mp3',
                'answer' => '<p> Odgovor: Namaz je način obožavanja Allaha gdje se koriste određene riječi i pokreti, od početnog tekbira do predaje selama. </p>',
            ],
            16 => [
                'question' => 'Pitanje br. 17: Koji je propis namaza?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3420.mp3',
                'answer' => '<p> Odgovor: Namaz je stroga obaveza svakome muslimanu.<span class="c6"><br /> Uzvišeni Allah veli:</span> "Vjernicima je propisano da u određeno vrijeme namaz obavljaju." <span class="c2">(En-Nisa, 103)</span>. </p>',
            ],
            17 => [
                'question' => 'Pitanje br. 18: Koji je propis osobe koja ne obavlja namaz?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3460.mp3',
                'answer' => '<p> Odgovor: Neobavljanje namaza je djelo nevjerstva. Rekao je Poslanik,<span class="c6"> sallallahu alejhi ve sellem:</span><br /> "Ugovor između nas i njih je namaz. Onaj koji ga ostavi, učinio je nevjerstvo."<br /> Bilježe ga Ahmed, Tirmizi i dr. </p>',
            ],
            18 => [
                'question' => 'Pitanje br. 19: Koliko je namaza musliman obavezan obavljati tokom dana i noći i koliko svaki od njih ima rek\'ata?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3500.mp3',
                'answer' => '<p> Odgovor: Pet namaza tokom dana i noći: <br /> <br /> 1. Sabah, dva rek\'ata farza, 2. Podne, četiri rek\'ata farza, 3. Ikindija, četiri rek\'ata farza, 4. Akšam, tri rek\'ata farza, 5. Jacija, četiri rek\'ata farza. </p>',
            ],
            19 => [
                'question' => 'Pitanje br. 20: Koji su uslovi ispravnosti namaza?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3530.mp3',
                'answer' => '<p> Odgovor: 1. Islam, jer namaz nije ispravan ako ga obavi nevjernik.<br /> 2. Razum, jer namaz nije ispravan ako ga obavi bezumna osoba.<br /> 3. Mogućnost razlučivanja, jer namaz nije ispravan ako ga obavi dijete koje još nije toliko odraslo da može razlučivati stvari.<br /> 4. Namjera.<br /> 5. Nastupanje vremena.<br /> 6. Pravna čistoća <span class="c2">(abdest ili gusul ako je potrebno)</span>.<br /> 7. Uklanjanje stvarne nečistoće.<br /> 8. Pokrivanje stidnog mjesta koje je definisano vjerskim tekstom.<br /> 9. Okretanje prema kibli <span class="c2">(Mekki)</span>. </p>',
            ],
            20 => [
                'question' => 'Pitanje br. 21: Koji su ruknovi (sastavni dijelovi namaza)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3640.mp3',
                'answer' => '<p> Odgovor: Četrnaest je namaskih ruknova,<span class="c6"> a oni su:</span><br /> Stajanje u obaveznom namazu onome ko je to u mogućnosti.<span class="c6"><br /> Početni tekbir koji glasi:</span> Allahu ekber.<br /> Učenje Fatihe.<br /> Pregibanje u namazu <span class="c2">(ruku\')</span> na način da se ispruže leđa i poravnaju sa glavom.<br /> Podizanje sa ruku\'a.<br /> Ispravljanje tijela u stajaćem položaju <span class="c2">(nakon ruku\'a)</span>.<br /> Padanje ničice <span class="c2">(sedžda)</span> na način da se na tlo spuste čelo, nos, dlanovi, koljena i vrhovi nožnih prstiju.<br /> Podizanje sa sedžde.<br /> Sjedenje između dvije sedžde.<br /> Sunnet je da se sjedi na lijevom stopalu, a da se desno uspravi na nožne prste prema kibli.<br /> Smirenost na svakom ruknu koji se radi.<br /> Zadnji tešehhud <span class="c2">(sjedenje)</span>.<br /> Sjedenje za zadnji tešehhud.<br /> Predaja selama na desnu i na lijevu stranu,<span class="c6"> tako što će se reći:</span> Esselamu \'alejkum ve rahmetullah.<br /> Redoslijed izvršavanja ruknova onako kako je to spomenuto. Ako bi neko, primjera radi, namjerno učinio sedždu prije ruku\'a, njegov namaz bi bio neispravan. A ukoliko bi to nenamjerno učinio, morao bi se vratiti da učini ruku\', a onda nastaviti da klanja sa propisanim redoslijedom. </p>',
            ],
            21 => [
                'question' => 'Pitanje br. 22: Koji su to vadžibi namaza?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3820.mp3',
                'answer' => '<p> Odgovor: Osam je namaskih vadžiba,<span class="c6"> a oni su:</span><br /> 1. Svi tekbiri mimo početnog.<br /> 2.<span class="c6"> Izgovaranje:</span> <span class="c2">(semi\'allahu limen hamideh)</span> od strane imama i onoga ko klanja samostalno.<br /> 3.<span class="c6"> Izgovaranje:</span> <span class="c2">(rabbena velekel-hamd)</span>.<br /> 4.<span class="c6"> Jednom izgovoriti:</span> <span class="c2">(subhane rabbijel-\'azim)</span> na ruku\'u.<br /> 5.<span class="c6"> Jednom izgovoriti:</span> <span class="c2">(subhane rabbijel-e\'ala)</span> na sedždi.<br /> 6.<span class="c6"> Izgovoriti:</span> <span class="c2">(rabbigfirli)</span> između dvije sedžde.<br /> 7. Prvi tešehhud.<br /> 8. Sjedenje za prvi tešehhud. </p>',
            ],
            22 => [
                'question' => 'Pitanje br. 23: Koji su to namaski sunneti?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3930.mp3',
                'answer' => '<p> Odgovor: Postoji jedanaest namaskih sunneta,<span class="c6"> a oni su:</span><br /> 1. Nakon početnog tekbira proučiti početnu dovu,<span class="c6"> a jedna od njih glasi:</span> Subhanekellahumme ve bi hamdike ve tebarekesmuke, ve te’ala džedduke, ve la ilahe gajruke.<br /> 2. Proučiti isti\'azu <span class="c2">(E\'uzu billahi mineš-šejtanir-radžim)</span>.<br /> 3. Proučiti bismillu <span class="c2">(Bismillahir-rahmanir-rahim)</span>.<br /> 4. Izgovoriti <span class="c2">(amin)</span> nakon Fatihe.<br /> 5. Učenje sure nakon Fatihe.<br /> 6. Učenje naglas kada se radi o imamu.<br /> 7. Nakon <span class="c2">(rabbena velekel-hamd)</span> proučiti: <span class="c2">(mil\'es-semavati ve mil\'el-erdi ve mil\'e ma ši\'te min šej\'in ba\'du)</span>.<br /> 8. Na ruku\'u izgovoriti <span class="c2">(subhane rabbijel-\'azim)</span> više od jednoga puta.<br /> 9. Na sedždi izgovoriti <span class="c2">(subhane rabbijel-e\'ala)</span> više od jednoga puta.<br /> 10. Između dvije sedžde izgovoriti <span class="c2">(rabbigfirli)</span> više od jednoga puta.<br /> 11. Na zadnjem tešehhudu donijeti salavat na porodicu Allahovog poslanika, te zamoliti Allaha da podari berićeta i njemu i njima, a potom da prouči dovu.<br /> Ovo su bili sunneti kada je riječ o onome što se izgovara, a u nastavku navodimo sunnete koji se odnose na djela <span class="c2">(pokrete)</span>:<br /> 1. Podizanje ruku prilikom izgovaranja početnog tekbira.<br /> 2. Podizanje ruku prilikom pregibanja u namazu.<br /> 3. Podizanje ruku kada se vraćamo nakon pregibanja.<br /> 4. Spuštanje ruku nakon toga.<br /> 5. Stavljanje desne ruke preko lijeve.<br /> 6. Gledanje u mjesto gdje se čini sedžda.<br /> 7. Umjereno širenje nogu prilikom stajanja.<br /> 8. Prilikom ruku\'a treba raširiti prste na rukama i tako obuhvatiti koljena, te poravnati leđa u istu ravan sa glavom.<br /> 9. Spustiti propisane dijelove tijela na tlo prilikom obavljanja sedžde na način da se osjeti tlo.<br /> 10. Odvojiti laktove od tijela, stomak od butina, butine od potkoljenica, raširiti noge tako da se napravi praznina između koljena, ispraviti stopala, unutrašnjost nožnih prstiju staviti u pružen položaj prema tlu razdvojenih prstiju, šake staviti raširene naspram ramena, a prste na rukama skupiti.<br /> 11. Između dvije sedžde i na prvom sjedenju sjedi se na lijevoj nozi <span class="c2">(stopalu)</span> a uspravi se desno stopalo, i prste treba držati okrenute prema kibli, dok se na zadnjem sjedenju sjedi na lijevom stegnu, izbacivši lijevu potkoljenicu i stopalo ispod desnog buta.<br /> 12. Na sjedenju dlanove staviti na butine koje treba umjereno raširiti, a prste na rukama treba skupiti jedne uz druge, s tim što tom prilikom treba desnu šaku postaviti na način da se saviju mali prst i prstenjak, od srednjeg prsta i palca napraviti krug, a kažiprstom pokazivati kada se spominje Allahovo ime.<br /> 13. Okretanje glavom desno i lijevo prilikom predaje selama. </p>',
            ],
            23 => [
                'question' => 'Pitanje br. 24: Šta kvari namaz?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4210.mp3',
                'answer' => '<p> Odgovor: 1. Izostavljanje nekog od sastavnih dijelova <span class="c2">(ruknova)</span> ili uslova <span class="c2">(šartova)</span> namaza.<br /> 2. Namjeran govor.<br /> 3. Konzumiranje hrane ili pića.<br /> 4. Mnogobrojni uzastopni pokreti.<br /> 5. Namjerno izostavljanje neke od namaskih obaveza. </p>',
            ],
            24 => [
                'question' => 'Pitanje br. 25: Kako musliman obavlja namaz?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4280.mp3',
                'answer' => '<p> Odgovor: Način obavljanja namaza:<br /> 1. Treba se cijelim tijelom okrenuti prema kibli, bez krivljenja tijela i okretanja.<br /> 2. Nakon toga treba u srcu donijeti nijjet <span class="c2">(namjeru)</span> za namaz koji se želi obaviti, bez izgovaranja nijjeta jezikom.<br /> 3. Sljedeće jeste donošenje početnog tekbira sa riječima <span class="c2">(Allahu ekber)</span>, pri čemu se dižu ruke u visini ramena <span class="c2">(ili ušiju)</span>.<br /> 4. Nakon toga se šaka desne ruke stavlja na lijevu , te ih potom treba staviti na prsa.<br /> 5.<span class="c6"> Potom se prouči početna dova koja glasi:</span> ALLAHUMME BA\'ID BEJNI VE BEJNE HATAJAJE KEMA BA‘ADTE BEJNEL-MEŠRIKI VEL-MAGRIB, ALLAHUMME, NEKKINI MIN HATAJAJE KEMA JUNEKKA ES-SEVBUL-EBJEDU MINED-DENES, ALLAHUMME-GSILNI MIN HATAJAJE BIL-MAI VES-SELDŽI VEL-BERED. <span class="c1">“Allahu moj, udalji me od grijeha na razdaljinu kolika je od Istoka do Zapada. Moj Allahu, sačuvaj me od grijeha kao što se čuva bijela odjeća od prljavštine. Gospodaru moj, očisti me od grijeha snijegom, kišom, i ledom.”</span><br /> Može se proučiti i: SUBHANEKELLAHUME VE BIHAMDIKE VE TEBARAKESMUKE VE TE\'ALA DŽEDDUKE VE LA ILAHE GAJRUKE. <span class="c1">“Slavljen neka si, Gospodaru moj. Tebi hvala pripada, slavljeno neka je ime Tvoje i uzvišeno veličanstvo. Nema istinskog boga osim Tebe.”</span><br /> 6.<span class="c6"> Potom će proučiti isti\'azu koja glasi:</span> E\'uzu billahi mineš-šejtanir-radžim <span class="c2">(Utječem se Allahu od prokletog šejtana)</span>. 7. Nakon nje će proučiti bismillu,<span class="c6"> a onda Fatihu:</span> Bismillahir-rahmanir-rahim/U ime Allaha Milostivog Samilosnog. Elhamulillahi Rabbil-\'alemin/Svaka hvala neka je Allahu, Gospodaru svjetova. Er-rahmanir-rahim/Svemilosnom, Milostivom. Maliki jeumid-din/Vladaru Dana sudnjeg. Ijjake na\'budu ve ijjake nesta\'in/Samo Tebi ibadet činimo i samo od Tebe pomoć molimo. Ihdinas-siratal-mustekim/Uputi nas na Pravi put. Sirata-llezine en\'amte \'alejhim, gajril-magdubi \'alejhim veled-ddallin/Na put onih kojima si blagodati podario. A ne na put onih na koje se srdžba izlila, niti na put onih koji su zalutali. <span class="c2">(El-Fatiha, 1-7)</span>.<br /> Poslije Fatihe izgovara se <span class="c2">(amin)</span>,<span class="c6"> što znači:</span> Allahu moj, uslišaj!<br /> Nakon toga uči se sura ili nekoliko ajeta, a na farzu sabah-namaza pohvalno je oduljiti sa učenjem.<br /> 9. Potom se čini ruku\', tj. pregibanje i savijanje leđa, čime se iskazuje veličanje Allaha. Tokom odlaska na ruku\' izgovara se tekbir <span class="c2">(Allahu ekber)</span> i ruke se dižu naspram ramena. Sunnet je da se leđa isprave i izravnaju s glavom. Šake se stavljaju na koljena, a prsti se trebaju raširiti.<br /> 10. Na ruku\'u se izgovara <span class="c2">(subhane rabbijel-\'azim)</span>, tri puta, a lijepo je pored toga proučiti i <span class="c2">(subhanekellahumme ve bi hamdike. Allahummagfirli)</span>.<br /> 11. Nakon toga podiže se s ruku\'a i izgovara <span class="c2">(semi\'allahu limen hamideh)</span>, dižući ruke naspram ramena. Onaj koji klanja za imamom ne izgovara spomenute riječi, nego nakon njih treba reći <span class="c2">(rabbena velekel-hamd)</span>.<br /> 12. Dakle, kada se podigne sa ruku\'a izgovorit će <span class="c2">(rabbena velekel-hamd, mil\'es-semavati ve mil\'el-erdi ve mil\'e ma ši\'te min šej\'in ba\'du)</span>.<br /> 13. Potom se čini prva sedžda, padajući ničice i izgovarajući <span class="c2">(Allahu ekber)</span>.<span class="c6"> Sedžda se čini na sedam dijelova tijela:</span> čelo, nos, dvije šake <span class="c2">(dlanovi)</span>, koljena i vrhovi prstiju na stopalima. Tom prilikom se laktovi odvajaju od tijela, podlaktice se ne stavljaju na tlo, a vrhovi prstiju okreću se prema kibli.<br /> 14. Na sedždi se izgovara <span class="c2">(subhane rabbijel-e\'ala)</span>, tri puta, a lijepo je pored toga proučiti i <span class="c2">(subhanekellahumme ve bi hamdike. Allahummagfirli)</span>.<br /> 15. Potom se podiže sa sedžde uz izgovaranje <span class="c2">(Allahu ekber)</span>.<br /> 16. Zatim se između dvije sedžde sjedne na lijevo stopalo, a desno se uspravi. Desna ruka se stavi na vrh desne butine, odmah do koljena, saviju se mali prst i prstenjak, od srednjeg prsta i palca načini se krug, a kažiprst se pomjera prilikom dove. Lijeva ruka <span class="c2">(šaka)</span> stavlja se pruženih prstiju na vrh lijeve butine, odmah do koljena.<br /> 17.<span class="c6"> Na sjedenju između dvije sedžde izgovara se:</span> <span class="c2">(Rabbigfirli, verhamni, vehdini, verzukni, vedžburni, ve \'afini)</span>.<br /> 18. Potom se izgovarajući <span class="c2">(Allahu ekber)</span> čini druga sedžda kao i prva, na kojoj se isto govori i radi.<br /> 19. Zatim se podiže sa druge sedžde uz riječi <span class="c2">(Allahu ekber)</span>, te se klanja drugi rek\'at kao i prvi, isto se uči i radi, osim početne dove.<br /> 20. Nakon što se završi drugi rek\'at, sjedne se uz izgovaranje <span class="c2">(Allahu ekber)</span>. Isto se sjedi kao i između dvije sedžde.<br /> 21.<span class="c6"> Na tom sjedenju uči se sljedeće:</span> <span class="c2">(Et-Tehijjatu lillahi ves-salavatu vet-tajjibatu, es-selamu ‘alejke, ejjuhen-nebijju ve rahmetullahi ve berekatuhu. Es-selamu ‘alejna ve ‘ala ‘ibadillahis-salihin, ešhedu en la ilahe illallah ve ešhedu enne Muhammeden ‘abduhu ve resuluhu. Allahumme salli \'ala Muhammedin ve \'ala ali Muhammed, kema sallejte ala Ibrahime, ve \'ala ali Ibrahim inneke hamidun medžid. Allahume barik \'ala Muhammedin ve \'ala ali Muhammed, kema barekte \'ala Ibrahime ve \'ala ali Ibrahime inneke hamidun medžid. E\'uzu billahi min \'azabi džehennem, ve min \'azabil-kabr, ve min fitnetil-mahja vel-memat, ve min fitnetil-mesihid-dedždžal)</span>. Nakon toga može se učiti bilo koja dova u kojoj se traži dobro ovoga i onoga svijeta.<br /> 22. Poslije se predaje selam na desnu stranu, riječima <span class="c2">(esselamu alejkum ve rahmetullah)</span>, a onda i na lijevu, na isti način.<br /> 23. Ako se radi o trorekatnom ili četverorekatnom namazu, tada se prilikom prvog tešehhuda zastaje na riječima <span class="c2">(ešhedu en la ilahe illallah ve ešhedu enne Muhammeden ‘abduhu ve resuluhu)</span>, odnosno, ne treba učiti salavate i dovu.<br /> 24. Potom se ustaje uz riječi <span class="c2">(Allahu ekber)</span>, pri čemu se dižu ruke naspram ramena.<br /> 25. Zatim se klanja ostatak namaza onako kako se klanjao i drugi rek\'at, osim što se uči samo Fatiha.<br /> 26. Poslije toga se sjedne na način koji se naziva teverruk, tj. sjedi se na lijevom stegnu, izbacivši lijevu potkoljenicu i stopalo ispod desnog buta.<br /> 27. Na ovom sjedenju uči se cijeli tešehhud, koji je već spomenut <span class="c2">(sa salavatima i dovom do predaje selama)</span>.<br /> 28. Poslije se predaje selam na desnu stranu, riječima <span class="c2">(esselamu alejkum ve rahmetullah)</span>, a onda i na lijevu, na isti način. </p>',
            ],
            25 => [
                'question' => 'Pitanje br. 26: Šta se izgovara i uči nakon predaje selama?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4610.mp3',
                'answer' => '<p> Odgovor: <span class="c2">(estagfirullah)</span> se izgovara tri puta.<br /> <span class="c2">(Allahumme entes-selamu ve minkes-selamu, tebarekte ja zel-dželali vel-ikram)</span>.<br /> <span class="c2">(La ilahe illellahu vahdehu la šerike leh, lehul-mulku velehul-hamdu ve huve \'ala kulli šej\'in kadir. Allahumme la mani’a lima e’atajte ve la mu’tije lima mena’te, ve la jenfe’u zel-džeddi minkel-džedd)</span>.<br /> <span class="c2">(La ilahe illellahu vahdehu la šerike leh, lehul-mulku ve lehul- hamdu ve huve’ ala kulli šej\'in kadir, la havle ve la kuvvete illa billahi, la ilahe illellahu, ve la na’ budu illa ijjahu, lehun-ni’metu ve lehul-fadlu ve lehus-senaul-hasen. La ilahe illellahu muhlisine lehud-dine ve lev kerihel-kafirun)</span>.<br /> Subhanallah - <span class="c2">(33x)</span>.<br /> El-hamdu lillah - <span class="c2">(33x)</span>.<br /> Allahu ekber - <span class="c2">(33x)</span>.<br /> Poslije ovoga,<span class="c6"> izgovara se:</span> <span class="c2">(La ilahe illellahu vahdehu la šerike leh, lehul-mulku ve lehul-hamdu ve huve ‘ala kulli šej\'in kadir)</span>.<br /> Pohvalno je proučiti po tri puta, nakon sabaha i akšama, a po jednom nakon ostalih namaza,<span class="c6"> sure:</span> El-Ihlas, El-Felek i En-Nas.<br /> Također, i ajetul-kursijj uči se jednom. </p>',
            ],
            26 => [
                'question' => 'Pitanje br. 27: Koji su to pritvrđeni sunneti i koja je njihova vrijednost?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4730.mp3',
                'answer' => '<p> Odgovor: - Dva rekata prije sabahskog farza.<br /> - Četiri rekata prije podnevskog farza.<br /> - Dva rekata poslije podnevskog farza.<br /> - Dva rekata poslije akšamskog farza.<br /> - Dva rekata poslije jacijskog farza.<br /> O vrijednosti ovih sunneta Poslanik, sallallahu alejhi ve sellem,<span class="c6"> veli:</span> "Uzvišeni Allah sagradit će kuću u Džennetu onome ko tokom dana i noći klanja dvanaest rekata dobrovoljnog namaza." Bilježe Muslim, Ahmed i drugi. </p>',
            ],
            27 => [
                'question' => 'Pitanje br. 28: Koji je najbolji dan u sedmici?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4800.mp3',
                'answer' => '<p> Odgovor: To je petak. Rekao je Vjerovjesnik,<span class="c6"> sallallahu alejhi ve sellem:</span> "Petak je jedan od najboljih dana: u njemu je stvoren Adem, u njemu je umro, u njemu će se puhnuti u Rog i u njemu će se desiti krik. Uslijed toga, petkom donosite što više salavata na mene, oni dopiru do mene.<span class="c6">" Prisutni upitaše:</span> \'\'Allahov Poslaniče, kako će naši salavati doprijeti do tebe kada će tvoje tijelo propasti, tj.<span class="c6"> istruhnuti?" On reče:</span> "Allah je zabranio zemlji da jede tijela vjerovjesnika." Hadis bilježi Ebu Davud i drugi. </p>',
            ],
            28 => [
                'question' => 'Pitanje br. 29: Koji je propis džuma-namaza?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4840.mp3',
                'answer' => '<p> Odgovor: Džuma namaz je farz \'ajn <span class="c2">(pojedinačna obaveza)</span> svakom muslimanu, muškarcu, punoljetnom, razumnom i onome ko nije putnik.<span class="c6"><br /> Uzvišeni Allah veli:</span> "O vjernici, kada se u petak na namaz pozove, kupoprodaju ostavite i pođite namaz obaviti; to vam je bolje, neka znate!" <span class="c2">(El-Džumu\'ah, 9)</span>. </p>',
            ],
            29 => [
                'question' => 'Pitanje br. 30: Koliko džuma ima rekata?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4880.mp3',
                'answer' => '<p> Odgovor: Džuma namaz ima dva rekata. Imam na ta dva rekata uči naglas, a prije toga održi se hutba iz dva dijela. </p>',
            ],
            30 => [
                'question' => 'Pitanje br. 31: Da li je dozvoljeno izostaviti džumu?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4910.mp3',
                'answer' => '<p> Odgovor: Džumu nije dozvoljeno izostavljati osim uz opravdan šerijatski razlog. Prenosi se da je Poslanik, sallallahu alejhi ve sellem,<span class="c6"> kazao:</span> "Allah će zapečatiti srce onome ko iz nemarnosti <span class="c2">(bez opravdanja)</span> ostavi tri džume." Bilježi Ebu Davud i drugi. </p>',
            ],
            31 => [
                'question' => 'Pitanje br. 32: Koji su džumanski sunneti?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4940.mp3',
                'answer' => '<p> Odgovor:<br /> 1. Kupanje.<br /> 2. Mirisanje.<br /> 3. Oblačenje lijepe odjeće.<br /> 4. Odlazak na džumu što ranije.<br /> 5. Donositi što više salavata na Poslanika, sallallahu alejhi ve sellem.<br /> 6. Učenje sure El-Kehf.<br /> 7. Odlazak u džamiju pješice.<br /> 8. Ulaganje truda kako bi se pronašao i iskoristio posebno preciziran period kada se prima dova. </p>',
            ],
            32 => [
                'question' => 'Pitanje br. 33: Spomeni vrijednost namaza u džematu?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5050.mp3',
                'answer' => '<p> Odgovor: Abdullah b. Omer prenosi da je Poslanik, sallallahu alejhi ve sellem,<span class="c6"> rekao:</span> "Namaz u džematu bolji je od pojedinačnog namaza za dvadeset i sedam stepeni." Hadis bilježi Muslim. </p>',
            ],
            33 => [
                'question' => 'Pitanje br. 34: Šta je to skrušenost u namazu?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5080.mp3',
                'answer' => '<p> Odgovor: To je srčana prisutnost i fizička smirenost.<span class="c6"><br /> Uzvišeni Allah veli:</span> "Ono što žele - vjernici će postići, oni koji molitvu svoju ponizno obavljaju." <span class="c2">(El-Mu\'minun, 1-2)</span>. </p>',
            ],
            34 => [
                'question' => 'Pitanje br. 35: Šta je to zekat?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5120.mp3',
                'answer' => '<p> Odgovor: Zekat je dio posebne vrste imetka koji se obavezno izdvaja definisanim skupinama u određeno vrijeme.<br /> Zekat je jedan od islamskih temelja i obavezno imovinsko izdvajanje, pri čemu se imetak uzima od bogatih i daje siromašnima.<span class="c6"><br /> Uzvišeni Allah veli:</span> "I zekat dajite." <span class="c2">(El-Bekare, 43)</span>. </p>',
            ],
            35 => [
                'question' => 'Pitanje br. 36: Šta je to pohvalna sadaka?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5170.mp3',
                'answer' => '<p> Odgovor: Sadaka je ono što nije zekat, poput davanja nečega u dobrotvorne svrhe, u bilo koje doba godina.<span class="c6"><br /> Uzvišeni Allah veli:</span> "I imetak na Allahovom putu žrtvujte." <span class="c2">(El-Bekare, 195)</span>. </p>',
            ],
            36 => [
                'question' => 'Pitanje br. 37: Šta je to post?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5210.mp3',
                'answer' => '<p> Odgovor: Način obožavanja Allaha na način da se donese namjera sudržavanja od svega što kvari post, od zore do akšama.<span class="c6"> Postoje dvije vrste posta:</span><br /> Obavezni post, poput posta ramazana koji je jedan od islamskih temelja.<span class="c6"><br /> Uzvišeni Allah veli:</span> "O vjernici! Propisuje vam se post, kao što je propisan onima prije vas, da biste se grijeha klonili." <span class="c2">(El-Bekare, 183)</span>.<br /> Dobrovoljni post poput posta ponedjeljkom i četvrtkom, post tri dana u svakom mjesecu, a najbolje je postiti "bijele dane", tj. 13., 14., i 15. dan svakog hidžretskog mjeseca. </p>',
            ],
            37 => [
                'question' => 'Pitanje br. 38: Koja je vrijednost posta mjeseca ramazana?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5270.mp3',
                'answer' => '<p> Odgovor: Prenosi se od Ebu Hurejre, r.a., da je Poslanik, sallallahu alejhi ve sellem,<span class="c6"> rekao:</span> „Ko provede ramazan u postu, sa imanom i nadajući se nagradi, biće mu oprošteni svi prijašnji grijesi." Muttefekun \'alejhi. </p>',
            ],
            38 => [
                'question' => 'Pitanje br. 39: Koja je vrijednost dobrovoljnog posta?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5300.mp3',
                'answer' => '<p> Odgovor: Prenosi se od Ebu Se\'ida El-Hudrija da je Poslanik, sallallahu alejhi ve sellem,<span class="c6"> rekao:</span> "Koji god Allahov rob posti jedan dan na Allahovom putu, Allah će ga zbog toga dana udaljiti od džehenemske vatre sedamdeset harifa <span class="c2">(godina)</span>." Muttefekun \'alejh.<br /> "Sedamdeset harifa" označava period od sedamdeset godina. </p>',
            ],
            39 => [
                'question' => 'Pitanje br. 40: Šta kvari post?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5330.mp3',
                'answer' => '<p> Odgovor: 1. Namjerno konzumiranje hrane i pića.<br /> 2. Namjerno povraćanje.<br /> 3. Odmetništvo od islama. </p>',
            ],
            40 => [
                'question' => 'Pitanje br. 41: Koji su sunneti posta?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5380.mp3',
                'answer' => '<p> Odgovor: 1. Požurivanje s iftarom.<br /> 2. Odgađanje sehura.<br /> 3. Što više činiti dobra djela i ibadeta.<br /> 4. Kada postača neko uvrijedi,<span class="c6"> treba da kaže:</span> Ja postim.<br /> 5. Dova prilikom iftara.<br /> 6. Prekidanje iftara datulama, a ako se ne nađu, onda vodom. </p>',
            ],
            41 => [
                'question' => 'Pitanje br. 42: Šta je to hadž?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5460.mp3',
                'answer' => '<p> Odgovor: Obožavanje Allaha na način da se ode u Mekku, kako bi se obavila propisana djela koja su definisana na poseban način i u tačno precizirano vrijeme.<span class="c6"><br /> Uzvišeni Allah veli:</span> "Hodočastiti Hram dužan je, Allaha radi, svaki onaj koji je u mogućnosti; a onaj koji neće da vjeruje – pa, zaista, Allah nije ovisan ni o kome." <span class="c2">(Ali \'Imran, 97)</span>. </p>',
            ],
            42 => [
                'question' => 'Pitanje br. 43: Koji su sastavni dijelovi (ruknovi) hadža?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5500.mp3',
                'answer' => '<p> Odgovor: 1. ihram.<br /> 2. boravak na Arefatu.<br /> 3. tavaful ifade.<br /> 4. kretanje između Safe i Merve. </p>',
            ],
            43 => [
                'question' => 'Pitanje br. 44: Koja je vrijednost hadža?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5560.mp3',
                'answer' => '<p> Odgovor: Ebu Hurejre prenosi da je Poslanik, sallallahu alejhi ve sellem,<span class="c6"> rekao:</span> "Ko obavi hadž, a ne bude nepristojne i ružne riječi govorio i ne bude kršio <span class="c2">(Allahove)</span> propise, vratit će se <span class="c2">(bez grijeha)</span> kao na dan kada ga je majka rodila." Zabilježili su ga Buhari i drugi.<br /> "kao na dan kada ga je majka rodila", tj. bez grijeha. </p>',
            ],
            44 => [
                'question' => 'Pitanje br. 45: Šta je to \'umra?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5600.mp3',
                'answer' => '<p> Odgovor: Obožavanje Allaha tako što se u bilo kom vremenskom periodu ode u Mekku, kako bi se obavila propisana djela koja su definisana na poseban način. </p>',
            ],
            45 => [
                'question' => 'Pitanje br. 46: Koji su to sastavni dijelovi (ruknovi) umre?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5630.mp3',
                'answer' => '<p> Odgovor: 1. ihram.<br /> 2. tavaf.<br /> 3. kretanje između Safe i Merve. </p>',
            ],
            46 => [
                'question' => 'Pitanje br. 47: Šta je to džihad na Allahovom putu?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5690.mp3',
                'answer' => '<p> Odgovor: Ulaganje truda u širenju islama, te odbrana kako islama, tako i njegovih sljedbenika, a isto tako i borba protiv neprijatelja islama i muslimana.<span class="c6"><br /> Uzvišeni Allah veli:</span> "Krećite u boj, bili slabi ili snažni, i borite se na Allahovu putu zalažući imetke svoje i živote svoje! To vam je, da znate, bolje!" <span class="c2">(Et-Tevba, 41)</span>. </p>',
            ],
        ],
        3 => [
            0 => [
                'question' => 'Pitanje br. 1: Koje je porijeklo našeg vjerovjesnika Muhammeda, sallallahu alejhi ve sellem?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5740.mp3',
                'answer' => '<p> Odgovor: On je Muhammed sin Abdullaha sin Abdul-Muttaliba sin Hašima. Hašim potiče iz Kurejša, a Kurejš je jedno od arapskih plemena. Arapi su potomci Ismaila, Ibrahimovog sina, neka je na njih i na našeg Vjerovjesnika mir Allahov i blagoslov. </p>',
            ],
            1 => [
                'question' => 'Pitanje br. 2: Kako se zvala majka našeg Vjerovjesnika, sallallahu alejhi ve sellem?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5770.mp3',
                'answer' => '<p> Odgovor: Amina, kćerka Vehba. </p>',
            ],
            2 => [
                'question' => 'Pitanje br. 3: Kada je umro otac Poslanika, sallallahu alejhi ve sellem?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5800.mp3',
                'answer' => '<p> Odgovor: Umro je u Medini dok je Muhammed, sallallahu alejhi ve sellem, bio još u stomaku svoje majke. </p>',
            ],
            3 => [
                'question' => 'Pitanje br. 4: Kada se rodio Vjerovjesnik, sallallahu alejhi ve sellem?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5830.mp3',
                'answer' => '<p> Odgovor: Rodio se u "Godini slona", u ponedjeljak, u mjesecu rebi\'ul-evvelu. </p>',
            ],
            4 => [
                'question' => 'Pitanje br. 5: Gdje se rodio?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5850.mp3',
                'answer' => '<p> Odgovor: U Mekki. </p>',
            ],
            5 => [
                'question' => 'Pitanje br. 6: Ko ga je, pored njegove majke dojio i o njemu brigu vodio?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5880.mp3',
                'answer' => '<p> Odgovor: - Ummu Ejmen, oslobođena ropkinja njegovog oca.<br /> - Suvejba, oslobođena ropkinja njegovog amidže Ebu Leheba.<br /> - Halima Es-Sa\'dijja. </p>',
            ],
            6 => [
                'question' => 'Pitanje br. 7: Kada mu je umrla majka?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5930.mp3',
                'answer' => '<p> Odgovor: Umrla je kada je on imao šest godina, a brigu o njemu preuzeo je tada njegov djed Abdul-Muttalib. </p>',
            ],
            7 => [
                'question' => 'Pitanje br. 8: Ko je preuzeo brigu o njemu nakon smrti djeda Abdul-Muttaliba?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5960.mp3',
                'answer' => '<p> Odgovor: Djed mu je umro kada je on imao osam godina, a poslije toga njegovo starateljstvo je preuzeo njegov amidža Ebu Talib. </p>',
            ],
            8 => [
                'question' => 'Pitanje br. 9: Kada je otputovao u Šam sa amidžom?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5990.mp3',
                'answer' => '<p> Odgovor: Otputovao je kada je imao dvanaest godina. </p>',
            ],
            9 => [
                'question' => 'Pitanje br. 10: Kada je drugi put išao u Šam?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6020.mp3',
                'answer' => '<p> Odgovor: Drugi put je putovao kada je imao 25 godina, s ciljem da trguje sa imetkom koji je Hatidža, r.a., poslala po njemu. Kada se vratio s tog putovanja, oženio je upravo Hatidžu. </p>',
            ],
            10 => [
                'question' => 'Pitanje br. 11: Kada su Kurejšije obnovile Ka\'bu?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6050.mp3',
                'answer' => '<p> Odgovor: To su uradili kada je Muhammed imao 35 godina.<br /> Tom prilikom oni su imali podijeljena mišljenja o tome ko će postaviti Crni kamen, pa su se obratili Poslaniku, sallallahu alejhi ve sellem, da im presudi. Tada je on stavio Crni kamen u jedan veo od tkanine, te je naredio da pripadnik svakog plemena, a bilo ih je četiri, uzme za vrh tkanine, te tako da podignu kamen. Kada su to uradili, on je lično preuzeo kamen i postavio ga na predviđeno mjesto. </p>',
            ],
            11 => [
                'question' => 'Pitanje br. 12: Koliko je imao godina kada je poslan i kome je poslan?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6080.mp3',
                'answer' => '<p> Odgovor: Imao je 40 godina kada je učinjen poslanikom, a poslan je svim ljudima, da donese radosne vijesti i da ih opomene. </p>',
            ],
            12 => [
                'question' => 'Pitanje br. 13: Čime je najprije otpočela objava?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6110.mp3',
                'answer' => '<p> Odgovor: To su bili istiniti snovi. Sve što bi u snu vidio, to bi mu se na javi poput jasne zore ostvarilo. </p>',
            ],
            13 => [
                'question' => 'Pitanje br. 14: Kakvo je bilo njegovo stanje prije objave i kada mu je prvi put stigla Objava?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6140.mp3',
                'answer' => '<p> Odgovor: Prije objave bi odlazio u pećinu Hira kako bi činio određeni vid obožavanja Allaha, a prije toga bi sa sobom ponio hrane i pića koja mu je bila potrebna za određeni period boravka u pećini.<br /> Objava mu je stigla dok je jedne prilike bio u pećini Hira. </p>',
            ],
            14 => [
                'question' => 'Pitanje br. 15: Šta je prvo objavljeno od Kur\'ana?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6180.mp3',
                'answer' => '<p> Odgovor: To su bile Allahove riječi: Čitaj, u ime Gospodara tvoga, koji stvara, stvara čovjeka od ugruška! Čitaj, plemenit je Gospodar tvoj, koji poučava peru, koji čovjeka poučava onome što ne zna. <span class="c2">(El-Alek, 1-5)</span>. </p>',
            ],
            15 => [
                'question' => 'Pitanje br. 16: Ko je prvi povjerovao u njegovo poslanstvo?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6200.mp3',
                'answer' => '<p> Odgovor: Od muškaraca Ebu Bekr Essidik, od žena Hatidža bint Huvejlid, od djece Alija ibn Ebi Talib, od oslobođenih robova Zejd b. Harise, a od robova Bilal el-Habeši, Allah bio zadovoljan svima njima. </p>',
            ],
            16 => [
                'question' => 'Pitanje br. 17: Kako je tekla misija pozivanja u islam?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6230.mp3',
                'answer' => '<p> Odgovor: Tri godine misija se odvijala u tajnosti, a poslije je Poslaniku, sallallahu alejhi ve sellem, naređeno da javno poziva. </p>',
            ],
            17 => [
                'question' => 'Pitanje br. 18: Kakvo je bilo stanje Poslanika, sallallahu alejhi ve sellem, i onih koji su povjerovali nakon što je počelo javno pozivanje u islam?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6260.mp3',
                'answer' => '<p> Odgovor: Mnogobošci su prelazili svaku mjeru u uznemiravanju njega i ostalih muslimana. To je bio razlog da im se dozvoli preseljenje u Abesiniju gdje je Nedžašija bio vladar.<br /> Mnogobošci su bili složni u svojoj namjeri da uznemiravaju Poslanika, sallallahu alejhi ve sellem, i da ga ubiju, ali ga je Uzvišeni Allah zaštitio preko njegovog amidže Ebu Taliba. </p>',
            ],
            18 => [
                'question' => 'Pitanje br. 19: Ko je umro desete godine po poslanstvu?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6300.mp3',
                'answer' => '<p> Odgovor: Poslanikov amidža Ebu Talib, i Poslanikova supruga Hatidža, radijallahu \'anha. </p>',
            ],
            19 => [
                'question' => 'Pitanje br. 20: Kada se desio Isra (noćno putovanje u Jerusalim) i Mi\'radž (uzdignuće na nebo)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6330.mp3',
                'answer' => '<p> Odgovor: To se desilo kada je Poslanik, sallallahu alejhi ve sellem, imao pedeset godina. Tada mu je propisano pet obaveznih namaza.<span class="c6"><br /> Isra:</span> to je noćno putovanje iz Svetog hrama u Meki u Daleki hram <span class="c2">(mesdžidul Aksa)</span> u Kudsu.<br /> Mi\'radž je uzdignuće iz Dalekog hrama u Kudsu u nebeske sfere, sve do Sidretul-munteha. </p>',
            ],
            20 => [
                'question' => 'Pitanje br. 21: Kako je Poslanik, sallallahu alejhi ve sellem, pozivao ljude izvan Meke?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6380.mp3',
                'answer' => '<p> Odgovor: Pozivao je stanovnike Taifa, odlazio bi tamo gdje se ljudi okupljaju. Desilo se tako, jednom prilikom, da stigne jedna grupa ensarija iz Medine koji su povjerovali u njega, te mu dali prisegu da će ga pomagati. </p>',
            ],
            21 => [
                'question' => 'Pitanje br. 22: Koliko je trajala poslanička misija u Mekki?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6410.mp3',
                'answer' => '<p> Odgovor: Trinaest godina. </p>',
            ],
            22 => [
                'question' => 'Pitanje br. 23: Gdje se odselio Poslanik, sallallahu alejhi ve sellem?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6440.mp3',
                'answer' => '<p> Odgovor: U Medinu. </p>',
            ],
            23 => [
                'question' => 'Pitanje br. 24: Koliko je boravio u Medini?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6470.mp3',
                'answer' => '<p> Odgovor: Deset godina. </p>',
            ],
            24 => [
                'question' => 'Pitanje br. 25: Šta mu je od islamskih propisa objavljeno u Medini?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6490.mp3',
                'answer' => '<p> Odgovor: Zekat, post, hadž, džihad, ezan, a i neki drugi propisi. </p>',
            ],
            25 => [
                'question' => 'Potanje br. 26: Koje su najvažnije bitke Poslanika, sallallahu alejhi ve sellem?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6520.mp3',
                'answer' => '<p> Odgovor: Velika bitka na Bedru.<br /> Bitka na Uhudu.<br /> Bitka na Hendeku <span class="c2">(saveznici, ahzab)</span>.<br /> Oslobođenje Mekke. </p>',
            ],
            26 => [
                'question' => 'Pitanje br. 27: Šta je posljednje što je objavljeno od Kur\'ana?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6580.mp3',
                'answer' => '<p> Odgovor: To su bile Allahove riječi: "I bojte se Dana kada ćete se svi Allahu vratiti, kada će se svakome ono što je zaslužio isplatiti - nikome krivo neće učinjeno biti." <span class="c2">(El-Bekare, 281)</span>. </p>',
            ],
            27 => [
                'question' => 'Pitanje br. 28: Kada je Poslanik, sallallahu alejhi ve sellem, preselio na onaj svijet i koliko mu je tada bilo godina?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6610.mp3',
                'answer' => '<p> Odgovor: Preselio je u mjesecu rebi\'ul-evvelu, 11. godine po Hidžri, a imao je 63 godine. </p>',
            ],
            28 => [
                'question' => 'Pitanje br. 29: Spomeni supruge Allahovog poslanika, sallallahu alejhi ve sellem!',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6640.mp3',
                'answer' => '<p> Odgovor: 1. Hatidža bint Huvejlid.<br /> 2. Sevda bint Zem\'ah.<br /> 3. Aiša bint ebi Bekr Es-Siddik.<br /> 4. Hafsa bint Omer.<br /> 5. Zejneb bint Huzejme.<br /> 6. Ummu Seleme Hind bint ebi Umejje.<br /> 7. Umu Habiba Remla bint ebi Sufjan.<br /> 8. Džuvejrija bint El-Haris.<br /> 9. Mejmuna bint El-Haris.<br /> 10. Safijja bint Hujejj.<br /> 11. Zejneb bint Džahš. </p>',
            ],
            29 => [
                'question' => 'Pitanje br. 30: Ko su bila djeca Allahovog poslanika, sallallahu alejhi ve sellem?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6760.mp3',
                'answer' => '<p> Odgovor: Troje muških:<br /> El-Kasim, i po njemu je bio dozivan <span class="c2">(Ebu-Kasim)</span>.<br /> Abdullah.<br /> Ibrahim.<span class="c6"><br /> Ženska djeca su:</span><br /> Fatima.<br /> Rukajja.<br /> Ummu Kulsum.<br /> Zejneb.<br /> Svu djecu je dobio sa Hatidžom osim Ibrahima i svi su umrli za vrijeme njegovog života, osim Fatime koja je umrla pola godine nakon Poslanika, sallallahu alejhi ve sellem. </p>',
            ],
            30 => [
                'question' => 'Pitanje br. 31: Spomeni neke karakteristike Poslanika, sallallahu alejhi ve sellem!',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6880.mp3',
                'answer' => '<p> Odgovor: Nije bio previše visok, niti previše nizak. Bio je bijele <span class="c2">(svijetle)</span> puti. Imao je gustu bradu, široke oči i veoma lijepo izgrađena usta. Kosa mu je bila veoma crna, imao je široka ramena, lijepo je mirisao i tako dalje. </p>',
            ],
            31 => [
                'question' => 'Pitanje br. 31: U kakvom je stanju Poslanik, sallallahu alejhi ve sellem, ostavio svoj ummet?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6910.mp3',
                'answer' => '<p> Odgovor: Ostavio ih je na jasnoj stazi, na stazi čija je noć jasna kao i dan. To je staza sa koje može skrenuti samo onaj koga definitivno čeka propast. Nije ostavio nijedno dobro, a da na njega nije ukazao, niti je izostavio ikakvo zlo, a da na njega nije upozorio. </p>',
            ],
        ],
        4 => [
            0 => [
                'question' => 'Pitanje br. 1: Prouči suru Fatihu i navedi njeno tumačenje!',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6960.mp3',
                'answer' => '<p> Odgovor: Sura Fatiha glasi:<br /> Bismillahir-rahmanir-rahim/U ime Allaha, Milostivog, Samilosnog. Elhamdulillahi Rabbil-\'alemin/Svaka hvala neka je Allahu, Gospodaru svjetova. Er-rahmanir-rahim/Svemilosnom, Milostivom. Maliki jeumid-din/Vladaru Dana sudnjeg. Ijjake na\'budu ve ijjake nesta\'in/Samo Tebi ibadet činimo i samo od Tebe pomoć molimo. Ihdinas-siratal-mustekim/Uputi nas na Pravi put. Siratallezine en\'amte \'alejhim, gajril-magdubi \'alejhim veled-dallin/Na put onih kojima si blagodati podario. A ne na put onih na koje se srdžba izlila, niti na put onih koji su zalutali. <span class="c2">(El-Fatiha, 1-7)</span>.<span class="c6"><br /> Komentar:</span><br /> Sura Fatiha nazvana je ovim imenom jer Allahova Knjiga sa njome otpočinje.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001001.mp3"></audio> Bismillahir-rahmanir-rahim/U ime Allaha, Milostivog,<span class="c6"> Samilosnog:</span> U ime Allaha otpočinjem učenje Kur\'ana, tražeći Njegovu pomoć i težeći blagoslovu putem izgovaranja Njegovog imena.<span class="c6"><br /> Allah:</span> Istinski Bog, niko ne nosi ovo ime osim Njega.<br /> Er-<span class="c6">Rahman:</span> Posjednik ogromne milosti koja obuhvata sve.<br /> Er-<span class="c6">Rahim:</span> Posjednik milosti koja se odnosi samo na vjernike.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001002.mp3"></audio> Elhamdulillahi Rabbil-\'alemin/Svaka hvala neka je Allahu,<span class="c6"> Gospodaru svjetova:</span> Sve vrste hvale, pohvale i savršenosti pripadaju samo Allahu Jedinom.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001003.mp3"></audio> Er-rahmanir-rahim/Svemilosnom,<span class="c6"> Milostivom:</span> Posjednik ogromne milosti koja obuhvata sve i posebne milosti koja obuhvata samo vjernike.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001004.mp3"></audio> Maliki jeumid-<span class="c6">din/Vladaru Dana sudnjeg:</span> On je Vlasnik i Upravitelj na Sudnjemu danu.<span class="c6"><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001005.mp3"></audio> Ijjake na\'budu ve ijjake neste\'in/Samo Tebi ibadet činimo i samo od Tebe pomoć molimo:</span> Mi samo Tebe obožavamo i nikoga više, i samo se Tebi obraćamo za pomoć.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001006.mp3"></audio> Ihdinas-siratal-<span class="c6">mustekim/Uputi nas na Pravi put:</span> To je put koji vodi islamu i sunnetu <span class="c2">(praksi Poslanika)</span>.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001007.mp3"></audio> Siratallezine en\'amte \'alejhim, gajril-magdubi \'alejhim veled-dallin/Na put onih kojima si blagodati podario. A ne na put onih na koje se srdžba izlila,<span class="c6"> niti na put onih koji su zalutali:</span> Put dobrih Allahovih robova, vjerovjesnika i njihovih sljedbenika, a ne put kršćana i Jevreja.<span class="c6"><br /> Sunnet je da se nakon učenja Fatihe izgovori:</span> Amin/Allahu, primi od nas! </p>',
            ],
            1 => [
                'question' => 'Pitanje br. 2: Prouči suru Ez-Zelzele i protumači je!',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7130.mp3',
                'answer' => '<p> Odgovor: Sura Ez-<span class="c6">Zelzele i njeno tumačenje:</span><br /> U ime Allaha, Milostivog, Samilosnog!<br /> Kada se Zemlja najžešćim potresom svojim potrese i kada Zemlja izbaci terete svoje,<span class="c6"> i čovjek uzvikne:</span> "Šta joj je?!" - toga Dana će ona vijesti svoje kazivati jer će joj Gospodar tvoj narediti. Tog Dana će se ljudi odvojeno pojaviti da im se pokažu djela njihova; onaj ko bude uradio koliko trun dobra - vidjeće ga, a onaj ko bude uradio i koliko trun zla - vidjet će ga. <span class="c2">(Ez-Zelzele, 1-8)</span>.<span class="c6"><br /> Komentar:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099001.mp3"></audio> 1. Kada se Zemlja snažno potrese nakon čega će uslijediti Smak svijeta,<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099002.mp3"></audio> 2. i kada Zemlja izbaci sve ono što se u njenoj unutrini nalazi, poput mrtvaca i drugoga,<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099003.mp3"></audio> 3. i kada čovjek, veoma zbunjeno,<span class="c6"> uzvikne i upita se:</span> "Šta je ovoj Zemlji i zbog čega se ovoliko trese?"<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099004.mp3"></audio> 4. Toga velikoga dana ona će kazivati o dobru i zlu koji su na njoj činjeni,<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099005.mp3"></audio> 5. a to će Zemlja učiniti jer će joj njen Gospodar tako odrediti i narediti.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099006.mp3"></audio> 6. Toga velikoga dana u kojem će se Zemlja potresti, ljudi će iz nje odvojeno izaći kako bi račun polagali i kako bi im bila pokazana njihova djela koja su činili na dunjaluku.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099007.mp3"></audio> 7. Onaj ko uradi dobro djelo pa makar bilo koliko mali mrav, vidjeće ga pred sobom.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099008.mp3"></audio> 8. A onaj ko uradi zlo, pa makar bilo i najmanje, također će ga vidjeti pred sobom. </p>',
            ],
            2 => [
                'question' => 'Pitanje br. 3: Prouči suru El-Adijat i protumači je!',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7270.mp3',
                'answer' => '<p> Odgovor: Sura El-<span class="c6">Adijat i njen komentar:</span><br /> U ime Allaha, Milostivog, Samilosnog!<br /> Tako mi onih koji dahćući jure pa varnice vrcaju, i zorom napadaju, i dižu tada prašinu pa u njoj u gomilu upadaju - čovjek je, zaista, Gospodaru svome nezahvalan i sam je on toga, doista, svjestan, i on je, zbilja, u ljubavi za dobrima dunjalučkim žestok. A zar on ne zna da će, kada budu oživljeni oni koji su u grobovima i kada iziđe na vidjelo ono što je u srcima, Gospodar njihov toga Dana, sigurno, sve znati o njima. <span class="c2">(El-Adijat, 1-11)</span>.<span class="c6"><br /> Komentar:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100001.mp3"></audio> Allah se kune konjima koji trče pa se čuje njihov glas i disanje zbog silnog trčanja.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100002.mp3"></audio> I kune se konjima koji trčeći snažno po kamenju prave varnice svojim kopitama.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100003.mp3"></audio> I kune se konjima koji rano jutrom napadaju neprijatelja.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100004.mp3"></audio> I svojim trčanjem pokreću i dižu prašinu.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100005.mp3"></audio> Pa u sredinu gomile nevjernika upadaju sa svojim konjanicima.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100006.mp3"></audio> Doista čovjek svojom nezahvalnošću sprječava dobro koje od Njega Gospodar želi.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100007.mp3"></audio> On je svjedok toga što radi, što nikako ne može da zanegira,<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100008.mp3"></audio> On je, uistinu, jako škrt uslijed silne ljubavi prema imetku.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100009.mp3"></audio> A zar ovaj čovjek koji je obmanut dunjalučkim životom ne zna da, kada kaburovi budu prevrnuti i kada Allah iz njih proživi ljude radi obračuna, stanje neće biti onako kako je zamišljao,<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100010.mp3"></audio> i kada budu ispoljene namjere i uvjerenja koja su bila skrivena u srcima.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100011.mp3"></audio> Toga Dana Allah će o svemu biti obaviješten, jer Njemu ništa nije skriveno i On će ih za njihove postupke obračunati onako kako su zaslužili. </p>',
            ],
            3 => [
                'question' => 'Pitanje br. 4: Prouči suru El-Kari\'ah i protumači je!',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7450.mp3',
                'answer' => '<p> Sura El-<span class="c6">Kari\'ah i njen komentar:</span><br /> U ime Allaha, Milostivog, Samilosnog!<br /> Udar zastrašujući! Šta je Udar zastrašujući? I šta ti znaš šta je Udar zastrašujući? Dan taj ljudi će biti kao leptiri raštrkani, a planine kao šarena vuna raščupana. Onaj čija dobra djela budu teška, u ugodnom životu će živjeti, a onaj čija dobra djela budu lahka, majka – utočište će mu bezdan biti. A znaš li ti šta će to biti? Vatra užarena! <span class="c2">(El-Kari\'ah, 1-11)</span>.<span class="c6"><br /> Komentar:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101001.mp3"></audio> Čas kada će srca biti potresena zbog velikih strahota.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101002.mp3"></audio> Koji je to Čas kada će srca biti potresena zbog velikih strahota?<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101003.mp3"></audio> I šta ti znaš, o Poslaniče, šta je taj čas kada će srca biti potresena zbog velikih strahota? To je Smak svijeta.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101004.mp3"></audio> Toga dana kada srca ljudska zbog strahote budu potresena, ljudi će biti poput leptirova, na sve strane raštrkani.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101005.mp3"></audio> Brda će biti poput vune raščupane lahka i pomjerat će se veoma jednostavno.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101006.mp3"></audio> Onaj čija dobra djela prevagnu u odnosu na loša,<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101007.mp3"></audio> on će živjeti ugodno u Džennetu.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101008.mp3"></audio> A onaj čija loša djela prevagnu u odnosu na dobra,<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101009.mp3"></audio> njegovo prebivalište na Sudnjem danu biće Džehennem.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101010.mp3"></audio> A znaš li, o Poslaniče, šta je to?<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101011.mp3"></audio> To je vatra čija je vrelina veoma žestoka. </p>',
            ],
            4 => [
                'question' => 'Pitanje br. 5: Prouči suru Et-Tekasur i protumači je!',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7610.mp3',
                'answer' => '<p> Sura Et-<span class="c6">Tekasur i njen komentar:</span><br /> U ime Allaha, Milostivog, Samilosnog!<br /> Zaokuplja vas nastojanje da što imućniji budete sve dok grobove ne naselite. A ne valja tako, saznaćete svakako! i još jednom, ne valja tako! Saznaćete sigurno! Ne valja tako, neka znate pouzdano, Džehennem ćete vidjeti jasno! I još jednom, doista ćete ga vidjeti očigledno! Zatim ćete toga dana za sladak život biti pitani sigurno! <span class="c2">(Et-Tekasur, 1-8)</span>.<span class="c6"><br /> Komentar:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102001.mp3"></audio> O ljudi, vas je od pokornosti Allahu zaokupilo nastojanje da što imućniji budete i da se hvališete vašim imetkom i djecom.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102002.mp3"></audio> sve dok ne umrete i ne uđete u kaburove.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102003.mp3"></audio> A ne treba da vas to zaokuplja od pokornosti Allahu, a saznat ćete koji je rezultat svega toga.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102004.mp3"></audio> Zatim, saznat ćete sigurno rezultat i posljedice toga.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102005.mp3"></audio> Doista, kada biste bili uvjereni da će vas Allah proživjeti i za vaša djela adekvatno tretirati, ne bi vas zaokupilo hvalisanje imetkom i djecom.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102006.mp3"></audio> Tako mi Allaha, vidjet ćete Vatru na Sudnjem danu.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102007.mp3"></audio> I još jednom, sasvim sigurno ćete ju vidjeti, bez imalo sumnje.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102008.mp3"></audio> Toga dana Allah će vas pitati o vašim blagodatima, kao što su zdravlje, bogatstvo i slično tome. </p>',
            ],
            5 => [
                'question' => 'Pitanje br. 6: Prouči suru El-Asr i protumači je!',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7750.mp3',
                'answer' => '<p> Odgovor: Sura El-<span class="c6">Asr i njeno tumačenje:</span><br /> U ime Allaha, Milostivog, Samilosnog!<br /> Tako mi vremena - čovjek, doista, gubi, samo ne oni koji vjeruju i dobra djela čine, i koji jedni drugima istinu preporučuju i koji jedni drugima preporučuju strpljenje. Sura El-Asr, 1-3.<span class="c6"><br /> Komentar:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/103001.mp3"></audio> Allah se kune vremenom.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/103002.mp3"></audio> Doista je čovjek u propasti i gubitku.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/103003.mp3"></audio> Samo nisu oni koji vjeruju u Allaha i dobra djela čine, i koji jedni drugima istinu preporučuju i jedni drugima preporučuju strpljenje. Oni koji imaju spomenuta svojstva uspjet će i na ovome i na onome svijetu. </p>',
            ],
            6 => [
                'question' => 'Pitanje br. 7: Prouči suru El-Humeze i protumači je!',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7830.mp3',
                'answer' => '<p> Odgovor: Sura El-<span class="c6">Humeze i njen komentar:</span><br /> U ime Allaha, Milostivog, Samilosnog!<br /> Teško svakom klevetniku podrugljivcu, koji blago gomila i prebrojava ga, i misli da će ga blago njegovo besmrtnim učiniti. A ne treba tako! On će, sigurno, biti bačen u Hutamu! A znaš li ti šta je Hutama? Vatra Allahova razbuktala, koja će do srca dopirati. Ona će nad njima biti zatvorena plamenim izduženim stubovima. <span class="c2">(Sura El-Humeze, 1-9)</span>.<span class="c6"><br /> Komentar:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104001.mp3"></audio> Teška prijetnja i kazna čeka onoga koji ljude ogovara i vrijeđa ih.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104002.mp3"></audio> To je onaj čija je briga kako će skupiti imetak i brojati ga, te nema druge brige i težnje osim toga.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104003.mp3"></audio> Usto, on smatra da će ga imetak koji skuplja sačuvati smrti i učiniti vječnim na ovome svijetu.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104004.mp3"></audio> A ne treba tako da misli taj neznalica, jer se to neće desiti! On će, sigurno, biti bačen u vatru džehennemsku koja će progutati sve što u nju dospije.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104005.mp3"></audio> A znaš li ti, o Poslaniče, šta je to Hutama, ili vatra koja će gutati sve što u nju bude bačeno.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104006.mp3"></audio> Uistinu, to je Allahova razbuktala vatra<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104007.mp3"></audio> koja će kroz tijela ljudi prolaziti i do njihovih srca dopirati.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104008.mp3"></audio> Iznad onih koji budu vatrom kažnjavani biće zatvoreno, te će ih vatra prekrivati<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104009.mp3"></audio> dugim stubovima kako ne bi mogli iz nje izaći. </p>',
            ],
            7 => [
                'question' => 'Pitanje br. 8: Prouči suru El-Fil i protumači je!',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7970.mp3',
                'answer' => '<p> Odgovor: Sura El-<span class="c6">Fil i njen komentar:</span><br /> U ime Allaha, Milostivog, Samilosnog!<br /> Zar nisi čuo šta je s vlasnicima slona Gospodar tvoj uradio? Zar lukavstvo njihovo nije upropastio i na njih jata ptica poslao, koje su na njih grumenje od gline pečene bacale, pa ih kao izjedeno lišće učinio? <span class="c2">(Sura El-Fil, 1-5)</span>.<span class="c6"><br /> Komentar:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105001.mp3"></audio> Zar nisi čuo, o Poslaniče, šta je s Ebrehom i njegovim drugovima, vlasnicima slona, Gospodar tvoj uradio, kada je on htio Kabu da sruši?<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105002.mp3"></audio> Njihove planove rušenja Kabe Allah je uništio, te nisu ostvarili svoj cilj da ljude od nje odvrate, niti su bilo šta drugo ostvarili.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105003.mp3"></audio> On je na njih poslao ptice u skupinama i jatima,<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105004.mp3"></audio> koje su na njih kamenje od pečene i tvrde gline bacali,<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105005.mp3"></audio> pa ih je On kao lišće koje su životinje pojele učinio. </p>',
            ],
            8 => [
                'question' => 'Pitanje br. 9: Prouči suru Kurejš i protumači je!',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8070.mp3',
                'answer' => '<p> Odgovor: Sura Kurejš i njen komentar:<br /> U ime Allaha, Milostivog, Samilosnog!<br /> Zbog navike Kurejšija, navike njihove da zimi i ljeti putuju, neka oni Gospodaru ove Kuće ibadet čine, koji ih gladne hrani i od straha brani. Kurejš, 1-4.<span class="c6"><br /> Komentar:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106001.mp3"></audio> Zbog navike i običaja Kurejšija,<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106002.mp3"></audio> navike da sigurni zimi putuju u Jemen, a ljeti u Šam.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106003.mp3"></audio> Neka obožavaju samo Gospodara ovog svetog hrama koji im je olakšao to putovanje i neka Mu nikoga kao sudruga ne pripisuju.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106004.mp3"></audio> On ih gladne hrani i od straha brani, tako što je u srcima ljudi <span class="c2">(arapa)</span> dao da poštuju harem i njegove stanovnike. </p>',
            ],
            9 => [
                'question' => 'Pitanje br. 10: Prouči suru El-Ma\'un i protumači je!',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8160.mp3',
                'answer' => '<p> Odgovor: Sura El-<span class="c6">Ma\'un i njen komentar:</span><br /> U ime Allaha, Milostivog, Samilosnog!<br /> Znaš li ti onoga koji onaj svijet poriče? Pa to je onaj koji grubo odbija siroče, i koji da se nahrani siromah - ne podstiče. A teško onima koji, kada namaz obavljaju, namaz svoj kako treba ne izvršavaju, koji se samo pretvaraju i nikome ništa ni u naručje ne daju! <span class="c2">(El-Ma\'un, 1-7)</span>.<span class="c6"><br /> Komentar:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107001.mp3"></audio> Šta znaš o onome koji negira Sudnji dan, kada će ljudi imati svoj obračun?<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107002.mp3"></audio> To je onaj ko na grub način odbija da udovolji potrebi siročeta.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107003.mp3"></audio> Ni sebe, a ni druge ne podstiče na davanje hrane siromasima.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107004.mp3"></audio> Propast i patnja čekaju one koji namaz obavljaju,<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107005.mp3"></audio> ali su prema njemu sasvim nemarni, te ga odgađaju izvan njegovog vremena.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107006.mp3"></audio> Oni se u svojim namazima i drugim djelima pred ljudima pretvaraju, tj. nisu iskreni u tome.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107007.mp3"></audio> I ne pomažu drugima tako što će im priuštiti nešto sasvim neznatno. </p>',
            ],
            10 => [
                'question' => 'Pitanje br. 11: Prouči suru El-Kevser i protumači je!',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8280.mp3',
                'answer' => '<p> Odgovor: Sura El-<span class="c6">Kevser i njeno tumačenje:</span><br /> U ime Allaha, Milostivog, Samilosnog!<br /> Mi smo ti, uistinu, Kevser dali, zato se Gospodaru svome klanjaj i kurban kolji, onaj koji tebe mrzi sigurno će on bez spomena ostati. El-Kevser, 1-3.<span class="c6"><br /> Komentar:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/108001.mp3"></audio> Mi smo ti, o Poslaniče, dali mnogo dobro, a u njega se ubraja i rijeka Kevser u Džennetu.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/108002.mp3"></audio> Budi zahvalan na tim blagodatima, klanjajući se samo Njemu i prinoseći Mu žrtvu, za razliku od mušrika koji su žrtve prinosili svojim kipovima.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/108003.mp3"></audio> Onaj ko tebe mrzi uskraćen je svakog dobra, biće bez spomena, a i ako se spomene, biće spomenut po zlu. </p>',
            ],
            11 => [
                'question' => 'Pitanje br. 12: Prouči suru El-Kafirun i protumači je!',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8360.mp3',
                'answer' => '<p> Sura El-<span class="c6">Kafirun i njeno tumačenje:</span><br /> U ime Allaha, Milostivog,<span class="c6"> Samilosnog!<br /> Reci:</span> <span class="c1">“O vi nevjernici, ja ne obožavam ono što vi obožavate, niti ste vi obožavaoci Onoga Koga ja obožavam, niti sam ja obožavalac onoga što vi obožavate, niti ste vi obožavaoci Onoga Koga ja obožavam, vama vaša vjera, a meni moja.”</span> <span class="c2">(El-Kafirun, 1-6)</span><br /> Komentar:<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109001.mp3"></audio> Reci,<span class="c6"> o Poslaniče:</span> O vi koji ne vjerujete u Allaha.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109002.mp3"></audio> Ja ni sada, a ni u budućnosti neću obožavati kipove koje vi obožavate,<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109003.mp3"></audio> a nećete ni vi obožavati onoga koga ja obožavam, tj. samo Allaha jedinog.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109004.mp3"></audio> Niti sam ja obožavalac kipova koje vi obožavate,<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109005.mp3"></audio> a ni vi ne obožavate onoga koga ja obožavam, tj. samo Allaha jedinog.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109006.mp3"></audio> Vama vaša vjera koju ste sami izmislili, a meni moja koju mi je Allah objavio. </p>',
            ],
            12 => [
                'question' => 'Pitanje br. 13: Prouči suru En-Nasr i protumači je!',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8470.mp3',
                'answer' => '<p> Sura En-<span class="c6">Nasr i njeno tumačenje:</span><br /> U ime Allaha, Milostivog, Samilosnog!<br /> Kada Allahova pomoć i pobjeda dođu, i vidiš ljude kako u skupinama u Allahovu vjeru ulaze – ti veličaj Gospodara svoga hvaleći Ga i moli Ga da ti oprosti, On je uvijek pokajanje primao. <span class="c2">(En-Nasr, 1-3)</span>.<span class="c6"><br /> Komentar:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/110001.mp3"></audio> Kada Allah pomogne tvoju vjeru, o Poslaniče, i kada je ojača i kada se Mekka oslobodi,<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/110002.mp3"></audio> te kada vidiš da ljudi prihvataju islam masovno u grupama, jedni nakon drugih -<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/110003.mp3"></audio> znaj da to ukazuje da je tvoj zadatak zbog kojeg te je Allah poslao pri kraju, pa slavi svoga Gospodara, zahvali Mu na blagodati pomoći i pobjede i traži oprost, jer On, uistinu, prima pokajanje od Svojih robova i prašta im. </p>',
            ],
            13 => [
                'question' => 'Pitanje br. 14: Prouči suru El-Mesed i protumači je!',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8550.mp3',
                'answer' => '<p> Odgovor: Sura El-<span class="c6">Mesed i njeno tumačenje:</span><br /> U ime Allaha, Milostivog, Samilosnog!<br /> Neka propadne Ebu Leheb, i propao je! neće mu biti od koristi blago njegovo, a ni ono što je stekao, ući će on, sigurno, u vatru rasplamsalu, i žena njegova, koja spletkari; o vratu njenu biće uže od ličine usukane! <span class="c2">(El-Mesed, 1-5)</span>.<span class="c6"><br /> Komentar:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111001.mp3"></audio> Neka propadnu ruke Ebu Leheba, amidže Poslanika, sallallahu alejhi ve sellem, sina Abdul-Muttaliba. I propao je zbog svojih postupaka budući da je uznemiravao Poslanika, sallallahu alejhi ve sellem.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111002.mp3"></audio> Šta će mu koristiti njegov imetak i djeca? Neće ga sačuvati kazne, niti će mu donijeti milost.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111003.mp3"></audio> Na sudnjem danu ući će u vatru rasplamsalu i osjetiti njenu vrelinu.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111004.mp3"></audio> U Vatru će ući i njegova žena Ummu Džemil koja je uznemiravala Poslanika, sallallahu alejhi ve sellem, bacajući trnje po putu kojim je išao.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111005.mp3"></audio> Na vratu njenom biće uže kojim će biti vođena u Vatru. </p>',
            ],
            14 => [
                'question' => 'Pitanje br. 15: Prouči suru El-Ihlas i protumači je!',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8650.mp3',
                'answer' => '<p> Odgovor: Sura El-<span class="c6">Ihlas i njen komentar:</span><br /> U ime Allaha, Milostivog,<span class="c6"> Samilosnog!<br /> Reci:</span> "On je Allah - Jedan! Allah je Utočište svakom! Nije rodio i rođen nije, i niko Mu ravan nije!" El-Ihlas, 1-4.<span class="c6"><br /> Komentar:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112001.mp3"></audio> Reci,<span class="c6"> o Poslaniče:</span> Allah je jedinstven u božanskim osobinama i On je jedini Bog.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112002.mp3"></audio> On je Gospodar kojem sva stvorenja teže i kod Njega utočište traže.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112003.mp3"></audio> Onaj koji nikog nije rodio, niti je Njega iko rodio. On Uzvišeni nema ni djeteta niti roditelja.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112004.mp3"></audio> Njemu niko od stvorenja nije sličan. </p>',
            ],
            15 => [
                'question' => 'Pitanje br. 16: Prouči suru El-Felek i protumači je!',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8750.mp3',
                'answer' => '<p> Odgovor: Sura El-<span class="c6">Felek i njen komentar:</span><br /> U ime Allaha, Milostivog,<span class="c6"> Samilosnog!<br /> Reci:</span> "Utječem se Gospodaru svitanja, od zla onoga što On stvara. i od zla mrkle noći kada razastre tmine, i od zla smutljivca kad smutnje sije, i od zla zavidljivca kad zavist ne krije!" El-Felek, 1-5.<span class="c6"><br /> Komentar:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113001.mp3"></audio> O Poslaniče,<span class="c6"> reci:</span> Tražim zaštitu kod Gospodara jutra.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113002.mp3"></audio> od zla kojeg čine stvorenja i od njihovih uznemiravanja.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113003.mp3"></audio> Pored toga, kod Allaha tražim spas od zla koje se pojavljuje noću poput životinja i lopova.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113004.mp3"></audio> I kod njega tražim spas od sihirbazica koje pušu u čvorove.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113005.mp3"></audio> I kod Njega tražim spas od zla zavidnika koji mrzi ljude zbog onoga što im je Allah dao od blagodati, želeći da ih izgube i da ih zlo zadesi. </p>',
            ],
            16 => [
                'question' => 'Pitanje br. 17: Prouči suru En-Nas i protumači je!',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8870.mp3',
                'answer' => '<p> Odgovor: Sura En-<span class="c6">Nas i njeno tumačenje:</span><br /> U ime Allaha, Milostivog,<span class="c6"> Samilosnog!<br /> Reci:</span> "Tražim zaštitu Gospodara ljudi, Vladara ljudi, Boga ljudi, od zla šejtana napasnika, koji zle misli unosi u srca ljudi - od džina i od ljudi!" En-Nas, 1-6.<span class="c6"><br /> Komentar:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114001.mp3"></audio> O Poslaniče,<span class="c6"> reci:</span> Tražim zaštitu kod Gospodara ljudi i Njemu se utječem.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114002.mp3"></audio> Vladaru ljudi koji čini s njima šta hoće i pored kojeg niko nema vlasti.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114003.mp3"></audio> Onome koji zaslužuje da se istinski obožava, pored kojeg niko drugi to ne zaslužuje.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114004.mp3"></audio> Od zla šejtana koji čovjeku donosi ružne misli kada čovjek zaboravi na Allaha, a kada Ga se sjeti, šejtan se sakrije i ne pojavljuje se.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114005.mp3"></audio> Taj šejtan unosi zle misli u ljudska srca,<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114006.mp3"></audio> te je on ponekad ljudske, a ponekad džinske vrste. </p>',
            ],
        ],
        5 => [
            0 => [
                'question' => 'Pitanje br. 1: Dopuni hadis: "Zaista se djela cijene prema namjerama..." i spomeni neke njegove koristi!',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9030.mp3',
                'answer' => '<p> Prenosi se od vladara pravovjernih, Ebu Hafsa Omera sina Hattaba, radijallahu \'anhu,<span class="c6"> da je rekao:</span> „Čuo sam Allahovog Poslanika, sallallahu \'alejhi ve selleme,<span class="c6"> kada je kazao:</span> Zaista se djela cijene prema namjerama i zaista će svaki čovjek dobiti ono što je naumio svojim djelom, pa ko bude hidžru učinio radi Allaha i Njegova Poslanika, njegova je hidžra Allahu i Poslaniku; a ko bude hidžru učinio zbog materijalne/ovosvjetske dobiti, ili zbog žene da bi ju oženio, njegova hidžra je za ono šta je naumio.\'“ Hadis bilježe Buhari i Muslim.<span class="c6"><br /> Neke koristi hadisa:</span><br /> 1. Svako djelo mora imati svoju namjeru, bilo da se radi o namazu, postu, hadžu, i tome slično.<br /> 2. Namjera mora biti iskrena u ime Allaha.<span class="c6"><br /> Drugi hadis:</span> </p>',
            ],
            1 => [
                'question' => 'Pitanje br. 2: Dopuni hadis: "Ko nešto novo uvede u ovu vjeru..."  i spomeni neke koristi iz njega!',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9090.mp3',
                'answer' => '<p> Aiša, radijallahu \'anha, prenosi da je Allahov Poslanik, sallallahu \'alejhi ve selleme,<span class="c6"> rekao:</span> "Ko nešto novo uvede u ovu vjeru, što nije od nje, to se odbija." Bilježe ga Buhari i Muslim.<span class="c6"><br /> Neke koristi hadisa:</span><br /> 1. Zabrana uvođenja vjerskih novotarija.<br /> 2. Novotarije u vjeri se ne prihvataju, nego se odbacuju kao neutemeljene.<span class="c6"><br /> Treći hadis:</span> </p>',
            ],
            2 => [
                'question' => 'Pitanje br. 3: Dopuni hadis: „Jednog dana sjedili smo kod Allahovog Poslanika, sallallahu \'alejhi ve selleme..." i spomeni neke njegove koristi!',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9160.mp3',
                'answer' => '<p> Omer ibn Hattab, radijallahu \'anhu,<span class="c6"> pripovijeda:</span> „Jednog dana sjedili smo kod Allahovog Poslanika, sallallahu \'alejhi ve selleme, te se iznenada pojavi jedan čovjek izuzetno bijele odjeće, jako crne kose, bez ikakvih znakova putovanja na sebi, a niko od nas ga nije poznavao. Približi se Allahovom Poslaniku, sallallahu \'alejhi ve selleme, i sjede pored njega, tako što je prislonio svoja koljena uz njegova i svoje ruke stavio na natkoljenice,<span class="c6"> a potom reče:</span> \'O Muhammede, obavijesti me o islamu!\' Allahov Poslanik, sallallahu \'alejhi ve selleme,<span class="c6"> reče mu:</span> \'Islam je da posvjedočiš da nema drugog boga, osim Allaha, i da je Muhammed Allahov poslanik, da obavljaš namaz, daješ zekat, postiš ramazan i da hodočastiš Bejtullah, ako si u mogućnosti.<span class="c6">\' On tada reče:</span> \'Istinu si kazao.\' Mi smo mu se čudili <span class="c2">(veli Omer)</span> pita ga, zatim mu potvrđuje.<span class="c6"> Čovjek ponovo reče:</span> \'Obavijesti me o imanu!\' Alejhisselam kaza: \'Iman je da vjeruješ Allaha, Njegove meleke, Njegove Knjige, Njegove poslanike, Sudnji dan i da vjeruješ da je sve određeno, bilo dobro, bilo zlo.<span class="c6">\' Čovjek opet reče:</span> \'Istinu si kazao.<span class="c6">\' Zatim reče:</span> \'Obavijesti me o ihsanu!\' Alejhisselam mu reče: \'Ihsan je da robuješ Allahu kao da Ga vidiš, jer ako ti Njega ne vidiš, On tebe, zaista, vidi.<span class="c6">\' Zatim reče:</span> \'Obavijesti me o Kijametskom danu?\' Alejhisselam odgovori: \'Upitani o tome ne zna ništa više od onoga koji ga je upitao.\' \'Obavijesti me o njegovim predznacima\', reče čovjek.<span class="c6"> Alejhisselam reče:</span> \'Da robinja rodi sebi gospodaricu, da vidiš gole i bose čobane, čuvare stada kako se nadmeću u gradnji visokih palača.\' Poslije toga je onaj čovjek otišao, a nakon izvjesnog vremena, Allahov Poslanik, sallallahu \'alejhi ve selleme,<span class="c6"> mi reče:</span> \'O Omere,<span class="c6"> znaš li ko je bio onaj čovjek?\' Ja mu odgovorih:</span> \'Allah i Njegov Poslanik najbolje znaju.<span class="c6">\' On mi tada reče:</span> \'To je bio Džibril, došao je da vas poduči vašoj vjeri.\'“ Hadis bilježi Muslim.<span class="c6"><br /> Neke koristi hadisa:</span><br /> 1. U hadisu se spominje pet temelja islama,<span class="c6"> a oni su:</span><br /> Svjedočenje da nema istinskog boga osim Allaha i da je Muhammed Njegov poslanik,<br /> obavljanje namaza,<br /> davanje zekata,<br /> post ramazana i<br /> hadž.<br /> 2. Također, u njemu se spominju temelji vjerovanja,<span class="c6"> a njih je šest:</span><br /> Vjerovanje u Allaha<br /> Vjerovanje u Njegove meleke.<br /> Vjerovanje u Njegove knjige.<br /> Vjerovanje u Njegove poslanike.<br /> Vjerovanje u Sudnji dan.<br /> Vjerovanje u odredbu dobra i zla.<br /> 3. Spominje se i ihsan koji ima samo jedan rukn, a to je da Allaha obožavaš kao da Ga vidiš, a ako ti Njega ne vidiš, pa On tebe, zaista, vidi.<br /> 4. Vrijeme nastupanja Sudnjeg dana samo Allah poznaje.<span class="c6"><br /> Četvrti hadis:</span> </p>',
            ],
            3 => [
                'question' => 'Dopuni hadis: "Najpotpunijeg imana su oni vjernici..."   i spomeni neke njegove kosti!',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9360.mp3',
                'answer' => '<p> Odgovor: Ebu Hurejre prenosi da je Poslanik, sallallahu alejhi ve sellem,<span class="c6"> rekao:</span> "Najpotpunijeg imana su oni vjernici koji imaju najljepše ponašanje." Hadis bilježi Tirmizi i kaže da je hasen-sahih.<span class="c6"><br /> Neke koristi hadisa:</span><br /> 1. Podsticaj na lijepo ponašanje.<br /> 2. Potpuno ponašanje ukazuje na potpunost vjerovanja.<br /> 3. Vjerovanje se povećava i smanjuje.<span class="c6"><br /> Peti hadis:</span> </p>',
            ],
            4 => [
                'question' => 'Pitanje br. 5: Dopuni hadis: "Ko se zakune nekim mimo Allaha..." i spomeni neke od njegovih koristi!',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9440.mp3',
                'answer' => '<p> Ibn Omer, radijallahu \'anhu prenosi da je Poslanik, sallallahu alejhi ve sellem,<span class="c6"> rekao:</span> "Ko se zakune nekim mimo Allaha, počinio je nevjerstvo ili širk." Hadis bilježi Tirmizi.<span class="c6"><br /> Neke koristi hadisa:</span><br /> - Nije dozvoljeno zaklinjati se osim Allahom.<br /> - Zaklinjanje nekim drugim mimo Allaha ubraja se u mali širk.<span class="c6"><br /> Šesti hadis:</span> </p>',
            ],
            5 => [
                'question' => 'Pitanje br. 6: Dopuni hadis: "Niko od vas neće biti vjernik sve dok mu ne budem draži..." i spomeni neke njegove koristi!',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9510.mp3',
                'answer' => '<p> Odgovor: Enes, radijallahu \'anhu prenosi da je Poslanik, sallallahu alejhi ve sellem,<span class="c6"> rekao:</span> "Niko od vas neće biti vjernik sve dok mu ne budem draži od roditelja, djece i svih ljudi." Hadis bilježe Buhari i Muslim.<span class="c6"><br /> Neke koristi hadisa:</span><br /> - Obaveza je voljeti Poslanika, sallallahu alejhi ve sellem, više od svih ljudi.<br /> - Ljubav prema njemu ukazuje na potpunost vjerovanja.<span class="c6"><br /> Sedmi hadis:</span> </p>',
            ],
            6 => [
                'question' => 'Pitanje br. 7: Dopuni hadis: "Niko od vas neće biti pravi vjernik sve dok ne bude želio svome bratu..." i spomeni neke njegove koristi!',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9580.mp3',
                'answer' => '<p> Odgovor: Enes, radijallahu \'anhu prenosi da je Poslanik, sallallahu alejhi ve sellem,<span class="c6"> rekao:</span> "Niko od vas neće biti pravi vjernik sve dok ne bude želio svome bratu ono što želi samome sebi." Hadis bilježe Buhari i Muslim.<span class="c6"><br /> Neke koristi hadisa:</span><br /> 1. Vjernik mora voljeti i željeti drugom vjerniku dobro, kao što voli i želi samome sebi.<br /> 2. Ova osobina ukazuje na potpunost vjerovanja.<span class="c6"><br /> Osmi hadis:</span> </p>',
            ],
            7 => [
                'question' => 'Pitanje br. 8: Dopuni hadis: "Tako mi Onoga u čijoj je ruci moja duša..." i spomeni neke od njegovih koristi!',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9650.mp3',
                'answer' => '<p> Ebu Se\'id, radijallahu \'anhu, prenosi da je Poslanik, sallallahu alejhi ve sellem,<span class="c6"> rekao:</span> "Tako mi Onoga u čijoj je ruci moja duša, ona <span class="c2">(sura El-Ihlas)</span> vrijedi kao trećina Kur\'ana." Hadis bilježi Buhari.<span class="c6"><br /> Neke koristi hadisa:</span><br /> 1. Vrijednost sure El-Ihlas.<br /> 2. Sura El-Ihlas vrijedi kao trećina Kur\'ana.<span class="c6"><br /> Deveti hadis:</span> </p>',
            ],
            8 => [
                'question' => 'Pitanje br. 9: Dopuni hadis: "Riječi la havle ve la kuvvete illa billahi..." i spomeni neke koristi ovog hadisa:',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9720.mp3',
                'answer' => '<p> Odgovor: Ebu Musa prenosi da je Poslanik, sallallahu alejhi ve sellem,<span class="c6"> rekao:</span> "Riječi: la havle ve la kuvvete illa billahi, jedna je od džennetskih riznica." Hadis bilježe Buhari i Muslim.<span class="c6"><br /> Neke od koristi hadisa:</span><br /> 1. Vrijednost spomenutih riječi koja se ogleda u tome da su one jedna od džennetskih riznica.<br /> 2. Riječi koje se spominju u hadisu ukazuju na to da se čovjek ne smije oslanjati na svoju snagu, nego se treba samo i uvijek oslanjati na Allaha i u Njega se pouzdati.<span class="c6"><br /> Deset hadis:</span> </p>',
            ],
            9 => [
                'question' => 'Pitanje br. 10: Dopuni hadis: "Zaista, u svakom tijelu ima jedan dio..." i spomeni neke njegove koristi!',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9790.mp3',
                'answer' => '<p> Nu\'man b. Bešir, radijallahu \'anhu,<span class="c6"> veli:</span> "Čuo sam Allahovog Poslanika, sallallahu alejhi ve sellem,<span class="c6"> kako kaže:</span> Zaista, u svakom tijelu ima jedan dio koji, ako valja, onda je i cijelo tijelo dobro, a ako taj dio bude pokvaren, pokvari se i cijelo tijelo. Taj dio je srce.\'" Hadis bilježe Buhari i Muslim.<span class="c6"><br /> Neke koristi hadisa:</span><br /> 1. Ispravnost srca vodi ka ispravnosti čovjekove forme i suštine.<br /> 2. Briga o srčanom stanju, jer se na taj način čovjek popravlja i biva bolji.<span class="c6"><br /> Jedanaesti hadis:</span> </p>',
            ],
            10 => [
                'question' => 'Pitanje br. 11: Dopuni hadis: „Kome posljednje riječi na ovom svijetu budu: La ilahe illallah..."  i spomeni neke njegove koristi!',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9860.mp3',
                'answer' => '<p> Mu\'az, radijallahu \'anhu, prenosi da je Allahov Poslanik, sallallahu \'alejhi ve selleme,<span class="c6"> rekao:</span> „Kome posljednje riječi na ovom svijetu budu: La ilahe illallah, ući će u Džennet." Bilježi ga Ebu Davud.<span class="c6"><br /> Neke koristi hadisa:</span><br /> 1. Vrijednost riječi la ilahe illellah, koja se, između ostalog, ogleda i u tome da one bivaju uzrokom ulaska u Džennet.<br /> 2. Vrijednost onoga kome posljednje riječi na ovome svijetu budu la ilahe illellah.<span class="c6"><br /> Dvanaesti hadis:</span> </p>',
            ],
            11 => [
                'question' => 'Pitanje br. 12: Dopuni hadis: „Vjernik ne vrijeđa, ne proklinje..." i spomeni neke njegove koristi!',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9940.mp3',
                'answer' => '<p> Odgovor: Abdullah b. Mes\'ud, radijallahu \'anhu, prenosi da je Poslanik, sallallahu alejhi ve sellem,<span class="c6"> kazao:</span> "Vjernik ne vrijeđa, ne proklinje, nije bestidan niti besraman.“ Hadis bilježi Tirmizi.<span class="c6"><br /> Neke koristi hadisa:</span><br /> 1. Zabrana svih vrsta neispravnog i ružnog govora.<br /> 2. Ovo su svojstva vjernika kada je riječ o njegovom govoru.<span class="c6"><br /> Trinaesti hadis:</span> </p>',
            ],
            12 => [
                'question' => 'Pitanje br. 13: Dopuni hadis: „Od ljepote islama - vjere jednog čovjeka jeste..." i spomeni neke koristi iz njega!',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10020.mp3',
                'answer' => '<p> Odgovor: Ebu Hurejre prenosi da je Poslanik, sallallahu alejhi ve sellem,<span class="c6"> rekao:</span> „Od ljepote islama - vjere jednog čovjeka jeste da se kloni onoga što ga se ne tiče.“ Hadis bilježe Tirmizi i drugi.<span class="c6"><br /> Neke koristi hadisa:</span><br /> 1. Čovjek treba zanemariti sve ono što ga se ne tiče po pitanju tuđe vjere i ovosvjetskih poslova.<br /> 2. Zapostavljanje onoga što nas se ne tiče ubraja se u potpunost našeg islama.<span class="c6"><br /> Četrnaesti hadis:</span> </p>',
            ],
            13 => [
                'question' => 'Pitanje br. 14: Dopuni hadis: "Ko prouči jedan harf - slovo iz Allahove Knjige (Kur\'ana)..." i navedi neke koristi koje se mogu zaključiti iz njega!',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10100.mp3',
                'answer' => '<p> Ibn-Mes\'ud, radijallahu \'anhu, prenosi da je Allahov Poslanik, sallallahu \'alejhi ve selleme,<span class="c6"> rekao:</span> „Ko prouči jedan harf iz Allahove Knjige imat će nagradu, a nagrada se deseterostruko uvećava. Ja ne kažem da je Elif-lam-mim harf, nego elif je harf, lam je harf i mim je harf.“ Hadis bilježi Tirmizi.<span class="c6"><br /> Neke koristi hadisa:</span><br /> 1. Vrijednost učenja Kur\'ana.<br /> 2. Za svaki harf kojeg proučiš pišu ti se dobra djela. </p>',
            ],
        ],
        6 => [
            0 => [
                'question' => 'Pitanje br. 1: Kako se treba ophoditi spram Allaha?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10190.mp3',
                'answer' => '<p> Odgovor: 1. Treba Ga veličati i slaviti.<br /> 2. Samo Njemu treba robovati i nikoga Mu kao sudruga ne pripisivati.<br /> 3. Moramo Mu biti pokorni.<br /> 4. Ne smijemo prema Njemu griješiti.<br /> 5. Trebamo Mu se zahvaljivati na nebrojenim blagodatima kojima nas obasipa.<br /> 6. Moramo biti strpljivi na onome što nam odredi. </p>',
            ],
            1 => [
                'question' => 'Pitanje br. 2: Kako se trebamo ophoditi prema Poslaniku, sallallahu alejhi ve sellem?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10270.mp3',
                'answer' => '<p> Odgovor: 1. Trebamo slijediti njegovu praksu.<br /> 2. Moramo mu biti pokorni.<br /> 3. Ne smijemo prema njemu griješiti.<br /> 4. Moramo vjerovati u ono što nam je prenio i o čemu nas je obavijestio.<br /> 5. Ne smijemo dodavati ništa na njegovu vjersku praksu.<br /> 6. Trebamo ga voljeti više nego same sebe i više od svih ljudi.<br /> 7. Moramo ga uvažavati, te njega i njegov sunnet pomagati. </p>',
            ],
            2 => [
                'question' => 'Pitanje br. 3: Kako se treba ponašati prema roditeljima?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10360.mp3',
                'answer' => '<p> Odgovor: 1. Trebamo im biti pokorni u svemu što nije grijeh.<br /> 2. Trebamo im biti na usluzi.<br /> 3. Trebamo im pomagati.<br /> 4. Trebamo njihove potrebe izvršavati.<br /> 5. Trebamo moliti Allaha za njih.<br /> 6. Trebamo se prema njima lijepo ophoditi. Ne smijemo im reći ni <span class="c2">(uh)</span>, a to je najmanji vid negodavanja.<br /> 7. Trebamo pred njima biti osmjehnuti, a ne smrknuti.<br /> 8. Ne smijemo dizati glas iznad njihovog, trebamo ih pomno slušati, ne trebamo ih prekidati kada govore, niti ih dozivati imenima,<span class="c6"> nego na primjer:</span> Oče, majko.<br /> 9. Kada su u sobi trebamo im pokucati na vrata tražeći dozvolu da uđemo.<br /> 10. Trebamo ih ljubiti u ruku i čelo. </p>',
            ],
            3 => [
                'question' => 'Pitanje br. 4: Kako se održavaju rodbinske veze?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10490.mp3',
                'answer' => '<p> Odgovor: 1: Posjeta rodbine, kao što su braća, sestre, amidže, tetke, dajdže, te ostala rodbina.<br /> 2. Dobročinstvo prema njima, sa riječima i djelima, te i pomaganje istih.<br /> 3. Održavanje kontakata sa njima i raspitivanje za njih. </p>',
            ],
            4 => [
                'question' => 'Pitanje br. 5: Kakvi trebaju biti odnosi sa braćom i prijateljima?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10550.mp3',
                'answer' => '<p> Odgovor: 1. Treba voljeti i družiti se sa dobrim ljudima.<br /> 2. Treba se udaljiti od zlih ljudi.<br /> 3. Treba nazivati selam prijateljima i rukovati se sa njima.<br /> 4. Treba ih posjećivati kada se razbole i moliti Allaha da ih izliječi.<br /> 5. Kada neko od njih kihne,<span class="c6"> treba mu nazdraviti riječima:</span> Jerhamukellah/Allah ti se smilovao.<br /> 6. Treba se odazvati kada nas pozovu u posjetu.<br /> 7. Treba ih savjetovati.<br /> 8. Kada nekome od njih bude učinjena nepravda, treba mu pomoći i spriječiti tu nepravdu.<br /> 10. Braći muslimanima treba željeti sve ono što sami sebi želimo.<br /> 11. Trebamo ih pomagati kada su u potrebi.<br /> 12. Ne smijemo ih uznemiravati ni riječima ni djelima.<br /> 13. Trebamo čuvati njihove tajne.<br /> 14. Ne smijemo ih vrijeđati, ogovarati i ponižavati. Ne smijemo im zavidjeti, uhoditi i varati ih. </p>',
            ],
            5 => [
                'question' => 'Pitanje br. 6: Kako se pravilno ophoditi prema komšijama?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10710.mp3',
                'answer' => '<p> Odgovor: 1. Prema komšijama treba činiti dobro, sa riječima i djelima. Trebamo ih pomagati kada su u potrebi.<br /> 2. Treba im čestitati kada su radosni povodom nekog blagdana, sklapanja braka i tome slično.<br /> 3. Treba ih posjetiti kada se razbole i izraziti im saučešće kada ih nevolja zadesi.<br /> 4. Lijepo je da im pošaljemo nešto od hrane koju pravimo, ako smo to u mogućnosti.<br /> 5. Ne smijemo ih uznemiravati ni riječima ni djelima.<br /> 6. Ne smijemo ga uznemiravati galamom i uhoditi, i trebamo biti u ophođenju strpljivi. </p>',
            ],
            6 => [
                'question' => 'Pitanje br. 7: Kako se trebamo ophoditi prema gostima?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10800.mp3',
                'answer' => '<p> Odgovor: 1. Trebamo se odazvati onome ko nas pozove u goste.<br /> 2. Kada želimo ići u goste, trebamo tražiti dozvolu i odrediti termin u kojem možemo slobodno doći.<br /> 3. Prije ulaska u kuću trebamo tražiti dozvolu.<br /> 4. Ne trebamo dugo ostajati prilikom posjete.<br /> 5. Trebamo obarati pogled od onoga što nas se ne tiče kada smo kod nekoga u gostima.<br /> 6. Gosta trebamo lijepo dočekati i izraziti mu dobrodošlicu na najljepši način, nasmiješenog i vedrog lica.<br /> 7. Gostu trebamo ustupiti najljepše mjesto.<br /> 8. Gosta trebamo lijepo počastiti hranom i pićem. </p>',
            ],
            7 => [
                'question' => 'Pitanje br. 8: Koja su pravila ponašanja vezana za bolest i posjetu bolesnika?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10900.mp3',
                'answer' => '<p> Odgovor: 1. Kada osjetimo bol na tijelu,<span class="c6"> stavit ćemo desnu ruku na to mjesto i proučiti tri puta:</span> bismillah/u ime Allaha,<span class="c6"> a onda sedam puta kazati:</span> E\'uzu bi \'izzetillahi min šerri ma edžidu ve uhaziru/Utječem se Allahovom veličinom i moći od zla kojeg osjećam i bojim ga se!<br /> 2. Trebamo biti zadovoljni i strpljivi na Allahovoj odredbi.<br /> 3. Kada se razboli brat musliman, trebamo ga što prije posjetiti, doviti za njegovo ozdravljenje i prilikom posjete ne trebamo dugo boraviti kod njega.<br /> 4. Lijepo je da mu proučimo rukju, ali da on to ne traži od nas.<br /> 5. Trebamo ga savjetovati da bude strpljiv, da dovi, klanja i da bude čist onoliko koliko može.<br /> 6.<span class="c6"> Dova za bolesnika glasi:</span> Molim Uzvišenog Allaha, Gospodara velikog Arša, da te izliječi/ES\'ELULLAHEL-AZIME, RABBEL-ARŠIL-AZIMI EN JEŠFIJEKE. <span class="c2">(sedam puta)</span> </p>',
            ],
            8 => [
                'question' => 'Pitanje br. 9: Koja su pravila prilikom traženja znanja?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10990.mp3',
                'answer' => '<p> Odgovor: 1. Iskrenost u ime Allaha.<br /> 2. Rad po znanju.<br /> 3. Uvažavanje učitelja kada je prisutan, te i kada je odsutan.<br /> 4. Sjedenje pred učiteljem s poštovanjem.<br /> 5. Pomno slušanje onoga što se govori i neprekidanje učitelja kada govori.<br /> 6. Postavljanje pitanja na lijep način.<br /> 7. Učitelja ne treba zvati imenom. </p>',
            ],
            9 => [
                'question' => 'Pitanje br. 10: Koja su pravila vezana za sijela?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11090.mp3',
                'answer' => '<p> Odgovor: 1. Poselamiti prisutne.<br /> 2. Sjesti tamo gdje završava red, ne treba nikoga dizati sa mjesta gdje sjedi i ne treba sjedati između dvojice osim uz njihovu dozvolu.<br /> 3. Drugima načiniti mjesto i prostor kako bi i oni mogli sjesti.<br /> 4. Ne treba prekidati trenutnu temu o kojoj se govori.<br /> 5. Prije napuštanja sijela treba tražiti dozvolu i poselamiti se kada se krene.<br /> 6. Kada se završi druženje, treba proučiti dovu kojom se iskupljuje za propuste na druženju. Subhanekellahume ve bi hamdike, ešhedu en la ilahe illa ente, estagfiruke ve etubu ilejke/Slavljen i hvaljen si, Allahu moj, svjedočim da si samo Ti istinski Bog, od Tebe oprost tražim i Tebi se kajem. </p>',
            ],
            10 => [
                'question' => 'Pitanje br. 11: Koja su pravila u vezi sa spavanjem?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11180.mp3',
                'answer' => '<p> Odgovor: 1. Treba zaspati ranije.<br /> 2. Treba spavati pod abdestom.<br /> 3. Ne treba spavati na stomaku.<br /> 4. Treba spavati na desnoj strani i staviti desni dlan pod desni obraz.<br /> 5. Otresti posteljinu i očistiti je.<br /> 6.<span class="c6"> Proučiti propisane zikrove:</span> ajetul-kursijju, sure El-Ihlas, El-Felek i En-Nas tri puta,<span class="c6"> te kazati:</span> Bismikellahume emutu ve ahja/S Tvojim imenom, Allahu moj, umirem i živim.<br /> 7. Probuditi se na sabah.<br /> 8.<span class="c6"> Nakon spavanja proučiti:</span> El-hamdu lillahillezi ahjana ba\'dema ematena ve ilejhin-nušuru/Hvala Allahu koji nas je oživio nakon što nas je bio usmrtio <span class="c2">(snom)</span> i pred Njim ćemo biti okupljeni. </p>',
            ],
            11 => [
                'question' => 'Pitanje br. 12: Koja su pravila konzumiranja hrane?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11290.mp3',
                'answer' => '<p> Odgovor:<br /> 1. Kunzumiranjem hrane i pića treba imati namjeru jačanja tijela kako bi se lakše sprovodilo ono u čemu je pokornost Allahu.<br /> 2. Oprati ruke prije jela.<br /> 3. Proučiti bismillu, jesti desnom rukom i ispred sebe, ne treba jesti sa sredine ili ispred drugih.<br /> 4.<span class="c6"> Ako se zaboravi bismilla treba kazati:</span> bismillahi evveluhu ve ahirehu/U ime Allaha i na početku i na kraju.<br /> 5. Treba biti zadovoljan hranom koja je pred nama i ne treba ju kuditi. Ukoliko nam hrana odgovara, jest ćemo je; a ukoliko nam ne odgovara, ostavit ćemo je.<br /> 6. Treba jesti nekoliko zalogaja, a ne prejedati se.<br /> 7. U hranu i piće ne treba puhati, nego ih treba ostaviti dok se ne ohlade.<br /> 8. Treba jesti zajedno s porodicom ili gostima.<br /> 9. Ne treba počinjati s jelom prije onih koji su stariji.<br /> 10. Kada se pije nešto, treba spomenuti Allahovo ime, i treba piti sjedeći, na tri puta.<br /> 11. Na kraju se treba zahvaliti Allahu. </p>',
            ],
            12 => [
                'question' => 'Pitanje br. 13: Koja su pravila odijevanja?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11440.mp3',
                'answer' => '<p> Odgovor: Počinjemo od desne strane i iskazujemo Allahu zahvalu na tome.<br /> 2. Odjeću ne treba puštati da prelazi ispod nožnih članaka.<br /> 3. Muškarci ne nose žensku, niti žene mušku odjeću.<br /> 4. Ne smiju se kroz odjeću oponašati nevjernici niti griješnici.<br /> 5. Prilikom skidanja odjeće trebamo spomenuti Allahovu ime.<br /> 6. Kada obuvamo obuću, prvo počinjeno od desne, a kada je skidamo, onda od lijeve noge. </p>',
            ],
            13 => [
                'question' => 'Pitanje br. 14: Koja su pravila vezana za putovanje?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11540.mp3',
                'answer' => '<p> Odgovor: Treba proučiti sljedeće riječi: Bismillahi, elhamdu lillahi/U ime Allaha, hvala Allahu... Subhanellezi sehhare lena haza ve ma kunna lehu mukrinin/Slavljen neka je Onaj koji je dao da nam ovo služi, jer mi to sami ne bismo mogli postići... ve inna ila rabbina le munkalibun/i mi ćemo se, sigurno, Gospodaru svome vratiti! <span class="c2">(Ez-Zuhruf, 13-14)</span>.<br /> 2. Kada prođemo pored muslimana, nazvat ćemo mu selam. </p>',
            ],
            14 => [
                'question' => 'Pitanje br. 15: Koja su pravila puta kojim se prolazi?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11590.mp3',
                'answer' => '<p> Odgovor: 1. Umjereno i ponizno kretanje, krećemo se desnom stranom puta.<br /> 2. Nazivanje selama onima koje sretnemo.<br /> 3. Trebamo obarati pogled i nikoga ne uznemiravati.<br /> 4. Širiti dobro i uklanjati zlo.<br /> 5. Uklanjati s puta sve ono što smeta prolaznicima. </p>',
            ],
            15 => [
                'question' => 'Pitanje br. 16: Koja su pravila koja se tiču ulaska i izlaska iz kuće?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11670.mp3',
                'answer' => '<p> Odgovor: 1.<span class="c6"> Izlazimo lijevom nogom i izgovaramo:</span> Bismillahi, tevekkeltu \'alellahi, ve la havle ve la kuvvete illa billahi. Allahumme, inne e\'uzu bike en edille ev udalle, ev ezille ev uzelle, ev azlime ev uzleme, ev edžhele ev judžhele \'alejje/U ime Allaha, u Allaha se uzdam i na Njega se oslanjam. Allahu dragi, ja se Tebi utječem od svoje lične zablude, i da me neko drugi u zabludu ne zavede, da ne zgriješim i da me drugi na grijeh ne navede, da kome nepravdu ne učinim, ili da ko meni ne učini nepravdu, da iz neznanja pogriješim, ili da me neko drugi zbog svoga neznanja u grijeh ne odvede. 2.<span class="c6"> U kuću treba ući desnom nogom i izgovoriti:</span> Bismillahi veledžna ve bismillahi haredžna va \'ala rabbina tevekkelna/U ime Allaha ulazimo, u Njegovo ime i izlazimo i na Njega se oslanjamo.<br /> 3. Čistimo zube misvakom i nazivamo selam ukućanima. </p>',
            ],
            16 => [
                'question' => 'Pitanje br. 17: Koja su pravila obavljanja fiziološke potrebe?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11730.mp3',
                'answer' => '<p> Odgovor: 1. Ulazimo lijevom nogom u toalet.<br /> 2.<span class="c6"> Prije ulaska kažemo:</span> Bismillahi, Allahumme inni e\'uzu bile minel-hubusi vel-habaisi/U ime Allaha, Allahu moj, utječem Ti se od muških i ženskih šejtana <span class="c2">(od svega što je ružno i prljavo)</span>.<br /> 3. U toalet se ne unosi ništa što sadrži spomen Allaha.<br /> 4. Prilikom vršenja nužde trebamo se čuvati od pogleda ljudi i od toga da se ne isprljamo.<br /> 5. Na mjestu gdje vršimo nuždu ništa ne govorimo.<br /> 6. Kada vršimo nuždu ne okrećemo se prema kibli, ni licem ni leđima.<br /> 7. Kada se čistimo nakon nužde, koristimo lijevu ruku, a nikako desnu ruku.<br /> 8. Nuždu ne vršimo po putevima gdje ljudi prolaze, niti na mjestima gdje se odmaraju.<br /> 9. Nakon završetka nužde peremo ruke.<br /> 10.<span class="c6"> Iz toaleta izlazimo desnom nogom i izgovaramo riječi:</span> gufraneke/oprosti Allahu. </p>',
            ],
            17 => [
                'question' => 'Pitanje br. 18: Koja su pravila vezana za džamiju?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11860.mp3',
                'answer' => '<p> Odgovor: 1.<span class="c6"> U džamiju ulazimo desnom nogom i učimo:</span> Bismillahi, Allahummeftah li ebvabe rahmetike/U ime Allaha, Allahu moj, otvori mi vrata Svoje milosti.<br /> 2. Ne sjedamo dok ne klanjamo dva rek\'ata.<br /> 3. Ne prolazimo ispred klanjača, ne oglašavamo izgubljenu stvar u džamiji, niti vršimo kupoprodaju.<br /> 4.<span class="c6"> Izlazimo lijevom nogom i učimo:</span> Allahumme inni es\'eluke min fadlike/Allahu moj, podari mi svako dobro od Tebe. </p>',
            ],
            18 => [
                'question' => 'Pitanje br. 19: Koja su pravila vezana za nazivanje selama?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11930.mp3',
                'answer' => '<p> Odgovor: 1.<span class="c6"> Kada sretnemo muslimana trebamo mu nazvati selam riječima:</span> esselamu \'alejkum ve rahmetullahi ve berekatuhu. Dakle, ne trebamo se pozdravljati drugim riječima mimo selama, niti trebamo samo pokazivati rukom kao vid pozdrava.<br /> 2. Trebamo se nasmiješiti onome kome nazivamo selam.<br /> 3. Trebamo se rukovati desnom rukom.<br /> 4. Ako nas neko pozdravi, trebamo mu odgovoriti na ljepši ili na isti način.<br /> 5. Nevjernicima ne trebamo nazivati selam, ali ako nam oni nazovu, odgovorit ćemo im na isti način.<br /> 6. Mlađi nazivaju selam starijima, onaj ko je na jahalici <span class="c2">(vozilu)</span> naziva selam pješaku, pješak naziva selam onome ko sjedi, a manja skupina većoj. </p>',
            ],
            19 => [
                'question' => 'Pitanje br. 20: Koja su pravila traženja dozvole?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12020.mp3',
                'answer' => '<p> Odgovor: 1. Prije nego uđemo u neko mjesto trebamo tražiti dozvolu za ulazak.<br /> 2. Dozvolu tražimo tri puta i ne više od toga. Ako nam se niko ne odazove, trebamo se vratiti.<br /> 3. Na vrata blago kucamo, i ne stojimo odmah ispred vrata, nego ćemo stati sa strane.<br /> 4. Ne ulazimo u roditeljsku ili nečiju drugu sobu dok ne dobijemo dozvolu, a pogotovo u vrijeme prije sabaha, za vrijeme popodnevnog odmora i nakon jacije.<br /> 5. U mjesta u kojima se ne stanuje možemo ulaziti bez dozvole, poput bolnice, pijace i tome slično. </p>',
            ],
            20 => [
                'question' => 'Pitanje br. 21: Kako da se odnosimo prema životinjama?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12100.mp3',
                'answer' => '<p> Odgovor: 1. Životinju trebamo hraniti i pojiti.<br /> 2. Trebamo biti samilosni i blagi prema životinjama i ne smijemo ih teretiti onim što nisu u mogućnosti.<br /> 3. Životinju ne smijemo ničim mučiti niti uznemiravati. </p>',
            ],
            21 => [
                'question' => 'Pitanje br. 22: Koja su pravila vezana za sport?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12160.mp3',
                'answer' => '<p> Odgovor: 1. Sportom kojim se osoba bavi treba imati namjeru jačanja tijela, kako bi se moglo lakše i spremnije biti pokoran Allahu.<br /> 2. Izbjegavati igru za vrijeme namaza.<br /> 3. U takvim aktivnostima treba razdvojiti muškarce od žena, dječake od djevojčica.<br /> 4. Treba pokriti stidni dio tijela.<br /> 5. Izbjegavati zabranjene sportske aktivnosti, kao npr. one sportove gdje se udara u lice ili gdje se otkriva stidni dio tijela. </p>',
            ],
            22 => [
                'question' => 'Pitanje br. 23: Spomeni neka pravila vezana za šalu?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12240.mp3',
                'answer' => '<p> Odgovor: 1. Istinu treba govoriti i prilikom šale, te se ne smije ni tada lagati.<br /> 2. Šala ne smije biti popraćena ismijavanjem, izrugivanjem, uznemiravanjem i plašenjem.<br /> 3. Šala ne treba biti popraćena pretjerivanjem. </p>',
            ],
            23 => [
                'question' => 'Pitanje br. 24: Koja su pravila kihanja?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12300.mp3',
                'answer' => '<p> Odgovor: 1. Prilikom kihanja na usta trebamo staviti ruku, dio odjeće ili maramicu.<br /> 2.<span class="c6"> Nakon kihanja trebamo se zahvaliti Allahu riječima:</span> Elhamdulillah/Hvala Allahu.<br /> 3. Onaj ko čuje da je neko kihnuo,<span class="c6"> treba mu reći:</span> jerhamukellah/Allah ti se smilovao.<br /> 4. A onaj ko je kihnuo,<span class="c6"> nakon toga treba reći:</span> Jehdikumullahu ve juslihu balekum/Allah te uputio i stanje ti popravio. </p>',
            ],
            24 => [
                'question' => 'Pitanje br. 25: Koja su pravila ponašanja prilikom zijevanja?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12360.mp3',
                'answer' => '<p> Odgovor: 1. Treba pokušati spriječiti <span class="c2">(ublažiti)</span> zijevanje.<br /> 2. Ne treba dizati glas <span class="c2">(aaaah)</span>.<br /> 3. Treba staviti ruku na usta. </p>',
            ],
            25 => [
                'question' => 'Pitanje br. 26: Koja su pravila učenja Kur\'ana?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12420.mp3',
                'answer' => '<p> Odgovor: 1. Učenje pod abdestom.<br /> 2. Sjedenje kojeg krasi smirenost i dostojanstvo.<br /> 3. Na početku učenja treba kod Allaha zatražiti utočište od šejtana.<br /> 4. Treba razmišljati o značenjima onoga što se uči. </p>',
            ],
        ],
        7 => [
            0 => [
                'question' => 'Pitanje br. 1: Koja je vrijednost lijepog ponašanja?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12500.mp3',
                'answer' => '<p> Odgovor: Rekao je Vjerovjesnik,<span class="c6"> sallallahu alejhi ve sellem:</span> "Najpotpunijeg imana su oni vjernici koji imaju najljepše ponašanje." Hadis bilježe Tirmizi i Ahmed. </p>',
            ],
            1 => [
                'question' => 'Pitanje br. 2: Zbog čega treba praktikovati islamsko ponašanje?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12530.mp3',
                'answer' => '<p> Odgovor: Ono vodi Allahovoj ljubavi.<br /> 2. Uzrok je da nas stvorenja zavole.<br /> 3. Ono je najteže djelo na vagi kojom će se vagati djela.<br /> 4. Lijepo ponašanje donosi mnogostruke nagrade i sevape.<br /> 5. Ono je znak potpunog vjerovanja. </p>',
            ],
            2 => [
                'question' => 'Pitanje br. 3: Odakle crpimo lijepo ponašanje?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12600.mp3',
                'answer' => '<p> Odgovor: Iz Kur\'ana.<span class="c6"> Allah Uzvišeni kaže:</span> "Doista ovaj Kur\'an vodi jedinom Pravom putu." <span class="c2">(El-Isra, 9)</span>. Također, crpimo ga iz sunneta Poslanika, sallallahu alejhi ve sellem,<span class="c6"> koji je kazao:</span> "Poslan sam da upotpunim lijepo ponašanje." Hadis bilježi Ahmed. </p>',
            ],
            3 => [
                'question' => 'Pitanje br. 4: Šta je to ihsan i koji su njegovi oblici?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12640.mp3',
                'answer' => '<p> Odgovor: Ihsan je stalna svijest o tome da nas Allah prati, te dobročinstvo prema stvorenjima.<br /> Rekao je Allahov Poslanik,<span class="c6"> sallallahu alejhi ve sellem:</span> "Allah je propisao dobročinstvo prema svemu." Hadis bilježi Muslim.<span class="c6"><br /> Neki oblici dobročinstva:</span><br /> Dobročinstvo u ibadetu koje se ogleda kroz iskren odnos prema Allahu.<br /> Dobročinstvo prema roditeljima, kako riječima tako i djelima.<br /> Dobročinstvo prema rodbini.<br /> Dobročinstvo prema komšijama.<br /> Dobročinstvo prema siromasima.<br /> Dobročinstvo prema onome ko nam učini zlo.<br /> Dobročinstvo u govoru.<br /> Dobročinstvo tokom diskusije.<br /> Dobročinstvo prema životinjama. </p>',
            ],
            4 => [
                'question' => 'Pitanje br. 5: Šta je suprotno dobročinstvu?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12780.mp3',
                'answer' => '<p> Odgovor: Činjenje zla.<span class="c6"><br /> Kao primjeri se mogu navesti:</span> neiskren ibadet.<br /> Neposlušnost roditeljima.<br /> Prekidanje rodbinskih veza.<br /> Loše ophođenje prema komšijama.<br /> Izbjegavanje dobročinstva prema siromasima, nevoljnicima i tako dalje. </p>',
            ],
            5 => [
                'question' => 'Pitanje br. 6: Koje su vrste i oblici emaneta (povjerenja)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12860.mp3',
                'answer' => '<p> Odgovor:<br /> 1. Emanet u pogledu očuvanja obaveza prema Allahu Uzvišenom.<span class="c6"><br /> Oblici ovog emaneta:</span> Emanet kada se radi o izvršavanju ibadeta poput namaza, zekata, posta, hadža, a isto tako i drugih obaveza koje je Allah propisao.<br /> 2.<span class="c6"> Emanet u pogledu očuvanja obaveza spram stvorenja:</span><br /> Čuvanje ljudske časti.<br /> Čuvanje ljudskih imetaka.<br /> Čuvanje života ljudi.<br /> Čuvanje njihovih tajni i svega onoga što su nam oni povjerili.<br /> U pogledu svojstava uspješnih,<span class="c6"> Uzvišeni Allah kaže:</span> "I koji o povjerenim im amanetima i obavezama svojim brigu brinu." <span class="c2">(El-Mu\'minun, 8)</span>. </p>',
            ],
            6 => [
                'question' => 'Pitanje br. 7: Šta je suprotno emanetu?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12980.mp3',
                'answer' => '<p> Odgovor: Hijanet <span class="c2">(prevara, pronevjera)</span>, a to je kršenje obaveza prema Allahu i ljudima.<br /> Rekao je Vjerovjesnik,<span class="c6"> sallallahu alejhi ve sellem:</span> "Tri su znaka licemjera...<span class="c6">" Jedno od ta tri je:</span> "Kada mu se nešto povjeri, on to iznevjeri." Muttefekun \'alejh. </p>',
            ],
            7 => [
                'question' => 'Pitanje br. 8: Šta je to istinoljubivost?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13020.mp3',
                'answer' => '<p> Odgovor: Istinoljubivost je kazivanje onoga što je u skladu sa stvarnim stanjem ili opisi nečega onakvim kakvo ono i jeste.<span class="c6"><br /> Neki oblici istinoljubivosti:</span><br /> Istinit govor u obraćanju ljudima.<br /> Istinoljubivost u pogledu obećanja.<br /> Istinoljubivost u pogledu svih riječi i postupaka.<br /> Rekao je Vjerovjesnik,<span class="c6"> sallallahu alejhi ve sellem:</span> "Doista istinoljubivost vodi ka dobru, a dobro vodi ka Džennetu. Čovjek će biti privržen istini sve dok kod Allaha ne bude upisan među istinoljubive." Muttefekun \'alejh. </p>',
            ],
            8 => [
                'question' => 'Pitanje br. 9: Šta je suprotno istinoljubivosti?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13100.mp3',
                'answer' => '<p> Odgovor: Laž, a to je sve što odudara od stvarnog stanja, kao što je laganje ljudima, kršenje obećanja, lažno svjedočenje i tako dalje.<br /> Allahov Poslanik, sallallahu alejhi ve sellem,<span class="c6"> je rekao:</span> "Doista laž vodi u griješenje, a griješenje vodi Vatri. Doista će čovjek toliko lagati, sve dok kod Allaha ne bude upisan među lažove." Muttefekun \'alejh. Također, Vjerovjesnik, allallahu alejhi ve sellem,<span class="c6"> je kazao:</span> "Tri su svojstva licemjera...<span class="c6">" Jedno od njih je:</span> "Kada govori-laže, a kada obeća-prekrši." Muttefekun \'alejh. </p>',
            ],
            9 => [
                'question' => 'Pitanje br. 10: Koje su vrste strpljenja?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13140.mp3',
                'answer' => '<p> Odgovor: Strpljenje u pokornosti Allahu.<br /> Strpljenje u ostavljanju grijeha.<br /> Strpljenje na nedaćama koje su nam određene i zahvalnost Allahu u svakome stanju.<span class="c6"><br /> Uzvišeni Allah veli:</span> "Allah voli strpljive." <span class="c2">(Ali \'Imran, 146)</span>. Rekao je Vjerovjesnik,<span class="c6"> sallallahu alejhi ve sellem:</span> "Čudan je slučaj sa vjernikom, on je uvijek na dobitku, a tako je samo sa vjernikom. Ako ga snađe neko dobro, on zahvaljuje, pa je na dobitku, a ako ga snađe nešto loše, on sabura, pa je na dobitku." Hadis bilježi Muslim. </p>',
            ],
            10 => [
                'question' => 'Pitanje br. 11: Šta je suprotno strpljenju?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13210.mp3',
                'answer' => '<p> Odgovor: Nepostojanje strpljenja u pokornosti Allahu i u ostavljanju grijeha, te negodovanje riječima ili djelima u pogledu onoga što nam je Allah odredio.<span class="c6"><br /> Oblici ove osobine:</span><br /> Želja za smrću.<br /> Udaranje po obrazima <span class="c2">(licu)</span>.<br /> Kidanje/cijepanje odjeće.<br /> Raspršivanje <span class="c2">(zapuštanje)</span> kose.<br /> Dova protiv sebe.<br /> Rekao je Vjerovjesnik,<span class="c6"> sallallahu alejhi ve sellem:</span> „Zaista je veličina nagrade prema veličini iskušenja. Uslijed toga, Uzvišeni Allah kada zavoli jedan narod, postavi ga na razne kušnje. U skladu s tim, ko bude zadovoljan sa tim, Allah će biti zadovoljan sa njim, a ko se rasrdi zbog toga, njemu pripada Allahova srdžba.“ Hadis bilježe Tirmizi i Ibn Madže. </p>',
            ],
            11 => [
                'question' => 'Pitanje br. 12: Šta je to međusobno pomaganje?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13310.mp3',
                'answer' => '<p> Odgovor: To je potpomaganje ljudi u istini i dobru.<span class="c6"><br /> Neki od oblika ove osobine:</span><br /> Potpomaganje u ispunjavanju tuđih prava.<br /> Potpomaganje u suzbijanju nepravde.<br /> Potpomoganje u ispunjavanju ljudskih potreba.<br /> Potpomaganje u svakoj vrsti dobra.<br /> Nepotpomaganje u grijehu i neprijateljstvu.<span class="c6"><br /> Uzvišeni Allah veli:</span> "Jedni drugima pomažite u dobročinstvu i čestitosti, a ne sudjelujte u grijehu i neprijateljstvu; i bojte se Allaha, jer Allah strašno kažnjava." <span class="c2">(El-Maide, 2)</span>. Rekao je Vjerovjesnik,<span class="c6"> sallallahu alejhi ve sellem:</span> "Vjernici su poput građevine čiji dijelovi jedni druge ojačavaju i učvršćuju." Muttefekun \'alejh. Rekao je Vjerovjesnik,<span class="c6"> sallallahu alejhi ve sellem:</span> "Musliman je brat muslimanu; ne čini mu nepravdu, niti dopušta da mu se nepravda čini. Ko pomogne svome bratu u nevolji, Allah će njemu pomoći u njegovoj. Ko otkloni nedaću jednog muslimana, Allah će njemu otkloniti jednu od njegovih nedaća na Sudnjem danu. A ko prikrije <span class="c2">(sramote)</span> jednog muslimana, Allah će prikriti njegove na Sudnjem danu." Muttefekun \'alejh. </p>',
            ],
            12 => [
                'question' => 'Pitanje br. 13: Koje su vrste stida?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13420.mp3',
                'answer' => '<p> Odgovor: 1. Stid od Allaha, u smislu da Mu se ne čine grijesi.<br /> 2. Stid od ljudi, kao na primjer da se ne govore ružne riječi, da se ne otkriva stidni dio tijela i tome slično.<br /> Poslanik, sallallahu alejhi ve sellem,<span class="c6"> je rekao:</span> "Iman se sastoji od sedamdeset i nekoliko ogranaka <span class="c2">(dijelova)</span>, ili šezdeset i nekoliko dijelova. Najvrednije je svjedočenje da nema drugog istinskog boga osim Allaha, a najmanje vrijedan je uklanjanje prepreke <span class="c2">(onoga što smeta)</span> s puta; a i stid je dio imana." Hadis bilježi Muslim. </p>',
            ],
            13 => [
                'question' => 'Pitanje br. 14: Spomeni neke oblike samilosti!',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13470.mp3',
                'answer' => '<p> Odgovor: Samilost prema starijima i njihovo uvažavanje.<br /> Samilost prema mlađima i djeci.<br /> Samilost prema siromasima, nevoljnicima i ljudima u potrebi.<br /> Samilost prema životinjama na način da se hrane i da se ne uznemiravaju.<br /> U ovo se ubraja i hadis Poslanika,<span class="c6"> sallallahu alejhi ve sellem:</span> "Vjernici, u međusobnoj pažnji, milosrđu i saosjećanju su poput jednog tijela. Kada oboli jedan njegov organ, svi ostali organi mu se odazovu i pridruže u bolu sa nesanicom i groznicom." Muttefekun \'alejh. Rekao je Poslanik,<span class="c6"> sallallahu alejhi ve sellem:</span> "Milostivi Allah smilovat će se onima koji su samilosni. Budite milostivi prema stanovnicima zemlje, pa će vam se smilovati Onaj koji je na nebesima." Hadis bilježe Ebu Davud i Tirmizi. </p>',
            ],
            14 => [
                'question' => 'Pitanje br. 15: Koje su vrste ljubavi?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13550.mp3',
                'answer' => '<p> Odgovor: Ljubav prema Allahu.<span class="c6"><br /> Uzvišeni Allah veli:</span> "A vjernici još više Allaha vole." <span class="c2">(El-Bekare, 165)</span>.<br /> Ljubav prema Poslaniku, sallallahu alejhi ve sellem.<br /> Poslanik, sallallahu alejhi ve sellem,<span class="c6"> je rekao:</span> "Tako mi Onoga u čijoj ruci je moja duša, niko od vas neće vjerovati, sve dok mu ne budem draži od roditelja i djece." Hadis bilježi Buhari.<br /> Ljubav prema vjernicima i želja da im bude dobro, baš onako kao što i sebi želimo.<br /> Rekao je Vjerovjesnik,<span class="c6"> sallallahu alejhi ve sellem:</span> "Niko od vas neće biti pravi vjernik sve dok ne bude želio svome bratu ono što želi samome sebi." Hadis bilježi Buhari. </p>',
            ],
            15 => [
                'question' => 'Pitanje br. 16: Šta je to ljubaznost?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13630.mp3',
                'answer' => '<p> Odgovor: To je blagost na licu popraćena radošću, osmijehom i pokazivanjem zadovoljstva pri susretu s ljudima.<br /> Ona je suprotna od namrštenosti koja odbija ljude.<br /> U pogledu vrijednosti ove osobine preneseni su mnogobrojni hadisi.<span class="c6"> Jedan od njih prenosi Ebu Zerr u kojem stoji:</span> "Nemoj potcjenjivati ni trun dobra, makar to bilo da sretneš svoga brata vedrog lica." Hadis bilježi Muslim. Rekao je Poslanik,<span class="c6"> sallallahu alejhi ve sellem:</span> "U sadaku se ubraja i to da se osmjehneš bratu muslimanu." Hadis bilježi Tirmizi. </p>',
            ],
            16 => [
                'question' => 'Pitanje br. 17: Šta je to zavidnost?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13690.mp3',
                'answer' => '<p> Odgovor: Želja da nestane blagodat u kojoj neko uživa ili preziranje da drugi uživaju u određenoj blagodati.<span class="c6"><br /> Rekao je Uzvišeni Allah:</span> "I od zla zavidljivca kad zavist ne krije!" <span class="c2">(El-Felek, 5)</span>.<br /> Prenosi se od Enesa b. Malika da je Poslanik, sallallahu alejhi ve sellem,<span class="c6"> rekao:</span> "Nemojte se međusobno mrziti, nemojte jedni drugima zavidjeti i okretati leđa, nego, robovi Allahovi, budite braća!" Hadis bilježe Buhari i Muslim. </p>',
            ],
            17 => [
                'question' => 'Pitanje br. 18: Šta je to izrugivanje?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13740.mp3',
                'answer' => '<p> Odgovor: To je ismijavanje i ponižavanje brata muslimana. To nije dozvoljeno.<span class="c6"><br /> Rekao je Uzvišeni Allah:</span> "O vjernici, neka se muškarci jedni drugima ne rugaju, možda su oni bolji od njih, a ni žene drugim ženama, možda su one bolje od njih. I ne kudite jedni druge i ne zovite jedni druge ružnim nadimcima! O, kako je ružno da se vjernici spominju podrugljivim nadimcima! A oni koji se ne pokaju - sami sebi čine nepravdu." <span class="c2">(El-Hudžurat, 11)</span>. </p>',
            ],
            18 => [
                'question' => 'Pitanje br. 19: Šta je to poniznost?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13780.mp3',
                'answer' => '<p> Odgovor: Poniznost je kada čovjek sebe ne smatra boljim od drugih, kada druge ne omalovažava i ne odbacuje istinu.<span class="c6"><br /> Uzvišeni Allah veli:</span> "A robovi Milostivoga su oni koji po Zemlji mirno hodaju." <span class="c2">(El-Furkan, 63)</span>.<span class="c6"> Mirno hodaju:</span> ponizno, skromno i staloženo. Rekao je Poslanik,<span class="c6"> sallallahu alejhi ve sellem:</span> "Niko se neće poniziti radi Allaha, a da ga On neće uzdići." Hadis bilježi Muslim. Poslanik, sallallahu alejhi ve sellem,<span class="c6"> rekao je:</span> "Zaista mi je Allah objavom naredio da budete međusobno ponizni tako da se jedan ne oholi prema drugom, niti da jedan drugog napada." Hadis bilježi Muslim. </p>',
            ],
            19 => [
                'question' => 'Pitanje br. 20: Koje su vrste oholosti koja je zabranjena?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13840.mp3',
                'answer' => '<p> Odgovor: Oholost nad istinom, u smislu da se ona odbacuje i da se kao takva ne prihvata.<br /> Oholost nad ljudima koja označava njihovo omalovažavanje i ponižavanje.<br /> Rekao je Poslanik,<span class="c6"> sallallahu alejhi ve sellem:</span> "U Džennet neće ući onaj koji u svome srcu ima koliko i trunčicu oholosti.<span class="c6">" Neki čovjek ga upita:</span> \'Zaista čovjek voli da mu odjeća i obuća budu lijepi.<span class="c6">\' Na to mu Allahov Poslanik reče:</span> Zaista je Allah lijep i voli ljepotu. Oholost je odbijanje istine i ponižavanje ljudi.\'“ Hadis bilježi Muslim.<br /> Odbijanje istine je njeno odbacivanje i neprihvatanje.<br /> Ponižavanje ljudi je njihovo omalovažavanje.<br /> Nošenje lijepe odjeće i obuće ne ubraja se u oholost. </p>',
            ],
            20 => [
                'question' => 'Pitanje br. 21: Spomeni neke vrste prevare koja je zabranjena!',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13910.mp3',
                'answer' => '<p> Odgovor: Prevara u kupoprodaji na način da se prikrije mahana robe.<br /> Prevara u nauci, kao npr. da se vara na ispitima.<br /> Prevara u govoru na način da se lažno svjedoči.<br /> Neispunjavanje onoga što je dogovoreno.<br /> U kontekstu zabrane varanja bilježi se i da je Allahov Poslanik, sallallahu alejhi ve sellem, naišao pored gomile hrane u koju je zavukao ruku, i kada je osjetio vlagu pod prstima,<span class="c6"> upitao je prodavača:</span> "Šta je ovo, vlasniče hrane?" "Pokisnulo je,<span class="c6"> Allahov Poslaniče!" On tada reče:</span> "Zašto vlažnu hranu nisi stavio na vrh da je ljudi vide? Nije od nas onaj ko nas vara!" Hadis bilježi Muslim.<br /> Es-<span class="c6">Subrah:</span> Gomila hrane. </p>',
            ],
            21 => [
                'question' => 'Pitanje br. 22: Šta je to gibet/ogovaranje?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13990.mp3',
                'answer' => '<p> Odgovor: Spominjanje brata muslimana koji nije prisutan u vezi sa onim što on ne voli da se spominje.<span class="c6"><br /> Uzvišeni Allah veli:</span> "I ne ogovarajte jedni druge! Zar bi nekome od vas bilo drago da jede meso umrloga brata svoga - a vama je to odvratno - zato se bojte Allaha, Allah, zaista, prima pokajanje i samilostan je." <span class="c2">(El-Hudžurat, 12)</span>. </p>',
            ],
            22 => [
                'question' => 'Pitanje br. 23: Šta je to nemimet?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14030.mp3',
                'answer' => '<p> Odgovor: Prenošenje tuđeg govora s ciljem zavađanja ljudi.<br /> Rekao je Poslanik,<span class="c6"> sallallahu alejhi ve sellem:</span> "U Džennet neće ući onaj koji prenosi tuđe riječi s ciljem da zavadi ljude." Hadis bilježi Muslim. </p>',
            ],
            23 => [
                'question' => 'Pitanje br. 24: Šta je to lijenost?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14070.mp3',
                'answer' => '<p> Odgovor: Lijenost je nedostatak volje za činjenjem dobra i u obavljanju onoga što je obaveza.<br /> Primjer tome je lijenost u pogledu izvršavanja obaveznih djela.<span class="c6"><br /> Rekao je Uzvišeni:</span> "Licemjeri, zaista, nastoje prevariti Allaha, ali On će njih u tome<br /> nadmudriti. Kada ustaju da namaz obavljaju, lijeno se dižu i prikazuju<br /> se svijetu, a Allaha samo malo spominju." <span class="c2">(En-Nisa, 142)</span>.<br /> Vjernik ne treba da bude lijen, letargičan i trom u radu i kretanju. On, naime, treba da bude marljiv radeći ono sa čime je Uzvišeni Allah zadovoljan. </p>',
            ],
            24 => [
                'question' => 'Pitanje br. 25:Koje su vrste srdžbe?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14130.mp3',
                'answer' => '<p> Odgovor: 1 Pohvalna srdžba, koja biva radi Allaha i to u slučaju kada nevjernici, licemjeri i bilo ko drugi krši Allahove granice.<br /> 2. Pokuđena srdžba koja čovjeka navraća da uradi ili kaže ono što ne priliči.<br /> Kako liječiti pokuđenu srdžbu?<br /> Abdestom.<br /> Ukoliko čovjek stoji treba sjesti, a ukoliko sjedi treba leći.<br /> Sprovođenje oporuke koju je ostavio Poslanik, sallallahu alejhi ve sellem,<span class="c6"> kada je rekao:</span> "Ne srdi se!"<br /> Samokontrola.<br /> Traženje zaštite kod Allaha od prokletog šejtana.<br /> Šutnja. </p>',
            ],
            25 => [
                'question' => 'Pitanje br. 26: Šta je to uhođenje?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14240.mp3',
                'answer' => '<p> Otkrivanje i praćanje ljudskih mahana i svega onoga što oni skrivaju.<span class="c6"><br /> Neki oblici ove ružne osobine:</span><br /> Gledanje u ono što ljudi skrivaju u kućama.<br /> Slušanje govora ljudi bez njihovog znanja <span class="c2">(dozvole)</span>.<span class="c6"><br /> Uzvišeni Allah veli:</span> "I jedni druge nemojte uhoditi." <span class="c2">(El-Hudžurat, 12)</span>. </p>',
            ],
            26 => [
                'question' => 'Pitanje br. 27: Šta je to rasipanje, škrtost i plemenitost?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14310.mp3',
                'answer' => '<p> Odgovor: Rasipanje je trošenje imetka na način kako nije propisano da se troši.<br /> Njemu je suprotna škrtost koja označava uskraćivanje imetka tamo gdje je propisano da se troši.<br /> Umjerenost je bolja od tog dvoga, a pored toga musliman treba da bude plemenit.<span class="c6"><br /> Uzvišeni Allah veli:</span> "i oni koji, kad udjeljuju, ne rasipaju i ne škrtare, već se u tome drže sredine." <span class="c2">(El-Furkan, 67)</span>. </p>',
            ],
            27 => [
                'question' => 'Pitanje br. 28: Šta je to kukavičluk, a šta hrabrost?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14370.mp3',
                'answer' => '<p> Odgovor: Kukavičluk je strah od nečega za što ne priliči da ga se boji.<br /> Primjer tome je strah od kazivanja istine i osude zla.<br /> Hrabrost je kada je neko odlučan u istini, poput toga da bude neustrašiv u borbi za odbranu islama i muslimana.<br /> Poslanik, sallallahu alejhi ve sellem,<span class="c6"> učio bi sljedeću dovu:</span> "Allahu moj, zaštiti me od kukavičluka..." Rekao je Poslanik,<span class="c6"> sallallahu alejhi ve sellem:</span> „Jak vjernik bolji je i Allahu draži od nejaka vjernika, a u obojici je dobro." Hadis bilježi Muslim. </p>',
            ],
            28 => [
                'question' => 'Pitanje br. 29: Spomeni neke primjere zabranjenog govora.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14440.mp3',
                'answer' => '<p> Odgovor: Proklinjanje i vrijeđanje.<br /> Nazivanje nekoga životinjom ili tome slično.<br /> Spominjanje riječi koje su razvratne i bespramne.<br /> Poslanik, sallallahu alejhi ve sellem,<span class="c6"> zabranio je sve ovo kazavši:</span> "Vjernik ne vrijeđa, ne proklinje, nije bestidan niti besraman.“ Hadis bilježe Tirmizi i Ibn Hibban. </p>',
            ],
            29 => [
                'question' => 'Pitanje br. 30: Koje su to stvari koje čovjeku pomažu da se okiti lijepim svojstvima?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14500.mp3',
                'answer' => '<p> Odgovor: 1. Tražiti od Allaha da nam podari lijepo ponašanje i da nas pomogne u tome.<br /> 2. Svijest o tome da nas Allah prati, te da zna, čuje i vidi šta radimo.<br /> 3. Svijest o nagradi za lijepo ponašanje, te da znamo da je isto uzrok ulaska u Džennet.<br /> 4. Podsjećanje na loše posljedice ružnog ponašanja, te da je ono jedan od uzroka ulaska u Vatru.<br /> 5. Lijepo ponašanje vodi ka Allahovoj ljubavi, ali i ljubavi stvorenja. S druge strane, ružno ponašanje donosi Allahovu srdžbu, ali i srdžbu ljudi.<br /> 6. Čitanje životopisa Poslanika, sallallahu alejhi ve sellem, i slijeđenje njegove prakse.<br /> 7. Druženje sa dobrim ljudima i udaljavanje od zlih. </p>',
            ],
        ],
        8 => [
            0 => [
                'question' => 'Pitanje br. 1: Koja je vrijednost zikra?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14630.mp3',
                'answer' => '<p> Odgovor: Rekao je Vjerovjesnik,<span class="c6"> sallallahu alejhi ve sellem:</span> "Onaj koji zikr čini <span class="c2">(spominje svoga Gospodara)</span> i onaj ko Ga ne spominje su poput živog i mrtvog čovjeka." Hadis bilježi Buhari.<br /> Ovo je zbog toga što se vrijednost čovjekovog života mjeri shodno njegovom spominjanju Allaha. </p>',
            ],
            1 => [
                'question' => 'Pitanje br. 2: Koje su koristi zikra?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14670.mp3',
                'answer' => '<p> Odgovor: 1. On donosi Allahovo zadovoljstvo.<br /> 2. Tjera šejtana.<br /> 3. Štiti muslimana od zla.<br /> 4. Donosi mu velike nagrade. </p>',
            ],
            2 => [
                'question' => 'Pitanje br. 3: Koji je najbolji zikr?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14730.mp3',
                'answer' => '<p> Odgovor: La ilahe illellah. Hadis o tome su zabilježili Tirmizi i Ibn Madže. </p>',
            ],
            3 => [
                'question' => 'Pitanje br. 4: Šta se uči kada se probudi nakon spavanja?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14760.mp3',
                'answer' => '<p> Odgovor: Elhamdu lillahillezi ahjana ba\'de ma ematena ve ilejhi-n-nušur/Hvala Allahu koji nas je proživio <span class="c2">(dao da se probudimo)</span>, nakon što nas je usmrtio <span class="c2">(dao nam da spavamo)</span>, i kod Njega je <span class="c2">(konačno)</span> okupljanje. Muttefekun \'alejh. </p>',
            ],
            4 => [
                'question' => 'Pitanje br. 5: Šta se uči prilikom oblačenja odjeće?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14790.mp3',
                'answer' => '<p> Odgovor: El-hamdu lillahillezi kesani hazas-sevbe ve rezakanihi min gajri havlin minni ve la kuvvetin/Hvala Allahu, Koji me je odjenuo ovim <span class="c2">(ovom odjećom)</span>, i koji me je opskrbio bez moje pomoći i moći. Hadis bilježe Ebu Davud, Tirmizi i drugi. </p>',
            ],
            5 => [
                'question' => 'Pitanje br. 6: Šta se uči prilikom skidanja odjeće?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14820.mp3',
                'answer' => '<p> Odgovor: Bismillahi/u ime Allaha. Hadis bilježi Tirmizi. </p>',
            ],
            6 => [
                'question' => 'Pitanje br. 7: Šta su uči prilikom odijevanja nove odjeće?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14850.mp3',
                'answer' => '<p> Odgovor: Allahumme lekel-hamdu, ente kesevtenihi. Es\'eluke min hajrihi vehajri ma suni‘a lehu. Ve e’uzu bike min šerrihi ve šerri ma suni‘a lehu/Allahu moj, Tebi hvala. Ti si me ovim odjenuo. Molim Te za dobro, koje mi ono pruža, i u čijoj je funkciji, a prizivam Te protiv zla njegova i onoga koje iz njega može proisteći. Hadis bilježe Ebu Davud i Tirmizi. </p>',
            ],
            7 => [
                'question' => 'Pitanje br. 8: Koja je dova za onoga ko obuče novu odjeću?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14880.mp3',
                'answer' => '<p> Odgovor: Kada vidiš na nekome novu odjeću,<span class="c6"> reci:</span> Tubli ve juhlifullahu te‘ala/Iznosio je, a novom te Allah počastio. Ovaj hadis je zabilježio Ebu Davud. </p>',
            ],
            8 => [
                'question' => 'Pitanje br. 9: Šta se uči prilikom ulaska u toalet?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14910.mp3',
                'answer' => '<p> Odgovor: Bismillahi. Allahhumme inni e’uzu bike minel-hubusi vel-habaisi/U ime Allaha. Allahu moj, prizivam Te protiv zla šejtana i šejtanica. Muttefekun \'alejh. </p>',
            ],
            9 => [
                'question' => 'Pitanje br. 10: Šta se uči prilikom izaska iz toaleta?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14940.mp3',
                'answer' => '<p> Odgovor: Gufraneke/Tvoj oprost tražim. Ovaj hadis su zabilježili Ebu Davud i Tirmizi. </p>',
            ],
            10 => [
                'question' => 'Pitanje br. 11: Šta se uči prije abdesta?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14970.mp3',
                'answer' => '<p> Odgovor: Bismillahi/u ime Allaha. Hadis bilježi Ebu Davud i drugi. </p>',
            ],
            11 => [
                'question' => 'Pitanje br. 12: Šta se uči nakon uzimanja abdesta?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15000.mp3',
                'answer' => '<p> Odgovor: Ešhedu en la ilahe illallahu vahdehu la šerike lehu, ve ešhedu enne Muhammeden abduhu ve resuluhu/Svjedočim da nema drugog istinskog boga osim Allaha, Jedinog. On nema sudruga. I svjedočim da je Muhammed Njegov rob i poslanik. Hadis bilježi Muslim. </p>',
            ],
            12 => [
                'question' => 'Pitanje br. 13: Koja se dova uči prilikom izlaska iz kuće?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15020.mp3',
                'answer' => '<p> Odgovor: Bismillahi, tevekkeltu ‘alellahi, ve la havle ve la kuvvete illa billahi/U ime Allaha, u Allaha se pouzdam, nema pomoći niti moći mimo Allahove. Hadis bilježe Ebu Davud i Tirmizi. </p>',
            ],
            13 => [
                'question' => 'Pitanje br. 14: Šta se uči prilikom ulaska u kuću?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15050.mp3',
                'answer' => '<p> Odgovor: Bismillahi veledžna ve bismillahi haredžna ve ala Rabbina tevekkelna/S Allahovim imenom ulazimo i sa Njegovim imenom izlazimo. Na Gospodara našega se oslanjamo. Nakon toga, prisutne trebamo poselamiti. Ovaj hadis je zabilježio Ebu Davud. </p>',
            ],
            14 => [
                'question' => 'Pitanje br. 15: Koja je dova propisana prilikom ulaska u džamiju?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15080.mp3',
                'answer' => '<p> Odgovor: Allahummeftah li ebvabe rahmetike/Allahu moj, otvori mi vrata milosti Tvoje!<br /> Hadis bilježi Muslim. </p>',
            ],
            15 => [
                'question' => 'Pitanje br. 16: Koja je dova propisana prilikom izlaska iz džamije?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15110.mp3',
                'answer' => '<p> Odgovor: Allahumme inni es‘eluke min fadlike/Allahu moj, molim Ti se da me dobrom obaspeš. Hadis bilježi Muslim. </p>',
            ],
            16 => [
                'question' => 'Pitanje br. 17: Šta se uči prilikom slušanja ezana?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15140.mp3',
                'answer' => '<p> Odgovor: Ponavlja se za mujezinom osim kod riječi: <span class="c1">“Dođite na namaz, dođite na spas”</span>, -<span class="c6"> poslije kojih se uči:</span> <span class="c1">“la havle ve la kuvvete illa billahi/Nema pomoći niti moći mimo Allahove.”</span> Muttefekun \'alejh. </p>',
            ],
            17 => [
                'question' => 'Pitanje br. 18: Šta se izgovara nakon ezana?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15170.mp3',
                'answer' => '<p> Odgovor: Donosi se salavat na Poslanika, sallallahu alejhi ve sellem. Hadis bilježi Muslim.<span class="c6"> Zatim se treba izgovoriti:</span> Allahumme Rabbe hazihid-da\'vetit-tammeti ves-salatil-kaimeti ati Muhammedenil-vesilete vel-fadilete veb\'ashu mekamen mahmudenillezi ve‘adtehu/Allahu moj, Gospodaru ove cjelovite molbe i namaza koji se upravo uspostavlja, podari Muhammedu veliki stepen u Džennetu i svako dobro, uzdigni ga na uzvišeno mjesto, koje si mu obećao. Ovaj hadis je zabilježio Buhari.<br /> Nakon ezana i ikameta, ako se ima prilike, treba doviti, jer se tada dova ne odbija. </p>',
            ],
            18 => [
                'question' => 'Pitanje br. 19: Koji se zikrovi uče jutrom i uvečer?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15220.mp3',
                'answer' => '<p> Odgovor: 1. Ajetul-kursijj Allah je, nema boga osim Njega, Živi i Samoopstojeći Održavatelj!<br /> Ne obuzima Ga ni drijemež ni san! Njegovo je ono što je na nebesima<br /> i na Zemlji! Ko je taj ko se može pred Njim zauzimati bez Njegovog<br /> dopuštenja?! On zna šta je bilo prije i šta će biti poslije njih, i oni ne<br /> mogu obuhvatiti od Njegovoga znanja osim koliko On želi. Njegova<br /> Kursija obuhvata i nebesa i Zemlju i Njemu nije teško održavati<br /> ih! On je Svevišnji i Veličanstveni! <span class="c2">(El-Bekare, 255)</span>. 2.<span class="c6"> Također se uči:</span> Bismillahir-rahmanir-rahim/U ime Allaha, Milostivog, Samilosnog. Sura el-<span class="c6">Ihlas:</span> Reci: “On je Allah – Jedan! Allah je utočište svakome. Nije rodio i rođen nije, i niko Mu ravan nije!" Tri puta. 2.<span class="c6"> Također se uči:</span> Bismillahir-rahmanir-rahim/U ime Allaha, Milostivog, Samilosnog. Sura el-<span class="c6">Felek:</span> Reci: "Utječem se Gospodaru svitanja, od zla onoga što On stvara. i od zla mrkle noći kada razastre tmine, i od zla smutljivca kad smutnje sije, i od zla zavidljivca kad zavist ne krije!" Tri puta. 2.<span class="c6"> Također se uči:</span> Bismillahir-rahmanir-rahim/U ime Allaha, Milostivog, Samilosnog. Sura en-<span class="c6">Nas:</span> Reci: "Tražim zaštitu Gospodara ljudi, Vladara ljudi, Boga ljudi, od zla šejtana napasnika, koji zle misli unosi u srca ljudi - od džina i od ljudi!" Tri puta. Allahumme Ente Rabbi, la ilahe illa Ente, halakteni ve ene ‘abduke ve, ene ‘ala ahdike ve va’dike mesteta’tu, e’uzu bike min šerri ma sana’tu, ebu’u leke bi ni’metike ‘alejje, ve ebu’u bi zenbi, fagfir li, fe innehu la jagfiruz-zunube illa Ente/\'Allahu, Ti si moj Gospodar, i samo si Ti istinski Bog, stvorio si me i ja sam Ti rob. Ugovor ispunjavam i održavam obećanje koliko mogu. Zaštiti me od zla mojih djela. Priznajem Tvoje blagodati prema meni i priznajem svoje grijehe, pa mi ih oprosti, jer samo Ti opraštaš grijehe! Hadis bilježi Buhari. </p>',
            ],
            19 => [
                'question' => 'Pitanje br. 20: Šta se uči prije spavanja?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15290.mp3',
                'answer' => '<p> Odgovor: Bismikellahumme emutu ve ahja/S Tvojim imenom, Allahu moj, umirem i živim. Muttefekun \'alejh. </p>',
            ],
            20 => [
                'question' => 'Pitanje br. 21: Šta se uči prije jela?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15320.mp3',
                'answer' => '<p> Odgovor: Bismillahi/u ime Allaha.<br /> Ako se zaboravi,<span class="c6"> onda se treba reći tokom jela:</span><br /> Bismillahi evvelehu ve ahirehu/U ime Allaha i na početku i na kraju. Hadis bilježe Ebu Davud i Tirmizi. </p>',
            ],
            21 => [
                'question' => 'Pitanje br. 22: Šta se uči nakon jela?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15370.mp3',
                'answer' => '<p> Odgovor: El-hamdu lillahillezi at\'ameni haza ve rezakanihi min gajri havlin minni ve la kuvvetin/Hvala Allahu, Koji me je nahranio i koji me je opskrbio bez moje pomoći i moći. Hadis bilježe Ebu Davud, Ibn Madže i drugi. </p>',
            ],
            22 => [
                'question' => 'Pitanje br. 23: Koju dovu uči gost za domaćina poslije jela?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15400.mp3',
                'answer' => '<p> Odgovor: Allahumme barik lehum fima rezaktehum va-gfir lehum ve-rhamhum/Allahu, blagoslovi im ono čime si ih opskrbio, oprosti im i smiluj im se! Hadis bilježi Muslim. </p>',
            ],
            23 => [
                'question' => 'Pitanje br. 24: Šta se kaže kada se kihne?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15430.mp3',
                'answer' => '<p> Odgovor: El-Hamdu lillahi/Hvala Allahu.<br /> Onaj ko čuje da je neko kihnuo i zahvalio se Allahu,<span class="c6"> treba mu reći:</span> jerhamukellah/Allah ti se smilovao.<br /> A onaj ko je kihnuo,<span class="c6"> nakon toga treba reći:</span> Jehdikumullahu ve juslihu balekum/Allah te uputio i stanje ti popravio. Hadis bilježi Buhari. </p>',
            ],
            24 => [
                'question' => 'Pitanje br. 25: Šta se uči nakon sijela kao dova iskupa za učinjene greške?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15480.mp3',
                'answer' => '<p> Odgovor: Subhanekellahume ve bi hamdike, ešhedu en la ilahe illa ente, estagfiruke ve etubu ilejke/Slavljen i hvaljen si, Allahu moj, svjedočim da si samo Ti istinski Bog, od Tebe oprost tražim i Tebi se kajem. Hadis bilježe Ebu Davud, Tirmizi i drugi. </p>',
            ],
            25 => [
                'question' => 'Pitanje br. 26: Koja se dova uči prilikom ulaska u prevozno sredstvo?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15510.mp3',
                'answer' => '<p> Odgovor: Bismillahi, elhamdu lillahi. Subhanellezi sehhare lena haza ve ma kunna lehu mukrinine, ve inna ila rabbina le munkalibun. Elhamdu lillahi elhamdu lillahi elhamdu lillahi. Allahu ekber, Allahu ekber, Allahu ekber. Subhanekellahume inni zalemtu nefsi, fagfir li, fe innehu la jagfiruz-zunube illa ente/S Allahovim imenom <span class="c2">(polazim)</span>. Hvala Allahu. Slavljen neka je Onaj Koji nam je omogućio ovo putovanje za koje mi nismo bili sposobni. Mi se, doista, Gospodaru našem vraćamo. Hvala Allahu, hvala Allahu, hvala Allahu. Allah je najveći, Allah je najveći, Allah je najveći. Neka si slavljen, Allahu. Zaista sam počinio nasilje prema sebi, zato - oprosti mi. Jer, grijehe, zasigurno, ne oprašta niko drugi osim Tebe! Hadis bilježe Ebu Davud i Tirmizi. </p>',
            ],
            26 => [
                'question' => 'Pitanje br. 27: Koja je putna dova?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15540.mp3',
                'answer' => '<p> Odgovor: Allahu ekber, Allahu ekber, Allahu ekber. Subhanellezi sehhare lena haza ve ma kunna lehu mukrinine, ve inna ila rabbina le munkalibun. Allahumme inna nes‘eluke fi seferina haza el-birre, vet-takva ve minel-’ameli ma terda. Allahumme hevvin ‘alejna seferena haza vatvi’ ‘anna bu‘dehu. Allahumme entes-sahibu fis-seferi vel-halifetu fil-ehli. Allahumme inni e’uzu bike min va‘sais-seferi ve keabetil-menzari ve suil-munkalebi fil-mali vel-ehli/Allah je najveći, Allah je najveći, Allah je najveći. Neka je slavljen Onaj Koji nam je omogućio ovo putovanje, a mi ga ne bismo bili sposobni obaviti sami. Mi se, doista, Gospodaru našem vraćamo. Allahu, molimo Te da nas prati dobro na putu našem i odanost Tebi, a od naših djela samo ona kojima si Ti zadovoljan! Allahu, olakšaj nam ovo putovanje, a razdaljinu njegovu podnošljivom! Allahu, Ti si Gospodar na putu i čuvar u porodici, zato - zaštiti me od zamora i nesreća na putu,<span class="c6"> te tuge koja bi me mogla zadesiti zbog imovine i porodice!<br /> A kada bi se vraćao s putovanja isto bi ovo izgovorio i još bi dodao:</span><br /> “Ajibune, taibune, ‘abidune, li rabbina hamidune/Vraćamo se i trajno kajemo, Allahu svome pobožni i zahvalni! Hadis bilježi Muslim. </p>',
            ],
            27 => [
                'question' => 'Pitanje br. 28: Koju dovu uči putnik za one koji ostaju?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15590.mp3',
                'answer' => '<p> Odgovor: Estevdi\'ukumullahe ellezi la tud\'iu veda\'iuhu/Allahu vas na čuvanje ostavljam, a ono što se Njemu povjeri, neće se zagubiti. Hadis bilježe Ahmed i Ibn Madže. </p>',
            ],
            28 => [
                'question' => 'Pitanje br. 29: Koja se dova uči putniku?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15620.mp3',
                'answer' => '<p> Odgovor: Estevdi\'ullahe dineke ve emaneteke ve havatime \'amelike/Ostavljam kod Allaha na čuvanje tvoju vjeru, tvoju sigurnost i emanet, te ishod i kraj tvoga rada i života. Bilježe Ahmed i Tirmizi. </p>',
            ],
            29 => [
                'question' => 'Pitanje br. 30: Koju dovu treba proučiti prilikom ulaska na pijacu (trg)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15650.mp3',
                'answer' => '<p> Odgovor: La ilahe illellahu vahdehu la šerike lehu. Lehul-mulku ve lehul-hamdu, juhji ve jumitu ve huve hajjun la jemutu. Bi jedihil-hajru ve huve ‘ala kulli šej\'in kadir/Nema boga koji istinski zaslužuje da se obožava osim Allaha Jedinoga, Koji Sebi ravnog nema. Njemu pripada sva vlast i zahvalnost. On proživljava i usmrćuje, i On je Živi, Koji ne umire. U Njega je svako dobro i On sve može. Ovaj hadis bilježe Tirmizi i Ibn Madže. </p>',
            ],
            30 => [
                'question' => 'Pitanje br. 31: Koju dovu treba učiti u srdžbi?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15680.mp3',
                'answer' => '<p> Odgovor: E\'uzu billahi mineš-šejtanir-radžim/Utječem se Allahu od prokletog šejtana. Muttefekun \'alejh. </p>',
            ],
            31 => [
                'question' => 'Pitanje br. 32: Šta kazati onome ko nam učini dobro?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15710.mp3',
                'answer' => '<p> Odgovor: Allah te nagradio. Ovaj hadis je zabilježio Tirmizi. </p>',
            ],
            32 => [
                'question' => 'Pitanje br. 33: Šta treba reći kada nam se prevozno sredstvo pokvari ili se pojavi neki problem kod istog?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15740.mp3',
                'answer' => '<p> Odgovor: Bismillahi/u ime Allaha. Hadis bilježi Ebu Davud. </p>',
            ],
            33 => [
                'question' => 'Pitanje br. 34: Šta se kaže kada nas nešto obraduje i usreći?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15770.mp3',
                'answer' => '<p> Odgovor: “El-hamdu lillahillezi bi ni’metihi tetimmus-salihatu/Hvala Allahu, sa čijom se blagodati upotpunjuju dobra djela. Ovaj hadis su zabilježili Hakim i drugi. </p>',
            ],
            34 => [
                'question' => 'Pitanje br. 35: Šta se kaže kada nam se desi nešto što nas oneraspoloži?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15800.mp3',
                'answer' => '<p> Odgovor: “El-hamdu lillahi \'ala kulli halin/Hvala Allahu na svakom stanju. Hadis se nalazi u zbirci Sahihul-Džami\'. </p>',
            ],
            35 => [
                'question' => 'Pitanje br. 36: Kako nazvati selam i odgovoriti na njega?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15830.mp3',
                'answer' => '<p> Odgovor: Es-selamu \'alejkum ve rahmetullahi ve berakatuhu.<span class="c6"><br /> Odgovara se:</span> Ve \'alejkumusselamu ve rahmetullahi ve berakatuhu. Hadis bilježe Tirmizi, Ebu Davud i drugi. </p>',
            ],
            36 => [
                'question' => 'Pitanje br. 37: Koja se dova uči kada pada kiša?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15870.mp3',
                'answer' => '<p> Odgovor: Allahumme sajjiben nafi’an/Allahu, za kišu korisnu molim Te! Hadis bilježi Buhari. </p>',
            ],
            37 => [
                'question' => 'Pitanje br. 38: Koja se dova uči nakon kiše?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15900.mp3',
                'answer' => '<p> Odgovor: Mutirna bi fadlillahi ve rahmetihi/Kiša nam je podarena dobrotom Allahovom i Njegovom milošću. Ovaj hadis bilježe Buhari i Muslim. </p>',
            ],
            38 => [
                'question' => 'Pitanje br. 39: Koja dova se uči kada pušu vjetrovi?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15930.mp3',
                'answer' => '<p> Odgovor: Allahumme inni es\'eluke hajreha ve e’uzu bike min šerriha/Allahu, molim Te da ovo izađe na dobro i tražim Tvoju zaštitu u vezi sa nesrećom koja bi se mogla dogoditi! Ovaj hadis su zabilježili Ebu Davud i Ibn Madže. </p>',
            ],
            39 => [
                'question' => 'Pitanje br. 40: Spomeni dovu koja se uči prilikom grmljavine!',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15960.mp3',
                'answer' => '<p> Subhanellezi jusebbihur-ra’du bi hamdihi vel-melaiketu men hifetihi/Slava Onome Koga grom slavi hvalom, a i meleci iz straha prema Njemu! Ovaj hadis je zabilježio Malik u svojoj Muvetti. </p>',
            ],
            40 => [
                'question' => 'Pitanje br. 41: Koja dova se uči kada vidimo osobu u problemu i nedaći?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15990.mp3',
                'answer' => '<p> Odgovor: El-hamdu lillahillezi’ afani mimma ibtelake bihi ve feddaleni ‘ala kesirin mimmen haleka tefdila/Hvala Allahu, Koji me je zaštitio od onoga što je tebe zadesilo i koji mi je dao prednost nad mnogim Njegovim stvorenjima. Bilježi Tirmizi. </p>',
            ],
            41 => [
                'question' => 'Pitanje br. 42: Dova onoga ko se boji da nekoga ne urekne?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16020.mp3',
                'answer' => '<p> Odgovor: U hadisu se spominje: "Ako vidite nešto kod svog brata ili nešto što je u njegovom vlasništvu što vas zadivi, zamolite Allaha da mu to blagoslovi <span class="c2">(Allahumme barik fihi)</span>, jer urok je, doista, istina!" Ovaj hadis su zabilježili Ahmed, Ibn Madže i drugi. </p>',
            ],
            42 => [
                'question' => 'Pitanje br. 43: Način donošenja salavata na Poslanika, sallallahu alejhi ve sellem.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16050.mp3',
                'answer' => '<p> Odgovor: Allahumme salli \'ala Muhammed ve \'ala ali Muhammed, kema sallejte \'ala Ibrahime ve \'ala ali Ibrahim, inneke hamidun medžid. Allahumme barik \'ala Muhammedin ve \'ala ali Muhammed, kema barekte \'ala Ibrahime ve \'ala ali Ibrahim, inneke hamidun medžid/Allahu moj, pohvali Muhameda i porodicu Muhamedovu kao što si pohvalio Ibrahima i porodicu Ibrahimovu, zaista si Ti Hvaljeni Slavljeni. I blagoslovi Muhameda i porodicu Muhameda kao što si blagoslovio Ibrahima i porodicu Ibrahima, zaista si Ti Hvaljeni Slavljeni! <span class="c5">[165]</span> Muttefekun \'alejh. </p>',
            ],
        ],
        9 => [
            0 => [
                'question' => 'Pitanje br. 1: Kojih pet vrsta propisa postoji kada je riječ o stepenu njihove ne/obaveznosti?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16090.mp3',
                'answer' => '<p> Odgovor:<br /> 1. Vadžib-obavezno.<br /> 2. Mustehabb-pohvalno.<br /> 3. muharram-zabranjeno.<br /> 4. mekruh-pokuđeno.<br /> 5. mubah-dozvoljeno. </p>',
            ],
            1 => [
                'question' => 'Pitanje br. 2: Pojasni ovih pet propisa!',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16170.mp3',
                'answer' => '<p> Odgovor:<br /> 1.<span class="c6"> Vadžib:</span> npr. pet namaza, post ramazana, dobročinstvo prema roditeljima i tako dalje.<br /> Za činjenje vadžiba čovjek će dobiti nagradu, a za njegovo neizvršenje kaznu.<br /> 2.<span class="c6"> Mustehabb:</span> npr. namaski sunneti, noćni namaz, sadaka, selam. Sunnet se još naziva i mendub.<br /> Za činjenje mustehabba čovjek će imati nagradu, a za njegovo izostavljanje neće imati kaznu.<span class="c6"><br /> Veoma važna napomena:</span><br /> Kada musliman čuje da je nešto sunnet ili pohvalno, treba to da uradi i da slijedi Poslanika, sallallahu alejhi ve sellem.<br /> 3.<span class="c6"> Haram:</span> npr. konzumiranje alkohola, neposlušnost roditeljima, prekidanje rodbinskih veza i tako dalje.<br /> Za ostavljanje harama čovjek će imati nagradu, a za njegovo činjenje kaznu.<br /> 4.<span class="c6"> Mekruh:</span> npr. uzimanje i davanje lijevom rukom, skupljanje odjeće tokom namaza i tako dalje.<br /> Za ostavljanje mekruha čovjek će imati nagradu, a za njegovo činjenje nema kazne.<br /> 5.<span class="c6"> Mubah:</span> npr. jedenje jabuka, pijenje čaja i tako dalje. Naziva se još i halalom.<br /> Za ostavljanje dozvoljenog nema nagrade niti ima kazna ako se uradi. </p>',
            ],
            2 => [
                'question' => 'Pitanje br. 3: Koji je propis kupoprodaje i drugih društveno-imovinskih odnosa?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16320.mp3',
                'answer' => '<p> Odgovor: Osnovno pravilo kada je riječ o kupoprodaji i drugim društveno imovinskim odnosima jeste dozvoljenost. Izuzetak su neke vrste koje nam je zabranio Uzvišeni Allah.<span class="c6"><br /> Uzvišeni Allah veli:</span> "A Allah je dozvolio trgovinu, a zabranio kamatu." <span class="c2">(El-Bekare, 275)</span>. </p>',
            ],
            3 => [
                'question' => 'Pitanje br. 4: Spomeni neke vrste zabranjenih društveno-ekonomskih odnosa i kupoprodaje!',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16360.mp3',
                'answer' => '<p> Odgovor:<br /> 1. Varanje, kao npr. skrivanje mahana robe koja se prodaje.<br /> Ebu-Hurejre, radijallahu \'anhu, prenosi da je Allahov Poslanik, sallallahu alejhi ve sellem, naišao pored gomile hrane u koju je zavukao ruku, i kada je osjetio vlagu pod prstima,<span class="c6"> zapita prodavača:</span> "Šta je ovo, vlasniče hrane?" "Pokisnulo je,<span class="c6"> Allahov Poslaniče!" On tada reče:</span> "Zašto vlažnu hranu nisi stavio na vrh da je ljudi vide? Nije od nas onaj ko nas vara!" Hadis bilježi Muslim.<br /> 2. Kamata. Primjer tome jeste da se zadužimo hiljadu, pod uslovom da vratimo dvije.<br /> Ovaj višak naziva se kamatom i zbog toga je zabranjen.<span class="c6"><br /> Uzvišeni Allah veli:</span> "A Allah je dozvolio trgovinu, a zabranio kamatu." <span class="c2">(El-Bekare, 275)</span>.<br /> 3. Obmana i nepoznanica. Primjer tome jeste da se prodaje mlijeko u vimenu ovce ili riba u vodi, prije nego se ulovi.<br /> Poslanik, sallallahu alejhi ve sellem, zabranio je prodaju gdje postoji određena nejasnoća, obmana i nepoznanica. Hadis u vezi sa tim je zabilježio Muslim. </p>',
            ],
            4 => [
                'question' => 'Pitanje br. 4: Spomeni neke od Allahovih blagodati prema tebi!',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16460.mp3',
                'answer' => '<p> Odgovor: 1. Blagodat islama i to što nisi nevjernik.<br /> 2. Blagodat sunneta i to što nisi novotar.<br /> 3. Blagodat zdravlja i normalnog sluha, vida, hodanja i tome slično.<br /> 4. Blagodat hrane, pića i odjeće.<br /> Mnogobrojne su Allahove blagodati prema nama.<span class="c6"><br /> Uzvišeni Allah veli:</span> "Ako vi budete brojali Allahove blagodati, nećete ih nabrojati, - Allah, uistinu, prašta i samilostan je." <span class="c2">(En-Nahl, 18)</span>. </p>',
            ],
            5 => [
                'question' => 'Pitanje br. 6: Koje čovjek obaveze ima naspram blagodati i kako da budemo zahvalni na njima?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16540.mp3',
                'answer' => '<p> Odgovor: Obavezni smo zahvaljivati na blagodatima koje uživamo na način da iznosimo pohvalu Allahu, da Mu se zahvaljujemo riječima i da priznamo da svako dobro dolazi od Njega. Također, ove blagodati trebamo koristiti kako bismo stekli Njegovo zadovoljstvo, a ne da bismo sa njima činili grijehe. </p>',
            ],
            6 => [
                'question' => 'Pitanje br. 7: Koji su muslimanski praznici?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16570.mp3',
                'answer' => '<p> Odgovor: Ramazanski i Kurban bajram.<span class="c6"><br /> Prenosi se da je Enes rekao:</span> "Kada je Poslanik, sallallahu alejhi ve sellem, stigao u Medinu zatekao je ljude da imaju dva dana koja obilježavaju. O njima ih je upitao,<span class="c6"> a oni su mu rekli:</span> \'Još od prije islama ove dane obilježavamo.<span class="c6">\' Tada je Poslanik rekao:</span> "Umjesto ova dva dana,<span class="c6"> Allah vam je dao druga dva koja su bolja:</span> Kurbanski i Ramazanski bajram." Ovaj hadis je zabilježio Ebu Davud.<br /> Svi drugi praznici ubrajaju se u novotarije. </p>',
            ],
            7 => [
                'question' => 'Pitanje br. 8: Koji je najbolji mjesec?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16620.mp3',
                'answer' => '<p> Odgovor: Ramazan </p>',
            ],
            8 => [
                'question' => 'Pitanje br. 9: Koji je najbolji dan?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16650.mp3',
                'answer' => '<p> Odgovor: Petak. </p>',
            ],
            9 => [
                'question' => 'Pitanje br. 10: Koji je navrijedniji dan u godini?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16680.mp3',
                'answer' => '<p> Odgovor: Dan Arefata. </p>',
            ],
            10 => [
                'question' => 'Pitanje br. 11: Koja je najbolja noć u godini?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16710.mp3',
                'answer' => '<p> Odgovor: Noć Kadra. </p>',
            ],
            11 => [
                'question' => 'Pitanje br. 12: Šta nam je obaveza kada vidimo ženu s kojom nismo u srodstvu?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16740.mp3',
                'answer' => '<p> Odgovor: Da oborimo pogled.<span class="c6"> Allah Uzvišeni kaže:</span> "Reci vjernicima neka obore poglede svoje." <span class="c2">(En-Nur, 30.)</span> </p>',
            ],
            12 => [
                'question' => 'Pitanje br. 13: Ko su čovjekovi neprijatelji?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16770.mp3',
                'answer' => '<p> 1. Duša koja je sklona zlu koju čovjek prati i slijedi shodno svojim prohtjevima, čineći grijehe.<span class="c6"> Allah Uzvišeni veli:</span> "Duša je sklona zlu, osim one kojoj se Gospodar moj smiluje. Gospodar moj zaista prašta i samilostan je." <span class="c2">(Jusuf, 53)</span>. 2. Šejtan. On je čovjekov neprijatelj i cilj mu je da ga navede na zlo i uvede u Vatru.<span class="c6"> Allah Uzvišeni kaže:</span> "I ne slijedite šejtanove stope, jer vam je on neprijatelj očevidni!" <span class="c2">(El-Bekare, 168)</span>. 3. Loše društvo koje čovjeka podstiče na zlo i odvraća od dobra.<span class="c6"> O tome je Uzvišeni kazao:</span> "Tog Dana će oni koji su jedni drugima bili prijatelji postati neprijatelji, samo to neće biti oni koji su se Allaha bojali i grijeha klonili." <span class="c2">(Ez-Zuhruf, 67)</span>. </p>',
            ],
            13 => [
                'question' => 'Pitanje br. 14: Šta je to tevba?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16820.mp3',
                'answer' => '<p> Odgovor: Tevba je povratak Allahu putem pokajanja od grijeha i iskazivanjem pokornosti Njemu.<span class="c6"> Rekao je Allah Uzvišeni:</span> "Ja ću sigurno oprostiti onome koji se pokaje i uzvjeruje i dobra djela čini, i koji zatim na Pravome putu istraje." <span class="c2">(Taha, 82)</span>. </p>',
            ],
            14 => [
                'question' => 'Pitanje br. Koji su uslovi za ispravno pokajanje?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16850.mp3',
                'answer' => '<p> Odgovor: 1. Odustajanje od grijeha.<br /> 2. Kajanje za ono što je urađeno.<br /> 3. Čvrsta odluka da se grijehu više ne vraća.<br /> 4. Ispunjavanje obaveza prema onima kojima smo nešto dužni.<span class="c6"><br /> Uzvišeni Allah veli:</span> "...i za one koji se, kada grijeh počine ili kad se prema sebi ogriješe, Allaha sjete i oprost za grijehe svoje zamole - a ko će oprostiti grijehe ako ne Allah? - i koji svjesno u grijehu ne ustraju." <span class="c2">(Ali \'Imran, 135)</span>. </p>',
            ],
            15 => [
                'question' => 'Pitanje br. 16: Šta znači salavat na Poslanika, sallallahu alejhi ve sellem?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16920.mp3',
                'answer' => '<p> Odgovor: Molba Allahu da pohvali Vjerovjesnika, sallallahu alejhi ve sellem, u odabranom društvu. </p>',
            ],
            16 => [
                'question' => 'Pitanje br. 17: Šta znači subhanallah?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16950.mp3',
                'answer' => '<p> Odgovor: Ove riječi označavaju negiranje da Allah Uzvišeni posjeduje bilo kakvu mahanu ili nedostatak. </p>',
            ],
            17 => [
                'question' => 'Pitanje br. 18: Šta znači elhamdu lillahi?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16980.mp3',
                'answer' => '<p> Odgovor: Iskazivanje pohvale Allahu tako što ga opisujemo svojstvima savršenstva. </p>',
            ],
            18 => [
                'question' => 'Pitanje br. 19: Šta znači Allahu ekber?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/17000.mp3',
                'answer' => '<p> Odgovor: Allah je veći, veličanstveniji i uzvišeniji od svega drugog. </p>',
            ],
            19 => [
                'question' => 'Pitanje br. 20: Šta znači la havle ve la kuvvete illa billahi?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/17030.mp3',
                'answer' => '<p> Odgovor: Čovjek ne može promijeniti svoje stanje niti ima snage da to učini osim sa Allahom. </p>',
            ],
            20 => [
                'question' => 'Pitanje br. 21: Šta znači estagfirullah?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/17060.mp3',
                'answer' => '<p> Odgovor: Tražim oprosta od Allaha. </p>',
            ],
        ],
    ],
];
