<?php
$data = [
    'title' => 'What Muslim Children Must Know',
    'description' => 'A project that contains a simple and easy curriculum for issues that a Muslim must know. It includes issues of belief, jurisprudence, prophetic biography, etiquette, tafsir, hadith, morals, and remembrance of Allah. It is suitable for young children in particular, for all ages, and newcomers to Islam.',
    'source' => 'https://kids.islamenc.com/en/home',
    'author' => 'Yazan Abdul Razzaq Raziq Alghanim',
    'sections' => [
      0 => 'The Creed Section',
      1 => 'The Fiqh Section',
      2 => 'The Prophetic Sīrah (Biography) Section',
      3 => 'The Tafsīr Section',
      4 => 'Hadīth Section',
      5 => 'Islamic Etiquettes Section',
      6 => 'Morals Section',
      7 => 'Supplications and Dhikrs Section',
      8 => 'Miscellaneous Section',
    ],
    'data' => [
      1 => [
        0 => [
          'question' => 'Q1: Who is your Lord?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/200.mp3',
          'answer' => '<p> Answer: My Lord is Allah Who has raised me and the whole worlds with His favor.<span class="c6"><br /> The evidence lies in His saying:</span> <span class="c4">{All praise be to Allah, the Lord of the worlds.}</span> <span class="c5">[Surat al-<span class="c6">Fātihah:</span> 2]</span> </p>',
        ],
        1 => [
          'question' => 'Q2: What is your religion?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/240.mp3',
          'answer' => '<p> Answer: My religion is Islam, which is all about submitting to Allah through monotheism, yielding to Him through obedience, and dissociating oneself from Shirk <span class="c2">(polytheism)</span> and its people.<span class="c6"><br /> Allah Almighty says:</span> <span class="c4">{The true religion with Allah is Islam...}</span> <span class="c5">[Surat Āl ‘Imrān: 19]</span> </p>',
        ],
        2 => [
          'question' => 'Q3: Who is your prophet?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/280.mp3',
          'answer' => '<p> Answer: Muhammad <span class="c2">(may Allah’s peace and blessings be upon him)</span>.<span class="c6"><br /> Allah Almighty says:</span> <span class="c4">{Muhammad is the Messenger of Allah...}</span> <span class="c5">[Surat al-Fat-<span class="c6">h:</span> 29]</span> </p>',
        ],
        3 => [
          'question' => 'Q4: What are the words of Tawhīd (monotheism) and mention Tawhīd\'s meaning?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/310.mp3',
          'answer' => '<p> Answer: The words of Tawhīd are "Lā ilāha illallāh". This means that none is worthy of worship except Allah.<span class="c6"><br /> Allah Almighty says:</span> <span class="c4">{Then know <span class="c5">[O Prophet]</span> that none has the right to be worshiped except Allah...}</span> {Surat Muhammad: 19] </p>',
        ],
        4 => [
          'question' => 'Q5: Where is Allah Almighty?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/350.mp3',
          'answer' => '<p> Answer: Allah is in the heaven, above the Throne and above all the creation.<span class="c6"> Allah Almighty says:</span> <span class="c4">{The Most Compassionate rose over the Throne.}</span> <span class="c5">[Surat Taha: 5]</span> He also says: <span class="c4">{He is the Vanquisher over His slaves, and He is the All-Wise, the All-Aware.}</span> <span class="c5">[Surat al-<span class="c6">An‘ām:</span> 18]</span> </p>',
        ],
        5 => [
          'question' => 'Q6: What is the meaning of the testimony that Muhammad is the Messenger of Allah?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/380.mp3',
          'answer' => '<p> Answer: It means that Allah sent him to the worlds as a bringer of glad tidings and as a warner.<span class="c6"><br /> It is a must to:</span><br /> 1. Obey his commands<br /> 2. Believe his reports<br /> 3. Refrain from disobeying him<br /> 4. Worship Allah only in compliance with his Sharia, which requires following the Sunnah and abandoning religious innovations.<span class="c6"><br /> Allah Almighty says:</span> <span class="c4">{Whoever obeys the Messenger has indeed obeyed Allah.}</span> <span class="c5">[Surat an-<span class="c6">Nisā’:</span> 80]</span> He also says: <span class="c4">{Nor does he speak out of his own desire. It is but a revelation sent down <span class="c5">[to him]</span>.}</span> <span class="c5">[Surat an-<span class="c6">Najm:</span> 3-4]</span> Allah Almighty also says: <span class="c4">{Indeed, in the Messenger of Allah you have an excellent example for those who look forward to Allah and the Last Day, and remember Allah much.}</span> <span class="c5">[Surat al-<span class="c6">Ahzāb:</span> 21]</span> </p>',
        ],
        6 => [
          'question' => 'Q7: Why did Allah Almighty create us?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/480.mp3',
          'answer' => '<p> Answer: He created us to worship Him alone without associating partners with Him,<br /> and did not create us for fun or play.<span class="c6"><br /> Allah Almighty says:</span> <span class="c4">{I have not created the jinn and mankind except to worship Me.}</span> <span class="c5">[Surat adh-<span class="c6">Dhāriyāt:</span> 56]</span> </p>',
        ],
        7 => [
          'question' => 'Q8: What is worship?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/530.mp3',
          'answer' => '<p> Answer: It is a broad term that includes all apparent and hidden sayings and deeds that Allah loves and is pleased with.<br /> Examples of the apparent sayings and deeds include making Dhikr with the tongue, like Tasbīh <span class="c2">(glorifying Allah)</span>, Tahmīd <span class="c2">(praising Allah)</span>, and Takbīr <span class="c2">(proclaiming Allah’s greatness)</span>, praying, and performing Hajj <span class="c2">(pilgrimage)</span>.<br /> On the other hand, reliance on Allah, fearing Him, and having hopes in Him are examples of the hidden aspects of worship. </p>',
        ],
        8 => [
          'question' => 'Q9: What is our greatest duty?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/580.mp3',
          'answer' => '<p> Answer: Our greatest duty is to believe in the Oneness of Allah Almighty, i.e., adopt Tawhīd. </p>',
        ],
        9 => [
          'question' => 'Q10: What are the types of Tawhīd?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/610.mp3',
          'answer' => '<p> Answer: 1. Tawhīd ar-Rubūbiyyah <span class="c2">(Oneness of Lordship)</span>: It means to believe that Allah alone is the Creator, the Provider, the Owner, and the Disposer of Affairs.<br /> 2. Tawhīd al-Ulūhiyyah <span class="c2">(Oneness of Worship)</span>: It means to single Allah out with worship, i.e., to worship none but Allah Almighty.<br /> 3. Tawhīd al-Asmā’ wa as-Sifāt <span class="c2">(Oneness of the Names and the Attributes)</span>: It means to believe in Allah’s names and attributes that are mentioned in the Qur’an and Sunnah without Tamthīl <span class="c2">(drawing resemblance between Allah and His creatures)</span>, Tashbīh <span class="c2">(likening)</span>, or Ta‘tīl <span class="c2">(negating)</span>.<span class="c6"><br /> Evidence on the three types of Tawhīd lies in the verse where Allah Almighty says:</span> <span class="c4">{Lord of the heavens and earth and all that is between them. So worship Him and be constant in worshiping Him. Do you know anyone equal to Him?}</span> <span class="c5">[Surat Maryam: 65]</span> </p>',
        ],
        10 => [
          'question' => 'Q11: What is the gravest sin?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/670.mp3',
          'answer' => '<p> Answer: Shirk <span class="c2">(polytheism)</span>, i.e., associating partners with Allah Almighty.<span class="c6"><br /> Allah Almighty says:</span> <span class="c4">{Allah does not forgive associating partners with Him, but forgives anything less than that for whom He wills. Whoever associates partners with Allah has indeed committed a grave sin.}</span> <span class="c5">[Surat an-<span class="c6">Nisā’:</span> 48]</span> </p>',
        ],
        11 => [
          'question' => 'Q12: Mention the definition of Shirk and its types?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/710.mp3',
          'answer' => '<p> Answer: Shirk is dedicating any sort of worship to other than Allah Almighty.<span class="c6"><br /> Its types are:</span><br /> Major Shirk, like supplicating, prostrating, or slaughtering a sacrifice for other than Allah Almighty.<br /> Minor shirk, like swearing by other than Allah, using amulets, which are things worn or hung to bring about benefit or ward off harm, and slight ostentation, such as praying in a perfect manner while people are looking. </p>',
        ],
        12 => [
          'question' => 'Q13: Does anyone know the unseen other than Allah?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/770.mp3',
          'answer' => '<p> Answer: None knows the unseen except Allah alone.<span class="c6"><br /> Allah Almighty says:</span> {Say, <span class="c1">“No one in the heavens and earth has knowledge of the unseen except Allah.”</span> Nor do they know when they will be resurrected.} <span class="c5">[Surat an-<span class="c6">Naml:</span> 65]</span> </p>',
        ],
        13 => [
          'question' => 'Q14: What are the pillars of Imān (faith)?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/810.mp3',
          'answer' => '<p> Answer: 1. Belief in Allah Almighty<br /> 2. Belief in His angels<br /> 3. Belief in His books<br /> 4. Belief in His messengers<br /> 5. Belief in the Last Day<br /> 6. Belief in destiny, with the pleasant and unpleasant aspects thereof<br /> Evidence lies in the famous Hadīth of Jibrīl <span class="c2">(Gabriel)</span> that was narrated by Muslim. Gabriel <span class="c2">(peace be upon him)</span> said to the Prophet <span class="c2">(may Allah’s peace and blessings be upon him)</span>: "\'Tell me about faith.<span class="c6">\' He said:</span> \'It is to believe in Allah, His angels, His books, His messengers, the Last Day, and destiny with the pleasant and unpleasant aspects thereof.\'" </p>',
        ],
        14 => [
          'question' => 'Q15: Explain the pillars of Imān (faith)?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/900.mp3',
          'answer' => '<p> Answer: Belief in Allah Almighty<br /> It is to believe that Allah is the One Who created you and provided for you, and that Allah alone is the Owner and the Disposer of affairs.<br /> It is also to believe that Allah is the only deity worthy of worship,<br /> and that He is the Magnificent, the Great, and the Perfect to Whom all praise is due and Who owns the beautiful names and the sublime attributes. He has no rivals and nothing is like Him.<br /> Belief in the Angels<br /> Angels are creatures that Allah created from light. They were created to worship Allah and fully obey His commands.<br /> Gabriel <span class="c2">(peace be upon him)</span>, who was assigned to bring down the revelation to the prophets, is one of the angels.<br /> Belief in the Books<br /> These are the books that Allah sent down to His messengers.<span class="c6"> Examples are:</span><br /> - The Qur’an that was revealed to Muhammad <span class="c2">(may Allah’s peace and blessings be upon him)</span><br /> - The Gospel that was revealed to ‘Isa <span class="c2">(Jesus)</span> <span class="c2">(peace be upon him)</span><br /> - The Torah that was revealed to Mūsa <span class="c2">(Moses)</span> <span class="c2">(peace be upon him)</span><br /> - The Psalms that were revealed to Dāwūd <span class="c2">(David)</span> <span class="c2">(peace be upon him)</span><br /> The Scriptures of Ibrāhim <span class="c2">(Abraham)</span> and Moses<br /> Belief in the Messengers<br /> They are the messengers whom Allah Almighty sent to His servants to teach them, bring them the glad tidings of good and Paradise, and warn them against evil and Hellfire.<br /> The best among them are the Messengers of Firm Resolve,<span class="c6"> who are:</span><br /> Nūh <span class="c2">(Noah)</span> <span class="c2">(peace be upon him)</span><br /> Ibrāhim <span class="c2">(Abraham)</span> <span class="c2">(peace be upon him)</span><br /> Mūsa <span class="c2">(Moses)</span> <span class="c2">(peace be upon him)</span><br /> Īsa <span class="c2">(Jesus)</span> <span class="c2">(peace be upon him)</span><br /> Muhammad <span class="c2">(may Allah’s peace and blessings be upon him)</span><br /> Belief in the Last Day<br /> It refers to what comes after death in the grave, on the Day of Judgment, and on the Day of Resurrection and Reckoning after which the dwellers of Paradise settle in their abodes and the dwellers of Hellfire settle in theirs.<br /> Belief in destiny with its good and bad aspects<br /> It is to believe that Allah knows everything that happens in the universe, which He had previously written in the Preserved Tablet and had willed to create and bring to existence.<span class="c6"><br /> Allah Almighty says:</span> <span class="c4">{Indeed, We have created everything according to a determined measure.}</span> <span class="c5">[Surat al-<span class="c6">Qamar:</span> 49]</span><br /> It has four levels:<br /> First: Knowledge of Allah Almighty: This includes Allah’s prior knowledge of everything, before and after it happens.<span class="c6"><br /> Allah says:</span> <span class="c4">{Indeed, Allah has the knowledge of the Hour. He sends down the rain and knows what is in the wombs. No soul knows what it will do tomorrow, nor does any soul know in which land it will die. Indeed, Allah is All-Knowing, All-Aware.}</span> <span class="c4">{Surat Luqmān: 34]<br /> Second: Allah had written this in the Preserved Tablet; so, whatever happened and whatever will still happen are written with Allah in a record.<span class="c6"><br /> Allah says:</span> {He alone has the keys of the unseen; no one knows them except Him. He knows what is in the land and sea. Not a leaf falls without His knowledge, nor a grain in the darkness of the earth, nor anything moist or dry, but is <span class="c5">[written]</span> in a Clear Record.}</span> <span class="c5">[Surat al-<span class="c6">An‘ām:</span> 59]</span><br /> Third: Everything happens by the will of Allah, i.e., nothing happens by Him or by His creatures, except by His will.<span class="c6"><br /> Allah says:</span> <span class="c4">{For those among you who wish to take the straight path. But you cannot wish except by the Will of Allah, the Lord of the worlds.}</span> <span class="c5">[Surat at-<span class="c6">Takwīr:</span> 28-29]</span><br /> Fourth: Believing that all creatures are created by Allah. He created them and created their qualities, movements, and everything related to them.<span class="c6"><br /> Allah says:</span> <span class="c4">{When it is Allah Who created you and all what you do?}</span> <span class="c5">[Surat as-<span class="c6">Sāffāt:</span> 96]</span> </p>',
        ],
        15 => [
          'question' => 'Q16: What is the definition of the Qur’an?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/1300.mp3',
          'answer' => '<p> Answer: It is the word of Allah Almighty, and it is not created.<span class="c6"><br /> Allah Almighty says:</span> <span class="c4">{If any of the polytheists asks you for protection, give it to him, so that he may hear the Word of Allah...}</span> <span class="c5">[Surat at-<span class="c6">Tawbah:</span> 6]</span> </p>',
        ],
        16 => [
          'question' => 'Q17: What is the Sunnah?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/1330.mp3',
          'answer' => '<p> Answer: It is every saying, deed, approval, physical or moral quality of the Prophet <span class="c2">(may Allah’s peace and blessings be upon him)</span>. </p>',
        ],
        17 => [
          'question' => 'Q18: What is religious innovation? Should we accept it?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/1350.mp3',
          'answer' => '<p> Answer: It is everything that people introduce in the religion that did not exist at the time of the Prophet <span class="c2">(may Allah’s peace and blessings be upon him)</span> and his Companions.<br /> We should not accept it; rather, we should reject it.<br /> Because the Prophet <span class="c2">(may Allah’s peace and blessings be upon him)</span> said: "Every religious innovation is an error." <span class="c5">[Narrated by Abu Dāwūd]</span><br /> Examples of religious innovations are: adding to worship, like adding a fourth-time washing to ablution, and celebrating the birthday of the Prophet, which was not reported from the Prophet <span class="c2">(may Allah\'s peace and blessings be upon him)</span> and his Companions. </p>',
        ],
        18 => [
          'question' => 'Q19: Mention the principle of Al-Walā’ (allegiance) and Al-Barā’ (dissociation)?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/1410.mp3',
          'answer' => '<p> Answer: Allegiance: It means loving and supporting the believers.<span class="c6"><br /> Allah Almighty says:</span> <span class="c4">{The believers, both men and women, are allies of one another...}</span> <span class="c5">[Surat at-<span class="c6">Tawbah:</span> 71]</span><br /> Dissociation: It means hating the disbelievers and taking them as enemies.<span class="c6"><br /> Allah Almighty says:</span> {Indeed, you have a good example in Abraham and those with him, when they said to their people, <span class="c1">“We dissociate ourselves from you and whatever you worship besides Allah. We renounce you, and the enmity and hatred have arisen between us and you forever until you believe in Allah alone”</span>.} <span class="c5">[Surat al-<span class="c6">Mumtahanah:</span> 4]</span> </p>',
        ],
        19 => [
          'question' => 'Q20: Does Allah accept any religion other than Islam?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/1480.mp3',
          'answer' => '<p> Answer: Islam is the only religion that Allah accepts.<span class="c6"><br /> Allah Almighty says:</span> <span class="c4">{Anyone who seeks a religion other than Islam, never will it be accepted from him; and in the Hereafter he will be among the losers.}</span> <span class="c5">[Surat Āl ‘Imrān: 85]</span> </p>',
        ],
        20 => [
          'question' => 'Q21: Kufr (disbelief) could be committed by words, deeds, and beliefs; give examples?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/1520.mp3',
          'answer' => '<p> Answer: An example of committing Kufr by words is blaspheming Allah Almighty or His Messenger <span class="c2">(may Allah’s peace and blessings be upon him)</span>.<br /> An example of committing Kufr by deeds is degrading the Mus-haf <span class="c2">(a bound copy of the Qur’an)</span>, or prostrating to other than Allah Almighty.<br /> An example of committing Kufr by belief is believing that there is someone who is worthy of worship other than Allah Almighty, or that there is a creator besides Allah. </p>',
        ],
        21 => [
          'question' => 'Q22: What is hypocrisy and what are its types?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/1570.mp3',
          'answer' => '<p> Answer:<br /> 1.<span class="c6"> Major Hypocrisy:</span> It means hiding disbelief and proclaiming faith.<br /> It gets one outside the fold of Islam and it is considered major disbelief.<span class="c6"><br /> Allah Almighty says:</span> <span class="c4">{Indeed, the hypocrites will be in the lowest depths of the Fire, and you will never find for them any helper.}</span> <span class="c5">[Surat an-<span class="c6">Nisā’:</span> 145]</span><br /> 2.<span class="c6"> Minor Hypocrisy:</span><br /> Examples include: lying, breaking promises, and betraying trusts.<br /> Hypocrisy does not take one out of the fold of Islam. Rather, it is a sin, and the one who commits it will be subjected to divine torment.<br /> The Messenger of Allah <span class="c2">(may Allah’s peace and blessings be upon him)</span> said: "Signs of the hypocrite are three: when he speaks, he tells lies; when he makes a promise, he breaks it; and when he is entrusted, he betrays the trust." <span class="c5">[Narrated by Al-Bukhāri and Muslim]</span> </p>',
        ],
        22 => [
          'question' => 'Q23: Who is the seal of the prophets and messengers?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/1680.mp3',
          'answer' => '<p> Answer: He is Muhammad <span class="c2">(may Allah’s peace and blessings be upon him)</span>.<span class="c6"><br /> Allah Almighty says:</span> <span class="c4">{Muhammad is not the father of any of your men, but he is the Messenger of Allah and the seal of the prophets...}</span> <span class="c5">[Surat al-<span class="c6">Ahzāb:</span> 40]</span> Moreover, the Prophet <span class="c2">(may Allah’s peace and blessings be upon him)</span> said: "I am the seal of the prophets, and there is no prophet after me." <span class="c5">[Narrated by Abu Dāwūd, At-Tirmidhi, and others]</span> </p>',
        ],
        23 => [
          'question' => 'Q24: What is the miracle?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/1730.mp3',
          'answer' => '<p> Answer: The miracle is every supernatural act or event with which Allah Almighty supported His prophets to prove their truthfulness.<span class="c6"> Examples are:</span><br /> - Splitting the moon for the Prophet <span class="c2">(may Allah’s peace and blessings be upon him)</span><br /> - Splitting the sea for Moses <span class="c2">(peace be upon him)</span> and the drowning of Pharaoh and his soldiers </p>',
        ],
        24 => [
          'question' => 'Q25: Who are the Companions? Should we love them?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/1780.mp3',
          'answer' => '<p> Answer: The Companion is the one who met the Prophet <span class="c2">(may Allah’s peace and blessings be upon him)</span>, believed in him, and died as a Muslim.<br /> We should love them and follow their example, since they are the best among the people after the prophets.<br /> The best Companions are the four Caliphs,<span class="c6"> who are:</span><br /> - Abu Bakr <span class="c2">(may Allah be pleased with him)</span><br /> - ‘Umar <span class="c2">(may Allah be pleased with him)</span><br /> - ‘Uthmān <span class="c2">(may Allah be pleased with him)</span><br /> - ‘Ali <span class="c2">(may Allah be pleased with him)</span> </p>',
        ],
        25 => [
          'question' => 'Q26: Who are the Mothers of the Believers?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/1870.mp3',
          'answer' => '<p> Answer: They are the wives of the Prophet <span class="c2">(may Allah’s peace and blessings be upon him)</span>.<span class="c6"><br /> Allah Almighty says:</span> <span class="c4">{The Prophet has a greater claim over the believers than their own selves, and his wives are their mothers.}</span> <span class="c5">[Surat al-<span class="c6">Ahzāb:</span> 6]</span> </p>',
        ],
        26 => [
          'question' => 'Q27: What is our duty towards the Prophet’s household?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/1910.mp3',
          'answer' => '<p> Answer: The household of the Prophet <span class="c2">(may Allah’s peace and blessings be upon him)</span> includes his wives, his offspring, and the believers from among Banu Hāshim and Banu Al-Muttalib. It is our duty to love and support them, hate whoever hates them, and avoid extremism regarding them. </p>',
        ],
        27 => [
          'question' => 'Q28: What is our duty towards the Muslim rulers?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/1940.mp3',
          'answer' => '<p> Answer: Our duty towards the Muslim rulers is to respect them, obey them in whatever does not involve a sin, not to rebel against them, supplicate for them, and advise them secretly. </p>',
        ],
        28 => [
          'question' => 'Q29: What is the abode of the believers?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/1970.mp3',
          'answer' => '<p> Answer: The abode of the believers is Paradise.<span class="c6"> Allah Almighty says:</span> <span class="c4">{Allah will surely admit those who believe and do righteous deeds to gardens under which rivers flow...}</span> <span class="c5">[Surat Muhammad: 12]</span> </p>',
        ],
        29 => [
          'question' => 'Q30: What is the abode of the disbelievers?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/2000.mp3',
          'answer' => '<p> Answer: The abode of the disbelievers is Hellfire.<span class="c6"> Allah Almighty says:</span> <span class="c4">{then beware of the Fire whose fuel will be people and stones, which is prepared for the disbelievers.}</span> <span class="c5">[Surat al-<span class="c6">Baqarah:</span> 24]</span> </p>',
        ],
        30 => [
          'question' => 'Q31: What is fear? What is hope? What is the evidence?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/2020.mp3',
          'answer' => '<p> Answer: Fear: means to fear Allah and fear His punishment.<span class="c6"><br /> Hope:</span> means hoping for Allah’s reward, forgiveness, and mercy.<span class="c6"><br /> Evidence lies in His saying:</span> <span class="c4">{Those whom they call upon seek means of nearness to their Lord, each trying to become closer, hoping for His Mercy and fearing His punishment.}</span> <span class="c5">[Surat al-<span class="c6">Isrā’:</span> 57]</span> Allah Almighty also says: <span class="c4">{Inform My slaves that I am indeed the All-Forgiving, the Most Merciful, and that My punishment is the most painful punishment.}</span> <span class="c5">[Surat al-<span class="c6">Hijr:</span> 49-50]</span> </p>',
        ],
        31 => [
          'question' => 'Q32: Mention some of the names and attributes of Allah Almighty?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/2070.mp3',
          'answer' => '<p> Answer: Allah, Ar-Rabb <span class="c2">(the Lord)</span>, Ar-Rahmān <span class="c2">(the Most Compassionate)</span>, As-Samī‘ <span class="c2">(the All-Hearing)</span>, Al-Basīr <span class="c2">(the All-Seeing)</span>, Al-‘Alīm <span class="c2">(the All-Knowing)</span>, Ar-Razzāq <span class="c2">(the All-Provider)</span>, Al-Hayy <span class="c2">(the Ever-Living)</span>, Al-‘Azhīm <span class="c2">(the Magnificent)</span> in addition to other beautiful names and sublime attributes. </p>',
        ],
        32 => [
          'question' => 'Q33: Explain these names?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/2100.mp3',
          'answer' => '<p> Answer: Allah: It means the only God worthy of worship with no partners.<br /> Ar-<span class="c6">Rabb:</span> It means the only Creator, Owner, Provider, and Disposer of Affairs.<br /> As-<span class="c6">Samī‘:</span> It means the One Whose Hearing encompasses everything, and Who hears all voices despite their differences and variations.<br /> Al-<span class="c6">Basīr:</span> It means the One Who sees everything, no matter how small or big it is.<br /> Al-<span class="c6">‘Alīm:</span> It means the One Whose knowledge encompasses everything in the past, present, and the future.<br /> Ar-<span class="c6">Rahmān:</span> It means the One Whose mercy encompasses all creatures and all living beings, i.e., all the servants and creatures are under His mercy.<br /> Ar-<span class="c6">Razzāq:</span> It means the One Who provides for all the creatures including the humans, the jinn, and all other living beings.<br /> Al-<span class="c6">Hayy:</span> It means the One Who does not die while all creatures die.<br /> Al-<span class="c6">‘Azhīm:</span> It means the One Who possesses all perfection and all magnificence in His names, attributes, and deeds. </p>',
        ],
        33 => [
          'question' => 'Q34: What is our duty towards the Muslim scholars?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/2210.mp3',
          'answer' => '<p> Answer: Our duty towards the Muslim scholars is to love them and refer to them in Sharia-related issues and unprecedented events. We should mention the scholars in a positive way, and whoever mentions them negatively is not following the right path.<span class="c6"><br /> Allah Almighty says:</span> <span class="c4">{Allah will raise in ranks those who believed from among you and those who are given knowledge. And Allah is All-Aware of what you do.}</span> <span class="c5">[Surat al-<span class="c6">Mujādalah:</span> 11]</span> </p>',
        ],
        34 => [
          'question' => 'Q35: Who are the Awliyā’ (allies) of Allah Almighty?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/2240.mp3',
          'answer' => '<p> Answer: They are the pious believers.<span class="c6"><br /> Allah Almighty says:</span> <span class="c4">{Indeed, the allies of Allah will have no fear, nor will they grieve. Those who believe and fear Allah.}</span> <span class="c5">[Surat Yūnus: 62-63]</span> </p>',
        ],
        35 => [
          'question' => 'Q36: Does Imān (faith) include words and deeds?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/2280.mp3',
          'answer' => '<p> Answer: Faith includes words, deeds, and beliefs. </p>',
        ],
        36 => [
          'question' => 'Q37: Does Imān increase and decrease?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/2310.mp3',
          'answer' => '<p> Answer: Imān increases by obeying Allah, and decreases by disobeying Him.<span class="c6"><br /> Allah Almighty says:</span> <span class="c4">{The true believers are those whose hearts are filled with awe when Allah is mentioned, and their faith increases when His verses are recited to them, and they put their trust only in their Lord.}</span> <span class="c5">[Surat al-<span class="c6">Anfāl:</span> 2]</span> </p>',
        ],
        37 => [
          'question' => 'Q38: What is Ihsān (benevolence/excellence)?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/2350.mp3',
          'answer' => '<p> Answer: To worship Allah as if you see Him, and if you cannot see Him, He sees you. </p>',
        ],
        38 => [
          'question' => 'Q39: When will the deeds be accepted by Allah Almighty?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/2370.mp3',
          'answer' => '<p> Answer: Deeds are accepted by Allah Almighty when two conditions are fulfilled,<span class="c6"> which are:</span><br /> 1. If the deed is dedicated with full sincerity to Allah Almighty<br /> 2. If the deed complies with the Sunnah of the Prophet <span class="c2">(may Allah’s peace and blessings be upon him)</span> </p>',
        ],
        39 => [
          'question' => 'Q40: What is Tawakkul (reliance) on Allah Almighty?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/2420.mp3',
          'answer' => '<p> Answer: It means reliance on Allah Almighty in bringing benefit and warding off harm, while utilizing the available means.<span class="c6"><br /> Allah Almighty says:</span> <span class="c4">{Whoever puts his trust in Allah, He is sufficient for him.}</span> <span class="c5">[Surat at-<span class="c6">Talāq:</span> 3]</span><br /> "Sufficient for him": It means He will grant him sufficiency. </p>',
        ],
        40 => [
          'question' => 'Q41: What is the duty of enjoining good and forbidding evil?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/2470.mp3',
          'answer' => '<p> Answer: Enjoining good: means enjoining people to do every act of obedience to Allah Almighty,<span class="c6"> and forbidding evil:</span> means forbidding people from every sin with which they disobey Allah Almighty.<span class="c6"><br /> Allah Almighty says:</span> <span class="c4">{You are the best nation ever raised for mankind: you enjoin what is right and forbid what is wrong, and believe in Allah.}</span> <span class="c5">[Surat Āl ‘Imrān: 110]</span> </p>',
        ],
        41 => [
          'question' => 'Q42: Who are Ahl-us-Sunnah wa al-Jamā‘ah?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/2510.mp3',
          'answer' => '<p> Answer: They are those people who adopt the way of the Prophet <span class="c2">(may Allah’s peace and blessings be upon him)</span> and his Companions in words, deeds, and beliefs.<br /> They are called "Ahl-us-Sunnah" because they follow the Sunnah of the Prophet <span class="c2">(may Allah’s peace and blessings be upon him)</span> and refrain from introducing innovations in the religion.<br /> "Al-Jamā’ah" <span class="c2">(group)</span> refers to the fact that they have united on the truth, and were not divided therein. </p>',
        ],
      ],
      2 => [
        0 => [
          'question' => 'Q1: Define Tahārah (ritual purification)?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/2580.mp3',
          'answer' => '<p> Answer: Tahārah means purification from Hadath <span class="c2">(ritual impurity)</span> and Khabath <span class="c2">(material impurity)</span>.<br /> Purification from "khabath" is by removing material impurity from one’s body, clothes, or place of prayer.<br /> Purification from "hadath" is by performing ablution or Ghusl <span class="c2">(ritual bath)</span> with pure water, or by performing Tayammum <span class="c2">(dry ablution)</span> in case the water is unavailable or it is difficult for one to use it. </p>',
        ],
        1 => [
          'question' => 'Q2: How could one purify what is affected by Najāsah (material impurity)?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/2630.mp3',
          'answer' => '<p> Answer: By washing it with water until it becomes clean.<br /> As for what is licked by a dog, it has to be washed seven times the first of which must be with dust. </p>',
        ],
        2 => [
          'question' => 'Q3: What is the merit of ablution?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/2660.mp3',
          'answer' => '<p> Answer: The Prophet <span class="c2">(may Allah’s peace and blessings be upon him)</span> said: "When a Muslim - or a believer - performs ablution and washes his face, every single sin that he committed with his eyes will be washed away from his face with water, or with the last drop of water. When he washes his hands, every single sin that he committed with his hands will be washed away from his hands with water, or with the last drop of water. When he washes his feet, every single sin that he committed with his feet will be washed away from his feet with the water, or with the last drop of water, until he finally becomes purified from all his sins." <span class="c5">[Narrated by Muslim]</span> </p>',
        ],
        3 => [
          'question' => 'Q4: How should we perform ablution?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/2690.mp3',
          'answer' => '<p> Answer: We perform ablution by:<br /> - Washing the hands - three times<br /> - Rinsing the mouth three times, and sniffing water into the nose and blowing it out of the nose -<span class="c6"> three times<br /> Madmadah:</span> It means rinsing the mouth with water then spitting it out.<span class="c6"><br /> Istinshāq:</span> It means sniffing water into the nose with the right hand.<span class="c6"><br /> Istinthār:</span> It means blowing water out of the nose with the left hand.<br /> - Washing the face - three times<br /> - Washing the arms including the elbows - three times<br /> - Wiping over the head, moving the hands forwards then backwards, and wiping the ears<br /> - Washing the feet up to the ankles - three times<br /> This is the most perfect manner of performing ablution as authentically reported from the Prophet <span class="c2">(may Allah’s peace and blessings be upon him)</span> in the Hadīths of Al-Bukhāri and Muslim that were narrated by ‘Uthmān, ‘Abdullah ibn Zayd, and others. It was also authentically reported from the Prophet <span class="c2">(may Allah’s peace and blessings be upon him)</span> in Sahīh al-Bukhāri and others that he washed each of the organs of ablution once and sometimes twice. </p>',
        ],
        4 => [
          'question' => 'Q5: What are the obligatory acts of ablution? How many are they?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/2810.mp3',
          'answer' => '<p> Answer: The obligatory acts of ablution are the acts that render one’s ablution invalid if one of them is left out.<span class="c6"> They are:</span><br /> 1. Washing the face, which includes rinsing the mouth and sniffing water into the nose<br /> 2. Washing the arms including the elbows<br /> 3. Wiping over the head, which includes wiping the ears<br /> 4. Washing the feet up to the ankles<br /> 5. Maintaining the prescribed order by washing the face first, followed by the hands, then wiping over the head, and finally washing the feet.<br /> 6. Succession, which means washing the organs of ablution successively without leaving an interval of time that allows the organs to become dry.<br /> An example in this regard is when one performs only half of the ablution and then completes it some other time. In this case, one’s ablution is invalid. </p>',
        ],
        5 => [
          'question' => 'Q6: What are the Sunan (recommended acts) of ablution? How many are they?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/2910.mp3',
          'answer' => '<p> Answer: The recommended acts of ablution are those acts which if performed, one\'s reward increases, and if one does not perform them, he incurs no sin and his ablution is valid.<span class="c6"> They are:</span><br /> 1.<span class="c6"> Saying:</span> "Bismillāh" <span class="c2">(In the Name of Allah)</span><br /> 2. Using the Siwāk <span class="c2">(tooth-cleaning twig)</span><br /> 3. Washing the two palms<br /> 4. Washing between the fingers<br /> 5. Washing the organs for a second and third time<br /> 6. Starting with the right organs first<br /> 7.<span class="c6"> Saying the following Dhikr after ablution:</span> "Ash-hadu allā ilāha illallāh wahdahu lā sharīka lah, wa ash-hadu anna Muhammad ‘abduhu wa rasūluh" <span class="c2">(I testify that there is no god but Allah with no partners with Him, and I testify that Muhammad is His servant and messenger)</span><br /> 8. Performing two Rak‘ahs <span class="c2">(units of prayer)</span> after ablution </p>',
        ],
        6 => [
          'question' => 'Q7: What are the invalidators of ablution?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/3020.mp3',
          'answer' => '<p> Answer: The invalidators of ablution are:<br /> 1. Whatever comes out of the two private parts, i.e., urine, feces, or wind<br /> 2. Sleep, madness, or loss of consciousness<br /> 3. Eating camel meat<br /> 4. Touching the front or back private parts with hand without a barrier </p>',
        ],
        7 => [
          'question' => 'Q8: What is Taymmum (dry ablution)?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/3080.mp3',
          'answer' => '<p> Answer: Tayammum: It means using dust or the like of earth when water is unavailable, or it cannot be used. </p>',
        ],
        8 => [
          'question' => 'Q9: How do we perform Tayammum?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/3110.mp3',
          'answer' => '<p> Answer: We perform Tayammum by striking the dust once with the palms of the hands and wiping the face and the back parts of the hands once only. </p>',
        ],
        9 => [
          'question' => 'Q10: What are the invalidators of Tayammum?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/3140.mp3',
          'answer' => '<p> Answer: All the invalidators of ablution,<br /> also when water is available. </p>',
        ],
        10 => [
          'question' => 'Q11: What are the Khuffs and Jawrabs? Is it permissible to wipe over them in ablution?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/3180.mp3',
          'answer' => '<p> Answer: The Khuffs refer to the leather socks that one may put on his feet.<br /> The Jawrabs, on the other hand, refer to socks that are made of other than leather.<br /> It is permissible to wipe over them in ablution instead of washing the feet. </p>',
        ],
        11 => [
          'question' => 'Q12: What is the wisdom behind wiping over leather socks?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/3230.mp3',
          'answer' => '<p> Answer: It is meant to make things easy for people and alleviate the hardship of performing ablution, especially in cold weather during winter, and while traveling when it is hard for one to take off the socks. </p>',
        ],
        12 => [
          'question' => 'Q13: What are the conditions of the validity of wiping over leather socks?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/3260.mp3',
          'answer' => '<p> Answer: 1. To put on the leather socks while being in a state of Tahārah <span class="c2">(ritual purification)</span>, i.e., after performing ablution.<br /> 2. The leather socks must be pure, since it is impermissible to wipe over what is impure.<br /> 3. The leather socks must cover the whole feet including ankles.<br /> 4. Wiping over leather socks must be within the limited period of time, which is a day and a night for a resident, and three days and three nights for a traveler. </p>',
        ],
        13 => [
          'question' => 'Q14: What is the manner of wiping over leather socks?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/3320.mp3',
          'answer' => '<p> Answer: It is by putting one’s wet fingers over his toes and wiping over them up to the shin, using the right hand to wipe over the right feet and the left hand to wipe over the left feet. The fingers should be kept apart during the wiping, and it should be done once without being repeated. </p>',
        ],
        14 => [
          'question' => 'Q15: What invalidates wiping over leather socks?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/3350.mp3',
          'answer' => '<p> Answer: 1. Expiry of the specific duration of time for wiping,<span class="c6"> since it is impermissible to wipe over them after that duration:</span> a day and a night for a resident, and three days and three nights for a traveler.<br /> 2. Taking off the leather socks or one of them after wiping. </p>',
        ],
        15 => [
          'question' => 'Q16: What is the meaning of Salāh (prayer)?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/3390.mp3',
          'answer' => '<p> Answer: Salāh is worshiping Allah by specific words and acts. It starts with Takbīr <span class="c2">(saying: Allāhu Akbar i.e., Allah is the Greatest)</span> and ends with Taslīm <span class="c2">(salutation of peace that ends the prayer)</span>. </p>',
        ],
        16 => [
          'question' => 'Q17: What is the ruling of prayer?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/3420.mp3',
          'answer' => '<p> Answer: Prayer is an obligation upon every Muslim.<span class="c6"><br /> Allah Almighty says:</span> <span class="c4">{Indeed, prayer is prescribed for the believers at specific times.}</span> <span class="c5">[Surat an-<span class="c6">Nisā’:</span> 103]</span> </p>',
        ],
        17 => [
          'question' => 'Q18: What is the ruling on abandoning the prayer?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/3460.mp3',
          'answer' => '<p> Answer: Abandoning the prayer constitutes disbelief, as the Prophet <span class="c2">(may Allah’s peace and blessings be upon him)</span> said:<br /> "The covenant <span class="c2">(that distinguishes)</span> between us and them <span class="c2">(disbelievers)</span> is the prayer; so, whoever abandons it has indeed committed disbelief."<br /> <span class="c5">[Narrated by Ahmad, At-Tirmidhi, and others]</span> </p>',
        ],
        18 => [
          'question' => 'Q19: How many prayers are obligatory upon the Muslim in one day and night? What are the number of Rak‘ahs in each prayer?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/3500.mp3',
          'answer' => '<p> Answer: There are five obligatory prayers in one day and night.<span class="c6"> They are:</span> the Fajr <span class="c2">(dawn)</span> prayer: two Rak‘ahs, the Zhuhr <span class="c2">(noon)</span> prayer: four Rak‘ahs, the ‘Asr <span class="c2">(afternoon)</span> prayer: four Rak‘ahs, the Maghrib <span class="c2">(sunset)</span> prayer: three Rak‘ahs, and the ‘Ishā’ <span class="c2">(night)</span> prayer: four Rak‘ahs. </p>',
        ],
        19 => [
          'question' => 'Q20: What are the conditions of prayer?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/3530.mp3',
          'answer' => '<p> Answer: 1. Islam, as the prayer of a disbeliever is invalid<br /> 2. Sanity, as the prayer of an insane person is invalid<br /> 3. Discernment, as the prayer of the undiscerning child is invalid<br /> 4. The intention<br /> 5. Commencement of the prescribed time<br /> 6. Tahārah, i.e., removal of Hadath <span class="c2">(ritual impurity)</span><br /> 7. Purification from physical impurity<br /> 8. Covering the ‘Awrah <span class="c2">(parts of the body that must be covered)</span><br /> 9. Facing the Qiblah <span class="c2">(direction of the Ka‘bah)</span> </p>',
        ],
        20 => [
          'question' => 'Q21: What are the pillars of the prayer?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/3640.mp3',
          'answer' => '<p> Answer: They are fourteen pillars,<span class="c6"> which are:</span><br /> 1. Standing in the obligatory prayer for the one who is capable<br /> 2. The opening Takbīr,<span class="c6"> which is saying:</span> "Allāhu Akbar" <span class="c2">(Allah is the Greatest)</span><br /> 3. Reciting Surat al-Fātihah<br /> 4. Rukū‘ <span class="c2">(bowing)</span> while straightening one’s back and making his head in alignment with his back<br /> 5. Rising from Rukū‘<br /> 6. Standing up straight<br /> 7. Sujūd <span class="c2">(prostration)</span>: It is by placing one’s forehead, nose, palms, knees, and tiptoes on the ground while prostrating<br /> 8. Rising from Sujūd<br /> 9. Sitting between the two prostrations<br /> It is an act of Sunnah to sit on one’s left foot, while keeping the right foot straight upward and keeping its toes facing the Qiblah.<br /> 10. Serenity, which is calmness in performing each physical pillar<br /> 11. The last Tashahhud<br /> 12. Sitting for Tashahhud<br /> 13.<span class="c6"> Making Taslīm by saying:</span> "As-salāmu ‘alaykum wa rahmatullāh" <span class="c2">(may the peace and mercy of Allah be upon you)</span> - twice.<br /> 14. Maintaining the prescribed order of the pillars as mentioned; so, if one intentionally prostrates before bowing, his prayer is invalid. However, if he does so unintentionally, he must return back to perform bowing first then prostrate. </p>',
        ],
        21 => [
          'question' => 'Q22: What are the obligatory acts of the prayer?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/3820.mp3',
          'answer' => '<p> Answer: The obligatory acts of the prayer are eight; they are:<br /> 1. Making Takbīrs <span class="c2">(saying: Allāhu Akbar)</span>, other than the opening Takbīr<br /> 2.<span class="c6"> Saying:</span> "Sami‘allāhu liman hamidah" <span class="c2">(Allah hears whoever praises Him)</span> by the Imam and the one praying alone<br /> 3.<span class="c6"> Saying:</span> "Rabbanā wa laka al-hamd" <span class="c2">(O our Lord, all praise belongs to You)</span><br /> 4.<span class="c6"> Saying:</span> "Subhāna rabbiya Al-‘Azhīm" <span class="c2">(Glory be to my Lord, the Magnificent)</span> once in Rukū‘ <span class="c2">(bowing)</span><br /> 5.<span class="c6"> Saying:</span> "Subhāna rabbiya Al-A‘lā" <span class="c2">(Glory be to my Lord, the Most High)</span> once in Sujūd <span class="c2">(prostration)</span><br /> 6.<span class="c6"> Saying:</span> "Rabbighfir lī" <span class="c2">(O Lord, forgive me)</span> between the two prostrations<br /> 7. Saying the first Tashahhud<br /> 8. Sitting for the first Tashahhud </p>',
        ],
        22 => [
          'question' => 'Q23: What are the Sunan (recommended acts) of the prayer?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/3930.mp3',
          'answer' => '<p> Answer: They are eleven,<span class="c6"> which are:</span><br /> 1. Reciting Du‘ā’ al-Istiftāh <span class="c2">(the opening supplication)</span>, after making the opening Takbīr,<span class="c6"> by saying:</span> "Subhānak Allāhumma wa bihamdik, wa tabārak ismuk, wa ta‘ālā jadduk, wa lā ilāha ghayruk" <span class="c2">(Glory be to You, O Allah, and with Your praise, and blessed is Your Name, and exalted is Your majesty, and there is no god but You)</span><br /> 2. Making Ta‘awwudh <span class="c2">(saying: A‘ūdhu billāh min ash-shaytān ar-rajīm)</span> <span class="c2">(I seek refuge with Allah from the accursed devil)</span><br /> 3.<span class="c6"> Saying:</span> "Bismillāh ar-Rahmān ar-Rahīm" <span class="c2">(In the Name of Allah, the Most Compassionate, the Most Merciful)</span><br /> 4.<span class="c6"> Saying:</span> "Āmīn" <span class="c2">(Amen)</span><br /> 5. Reciting a surah after Surat al-Fātihah<br /> 6. Reciting the Qur’an audibly by the Imam<br /> 7. Saying after Tahmīd <span class="c2">(praising Allah)</span>: "Mil’as-samāwāti wa mil’al-ardi wa mil’a mā shi’ta min shay’in ba‘d" <span class="c2">(filling the heavens, the earth, and whatever else You will)</span><br /> 8. The Tasbīhs <span class="c2">(Glorifying Allah)</span> after the first Tasbīh in Rukū‘, i.e., the second and third Tasbihs or more<br /> 9. The Tasbīhs <span class="c2">(Glorifying Allah)</span> after the first Tasbīh in Sujūd<br /> 10.<span class="c6"> Saying more than once:</span> "Rabbighfir lī" between the two prostrations<br /> 11.<span class="c6"> Invoking the peace and blessings of Allah upon the Prophet and his family in the last Tashahhud and making supplication thereafter<br /> Fourth:</span> The physical Sunan <span class="c2">(recommended acts)</span> of the prayer, which are called "postures",<span class="c6"> are:</span><br /> 1. Raising both hands with the opening Takbīr<br /> 2. Raising both hands when performing Rukū‘<br /> 3. Raising both hands when rising from Rukū‘<br /> 4. Lowering the hands after that<br /> 5. Placing the right hand over the left one<br /> 6. Looking at one’s place of prostration<br /> 7. Leaving a gap between the feet while standing<br /> 8. Gripping the knees with both hands with the fingers spread out in Rukū‘, while straightening one’s back, and making one’s head in alignment with one\'s back<br /> 9. Resting the organs of prostration on the ground, while making sure that all of them touch the ground.<br /> 10. Keeping the arms away from the sides, the abdomen away from the thighs, and the thighs away from the legs; keeping the knees apart and keeping the feet erected with the toes separated and their bottom touching the ground; putting the hands in alignment with the shoulders while being spread out and with the fingers joined.<br /> 11. Engaging in Iftirāsh <span class="c2">(to place the left foot on its side and sitting on it; and keeping the right foot erected while resting on the bottom of the toes facing them towards the Qiblah)</span> while sitting between the two prostrations and during the first Tashahhud. However, performing Tawarruk <span class="c2">(to sit with the left posterior on the ground; the right foot erected with the toes pointing towards the Qiblah; and the left foot on its side emerging from under the right foot)</span> during the second Tashahhud.<br /> 12. Putting the hands spread out on the thighs with the fingers joined between the two prostrations and during the Tashahhud as well; however, in the latter, one may clench the little and ring fingers of the right hand, making a ring with the thumb and middle fingers, and pointing with the index finger when mentioning Allah.<br /> 13. Turning the face to the right and then to the left when making Taslīm </p>',
        ],
        23 => [
          'question' => 'Q24: What are the invalidators of the prayer?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/4210.mp3',
          'answer' => '<p> Answer: 1. Leaving out one of the pillars or conditions of the prayer<br /> 2. Talking deliberately<br /> 3. Eating or drinking<br /> 4. Frequent and successive movements<br /> 5. Leaving out one of the obligatory acts of the prayer deliberately </p>',
        ],
        24 => [
          'question' => 'Q25: How should a Muslim perform the prayer?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/4280.mp3',
          'answer' => '<p> Answer: The manner of the prayer is as follows:<br /> 1. Face the Qiblah with one’s whole body, without deviating or turning away from that direction<br /> 2. Make the intention, in one’s heart without uttering it, to perform a specific prayer<br /> 3.<span class="c6"> Make the opening Takbīr by saying:</span> "Allāhu Akbar" <span class="c2">(Allah is the Greatest)</span>, while raising the hands to be in alignment with the shoulders<br /> 4. Place the right palm on top of the left hand above the chest<br /> 5.<span class="c6"> Recite the opening supplication by saying:</span> "Allāhumma bā‘id baynī wa bayna khatāyāy kamā bā‘dta bayna al-mashriq wa al-maghrib, Allāhumma naqqinī min khatāyāy kamā yunaqqa ath-thawb al-abyad min ad-danas, Allāhumma ighsilnī min khatāyāy bil mā’i wa ath-thalji wa al-barad" <span class="c2">(O Allah, separate me from my sins as You have separated the East from the West. O Allah, cleanse me of my sins as the white garment is cleansed of stains. O Allah, wash away my sins with ice, water, and hail)</span>.<span class="c6"><br /> Or by saying:</span> "Subhānak Allāhumma wa bihamdika, wa tabārak ismuka, wa ta‘ālā jadduka, wa lā ilāha ghayruk" <span class="c2">(Glory be to You, O Allah, and with Your praise, and blessed is Your Name, and exalted is Your majesty, and there is no god but You)</span><br /> 6.<span class="c6"> Seek refuge with Allah by saying:</span> "A‘ūdhu billāh min ash-shaytān ar-rajīm" <span class="c2">(I seek refuge with Allah from the accursed devil)</span> 7. Say Bismillah and recite Surat al-<span class="c6">Fātihah by saying:</span> <span class="c4">{In the name of Allah, the Most Compassionate, the Most Merciful}</span> All praise be to Allah, the Lord of the worlds, the Most Compassionate, the Most Merciful, Master of the Day of Judgment. You alone we worship, and You alone we ask for help. Guide us to the straight path, the path of those whom You have blessed; not of those who incurred Your Wrath, or of those who went astray.} <span class="c5">[Surat al-<span class="c6">Fātihah:</span> 1-7]</span><br /> Then,<span class="c6"> one says:</span> "Āmīn",<span class="c6"> which means:</span> O Allah, answer the supplication.<br /> 8. Recite the Qur’an as much as is easy, and prolong the recitation in the morning prayer<br /> 9. Bow, which means bending one’s back to glorify Allah; and making Takbīr when bowing, while raising the hands to be in alignment with the shoulders.<br /> It is a Sunnah to extend one’s back and make the head on the same line with the back, while placing the hands, with the fingers kept apart, on one\'s knees.<br /> 10.<span class="c6"> Say the following in Rukū‘:</span> "Subhāna rabbiya Al-‘Azhīm" <span class="c2">(Glory be to my Lord, the Magnificent)</span> - three times.<span class="c6"> If one adds to that:</span> "Subhānak Allāhumma wa bihamdik, Allāhumma ighfir lī" <span class="c2">(Glory be to You, O Allah, and with Your praise. O Allah, forgive me)</span>, that will be good.<br /> 11.<span class="c6"> Raise your head from Rukū‘ while saying:</span> "Sami‘allāhu liman hamidah" <span class="c2">(Allah hears whoever praises Him)</span>, then raise your hands up to the shoulders.<span class="c6"> The one praying behind the Imam does not say:</span> "Sami‘allāhu liman hamidah"; rather,<span class="c6"> one should say:</span> "Rabbanā wa laka al-hamd" <span class="c2">(O our Lord, praise be to You)</span>.<br /> 12. After rising from Rukū‘,<span class="c6"> one says:</span> "Rabbanā wa laka al-hamd mil’a as-samāwāti wa mil’a al-ardi wa mil’a mā shi’ta min shay’in ba‘d" <span class="c2">(O our Lord, praise be to You as much as would fill the heavens and the earth, and as much as would fill whatever You will after that)</span>.<br /> 13.<span class="c6"> Make the first prostration while saying:</span> "Allāhu Akbar" <span class="c2">(Allah is the Greatest)</span> and prostrate on seven parts of the body: the forehead, the nose, the palms, the knees, and the tiptoes; keeping the arms away from the sides and not spreading out the arms on the ground, and facing the Qiblah with the tiptoes.<br /> 14.<span class="c6"> Say in the prostration:</span> "Subhāna rabbiya Al-A‘lā" <span class="c2">(Glory be to my Lord, the Most High)</span> - three times.<span class="c6"> If one adds to that:</span> "Subhānak Allāhumma wa bihamdik, Allāhumma ighfir lī" <span class="c2">(Glory be to You, O Allah, and with Your praise. O Allah, forgive me)</span>, that will be good.<br /> 15.<span class="c6"> Raise the head from prostration while saying:</span> "Allāhu Akbar" <span class="c2">(Allah is the Greatest)</span>.<br /> 16. Sit between the two prostrations on the left foot, with the right foot erect, putting the right hand on the edge of the thigh, just above the knee, while clenching the little and ring fingers and raising the index finger and moving it when making supplication; joining the tip of the thumb with the tip of the middle finger to make a ring; putting the left hand, with the fingers spread out, on the edge of the thigh, just above the knee.<br /> 17.<span class="c6"> Say the following while sitting between the two prostrations:</span> "Rabb ighfir lī warhamnī wahdinī warzuqnī wajburnī wa ‘āfinī" <span class="c2">(O Lord, forgive me, have mercy on me, guide me, provide for me, improve my situation, and grant me safety)</span>.<br /> 18. Perform the second prostration in the same manner as the first one in terms of what is to be said and done; make Takbīr at the moment of prostrating.<br /> 19.<span class="c6"> Rise from the second prostration while saying:</span> "Allāhu Akbar" <span class="c2">(Allah is the Greatest)</span>, and perform the second Rak‘ah <span class="c2">(unit of prayer)</span> like the first one, but without reciting the opening supplication.<br /> 20.<span class="c6"> Sit after the second Rak‘ah while saying:</span> "Allāhu Akbar" in the same manner of sitting between the two prostrations.<br /> 21. Recite Tashahhud, in this sitting posture,<span class="c6"> saying:</span> "At-tahiyyātu lillāhi wa as-salawātu wa at-tayyibāt, as-salāmu ‘alayka ayyuhā an-nabiyy wa rahmatullāhi wa barakātuh, as-salāmu ‘alaynā wa ‘alā ‘ibādillāhi as-sālihīn, ash-hadu allā ilāha illallāh wa ash-hadu anna Muhammad ‘abduhu wa rasūluh. Allāhumma salli ‘alā Muhammad wa ‘alā āli Muhammad kamā sallayta ‘alā Ibrāhīm wa ‘alā āli Ibrāhīm innaka hamīdun majīd, wa bārik ‘alā Muhammad wa ‘alā āli Muhammad kamā bārakta ‘alā Ibrāhīm wa ‘alā āli Ibrāhīm innaka hamīdun majīd, a‘ūdhu billāhi min ‘adhābi jahannam wa min ‘adhābi al-qabr wa min fitnat al-mahyā wa al-mamāt wa min fintnat al-masīh ad-dajjāl" <span class="c2">(All compliments, prayers and pure words are due to Allah. Peace be upon you, O Prophet, and the mercy of Allah and His blessings. Peace be upon us and upon the righteous slaves of Allah. I bear witness that there is no god except Allah and I bear witness that Muhammad is His slave and messenger. O Allah, send prayers upon Muhammad and upon the family of Muhammad, as You sent prayers upon Abraham and the family of Abraham, You are indeed Praiseworthy, Most Glorious. O Allah, bless Muhammad and the family of Muhammad as You blessed Abraham and the family of Abraham, You are indeed Praiseworthy, Most Glorious. I seek refuge in Allah from the torment of Hellfire, from the torment of the grave, from the trial of life and death, and from the trial of the Antichrist)</span>. Then, one may supplicate Allah asking for whatever he wishes of the good of this life and the Hereafter.<br /> 22. Make Taslīm on the right,<span class="c6"> saying:</span> "As-salāmu ‘alaykum wa rahmatullāh" <span class="c2">(May the peace and mercy of Allah be upon you)</span>, then make Taslīm on the left.<br /> 23. In case it is a three-Rak‘ah or four-Rak‘ah prayer,<span class="c6"> then the first Tashahhud should stop at the point of saying:</span> "Ash-hadu allā ilāha illallāh wa ash-hadu anna Muhammad ‘abduhu wa rasūluh" <span class="c2">(I testify that there is no god but Allah, and I bear witness that Muhammad is His slave and messenger)</span>.<br /> 24.<span class="c6"> Stand up while saying:</span> "Allāhu Akbar" and raise the hands to be in alignment with the shoulders.<br /> 25. Perform the rest of the prayer in the same manner of the second Rak‘ah, except that Surat-al-Fātihah should only be recited.<br /> 26. Sit in the Tawarruk position, keeping the right foot erect, extending the left foot from underneath the right leg, resting the posterior on the ground, and putting the hands on the thighs in the same manner as in the first Tashahhud.<br /> 27. Recite the whole Tashahhud while sitting in this position.<br /> 28. Make Taslīm to the right,<span class="c6"> saying:</span> "As-salāmu ‘alaykum wa rahmatullāh" <span class="c2">(May the peace and mercy of Allah be upon you)</span>, then make Taslīm to the left. </p>',
        ],
        25 => [
          'question' => 'Q26: What Adhkār (regular supplications) should be recited after making Taslīm and ending the prayer?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/4610.mp3',
          'answer' => '<p> Answer: - "Astaghfirullāh" <span class="c2">(I ask Allah for forgiveness)</span> - three times.<br /> - "Allāhumma anta as-salām wa minka as-salām tabārakta ya dhal-jalāl wa al-ikrām" <span class="c2">(O Allah, You are the Source of Peace and all peace comes from You, blessed are You, O Possessor of majesty and honor)</span>.<br /> - "Lā ilāha illallāh wahdahu lā sharīka lah, lahu al-mulku wa lahu al-hamdu wa huwa ‘alā kulli shay’in qadīr, Allāhumma lā māni‘a limā a‘tayt wa lā mu‘tī limā mana‘t wa lā yanfa‘u dhal-jaddi minka al-jadd <span class="c2">(There is no god but Allah alone with no partners. To Him belong the sovereignty and praise, and He is Omnipotent over all things. O Allah, none can withhold what You have given, and none can give what You have withheld. No wealth or fortune can benefit anyone, as all wealth and fortune come from You)</span>.<br /> - "Lā ilāha illallāh wahdahu lā sharīka lah, lahu al-mulku wa lahu al-hamdu wa huwa ‘alā kulli shay’in qadīr, lā hawla wa lā quwwata illā billāh, lā ilāha illallāh wa lā na‘budu illā iyyāh, lahu an-ni‘matu wa lahu al-fadl wa lahu ath-thanā’ al-hasan, lā ilāha illallāh mukhlisīn lahu ad-dīn wa law kariha al-kāfirūn" <span class="c2">(There is no god but Allah alone, with no partner. To Him belongs the sovereignty and to Him belongs the praise, and He is Omnipotent over all things. There is no power and no strength except with Allah, there is no god but Allah and we worship none but Him. From Him (alone)</span> come all blessings and favors, and all good praise is due to Him. There is no god but Allah and we make our worship purely for Him <span class="c2">(alone)</span> even if the disbelievers hate that).<br /> - "Subhānallāh" <span class="c2">(Glory be to Allah)</span> - thirty-three times.<br /> "Alhamdulillāh" <span class="c2">(praise be to Allah)</span> - thirty-three times.<br /> "Allāhu Akbar" <span class="c2">(Allah is the Greatest)</span> - thirty-three times.<br /> Then, to complete one hundred,<span class="c6"> say:</span> "Lā ilāha illallāh wahdahu lā sharīka lah, lahu al-mulku wa lahu al-hamdu wa huwa ‘alā kulli shay’in qadīr" <span class="c2">(There is no god but Allah alone, with no partner. To Him belongs the sovereignty and to Him belongs the praise, and He is Omnipotent over all things)</span>.<br /> - Reciting Surat al-Ikhlās and Al-Mu‘awwidhāt <span class="c2">(Surat al-Falaq and Surat an-Nās)</span> three times after the Fajr and Maghrib prayers, and once after the other prayers.<br /> - Reciting Āyat al-Kursi <span class="c2">(verse no. 255 of Surat al-Baqarah)</span> once. </p>',
        ],
        26 => [
          'question' => 'Q27: What are the regular Sunnah prayers? What is their merit?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/4730.mp3',
          'answer' => '<p> Answer: - Two Rak‘ahs before Fajr<br /> - Four Rak‘ahs before Zhuhr<br /> - Two Rak‘ahs after Zhuhr<br /> - Two Rak‘ahs after Maghrib<br /> - Two Rak‘ahs after ‘Ishā’<br /> Regarding their merit, the Prophet <span class="c2">(may Allah’s peace and blessings be upon him)</span> said: "Allah builds a house in Paradise for whoever prays twelve voluntary Rak‘ahs in one day and night." <span class="c5">[Narrated by Muslim, Ahmad, and others]</span> </p>',
        ],
        27 => [
          'question' => 'Q28: What is the best day of the week?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/4800.mp3',
          'answer' => '<p> Answer: The best day of the week is Friday, as the Prophet <span class="c2">(may Allah’s peace and blessings be upon him)</span> said: "Friday is among the best of your days. It is the day Adam was created and the day he died. It is the day on which the Trumpet will be blown and the Screak will be made; so, send more blessings on me on that day, for your blessings will be presented before me.<span class="c6">" They said:</span> "O Messenger of Allah,<span class="c6"> how can it be that our blessings will be presented to you while your body is decayed?" He replied:</span> "Allah Almighty has prohibited the earth from consuming the bodies of the prophets." <span class="c5">[Narrated by Abu Dāwūd and others]</span> </p>',
        ],
        28 => [
          'question' => 'Q29: What is the ruling on the Jumu‘ah (Friday) prayer?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/4840.mp3',
          'answer' => '<p> Answer: It is an individual duty on every male, adult, sane, and resident Muslim.<span class="c6"><br /> Allah Almighty says:</span> <span class="c4">{O you who believe, do not let your wealth and your children distract you from Allah’s remembrance. For whoever does that, it is they who are the losers.}</span> <span class="c5">[Surat al-<span class="c6">Munāfiqūn:</span> 9]</span> </p>',
        ],
        29 => [
          'question' => 'Q30: What is the number of Rak‘ahs in the Jumu‘ah prayer?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/4880.mp3',
          'answer' => '<p> Answer: The Jumu‘ah prayer consists of two Rak‘ahs in which the Imam recites the Qur’anic verses audibly, and which are preceded with two Khutbahs <span class="c2">(sermons)</span>. </p>',
        ],
        30 => [
          'question' => 'Q31: Is it permissible not to attend the Jumu‘ah prayer?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/4910.mp3',
          'answer' => '<p> Answer: Not attending the Jumu‘ah prayer is impermissible, except for a Sharia-approved excuse. The Prophet <span class="c2">(may Allah’s peace and blessings be upon him)</span> said: "Whoever misses three Friday prayers out of negligence, Allah places a seal upon his heart." <span class="c5">[Narrated by Abu Dāwūd and others]</span> </p>',
        ],
        31 => [
          'question' => 'Q32: Mention the Sunnah acts to be performed on Friday?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/4940.mp3',
          'answer' => '<p> Answer:<br /> 1. Taking a shower<br /> 2. Putting on perfume<br /> 3. Wearing the best of clothes<br /> 4. Going early to the mosque<br /> 5. Invoking blessings upon the Prophet frequently<br /> 6. Reciting Surat al-Kahf<br /> 7. Walking to the mosque<br /> 8. Seeking the hour in which supplication is most likely to be answered </p>',
        ],
        32 => [
          'question' => 'Q33: What is the merit of the congregational prayer?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/5050.mp3',
          'answer' => '<p> Answer: ‘Abdullah ibn ‘Umar <span class="c2">(may Allah be pleased with him and his father)</span> reported that the Prophet <span class="c2">(may Allah’s peace and blessings be upon him)</span> said: "Praying in congregation is twenty-seven times better than praying alone." <span class="c5">[Narrated by Muslim]</span> </p>',
        ],
        33 => [
          'question' => 'Q34: What is Khushū‘ (humility) in prayer?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/5080.mp3',
          'answer' => '<p> Answer: It means the attendance of the heart and the serenity of the body while performing the prayer.<span class="c6"><br /> Allah Almighty says:</span> <span class="c4">{The believers have attained true success: those who humble themselves in their prayers.}</span> <span class="c5">[Surat al-<span class="c6">Mu’minūn:</span> 1-2]</span> </p>',
        ],
        34 => [
          'question' => 'Q35: What is the definition of Zakah?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/5120.mp3',
          'answer' => '<p> Answer: It is a due right on a specific type of property, to be given to a specific group of people, at a specific time.<br /> It is one of the pillars of Islam and an obligatory charity that is taken from the rich and given to the poor.<span class="c6"><br /> Allah Almighty says:</span> <span class="c4">{Give Zakah.}</span> <span class="c5">[Surat al-<span class="c6">Baqarah:</span> 43]</span> </p>',
        ],
        35 => [
          'question' => 'Q36: What is the recommended charity?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/5170.mp3',
          'answer' => '<p> Answer: It is different from Zakah, as it is giving anything by way of charity to be used in any of the aspects of goodness at any time.<span class="c6"><br /> Allah Almighty says:</span> <span class="c4">{Spend in the way of Allah.}</span> <span class="c5">[Surat al-<span class="c6">Baqarah:</span> 195]</span> </p>',
        ],
        36 => [
          'question' => 'Q37: What is the definition of  Siyām (fasting)?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/5210.mp3',
          'answer' => '<p> Answer: It means worshiping Allah by abstaining from the invalidators of fasting from the break of dawn until sunset, while having the intention of fasting.<span class="c6"> It is of two types:</span><br /> First: Obligatory fasting: such as fasting the month of Ramadān, which is one of the pillars of Islam.<span class="c6"><br /> Allah Almighty says:</span> <span class="c4">{O you who believe, fasting is prescribed upon you as it was prescribed upon those who were before you, so that you may become righteous.}</span> <span class="c5">[Surat al-<span class="c6">Baqarah:</span> 183]</span><br /> Second: Voluntary fasting: such as fasting on Mondays and Thursdays; fasting three days every month, the best of which are the White Days <span class="c2">(13th, 14th, 15th)</span> of every lunar month. </p>',
        ],
        37 => [
          'question' => 'Q38: What is the merit of fasting Ramadān?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/5270.mp3',
          'answer' => '<p> Answer: Abu Hurayrah <span class="c2">(may Allah be pleased with him)</span> reported that the Prophet <span class="c2">(may Allah’s peace and blessings be upon him)</span> said: "Whoever fasts Ramadān out of faith and seeking reward from Allah, will have his past sins forgiven." <span class="c5">[Agreed upon]</span> </p>',
        ],
        38 => [
          'question' => 'Q39: What is the merit of voluntary fasting?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/5300.mp3',
          'answer' => '<p> Answer: Abu Sa‘īd al-Khudri <span class="c2">(may Allah be pleased with him)</span> reported that the Prophet <span class="c2">(may Allah’s peace and blessings be upon him)</span> said: "Whoever fasts a day for the sake of Allah, Allah will keep his face away from Hellfire <span class="c2">(the distance of)</span> seventy autumns for that day." <span class="c5">[Agreed upon]</span><br /> "Seventy autumns" means: seventy years. </p>',
        ],
        39 => [
          'question' => 'Q40: What are some of the invalidators of fasting?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/5330.mp3',
          'answer' => '<p> Answer: 1. Eating and drinking deliberately<br /> 2. Vomiting deliberately<br /> 3. Apostasy </p>',
        ],
        40 => [
          'question' => 'Q41: What are the Sunnah acts of fasting?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/5380.mp3',
          'answer' => '<p> Answer: 1. Hastening to break the fast<br /> 2. Having the Suhūr <span class="c2">(pre-dawn meal)</span> and delaying it<br /> 3. Increasing good deeds and acts of worship<br /> 4.<span class="c6"> Saying:</span> "I am fasting" if insulted<br /> 5. Supplicating at the time of breaking the fast<br /> 6. Breaking the fast by fresh dates or ripe dates, or drinking water if dates are unavailable </p>',
        ],
        41 => [
          'question' => 'Q42: What is the definition of  Hajj (pilgrimage)?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/5460.mp3',
          'answer' => '<p> Answer: Hajj means worshiping Allah Almighty by visiting His Sacred House and performing specific rituals during a specific time.<span class="c6"><br /> Allah Almighty says:</span> <span class="c4">{Pilgrimage to the House is a duty owed to Allah upon all people who are able to make their way to it; whoever disbelieves, then Allah is in no need for the worlds.}</span> <span class="c5">[Surat Āl ‘Imrān: 97]</span> </p>',
        ],
        42 => [
          'question' => 'Q43: How many pillars of Hajj are there?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/5500.mp3',
          'answer' => '<p> Answer: 1. Ihrām <span class="c2">(entering the ritual state of consecration)</span><br /> 2. Standing at ‘Arafah<br /> 3. Performing the Tawāf <span class="c2">(circumambulating the Ka‘bah)</span> of Ifādah <span class="c2">(pouring forth)</span><br /> 4. Performing Sa‘y <span class="c2">(walking at a brisk pace)</span> between Safa and Marwah </p>',
        ],
        43 => [
          'question' => 'Q44: What is the merit of Hajj?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/5560.mp3',
          'answer' => '<p> Answer: Abu Hurayrah <span class="c2">(may Allah be pleased with him)</span> reported that the Prophet <span class="c2">(may Allah’s peace and blessings be upon him)</span> said: "Whoever performs Hajj for the sake of Allah, while abstaining from intercourse and foul language, will return <span class="c2">(free from sins)</span> as if he were born anew." <span class="c5">[Narrated by Al-Bukhāri and others]</span><br /> "As if he were born anew" means: free from sins. </p>',
        ],
        44 => [
          'question' => 'Q45: What is the definition of  ‘Umrah?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/5600.mp3',
          'answer' => '<p> Answer: ‘Umrah <span class="c2">(minor pilgrimage)</span> means worshiping Allah Almighty by visiting His Sacred House to perform specific rituals at any time. </p>',
        ],
        45 => [
          'question' => 'Q46: What are the pillars of ‘Umrah?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/5630.mp3',
          'answer' => '<p> Answer: 1. Ihrām <span class="c2">(entering a ritual state of consecration)</span><br /> 2. Tawāf <span class="c2">(circumambulating the Ka‘bah)</span><br /> 3. Sa‘y <span class="c2">(walking at a brisk pace)</span> between Safa and Marwah </p>',
        ],
        46 => [
          'question' => 'Q47: What is Jihad (striving) in the cause of Allah?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/5690.mp3',
          'answer' => '<p> Answer: It means exerting one’s utmost effort in spreading Islam and defending it and its people, or fighting the enemies of Islam and Muslims.<span class="c6"><br /> Allah Almighty says:</span> <span class="c4">{And strive in the cause of Allah with your wealth and your lives. That is best for you, if only you knew.}</span> <span class="c5">[Surat at-<span class="c6">Tawbah:</span> 41]</span> </p>',
        ],
      ],
      3 => [
        0 => [
          'question' => 'Q1: What is the lineage of our Prophet Muhammad (may Allah’s peace and blessings be upon him)?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/5740.mp3',
          'answer' => '<p> Answer: He is Muhammad ibn ‘Abdullah ibn ‘Abd al-Muttalib ibn Hāshim. Hāshim was from the Quraysh, which belongs to the Arabs, who are from the offspring of Ismā‘il <span class="c2">(Ishmael)</span> the son of Ibrāhim <span class="c2">(Abraham)</span> <span class="c2">(peace be upon him)</span>. </p>',
        ],
        1 => [
          'question' => 'Q2: What is the name of our Prophet’s mother?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/5770.mp3',
          'answer' => '<p> Answer: Āminah bint Wahb. </p>',
        ],
        2 => [
          'question' => 'Q3: When did his father die?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/5800.mp3',
          'answer' => '<p> Answer: His father died in Madīnah when he was still an embryo, and was not born. </p>',
        ],
        3 => [
          'question' => 'Q4: When was the Prophet (may Allah’s peace and blessings be upon him) born?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/5830.mp3',
          'answer' => '<p> Answer: He was born in the Year of the Elephant, on Monday, in Rabī‘ al-Awwal. </p>',
        ],
        4 => [
          'question' => 'Q5: Where was he born?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/5850.mp3',
          'answer' => '<p> Answer: In Makkah. </p>',
        ],
        5 => [
          'question' => 'Q6: Who are his wet nurses?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/5880.mp3',
          'answer' => '<p> Answer: - Umm Ayman, the bondmaid of his father<br /> - Thuwaybah, the bondmaid of his uncle Abu Lahab<br /> - Halīmah as-Sa‘diyyah </p>',
        ],
        6 => [
          'question' => 'Q7: When did his mother die?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/5930.mp3',
          'answer' => '<p> Answer: His mother died when he was six years old, and his grandfather, ‘Abdul-Muttalib, took care of him after his mother’s death. </p>',
        ],
        7 => [
          'question' => 'Q8: Who took care of him after the death of his grandfather ‘Abdul-Muttalib?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/5960.mp3',
          'answer' => '<p> Answer: When he was eight years old, his grandfather died and his uncle, Abu Tālib, took care of him. </p>',
        ],
        8 => [
          'question' => 'Q9: When did he travel with his uncle to the Levant?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/5990.mp3',
          'answer' => '<p> Answer: He traveled with his uncle to the Levant when he was twelve years old. </p>',
        ],
        9 => [
          'question' => 'Q10: When was his second trip?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/6020.mp3',
          'answer' => '<p> Answer: He traveled for the second time on a trade journey with the money of Khadījah <span class="c2">(may Allah be pleased with her)</span>. When he returned, he married her when he was twenty-five years old. </p>',
        ],
        10 => [
          'question' => 'Q11: When did the Quraysh rebuild the Ka‘bah?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/6050.mp3',
          'answer' => '<p> Answer: The Quraysh rebuilt the Ka‘bah when he was thirty-five years old.<br /> On disagreeing about who would restore the Black Stone to its place, they sought his judgment; so, he put it on a piece of cloth and ordered each of the four tribes to hold one end of the cloth. Then, when they lifted it, he <span class="c2">(may Allah’s peace and blessings be upon him)</span> restored it to its place with his hands. </p>',
        ],
        11 => [
          'question' => 'Q12: How old was he when he was assigned the mission of prophethood? To whom was he sent?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/6080.mp3',
          'answer' => '<p> Answer: He was forty years old, and he was sent as a bringer of glad tidings and as a warner to all people. </p>',
        ],
        12 => [
          'question' => 'Q13: How did the revelation start?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/6110.mp3',
          'answer' => '<p> Answer: It started with the true vision: He would see no vision, except that it would occur just the way he had seen it. </p>',
        ],
        13 => [
          'question' => 'Q14: What was his state before the revelation? When did the revelation descend upon him the first time?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/6140.mp3',
          'answer' => '<p> Answer: He was worshiping Allah in the Cave of Hirā’,<br /> and the revelation descended upon him while he was in the cave in that state. </p>',
        ],
        14 => [
          'question' => 'Q15: What were the first Qur’anic verses that were revealed to him?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/6180.mp3',
          'answer' => '<p> Answer: The verses where Allah Almighty says: <span class="c4">{Read in the name of your Lord Who created, created man from a clinging clot. Read, and your Lord is the Most Generous, Who taught by the pen, taught man what he did not know.}</span> <span class="c5">[Surat al-<span class="c6">‘Alaq:</span> 1-5]</span> </p>',
        ],
        15 => [
          'question' => 'Q16: Who was the first one to believe in his message?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/6200.mp3',
          'answer' => '<p> Answer: The first to believe in his message from among the men was Abu Bakr; from the women: Khadījah bint Khuwaylid; from the boys: ‘Ali ibn Abi Tālib; from the freed slaves: Zayd ibn Hārithah; and from the salves: Bilāl al-Habashi <span class="c2">(may Allah be pleased with them)</span>, in addition to others. </p>',
        ],
        16 => [
          'question' => 'Q17: How was Da‘wah (preaching) to Islam carried out?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/6230.mp3',
          'answer' => '<p> Answer: Da‘wah to Islam was carried out secretly for almost three years. Then, the Prophet <span class="c2">(may Allah’s peace and blessings be upon him)</span> was commanded to call people to Islam in public. </p>',
        ],
        17 => [
          'question' => 'Q18: What was the state of the Prophet (may Allah’s peace and blessings be upon him) and those who believed in him after starting to make Da‘wah publicly?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/6260.mp3',
          'answer' => '<p> Answer: The polytheists started hurting him and the Muslims severely, until the believers were given the permission to emigrate to Najāshi <span class="c2">(Negus)</span> in Abyssinia.<br /> The polytheists unanimously agreed to kill the Prophet <span class="c2">(may Allah’s peace and blessings be upon him)</span>; nevertheless, Allah protected him and supported him with his uncle, Abu Tālib, to defend him against them. </p>',
        ],
        18 => [
          'question' => 'Q19: Who died in the tenth year of the Bi‘thah (start of the Prophet’s mission)?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/6300.mp3',
          'answer' => '<p> Answer: Both his uncle Abu Tālib and his wife Khadījah <span class="c2">(may Allah be pleased with her)</span>. </p>',
        ],
        19 => [
          'question' => 'Q20: When did the Isrā’ (Night Journey) along with the Mi‘rāj (Ascension Journey) take place?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/6330.mp3',
          'answer' => '<p> Answer: It took place when the Prophet <span class="c2">(may Allah’s peace and blessings be upon him)</span> was fifty years old. In this journey the five prayers were prescribed.<span class="c6"><br /> The Isrā’:</span> It was a journey from the Sacred Mosque to the Aqsa Mosque.<span class="c6"><br /> The Mi‘rāj:</span> It was ascension from the Aqsa Mosque to the heaven, then to the Sidrat al-Muntaha <span class="c2">(the Lote Tree of the Utmost Boundary)</span>. </p>',
        ],
        20 => [
          'question' => 'Q21: How did the Prophet (may Allah’s peace and blessings be upon him) call people to Allah outside of Makkah?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/6380.mp3',
          'answer' => '<p> Answer: He called the people of Tā’if to Islam and presented himself to people in their gathering seasons, until the Ansār <span class="c2">(the Supporters)</span> from among the people of Madīnah came and pledged allegiance to support him. </p>',
        ],
        21 => [
          'question' => 'Q22: How long did the Prophet (may Allah’s peace and blessings be upon him) stay in Makkah preaching?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/6410.mp3',
          'answer' => '<p> Answer: He stayed there for thirteen years. </p>',
        ],
        22 => [
          'question' => 'Q23: To where did the Prophet (may Allah’s peace and blessings be upon him) emigrate?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/6440.mp3',
          'answer' => '<p> Answer: He emigrated from Makkah to Madīnah. </p>',
        ],
        23 => [
          'question' => 'Q24: How long did he stay in Madīnah?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/6470.mp3',
          'answer' => '<p> Answer: Ten years. </p>',
        ],
        24 => [
          'question' => 'Q25: What were the Islamic legislations that were prescribed when he was in Madīnah?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/6490.mp3',
          'answer' => '<p> Answer: Zakah, fasting, Hajj, Jihad, the Adhān <span class="c2">(call to prayer)</span> besides other Islamic legislations that were prescribed when he was in Madīnah. </p>',
        ],
        25 => [
          'question' => 'Q26: What are his most important battles?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/6520.mp3',
          'answer' => '<p> Answer: -The Battle of Badr<br /> - The Battle of ’Uhud<br /> - The Battle of the Ahzāb <span class="c2">(the confederates)</span><br /> - The Battle of the Conquest of Makkah </p>',
        ],
        26 => [
          'question' => 'Q27: What is the last thing revealed of the Qur’an?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/6580.mp3',
          'answer' => '<p> Answer: The verse where Allah Almighty says: <span class="c4">{And fear the Day when you will be brought back to Allah. Then every soul will be rewarded in full for what it has earned, and none will be wronged.}</span> <span class="c5">[Surat al-<span class="c6">Baqarah:</span> 281]</span> </p>',
        ],
        27 => [
          'question' => 'Q28: When did the Prophet (may Allah’s peace and blessings be upon him) die? How old was he?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/6610.mp3',
          'answer' => '<p> Answer: He died in Rabī‘ al-Awwal, in the eleventh year of Hijrah. He was sixty-three years old. </p>',
        ],
        28 => [
          'question' => 'Q29: Who were the wives of the Prophet (may Allah’s peace and blessings be upon him)?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/6640.mp3',
          'answer' => '<p> Answer: 1. Khadījah bint Khuwaylid <span class="c2">(may Allah be pleased with her)</span><br /> 2. Sawdah bint Zam‘ah <span class="c2">(may Allah be pleased with her)</span><br /> 3. ‘Ā’ishah bint Abu Bakr <span class="c2">(may Allah be pleased with her)</span><br /> 4. Hafsah bint ‘Umar <span class="c2">(may Allah be pleased with her)</span><br /> 5. Zaynab bint Khuzaymah <span class="c2">(may Allah be pleased with her)</span><br /> 6. Umm Salamah Hind bint Abu Umayyah <span class="c2">(may Allah be pleased with her)</span><br /> 7. Umm Habībah Ramlah bint Abu Sufyān <span class="c2">(may Allah be pleased with her)</span><br /> 8. Juwayriyah bint al-Hārith <span class="c2">(may Allah be pleased with her)</span><br /> 9. Maymūnah bint al-Hārith <span class="c2">(may Allah be pleased with her)</span><br /> 10. Safiyyah bint Huyayy <span class="c2">(may Allah be pleased with her)</span><br /> 11. Zaynab bint Jahsh <span class="c2">(may Allah be pleased with her)</span> </p>',
        ],
        29 => [
          'question' => 'Q30: Who are the Prophet\'s sons and daughters?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/6760.mp3',
          'answer' => '<p> Answer: The Prophet <span class="c2">(may Allah\'s peace and blessings be upon him)</span> had three sons,<span class="c6"> who are:</span><br /> - Al-Qāsim, after whom he was nicknamed as "Abu al-Qāsim"<br /> - ‘Abdullah<br /> - Ibrāhim<br /> He had four daughters,<span class="c6"> who are:</span><br /> - Fātimah<br /> - Ruqayyah<br /> - Umm Kulthūm<br /> - Zaynab<br /> He had all of his children from Kahdījah <span class="c2">(may Allah be pleased with her)</span>, except Ibrāhim. All of them died before him, except Fātimah who died six months after his death. </p>',
        ],
        30 => [
          'question' => 'Q31: Mention some of the physical characteristics of the Prophet (may Allah’s peace and blessings be upon him).',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/6880.mp3',
          'answer' => '<p> Answer: He was of average height, not too short and not too tall. He had a white complexion, which was slightly reddish. He had a thick beard, big eyes, and a wide mouth. His hair was extremely black, his shoulders were broad, his smell was pleasant, in addition to other beautiful characteristics. </p>',
        ],
        31 => [
          'question' => 'Q32: Upon what did the Prophet (may Allah’s peace and blessings be upon him) leave his Ummah?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/6910.mp3',
          'answer' => '<p> Answer: He left his Ummah upon the clear path, whose night is as clear as its day and no one will deviate from it except one who is doomed. He has guided his Ummah to all goodness and has warned them against all evil. </p>',
        ],
      ],
      4 => [
        0 => [
          'question' => 'Q1: Recite Surat al-Fātihah and explain it.',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/6960.mp3',
          'answer' => '<p> Answer: Surat al-Fātihah and its Interpretation<br /> {<span class="c2">(In the name of Allah, the Most Compassionate, the Most Merciful)</span> <span class="c2">(All praise be to Allah, the Lord of the worlds)</span>, <span class="c2">(the Most Compassionate, the Most Merciful)</span> <span class="c2">(Master of the Day of Judgment)</span> <span class="c2">(You alone we worship, and You alone we ask for help)</span>. <span class="c2">(Guide us to the straight path)</span> <span class="c2">(the path of those whom You have blessed; not of those who incurred Your Wrath, or of those who went astray)</span>} <span class="c5">[Surat al-<span class="c6">Fātihah:</span> 1-7]</span><br /> Interpretation<br /> Surat al-Fātihah <span class="c2">(the Opening)</span> was given this name because it is the surah with which the Noble Qur’an begins.<br /> 1. <span class="c4">{بِسۡمِ ٱللَّهِ ٱلرَّحۡمَٰنِ ٱلرَّحِيمِ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001001.mp3"></audio>: In the name of Allah I start reciting the Qur’an, seeking His help and seeking blessing by mentioning His name.<br /> <span class="c4">{Allah}</span>: The One Who is truly worthy of worship, and none is given that name except the Almighty Lord.<br /> <span class="c4">{Ar-Rahmān}</span>: The One Whose extensive mercy encompasses everything.<br /> <span class="c4">{Ar-Rahīm}</span>: The One Who shows mercy to the believers.<br /> 2. <span class="c4">{ٱلۡحَمۡدُ لِلَّهِ رَبِّ ٱلۡعَٰلَمِينَ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001002.mp3"></audio>: All kinds of praise and perfection belong to Allah alone.<br /> 3. <span class="c4">{ٱلرَّحۡمَٰنِ ٱلرَّحِيمِ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001003.mp3"></audio>: The One Whose extensive mercy encompasses everything, and the One Who bestows mercy upon the believers.<br /> 4. <span class="c4">{مَٰلِكِ يَوۡمِ ٱلدِّينِ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001004.mp3"></audio>: It refers to the Day of Judgment.<br /> 5. <span class="c4">{إِيَّاكَ نَعۡبُدُ وَإِيَّاكَ نَسۡتَعِينُ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001005.mp3"></audio>: We worship You alone and we seek help from You alone.<br /> 6. <span class="c4">{ٱهۡدِنَا ٱلصِّرَٰطَ ٱلۡمُسۡتَقِيمَ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001006.mp3"></audio>: It refers to guidance to Islam and the Sunnah.<br /> 7. <span class="c4">{صِرَٰطَ ٱلَّذِينَ أَنۡعَمۡتَ عَلَيۡهِمۡ غَيۡرِ ٱلۡمَغۡضُوبِ عَلَيۡهِمۡ وَلَا ٱلضَّآلِّينَ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001007.mp3"></audio>: The path of the righteous slaves of Allah from the prophets and their followers, which is different from the path of the Christians and the Jews.<br /> -<span class="c6"> It is Sunnah to say:</span> "Āmīn" <span class="c2">(Answer our supplication!)</span> after reciting Surat al-Fātihah. </p>',
        ],
        1 => [
          'question' => 'Q2: Recite and explain Surat az-Zalzalah.',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/7130.mp3',
          'answer' => '<p> Answer: Surat az-Zalzalah and its Interpretation<br /> In the name of Allah, the Most Compassionate, the Most Merciful<br /> {When the earth is shaken with a mighty quake, and the earth throws out its burdens, and man says, <span class="c1">“What is the matter with it?”</span> On that Day it will recount all its news, because your Lord has inspired it <span class="c5">[to do so]</span>. On that Day all people will come forward in separate groups to be shown their deeds. So whoever does an atom’s weight of good will see it, and whoever does an atom’s weight of evil will see it.} <span class="c5">[Surat az-<span class="c6">Zalzalah:</span> 1-8]</span><br /> Interpretation<br /> 1. <span class="c4">{إِذَا زُلۡزِلَتِ ٱلۡأَرۡضُ زِلۡزَالَهَا}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099001.mp3"></audio>: When the earth is severely shaken on the Day of Judgment.<br /> 2. <span class="c4">{وَأَخۡرَجَتِ ٱلۡأَرۡضُ أَثۡقَالَهَا}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099002.mp3"></audio>: And when the earth brings out what is inside it of the dead and other things.<br /> 3. <span class="c4">{وَقَالَ ٱلۡإِنسَٰنُ مَا لَهَا}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099003.mp3"></audio>: And man says confusedly: "Why is the earth moving and shaking like that?!"<br /> 4. <span class="c4">{يَوۡمَئِذٖ تُحَدِّثُ أَخۡبَارَهَا}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099004.mp3"></audio>: On that great Day, the earth will speak of what goodness and evil had been done on it.<br /> 5. <span class="c4">{بِأَنَّ رَبَّكَ أَوۡحَىٰ لَهَا}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099005.mp3"></audio>: Because Allah informed it and commanded it to do so.<br /> 6. <span class="c4">{يَوۡمَئِذٖ يَصۡدُرُ ٱلنَّاسُ أَشۡتَاتٗا لِّيُرَوۡاْ أَعۡمَٰلَهُمۡ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099006.mp3"></audio>: On that great Day, when the earth is shaken, people will come in groups for Reckoning and they will be shown their worldly deeds.<br /> 7. <span class="c4">{فَمَن يَعۡمَلۡ مِثۡقَالَ ذَرَّةٍ خَيۡرٗا يَرَهُۥ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099007.mp3"></audio>: Whoever does an atom’s weight of good will see it in front of him.<br /> 8. <span class="c4">{وَمَن يَعۡمَلۡ مِثۡقَالَ ذَرَّةٖ شَرّٗا يَرَهُۥۥ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099008.mp3"></audio>: And whoever does its weight of evil will see it in front of him. </p>',
        ],
        2 => [
          'question' => 'Q3: Recite and explain Surat al-‘Ādiyāt.',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/7270.mp3',
          'answer' => '<p> Answer: Surat al-Ādiyāt and its Interpretation<br /> In the name of Allah, the Most Compassionate, the Most Merciful<br /> <span class="c4">{By the galloping, panting horses, striking sparks of fire <span class="c5">[with their hooves]</span>, launching raids at dawn, stirring up thereby clouds of dust, plunging thereby into the midst of the enemy, indeed, man is very ungrateful to his Lord – and he himself is a witness to that – and he is truly extreme in his love of wealth. Does he not know that the contents of graves will be overturned, and the secrets of the hearts will be brought to light? Indeed, their Lord is All-Aware of them on that Day.}</span> <span class="c5">[Surat al-<span class="c6">‘Ādiyāt:</span> 1-11]</span><br /> Interpretation:<br /> 1. <span class="c4">{وَٱلۡعَٰدِيَٰتِ ضَبۡحٗا}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100001.mp3"></audio>: Allah swears by the horses that run so fast that the sound of their breathing is heard.<br /> 2. <span class="c4">{فَٱلۡمُورِيَٰتِ قَدۡحٗا}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100002.mp3"></audio>: He also swears by the horses that strike sparks of fire with their hooves when strongly coming in contact with the rocks.<br /> 3. <span class="c4">{فَٱلۡمُغِيرَٰتِ صُبۡحٗا}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100003.mp3"></audio>: He swears by the horses that attack the enemies in the morning.<br /> 4. <span class="c4">{فَأَثَرۡنَ بِهِۦ نَقۡعٗا}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100004.mp3"></audio>: So, they stir up dust by their running.<br /> 5. <span class="c4">{فَوَسَطۡنَ بِهِۦ جَمۡعًا}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100005.mp3"></audio>: Plunging with their riders into the midst of a group of the enemies.<br /> 6. <span class="c4">{إِنَّ ٱلۡإِنسَٰنَ لِرَبِّهِۦ لَكَنُودٞ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100006.mp3"></audio>: Indeed, man withholds the goodness that his Lord commands him to give out.<br /> 7. <span class="c4">{وَإِنَّهُۥ عَلَىٰ ذَٰلِكَ لَشَهِيدٞ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100007.mp3"></audio>: He himself is a witness to his own withholding of goodness, and he cannot deny it because it is so clear.<br /> 8. <span class="c4">{وَإِنَّهُۥ لِحُبِّ ٱلۡخَيۡرِ لَشَدِيدٌ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100008.mp3"></audio>: Due to his extreme love for money, he greedily withholds it.<br /> 9. <span class="c4">{أَفَلَا يَعۡلَمُ إِذَا بُعۡثِرَ مَا فِي ٱلۡقُبُورِ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100009.mp3"></audio>: Does this man, who is deceived by the worldly life, not know that when Allah brings out the dead from the graves and out of the earth for reckoning and recompense that things will not be the way he fancied?!<br /> 10. <span class="c4">{وَحُصِّلَ مَا فِي ٱلصُّدُورِ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100010.mp3"></audio>: What is in the hearts of intentions, beliefs, and others will be shown and brought to light.<br /> 11. <span class="c4">{إِنَّ رَبَّهُم بِهِمۡ يَوۡمَئِذٖ لَّخَبِيرُۢ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100011.mp3"></audio>: Indeed, their Lord is All-Aware of them on that Day, and nothing of His slaves\' affairs will be hidden from Him and He shall recompense them for it. </p>',
        ],
        3 => [
          'question' => 'Q4: Recite and explain Surat al-Qāri‘ah.',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/7450.mp3',
          'answer' => '<p> Answer: Surat al-Qāri‘ah and its Interpretation<br /> In the name of Allah, the Most Compassionate, the Most Merciful<br /> <span class="c4">{The Striking Calamity! What is the Striking Calamity? How do you know what the Striking Calamity is? On that Day people will be like scattered moths, and the mountains will be like carded wool. Then the one whose scales of good deeds are heavy, will have a pleasant life. But the one whose scales of good deeds are light, his abode will be the abyss. And how do you know what it is? It is a Blazing Fire.}</span> <span class="c5">[Surat al-<span class="c6">Qāri‘ah:</span> 1-11]</span><br /> Interpretation<br /> 1. <span class="c4">{ٱلۡقَارِعَةُ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101001.mp3"></audio>: The Hour that strikes people’s hearts because of it being extremely terrifying.<br /> 2. <span class="c4">{مَا ٱلۡقَارِعَةُ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101002.mp3"></audio>: What is this Hour that strikes people’s hearts because of it being extremely terrifying?!<br /> 3. <span class="c4">{وَمَآ أَدۡرَىٰكَ مَا ٱلۡقَارِعَةُ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101003.mp3"></audio>: How do you know - O Messenger - what this Hour is that strikes people’s hearts because of it being extremely terrifying? It is the Day of Judgment.<br /> 4. <span class="c4">{يَوۡمَ يَكُونُ ٱلنَّاسُ كَٱلۡفَرَاشِ ٱلۡمَبۡثُوثِ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101004.mp3"></audio>: The day it strikes people’s hearts, they will be like the moths scattered here and there.<br /> 5. <span class="c4">{وَتَكُونُ ٱلۡجِبَالُ كَٱلۡعِهۡنِ ٱلۡمَنفُوشِ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101005.mp3"></audio>: The mountains will be like carded wool, fluffed up.<br /> 6. <span class="c4">{فَأَمَّا مَن ثَقُلَتۡ مَوَٰزِينُهُۥ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101006.mp3"></audio>: The one whose good deeds outweigh his bad deeds.<br /> 7. <span class="c4">{فَهُوَ فِي عِيشَةٖ رَّاضِيَةٖ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101007.mp3"></audio>: He will enjoy a pleasant life in Paradise.<br /> 8. <span class="c4">{وَأَمَّا مَنۡ خَفَّتۡ مَوَٰزِينُهُۥ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101008.mp3"></audio>: The one whose bad deeds outweigh his good deeds.<br /> 9. <span class="c4">{فَأُمُّهُۥ هَاوِيَةٞ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101009.mp3"></audio>: His abode and dwelling will be Hellfire.<br /> 10. <span class="c4">{وَمَآ أَدۡرَىٰكَ مَا هِيَهۡ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101010.mp3"></audio>: How do you know - O Messenger - what it is?<br /> 11. <span class="c4">{نَارٌ حَامِيَةُۢ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101011.mp3"></audio>: It is a blazing fire. </p>',
        ],
        4 => [
          'question' => 'Q5: Recite and explain Surat at-Takāthur.',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/7610.mp3',
          'answer' => '<p> Answer: Surat at-Takāthur and its Interpretation<br /> In the name of Allah, the Most Compassionate, the Most Merciful<br /> <span class="c4">{Competition for worldly gains distracts you <span class="c5">[from Allah]</span>, until you come to your graves. No indeed! You will come to know. Again no! You will come to know. No indeed! If only you knew for certain. You will surely see the Blazing Fire, Again, you will see it with absolute certainty. Then on that Day you will surely be asked about your worldly pleasures.}</span> <span class="c5">[Surat at-<span class="c6">Takāthur:</span> 1-8]</span><br /> Interpretation<br /> 1. <span class="c4">{أَلۡهَىٰكُمُ ٱلتَّكَاثُرُ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102001.mp3"></audio>: O people, boasting about your wealth and children distracted you from obeying Allah.<br /> 2. <span class="c4">{حَتَّىٰ زُرۡتُمُ ٱلۡمَقَابِرَ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102002.mp3"></audio>: Until you die and enter your graves.<br /> 3. <span class="c4">{كَلَّا سَوۡفَ تَعۡلَمُونَ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102003.mp3"></audio>: You should not have been distracted by boasting, and you will come to realize the consequence of that distraction.<br /> 4. <span class="c4">{ثُمَّ كَلَّا سَوۡفَ تَعۡلَمُونَ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102004.mp3"></audio>: Then, you will come to realize its consequence.<br /> 5. <span class="c4">{كَلَّا لَوۡ تَعۡلَمُونَ عِلۡمَ ٱلۡيَقِينِ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102005.mp3"></audio>: Truly, if you had known for certain that you will be resurrected to Allah Who will recompense you for your deeds, you would not have been distracted by boasting about wealth and children.<br /> 6. <span class="c4">{لَتَرَوُنَّ ٱلۡجَحِيمَ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102006.mp3"></audio>: By Allah, you will surely see Hellfire on the Day of Judgment.<br /> 7. <span class="c4">{ثُمَّ لَتَرَوُنَّهَا عَيۡنَ ٱلۡيَقِينِ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102007.mp3"></audio>: Again, you will see it with absolute certainty.<br /> 8. <span class="c4">{ثُمَّ لَتُسۡـَٔلُنَّ يَوۡمَئِذٍ عَنِ ٱلنَّعِيمِ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102008.mp3"></audio>: Then, on that Day Allah will ask you about the blessings that He bestowed upon you including health, wealth, and others. </p>',
        ],
        5 => [
          'question' => 'Q6: Recite and explain Surat al-‘Asr.',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/7750.mp3',
          'answer' => '<p> Answer: Surat al-‘Asr and its Interpreation<br /> In the name of Allah, the Most Compassionate, the Most Merciful<br /> <span class="c4">{By the time, man is in utter loss, except those who believe and do righteous deeds, and exhort one another to the truth and exhort one another to patience.}</span> <span class="c5">[Surat al-<span class="c6">‘Asr:</span> 1-3]</span><br /> Interpretation<br /> 1. <span class="c4">{وَٱلۡعَصۡرِ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/103001.mp3"></audio>: Allah Almighty swears by time.<br /> 2. <span class="c4">{إِنَّ ٱلۡإِنسَٰنَ لَفِي خُسۡرٍ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/103002.mp3"></audio>: All mankind are in utter loss.<br /> 3. <span class="c4">{إِلَّا ٱلَّذِينَ ءَامَنُواْ وَعَمِلُواْ ٱلصَّٰلِحَٰتِ وَتَوَاصَوۡاْ بِٱلۡحَقِّ وَتَوَاصَوۡاْ بِٱلصَّبۡرِ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/103003.mp3"></audio>: The only survivors of that loss are those who believe and perform righteous deeds and at the same time call to the truth and endure it with patience. </p>',
        ],
        6 => [
          'question' => 'Q7: Recite and explain Surat al-Humuzah.',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/7830.mp3',
          'answer' => '<p> Answer: Surat al-Humazah and its Interpretaion<br /> In the name of Allah, the Most Compassionate, the Most Merciful<br /> <span class="c4">{Woe to every backbiter and slanderer, who amasses wealth and counts it over and again, thinking that his wealth will make him live forever. No indeed! He will surely be cast into the Crushing Fire, and how do you know what the Crushing Fire is? It is the kindled Fire of Allah, which reaches the hearts. It will be closed down upon them, locked with towering columns.}</span> <span class="c5">[Surat al-<span class="c6">Humazah:</span> 1-9]</span><br /> Interpretation<br /> 1. <span class="c4">{وَيۡلٞ لِّكُلِّ هُمَزَةٖ لُّمَزَةٍ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104001.mp3"></audio>: Woe and severe torment to everyone who frequently backbites and slanders people.<br /> 2. <span class="c4">{ٱلَّذِي جَمَعَ مَالٗا وَعَدَّدَهُۥ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104002.mp3"></audio>: The one who is interested in nothing but accumulating and counting money.<br /> 3. <span class="c4">{يَحۡسَبُ أَنَّ مَالَهُۥٓ أَخۡلَدَهُۥ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104003.mp3"></audio>: He thinks that the money he has amassed will save him from death and keep him live forever.<br /> 4. <span class="c4">{كَلَّاۖ لَيُنۢبَذَنَّ فِي ٱلۡحُطَمَةِۥ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104004.mp3"></audio>: Things will not be the way this ignorant person has fancied. Indeed, he will be cast in Hellfire and will be crushed therein by its severity.<br /> 5. <span class="c4">{وَمَآ أَدۡرَىٰكَ مَا ٱلۡحُطَمَةُ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104005.mp3"></audio>: How do you know - O Messenger - what this Fire is that crushes everything thrown therein?<br /> 6. <span class="c4">{نَارُ ٱللَّهِ ٱلۡمُوقَدَةُ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104006.mp3"></audio>: It is the kindled Fire of Allah.<br /> 7. <span class="c4">{ٱلَّتِي تَطَّلِعُ عَلَى ٱلۡأَفۡـِٔدَةِ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104007.mp3"></audio>: That penetrates people’s bodies reaching their hearts.<br /> 8. <span class="c4">{إِنَّهَا عَلَيۡهِم مُّؤۡصَدَةٞ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104008.mp3"></audio>: It is closed down upon those tormented therein.<br /> 9. <span class="c4">{فِي عَمَدٖ مُّمَدَّدَةِۭ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104009.mp3"></audio>: It is locked with long and extended columns so that they are not able to come out. </p>',
        ],
        7 => [
          'question' => 'Q8: Recite and explain Surat al-Fīl.',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/7970.mp3',
          'answer' => '<p> Answer: Surat al-Fīl and its Interpretation<br /> In the name of Allah, the Most Compassionate, the Most Merciful<br /> <span class="c4">{Have you not seen how your Lord dealt with the people of the Elephant? Did He not turn their scheme into a total loss? He sent against them swarms of birds, pelting them with stones of baked clay, leaving them like chewed up and trampled chaff.}</span> <span class="c5">[Surat al-<span class="c6">Fīl:</span> 1-5]</span><br /> Interpretation<br /> 1. <span class="c4">{أَلَمۡ تَرَ كَيۡفَ فَعَلَ رَبُّكَ بِأَصۡحَٰبِ ٱلۡفِيلِ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105001.mp3"></audio>: Have you not known - O Messenger - what your Lord did to Abrahah and his companions, the people of the Elephant, when they wanted to demolish the Ka‘bah?<br /> 2. <span class="c4">{أَلَمۡ يَجۡعَلۡ كَيۡدَهُمۡ فِي تَضۡلِيلٖ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105002.mp3"></audio>: Allah turned their evil scheme to demolish it into a total loss; thus, they did not attain what they had wished for, namely turning people away from the Ka‘bah and destroying it.<br /> 3. <span class="c4">{وَأَرۡسَلَ عَلَيۡهِمۡ طَيۡرًا أَبَابِيلَ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105003.mp3"></audio>: He sent against them swarms of birds.<br /> 4. <span class="c4">{تَرۡمِيهِم بِحِجَارَةٖ مِّن سِجِّيلٖ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105004.mp3"></audio>: Pelting them with stones of baked clay.<br /> 5. <span class="c4">{فَجَعَلَهُمۡ كَعَصۡفٖ مَّأۡكُولِۭ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105005.mp3"></audio>: Allah made them like leaves that are eaten and trodden by animals. </p>',
        ],
        8 => [
          'question' => 'Q9: Recite and explain Surat Quraysh.',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/8070.mp3',
          'answer' => '<p> Answer: Surat Quraysh and its Interpretation<br /> In the name of Allah, the Most Compassionate, the Most Merciful<br /> <span class="c4">{For the accustomed security of Quraysh, secure in their winter and summer journeys. Let them worship the Lord of this <span class="c5">[Sacred]</span> House, Who fed them against hunger and made them secure against fear.}</span> <span class="c5">[Surat Quraysh: 1-4]</span><br /> Interpretation<br /> 1. <span class="c4">{لِإِيلَٰفِ قُرَيۡشٍ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106001.mp3"></audio>: It is referring to the winter and summer journeys that they were familiar with.<br /> 2. <span class="c4">{إِۦلَٰفِهِمۡ رِحۡلَةَ ٱلشِّتَآءِ وَٱلصَّيۡفِ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106002.mp3"></audio>: They were secure in their winter journey to Yemen and in their summer journey to the Levant.<br /> 3. <span class="c4">{فَلۡيَعۡبُدُواْ رَبَّ هَٰذَا ٱلۡبَيۡتِ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106003.mp3"></audio>: Let them worship Allah, the Lord of this Sacred House, alone. He is the One Who facilitated that journey for them; so, let them not associate any partners with Him.<br /> 4. <span class="c4">{ٱلَّذِيٓ أَطۡعَمَهُم مِّن جُوعٖ وَءَامَنَهُم مِّنۡ خَوۡفِۭ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106004.mp3"></audio>: Who fed them against hunger and made them secure against fear by making the Arabs revering Al-Haram <span class="c2">(the Sacred Precinct)</span> and its people. </p>',
        ],
        9 => [
          'question' => 'Q10: Recite and explain Surat al-Mā‘ūn.',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/8160.mp3',
          'answer' => '<p> Answer: Surat al-Mā‘ūn and its Interpretation<br /> In the name of Allah, the Most Compassionate, the Most Merciful<br /> <span class="c4">{Have you seen the one who denies the Recompense? Such is the one who repulses the orphan harshly, and does not urge others to feed the needy. So woe to those who pray, but are heedless of their prayer; those who only show off, and withhold even the small kindnesses.}</span> <span class="c5">[Surat al-<span class="c6">Mā‘ūn:</span> 1-7]</span><br /> Interpretation<br /> 1. <span class="c4">{أَرَءَيۡتَ ٱلَّذِي يُكَذِّبُ بِٱلدِّينِ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107001.mp3"></audio>: Did you know the one who denies recompense on the Day of Judgment?<br /> 2. <span class="c4">{فَذَٰلِكَ ٱلَّذِي يَدُعُّ ٱلۡيَتِيمَ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107002.mp3"></audio>: Such is the one who repulses the orphan harshly.<br /> 3. <span class="c4">{وَلَا يَحُضُّ عَلَىٰ طَعَامِ ٱلۡمِسۡكِينِ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107003.mp3"></audio>: He does not urge himself or others to feed the poor.<br /> 4. <span class="c4">{فَوَيۡلٞ لِّلۡمُصَلِّينَ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107004.mp3"></audio>: Woe and torment to those who pray.<br /> 5. <span class="c4">{ٱلَّذِينَ هُمۡ عَن صَلَاتِهِمۡ سَاهُونَ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107005.mp3"></audio>: Those who are heedless of their prayer until its prescribed time is gone.<br /> 6. <span class="c4">{ٱلَّذِينَ هُمۡ يُرَآءُونَ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107006.mp3"></audio>: Those who only show off by praying and doing good deeds, and who do not dedicate them with sincerity to Allah.<br /> 7. <span class="c4">{وَيَمۡنَعُونَ ٱلۡمَاعُونَ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107007.mp3"></audio>: And they withhold anything that could be of help to others no matter how small it is. </p>',
        ],
        10 => [
          'question' => 'Q11: Recite and explain Surat al-Kawthar.',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/8280.mp3',
          'answer' => '<p> Answer: Surat al-Kawthar and its Interpretation<br /> In the name of Allah, the Most Compassionate, the Most Merciful<br /> <span class="c4">{We have surely given you <span class="c5">[O Prophet]</span> Al-Kawthar <span class="c5">[abundance]</span>, so pray and sacrifice to your Lord alone. Indeed, the one who hates you is truly cut off <span class="c5">[from all goodness]</span>.}</span> <span class="c5">[Surat al-<span class="c6">Kawthar:</span> 1-3]</span><br /> Interpretation<br /> 1. <span class="c4">{إِنَّآ أَعۡطَيۡنَٰكَ ٱلۡكَوۡثَرَ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/108001.mp3"></audio>: We have given you, O Messenger, abundant goodness that includes the Kawthar River in Paradise.<br /> 2. <span class="c4">{فَصَلِّ لِرَبِّكَ وَٱنۡحَرۡ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/108002.mp3"></audio>: So, be thankful to Allah for this blessing by praying and sacrificing to Him alone, contrary to what the polytheists do when they seek closeness to their idols by offering sacrifices to them.<br /> 3. <span class="c4">{إِنَّ شَانِئَكَ هُوَ ٱلۡأَبۡتَرُ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/108003.mp3"></audio>: The one who hates you is, indeed, the one who is cut off from all goodness, the one who is forgotten, and the one who is ill spoken of whenever mentioned. </p>',
        ],
        11 => [
          'question' => 'Q12: Recite and explain Surat al-Kāfirūn.',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/8360.mp3',
          'answer' => '<p> Answer: Surat al-Kāfirūn and its Interpretation<br /> In the name of Allah, the Most Compassionate, the Most Merciful<br /> <span class="c4">{Say, “O disbelievers, I do not worship what you worship, nor do you worship what I worship. Never will I worship what you worship, nor will you ever worship what I worship. You have your religion and I have my religion.}</span> <span class="c5">[Surat al-<span class="c6">Kāfirūn:</span> 1-6]</span><br /> Interpretation<br /> 1. <span class="c4">{قُلۡ يَٰٓأَيُّهَا ٱلۡكَٰفِرُونَ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109001.mp3"></audio>: Say - O Messenger -<span class="c6"> :</span> O you who disbelieve in Allah.<br /> 2. <span class="c4">{لَآ أَعۡبُدُ مَا تَعۡبُدُونَ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109002.mp3"></audio>: I do not and I shall not worship the idols that you worship.<br /> 3. <span class="c4">{وَلَآ أَنتُمۡ عَٰبِدُونَ مَآ أَعۡبُدُ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109003.mp3"></audio>: Nor do you worship what I worship, namely, Allah alone.<br /> 4. <span class="c4">{وَلَآ أَنَا۠ عَابِدٞ مَّا عَبَدتُّمۡ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109004.mp3"></audio>: And never will I worship the idols that you worship.<br /> 5. <span class="c4">{وَلَآ أَنتُمۡ عَٰبِدُونَ مَآ أَعۡبُدُ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109005.mp3"></audio>: Nor will you ever worship what I worship, namely, Allah alone.<br /> 6. <span class="c4">{لَكُمۡ دِينُكُمۡ وَلِيَ دِينِ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109006.mp3"></audio>: You have your own religion that you invented, and I have my religion that Allah revealed to me. </p>',
        ],
        12 => [
          'question' => 'Q13: Recite and explain Surat an-Nasr.',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/8470.mp3',
          'answer' => '<p> Answer: Surat an-Nasr and its Interpretation<br /> In the Name of Allah, the Most Compassionate, the Most Merciful<br /> <span class="c4">{When there comes Allah’s help and the conquest, and you see people entering Allah’s religion in multitudes, then glorify the praise of your Lord, and ask His forgiveness. Indeed, He is ever Accepting of Repentance.}</span> <span class="c5">[Surat an-<span class="c6">Nasr:</span> 1-3]</span><br /> Interpretation<br /> 1. <span class="c4">{إِذَا جَآءَ نَصۡرُ ٱللَّهِ وَٱلۡفَتۡحُ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/110001.mp3"></audio>: When Allah grants victory and strength to your religion - O Messenger - and when the Conquest of Makkah takes place.<br /> 2. <span class="c4">{وَرَأَيۡتَ ٱلنَّاسَ يَدۡخُلُونَ فِي دِينِ ٱللَّهِ أَفۡوَاجٗا}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/110002.mp3"></audio>: And you see people embracing Islam one delegation after the other.<br /> 3. <span class="c4">{فَسَبِّحۡ بِحَمۡدِ رَبِّكَ وَٱسۡتَغۡفِرۡهُۚ إِنَّهُۥ كَانَ تَوَّابَۢا}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/110003.mp3"></audio>: You should know, then, that this is a sign that your mission is about to end. Thus, glorify the praise of your Lord, out of gratitude for His blessing of the victory and conquest, and seek His forgiveness, for indeed, He accepts the repentance of His slaves and forgives them. </p>',
        ],
        13 => [
          'question' => 'Q14: Recite and explain Surat al-Masad.',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/8550.mp3',
          'answer' => '<p> Answer: Surat al-Masad and its Interpretation<br /> In the name of Allah, the Most Compassionate, the Most Merciful<br /> <span class="c4">{May the hands of Abu Lahab perish, and may he perish! Neither his wealth nor his worldly gains will avail him. He will burn in a Flaming Fire, and so will his wife, the carrier of firewood, around her neck will be a rope of palm fiber.}</span> <span class="c5">[Surat al-<span class="c6">Masad:</span> 1-5]</span><br /> Interpretation<br /> 1. <span class="c4">{تَبَّتۡ يَدَآ أَبِي لَهَبٖ وَتَبَّ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111001.mp3"></audio>: May perish the hands of the Prophet’s uncle, Abu Lahab ibn ‘Abd al-Muttalib, just as his deeds perished because he used to abuse the Prophet <span class="c2">(may Allah’s peace and blessings be upon him}.<br /> 2. <span class="c4">{مَآ أَغۡنَىٰ عَنۡهُ مَالُهُۥ وَمَا كَسَبَ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111002.mp3"></audio>: Were his wealth and children of any use to him? They could neither save him from torment nor bring him mercy.<br /> 3. <span class="c4">{سَيَصۡلَىٰ نَارٗا ذَاتَ لَهَبٖ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111003.mp3"></audio>: On the Day of Judgment, he will be admitted into Hellfire where he will suffer from its heat.<br /> 4. <span class="c4">{وَٱمۡرَأَتُهُۥ حَمَّالَةَ ٱلۡحَطَبِ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111004.mp3"></audio>: His wife, Umm Jamīl, who used to hurt the Prophet (may Allah’s peace and blessings be upon him)</span> by throwing thorns on his way, will also be admitted to Hellfire.<br /> 5. <span class="c4">{فِي جِيدِهَا حَبۡلٞ مِّن مَّسَدِۭ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111005.mp3"></audio>: She will be driven to Hellfire by a tight rope around her neck. </p>',
        ],
        14 => [
          'question' => 'Q15: Recite and explain Surat al-Ikhlās.',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/8650.mp3',
          'answer' => '<p> Answer: Surat al-Ikhlās and its Interpretation<br /> In the name of Allah, the Most Compassionate,<span class="c6"> the Most Merciful<br /> {Say:</span> <span class="c1">“He is Allah, the One; Allah, the Eternal Refuge. He neither begets nor is He begotten, and there is none comparable to Him.”</span>} <span class="c5">[Surat al-<span class="c6">Ikhlās:</span> 1-4]</span><br /> Interpretation<br /> 1. <span class="c4">{قُلۡ هُوَ ٱللَّهُ أَحَدٌ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112001.mp3"></audio>: Say - O Messenger -: He is Allah; there is no god worthy of worship but Him.<br /> 2. <span class="c4">{ٱللَّهُ ٱلصَّمَدُ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112002.mp3"></audio>: It means that all the needs of His creation are raised to Him.<br /> 3. <span class="c4">{لَمۡ يَلِدۡ وَلَمۡ يُولَدۡ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112003.mp3"></audio>: Allah Almighty neither has a child nor does He have a father.<br /> 4. <span class="c4">{وَلَمۡ يَكُن لَّهُۥ كُفُوًا أَحَدُۢ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112004.mp3"></audio>: None of His creation is like Him. </p>',
        ],
        15 => [
          'question' => 'Q16: Recite and explain Surat al-Falaq.',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/8750.mp3',
          'answer' => '<p> Answer: Surat al-Falaq and its Interpretation<br /> In the name of Allah, the Most Compassionate, the Most Merciful<br /> <span class="c4">{Say, “I seek refuge with the Lord of the daybreak, from the harm of all what He has created; from the harm of night’s darkness when it spreads around, from the harm of the sorceresses who blow on knots, and from the harm of the envier when he envies.}</span> <span class="c5">[Surat al-<span class="c6">Falaq:</span> 1-5]</span><br /> Interpretation<br /> 1. <span class="c4">{قُلۡ أَعُوذُ بِرَبِّ ٱلۡفَلَقِ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113001.mp3"></audio>: Say - O Messenger -: I resort to and seek refuge with the Lord of the morning.<br /> 2. <span class="c4">{مِن شَرِّ مَا خَلَقَ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113002.mp3"></audio>: From the evil of the harmful creatures.<br /> 3. <span class="c4">{وَمِن شَرِّ غَاسِقٍ إِذَا وَقَبَ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113003.mp3"></audio>: And I seek refuge with Allah from the evils of what appear at night like animals and thieves.<br /> 4. <span class="c4">{وَمِن شَرِّ ٱلنَّفَّٰثَٰتِ فِي ٱلۡعُقَدِ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113004.mp3"></audio>: And I seek refuge with Allah from the evil of the sorceresses who blow on knots.<br /> 5. <span class="c4">{وَمِن شَرِّ حَاسِدٍ إِذَا حَسَدَ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113005.mp3"></audio>: And from the evil of the one who hates and envies people for the blessings that Allah bestowed on them, as he wishes that they would no longer enjoy such blessings and wishes that harm be inflicted on them. </p>',
        ],
        16 => [
          'question' => 'Q17: Recite and explain Surat an-Nās.',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/8870.mp3',
          'answer' => '<p> Answer: Surat an-Nās and its Interpretation<br /> In the name of Allah, the Most Compassionate, the Most Merciful<br /> {Say, <span class="c1">“I seek refuge with the Lord of mankind, the Sovereign of mankind, the God of mankind, from the harm of the lurking whisperer, who whispers into the hearts of mankind, from among jinn and mankind.”</span>} <span class="c5">[Surat an-<span class="c6">Nās:</span> 1-6]</span><br /> Interpretation<br /> 1. <span class="c4">{قُلۡ أَعُوذُ بِرَبِّ ٱلنَّاسِ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114001.mp3"></audio>: Say - O Messenger -: I seek protection and refuge with the Lord of mankind.<br /> 2. <span class="c4">{مَلِكِ ٱلنَّاسِ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114002.mp3"></audio>: He manages their affairs as He wills, and He is their only Owner.<br /> 3. <span class="c4">{إِلَٰهِ ٱلنَّاسِ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114003.mp3"></audio>: Their true God, and there is no god other than Him worthy of their worship.<br /> 4. <span class="c4">{مِن شَرِّ ٱلۡوَسۡوَاسِ ٱلۡخَنَّاسِ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114004.mp3"></audio>: From the evil of the devil, who whispers to people.<br /> 5. <span class="c4">{ٱلَّذِي يُوَسۡوِسُ فِي صُدُورِ ٱلنَّاسِ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114005.mp3"></audio>: Who whispers into the hearts of mankind.<br /> 6. <span class="c4">{مِنَ ٱلۡجِنَّةِ وَٱلنَّاسِ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114006.mp3"></audio>: It means that the whisperer could be from mankind or from the jinn. </p>',
        ],
      ],
      5 => [
        0 => [
          'question' => 'Q1: Complete the following Hadīth: "Verily, the reward of deeds depends on the intentions...", and mention some of its benefits.',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/9030.mp3',
          'answer' => '<p> Answer: The Commander of the Believers, Abu Hafs ‘Umar ibn al-Khattāb <span class="c2">( may Allah be pleased with him)</span> reported that he heard the Prophet <span class="c2">(may Allah\'s peace and blessings be upon him)</span> say: "Verily, the reward of deeds depends on the intentions, and each person will be rewarded according to what he intended. So, he whose migration is for the sake of Allah and His Messenger, then his migration is for the sake of Allah and His Messenger, and he whose migration is to achieve some worldly gain or to take some woman in marriage, then his migration is for that for which he migrated." <span class="c5">[Narrated by Al-Bukhāri and Muslim]</span><br /> Benefits of the Hadīth<br /> 1. Every deed requires an intention, such as prayer, fasting, pilgrimage, etc.<br /> 2. The intention must be dedicated with full sincerity to Allah Almighty.<br /> Second Hadīth </p>',
        ],
        1 => [
          'question' => 'Q2: Complete the following Hadīth: "Whoever introduces in this matter of ours ..." and mention some of its benefits.',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/9090.mp3',
          'answer' => '<p> Answer: The Mother of the Believers, Umm ‘Abdullah ‘Ā’ishah <span class="c2">(may Allah be pleased with her)</span> reported that the Prophet <span class="c2">(may Allah\'s peace and blessings be upon him)</span> said: "Whoever introduces in this matter of ours <span class="c2">(the religion)</span> something that does not belong to it, it will be rejected." <span class="c5">[Narrated by Al-Bukhāri and Muslim]</span><br /> Benefits of the Hadīth<br /> 1. Prohibition of introducing new things in religion<br /> 2. Actions based upon religious innovations are rejected<br /> Third Hadīth </p>',
        ],
        2 => [
          'question' => 'Q3: Complete the following Hadīth: "While we were one day sitting with the Messenger of Allah (may Allah\'s peace and blessings be upon him)..." and mention some of its benefits.',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/9160.mp3',
          'answer' => '<p> Answer: ‘Umar ibn al-Khattāb <span class="c2">(may Allah be pleased with him)</span> said: "While we were one day sitting with the Messenger of Allah <span class="c2">(may Allah\'s peace and blessings be upon him)</span>, there appeared before us a man dressed in extremely white clothes and with very black hair. No traces of traveling were visible on him, and none of us knew him. He sat down close to the Prophet <span class="c2">(may Allah\'s peace and blessings be upon him)</span> resting his knees against the knees of the Prophet <span class="c2">(may Allah\'s peace and blessings be upon him)</span> and placing his palms over his thighs,<span class="c6"> and said:</span> \'O Muhammad, tell me about Islam.\' The Messenger of Allah <span class="c2">(may Allah\'s peace and blessings be upon him)</span> replied: \'Islam is to testify that there is no god except Allah and that Muhammad is His messenger, to perform prayer, give Zakah, fast Ramadān, and perform Hajj <span class="c2">(pilgrimage)</span> to the House <span class="c2">(the Ka‘bah)</span>, if you have the means to perform it.<span class="c6">\' He said:</span> \'You have spoken the truth.\' We were surprised at his questioning him and then declaring that he spoke the truth.<span class="c6"> He said:</span> \'Tell me about Imān <span class="c2">(faith)</span>.\' He <span class="c2">(the Prophet)</span> answered: \'It is to believe in Allah, His angels, His Books, His messengers, the Last Day, and in destiny with its good and evil aspects.<span class="c6">\' He said:</span> \'You have spoken the truth.\' Then he <span class="c2">(the man)</span> said: \'Tell me about Ihsān <span class="c2">(excellence)</span>.\' He <span class="c2">(the Prophet)</span> answered: \'It is to worship Allah as though you could see Him, for if you cannot see Him, He indeed sees you.<span class="c6">\' He said:</span> \'Tell me about the Hour.\' He <span class="c2">(the Prophet)</span> said: \'The one questioned knows no more than the questioner.<span class="c6">\' So he said:</span> \'Well, tell me about its signs.<span class="c6">\' He said:</span> \'When the slave-girl will give birth to her mistress, and to see the barefooted, the naked, and the destitute shepherds <span class="c2">(competing with one another in)</span> making lofty buildings.\' Thereupon the man went off. He <span class="c2">(the Prophet)</span> waited a while and then he said: \'O ‘Umar,<span class="c6"> do you know who that questioner was?\' I replied:</span> \'Allah and His Messenger know best.<span class="c6">\' He said:</span> \'That was Jibrīl <span class="c2">(Gabriel)</span>. He came to teach you your religion.\'" <span class="c5">[Narrated by Muslim]</span><br /> Benefits of the Hadīth<br /> 1. Mentioning the five pillars of Islam,<span class="c6"> which are:</span><br /> - Testifying that there is no god but Allah and that Muhammad is the Messenger of Allah<br /> - Establishing the prayer<br /> - Giving Zakah<br /> - Fasting Ramadān<br /> - Performing Hajj to the Sacred House of Allah<br /> 2. Mentioning the pillars of Imān,<span class="c6"> which are:</span><br /> - Believing in Allah<br /> - Believing in His angels<br /> - Believing in His Books<br /> - Believing in His messengers<br /> - Believing in the Last Day<br /> - Believing in destiny with its good and evil aspects<br /> 3. Mentioning the pillar of Ihsān, which is only one pillar, and that is to worship Allah as if you see Him, for if you cannot see Him, He indeed sees you.<br /> 4. None knows the timing of the Hour except Allah Almighty.<br /> Fourth Hadīth </p>',
        ],
        3 => [
          'question' => 'Q4: Complete the following Hadīth: "The believers who have the most perfect faith..." and mention some of its benefits.',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/9360.mp3',
          'answer' => '<p> Answer: Abu Hurayrah <span class="c2">(may Allah be pleased with him)</span> reported that the Prophet <span class="c2">(may Allah\'s peace and blessings be upon him)</span> said: "The believers who have the most perfect faith are those who have the best morals." [Narrated by At-Tirmidhi, who judged it as Hasan Sahīh <span class="c2">(sound authentic)</span>]<br /> Benefits of the Hadīth<br /> 1. Encouraging good morals<br /> 2. The perfection of morals is part of the perfection of faith<br /> 3. Imān <span class="c2">(faith)</span> increases and decreases<br /> Fifth Hadīth </p>',
        ],
        4 => [
          'question' => 'Q5: Complete the following Hadīth: "Whoever swears by other than Allah..." and mention some of its benefits.',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/9440.mp3',
          'answer' => '<p> Answer: Ibn ‘Umar <span class="c2">(may Allah be pleased with him and his father)</span> reported that the Prophet <span class="c2">(may Allah\'s peace and blessings be upon him)</span> said: "Whoever swears by other than Allah, has indeed committed an act of disbelief or polytheism." <span class="c5">[Narrated by At-Tirmidhi]</span><br /> Benefits of the Hadīth<br /> - Swearing by other than Allah Almighty is impermissible<br /> - Swearing by other than Allah Almighty is an act of minor Shirk <span class="c2">(polytheism)</span><br /> Sixth Hadīth </p>',
        ],
        5 => [
          'question' => 'Q6: Complete the following Hadīth: "None of you truly believes until I am dearer to him..." and mention some of its benefits.',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/9510.mp3',
          'answer' => '<p> Answer: Anas <span class="c2">(may Allah be pleased with him)</span> reported that the Messenger of Allah <span class="c2">(may Allah\'s peace and blessings be upon him)</span> said: "None of you truly believes until I am dearer to him than his father, his children, and all people." <span class="c5">[Narrated by Al-Bukhāri and Muslim]</span><br /> Benefits of the Hadīth<br /> - We should love the Prophet <span class="c2">(may Allah\'s peace and blessings be upon him)</span> more than all people.<br /> - This is part of perfect Imān <span class="c2">(faith)</span>.<br /> Seventh Hadīth </p>',
        ],
        6 => [
          'question' => 'Q7: Complete the following Hadīth: "None of you truly believes until he loves for his brother..." and mention some of its benefits.',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/9580.mp3',
          'answer' => '<p> Answer: Anas <span class="c2">(may Allah be pleased with him)</span> reported that the Prophet <span class="c2">(may Allah\'s peace and blessings be upon him)</span> said: "None of you truly believes until he loves for his brother what he loves for himself." <span class="c5">[Narrated by Al-Bukhāri and Muslim]</span><br /> Benefits of the Hadīth<br /> 1. A believer should love for the believers what he loves for himself of goodness.<br /> 2. This is part of perfect faith.<br /> Eighth Hadīth </p>',
        ],
        7 => [
          'question' => 'Q8: Complete the following Hadīth: "By the One in whose Hand my soul is..." and mention some of its benefits.',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/9650.mp3',
          'answer' => '<p> Answer: Abu Sa‘īd <span class="c2">(may Allah be pleased with him)</span> reported that the Prophet <span class="c2">(may Allah\'s peace and blessings be upon him)</span> said: "By the One in whose Hand my soul is, it is equivalent to one third of the Qur’an." <span class="c5">[Narrated by Al-Bukhāri]</span><br /> Benefits of the Hadīth<br /> 1. Merit of Surat al-Ikhlās<br /> 2. It is equivalent to one third of the Qur’an<br /> Ninth Hadīth </p>',
        ],
        8 => [
          'question' => 'Q9: Complete the following Hadīth: "There is no might and no strength except in Allah..." and mention some of its benefits.',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/9720.mp3',
          'answer' => '<p> Answer: Abu Mūsa <span class="c2">(may Allah be pleased with him)</span> reported that the Prophet <span class="c2">(may Allah\'s peace and blessings be upon him)</span> said: "La hawla wala quwwata illa billāh <span class="c2">(there is no might and no strength except in Allah)</span> is one of the treasures of Paradise." <span class="c5">[Narrated by Al-Bukhāri and Muslim]</span><br /> Benefits of the Hadīth<br /> 1. The merit of these words, which is one of the treasures of Paradise<br /> 2. Renunciation of one’s power and strength and reliance on Allah Almighty alone<br /> Tenth Hadīth </p>',
        ],
        9 => [
          'question' => 'Q10: Complete the following Hadīth: "Verily, there is a piece of flesh in the body...", and mention some of its benefits.',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/9790.mp3',
          'answer' => '<p> Answer: An-Nu‘mān ibn Bashīr <span class="c2">(may Allah be pleased with him and his father)</span> reported that he heard the Prophet <span class="c2">(may Allah\'s peace and blessings be upon him)</span> say: "Verily, there is a piece of flesh in the body; if it is upright then the entire body will be upright, and if it is corrupt then the entire body will be corrupt. Verily, it is the heart." <span class="c5">[Narrated by Al-Bukhāri and Muslim]</span><br /> Benefits of the Hadīth<br /> 1. Uprightness of the heart ensures one\'s apparent and hidden uprightness.<br /> 2. Paying attention to the uprightness of the heart because a human\'s uprightness is dependent upon it.<br /> Eleventh Hadīth </p>',
        ],
        10 => [
          'question' => 'Q11: Complete the following Hadīth: "One whose last words are: La ilāha illallāh...", and mention some of its benefits.',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/9860.mp3',
          'answer' => '<p> Answer: Mu‘ādh ibn Jabal <span class="c2">(may Allah be pleased with him)</span> reported that the Prophet <span class="c2">(may Allah\'s peace and blessings be upon him)</span> said: "One whose last words are: \'La ilāha illallāh <span class="c2">(there is no god but Allah)</span>\' will enter Paradise." <span class="c5">[Narrated by Abu Dāwūd]</span><br /> Benefits of the Hadīth<br /> 1. The merit of "La ilāha illallāh" <span class="c2">(there is no god but Allah)</span> and how it is a cause for admitting one into Paradise<br /> 2.<span class="c6"> The privilege of the one whose last words are:</span> "La ilāha illallāh" <span class="c2">(there is no god but Allah)</span><br /> Twelfth Hadīth </p>',
        ],
        11 => [
          'question' => 'Q12: Complete the following Hadīth: "A believer is neither a slanderer nor an invoker of curse...", and mention some of its benefits.',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/9940.mp3',
          'answer' => '<p> Answer: ‘Abdullah ibn Mas‘ūd <span class="c2">(may Allah be pleased with him)</span> reported that the Prophet <span class="c2">(may Allah\'s peace and blessings be upon him)</span> said: "A believer is neither a slanderer or an invoker of curse, nor is he indecent or foulmouthed." <span class="c5">[Narrated by At-Tirmidhi]</span><br /> Benefits of the Hadīth<br /> 1. Prohibition of all false and foul speech<br /> 2. Description of the believer\'s speech<br /> Thirteenth Hadīth </p>',
        ],
        12 => [
          'question' => 'Q13: Complete the following Hadīth: "It is from the best Muslim character...", and mention some of its benefits.',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/10020.mp3',
          'answer' => '<p> Answer: Abu Hurayrah <span class="c2">(may Allah be pleased with him)</span> reported that the Prophet <span class="c2">(may Allah\'s peace and blessings be upon him)</span> said: "It is from the best Muslim character to leave that which is not of one\'s concern." <span class="c5">[Narrated by At-Tirmidhi and others]</span><br /> Benefits of the Hadīth<br /> 1. One should not interfere with others\' religious or worldly affairs.<br /> 2. Not interfering with others\' affairs is part of one\'s perfect Islam.<br /> Fourteenth Hadīth </p>',
        ],
        13 => [
          'question' => 'Q14: Complete the following Hadīth: "Whoever recites a letter from the Book of Allah...", and mention some of its benefits.',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/10100.mp3',
          'answer' => '<p> Answer: ‘Abdullah ibn Mas‘ūd reported that the Prophet <span class="c2">(may Allah\'s peace and blessings be upon him)</span> said: "Whoever recites a letter from the Book of Allah will be credited with a good deed, and the good deed receives a ten-fold reward. I am not saying that Alif-Lām-Mīm is one letter, but Alif is a letter, Lām is a letter and Mīm is a letter." <span class="c5">[Narrated by At-Tirmidhi]</span><br /> Benefits of the Hadīth<br /> 1. Merit of reciting the Qur’an<br /> 2. One is given rewards for every single letter he recites </p>',
        ],
      ],
      6 => [
        0 => [
          'question' => 'Q1: How should one show courtesy to Allah Almighty?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/10190.mp3',
          'answer' => '<p> Answer: One should show courtesy to Allah Almighty by: <br /> 1. Magnifying Him<br /> 2. Worshiping Him alone without associating partners with Him<br /> 3. Obeying Him<br /> 4. Refraining from disobeying Him<br /> 5. Showing gratitude to Him and praising Him for His countless favors and blessings<br /> 6. Showing patience with what He decrees </p>',
        ],
        1 => [
          'question' => 'Q2: How should one show courtesy to the Messenger of Allah (may Allah\'s peace and blessings be upon him)?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/10270.mp3',
          'answer' => '<p> Answer: One should show courtesy to him by:<br /> 1. Following him and taking him as a role model<br /> 2. Obeying him<br /> 3. Refraining from disobeying him<br /> 4. Believing him in what he reported<br /> 5. Not introducing new things by adding to his Sunnah<br /> 6. Loving him more than oneself and all people<br /> 7. Revering and supporting him and his Sunnah </p>',
        ],
        2 => [
          'question' => 'Q3: How should one show courtesy to one\'s parents?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/10360.mp3',
          'answer' => '<p> Answer: One should show courtesy to one\'s parents by:<br /> 1. Obeying them in whatever does not involve a sin<br /> 2. Serving them<br /> 3. Helping them<br /> 4. Fulfilling their needs<br /> 5. Supplicating for them<br /> 6. Speaking politely with them, as it is impermissible to say even "Uff", which is the slightest word expressing annoyance.<br /> 7. Smiling at them and refraining from frowning at them<br /> 8. Not raising one\'s voice when talking to them, listening to them without any interruption, and not calling them by their names; rather, one should say "dad" and "mom"<br /> 9. Seeking permission before entering when they are in their room<br /> 10. Kissing their heads and hands </p>',
        ],
        3 => [
          'question' => 'Q4: How should one maintain kinship ties?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/10490.mp3',
          'answer' => '<p> Answer: One should maintain kinship ties by:<br /> 1. Visiting relatives like brothers, sisters, paternal uncles and aunts, maternal uncles and aunts, etc.<br /> 2. Showing kindness to them in words and deeds and offering them help<br /> 3. Calling them and checking on them </p>',
        ],
        4 => [
          'question' => 'Q5: How should one act with one\'s brothers and friends?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/10550.mp3',
          'answer' => '<p> Answer: 1. Loving good people and taking them as friends<br /> 2. Avoiding the company of evil people<br /> 3. Greeting and shaking hands with one\'s brothers<br /> 4. Visiting them when they are sick and supplicating to Allah to cure them<br /> 5.<span class="c6"> Saying:</span> "Yarhamukallāh" <span class="c2">(May Allah have mercy upon you)</span> to the one who sneezes<br /> 6. Accepting their invitation to visit them<br /> 7. Offering advice to them<br /> 8. Supporting them when wronged and preventing them from committing oppression<br /> 9. Loving for them what one loves for oneself<br /> 10. Offering them help when needed<br /> 11. Refraining from harming them with words or deeds<br /> 12. Keeping their secrets<br /> 13. Refraining from insulting, backbiting, despising, envying, spying on, or cheating them </p>',
        ],
        5 => [
          'question' => 'Q6: What are the etiquettes of neighbors?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/10710.mp3',
          'answer' => '<p> Answer: 1. Showing kindness to one\'s neighbor in words and deeds and offering help when needed<br /> 2. Congratulating them on happy occasions like Eid, marriage, etc.<br /> 3. Visiting them when they are sick and consoling them when being afflicted<br /> 4. Offering them as much as possible of the food that one cooks<br /> 5. Refraining from harming them with words or deeds<br /> 6. Not disturbing them with loud voices, not spying on them, but being patient with them </p>',
        ],
        6 => [
          'question' => 'Q7: What are the etiquettes that the host and the guest must follow?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/10800.mp3',
          'answer' => '<p> Answer: 1. Accepting the host\'s invitation<br /> 2. Seeking permission and arranging an appointment when visiting someone<br /> 3. Seeking permission before entering<br /> 4. Not staying for too long during a visit<br /> 5. Lowering the gaze from the host\'s family<br /> 6. Welcoming the guest and receiving him with cheerfulness and friendly words<br /> 7. Seating the guest in the best place<br /> 8. Honoring the guest by offering him food and drink </p>',
        ],
        7 => [
          'question' => 'Q8: What are the etiquettes of sickness and visiting the sick?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/10900.mp3',
          'answer' => '<p> Answer: 1.<span class="c6"> Putting the right hand on the place where the pain is felt and saying:</span> "Bismillāh" <span class="c2">(in the name of Allah)</span> three times,<span class="c6"> followed by saying:</span> "A‘ūdhu bi‘izatillāhi wa qudratihi min sharri ma ajidu wa uhādhir" <span class="c2">(I seek refuge in the might and power of Allah against what I find and fear)</span> - seven times.<br /> 2. Being content and patient with what Allah has decreed<br /> 3. Hastening to visit the patient, supplicating for him, and not staying for too long with him<br /> 4. Making Ruqyah <span class="c2">(healing method by the Qur’an and Sunnah)</span> for the sick without him asking for it.<br /> 5. Advising him to be patient and to adhere to supplication, prayer, and ritual purity as much as he can.<br /> 6.<span class="c6"> Supplicating for the patient by saying:</span> "As’alullāh al-‘azhīm rabb al-‘arsh al-‘azhīm ay yashfeek" <span class="c2">(I ask Allah the Magnificent, the Lord of the magnificent Throne to cure you)</span> - seven times. </p>',
        ],
        8 => [
          'question' => 'Q9: Mention the etiquettes of seeking knowledge.',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/10990.mp3',
          'answer' => '<p> Answer: 1. Dedicating the intention to Allah Almighty with full sincerity<br /> 2. Acting upon the knowledge that one has learnt<br /> 3. Respecting and revering the teacher in his presence and absence<br /> 4. Sitting politely in his presence<br /> 5. Listening to him attentively without interrupting him<br /> 6. Posing questions politely<br /> 7. Refraining from calling him by his name </p>',
        ],
        9 => [
          'question' => 'Q10: What are the assembly etiquettes?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/11090.mp3',
          'answer' => '<p> Answer: 1. Greeting people in the assembly<br /> 2. Sitting in the first empty place available without asking for anyone\'s seat or sitting between two people, except with their permission<br /> 3. Making room for others to sit<br /> 4. Not interrupting others\' speech<br /> 5. Seeking permission and greeting people before leaving<br /> 6. Saying the assembly expiation supplication when the assembly is over.<span class="c6"> It reads:</span> "Subhānak allāhumma wa bihamdik, ash-hadu allā ilāha illā ant, astaghfiruka wa atūbu ilayk" <span class="c2">(Glory be to You, O Allah, and praise. There is no god but You. I seek Your forgiveness and I repent to You)</span>. </p>',
        ],
        10 => [
          'question' => 'Q11: Mention the sleeping etiquettes.',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/11180.mp3',
          'answer' => '<p> Answer: 1. Sleeping early<br /> 2. Sleeping in a state of ritual purity<br /> 3. Not sleeping on the belly<br /> 4. Sleeping on the right side while putting the right hand under the right cheek<br /> 5. Dusting off the bed<br /> 6. Reciting the bedtime supplications,<span class="c6"> which are:</span> Āyat al-Kursi, Surat al-Ikhlās, Surat al-Falaq, and Surat an-Nās, three times,<span class="c6"> saying:</span> "Bismik allāhumma amūtu wa ahyā" <span class="c2">(in Your name, O Allah, I die and I live)</span><br /> 7. Waking up to pray Fajr<br /> 8.<span class="c6"> Saying upon waking up the following:</span> "Alhamdulillāhi alladhī ahyānā ba‘damā amātanā wa ilayhi an-nushūr" <span class="c2">(Praise be to Allah Who gave us life after having taken it from us and to Him is the resurrection)</span> </p>',
        ],
        11 => [
          'question' => 'Q12: What are the eating etiquettes?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/11290.mp3',
          'answer' => '<p> Answer:<br /> 1. Intending by eating and drinking to be strong enough to obey Allah Almighty<br /> 2. Washing hands before eating<br /> 3.<span class="c6"> Saying:</span> "Bismillāh" <span class="c2">(in the name of Allah)</span>, eating with the right hand and from what is near to one, not from the middle of the plate or from what is in front of others<br /> 4. In case of forgetting to say "Bismillāh" before eating,<span class="c6"> one should say:</span> "Bismillāh awwaluhu wa ākhiruh" <span class="c2">(in the name of Allah, in the beginning and in the end)</span><br /> 5. Being content with the food that is available and not criticizing it, i.e., one should eat it if he likes it, or leave it if he does not like it<br /> 6. Eating few mouthfuls and refraining from overeating<br /> 7. Not blowing in the food or drink and waiting until it cools down<br /> 8. Eating together with one\'s family or guests<br /> 9. Not starting to eat before the elders<br /> 10. Mentioning Allah\'s name before drinking, and drinking while sitting down and drinking in three sips<br /> 11. Praising Allah after eating </p>',
        ],
        12 => [
          'question' => 'Q13: What are the etiquettes of dressing?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/11440.mp3',
          'answer' => '<p> Answer: 1. Starting to put on the garment with the right hand and praising Allah<br /> 2. Refraining from lengthening the garment beneath the heels<br /> 3. Boys should not wear girls\' clothes and vice versa<br /> 4. Not imitating the disbelievers and the evildoers in the way they dress<br /> 5. Mentioning Allah\'s name when getting undressed<br /> 6. Starting with the right when wearing shoes and with the left when taking them off </p>',
        ],
        13 => [
          'question' => 'Q14: Mention the riding etiquettes.',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/11540.mp3',
          'answer' => '<p> Answer: 1.<span class="c6"> Saying:</span> "Bismillāh, alhamdulillāh" <span class="c2">(in the name of Allah, praise be to Allah)</span> <span class="c4">{Glory be to Him Who has subjected this for us, for we could not have done it by ourselves. It is to our Lord that we will surely return.}</span> <span class="c5">[Surat az-<span class="c6">Zukhruf:</span> 13, 14]</span><br /> 2. In case of passing by a Muslim, greet him with peace </p>',
        ],
        14 => [
          'question' => 'Q15: Mention the etiquettes of the road.',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/11590.mp3',
          'answer' => '<p> Answer: 1. Walking in a moderate and humble manner and on the right side of the road<br /> 2. Greeting those whom one meets on his way with the greeting of peace<br /> 3. Lowering the gaze and not harming anyone<br /> 4. Enjoining what is good and forbidding what is evil<br /> 5. Removing whatever is harmful from the way </p>',
        ],
        15 => [
          'question' => 'Q16: Mention the etiquettes of entering and leaving the house.',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/11670.mp3',
          'answer' => '<p> Answer: 1.<span class="c6"> Coming out of the house with the left foot while saying:</span> "Bismillāh, tawakkaltu ‘alallāh, la hawla wala quwwata illa billāh, allāhumma innī a‘ūdhu bika an adilla aw udall, aw azilla awa uzall, aw azhlim aw uzhlam, aw ajhal aw yujhal ‘alayy" <span class="c2">(In the name of Allah, I rely on Allah and there is no might or strength save in Allah. O Allah, I seek refuge with You from misleading or being misled, from tripping or being tripped, from oppressing or being oppressed, from acting ignorantly or being treated with ignorance)</span>. 2. Entering the house with the right foot,<span class="c6"> saying:</span> "Bismillāhi walajna, wa bismillāhi kharajna, wa ‘ala rabbinā tawakkalna" <span class="c2">(In the name of Allah we enter, and in the name of Allah we leave, and on our Lord we rely)</span>.<br /> 3. Using the Siwāk <span class="c2">(tooth-cleaning twig)</span> then greeting the people in the house. </p>',
        ],
        16 => [
          'question' => 'Q17: Mention the toilet etiquettes.',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/11730.mp3',
          'answer' => '<p> Answer: 1. Entering with the left foot<br /> 2.<span class="c6"> Saying the following before entering:</span> "Bismillāh, allāhumma innī a‘ūdhu bika min al-khubth wa al-khabā’ith" <span class="c2">(In the name of Allah, O Allah, I seek refuge with You from the male and female devils)</span><br /> 3. Not carrying that which has Allah\'s name on it<br /> 4. Screening from others while relieving oneself<br /> 5. Refraining from speaking in the toilet<br /> 6. Refraining from facing the Qiblah or turning one\'s back to it while urinating or defecating<br /> 7. Using the left hand, not the right hand, in removing impurities<br /> 8. Refraining from relieving oneself on people\'s way or in their shade<br /> 9. Washing the hands after relieving oneself<br /> 10.<span class="c6"> Coming out of the toilet with the left foot while saying:</span> "Ghufrānak" <span class="c2">(Your forgiveness, O Lord)</span> </p>',
        ],
        17 => [
          'question' => 'Q18: Mention the etiquettes of the mosque.',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/11860.mp3',
          'answer' => '<p> Answer: 1.<span class="c6"> Entering the mosque with the right foot while saying:</span> "Bismillāh, allāhummaftah lī abwāba rahmatik" <span class="c2">(In the name of Allah, O Allah, open for me the doors of Your mercy)</span><br /> 2. Not sitting down before offering two Rak‘ahs <span class="c2">(unit of prayer)</span><br /> 3. Not passing in front of praying people, not seeking lost objects or selling and buying in mosques<br /> 4.<span class="c6"> Coming out of the mosque with the left foot while saying:</span> "Allāhumma innī as’aluka min fadlik" <span class="c2">(O Allah, I ask You for Your favor)</span> </p>',
        ],
        18 => [
          'question' => 'Q19: Mention the greeting etiquettes.',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/11930.mp3',
          'answer' => '<p> Answer: 1. On meeting a Muslim,<span class="c6"> one should start by greeting him with peace saying:</span> "Assalāmu ‘alaykum wa rahmatullāhi wa barakātuh" <span class="c2">(may the peace, mercy, and blessings of Allah be upon you)</span>. It must be the greeting of peace and signaling with the hand alone is not enough.<br /> 2. Greeting others while having a smile on the face<br /> 3. Shaking hands with the right hand<br /> 4. When greeted by someone, one should return the greeting with a better or similar one.<br /> 5. On meeting a disbeliever, one should not start greeting him. If he is greeted, then he returns it with its like.<br /> 7. The young should greet the old, the riding should greet the walking, the walking should greet the sitting, and the few should greet the bigger group </p>',
        ],
        19 => [
          'question' => 'Q20: Mention the etiquettes of seeking permission.',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/12020.mp3',
          'answer' => '<p> Answer: 1. Seeking permission before entering a place<br /> 2. Seeking permission three times and no more, after which one should leave<br /> 3. Knocking the door gently and standing away from the door, i.e., on its right or left<br /> 4. Not entering the room of one\'s parents or anyone else before seeking permission, especially before dawn, during the siesta at noon, and after the ‘Ishā’ prayer<br /> 5. It is permissible to enter public places, like the hospital or store, without seeking permission </p>',
        ],
        20 => [
          'question' => 'Q21: Mention the etiquettes of animal welfare.',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/12100.mp3',
          'answer' => '<p> Answer: 1. Providing the animal with food and drink<br /> 2. Showing mercy to the animal and not burdening it with what it cannot bear<br /> 3. Refraining from torturing or abusing the animal in any way </p>',
        ],
        21 => [
          'question' => 'Q22: Mention the sports etiquettes.',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/12160.mp3',
          'answer' => '<p> Answer: 1. Intending by practicing sports to be strong enough to obey Allah and please Him<br /> 2. Not playing sports when prayer time is due<br /> 3. Boys should not play sports with girls<br /> 4. Wearing sports clothes that cover the ‘Awrah <span class="c2">(body parts that must be covered)</span><br /> 5. Avoiding forbidden sports like those which involve hitting the face or uncovering the ‘Awrah </p>',
        ],
        22 => [
          'question' => 'Q23: Mention some of the etiquettes of joking.',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/12240.mp3',
          'answer' => '<p> Answer: 1. Being truthful and not lying when joking<br /> 2. Joking should be free of mockery, ridicule, harm, and intimidation<br /> 3. Refraining from frequent joking </p>',
        ],
        23 => [
          'question' => 'Q24: Mention the etiquettes of sneezing.',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/12300.mp3',
          'answer' => '<p> Answer: 1. Putting the hand, garment, or handkerchief on the mouth when sneezing<br /> 2.<span class="c6"> Praising Allah after sneezing by saying:</span> "Alhamdulillāh" <span class="c2">(praise be to Allah)</span><br /> 3.<span class="c6"> The sneezer\'s brother or companion should say to him:</span> "Yarhamukallāh" <span class="c2">(may Allah have mercy on you)</span>,<br /> whereupon,<span class="c6"> the sneezer should reply by saying:</span> "Yahdīkumullāh wa yuslih bālakum" <span class="c2">(may Allah guide you and improve your condition)</span> </p>',
        ],
        24 => [
          'question' => 'Q25: What are the etiquettes of yawning?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/12360.mp3',
          'answer' => '<p> Answer: 1. Trying to suppress the yawning<br /> 2. Not raising the voice while yawning<br /> 3. Putting the hand on the mouth </p>',
        ],
        25 => [
          'question' => 'Q26: Mention the etiquettes of reciting the Qur’an.',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/12420.mp3',
          'answer' => '<p> Answer: 1. Reciting while being in a state of ritual purity after performing ablution<br /> 2. Sitting politely and with dignity<br /> 3. Seeking refuge with Allah from the devil at the beginning of recitation<br /> 4. Pondering the recitation </p>',
        ],
      ],
      7 => [
        0 => [
          'question' => 'Q1: Mention the merit of good morals?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/12500.mp3',
          'answer' => '<p> Answer: The Prophet <span class="c2">(may Allah\'s peace and blessings be upon him)</span> said: "The most perfect believer in his faith is the one who has the most excellent morals." <span class="c5">[Narrated by At-Tirmidhi and Ahmad]</span> </p>',
        ],
        1 => [
          'question' => 'Q2: Why should we adhere to the Islamic morals?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/12530.mp3',
          'answer' => '<p> Answer: We should adhere to the Islamic morals because: 1. It leads to Allah\'s love<br /> 2. It leads to people\'s love<br /> 3. It is the heaviest thing on the Scale<br /> 4. It leads to multiplying the reward<br /> 5. It is a sign of perfect faith </p>',
        ],
        2 => [
          'question' => 'Q3: From where should we derive morals?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/12600.mp3',
          'answer' => '<p> Answer: From the Noble Qur’an,<span class="c6"> as Allah Almighty says:</span> <span class="c4">{Indeed, this Qur’an guides to what is most upright.}</span> <span class="c5">[Surat al-<span class="c6">Isrā’:</span> 9]</span> And from the Prophetic Sunnah as the Prophet <span class="c2">(may Allah\'s peace and blessings be upon him)</span> said: "Verily, I was sent to make perfect righteous morals." <span class="c5">[Narrated by Ahmad]</span> </p>',
        ],
        3 => [
          'question' => 'Q4: What is the quality of Ihsān (benevolence) and its examples?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/12640.mp3',
          'answer' => '<p> Answer: Ihsān means being constantly heedful of Allah and acting kindly and benevolently towards all creatures.<br /> The Prophet <span class="c2">(may Allah\'s peace and blessings be upon him)</span> said: "Verily, Allah has enjoined kindness upon all things." <span class="c5">[Narrated by Muslim]</span><br /> Examples of Ihsān include:<br /> . Benevolence in worshiping Allah Almighty by dedicating the worship with full sincerity to Him<br /> . Benevolence towards parents in words and deeds<br /> . Benevolence towards kindred and relatives<br /> . Benevolence towards neighbors<br /> . Benevolence towards the orphans and the needy<br /> . Benevolence towards the one who offended you<br /> . Benevolence in speech<br /> . Benevolence in arguments<br /> . Benevolence towards animals </p>',
        ],
        4 => [
          'question' => 'Q5: What is the opposite of Ihsān?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/12780.mp3',
          'answer' => '<p> Answer: The opposite of Ihsān is Isā’ah <span class="c2">(offence)</span><br /> Examples of offence include: . Insincerity in worshiping Allah Almighty<br /> . Undutifulness to one\'s parents<br /> . Severing kinship ties<br /> . Bad neighborliness<br /> . Unkindness towards the poor and the needy, in addition to other evil words and deeds </p>',
        ],
        5 => [
          'question' => 'Q6: What are the types and examples of integrity?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/12860.mp3',
          'answer' => '<p> Answer:<br /> 1.<span class="c6"> Integrity in preserving the rights of Allah Almighty<br /> Examples include:</span> Integrity in performing acts of worship like the prayer, Zakah, fasting, Hajj, etc.<br /> 2.<span class="c6"> Integrity in preserving others\' rights<br /> Examples include preserving:</span> . People\'s honor<br /> . Their properties<br /> . Their lives<br /> .<span class="c6"> Their secret affairs and everything that one is entrusted with<br /> Allah Almighty says concerning the qualities of those who are successful:</span> <span class="c4">{And those who are faithful to their trusts and pledges.}</span> <span class="c5">[Surat al-<span class="c6">Mu’minūn:</span> 8]</span> </p>',
        ],
        6 => [
          'question' => 'Q7: What is the opposite of integrity?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/12980.mp3',
          'answer' => '<p> Answer: The opposite of integrity is betrayal, which means wasting the rights of Allah Almighty and those of people.<br /> The Prophet <span class="c2">(may Allah\'s peace and blessings be upon him)</span> said: "There are three signs of a hypocrite" and he mentioned among them: "... and if he is entrusted, he betrays the trust". <span class="c5">[Agreed upon]</span> </p>',
        ],
        7 => [
          'question' => 'Q8: What is the truthfulness?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/13020.mp3',
          'answer' => '<p> Answer: Truthfulness means saying what conforms with the reality or what is true.<span class="c6"><br /> Examples include:</span><br /> . Truthfulness in talking with people<br /> . Truthfulness in making a promise<br /> . Truthfulness in every word and deed<br /> The Prophet <span class="c2">(may Allah\'s peace and blessings be upon him)</span> said: "Adhere to truthfulness, for truthfulness leads to righteousness and righteousness leads to Paradise. A man will keep speaking the truth until he becomes of the most truthful." <span class="c5">[Agreed upon]</span> </p>',
        ],
        8 => [
          'question' => 'Q9: What is the opposite of truthfulness?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/13100.mp3',
          'answer' => '<p> Answer: Lying is the opposite of truthfulness and it means not telling the truth.<span class="c6"> Examples include:</span> lying to people, not keeping promises, and false testimony.<br /> The Prophet <span class="c2">(may Allah\'s peace and blessings be upon him)</span> said: "Lying leads to wickedness and wickedness leads to Hellfire. A man will keep telling lies until he is recorded with Allah as an utter liar." <span class="c5">[Agreed upon]</span> The Prophet <span class="c2">(may Allah\'s peace and blessings be upon him)</span> also said: "There are three signs of a hypocrite",<span class="c6"> and he mentioned among them:</span> "When he speaks he lies, and when he makes a promise he breaks it". <span class="c5">[Agreed upon]</span> </p>',
        ],
        9 => [
          'question' => 'Q10: Mention the types of patience?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/13140.mp3',
          'answer' => '<p> Answer: . Patience in obeying Allah Almighty<br /> . Patience in refraining from sins<br /> . Patience in dealing with the harsh divine decrees,<span class="c6"> and praising Allah in all states<br /> Allah Almighty says:</span> <span class="c4">{And Allah loves those who are patient.}</span> <span class="c5">[Surat Āl ‘Imrān: 146]</span> Moreover, the Prophet <span class="c2">(may Allah\'s peace and blessings be upon him)</span> said: "How wonderful the affair of the believer is! Indeed, all of his affairs are good for him. This is for no one but the believer. If something good happens to him, he is grateful to Allah, which is good for him. And if something bad happens to him, he stays patient, which is good for him." <span class="c5">[Narrated by Muslim]</span> </p>',
        ],
        10 => [
          'question' => 'Q11: What is the opposite of patience?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/13210.mp3',
          'answer' => '<p> Answer: Impatience is the opposite of patience and it means showing impatience in obeying Allah and in refraining from sins. It also means expressing discontent at the divine decree with words or deeds.<span class="c6"><br /> Examples include:</span><br /> . Wishing for death<br /> . Slapping the cheeks<br /> . Tearing the clothes<br /> . Disheveling the hair<br /> . Invoking death upon oneself<br /> The Prophet <span class="c2">(may Allah\'s peace and blessings be upon him)</span> said: "The greater the tribulation is, the greater the reward will be. When Allah loves people, He tests them. So, whoever is content, for him is pleasure; and whoever is discontent, for him is displeasure." <span class="c5">[Narrated by At-Tirmidhi and Ibn Mājah]</span> </p>',
        ],
        11 => [
          'question' => 'Q12: What is the trait of cooperation.',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/13310.mp3',
          'answer' => '<p> Answer: It is cooperation between people in truth and goodness.<span class="c6"><br /> Examples of cooperation include:</span><br /> . Cooperation in restoring rights<br /> . Cooperation in preventing oppression<br /> . Cooperation in fulfilling the needs of the people and the needy<br /> . Cooperation in all goodness<br /> . Non-Cooperation in sin, harm,<span class="c6"> and transgression<br /> Allah Almighty says:</span> <span class="c4">{Cooperate with one another in goodness and righteousness, and do not cooperate in sin and transgression. And fear Allah, for Allah is severe in punishment.}</span> <span class="c5">[Surat al-<span class="c6">Mā’idah:</span> 2]</span> The Prophet <span class="c2">(may Allah\'s peace and blessings be upon him)</span> said: "The relationship of the believer with another believer is like <span class="c2">(the bricks of)</span> a building, each strengthens the other." <span class="c5">[Agreed upon]</span> The Prophet <span class="c2">(may Allah\'s peace and blessings be upon him)</span> also said: "A Muslim is the brother of a Muslim; he does not wrong him and he does not hand him over to an oppressor. Whoever fulfills the needs of his brother, Allah will fulfill his needs; and whoever relieves a Muslim of a burden, Allah will relieve him of a burden from the burdens of the Day of Judgment; and whoever covers <span class="c2">(the faults of)</span> a Muslim, Allah will cover <span class="c2">(his faults)</span> on the Day of Judgment." <span class="c5">[Agreed upon]</span> </p>',
        ],
        12 => [
          'question' => 'Q13: What are the types of Hayā’ (modesty)?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/13420.mp3',
          'answer' => '<p> Answer: 1. Modesty towards Allah by not disobeying Him<br /> 2. Modesty towards people by refraining from foul and indecent speech and from uncovering the ‘Awrah<br /> The Prophet <span class="c2">(may Allah\'s peace and blessings be upon him)</span> said: "Faith has over seventy branches – or over sixty branches – the best of which is saying: There is no god but Allah; and the least of which is the removal of harmful objects from the way; and modesty is a branch of faith." <span class="c5">[Narrated by Muslim]</span> </p>',
        ],
        13 => [
          'question' => 'Q14: Mention examples of the trait of mercy.',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/13470.mp3',
          'answer' => '<p> Answer: . Being merciful to old people and revering them<br /> . Being merciful to young people and children<br /> . Being merciful to the poor, the needy, and the destitute<br /> . Being merciful to animals by feeding them and not harming them<br /> In this regard, the Prophet <span class="c2">(may Allah\'s peace and blessings be upon him)</span> said: "You will find the believers in their mutual compassion, love,<span class="c6"> and sympathy like a single body:</span> if one of its organs suffers, the whole body will react with sleeplessness and fever." <span class="c5">[Agreed upon]</span> The Prophet <span class="c2">(may Allah\'s peace and blessings be upon him)</span> also said: "Those who are merciful will be shown mercy by the Most Merciful. Be merciful to those on earth and the One in the heaven will be merciful to you." <span class="c5">[Narrated by Abu Dāwūd and At-Tirmidhi]</span> </p>',
        ],
        14 => [
          'question' => 'Q15: What are the types of love?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/13550.mp3',
          'answer' => '<p> Answer: .<span class="c6"> Love for Allah Almighty<br /> Allah Almighty says:</span> <span class="c4">{But those who believe are stronger in their love for Allah.}</span> <span class="c5">[Surat al-<span class="c6">Baqarah:</span> 165]</span><br /> . Love for the Messenger of Allah <span class="c2">(may Allah\'s peace and blessings be upon him)</span><br /> The Prophet <span class="c2">(may Allah\'s peace and blessings be upon him)</span> said: "By the One in Whose Hand my soul is, none of you will attain perfect faith until I am dearer to him than his father and his child." <span class="c5">[Narrated by Al-Bukhāri]</span><br /> . Love for the believers and wishing goodness for them just as one wishes for himself<br /> The Prophet <span class="c2">(may Allah\'s peace and blessings be upon him)</span> said: "None of you is a real believer until he loves for his brother what he loves for himself.\'\' <span class="c5">[Narrated by Al-Bukhāri]</span> </p>',
        ],
        15 => [
          'question' => 'Q16: Define cheerfulness.',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/13630.mp3',
          'answer' => '<p> Answer: It is having a cheerful face, along with showing happiness and a smile, being friendly, and expressing delight when meeting people.<br /> It is the opposite of frowning at people, which is a repellent attitude.<br /> Many Hadīths mention the merit of cheerfulness, among them is the Hadīth where Abu Dharr <span class="c2">(may Allah be pleased with him)</span> reported that the Prophet <span class="c2">(may Allah\'s peace and blessings be upon him)</span> said: "Do not belittle any good deed, even if it is meeting your brother with a cheerful face." <span class="c5">[Narrated by Muslim]</span> Moreover, the Prophet <span class="c2">(may Allah\'s peace and blessings be upon him)</span> said: "Smiling at your brother is counted as a charity." <span class="c5">[Narrated by At-Tirmidhi]</span> </p>',
        ],
        16 => [
          'question' => 'Q17: What is envy?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/13690.mp3',
          'answer' => '<p> Answer: It is wishing that the blessing of others would cease to exist or hating to see others enjoy a blessing.<span class="c6"><br /> Allah Almighty says:</span> <span class="c4">{And from the harm of the envier when he envies.}</span><br /> Anas ibn Mālik <span class="c2">(may Allah be pleased with him)</span> reported that the Prophet <span class="c2">(may Allah\'s peace and blessings be upon him)</span> said: "Do not hate one another, do not envy one another, and do not turn your backs on one another, but be, O servants of Allah, as brothers." <span class="c5">[Narrated by Al-Bukhāri and Muslim]</span> </p>',
        ],
        17 => [
          'question' => 'Q18: What is mockery?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/13740.mp3',
          'answer' => '<p> Answer: It is ridiculing and despising one\'s Muslim brother, which is impermissible.<br /> Forbidding mockery,<span class="c6"> Allah Almighty says:</span> <span class="c4">{O you who believe, let not some men ridicule others, for it may be that they are better than them; nor let some women ridicule others, for it may be that they are better than them. Do not speak ill of one another, nor call one another by <span class="c5">[offensive]</span> nicknames. How evil is the name of wickedness after having faith! And whoever does not repent, it is they who are the wrongdoers.}</span> <span class="c5">[Surat al-<span class="c6">Hujurāt:</span> 11]</span> </p>',
        ],
        18 => [
          'question' => 'Q19: Define humility.',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/13780.mp3',
          'answer' => '<p> Answer: It is the quality of not thinking that one is better than other people; thus, one does not despise people or reject the truth.<span class="c6"><br /> Allah Almighty says:</span> <span class="c4">{The slaves of the Most Compassionate are those who walk on earth humbly.}</span> <span class="c5">[Surat al-<span class="c6">Furqān:</span> 63]</span> It means that they are humble. Moreover, the Prophet <span class="c2">(may Allah\'s peace and blessings be upon him)</span> said: "No one humbles himself seeking the pleasure of Allah except that Allah will raise his rank." <span class="c5">[Narrated by Muslim]</span> The Prophet <span class="c2">(may Allah\'s peace and blessings be upon him)</span> also said: "Allah revealed to me that you should all be humble; so that people should not feel proud over one another, and that they should not wrong one another." <span class="c5">[Narrated by Muslim]</span> </p>',
        ],
        19 => [
          'question' => 'Q20: What are the types of the forbidden arrogance?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/13840.mp3',
          'answer' => '<p> Answer: 1. Arrogance in dealing with the truth, i.e., rejecting and not accepting the truth<br /> 2. Arrogance in dealing with people, i.e., despising and disdaining them<br /> The Prophet <span class="c2">(may Allah\'s peace and blessings be upon him)</span> said: "Whoever has an atom\'s weight of arrogance in his heart will not enter Paradise.<span class="c6">" A man said:</span> "What if one likes his clothes and shoes to be good?" He said: "Verily, Allah is beautiful and He loves beauty. Arrogance is rejecting the truth and looking down on people." <span class="c5">[Narrated by Muslim]</span><br /> -<span class="c6"> "Rejecting the truth":</span> not accepting it.<br /> -<span class="c6"> "Looking down on people":</span> despising them.<br /> - Wearing good-looking clothes and shoes is not arrogance. </p>',
        ],
        20 => [
          'question' => 'Q21: Mention some of the types of the forbidden cheating.',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/13910.mp3',
          'answer' => '<p> Answer: - Cheating in selling and buying, by hiding the defect in the commodity<br /> - Cheating in learning, like the students\' cheating on exams<br /> - Cheating in speaking, like in false testimony and lying<br /> - Breaching one\'s agreements with others<br /> The prohibition of cheating is clear in the Hadīth stating that the Messenger of Allah <span class="c2">(may Allah\'s peace and blessings be upon him)</span> once came upon a heap of food, and when he put his hand into it, his fingers felt some dampness. So,<span class="c6"> he asked:</span> "What is this,<span class="c6"> O owner of the food? The man replied:</span> "Rain had fallen on it, O Messenger of Allah,<span class="c6">" whereupon the Prophet (may Allah\'s peace and blessings be upon him said:</span> "Why did you not put the damp part on top of the food so that people might see it? He who cheats has nothing to do with me." <span class="c5">[Narrated by Muslim]</span><br /> "Heap of food": a pile of food. </p>',
        ],
        21 => [
          'question' => 'Q22: What is backbiting?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/13990.mp3',
          'answer' => '<p> Answer: It is mentioning one\'s Muslim brother with what he dislikes in his absence.<span class="c6"><br /> Allah Almighty says:</span> <span class="c4">{And do not backbite one another. Would any of you like to eat the flesh of his dead brother? You would surely abhor it. So fear Allah. Indeed, Allah is Accepting of Repentance, Most Merciful.}</span> <span class="c5">[Surat al-<span class="c6">Hujurat:</span> 12]</span> </p>',
        ],
        22 => [
          'question' => 'Q23: Define talebearing.',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/14030.mp3',
          'answer' => '<p> Answer: It is spreading words of one another between people with the intent of causing mistrust and dissension among people.<br /> The Prophet <span class="c2">(may Allah\'s peace and blessings be upon him)</span> said: "No talebearer will enter Paradise." <span class="c5">[Narrated by Muslim]</span> </p>',
        ],
        23 => [
          'question' => 'Q24: What is indolence?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/14070.mp3',
          'answer' => '<p> Answer: It is slackening in performing acts of goodness and in carrying out one\'s duties.<br /> It includes slackness in carrying out obligations.<span class="c6"><br /> Allah Almighty says:</span> <span class="c4">{The hypocrites seek to deceive Allah, but it is He Who deceives them. Whenever they stand up for prayer, they stand up reluctantly, only to be seen by people, and they do not remember Allah but a little.}</span> <span class="c5">[Surat an-<span class="c6">Nisā’:</span> 142]</span><br /> The believer should, thus, abandon indolence, sluggishness, and laziness and should work hard and work diligently in this life in a way that is pleasing to Allah Almighty. </p>',
        ],
        24 => [
          'question' => 'Q25: Mention the types of anger.',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/14130.mp3',
          'answer' => '<p> Answer: 1.<span class="c6"> Praiseworthy anger:</span> It is the anger that one feels for the sake of Allah in case the disbelievers, hypocrites, or others violate any of His limits.<br /> 2.<span class="c6"> Dispraised anger:</span> It is the anger that drives one to say and do what he should not.<br /> Treatment of Dispraised Anger<br /> - Performing ablution<br /> - The one who is standing should sit, and the one who is sitting should lie down<br /> - Adhering to the Prophet\'s advice in this regard,<span class="c6"> as he said:</span> "Do not get angry"<br /> - Controlling oneself at times of anger<br /> - Seeking refuge with Allah from the accursed devil<br /> - Keeping silent </p>',
        ],
        25 => [
          'question' => 'Q26: What is spying?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/14240.mp3',
          'answer' => '<p> Answer: It is pursuing and exposing people\'s faults and what they hide.<span class="c6"><br /> Examples of prohibited spying include:</span><br /> - Trying to know people\'s private affairs in their homes<br /> -<span class="c6"> Eavesdropping on people\'s private conversations<br /> Allah Almighty says:</span> <span class="c4">{Do not spy on one another...}</span> <span class="c5">[Surat al-<span class="c6">Hujurāt:</span> 12]</span> </p>',
        ],
        26 => [
          'question' => 'Q27: What is wastefulness? What is stinginess? What is generosity?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/14310.mp3',
          'answer' => '<p> Answer: Wastefulness is spending money inefficiently.<br /> It is opposite to stinginess, which means withholding money and not spending it rightfully.<br /> The correct attitude is a moderate way between wastefulness and stinginess, i.e., to be generous.<span class="c6"><br /> Allah Almighty says:</span> <span class="c4">{And those who neither spend wastefully nor stingily, but are moderate between them.}</span> <span class="c5">[Surat al-<span class="c6">Furqān:</span> 67]</span> </p>',
        ],
        27 => [
          'question' => 'Q28:What is cowardice? What is bravery?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/14370.mp3',
          'answer' => '<p> Answer: Cowardice is fearing something that one should not fear.<br /> Such as fearing to say the truth or to forbid evil.<br /> Bravery is prowess upon the truth, such as undertaking the mission of defending Islam and Muslims in the fields of Jihad.<br /> The Prophet <span class="c2">(may Allah\'s peace and blessings be upon him)</span> used to say the following in his supplication: "Allāhumma innī a‘ūdhu bika min al-jubn" <span class="c2">(O Allah, I seek refuge with You from cowardice)</span>. The Prophet <span class="c2">(may Allah\'s peace and blessings be upon him)</span> also said: "A strong believer is better and dearer to Allah than a weak believer, and there is good in both." <span class="c5">[Narrated by Muslim]</span> </p>',
        ],
        28 => [
          'question' => 'Q29: Mention some of the prohibited words and speeches.',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/14440.mp3',
          'answer' => '<p> Answer: - Curses and insults<br /> - Saying that someone is an animal or the like<br /> - Saying obscene or indecent words<br /> The Prophet <span class="c2">(may Allah\'s peace and blessings be upon him)</span> forbade all such things by saying: "A believer is neither a slanderer or an invoker of curse, nor is he indecent or foulmouthed." <span class="c5">[Narrated by At-Tirmidhi and Ibn Hibbān]</span> </p>',
        ],
        29 => [
          'question' => 'Q30: Mention some of the methods that may help a Muslim adhere to good morals.',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/14500.mp3',
          'answer' => '<p> Answer: 1. Supplicating to Allah to grant you good morals and asking Him to help you adhere to them.<br /> 2. Being constantly heedful of Allah Almighty and knowing that he knows, hears, and sees you.<br /> 3. Remembering the reward of good morals and that they are a cause for entering Paradise.<br /> 4. Remembering the consequences of bad morals and that they are a cause for entering Hellfire.<br /> 5. Good morals lead to winning the love of Allah Almighty and His creation, whereas, bad morals bring about the wrath of Allah and His creation.<br /> 6. Reading the biography of the Prophet <span class="c2">(may Allah\'s peace and blessings be upon him)</span> and taking him as a role model<br /> 7. Taking good people as companions and avoiding the company of evil people </p>',
        ],
      ],
      8 => [
        0 => [
          'question' => 'Q1: What is the merit of Dhikr (remembrance of Allah)?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/14630.mp3',
          'answer' => '<p> Answer: The Prophet <span class="c2">(may Allah\'s peace and blessings be upon him)</span> said: "The example of the one who remembers his Lord and the one who does not remember Him is like the example of a living and a dead person." <span class="c5">[Narrated by Al-Bukhāri]</span><br /> This is because the value and worth of man\'s life depend on how frequently he remembers Allah Almighty. </p>',
        ],
        1 => [
          'question' => 'Q2: Mention some of the benefits of Dhikr.',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/14670.mp3',
          'answer' => '<p> Answer: 1. It pleases the Most Compassionate<br /> 2. It expels the devil<br /> 3. It protects the Muslim against evil<br /> 4. It brings about recompense and reward </p>',
        ],
        2 => [
          'question' => 'Q3: What is the best Dhikr?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/14730.mp3',
          'answer' => '<p> Answer: The best Dhikr is: "La ilāha illallāh" <span class="c2">(there is no god but Allah)</span>. <span class="c5">[Narrated by At-Tirmidhi and Ibn Mājah]</span> </p>',
        ],
        3 => [
          'question' => 'Q4: What should one say upon waking up?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/14760.mp3',
          'answer' => '<p> Answer: "Alhamdulillāhi alladhī ahyāna ba‘damā amātanā wa ilayhi an-nushūr" <span class="c2">(Praise be to Allah Who gave us life after He caused us to die and to Him is the resurrection)</span>. <span class="c5">[Agreed upon]</span> </p>',
        ],
        4 => [
          'question' => 'Q5: What should one say when wearing garment?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/14790.mp3',
          'answer' => '<p> Answer: "Alhamdulillāhi alladhī kasānī hadha ath-thawba wa razaqanīhi min ghayri hawlin minnī wa la quwwah" <span class="c2">(Praise be to Allah Who clothed me in this garment and gave it to me without any power or strength on my side)</span>. <span class="c5">[Narrated by Abu Dāwūd, At-Tirmidhi, and others]</span> </p>',
        ],
        5 => [
          'question' => 'Q6: What should one say when getting undressed?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/14820.mp3',
          'answer' => '<p> Answer: "Bismillāh" <span class="c2">(In the name of Allah)</span>. <span class="c5">[Narrated by At-Tirmidhi]</span> </p>',
        ],
        6 => [
          'question' => 'Q7: What supplication should be said on wearing a new garment?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/14850.mp3',
          'answer' => '<p> Answer: "Allāhumma lakal hamdu anta kasawtanīhi as’aluka khayrahu wa khayra ma suni‘a lahu wa a‘ūdhu bika min sharrihi wa sharri ma suni‘a lah" <span class="c2">(O Allah, praise be to You, You clothed me therewith. I ask You for its good and the good of that for which it was made, and I seek refuge with You from its evil and the evil of that for which it was made)</span>. <span class="c5">[Narrated by Abu Dāwūd and At-Tirmidhi]</span> </p>',
        ],
        7 => [
          'question' => 'Q8: What supplication should be said when seeing someone wearing a new garment?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/14880.mp3',
          'answer' => '<p> Answer: When seeing someone wearing a new garment,<span class="c6"> one should supplicate for him and say:</span> "Tublī wa yukhlifullāhu ta‘āla" <span class="c2">(May you wear it out and may Allah Almighty grant you another instead)</span>. <span class="c5">[Narrated by Abu Dāwūd]</span> </p>',
        ],
        8 => [
          'question' => 'Q9: Mention the supplication to be said when entering the toilet.',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/14910.mp3',
          'answer' => '<p> Answer: "Allāhumma innī a‘ūdhu bika min al-khubuthi wal khabā’ith" <span class="c2">(O Allah, I seek refuge with You from the male and female devils)</span>. <span class="c5">[Agreed upon]</span> </p>',
        ],
        9 => [
          'question' => 'Q10: What supplication should be said when coming out of the toilet?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/14940.mp3',
          'answer' => '<p> Answer: "Ghufrānak" <span class="c2">(I seek Your forgiveness)</span>. <span class="c5">[Narrated by Abu Dāwūd and At-Tirmidhi]</span> </p>',
        ],
        10 => [
          'question' => 'Q11: What should be said before performing ablution?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/14970.mp3',
          'answer' => '<p> Answer: "Bismillāh" <span class="c2">(In the name of Allah)</span>. <span class="c5">[Narrated by Abu Dāwūd and others]</span> </p>',
        ],
        11 => [
          'question' => 'Q12: What Dhikr should be said after performing ablution?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/15000.mp3',
          'answer' => '<p> Answer: "Ash-hadu allā ilāha illallāh wahdahu la sharīka lah wa ash-hadu anna Muahmmadan ‘abduhu wa rasūluh" <span class="c2">(I testify that there is no god but Allah alone with no partner, and I testify that Muhammad is His slave and messenger)</span>. <span class="c5">[Narrated by Muslim]</span> </p>',
        ],
        12 => [
          'question' => 'Q13: What Dhikr should be said on leaving the house?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/15020.mp3',
          'answer' => '<p> Answer: "Bismillāhi tawakkaltu ‘alallāh wala hawala wala quwwata illā billāh" <span class="c2">(In the name of Allah, I rely upon Allah, and there is no might nor strength except with Allah)</span>. <span class="c5">[Narrated by Abu Dāwūd and At-Tirmidhi]</span> </p>',
        ],
        13 => [
          'question' => 'Q14: What Dhikr should be said on entering the house?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/15050.mp3',
          'answer' => '<p> Answer: "Bismillāhi walajnā wa bismillāhi kharajnā wa ‘alallāhi rabbinā tawakkalnā" <span class="c2">(In the name of Allah we enter, and in the name of Allah we leave, and on Allah, our Lord, we rely)</span> then one should greet his family. <span class="c5">[Narrated by Abu Dāwūd]</span> </p>',
        ],
        14 => [
          'question' => 'Q15: What is the supplication of entering the mosque?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/15080.mp3',
          'answer' => '<p> Answer: "Allāhumma iftah lī abwāba rahmatik" <span class="c2">(O Allah, open for me the doors of Your mercy)</span>. <span class="c5">[Narrated by Muslim]</span> </p>',
        ],
        15 => [
          'question' => 'Q16: Mention the supplication of leaving the mosque.',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/15110.mp3',
          'answer' => '<p> Answer: "Allāhumma innī as’aluka min fadlik" <span class="c2">(O Allah, I ask You for Your favor)</span>. <span class="c5">[Narrated by Muslim]</span> </p>',
        ],
        16 => [
          'question' => 'Q17: What should be said on hearing the Adhān (prayer call)?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/15140.mp3',
          'answer' => '<p> Answer: One should repeat what the muezzin says except when saying: "Hayy ‘ala as-salāh" <span class="c2">(come to prayer)</span> and "Hayy ‘ala al-falāh" <span class="c2">(come to success)</span>. Here,<span class="c6"> one should say:</span> "La hawla wala quwwata illā billāh" <span class="c2">(there is no might nor strength except with Allah)</span>. <span class="c5">[Agreed upon]</span> </p>',
        ],
        17 => [
          'question' => 'Q18: What should be said after the Adhān?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/15170.mp3',
          'answer' => '<p> Answer: Invoke blessings upon the Prophet <span class="c2">(may Allah\'s peace and blessings be upon him. <span class="c5">[Narrated by Muslim]</span> Then,<span class="c6"> one should say:</span> "Allāhumma rabba hādhihi ad-da‘watit tāmmah wasalātil qā’imah āti Muhammadan al-wasīlata wal fadīlah wab‘athuhu maqāman mahmūdan illadhī wa‘adtah" (O Allah, Lord of this perfect call and the prayer that is about to be established, grant Muhammad the right of intercession and favor and resurrect him to a praised position that You have promised him)</span>. <span class="c5">[Narrated by Al-Bukhāri]</span><br /> One should also supplicate to Allah between the Adhān and Iqāmah <span class="c2">(the second call to prayer)</span>, as it is a time when the supplication is not rejected. </p>',
        ],
        18 => [
          'question' => 'Q19: What are the morning and evening Adhkār (prescribed set of regular supplications)?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/15220.mp3',
          'answer' => '<p> Answer: 1. Reciting Āyat al-Kursi,<span class="c6"> which reads:</span> <span class="c4">{Allah: none has the right to be worshiped except Him, the Ever-Living, All-Sustaining. Neither drowsiness overtakes Him nor sleep. To Him belongs all that is in the heavens and all that is on earth. Who is there that can intercede with Him except with His permission? He knows what was before them and what will be after them, while they encompass nothing of His knowledge, except what He wills. His Kursī <span class="c5">[footstool]</span> extends over the heavens and earth, and safeguarding of both does not weary Him, for He is the Most High, the Most Great.}</span> <span class="c5">[Surat al-<span class="c6">Baqarah:</span> 255]</span> 2.<span class="c6"> Reciting:</span> In the name of Allah, the Most Compassionate,<span class="c6"> the Most Merciful {Say:</span> <span class="c1">“He is Allah, the One; Allah, the Eternal Refuge. He neither begets nor is He begotten, and there is none comparable to Him.”</span>} <span class="c5">[Surat al-<span class="c6">Ikhlās:</span> 1-4]</span> Three times In the name of Allah, the Most Compassionate, the Most Merciful {Say, <span class="c1">“I seek refuge with the Lord of the daybreak, from the harm of all what He has created; from the harm of night’s darkness when it spreads around, from the harm of the sorceresses who blow on knots, and from the harm of the envier when he envies.} <span class="c5">[Surat al-<span class="c6">Falaq:</span> 1-5]</span> - three times In the name of Allah, the Most Compassionate, the Most Merciful {Say, “I seek refuge with the Lord of mankind, the Sovereign of mankind, the God of mankind, from the harm of the lurking whisperer, who whispers into the hearts of mankind, from among jinn and mankind.”</span>} <span class="c5">[Surat an-<span class="c6">Nās:</span> 1-6]</span> - three times 3. "Allāhumma anta rabbī lā ilāha illa anta khalaqtanī wa ana ‘abduka wa ana ‘ala ‘ahdika wa wa‘dika mastata‘t, a‘ūdhu bika min sharri ma sana‘t, abū’u laka bini‘matika ‘alayy wa abū’u bidhambī faghfir lī fa innahu lā yaghfiru adh-dhunūba illa anta" <span class="c2">(O Allah, You are my Lord. There is no god except You. You have created me, and I am Your slave, and I hold to Your covenant as far as I can. I seek refuge in You from the evil of what I have done. I acknowledge the favors that You have bestowed upon me, and I confess my sins. So, forgive me, for none can forgive sins except You)</span>. <span class="c5">[Narrated by Al-Bukhāri]</span> </p>',
        ],
        19 => [
          'question' => 'Q20: What should be said before sleeping?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/15290.mp3',
          'answer' => '<p> Answer: "Bismika allāhumma amūtu wa ahyā" <span class="c2">(In Your name, O Allah, I die and I live)</span>. <span class="c5">[Agreed upon]</span> </p>',
        ],
        20 => [
          'question' => 'Q21: What should be said before eating?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/15320.mp3',
          'answer' => '<p> Answer: "Bismillāh" <span class="c2">(In the name of Allah)</span>.<br /> If one forgets to say it before eating,<span class="c6"> he should say:</span><br /> "Bismillāhi fī awwalihi wa ākhirih" <span class="c2">(In the name of Allah at its beginning and at its end)</span>. <span class="c5">[Narrated by Abu Dāwūd and At-Tirmidhi]</span> </p>',
        ],
        21 => [
          'question' => 'Q22: What should be said after eating?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/15370.mp3',
          'answer' => '<p> Answer: "Alhamdullillāhi al-ladhī at‘amanī hādha wa razaqanīh min ghayri hawlin minnī wala quwwah" <span class="c2">(Praise be to Allah Who fed me and provided me with this food without any power or strength on my side)</span>. <span class="c5">[Narrated by Abu Dāwūd, Ibn Mājah, and others]</span> </p>',
        ],
        22 => [
          'question' => 'Q23: What should the guest say in supplicating for the host?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/15400.mp3',
          'answer' => '<p> Answer: "Allāhumma bārik lahum fīmā razaqtahum waghfir lahum warhamuhum" <span class="c2">(O Allah, bless them in what You have provided them with, and forgive them and have mercy on them)</span>. <span class="c5">[Narrated by Muslim]</span> </p>',
        ],
        23 => [
          'question' => 'Q24: What should one say when sneezing?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/15430.mp3',
          'answer' => '<p> Answer: "Alhamdulillāh" <span class="c2">(praise be to Allah)</span>.<span class="c6"><br /> His brother or his companion should say to him:</span> "Yarhamukallāh" <span class="c2">(may Allah have mercy on you)</span>.<br /> The sneezer should, then,<span class="c6"> reply saying:</span> "Yahdīkumullāh wa yuslih bālakum" <span class="c2">(may Allah guide you and improve your condition)</span>. <span class="c5">[Narrated by Al-Bukhāri]</span> </p>',
        ],
        24 => [
          'question' => 'Q25: What should one say when leaving an assembly, i.e., the "Expiation of assembly supplication"?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/15480.mp3',
          'answer' => '<p> Answer: "Subhānak allāhumma wa bihamdik, ash-hadu allā ilāha illā ant, astaghfiruka wa atūbu ilayk" <span class="c2">(Glory and praise be to You, O Allah. I testify that there is no god but You. I seek Your forgiveness and I repent to You)</span>. <span class="c5">[Narrated by Abu Dāwūd, At-Tirmidhi, and others]</span> </p>',
        ],
        25 => [
          'question' => 'Q26: What is the riding supplication?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/15510.mp3',
          'answer' => '<p> Answer: "Bismillāh walhamdulillāh" <span class="c2">(In the name of Allah and praise be to Allah)</span>, "Subhāna al-ladhī sakhkhara lanā hādha wa mā kunnā lahu muqrinīn wa innā ilā rabbinā lamunqalibūn" <span class="c2">(Glory be to Him Who has subjected this for us, for we could not have done it by ourselves. It is to our Lord that we will surely return)</span>, "Alhamdulillāh, alhamdulillāh, alhamdulillāh, allāhu akbar, allāhu akbar, allāhu akbar, subhānaka allāhumma innī zhalamtu nafsī faghfir lī fa’innahu lā yaghfiru adh-dhunūba illā ant" <span class="c2">(Praise be to Allah - three times - Allah is the Most Great - three times - Glory be to You, O Allah, I wronged myself, so forgive me, for none can forgive sins but You)</span>. <span class="c5">[Narrated by Abu Dāwūd and At-Tirmidhi]</span> </p>',
        ],
        26 => [
          'question' => 'Q27: Mention the traveling supplication.',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/15540.mp3',
          'answer' => '<p> Answer: "Allāhu akbar, allāhu akbar, allāhu akbar" <span class="c2">(Allah is the Most Great - three times)</span>, "Subhāna al-ladhī sakhkhara lanā hādha wa mā kunnā lahu muqrinīn wa innā ilā rabbinā lamunqalibūn" <span class="c2">(Glory be to Him Who has subjected this for us, for we could not have done it by ourselves. It is to our Lord that we will surely return)</span>, "Allāhumma innā nas’aluka fī safarinā hādha al-birra wat-taqwā wa min al-‘amali mā tardā, allāhumma hawwin ‘alaynā safaranā hādha watwi ‘annā bu‘dah, allāhumma anta as-sāhibu fis-safar wa al-khalīfatu fil ahl, allāhumma innī a‘ūdhu bika min wa‘thā’ as-safar wa ka’ābat al-manzhar wa sū’ il-munqalab fil māli wal ahl" <span class="c2">(O Allah, we ask You on this journey of ours for goodness and piety, and for deeds that are pleasing to You. O Allah, make easy this journey for us and make its distance short for us. O Allah, You are the Companion on the journey and the One in Whose care we leave our family behind. O Allah, I seek refuge in You from this journey\'s hardships, and from the terrible sights in store and from a misfortunate return to our property and our family)</span>.<br /> On returning,<span class="c6"> one should say the same and add the following:</span><br /> "Āyibūn tā’ibūn ‘ābidūn lirabbinā hāmidūn" <span class="c2">(We are returning in safety, turning to our Lord in repentance, worshiping Him, and praising Him)</span>. <span class="c5">[Narrated by Muslim]</span> </p>',
        ],
        27 => [
          'question' => 'Q28: What supplication should the traveler make for the resident?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/15590.mp3',
          'answer' => '<p> Answer: "Astawdi‘ukumllāh al-ladhī lā tadī‘u wadā’i‘h" <span class="c2">(I entrust you to Allah Whose trusts are never lost)</span>. <span class="c5">[Narrated by Ahmad and Ibn Mājah]</span> </p>',
        ],
        28 => [
          'question' => 'Q29: What supplication should the resident make for the traveler?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/15620.mp3',
          'answer' => '<p> Answer: "Astawdi‘ullāha dīnak wa amānatak wa khawātīma ‘amalik" <span class="c2">(I entrust to Allah your religion, your trust, and your final deeds)</span>. <span class="c5">[Narrated by Ahmad and At-Tirmidhi]</span> </p>',
        ],
        29 => [
          'question' => 'Q30: What supplication should be made upon entering the market?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/15650.mp3',
          'answer' => '<p> Answer: "Lā ilāha illallāh wahdahu lā sharīka lah, lahul mulk walahul hamd yuhyī wa yumīt biyadihi al-khayr wahuwa ‘ala kulli shay’in qadīr" <span class="c2">(There is no god but Allah alone, with no partner. To Him belong the dominion and all praise. He gives life and causes death and He is Ever-Living and He never dies. In His Hand lies all good, and He is competent over all things)</span>. <span class="c5">[Narrated by At-Tirmidhi and Ibn Mājah]</span> </p>',
        ],
        30 => [
          'question' => 'Q31: Mention the supplication that should be said in times of anger.',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/15680.mp3',
          'answer' => '<p> Answer: "A‘ūdhu billāhi min ash-shaytān ar-rajīm" <span class="c2">(I seek refuge with Allah from the accursed devil)</span>. <span class="c5">[Agreed upon]</span> </p>',
        ],
        31 => [
          'question' => 'Q32: What should one say to someone who did him a favor?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/15710.mp3',
          'answer' => '<p> Answer: "Jazākallāhu khayran" <span class="c2">(may Allah reward you)</span>. <span class="c5">[Narrated by At-Tirmidhi]</span> </p>',
        ],
        32 => [
          'question' => 'Q33: What supplication should be said when one\'s riding animal trips?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/15740.mp3',
          'answer' => '<p> Answer: "Bismillāh" <span class="c2">(In the name of Allah)</span>. <span class="c5">[Narrated by Abu Dāwūd]</span> </p>',
        ],
        33 => [
          'question' => 'Q34: What should one say when something good happens to him?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/15770.mp3',
          'answer' => '<p> Answer: "Alhamdulillāhi al-ladhī bini‘matihi tatimmu as-sālihāt" <span class="c2">(Praise be to Allah with Whose favor good things are completed)</span>. <span class="c5">[Narrated by Al-Hākim and others]</span> </p>',
        ],
        34 => [
          'question' => 'Q35: What should one say when something bad happens to him?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/15800.mp3',
          'answer' => '<p> Answer: "Alhamdulillāh ‘ala kulli hāl" <span class="c2">(Praise be to Allah in all cases)</span>. <span class="c5">[Sahīh al-Jāmi‘]</span> </p>',
        ],
        35 => [
          'question' => 'Q36: What is the way of greeting and returning the greeting?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/15830.mp3',
          'answer' => '<p> Answer: A Muslim should say: "As-salāmu ‘alaykum warahmatullāhi wa barakātuh" <span class="c2">(May the peace, mercy, and blessings of Allah be upon you)</span>.<br /> His brother should return the greeting,<span class="c6"> saying:</span> "Wa ‘alaykum as-salām warahmatullāhi wa barakātuh" <span class="c2">(And may the peace, mercy, and blessings of Allah be upon you too)</span>. <span class="c5">[Narrated by At-Tirmidhi, Abu Dāwūd, and others]</span> </p>',
        ],
        36 => [
          'question' => 'Q37: What supplication should be said when it rains?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/15870.mp3',
          'answer' => '<p> Answer: "Allāhumma sayyiban nāfi‘an" <span class="c2">(O Allah, may it be beneficial rain)</span>. <span class="c5">[Narrated by Al-Bukhāri]</span> </p>',
        ],
        37 => [
          'question' => 'Q38: What supplication should be said after rainfall?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/15900.mp3',
          'answer' => '<p> Answer: "Mutirnā bifadlillāhi wa rahmatih" <span class="c2">(We have been given rain by the grace and mercy of Allah)</span>. <span class="c5">[Narrated by Al-Bukhāri and Muslim]</span> </p>',
        ],
        38 => [
          'question' => 'Q39: Mention the supplication that should be said when the wind blows.',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/15930.mp3',
          'answer' => '<p> Answer: "Allāhumma innī as’aluka khayrahā wa a‘ūdhu bika min sharrihā" <span class="c2">(O Allah, I ask You for its goodness and I seek refuge with You from its evil)</span>. <span class="c5">[Narrated by Abu Dāwūd and Ibn Mājah]</span> </p>',
        ],
        39 => [
          'question' => 'Q40: Mention the supplication that should be said on hearing thunder.',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/15960.mp3',
          'answer' => '<p> Answer: "Subhāna al-ladhī yusabbihu ar-ra‘du bihamdihi wal malā’ikatu min khīfatih" <span class="c2">(Glory be to the One by Whose praise the thunder exalts Him and the angels as well for fear of Him)</span>. <span class="c5">[Muwatta’ Mālik]</span> </p>',
        ],
        40 => [
          'question' => 'Q41: What supplication should be said (to oneself) on seeing an afflicted person?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/15990.mp3',
          'answer' => '<p> Answer: "Alhamdulillāhi al-ladhī ‘āfānī mimma ibtalāka bihi wa faddalanī ‘ala kathīrin mimman khalaqa tafdīla" <span class="c2">(Praise be to Allah Who has spared me what He has afflicted you with, and preferred me greatly above much of what He has created)</span>. <span class="c5">[Narrated by At-Tirmidhi]</span> </p>',
        ],
        41 => [
          'question' => 'Q42: What supplication should be said on fearing to affect something with one\'s evil eye?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/16020.mp3',
          'answer' => '<p> Answer: The Hadīth states: "If one of you sees something from his brother, himself, or his wealth which he finds amazing, then let him invoke blessings for it, for the evil eye is, indeed, true." <span class="c5">[Narrated by Ahmad, Ibn Mājah, and others]</span> </p>',
        ],
        42 => [
          'question' => 'Q43: How should one invoke blessings upon the Prophet (may Allah\'s peace and blessings be upon him)?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/16050.mp3',
          'answer' => '<p> Answer: "Allāhumma salli ‘ala Muhammadin wa ‘ala āli Muhammadin kama sallayta ‘ala Ibrāhīm wa ‘ala āli Ibrāhīm, innaka hamīdun majīd. Allāhumma bārik ‘ala Muhammadin wa ‘ala āli Muhammadin kama bārakta ‘ala Ibrāhīm wa ‘ala āli Ibrāhīm, innaka hamīdun majīd" <span class="c2">(O Allah, exalt the mention of Muhammad and the family of Muhammad as you exalted the mention of Abraham and the family of Abraham, You are Praiseworthy and Most Glorious. O Allah, bless Muhammad and the family of Muhammad as You blessed Abraham and the family of Abraham, You are Praiseworthy and Most Glorious)</span>. <span class="c5">[Agreed upon]</span> </p>',
        ],
      ],
      9 => [
        0 => [
          'question' => 'Q1: What are the five assignment rulings?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/16090.mp3',
          'answer' => '<p> Answer:<br /> 1. Wājib <span class="c2">(obligatory)</span><br /> 2. Mustahabb <span class="c2">(recommended)</span><br /> 3. Muharram <span class="c2">(prohibited)</span><br /> 4. Makrūh <span class="c2">(disliked)</span><br /> 5. Mubāh <span class="c2">(permissible)</span> </p>',
        ],
        1 => [
          'question' => 'Q2: Explain these five rulings.',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/16170.mp3',
          'answer' => '<p> Answer:<br /> 1. Wājib <span class="c2">(Obligatory)</span>: such as the five prayers, fasting in Ramadān, and dutifulness to one\'s parents.<br /> Performing what is obligatory will be rewarded, whereas, abandoning it will be punished.<br /> 2. Mustahabb <span class="c2">(Recommended)</span>: such as the regular Sunnah prayers, the night prayer, feeding people, and the greeting of peace. It is also called "Sunnah" and "Mandūb".<br /> Performing what is recommended will be rewarded, and abandoning it will not be punished.<span class="c6"><br /> Important Note:</span><br /> The Muslim must hasten to perform whatever is Sunnah or recommended and follow the example of the Prophet <span class="c2">(may Allah\'s peace and blessings be upon him)</span>.<br /> 3. Muharram <span class="c2">(Prohibited)</span>: such as the consumption of alcohol, being undutiful to one\'s parents, and severing kinship ties.<br /> Abandoning what is prohibited will be rewarded, whereas, committing it will be punished.<br /> 3. Makrūh <span class="c2">(Disliked)</span>: such as taking and giving with the left hand, and lifting up the lower part of the garment during the prayer.<br /> Abandoning what is disliked will be rewarded, and doing it will not be punished.<br /> 5. Mubāh <span class="c2">(Permissible)</span>: such as eating an apple and drinking tea. It is also called "Jā’iz" and "Halāl".<br /> Abandoning what is permissible will not be rewarded, as doing it will not be punished. </p>',
        ],
        2 => [
          'question' => 'Q3: What is the ruling on sales and transactions?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/16320.mp3',
          'answer' => '<p> Answer: In principle, all types of sales and transactions are permissible, except some types which have been prohibited by Allah Almighty.<span class="c6"><br /> Allah Almighty says:</span> <span class="c4">{But Allah has permitted trade and forbidden usury.}</span> <span class="c5">[Surat al-<span class="c6">Baqarah:</span> 275]</span> </p>',
        ],
        3 => [
          'question' => 'Q4: Mention some of the prohibited types of sales and transactions.',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/16360.mp3',
          'answer' => '<p> Answer:<br /> 1.<span class="c6"> Cheating:</span> such as hiding the defect in a commodity.<br /> Abu Hurayrah <span class="c2">(may Allah be pleased with him)</span> reported that the Prophet <span class="c2">(may Allah\'s peace and blessings be upon him)</span> once came upon a heap of food, and when he put his hand into it, his fingers felt some dampness. So,<span class="c6"> he asked the owner of the food:</span> "What is this,<span class="c6"> O owner of the food?" The man replied:</span> "The rain had fallen on it, O Messenger of Allah." Thereupon, the Prophet <span class="c2">(may Allah\'s peace and blessings be upon him)</span> said: "Why did you not put the damp part on the top of the food so that people can see it? He who cheats has nothing to do with me." <span class="c5">[Narrated by Muslim]</span><br /> 2. Riba <span class="c2">(usury)</span>: such as borrowing one thousand from someone to be returned as two thousands.<br /> This excess is the prohibited usury.<span class="c6"><br /> Allah Almighty says:</span> <span class="c4">{But Allah has permitted trade and forbidden usury.}</span> <span class="c5">[Surat al-<span class="c6">Baqarah:</span> 275]</span><br /> 3. Gharar <span class="c2">(uncertainty, risk)</span> and Jahālah <span class="c2">(ignorance)</span>: such as selling milk that is still in the female sheep udder, or fish that is not yet caught.<span class="c6"><br /> The Hadīth states:</span> "The Messenger of Allah <span class="c2">(may Allah\'s peace and blessings be upon him)</span> forbade any sale that involves Gharar <span class="c2">(uncertainty, risk)</span>." <span class="c5">[Narrated by Muslim]</span> </p>',
        ],
        4 => [
          'question' => 'Q5: Mention some of the blessings that Allah has bestowed on you.',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/16460.mp3',
          'answer' => '<p> Answer: 1. The blessing of being a Muslim and not being from the disbelievers<br /> 2. The blessing of adhering to the Sunnah and not being from the heretic innovators<br /> 3. The blessing of health and wellbeing, including the blessing of hearing, seeing, walking, etc.<br /> 4. The blessing of having food, drink, and clothes.<br /> In fact, the blessings that Allah Almighty has bestowed upon us are numerous and cannot be counted or enumerated.<span class="c6"><br /> Allah Almighty says:</span> <span class="c4">{If you try to count Allah’s favors, you will not be able to enumerate them. Indeed, Allah is All-Forgiving, Most Merciful.}</span> <span class="c5">[Surat an-<span class="c6">Nahl:</span> 18]</span> </p>',
        ],
        5 => [
          'question' => 'Q6: What is our duty towards our blessings? How should we show gratitude?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/16540.mp3',
          'answer' => '<p> Answer: It is our duty to express gratitude for having such blessings by praising Allah with the tongue and attributing all favors to Him alone, and by using such blessings in a way that pleases Allah Almighty and not in disobeying Him. </p>',
        ],
        6 => [
          'question' => 'Q7: What are the Muslims\' festivals?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/16570.mp3',
          'answer' => '<p> Answer: Eid al-Fitr and Eid al-Ad\'ha.<span class="c6"><br /> This is mentioned in the Hadīth of Anas who said:</span> "When the Messenger of Allah <span class="c2">(may Allah\'s peace and blessings be upon him)</span> came to Madīnah, the people had two days on which they used to play games.<span class="c6"> He asked:</span> \'What are these two days?\' They said: \'We used to play on them in the pre-Islamic period.\' Thereupon, the Messenger of Allah <span class="c2">(may Allah\'s peace and blessings be upon him)</span> said: \'Allah has given you something better than these two: the day of sacrifice <span class="c2">(Eid al-Ad\'ha)</span> and the day of the breaking the fast <span class="c2">(Eid al-Fitr)</span>.\'" <span class="c5">[Narrated by Abu Dāwūd]</span><br /> All festivals, other than these two Eids, are counted as religious innovations. </p>',
        ],
        7 => [
          'question' => 'Q8: What is the best month?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/16620.mp3',
          'answer' => '<p> Answer: The month of Ramadān. </p>',
        ],
        8 => [
          'question' => 'Q9: What is the best day?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/16650.mp3',
          'answer' => '<p> Answer: Friday. </p>',
        ],
        9 => [
          'question' => 'Q10: What is the best day of the year?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/16680.mp3',
          'answer' => '<p> Answer: The Day of ‘Arafah <span class="c2">(9th of Dhul-Hijjah)</span>. </p>',
        ],
        10 => [
          'question' => 'Q11: What is the best night of the year?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/16710.mp3',
          'answer' => '<p> Answer: Laylat al-Qadr <span class="c2">(the Night of Decree)</span>. </p>',
        ],
        11 => [
          'question' => 'Q12: What should one do on seeing a non-Mahram woman?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/16740.mp3',
          'answer' => '<p> Answer: One should lower his gaze,<span class="c6"> as Allah Almighty says:</span> <span class="c4">{Tell the believing men to lower their gazes.}</span> <span class="c5">[Surat an-<span class="c6">Nūr:</span> 30]</span> </p>',
        ],
        12 => [
          'question' => 'Q13: Who are man\'s enemies?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/16770.mp3',
          'answer' => '<p> Answer: 1.<span class="c6"> The human soul that prompts one to evil:</span> This is when one follows what his soul dictates to him and follows his personal desires in disobeying Allah Almighty,<span class="c6"> Who says:</span> <span class="c4">{Indeed, the human soul prompts one to evil, except those to whom my Lord may show mercy. Indeed, my Lord is All-Forgiving, Most Merciful.}</span> <span class="c5">[Surat Yūsuf: 53]</span> 2.<span class="c6"> The devil:</span> He is the human\'s foe whose main goal is to mislead man, whisper evil to him, and lead him to Hellfire.<span class="c6"> Allah Almighty says:</span> <span class="c4">{Do not follow the footsteps of Satan, for he is your sworn enemy.}</span> <span class="c5">[Surat al-<span class="c6">Baqarah:</span> 168]</span> 3.<span class="c6"> Evil companions:</span> They are those who urge one towards evil and prevent him from goodness.<span class="c6"> Allah Almighty says:</span> <span class="c4">{On that Day, close friends will become enemies to one another, except the righteous.}</span> <span class="c5">[Surat az-<span class="c6">Zukhruf:</span> 67]</span> </p>',
        ],
        13 => [
          'question' => 'Q14: What is repentance?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/16820.mp3',
          'answer' => '<p> Answer: Repentance means abandoning sins and starting to obey Allah Almighty.<span class="c6"> Allah Almighty says:</span> <span class="c4">{I am indeed Most Forgiving to those who repent and believe, and do righteous deeds, then stay on the right path.}</span> <span class="c5">[Surat Taha: 82]</span> </p>',
        ],
        14 => [
          'question' => 'Q15: What are the conditions of sound repentance?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/16850.mp3',
          'answer' => '<p> Answer: 1. Abandoning sin<br /> 2. Remorse for committing sin<br /> 3. Resolve not to return to sin<br /> 4.<span class="c6"> Restoring the rights to its owners<br /> Allah Almighty says:</span> <span class="c4">{And those who, when they commit a shameful act or wrong themselves, remember Allah and seek forgiveness for their sins – who can forgive sins except Allah? – and they do not persist in what they did knowingly.}</span> <span class="c5">[Surat Āl ‘Imrān: 135]</span> </p>',
        ],
        15 => [
          'question' => 'Q16: What is the meaning of invoking blessings upon the Prophet (may Allah\'s peace and blessings be upon him)?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/16920.mp3',
          'answer' => '<p> Answer: It means supplicating to Allah and asking Him to exalt the mention of His Prophet <span class="c2">(may Allah\'s peace and blessings be upon him)</span> in the highest assembly. </p>',
        ],
        16 => [
          'question' => 'Q17: What is the meaning of "Subhānallāh"?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/16950.mp3',
          'answer' => '<p> Answer: Tasbīh <span class="c2">(saying: Subhānallāh)</span> means exalting Allah Almighty above any deficiency, defect, or evil. </p>',
        ],
        17 => [
          'question' => 'Q18: What is the meaning of "Alhamdulillāh"?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/16980.mp3',
          'answer' => '<p> Answer: It means praising Allah Almighty and describing Him with all the attributes of perfection. </p>',
        ],
        18 => [
          'question' => 'Q19: What is the meaning of "Allāhu Akbar"?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/17000.mp3',
          'answer' => '<p> Answer: It means that Allah Almighty is the Most Great, the Most Magnificent, and the Most Mighty among all other things. </p>',
        ],
        19 => [
          'question' => 'Q20: What is the meaning of "La hawla wala quwwata illa billāh"?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/17030.mp3',
          'answer' => '<p> Answer: It means that a person cannot change from one state to another except by the strength and power of Allah. </p>',
        ],
        20 => [
          'question' => 'Q21: What is the meaning of "Astaghfirullāh"?',
          'audio' => 'https://kids.islamenc.com/assets/audios/ar/17060.mp3',
          'answer' => '<p> Answer: It means asking Allah Almighty to erase one\'s sins and cover one\'s flaws. </p>',
        ],
      ],
    ],
];