<?php
$data = [
    'title' => 'Lo que los niños musulmanes deben saber',
    'description' => 'Un proyecto sencillo y completo sobre cuestiones que los niños musulmanes deben saber. Incluye temas de creencia, jurisprudencia, biografía del profeta, etiqueta, Tafsir (exégesis), Hadices, moral y recordatorios, es adecuado especialmente para los niños, para los recién conversos y generalmente para todas las edades.',
    'source' => 'https://kids.islamenc.com/es/home',
    'author' => 'Yazan Abdul Razzaq Raziq Alghanim',
    'sections' => [
        0 => 'La Creencia Islámica',
        1 => 'Jurisprudencia Islámica',
        2 => 'Biografía del profeta Muhámmad ﷺ',
        3 => 'Exégesis (interpretación) de algunas suras del Corán',
        4 => 'Sección de hadices',
        5 => 'Modales Islámicos',
        6 => 'Etiquetas y moral Islámica',
        7 => 'Súplicas y Dhikr (recuerdo de Al-láh)',
        8 => 'Preguntas varias',
    ],
    'data' => [
        1 => [
            0 => [
                'question' => 'P 1: ¿Quién es tu Señor?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/200.mp3',
                'answer' => '<p> R - Mi Señor es Al-láh ﷻ, Quien me educó y me otorgó el sustento a mí y a todos los mundos por Su gracia.<br /> Y la prueba es que Al-<span class="c6">láh ﷻ dijo:</span> ﴾Alabado sea Al-láh, el Señor de los mundos﴿ <span class="c2">(Traducción del Corán,<span class="c6"> 1:</span>2)</span>. </p>',
            ],
            1 => [
                'question' => 'P 2: ¿Cuál es tu religión?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/240.mp3',
                'answer' => '<p> R- Mi religión es el Islam, que es la sumisión a Al-láh ﷻ con el monoteísmo. Es someterse a Él con obediencia, eximiéndome del politeísmo y su gente.<span class="c6"><br /> El Altísimo dijo:</span> ﴾Para Al-láh la verdadera religión es el Islam <span class="c2">(…)</span> ﴿ <span class="c2">(Traducción del Corán,<span class="c6"> 3:</span>19)</span>. </p>',
            ],
            2 => [
                'question' => 'P 3: ¿Quién es tu Profeta?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/280.mp3',
                'answer' => '<p> R- Mi profeta es Muhámmad ﷺ.<br /> Al-<span class="c6">láh ﷻ dijo:</span> ﴾Muhámmad es el Mensajero de Al-láh <span class="c2">(…)</span> ﴿ <span class="c2">(Traducción del Corán,<span class="c6"> 48:</span>29)</span>. </p>',
            ],
            3 => [
                'question' => 'P 4: Menciona la declaración del monoteísmo y su significado.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/310.mp3',
                'answer' => '<p> R- La declaración del monoteísmo es <span class="c1">“no hay más divinidad salvo Al-láh”</span>,<span class="c6"> y su significado es:</span> no hay nadie que merezca ser verdaderamente adorado excepto Al-láh.<br /> Al-<span class="c6">láh ﷻ dijo:</span> ﴾Debes saber que no hay nada ni nadie con derecho a ser adorado, salvo Al-láh <span class="c2">(…)</span> ﴿ <span class="c2">(Traducción del Corán,<span class="c6"> 47:</span>19)</span>. </p>',
            ],
            4 => [
                'question' => 'P 5: ¿En dónde está Al-láh, el Poderoso y Sublime?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/350.mp3',
                'answer' => '<p> R- Al-láh ﷻ está en los cielos, por encima de Su trono, y por encima de todas las criaturas.<span class="c6"> El Todopoderoso dijo:</span> ﴾El Compasivo, que se estableció sobre el Trono﴿ <span class="c2">(Traducción del Corán,<span class="c6"> 20:</span>5)</span>.<span class="c6"> Y dijo:</span> ﴾Él tiene total dominio sobre Sus siervos, y Él es el Sabio, el Conocedor﴿ <span class="c2">(Traducción del Corán,<span class="c6"> 6:</span>18)</span>. </p>',
            ],
            5 => [
                'question' => 'P 6: ¿Cuál es el significado en el testimonio de fe de que Muhammad es el Mensajero de Al-láh?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/380.mp3',
                'answer' => '<p> R-<span class="c6"> Significado:</span> Al-láh ﷻ envió al profeta Muhammad ﷺ como dador de buenas nuevas y advertidor para los mundos.<span class="c6"><br /> Debemos:</span><br /> 1- Obedecerle en lo que ordena.<br /> 2- Creer en lo que dijo.<br /> 3- No desobedecerle.<br /> 4- Adorar a Al-láh ﷻ sólo con lo que Él ha legislado y con la Sunnah, dejando de lado la innovación.<span class="c6"><br /> El Todopoderoso dijo:</span> ﴾Quien obedezca al Mensajero obedece a Al-láh <span class="c2">(…)</span> ﴿ <span class="c2">(Traducción del Corán,<span class="c6"> 4:</span>80)</span>.<span class="c6"> Y también dijo:</span> ﴾Ni habla de acuerdo con sus pasiones. Él solo trasmite lo que le ha sido revelado﴿ <span class="c2">(Traducción del Corán,<span class="c6"> 53:</span>3-4)</span>. Al-<span class="c6">láh ﷻ dijo:</span> ﴾En el Mensajero de Al-láh hay un bello ejemplo para quienes tienen esperanza en Al-láh, <span class="c5">[anhelan ser recompensados]</span> en el Día del Juicio y recuerdan frecuentemente a Al-láh﴿ <span class="c2">(Traducción del Corán,<span class="c6"> 33:</span>21)</span>. </p>',
            ],
            6 => [
                'question' => 'P 7: ¿Por qué Al-láh Todopoderoso nos creó?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/480.mp3',
                'answer' => '<p> R- Fuimos creados para adorarlo solo a Él, Dios Único, sin compañero.<br /> No por diversión ni juego.<br /> Al-<span class="c6">láh ﷻ dijo:</span> ﴾No he creado a los genios a los seres humanos sino para que Me adoren﴿ <span class="c2">(Traducción del Corán,<span class="c6"> 51:</span>56)</span>. </p>',
            ],
            7 => [
                'question' => 'P 8: ¿Qué es la adoración?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/530.mp3',
                'answer' => '<p> R- Es un sustantivo que engloba todo lo que Al-láh ﷻ ama y Le agrada en las palabras y las acciones externas e internas.<span class="c6"><br /> • Acciones externas:</span> como invocar a Al-láh ﷻ con el lenguaje de la glorificación (decir <span class="c1">“Glorificado sea Al-láh”</span>), el tajmid (la alabanza, decir <span class="c1">“Alabado sea Al-láh”</span>), el takbir (decir <span class="c1">“Al-láh es el Más grande”</span>), la oración y la peregrinación.<span class="c6"><br /> • Acciones internas:</span> como la confianza, el temor y la esperanza en Al-láh. </p>',
            ],
            8 => [
                'question' => 'P 9: ¿Cuál es nuestro mayor deber?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/580.mp3',
                'answer' => '<p> R- Nuestro mayor deber es la adoración a Al-láh ﷻ con el monoteísmo, sin asociarlo. </p>',
            ],
            9 => [
                'question' => 'P 10: ¿Cuáles son los tipos de monoteísmo?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/610.mp3',
                'answer' => '<p> R- <br /> 1- Monoteísmo del Señorío <span class="c2">(Tawhid Al-Rububiah)</span>: es la creencia de que Al-láh ﷻ es el Creador, el Proveedor, el Dueño, el Maestro, el Único, sin asociados.<br /> 2- Monoteísmo de la divinidad <span class="c2">(Tawhid al-Uluhiyyah)</span>: es la singularidad de Al-láh ﷻ en la adoración, por lo que nadie es adorado salvo Al-láh Todopoderoso.<br /> 3- La unificación de los nombres y atributos <span class="c2">(Tawhid Al-Asmaa wa al-sifat)</span>: es la creencia en los nombres y atributos de Al-láh ﷻ mencionados en el Corán y la Sunnah, sin representación, analogía o disrupción.<br /> Al-<span class="c6">láh ﷻ evidenció tres tipos de monoteísmo cuando dijo:</span> ﴾Es el Señor de los cielos, de la Tierra y de cuanto hay entre ambos. Adóralo y persevera en Su adoración. ¿Conoces a alguien similar a Él?” ﴿ <span class="c2">(Traducción del Corán,<span class="c6"> 19:</span>65)</span>. </p>',
            ],
            10 => [
                'question' => 'P 11: ¿Cuál es el pecado mayor?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/670.mp3',
                'answer' => '<p> R- El pecado mayor es asociar a Al-láh ﷻ con otros.<br /> Al-<span class="c6">láh ﷻ dijo:</span> ﴾Al-láh no perdona la idolatría, pero fuera de ello perdona a quien Le place. Quien asocie algo a Al-láh comete un pecado gravísimo﴿ <span class="c2">(Traducción del Corán,<span class="c6"> 4:</span>48)</span>. </p>',
            ],
            11 => [
                'question' => 'P 12: ¿Qué es el politeísmo y cuáles son sus tipos?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/710.mp3',
                'answer' => '<p> R- El politeísmo es intercambiar o asociar cualquier tipo de adoración a Al-láh ﷻ con otros.<span class="c6"><br /> Tipos de politeísmo:</span><br /> Politeísmo mayor: tal como suplicar a otro que no sea Al-láh ﷻ, alabar o postrarse ante otro que no sea Al-láh ﷻ, o sacrificar algo por otro que no sea Al-láh, el Poderoso y Sublime.<span class="c6"><br /> Politeísmo menor:</span> tal como jurar por otro que no sea Al-láh, utilizar amuletos (lo que se cuelga de las cosas para supuestamente <span class="c1">“beneficiar o evitar el mal”</span>); o hacer algo por la gente, como mejorar su oración cuando la gente lo ve para que piensen que él es muy religioso. </p>',
            ],
            12 => [
                'question' => 'P 13: ¿Alguien a excepción de Al-láh ﷻ conoce lo invisible?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/770.mp3',
                'answer' => '<p> R- No, sólo Al-láh ﷻ conoce lo invisible, lo oculto.<br /> Al-<span class="c6">láh ﷻ dijo:</span> ﴾Di: <span class="c1">“Nadie en los cielos ni en la Tierra conoce lo oculto salvo Al-láh. No saben siquiera cuándo serán resucitados”</span>﴿ <span class="c2">(Traducción del Corán,<span class="c6"> 27:</span>65)</span>. </p>',
            ],
            13 => [
                'question' => 'P 14: ¿Cuántos son los Pilares de Fe?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/810.mp3',
                'answer' => '<p> R-<span class="c6"> Los Pilares de la Fe son seis:</span><br /> 1- La Creencia en Al-láhﷻ.<br /> 2- La creencia en Sus ángeles.<br /> 3- La creencia en Sus Libros revelados.<br /> 4- La creencia en los Profetas y Mensajeros de Al-láh.<br /> 5- La creencia en el Último Día.<br /> 6- La creencia en el destino, ya sea agradable o desagradable.<br /> La prueba de estas creencias la encontramos en el famoso hadiz relatado por Muslim,<span class="c6"> en el que Gabriel le preguntó al profeta Muhámmad ﷺ sobre el Islam y él le respondió:</span> <span class="c1">“<span class="c2">(…)</span> El Islam es que atestigües que no hay divinidad salvo Al-láh y que Muhámmad es el Mensajero de Al-láh; que hagas la oración; que des la caridad obligatoria; que ayunes en el mes de Ramadán; y que hagas la peregrinación a la Casa de Al-láh, si puedes y tienes medios para ello <span class="c2">(…)</span>”</span>. </p>',
            ],
            14 => [
                'question' => 'P 15: ¿Podrías explicar los pilares de la fe?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/900.mp3',
                'answer' => '<p> R-<br /> 1- La creencia en Al-<span class="c6">lah ﷻ:</span><br /> § Creer en que Al-láh ﷻ te creó y te proporcionó el sustento. Él es el Único dueño y autor intelectual de las criaturas.<br /> § Él es el Único que merece ser adorado, no hay otra divinidad salvo Él.<br /> § Él es el Grandísimo, el Perfecto, para Quien es toda alabanza, y a Él pertenecen los más hermosos nombres y atributos. Él no tiene igual, ni algo que se asemeje.<br /> 2-<span class="c6"> La creencia en Sus ángeles:</span><br /> Creer en que los ángeles son criaturas creadas por Al-láh ﷻ a partir de la luz, creados para adorarle y estar completamente sujetos a Su mandato.<br /> - Entre ellos está Gabriel -la paz sea con él- que desciende con la revelación sobre los Profetas.<br /> 3-<span class="c6"> La creencia en Sus libros revelados:</span><br /> Son los libros que Al-láh ﷻ envió a Sus mensajeros.<br /> -<span class="c6"> El Corán:</span> revelado a Muhámmad ﷺ.<br /> -<span class="c6"> El Evangelio:</span> revelado a Jesús, la paz sea con él.<br /> -<span class="c6"> La Torá:</span> revelada a Moisés, la paz sea con él.<br /> -<span class="c6"> Los Salmos:</span> revelados a David, la paz sea con él.<br /> -<span class="c6">Los Pergaminos:</span> revelados a Abraham y Moisés, la paz sea con ellos.<br /> 4- La creencia en los Profetas y Mensajeros de Al-<span class="c6">láh:</span><br /> Creer en que Al-láh ﷻ eligió los Profetas y Mensajeros y los envió a Sus siervos para enseñarles y darles buenas nuevas del bien y del Paraíso, y adviérteles del mal y del Fuego.<span class="c6"><br /> Los mejores de entre ellos son:</span><br /> Noé, la paz sea con él.<br /> Abraham, la paz sea con él.<br /> Moisés, la paz sea con él.<br /> Jesús, la paz sea con él.<br /> Muhámmad ﷺ.<br /> 5-<span class="c6"> La creencia en el Último Día:</span><br /> Este Día se dará después de la muerte y la tumba, es el Día del Juicio Final, el Día de la Resurrección y el Ajuste de cuentas, donde la gente del Paraíso se asentará en sus hogares y la gente del fuego del Infierno en sus hogares.<br /> 6- La creencia en el destino, bien sea agradable o desagradable.<span class="c6"><br /> El destino:</span> es la creencia de que Al-láh ﷻ sabe todo lo que hay en el universo, que lo escribió eso en la Tabla Preservada y que Él quería que existiera.<span class="c6"><br /> El Todopoderoso dijo:</span> ﴾He creado todas las cosas en su justa medida﴿ <span class="c2">(Traducción del Corán,<span class="c6"> 54:</span>49)</span>.<span class="c6"><br /> La creencia en el destino se articula de cuatro asuntos:</span><br /> Primero: el conocimiento de Al-<span class="c6">láh ﷻ:</span> incluido Su conocimiento previo de todo, antes y después de que sucedan las cosa.<br /> Su prueba está en lo que Al-<span class="c6">láh ﷻ dijo:</span> ﴾Solo Al-láh sabe cuándo llegará la Hora <span class="c5">[el Día del Juicio]</span>, cuándo hará descender lluvia y qué encierra el útero; nadie sabe qué le deparará el día siguiente ni en qué tierra ha de morir. Al-láh lo sabe todo y está bien informado de lo que ustedes hacen﴿ <span class="c2">(Traducción del Corán,<span class="c6"> 31:</span>34)</span>.<span class="c6"><br /> Segundo:</span> Al-láh ﷻ escribió el destino en la Tabla Preservada, así que todo lo que ha pasado y pasará está escrito con Él en un libro.<br /> La fuente de esto está en lo que Al-<span class="c6">láh ﷻ dijo:</span> ﴾Él posee las llaves de lo oculto y nadie más que Él las conoce. Él sabe lo que hay en la costa y en el mar. No hay hoja de árbol que caiga sin que Él lo sepa, ni grano en el seno de la tierra, o algo que esté verde o seco, sin que se encuentre registrado en un libro evidente﴿ <span class="c2">(Traducción del Corán,<span class="c6"> 6:</span>59)</span><br /> Tercero: todo sucede por voluntad de Al-láh ﷻ, y nada sucede por parte de Él ni de Su creación, sino es por Su voluntad.<br /> La prueba de esto está en lo que Al-<span class="c6">láh ﷻ dijo:</span> ﴾Para que se encamine quien quiera. Pero sepan que solo se encaminará quien quiera Al-láh, Señor del universo﴿ <span class="c2">(Traducción del Corán,<span class="c6"> 81:</span>28-29)</span>.<span class="c6"><br /> Cuarto:</span> todos los seres son creados por Al-láh ﷻ, y Él creó todos sus tipos, atributos, movimientos y todo lo que hay en ellos.<br /> Al-<span class="c6">lah ﷻ evidenció esto cuando dijo:</span> ﴾Al-láh es Quien los creó a ustedes y lo que ustedes hacen﴿ <span class="c2">(Traducción del Corán,<span class="c6"> 37:</span>96)</span>. </p>',
            ],
            15 => [
                'question' => 'P 16: ¿Cuál es la definición del Corán?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1300.mp3',
                'answer' => '<p> R- El Corán es la palabra de Al-láh Todopoderoso, no fue creada.<br /> Al-<span class="c6">láh ﷻ dijo:</span> ﴾Si alguno de los idólatras te pidiera protección, dale asilo para que así recapacite y escuche la Palabra de Al-láh <span class="c2">(…)</span> ﴿ <span class="c2">(Traducción del Corán,<span class="c6"> 9:</span>6)</span>. </p>',
            ],
            16 => [
                'question' => 'P 17: ¿Qué es la Sunnah?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1330.mp3',
                'answer' => '<p> R- La Sunnah es toda palabra, acción, determinación o rasgo de carácter y moralidad del profeta Muhámmad ﷺ. </p>',
            ],
            17 => [
                'question' => 'P 18: ¿Qué es la innovación en la religión? ¿La aceptamos?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1350.mp3',
                'answer' => '<p> R- Es todo lo que la gente innovó en la religión, es decir, que no fue hecho por el profeta Muhámmad ﷺ ni sus compañeros.<br /> *La innovación no es aceptada y debe rechazarse.<span class="c6"><br /> El profeta Muhámmad ﷺ dijo:</span> <span class="c1">“Toda innovación es desvío”</span>. <span class="c2">(Relatado por Abu Dawud)</span>.<span class="c6"><br /> Por ejemplo:</span> un aumento en los actos de adoración; tal como agregar algo a en la ablución, una cuarta ablución; o celebrar el cumpleaños del Profeta ﷺ. Ninguna de estas acciones fue realizada por el profeta Muhámmad ﷺ o por sus compañeros. </p>',
            ],
            18 => [
                'question' => 'P 19: ¿Qué es el credo de lealtad y rechazo (Al Walaa wa Al Baraa)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1410.mp3',
                'answer' => '<p> R- <br /> *Lealtad <span class="c2">(Al Walaa)</span>: es el amor y apoyo entre los creyentes.<br /> Al-<span class="c6">láh ﷻ dijo:</span> ﴾Los creyentes y las creyentes son aliados unos de otros, ordenan el bien y prohíben el mal, cumplen con la oración prescrita, pagan el zakat y obedecen a Al-láh y a Su Mensajero. De ellos Al-láh tendrá misericordia. Al-láh es Poderoso, Sabio﴿ <span class="c2">(Traducción del Corán,<span class="c6"> 9:</span>71)</span>.<br /> *Rechazo <span class="c2">(Al Baraa)</span>: es la animadversión hacia los incrédulos y de los que son hostiles con los creyentes.<br /> Al-<span class="c6">láh ﷻ dijo:</span> Tienen un buen ejemplo en Abraham y sus seguidores,<span class="c6"> cuando dijeron a su pueblo:</span> “Nosotros somos inocentes de ustedes y de cuanto adoran en lugar de Al-láh. Negamos que sea verdad lo que ustedes creen, y la animadversión y el desacuerdo <span class="c5">[en temas de creencia]</span> se darán hasta que no acepten que solamente Al-láh merece ser adorado <span class="c2">(…)</span> ﴿ <span class="c2">(Traducción del Corán,<span class="c6"> 60:</span>4)</span>. </p>',
            ],
            19 => [
                'question' => 'P 20: ¿Acepta Al-láh ﷻ una religión distinta al Islam?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1480.mp3',
                'answer' => '<p> R- Al-láh ﷻ no acepta nada más que el Islam.<br /> Al-<span class="c6">láh ﷻ dijo:</span> ﴾Quien profese una religión diferente al Islam no le será aceptada, y en la otra vida se contará entre los perdedores﴿ <span class="c2">(Traducción del Corán,<span class="c6"> 3:</span>85)</span>. </p>',
            ],
            20 => [
                'question' => 'P 21: La incredulidad se manifiesta en palabras, hechos y creencias ¿Podría dar algunos ejemplos?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1520.mp3',
                'answer' => '<p> R- Un ejemplo de incredulidad manifiesta en palabras sería insultar a Al-láh ﷻ o a Su mensajero ﷺ.<br /> Un ejemplo de incredulidad manifiesta en hechos sería maltratar el Corán o postrarse ante alguien que no sea Al-láh.<br /> Un ejemplo de incredulidad manifiesta en la creencia es profesar que alguien es digno de adoración aparte de Al-láh ﷻ, que existe un Creador junto con Al-láh ﷻ o que Al-láh tiene hijos. </p>',
            ],
            21 => [
                'question' => 'P 22: ¿Qué es la hipocresía y cuáles son sus tipos?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1570.mp3',
                'answer' => '<p> R-<br /> 1-<span class="c6"> Hipocresía mayor:</span> es encubrir la incredulidad y manifestar la fe.<br /> Al practicar la hipocresía se es expulsado del Islam, porque es la mayor incredulidad.<br /> Al-<span class="c6">láh ﷻ dijo:</span> ﴾Los hipócritas estarán en el abismo más profundo del Fuego y no encontrarán quién los socorra﴿ <span class="c2">(Traducción del Corán,<span class="c6"> 4:</span>145)</span>.<br /> 2-<span class="c6"> Hipocresía menor:</span><br /> Tales como mentir, romper una promesa o el abuso de confianza.<br /> No proviene del Islam, es un pecado y quien la practica está sujeto al castigo.<br /> El Mensajero de Al-<span class="c6">láh ﷺ dijo:</span> "El hipócrita se distingue por tres cualidades: cuando dice algo, miente; cuando promete, no cumple; y cuando confían en él, traiciona" . <span class="c2">(Relatado por Al-Bujari y Muslim)</span>. </p>',
            ],
            22 => [
                'question' => 'P 23: ¿Quién es el sello de los Profetas y Mensajeros?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1680.mp3',
                'answer' => '<p> R- El sello de los Profetas y Mensajeros es Muhámmad ﷺ.<br /> Al-<span class="c6">láh ﷻ dijo:</span> ﴾Muhámmad no es el padre de ninguno de sus hombres, sino que es el Mensajero de Al-láh y el sello de los Profetas﴿ <span class="c2">(Traducción del Corán,<span class="c6"> 33:</span>40)</span>. El Mensajero de Al-<span class="c6">láh ﷺ dijo:</span> <span class="c1">“Yo soy el sello de los Profetas, no habrá Profeta después de mí”</span>. <span class="c2">(Relatado por Abu Dawud, Al-Tirmidhi y otros)</span>. </p>',
            ],
            23 => [
                'question' => 'P 24: ¿Qué es un milagro?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1730.mp3',
                'answer' => '<p> R-<span class="c6"> Milagro:</span> es todo lo que Al-láh ﷻ dio a Sus profetas de sobrenatural para indicar su sinceridad,<span class="c6"> tales como:</span><br /> -La división de la luna por el profeta Muhammad ﷺ.<br /> -La división del mar por Moisés- la paz sea con él-, y el ahogamiento del Faraón y sus soldados. </p>',
            ],
            24 => [
                'question' => 'P 25: ¿Quiénes son los Compañeros del Profeta? ¿Debo amarlos?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1780.mp3',
                'answer' => '<p> R- Los Compañeros del profeta Muhammad -que Al-láh se complazca con ellos- son todos aquellos que conocieron al Profeta ﷺ personalmente, creyeron en él y murieron en el Islam.<br /> -Los amamos y los tomamos como ejemplo, porque son lo mejor de la gente después de los Profetas.<span class="c6"><br /> Los mejores de entre ellos son los cuatro califas:</span><br /> Abu Bakr, que Al-láh se complazca con él.<br /> Umar, que Al-láh se complazca con él.<br /> Uthman, que Al-láh se complazca con él.<br /> Alí, que Al-láh se complazca con él. </p>',
            ],
            25 => [
                'question' => 'P 26: ¿Quiénes son las madres de los creyentes?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1870.mp3',
                'answer' => '<p> R- Las madres de los creyentes son las esposas del Profeta Muhammad ﷺ.<br /> Al-<span class="c6">láh ﷻ dijo:</span> ﴾El Profeta es más amado para los creyentes que ellos mismos; las esposas del Profeta <span class="c5">[deben ser respetadas como si fueran]</span> sus madres <span class="c2">(…)</span> ﴿ <span class="c2">(Traducción del Corán,<span class="c6"> 33:</span>6)</span>. </p>',
            ],
            26 => [
                'question' => 'P 27: ¿Cuáles son nuestros deberes con la familia del profeta Muhammad ﷺ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1910.mp3',
                'answer' => '<p> R- La familia del Profeta se compone de sus esposas, su descendencia, los hijos de Hashim y los hijos de Al-Muttalib de entre los creyentes. Los musulmanes debemos amar y apoyar a la familia del Profeta y repudiar a quienes les odian. </p>',
            ],
            27 => [
                'question' => 'P 28: ¿Cuál es nuestro deber hacia los gobernantes de los musulmanes?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1940.mp3',
                'answer' => '<p> R- Nuestro deber hacia los gobernantes de los musulmanes es respetarlos, obedecerlos en todo, menos en el pecado, no rebelarnos en su contra, hacer súplicas por ellos y aconsejarlos en privado. </p>',
            ],
            28 => [
                'question' => 'P 29: ¿Cuál es la morada de los creyentes?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1970.mp3',
                'answer' => '<p> R- La morada de los creyentes es el Paraíso.<span class="c6"> El Todopoderoso dijo:</span> ﴾Al-láh introducirá a los creyentes que obran rectamente en jardines por donde corren ríos <span class="c2">(…)</span> ﴿ <span class="c2">(Traducción del Corán,<span class="c6"> 47:</span>12)</span>. </p>',
            ],
            29 => [
                'question' => 'P 30: ¿Cuál será la morada de los incrédulos?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2000.mp3',
                'answer' => '<p> R- La morada de los incrédulos será el Infierno.<span class="c6"> El Todopoderoso dijo:</span> ﴾Teman al fuego, cuyo combustible serán seres humanos y piedras, <span class="c5">[un fuego]</span> que ha sido preparado para los que niegan la verdad﴿ <span class="c2">(Traducción del Corán,<span class="c6"> 2:</span>24)</span>. </p>',
            ],
            30 => [
                'question' => 'P 31: ¿Qué es el miedo? ¿Qué es la esperanza? ¿Cuál son las fuentes de estos?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2020.mp3',
                'answer' => '<p> R-<span class="c6"> Miedo:</span> es el temor a Al-láh ﷻ y a Su castigo.<span class="c6"><br /> Esperanza:</span> es el anhelo de la recompensa, el perdón y la misericordia de Al-láh ﷻ.<br /> La fuente de ambos está en las palabras de Al-<span class="c6">láh ﷻ cuando dijo:</span> ﴾<span class="c5">[Aquellos]</span> a los que ustedes invocan buscan el medio de acercarse más a su Señor, anhelan Su misericordia y temen Su castigo ¡Porque el castigo de tu Señor es temible! ﴿ <span class="c2">(Traducción del Corán,<span class="c6"> 17:</span>57)</span>.<span class="c6"> Y Él ﷻ dijo:</span> ﴾Anúnciales a Mis siervos <span class="c5">[oh, Muhammad]</span> que soy el Absolvedor, el Misericordioso, y que Mi castigo es el verdadero castigo doloroso﴿ <span class="c2">(Traducción del Corán,<span class="c6"> 15:</span>49-50)</span>. </p>',
            ],
            31 => [
                'question' => 'P 32: Mencione algunos de los nombres y atributos de Al-láh ﷻ.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2070.mp3',
                'answer' => '<p> R- Al-láh, el Señor, el Omnioyente, el Omnividente, el Omnisapiente, el Misericordioso, el Sustentador, el Viviente, el Grandísimo, entre otros. Al-láh posee los atributos más bellos y más elevados. </p>',
            ],
            32 => [
                'question' => 'P 33: Explique los nombres mencionados en la pregunta anterior.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2100.mp3',
                'answer' => '<p> R-<br /> *Al-<span class="c6">láh:</span> el Único, el verdaderamente adorado, solo y sin compañero.<span class="c6"><br /> *El Señor:</span> el Creador, el Dueño, el Proveedor y el Único Gobernante.<span class="c6"><br /> *El Omnioyente:</span> Aquel cuyo oído alcanza todas las cosas y oye todas las cosas. Escucha todas las voces aun cuando son diferentes y variadas.<span class="c6"><br /> *El Omnividente:</span> Aquel que todo lo ve, sea pequeño o grande.<span class="c6"><br /> *El Omnisapiente:</span> Aquel cuyo conocimiento abarca todo el pasado, presente y futuro.<span class="c6"><br /> *El Misericordioso:</span> cuya misericordia se extiende a toda criatura viviente, y todas las criaturas están bajo Su misericordia.<span class="c6"><br /> *El Sustentador:</span> Aquel que proporciona el sustento a todas las criaturas, incluidos los humanos, los genios y todos los animales.<span class="c6"><br /> *El Viviente:</span> Aquel que no muere, mientras que toda la creación muere.<span class="c6"><br /> *El Grandísimo:</span> Aquel que tiene toda la perfección y toda la grandeza en Sus nombres Sus atributos y acciones. </p>',
            ],
            33 => [
                'question' => 'P 34: ¿Cuál es nuestro deber hacia los sabios musulmanes?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2210.mp3',
                'answer' => '<p> R- Nuestro deber hacia los sabios musulmanes es amarlos; referirnos a ellos en asuntos legales y calamidades; no les recordamos sino por lo bueno, y aquellos que los mencionan de otra manera no están en el camino correcto.<br /> Al-<span class="c6">láh ﷻ dijo:</span> ﴾ <span class="c2">(…)</span> Sepan que Al-láh elevará en grados a los creyentes y a quienes agracie con el conocimiento. Al-láh sabe cuánto hacen﴿ <span class="c2">(Traducción del Corán,<span class="c6"> 58:</span>11)</span>. </p>',
            ],
            34 => [
                'question' => 'P 35: ¿Quiénes son los amigos de Al-láh ﷻ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2240.mp3',
                'answer' => '<p> R- Los amigos de Al-láh ﷻ son los creyentes piadosos.<br /> Al-<span class="c6">láh ﷻ dijo:</span> ﴾Los amigos cercanos de Al-láh no han de temer ni estarán tristes, porque creyeron y fueron piadosos﴿ <span class="c2">(Traducción del Corán,<span class="c6"> 10:</span>62-63)</span>. </p>',
            ],
            35 => [
                'question' => 'P 36: ¿Es la fe una declaración y una acción?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2280.mp3',
                'answer' => '<p> R- La fe es una declaración de palabras, acciones y creencia. </p>',
            ],
            36 => [
                'question' => 'P 37: ¿La fe aumenta y disminuye?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2310.mp3',
                'answer' => '<p> R- La fe aumenta con la obediencia y disminuye con la desobediencia.<br /> Al-<span class="c6">láh ﷻ dijo:</span> ﴾Los creyentes son aquellos que cuando les es mencionado el nombre de Al-láh sus corazones se estremecen, y que cuando les son recitados Sus aleyas les aumenta la fe y se encomiendan a su Señor﴿ <span class="c2">(Traducción del Corán,<span class="c6"> 8:</span>2)</span>. </p>',
            ],
            37 => [
                'question' => 'P 38: ¿Qué es Al-Ihsan?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2350.mp3',
                'answer' => '<p> R- Al-Ihsan es adorar a Al-láh ﷻ como si lo vieras y saber que aún cuando no lo ves, Él si te ve. </p>',
            ],
            38 => [
                'question' => 'P 39: ¿Cuándo son aceptables las obras ante Al-láh ﷻ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2370.mp3',
                'answer' => '<p> R- Para que las obras sean aceptables ante Al-<span class="c6">láh ﷻ deben cumplirse dos condiciones:</span><br /> 1- Que sean puramente por Al-láh ﷻ.<br /> 2- Que estén de acuerdo con la Sunnah del Profeta ﷺ. </p>',
            ],
            39 => [
                'question' => 'P 40: ¿Qué es la confianza en Al-láh ﷻ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2420.mp3',
                'answer' => '<p> R- La confianza en Al-láh ﷻ es tener la certeza en que Él trae el beneficio y repele el daño, mientras se toman todas las acciones y precauciones.<br /> Al-<span class="c6">láh ﷻ dijo:</span> ﴾ <span class="c2">(…)</span> Quien deposite su confianza en Al-láh, sepa que Él le será suficiente <span class="c2">(…)</span> ﴿ <span class="c2">(Traducción del Corán,<span class="c6"> 65:</span>3)</span>.<br /> La palabra ﴾ suficiente ﴿ quiere decir que Él le bastará. </p>',
            ],
            40 => [
                'question' => 'P 41: ¿En qué consiste el deber de ordenar el bien y prohibir el mal?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2470.mp3',
                'answer' => '<p> R- Ordenar el bien es el encomendar toda obediencia a Al-láh ﷻ, y prohibir el mal es la prohibición de toda desobediencia a Al-láh ﷻ.<br /> Al-<span class="c6">láh ﷻ dijo:</span> ﴾ <span class="c5">[¡Musulmanes!]</span> Son la mejor nación que haya surgido de la humanidad porque ordenan el bien, prohíben el mal y creen en Al-láh <span class="c2">(…)</span> ﴿ <span class="c2">(Traducción del Corán,<span class="c6"> 3:</span>110)</span>. </p>',
            ],
            41 => [
                'question' => 'P 42: ¿Quiénes son Ahlu al-Sunnah wa Al-Yamaa (la gente de la Sunnah y la unidad)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2510.mp3',
                'answer' => '<p> R- Ahlu al-Sunnah wa Al-Yamaa <span class="c2">(La gente de la Sunnah y la unidad)</span> son aquellos que practican y creen lo mismo que el Profeta ﷺ y sus compañeros, en palabras, hechos y creencias.<br /> Ahlu al-Sunnah <span class="c2">(la gente de la Sunnah)</span>: son todos aquellos musulmanes rectos que siguen la Sunnah del profeta Muhammad ﷺ y abandonan la innovación en la religión.<br /> A-Yamaa <span class="c2">(la gente de la unidad)</span>: son llamados así porque están unidos en la verdad y no divididos en ella. </p>',
            ],
        ],
        2 => [
            0 => [
                'question' => 'P 1: ¿Cuál es la definición de purificación?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2580.mp3',
                'answer' => '<p> R-<span class="c6"> Purificación:</span> es la eliminación de la impureza, limpiar y purificar.<span class="c6"> Desglosemos este concepto:</span><br /> -<span class="c6"> La eliminación de la impureza:</span> corresponde a un musulmán quitar lo que ha caído de impureza a su cuerpo, ropa y lugar donde va a rezar.<br /> -<span class="c6"> Limpiar y purificar:</span> es lo que se hace con el wudú <span class="c2">(la ablución)</span> o el Gusl <span class="c2">(purificación mayor)</span>, con agua pura, o con el Tayammum <span class="c2">(purificación seca)</span> para quien no tiene agua o no puede usarla. </p>',
            ],
            1 => [
                'question' => 'P 2: ¿Cómo purificas lo que ha sido contaminado con impurezas?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2630.mp3',
                'answer' => '<p> R- La mejor manera de purificar lo que ha sido contaminado con impurezas es lavarlo con agua hasta que quede puro.<br /> - En cuanto a lo que lame el perro para nuestro uso <span class="c2">(de recipientes de comida)</span>, se lava siete veces; la primera con tierra y las demás con agua. </p>',
            ],
            2 => [
                'question' => 'P 3: ¿Cuál es la virtud de la ablución (Wudú)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2660.mp3',
                'answer' => '<p> R-<span class="c6"> El Profeta ﷺ dijo:</span> <span class="c1">“Cuando el siervo musulmán o creyente hace la ablución <span class="c2">(wudú)</span>, al lavar su cara, el agua se llevará -o con la última gota se irán- todas las faltas que haya cometido con la vista; y al lavarse las manos, el agua se llevará -o con la última gota se irán- todas las faltas que haya cometido con ellas; y al lavar sus pies, el agua se llevará -o con la última gota se irán- todas las faltas a las que sus pies le han llevado. Y así hasta que quede puro y limpio de toda falta”</span>. <span class="c2">(Relatado por Muslim)</span>. </p>',
            ],
            3 => [
                'question' => 'P 4: ¿Cómo se realiza la ablución (Wudú)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2690.mp3',
                'answer' => '<p> R- La ablución <span class="c2">(Wudú)</span> se realiza de la siguiente forma:<br /> 1) Lavarse las manos, tres veces.<br /> 2) Enjuagar la boca, inhalar y exhalar agua por la nariz, tres veces.<span class="c6"><br /> Enjuague bucal:</span> poner dentro de la boca agua, moverla y luego expulsarla.<span class="c6"><br /> Inhalar:</span> aspirar agua con aire en la nariz. <br /> Es recomendable que el tomar el agua sea con la mano derecha para luego ser inhalada.<span class="c6"><br /> Exhalar:</span> es la expulsión del agua por la nariz tras la inhalación. <br /> Al retirar el agua de la nariz en la exhalación se debe sonar, y esto es recomendable hacerlo con la mano izquierda.<br /> 3) Luego lavar la cara, tres veces.<br /> 4) Luego lavarse manos y brazos hasta los codos, tres veces.<br /> 5) Luego pasar por la cabeza las manos húmedas desde arriba de la frente hasta la nuca y regresar, luego pasar las manos húmedas por las orejas. <span class="c2">(Una sola vez)</span>.<br /> 6) Luego lavarse los pies hasta los tobillos, tres veces.<br /> Ésta es la forma más completa que ha sido comprobada con la autoridad del Profeta ﷺ, en los dichos <span class="c2">(hadices)</span> de Al-Bujari y Muslim, relatados por Uthman, Abdul-lah bin Zaid y otros. También se ha relatado en Al-Bujari y otros, que en ocasiones el Profeta ﷺ realizaba los pasos de la ablución tres veces, una vez cada parte; y a veces lo hacía dos veces cada parte. </p>',
            ],
            4 => [
                'question' => 'P 5: ¿Cuáles y cuántas son las exigencias de la ablución?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2810.mp3',
                'answer' => '<p> R- Las exigencias de la ablución son aquellas que, de no realizarse una de estas, se invalida la ablución del musulmán.<span class="c6"> Éstas son:</span><br /> 1- Lavado de la cara. Esto incluye el enjuague de la boca y lavar la nariz.<br /> 2- Lavarse las manos y brazos hasta los codos.<br /> 3- Pasar las manos húmedas por la cabeza, incluidas las orejas.<br /> 4- Lavar los pies hasta los tobillos.<br /> 5-<span class="c6"> Realizar los pasos en el orden mencionado:</span> lavado de la cara, luego manos, luego pasar las manos húmedas por la cabeza, luego lavar los pies.<br /> 6-<span class="c6"> Al Muwaalah:</span> realizar la ablución consecutivamente, es decir, hacerla en un tiempo continuo, sin intervalos que permitan que se seque el agua de las partes que ya se purificaron.<br /> - Si se hace la ablución a medias y la completa en otro momento, entonces no es válida. </p>',
            ],
            5 => [
                'question' => 'P 6: ¿Cuáles y cuántas son las Sunnahs de la ablución?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2910.mp3',
                'answer' => '<p> R-<span class="c6"> Sunnahs de la ablución:</span> son aquellas que de realizarse se obtienen más bendiciones, y si se abandonan no se incurre en un pecado, es decir, su ablución es correcta.<br /> 1- Decir <span class="c1">“Bismil-láh”</span> <span class="c2">(en el nombre de Al-láh)</span>.<br /> 2- Utilizar el Misuak <span class="c2">(cepillo de dientes)</span>.<br /> 3- Lavarse las manos al principio.<br /> 4- Lavarse entre los dedos.<br /> 5- El segundo y tercer lavado de cada parte.<br /> 6- Empezar por la derecha <span class="c2">(brazos y pies)</span>.<br /> 7- Dhikr <span class="c2">(recuerdo de Al-láh)</span> después de la ablución: <span class="c1">“Doy testimonio de que no hay divinidad, salvo Al-láh, el Único, sin socio, y doy testimonio de que Muhámmad es Su siervo y mensajero”</span>.<br /> 8- Rezar dos raka’ah después de la ablución. </p>',
            ],
            6 => [
                'question' => 'P 7: ¿Qué invalida la ablución?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3020.mp3',
                'answer' => '<p> R-<span class="c6"> <br /> 1) Todo lo que sale por ambos esfínteres:</span> orinar, defecar, flatulencias, etc.<br /> 2) Quedarse dormido, perder la conciencia o desmayarse.<br /> 3) Comer carne de camello.<br /> 4) Tocar las partes íntimas directamente con la mano, sin ninguna barrera. </p>',
            ],
            7 => [
                'question' => 'P 8: ¿Qué es la ablución seca (At-Tayammum)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3080.mp3',
                'answer' => '<p> R- Ablución seca <span class="c2">(At-Tayammum)</span>: es el aprovechamiento de la tierra limpia u otras superficies para realizar la purificación cuando no se consigue agua o no se puede utilizar. </p>',
            ],
            8 => [
                'question' => 'P 9: ¿Cómo se realiza el At-Tayammum?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3110.mp3',
                'answer' => '<p> R- Tocar con las palmas de las manos la tierra limpia <span class="c2">(una sola vez)</span>, luego pasarlas sobre el rostro y luego sobre la superficie de las manos. </p>',
            ],
            9 => [
                'question' => 'P 10: ¿Cuáles son los anuladores de At-Tayammum?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3140.mp3',
                'answer' => '<p> R- Los anuladores de At- Tayammum son todos aquellos que invalidan la ablución menor y mayor.<br /> También se anula si se encuentra agua. </p>',
            ],
            10 => [
                'question' => 'P 11: ¿Qué se considera calzado y calcetines? ¿Pueden limpiarse como parte de la purificación?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3180.mp3',
                'answer' => '<p> R-<span class="c6"> El calzado:</span> todo lo que se usa en los pies hecho de cuero u otros materiales resistentes.<span class="c6"><br /> Calcetines:</span> lo que se usa en los pies debajo del calzado que no está hecho de cuero.<br /> Para ambos se prescribe pasar las manos húmedas sobre ellos en lugar de lavar los pies en la purificación. </p>',
            ],
            11 => [
                'question' => 'P 12: ¿Cuál es la sabiduría detrás de pasar las manos húmedas sobre los calcetines?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3230.mp3',
                'answer' => '<p> R- Su sabiduría está en facilitar la ablución y aliviar a los siervos de Al-láh ﷻ, especialmente en momentos de frío, invierno y viajes, donde es difícil quitarse lo que está en los pies. </p>',
            ],
            12 => [
                'question' => 'P 13: ¿Cuáles son las condiciones válidas para poder pasar las manos húmedas sobre el calzado o sobre los calcetines durante la ablución?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3260.mp3',
                'answer' => '<p> R- <br /> 1) Ponerse el calzado o calcetín en estado de pureza, es decir, después de la ablución.<br /> 2) El calzado debe estar limpio, por lo que no está permitido pasar las manos húmedas por el calzado que tiene impurezas en sus suelas.<br /> 3) Deben cubrir el lugar donde debe lavarse en la ablución <span class="c2">(desde los dedos hasta los tobillos)</span>.<br /> 4) Calzarlos dentro del plazo especificado; para el residente un máximo de 24 horas y para el viajero un máximo de 72 horas. </p>',
            ],
            13 => [
                'question' => 'P 14: ¿Cómo se debe pasar las manos húmedas sobre el calzado o los calcetines durante la ablución?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3320.mp3',
                'answer' => '<p> R- Se debe realizar la ablución completa y cuando corresponda limpiar los pies, se debe pasar las palmas de las manos húmedas sobre los pies, iniciando desde los dedos hacia arriba <span class="c2">(por la parte superior de los pies)</span>; la mano derecha con el pie derecho, la mano izquierda con el pie izquierdo.<br /> En caso de utilizar sandalias, se deben pasar los dedos de los manos húmedos dentro de los dedos de los pies. </p>',
            ],
            14 => [
                'question' => 'P 15: ¿Qué invalida la purificación sobre el calzado o calcetines?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3350.mp3',
                'answer' => '<p> R- <br /> 1) Se invalida el pasar las manos húmedas sobre el calzado y los calcetines si ha expirado el plazo especificado <span class="c2">(para un residente un máximo de 24 horas, y para el viajero un máximo de 72 horas)</span>.<br /> 2) Si se quita uno o ambos calzados o calcetines después de haber realizado la ablución con ellos. </p>',
            ],
            15 => [
                'question' => 'P 16: ¿Qué es la oración?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3390.mp3',
                'answer' => '<p> R-<span class="c6"> La oración:</span> es adorar a Al-láh ﷻ con palabras y acciones específicas. Comienza con Al-Takbir <span class="c2">(decir: "Al-láhu Ákbar")</span> y finaliza con el saludo del lado derecho y lado izquierdo. </p>',
            ],
            16 => [
                'question' => 'P 17: ¿Para quién es obligatoria la oración?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3420.mp3',
                'answer' => '<p> R- La oración es una obligación para todo musulmán.<span class="c6"><br /> El Todopoderoso dijo:</span> ﴾ <span class="c2">(…)</span> La oración ha sido ordenada para que los creyentes la realicen en horarios específicos ﴿ <span class="c2">(Traducción del Corán,<span class="c6"> 4:</span>103)</span>. </p>',
            ],
            17 => [
                'question' => 'P 18: ¿Cuál es el veredicto para quién abandona la oración?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3460.mp3',
                'answer' => '<p> R- Abandonar la oración es incredulidad.<span class="c6"> El Profeta ﷺ dijo:</span><br /> <span class="c1">“La distinción entre ellos y nosotros es la oración, así que quien la abandona es un incrédulo”</span>.<br /> <span class="c2">(Relatado por Ahmad, Al-Tirmidhi y otros)</span>. </p>',
            ],
            18 => [
                'question' => 'P 19: ¿Cuántas oraciones son obligatorias para un musulmán en el día y la noche? ¿Cuántas raka’ahs hay en cada oración?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3500.mp3',
                'answer' => '<p> R- Las oraciones obligatorias para todo musulmán son cinco y están distribuidas durante el día y la noche.<br /> La oración Fayr <span class="c2">(madrugada)</span> consta de dos raka’ahs, la oración del Dhuhr <span class="c2">(mediodía)</span> consta de cuatro raka’ahs, la oración del Asr <span class="c2">(la tarde)</span> consta de cuatro raka’ahs, la oración del Magrib <span class="c2">(el ocaso)</span> consta de tres raka’ahs y la oración del Ishaa <span class="c2">(la noche)</span> consta de cuatro raka’ahs. </p>',
            ],
            19 => [
                'question' => 'P 20: ¿Cuáles son las condiciones para que la oración sea válida?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3530.mp3',
                'answer' => '<p> R-<span class="c6"> Condiciones para la aceptación de la oración:</span><br /> 1) El Islam, puesto que no es aceptada del incrédulo.<br /> 2) Estar consciente, pues no es aceptada por quien está inconsciente.<br /> 3) Haber alcanzado la pubertad, puesto que no es obligatoria para los niños que no han alcanzado la pubertad.<br /> 4) La intención <span class="c5">[de realizarla]</span>.<br /> 5) Realizarse dentro del tiempo de cada oración <span class="c2">(no es aceptada si se realiza antes de su tiempo)</span>.<br /> 6) Tener la purificación física y espiritual.<br /> 7) Quitar toda impureza del cuerpo, de la ropa y del lugar de la oración.<br /> 8) Cubrir el ‘Awrah <span class="c2">(pudor)</span>.<br /> 9) Rezar encarando la dirección de la Qibla <span class="c2">(la Kaaba)</span>. </p>',
            ],
            20 => [
                'question' => 'P 21: ¿Cuáles son los pilares de la oración?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3640.mp3',
                'answer' => '<p> R- Los pilares de oración son catorce,<span class="c6"> estos son:</span><br /> 1) Ser capaz de cumplir con las obligaciones.<br /> 2) El Takbir Al-Ihram (decir <span class="c1">“Al-láhu Ákbar)”</span> al inicio de la oración.<br /> 3) Recitar Al-Fatihah <span class="c2">(Sura la Apertura)</span>.<span class="c6"><br /> 4) Ar Ruku’:</span> inclinarse hacia adelante, manteniendo las piernas rectas, posando las manos sobre las rodillas, y manteniendo la espalda y cabeza rectas <span class="c2">(logrando con el cuerpo un ángulo de 90°)</span>.<br /> 5) Levantarse de la inclinación.<br /> 6) Pararse derecho luego de levantarse.<br /> 7) Postrarse apoyando en el suelo su frente, nariz, manos, rodillas y las puntas de los dedos de los pies en el lugar de la postración.<br /> 8) Levantarse de la postración.<br /> 9) Sentarse entre las dos postraciones.<span class="c6"><br /> La Sunnah:</span> al estar arrodillado, sentarse sobre el pie izquierdo, y el pie derecho levantarlo, apoyando los dedos de los pies y dirigiéndolo hacia la Qibla.<br /> 10) Tranquilidad, es decir, la quietud en cada posición.<br /> 11) El último At-Tashahud <span class="c2">(salutaciones al Profeta ﷺ al finalizar la oración)</span>.<br /> 12) Sentarse durante el At-Tashahud.<br /> 13) Los dos saludos al finalizar la oración, que es decir,<span class="c6"> dos veces:</span> <span class="c1">“As-salamu ‘Alaikum Wa Rahmatul-lah <span class="c2">(La paz y la misericordia de Al-láh sean con vosotros)</span>”</span>.<br /> 14) Hacer los pilares por orden tal como fueron mencionados.<span class="c6"> Por ejemplo:</span> si se postra intencionalmente antes de la inclinación, su oración queda inválida; pero si lo hizo por olvido o negligencia, se debe regresar a la inclinación y continuar con la oración hasta el final, y agregar las <span class="c1">“dos postraciones del olvido”</span>. </p>',
            ],
            21 => [
                'question' => 'P 22: ¿Cuáles son los deberes de la oración?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3820.mp3',
                'answer' => '<p> R- Los deberes de la oración son ocho,<span class="c6"> estos son:</span><br /> 1) Los Takbirat (decir <span class="c1">“Al-láhu Ákbar”</span> al cambiar de posición), estos no incluyen el Takbir de Ihram (decir <span class="c1">“Al-láhu Ákbar”</span> en la apertura de la oración), pues éste es un pilar obligatorio de la oración.<br /> 2- Cuando nos levantamos de la inclinación tanto el Imam <span class="c2">(quien dirige la oración en congregación)</span> como los orantes deben decir: <span class="c1">“Sami’a Al-láhu liman jámidah. <span class="c2">(Al-láh Oye a aquellos que Lo alaban)</span>”</span>.<br /> 3-<span class="c6"> Decir:</span> <span class="c1">“Rabbana walakal jamd. <span class="c2">(Al-láh merece todas las alabanzas y a Él le pertenecen)</span>”</span>. <span class="c2">(Continuando la frase anterior descrita en el paso N°2)</span>”.<br /> 4-<span class="c6"> Decir una vez al inclinarse:</span> <span class="c1">“Subhana Rabbi Al Adim <span class="c2">(Alabado sea mi Señor, el Grandísimo)</span>”</span>.<br /> 5-<span class="c6"> Decir una vez en postración:</span> <span class="c1">“Subhana Rabbi Al Aala <span class="c2">(Alabado Seas mi Señor, el Altísimo)</span>”</span>.<br /> 6-<span class="c6"> Decir entre las dos postraciones:</span> <span class="c1">“Rabbi igfirli <span class="c2">(¡Oh, Señor! Perdóname)</span>”</span>.<br /> 7- El primer At-Tashahud <span class="c2">(la primera parte del Attahiyatu)</span>.<br /> 8- Sentarse para el primer At-Tashahud. </p>',
            ],
            22 => [
                'question' => 'P 23: ¿Cuáles son las Sunnah de la oración?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3930.mp3',
                'answer' => '<p> R- La Sunnah de la oración son veinticuatro; se dividen en once Sunnah de la lengua,<span class="c6"> y trece Sunnah de los movimientos:</span><br /> Sunnah de la lengua:<br /> 1-<span class="c6"> Decir después del Takbir de apertura la súplica de la apertura:</span> <span class="c1">“Subhanak Al-lahumma wa bihamdika wa tabarak ismuk wa ta’ala yaduk wa la il-laha gairuk. <span class="c2">(Glorificado y alabado sea Al-láh; bendito sea Tu nombre; suprema es Tu voluntad, no hay divinidad salvo Tú)</span>”</span>.<br /> 2- Buscar refugio en Al-láh del demonio antes de recitar la Fatihah,<span class="c6"> diciendo:</span> <span class="c1">“A’udhu bil-láhi min ash-Shaitán ar rayim. <span class="c2">(Me refugio en Al-láh del maldito Satanás)</span>”</span>.<br /> 3-<span class="c6"> Decir:</span> <span class="c1">“Bismil-láh. <span class="c2">(en el nombre de Al-láh)</span>”</span> al iniciar Al Fatihah.<br /> 4-<span class="c6"> Decir:</span> <span class="c1">“Amín. <span class="c2">(Amén)</span>”</span> luego de terminar de recitar Al Fatihah.<br /> 5- Recitar una sura del Corán o parte de ella después de recitar Al-Fatihah.<br /> 6- Para el Imám <span class="c2">(quien dirige la oración en congregación)</span>: en las primeras dos Raka’ah de las oraciones del Fayr, el Magrib y el Ishaa recitar en voz alta.<br /> 7-<span class="c6"> Decir luego de recitar lo que se menciona en la inclinación o la postración:</span> <span class="c1">“Mil a assamawati, wa mil a Al Arddi, wa mil a ma shitta minshain baad. <span class="c2">(Llenos están los Cielos y la Tierra y lo que existe entre ellos de alabanzas para Ti y todo lo que quieres se desborda de alabanzas)</span>”</span>.<br /> 8- Decir más de una vez lo que se dice al glorificar en la inclinación.<br /> 9- Decir más de una vez lo que se dice al glorificar en la postración.<br /> 10- Decir más de una vez entre las dos postraciones <span class="c1">“Rabbí Igfirlí. <span class="c2">(¡Oh Señor! Perdóname)</span>”</span>.<br /> 11- Agregar frases de saludo al profeta Muhámmad y su familia, y hacer súplica por ellos en la segunda parte del At-Tashahud.<span class="c6"><br /> Sunnah de los movimientos:</span><br /> 1- Levantar las manos al nivel de los hombros o las orejas diciendo el Takbir de Ihram <span class="c2">(Takbir de apertura de la oración)</span>.<br /> 2- Levantar las manos antes de la inclinación.<br /> 3- Levantar las palmas de las manos al levantarse de la inclinación.<br /> 4- Bajar las manos después del paso n° 3.<br /> 5- Colocar la mano derecha sobre la izquierda.<br /> 6- Fijar la mirada en el lugar de la postración.<br /> 7- Al estar de pie, separar los pies.<br /> 8- En la inclinación, reposar las manos sobre las rodillas con los dedos separados, y tratar de mantener la espalda y cabeza rectas.<br /> 9- Permitir que los miembros del cuerpo se postren en el suelo y dirigirlos al lugar de la postración.<br /> 10- En el momento de la postración es recomendable separar los codos del cuerpo y no tocar el suelo con los mismos, no acercar el estómago a las rodillas, no apoyar los muslos en los pies, separar ligeramente las rodillas, apoyar los dedos de los pies y poner las palmas de las manos <span class="c2">(con los dedos juntos)</span> en el suelo a la altura de los hombros en dirección a la Qibla.<br /> 11- Sentarse cómoda y brevemente entre las dos postraciones y en el primer At-Tashahud <span class="c2">(véase 9° deber de la oración)</span>. En el segundo At-Tashahud es recomendable, al sentarse, cruzar la pierna izquierda debajo de la derecha.<br /> 12- Entre las dos postraciones es recomendable al sentarse, poner las palmas de las manos sobre los muslos, cerca de las rodillas, con los dedos juntos. También, en el At-Tashahud, pero cerrando la mano derecha y levantando el dedo índice derecho cuando se nombra a Al-láh ﷻ.<br /> 13- Girar el rostro a la derecha y a la izquierda al finalizar la oración con el saludo. </p>',
            ],
            23 => [
                'question' => 'P 24: ¿Qué anula la oración?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4210.mp3',
                'answer' => '<p> R-<br /> 1) Abandonar un pilar o una condición de la oración.<br /> 2) Hablar deliberadamente.<br /> 3) Comer o beber durante la oración.<br /> 4) Muchos movimientos consecutivos <span class="c2">(ajenos a la oración)</span>.<br /> 5) Descuidar deliberadamente una oración obligatoria. </p>',
            ],
            24 => [
                'question' => 'P 25: ¿Cómo debe realizar la oración un musulmán?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4280.mp3',
                'answer' => '<p> R- La oración debe realizarse en idioma árabe, con los pasos consecutivos descritos y sin ninguna omisión.<span class="c6"> Para que ella sea válida debe:</span><br /> 1- Ponerse de pie, con la parte delantera de su cuerpo y rostro en dirección a la Qibla.<br /> 2- Luego, tener la intención de realizar la oración que quiere hacer con el corazón, sin pronunciar oralmente la intención.<br /> 3- Luego al levantar las manos a la altura de las orejas o los hombros,<span class="c6"> dice el Takbir Al Ihram:</span> <span class="c1">“Al-láhu Ákbar”</span> (<span class="c1">“Al-láh es El más Grande”</span>).<br /> 4- Luego pone la mano derecha sobre la izquierda, y ambas en la parte baja del pecho.<br /> 5-<span class="c6"> Y dice en voz baja:</span> <span class="c1">“Alahuma baid baini wa baina khataiaia kama ba-ata baina al mashriqi wal magrib, Alahuma naqini min khataiaia kama iunaqa al thawbu al abiaddu mina al danas, Alahuma igsilni min khataiaia bilmaa wa al thalyi wa al barad.<br /> <span class="c2">(¡Oh Al-láh! Aléjame de mis pecados como has alejado el Oriente del Occidente. ¡Oh Al-láh! Purifícame de mis pecados como un vestido blanco se purifica de la suciedad. ¡Oh Al-láh! Purifícame de mis pecados con agua, nieve y granizo)</span>”</span>.<span class="c6"><br /> O dice:</span> <span class="c1">“Subhanak Alahumma wa bijamdika wa tabarak ismuk wa ta’ala yadduk wa la il-laha gairuk”</span> (<span class="c1">“Glorificado y alabado sea Al-láh; bendito sea Tu nombre; suprema es Tu voluntad y no hay divinidad salvo Tú”</span>).<br /> 6) Luego busca refugio en Al-<span class="c6">láh ﷻ diciendo:</span> <span class="c1">“A’udhu bil-láhi min ash-Shaitán ar rayim”</span> (<span class="c1">“Me refugio en Al-láh del maldito Satanás”</span>). 7) Luego recita Al-<span class="c6">Fatihah en árabe:</span> <span class="c2">(بِسْمِ اللهِ الرَّحْمنِ الرَّحِيمِ)</span><br /> <span class="c1">“Bismil-láhi Rahmáni Rahím<br /> <span class="c2">("En el nombre de Al-láh, el Compasivo, el Misericordioso)</span>. <span class="c2">(الْحَمْدُ للّهِ رَبِّ الْعَالَمِينَ)</span><br /> Al hamdulil-láhi, Rabbil ‘Alamín <br /> <span class="c2">(Alabado sea Al-láh, Señor del Universo)</span>, <span class="c2">(الرَّحْمـنِ الرَّحِيمِ)</span><br /> Ar Rahmáni, Ar Rahím <br /> <span class="c2">(Clemente, Misericordioso)</span>. <span class="c2">(مَالِكِ يَوْمِ الدِّينِ)</span><br /> Máliki Iaumi Dín <br /> <span class="c2">(Soberano en el Día del Juicio)</span> <span class="c2">(إِيَّاكَ نَعْبُدُ وإِيَّاكَ نَسْتَعِينُ)</span><br /> i-iáka na’budu wa i-iáka nasta’in <br /> <span class="c2">(Sólo a Ti adoramos y de Ti imploramos ayuda)</span> <span class="c2">(اهدِنَــــا الصِّرَاطَ المُستَقِيمَ)</span><br /> Ihdinás Sirátal Mustaquim <br /> <span class="c2">(¡Guíanos por el sendero recto!)</span> <span class="c2">(صِرَاطَ الَّذِينَ أَنعَمتَ عَلَيهِمْ غَيرِ المَغضُوبِ عَلَيهِمْ وَلاَ الضَّالِّينَ)</span><br /> Sirátal ladina an’amta ‘alaihim, Gairil Magdubi ‘alaihim Wa lad dáalin"<br /> <span class="c2">(El camino de los que has colmado con Tus favores, no el de los que cayeron en Tu ira, ni el de los que se extraviaron)</span>". <span class="c2">(Noble Corán,<span class="c6"> surah Al Fatihah:</span>1-7)</span>.<span class="c6"><br /> Luego dice:</span> “Amín”</span> <span class="c2">(Amén)</span>.<br /> 8- Luego recita otra surah del Corán o lo que le sea más fácil del Corán. Si está realizando la oración del Fayr <span class="c2">(madrugada)</span>, prolonga la recitación del Corán.<br /> 9- Luego hace Ar ruku’, es decir, se inclina hacia adelante, manteniendo las piernas rectas, y posando las manos sobre las rodillas, manteniendo la espalda y cabeza recta.<span class="c6"> <br /> Sunnah:</span> mantener la espalda recta, fijar la mirada hacia el punto de postración, posar las manos sobre las rodillas con los dedos separados.<br /> 10- Dice en la inclinación,<span class="c6"> tres veces:</span> <span class="c1">“Subhána Rabbil ‘Adhim”</span> (<span class="c1">“Alabado sea mi Señor, el Grandísimo”</span>).<span class="c6"> Y si desea puede agregar:</span> <span class="c1">“Subhánaka Al-lahuma wa bihámdika, Al-lahuma Igfirlí”</span> <span class="c2">(Glorificado y alabado sea Al-láh, ¡Oh Al-láh! Perdóname)</span>.<br /> 11- Se levanta y eleva las palmas de las manos a la altura de sus hombros hasta estar nuevamente erguido,<span class="c6"> luego las baja y dice:</span> <span class="c1">“Sami’Al-láhu liman jámidah”</span> (<span class="c1">“Al-láh Oye a aquellos que Lo alaban”</span>), <span class="c1">“Rabbana wa lakal jamd”</span> (<span class="c1">“Al-láh merece todas las alabanzas y Le pertenecen”</span>).<br /> *Cuando se está en la oración en congregación, el Imam dice el <span class="c1">“Sami’Al-láhu liman jámida”</span> y los orantes responden <span class="c1">“Rabbana wa lakal hamd”</span>.<br /> 12-<span class="c6"> Es recomendable agregar:</span> <span class="c1">“Rabbana wa lakal hamd, Mil a assamawati wa mil a Al Ardi wa mil a ma shitta minshain baad”</span> (<span class="c1">“Al-láh merece todas las alabanzas y Le pertenecen, llenos están los Cielos y la Tierra y lo que existe entre ellos de alabanzas para Ti y todo lo que quieres se desborda de alabanzas”</span>).<br /> 13-<span class="c6"> Luego dice el Takbir:</span> <span class="c1">“Al-láhu Ákbar”</span> (<span class="c1">“Al-láh es el más Grande”</span>) y realiza la postración apoyando siete partes de su cuerpo; las dos manos, las dos rodillas, frente y nariz sobre el suelo. Los dedos de los pies deben igualmente estar apoyados.<br /> 14-<span class="c6"> Estando en esta posición dice tres veces:</span> <span class="c1">“Subhána Rabbil A’la”</span> (<span class="c1">“Alabado Seas mi Señor, el Altísimo”</span>).<span class="c6"> Es recomendable agregar:</span> <span class="c1">“Mil a assamawati wa mil a Al Ardi wa mil a ma shitta minshain baad”</span> (<span class="c1">“Llenos están los Cielos y la Tierra y lo que existe entre ellos de alabanzas para Ti y todo lo que quieres se desborda de alabanzas”</span>).<br /> 15- Levantar la cabeza diciendo el Takbir <span class="c1">“Al-láhu Ákbar”</span>.<br /> 16- Luego se sienta sobre su pie izquierdo, levanta su pie derecho <span class="c2">(apoyando los dedos en el suelo)</span>, coloca la palma de su mano izquierda sobre la punta de su rodilla izquierda; y la palma de la mano derecha sobre la punta de su rodilla derecha, y al suplicar une los dedos de la mano derecha y levanta y mueve el dedo índice.<br /> 17-<span class="c6"> Sentado en medio de las dos postraciones dice:</span> <span class="c1">“Rabbí Igfirlí”</span> (<span class="c1">“¡Oh Señor! Perdóname”</span>). Y si desea, puede agregar <span class="c1">“Warhamni, wahdini, warzuqni, waburni, waafini”</span> <span class="c2">(enderézame, ten piedad de mí, guíame, dame el sustento y eleva mi rango)</span>.<br /> 18- Luego se postra por segunda vez diciendo <span class="c1">“Al-láhu Ákbar”</span> <span class="c2">(como en el paso n.º 13)</span>,<span class="c6"> y repite tres veces:</span> <span class="c1">“Subhána Rabbil A’la”</span> (<span class="c1">“Alabado Seas mi Señor, el Altísimo”</span>).<br /> 19- Al completar la primera Raka’ah, se pone de pie para realizar la segunda (diciendo <span class="c1">“Al-láhu Ákbar”</span>) y continúa desde la recitación de la sura Al-Fatihah <span class="c2">(sin hacer la súplica de la apertura)</span>.<br /> 20- Luego de haber realizado la segunda postración del segundo Raka’ah, se sienta diciendo <span class="c1">“Al-láhu Ákbar”</span>.<br /> 21- Al finalizar la oración, debe decir el At-<span class="c6">Tashahud completo:</span> Primera parte del At-<span class="c6">tashahud:</span> <span class="c1">“At-Tahiátu lil-láhi was-salawátu wattaiebat assalámu \'alaika aiuhan-nabiu wa rahmatul-láhi wa barakátuh. Assalámu \'alaina wa \'ala \'ibadi-láhis-sálihin”</span> (<span class="c1">“Las salutaciones son para Al-láh, todos los actos de adoración y las buenas obras. Que la paz, la misericordia y las bendiciones de Al-láh sean con el Profeta. Que la paz sea sobre nosotros y sobre los siervos virtuosos de Al-láh”</span>). <br /> <span class="c1">“Ash-hadu an lá iláha il-laláhu Wa ash-hadu anna Muhámmadan \'abduhu wa rasuluhu”</span> (<span class="c1">“Atestiguo que no hay divinidad salvo Al-láh y atestiguo que Muhámmad es Su siervo y mensajero”</span>). <br /> Segunda parte del At-<span class="c6">tashahud:</span> <span class="c1">“Al-lahumma Sal-li \'ala Muhámmad wa \'ala Aali Muhámmad Kama sal-laita \'ala Ibrahim wa ‘ala Aali Ibrahim. Innaka hamidun Mayid. Al-lahumma Bárik \'ala Muhámmad wa \'ala Aali Muhámmad Kama barakta \'ala Ibrahim wa ‘ala Aali Ibrahim. Innaka hamidun Mayid”</span> (<span class="c1">“Oh Al-láh, exalta a Muhámmad y a la familia de Muhámmad, como exaltaste a Abraham y a la familia de Abraham. Ciertamente Tú eres Alabadísimo y Majestuoso ¡Oh, Al-láh! Bendice a Muhámmad y la familia de Muhámmad, como bendijiste a Abraham y a la familia de Abraham. Por cierto, Tú eres Alabadísimo y Majestuoso”</span>).<br /> Es recomendable agregar esta súplica al finalizar el At-<span class="c6">tashahud:</span> <span class="c1">“Al-lahumma inni a’udu bika min adhabi iiayannam wa min adhabil qabr wa min fitnatil mahhia wa mamat wa sharri fitnatil masih ad-dayyal”</span> (<span class="c1">“Al-láh, me refugio en Ti del castigo del Infierno, me refugio en Ti del castigo de la tumba, me refugio en Ti de la tentación de la vida y la muerte y del mal de la tribulación del falso Mesías”</span>). Luego súplica a su Señor por lo que ama de la bondad de este mundo y del Más Allá.<br /> 22- Para finalizar el rezo, gira su rostro; primero hacia su lado derecho,<span class="c6"> diciendo:</span> <span class="c1">“As-salamu ‘Alaikum Wa Rahmatul-láh”</span> (<span class="c1">“La paz y la misericordia de Al-láh sea con vosotros”</span>).<span class="c6"> Y luego hacia el lado izquierdo:</span> As-salamu ‘Alaikum Wa Rahmatul-láh”.<br /> 23- Si la oración es de tres o cuatro Raka’ah, se debe decir la primera parte del At-tashahud hasta el testimonio de fe (<span class="c1">“Ash-hadu an lá iláha il-laláhu Wa ash-hadu anna Muhámmadan \'abduhu wa rasuluh”</span>) y luego levantarse para continuar con las demás Raka’ah.<br /> 24- Al continuar la oración, se levanta diciendo <span class="c1">“Al-láhu Ákbar”</span> elevando las palmas de las manos a la altura de las orejas o los hombros.<br /> 25- Luego continúa con los demás pasos de la oración que completa la raka\'ah, pero solo recitando la Fatihah, es decir, sin agregar otra surah o aleya del Corán.<br /> 26- En el segundo At-tashahud es recomendable, al sentarse, cruzar la pierna izquierda debajo de la derecha.<br /> 27- Decir el At-tashahud completo.<br /> 28- Girar el rostro, primero hacia su lado derecho,<span class="c6"> diciendo:</span> <span class="c1">“As-salamu ‘Alaikum Wa Rahmatul-láh”</span> (<span class="c1">“La paz y la misericordia de Al-láh sea con vosotros”</span>).<span class="c6"> Y luego hacia el lado izquierdo:</span> As-salamu ‘Alaikum Wa Rahmatul-láh”. </p>',
            ],
            25 => [
                'question' => 'P 26: ¿Qué decimos de Dhikr (recuerdo de Al-láh) al finalizar la oración?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4610.mp3',
                'answer' => '<p> R-<br /> -<span class="c6"> Decir tres veces:</span> <span class="c1">“Astagfirul-láh”</span> (<span class="c1">“pido perdón a Al-láh”</span>).<br /> -<span class="c6"> Decir tres veces:</span> <span class="c1">“Al-lahumma anta As-Salam wa minka As-Salam tabarakta ia dhal yalalil wal ikram”</span> (<span class="c1">“Al-láh Tu eres la paz y de Ti viene la paz; bendito seas, poseedor de la gloria y la bondad).<br /> -<span class="c6"> Decir una vez:</span> “La iláha il-la Al-láh, láhul mulk wa láhul hamd wa húa ‘ala kul shai’ qadir. Al-lahumma la mani’ lima a tait wa la mu’ti lima mana’t wa la ianfa’dhal yaddi minka al yadd”</span> <span class="c2">(No hay divinidad excepto Al-láh, Suya es la soberanía y Suya es la alabanza, y es de todo Poderoso. Al-láh no hay quien retenga lo que Tú diste, ni quien dé lo que Tú retuviste, y no le sirve de nada la fuerza al fuerte, pues la fuerza viene de Ti)</span>.<span class="c6"><br /> Decir una vez:</span> <span class="c1">“La iláha il-la Al-láh, láhul mulk wa láhul hamd wa húa ‘ala kul shai’ qadir. La hawla wa la quata il-la bil-láh; la ilahah il-la Al-láh wa la na’budu il-la i-iahu, lahun-ni’ma wa lahul fadl wa lahuz-zana’ul hasan. La ilaha il-la Al-láh, muhlisin Lahud-din wa law kariha al kafirun”</span> <span class="c2">(No hay divinidad excepto Al-láh, Suya es la soberanía y Suya es la alabanza, y es de todo Poderoso. No hay fuerza ni poder sino en Al-láh, no adoramos nada sino a Él. Suya es la gracia y Suya la bondad y la alabanza bella. No hay divinidad excepto Al-láh, a Él adoramos sinceramente, aunque renieguen de ello los incrédulos)</span>.<br /> -<span class="c6"> Decir treinta y tres veces:</span> <span class="c1">“Subhánal-láh" <span class="c2">(Glorificado sea Al-láh)</span>.<br /> -<span class="c6"> Decir treinta y tres veces:</span> “Alhámdulil-láh”</span> <span class="c2">(Alabado sea Al-láh)</span>.<br /> -<span class="c6"> Decir treinta y tres veces:</span> <span class="c1">“Al-láhu Ákbar”</span> <span class="c2">(Al-láh es el Más Grande)</span>.<br /> - Luego, para completar cien frases del recuerdo de Al-láh,<span class="c6"> decir una vez:</span> <span class="c1">“La iláha il-la Al-láh, wahdahu la shárika láh, láhul mulk wa láhul hamd wa hua ala kul shai’ qadir”</span> <span class="c2">(No hay divinidad excepto Al-láh, sin iguales ni copartícipes; Suya es la soberanía y suya es la alabanza y es Omnipotente)</span>.<br /> - Recitar tres veces las suras Al-<span class="c6">Ikhlaas:</span> El monoteísmo puro <span class="c2">(n° 112)</span>, Al-<span class="c6">Falaq:</span> El amanecer <span class="c2">(n° 113)</span> y An-<span class="c6">Naas:</span> Los seres humanos <span class="c2">(n° 114)</span>, después de la oración del Fayr y el Magrib, y una sola vez después de las demás oraciones.<br /> - Recitar Ayat Al Kursi [la aleya 255 de surah la Vaca <span class="c2">(n° 2)</span>] una sola vez. </p>',
            ],
            26 => [
                'question' => 'P 27: ¿Cuáles y cuántas son las oraciones Sunnah que el Profeta ﷺ hacía constantemente y cuál es su recompensa?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4730.mp3',
                'answer' => '<p> R-<span class="c6"> Las oraciones Sunnah que el profeta Muhámmad ﷺ hacía constantemente las realizaba dentro del tiempo de cada oración de la siguiente manera:</span><br /> *Dos raka’ahs antes de realizar la oración obligatoria del Fayr.<br /> *Cuatro raka’ahs antes de realizar la oración obligatoria del Dhuhr <span class="c2">(es decir, dos raka’ahs y luego dos raka’ahs)</span>.<br /> Y después del rezar el Dhuhr realizaba otras dos raka’ahs voluntarias .<br /> *Dos raka’ahs después del Magrib.<br /> *Dos raka’ahs después del Ishaa.<span class="c6"><br /> Su recompensa está descrita en lo que informó el Profeta ﷺ:</span> <span class="c1">“Quien reza en el día y la noche doce raka’ahs voluntarias, Al-láh le construirá una casa en el Paraíso”</span>. <span class="c2">(Relatado por Muslim, Ahmad y otros)</span>. </p>',
            ],
            27 => [
                'question' => 'P 28: ¿Cuál es el mejor día de la semana?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4800.mp3',
                'answer' => '<p> R- El mejor día de la semana es el viernes.<span class="c6"> El Profeta ﷺ dijo:</span> <span class="c1">“El mejor día para ustedes es el viernes; Al-láh creó a Adán en ese día, Adán murió en este día, el llamado de la trompeta y la muerte de toda la creación será ese día. Multipliquen las salutaciones a mí, porque su saludo me será presentado”</span>.<span class="c6"> Dijeron los compañeros:</span> ¡Oh Mensajero de Al-láh! ¿Y cómo te será mostrado si al morir desaparecerá tu cuerpo?”.<span class="c6"> Él respondió:</span> Al-láh ﷻ prohibió que la tierra ingiera el cuerpo de los Profetas”. <span class="c2">(Relatado por Abu Dawud y otros)</span>. </p>',
            ],
            28 => [
                'question' => 'P 29: ¿Cuál es el veredicto sobre la oración del viernes?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4840.mp3',
                'answer' => '<p> R- La oración del viernes es una obligación para todo hombre musulmán consciente que alcanzó la pubertad.<span class="c6"><br /> El Todopoderoso dijo:</span> ﴾ ¡Creyentes! Cuando sea realizado el llamado a la oración del viernes, acudan al recuerdo de Al-láh y abandonen el comercio, es lo mejor para ustedes. ¡Si supieran!” ﴿ <span class="c2">(Traducción del Corán,<span class="c6"> 62:</span>9)</span>. </p>',
            ],
            29 => [
                'question' => 'P 30: ¿Cuántas raka’ahs se realizan la oración del viernes?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4880.mp3',
                'answer' => '<p> R- El número de raka’ahs de la oración del viernes son dos. Al Imam de la oración le corresponde recitar en voz alta el Corán, seguido de dos conocidos sermones. </p>',
            ],
            30 => [
                'question' => 'P 31: ¿Es permitido faltar a la oración del viernes?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4910.mp3',
                'answer' => '<p> R- No, no está permitido faltar a la oración del viernes.<span class="c6"> El Profeta ﷺ dijo:</span> <span class="c1">“Quien abandona tres oraciones del viernes por descuido, Al-láh Le sellará su corazón”</span>. <span class="c2">(Relatado por Abu Dawud y otros)</span>. </p>',
            ],
            31 => [
                'question' => 'P 32: ¿Cuáles son las Sunnahs del viernes?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4940.mp3',
                'answer' => '<p> R-<br /> 1- Hacer el Gusl <span class="c2">(purificación mayor)</span>.<br /> 2- Usar perfume.<br /> 3- Usar la mejor ropa.<br /> 4- Ir temprano a la mezquita.<br /> 5- Pedir muchas bendiciones para el Profeta ﷺ.<br /> 6- Recitar Surat Al-Kahf <span class="c2">(surah la Caverna, n° 18)</span> antes de la oración.<br /> 7- Ir a la mezquita a pie.<br /> 8- Aprovechar hacer súplicas durante todo el día porque hay una hora <span class="c2">(que es desconocida)</span> en la que Al-láh ﷻ acepta las súplicas. </p>',
            ],
            32 => [
                'question' => 'P 33: Mencione la virtud de la oración en congregación',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5050.mp3',
                'answer' => '<p> R- Abdul-lah bin Omar -que Al-láh se complazca con ambos-,<span class="c6"> dijo que el Mensajero ﷺ dijo:</span> <span class="c1">“La oración en congregación es mejor que la oración individual en veintisiete grados”</span>. <span class="c2">(Relatado por Muslim)</span>. </p>',
            ],
            33 => [
                'question' => 'P 34: ¿Qué es la humildad en la oración?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5080.mp3',
                'answer' => '<p> R- Es la presencia del corazón y la quietud de los miembros durante la oración.<span class="c6"><br /> El Todopoderoso dijo:</span> ﴾ Bienaventurados los creyentes que en sus oraciones son humildes <span class="c5">[ante Al-láh]</span> ﴿ <span class="c2">(Traducción del Corán,<span class="c6"> 23:</span>1-2)</span>. </p>',
            ],
            34 => [
                'question' => 'P 35: ¿Cuál es la definición de Zakat (Caridad obligatoria)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5120.mp3',
                'answer' => '<p> R- El Zakat <span class="c2">(Caridad obligatoria)</span> es un deber según la riqueza, obligatorio para un grupo de personas en un momento específico.<br /> Es uno de los pilares del Islam, y es una caridad obligatoria. Se recibe de los adinerados y es entregada a los necesitados.<span class="c6"><br /> El Altísimo dijo:</span> ﴾ <span class="c2">(…)</span> Paguen el Zakat <span class="c2">(…)</span> ﴿ <span class="c2">(Traducción del Corán,<span class="c6"> 2:</span>43)</span>. </p>',
            ],
            35 => [
                'question' => 'P 36: ¿Qué es la caridad voluntaria?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5170.mp3',
                'answer' => '<p> R- No es lo mismo que el Zakat. Es dar caridad de cualquier manera, en el camino del bien y en cualquier momento.<span class="c6"><br /> El Todopoderoso dijo:</span> ﴾Contribuyan a la causa de Al-láh <span class="c5">[de buen grado]</span> <span class="c2">(…)</span> ﴿ <span class="c2">(Traducción del Corán,<span class="c6"> 2:</span>195)</span>. </p>',
            ],
            36 => [
                'question' => 'P 37: ¿Cuál es la definición de ayuno?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5210.mp3',
                'answer' => '<p> R- El ayuno es adorar a Al-láh ﷻ absteniéndose de cosas que rompen el ayuno, en un tiempo que comprende desde el amanecer hasta el ocaso, con la intención de ayunar.<span class="c6"> Existen dos tipos de ayuno:</span><br /> Ayuno obligatorio: es ayunar durante el mes de Ramadán y es uno de los pilares del Islam.<span class="c6"><br /> El Todopoderoso dijo:</span> ﴾ ¡Oh, creyentes! Se les prescribe el ayuno al igual que fue prescrito a quienes les precedieron, para que así alcancen la piedad﴿ <span class="c2">(Traducción del Corán,<span class="c6"> 2:</span>183)</span>.<span class="c6"><br /> Ayuno voluntario:</span> tal como ayunar los lunes y jueves de cada semana, ayunar tres días de cada mes, los mejores de los cuales son los <span class="c1">“días blancos”</span>, es decir, el 13,14 y 15 de cada mes lunar. </p>',
            ],
            37 => [
                'question' => 'P 38: ¿Cuál es la virtud de ayunar en el mes de Ramadán?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5270.mp3',
                'answer' => '<p> R- Abu Huraira -que Al-láh se complazca con él-,<span class="c6"> dijo que el Mensajero ﷺ dijo:</span> <span class="c1">“A quien ayune durante Ramadán con fe y devoción, Al-láh le perdonará sus faltas anteriores”</span>. <span class="c2">(Hadiz concertado)</span> </p>',
            ],
            38 => [
                'question' => 'P 39: ¿Cuál es la virtud del ayuno voluntario?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5300.mp3',
                'answer' => '<p> R- Abu Said Al-Khudri -que Al-láh se complazca con él-<span class="c6"> dijo:</span> <span class="c1">“El Mensajero ﷺ me dijo: ‘No hay siervo que ayune por la causa de Al-láh, excepto que Al-láh mantenga su rostro alejado del Fuego por setenta otoños en ese día’”</span>. <span class="c2">(Hadiz convenido)</span><br /> - "Setenta otoños" significa setenta años. </p>',
            ],
            39 => [
                'question' => 'P 40: Mencionar algunos de los invalidantes del ayuno',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5330.mp3',
                'answer' => '<p> R-<br /> 1- Comer o beber intencionalmente.<br /> 2- Vomitar intencionalmente.<br /> 3- Apostasía del Islam. </p>',
            ],
            40 => [
                'question' => 'P 41: ¿Cuáles son las Sunnah del ayuno?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5380.mp3',
                'answer' => '<p> R-<br /> 1- Apresurarse en romper el ayuno en cuanto llega el tiempo de romperlo.<br /> 2- El Suhur <span class="c2">(comer antes del Fayr como preparación para el ayuno)</span> y su cercanía al tiempo de la oración.<br /> 3- Un aumento en las obras de caridad y de adoración.<br /> 4- Cuando alguien insulta o molesta a una persona que ayuna,<span class="c6"> el ayunante debe responder diciendo:</span> <span class="c1">“Estoy ayunando”</span>.<br /> 5- La súplica al momento de romper el ayuno.<br /> 6- Romper el ayuno con dátiles frescos, y si no los encuentra, entonces con agua. </p>',
            ],
            41 => [
                'question' => 'P 42: ¿Qué es el hayy (Peregrinación mayor)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5460.mp3',
                'answer' => '<p> R-<span class="c6"> Hayy:</span> es la devoción a Al-láh Todopoderoso, con la intención de visitar Su Casa Sagrada para unas acciones específicas en un momento específico.<span class="c6"><br /> El Todopoderoso dijo:</span> ﴾ <span class="c2">(…)</span> Es obligatorio para las personas peregrinar a esta Casa Sagrada si se encuentran en condiciones <span class="c5">[físicas y económicas]</span> de hacerlo. Pero quien niegue lo que Al-láh ha prescrito, sepa que Al-láh no necesita de Sus criaturas﴿ <span class="c2">(Traducción del Corán,<span class="c6"> 3:</span>97)</span> </p>',
            ],
            42 => [
                'question' => 'P 43: ¿Cuáles son los pilares del hayy?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5500.mp3',
                'answer' => '<p> R-<br /> 1- Al Ihram <span class="c2">(cambiarse toda la ropa por dos telas blancas que lo cubrirán, y tener la intención. Esto se hace en un lugar específico)</span>.<br /> 2- Pararse sobre la montaña Arafat.<br /> 3- Tawaf al-Ifadah <span class="c2">(realizar las siete vueltas a la Kaaba en un día específico)</span>.<br /> 4- Caminar entre las montañas Safa y Marwa. </p>',
            ],
            43 => [
                'question' => 'P 44: ¿Cuáles son las virtudes del hayy?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5560.mp3',
                'answer' => '<p> R- Abu Huraira -que Al-láh se complazca con él- dijo escuchar al Mensajero de Al-<span class="c6">láh ﷺ decir:</span> <span class="c1">“Quien peregrina por Al-láh y no comete obscenidad ni inmoralidad, volverá como el día que su madre le dio a luz”</span>. <span class="c2">(Relatado por Al-Bujari y otros)</span>.<br /> - <span class="c1">“Como el día que su madre lo dio a luz”</span>: sin pecados. </p>',
            ],
            44 => [
                'question' => 'P 45: ¿Qué es la Umrah (Peregrinación Menor)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5600.mp3',
                'answer' => '<p> R-<span class="c6"> Umrah:</span> es la devoción a Al-láh ﷻ con el propósito de peregrinar a Su Casa Sagrada para hacer una obra específica en cualquier momento del año. Esta peregrinación es voluntaria. </p>',
            ],
            45 => [
                'question' => 'P 46: ¿Cuáles son los pilares de la Umrah (Peregrinación Menor)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5630.mp3',
                'answer' => '<p> R-<br /> 1- Al Ihram <span class="c2">(cambiar toda la ropa por dos telas blancas que lo cubrirán, y tener la intención. Esto se hace en un momento específico)</span>.<br /> 2- Hacer el Tawaf <span class="c2">(realizar las siete vueltas a la Kaaba)</span>.<br /> 3- Caminar entre las montañas de Safa y Marwa. </p>',
            ],
            46 => [
                'question' => 'P 47: ¿Qué es la yijad por la causa de Al-láh?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5690.mp3',
                'answer' => '<p> R- La yijad por la causa de Al-láh es esforzarse en difundir el Islam, defenderlo a él y a su gente. Es luchar contra un enemigo del Islam y su gente.<span class="c6"><br /> El Todopoderoso dijo:</span> ﴾Salgan a combatir, sea que tengan una situación fácil o difícil. Contribuyan por la causa de Al-láh con sus bienes y luchen, porque es lo mejor para ustedes, si supieran﴿ <span class="c2">(Traducción del Corán,<span class="c6"> 9:</span>41)</span>. </p>',
            ],
        ],
        3 => [
            0 => [
                'question' => 'P 1: ¿Cuál es el linaje del profeta Muhámmad ﷺ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5740.mp3',
                'answer' => '<p> R-Él es Muhámmad bin Abdul-lah bin Abdul Muttalib bin Hashim. Hashim es de la tribu de los Quraish, y Quraish es de los árabes, los árabes son descendientes de Ismail, e Ismail es hijo del profeta Abraham -la paz sea con ellos. </p>',
            ],
            1 => [
                'question' => 'P 2: ¿Cuál es el nombre de la madre de nuestro Profeta ﷺ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5770.mp3',
                'answer' => '<p> R- Amina bintu Wahb. </p>',
            ],
            2 => [
                'question' => 'P 3: ¿Cuándo murió el padre del Profeta ﷺ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5800.mp3',
                'answer' => '<p> R- El padre del profeta Muhámmad ﷺ murió en Medina mientras su madre estaba embarazada. El Profeta ﷺ nació huérfano de padre. </p>',
            ],
            3 => [
                'question' => 'P 4: ¿Cuándo nació el profeta Muhámmad ﷺ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5830.mp3',
                'answer' => '<p> R- El profeta Muhámmad ﷺ nació en el Año del Elefante, un día lunes del mes de Rabi’ Al-Awwal. </p>',
            ],
            4 => [
                'question' => 'P 5: ¿En dónde nació el Profeta ﷺ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5850.mp3',
                'answer' => '<p> R- En la Meca. </p>',
            ],
            5 => [
                'question' => 'P 6: ¿Quiénes fueron las madres de leche y nodrizas del Profeta ﷺ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5880.mp3',
                'answer' => '<p> R- <br /> - Um Aiman.<br /> - Thuwaibah.<br /> - Jalima Al Saadia. </p>',
            ],
            6 => [
                'question' => 'P 7: ¿Cuándo murió la madre del Profeta ﷺ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5930.mp3',
                'answer' => '<p> R- La madre del profeta Muhámmad ﷺ murió cuando él tenía seis años y su abuelo Abdul Muttalib se hizo cargo de él. </p>',
            ],
            7 => [
                'question' => 'P 8: ¿Quién cuidó del Profeta ﷺ después de la muerte de su abuelo Abdul Muttalib?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5960.mp3',
                'answer' => '<p> R- El abuelo del profeta Muhámmad ﷺ, Abdul al-Muttalib, murió cuando el Profeta ﷺ tenía ocho años y su tío Abu Talib fue quien asumió su cuidado. </p>',
            ],
            8 => [
                'question' => 'P 9: ¿Cuándo viajó el profeta Muhámmad ﷺ con su tío a la región de Al Sham?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5990.mp3',
                'answer' => '<p> R- Viajó con su tío a Al Sham cuando tenía doce años de edad. </p>',
            ],
            9 => [
                'question' => 'P 10: ¿Cuándo fue el segundo viaje del profeta Muhámmad ﷺ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6020.mp3',
                'answer' => '<p> R- El segundo viaje del profeta Muhámmad ﷺ fue como comerciante con el dinero de Khadiya- que Al-láh se complazca con ella. Cuando regresó contrajo matrimonio con ella, a la edad de veinticinco años. </p>',
            ],
            10 => [
                'question' => 'P 11: ¿Cuándo reconstruyeron los Quraish la Kaaba?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6050.mp3',
                'answer' => '<p> R- Los Quraish reconstruyeron la Kaaba cuando el profeta Muhámmad ﷺ tenía treinta y cinco años.<br /> Los integrantes de la tribu le solicitaron al Profeta ﷺ ser juez cuando discreparon sobre quién debía poner la Piedra Negra, así que él ﷺ la colocó en un manto, y ordenó a cada miembro de la tribu que tomara un extremo del manto. Finalmente, el profeta Muhámmad ﷺ con sus manos puso la piedra en una de las esquinas de la Kaaba. </p>',
            ],
            11 => [
                'question' => 'P 12: ¿Qué edad tenía el profeta Muhámmad ﷺ cuando le fue revelado el Mensaje? ¿Y a quiénes fue enviado como Profeta ﷺ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6080.mp3',
                'answer' => '<p> R- El profeta Muhámmad ﷺ tenía cuarenta años cuando le llegó la primera revelación. Él ﷺ fue enviado a todos los seres humanos como advertidor y como portador de buenas nuevas. </p>',
            ],
            12 => [
                'question' => 'P 13: ¿Qué fue lo primero con lo que comenzó la revelación del Profeta ﷺ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6110.mp3',
                'answer' => '<p> R- Lo primero con lo que comenzó la revelación fue que los sueños que tenía el Profeta ﷺ sucedían. </p>',
            ],
            13 => [
                'question' => 'P 14: ¿Cómo era la condición del profeta Muhámmad ﷺ antes de la revelación? ¿Cuándo bajó la revelación por primera vez?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6140.mp3',
                'answer' => '<p> R- El profeta Muhámmad ﷺ solía adorar a Al-láh ﷻ en la cueva de Jiraá y proveerse para ello.<br /> La revelación le llegó mientras estaba en la cueva adorando al Creador. </p>',
            ],
            14 => [
                'question' => 'P 15: ¿Qué fue lo primero que le fue revelado del Corán?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6180.mp3',
                'answer' => '<p> R- Al-<span class="c6">láh ﷻ dijo:</span> ﴾ ¡Lee! <span class="c5">[¡oh, Muhámmad!]</span> En el nombre de tu Señor, Quien creó todas las cosas. Creó al hombre de una célula embrionaria. ¡Lee! Que tu Señor es el más Generoso. Enseñó la escritura con la pluma y le enseñó al hombre lo que éste no sabía﴿ <span class="c2">(Traducción del Corán,<span class="c6"> 96:</span>1-5)</span> </p>',
            ],
            15 => [
                'question' => 'P 16: ¿Quiénes fueron los primeros en creer en el Mensaje?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6200.mp3',
                'answer' => '<p> R-<span class="c6"> Los primeros en creer en el mensaje del Islam en los tiempos del profeta Muhámmad ﷺ fueron:</span><br /> - De los hombres, Abu Bakr As-Siddiq.<br /> - De las mujeres, Khadiya bintu Khuwaylid.<br /> - De entre los jóvenes, Ali bin Abi Talib.<br /> - De entre los leales, Zaid bin Jaritha.<br /> - De entre los esclavos, Bilal al-Jabashi .<br /> ¡Qué Al-láh esté complacido con todos ellos! </p>',
            ],
            16 => [
                'question' => 'P 17: ¿Cómo fue el llamado al Islam?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6230.mp3',
                'answer' => '<p> R- Durante unos tres años el llamado al Islam fue en secreto, luego el profeta Muhámmad ﷺ hizo el llamado en público. </p>',
            ],
            17 => [
                'question' => 'P 18: ¿Cuál era la situación del Profeta ﷺ y de quienes creyeron en él después de la llamada al Islam?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6260.mp3',
                'answer' => '<p> R- La situación del Profeta ﷺ y de quienes creyeron en él después de la llamada al Islam era difícil, pues los politeístas exageraron en sus agravios e hicieron daño a los musulmanes, hasta que el Mensajero ﷺ le sugirió a los creyentes emigrar al reino de Nayashi en Al Jabasha <span class="c2">(Etiopia hoy en día)</span>.<br /> Los politeístas acordaron dañar y matar al Profeta ﷺ por lo que Al-láh lo protegió y lo rodeó con su tío Abu Talib para protegerlo de ellos. </p>',
            ],
            18 => [
                'question' => 'P 19: ¿Quién murió en el décimo año de la misión del Profeta ﷺ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6300.mp3',
                'answer' => '<p> R- En el décimo año de la misión del profeta Muhámmad ﷺ fallecieron su tío Abu Talib y su esposa Khadiya -que Al-láh se complazca con ella-. </p>',
            ],
            19 => [
                'question' => 'P 20: ¿Cuándo sucedió el Viaje Nocturno?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6330.mp3',
                'answer' => '<p> R- El Viaje Nocturno sucedió cuando el profeta Muhámmad ﷺ tenía cincuenta años, y allí recibió la orden de las cinco oraciones.<span class="c6"><br /> El Viaje Nocturno se comprende de dos viajes:</span><br /> Al Israa: el viaje desde la Mezquita Sagrada a la mezquita de Al-Aqsa.<br /> Al-<span class="c6">Miaaray:</span> el viaje desde la Mezquita Al-Aqsa hasta el cielo Sidrat Al-Muntaha. </p>',
            ],
            20 => [
                'question' => 'P 21: ¿Cómo invitó al Islam el Profeta ﷺ a la gente fuera de la Meca?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6380.mp3',
                'answer' => '<p> R- El profeta Muhámmad ﷺ solía invitar al Islam a la gente del pueblo de Taa-if <span class="c2">(un pueblo cerca de Meca)</span>. Además, se presentaba ante los viajeros que visitaban la ciudad y también en las reuniones, hasta que la gente de Medina Al Ansar creyeron en el Profeta ﷺ y prometieron su lealtad a él ﷺ por su apoyo. </p>',
            ],
            21 => [
                'question' => 'P 22: ¿Cuánto tiempo permaneció el profeta Muhámmad ﷺ predicando en la Meca?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6410.mp3',
                'answer' => '<p> R- El profeta Muhámmad ﷺ permaneció trece años predicando en la ciudad de la Meca. </p>',
            ],
            22 => [
                'question' => 'P 23: ¿Hacia dónde emigró el profeta Muhámmad ﷺ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6440.mp3',
                'answer' => '<p> R- El Profeta ﷺ emigró de la ciudad de la Meca a la ciudad de Medina. </p>',
            ],
            23 => [
                'question' => 'P 24: ¿Cuánto tiempo permaneció profeta Muhámmad ﷺ en la ciudad de Medina?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6470.mp3',
                'answer' => '<p> R- El Profeta ﷺ permaneció diez años en la ciudad de Medina. </p>',
            ],
            24 => [
                'question' => 'P 25: ¿Cuáles fueron las leyes del Islam reveladas en la ciudad de Medina?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6490.mp3',
                'answer' => '<p> R- Las leyes del Islam reveladas e impuestas como obligación en Medina fueron el pagar el Zakat, el ayuno, el Hayy, la yijad, el llamado a la oración y otras legislaciones islámicas. </p>',
            ],
            25 => [
                'question' => 'P 26: ¿Cuáles fueron las más importantes batallas del Profeta ﷺ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6520.mp3',
                'answer' => '<p> R-<br /> *La gran batalla de Badr.<br /> * La batalla de Uhud.<br /> * La batalla de Al Ajzab.<br /> * La conquista de la Meca. </p>',
            ],
            26 => [
                'question' => 'P 27: ¿Qué es lo último que se reveló del Corán?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6580.mp3',
                'answer' => '<p> R- Al-<span class="c6">láh ﷻ dijo:</span> ﴾Teman el día en que serán retornados a Al-láh, y en que cada persona reciba lo que merezca sin ser oprimido﴿ <span class="c2">(Traducción del Corán,<span class="c6"> 2:</span>281)</span>. </p>',
            ],
            27 => [
                'question' => 'P 28: ¿Cuándo y a qué edad murió el profeta Muhámmad ﷺ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6610.mp3',
                'answer' => '<p> R- El profeta Muhámmad ﷺ murió en el mes de Rabi’ Al-Awwal, en el año onceavo de la emigración, a la edad de sesenta y tres años. </p>',
            ],
            28 => [
                'question' => 'P 29: Nombre a las esposas del Profeta Muhámmad ﷺ.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6640.mp3',
                'answer' => '<p> R-<br /> 1- Khadiya bint Khuwaylid, que Al-láh se complazca con ella.<br /> 2- Sawdah bint Zam\'ah, que Al-láh se complazca con ella.<br /> 3- Aisha, hija de Abu Bakr Al Siddiq, que Al-láh se complazca con ella.<br /> 4- Hafsa Bint Omar, que Al-láh se complazca con ella.<br /> 5- Zainab Bint Juzaymah, que Al-láh se complazca con ella.<br /> 6- Umm Salamah Hind, hija de Abu Umayyah, que Al-láh se complazca con ella.<br /> 7- Umm Habiba Ramla, hija de Abu Sufyan, que Al-láh se complazca con ella.<br /> 8- Juwayriyah Bint Al Harith, que Al-láh se complazca con ella.<br /> 9- Maymuna Bint Al Harith, que Al-láh se complazca con ella.<br /> 10- Safiya Bint Hayyi, que Al-láh se complazca con ella.<br /> 11- Zainab Bint Jahsh, que Al-láh se complazca con ella. </p>',
            ],
            29 => [
                'question' => 'P 30: ¿Cuántos hijos tuvo el Profeta ﷺ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6760.mp3',
                'answer' => '<p> R-<span class="c6"> los hijos varones fueron tres:</span><br /> -Al-Qasim, y por eso le llamaban al Profeta ﷺ <span class="c1">“Abu Al Qasim”</span>.<br /> - Abdul-láh.<br /> - Ibrahim.<span class="c6"><br /> Las hijas:</span><br /> - Fátima.<br /> - Ruqayyah.<br /> - Umm Kulthum.<br /> - Zainab.<br /> Todos los hijos del profeta Muhámmad ﷺ fueron de Khadiya, que Al-láh se complazca con ella, excepto Ibrahim. Todos murieron antes que él ﷺ, excepto Fátima -que Al-láh se complazca con ella-, que falleció seis meses después del Mensajero ﷺ. </p>',
            ],
            30 => [
                'question' => 'P 31: Mencione algunas de las características físicas del profeta Muhámmad ﷺ.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6880.mp3',
                'answer' => '<p> R- El Profeta ﷺ era de estatura mediana, ni bajo ni alto, sino intermedio; era de piel blanca y se sonrojaba con facilidad. Tenía una barba poblada, ojos y boca grandes, cabello muy negro, hombros anchos y un olor dulce, además de su hermoso físico. </p>',
            ],
            31 => [
                'question' => 'P 32: ¿Qué le dejó el Profeta ﷺ a su comunidad?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6910.mp3',
                'answer' => '<p> R- El Profeta ﷺ le dejó a su comunidad una fuente blanca con una noche como su día <span class="c2">(muy clara)</span>, de la que nadie se desvía, excepto el perdedor. Él ﷺ no dejó ninguna cosa buena sin haberla enseñado a su comunidad, ni dejo cosa mala sin advertir contra ella. Ésta es la Sunnah del profeta Muhámmad ﷺ. </p>',
            ],
        ],
        4 => [
            0 => [
                'question' => 'P 1: Lee la surah Al-Fatihah (La Apertura/ Surah n°1) y extrae la interpretación.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6960.mp3',
                'answer' => '<p> R- Surah Al-<span class="c6">Fatihah y su interpretación:</span><br /> 1 بِسْمِ اللَّهِ الرَّحْمَنِ الرَّحِيمِ<span class="c4">﴿ الْحَمْدُ لِلَّهِ رَبِّ الْعَالَمِينَ 2 الرَّحْمَنِ الرَّحِيمِ 3 مَالِكِ يَوْمِ الدِّينِ 4 إِيَّاكَ نَعْبُدُ وَإِيَّاكَ نَسْتَعِينُ 5 اهْدِنَا الصِّرَاطَ الْمُسْتَقِيمَ 6 ﴾</span>7 صِرَاطَ الَّذِينَ أَنْعَمْتَ عَلَيْهِمْ غَيْرِ الْمَغْضُوبِ عَلَيْهِمْ وَلَا الضَّالِّينَ <span class="c2">(Noble Corán,<span class="c6"> sura Al Fatihah:</span> 1-7)</span>.<span class="c6"><br /> Interpretación:</span><br /> Se llama Sura Al-Fatihah porque es la primera sura del Noble Corán, es la sura que abre el libro de Al-láh ﷻ.<br /> 1- <span class="c4">{بِسۡمِ ٱللَّهِ ٱلرَّحۡمَٰنِ ٱلرَّحِيمِ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001001.mp3"></audio><br /> En el nombre de Al-láh, el Compasivo, el Misericordioso.<br /> Al-<span class="c6">láh:</span> es un nombre propio, exclusivo de Dios Único y Todopoderoso, Creador y Sustentador, el merecedor de toda forma de adoración, Gloria a Él.<br /> Ar-Rahman <span class="c2">(el Compasivo)</span>: es un significado más amplio de Misericordioso, abarca la misericordia que Él tiene hacia toda la creación.<br /> Ar-Rahim <span class="c2">(el Misericordioso)</span>: incluye el concepto de especificidad, es decir, una forma especial de misericordia concedida solamente a los creyentes.<br /> 2- <span class="c4">{ٱلۡحَمۡدُ لِلَّهِ رَبِّ ٱلۡعَٰلَمِينَ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001002.mp3"></audio><br /> Todas las alabanzas son para Al-láh, Señor de todo cuanto existe.<br /> 3- <span class="c4">{ٱلرَّحۡمَٰنِ ٱلرَّحِيمِ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001003.mp3"></audio><br /> El Compasivo, el Misericordioso.<span class="c6"> Esto significa:</span> el poseedor de una gran misericordia que se extiende a los creyentes.<br /> 4- <span class="c4">{مَٰلِكِ يَوۡمِ ٱلدِّينِ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001004.mp3"></audio> <br /> Soberano del Día del Juicio Final <span class="c2">(el Día de la Resurrección)</span>.<br /> 5- <span class="c4">{إِيَّاكَ نَعۡبُدُ وَإِيَّاكَ نَسۡتَعِينُ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001005.mp3"></audio> <br /> Solo a Ti te adoramos y solo de Ti imploramos ayuda.<br /> 6- <span class="c4">{ٱهۡدِنَا ٱلصِّرَٰطَ ٱلۡمُسۡتَقِيمَ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001006.mp3"></audio><br /> ¡Guíanos por el camino recto! <span class="c2">(el camino del Islam y la Sunnah)</span>.<br /> 7- <span class="c4">{صِرَٰطَ ٱلَّذِينَ أَنۡعَمۡتَ عَلَيۡهِمۡ غَيۡرِ ٱلۡمَغۡضُوبِ عَلَيۡهِمۡ وَلَا ٱلضَّآلِّينَ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001007.mp3"></audio><br /> El camino de los que has colmado con Tus favores, no el de los que cayeron en Tu ira, ni el de los que se extraviaron <span class="c2">(como los cristianos y judíos)</span>.<span class="c6"><br /> Es Sunnah que luego de leer esta surah se diga:</span> "Amin <span class="c2">(Amén)</span>". </p>',
            ],
            1 => [
                'question' => 'P 2: Lee la surah Al-Zalzalah (el Terremoto/ Surah n° 99) y presenta su interpretación.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7130.mp3',
                'answer' => '<p> R-Surah Al-<span class="c6">Zalzalah y su interpretación:</span><br /> ﷽<br /> إِذَا زُلْزِلَتِ الْأَرْضُ زِلْزَالَهَا 1<span class="c4">﴿ وَأَخْرَجَتِ الْأَرْضُ أَثْقَالَهَا 2 وَقَالَ الْإِنْسَانُ مَا لَهَا 3 يَوْمَئِذٍ تُحَدِّثُ أَخْبَارَهَا 4 بِأَنَّ رَبَّكَ أَوْحَى لَهَا 5 يَوْمَئِذٍ يَصْدُرُ النَّاسُ أَشْتَاتًا لِيُرَوْا أَعْمَالَهُمْ 6 7 فَمَنْ يَعْمَلْ مِثْقَالَ ذَرَّةٍ خَيْرًا يَرَهُ ﴾</span> 8 وَمَنْ يَعْمَلْ مِثْقَالَ ذَرَّةٍ شَرًّا يَرَهُ <span class="c2">(Noble Corán, sura Al-<span class="c6">Zalzalah:</span> 1-8)</span>.<span class="c6"><br /> Interpretación:</span><br /> 1- <span class="c4">{إِذَا زُلۡزِلَتِ ٱلۡأَرۡضُ زِلۡزَالَهَا}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099001.mp3"></audio><br /> Cuando la Tierra sea sacudida por el gran terremoto,<br /> 2- <span class="c4">{وَأَخۡرَجَتِ ٱلۡأَرۡضُ أَثۡقَالَهَا}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099002.mp3"></audio><br /> y expulse su carga <span class="c5">[haciendo surgir a los muertos de sus tumbas]</span>,<br /> 3- <span class="c4">{وَقَالَ ٱلۡإِنسَٰنُ مَا لَهَا}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099003.mp3"></audio><br /> y el hombre diga: <span class="c1">“¿Qué le sucede a la Tierra?”</span><br /> 4- <span class="c4">{يَوۡمَئِذٖ تُحَدِّثُ أَخۡبَارَهَا}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099004.mp3"></audio><br /> Ese día, la Tierra dará testimonio de todo cuanto sucedió sobre ella,<br /> 5- <span class="c4">{بِأَنَّ رَبَّكَ أَوۡحَىٰ لَهَا}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099005.mp3"></audio><br /> por orden de su Señor.<br /> 6- <span class="c4">{يَوۡمَئِذٖ يَصۡدُرُ ٱلنَّاسُ أَشۡتَاتٗا لِّيُرَوۡاْ أَعۡمَٰلَهُمۡ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099006.mp3"></audio><br /> Entonces, los seres humanos acudirán al Día del Juicio en grupos para conocer el resultado de sus obras.<br /> 7- <span class="c4">{فَمَن يَعۡمَلۡ مِثۡقَالَ ذَرَّةٍ خَيۡرٗا يَرَهُۥ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099007.mp3"></audio><br /> Quien haya realizado una obra de bien, aunque sea tan pequeña como un átomo, la encontrará registrada.<br /> 8- <span class="c4">{وَمَن يَعۡمَلۡ مِثۡقَالَ ذَرَّةٖ شَرّٗا يَرَهُۥۥ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099008.mp3"></audio><br /> Y quien haya realizado una mala obra, tan pequeña como un átomo, la encontrará registrada. </p>',
            ],
            2 => [
                'question' => 'P 3: Lee la sura Al-Ádiyat (Los Corceles/ Sura n° 100) y presenta la interpretación.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7270.mp3',
                'answer' => '<p> R- Surah Al-<span class="c6">Adiyat y su interpretación:</span><br /> ﷽<br /> وَالْعَادِيَاتِ ضَبْحًا 1<span class="c4">﴿ فَالْمُورِيَاتِ قَدْحًا 2 فَالْمُغِيرَاتِ صُبْحًا 3 فَأَثَرْنَ بِهِ نَقْعًا 4 فَوَسَطْنَ بِهِ جَمْعًا 5 إِنَّ الْإِنْسَانَ لِرَبِّهِ لَكَنُودٌ 6 وَإِنَّهُ عَلَى ذَلِكَ لَشَهِيدٌ 7 وَإِنَّهُ لِحُبِّ الْخَيْرِ لَشَدِيدٌ 8 أَفَلَا يَعْلَمُ إِذَا بُعْثِرَ مَا فِي الْقُبُورِ 9 وَحُصِّلَ مَا فِي الصُّدُورِ 10 ﴾</span>11إِنَّ رَبَّهُمْ بِهِمْ يَوْمَئِذٍ لَخَبِيرٌ <span class="c2">(Noble Corán, surat Al-<span class="c6">Adiyat:</span> 1-11)</span>.<span class="c6"><br /> Interpretación:</span><br /> 1- <span class="c4">{وَٱلۡعَٰدِيَٰتِ ضَبۡحٗا}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100001.mp3"></audio> <br /> Juro por los corceles que se lanzan relinchando<br /> 2- <span class="c4">{فَٱلۡمُورِيَٰتِ قَدۡحٗا}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100002.mp3"></audio> <br /> y arrancan chispas con sus cascos<br /> 3- <span class="c4">{فَٱلۡمُغِيرَٰتِ صُبۡحٗا}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100003.mp3"></audio><br /> y sorprenden al amanecer<br /> 4- <span class="c4">{فَأَثَرۡنَ بِهِۦ نَقۡعٗا}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100004.mp3"></audio><br /> levantando una nube de polvo,<br /> 5- <span class="c4">{فَوَسَطۡنَ بِهِۦ جَمۡعًا}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100005.mp3"></audio> <br /> e irrumpiendo conjuntamente en las filas del enemigo,<br /> 6- <span class="c4">{إِنَّ ٱلۡإِنسَٰنَ لِرَبِّهِۦ لَكَنُودٞ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100006.mp3"></audio> <br /> que el ser humano es ingrato con el bien recibido por parte de su Señor.<br /> 7- <span class="c4">{وَإِنَّهُۥ عَلَىٰ ذَٰلِكَ لَشَهِيدٞ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100007.mp3"></audio> <br /> Y él mismo es testigo de ello,<br /> 8- <span class="c4">{وَإِنَّهُۥ لِحُبِّ ٱلۡخَيۡرِ لَشَدِيدٌ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100008.mp3"></audio> <br /> porque tiene una codicia apasionada por los bienes materiales.<br /> 9- <span class="c4">{أَفَلَا يَعۡلَمُ إِذَا بُعۡثِرَ مَا فِي ٱلۡقُبُورِ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100009.mp3"></audio> <br /> ¿Acaso no sabe que cuando se haga surgir a quienes están en las sepulturas<br /> 10- <span class="c4">{وَحُصِّلَ مَا فِي ٱلصُّدُورِ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100010.mp3"></audio> <br /> y se evidencie lo que hay en los corazones,<br /> 11- <span class="c4">{إِنَّ رَبَّهُم بِهِمۡ يَوۡمَئِذٖ لَّخَبِيرُۢ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100011.mp3"></audio><br /> ese día su Señor estará bien informado de lo que hicieron? </p>',
            ],
            3 => [
                'question' => 'P 4: Lee la surah Al-Qari\'ah (El Evento Repentino/ Surah n° 101) y extrae su interpretación.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7450.mp3',
                'answer' => '<p> R- Surah Al-<span class="c6">Qari’ah y su interpretación:</span><br /> ﷽<br /> الْقَارِعَةُ 1<span class="c4">﴿ مَا الْقَارِعَةُ 2 وَمَا أَدْرَاكَ مَا الْقَارِعَةُ 3 يَوْمَ يَكُونُ النَّاسُ كَالْفَرَاشِ الْمَبْثُوثِ 4 وَتَكُونُ الْجِبَالُ كَالْعِهْنِ الْمَنْفُوشِ 5 فَأَمَّا مَنْ ثَقُلَتْ مَوَازِينُهُ 6 فَهُوَ فِي عِيشَةٍ رَاضِيَةٍ 7 وَأَمَّا مَنْ خَفَّتْ مَوَازِينُهُ 8 فَأُمُّهُ هَاوِيَةٌ 9 وَمَا أَدْرَاكَ مَا هِيَهْ 10 ﴾</span>11 نَارٌ حَامِيَةٌ <span class="c2">(Noble Corán, surah Al-<span class="c6">Qari\'ah:</span> 1-11)</span>.<span class="c6"><br /> Interpretación:</span><br /> 1- <span class="c4">{ٱلۡقَارِعَةُ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101001.mp3"></audio> <br /> El evento repentino.<br /> 2- <span class="c4">{مَا ٱلۡقَارِعَةُ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101002.mp3"></audio> <br /> ¿Qué es el evento repentino?<br /> 3- <span class="c4">{وَمَآ أَدۡرَىٰكَ مَا ٱلۡقَارِعَةُ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101003.mp3"></audio> <br /> ¿Y qué te hará comprender la magnitud del evento repentino?<br /> 4- <span class="c4">{يَوۡمَ يَكُونُ ٱلنَّاسُ كَٱلۡفَرَاشِ ٱلۡمَبۡثُوثِ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101004.mp3"></audio> <br /> Ese día la gente parecerá mariposas dispersas,<br /> 5- <span class="c4">{وَتَكُونُ ٱلۡجِبَالُ كَٱلۡعِهۡنِ ٱلۡمَنفُوشِ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101005.mp3"></audio><br /> y las montañas copos de lana cardada.<br /> 6- <span class="c4">{فَأَمَّا مَن ثَقُلَتۡ مَوَٰزِينُهُۥ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101006.mp3"></audio> <br /> Aquel cuyas obras buenas sean más pesadas en la balanza<br /> 7- <span class="c4">{فَهُوَ فِي عِيشَةٖ رَّاضِيَةٖ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101007.mp3"></audio> <br /> gozará de una vida placentera <span class="c2">(en el Paraíso)</span>.<br /> 8- <span class="c4">{وَأَمَّا مَنۡ خَفَّتۡ مَوَٰزِينُهُۥ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101008.mp3"></audio><br /> En cambio, aquel cuyas obras buenas sean más livianas en la balanza,<br /> 9- <span class="c4">{فَأُمُّهُۥ هَاوِيَةٞ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101009.mp3"></audio> <br /> su morada estará en el abismo <span class="c2">(el Infierno)</span>.<br /> 10- <span class="c4">{وَمَآ أَدۡرَىٰكَ مَا هِيَهۡ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101010.mp3"></audio> <br /> <br /> ¿Y qué te hará comprender qué es el abismo?<br /> 11- <span class="c4">{نَارٌ حَامِيَةُۢ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101011.mp3"></audio> <br /> Es un fuego abrasador. </p>',
            ],
            4 => [
                'question' => 'P 5: Lee la surah Al-Takathur (La acumulación/Surah n° 102) y extrae su interpretación.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7610.mp3',
                'answer' => '<p> R- Surah At-<span class="c6">Takathur y su interpretación:</span><br /> ﷽<br /> أَلْهَاكُمُ التَّكَاثُرُ 1<span class="c4">﴿ حَتَّى زُرْتُمُ الْمَقَابِرَ 2 كَلَّا سَوْفَ تَعْلَمُونَ 3 ثُمَّ كَلَّا سَوْفَ تَعْلَمُونَ 4 كَلَّا لَوْ تَعْلَمُونَ عِلْمَ الْيَقِينِ 5 لَتَرَوُنَّ الْجَحِيمَ 6 ثُمَّ لَتَرَوُنَّهَا عَيْنَ الْيَقِينِ 7 ﴾</span>8 ثُمَّ لَتُسْأَلُنَّ يَوْمَئِذٍ عَنِ النَّعِيمِ <span class="c2">(Noble Corán, surah Al-<span class="c6">Takathur:</span> 1-8)</span>.<span class="c6"><br /> La interpretación:</span><br /> 1- <span class="c4">{أَلۡهَىٰكُمُ ٱلتَّكَاثُرُ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102001.mp3"></audio> <br /> El afán de tener más y más los domina<br /> 2- <span class="c4">{حَتَّىٰ زُرۡتُمُ ٱلۡمَقَابِرَ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102002.mp3"></audio> <br /> hasta que la muerte los sorprenda y entren en la tumba.<br /> 3- <span class="c4">{كَلَّا سَوۡفَ تَعۡلَمُونَ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102003.mp3"></audio><br /> ¡No deberían comportarse así! Ya se van a enterar <span class="c5">[que obrar para la otra vida es superior]</span>.<br /> 4- <span class="c4">{ثُمَّ كَلَّا سَوۡفَ تَعۡلَمُونَ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102004.mp3"></audio> <br /> Una vez más: ¡No deberían comportarse así! Ya se van a enterar <span class="c5">[que obrar para la otra vida es superior]</span>.<br /> 5- <span class="c4">{كَلَّا لَوۡ تَعۡلَمُونَ عِلۡمَ ٱلۡيَقِينِ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102005.mp3"></audio><br /> Si hubieran sabido con certeza <span class="c5">[el castigo de quienes consumen su vida en el afán de tener más y más, habrían cambiado el rumbo de sus vidas]</span>.<br /> 6- <span class="c4">{لَتَرَوُنَّ ٱلۡجَحِيمَ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102006.mp3"></audio> <br /> Habrán de ver el fuego del Infierno,<br /> 7- <span class="c4">{ثُمَّ لَتَرَوُنَّهَا عَيۡنَ ٱلۡيَقِينِ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102007.mp3"></audio><br /> y lo verán con los ojos de la certeza.<br /> 8- <span class="c4">{ثُمَّ لَتُسۡـَٔلُنَّ يَوۡمَئِذٍ عَنِ ٱلنَّعِيمِ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102008.mp3"></audio><br /> Luego, ese día <span class="c5">[del Juicio]</span> se les preguntará por cada bendición que recibieron <span class="c5">[durante la vida mundanal]</span>. </p>',
            ],
            5 => [
                'question' => 'P 6: Lee la surah Al-Asr (el Tiempo/ Surah n°103) y extrae su interpretación.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7750.mp3',
                'answer' => '<p> R- Surah Al-<span class="c6">Asr y su interpretación:</span><br /> ﷽<br /> وَالْعَصْرِ 1<span class="c4">﴿ إِنَّ الْإِنْسَانَ لَفِي خُسْرٍ 2 ﴾</span>3 إِلَّا الَّذِينَ آمَنُوا وَعَمِلُوا الصَّالِحَاتِ وَتَوَاصَوْا بِالْحَقِّ وَتَوَاصَوْا بِالصَّبْرِ <span class="c2">(Noble Corán, surah Al-<span class="c6">Asr:</span> 1-3)</span>.<span class="c6"><br /> La interpretación:</span><br /> 1- <span class="c4">{وَٱلۡعَصۡرِ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/103001.mp3"></audio> <br /> Juro por el tiempo<br /> 2- <span class="c4">{إِنَّ ٱلۡإِنسَٰنَ لَفِي خُسۡرٍ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/103002.mp3"></audio> <br /> que los seres humanos están en la perdición,<br /> 3- <span class="c4">{إِلَّا ٱلَّذِينَ ءَامَنُواْ وَعَمِلُواْ ٱلصَّٰلِحَٰتِ وَتَوَاصَوۡاْ بِٱلۡحَقِّ وَتَوَاصَوۡاْ بِٱلصَّبۡرِ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/103003.mp3"></audio><br /> excepto aquellos que crean, obren rectamente, y se aconsejen mutuamente con la verdad y con la paciencia <span class="c5">[ante las adversidades]</span>. </p>',
            ],
            6 => [
                'question' => 'P 7: Lee la surah Al-Jumazah (El Difamador/ Surah n.º 104) y extrae la interpretación.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7830.mp3',
                'answer' => '<p> R- Surah Al-<span class="c6">Jumazah y su interpretación:</span><br /> ﷽<br /> وَيْلٌ لِكُلِّ هُمَزَةٍ لُمَزَةٍ 1<span class="c4">﴿ الَّذِي جَمَعَ مَالًا وَعَدَّدَهُ 2 يَحْسَبُ أَنَّ مَالَهُ أَخْلَدَهُ 3 كَلَّا لَيُنْبَذَنَّ فِي الْحُطَمَةِ 4 وَمَا أَدْرَاكَ مَا الْحُطَمَةُ 5 نَارُ اللَّهِ الْمُوقَدَةُ 6 الَّتِي تَطَّلِعُ عَلَى الْأَفْئِدَةِ 7 إِنَّهَا عَلَيْهِمْ مُؤْصَدَةٌ 8 ﴾</span>9 فِي عَمَدٍ مُمَدَّدَةٍ <span class="c2">(Noble Corán, surah Al-<span class="c6">Jumazah:</span> 1-9)</span>.<span class="c6"><br /> La interpretación:</span><br /> 1- <span class="c4">{وَيۡلٞ لِّكُلِّ هُمَزَةٖ لُّمَزَةٍ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104001.mp3"></audio><br /> ¡Ay del castigo que les aguarda al difamador y al calumniador,<br /> 2- <span class="c4">{ٱلَّذِي جَمَعَ مَالٗا وَعَدَّدَهُۥ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104002.mp3"></audio> <br /> al que acumula bienes materiales y los cuenta una y otra vez,<br /> 3- <span class="c4">{يَحۡسَبُ أَنَّ مَالَهُۥٓ أَخۡلَدَهُۥ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104003.mp3"></audio><br /> creyendo que su riqueza lo hará vivir eternamente!<br /> 4- <span class="c4">{كَلَّاۖ لَيُنۢبَذَنَّ فِي ٱلۡحُطَمَةِۥ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104004.mp3"></audio> <br /> Por el contrario, serán arrojados en un fuego demoledor.<br /> 5- <span class="c4">{وَمَآ أَدۡرَىٰكَ مَا ٱلۡحُطَمَةُ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104005.mp3"></audio> <br /> ¿Y qué te hará comprender lo que es un fuego demoledor?<br /> 6- <span class="c4">{نَارُ ٱللَّهِ ٱلۡمُوقَدَةُ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104006.mp3"></audio> <br /> Es un fuego encendido por Al-láh.<br /> 7- <span class="c4">{ٱلَّتِي تَطَّلِعُ عَلَى ٱلۡأَفۡـِٔدَةِ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104007.mp3"></audio><br /> cuyo dolor alcanza los corazones.<br /> 8- <span class="c4">{إِنَّهَا عَلَيۡهِم مُّؤۡصَدَةٞ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104008.mp3"></audio> <br /> El Infierno se cerrará en torno a ellos<br /> 9- <span class="c4">{فِي عَمَدٖ مُّمَدَّدَةِۭ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104009.mp3"></audio> <br /> con columnas inmensas. </p>',
            ],
            7 => [
                'question' => 'P 8: Lee la surah Al-Fil (El Elefante/ Surah n° 105) y extrae la interpretación.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7970.mp3',
                'answer' => '<p> R- Surah Al-<span class="c6">Fil y su interpretación:</span><br /> ﷽<br /> أَلَمْ تَرَ كَيْفَ فَعَلَ رَبُّكَ بِأَصْحَابِ الْفِيلِ 1<span class="c4">﴿ أَلَمْ يَجْعَلْ كَيْدَهُمْ فِي تَضْلِيلٍ 2 وَأَرْسَلَ عَلَيْهِمْ طَيْرًا أَبَابِيلَ 3 تَرْمِيهِمْ بِحِجَارَةٍ مِنْ سِجِّيلٍ 4 ﴾</span>5 فَجَعَلَهُمْ كَعَصْفٍ مَأْكُولٍ <span class="c2">(Noble Corán, surah Al-<span class="c6">Fil:</span> 1-5)</span>.<span class="c6"><br /> La interpretación:</span><br /> 1- <span class="c4">{أَلَمۡ تَرَ كَيۡفَ فَعَلَ رَبُّكَ بِأَصۡحَٰبِ ٱلۡفِيلِ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105001.mp3"></audio><br /> ¿No has observado lo que hizo tu Señor con el ejército del elefante?<br /> 2- <span class="c4">{أَلَمۡ يَجۡعَلۡ كَيۡدَهُمۡ فِي تَضۡلِيلٖ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105002.mp3"></audio><br /> ¿No has visto cómo desbarató sus planes <span class="c5">[de destruir la Ka‘bah]</span>?<br /> 3- <span class="c4">{وَأَرۡسَلَ عَلَيۡهِمۡ طَيۡرًا أَبَابِيلَ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105003.mp3"></audio> <br /> Y envió sobre ellos bandadas de aves<br /> 4- <span class="c4">{تَرۡمِيهِم بِحِجَارَةٖ مِّن سِجِّيلٖ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105004.mp3"></audio> <br /> que les arrojaron piedras de arcilla dura,<br /> 5- <span class="c4">{فَجَعَلَهُمۡ كَعَصۡفٖ مَّأۡكُولِۭ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105005.mp3"></audio> <br /> y los dejó como heno carcomido. </p>',
            ],
            8 => [
                'question' => 'P 9: Lee la surah Quraish (La Tribu de Quraish/ Surah n.º 106) y extrae la interpretación.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8070.mp3',
                'answer' => '<p> R-<span class="c6"> Surah Quraish y su interpretación:</span><br /> ﷽<br /> لِإِيلَافِ قُرَيْشٍ 1<span class="c4">﴿ إِيلَافِهِمْ رِحْلَةَ الشِّتَاءِ وَالصَّيْفِ 2 فَلْيَعْبُدُوا رَبَّ هَذَا الْبَيْتِ 3 ﴾</span>4 الَّذِي أَطْعَمَهُمْ مِنْ جُوعٍ وَآمَنَهُمْ مِنْ خَوْفٍ <span class="c2">(Noble Corán,<span class="c6"> surah Quraish:</span> 1-4)</span>.<span class="c6"><br /> La interpretación:</span><br /> 1- <span class="c4">{لِإِيلَٰفِ قُرَيۡشٍ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106001.mp3"></audio><br /> Le proporcioné seguridad a <span class="c5">[la tribu de]</span> Quraish,<br /> 2- <span class="c4">{إِۦلَٰفِهِمۡ رِحۡلَةَ ٱلشِّتَآءِ وَٱلصَّيۡفِ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106002.mp3"></audio> <br /> e hice que sus caravanas en invierno <span class="c5">[al Yemen]</span> y en verano <span class="c5">[a Siria]</span> fueran respetadas.<br /> 3- <span class="c4">{فَلۡيَعۡبُدُواْ رَبَّ هَٰذَا ٱلۡبَيۡتِ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106003.mp3"></audio> <br /> Que adoren y agradezcan, en consecuencia, al Señor de esta Casa <span class="c5">[la Ka‘bah]</span>,<br /> 4- <span class="c4">{ٱلَّذِيٓ أَطۡعَمَهُم مِّن جُوعٖ وَءَامَنَهُم مِّنۡ خَوۡفِۭ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106004.mp3"></audio> <br /> Quien les concedió el sustento para que no sufrieran hambre y les dio seguridad para protegerlos del peligro. </p>',
            ],
            9 => [
                'question' => 'P 10: Lee la surah Al-Ma\'un (La Ayuda Mínima/ Surah n.º 107) y extrae su interpretación.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8160.mp3',
                'answer' => '<p> R- Surah Al-<span class="c6">Ma\'un y su interpretación:</span><br /> ﷽<br /> أَرَأَيْتَ الَّذِي يُكَذِّبُ بِالدِّينِ 1<span class="c4">﴿ فَذَلِكَ الَّذِي يَدُعُّ الْيَتِيمَ 2 وَلَا يَحُضُّ عَلَى طَعَامِ الْمِسْكِينِ 3 فَوَيْلٌ لِلْمُصَلِّينَ 4 الَّذِينَ هُمْ عَنْ صَلَاتِهِمْ سَاهُونَ 5 الَّذِينَ هُمْ يُرَاءُونَ 6 ﴾</span>7 وَيَمْنَعُونَ الْمَاعُونَ <span class="c2">(Noble Corán, surah Al-<span class="c6">Ma\'un:</span> 1-7)</span>.<span class="c6"><br /> La interpretación:</span><br /> 1- <span class="c4">{أَرَءَيۡتَ ٱلَّذِي يُكَذِّبُ بِٱلدِّينِ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107001.mp3"></audio> <br /> ¿Acaso has observado a quien desmiente el Día del Juicio?<br /> 2- <span class="c4">{فَذَٰلِكَ ٱلَّذِي يَدُعُّ ٱلۡيَتِيمَ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107002.mp3"></audio> <br /> Es quien rechaza al huérfano<br /> 3- <span class="c4">{وَلَا يَحُضُّ عَلَىٰ طَعَامِ ٱلۡمِسۡكِينِ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107003.mp3"></audio><br /> y no exhorta a alimentar al pobre.<br /> 4- <span class="c4">{فَوَيۡلٞ لِّلۡمُصَلِّينَ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107004.mp3"></audio> <br /> ¡Ay de los orantes<br /> 5- <span class="c4">{ٱلَّذِينَ هُمۡ عَن صَلَاتِهِمۡ سَاهُونَ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107005.mp3"></audio> <br /> que son negligentes en sus oraciones realizándolas fuera de su horario],<br /> 6- <span class="c4">{ٱلَّذِينَ هُمۡ يُرَآءُونَ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107006.mp3"></audio> <br /> y solo las realizan para hacerse ver,<br /> 7- <span class="c4">{وَيَمۡنَعُونَ ٱلۡمَاعُونَ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107007.mp3"></audio> <br /> y se niegan a prestar hasta la mínima ayuda! </p>',
            ],
            10 => [
                'question' => 'P 11: Lee la surah Al-Kawthar (La Abundancia/ Surah n.º 108) y extrae la interpretación.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8280.mp3',
                'answer' => '<p> R- Surah Al-<span class="c6">Kawthar y su interpretación:</span><br /> ﷽<br /> إِنَّا أَعْطَيْنَاكَ الْكَوْثَرَ 1<span class="c4">﴿ فَصَلِّ لِرَبِّكَ وَانْحَرْ 2 ﴾</span>3 إِنَّ شَانِئَكَ هُوَ الْأَبْتَرُ <span class="c2">(Noble Corán, surah Al-<span class="c6">Kawthar:</span> 1-3)</span>.<span class="c6"><br /> La interpretación:</span><br /> 1- <span class="c4">{إِنَّآ أَعۡطَيۡنَٰكَ ٱلۡكَوۡثَرَ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/108001.mp3"></audio><br /> <span class="c5">[¡Oh, Muhámmad!]</span> te he agraciado con la abundancia.<br /> 2- <span class="c4">{فَصَلِّ لِرَبِّكَ وَٱنۡحَرۡ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/108002.mp3"></audio><br /> Reza a tu Señor y sacrifica <span class="c5">[los animales en Su nombre]</span>.<br /> 3- <span class="c4">{إِنَّ شَانِئَكَ هُوَ ٱلۡأَبۡتَرُ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/108003.mp3"></audio><br /> Porque a quien te desdeñe y odie le privaré de todo bien. </p>',
            ],
            11 => [
                'question' => 'P 12: Lee la surah Al-Kafirun (Los Incrédulos/ Surah n.º 109) y extrae la interpretación.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8360.mp3',
                'answer' => '<p> R- Surah Al-<span class="c6">Kafirun y su interpretación:</span><br /> ﷽<br /> قُلْ يَا أَيُّهَا الْكَافِرُونَ 1<span class="c4">﴿ لَا أَعْبُدُ مَا تَعْبُدُونَ 2 وَلَا أَنْتُمْ عَابِدُونَ مَا أَعْبُدُ 3 وَلَا أَنَا عَابِدٌ مَا عَبَدْتُمْ 4 وَلَا أَنْتُمْ عَابِدُونَ مَا أَعْبُدُ 5 ﴾</span>6 لَكُمْ دِينُكُمْ وَلِيَ دِينِ <span class="c2">(Noble Corán, surah Al-<span class="c6">Kafirun:</span> 1-6)</span><br /> Interpretación:<br /> 1- <span class="c4">{قُلۡ يَٰٓأَيُّهَا ٱلۡكَٰفِرُونَ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109001.mp3"></audio><br /> Di: <span class="c1">“¡Oh, incrédulos!<br /> 2- <span class="c4">{لَآ أَعۡبُدُ مَا تَعۡبُدُونَ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109002.mp3"></audio> <br /> No adoro lo que adoran.<br /> 3- <span class="c4">{وَلَآ أَنتُمۡ عَٰبِدُونَ مَآ أَعۡبُدُ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109003.mp3"></audio><br /> Ni adoran ustedes a Quien yo adoro.<br /> 4- <span class="c4">{وَلَآ أَنَا۠ عَابِدٞ مَّا عَبَدتُّمۡ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109004.mp3"></audio><br /> Y jamás adoraré lo que adoran.<br /> 5- <span class="c4">{وَلَآ أَنتُمۡ عَٰبِدُونَ مَآ أَعۡبُدُ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109005.mp3"></audio> <br /> Ni adorarán ustedes a Quien yo adoro.<br /> 6- <span class="c4">{لَكُمۡ دِينُكُمۡ وَلِيَ دِينِ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109006.mp3"></audio><br /> Ustedes tienen su religión y yo la mía”</span>. </p>',
            ],
            12 => [
                'question' => 'P 13: Lee la surah Al-Nasr (El Socorro/ Surah n° 110) y extrae la interpretación.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8470.mp3',
                'answer' => '<p> R- Surah Al-<span class="c6">Nasr y su interpretación:</span><br /> ﷽<br /> إِذَا جَاءَ نَصْرُ اللَّهِ وَالْفَتْحُ 1<span class="c4">﴿ وَرَأَيْتَ النَّاسَ يَدْخُلُونَ فِي دِينِ اللَّهِ أَفْوَاجًا 2 ﴾</span>3 فَسَبِّحْ بِحَمْدِ رَبِّكَ وَاسْتَغْفِرْهُ إِنَّهُ كَانَ تَوَّابًا <span class="c2">(Noble Corán, surah Al-<span class="c6"> Nasr:</span> 1-3)</span>.<span class="c6"><br /> Interpretación:</span><br /> 1- <span class="c4">{إِذَا جَآءَ نَصۡرُ ٱللَّهِ وَٱلۡفَتۡحُ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/110001.mp3"></audio><br /> <span class="c5">[¡Oh, Muhámmad!]</span> Cuando llegue el socorro de Al-láh y la victoria,<br /> 2- <span class="c4">{وَرَأَيۡتَ ٱلنَّاسَ يَدۡخُلُونَ فِي دِينِ ٱللَّهِ أَفۡوَاجٗا}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/110002.mp3"></audio><br /> y veas a la gente ingresar en masa a la religión de Al-láh,<br /> 3- <span class="c4">{فَسَبِّحۡ بِحَمۡدِ رَبِّكَ وَٱسۡتَغۡفِرۡهُۚ إِنَّهُۥ كَانَ تَوَّابَۢا}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/110003.mp3"></audio><br /> glorifica alabando a tu Señor y pide Su perdón; Él es Indulgente. </p>',
            ],
            13 => [
                'question' => 'P 14: Lee la surah Al-Masad (Las Fibras de Palmera/ Surah n°111) y extrae su interpretación.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8550.mp3',
                'answer' => '<p> R- Surah Al-<span class="c6">Masad y su interpretación:</span><br /> ﷽<br /> تَبَّتْ يَدَا أَبِي لَهَبٍ وَتَبَّ 1<span class="c4">﴿ مَا أَغْنَى عَنْهُ مَالُهُ وَمَا كَسَبَ 2 سَيَصْلَى نَارًا ذَاتَ لَهَبٍ 3 وَامْرَأَتُهُ حَمَّالَةَ الْحَطَبِ 4 ﴾</span>5 فِي جِيدِهَا حَبْلٌ مِنْ مَسَدٍ <span class="c2">(Noble Corán, surah Al-<span class="c6"> Masad:</span> 1-5)</span>.<span class="c6"><br /> Interpretación:</span><br /> 1- <span class="c4">{تَبَّتۡ يَدَآ أَبِي لَهَبٖ وَتَبَّ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111001.mp3"></audio> <br /> ¡Maldito sea Abu Lahab y que perezca!<br /> 2- <span class="c4">{مَآ أَغۡنَىٰ عَنۡهُ مَالُهُۥ وَمَا كَسَبَ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111002.mp3"></audio> <br /> No le servirán de nada su poder ni sus bienes materiales.<br /> 3- <span class="c4">{سَيَصۡلَىٰ نَارٗا ذَاتَ لَهَبٖ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111003.mp3"></audio> <br /> Será arrojado en el fuego llameante<br /> 4- <span class="c4">{وَٱمۡرَأَتُهُۥ حَمَّالَةَ ٱلۡحَطَبِ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111004.mp3"></audio> <br /> junto con su mujer, la que acarreaba espinas,<br /> 5- <span class="c4">{فِي جِيدِهَا حَبۡلٞ مِّن مَّسَدِۭ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111005.mp3"></audio> <br /> que llevará en su cuello una cuerda de fibras de palmera <span class="c2">(con la que será conducida al Fuego)</span>. </p>',
            ],
            14 => [
                'question' => 'P 15: Lee la surah Al-Ikhlas (El Monoteísmo Puro/ Surah n°112) y extrae la interpretación.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8650.mp3',
                'answer' => '<p> R- Surah Al-<span class="c6">Ikhlas y su interpretación:</span><br /> ﷽<br /> قُلْ هُوَ اللَّهُ أَحَدٌ 1<span class="c4">﴿ اللَّهُ الصَّمَدُ 2 لَمْ يَلِدْ وَلَمْ يُولَدْ 3 ﴾</span>4 وَلَمْ يَكُنْ لَهُ كُفُوًا أَحَدٌ <span class="c2">(Noble Corán,<span class="c6"> surah Al Ikhlas:</span> 1-4)</span>.<span class="c6"><br /> Interpretación:</span><br /> 1- <span class="c4">{قُلۡ هُوَ ٱللَّهُ أَحَدٌ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112001.mp3"></audio><br /> Di: <span class="c1">“Él es Al-lah, Uno.<br /> 2- <span class="c4">{ٱللَّهُ ٱلصَّمَدُ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112002.mp3"></audio><br /> Al-láh es el Absoluto <span class="c2">(De Quien todos necesitan, mientras que Él no necesita de nadie)</span>.<br /> 3- <span class="c4">{لَمۡ يَلِدۡ وَلَمۡ يُولَدۡ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112003.mp3"></audio><br /> No engendró ni fue engendrado.<br /> 4- <span class="c4">{وَلَمۡ يَكُن لَّهُۥ كُفُوًا أَحَدُۢ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112004.mp3"></audio> <br /> Y no hay nada ni nadie que sea semejante a Él”</span>. </p>',
            ],
            15 => [
                'question' => 'P 16: Lee la surah Al-Falaq (El Amanecer/Surah n.º 113) y extrae la interpretación.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8750.mp3',
                'answer' => '<p> R- Surah Al-<span class="c6">Falaq y su interpretación:</span><br /> ﷽<br /> قُلْ أَعُوذُ بِرَبِّ الْفَلَقِ 1<span class="c4">﴿ مِنْ شَرِّ مَا خَلَقَ 2 وَمِنْ شَرِّ غَاسِقٍ إِذَا وَقَبَ 3 وَمِنْ شَرِّ النَّفَّاثَاتِ فِي الْعُقَدِ 4 ﴾</span>5 وَمِنْ شَرِّ حَاسِدٍ إِذَا حَسَدَ <span class="c2">(Noble Corán, surah Al-<span class="c6"> Falaq:</span> 1-5)</span>.<span class="c6"><br /> Interpretación:</span><br /> 1- <span class="c4">{قُلۡ أَعُوذُ بِرَبِّ ٱلۡفَلَقِ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113001.mp3"></audio> <br /> Di: <span class="c1">“Me refugio en el Señor del amanecer,<br /> 2- <span class="c4">{مِن شَرِّ مَا خَلَقَ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113002.mp3"></audio> <br /> de todo el mal que existe en lo que Él creó,<br /> 3- <span class="c4">{وَمِن شَرِّ غَاسِقٍ إِذَا وَقَبَ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113003.mp3"></audio> <br /> del mal de la oscuridad de la noche cuando se extiende <span class="c2">(como las fieras o los ladrones)</span><br /> 4- <span class="c4">{وَمِن شَرِّ ٱلنَّفَّٰثَٰتِ فِي ٱلۡعُقَدِ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113004.mp3"></audio> <br /> del mal de las <span class="c5">[hechiceras]</span> sopladoras de nudos,<br /> 5- <span class="c4">{وَمِن شَرِّ حَاسِدٍ إِذَا حَسَدَ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113005.mp3"></audio> <br /> y del mal del envidioso cuando envidia”</span>. </p>',
            ],
            16 => [
                'question' => 'P 17: Lee la surah An-Nas (Los Seres Humanos/ Surah n°114) y extrae la interpretación.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8870.mp3',
                'answer' => '<p> R- Surah An-<span class="c6">Nas y su interpretación:</span><br /> ﷽<br /> قُلْ أَعُوذُ بِرَبِّ النَّاسِ 1<span class="c4">﴿ مَلِكِ النَّاسِ 2 إِلَهِ النَّاسِ 3 مِنْ شَرِّ الْوَسْوَاسِ الْخَنَّاسِ 4 الَّذِي يُوَسْوِسُ فِي صُدُورِ النَّاسِ 5 ﴾</span>6 مِنَ الْجِنَّةِ وَالنَّاسِ <span class="c2">(Noble Corán, surah An-<span class="c6"> Nas:</span> 1-6)</span>.<span class="c6"><br /> Interpretación:</span><br /> 1- <span class="c4">{قُلۡ أَعُوذُ بِرَبِّ ٱلنَّاسِ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114001.mp3"></audio> <br /> Di: <span class="c1">“Me refugio en el Señor de los seres humanos,<br /> 2- <span class="c4">{مَلِكِ ٱلنَّاسِ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114002.mp3"></audio> <br /> en el Rey Soberano de los seres humanos,<br /> 3- <span class="c4">{إِلَٰهِ ٱلنَّاسِ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114003.mp3"></audio> <br /> en el <span class="c5">[Único]</span> Dios de los seres humanos,<br /> 4- <span class="c4">{مِن شَرِّ ٱلۡوَسۡوَاسِ ٱلۡخَنَّاسِ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114004.mp3"></audio><br /> de la maldad del <span class="c5">[demonio]</span> susurrador que huye <span class="c5">[cuando el nombre de Al-láh es mencionado]</span>,<br /> 5- <span class="c4">{ٱلَّذِي يُوَسۡوِسُ فِي صُدُورِ ٱلنَّاسِ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114005.mp3"></audio> <br /> que susurra en los corazones de los seres humanos,<br /> 6- <span class="c4">{مِنَ ٱلۡجِنَّةِ وَٱلنَّاسِ}</span> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114006.mp3"></audio> <br /> y existe entre los genios y entre los seres humanos”</span>. </p>',
            ],
        ],
        5 => [
            0 => [
                'question' => 'P 1: Complete el hadiz “Ciertamente las obras dependen de las intenciones …”, y mencione algunos de sus beneficios.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9030.mp3',
                'answer' => '<p> R- \'Umar Ibn Al-Jattab- Al-láh se complazca con él-<span class="c6"> dijo:</span> "Escuché al Mensajero de Al-<span class="c6">láh ﷺ decir:</span> Ciertamente las obras dependen de las intenciones, y cada persona será retribuida según su intención, de tal manera que aquel cuya emigración fue por Al-láh y Su Mensajero, su emigración fue por Al-láh y Su Mensajero, y aquel cuya emigración fue por conseguir algún beneficio mundanal o por tomar alguna mujer en matrimonio, su emigración fue por aquello por lo que emigró\'". <span class="c2">(Relatado por Al Bujari y Muslim)</span>.<span class="c6"><br /> Beneficios del hadiz:</span><br /> 1- Cada acción debe tener una intención; como la oración, el ayuno, el Jayy y otras acciones.<br /> 2- Es necesario tener sinceridad en la intención a Al-láh ﷻ.<span class="c6"><br /> *Hadiz número dos:</span> </p>',
            ],
            1 => [
                'question' => 'P 2: Complete el hadiz “Quien innove en este nuestros asuntos [religiosos] …”, y mencione algunos de sus beneficios.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9090.mp3',
                'answer' => '<p> R- Aisha, Madre de los creyentes -que Al-láh se complazca con ella-, narró que el Mensajero de Al-<span class="c6">láh ﷺ dijo:</span> <span class="c1">“Quien invente en este nuestro asunto <span class="c2">(nuestra religión)</span> algo ajeno al mismo, su acto será rechazado”</span>. <span class="c2">(Relatado por Al Bujari y Muslim)</span>.<span class="c6"><br /> Beneficios del hadiz:</span><br /> 1- La prohibición de la innovación en la religión.<br /> 2- No son aceptadas las obras provenientes de la innovación <span class="c5">[religiosa]</span>.<span class="c6"><br /> * Hadiz número tres:</span> </p>',
            ],
            2 => [
                'question' => 'P 3: Complete el hadiz “Estando sentados un día con el Mensajero ﷺ …”, y mencione algunos de sus beneficios.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9160.mp3',
                'answer' => '<p> R- Úmar Ibn Al Jattab- que Al-láh se complazca con él-<span class="c6"> narró:</span> <br /> “Estando sentados un día con el Mensajero de Al-láh ﷺ se presentó un hombre con unas vestiduras muy blancas; el pelo de su barba muy negro, sin que se le vieran señales de haber viajado y ninguno de nosotros lo conocía. Fue a sentarse frente al Profeta ﷺ, dando sus rodillas con las de él y colocando las manos sobre sus muslos en actitud de discípulo.<span class="c6"> Le preguntó:</span> ‘¡Oh Muhámmad, infórmame acerca del Islam!’. Y le dijo el Mensajero de Al-<span class="c6">láh ﷺ:</span> ‘El Islam es que atestigües que No hay divinidad salvo Al-láh y que Muhámmad es el Mensajero de Al-láh; que hagas la oración; que des el Zakat; que ayunes en el mes de Ramadán; y que hagas la peregrinación a la Casa de Al-láh, si puedes y tienes medios para ello’.<span class="c6"> Y dijo el hombre:</span> ‘¡Has dicho la verdad!’ Entonces nos quedamos maravillados viendo cómo preguntaba, y al mismo tiempo decía que había dicho la verdad.<span class="c6"> Después dijo:</span> ‘¡Infórmame pues, acerca del Imán <span class="c2">(fe)</span>!’ Dijo: ‘Que creas en Al-láh, en Sus ángeles, Sus Libros, Sus Enviados, en el Último Día y que creas en el decreto tanto agradable como desagradable’.<span class="c6"> Dijo:</span> ‘Has dicho la verdad’.<span class="c6"> Después dijo:</span> ‘¡Infórmame del Ihsán <span class="c2">(benevolencia)</span>!’.<span class="c6"> Y le contestó:</span> ‘Es que adores a Al-láh como si lo vieras, pues si tú no lo ves realmente, Él te ve’.<span class="c6"> Dijo:</span> ‘¡Infórmame de la Hora!’.<span class="c6"> Y le dijo:</span> ‘El preguntado no sabe de ella más que el que pregunta’.<span class="c6"> Después le dijo:</span> ‘¡Infórmame pues, de sus señales!’.<span class="c6"> Dijo:</span> ‘Cuando la esclava dé a luz a su señora y cuando veas a los pobres descalzos y harapientos pastores de ovejas, rivalizando en la construcción de altos edificios’.<span class="c6"> Después partió el hombre y yo permanecí sentado largo tiempo y me preguntó el Profeta ﷺ:</span> ‘¿Úmar,<span class="c6"> sabes quién era?’ Contesté:</span> ‘¡Al-láh y su Mensajero saben mejor!’.<span class="c6"> Dijo Muhámmad ﷺ:</span> ‘¡Úmar, él era el ángel Gabriel que ha venido a vosotros para enseñaros vuestro Din <span class="c2">(religión)</span>!’’’. <span class="c2">(Relatado por Muslim)</span>.<span class="c6"><br /> Beneficios del hadiz:</span><br /> 1-<span class="c6"> Este hadiz menciona los cinco pilares del Islam:</span><br /> - El testimonio de que no hay divinidad salvo Al-láh, y que Muhámmad es Su mensajero.<br /> -Establecer la oración.<br /> - Dar la Zakat <span class="c2">(Caridad obligatoria)</span>.<br /> - Ayunar en el mes de Ramadán.<br /> - La peregrinación a la Casa Sagrada de Al-láh.<br /> 2- Este hadiz también menciona los pilares de la fe,<span class="c6"> que son seis:</span><br /> - La creencia en Al-láh.<br /> - La creencia en los Ángeles.<br /> - La creencia en los Libros.<br /> - La creencia en los Profetas y Mensajeros.<br /> - La creencia en el Día del Juicio.<br /> - La creencia en el destino, sea agradable o desagradable.<br /> 3- Menciona el pilar del Ihsán <span class="c2">(benevolencia)</span>, que es adorar a Al-láh ﷻ como si lo vieras, y si no lo ves, entonces Él te ve.<br /> 4- Menciona que el tiempo de la Hora de la Resurrección sólo Al-láh ﷻ lo sabe.<span class="c6"><br /> *Hadiz número cuatro:</span> </p>',
            ],
            3 => [
                'question' => 'P 4: Complete el hadiz “Los creyentes con la fe más completa …”, y mencione algunos de sus beneficios.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9360.mp3',
                'answer' => '<p> R- Abu Huraira-que Al-láh se complazca con él-, narró que el Mensajero de Al-<span class="c6">láh ﷺ le dijo:</span> <span class="c1">“Los creyentes con la fe más completa son los que tienen el mejor carácter”</span>. <span class="c2">(Relatado por Al-Tirmidhi. Hadiz Hassan sahih)</span>.<span class="c6"><br /> Beneficios del hadiz:</span><br /> 1- Fomentar los buenos modales.<br /> 2- La perfección del carácter es parte de la perfección de la fe.<br /> 3- La fe aumenta y disminuye.<span class="c6"><br /> * Hadiz número cinco:</span> </p>',
            ],
            4 => [
                'question' => 'P 5: Complete el hadiz “Quien jure por algo diferente a Al-láh …”, y mencione algunos de sus beneficios.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9440.mp3',
                'answer' => '<p> R- Abdul-lah Ibn Umar -que Al-láh se complazca con ambos-,<span class="c6"> narró que el Profeta ﷺ dijo:</span> <span class="c1">“Quien jure por algo diferente a Al-láh habrá descreído o asociado”</span>. <span class="c2">(Relatado por Al-Tirmidhi)</span>.<span class="c6"><br /> Beneficios del hadiz:</span><br /> 1-No es lícito jurar por alguien salvo por Al-láh ﷻ.<br /> - Jurar por alguien que no sea Al-láh es una forma de politeísmo menor.<span class="c6"><br /> *Hadiz número seis:</span> </p>',
            ],
            5 => [
                'question' => 'P 6: Complete el hadiz “Ninguno de vosotros completará su fe hasta que yo sea más amado para él que …”, y mencione algunos de sus beneficios.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9510.mp3',
                'answer' => '<p> R- Anás -que Al-láh se complazca con él-, narró que el Mensajero de Al-<span class="c6">láh ﷺ dijo:</span> <span class="c1">“Ninguno de vosotros completará su fe hasta que yo sea más amado para él que su propio hijo, su padre y toda la humanidad”</span>. <span class="c2">(Relatado por Al Bujari y Muslim)</span>.<span class="c6"><br /> Beneficios del hadiz:</span><br /> - Es un deber amar al profeta Muhámmad ﷺ más que a cualquier persona.<br /> - Esa es la perfección de la fe.<span class="c6"><br /> * Hadiz número siete:</span> </p>',
            ],
            6 => [
                'question' => 'P 7: Complete el hadiz “No creerá (completamente) ninguno de ustedes mientras no quiera para su hermano …”, y mencione algunos de sus beneficios.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9580.mp3',
                'answer' => '<p> R- Anás -que Al-láh se complazca con él-, narró que el Mensajero de Al-<span class="c6">láh ﷺ dijo:</span> "No creerá <span class="c2">(completamente)</span> ninguno de ustedes mientras que no quiera para su hermano lo que quiere para sí mismo”. <span class="c2">(Relatado por Al Bujari y Muslim)</span>.<span class="c6"><br /> Beneficios del hadiz:</span><br /> 1- El creyente debe querer el bien para los creyentes como lo quiere para él mismo.<br /> - Esa es la perfección de la fe.<span class="c6"><br /> *Hadiz número ocho:</span> </p>',
            ],
            7 => [
                'question' => 'P 8: Complete el hadiz “¡Juro por Aquel que tiene mi alma en Su mano! …”, y mencione algunos de sus beneficios.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9650.mp3',
                'answer' => '<p> R- Abu Said -que Al-láh se complazca con él- escuchó al Mensajero de Al-<span class="c6">láh ﷺ decir:</span> <span class="c1">“¡Juro por Aquel que tiene mi alma en Su mano! Que ella <span class="c2">(Surah Al-Ikhlas)</span> es equivalente a un tercio del Corán”</span>. <span class="c2">(Relatado por Al Bujari)</span>.<span class="c6"><br /> Algunos beneficios del hadiz:</span><br /> 1- La virtud de la Surah Al-Ikhlas <span class="c2">(Surah n° 112)</span>.<br /> 2- La Surah Al-Ikhlas es equivalente a un tercio del Corán.<span class="c6"><br /> *Hadiz número nueve:</span> </p>',
            ],
            8 => [
                'question' => 'P 9: Complete el hadiz “No hay fuerza ni poder excepto en Al-láh …”, y mencione algunos de sus beneficios.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9720.mp3',
                'answer' => '<p> R- Abu Musa - que Al-láh se complazca con él- narró que el Mensajero de Al-<span class="c6">láh ﷺ dijo:</span> <span class="c1">“\'No hay fuerza ni poder, excepto en Al-láh’, esta frase es de los tesoros del Paraíso”</span>. <span class="c2">(Relatado por Al Bujari y Muslim)</span>.<span class="c6"><br /> Beneficios del hadiz:</span><br /> 1- La virtud de las palabras <span class="c1">“No hay fuerza ni poder excepto en Al-láh”</span>, y el valor que tiene al ser uno de los tesoros del Paraíso.<br /> 2- El siervo de Al-láh no tiene fuerza, su fuerza y su dependencia proviene solamente de Al-láh ﷻ.<span class="c6"><br /> *Hadiz número diez:</span> </p>',
            ],
            9 => [
                'question' => 'P 10: Complete el hadiz “En efecto, todos tenemos un trozo de carne en el cuerpo que …”, y mencione algunos de sus beneficios.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9790.mp3',
                'answer' => '<p> R- Narró Al-Nu’man bin Bashir -que Al-láh se complazca con él-: <span class="c1">“Escuché al Mensajero de Al-<span class="c6">láh ﷺ decir:</span> ‘En efecto, todos tenemos un trozo de carne en el cuerpo que, si está sano, todo el cuerpo está sano; y si está corrompido, todo el cuerpo esta corrupto; y ese no es otro más que el corazón’”</span>. <span class="c2">(Relatado por Al Bujari y Muslim)</span>.<span class="c6"><br /> Algunos beneficios del hadiz:</span><br /> 1- La rectitud del corazón incluye la rectitud del exterior y del interior.<br /> 2- Prestar atención a la bondad del corazón, porque contiene la bondad de la persona.<span class="c6"><br /> *Hadiz número once:</span> </p>',
            ],
            10 => [
                'question' => 'P 11: Complete el hadiz “Quien en sus últimas palabras diga: \'No hay divinidad excepto Al-láh …\'”, y mencione algunos de sus beneficios.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9860.mp3',
                'answer' => '<p> R- Muadh bin Jabal -que Al-láh se complazca con él-, narró que el Mensajero de Al-<span class="c6">láh ﷺ dijo:</span> <span class="c1">“Quien en sus últimas palabras diga: ‘No hay divinidad excepto Al-láh\', entrará en el Paraíso”</span>. <span class="c2">(Relatado por Abu Dawud)</span>.<span class="c6"><br /> Algunos beneficios del hadiz:</span><br /> 1- La virtud de las palabras <span class="c1">“No hay divinidad excepto Al-láh”</span>, y que el siervo entra en el Paraíso gracias a ellas.<br /> 2- La virtud de las palabras <span class="c1">“No hay divinidad excepto Al-láh”</span> cuando son las últimas palabras de la persona.<span class="c6"><br /> *Hadiz número doce:</span> </p>',
            ],
            11 => [
                'question' => 'P 12: Complete el hadiz “El creyente no debe …”, y mencione algunos de sus beneficios.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9940.mp3',
                'answer' => '<p> R- Narró Abdul-lah Ibn Mas\'ud -que Al-láh se complazca con él- que el Mensajero de Al-<span class="c6">láh ﷺ dijo:</span> <span class="c1">“El creyente no debe insultar, ni maldecir, ni ser obsceno, ni rudo al hablar”</span>. <span class="c2">(Relatado por Al-Tirmidhi)</span>.<span class="c6"><br /> Beneficios del hadiz:</span><br /> 1- La prohibición de todas las palabras falsas y obscenas.<br /> - Éstas son las características del lenguaje del creyente.<span class="c6"><br /> *Hadiz número trece:</span> </p>',
            ],
            12 => [
                'question' => 'P 13: Completa el hadiz “De la bondad del Islam de una persona es …”, y menciona algunos de sus beneficios.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10020.mp3',
                'answer' => '<p> R- Abu Huraira -que Al-láh se complazca con él-<span class="c6"> dijo:</span> <span class="c1">“El Mensajero de Al-<span class="c6">láh ﷺ dijo:</span> "Una muestra del Islam de una persona es dejar lo que no le concierne”</span>. <span class="c2">(Relatado por Al-Tirmidhi y otros)</span>.<span class="c6"><br /> Beneficios del hadiz:</span><br /> 1- Dejar lo que no concierne a una persona en asuntos relacionados con la religión <span class="c2">(como indagar o criticar la manera en la que alguien reza)</span> y los asuntos mundanos de los demás.<br /> 2- Dejar lo que no nos concierne es parte de completar nuestra fe.<span class="c6"><br /> *Hadiz número catorce:</span> </p>',
            ],
            13 => [
                'question' => 'P 14: Completa el hadiz “Quien recite una letra del Libro de Al-láh …”, y menciona algunos de sus beneficios.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10100.mp3',
                'answer' => '<p> R- Se transmitió de Ibn Masud -que Al-láh se complazca con él- que el Mensajero de Al-<span class="c6">láh ﷺ dijo:</span> <span class="c1">“Quien recite una letra del libro de Al-láh, tiene una buena acción <span class="c2">(hásana)</span> en su haber. Y la ‘hásana’ equivale a otras diez iguales. Y no digo que ‘ALIF’, ‘LAM’, ‘MIM’ son una sola letra, sino que ‘ALIF’ es una letra, ‘LAM’ es una letra y ‘MIM’ es una letra”</span>. <span class="c2">(Relatado por At Tirmidí)</span>.<span class="c6"><br /> Algunos beneficios del hadiz:</span><br /> 1- La virtud de recitar el Corán <span class="c2">(en su idioma original, el árabe)</span>.<br /> 2- Por cada letra que recites tendrá bendiciones. </p>',
            ],
        ],
        6 => [
            0 => [
                'question' => 'P 1: ¿Cómo deben ser nuestros modales con Al-láh ﷻ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10190.mp3',
                'answer' => '<p> R- Nuestros modales con Al-<span class="c6">láh ﷻ deben ser:</span><br /> 1- Glorificarle.<br /> 2- Adorarle a Él únicamente, sin agregarle copartícipe.<br /> 3- Obedecerle.<br /> 4- Abandonar la desobediencia.<br /> 5- Agradecerle y alabarle por Su generosidad y sustento, que son incontables.<br /> 6- Tener paciencia en Su predestinación. </p>',
            ],
            1 => [
                'question' => 'P 2: ¿Cómo deben ser nuestros modales con el profeta Muhámmad ﷺ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10270.mp3',
                'answer' => '<p> R-<span class="c6"> Nuestros modales con el profeta Muhámmad ﷺ deben ser:</span><br /> 1- Seguirle y tomarle como ejemplo.<br /> 2- Obedecerle.<br /> 3- Abandonar la desobediencia.<br /> 4- Creer en lo que dijo.<br /> 5- No innovar al exceder en su Sunnah.<br /> 6- Amarlo más que a uno mismo y que a toda la humanidad.<br /> 7- Darle gran valor, apoyarlo y apoyar su Sunnah <span class="c2">(enseñanza)</span>. </p>',
            ],
            2 => [
                'question' => 'P 3: ¿Cómo deben ser nuestros modales con nuestros padres?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10360.mp3',
                'answer' => '<p> R-<span class="c6"> Los modales con nuestros padres deben ser:</span><br /> 1- Obedecerles en todo, a excepción de cometer algún pecado.<br /> 2- Servirles.<br /> 3- Ayudarles.<br /> 4- Satisfacer sus necesidades.<br /> 5- Suplicar a Al-láh ﷻ por ellos.<br /> 6- Ser cortés al hablarles. No está permitido decirles ni “Uff” <span class="c2">(aunque ésta sea la mínima expresión negativa)</span>.<br /> 7- Sonreírles y no fruncirles el ceño.<br /> 8- No alzar la voz por encima de la voz de ellos; escucharlos y no interrumpir sus palabras; ni llamarlos por su nombre,<span class="c6"> más bien decirles:</span> "papá", "mamá".<br /> 9- Pedirles permiso antes de entrar a su alcoba mientras están en ella.<br /> 10- Besar sus manos y cabeza en demostración de afecto. </p>',
            ],
            3 => [
                'question' => 'P 4: ¿Cuáles son los modales islámicos para con quienes comparto lazos familiares?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10490.mp3',
                'answer' => '<p> R-<span class="c6"> Los modales para con quienes se comparte lazos familiares son las siguientes:</span><br /> 1- Visitar a los familiares; como el hermano, tíos, tías, otros.<br /> 2- Ser amable con ellos en palabra y obras, y ayudarlos.<br /> 3) Contactarles y preguntarles sobre cómo se encuentran. </p>',
            ],
            4 => [
                'question' => 'P 5: ¿Cuáles son los modales y las normas de cortesía islámica con mis hermanos y amigos?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10550.mp3',
                'answer' => '<p> R-<span class="c6"> Los modales y las normas de cortesía islámica con mis hermanos y amigos deben ser:</span><br /> 1- Me agradan y elijo de entre ellos a los buenos compañeros.<br /> 2- Evito y me alejo de las malas compañías.<br /> 3- Saludo a mis hermanos en el Islam. Y a quienes son de mí mismo tipo, les doy la mano.<br /> 4- Los visito si están enfermos y pido a Al-láh ﷻ para que se recuperen.<br /> 5- Cuando estornudan y dicen <span class="c1">“Alhámdulil-láh <span class="c2">(Alabado sea Al-láh)</span>”</span>,<span class="c6"> le respondo diciendo:</span> <span class="c1">“iarhámuka Al-láh <span class="c2">(Que Al-láh tenga misericordia de ti)</span>”</span>.<br /> 6- Respondo a sus invitaciones si me invitan a visitarlos.<br /> 7- Les aconsejo.<br /> 8- Les ayudo si son agraviados, y evito que hagan el mal.<br /> 9- Amo para mis hermanos musulmanes lo que amo para mí mismo.<br /> 10- Les ayudo si necesitan mi ayuda.<br /> 11- No les hago daño, ni en palabras ni en acciones.<br /> 12- Guardo sus secretos.<br /> 13- No los insulto, ni calumnio, ni desprecio y mucho menos los envidio. No los espío, ni los engaño. </p>',
            ],
            5 => [
                'question' => 'P 6: ¿Cuáles son los modales y las normas de cortesía del vecino?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10710.mp3',
                'answer' => '<p> R-<span class="c6"> Los modales y las normas de cortesía entre vecinos son las siguientes:</span><br /> 1- Hacerles el bien, con las palabras y las acciones, y ayudarlos si necesitan mi ayuda.<br /> 2- Saludarlos si están celebrando alguna fiesta, como el matrimonio o cualquier otra festividad que no sea religiosa, si es que practican otra creencia diferente al Islam.<br /> 3- Visitarlos si están enfermos y consolarlos si están heridos.<br /> 4- Ofrecerles lo que hago de comida, en la medida de lo posible.<br /> 5- No les hiero, ni en palabras ni en acciones.<br /> 6- No se les molesta elevando la voz o indagando. Y les tengo paciencia. </p>',
            ],
            6 => [
                'question' => 'P 7: ¿Cuáles son los modales y las normas de cortesía de la hospitalidad y del invitado?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10800.mp3',
                'answer' => '<p> R-<span class="c6"> Los modales y normas de cortesía de la hospitalidad y del invitado son las siguientes:</span><br /> 1- Responder la invitación de quien invitó a su hospitalidad.<br /> 2- Si se quiere visitar a alguien, se debe pedir primero permiso y una cita.<br /> 3- Pedir permiso antes de entrar al hogar.<br /> 4- No llegar tarde a una visita.<br /> 5- Evitar mirar mucho a los integrantes del hogar.<br /> 6- Recibir al huésped con la mejor bienvenida, con la cara alegre y las mejores palabras de bienvenida.<br /> 7- Sentar al huésped en el mejor lugar.<br /> 8- Honrar al invitado con hospitalidad, comida y bebida. </p>',
            ],
            7 => [
                'question' => 'P 8: ¿Cuáles son los modales del enfermo y las normas de cortesía al visitar a los enfermos?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10900.mp3',
                'answer' => '<p> R-<span class="c6"> Los modales del enfermo y las normas de cortesía al visitar a los enfermos son las siguientes:</span><br /> 1-<span class="c6"> Cuando el enfermo siente un dolor se pone la mano derecha en la parte adolorida y se dice:</span> <span class="c1">““Bismil-láh. <span class="c2">(En el nombre de Al-láh)</span>”</span> <span class="c2">(tres veces)</span>.<span class="c6"> Y se añade:</span> <span class="c1">“Audhu bil-láh wa qudratihi min shari ma ayidu wa auhathar. <span class="c2">(Busco refugio en la gloria y el poder de Al-láh del mal de lo que encuentro y lo que me está por venir)</span>”</span> <span class="c2">(Siete veces)</span>.<br /> 2- Aceptar lo que Al-láh ﷻ ha decretado y ser paciente.<br /> 3- Apresurarse a visitar al hermano enfermo y hacer súplicas por él. No quedarse mucho tiempo durante la visita.<br /> 4- Realizarle voluntariamente al enfermo la Ruqia Shar-iah.<br /> 5- Aconsejarle al enfermo ser paciente, suplicante, y que rece y se purifique tanto como pueda.<br /> 6-<span class="c6"> Hacer la súplica por el enfermo:</span> <span class="c1">“Asalu Al-laha al’adhima Rabbal arshil ’adhiimi an iashfiika <span class="c2">(Le ruego a Al-láh el Grandioso, Señor del trono grandioso que te devuelva la salud)</span>”</span> <span class="c2">(siete veces)</span>. </p>',
            ],
            8 => [
                'question' => 'P 9: ¿Cuáles son los modales en la búsqueda del conocimiento?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10990.mp3',
                'answer' => '<p> R-<span class="c6"> Los modales en la búsqueda del conocimiento son los siguientes:</span><br /> 1- Sinceridad en la intención ante Al-láh ﷻ.<br /> 2- Aplicar el conocimiento adquirido.<br /> 3- Respetar y honrar al maestro en su presencia y en su ausencia.<br /> 4- Sentarse cortésmente frente al educador.<br /> 5- Escuchar atentamente y no interrumpir en sus lecciones.<br /> 6- Ser cortés al preguntar.<br /> 7- No llamar al maestro por su nombre solamente. </p>',
            ],
            9 => [
                'question' => 'P 10: ¿Cuáles son los modales y normas de cortesía en las reuniones?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11090.mp3',
                'answer' => '<p> R-<span class="c6"> Los modales y normas de cortesía en las reuniones son:</span><br /> 1- Saludar a la gente reunida.<br /> 2- Sentarse donde se terminó de saludar. No levantar a nadie de su silla, ni sentarse entre dos sin su permiso.<br /> 3- Ceder la silla, especialmente a las personas mayores.<br /> 4- No interrumpir la conversación de la reunión.<br /> 5- Solicitar permiso al presentarse y al despedirse de la reunión.<br /> 6- Cuando se termina la reunión,<span class="c6"> se hace la súplica por la expiación de la reunión:</span> <span class="c1">“Subhánaka Al-lahumma wa bihámdika ásh-hadu an laa ilaaha il-la anta astágfiruka wa atub ileika. <span class="c2">(Gloria a Ti ¡Oh Al-láh! La alabanza es para Ti. Doy testimonio de que no hay divinidad excepto Tú. Busco Tu perdón y me arrepiento ante Ti)</span>”</span>. </p>',
            ],
            10 => [
                'question' => 'P 11: ¿Cuáles son los modales y etiqueta al dormir?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11180.mp3',
                'answer' => '<p> R-<span class="c6"> Los modales y etiqueta al dormir son:</span><br /> 1- Dormir temprano.<br /> 2- Dormir en estado de pureza.<br /> 3- No dormir boca abajo.<br /> 4- Dormir sobre el lado derecho de uno, con la mano derecha debajo de la mi mejilla.<br /> 5- Sacudir la cama.<br /> 6- Hacer Dhikr <span class="c2">(recordar a Al-láh)</span> antes de dormir, como por ejemplo recitar Ayat al-Kursi <span class="c2">(2:255)</span>, Surah Al-Ikhlas <span class="c2">(n° 112)</span> y surah n° 113 y n° 114 tres veces,<span class="c6"> y decir:</span> <span class="c1">“Bismika Al-lahumma amuutu wa ahiaa. <span class="c2">(En tu nombre, ¡Oh Al-láh! Muero y revivo)</span>”</span>.<br /> 7- Despertarse para la oración del Fayr <span class="c2">(amanecer)</span>.<br /> 8-<span class="c6"> Al despertar del sueño decir:</span> <span class="c1">“Alhámdulil-lah al-ladhí ahiaanaa ba\'ada maa amatana wa ilaihi-nushur <span class="c2">(¡Alabado sea Al-láh! Quien me ha devuelto la vida, luego de haberme dado la muerte y a Él será el retorno)</span>”</span>. </p>',
            ],
            11 => [
                'question' => 'P 12: ¿Cuáles son los modales al comer?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11290.mp3',
                'answer' => '<p> R-<span class="c6"> Los modales al comer son:</span><br /> 1- Tener la intención de que se va a comer y beber para tener fuerza para adorar a Al-láh, el Poderoso y Sublime.<br /> 2- Lavarse las manos antes de comer.<br /> 3-<span class="c6"> Decir:</span> <span class="c1">“Bismil-láh <span class="c2">(En nombre de Al-láh)</span>”</span> y comer con la mano derecha de lo que está cerca; no comer del medio de los platos compartidos, ni delante de la comida de otra persona.<br /> 4- Si se olvida decir <span class="c1">“Bismil-láh <span class="c2">(En nombre de Al-láh)</span>”</span>,<span class="c6"> se dice al recordar:</span> <span class="c1">“Bismil-lah fii awwuálihi wa aahírihi <span class="c2">(En el nombre de Al-láh en su comienzo y final)</span>”</span>.<br /> 5- Estar satisfecho con la comida presente. No hablar mal de la comida; si es gustosa, se come; y si no, se deja.<br /> 6- Comer bocados pequeños y no grandes cantidades.<br /> 7- No soplar sobre la comida o bebida, lo mejor es dejar que se enfríe.<br /> 8- Reunirse con otros para comer en familia o con invitados.<br /> 9- No empezar a comer antes que alguien mayor.<br /> 10- Nombrar a Al-láh ﷻ al beber, y al tomar; hacerlo sentado, y en tres tandas.<br /> 11- Alabar a Al-láh <span class="c2">(decir: "Alhámduli-láh")</span> cuando se termina de comer. </p>',
            ],
            12 => [
                'question' => 'P 13: ¿Cuáles son los modales al vestir?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11440.mp3',
                'answer' => '<p> R-<span class="c6"> Los modales y vestir son:</span><br /> 1- Comenzar a vestir la ropa con la mano derecha, y alabar a Al-láh <span class="c2">(decir: "Alhámduli-láh")</span> por ello.<br /> 2- No extender el vestido por debajo de los tobillos.<br /> 3- Los niños no usan ropa de niña, y las niñas no usan ropa de niño.<br /> 4- No imitar la ropa de los incrédulos o de los pecadores.<br /> 5- Decir <span class="c1">“Bismil-láh <span class="c2">(En el nombre de Al-láh)</span>”</span> al desvestirse.<br /> 6- Al ponerse el calzado, iniciar por el pie derecho; y al quitarlo iniciar por el izquierdo. </p>',
            ],
            13 => [
                'question' => 'P 14: ¿Cuáles son los modales al subir a un medio de transporte?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11540.mp3',
                'answer' => '<p> R-<span class="c6"> Los modales y normas de cortesía al subir a un medio de transporte son:</span><br /> 1-<span class="c6"> Decir:</span> <span class="c1">“Bismil-láhi wal hámdulil-lahi <span class="c2">(En el nombre de Al-láh, alabado sea Al-láh)</span>”</span>, ﴾ <span class="c2">(…)</span> Subbháana al-ladhíí sáJJara lanaa haadhaa wa maa kunnaa lahu muqriníína <br /> [Glorificado sea Quien nos lo ha facilitado, ya que nosotros no habríamos sido capaces <span class="c2">(por nuestro mero esfuerzo)</span>], wa innaa ilaa rábbinaa lamúnqalibuuna. <span class="c5">[y ante nuestro Señor hemos de regresar]</span> ﴿ <span class="c2">(Noble Corán,<span class="c6"> 43:</span>13-14)</span>.<br /> 2- Si se encuentra a un musulmán<span class="c2">(a)</span>, se le saluda con Assalamu alaikum <span class="c2">(la paz sea contigo)</span>. </p>',
            ],
            14 => [
                'question' => 'P 15: ¿Cuáles son los modales del camino?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11590.mp3',
                'answer' => '<p> R-<span class="c6"> Los modales del camino son:</span><br /> 1- Ser moderado y humilde al andar. Buscar siempre caminar por el lado derecho del camino.<br /> 2- Saludar a los musulmanes con "Assalamu alaikum <span class="c2">(la paz sea contigo)</span>".<br /> 3- Recatar la mirada y no hacerle daño a nadie.<br /> 4- Aconsejar el bien y prohibir el mal.<br /> 5- Quitar del camino cualquier cosa que pueda hacer un daño. </p>',
            ],
            15 => [
                'question' => 'P 16: ¿Cuáles son los modales al entrar y salir de casa?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11670.mp3',
                'answer' => '<p> R-<span class="c6"> Los modales al entrar y salir de casa son:</span><br /> 1-<span class="c6"> Salir con el pie izquierdo y decir:</span> <span class="c1">“Bismil-láh, tauakaltu ’alaa Al-láh, laa háula wa laa quuwata il-la bil-láh, Al-lahumma innii ’audhu bika an adil-la, au udal-li, au azhil-la, au uzhal-la, au adhlima, au udhlama, au ayhala, au iuyhala ’aleiia. <span class="c2">(En el nombre de Al-láh, me encomiendo en Al-láh, no<br /> hay fuerza ni poder salvo en Al-láh, ¡Oh Al-láh! Me refugio en Ti de desviarme o ser desviador, de equivocarme o de que me precipite en el error, de oprimir o ser oprimido, de ser ignorante o que sean ignorantes conmigo)</span>”</span>. 2-<span class="c6"> Entrar a la casa con el pie derecho y decir:</span> <span class="c1">“Bismil-láhi wa la-y-naa, wa Bismil-lahi khara-y-naa, wa ’alaa Rábbinaa tawuakalnaa. <span class="c2">(En el nombre de Al-láh regresamos y en el nombre de Al-láh salimos y nos encomendamos a nuestro Señor)</span>”</span>.<br /> 3- Cepillar los dientes con el Mizuak <span class="c2">(para tener un aliento agradable)</span>, luego saludar a la familia con "Assalam alaikum". </p>',
            ],
            16 => [
                'question' => 'P 17: ¿Cuáles son los modales al hacer las necesidades?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11730.mp3',
                'answer' => '<p> R-<span class="c6"> Los modales y etiquetas al hacer las necesidades son los siguientes:</span><br /> 1- Entrar con el pie izquierdo.<br /> 2-<span class="c6"> Antes de entrar decir:</span> <span class="c1">“<span class="c5">[Bismil-láh]</span> Al-láhumma innii ’audhu bika min al hubthi wal Khabaa ith. <span class="c2">(¡Oh Al-láh! Ciertamente, me refugio en Ti de los malvados y malvadas)</span>”</span>.<br /> 3- No entro al baño nada con el nombre de Al-láh <span class="c2">(Corán, etc.)</span>.<br /> 4- Cubrirse cuando sea necesario.<br /> 5- No hablar a menos que sea una urgencia.<br /> 6- No sentarse haciendo frente o dando la espalda a la dirección de la Quibla <span class="c2">(en dirección a la Kaaba)</span> al orinar o defecar.<br /> 7- No usar la mano derecha para limpiar las impurezas, se debe usar para ello la mano izquierda.<br /> 8- No hacer necesidades fisiológicas en el camino de la gente o bajo de un árbol que sea utilizado para la sombra.<br /> 9- Lavarse las manos después de hacer las necesidades fisiológicas.<br /> 10-<span class="c6"> Salir del baño con el pie derecho y decir:</span> <span class="c1">“Gufrának <span class="c2">(perdóname)</span>”</span>. </p>',
            ],
            17 => [
                'question' => 'P 18: ¿Cuáles son los modales que debemos practicar en la mezquita?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11860.mp3',
                'answer' => '<p> R-<span class="c6"> Los modales y la etiqueta que debemos practicar en la mezquita son los siguientes:</span><br /> 1-<span class="c6"> Entrar en la mezquita con el pie derecho y decir:</span> <span class="c1">“Bismil-láh Al-lahumma iftah lii abbuaaba rahmátika. <span class="c2">(En el nombre de Al-láh, ¡Oh Al-láh! Ábreme las puertas de Tu misericordia)</span>”</span>.<br /> 2- No sentarse hasta haber orado dos raka’ahs.<br /> 3- No caminar frente a los que están rezando. Tampoco publicar en voz alta sobre algo perdido en la mezquita, así como tampoco hacer comercio <span class="c2">(negocios)</span> en ella.<br /> 4- Al salir de la mezquita,<span class="c6"> hacerlo con el pie izquierdo y diciendo:</span> <span class="c1">““Al-lahumma innii asáluka min fádlika. <span class="c2">(¡Oh Al-láh! Pido Tu favor)</span>”</span>. </p>',
            ],
            18 => [
                'question' => 'P 19: ¿Cuáles son los modales del saludo?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11930.mp3',
                'answer' => '<p> R-<span class="c6"> Los modales y la cortesía del saludo son los siguientes:</span><br /> 1- Cuando recién se ve a un hermano musulmán, se inicia con el saludo,<span class="c6"> diciendo:</span> <span class="c1">“Assalamu aleikum wa rahmatul-lahi wa baraqatuh. <span class="c2">(La paz y bendiciones de Al-láh sean contigo)</span>”</span>. No se saluda de otra forma que no sea con la paz, ni se saluda únicamente con dar la mano.<br /> 2- Sonreír al que le saluda.<br /> 3- Dar la mano derecha al saludar.<br /> 4- Si alguien te saluda, le respondes el saludo con uno mejor o igual.<br /> 5- No se inicia el saludo al incrédulo con "Assalaam <span class="c2">(la paz)</span>". Si éste saluda, se le responde con lo mismo.<br /> 6- Es recomendable que el primero que salude sea el más joven al mayor, el que transita en un medio de transporte, saluda al que está caminando, el que está caminando, saluda primero al que está sentado, y la minoría saluda primero a la mayoría. </p>',
            ],
            19 => [
                'question' => 'P 20: ¿Cuáles son los modales al momento de pedir permiso?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12020.mp3',
                'answer' => '<p> R-<span class="c6"> Los modales al momento de pedir permiso son los siguientes:</span><br /> 1- Pedir permiso antes de entrar al lugar.<br /> 2- Pedir permiso hasta un máximo de tres veces y no más; si no se recibe una respuesta, retirarse del lugar.<br /> 3- Tocar suavemente la puerta y no pararse frente a ella, sino a la derecha o a la izquierda de esta <span class="c2">(para evitar ver dentro del lugar o irrumpir la privacidad cuando abran)</span>.<br /> 4- No entrar a la habitación de los padres sin pedir permiso, especialmente antes del Fayr <span class="c2">(amanecer)</span>, cuando estén haciendo la siesta o después del Ishaa <span class="c2">(noche)</span>.<br /> 5- Ingresar libremente <span class="c2">(sin pedir permiso)</span> en lugares públicos, como un hospital o una tienda. </p>',
            ],
            20 => [
                'question' => 'P 21: ¿Cuáles son los modales de amabilidad con los animales?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12100.mp3',
                'answer' => '<p> R-<span class="c6"> Los modales de amabilidad con los animales son los siguientes:</span><br /> 1- Alimentar y dar de beber al animal.<br /> 2- Compasión y misericordia por ellos. Esto incluye no cargarles con lo que no pueden soportar.<br /> 3- No torturar a los animales con ningún tipo de maltrato o daño. </p>',
            ],
            21 => [
                'question' => 'P 22: ¿Cuáles son los modales y la etiqueta en la práctica de deportes?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12160.mp3',
                'answer' => '<p> R-<span class="c6"> Los modales y la etiqueta en la práctica de deportes son los siguientes:</span><br /> 1- Poner la intención de que la práctica de tal deporte es para fortalecerse al obedecer y agradar a Al-láh ﷻ.<br /> 2- No jugar o practicar el deporte en el momento de la oración.<br /> 3- Los deportes deben realizarse con personas del mismo género. Los chicos no hacen deporte con las chicas.<br /> 4- Hacer uso de ropa deportiva que cubra el Awrah <span class="c2">(pudor)</span>.<br /> 5- Evitar los deportes prohibidos, como aquellos en los que se reciben golpes en la cara o muestran la desnudez. </p>',
            ],
            22 => [
                'question' => 'P 23: ¿Cómo deben ser nuestros modales al bromear?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12240.mp3',
                'answer' => '<p> R-<span class="c6"> Al bromear se debe tener en cuenta los siguientes modales:</span><br /> 1- Honestidad al bromear. No mentir.<br /> 2- Los chistes deben estar libres de burlas, abuso o intimidación.<br /> 3- No bromear en exceso. </p>',
            ],
            23 => [
                'question' => 'P 24: ¿Cuáles son los modales al estornudar?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12300.mp3',
                'answer' => '<p> R- Al estornudar o ver a alguien estornudar,<span class="c6"> se deben tener presente los siguientes modales islámicos:</span><br /> 1- Taparse con una mano, una prenda o un pañuelo al estornudar.<br /> 2- Alabar a Al-<span class="c6">láh ﷻ después de estornudar diciendo:</span> <span class="c1">“Alhámdulil-láh <span class="c2">(Alabado sea Al-láh)</span>”</span>.<br /> 3- El hermano musulmán que escucha a otro hermano estornudar y alabar a Al-láh,<span class="c6"> debe decirle:</span> <span class="c1">“iarháamuka Al-láh. <span class="c2">(Que Al-láh tenga misericordia de ti)</span>”</span>.<span class="c6"><br /> Luego quien ha estornudado debe responderle:</span> <span class="c1">“iahdííkumu Al-láhu wa iuslihu báálakum. <span class="c2">(Que Al-láh te guíe y te rectifique)</span>”</span>. </p>',
            ],
            24 => [
                'question' => 'P 25: ¿Cuáles son los modales al bostezar?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12360.mp3',
                'answer' => '<p> R-<span class="c6"> Al bostezar se deben tener presente los siguientes modales:</span><br /> 1- Intentar suprimir el bostezo.<br /> 2- No levantar la voz expresando el bostezo con un “aaah”.<br /> 3- Cubrir la boca con la mano. </p>',
            ],
            25 => [
                'question' => 'P 26: ¿Cuáles son los modales en la recitación?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12420.mp3',
                'answer' => '<p> R-<span class="c6"> Los modales en la recitación son los siguientes:</span><br /> 1- Recitar con la ablución.<br /> 2- Sentarse educadamente y con recato.<br /> 3- Buscar refugio en Al-<span class="c6">láh ﷻ de Satanás al comienzo de la recitación:</span> <span class="c1">“A’udhu bil-lahi min a sheiTááni arrayiimi. <span class="c2">(Me refugio en Al-láh del maldito Satanás)</span>”</span>.<br /> 4- Reflexionar en la lectura. </p>',
            ],
        ],
        7 => [
            0 => [
                'question' => 'P 1: ¿Cuál es la virtud de las buenas morales?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12500.mp3',
                'answer' => '<p> R-<span class="c6"> El profeta Muhámmad ﷺ dijo:</span> <span class="c1">“Los creyentes que tienen la fe más completa son los que tienen las mejores morales”</span>. <span class="c2">(Relatado por Al-Tirmidhi y Ahmad)</span>. </p>',
            ],
            1 => [
                'question' => 'P 2: ¿Por qué nos adherimos a la moral islámica?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12530.mp3',
                'answer' => '<p> R-<span class="c6"> Nos adherimos a la moral islámica por las siguientes razones:</span><br /> 1- Aumenta nuestro amor de Al-láh ﷻ.<br /> 2- Es una razón para amar la creación.<br /> 3- Es lo que más pesará en la balanza en el Día del Juicio.<br /> 4- Las recompensas se multiplican por las buenas morales.<br /> 5- Es un signo de perfección de la fe. </p>',
            ],
            2 => [
                'question' => 'P 3: ¿De dónde obtenemos la moral?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12600.mp3',
                'answer' => '<p> R- Del Noble Corán, Al-<span class="c6">láh ﷻ dijo:</span> ﴾El Corán guía por el sendero más justo y firme, y di a los creyentes que obran rectamente que recibirán una gran recompensa﴿ <span class="c2">(Traducción del Corán,<span class="c6"> 17:</span>9)</span>. Y también de la Sunnah profética, pues el Mensajero de Al-<span class="c6">láh ﷺ dijo:</span> <span class="c1">“Ciertamente yo fui enviado para completar la rectitud de las morales”</span>. <span class="c2">(Relatado por Ahmad)</span>. </p>',
            ],
            3 => [
                'question' => 'P 4: ¿Cuál es la naturaleza del Ihsan (bondad y excelencia) y cuáles son sus tipos?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12640.mp3',
                'answer' => '<p> R- Ihsan <span class="c2">(bondad y excelencia)</span>: es saber que Al-láh ﷻ siempre observa, hacer el bien y ser benévolo con las criaturas.<span class="c6"><br /> El profeta Muhámmad ﷺ dijo:</span> <span class="c1">“Ciertamente Al-láh ha prescrito la benevolencia en todos los asuntos”</span>. <span class="c2">(Relatado por Muslim)</span>.<br /> Tipos del Ihsan <span class="c2">(bondad y excelencia)</span>:<br /> ·La adoración a Al-láh ﷻ con completa sinceridad.<br /> ·Amabilidad con los padres, en palabra y acciones.<br /> ·Benevolencia con los parientes.<br /> ·Benevolencia con el prójimo.<br /> ·Benevolencia con los huérfanos y los necesitados.<br /> ·Bondad con el que te hace un mal.<br /> ·Bondad en las palabras.<br /> ·Benevolencia en una discusión.<br /> ·Amabilidad con los animales. </p>',
            ],
            4 => [
                'question' => 'P 5: ¿Qué es lo opuesto a la bondad?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12780.mp3',
                'answer' => '<p> R – Lo opuesto a la bondad es la maldad.<span class="c6"><br /> * Incluyendo:</span> abandonar la sinceridad en la adoración a Al-láh ﷻ.<br /> * Desobediencia a los padres.<br /> * Cortar los lazos familiares.<br /> * Hacer daño a los vecinos.<br /> * Dejar de ser bondadoso con los pobres, necesitados y otros en palabras y acciones. </p>',
            ],
            5 => [
                'question' => 'P 6: ¿Cuáles son los tipos de honestidad y sus formas?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12860.mp3',
                'answer' => '<p> R-<span class="c6"> Los tipos de honestidad son:</span><br /> 1- Honestidad en la preservación de los derechos de Al-láh ﷻ.<span class="c6"><br /> Sus formas:</span> honestidad en la realización de los actos de adoración como la oración, el Zakat, el ayuno, el Jayy y otras cosas que Al-láh ﷻ nos ha ordenado.<br /> 2-<span class="c6"> Honestidad en la conservación de los derechos de la creación:</span><br /> • Mantener el honor de las personas.<br /> • Mantener el honor del dinero de las personas.<br /> • Mantener el honor de la sangre.<br /> • Mantener el honor de los secretos y todo lo que la gente te ha confiado.<br /> Al-<span class="c6">láh ﷻ describiendo las características del éxito dijo:</span> ﴾ <span class="c5">[Estarán entre los bienaventurados quienes]</span> sean fieles a la confianza depositada en ellos, cumplen con sus compromisos y acuerdos﴿ <span class="c2">(Traducción del Corán,<span class="c6"> 23:</span>8)</span>. </p>',
            ],
            6 => [
                'question' => 'P 7: ¿Qué es lo opuesto a la honestidad?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12980.mp3',
                'answer' => '<p> R- Lo opuesto a la honestidad es la deshonestidad y la traición. Es el descuido de los derechos de Al-láh ﷻ y de las personas.<br /> El profeta Muhámmad ﷺ dijo que las características de los hipócritas son tres,<span class="c6"> y una de éstas es:</span> <span class="c1">“<span class="c2">(…)</span> Y si se le confía algo, traiciona”</span>. <span class="c2">(Relatado por Al Bujari y Muslim)</span>. </p>',
            ],
            7 => [
                'question' => 'P 8: ¿Cuáles son las características de la veracidad?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13020.mp3',
                'answer' => '<p> R- La veracidad es contar la verdad, sin cambiarla o inventar.<span class="c6"><br /> Entre sus tipos está:</span><br /> - La veracidad al hablar con la gente.<br /> - La veracidad en una promesa.<br /> - La veracidad en cada palabra y obra.<br /> -<span class="c6"> El profeta Muhámmad ﷺ dijo:</span> <span class="c1">“Sean honestos y veraces, porque la verdad conduce a las buenas acciones y las buenas acciones conducen al Paraíso, y si una persona dice la verdad y la verdad es su objetivo, será registrado como veraz ante Al-láh <span class="c2">(…)</span>”</span>. <span class="c2">(Relatado por Al Bujari y Muslim)</span>. </p>',
            ],
            8 => [
                'question' => 'P 9: ¿Qué es lo opuesto a la veracidad?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13100.mp3',
                'answer' => '<p> R- Lo opuesto a la veracidad es la falsedad. Es la mentira y el perjurio.<br /> Sobre el falso testimonio y el perjurio,<span class="c6"> el profeta Muhámmad ﷺ dijo:</span> <span class="c1">“<span class="c2">(…)</span> Eviten la falsedad, porque la falsedad conduce a la maldad y la maldad al Infierno, y si un hombre dice falsedades y la falsedad es su objetivo, será registrado ante Al-láh como mentiroso”</span>. <span class="c2">(Relatado por Al Bujari y Muslim)</span>.<span class="c6"> El Profeta ﷺ también dijo que existen tres señales del hipócrita y las mencionó:</span> “<span class="c2">(…)</span> Cuando habla, miente; cuando promete, no cumple; y si se le confía algo, traiciona". <span class="c2">(Relatado por Al Bujari y Muslim)</span>. </p>',
            ],
            9 => [
                'question' => 'P 10: ¿Cuáles son los tipos de paciencia?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13140.mp3',
                'answer' => '<p> R-<span class="c6"> Los tipos de paciencia son:</span><br /> - Paciencia en la obediencia a Al-láh ﷻ.<br /> - Paciencia al alejarse de la desobediencia.<br /> - Paciencia ante los sucesos dolorosos, alabando a Al-láh en cada ocasión.<br /> Al-<span class="c6">lah ﷻ dijo:</span> ﴾ <span class="c2">(…)</span> Al-láh ama a los perseverantes﴿ <span class="c2">(Traducción del Corán,<span class="c6"> 3:</span>146)</span>.<span class="c6"> Y el Profeta ﷺ dijo:</span> <span class="c1">“¡Es admirable el caso del creyente! Todo asunto encierra un bien para él y esto no ocurre nada más que con el creyente. Pues, si le llega la facilidad es agradecido con Al-láh y hay un bien para él. Y si tiene paciencia ante la dificultad, también consigue un bien para él”</span>. <span class="c2">(Relatado por Muslim)</span>. </p>',
            ],
            10 => [
                'question' => 'P 11: ¿Qué es lo opuesto a la paciencia?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13210.mp3',
                'answer' => '<p> R- Lo opuesto a la paciencia es la desesperación en la obediencia y el descontento con la predestinación en las palabras o en las acciones.<span class="c6"><br /> Entre los tipos de la desesperación se encuentran:</span><br /> § Desear la muerte.<br /> § Golpearse las mejillas.<br /> § Rasgarse la ropa.<br /> § Difundir con desespero el sentimiento.<br /> § Pedir la propia perdición.<span class="c6"><br /> El Profeta ﷺ dijo:</span> <span class="c1">“La gran recompensa es fruto de las grandes pruebas. Si Al-láh ﷻ ama a un pueblo, lo examina poniéndolo a prueba. Quien se complazca, tendrá la complacencia y quien se indigne tendrá la ira <span class="c2">(de Al-láh)</span>”</span>. <span class="c2">(Relatado por al-Tirmidhi e Ibn Mayah)</span>. </p>',
            ],
            11 => [
                'question' => 'P 12: ¿Qué es la cooperación?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13310.mp3',
                'answer' => '<p> R- Es el conjunto de acciones y esfuerzos que las personas hacen entre sí en el camino del bien y la verdad.<span class="c6"><br /> Tipos de cooperación:</span><br /> * Cooperación en la restitución de los derechos.<br /> * Cooperación en respuesta a los injustos.<br /> * Cooperación en la satisfacción de las necesidades de la gente y de los necesitados.<br /> * Cooperación en todo lo bueno.<br /> * No cooperar en el pecado.<span class="c6"><br /> El Todopoderoso dijo:</span> ﴾ <span class="c2">(…)</span> Sino que cooperen con ellos a obrar el bien e impedir el mal, pero no cooperen en el pecado y la enemistad. Y tengan temor de Al-láh; Al-láh es severo en el castigo﴿ <span class="c2">(Traducción del Corán,<span class="c6"> 5:</span>2)</span>.<span class="c6"> El Profeta ﷺ dijo:</span> <span class="c1">“Los creyentes son como una estructura cuyas partes se sostienen unas a otras. Los creyentes, en su amistad natural, misericordia y afecto son como un cuerpo; si una parte sufre, el resto del cuerpo también sufrirá”</span>. <span class="c2">(Relatado por Al Bujari y Muslim)</span>.<span class="c6"> Y también dijo el Profeta ﷺ:</span> <span class="c1">“<span class="c2">(...)</span> El musulmán es hermano del musulmán, no es injusto con él ni lo traiciona, no le miente ni lo desprecia. El temor de Al-láh <span class="c2">(taqwa)</span> está aquí mismo -señalando su pecho tres veces-, y es suficiente maldad para una persona despreciar a su hermano musulmán.<span class="c6"> Todo musulmán es inviolable para otro musulmán:</span> en su vida, honor y bienes”</span>. <span class="c2">(Hadiz concordado)</span> </p>',
            ],
            12 => [
                'question' => 'P 13: ¿Cuáles son los tipos de modestia?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13420.mp3',
                'answer' => '<p> R-<span class="c6"> Los tipos de modestia son:</span><br /> 1- Modestia con Al-<span class="c6">láh ﷻ:</span> es no desobedecerle.<br /> 2-<span class="c6"> Modestia con la gente:</span> incluye dejar de hablar obscenidades y vulgaridades, y no mostrar la desnudez.<br /> El Mensajero de Al-<span class="c6">láh ﷺ dijo:</span> <span class="c1">“La fe presenta más de sesenta o más de setenta ramas <span class="c2">(grados)</span>. La más elevada de ellas es la afirmación de que no hay divinidad salvo Al-láh <span class="c2">("La iláha il-la Al-láh")</span>, la más baja es quitar algo dañino del camino, y la modestia es una de las ramas de la fe”</span>. <span class="c2">(Registrado por Al-Bujari y Muslim)</span>. </p>',
            ],
            13 => [
                'question' => 'P 14: ¿Cuáles son los tipos de la misericordia?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13470.mp3',
                'answer' => '<p> R-<span class="c6"> Los tipos de misericordia son:</span><br /> - Compasión y respeto por los ancianos.<br /> - Misericordia con los jóvenes y los niños.<br /> - Misericordia con los pobres y los necesitados.<br /> - Misericordia con los animales al alimentarlos y no causarles daño alguno.<span class="c6"><br /> El profeta Muhámmad ﷺ dijo:</span> <span class="c1">“El ejemplo de los creyentes en su amor mutuo,<span class="c6"> misericordia y colaboración es como el cuerpo humano:</span> si le duele de un órgano, se resiente el resto del cuerpo por la fiebre y el insomnio”</span>. <span class="c2">(Hadiz concordado)</span>. Y también dijo el Mensajero de Al-<span class="c6">láh ﷺ:</span> <span class="c1">“A los Misericordiosos les tiene misericordia el Misericordioso. Compadeceos de las gentes de la Tierra, y se compadecerá de vosotros quien está en el Cielo”</span>. <span class="c2">(Registrado por Abu Dawud y Al-Tirmidhi)</span>. </p>',
            ],
            14 => [
                'question' => 'P 15: ¿Cuáles son los tipos de amor?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13550.mp3',
                'answer' => '<p> R-<span class="c6"> Los tipos de amor son:</span><br /> • El amor a Al-láh ﷻ.<span class="c6"><br /> El Todopoderoso dijo:</span> ﴾ <span class="c2">(…)</span> Los creyentes aman más a Al-láh <span class="c5">[de lo que estos aman a sus divinidades]</span>. <span class="c2">(…)</span> ﴿ <span class="c2">(Traducción del Corán,<span class="c6"> 2:</span>165)</span>.<br /> • El amor al profeta Muhámmad ﷺ.<span class="c6"><br /> Él ﷺ dijo:</span> <span class="c1">“¡Por Aquel que tiene mi alma en Su mano! Ninguno de vosotros completará su fe hasta que yo sea más amado para él que su propio hijo, su padre y toda la humanidad”</span>. <span class="c2">(Relatado por Al Bujari)</span>.<br /> • El amor a los creyentes y el amar el bien para ellos tal como si fuera para uno mismo.<span class="c6"><br /> El profeta Muhámmad ﷺ dijo:</span> <span class="c1">“No creerá <span class="c2">(completamente)</span> ninguno de ustedes mientras no quiera para su hermano lo que quiere para sí mismo”</span>. <span class="c2">(Relatado por Al Bujari y Muslim)</span>. </p>',
            ],
            15 => [
                'question' => 'P 16: ¿Cuál es la definición de alegría?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13630.mp3',
                'answer' => '<p> R- La alegría es mostrar la amabilidad en la cara con una sonrisa, manifestando satisfacción, bondad y placer al encontrarse con la gente.<br /> La alegría es lo opuesto a fruncir el ceño ante las personas. Es lo que las separa.<br /> Abu Dhar Al-Ghifari -que Al-láh se complazca con él-<span class="c6"> narró que el Profeta ﷺ dijo:</span> <span class="c1">“No menosprecies ningún acto de bondad, ni siquiera el encontrarte con tu hermano llevando un rostro sonriente”</span>. <span class="c2">(Relatado por Muslim)</span>. El Mensajero de Al-<span class="c6">láh ﷺ dijo:</span> <span class="c1">“Sonreír en la cara de tu hermano es un acto de caridad”</span>. <span class="c2">(Relatado por At-Tirmidhi)</span>. </p>',
            ],
            16 => [
                'question' => 'P 17: ¿Qué es la envidia?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13690.mp3',
                'answer' => '<p> R- La envidia es desear que los demás no tengan una bendición u odiar una bendición para los demás.<br /> Al-<span class="c6">láh ﷻ dijo:</span> ﴾y del mal del envidioso cuando envidia﴿ <span class="c2">(Traducción del Corán,<span class="c6"> 113:</span>5)</span>.<br /> Anas bin Malik -que Al-láh se complazca con él- narró que el Mensajero de Al-<span class="c6">láh ﷺ dijo:</span> <span class="c1">“No se envidien unos a otros, ni pujen para implicar a los demás, ni se odien unos a otros, ni se den la espalda <span class="c2">(…)</span> oh siervos de Al-láh, hermanos <span class="c2">(…)</span>”</span>. <span class="c2">(Registrado por Muslim)</span>. </p>',
            ],
            17 => [
                'question' => 'P 18: ¿Qué es la burla?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13740.mp3',
                'answer' => '<p> R- La burla es ridiculizar y degradar a tu hermano musulmán. Esto no está permitido.<br /> Con respecto a la prohibición de esto,<span class="c6"> el Todopoderoso dijo:</span> ﴾¡Oh, creyentes! No se burlen unos de otros, porque pudiera ser que los que son blancos de las burlas sean mejores que los que se están burlando. Que las mujeres no se burlen de otras mujeres, porque es posible que las que son el blanco de las burlas sean mejores que las que se burlan. No difamen ni pongan apodos ofensivos. ¡Qué malo es comportarse como un corrupto luego de haber sido agraciado con la fe! Quienes no se arrepientan… esos son los injustos﴿ <span class="c2">(Traducción del Corán,<span class="c6"> 49:</span>11)</span> </p>',
            ],
            18 => [
                'question' => 'P 19: ¿Qué es la humildad?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13780.mp3',
                'answer' => '<p> R- La humildad es cuando la persona no siente que tiene más valor que los demás, por eso no maltrata ni rechaza la verdad.<span class="c6"><br /> El Todopoderoso dijo:</span> ﴾Los siervos del Misericordioso son aquellos que caminan sobre la faz de la tierra con humildad, y cuando son increpados por los ignorantes les responden <span class="c5">[con palabras de]</span> paz﴿ <span class="c2">(Traducción del Corán,<span class="c6"> 25:</span>63)</span>. Esto es la humildad. - El Mensajero de Al-<span class="c6">láh ﷺ dijo:</span> "<span class="c2">(…)</span> Y nadie ha sido humilde y modesto por Al-láh sin que Al-láh le haya elevado de categoría por ello”. <span class="c2">(Relatado por Muslim)</span>. -<span class="c6"> Y él ﷺ dijo:</span> <span class="c1">“Al-láh me reveló que debemos ser humildes para que nadie se sienta por encima de los demás, y no ser injustos con nadie”</span>. <span class="c2">(Relatado por Muslim)</span>. </p>',
            ],
            19 => [
                'question' => 'P 20: ¿Cuáles son los tipos de soberbia?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13840.mp3',
                'answer' => '<p> R- La altivez es un antivalor y es prohibida.<span class="c6"> Sus tipos son:</span><br /> 1- Altivez ante la verdad, que es rechazar la verdad y no aceptarla.<br /> 2- Altivez hacia las personas, que es despreciarlas y menospreciarlas.<br /> El Mensajero de Al-<span class="c6">láh ﷺ dijo:</span> “\'No entra en el Paraíso la persona que tiene un átomo de altivez en el corazón\'. Entonces,<span class="c6"> un hombre dijo:</span> \'Ciertamente al hombre le gusta vestir buena ropa y buen calzado <span class="c2">(buenas sandalias)</span>\'. Dijo el Mensajero de Al-<span class="c6">láh ﷺ:</span> Ciertamente Al-láh es bello y ama lo bello. La soberbia es negar la verdad y menospreciar o ser ingrato con la gente\'". <span class="c2">(Relatado por Muslim)</span>.<span class="c6"><br /> La soberbia:</span> refutar la verdad.<span class="c6"><br /> Menospreciar:</span> faltar al respeto denigrando a las personas.<br /> Un buen vestido y calzado no son altivez o arrogancia. </p>',
            ],
            20 => [
                'question' => 'P 21: ¿Qué es el fraude y cuáles son sus tipos?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13910.mp3',
                'answer' => '<p> R- El fraude es hacer trampa en la compra y venta. Es encubrir el defecto de la mercancía. Este es un antivalor y está prohibido en el Islam.<span class="c6"> Sus tipos son:</span><br /> - El fraude en el aprendizaje de las ciencias, así como que los estudiantes hagan trampa en los exámenes.<br /> - El fraude en la palabra, como el falso testimonio y la mentira.<br /> - No cumplir lo que se dice y lo que se acuerda con la gente.<br /> Con respecto a la prohibición de cometer fraude, el Profeta ﷺ al ir al mercado y ver un saco de granos,<span class="c6"> metió su noble mano en el saco y lo encontró mojado y preguntó al vendedor:</span> <span class="c1">“¿Por qué engañas así?”</span>.<span class="c6"> Éste le respondió:</span> <span class="c1">“Lo mojó la lluvia”</span>.<span class="c6"> Entonces el Profeta ﷺ dijo:</span> <span class="c1">“¡Tienes que ponerlo al descubierto para que la gente lo vea!”</span>,<span class="c6"> y a continuación sentenció:</span> <span class="c1">“Quien nos engaña no es de los nuestros”</span>. <span class="c2">(Relatado por Muslim)</span>.<span class="c6"><br /> Un saco de granos:</span> un saco lleno de comida. </p>',
            ],
            21 => [
                'question' => 'P 22: ¿Qué es la murmuración?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13990.mp3',
                'answer' => '<p> R- La murmuración es decir algo de tu hermano musulmán que le disgusta mientras está ausente.<span class="c6"><br /> El Todopoderoso dijo:</span> ﴾ <span class="c2">(…)</span> Y no se espíen, ni hablen mal del ausente, porque es tan repulsivo como comer la carne muerta de su hermano. ¿Acaso alguien desearía hacerlo? Por supuesto que les repugnaría. Tengan temor de Al-láh, porque Al-láh es Indulgente, Misericordioso﴿ <span class="c2">(Traducción del Corán,<span class="c6"> 49:</span>12)</span> </p>',
            ],
            22 => [
                'question' => 'P 23: ¿Qué es el chisme?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14030.mp3',
                'answer' => '<p> R- El chisme es la transmisión de dichos entre personas para corromperlas.<br /> - Dijo el Mensajero de Al-<span class="c6">láh ﷺ:</span> <span class="c1">“No entra en el Paraíso un chismoso”</span>. <span class="c2">(Relatado por Muslim)</span>. </p>',
            ],
            23 => [
                'question' => 'P 24: ¿Qué es la pereza?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14070.mp3',
                'answer' => '<p> R- La pereza es la falta de ganas de hacer el bien y cumplir los deberes.<span class="c6"><br /> Incluyendo:</span> pereza en el cumplimiento de los deberes.<br /> Al-<span class="c6">láh ﷻ dijo:</span> ﴾Los hipócritas pretenden engañar a Al-láh, pero Él hace que ellos se engañen a sí mismos. Cuando se levantan para hacer la oración lo hacen con desgano, solo para ser vistos por la gente, sin apenas acordarse de Al-láh﴿ <span class="c2">(Traducción del Corán,<span class="c6"> 4:</span>142)</span>.<br /> El creyente debe abandonar la pereza, el letargo y la flojera; y esmerarse en esforzarse en el trabajo, el movimiento y la diligencia en esta vida, de una manera que agrade a Al-láh ﷻ. </p>',
            ],
            24 => [
                'question' => 'P 25: ¿Cuáles son los tipos de ira?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14130.mp3',
                'answer' => '<p> R-<span class="c6"> Los tipos de ira son:</span><br /> 1-<span class="c6"> La ira a favor del Islam:</span> es por Al-láh ﷻ, si los infieles o hipócritas u otros violan Sus prohibiciones.<br /> 2-<span class="c6"> La ira reprochable:</span> es la ira que provoca el hombre cuando hace y dice lo que no debe.<span class="c6"><br /> El tratamiento para calmar la ira reprochable es:</span><br /> • Hacer la ablución.<br /> • Sentarse si está de pie, y recostarse si se está sentado.<span class="c6"><br /> • Cumplir el mandato del Profeta ﷺ:</span> <span class="c1">“No te enojes”</span>.<br /> • Intentar controlarse cuando se está enojado.<br /> • Buscar el refugio en Al-láh del maldito Satanás.<br /> • El silencio. </p>',
            ],
            25 => [
                'question' => 'P 26: ¿Qué es espiar?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14240.mp3',
                'answer' => '<p> R- Espiar es curiosear buscando las faltas en las personas y lo que ocultan.<span class="c6"><br /> De sus tipos ilícitos:</span><br /> 1- Espiar para ver las partes íntimas de las personas o sus casas.<br /> 2- Espiar para escuchar la conversación ajena sin el conocimiento de los hablantes.<span class="c6"><br /> El Todopoderoso dijo:</span> ﴾ <span class="c2">(…)</span> Y no se espíen <span class="c2">(…)</span> ﴿ <span class="c2">(Traducción del Corán,<span class="c6"> 49:</span>12)</span>. </p>',
            ],
            26 => [
                'question' => 'P 27: ¿Qué es la extravagancia? ¿Qué es la avaricia? ¿Y qué es la generosidad?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14310.mp3',
                'answer' => '<p> R-<span class="c6"> <br /> • Extravagancia:</span> es derrochar el dinero en cosas innecesarias.<span class="c6"><br /> • Avaricia:</span> Es privarse de gastar en cosas necesarias.<span class="c6"><br /> • Generosidad:</span> es lo que es correcto. Es el término medio entre la extravagancia y la avaricia, y es una característica del musulmán, quien debe ser generoso.<span class="c6"><br /> El Todopoderoso dijo:</span> ﴾ <span class="c5">[Los siervos del Misericordioso son]</span> aquellos que cuando hacen una caridad no dan todo lo que tienen ni tampoco escatiman, sino que dan con equilibrio﴿ <span class="c2">(Traducción del Corán,<span class="c6"> 25:</span>67)</span>. </p>',
            ],
            27 => [
                'question' => 'P 28: ¿Qué es la cobardía? ¿Y qué es la valentía?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14370.mp3',
                'answer' => '<p> R-<span class="c6"> <br /> • Cobardía:</span> miedo o falta de valor ante ciertas situaciones.<br /> Como el miedo a decir la verdad y a negar el mal.<span class="c6"><br /> • Valentía:</span> determinación en la búsqueda de la verdad, como tomar la delantera en los campos de batalla de la yihad para defender el Islam y los musulmanes.<span class="c6"><br /> El Profeta ﷺ dijo en su súplica:</span> <span class="c1">“Me refugio en Ti de la cobardía <span class="c2">(…)</span>”</span>.<span class="c6"> Y él ﷺ también dijo:</span> <span class="c1">“Un creyente fuerte es mejor y más amado por Al-láh que un creyente débil, y en cada uno hay algo bueno”</span>. <span class="c2">(Relatado por Muslim)</span>. </p>',
            ],
            28 => [
                'question' => 'P 29: ¿Qué tipo de palabras son prohibidas para la lengua?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14440.mp3',
                'answer' => '<p> R- Son prohibidas para la lengua las malas palabras, como maldecir o insultar.<br /> - Como cuando alguien le dice <span class="c1">“animal” a otro o expresiones similares.<br /> - Decir obscenidades y vulgaridades.<br /> -<span class="c6"> El Profeta ﷺ prohibió todos estos tipos de expresiones cuando dijo:</span> “El creyente no debe insultar, ni maldecir, ni ser obsceno, ni ruidoso al hablar”</span>. <span class="c2">(Relatado por Al-Tirmidhi e Ibn Hibban)</span>. </p>',
            ],
            29 => [
                'question' => 'P 30: ¿Cómo busca y encuentra el musulmán la buena moral?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14500.mp3',
                'answer' => '<p> R-<span class="c6"> El musulmán busca y encuentra la buena moral realizando las siguientes acciones:</span><br /> 1- Haciendo súplicas para que Al-láh ﷻ le bendiga con buen carácter y le ayude a hacerlo.<br /> 2- Sentir que Al-láh es el Poderoso y Sublime, y que Él le conoce, observa y escucha.<br /> 3- Recordar la recompensa de los buenos modales y que es uno de los motivos para entrar al Paraíso.<br /> 4- Recordar la consecuencia de los malos modales y que es motivo para entrar en el Infierno.<br /> 5- Recordar que los buenos modales atraen el amor de Al-láh ﷻ y de Su creación hacia uno mismo, y que los malos modales atraen el odio de Al-láh ﷻ y de Su creación hacia uno mismo.<br /> 6- Leer la biografía del profeta Muhámmad ﷺ y seguir su ejemplo.<br /> 7- Manteniéndose en compañía de buenas personas y evitando las malas compañías. </p>',
            ],
        ],
        8 => [
            0 => [
                'question' => 'P 1: ¿Cuál es la virtud del dhikr (recuerdo de Al-láh)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14630.mp3',
                'answer' => '<p> R-<span class="c6"> El profeta Muhámmad ﷺ dijo:</span> <span class="c1">“El ejemplo de aquellos que recuerdan a su Señor y el que no se acuerda de su Señor, es como la diferencia de entre los vivos y los muertos”</span>. <span class="c2">(Relatado por Al-Bujari)</span>.<br /> - Esto se debe a que el valor de la vida de una persona es tanto como su recuerdo de Al-láh ﷻ. </p>',
            ],
            1 => [
                'question' => 'P 2: Mencione algunos de los beneficios del dhikr (recuerdo de Al-láh).',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14670.mp3',
                'answer' => '<p> R-<br /> 1- Agradar al Misericordioso.<br /> 2- Aleja a Satanás y a sus secuaces.<br /> 3- Protege al musulmán del mal.<br /> 4- Se obtiene recompensa y bendiciones. </p>',
            ],
            2 => [
                'question' => 'P 3: ¿Cuál es el mejor dhikr (recuerdo de Al-láh)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14730.mp3',
                'answer' => '<p> R- El mejor dhikr <span class="c2">(recuerdo de Al-láh)</span> es decir: <span class="c1">“La iláha il-la Al-láh <span class="c2">(no hay más divinidad salvo Al-láh)</span>.”</span> <span class="c2">(Relatado por al-Tirmidhi e Ibn Mayah)</span>. </p>',
            ],
            3 => [
                'question' => 'P 4: ¿Qué se dice al despertarse del sueño?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14760.mp3',
                'answer' => '<p> R-<span class="c6"> Al despertar del sueño es recomendable decir:</span> <span class="c1">“Alhámdulil-láh al-ladhí ahiaanaa ba\'ada maa amatana wa ileihin-nushur <span class="c2">(¡Alabado sea Al-láh! Quien me ha devuelto la vida, luego de haberme dado la muerte y a Él será el retorno)</span>”</span>. <span class="c2">(Hadiz concordado)</span>. </p>',
            ],
            4 => [
                'question' => 'P 5: ¿Qué se dice al vestirse?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14790.mp3',
                'answer' => '<p> R-<span class="c6"> Al vestirse es recomendable decir:</span> <span class="c1">“Alhámdulil-lah al-ladhí kasaanii haadhaa ath-thaub wa raz-qaniihi min gairi haulin minnii wa laa quwwata. <span class="c2">(¡Alabado sea Al-láh! Quien me ha provisto esta vestimenta y me ha concedido todo sin esfuerzo ni poder de mi parte)</span>”</span>. <span class="c2">(Relatado por Abu Dawud, Al-Tirmidhi y otros)</span>. </p>',
            ],
            5 => [
                'question' => 'P 6: ¿Qué se dice al desvestirse?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14820.mp3',
                'answer' => '<p> R-<span class="c6"> Al desvestirse es recomendable decir:</span> <span class="c1">“Bismil-láh. <span class="c2">(En el nombre de Al-láh)</span>”</span>. <span class="c2">(Relatado por Al-Tirmidhi)</span>. </p>',
            ],
            6 => [
                'question' => 'P 7: ¿Cuál es la súplica que se recomienda decir al estrenar una prenda de vestir?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14850.mp3',
                'answer' => '<p> R-<span class="c6"> La súplica al estrenar es:</span> <span class="c1">“Al-lahumma lakal hámdu Anta kasautaniihi as.áluka min hairihi wa hairi maa Suni’a lahu, wa a’udhu bika min sharrihi wa sharri maa Suni’a lahu. <span class="c2">(¡Oh Al-láh! Para Ti es la alabanza, Tú me has vestido esto. Te pido su bien y lo bueno para lo que fue hecha y me refugio en Ti de su mal y del mal para lo que fuera hecha)</span>”</span>. <span class="c2">(Relatado por Abu Dawud y Tirmidhi)</span>. </p>',
            ],
            7 => [
                'question' => 'P 8: ¿Cuál es la súplica por quien estrena una prenda de vestir?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14880.mp3',
                'answer' => '<p> R- Si ves una prenda nueva en otra persona,<span class="c6"> pides por esa persona diciendo:</span> <span class="c1">“Tublii wa iukhliful-lahu ta’alaa. <span class="c2">(Que la utilices y que Al-láh te la reemplace con otra)</span>”</span>. <span class="c2">(Relatado por Abu Dawud)</span>. </p>',
            ],
            8 => [
                'question' => 'P 9: ¿Qué súplica se dice antes de entrar al baño o al ingresar al lugar en donde se hacen las necesidades fisiológicas?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14910.mp3',
                'answer' => '<p> R-<span class="c6"> La súplica que se dice antes de entrar al baño o al lugar en donde se hacen las necesidades fisiológicas es:</span> <span class="c1">“Al-lahumma innii ’audhu bika min al hubthi wal habaa.ith. <span class="c2">(Oh Al-láh, busco refugio en Ti de los malvados y las malvadas)</span>”</span>. <span class="c2">(Hadiz concordado)</span>. </p>',
            ],
            9 => [
                'question' => 'P 10: ¿Qué súplica se dice al salir del baño?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14940.mp3',
                'answer' => '<p> R-<span class="c6"> La súplica que se dice al salir del baño es:</span> <span class="c1">“Gufránaka <span class="c2">(Te pido perdón)</span>”</span>. <span class="c2">(Relatado por Abu Dawud y Tirmidhi)</span>. </p>',
            ],
            10 => [
                'question' => 'P 11: ¿Qué se dice antes de la ablución?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14970.mp3',
                'answer' => '<p> R-<span class="c6"> Antes de realizar la ablución se dice:</span> <span class="c1">“Bismil-láh <span class="c2">(en el nombre de Al-láh)</span>”</span>. <span class="c2">(Relatado por Abu Dawud y otros)</span>. </p>',
            ],
            11 => [
                'question' => 'P 12: ¿Qué dhikr se dice al terminar la ablución?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15000.mp3',
                'answer' => '<p> R-<span class="c6"> Al terminar la ablución se dice:</span> <span class="c1">“Ashhadu an laa ilaha il-la Al-láh wahdahu laa shariika lahu wa áshhadu anna Muhámmadan ’abduhu wa rasuuluhu. <span class="c2">(Atestiguo que no hay divinidad salvo Al-láh, Único sin asociado y atestiguo que Muhámmad es Su siervo y mensajero)</span>”</span>. <span class="c2">(Relatado por Muslim)</span>. </p>',
            ],
            12 => [
                'question' => 'P 13: ¿Qué dhikr se dice al salir de casa?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15020.mp3',
                'answer' => '<p> R-<span class="c6"> Al salir de casa se dice:</span> <span class="c1">“Bismil-láhi tauakaltu ’alaa Al-láh wa laa haula wa laa quuwata il-la bil-láh. <span class="c2">(En el nombre de Al-láh, en Al-láh confío, no hay fuerza ni poder sino en Al-láh)</span>”</span>. <span class="c2">(Relatado por Abu Dawud y Tirmidhi)</span>. </p>',
            ],
            13 => [
                'question' => 'P 14: ¿Qué dhikr se dice al entrar en la casa?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15050.mp3',
                'answer' => '<p> R-<span class="c6"> Al entrar en casa se dice:</span> <span class="c1">“Bismil-láhi wa laynaa, wa bismil-láhi haraynaa, wa ’alaa Rábbinaa tawuakalnaa. (En el nombre de Al-láh vinimos, y en el nombre de Al-láh salimos, y en Al-láh nuestro Señor confiamos”</span>. Luego se saluda a la familia. <span class="c2">(Relatado por Abu Dawud)</span>. </p>',
            ],
            14 => [
                'question' => 'P 15: ¿Cuál es la súplica al entrar a la mezquita?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15080.mp3',
                'answer' => '<p> R-<span class="c6"> La súplica al entrar a la mezquita es:</span> <span class="c1">“Al-láhumma aftah lii abbuaab rahmátika. (¡Oh Al-láh! ábreme las puertas de Tu misericordia”</span> <span class="c2">(Relatado por Muslim)</span>. </p>',
            ],
            15 => [
                'question' => 'P 16: ¿Cuál es la súplica al salir de la mezquita?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15110.mp3',
                'answer' => '<p> R-<span class="c6"> La súplica al salir de la mezquita es:</span> <span class="c1">“Al-lahumma innii as.áluka min fádlika. <span class="c2">(¡Oh Al-láh! Te pido Tu favor)</span>”</span> <span class="c2">(Relatado por Muslim)</span>. </p>',
            ],
            16 => [
                'question' => 'P 17: ¿Qué se dice cuando se escucha el llamado a la oración?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15140.mp3',
                'answer' => '<p> R- Cuando se escucha el llamado a la oración se dice <span class="c2">(en voz baja)</span> lo mismo que dice el almuédano <span class="c2">(el que hace el llamado)</span> excepto cuando dice <span class="c1">“haiia ’alaa aSSalat, haiia ’alaal falahi. <span class="c2">(Venid a la Oración, venid a la felicidad)</span>”</span>,<span class="c6"> los orantes decimos:</span> <span class="c1">“La haula wa la qúwwata il-la bil-láh. <span class="c2">(No hay fuerza ni poder salvo en Al-láh)</span>”</span>. <span class="c2">(Hadiz concordado)</span>. </p>',
            ],
            17 => [
                'question' => 'P 18: ¿Qué se dice después de la llamada a la oración?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15170.mp3',
                'answer' => '<p> R- Después del llamado a la oración se piden bendiciones para el Profeta ﷺ. <span class="c2">(Relatado por Muslim)</span>.<span class="c6"> Luego de responder al llamado del Almuédano se agrega:</span> <span class="c1">“Al-lahumma Rabba haadhihi dá’wuati taammati wa assalaatil qaa.ímati, aati Muhámmadan al-uasiilata wal fadíílata wa ab’azhu maqaaman mahmuudan al-ladhíí ua’ád.tahu, ínnaka laa tuhliful mii’aadi. <span class="c2">(¡Oh Al-láh! Señor de este llamado perfecto, y de esta oración establecida, concede a Muhámmad, Al-Uasila (una estación del Paraíso)</span> y Al-Fadila <span class="c2">(rango por encima del resto de la Creación)</span>, y concédenos su intercesión que le has prometido, Tu no faltas jamás a tu promesa”</span>. <span class="c2">(Relatado por Bujari)</span>.<br /> La súplica entre la llamada a la oración y el Iqamah no es rechazada. </p>',
            ],
            18 => [
                'question' => 'P 19: ¿Qué dhikr es recomendable decir en la mañana y en la tarde?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15220.mp3',
                'answer' => '<p> R-<span class="c6"> Dhikr en la mañana y la tarde:</span><br /> 1- Recitar Ayat al-Kursi en árabe. اللَّهُ لَا إِلَهَ إِلَّا هُوَ الْحَيُّ الْقَيُّومُ لَا تَأْخُذُهُ سِنَةٌ وَلَا نَوْمٌ لَهُ مَا فِي السَّمَاوَاتِ وَمَا فِي الْأَرْضِ مَنْ ذَا الَّذِي يَشْفَعُ عِنْدَهُ إِلَّا بِإِذْنِهِ يَعْلَمُ مَا بَيْنَ أَيْدِيهِمْ وَمَا خَلْفَهُمْ وَلَا يُحِيطُونَ بِشَيْءٍ مِنْ عِلْمِهِ إِلَّا بِمَا شَاءَ وَسِعَ كُرْسِيُّهُ السَّمَاوَاتِ وَالْأَرْضَ وَلَا يَئُودُهُ حِفْظُهُمَا وَهُوَ الْعَلِيُّ الْعَظِيمُ255 <br /> <br /> <span class="c2">(¡Al-láh! No existe nada ni nadie con derecho a ser adorado, excepto Él, el Viviente <span class="c5">[Eterno]</span>, el Sustentador <span class="c5">[y Gobernador de toda la creación]</span>. No Lo afectan somnolencia ni sueño. Suyo es cuanto hay en los cielos y la Tierra. ¿Quién podrá interceder ante Él si no es con Su permiso? Conoce el pasado y el futuro <span class="c5">[lo manifiesto y lo oculto]</span> y nadie abarca de Su conocimiento salvo lo que Él quiere. El escabel de Su Trono abarca los cielos y la Tierra, y la custodia <span class="c5">[y mantenimiento]</span> de ambos no Lo agobia. Y Él es el Sublime, el Grandioso)</span>". <span class="c2">(Noble Corán,<span class="c6"> 2:</span>255)</span> 2- Y recitar la Surah Al-Ikhlas <span class="c2">(Surah n° 112)</span> en árabe:<br /> ﷽<br /> <span class="c2">(En el nombre de Al-láh, el Compasivo, el Misericordioso)</span>.<span class="c6"> قُلْ هُوَ اللَّهُ أَحَدٌ 1﴿<br /> (Di:</span> <span class="c1">“Él es Al-láh, Uno. اللَّهُ الصَّمَدُ 2<br /> Al-láh es el Absoluto. لَمْ يَلِدْ وَلَمْ يُولَدْ 3<br /> No engendró ni fue engendrado. ﴾4 وَلَمْ يَكُنْ لَهُ كُفُوًا أَحَدٌ<br /> Y no hay nada ni nadie que sea semejante a Él”</span>). Tres veces. Y recitar la Surah Al -Falaq <span class="c2">(Surah n° 113)</span> en árabe:<br /> ﷽<br /> <span class="c2">(En el nombre de Al-láh, el Compasivo, el Misericordioso)</span>.<span class="c6"> قُلْ أَعُوذُ بِرَبِّ الْفَلَقِ 1﴿<br /> (Di:</span> <span class="c1">“Me refugio en el Señor del amanecer, مِنْ شَرِّ مَا خَلَقَ 2<br /> de todo el mal que existe en lo que Él creó, وَمِنْ شَرِّ غَاسِقٍ إِذَا وَقَبَ 3<br /> del mal de la oscuridad de la noche cuando se extiende, وَمِنْ شَرِّ النَّفَّاثَاتِ فِي الْعُقَدِ 4<br /> del mal de las <span class="c5">[hechiceras]</span> sopladoras de nudos, ﴾5 وَمِنْ شَرِّ حَاسِدٍ إِذَا حَسَدَ<br /> y del mal del envidioso cuando envidia”</span>). Tres veces. Y recitar la Surah An-Nas <span class="c2">(Surah n° 114)</span> en árabe:<br /> ﷽<br /> <span class="c2">(En el nombre de Al-láh, el Compasivo, el Misericordioso)</span>.<span class="c6"> قُلْ أَعُوذُ بِرَبِّ النَّاسِ 1﴿<br /> (Di:</span> <span class="c1">“Me refugio en el Señor de los seres humanos, مَلِكِ النَّاسِ 2<br /> en el Rey Soberano de los seres humanos, إِلَهِ النَّاسِ 3<br /> en el <span class="c5">[Único]</span> Dios de los seres humanos, مِنْ شَرِّ الْوَسْوَاسِ الْخَنَّاسِ 4<br /> de la maldad del <span class="c5">[demonio]</span> susurrador que huye <span class="c5">[cuando el nombre de Al-láh es mencionado]</span>, الَّذِي يُوَسْوِسُ فِي صُدُورِ النَّاسِ 5<br /> que susurra en los corazones de los seres humanos, ﴾6 مِنَ الْجِنَّةِ وَالنَّاسِ<br /> y existe entre los genios y entre los seres humanos”</span>). Tres veces. 3-<span class="c6"> Decir:</span> <span class="c1">“Al-lahumma Anta Rabbii laa ilaha il-la Anta halaqtanii wa ana ’abduka, wa ana ’alaa ’ahdika wa wá’dika maa istaTa’tu a’udhu bika min sherri maa Sana’tu, ábuu.u laka bini’matika ’aleiia, wa abuu.u bi dhanbii, faagfir lii fa innahu laa iagfira addhunuuba il-laa Anta (¡Oh Al-láh! Tú eres mi Señor, no hay divinidad, salvo Tú, me has creado y yo soy tu siervo, mantengo mi pacto y promesa contigo de la mejor manera que puedo, en Ti me refugio del mal que haya cometido. Reconozco Tus gracias para conmigo y reconozco mis pecados, perdóname porque ciertamente nadie perdona los pecados sino Tú”</span>. <span class="c2">(Relatado por Bujari)</span>. </p>',
            ],
            19 => [
                'question' => 'P 20: ¿Qué se dice antes de dormir?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15290.mp3',
                'answer' => '<p> R-<span class="c6"> Antes de dormir se dice:</span> <span class="c1">“Bismika Al-lahumma amuutu wa ahiaa. <span class="c2">(En tu nombre, ¡Oh Al-láh! Muero y revivo)</span>”</span>. <span class="c2">(Hadiz concordado)</span>. </p>',
            ],
            20 => [
                'question' => 'P21: ¿Qué se dice antes de comer?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15320.mp3',
                'answer' => '<p> R-<span class="c6"> Antes de comer se dice:</span> <span class="c1">“Bismil-láh <span class="c2">(En el nombre de Al-láh)</span>”</span>.<br /> Y si se olvida decirlo al principio,<span class="c6"> al recordar se dice:</span><br /> <span class="c1">“Bismil-lahi fii awwuálihi wa aahírihi (En el nombre de Al-láh en su comienzo y final”</span>. <span class="c2">(Relatado por Abu Dawud y Tirmidhi)</span>. </p>',
            ],
            21 => [
                'question' => 'P 22: ¿Qué se dice al terminar de comer?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15370.mp3',
                'answer' => '<p> R-<span class="c6"> Al terminar de comer se dice:</span> <span class="c1">“Alhámdulil-lahi al-ladhíí aT’amaníí haadhaa wa razhaqaniihi min gueira haulin minníí wa laa qúwatin. <span class="c2">(Alabado sea Al-láh, que me alimentó con esto y me lo proporcionó sin poder ni fuerza de mi parte)</span>”</span>. <span class="c2">(Relatado por Abu Dawud, Ibn Mayah y otros)</span>. </p>',
            ],
            22 => [
                'question' => 'P 23: ¿Cuál es la súplica para quien invita a comer?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15400.mp3',
                'answer' => '<p> R- El invitado pide a Al-láh por quienes lo invitaron,<span class="c6"> diciendo:</span> <span class="c1">“Al-lahumma baarik lahum fiimaa razaqtahum, wagfir lahum war hamhum. (¡Qué Al-láh los bendiga con lo que les ha proporcionado, y los perdone y tenga misericordia de ellos!”</span>. <span class="c2">(Relatado por Muslim)</span>. </p>',
            ],
            23 => [
                'question' => 'P 24: ¿Qué se dice al estornudar?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15430.mp3',
                'answer' => '<p> R-<span class="c6"> Al estornudar se dice:</span> <span class="c1">“Alhámdulil-láh <span class="c2">(Alabado sea Al-láh)</span>”</span>.<br /> El hermano musulmán que escucha a otro hermano estornudar y alabar a Al-láh,<span class="c6"> debe decirle:</span> <span class="c1">“iarhámuka Al-láh. <span class="c2">(Que Al-láh tenga misericordia de ti)</span>”</span>.<br /> Luego quien ha estornudado,<span class="c6"> debe responderle:</span> <span class="c1">“iahdííkumu Al-láhu wa iuSlihu báálakum <span class="c2">(Que Al-láh te guíe y te rectifique)</span>”</span>. <span class="c2">(Relatado por Al Bujari)</span>. </p>',
            ],
            24 => [
                'question' => 'P 25: ¿Cuál es la súplica que se dice al finalizar una reunión?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15480.mp3',
                'answer' => '<p> R- Cuando termina la reunión,<span class="c6"> se hace la súplica por la expiación de la reunión:</span> <span class="c1">“Subhánaka Al-lahumma wa bihámdika ásh-hadu an laa ilaaha il-la Anta astágfiruka wa atub ilaika. <span class="c2">(Gloria a Ti ¡Oh Al-láh! La alabanza es para Ti. Doy testimonio de que no hay divinidad excepto Tú. Busco Tu perdón y me arrepiento ante Ti)</span>”</span>. <span class="c2">(Relatado por Abu Dawud, Al-Tirmidhi y otros)</span>. </p>',
            ],
            25 => [
                'question' => 'P 26: ¿Cuál es la súplica al subir a un medio de transporte?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15510.mp3',
                'answer' => '<p> R-<span class="c6"> La súplica para subir al transporte es:</span> <span class="c1">“Bismil-láhi wal hámdulil-lahi ﴾ <span class="c2">(…)</span> Subbháana al-ladhíí sáhhara lanaa haadhaa wa maa kunnaa lahu muqriníína wa innaa ilaa rábbinaa lamúnqalibuuna﴿ Al hámdulil-láhi, al hámdulil-láhi, al hámdulil-láji, Al-láhu ákbaru, Al-láhu ákbaru, Al-láhu ákbaru Subháanaka lahumma innii Dhalamtu nafsíí fáágfir líí faínnahu laa iágfiru adhdhuunuba il-laa Anta. <span class="c2">(En el nombre de Al-láh, alabado sea Al-láh)</span>, ﴾<span class="c2">(…)</span> Glorificado sea Quien nos lo ha facilitado, ya que nosotros no habríamos sido capaces <span class="c5">[por nuestro mero esfuerzo]</span>, y ante nuestro Señor hemos de regresar]﴿ ¡Alabado sea Al-láh! ¡Alabado sea Al-láh! ¡Alabado sea Al-láh! ¡Al-láh es grande! ¡Al-láh es grande! ¡Al-láh es grande! ¡Gloria a Al-láh! He sido injusto conmigo mismo, así que perdóname; porque nadie perdona los pecados excepto Tú)”</span>. <span class="c2">(Relatado por Abu Dawud y Al-Tirmidhi)</span>. </p>',
            ],
            26 => [
                'question' => 'P 27: ¿Cuál es la súplica del viajero?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15540.mp3',
                'answer' => '<p> R-<span class="c6"> La súplica antes de emprender un viaje es:</span> <span class="c1">“Al-láhu Ákbar, Al-láhu Ákbar, Al-láhu Ákbar ﴾ <span class="c2">(…)</span> Subbáana al-ladhíí sáhhara lanaa haadhaa wa maa kunnaa lahu muqriníína wa innaa ilaa rábbinaa lamúnqalibuuna﴿ <span class="c2">(Al-lahumma innaa nas áluka fii sáfarinaa haadha al birr wa ttaquaa, wa minal ’amali maa tardaa, Al-lahumma háwwin ’aleinaa sáfaranaa haadhaa wa átui ’annaa bu’dahu, Al-lahumma Anta assááhibu fiis sáfari, wal halíífatu fi al maal wal ahl.<br /> (Al-láh es grande, Al-láh es grande, Al-láh es grande ﴾ (…)</span> Glorificado sea Quien nos lo ha facilitado, ya que nosotros no habríamos sido capaces <span class="c5">[por nuestro mero esfuerzo]</span>, y ante nuestro Señor hemos de regresar] ﴿ Oh Al-láh, te pedimos durante este viaje nuestro por la justicia, la piedad y las obras que te agradan. Oh Al-láh, facilítanos este viaje y acorta la distancia para nosotros. Oh Al-láh, eres el compañero durante el viaje y el guardián de la familia y la propiedad en nuestra ausencia)”</span>.<span class="c6"><br /> Al regresar se dice la misma súplica y se agrega:</span><br /> "Aaiibuuna taa.ibuuna ’aabiduuna li rabbinaa aamiduuna.<span class="c2">(Regresamos adorándote, arrepentidos y agradeciendo a nuestro Señor)</span>". <span class="c2">(Relatado por Muslim)</span>. </p>',
            ],
            27 => [
                'question' => 'P 28: ¿Cuál es la súplica del viajero por el residente?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15590.mp3',
                'answer' => '<p> R-<span class="c6"> La súplica del viajero por el residente es:</span> “Astaudi’akumu Al-láh al-ladíí laa tadii’u wadaa.i’uhu. <span class="c2">(Te encomiendo en Al-láh, Quien no descuida lo que se le ha encomendado)</span>". <span class="c2">(Relatado por Ahmad e Ibn Mayah)</span>. </p>',
            ],
            28 => [
                'question' => 'P 29: ¿Cuál es la súplica del residente por el viajero?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15620.mp3',
                'answer' => '<p> R-<span class="c6"> La súplica del residente por el viajero es:</span> <span class="c1">“Astaudi’u Al-láha díínaka wa amaanátaika wa hawaatiima ’amálika. [Que Al-láh resguarde tu religión <span class="c2">(din)</span>, tus responsabilidades y la terminación de tus acciones]”</span>. <span class="c2">(Relatado por Ahmad y Al-Tirmidhi)</span>. </p>',
            ],
            29 => [
                'question' => 'P 30: ¿Cuál es la súplica al ingresar al lugar de comercio?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15650.mp3',
                'answer' => '<p> R- <span class="c1">“Laa iláaha il-la Al-láhu wáhdahu laa shariika lahu, lahul mulku wa lahul hamdu iuhii wa iumiitu wa hua haiun laa iamuutu biiádihil hairu wa hua ’alaa kul-li shai.in qadiirun. (No hay divinidad salvo Al-láh, Único sin asociado, Suyo es el reino y Suya es la alabanza, Él da la vida y la muerte, Él es el Viviente que no muere, en Sus manos está el bien y es sobre todas las cosas Poderoso”</span>. <span class="c2">(Relatado por Al-Tirmidhi e Ibn Mayah)</span>. </p>',
            ],
            30 => [
                'question' => 'P 31: ¿Cuál es la súplica que se debe decir al enojarse?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15680.mp3',
                'answer' => '<p> R- Al estar enojado, se busca refugio en Al-<span class="c6">lah diciendo:</span> “A’udhu bil-láhi min ash-Shaitán ar rayim. <span class="c2">(Me refugio en Al-láh del maldito Satanás)</span>". <span class="c2">(Hadiz concordado)</span>. </p>',
            ],
            31 => [
                'question' => 'P 32: ¿Cuál es la súplica por quien nos hace un favor?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15710.mp3',
                'answer' => '<p> R- <span class="c1">“Yazhaaka Al-láhu Khairan. <span class="c2">(Que Al-láh te recompense con el bien)</span>”</span>. <span class="c2">(Relatado por Al-Tirmidhi)</span>. </p>',
            ],
            32 => [
                'question' => 'P 33: ¿Cuál es la súplica que se dice al averiarse el medio de transporte?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15740.mp3',
                'answer' => '<p> R- “Bismil-láh. <span class="c2">(En el nombre de Al-láh)</span>". <span class="c2">(Relatado por Abu Dawud)</span>. </p>',
            ],
            33 => [
                'question' => 'P 34: ¿Qué se dice al recibir buenas noticias?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15770.mp3',
                'answer' => '<p> R- <span class="c1">“Alhámdulil-lahi al-ladhíí bini’mátihí tatimmus Saalihaat. <span class="c2">(Alabado sea Al-láh que por Su gracia se ha hecho realidad esta maravilla)</span>”</span>. <span class="c2">(Relatado por Al-Haakim y otros)</span>. </p>',
            ],
            34 => [
                'question' => 'P 35: ¿Qué se dice al recibir noticias desagradables?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15800.mp3',
                'answer' => '<p> R- <span class="c1">“Alhámdulil-lahi ’alaa kul-li haal. <span class="c2">(Alabado sea Al-láh en toda circunstancia)</span>”</span>. <span class="c2">(Sahih Al-Jaami\')</span>. </p>',
            ],
            35 => [
                'question' => 'P 36: ¿Cuáles son las formas del saludo?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15830.mp3',
                'answer' => '<p> R- El musulmán<span class="c2">(a)</span> que saluda primero dice: "Assalamu alaikum wa rahmatul-lahi wa baraqatuh. <span class="c2">(La paz y bendiciones de Al-láh sean contigo)</span>”.<br /> Y su hermano<span class="c2">(a)</span> musulmán<span class="c2">(a)</span> le responde: <span class="c1">“wa alaikum assalam wa rahmatul-lahi wa baraqatuh. <span class="c2">(Y que la paz y las bendiciones de Al-láh sean contigo)</span>”</span>. <span class="c2">(Relatado por Al-Tirmidhi, Abu Dawud y otros)</span>. </p>',
            ],
            36 => [
                'question' => 'P 37: ¿Qué súplica se dice cuando llueve?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15870.mp3',
                'answer' => '<p> R- <span class="c1">“Al-lahumma Saiííban nááfi’an. <span class="c2">(¡Oh Señor! Que sea una nube con lluvia que traiga beneficio)</span>”</span>. <span class="c2">(Relatado por Al Bujari)</span>. </p>',
            ],
            37 => [
                'question' => 'P 38: ¿Qué súplica se dice luego de la lluvia?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15900.mp3',
                'answer' => '<p> R- <span class="c1">“MuTirnaa bifaDli Al-láhi wa rahmátihi. <span class="c2">(Ha llovido por la gracia y misericordia de Al-láh)</span>”</span>. <span class="c2">(Al Bujari y Muslim)</span>. </p>',
            ],
            38 => [
                'question' => 'P 39: ¿Qué súplica se dice ante una tormenta de viento?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15930.mp3',
                'answer' => '<p> R- Al-lahumma innii as.áluka héiraha wa a’udhu bika min shérriha. <span class="c2">(Oh Señor ciertamente Te suplico el bien que hay en ella, y me refugio en Ti de su mal”. (Abu Dawud e Ibn Mayah)</span>. </p>',
            ],
            39 => [
                'question' => 'P 40: ¿Qué súplica se dice al escuchar truenos?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15960.mp3',
                'answer' => '<p> R- <span class="c1">“Subháana al-ladhíí iusábbihu arra’du bihámdiji wal maláa.íkatu min híífatihi. <span class="c2">(Glorificado sea Aquel a quien glorifica y alaba el trueno, así como lo hacen los ángeles atemorizados)</span>”</span>. <span class="c2">(Muatta de Malik)</span>. </p>',
            ],
            40 => [
                'question' => 'P 41: ¿Qué súplica se dice si ves a una persona afligida?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15990.mp3',
                'answer' => '<p> R- “Alhámdulil-lahi al-ladhíí ’aafaanii minmaa abtálaka bihi wa faddálanii ’alaa kaziirin minman halaqa afdiilan. <span class="c2">(Alabado sea Al-láh, Quien me ha preservado de aquello con que te ha probado, y me ha favorecido sobre muchos de Su creación)</span>". <span class="c2">(Relatado por Al-Tirmidhi)</span>. </p>',
            ],
            41 => [
                'question' => 'P 42: ¿Qué súplica se dice para quién teme que le suceda algo (envidia o mal de ojo)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16020.mp3',
                'answer' => '<p> R-<span class="c6"> En el hadiz:</span> <span class="c1">“Si alguno de vosotros ve en su hermano o en sí mismo algo que le llame la atención, que pida la bendición de Al-láh para él, porque ciertamente la envidia <span class="c2">(mal de ojo)</span> es cierta y verdadera”</span>. <span class="c2">(Relatado por Ahmad, Ibn Mayah y otros)</span>. </p>',
            ],
            42 => [
                'question' => 'P 43: ¿Cómo pedir las bendiciones sobre el Profeta ﷺ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16050.mp3',
                'answer' => '<p> R- <span class="c1">“Al-lahumma Sal-li ’ala Muhámmadin wa ’ala Aali Muhámmadin kama Sal-laita ’ala Ibrahim wa ’ala Aali Ibrahim ínnaka hámidun mayiid, Al-lahumma barik ’ala Muhámmadin wa ’ala Aali Muhámmadin kama barakta ’ala Ibrahim wa ’ala Ibrahimi ínnaka hámidun mayiid. <span class="c2">(Oh Al-láh, alaba a Muhámmad y a la familia de Muhámmad, como alabaste a Abraham y a la familia de Abraham. Ciertamente, Tú eres Alabado y Majestuoso ¡Oh Al-láh! Bendice a Muhámmad y la familia de Muhámmad, como bendijiste a Abraham y a la familia de Abraham. Por cierto, Tú eres Alabado y Majestuoso)</span>”</span>. <span class="c2">(Hadiz concordado)</span>. </p>',
            ],
        ],
        9 => [
            0 => [
                'question' => 'P 1: ¿Cuáles son las cinco disposiciones obligatorias?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16090.mp3',
                'answer' => '<p> R-<span class="c6"> Las cinco disposiciones obligatorias son:</span><br /> 1- Obligatorio <span class="c2">(Wayib)</span>.<br /> 2- Recomendable <span class="c2">(Mustahabb)</span>.<br /> 3- Prohibido <span class="c2">(Muharram)</span>.<br /> 4- No recomendable <span class="c2">(Mak-ruh)</span>.<br /> 5- Permisible <span class="c2">(Mubah)</span>. </p>',
            ],
            1 => [
                'question' => 'P 2: Explique las cinco disposiciones obligatorias en el Islam.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16170.mp3',
                'answer' => '<p> R-<br /> 1- Obligatorio <span class="c2">(Wayib)</span>: Al igual que las cinco oraciones diarias, el ayuno de Ramadán y honrar a los padres.<br /> -Hacer lo obligatorio <span class="c2">(Wayib)</span> es recompensado, y descuidarlo o dejar de hacerlo es castigable.<br /> 2- Recomendable <span class="c2">(Mustahabb)</span>: como las oraciones regulares de la Sunnah, la oración de la noche y el saludo musulmán, a lo que se les llama Sunnah y Mandub.<br /> -Hacer lo recomendable <span class="c2">(Mustahabb)</span> es recompensado, y no hacerlo no trae un castigo.<span class="c6"><br /> Nota importante:</span><br /> Cuando un musulmán escucha que este asunto es Sunnah o Mandub, debe apresurarse a hacerlo y seguir el ejemplo del Profeta ﷺ.<br /> 3- Prohibido <span class="c2">(Muharram)</span>: como beber alcohol, desobedecer a los padres y cortar los lazos familiares.<br /> - Hacer lo prohibido <span class="c2">(Muharram)</span> es castigable, y el que abandona y se aleja de lo prohibido es recompensado.<br /> 4. No recomendable <span class="c2">(Mak-ruh)</span>: como recibir y dar algo con la mano izquierda o recogerse la ropa durante la oración.<br /> - Lo no recomendable <span class="c2">(Mak-ruh)</span> no es algo castigable, pero quien lo deje será recompensado.<br /> 5. Permisible <span class="c2">(Mubah)</span>: como comer una manzana o beber té.<span class="c6"> Se llama:</span> Yaaiz o también Halal.<br /> -Lo permisible <span class="c2">(Mubah)</span> no es recompensable ni castigable. </p>',
            ],
            2 => [
                'question' => 'P 3: ¿Cuál es la normativa sobre las ventas y las transacciones financieras?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16320.mp3',
                'answer' => '<p> R- El principio básico en todas las ventas y transacciones es que sean permisibles, a excepción de algunos tipos de las que Al-láh ﷻ ha prohibido.<br /> Al-<span class="c6">láh ﷻ dijo:</span> ﴾ <span class="c2">(…)</span> Al-láh permitió el comercio y prohibió la usura <span class="c2">(…)</span> ﴿ <span class="c2">(Traducción del Corán,<span class="c6"> 2:</span>275)</span> </p>',
            ],
            3 => [
                'question' => 'P 4: Mencione algunos tipos de transacciones y ventas prohibidas.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16360.mp3',
                'answer' => '<p> R-<br /> 1- Hacer trampa, por ejemplo, ocultar el defecto de la mercancía.<br /> Abu Huraira- que Al-láh se complazca con él-<span class="c6"> dijo que el Profeta ﷺ dijo:</span> <span class="c1">“Quien nos engaña no es de los nuestros”</span>. La historia de este dicho profético es que el Profeta ﷺ fue al mercado y vio un saco de granos, metió su noble mano en el saco y lo encontró mojado,<span class="c6"> preguntó al vendedor:</span> <span class="c1">“¿Por qué engañas así?”</span>,<span class="c6"> éste le respondió:</span> <span class="c1">“Lo mojó la lluvia”</span>; entonces el Profeta ﷺ dijo: <span class="c1">“¡Tienes que ponerlo al descubierto para que la gente lo vea!”</span>,<span class="c6"> y a continuación dijo:</span> <span class="c1">“Quien nos engaña no es de los nuestros”</span>. <span class="c2">(Relatado por Muslim)</span>.<br /> 2-<span class="c6"> La usura:</span> comprende, por ejemplo, dar una deuda de mil a un deudor y que le devuelva el doble.<br /> El interés de la usura está prohibido.<br /> Al-<span class="c6">láh ﷻ dijo:</span> ﴾ <span class="c2">(…)</span> Al-láh permitió el comercio y prohibió la usura. <span class="c2">(…)</span> ﴿ <span class="c2">(Traducción del Corán,<span class="c6"> 2:</span>275)</span>.<br /> 3-<span class="c6"> La especulación y la ambigüedad:</span> como por ejemplo; vender leche en la ubre de una oveja, o vender un pez que está en el agua y aún no ha sido pescado.<br /> El Mensajero de Al-láh ﷺ prohibió la venta especulativa y ambigua. <span class="c2">(Relatado por Muslim)</span>. </p>',
            ],
            4 => [
                'question' => 'P 5: Mencione algunas de las bendiciones de Al-láh que has recibido.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16460.mp3',
                'answer' => '<p> R- <br /> 1- La bendición del Islam y no ser de la gente de incredulidad.<br /> 2- La bendición de la Sunnah, y no ser de la gente de la innovación.<br /> 3- La bendición de la salud y el bienestar del oído, la vista, el andar y otros.<br /> 4- La bendición de la comida, la bebida y la vestimenta.<br /> Las bendiciones de Al-láh ﷻ sobre nosotros son numerosas e incontables.<br /> Al-<span class="c6">láh ﷻ dijo:</span> ﴾Si intentaran contar las gracias de Al-láh no podrían enumerarlas. Al-láh es Absolvedor, Misericordioso﴿ <span class="c2">(Traducción del Corán,<span class="c6"> 16:</span>18)</span>. </p>',
            ],
            5 => [
                'question' => 'P6: ¿Cuál es nuestro deber con respecto a las bendiciones? ¿Cómo podemos agradecerlas?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16540.mp3',
                'answer' => '<p> R- Nuestro deber con respecto a las bendiciones es ser agradecidos alabando a Al-láh ﷻ con la lengua, reconociendo que sólo Él ﷻ tiene el merecimiento <span class="c5">[de ser alabado]</span>, usar estas bendiciones de manera que agraden a Al-láh ﷻ y no desobedeciéndole. </p>',
            ],
            6 => [
                'question' => 'P 7: ¿Cuáles son las festividades islámicas?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16570.mp3',
                'answer' => '<p> R- Las festividades islámicas son Eid Al-Fitr y Eid Al-Adha.<br /> - Como en el hadiz narrado por Anas -que Al-<span class="c6">láh se complazca con él:</span> <span class="c1">“Cuando el profeta Muhámmad ﷺ llegó a Medina, encontró que los Ansar <span class="c2">(los auxiliadores)</span> que eran los musulmanes de Medina, jugaban y se divertían en dos días determinados del año.<span class="c6"> Les preguntó el Profeta ﷺ:</span> ‘¿Qué hay en estos dos días?’.<span class="c6"> Respondieron:</span> ‘En estos dos días nos entreteníamos antes de la llegada del Islam’. Les dijo el Mensajero de Al-<span class="c6">láh ﷺ:</span> “Ciertamente, Al-<span class="c6">láh os ha cambiado estos días por otros mejores que esos dos días:</span> el Eid Al-Adha <span class="c2">(la festividad del Sacrificio)</span> y el Eid Al-Fitr <span class="c2">(final del ayuno de Ramadán)</span>”</span>. <span class="c2">(Relatado por Abu Dawud)</span>.<br /> Las demás fiestas son innovación en la religión. </p>',
            ],
            7 => [
                'question' => 'P 8: ¿Cuál es el mejor mes?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16620.mp3',
                'answer' => '<p> R- El mejor mes es el mes de Ramadán. </p>',
            ],
            8 => [
                'question' => 'P 9: ¿Cuáles son los mejores días?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16650.mp3',
                'answer' => '<p> R- Los mejores días son los viernes. </p>',
            ],
            9 => [
                'question' => 'P 10: ¿Cuál es el mejor día del año?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16680.mp3',
                'answer' => '<p> R- El mejor día de del año es el día de Arafah. </p>',
            ],
            10 => [
                'question' => 'P 11: ¿Cuál es la mejor noche del año?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16710.mp3',
                'answer' => '<p> R- La mejor noche es la Noche del Decreto. </p>',
            ],
            11 => [
                'question' => 'P 12: ¿Cuál es el deber de un hombre al ver a una mujer ajena a su familia?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16740.mp3',
                'answer' => '<p> R- El deber de un hombre al ver a una mujer ajena a su familia es bajar la mirada. Al-<span class="c6">láh ﷻ dijo:</span> ﴾Diles a los creyentes <span class="c5">[¡oh, Muhámmad!]</span> que recaten sus miradas <span class="c2">(…)</span> ﴿ <span class="c2">(Traducción del Corán,<span class="c6"> 24:</span>30)</span>. </p>',
            ],
            12 => [
                'question' => 'P13: ¿Quiénes son los enemigos del ser humano?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16770.mp3',
                'answer' => '<p> R-<span class="c6"> Los enemigos del ser humano son:</span><br /> 1-<span class="c6"> El espíritu rebelde:</span> éste se manifiesta cuando una persona sigue lo que su espíritu y deseos le dictan en desobediencia a Al-láh ﷻ.<span class="c6"> El Todopoderoso dijo:</span> ﴾No pretendo excusarme, porque el espíritu suele ordenar el mal, y solo están a salvo de ello aquellos a quienes mi Señor los protege. Mi Señor es Absolvedor, Misericordioso” ﴿ <span class="c2">(Traducción del Corán,<span class="c6"> 12:</span>53)</span>. 2-<span class="c6"> Satanás:</span> es el enemigo del hijo de Adán y su objetivo es engañar al hombre susurrándole el mal con el propósito de que lo acompañe en el Infierno. Al-<span class="c6">láh ﷻ dijo:</span> ﴾ <span class="c2">(…)</span> No sigan los pasos del demonio, él es su enemigo declarado﴿ <span class="c2">(Traducción del Corán,<span class="c6"> 2:</span>168)</span>. 3-<span class="c6"> Las malas compañías:</span> aquellos que aconsejan hacer el mal y no permiten hacer el bien. Al-<span class="c6">láh ﷻ dijo:</span> ﴾Ese día los amigos serán enemigos unos de otros, excepto los que hayan tenido temor de Dios﴿ <span class="c2">(Traducción del Corán,<span class="c6"> 43:</span>67)</span>. </p>',
            ],
            13 => [
                'question' => 'P 14: ¿Qué es el arrepentimiento?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16820.mp3',
                'answer' => '<p> R-<span class="c6"> Arrepentimiento:</span> es volver de la desobediencia a Al-láh ﷻ a Su obediencia. Al-<span class="c6">láh ﷻ dijo:</span> ﴾Yo soy Perdonador con quienes se arrepienten, creen, obran rectamente y se encaminan <span class="c5">[por el sendero recto]</span> ﴿ <span class="c2">(Traducción del Corán,<span class="c6"> 20:</span>82)</span>. </p>',
            ],
            14 => [
                'question' => 'P 15: ¿Cuáles son las condiciones para que el arrepentimiento sea aceptado?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16850.mp3',
                'answer' => '<p> R-<span class="c6"> Las condiciones del arrepentimiento sincero son:</span><br /> 1- Abandonar el pecado.<br /> 2- Lamentar la desobediencia.<br /> 3- Decidir no volver a cometer tal desobediencia.<br /> 4- Regresar el derecho de las personas afectadas por tal acción.<br /> Al-<span class="c6">láh ﷻ dijo:</span> ﴾Aquellos que al cometer una obscenidad o injusticia invocan a Al-láh pidiendo perdón por sus pecados, porque saben que solo Al-láh perdona los pecados, y no reinciden a sabiendas﴿ <span class="c2">(Traducción del Corán,<span class="c6"> 3:</span>135)</span>. </p>',
            ],
            15 => [
                'question' => 'P 16: ¿Cuál es el significado de las salutaciones sobre el Profeta ﷺ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16920.mp3',
                'answer' => '<p> R- Las salutaciones sobre el Profeta ﷺ significan que se invoca a Al-láh ﷻ para enaltecer a Su profeta ﷺ. </p>',
            ],
            16 => [
                'question' => 'P 17: ¿Cuál es el significado de “glorificado sea Al-láh”?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16950.mp3',
                'answer' => '<p> R- El significado de la frase <span class="c1">“glorificado sea Al-láh”</span> es reconocer que Él ﷻ es la perfección completa y entera, sin defecto. </p>',
            ],
            17 => [
                'question' => 'P 18: ¿Cuál es el significado de “alabado sea Al-láh”?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16980.mp3',
                'answer' => '<p> R- El significado de la frase <span class="c1">“alabado sea Al-láh”</span> es enaltecer a Al-láh, el Altísimo, y describirlo con todos los atributos de la perfección. </p>',
            ],
            18 => [
                'question' => 'P 19: ¿Cuál es el significado de “Al-láh es lo más grande”?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/17000.mp3',
                'answer' => '<p> R- El significado de la frase <span class="c1">“Al-láh es lo más grande”</span> es reconocer que Su alabanza es más grande que todo, más grandiosa y más querida que todo. </p>',
            ],
            19 => [
                'question' => 'P 20: ¿Cuál es el significado de “no hay poder o fuerza excepto en Al-láh”?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/17030.mp3',
                'answer' => '<p> R - El significado de la frase <span class="c1">“no hay poder o fuerza excepto en Al-láh”</span> es que el siervo acepta sus limitaciones y que el Único con poder sobre todo es Al-láh ﷻ. </p>',
            ],
            20 => [
                'question' => 'P 21: ¿Cuál es el significado de “pido perdón a Al-láh”?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/17060.mp3',
                'answer' => '<p> R- El significado de la frase <span class="c1">“pido perdón a Al-láh”</span> es que el siervo pide y solicita a su Señor que borre sus pecados y oculte sus faltas. </p>',
            ],
        ],
    ],
];
