<?php
$data = [
    'title' => 'Ce qu\'aucun enfant musulman n\'est censé ignorer',
    'description' => 'Un projet qui contient un programme facile et simple pour des sujets qu\'un musulman n\'est pas censé ignorer. Il comprend des sujets de croyance, de jurisprudence, de biographie prophétique, d\'éthique, d\'exégèse, de hadith, de morale et de rappel d\'Allah. Il convient particulièrement aux jeunes enfants de tout âge et aux nouveaux musulmans.',
    'source' => 'https://kids.islamenc.com/fr/home',
    'author' => 'Yazan Abdul Razzaq Raziq Alghanim',
    'sections' => [
        0 => 'Partie : la Croyance',
        1 => 'Partie : Jurisprudence (Al Fiqh)',
        2 => 'Partie :  La biographie prophétique.',
        3 => 'Partie : Exégèse (Tafsîr)',
        4 => 'Partie : Hadith (Hadîth)',
        5 => 'Partie : Les bonnes manières islamiques.',
        6 => 'Partie : Les comportements.',
        7 => 'Partie : les invocations et les évocations.',
        8 => 'Partie : Divers.',
    ],
    'data' => [
        1 => [
            0 => [
                'question' => 'Q1 : Qui est ton Seigneur (Ar-Rabb) ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/200.mp3',
                'answer' => '<p> Réponse <span class="c2">(R)</span> : Mon Seigneur est Allah, Celui qui m’a élevé et qui a élevé l\'ensemble des mondes par Son bienfait.<br /> Et la preuve est Sa parole, Élevé soit-<span class="c6">Il :</span> {Louange à Allah, le Seigneur des mondes <span class="c2">(2)</span> } <span class="c5">[Sourate : L\'Ouverture,<span class="c6"> 1 :</span> 2]</span>. </p>',
            ],
            1 => [
                'question' => 'Q2 : Quelle est ta religion (Ad-Dîn) ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/240.mp3',
                'answer' => '<p> R : Ma religion est l\'Islam ; c\'est la soumission à Allah par pur monothéisme, tout en se soumettant à Lui à travers Son obéissance et en se désavouant du polythéisme et de ses adeptes.<br /> Il <span class="c2">(Élevé soit-Il)</span> a dit : <span class="c4">{Certes, la religion <span class="c5">[agréée]</span> auprès d\'Allah est l’Islam.}</span> <span class="c5">[Sourate : La Famille d’Imrân,<span class="c6"> 3 :</span> 19]</span>. </p>',
            ],
            2 => [
                'question' => 'Q3 : Qui est ton Prophète (An-Nabî) ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/280.mp3',
                'answer' => '<p> R : Mohammed ﷺ.<br /> Il <span class="c2">(Élevé soit-Il)</span> a dit : <span class="c4">{Mohammed est le Messager d\'Allah...}</span> <span class="c5">[Sourate : La Victoire,<span class="c6"> 48 :</span> 29]</span>. </p>',
            ],
            3 => [
                'question' => 'Q4 : Mentionne la parole du monothéisme (Kalimah At-Tawhîd) et sa signification ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/310.mp3',
                'answer' => '<p> R : La parole du monothéisme est : <span class="c3">« Il n’y a aucune divinité excepté Allah. »</span> <span class="c2">(Lâ Ilaha Illâ Llah)</span> dont la signification est : <span class="c3">« Aucune divinité ne mérite d’être adorée, en toute vérité, excepté Allah. »</span><br /> Il <span class="c2">(Élevé soit-Il)</span> a dit : <span class="c4">{Sache donc qu’il n’y a aucune divinité <span class="c5">[digne d\'adoration]</span> excepté Allah.}</span> <span class="c5">[Sourate : Mohammed,<span class="c6"> 47 :</span> 19]</span>. </p>',
            ],
            4 => [
                'question' => 'Q5 : Où est Allah (Exalté et Magnifié soit-Il) ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/350.mp3',
                'answer' => '<p> R : Allah est au-dessus des cieux, au-dessus du Trône, au-dessus de l\'ensemble des créatures. Il <span class="c2">(Élevé soit-Il)</span> a dit : {Le Tout Miséricordieux s\'est établi sur le Trône. <span class="c2">(5)</span> } <span class="c5">[Sourate : Ṭâ-Hâ,<span class="c6"> 20 :</span> 5]</span>.<span class="c6"> Et Il a dit :</span> <span class="c4">{Il est le Dominateur Suprême au-dessus de Ses serviteurs et Il est le Sage, le Parfaitement Informé.}</span> <span class="c5">[Sourate : Les Bestiaux,<span class="c6"> 6 :</span> 18]</span>. </p>',
            ],
            5 => [
                'question' => 'Q6 : Quelle est la signification de l’attestation : « Mohammed est le Messager d’Allah » ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/380.mp3',
                'answer' => '<p> R : Sa signification est qu’Allah l’a envoyé à l’humanité toute entière comme annonciateur <span class="c2">(de bonnes nouvelles)</span> et avertisseur.<span class="c6"><br /> On doit donc :</span><br /> 1. Lui obéir dans <span class="c5">[tout]</span> ce qu\'il a ordonné.<br /> 2- Le déclarer véridique dans <span class="c5">[tout]</span> ce qu\'il a informé.<br /> 3- Ne pas lui désobéir.<br /> 4- Adorer Allah uniquement par ce qu\'il a prescrit, qui est la conformité à sa Tradition <span class="c2">(As Sunnah)</span> et le délaissement de l\'innovation <span class="c5">[en matière de religion]</span>.<br /> Allah <span class="c2">(Élevé soit-Il)</span> a dit : <span class="c4">{Quiconque obéit au Messager, alors assurément il a obéi à Allah...}</span> <span class="c5">[Sourate : Les Femmes,<span class="c6"> 4 :</span> 80]</span>. Il <span class="c2">(Glorifié soit-Il)</span> a <span class="c5">[aussi]</span> dit : {Et il ne prononce rien sur le coup de la passion <span class="c2">(3)</span> ; certes, ce n\'est qu\'une révélation qui lui est révélée <span class="c2">(4)</span> } <span class="c5">[Sourate : L\'Étoile,<span class="c6"> 53 :</span> 3-4]</span>. Il <span class="c2">(Exalté et Magnifié soit-Il)</span> a dit : {Et, assurément, vous avez dans le Messager d’Allah un excellent modèle <span class="c5">[à suivre]</span> pour quiconque espère en Allah et au Jour Dernier et invoque Allah abondamment. <span class="c2">(21)</span> } <span class="c5">[Sourate : Les Coalisés,<span class="c6"> 33 :</span> 21]</span>. </p>',
            ],
            6 => [
                'question' => 'Q7 : Pourquoi Allah (Élevé soit-Il) nous a-t-Il créés ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/480.mp3',
                'answer' => '<p> R : Il nous a créés pour Son adoration, Seul et sans associé.<br /> Et non par futilité ou par jeu.<br /> Il <span class="c2">(Élevé soit-Il)</span> a dit : <span class="c4">{Et Je n’ai créé les djinns et les hommes que pour qu’ils M’adorent.}</span> <span class="c5">[Sourate : Ceux qui Éparpillent,<span class="c6"> 51 :</span> 56]</span>. </p>',
            ],
            7 => [
                'question' => 'Q8 : Qu\'est-ce que l\'adoration (Al \'Ibâda) ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/530.mp3',
                'answer' => '<p> R : C\'est un nom global pour désigner tout ce qu\'Allah aime et agrée parmi les paroles et les œuvres cachées et apparentes.<br /> .<span class="c6"> Apparentes :</span> par exemple, l\'évocation d\'Allah avec la bouche <span class="c5">[oralement]</span> comme : la glorification <span class="c2">(At-Tasbîh)</span>, la louange <span class="c2">(At-Tahmîd)</span>, la proclamation de la grandeur d\'Allah <span class="c2">(At-Takbîr)</span>, la prière, le pèlerinage, etc.<br /> .<span class="c6"> Cachées :</span> par exemple, la confiance en Allah, la crainte, l\'espoir, etc. </p>',
            ],
            8 => [
                'question' => 'Q9 : Quel est le plus immense devoir (Al Wâjib) qui nous incombe ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/580.mp3',
                'answer' => '<p> R : Le plus immense devoir qui nous incombe est : la croyance en l\'Unicité d\'Allah <span class="c2">(Élevé soit-Il)</span>. </p>',
            ],
            9 => [
                'question' => 'Q10 : Quels sont les types d\'unicité (At-Tawhîd) ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/610.mp3',
                'answer' => '<p> R : 1- L\'Unicité dans la Seigneurie <span class="c2">(Tawhîd ar Rubûbiyyah)</span> : C\'est le fait de croire qu\'Allah est le Créateur, le Pourvoyeur, le Souverain, le Gérant, Seul et sans associé.<br /> 2- L\'Unicité dans la Divinité <span class="c2">(Tawhîd al Ulûhiyyah)</span> : C\'est le fait de singulariser Allah par l\'adoration, de sorte que rien ni personne n\'est <span class="c5">[véritablement]</span> adoré excepté Allah <span class="c2">(Élevé soit-Il)</span>.<br /> 3- L\'Unicité dans les Noms et Attributs <span class="c2">(Tawhîd al Asmâ\' wa as Siffât)</span> : C\'est le fait de croire aux Noms et aux Attributs d\'Allah <span class="c2">(Élevé soit-Il)</span> qui ont été rapportés dans le Livre <span class="c5">[le Coran]</span> et la Tradition <span class="c2">(As Sunnah)</span>, sans représentation <span class="c2">(Tamthîl)</span>, ni comparaison <span class="c2">(Tachbîh)</span> et ni reniement <span class="c2">(Ta\'tîl)</span>.<br /> Et la preuve des types d\'Unicité est Sa parole <span class="c2">(Élevé soit-Il)</span> : { <span class="c5">[Il est le]</span> Seigneur des cieux et de la Terre et de tout ce qui est entre eux. Adore-Le donc! Et sois constant dans Son adoration. Est-ce que tu Lui connais un homonyme ? <span class="c2">(65)</span> } <span class="c5">[Sourate : Marie,<span class="c6"> 19 :</span> 65]</span>. </p>',
            ],
            10 => [
                'question' => 'Q11 : Quel est le plus grave des péchés ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/670.mp3',
                'answer' => '<p> R : L\'association à Allah <span class="c2">(Élevé soit-Il)</span>.<br /> Il <span class="c2">(Élevé soit-Il)</span> a dit : {Certes, Allah ne pardonne pas qu’on Lui associe quoi que ce soit. En dehors de cela, Il pardonne à qui Il souhaite. Et quiconque associe quoi que ce soit à Allah, alors assurément il a commis un immense péché. <span class="c2">(48)</span> } <span class="c5">[Sourate : Les Femmes,<span class="c6"> 4 :</span> 48]</span>. </p>',
            ],
            11 => [
                'question' => 'Q12 : Mentionne le polythéisme (Ach Chirk) et ses divers types ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/710.mp3',
                'answer' => '<p> R : Le polythéisme consiste à vouer n\'importe quel type d\'adoration à un autre qu\'Allah <span class="c2">(Élevé soit-Il)</span>.<span class="c6"><br /> Ses types :</span><br /> Le polythéisme majeur : comme par exemple : invoquer autre qu\'Allah <span class="c2">(Élevé soit-Il)</span>, se prosterner pour autre que Lui <span class="c2">(Glorifié soit-Il)</span> ou effectuer un sacrifice pour autre qu\'Allah <span class="c2">(Exalté et Magnifié soit-Il)</span>.<span class="c6"><br /> Le polythéisme mineur :</span> comme par exemple : jurer par autre qu\'Allah <span class="c2">(Élevé soit-Il)</span>, porter des amulettes <span class="c5">[c\'est-à-<span class="c6">dire :</span> des choses que l\'on attache pour attirer un bénéfice ou repousser un mal]</span> ou faire preuve d\'ostentation, comme le fait d\'embellir sa prière lorsque des gens nous regardent. </p>',
            ],
            12 => [
                'question' => 'Q13 : Est-ce que quelqu\'un en dehors d\'Allah (Élevé soit-Il) connait l\'Invisible (Al Ghayb) ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/770.mp3',
                'answer' => '<p> R : Nul ne connaît l\'Invisible excepté Allah, Seul.<br /> Il <span class="c2">(Élevé soit-Il)</span> a dit : {Dis : " Quiconque est dans les cieux et sur la Terre ne connaît l\'Inconnaissable, excepté Allah. Et ils n\'ont aucune idée quand ils seront ressuscités. " <span class="c2">(65)</span> } <span class="c5">[Sourate : Les Fourmis,<span class="c6"> 27 :</span> 65]</span>. </p>',
            ],
            13 => [
                'question' => 'Q14 : Énumère les piliers de la foi (Arkâne al Îmân) ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/810.mp3',
                'answer' => '<p> R : 1- La foi en Allah <span class="c2">(Élevé soit-Il)</span> :<br /> 2- En Ses Anges.<br /> 3- En Ses Livres.<br /> 4- En Ses Messagers.<br /> 5- Au Jour Dernier.<br /> 6- Et le Destin, en son bien et en son mal.<span class="c6"><br /> Et la preuve réside dans le célèbre hadith de Gabriel rapporté par Mouslim :</span> Gabriel <span class="c2">(paix sur lui)</span> dit au Prophète ﷺ : " Informe-<span class="c6">moi donc à propos de la foi ? " Il répondit :</span> " La foi consiste à croire en Allah, Ses Anges, Ses Livres, Ses Messagers, au Jour Dernier et que tu crois au Destin, en son bien et en son mal. " </p>',
            ],
            14 => [
                'question' => 'Q15 : Explique les piliers de la foi ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/900.mp3',
                'answer' => '<p> R : La foi en Allah <span class="c2">(Élevé soit-Il)</span> :<br /> 1- Tu crois qu\'Allah est Celui qui t\'a créé et t\'a pourvu. Il est le Souverain et le Gérant unique des créatures.<br /> 2- Il est Celui qui est adoré et rien ni personne n\'est digne d\'être adoré en dehors de Lui.<br /> 3- Il est le Majestueux, le Grand, le Parfait ; Celui à qui reviennent toutes les louanges ; Celui qui possède les Noms les plus beaux ainsi que les Attributs les plus hauts ; Il n\'a pas d\'égal et rien ni personne ne Lui <span class="c2">(Glorifié soit-Il)</span> est comparable.<span class="c6"><br /> La foi aux Anges :</span><br /> Ce sont des créatures qu\'Allah a créées de lumière pour Son adoration et pour leur soumission parfaite à Son ordre.<br /> Parmi eux,<span class="c6"> il y a :</span> Gabriel <span class="c2">(paix sur lui)</span>, celui qui fait descendre la Révélation sur les prophètes <span class="c2">(paix sur eux)</span>.<span class="c6"><br /> La foi aux Livres :</span><br /> Ce sont les Livres qu\'Allah a fait descendre sur Ses Messagers.<br /> -<span class="c6"> Comme :</span> le Coran sur Mohammed ﷺ.<br /> - L\'Évangile sur Jésus <span class="c2">(paix sur lui)</span>.<br /> - La Torah sur Moïse <span class="c2">(paix sur lui)</span>.<br /> - Les Psaumes sur David <span class="c2">(paix sur lui)</span>.<br /> - Les Feuillets d\'Abraham et de Moïse sur Abraham et Moïse <span class="c2">(paix sur eux deux)</span>.<span class="c6"><br /> La foi aux Messagers :</span><br /> Ce sont ceux qu\'Allah a envoyés à Ses serviteurs afin qu\'ils leur enseignent, leur annoncent les bonnes nouvelles et le Paradis et les avertissent du mal et de l\'Enfer.<br /> -<span class="c6"> Les meilleurs d\'entre eux sont les Messagers doués de résolution qui sont :</span><br /> Noé <span class="c2">(paix sur lui)</span>.<br /> Abraham <span class="c2">(paix sur lui)</span>.<br /> Moïse <span class="c2">(paix sur lui)</span>.<br /> Jésus <span class="c2">(paix sur lui)</span>.<br /> Mohammed ﷺ.<span class="c6"><br /> La foi au Jour Dernier :</span><br /> C\'est ce qui se passe après la mort dans la tombe, le Jour de la Résurrection, le Jour du Renvoi <span class="c5">[à la vie après avoir goûté à la mort]</span> et du Jugement, de sorte que les gens du Paradis résident dans leurs demeures et les gens de l\'Enfer résident dans les leurs.<br /> La foi au Destin <span class="c2">(Al Qadr)</span>,<span class="c6"> en son bien et son mal :</span><br /> Le Destin correspond au fait de croire qu\'Allah a connaissance de toute chose se produisant dans l\'univers, de croire qu\'Il a écrit cela dans la Tablette Préservée <span class="c2">(Al-Lawh Al Mahfûz)</span>, de croire qu\'Il a voulu son existence et qu\'Il l\'a créé.<br /> Il <span class="c2">(Élevé soit-Il)</span> a dit : <span class="c4">{Certes, Nous avons créé toute chose avec mesure. }</span> <span class="c5">[Sourate : La Lune,<span class="c6"> 54 :</span> 49]</span>.<br /> -<span class="c6"> Et il est de quatre degrés :</span><br /> Le premier : La connaissance d\'Allah <span class="c2">(Élevé soit-Il)</span>. Et parmi cela, Sa connaissance antérieure de toute chose avant qu\'elles ne surviennent et après leur survenue.<br /> La preuve est Sa parole <span class="c2">(Élevé soit-Il)</span> : {Certes, Allah détient la connaissance de l\'Heure ; Il fait tomber la pluie bénéfique ; Il connait ce qu’il y a dans les utérus <span class="c5">[de toute femme enceinte]</span> ; aucune âme ne sait ce qu’elle acquerra demain, et aucune âme ne sait sur quelle terre elle mourra. Certes, Allah est Omniscient, Parfaitement Informé. <span class="c2">(34)</span> } <span class="c5">[Sourate : Luqmân,<span class="c6"> 31 :</span> 34]</span>.<span class="c6"><br /> Le second :</span> Allah a écrit cela dans la Tablette Préservée <span class="c2">(Al Lawh-Al Mahfoûz)</span>. Ainsi, toute chose qui s\'est produite et se produira est écrite auprès de Lui dans un Livre.<br /> La preuve est Sa parole <span class="c2">(Élevé soit-Il)</span> : { Et Il possède les clés de l\'Invisible ; nul autre que Lui ne les connaît. Il connaît tout ce qui est sur la terre et dans la mer. Pas une feuille ne tombe sans qu’Il ne le sache. Et il n’y a pas une graine dans les ténèbres de la terre, rien d\'humide ou de sec, qui ne soit consigné dans un livre explicite. <span class="c2">(59)</span> } <span class="c5">[Sourate : Les Bestiaux,<span class="c6"> 6 :</span> 59]</span>.<span class="c6"><br /> Le troisième :</span> Toute chose qui se produit l\'est par la volonté d\'Allah et rien n\'émane de Lui ou de Sa création sans Sa volonté <span class="c2">(Élevé soit-Il)</span>.<br /> La preuve est Sa parole <span class="c2">(Élevé soit-Il)</span> : {Pour quiconque parmi vous souhaite être droit <span class="c2">(28)</span> ; mais vous ne pouvez vouloir, que si Allah <span class="c5">[le]</span> veut, le Seigneur des mondes. <span class="c2">(29)</span> } <span class="c5">[Sourate : L\'Obscurcissement,<span class="c6"> 81 :</span> 28-29]</span>.<span class="c6"><br /> Le quatrième :</span> croire que tous les êtres existants sont des créatures et qu\'Allah a créés. Il a créé leurs entités, leurs attributs, leurs mouvements et toute chose qu\'ils contiennent.<br /> La preuve est Sa parole <span class="c2">(Élevé soit-Il)</span> : {Et <span class="c5">[pourtant]</span> Allah vous a créés et ce que vous faites. <span class="c2">(96)</span> } <span class="c5">[Sourate : Ceux qui sont rangés,<span class="c6"> 37 :</span> 96]</span>. </p>',
            ],
            15 => [
                'question' => 'Q16 : Quelle est la définition du Coran ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1300.mp3',
                'answer' => '<p> R : C\'est la Parole d\'Allah <span class="c2">(Élevé soit-Il)</span> qui est incréée.<br /> 6- Et le Destin, en son bien et en son mal. <span class="c4">{Et si l\'un des polythéistes te demande asile, alors donne-le lui afin qu\'il entende la parole d\'Allah...}</span> <span class="c5">[Sourate : Le Repentir,<span class="c6"> 9 :</span> 6]</span>. </p>',
            ],
            16 => [
                'question' => 'Q17 : Qu\'est-ce que la Tradition prophétique (As Sunnah) ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1330.mp3',
                'answer' => '<p> R : La Tradition prophétique désigne toute parole, acte, approbation ou caractéristique physique et morale du Prophète ﷺ. </p>',
            ],
            17 => [
                'question' => 'Q18 : Qu’est-ce que l’innovation (Al Bid\'a) ? Est-ce que nous l’acceptons ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1350.mp3',
                'answer' => '<p> R : L’innovation désigne tout ce que les gens ont inventé dans la religion et qui n’était pas présent à l’époque du Prophète ﷺ ni de ses Compagnons <span class="c2">(qu’Allah les agrée)</span>.<br /> * Nous ne l\'acceptons pas et nous la rejetons.<span class="c6"><br /> En raison de la parole du Prophète ﷺ :</span> <span class="c3">« Toute innovation est égarement. »</span> Rapporté par Abû Dâwud.<span class="c6"><br /> Par exemple :</span> L\'ajout dans l’adoration, comme ajouter un quatrième lavage lors des ablutions, ou bien fêter l’anniversaire du Prophète ﷺ,... Cela n’a pas été rapporté du Prophète ﷺ ni de ses Compagnons <span class="c2">(qu’Allah les agrée)</span>. </p>',
            ],
            18 => [
                'question' => 'Q19 : Mentionne la croyance concernant l’alliance (Al Walâ) et le désaveu (Al Barâ) ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1410.mp3',
                'answer' => '<p> R : -<span class="c6"> L’alliance :</span> C’est l’amour des croyants et le fait de les secourir.<br /> Il <span class="c2">(Élevé soit-Il)</span> a dit : <span class="c4">{Les croyants et les croyantes sont alliés les uns des autres...}</span> <span class="c5">[Sourate : Le Repentir,<span class="c6"> 9 :</span> 71]</span>.<br /> -<span class="c6"> Le désaveu :</span> C’est la détestation des mécréants et leur inimitié.<br /> Il <span class="c2">(Élevé soit-Il)</span> a dit : <span class="c4">{Assurément, vous avez eu un bel exemple <span class="c5">[à suivre]</span> en Abraham et en ceux qui étaient avec lui,<span class="c6"> lorsqu\'ils ont dit à leur peuple :</span> " Nous vous désavouons, vous et ce que vous adorez en dehors d\'Allah. Nous vous renions. Entre vous et nous, l\'inimitié et la haine sont à jamais déclarées jusqu\'à ce que vous croyiez en Allah, Seul.}</span> <span class="c5">[Sourate : L\'Éprouvée,<span class="c6"> 60 :</span> 4]</span>. </p>',
            ],
            19 => [
                'question' => 'Q20 : Est-ce qu\'Allah ﷻ accepte une religion autre que l’Islam ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1480.mp3',
                'answer' => '<p> R : Allah n’accepte aucune religion autre que l’Islam.<br /> Il <span class="c2">(Élevé soit-Il)</span> a dit : {Et quiconque recherche une religion autre que l\'Islam, cela ne sera pas accepté de lui, et dans l\'au-delà, il sera parmi les perdants. <span class="c2">(85)</span> } <span class="c5">[Sourate : La Famille d’Imrân,<span class="c6"> 3 :</span> 85]</span>. </p>',
            ],
            20 => [
                'question' => 'Q21 : La mécréance (al Kufr) peut être matérialisée à travers la parole, les actes et la croyance. Donne un exemple de cela ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1520.mp3',
                'answer' => '<p> R : -<span class="c6"> Exemple de la parole :</span> Insulter Allah <span class="c2">(Glorifié soit-Il)</span> ou Son Messager ﷺ.<span class="c6"><br /> • Exemple de l\'œuvre :</span> Manquer de respect au Coran <span class="c2">(il est question ici du livre dans sa forme physique)</span> ou se prosterner pour un autre qu’Allah <span class="c2">(Élevé soit-Il)</span>.<span class="c6"><br /> • Exemple de la croyance :</span> Croire qu’il y a quelqu\'un ou quelque chose qui mérite l’adoration en dehors d’Allah <span class="c2">(Élevé soit-Il)</span> ou qu’il existe un créateur avec Allah <span class="c2">(Élevé soit-Il)</span>. </p>',
            ],
            21 => [
                'question' => 'Q22 : Qu’est-ce que l’hypocrisie (An Nifâq) et quelles sont ses catégories ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1570.mp3',
                'answer' => '<p> R :<br /> 1.<span class="c6"> L’hypocrisie majeure :</span> C\'est le fait de cacher la mécréance <span class="c5">[en soi-même]</span> et de manifester la foi <span class="c5">[aux autres]</span>.<br /> Elle exclut <span class="c5">[la personne]</span> de l\'Islam et elle fait partie de la mécréance majeure.<br /> Il <span class="c2">(Élevé soit-Il)</span> a dit : {Certes, les hypocrites seront au plus bas fond du Feu et tu ne leur trouveras jamais de secoureur. <span class="c2">(145)</span> } <span class="c5">[Sourate : Les Femmes,<span class="c6"> 4 :</span> 145]</span>.<br /> 2.<span class="c6"> L’hypocrisie mineure :</span><br /> Par exemple : C\'est le fait de mentir, manquer à sa promesse ou encore trahir le dépôt confié.<br /> Elle n\'exclut pas <span class="c5">[la personne]</span> de l’Islam, bien qu’elle fasse partie des péchés et que son auteur est exposé au châtiment.<span class="c6"><br /> Le Messager d\'Allah ﷺ a dit :</span> <span class="c3">« Les signes de l’hypocrite sont au nombre de trois : Lorsqu\'il parle, il ment ; lorsqu\'il promet, il ne tient pas sa promesse ; et lorsqu\'on lui fait confiance, il trahit. »</span> Rapporté par Al Bukhârî et Muslim. </p>',
            ],
            22 => [
                'question' => 'Q23 : Qui est le sceau des Prophètes et des Envoyés ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1680.mp3',
                'answer' => '<p> R : Mohammed ﷺ.<br /> Il <span class="c2">(Élevé soit-Il)</span> a dit : <span class="c4">{Mohammed n\'a jamais été le père de l\'un de vos hommes, mais il est le Messager d\'Allah et le sceau des Prophètes...}</span> <span class="c5">[Sourate : Les Coalisés,<span class="c6"> 33 :</span> 40]</span>.<span class="c6"> Le Messager d\'Allah ﷺ a dit :</span> " Je suis le sceau des Prophètes ; il n\'y a plus de prophète après moi. " Rapporté par Abû Dâwud, at Tirmidhi et autres. </p>',
            ],
            23 => [
                'question' => 'Q24 : Qu’est-ce qu’un miracle ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1730.mp3',
                'answer' => '<p> R : Un miracle désigne tout ce qu’Allah a accordé à Ses Prophètes comme phénomènes extraordinaires pour témoigner de leur véracité,<span class="c6"> comme par exemple :</span><br /> - La séparation de la lune en deux accordée au Prophète ﷺ.<br /> - La séparation de la mer accordée à Moïse <span class="c2">(paix sur lui)</span> et la noyade de Pharaon et ses armées. </p>',
            ],
            24 => [
                'question' => 'Q25 : Qui sont les Compagnons (As-Sahâbah) ? Et est-ce que je les aime ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1780.mp3',
                'answer' => '<p> R : Un Compagnon correspond à celui qui a rencontré le Prophète ﷺ, a cru en lui et est mort musulman.<br /> Nous les aimons et nous les suivons. Ils sont les meilleurs et les plus émérites des hommes après les Prophètes.<br /> Les meilleurs d\'entre eux sont les quatre califes bien-<span class="c6">guidés :</span><br /> Abû Bakr <span class="c2">(qu\'Allah l\'agrée)</span>.<br /> \'Umar <span class="c2">(qu\'Allah l\'agrée)</span>.<br /> \'Uthmân <span class="c2">(qu\'Allah l\'agrée)</span>.<br /> \'Alî <span class="c2">(qu\'Allah l\'agrée)</span>. </p>',
            ],
            25 => [
                'question' => 'Q26 : Qui sont les mères des croyants ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1870.mp3',
                'answer' => '<p> R : Elles sont les épouses du Prophète ﷺ.<br /> Il <span class="c2">(Élevé soit-Il)</span> a dit : <span class="c4">{Le Prophète a plus de droit sur les croyants qu\'ils n\'en ont sur eux-mêmes ; et ses épouses sont leurs mères.}</span> <span class="c5">[Sourate : Les Coalisés,<span class="c6"> 33 :</span> 6]</span>. </p>',
            ],
            26 => [
                'question' => 'Q27 : Quel est le droit de la famille du Prophète ﷺ sur nous ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1910.mp3',
                'answer' => '<p> R : Nous les aimons, nous les prenons comme alliés et nous détestons quiconque les déteste. Toutefois, nous n\'exagérons pas en ce qui les concerne. Ils sont ses épouses, sa descendance mais aussi les croyants parmi Bani Hâchim et Bani Al Muttalib. </p>',
            ],
            27 => [
                'question' => 'Q28 : Quel est notre devoir à l\'égard des dirigeants musulmans ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1940.mp3',
                'answer' => '<p> R : Notre obligation <span class="c5">[envers eux]</span> est de les respecter, les écouter et leur obéir dans tout ce qui ne constitue pas une désobéissance <span class="c5">[à Allah]</span>. On ne se révolte pas contre eux, on invoque en leur faveur et on les conseille secrètement. </p>',
            ],
            28 => [
                'question' => 'Q29 : Quelle est la demeure des croyants ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1970.mp3',
                'answer' => '<p> R : Le Paradis <span class="c2">(Al Jannah)</span>. Allah <span class="c2">(Élevé soit-Il)</span> a dit : <span class="c4">{Certes, Allah fait entrer ceux qui ont cru et accompli les bonnes œuvres dans des Jardins sous lesquels coulent les ruisseaux.}</span> <span class="c5">[Sourate : Muhammad,<span class="c6"> 47 :</span> 12]</span>. </p>',
            ],
            29 => [
                'question' => 'Q30 : Quelle est la demeure des mécréants ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2000.mp3',
                'answer' => '<p> R : L\'Enfer <span class="c2">(An-Nâr)</span>. Allah <span class="c2">(Élevé soit-Il)</span> a dit : {Craignez donc le Feu qu\'alimenteront les hommes et les pierres qui a été préparé pour les mécréants <span class="c2">(24)</span> } <span class="c5">[Sourate : La Vache,<span class="c6"> 2 :</span> 24]</span>. </p>',
            ],
            30 => [
                'question' => 'Q31 : Qu’est-ce que la peur ? Qu\'est-ce que l’espoir ? Quelle est la preuve de ceci et de cela ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2020.mp3',
                'answer' => '<p> R : La peur : C’est la peur d’Allah et de Sa punition.<span class="c6"><br /> L’espoir :</span> C’est l’espoir de la rétribution d’Allah, Son pardon et Sa miséricorde.<br /> La preuve est Sa parole <span class="c2">(Élevé soit-Il)</span> : <span class="c4">{Ceux qu’ils invoquent, cherchent <span class="c5">[eux-mêmes]</span>, à qui mieux, le moyen de se rapprocher le plus de leur Seigneur. Ils espèrent Sa miséricorde et craignent Son châtiment. Certes, le châtiment de ton Seigneur est vraiment redouté.}</span> <span class="c5">[Sourate : Le Voyage Nocturne,<span class="c6"> 17 :</span> 57]</span>. Il <span class="c2">(Élevé soit-Il)</span> a dit : {Informe Mes serviteurs que certes, c\'\'est Moi le Pardonneur, le Très Miséricordieux <span class="c2">(49)</span> et que Mon châtiment est le châtiment douloureux. <span class="c2">(50)</span> } <span class="c5">[Sourate : Al Hijr,<span class="c6"> 15 :</span> 49-50]</span>. </p>',
            ],
            31 => [
                'question' => 'Q32 : Mentionne quelques Noms (Asmâ\') et Attributs (Sifât) d’Allah ﷻ ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2070.mp3',
                'answer' => '<p> R : Allah, Le Seigneur, Le Tout-Miséricordieux, L’Audient, Le Clairvoyant, L’Omniscient, Le Grand Pourvoyeur, Le Vivant, L’Immense, etc. parmi les plus beaux Noms et les plus hauts Attributs d’Allah <span class="c2">(Élevé soit-Il)</span>. </p>',
            ],
            32 => [
                'question' => 'Q33 : Explique ces Noms ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2100.mp3',
                'answer' => '<p> R : • Allah : Sa signification est : La véritable Divinité adorée uniquement et sans associé.<span class="c6"><br /> • Le Seigneur :</span> C’est-à-<span class="c6">dire :</span> Le Créateur, le Souverain, le Grand Pourvoyeur et le Seul Régisseur <span class="c2">(Glorifié soit-Il)</span>.<span class="c6"><br /> • L\' Audient :</span> Celui dont l’ouïe cerne toute chose, Il entend tous les sons aussi différents et divers soient-ils.<span class="c6"><br /> • Le Clairvoyant :</span> Celui qui voit toute chose et qui est clairvoyant sur toute chose, petite ou grande.<span class="c6"><br /> • L’Omniscient :</span> Il est Celui dont la science a embrassé toute chose, que cela concerne le passé, le présent ou le futur.<br /> • Le Tout-<span class="c6">Miséricordieux :</span> Celui dont la miséricorde a englobé toute créature et tout être vivant. Ainsi donc, tous les serviteurs et toutes les créatures sont sous Sa miséricorde.<span class="c6"><br /> • Le Grand Pourvoyeur :</span> Celui qui est en charge de la subsistance de l’ensemble des créatures, parmi les hommes, les djinns et toutes les bêtes.<span class="c6"><br /> • Le Vivant :</span> Le Vivant, Celui qui ne meurt pas tandis que <span class="c5">[l’ensemble de]</span> la création meurt <span class="c5">[et est vouée à disparaître]</span>.<span class="c6"><br /> • L’Immense :</span> Celui qui possède toute la Perfection et toute la Grandeur dans Ses Noms, Ses Attributs et Ses actes. </p>',
            ],
            33 => [
                'question' => 'Q34 : Quelle est notre obligation envers les savants musulmans ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2210.mp3',
                'answer' => '<p> R : Nous les aimons et nous revenons vers eux concernant les questions religieuses et les évènements <span class="c5">[qui touchent la communauté]</span>. Nous ne les mentionnons qu\'en bien et quiconque les mentionne différemment de cela, notamment en mal, alors cette personne n’est pas sur le bon chemin.<br /> Il <span class="c2">(Élevé soit-Il)</span> a dit : {Allah élève en degrés ceux d\'entre vous qui ont cru et ceux qui ont reçu le savoir. Et Allah est bien Informé de ce que vous accomplissez. <span class="c2">(11)</span> } <span class="c5">[Sourate : La Discussion,<span class="c6"> 58 :</span> 11]</span>. </p>',
            ],
            34 => [
                'question' => 'Q35 : Qui sont les alliés (Al Awliyâ\') d’Allah (Élevé soit-Il) ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2240.mp3',
                'answer' => '<p> R : Ce sont les croyants pieux.<br /> Il <span class="c2">(Élevé soit-Il)</span> a dit : {N\'est-ce pas que les alliés d\'Allah seront à l\'abri de toute crainte et ils ne seront point attristés <span class="c2">(62)</span> ceux qui ont cru et craint <span class="c5">[Allah]</span> <span class="c2">(63)</span>. } <span class="c5">[Sourate : Jonas,<span class="c6"> 10 :</span> 62-63]</span>. </p>',
            ],
            35 => [
                'question' => 'Q36 : Est-ce que la Foi (Al Îmâne) est [seulement] une parole et une œuvre ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2280.mp3',
                'answer' => '<p> R : La foi est une parole, une œuvre et une croyance. </p>',
            ],
            36 => [
                'question' => 'Q37 : Est-ce que la foi augmente et diminue ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2310.mp3',
                'answer' => '<p> R : La foi augmente avec l’obéissance <span class="c5">[à Allah]</span> et elle diminue avec la désobéissance <span class="c5">[à Allah]</span>.<br /> Il <span class="c2">(Élevé soit-Il)</span> a dit : {Certes, les <span class="c5">[véritables]</span> croyants sont ceux qui, lorsque le nom d’Allah est mentionné, leurs cœurs frémissent de crainte ; et lorsque leur sont récités Ses versets, leur foi augmente. Et ils placent leur confiance en leur Seigneur. <span class="c2">(2)</span> } <span class="c5">[Sourate : Les Prises de Guerre,<span class="c6"> 8 :</span> 2]</span>. </p>',
            ],
            37 => [
                'question' => 'Q38 : Qu\'est-ce que la bienfaisance (Al Ihsâne) ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2350.mp3',
                'answer' => '<p> R : C\'est le fait d\'adorer Allah comme si tu Le voyais... Toutefois, si tu ne Le vois pas, Lui te voit. </p>',
            ],
            38 => [
                'question' => 'Q39 : Quand est-ce que les œuvres sont acceptées par Allah (Glorifié soit-Il) ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2370.mp3',
                'answer' => '<p> R : Elles sont acceptées lorsqu’elles remplissent deux conditions :<br /> 1- Lorsqu\'elle est vouée sincèrement pour le Visage d\'Allah <span class="c2">(Élevé soit-Il)</span>.<br /> 2- Lorsqu’elles sont conformes à la Tradition <span class="c2">(As Sunnah)</span> du Prophète ﷺ. </p>',
            ],
            39 => [
                'question' => 'Q40 : Qu\'est-ce que placer sa confiance (At-Tawakkul) en Allah (Élevé soit-Il) ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2420.mp3',
                'answer' => '<p> R : C’est le fait de compter sur Allah <span class="c2">(Élevé soit-Il)</span> dans le fait d’obtenir les bienfaits et repousser les méfaits, tout en accomplissant les causes nécessaires.<br /> Il <span class="c2">(Élevé soit-Il)</span> a dit : <span class="c4">{Et quiconque place sa confiance en Allah, alors Il lui suffit...}</span> <span class="c5">[Sourate : Le Divorce,<span class="c6"> 65 :</span> 3]</span>.<br /> <span class="c4">{Il lui suffit...}</span> : C\'est-à-<span class="c6">dire :</span> Il le contente. </p>',
            ],
            40 => [
                'question' => 'Q41 : Qu\'est-ce que l’obligation d’ordonner le convenable et d’interdire le blâmable?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2470.mp3',
                'answer' => '<p> R : Le convenable : C’est le fait d\'ordonner toute obéissance à Allah <span class="c2">(Exalté et Magnifié soit-Il)</span>.<span class="c6"> Le blâmable :</span> C’est le fait d\'interdire toute désobéissance à Allah <span class="c2">(Élevé soit-Il)</span>.<br /> Il <span class="c2">(Élevé soit-Il)</span> a dit : <span class="c4">{Vous êtes la meilleure communauté qu\'on ait fait surgir pour les hommes : vous ordonnez le convenable, vous interdisez le blâmable et vous croyez en Allah...}</span> <span class="c5">[Sourate : La Famille d’Imrân,<span class="c6"> 3 :</span> 110]</span>. </p>',
            ],
            41 => [
                'question' => 'Q42 : Qui sont « Les Gens de la Tradition et du Groupe » (Ahl as Sunnah wal Jama’a) ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2510.mp3',
                'answer' => '<p> R : Ils sont ceux se tenant sur la même voie que le Prophète ﷺ ainsi que ses Compagnons concernant les paroles, les œuvres et la croyance.<br /> Ils ont été nommé <span class="c3">« Les Gens de la Tradition »</span> en raison de leur suivi de la Tradition du Prophète ﷺ et leur délaissement de l\'innovation religieuse.<br /> <span class="c3">« Et du Groupe »</span> : Car ils se sont réunis sur la Vérité et ne se sont pas divisés à son sujet. </p>',
            ],
        ],
        2 => [
            0 => [
                'question' => 'Q1 : Définis la purification (At-Tahârah) ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2580.mp3',
                'answer' => '<p> R : La purification désigne le fait d\'ôter l\'impureté et de faire disparaître la souillure.<span class="c6"><br /> La purification de la souillure :</span> C\'est le fait que le musulman fasse disparaître l\'impureté qui a touché son corps, son habit ou l\'endroit et le lieu dans lequel il prie.<span class="c6"><br /> La purification de l\'impureté :</span> C\'est le fait d\'accomplir l\'ablution mineure <span class="c2">(Al Wudu)</span> ou l\'ablution majeure <span class="c2">(Al Ghusl)</span> avec de l\'eau pure ; ou d\'accomplir l\'ablution sèche <span class="c2">(At-Tayammum)</span> en cas d\'absence d\'eau ou en raison d\'une excuse justifiant l\'impossibilité d\'utiliser de l\'eau. </p>',
            ],
            1 => [
                'question' => 'Q2 : Comment purifies-tu ce qui a été touché par la souillure (An Najâsa) ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2630.mp3',
                'answer' => '<p> R : Par le lavage avec de l\'eau jusqu\'à ce qu\'il soit pur.<br /> - Quant à ce qui a été léché par le chien, on doit le laver sept fois dont la première avec de la terre. </p>',
            ],
            2 => [
                'question' => 'Q3 : Quel est le mérite de l\'ablution (Al Wudu) ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2660.mp3',
                'answer' => '<p> Le Prophète ﷺ a dit : " Lorsque le musulman - ou le croyant - fait ses ablutions et se lave le visage, chaque péché qu’il a commis en regardant avec ses yeux sort de son visage avec l’eau, ou avec la dernière goutte d’eau. Lorsqu’il se lave les mains, chaque péché qu’il a commis avec ses mains sort de celles-ci avec l’eau, ou avec la dernière goutte d’eau. Lorsqu’il se lave les pieds, chaque péché qu’il a commis en se déplaçant ici et là sort de ses pieds avec l’eau, ou avec la dernière goutte d’eau. Ainsi, il ressort de ses ablutions pur de tout péché. " Rapporté par Muslim. </p>',
            ],
            3 => [
                'question' => 'Q4 : Comment te purifies-tu ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2690.mp3',
                'answer' => '<p> R : Tu te laves les mains trois fois.<br /> Tu te gargarises la bouche, tu aspires de l\'eau par le nez et tu l\'expulses, trois fois.<br /> La gargarisation consiste à mettre de l\'eau dans sa bouche, de la faire tourner dans sa bouche puis de la recracher.<br /> L\'aspiration consiste à mettre de l\'eau dans son nez de sa main droite.<br /> L\'expulsion consiste à faire ressortir l\'eau du nez de sa main gauche après l\'avoir aspiré.<br /> Ensuite, tu te laves le visage trois fois.<br /> Puis tu te laves les mains et les bras jusqu\'aux coudes, trois fois.<br /> Ensuite, tu t\'essuies la tête de l\'avant à l\'arrière, en revenant, et tu t\'essuies les oreilles.<br /> Puis, tu te laves les pieds jusqu\'aux chevilles.<span class="c6"><br /> Ceci est ce qui est le plus complet et cela a été attesté de la part du Prophète ﷺ dans des hadiths rapportés par Al Bukhâri et Muslim dont les rapporteurs sont :</span> \'Uthmân, \'Abd Allah ibn Zayd et d\'autres. De même, toujours chez Al Bukhâri ainsi que d\'autres,<span class="c6"> il a été attesté que :</span> " Parfois, il effectuait ses ablutions en une fois ; parfois, il effectuait ses ablutions en deux fois ; etc. " C\'est-à-dire qu\'il se lavait chaque membre qu\'une seule fois ou deux fois. </p>',
            ],
            4 => [
                'question' => 'Q5 Quelles sont les obligations de l\'ablution et quel est leur nombre ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2810.mp3',
                'answer' => '<p> R : Elles sont celles qui invalident les ablutions dans le cas où le musulman en délaisserait une parmi elles lors de l\'accomplissement de la purification.<br /> 1- Le lavage du visage et notamment la gargarisation et l\'aspiration.<br /> 2- Le lavage des mains jusqu\'aux coudes.<br /> 3- L\'essuyage de la tête et notamment des oreilles.<br /> 4- Le lavage des pieds jusqu\'aux chevilles.<br /> 5- L\'ordre entre les membres,<span class="c6"> à savoir :</span> le lavage du visage ; le lavage des mains jusqu\'aux coudes ; l\'essuyage de la tête ; le lavage des pieds.<br /> 6-<span class="c6"> La continuité :</span> c\'est le fait d\'accomplir les ablutions durant un seul et même temps qui se suit sans séparation, de sorte que les membres sèchent entretemps.<br /> - C\'est comme s\'il effectuait la moitié des ablutions et qu\'il terminait le reste à un autre moment. De telles ablutions ne sont pas valides. </p>',
            ],
            5 => [
                'question' => 'Q6 : Quelles sont les actes recommandés de l\'ablution et quel est leur nombre ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2910.mp3',
                'answer' => '<p> R : Les actes recommandés de l\'ablution représentent les actes méritoires qui augmentent la récompense de celui qui les accomplis ; toutefois, celui qui les délaisse n\'aura pas commis de faute et ses ablutions seront tout à fait valide.<br /> 1- L\'évocation du nom d\'Allah, c\'est-à-<span class="c6">dire :</span> commencer en disant : Au nom d\'Allah. <span class="c5">[Bismillah]</span><br /> 2- L\'utilisation du Siwâk.<br /> 3- Le lavage des mains.<br /> 4- Faire passer les doigts d\'une main entre les autres.<br /> 5- La seconde et troisième répétition du lavage des membres.<br /> 6- Le commencement par la droite.<br /> 7- L\'invocation <span class="c5">[spécifique]</span> après l\'ablution : " J\'atteste qu\'il n\'y a aucune divinité <span class="c5">[digne d\'adoration]</span> excepté Allah, Seul et sans associé ; et j\'atteste que Mohammed est Son serviteur et Son Messager. "<br /> 8- L\'accomplissement de deux unités de prière après l\'ablution. </p>',
            ],
            6 => [
                'question' => 'Q7 : Énumère les annulatifs de l\'ablution ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3020.mp3',
                'answer' => '<p> R : Tout ce qui sort des orifices : verge et anus, que ce soit de l\'urine, des selles ou des gaz.<br /> Le sommeil ou la perte de raison <span class="c2">(littéralement : la folie)</span> ou l\'évanouissement.<br /> . La consommation de la viande de chameau.<br /> . Le toucher du sexe ou de l\'anus avec la main sans protection. </p>',
            ],
            7 => [
                'question' => 'Q8 : Qu\'est-ce que l\'ablution sèche (At-Tayammum) ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3080.mp3',
                'answer' => '<p> R : L\'ablution sèche désigne l\'utilisation de terre ou autre à la surface de la terre en cas d\'absence ou de manque d\'eau ou si son utilisation s\'avère impossible. </p>',
            ],
            8 => [
                'question' => 'Q9 : Comment accomplis-tu l\'ablution sèche ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3110.mp3',
                'answer' => '<p> R : On frappe la terre une seule fois avec ses paumes puis on s\'essuie le visage et l\'intérieur des mains, une seule fois. </p>',
            ],
            9 => [
                'question' => 'Q10 : Quels sont les annulatifs de l\'ablution sèche ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3140.mp3',
                'answer' => '<p> R : Ce sont tous les annulatifs de l\'ablution mineure.<br /> Dès lors où il y a de l\'eau. </p>',
            ],
            10 => [
                'question' => 'Q11 : Que sont les chaussons (Al Khufayne) et les chaussettes (Al Jawrabayne) ? Est-ce que l\'on peut essuyer dessus ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3180.mp3',
                'answer' => '<p> R : Les chaussons désignent ce qui est porté aux pieds et constitué de cuir.<br /> Les chaussettes désignent ce qui est porté aux pieds et constitué d\'une autre matière que le cuir.<br /> Il est prescrit de s\'essuyer dessus en remplacement du lavage des pieds. </p>',
            ],
            11 => [
                'question' => 'Q13 : Mentionne la sagesse se cachant derrière l\'essuyage (Al Mas\'h) sur les chaussons ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3230.mp3',
                'answer' => '<p> R : C\'est par facilité et allègement pour les serviteurs, notamment en cas de froid, en hiver ou en voyage étant donné qu\'enlever ce qu\'on porte peut constituer une difficulté. </p>',
            ],
            12 => [
                'question' => 'Q13 : Quelles sont les conditions de la validité de l\'essuyage sur les chaussons ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3260.mp3',
                'answer' => '<p> R : 1- Les chaussons en cuir doivent être mis en état de purification, c\'est-à-<span class="c6">dire :</span> après les ablutions.<br /> 2- Les chaussons en cuir doivent être purs ; en effet, l\'essuyage sur quelque chose d\'impur ou souillé n\'est pas permis.<br /> 3- Les chaussons en cuir doivent couvrir la zone sur laquelle on effectue normalement les ablutions.<br /> 4- L\'essuyage doit être durant la durée déterminée, à savoir que pour un résident cela correspond à un jour et une nuit, tandis que pour un voyageur cela correspond à trois jours et trois nuits. </p>',
            ],
            13 => [
                'question' => 'Q14 : Quelle est la description de l\'essuyage sur les chaussons ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3320.mp3',
                'answer' => '<p> R : Quant à la description de l\'essuyage, elle correspond au fait de passer les doigts de ses mains humidifiés d\'eau sur les doigts de pieds et ensuite les passer le long du pied. On essuie le pied droit avec la main droite et le pied gauche avec la main gauche, et on écarte les doigts lorsqu\'on essuie sans recommencer. </p>',
            ],
            14 => [
                'question' => 'Q15 : Qu\'est-ce qui annule l\'essuyage sur les chaussons ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3350.mp3',
                'answer' => '<p> R : 1- L\'expiration de la durée de l\'essuyage ; en effet, il n\'est pas permis d\'essuyer sur les chaussettes après l\'expiration de la durée d\'essuyage légalement définie, à savoir une journée et une nuit pour le résident et trois jours et trois nuits pour le voyageur.<br /> 2- L\'enlèvement des chaussons en cuir ; en effet, si la personne enlève ses chaussons en cuir, ou l\'un des deux, après les avoir essuyé, alors l\'essuyage sur eux devient invalide. </p>',
            ],
            15 => [
                'question' => 'Q16 : Quelle est la signification de la prière (As-Salât) ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3390.mp3',
                'answer' => '<p> R : La prière désigne le fait de se dévouer à Allah à travers des paroles et des actes spécifiques ; celle-ci commence par la proclamation de la grandeur d\'Allah et elle se termine par la salutation. </p>',
            ],
            16 => [
                'question' => 'Q17 : Quel est le jugement de la prière ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3420.mp3',
                'answer' => '<p> R : La prières est une obligation qui incombe à tout musulman.<br /> Il <span class="c2">(Élevé soit-Il)</span> a dit : {Certes, la prière est pour les croyants une prescription en des temps déterminés. <span class="c2">(103)</span> } <span class="c5">[Sourate : Les Femmes,<span class="c6"> 4 :</span> 103]</span>. </p>',
            ],
            17 => [
                'question' => 'Q18 : Quel est le jugement de délaisser la prière ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3460.mp3',
                'answer' => '<p> R : Le délaissement de la prière constitue une forme de mécréance.<span class="c6"> Le Prophète ﷺ a dit :</span><br /> " L\'engagement qu\'il y a entre nous et eux est la prière ; ainsi donc, quiconque la délaisse a assurément mécru. "<br /> Rapporté par Ahmed, at Tirmidhi et autres. </p>',
            ],
            18 => [
                'question' => 'Q19 : Combien de prières sont obligatoires pour le musulman, de jour comme de nuit ? Combien y a-t-il d\'unités dans chaque prière ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3500.mp3',
                'answer' => '<p> R : Cinq prières de jour comme de nuit. La prière de l\'aube <span class="c2">(Al Fajr)</span> : deux unités de prière ; la prière de midi <span class="c2">(Adh Dhuhr)</span> : quatre unités de prière ; la prière de l\'après-midi <span class="c2">(Al \'Asr)</span> : quatre unités de prière ; la prière du coucher <span class="c2">(Al Maghrib)</span> : trois unités de prière ; la prière du soir <span class="c2">(Al \'Ichâ\')</span> : quatre unités de prière. </p>',
            ],
            19 => [
                'question' => 'Q20 : Énumère les conditions de la prière ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3530.mp3',
                'answer' => '<p> R : 1- L\'islam. En effet, la prière d\'un mécréant n\'est pas valide.<br /> 2- La raison. En effet, la prière de celui ayant perdu la raison n\'est pas valide.<br /> 3- La distinction. En effet, la prière d\'un petit qui ne distingue pas n\'est pas valide.<br /> 4- L\'intention.<br /> 5- L\'entrée du temps de la prière.<br /> 6- La purification en ayant ôté toute impureté et souillure.<br /> 7- Le fait d\'être pur de toute souillure.<br /> 8- Couvrir sa partie intime.<br /> 9- Le fait de se diriger vers la Qibla. </p>',
            ],
            20 => [
                'question' => 'Q21 : Énumère les piliers de la prière ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3640.mp3',
                'answer' => '<p> R : Il y a quatorze piliers,<span class="c6"> comme suit :</span><br /> Le premier : Se tenir debout dans la prière obligatoire pour quiconque est capable.<span class="c6"><br /> Le " Takbîr " de sacralisation qui est :</span> " Allah est le Plus Grand.<span class="c6"> "<br /> La lecture de la sourate :</span> L\'Ouverture <span class="c2">(n°1)</span> <span class="c5">[Al Fâtiha]</span>.<span class="c6"><br /> L\'inclinaison :</span> c\'est le fait d\'étendre son dos, droit, et de placer sa tête droite dans l\'axe.<br /> Le relèvement de l\'inclinaison.<br /> La position debout droite après l\'inclinaison.<br /> La prosternation, notamment le fait de bien placer son front, son nez, ses paumes, ses genoux et les extrémités des ses doigts de pieds là où l\'on se prosterne.<br /> Le relèvement de la prosternation.<br /> L\'assise entre les deux prosternations.<br /> Et la tradition est de bien s\'asseoir sur son pied gauche et de redresser le pied droit en le dirigeant vers la Qibla.<br /> La quiétude qui consiste à être serein lors de l\'accomplissement de chaque pilier pratique.<br /> Le dernier Tachahud.<br /> Le fait de s\'assoir au cours de celui-ci.<span class="c6"><br /> Les deux salutations qui consiste à dire deux fois :</span> " Paix sur vous ainsi que la miséricorde d\'Allah. "<br /> L\'ordre des piliers - comme nous l\'avons mentionné - ; ainsi, par exemple, si la personne se prosterne volontairement avant son inclinaison, alors la prière est vaine ; et si la personne effectue cela par oubli, alors il doit revenir afin de s\'incliner et ensuite il se prosterne. </p>',
            ],
            21 => [
                'question' => 'Q22 : Mentionne les obligations de la prière.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3820.mp3',
                'answer' => '<p> R : Les obligations de la prière sont au nombre de huit,<span class="c6"> comme suit :</span><br /> 1- Les " Takbîrat " hormis le " Takbîr " de sacralisation <span class="c5">[du début de la prière]</span>.<br /> 2-<span class="c6"> La parole :</span> " Allah a entendu quiconque L\'a loué " de la part de l\'imam et de quiconque prie seul.<br /> 3-<span class="c6"> La parole :</span> " Notre Seigneur, à Toi la louange. "<br /> 4-<span class="c6"> La parole :</span> " Gloire à mon Seigneur, le Majestueux. " Une seule fois dans l\'inclinaison.<br /> 5-<span class="c6"> La parole :</span> " Gloire à mon Seigneur, le Plus-Haut. " Une seule fois dans la prosternation.<br /> 6-<span class="c6"> La parole :</span> " Seigneur ! Pardonne-moi. " Entre les deux prosternations.<br /> 7- Le premier Tachahud.<br /> 8- L\'assise au cours du premier Tachahud. </p>',
            ],
            22 => [
                'question' => 'Q23 : Quelles sont les actes recommandés de la prière ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3930.mp3',
                'answer' => '<p> R : ils sont au nombre de onze,<span class="c6"> comme suit :</span><br /> 1- Après le " Takbîr " de sacralisation,<span class="c6"> la parole suivante :</span> " Gloire à toi, ô Allah, et par Ta louange ; Ton nom est béni ; Ta gloire est élevée ; et il n\'y a aucune divinité <span class="c5">[digne d\'adoration]</span> autre que Toi. "<br /> 2- Le fait de se réfugier <span class="c5">[auprès d\'Allah]</span>.<br /> 3-<span class="c6"> Dire :</span> Au nom d\'Allah, le Tout Miséricordieux, le Très Miséricordieux <span class="c2">(Al Basmalah)</span>.<br /> 4-<span class="c6"> Dire :</span> Âmîn.<br /> 5- Lire une sourate après Al Fâtiha.<br /> 6- Réciter à voix haute de la part de l\'imam.<br /> 7-<span class="c6"> Dire après la louange :</span> " Qui emplit les cieux, emplit la Terre et emplit ce que Tu souhaites après cela. "<br /> 8- La répétition de la glorification lors de l\'inclinaison plus d\'une fois, c\'est-à-<span class="c6">dire :</span> la seconde glorification, la troisième, et plus encore.<br /> 9- La répétition de la glorification lors de la prosternation plus d\'une fois.<br /> 10-<span class="c6"> La répétition de la parole entre les deux prosternations :</span> " Seigneur ! Pardonne-moi. " plus d\'une fois.<br /> 11- La prière sur la famille du Prophète ﷺ dans le dernier Tachahud ainsi que la bénédiction sur lui et sur eux et les invocations après cela.<span class="c6"><br /> Quatrièmement :</span> Les actes recommandés gestuelles qui sont appelés " les positions " :<br /> 1- Lever les mains au moment du " Takbîr " de sacralisation <span class="c5">[du début de la prière]</span>.<br /> 2- Lever les mains au moment de l\'inclinaison.<br /> 3- Lever les mains au moment du relèvement de l\'inclinaison.<br /> 4- Les laisser le long du corps après cela.<br /> 5- Placer la main droite sur la main gauche.<br /> 6- Diriger son regard vers l\'endroit de la prosternation.<br /> 7- Laisser une séparation entre ses deux pieds en étant debout.<br /> 8- Saisir les genoux avec les mains, les doigts écartés, lors de l\'inclinaison, étendre le dos durant cette position en ayant la tête droite dans l\'axe.<br /> 9- Se prosterner à terre sur les sept membres lors de la prosternation, en touchant le sol.<br /> 10- Espacer ses bras de ses flancs, son ventre de ses cuisses et ses cuisses de ses jambes ; séparer entre ses genoux ; redresser ses pieds ; poser l\'intérieur de ses doigts sur le sol en les séparant ; et placer ses mains à la hauteur de ses épaules, les doigts étendus et regroupés.<br /> 11- S\'assoir sur son pied gauche et tendre le pied droit dans l\'assise entre les deux prosternations et durant le premier Tachahud. S\'asseoir sur se fesse et passer sa jambe gauche sous sa jambe droite dans le second Tachahud.<br /> 12 - Poser les mains bien étendues sur les cuisses, les doigts regroupés, entre les deux prosternations. Il en est de même dans le Tachahud, à l\'exception que - lors de la mention d\'Allah - de la main droite on pointe devant soi avec l\'index et on regroupe le pouce au majeur en faisant un cercle.<br /> 13- Tourner sa tête à droite puis à gauche au moment de la salutation finale. </p>',
            ],
            23 => [
                'question' => 'Q24 : Énumère les annulatifs de la prière.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4210.mp3',
                'answer' => '<p> R : 1- Délaisser un pilier ou une condition parmi les piliers ou les conditions de la prière.<br /> 2- Parler de manière volontaire.<br /> 3- Manger ou boire.<br /> 4- Bouger beaucoup de manière successive.<br /> 5- Délaisser volontairement une obligation parmi les obligations de la prière. </p>',
            ],
            24 => [
                'question' => 'Q25 : Comment le musulman prie-t-il ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4280.mp3',
                'answer' => '<p> R : Description de la prière.<br /> 1- Il se dirige de tout son corps en direction de la Qibla sans dévier ni se tourner.<br /> 2- Ensuite, dans son cœur et sans la prononcer, il formule l\'intention de la prière qu\'il souhaite accomplir.<br /> 3- Puis,<span class="c6"> il proclame la grandeur d\'Allah en guise d\'ouverture de la prière en disant :</span> " Allah est le Plus Grand. " Il lève ses deux mains à hauteur de ses épaules au moment du Takbîr.<br /> 4- Ensuite, il place la paume de sa main droite sur le dos de sa main gauche, au-dessus de sa poitrine.<br /> 5- Ensuite,<span class="c6"> il commence sa prière en disant :</span> <span class="c3">« Ô Allah ! Eloigne de moi mes péchés comme Tu as éloigné l\'Orient de l\'Occident. Ô Allah ! Purifie-moi de mes pêchés comme on purifie le vêtement blanc de sa saleté. Ô Allah ! Lave moi de mes péchés par l\'eau, la neige et la grêle. »</span><br /> Ou il a dit : " Gloire à Toi, ô Allah, et à Toi la louange. Que Ton nom soit béni, que Ta majesté soit élevée et il n\'y a aucune divinité <span class="c5">[digne d\'adoration]</span> autre que Toi. "<br /> 6- Ensuite, il cherche refuge <span class="c5">[auprès d\'Allah]</span> en disant : " Je cherche refuge auprès d\'Allah contre Satan le lapidé. " 7- Ensuite,<span class="c6"> il dit :</span> " Au nom d\'Allah " et il lit la sourate : " al Fâtiha" en disant : {Au nom d\'Allah, Le Tout Miséricordieux , Le Très Miséricordieux. <span class="c2">(1)</span> Louange à Allah, Seigneur des mondes. <span class="c2">(2)</span> Le Tout Miséricordieux, le Très Miséricordieux. <span class="c2">(3)</span> Souverain au Jour de la Rétribution. <span class="c2">(4)</span> C\'est Toi <span class="c2">(Seul)</span> que nous adorons et c\'est Toi <span class="c2">(Seul)</span> dont nous cherchons l\'assistance. <span class="c2">(5)</span> Guide-<span class="c6">nous sur le droit chemin :</span> <span class="c2">(6)</span> Le chemin de ceux que Tu as comblés de bienfaits, non pas de ceux qui ont encouru la colère ni les égarés. <span class="c2">(7)</span> } <span class="c5">[Sourate : L\'Ouverture,<span class="c6"> 1 :</span> 1 à 7]</span>.<br /> Ensuite,<span class="c6"> il dit :</span> Âmîn.<span class="c6"> Cela signifie :</span> Ô Allah ! Exauce-nous.<br /> Puis, il lit ce qu\'il peut du Coran ; notamment, il prolonge la lecture au cours de la prière de l\'aube <span class="c2">(As-Subh)</span>.<br /> 9- Ensuite, il s\'incline, c\'est-à-<span class="c6">dire :</span> il abaisse son dos en guise de vénération vouée à Allah ; il dit: Allahou Akbar au moment de son inclinaison ; il lève ses mains à hauteur de ses épaules. Et la Tradition est de bien étendre droit son dos et de mettre sa tête bien droite dans l\'axe ; il place ses mains sur ses genoux en les attrapant avec ses doigts espacés.<br /> 10- Dans son inclinaison,<span class="c6"> il dit :</span> <span class="c3">« Gloire à mon Seigneur, le Majestueux. »</span> <span class="c2">(3 fois)</span> Et il peut aussi ajouter : " <span class="c3">« Gloire à Toi, ô Allah, et à Toi la louange. Ô Allah ! Pardonne-moi. »</span> En effet, ceci est bien.<br /> 11- Puis,<span class="c6"> il relève sa tête de l\'inclinaison en disant :</span> <span class="c3">« Allah a entendu quiconque L\'a loué. »</span> Il lève alors à ce moment-là ses mains à hauteur de ses épaules. Quant au fidèle qui suit l\'imam, il ne dit pas cette invocation, c\'est-à-<span class="c6">dire :</span> <span class="c3">« Allah a entendu quiconque L\'a loué. »</span> Plutôt, à la place,<span class="c6"> il dit :</span> <span class="c3">« Nôtre Seigneur, à Toi la louange. <span class="c5">[une louange abondante, pure et bénie]</span> »</span><br /> 12- Ensuite, après s\'être relevé,<span class="c6"> il dit :</span> <span class="c3">« Notre Seigneur, à Toi la louange, qui emplit les cieux et la Terre et qui emplit ce que Tu souhaites après cela. »</span><br /> 13- Puis,<span class="c6"> il effectue la première prosternation qu\'il accompagnera par la parole :</span> " Allah est le Plus Grand.<span class="c6"> " Il se prosterne sur sept membres :</span> le front, le nez, les paumes <span class="c5">[des mains]</span>, les genoux et les extrémités des orteils. Il espace ses bras de ses flancs, il n\'étend pas au sol ses avant-bras et le bout de ses doigts sont en direction de la Qibla.<br /> 14- Dans sa prosternation,<span class="c6"> il dit :</span> <span class="c3">« Gloire à mon Seigneur, le Plus-Haut. »</span> <span class="c2">(3 fois)</span> Et s\'il ajoute : <span class="c3">« Gloire à Toi, notre Seigneur et à Toi la louange. Ô Allah ! Pardonne-moi. »</span> Alors, ceci est bien.<br /> 15- Ensuite,<span class="c6"> il relève sa tête de la prosternation en disant :</span> " Allah est le Plus Grand. "<br /> 16- Puis, il s\'assoit entre les deux prosternations sur son pied gauche, redresse son pied droit, place sa main droite sur le bout de sa cuisse droite, qui est à côté de son genou ; il saisit l\'auriculaire et l\'annulaire, il lève son index et le bouge au moment de son invocation ; il fait en sorte que le bout de son pouce touche e bout de son majeur comme un anneau ; et il place sa main gauche avec les doigts tendus sur le bout de sa cuisse gauche, à côté de son genou.<br /> 17-<span class="c6"> Il dit dans sa position assise entre les deux prosternations :</span> " Seigneur ! Pardonne-moi, fais-moi miséricorde, guide-moi, pourvois-moi, panse-moi et préserve-moi. "<br /> 18- Puis, il se prosterne une seconde fois, comme dans la première prosternation en disant et en faisant exactement ce qu\'il a effectué précédemment. Il proclame la grandeur d\'Allah dans sa prosternation.<br /> 19- Ensuite,<span class="c6"> il se relève de sa seconde prosternation en disant :</span> " Allah est le Plus Grand. " Et là il entame la seconde unité de prière en disant et en faisant comme dans la première unité à la seule différence qu\'il ne répète pas l\'invocation de l\'ouverture de la prière.<br /> 20- Puis, à la fin de la seconde unité de prière,<span class="c6"> il s\'assoit en disant :</span> " Allah est le Plus Grand. " Et là il s\'assoit exactement comme il s\'est assis entre les deux prosternations.<br /> 21-<span class="c6"> Il récite le Tachahud dans cette position assise et il dit :</span> " Les salutations appartiennent à Allah ainsi que les bonnes œuvres. Que le salut soit sur toi, ô Prophète, ainsi que la miséricorde d\'Allah et Ses bénédictions. Que le salut soit sur nous et sur les vertueux serviteurs d\'Allah. J\'atteste qu\'il n\'y a aucune divinité <span class="c5">[digne d\'adoration]</span> excepté Allah et j\'atteste que Muhammad est Son serviteur et Son messager. Ô Allah ! Prie sur Mohammed et sur la famille de Mohammed, comme Tu as prié sur Abraham et sur la famille d\'Abraham. Certes, Tu es digne de louanges et Glorieux. Ô Allah ! Bénis Mohammed et la famille de Mohammed, comme Tu as béni Abraham et la famille d\'Abraham. Certes, Tu es digne de louanges et Glorieux. Je me réfugie auprès d\'Allah contre le châtiment de l\'Enfer, contre le châtiment de la tombe, contre l\'épreuve de la vie et de la mort et contre la tentation du Dajjâl. " Ensuite, il invoque son Seigneur de ce qu\'il souhaite parmi les bienfaits d\'ici-bas et de l\'au-delà.<br /> 22- Puis,<span class="c6"> il salue à sa droite en disant :</span> " Paix sur vous ainsi que la miséricorde d\'Allah. " Et il fait de même à sa gauche.<br /> 23- Si la prière est de trois ou quatre unités de prière,<span class="c6"> alors il reste comme il est à la fin du premier Tachahud dans lequel il dit :</span> " J\'atteste qu\'il n\'y a aucune divinité <span class="c5">[digne d\'adoration]</span> excepté Allah et j\'atteste que Muhammad est Son serviteur et Son Messager. "<br /> 24- Ensuite,<span class="c6"> il se redresse debout en disant :</span> " Allah est le Plus Grand. " Et, à ce moment-là, il lève ses mains à hauteur de ses épaules.<br /> 25- Puis,<span class="c6"> il prie ce qu\'il lui reste à finir de sa prière de la même manière que lors de la seconde unité de prière à la seule différence qu\'il se contente uniquement de lire la sourate :</span> al Fâtiha.<br /> 26- Ensuite, il s\'assoit sur le côté gauche en redressant son pied droit et en sortant son pied gauche de sous sa cuisse droite et ainsi il reste assis à même le sol. Il pose sa main droite et son avant-bras sur sa cuisse droite de la même manière qu\'il les avait mis dans le premier Tachahud.<br /> 27- Et dans cette assise, il dit le Tachahud en entier.<br /> 28- Enfin,<span class="c6"> il salue à sa droite en disant :</span> " Paix sur vous ainsi que la miséricorde d\'Allah. " Et il fait de même à sa gauche. </p>',
            ],
            25 => [
                'question' => 'Q26 : Que dis-tu comme évocation après la salutation finale de la prière ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4610.mp3',
                'answer' => '<p> R : " J\'implore le pardon d\'Allah ", trois fois.<br /> " Ô Allah ! Tu es le Salut, de Toi provient le salut. Béni sois-Tu ! Ô Détenteur de la Majesté et de la Générosité ! "<br /> <span class="c3">« Il n’y a aucune divinité <span class="c5">[digne d\'adoration]</span> excepté Allah, Unique, sans associé. A Lui la royauté, à Lui la louange et Il est Omnipotent sur toute chose. Ô Allah ! Nul ne peut retenir ce que Tu as donné et nul ne peut donner ce que Tu as retenu. Le fortuné ne trouve dans sa fortune aucune protection efficace contre Toi. »</span><br /> <span class="c3">« Il n’y a aucune divinité <span class="c5">[digne d\'adoration]</span> excepté Allah, Unique et sans associé. A Lui la royauté, à Lui la louange et Il est Omnipotent sur toute chose. Il n’y a aucune puissance ni force excepté par Allah. Il n\'y a aucune divinité <span class="c5">[digne d\'adoration]</span> excepté Allah et nous n’adorons que Lui. Le bienfait, la grâce et le bel éloge Lui appartiennent et Lui reviennent. Il n\'y a aucune divinité <span class="c5">[digne d\'adoration]</span> excepté Allah. Nous Lui vouons un culte exclusif en dépit de l\'aversion des mécréants. »</span><br /> - " Gloire à Allah <span class="c2">(Subhânallah)</span> ", trente trois fois.<br /> - " Louange à Allah <span class="c2">(Al Hamdulillah)</span> ", trente trois fois.<br /> - "Allah est le plus Grand <span class="c2">(Allah Akbar)</span> ", trente trois fois.<br /> Ensuite, pour compléter le centième,<span class="c6"> il dit :</span> " Il n’y a aucune divinité <span class="c5">[digne d\'adoration]</span> excepté Allah uniquement, sans associé. La Royauté Lui appartient et la louange Lui revient. Et Il est Omnipotent sur toute chose. " <span class="c2">(Lâ Ilaha IllaLlâh Wahdahu Lâ Charîka Lah, Lahul Mulk Wa Lahul Hamd, Wa Uwa \'Alâ Kulli Chay-in Qadîr)</span>.<br /> -<span class="c6"> Les sourates :</span> al Ikhlâs et les Deux Protectrices se lisent trois fois après les prières de l\'Aube <span class="c2">(Al Fajr)</span> et du Coucher <span class="c2">(Al Maghrib)</span> et une seule fois après les autres prières.<br /> - Le verset du Trône se lit une seule fois. </p>',
            ],
            26 => [
                'question' => 'Q27 : Que sont les prières surérogatoires dites : " Ar-Rawâtib " ? Quel est leur mérite (Al Fadl) ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4730.mp3',
                'answer' => '<p> R : Deux unités de prière avant <span class="c5">[la prière de]</span> l\'Aube <span class="c2">(Al Fajr)</span>.<br /> Quatre unités de prière avant <span class="c5">[la prière du]</span> midi <span class="c2">(Az-Zuhr)</span>.<br /> Deux unités de prière après <span class="c5">[la prière du]</span> midi <span class="c2">(Az-Zuhr)</span>.<br /> Deux unités de prière après <span class="c5">[la prière du]</span> coucher <span class="c5">[du soleil]</span> <span class="c2">(Al Maghrib)</span>.<br /> Deux unités de prière après la prière du soir <span class="c2">(Al \'Ichâ\')</span>.<span class="c6"><br /> Leur mérite :</span> Le Prophète ﷺ a dit : " Quiconque prie, de manière surérogatoire, douze unités de prière au cours de la journée et de la nuit, Allah lui construit une demeure au Paradis. " Rapporté par Muslim, Ahmed et d\'autres. </p>',
            ],
            27 => [
                'question' => 'Q28 : Quel est le meilleur jour de la semaine ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4800.mp3',
                'answer' => '<p> R : Le jour du vendredi.<span class="c6"> Le Prophète ﷺ a dit :</span> <span class="c3">« Parmi les meilleurs de vos jours,<span class="c6"> le jour du vendredi :</span> ce jour-là, Adam a été créé ; ce jour-là, il est mort ; ce jour-là, il y aura le souffle dans la Trompe ; et ce jour-là, il y aura l\'évanouissement. Multipliez donc les prières sur moi ce jour-là, car certes vos prières me sont présentées. »</span> Il a dit : Ils demandèrent : " Ô Messager d\'Allah ! Et comment nos prières te sont présentées alors que tu auras été décomposé ? " Il répondit : « Certes, Allah <span class="c2">(Exalté et Magnifié soit-Il)</span> a interdit à la terre de manger le corps des prophètes. » Rapporté par Abû Dâwud et d\'autres<br /> . </p>',
            ],
            28 => [
                'question' => 'Q29 : Quel est le jugement de la prière du Vendredi (Al Jumu\'ah) ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4840.mp3',
                'answer' => '<p> R : C\'est une obligation individuelle qui incombe à tout musulman, homme, pubère, doué de raison et résident.<br /> Il <span class="c2">(Élevé soit-Il)</span> a dit : {Ô vous qui avez cru ! Lorsqu\'on appelle à la prière du jour du Vendredi, alors accourez au rappel d\'Allah et laissez tout négoce. Cela est bien meilleur pour vous, si vous saviez ! <span class="c2">(9)</span> } <span class="c5">[Sourate : Le Vendredi,<span class="c6"> 62 :</span> 9]</span>. </p>',
            ],
            29 => [
                'question' => 'Q30 : Combien d\'unités de prière (Raka\'ât) comporte la prière du Vendredi ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4880.mp3',
                'answer' => '<p> R : Le nombre d\'unités de prière de la prière du vendredi est de deux, au cours desquelles l\'imam lit à haute voix et celles-ci sont précédées par deux sermons bien connus. </p>',
            ],
            30 => [
                'question' => 'Q31 : Est-ce qu\'il est permis de ne pas assister à la prière du Vendredi ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4910.mp3',
                'answer' => '<p> R : Il n\'est pas permis de ne pas assister à la prière du vendredi à moins d\'une excuse religieuse valable. En effet,<span class="c6"> il a été rapporté du Prophète ﷺ sa parole :</span> " Quiconque délaisse <span class="c5">[consécutivement]</span> trois <span class="c5">[sermons du]</span> vendredi, par négligence, Allah scelle son cœur. " Rapporté par Abû Dâwud et d\'autres. </p>',
            ],
            31 => [
                'question' => 'Q32 : Mentionne les actes recommandés du jour du Vendredi ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4940.mp3',
                'answer' => '<p> R :<br /> 1- Se laver.<br /> 2- Se parfumer.<br /> 3- Porter les plus beaux habits.<br /> 4- Aller tôt à la mosquée.<br /> 5- Multiplier la prière sur le Prophète ﷺ.<br /> 6-<span class="c6"> Lire la sourate :</span> La Caverne <span class="c2">(n°18)</span>.<br /> 7- Aller à la mosquée à pied.<br /> 8- Se libérer afin de se consacrer à l\'heure d\'exaucement des invocations. </p>',
            ],
            32 => [
                'question' => 'Q33 : Mentionne le mérite de la prière en groupe (Al Jamâ\'ah) ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5050.mp3',
                'answer' => '<p> R : D\'après \'Abd Allah ibn \'Umar <span class="c2">(qu\'Allah les agrée tous les deux)</span> : Le Messager d\'Allah ﷺ a dit : " La prière en groupe est meilleure que la prière seule de vingt-sept degrés. " Rapporté par Muslim. </p>',
            ],
            33 => [
                'question' => 'Q34 : Qu\'est-ce que le recueillement dans la prière ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5080.mp3',
                'answer' => '<p> R : C\'est la présence du cœur et l\'immobilité des membres dans la prière.<br /> Il <span class="c2">(Élevé soit-Il)</span> a dit : {Assurément, les croyants ont réussi. <span class="c2">(1)</span> Ceux qui, dans leur prière, se recueillent. <span class="c2">(2)</span> } <span class="c5">[Sourate : Les Croyants,<span class="c6"> 21 :</span> 1-2]</span>. </p>',
            ],
            34 => [
                'question' => 'Q35 : Définis l\'aumône légale (Az-Zakât) ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5120.mp3',
                'answer' => '<p> R : C\'est un acquittement financier obligatoire relatif à des biens spécifiques, propre à un groupe spécifique et à un moment spécifique.<br /> - C\'est un des piliers de l\'Islam et une aumône obligatoire qui est prélevée du riche pour être redistribuée au pauvre.<br /> Il <span class="c2">(Élevé soit-Il)</span> a dit : <span class="c4">{Et acquittez-vous de l\'aumône !}</span> <span class="c5">[Sourate : La Vache,<span class="c6"> 2 :</span> 43]</span>. </p>',
            ],
            35 => [
                'question' => 'Q36 : Quelles sont les aumônes recommandées (Sadaqât) ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5170.mp3',
                'answer' => '<p> R : Ce sont toutes les autres en dehors de l\'aumône légale, comme la charité dans n\'importe quelle voie du bien et cela à n\'importe quel moment.<br /> Il <span class="c2">(Élevé soit-Il)</span> a dit : <span class="c4">{Et dépensez dans le sentier d\'Allah.}</span> <span class="c5">[Sourate : La Vache,<span class="c6"> 2 :</span> 195]</span>. </p>',
            ],
            36 => [
                'question' => 'Q37 : Définis le jeûne ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5210.mp3',
                'answer' => '<p> R : C\'est le fait de se dévouer à Allah en s\'abstenant de tout ce qui peut rompre le jeûne, du lever du soleil jusqu\'à son coucher, tout en ayant l\'intention de faire cela pour Allah.<span class="c6"> Il existe deux types de jeûne :</span><br /> 1- Un jeûne obligatoire,<span class="c6"> comme :</span> le jeûne du mois de Ramadân qui est un des piliers de l\'Islam.<br /> Il <span class="c2">(Élevé soit-Il)</span> a dit : <span class="c4">{Ô vous qui avez cru ! Le jeûne vous a été prescrit comme il a été prescrit à ceux qui vous ont précédé, peut-être atteindrez-vous la piété.}</span> <span class="c5">[Sourate : La Vache,<span class="c6"> 2 :</span> 183]</span>.<br /> 2- Un jeûne non obligatoire,<span class="c6"> comme :</span> le jeûne du lundi et du jeudi de chaque semaine ; le jeûne de trois jours durant le mois, dont les meilleurs sont les jours blancs <span class="c2">(13, 14 et 15)</span> de chaque mois lunaire. </p>',
            ],
            37 => [
                'question' => 'Q38 : Mentionne le mérite du jeûne du mois de Ramadân ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5270.mp3',
                'answer' => '<p> R : D"après Abû Hurayra <span class="c2">(qu\'Allah l"agrée)</span> : Le Messager d\'Allah ﷺ a dit : " Quiconque jeûne <span class="c5">[le mois de]</span> Ramadân en ayant foi et en espérant la récompense <span class="c5">[divine]</span>, ses péchés précédents lui seront pardonnés. " Unanimement reconnu authentique <span class="c5">[Al Bukhârî et Muslim]</span>. </p>',
            ],
            38 => [
                'question' => 'Q39 : Mentionne le mérite de jeûner de manière surérogatoire en dehors [du mois] de Ramadân.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5300.mp3',
                'answer' => '<p> R : D\'après Abû Sa\'îd Al Khudrî <span class="c2">(qu\'Allah l\'agrée)</span> : " Le Messager d\'Allah ﷺ a dit : " Pas un serviteur ne jeûne un jour dans le sentier d\'Allah sans qu\'Allah n\'éloigne par cela son visage de l\'Enfer de soixante-dix années. " Unanimement reconnu authentique <span class="c5">[Al Bukhârî et Muslim]</span>.<br /> - La signification de " soixante-<span class="c6">dix automnes " désigne :</span> soixante-dix années. </p>',
            ],
            39 => [
                'question' => 'Q40 : Mentionne certains actes qui rompent le jeûne ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5330.mp3',
                'answer' => '<p> R : 1- Manger et boire de manière volontaire.<br /> 2- Vomir de manière volontaire.<br /> 3- Apostasier de l\'Islam. </p>',
            ],
            40 => [
                'question' => 'Q41 : Quelles sont les actes recommandés du jeûne ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5380.mp3',
                'answer' => '<p> R : 1- S\'empresser de le rompre <span class="c5">[dès le coucher du soleil]</span>.<br /> 2- Prendre une collation avant l\'heure de la prière d\'al Fajr en faisant en sorte qu\'elle <span class="c5">[la collation]</span> soit le plus tard possible.<br /> 3- Multiplier les œuvres de bien et les actes d\'adoration.<br /> 3-<span class="c6"> Dire :</span> " Certes, je suis un jeûneur ", en cas d\'injure ou d\'insulte de la part de quelqu\'un.<br /> 5- Invoquer au moment de la rupture.<br /> 6- Rompre avec des dattes fraîches <span class="c2">(Rutab)</span> ou de simples dattes <span class="c2">(Tamr)</span> ; et si on ne trouve ni l\'une ni l\'autre, alors rompre son jeûne avec de l\'eau. </p>',
            ],
            41 => [
                'question' => 'Q42 : Définis le pèlerinage (Al Hajj) ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5460.mp3',
                'answer' => '<p> R : Le pèlerinage est le fait de se dévouer à Allah <span class="c2">(Élevé soit-Il)</span> en ayant l\'intention de se rendre à la Mosquée Sacré afin d\'y accomplir des œuvres spécifiques à un moment spécifique.<br /> Il <span class="c2">(Élevé soit-Il)</span> a dit : {Et c\'est un devoir envers Allah, pour les gens qui ont les moyens, d\'aller faire le pèlerinage à la Maison. Et quiconque mécroit, alors Allah se passe des mondes. <span class="c2">(97)</span> } <span class="c5">[Sourate : La Famille d’Imrân,<span class="c6"> 3 :</span> 97]</span>. </p>',
            ],
            42 => [
                'question' => 'Q43 : Énumère les piliers du pèlerinage ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5500.mp3',
                'answer' => '<p> R : 1- La sacralisation <span class="c2">(Al Ihrâm)</span>.<br /> 2- La station <span class="c2">(Al Wuqûf)</span> à \'Arafat.<br /> 3- La circumambulation <span class="c2">(Tawâf Al Ifâdah)</span>.<br /> 4- Le passage <span class="c2">(As-Sa\'yî)</span> entre As-Safâ et Al Marwa. </p>',
            ],
            43 => [
                'question' => 'Q44 : Quel est le mérite du pèlerinage ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5560.mp3',
                'answer' => '<p> R : D\'après Abû Hurayrah <span class="c2">(qu\'Allah l\'agrée)</span> : " Le Messager d\'Allah ﷺ a dit : " Quiconque effectue le pèlerinage pour Allah sans avoir de rapport sexuel ni commettre de désobéissance revient comme le jour où sa mère l\'a mis au monde. " Rapporté par Al Bukhârî et d\'autres.<br /> -<span class="c6"> " Comme le jour où sa mère l\'a mis au monde " :</span> C\'est-à-<span class="c6">dire :</span> sans aucun péché. </p>',
            ],
            44 => [
                'question' => 'Q45 : Définis la \'Umra.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5600.mp3',
                'answer' => '<p> R : La \'Umra désigne le fait de se dévouer à Allah <span class="c2">(Élevé soit-Il)</span> dans l\'intention de se rendre à la Maison Sacrée pour y accomplir des œuvres spécifiques à n\'importe quel moment. </p>',
            ],
            45 => [
                'question' => 'Q36 : Énumère les piliers de la \'Umra.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5630.mp3',
                'answer' => '<p> R : La sacralisation <span class="c2">(Al Ihrâm)</span>.<br /> 2- La circumambulation <span class="c2">(At Tawâf)</span> autour de la Ka\'ba.<br /> 3- Le passage entre As-Safâ et Al Marwa. </p>',
            ],
            46 => [
                'question' => 'Q47 : Qu\'est-ce que le combat (Al Jihâd) dans le sentier d\'Allah ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5690.mp3',
                'answer' => '<p> R : C\'est le fait de déployer des efforts et de l\'ardeur dans la propagation et la défense de l\'Islam et de ses adeptes, ou de combattre les ennemis de l\'Islam et de ses partisans.<br /> Il <span class="c2">(Élevé soit-Il)</span> a dit : {Et combattez avec vos biens et vos personnes dans le sentier d\'Allah. Cela est meilleur pour vous, si vous saviez <span class="c2">(41)</span> } <span class="c5">[Sourate : Le Repentir,<span class="c6"> 9 :</span> 41]</span>. </p>',
            ],
        ],
        3 => [
            0 => [
                'question' => 'Q1 : Quelle est la lignée de notre Prophète Mohammed ﷺ ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5740.mp3',
                'answer' => '<p> R : Il est Mohammed ibn \'Abd Allah ibn \'Abd al Muttalib ibn Hâchim ; Hâchim fait partie de Quraych ; Quraych fait partie des Arabes ; les Arabes sont de la descendance d\'Ismaël ; et Ismaël est le fils d\'Abraham, paix sur lui ainsi que sur notre Prophète, de même que le salut. </p>',
            ],
            1 => [
                'question' => 'Q2 : Quel est le nom de la mère de notre Prophète ﷺ ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5770.mp3',
                'answer' => '<p> R : Âmina bint Wahb. </p>',
            ],
            2 => [
                'question' => 'Q3 : Quand son père est-il mort ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5800.mp3',
                'answer' => '<p> R : Son père est mort à Médine alors qu\'il était dans le ventre de sa mère et donc pas encore né ﷺ. </p>',
            ],
            3 => [
                'question' => 'Q4 : Quand est né le Prophète ﷺ ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5830.mp3',
                'answer' => '<p> R : Il est né lors de l\'année de l\'Éléphant, un lundi, durant le mois de Rabî\' I. </p>',
            ],
            4 => [
                'question' => 'Q5 : Dans quelle ville est-il ﷺ né ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5850.mp3',
                'answer' => '<p> R : Il est né à La Mecque. </p>',
            ],
            5 => [
                'question' => 'Q6 : Qui l\'a allaité et gardé en dehors de sa mère ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5880.mp3',
                'answer' => '<p> R : -<span class="c6"> L\'esclave affranchie de son père :</span> Um Ayman.<br /> -<span class="c6"> L\'esclave affranchie de son oncle paternel Abû Lahab :</span> Thuwaybah.<br /> - Halîmah as-Sa\'diyah. </p>',
            ],
            6 => [
                'question' => 'Q7 : Quand sa mère est-elle morte ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5930.mp3',
                'answer' => '<p> R : Sa mère est décédée alors qu\'il avait seulement six ans et c\'est son grand-père \'Abd Al Muttalib qui l\'a pris sous sa tutelle. </p>',
            ],
            7 => [
                'question' => 'Q8 :Qui s\'est chargé de lui après la mort de son grand-père \'Abd Al Muttalib ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5960.mp3',
                'answer' => '<p> R : Son grand-père \'Abd Al Muttalib est décédé alors qu\'il avait huit ans et c\'est alors son oncle paternel Abû Lahab qui l\'a pris en charge. </p>',
            ],
            8 => [
                'question' => 'Q9 : Quand a-t-il voyagé avec son oncle au Châm ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5990.mp3',
                'answer' => '<p> R : Il a voyagé avec son oncle au Châm alors qu\'il avait douze ans. </p>',
            ],
            9 => [
                'question' => 'Q10 : Quand eut lieu son second voyage ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6020.mp3',
                'answer' => '<p> R : Son second voyage fut pour du commerce pour le compte de Khadîja <span class="c2">(qu\'Allah l\'agrée)</span>, et à son retour il ﷺ l\'épousa. Il était âgé de vingt-cinq ans. </p>',
            ],
            10 => [
                'question' => 'Q11 : Quand [la tribu de] Quraych a-t-elle reconstruit la Ka\'ba ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6050.mp3',
                'answer' => '<p> R : Quraych a reconstruit la Ka\'ba alors qu\'il avait trente-cinq ans.<br /> Les gens de Quraych le prirent comme arbitre quand ils divergèrent au sujet de qui déposera la pierre noire ; il la mit alors dans un vêtement et il ordonna à chaque tribu d\'en tenir une extrémité, et ils étaient quatre tribus. Quand ils l\'ont soulevées <span class="c5">[pour la mettre]</span> à sa place, il ﷺ l\'a alors placé lui-même de sa main. </p>',
            ],
            11 => [
                'question' => 'Q12 : Quel âge avait le Prophète ﷺ le jour où il fut envoyé ? Et à qui fut-il envoyé ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6080.mp3',
                'answer' => '<p> R : Il avait quarante lors de sa mission et il fut envoyé à toute l\'humanité en tant qu\'annonciateur de bonnes nouvelles et avertisseur de menaces. </p>',
            ],
            12 => [
                'question' => 'Q13 : Quelle fut la première chose avec laquelle la Révélation a commencé ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6110.mp3',
                'answer' => '<p> R : La Révélation débuta avec le rêve et la vision véridique, c\'est-à-dire qu\'il ne voyait pas une chose en rêve sans que cela ne se produise, comme l\'aube naissante. </p>',
            ],
            13 => [
                'question' => 'Q14 : Quelle était sa situation avant la Révélation ? Et quand la Révélation est-elle descendue sur lui pour la première fois ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6140.mp3',
                'answer' => '<p> R : Il se consacrait à Allah dans la grotte de Hirâ\' et pour cela il s\'approvisionnait à l\'avance.<br /> La Révélation descendit alors sur lui pendant qu\'il était dans la grotte en train de se consacrer à l\'adoration d\'Allah. </p>',
            ],
            14 => [
                'question' => 'Q15 : Quels sont les premiers versets du Coran qui sont descendus sur lui ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6180.mp3',
                'answer' => '<p> R : Sa parole <span class="c2">(Élevé soit-Il)</span> : {Lis au nom de ton Seigneur ! Celui qui a créé <span class="c2">(1)</span> qui a créé l\'Homme d\'une adhérence. <span class="c2">(2)</span> Lis ! Et ton Seigneur est le Plus Généreux. <span class="c2">(3)</span> Celui qui a enseigné par la Plume. <span class="c2">(4)</span> Il a enseigné à l\'Homme ce qu\'il ne savait pas. <span class="c2">(5)</span> } <span class="c5">[Sourate : L\'Adhérence,<span class="c6"> 96 :</span> 1 à 5]</span>. </p>',
            ],
            15 => [
                'question' => 'Q16 : Qui est la première personne à avoir cru au message du Prophète ﷺ ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6200.mp3',
                'answer' => '<p> R : Parmi les hommes : Abû Bakr as Siddîq.<span class="c6"> Parmi les femmes :</span> Khadîja bint Khuwaylid.<span class="c6"> Parmi les enfants :</span> \'Alî ibn Abî Tâlib.<span class="c6"> Parmi les esclaves affranchis :</span> Zayd ibn Hâritha.<span class="c6"> Parmi les esclaves :</span> Bilâl ibn Abî Rabâh, l\'Abyssinien. Qu\'Allah les agrée tous ainsi que tous les autres. </p>',
            ],
            16 => [
                'question' => 'Q17 : Comment se déroula la prédication à l\'Islam ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6230.mp3',
                'answer' => '<p> R : La prédication fut secret durant environ trois années, ensuite il ﷺ ordonna de la proclamer ouvertement. </p>',
            ],
            17 => [
                'question' => 'Q18 : Quelle fut la situation du Prophète ﷺ  et celle de ceux qui avaient  cru en lui après la proclamation ouverte de l\'appel à l\'Islam ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6260.mp3',
                'answer' => '<p> R : Les polythéistes lui firent beaucoup de tort ainsi qu\'aux musulmans, à tel point que les croyant furent autorisés à émigrer auprès du Négus en Abyssinie.<br /> Ensuite, les polythéistes s\'accordèrent pour poursuivre leur nuisance au Prophète ﷺ et même le tuer, mais Allah le protégea et le soutint par le biais de son oncle Abû Tâlib afin de le protéger d\'eux. </p>',
            ],
            18 => [
                'question' => 'Q19 : Qui décéda en l\'an 10 de la mission du Prophète ﷺ ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6300.mp3',
                'answer' => '<p> R : Son oncle Abû Tâlib est décédé ainsi que son épouse Khadîja <span class="c2">(qu\'Allah l\'agrée)</span>. </p>',
            ],
            19 => [
                'question' => 'Q20 : Quand eut lieu le Voyage Nocturne et l\'Ascension (Al Isrâ\' Wal Mi\'râj) ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6330.mp3',
                'answer' => '<p> R : Il eut lieu lors de ses cinquante ans et c\'est à ce moment-là que les cinq prières lui furent prescrites.<br /> Le Voyage Nocturne eut lieu de la Mosquée Sacrée jusqu\'à la Mosquée al Aqsa.<br /> L\'Ascension eut lieu de la Mosquée al Aqsâ jusqu\'au ciel puis jusqu\'au Jujubier de la limite. </p>',
            ],
            20 => [
                'question' => 'Q21 : Comment le Prophète ﷺ appelait-il les gens [à l\'Islam] à l\'extérieur de La Mecque ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6380.mp3',
                'answer' => '<p> R : Il appelait les gens de at Taïf, il se présentait lors des évènements et des rassemblements jusqu\'à ce que les habitants de Médine -Al Ansâr- se présentèrent au Prophète ﷺ, crurent en lui et lui prêtèrent allégeance afin de le secourir. </p>',
            ],
            21 => [
                'question' => 'Q22 : Combien de temps le Prophète ﷺ est-il resté à la Mecque à appeler les gens [à l\'Islam] ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6410.mp3',
                'answer' => '<p> R : Il y est resté treize années. </p>',
            ],
            22 => [
                'question' => 'Q23 : Vers où le Prophète ﷺ a-t-il émigré ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6440.mp3',
                'answer' => '<p> R : Il a émigré de La Mecque vers Médine. </p>',
            ],
            23 => [
                'question' => 'Q24 : Combien de temps est-il ﷺ resté à Médine ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6470.mp3',
                'answer' => '<p> R : Il y est resté dix ans. </p>',
            ],
            24 => [
                'question' => 'Q25 : Que lui fut-il ﷺ prescrit à Médine comme préceptes de l\'Islam ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6490.mp3',
                'answer' => '<p> R : Il lui fut prescrit : l\'aumône légale, le jeûne, le pèlerinage, le combat, l\'appel à la prière ainsi que d\'autres préceptes de l\'Islam. </p>',
            ],
            25 => [
                'question' => 'Q26: Quelles furent ses ﷺ plus importantes batailles ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6520.mp3',
                'answer' => '<p> R : La bataille de Badr <span class="c2">(Badr Al Kubrâ)</span>.<br /> La bataille de Uhud.<br /> La bataille des Coalisés <span class="c2">(Al Ahzâb)</span><br /> La bataille de la Conquête de La Mecque <span class="c2">(Fath Makkah)</span>. </p>',
            ],
            26 => [
                'question' => 'Q27 : Quels furent les derniers versets révélés ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6580.mp3',
                'answer' => '<p> R : Sa parole <span class="c2">(Élevé soit-Il)</span> : {Et craignez un jour où vous serez ramenés vers Allah, alors chaque âme sera pleinement rétribuée de ce qu\'elle aura acquis. Et il ne seront point lésés. <span class="c2">(281)</span> } <span class="c5">[Sourate : La Vache,<span class="c6"> 2 :</span> 281]</span>. </p>',
            ],
            27 => [
                'question' => 'Q28 : Quand le Prophète ﷺ est-il décédé ? Quel âge avait-il ﷺ à ce moment-là ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6610.mp3',
                'answer' => '<p> R : Le Prophète ﷺ est décédé durant le mois de Rabî\' I de l\'an 11 de l\'Hégire et il ﷺ avait 63 ans. </p>',
            ],
            28 => [
                'question' => 'Q29 : Mentionne les épouses du Prophète ﷺ ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6640.mp3',
                'answer' => '<p> R : 1- Khadîja bint Khuwaylid <span class="c2">(qu\'Allah l\'agrée)</span>.<br /> 2- Sawda bint Zam\'a <span class="c2">(qu\'Allah l\'agrée)</span>.<br /> 3- \'Aïcha bint Abî Bakr As-Siddîq <span class="c2">(qu\'Allah l\'agrée)</span>.<br /> 4- Hafsa bint \'Umar <span class="c2">(qu\'Allah l\'agrée)</span>.<br /> 5- Zayneb bint Khuzayma <span class="c2">(qu\'Allah l\'agrée)</span>.<br /> 6- Um Salama Hind bint Abî Umayya <span class="c2">(qu\'Allah l\'agrée)</span>.<br /> 7- Um Habîba Ramla bint Abî Sufyâne <span class="c2">(qu\'Allah l\'agrée)</span>.<br /> 8- Juwayriyya bint Al Hârith <span class="c2">(qu\'Allah l\'agrée)</span>.<br /> 9- Maymûna bint Al Hârith <span class="c2">(qu\'Allah l\'agrée)</span>.<br /> 10- Safiyya bint Huyi <span class="c2">(qu\'Allah l\'agrée)</span>.<br /> 11- Zayneb bint Jahch <span class="c2">(qu\'Allah l\'agrée)</span>. </p>',
            ],
            29 => [
                'question' => 'Q30 : Qui sont ses ﷺ enfants ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6760.mp3',
                'answer' => '<p> R : Il eut trois garçons :<br /> Al Qâsim,<span class="c6"> et c\'est ainsi qu\'il était surnommé :</span> Abû Al Qâsim.<br /> \'Abd Allah.<br /> Ibrâhîm.<br /> Et parmi les filles,<span class="c6"> il eut :</span><br /> Fâtima.<br /> Ruqayya.<br /> Um Kulthûm.<br /> Zayneb.<br /> Tous ses enfants sont de Khadîja <span class="c2">(qu\'Allah l\'agrée)</span> excepté Ibrâhîm et ils sont tous morts avant lui excepté Fâtima <span class="c2">(qu\'Allah l\'agrée)</span> qui est morte six mois après lui. </p>',
            ],
            30 => [
                'question' => 'Q31 : Mentionne certains attributs physiques du Prophète ﷺ ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6880.mp3',
                'answer' => '<p> R : Il ﷺ était une personne de taille moyenne, ni petit ni grand, plutôt entre les deux. Il ﷺ était blanc, avec un teint légèrement rougeâtre. Il avait une barbe épaisse, de grands yeux, une grande bouche, des cheveux très noirs, de larges épaules, une odeur agréable, et encore d\'autres choses parmi sa belle constitution physique ﷺ. </p>',
            ],
            31 => [
                'question' => 'Q32 : Qu\'est-ce que le Prophète ﷺ laissa à sa communauté ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6910.mp3',
                'answer' => '<p> R : Il ﷺ a laissé sa communauté sur une preuve éclatante, de jour comme de nuit, nul ne s\'en écarte sans qu\'il soit détruit. Il n\'y a pas un bien sans qu\'il l\'a indiqué pour sa communauté et il n\'y a pas un mal sans qu\'il en a averti sa communauté. </p>',
            ],
        ],
        4 => [
            0 => [
                'question' => 'Q1 : Lis la sourate : L\'Ouverture [Al Fâtiha] (n°1) et fais-en l\'exégèse ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6960.mp3',
                'answer' => '<p> R : La sourate : L\'Ouverture et son exégèse :<br /> {Au nom d\'Allah, le Tout-Miséricordieux, le Très-Miséricordieux. <span class="c2">(1)</span> Louange à Allah, Seigneur des mondes. <span class="c2">(2)</span> Le Tout Miséricordieux, le Très Miséricordieux. <span class="c2">(3)</span> Souverain au Jour de la Rétribution. <span class="c2">(4)</span> C\'est Toi <span class="c5">[Seul]</span> que nous adorons et c\'est Toi <span class="c5">[Seul]</span> dont nous cherchons l\'assistance. <span class="c2">(5)</span> Guide-<span class="c6">nous sur le droit chemin :</span> <span class="c2">(6)</span> le chemin de ceux que Tu as comblés de bienfaits, non pas de ceux qui ont encouru la colère ni les égarés. <span class="c2">(7)</span> } <span class="c5">[Sourate : L\'Ouverture,<span class="c6"> 1 :</span> 1 à 7]</span>.<span class="c6"><br /> Exégèse :</span><br /> Cette sourate a été appelée la sourate de l\'Ouverture car le Livre d\'Allah débute par cette dernière.<br /> 1- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001001.mp3"></audio> <span class="c4">{بِسۡمِ ٱللَّهِ ٱلرَّحۡمَٰنِ ٱلرَّحِيمِ}</span> {Au nom d\'Allah, le Tout-Miséricordieux, le Très-Miséricordieux. <span class="c2">(1)</span> } Au nom d\'Allah, je commence la lecture du Coran en cherchant assistance auprès de Lui <span class="c2">(Élevé soit-Il)</span> et en recherchant la bénédiction par la mention de Son nom.<br /> <span class="c4">{Allah}</span> C\'est-à-<span class="c6">dire :</span> Celui qui est adoré en toute vérité. Et personne autre que Lui <span class="c2">(Glorifié soit-Il)</span> n\'est appelé ainsi.<br /> <span class="c4">{Le Tout-Miséricordieux}</span> C\'est-à-<span class="c6">dire :</span> Le Détenteur de la vaste miséricorde. Il est Celui dont la miséricorde a embrassé toute chose.<br /> <span class="c4">{Le Très-Miséricordieux}</span> C\'est-à-<span class="c6">dire :</span> Le Détenteur de la miséricorde envers les croyants.<br /> 2- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001002.mp3"></audio> <span class="c4">{ٱلۡحَمۡدُ لِلَّهِ رَبِّ ٱلۡعَٰلَمِينَ}</span> {Louange à Allah, Seigneur des mondes. <span class="c2">(2)</span> } : C\'est-à-<span class="c6">dire :</span> L\'ensemble des types de louanges et la perfection appartiennent à Allah, Seul.<br /> 3- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001003.mp3"></audio> <span class="c4">{ٱلرَّحۡمَٰنِ ٱلرَّحِيمِ}</span> {Le Tout Miséricordieux, le Très Miséricordieux. <span class="c2">(3)</span> } : C\'est-à-<span class="c6">dire :</span> Le Détenteur de la vaste miséricorde, celle qui a embrassé toute chose. Et le Détenteur de la miséricorde qui parvient <span class="c5">[spécifiquement]</span> aux croyants.<br /> 4- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001004.mp3"></audio> <span class="c4">{مَٰلِكِ يَوۡمِ ٱلدِّينِ}</span> {Souverain au Jour de la Rétribution. <span class="c2">(4)</span> } : C\'est le Jour de la Résurrection.<br /> 5- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001005.mp3"></audio> <span class="c4">{إِيَّاكَ نَعۡبُدُ وَإِيَّاكَ نَسۡتَعِينُ}</span> {C\'est Toi <span class="c5">[Seul]</span> que nous adorons et c\'est Toi <span class="c5">[Seul]</span> dont nous cherchons l\'assistance. <span class="c2">(5)</span> } : C\'est-à-<span class="c6">dire :</span> Nous n\'adorons que Toi, Seul ; et nous cherchons assistance qu\'auprès de Toi uniquement.<br /> 6- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001006.mp3"></audio> <span class="c4">{ٱهۡدِنَا ٱلصِّرَٰطَ ٱلۡمُسۡتَقِيمَ}</span> {Guide-<span class="c6">nous sur le droit chemin :</span> <span class="c2">(6)</span> } : C\'est la guidée vers l\'Islam et la Tradition prophétique.<br /> 7- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001007.mp3"></audio> <span class="c4">{صِرَٰطَ ٱلَّذِينَ أَنۡعَمۡتَ عَلَيۡهِمۡ غَيۡرِ ٱلۡمَغۡضُوبِ عَلَيۡهِمۡ وَلَا ٱلضَّآلِّينَ}</span> {Le chemin de ceux que Tu as comblés de bienfaits, non pas de ceux qui ont encouru la colère ni les égarés. <span class="c2">(7)</span> } : C\'est-à-<span class="c6">dire :</span> La voie des vertueux serviteurs d\'Allah parmi les Prophètes et ceux qui les ont suivi <span class="c5">[parmi les véridiques, les martyrs et les vertueux]</span> et non la voie des juifs et des chrétiens.<br /> - Et après sa lecture,<span class="c6"> cela fait partie de la Tradition de dire :</span> " Âmîn ",<span class="c6"> dont la signification est :</span> " Exauce-nous ! " </p>',
            ],
            1 => [
                'question' => 'Q2 : Lis la sourate : La Secousse (Az-Zalzalah] (n°99) et fais-en l\'exégèse ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7130.mp3',
                'answer' => '<p> R : La sourate : La Secousse <span class="c2">(n°99)</span> et son exégèse :<br /> Au nom d\'Allah, le Tout Miséricordieux, le Très Miséricordieux.<br /> {Lorsque la Terre tremblera d\'un violente secousse <span class="c2">(1)</span> Et que la Terre fera sortir ses fardeaux <span class="c2">(2)</span> Et que l\'homme dira : " Qu\'a-t-elle ? " <span class="c2">(3)</span> Ce jour-là, elle racontera ses nouvelles <span class="c2">(4)</span> Selon ce que ton Seigneur lui aura révélé. <span class="c2">(5)</span> Ce jour-là, les gens sortiront séparément pour que leur soient montrées leurs œuvres. <span class="c2">(6)</span> Quiconque accomplit donc le poids d\'un atome de bien, le verra <span class="c2">(7)</span> Et quiconque commet le poids d\'un atome de mal, le verra. <span class="c2">(8)</span> } <span class="c5">[Sourate : La Secousse,<span class="c6"> 99 :</span> 1 à 8]</span>.<span class="c6"><br /> Exégèse :</span><br /> 1- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099001.mp3"></audio> <span class="c4">{إِذَا زُلۡزِلَتِ ٱلۡأَرۡضُ زِلۡزَالَهَا}</span> {Lorsque la Terre tremblera d\'un violente secousse <span class="c2">(1)</span> } : Lorsque la Terre bougera d\'un violent mouvement qui provoquera alors le Jour de la Résurrection.<br /> 2- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099002.mp3"></audio> <span class="c4">{وَأَخۡرَجَتِ ٱلۡأَرۡضُ أَثۡقَالَهَا}</span> {Et que la Terre fera sortir ses fardeaux <span class="c2">(2)</span> } : La Terre fera sortir ce qu\'il y a en son sein parmi les morts et autres.<br /> 3- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099003.mp3"></audio> <span class="c4">{وَقَالَ ٱلۡإِنسَٰنُ مَا لَهَا}</span> {Et que l\'homme dira : " Qu\'a-t-elle ? " <span class="c2">(3)</span> } : De manière perplexe,<span class="c6"> l\'homme dira :</span> " Qu\'est-ce que la Terre a à ainsi bouger et se secouer !?<br /> 4- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099004.mp3"></audio> <span class="c4">{يَوۡمَئِذٖ تُحَدِّثُ أَخۡبَارَهَا}</span> {Ce jour-là, elle racontera ses nouvelles <span class="c2">(4)</span> } : En cet immense jour, la Terre informera de ce qui aura été accompli à sa surface, de bien ou de mal.<br /> 5- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099005.mp3"></audio> <span class="c4">{بِأَنَّ رَبَّكَ أَوۡحَىٰ لَهَا}</span> {Selon ce que ton Seigneur lui aura révélé. <span class="c2">(5)</span> } : Parce qu\'Allah l\'aura informé et lui aura ordonné cela.<br /> 6- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099006.mp3"></audio> <span class="c4">{يَوۡمَئِذٖ يَصۡدُرُ ٱلنَّاسُ أَشۡتَاتٗا لِّيُرَوۡاْ أَعۡمَٰلَهُمۡ}</span> {Ce jour-là, les gens sortiront séparément pour que leur soient montrées leurs œuvres. <span class="c2">(6)</span> } : En cet immense jour, celui où la Terre tremblera, les gens sortiront séparément de la station du jugement afin qu\'ils voient leurs œuvres qu\'ils auront accompli en ce bas monde.<br /> 7- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099007.mp3"></audio> <span class="c4">{فَمَن يَعۡمَلۡ مِثۡقَالَ ذَرَّةٍ خَيۡرٗا يَرَهُۥ}</span> {Quiconque accomplit donc le poids d\'un atome de bien, le verra <span class="c2">(7)</span> } : Quiconque aura accompli le poids d\'une petite fourmi comme œuvres de bien et de charité le verra devant lui.<br /> 8- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099008.mp3"></audio> <span class="c4">{وَمَن يَعۡمَلۡ مِثۡقَالَ ذَرَّةٖ شَرّٗا يَرَهُۥۥ}</span> {Et quiconque commet le poids d\'un atome de mal, le verra. <span class="c2">(8)</span> } : Et quiconque aura commis le poids d\'une petite fourmi comme œuvres de mal le verra devant lui. </p>',
            ],
            2 => [
                'question' => 'Q3 : Lis la sourate : Les Coursiers (n°100) et fais-en l\'exégèse ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7270.mp3',
                'answer' => '<p> R : La sourate : Les Coursiers <span class="c2">(n°100)</span> et son exégèse :<br /> Au nom d\'Allah, le Tout Miséricordieux, le Très Miséricordieux.<br /> {Par les coursiers qui halètent ! <span class="c2">(1)</span> Qui font jaillir des étincelles <span class="c2">(2)</span> Qui attaquent au matin <span class="c2">(3)</span> Et font ainsi voler la poussière <span class="c2">(4)</span> Et qui pénètrent au centre de la troupe ennemie. <span class="c2">(5)</span> Certes, l\'homme est ingrat envers son Seigneur ; <span class="c2">(6)</span> Et, certes, il est témoin de cela ; <span class="c2">(7)</span> Et, certes, pour l\'amour des richesses il est ardent. <span class="c2">(8)</span> Ne sait-il donc pas que lorsque ce qui est dans les tombes sera bouleversé ? <span class="c2">(9)</span> Et que sera divulgué ce qui est dans les poitrines <span class="c2">(10)</span> <span class="c4">{Certes, ce jour-là, leur Seigneur sera Parfaitement Informé d\'eux ! }</span> <span class="c5">[Sourate : Les Coursiers,<span class="c6"> 100 :</span> 1 à 11]</span>.<span class="c6"><br /> Exégèse :</span><br /> 1- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100001.mp3"></audio> <span class="c4">{وَٱلۡعَٰدِيَٰتِ ضَبۡحٗا}</span> {Par les coursiers qui halètent ! <span class="c2">(1)</span> } : Allah jure par les chevaux qui galopent de sorte qu\'on entend le bruit de leur halètement en raison de leur galop rapide.<br /> 2- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100002.mp3"></audio> <span class="c4">{فَٱلۡمُورِيَٰتِ قَدۡحٗا}</span> {Qui font jaillir des étincelles <span class="c2">(2)</span> } : Il a juré par les chevaux qui font jaillir des étincelles avec leurs sabots lorsqu\'ils touchent des rochers en raison de la dureté de leur impact sur eux.<br /> 3- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100003.mp3"></audio> <span class="c4">{فَٱلۡمُغِيرَٰتِ صُبۡحٗا}</span> {Qui attaquent au matin <span class="c2">(3)</span> } : Il a juré par les chevaux qui fondent sur les ennemis à l\'aube.<br /> 4- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100004.mp3"></audio> <span class="c4">{فَأَثَرۡنَ بِهِۦ نَقۡعٗا}</span> {Et font ainsi voler la poussière <span class="c2">(4)</span> } : Avec leur galop, ils soulèvent de la poussière.<br /> 5- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100005.mp3"></audio> <span class="c4">{فَوَسَطۡنَ بِهِۦ جَمۡعًا}</span> {Et qui pénètrent au centre de la troupe ennemie. <span class="c2">(5)</span> } : Avec leur cavalerie, ils pénètrent au centre des ennemis.<br /> 6- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100006.mp3"></audio> <span class="c4">{إِنَّ ٱلۡإِنسَٰنَ لِرَبِّهِۦ لَكَنُودٞ}</span> {Certes, l\'homme est ingrat envers son Seigneur ; <span class="c2">(6)</span> } : Certes, l\'homme prive <span class="c5">[son prochain]</span> du bien que son Seigneur veut pourtant de lui.<br /> 7- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100007.mp3"></audio> <span class="c4">{وَإِنَّهُۥ عَلَىٰ ذَٰلِكَ لَشَهِيدٞ}</span> {Et, certes, il est témoin de cela ; <span class="c2">(7)</span> } : Et pourtant il est témoin de cette privation du bien qu\'il commet. Il ne peut pas nier cela étant donné sa clarté.<br /> 8- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100008.mp3"></audio> <span class="c4">{وَإِنَّهُۥ لِحُبِّ ٱلۡخَيۡرِ لَشَدِيدٌ}</span> {Et, certes, pour l\'amour des richesses il est ardent. <span class="c2">(8)</span> } : Et en raison de son vif amour pour l\'argent, il se montre avare.<br /> 9- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100009.mp3"></audio> <span class="c4">{أَفَلَا يَعۡلَمُ إِذَا بُعۡثِرَ مَا فِي ٱلۡقُبُورِ}</span> {Ne sait-il donc pas que lorsque ce qui est dans les tombes sera bouleversé ? <span class="c2">(9)</span> } : Cet homme qui est leurré par cette vie d\'ici-bas ne sait-il pas que lorsqu\'Allah ressuscitera ce qu\'il y a dans les tombes, notamment les morts, et qu\'Il les sortira de la terre pour le jugement et la rétribution que l\'affaire n\'était pas comme il se l\'était imaginé !?<br /> 10- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100010.mp3"></audio> <span class="c4">{وَحُصِّلَ مَا فِي ٱلصُّدُورِ}</span> {Et que sera divulgué ce qui est dans les poitrines <span class="c2">(10)</span> } : Ce qui était dans les cœurs,<span class="c6"> comme :</span> intentions, croyances, etc. sera rendu manifeste et montré clairement.<br /> 11- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100011.mp3"></audio> <span class="c4">{إِنَّ رَبَّهُم بِهِمۡ يَوۡمَئِذٖ لَّخَبِيرُۢ}</span> {Certes, ce jour-là, leur Seigneur sera Parfaitement Informé d\'eux ! <span class="c2">(11)</span> } : Certes, en ce jour, leur Seigneur sera parfaitement informé d\'eux. Rien ne Lui échappera comme affaire de Ses serviteurs et Il les rétribuera pour cela. </p>',
            ],
            3 => [
                'question' => 'Q3 : Lis la sourate : Le Fracas (n°101) et fais-en l\'exégèse ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7450.mp3',
                'answer' => '<p> R : La sourate : Le Fracas <span class="c2">(n°101)</span> et son exégèse :<br /> Au nom d\'Allah, le Tout Miséricordieux, le Très Miséricordieux.<br /> {Le Fracas ! <span class="c2">(1)</span> Qu\'est-ce que le Fracas ? <span class="c2">(2)</span> Et qui te dira ce qu\'est le Fracas ? <span class="c2">(3)</span> C\'est le jour où les gens seront comme des papillons éparpillés <span class="c2">(4)</span> et les montagnes <span class="c5">[seront]</span> comme de la laine cardée. <span class="c2">(5)</span> Quant à quiconque dont les balances seront lourdes, <span class="c2">(6)</span> alors il sera dans une vie agréable. <span class="c2">(7)</span> Quant à quiconque dont les balances seront légères, <span class="c2">(8)</span> alors son refuge sera un abîme profond. <span class="c2">(9)</span> Et qui te dira ce que c\'est ? <span class="c2">(10)</span> C\'est un feu ardent. <span class="c2">(11)</span> } <span class="c5">[Sourate : Le Fracas,<span class="c6"> 101 :</span> 1 à 11]</span>.<span class="c6"><br /> Exégèse :</span><br /> 1- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101001.mp3"></audio> <span class="c4">{ٱلۡقَارِعَةُ}</span> {Le Fracas ! <span class="c2">(1)</span> } : L\'Heure qui fera trembler les cœurs des gens en raison de l\'énorme effroi qu\'elle causera.<br /> 2- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101002.mp3"></audio> <span class="c4">{مَا ٱلۡقَارِعَةُ}</span> {Qu\'est-ce que le Fracas ? <span class="c2">(2)</span> } : Quelle est cette Heure qui fera trembler les cœurs des gens en raison de la gravité de ses affres !?<br /> 3- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101003.mp3"></audio> <span class="c4">{وَمَآ أَدۡرَىٰكَ مَا ٱلۡقَارِعَةُ}</span> {Et qui te dira ce qu\'est le Fracas ? <span class="c2">(3)</span> } Et qui t\'a informé - ô Messager - de cette Heure qui fera trembler les cœurs des gens en raison de la grandeur de sa frayeur ? Certes, c\'est le Jour de la Résurrection.<br /> 4- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101004.mp3"></audio> <span class="c4">{يَوۡمَ يَكُونُ ٱلنَّاسُ كَٱلۡفَرَاشِ ٱلۡمَبۡثُوثِ}</span> {C\'est le jour où les gens seront comme des papillons éparpillés ; <span class="c2">(4)</span> } : Le jour où les cœurs des gens trembleront, ils seront comme des papillons éparpillés ici et là.<br /> 5- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101005.mp3"></audio> <span class="c4">{وَتَكُونُ ٱلۡجِبَالُ كَٱلۡعِهۡنِ ٱلۡمَنفُوشِ}</span> {et les montagnes seront comme de la laine cardée ;<br /> <span class="c2">(5)</span> } : Les montagnes seront comme de la laine enroulée dans la légèreté de son filage et sa texture.<br /> 6- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101006.mp3"></audio> <span class="c4">{فَأَمَّا مَن ثَقُلَتۡ مَوَٰزِينُهُۥ}</span> {Quant à quiconque dont les balances seront lourdes, <span class="c2">(6)</span> } : Quiconque dont les bonnes œuvres surpasseront les mauvaises œuvres.<br /> 7- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101007.mp3"></audio> <span class="c4">{فَهُوَ فِي عِيشَةٖ رَّاضِيَةٖ}</span> {Alors, il sera dans une vie agréable. <span class="c2">(7)</span> } : Il sera dans une vie de satisfaction qu\'il obtiendra au Paradis.<br /> 8- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101008.mp3"></audio> <span class="c4">{وَأَمَّا مَنۡ خَفَّتۡ مَوَٰزِينُهُۥ}</span> {Et quant à quiconque dont les balances seront légères,<span class="c2">(8)</span> } : Quiconque dont les mauvaises œuvres surpasseront les bonnes œuvres, de par le peu de ces dernières.<br /> 9- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101009.mp3"></audio> <span class="c4">{فَأُمُّهُۥ هَاوِيَةٞ}</span> {Alors, sa mère <span class="c5">[destination]</span> sera un abîme profond. <span class="c2">(9)</span> } : Alors, au Jour de la Résurrection, sa demeure et son refuge seront la Géhenne.<br /> 10- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101010.mp3"></audio> <span class="c4">{وَمَآ أَدۡرَىٰكَ مَا هِيَهۡ}</span> {Et qui te dira ce que c\'est ? <span class="c2">(10)</span> } : Et qui t\'a informé - ô Messager - de ce que c\'est !?<br /> 11- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101011.mp3"></audio> <span class="c4">{نَارٌ حَامِيَةُۢ}</span> {C\'est un feu ardent. <span class="c2">(11)</span> } : C\'est un feu à la chaleur ardente. </p>',
            ],
            4 => [
                'question' => 'Q5 : Lis la sourate : La Course aux Richesses [At-Takâthur] (n°102) et fais-en l\'exégèse ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7610.mp3',
                'answer' => '<p> R : La sourate : La Course aux Richesses <span class="c2">(n°102)</span> et son exégèse :<br /> Au nom d\'Allah, le Tout Miséricordieux, le Très Miséricordieux.<br /> {La course aux richesses vous distrait <span class="c2">(1)</span> jusqu\'à ce que vous visitiez les cimetières. <span class="c2">(2)</span> Mais non ! Bientôt, vous saurez. <span class="c2">(3)</span> Mais non encore ! Bientôt, vous saurez. <span class="c2">(4)</span> Mais non ! Si vous saviez de science certaine. <span class="c2">(5)</span> Vraiment, vous verrez la Fournaise ! <span class="c2">(6)</span> Ensuite, vous la verrez de l\'œil de la certitude <span class="c2">(7)</span> Puis, ce jour-là, vous serez vraiment interrogés concernant les délices. <span class="c2">(8)</span> <span class="c5">[Sourate : La Course aux Richesses,<span class="c6"> 102 :</span> 1 à 8]</span>.<span class="c6"><br /> Exégèse :</span><br /> 1- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102001.mp3"></audio> <span class="c4">{أَلۡهَىٰكُمُ ٱلتَّكَاثُرُ}</span> {La course aux richesses vous distrait <span class="c2">(1)</span> } : Ô gens ! Votre préoccupation réside dans la vantardise à travers les biens et les enfants au lieu de l\'obéissance à Allah.<br /> 2- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102002.mp3"></audio> <span class="c4">{حَتَّىٰ زُرۡتُمُ ٱلۡمَقَابِرَ}</span> {Jusqu\'à ce que vous visitiez les cimetières. <span class="c2">(2)</span> } : Jusqu\'à ce que vous mourriez et vous entriez dans vos tombes.<br /> 3- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102003.mp3"></audio> <span class="c4">{كَلَّا سَوۡفَ تَعۡلَمُونَ}</span> {Mais non ! Bientôt, vous saurez. <span class="c2">(3)</span> } : Si votre préoccupation est la vanité au lieu d\'obéir à Allah, alors bientôt vous connaîtrez la conséquence de cette préoccupation.<br /> 4- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102004.mp3"></audio> <span class="c4">{ثُمَّ كَلَّا سَوۡفَ تَعۡلَمُونَ}</span> {Mais non encore ! Bientôt, vous saurez. <span class="c2">(4)</span> } : Ensuite, bientôt, vous saurez sa conséquence.<br /> 5- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102005.mp3"></audio> <span class="c4">{كَلَّا لَوۡ تَعۡلَمُونَ عِلۡمَ ٱلۡيَقِينِ}</span> {Mais non ! Si vous saviez de science certaine. <span class="c2">(5)</span> } : Vraiment, si vous saviez avec certitude que vous serez ressuscités devant Allah et qu\'Il vous rétribuera pour vos œuvres, vous ne vous préoccuperiez pas de vous vanter des biens et des enfants.<br /> 6- 102_6 <span class="c4">{لَتَرَوُنَّ ٱلۡجَحِيمَ}</span> {Vraiment, vous verrez la Fournaise ! <span class="c2">(6)</span> } : Par Allah ! Vraiment, au Jour de la Résurrection, vous verrez l\'Enfer.<br /> 7- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102007.mp3"></audio> <span class="c4">{ثُمَّ لَتَرَوُنَّهَا عَيۡنَ ٱلۡيَقِينِ}</span> {Ensuite, vous la verrez de l\'œil de la certitude <span class="c2">(7)</span> } : Puis, vraiment, vous la verrez d\'une vision certaine sur laquelle il n\'y a aucun doute.<br /> 8- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102008.mp3"></audio> <span class="c4">{ثُمَّ لَتُسۡـَٔلُنَّ يَوۡمَئِذٍ عَنِ ٱلنَّعِيمِ}</span> {Puis, ce jour-là, vous serez vraiment interrogés concernant les délices. <span class="c2">(8)</span> } : Ensuite, en ce jour, vraiment Allah vous interrogera concernant ce dont Il vous a comblés de bienfaits,<span class="c6"> comme :</span> la santé, la richesse, etc. </p>',
            ],
            5 => [
                'question' => 'Q6 : Lis la sourate : Le Temps [Al \'Asr] (n°103) et fais-en l\'exégèse ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7750.mp3',
                'answer' => '<p> R : La sourate : Le temps <span class="c2">(n°102)</span> et son exégèse :<br /> Au nom d\'Allah, le Tout Miséricordieux, le Très Miséricordieux.<br /> {Par le temps <span class="c5">[qui passe]</span> ! <span class="c2">(1)</span> Certes, l’homme est vraiment en perdition <span class="c2">(2)</span> Excepté ceux qui ont cru, ont accompli les œuvres vertueuses, se sont recommandé la vérité et se sont recommandé la patience <span class="c2">(3)</span>.} <span class="c5">[Sourate : Le Temps,<span class="c6"> 103 :</span> 1 à 3]</span>.<span class="c6"><br /> Exégèse :</span><br /> 1- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/103001.mp3"></audio> <span class="c4">{وَٱلۡعَصۡرِ}</span> {Par le temps <span class="c5">[qui passe]</span> ! <span class="c2">(1)</span> } : Allah <span class="c2">(Glorifié soit-Il)</span> a juré par le temps.<br /> 2- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/103002.mp3"></audio> <span class="c4">{إِنَّ ٱلۡإِنسَٰنَ لَفِي خُسۡرٍ}</span> {Certes, l’homme est vraiment en perdition <span class="c2">(2)</span> } : C\'est-à-<span class="c6">dire :</span> Chaque homme est voué à la diminution et la destruction.<br /> 3- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/103003.mp3"></audio> <span class="c4">{إِلَّا ٱلَّذِينَ ءَامَنُواْ وَعَمِلُواْ ٱلصَّٰلِحَٰتِ وَتَوَاصَوۡاْ بِٱلۡحَقِّ وَتَوَاصَوۡاْ بِٱلصَّبۡرِ}</span> {Excepté ceux qui ont cru, ont accompli les œuvres vertueuses, se sont recommandé la vérité et se sont recommandé la patience <span class="c2">(3)</span>.<span class="c6">} :</span> Excepté quiconque a cru et a vertueusement œuvré ; et en plus de cela, ces gens ont appelé à la vérité et ont patienté sur elle. Ces personnes-là sont donc celles qui sont sauvées de la perdition. </p>',
            ],
            6 => [
                'question' => 'Q7 :  Lis la sourate : Le Calomniateurs (n°104) et fais-en l\'exégèse ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7830.mp3',
                'answer' => '<p> R : La sourate : Les Calomniateurs <span class="c2">(n°104)</span> et son exégèse :<br /> Au nom d\'Allah, le Tout Miséricordieux, le Très Miséricordieux.<br /> {Malheur à tout calomniateur, diffamateur <span class="c2">(1)</span> qui amasse l\'argent et le compte <span class="c2">(2)</span> il pense que son argent l\'immortalisera. <span class="c2">(3)</span> Mais non ! Vraiment, il sera jeté dans Al Hutamah. <span class="c2">(4)</span> Et qui te dira ce qu\'est Al Hutamah ? <span class="c2">(5)</span> C\'est le feu attisé d\'Allah <span class="c2">(6)</span> qui monte jusqu\'aux cœurs. <span class="c2">(7)</span> Certes, il se refermera sur eux <span class="c2">(8)</span> en colonnes <span class="c5">[de flammes]</span> étendues. <span class="c2">(9)</span> } <span class="c5">[Sourate : Les Calomniateurs,<span class="c6"> 104 :</span> 1 à 9]</span>.<span class="c6"><br /> Exégèse :</span><br /> 1- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104001.mp3"></audio> <span class="c4">{وَيۡلٞ لِّكُلِّ هُمَزَةٖ لُّمَزَةٍ}</span> {Malheur à tout calomniateur, diffamateur <span class="c2">(1)</span> } : Malheur et dur châtiment à celui qui calomnie en masse les gens et les critique.<br /> 2- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104002.mp3"></audio> <span class="c4">{ٱلَّذِي جَمَعَ مَالٗا وَعَدَّدَهُۥ}</span> {qui amasse l\'argent et le compte <span class="c2">(2)</span> } : Celui dont l\'unique souci est d\'accumuler l\'argent et le dénombrer, et rien d\'autre en dehors de cela.<br /> 3- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104003.mp3"></audio> <span class="c4">{يَحۡسَبُ أَنَّ مَالَهُۥٓ أَخۡلَدَهُۥ}</span> {Et il pense que son argent l\'immortalisera. <span class="c2">(3)</span> } : Il croit que son argent qu\'il a accumulé le sauvera de la mort et il restera éternellement en ce bas monde.<br /> 4- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104004.mp3"></audio> <span class="c4">{كَلَّاۖ لَيُنۢبَذَنَّ فِي ٱلۡحُطَمَةِۥ}</span> {Mais non ! Vraiment, il sera jeté dans Al Hutamah. <span class="c2">(4)</span> } : L\'affaire n\'est pas comme cet ignorant se la représente. En fait, il sera jeté dans le Feu de la Géhenne qui brise et broie tout ce qui est jeté en son sein en raison de son dureté.<br /> 5- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104005.mp3"></audio> <span class="c4">{وَمَآ أَدۡرَىٰكَ مَا ٱلۡحُطَمَةُ}</span> {Et qui te dira ce qu\'est Al Hutamah ? <span class="c2">(5)</span> } : Et qui t\'a informé - ô Messager - quel est ce feu qui brise tout ce qui est jeté dedans !?<br /> 6- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104006.mp3"></audio> <span class="c4">{نَارُ ٱللَّهِ ٱلۡمُوقَدَةُ}</span> {C\'est le feu attisé d\'Allah <span class="c2">(6)</span> } : Certes, c\'est le Feu ardent d\'Allah.<br /> 7- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104007.mp3"></audio> <span class="c4">{ٱلَّتِي تَطَّلِعُ عَلَى ٱلۡأَفۡـِٔدَةِ}</span> {Qui monte jusqu\'aux cœurs. <span class="c2">(7)</span> } : Qui remonte des corps des gens jusqu\'à leurs cœurs.<br /> 8- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104008.mp3"></audio> <span class="c4">{إِنَّهَا عَلَيۡهِم مُّؤۡصَدَةٞ}</span> {Certes, il se refermera sur eux <span class="c2">(8)</span> } : Certes, il se fermera sur les châtiés.<br /> 9- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104009.mp3"></audio> <span class="c4">{فِي عَمَدٖ مُّمَدَّدَةِۭ}</span> {en colonnes <span class="c5">[de flammes]</span> étendues. <span class="c2">(9)</span> } : En longues colonnes étendues jusqu\'à ce qu\'ils ne puissent pas en sortir. </p>',
            ],
            7 => [
                'question' => 'Q8 :  Lis la sourate : L\'Éléphant [Al Fîl] (n°105) et fais-en l\'exégèse ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7970.mp3',
                'answer' => '<p> R : La sourate : L\'Éléphant <span class="c2">(n°105)</span> et son exégèse ?<br /> Au nom d\'Allah, le Tout Miséricordieux, le Très Miséricordieux.<br /> {N\'as-tu pas vu comment ton Seigneur a agi envers les Gens de l\'éléphant ? <span class="c2">(1)</span> N\'a-t-Il pas rendu leur complot <span class="c5">[complètement]</span> vain ? <span class="c2">(2)</span> Et Il leur a envoyé des oiseaux par volées <span class="c2">(3)</span> qui leur lançaient des pierres d\'argile ? <span class="c2">(4)</span> Et Il les a rendus semblables à de la paille mâchée. <span class="c2">(5)</span> } <span class="c5">[Sourate : L\'Éléphant,<span class="c6"> 105 :</span> 1 à 5]</span>.<span class="c6"><br /> Exégèse :</span><br /> 1- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105001.mp3"></audio> <span class="c4">{أَلَمۡ تَرَ كَيۡفَ فَعَلَ رَبُّكَ بِأَصۡحَٰبِ ٱلۡفِيلِ}</span> {N\'as-tu pas vu comment ton Seigneur a agi envers les Gens de l\'éléphant ? <span class="c2">(1)</span> } : N\'as-tu pas su - ô Messager - comment ton Seigneur a agi avec Abraha et ses compagnons, les Gens de l\'éléphant, au moment où ils ont voulu détruire la Ka\'bah !?<br /> 2- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105002.mp3"></audio> <span class="c4">{أَلَمۡ يَجۡعَلۡ كَيۡدَهُمۡ فِي تَضۡلِيلٖ}</span> {N\'a-t-Il pas rendu leur complot <span class="c5">[complètement]</span> vain ? <span class="c2">(2)</span> } : Assurément, Allah a voué à la perdition leur mauvais plan de destruction de la Ka\'bah, de sorte qu\'ils n\'ont pas obtenu ce qu\'ils souhaitaient,<span class="c6"> à savoir :</span> détourner les gens de la Ka\'bah. En fait, ils n\'en ont rien obtenu.<br /> 3- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105003.mp3"></audio> <span class="c4">{وَأَرۡسَلَ عَلَيۡهِمۡ طَيۡرًا أَبَابِيلَ}</span> {Et Il leur a envoyé des oiseaux par volées <span class="c2">(3)</span> } : Il leur a envoyé des oiseaux qui sont venus à eux groupes après groupes.<br /> 4- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105004.mp3"></audio> <span class="c4">{تَرۡمِيهِم بِحِجَارَةٖ مِّن سِجِّيلٖ}</span> {qui leur lançaient des pierres d\'argile ? <span class="c2">(4)</span> } : Ils leur lançaient des pierres d\'argile pétrifiée.<br /> 5- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105005.mp3"></audio> <span class="c4">{فَجَعَلَهُمۡ كَعَصۡفٖ مَّأۡكُولِۭ}</span> {Et Il les a rendus semblables à de la paille mâchée. <span class="c2">(5)</span> } : Allah les a rendus comme des feuilles de plants qui ont été mangées et mâchées par les bêtes. </p>',
            ],
            8 => [
                'question' => 'Q9 : Lis la sourate : Quraych (n°106) et fais-en l\'exégèse ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8070.mp3',
                'answer' => '<p> R : La sourate : Quraych <span class="c2">(n°106)</span> et son exégèse ?<br /> Au nom d\'Allah, le Tout Miséricordieux, le Très Miséricordieux.<br /> {En raison du pacte de Quraych <span class="c2">(1)</span> De leur pacte concernant les voyages d\'hiver et d\'été <span class="c2">(2)</span> Qu\'ils adorent donc le Seigneur de cette Demeure <span class="c2">(3)</span> } {Celui qui les a nourris contre la faim et les a rassurés de la peur <span class="c2">(4)</span> } <span class="c5">[Sourate : Quraych,<span class="c6"> 106 :</span> 1 à 4]</span>.<span class="c6"><br /> Exégèse :</span><br /> 1- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106001.mp3"></audio> <span class="c4">{لِإِيلَٰفِ قُرَيۡشٍ}</span> {En raison du pacte de Quraych <span class="c2">(1)</span> } : Le sens voulu de cela désigne l\'habitude que les Quraych avaient de voyager en hiver et en été.<br /> 2- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106002.mp3"></audio> <span class="c4">{إِۦلَٰفِهِمۡ رِحۡلَةَ ٱلشِّتَآءِ وَٱلصَّيۡفِ}</span> {De leur pacte concernant les voyages d\'hiver et d\'été <span class="c2">(2)</span> } : Le voyage d\'hiver au Yémen et le voyage d\'été au Châm, en toute sécurité.<br /> 3- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106003.mp3"></audio> <span class="c4">{فَلۡيَعۡبُدُواْ رَبَّ هَٰذَا ٱلۡبَيۡتِ}</span> {Qu\'ils adorent donc le Seigneur de cette Demeure <span class="c2">(3)</span> } : Qu\'ils adorent donc Allah, le Seigneur de cette Demeure sacrée, Celui qui leur a facilité ces voyages, et qu\'ils ne Lui associent rien.<br /> 4- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106004.mp3"></audio> <span class="c4">{ٱلَّذِيٓ أَطۡعَمَهُم مِّن جُوعٖ وَءَامَنَهُم مِّنۡ خَوۡفِۭ}</span> {Celui qui les a nourris contre la faim et les a rassurés de la peur <span class="c2">(4)</span> } : Celui qui les a nourris contre la faim et qui les a rassurés contre la peur en mettant dans les cœurs des Arabes la grandeur et la haute considération de ce sanctuaire sacré ainsi que celles de ses habitants. </p>',
            ],
            9 => [
                'question' => 'Q 10 : Lis la sourate : L\'Ustensile [Al Mâ\'ûn] (n°107) et fais-en l\'exégèse ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8160.mp3',
                'answer' => '<p> R : La sourate : L\'Ustensile <span class="c2">(n°107)</span> et son exégèse :<br /> Au nom d\'Allah, le Tout Miséricordieux, le Très Miséricordieux.<br /> {As-tu vu celui qui traite de mensonge la Rétribution ? <span class="c2">(1)</span> C\'est celui qui repousse l\'orphelin, <span class="c2">(2)</span> et qui n\'encourage pas à nourrir le pauvre. <span class="c2">(3)</span> Malheur donc, à ceux qui prient, <span class="c2">(4)</span> ceux qui négligent leur prière, <span class="c2">(5)</span> ceux qui sont pleins d\'ostentation <span class="c2">(6)</span> et qui refusent l\'ustensile <span class="c5">[à quiconque en a besoin]</span>. <span class="c2">(7)</span> } <span class="c5">[Sourate : L\'Ustensile,<span class="c6"> 107 :</span> 1 à 7]</span>.<span class="c6"><br /> Exégèse :</span><br /> 1- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107001.mp3"></audio> <span class="c4">{أَرَءَيۡتَ ٱلَّذِي يُكَذِّبُ بِٱلدِّينِ}</span> {As-tu vu celui qui traite de mensonge la Rétribution ? <span class="c2">(1)</span> } : Est-ce que tu as su ce qui est arrivé à celui qui traite de mensonge la Rétribution au Jour de la Résurrection !?<br /> 2- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107002.mp3"></audio> <span class="c4">{فَذَٰلِكَ ٱلَّذِي يَدُعُّ ٱلۡيَتِيمَ}</span> {C\'est celui qui repousse l\'orphelin, <span class="c2">(2)</span> } : C\'est celui qui repousse l\'orphelin avec violence et ne répond pas à son besoin.<br /> 3- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107003.mp3"></audio> <span class="c4">{وَلَا يَحُضُّ عَلَىٰ طَعَامِ ٱلۡمِسۡكِينِ}</span> {Et qui n\'encourage pas à nourrir le pauvre. <span class="c2">(3)</span> }<br /> 4- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107004.mp3"></audio> <span class="c4">{فَوَيۡلٞ لِّلۡمُصَلِّينَ}</span> {Malheur donc, à ceux qui prient, <span class="c2">(4)</span> } : Anéantissement et châtiment pour ceux qui prient.<br /> 5- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107005.mp3"></audio> <span class="c4">{ٱلَّذِينَ هُمۡ عَن صَلَاتِهِمۡ سَاهُونَ}</span> {Ceux qui négligent <span class="c2">(5)</span> } : Ceux qui sont négligents concernant leur prière et qui ne s\'en soucient pas jusqu\'à ce que son temps imparti sorte.<br /> 6- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107006.mp3"></audio> <span class="c4">{ٱلَّذِينَ هُمۡ يُرَآءُونَ}</span> {Ceux qui sont pleins d\'ostentation <span class="c2">(6)</span> } : Ceux qui sont ostentatoires dans leur prière, ils ne sont pas sincères dans leur œuvre pour Allah.<br /> 7- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107007.mp3"></audio> <span class="c4">{وَيَمۡنَعُونَ ٱلۡمَاعُونَ}</span> {Et qui refusent l\'ustensile <span class="c5">[à quiconque en a besoin]</span>. <span class="c2">(7)</span> } : Ils refusent d\'aider leurs prochains de ce qui pourtant ne constitue pas un préjudice pour eux. </p>',
            ],
            10 => [
                'question' => 'Q11 : Lis la sourate : L\'Abondance [Al Kawthar] (n°108) et fais-en l\'exégèse ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8280.mp3',
                'answer' => '<p> R : Sourate : L\'Abondance <span class="c5">[Al Kawthar]</span> <span class="c2">(n°108)</span> et son l\'exégèse ?<br /> Au nom d\'Allah, le Tout Miséricordieux, le Très Miséricordieux.<br /> {Certes, Nous t’avons donné l’Abondance. <span class="c2">(1)</span> Prie donc pour ton Seigneur et sacrifie. <span class="c2">(2)</span> Certes, celui qui te hait sera sans postérité. <span class="c2">(3)</span> } <span class="c5">[Sourate : L\'Abondance,<span class="c6"> 108 :</span> 1 à 3]</span>.<span class="c6"><br /> Exégèse :</span><br /> 1- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/108001.mp3"></audio> <span class="c4">{إِنَّآ أَعۡطَيۡنَٰكَ ٱلۡكَوۡثَرَ}</span> {Certes, Nous t’avons donné l’Abondance. <span class="c2">(1)</span> } : Certes, Nous t\'avons donné - ô Messager - le bien à profusion, et notamment le fleuve de l\'Abondance <span class="c2">(Al Kawthar)</span> au Paradis.<br /> 2- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/108002.mp3"></audio> <span class="c4">{فَصَلِّ لِرَبِّكَ وَٱنۡحَرۡ}</span> {Prie donc pour ton Seigneur et sacrifie. <span class="c2">(2)</span> } : Acquitte-toi du remerciement d\'Allah pour ce bienfait en priant pour Lui, Seul, et en sacrifiant à la différence de ce que font les polythéistes qui eux aussi se rapprochent de leurs idoles par le sacrifice.<br /> 3- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/108003.mp3"></audio> <span class="c4">{إِنَّ شَانِئَكَ هُوَ ٱلۡأَبۡتَرُ}</span> {Certes, celui qui te hait sera sans postérité. <span class="c2">(3)</span> } : Certes, celui qui te déteste est celui qui est coupé de tout bien, l\'oublié, et s\'il est mentionné alors il est mentionné en mal. </p>',
            ],
            11 => [
                'question' => 'Q 12 : Lis la sourate : Les Infidèles  [Al Kâfirûn] (n°109) et fais-en l\'exégèse ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8360.mp3',
                'answer' => '<p> R : Sourate : Les Infidèles <span class="c5">[Al Kâfirûn]</span> <span class="c2">(n°109)</span> et son exégèse :<br /> Au nom d\'Allah, le Tout Miséricordieux, le Très Miséricordieux.<span class="c6"><br /> {Dis :</span> " Ô vous les infidèles ! <span class="c2">(1)</span> Je n’adore pas ce que vous adorez. <span class="c2">(2)</span> Et vous n’êtes pas adorateurs de ce que j’adore. <span class="c2">(3)</span> Et je ne suis pas adorateur de ce que vous avez adoré. <span class="c2">(4)</span> Et vous n’êtes pas adorateurs de ce que j’adore. <span class="c2">(5)</span> À vous votre religion, et à moi ma religion. " <span class="c2">(6)</span> } <span class="c5">[Sourate : Les Infidèles,<span class="c6"> 109 :</span> 1 à 6]</span>.<span class="c6"><br /> Exégèse :</span><br /> 1- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109001.mp3"></audio> <span class="c4">{قُلۡ يَٰٓأَيُّهَا ٱلۡكَٰفِرُونَ}</span> {Dis : " Ô vous les infidèles ! <span class="c2">(1)</span> } : Dis - ô Messager -<span class="c6"> :</span> " Ô vous les mécréants en Allah.<br /> 2- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109002.mp3"></audio> <span class="c4">{لَآ أَعۡبُدُ مَا تَعۡبُدُونَ}</span> {Je n’adore pas ce que vous adorez. <span class="c2">(2)</span> } : Je n\'adore pas ni présentement ni à l\'avenir ce que vous adorez comme statues.<br /> 3- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109003.mp3"></audio> <span class="c4">{وَلَآ أَنتُمۡ عَٰبِدُونَ مَآ أَعۡبُدُ}</span> {Et vous n’êtes pas adorateurs de ce que j’adore. <span class="c2">(3)</span> } : Et vous n\'êtes pas adorateurs de ce que j\'adore, moi, et qui est Allah, le Seul.<br /> 4- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109004.mp3"></audio> <span class="c4">{وَلَآ أَنَا۠ عَابِدٞ مَّا عَبَدتُّمۡ}</span> {Et je ne suis pas adorateur de ce que vous avez adoré. <span class="c2">(4)</span> } : Et je ne suis pas adorateur de ce que vous avez adoré comme statues.<br /> 5- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109005.mp3"></audio> <span class="c4">{وَلَآ أَنتُمۡ عَٰبِدُونَ مَآ أَعۡبُدُ}</span> {Et vous n’êtes pas adorateurs de ce que j’adore. <span class="c2">(5)</span> } : Et vous n\'êtes pas adorateurs de ce que j\'adore, moi, et qui est Allah, le Seul.<br /> 6- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109006.mp3"></audio> <span class="c4">{لَكُمۡ دِينُكُمۡ وَلِيَ دِينِ}</span> {À vous votre religion, et à moi ma religion. " <span class="c2">(6)</span> } : À vous votre religion que vous avez innovée pour vous-mêmes et à moi ma religion qu\'Allah m\'a fait descendre. </p>',
            ],
            12 => [
                'question' => 'Q13 : Lis la sourate : Le Secours [An-Nasr] (n°110) et fais-en l\'exégèse ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8470.mp3',
                'answer' => '<p> R : Sourate : Le Secours <span class="c5">[An-Nasr]</span> <span class="c2">(n°110)</span> et son exégèse :<br /> Au nom d\'Allah, le Tout Miséricordieux, le Très Miséricordieux.<br /> {Lorsque sont venus le secours d\'Allah et le triomphe. <span class="c2">(1)</span> Et que tu as vu les gens entrer en masse dans la religion d\'Allah. <span class="c2">(2)</span> Alors, glorifie par la louange de ton Seigneur et implore le pardon, certes Il est l\'Accueillant au repentir. <span class="c2">(3)</span> } <span class="c5">[Sourate : Le Secours,<span class="c6"> 110 :</span> 1 à 3]</span>.<span class="c6"><br /> Exégèse :</span><br /> 1- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/110001.mp3"></audio> <span class="c4">{إِذَا جَآءَ نَصۡرُ ٱللَّهِ وَٱلۡفَتۡحُ}</span> {Lorsque sont venus le secours d\'Allah et le triomphe. <span class="c2">(1)</span> } : Lorsqu\'est venu le secours d\'Allah de ta religion - ô Messager - ainsi que son renforcement et la conquête de La Mecque s\'est produite.<br /> 2- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/110002.mp3"></audio> <span class="c4">{وَرَأَيۡتَ ٱلنَّاسَ يَدۡخُلُونَ فِي دِينِ ٱللَّهِ أَفۡوَاجٗا}</span> {Et que tu as vu les gens entrer en masse dans la religion d\'Allah. <span class="c2">(2)</span> } : Et tu as vu les gens embrasser l\'Islam délégation après délégation.<br /> 3- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/110003.mp3"></audio> <span class="c4">{فَسَبِّحۡ بِحَمۡدِ رَبِّكَ وَٱسۡتَغۡفِرۡهُۚ إِنَّهُۥ كَانَ تَوَّابَۢا}</span> {Alors, glorifie par la louange de ton Seigneur et implore le pardon, certes Il est l\'Accueillant au repentir. <span class="c2">(3)</span> } : Alors, sache que cela est un signe de la proximité de la fin de la tâche pour laquelle tu as été envoyé. Glorifie donc par la louange ton Seigneur en Le remerciant pour le bienfait du secours et de la victoire et demande Lui le pardon. En effet, Il est l\'Accueillant au repentir, Celui qui accepte le repentir de Ses serviteurs et qui leur pardonne. </p>',
            ],
            13 => [
                'question' => 'Q14 : Lis la sourate : Les Fibres [Al Masad] (n°111) et fais-en l\'exégèse ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8550.mp3',
                'answer' => '<p> R : Sourate : Les Fibres <span class="c5">[Al Masad]</span> <span class="c2">(n°111)</span> et son exégèse :<br /> Au nom d\'Allah, le Tout Miséricordieux, le Très Miséricordieux.<br /> {Que périssent les deux mains d\'Abû Lahab et que lui-même périsse. <span class="c2">(1)</span> Son argent ne lui servira à rien, ni ce qu\'il a acquis. <span class="c2">(2)</span> Il sera brûlé dans un Feu plein de flammes. <span class="c2">(3)</span> De même sa femme, la porteuse de bois, <span class="c2">(4)</span> à son cou, une corde de fibres. <span class="c2">(5)</span> } <span class="c5">[Sourate : Les Fibres),<span class="c6"> 111 :</span> 1 à 5]</span>.<span class="c6"><br /> Exégèse :</span><br /> 1- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111001.mp3"></audio> <span class="c4">{تَبَّتۡ يَدَآ أَبِي لَهَبٖ وَتَبَّ}</span> {Que périssent les deux mains d\'Abû Lahab et que lui-même périsse. <span class="c2">(1)</span> } : Que périssent les deux mains de l\'oncle du Prophète ﷺ, Abû Lahab ibn \'Abd Al Muttalib, en raison de la perdition de son œuvre accomplie puisqu\'il nuisait au Prophète ﷺ. Son effort fut vain.<br /> 2- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111002.mp3"></audio> <span class="c4">{مَآ أَغۡنَىٰ عَنۡهُ مَالُهُۥ وَمَا كَسَبَ}</span> {Son argent ne lui servira à rien, ni ce qu\'il a acquis. <span class="c2">(2)</span> } : C\'est-à-<span class="c6">dire :</span> À quoi lui servira son argent et ses enfants ? Cela ne le prémunira pas du châtiment ni ne lui procurera de la miséricorde.<br /> 3- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111003.mp3"></audio> <span class="c4">{سَيَصۡلَىٰ نَارٗا ذَاتَ لَهَبٖ}</span> {Il sera brûlé dans un Feu plein de flammes. <span class="c2">(3)</span> } : Au Jour de la Résurrection, il entrera dans un Feu plein de flammes dont la chaleur sera ardente.<br /> 4- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111004.mp3"></audio> <span class="c4">{وَٱمۡرَأَتُهُۥ حَمَّالَةَ ٱلۡحَطَبِ}</span> {De même sa femme, la porteuse de bois, <span class="c2">(4)</span> } : Et son épouse, Um Jamîl, celle qui nuisait aussi au Prophète ﷺ en jetant des épines sur son chemin, elle aussi entrera dans le Feu.<br /> 5- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111005.mp3"></audio> <span class="c4">{فِي جِيدِهَا حَبۡلٞ مِّن مَّسَدِۭ}</span> {À son cou, une corde de fibres. <span class="c2">(5)</span> } : À son cou, une corde bien ficelée avec laquelle elle sera conduite en Enfer. </p>',
            ],
            14 => [
                'question' => 'Q15 : Lis la sourate : La Sincérité [Al Ikhlâs] (n°112) et fais-en l\'exégèse.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8650.mp3',
                'answer' => '<p> R : Sourate : La Sincérité <span class="c5">[Al Ikhlâs]</span> <span class="c2">(n°112)</span> et son exégèse :<br /> Au nom d\'Allah, le Tout Miséricordieux, le Très Miséricordieux.<span class="c6"><br /> {Dis :</span> « Il est Allah, l’Unique. <span class="c2">(1)</span> Allah, L\'Absolu. <span class="c2">(2)</span> Il n’a pas enfanté et n’a pas été enfanté <span class="c2">(3)</span> Et nul n’est égal à Lui. » <span class="c2">(4)</span> } <span class="c5">[Sourate : La Sincérité,<span class="c6"> 112 :</span> 1 à 4]</span>.<span class="c6"><br /> Exégèse :</span><br /> 1- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112001.mp3"></audio> <span class="c4">{قُلۡ هُوَ ٱللَّهُ أَحَدٌ}</span> {Dis : « Il est Allah, l’Unique. <span class="c2">(1)</span> } : Dis - ô Messager -<span class="c6"> :</span> Il est Allah, il n\'y a aucune divinité <span class="c5">[digne d\'adoration]</span> autre que Lui.<br /> 2- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112002.mp3"></audio> <span class="c4">{ٱللَّهُ ٱلصَّمَدُ}</span> {Allah, l’Absolu. <span class="c2">(2)</span> } : C\'est-à-<span class="c6">dire :</span> Les besoins des créatures montent à Lui.<br /> 3- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112003.mp3"></audio> <span class="c4">{لَمۡ يَلِدۡ وَلَمۡ يُولَدۡ}</span> {Il n’a pas enfanté et n’a pas été enfanté <span class="c2">(3)</span> } : Il <span class="c2">(Glorifié soit-Il)</span> n\'a pas d\'enfant ni de parent.<br /> 4- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112004.mp3"></audio> <span class="c4">{وَلَمۡ يَكُن لَّهُۥ كُفُوًا أَحَدُۢ}</span> {Et nul n’est égal à Lui. » <span class="c2">(4)</span> } : Et rien ne Lui est semblable parmi Sa création et Ses créatures. </p>',
            ],
            15 => [
                'question' => 'Q16 : Lis la sourate : L\'Aube Naissante [Al Falaq] (n°113) et fais-en l\'exégèse ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8750.mp3',
                'answer' => '<p> R : Sourate : L\'Aube Naissante <span class="c5">[Al Falaq]</span> <span class="c2">(n°113)</span> et son exégèse :<br /> Au nom d\'Allah, le Tout Miséricordieux, le Très Miséricordieux.<span class="c6"><br /> {Dis :</span> " Je me réfugie auprès du Seigneur de l’aube naissante <span class="c2">(1)</span> Contre le mal de ce qu’Il a créé <span class="c2">(2)</span> Contre le mal de l’obscurité lorsqu\'elle s\'approfondit <span class="c2">(3)</span> Contre le mal de celles qui soufflent sur les nœuds <span class="c2">(4)</span> Et contre le mal de l\'envieux lorsqu\'il envie. <span class="c2">(5)</span> } <span class="c5">[Sourate : L\'Aube Naissante,<span class="c6"> 113 :</span> 1 à 5]</span>.<span class="c6"><br /> Exégèse :</span><br /> 1- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113001.mp3"></audio> <span class="c4">{قُلۡ أَعُوذُ بِرَبِّ ٱلۡفَلَقِ}</span> {Dis : " Je me réfugie auprès du Seigneur de l’aube naissante <span class="c2">(1)</span> } : Dis - ô Messager -<span class="c6"> :</span> " Je cherche protection auprès du Seigneur de l\'aube et je cherche refuge auprès de Lui. "<br /> 2- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113002.mp3"></audio> <span class="c4">{مِن شَرِّ مَا خَلَقَ}</span> {Contre le mal de ce qu’Il a créé <span class="c2">(2)</span> } : Contre le mal qui nuit de la part des créatures.<br /> 3- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113003.mp3"></audio> <span class="c4">{وَمِن شَرِّ غَاسِقٍ إِذَا وَقَبَ}</span> {Contre le mal de l’obscurité lorsqu\'elle s\'approfondit <span class="c2">(3)</span> } : Je cherche protection auprès d\'Allah contre les maux et méfaits qui apparaissent la nuit de la part des bêtes et des voleurs.<br /> 4- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113004.mp3"></audio> <span class="c4">{وَمِن شَرِّ ٱلنَّفَّٰثَٰتِ فِي ٱلۡعُقَدِ}</span> {Contre le mal de celles qui soufflent sur les nœuds <span class="c2">(4)</span> } : Et je cherche protection contre le mal des sorcières, celles qui soufflent sur les nœuds.<br /> 5- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113005.mp3"></audio> <span class="c4">{وَمِن شَرِّ حَاسِدٍ إِذَا حَسَدَ}</span> {Et contre le mal de l\'envieux lorsqu\'il envie. <span class="c2">(5)</span> } : Et contre le mal de l\'envieux, du haineux, etc. vis-à-vis des gens lorsqu\'il les envie de ce qu\'Allah leur a octroyé comme bienfaits et qui souhaite voir ces bienfaits disparaître, notamment en leur portant préjudice. </p>',
            ],
            16 => [
                'question' => 'Q17 : Lis la sourate : Les Hommes [An-Nâs] (n°114) et fais-en l\'exégèse ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8870.mp3',
                'answer' => '<p> R : Sourate : Les Hommes <span class="c5">[An-Nâs]</span> <span class="c2">(n°114)</span> et son exégèse :<br /> Au nom d\'Allah, le Tout Miséricordieux, le Très Miséricordieux.<span class="c6"><br /> {Dis :</span> "Je me réfugie auprès du Seigneur des hommes. <span class="c2">(1)</span> Souverain des hommes. <span class="c2">(2)</span> Dieu des hommes. <span class="c2">(3)</span> Contre le mal de celui qui insuffle, le furtif. <span class="c2">(4)</span> Celui qui insuffle <span class="c5">[le mal]</span> dans les poitrines des hommes. <span class="c2">(5)</span> Parmi les djinns et les hommes. <span class="c2">(6)</span> } <span class="c5">[Sourate : Les Hommes,<span class="c6"> 114 :</span> 1 à 6]</span>.<span class="c6"><br /> Exégèse :</span><br /> 1- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114001.mp3"></audio> <span class="c4">{قُلۡ أَعُوذُ بِرَبِّ ٱلنَّاسِ}</span> {Dis : Je me réfugie après du Seigneur des hommes <span class="c2">(1)</span> } : Dis - ô Messager -<span class="c6"> :</span> Je cherche protection auprès du Seigneur des hommes et je cherche asile auprès de Lui.<br /> 2- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114002.mp3"></audio> <span class="c4">{مَلِكِ ٱلنَّاسِ}</span> {Souverain des hommes <span class="c2">(2)</span> } : Celui qui agit parmi eux comme Il le souhaite. Ils n\'ont pas de Souverain autre que Lui.<br /> 3- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114003.mp3"></audio> <span class="c4">{إِلَٰهِ ٱلنَّاسِ}</span> {Dieu des hommes <span class="c2">(3)</span> } Leur être adoré en toute vérité. Ils n\'ont pas d\'autre être adoré en toute vérité autre que Lui.<br /> 4- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114004.mp3"></audio> <span class="c4">{مِن شَرِّ ٱلۡوَسۡوَاسِ ٱلۡخَنَّاسِ}</span> {Contre le mal de l\'insufflateur, le furtif <span class="c2">(4)</span> } : Contre le mal du Diable <span class="c2">(Satan)</span>, celui qui instille ses insufflations chez les hommes.<br /> 5- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114005.mp3"></audio> <span class="c4">{ٱلَّذِي يُوَسۡوِسُ فِي صُدُورِ ٱلنَّاسِ}</span> {Celui qui insuffle <span class="c5">[le mal]</span> dans les poitrines des hommes <span class="c2">(5)</span> } : Celui qui instille ses insufflations dans les cœurs des hommes.<br /> 6- <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114006.mp3"></audio> <span class="c4">{مِنَ ٱلۡجِنَّةِ وَٱلنَّاسِ}</span> {Qu\'il soit parmi les djinns ou les humains <span class="c2">(6)</span> } : C\'est-à-<span class="c6">dire :</span> Celui qui insuffle peut être soit parmi les humains soit parmi les djinns. </p>',
            ],
        ],
        5 => [
            0 => [
                'question' => 'Q1 : Complète le hadith : " Certes, les œuvres ne valent que par les intentions... " Et mentionne certains de ses enseignements ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9030.mp3',
                'answer' => '<p> R : D\'après l\'émir des croyants Abû Hafs \'Umar ibn Al Khattâb <span class="c2">(qu\'Allah - Élevé soit-Il - l\'agrée)</span> : " J\'ai entendu le Messager d\'Allah ﷺ dire : <span class="c3">« Certes, les œuvres ne valent que par les intentions et chaque homme sera rétribué en fonction de son intention. Ainsi, quiconque émigre vers Allah et Son Messager, alors son émigration sera pour Allah et Son Messager ; et quiconque émigre pour un intérêt mondain qu\'il convoite ou pour une femme qu\'il veut épouser, alors son émigration sera pour ce vers quoi il a émigré. »</span> Rapporté par Al Bukhârî et Muslim.<span class="c6"><br /> Quelques enseignements tirés du hadith :</span><br /> 1- Toute œuvre doit avoir une intention, que ce soit une prière, un jeûne, un pèlerinage, etc. parmi les œuvres.<br /> 2- La sincérité pour Allah <span class="c2">(Élevé soit-Il)</span> est obligatoire dans l\'intention.<span class="c6"><br /> * Hadith 2 :</span> </p>',
            ],
            1 => [
                'question' => 'Q2 : Complète le hadith : " Quiconque apporte une chose nouvelle dans notre affaire-ci... " Et mentionne certains de ses enseignements ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9090.mp3',
                'answer' => '<p> R : D\'après la mère des croyants Um \'Abd Allah \'Aïcha <span class="c2">(qu’Allah l’agrée)</span> : " Le Messager d’Allah ﷺ a dit : " Quiconque apporte une chose nouvelle dans notre affaire-ci qui n\'en fait pas partie, alors elle sera rejetée. " Rapporté par Al Bukhâri et Muslim.<span class="c6"><br /> Quelques enseignements tirés du hadith :</span><br /> 1- L\'interdiction de l\'innovation dans la religion.<br /> 2- Les œuvres nouvelles <span class="c5">[dans la religion]</span> sont rejetées et ne sont pas acceptées.<span class="c6"><br /> * Hadith 3 :</span> </p>',
            ],
            2 => [
                'question' => 'Q3 : Complète le hadith : " Un jour, pendant que nous étions assis auprès du Messager d\'Allah ﷺ ... " Et mentionne certains de ses enseignements ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9160.mp3',
                'answer' => '<p> R : D\'après \'Umar ibn Al Khaṭṭâb <span class="c2">(qu\'Allah l\'agrée)</span> : « Un jour, pendant que nous étions assis auprès du Messager d\'Allah ﷺ voici que nous apparut un homme aux habits d’une vive blancheur et aux cheveux d’une noirceur intense, sans trace visible de voyage, personne parmi nous ne le connaissait. Il vint s’asseoir en face du Prophète ﷺ, plaça ses genoux contre les siens,<span class="c6"> posa les paumes de ses mains sur ses deux cuisses et dit :</span> " Ô Mohammed ! Informe-<span class="c6">moi au sujet de l’Islam ! " Le Messager d\'Allah ﷺ lui répondit alors :</span> " L’Islam est que tu témoignes qu’il n’y a pas de divinité <span class="c5">[digne d\'adoration]</span> excepté Allah et que Mohammed est le Messager d\'Allah ; que tu accomplisses la prière ; que tu verses l’aumône légale ; que tu jeûnes durant le mois de Ramadan ; et que tu effectues le Pèlerinage à La Demeure <span class="c5">[Sacrée]</span> si tu en as la possibilité. - Tu as dit vrai ! " dit l’homme. Nous nous étonnâmes de le voir interroger le Messager d\'Allah ﷺ puis l’approuver <span class="c5">[ensuite]</span>.<span class="c6"> Il poursuivit :</span> " Informe-moi au sujet de la foi ! - C’est que tu croies en Allah, en Ses Anges, en Ses Livres, en Ses Messagers, au Jour Dernier et au Destin en bien ou en mal, répliqua le Messager d\'Allah ﷺ. -Tu as dit vrai ! répéta l’homme qui poursuivit <span class="c5">[en demandant]</span> : " Informe-moi au sujet de la bienfaisance ! -<span class="c6"> Le Prophète ﷺ répondit :</span> C’est que tu adores Allah comme si tu Le voyais. Car si tu ne Le vois pas, assurément Lui te voit ! -<span class="c6"> L’homme dit :</span> Informe-moi au sujet de l’Heure ! -<span class="c6"> Le Prophète ﷺ répondit :</span> L’interrogé n’en sait pas plus que celui qui l’interroge ! -<span class="c6"> L’homme demanda alors :</span> Quels en sont les signes précurseurs ? -<span class="c6"> Le Prophète ﷺ répondit :</span> C’est lorsque la servante engendrera sa maîtresse, et lorsque tu verras les bergers miséreux, pieds nus et mal vêtus rivaliser dans l’édification de constructions élevées. " Là-dessus, l’homme partit. Quant à moi, je restai un moment. Ensuite,<span class="c6"> le Prophète ﷺ me demanda :</span> " Ô ’Umar ! Sais-tu qui interrogeait ? -<span class="c6"> Je répondis :</span> Allah et Son Messager savent mieux ! -<span class="c6"> Le Prophète ﷺ a alors dit :</span> C’est Jibril qui est venu vous enseigner votre religion ! " Rapporté par Muslim.<span class="c6"><br /> Quelques enseignements tirés du hadith :</span><br /> 1-<span class="c6"> La mention des cinq piliers de l\'Islam qui sont :</span><br /> - L\'attestation qu’il n’y a aucune divinité <span class="c5">[digne d\'adoration]</span> excepté Allah, et que Moḥammed est le Messager d’Allah.<br /> - L\'accomplissement de la prière.<br /> -L\'acquittement de l\'aumône légale.<br /> - Le jeûne <span class="c5">[du mois]</span> de Ramadân.<br /> - Le pèlerinage à la Demeure Sacrée <span class="c2">(Al Hajj)</span>.<br /> 2-<span class="c6"> La mention des six piliers de la foi qui sont :</span><br /> - La foi en Allah.<br /> - Ses Anges.<br /> - Ses Livres.<br /> - Ses Messagers.<br /> - Au Jour Dernier.<br /> - Au Destin, en son bien et en son mal.<br /> 3- La mention du pilier de la bienfaisance qui est un seul pilier et qui consiste à adorer Allah comme si tu Le voyais car si tu ne Le vois, alors Lui te voit.<br /> 4- Le moment de la survenue de l\'Heure. Seul Allah <span class="c2">(Élevé soit-Il)</span> connait celui-ci.<span class="c6"><br /> Hadith 4 :</span> </p>',
            ],
            3 => [
                'question' => 'Q4 : Complète le hadith : " Celui parmi les croyants qui a la foi la plus complète... " Et mentionne certains de ses enseignements ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9360.mp3',
                'answer' => '<p> R : D\'après Abû Hurayra <span class="c2">(qu\'Allah l\'agrée)</span> : " Le Messager d\'Allah ﷺ a dit : <span class="c3">« Celui parmi les croyants qui a la foi la plus complète est celui qui a le meilleur comportement parmi eux. »</span> Rapporté par at Tirmidhî qui a dit : " Hadith bon-authentique.<span class="c6"> "<br /> Quelques enseignements tirés du hadith :</span><br /> 1- L\'incitation au bon comportement.<br /> 2- La perfection du comportement fait partie de la perfection de la foi.<br /> 3- La foi augmente et diminue.<span class="c6"><br /> Hadith 5 :</span> </p>',
            ],
            4 => [
                'question' => 'Q5 : Complète le hadith : " Quiconque jure par autre qu\'Allah... " Et mentionne certains de ses enseignements ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9440.mp3',
                'answer' => '<p> R : D\'après Ibn \'Umar <span class="c2">(qu\'Allah les agrée tous les deux)</span>,<span class="c6"> le Prophète ﷺ a dit :</span> " Quiconque jure par un autre qu’Allah, alors assurément il commis un acte de mécréance <span class="c2">(littéralement : il a mécru)</span> ou de polythéisme <span class="c2">(littéralement : il a associé)</span>. " Rapporté par At Tirmidhî.<span class="c6"><br /> Quelques enseignements tirés du hadith :</span><br /> 1- Il n\'est pas permis de jurer par un autre qu\'Allah <span class="c2">(Élevé soit-Il)</span>.<br /> 2- Le fait de jurer par un autre qu\'Allah <span class="c2">(Élevé soit-Il)</span> fait partie du polythéisme mineur.<span class="c6"><br /> Hadith 6 :</span> </p>',
            ],
            5 => [
                'question' => 'Q6 : Complète le hadith : " Aucun d\'entre vous ne croira [véritablement] jusqu\'à ce que je sois plus aimé que sa propre personne... " Et mentionne certains de ses enseignements ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9510.mp3',
                'answer' => '<p> R : D\'après Anas <span class="c2">(qu\'Allah l\'agrée)</span>,<span class="c6"> le Messager d\'Allah ﷺ a dit :</span> " Aucun d\'entre vous ne croira <span class="c5">[vraiment]</span> jusqu\'à ce que je sois plus aimé que sa propre personne, ses parents et tous les hommes. " Rapporté par Al Bukhârî et Muslim.<span class="c6"><br /> Quelques enseignements tirés du hadith :</span><br /> 1- L\'obligation d\'aimer le Prophète ﷺ plus que tous les hommes.<br /> 2- Cet amour pour le Prophète ﷺ fait partie de la perfection de la foi.<span class="c6"><br /> Hadith 7 :</span> </p>',
            ],
            6 => [
                'question' => 'Q7 : Complète le hadith : " Aucun d\'entre vous ne croira [vraiment] jusqu\'à ce qu\'il aime pour son frère... " Et mentionne certains de ses enseignements ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9580.mp3',
                'answer' => '<p> R : D\'après Anas <span class="c2">(qu\'Allah l\'agrée)</span> : le Messager d\'Allah ﷺ a dit : " Aucun de vous ne croira <span class="c5">[vraiment]</span> jusqu\'à ce qu\'il aime pour son frère ce qu’il aime pour lui-même. ” Rapporté par Al Bukhâri et Muslim .<span class="c6"><br /> Quelques enseignements tirés du hadith :</span><br /> 1- Le croyant doit aimer le bien pour les croyants comme il l\'aime pour lui-même.<br /> 2- Cet amour pour les croyants fait partie de la perfection de la foi.<span class="c6"><br /> Hadith 8 :</span> </p>',
            ],
            7 => [
                'question' => 'Q8 : Complète le hadith : " Par Celui qui détient mon âme dans Sa Main ! ... " Et mentionne certains de ses enseignements ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9650.mp3',
                'answer' => '<p> R : D\'après Abû Saïd <span class="c2">(qu\'Allah l\'agrée)</span>,<span class="c6"> le Messager d\'Allah ﷺ a dit :</span> " Par Celui qui détient mon âme dans Sa Main ! Certes, elle équivaut au tiers du Coran. " Rapporté par Al Bukhâri.<span class="c6"><br /> Quelques enseignements tirés du hadith :</span><br /> 1-<span class="c6"> Le mérite de la sourate :</span> La Sincérité.<br /> 2- Cette sourate équivaut au tiers du Coran.<span class="c6"><br /> Hadith 9 :</span> </p>',
            ],
            8 => [
                'question' => 'Q9 : Complète le hadith : " Il n\'y a ni force ni puissance excepté par Allah. " Et mentionne certains de ses enseignements ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9720.mp3',
                'answer' => '<p> R : D\'après Abû Mûsâ <span class="c2">(qu\'Allah l\'agrée)</span> : le Messager d\'Allah ﷺ a dit : " Il n\'y a ni force ni puissance excepté par Allah est un trésor parmi les trésors du Paradis. " Rapporté par Al Bukhâri et Muslim.<span class="c6"><br /> Quelques enseignements tirés du hadith :</span><br /> 1- Le mérite de cette parole et le fait qu\'elle est un des trésors du Paradis.<br /> 2- Le désaveu du serviteur de sa force et sa puissance et le fait de se reposer uniquement sur Allah <span class="c2">(Élevé soit-Il)</span>.<span class="c6"><br /> * Hadith 10 :</span> </p>',
            ],
            9 => [
                'question' => 'Q10 : Complète le hadith : " N\'est-ce pas que dans le corps il y a un partie... " Et mentionne certains de ses enseignements ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9790.mp3',
                'answer' => '<p> R : D\'après An-Nu\'mân ibn Bachîr <span class="c2">(qu\'Allah les agrée tous les deux)</span> : " J\'ai entendu le Messager d\'Allah ﷺ dire : " N\'est-ce pas que dans le corps, il y a une partie, si elle est bonne, alors le corps tout entier est bon ; et si elle est corrompue, alors le corps tout entier est corrompu ; n\'est-ce pas que cette partie est le<br /> cœur. " Rapporté par Al Bukhârî et Muslim.<span class="c6"><br /> Quelques enseignements tirés du hadith :</span><br /> 1- La sainteté du cœur procure le bien-être apparent et intérieur.<br /> 2- L\'importance de se soucier de l\'état de son cœur car de cela résulte le bien-être de l\'homme.<span class="c6"><br /> * Hadith 11 :</span> </p>',
            ],
            10 => [
                'question' => 'Q11 : Complète le hadith : " Quiconque dont ses dernières paroles ici-bas sont : " Il n\'y a aucune divinité [digne d\'adoration] excepté Allah... " Et mentionne certains de ses enseignements ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9860.mp3',
                'answer' => '<p> R : D\'après Mu\'âdh ibn Jabal <span class="c2">(qu\'Allah l\'agrée)</span> : " Le Messager d\'Allah ﷺ a dit : " Quiconque dont ses dernières paroles sont : " Il n\'y a aucune divinité <span class="c5">[digne d\'adoration]</span> excepté Allah " entrera au Paradis. " Rapporté par Abû Dâwud.<span class="c6"><br /> Quelques enseignements tirés du hadith :</span><br /> 1-<span class="c6"> Le mérite de :</span> " Il n\'y a aucune divinité <span class="c5">[digne d\'adoration]</span> excepté Allah " et le fait que grâce à celle-ci le serviteur entrera au Paradis.<br /> 2-<span class="c6"> Le mérite de quiconque dont les dernières paroles en ce bas monde sont :</span> " Il n\'y a aucune divinité <span class="c5">[digne d\'adoration]</span> excepté Allah.<span class="c6"> "<br /> * Hadith 12 :</span> </p>',
            ],
            11 => [
                'question' => 'Q12 : Complète le hadith : " Le croyant n\'insulte pas, ne maudit pas... " Et mentionne certains de ses enseignements ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9940.mp3',
                'answer' => '<p> R : D\'après \'Abd Allah ibn Mas\'ûd <span class="c2">(qu\'Allah l\'agrée)</span> : " Le Messager d\'Allah ﷺ a dit : " Le croyant n\'insulte pas, ne maudit pas et il n\'est ni vulgaire ni grossier. " Rapporté par at Tirmidhî.<span class="c6"><br /> Quelques enseignements tirés du hadith :</span><br /> 1- L\'interdiction de toute parole futile et vulgaire.<br /> En effet, cela est une caractéristique du croyant concernant sa langue.<span class="c6"><br /> * Hadith 13 :</span> </p>',
            ],
            12 => [
                'question' => 'Q13 : Complète le hadith : " Fait partie de la bonne application de l\'Islam, le fait que la personne... " Et mentionne certain de ses enseignements ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10020.mp3',
                'answer' => '<p> R : D\'après Abû Hurayra <span class="c2">(qu\'Allah l\'agrée)</span> : " Le Messager d\'Allah ﷺ a dit : "Fait partie de la bonne application de l\'Islam, le fait que la personne délaisse ce qui ne le regarde pas. " Rapporté par at Tirmidhî et d\'autres.<span class="c6"><br /> Quelques enseignements tirés du hadith :</span><br /> 1- Délaisser ce qui ne nous regarde pas au sujet des affaires religieuses et mondaines d\'autrui.<br /> 2- Le fait de délaisser ce qui ne nous regarde pas fait partie de la perfection de l\'application de l\'Islam.<span class="c6"><br /> * Hadith 14 :</span> </p>',
            ],
            13 => [
                'question' => 'Q14 : Complète le hadith : " Quiconque lit une lettre du Livre d\'Allah... " Et mentionne certains de ses enseignements ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10100.mp3',
                'answer' => '<p> R : D\'après \'Abd Allah ibn Mas\'ûd <span class="c2">(qu\'Allah l\'agrée)</span> : " Le Prophète ﷺ a dit : " Quiconque lit une lettre du Livre d\'Allah aura une bonne action, et la bonne action est multipliée par dix.<span class="c6"> Je ne dis pas que :</span> " Alif-Lâm-Mîm " est une lettre, mais " Alif " est une lettre, " Lâm " est une lettre, et " Mîm " est une lettre. " Rapporté par At Tirmidhî.<span class="c6"><br /> Quelques enseignements tirés du hadith :</span><br /> 1- Le mérite de la récitation du Coran.<br /> 2- Pour chaque lettre lue, la personne obtient des bonnes actions. </p>',
            ],
        ],
        6 => [
            0 => [
                'question' => 'Q1 : Quelles sont les bonnes manières avec Allah (Élevé soit-Il) ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10190.mp3',
                'answer' => '<p> R : 1- Le fait de L\'immensifier <span class="c5">[et Le considérer à Sa juste valeur]</span> <span class="c2">(Glorifié et Élevé soit-Il)</span>.<br /> 2- L\'adorer, Seul et sans associé.<br /> 3- Lui obéir.<br /> 4- Délaisser Sa désobéissance.<br /> 5- Le remercier et Le louer <span class="c2">(Exalté et Magnifié soit-Il)</span> pour Sa faveur et Ses bienfaits qu\'on ne peut recenser.<br /> 6- Patienter sur Ses décrets. </p>',
            ],
            1 => [
                'question' => 'Q2 : Quelles sont les bonnes manières avec le Messager ﷺ ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10270.mp3',
                'answer' => '<p> 1- Son suivisme et l\'application de sa Tradition.<br /> 2- Lui obéir.<br /> 3- Délaisser sa désobéissance.<br /> 4- Le déclarer véridique dans <span class="c5">[tout]</span> ce qu\'il a informé.<br /> 5- Ne pas innover en ajoutant dans sa Tradition.<br /> 6- L\'aimer plus que soi-même et plus que tous les gens.<br /> 7- Le considérer en haute estime, le secourir et faire triompher sa Tradition. </p>',
            ],
            2 => [
                'question' => 'Q3 : Quelles sont les bonnes manières avec les parents ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10360.mp3',
                'answer' => '<p> R : 1- Leur obéir sans désobéir au Créateur.<br /> 2- Les servir.<br /> 3- Les aider.<br /> 4- Répondre à leurs besoins.<br /> 5- Invoquer en leur faveur.<br /> 6- Être respectueux envers eux dans la manière de parler,<span class="c6"> notamment il n\'est par permis de leur dire :</span> " Pfff " qui est la moindre des paroles.<br /> 7- Leur sourire en les voyant et ne pas être renfrogné.<br /> 8- Ne pas élever la voix au-dessus de la leur, les écouter, ne pas leur couper la parole ni les interrompre <span class="c5">[lorsqu\'ils parlent]</span>,<span class="c6"> ne pas les appeler ni les interpeller par leurs prénoms mais plutôt dire :</span> " Mon père / Mon cher père " ; " Ma mère / Ma chère mère " ;<br /> 9- Leur demander la permission avant d\'entrer auprès d\'eux lorsqu\'ils sont dans leur chambre.<br /> 10- Embrasser leur main et leur tête. </p>',
            ],
            3 => [
                'question' => 'Q4 : Comment maintiens-je le lien de parenté ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10490.mp3',
                'answer' => '<p> 1-<span class="c6"> Visiter les proches :</span> frère, sœur, oncle paternel et tante paternelle, oncle maternel et tante maternelle et le reste des proches <span class="c2">(grands-mères et grands-pères)</span>, etc.<br /> 2- Être bienfaisant envers eux en paroles et en actes et les aider.<br /> 3- Les appeler, les contacter afin de s\'enquérir d\'eux et de leurs situations. </p>',
            ],
            4 => [
                'question' => 'Q5 : Comment dois-je me comporter avec mes frères et mes amis ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10550.mp3',
                'answer' => '<p> 1- J\'aime les plus nobles et je leur tiens compagnie.<br /> 2- J\'évite et je délaisse la compagnie des plus vils.<br /> 3- Je salue mes frères et je leur serre la main.<br /> 4- Je les visite lorsqu\'ils sont malades et j\'invoque la guérison d\'Allah en leur faveur.<br /> 5- J\'implore la miséricorde d\'Allah en faveur de celui qui éternue <span class="c5">[en ma présence]</span>.<br /> 6- Je réponds à l\'invitation de mon frère lorsqu\'il m\'invite à le visiter.<br /> 7- Je prodigue le conseil à mon frère.<br /> 8- Je le secoure lorsqu\'il est opprimé et je l\'empêche de commettre une injustice.<br /> 9- J\'aime pour mon frère musulman ce que j\'aime pour moi-même.<br /> 10- J\'aide mon frère s\'il a besoin de moi.<br /> 11- Je ne lui nuis pas ni dans mes paroles ni dans mes actes.<br /> 12- Je garde ses secrets.<br /> 13- Je n\'insulte pas mon frère, je ne médis pas sur lui, je ne le méprise pas, je ne l\'envie pas, je ne l\'espionne pas et je ne le trompe pas. </p>',
            ],
            5 => [
                'question' => 'Q6 : Quelles sont les bonnes manières du voisinage ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10710.mp3',
                'answer' => '<p> 1- Je suis bienfaisant envers mon voisin, tant en paroles qu\'en actes, et je l\'aide s\'il a besoin de moi.<br /> 2- Je le félicite lors des fêtes, d\'un mariage ou autre.<br /> 3- Je le visite lorsqu\'il est malade et je lui présente mes condoléances lorsqu\'il est touché par un malheur.<br /> 4- Je lui présente et propose ce que j\'ai préparé comme repas, autant que possible.<br /> 5- Je ne lui cause aucun tort, ni en paroles ni en actes.<br /> 6- Je ne le dérange pas en élevant la voix ou en l\'espionnant, mais plutôt je patiente à son sujet. </p>',
            ],
            6 => [
                'question' => 'Q7 : Quelles sont les bonnes manières relatives à l\'invitation et la réception ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10800.mp3',
                'answer' => '<p> R : 1- Je réponds à celui qui m\'invite chez lui.<br /> 2- Si je souhaite visiter quelqu\'un, je lui demande la permission et je fixe un rendez-vous.<br /> 3- Je demande la permission avant d\'entrer.<br /> 4- Je ne suis pas en retard lors de la visite.<br /> 5- Je baisse le regard vis-à-vis des personnes se trouvant dans la demeure.<br /> 6- Je souhaite la bienvenue à l\'invité et je l\'accueille du plus bel accueil avec un visage souriant et les plus belles formules de bienvenue.<br /> 7- J\'assois l\'invité au meilleur endroit.<br /> 8- Je l\'honore en lui présentant des mets et des boissons. </p>',
            ],
            7 => [
                'question' => 'Q8 : Mentionne les bonnes manières relatives à la maladie et à la visite du malade ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10900.mp3',
                'answer' => '<p> R : 1- Lorsque je ressens une douleur,<span class="c6"> je mets ma main droite sur l\'endroit douloureux et je dis trois fois :</span> " Au nom d\'Allah ! " Puis,<span class="c6"> je dis sept fois :</span> " Je me réfugie auprès de la puissance d\'Allah et Son omnipotence contre le mal que j\'éprouve et que je crains. "<br /> 2- J\'accepte ce qu\'Allah a décrété et je patiente.<br /> 3- Je m\'empresse de visiter mon frère malade, j\'invoque en sa faveur et je ne prolonge pas ma visite auprès de lui.<br /> 4- Je lui fais une Ruqiya sans qu\'il ne me le demande.<br /> 5- Je lui recommande la patience, l\'invocation, la prière et la purification selon ce qui lui est possible.<br /> 6-<span class="c6"> L\'invocation en faveur du malade :</span> " Je demande à Allah, le Majestueux, le Seigneur du Trône immense qu\'Il te guérisse. " Sept fois. </p>',
            ],
            8 => [
                'question' => 'Q9 : Mentionne les bonnes manières relatives à la recherche de la science.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10990.mp3',
                'answer' => '<p> R : 1- Avoir une intention sincère pour Allah <span class="c2">(Exalté et Magnifié soit-Il)</span>.<br /> 2- Œuvrer avec les connaissances que l\'on a appris.<br /> 3- Respecter et honorer l\'enseignant en sa présence et en son absence.<br /> 4- S\'assoir devant lui avec respect.<br /> 5- Se taire en sa présence et ne pas l\'interrompre durant son cours.<br /> 6- Faire preuve d\'éducation dans la manière de poser des questions.<br /> 7- Ne pas l\'appeler par son nom. </p>',
            ],
            9 => [
                'question' => 'Q10 : Quelles sont les bonnes manières lors de l\'assise ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11090.mp3',
                'answer' => '<p> R : 1- Saluer les personnes de l\'assise.<br /> 2- S\'assoir là où se termine l\'assise de sorte que je ne fais pas lever quelqu\'un de sa place ou je m\'assois entre deux personnes, à moins d\'avoir eu la permission de leur part.<br /> 3- Faire de la place dans l\'assise afin que d\'autres puissent s\'assoir.<br /> 4- Ne pas interrompre la discussion qu\'il y a dans l\'assise.<br /> 5- Demander la permission et saluer avant de quitter l\'assise.<br /> 6- Au moment où s\'achève l\'assise,<span class="c6"> faire l\'invocation de l\'expiation de l\'assise :</span> " Gloire à Toi, ô Allah, et par Ta louange. J\'atteste qu\'il n\'y a aucune divinité <span class="c5">[digne d\'adoration]</span> excepté Allah, j\'implore Ton pardon et je me repens à Toi. " </p>',
            ],
            10 => [
                'question' => 'Q11 : Mentionne les bonnes manières relatives au sommeil.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11180.mp3',
                'answer' => '<p> R : 1- Je dors tôt.<br /> 2- Je dors en état de pureté.<br /> 3- Je ne dors pas sur le ventre.<br /> 4- Je dors sur le côté droit et je mets ma main droite sous ma joue droite.<br /> 5- J\'époussète mon lit.<br /> 6- Je récite les invocations du sommeil,<span class="c6"> notamment :</span> le Verset du Trône, une fois,<span class="c6"> ainsi que les sourates :</span> La Sincérité et les Deux Protectrices, trois fois. Puis,<span class="c6"> je dis :</span> " En Ton nom, ô Allah, je meurs et je vis. "<br /> 7- Je me lève pour la prière de l\'aube <span class="c2">(Al Fajr)</span>.<br /> 8- Après m\'être réveillé de mon sommeil,<span class="c6"> je dis :</span> " Louange à Allah, Celui qui nous a fait revivre après nous avoir fait mourir et vers Lui est le retour. " </p>',
            ],
            11 => [
                'question' => 'Quelles sont les bonnes manières relatives à la nourriture ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11290.mp3',
                'answer' => '<p> R :<br /> 1- Avoir l\'intention, à travers ce que je mange et bois, de me renforcer pour accomplir les actes d\'obéissance à Allah <span class="c2">(Exalté et Magnifié soit-Il)</span>.<br /> 2- Se laver les mains avant de manger.<br /> 3-<span class="c6"> Dire :</span> " Au nom d\'Allah. " Manger de la main droite et <span class="c5">[manger]</span> devant soi. Ne pas manger au milieu du plat ou ce qui est devant quelqu\'un d\'autre.<br /> 4-<span class="c6"> En cas d\'oubli de l\'appellation :</span> " Au nom d\'Allah. ",<span class="c6"> dire alors :</span> " Au nom d\'Allah à son début et à sa fin. "<br /> 5- Être satisfait de ce qu\'il y a comme nourriture et ne pas critiquer la nourriture. Si cela me plaît, alors j\'en mange ; et si cela ne me plaît pas, alors je la délaisse.<br /> 6- Manger par bouchées et ne pas manger goulûment.<br /> 7- Ne pas souffler sur la nourriture ou sur la boisson mais attendre que cela refroidisse.<br /> 8- Se réunir avec d\'autres autour du repas, notamment les membres de la famille ou des invités.<br /> 9- Ne pas commencer à manger avant quelqu\'un qui est plus âgé que nous.<br /> 10- Prononcer le nom d\'Allah au moment de boire. Ne pas boire debout mais assis. Et boire en trois fois.<br /> 11- Louer Allah après avoir fini de manger et boire. </p>',
            ],
            12 => [
                'question' => 'Q13 : Énumère les bonnes manières relatives à l\'habillement.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11440.mp3',
                'answer' => '<p> R : 1- Je mets mon habit en commençant par le côté droit et je loue Allah pour cela.<br /> 2- Je ne fais pas tomber mon habit en-dessous des chevilles.<br /> 3- Les garçons ne portent pas d\'habits de filles et les filles ne portent pas d\'habits de garçons.<br /> 4- Les habits ne doivent pas ressembler aux habits des mécréants ou des pervers.<br /> 5- Prononcer le nom d\'Allah au moment d\'enlever ses habits.<br /> 6- Se chausser en commençant par le pied droit et se déchausser en commençant par le pied gauche. </p>',
            ],
            13 => [
                'question' => 'Q14 : Mentionne les bonnes manières relatives aux moyens de transport.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11540.mp3',
                'answer' => '<p> R : 1-<span class="c6"> Je dis :</span> " Au nom d\'Allah. Louange à Allah. " {"Gloire à Celui qui nous a soumis cela alors que nous n\'étions pas capables de les dominer. <span class="c2">(13)</span> Et c\'est vers notre Seigneur que nous retournons. " <span class="c2">(14)</span> } <span class="c5">[Sourate : L\'Ornement,<span class="c6"> 43 :</span> 13-14]</span>.<br /> 2- Si je rencontre un musulman, alors je le salue. </p>',
            ],
            14 => [
                'question' => 'Q15 : Mentionne les bonnes manières lors de la marche.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11590.mp3',
                'answer' => '<p> R : 1- Je marche droit, je suis humble dans ma démarche et je marche du côté droit du chemin.<br /> 2- Je salue quiconque je rencontre.<br /> 3- Je baisse le regard et je ne fais du tort à personne.<br /> 4- J\'ordonne le convenable et j\'interdis le blâmable.<br /> 5- J\'ôte la nuisance du chemin. </p>',
            ],
            15 => [
                'question' => 'Q16 : Mentionne les bonnes manières lors de l\'entrée de la demeure et la sortie ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11670.mp3',
                'answer' => '<p> R : 1-<span class="c6"> Je sors du pied gauche et je dis :</span> <span class="c3">« Au nom d’Allah ! Je place ma confiance à Allah. Il n’y a ni force ni puissance excepté par Allah. Ô Allah ! Je me réfugie auprès de Toi afin que je n’égare personne ou que je m\'égare, que je fasse un faux pas ou qu’on m\'en fasse faire un, que je sois injuste ou que je subisse une injustice, que je fasse preuve d\'ignorance ou que j\'en subisse une. »</span> 2-<span class="c6"> J\'entre du pied droit et je dis :</span> <span class="c3">« Au nom d\'Allah nous entrons et au nom d\'Allah nous sortons et en Allah nous plaçons notre confiance. »</span><br /> 3- Je commence par me frotter les dents avec le siwâk et ensuite je salue les gens de ma famille. </p>',
            ],
            16 => [
                'question' => 'Q17 : Mentionne les bonnes manières lors des besoins aux toilettes.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11730.mp3',
                'answer' => '<p> R : 1- J\'entre du pied gauche.<br /> 2- Avant d\'entrer,<span class="c6"> je dis :</span> <span class="c3">« Au nom d’Allah ! Ô Allah ! Je me réfugie auprès de Toi contre les démons mâles et femelles. »</span><br /> 3- Je ne fais rien rentrer qui contient le nom d\'Allah.<br /> 4- Je me cache au moment d\'accomplir mes besoins.<br /> 5- Je ne parle pas dans le lieu où j\'accomplis mes besoins.<br /> 6- Je me dirige pas en direction de la Qibla ni je ne lui tourne le dos au moment d\'uriner ou de déféquer.<br /> 7- J\'utilise ma main gauche pour enlever la souillure et je n\'utilise pas la main droite.<br /> 8- Je n\'accomplis pas mes besoins sur les lieux de passage et ni dans les zones d\'ombrage pour les gens.<br /> 9- Je me lave les mains après avoir accompli mes besoins.<br /> 10-<span class="c6"> Je sors d\'abord du pied droit et je dis :</span> " <span class="c5">[Je te demande]</span> Ton pardon. " </p>',
            ],
            17 => [
                'question' => 'Q18 : Mentionne les bonnes manières à avoir à la mosquée.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11860.mp3',
                'answer' => '<p> 1-<span class="c6"> J\'entre à la mosquée du pied droit et je dis :</span> " Au nom d\'Allah ! Ô Allah ! Ouvre-moi les portes de Ta miséricorde. "<br /> 2- Je ne m\'assois pas tant que je n\'ai pas effectué deux unités de prière.<br /> 3- Dans la mosquée, je ne passe pas devant les fidèles qui prient, je ne fais pas d\'annonce de recherche d\'une chose perdue et je ne vends pas ni n\'achète à la mosquée.<br /> 4-<span class="c6"> Je sors de la mosquée du pied gauche et je dis :</span> " Ô Allah ! Certes, je Te demande de Ta grâce. " </p>',
            ],
            18 => [
                'question' => 'Q19 : Mentionne les bonnes manières relatives à la salutation.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11930.mp3',
                'answer' => '<p> R : 1- Lorsque je rencontre un musulman,<span class="c6"> je commence par le saluer en disant :</span> " Paix sur vous ainsi que la miséricorde d\'Allah et Sa bénédiction. "<br /> 2- J\'accueille avec un visage souriant celui que je salue.<br /> 3- Je lui serre la main de ma main droite.<br /> 4- Si quelqu\'un me salue en premier, alors je réponds à son salut d\'un salut meilleur ou équivalent au sien.<br /> 5- Je ne commence pas à saluer en premier le mécréant mais s\'il me salue alors je lui réponds de la même manière.<br /> 6- Le jeune salue la personne âgée ; la personne sur une monture salue celle à pied ; la personne à pied salue celle qui est assise ; ceux qui sont peu saluent ceux qui sont plus nombreux. </p>',
            ],
            19 => [
                'question' => 'Q20 : Mentionne les bonnes manières relatives à la demande de permission.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12020.mp3',
                'answer' => '<p> R : 1- Je demande la permission avant d\'entrer dans un lieu.<br /> 2- Je demande trois fois la permission, pas plus, et après cela je m\'en vais.<br /> 3- Je frappe doucement à la porte et je ne me tiens pas devant, mais plutôt sur le côté droit ou gauche de celle-ci.<br /> 4- Je n\'entre pas dans la chambre de mon père, de ma mère ou qui que ce soit d\'autre sans demander la permission ; et plus particulièrement avant l\'aube <span class="c2">(Al Fajr)</span>, au moment de la sieste du midi <span class="c2">(Adh Dhuhr)</span>, et après la prière du soir <span class="c2">(Al \'Ichâ\')</span>.<br /> 5- Il m\'est possible d\'entrer dans des lieux qui ne sont pas habités,<span class="c6"> comme :</span> un hôpital, un magasin, etc. sans demander la permission. </p>',
            ],
            20 => [
                'question' => 'Q21 : Mentionne les bonnes manières envers les animaux.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12100.mp3',
                'answer' => '<p> R : Je nourris les animaux et je les abreuve.<br /> 2- Je suis miséricordieux et je fais preuve de compassion envers les animaux et je ne les charge pas plus qu\'ils ne peuvent supporter.<br /> 3- Je ne châtie pas et je ne torture pas les animaux, et ce de n\'importe quelle manière contenant une nuisance ou une torture pour eux. </p>',
            ],
            21 => [
                'question' => 'Q22 : Mentionne les bonnes manières dans le sport.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12160.mp3',
                'answer' => '<p> R : 1- Mon intention à travers le sport est d\'être plus fort dans l\'obéissance d\'Allah et Sa satisfaction.<br /> 2- Nous ne jouons pas au moment de la prière.<br /> 3- Les garçons ne font pas de sport avec les filles.<br /> 4- Je m\'efforce de porter une tenue sportive qui cache ma nudité.<br /> 5- J\'évite les sports interdits, notamment ceux contenant des frappes au visage ou ceux où l\'on doit dévoiler sa nudité. </p>',
            ],
            22 => [
                'question' => 'Q23 : Mentionne les bonnes manières dans la plaisanterie.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12240.mp3',
                'answer' => '<p> R : 1- Être véridique dans la plaisanterie et ne pas mentir.<br /> 2- Plaisanter sans moquerie ni raillerie, et sans nuisance et ni en effrayant les autres.<br /> 3- Ne pas trop plaisanter . </p>',
            ],
            23 => [
                'question' => 'Q24 : Mentionne les bonnes manières relatives à l\'éternuement.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12300.mp3',
                'answer' => '<p> R : 1- Mettre la main, un habit ou un mouchoir <span class="c5">[devant sa bouche et son nez]</span> au moment d\'éternuer.<br /> 2-<span class="c6"> Louer Allah après avoir éternué en disant :</span> " Louange à Allah. "<br /> 3-<span class="c6"> Et son frère ou la personne présente lui répond alors :</span> " Qu\'Allah te fasse miséricorde.<span class="c6"> "<br /> La personne ayant éternué répond alors :</span> " Qu\'Allah vous guide et améliore votre situation. " </p>',
            ],
            24 => [
                'question' => 'Q25 : Quelles sont les bonnes manières relatives au bâillement.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12360.mp3',
                'answer' => '<p> 1- S\'efforcer de contenir son bâillement.<br /> 2-<span class="c6"> Ne pas élever la voix en disant :</span> " Ah...Ah... "<br /> 3- Mettre la main devant la bouche. </p>',
            ],
            25 => [
                'question' => 'Q26 : Mentionne les bonnes manières dans la récitation du noble Coran.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12420.mp3',
                'answer' => '<p> R : 1- Réciter en état de purification après avoir effectué l\'ablution mineure.<br /> 2- S\'assoir avec politesse et humilité.<br /> 3- Chercher refuge auprès d\'Allah contre Satan au début de la récitation.<br /> 4- Je médite à propos de ce que je lis. </p>',
            ],
        ],
        7 => [
            0 => [
                'question' => 'Q1 : Mentionne le mérite du bon comportement.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12500.mp3',
                'answer' => '<p> Le Prophète ﷺ a dit : <span class="c3">« Celui parmi les croyants qui a la foi la plus complète est celui qui a le meilleur comportement parmi eux. »</span> Rapporté par At Tirmidhî et Ahmed. </p>',
            ],
            1 => [
                'question' => 'Q2 : Pourquoi nous attachons-nous aux comportements islamiques ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12530.mp3',
                'answer' => '<p> R : 1- Ils sont une cause de l\'amour d\'Allah <span class="c2">(Élevé soit-Il)</span>.<br /> 2- Ils sont une cause de l\'amour des créatures.<br /> 3- Ils sont la chose la plus lourde dans la Balance.<br /> 4- Le bon comportement multiplie la récompense et la rétribution.<br /> 5- Ils sont un signe de la perfection de la foi. </p>',
            ],
            2 => [
                'question' => 'Q3 : D\'où prenons-nous les comportements ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12600.mp3',
                'answer' => '<p> R : <span class="c5">[Nous les prenons]</span> Du noble Coran. Allah <span class="c2">(Élevé soit-Il)</span> dit : <span class="c4">{Certes, ce Coran guide vers ce qu\'il y a de plus droit.}</span> <span class="c5">[Sourate : Le Voyage Nocturne,<span class="c6"> 17 :</span> 9]</span>.<span class="c6"> Et dans la Tradition Prophétique :</span> Le Messager d\'Allah ﷺ a dit : " Je n’ai été envoyé que pour parfaire les nobles caractères. " Rapporté par Ahmed. </p>',
            ],
            3 => [
                'question' => 'Q4 : Qu\'est-ce que la bienfaisance ? Et quelles sont ses formes ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12640.mp3',
                'answer' => '<p> R : La bienfaisance désigne l\'observance d\'Allah en continu et le déploiement de tout bien et toute bienfaisance en faveur des créatures.<span class="c6"><br /> Le Prophète ﷺ a dit :</span> " Certes, Allah a prescrit la bienfaisance pour toute chose. " Rapporté par Muslim.<span class="c6"><br /> Et parmi les formes de la bienfaisance :</span><br /> . La bienfaisance dans l\'adoration d\'Allah <span class="c2">(Élevé soit-Il)</span>, cela à travers la sincérité dans Son adoration.<br /> . La bienfaisance envers les parents aussi bien dans les paroles que dans les actes.<br /> . La bienfaisance envers les personnes de la famille et les proches parents.<br /> . La bienfaisance envers le voisin.<br /> . La bienfaisance envers les orphelins et les pauvres.<br /> . La bienfaisance envers quiconque agit mal avec toi.<br /> . La bienfaisance dans les paroles.<br /> . La bienfaisance dans la discussion.<br /> . La bienfaisance envers les animaux. </p>',
            ],
            4 => [
                'question' => 'Q5 : Quel est le contraire de la bienfaisance ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12780.mp3',
                'answer' => '<p> R : Le contraire de la bienfaisance est la malfaisance.<br /> * Et parmi cela,<span class="c6"> il y a :</span> Le délaissement de la sincérité dans l\'adoration à Allah <span class="c2">(Élevé soit-Il)</span>.<br /> * La désobéissance aux parents.<br /> * La rupture des liens de parenté.<br /> * Le mauvais voisinage.<br /> * Le délaissement de la bienfaisance envers les indigents et les pauvres ainsi que les mauvaises paroles et les viles œuvres. </p>',
            ],
            5 => [
                'question' => 'Q6 : Quels sont les types de dépôts ? Et leurs formes ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12860.mp3',
                'answer' => '<p> R :<br /> 1- La loyauté dans la préservation des droits d\'Allah <span class="c2">(Élevé soit-Il)</span>.<span class="c6"><br /> Ses formes :</span> La loyauté dans l\'acquittement des adorations,<span class="c6"> comme :</span> la prière, l\'aumône légale, le jeûne, le pèlerinage, etc. parmi ce qu\'Allah nous a imposés.<br /> 2-<span class="c6"> La loyauté dans la préservation des droits des créatures :</span><br /> . L\'honneur des gens.<br /> . Leurs biens.<br /> . Leur sang.<br /> . Leurs secrets et l\'ensemble de ce que les gens nous ont confiés.<br /> En mentionnant les caractéristiques de ceux qui réussissent, Allah <span class="c2">(Élevé soit-Il)</span> a dit : {Et ceux qui gardent les dépôts qu\'on leur confiés et honorent leurs engagements <span class="c2">(8)</span> } <span class="c5">[Sourate : Les Croyants,<span class="c6"> 21 :</span> 8]</span>. </p>',
            ],
            6 => [
                'question' => 'Q7 : Quel est le contraire de la loyauté
   ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12980.mp3',
                'answer' => '<p> R : La trahison. C\'est le délaissement des droits d\'Allah <span class="c2">(Élevé soit-Il)</span> et des droits des gens.<span class="c6"><br /> Le Prophète ﷺ a dit :</span> " L\'hypocrite possède trois signes - et parmi eux il mentionna -<span class="c6"> :</span> Lorsqu\'on lui confie une chose en dépôt, il trahit. " Unanimement Reconnu Authentique <span class="c5">[Rapporté par Al Bukhâri et Muslim]</span>. </p>',
            ],
            7 => [
                'question' => 'Q8 : Qu\'est-ce que la véracité ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13020.mp3',
                'answer' => '<p> R : C\'est le fait que mes propos soit conforme à la réalité.<br /> Et parmi ses formes,<span class="c6"> il y a :</span><br /> - Être véridique dans ses propos avec les gens.<br /> - Être véridique dans sa promesse.<br /> - Être véridique dans toutes ses paroles et œuvres.<span class="c6"><br /> Le Prophète ﷺ a dit :</span> " Certes, la véracité guide vers la bonté et la bonté guide vers le Paradis ; et la personne ne cesse d\'être véridique jusqu\'à ce qu\'il soit une personne véridique. " Unanimement Reconnu Authentique <span class="c5">[Al Bukhârî et Muslim]</span>. </p>',
            ],
            8 => [
                'question' => 'Q9 : Quel est le contraire de la véracité ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13100.mp3',
                'answer' => '<p> R : Le mensonge. C\'est ce qui est différent de la réalité,<span class="c6"> et parmi cela il y a :</span> le fait de mentir aux gens ; ne pas tenir ses promesses ; proférer de faux témoignages ; etc.<span class="c6"><br /> Le Prophète ﷺ a dit :</span> " Et certes, le mensonge guide vers l\'immoralité et l\'immoralité guide vers l\'Enfer ; et la personne ne cesse de mentir jusqu\'à ce qu\'on l\'écrive, auprès d\'Allah comme un grand menteur. " Unanimement Reconnu Authentique <span class="c5">[Al Bukhârî et Muslim]</span>.<span class="c6"> Le Prophète ﷺ a aussi dit :</span> " L\'hypocrite possède trois signes - et parmi eux il mentionna -<span class="c6"> :</span> Lorsqu\'il parle, il ment ; et lorsqu\'il promet, il rompt sa promesse. " Unanimement Reconnu Authentique <span class="c5">[Al Bukhârî et Muslim]</span>. </p>',
            ],
            9 => [
                'question' => 'Q10 : Mentionne les types de patience.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13140.mp3',
                'answer' => '<p> R : 1- La patience dans l\'obéissance à Allah <span class="c2">(Élevé soit-Il)</span>.<br /> 2- La patience afin de ne pas désobéir <span class="c5">[à Allah]</span>.<br /> 3- La patience sur les décrets douloureux et le fait de louer Allah en toute circonstance.<br /> Il <span class="c2">(Élevé soit-Il)</span> a dit : {Et Allah aime les patients. <span class="c2">(146)</span> } <span class="c5">[Sourate : La Famille d\'Imrân,<span class="c6"> 3 :</span> 146]</span>.<span class="c6"> Le Prophète ﷺ a dit :</span> " L\'affaire du croyant est étonnante ! En effet, toute son affaire est un bien mais cela n\'est pour personne excepté le croyant. Si une aisance le touche, alors il est reconnaissant et ceci lui est alors un bien ; et si une adversité l\'atteint, alors il est patient et ceci lui est alors un bien. " Rapporté par Muslim. </p>',
            ],
            10 => [
                'question' => 'Q11 : Quel est le contraire de la patience ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13210.mp3',
                'answer' => '<p> R : - C\'est le fait de ne pas patienter face l\'obéissance et la désobéissance mais aussi se courroucer contre les décrets <span class="c5">[divins]</span> à travers les paroles ou les actes.<span class="c6"><br /> Parmi ses formes :</span><br /> - Souhaiter la mort.<br /> - Se frapper les joues.<br /> - Déchirer ses vêtements.<br /> - Étaler ses émotions.<br /> - Invoquer la destruction sur soi.<span class="c6"><br /> Le Prophète ﷺ a dit :</span> " La rétribution est proportionnelle à l’immensité de l’épreuve. Et lorsqu’Allah aime des gens, Il les éprouve. Ainsi donc, quiconque est satisfait <span class="c5">[du décret d’Allah]</span> aura la satisfaction <span class="c5">[d’Allah]</span> et quiconque en est courroucé subira le courroux <span class="c5">[d’Allah]</span>. " Rapporté par At Tirmidhî et Ibn Mâja. </p>',
            ],
            11 => [
                'question' => 'Q12 : Qu\'est-ce que la solidarité et l\'entraide ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13310.mp3',
                'answer' => '<p> -<span class="c6"> R :</span> C\'est le fait de s\'entraider avec les gens dans la vérité et le bien.<span class="c6"><br /> Les formes d\'entraide :</span><br /> - L\'entraide dans le fait de s\'acquitter des droits.<br /> - L\'entraide dans le fait de répondre à l\'oppresseur.<br /> - L\'entraide dans le fait de combler les besoins des gens et des pauvres.<br /> - L\'entraide dans tout bien.<br /> - Le fait de ne pas s\'entraider dans le péché, le tort et la transgression.<br /> Il <span class="c2">(Élevé soit-Il)</span> a dit : {Et entraidez-vous dans la bonté et la piété et ne vous entraidez pas dans le péché et la transgression. <span class="c2">(2)</span> } <span class="c5">[Sourate : La Table Servie,<span class="c6"> 5 :</span> 2]</span>.<span class="c6"> Le Prophète ﷺ a dit :</span> " Le croyant est pour le croyant telle une construction qui se soutient l\'un l\'autre. " Unanimement reconnu authentique <span class="c5">[Al Bukhâri et Muslim]</span>.<span class="c6"> Le Prophète ﷺ a dit :</span> " Le musulman est le frère du musulman. Il ne lui fait pas d\'injustice et ne le trahit point. Quiconque comble le besoin de son frère, Allah comblera son besoin. Quiconque dissipe une affliction à un musulman, Allah lui dissipera une affliction parmi celles du Jour de la Résurrection. Et quiconque couvre un musulman, Allah le couvrira au Jour de la Résurrection. " Unanimement Reconnu Authentique <span class="c5">[Al Bukhâri et Muslim]</span>. </p>',
            ],
            12 => [
                'question' => 'Q13 : Quelles sont les différentes formes de pudeur ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13420.mp3',
                'answer' => '<p> R : 1- La pudeur vis-à-vis d\'Allah <span class="c2">(Glorifié soit-Il)</span> en ne Lui désobéissant pas.<br /> 2- La pudeur vis-à-vis des gens, notamment en ne proférant pas de paroles grossières et vulgaires ni en dévoilant ce qui est intime.<span class="c6"><br /> Le Messager d\'Allah ﷺ a dit :</span> <span class="c3">« La foi comporte quelque soixante-dix - ou soixante - branches. La plus haute d’entre elle est l’attestation qu’il n’y a aucune divinité <span class="c5">[digne d’adoration]</span> excepté Allah et la moindre d\'entre elle consiste à ôter ce qui est nuisible du chemin. Et la pudeur est une branche de la foi. »</span> Rapporté par Muslim. </p>',
            ],
            13 => [
                'question' => 'Q14 : Mentionne des formes du caractère de la miséricorde.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13470.mp3',
                'answer' => '<p> R : - La miséricorde envers les personnes âgées et leur respect.<br /> - La miséricorde envers les petits et les enfants.<br /> - La miséricorde envers le pauvre, l\'indigent et le besogneux.<br /> - La miséricorde envers les animaux en les nourrissant et en ne leur nuisant pas.<br /> Et parmi cela,<span class="c6"> il y a la parole du Prophète ﷺ :</span> " Dans leur miséricorde mutuelle,<span class="c6"> leur affection et leur sentiment les croyants sont comme le corps :</span> lorsqu\'un membre se plaint, alors le reste du corps réponds par l\'insomnie et la fièvre. " Unanimement Reconnu Authentique <span class="c5">[Al Bukhâri et Muslim]</span>.<span class="c6"> Le Messager d\'Allah ﷺ a dit :</span> " Le Tout Miséricordieux fait miséricorde aux miséricordieux. Faites miséricorde aux habitants de la Terre, et Celui qui est dans les cieux vous fera miséricorde. " Rapporté par Abû Dawûd et At Tirmidhî. </p>',
            ],
            14 => [
                'question' => 'Q15 : Quels sont les types d\'amour ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13550.mp3',
                'answer' => '<p> R : L\'amour d\'Allah <span class="c2">(Élevé soit-Il)</span>.<br /> Il <span class="c2">(Élevé soit-Il)</span> a dit : <span class="c4">{Et ceux qui ont cru sont plus forts dans l\'amour d\'Allah.}</span> <span class="c5">[Sourate : La Vache,<span class="c6"> 2 :</span> 165]</span>.<br /> 2- L\'amour du Messager ﷺ.<span class="c6"><br /> Il a dit :</span> " Par Celui qui détient mon âme dans Sa Main ! Aucun d\'entre vous ne croira vraiment tant qu\'il ne m\'aimera pas plus que sa propre personne, ses parents et ses enfants. " Rapporté par Al Bukhârî.<br /> Aimer les croyants et aimer le bien pour eux, comme tu l\'aimerais pour toi-même.<span class="c6"><br /> Le Prophète ﷺ a dit :</span> " Aucun de vous ne croira vraiment jusqu\'à ce qu\'il aime pour son frère ce qu\'il aime pour lui-même. " Rapporté par Al Bukhârî. </p>',
            ],
            15 => [
                'question' => 'Q16 : Définis la gaieté.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13630.mp3',
                'answer' => '<p> R : C\'est le fait d\'avoir le visage radieux en étant joyeux, souriant, doux et le fait de manifester sa joie lorsque l\'on rencontre les gens.<br /> C\'est le contraire de se montrer renfrogné lorsqu\'on voit les gens et qui provoque leur fuite.<br /> Et des hadith ont été rapportés concernant le mérite de cela, notamment d\'après Abû Dharr <span class="c2">(qu\'Allah l\'agrée)</span> qui a dit : " Le Prophète ﷺ m\'a dit : " Ne méprise rien du convenable, ne serait-ce que tu rencontres ton frère avec un visage gai. " Rapporté par Muslim.<span class="c6"> Le Messager d\'Allah ﷺ a dit :</span> " Sourire à ton frère est une aumône en ta faveur. " Rapporté par At Tirmidhî. </p>',
            ],
            16 => [
                'question' => 'Q17 : Qu\'est-ce que la jalousie ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13690.mp3',
                'answer' => '<p> R : C\'est de souhaiter la disparition du bienfait des autres ou d\'avoir en aversion le bienfait que les autres ont.<br /> Il <span class="c2">(Élevé soit-Il)</span> a dit : {Et contre le mal de l\'envieux lorsqu\'il envie <span class="c2">(5)</span> } <span class="c5">[Sourate : L\'Aube Naissante,<span class="c6"> 113 :</span> 5]</span>.<br /> Et d\'après Anas ibn Mâlik <span class="c2">(qu\'Allah l\'agrée)</span> : " Le Messager d\'Allah ﷺ a dit : " Ne vous détestez pas, ne vous enviez pas et ne vous tournez pas le dos ; soyez plutôt des serviteurs d\'Allah, des frères. " Rapporté par Al Bukhârî et Muslim. </p>',
            ],
            17 => [
                'question' => 'Q18 : Qu\'est-ce que la moquerie ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13740.mp3',
                'answer' => '<p> R : C\'est le fait de se moquer de ton frère musulman et de le mépriser. Et ceci n\'est pas permis.<br /> Concernant l\'interdiction de cela, Allah <span class="c2">(Élevé soit-Il)</span> a dit : {Ô vous qui avez cru ! Que des ne prennent pas en raillerie d\'autres hommes : il se peut que ceux-ci soient meilleurs qu\'eux.<span class="c6"> Et que des femmes ne prennent pas en raillerie d\'autres femmes :</span> il se peut que celles-ci soient meilleures qu\'elles. Ne vous dénigrez pas et ne vous donnez pas mutuellement des sobriquets. Quel vilain mot que " perversion " après <span class="c5">[avoir eu]</span> la foi . Et quiconque ne se repent pas, alors ceux-là sont les injustes. <span class="c2">(11)</span> } <span class="c5">[Sourate : Les Appartements,<span class="c6"> 49 :</span> 11]</span>. </p>',
            ],
            18 => [
                'question' => 'Q19 : Définis l\'humilité.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13780.mp3',
                'answer' => '<p> R : C\'est le fait de ne pas se considérer au-dessus des autres, de sorte de ne pas les mépriser ou de rejeter la vérité.<br /> Il <span class="c2">(Élevé soit-Il)</span> a dit : <span class="c4">{Et les serviteurs du Tout Miséricordieux sont ceux qui marchent humblement sur la Terre ;}</span> <span class="c5">[Sourate : Le Discernement,<span class="c6"> 25 :</span> 63]</span>. C\'est-à-<span class="c6">dire :</span> modestement.<span class="c6"> Le Messager d\'Allah ﷺ a dit :</span> " Et personne ne se montre humble pour Allah sans qu\'Allah l\'élève. " Rapporté par Muslim.<span class="c6"> Il ﷺ a dit :</span> " Certes, Allah m\'a révélé que vous devez être humble <span class="c5">[les uns envers les autres]</span> de sorte que personne ne se pavane sur un autre ni que personne commette un injustice envers un autre. " Rapporté par Muslim. </p>',
            ],
            19 => [
                'question' => 'Q20 : Quels sont les types d\'orgueil interdits ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13840.mp3',
                'answer' => '<p> R : 1- L\'orgueil vis-à-vis de la vérité qui consiste à la rejeter et à ne pas l\'accepter.<br /> 2- L\'orgueil vis-à-vis des gens qui consiste à les mépriser et les rabaisser.<span class="c6"><br /> Le Messager d\'Allah ﷺ a dit :</span> " Quiconque a dans son cœur le poids d\'un atome d\'orgueil n\'entrera pas au Paradis. " Alors,<span class="c6"> un homme objecta :</span> " Mais,<span class="c6"> l\'homme aime que son habit soit beau et que ses sandales soient belles ? " Il a alors répondu :</span> " Certes, Allah est beau et Il aime la beauté. Et l\'orgueil consiste à rejeter la vérité et à mépriser les gens. " Rapporté par Muslim.<br /> -<span class="c6"> Rejeter la vérité :</span> c\'est la repousser.<br /> -<span class="c6"> Mépriser les gens :</span> c\'est les dédaigner.<br /> - Le bel habit et les belles sandales ne font pas partie de l\'orgueil. </p>',
            ],
            20 => [
                'question' => 'Q21 : Mentionne certains types de tricherie interdits.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13910.mp3',
                'answer' => '<p> R : - La tricherie dans la vente et l\'achat consiste à cacher un défaut dans la marchandise.<br /> - La tricherie dans l\'apprentissage de la science, comme la tricherie des étudiants lors des examens.<br /> - La tricherie dans les paroles, comme le faux témoignage et le mensonge.<br /> - Le non respect de la parole ou de l\'engagement pris avec les gens.<span class="c6"><br /> Concernant l\'interdiction de la tricherie :</span> Un jour, le messager d\'Allah ﷺ passa près d\'une pile de nourriture dans laquelle il mit sa main à l\'intérieur, et ses doigts touchèrent alors quelque chose d\'humide.<span class="c6"> Il demanda :</span> "Qu\'est-ce que cela,<span class="c6"> ô propriétaire de la nourriture ? " La personne répondit :</span> " La pluie l\'a touchée, ô Messager d\'Allah.<span class="c6"> " Il a alors dit :</span> " Pourquoi n\'as-tu pas mis cela au-dessus du tas afin que les gens le voient ? Quiconque nous trompant ne fait pas partie des miens <span class="c5">[et dans une version : il n\'est pas des nôtres]</span>. " Rapporté par Muslim.<span class="c6"><br /> La pile :</span> c\'est le tas de nourriture. </p>',
            ],
            21 => [
                'question' => 'Q22 : Qu\'est-ce que la médisance ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13990.mp3',
                'answer' => '<p> R : C\'est le fait de mentionner ton frère musulman de ce qu\'il répugnerait <span class="c5">[entendre]</span> alors qu\'il est absent.<br /> Il <span class="c2">(Élevé soit-Il)</span> a dit : {Et ne médisez pas les uns des autres. L\'un de vous aimerait-il manger la chair de son frère mort ? <span class="c5">[Non !]</span> Vous en auriez horreur. Et craignez Allah. Certes, Allah est Grand Accueillant au repentir, Très Miséricordieux. <span class="c2">(12)</span> } <span class="c5">[Sourate : Les Appartements,<span class="c6"> 49 :</span> 12]</span>. </p>',
            ],
            22 => [
                'question' => 'Q23 : Définis la calomnie.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14030.mp3',
                'answer' => '<p> R : C\'est le fait de rapporter les discussions aux gens afin de provoquer la dissension entre eux.<span class="c6"><br /> Le Messager d\'Allah ﷺ a dit :</span> " Le calomniateur n\'entrera pas au Paradis. " Rapporté par Muslim. </p>',
            ],
            23 => [
                'question' => 'Q24 : Qu\'est-ce que la fainéantise ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14070.mp3',
                'answer' => '<p> R : C\'est la lourdeur à faire le bien ou ce qui incombe à la personne de faire.<br /> Et parmi cela, il y a la fainéantise dans l\'accomplissement des obligations.<br /> Allah <span class="c2">(Élevé soit-Il)</span> a dit : {Certes, les hypocrites pensent tromper Allah, mais en fait c\'est Lui qui les trompe. Et lorsqu\'ils se lèvent pour la prière, ils se lèvent avec paresse et par ostentation envers les gens et ils ne mentionnent Allah que peu. <span class="c2">(142)</span> } <span class="c5">[Sourate : Les Femmes,<span class="c6"> 4 :</span> 142]</span>.<br /> Ainsi donc, il convient au croyant de délaisser la fainéantise, la torpeur et l\'inactivité, il lui incombe plutôt de s\'efforcer d\'œuvrer, de se bouger, de déployer de l\'ardeur et de faire des efforts en ce bas monde dans ce qui satisfait Allah <span class="c2">(Élevé soit-Il)</span>. </p>',
            ],
            24 => [
                'question' => 'Q25 : Mentionne les types de colère.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14130.mp3',
                'answer' => '<p> R : 1-<span class="c6"> Une colère louable :</span> C\'est une colère pour Allah <span class="c2">(Glorifié soit-Il)</span> lorsque les mécréants, les hypocrites, ou quiconque autre violent Ses limites sacrées.<br /> 2-<span class="c6"> Une colère blâmable :</span> C\'est une colère qui met la personne dans un état où elle fait ou dit des choses qui ne conviennent pas.<span class="c6"><br /> Le traitement de la colère blâmable :</span><br /> - Faire ses ablutions.<br /> - S\'assoir si on est debout ; s\'allonger si on est assis.<br /> - S\'attacher à la recommandation du Prophète ﷺ concernant cela,<span class="c6"> à savoir :</span> " Ne te mets pas en colère. "<br /> - Se maîtriser afin de ne pas laisser libre cours à la colère.<br /> - Chercher refuge auprès d\'Allah contre Satan le lapidé.<br /> - Se taire. </p>',
            ],
            25 => [
                'question' => 'Q26 : Qu\'est-ce que le fait d\'espionner ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14240.mp3',
                'answer' => '<p> R : C\'est le fait de dévoiler et " courir après " les choses intimes des personnes et ce qu\'elles cachent.<span class="c6"><br /> Parmi ses formes interdites :</span><br /> - Le fait de divulguer les choses intimes des gens <span class="c5">[qui se passent]</span> dans les demeures.<br /> - Le fait que la personne écoute les discussions des gens sans qu\'ils le sachent.<br /> Il <span class="c2">(Élevé soit-Il)</span> a dit : <span class="c4">{Et ne vous espionnez pas...}</span> <span class="c5">[Sourate : Les Appartements,<span class="c6"> 49 :</span> 12]</span>. </p>',
            ],
            26 => [
                'question' => 'Q27 : Qu\'est-ce que le gaspillage ? Qu\'est-ce que l\'avarice ? Qu\'est-ce que la générosité ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14310.mp3',
                'answer' => '<p> R : - Le gaspillage désigne le fait de dépenser de l\'argent sans juste droit.<br /> - L\'avarice est son contraire et cela désigne le fait de s\'abstenir de dépenser de l\'argent à juste titre.<br /> Ce qui convient est le juste milieu entre les deux ; à savoir, le musulman doit être généreux.<br /> Il <span class="c2">(Élevé soit-Il)</span> a dit : {Et ceux qui lorsqu\'ils dépensent ne sont ni excessifs ni avares mais se tiennent entre cela, au juste milieu. <span class="c2">(67)</span> } <span class="c5">[Sourate : Le Discernement,<span class="c6"> 25 :</span> 68]</span>. </p>',
            ],
            27 => [
                'question' => 'Q28 : Qu\'est-ce que la lâcheté ? Et qu\'est-ce que le courage ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14370.mp3',
                'answer' => '<p> R : La lâcheté : c\'est le fait d\'avoir peur de quelque chose dont il n\'incombe d\'avoir peur.<br /> Par exemple, la peur de dire la vérité ou de réprouver le blâmable.<span class="c6"><br /> Le courage :</span> c\'est le fait de se cramponner à la vérité, notamment la bravoure sur le champ de bataille afin de défendre l\'Islam et les musulmans.<span class="c6"><br /> Et parmi les invocations du Prophète ﷺ :</span> " Ô Allah ! Certes, je me réfugie auprès de Toi contre la lâcheté...<span class="c6"> " Le Messager d\'Allah ﷺ disait aussi :</span> " Le croyant fort est meilleur et plus aimé auprès d\'Allah que le croyant faible ; et dans chacun d\'eux il y a du bien. " Rapporté par Muslim. </p>',
            ],
            28 => [
                'question' => 'Q29 : Mentionne certaines paroles qui sont interdites ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14440.mp3',
                'answer' => '<p> R : -<span class="c6"> Par exemple :</span> la malédiction et l\'insulte.<br /> - Un autre exemple, le fait de traiter une personne de bête, ou ce qui y ressemble comme expressions.<br /> - Ou mentionner des paroles obscènes par le biais d\'expressions grossières et vulgaires.<br /> Et le Prophète ﷺ a interdit tout cela. En effet,<span class="c6"> il a dit :</span> " Le croyant n\'insulte pas, ne maudit pas et il n\'est ni vulgaire ni grossier. " Rapporté par at Tirmidhî et Ibn Hibbân. </p>',
            ],
            29 => [
                'question' => 'Q30 : Mentionne des causes aidant le musulman à se parer des beaux caractères ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14500.mp3',
                'answer' => '<p> R : 1- L\'invocation en demandant Allah de nous octroyer le bon comportement et de nous assister dans cela.<br /> 2- Ressentir le fait qu\'Allah <span class="c2">(Exalté et Magnifié soit-Il)</span> nous surveille et avoir conscience qu\'Il sait, entend et voit tout de nous.<br /> 3- Se rappeler la rétribution du bon comportement et qu\'il est une cause d\'entrée au Paradis.<br /> 4- Se rappeler la conséquence du mauvais comportement et qu\'il est une cause d\'entrée en Enfer.<br /> 5- Le bon comportement procure l\'amour d\'Allah <span class="c2">(Élevé soit-Il)</span> et l\'amour de Ses créatures ; et à l\'inverse, le mauvais comportement provoque la colère d\'Allah et la colère de Ses créatures.<br /> 6- La lecture de la biographie du Prophète ﷺ et son suivisme.<br /> 7- La compagnie des nobles personnes et s\'éloigner de la compagnie des mauvais. </p>',
            ],
        ],
        8 => [
            0 => [
                'question' => 'Q1 : Quel est le mérite de l\'évocation?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14630.mp3',
                'answer' => '<p> R : Le Prophète ﷺ a dit : " L\'exemple de celui qui mentionne son Seigneur et celui qui ne mentionne pas son Seigneur est comme l\'exemple du vivant et du mort. " Rapporté par Al Bukhârî.<br /> - Ceci car la valeur de la vie de l\'homme est selon son évocation d\'Allah <span class="c2">(Élevé soit-Il)</span>. </p>',
            ],
            1 => [
                'question' => 'Q2 : Mentionne certains bénéfices de l\'évocation ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14670.mp3',
                'answer' => '<p> R : 1- Il satisfait le Tout-Miséricordieux.<br /> 2- Il repousse le Diable.<br /> 3- Il prémunit le musulman des maux et méfaits.<br /> 4- Il permet d\'obtenir une immense récompense et rétribution. </p>',
            ],
            2 => [
                'question' => 'Q3 : Quelle est la meilleure évocation ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14730.mp3',
                'answer' => '<p> R : " Il n\'y a aucune divinité <span class="c5">[digne d\'adoration]</span> excepté Allah <span class="c2">(Lâ Ilaha IllâLlah)</span>. " Rapporté par At Tirmidhî et Ibn Mâja. </p>',
            ],
            3 => [
                'question' => 'Q4 : Que dis-tu au moment de te réveiller ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14760.mp3',
                'answer' => '<p> R : <span class="c3">« Louange à Allah qui nous a fait revivre après nous avoir fait mourir, et vers Lui est le retour. »</span> Unanimement Reconnu Authentique <span class="c5">[Al Bukhârî et Muslim]</span>. </p>',
            ],
            4 => [
                'question' => 'Q5 : Que dis-tu lorsque tu t\'habilles ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14790.mp3',
                'answer' => '<p> R : <span class="c3">« Louange à Allah qui m’a vêtu de cet habit et m\'en a pourvu, sans aucune force de ma part ni puissance. »</span> Rapporté par Abû Dâwud, at Tirmidhî et d\'autres. </p>',
            ],
            5 => [
                'question' => 'Q6 : Que dis-tu lorsque tu te déshabilles ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14820.mp3',
                'answer' => '<p> R : " Au nom d\'Allah. " Rapporté par At Tirmidhî. </p>',
            ],
            6 => [
                'question' => 'Q7 : Quelles est l\'invocation lorsqu\'on met un habit neuf ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14850.mp3',
                'answer' => '<p> R : <span class="c3">« Ô Allah ! Louange à Toi qui m’en a vêtu. Je Te demande son bien et le bien pour lequel il a été fabriqué et je me réfugie auprès de Toi contre son mal et le mal pour lequel il a été fabriqué. »</span> Rapporté par Abû Dâwud et At Tirmidhî. </p>',
            ],
            7 => [
                'question' => 'Q8 : Quelle est l\'invocation à dire à quelqu\'un qui porte un habit neuf ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14880.mp3',
                'answer' => '<p> R : Lorsque tu vois quelqu\'un qui porte un habit neuf,<span class="c6"> invoque en sa faveur en disant :</span> « Use-le et qu’Allah <span class="c2">(Élevé soit-Il)</span> te donne davantage. » Rapporté par Abû Dâwud. </p>',
            ],
            8 => [
                'question' => 'Q9 : Mentionne l\'invocation de l\'entrée aux toilettes.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14910.mp3',
                'answer' => '<p> R : <span class="c3">« Ô Allah ! Je me réfugie auprès de Toi contre les démons mâles et femelles. »</span> Unanimement Reconnu Authentique <span class="c5">[Al Bukhârî et Muslim]</span>. </p>',
            ],
            9 => [
                'question' => 'Q10 : Quelle est l\'invocation de la sortie des toilettes ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14940.mp3',
                'answer' => '<p> R : <span class="c3">« Je te demande pardon. »</span> Rapporté par Abû Dâwud et At Tirmidhî. </p>',
            ],
            10 => [
                'question' => 'Q11 : Que dis-tu avant [de faire] les ablutions ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14970.mp3',
                'answer' => '<p> R : " Au nom d\'Allah. " Rapporté par Abû Dâwud et d\'autres. </p>',
            ],
            11 => [
                'question' => 'Q12 : Quelle est l\'invocation à dire après avoir fini les ablutions ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15000.mp3',
                'answer' => '<p> " J\'atteste qu\'il n\'y a aucune divinité <span class="c5">[digne d\'adoration]</span> excepté Allah, Seul et sans associé ; et j\'atteste que Mohammed est Son serviteur et Son Messager. " Rapporté par Muslim. </p>',
            ],
            12 => [
                'question' => 'Q13 : Quelle est l\'invocation au moment de sortir de la maison ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15020.mp3',
                'answer' => '<p> R : " Au nom d\'Allah. Je place ma confiance en Allah. Et il n\'y a ni force ni puissance hormis par Allah. " Rapporté par Abû Dâwud et at Tirmidhî. </p>',
            ],
            13 => [
                'question' => 'Q14 : Quelle est l\'invocation au moment d\'entrer à la maison ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15050.mp3',
                'answer' => '<p> R : <span class="c3">« Au nom d\'Allah nous entrons et au nom d\'Allah nous sortons et c\'est en Allah, notre Seigneur, que nous plaçons notre confiance. »</span> Ensuite, la personne salue sa famille. Rapporté par Abû Dâwud. </p>',
            ],
            14 => [
                'question' => 'Q15 : Quelle est l\'invocation de l\'entrée à la mosquée
   ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15080.mp3',
                'answer' => '<p> R : " Ô Allah ! Ouvre-moi les portes de Ta miséricorde. " Rapporté par Muslim. </p>',
            ],
            15 => [
                'question' => 'Q16 : Mentionne l\'invocation de la sortie de la mosquée.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15110.mp3',
                'answer' => '<p> R : " Ô Allah ! Certes, je Te demande de Ta grâce. " Rapporté par Mouslim. </p>',
            ],
            16 => [
                'question' => 'Q17 : Que dis-tu lorsque tu entends l\'appel à la prière ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15140.mp3',
                'answer' => '<p> R : Je dis exactement ce que dit le muezzin excepté après : <span class="c3">« Accourrez à la prière ! »</span> et <span class="c3">« Accourrez au succès ! »</span> où là je dis : <span class="c3">« Il n\'y a ni force ni puissance hormis par Allah. »</span> Unanimement Reconnu Authentique <span class="c5">[Al Bukhârî et Muslim]</span>. </p>',
            ],
            17 => [
                'question' => 'Q18 : Que dis-tu après l\'appel à la prière ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15170.mp3',
                'answer' => '<p> R : Tu pries sur le Prophète ﷺ. Rapporté par Muslim.<span class="c6"> Et tu dis :</span> <span class="c3">« Ô Allah ! Seigneur de cet appel parfait et de la prière que l\'on va accomplir, donne à Mohammed le pouvoir d\'intercéder et la place d\'honneur, et ressuscite-le dans la position louable que Tu lui as promise. »</span> Al Bukhârî.<br /> Et tu invoques entre l\'appel à la prière <span class="c2">(Al Adhân)</span> et le second appel <span class="c2">(Al Iqâmah)</span>. En effet, à ce moment-là, l\'invocation n\'est pas rejetée. </p>',
            ],
            18 => [
                'question' => 'Q19 : Quelles sont les invocations du matin et du soir ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15220.mp3',
                'answer' => '<p> R : 1-<span class="c6"> Je lis :</span> " Le Verset du Repose-pied" <span class="c2">(Ayat al Kursî)</span>. {Allah ! Aucune divinité <span class="c5">[digne d\'adoration]</span> excepté Lui, le Vivant, Celui qui subsiste par Lui-même et par Qui tout subsiste. Ni somnolence ni sommeil ne Le saisissent. Tout ce qui est dans les cieux et sur la Terre Lui appartient. Qui peut intercéder auprès de Lui sans Sa permission ? Il connaît ce qu\'il y a devant eux <span class="c2">(leur futur)</span> et ce qu\'il y a derrière eux <span class="c2">(leur passé)</span>. Et, de Sa science, ils n\'embrassent que ce qu\'Il souhaite. Son Marchepied déborde les cieux et la Terre, dont la garde ne Lui coûte aucune peine. Et Il est le Très Haut, le Majestueux.} <span class="c5">[Sourate : La Vache,<span class="c6"> 2 :</span> 255]</span>. 2-<span class="c6"> Je lis :</span> " Au nom d\'Allah, le Tout Miséricordieux, le Très Miséricordieux.<span class="c6"> " {Dis :</span> « Il est Allah, l’Unique. <span class="c2">(1)</span> Allah, L\'Absolu. <span class="c2">(2)</span> Il n’a pas enfanté et n’a pas été enfanté <span class="c2">(3)</span> Et nul n’est égal à Lui. » <span class="c2">(4)</span> } Trois fois. " Au nom d\'Allah, le Tout Miséricordieux, le Très Miséricordieux.<span class="c6"> " {Dis :</span> " Je me réfugie auprès du Seigneur de l’aube naissante <span class="c2">(1)</span> Contre le mal de ce qu’Il a créé <span class="c2">(2)</span> Contre le mal de l’obscurité lorsqu\'elle s\'approfondit <span class="c2">(3)</span> Contre le mal de celles qui soufflent sur les nœuds <span class="c2">(4)</span> {Et contre le mal de l\'envieux lorsqu\'il envie. <span class="c2">(5)</span> } Trois fois. " Au nom d\'Allah, le Tout Miséricordieux, le Très Miséricordieux.<span class="c6"> " {Dis :</span> "Je me réfugie auprès du Seigneur des hommes. <span class="c2">(1)</span> Souverain des hommes. <span class="c2">(2)</span> Dieu des hommes. <span class="c2">(3)</span> Contre le mal de celui qui insuffle, le furtif. <span class="c2">(4)</span> Celui qui insuffle <span class="c5">[le mal]</span> dans les poitrines des hommes. <span class="c2">(5)</span> Parmi les djinns et les hommes. <span class="c2">(6)</span> } Trois fois. <span class="c3">« Ô Allah ! Tu es mon Seigneur. Il n\'y a aucune divinité <span class="c5">[digne d\'adoration]</span> excepté Toi. Tu m\'as créé et je suis Ton serviteur. Je me conforme autant que je peux à mon engagement et à ma promesse vis-à-vis de Toi. Je me réfugie auprès de Toi contre le mal de ce que j\'ai fait. Je Te reconnais Ton bienfait à mon égard. Je reconnais mon péché. Pardonne-moi donc car nul ne pardonne les péchés excepté Toi. »</span> Rapporté par Al Bukhârî. </p>',
            ],
            19 => [
                'question' => 'Q20 : Que dis-tu au moment du sommeil ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15290.mp3',
                'answer' => '<p> " En Ton nom, ô Allah, je meurs et je vis. " Unanimement Reconnu Authentique <span class="c5">[Al Bukhârî et Muslim]</span>. </p>',
            ],
            20 => [
                'question' => 'Q31 : Que dis-tu avant de manger ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15320.mp3',
                'answer' => '<p> R : " Au nom d\'Allah. "<br /> Et si tu as oublié de dire cela au début,<span class="c6"> alors dis :</span><br /> " Au nom d\'Allah à son début et à sa fin. " Rapporté par Abû Dâwud et At Tirmidhî. </p>',
            ],
            21 => [
                'question' => 'Q22 : Que dis-tu lorsque tu as fini de manger ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15370.mp3',
                'answer' => '<p> R : " Louange à Allah qui m\'a nourri de ceci et m\'en a pourvu sans force ni puissance de ma part. " Rapporté par Abû Dâwud, Ibn Mâja et d\'autres. </p>',
            ],
            22 => [
                'question' => 'Q23 : Quelle est l\'invocation de l\'invité en faveur de son hôte ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15400.mp3',
                'answer' => '<p> R : <span class="c3">« Ô Allah ! Bénis-leur ce dont Tu les a pourvus, pardonne-leur et fais-leur miséricorde. »</span> Rapporté par Muslim. </p>',
            ],
            23 => [
                'question' => 'Q24 : Que dis la personne lorsqu\'elle éternue ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15430.mp3',
                'answer' => '<p> R : " Louange à Allah.<span class="c6"> "<br /> Et son frère ou la personne présente lui répond alors :</span> " Qu\'Allah te fasse miséricorde.<span class="c6"> "<br /> La personne ayant éternué répond alors à son frère ou à cette personne présente la parole suivante :</span> " Qu\'Allah vous guide et améliore votre situation. " Rapporté par Al Bukhârî. </p>',
            ],
            24 => [
                'question' => 'Q25 : Que dis-tu au moment de te lever d\'une assise et de la quitter, qu\'on appelle aussi : " L\'invocation de l\'expiation de l\'assise. " ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15480.mp3',
                'answer' => '<p> R : " Gloire à Toi, ô Allah, et par Ta louange. J\'atteste qu\'il n\'y a aucune divinité <span class="c5">[digne d\'adoration]</span> excepté Allah, j\'implore Ton pardon et je me repens à Toi. " Rapporté par Abû Dâwud, At Tirmidhî et d\'autres. </p>',
            ],
            25 => [
                'question' => 'Q26 : Quelle est l\'invocation lorsque l\'on prend place dans un moyen de transport  ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15510.mp3',
                'answer' => '<p> R : « Au nom d’Allah, la louange est à Allah. {Gloire à Celui qui nous a soumis ceci alors que nous n’étions pas capables de les dominer. <span class="c2">(13)</span> Et c’est vers notre Seigneur que vraiment nous retournons. <span class="c2">(14)</span> } Louange à Allah, louange à Allah, louange à Allah. Allah est le Plus Grand, Allah est le Plus Grand, Allah est le Plus Grand. Gloire à Toi, Ô Allah, certes je me suis fait du tort à ma propre personne, pardonne-moi donc ! En effet, nul ne pardonne les péchés excepté Toi. » Rapporté par Abû Dâwud et At Tirmidhî. </p>',
            ],
            26 => [
                'question' => 'Q27 : Mentionne l\'invocation du voyage ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15540.mp3',
                'answer' => '<p> R : « Allah est le Plus Grand, Allah est le Plus Grand, Allah est le Plus Grand. {Gloire à Celui qui nous a soumis ceci alors que nous n’étions pas capables de les dominer. <span class="c2">(13)</span> Et c’est vers notre Seigneur que vraiment nous retournons. <span class="c2">(14)</span> } Ô Allah ! Nous Te demandons dans ce voyage la bonté, la piété et toute œuvre qui Te satisfait. Ô Allah ! Tranquillise-nous dans ce voyage et diminue-nous-en la distance. Ô Allah ! Tu es le compagnon de voyage et le remplaçant dans la famille. Ô Allah ! Je me réfugie auprès de Toi contre les fatigues du voyage, contre tout paysage source de chagrin, et contre tout mal qui nous frapperait, de retour dans nos biens et nos familles. »<br /> Et lorsqu\'il revient,<span class="c6"> il dit et ajoute :</span><br /> <span class="c3">« Nous voilà de retour, repentants, dévoués et proclamant la louange de notre Seigneur. »</span> Rapporté par Muslim. </p>',
            ],
            27 => [
                'question' => 'Q28 : Quelle est l\'invocation du voyageur en faveur du résident ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15590.mp3',
                'answer' => '<p> R : <span class="c3">« Je vous confie à Allah dont les dépôts confiés ne se perdent jamais. »</span> Rapporté par Ahmed et Ibn Mâja. </p>',
            ],
            28 => [
                'question' => 'Q29 : Quelle est l\'invocation du résident en faveur du voyageur ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15620.mp3',
                'answer' => '<p> R : <span class="c3">« Je confie à Allah <span class="c5">[le soin de préserver]</span> ta religion, ton honnêteté et tes dernières œuvres. »</span> Rapporté par Ahmad et At Tirmidhî. </p>',
            ],
            29 => [
                'question' => 'Q30 : Quelle est l\'invocation de l\'entrée au marché ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15650.mp3',
                'answer' => '<p> R : <span class="c3">« Il n’y a aucune divinité <span class="c5">[digne d\'adoration]</span> excepté Allah, Seul, sans associé. À Lui la royauté et à Lui la louange, Il donne la vie et Il donne la mort. Il est vivant et ne meurt pas. Le bien est dans Sa main et Il est Omnipotent sur toute chose. »</span> Rapporté par At Tirmidhî et Ibn Mâja. </p>',
            ],
            30 => [
                'question' => 'Q31 : Mentionne l\'invocation au moment de la colère ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15680.mp3',
                'answer' => '<p> R : " Je me réfugie auprès d\'Allah contre Satan le lapidé. " Unanimement Reconnu Authentique <span class="c5">[Al Bukhârî et Muslim]</span>. </p>',
            ],
            31 => [
                'question' => 'Q32 : Que dis-tu à quiconque te fait un bien ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15710.mp3',
                'answer' => '<p> R : " Qu\'Allah te récompense en bien. " Rapporté par At Tirmidhî. </p>',
            ],
            32 => [
                'question' => 'Q33 : Quelle est l\'invocation lorsque la monture n\'est pas docile ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15740.mp3',
                'answer' => '<p> R : " Au nom d\'Allah. " Rapporté par Abû Dâwud. </p>',
            ],
            33 => [
                'question' => 'Q34 : Que dis-tu lorsqu\'il t\'arrive ce qui te réjouit ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15770.mp3',
                'answer' => '<p> R : <span class="c3">« Louange à Allah, Celui qui par Son bienfait permet de parachever les bonnes choses. »</span> Rapporté par Al Hâkim et d\'autres. </p>',
            ],
            34 => [
                'question' => 'Q35 : Que dis-tu lorsqu\'il t\'arrive ce qui t\'est désagréable ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15800.mp3',
                'answer' => '<p> R : <span class="c3">« Louange à Allah en toutes circonstances. »</span> Sahîh Al Jâmi\'. </p>',
            ],
            35 => [
                'question' => 'Q36 : Quelle est la manière de saluer et de répondre au salut ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15830.mp3',
                'answer' => '<p> R : Le musulman dit : " Que la paix soit sur vous ainsi que la miséricorde d\'Allah et Sa bénédiction.<span class="c6"> "<br /> Et son frère lui répond :</span> " Et que la paix soit sur vous, la miséricorde d\'Allah et Sa bénédiction. " Rapporté par At Tirmidhî, Abû Dâwud et d\'autres. </p>',
            ],
            36 => [
                'question' => 'Q37 : Quelle est l\'invocation au moment de la tombée de la pluie ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15870.mp3',
                'answer' => '<p> R : " Ô Allah ! Rends cette pluie abondante et bénéfique. " Al Bukhârî. </p>',
            ],
            37 => [
                'question' => 'Q38 : Quelle est l\'invocation après la tombée de la pluie ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15900.mp3',
                'answer' => '<p> R : " Il a plu par la grâce d\'Allah et Sa miséricorde. " Al Bukhârî et Muslim. </p>',
            ],
            38 => [
                'question' => 'Q39 : Mentionne l\'invocation lorsque le vent souffle  ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15930.mp3',
                'answer' => '<p> R : <span class="c3">« Ô Allah ! Certes, je Te demande son bien et je me réfugie auprès de Toi contre son mal. »</span> Rapporté par Abû Dâwud et Ibn Mâja. </p>',
            ],
            39 => [
                'question' => 'Q40 : Mentionne l\'invocation lorsque le tonnerre gronde ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15960.mp3',
                'answer' => '<p> R : <span class="c3">« Gloire à Celui dont le tonnerre Le glorifie par Sa louange ainsi que les Anges <span class="c5">[sous l’effet]</span> de sa crainte. »</span> Al Muwatâ de l\'imam Mâlik. </p>',
            ],
            40 => [
                'question' => 'Q41 : Quelle est l\'invocation lorsque tu vois une personne éprouvée ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15990.mp3',
                'answer' => '<p> R : <span class="c3">« Louange à Allah, Celui qui m’a préservé de ce dont tu es affligé et qui m’a préféré à beaucoup de ce qu\'Il a créé. »</span> Rapporté par At Tirmidhî. </p>',
            ],
            41 => [
                'question' => 'Q42 : L\'invocation de celui qui craint d\'atteindre qui que ce soit de son mauvais œil ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16020.mp3',
                'answer' => '<p> R : Dans le hadith : <span class="c3">« Si l’un de vous voit chez son frère, ou chez lui-même, ou dans ses biens une chose qui lui plaît <span class="c5">[qu’il invoque donc en sa faveur la bénédiction d’Allah]</span> car le mauvais œil est certes une vérité. »</span> Rapporté par Ahmed, Ibn Mâja et d\'autres. </p>',
            ],
            42 => [
                'question' => 'Q43 : Comment pries-tu sur le Prophète ﷺ ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16050.mp3',
                'answer' => '<p> R : « Ô Allah ! Prie sur Muhammad et sur la famille de Muhammad comme Tu as prié sur Ibrâhîm <span class="c2">(Abraham)</span> et sur la famille d\'Ibrâhîm, certes Tu es digne de louange et de glorification. Ô Allah ! Bénis Muhammad et la famille de Muhammad comme Tu as béni Ibrâhîm et la famille d\'Ibrâhîm, certes Tu es digne de louange et de glorification. » Unanimement reconnu authentique <span class="c5">[Al Bukhârî et Muslim]</span>. </p>',
            ],
        ],
        9 => [
            0 => [
                'question' => 'Q1 : Quels sont les cinq statuts juridiques ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16090.mp3',
                'answer' => '<p> R :<br /> 1- L\'obligation <span class="c2">(Al Wâjib)</span>.<br /> 2- Le recommandé <span class="c2">(Al Mustahab)</span>.<br /> 3- L\'interdiction <span class="c2">(Al Muharram)</span>.<br /> 4- Le détestable <span class="c2">(Al Makrûh)</span>.<br /> 5- La permission <span class="c2">(Al Mubâh)</span>. </p>',
            ],
            1 => [
                'question' => 'Q2 : Explique ces cinq statuts juridiques ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16170.mp3',
                'answer' => '<p> R :<br /> 1-<span class="c6"> L\'obligation :</span> Comme les cinq prières, le jeûne de Ramadân, la bienfaisance envers les parents, etc.<br /> Celui qui accomplit ce qui est obligatoire est rétribué pour cela et il est puni s\'il le délaisse.<br /> 2-<span class="c6"> L\'acte recommandé :</span> Comme les prières surérogatoires dites " Rawâtib ", la prière de nuit, nourrir les gens, la salutation des personnes, etc.<span class="c6"> On appelle aussi cela :</span> ce qui est de tradition <span class="c2">(As Sunnah)</span> ou ce qui est préférable <span class="c2">(Al Mandûb)</span>.<br /> Celui qui accomplit ce qui est recommandé est rétribué pour cela et celui qui le délaisse n\'est pas puni.<span class="c6"><br /> Remarque importante :</span><br /> Il convient au musulman qui entend qu\'une affaire être une Sounna ou qu\'elle est recommandée de s\'empresser de l\'accomplir et d\'imiter en cela le Prophète ﷺ.<br /> 3-<span class="c6"> L\'interdiction :</span> Comme la consommation d\'alcool, la désobéissance aux parents, la rupture des liens de parenté, etc.<br /> Celui qui délaisse ce qui est interdit est rétribué pour cela et celui qui le commet est puni.<br /> 4-<span class="c6"> L\'acte détestable :</span> Comme le fait de prendre ou de donner de la main gauche, replier le vêtement dans la prière, etc.<br /> Celui qui délaisse ce qui est détestable est rétribué pour cela et celui qui le commet n\'est pas puni.<br /> 5-<span class="c6"> La permission :</span> comme le fait de manger une pomme, de boire du thé,... Il est aussi appelé l\'acte autorisé ou licite.<br /> Celui qui délaisse ce qui est permis n\'est pas rétribué pour cela et celui qui le commet n\'est pas puni. </p>',
            ],
            2 => [
                'question' => 'Q3 : Quel est le statut du négoce et des transactions ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16320.mp3',
                'answer' => '<p> R : La base de toutes les ventes et transactions est leur licéité excepté quelques types parmi elles qu\'Allah <span class="c2">(Élevé soit-Il)</span> a interdites.<br /> Il <span class="c2">(Élevé soit-Il)</span> a dit : <span class="c4">{Et Allah a rendu licite le négoce et Il a rendu illicite l\'intérêt usuraire.}</span> <span class="c5">[Sourate : La Vache,<span class="c6"> 2 :</span> 275]</span>. </p>',
            ],
            3 => [
                'question' => 'Q4 : Mentionne certains types de transactions et de négoces interdits ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16360.mp3',
                'answer' => '<p> R :<br /> 1- La tricherie ,<span class="c6"> notamment :</span> la dissimulation d\'un défaut de la marchandise.<br /> En effet, d\'après Abû Hurayra <span class="c2">(qu\'Allah l\'agrée)</span> : Le Messager d\'Allah ﷺ passa près d\'une pile d\'aliment - c\'est-à-<span class="c6">dire :</span> un tas de nourriture - alors il y entra sa main et là ses doigts touchèrent ce qui était avarié,<span class="c6"> il demanda alors :</span> " Ô propriétaire de la nourriture ! Qu\'est-<span class="c6">ce que ceci ? " Ce dernier a alors répondu :</span> " Ô Messager d\'Allah ! La pluie l\'a touchée.<span class="c6"> " Il a dit :</span> " Pourquoi ne l\'as-tu donc pas mis au-dessus de la pile afin que les gens le voient clairement ? Quiconque triche ne fait pas partie des miens. Rapporté par Muslim.<br /> 2- L\'intérêt usuraire <span class="c2">(Ar-Ribâ)</span> : Cela consiste à prendre 1000 auprès d\'une personne en tant que dette et à lui rendre ensuite 2000.<br /> L\'augmentation est l\'intérêt usuraire interdit.<br /> Il <span class="c2">(Élevé soit-Il)</span> a dit : <span class="c4">{Et Allah a rendu licite le négoce et Il a rendu illicite l\'intérêt usuraire.}</span> <span class="c5">[Sourate : La Vache,<span class="c6"> 2 :</span> 275]</span>.<br /> 3-<span class="c6"> Tout ce qui est inconnu :</span> Comme le fait de vendre du lait alors que celui-ci est encore dans le pis de la bête ou le poisson qui est dans l\'eau et qui n\'a pas encore été péché.<span class="c6"><br /> Et dans le hadith :</span> " Le Messager d\'Allah ﷺ a interdit la " vente inconnue " Rapporté par Muslim. </p>',
            ],
            4 => [
                'question' => 'Q5 : Mentionne certains bienfaits d\'Allah sur toi ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16460.mp3',
                'answer' => '<p> R : 1- Le bienfait de l\'Islam et le fait que tu ne fasses pas partie des mécréants.<br /> 2- Le bienfait de la Sunnah et le fait que tu ne fasses pas partie des innovateurs.<br /> 3- Le bienfait de la santé et de la préservation,<span class="c6"> et notamment :</span> l\'ouïe, la vue, la mobilité, etc.<br /> 4- Le bienfait de la nourriture, la boisson, l\'habillement, etc.<br /> Et les bienfaits d\'Allah <span class="c2">(Élevé soit-Il)</span> sur nous sont nombreux, on ne peut les dénombrer ni les recenser.<br /> Il <span class="c2">(Élevé soit-Il)</span> a dit : <span class="c4">{Et si vous comptez les bienfaits d\'Allah, vous ne pourrez pas les recenser. Certes, Allah est vraiment Pardonneur, Miséricordieux.}</span> <span class="c5">[Sourate : Les Abeilles,<span class="c6"> 16 :</span> 18]</span>. </p>',
            ],
            5 => [
                'question' => 'Q6 : Quel est le devoir vis-à-vis des bienfaits ? Comment remercies-tu Allah pour ceux-ci ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16540.mp3',
                'answer' => '<p> R : Le devoir vis-à-vis des bienfaits est de s\'en montrer reconnaissant et cela en faisant l\'éloge d\'Allah pour ceux-ci, en Le louant par la langue, notamment que le mérite ne revient qu\'à Lui Seul, et en utilisant ces bienfaits dans ce qui satisfait Allah <span class="c2">(Élevé soit-Il)</span> et non dans Sa désobéissance. </p>',
            ],
            6 => [
                'question' => 'Q7 : Quelles sont les fêtes des musulmans ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16570.mp3',
                'answer' => '<p> R : La fête de la Rupture <span class="c2">(Aïd al Fitr)</span> et la fête du Sacrifice <span class="c2">(Aïd Al Adhâ)</span>.<br /> Comme rapporté dans le hadith d\'Anas <span class="c2">(qu\'Allah l\'agrée)</span> qui a dit : " Le Messager d\'Allah ﷺ est arrivé à Médine et il vit que les gens avait deux jours durant lesquels ils jouaient,<span class="c6"> alors il demanda :</span> " Que sont ces deux jours ? " Les gens répondirent : " Ce sont deux jours au cours desquels nous jouions durant la période préislamique païenne <span class="c2">(Al Jâhiliyyah)</span>. " Alors,<span class="c6"> le Messager d\'Allah ﷺ a dit :</span> " Certes,<span class="c6"> Allah vous a remplacé ces deux jours par deux autres meilleurs encore :</span> le jour du sacrifice <span class="c2">(Yawm Al Adhâ)</span> et le jour de la rupture <span class="c2">(Yawm Al Fitr)</span>. " Rapporté par Abû Dâwud.<br /> En dehors de ces deux fêtes-là, toute autre fête fait partie des innovations. </p>',
            ],
            7 => [
                'question' => 'Q8 : Quel est le meilleur des mois ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16620.mp3',
                'answer' => '<p> R : Le mois de Ramadân. </p>',
            ],
            8 => [
                'question' => 'Q9 : Quel est le meilleur des jours ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16650.mp3',
                'answer' => '<p> R : Le jour du vendredi. </p>',
            ],
            9 => [
                'question' => 'Q10 : Quel est le meilleur jour dans l\'année ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16680.mp3',
                'answer' => '<p> R : Le jour d\'Arafat. </p>',
            ],
            10 => [
                'question' => 'Q11 : Quelle est la meilleure nuit dans l\'année ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16710.mp3',
                'answer' => '<p> R : La nuit du Destin. </p>',
            ],
            11 => [
                'question' => 'Q12 : Quelle est l\'obligation lorsque tu vois une femme étrangère ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16740.mp3',
                'answer' => '<p> R : L\'obligation est de baisser le regard. Allah <span class="c2">(Élevé soit-Il)</span> dit : <span class="c4">{Dis aux croyants qu\'ils baissent leur regard.}</span> <span class="c5">[Sourate : La lumière,<span class="c6"> 24 :</span> 30]</span>. </p>',
            ],
            12 => [
                'question' => 'Q13 : Qui sont les ennemis de l\'Homme ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16770.mp3',
                'answer' => '<p> 1-<span class="c6"> L\'âme incitatrice au mal :</span> Cela par le fait que l\'Homme suit les penchants de son âme et de sa passion dans la désobéissance à Allah <span class="c2">(Béni et Élevé soit-Il)</span>. Il <span class="c2">(Glorifié soit-Il)</span> a dit : <span class="c4">{Certes, l\'âme est incitatrice au mal excepté celle à qui Allah a fait miséricorde. Certes, mon Seigneur est Pardonneur, Très Miséricordieux.}</span> <span class="c5">[Sourate : Joseph,<span class="c6"> 12 :</span> 53]</span>. 2-<span class="c6"> Le Diable :</span> Il est l\'ennemi du fils d\'Adam et son objectif est d\'égarer l\'Homme en lui insufflant le mal et ainsi le faire entrer en Enfer. Allah <span class="c2">(Élevé soit-Il)</span> a dit : <span class="c4">{Et ne suivez pas les pas du Diable ! Certes, Il est pour vous un ennemi déclaré.}</span> <span class="c5">[Sourate : La Vache,<span class="c6"> 2 :</span> 168]</span>. 3-<span class="c6"> Les gens mauvais :</span> Ils sont ceux qui incitent l\'Homme au mal et qui obstruent la voie au bien. Allah <span class="c2">(Élevé soit-Il)</span> a dit : <span class="c4">{Ce jour-là, les intimes seront ennemis les uns des autres, excepté les pieux.}</span> <span class="c5">[Sourate : L\'Ornement,<span class="c6"> 43 :</span> 67]</span>. </p>',
            ],
            13 => [
                'question' => 'Q14 : Qu\'est-ce que le repentir (At-Tawbah) ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16820.mp3',
                'answer' => '<p> R : Le repentir désigne le fait de délaisser une désobéissance à Allah <span class="c2">(Élevé soit-Il)</span> pour Son obéissance. Il <span class="c2">(Élevé soit-Il)</span> a dit : <span class="c4">{Et certes, Je suis vraiment Grand Pardonneur pour quiconque s\'est repenti, a cru, a œuvré vertueusement et a pris le chemin de la guidée.}</span> <span class="c5">[Sourate : Ṭâ-Hâ,<span class="c6"> 20 :</span> 82]</span>. </p>',
            ],
            14 => [
                'question' => 'Q15 : Quelles sont les conditions du repentir véridique ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16850.mp3',
                'answer' => '<p> R : 1- Renoncer au péché.<br /> 2- Regretter ce qui a été commis.<br /> 3- Être résolu à ne plus refaire ce péché.<br /> 4- S\'acquitter des droits et des injustices commises auprès de leur ayant-droits.<br /> Allah <span class="c2">(Élevé soit-Il)</span> a dit : <span class="c4">{Et ceux qui ont commis une turpitude ou se sont fait du tort à eux-mêmes <span class="c5">[en désobéissant à Allah]</span>, puis se sont souvenu d\'Allah et ont alors imploré le pardon pour leur péchés - et qui pardonne les péchés sinon Allah ? - Et ils n\'ont pas sciemment persisté dans ce qu\'ils ont fait <span class="c5">[de mal]</span>.}</span> <span class="c5">[Sourate : La Famille d\'Imrân,<span class="c6"> 3 :</span> 135]</span>. </p>',
            ],
            15 => [
                'question' => 'Q16 : Quelle est la signification de : La prière sur le Prophète ﷺ ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16920.mp3',
                'answer' => '<p> R : Elle signifie : invoquer Allah afin qu\'Il fasse l\'éloge de son Prophète ﷺ au sein de la plus Haute Assemblée. </p>',
            ],
            16 => [
                'question' => 'Q17 : Quelle est la signification de : " Gloire à Allah (SubhânaLlah) " ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16950.mp3',
                'answer' => '<p> R : La glorification désigne l\'exemption d\'Allah <span class="c2">(Glorifié et Élevé soit-Il)</span> de toute déficience, tout défaut et tout méfait. </p>',
            ],
            17 => [
                'question' => 'Q18 : Quelle est la signification de : " Louange à Allah (Al Hamdulillah) " ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16980.mp3',
                'answer' => '<p> R : C\'est l\'éloge d\'Allah <span class="c2">(Élevé soit-Il)</span> et le fait de Lui reconnaître tous les attributs de perfection. </p>',
            ],
            18 => [
                'question' => 'Q19 : Quelle est la signification de : " Allah est plus Grand (Allah Akbar) " ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/17000.mp3',
                'answer' => '<p> R : C\'est-à-<span class="c6">dire :</span> Il <span class="c2">(Glorifié soit-Il)</span> est plus grand que toute chose et Il est plus sublime, plus immense et plus puissant que toute chose. </p>',
            ],
            19 => [
                'question' => 'Q20 : Quelle est la signification de : " Il n\'y a ni force ni puissance excepté en Allah (Lâ Hawla Wa La Quwwata illa Billah) " ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/17030.mp3',
                'answer' => '<p> R : Sa signification est : Le serviteur ne se meut pas d\'un état à un autre ni n\'a de puissance pour faire cela excepté par Allah. </p>',
            ],
            20 => [
                'question' => 'Q21 : Quelle est la signification de : " J\'implore le pardon d\'Allah (Astaghfirullah) " ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/17060.mp3',
                'answer' => '<p> R : C\'est la demande du serviteur à son Seigneur qu\'Il lui efface ses péchés et lui cache ses défauts. </p>',
            ],
        ],
    ],
];
