<?php
$data = [
    'title' => 'Ką turi žinoti musulmonų vaikai',
    'description' => 'Projektas paprastu ir lengvu požiūriu į problemas, kurių musulmonas negali ignoruoti. Tai apima tikėjimo, jurisprudencijos, Pranašo biografijos, etiketo, Korano aiškinimo, chadisų, moralės ir dhikr dalykus. Tinka įvairaus amžiaus žmonėms, ypač vaikams ir islamo naujokams.',
    'source' => 'https://kids.islamenc.com/lt/home',
    'author' => 'Yazan Abdul Razzaq Raziq Alghanim',
    'sections' => [
        0 => 'Tikėjimo (akydos) skyrius',
        1 => 'Fikh (jurisprudencijos) skyrius',
        2 => 'Pranašo sira (biografijos) skyrius',
        3 => 'Korano interpretacijos (tafsiro) skyrius',
        4 => 'Hadisų skyrius',
        5 => 'Islamo etiketo skyrius',
        6 => 'Moralės skyrius',
        7 => 'Maldavimų ir Allaho Zikr (atminimo žodžių) skyrius',
        8 => 'Įvairių kitų dalykų skyrius',
    ],
    'data' => [
        1 => [
            0 => [
                'question' => '1 Klausimas: kas yra tavo Viešpats?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/200.mp3',
                'answer' => '<p> Atsakymas: mano Viešpats yra Allahas, kuris rūpinasi manimi ir viskuo per Savo malonę.<span class="c6"><br /> To įrodymas yra Allaho posakis:</span> { Visa šlovė ir dėkingumas – Allahui, pasaulių <span class="c2">(alamyn - žmonijos, džinų ir visa, kas egzistuoja)</span> Viešpačiui} <span class="c5">[Koranas,<span class="c6"> sūra „Atveriančioji“ 1:</span>2]</span>. </p>',
            ],
            1 => [
                'question' => '2 Klausimas: kokia tavo religija?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/240.mp3',
                'answer' => '<p> Atsakymas: mano religija yra islamas, kuri reiškia paklusnumą Allahui per monoteizmą, atsidavimą Jam per paklusnumą ir atsiribojimą nuo politeizmo <span class="c2">(širk)</span> ir politeistų.<span class="c6"><br /> Tarė Visagalis:</span> <span class="c4">{ Iš tiesų religija Allaho - islamas.}</span> <span class="c5">[Koranas,<span class="c6"> sūra „Imrano giminė“ 3:</span>19]</span>. </p>',
            ],
            2 => [
                'question' => '3 Klausimas: kas yra tavo pranašas?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/280.mp3',
                'answer' => '<p> Atsakymas: Muchammedas <span class="c2">(ramybė ir Allaho palaima jam)</span>.<span class="c6"><br /> Tarė Visagalis:</span> <span class="c4">{ Muchammedas yra Allaho Pasiuntinys...}</span> <span class="c5">[Koranas,<span class="c6"> sūra „Pergalė“ 48:</span>29]</span>. </p>',
            ],
            3 => [
                'question' => '4 Klausimas: kokie yra monoteizmo (tauchyd) žodžiai ir jų reikšmė?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/310.mp3',
                'answer' => '<p> Atsakymas: monoteizmo žodžiai yra - lia Iliaha illa Allah, kurie reiškia, kad nėra jokio kito dievo, išskyrus Allahą.<span class="c6"><br /> Tarė Visagalis:</span> { Taigi žinok, <span class="c2">(o Muchammedai)</span>, kad Lia iliaha illia Allah <span class="c2">(niekas neturi teisės būti garbinamas išskyrus Allahą)</span>.} <span class="c5">[Koranas,<span class="c6"> sūra „Muchammedas“ 47:</span>19]</span>. </p>',
            ],
            4 => [
                'question' => '5 Klausimas: kur yra Visagalis Allahas?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/350.mp3',
                'answer' => '<p> Atsakymas: Allahas yra danguje virš sosto, virš visų kūrinių.<span class="c6"> Tarė Jis:</span> { Maloningiausiasis <span class="c2">(Allahas)</span> pakilo <span class="c2">(istava)</span> į <span class="c2">(Galingą)</span> Sostą <span class="c2">(būdu, kuris pritinka tik Jo Didenybei)</span>.} <span class="c5">[Koranas,<span class="c6"> sūra „Ta ha“ 20:</span>5]</span>.<span class="c6"> Ir tarė:</span> { Ir Jis yra Nenugalimas, <span class="c2">(Aukščiausiasis)</span> virš Savo vergų ir Jis yra Visa Išmanantis, Visa Žinantis.} <span class="c5">[Koranas,<span class="c6"> sūra „Galvijai“ 6:</span>18]</span>. </p>',
            ],
            5 => [
                'question' => '6 Klausimas: ką reiškia liudijimas, kad Muchammedas yra Allaho Pasiuntinys?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/380.mp3',
                'answer' => '<p> Atsakymas: tai reiškia, kad Allahas atsiuntė jį į pasaulius kaip džiugių žinių nešėją ir perspėtoją.<span class="c6"><br /> Reikia:</span><br /> 1. Paklusti jo įsakymams.<br /> 2. Tikėti jo pranešimais.<br /> 3. Susilaikyti nuo nepaklusimo jam.<br /> 4. Garbinti Allahą tik laikantis jo šariato, kuris reikalauja laikytis sunos ir atsisakyti religinių naujovių.<span class="c6"><br /> Tarė Visagalis:</span> { Tas, kuris paklūsta Pasiuntiniui <span class="c2">(Muchammedui)</span>, iš tiesų pakluso Allahui,} <span class="c5">[Koranas,<span class="c6"> sūra „Moterys“ 4:</span>80]</span>. Ir tarė,<span class="c6"> šlovė Jam:</span> { Ir nekalba jis <span class="c2">(savo)</span> troškimu. <span class="c2">(3)</span> Tai tėra apreiškimas, apreikštas. <span class="c2">(4)</span>} <span class="c5">[Koranas,<span class="c6"> sūra „Žvaigždė“ 53:</span>3-4]</span>.<span class="c6"> Tarė Visagalis:</span> { Iš tiesų Allaho Pasiuntinyje jūs turite gerą pavyzdį, sektiną tam, kuris tikisi <span class="c2">(susitikimo su)</span> Allahu ir Paskutiniosios Dienos, ir prisimena Allahą gausiai.} <span class="c5">[Koranas,<span class="c6"> sūra „Sąjungininkai“ 33:</span>21]</span>. </p>',
            ],
            6 => [
                'question' => '7 Klausimas: kodėl Visagalis Allahas mus sukūrė?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/480.mp3',
                'answer' => '<p> Atsakymas: Jis sukūrė mus, kad garbintume Jį Vieną, nesusiedami Jo su jokiais partneriais,<br /> o ne linksmintis ir žaisti.<span class="c6"><br /> Tarė Visagalis:</span> { Ir Aš <span class="c2">(Allahas)</span> nesukūriau džinų ir žmonių, išskyrus tam, kad jie garbintu Mane <span class="c2">(Vieną)</span>.} <span class="c5">[Koranas,<span class="c6"> sūra „Vėjai“ 51:</span>56]</span>. </p>',
            ],
            7 => [
                'question' => '8 Klausimas: kas yra garbinimas?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/530.mp3',
                'answer' => '<p> Atsakymas: tai plati sąvoka, apimanti visus akivaizdžius ir paslėptus posakius ir poelgius, kuriuos Allahas myli ir yra patenkintas jais.<span class="c6"><br /> · Akivaizdaus garbinimo tipas:</span> pavyzdžiui, Allaho atminimas liežuviu <span class="c2">(tariant žodžius: „Subchana Allah“, „Al-chamdu lillah“, „Allahu akbar“)</span>, malda ir hadžas.<span class="c6"><br /> · Paslėpto garbinimo tipas:</span> pasitikėjimas Allahu, Jo baiminimasis ir viltis į Jį. </p>',
            ],
            8 => [
                'question' => '9 Klausimas: kokia yra mūsų didžiausia pareiga?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/580.mp3',
                'answer' => '<p> Atsakymas: mūsų didžiausia pareiga yra tikėti Visagalio Allaho Vienumu <span class="c2">(tauchyd)</span>. </p>',
            ],
            9 => [
                'question' => '10 Klausimas: kokie yra monoteizmo tipai?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/610.mp3',
                'answer' => '<p> Atsakymas <span class="c2">(1)</span>: Allaho išskirtinumas viešpataujant - tikėjimas, kad Allahas yra Kūrėjas, suteikiantis aprūpinimą, viskas Jam pavaldu ir Jis viską kontroliuoja bei neturi partnerių.<br /> <span class="c2">(2)</span>: Allaho vienybė dievybėje - tikėjimas, kad tik Allahas yra vertas garbinimo ir niekas negali garbinti nieko, išskyrus Visagalį.<br /> <span class="c2">(3)</span>: Allaho unikalumas vardais ir savybėmis - tikėjimas Visagalio Allaho vardais ir savybėmis, minimais Korane ir sunoje, be pristatymo, palyginimo ar neigimo.<span class="c6"><br /> Šių trijų monoteizmo tipų įrodymas yra Visagalio žodžiai:</span> { Dangų ir žemės, ir viso, kas tarp jų, Viešpats, tad garbink Jį <span class="c2">(Vienintelį)</span> ir būk pastovus ir kantrus Jo garbinime. Ar žinai ką nors, kas būtų panašus į Jį? <span class="c2">(žinoma, kad niekas nėra panašus ar lygus ar palyginamas su Juo, ir Jis neturi jokių Savo partnerių)</span>. <span class="c5">[Nėra nieko panašaus į Jį ir Jis yra Visa Girdintis, Visa Matantis]</span>.} [Koranas, sūra „Marjam <span class="c2">(Marija)</span>“ 19:65]. </p>',
            ],
            10 => [
                'question' => '11 klausimas: kokia yra didžiausia nuodėmė?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/670.mp3',
                'answer' => '<p> Atsakymas: politeizmas <span class="c2">(širk)</span>.<span class="c6"><br /> Tarė Visagalis:</span> { Iš tiesų, Allahas neatleidžia to, kad Jam būtų priskirti partneriai <span class="c2">(garbinime)</span>, tačiau Jis atleidžia <span class="c2">(visa kita)</span>, išskyrus tai, tiems, kam Jis nori. Ir kas priskiria Allahui partnerius garbinime, jis iš tikrųjų prasimanė siaubingą nuodėmę.} <span class="c5">[Koranas,<span class="c6"> sūra „Moterys“ 4:</span>48]</span>. </p>',
            ],
            11 => [
                'question' => '12 Klausimas: paminėk politeizmo (širk) apibrėžimą ir jo tipus?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/710.mp3',
                'answer' => '<p> Atsakymas: politeizmas yra skirti bet kokį garbinimą ne Visagaliam Allahui.<span class="c6"><br /> Jo tipai yra:</span><br /> Didysis širk - kaip maldavimas kitam nei Allahui, nusilenkimas ne Allahui, aukojimas ne Allahui.<br /> Mažasis širk - kaip prisiekimas kitu, o ne Allahu, amuletų naudojimas, kurie yra dėvimi ar pakabinami, siekiant gauti naudos ar apsisaugoti nuo žalos, bei menkas puikavimasis, pavyzdžiui, tobulai meldžiantis kai žmonės žiūri. </p>',
            ],
            12 => [
                'question' => '13 Klausimas: ar kas nors žino paslėptus dalykus (ghaib), išskyrus Allahą?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/770.mp3',
                'answer' => '<p> Atsakymas: Allahas vienas žino paslėptus dalykus.<span class="c6"><br /> Tarė Visagalis:</span> { Sakyk: „Niekas danguose ir žemėje nežino Ghaib <span class="c2">(Nematomo)</span>, išskyrus Allahas, nei gali jie suvokti, kada jie bus prikelti.“} <span class="c5">[Koranas,<span class="c6"> sūra „Skruzdės“ 27:</span>65]</span>. </p>',
            ],
            13 => [
                'question' => '14 Klausimas: kiek tikėjimo (iman) ramsčių?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/810.mp3',
                'answer' => '<p> Atsakymas <span class="c2">(1)</span>: tikėjimas Visagaliu Allahu.<br /> <span class="c2">(2)</span>: Jo angelais.<br /> <span class="c2">(3)</span>: Jo Raštais.<br /> <span class="c2">(4)</span>: Jo pranašais.<br /> <span class="c2">(5)</span>: Paskutiniąja diena.<br /> <span class="c2">(6)</span>: likimo gėriu ir blogiu.<br /> Įrodymas yra žinomas Džibrilio chadisas, perduotas Achmed. Jame Džibrilis pasakė Pranašui <span class="c2">(ramybė ir Allaho palaima jam)</span>: „Pasakyk man apie tikėjimą <span class="c2">(iman)</span>.<span class="c6">“ Jis atsakė:</span> „Tai yra tikėti Allahu, Jo angelais, Jo Raštais, Jo pasiuntiniais ir Teismo diena, ir tikėti likimo gėriu ir blogiu.“ </p>',
            ],
            14 => [
                'question' => '15 Klausimas: paaiškink tikėjimo (iman) ramsčius?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/900.mp3',
                'answer' => '<p> Atsakymas: tikėti Visagaliu Allahu:<br /> § Kad Allahas yra Tas, kuris tave sukūrė ir pasirūpino, ir kad tik Allahas yra kūrinių reikalų Savininkas ir Tvarkytojas.<br /> § Kad Allahas yra Vienintelis vertas garbinimo ir niekas nėra vertas garbinimo, išskyrus Jį.<br /> § Kad Allahas yra Didysis ir Tobulas, visa šlovė Jam, Jis turi gražiausius vardus ir iškiliausias savybes, ir nėra Jam lygaus ar panašaus.<span class="c6"><br /> Tikėjimas angelais:</span><br /> Tai Allaho sukurtos būtybės iš šviesos, kad jie garbintų tik Jį ir visiškai paklustų Jo įsakymams.<br /> Tarp jų yra Gabrielius <span class="c2">(ramybė jam)</span>, kuris atneša apreiškimus pranašams.<span class="c6"><br /> Tikėjimas Raštais:</span><br /> Tai knygos, kurias Allahas atsiuntė Savo pasiuntiniams.<span class="c6"> Pavyzdžiui:</span><br /> - Koranas - Muchammedui <span class="c2">(ramybė ir Allaho palaima jam)</span>.<br /> - Evangelija - Isai <span class="c2">(Jėzui)</span> <span class="c2">(ramybė jam)</span>.<br /> - Tora - Mūsai <span class="c2">(Mozei)</span> <span class="c2">(ramybė jam)</span>.<br /> - Psalmės - Daūdui <span class="c2">(Dovydui)</span> <span class="c2">(ramybė jam)</span>.<br /> - Ibrahimo <span class="c2">(Abraomo)</span> ir Mozės Raštai.<span class="c6"><br /> Tikėjimas pasiuntiniais:</span><br /> Juos atsiuntė Visagalis Allahas savo tarnams, kad juos mokytų, skelbtų džiugią žinią apie gėrį ir rojų bei įspėtų nuo blogio ir pragaro ugnies.<br /> Geriausi iš jų yra stiprios dvasios <span class="c2">(ulū al-azm)</span>:<br /> Nūch <span class="c2">(Nojus)</span> <span class="c2">(ramybė jam)</span>.<br /> Ibrahim <span class="c2">(Abraomas)</span> <span class="c2">(ramybė jam)</span>.<br /> Mūsa <span class="c2">(Mozė)</span> <span class="c2">(ramybė jam)</span>.<br /> Isa <span class="c2">(Jėzus)</span> <span class="c2">(ramybė jam)</span>.<br /> Muchammedas <span class="c2">(ramybė ir Allaho palaima jam)</span>.<span class="c6"><br /> Tikėjimas Paskutiniąja diena:</span><br /> Tai tikėjimas tuo, kas atsitiks kape po mirties ir Prisikėlimo bei Atsiskaitymo dieną, kai rojaus gyventojai pateks į rojų, o pragaro - į pragarą.<span class="c6"><br /> Tikėjimas likimo gėriu ir blogiu:</span><br /> Tai tikėjimas, kad Allahas žino viską, kas vyksta visatoje, ką Jis anksčiau buvo įrašęs į Išsaugotą knygą <span class="c2">(Al-lauch al-machfūz)</span> ir ką norėjo sukurti bei įgyvendinti.<span class="c6"><br /> Tarė Visagalis:</span> { Iš tiesų, Mes sukūrėme viską su Kadar <span class="c2">(išankstiniu numatymu, planu, lemtimi, kuri prieš sukūrimą buvo užrašyta Lemties Knygoje Al-Lauch Al-Machfūz)</span>.} <span class="c5">[Koranas,<span class="c6"> sūra „Mėnulis“ 54:</span>49]</span>.<span class="c6"><br /> Likimas turi keturis lygius:</span><br /> Pirmas - Visagalio Allaho pažinimas - kad Jis viską žino prieš tai įvykstant ir po to.<span class="c6"><br /> To įrodymas yra Visagalio posakis:</span> { Iš tiesų, Allahas, pas Jį <span class="c2">(Vienintelį)</span> yra žinios apie Valandą, Jis nuleidžia lietų ir žino tai, kas yra gimdose. Nė vienas žmogus nežino, ką jis įgis rytoj, ir nė vienas žmogus nežino, kokioje žemėje jis mirs. Iš tiesų, Allahas yra Visa Žinantis, Visa Išmanantis apie viską.} <span class="c5">[Koranas,<span class="c6"> sūra „Lukman“ 31:</span>34]</span>.<br /> Antras - Allahas visa tai įrašė Išsaugotoje knygoje, joje yra viskas, kas buvo, yra ir bus.<span class="c6"><br /> To įrodymas yra Visagalio posakis:</span> { Ir pas Jį yra Ghaib <span class="c2">(viso, kas paslėpta)</span> raktai, niekas nežino jų, tik Jis. Ir Jis žino viską, kas yra žemėje ir jūroje. Nenukrenta lapas, apie kurį Jis nesužino. Nėra grūdo žemės tamsybėje, nei nieko šviežio ar sudžiuvusio, kas nebūtų įrašyta Aiškiame Įraše.} <span class="c5">[Koranas,<span class="c6"> sūra „Galvijai“ 6:</span>59]</span>.<br /> Trečias - viskas vyksta pagal Allaho valią ir viskas, ką Jis ir Jo kūriniai daro, neperžengia Jo valios ribų.<span class="c6"><br /> To įrodymas yra Visagalio posakis:</span> { tiems iš jūsų, kurie trokšta rinktis teisingą kelią. <span class="c2">(28)</span> Ir jūs netrokštate, išskyrus <span class="c2">(tada)</span>, kai trokšta Allahas, pasaulių Viešpats. <span class="c2">(29)</span>} <span class="c5">[Koranas, sūra ,,<span class="c6">Suvyniojimas“ 81:</span>28-29]</span>.<br /> Ketvirtas - tikėjimas, kad viską sukūrė Allahas. Jis sukūrė ir pačius kūrinius, ir jų savybes, ir veiksmus, ir viską, kas juose.<span class="c6"><br /> To įrodymas yra Visagalio posakis:</span> <span class="c4">{ „Kai Allahas sukūrė jus ir tai, ką jūs darote?“}</span> <span class="c5">[Koranas, sūra ,,<span class="c6">Išrikiuotieji lygiais“ 37:</span>96]</span>. </p>',
            ],
            15 => [
                'question' => '16 Klausimas: koks yra Korano apibrėžimas?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1300.mp3',
                'answer' => '<p> Atsakymas: tai Visagalio Allaho žodis, o ne kūrinys.<span class="c6"><br /> Tarė Visagalis:</span> { Ir jei kas nors iš Mušrikūn <span class="c2">(daugiadievių, stabmeldžių, pagonių, netikinčiųjų Allaho Vienumu)</span> prašys tavo apsaugos, tada suteik jam apsaugą tam, kad jis išgirstų Allaho Žodį <span class="c2">(Koraną)</span>,} <span class="c5">[Koranas, sūra ,,<span class="c6">Atgaila“ 9:</span>6]</span>. </p>',
            ],
            16 => [
                'question' => '17 Klausimas: kas yra suna?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1330.mp3',
                'answer' => '<p> Atsakymas: tai yra kiekvienas Pranašo posakis, poelgis, pritarimas, fizinė ar moralinė savybė <span class="c2">(ramybė ir Allaho palaima jam)</span>. </p>',
            ],
            17 => [
                'question' => '18 Klausimas: kas yra religinės naujovės (bida)? Ar turėtume jas priimti?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1350.mp3',
                'answer' => '<p> Atsakymas: tai viskas, ką žmonės įveda į religiją, kas neegzistavo Pranašo <span class="c2">(ramybė ir Allaho palaima jam)</span> ir jo kompanjonų laikais.<br /> * Mes neturėtume jų priimti, verčiau turėtume jas atmesti.<br /> Pagal Pranašo posakį <span class="c2">(ramybė ir Allaho palaima jam)</span>: ,,Kiekviena naujovė <span class="c2">(bida)</span> yra suklaidinimas.“ Perdavė Abu Daūd.<span class="c6"><br /> Religinių naujovių pavyzdžiai:</span> garbinimo papildymas, kaip apsiplovimo veiksmus kartoti keturis kartus bei Pranašo gimtadienio šventimas, apie kurį nepranešė nei jis <span class="c2">(ramybė ir Allaho palaima jam)</span>, nei jo kompanjonai. </p>',
            ],
            18 => [
                'question' => '19 Klausimas: paminėk Al-vala (ištikimybės) ir Al-bara (atsiribojimo) principus?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1410.mp3',
                'answer' => '<p> Atsakymas: Al-vala - reiškia mylėti ir palaikyti tikinčiuosius.<span class="c6"><br /> Tarė Visagalis:</span> { Tikintieji, vyrai ir moterys, yra vienas kito Aulyja <span class="c2">(padėjejai, rėmėjai, draugai, globėjai)</span>.} <span class="c5">[Koranas, sūra ,,<span class="c6">Atgaila“ 9:</span>71]</span>.<br /> Al-bara - reiškia nekęsti netikinčiųjų ir laikyti juos priešais.<span class="c6"><br /> Tarė Visagalis:</span> { Jau buvo jums <span class="c2">(pateiktas)</span> puikus Ibrahimo <span class="c2">(Abraomo)</span> ir tų, kurie su juo, pavyzdys,<span class="c6"> kai jie sakė savo žmonėms:</span> „Iš tiesų, mes atsiribojame nuo jūsų ir to, ką jūs garbinate kitą nei Allahas. Mes atmetėme jus ir tarp mūsų ir jūsų iškilo priešiškumas ir neapykanta amžiams, kol jūs patikėsite Allahą Vienintelį.“} <span class="c5">[Koranas, sūra ,,<span class="c6">Atgaila“ 60:</span>4]</span>. </p>',
            ],
            19 => [
                'question' => '20 Klausimas: ar Allahas priima kitą religiją, išskyrus islamą?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1480.mp3',
                'answer' => '<p> Atsakymas: islamas yra vienintelė religija, kurią priima Allahas.<span class="c6"><br /> Tarė Visagalis:</span> <span class="c4">{ Ir tas, kas ieško tikėjimo kito, nei islamas, tai niekada nebus priimta iš jo, o Amžinybėje jis bus vienas iš pralaimėtojų.}</span> <span class="c5">[Koranas, sūra ,,<span class="c6">Imrano giminė“ 3:</span>85]</span>. </p>',
            ],
            20 => [
                'question' => '21 Klausimas: netikėjimas (kufr) gali būti padarytas žodžiais, darbais ir įsitikinimais, duok pavyzdžių?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1520.mp3',
                'answer' => '<p> Atsakymas: netikėjimo, įvykdyto žodžiais, pavyzdys yra piktžodžiavimas prieš Visagalį Allahą arba Jo Pasiuntinį <span class="c2">(ramybė ir Allaho palaima jam)</span>.<br /> Netikėjimo, įvykdyti darbais, pavyzdys, yra Muschaf <span class="c2">(rašytinės Korano kopijos)</span> žeminimas arba nusilenkimas kitam, nei Allahui.<br /> Netikėjimo, įvykdyto įsitikinimais, pavyzdys yra tikėjimas, kad yra kažkas kitas vertas garbinimo šalia Allaho, arba kad yra kitas kūrėjas, išskyrus Allahą. </p>',
            ],
            21 => [
                'question' => '22 Klausimas: kas yra veidmainystė ir kokios jos rūšys?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1570.mp3',
                'answer' => '<p> Atsakymas:<br /> 1. Didžioji veidmainystė - reiškia slėpti netikėjimą, skelbiant tikėjimą.<br /> Ji patenka už islamo ribos ir laikoma dideliu netikėjimu.<span class="c6"><br /> Tarė Visagalis:</span> { Iš tiesų, veidmainiai bus Pragaro žemiausiame gylyje <span class="c2">(lygyje)</span>. Nerasite jiems jokių padėjėjų.} <span class="c5">[Koranas, sūra ,,<span class="c6">Moterys“ 4:</span>145]</span>.<br /> 2.<span class="c6"> Mažioji vaidmenystė:</span><br /> Pavyzdžiui - melas, pažadų nesilaikymas ir pasitikėjimo išdavystė.<br /> Šis veidmainystės tipas neišmeta žmogaus už islamo ribos, tačiau, tai yra nuodėmė, ir tas, kuris tai daro, patirs kankinimą.<br /> Tarė Allaho Pasiuntinys <span class="c2">(ramybė ir Allaho palaima jam)</span>: „Veidmainio požymiai yra trys: kalbėdamas jis meluoja, kai duoda pažadą - jį sulaužo, o kai jam patikėta - išduoda pasitikėjimą.“ Perdavė Al-Bukhari ir Muslim. </p>',
            ],
            22 => [
                'question' => '22 Klausimas: kas yra paskutinis iš pranašų ir pasiuntinių?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1680.mp3',
                'answer' => '<p> Atsakymas: Muchammedas <span class="c2">(ramybė ir Allaho palaima jam)</span>.<span class="c6"><br /> Tarė Visagalis:</span> <span class="c4">{ Muchammedas nėra nė vieno iš jūsų vyrų tėvas, tačiau jis yra Allaho Pasiuntinys ir paskutinis iš Pranašų.}</span> <span class="c5">[Koranas, sūra ,,<span class="c6">Sąjungininkai“ 33:</span>40]</span>. Tarė Allaho Pasiuntinys <span class="c2">(ramybė ir Allaho palaima jam)</span>: „Iš tiesų, aš esu paskutinis iš pranašų, ir po manęs pranašų nebebus.“ Perdavė Abu Daūd, At-Tirmizi ir kt. </p>',
            ],
            23 => [
                'question' => '24 Klausimas: kas yra stebuklas?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1730.mp3',
                'answer' => '<p> Atsakymas: stebuklas - tai kiekvienas antgamtinis veiksmas ar įvykis, kuriuo Visagalis Allahas palaikė savo pranašus, kad įrodytų jų teisingumą.<span class="c6"> Pavyzdžiai:</span><br /> Mėnulio padalijimas Pranašui <span class="c2">(ramybė ir Allaho palaima jam)</span>.<br /> Jūros padalijimas Mozei <span class="c2">(ramybė jam)</span> ir Faraono bei jo karių nuskandinimas. </p>',
            ],
            24 => [
                'question' => '25 Klausimas: kas yra kompanjonai? Ar turėčiau juos mylėti?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1780.mp3',
                'answer' => '<p> Atsakymas: kompanjonas yra tas, kuris sutiko Pranašą <span class="c2">(ramybė ir Allaho palaima jam)</span>, patikėjo juo ir mirė kaip musulmonas.<br /> Turime juos mylėti ir sekti jų pavyzdžiu, nes jie yra geriausi tarp žmonių po pranašų.<br /> Geriausi kompanjonai yra keturi kalifai,<span class="c6"> kurie yra:</span><br /> Abu Bakr <span class="c2">(tebūnie Allahas juo patenkintas)</span>.<br /> Umar <span class="c2">(tebūnie Allahas juo patenkintas)</span>.<br /> Uthman <span class="c2">(tebūnie Allahas juo patenkintas)</span>.<br /> Ali <span class="c2">(tebūnie Allahas juo patenkintas)</span>. </p>',
            ],
            25 => [
                'question' => '26 Klausimas: kas yra tikinčiųjų motinos?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1870.mp3',
                'answer' => '<p> Atsakymas: jos yra Pranašo <span class="c2">(ramybė ir Allaho palaima jam)</span> žmonos.<span class="c6"><br /> Tarė Visagalis:</span> { Pranašas yra arčiau tikinčiųjų nei jie patys sau, o jo žmonos yra jų <span class="c2">(tikinčiųjų)</span> motinos <span class="c2">(dėl pagarbos ir santuokos)</span>.} <span class="c5">[Koranas,<span class="c6"> sūra „Sąjungininkai“ 33:</span>6]</span>. </p>',
            ],
            26 => [
                'question' => '27 Klausimas: kokios yra mūsų pareigos Pranašo (ramybė ir Allaho palaima jam) šeimai (ahl al-bait)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1910.mp3',
                'answer' => '<p> Atsakymas: Pranašo šeima apima jo žmonas, jo palikuonis ir tikinčiuosius iš Banu Hašim ir Banu Al-Muttalib. Mūsų pareiga yra juos mylėti ir palaikyti, nekęsti tų, kurie jų nekenčia. </p>',
            ],
            27 => [
                'question' => '28 Klausimas: kokia mūsų pareiga musulmonų valdovams?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1940.mp3',
                'answer' => '<p> Atsakymas: mūsų pareiga musulmonų valdovų atžvilgiu yra gerbti juos, paklusti jiems <span class="c2">(kas nesusiję su nuodėme)</span>, nemaištauti prieš juos, melstis už juos ir asmeniškai patarti. </p>',
            ],
            28 => [
                'question' => '29 Klausimas: kokia yra tikinčiųjų buveinė?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1970.mp3',
                'answer' => '<p> Atsakymas: Rojus.<span class="c6"> Tarė Visagalis:</span> { Iš tiesų, Allahas įleis tuos, kurie tikėjo <span class="c2">(Allaho Vienumu)</span> ir darė gerus darbus, į sodus su žemumoje tekančiomis upėmis.} <span class="c5">[Koranas,<span class="c6"> sūra „Muchammedas“ 47:</span>12]</span>. </p>',
            ],
            29 => [
                'question' => '30 Klausimas: kokia yra netikinčiųjų buveinė?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2000.mp3',
                'answer' => '<p> Atsakymas: Pragaras.<span class="c6"> Tarė Visagalis:</span> <span class="c4">{ tada bijokite Ugnies, kurio pakuros yra žmonės ir akmenys, paruošti netikintiesiems.}</span> <span class="c5">[Koranas,<span class="c6"> sūra „Karvė“ 2:</span>24]</span>. </p>',
            ],
            30 => [
                'question' => '31 Klausimas: kas yra baimė? Kas yra viltis? Kokie yra įrodymai?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2020.mp3',
                'answer' => '<p> Atsakymas: baimė reiškia bijoti Allaho ir Jo bausmės.<br /> Viltis reiškia tikėtis Allaho atlygio, atleidimo ir gailestingumo.<span class="c6"><br /> Įrodymas yra Visagalio posakis:</span> { Tie, kurių jie šaukiasi [kaip Isa <span class="c2">(Jėzus)</span> - Marjam <span class="c2">(Marijos)</span> sūnus, Uzair <span class="c2">(Ezar)</span>, angelai] trokšta <span class="c2">(patys sau)</span> būdų pasiekti savo Viešpatį <span class="c2">(Allahą)</span>, kuris iš jūsų būtų arčiausiai. Ir jie [Isa <span class="c2">(Jėzus)</span>, Uzair <span class="c2">(Ezra)</span>, angelai ir kiti] tikisi Jo Gailestingumo ir bijo Jo bausmės. Iš tiesų, jūsų Viešpaties bausmė yra <span class="c2">(tai)</span> ko reikia bijoti!} <span class="c5">[Koranas,<span class="c6"> sūra „Nakties kelionė“ 17:</span>57]</span>.<span class="c6"> Tarė Visagalis:</span> { Paskelbk <span class="c2">(Muchammedai)</span> Mano vergams, kad tikrai Aš esu Dažnai Atleidžiantis, Gailestingiausiasis. <span class="c2">(49)</span> Ir kad Mano bausmė tikrai yra skausmingiausia kankynė. <span class="c2">(50)</span>} <span class="c5">[Koranas,<span class="c6"> sūra „Nakties kelionė“ 15:</span>49-50]</span>. </p>',
            ],
            31 => [
                'question' => '32 Klausimas: paminėk kai kuriuos Visagalio Allaho vardus ir savybes?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2070.mp3',
                'answer' => '<p> Atsakymas: Allahas, Viešpatis, Gailestingasis, Viską Girdintis, Matantis, Viską Žinantis, Viską Teikiantis, Amžinai Gyvenantis, Galingasis, ir kt. gražūs vardai ir didingos savybės. </p>',
            ],
            32 => [
                'question' => '33 Klausimas: paaiškink šiuos vardus.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2100.mp3',
                'answer' => '<p> Atsakymas: Allahas yra Dievas, Vienintelis vertas garbinimo, ir Jis neturi partnerių.<br /> Viešpats <span class="c2">(Ar-Rabb)</span> - tai reiškia Vienintelį Kūrėją, Savininką, Viską Teikiantį ir Rėmėją.<br /> Viską Girdintis - tai reiškia Tas, kurio klausa apima viską ir kuris girdi visus balsus, nepaisant jų skirtumų ir skirtingumų.<br /> Viską Matantis - tai reiškia Tas, Kuris mato viską, nesvarbu, mažas ar didelis.<br /> Viską Žinantis - tai reiškia Tas, kuris žino absoliučiai viską - praeitį, dabartį ir ateitį.<br /> Gailestingasis - tai reiškia Tas, kurio gailestingumas apima visus kūrinius ir visas gyvas būtybes, t. y. visi tarnai ir kūriniai yra Jo malonėje.<br /> Viską Teikiantis - tai reiškia Tas, kuris rūpinasi visomis būtybėmis, įskaitant žmones, džinus ir visas kitas gyvas būtybes.<br /> Amžinai Gyvenantis - tai reiškia Tas, kuris nemiršta, o visi Jo kūriniai miršta.<br /> Galingasis - tai reiškia Tas, kuris turi visą tobulumą ir didybę Savo varduose, savybėse ir poelgiuose. </p>',
            ],
            33 => [
                'question' => '34 Klausimas: kokia mūsų pareiga musulmonų mokslininkų atžvilgiu?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2210.mp3',
                'answer' => '<p> Atsakymas: turime mylėti juos ir kreiptis į juos su klausimais apie religiją, apie juos sakyti tik gera, o kas apie juos kalba blogai, elgiasi neteisingai.<span class="c6"><br /> Tarė Visagalis:</span> <span class="c4">{ Allahas išaukštins tuos, kurie iš jūsų tarpo patikėjo, ir tuos, kuriems buvo suteiktas išmanymas, laipsniais. Ir Allahas yra Visa Žinantis, apie tai, ką jūs darote.}</span> <span class="c5">[Koranas,<span class="c6"> sūra „Besiginčijančioji“ 58:</span>11]</span>. </p>',
            ],
            34 => [
                'question' => '35 Klausimas: kas yra Visagalio Alllaho sąjungininkai (aulija)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2240.mp3',
                'answer' => '<p> Atsakymas: jie yra dievobaimingi tikintieji.<span class="c6"><br /> Tarė Visagalis:</span> { Nėr abejonės, iš tiesų Allaho AulIja [t.y. tie, kurie tiki Allaho Vienumą ir labai bijo Allaho <span class="c2">(susilaiko nuo visų nuodėmių ir blogų darbų, kuriuos Jis uždraudė)</span>, ir labai myli Allahą <span class="c2">(atlieka visus gerus darbus, kuriuos Jis įsakė)</span>], nebus jiems baimės anei jie liūdės. <span class="c2">(62)</span> Tie, kurie patikėjo <span class="c2">(Allaho Vienumą – islamiškąjį monotiezmą)</span> ir labai bijodavo Allaho <span class="c2">(susilaikydami nuo blogų darbų ir nuodėmių ir darydami gerus teisingus darbus)</span>. <span class="c2">(63)</span>} [Koranas, sūra „Jūnus <span class="c2">(Jona)</span>“ 10:62-63]. </p>',
            ],
            35 => [
                'question' => '36 Klausimas: ar tikėjimas (iman) apima žodžius ir darbus?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2280.mp3',
                'answer' => '<p> Atsakymas: tikėjimas apima žodžius, darbus ir įsitikinimus. </p>',
            ],
            36 => [
                'question' => '37 Klausimas: ar tikėjimas didėja ir mažėja?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2310.mp3',
                'answer' => '<p> Atsakymas: tikėjimas didėja su paklusnumu Allahui ir mažėja atliekant nuodėmes.<span class="c6"><br /> Tarė Visagalis:</span> { Tikintieji yra tik tie, kurie, kai Allahas yra minimas, jaučia baimę savo širdyse, o kai Jo eilutės <span class="c2">(šis Koranas)</span> yra jiems recituojamas, jos <span class="c2">(t. y. eilutės)</span> padidina jų Tikėjimą ir jie pasitiki savo Viešpačiu <span class="c2">(Vieninteliu)</span>,} <span class="c5">[Koranas,<span class="c6"> sūra „Karo grobis“ 8:</span>2]</span>. </p>',
            ],
            37 => [
                'question' => '38 Klausimas: kas yra ichsan (tobulumas religijoje)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2350.mp3',
                'answer' => '<p> Atsakymas: garbinti Allahą taip, lyg Jį matytum, o jei nematai Jo, Jis mato tave. </p>',
            ],
            38 => [
                'question' => '39 Klausimas: kada Visagalis Allahas priima mūsų veiksmus?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2370.mp3',
                'answer' => '<p> Atsakymas: kai įvykdomos dvi sąlygos,<span class="c6"> kurios yra:</span><br /> 1 - Jei veiksmas su visu nuoširdumu skirtas Visagaliui Allahui.<br /> 2 - Jei veiksmas atitinka Pranašo suną <span class="c2">(ramybė ir Allaho palaima jam)</span>. </p>',
            ],
            39 => [
                'question' => '40 Klausimas: kas yra tavakkul (pasitikėjimas Allahu)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2420.mp3',
                'answer' => '<p> Atsakymas: tai reiškia pasikliauti Visagaliu Allahu, atnešant naudos ir išvengiant žalos, naudojant turimas priemones.<span class="c6"><br /> Tarė Visagalis:</span> <span class="c4">{ O kas pasikliauna Allahu - tam Jis pakankamas.}</span> <span class="c5">[Koranas,<span class="c6"> sūra „Skyrybos“ 65:</span>3]</span>.<br /> „tam Jis pakankamas“ - tai reiškia, kad Jis suteiks jam pakankamai. </p>',
            ],
            40 => [
                'question' => '41 Klausimas: kokia pareiga įsakyti gėrį ir uždrausti blogį?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2470.mp3',
                'answer' => '<p> Atsakymas: įsakyti gėrį - reiškia įpareigoti žmones paklusti Visagaliui, o uždrausti blogį - reiškia drausti žmonėms visas nuodėmes, kuriomis jie nepaklūsta Allahui.<span class="c6"><br /> Tarė Visagalis:</span> { Jūs <span class="c5">[tikri tikintieji islamiškuoju monoteizmu ir tikri Pranašo Muchammedo ir jo sunos pasekėjai]</span> esate geriausi žmonės, kada nors išauginti žmonijai. Jūs įsakote Al-Marūf <span class="c2">(t. y. islamiškąjį monoteizmą ir visa, ką islamas įsakė)</span> ir draudžiate Al-Munkar <span class="c2">(daugiadievystę, netikėjimą ir visa, ką islamas uždraudė)</span>, ir jūs tikite Allahą.} <span class="c5">[Koranas,<span class="c6"> sūra „Imrano giminė“ 3:</span>110]</span>. </p>',
            ],
            41 => [
                'question' => '42 Klausimas: kas yra Ahlus-sunna val-džama?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2510.mp3',
                'answer' => '<p> Atsakymas: tai tie žmonės, kurie eina Pranašo <span class="c2">(ramybė ir Allaho palaima jam)</span> ir jo kompanjonų keliu žodžiais, darbais ir įsitikinimais.<br /> Jie vadinami „Ahlus-sunna“ <span class="c2">(sunos žmonės)</span>, nes seka Pranašo <span class="c2">(ramybė ir Allaho palaima jam)</span> suna ir susilaiko nuo naujovių diegimo religijoje.<br /> „va al-džamaa“ <span class="c2">(grupė)</span> reiškia, kad jie susivienija tiesoje ir nėra joje susiskaldę. </p>',
            ],
        ],
        2 => [
            0 => [
                'question' => '1 Klausimas: kas yra apsivalymas (tahara)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2580.mp3',
                'answer' => '<p> Atsakymas: tahara reiškia apsivalymą nuo hadas <span class="c2">(ritualinės nešvaros)</span> ir khabas <span class="c2">(materialių nešvarumų)</span>.<br /> Apsivalymas nuo „khabas“ yra materialių nešvarumų pašalinimas nuo kūno, drabužių ar maldos vietos.<br /> Apsivalymas nuo „hadas“ daromas atliekant apsiplovimą <span class="c2">(vudu)</span> arba ghusl <span class="c2">(apsiprausimą)</span> tyru vandeniu, arba atliekant tajamum <span class="c2">(sausą apsiplovimą)</span>, jei vandens nėra arba sunku jį naudoti. </p>',
            ],
            1 => [
                'question' => '2 Klausimas: kaip reikėtų šalinti nadžasa (nešvarumus)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2630.mp3',
                'answer' => '<p> Atsakymas: plaunant vandeniu, kol taps švaru.<br /> Kalbant apie indus, iš kurių šuo valgė ar gėrė, jie plaunami septynis kartus, pirmą kartą - su žeme. </p>',
            ],
            2 => [
                'question' => '3 Klausimas: koks yra apsiplovimo (vudu) gėris?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2660.mp3',
                'answer' => '<p> Pranašas <span class="c2">(ramybė ir Allaho palaima jam)</span> pasakė: „Kai musulmonas <span class="c2">(kitaip, tikintysis)</span> atlieka vudu ir nusiplauna veidą, viskas, kas nuodėminga, į ką jis žiūrėjo savo akimis, nuteka nuo jo veido kartu su vandeniu <span class="c2">(arba kartu su paskutiniu vandens lašu)</span>. Kai jis nusiplauna rankas, kartu su vandeniu <span class="c2">(arba kartu su paskutiniu vandens lašu)</span>, visi nuodėmingi dalykai, kuriuos jis padarė savo rankomis, nukrenta. Kai jis plauna kojas, kartu su vandeniu <span class="c2">(arba kartu su paskutiniu vandens lašu)</span> nuo jo kojų nuteka viskas, kas nuodėminga, į ką jos ėjo, ir taip tęsiasi tol, kol jis tampa laisvas nuo nuodėmių.“ Perdavė Muslim. </p>',
            ],
            3 => [
                'question' => '4 Klausimas: kaip turėtume atlikti vudu?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2690.mp3',
                'answer' => '<p> Atsakymas: plauti rankas tris kartus.<br /> Tris kartus skalauti burną, įtraukti vandenį į nosį ir jį išpūsti - tris kartus.<br /> Skalauti burną <span class="c2">(madmada)</span> reiškia įsiurbti vandenį į burną, išskalauti ir išspjauti vandenį.<br /> Skalauti nosį <span class="c2">(istinšak)</span> reiškia įtraukti vandenį į nosį iš dešinės rankos.<br /> Išpūtimas <span class="c2">(istinsar)</span> reiškia, pasitelkiant kairę ranką, išpūsti vandenį, kuris buvo įsiurbtas į nosį.<br /> Nuplauti veidą tris kartus.<br /> Tris kartus plauti rankas, įskaitant alkūnes.<br /> Šlapiomis rankomis perbraukti per galvą nuo kaktos iki pakaušio ir atgal bei išvalyti ausis.<br /> Plauti kojas iki kulkšnių tris kartus.<br /> Tai yra pats tobuliausias apsiprausimo būdas ir taip Pranašas <span class="c2">(ramybė ir Allaho palaima jam)</span> darė, kaip pranešta Al-Bukhari ir Muslim autentiškuose chadisuose, kuriuos perdavė Usman, Abdullah Ibn Zaid ir kiti. Taip pat buvo autentiškai pranešta nuo Pranašo <span class="c2">(ramybė ir Allaho palaima jam)</span> Sachych Al-Bukhari rinkinyje ir kt., kad jis kartais vieną kartą, o kartais ir du kartus plaudavo kiekvieną atitinkamą kūno dalį, atlikdamas vudu. </p>',
            ],
            4 => [
                'question' => '5 Klausimas: kokie yra privalomi vudu veiksmai? Kiek jų yra?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2810.mp3',
                'answer' => '<p> Atsakymas: privalomi vudu veiksmai yra tie, dėl kurių apsiplovimas tampa negaliojantis, jei vienas iš jų yra praleistas.<span class="c6"> Jie yra:</span><br /> 1 - Veido plovimas, apimantis burnos skalavimą ir vandens įtraukimą į nosį.<br /> 2 - Rankų, įskaitant alkūnes, plovimas.<br /> 3 - Perbraukimas per galvą, įskaitant ausų valymą.<br /> 4 - Pėdų plovimas iki kulkšnių.<br /> 5 - Numatyto eiliškumo palaikymas pirmiausia plaunant veidą, po to rankas, tada perbraukiant galvą, galiausiai nuplaunant kojas.<br /> 6 -<span class="c6"> Veiksmų tęstinumas:</span> tarp veiksmų neturėtų būti tokių laiko tarpų, per kuriuos nuplautos kūno dalys spėtų išdžiūti.<br /> Pavyzdžiui, žmogus atlieka pusę vudu ir po kurio laiko jį pabaigia - toks apsiplovimas negalioja. </p>',
            ],
            5 => [
                'question' => '6 Klausimas: kokia yra apsiplovimo suna (rekomenduojami veiksmai)? Kiek jų yra?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2910.mp3',
                'answer' => '<p> Atsakymas: rekomenduojami apsiplovimo veiksmai yra tie veiksmai, kuriuos atlikus, atlygis didėja, o neatlikus nėra nuodėmės ir vudu galioja.<span class="c6"> Jie yra:</span><br /> 1 - Sakyti bismillah <span class="c2">(vardan Allaho)</span>.<br /> 2 - Naudoti sivak <span class="c2">(dantų valymo šakelę)</span>.<br /> 3 - Plauti delnus.<br /> 4 - Plauti tarpupirščius.<br /> 5 - Plauti kūno dalis antrą ir trečią kartą.<br /> 6 - Pirmiausia pradėti nuo dešiniųjų kūno dalių.<br /> 7 -<span class="c6"> Po apsiplovimo ištarti šį zikr:</span> „Liudiju, kad nėra jokio kito dievo, išskyrus Allahą, kuris neturi partnerių, ir liudiju, kad Muchammedas yra Jo tarnas bei Pasiuntinys <span class="c2">(Ašhadu allia iliaha illa-llah ua ašhadu anna Muchammadan abduhu ua rasūluh)</span>.“<br /> 8 - Dviejų maldos rakatų atlikimas po vudu. </p>',
            ],
            6 => [
                'question' => '7 Klausimas: kokie yra vudu anuliuojantys veiksniai?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3020.mp3',
                'answer' => '<p> Atsakymas: - viskas, kas išeina iš dviejų privačių kūno dalių, t.y., šlapimas, išmatos ar dujos.<br /> - Miegas, beprotybė arba sąmonės netekimas.<br /> - Kupranugarių mėsos valgymas.<br /> - Tiesioginis privačių kūno dalių lietimas, be barjero. </p>',
            ],
            7 => [
                'question' => '8 Klausimas: kas yra tajamum (sausas apsiplovimas)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3080.mp3',
                'answer' => '<p> Atsakymas: tai žemės paviršiaus naudojimas apsivalymui, kai nėra vandens arba negalima jo panaudoti. </p>',
            ],
            8 => [
                'question' => '9 Klausimas: kaip atlikti tajamum?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3110.mp3',
                'answer' => '<p> Atsakymas: vieną kartą paliečiant žemę delnais ir nusišluostant veidą bei išorines rankų dalis. </p>',
            ],
            9 => [
                'question' => '10 Klausimas: kokie yra tajamum anuliuojantys veiksniai?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3140.mp3',
                'answer' => '<p> Atsakymas: - tie patys kaip ir vudu anuliuojantys veiksniai.<br /> Taip pat kai atsiranda galimybė naudoti vandenį. </p>',
            ],
            10 => [
                'question' => '11 Klausimas: kas yra khuffain ir džauvarib? Ar leidžiama per juos perbraukti atliekant vudu?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3180.mp3',
                'answer' => '<p> Atsakymas: khuffain - odinės kojinės.<br /> - Džauvarib - kojinės, kurios yra pagamintos ne iš odos.<br /> Leidžiama per jas <span class="c2">(khuffain ir džauvarib)</span> perbraukti atliekant vudu, vietoj kojų plovimo. </p>',
            ],
            11 => [
                'question' => '12 Klausimas: kokia yra khuffain perbraukimo išmintis?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3230.mp3',
                'answer' => '<p> Atsakymas: palengvinimas žmonėms, ypač šaltu oru ar kelyje, kai sunku nusimauti kojines ar nusiauti batus apsiprausimui. </p>',
            ],
            12 => [
                'question' => '13 Klausimas: kokios yra khuffain braukimo galiojimo sąlygos?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3260.mp3',
                'answer' => '<p> Atsakymas: 1 - Jas užsimauti būnant tyrumo būsenoje, t.y., po vudu atlikimo.<br /> 2 - Khuffain turi būti švarios, nes negalima šluostyti to, kas nešvaru.<br /> 3 - Khuffain turi dengti visas pėdas, įskaitant kulkšnis.<br /> 4 - Galima perbraukti griežtai apibrėžtam laikotarpiui. Jei nekeliaujama, tai vieną dieną, o jei keliajama, tada tris dienas. </p>',
            ],
            13 => [
                'question' => '14 Klausimas: kaip perbraukti per khuffain?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3320.mp3',
                'answer' => '<p> Atsakymas: šlapiais pirštais braukti nuo kojų pirštų iki blauzdos, dešine ranka perbraukti per dešinę koją, o kaire ranka - per kairę. Perbraukimo metu rankų pirštai turi būti praskėsti ir tai turi būti atliekama vieną kartą, nekartojant. </p>',
            ],
            14 => [
                'question' => '15 Klausimas: kas anuliuoja braukimą per khuffain?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3350.mp3',
                'answer' => '<p> Atsakymas: 1 - Pasibaigus konkretaus perbraukimo laiko trukmei,<span class="c6"> po to per jas braukti nebegalima:</span> nekeliautojui dieną ir naktį, o keliautojui - tris dienas ir tris naktis <span class="c2">(esamas reikia pakeisti naujomis khuffain)</span>.<br /> 2 - Nusimovus khuffain arba vieną iš jų. </p>',
            ],
            15 => [
                'question' => '16 Klausimas: kokia yra maldos reikšmė?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3390.mp3',
                'answer' => '<p> Atsakymas: malda yra Allaho garbinimas tam tikrais žodžiais ir veiksmais, pradedant su takbir ir baigiant su taslim <span class="c2">(atsisveikinimu)</span>. </p>',
            ],
            16 => [
                'question' => '17 Klausimas: ar malda yra privaloma?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3420.mp3',
                'answer' => '<p> Atsakymas: malda yra kiekvieno musulmono pareiga <span class="c2">(fard)</span>.<span class="c6"><br /> Tarė Visagalis:</span> { Iš tiesų, As-Salat <span class="c2">(malda)</span> yra įsakyta tikintiesiems nustatytomis valandomis.} <span class="c5">[Koranas,<span class="c6"> sūra „Moterys“ 4:</span>103]</span>. </p>',
            ],
            17 => [
                'question' => '18 Klausimas: koks yra maldos neatlikimo nuosprendis?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3460.mp3',
                'answer' => '<p> Atsakymas: maldos atsisakymas reiškia netikėjimą <span class="c2">(kufr)</span>, kaip Pranašas <span class="c2">(ramybė ir Allaho palaima jam)</span> pasakė:<br /> „Sandora <span class="c2">(kuri atskiria)</span> tarp mūsų ir jų <span class="c2">(netikinčiųjų)</span> yra malda; taigi, kas jos atsisako, iš tikrųjų atliko netikėjimo veiksmą <span class="c2">(kufr)</span>.“<br /> Perdavė Achmed, At-Tirmizi ir kiti. </p>',
            ],
            18 => [
                'question' => '19 Klausimas: kiek kartų per dieną musulmonas turi melstis? Iš kiek rakatų sudaryta kiekviena malda?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3500.mp3',
                'answer' => '<p> Atsakymas: musulmonas meldžiasi penkis kartus per dieną: fadžr malda - du rakatai, zuhr - keturi, asr - keturi, maghrib - trys, iša - keturi. </p>',
            ],
            19 => [
                'question' => '20 Klausimas: kokios yra maldos sąlygos?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3530.mp3',
                'answer' => '<p> Atsakymas: 1 - islamo priėmimas, nes netikinčiojo malda negalioja.<br /> 2 - Sveikas protas, nes išprotėjusio žmogaus malda negalioja.<br /> 3 - Sąmonė, nes sąmoningo amžiaus nesulaukusio vaiko malda negalioja.<br /> 4 - Ketinimas.<br /> 5 - Nustatyto maldos laiko pradžia.<br /> 6 - Tyrumas, t.y. hadas <span class="c2">(ritualinės nešvaros)</span> pašalinimas.<br /> 7 - Tyrumas nuo nešvarumų.<br /> 8 - Privačių dalių <span class="c2">(auros)</span> uždengimas.<br /> 9 - Atsigręžimas į kiblą <span class="c2">(Kaabos kryptį)</span>. </p>',
            ],
            20 => [
                'question' => '21 Klausimas: kokie yra maldos ramsčiai?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3640.mp3',
                'answer' => '<p> Atsakymas: tai keturiolika ramsčių,<span class="c6"> kurie yra:</span><br /> 1 - Stovėti privalomoje maldoje, jei įmanoma.<br /> 2 - Ištarti atidarantį takbir <span class="c2">(t.y. sakyti Allahu akbar)</span>.<br /> 3 - Recituoti sūrą „Atveriančioji“ <span class="c2">(Al-Faticha)</span>.<br /> 4 - Nusilenkti <span class="c2">(rukū)</span> tiesia nugara galvos lygyje.<br /> 5 - Pakilti iš nusilenkimo.<br /> 6 - Stovėti tiesiai.<br /> 7 - Pulti kniūbsčia <span class="c2">(sudžiūd)</span> - tai yra kaktos, nosies, delnų, kelių ir kojų pirštų galų padėjimas ant žemės nusilenkiant.<br /> 8 - Pakilti iš sukniūbimo.<br /> 9 - Sėdėti tarp dviejų sukniūbimų <span class="c2">(sudžiūdų)</span>.<br /> Suna yra sėdėti ant kairės pėdos, dešinę pėdą laikant tiesiai, sulenktais pirštais, kad jie būtų nukreipti į kiblą.<br /> 10 - Romumas atliekant kiekvieną veiksmą.<br /> 11 - Ištarti paskutinį tašahud.<br /> 12 - Sėdėti tašahud ištarimo metu.<br /> 13 - Sakyti du taslim <span class="c2">(atsisveikinimus)</span>, tai yra du kartus ištarti - „Assalamu alaikum va rahmatul-lah“.<br /> 14 - Palaikyti numatytą ramsčių tvarką, kaip minėta anksčiau. Taigi, jei žmogus tyčia puola kniūbsčia <span class="c2">(sudžud)</span> prieš nusilenkdamas <span class="c2">(rukū)</span>, jo malda negalioja. Tačiau jei tai padarys netyčia, jis turi grįžti atgal ir pirmiausia nusilenkti, o tada puolti kniūbsčia. </p>',
            ],
            21 => [
                'question' => '22 Klausimas: kokie yra privalomi maldos veiksmai?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3820.mp3',
                'answer' => '<p> Atsakymas: jų yra aštuoni:<br /> 1 - Ištarti visus takbir, įskaitant atidaromąjį.<br /> 2 - Su imamu ir vienam besimeldžiančiam sakyti „samijal-lahu liman hamidah <span class="c2">(Allahas girdi, kas Jį giria)</span>.“<br /> 3 - Sakyti „rabbana va lakal-hamd <span class="c2">(Viešpatie, visa šlovė priklauso Tau)</span>.“<br /> 4 - Sakyti „subhana rabijal-azim <span class="c2">(Šlovė mano Viešpačiui, Didingajam)</span>“ vieną kartą nusilenkiant <span class="c2">(per ruku)</span>.<br /> 5 - Sakyti „subhana rabijal-ala <span class="c2">(Šlovė mano Viešpačiui, Aukščiausiajam)</span>“ vieną kartą puolant kniūbsčia <span class="c2">(per sudžud)</span>.<br /> 6 - Sakyti „rabigh-firli <span class="c2">(Viešpatie, atleisk man)</span>“ tarp dviejų sudžiūd.<br /> 7 - Ištarti pirmąjį tašahud.<br /> 8 - Sėdėti per pirmąjį tašahud. </p>',
            ],
            22 => [
                'question' => '23 Klausimas: kokie yra maldos rekomenduojami veiksmai (suna)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3930.mp3',
                'answer' => '<p> Atsakymas: jų yra vienuolika:<br /> 1) Sakyti po įžanginio <span class="c2">(ihram)</span> takbir,<span class="c6"> istiftah takbir:</span> „subhanakal-lahumma ua bi-hamdika, ua tabarakas-mu-ka, ua tala džaduka, ua lia iliaha ghairuk <span class="c2">(Šlovė tau, o Allah, Palaimintas Tavo vardas, Tavo didybė yra aukščiau už viską, ir nėra jokio kito dievo, išskyrus Tave)</span>.“<br /> 2 - Ištarti tavuz <span class="c2">(t.y.,<span class="c6"> sakyti:</span> aūzu billahi minaš-šajtanir-radžim)</span> <span class="c2">(ieškau prieglobsčio pas Allahą nuo prakeikto šėtono)</span>.<br /> 3 - Ištarti basmala <span class="c2">(t.y.,<span class="c6"> sakyti:</span> bismil-liahir-rahmanir-rahim)</span> <span class="c2">(Vardan Allaho Maloningojo, Gailestingojo)</span>.<br /> 4 - Sakyti amyn.<br /> 5 - Recituoti sūrą „Atveriančioji“ <span class="c2">(Al-Fatiha)</span>.<br /> 6 - Imamas turi garsiai recituoti.<br /> 7 - Sakyti po tahmid <span class="c2">(Allaho šlovinimo)</span>: mil-as-samauti va mil-al-ard va mil-a ma ši-ta min šaj-in bad <span class="c2">(dangaus, žemės ir bet ko kito pripildymas)</span>.<br /> 8 - Ištarti daugiau negu vieną tasbih <span class="c2">(t.y., sakyti subhana rabijal-azim)</span> per ruku, - tarti du kartus, tris ar daugiau.<br /> 9 - Ištarti daugiau negu vieną tasbih per sudžud <span class="c2">(t.y., sakyti subhana rabijal-ala)</span>.<br /> 9 - Ištarti „rabigh-firli“ daugiau negu vieną kartą tarp dviejų sudžiūd.<br /> 11 - Pranašo ir jo šeimos palaiminimų ir sveikinimų <span class="c2">(ramybė jiems)</span> tarimas paskutiniame tašahud ir maldauti <span class="c2">(dua)</span> po to.<span class="c6"><br /> Ketvirta:</span> rekomenduojami maldos fiziniai veiksmai <span class="c2">(suna)</span> vadinami „Al-haj-at“,<span class="c6"> jie yra:</span><br /> 1 - Rankų pakėlimas atidarymo takbir metu.<br /> 2 - Rankų pakėlimas nusilenkimo metu.<br /> 2 - Rankų pakėlimas kylant iš nusilenkimo.<br /> 4 - Rankų nuleidimas po to.<br /> 5 - Dešinės rankos uždėjimas ant kairės<br /> 6 - Žiūrėti į vietą žemėje, kurią paliečia galva per sudžiūd.<br /> 7 - Stovint palikti tarpą tarp pėdų.<br /> 8 - Rankų padėjimas išskėstais pirštais ant kelių nusilenkimo metu ir tiesinant nugarą taip, kad galva būtų vienoje linijoje su nugara.<br /> 9 - Sudžud kūno dalis remti į žemę, tuo pačiu užtikrinti, kad visos jos liestųsi su žeme.<br /> 10 - Alkūnes patraukti nuo šonų, pilvą nuo šlaunų, o šlaunis nuo blauzdų. Taip pat išskėsti kelius, vertikaliai pastatyti pėdas, delnais liesti žemę. Dėti rankas priešais pečius ištiestais ir suglaustais pirštais.<br /> 11 - Sėdėti iftiraš pozicijoje <span class="c2">(kairės kojos ištiesimas ir sėdėjimas ant jos, dešinės pėdos pastatymas vertikaliai, kad pirštai būtų nukreipti į kiblą)</span> tarp dviejų sudžiūd ir pirmame tašahud. Taip pat sėdėti tauvaruk pozicijoje <span class="c2">(maldininkas ištiesia kairę koją, padeda dešinę pėdą vertikaliai, kad abi būtų dešinėje pusėje, o sėdmenys būtų prispausti prie žemės)</span> per antrą tašahhud.<br /> 12 - Uždėti ištiestas rankas ant šlaunų suglaustais pirštais tarp dviejų sudžiūd, o per tašahud sugniaužti dešinės rankos mažąjį ir bevardį pirštus, darant žiedą nykščiu ir viduriniu pirštais, o minint Allahą rodyti rodomuoju pirštu.<br /> 13 - Atsisveikinant veidą pasukti į dešinę, paskui į kairę. </p>',
            ],
            23 => [
                'question' => '24 Klausimas: kiek yra maldos anulatorių?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4210.mp3',
                'answer' => '<p> Atsakymas: 1 - Praleisti vieną iš maldos ramsčių ar sąlygų.<br /> 2 - Kalbėti tyčia.<br /> 3 - Valgyti ar gerti.<br /> 4 - Dažnai ir nuolatos judėti.<br /> 5 - Tyčia praleisti vieną iš privalomų maldos veiksmų. </p>',
            ],
            24 => [
                'question' => '25 klausimas: kaip musulmonas turėtų atlikti maldą?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4280.mp3',
                'answer' => '<p> Atsakymas: melstis reikia taip:<br /> 1 - Maldininkas visu kūnu stovi tiesiai pasisukdamas į kiblą, nenukrypdamas nuo jos ir nesisukiodamas.<br /> 2 - Turı intenciją atlikti tam tikrą maldą, ne žodžiais, o širdyje.<br /> 3 - Ištaria atidarymo takbir, keldamas rankas iki pečių lygio.<br /> 4 - Dešinį delną uždeda ant kairės rankos po krūtine.<br /> 5 -<span class="c6"> Ištaria istiftach:</span> „Allahumma ba-id baini va baina khataja kama ba-ata bajnal-mašriki val-maghrib, allahumma nakkini min khataja kama junakka as-subul-abjadu minad-danasi, allahumma-ghsilni min khatajaja bil ma-i vas-saldži val-barad“ <span class="c2">(O Allahe, atskirk mane nuo mano nuodėmių, kaip atskyrei Rytus nuo Vakarų. O Allahe, apvalyk mane nuo mano nuodėmių, kaip baltą drabužį išvalytą nuo dėmių. O Allahe, nuplauk mano nuodėmes vandeniu, ledu ir kruša)</span>.<span class="c6"><br /> Arba sako:</span> „subhanaka Allahuma va bihamdik, va tabarakas-muk, va tala džaduk, va lia iliaha ghajruk <span class="c2">(Garbė Tau, o Allahe ir šlovė Tau, palaimintas Tavo vardas ir išaukštinta Tavo didybė, ir nėra kito dievo, išskyrus Tave)</span>.“<br /> 6 - Prašo Allaho apsaugos,<span class="c6"> sakydamas:</span> „Auzu billiahi minaš-šaitanir-radžim <span class="c2">(Ieškau prieglobsčio pas Allahą nuo prakeikiamojo šėtono)</span>.“ 7 - Tada sako bismillah ir recituoja sūrą „Atveriančioji“ <span class="c2">(al-Fatiha)</span>: { Vardan Allaho, Maloningojo, Gailestingojo <span class="c2">(1)</span> Visa šlovė ir dėkingumas - Allahui, pasaulių <span class="c2">(alamyn - žmonijos, džinų ir visa, kas egzistuoja)</span> Viešpačiui <span class="c2">(2)</span> Maloningiausiajam, Gailestingiausiajam <span class="c2">(3)</span> Atpildo Dienos <span class="c2">(t. y. Prikėlimo dienos)</span> Vieninteliam Valdytojui <span class="c2">(ir Vieninteliam Teisėjui)</span> <span class="c2">(4)</span> Tave <span class="c2">(Vienintelį)</span> mes garbiname ir Tavęs <span class="c2">(Vienintelio)</span> mes prašome pagalbos <span class="c2">(5)</span> Vesk mus Tiesiu keliu <span class="c2">(6)</span> Keliu tų, kuriems Tu suteikei Savo Malonę, bet ne tų, kurie užsitraukė Tavo Pyktį <span class="c2">(kaip judėjai)</span>, ir ne tų, kurie nuklydo <span class="c2">(kaip krikščionys)</span>. <span class="c2">(7)</span> } <span class="c5">[Koranas,<span class="c6"> sūra „Atveriančioji“ 1:</span>1-7]</span>.<span class="c6"><br /> Po to sako:</span> amyn, t.y., o Allahe, atsakyk į prašymą.<br /> 8 - Tada recituoja kiek gali iš Korano, ir ilgiau recituoja fadžr maldoje.<br /> 9 - Po to nusilenkia Visagaliui taip Jį išaukštindamas, tardamas takbyr ir pakeldamas rankas prie pečių. Suna yra ištiesti nugarą taip, kad galva ir nugara būtų viename lygyje, ir dėti rankas išskėstais pirštais ant kelių.<br /> 10 - Nusilenkdamas <span class="c2">(ruku)</span> sako: „subhana rabijal-azim <span class="c2">(Šlovė mano Viešpačiui, Didingajam)</span>“ - tris kartus.<span class="c6"> Jei dar sako:</span> „subhanaka Allahuma va bihamdik, allahuma ghfirli <span class="c2">(Palaimintas Tu, o Allahe, Šlovė Tau. O Allahe, atleisk man)</span>“, tai yra gerai.<br /> 11 -<span class="c6"> Pakyla nuo nusilenkimo sakydamas:</span> „tegul Allahas išgirsta tuos, kurie Jį giria <span class="c2">(sami Allahu liman hamida)</span>“ ir pakelia rankas iki pečių lygio. O tas,<span class="c6"> kuris meldžiasi vadovaujamas imamo vietoj šių žodžių sako:</span> „Viešpatie, šlovė tau <span class="c2">(rabana va lakal hamd)</span>“.<br /> 12 -<span class="c6"> Pakilęs iš ruku sako:</span> „koks tobulas yra Allahas, Šlovė Jam; ir aš garbinu Jį sulig Jo kūrinių skaičiumi, ir sulig Jo pasitenkinimu <span class="c2">(rabana va lakal hamd mil-assamavati va mil al-ardi va mila ma šita min šaj-in bad)</span>.“<br /> 13 -<span class="c6"> Tada atlieka pirmą sudžud sakydamas:</span> „Allahu akbar <span class="c2">(Allahas yra Didžiausias)</span>“,<span class="c6"> remdamasis ant septynių sudžud kūno dalių:</span> kaktos, nosies, delnų, kelių ir pėdų galų. Alkūnes atitraukdamas nuo šonų, neliečiant dilbiais žemės, o pirštus dėdamas taip, kad jie būtų nukreipti į kiblą.<br /> 14 -<span class="c6"> Puldamas kniūbsčia sako:</span> „Išaukštintas yra mano Viešpats, Aukščiausiasis <span class="c2">(subhana rabbijal-ala)</span>“ tris kartus,<span class="c6"> o jei priduria:</span> „Išaukštintas tu, o Allahe, mūsų Viešpatie, ir šlovė tau, atleisk man <span class="c2">(subhanaka Allahuma, rabana va bihamdik, allahuma ghfirli)</span>, tai yra gerai.<br /> 15 -<span class="c6"> Po to pakelia galvą nuo sudžud sakydamas:</span> „Allahu akbar <span class="c2">(Allahas yra Didžiausias)</span>“.<br /> 16 - Paskui pakelia galvą, tardamas takbir ir atsisėda ant kairės kojos, dešinę pėdą statydamas vertikaliai. Tuo pat metu deda rankas ant šlaunų. Tada sugniaužia mažąjį ir bevardį pirštą, o nykštį ir vidurinį pirštą sujungia žiedu, tardamas maldą ištiesia rodomąjį pirštą ir jį judina.<br /> 17 -<span class="c6"> Sėdėdamas tarp dviejų sudžud sako:</span> „Rabi ghfirli va rhamni va hdini va rzukni va džburni va afini <span class="c2">(Viešpatie, atleisk man, pasigailėk manęs, nukreipk mane tiesiu keliu, suteik man paveldėjimą, palaikyk mane ir suteik gerovę)</span>.“<br /> 18 - Atlieka antrąjį sudžud tardamas takbir ir sakydamas bei darydamas viską taip pat, kaip ir pirmajame.<br /> 19 - Pakyla iš antrojo sudžud ir stovi,<span class="c6"> sakydamas:</span> „Allahu akbar“. Tada atlieka antrąjį rakatą, lygiai taip, kaip pirmąjį, išskyrus tai, kad jis neskaito istiftah.<br /> 20 - Po antrojo nusilenkimo antrajame rakate jis ištaria takbir ir lieka sėdėti taip pat, kaip ir tarp dviejų sudžud.<br /> 21 -<span class="c6"> Ištaria pirmąjį tašahud sakydamas:</span> „At-tahijatu lilliahi va salavatu va tajibat, as-salamu alaika aijuhan-nabiju va rahmatullahi va barakatuh, as-salamu alaina va ala ibadillahi salihin, aš-hadu ala ilaha ill Allah va aš-hadu ana Muchammadan abduhu va rasuluh. Allahuma salli ala Muchammed, va ala ali Muchammed, kama salaita ala Ibrahim, va ala ali Ibrahim, inaka hamidun madžid, va barik ala Muchammed, va ala ali Muchammed, kama barakta ala Ibrahim, va ala ali Ibrahim, inaka hamidun madžid. Auzu billahi min azabi džahanam, va min azabil-kabr, va min fitnatil-mahja val-mamat, va min fintnatil-masihi dadžal. <span class="c2">(Sveikinimai Allahui, maldos ir geri darbai. Taika tau, Pranaše, ir Allaho gailestingumas bei palaiminimai. Taika mums ir teisiems Allaho tarnams. Liudiju, kad nėra jokių kitų garbinimo vertų dievybių, išskyrus Allahą, ir liudiju kad Muchammedas yra Jo tarnas bei Pasiuntinys. O Allahe, siųsk maldas už Pranašą Muchammedą ir jo šeimą lygiai taip, kaip siuntei maldas už Abraomą ir jo šeimą; iš tiesų, Tu esi vertas šlovinimo ir garbės. O, Allahe, palaimink Pranašą Muchammedą ir jo šeimą, kaip kad palaiminai Abraomą ir jo šeimą. Iš tiesų, Tu esi vertas šlovinimo ir garbės. Aš ieškau prieglobsčio pas Allahą nuo pragaro ir kapo kančių, nuo gyvenimo ir mirties išbandymų bei nuo Al-Masih Ad-Dadžal (netikrojo Mesijo)</span> išbandymų.)“ Paskui gali prašyti Allaho visko, ko tik nori iš šio ir būsimo pasaulių gėrio.<br /> 22 -<span class="c6"> Po to pasuka galvą į dešinę sakydamas:</span> „as salamu alaikum va rahmatullah <span class="c2">(taika ir Allaho gailestingumas jums)</span>“, tada pasuka galvą į kairę ir ištaria tuos pačius žodžius.<br /> 23 - Jei tai yra trijų ar keturių rakatų malda,<span class="c6"> tada pirmasis tašahud turėtų baigtis ties sakymu:</span> „ašhadu ala ilaha illa Allah va ašhadu ana Muchammadan abduhu va rasulu <span class="c2">(Liudiju, kad nėra jokio kito dievo, išskyrus Allahą, ir liudiju, kad Muchammedas yra Jo tarnas bei Pasiuntinys)</span>.“<br /> 24 -<span class="c6"> Atsistoja sakydamas:</span> „Allahu akbar“ ir pakelia rankas taip, kad jos būtų vienoje linijoje su pečiais.<br /> 25 - Tada daro viską taip pat, kaip ir antrame rakate, tačiau trečiajame ir ketvirtajame rakate apsiriboja sūros „Atveriančioji“ recitavimu.<br /> 26 - Sėdi tavaruk pozicijoje, dešinę pėdą laikydamas stačią, kairiąją pėdą ištiesdamas po dešine koja, sėdmenis remdamas į žemę ir rankas uždėdamas ant šlaunų taip pat, kaip ir pirmajame tašahud.<br /> 27 - Sėdėdamas šioje pozicijoje ištaria visą tašahud.<br /> 28 - Ištaria taslim <span class="c2">(atsisveikina)</span> į dešinę,<span class="c6"> sakydamas:</span> „as-salamu alaikum va rahmatullah <span class="c2">(Allaho taika ir gailestingumas jums)</span>“, tada į kairę. </p>',
            ],
            25 => [
                'question' => '26 Klausimas: kokie (zikr) žodžiai sakomi pasibaigus maldai (po taslim)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4610.mp3',
                'answer' => '<p> Atsakymas: - „astaghfirullah <span class="c2">(prašau Allaho atleidimo)</span>“ - tris kartus.<br /> - „Allahuma anta salam, va minka salam, tabarakta ja zal-džalali va al-ikram <span class="c2">(O Allahe, Tu esi Tobulas, o iš Tavęs kyla gerovė, Palaimintas Tu, didybės ir dosnumo Turėtojau)</span>.“<br /> - „La ilaha illa Allah vahdahu la šarika lahu, lahu al-mulku va lahu al-hamd va huva ala kuli šaj-in kadir, Allahuma la mania lima atajta va la mutija lima manata va la janfa-u zal-džadi mink al-džad <span class="c2">(Nėra jokio kito dievo, išskyrus Allahą, Vieną be partnerių. Jam priklauso valdžia ir šlovė, ir Jis yra Visagalis. O Allahe, niekas neatims to, ką Tu davei, ir niekas nedovanos to, ką atėmei. Ir savininko turtas bus bevertis prieš Tave)</span>.“<br /> - „La ilaha illa Allahu vahdahu la šarika lah, lahu al-mulku va lahu al-hamd va huva ala kuli šaj-in kadir, la haula va la kuvata illa billah, la ilaha illa Allah, va la na-budu illa ijah, lahun-ni-matu va lahul-fadl, va lahu azana-ul-hasan, la ilaha illa Allah mukhlisina Allahu din va lau karihal-kafirun <span class="c2">(Nėra jokio kito dievo, išskyrus Allahą, Vieną be partnerių. Jam priklauso valdžia ir šlovė, ir Jis yra Visagalis. Nėra jokios jėgos ar dievo, išskyrus Allahą, ir mes negarbiname nieko kito, išskyrus Jį. Jam priklauso gėris, gailestingumas ir gražus pagyrimas. Nėra jokio kito dievo, išskyrus Allahą, mes skiriame religiją tik Jam, net jei jos nekenčia netikintieji)</span>.“<br /> - „Subhanallah <span class="c2">(Tebūna Išaukštintas Allahas)</span>“ - trisdešimt tris kartus.<br /> - „Alhamdulillah <span class="c2">(Šlovė Allahui)</span>“ - trisdešimt tris kartus.<br /> - „Allahu akbar <span class="c2">(Allahas yra Didžiausias)</span>“ - trisdešimt tris kartus.<br /> Tada, kad užbaigtų šimtą,<span class="c6"> sakyti:</span> „La ilaha illa Allahu vahdahu la šarika lah, lahu al-mulku va lahu al-hamd va huva ala kuli šaj-in kadir (Nėra jokio kito dievo, išskyrus Allahą, Vieną be partnerių. Jam priklauso valdžia ir šlovė, ir Jis yra Visagalis.“<br /> - Recituoti sūrą „Visiškas atsidavimas“, „Aušra“ ir „Žmonės“ tris kartus po fadžr ir maghrib maldų ir vieną kartą po kitų maldų.<br /> - Recituoti „Al-Kursi“ ajatą vieną kartą. </p>',
            ],
            26 => [
                'question' => '27 Klausimas: kokios yra sunna maldos, atliekamos prieš ir po privalomųjų maldų? Ir koks yra atlygis už jas?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4730.mp3',
                'answer' => '<p> Atsakymas: - du rakatai prieš fadžr maldą.<br /> - Keturi rakatai prieš zuhr maldą.<br /> - Du rakatai po zuhr maldos.<br /> - Du rakatai po maghrib maldos.<br /> - Du rakatai po iša maldos.<br /> Kalbant apie atlygį, Pranašas <span class="c2">(ramybė ir Allaho palaima jam)</span> pasakė: „Allahas pastato namą Rojuje tam, kuris per vieną dieną ir naktį pasimeldžia dvylika neprivalomų rakatų.“ Perdavė Muslim, Ahmed ir kiti. </p>',
            ],
            27 => [
                'question' => '28 Klausimas: kokia yra geriausia savaitės diena?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4800.mp3',
                'answer' => '<p> Atsakymas: penktadienis, kaip pasakė Pranašas <span class="c2">(ramybė ir Allaho palaima jam)</span>: „Iš tiesų, penktadienis yra viena iš geriausių jūsų dienų. Tai diena, kai Adamas <span class="c2">(Adomas)</span> buvo sukurtas ir diena, kai jis mirė. Tai diena, kai bus pučiamas Trimitas ir bus smūgis. Taigi, siųskite man kuo daugiau palaiminimų tą dieną, nes jūsų palaiminimai pasieks mane.<span class="c6">“ Žmonės paklausė:</span> „O Allaho Pasiuntiny, kaip tave pasieks mūsų palaiminimai,<span class="c6"> kai tavo kūnas bus jau suiręs?“ Jis atsakė:</span> „Allahas uždraudė žemei praryti pranašų kūnus.“ Perdavė Abu Davud ir kiti. </p>',
            ],
            28 => [
                'question' => '29 Klausimas: koks yra religinis sprendimas dėl penktadienio maldos?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4840.mp3',
                'answer' => '<p> Atsakymas: tai yra kiekvieno musulmono vyro, sulaukusio pilnametystės, esančio sveiko proto ir nesančio kelyje, pareiga.<span class="c6"><br /> Tarė Visagalis:</span> {O jūs, kurie tikite <span class="c2">(musulmonai)</span>. Kai skelbiamas kvietimas Salat <span class="c2">(maldai)</span> penktadienį <span class="c2">(Džuma maldai)</span>, ateikite į Allaho prisiminimą [Džumos religinį pamokslą <span class="c2">(Khutba)</span> ir Salat <span class="c2">(maldą)</span>] ir palikite prekybą <span class="c2">(ir visus kitus dalykus)</span>. Tai geriau jums, jei tik žinotumėte.} [Koranas, sūra „Džuma <span class="c2">(Penktadienis)</span>“ 62:9] </p>',
            ],
            29 => [
                'question' => '30 Klausimas: kiek yra rakatų penktadienio (džuma) maldoje?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4880.mp3',
                'answer' => '<p> Atsakymas: džuma maldą sudaro du rakatai, per kuriuos imamas garsiai recituoja Koraną, ir prieš kuriuos yra du pamokslai <span class="c2">(khutba)</span>. </p>',
            ],
            30 => [
                'question' => '31 Klausimas: ar leidžiama nedalyvauti džuma maldoje?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4910.mp3',
                'answer' => '<p> Atsakymas: tai neleistina, išskyrus šariato patvirtintą pateisinimą. Pranašas <span class="c2">(ramybė ir Allaho palaima jam)</span> pasakė: „Kas dėl aplaidumo praleidžia tris penktadienio maldas, Allahas uždeda antspaudą ant jo širdies.“ Perdavė Abu Davud ir kiti. </p>',
            ],
            31 => [
                'question' => '32 Klausimas: įvardyk penktadienį rekomenduojamus sunna veiksmus:',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4940.mp3',
                'answer' => '<p> Atsakymas:<br /> 1 - Atlikti ghusl <span class="c2">(apsiprausti)</span>.<br /> 2 - Naudoti kvepalus.<br /> 3 - Dėvėti geriausius drabužius.<br /> 4 - Anksti eiti į mečetę.<br /> 5 - Siųsti daugiau palaiminimų Pranašui.<br /> 6 - Recituoti sūrą „Urvas“ <span class="c2">(Al-Kahf)</span>.<br /> 7 - Eiti pėščiomis į mečetę.<br /> 8 - Siekti išnaudoti laikotarpį, kai atsakoma malda <span class="c2">(dua)</span>. </p>',
            ],
            32 => [
                'question' => '33 Klausimas: koks yra kolektyvinės (džama) maldos nuopelnas?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5050.mp3',
                'answer' => '<p> Atsakymas: Abdullah Ibn Umar <span class="c2">(tebūnie Allahas jais patenkintas)</span> pranešė, kad Pasiuntinys <span class="c2">(ramybė ir Allaho palaima jam)</span> pasakė: „Kolektyvinė malda <span class="c2">(džama)</span> yra dvidešimt septyniais laipsniais geriau nei melstis vienam.“ Perdavė Muslim. </p>',
            ],
            33 => [
                'question' => '34 Klausimas: kas yra nuolankumas (khušu) maldoje?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5080.mp3',
                'answer' => '<p> Atsakymas: tai reiškia širdies susikaupimą ir kūno ramybę atliekant maldą.<span class="c6"><br /> Tarė Visagalis:</span> { Sėkmingi iš tiesų yra tikintieji. <span class="c2">(1)</span> Tie, kurie atlieka savo Salat <span class="c2">(maldas)</span> visiškai rimtai ir pilnu nuolankumu. <span class="c2">(2)</span> <span class="c5">[Koranas,<span class="c6"> sūra „Tikintieji“ 23:</span>1-2]</span> </p>',
            ],
            34 => [
                'question' => '35 Klausimas: koks yra zakat apibrėžimas?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5120.mp3',
                'answer' => '<p> Atsakymas: tai yra teisė į tam tikros rūšies turtą, kuri turi būti suteikta tam tikrai žmonių grupei konkrečiu laiku.<br /> Tai vienas iš islamo ramsčių ir privaloma labdara, kuri paimama iš turtingųjų ir atiduodama vargšams.<span class="c6"><br /> Tarė Visagalis:</span> <span class="c4">{ ir duokite Zakat}</span> <span class="c5">[Koranas,<span class="c6"> sūra „Karvė“ 2:</span>43]</span>. </p>',
            ],
            35 => [
                'question' => '36 Klausimas: kokia yra rekomenduojama (mustahab) labdara (sadaka)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5170.mp3',
                'answer' => '<p> Atsakymas: tai skiriasi nuo zakato, nes labdarai galima dovanoti bet ką, bet kokiam geram tikslui.<span class="c6"><br /> Tarė Visagalis:</span> { Ir išleiskite vardan Allaho <span class="c2">(t. y. visų rūšių Džihadas)</span>} <span class="c5">[Koranas,<span class="c6"> sūra „Karvė“ 2:</span>195]</span>. </p>',
            ],
            36 => [
                'question' => '37 Klausimas: koks yra pasninko apibrėžimas?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5210.mp3',
                'answer' => '<p> Atsakymas: tai reiškia garbinti Allahą, susilaikant nuo pasninko anuliatorių nuo aušros iki saulėlydžio, tuo pačiu turint ketinimą pasninkauti.<span class="c6"> Jis yra dviejų tipų:</span><br /> Pirma - privalomas pasninkas, pavyzdžiui, pasninkas Ramadano mėnesį, kuris yra vienas iš islamo ramsčių.<span class="c6"><br /> Tarė Visagalis:</span> { O jūs, kurie tikite! As-Saum <span class="c2">(pasninko)</span> laikymasis yra nurodytas jums, kaip jis buvo nurodytas tiems, iki jūsų, tam, kad galėtumėte tapti Al-Mutakūn <span class="c2">(dievobaimingaisiais)</span> } <span class="c5">[Koranas,<span class="c6"> sūra „Karvė“ 2:</span>183]</span>.<br /> Antra - savanoriškas pasninkas, pavyzdžiui, pasninkauti pirmadieniais ir ketvirtadieniais kiekvieną savaitę, ar tris dienas kiekvieną mėnesį, iš kurių geriausios yra kiekvieno mėnulio mėnesio „baltosios“ dienos <span class="c2">(13, 14, 15 dienos)</span>. </p>',
            ],
            37 => [
                'question' => '38 Klausimas: koks yra Ramadano mėnesio pasninko atlygis?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5270.mp3',
                'answer' => '<p> Atsakymas: Abu Hurairah <span class="c2">(tebūnie Allahas juo patenkintas)</span> pranešė, kad Pasiuntinys <span class="c2">(ramybė ir Allaho palaima jam)</span> pasakė: „Kas pasninkauja Ramadaną su tikėjimu ir tikisi atpildo iš Allaho, jo praeities nuodėmės bus atleistos.“ Mutafakun alaih <span class="c2">(pagal du didžius mokslininkus Al-Bukhari ir Muslim kaip „bendrai sutartas“)</span>. </p>',
            ],
            38 => [
                'question' => '39 Klausimas: koks yra savanoriško pasninko atlygis?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5300.mp3',
                'answer' => '<p> Atsakymas: Abu Said Al-Khudri <span class="c2">(tebūnie Allahas juo patenkintas)</span> pranešė, kad Pasiuntinys <span class="c2">(ramybė ir Allaho palaima)</span> pasakė: „Kas pasninkauja dieną dėl Allaho, už tą dieną Allahas saugos jo veidą nuo Pragaro Ugnies atstumu kaip septyniasdešimt rudenių.“ Mutafakun alaih <span class="c2">(pagal du didžius mokslininkus Al-Bukhari ir Muslim kaip „bendrai sutartas“)</span>.<span class="c6"><br /> „Septyniasdešimt rudenių“ reiškia:</span> septyniasdešimt metų. </p>',
            ],
            39 => [
                'question' => '40 Klausimas: kokie veiksmai anuliuoja pasninką?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5330.mp3',
                'answer' => '<p> Atsakymas: 1 - tyčia valgyti ar gerti.<br /> 2 - Tyčia vemti.<br /> 3 - Islamo atmetimas. </p>',
            ],
            40 => [
                'question' => '41 Klausimas: kokie yra rekomenduojami pasninko veiksmai (sunna)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5380.mp3',
                'answer' => '<p> Atsakymas: 1 - skubėti nutraukti pasninką.<br /> 2 - Suhur <span class="c2">(valgymas prieš aušrą)</span> ir jo suvėlinimas kiek tik įmanoma.<br /> 3 - Aktyviai atlikti gerus darbus ir garbinimus.<br /> 4 -<span class="c6"> Sakyti:</span> „aš pasninkauju“, jei pasninkautojas įžeidinėjamas.<br /> 5 - Maldauti <span class="c2">(dua)</span> pasninko nutraukimo metu.<br /> 6 - Pasninko nutraukimas šviežiomis ar džiovintomis datulėmis, o jeigu jų nėra, vandeniu. </p>',
            ],
            41 => [
                'question' => '42 Klausimas: koks yra hadžo (piligriminės kelionės) apibrėžimas?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5460.mp3',
                'answer' => '<p> Atsakymas: hadž reiškia garbinti Visagalį Allahą, lankantis Jo namuose ir atliekant tam tikrus ritualus tam tikru metu.<span class="c6"><br /> Tarė Visagalis:</span> { Ir Hadžas <span class="c2">(piligriminė kelionė į Mekką)</span> į Namą <span class="c2">(Kaabą)</span> yra pareiga, kurią žmonija turi Allahui, tiems, kurie išgali išlaidas <span class="c2">(nuvykimo, prasimaitinimo ir apsistojimo)</span>. Ir tas, kuris netiki, tada Allahui nereikia nė vieno iš Alamyn <span class="c2">(žmonijos, džinų ir viso, kas egzistuoja)</span>.} <span class="c5">[Koranas,<span class="c6"> sūra „Imrano giminė“ 3:</span>97]</span>. </p>',
            ],
            42 => [
                'question' => '43 Klausimas: kiek yra hadžo ramsčių?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5500.mp3',
                'answer' => '<p> Atsakymas: 1 - ihram <span class="c2">(įėjimas į ritualinę pasišventimo būseną)</span>.<br /> 2 - Stovėjimas prie Arafa.<br /> 3 - Tavaf al-ifada <span class="c2">(apeiti Kaabą)</span> atlikimas.<br /> 4 - Atlikti Sai <span class="c2">(vaikščioti sparčiu žingsniu)</span> tarp Safa ir Marva kalnų. </p>',
            ],
            43 => [
                'question' => '44 Klausimas: koks yra hadžo atlygis?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5560.mp3',
                'answer' => '<p> Atsakymas: Abu Hurairah <span class="c2">(tebūnie Allahas juo patenkintas)</span> pranešė, kad Pasiuntinys <span class="c2">(ramybė ir Allaho palaima jam)</span> pasakė: „Tas, kuris atlieka hadžą, nepasakydamas ir nepadarydamas nieko netinkamo, grįš toks pat švarus nuo nuodėmių, koks buvo tą dieną, kai motina jį pagimdė.“ Perdavė Al-Bukhari ir kiti.<br /> „koks buvo tą dieną, kai motina jį pagimdė.“ t. y. laisvas nuo nuodėmių. </p>',
            ],
            44 => [
                'question' => '45 Klausimas: koks yra umros apibrėžimas?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5600.mp3',
                'answer' => '<p> Atsakymas: umra - <span class="c2">(mažoji piligrimystė)</span> reiškia Visagalio Allaho garbinimą, apsilankant Jo Namuose <span class="c2">(Kaaboje)</span> ir bet kuriuo metu atliekant konkrečius ritualus. </p>',
            ],
            45 => [
                'question' => '46 Klausimas: kokie yra umros ramsčiai?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5630.mp3',
                'answer' => '<p> Atsakymas: 1 - ihram <span class="c2">(įėjimas į ritualinę pasišventimo būseną)</span>.<br /> 2 - Tavaf <span class="c2">(Kaabos apėjimas)</span>.<br /> 3 - Sai <span class="c2">(vaikščiojimas sparčiu žingsniu)</span> tarp Safa ir Marva kalnų. </p>',
            ],
            46 => [
                'question' => '47 Klausimas: kas yra džihadas vardan Allaho?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5690.mp3',
                'answer' => '<p> Atsakymas: tai reiškia dėti visas pastangas skleidžiant islamą ir ginant jį bei muslmonus arba kovojant su islamo priešais.<span class="c6"><br /> Tarė Visagalis:</span> <span class="c4">{ ir stenkitės stipriai savo turtu ir savo gyvybėmis vardan Allaho. Tai geriau jums, jei tik jūs žinotumėte.}</span> <span class="c5">[Koranas, sūra ,,<span class="c6">Atgaila“ 9:</span>41]</span>. </p>',
            ],
        ],
        3 => [
            0 => [
                'question' => '1 Klausimas: kokia yra mūsų Pranašo Muchammedo (ramybė ir Allaho palaima jam) kilmė?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5740.mp3',
                'answer' => '<p> Atsakymas: jis yra Muchammed Ibn Abdullah Ibn Abdul-Mutalib Ibn Hašim. Hašim buvo iš Kuraiš genties. Ši gentis buvo iš arabų, o arabai yra pranašo Ismailo - pranašo Ibrahimo sūnaus, palikuonys <span class="c2">(ramybė ir Allaho palaima jiems)</span>. </p>',
            ],
            1 => [
                'question' => '2 Klausimas: koks mūsų Pranašo motinos vardas?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5770.mp3',
                'answer' => '<p> Atsakymas: Amina Bint Vahab. </p>',
            ],
            2 => [
                'question' => '3 Klausimas: kada mirė jo tėvas?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5800.mp3',
                'answer' => '<p> Atsakymas: jo tėvas mirė Medinoje prieš gimstant Muchammedui <span class="c2">(ramybė ir Allaho palaima jam)</span>. </p>',
            ],
            3 => [
                'question' => '4 Klausimas: kada gimė Pranašas (ramybė ir Allaho palaima jam)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5830.mp3',
                'answer' => '<p> Atsakymas: jis gimė Al-Fil metais, pirmadienį, Rabi al-Aval mėnesį. </p>',
            ],
            4 => [
                'question' => '5 Klausimas: kur jis gimė?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5850.mp3',
                'answer' => '<p> Atsakymas: Mekkoje. </p>',
            ],
            5 => [
                'question' => '6 Klausimas: kas, be motinos, juo rūpinosi ir maitino?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5880.mp3',
                'answer' => '<p> Atsakymas: - Umm Aiman, jo tėvo tarnaitė.<br /> - Suaiba, jo dėdės Abu Lahab tarnaitė.<br /> - Halima As-Sadija. </p>',
            ],
            6 => [
                'question' => '7 Klausimas: kada mirė jo motina?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5930.mp3',
                'answer' => '<p> Atsakymas: jo motina mirė, kai jam buvo šešeri, o po to juo rūpinosi senelis Abdul-Mutalib. </p>',
            ],
            7 => [
                'question' => '8 Klausimas: kas juo rūpinosi po senelio Abdul-Mutalib mirties?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5960.mp3',
                'answer' => '<p> Atsakymas: kai jam buvo aštuoneri, mirė jo senelis ir juo rūpinosi dėdė Abu Talib. </p>',
            ],
            8 => [
                'question' => '9 Klausimas: kada jis keliavo su savo dėde į Levantą?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5990.mp3',
                'answer' => '<p> Atsakymas: jis su dėde keliavo į Levantą, kai jam buvo dvylika metų. </p>',
            ],
            9 => [
                'question' => '10 Klausimas: kada buvo jo antroji kelionė?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6020.mp3',
                'answer' => '<p> Atsakymas: jis antrą kartą išvyko į prekybą su Hadidžos pinigais <span class="c2">(tebūnie Allahas ja patenkintas)</span>. Grįžęs vedė ją, kai jam buvo dvidešimt penkeri metai. </p>',
            ],
            10 => [
                'question' => '11 Klausimas: kada Kuraiš žmonės atstatė Kaabą?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6050.mp3',
                'answer' => '<p> Atsakymas: Kuraišai atstatė Kaabą, kai jam buvo trisdešimt penkeri metai.<br /> Nesutarę, kas grąžins Juodąjį akmenį į vietą, jie paklausė Pranašo sprendimo. Taigi, jis uždėjo akmenį ant audinio gabalo ir įsakė kiekvienai iš keturių genčių laikyti po vieną audinio kampą. Tada, kai jie jį pakėlė, Pranašas <span class="c2">(ramybė ir Allaho palaima jam)</span> rankomis įstatė jį į vietą. </p>',
            ],
            11 => [
                'question' => '12 Klausimas: kiek jam buvo metų, kai jam buvo paskirta pranašystės misija? Kam jis buvo pasiųstas?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6080.mp3',
                'answer' => '<p> Atsakymas: jam buvo keturiasdešimt metų ir buvo pasiųstas kaip džiugios žinios nešėjas ir kaip perspėjimas visiems žmonėms. </p>',
            ],
            12 => [
                'question' => '13 Klausimas: kaip prasidėjo apreiškimas (vahi)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6110.mp3',
                'answer' => '<p> Atsakymas: viskas prasidėjo nuo tikrojo regėjimo: kiekvienas sapnas, įvyko realybėje lygiai taip, kaip jis matė. </p>',
            ],
            13 => [
                'question' => '14 Klausimas: ką jis veikė prieš apreiškimą? Kada jam buvo atsiųstas pirmasis apreiškimas?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6140.mp3',
                'answer' => '<p> Atsakymas: jis garbino Allahą Hira oloje,<br /> ir apreiškimas nusileido jam esant oloje tokioje būsenoje. </p>',
            ],
            14 => [
                'question' => '15 Klausimas: kokios buvo pirmosios, jam atskleistos, Korano eilutės?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6180.mp3',
                'answer' => '<p> Atsakymas: Allaho žodžiai: { Recituok! Vardan Viešpaties, Kuris sukūrė, - <span class="c2">(1)</span> sukūrė žmogų iš prikibusios medžiagos. <span class="c2">(2)</span> Recituok! Ir tavo Viešpats yra Dosniausiasis, <span class="c2">(3)</span> Kuris išmokė rašikliu - <span class="c2">(4)</span> išmokė žmogų tai, ko jis nežinojo. <span class="c2">(5)</span>} <span class="c5">[Koranas, sūra ,,<span class="c6">Kraujo krešulėlis“ 96:</span>1-5]</span>. </p>',
            ],
            15 => [
                'question' => '16 Klausimas: kas pirmasis patikėjo jo žinia?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6200.mp3',
                'answer' => '<p> Atsakymas: pirmasis, kuris patikėjo jo žinia iš vyrų yra Abu Bakr As-Sidik, iš moterų - Hadidža Bint Khuvailid, iš berniukų - Ali Ibn Abi Talib, iš išlaisvintų vergų - Zaid Ibn Harisa, ir iš vergų - Bilal al-Habaši <span class="c2">(tebūnie Allahas jais patenkintas)</span>, ir kiti. </p>',
            ],
            16 => [
                'question' => '17 Klausimas: kaip buvo vykdoma daua (kvietimas) į islamą?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6230.mp3',
                'answer' => '<p> Atsakymas: dava islamui buvo vykdoma slapta beveik trejus metus. Tada Pranašui <span class="c2">(ramybė ir Allaho palaima jam)</span> buvo įsakyta viešai kviesti žmones į islamą. </p>',
            ],
            17 => [
                'question' => '18 Klausimas: kokia buvo Pranašo (ramybė ir Allaho palaima jam) ir tų, kurie juo tikėjo, padėtis pradėjus viešai kviesti į islamą?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6260.mp3',
                'answer' => '<p> Atsakymas: politeistai pradėjo skaudžiai skriausti jį ir musulmonus, kol jiems buvo suteiktas leidimas emigruoti pas Abisinijos karalių - Negu.<br /> Politeistai vienbalsiai sutiko nužudyti Pranašą, nepaisant to, Allahas jį saugojo ir palaikė su dėde Abu Talib, kad apgintų jį nuo jų. </p>',
            ],
            18 => [
                'question' => '19 Klausimas: kas mirė dešimtaisiais metais nuo Pranašo misijos pradžios?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6300.mp3',
                'answer' => '<p> Atsakymas: jo dėdė Abu Talib ir jo žmona Hadidža <span class="c2">(tebūnie Allahas ja patenkintas)</span>. </p>',
            ],
            19 => [
                'question' => '20 Klausimas: kada vyko Isra (naktinė kelionė į Jeruzalę) ir Miradž (pakilimas į dangų)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6330.mp3',
                'answer' => '<p> Atsakymas: tai įvyko, kai Pranašui <span class="c2">(ramybė ir Allaho palaima jam)</span> buvo penkiasdešimt metų. Šioje kelionėje buvo nurodyta atlikti penkias kasdienines maldas.<br /> Isra - kelionė nuo Al-Haram mečetės iki Al-Aksa mečetės.<br /> Miradž - pakilimas iš Aksa mečetės į dangų, prie Sidratul-Muntaha. </p>',
            ],
            20 => [
                'question' => '21 Klausimas: kaip Pranašas (ramybė ir Allaho palaima jam) kvietė žmones į islamą už Mekkos ribų?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6380.mp3',
                'answer' => '<p> Atsakymas: jis kviesdavo Taif žmones į islamą ir prisistatydavo žmonėms susibūrimo metu, kol atvyko pas Ansar <span class="c2">(rėmėjus)</span> iš Medinos žmonių ir jie prisiekė ištikimybę jį palaikyti. </p>',
            ],
            21 => [
                'question' => '22 Klausimas: kiek laiko Pranašas (ramybė ir Allaho palaima jam) išbuvo Mekkoje kviesdamas į islamą?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6410.mp3',
                'answer' => '<p> Atsakymas: jis ten išbuvo trylika metų. </p>',
            ],
            22 => [
                'question' => '23 Klausimas: kur Pranašas emigravo?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6440.mp3',
                'answer' => '<p> Atsakymas: emigravo iš Mekkos į Mediną. </p>',
            ],
            23 => [
                'question' => '24 Klausimas: kiek laiko išbuvo Medinoje?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6470.mp3',
                'answer' => '<p> Atsakymas: dešimt metų. </p>',
            ],
            24 => [
                'question' => '25 Klausimas: kokie islamo įstatymai buvo nustatyti jam būnant Medinoje?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6490.mp3',
                'answer' => '<p> Atsakymas: zakatas, pasninkas, hadžas, džihadas, azanas <span class="c2">(kvietimas į maldą)</span> ir kt. </p>',
            ],
            25 => [
                'question' => '26 Klausimas: kokie yra jo svarbiausi mūšiai?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6520.mp3',
                'answer' => '<p> Atsakymas: - Badr mūšis.<br /> - Uhud mūšis.<br /> - Al-Ahzab mūšis.<br /> - Mekkos užkariavimo mūšis. </p>',
            ],
            26 => [
                'question' => '27 Klausimas: kokia yra paskutinė apreikšta Korano eilutė?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6580.mp3',
                'answer' => '<p> Allaho žodžiai: <span class="c4">{ Ir bijokite Dienos, kai būsite sugrąžinti pas Allahą. Tada kiekvienam bus atlyginta už tai, ką jis įgijo, ir su jais nebus elgiamasi neteisingai.}</span> <span class="c5">[Koranas,<span class="c6"> sūra „Karvė“ 2:</span>281]</span>. </p>',
            ],
            27 => [
                'question' => '28 Klausimas: kada mirė Pranašas (ramybė ir Allaho palaima jam)? Kiek jam buvo metų?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6610.mp3',
                'answer' => '<p> Atsakymas: mirė Rabi Al-Aval mėnesį, vienuoliktais Hidžra metais, kai jam buvo šešiasdešimt treji metai. </p>',
            ],
            28 => [
                'question' => '29 Klausimas: kas buvo Pranašo (ramybė ir Allaho palaima jam) žmonos?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6640.mp3',
                'answer' => '<p> Atsakymas: 1 - Hadidža Bint Khuvailid <span class="c2">(tebūnie Allahas ja patenkintas)</span>.<br /> 2 - Sauda Bint Zama <span class="c2">(tebūnie Allahas ja patenkintas)</span>.<br /> 3 - Aiša Bint Abi Bakr As-Sidik <span class="c2">(tebūnie Allahas ja patenkintas)</span>.<br /> 4 - Hafsa Bint Umar <span class="c2">(tebūnie Allahas ja patenkintas)</span>.<br /> 5 - Zainab Bint Khuzaima <span class="c2">(tebūnie Allahas ja patenkintas)</span>.<br /> 6 - Umm Salama Hind Bint Abi Umaja <span class="c2">(tebūnie Allahas ja patenkintas)</span>.<br /> 7 - Umm Habiba Ramla Bint Abi Sufjan <span class="c2">(tebūnie Allahas ja patenkintas)</span>.<br /> 8 - Džuvairija Bint Al-Haris <span class="c2">(tebūnie Allahas ja patenkintas)</span>.<br /> 8 - Maimuna Bint Al-Haris <span class="c2">(tebūnie Allahas ja patenkintas)</span>.<br /> 10 - Safija Bint Hujaj <span class="c2">(tebūnie Allahas ja patenkintas)</span>.<br /> 11 - Zainab Bint Džahš <span class="c2">(tebūnie Allahas ja patenkintas)</span>. </p>',
            ],
            29 => [
                'question' => '30 Klausimas: Kas yra jo vaikai (ramybė ir Allaho palaima jam)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6760.mp3',
                'answer' => '<p> Atsakymas: trys sūnūs:<br /> - Al-Kasim, kurio vardu jis buvo pramintas „Abu Al-Kasim“.<br /> - Abdullah.<br /> - Ibrahim.<span class="c6"><br /> Dukros:</span><br /> - Fatima.<br /> - Rukaja.<br /> - Umm Kulsum.<br /> - Zainab.<br /> Visi jo vaikai buvo iš Khadidžos <span class="c2">(tebūnie Allahas ja patenkintas)</span>, išskyrus Ibrahim. Jie visi mirė anksčiau jo, išskyrus Fatimą, kuri mirė praėjus šešiems mėnesiams po jo <span class="c2">(Pranašo)</span> mirties. </p>',
            ],
            30 => [
                'question' => '31 Klausimas: Paminėk kai kurias fizines Pranašo savybes (ramybė ir Allaho palaima jam).',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6880.mp3',
                'answer' => '<p> Atsakymas: Jis buvo vidutinio ūgio, nei per žemas ir nei per aukštas. Jis turėjo baltą veido spalvą, kuri buvo šiek tiek rausva. Jis turėjo vešlią barzdą, dideles akis ir plačią burną. Jo plaukai buvo itin juodi, pečiai platūs, kvapas malonus, bei turėjo kitas gražias savybes. </p>',
            ],
            31 => [
                'question' => '32 Klausimas: kokiame stovyje Pranašas (ramybė ir Allaho palaima jam) paliko savo tautą?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6910.mp3',
                'answer' => '<p> Atsakymas: Jis paliko savo tautą <span class="c2">(ummą)</span> aiškiame kelyje, kurio naktis giedra kaip diena ir niekas nuo jo nenukryps, išskyrus tą, kuris pasmerktas. Jis vedė savo tautą į visuotinį gėrį ir įspėjo juos apie visokį blogį. </p>',
            ],
        ],
        4 => [
            0 => [
                'question' => '1 Klausimas: recituok ir paaiškink sūrą „Atveriančioji Knygą“ (Al-Fatiha).',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6960.mp3',
                'answer' => '<p> Atsakymas: sūra „Atveriančioji Knygą“ ir jos interpretacija:<br /> { Vardan Allaho, Maloningojo, Gailestingojo <span class="c2">(1)</span> Visa šlovė ir dėkingumas – Allahui, pasaulių <span class="c2">(alamyn - žmonijos, džinų ir visa, kas egzistuoja)</span> Viešpačiui <span class="c2">(2)</span> Maloningiausiajam, Gailestingiausiajam <span class="c2">(3)</span> Atpildo Dienos <span class="c2">(t. y. Prikėlimo dienos)</span> Vieninteliam Valdytojui <span class="c2">(ir Vieninteliam Teisėjui)</span> <span class="c2">(4)</span> Tave <span class="c2">(Vienintelį)</span> mes garbiname ir Tavęs <span class="c2">(Vienintelio)</span> mes prašome pagalbos <span class="c2">(5)</span> Vesk mus Tiesiu keliu <span class="c2">(6)</span> Keliu tų, kuriems Tu suteikei Savo Malonę, bet ne tų, kurie užsitraukė Tavo Pyktį <span class="c2">(kaip judėjai)</span>, ir ne tų, kurie nuklydo <span class="c2">(kaip krikščionys)</span>. <span class="c2">(7)</span>} <span class="c5">[Koranas,<span class="c6"> sūra „Atveriančioji Knygą“ 1:</span>1-7]</span>.<span class="c6"><br /> Interpretacija:</span><br /> Sūra vadinama „Atveriančioji Knygą“ <span class="c2">(Al-Fatiha)</span>, nes ji atveria Allaho Knygą.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001001.mp3"></audio> 1) <span class="c4">{ Vardan Allaho, Maloningojo, Gailestingojo}</span> - Allaho vardu aš pradedu recituoti Koraną, prašydamas Jo pagalbos ir siekdamas palaiminimo, paminėdamas Jo vardą.<br /> <span class="c4">{Allahas}</span> - Vienintelis vertas garbinimo, niekas nėra vadinamas tokiu vardu, išskyrus Jį.<br /> <span class="c4">{Maloningasis}</span> - didelio gailestingumo, apimančio viską, Turėtojas.<br /> <span class="c4">{Gailestingasis}</span> - Tas, Kuris rodo gailestingumą tikintiesiems.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001002.mp3"></audio> 2) { Visa šlovė ir dėkingumas – Allahui, pasaulių <span class="c2">(alamyn - žmonijos, džinų ir visa, kas egzistuoja)</span> Viešpačiui} - visa šlovė ir tobulumas priklauso tik Allahui.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001003.mp3"></audio> 3) <span class="c4">{ Maloningiausiajam, Gailestingiausiajam}</span> - didelio gailestingumo, apimančio viską, Turėtojuı, ir Tam, Kuris rodo gailestingumą tikintiesiems.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001004.mp3"></audio> 4) { Atpildo Dienos Vieninteliam Valdytojui <span class="c2">(ir Vieninteliam Teisėjui)</span>} - tai yra Prikėlimo dienos.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001005.mp3"></audio> 5) <span class="c4">{ Tave mes garbiname ir Tavęs mes prašome pagalbos}</span> - mes garbiname Tave vieną ir tik iš Tavęs prašome pagalbos.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001006.mp3"></audio> 6) <span class="c4">{ Vesk mus Tiesiu keliu}</span> - tai islamo ir sunnos kelias.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001007.mp3"></audio> 7) <span class="c4">{ Keliu tų, kuriems Tu suteikei Savo Malonę, bet ne tų, kurie užsitraukė Tavo Pyktį, ir ne tų, kurie nuklydo.}</span> - tai teisiųjų Allaho tarnų iš pranašų ir jų pasekėjų kelias, o ne krikščionių ir judėjų.<br /> -<span class="c6"> Jį perskaičius patartina pasakyti:</span> „Amin“,<span class="c6"> o tai reiškia:</span> „Atsakyk į mūsų maldas“. </p>',
            ],
            1 => [
                'question' => '2 Klausimas: recituok ir paaiškink sūrą „Žemės drebėjimas“ (Az-Zalzala).',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7130.mp3',
                'answer' => '<p> Atsakymas: sūra „Žemės drebėjimas“ <span class="c2">(Az-Zalzala)</span> ir jos interpretacija:<br /> Vardan Allaho Maloningojo, Gailestingojo<br /> { Kai žemė bus sudrebinta savo <span class="c2">(paskutiniu)</span> žemės drebėjimu <span class="c2">(1)</span> ir žemė išmes savo naštą, <span class="c2">(2)</span> ir žmogus sakys: „Kas <span class="c2">(blogo)</span> jai?“ <span class="c2">(3)</span> Tą Dieną ji praneš savo naujienas, <span class="c2">(4)</span> nes tavo Viešpats įkvėpė <span class="c2">(t. y. įsakė)</span> ją. <span class="c2">(5)</span> Tą Dieną žmonės išeis suskirstyti <span class="c2">(į rūšis)</span>, kad jiems būtų parodytas jų veiksmų <span class="c2">(rezultatas)</span>. <span class="c2">(6)</span> Tad, kas darė mažos skruzdės svorio gėrį, pamatys tai, <span class="c2">(7)</span> ir kas darė mažos skruzdės svorio blogį – pamatys tai. <span class="c2">(8)</span>} <span class="c5">[Koranas,<span class="c6"> sūra „Žemės drebėjimas“ 99:</span>1-8]</span>.<span class="c6"><br /> Interpretacija:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099001.mp3"></audio> 1) { Kai žemė bus sudrebinta savo <span class="c2">(paskutiniu)</span> žemės drebėjimu} - kai žemė smarkiai drebės Prikėlimo dieną.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099002.mp3"></audio> 2) <span class="c4">{ ir žemė išmes savo naštą,}</span> - ir kai žemė išmes tai, kas joje yra iš mirusiųjų ir kitų dalykų.<span class="c6"><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099003.mp3"></audio> 3) { ir žmogus sakys:</span> „Kas <span class="c2">(blogo)</span> jai?“} -<span class="c6"> o žmogus sutrikęs sakys:</span> „Kodėl žemė taip juda ir dreba?!“<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099004.mp3"></audio> 4) <span class="c4">{ Tą Dieną ji praneš savo naujienas,}</span> - tą didžiąją dieną žemė kalbės apie tai, kas čia buvo padaryta gero ir blogo.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099005.mp3"></audio> 5) <span class="c4">{ nes tavo Viešpats įkvėpė ją.}</span> - nes Allahas tai pranešė ir įsakė tai padaryti.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099006.mp3"></audio> 6) { Tą Dieną žmonės išeis suskirstyti, kad jiems būtų parodytas jų veiksmų <span class="c2">(rezultatas)</span>.} - tą didžiąją dieną, kai žemė drebės, žmonės ateis grupėmis į atsiskaitymą ir jiems bus parodyti jų gyvenimo darbai.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099007.mp3"></audio> 7) <span class="c4">{ Tad, kas darė mažos skruzdės svorio gėrį, pamatys tai,}</span> - kas padarė gerą, labdaringą darbą, net mažos skruzdėlės svorio, pamatys tai priešais save.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099008.mp3"></audio> 8) <span class="c4">{ ir kas darė mažos skruzdės svorio blogį – pamatys tai.}</span> - ir kas padarė blogą poelgį, net ir mažos skruzdėlės svorio, tas pamatys tai priešais save. </p>',
            ],
            2 => [
                'question' => '3 Klausimas: recituok ir paaiškink sūrą „Lenktyniautojai“ (Al-Adijat).',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7270.mp3',
                'answer' => '<p> Atsakymas: sūra „Lenktyniautojai“ <span class="c2">(Al-Adijat)</span> ir jos interpretacija:<br /> Vardan Allaho Maloningojo, Gailestingojo<br /> { <span class="c2">(Prisiekiu)</span> švokščiančiais lenktyniautojais <span class="c2">(1)</span> ir paleidžiančiais žiežirbas įskeliant, <span class="c2">(2)</span> ir žirgais aušros metu, <span class="c2">(3)</span> sukeliančiais tuo dulkių <span class="c2">(debesis)</span>, <span class="c2">(4)</span> drauge taip įsiveržiančiais į vidurį. <span class="c2">(5)</span> Iš tiesų, žmogus savo Viešpačiui yra nedėkingas, <span class="c2">(6)</span> ir iš tiesų, jis yra to liudytojas, <span class="c2">(7)</span> ir iš tiesų, jis labai myli turtą. <span class="c2">(8)</span> Tačiau argi jis nežino, kad, kai kapų turinys bus išmestas <span class="c2">(9)</span> ir tai, kas krūtinėse, bus išgauta, <span class="c2">(10)</span> iš tiesų, jų Viešpats Tą Dieną yra <span class="c2">(viską)</span> apie juos Žinantis. <span class="c2">(11)</span>} <span class="c5">[Koranas,<span class="c6"> sūra „Lenktyniautojai“ 100:</span>1-11]</span>.<span class="c6"><br /> Interpretacija:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100001.mp3"></audio> 1) { <span class="c2">(Prisiekiu)</span> švokščiančiais lenktyniautojais} - Allahas prisiekia žirgais, kurie bėga taip greitai, kad girdisi jų alsavimo garsas.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100002.mp3"></audio> 2) <span class="c4">{ ir paleidžiančiais žiežirbas įskeliant,}</span> - Allahas taip pat prisiekia žirgais, kurie kanopomis svaido ugnies kibirkštis, kai stipriai liečiasi su uolomis.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100003.mp3"></audio> 3) <span class="c4">{ ir žirgais aušros metu,}</span> - Allahas prisiekia žirgais, kurie ryte puola priešus.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100004.mp3"></audio> 4) { sukeliančiais tuo dulkių <span class="c2">(debesis)</span>,} - taigi, bėgdami jie maišo dulkes.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100005.mp3"></audio> 5) <span class="c4">{ drauge taip įsiveržiančiais į vidurį.}</span> - jie dideliu greičiu lekia į priešų vidurį, nešdami savo raitelius.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100006.mp3"></audio> 6) <span class="c4">{ Iš tiesų, žmogus savo Viešpačiui yra nedėkingas,}</span> - iš tiesų, žmogus šykšti gerumo, kurį Viešpats įsako jam skleisti.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100007.mp3"></audio> 7) <span class="c4">{ ir iš tiesų, jis yra to liudytojas,}</span> - jis pats liudija, kad jis stabdo gėrį, ir negali to neigti, nes tai yra labai aišku.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100008.mp3"></audio> 8) <span class="c4">{ ir iš tiesų, jis labai myli turtą.}</span> - dėl didžiulės meilės pinigams jis godžiai jų šykšti.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100009.mp3"></audio> 9) <span class="c4">{ Tačiau argi jis nežino, kad, kai kapų turinys bus išmestas}</span> - ar šis žmogus, apgautas pasaulietiško gyvenimo, nežino, kad kai Allahas išves mirusiuosius iš kapų ir iš žemės, kad atsiskaitytų ir atlygintų, kad viskas nebus taip, kaip jis įsivaizdavo?!<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100010.mp3"></audio> 10) <span class="c4">{ ir tai, kas krūtinėse, bus išgauta,}</span> - taps aišku ir akivaizdu, kas yra širdyse – ketinimai, įsitikinimai ir pan.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100011.mp3"></audio> 11) { iš tiesų, jų Viešpats Tą Dieną yra <span class="c2">(viską)</span> apie juos Žinantis.} - iš tiesų, jų Viešpats tą dieną apie juos viską žino, ir jokie Jo vergų reikalai nebus nuo Jo paslėpti ir Jis jiems už tai atlygins. </p>',
            ],
            3 => [
                'question' => '4 Klausimas: recituok ir paaiškink sūrą „Pribloškianti“ (Al-Karija).',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7450.mp3',
                'answer' => '<p> Atsakymas: sūra „Pribloškianti“ <span class="c2">(Al-Karija)</span> ir jos interpretacija:<br /> Vardan Allaho Maloningojo, Gailestingojo<br /> { Pribloškianti Neganda! <span class="c2">(1)</span> Kas yra Pribloškianti Neganda? <span class="c2">(2)</span> Ir kas tau paaiškins, kas yra Pribloškianti Neganda? <span class="c2">(3)</span> Tai Diena, kai žmonės bus kaip išvaikyti drugiai <span class="c2">(4)</span> ir kalnai bus kaip iškaršta vilna. <span class="c2">(5)</span> Tada tas, kurio svarstyklės bus sunkios <span class="c2">(gerais darbais)</span>, <span class="c2">(6)</span> bus maloniame gyvenime. <span class="c2">(7)</span> Tačiau to, kurio svarstyklės bus lengvos, <span class="c2">(8)</span> prieglobstis bus Bedugnė. <span class="c2">(9)</span> Ir kas tau paaiškins, kas tai yra? <span class="c2">(10)</span> Tai - ypatingai karšta Ugnis. <span class="c2">(11)</span>} <span class="c5">[Koranas,<span class="c6"> sūra „Pribloškianti“ 101:</span>1-11]</span>.<span class="c6"><br /> Interpretacija:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101001.mp3"></audio> 1) <span class="c4">{ Pribloškianti Neganda!}</span> - valanda, kuri sukrečia žmonių širdis, nes yra nepaprastai siaubinga.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101002.mp3"></audio> 2) <span class="c4">{ Kas yra Pribloškianti Neganda?}</span> - kokia yra ši valanda, kuri sukrečia žmonių širdis, nes yra nepaprastai siaubinga?!<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101003.mp3"></audio> 3) <span class="c4">{ Ir kas tau paaiškins, kas yra Pribloškianti Neganda?}</span> - iš kur žinai, o Pasiuntiny, kokia ši valanda, kuri sukrečia žmonių širdis dėl to, kad yra nepaprastai siaubinga? Tai Prisikėlimo diena.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101004.mp3"></audio> 4) <span class="c4">{ Tai Diena, kai žmonės bus kaip išvaikyti drugiai}</span> - tą dieną, kai žmonių širdys bus sukrėstos, žmonės bus kaip drugeliai, išsibarstę į visas puses.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101005.mp3"></audio> 5) <span class="c4">{ ir kalnai bus kaip iškaršta vilna.}</span> - kalnai bus kaip iškaršta vilna, kaip pūkai.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101006.mp3"></audio> 6) { Tada tas, kurio svarstyklės bus sunkios <span class="c2">(gerais darbais)</span>,} - tas, kurio geri darbai nusveria blogus.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101007.mp3"></audio> 7) <span class="c4">{ bus maloniame gyvenime.}</span> - jis mėgausis maloniu gyvenimu Rojuje.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101008.mp3"></audio> 8) <span class="c4">{ Tačiau to, kurio svarstyklės bus lengvos,}</span> - tas, kurio blogi darbai nusveria gerus darbus.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101009.mp3"></audio> 9) <span class="c4">{ prieglobstis bus Bedugnė.}</span> - jo buveinė ir būstas bus pragaro Ugnis.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101010.mp3"></audio> 10) <span class="c4">{ Ir kas tau paaiškins, kas tai yra?}</span> - iš kur žinai, o Pasiuntiny, kas tai?<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101011.mp3"></audio> 11) <span class="c4">{ Tai - ypatingai karšta Ugnis.}</span> - tai liepsnojanti Ugnis. </p>',
            ],
            4 => [
                'question' => '5 Klausimas: recituok ir paaiškink sūrą „Varžymasis kaupime“ (At-Takasur).',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7610.mp3',
                'answer' => '<p> Atsakymas: sūra „Varžymasis kaupime“ ir jos interpretacija:<br /> Vardan Allaho Maloningojo, Gailestingojo<br /> { Varžymasis <span class="c2">(žemiškųjų dalykų)</span> kaupime atitraukia jus, <span class="c2">(1)</span> kol aplankysite kapus. <span class="c2">(2)</span> Ne! Jūs greitai sužinosite! <span class="c2">(3)</span> Tad ne! Jūs greitai sužinosite! <span class="c2">(4)</span> Ne, jei tik jūs žinotumėte užtikrintu žinojimu… <span class="c2">(5)</span> Jūs tikrai pamatysite Pragarą! <span class="c2">(6)</span> Tada jūs tikrai pamatysite tai užtikrintomis akimis! <span class="c2">(7)</span> Tada jūs tikrai būsite paklausti Tą Dieną apie malonumus! <span class="c2">(8)</span>} <span class="c5">[Koranas,<span class="c6"> sūra „Varžymasis kaupime“ 102:</span>1-8]</span>.<span class="c6"><br /> Interpretacija:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102001.mp3"></audio> 1) { Varžymasis <span class="c2">(žemiškųjų dalykų)</span> kaupime atitraukia jus,} - o žmonės, gyrimasis savo turtais ir vaikais atitraukė jus nuo paklusimo Allahui.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102002.mp3"></audio> 2) <span class="c4">{ kol aplankysite kapus.}</span> - kol numirsite ir įeisite į savo kapus.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102003.mp3"></audio> 3) <span class="c4">{Ne! Jūs greitai sužinosite!}</span> - jūs neturėjote blaškytis girdamiesi, ir jūs suprasite to blaškymosi pasekmes.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102004.mp3"></audio> 4) <span class="c4">{ Tad ne! Jūs greitai sužinosite!}</span> - tada jūs suprasite to pasekmes.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102005.mp3"></audio> 5) <span class="c4">{ Ne, jei tik jūs žinotumėte užtikrintu žinojimu…}</span> - iš tiesų, jei būtumėte tikrai žinoję, kad būsite prikelti Allaho, Kuris jums atlygins už jūsų poelgius, būtumėte nesiblaškęs girdamiesi turtais ir vaikais.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102006.mp3"></audio> 6) <span class="c4">{ Jūs tikrai pamatysite Pragarą!}</span> - prisiekiu Allahu, Prikėlimo dieną tikrai pamatysite Pragaro Ugnį.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102007.mp3"></audio> 7) <span class="c4">{ Tada jūs tikrai pamatysite tai užtikrintomis akimis!}</span> - vėlgi, jūs tai pamatysite visiškai užtikrintai.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102008.mp3"></audio> 8) <span class="c4">{ Tada jūs tikrai būsite paklausti tą Dieną apie malonumus!}</span> - tada tą dieną Allahas paklaus jūsų apie palaiminimus, kuriuos jums suteikė; sveikatą, turtus ir kt. </p>',
            ],
            5 => [
                'question' => '6 Klausimas: recituok ir paaiškink sūrą „Laikas“ (Al-Asr).',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7750.mp3',
                'answer' => '<p> Atsakymas: sūra „Laikas“ ir jos interpretacija:<br /> Vardan Allaho Maloningojo, Gailestingojo<br /> { <span class="c2">(Prisiekiu)</span> laiku! <span class="c2">(1)</span> Iš tiesų, žmogus yra nuostolyje, <span class="c2">(2)</span> išskyrus tuos, kurie patikėjo ir darė teisingus darbus, ir patarinėjo vienas kitam dėl tiesos, ir patarinėjo vienas kitam dėl kantrybės. <span class="c2">(3)</span>} <span class="c5">[Koranas,<span class="c6"> sūra „Laikas“ 103:</span>1-3]</span>.<span class="c6"><br /> Interpretacija:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/103001.mp3"></audio> 1) { Prisiekiu Al-Asr <span class="c2">(laiku)</span>!} - Visagalis Allahas prisiekia laiku.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/103002.mp3"></audio> 2) <span class="c4">{ Iš tiesų, žmogus yra nuostolyje,}</span> - visa žmonija yra visiškoje netektyje.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/103003.mp3"></audio> 3) <span class="c4">{ išskyrus tuos, kurie patikėjo ir darė teisingus darbus, ir patarinėjo vienas kitam dėl tiesos, ir patarinėjo vienas kitam dėl kantrybės.}</span> - tos netekties išvengia tik tie, kurie tiki ir daro teisingus darbus bei šaukiasi tiesos ir kantriai ją ištveria. </p>',
            ],
            6 => [
                'question' => '7 Klausimas: recituok ir paaiškink sūrą „Niekintojas“ (Al-Humaza).',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7830.mp3',
                'answer' => '<p> Atsakymas: sūra „Niekintojas“ ir jos interpretacija:<br /> Vardan Allaho Maloningojo, Gailestingojo<br /> { Vargas kiekvienam niekintojui ir besityčiojančiam, <span class="c2">(1)</span> kuris kaupia turtą ir <span class="c2">(be perstojo)</span> jį skaičiuoja! <span class="c2">(2)</span> Jis mano, kad jo turtas padarys jį nemirtingu. <span class="c2">(3)</span> Ne! Jis tikrai bus įmestas į triuškinančią Ugnį. <span class="c2">(4)</span> Ir kas tau paaiškins, kas yra triuškinančioji Ugnis? <span class="c2">(5)</span> Tai yra <span class="c2">(amžinai)</span> liepsnojanti Allaho Ugnis, <span class="c2">(6)</span> kylanti link širdžių. <span class="c2">(7)</span> Iš tiesų, tai <span class="c2">(t. y. Pragaras)</span> bus užvertas virš jų <span class="c2">(8)</span> nusidriekusiomis kolonomis. <span class="c2">(9)</span>} <span class="c5">[Koranas,<span class="c6"> sūra „Niekintojas“ 104:</span>1-9]</span>.<span class="c6"><br /> Interpretacija:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104001.mp3"></audio> 1) <span class="c4">{ Vargas kiekvienam niekintojui ir besityčiojančiam,}</span> - vargas ir didžiulė kančia visiems, kurie dažnai apkalbinėja ir šmeižia žmones.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104002.mp3"></audio> 2) { kuris kaupia turtą ir <span class="c2">(be perstojo)</span> jį skaičiuoja!} - tas, kuriam rūpi tik kaupti ir skaičiuoti pinigus.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104003.mp3"></audio> 3) <span class="c4">{ Jis mano, kad jo turtas padarys jį nemirtingu.}</span> - jis mano, kad sukaupti pinigai išgelbės jį nuo mirties ir leis gyventi amžinai.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104004.mp3"></audio> 4) <span class="c4">{ Ne! Jis tikrai bus įmestas į triuškinančią Ugnį.}</span> - nebus taip, kaip šis neišmanėlis įsivaizdavo. Iš tiesų, jis bus įmestas į Pragaro Ugnį ir bus sugniuždytas.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104005.mp3"></audio> 5) <span class="c4">{ Ir kas tau paaiškins, kas yra triuškinančioji Ugnis?}</span> - iš kur tu žinai, o Pasiuntiny, kas ta Ugnis, kuri sutriuškina viską, kas į ją įmesta?<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104006.mp3"></audio> 6) { Tai yra <span class="c2">(amžinai)</span> liepsnojanti Allaho Ugnis,} - tai užsidegusi Allaho Ugnis.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104007.mp3"></audio> 7) <span class="c4">{ kylanti link širdžių.}</span> - kuri prasiskverbia į žmonių kūnus ir pasiekia jų širdis.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104008.mp3"></audio> 8) { Iš tiesų, tai <span class="c2">(t. y. Pragaras)</span> bus užvertas virš jų} - tie, kurie kankinasi šioje liepsnoje, bus joje uždaryti.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104009.mp3"></audio> 9) <span class="c4">{ nusidriekusiomis kolonomis.}</span> - ji užrakinta ilgomis ir prailgintomis kolonomis, kad jie negalėtų išbėgti. </p>',
            ],
            7 => [
                'question' => '8 Klausimas: recituok ir paaiškink sūrą „Dramblys“ (Al-Fil).',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7970.mp3',
                'answer' => '<p> Atsakymas: sūra „Dramblys“ ir jos interpretacija:<br /> Vardan Allaho Maloningojo, Gailestingojo<br /> { Ar tu <span class="c2">(Muchammedai)</span> neapmąstei, kaip tavo Viešpats pasielgė su dramblio kompanjonais? <span class="c2">(1)</span> Ar Jis nepavertė jų plano paklydimu? <span class="c2">(2)</span> Ir Jis siuntė prieš juos paukščius pulkais, <span class="c2">(3)</span> daužančiais juos kieto molio akmenimis. <span class="c2">(4)</span> Ir Jis pavertė juos panašiais į nuvalgytus šiaudus. <span class="c2">(5)</span>} <span class="c5">[Koranas,<span class="c6"> sūra „Dramblys“ 105:</span>1-5]</span>.<span class="c6"><br /> Interpretacija:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105001.mp3"></audio> 1) { Ar tu <span class="c2">(Muchammedai)</span> neapmąstei, kaip tavo Viešpats pasielgė su dramblio kompanjonais?} - argi tu, o Pasiuntiny, nežinai, ką tavo Viešpats padarė Abrahai ir jo palydovams - „dramblio“ žmonėms, kai jie norėjo sugriauti Kaabą?<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105002.mp3"></audio> 2) <span class="c4">{ Ar Jis nepavertė jų plano paklydimu?}</span> - Allahas pavertė jų piktą planą į visišką nuostolį; taigi, jie nepasiekė to, ko norėjo, t. y., nukreipti žmones nuo Kaabos ir ją sunaikinti.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105003.mp3"></audio> 3) <span class="c4">{ Ir Jis siuntė prieš juos paukščius pulkais,}</span> - jis pasiuntė prieš juos daug paukščių pulkų.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105004.mp3"></audio> 4) <span class="c4">{ daužančiais juos kieto molio akmenimis.}</span> - kurie apmėtė juos kepto molio akmenimis.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105005.mp3"></audio> 5) <span class="c4">{ Ir Jis pavertė juos panašiais į nuvalgytus šiaudus.}</span> - Allahas padarė juos kaip lapus, kuriuos valgo ir trypia gyvūnai. </p>',
            ],
            8 => [
                'question' => '9 Klausimas: recituok ir paaiškink sūrą „Kureišų gentis“.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8070.mp3',
                'answer' => '<p> Atsakymas: sūra „Kureišų gentis“ ir jos interpretacija:<br /> Vardan Allaho Maloningojo, Gailestingojo<br /> { <span class="c2">(Didelė malonė iš Allaho)</span> dėl Kuraišų apsaugos, <span class="c2">(1)</span> jų kasdienio saugumo karavanų <span class="c2">(metu)</span> žiemą ir vasarą, <span class="c2">(2)</span> lai jie garbina šio Namo Viešpatį, <span class="c2">(3)</span> Kuris maitino juos, <span class="c2">(išgelbėdamas)</span> nuo alkio, ir apsaugojo juos, <span class="c2">(išgelbėdamas)</span> nuo baimės. <span class="c2">(4)</span>} <span class="c5">[Koranas,<span class="c6"> sūra „Kureišų gentis“ 106:</span>1-4]</span>.<span class="c6"><br /> Interpretacija:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106001.mp3"></audio> 1) { <span class="c2">(Didelė malonė iš Allaho)</span> dėl Kuraišų apsaugos,} - kalbama apie jiems pažįstamas žiemos ir vasaros keliones.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106002.mp3"></audio> 2) { jų kasdienio saugumo karavanų <span class="c2">(metu)</span> žiemą ir vasarą,} - jie buvo saugūs žiemos kelionėje į Jemeną ir vasaros kelionėje į Levantą.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106003.mp3"></audio> 3) <span class="c4">{ lai jie garbina šio Namo Viešpatį,}</span> - tegul jie garbina Allahą, šių Šventųjų Namų <span class="c2">(Kaabos)</span> Viešpatį. Jis yra Tas, kuris palengvino jiems kelionę; taigi, tegul jie nesieja su Juo partnerių.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106004.mp3"></audio> 4) { Kuris maitino juos, <span class="c2">(išgelbėdamas)</span> nuo alkio, ir apsaugojo juos, <span class="c2">(išgelbėdamas)</span> nuo baimės.} - kuris maitino juos nuo bado ir apsaugojo nuo baimės, priversdamas arabus gerbti Al-Haram <span class="c2">(šventąją vietą)</span> ir jo žmones. </p>',
            ],
            9 => [
                'question' => '10 Klausimas: recituok ir paaiškink sūrą „Pagalba“ (Al-Maun).',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8160.mp3',
                'answer' => '<p> Atsakymas: sūra „Pagalba“ ir jos interpretacija:<br /> Vardan Allaho Maloningojo, Gailestingojo<br /> { Ar matei tą, kuris neigia Atsiskaitymą? <span class="c2">(1)</span> Nes tai yra tas, kuris išveja našlaitį <span class="c2">(2)</span> ir neskatina maitinti vargšo. <span class="c2">(3)</span> Tad vargas tiems, kurie meldžiasi, <span class="c2">(4)</span> <span class="c2">(tačiau)</span> yra nerūpestingi dėl savo maldos, <span class="c2">(5)</span> tiems, kurie puikuojasi <span class="c2">(savo veiksmais)</span> <span class="c2">(6)</span> ir šykšti <span class="c2">(nedidelės)</span> pagalbos. <span class="c2">(7)</span>} <span class="c5">[Koranas,<span class="c6"> sūra „Pagalba“ 107:</span>1-7]</span>.<span class="c6"><br /> Interpretacija:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107001.mp3"></audio> 1) <span class="c4">{ Ar matei tą, kuris neigia Atsiskaitymą?}</span> - ar pažinojote tą, kuris neigia Prikėlimo dienos atlygį?<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107002.mp3"></audio> 2) <span class="c4">{ Nes tai yra tas, kuris išveja našlaitį}</span> - toks yra tas, kuris grubiai atstumia našlaitį.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107003.mp3"></audio> 3) <span class="c4">{ ir neskatina maitinti vargšo.}</span> - jis neragina nei savęs, nei kitų maitinti vargšus.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107004.mp3"></audio> 4) <span class="c4">{ Tad vargas tiems, kurie meldžiasi,}</span> - vargas ir kančia besimeldžiantiems.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107005.mp3"></audio> 5) { <span class="c2">(tačiau)</span> yra nerūpestingi dėl savo maldos,} - tie, kurie neskiria dėmesio maldai ir atidėlioja kol pasibaigs jos nustatytas laikas.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107006.mp3"></audio> 6) <span class="c4">{ tiems, kurie puikuojasi}</span> - tiems, kurie tik puikuojasi melsdamiesi ir darydami gerus darbus, o ne nuoširdžiai juos skiria Allahui.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107007.mp3"></audio> 7) <span class="c4">{ ir sulaiko pagalbą.}</span> - jie atsisako padėti kitiems net tuose dalykuose, kuriuose jiems nesunku padėti. </p>',
            ],
            10 => [
                'question' => '11 Klausimas: recituok ir paaiškink sūrą „Gėrio gausybė“ (Al-Kausar).',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8280.mp3',
                'answer' => '<p> Atsakymas: sūra „Gėrio gausybė“ ir jos interpretacija:<br /> Vardan Allaho Maloningojo, Gailestingojo<br /> { Iš tiesų, Mes suteikėme tau <span class="c2">(Muchammedai ﷺ )</span> Al-Kausar <span class="c2">(upę Rojuje)</span>, <span class="c2">(1)</span> tad melskis savo Viešpačiui ir atlik aukojimą! <span class="c2">(2)</span> Iš tiesų, tavo <span class="c2">(Muchammedai ﷺ )</span> priešas yra atskirtas <span class="c2">(nuo visko gero šiame pasaulyje ir sekančiame)</span>. <span class="c2">(3)</span>} <span class="c5">[Koranas,<span class="c6"> sūra „Gėrio gausybė“ 108:</span>1-3]</span>.<span class="c6"><br /> Interpretacija:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/108001.mp3"></audio> 1) { Iš tiesų, Mes suteikėme tau <span class="c2">(Muchammedai ﷺ )</span> Al-Kausar <span class="c2">(upę Rojuje)</span>,} - Mes davėme tau, o Pasiuntiny, gausų gėrį, įskaitant Kausar upę rojuje.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/108002.mp3"></audio> 2) <span class="c4">{ tad melskis savo Viešpačiui ir atlik aukojimą!}</span> - taigi, būk dėkingas Allahui už šį palaiminimą melsdamasis ir aukodamas vien tik Jam, priešingai nei daro politeistai, ieškodami artumo savo stabams aukojant jiems aukas.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/108003.mp3"></audio> 3) { Iš tiesų, tavo <span class="c2">(Muchammedai ﷺ )</span> priešas yra atskirtas <span class="c2">(nuo visko gero šiame pasaulyje ir sekančiame)</span>.} - tiesą sakant, tas, kuris tavęs nekenčia, yra atkirstas nuo visokio gėrio ir užmirštas taip, kad prisiminus, jis būtų minimas blogu žodžiu. </p>',
            ],
            11 => [
                'question' => '12 Klausimas: recituok ir paaiškink sūrą „Netikintieji“ (Al-Kafirun).',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8360.mp3',
                'answer' => '<p> Atsakymas: sūra „Netikintieji<span class="c1">“ ir jos interpretacija:<br /> Vardan Allaho Maloningojo,<span class="c6"> Gailestingojo<br /> { Sakyk:</span> „O jūs, netikintieji! <span class="c2">(1)</span> Aš negarbinu to, ką jūs garbinate, <span class="c2">(2)</span> nei jūs esate garbintojai to, ką aš garbinu, <span class="c2">(3)</span> nei aš būsiu garbintojas to, ką jūs garbinate, <span class="c2">(4)</span> nei jūs būsite garbintojai to, ką aš garbinu. <span class="c2">(5)</span> Jums – jūsų religija, o man – mano religija.”</span> <span class="c2">(6)</span>} [Koranas, sūra „Netikintieji<span class="c1">“ 109:1-6].<span class="c6"><br /> Interpretacija:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109001.mp3"></audio> 1) <span class="c4">{ Sakyk: „O jūs, netikintieji!}</span> - sakyk,<span class="c6"> o Pasiuntiny:</span> o jūs, netikintys Allahu.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109002.mp3"></audio> 2) <span class="c4">{ Aš negarbinu to, ką jūs garbinate,}</span> - aš negarbinu dabar ir negarbinsiu ateityje stabų, kuriuos garbinate.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109003.mp3"></audio> 3) <span class="c4">{ nei jūs esate garbintojai to, ką aš garbinu,}</span> - jūs taip pat negarbinate to, ką aš garbinu, t. y., tik Allahą Vienintelį.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109004.mp3"></audio> 4) <span class="c4">{ nei aš būsiu garbintojas to, ką jūs garbinate,}</span> - ir niekada negarbinsiu stabų, kuriuos garbinate jūs.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109005.mp3"></audio> 5) <span class="c4">{ nei jūs būsite garbintojai to, ką aš garbinu.}</span> - jūs taip pat negarbinsite to, ką aš garbinu, t. y., tik Allahą Vienintelį.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109006.mp3"></audio> 6) { Jums – jūsų religija, o man – mano religija.”</span>} - jūs turite savo religiją, kurią sugalvojote, o aš turiu savo religiją, kurią man atskleidė Allahas. </p>',
            ],
            12 => [
                'question' => '13 Klausimas: recituok ir paaiškink sūrą „Pergalė“ (An-Nasr).',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8470.mp3',
                'answer' => '<p> Atsakymas: sūra „Pergalė“ ir jos interpretacija:<br /> Vardan Allaho Maloningojo, Gailestingojo<br /> { Kai ateis Allaho pergalė ir užkariavimas, <span class="c2">(1)</span> ir tu pamatysi žmones, priimančius Allaho religiją miniomis, <span class="c2">(2)</span> tada išaukštink <span class="c2">(Jį)</span>, šlovindamas savo Viešpatį, ir prašyk Jo atleidimo. Iš tiesų, Jis yra labiausiai Priimantis atgailą. <span class="c2">(3)</span>} <span class="c5">[Koranas,<span class="c6"> sūra „Pergalė“ 110:</span>1-3]</span>.<span class="c6"><br /> Interpretacija:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/110001.mp3"></audio> 1) <span class="c4">{ Kai ateis Allaho pergalė ir užkariavimas,}</span> - kai Allahas suteiks pergalę ir stiprybę tavo religijai – o Pasiuntiny – ir kai įvyks Mekkos užkariavimas.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/110002.mp3"></audio> 2) <span class="c4">{ ir tu pamatysi žmones, priimančius Allaho religiją miniomis,}</span> - ir matysi, kaip žmonės priima islamą viena grupė po kitos.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/110003.mp3"></audio> 3) { tada išaukštink <span class="c2">(Jį)</span>, šlovindamas savo Viešpatį, ir prašyk Jo atleidimo. Iš tiesų, Jis yra labiausiai Priimantis atgailą.} - turėtum žinoti, kad tai yra ženklas, kad tavo misija tuoj baigsis. Taigi šlovink savo Viešpaties šlovę iš dėkingumo už pergalės ir užkariavimo palaiminimą ir ieškok Jo atleidimo, nes iš tikrųjų Jis priima savo vergų atgailą ir jiems atleidžia. </p>',
            ],
            13 => [
                'question' => '14 Klausimas: recituok ir paaiškink sūrą „Plaušas“ (Al-Masad).',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8550.mp3',
                'answer' => '<p> Atsakymas: sūra „Plaušas“ ir jos interpretacija:<br /> Vardan Allaho Maloningojo, Gailestingojo<br /> { Lai Abu Lahab rankos būna pražuvusios ir pražuvęs yra jis pats. <span class="c2">(1)</span> Nepadės jam jo turtas ir tai, ką jis įgijo. <span class="c2">(2)</span> Jis <span class="c2">(įžengs ir)</span> degs <span class="c2">(degančios)</span> liepsnos Ugnyje <span class="c2">(3)</span> ir jo žmona <span class="c2">(taip pat)</span> – malkų nešėja. <span class="c2">(4)</span> Aplink jos kaklą – virvė iš <span class="c2">(pinto)</span> plaušo. <span class="c2">(5)</span>} <span class="c5">[Koranas,<span class="c6"> sūra „Plaušas“ 111:</span>1-5]</span>.<span class="c6"><br /> Interpretacija:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111001.mp3"></audio> 1) <span class="c4">{ Lai Abu Lahab rankos būna pražuvusios ir pražuvęs yra jis pats.}</span> - lai žūva Pranašo dėdės Abu Lahab ibn Abd Al-Mutalib rankos, kaip ir jo darbai žuvo dėl to, kad jis piktnaudžiavo Pranašu <span class="c2">(ramybė ir Allaho palaima jam)</span>, ir visos jo pastangos buvo bergždžios.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111002.mp3"></audio> 2) <span class="c4">{ Nepadės jam jo turtas ir tai, ką jis įgijo.}</span> - ar jo turtai ir vaikai jam buvo naudingi? Jie negalėjo nei išgelbėti jo nuo kančių, nei suteikti jam pasigailėjimo.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111003.mp3"></audio> 3) { Jis <span class="c2">(įžengs ir)</span> degs <span class="c2">(degančios)</span> liepsnos Ugnyje} - Prikėlimo dieną, jis bus įleistas į Pragaro Ugnį, kur kentės nuo karščio.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111004.mp3"></audio> 4) { ir jo žmona <span class="c2">(taip pat)</span> – malkų nešėja.} - jo žmona, Umm Džamil, kuri skaudindavo Pranašą <span class="c2">(ramybė ir Allaho palaima jam)</span> svaidydama jam spyglius, taip pat bus įmesta į Pragaro Ugnį.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111005.mp3"></audio> 5) { Aplink jos kaklą – virvė iš <span class="c2">(pinto)</span> plaušo.} - ją į Pragaro Ugnį įtrauks tvirta virvė aplink kaklą. </p>',
            ],
            14 => [
                'question' => '15 Klausimas: recituok ir paaiškink sūrą „Apvalymas“ (Al-Ikhlas).',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8650.mp3',
                'answer' => '<p> Atsakymas: sūra „Apvalymas“ ir jos interpretacija:<br /> Vardan Allaho Maloningojo,<span class="c6"> Gailestingojo<br /> { Sakyk:</span> „Jis yra Allahas, <span class="c2">(Kuris yra)</span> Vienas. <span class="c2">(1)</span> Allahas, Amžinas Prieglobstis. <span class="c2">(2)</span> Nei Jis gimdo, nei yra gimęs, <span class="c2">(3)</span> nei yra Jam ko nors lygaus.“ <span class="c2">(4)</span>} <span class="c5">[Koranas,<span class="c6"> sūra „Apvalymas“ 112:</span>1-4]</span>.<span class="c6"><br /> Interpretacija:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112001.mp3"></audio> 1) { Sakyk: „Jis yra Allahas, <span class="c2">(Kuris yra)</span> Vienas.} - sakyk,<span class="c6"> o Pasiuntiny:</span> Jis yra Allahas, nėra kito dievo, verto garbinimo, išskyrus Jį.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112002.mp3"></audio> 2) <span class="c4">{ Allahas, Amžinas Prieglobstis.}</span> - tai reiškia, kad visi Jo kūrinijos poreikiai keliami Jam.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112003.mp3"></audio> 3) <span class="c4">{ Nei Jis gimdo, nei yra gimęs,}</span> - Visagalis Allahas neturi nei vaiko, nei tėvo.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112004.mp3"></audio> 4) <span class="c4">{ nei yra Jam ko nors lygaus.“}</span> - nė vienas iš Jo kūrinių nėra panašus į Jį. </p>',
            ],
            15 => [
                'question' => '16 Klausimas: recituok ir paaiškink sūrą „Aušra“ (Al-Falak).',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8750.mp3',
                'answer' => '<p> Atsakymas: sūra „Aušra“ ir jos interpretacija:<br /> Vardan Allaho Maloningojo,<span class="c6"> Gailestingojo<br /> { Sakyk:</span> „Aš ieškau prieglobsčio pas aušros Viešpatį <span class="c2">(1)</span> nuo blogio, kurį Jis sukūrė, <span class="c2">(2)</span> ir nuo tamsos blogio, kai ji nusileidžia, <span class="c2">(3)</span> ir nuo pūtėjų į mazgus blogio, <span class="c2">(4)</span> ir nuo blogio pavyduolio, kai jis pavydi.“ <span class="c2">(5)</span>} <span class="c5">[Koranas,<span class="c6"> sūra „Aušra“ 113:</span>1-5]</span>.<span class="c6"><br /> Interpretacija:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113001.mp3"></audio> 1) <span class="c4">{ Sakyk: „Aš ieškau prieglobsčio pas aušros Viešpatį}</span> - sakyk,<span class="c6"> o Pasiuntiny:</span> aš tvirtai laikausi ir ieškau prieglobsčio ryto Viešpaties.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113002.mp3"></audio> 2) <span class="c4">{ nuo blogio, kurį Jis sukūrė,}</span> - nuo žalingų būtybių blogio.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113003.mp3"></audio> 3) <span class="c4">{ ir nuo tamsos blogio, kai ji nusileidžia,}</span> - ir aš ieškau prieglobsčio pas Allahą nuo blogio, kuris pasirodo naktį, kaip gyvūnai ir vagys.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113004.mp3"></audio> 4) <span class="c4">{ ir nuo pūtėjų į mazgus blogio,}</span> - ir aš ieškau prieglobsčio pas Allahą nuo burtininkų, kurie pučia į mazgus, blogio.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113005.mp3"></audio> 5) <span class="c4">{ ir nuo blogio pavyduolio, kai jis pavydi.“}</span> - ir nuo blogio to, kuris nekenčia ir pavydi žmonėms dėl tų palaiminimų, kuriuos jiems suteikė Allahas, nes jis nori, kad jie nebegautų tokių palaiminimų ir trokšta, kad jiems būtų padaryta žala. </p>',
            ],
            16 => [
                'question' => '17 Klausimas: recituok ir paaiškink sūrą „Žmonija“ (An-Nas).',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8870.mp3',
                'answer' => '<p> Atsakymas: sūra „Žmonija“ ir jos interpretacija:<br /> Vardan Allaho Maloningojo,<span class="c6"> Gailestingojo<br /> { Sakyk:</span> „Aš ieškau prieglobsčio pas žmonijos Viešpatį <span class="c2">(1)</span> žmonijos Valdovą, <span class="c2">(2)</span> žmonijos Dievą, <span class="c2">(3)</span> nuo blogio pasišalinančio šnabždėtojo, <span class="c2">(4)</span> kuris šnabžda <span class="c2">(blogį)</span> į žmonių krūtines, <span class="c2">(5)</span> iš džinų ir žmonių tarpo.“ <span class="c2">(6)</span>} <span class="c5">[Koranas,<span class="c6"> sūra „Žmonija“ 114:</span>1-6]</span>.<span class="c6"><br /> Interpretacija:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114001.mp3"></audio> 1) <span class="c4">{ Sakyk: „Aš ieškau prieglobsčio pas žmonijos Viešpatį}</span> - sakyk,<span class="c6"> o Pasiuntiny:</span> aš ieškau apsaugos ir prieglobsčio pas žmonijos Viešpatį.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114002.mp3"></audio> 2) <span class="c4">{ žmonijos Valdovą,}</span> - Jis tvarko jų reikalus, kaip nori ir yra vienintelis jų Savininkas.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114003.mp3"></audio> 3) <span class="c4">{ žmonijos Dievą,}</span> - jų tikrasis Dievas, ir nėra kito dievo, išskyrus Jį, verto garbinimo.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114004.mp3"></audio> 4) { nuo blogio pasišalinančio <span class="c2">(paminėjus Allahą)</span> šnabždėtojo,} - nuo velnio blogio, kuris šnabžda žmonėms.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114005.mp3"></audio> 5) {kuris šnabžda <span class="c2">(blogį)</span> į žmonių krūtines,} - kuris šnabžda į žmonių širdis.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114006.mp3"></audio> 6) <span class="c4">{ iš džinų ir žmonių tarpo.“}</span> - tai reiškia, kad šnabždesys gali būti iš žmonių arba iš džinų. </p>',
            ],
        ],
        5 => [
            0 => [
                'question' => '1 Klausimas: tęsk šį hadisą: „Iš tiesų, atlygis už darbus priklauso nuo ketinimų...“ ir paminėk kai kuriuos jo privalumus.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9030.mp3',
                'answer' => '<p> Atsakymas: tikinčiųjų vadas Abu Hafs Umar Ibn Al-Khatab <span class="c2">(tebūnie Allahas juo patenkintas)</span> pranešė, kad Pranašas <span class="c2">(ramybė ir Allaho palaima jam)</span> pasakė: „Iš tiesų, atlygis už darbus priklauso nuo ketinimų, ir kiekvienas žmogus bus apdovanotas pagal tai, ką jis ketino. Taigi, kas migruoja dėl Allaho ir Jo Pasiuntinio, tada jo migracija yra dėl Allaho ir Pasiuntinio. Ir tas, kurio migracija yra tam, kad pasiektų pasaulinę naudą arba vestų moterį, tada jo migracija skirta tam, dėl ko jis migravo.“ Perdavė Al-Bukhari ir Muslim.<span class="c6"><br /> Hadiso pranašumai:</span><br /> 1 - Kiekvienas poelgis reikalauja ketinimo, pavyzdžiui, malda, pasninkas, piligrimystė ir pan.<br /> 2 - Ketinimas turi būti nuoširdžiai skirtas Visagaliui Allahui.<span class="c6"><br /> Antras hadisas:</span> </p>',
            ],
            1 => [
                'question' => '2 Klausimas: tęsk šį hadisą: „Kas įves į šį mūsų (religijos) reikalą tai...“ ir paminėk kai kuriuos jo privalumus.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9090.mp3',
                'answer' => '<p> Atsakymas: tikinčiųjų Motina Umm Abdullah Aiša <span class="c2">(tebūnie Allahas ja patenkintas)</span> pranešė, kad Pranašas <span class="c2">(ramybė ir Allaho palaima jam)</span> pasakė: „Kas įves į šį mūsų <span class="c2">(religijos)</span> reikalą tai, kas jai nepriklauso, tai bus atmesta.“ Perdavė Al-Bukhari ir Muslim.<span class="c6"><br /> Hadiso pranašumai:</span><br /> 1 - Draudžiama religijoje įvesti naujus dalykus.<br /> 2 - Religinėmis naujovėmis pagrįsti veiksmai atmetami.<span class="c6"><br /> Trečias hadisas:</span> </p>',
            ],
            2 => [
                'question' => '3 Klausimas: tęsk šį hadisą: „Kai vieną dieną sėdėjome su Pasiuntiniu (ramybė ir Allaho palaima jam)...“ ir paminėk kai kuriuos jo privalumus.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9160.mp3',
                'answer' => '<p> Atsakymas: Umar Ibn Al-Khattab <span class="c2">(tebūnie Allahas juo patenkintas)</span> pasakė: „Kai vieną dieną sėdėjome su Pasiuntiniu <span class="c2">(ramybė ir Allaho palaima jam)</span>, prieš mus pasirodė vyras, apsirengęs baltais drabužiais ir labai juodais plaukais. Jokių kelionės pėdsakų ant jo nesimatė ir niekas iš mūsų jo nepažinojo. Jis atsisėdo šalia Pranašo, atsirėmęs į Pranašo kelius ir uždėjęs delnus ant šlaunų,<span class="c6"> pasakė:</span> „O Muchammedai, papasakok man apie islamą“.<span class="c6"> Pasiuntinys atsakė:</span> „Islamas yra paliudyti, kad nėra kito dievo, išskyrus Allahą ir kad Muchammedas yra Jo Pasiuntinys, melstis, duoti zakatą, pasninkauti Ramadano mėnesį ir atlikti hadžą, jei įmanoma.<span class="c6"> Vyras pasakė:</span> „Tu kalbėjai tiesą.“ Buvome nustebinti, kai jis jį apklausinėjo, o paskui pareiškė, kad kalbėjo tiesą.<span class="c6"> Po to pasakė:</span> „Papasakok man apie imaną <span class="c2">(tikėjimą)</span>.<span class="c6">“ Pranašas atsakė:</span> „Tai tikėjimas Allahu, angelais, Raštais, pasiuntiniais, Paskutiniaja diena ir likimo gėriu ir blogu.<span class="c6">“ Jis pasakė:</span> „Tu kalbėjai tiesą.<span class="c6">“ Tada vyras pasakė:</span> „Papasakok man apie ihsan <span class="c2">(tobulumą religijoje)</span>.<span class="c6"> Pranašas atsakė:</span> „Tai yra garbinti Allahą taip, lyg Jį matytume, nes jei nematai Jo, Jis tikrai tave mato.<span class="c6">“ Jis pasakė:</span> „Papasakok man apie Valandą <span class="c2">(Paskutiniąją dieną)</span>.<span class="c6">“ Pranašas pasakė:</span> „Klausiamasis <span class="c2">(Pranašas)</span> nežino daugiau nei klausinėjantis <span class="c2">(vyras)</span>.<span class="c6">“ Taigi jis pasakė:</span> „Tada papasakok man apie jos ženklus.<span class="c6">“ Jis pasakė:</span> „Kai vergė pagimdo savo šeimininkę ir kai pamatai basus, nuogus ir skurdžius piemenis <span class="c2">(arabus)</span> <span class="c2">(konkuruojančius tarpusavyje)</span>, statančius aukštus pastatus.“ Po to vyras išėjo.<span class="c6"> Pranašas šiek tiek palaukė ir tada pasakė:</span> „O Umar, ar žinai,<span class="c6"> kas buvo tas klausinėtojas?“ Aš atsakiau:</span> „Allahas ir Jo Pasiuntinys žino geriausiai“.<span class="c6"> Jis pasakė:</span> „Tai buvo Džibrilis <span class="c2">(Gabrielius)</span>, atėjęs išmokyti jūsų religijos.“ “ Perdavė Muslim.<span class="c6"><br /> Iš hadiso pranašumų:</span><br /> 1 - Paminėti penki islamo ramsčiai,<span class="c6"> kurie yra:</span><br /> Liudijimas, kad nėra nieko kito verto garbinimo, išskyrus Vienintelį Allahą ir kad Muchammedas yra Allaho Pasiuntinys.<br /> Maldos atlikimas.<br /> Zakato mokėjimas.<br /> Ramadano mėnesio pasninkas.<br /> Atlikti hadžą, jei įmanoma.<br /> 2 - Paminėti šeši iman <span class="c2">(tikėjimo)</span> ramsčiai,<span class="c6"> kurie yra:</span><br /> Tikėjimas Allahu.<br /> Angelais.<br /> Raštais.<br /> Pasiuntiniais.<br /> Paskutiniaja diena.<br /> Likimo gėriu ir blogiu.<br /> 3 - Paminėtas vienintelis ihsan ramstis - tai yra garbinti Allahą taip, lyg jį matytum, nes jei tu Jo nematai, Jis tikrai tave mato.<br /> 4 - Niekas nežino Valandos <span class="c2">(Paskutiniosios dienos)</span> laiko, išskyrus Visagalį Allahą.<span class="c6"><br /> Ketvirtas hadisas:</span> </p>',
            ],
            3 => [
                'question' => '4 Klausimas: tęsk šį hadisą: „Tobuliausią tikėjimą turi tie...“ ir paminėk kai kuriuos jo privalumus.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9360.mp3',
                'answer' => '<p> Atsakymas: Abu Huraira <span class="c2">(tebūnie Allahas juo patenkintas)</span> pranešė, kad Pranašas <span class="c2">(ramybė ir Allaho palaima jam)</span> pasakė: „Tobuliausią tikėjimą turi tie, kurių moralė yra geriausia.“ Perdavė At-Tirmizi, kuris įvertino hadisą kaip hasan sahih <span class="c2">(geras autentiškas)</span>.<span class="c6"><br /> Hadiso pranašumai:</span><br /> 1 - Geros moralės skatinimas.<br /> 2 - Moralės tobulumas yra iman <span class="c2">(tikėjimo tobulumo)</span> dalis.<br /> 3 - Iman <span class="c2">(tikėjimas)</span> didėja ir mažėja.<span class="c6"><br /> Penktas hadisas:</span> </p>',
            ],
            4 => [
                'question' => '5 Klausimas: tęsk šį hadisą: „Kas prisiekia kitu, nei Allahu...“ ir paminėk kai kuriuos jo privalumus.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9440.mp3',
                'answer' => '<p> Atsakymas: Ibn Umar <span class="c2">(tebūnie Allahas jais patenkintas)</span> pranešė, kad Pranašas <span class="c2">(ramybė ir Allaho palaima jam)</span> pasakė: „Kas prisiekia kitu, nei Allahu, iš tikrųjų atliko širk arba politeizmą.“ Perdavė At-Tirmizi.<span class="c6"><br /> Hadiso pranašumai:</span><br /> - Neleistina prisiekti kitu, nei Visagaliu Allahu.<br /> - Prisiekimas kitu, nei Visagaliu Allahu, yra mažojo širk <span class="c2">(politeizmo)</span> veiksmas.<span class="c6"><br /> Šeštas hadisas:</span> </p>',
            ],
            5 => [
                'question' => '6 Klausimas: tęsk šį hadisą: „Nė vienas iš jūsų netiki, kol nesu jam brangesnis...“ ir paminėk kai kuriuos jo privalumus.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9510.mp3',
                'answer' => '<p> Atsakymas: Anas <span class="c2">(tebūnie Allahas juo patenkintas)</span> pranešė, kad Allaho Pasiuntinys <span class="c2">(ramybė ir Allaho palaima jam)</span> pasakė: „Nė vienas iš jūsų netiki, kol nesu jam brangesnis už jo tėvą, vaikus ir visus žmones.“ Perdavė Al-Bukhari ir Muslim.<span class="c6"><br /> Iš hadiso pranašumų:</span><br /> - Mes turėtume mylėti Pranašą <span class="c2">(ramybė ir Allaho palaima jam)</span> labiau nei visus žmones.<br /> - Tai yra tobulo iman <span class="c2">(tikėjimo)</span> dalis.<span class="c6"><br /> Septintas hadisas:</span> </p>',
            ],
            6 => [
                'question' => '7 Klausimas: tęsk šį hadisą: „Nė vienas iš jūsų netiki, kol nelinki savo broliui to...“ ir paminėk kai kuriuos jo privalumus.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9580.mp3',
                'answer' => '<p> Atsakymas: Anas <span class="c2">(tebūnie Allahas juo patenkintas)</span> pranešė, kad Pranašas <span class="c2">(ramybė ir Allaho palaima jam)</span> pasakė: „Nė vienas iš jūsų netiki, kol nelinki savo broliui to, ko linki pats sau.“ Perdavė Al-Bukhari ir Muslim.<span class="c6"><br /> Iš hadiso privalumų:</span><br /> 1 - Tikintysis turi linkėti tikintiesiems tai, ko linki sau iš gėrio.<br /> - Tai yra tobulo iman <span class="c2">(tikėjimo)</span> dalis.<span class="c6"><br /> Aštuntas hadisas:</span> </p>',
            ],
            7 => [
                'question' => '8 Klausimas: tęsk šį hadisą: „Aš prisiekiu Tuo, Kurio rankoje yra mano siela...“ ir paminėk kai kuriuos jo privalumus.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9650.mp3',
                'answer' => '<p> Atsakymas: Abu Said <span class="c2">(tebūnie Allahas juo patenkintas)</span> pranešė, kad Pranašas <span class="c2">(ramybė ir Allaho palaima jam)</span> pasakė: „Aš prisiekiu Tuo, kurio rankoje yra mano siela, iš tikrųjų ji atitinka trečdalį Korano.“ Perdavė Al-Bukhari.<span class="c6"><br /> Keletas hadiso privalumų:</span><br /> 1 - Sūra „Apvalymas“ <span class="c2">(Al-Ikhlas)</span> nuopelnas.<br /> 2 - Tai prilygsta trečdaliui Korano.<span class="c6"><br /> Devintas hadisas:</span> </p>',
            ],
            8 => [
                'question' => '9 Klausimas: tęsk šį hadisą: „La haula va la kuvata illa billiah...“ ir paminėk kai kuriuos jo privalumus.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9720.mp3',
                'answer' => '<p> Atsakymas: Abu Mūsa <span class="c2">(tebūnie Allahas juo patenkintas)</span> pranešė, kad Pranašas <span class="c2">(ramybė ir Allaho palaima jam)</span> pasakė: „La haula va la kuvata illa billah <span class="c2">(visa galia priklauso Allahui)</span> yra vienas iš Rojaus lobių.“ Perdavė Al-Bukhari ir Muslim.<span class="c6"><br /> Iš hadiso privalumų:</span><br /> 1 - Šio posakio nuopelnas, kad jis yra vienas iš Rojaus lobių.<br /> 2 - Savo galios ir stiprybės atsisakymas ir pasikliovimas vien tik Visagaliu Allahu.<span class="c6"><br /> Dešimtas hadisas:</span> </p>',
            ],
            9 => [
                'question' => '10 Klausimas: tęsk šį hadisą: „Iš tiesų kūne yra mėsos gabalas...“ ir paminėk kai kuriuos jo privalumus.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9790.mp3',
                'answer' => '<p> Atsakymas: An-Numan Ibn Bašir <span class="c2">(tebūnie Allahas juo ir jo tėvu patenkintas)</span> pranešė,<span class="c6"> kad girdėjo Pranašą sakant:</span> „Iš tiesų kūne yra mėsos gabalas, jei jis sveikas, sveikas visas kūnas, o jei sugedęs - tai ir visas kūnas <span class="c2">(sugedęs)</span>. Iš tiesų, tai yra širdis.“ Perdavė Al-Bukhari ir Muslim.<span class="c6"><br /> Iš hadiso privalumų:</span><br /> 1 - Širdies teisumas užtikrina teisumą išorėje ir viduje.<br /> 2 - Atkreipti dėmesį į širdies teisumą, nes nuo to priklauso žmogaus teisumas.<span class="c6"><br /> Vienuoliktas hadisas:</span> </p>',
            ],
            10 => [
                'question' => '11 Klausimas: tęsk šį hadisą: „Kas miršta su paskutiniais žodžiais: „Nėra kito dievo, išskyrus Allahą“...“ ir paminėk kai kuriuos jo privalumus.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9860.mp3',
                'answer' => '<p> Atsakymas: Muaz Ibn Džabal <span class="c2">(tebūnie Allahas juo patenkintas)</span> pranešė, kad Pranašas <span class="c2">(ramybė ir Allaho palaima jam)</span> pasakė: „Kas miršta su paskutiniais žodžiais <span class="c2">(kurių prasmė yra)</span>: „Nėra kito dievo, išskyrus Allahą“, pateks į Rojų.“ Perdavė Abu Davud.<span class="c6"><br /> Iš hadiso privalumų:</span><br /> 1 - „La ilaha illallah“ <span class="c2">(nėra kito dievo, išskyrus Allahą)</span> nuopelnai ir kad tai yra priežastis įleisti žmogų į Rojų.<br /> 2 - Privilegija to,<span class="c6"> kurio paskutiniai žodžiai yra:</span> „La ilaha illallah“ <span class="c2">(nėra kito dievo, išskyrus Allahą)</span>.<span class="c6"><br /> Dvyliktas hadisas:</span> </p>',
            ],
            11 => [
                'question' => '12 Klausimas: tęsk šį hadisą: „Tikras tikintysis nedalyvauja nei patyčiose, nei dažnai keikiant...“ ir paminėk kai kuriuos jo privalumus.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9940.mp3',
                'answer' => '<p> Atsakymas: Abdullah Ibn Masud <span class="c2">(tebūnie Allahas juo patenkintas)</span> pranešė, kad Pranašas <span class="c2">(ramybė ir Allaho palaima jam)</span> pasakė: „Tikras tikintysis nedalyvauja nei patyčiose, nei dažnai keikiant <span class="c2">(kitus)</span>, nei jis būna nepadorus ar įžeidus.“ Perdavė At-Tirmizi.<span class="c6"><br /> Iš hadiso privalumų:</span><br /> 1 - Bet kokios melagingos ir nešvankios kalbos draudimas.<br /> 2 - Tai tikinčiojo kalbos savybės.<span class="c6"><br /> Tryliktas hadisas:</span> </p>',
            ],
            12 => [
                'question' => '13 Klausimas: tęsk šį hadisą: „Žmogaus pamaldumo požymis...“ ir paminėk kai kuriuos jo privalumus.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10020.mp3',
                'answer' => '<p> Atsakymas: Abu Huraira <span class="c2">(tebūnie Allahas juo patenkintas)</span> pranešė, kad Pranašas <span class="c2">(ramybė ir Allaho palaima jam)</span> pasakė: „Žmogaus pamaldumo požymis yra laikytis atokiai nuo to, kas jo neliečia.“ Perdavė At-Tirmizi ir kiti.<span class="c6"><br /> Iš hadiso privalumų:</span><br /> 1 - Negalima kištis į kitų religinius ar pasaulinius reikalus.<br /> 2 - Nesikišti į kitų reikalus yra religijos išpažinimo išbaigtumo ženklas.<span class="c6"><br /> Keturioliktas hadisas:</span> </p>',
            ],
            13 => [
                'question' => '14 Klausimas: tęsk šį hadisą: „Kas recituoja vieną raidę iš Allaho knygos...“ ir paminėk kai kuriuos jo privalumus.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10100.mp3',
                'answer' => '<p> Atsakymas: Abdullah Ibn Masud pranešė, kad Pranašas <span class="c2">(ramybė ir Allaho palaima jam)</span> pasakė: „Kas recituoja vieną raidę iš Allaho knygos, tas gauna už ją atlygį ir dešimt panašių atlygių. Aš nesakau, kad Alif Lam Mym yra raidė, bet Alif yra raidė, Lam yra raidė ir Mym yra raidė.“ Perdavė At-Tirmizi.<span class="c6"><br /> Iš hadiso privalumų:</span><br /> 1 - Korano recitavimo nuopelnas.<br /> 2 - Už kiekvieną jo recituojamą raidę apdovanojama. </p>',
            ],
        ],
        6 => [
            0 => [
                'question' => '1 Klausimas: kaip reikėtų parodyti mandagumą Visagaliam Allahui?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10190.mp3',
                'answer' => '<p> Atsakymas: 1 - Išaukštinant Jį.<br /> 2 - Garbinant Jį Vieną, nesusiejant su Juo partnerių.<br /> 3 - Paklūstant Jam.<br /> 4 - Susilaikant nuo nepaklusimo Jam.<br /> 5 - Parodant Jam dėkingumą ir šlovinant Jį už daugybę Jo malonių ir palaiminimų.<br /> 6 - Parodant kantrybę dėl to, ką Jis nulėmė. </p>',
            ],
            1 => [
                'question' => '2 Klausimas: kaip reikėtų parodyti mandagumą Pasiuntiniui (ramybė ir Allaho palaima jam)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10270.mp3',
                'answer' => '<p> Atsakymas: 1 - Imant jį sektinu pavyzdžiu.<br /> 2 - Paklūstant jam.<br /> 3 - Susilaikant nuo nepaklusimo jam .<br /> 4 - Tikint tuo, ką jis pranešė.<br /> 5 - Atsisakant naujų dalykų, pridedamų prie jo sunnos.<br /> 6 - Mylint jį labiau nei save ir visus žmones.<br /> 7 - Gerbiant ir palaikant jį bei jo sunną. </p>',
            ],
            2 => [
                'question' => '3 Klausimas: kaip reikėtų parodyti mandagumą savo tėvams?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10360.mp3',
                'answer' => '<p> Atsakymas: 1 - Paklusti jiems tame, kas nėra susiję su nuodėme.<br /> 2 - Patarnauti jiems.<br /> 3 - Padėti jiems.<br /> 4 - Tenkinti jų poreikius.<br /> 5 - Maldauti už juos.<br /> 6 - Mandagiai su jais kalbėti, neleistina sakyti net „uf“, o tai yra menkiausias susierzinimą išreiškiantis žodis.<br /> 7 - Šypsotis jiems ir nesiraukyti jų akivaizdoje.<br /> 8 - Nekelti balso su jais kalbantis, atidžiai ir nepertraukiamai klausytis ir nevadinti vardais, verčiau reikėtų sakyti „tėtis“ ir „mama“.<br /> 9 - Prašyti leidimo prieš įeinant, kai jie yra savo kambaryje.<br /> 10 - Bučiuoti galvą ir rankas. </p>',
            ],
            3 => [
                'question' => '4 Klausimas: kaip palaikyti giminystės ryšius?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10490.mp3',
                'answer' => '<p> Atsakymas: 1 - Lankyti giminaičius, pavyzdžiui, brolius, seseris, dėdes ir tetas iš tėvo bei motinos pusės ir kt.<br /> 2 - Parodyti jiems gerumą žodžiais ir darbais bei pasiūlyti jiems pagalbą.<br /> 3 - Palaikyti ryšį su jais ir domėtis jų padėtimi. </p>',
            ],
            4 => [
                'question' => '5 Klausimas: kaip elgtis su savo broliais ir draugais?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10550.mp3',
                'answer' => '<p> Atsakymas: 1 - Mylėti gerus žmones ir priimti juos kaip draugus.<br /> 2 - Vengti piktų žmonių draugijos.<br /> 3 - Pasisveikinti ir paspausti rankas savo broliams.<br /> 4 - Lankyti juos, kai jie serga, ir maldauti Allaho, kad juos išgydytų.<br /> 5 -<span class="c6"> Sakyti:</span> „Jarhamukallah“ <span class="c2">(Tepagaili tavęs Allahas)</span> tam, kuris nusičiaudėjo.<br /> 6 - Priimti jų kvietimą apsilankyti.<br /> 7 - Duoti jiems patarimus.<br /> 8 - Remti juos, kai jie skriaudžiami, ir neleisti jiems neteisingai elgtis.<br /> 9 - Linkėti jiems to, ko patys norime sau.<br /> 10 - Pasiūlyti jiems pagalbą, kai reikia.<br /> 11 - Susilaikyti nuo jų žalojimo žodžiais ar darbais.<br /> 12 - Saugoti jų paslaptis.<br /> 13 - Susilaikyti nuo jų įžeidimo, apkalbinėjimo, niekinimo, pavydėjimo, šnipinėjimo ar apgaudinėjimo. </p>',
            ],
            5 => [
                'question' => '6 Klausimas: koks yra etiketas su kaimynais?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10710.mp3',
                'answer' => '<p> Atsakymas: 1 - Žodžiais ir darbais rodyti gerumą kaimynui ir siūlyti pagalbą, kai reikia.<br /> 2 - Pasveikinti juos laimingomis progomis, tokiomis kaip šventės, santuoka ir pan.<br /> 3 - Lankyti juos, kai jie serga, ir paguosti, kai kenčia.<br /> 4 - Siūlyti jiems gaminamo maisto pagal galimybes.<br /> 5 - Susilaikyti nuo jų žalojimo žodžiais ar darbais.<br /> 6 - Netrukdyti jiems garsiais balsais, nešnipinėti, o būti kantriems su jais. </p>',
            ],
            6 => [
                'question' => '7 Klausimas: kokio etiketo turi laikytis šeimininkas ir svečias?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10800.mp3',
                'answer' => '<p> Atsakymas: 1 - Priimti kvietimą į svečius.<br /> 2 - Norint aplankyti kažką, reikia prašyti leidimo ir susitarti dėl susitikimo laiko.<br /> 3 - Prašyti leidimo prieš įeinant.<br /> 4 - Per ilgai neužsibūti apsilankymo metu.<br /> 5 - Per daug nesižvalgyti į namų gyventojus.<br /> 6 - Svečią sutikti ir priimti linksmai ir draugiškais žodžiais.<br /> 7 - Pasodinti svečią į geriausią vietą.<br /> 8 - Pagerbti svečią siūlant jam valgyti ir gerti. </p>',
            ],
            7 => [
                'question' => '8 Klausimas: koks yra ligos ir ligonių lankymo etiketas?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10900.mp3',
                'answer' => '<p> Atsakymas: 1 -<span class="c6"> Dešinę ranką uždėti ant skausmingos vietos ir tris kartus sakyti:</span> „bismillah“ <span class="c2">(Allaho vardu)</span>,<span class="c6"> po to sakyti:</span> „Auzu bi-izatillahi va kudratihi min šari ma adžidu va uhadhir“ <span class="c2">(Ieškau prieglobsčio Allaho galybėje ir galioje nuo to, ką jaučiu ir ko bijau)</span> - septynis kartus.<br /> 2 - Būti patenkintu ir kantriu tam, ką Allahas nulėmė.<br /> 3 - Paskubėti aplankyti bei maldauti už ligonį ir per ilgai pas jį neužsibūti.<br /> 4 - Atlikti rukija <span class="c2">(gydymo metodą pagal Koraną ir sunną)</span> ligoniui jam to nepaprašius.<br /> 5 - Patarti jam būti kantriam ir kiek gali laikytis dua, maldos ir ritualinio tyrumo.<br /> 6 -<span class="c6"> Maldauti už ligonį sakant:</span> „As-alu-llahal-azim rabal-aršil-azim an jašfik“ <span class="c2">(prašau Allaho Didžiausiojo, Didingojo Sosto Valdovo, kad tave išgydytų)</span> - septynis kartus. </p>',
            ],
            8 => [
                'question' => '9 Klausimas: paminėk žinių siekimo etiketą.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10990.mp3',
                'answer' => '<p> Atsakymas: 1 - Nuoširdžiai skirti intenciją Visagaliui Allahui.<br /> 2 - Elgtis pagal įgytas žinias.<br /> 3 - Gerbti mokytoją jam esant ir nesant.<br /> 4 - Mandagiai sėdėti jo buvimo metu.<br /> 5 - Atidžiai jo klausyti nepertraukiant.<br /> 6 - Mandagiai klausti.<br /> 7 - Nevadinti jo vardu. </p>',
            ],
            9 => [
                'question' => '10 Klausimas: koks yra susirinkimo etiketas?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11090.mp3',
                'answer' => '<p> Atsakymas: 1 - Pasveikinti žmones susirinkime.<br /> 2 - Atsisėsti pirmoje tuščioje vietoje neprašant nieko atsistoti arba nesėdėti tarp dviejų žmonių, nebent jiems leidus.<br /> 3 - Padaryti vietos atsisėsti kitiems.<br /> 4 - Nepertraukinėti kitų kalbos.<br /> 5 - Paprašyti leidimo ir atsisveikinti su žmonėmis prieš išeinant.<br /> 6 -<span class="c6"> Susirinkimo pabaigoje ištarti:</span> „Subhanakallahuma va bihamdik, aš-hadu alla ilaha illa ant, astaghfiruka va atubu ilaik“ <span class="c2">(šlovė ir garbė Tau, o Allah. Nėra jokio kito dievo, tik Tu. Aš ieškau Tavo atleidimo ir atgailauju Tau)</span>. </p>',
            ],
            10 => [
                'question' => '11 Klausimas: paminėk miegojimo etiketą.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11180.mp3',
                'answer' => '<p> Atsakymas: 1 - Anksti atsigulti miegoti.<br /> 2 - Miegoti tyrumo būsenoje <span class="c2">(su vudu)</span>.<br /> 3 - Nemiegoti ant pilvo.<br /> 4 - Miegoti ant dešiniojo šono ir dešinę ranką dėti po dešiniu skruostu.<br /> 5 - Nupurtyti patalus.<br /> 6 - Tris kartus ištarti maldavimus <span class="c2">(dua)</span> prieš miegą,<span class="c6"> kurie yra:</span> Ajatul-Kursi, sūra Al-Ikhlas, sūra Al-Falak ir sūra An-Nas,<span class="c6"> bei sakyti:</span> „Bismikallahumma amutu va ahja“ <span class="c2">(Vardan Allaho, aš mirštu ir atgyju)</span>.<br /> 7 - Atsikelti melstis Fadžr.<br /> 8 -<span class="c6"> Pabudus sakyti:</span> „Alhamdu lillahil-liadhi ahjana ba-da-ma amatana va ilaihin-nušur“ <span class="c2">(Šlovė Allahui, kuris davė mums gyvybę po to, kai ją iš mūsų atėmė, ir Jam priklauso prisikėlimas)</span>. </p>',
            ],
            11 => [
                'question' => '12 Klausimas: koks yra valgymo etiketas?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11290.mp3',
                'answer' => '<p> Atsakymas:<br /> 1 - Valgyti ir gerti su ketinimu įgyti jėgų garbinti Visagalį Allahą.<br /> 2 - Plauti rankas prieš valgant.<br /> 3 -<span class="c6"> Sakyti:</span> „bismilliah“ <span class="c2">(Allaho vardu)</span>, valgyti dešine ranka ir iš to, kas yra šalia, o ne iš lėkštės vidurio ar iš to, kas yra priešais kitus.<br /> 4 - Pamiršus prieš valgant pasakyti „bismilliah“,<span class="c6"> reikia pasakyti:</span> „bismilliah avaluhu va akhiruh“ <span class="c2">(vardan Allaho, pradžioje ir pabaigoje)</span>.<br /> 5 - Pasitenkinti turimu maistu ir jo nekritikuoti, t. y. valgyti, jei patinka, arba palikti, jei nepatinka.<br /> 6 - Pavalgyti kelis kąsnius ir susilaikyti nuo persivalgymo.<br /> 7 - Nepūsti į maistą ar gėrimą ir laukti, kol atvės.<br /> 8 - Valgyti kartu su šeima ar svečiais.<br /> 9 - Nepradėti valgyti anksčiau nei vyresnieji.<br /> 10 - Paminėti Allaho vardą prieš geriant, atsisėsti ir gerti trimis gurkšneliais.<br /> 11 - Pavalgius šlovinti Allahą. </p>',
            ],
            12 => [
                'question' => '13 Klausimas: koks yra apsirengimo etiketas?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11440.mp3',
                'answer' => '<p> Atsakymas: 1 - Pradėti vilktis drabužį dešine ranka ir šlovinti Allahą<br /> 2 - Nenuleisti drabužių žemiau kulkšnių.<br /> 3 - Berniukai neturėtų dėvėti mergaitiškų drabužių ir atvirkščiai.<br /> 4 - Nemėgdžioti netikinčiųjų ir piktadarių apsirengimu.<br /> 5 - Paminėti Allaho vardą rengiantis.<br /> 6 - Pradėti nuo dešinės aunantis batus ir nuo kairės juos nusiaunant. </p>',
            ],
            13 => [
                'question' => '14 Klausimas: paminėk važiavimo etiketą.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11540.mp3',
                'answer' => '<p> Atsakymas: 1 -<span class="c6"> Sakyti:</span> „bismilliah, alhamdulilliah“ <span class="c2">(vardan Allaho, šlovė Allahui)</span>. { „Garbė Tam, Kuris suteikė tai mums, o mes galėjome niekada to neturėti <span class="c2">(savo pastangomis)</span>. <span class="c2">(13)</span> Ir tikrai, pas Savo Viešpatį mes sugrįšime.“ <span class="c2">(14)</span>} <span class="c5">[Koranas,<span class="c6"> sūra „Auksinės puošmenos“ 43:</span>13-14]</span>.<br /> 2 - Praeinant pro musulmoną, jį pasveikinti. </p>',
            ],
            14 => [
                'question' => '15 Klausimas: paminėk kelio etiketą.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11590.mp3',
                'answer' => '<p> Atsakymas: 1 - Eiti ramiai ir kukliai dešine kelio puse.<br /> 2 - Sveikinti sutiktuosius savo kelyje.<br /> 3 - Nuleisti akis ir nieko neįžeisti.<br /> 4 - Mėgautis gėriu ir uždrausti blogį.<br /> 5 - Pašalinti nuo kelio viską, kas žalinga. </p>',
            ],
            15 => [
                'question' => '16 Klausimas: paminėk įėjimo ir išėjimo iš namų etiketą.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11670.mp3',
                'answer' => '<p> Atsakymas: 1 -<span class="c6"> Išeiti iš namų kaire koja sakant:</span> „Bismilliah, tavakaltu alallah, la haula vala kuvata illa billah, allahuma ini auzu bika an adila vu udall, au azila ava uzal, au azlim au uzlam, au adžhal au judžhal alai“ <span class="c2">(pasikliauju Allahu ir nėra jokios jėgos ar stiprybės, išskyrus Allahą. O Allah, aš ieškau prieglobsčio pas Tave nuo paklydimo, suklupimo, engimo ir nuo nemokšiško elgesio)</span>. 2 - Įeiti į namus dešine koja,<span class="c6"> sakant:</span> „Bismilliahi valadžna, va bismilliahi kharadžna, va ala rabina tavakalna“ <span class="c2">(Alaho vardu mes įeiname, Allaho vardu išeiname, ir pasitikime savo Viešpačiu)</span>.<br /> 3 - Naudoti sivak <span class="c2">(dantų valymo šakelę)</span>, tada sveikintis su žmonėmis. </p>',
            ],
            16 => [
                'question' => '17 Klausimas: paminėk tuštinimosi etiketą.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11730.mp3',
                'answer' => '<p> Atsakymas: 1 - Įeiti kaire koja.<br /> 2 -<span class="c6"> Prieš įeinant ištarti:</span> „Bismilliah, allahuma ini auzu bika minal-khubs val-khabais“ <span class="c2">(Allaho vardu, aš ieškau prieglobsčio pas Tave nuo vyriškų ir moteriškų velnių)</span>.<br /> 3 - Nedėvėti to, ant ko užrašytas Allaho vardas.<br /> 4 - Tuštinimosi metu apsidengti <span class="c2">(kai reikia)</span>.<br /> 5 - Nekalbėti tuštinimosi vietoje.<br /> 6 - Neatsigręžti į kiblą bei neatsukti jai nugaros šlapinimosi ar tuštinimosi metu.<br /> 7 - Kaire ranka pašalinti nešvarumus <span class="c2">(apsivalyti)</span>.<br /> 8 - Nesituštinti ant kelio, kuriuo žmonės eina, ar šešėlyje, kuriame jie sėdi.<br /> 9 - Nusiplauti rankas po tuštinimosi.<br /> 10 -<span class="c6"> Išeiti iš tuštinimosi vietos dešine koja sakant:</span> „ghufranak“ <span class="c2">(Tavo atleidimo prašau, o Viešpatie)</span>. </p>',
            ],
            17 => [
                'question' => '18 Klausimas: paminėk mečetės etiketą.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11860.mp3',
                'answer' => '<p> Atsakymas: 1 -<span class="c6"> Įeinant į mečetę dešine koja sakyti:</span> „Bismilliah, allahumaftah li abvaba rahmatik“ <span class="c2">(Vardan Allaho. O Allah, atverk man Savo Gailestingumo duris)</span>.<br /> 2 - Neatsisėsti prieš tai nepasimeldus dviejų rakatų maldos.<br /> 3 - Nepraeiti prieš besimeldžiančius žmones, neskelbti apie prarastą daiktą bei nepardavinėti ar nepirkti mečetėje.<br /> 4 -<span class="c6"> Išeiti iš mečetės kaire koja sakant:</span> „Allahuma ini as-aluka min fadlik“ <span class="c2">(O Allah, aš prašau Tavo malonės)</span>. </p>',
            ],
            18 => [
                'question' => '19 Klausimas: paminėk pasisveikinimo etiketą.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11930.mp3',
                'answer' => '<p> Atsakymas: 1 - Susitikus su musulmonu jį pasveikinti,<span class="c6"> sakant:</span> „assalamu alaikum va rahmatullahi va barakatuh“ <span class="c2">(tebūnie jums ramybė, Allaho gailestingumas ir palaiminimai)</span>. Toks turi būti pasveikinimas ir vien rankos gesto neužtenka.<br /> 2 - Pasveikinti kitus su šypsena veide.<br /> 3 - Paspausti dešinę ranką.<br /> 4 - Į pasisveikinimą atsakyti geresniu <span class="c2">(išsamesniu)</span> arba tuo pačiu pasisveikinimu.<br /> 5 - Nereikia pradėti pirmam sveikinti netikintįjį. Jei jis pasisveikina, tada reikia atsakyti jam panašiai.<br /> 7 - Jauni turi sveikinti senus, važiuojantys - einančius, vaikščiojantys - sėdinčius, o mažesnė grupė - didesnę. </p>',
            ],
            19 => [
                'question' => '20 Klausimas: paminėk leidimo prašymo etiketą.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12020.mp3',
                'answer' => '<p> Atsakymas: 1 - Prašyti leidimo prieš kažkur įeinant.<br /> 2 - Tris kartus, ir ne daugiau, prašyti leidimo, po to išeiti.<br /> 3 - Švelniai belstis į duris ir nestovėti priešais, bet dešinėje arba kairėje.<br /> 4 - Neįeiti į savo tėvų ar kieno nors kito kambarį prieš prašant leidimo, ypač prieš aušrą, per vidurdienį ir po iša maldos.<br /> 5 - Leidžiama užeiti į viešas vietas, tokias kaip ligoninė ar parduotuvė, neprašant leidimo. </p>',
            ],
            20 => [
                'question' => '21 Klausimas: paminėk gailestingumo gyvūnams etiketą.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12100.mp3',
                'answer' => '<p> Atsakymas: 1 - Gyvūnui duoti ėsti ir gerti.<br /> 2 - Parodyti gailestingumą gyvūnui ir neapkrauti jo tuo, ko jis negali padaryti.<br /> 3 - Susilaikyti nuo bet kokio gyvūno kankinimo ar prievartos. </p>',
            ],
            21 => [
                'question' => '22 Klausimas: paminėk sporto etiketą.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12160.mp3',
                'answer' => '<p> Atsakymas: 1 - Sportuoti su ketinimu sustiprinti savo kūną paklusnumui Allahui ir poelgiams, kurie patinka Allahui.<br /> 2 - Nesportuoti, kai ateina maldos laikas.<br /> 3 - Berniukai neturėtų sportuoti su mergaitėmis.<br /> 4 - Dėvėti sportinius drabužius, dengiančius aurą <span class="c2">(privačias kūno dalis)</span>.<br /> 5 - Vengti draudžiamų sporto šakų, kur reikia smogti į veidą ar atidengti aurą. </p>',
            ],
            22 => [
                'question' => '23 Klausimas: paminėk kai kuriuos juokavimo etiketus.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12240.mp3',
                'answer' => '<p> Atsakymas: 1 - Būti nuoširdžiam ir nemeluoti juokaujant.<br /> 2 - Juokaujant negalima tyčiotis, pajuokti, skriausti ir bauginti kitų.<br /> 3 - Susilaikyti nuo dažno juokavimo. </p>',
            ],
            23 => [
                'question' => '24 Klausimas: paminėk čiaudėjimo etiketą.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12300.mp3',
                'answer' => '<p> Atsakymas: 1 - Uždėti ranką, drabužį ar nosinę ant burnos čiaudint.<br /> 2 -<span class="c6"> Šlovinti Allahą nusičiaudėjus sakant:</span> „alhamdulillah“ <span class="c2">(šlovė Allahui)</span>.<br /> 3 -<span class="c6"> Išgirdus nusičiaudėjusį sakyti:</span> „jarhamukallah“ <span class="c2">(tegul Allahas tavęs pasigaili)</span>.<span class="c6"><br /> Į tai nusičiaudėjusysis turi atsakyti sakydamas:</span> „jahdikumullah va juslih balakum“ <span class="c2">(tegul Allahas nukreipia jus teisingu keliu ir pagerina jūsų būklę)</span>. </p>',
            ],
            24 => [
                'question' => '25 Klausimas: paminėk žiovavimo etiketą.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12360.mp3',
                'answer' => '<p> Atsakymas: 1 - Bandyti nuslopinti žiovulį.<br /> 2 - Nekelti balso žiovaujant.<br /> 3 - Ranką uždėti ant burnos. </p>',
            ],
            25 => [
                'question' => '26 Klausimas: paminėk Korano recitavimo etiketą.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12420.mp3',
                'answer' => '<p> Atsakymas: 1 - Recituoti tyrumo būsenoje po apsiplovimo.<br /> 2 - Mandagiai ir oriai sėdėti.<br /> 3 - Recitavimo pradžioje ieškoti prieglobsčio pas Allahą nuo šėtono <span class="c2">(t. y.,<span class="c6"> sakyti:</span> auzu billahi minaš-šaitanir-radžim)</span>.<br /> 4 - Apmąstyti recitaciją. </p>',
            ],
        ],
        7 => [
            0 => [
                'question' => '1 Klausimas: paminėk geros moralės privalumus?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12500.mp3',
                'answer' => '<p> Atsakymas: Pranašas <span class="c2">(ramybė ir Allaho palaima jam)</span> pasakė: „Tobuliausią tikėjimą turi geriausiai besielgiantys tikintieji.“ Perdavė At-Tirmizi ir Ahmed. </p>',
            ],
            1 => [
                'question' => '2 Klausimas: kodėl turėtume laikytis islamo moralės?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12530.mp3',
                'answer' => '<p> Atsakymas: 1 - Nes tai veda į meilę Allahui.<br /> 2 - Tai veda į meilę kūrinijai.<br /> 3 - Tai yra sunkiausias dalykas Svarstyklėse.<br /> 4 - Tai veda prie gausesnio atlygio.<br /> 5 - Tai tobulo tikėjimo ženklas. </p>',
            ],
            2 => [
                'question' => '3 Klausimas: iš kur turėtume gauti moralės standartus?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12600.mp3',
                'answer' => '<p> Atsakymas: iš Kilniojo Korano,<span class="c6"> kaip Visagalis tarė:</span> <span class="c4">{ Iš tiesų, šis Koranas veda į tai, kas teisingiausia}</span> <span class="c5">[Koranas,<span class="c6"> sūra „Nakties kelionė“ 17:</span>9]</span>. Ir iš Pranašo sunnos kaip Pasiuntinys <span class="c2">(ramybė ir Allaho palaima jam)</span> pasakė: „Buvau pasiųstas ištobulinti geras manieras.“ Perdavė Ahmed. </p>',
            ],
            3 => [
                'question' => '4 Klausimas: koks yra ihsan (tobulumas religijoje) ir jo pavyzdžiai?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12640.mp3',
                'answer' => '<p> Atsakymas: ihsan reiškia nuolat klausyti Allaho ir elgtis maloniai bei geranoriškai visų būtybių atžvilgiu.<span class="c6"><br /> Pranašas tarė:</span> „Iš tiesų, Allahas įsakė gerumą viskam.“ Perdavė Muslim.<span class="c6"><br /> Ihsan pavyzdžiai:</span><br /> . Geranoriškumas garbinant Visagalį Allahą, skiriant garbinimą visiškai nuoširdžiai Jam.<br /> . Geranoriškumas tėvams žodžiais ir poelgiais.<br /> . Geranoriškumas giminaičiams ir artimiesiems.<br /> . Geranoriškumas kaimynams.<br /> . Geranoriškumas našlaičiams ir vargstantiems.<br /> . Geranoriškumas tam, kuris tave įžeidė.<br /> . Geranoriškumas kalbant.<br /> . Geranoriškumas ginčuose.<br /> . Geranoriškumas gyvūnams. </p>',
            ],
            4 => [
                'question' => '5 Klausimas: kas yra ihsan priešingybė?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12780.mp3',
                'answer' => '<p> Atsakymas: ihsan priešingybė yra isa-a <span class="c2">(įžeidimas)</span>.<span class="c6"><br /> Įžeidimo pavyzdžiai:</span> - Nenuoširdumas garbinant Visagalį Allahą.<br /> - Blogas elgesys su savo tėvais.<br /> - Giminystės ryšių nutraukimas.<br /> - Blogas elgesys su kaimynams.<br /> - Atsisakymas daryti gera vargšams ir skurstantiems, ir kiti blogi dalykai. </p>',
            ],
            5 => [
                'question' => '6 Klausimas: kokios yra ištikimybės (amana) rūšys ir apraiškos?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12860.mp3',
                'answer' => '<p> Atsakymas:<br /> 1 - Ištikimybė išsaugant Visagalio Allaho teises.<span class="c6"><br /> Jos apraiškos:</span> ištikimybė atliekant ritualus – maldą, zakatą, pasninką, hadžą ir kitas religines pareigas.<br /> 2 -<span class="c6"> Ištikimybė išsaugant kitų teises:</span><br /> - saugoti žmonių garbę.<br /> - saugoti žmonių turtą.<br /> - saugoti žmonių gyvybes.<br /> - saugoti žmonių paslaptis ir viską, ką jie jums patikėjo.<br /> Visagalis Allahas tarė,<span class="c6"> išvardindamas sėkmingųjų savybes:</span> {Tie, kurie yra ištikimai atsidavę savo Amanat <span class="c2">(visoms pareigoms, kurias Allahas įsakė, sąžiningumui, moralinei atsakomybei ir patikėtiems dalykams)</span> ir savo įsipareigojimams} <span class="c5">[Koranas,<span class="c6"> sūra „Tikintieji“ 23:</span>8]</span>. </p>',
            ],
            6 => [
                'question' => '7 Klausimas: kas yra ištikimybės priešingybė?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12980.mp3',
                'answer' => '<p> Atsakymas: Išdavystė, o tai reiškia Visagalio Allaho ir žmonių teisių švaistymą.<br /> Pranašas <span class="c2">(ramybė ir Allaho palaima jam)</span> pasakė: „Yra trys veidmainio požymiai“ tarp kurių jis paminėjo: „... o jei jam patikėta, jis išduoda pasitikėjimą“. Al-Bukhari ir Muslim. </p>',
            ],
            7 => [
                'question' => '8 Klausimas: kas yra teisingumas?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13020.mp3',
                'answer' => '<p> Atsakymas: kai mes sakome viską taip, kaip yra, arba kai mūsų žodžiai atitinka tikrovę.<span class="c6"><br /> Jo apraiškos apima:</span><br /> - sąžiningumas kalbant su žmonėmis.<br /> - sąžiningumas duodant pažadą.<br /> - sąžiningumas visuose žodžiuose ir veiksmuose.<br /> Pranašas <span class="c2">(ramybė ir Allaho palaima jam)</span> pasakė: „Sąžiningumas veda į teisumą, o teisumas veda į Rojų. O žmogus ir toliau sako tiesą, kol tampa teisingiausu žmogumi <span class="c2">(sidik)</span>.“ Al-Bukhari ir Muslim. </p>',
            ],
            8 => [
                'question' => '9 Klausimas: Kas yra teisingumo priešingybė?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13100.mp3',
                'answer' => '<p> Atsakymas: Melas, o tai yra tiesos priešingybė.<span class="c6"> Pavyzdžiai:</span> melas žmonėms, pažadų netęsėjimas ir melagingi parodymai.<br /> Pranašas <span class="c2">(ramybė ir Allaho palaima jam)</span> pasakė: „Melas veda į nedorybę, o nedorybė veda į pragarą. O žmogus ir toliau meluoja, kol bus užrašytas pas Allahą melagiu.“ Al-Bukhari ir Muslim. Pranašas <span class="c2">(ramybė ir Allaho palaima jam)</span> dar pasakė: „Yra trys veidmainio požymiai“,<span class="c6"> tarp kurių jis paminėjo:</span> „Kalbėdamas meluoja, o pažadėdamas pažadą sulaužo.“ Al-Bukhari ir Muslim. </p>',
            ],
            9 => [
                'question' => '10 Klausimas: paminėkite kantrybės rūšis?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13140.mp3',
                'answer' => '<p> Atsakymas: - kantrybė paklūstant Visagaliam Allahui.<br /> - kantrybė susilaikant nuo nuodėmių.<br /> - kantrybė mums nemalonaus likimo atžvilgiu ir Allaho šlovinimas bet kokiu atveju.<span class="c6"><br /> Tarė Visagalis:</span> { Ir Allahas myli As-Sabirun <span class="c2">(kantriuosius)</span>.} <span class="c5">[Koranas,<span class="c6"> sūra „Imrano giminė“ 3:</span>146]</span>. Pranašas <span class="c2">(ramybė ir Allaho palaima jam)</span> pasakė: „Kokia nuostabi yra tikinčiojo būsena. Jam viskas yra gerai, ir tai nėra duota niekam, išskyrus tikinčiam. Jei jam atsitinka kas nors gero , jis padėkoja <span class="c2">(Allahui)</span> ir tai tampa jam gėriu. O jei jį ištinka nelaimė, jis ištveria kantriai ir taip jam geriau.“ Perdavė Muslim. </p>',
            ],
            10 => [
                'question' => '11 Klausimas: Kas yra kantrybės priešingybė?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13210.mp3',
                'answer' => '<p> Atsakymas: Nekantrumas yra kantrybės priešingybė ir reiškia parodyti nekantrumą paklūstant Allahui ir susilaikant nuo nuodėmių. Tai taip pat reiškia nepasitenkinimą Allaho lemtimi žodžiais ar darbais.<span class="c6"><br /> Jo apraiškos apima:</span><br /> - mirties linkėjimas.<br /> - plekšnojimas į skruostus.<br /> - drabužių plėšymas.<br /> - plaukų rovimasis.<br /> - mirties šaukimasis.<br /> Pranašas <span class="c2">(ramybė ir Allaho palaima jam)</span> pasakė: „Atlygio dydis eina kartu su kančios dydžiu. Kai Allahas, Didis ir Šlovingas, myli žmones, Jis juos išbando, ir tie, kurie tai priima, su malonumu sutinka Allaho malonę, o nepatenkintieji – Allaho nemalonę.“ Perdavė At-Tirmizi ir Ibn Madža. </p>',
            ],
            11 => [
                'question' => '12 Klausimas: koks yra bendradarbiavimo bruožas?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13310.mp3',
                'answer' => '<p> Atsakymas: tai žmonių bendradarbiavimas tiesoje ir gėryje.<span class="c6"><br /> Bendradarbiavimo pavyzdžiai:</span><br /> - bendradarbiavimas atkuriant teises.<br /> - bendradarbiavimas atremiant engėją.<br /> - bendradarbiavimas tenkinant žmonių ir vargstančiųjų poreikius.<br /> - bendradarbiavimas visokiausiame gėryje.<br /> - nebendradarbiavimas nuodėmėje, skriaudoje ir nusižengime.<span class="c6"><br /> Tarė Visagalis:</span> { Padėkite vienas kitam Al-Bir ir At-Takva <span class="c2">(dorume, teisingume ir dievobaimingume)</span>, tačiau nepadėkite vienas kitam nuodėmėje ir prasižengime. Ir bijokite Allaho. Iš tiesų, Allahas yra Rūstus bausdamas.} <span class="c5">[Koranas,<span class="c6"> sūra „Maistu padengtas stalas“ 5:</span>2]</span>. Pranašas <span class="c2">(ramybė ir Allaho palaima jam)</span> pasakė: „Tikinčiojo santykiai su kitu tikinčiuoju yra tarsi pastato <span class="c2">(plytos)</span>, kiekvienas stiprina kitą.“ Al-Bukhari ir Muslim. Pranašas <span class="c2">(ramybė ir Allaho palaima jam)</span> dar pasakė: „Musulmonas yra musulmono brolis; jis jo neskriaudžia ir neperduoda engėjui. Kas tenkina savo brolio poreikius, Allahas patenkins jo poreikius; o kas atleidžia musulmoną nuo naštos, Allahas atleis jį nuo naštos iš Prikėlimo dienos naštų; ir kas pridengs musulmoną <span class="c2">(jo klaidas)</span>, Allahas pridengs <span class="c2">(jo klaidas)</span> Prikėlimo dieną.“ Al-Bukhari ir Muslim. </p>',
            ],
            12 => [
                'question' => '13 Klausimas: kokie yra haja (drovumo) tipai?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13420.mp3',
                'answer' => '<p> Atsakymas: 1. Drovumas Allaho atžvilgiu, Jam nepaklusus.<br /> 2. Drovumas žmonių atžvilgiu, susilaikant nuo nešvankių ir nepadorių kalbų ir nuo auros atskleidimo.<br /> Tarė Allaho Pasiuntinys <span class="c2">(ramybė ir Allaho palaima jam)</span>: „Tikėjimas turi daugiau nei septyniasdešimt šakų“ arba „daugiau nei šešiasdešimt šakų“ -<span class="c6"> „Iš kurių geriausia yra sakyti:</span> nėra kito dievo, išskyrus Allahą; o mažiausias iš jų yra kenksmingų objektų pašalinimas nuo kelio; ir drovumas - viena iš tikėjimo šakų.“ Perdavė Muslim. </p>',
            ],
            13 => [
                'question' => '14 Klausimas: paminėk gailestingumo bruožo pavyzdžius.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13470.mp3',
                'answer' => '<p> Atsakymas: - būti gailestingu seniems žmonėms ir gerbti juos.<br /> - būti gailestingu jaunimui ir vaikams.<br /> - Būti gailestingu vargšams ir skurstantiems.<br /> - būti gailestingu gyvūnams, juos šeriant ir nekenkiant jiems.<br /> Šiuo atžvilgiu Pranašas <span class="c2">(ramybė ir Allaho palaima jam)</span> pasakė: „Tikinčiuosius jų abipusiu gailestingumu,<span class="c6"> meile ir užuojauta rasite kaip vieną kūną:</span> jei kenčia vienas iš jo organų, visas kūnas reaguos su nemiga ir karščiavimu.“ Al-Bukhari ir Muslim. Tarė Allaho Pasiuntinys <span class="c2">(ramybė ir Allaho palaima jam)</span>: „Gailestingųjų pasigailės Gailestingasis. Būkite gailestingi tiems, kurie yra žemėje, ir Tas, Kuris yra danguje, bus Gailestingas jums.“ Perdavė Abu Davud ir At-Tirmizi. </p>',
            ],
            14 => [
                'question' => '15 Klausimas: kokios yra meilės rūšys?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13550.mp3',
                'answer' => '<p> Atsakymas: - meilė Visagaliam Allahui.<span class="c6"><br /> Tarė Visagalis:</span> { Bet tie, kurie tiki, myli Allahą labiau <span class="c2">(nei ką nors kitą)</span>.} <span class="c5">[Koranas,<span class="c6"> sūra „Karvė“ 2:</span>165]</span>.<br /> - meilė Allaho Pasiuntiniui <span class="c2">(ramybė ir Allaho palaima jam)</span>.<br /> Tarė <span class="c2">(ramybė ir Allaho palaima jam)</span>: „Prisiekiu Tuo, Kurio rankoje yra mano siela, nė vienas iš jūsų nepasieks tobulo tikėjimo, kol nebūsiu jam brangesnis už jo tėvą ir jo vaiką.“ Perdavė Al-Bukhari.<br /> Meilė tikintiesiems ir linkėjimas jiems gėrio taip, kaip linkime sau.<br /> Pranašas <span class="c2">(ramybė ir Allaho palaima jam)</span> pasakė: „Nė vienas iš jūsų netiki, kol nelinki savo broliui to, ką linki pats sau.“ Perdavė Al-Bukhari. </p>',
            ],
            15 => [
                'question' => '16 Klausimas: apibrėžk linksmumą.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13630.mp3',
                'answer' => '<p> Atsakymas: tai linksmas ir laimingas veidas su šypsena, draugiškumas ir maloningumas susitikus su žmonėmis.<br /> Tai priešinga susiraukimui prieš žmones, o tai yra atstumiantis poelgis.<br /> Daugelis hadisų mini linksmumo privalumus, tarp jų yra hadisas, kuriame Abu Zar <span class="c2">(tebūnie Allahas juo patenkintas)</span> pranešė, kad Pranašas <span class="c2">(ramybė ir Allaho palaima jam)</span> pasakė: „Nenureikšmink jokio gero poelgio, net jei tai būtų brolio sutikimas linksmu veidu.“ Perdavė Muslim. Tarė Allaho Pasiuntinys <span class="c2">(ramybė ir Allaho palaima jam)</span>: „Šypsojimasis savo broliui yra labdara.“ Perdavė At-Tirmizi. </p>',
            ],
            16 => [
                'question' => '17 Klausimas: kas yra pavydas?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13690.mp3',
                'answer' => '<p> Atsakymas: tai noras, kad dingtų kitų palaiminimas, arba nekentimas matyti, kad kiti mėgaujasi palaima.<span class="c6"><br /> Tarė Visagalis:</span> <span class="c4">{ ir nuo blogio pavyduolio, kai jis pavydi.“}</span> <span class="c5">[Koranas,<span class="c6"> sūra „Aušra“ 113:</span>5]</span><br /> Anas Ibn Malik <span class="c2">(tebūnie Allahas juo patenkintas)</span> pranešė, kad Pasiuntinys <span class="c2">(ramybė ir Allaho palaima jam)</span> pasakė: „Nejauskite neapykantos ir nepavydėkite vieni kitiems ir nenusukite vienas kitam nugaros, bet būkite, o Allaho tarnai, kaip broliai.“ Perdavė Al-Bukhari ir Muslim. </p>',
            ],
            17 => [
                'question' => '18 Klausimas: kas yra pasityčiojimas?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13740.mp3',
                'answer' => '<p> Atsakymas: tai yra tyčiojimasis iš savo brolio musulmono ir jo niekinimas, o tai neleistina.<br /> Uždrausdamas tyčiotis,<span class="c6"> Visagalis Allahas tarė:</span> { O jūs, kurie tikite! Neleiskite vieniem <span class="c2">(vyram)</span> šaipytis iš kitų, nes kiti gali būti geresni už juos. Ir neleiskite vienoms moterims šaipytis iš kitų moterų, nes kitos gali būti geresnės už jas. Ir nežeminkite vieni kitų, bei nesikreipkite blogomis pravardėmis. Ir kaip blogai yra vadinti savo brolį <span class="c2">(nusidėjėliu ar nedorėliu)</span> kuomet <span class="c2">(jis yra priėmęs)</span> tikėjimą. Ir kas neatgailauja, tie yra Zalimūn <span class="c2">(nedorėlis, piktadariys ir t. t.)</span>.} <span class="c5">[Koranas,<span class="c6"> sūra „Kambariai“ 49:</span>11]</span> </p>',
            ],
            18 => [
                'question' => '19 Klausimas: apibrėžk kuklumą.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13780.mp3',
                'answer' => '<p> Atsakymas: tai yra negalvoti, kad vienas yra geresnis už kitus žmones, taigi žmogus neniekina žmonių ir neatmeta tiesos.<span class="c6"><br /> Tarė Visagalis:</span> { Ir <span class="c2">(ištikimi)</span> Maloningiausiojo <span class="c2">(Allaho)</span> vergai yra tie, kurie vaikšto žeme kukliai ir ramiai} <span class="c5">[Koranas,<span class="c6"> sūra „Atskyrimas“ 25:</span>63]</span>. T. y., jie yra nuolankūs. Tarė Allaho Pasiuntinys <span class="c2">(ramybė ir Allaho palaima jam)</span>: „Allahas tikrai išaukštins tą, kuris yra nuolankus Jam.“ Perdavė Muslim.<span class="c6"> Ir tarė:</span> „Allahas man nurodė, kad jūs visi turite būti kuklūs, kad žmonės nesididžiuotų vieni kitais ir kad neskriaustų vienas kito.“ Perdavė Muslim. </p>',
            ],
            19 => [
                'question' => '20 Klausimas: kokios yra draudžiamos arogancijos rūšys?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13840.mp3',
                'answer' => '<p> Atsakymas: 1 - Arogancija sprendžiant tiesą, t. y. tiesos atmetimas ir nepriėmimas.<br /> 2 - Arogancija bendraujant su žmonėmis, t. y. tyčiojimasis bei jų niekinimas.<br /> Tarė Allaho Pasiuntinys <span class="c2">(ramybė ir Allaho palaima jam)</span>: „Kas turi atomo svorio arogancijos savo širdyje, nepateks į Rojų.<span class="c6">“ Vyras pasakė:</span> „O kas, jei žmogui patinka,<span class="c6"> kad drabužiai ir batai yra gražūs?“ Pranašas atsakė:</span> „Iš tiesų, Allahas yra Gražus ir myli grožį. Arogancija yra tiesos atmetimas ir žvelgimas į žmones iš aukšto.“ Perdavė Muslim.<br /> „Tiesos atmetimas“ - jos nepriėmimas.<br /> „Žvelgimas į žmones iš aukšto“ - jų niekinimas.<br /> Nešioti gražiai atrodančius drabužius ir avalynę nėra arogancija. </p>',
            ],
            20 => [
                'question' => '21 Klausimas: paminėk kai kuriuos draudžiamo sukčiavimo tipus.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13910.mp3',
                'answer' => '<p> Atsakymas: - Sukčiavimas parduodant ir perkant, slepiant prekės trūkumą.<br /> - Sukčiavimas mokantis, kaip ir mokinių sukčiavimas per egzaminus.<br /> - Sukčiavimas kalbant, kaip melagingas liudijimas ir melas.<br /> - Sutarčių pažeidimas.<br /> Apgaudinėjimo draudimas yra paminėtas hadise, kuriame pranešama, kad Pasiuntinys <span class="c2">(ramybė ir Allaho palaima jam)</span> kartą priėjo prie maisto krūvos, o kai įkišo į ją ranką, pirštai pajuto drėgmę. Taigi,<span class="c6"> jis paklausė:</span> „Kas tai yra,<span class="c6"> o maisto savininke?“ Vyras atsakė:</span> „Ant jų iškrito lietus, o Allaho Pasiuntiny“,<span class="c6"> po to Pranašas pasakė:</span> „Kodėl nepalikai drėgnos dalies iš viršaus, kad žmonės tai matytų? Kas apgaudinėja, tai neturi nieko bendra su manimi.“ Perdavė Muslim.<br /> „Maisto krūva“ - grūdų krūva. </p>',
            ],
            21 => [
                'question' => '22 Klausimas: kas yra apkalbinėjimas?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13990.mp3',
                'answer' => '<p> Atsakymas: tai yra savo brolio musulmono paminėjimas jam nesant taip, kaip jam nepatiktų.<span class="c6"><br /> Tarė Visagalis:</span> { ir neapkalbinėkite vienas kito. Ar vienas jūsų norėtų valgyti savo mirusio brolio mėsą? Jūs to nekęstumėte <span class="c2">(todėl nekęskite apkalbinėjimo)</span>. Ir bijokite Allaho. Iš tiesų, Allahas yra Tas, Kuris atleidžia ir priima atgailą, Gailestingiausias.} <span class="c5">[Koranas,<span class="c6"> sūra „Kambariai“ 49:</span>12]</span> </p>',
            ],
            22 => [
                'question' => '23 Klausimas: kas yra apkalbos?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14030.mp3',
                'answer' => '<p> Atsakymas: tai vienas kito žodžių skleidimas tarp žmonių, siekiant sukelti žmonių nepasitikėjimą ir nesutarimus.<br /> Tarė Allaho Pasiuntinys <span class="c2">(ramybė ir Allaho palaima jam)</span>: „Apkalbinėtojas nepateks į Rojų.“ Perdavė Muslim. </p>',
            ],
            23 => [
                'question' => '24 Klausimas: kas yra tinginystė?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14070.mp3',
                'answer' => '<p> Atsakymas: tai vengimas daryti gerus darbus ir vykdyti pareigas.<br /> Tai apima tinginystę atliekant religines pareigas.<span class="c6"><br /> Tarė Visagalis Allahas:</span> { Iš tiesų, veidmainiai siekia apgauti Allahą, tačiau Jis yra Tas, Kuris apgauna juos. <span class="c5">[19]</span> Ir kai jie stojasi <span class="c2">(atlikti)</span> As-Salat <span class="c2">(maldą)</span>, jie stojasi tingiai ir tik tam, kad žmonės pamatytų, ir jie neprisimena Allaho, tik truputį.} <span class="c5">[Koranas,<span class="c6"> sūra „Moterys“ 4:</span>142]</span>.<br /> Taigi, tikintysis turėtų atsikratyti tinginystės, neveiklumo ir nesėdėti be darbo. Priešingai, jis turėtų būti aktyvus ir kruopštus, judėti, dirbti, dėti pastangas savo žemiškame gyvenime bei stengtis įtikti Allahui. </p>',
            ],
            24 => [
                'question' => '25 Klausimas: paminėk pykčio tipus.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14130.mp3',
                'answer' => '<p> Atsakymas: 1 -<span class="c6"> Pagirtinas pyktis:</span> tai pyktis, kurį žmogus jaučia dėl Allaho, jei netikintieji, veidmainiai ar kiti pažeidžia bet kurias Jo ribas.<br /> 2 -<span class="c6"> Nepagirtinas pyktis:</span> pyktis, kuris skatina sakyti ir daryti tai, ko neturėtų.<span class="c6"><br /> Nepagirtinio pykčio gydymas:</span><br /> Apsiplovimas <span class="c2">(vudu)</span>.<br /> Kas stovi, turi atsisėsti, o sėdintis - atsigulti.<br /> Laikytis Pranašo patarimo šiuo klausimu,<span class="c6"> kaip jis pasakė:</span> „Nepyk“.<br /> Suvaldyti save pykčio metu.<br /> Ieškoti prieglobsčio pas Allahą nuo prakeikto šėtono.<br /> Tylėti. </p>',
            ],
            25 => [
                'question' => '26 Klausimas: kas yra šnipinėjimas?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14240.mp3',
                'answer' => '<p> Atsakymas: tai yra žmonių ydų ir tai, ką jie slepia, ieškojimas ir atskleidimas.<span class="c6"><br /> Draudžiamo šnipinėjimo pavyzdžiai:</span><br /> - Stengtis sužinoti privačius žmonių reikalus jų namuose.<br /> - Asmeninių žmonių pokalbių pasiklausymas.<span class="c6"><br /> Tarė Visagalis:</span> <span class="c4">{ Ir nešnipinėkite}</span> <span class="c5">[Koranas,<span class="c6"> sūra „Kambariai“ 49:</span>12]</span> </p>',
            ],
            26 => [
                'question' => '27 Klausimas: kas yra švaistymas? Kas yra šykštumas? Kas yra dosnumas?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14310.mp3',
                'answer' => '<p> Atsakymas: švaistymas yra neefektyvus pinigų išleidimas.<br /> Jo priešingybė - šykštumas, tai yra atsisakymas tinkamai leisti pinigus.<br /> Teisingiausia yra saikingas būdas tarp švaistymo ir šykštumo, t. y., būti dosniam.<span class="c6"><br /> Tarė Visagalis:</span> { Ir tie, kurie, kai jie leidžia, nėra nei išlaidūs nei šykštuoliai, tačiau laikosi vidurio <span class="c2">(kelio)</span> tarp to <span class="c2">(šių kraštutinumų)</span>.} <span class="c5">[Koranas,<span class="c6"> sūra „Atskyrimas“ 25:</span>63]</span>. </p>',
            ],
            27 => [
                'question' => '28 Klausimas: kas yra bailumas? Kas yra drąsa?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14370.mp3',
                'answer' => '<p> Atsakymas: bailumas yra bijojimas to, ko nereikėtų bijoti.<br /> Pavyzdžiui, bijoma pasakyti tiesą ar uždrausti blogį.<br /> Drąsa yra ryžtingai daryti tai, kas teisinga. Drąsos pavyzdys yra puolimas mūšyje, siekiant apsaugoti islamą ir musulmonus.<br /> Pranašas <span class="c2">(ramybė ir Allaho palaima jam)</span> maldaudamas sakydavo: „Allahumma ini auzu bika min al-džubn...“ <span class="c2">(O Allah! Aš prašau apsaugoti mane nuo bailumo.)</span> Tarė Allaho Pasiuntinys <span class="c2">(ramybė ir Allaho palaima jam)</span>: „Stiprus tikintysis yra geresnis ir brangesnis Allahui nei silpnas tikintysis, nors abiejuose yra gero.“ Perdavė Muslim. </p>',
            ],
            28 => [
                'question' => '29 Klausimas: paminėk kai kuriuos draudžiamus žodžius ir kalbas.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14440.mp3',
                'answer' => '<p> Atsakymas: - prakeikimai ir įžeidinėjimai.<br /> - sakyti, kad kažkas yra gyvulys ar pan.<br /> - necenzūrinių ar nepadorių žodžių sakymas.<br /> Pranašas <span class="c2">(ramybė ir Allaho palaima jam)</span> uždraudė visus tokius dalykus sakydamas: „Tikras tikintysis nedalyvauja nei patyčiose, nei dažnai keikiant <span class="c2">(kitus)</span>, nei jis būna nepadorus ar įžeidus.“ Perdavė At-Tirmizi ir Ibn Haban. </p>',
            ],
            29 => [
                'question' => '30 Klausimas: paminėk kai kuriuos metodus, kurie gali padėti musulmonui laikytis geros moralės.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14500.mp3',
                'answer' => '<p> Atsakymas: 1. Prašyti Allaho, kad jis suteiktų jums gerą moralę, ir prašyti Jo padėti jums jų laikytis.<br /> 2. Nuolat paisyti Visagalio Allaho ir žinoti, kad jis tave pažįsta, girdi ir mato.<br /> 3. Prisiminti atlygį už gerą moralę ir kad tai yra priežastis patekti į Rojų.<br /> 4. Prisiminti blogos moralės pasekmes ir kad tai yra priežastis patekti į Pragarą.<br /> 5. Gera moralė padeda laimėti Visagalio Allaho ir Jo kūrinijos meilę, o bloga moralė sukelia Allaho ir Jo kūrinijos rūstybę.<br /> 6. Skaityti Pranašo biografiją ir imti jį <span class="c2">(ramybė ir Allaho palaima jam)</span> sektinu pavyzdžiu.<br /> 7. Priimti gerus žmones kompanjonais ir vengti piktų žmonių draugijos. </p>',
            ],
        ],
        8 => [
            0 => [
                'question' => '1 Klausimas: koks yra Zikr (Allaho atminimo) nuopelnas?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14630.mp3',
                'answer' => '<p> Atsakymas: tarė Pranašas <span class="c2">(ramybė ir Allaho palaima jam)</span>: „Pavyzdys to, kuris prisimena savo Viešpatį, ir to, kuris Jo neprisimena, yra kaip gyvo ir mirusio žmogaus pavyzdys.“ Perdavė Al-Bukhari.<br /> - Taip yra todėl, kad žmogaus gyvenimo vertė priklauso nuo to, kaip dažnai jis prisimena Visagalį Allahą. </p>',
            ],
            1 => [
                'question' => '2 Klausimas: paminėk kai kuriuos Zikr privalumus.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14670.mp3',
                'answer' => '<p> Atsakymas: 1 - tai patinka Gailestingiausiajam.<br /> 2 - tai išvaro šėtoną.<br /> 3 - apsaugo musulmoną nuo blogio.<br /> 4 - atneša atlygį ir apdovanojimą. </p>',
            ],
            2 => [
                'question' => '3 Klausimas: koks yra geriausias Zikr?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14730.mp3',
                'answer' => '<p> Atsakymas: „La ilaha illallah“ <span class="c2">(nėra kito dievo, išskyrus Allahą)</span>. Perdavė At-Tirmizi ir Ibn Madža. </p>',
            ],
            3 => [
                'question' => '4 Klausimas: ką reikėtų pasakyti pabudus?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14760.mp3',
                'answer' => '<p> Atsakymas: „Alhamdulillahil-lazi ahjana badama amatana va ilaihin-nušur“ <span class="c2">(Garbė Allahui, Kuris davė mums gyvybę po to, kai leido mums mirti, ir pas Jį yra prisikėlimas)</span>. Al-Bukhari ir Muslim. </p>',
            ],
            4 => [
                'question' => '5 Klausimas: ką reikia pasakyti apsirengiant drabužį?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14790.mp3',
                'answer' => '<p> Atsakymas: „Alhamdulilliahil-lazi kasani haza as-sauba va razakanihi min ghairi haulin mini va la kuva“ <span class="c2">(Garbė Allahui, Kuris aprengė mane šiuo drabužiu ir davė kuomet aš pats neturėjau tam nei galimybių, nei jėgų)</span>. Perdavė Abu Davud, At-Tirmizi ir kt. </p>',
            ],
            5 => [
                'question' => '6 Klausimas: ką reikia pasakyti nusirengiant?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14820.mp3',
                'answer' => '<p> Atsakymas: „Bismillah“ <span class="c2">(Allaho vardu)</span>. Perdavė At-Tirmizi. </p>',
            ],
            6 => [
                'question' => '7 Klausimas: kokį maldavimą reikėtų pasakyti apsirengiant naują drabužį?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14850.mp3',
                'answer' => '<p> Atsakymas: „Allahumma lakal hamdu anta kasautanihi as-aluka khairahu va khaira ma suni-a lahu va auzu bika min šarihi va šari ma suni-a lah“ <span class="c2">(O Allah, šlovė tau, tu mane tuo aprengei. Aš prašau Tavęs jo gėrio ir gėrio to, kam jis buvo sukurtas, ir aš ieškau prieglobsčio pas Tave nuo jo blogio ir blogio to, kam jis buvo sukurtas)</span>. Perdavė Abu Davud ir At-Tirmizi. </p>',
            ],
            7 => [
                'question' => '8 Klausimas: kokį maldavimą reikėtų pasakyti, kai matai ką nors dėvintį naują drabužį?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14880.mp3',
                'answer' => '<p> Atsakymas: pamačius ką nors dėvintį naują drabužį,<span class="c6"> reikia dėl jo maldauti ir pasakyti:</span> „Tubli va jukhlifullahu ta-ala“ <span class="c2">(Tegul nusidėvi ir Visagalis Allahas duos tau kitą)</span>. Perdavė Abu Davud. </p>',
            ],
            8 => [
                'question' => '9 Klausimas: paminėk maldavimą, kurį reikėtų pasakyti įeinant į tualetą.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14910.mp3',
                'answer' => '<p> Atsakymas: „Allahumma ini auzu bika min al-khubsi val khaba-is“ <span class="c2">(O Allah, aš ieškau prieglobsčio pas Tave nuo vyriškų ir moteriškų velnių)</span>. Al-Bukhari ir Muslim. </p>',
            ],
            9 => [
                'question' => '10 Klausimas: kokį maldavimą reikėtų pasakyti išeinant iš tualeto?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14940.mp3',
                'answer' => '<p> Atsakymas: „Ghufranak“ <span class="c2">(Aš ieškau Tavo atleidimo)</span>. Perdavė Abu Davud ir At-Tirmizi. </p>',
            ],
            10 => [
                'question' => '11 Klausimas: ką reikėtų pasakyti prieš atliekant vudu (apsiplovimą)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14970.mp3',
                'answer' => '<p> Atsakymas: „Bismillah“ <span class="c2">(Allaho vardu)</span>. Perdavė Abu Davud ir kiti. </p>',
            ],
            11 => [
                'question' => '12 Klausimas: kokį Zikr reikėtų pasakyti atlikus vudu (apsiplovimą)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15000.mp3',
                'answer' => '<p> Atsakymas: „Ašhadu alla ilaha illa-llah vahdahu la šarika lah va ašhadu ana Muchammadan abduhu va rasuluh“ <span class="c2">(Liudiju, kad nėra jokio kito dievo, išskyrus Allahą Vieną, Kuris neturi partnerių, ir liudiju, kad Muchammedas yra Jo tarnas bei Pasiuntinys)</span>. Perdavė Muslim. </p>',
            ],
            12 => [
                'question' => '13 Klausimas: kokį Zikr reikėtų pasakyti išeinant iš namų?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15020.mp3',
                'answer' => '<p> Atsakymas: „Bismilliahi tavakaltu alallah, va la haula va la kuvata illa billah“ <span class="c2">(Vardan Allaho, aš pasitikiu Allahu, ir visa galia priklauso Allahui)</span>. Perdavė Abu Davud ir At-Tirmizi. </p>',
            ],
            13 => [
                'question' => '14 Klausimas: kokį Zikr reikėtų pasakyti įeinant į namus?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15050.mp3',
                'answer' => '<p> Atsakymas: „Bismillahi valadžna va bismilliahi kharadžna va ala llahi rabbina tavakalna“ <span class="c2">(Allaho vardu mes įeiname, Allaho vardu mes išeiname, ir Allahu, mūsų Viešpačiu, mes pasitikime)</span>, tada reikia pasveikinti savo šeimą. Perdavė Abu Davud. </p>',
            ],
            14 => [
                'question' => '15 Klausimas: kokį maldavimą reikėtų pasakyti įžengus į mečetę?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15080.mp3',
                'answer' => '<p> Atsakymas: „Allahumma-ftah li abvaba rahmatik“ <span class="c2">(O Allah, atidaryk man Savo gailestingumo duris)</span>. <span class="c5">[Perdavė Muslim]</span> </p>',
            ],
            15 => [
                'question' => '16 klausimas: paminėk maldavimą išeinant iš mečetės.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15110.mp3',
                'answer' => '<p> Atsakymas: „Allahumma ini as-aluka min fadlik“ <span class="c2">(O Allah, aš prašau Tavo malonės)</span>. <span class="c5">[Perdavė Muslim]</span> </p>',
            ],
            16 => [
                'question' => '17 Klausimas: ką reikėtų pasakyti išgirdus azaną (kvietimą maldai)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15140.mp3',
                'answer' => '<p> Atsakymas: Reikėtų kartoti tai, ką sako muazinas, išskyrus tuos atvejus,<span class="c6"> kai sako:</span> „Haj ala as-salah“ <span class="c2">(ateik į maldą)</span> ir „Haj ala al-falah“ <span class="c2">(ateik į sėkmę)</span>.<span class="c6"> Čia reikia pasakyti:</span> „La haula vala kuvata illa billah“ <span class="c2">(visa galia priklauso Allahui)</span>. Al-Bukhari ir Muslim. </p>',
            ],
            17 => [
                'question' => '18 Klausimas: ką reikėtų pasakyti po azano?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15170.mp3',
                'answer' => '<p> Atsakymas: prašyk palaiminimų už Pranašą <span class="c2">(ramybė ir Allaho palaima jam)</span>. Perdavė Muslim.<span class="c6"> Tada reikėtų pasakyti:</span> „Allahumma raba hazihi ad-davatit-tamah vasalatil ka-imah ati Muchammadan al-vasilata val fadilah vab-athu makaman mahmudan alazi va-adtah“ <span class="c2">(O Allah, šio tobulo kvietimo ir maldos Viešpatie, kuri netrukus bus atlikta, suteik Muchammedui užtarimo ir palankumo teisę ir pakelk jį į šlovingą padėtį, kurią jam pažadėjai)</span>. Perdavė Al-Bukhari.<br /> Taip pat reikia melstis Allahui tarp azano ir ikamos <span class="c2">(antrojo kvietimo maldai)</span>, nes tai laikas, kai prašymas nėra atmetamas. </p>',
            ],
            18 => [
                'question' => '19 Klausimas: kokie yra rytinis ir vakarinis Azkar (nurodytas reguliarių maldų rinkinys)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15220.mp3',
                'answer' => '<p> Atsakymas: 1 - recituok Ajat al-<span class="c6">Kursi:</span> { Allahas! La ilaha illa Huva <span class="c2">(niekas neturi teisės būti garbinamas, tik Jis)</span>, Al-Haiul-Kajum <span class="c2">(Amžinas, Tas, Kuris išlaiko ir saugo visa, kas egzistuoja)</span>, La ta khuzuhu sinatu va la naum <span class="c2">(Nei snaudulys, nei miegas Jo neapima)</span>, lahu ma fi samavati va ma fi-lard <span class="c2">(Jam priklauso viskas, kas yra danguose, ir viskas, kas yra žemėje)</span>, man zal-lazi jašfeu indahu ila bi-iznih <span class="c2">(Kas gali prašyti Jo užtarimo, išskyrus su Jo leidimu?)</span>, jalamu ma bajna aidihim va ma khalfahum <span class="c2">(Jis žino, kas nutinka jiems (Jo kūrinijai)</span> šiame pasaulyje ir kas nutiks jiems amžinybėje), va la juhituna bišajim-min ilmihi ila bima ša <span class="c2">(Ir jie niekada nesupras nieko iš Jo žinių, išskyrus tai, ką Jis panorės)</span>, va sia kursijuhu samavati va-lard <span class="c2">(Jo Kursi driekiasi virš dangų ir žemės)</span>, va la jauduhu hifzuhuma <span class="c2">(ir Jis nejaučia jokio nuovargio sergėdamas ir saugodamas juos)</span>, va huval-Alijul-Azim <span class="c2">(Ir Jis – Aukščiausiasis, Didingiausiasis)</span>.} <span class="c5">[Koranas,<span class="c6"> sūra „Karvė“ 2:</span>255]</span>. 2 -<span class="c6"> ir recituok:</span> Vardan Allaho, Maloningiausiojo,<span class="c6"> Gailestingiausiojo { Sakyk:</span> „Jis yra Allahas, <span class="c2">(Kuris yra)</span> Vienas. <span class="c2">(1)</span> Allahas, Amžinas Prieglobstis. <span class="c2">(2)</span> Nei Jis gimdo, nei yra gimęs, <span class="c2">(3)</span> nei yra Jam ko nors lygaus.“ <span class="c2">(4)</span>} Tris kartus. Vardan Allaho, Maloningiausiojo,<span class="c6"> Gailestingiausiojo { Sakyk:</span> „Aš ieškau prieglobsčio pas aušros Viešpatį <span class="c2">(1)</span> nuo blogio, kurį Jis sukūrė, <span class="c2">(2)</span> ir nuo tamsos blogio, kai ji nusileidžia, <span class="c2">(3)</span> ir nuo pūtėjų į mazgus blogio, <span class="c2">(4)</span> ir nuo blogio pavyduolio, kai jis pavydi.“ <span class="c2">(5)</span>} Tris kartus. Vardan Allaho, Maloningiausiojo,<span class="c6"> Gailestingiausiojo { Sakyk:</span> „Aš ieškau prieglobsčio pas žmonijos Viešpatį <span class="c2">(1)</span> žmonijos Valdovą, <span class="c2">(2)</span> žmonijos Dievą, <span class="c2">(3)</span> nuo blogio pasišalinančio šnabždėtojo, <span class="c2">(4)</span> kuris šnabžda <span class="c2">(blogį)</span> į žmonių krūtines, <span class="c2">(5)</span> iš džinų ir žmonių tarpo.“ <span class="c2">(6)</span>} Tris kartus. 3 - „Allahumma anta Rabi la ilaha illa ant, khalaktani va ana abduk, va ana ala ahdika va vadika mastatat, auzu bika min šari ma sanat, abu laka bi nimatika alaj, va abu bizanbi faghfir li fa-inahu la jaghfiruz-zunuba illa ant.“ <span class="c2">(O Allahai, Tu esi mano Viešpats, niekas neturi teisės būti šlovinamas išskyrus Tave, Tu mane sukūrei ir aš esu Tavo tarnas. Ir aš tvirtai laikausi Tavo sandoros ir pasižadu visu pajėgumu, aš ieškau prieglobsčio Tavy nuo piktadarystės, kurią įvykdžiau. Aš patvirtinu Tavo malonę man ir pripažįstu savo nuodėmes. Tad atleiski man, juk išties, niekas negali atleisti nuodėmių išskyrus Tave.)</span> Perdavė Al-Bukhari. </p>',
            ],
            19 => [
                'question' => '20 Klausimas: ką reikėtų pasakyti prieš miegą?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15290.mp3',
                'answer' => '<p> Atsakymas: „Bismikal-lahumma amutu va ahja“ <span class="c2">(Vardan Allaho, aš mirštu ir atgyju.)</span> Al-Bukhari ir Muslim. </p>',
            ],
            20 => [
                'question' => '21 Klausimas: ką reikėtų pasakyti prieš valgant?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15320.mp3',
                'answer' => '<p> Atsakymas: „Bismillah“ <span class="c2">(Allaho vardu)</span>.<br /> Jei žmogus pamiršta tai pasakyti prieš valgydamas,<span class="c6"> jis turėtų pasakyti:</span><br /> „Bismilliahi fi avalihi va akhirih“ <span class="c2">(Allaho vardu jo pradžioje ir pabaigoje)</span>. Perdavė Abu Davud ir At-Tirmizi. </p>',
            ],
            21 => [
                'question' => '22 Klausimas: ką reikėtų pasakyti pavalgius?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15370.mp3',
                'answer' => '<p> Atsakymas: „Alhamdullillahi al-lazi at-amani haza va razakanih min ghairi haulin mini vala kuvah“ <span class="c2">(Garbė Allahui, Kuris mane pamaitino ir aprūpino šiuo maistu kuomet aš pats neturėjau nei galimybių, nei jėgos)</span>. Perdavė Abu Davud, Ibn Madža ir kiti. </p>',
            ],
            22 => [
                'question' => '23 Klausimas: ką turėtų pasakyti svečias, maldaujantis už šeimininką?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15400.mp3',
                'answer' => '<p> Atsakymas: „Allahumma barik lahum fima razaktahum vaghfir lahum varhamuhum“ <span class="c2">(O Allah, palaimink juos tuo, ką jiems suteikei, ir atleisk jiems bei pasigailėk)</span>. Perdavė Muslim. </p>',
            ],
            23 => [
                'question' => '24 Klausimas: ką reikia pasakyti čiaudint?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15430.mp3',
                'answer' => '<p> Atsakymas: „Alhamdulilliah“ <span class="c2">(šlovė Allahui)</span>.<span class="c6"><br /> Nusičiaudėjusį girdint sakyti:</span> „jarhamukallah“ <span class="c2">(tegul Allahas tavęs pasigaili)</span>.<span class="c6"><br /> Į tai čiaudėjantis turi atsakyti sakydamas:</span> „jahdikumullah va juslih balakum“ <span class="c2">(tegul Allahas nukreipia jus teisingu keliu ir pagerina jūsų būklę)</span>. Perdavė Al-Bukhari. </p>',
            ],
            24 => [
                'question' => '25 Klausimas: ką reikėtų pasakyti išeinant iš surinkimo, t. y. „Susirinkimo pabaigos maldavimas“?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15480.mp3',
                'answer' => '<p> Atsakymas: „Subhanakal-lahumma va bihamdik, ašhadu alla ilaha illa ant, astaghfiruka va atubu ilaik“ <span class="c2">(Šlovė ir garbė Tau, o Allahai. Nėra jokio kito dievo, tik Tu. Aš ieškau Tavo atleidimo ir atgailauju Tau)</span>. Perdavė Abu Davud, At-Tirmizi ir kiti. </p>',
            ],
            25 => [
                'question' => '26 Klausimas: koks yra sėdimo į transporto priemonę maldavimas?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15510.mp3',
                'answer' => '<p> Atsakymas: „Bismillah valhamdulillah“ <span class="c2">(Allaho vardu ir šlovė Allahui)</span>, „Subhana al-lazi sakhara lana haza va ma kuna lahu mukrinin va ina ila rabina lamunkalibun“ <span class="c2">(Garbė Tam, Kuris suteikė tai mums, o mes galėjome niekada to neturėti (savo pastangomis)</span>. Ir tikrai, pas Savo Viešpatį mes sugrįšime.), „Alhamdulillah, alhamdulillah, alhamdulillah, Allahu akbar, Allahu akbar, Allahu akbar, subhanaka Allahuma ini dhalamtu nafsi faghfir li fa-inahu la jaghfiruz-zunuba illa ant“ <span class="c2">(Šlovė Allahui – tris kartus; Allahas yra Didis – tris kartus; Garbė tau, o Allahai, aš nusižengiau prieš save patį, todėl atleisk man, nes niekas negali atleisti nuodėmių, tik Tu)</span>. Perdavė Abu Davud ir At-Tirmizi. </p>',
            ],
            26 => [
                'question' => '27 Klausimas: paminėk kelionės maldavimą.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15540.mp3',
                'answer' => '<p> Atsakymas: „Allahu akbar, Allahu akbar, Allahu akbar“ <span class="c2">(Allahas yra Didis – tris kartus)</span>, „Subhana al-lazi sakhara lana haza va ma kuna lahu mukrinin va ina ila rabina lamunkalibun“ <span class="c2">(Garbė Tam, Kuris suteikė tai mums, ir mes galėjome niekada to neturėti (savo pastangomis)</span>. Ir tikrai, pas Savo Viešpatį mes sugrįšime.), "Allahumma ina nas-aluka fi safarina haza al-bira vat-takva va min al-amali ma tarda, allahumma havin alaina safarana haza vatvi ana budah, allahumma anta as-sahibu fis-safar va al-khalifatu fil ahl, allahumma ini auzu bika min vasa as-safar va ka-abat al-manzr va su-il-munkalab fil mali val ahl“ <span class="c2">(O Allahai, mes prašome Tavęs šioje mūsų kelionėje gerumo ir pamaldumo bei Tau malonių darbų. O Allahai, palengvink šią kelionę ir sumažink jos atstumą mums. O Allahai, Tu esi kelionės palydovas ir Tas, Kurio globai paliekame savo šeimą. O Allahai, aš ieškau Tavyje prieglobsčio nuo šios kelionės sunkumų, nuo baisių vaizdų ir nelaimės mūsų turtui ir šeimai)</span>.<span class="c6"><br /> Grįžus reikia pasakyti tą patį ir pridėti:</span><br /> „Ajibun ta-ibun abidun lirabina hamidun“ <span class="c2">(Grįžtame saugiai, atgailaudami kreipiamės į Viešpatį, garbiname Jį ir šloviname Jį)</span>. Perdavė Muslim. </p>',
            ],
            27 => [
                'question' => '28 Klausimas: kokį maldavimą iškeliaujantis turėtų pasakyti pasiliekantiems?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15590.mp3',
                'answer' => '<p> Atsakymas: „Astaudi-ukumullah al-lazi la tadi-u vada-i-uh“ <span class="c2">(Aš patikiu jus Allahui, Kurio pasitikėjimas niekada neprarandamas)</span>. Perdavė Ahmad ir Ibn Madža. </p>',
            ],
            28 => [
                'question' => '29 Klausimas: kokį maldavimą pasiliekantis turėtų pasakyti iškeliaujančiam?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15620.mp3',
                'answer' => '<p> Atsakymas: „Astaudi-ullaha dinak va amanatak va khavatima amalik“ <span class="c2">(Aš patikiu Allahui tavo religiją, pasitikėjimą ir paskutinius tavo darbus)</span>. Perdavė Ahmad ir At-Tirmizi. </p>',
            ],
            29 => [
                'question' => '30 Klausimas: kokį maldavimą sakome įeinant į turgų?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15650.mp3',
                'answer' => '<p> Atsakymas: „La ilaha illallah vahdahu la šarika lah, lahul mulk valahul hamd juhji va jumit bijadihi al-khair vahuva ala kuli šai-in kadir“ <span class="c2">(Nėra kito dievo, išskyrus Allahą, Vieną be partnerio. Jam priklauso viešpatavimas ir visas šlovinimas. Jis duoda gyvybę ir sukelia mirtį, Jis yra amžinai gyvas ir niekada nemiršta. Jo rankoje yra viskas, kas gera, ir Jis viską gali)</span>. Perdavė At-Tirmizi ir Ibn Madža. </p>',
            ],
            30 => [
                'question' => '31 Klausimas: paminėk maldavimą, kurį reikėtų pasakyti pykčio metu.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15680.mp3',
                'answer' => '<p> Atsakymas: „Auzu billahi minaš-šaitanir-radžim <span class="c2">(Ieškau prieglobsčio pas Allahą nuo prakeikiamojo šėtono)</span>.“ Al-Bukhari ir Muslim. </p>',
            ],
            31 => [
                'question' => '32 Klausimas: ką reikėtų pasakyti žmogui, kuris padarė tau paslaugą?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15710.mp3',
                'answer' => '<p> Atsakymas: „Džazakallahu khairan“ <span class="c2">(tegul Allahas atlygina tau geru)</span>. Perdavė At-Tirmizi. </p>',
            ],
            32 => [
                'question' => '33 Klausimas: kokį maldavimą reikėtų pasakyti kai jojamasis gyvūnas suklumpa?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15740.mp3',
                'answer' => '<p> Atsakymas: „Bismillah“ <span class="c2">(Allaho vardu)</span>. Perdavė Abu Davud. </p>',
            ],
            33 => [
                'question' => '34 Klausimas: ką reikia pasakyti, kai tau atsitinka kažkas gero?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15770.mp3',
                'answer' => '<p> Atsakymas: „Alhamdulillahil-lazi binimatihi tatimu as-salihat“ <span class="c2">(Garbė Allahui, Kurio palankumu atsitinka geri dalykai)</span>. Perdavė Al-Hakim ir kiti. </p>',
            ],
            34 => [
                'question' => '35 Klausimas: ką reikia pasakyti, kai tau atsitinka kažkas blogo?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15800.mp3',
                'answer' => '<p> Atsakymas: „Alhamdulillah ala kuli hal“ <span class="c2">(visais atvejais tebūna šlovė Allahui)</span>. Sahih Al-Džami. </p>',
            ],
            35 => [
                'question' => '36 Klausimas: koks yra pasisveikinimo ir atsisveikinimo būdas?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15830.mp3',
                'answer' => '<p> Atsakymas: Musulmonas turėtų pasakyti: „As-salamu alaikum va rahmatullahi va barakatuh“ <span class="c2">(Tebūnie jums ramybė, gailestingumas ir Allaho palaiminimas)</span>.<span class="c6"><br /> Jo brolis turėtų atsisveikinti sakydamas:</span> „va alaikum as-salam va rahmatullahi va barakatuh“ <span class="c2">(Ir jums tebūnie ramybė, gailestingumas ir Allaho palaiminimas)</span>. Perdavė At-Tirmizi, Abu Davud ir kiti. </p>',
            ],
            36 => [
                'question' => '37 Klausimas: kokį maldavimą reikėtų pasakyti lyjant?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15870.mp3',
                'answer' => '<p> Atsakymas: „Allahumma saiban nafi-an“ <span class="c2">(O Allahai, tebūna naudingas lietus)</span>. Perdavė Al-Bukhari. </p>',
            ],
            37 => [
                'question' => '38 Klausimas: koks maldavimas turėtų būti pasakytas po lietaus?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15900.mp3',
                'answer' => '<p> Atsakymas: „Mutirna bifadlillahi va rahmatih“ <span class="c2">(Mums duotas lietus iš Allaho malonės ir gailestingumo)</span>. Al-Bukhari ir Muslim. </p>',
            ],
            38 => [
                'question' => '39 Klausimas: paminėk maldavimą, kurį reikėtų pasakyti, kai pučia vėjas.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15930.mp3',
                'answer' => '<p> Atsakymas: „Allahumma ini asaluka khairaha va auzu bika min šariha“ <span class="c2">(O Allahai, aš prašau Tavęs jo gėrio ir ieškau prieglobsčio pas Tave nuo jo blogio)</span>. Perdavė Abu Davud ir Ibn Madža. </p>',
            ],
            39 => [
                'question' => '40 Klausimas: paminėk maldavimą, kurį reikėtų pasakyti išgirdus griaustinį.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15960.mp3',
                'answer' => '<p> Atsakymas: „Subhanal-lazi jusabihur-radu bihamdihi valmala-ikatu min khifatih“ <span class="c2">(Šlovė Tam, Kuris išaukština perkūną savo šlovę, aukština Jį ir angelai, iš baimės jam)</span>. Muvata Malik. </p>',
            ],
            40 => [
                'question' => '41 Klausimas: kokį maldavimą reikėtų pasakyti (sau) pamačius kenčiantį asmenį?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15990.mp3',
                'answer' => '<p> Atsakymas: „Alhamdulillahil-lazi afani mima ibtalaka bihi va fadalani ala kasirin miman khalaka tafdila“ <span class="c2">(Garbė Allahui, Kuris išgelbėjo mane nuo to, kuo tave išbandė, ir man labiau teikė pirmenybę prieš kitus, kuriuos sukūrė)</span>. Perdavė At-Tirmizi. </p>',
            ],
            41 => [
                'question' => '42 Klausimas: kokį maldavimą reikėtų pasakyti dėl baimės ką nors nužiūrėti (paveikti bloga akimi)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16020.mp3',
                'answer' => '<p> Atsakymas: hadisas teigia: „Jei vienas iš jūsų mato ką nors nuostabaus savo brolyje, savyje ar jo turtuose, tegul prašo palaiminimo, nes bloga akis iš tikrųjų yra tiesa“. Perdavė Ahmad, Ibn Madža ir kiti. </p>',
            ],
            42 => [
                'question' => '43 Klausimas: kaip reikėtų prašyti palaiminimų už Pranašą (ramybė ir Allaho palaima jam)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16050.mp3',
                'answer' => '<p> Atsakymas: „Allahumma sali ala Muchammad, va ala ali Muchammad, kama salaita ala Ibrahima va ala ali Ibrahim, inaka hamidun madžid, Allahuma barik ala Muchammad, va ala ali Muchammad, kama barakta ala Ibrahim, va ala ali Ibrahim, inaka hamidun madžid“. <span class="c2">(O Allah, siųsk maldas už Pranašą Muchammedą ir jo šeimą lygiai taip, kaip siuntei maldas už Abraomą ir jo šeimą; iš tiesų, Tu esi vertas šlovinimo ir garbės. O Allah, palaimink Pranašą Muchammedą ir jo šeimą, kaip kad palaiminai Abraomą ir jo šeimą. Iš tiesų, Tu esi vertas šlovinimo ir garbės)</span>. Al-Bukhari ir Muslim. </p>',
            ],
        ],
        9 => [
            0 => [
                'question' => '1 Klausimas: įvardyk penkis šariato nutarimus.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16090.mp3',
                'answer' => '<p> Atsakymas:<br /> 1. Vadžib <span class="c2">(privaloma)</span>.<br /> 2. Mustahab <span class="c2">(rekomenduojama)</span>.<br /> 3. Muharam <span class="c2">(draudžiama)</span>.<br /> 4. Makruh <span class="c2">(nepageidautina)</span>.<br /> 5. Mubah <span class="c2">(leistina)</span>. </p>',
            ],
            1 => [
                'question' => '2 Klausimas: paaiškink šiuos penkis šariato nutarimus.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16170.mp3',
                'answer' => '<p> Atsakymas:<br /> 1. Vadžib <span class="c2">(privaloma)</span>: pavyzdžiui, penkios maldos, Ramadano pasninkas ir pareigingumas tėvams.<br /> Atliekant tai, kas privaloma, bus atlyginta, o už atsisakymą – baudžiama.<br /> 2. Mustahab <span class="c2">(rekomenduojama)</span>: pavyzdžiui, reguliarios sunna maldos, naktinė malda, žmonių maitinimas ir pasisveikinimas. Tai taip pat vadinama „Sunna“ ir „Mandub“.<br /> Atliekant tai, kas rekomenduojama, bus atlyginta, o už to atsisakymą nebus baudžiama.<span class="c6"><br /> Svarbi pastaba:</span><br /> Musulmonas turėtų paskubėti atlikti viską, kas yra sunna ar rekomenduojama, ir sekti Pranašo pavyzdžiu <span class="c2">(ramybė ir Allaho palaima jam)</span>.<br /> 3. Muharam <span class="c2">(draudžiama)</span>: pavyzdžiui, alkoholio vartojimas, nepagarba tėvams ir giminystės ryšių nutraukimas.<br /> Atsisakius to, kas uždrausta, bus atlyginta, o tai padarius bus baudžiama.<br /> 3. Makruh <span class="c2">(nepageidautina)</span>: pavyzdžiui, kaire ranka imti ir duoti, pakelti apatinę drabužio dalį maldos metu.<br /> Atsisakius to, kas nepageidautina, bus atlyginta, o darant tai - nebus baudžiama.<br /> 5. Muba <span class="c2">(leistina)</span>: pavyzdžiui, valgyti obuolį ir gerti arbatą. Tai taip pat vadinamas „Džaiz“ ir „Halal“.<br /> Atsisakius to, kas leistina, nebus atlyginta, o padarius - nebus baudžiama. </p>',
            ],
            2 => [
                'question' => '3 Klausimas: koks yra sprendimas dėl pardavimo ir sandorių?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16320.mp3',
                'answer' => '<p> Atsakymas: iš esmės visi pardavimo ir sandorių tipai yra leistini, išskyrus kai kuriuos tipus, kuriuos uždraudė Visagalis Allahas.<span class="c6"><br /> Tarė Visagalis:</span> { Tuo tarpu Allahas leido prekiauti, tačiau uždraudė Riba <span class="c2">(palūkanas)</span>.} <span class="c5">[Koranas,<span class="c6"> sūra „Karvė“ 2:</span>275]</span>. </p>',
            ],
            3 => [
                'question' => '4 Klausimas: paminėk kai kuriuos draudžiamus pardavimo ir sandorių tipus.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16360.mp3',
                'answer' => '<p> Atsakymas:<br /> 1.<span class="c6"> Sukčiavimas:</span> pavyzdžiui, prekės trūkumo slėpimas.<br /> Abu Huraira <span class="c2">(tebūnie Allahas juo patenkintas)</span> pranešė, kad Pranašas <span class="c2">(ramybė ir Allaho palaima jam)</span> kartą priėjo prie krūvos maisto, o kai įkišo į ją ranką, jo pirštai pajuto drėgmę. Taigi,<span class="c6"> jis paklausė maisto savininko:</span> „Kas tai yra,<span class="c6"> o maisto savininke?“ Vyriškis atsakė:</span> „Lietus prapliupo, o Allaho Pasiuntiny“. Po to Pranašas <span class="c2">(ramybė ir Allaho palaima jam)</span> pasakė: „Kodėl nepalikai drėgnos dalies ant maisto viršaus, kad žmonės ją matytų? Kas apgaudinėja, tas neturi nieko bendra su manimi.“ Perdavė Muslim.<br /> 2. Riba <span class="c2">(lupikavimas)</span>: pavyzdžiui, pasiskolinti iš ko nors vieną tūkstantį, o grąžinti du.<br /> Šis perteklius yra draudžiamas lupikavimas.<span class="c6"><br /> Tarė Visagalis:</span> { Tuo tarpu Allahas leido prekiauti, tačiau uždraudė Riba <span class="c2">(palūkanas)</span>.} <span class="c5">[Koranas,<span class="c6"> sūra „Karvė“ 2:</span>275]</span>.<br /> 3. Gharar <span class="c2">(netikrumas, rizika)</span> ir džahala <span class="c2">(nežinojimas)</span>: pavyzdžiui, parduodant pieną, kuris vis dar yra patelės tešmenyje, arba žuvį, kuri dar nepagauta.<span class="c6"><br /> Hadise rašoma:</span> „Allaho Pasiuntinys <span class="c2">(ramybė ir Allaho palaima jam)</span> uždraudė bet kokį pardavimą, kuris susijęs su Gharar <span class="c2">(netikrumu, rizika)</span>.“ Perdavė Muslim. </p>',
            ],
            4 => [
                'question' => '5 Klausimas: paminėk kai kurias tau Allaho suteiktas malones.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16460.mp3',
                'answer' => '<p> Atsakymas: 1. Palaiminimas būti musulmonu ir nebūti iš netikinčiųjų.<br /> 2. Palaiminimas laikytis sunnos ir nebūti iš religinių naujovių įvedėjų.<br /> 3. Sveikatos ir gerovės malonė, įskaitant malonę girdėti, matyti, vaikščioti ir panašiai.<br /> 4. Malonė turėti maisto, gėrimų ir drabužių.<br /> Tiesą sakant, mums Allaho suteiktų malonių yra daug ir jų negalima suskaičiuoti ar išvardyti.<span class="c6"><br /> Tarė Visagalis:</span> <span class="c4">{ Ir jei jūs skaičiuotumėte Allaho malones, niekada nesugebėtumėte jų suskaičiuoti. Iš tiesų, Allahas yra dažnai Atleidžiantis, Gailestingiausiasis.}</span> <span class="c5">[Koranas,<span class="c6"> sūra „Bitės“ 16:</span>18]</span>. </p>',
            ],
            5 => [
                'question' => '6 Klausimas: ką įsipareigojame už (Allaho) malones mums? Kaip turėtume parodyti dėkingumą?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16540.mp3',
                'answer' => '<p> Atsakymas: Mūsų pareiga yra išreikšti dėkingumą už tokias malones, šlovinant Allahą liežuviu ir skiriant visą padėką tik Jam bei naudojant jas <span class="c2">(malones)</span> taip, kad Visagalis Allahas būtų patenkintas, o ne Jam nepaklūstant. </p>',
            ],
            6 => [
                'question' => '7 Klausimas: kokios yra musulmonų šventės?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16570.mp3',
                'answer' => '<p> Atsakymas: Eid al-Fitr ir Eid al-Adha.<br /> Tai minima Anas hadise,<span class="c6"> kuris sakė:</span> «Kai Allaho Pasiuntinys <span class="c2">(ramybė ir Allaho palaima jam)</span> atvyko į Mediną, žmonės turėjo dvi dienas, kurių metu rengė žaidimus.<span class="c6"> Jis paklausė:</span> „Kas yra šios dvi dienos?“ Jie atsakė: „Mes žaisdavome per jas prieš islaminiu laikotarpiu“. Po to Allaho Pasiuntinys <span class="c2">(ramybė ir Allaho palaima jam)</span> pasakė: „Allahas davė jums kai ką geresnio už šias dvi: aukos dieną <span class="c2">(Eid al-Adha)</span> ir pasninko nutraukimo dieną <span class="c2">(Eid al-Fitr)</span>.“» Perdavė Abu Davud.<br /> Visos šventės, išskyrus šias dvi, laikomos religinėmis naujovėmis. </p>',
            ],
            7 => [
                'question' => '8 Klausimas: koks mėnuo yra geriausias?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16620.mp3',
                'answer' => '<p> Atsakymas: Ramadano mėnuo. </p>',
            ],
            8 => [
                'question' => '9 Klausimas: kokia diena yra geriausia?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16650.mp3',
                'answer' => '<p> Atsakymas: penktadienis. </p>',
            ],
            9 => [
                'question' => '10 Klausimas: kokia yra geriausia metų diena?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16680.mp3',
                'answer' => '<p> Atsakymas: „Arafato“ diena <span class="c2">(9-oji Zul-Hidža mėnesio diena)</span>. </p>',
            ],
            10 => [
                'question' => '11 Klausimas: kokia yra geriausia metų naktis?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16710.mp3',
                'answer' => '<p> Atsakymas: Lailat al-Kadr <span class="c2">(Lemties naktis)</span>. </p>',
            ],
            11 => [
                'question' => '12 Klausimas: kaip privalu elgtis pamačius svetimą moterį?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16740.mp3',
                'answer' => '<p> Atsakymas: reikia nuleisti žvilgsnį,<span class="c6"> kaip sako Visagalis Allahas:</span> { Sakykite tikintiems vyrams nuleisti savo žvilgsnius <span class="c2">(nuo žiūrėjimo į draudžiamus dalykus)</span>} <span class="c5">[Koranas,<span class="c6"> sūra „Šviesa“ 24:</span>30]</span>. </p>',
            ],
            12 => [
                'question' => '13 Klausimas: kas yra žmogaus priešai?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16770.mp3',
                'answer' => '<p> Atsakymas: 1. Paties žmogaus siela,<span class="c6"> skatinanti į blogį:</span> tai yra tada, kai žmogus vadovaujasi tuo, ką jam diktuoja jo siela, ir seka asmeniniais troškimais, nepaklusdamas Visagaliam Allahui,<span class="c6"> Kuris sako:</span> { Iš tiesų, pats <span class="c2">(žmogus)</span> yra linkęs į blogį, išskyrus tada, kai mano Viešpats suteikia Savo Gailestingumą <span class="c2">(tam, kuriam Jis nori)</span>. Iš tiesų, mano Viešpats yra dažnai Atleidžiantis, Gailestingiausiasis.“} [Koranas, sūra „Jusufas <span class="c2">(Juozapas)</span>“ 12:53]. 2.<span class="c6"> Šėtonas:</span> jis yra žmogaus priešas, kurio pagrindinis tikslas yra suklaidinti žmogų, šnibždėti jam blogį ir nuvesti į pragaro ugnį.<span class="c6"> Tarė Visagalis Allahas:</span> <span class="c4">{ ir nesekite šėtono pėdomis. Iš tiesų, jis yra jums aiškus priešas.}</span> <span class="c5">[Koranas,<span class="c6"> sūra „Karvė“ 2:</span>168]</span>. 3.<span class="c6"> Piktieji kompanjonai:</span> tai tie, kurie skatina žmogų link blogio ir atitraukia jį nuo gėrio.<span class="c6"> Tarė Visagalis Allahas:</span> { Draugai tą Dieną bus priešais vienas kitam, išskyrus Al-Mutakūn <span class="c2">(dievobaiminguosius)</span>.} <span class="c5">[Koranas,<span class="c6"> sūra „Auksinės puošmenos“ 43:</span>67]</span>. </p>',
            ],
            13 => [
                'question' => '14 Klausimas: kas yra atgaila?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16820.mp3',
                'answer' => '<p> Atsakymas: atgaila reiškia nuodėmių palikimą ir pradėjimą paklusti Visagaliam Allahui.<span class="c6"> Tarė Visagalis Allahas:</span> { Ir iš tiesų, Aš tikrai atleidžiantis tam, kuris atgailauja, tiki <span class="c2">(Mano Vienumą ir nepriskiria Man jokių partnerių garbinime)</span> ir daro teisingus gerus darbus ir tada išlieka pastovus darydamas tai <span class="c2">(iki savo mirties)</span>.} <span class="c5">[Koranas,<span class="c6"> sūra „Ta ha“ 20:</span>82]</span>. </p>',
            ],
            14 => [
                'question' => '15 Klausimas: kokios yra esminės teisingos atgailos sąlygos?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16850.mp3',
                'answer' => '<p> Atsakymas: 1. Atsisakyti nuodėmės.<br /> 2. Atgailauti dėl nuodėmės.<br /> 3. Pasiryžti nebegrįžti į nuodėmę.<br /> 4. Atkurti pažeistas teises, atlyginti už padarytą žalą ir įžeidimus.<span class="c6"><br /> Tarė Visagalis:</span> { O tiems, kurie atlikę ką nors gėdingo arba nusidėję blogiu, prisimena Allahą ir prašo atleidimo už jų nuodėmes, - ir niekas negali atleisti jų nuodėmių, tik Allahas – ir nebetęsia <span class="c2">(blogio)</span> ką jie padarė, nors ir žino.} <span class="c5">[Koranas,<span class="c6"> sūra „Imrano giminė“ 3:</span>135]</span>. </p>',
            ],
            15 => [
                'question' => '16 Klausimas: ką reiškia palaiminimai už Pranašą (ramybė ir Allaho palaima jam)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16920.mp3',
                'answer' => '<p> Atsakymas: tai reiškia maldauti Allahą ir prašyti Jį, kad pagirtų Pranašą <span class="c2">(ramybė ir Allaho palaima jam)</span> aukščiausiame susirinkime. </p>',
            ],
            16 => [
                'question' => '17 Klausimas: ką reiškia „Subhanallah“?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16950.mp3',
                'answer' => '<p> Atsakymas: Tasbih <span class="c2">(tarimas: Subhanallah)</span> reiškia Visagalio Allaho iškėlimą aukščiau bet kokių trūkumų, ydų ar blogio. </p>',
            ],
            17 => [
                'question' => '18 Klausimas: ką reiškia „Alhamdulilliah“?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16980.mp3',
                'answer' => '<p> Atsakymas: tai reiškia šlovinti Visagalį Allahą ir apibūdinti Jį visomis tobulumo savybėmis. </p>',
            ],
            18 => [
                'question' => '19 Klausimas: ką reiškia „Allahu Akbar“?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/17000.mp3',
                'answer' => '<p> Atsakymas: tai reiškia, kad Visagalis Allahas yra Didžiausias, Didingiausias ir Galingiausias iš visų. </p>',
            ],
            19 => [
                'question' => '20 Klausimas: ką reiškia „La haula va la kuvata illa billah“?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/17030.mp3',
                'answer' => '<p> Atsakymas: tai reiškia, kad žmogus negali pereiti iš vienos būsenos į kitą, nebent Allaho jėgos ir galios dėka. </p>',
            ],
            20 => [
                'question' => '21 Klausimas: ką reiškia „Astaghfirullah“?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/17060.mp3',
                'answer' => '<p> Atsakymas: tai reiškia prašyti Visagalio Allaho, kad jis ištrintų nuodėmes ir uždengtų trūkumus. </p>',
            ],
        ],
    ],
];
