<?php
$data = [
    'title' => 'What Muslim Children Must Know',
    'description' => 'A project that contains a simple and easy curriculum for issues that a Muslim must know. It includes issues of belief, jurisprudence, prophetic biography, etiquette, tafsir, hadith, morals, and remembrance of Allah. It is suitable for young children in particular, for all ages, and newcomers to Islam.',
    'source' => 'https://kids.islamenc.com/ml/home',
    'author' => 'Yazan Abdul Razzaq Raziq Alghanim',
    'sections' => [
        0 => 'അഖീദഃ (വിശ്വാസം)',
        1 => 'ഫിഖ്ഹ് (കർമ്മശാസ്ത്രം)',
        2 => 'നബിചരിത്രം',
        3 => 'തഫ്സീർ',
        4 => 'ഹദീഥ്',
        5 => 'ഇസ്ലാമിക മര്യാദകൾ',
        6 => 'സൽസ്വഭാവം',
        7 => 'പ്രാർത്ഥനകളും ദിക്റുകളും',
        8 => 'വ്യത്യസ്ത വിഷയങ്ങൾ',
    ],
    'data' => [
        1 => [
            0 => [
                'question' => 'ചോദ്യം 1: ആരാണ് നിൻ്റെ റബ്ബ് (രക്ഷിതാവ്)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/200.mp3',
                'answer' => '<p> ഉത്തരം: എൻ്റെയും സർവ്വ ലോകങ്ങളുടെയും പരിപാലകനായ, ഏവർക്കും തൻ്റെ അനുഗ്രഹങ്ങൾ നൽകിയവനായ അല്ലാഹുവാണ് എൻ്റെ റബ്ബ്.<span class="c6"><br /> <br /> അതിനുള്ള തെളിവ് അല്ലാഹുവിൻ്റെ വാക്കാണ്:</span> "<span class="c2">(സാരം)</span> സർവ്വ സ്തുതികളും സർവ്വലോക പരിപാലകനായ അല്ലാഹുവിനാകുന്നു." <span class="c2">(ഫാതിഹഃ: 2)</span> </p>',
            ],
            1 => [
                'question' => 'ചോദ്യം 2: ഏതാണ് നിൻ്റെ ദീൻ (മതം)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/240.mp3',
                'answer' => '<p> എൻ്റെ ദീൻ ഇസ്ലാമാണ്. അല്ലാഹുവിനെ ഏകനാക്കി കൊണ്ട് അവന് സമർപ്പിക്കുകയും, അവനെ അനുസരിച്ചു കൊണ്ട് കീഴൊതുങ്ങുകയും, ബഹുദൈവാരാധനയിൽ നിന്നും അതിൻ്റെ വക്താക്കളിൽ നിന്നും അകലം പാലിക്കുകയും ചെയ്യലാണ് ഇസ്ലാം.<span class="c6"><br /> <br /> അല്ലാഹു പറയുന്നു:</span> "തീർച്ചയായും അല്ലാഹുവിങ്കൽ മതമെന്നാൽ ഇസ്ലാമാകുന്നു." <span class="c2">(ആലു ഇംറാൻ: 19)</span> </p>',
            ],
            2 => [
                'question' => 'ചോദ്യം 3: നിൻ്റെ നബിയാരാണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/280.mp3',
                'answer' => '<p> ഉത്തരം: എൻ്റെ നബി മുഹമ്മദ് നബി -ﷺ- യാണ്.<span class="c6"><br /> <br /> അല്ലാഹു പറയുന്നു:</span> "മുഹമ്മദ് അല്ലാഹുവിൻ്റെ ദൂതനാകുന്നു." <span class="c2">(ഫത്ഹ്: 29)</span> </p>',
            ],
            3 => [
                'question' => 'ചോദ്യം 4: എന്താണ് കലിമതുത്തൗഹീദ് (തൗഹീദിൻ്റെ വാചകം)? എന്താണ് അതിൻ്റെ അർത്ഥം?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/310.mp3',
                'answer' => '<p> ഉത്തരം: \'ലാ ഇലാഹ ഇല്ലല്ലാഹ്\' എന്നതാണ് കലിമതുത്തൗഹീദ്. \'അല്ലാഹുവല്ലാതെ ആരാധനക്ക് അർഹനായി മറ്റാരുമില്ല\' എന്നാകുന്നു അതിൻ്റെ അർത്ഥം.<span class="c6"><br /> <br /> അല്ലാഹു പറയുന്നു:</span> "അറിയുക; അല്ലാഹുവല്ലാതെ ആരാധനക്ക് അർഹനായി മറ്റാരുമില്ല എന്ന്." <span class="c2">(മുഹമ്മദ്: 19)</span> </p>',
            ],
            4 => [
                'question' => 'ചോദ്യം 5: അല്ലാഹു എവിടെയാണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/350.mp3',
                'answer' => '<p> ഉത്തരം: അല്ലാഹു ആകാശങ്ങൾക്ക് മേലെയാണുള്ളത്. അല്ലാഹു എല്ലാ സൃഷ്ടികളുടെയും മുകളിൽ, അവൻ്റെ സിംഹാസനത്തിന് മേലാണ്.<span class="c6"> അല്ലാഹു പറയുന്നു:</span> "റഹ്മാനായ അല്ലാഹു സിംഹാസനത്തിന് മേൽ ആരോഹിതനായിരിക്കുന്നു." <span class="c2">(ത്വാഹാ: 5)</span> അല്ലാഹു പറയുന്നു: "അവനാകുന്നു തൻ്റെ അടിമകളെ മുകളിൽ നിന്ന് അടക്കിഭരിക്കുന്നവൻ. അങ്ങേയറ്റം യുക്തിയുള്ളവനും <span class="c2">(ഹകീം)</span> എല്ലാം സൂക്ഷ്മമായി അറിയുന്നവനുമത്രെ <span class="c2">(ഖബീർ)</span> അവൻ." <span class="c2">(അൻആം: 18)</span> </p>',
            ],
            5 => [
                'question' => 'ചോദ്യം 6: \'മുഹമ്മദുൻ റസൂലുല്ലാഹ്\' എന്ന സാക്ഷ്യവചനത്തിന്റെ അർത്ഥം എന്താണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/380.mp3',
                'answer' => '<p> ഉത്തരം: മുഹമ്മദ് നബി -ﷺ- യെ അല്ലാഹു അവൻ്റെ ദൂതനായി എല്ലാ ലോകരിലേക്കും നിയോഗിച്ചിരിക്കുന്നു. സ്വർഗത്തെ കുറിച്ച് സന്തോഷവാർത്ത അറിയിക്കുകയും, നരകത്തെ കുറിച്ച് താക്കീത് നൽകുകയും ചെയ്യുന്നവരാണ് അവർ.<span class="c6"><br /> <br /> നമ്മളെല്ലാം നിർബന്ധമായും:</span><br /> <br /> 1- നബി -ﷺ- കൽപ്പിച്ച കാര്യങ്ങളെല്ലാം അനുസരിക്കണം.<br /> <br /> 2- നബി -ﷺ- പറഞ്ഞതെല്ലാം വിശ്വസിക്കണം.<br /> <br /> 3- നബി -ﷺ- യെ ഒരിക്കലും ധിക്കരിക്കരുത്.<br /> <br /> 4- നബി -ﷺ- പഠിപ്പിച്ചതു പോലെ മാത്രം അല്ലാഹുവിനെ ആരാധിക്കണം. അഥവാ, സുന്നത്ത് <span class="c2">(നബിചര്യ)</span> പിൻപറ്റുകയും, ബിദ്അത്ത് <span class="c2">(ദീനിൽ പുതുതായി ഉണ്ടാക്കിയത്)</span> ഉപേക്ഷിക്കുകയും ചെയ്യണം.<span class="c6"><br /> <br /> അല്ലാഹു പറയുന്നു:</span> "ആരെങ്കിലും അല്ലാഹുവിൻ്റെ റസൂലിനെ അനുസരിച്ചാൽ അവൻ അല്ലാഹുവിനെ അനുസരിച്ചിരിക്കുന്നു." <span class="c2">(നിസാഅ്: 80)</span>.<span class="c6"> അല്ലാഹു പറയുന്നു:</span> "മുഹമ്മദ് നബി തന്നിഷ്ടപ്രകാരം സംസാരിക്കുന്നില്ല. അവിടുന്ന് സംസാരിക്കുന്നതെല്ലാം അല്ലാഹുവിൽ നിന്ന് നൽകപ്പെടുന്ന സന്ദേശപ്രകാരമാണ്." <span class="c2">(നജ്മ്: 3-4)</span> അല്ലാഹു പറയുന്നു: "തീർച്ചയായും നിങ്ങൾക്ക് അല്ലാഹുവിൻ്റെ റസൂലിൽ ഉത്തമമായ മാതൃകയുണ്ട്. അതായത് അല്ലാഹുവെയും അന്ത്യദിനത്തെയും പ്രതീക്ഷിച്ചു കൊണ്ടിരിക്കുകയും, അല്ലാഹുവെ ധാരാളമായി ഓർമിക്കുകയും ചെയ്തു വരുന്നവർക്ക്." <span class="c2">(അഹ്സാബ്: 21)</span> </p>',
            ],
            6 => [
                'question' => 'ചോദ്യം 7: എന്തിനാണ് അല്ലാഹു നാമേവരെയും പടച്ചത്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/480.mp3',
                'answer' => '<p> ഉത്തരം: അല്ലാഹുവിനെ മാത്രം നാം ആരാധിക്കുന്നതിനും, അവനുള്ള ആരാധനയിൽ ഒരാളെയും പങ്കുചേർക്കാതിരിക്കാനുമാണ് അല്ലാഹു നമ്മെ സൃഷ്ടിച്ചത്.<br /> <br /> ജീവിതം വെറും കളിയും ചിരിയുമല്ല.<span class="c6"><br /> <br /> അല്ലാഹു പറയുന്നു:</span> ജിന്നുകളെയും മനുഷ്യരെയും എന്നെ ആരാധിക്കാൻ വേണ്ടിയല്ലാതെ ഞാൻ സൃഷ്ടിച്ചിട്ടില്ല.\'\' <span class="c2">(ദാരിയാത്: 56)</span> </p>',
            ],
            7 => [
                'question' => 'ചോദ്യം 8: എന്താണ് ആരാധന (ഇബാദത്)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/530.mp3',
                'answer' => '<p> ഉത്തരം: അല്ലാഹുവിന് ഇഷ്ടമുള്ളതും തൃപ്തികരമായതുമായ, ബാഹ്യവും ആന്തരികവുമായ എല്ലാ വാക്കുകളെയും പ്രവർത്തനങ്ങളെയും ഉൾക്കൊള്ളുന്ന പദമാണ് ഇബാദത്ത്.<br /> <br /> - ബാഹ്യമായത് എന്നാൽ നാവു കൊണ്ടുള്ള ദിക്ർ ഉദാഹരണം. സുബ്ഹാനല്ലാഹ്, അൽഹംദുലില്ലാഹ്, അല്ലാഹു അക്ബർ... ഇവയൊക്കെ നാവു കൊണ്ടുള്ള ദിക്റുകളാണ്. നിസ്കാരവും ഹജ്ജും ബാഹ്യമായ <span class="c2">(പുറമേക്ക് കാണുന്ന)</span> ഇബാദത്തുകൾക്ക് ഉദാഹരണം തന്നെ.<br /> <br /> - ആന്തരികമായത് എന്നാൽ ഹൃദയത്തിലുള്ള പ്രവർത്തനമാണ്. അല്ലാഹുവിൽ ഭരമേൽപ്പിക്കുക <span class="c2">(തവക്കുൽ)</span>, അല്ലാഹുവിനെ ഭയക്കുക, അല്ലാഹുവിൽ പ്രതീക്ഷ വെക്കുക എന്നതെല്ലാം അതിൻ്റെ ഉദാഹരണങ്ങളാണ്. </p>',
            ],
            8 => [
                'question' => 'ചോദ്യം 9: നമ്മുടെ മേൽ ഏറ്റവും നിർബന്ധമായ കാര്യം എന്താണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/580.mp3',
                'answer' => '<p> ഉത്തരം: തൗഹീദ് -അല്ലാഹുവിനെ ഏകനാക്കുക എന്നത്-; അതാണ് നമ്മുടെ മേലുള്ള ഏറ്റവും വലിയ വാജിബ് <span class="c2">(നിർബന്ധമായ കാര്യം)</span>. </p>',
            ],
            9 => [
                'question' => 'ചോദ്യം 10: തൗഹീദിൻ്റെ ഇനങ്ങൾ ഏതെല്ലാമാണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/610.mp3',
                'answer' => '<p> ഉത്തരം: 1- അല്ലാഹു മാത്രമാണ് റബ്ബ് എന്ന് വിശ്വസിക്കൽ <span class="c2">(തൗഹീദു റുബൂബിയ്യഃ)</span>. അല്ലാഹു മാത്രമാണ് എല്ലാം സൃഷ്ടിച്ചതും എല്ലാവർക്കും ഉപജീവനം നൽകുന്നതും; അവനാണ് എല്ലാവരുടെയും ഉടമസ്ഥനും എല്ലാത്തിനെയും നിയന്ത്രിക്കുന്നവനും. ഈ പറഞ്ഞതിലെല്ലാം അല്ലാഹു ഏകനാണ്. ഇതിലൊന്നും അവന് ഒരു പങ്കുകാരനുമില്ല.<br /> <br /> 2- അല്ലാഹു മാത്രമാണ് ഇലാഹ് എന്ന് വിശ്വസിക്കൽ <span class="c2">(തൗഹീദുൽ ഉലൂഹിയ്യഃ)</span>. അല്ലാഹുവിന് മാത്രം ആരാധനകൾ <span class="c2">(ഇബാദതുകൾ)</span> ഏകമാക്കുകയും, അല്ലാഹുവിനോടൊപ്പം മറ്റൊരാളെയും ഇബാദത്ത് ചെയ്യാതിരിക്കുകയും ചെയ്യണം.<br /> <br /> 3- അല്ലാഹുവിൻ്റെ നാമങ്ങളിലും ഗുണവിശേഷണങ്ങളിലും അവൻ ഏകനാണെന്ന് വിശ്വസിക്കൽ <span class="c2">(തൗഹീദുൽ അസ്മാഇ വസ്വിഫാത്)</span>. ഖുർആനിലും സുന്നത്തിലും വന്ന അല്ലാഹുവിൻ്റെ എല്ലാ നാമങ്ങളിലും വിശേഷണങ്ങളിലും അവൻ വിശ്വസിക്കണം. ഈ വിശേഷണങ്ങളിലൊന്നും അല്ലാഹു സൃഷ്ടികളോട് സമനാണെന്നോ സാദൃശ്യമുള്ളവനാണെന്നോ പറയാതെ, അവയുടെ അർത്ഥമോ ഉദ്ദേശ്യമോ നിഷേധിക്കാതെ വിശ്വസിക്കണം.<span class="c6"><br /> <br /> തൗഹീദിൻ്റെ ഈ മൂന്ന് ഇനങ്ങൾക്കുള്ള തെളിവ് അല്ലാഹുവിൻ്റെ വചനമാണ്:</span> "ആകാശങ്ങളുടെയും ഭൂമിയുടെയും അവയ്ക്കിടയിലുള്ളതിൻ്റെയും റബ്ബത്രെ അവൻ. അതിനാൽ അവനെ താങ്കൾ ആരാധിക്കുകയും അവന്നുള്ള ആരാധനയിൽ ക്ഷമയോടെ ഉറച്ചുനിൽക്കുകയും ചെയ്യുക. അവന്ന് പേരൊത്ത ആരെയെങ്കിലും താങ്കൾക്കറിയാമോ?" <span class="c2">(മർയം: 65)</span> </p>',
            ],
            10 => [
                'question' => 'ചോദ്യം 11: ഏറ്റവും ഗുരുതരമായ തിന്മ ഏതാണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/670.mp3',
                'answer' => '<p> ഉത്തരം: ശിർക് <span class="c2">(അല്ലാഹുവിൽ പങ്കുചേർക്കുക)</span> ആണ് ഏറ്റവും വലിയ തിന്മ.<span class="c6"><br /> <br /> അല്ലാഹു പറയുന്നു:</span> "നിശ്ചയം അല്ലാഹു അവനിൽ പങ്കു ചേർക്കുന്നത് ഒരിക്കലും പൊറുക്കുകയില്ല, അതല്ലാത്തവ അവനുദ്ദേശിക്കുന്നവർക്ക് അവൻ പൊറുത്തു കൊടുക്കുന്നതാണ്. അല്ലാഹുവിൽ ആരെങ്കിലും പങ്കു ചേർക്കുന്നുവോ അവൻ ഭയങ്കര കുറ്റമാണ് വ്യാജമായി കെട്ടിച്ചമച്ചിരിക്കുന്നത്." <span class="c2">(നിസാഅ്: 48)</span> </p>',
            ],
            11 => [
                'question' => 'ചോദ്യം 12: എന്താണ് ശിർക്? ഏതെല്ലാമാണ് ശിർകിൻ്റെ ഇനങ്ങൾ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/710.mp3',
                'answer' => '<p> ഉത്തരം: ഏതെങ്കിലുമൊരു ഇബാദത്ത് അല്ലാഹു അല്ലാത്തവർക്ക് നൽകിയാൽ അത് ശിർകാണ്.<span class="c6"><br /> <br /> ശിർകിന്റെ ഇനങ്ങൾ:</span> ശിർക് രണ്ട് രൂപത്തിലുണ്ട്.<span class="c6"><br /> <br /> വലിയ ശിർക്:</span> അല്ലാഹുവല്ലാത്തവരോട് പ്രാർത്ഥിക്കുക, അല്ലാഹുവല്ലാത്തവർക്ക് സുജൂദ് ചെയ്യുക, അല്ലാഹുവല്ലാത്തവർക്ക് വേണ്ടി ബലിയർപ്പിക്കുക... ഇതെല്ലാം വലിയ ശിർകിൻ്റെ ഉദാഹരണങ്ങളാണ്.<span class="c6"><br /> <br /> ചെറിയ ശിർക്:</span> അല്ലാഹുവല്ലാത്തവരുടെ പേരിൽ സത്യം ചെയ്യുക, ഉപകാരം ലഭിക്കുന്നതിനോ ഉപദ്രവം തടുക്കുന്നതിനോ വേണ്ടി ഉറുക്കുകളും ഏലസ്സുകളും ചരടുകളും മറ്റും ധരിക്കുക, ഇടക്കെപ്പോഴെങ്കിലുമൊക്കെ ജനങ്ങളെ കാണിക്കാൻ വേണ്ടി നന്മ ചെയ്യുക; ഉദാഹരണത്തിന് ജനങ്ങൾ കാണുമ്പോൾ നിസ്കാരം ഭംഗിയാക്കുക... ഇതെല്ലാം ചെറിയ ശിർകിൻ്റെ ഉദാഹരണങ്ങളാണ്. </p>',
            ],
            12 => [
                'question' => 'ചോദ്യം 13: അല്ലാഹുവല്ലാത്ത ആർക്കെങ്കിലും ഗയ്ബ് (മറഞ്ഞ കാര്യം) അറിയാൻ സാധിക്കുമോ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/770.mp3',
                'answer' => '<p> ഉത്തരം: അല്ലാഹുവിനല്ലാതെ ഒരാൾക്കും മറഞ്ഞ കാര്യങ്ങൾ ഒന്നും അറിയാൻ സാധിക്കുകയില്ല.<span class="c6"><br /> <br /> അല്ലാഹു പറയുന്നു:</span> "<span class="c2">(നബിയേ,)</span> പറയുക; ആകാശങ്ങളിലും ഭൂമിയിലും ഉള്ളവരാരും അദൃശ്യകാര്യം അറിയുകയില്ല; അല്ലാഹുവല്ലാതെ. തങ്ങൾ എന്നാണ് ഉയിർത്തെഴുന്നേൽപ്പിക്കപ്പെടുക എന്നും അവർക്കറിയില്ല." <span class="c2">(നംല്: 65)</span> </p>',
            ],
            13 => [
                'question' => 'ചോദ്യം 14: ഈമാനിൻ്റെ സ്തംഭങ്ങൾ (അർകാനുൽ ഈമാൻ) ഏതെല്ലാമാണെന്ന് എണ്ണിപ്പറയുക?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/810.mp3',
                'answer' => '<p> ഉത്തരം: 1- അല്ലാഹുവിലുള്ള വിശ്വാസം.<br /> <br /> 2- മലക്കുകളിലുള്ള വിശ്വാസം.<br /> <br /> 3- കിതാബുകളിലുള്ള <span class="c2">(അല്ലാഹുവിൻ്റെ വേദഗ്രന്ഥങ്ങളിലുള്ള)</span> വിശ്വാസം.<br /> <br /> 4- റസൂലുകളിലുള്ള <span class="c2">(അല്ലാഹുവിൻ്റെ ദൂതന്മാരിലുള്ള)</span> വിശ്വാസം.<br /> <br /> 5- ഖിയാമത്ത് നാളിലുള്ള <span class="c2">(അന്ത്യനാളിലുള്ള)</span> വിശ്വാസം.<br /> <br /> 6- ഖദാ ഖദറിലും <span class="c2">(അല്ലാഹുവിൻ്റെ വിധിയിലുള്ള)</span> അതിൻ്റെ നന്മയിലും തിന്മയിലുമുള്ള വിശ്വാസം.<br /> <br /> ഇമാം മുസ്ലിം നിവേദനം ചെയ്ത, ഹദീഥു ജിബ്രീൽ എന്ന പേരിൽ പ്രസിദ്ധമായ ഒരു ഹദീഥാണ് അതിനുള്ള തെളിവ്. നബി -ﷺ-<span class="c6"> യോട് ജിബ്രീൽ ചോദിച്ചു:</span> "എന്താണ് ഈമാൻ എന്ന് എനിക്ക് പറഞ്ഞു തന്നാലും." അപ്പോൾ നബി -ﷺ-<span class="c6"> പറഞ്ഞു:</span> "ഈമാൻ എന്നാൽ താങ്കൾ അല്ലാഹുവിലും അവൻ്റെ മലക്കുകളിലും, കിതാബുകളിലും, റസൂലുകളിലും, അന്ത്യനാളിലും, \'ക്വദ്റി\'ൽ; അതിൻ്റെ ഖൈറിലും <span class="c2">(നന്മയിലും)</span> ശർറിലും <span class="c2">(തിന്മയിലും)</span> വിശ്വസിക്കലാണ്." </p>',
            ],
            14 => [
                'question' => 'ചോദ്യം 15: ഈമാനിൻ്റെ സ്തംഭങ്ങൾ ഓരോന്നും വിശദീകരിച്ചു പറയൂ.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/900.mp3',
                'answer' => '<p> ഉത്തരം: അല്ലാഹുവിലുള്ള വിശ്വാസം എന്നാൽ ഉദ്ദേശിക്കുന്നത്:<br /> <br /> * അല്ലാഹുവാണ് നിന്നെ സൃഷ്ടിക്കുകയും നിനക്ക് ഭക്ഷണം നൽകുകയും ചെയ്തതെന്നും വിശ്വസിക്കലാണ്. അവനാണ് നിൻ്റെ ഉടമസ്ഥനും, എല്ലാ സൃഷ്ടികളെയും നിയന്ത്രിക്കുന്നവനും.<br /> <br /> * അവനാണ് ആരാധനകൾ <span class="c2">(ഇബാദത്തുകൾ)</span> നൽകപ്പെടാൻ അർഹതയുള്ളവൻ; അവന് പുറമെ ആരാധിക്കപ്പെടാവുന്ന ആരും തന്നെയില്ല.<br /> <br /> * അല്ലാഹു ഏറ്റവും വലിയവനും എല്ലാ പൂർണ്ണതയും ഉള്ളവനുമാണ്. സർവ്വ സ്തുതികളും അവന് മാത്രമാണ്. ഏറ്റവും നല്ല പേരുകളും, ഏറ്റവും ഉന്നതമായ വിശേഷണങ്ങളും അല്ലാഹുവിനുണ്ട്. അവന് ഒരു പങ്കുകാരനുമില്ല. ലോകത്തിലെ ഒരു വസ്തുവും അല്ലാഹുവിനെ പോലെയില്ല.<span class="c6"><br /> <br /> മലക്കുകളിലുള്ള വിശ്വാസം എന്നാൽ:</span><br /> <br /> മലക്കുകൾ അല്ലാഹുവിൻ്റെ സൃഷ്ടികളിൽ പെട്ട ഒരു വിഭാഗമാണ് എന്ന് വിശ്വസിക്കലാണ്. അല്ലാഹു പ്രകാശത്തിൽ നിന്നാണ് അവരെ പടച്ചത്. അല്ലാഹുവിനെ ആരാധിക്കാനും, അവൻ്റെ കൽപ്പനകൾ പരിപൂർണ്ണമായി അനുസരിക്കാനുമാണ് മലക്കുകളെ അല്ലാഹു സൃഷ്ടിച്ചത്.<br /> <br /> മലക്കുകളിൽ പെട്ട ഒരു വ്യക്തിയാണ് ജിബ്രീൽ -عَلَيْهِ السَّلَامُ-. നബിമാർക്കെല്ലാം അല്ലാഹുവിൻ്റെ സന്ദേശം എത്തിച്ചു കൊടുക്കുന്നത് ജിബ്രീലാണ്.<span class="c6"><br /> <br /> വേദഗ്രന്ഥങ്ങളിലുള്ള വിശ്വാസം എന്നാൽ:</span><br /> <br /> അല്ലാഹു അവൻ്റെ റസൂലുകൾക്ക് മേൽ അവതരിപ്പിച്ച ഗ്രന്ഥങ്ങളിൽ വിശ്വസിക്കലാണ്.<br /> <br /> മുഹമ്മദ് നബി -ﷺ- ക്ക് മേൽ അവതരിപ്പിക്കപ്പെട്ട ഗ്രന്ഥമാണ് ഖുർആൻ.<br /> <br /> ഈസാ നബി -عَلَيْهِ السَّلَامُ- ക്ക് മേൽ അവതരിപ്പിക്കപ്പെട്ട ഗ്രന്ഥമാണ് ഇഞ്ചീൽ.<br /> <br /> മൂസാ നബി -عَلَيْهِ السَّلَامُ- ക്ക് മേൽ അവതരിപ്പിക്കപ്പെട്ട ഗ്രന്ഥമാണ് തൗറാത്ത്.<br /> <br /> ദാവൂദ് നബി -عَلَيْهِ السَّلَامُ- ക്ക് മേൽ അവതരിപ്പിക്കപ്പെട്ട ഗ്രന്ഥമാണ് സബൂർ.<br /> <br /> ഇബ്രാഹീം നബി -عَلَيْهِ السَّلَامُ- ക്കും മൂസാ നബി -عَلَيْهِ السَّلَامُ- ക്കും മേൽ അവതരിപ്പിക്കപ്പെട്ട ഏടുകളും ഇതിൽ പെടും.<span class="c6"><br /> <br /> അല്ലാഹുവിൻ്റെ ദൂതന്മാരിലുള്ള വിശ്വാസം എന്നാൽ:</span><br /> <br /> അല്ലാഹു അവൻ്റെ ദാസന്മാരിലേക്ക് നബിമാരെയും റസൂലുകളെയും അയച്ചിട്ടുണ്ട് എന്ന് വിശ്വസിക്കലാണ്. അവർ ജനങ്ങൾക്ക് സ്വർഗത്തെ കുറിച്ചും നന്മകളെ കുറിച്ചും സന്തോഷവാർത്ത അറിയിക്കുകയും, നരകത്തെ കുറിച്ചും തിന്മകളെ കുറിച്ചും താക്കീത് നൽകുകയും ചെയ്തവരാണ്.<br /> <br /> നബിമാരിൽ ഏറ്റവും ശ്രേഷ്ഠർ ഉലുൽ അസ്മിൽ പെട്ടവരാണ്. അവർ അഞ്ചു പേരുണ്ട്.<br /> <br /> നൂഹ് നബി -عَلَيْهِ السَّلَامُ-.<br /> <br /> ഇബ്രാഹീം നബി -عَلَيْهِ السَّلَامُ-.<br /> <br /> മൂസാ നബി -عَلَيْهِ السَّلَامُ-.<br /> <br /> ഈസാ നബി -عَلَيْهِ السَّلَامُ-.<br /> <br /> മുഹമ്മദ് നബി -ﷺ-<span class="c6"><br /> <br /> അന്ത്യ ദിനത്തിലുള്ള വിശ്വാസം എന്നാൽ:</span><br /> <br /> മരണത്തിന് ശേഷം ഖബ്റിൽ ജീവിതമുണ്ട്, അന്ത്യനാൾ സംഭവിക്കുന്നതാണ്, അല്ലാഹു മനുഷ്യരെ മരിച്ചതിന് ശേഷം ഉയിർത്തെഴുന്നേൽപ്പിക്കുന്നതാണ്, അവരുടെ പ്രവർത്തനങ്ങൾ വിചാരണ ചെയ്യുന്നതാണ്, നന്മ ചെയ്തവർ സ്വർഗത്തിലും, തിന്മ ചെയ്തവർ നരകത്തിലും പ്രവേശിക്കപ്പെടുന്നതാണ് എന്നിങ്ങനെയുള്ള കാര്യങ്ങൾ വിശ്വസിക്കലാണ്.<br /> <br /> 6- ഖദാ ഖദറിലും <span class="c2">(അല്ലാഹുവിൻ്റെ വിധിയിലുള്ള)</span> അതിൻ്റെ നന്മയിലും തിന്മയിലുമുള്ള വിശ്വാസം.<br /> <br /> ലോകത്തിൽ സംഭവിക്കാനിരിക്കുന്ന എല്ലാ കാര്യങ്ങളും അല്ലാഹുവിന് അറിയാമെന്നും, അവയെല്ലാം അവൻ \'ലൗഹുൽ മഹ്ഫൂദ്\' എന്ന ഗ്രന്ഥത്തിൽ രേഖപ്പെടുത്തിയിട്ടുണ്ടെന്നും, അല്ലാഹു ഉദ്ദേശിക്കുന്ന കാര്യങ്ങൾ മാത്രമേ ഉണ്ടാവൂ എന്നും, അവനാണ് എല്ലാം സൃഷ്ടിച്ചത് എന്നും വിശ്വസിക്കലാണ്.<span class="c6"><br /> <br /> അല്ലാഹു പറയുന്നു:</span> "എല്ലാ വസ്തുക്കളെയും നാം സൃഷ്ടിച്ചത് കൃത്യമായ നിർണ്ണയത്തോടെയാണ്." <span class="c2">(ഖമർ: 49)</span><br /> <br /> അല്ലാഹുവിൻ്റെ വിധി നാല് പടികളാണ്:<br /> <br /> ഒന്ന്: അല്ലാഹുവിൻ്റെ അറിവ്. അല്ലാഹു എല്ലാ കാര്യങ്ങളും എന്നേ അറിഞ്ഞവനാണ്. കാര്യങ്ങൾ സംഭവിക്കുന്നതിന് മുൻപും, ശേഷവും അവൻ അതിനെ കുറിച്ച് അറിയുന്നു.<span class="c6"><br /> <br /> അല്ലാഹു പറയുന്നു:</span> തീർച്ചയായും അല്ലാഹുവിൻ്റെ പക്കലാണ് അന്ത്യ സമയത്തെ സംബന്ധിച്ചുള്ള അറിവ്. അവൻ മഴ വർഷിപ്പിക്കുന്നു. ഗർഭാശയങ്ങളിലുള്ളത് അവൻ അറിയുകയും ചെയ്യുന്നു. നാളെ താൻ എന്താണ് പ്രവർത്തിക്കുക എന്ന് ഒരാളും അറിയുകയില്ല. താൻ ഏത് നാട്ടിൽ വെച്ചാണ് മരിക്കുക എന്നും ഒരാളും അറിയുകയില്ല. തീർച്ചയായും അല്ലാഹു സർവ്വജ്ഞനും സൂക്ഷ്മജ്ഞാനിയുമാകുന്നു.\'\' <span class="c2">(ലുഖ്മാൻ: 34)</span><br /> രണ്ട്: അല്ലാഹു അറിഞ്ഞത് ലൗഹുൽ മഹ്ഫൂദ്വിൽ രേഖപ്പെടുത്തിയിരിക്കുന്നു. സംഭവിച്ചതും സംഭവിക്കാനിരിക്കുന്നതും അവൻ്റെ പക്കൽ ഒരു ഗ്രന്ഥത്തിൽ രേഖപ്പെടുത്തപ്പെട്ടിരിക്കുന്നു.<span class="c6"><br /> <br /> അല്ലാഹു പറയുന്നു:</span> "അവൻ്റെ പക്കലാകുന്നു അദൃശ്യകാര്യത്തിൻ്റെ ഖജനാവുകൾ. അവനല്ലാതെ അവ അറിയുകയില്ല. കരയിലും കടലിലുമുള്ളത് അവൻ അറിയുന്നു. അവനറിയാതെ ഒരു ഇല പോലും വീഴുന്നില്ല. ഭൂമിയിലെ ഇരുട്ടുകൾക്കുള്ളിലിരിക്കുന്ന ഒരു ധാന്യമണിയാകട്ടെ, പച്ചയോ, ഉണങ്ങിയതോ ആയ ഏതൊരു വസ്തുവാകട്ടെ, വ്യക്തമായ ഒരു രേഖയിൽ എഴുതപ്പെട്ടതായിട്ടല്ലാതെയില്ല." <span class="c2">(അൻആം: 59)</span><br /> മൂന്ന്: അല്ലാഹുവിൻ്റെ ഉദ്ദേശ്യപ്രകാരമല്ലാതെ ഒരു കാര്യവും സംഭവിക്കുന്നില്ല. അല്ലാഹുവിൽ നിന്നോ അവൻ്റെ സൃഷ്ടികളിൽ നിന്നോ എന്തൊരു കാര്യം സംഭവിക്കുന്നെങ്കിലും അത് അവൻ്റെ ഉദ്ദേശ്യപ്രകാരമല്ലാതെ സംഭവിക്കില്ല.<span class="c6"><br /> <br /> അല്ലാഹു പറയുന്നു:</span> അതായത് നിങ്ങളുടെ കൂട്ടത്തിൽ നിന്ന് നേരെ നിലകൊള്ളാൻ ഉദ്ദേശിച്ചവർക്ക് വേണ്ടി. ലോകങ്ങളുടെ രക്ഷിതാവായ അല്ലാഹു ഉദ്ദേശിക്കുന്നുവെങ്കിലല്ലാതെ നിങ്ങൾ ഉദ്ദേശിക്കുകയില്ല.\'\' <span class="c2">(തക്വീർ: 28, 29)</span><br /> നാല്: സർവ്വ വസ്തുക്കളെയും അല്ലാഹുവാണ് സൃഷ്ടിച്ചത് എന്ന വിശ്വാസം. അവയുടെ രൂപവും വിശേഷണങ്ങളും ചലനങ്ങളും അവയിലുള്ള മറ്റെല്ലാ കാര്യങ്ങളും അല്ലാഹുവാണ് സൃഷ്ടിച്ചത്.<span class="c6"><br /> <br /> അല്ലാഹു പറയുന്നു:</span> അല്ലാഹുവാണ് നിങ്ങളെയും നിങ്ങൾ നിർമ്മിച്ചുണ്ടാക്കുന്നവയെയും സൃഷ്ടിച്ചത്.\'\' <span class="c2">(സ്വാഫാത്ത്: 96)</span> </p>',
            ],
            15 => [
                'question' => 'ചോദ്യം 16: എന്താണ് വിശുദ്ധ ഖുർആൻ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1300.mp3',
                'answer' => '<p> ഉത്തരം: അല്ലാഹുവിൻ്റെ സംസാരമാണത്. ഖുർആൻ സൃഷ്ടിയല്ല.<span class="c6"><br /> <br /> അല്ലാഹു പറയുന്നു:</span> "ബഹുദൈവവിശ്വാസികളിൽ വല്ലവനും നിൻ്റെയടുക്കൽ അഭയം തേടിവന്നാൽ അല്ലാഹുവിൻ്റെ സംസാരം അവന് കേട്ട് ഗ്രഹിക്കാൻ വേണ്ടി അവന് അഭയം നൽകുക." <span class="c2">(തൗബ: 6)</span> </p>',
            ],
            16 => [
                'question' => 'ചോദ്യം 17: എന്താണ് സുന്നത്ത്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1330.mp3',
                'answer' => '<p> ഉത്തരം: നബി -ﷺ- യുടെ വാക്കുകൾക്കും പ്രവർത്തികൾക്കും അവിടുത്തെ അംഗീകാരത്തിനും സുന്നത്ത് എന്ന് പറയും. അവിടുത്തെ സ്വഭാവമോ ശാരീരിക രൂപമോ വിവരിക്കുന്ന വാക്കുകൾക്കും സുന്നത്ത് എന്ന് പറയും. </p>',
            ],
            17 => [
                'question' => 'ചോദ്യം 18: എന്താണ് ബിദ്അത്ത്? ബിദ്അത്തുകൾ നമ്മൾ സ്വീകരിക്കാൻ പാടുണ്ടോ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1350.mp3',
                'answer' => '<p> ഉത്തരം: നബി -ﷺ- യുടെയോ സ്വഹാബികളുടെയോ കാലത്തില്ലാത്ത, ദീനിൽ പുതുതായി ജനങ്ങൾ ഉണ്ടാക്കിയ എല്ലാ കാര്യങ്ങളും ബിദ്അത്തുകളാണ്.<br /> <br /> ബിദ്അത്തുകൾ ഒരിക്കലും നാം സ്വീകരിക്കരുത്. എല്ലാ ബിദ്അത്തുകളെയും നാം തള്ളിക്കളയുകയാണ് വേണ്ടത്.<br /> <br /> കാരണം നബി -ﷺ-<span class="c6"> പറഞ്ഞിരിക്കുന്നു:</span> "എല്ലാ ബിദ്അത്തും വഴികേടാകുന്നു." <span class="c2">(അബൂദാവൂദ്)</span><br /> ആരാധനകളിൽ എന്തൊരു കാര്യം അധികരിപ്പിക്കുന്നതും ബിദ്അത്തിൽ പെടും. ഉദാഹരണത്തിന് ഒരാൾ വുദൂഅ് ചെയ്യുമ്പോൾ നാലു തവണ മുഖം കഴുകിയാൽ അത് ബിദ്അത്താണ്. നബി -ﷺ- ജനിച്ച ദിവസം ആഘോഷിക്കുക എന്നതും ഇത് പോലെ ബിദ്അത്താണ്. ഇതൊന്നും നബി -ﷺ- യോ സ്വഹാബികളോ ചെയ്തിട്ടില്ല. </p>',
            ],
            18 => [
                'question' => 'ചോദ്യം 19: വലാഉം ബറാഉം (വിശ്വാസപരമായ അടുപ്പവും അകൽച്ചയും) എന്നു പറയുന്നതിൻ്റെ ഉദ്ദേശ്യം എന്താണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1410.mp3',
                'answer' => '<p> ഉത്തരം: അല്ലാഹുവിലും അവൻ്റെ റസൂലിലും വിശ്വസിച്ച മുസ്ലിംകളെ സ്നേഹിക്കലും അവരെ സഹായിക്കലുമാണ് വലാഅ് എന്നു പറഞ്ഞാൽ.<span class="c6"><br /> <br /> അല്ലാഹു പറയുന്നു:</span> "<span class="c2">(അല്ലാഹുവിൽ)</span> വിശ്വസിച്ച പുരുഷന്മാരും വിശ്വസിച്ച സ്ത്രീകളും പരസ്പരം അന്യോന്യം ഉറ്റമിത്രങ്ങളാകുന്നു." <span class="c2">(തൗബ: 71)</span><br /> അല്ലാഹുവിനെയും അവൻ്റെ ദൂതനെയും നിഷേധിച്ചവരെ വെറുക്കലും അവരോട് അകൽച്ച പുലർത്തലുമാണ് ബറാഅ് എന്നു പറഞ്ഞാൽ.<span class="c6"><br /> <br /> അല്ലാഹു പറയുന്നു:</span> "നിങ്ങൾക്ക് ഇബ്രാഹീമിലും അദ്ദേഹത്തിൻ്റെ കൂടെയുള്ളവരിലും ഉത്തമമായ ഒരു മാതൃക ഉണ്ടായിട്ടുണ്ട്.<span class="c6"> അവർ തങ്ങളുടെ ജനതയോട് ഇപ്രകാരം പറഞ്ഞ സന്ദർഭം:</span> നിങ്ങളുമായും അല്ലാഹുവിന് പുറമെ നിങ്ങൾ ആരാധിക്കുന്നവയുമായുള്ള ബന്ധത്തിൽ നിന്നു തീർച്ചയായും ഞങ്ങൾ ഒഴിവായവരാകുന്നു. നിങ്ങളിൽ ഞങ്ങൾ അവിശ്വസിച്ചിരിക്കുന്നു. നിങ്ങൾ അല്ലാഹുവിൽ മാത്രം വിശ്വസിക്കുന്നത് വരെ എന്നെന്നേക്കുമായി ഞങ്ങളും നിങ്ങളും തമ്മിൽ ശത്രുതയും വിദ്വേഷവും പ്രകടമാവുകയും ചെയ്തിരിക്കുന്നു." <span class="c2">(മുംതഹിന: 4)</span> </p>',
            ],
            19 => [
                'question' => 'ചോദ്യം 20: ഇസ്ലാമല്ലാത്ത മറ്റേതെങ്കിലും മതം അല്ലാഹു സ്വീകരിക്കുമോ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1480.mp3',
                'answer' => '<p> ഉത്തരം: ഇസ്ലാമല്ലാത്ത മറ്റേതെങ്കിലും മതം അല്ലാഹു സ്വീകരിക്കുകയില്ല.<span class="c6"><br /> <br /> അല്ലാഹു പറയുന്നു:</span> "ആരെങ്കിലും ഇസ്ലാമല്ലാത്ത മറ്റേതു കാര്യവും തൻ്റെ മതമായി അന്വേഷിച്ചാൽ അത് അവനിൽ നിന്ന് സ്വീകരിക്കപ്പെടുന്നതല്ല. അന്ത്യനാളിൽ അവൻ നഷ്ടക്കാരിൽ ഉൾപ്പെടുന്നതാണ്." <span class="c2">(ആലു ഇംറാൻ: 85)</span> </p>',
            ],
            20 => [
                'question' => 'ചോദ്യം 21: വാക്കു കൊണ്ടും പ്രവർത്തി കൊണ്ടും വിശ്വാസം കൊണ്ടും ഒരാൾ ഇസ്ലാമിൽ നിന്ന് പുറത്തു പോകും (കുഫ്ർ). ഉദാഹരണങ്ങൾ പറയാമോ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1520.mp3',
                'answer' => '<p> ഉത്തരം: വാക്ക് കൊണ്ട് ഇസ്ലാമിൽ നിന്ന് പുറത്തു പോകുന്നതിന് ഉദാഹരണമാണ് അല്ലാഹുവിനെയോ അവൻ്റെ റസൂലിനെയോ മോശം പറയുക എന്നത്.<br /> <br /> ഇസ്ലാമിൽ നിന്ന് പുറത്തു പോകാൻ കാരണമാകുന്ന പ്രവർത്തിക്ക് ഉദാഹരണമാണ് വിശുദ്ധ ഖുർആനിനെ <span class="c2">(മുസ്ഹഫ്)</span> നിന്ദിക്കുകയോ, അല്ലാഹുവല്ലാത്തവർക്ക് മുൻപിൽ സുജൂദ് നിർവ്വഹിക്കുകയോ ചെയ്യുന്നത്.<br /> <br /> അല്ലാഹുവല്ലാത്ത ആർക്കെങ്കിലും ആരാധനക്ക് അർഹതയുണ്ട് എന്നോ, അല്ലാഹുവല്ലാത്ത ഏതെങ്കിലും സ്രഷ്ടാവ് ഉണ്ട് എന്നോ വിശ്വസിക്കുന്നത് ഇസ്ലാമിൽ നിന്ന് പുറത്തു പോകുന്ന വിശ്വാസത്തിൽ പെട്ടതാണ്. </p>',
            ],
            21 => [
                'question' => 'ചോദ്യം 22: എന്താണ് നിഫാഖ് (കപടവിശ്വാസം)? അതിൻ്റെ ഇനങ്ങൾ ഏതെല്ലാമാണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1570.mp3',
                'answer' => '<p> ഉത്തരം: നിഫാഖ് <span class="c2">(കപടവിശ്വാസം)</span> രണ്ട് രൂപത്തിലുണ്ട്.<br /> <br /> 1- വലിയ നിഫാഖ്. പുറത്തേക്ക് മുസ്ലിമാണെന്ന് കാണിക്കുകയും, ഉള്ളിൽ കുഫ്ർ ഒളിപ്പിച്ചു വെക്കുകയും ചെയ്യൽ വലിയ നിഫാഖാണ്.<br /> <br /> ഒരാൾ ഇങ്ങനെ ചെയ്താൽ അവൻ ഇസ്ലാമിൽ നിന്ന് പുറത്തു പോകും.<span class="c6"><br /> <br /> അല്ലാഹു പറയുന്നു:</span> "തീർച്ചയായും നിഫാഖുള്ളവർ <span class="c2">(കപടവിശ്വാസികൾ / മുനാഫിഖുകൾ)</span> നരകത്തിൻ്റെ അടിത്തട്ടിലായിരിക്കും. അവർക്ക് ഒരു സഹായിയെയും നിനക്ക് കണ്ടെത്താൻ കഴിയില്ല." <span class="c2">(നിസാഅ്: 145)</span><br /> 2- ചെറിയ നിഫാഖ്.<br /> <br /> കളവു പറയലും, വാഗ്ദാനം ലംഘിക്കലും, വിശ്വസിച്ചേൽപ്പിച്ച കാര്യത്തിൽ വഞ്ചന കാണിക്കലും അതിൽ പെടും.<br /> <br /> എന്നാൽ ചെറിയ നിഫാഖ് കൊണ്ട് ഒരാൾ ഇസ്ലാമിൽ നിന്ന് പുറത്തു പോവുകയില്ല. മറിച്ച്, ശിക്ഷ ലഭിക്കാൻ കാരണമാകുന്ന തിന്മകളിലാണ് അത് ഉൾപ്പെടുക.<br /> <br /> അല്ലാഹുവിൻ്റെ റസൂൽ -ﷺ-<span class="c6"> പറഞ്ഞിരിക്കുന്നു:</span> "കപടവിശ്വാസിയുടെ ലക്ഷണങ്ങൾ മൂന്നെണ്ണമാണ്. സംസാരിച്ചാൽ അവൻ കളവു പറയും. വാഗ്ദാനം ചെയ്താൽ ലംഘിക്കും. വിശ്വസിക്കപ്പെട്ടാൽ വഞ്ചിക്കും." <span class="c2">(ബുഖാരി, മുസ്ലിം)</span> </p>',
            ],
            22 => [
                'question' => 'ചോദ്യം 23: അവസാനത്തെ നബിയും റസൂലും ആരാണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1680.mp3',
                'answer' => '<p> ഉത്തരം: മുഹമ്മദ് നബി -ﷺ- യാണ്.<span class="c6"><br /> <br /> അല്ലാഹു പറയുന്നു:</span> "മുഹമ്മദ് നിങ്ങളുടെ പുരുഷന്മാരിൽ ഒരാളുടെയും പിതാവായിട്ടില്ല.പക്ഷെ, അദ്ദേഹം അല്ലാഹുവിൻ്റെ ദൂതനും നബിമാരിൽ അന്തിമനുമാകുന്നു." <span class="c2">(അഹ്സാബ്: 40)</span> അല്ലാഹുവിൻ്റെ റസൂൽ -ﷺ-<span class="c6"> പറഞ്ഞിരിക്കുന്നു:</span> "ഞാൻ നബിമാരിൽ അന്തിമനാകുന്നു. എനിക്ക് ശേഷം ഇനിയൊരു നബിയില്ല." <span class="c2">(അബൂദാവൂദ്, തിർമിദി തുടങ്ങിയവർ)</span> </p>',
            ],
            23 => [
                'question' => 'ചോദ്യം 24: എന്താണ് മുഅ്ജിസത്ത്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1730.mp3',
                'answer' => '<p> ഉത്തരം: അല്ലാഹു അവൻ്റെ നബിമാരുടെ സത്യസന്ധത ബോധ്യപ്പെടുത്താനുള്ള തെളിവുകളായി അവർക്ക് നൽകിയ അത്ഭുതസംഭവങ്ങളാണ് മുഅ്ജിസത്തുകൾ.<span class="c6"> ഉദാഹരണം:</span><br /> <br /> - നബി -ﷺ- ക്ക് വേണ്ടി ചന്ദ്രനെ രണ്ടായി പിളർത്തിയത്.<br /> <br /> - മൂസാ നബി -عَلَيْهِ السَّلَامُ- ക്ക് വേണ്ടി സമുദ്രം രണ്ടായി പിളർന്നതും, ഫിർഔനും സൈന്യവും അതിൽ മുക്കി നശിപ്പിക്കപ്പെട്ടതും. </p>',
            ],
            24 => [
                'question' => 'ചോദ്യം 25: ആരാണ് സ്വഹാബികൾ? ഞാൻ അവരെ സ്നേഹിക്കണമോ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1780.mp3',
                'answer' => '<p> ഉത്തരം: നബി -ﷺ- യെ കണ്ടുമുട്ടുകയും, അവിടുത്തെ വിശ്വസിക്കുകയും, മുസ്ലിമായി മരണപ്പെടുകയും ചെയ്ത എല്ലാ വ്യക്തികളും സ്വഹാബിമാരിൽ പെടും.<br /> <br /> - നാം സ്വഹാബികളെ സ്നേഹിക്കുകയും അവരെ മാതൃകയാക്കുകയും വേണം. നബിമാർ കഴിഞ്ഞാൽ ഏറ്റവും നല്ലവരും ഏറ്റവും ശ്രേഷ്ഠതയുള്ളവരും അവരാണ്.<br /> <br /> സ്വഹാബികളിൽ ഏറ്റവും ശ്രേഷ്ഠതയുള്ളവർ നാല് ഖലീഫമാരാണ്.<br /> <br /> അബൂബക്ർ സിദ്ധീഖ് -رضي الله عنه-<br /> <br /> ഉമർ ബ്നുൽ ഖത്താബ് -رضي الله عنه-<br /> <br /> ഉഥ്മാൻ ബ്നു അഫ്ഫാൻ -رضي الله عنه-<br /> <br /> അലി ബ്നു അബീ ത്വാലിബ് -رضي الله عنه- </p>',
            ],
            25 => [
                'question' => 'ചോദ്യം 26: ആരാണ് ഉമ്മഹാതുൽ മുഅ്മിനീൻ (വിശ്വാസികളുടെ മാതാക്കൾ)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1870.mp3',
                'answer' => '<p> ഉത്തരം: നബി -ﷺ- യുടെ ഭാര്യമാരെല്ലാം വിശ്വാസികളുടെ മാതാക്കളാണ്.<span class="c6"><br /> <br /> അല്ലാഹു പറയുന്നു:</span> "നബി സത്യവിശ്വാസികൾക്ക് സ്വദേഹങ്ങളെക്കാളും അടുപ്പമുള്ളവരാകുന്നു. അവിടുത്തെ ഭാര്യമാർ അവരുടെ മാതാക്കളുമാകുന്നു." <span class="c2">(അഹ്സാബ്: 6)</span> </p>',
            ],
            26 => [
                'question' => 'ചോദ്യം 27: നബി -ﷺ- യുടെ കുടുംബത്തോടുള്ള നമ്മുടെ ബാധ്യത എന്താണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1910.mp3',
                'answer' => '<p> ഉത്തരം: നാം അവരെ സ്നേഹിക്കുകയും അവരോട് ബന്ധംചേർക്കുകയും വേണം. അവരെ വെറുക്കുന്നവരെ നാം വെറുക്കുന്നു. എന്നാൽ അവരുടെ കാര്യത്തിൽ നാം അതിരു കവിയാൻ പാടില്ല. നബി -ﷺ- യുടെ കുടുംബം എന്നാൽ അവിടുത്തെ ഭാര്യമാരും, മക്കളും, മുസ്ലിംകളായ ബനൂ ഹാശിമുകാരും ബനുൽ മുത്വലിബുകാരുമാണ്. </p>',
            ],
            27 => [
                'question' => 'ചോദ്യം 28: മുസ്ലിം ഭരണാധികാരികളോടുള്ള നമ്മുടെ ബാധ്യത എന്താണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1940.mp3',
                'answer' => '<p> ഉത്തരം: മുസ്ലിം ഭരണാധികാരികളെ നാം ആദരിക്കുകയും, അവരുടെ വാക്കുകൾ കേൾക്കുകയും അനുസരിക്കുകയും ചെയ്യണം. എന്നാൽ തിന്മ ചെയ്യാൻ അവർ പറഞ്ഞാൽ അത് കേൾക്കുകയോ അനുസരിക്കുകയോ വേണ്ടതില്ല. ഇസ്ലാമിക ഭരണാധികാരികൾക്ക് എതിരെ നാം വിപ്ലവം നടത്തരുത്. അവർക്ക് വേണ്ടി പ്രാർത്ഥിക്കുകയും, അവരെ രഹസ്യമായി ഉപദേശിക്കുകയുമാണ് ചെയ്യേണ്ടത്. </p>',
            ],
            28 => [
                'question' => 'ചോദ്യം 29: മുഅ്മിനുകളുടെ സങ്കേതം ഏതാണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1970.mp3',
                'answer' => '<p> ഉത്തരം: സ്വർഗമാണ് മുഅ്മിനുകളുടെ സങ്കേതം.<span class="c6"> അല്ലാഹു പറയുന്നു:</span> "<span class="c2">(അല്ലാഹുവിലും അവൻ്റെ ദൂതനിലും)</span> വിശ്വസിക്കുകയും, സൽകർമ്മങ്ങൾ പ്രവർത്തിക്കുകയും ചെയ്തവരെ താഴ്ഭാഗത്തുകൂടി നദികൾ ഒഴുകിക്കൊണ്ടിരിക്കുന്ന സ്വർഗത്തോപ്പുകളിൽ അല്ലാഹു പ്രവേശിപ്പിക്കുക തന്നെ ചെയ്യുന്നതാണ്." <span class="c2">(മുഹമ്മദ്: 12)</span> </p>',
            ],
            29 => [
                'question' => 'ചോദ്യം 30: കാഫിറുകളുടെ സങ്കേതം ഏതാണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2000.mp3',
                'answer' => '<p> ഉത്തരം: നരകമാണ് കാഫിറുകളുടെ സങ്കേതം.<span class="c6"> അല്ലാഹു പറയുന്നു:</span> "നിങ്ങൾ നരകത്തെ സൂക്ഷിക്കുക; മനുഷ്യരും കല്ലുകളുമാണ് അതിലെ ഇന്ധനം. കാഫിറുകൾക്ക് വേണ്ടി ഒരുക്കപ്പെട്ടതാണത്." <span class="c2">(ബഖറ: 24)</span> </p>',
            ],
            30 => [
                'question' => 'ചോദ്യം 31: എങ്ങനെയാണ് ഭയമുണ്ടാകേണ്ടത്? എങ്ങനെയാണ് പ്രതീക്ഷ വെക്കേണ്ടത്? എന്താണ് അതിനുള്ള തെളിവ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2020.mp3',
                'answer' => '<p> ഉത്തരം: ഭയം എന്നാൽ അല്ലാഹുവിനെയും അവൻ്റെ ശിക്ഷയെയും ഭയക്കലാണ്.<br /> <br /> പ്രതീക്ഷ എന്നാൽ അല്ലാഹുവിൻ്റെ പ്രതിഫലത്തിലും അവൻ്റെ പാപമോചനത്തിലും കാരുണ്യത്തിലും പ്രതീക്ഷ വെക്കലാണ്.<span class="c6"><br /> <br /> ഈ പറഞ്ഞതിനുള്ള തെളിവ് അല്ലാഹുവിൻ്റെ വചനമാണ്:</span> "<span class="c2">(അവർ വിളിച്ചു പ്രാർത്ഥിച്ചു കൊണ്ടിരിക്കുന്നത് ആരെയാണോ അവർ തന്നെ തങ്ങളുടെ രക്ഷിതാവിങ്കലേക്ക് സമീപനമാർഗ്ഗം തേടിക്കൊണ്ടിരിക്കുകയാണ്. അതെ, അവരുടെ കൂട്ടത്തിൽ അല്ലാഹുവോട് ഏറ്റവും അടുത്തവർ തന്നെ (അപ്രകാരം തേടുന്നു)</span>. അവർ അവൻ്റെ കാരുണ്യം ആഗ്രഹിക്കുകയും അവൻ്റെ ശിക്ഷ ഭയപ്പെടുകയും ചെയ്യുന്നു. നിൻ്റെ രക്ഷിതാവിൻ്റെ ശിക്ഷ തീർച്ചയായും ഭയപ്പെടേണ്ടതാകുന്നു.)" <span class="c2">(ഇസ്റാഅ്: 57)</span> അല്ലാഹു പറയുന്നു: "<span class="c2">(നബിയേ!)</span> ഞാൻ ധാരാളമായി പൊറുത്തു കൊടുക്കുന്ന ഗഫൂറാണെന്നും ധാരാളമായി കരുണ ചൊരിയുന്ന റഹീമാണെന്നും എൻ്റെ ദാസന്മാരെ അറിയിക്കുക! എൻ്റെ ശിക്ഷ തന്നെയാണ് അതീവ വേദനയുള്ള ശിക്ഷയെന്നും <span class="c2">(അവരെ അറിയിക്കുക)</span>." <span class="c2">(ഹിജ്ർ: 49-50)</span> </p>',
            ],
            31 => [
                'question' => 'ചോദ്യം 32: അല്ലാഹുവിൻ്റെ ചില നാമങ്ങളും (അസ്മാഉൽ ഹുസ്നാ) ചില വിശേഷണങ്ങളും പറയാമോ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2070.mp3',
                'answer' => '<p> ഉത്തരം: അല്ലാഹു <span class="c2">(യഥാർത്ഥ ആരാധ്യൻ)</span>, അർ-റബ്ബ് <span class="c2">(സർവ്വലോക രക്ഷിതാവ്)</span>, അർ-റഹ്മാൻ <span class="c2">(അതിവിശാലമായ കാരുണ്യമുള്ളവൻ)</span>, അസ്സമീഅ് <span class="c2">(എല്ലാം കേൾക്കുന്നവൻ)</span>, അൽ-ബസ്വീർ <span class="c2">(എല്ലാം കാണുന്നവൻ)</span>, അൽ-അലീം <span class="c2">(എല്ലാം അറിയുന്നവൻ)</span>, അർ-റസ്സാഖ് <span class="c2">(എല്ലാവർക്കും ഉപജീവനം നൽകുന്നവൻ)</span>, അൽ-ഹയ്യ് <span class="c2">(എന്നെന്നും ജീവിച്ചിരിക്കുന്നവൻ)</span>, അൽ-അദ്വീം <span class="c2">(അതീവ മഹത്വമുള്ളവൻ)</span>... ഇവയെല്ലാം അല്ലാഹുവിൻ്റെ ഏറ്റവും മഹത്തരമായ ചില നാമങ്ങളും വിശേഷണങ്ങളുമാണ്. </p>',
            ],
            32 => [
                'question' => 'ചോദ്യം 33: അല്ലാഹുവിൻ്റെ ഈ നാമങ്ങൾ വിശദീകരിക്കാമോ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2100.mp3',
                'answer' => '<p> ഉത്തരം: അല്ലാഹു: യഥാർത്ഥ ആരാധ്യനും, സർവ്വ ഇബാദത്തുകൾക്കും അർഹതയുള്ളവനുമായ ഏകആരാധ്യൻ എന്നാണ് അതിൻ്റെ അർത്ഥം.<br /> <br /> അർ-<span class="c6">റബ്ബ്:</span> സർവ്വരെയും സൃഷ്ടിച്ചവനും സർവ്വരുടെയും ഉടമസ്ഥനും എല്ലാവർക്കും ഉപജീവനം നൽകുന്നവനും എല്ലാവരെയും നിയന്ത്രിക്കുന്നവനുമാണ് റബ്ബ്.<span class="c6"><br /> <br /> അസ്സമീഅ്:</span> എല്ലാ കാര്യങ്ങളും കേൾക്കുന്നവനാണ് അവൻ. വ്യത്യസ്തങ്ങളും വിവിധങ്ങളുമായ എല്ലാ ശബ്ദങ്ങളും അവൻ കേൾക്കുന്നു.<br /> <br /> അൽ-<span class="c6">ബസ്വീർ:</span> എല്ലാ കാര്യങ്ങളും കാണുന്നവൻ; ചെറുതാകട്ടെ വലുതാകട്ടെ, അവയെല്ലാം അല്ലാഹു കാണുന്നതാണ്.<br /> <br /> അൽ-<span class="c6">അലീം:</span> എല്ലാ കാര്യങ്ങളെയും സൂക്ഷ്മമായി അറിഞ്ഞവൻ; കഴിഞ്ഞു പോയതും നടന്നു കൊണ്ടിരിക്കുന്നതും വരാനിരിക്കുന്നതുമെല്ലാം അവൻ അറിഞ്ഞിരിക്കുന്നു.<br /> <br /> അർ-<span class="c6">റഹ്മാൻ:</span> സർവ്വ സൃഷ്ടികൾക്കും ജീവികൾക്കും തൻ്റെ വിശാലമായ കാരുണ്യം നൽകിയവൻ. അല്ലാഹുവിൻ്റെ കാരുണ്യത്തിന് കീഴിലാണ് എല്ലാ സൃഷ്ടികളും എല്ലാ മനുഷ്യരുമുള്ളത്.<br /> <br /> അർ-<span class="c6">റസാഖ്:</span> മനുഷ്യർക്കും ജിന്നുകൾക്കും മറ്റേതെല്ലാം ജീവികളുണ്ടോ അവക്കുമെല്ലാം ഉപജീവനം നൽകുന്നവനാണ് അല്ലാഹു.<span class="c6"><br /> <br /> അൽഹയ്യ്:</span> ഒരിക്കലും മരിക്കാത്ത, എന്നെന്നും ജീവിച്ചിരിക്കുന്നവനാണ് അല്ലാഹു. എല്ലാ സൃഷ്ടികളും മരിക്കുന്നതാണ്.<span class="c6"><br /> <br /> അൽഅദ്വീം:</span> എല്ലാ നിലക്കും പരിപൂർണ്ണതയുള്ളവൻ. അവൻ്റെ പേരുകളും വിശേഷണങ്ങളും പ്രവർത്തികളുമെല്ലാം അതീവ മഹത്തരമാണ്. </p>',
            ],
            33 => [
                'question' => 'ചോദ്യം 34: മുസ്ലിം പണ്ഡിതന്മാരോടുള്ള നമ്മുടെ ബാധ്യത എന്താണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2210.mp3',
                'answer' => '<p> ഉത്തരം: മുസ്ലിം പണ്ഡിതന്മാരെ നാം ബഹുമാനിക്കണം. മതപരമായ വിഷയങ്ങൾ അറിയുന്നതിനും, പ്രശ്നങ്ങൾ പരിഹരിക്കുന്നതിനും നാം അവരെ സമീപിക്കണം. ദീൻ പഠിച്ച പണ്ഡിതന്മാരെ കുറിച്ച് നല്ലതല്ലാതെ നമ്മൾ പറയാൻ പാടില്ല. ആരെങ്കിലും ഇസ്ലാമിക പണ്ഡിതന്മാരെ മോശം പറയുന്നുവെങ്കിൽ അവൻ ശരിയായ വഴിയിൽ നിന്ന് തെറ്റിപ്പോയിരിക്കുന്നു.<span class="c6"><br /> <br /> അല്ലാഹു പറയുന്നു:</span> "നിങ്ങളിൽ നിന്ന് ഈമാനുള്ളവരെയും അറിവ് നല്കപ്പെട്ടവരെയും അല്ലാഹു പല പടികൾ ഉയർത്തുന്നതാണ്. അല്ലാഹു നിങ്ങൾ പ്രവർത്തിക്കുന്നതിനെ പറ്റി സൂക്ഷ്മമായി അറിയുന്നവനാകുന്നു." <span class="c2">(മുജാദിലഃ: 11)</span> </p>',
            ],
            34 => [
                'question' => 'ചോദ്യം 35: ആരാണ് അല്ലാഹുവിൻ്റെ ഔലിയാക്കൾ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2240.mp3',
                'answer' => '<p> ഉത്തരം: അല്ലാഹുവിലും അവൻ്റെ റസൂലിലും വിശ്വസിച്ച, അല്ലാഹുവിനെ സൂക്ഷിച്ചു ജീവിക്കുന്ന മുത്തഖീങ്ങളാണ് ഔലിയാക്കൾ.<span class="c6"><br /> <br /> അല്ലാഹു പറയുന്നു:</span> "അറിയുക! തീർച്ചയായും അല്ലാഹുവിൻ്റെ ഔലിയാക്കൾ; അവർക്ക് യാതൊരു ഭയവുമില്ല. അവർ ദുഃഖിക്കേണ്ടി വരികയുമില്ല. <span class="c2">(അല്ലാഹുവിലും അവൻ്റെ റസൂലിലും)</span> വിശ്വസിക്കുകയും സൂക്ഷ്മത പാലിച്ചു കൊണ്ടിരിക്കുകയും ചെയ്യുന്നവരത്രെ അവർ." <span class="c2">(യൂനുസ്: 62-63)</span> </p>',
            ],
            35 => [
                'question' => 'ചോദ്യം 36: ഈമാൻ എന്നാൽ വാക്കും പ്രവർത്തിയും കൂടുന്നതാണോ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2280.mp3',
                'answer' => '<p> ഉത്തരം: അതെ! ഈമാൻ എന്നാൽ വാക്കും പ്രവർത്തിയും വിശ്വാസവും ഒരുമിച്ചു കൂടിയ കാര്യമാണ്. </p>',
            ],
            36 => [
                'question' => 'ചോദ്യം 37: ഈമാൻ കൂടുകയും കുറയുകയും ചെയ്യുമോ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2310.mp3',
                'answer' => '<p> ഉത്തരം: അതെ! നന്മകൾ ചെയ്യുമ്പോൾ ഈമാൻ കൂടുകയും, തിന്മകൾ പ്രവർത്തിച്ചാൽ ഈമാൻ കുറയുകയും ചെയ്യും.<span class="c6"><br /> <br /> അല്ലാഹു പറയുന്നു:</span> "അല്ലാഹുവെപ്പറ്റി പറയപ്പെട്ടാൽ ഹൃദയങ്ങൾ പേടിച്ച് നടുങ്ങുകയും, അവൻ്റെ ദൃഷ്ടാന്തങ്ങൾ വായിച്ചു കേൾപ്പിക്കപ്പെട്ടാൽ വിശ്വാസം വർദ്ധിക്കുകയും, തങ്ങളുടെ രക്ഷിതാവിൻ്റെ മേൽ ഭരമേല്പിക്കുകയും ചെയ്യുന്നവർ മാത്രമാണ് സത്യവിശ്വാസികൾ." <span class="c2">(അൻഫാൽ: 2)</span> </p>',
            ],
            37 => [
                'question' => 'ചോദ്യം 38: എന്താണ് ഇഹ്സാൻ എന്നു പറഞ്ഞാൽ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2350.mp3',
                'answer' => '<p> ഉത്തരം: ഇഹ്സാൻ എന്നാൽ നീ അല്ലാഹുവിനെ കാണുന്നതു പോലെ അവനെ ആരാധിക്കലാകുന്നു. നീ അല്ലാഹുവിനെ കാണുന്നില്ലെങ്കിലും അവൻ നിന്നെ കാണുന്നുണ്ട്. </p>',
            ],
            38 => [
                'question' => 'ചോദ്യം 39: എപ്പോഴാണ് അല്ലാഹു നമ്മുടെ പ്രവർത്തനങ്ങൾ സ്വീകരിക്കുക?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2370.mp3',
                'answer' => '<p> ഉത്തരം: അല്ലാഹു നമ്മുടെ പ്രവർത്തനങ്ങൾ സ്വീകരിക്കണമെങ്കിൽ രണ്ട് നിബന്ധനകൾ ഉണ്ട്.<br /> <br /> 1- അല്ലാഹുവിൻ്റെ പ്രതിഫലം ഉദ്ദേശിച്ചു കൊണ്ട്, അവൻ്റെ തിരുവദനം ദർശിക്കണമെന്ന ഉദ്ദേശ്യത്തോടെ മാത്രം ഇബാദത്ത് ചെയ്യണം.<br /> <br /> 2- നബി -ﷺ- യുടെ സുന്നത്തിനോട് -അവിടുത്തെ ചര്യയോട്- യോജിച്ച രൂപത്തിലായിരിക്കണം. </p>',
            ],
            39 => [
                'question' => 'ചോദ്യം 40: അല്ലാഹുവിൻ്റെ മേൽ തവക്കുൽ ചെയ്യേണ്ടത് എങ്ങനെയാണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2420.mp3',
                'answer' => '<p> ഉത്തരം: എന്തൊരു ഉപകാരം ലഭിക്കുന്നതിനും, ഏതു ഉപദ്രവം തടുക്കുന്നതിനും അല്ലാഹുവിൻ്റെ മേൽ മാത്രം നീ ഭരമേൽപ്പിക്കുക, അതോടൊപ്പം നിൻ്റെ ഉദ്ദേശ്യം നടക്കാൻ വേണ്ട പണികൾ ചെയ്യുക; ഇതാണ് തവക്കുൽ.<span class="c6"><br /> <br /> അല്ലാഹു പറയുന്നു:</span> "ആരെങ്കിലും അല്ലാഹുവിൻ്റെമേൽ ഭരമേൽപ്പിക്കുന്ന പക്ഷം അവന് അല്ലാഹു തന്നെ മതിയാകുന്നതാണ്." <span class="c2">(ത്വലാഖ്: 3)</span><br /> അല്ലാഹു അവന് മതിയാകുന്നതാണ് എന്നു പറഞ്ഞാൽ അല്ലാഹു അവൻ്റെ എല്ലാ കാര്യവും നിറവേറ്റി കൊടുക്കുന്നതാണ് എന്നാണ് അർത്ഥം. </p>',
            ],
            40 => [
                'question' => 'ചോദ്യം 41: നന്മ കൽപ്പിക്കുക എന്നതും തിന്മ വിരോധിക്കുക എന്നതും നിർബന്ധമാണല്ലോ? എന്താണ് അതിൻ്റെ ഉദ്ദേശ്യം?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2470.mp3',
                'answer' => '<p> ഉത്തരം: അല്ലാഹുവിന് ഇഷ്ടമുള്ള, അവനെ അനുസരിക്കേണ്ട ഏതു കാര്യം കൽപ്പിച്ചാലും അത് നന്മ കൽപ്പിക്കലാണ്. അല്ലാഹുവിന് ഇഷ്ടമില്ലാത്ത, അവനെ ധിക്കരിക്കുന്ന ഏതു കാര്യം വിലക്കിയാലും അത് തിന്മ വിരോധിക്കലാണ്.<span class="c6"><br /> <br /> അല്ലാഹു പറയുന്നു:</span> "മനുഷ്യവംശത്തിനു വേണ്ടി രംഗത്ത് കൊണ്ടുവരപ്പെട്ട ഉത്തമസമുദായമാകുന്നു നിങ്ങൾ. നിങ്ങൾ നന്മ കല്പിക്കുകയും, തിന്മയിൽ നിന്ന് വിലക്കുകയും, അല്ലാഹുവിൽ വിശ്വസിക്കുകയും ചെയ്യുന്നു." <span class="c2">(ആലു ഇംറാൻ: 110)</span> </p>',
            ],
            41 => [
                'question' => 'ചോദ്യം 42: ആരാണ് അഹ്ലുസ്സുന്നത്തി വൽ ജമാഅഃ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2510.mp3',
                'answer' => '<p> ഉത്തരം: മുഹമ്മദ് നബി -ﷺ- യും അവിടുത്തെ അനുചരന്മാരായ സ്വഹാബികളും നിലകൊണ്ടിരുന്ന അതേ മാർഗത്തിൽ നിലകൊള്ളുന്നവരാണ് അഹ്ലുസ്സുന്നത്തി വൽ ജമാഅഃ. വാക്കിലും പ്രവർത്തിയിലും വിശ്വാസത്തിലും ഈ മാർഗമാണ് നാം സ്വീകരിക്കേണ്ടത്.<br /> <br /> നബി -ﷺ- യുടെ സുന്നത്തും അവിടുത്തെ ചര്യയും പിൻപറ്റുന്നത് കൊണ്ടും, എല്ലാ പുതിയകാര്യങ്ങളെയും ബിദ്അത്തുകളെയും ഉപേക്ഷിക്കുന്നത് കൊണ്ടുമാണ് അവർക്ക് അഹ്ലുസ്സുന്നഃ എന്ന പേര് നൽകപ്പെട്ടത്.<br /> <br /> സത്യത്തിൻ്റെ മാർഗത്തിൽ ഒരേ ജമാഅത്തായി ഐക്യത്തോടെ നിലകൊള്ളുകയും, ഭിന്നിക്കാതിരിക്കുകയും ചെയ്യുന്നത് കൊണ്ടാണ് അവർക്ക് അഹ്ലുൽ ജമാഅഃ എന്ന പേര് നൽകപ്പെട്ടത്. </p>',
            ],
        ],
        2 => [
            0 => [
                'question' => 'ചോദ്യം 1: എന്താണ് ശുദ്ധീകരണം?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2580.mp3',
                'answer' => '<p> ഉത്തരം: അശുദ്ധി നീക്കലും, മാലിന്യം എടുത്തു മാറ്റലുമാണ് ശുദ്ധീകരണം.<br /> <br /> മാലിന്യം എടുത്തു മാറ്റുക എന്നത് കൊണ്ട് ഉദ്ദേശ്യം ശരീരത്തിലോ വസ്ത്രത്തിലോ നിസ്കരിക്കുന്ന സ്ഥലത്തോ നജസ് <span class="c2">(മാലിന്യം)</span> ആയിട്ടുണ്ട് എങ്കിൽ അത് എടുത്ത് നീക്കലാണ്.<br /> <br /> അശുദ്ധി നീക്കുക എന്നാൽ വുദൂഅ് എടുക്കലും ജനാബത്തിൻ്റെ കുളി നിർവ്വഹിക്കലുമാണ്. വെള്ളം ഇല്ലാത്ത സന്ദർഭങ്ങളിലോ, വെള്ളം ഉപയോഗിക്കാൻ സാധ്യമല്ലാത്ത സമയങ്ങളിലോ തയമ്മും ചെയ്യലും അശുദ്ധി നീക്കുന്നതിൻ്റെ ഭാഗമാണ്. </p>',
            ],
            1 => [
                'question' => 'ചോദ്യം 2: നജസ് ബാധിച്ച വസ്തു എങ്ങനെയാണ് വൃത്തിയാക്കുക?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2630.mp3',
                'answer' => '<p> ഉത്തരം: നജസ് പോവുകയും, അങ്ങനെ വസ്തു ശുദ്ധിയാവുകയും ചെയ്യുന്നത് വരെ വെള്ളം കൊണ്ട് കഴുകുകയാണ് വേണ്ടത്.<br /> <br /> - എന്നാൽ നായ പാത്രത്തിൽ തലയിടുകയോ മറ്റോ ചെയ്താൽ അത് ഏഴു തവണ കഴുകണം; അതിലെ ആദ്യത്തെ തവണ മണ്ണു കലർത്തി കൊണ്ടാണ് കഴുകേണ്ടത്. </p>',
            ],
            2 => [
                'question' => 'ചോദ്യം 3: വുദൂഅ് എടുക്കുന്നതിൻ്റെ ശ്രേഷ്ഠത എന്താണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2660.mp3',
                'answer' => '<p> നബി -ﷺ-<span class="c6"> പറഞ്ഞു:</span> "മുസ്ലിമായ -അല്ലെങ്കിൽ മുഅ്മിനായ- ഒരു മനുഷ്യൻ വുദൂഅ് നിർവ്വഹിക്കുകയും, തൻ്റെ മുഖം കഴുകുകയും ചെയ്താൽ തൻ്റെ രണ്ട് കണ്ണുകൾ കൊണ്ട് അവൻ നോക്കിയ എല്ലാ തെറ്റുകളും ആ വെള്ളത്തിനോടൊപ്പം -അല്ലെങ്കിൽ അതിൻ്റെ അവസാന തുള്ളിയോടൊപ്പം- പുറത്തു പോകും. അവൻ തൻ്റെ രണ്ട് കൈകളും കഴുകിയാൽ അവൻ്റെ രണ്ട് കൈകൾ കൊണ്ടും അവൻ പിടിച്ച എല്ലാ തെറ്റുകളും അവൻ്റെ രണ്ട് കൈകളിൽ നിന്നും വെള്ളത്തോടൊപ്പം -അല്ലെങ്കിൽ അതിൻ്റെ അവസാന തുള്ളിയോടൊപ്പം- ഒലിച്ചു പോകും. അവൻ തൻ്റെ രണ്ട് കാലുകളും കഴുകിയാൽ ആ കാലുകൾ കൊണ്ട് അവൻ നടന്നെത്തിയ തിന്മകളെല്ലാം ആ വെള്ളത്തോടൊപ്പം -അല്ലെങ്കിൽ അവസാനത്തെ തുള്ളിയോടൊപ്പം- പുറത്തു പോകും. അങ്ങനെ തിന്മകളിൽ നിന്നെല്ലാം ശുദ്ധനായി കൊണ്ട് അവൻ പുറത്തുവരും." <span class="c2">(മുസ്ലിം)</span> </p>',
            ],
            3 => [
                'question' => 'ചോദ്യം 4: എങ്ങനെയാണ് വുദൂഅ് ചെയ്യേണ്ടത്.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2690.mp3',
                'answer' => '<p> ഉത്തരം: ആദ്യം രണ്ട് കൈപ്പത്തികളും മൂന്നു തവണ കഴുകുക.<br /> <br /> പിന്നീട് വായിൽ വെള്ളം കൊപ്ലിക്കുകയും മൂക്കിൽ വെള്ളം കയറ്റുകയും അത് പുറത്തേക്ക് ചീറ്റിക്കളയുകയും ചെയ്യുക; ഇത് മൂന്നു തവണ ചെയ്യണം.<br /> <br /> വായിൽ വെള്ളം ആക്കിയ ശേഷം അത് കുലുക്കുകയും തുപ്പിക്കളയുകയും ചെയ്താൽ വായ കൊപ്ലിക്കലായി.<br /> <br /> മൂക്കിൻ്റെ ഉള്ളിലേക്ക് വെള്ളം വലതു കൈ കൊണ്ട് ആക്കുകയും, വലിച്ചെടുക്കുകയും ചെയ്താൽ വെള്ളം മൂക്കിലേക്ക് കയറ്റലായി.<br /> <br /> മൂക്കിൽ നിന്ന് വെള്ളം ഇടതു കൈ കൊണ്ട് പുറത്തേക്ക് ചീറ്റിക്കളഞ്ഞാൽ മൂക്ക് ചീറ്റലാവുകയും ചെയ്തു.<br /> <br /> ശേഷം മുഖം മൂന്ന് തവണ കഴുകണം.<br /> <br /> പിന്നീട് കൈകൾ മുട്ടുകൾ സഹിതം മൂന്ന് തവണ കഴുകണം.<br /> <br /> പിന്നീട് തല തടവണം; രണ്ട് കൈകൾ കൊണ്ടും തലയുടെ പിറകിലേക്കും മുന്നിലേക്കും കൈകൾ കൊണ്ട് തടവുകയും, ശേഷം രണ്ട് ചെവികളും തടവുകയും ചെയ്യണം.<br /> <br /> ശേഷം രണ്ട് കാലുകളും നെരിയാണി ഉൾപ്പടെ -മൂന്നു തവണ- കഴുകണം.<br /> <br /> ഇതാണ് വുദൂഇൻ്റെ പൂർണ്ണമായ രൂപം. നബി -ﷺ- ഇപ്രകാരം വുദൂഅ് എടുത്തതായി ഉഥ്മാനു ബ്നു അഫ്ഫാൻ -رَضِيَ اللَّهُ عَنْهُ-, അബ്ദുല്ലാഹി ബ്നു സയ്ദ് -رَضِيَ اللَّهُ عَنْهُ- തുടങ്ങിയ സ്വഹാബികൾ അറിയിച്ചിട്ടുണ്ട്. <span class="c2">(ബുഖാരി, മുസ്ലിം)</span> നബി -ﷺ- വുദൂഇൻ്റെ അവയവങ്ങൾ മൂന്നു തവണ കഴുകുന്നതിന് പകരം ഒരു തവണയായി കഴുകിയതും, രണ്ട് തവണകളായി കഴുകിയതും ഹദീഥുകളിൽ സ്ഥിരപ്പെട്ടിട്ടുണ്ട്. <span class="c2">(ബുഖാരി)</span> </p>',
            ],
            4 => [
                'question' => 'ചോദ്യം 5: എന്താണ് വുദൂഇൻ്റെ ഫർദ്വുകൾ? അവ എത്രയെണ്ണമുണ്ട്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2810.mp3',
                'answer' => '<p> ഉത്തരം: വുദൂഇൽ ഒരിക്കലും ഉപേക്ഷിക്കാൻ പാടില്ലാത്ത നിർബന്ധ കർമ്മങ്ങളാണ് വുദൂഇൻ്റെ ഫർദ്വുകൾ. <span class="c2">(അവ ആറെണ്ണമുണ്ട്.)</span><br /> <br /> 1- മുഖം കഴുകൽ; വായ കൊപ്ലിക്കലും മൂക്കിൽ വെള്ളം കയറ്റലും അതിൽ പെട്ടതാണ്.<br /> <br /> 2- കൈകൾ മുട്ടുകൾ സഹിതം കഴുകൽ.<br /> <br /> 3- തല തടവൽ; ചെവി തടവുക എന്നതും അതിൻ്റെ ഭാഗമാണ്.<br /> <br /> 4- കാലുകൾ നെരിയാണി ഉൾപ്പെടെ കഴുകൽ.<br /> <br /> 5- ഈ അവയവങ്ങൾ ക്രമത്തിൽ കഴുകണം. ആദ്യം മുഖം കഴുകൽ, ശേഷം കൈകൾ, ശേഷം തല തടവൽ, പിന്നീട് കാലുകൾ കഴുകൽ.<br /> <br /> 6- തുടർച്ചയുണ്ടാവുക. അതായത് വുദൂഇൻ്റെ കർമ്മങ്ങൾ തുടരെത്തുടരെ നിർവ്വഹിക്കണം. ഒരു അവയവം കഴുകിയ ശേഷം അത് ഉണങ്ങുവോളം അടുത്ത അവയവം കഴുകുന്നത് വൈകിപ്പിക്കാൻ പാടില്ല.<br /> <br /> ഉദാഹരണത്തിന് വുദൂഇൻ്റെ പകുതി ചെയ്ത ശേഷം കുറച്ചു സമയം കഴിഞ്ഞ് അത് പൂർത്തീകരിക്കുക എന്നത് പാടില്ല. ഇങ്ങനെ ചെയ്താൽ വുദൂഅ് ശരിയാവില്ല. </p>',
            ],
            5 => [
                'question' => 'ചോദ്യം 5: എന്താണ് വുദൂഇൻ്റെ സുന്നത്തുകൾ? അവ എത്രയെണ്ണമുണ്ട്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2910.mp3',
                'answer' => '<p> ഉത്തരം: വുദൂഇൻ്റെ സന്ദർഭത്തിൽ പ്രവർത്തിച്ചാൽ കൂടുതൽ പ്രതിഫലം ലഭിക്കുന്നതിന് കാരണമാകുന്ന, എന്നാൽ ഉപേക്ഷിച്ചാൽ ശിക്ഷ ലഭിക്കാത്ത കാര്യങ്ങളാണ് സുന്നത്തുകൾ. സുന്നത്ത് ഉപേക്ഷിച്ചതു കൊണ്ട് വുദൂഅ് ശരിയാകാതിരിക്കില്ല.<br /> <br /> 1- ബിസ്മി ചൊല്ലൽ.<br /> <br /> 2- പല്ലു തേക്കൽ.<br /> <br /> 3- രണ്ട് കൈപ്പത്തികളും കഴുകൽ.<br /> <br /> 4- വിരലുകൾ കോർത്തു കഴുകൽ.<br /> <br /> 5- രണ്ടു തവണയോ മൂന്നു തവണയോ അവയവങ്ങൾ കഴുകൽ.<br /> <br /> 6- ആദ്യം വലതു ഭാഗം കഴുകൽ.<br /> <br /> 7- വുദൂഇന് ശേഷമുള്ള ദിക്ർ <span class="c2">(താഴെ കൊടുത്തത് പോലെ)</span> ചൊല്ലൽ. "<span class="c2">(സാരം)</span> അല്ലാഹുവല്ലാതെ ആരാധനക്ക് അർഹനായി മറ്റാരുമില്ലെന്ന് ഞാൻ സാക്ഷ്യം വഹിക്കുന്നു. അവൻ മാത്രമാണ് ആരാധനക്കർഹൻ. അവന് യാതൊരു പങ്കുകാരനുമില്ല. മുഹമ്മദ് നബി<span class="c2">(ﷺ)</span> അല്ലാഹുവിൻ്റെ അടിമയും അവൻ്റെ ദൂതനുമാണെന്നും ഞാൻ സാക്ഷ്യം വഹിക്കുന്നു."<br /> 8- വുദൂഇന് ശേഷം രണ്ട് റക്അത്ത് നിസ്കരിക്കൽ. </p>',
            ],
            6 => [
                'question' => 'ചോദ്യം 7: വുദൂഅ് മുറിക്കുന്ന കാര്യങ്ങൾ എണ്ണിപ്പറയുക?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3020.mp3',
                'answer' => '<p> ഉത്തരം: <span class="c2">(1)</span> രണ്ട് ഗുഹ്യസ്ഥാനങ്ങളിലൂടെയും എന്തെങ്കിലും പുറത്തു വരുന്നത്. മൂത്രം, മലം, കീഴ്ശ്വാസം എന്നിവ പോലെ.<br /> <br /> <span class="c2">(2)</span> ഉറങ്ങുകയോ, ഭ്രാന്ത് ബാധിക്കുകയോ ബോധം നഷ്ടപ്പെടുകയോ ചെയ്യൽ.<br /> <br /> <span class="c2">(3)</span> ഒട്ടകത്തിൻ്റെ മാംസം കഴിക്കൽ.<br /> <br /> <span class="c2">(4)</span> കൈയ്യിൻ്റെ ഉൾഭാഗം കൊണ്ട് -മറയില്ലാതെ- ഗുഹ്യസ്ഥാനത്ത് സ്പർശിക്കൽ. </p>',
            ],
            7 => [
                'question' => 'ചോദ്യം 8: എന്താണ് തയമ്മും?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3080.mp3',
                'answer' => '<p> ഉത്തരം: വെള്ളം ലഭ്യമല്ലാത്ത സന്ദർഭത്തിലോ, വെള്ളം ഉപയോഗിക്കാൻ സാധിക്കാത്ത സാഹചര്യത്തിലോ ഭൂപ്രതലത്തിൽ ഉൾപ്പെടുന്ന മണ്ണോ മറ്റോ ഉപയോഗിച്ചു കൊണ്ട് ശുദ്ധീകരിക്കുന്നതിനാണ് തയമ്മും എന്ന് പറയുക. </p>',
            ],
            8 => [
                'question' => 'ചോദ്യം 9: എങ്ങനെയാണ് തയമ്മും ചെയ്യേണ്ടത്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3110.mp3',
                'answer' => '<p> ഉത്തരം: കൈയ്യിൻ്റെ ഉൾഭാഗം കൊണ്ട് ഒരു തവണ മണ്ണിൽ അടിക്കുകയും, ശേഷം മുഖവും കൈപ്പത്തിയുടെ പുറംഭാഗവും ഒരു തവണ തടവുകയും ചെയ്യുക. </p>',
            ],
            9 => [
                'question' => 'ചോദ്യം 10: തയമ്മും അസാധുവാക്കുന്ന കാര്യങ്ങൾ എന്തെല്ലാമാണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3140.mp3',
                'answer' => '<p> ഉത്തരം: വുദൂഅ് മുറിക്കുന്ന കാര്യങ്ങൾ കൊണ്ടെല്ലാം തയമ്മും എന്നതും നഷ്ടമാകുന്നതാണ്.<br /> <br /> അതോടൊപ്പം വെള്ളം ലഭിച്ചാലും തയമ്മും അസാധുവാകും. </p>',
            ],
            10 => [
                'question' => 'ചോദ്യം 11: എന്താണ് ഖുഫ്ഫകളും ഷോക്സുകളും? വുദൂഇൻ്റെ സന്ദർഭത്തിൽ അവയുടെ മേൽ തടവാൻ അനുവാദമുണ്ടോ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3180.mp3',
                'answer' => '<p> ഉത്തരം: തോലു കൊണ്ടും മറ്റും നിർമ്മിക്കുന്ന കാൽ മുഴുവനായി മൂടുന്ന ഉറയാണ് ഖുഫ്ഫ എന്നു പറഞ്ഞാൽ.<br /> <br /> തോലു കൊണ്ടല്ലാത്ത എല്ലാ കാലുറകൾക്കും ഷോക്സ് / ഷൂ എന്നൊക്കെ പറയാം.<br /> <br /> കാലുകൾ കഴുകുന്നതിന് പകരം ഇവയുടെ മുകളിൽ തടവുക എന്നത് അനുവദനീയമാണ്. </p>',
            ],
            11 => [
                'question' => 'ചോദ്യം 12: എന്തിനാണ് ഖുഫ്ഫകളുടെ മേൽ തടവുക എന്ന നിയമം നിശ്ചയിക്കപ്പെട്ടത്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3230.mp3',
                'answer' => '<p> ഉത്തരം: അല്ലാഹു അവൻ്റെ അടിമകൾക്ക് ദീൻ എളുപ്പമാക്കുകയും, അതിൽ ഇളവുകൾ നൽകുകയും ചെയ്തിരിക്കുന്നു. തണുപ്പും ശൈത്യവും നേരിടുന്ന സന്ദർഭങ്ങളിലും, യാത്രാ വേളകളിലും ഖുഫ്ഫയുടെ മേൽ തടവുക എന്ന ഈ നിയമം വളരെ ഉപകാരപ്രദമാണ്. കാരണം, കാലിൽ നിന്ന് അവ ഓരോ പ്രാവശ്യവും ഊരിമാറ്റുക എന്നത് പ്രയാസകരമാണ്. </p>',
            ],
            12 => [
                'question' => 'ചോദ്യം 13: ഖുഫ്ഫകളുടെ മേൽ തടവുന്നത് ശരിയാകണമെങ്കിൽ പാലിക്കേണ്ട നിബന്ധനകൾ ഏതെല്ലാമാണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3260.mp3',
                'answer' => '<p> ഉത്തരം: 1- ശുദ്ധിയോടു കൂടിയായിരിക്കണം ഖുഫ്ഫകൾ ധരിച്ചത്; അതായത് പൂർണ്ണമായും വുദൂഅ് എടുത്ത ശേഷമായിരിക്കണം.<br /> <br /> 2- ഖുഫ്ഫ ശുദ്ധിയുള്ളതായിരിക്കണം. നജസായ ഖുഫ്ഫയുടെ മേൽ തടവുന്നത് അനുവദനീയമല്ല.<br /> <br /> 3- വുദൂഇൻ്റെ സന്ദർഭത്തിൽ നിർബന്ധമായും കഴുകേണ്ട കാലിൻ്റെ ഭാഗം പൂർണ്ണമായും മറക്കുന്ന തരത്തിലുള്ളതായിരിക്കണം ഖുഫ്ഫകൾ; <span class="c2">(ചെരിപ്പുകൾ പോലുള്ളവ പറ്റില്ല)</span>.<br /> <br /> 4- നിശ്ചയിക്കപ്പെട്ട സമയപരിധിക്ക് ഉള്ളിൽ മാത്രമേ ഖുഫ്ഫ തടവാൻ പാടുള്ളൂ. നാട്ടിൽ താമസിക്കുന്നവർക്ക് ഒരു പകലും രാത്രിയും, യാത്രക്കാർക്ക് മൂന്നു പകലും മൂന്നു രാത്രികളുമെന്നാണ് കണക്ക്. </p>',
            ],
            13 => [
                'question' => 'ചോദ്യം 14: ഖുഫ്ഫകളുടെ മേൽ തടവുന്നതിൻ്റെ രൂപം എന്താണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3320.mp3',
                'answer' => '<p> ഉത്തരം: കൈവിരലുകൾ വെള്ളം കൊണ്ട് നനച്ച ശേഷം, കാലിൻ്റെ വിരലുകളുടെ ഭാഗത്ത് അവ വെക്കുകയും, ശേഷം നെരിയാണി വരെ തടവുകയും ചെയ്യുക. വലതു കൈ കൊണ്ട് വലതു കാലും, ഇടതു കൈ കൊണ്ട് ഇടതു കാലും തടവണം. തടവുമ്പോൾ വിരലുകൾ വിട്ടുപിടിക്കുക; ഒരു തവണ തടവിയാൽ മതി <span class="c2">(ആവർത്തിക്കേണ്ടതില്ല)</span>. </p>',
            ],
            14 => [
                'question' => 'ചോദ്യം 14: ഖുഫ്ഫകളുടെ മേൽ തടവുന്നത് എപ്പോഴാണ് അസാധുവാകുക?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3350.mp3',
                'answer' => '<p> ഉത്തരം: 1- ഖുഫ്ഫയുടെ മേൽ തടവാനുള്ള സമയപരിധി കഴിഞ്ഞാൽ പിന്നീട് ഖുഫ്ഫയുടെ മേൽ തടവാൻ അനുവാദമില്ല. നാട്ടിൽ താമസിക്കുന്നവന് ഒരു പകലും രാത്രിയും, യാത്രക്കാർക്ക് മൂന്നു പകലും മൂന്നു രാത്രികളുമാണ് സമയപരിധി.<br /> <br /> 2- ഖുഫ്ഫകൾ ഊരിവെക്കുന്നത്; ഒരാൾ ഖുഫ്ഫകളിൽ തടവിയശേഷം തൻ്റെ ഖുഫ്ഫകളിൽ ഏതെങ്കിലുമൊന്നോ അവ രണ്ടുമോ ഊരിവെച്ചാൽ അതോടെ അതിന് മുകളിൽ തടവിയത് അസാധുവാകും. </p>',
            ],
            15 => [
                'question' => 'ചോദ്യം 16: എന്താണ് നിസ്കാരം?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3390.mp3',
                'answer' => '<p> ഉത്തരം: നിശ്ചിത വാക്കുകൾ പറഞ്ഞു കൊണ്ടും, പ്രവർത്തികൾ ചെയ്തു കൊണ്ടും അല്ലാഹുവിനെ ആരാധിക്കലാണ് നിസ്കാരം. അതിൻ്റെ ആരംഭം തക്ബീർ കൊണ്ടും, അവസാനം സലാം വീട്ടൽ കൊണ്ടുമാണ്. </p>',
            ],
            16 => [
                'question' => 'ചോദ്യം 17: എന്താണ് നിസ്കാരത്തിൻ്റെ വിധി?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3420.mp3',
                'answer' => '<p> ഉത്തരം: നിസ്കാരം എല്ലാ മുസ്ലിമിൻ്റെ മേലും നിർബന്ധമാണ്.<span class="c6"><br /> <br /> അല്ലാഹു പറയുന്നു:</span> "തീർച്ചയായും നിസ്കാരം വിശ്വാസികളുടെ മേൽ സമയബന്ധിതമായ നിർബന്ധകർമ്മമാണ്." <span class="c2">(നിസാഅ്: 103)</span> </p>',
            ],
            17 => [
                'question' => 'ചോദ്യം 18: നിസ്കാരം ഉപേക്ഷിക്കുന്നതിൻ്റെ വിധി എന്താണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3460.mp3',
                'answer' => '<p> ഉത്തരം: നിസ്കാരം ഉപേക്ഷിക്കൽ കുഫ്റാണ്. നബി -ﷺ-<span class="c6"> പറഞ്ഞു:</span><br /> <br /> "നമുക്കും അവർക്കും <span class="c2">(മുസ്ലിംകൾക്കും അല്ലാത്തവർക്കും)</span> ഇടയിലുള്ള രേഖ നിസ്കാരമാണ്. ആരെങ്കിലും അത് ഉപേക്ഷിച്ചാൽ അവൻ കാഫിറായി."<br /> <br /> <span class="c2">(അഹ്മദ്, തിർമിദി തുടങ്ങിയവർ)</span> </p>',
            ],
            18 => [
                'question' => 'ചോദ്യം 19: പകലും രാത്രിയുമായി എത്ര തവണ ഒരു മുസ്ലിം നിർബന്ധമായും നിസ്കരിക്കണം? ഓരോ നിസ്കാരത്തിലുമുള്ള റക്അത്തുകളുടെ എണ്ണം എത്രയാണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3500.mp3',
                'answer' => '<p> ഉത്തരം: പകലിലും രാത്രിയിലുമായി അഞ്ചു നേരത്തെ നിസ്കാരം നിർബന്ധമാണ്. ഫജ്ർ നിസ്കാരം = രണ്ട് റക്അത്തുകൾ, ദ്വുഹ്ർ = നാല് റക്അത്തുകൾ, അസ്വർ = നാല് റക്അത്തുകൾ, മഗ്രിബ് = മൂന്ന് റക്അത്തുകൾ, ഇശാഅ് = നാല് റക്അത്തുകൾ. </p>',
            ],
            19 => [
                'question' => 'ചോദ്യം 20: നിസ്കാരത്തിൻ്റെ നിബന്ധനകൾ എണ്ണിപ്പറയുക?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3530.mp3',
                'answer' => '<p> ഉത്തരം: 1- മുസ്ലിമാവുക; കാഫിറിൻ്റെ നിസ്കാരവും <span class="c2">(മറ്റു ആരാധനകളും)</span> സ്വീകരിക്കപ്പെടുകയില്ല.<br /> <br /> 2- ബുദ്ധിയുണ്ടാവുക; ഭ്രാന്തൻ്റെ കർമ്മങ്ങൾ സ്വീകരിക്കപ്പെടുകയില്ല.<br /> <br /> 3- വകതിരിവുണ്ടായിരിക്കുക; കാര്യങ്ങൾ വേർതിരിച്ചറിയാൻ കഴിയാത്ത ചെറിയ കുട്ടികളുടെ നിസ്കാരം ശരിയാവുകയില്ല.<br /> <br /> 4- നിയ്യത്ത് <span class="c2">(ഉദ്ദേശ്യം)</span>.<br /> <br /> 5- നിസ്കാര സമയം ആവുക.<br /> <br /> 6- അശുദ്ധി നീക്കം ചെയ്യുക <span class="c2">(വുദു / തയമ്മും)</span><br /> <br /> 7- നജസുകളിൽ നിന്ന് വൃത്തിയാവുക.<br /> <br /> 8- ഔറത്തുകൾ മറക്കുക.<br /> <br /> 9. ഖിബ്\'ലക്ക് നേരെ തിരിയുക. </p>',
            ],
            20 => [
                'question' => 'ചോദ്യം 21: നിസ്കാരത്തിൻ്റെ റുക്നുകൾ (അവിഭാജ്യ ഘടകങ്ങൾ) എണ്ണിപ്പറയുക?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3640.mp3',
                'answer' => '<p> ഉത്തരം: നിസ്കാരത്തിന് പതിനാല് റുക്നുകളുണ്ട്.<span class="c6"> അവ താഴെ പറയാം:</span><br /> <br /> 1- ഫർദ്വ് നിസ്കാരങ്ങളിൽ നിൽക്കാൻ സാധിക്കുന്നവൻ നിന്നു കൊണ്ട് നിസ്കരിക്കണം.<br /> <br /> 2- തക്ബീറതുൽ ഇഹ്റാം അഥവാ തുടക്കത്തിൽ \'അല്ലാഹു അക്ബർ\' എന്നു പറയുക.<br /> <br /> 3- സൂറതുൽ ഫാതിഹഃ പാരായണം ചെയ്യണം.<br /> <br /> 4- റുകൂഅ് ചെയ്യണം. മുതുക് നേരെയാക്കുകയും, ശിരസ്സ് അതിന് സമാനമായി വെക്കുകയും വേണം.<br /> <br /> 5- റുകൂഇൽ നിന്ന് ഉയരണം.<br /> <br /> 6- ഇഅ്തിദാലിൽ നിൽക്കണം.<br /> <br /> 7- സുജൂദ് ചെയ്യണം. നെറ്റി, മൂക്ക്, രണ്ട് കൈപ്പത്തികൾ, കാൽമുട്ടുകൾ, കാൽവിരലുകൾ എന്നിവ സുജൂദിൻ്റെ സ്ഥാനത്ത് ചേർത്തു വെക്കണം.<br /> <br /> 8- സുജൂദിൽ നിന്ന് ഉയരണം.<br /> <br /> 9- രണ്ട് സുജൂദുകൾക്ക് ഇടയിൽ ഇരിക്കണം.<br /> <br /> വലതു കാൽ കുത്തിവെച്ച നിലയിൽ ഖിബ്\'ലയുടെ ദിശയിലേക്ക് വെച്ചു കൊണ്ട് ഇടതു കാൽ പരത്തി വെച്ചു കൊണ്ട് അതിന്മേൽ ഇഫ്തിറാശിൻ്റെ ഇരുത്തം ഇരിക്കുക. ഈ രീതി സ്വീകരിക്കുന്നതാണ് സുന്നത്ത്.<br /> <br /> 10- നിസ്കാരത്തിൽ മുഴുവനായും അടക്കം പാലിക്കണം. ഓരോ റുക്നിലും അല്പസമയമെങ്കിലും അടങ്ങി നിൽക്കണം.<br /> <br /> 11- അവസാനത്തെ തശഹ്ഹുദ് നിർവ്വഹിക്കണം.<br /> <br /> 12- അതിന് വേണ്ടി ഇരിക്കണം.<br /> <br /> 13- രണ്ട് സലാമുകൾ. ഇതിനായി \'അസ്സലാമു അലൈകും വ റഹ്മതുല്ലാഹ്\' എന്ന് രണ്ട് തവണ പറയണം.<br /> <br /> 14- ഈ പറഞ്ഞ റുക്നുകളെല്ലാം ഇതേ ക്രമത്തിൽ നിർവ്വഹിക്കണം. ഉദാഹരണത്തിന്, ഒരാൾ സുജൂദിന് മുൻപ് റുകൂഅ് ചെയ്താൽ അവൻ്റെ നിസ്കാരം അസാധുവാകും. മറന്നു കൊണ്ട് അങ്ങനെ ചെയ്താൽ നിർബന്ധമായും അവൻ റുകൂഇലേക്ക് തിരിച്ചു വരികയും, അത് നിർവ്വഹിച്ച ശേഷം സുജൂദ് ചെയ്യുകയും വേണം. </p>',
            ],
            21 => [
                'question' => 'ചോദ്യം 22- നിസ്കാരത്തിലെ വാജിബാതുകൾ (നിർബന്ധ കർമ്മങ്ങൾ) എണ്ണിപ്പറയുക.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3820.mp3',
                'answer' => '<p> ഉത്തരം: നിസ്കാരത്തിലെ വാജിബുകൾ എട്ടു കാര്യങ്ങളാണ്.<span class="c6"> അവ താഴെ പറയാം:</span><br /> <br /> 1- തക്ബീറതുൽ ഇഹ്റാം ഒഴികെയുള്ള തക്ബീറുകൾ.<br /> <br /> 2- \'സമി അല്ലാഹു ലിമൻ ഹമിദഹ്\' എന്നു പറയൽ; ഇമാമിനും ഒറ്റക്ക് നിസ്കരിക്കുന്ന വ്യക്തിക്കും.<br /> <br /> 3- \'റബ്ബനാ വലകൽ ഹംദ്\' എന്ന് പറയൽ.<br /> <br /> 4- \'സുബ്ഹാന റബ്ബിയൽ അദ്വീം\' എന്ന് ഒരു തവണ റുകൂഇൽ പറയൽ.<br /> <br /> 5- \'സുബ്ഹാന റബ്ബിയൽ അഅ്ലാ\' എന്ന് ഒരു തവണ സുജൂദിൽ പറയൽ.<br /> <br /> 6- സുജൂദുകൾക്ക് ഇടയിൽ \'റബ്ബിഗ്ഫിർ ലീ\' എന്ന് പറയൽ.<br /> <br /> 7- ഒന്നാമത്തെ തശഹ്ഹുദ്.<br /> <br /> 8- ഒന്നാമത്തെ തശഹ്ഹുദിന് വേണ്ടി ഇരിക്കൽ. </p>',
            ],
            22 => [
                'question' => 'ചോദ്യം 23: നിസ്കാരത്തിലെ സുന്നത്തുകൾ ഏതെല്ലാമാണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3930.mp3',
                'answer' => '<p> ഉത്തരം: നിസ്കാരത്തിൽ പതിനൊന്ന് സുന്നത്തുകളുണ്ട്.<span class="c6"> അവ താഴെ പറയാം:</span><br /> <br /> 1- തക്ബീറതുൽ ഇഹ്റാമിന് ശേഷം പ്രാരംഭപ്രാർത്ഥന ചൊല്ലൽ. <span class="c2">(സ്ഥിരപ്പെട്ട പ്രാർത്ഥനകളിൽ ഒന്ന് ഇപ്രകാരമാണ്)</span> (അർത്ഥം: അല്ലാഹുവേ! നിൻ്റെ പരിശുദ്ധി വാഴ്ത്തുന്നതിനൊപ്പം ഞാൻ നിന്നെ സ്തുതിക്കുന്നു. നിൻ്റെ നാമം അനുഗ്രഹപൂർണ്ണമായിരിക്കുന്നു. നിൻ്റെ മഹത്വം ഉന്നതമാവുകയും ചെയ്തിരിക്കുന്നു. നീയല്ലാതെ ആരാധനക്ക് അർഹനായി മറ്റാരുമില്ല."<br /> <br /> 2- അഊദു ചൊല്ലൽ.<br /> <br /> 3- ബിസ്മി ചൊല്ലൽ.<br /> <br /> 4- ആമീൻ എന്ന് പറയൽ.<br /> <br /> 5- ഫാതിഹഃക്ക് ശേഷം ഒരു സൂറത്ത് പാരായണം ചെയ്യൽ.<br /> <br /> 6- ഇമാം നിസ്കാരത്തിൽ ഉറക്കെ പാരായണം ചെയ്യൽ.<br /> <br /> 7- \'റബ്ബനാ വലകൽ ഹംദ്\' എന്ന വാക്കിന് ശേഷം \'മിൽഅസ്സമാവാതി\' എന്നു തുടങ്ങുന്ന പ്രാർത്ഥന പറയൽ.<br /> <br /> 8- റുകൂഇൽ ഒന്നിൽ കൂടുതൽ തവണ -രണ്ടോ മൂന്നോ അതിൽ കൂടുതലോ തവണകൾ- തസ്ബീഹ് പറയുക എന്നത്.<br /> <br /> 9- സുജൂദിലെ തസ്ബീഹ് ഒന്നിലധികം തവണ പറയൽ.<br /> <br /> 10- രണ്ട് സുജൂദുകൾക്ക് ഇടയിൽ പറയുന്നത് ഒന്നിലധികം തവണ ആവർത്തിക്കൽ.<br /> <br /> 11- അവസാനത്തെ തശഹ്ഹുദിൽ നബി -ﷺ- യുടെ മേലും അവിടുത്തെ കുടുംബത്തിന് മേലും സ്വലാത്തും സലാമും ബറകതും ചൊല്ലുകയും, അതിന് ശേഷം പ്രാർത്ഥനകൾ ചൊല്ലുകയും ചെയ്യുക.<span class="c6"><br /> <br /> നാല്:</span> നിസ്കാരത്തിലെ പ്രവർത്തികളിലുള്ള സുന്നത്തുകൾ താഴെ പറയാം:<br /> <br /> 1- തക്ബീറതുൽ ഇഹ്റാം ചൊല്ലുന്നതിനൊപ്പം രണ്ട് കൈകളും ഉയർത്തൽ.<br /> <br /> 2- റുകൂഇൻ്റെ സന്ദർഭത്തിൽ കൈകൾ ഉയർത്തൽ.<br /> <br /> 3- റുകൂഇൽ നിന്ന് ഉയരുമ്പോൾ കൈകൾ ഉയർത്തൽ.<br /> <br /> 4- ഈ പറഞ്ഞതിന് ശേഷം കൈകൾ താഴ്ത്തിയിടൽ.<br /> <br /> 5- വലതു കൈ ഇടതു കയ്യിൻ്റെ മുകളിലായി വെക്കൽ.<br /> <br /> 6- സുജൂദിൻ്റെ സ്ഥാനത്തേക്ക് നോക്കൽ.<br /> <br /> 7- നിൽക്കുമ്പോൾ രണ്ട് കാലുകളും വിട്ടു വെക്കൽ.<br /> <br /> 8- റുകൂഇൽ കാൽമുട്ടുകളിൽ പിടിക്കുകയും, പ്രസ്തുത വേളയിൽ കൈവിരലുകൾ പരത്തി വെക്കുകയും, റുകൂഇൽ മുതുക് പരത്തി വെക്കുകയും, തല അതിന് നേരെയാകുന്ന വിധം പിടിക്കുകയും ചെയ്യൽ.<br /> <br /> 9- സുജൂദിൻ്റെ അവയവങ്ങൾ ഭൂമിയിൽ ചേർത്തു വെക്കൽ. സുജൂദിൻ്റെ സ്ഥാനത്തോട് ഈ അവയവങ്ങൾ സ്പർശിച്ചിരിക്കണം.<br /> <br /> 10- സുജൂദിൻ്റെ സന്ദർഭത്തിൽ രണ്ട് പാർശ്വങ്ങളിൽ നിന്നും കൈകൾ അകറ്റിയ നിലയിൽ വെക്കുക. ഇതു പോലെ, വയറിൽ നിന്ന് കാലിൻ്റെ തുടകളും, കാലിൻ്റെ തുടകളിൽ നിന്ന് കണങ്കാലുകളും, രണ്ട് കാൽ മുട്ടുകൾ തമ്മിലും അകറ്റി വെക്കുക. സുജൂദിൽ കാൽപ്പത്തികൾ കുത്തിനിർത്തുകയും, അതിലെ വിരലുകൾ ഭൂമിയിൽ പതിയുന്ന തരത്തിൽ വിടർത്തി വെക്കുകയും വേണം. രണ്ട് കൈപ്പത്തികളും തോളിന് നേരെയാകും വിധം പരത്തി വെക്കുകയും, വിരലുകൾ കൂട്ടിപ്പിടിക്കുകയും വേണം.<br /> <br /> 11- രണ്ട് സുജൂദുകൾക്ക് ഇടയിലും ഒന്നാമത്തെ തശഹ്ഹുദിലും ഇഫ്തിറാശിൻ്റെ ഇരുത്തം സ്വീകരിക്കുക. രണ്ടാമത്തെ തശഹ്ഹുദിൽ തവർറുകിൻ്റെ ഇരുത്തവും സ്വീകരിക്കുക.<br /> <br /> 12- രണ്ട് കൈകളും കാലിൻ്റെ തുടകൾക്ക് മേൽ വെക്കുകയും, കൈവിരലുകൾ ചേർത്തു പിടിച്ച നിലയിൽ തുടക്ക് മേൽ പരത്തി വെക്കുകയും ചെയ്യുക. തശഹ്ഹുദിലും ഇതു പോലെത്തന്നെ; എന്നാൽ വലതു കൈയ്യിൻ്റെ ചെറുവിരലും മോതിരവിരലും മടക്കി വെക്കുകയും, നടുവിരലും തള്ളവിരലും കൊണ്ട് ഒരു വട്ടമുണ്ടാക്കുകയും, ചൂണ്ടുവിരൽ കൊണ്ട് ദിക്റിൻ്റെ സന്ദർഭത്തിൽ ചൂണ്ടുകയും ചെയ്യുക.<br /> <br /> 13- സലാം വീട്ടുമ്പോൾ വലത്തോട്ടും ഇടത്തോട്ടും മുഖം തിരിക്കുക. </p>',
            ],
            23 => [
                'question' => 'ചോദ്യം 24: നിസ്കാരം അസാധുവാക്കുന്ന കാര്യങ്ങൾ ഏതെല്ലാമാണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4210.mp3',
                'answer' => '<p> ഉത്തരം: <span class="c2">(1)</span> നിസ്കാരത്തിലെ ഏതെങ്കിലും റുക്നോ ശർത്വോ ഉപേക്ഷിക്കുക.<br /> <br /> <span class="c2">(2)</span> നിസ്കാരത്തിൽ ബോധപൂർവ്വം സംസാരിക്കുക.<br /> <br /> <span class="c2">(3)</span> ഭക്ഷണ-പാനീയങ്ങൾ കഴിക്കുക.<br /> <br /> <span class="c2">(4)</span> തുടർച്ചയായി ധാരാളം ചലിക്കുക.<br /> <br /> <span class="c2">(5)</span> നിസ്കാരത്തിലെ ഏതെങ്കിലുമൊരു വാജിബ് ബോധപൂർവ്വം ഉപേക്ഷിക്കുക. </p>',
            ],
            24 => [
                'question' => 'ചോദ്യം 25: എങ്ങനെയാണ് ഒരു മുസ്ലിം നിസ്കരിക്കേണ്ടത്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4280.mp3',
                'answer' => '<p> ഉത്തരം: നിസ്കാരത്തിൻ്റെ രൂപം ഇപ്രകാരമാണ്:<br /> <br /> 1- ശരീരം മുഴുവൻ ഖിബ്\'ലക്ക് നേരെ തിരിച്ചു വെക്കുക. ഖിബ്\'ലയിൽ നിന്ന് ചെരിയുകയോ ദിശ മാറുകയോ ചെയ്യരുത്.<br /> <br /> 2- ശേഷം അവൻ നിസ്കരിക്കാൻ പോകുന്നത് എന്താണോ, അത് നിയ്യത്ത് കരുതുക. നിയ്യത്ത് ഹൃദയത്തിലാണ്; നാവ് കൊണ്ട് അത് ഉച്ചരിക്കേണ്ട കാര്യമില്ല.<br /> <br /> 3- ശേഷം \'അല്ലാഹു അക്ബർ\' എന്ന് പറഞ്ഞു കൊണ്ട് തക്ബീറതുൽ ഇഹ്റാം കെട്ടുക. രണ്ട് കൈകളും ഈ സന്ദർഭത്തിൽ തോളു വരെ ഉയർത്തുക.<br /> <br /> 4- ശേഷം തൻ്റെ വലതു കൈപ്പത്തി ഇടത് കൈപ്പത്തിയുടെ പുറംഭാഗത്തായി -നെഞ്ചിന് മുകളിൽ- വെക്കുക.<br /> <br /> 5-<span class="c6"> ശേഷം പ്രാരംഭപ്രാർത്ഥന ചൊല്ലുക:</span> <span class="c2">(സാരം:)</span> "അല്ലാഹുവേ! കിഴക്കിനും പടിഞ്ഞാറിനും ഇടയിൽ നീ അകൽച്ച വരുത്തിയതു പോലെ, എനിക്കും എൻ്റെ തെറ്റുകൾക്കും ഇടയിൽ നീ അകൽച്ചയുണ്ടാക്കേണമേ! അല്ലാഹുവേ! വെള്ളവസ്ത്രം കറകളിൽ നിന്ന് ശുദ്ധീകരിക്കപ്പെടുന്നത് പോലെ,<span class="c6"> എൻ്റെ തിന്മകളിൽ നിന്ന് നീ എന്നെ ശുദ്ധീകരിക്കേണമേ! അല്ലാഹുവേ! മഞ്ഞും വെള്ളവും ആലിപ്പഴവും കൊണ്ട് എൻ്റെ തിന്മകളിൽ നിന്ന് നീ എന്നെ കഴുകേണമേ!"<br /> അതല്ലെങ്കിൽ ഇപ്രകാരം ചൊല്ലുക:</span> <span class="c2">(സാരം)</span> "അല്ലാഹുവെ! നീയെത്ര പരിശുദ്ധൻ! നിന്നെ ഞാൻ സ്തുതിക്കുന്നു. നിൻ്റെ നാമം എല്ലാ നന്മകളും നിറഞ്ഞതാകുന്നു. നിൻ്റെ മഹത്വം ഉന്നതമാകുന്നു. നീയല്ലാതെ ആരാധനക്കർഹനായി മറ്റാരുമില്ല."<br /> <br /> 6- ശേഷം അഊദു ചൊല്ലുക. "ആട്ടിയോടിക്കപ്പെട്ട പിശാചിൽ നിന്നും അല്ലാഹുവിനോട് ഞാൻ ശരണം തേടുന്നു." 7- ശേഷം ബിസ്മി ചൊല്ലുകയും, സൂറത്തുൽ ഫാതിഹഃ പാരായണം നടത്തുകയും ചെയ്യുക. <span class="c2">(അർത്ഥം)</span> പരമകാരുണികനും കരുണാനിധിയുമായ അല്ലാഹുവിൻ്റെ നാമത്തിൽ സർവ്വ സ്തുതികളും സർവ്വലോക പരിപാലകനായ അല്ലാഹുവിനാകുന്നു. സർവ്വ വിശാലമായ കാരുണ്യമുള്ളവനും, അങ്ങേയറ്റം കരുണ ചൊരിയുന്നവനുമായ <span class="c2">(അല്ലാഹുവിന്)</span>. പ്രതിഫല ദിവസത്തിൻ്റെ ഉടമസ്ഥന്. നിന്നെ മാത്രം ഞങ്ങൾ ആരാധിക്കുന്നു. നിന്നോട് മാത്രം ഞങ്ങൾ സഹായം തേടുന്നു. ഞങ്ങളെ നീ നേരായ മാർഗത്തിൽ <span class="c2">(ഇസ്ലാമിൽ)</span> ചേർക്കേണമേ. നീ അനുഗ്രഹിച്ചവരുടെ മാർഗത്തിൽ. കോപത്തിന്ന് ഇരയായവരുടെ മാർഗത്തിലല്ല. പിഴച്ചുപോയവരുടെ മാർഗത്തിലുമല്ല. <span class="c2">(ഫാതിഹഃ: 1-7)</span><br /> ശേഷം \'ആമീൻ\' പറയുക. \'അല്ലാഹുവേ! പ്രാർത്ഥനക്ക് ഉത്തരം നൽകണേ!\' എന്നാണ് അതിൻ്റെ അർത്ഥം.<br /> <br /> 8- ശേഷം ഖുർആനിൽ നിന്ന് സാധിക്കുന്നത് പാരായണം ചെയ്യുക. സുബ്ഹ് നിസ്കാരത്തിൽ ഈ പാരായണം അധികരിപ്പിക്കുന്നത് സുന്നത്താണ്.<br /> <br /> 9- ശേഷം റുകൂഅ് ചെയ്യുക; അല്ലാഹുവിനോടുള്ള ആദരവായി കൊണ്ട് അവൻ തൻ്റെ മുതുക് കുനിക്കലാണ് റുകൂഅ്. റുകൂഇൻ്റെ സന്ദർഭത്തിൽ തക്ബീർ ചൊല്ലുകയും, രണ്ട് കൈകളും തോളിന് നേരെയാകുന്ന വിധത്തിൽ ഉയർത്തുകയും ചെയ്യണം. മുതുക് പരത്തി വെക്കുക എന്നതും, ശിരസ്സ് അതിന് നേരെയാകും വിധം വെക്കുക എന്നതും, രണ്ട് കൈകളും മുട്ടിന് മേൽ വെക്കുകയും, വിരലുകൾ വിടർത്തിപിടിക്കുകയും ചെയ്യുക എന്നതാണ് സുന്നത്ത്.<br /> <br /> 10- റുകൂഇൽ \'മഹോന്നതനായ എൻ്റെ രക്ഷിതാവിനെ ഞാൻ സ്തുതിക്കുന്നു\' എന്നർത്ഥം വരുന്ന ദിക്ർ ചൊല്ലുക. \'അല്ലാഹുവേ! നിന്നെ പരിശുദ്ധപ്പെടുത്തുന്നതോടൊപ്പം നിന്നെ ഞാൻ സ്തുതിക്കുന്നു. എനിക്ക് നീ പൊറുത്തു തരണേ!\' എന്നർത്ഥമുള്ള ദിക്ർ അധികമായി ചൊല്ലിയാൽ അത് കൂടുതൽ നല്ലത്.<br /> <br /> 11- ശേഷം റുകൂഇൽ നിന്ന് തലയുയർത്തുകയും \'അല്ലാഹുവിനെ സ്തുതിച്ചവനെ അവൻ കേട്ടിരിക്കുന്നു\' എന്നർത്ഥമുള്ള വാക്ക് പറയുകയും ചെയ്യുക. കൈകൾ തോളിന് നേരെയാകുന്ന വിധത്തിൽ ഈ സന്ദർഭത്തിലും ഉയർത്തണം. എന്നാൽ ഇമാമിനെ പിന്തുടർന്ന് നിസ്കരിക്കുന്ന മഅ്മൂം ഇപ്രകാരം പറയേണ്ടതില്ല. മറിച്ച്, ഇതിന് പകരമായി \'ഞങ്ങളുടെ രക്ഷിതാവേ! നിനക്ക് സർവ്വ സ്തുതിയും\' എന്നർത്ഥം വരുന്ന ദിക്റാണ് അവൻ ചൊല്ലേണ്ടത്.<br /> <br /> 12-<span class="c6"> റുകൂഇൽ നിന്ന് ഉയർന്നതിന് ശേഷം പറയുക:</span> <span class="c2">(അർത്ഥം)</span> "ഞങ്ങളുടെ രക്ഷിതാവേ! നിനക്ക് സർവ്വ സ്തുതിയും. ആകാശങ്ങളും ഭൂമിയും നിറയെ. അതിന് ശേഷം നീ ഉദ്ദേശിക്കുന്നതെല്ലാം നിറയെ."<br /> <br /> 13- ശേഷം ഒന്നാമത്തെ സുജൂദ് ചെയ്യുക. സുജൂദിലേക്ക് പോകുമ്പോൾ \'അല്ലാഹു അക്ബർ\' എന്ന് പറയണം. ഏഴ് അവയവങ്ങൾക്ക് മേലാണ് ഒരാൾ സുജൂദ് ചെയ്യേണ്ടത്; നെറ്റി, മൂക്ക്, രണ്ട് കൈപ്പത്തികൾ, രണ്ട് കാല്മുട്ടുകൾ, കാൽപ്പാദങ്ങളുടെ അറ്റങ്ങൾ എന്നിവയാണവ. സുജൂദിൽ രണ്ട് പാർശ്വങ്ങളിൽ നിന്നും കൈമുട്ടുകൾ അകറ്റി പിടിക്കണം. കൈത്തണ്ട ഭൂമിയിൽ പരത്തി വെക്കാൻ പാടില്ല. അവൻ്റെ വിരലുകൾ ഖിബ്\'ലയുടെ ദിശയിലേക്ക് ആയിരിക്കുകയും വേണം.<br /> <br /> 14- സുജൂദിൽ \'ഔന്നത്യമുടയവനായ എൻ്റെ രക്ഷിതാവിന്റെ പരിശുദ്ധിയെ ഞാൻ പ്രകീർത്തിക്കുന്നു\' എന്നർത്ഥം വരുന്ന ദിക്ർ ചൊല്ലുക. \'അല്ലാഹുവേ! നിന്നെ പരിശുദ്ധപ്പെടുത്തുന്നതോടൊപ്പം നിന്നെ ഞാൻ സ്തുതിക്കുന്നു. എനിക്ക് നീ പൊറുത്തു തരണേ!\' എന്നർത്ഥമുള്ള ദിക്ർ അധികമായി ചൊല്ലിയാൽ അത് കൂടുതൽ നല്ലത്.<br /> <br /> 15- ശേഷം \'അല്ലാഹു അക്ബർ\' എന്നു പറഞ്ഞു കൊണ്ട് സുജൂദിൽ നിന്ന് തലയുയർത്തുക.<br /> <br /> 16- ശേഷം രണ്ട് സുജൂദുകൾക്ക് ഇടയിൽ ഇരിക്കുക; അവൻ്റെ ഇടതു കാലിന് മുകളിൽ ഇരിക്കുകയും, വലതു കാൽ കുത്തിവെക്കുകയുമാണ് വേണ്ടത്. വലതു കൈ വലതു കാലിൻ്റെ തുടയുടെ അറ്റത്ത് -മുട്ടിനോട് ചേർത്ത നിലയിൽ- വെക്കുകയും, ചെറുവിരലും മോതിരവിരലും മടക്കി പിടിക്കുകയും, ചൂണ്ടുവിരൽ ഉയർത്തിപ്പിടിക്കുകയും പ്രാർത്ഥനയുടെ സന്ദർഭത്തിൽ അത് ചലിപ്പിക്കുകയും ചെയ്യുക. തള്ളവിരലിൻ്റെ അറ്റം നടുവിരലിൻ്റെ അറ്റത്തിനോട് ചേർത്ത നിലയിൽ ഒരു വളയം പോലെ വെക്കുക. ഇടതു കൈ വിരലുകൾ പരത്തി വെച്ച നിലയിൽ ഇടതു തുടയുടെ അറ്റത്ത് -മുട്ടിനോട് ചേർന്ന സ്ഥലത്ത്- വെക്കുകയും വേണം.<br /> <br /> 17-<span class="c6"> രണ്ട് സുജൂദുകൾക്ക് ഇടയിലുള്ള ഇരുത്തത്തിൽ ഇപ്രകാരം പറയുക:</span> <span class="c2">(സാരം:)</span> "എൻ്റെ രക്ഷിതാവേ! എനിക്ക് നീ പൊറുത്തു തരികയും എന്നോട് കരുണ കാണിക്കുകയും എനിക്ക് സന്മാർഗം നൽകുകയും ഉപജീവനം നൽകുകയും എൻ്റെ കുറവുകൾ നികത്തുകയും എനിക്ക് സൗഖ്യം നൽകുകയും ചെയ്യേണമേ!"<br /> 18- ശേഷം രണ്ടാമത്തെ സുജൂദിലേക്ക് പോവുക; ഇത് ആദ്യത്തെ സുജൂദിനെ പോലെ തന്നെ. അവിടെ ചെയ്തതും പറഞ്ഞതും ഇവിടെയും ആവർത്തിക്കണം. സുജൂദിലേക്ക് പോകുന്ന സന്ദർഭത്തിൽ അല്ലാഹു അക്ബർ എന്ന് തക്ബീർ ചൊല്ലുകയും വേണം.<br /> <br /> 19- ശേഷം രണ്ടാമത്തെ സുജൂദിൽ നിന്ന് \'അല്ലാഹു അക്ബർ\' എന്ന് ചൊല്ലിക്കൊണ്ട് എഴുന്നേൽകുക. ആദ്യത്തെ റക്അത്ത് പോലെ തന്നെ രണ്ടാമത്തെ റക്അത്തും നിസ്കരിക്കുക; അതിൽ പറഞ്ഞതും ചെയ്തതുമെല്ലാം രണ്ടാമത്തെ റക്അത്തിലും വേണം; പ്രാരംഭപ്രാർത്ഥന ഒഴികെ.<br /> <br /> 20- രണ്ടാമത്തെ റക്അത്ത് കഴിഞ്ഞതിന് ശേഷം അല്ലാഹു അക്ബർ എന്ന് പറഞ്ഞു കൊണ്ട് ഇരിക്കുകയും, രണ്ട് സുജൂദുകൾക്ക് ഇടയിൽ ഇരുന്ന രൂപത്തിൽ ഇവിടെ ഇരിക്കുകയും ചെയ്യുക.<br /> <br /> 21- ഈ ഇരുത്തത്തിൽ തശഹ്ഹുദ് പാരായണം ചെയ്യുക. <span class="c2">(സാരം)</span> "സർവ്വ അഭിവാദനങ്ങളും ആരാധനാകർമ്മങ്ങളും സൽകർമ്മങ്ങളും അല്ലാഹുവിന് മാത്രമാകുന്നു. അല്ലാഹുവിൻ്റെ രക്ഷയും കാരുണ്യവും അനുഗ്രഹങ്ങളും -നബിയേ- താങ്കൾക്ക് മേലെയുണ്ടാകട്ടെ! നമ്മുടെ മേലും, അല്ലാഹുവിൻ്റെ സച്ചരിതരായ അടിമകളുടെ മേലും അല്ലാഹുവിൻ്റെ രക്ഷയുണ്ടാകട്ടെ! അല്ലാഹുവല്ലാതെ ആരാധനക്ക് അർഹനായി മറ്റാരുമില്ലെന്നും, മുഹമ്മദ് നബി -ﷺ- അല്ലാഹുവിൻ്റെ അടിമയും അവൻ്റെ ദൂതനുമാണെന്നും ഞാൻ സാക്ഷ്യം വഹിക്കുന്നു. അല്ലാഹുവേ! ഇബ്രാഹീം നബിയുടെയും അദ്ദേഹത്തിൻ്റെ കുടുംബത്തിനും മേൽ നീ സ്വലാത് വർഷിച്ചതു <span class="c2">(അല്ലാഹുവിൻ്റെ ഉന്നതമായ സദസ്സിൽ അവൻ നബിയെ സ്മരിക്കലാണ് അല്ലാഹുവിൻ്റെ സ്വലാത് എന്നത് കൊണ്ടുള്ള ഉദ്ദേശം)</span> പോലെ, മുഹമ്മദ് നബിയുടെ മേലും അവിടുത്തെ കുടുംബത്തിന് മേലും നീ സ്വലാത് വർഷിക്കേണമേ. തീർച്ചയായും നീ അങ്ങേയറ്റം സ്തുത്യർഹനും അതീവ മഹത്വമുള്ളവനുമാകുന്നു. അല്ലാഹുവേ! ഇബ്രാഹീം നബിയുടെയും അദ്ദേഹത്തിൻ്റെ കുടുംബത്തിനും മേൽ നീ അനുഗ്രഹം ചൊരിഞ്ഞതു പോലെ, മുഹമ്മദ് നബിയുടെ മേലും അവിടുത്തെ കുടുംബത്തിന് മേലും നീ അനുഗ്രഹം ചൊരിയേണമേ! തീർച്ചയായും നീ അങ്ങേയറ്റം സ്തുത്യർഹനും അതീവ മഹത്വമുള്ളവനുമാകുന്നു. നരകശിക്ഷയിൽ നിന്നും, ഖബ്ർ ശിക്ഷയിൽ നിന്നും, ജീവിതത്തിന്റെയും മരണത്തിന്റെയും പരീക്ഷണങ്ങളിൽ നിന്നും, മസീഹുദ്ദജ്ജാലിന്റെ കുഴപ്പങ്ങളിൽ നിന്നും ഞാൻ അല്ലാഹുവിനോട് കാവൽ തേടുന്നു." ശേഷം അവന് ഇഷ്ടമുള്ള പ്രാർത്ഥനകൾ ചൊല്ലിക്കൊണ്ട് ഇഹപരലോകത്തെ നന്മകൾ അവന് ചോദിക്കാവുന്നതാണ്.<br /> 22- ശേഷം വലതു ഭാഗത്തേക്ക് \'അസ്സലാമു അലൈകും വ റഹ്മതുല്ലാഹ്\' എന്ന് പറഞ്ഞു കൊണ്ട് സലാം വീട്ടുക; പിന്നീട് ഇടതു ഭാഗത്തേക്കും ഇതു പോലെ ചെയ്യുക.<br /> <br /> 23- നിസ്കാരം മൂന്ന് റക്അത്തുള്ളതോ നാലു റക്അത്തുള്ളതോ ആണെങ്കിൽ ഒന്നാമത്തെ തശഹ്ഹുദിൻ്റെ അവസാനത്തിൽ -അശ്ഹദു അല്ലാ ഇലാഹ ഇല്ലല്ലാഹ്, വ അശ്ഹദു അന്ന മുഹമ്മദൻ അബ്ദുഹു വ റസൂലുഹു\' എന്ന ഭാഗം- വരെ അവൻ ചൊല്ലുക.<br /> <br /> 24- ശേഷം അല്ലാഹു അക്ബർ എന്ന് പറഞ്ഞു കൊണ്ട് എഴുന്നേൽക്കുക. രണ്ട് കൈകളും തോളിന് നേരെ വരുന്ന രൂപത്തിൽ അവൻ ഉയർത്തുകയും വേണം.<br /> <br /> 25- ശേഷം ബാക്കിയുള്ള നിസ്കാരം രണ്ടാമത്തെ റക്അത്തിലേതു പോലെ പൂർത്തീകരിക്കുക; എന്നാൽ ഫാതിഹഃക്ക് ശേഷമുള്ള സൂറത്ത് ഈ റക്അത്തിൽ വേണ്ടതില്ല.<br /> <br /> 26- ശേഷം തവർറുകിൻ്റെ ഇരുത്തം ഇരിക്കുക; അവൻ്റെ വലതു കാൽപാദം കുത്തി നിർത്തുകയും, ഇടതുകാൽ പാദം അവൻ്റെ വലതു കാലിൻ്റെ കണങ്കാലിന് ഇടയിലൂടെ പുറത്തു കൊണ്ടുവരികയും ചെയ്യുക. പൃഷ്ഠം ഭൂമിയിലേക്ക് അമർത്തി വെക്കുകയും, തൻ്റെ രണ്ട് കൈകളും ഒന്നാമത്തെ തശഹ്ഹുദിൽ ചെയ്തതു പോലെ കാൽത്തുടകളുടെ മേൽ വെക്കുകയും ചെയ്യുക.<br /> <br /> 27- ഈ ഇരുത്തത്തിൽ തശഹ്ഹ്ദ് മുഴുവനായും ചൊല്ലണം.<br /> <br /> 28- ശേഷം വലതു ഭാഗത്തേക്ക് \'അസ്സലാമു അലൈകും വ റഹ്മതുല്ലാഹ്\' എന്ന് പറഞ്ഞു കൊണ്ട് സലാം വീട്ടുക; പിന്നീട് ഇടതു ഭാഗത്തേക്കും ഇതു പോലെ ചെയ്യുക. </p>',
            ],
            25 => [
                'question' => 'ചോദ്യം 26: നിസ്കാരത്തിന് ശേഷം ചൊല്ലേണ്ട അദ്കാറുകൾ ഏതെല്ലാമാണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4610.mp3',
                'answer' => '<p> ഉത്തരം: \'അസ്തഗ്ഫിറുല്ലാഹ്\' <span class="c2">(അല്ലാഹുവേ! എനിക്ക് പൊറുത്തു തരേണമേ!)</span> എന്ന് മൂന്നു തവണ പറയുക.<span class="c6"><br /> <br /> ശേഷം ഈയർത്ഥം വരുന്ന ദുആ ചൊല്ലുക:</span> "അല്ലാഹുവേ! നീയാണ് എല്ലാ ന്യൂനതകളിൽ നിന്നും സുരക്ഷിതനായവൻ. സുരക്ഷ നിന്നിൽ നിന്നാകുന്നു. ഏറ്റവും മഹത്വവും ആദരവുകളുമുള്ളവനേ! നീ അനുഗ്രഹസമ്പൂർണനാകുന്നു."<br /> <br /> "അല്ലാഹുവല്ലാതെ ആരാധനക്കർഹനായി മറ്റാരുമില്ല. അവൻ ഏകനാണ്. അവന് യാതൊരു പങ്കുകാരുമില്ല. അവനാണ് എല്ലാ ആധിപത്യവും. അവന്നാണ് എല്ലാ സ്തുതിയും. അവൻ എല്ലാ കാര്യത്തിനും കഴിവുള്ളവനാകുന്നു. അല്ലാഹുവേ! നീ നൽകിയത് തടയാൻ ആരുമില്ല. നീ തടഞ്ഞത് നൽകാനും ആരും തന്നെയില്ല. ഒരു കഴിവുള്ളവനും അവൻ്റെ കഴിവ് നിൻ്റെ പക്കൽ പ്രയോജനപ്പെടുകയില്ല. <span class="c2">(നിന്നിലുള്ള വിശ്വാസവും നിന്നോടുള്ള അനുസരണയും മാത്രമാണ് പ്രയോജനപ്പെടുക.)</span>"<br /> <br /> "അല്ലാഹുവല്ലാതെ ആരാധനക്ക് അർഹനായി മറ്റാരുമില്ല. അവൻ ഏകനാകുന്നു; യാതൊരു പങ്കുകാരനും അവനില്ല. സർവ്വ അധികാരവും, സർവ്വ സ്തുതികളും അവനത്രെ. അവൻ എല്ലാ കാര്യത്തിനും അങ്ങേയറ്റം കഴിവുള്ളവനാകുന്നു. അല്ലാഹുവിനെ കൊണ്ടല്ലാതെ യാതൊരു കഴിവോ ശക്തിയോ ഇല്ല. അല്ലാഹുവല്ലാതെ ആരാധനക്ക് അർഹനായി മറ്റാരുമില്ല. അവനെയല്ലാതെ മറ്റാരെയും നാം ആരാധിക്കുകയില്ല. അവൻ്റേതാകുന്നു സർവ്വ അനുഗ്രഹങ്ങളും. അവൻ്റേതാകുന്നു എല്ലാ ഔദാര്യങ്ങളും. അവനാകുന്നു ഏറ്റവും ഉത്തമമായ പ്രശംസകൾ. അല്ലാഹുവല്ലാതെ ആരാധനക്ക് അർഹനായി മറ്റാരുമില്ല. മതം <span class="c2">(കീഴ്വണക്കം)</span> അവന് മാത്രം നിഷ്കളങ്കരാക്കുന്നവരായി; നിഷേധികൾക്ക് അത് വെറുപ്പുളവാക്കിയാലും."<br /> <br /> സുബ്ഹാനല്ലാഹ് <span class="c2">(33 പ്രാവശ്യം)</span><br /> <br /> അൽഹംദുലില്ലാഹ് <span class="c2">(33 പ്രാവശ്യം)</span><br /> <br /> അല്ലാഹു അക്ബർ <span class="c2">(33 പ്രാവശ്യം)</span><br /> <br /> പിന്നീട് നൂറ് എണ്ണം പൂർത്തീകരിച്ചു കൊണ്ട് പറയുക: "അല്ലാഹുവല്ലാതെ ആരാധനക്കർഹനായി മറ്റാരുമില്ല. അവൻ ഏകനാണ്. അവന് യാതൊരു പങ്കുകാരുമില്ല. അവനാണ് എല്ലാ ആധിപത്യവും. അവന്നാണ് എല്ലാ സ്തുതിയും.അവൻ എല്ലാ കാര്യത്തിനും കഴിവുള്ളവനാകുന്നു."<br /> സുബ്ഹ്, മഗ്രിബ് എന്നീ നിസ്കാരങ്ങളിൽ ഇത്രയും ചൊല്ലിയതിന് ശേഷം സൂറതുൽ ഇഖ്\'ലാസും സൂറതുൽ ഫലഖും സൂറതുന്നാസും മൂന്നു തവണ വീതം പാരായണം ചെയ്യുക. മറ്റു നിസ്കാരങ്ങൾക്ക് ശേഷം ഈ സൂറത്തുകൾ ഒരു തവണ പാരായണം ചെയ്താൽ മതി.<br /> <br /> ശേഷം ആയതുൽ കുർസിയ്യ് ഒരു തവണ പാരായണം ചെയ്യുക. </p>',
            ],
            26 => [
                'question' => 'ചോദ്യം 27: എന്താണ് റവാതിബ് സുന്നത്തുകൾ? എന്താണ് അതിൻ്റെ ശ്രേഷ്ഠത?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4730.mp3',
                'answer' => '<p> ഉത്തരം: സുബ്ഹിന് മുൻപ് രണ്ട് റക്അത്തുകൾ.<br /> <br /> ദ്വുഹറിന് മുൻപ് നാല് റക്അത്തുകൾ.<br /> <br /> ദ്വുഹ്റിന് ശേഷം രണ്ട് റക്അത്തുകൾ.<br /> <br /> മഗ്രിബിന് ശേഷം രണ്ട് റക്അത്തുകൾ.<br /> <br /> ഇശാഇന് ശേഷം രണ്ട് റക്അത്തുകൾ.<br /> <br /> ഈ നിസ്കാരങ്ങളുടെ ശ്രേഷ്ഠത ബോധ്യപ്പെടുത്തി കൊണ്ട് നബി -ﷺ-<span class="c6"> പറഞ്ഞു:</span> "ആരെങ്കിലും രാവിലെയും രാത്രിയുമായി പന്ത്രണ്ട് റക്അത്തുകൾ ഐഛികമായി നിസ്കരിച്ചാൽ അല്ലാഹു സ്വർഗത്തിൽ അവന് വേണ്ടി ഒരു ഭവനം നിർമ്മിക്കുന്നതാണ്." <span class="c2">(മുസ്ലിം, അഹ്മദ് തുടങ്ങിയവർ)</span> </p>',
            ],
            27 => [
                'question' => 'ചോദ്യം 28: ആഴ്ച്ചയിലെ ഏറ്റവും ശ്രേഷ്ഠമായ ദിവസം ഏതാണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4800.mp3',
                'answer' => '<p> ഉത്തരം: വെള്ളിയാഴ്ച്ച ദിവസം. നബി -ﷺ-<span class="c6"> അതിൻ്റെ ശ്രേഷ്ഠതയെ കുറിച്ച് പറഞ്ഞു:</span> "നിങ്ങളുടെ ദിവസങ്ങളിൽ ഏറ്റവും ശ്രേഷ്ഠമായ ദിവസം വെള്ളിയാഴ്ച്ച ദിവസമാണ്. അന്നാണ് ആദം സൃഷ്ടിക്കപ്പെട്ടത്. അന്നാണ് അദ്ദേഹം മരണപ്പെട്ടതും. അന്നാണ് അന്ത്യനാളിലെ കാഹളമൂത്ത് ഉണ്ടാവുക. അന്നാണ് <span class="c2">(മനുഷ്യരെല്ലാം)</span> നിലംപതിക്കുക. അതിനാൽ അന്നേ ദിവസം നിങ്ങൾ എൻ്റെ മേലുള്ള സ്വലാത്ത് അധികരിപ്പിക്കുക; നിങ്ങളുടെ സ്വലാത്ത് എനിക്ക് പ്രദർശിക്കപ്പെടുന്നതാണ്.<span class="c6">" സ്വഹാബികൾ ചോദിച്ചു:</span> "അല്ലാഹുവിൻ്റെ റസൂലേ! അങ്ങ് മണ്ണായിത്തീർന്നിരിക്കെ എങ്ങനെയാണ് ഞങ്ങളുടെ സ്വലാത്ത് അങ്ങേക്ക് കാണിക്കപ്പെടുക?!" നബി -ﷺ-<span class="c6"> പറഞ്ഞു:</span> "തീർച്ചയായും അല്ലാഹു നബിമാരുടെ ശരീരങ്ങൾ മണ്ണ് തിന്നുന്നത് നിഷിദ്ധമാക്കിയിരിക്കുന്നു." <span class="c2">(അബൂദാവൂദ്)</span> </p>',
            ],
            28 => [
                'question' => 'ചോദ്യം 29: ജുമുഅഃ നിസ്കാരത്തിൻ്റെ വിധി എന്താണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4840.mp3',
                'answer' => '<p> ഉത്തരം: പ്രായപൂർത്തിയെത്തിയ, ബുദ്ധിയുള്ള, നാട്ടിൽ താമസിക്കുന്ന <span class="c2">(യാത്രക്കാരനല്ലാത്ത)</span>, പുരുഷനായ ഓരോ മുസ്ലിമിൻ്റെ മേലും വ്യക്തിപരമായ നിർബന്ധബാധ്യതയാണ് ജുമുഅ നിസ്കാരം.<span class="c6"><br /> <br /> അല്ലാഹു പറയുന്നു:</span> "<span class="c2">(അല്ലാഹുവിലും അവൻ്റെ ദൂതനിലും)</span> വിശ്വസിച്ചവരേ! വെള്ളിയാഴ്ച നിസ്കാരത്തിന് വിളിക്കപ്പെട്ടാൽ അല്ലാഹുവെ പറ്റിയുള്ള സ്മരണയിലേക്ക് നിങ്ങൾ വേഗത്തിൽ വരികയും, വ്യാപാരം ഒഴിവാക്കുകയും ചെയ്യുക. അതാണ് നിങ്ങൾക്ക് ഉത്തമം; നിങ്ങൾ കാര്യം മനസ്സിലാക്കുന്നുവെങ്കിൽ." <span class="c2">(ജുമുഅഃ: 9)</span> </p>',
            ],
            29 => [
                'question' => 'ചോദ്യം 30: ജുമുഅഃ നിസ്കാരത്തിൻ്റെ റക്അത്തുകളുടെ എണ്ണം എത്രയാണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4880.mp3',
                'answer' => '<p> ഉത്തരം: ജുമുഅഃ നിസ്കാരത്തിൽ രണ്ട് റക്അത്തുകളാണ് ഉള്ളത്. ഈ രണ്ട് റക്അത്തുകളിലും ഇമാം ഉച്ചത്തിൽ പാരായണം ചെയ്യണം. ഈ നിസ്കാരത്തിന് മുൻപ് രണ്ട് ഖുതുബകൾ <span class="c2">(പ്രഭാഷണം)</span> നടത്തുകയും വേണം. </p>',
            ],
            30 => [
                'question' => 'ചോദ്യം 31: ജുമുഅഃ നിസ്കാരത്തിൽ നിന്ന് പിന്തിനിൽക്കുക എന്നത് അനുവദനീയമാണോ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4910.mp3',
                'answer' => '<p> ഉത്തരം: ജുമുഅഃ നിസ്കാരത്തിൽ നിന്ന് മതപരമായ യാതൊരു ഒഴിവുകഴിവുമില്ലാതെ പിന്തിനിൽക്കുക എന്നത് അനുവദനീയമല്ല. നബി -ﷺ-<span class="c6"> പറഞ്ഞിരിക്കുന്നു:</span> "ആരെങ്കിലും മൂന്ന് ജുമുഅഃകൾ അവഗണനയോടെ ഉപേക്ഷിച്ചാൽ അല്ലാഹു അവൻ്റെ ഹൃദയത്തിന് മേൽ മുദ്ര വെക്കുന്നതാണ്." <span class="c2">(അബൂദാവൂദ്)</span> </p>',
            ],
            31 => [
                'question' => 'ചോദ്യം 32: വെള്ളിയാഴ്ച്ച ദിവസത്തെ സുന്നത്തുകൾ ഏതെല്ലാമാണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4940.mp3',
                'answer' => '<p> ഉത്തരം:<br /> <br /> 1- കുളിക്കൽ.<br /> <br /> 2- സുഗന്ധം പുരട്ടൽ.<br /> <br /> 3- ഏറ്റവും നല്ല വസ്ത്രം ധരിക്കൽ.<br /> <br /> 4- മസ്ജിദിലേക്ക് നേരത്തെ പുറപ്പെടുക.<br /> <br /> 5- നബി -ﷺ- യുടെ മേലുള്ള സ്വലാത്ത് അധികരിപ്പിക്കുക.<br /> <br /> 6- സൂറതുൽ കഹ്ഫ് പാരായണം ചെയ്യുക.<br /> <br /> 7- മസ്ജിദിലേക്ക് നടന്നു കൊണ്ട് പോവുക.<br /> <br /> 8- പ്രാർത്ഥന സ്വീകരിക്കപ്പെടാൻ സാധ്യതയുള്ള സമയത്ത് പ്രാർത്ഥിക്കുക. </p>',
            ],
            32 => [
                'question' => 'ചോദ്യം 33: ജമാഅത്ത് നിസ്കാരത്തിൻ്റെ ശ്രേഷ്ഠത എന്താണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5050.mp3',
                'answer' => '<p> ഉത്തരം: അബ്ദുല്ലാഹി ബ്നു ഉമർ -رَضِيَ اللَّهُ عَنْهُمَا-<span class="c6"> നിവേദനം:</span> നബി -ﷺ-<span class="c6"> പറഞ്ഞു:</span> "ജമാഅത്തായ നിസ്കാരം ഒറ്റക്കുള്ള നിസ്കാരത്തേക്കാൾ ഇരുപത്തിഏഴ് പടികൾ ശ്രേഷ്ഠതയുള്ളതാണ്." <span class="c2">(മുസ്ലിം)</span> </p>',
            ],
            33 => [
                'question' => 'ചോദ്യം 34: നിസ്കാരത്തിൽ ഭയഭക്തിയുണ്ടാവേണ്ടത് എങ്ങനെയാണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5080.mp3',
                'answer' => '<p> ഉത്തരം: നിസ്കാരത്തിൽ ഹൃദയസാന്നിധ്യം ഉണ്ടാവുകയും, ശരീരത്തിലെ അവയവങ്ങൾ അടക്കത്തോടെ ആവുകയും ചെയ്യുക എന്നതാണ് ഭയഭക്തി.<span class="c6"><br /> <br /> അല്ലാഹു പറയുന്നു:</span> "<span class="c2">(അല്ലാഹുവിലും അവൻ്റെ റസൂലിലും)</span> വിശ്വസിച്ചവർ വിജയം പ്രാപിച്ചിരിക്കുന്നു. തങ്ങളുടെ നമസ്കാരത്തിൽ ഭക്തിയുള്ളവരാണവർ." <span class="c2">(മുഅ്മിനൂൻ: 1-2)</span> </p>',
            ],
            34 => [
                'question' => 'ചോദ്യം 35: എന്താണ് സകാത്ത്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5120.mp3',
                'answer' => '<p> ഉത്തരം: നിശ്ചിത സമ്പത്തുകളിൽ നിന്ന്, നിശ്ചയിക്കപ്പെട്ട ചില വിഭാഗങ്ങൾക്ക്, നിശ്ചയിക്കപ്പെട്ട ചില സമയങ്ങളിൽ നൽകേണ്ട സാമ്പത്തിക ബാധ്യതയാണത്.<br /> <br /> - ഇസ്ലാമിലെ സ്തംഭങ്ങളിൽ ഒന്നാണത്. സമ്പന്നരിൽ നിന്ന് എടുത്തു കൊണ്ട് ദരിദ്രരിൽ വിതരണം ചെയ്യപ്പെടേണ്ട സമ്പത്താണത്.<span class="c6"><br /> <br /> അല്ലാഹു പറയുന്നു:</span> "നിങ്ങൾ സകാത്ത് നൽകുക." <span class="c2">(ബഖറ: 43)</span> </p>',
            ],
            35 => [
                'question' => 'ചോദ്യം 36: എന്താണ് ഐഛികമായ സ്വദഖകൾ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5170.mp3',
                'answer' => '<p> ഉത്തരം: സകാത്തിന് പുറമേ നൽകുന്ന ദാനങ്ങളാണ് സ്വദഖകൾ. ഏതു സന്ദർഭത്തിലും ഒരാൾ നന്മയുടെ മാർഗത്തിൽ എന്തൊന്ന് ചെലവഴിച്ചാലും അത് സ്വദഖയിൽ പെടും.<span class="c6"><br /> <br /> അല്ലാഹു പറയുന്നു:</span> "നിങ്ങൾ അല്ലാഹുവിൻ്റെ മാർഗത്തിൽ ദാനം ചെയ്യുക." <span class="c2">(ബഖറ: 195)</span> </p>',
            ],
            36 => [
                'question' => 'ചോദ്യം 37: എന്താണ് നോമ്പ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5210.mp3',
                'answer' => '<p> ഉത്തരം: പുലരി ഉദിച്ചത് മുതൽ സൂര്യൻ അസ്തമിക്കുന്നത് വരെ, അല്ലാഹുവിൻ്റെ പ്രതിഫലം പ്രതീക്ഷിച്ചു കൊണ്ട് നോമ്പ് മുറിക്കുന്ന കാര്യങ്ങളിൽ നിന്ന് സ്വന്തത്തെ പിടിച്ചു വെച്ചു കൊണ്ട് നിയ്യത്തോടെ ആരാധന നിർവ്വഹിക്കുന്നതിനാണ് നോമ്പ് എന്ന് പറയുക. നോമ്പ് രണ്ട് രൂപത്തിലുണ്ട്.<span class="c6"><br /> <br /> നിർബന്ധമായ നോമ്പ്:</span> റമദാൻ മാസത്തിലെ നോമ്പ് ഉദാഹരണം. ഇസ്ലാമിൻ്റെ സ്തംഭങ്ങളിൽ പെട്ട കാര്യമാണത്.<span class="c6"><br /> <br /> അല്ലാഹു പറയുന്നു:</span> "<span class="c2">(അല്ലാഹുവിലും അവൻ്റെ ദൂതനിലും)</span> വിശ്വസിച്ചവരേ! നിങ്ങളുടെ മുമ്പുള്ളവരോട് കൽപിച്ചിരുന്നത് പോലെത്തന്നെ നിങ്ങൾക്കും നോമ്പ് നിർബന്ധമായി കൽപിക്കപ്പെട്ടിരിക്കുന്നു. നിങ്ങൾ ദോഷബാധയെ സൂക്ഷിക്കുവാൻ വേണ്ടിയത്രെയത്." <span class="c2">(ബഖറ: 183)</span><br /> നിർബന്ധമല്ലാത്ത നോമ്പ്: എല്ലാ ആഴ്ച്ചയിലെയും തിങ്കളും വ്യാഴവുമുള്ള നോമ്പുകളും, എല്ലാ മാസത്തിലെയും മൂന്നു ദിവസം നോമ്പെടുക്കലും ഉദാഹരണം. ഹിജ്റ മാസത്തിലെ 13, 14, 15 എന്നീ ദിവസങ്ങളാണ് അതിൽ ഏറ്റവും ശ്രേഷ്ഠമായ നോമ്പുകൾ. </p>',
            ],
            37 => [
                'question' => 'ചോദ്യം 38: റമദാൻ മാസത്തിൻ്റെ ശ്രേഷ്ഠത വിവരിക്കുക.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5270.mp3',
                'answer' => '<p> ഉത്തരം: അബൂഹുറയ്റ <span class="c2">(رَضِيَ اللَّهُ عَنْهُ)</span> നിവേദനം: അല്ലാഹുവിൻ്റെ റസൂൽ <span class="c2">(ﷺ)</span> പറഞ്ഞിരിക്കുന്നു: "ആരെങ്കിലും വിശ്വാസത്തോടെയും പ്രതിഫലേഛയോടെയും റമദാൻ മാസം നോമ്പനുഷ്ഠിച്ചാൽ അവൻ്റെ മുൻകഴിഞ്ഞ പാപങ്ങൾ പൊറുക്കപ്പെടുന്നതാണ്." <span class="c2">(ബുഖാരി, മുസ്ലിം)</span> </p>',
            ],
            38 => [
                'question' => 'ചോദ്യം 39: റമദാൻ മാസത്തിൽ അല്ലാത്ത സന്ദർഭങ്ങളിൽ സുന്നത്ത് നോമ്പ് എടുക്കുന്നതിൻ്റെ ശ്രേഷ്ഠത എന്താണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5300.mp3',
                'answer' => '<p> അബൂ സഈദ് അൽ ഖുദ്രി <span class="c2">(رَضِيَ اللَّهُ عَنْهُ)</span> നിവേദനം: അല്ലാഹുവിൻ്റെ റസൂൽ <span class="c2">(ﷺ)</span> പറഞ്ഞിരിക്കുന്നു: "അല്ലാഹുവിൻ്റെ മാർഗത്തിൽ ഒരു ദിവസം ഏതൊരാൾ നോമ്പെടുത്താലും അല്ലാഹു അവൻ്റെ മുഖത്തെ നരകത്തിൽ നിന്ന് എഴുപത് വർഷം വഴിദൂരം അകറ്റാതിരിക്കുകയില്ല." <span class="c2">(ബുഖാരി, മുസ്ലിം)</span><br /> എഴുപത് വർഷം എന്നാണ് ഹദീഥിലെ ഖരീഫ് എന്ന പദത്തിൻ്റെ ഉദ്ദേശ്യം. </p>',
            ],
            39 => [
                'question' => 'ചോദ്യം 40: നോമ്പ് മുറിച്ചുകളയുന്ന ചില കാര്യങ്ങൾ പറയുക.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5330.mp3',
                'answer' => '<p> ഉത്തരം: 1- മനപ്പൂർവ്വം ഭക്ഷണം കഴിക്കുകയോ വെള്ളം കുടിക്കുകയോ ചെയ്യുക.<br /> <br /> 2- മനപ്പൂർവ്വം സ്വയം ഛർദ്ദിപ്പിക്കുക.<br /> <br /> 3- ഇസ്ലാം ഉപേക്ഷിക്കുക. </p>',
            ],
            40 => [
                'question' => 'ചോദ്യം 41: നോമ്പിൻ്റെ സുന്നത്തുകൾ ഏതെല്ലാമാണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5380.mp3',
                'answer' => '<p> ഉത്തരം: 1- നോമ്പുതുറക്ക് സമയമായാൽ ഉടനെ നോമ്പുതുറക്കാൻ ധൃതികൂട്ടുക.<br /> <br /> 2- അത്താഴം കഴിക്കലും, അത് വൈകിപ്പിക്കലും.<br /> <br /> 3- നന്മകളും ആരാധനകളും നോമ്പിൻ്റെ വേളയിൽ അധികരിപ്പിക്കുക.<br /> <br /> 4- നോമ്പുകാരനെ ആരെങ്കിലും ചീത്ത പറഞ്ഞാൽ \'ഞാൻ നോമ്പുകാരനാണ്\' എന്ന് പറയുക.<br /> <br /> 5- നോമ്പ് തുറക്കുമ്പോൾ പ്രാർത്ഥിക്കുക.<br /> <br /> 6- ഈത്തപ്പഴമോ കാരക്കയോ കഴിച്ചു കൊണ്ട് നോമ്പ് തുറക്കുക. ഇത് ലഭിച്ചില്ലെങ്കിൽ വെള്ളം കുടിച്ചു കൊണ്ട് നോമ്പ് തുറക്കുക. </p>',
            ],
            41 => [
                'question' => 'ചോദ്യം 42: എന്താണ് ഹജ്ജ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5460.mp3',
                'answer' => '<p> ഉത്തരം: അല്ലാഹുവിൻ്റെ പരിശുദ്ധ ഭവനമായ കഅ്ബയെ ലക്ഷ്യം വെച്ചു കൊണ്ട് പുറപ്പെടുകയും, നിശ്ചയിക്കപ്പെട്ട സമയത്ത് നിശ്ചിതമായ ആരാധനകൾ നിർവ്വഹിക്കുകയും ചെയ്തു കൊണ്ട് അല്ലാഹുവിനെ ആരാധിക്കുക എന്നതാണ് ഹജ്ജ്.<span class="c6"><br /> <br /> അല്ലാഹു പറയുന്നു:</span> "ആ മന്ദിരത്തിൽ <span class="c2">(കഅ്ബ)</span> എത്തിച്ചേരാൻ കഴിവുള്ള മനുഷ്യർ അതിലേക്ക് ഹജ്ജ് തീർത്ഥാടനം നടത്തൽ അവർക്ക് അല്ലാഹുവോടുള്ള ബാധ്യതയാകുന്നു. വല്ലവനും അവിശ്വസിക്കുന്നപക്ഷം അല്ലാഹു ലോകരുടെ ആശ്രയം ഇല്ലാത്തവനാകുന്നു." <span class="c2">(ആലു ഇംറാൻ: 97)</span> </p>',
            ],
            42 => [
                'question' => 'ചോദ്യം 43: ഹജ്ജിൻ്റെ സ്തംഭങ്ങൾ ഏതെല്ലാമാണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5500.mp3',
                'answer' => '<p> 1- ഇഹ്റാം കെട്ടൽ.<br /> <br /> 2- അറഫയിൽ നിൽക്കൽ.<br /> <br /> 3- ത്വവാഫുൽ ഇഫാദ്വ.<br /> <br /> 4- സ്വഫാ മർവക്കിടയിലുള്ള നടത്തം. </p>',
            ],
            43 => [
                'question' => 'ചോദ്യം 44: ഹജ്ജിൻ്റെ ശ്രേഷ്ഠത എന്താണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5560.mp3',
                'answer' => '<p> അബൂഹുറയ്റ <span class="c2">(رَضِيَ اللَّهُ عَنْهُ)</span> നിവേദനം: അല്ലാഹുവിൻ്റെ റസൂൽ <span class="c2">(ﷺ)</span> പറഞ്ഞിരിക്കുന്നു: "ആരെങ്കിലും ഹജ്ജ് നിർവ്വഹിക്കുകയും, അതിൽ അശ്ലീലമോ ധിക്കാരമോ പ്രവർത്തിക്കാതിരിക്കുകയും ചെയ്താൽ അവൻ തിരിച്ചുവരുന്നത് അവൻ്റെ ഉമ്മ അവനെ പ്രസവിച്ച ദിവസത്തേതു പോലെയാണ്." <span class="c2">(ബുഖാരി)</span><br /> ഉമ്മ പ്രസവിച്ച ദിവസത്തേതു പോലെ\' എന്നാൽ ഒരു തെറ്റുമില്ലാതെ തിരിച്ചു വരും എന്നാണർത്ഥം. </p>',
            ],
            44 => [
                'question' => 'ചോദ്യം 45: എന്താണ് ഉംറ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5600.mp3',
                'answer' => '<p> ഉത്തരം: അല്ലാഹുവിൻ്റെ പരിശുദ്ധ ഭവനമായ കഅ്ബയെ ലക്ഷ്യം വെച്ചു കൊണ്ട് പുറപ്പെടുകയും, നിശ്ചിതമായ ആരാധനകൾ നിർവ്വഹിക്കുകയും ചെയ്തു കൊണ്ട് അല്ലാഹുവിനെ ആരാധിക്കുക എന്നതാണ് ഉംറ. ഇതിന് പ്രത്യേക സമയമില്ല. ഏത് കാലത്തും ഉംറ നിർവഹിക്കാം. </p>',
            ],
            45 => [
                'question' => 'ചോദ്യം 46: ഉംറയുടെ സ്തംഭങ്ങൾ ഏതെല്ലാമാണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5630.mp3',
                'answer' => '<p> 1- ഇഹ്റാം കെട്ടൽ.<br /> <br /> 2- കഅ്ബ ത്വവാഫ് ചെയ്യൽ.<br /> <br /> 4- സ്വഫാ മർവക്കിടയിലുള്ള നടത്തം. </p>',
            ],
            46 => [
                'question' => 'ചോദ്യം 47: അല്ലാഹുവിൻ്റെ മാർഗത്തിലുള്ള ജിഹാദ് എന്നത് കൊണ്ട് ഉദ്ദേശ്യം എന്താണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5690.mp3',
                'answer' => '<p> ഉത്തരം: ഇസ്ലാമിൻ്റെ പ്രചാരണത്തിന് വേണ്ടി സാധ്യമായ പരിശ്രമമെല്ലാം നടത്തുന്നതിനും, ഇസ്ലാമിനെയും മുസ്ലിംകളെയും പ്രതിരോധിക്കുന്നതിനുമാണ് ജിഹാദ് എന്ന് പറയുക. ഇസ്ലാമിനും മുസ്ലിംകൾക്കെതിരെ നിലകൊള്ളുന്ന ശത്രുക്കൾക്കെതിരെയുള്ള യുദ്ധത്തിനും ജിഹാദ് എന്ന് പറയും.<span class="c6"><br /> <br /> അല്ലാഹു പറയുന്നു:</span> "നിങ്ങളുടെ സ്വത്തുക്കൾ കൊണ്ടും ശരീരങ്ങൾ കൊണ്ടും അല്ലാഹുവിൻ്റെ മാർഗത്തിൽ നിങ്ങൾ ജിഹാദ് നടത്തുക. അതാണ് നിങ്ങൾക്ക് ഉത്തമം. നിങ്ങൾ മനസ്സിലാക്കുന്നുണ്ടെങ്കിൽ." <span class="c2">(തൗബ: 41)</span> </p>',
            ],
        ],
        3 => [
            0 => [
                'question' => 'ചോദ്യം 1: നമ്മുടെ നബിയുടെ -ﷺ- കുടുംബപരമ്പര പറയുക.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5740.mp3',
                'answer' => '<p> ഉത്തരം: മുഹമ്മദ് ബ്നു അബ്ദില്ലാഹി ബ്നി അബ്ദിൽ മുത്വലിബ് ബ്നി ഹാശിം. ഹാശിം ഖുറൈശിയും ഖുറൈശികൾ അറബികളിൽ പെട്ടവരുമാകുന്നു. അറബികൾ ഇബ്റാഹീം നബി<span class="c2">(عليه السلام)</span> യുടെ പുത്രൻ ഇസ്മാഈൽ<span class="c2">(عليه السلام)</span> ൻ്റെ സന്താന പരമ്പരയിൽ പെട്ടവരാണ്. നമ്മുടെ നബിയുടെ മേൽ അല്ലാഹുവിൻ്റെ രക്ഷയും കരുണയുമുണ്ടാവട്ടെ. </p>',
            ],
            1 => [
                'question' => 'ചോദ്യം 2: നമ്മുടെ നബിയുടെ -ﷺ- ഉമ്മയുടെ പേരെന്താണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5770.mp3',
                'answer' => '<p> ഉത്തരം: ആമിനഃ ബിൻത് വഹബ്. </p>',
            ],
            2 => [
                'question' => 'ചോദ്യം 3: എപ്പോഴാണ് നബി -ﷺ- യുടെ പിതാവ് മരണപ്പെട്ടത്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5800.mp3',
                'answer' => '<p> ഉത്തരം: മദീനയിൽ വെച്ചാണ് അവിടുത്തെ പിതാവ് മരണപ്പെട്ടത്. പിതാവ് മരിക്കുന്ന സന്ദർഭത്തിൽ അവിടുന്ന് ഗർഭസ്ഥശിശുവായിരുന്നു. </p>',
            ],
            3 => [
                'question' => 'ചോദ്യം 4: എന്നാണ് നബി -ﷺ- ജനിച്ചത്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5830.mp3',
                'answer' => '<p> ഉത്തരം: അബ്രഹതും കൂട്ടരും കഅ്ബ തകർക്കാൻ വന്ന വർഷമായ \'ആമുൽ ഫീലിൽ\', റബീഉൽ അവ്വൽ മാസത്തിൽ ഒരു തിങ്കളാഴ്ച്ചയാണ് അവിടുന്ന് ജനിച്ചത്. </p>',
            ],
            4 => [
                'question' => 'ചോദ്യം 5: ഏതു നാട്ടിലാണ് നബി -ﷺ- ജനിച്ചത്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5850.mp3',
                'answer' => '<p> ഉത്തരം: മക്കയിൽ. </p>',
            ],
            5 => [
                'question' => 'ചോദ്യം 6: നബി -ﷺ- യുടെ മാതാവിന് പുറമെ അവിടുത്തേക്ക് മുലപ്പാൽ നൽകിയവർ ആരെല്ലാമാണ്? അവിടുത്തെ വളർത്തുമ്മമാർ ആരെല്ലാമാണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5880.mp3',
                'answer' => '<p> ഉത്തരം: നബി -ﷺ- യുടെ പിതാവിൻ്റെ അടിമയായിരുന്ന ഉമ്മു അയ്മൻ.<br /> <br /> നബി -ﷺ- യുടെ പിതൃസഹോദരനായിരുന്ന അബൂ ലഹബിൻ്റെ അടിമ, ഥുവയ്ബഃ.<br /> <br /> ഹലീമഃ സഅ്ദിയ്യഃ. </p>',
            ],
            6 => [
                'question' => 'ചോദ്യം 7: നബി -ﷺ- യുടെ മാതാവ് എപ്പോഴാണ് മരണപ്പെട്ടത്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5930.mp3',
                'answer' => '<p> ഉത്തരം: നബി -ﷺ- ക്ക് ആറു വയസ്സുള്ളപ്പോഴാണ് അവിടുത്തെ മാതാവ് മരണപ്പെട്ടത്. പിന്നീട് അവിടുത്തെ പിതാമഹനായ അബ്ദുൽ മുത്വലിബാണ് അവിടുത്തെ എടുത്തു വളർത്തിയത്. </p>',
            ],
            7 => [
                'question' => 'ചോദ്യം 8: അബ്ദുൽ മുത്വലിബിൻ്റെ മരണശേഷം ആരാണ് നബി -ﷺ- യെ എടുത്തു വളർത്തിയത്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5960.mp3',
                'answer' => '<p> ഉത്തരം: നബി -ﷺ- ക്ക് എട്ടു വയസ്സുള്ളപ്പോൾ അബ്ദുൽ മുത്വലിബ് മരണപ്പെട്ടു. ശേഷം അവിടുത്തെ പിതൃസഹോദരനായ അബൂ ത്വാലിബാണ് നബി -ﷺ- യെ എടുത്തു വളർത്തിയത്. </p>',
            ],
            8 => [
                'question' => 'ചോദ്യം 9: തൻ്റെ പിതൃസഹോദരനോടൊപ്പം എത്രാമത്തെ വയസ്സിലാണ് നബി -ﷺ- ശാമിലേക്ക് യാത്ര പോയത്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5990.mp3',
                'answer' => '<p> ഉത്തരം: നബി -ﷺ- ക്ക് പന്ത്രണ്ട് വയസ്സുള്ളപ്പോഴാണ് അവിടുന്ന് അബൂ ത്വാലിബിനോടൊപ്പം ശാമിലേക്ക് യാത്ര പോയത്. </p>',
            ],
            9 => [
                'question' => 'ചോദ്യം 10: നബി -ﷺ- യുടെ രണ്ടാമത്തെ യാത്ര എപ്പോഴായിരുന്നു?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6020.mp3',
                'answer' => '<p> ഉത്തരം: ഖദീജഃ -رَضِيَ اللَّهُ عَنْهَا- യുടെ കച്ചവട സ്വത്തുമായാണ് അവിടുന്ന് രണ്ടാമത്തെ യാത്ര നടത്തിയത്. ഈ യാത്ര കഴിഞ്ഞു വന്ന ശേഷമാണ് അവിടുന്ന് ഖദീജഃ -رَضِيَ اللَّهُ عَنْهَا- യെ വിവാഹം കഴിച്ചത്. നബി -ﷺ- ക്ക് വിവാഹ സമയത്ത് ഇരുപത്തി അഞ്ച് വയസ്സ് പ്രായമുണ്ടായിരുന്നു. </p>',
            ],
            10 => [
                'question' => 'ചോദ്യം 11: ഖുറൈശികൾ കഅ്ബയുടെ പുനർനിർമ്മാണം നടത്തിയത് എപ്പോഴായിരുന്നു?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6050.mp3',
                'answer' => '<p> ഉത്തരം: ഖുറൈശികൾ കഅ്ബ പുനർനിർമ്മിച്ചത് നബി -ﷺ- ക്ക് മുപ്പത്തി അഞ്ച് വയസ്സ് പ്രായമുള്ളപ്പോഴാണ്.<br /> <br /> ഹജറുൽ അസ്വദ് കഅ്ബക്കുള്ളിലേക്ക് വെക്കേണ്ടത് ആരാണെന്ന കാര്യത്തിൽ ഖുറൈശികൾ ഭിന്നിച്ചപ്പോൾ നബി -ﷺ- യെയാണ് അവർ തങ്ങളുടെ വിധികർത്താവാക്കിയത്. അവിടുന്ന് ഹജറുൽ അസ്വദ് ഒരു വിരിപ്പിൽ വെക്കുകയും,ഖുറൈശികളിലെ നാല് ഗോത്രനേതാക്കന്മാരോടും തുണിയുടെ ഓരോ ഭാഗം പിടിക്കാൻ പറയുകയും, അവർ അത് എടുത്ത് കൊണ്ടുപോയി അതിൻ്റെ സ്ഥാനത്തേക്ക് എത്തിക്കുകയും ചെയ്തു. ശേഷം നബി -ﷺ- തൻ്റെ തിരുകരങ്ങൾ കൊണ്ട് അത് എടുത്തു വെക്കുകയും ചെയ്തു. </p>',
            ],
            11 => [
                'question' => 'ചോദ്യം 12: നബി -ﷺ- പ്രവാചകനായി നിയോഗിക്കപ്പെടുന്ന സമയം അവിടുത്തേക്ക് എത്ര വയസ്സുണ്ടായിരുന്നു? അവിടുന്ന് ആരിലേക്കെല്ലാമാണ് നിയോഗിക്കപ്പെട്ടത്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6080.mp3',
                'answer' => '<p> ഉത്തരം: അവിടുന്ന് നബിയാകുമ്പോൾ നാൽപ്പത് വയസ്സായിരുന്നു. എല്ലാ ജനങ്ങളിലേക്കുമുള്ള പ്രവാചകനായാണ് അവിടുത്തെ നിയോഗിച്ചിരിക്കുന്നത്. </p>',
            ],
            12 => [
                'question' => 'ചോദ്യം 13: നബി -ﷺ- ക്ക് അല്ലാഹുവിൽ നിന്നുള്ള സന്ദേശങ്ങൾ ലഭിച്ചു തുടങ്ങുന്നതിൻ്റെ ആരംഭം എങ്ങനെയായിരുന്നു?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6110.mp3',
                'answer' => '<p> ഉത്തരം: നല്ല സ്വപ്നങ്ങളായിരുന്നു ആദ്യത്തെ അടയാളം. അവിടുന്ന് ഏതൊരു സ്വപ്നം കണ്ടാലും അത് നേർക്കുനേരെ പുലർന്നു കാണുമായിരുന്നു. </p>',
            ],
            13 => [
                'question' => 'ചോദ്യം 14: നബി -ﷺ- ക്ക് അല്ലാഹുവിൽ നിന്നുള്ള സന്ദേശമായ വഹ്\'യ് ലഭിക്കുന്നതിന് മുൻപ് അവിടുത്തെ അവസ്ഥ എന്തായിരുന്നു? എപ്പോഴാണ് ആദ്യമായി അവിടുത്തേക്ക് വഹ്\'യ് ലഭിച്ചത്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6140.mp3',
                'answer' => '<p> ഉത്തരം: നബി -ﷺ- ഹിറാ ഗുഹയിൽ അല്ലാഹുവിനെ ആരാധിച്ചു കൊണ്ട് കഴിഞ്ഞു കൂടുകയായിരുന്നു പതിവ്.<br /> <br /> ഗുഹയിൽ ഇപ്രകാരം ഇരിക്കുന്ന സന്ദർഭങ്ങളിലൊന്നിലാണ് അവിടുത്തെ മേൽ അല്ലാഹുവിൻ്റെ സന്ദേശം വന്നെത്തിയത്. </p>',
            ],
            14 => [
                'question' => 'ചോദ്യം 15: നബി -ﷺ- ക്ക് ആദ്യമായി അവതരിച്ച ഖുർആൻ വചനങ്ങൾ ഏതാണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6180.mp3',
                'answer' => '<p> ഉത്തരം: അല്ലാഹുവിൻ്റെ ഈ വചനങ്ങളാണത്: "സൃഷ്ടിച്ചവനായ നിൻ്റെ റബ്ബിൻ്റെ നാമത്തിൽ വായിക്കുക. മനുഷ്യനെ അവൻ ഭ്രൂണത്തിൽ നിന്ന് സൃഷ്ടിച്ചിരിക്കുന്നു. നീ വായിക്കുക നിൻ്റെ റബ്ബ് ഏറ്റവും വലിയ ഔദാര്യവാനാകുന്നു. പേന കൊണ്ട് പഠിപ്പിച്ചവൻ. മനുഷ്യന് അറിയാത്തത് അവൻ പഠിപ്പിച്ചിരിക്കുന്നു." <span class="c5">[സൂറത്തുൽ അലഖ്: 1-5]</span> </p>',
            ],
            15 => [
                'question' => 'ചോദ്യം 16: നബി -ﷺ- യിൽ ആദ്യമായി വിശ്വസിച്ചത് ആരെല്ലാമാണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6200.mp3',
                'answer' => '<p> ഉത്തരം: നബി -ﷺ- യിൽ ആദ്യമായി വിശ്വസിച്ച പുരുഷൻ അബൂബക്ർ സിദ്ധീഖ് -رَضِيَ اللَّهُ عَنْهُ- വാണ്. സ്ത്രീകളിൽ ആദ്യം വിശ്വസിച്ചത് ഖദീജഃ -رَضِيَ اللَّهُ عَنْهَا- യാണ്. കുട്ടികളിൽ ആദ്യം വിശ്വസിച്ചത് അലി ബ്നു അബീ ത്വാലിബ് -رَضِيَ اللَّهُ عَنْهُ- വാണ്. മോചിതരായ അടിമകളിൽ ആദ്യം വിശ്വസിച്ചത് സയ്ദ് ബ്നു ഹാരിഥ -رَضِيَ اللَّهُ عَنْهُ- യാണ്. അടിമകളിൽ ആദ്യമായി വിശ്വസിച്ചത് ബിലാൽ ബ്നു റബാഹ് -رَضِيَ اللَّهُ عَنْهُ- വാണ്. </p>',
            ],
            16 => [
                'question' => 'ചോദ്യം 17: എങ്ങനെയായിരുന്നു ഇസ്ലാമിലേക്ക് നബി -ﷺ- പ്രബോധനം നടത്തിയത്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6230.mp3',
                'answer' => '<p> ഉത്തരം: മൂന്ന് വർഷക്കാലത്തോളം രഹസ്യമായാണ് നബി -ﷺ- പ്രബോധനം നടത്തിയത്. ശേഷം അല്ലാഹു അവിടുത്തോട് പ്രബോധനം പരസ്യമാക്കാൻ കൽപ്പിച്ചു. </p>',
            ],
            17 => [
                'question' => 'ചോദ്യം 18: പ്രബോധനം പരസ്യമാക്കിയതിന് ശേഷം നബി -ﷺ- യുടെയും അവിടുത്തെ പ്രബോധനത്തിൽ വിശ്വസിച്ചവരുടെയും അവസ്ഥ എന്തായിരുന്നു?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6260.mp3',
                'answer' => '<p> ഉത്തരം: നബി -ﷺ- യെയും മുസ്ലിംകളെയും ഇതോടു കൂടെ മുശ്രിക്കുകൾ കഠിനമായി ഉപദ്രവിച്ചു. പ്രയാസങ്ങൾ കടുത്തതോടെ നജ്ജാശിയുടെ ഭരണത്തിന് കീഴിലുള്ള അബ്സീനിയ എന്ന രാജ്യത്തേക്ക് പലായനം ചെയ്യാൻ അല്ലാഹു മുസ്ലിംകൾക്ക് അനുവാദം നൽകി.<br /> <br /> എന്നാൽ നബി -ﷺ- യെ ഉപദ്രവിക്കാനും അവിടുത്തെ കൊലപ്പെടുത്താനും മുശ്രിക്കുകൾ എല്ലാവരും ഒത്തുചേർന്നു. അല്ലാഹു അവരിൽ നിന്ന് അബൂത്വാലിബ് മുഖേന നബി -ﷺ- യെ കാത്തുരക്ഷിച്ചു. </p>',
            ],
            18 => [
                'question' => 'ചോദ്യം 19: നബി -ﷺ- ക്ക് പ്രവാചകത്വം ലഭിച്ചതിന് പത്തു വർഷങ്ങൾക്ക് ശേഷം മരണപ്പെട്ട രണ്ടു പേർ ആരെല്ലാമാണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6300.mp3',
                'answer' => '<p> ഉത്തരം: നബി -ﷺ- യുടെ പിതൃസഹോദരനായ അബൂ ത്വാലിബും, അവിടുത്തെ പത്നിയായ ഖദീജഃ -رَضِيَ اللَّهُ عَنْهَا- യും ഈ വർഷത്തിലാണ് മരണപ്പെട്ടത്. </p>',
            ],
            19 => [
                'question' => 'ചോദ്യം 20: എപ്പോഴായിരുന്നു ഇസ്റാഉം മിഅ്റാജും നടന്നത്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6330.mp3',
                'answer' => '<p> ഉത്തരം: നബി -ﷺ- ക്ക് അൻപതു വയസ്സുള്ളപ്പോഴാണ് ഇസ്റാഉം മിഅ്റാജും നടന്നത്.<br /> <br /> ഇസ്റാഅ് എന്നാൽ മസ്ജിദുൽ ഹറമിൽ നിന്ന് ബയ്തുൽ മഖ്ദിസിലേക്ക് ഒരു രാത്രി കൊണ്ട് നടത്തിയ യാത്രയാണ്.<br /> <br /> മിഅ്റാജ് എന്നാൽ മസ്ജിദുൽ അഖ്സ്വായിൽ നിന്ന് ആകാശ ലോകത്തുള്ള സിദ്റതുൽ മുൻതഹാ വരെ നടത്തിയ യാത്രയുമാണ്. </p>',
            ],
            20 => [
                'question' => 'ചോദ്യം 21: മക്കയുടെ പുറത്ത് എങ്ങനെയായിരുന്നു നബി -ﷺ- ജനങ്ങളെ ദീനിലേക്ക് ക്ഷണിച്ചിരുന്നത്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6380.mp3',
                'answer' => '<p> ഉത്തരം: നബി -ﷺ- ത്വാഇഫിലെ ജനങ്ങളെ ഇസ്ലാമിലേക്ക് ക്ഷണിക്കുമായിരുന്നു. അതോടൊപ്പം ഹജ്ജിൻ്റെ സന്ദർഭങ്ങളിലും ജനങ്ങൾ ഒരുമിച്ചു കൂടുന്ന വേളകളിലും അവിടുന്ന് ഇസ്ലാമിലേക്ക് അവരെ ക്ഷണിക്കുമായിരുന്നു. അങ്ങനെയിരിക്കെ മദീനയിൽ നിന്ന് അൻസ്വാരികൾ വന്നെത്തി. അവർ നബി -ﷺ- യിൽ വിശ്വസിക്കുകയും, അവിടുത്തെ സഹായിക്കാം എന്ന് കരാർ നൽകുകയും ചെയ്തു. </p>',
            ],
            21 => [
                'question' => 'ചോദ്യം 22: നബി -ﷺ- എത്ര കാലമാണ് മക്കയിൽ തൻ്റെ പ്രബോധനം നിർവ്വഹിച്ചത്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6410.mp3',
                'answer' => '<p> ഉത്തരം: നബി -ﷺ- പതിമൂന്ന് വർഷം മക്കയിൽ പ്രബോധനം നടത്തിയിട്ടുണ്ട്. </p>',
            ],
            22 => [
                'question' => 'ചോദ്യം 23: നബി -ﷺ- എവിടേക്കാണ് ഹിജ്റ (പലായനം) ചെയ്തത്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6440.mp3',
                'answer' => '<p> ഉത്തരം: മക്കയിൽ നിന്ന് മദീനയിലേക്കാണ് നബി -ﷺ- ഹിജ്റ ചെയ്തത്. </p>',
            ],
            23 => [
                'question' => 'ചോദ്യം 24: എത്ര കാലമാണ് നബി -ﷺ- മദീനയിൽ ജീവിച്ചത്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6470.mp3',
                'answer' => '<p> ഉത്തരം: പത്തു വർഷം. </p>',
            ],
            24 => [
                'question' => 'ചോദ്യം 25: മദീനയിലായിരിക്കെ നബി -ﷺ- ക്ക് മേൽ നിർബന്ധമാക്കപ്പെട്ട കർമ്മങ്ങൾ ഏതെല്ലാമാണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6490.mp3',
                'answer' => '<p> ഉത്തരം: സകാത്ത്, നോമ്പ്, ഹജ്ജ്, ജിഹാദ്, ബാങ്ക് വിളി എന്നിങ്ങനെയുള്ള നിയമങ്ങൾ മദീനയിൽ വെച്ചാണ് നിർബന്ധമാക്കപ്പെട്ടത്. </p>',
            ],
            25 => [
                'question' => 'ചോദ്യം 26: നബി -ﷺ- യുടെ ജീവിതത്തിലെ പ്രധാനപ്പെട്ട യുദ്ധങ്ങൾ ഏതെല്ലാമാണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6520.mp3',
                'answer' => '<p> ഉത്തരം: ബദ്ർ യുദ്ധം.<br /> <br /> ഉഹ്ദ് യുദ്ധം.<br /> <br /> അഹ്സാബ് യുദ്ധം.<br /> <br /> മക്കാ വിജയത്തിലേക്ക് നയിച്ച സൈനിക നീക്കം. </p>',
            ],
            26 => [
                'question' => 'ചോദ്യം 27: ഖുർആനിൽ അവസാനമായി അവതരിച്ച വചനം ഏതാണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6580.mp3',
                'answer' => '<p> ഉത്തരം: അല്ലാഹുവിൻ്റെ ഈ വചനങ്ങളാണത്: "അല്ലാഹുവിലേക്ക് നിങ്ങൾ മടക്കപ്പെടുന്ന ഒരു ദിവസത്തെ നിങ്ങൾ സൂക്ഷിക്കുക! എന്നിട്ട് ഓരോരുത്തർക്കും അവരവർ പ്രവർത്തിച്ചതിൻ്റെ ഫലം പൂർണ്ണമായി നൽകപ്പെടുന്നതാണ്. അവരോട് <span class="c2">(ഒട്ടും)</span> അനീതി കാണിക്കപ്പെടുകയില്ല." <span class="c2">(ബഖറ: 281)</span> </p>',
            ],
            27 => [
                'question' => 'ചോദ്യം 28: നബി -ﷺ- എപ്പോഴാണ് വഫാത്തായത്? എത്രാമത്തെ വയസ്സിലായിരുന്നു അത്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6610.mp3',
                'answer' => '<p> ഉത്തരം: റബീഉൽ അവ്വൽ മാസത്തിലാണ് നബി -ﷺ- വഫാത്തായത്. ഹിജ്റ നടന്നതിന് ശേഷമുള്ള പതിനൊന്നാമത്തെ വർഷമായിരുന്നു അത്. നബി -ﷺ- ക്ക് 63 വയസ്സുള്ളപ്പോഴാണ് അവിടുന്ന് വഫാത്തായത്. </p>',
            ],
            28 => [
                'question' => 'ചോദ്യം 29: നബി -ﷺ- യുടെ ഭാര്യമാരുടെ പേരുകൾ പറയുക.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6640.mp3',
                'answer' => '<p> ഉത്തരം: 1- ഖദീജഃ ബിൻത് ഖുവൈലിദ് -رَضِيَ اللَّهُ عَنْهَا-<br /> <br /> 2- സൗദ ബിൻത് സംഅഃ -رَضِيَ اللَّهُ عَنْهَا-<br /> <br /> 3- ആയിഷ ബിൻത് അബീബക്കർ സിദ്ധീഖ് -رضي الله عنهما-<br /> <br /> 4- ഫഫ്സ്വ ബിൻത് ഉമർ -رَضِيَ اللَّهُ عَنْهَا-<br /> <br /> 5- സൈനബ് ബിൻത് ഖുസൈമഃ -رضي الله عنها-<br /> <br /> 6- ഉമ്മു സലമഃ ഹിന്ദ് ബിൻത് അബീ ഉമയ്യഃ -رَضِيَ اللَّهُ عَنْهَا-<br /> <br /> 7- ഉമ്മുഹബീബ റംലഃ ബിൻത് അബീസുഫ്യാൻ -رضي الله عنها-<br /> <br /> 8- ജുവൈരിയ്യ ബിൻതുൽ ഹാരിസ് -رضي الله عنها-<br /> <br /> 9- മൈമൂന ബിൻതുൽ ഹാരിസ് -رضي الله عنها-<br /> <br /> 10- സ്വഫിയ്യ ബിൻത് ഹുയയ്യ് -رضي الله عنها-<br /> <br /> 11- സയ്നബ് ബിൻത് ജഹ്ശ് -رضي الله عنها- </p>',
            ],
            29 => [
                'question' => 'ചോദ്യം 30: നബി -ﷺ- യുടെ മക്കളുടെ പേരുകൾ പറയുക!',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6760.mp3',
                'answer' => '<p> ഉത്തരം: അവിടുത്തേക്ക് മൂന്ന് ആണ്മക്കളുണ്ടായിരുന്നു.<br /> <br /> ഖാസിം; ഈ പേര് ചേർത്തു കൊണ്ട് അവിടുത്തെ അബൂ ഖാസിം എന്ന് വിളിക്കാറുണ്ടായിരുന്നു.<br /> <br /> അബ്ദുല്ലാഹ്.<br /> <br /> ഇബ്രാഹീം.<br /> <br /> നബി -ﷺ-<span class="c6"> യുടെ പെണ്മക്കൾ ഇവരാണ്:</span><br /> <br /> ഫാത്വിമ -رَضِيَ اللَّهُ عَنْهَا-<br /> <br /> റുഖയ്യഃ -رَضِيَ اللَّهُ عَنْهَا-<br /> <br /> ഉമ്മു കുൽഥൂം -رَضِيَ اللَّهُ عَنْهَا-<br /> <br /> സയ്നബ് -رَضِيَ اللَّهُ عَنْهَا-<br /> <br /> നബി -ﷺ- യുടെ മക്കളെല്ലാം ഖദീജഃ -رَضِيَ اللَّهُ عَنْهَا- യിൽ നിന്നായിരുന്നു; ഇബ്രാഹീം ഒഴികെ. നബി -ﷺ- യുടെ മരണത്തിന് മുൻപ് അവിടുത്തെ മക്കളെല്ലാം മരണപ്പെട്ടിട്ടുണ്ട്; ഫാത്വിമഃ ഒഴികെ. അവിടുന്ന് വഫാത്തായതിന് ആറു മാസങ്ങൾക്ക് ശേഷം അവർ മരണപ്പെട്ടു. </p>',
            ],
            30 => [
                'question' => 'ചോദ്യം 31: നബി -ﷺ- യുടെ ചില ശാരീരിക പ്രത്യേകതകൾ പറയൂ.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6880.mp3',
                'answer' => '<p> ഉത്തരം: നബി -ﷺ- ഒത്ത ശരീരപ്രകൃതിയുള്ളവരായിരുന്നു. അവിടുന്ന് കുറിയവരോ ഏറെ നീളമുള്ളവരോ ആയിരുന്നില്ല; മറിച്ച് അതിനിടയിലായിരുന്നു. അവിടുന്ന് ചുവപ്പ് കലർന്ന വെളുപ്പുള്ള നിറമായിരുന്നു. തിങ്ങിയ താടിയും അവിടുത്തേക്കുണ്ടായിരുന്നു. വിശാലമായ നയനങ്ങളും, വലിപ്പമുള്ള വായയും, വിശാലമായ മുതുകും, കറുത്ത മുടിയിഴകളുമായിരുന്നു അവിടുത്തേക്കുണ്ടായിരുന്നത്. സുഗന്ധമേറിയ ശരീരവുമായിരുന്നു അവിടുത്തേത്. സുന്ദരമായ ശരീരപ്രകൃതിയുള്ളവരായിരുന്നു അവിടുന്ന്. </p>',
            ],
            31 => [
                'question' => 'ചോദ്യം 31: നബി -ﷺ- തൻ്റെ ഉമ്മത്തിനെ വിട്ടേച്ചു പോയത് ഏതു കാര്യത്തിലാണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6910.mp3',
                'answer' => '<p> ഉത്തരം: പ്രകാശപൂരിതമായ മാർഗത്തിലാണ് അവിടുന്ന് തൻ്റെ ഉമ്മത്തിനെ വിട്ടേച്ചു പോയത്. അതിലെ രാത്രികൾ പോലും പകലുകൾ പോലെ പ്രകാശമുള്ളതാണ്. ഒരു നന്മയും തൻ്റെ ഉമ്മത്തിന് അറിയിച്ചു നൽകാതെ അവിടുന്ന് ഉപേക്ഷിച്ചിട്ടില്ല. ഒരു തിന്മയും അവിടുന്ന് തൻ്റെ ഉമ്മത്തിനെ താക്കീത് ചെയ്യാതെ വിട്ടിട്ടില്ല. </p>',
            ],
        ],
        4 => [
            0 => [
                'question' => 'ചോദ്യം 1: സൂറതുൽ ഫാതിഹഃ ഓതുകയും, അതിൻ്റെ വിശദീകരണം പറയുകയും ചെയ്യുക.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6960.mp3',
                'answer' => '<p> ഉത്തരം: സൂറത്തുൽ ഫാതിഹഃയിലെ ആയത്തുകളും, അവയുടെ വിശദീകരണവും ഇപ്രകാരമാണ്.<br /> <br /> പരമകാരുണികനും കരുണാനിധിയുമായ അല്ലാഹുവിൻ്റെ നാമത്തിൽ. സർവ്വ സ്തുതികളും സർവ്വലോക പരിപാലകനായ അല്ലാഹുവിനാകുന്നു. സർവ്വ വിശാലമായ കാരുണ്യമുള്ളവനും, അങ്ങേയറ്റം കരുണ ചൊരിയുന്നവനുമായ <span class="c2">(അല്ലാഹുവിന്)</span>. പ്രതിഫല ദിവസത്തിൻ്റെ ഉടമസ്ഥനായ <span class="c2">(അല്ലാഹുവിന്)</span>. നിന്നെ മാത്രം ഞങ്ങൾ ആരാധിക്കുന്നു. നിന്നോട് മാത്രം ഞങ്ങൾ സഹായം തേടുന്നു. ഞങ്ങളെ നീ നേരായ മാർഗത്തിൽ <span class="c2">(ഇസ്ലാമിൽ)</span> ചേർക്കേണമേ. നീ അനുഗ്രഹിച്ചവരുടെ മാർഗത്തിൽ. കോപത്തിന്ന് ഇരയായവരുടെ മാർഗത്തിലല്ല. പിഴച്ചുപോയവരുടെ മാർഗത്തിലുമല്ല. <span class="c2">(ഫാതിഹഃ: 1-7)</span><br /> ഫാതിഹഃയുടെ വിശദീകരണം:<br /> <br /> വിശുദ്ധ ഖുർആനിൻ്റെ പ്രാരംഭം ഫാതിഹഃ സൂറത്ത് കൊണ്ടാണ് എന്നതിനാലാണ് ഈ അർത്ഥം വരുന്ന ഫാതിഹഃ എന്ന പേര് ഈ അദ്ധ്യായത്തിന് നൽകപ്പെട്ടത്.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001001.mp3"></audio> 1- അല്ലാഹുവിൻ്റെ നാമം ഉച്ചരിച്ചു കൊണ്ട് ഞാൻ ഖുർആൻ പാരായണം ആരംഭിക്കുന്നു. അവനോട് ഞാൻ സഹായം തേടുകയും, അവൻ്റെ പേര് ഉച്ചരിച്ചു കൊണ്ട് ബറകത്ത് <span class="c2">(അനുഗ്രഹം)</span> തേടുകയും ചെയ്യുന്നു.<br /> <br /> യഥാർത്ഥ ആരാധ്യൻ എന്നാണ് അല്ലാഹു എന്ന പേരിൻ്റെ അർത്ഥം. ഈ പേര് അല്ലാഹുവിനല്ലാതെ മറ്റാർക്കുമില്ല.<br /> <br /> അർ-റഹ്മാൻ എന്നാൽ സർവ്വതിനെയും വിശാലമായി ചൂഴ്ന്നിരിക്കുന്ന, മഹത്തരമായ കാരുണ്യത്തിൻ്റെ ഉടമ എന്നാണർത്ഥം.<br /> <br /> അർ-റഹീം എന്നാൽ അല്ലാഹുവിൽ വിശ്വസിച്ചവർക്ക് മേൽ ധാരാളമായി കരുണ ചൊരിയുന്നവൻ എന്നാണർത്ഥം.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001002.mp3"></audio> 2- എല്ലാ തരത്തിലുള്ള സ്തുതികളും നല്ല വാക്കുകളും അല്ലാഹുവിന് മാത്രമാകുന്നു.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001003.mp3"></audio> 3- അർ-റഹ്മാൻ എന്നാൽ സർവ്വതിനെയും വിശാലമായി ചൂഴ്ന്നിരിക്കുന്ന, മഹത്തരമായ കാരുണ്യത്തിൻ്റെ ഉടമ എന്നാണർത്ഥം. അർ-റഹീം എന്നാൽ അല്ലാഹുവിൽ വിശ്വസിച്ചവർക്ക് മേൽ ധാരാളമായി കരുണ ചൊരിയുന്നവൻ എന്നാണർത്ഥം.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001004.mp3"></audio> 4- പ്രതിഫലനാൾ എന്നാൽ ഖിയാമത്ത് നാളാണ് ഉദ്ദേശ്യം.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001005.mp3"></audio> 5- "നിന്നെ മാത്രം ഞങ്ങൾ ആരാധിക്കുന്നു. നിന്നോട് മാത്രം ഞങ്ങൾ സഹായം തേടുന്നു." അല്ലാഹുവേ! നിനക്ക് മാത്രമേ ഞങ്ങൾ ആരാധനകൾ നൽകുകയുള്ളൂ. നിന്നോട് മാത്രമേ ഞങ്ങൾ സഹായം ചോദിക്കുകയുള്ളൂ.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001006.mp3"></audio> 6- "ഞങ്ങളെ നീ നേരായ മാർഗത്തിൽ <span class="c2">(ഇസ്ലാമിൽ)</span> ചേർക്കേണമേ." ഇസ്ലാമിലേക്കും അഹ്ലുസ്സുന്നത്തിലേക്കും ഞങ്ങളെ നയിക്കേണമേ എന്നർത്ഥം.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001007.mp3"></audio> 7- "നീ അനുഗ്രഹിച്ചവരുടെ മാർഗത്തിൽ. കോപത്തിന്ന് ഇരയായവരുടെ മാർഗത്തിലല്ല. പിഴച്ചുപോയവരുടെ മാർഗത്തിലുമല്ല." - നബിമാരുടെയും, അവരെ പിൻപറ്റിയ അല്ലാഹുവിൻ്റെ സച്ചരിതരായ ദാസന്മാരുടെയും വഴിയിലേക്ക് ഞങ്ങളെ നയിക്കേണമേ! നസ്വാറാക്കളുടെയോ യഹൂദരുടെയോ വഴികളിലേക്ക് ഞങ്ങളെ പ്രവേശിപ്പിക്കരുതേ.<br /> <br /> ഫാതിഹഃ ഓതിക്കഴിഞ്ഞാൽ \'ആമീൻ\' എന്ന് പറയൽ സുന്നത്താണ്. അല്ലാഹുവേ! ഞങ്ങളുടെ പ്രാർത്ഥനക്ക് ഉത്തരം നൽകേണമേ! എന്നാണ് അതിൻ്റെ അർത്ഥം. </p>',
            ],
            1 => [
                'question' => 'ചോദ്യം 2: സൂറ. സൽസലഃ പാരായണം ചെയ്യുകയും അതിൻ്റെ വിശദീകരണം പറയുകയും ചെയ്യുക.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7130.mp3',
                'answer' => '<p> ഉത്തരം: സൂറതു സൽസലയിലെ ആയത്തുകളും, അവയുടെ വിശദീകരണവും ഇപ്രകാരമാണ്.<br /> <br /> പരമകാരുണികനും കരുണാനിധിയുമായ അല്ലാഹുവിൻ്റെ നാമത്തിൽ.<br /> <br /> ഭൂമി പ്രകമ്പനം കൊള്ളിക്കപ്പെട്ടാൽ - അതിൻ്റെ ഭയങ്കരമായ ആ പ്രകമ്പനം. ഭൂമി അതിൻ്റെ ഭാരങ്ങൾ പുറം തള്ളുകയും, അതിന് എന്തുപറ്റി എന്ന് മനുഷ്യൻ പറയുകയും ചെയ്താൽ. അന്നേ ദിവസം അത് <span class="c2">(ഭൂമി)</span> അതിൻ്റെ വർത്തമാനങ്ങൾ പറഞ്ഞറിയിക്കുന്നതാണ്. നിൻ്റെ രക്ഷിതാവ് അതിന് ബോധനം നല്കിയത് നിമിത്തം. അന്നേ ദിവസം മനുഷ്യർ പല സംഘങ്ങളായി പുറപ്പെടുന്നതാണ്. അവർക്ക് അവരുടെ കർമ്മങ്ങൾ കാണിക്കപ്പെടേണ്ടതിനായിട്ട്. ആരെങ്കിലും ഒരു ഉറുമ്പിൻ്റെ കാലടിപ്പാടിനോളം നന്മ ചെയ്താൽ അവനത് കാണുന്നതാണ്. ആരെങ്കിലും ഒരു ഉറുമ്പിൻ്റെ കാലടിപ്പാടിനോളം തിന്മ ചെയ്താൽ അവനതും കാണുന്നതാണ്. <span class="c2">(സൽസലഃ: 1-8)</span><br /> സൂറ.<span class="c6"> സൽസലയുടെ വിശദീകരണം:</span><br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099001.mp3"></audio> 1- "ഭൂമി പ്രകമ്പനം കൊള്ളിക്കപ്പെട്ടാൽ - അതിൻ്റെ ഭയങ്കരമായ ആ പ്രകമ്പനം." ഭൂമി ശക്തിയായി പ്രകമ്പനം കൊണ്ടാൽ; അന്ത്യനാളിൽ സംഭവിക്കുന്ന കാര്യമാണിത്.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099002.mp3"></audio> 2- "ഭൂമി അതിൻ്റെ ഭാരങ്ങൾ പുറം തള്ളിയാൽ." ഭൂമിയിൽ മറമാടപ്പെട്ട മനുഷ്യരും മറ്റു വസ്തുക്കളും പുറത്തേക്ക് തള്ളപ്പെട്ടാൽ.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099003.mp3"></audio> 3- "അതിന് എന്തുപറ്റി എന്ന് മനുഷ്യൻ പറയുകയും ചെയ്താൽ." - ഭൂമിക്കെന്താണ് സംഭവിച്ചത്? എന്തു കൊണ്ടാണ് ഇത് ഇളകിമറിയുന്നത് എന്ന് ജനങ്ങൾ അന്നേരം പറയും.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099004.mp3"></audio> 4- "അന്നേ ദിവസം അത് <span class="c2">(ഭൂമി)</span> അതിൻ്റെ വർത്തമാനങ്ങൾ പറഞ്ഞറിയിക്കുന്നതാണ്." ഭൂമി അതിൻ്റെ മുകളിൽവെച്ച് നടമാടിയ നന്മ-തിന്മകളെ കുറിച്ച് സംസാരിക്കുന്നതാണ്.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099005.mp3"></audio> 5- "നിൻ്റെ രക്ഷിതാവ് അതിന് ബോധനം നല്കിയത് നിമിത്തം." കാരണം അല്ലാഹു അപ്രകാരം ചെയ്യാൻ അതിനോട് കൽപ്പിക്കുകയും, അതിന് അറിവ് നൽകുകയും ചെയ്തിരിക്കുന്നു.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099006.mp3"></audio> 6- "അന്നേ ദിവസം മനുഷ്യർ പല സംഘങ്ങളായി പുറപ്പെടുന്നതാണ്. അവർക്ക് അവരുടെ കർമ്മങ്ങൾ കാണിക്കപ്പെടേണ്ടതിനായിട്ട്." ഭൂമി പ്രകമ്പനം കൊള്ളുന്ന ഭയാനകമായ ആ ദിവസത്തിൽ, ജനങ്ങൾ വിചാരണയുടെ വേദിയിൽ നിന്ന് ഇഹലോകത്ത് തങ്ങൾ പ്രവർത്തിച്ചതെന്തോ, അത് സാക്ഷ്യം വഹിക്കുന്നതിനായി വിവിധ വിഭാഗങ്ങളായി പുറപ്പെടുന്നതാണ്.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099007.mp3"></audio> 7- "ആരെങ്കിലും ഒരു ഉറുമ്പിൻ്റെ കാലടിപ്പാടിനോളം നന്മ ചെയ്താൽ അവനത് കാണുന്നതാണ്." എത്ര ചെറിയ നന്മയും സൽകർമ്മവും ചെയ്തിട്ടുണ്ടെങ്കിൽ അവനത് തൻ്റെ കണ്മുന്നിൽ കാണുന്നതാണ്.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099008.mp3"></audio> 8- "ആരെങ്കിലും ഒരു ഉറുമ്പിൻ്റെ കാലടിപ്പാടിനോളം തിന്മ ചെയ്താൽ അവനതും കാണുന്നതാണ്." എന്തെങ്കിലുമൊരു തിന്മ -അതെത്ര ചെറുതാണെങ്കിലും- അവൻ തൻ്റെ കണ്മുന്നിൽ കാണുന്നതാണ്. </p>',
            ],
            2 => [
                'question' => 'ചോദ്യം 3: സൂറ. ആദിയാത്ത് പാരായണം ചെയ്യുകയും അതിൻ്റെ വിശദീകരണം പറയുകയും ചെയ്യുക.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7270.mp3',
                'answer' => '<p> ഉത്തരം: സൂറത്തുൽ ആദിയാത്തിലെ ആയത്തുകളും, അവയുടെ വിശദീകരണവും ഇപ്രകാരമാണ്.<br /> <br /> പരമകാരുണികനും കരുണാനിധിയുമായ അല്ലാഹുവിൻ്റെ നാമത്തിൽ<br /> <br /> കിതച്ചു കൊണ്ട് ഓടുന്നവ തന്നെ സത്യം. അങ്ങനെ <span class="c2">(കുളമ്പ് കല്ലിൽ)</span> ഉരസി തീപ്പൊരി പറപ്പിക്കുന്നവയും, എന്നിട്ട് പ്രഭാതത്തിൽ ആക്രമണം നടത്തുന്നവയും, അന്നേരത്ത് പൊടിപടലം ഇളക്കിവിട്ടവയും, അതിലൂടെ <span class="c2">(ശത്രു)</span> സംഘത്തിൻ്റെ നടുവിൽ പ്രവേശിച്ചവയും <span class="c2">(കുതിരകൾ)</span> തന്നെ സത്യം. തീർച്ചയായും മനുഷ്യൻ തൻ്റെ രക്ഷിതാവിനോട് നന്ദികെട്ടവൻ തന്നെ. തീർച്ചയായും അവൻ അതിന്ന് സാക്ഷ്യം വഹിക്കുന്നവനുമാകുന്നു. തീർച്ചയായും അവന് ധനത്തോടുള്ള സ്നേഹം കഠിനമായവനാകുന്നു. എന്നാൽ അവൻ അറിയുന്നില്ലേ? ഖബ്റുകളിലുള്ളത് ഇളക്കിമറിച്ച് പുറത്ത് കൊണ്ട് വരപ്പെടുകയും ഹൃദയങ്ങളിലുള്ളത് വെളിക്ക് കൊണ്ടു വരപ്പെടുകയും ചെയ്താൽ, തീർച്ചയായും അവരുടെ രക്ഷിതാവ് അന്നേ ദിവസം അവരെ പറ്റി സൂക്ഷ്മമായി അറിയുന്നവൻ തന്നെയാകുന്നു. <span class="c2">(ആദിയാത്ത്: 1-11)</span><br /> വിശദീകരണം:<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100001.mp3"></audio> 1- "കിതച്ചു കൊണ്ട് ഓടുന്നവ തന്നെ സത്യം." - വേഗതയിൽ സഞ്ചരിക്കുന്ന കുതിരകളെ കൊണ്ട് അല്ലാഹു സത്യം ചെയ്തിരിക്കുന്നു. വളരെ വേഗതയിൽ സഞ്ചരിക്കുന്നത് കാരണത്താൽ അതിൻ്റെ കിതപ്പിൻ്റെ ശബ്ദം കേൾക്കുന്നുണ്ട്.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100002.mp3"></audio> 2- "അങ്ങനെ <span class="c2">(കുളമ്പ് കല്ലിൽ)</span> ഉരസി തീപ്പൊരി പറപ്പിക്കുന്നവയും." - പാറക്കല്ലുകൾക്ക് മുകളിൽ കുളമ്പുകൾ ശക്തമായി ഉരസി തീപ്പൊരി പറപ്പിച്ച് കുതിക്കുന്ന കുതിരകളെ കൊണ്ട് അല്ലാഹു സത്യം ചെയ്യുന്നു.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100003.mp3"></audio> 3- "എന്നിട്ട് പ്രഭാതത്തിൽ ആക്രമണം നടത്തുന്നവയും." - പ്രഭാതത്തിൽ ശത്രുക്കൾക്ക് നേരെ കുതിച്ചു പായുന്ന കുതിരകളെ കൊണ്ടും അല്ലാഹു സത്യം ചെയ്തിരിക്കുന്നു.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100004.mp3"></audio> 4- "അന്നേരത്ത് പൊടിപടലം ഇളക്കിവിട്ടവയും." - തങ്ങളുടെ ചലനം കൊണ്ട് അവ പൊടിപറത്തിയിരിക്കുന്നു.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100005.mp3"></audio> 5- "അതിലൂടെ <span class="c2">(ശത്രു)</span> സംഘത്തിൻ്റെ നടുവിൽ പ്രവേശിച്ചവയും <span class="c2">(കുതിരകൾ)</span> തന്നെ സത്യം." - അങ്ങനെ തങ്ങളുടെ മേലിരിക്കുന്ന പടയാളിയെയും കൊണ്ട് ശത്രുസംഘത്തിന് നടുവിൽ അത് പ്രവേശിച്ചിരിക്കുന്നു.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100006.mp3"></audio> 6- "തീർച്ചയായും മനുഷ്യൻ തൻ്റെ രക്ഷിതാവിനോട് നന്ദികെട്ടൻ തന്നെ." - തീർച്ചയായും മനുഷ്യൻ അവൻ്റെ രക്ഷിതാവ് അവനിൽ നിന്ന് ആവശ്യപ്പെടുന്ന നന്മയോട് വളരെ നിഷേധാത്മക സമീപനമുള്ളവൻ തന്നെ.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100007.mp3"></audio> 7- "തീർച്ചയായും അവൻ അതിന്ന് സാക്ഷ്യം വഹിക്കുന്നവനുമാകുന്നു." - താൻ നന്മയോട് വളരെ തടസ്സം കാണിക്കുന്നവനാണ് എന്നതിന് അവൻ സ്വയം തന്നെ സാക്ഷിയാണ്; അത്ര വ്യക്തമാണ് അക്കാര്യം എന്നതിനാൽ അവനത് നിഷേധിക്കുക സാധ്യമല്ല തന്നെ.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100008.mp3"></audio> 8- "തീർച്ചയായും അവന് ധനത്തോടുള്ള സ്നേഹം കഠിനമായവനാകുന്നു." - സമ്പത്തിനോടുള്ള അവൻ്റെ കഠിനമായ സ്നേഹം കാരണത്താൽ അവൻ പിശുക്കനായി തീർന്നിരിക്കുന്നു.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100009.mp3"></audio> 9- "എന്നാൽ അവൻ അറിയുന്നില്ലേ? ഖബ്റുകളിലുള്ളത് ഇളക്കിമറിച്ച് പുറത്ത് കൊണ്ട് വരപ്പെടുകയും." - ഐഹിക ജീവിതത്തിൽ വഞ്ചിതനായിട്ടുള്ള ഈ മനുഷ്യൻ മനസ്സിലാക്കുന്നില്ലേ, അല്ലാഹു ഖബ്റുകളിൽ കിടക്കുന്ന മരിച്ചവരെ തിരിച്ചു കൊണ്ടു വരികയും, വിചാരണക്കും പ്രതിഫലത്തിനുമായി അവരെ ഭൂമിയിൽ നിന്ന് പുറത്തെത്തിക്കുകയും ചെയ്താൽ അവൻ ധരിച്ചു വെച്ചതു പോലെയായിരിക്കില്ല കാര്യമെന്ന്?!<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100010.mp3"></audio> 10- "ഹൃദയങ്ങളിലുള്ളത് വെളിക്ക് കൊണ്ടു വരപ്പെടുകയും ചെയ്താൽ," - ഹൃദയങ്ങളിൽ ഉണ്ടായിരുന്ന ഉദ്ദേശങ്ങളും വിശ്വാസങ്ങളും മറ്റും പുറത്തു കൊണ്ടു വരപ്പെടുകയും, വ്യക്തമാവുകയും ചെയ്താൽ;<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100011.mp3"></audio> 11- "തീർച്ചയായും അവരുടെ രക്ഷിതാവ് അന്നേ ദിവസം അവരെ പറ്റി സൂക്ഷ്മമായി അറിയുന്നവൻ തന്നെയാകുന്നു." - തീർച്ചയായും അവരുടെ രക്ഷിതാവ് അന്നേ ദിവസം അവരെ കുറിച്ച് സൂക്ഷ്മമായി അറിയുന്നവൻ തന്നെയാകുന്നു; അവരുടെ ഒരു കാര്യവും അവന് അവ്യക്തമായിരിക്കുകയില്ല. അതിൻ്റെ അടിസ്ഥാനത്തിൽ തന്നെ അവർക്ക് അവൻ പ്രതിഫലം നൽകുകയും ചെയ്യും. </p>',
            ],
            3 => [
                'question' => 'ചോദ്യം 2: സൂറ. ഖാരിഅഃ പാരായണം ചെയ്യുകയും അതിൻ്റെ വിശദീകരണം പറയുകയും ചെയ്യുക.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7450.mp3',
                'answer' => '<p> ഉത്തരം: സൂറത്തുൽ ഖാരിഅഃയിലെ ആയത്തുകളും, അവയുടെ വിശദീകരണവും ഇപ്രകാരമാണ്.<br /> <br /> പരമകാരുണികനും കരുണാനിധിയുമായ അല്ലാഹുവിൻ്റെ നാമത്തിൽ<br /> <br /> ഭയങ്കരമായ ആ സംഭവം. ഭയങ്കരമായ സംഭവം എന്നാൽ എന്താകുന്നു? ഭയങ്കരമായ സംഭവമെന്നാൽ എന്താണെന്ന് നിനക്കറിയുമോ? മനുഷ്യർ ചിന്നിച്ചിതറിയ പാറ്റയെപ്പോലെ ആകുന്ന ദിവസം! പർവ്വതങ്ങൾ കടഞ്ഞ ആട്ടിൻ രോമം പോലെയും അപ്പോൾ ഏതൊരാളുടെ തുലാസുകൾ ഘനം തൂങ്ങിയോ അവൻ സംതൃപ്തമായ ജീവിതത്തിലായിരിക്കും. എന്നാൽ ഏതൊരാളുടെ തുലാസുകൾ തൂക്കം കുറഞ്ഞതായോ അവൻ്റെ സങ്കേതം ഹാവിയഃ ആയിരിക്കും. ഹാവിയഃ എന്നാൽ എന്താണെന്ന് നിനക്കറിയുമോ? ചൂടേറിയ നരകാഗ്നിയത്രെ അത്. <span class="c2">(ഖാരിഅഃ: 1-11)</span><br /> വിശദീകരണം:<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101001.mp3"></audio> 1- "ഭയങ്കരമായ ആ സംഭവം." - ഭയാനകത കൊണ്ട് ഹൃദയങ്ങളെ ഭീതിയിലാഴ്ത്തുന്ന സമയം.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101002.mp3"></audio> 2- "ഭയങ്കരമായ സംഭവം എന്നാൽ എന്താകുന്നു?" -ഭയാനകത കൊണ്ട് ഹൃദയങ്ങളെ ഭീതിയിലാഴ്ത്തുന്ന സമയം എന്താകുന്നു?<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101003.mp3"></audio> 3- "ഭയങ്കരമായ സംഭവമെന്നാൽ എന്താണെന്ന് നിനക്കറിയുമോ?" -അല്ലാഹുവിൻ്റെ റസൂലേ! അതിഭീകരത കൊണ്ട് ഹൃദയങ്ങളെ ഭയപ്പെടുത്തുന്ന ഈ സമയം ഏതാണെന്ന് നിനക്ക് അറിയുമോ?! അന്ത്യനാളാകുന്നു അത്.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101004.mp3"></audio> 4- "മനുഷ്യർ ചിന്നിച്ചിതറിയ പാറ്റയെപ്പോലെ ആകുന്ന ദിവസം!" -മനുഷ്യരുടെ ഹൃദയങ്ങളെ അത് ഭീതിയിലാഴ്ത്തുകയും, അവർ അവിടെയും ഇവിടെയുമായി ചിന്നിച്ചിതറിയ പാറ്റകളെ പോലെ ആയിത്തീരുകയും ചെയ്യും.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101005.mp3"></audio> 5- "പർവ്വതങ്ങൾ കടഞ്ഞ ആട്ടിൻ രോമം പോലെയും" -പർവ്വതങ്ങൾ കടഞ്ഞ കമ്പിളി പോലെ -ഭാരമില്ലാതെ ചലിച്ചു കൊണ്ടിരിക്കുന്ന- അവസ്ഥയിലാകും.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101006.mp3"></audio> 6- "അപ്പോൾ ഏതൊരാളുടെ തുലാസുകൾ ഘനം തൂങ്ങിയോ" -എന്നാൽ ഏതൊരാളുടെ നന്മയുടെ ഏടുകൾ അവൻ്റെ തിന്മയുടെ ഏടുകളെക്കാൾ കനം തൂങ്ങിയോ;<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101007.mp3"></audio> 7- "അവൻ സംതൃപ്തമായ ജീവിതത്തിലായിരിക്കും." -അവന് ലഭിക്കുന്ന സ്വർഗത്തിൽ അവൻ തൃപ്തികരമായ ജീവിതം നയിക്കും.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101008.mp3"></audio> 8- "എന്നാൽ ഏതൊരാളുടെ തുലാസുകൾ തൂക്കം കുറഞ്ഞതായോ" -എന്നാൽ ഏതൊരാളുടെ തിന്മയുടെ ഏടുകൾ അവൻ്റെ നന്മയുടെ ഏടുകളെക്കാൾ കനം തൂങ്ങിയോ;<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101009.mp3"></audio> 9- "അവൻ്റെ സങ്കേതം ഹാവിയഃ ആയിരിക്കും." -അവൻ്റെ സങ്കേതവും താമസസ്ഥലവും \'ഹാവിയഃ\' ആയിരിക്കും.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101010.mp3"></audio> 10- "ഹാവിയഃ എന്നാൽ എന്താണെന്ന് നിനക്കറിയുമോ?" -ഹേ റസൂൽ! \'ഹാവിയഃ\' എന്നാൽ എന്താണെന്ന് നിനക്കറിയുമോ?<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101011.mp3"></audio> 11- "ചൂടേറിയ നരകാഗ്നിയത്രെ അത്." -കടുത്ത ചൂടുള്ള നരകാഗ്നിയത്രെ അത്. </p>',
            ],
            4 => [
                'question' => 'ചോദ്യം 2: സൂറ. തകാഥുർ പാരായണം ചെയ്യുകയും അതിൻ്റെ വിശദീകരണം പറയുകയും ചെയ്യുക.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7610.mp3',
                'answer' => '<p> ഉത്തരം: സൂറത്തുൽ തകാഥുറിലെ ആയത്തുകളും, അവയുടെ വിശദീകരണവും ഇപ്രകാരമാണ്.<br /> <br /> പരമകാരുണികനും കരുണാനിധിയുമായ അല്ലാഹുവിൻ്റെ നാമത്തിൽ<br /> <br /> പരസ്പരം പെരുമ നടിക്കുക എന്ന കാര്യം നിങ്ങളെ അശ്രദ്ധയിലാക്കിയിരിക്കുന്നു. നിങ്ങൾ ശവകുടീരങ്ങൾ സന്ദർശിക്കുന്നത് വരേക്കും. നിസ്സംശയം, നിങ്ങൾ വഴിയെ അറിഞ്ഞ് കൊള്ളും. പിന്നെയും നിസ്സംശയം നിങ്ങൾ വഴിയെ അറിഞ്ഞ് കൊള്ളും നിസ്സംശയം, നിങ്ങൾ ദൃഢമായ അറിവ് അറിയുമായിരുന്നെങ്കിൽ ജ്വലിക്കുന്ന നരകത്തെ നിങ്ങൾ കാണുക തന്നെ ചെയ്യും. പിന്നെ തീർച്ചയായും നിങ്ങൾ അതിനെ ദൃഢമായും കണ്ണാൽ കാണുക തന്നെ ചെയ്യും. പിന്നീട് ആ ദിവസത്തിൽ സുഖാനുഭവങ്ങളെ പറ്റി തീർച്ചയായും നിങ്ങൾ ചോദ്യം ചെയ്യപ്പെടുകതന്നെ ചെയ്യും. <span class="c2">(തകാഥുർ: 1-8)</span><br /> വിശദീകരണം:<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102001.mp3"></audio> 1- "പരസ്പരം പെരുമനടിക്കുക എന്ന കാര്യം നിങ്ങളെ അശ്രദ്ധയിലാക്കിയിരിക്കുന്നു." - അല്ലയോ ജനങ്ങളേ! സമ്പാദ്യവും സന്താനങ്ങളും കൊണ്ടുള്ള പെരുമ നടിക്കൽ നിങ്ങളെ അല്ലാഹുവിനെ അനുസരിക്കുന്നതിൽ നിന്ന് ശ്രദ്ധ തെറ്റിച്ചിരിക്കുന്നു.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102002.mp3"></audio> 2- "നിങ്ങൾ ശവകുടീരങ്ങൾ സന്ദർശിക്കുന്നത് വരേക്കും." - നിങ്ങൾ മരിക്കുകയും, നിങ്ങളുടെ ഖബ്റുകളിൽ സന്ദർശിക്കുകയും ചെയ്യുന്നത് വരെ.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102003.mp3"></audio> 3- "നിസ്സംശയം, നിങ്ങൾ വഴിയെ അറിഞ്ഞ് കൊള്ളും." - അല്ലാഹുവിനുള്ള അനുസരണയിൽ നിന്ന് ഈ പൊങ്ങച്ചം നിങ്ങളുടെ ശ്രദ്ധ തെറ്റിക്കാൻ പാടില്ലായിരുന്നു. ഇതിൻ്റെ പരിണിതഫലം നിങ്ങൾ വഴിയെ അറിഞ്ഞു കൊള്ളും.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102004.mp3"></audio> 4- "പിന്നെയും നിസ്സംശയം നിങ്ങൾ വഴിയെ അറിഞ്ഞ് കൊള്ളും" - വീണ്ടും! നിങ്ങൾ വഴിയെ അറിഞ്ഞു കൊള്ളും.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102005.mp3"></audio> 5- "നിസ്സംശയം, നിങ്ങൾ ദൃഢമായ അറിവ് അറിയുമായിരുന്നെങ്കിൽ." - നിങ്ങൾ അല്ലാഹുവിലേക്ക് ഉയർത്തെഴുന്നേൽപ്പിക്കപ്പെടുന്നവർ ആണെന്നും, അവൻ നിങ്ങളുടെ പ്രവർത്തനങ്ങൾക്ക് പ്രതിഫലം നൽകുമെന്നും നിങ്ങൾക്ക് ദൃഢമായ ബോധ്യമുണ്ടായിരുന്നെങ്കിൽ നിങ്ങളൊരിക്കലും സമ്പാദ്യവും സന്താനവും കൊണ്ട് പെരുമ നടിക്കുന്നതിൽ ശ്രദ്ധ കേന്ദ്രീകരിക്കുന്നവരായി മാറുമായിരുന്നില്ല. സത്യം!<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102006.mp3"></audio> 6- "ജ്വലിക്കുന്ന നരകത്തെ നിങ്ങൾ കാണുക തന്നെ ചെയ്യും." - അല്ലാഹു സത്യം! നിങ്ങൾ അന്ത്യനാളിൽ നരകം കണ്ണു കൊണ്ട് വീക്ഷിക്കുക തന്നെ ചെയ്യും.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102007.mp3"></audio> 7- "പിന്നെ തീർച്ചയായും നിങ്ങൾ അതിനെ ദൃഢമായും കണ്ണാൽ കാണുക തന്നെ ചെയ്യും." - വീണ്ടും! നിങ്ങൾ നരകത്തെ -ഒരു സംശയവുമില്ലാത്ത വണ്ണം- നന്നായി കാണുക തന്നെ ചെയ്യും.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102008.mp3"></audio> 8- "പിന്നീട് ആ ദിവസത്തിൽ സുഖാനുഭവങ്ങളെ പറ്റി തീർച്ചയായും നിങ്ങൾ ചോദ്യം ചെയ്യപ്പെടുകതന്നെ ചെയ്യും." - പിന്നീട് അല്ലാഹു നിങ്ങളോട് അന്നേ ദിവസം നിങ്ങൾക്ക് മേൽ ചൊരിഞ്ഞ ഓരോ അനുഗ്രഹത്തെ കുറിച്ചും -ആരോഗ്യവും സമ്പാദ്യവും മറ്റുമെല്ലാം- ചോദിക്കുക തന്നെ ചെയ്യും. </p>',
            ],
            5 => [
                'question' => 'ചോദ്യം 2: സൂറതുൽ അസ്വ്\'ർ പാരായണം ചെയ്യുകയും അതിൻ്റെ വിശദീകരണം പറയുകയും ചെയ്യുക.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7750.mp3',
                'answer' => '<p> ഉത്തരം: സൂറത്തുൽ അസ്വ്\'റിലെ ആയത്തുകളും, അവയുടെ വിശദീകരണവും ഇപ്രകാരമാണ്.<br /> <br /> പരമകാരുണികനും കരുണാനിധിയുമായ അല്ലാഹുവിൻ്റെ നാമത്തിൽ<br /> <br /> കാലം തന്നെയാണെ സത്യം. തീർച്ചയായും മനുഷ്യൻ നഷ്ടത്തിൽ തന്നെയാകുന്നു. വിശ്വസിക്കുകയും, സൽകർമങ്ങൾ പ്രവർത്തിക്കുകയും, സത്യം കൈക്കൊള്ളാൻ അന്യോന്യം ഉപദേശിക്കുകയും ക്ഷമ പരസ്പരം ഉപദേശിക്കുകയും ചെയ്തവരൊഴികെ <span class="c2">(അസ്വ്\'ർ: 1-3)</span><br /> വിശദീകരണം:<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/103001.mp3"></audio> 1- "കാലം തന്നെയാണെ സത്യം." - അല്ലാഹു മദ്ധ്യാഹ്ന സമയത്തെ <span class="c2">(അസ്വ് ർ നിസ്കാര സമയം)</span> കൊണ്ട് സത്യം ചെയ്തിരിക്കുന്നു.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/103002.mp3"></audio> 2- "തീർച്ചയായും മനുഷ്യൻ നഷ്ടത്തിൽ തന്നെയാകുന്നു." - തീർച്ചയായും മനുഷ്യൻ നഷ്ടത്തിലും നാശത്തിലും തന്നെയാകുന്നു.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/103003.mp3"></audio> 3- "വിശ്വസിക്കുകയും, സൽകർമങ്ങൾ പ്രവർത്തിക്കുകയും, സത്യം കൈക്കൊള്ളാൻ അന്യോന്യം ഉപദേശിക്കുകയും ക്ഷമ പരസ്പരം ഉപദേശിക്കുകയും ചെയ്തവരൊഴികെ." - അല്ലാഹുവിലും റസൂലിലും വിശ്വസിക്കുകയും, സൽകർമ്മങ്ങൾ പ്രവർത്തിക്കുകയും, സത്യത്തിലേക്ക് ക്ഷണിക്കുകയും അതിൽ ക്ഷമയോടെ നിലകൊള്ളുകയും ചെയ്തവരൊഴികെ. ഈ വിശേഷണങ്ങൾ ഉള്ളവർ തങ്ങളുടെ ഐഹിക-പാരത്രിക ജീവിതങ്ങളിൽ വിജയിച്ചവരാണ്. </p>',
            ],
            6 => [
                'question' => 'ചോദ്യം 2: സൂറതുൽ ഹുമസഃ പാരായണം ചെയ്യുകയും അതിൻ്റെ വിശദീകരണം പറയുകയും ചെയ്യുക.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7830.mp3',
                'answer' => '<p> ഉത്തരം: സൂറതുൽ ഹുമസയിലെ ആയത്തുകളും, അവയുടെ വിശദീകരണവും ഇപ്രകാരമാണ്.<br /> <br /> പരമകാരുണികനും കരുണാനിധിയുമായ അല്ലാഹുവിൻ്റെ നാമത്തിൽ<br /> <br /> കുത്തുവാക്ക് പറയുന്നവനും അവഹേളിക്കുന്നവനുമായ ഏതൊരാൾക്കും നാശം. അതായത് ധനം ശേഖരിക്കുകയും അത് എണ്ണിനോക്കിക്കൊണ്ടിരിക്കുകയും ചെയ്യുന്നവന്. അവൻ്റെ ധനം അവന് ശാശ്വത ജീവിതം നല്കിയിരിക്കുന്നു എന്ന് അവൻ വിചാരിക്കുന്നു. നിസ്സംശയം, അവൻ ഹുത്വമയിൽ എറിയപ്പെടുക തന്നെ ചെയ്യും. ഹുത്വമ എന്നാൽ എന്താണെന്ന് നിനക്കറിയാമോ? അത് അല്ലാഹുവിൻ്റെ ജ്വലിപ്പിക്കപ്പെട്ട അഗ്നിയാകുന്നു. ഹൃദയങ്ങളിലേക്ക് കത്തിപ്പടരുന്നതായ തീർച്ചയായും അത് അവരുടെ മേൽ അടച്ചുമൂടപ്പെടുന്നതായിരിക്കും. നീട്ടിയുണ്ടാക്കപ്പെട്ട സ്തംഭങ്ങളിലായിക്കൊണ്ട് <span class="c2">(ഹുമസഃ: 1-9)</span><br /> വിശദീകരണം:<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104001.mp3"></audio> 1- "കുത്തുവാക്ക് പറയുന്നവനും അവഹേളിക്കുന്നവനുമായ ഏതൊരാൾക്കും നാശം." - ജനങ്ങളെ കുറിച്ച് ധാരാളമായി പരദൂഷണം പറയുകയും, അവരെ കുത്തി പറയുകയും ചെയ്യുന്നവർക്ക് നാശവും കടുത്ത ശിക്ഷയുമുണ്ടാകട്ടെ.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104002.mp3"></audio> 2- "അതായത് ധനം ശേഖരിക്കുകയും അത് എണ്ണിനോക്കിക്കൊണ്ടിരിക്കുകയും ചെയ്യുന്നവന്." - അവൻ്റെ കാര്യമായ ചിന്ത സമ്പത്ത് സ്വരുക്കൂട്ടലും അതെണ്ണി തിട്ടപ്പെടുത്തി വെക്കലുമാണ്. അതല്ലാത്ത മറ്റൊരു ചിന്തയും അവനില്ല.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104003.mp3"></audio> 3- "അവൻ്റെ ധനം അവന് ശാശ്വത ജീവിതം നല്കിയിരിക്കുന്നു എന്ന് അവൻ വിചാരിക്കുന്നു." - അവൻ ഒരുമിച്ചു കൂട്ടിയ സമ്പാദ്യം മരണത്തിൽ നിന്ന് അവനെ രക്ഷിക്കുകയും, അങ്ങനെ ഭൂമിയിൽ കാലാകാലം വസിക്കാമെന്നുമാണ് അവൻ ധരിക്കുന്നത്.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104004.mp3"></audio> 4- "നിസ്സംശയം, അവൻ ഹുത്വമയിൽ എറിയപ്പെടുക തന്നെ ചെയ്യും." - ഈ വിഡ്ഢി ധരിച്ചു വെച്ചിരിക്കുന്നത് പോലെയല്ല കാര്യം. കാഠിന്യം കാരണം വന്നു വീഴുന്നതിനെയെല്ലാം തകർക്കുകയും പൊട്ടിച്ചെറിയുകയും ചെയ്യുന്ന, നരകാഗ്നിയിൽ അവൻ വലിച്ചെറിയപ്പെടുക തന്നെ ചെയ്യും.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104005.mp3"></audio> 5- "ഹുത്വമ എന്നാൽ എന്താണെന്ന് നിനക്കറിയാമോ?" - അല്ലാഹുവിൻ്റെ റസൂലേ! വന്നു വീഴുന്നതിനെയെല്ലാം തകർക്കുകയും പൊട്ടിച്ചെറിയുകയും ചെയ്യുന്ന ഈ നരകാഗ്നി -ഹുത്വമ- എന്താണെന്ന് അങ്ങേക്ക് അറിയുമോ?<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104006.mp3"></audio> 6- "അത് അല്ലാഹുവിൻ്റെ ജ്വലിപ്പിക്കപ്പെട്ട അഗ്നിയാകുന്നു." - കത്തിജ്വലിപ്പിക്കപ്പെട്ട അല്ലാഹുവിൻ്റെ നരകാഗ്നിയാകുന്നു അത്.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104007.mp3"></audio> 7- "ഹൃദയങ്ങളിലേക്ക് കത്തിപ്പടരുന്നതായ" - മനുഷ്യരുടെ ശരീരങ്ങൾ കത്തിക്കരിച്ചതിന് ശേഷം അത് അവരുടെ ഹൃദയങ്ങളിലേക്ക് എത്തും.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104008.mp3"></audio> 8- "തീർച്ചയായും അത് അവരുടെ മേൽ അടച്ചുമൂടപ്പെടുന്നതായിരിക്കും." - അതിൽ ശിക്ഷിക്കപ്പെടുന്നവരുടെ മേൽ അടച്ചു മൂടപ്പെട്ട നിലയിലായിരിക്കും അത്.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104009.mp3"></audio> 9- "നീട്ടിയുണ്ടാക്കപ്പെട്ട സ്തംഭങ്ങളിലായിക്കൊണ്ട്." - അതിൽ നിന്ന് പുറത്തു കടക്കാതിരിക്കാൻ നീട്ടിയുണ്ടാക്കപ്പെട്ട തൂണുകൾ മുഖേന ബന്ധിക്കപ്പെട്ടിരിക്കും. </p>',
            ],
            7 => [
                'question' => 'ചോദ്യം 3: സൂറതുൽ ഫീൽ പാരായണം ചെയ്യുകയും അതിൻ്റെ വിശദീകരണം പറയുകയും ചെയ്യുക.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7970.mp3',
                'answer' => '<p> ഉത്തരം: സൂറത്തുൽ ഫീലിലെ ആയത്തുകളും, അവയുടെ വിശദീകരണവും ഇപ്രകാരമാണ്.<br /> <br /> പരമകാരുണികനും കരുണാനിധിയുമായ അല്ലാഹുവിൻ്റെ നാമത്തിൽ<br /> <br /> ആനക്കാരെ നിൻ്റെ രക്ഷിതാവ് എന്തു ചെയ്തു എന്ന് നീ കണ്ടില്ലേ? അവരുടെ തന്ത്രം അവന് പിഴവിലാക്കിയില്ലേ? കൂട്ടംകൂട്ടമായിക്കൊണ്ടുള്ള പക്ഷികളെ അവരുടെ നേർക്ക് അവൻ അയക്കുകയും ചെയ്തു. അവ ചൂള വെച്ച കല്ലു കൊണ്ട് അവരെ എറിഞ്ഞു കൊണ്ടിരുന്നു. അങ്ങനെ അവൻ അവരെ തിന്നൊടുക്കപ്പെട്ട വൈക്കോൽ തുരുമ്പുപോലെയാക്കി. <span class="c2">(ഫീൽ: 1-5)</span><br /> വിശദീകരണം:<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105001.mp3"></audio> 1- "ആനക്കാരെ നിൻ്റെ രക്ഷിതാവ് എന്തു ചെയ്തു എന്ന് നീ കണ്ടില്ലേ?" - അല്ലാഹുവിൻ്റെ റസൂലേ! അബ്റഹതും ആനപ്പുറത്തേറി വന്ന അവൻ്റെ കൂട്ടാളികളും അല്ലാഹുവിൻ്റെ ഭവനമായ കഅ്ബ തകർക്കാൻ ഉദ്ദേശിച്ചപ്പോൾ നിൻ്റെ രക്ഷിതാവ് അവരെ എന്താണ് ചെയ്തതെന്ന് നീ അറിഞ്ഞില്ലേ?!<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105002.mp3"></audio> 2- "അവരുടെ തന്ത്രം അവന് പിഴവിലാക്കിയില്ലേ?" - കഅ്ബ തകർക്കാൻ വേണ്ടി അവർ മെനഞ്ഞ കുതന്ത്രം അല്ലാഹു വൃഥാവിലാക്കി. കഅ്ബയിൽ നിന്ന് ജനങ്ങളെ തിരിച്ചു കളയുക എന്ന അവരുടെ ഉദ്ദേശം അവർക്ക് നേടിയെടുക്കാൻ കഴിഞ്ഞില്ല. <span class="c2">(അല്ല!)</span> ഒന്നും തന്നെ അവർക്കതിൽ നിന്ന് ലഭിച്ചില്ല.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105003.mp3"></audio> 3- "കൂട്ടംകൂട്ടമായിക്കൊണ്ടുള്ള പക്ഷികളെ അവരുടെ നേർക്ക് അവൻ അയക്കുകയും ചെയ്തു." - അവരുടെ നേർക്ക് പക്ഷികളെ അവൻ നിയോഗിച്ചു; അവ അവരിലേക്ക് കൂട്ടംകൂട്ടമായി പറന്നു ചെന്നു.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105004.mp3"></audio> 4- "അവ ചൂള വെച്ച കല്ലു കൊണ്ട് അവരെ എറിഞ്ഞു കൊണ്ടിരുന്നു." - അവ ചൂള വെച്ച കല്ലു കൊണ്ട് അവരെ എറിഞ്ഞു കൊണ്ടിരുന്നു.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105005.mp3"></audio> 5- "അങ്ങനെ അവൻ അവരെ തിന്നൊടുക്കപ്പെട്ട വൈക്കോൽ തുരുമ്പുപോലെയാക്കി." - അങ്ങനെ അല്ലാഹു അവരെ കന്നുകാലികൾ തിന്നുകയും ചവിട്ടി മെതിക്കുകയും ചെയ്ത ഇലകളെ പോലെയാക്കി. </p>',
            ],
            8 => [
                'question' => 'ചോദ്യം 2: സൂറ. ഖുറൈശ് പാരായണം ചെയ്യുകയും അതിൻ്റെ വിശദീകരണം പറയുകയും ചെയ്യുക.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8070.mp3',
                'answer' => '<p> ഉത്തരം: സൂറ. ഖുറൈശിലെ ആയത്തുകളും, അവയുടെ വിശദീകരണവും ഇപ്രകാരമാണ്.<br /> <br /> പരമകാരുണികനും കരുണാനിധിയുമായ അല്ലാഹുവിൻ്റെ നാമത്തിൽ<br /> <br /> ഖുറൈശ് ഗോത്രത്തെ കൂട്ടിയിണക്കിയതിനാൽ. ശൈത്യകാലത്തെയും ഉഷ്ണകാലത്തെയും യാത്രയുമായി അവരെ കൂട്ടിയിണക്കിയതിനാൽ, ഈ ഭവനത്തിൻ്റെ രക്ഷിതാവിനെ അവർ ആരാധിച്ചുകൊള്ളട്ടെ. അതായത് അവർക്ക് വിശപ്പിന്ന് ആഹാരം നല്കുകയും, ഭയത്തിന് പകരം സമാധാനം നല്കുകയും ചെയ്തവനെ. <span class="c2">(ഖുറൈശ്: 1-4)</span><br /> ഫാതിഹഃയുടെ വിശദീകരണം:<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106001.mp3"></audio> 1- "ഖുറൈശ് ഗോത്രത്തെ കൂട്ടിയിണക്കിയതിനാൽ." - ഖുറൈശികളുടെ ശൈലിയും ഇണക്കവും കാരണത്താൽ.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106002.mp3"></audio> 2- "ശൈത്യകാലത്തെയും ഉഷ്ണകാലത്തെയും യാത്രയുമായി അവരെ കൂട്ടിയിണക്കിയതിനാൽ," - ശൈത്യകാലത്ത് യമനിലേക്കും ഉഷ്ണ കാലത്ത് ശാമിലേക്കുമുള്ള നിർഭയത്വത്തോടെയുള്ള അവരുടെ യാത്ര.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106003.mp3"></audio> 3- "ഈ ഭവനത്തിൻ്റെ രക്ഷിതാവിനെ അവർ ആരാധിച്ചുകൊള്ളട്ടെ." അവർക്ക് ഈ യാത്ര എളുപ്പമാക്കി നൽകിയ, പരിശുദ്ധമായ ഈ ഭവനത്തിൻ്റെ രക്ഷിതാവിനെ മാത്രം അവർ ആരാധിക്കട്ടെ; അവനുള്ള ആരാധനയിൽ ഒരാളെയും അവർ പങ്കു ചേർക്കാതിരിക്കുകയും ചെയ്യട്ടെ.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106004.mp3"></audio> 4- "അതായത് അവർക്ക് വിശപ്പിന്ന് ആഹാരം നല്കുകയും, ഭയത്തിന് പകരം സമാധാനം നല്കുകയും ചെയ്തവനെ." - അവർക്ക് വിശപ്പിന്ന് ആഹാരം നൽകുകയും, ഭയത്തിൽ നിന്ന് നിർഭയത്വം നൽകുകയും ചെയ്തവനായ -അറബികളുടെ മനസ്സിൽ പരിശുദ്ധ കഅ്ബയോടുള്ള ആദരവും അതിൻ്റെ ചുറ്റുപാടും താമസിക്കുന്നവരോട് ബഹുമാനവും നിശ്ചയിച്ച- അല്ലാഹുവിനെ. </p>',
            ],
            9 => [
                'question' => 'ചോദ്യം 2: സൂറ. മാഊൻ പാരായണം ചെയ്യുകയും അതിൻ്റെ വിശദീകരണം പറയുകയും ചെയ്യുക.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8160.mp3',
                'answer' => '<p> ഉത്തരം: സൂറതുൽ മാഊനിലെ ആയത്തുകളും, അവയുടെ വിശദീകരണവും ഇപ്രകാരമാണ്.<br /> <br /> പരമകാരുണികനും കരുണാനിധിയുമായ അല്ലാഹുവിൻ്റെ നാമത്തിൽ<br /> <br /> മതത്തെ വ്യാജമാക്കുന്നവൻ ആരെന്ന് നീ കണ്ടുവോ? അനാഥക്കുട്ടിയെ തള്ളിക്കളയുന്നവനത്രെ അത്. സാധുവിന് ഭക്ഷണം കൊടുക്കുവാൻ അവൻ പ്രോത്സാഹിപ്പിച്ചിരുന്നുമില്ല. എന്നാൽ നമസ്കാരക്കാർക്കാകുന്നു നാശം. തങ്ങളുടെ നമസ്കാരത്തെപ്പറ്റി ശ്രദ്ധയില്ലാത്തവരായ ജനങ്ങളെ കാണിക്കാൻ വേണ്ടി പ്രവർത്തിക്കുന്നവരായ പരോപകാര വസ്തുക്കൾ മുടക്കുന്നവരുമായവർക്ക് <span class="c2">(മാഊൻ: 1-7)</span><br /> വിശദീകരണം:<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107001.mp3"></audio> 1- "മതത്തെ വ്യാജമാക്കുന്നവൻ ആരെന്ന് നീ കണ്ടുവോ?" - അന്ത്യനാളിൽ പ്രതിഫലം നൽകപ്പെടും എന്നതിനെ കളവാക്കുന്നവനെ നീ അറിഞ്ഞുവോ?<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107002.mp3"></audio> 2- "അനാഥക്കുട്ടിയെ തള്ളിക്കളയുന്നവനത്രെ അത്." - അനാഥന് അവൻ്റെ അവകാശം പരുഷമായി തടഞ്ഞു വെക്കുന്നവനാരോ; അവനാണത്.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107003.mp3"></audio> 3- "സാധുവിന് ഭക്ഷണം കൊടുക്കുവാൻ അവൻ പ്രോത്സാഹിപ്പിച്ചിരുന്നുമില്ല." - അവൻ സ്വന്തത്തെയോ മറ്റുള്ളവരെയോ പാവപ്പെട്ടവർക്ക് ഭക്ഷണം നൽകാൻ പ്രേരിപ്പിക്കുന്നില്ല.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107004.mp3"></audio> 4- "എന്നാൽ നമസ്കാരക്കാർക്കാകുന്നു നാശം." - നമസ്കാരക്കാർക്ക് നാശവും ശിക്ഷയും ഉണ്ടാകട്ടെ.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107005.mp3"></audio> 5- "തങ്ങളുടെ നമസ്കാരത്തെപ്പറ്റി ശ്രദ്ധയില്ലാത്തവരായ." - തങ്ങളുടെ നിസ്കാരത്തെ കുറിച്ച് അശ്രദ്ധയിലായവർക്ക് നാശവും ശിക്ഷയും ഉണ്ടാകട്ടെ. നിസ്കാരത്തിൻ്റെ സമയം കഴിഞ്ഞു പോകുന്നതു വരെ അവർ അതിനെ ഗൗനിക്കാതെ വിടുന്നതാണ്.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107006.mp3"></audio> 6- "ജനങ്ങളെ കാണിക്കാൻ വേണ്ടി പ്രവർത്തിക്കുന്നവരായ." - തങ്ങളുടെ നിസ്കാരം കൊണ്ടും, പ്രവർത്തനങ്ങൾ കൊണ്ടും ജനങ്ങളെ കാണിക്കുന്നവർ; തങ്ങളുടെ പ്രവർത്തനങ്ങൾ അവർ അല്ലാഹുവിന് നിഷ്കളങ്കമാക്കുന്നില്ല.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107007.mp3"></audio> 7- "പരോപകാര വസ്തുക്കൾ മുടക്കുന്നവരുമായ." - ഒരു പ്രയാസവുമില്ലാത്ത, ചെറിയ സഹായങ്ങൾ പോലും മറ്റുള്ളവർക്ക് അവർ കൊടുക്കുകയില്ല. </p>',
            ],
            10 => [
                'question' => 'ചോദ്യം 2: സൂറതുൽ കൗഥർ പാരായണം ചെയ്യുകയും അതിൻ്റെ വിശദീകരണം പറയുകയും ചെയ്യുക.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8280.mp3',
                'answer' => '<p> ഉത്തരം: സൂറതുൽ കൗഥറിലെ ആയത്തുകളും, അവയുടെ വിശദീകരണവും ഇപ്രകാരമാണ്.<br /> <br /> പരമകാരുണികനും കരുണാനിധിയുമായ അല്ലാഹുവിൻ്റെ നാമത്തിൽ<br /> <br /> തീർച്ചയായും താങ്കൾക്ക് നാം ധാരാളം നേട്ടം നല്കിയിരിക്കുന്നു. ആകയാൽ നീ നിൻ്റെ രക്ഷിതാവിന് വേണ്ടി നിസ്കരിക്കുകയും ബലിയർപ്പിക്കുകയും ചെയ്യുക. തീർച്ചയായും നിന്നോട് വിദ്വേഷം വെച്ച് പുലർത്തുന്നവൻ തന്നെയാകുന്നു വാലറ്റവൻ <span class="c2">(ഭാവിയില്ലാത്തവൻ)</span>. <span class="c2">(കൗഥർ: 1-3)</span><br /> വിശദീകരണം:<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/108001.mp3"></audio> 1- "തീർച്ചയായും താങ്കൾക്ക് നാം ധാരാളം നേട്ടം നല്കിയിരിക്കുന്നു." അല്ലാഹുവിൻ്റെ റസൂലേ! അങ്ങേക്ക് നാം ധാരാളം നന്മകൾ ചെയ്തു തന്നിരിക്കുന്നു. അതിൽ പെട്ടതാണ് സ്വർഗത്തിലുള്ള \'കൗഥർ\' എന്ന അരുവി.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/108002.mp3"></audio> 2- "ആകയാൽ നീ നിൻ്റെ രക്ഷിതാവിന് വേണ്ടി നിസ്കരിക്കുകയും ബലിയർപ്പിക്കുകയും ചെയ്യുക." അതിനാൽ അല്ലാഹു നിനക്ക് ചെയ്തു തന്ന ഈ അനുഗ്രഹത്തിനുള്ള നന്ദിയായി അവന് വേണ്ടി മാത്രം നിസ്കരിക്കുകയും, അവന് മാത്രമായി ബലിയർപ്പിക്കുകയും ചെയ്യുക. ബഹുദൈവാരാധകർ ചെയ്യുന്നത് പോലെ അവരുടെ വിഗ്രഹങ്ങളോട് സാമീപ്യം ലഭിക്കാൻ വേണ്ടി അവക്കായി ബലിയറുപ്പിക്കുന്നതിന് കടകവിരുദ്ധമായിരിക്കണം നിൻ്റെ ബലി.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/108003.mp3"></audio> 3- "തീർച്ചയായും നിന്നോട് വിദ്വേഷം വെച്ച് പുലർത്തുന്നവൻ തന്നെയാകുന്നു വാലറ്റവൻ <span class="c2">(ഭാവിയില്ലാത്തവൻ)</span>." നിന്നോട് വിദ്വേഷമുള്ളവൻ തന്നെയാണ് എല്ലാ നന്മകളിൽ നിന്നും വിഛേദിക്കപ്പെടുകയും, വിസ്മരിക്കപ്പെടുകയും ചെയ്യുന്നവൻ. അവൻ്റെ പേര് പരാമർശിക്കപ്പെട്ടാൽ തന്നെയും മോശമായി കൊണ്ട് മാത്രമേ അത് പരാമർശിക്കപ്പെടുകയുള്ളൂ. </p>',
            ],
            11 => [
                'question' => 'ചോദ്യം 3: സൂറതുൽ കാഫിറൂൻ പാരായണം ചെയ്യുകയും അതിൻ്റെ വിശദീകരണം പറയുകയും ചെയ്യുക.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8360.mp3',
                'answer' => '<p> ഉത്തരം: സൂറതുൽ കാഫിറൂനിലെ ആയത്തുകളും, അവയുടെ വിശദീകരണവും ഇപ്രകാരമാണ്.<br /> <br /> പരമകാരുണികനും കരുണാനിധിയുമായ അല്ലാഹുവിൻ്റെ നാമത്തിൽ<br /> <br /> <span class="c2">(നബിയേ,)</span> പറയുക: <span class="c2">(അല്ലാഹുവിനെയും അവൻ്റെ ദൂതനെയും പരലോകത്തെയും)</span> നിഷേധിച്ചവരേ! നിങ്ങൾ ആരാധിച്ചുവരുന്നതിനെ ഞാൻ ആരാധിക്കുന്നില്ല. ഞാൻ ആരാധിച്ചു വരുന്നതിനെ നിങ്ങളും ആരാധിക്കുന്നില്ല. നിങ്ങൾ ആരാധിക്കുന്ന വിഗ്രഹങ്ങളെ ആരാധിക്കുന്നവനുമല്ല ഞാൻ. ഞാൻ ആരാധിച്ചു വരുന്നതിനെ നിങ്ങളും ആരാധിക്കാൻ പോകുന്നവരല്ല. നിങ്ങൾക്ക് നിങ്ങളുടെ മതം. എനിക്ക് എൻ്റെ മതവും. <span class="c2">(കാഫിറൂൻ: 1-6)</span><br /> ഫാതിഹഃയുടെ വിശദീകരണം:<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109001.mp3"></audio> 1- "<span class="c2">(നബിയേ,)</span> പറയുക: <span class="c2">(അല്ലാഹുവിനെയും അവൻ്റെ ദൂതനെയും പരലോകത്തെയും)</span> നിഷേധിച്ചവരേ!" -<span class="c6"> അല്ലാഹുവിൻ്റെ റസൂലേ! പറയുക:</span> അല്ലയോ അല്ലാഹുവിൽ വിശ്വസിക്കാത്തവരേ!<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109002.mp3"></audio> 2- "നിങ്ങൾ ആരാധിച്ചുവരുന്നതിനെ ഞാൻ ആരാധിക്കുന്നില്ല." - ഇന്നോ ഇനിയെന്നെങ്കിലുമോ ഞാൻ നിങ്ങൾ ആരാധിക്കുന്ന വിഗ്രഹങ്ങളെ ആരാധിക്കുകയില്ല.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109003.mp3"></audio> 3- "ഞാൻ ആരാധിച്ചു വരുന്നതിനെ നിങ്ങളും ആരാധിക്കാൻ പോകുന്നവരല്ല." - ഞാൻ ആരാധിക്കുന്നതിനെ - അല്ലാഹുവിനെ മാത്രം - നിങ്ങളും ആരാധിക്കുന്നവരല്ല.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109004.mp3"></audio> 4- "നിങ്ങൾ ആരാധിക്കുന്ന വിഗ്രഹങ്ങളെ ആരാധിക്കുന്നവനുമല്ല ഞാൻ." - നിങ്ങൾ ആരാധിക്കുന്ന വിഗ്രഹങ്ങളെ ആരാധിക്കുന്നവനുമല്ല ഞാൻ.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109005.mp3"></audio> 5- "ഞാൻ ആരാധിച്ചു വരുന്നതിനെ നിങ്ങളും ആരാധിക്കാൻ പോകുന്നവരല്ല." - ഞാൻ ആരാധിക്കുന്നതിനെ - അല്ലാഹുവിനെ മാത്രം - നിങ്ങളും ആരാധിക്കുന്നവരല്ല.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109006.mp3"></audio> 6- "നിങ്ങൾക്ക് നിങ്ങളുടെ മതം. എനിക്ക് എൻ്റെ മതവും." - നിങ്ങൾ സ്വയം പടച്ചുണ്ടാക്കിയ മതം നിങ്ങൾക്ക്! എനിക്ക് അല്ലാഹു എൻ്റെ മേൽ അവതരിപ്പിച്ചു തന്ന എൻ്റെ മതം മതി. </p>',
            ],
            12 => [
                'question' => 'ചോദ്യം 2: സൂറതുൽ നസ്വ്\'ർ പാരായണം ചെയ്യുകയും അതിൻ്റെ വിശദീകരണം പറയുകയും ചെയ്യുക.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8470.mp3',
                'answer' => '<p> ഉത്തരം: സൂറത്തുൽ നസ്വ്\'റിലെ ആയത്തുകളും, അവയുടെ വിശദീകരണവും ഇപ്രകാരമാണ്.<br /> <br /> പരമകാരുണികനും കരുണാനിധിയുമായ അല്ലാഹുവിൻ്റെ നാമത്തിൽ.<br /> <br /> അല്ലാഹുവിൻ്റെ സഹായവും വിജയവും വന്നുകിട്ടിയാൽ. ജനങ്ങൾ അല്ലാഹുവിൻ്റെ മതത്തിൽ കൂട്ടംകൂട്ടമായി പ്രവേശിക്കുന്നത് താങ്കൾ കാണുകയും ചെയ്താൽ. നിൻ്റെ രക്ഷിതാവിനെ സ്തുതിക്കുന്നതോടൊപ്പം നീ അവനെ പ്രകീർത്തിക്കുകയും, അവനോട് പാപമോചനം തേടുകയും ചെയ്യുക. തീർച്ചയായും അവൻ പശ്ചാത്താപം സ്വീകരിക്കുന്നവനാകുന്നു. <span class="c2">(നസ്വ്\'ർ: 1-3)</span><br /> വിശദീകരണം:<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/110001.mp3"></audio> 1- "അല്ലാഹുവിൻ്റെ സഹായവും വിജയവും വന്നുകിട്ടിയാൽ." അല്ലാഹുവിൻ്റെ റസൂലേ! താങ്കളുടെ മതത്തിന് അല്ലാഹുവിൻ്റെ സഹായം ലഭിക്കുകയും, അവൻ അതിനെ പ്രതാപമുള്ളതാക്കുകയും, മക്ക വിജയിച്ചടക്കുകയും ചെയ്താൽ.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/110002.mp3"></audio> 2- "ജനങ്ങൾ അല്ലാഹുവിൻ്റെ മതത്തിൽ കൂട്ടംകൂട്ടമായി പ്രവേശിക്കുന്നത് താങ്കൾ കാണുകയും ചെയ്താൽ." - ജനങ്ങൾ ഇസ്ലാമിലേക്ക് ഒരോരോ നിവേദകസംഘങ്ങളായി -കൂട്ടംകൂട്ടമായി- പ്രവേശിക്കുന്നത് താങ്കൾ കാണുകയും ചെയ്താൽ.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/110003.mp3"></audio> 3- "നിൻ്റെ രക്ഷിതാവിനെ സ്തുതിക്കുന്നതോടൊപ്പം താങ്കൾ അവനെ പ്രകീർത്തിക്കുകയും, നീ അവനോട് പാപമോചനം തേടുകയും ചെയ്യുക. തീർച്ചയായും അവൻ പശ്ചാത്താപം സ്വീകരിക്കുന്നവനാകുന്നു." - <span class="c2">(അത് സംഭവിച്ചാൽ)</span> നിൻ്റെ മേൽ ഏൽപ്പിക്കപ്പെട്ട ബാധ്യത അവസാനിക്കാറായി എന്നതിൻ്റെ അടയാളമാണത് എന്ന് നീ മനസ്സിലാക്കുക. അപ്പോൾ നിൻ്റെ രക്ഷിതാവ് നിനക്ക് നൽകിയ വിജയത്തിനും സഹായത്തിനും നന്ദിയായി കൊണ്ട്, അവനെ സ്തുതിച്ചു കൊണ്ട് പ്രകീർത്തിക്കുക. അവനോട് പാപമോചനം തേടുകയും ചെയ്യുക. തൻ്റെ അടിമകളുടെ പശ്ചാത്താപം അങ്ങേയറ്റം സ്വീകരിക്കുകയും, അവർക്ക് പൊറുത്തു കൊടുക്കുകയും ചെയ്യുന്ന \'തവ്വാബ്\' ആണവൻ. </p>',
            ],
            13 => [
                'question' => 'ചോദ്യം 2: സൂറ. മസദ് പാരായണം ചെയ്യുകയും അതിൻ്റെ വിശദീകരണം പറയുകയും ചെയ്യുക.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8550.mp3',
                'answer' => '<p> ഉത്തരം: സൂറതുൽ മസദിലെ ആയത്തുകളും, അവയുടെ വിശദീകരണവും ഇപ്രകാരമാണ്.<br /> <br /> പരമകാരുണികനും കരുണാനിധിയുമായ അല്ലാഹുവിൻ്റെ നാമത്തിൽ.<br /> <br /> അബൂലഹബിൻ്റെ ഇരുകൈകളും നശിച്ചിരിക്കുന്നു. അവൻ നാശമടയുകയും ചെയ്തിരിക്കുന്നു. അവൻ്റെ ധനമോ അവൻ സമ്പാദിച്ചുവെച്ചതോ അവനു ഉപകാരപ്പെട്ടില്ല. തീജ്വാലകളുള്ള നരകാഗ്നിയിൽ അവൻ കടന്നെരിയുന്നതാണ്. വിറകുചുമട്ടുകാരിയായ അവൻ്റെ ഭാര്യയും. അവളുടെ കഴുത്തിൽ ഈന്തപ്പനനാരുകൊണ്ടുള്ള ഒരു കയറുണ്ടായിരിക്കും. <span class="c2">(മസദ്: 1-5)</span><br /> വിശദീകരണം:<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111001.mp3"></audio> 1- "അബൂലഹബിൻ്റെ ഇരുകൈകളും നശിച്ചിരിക്കുന്നു. അവൻ നാശമടയുകയും ചെയ്തിരിക്കുന്നു." - നബി-ﷺ-യുടെ പിതൃസഹോദരനായ അബൂലഹബ് ബ്നു അബ്ദിൽ മുത്വലിബിൻ്റെ പ്രവർത്തനങ്ങളെല്ലാം നിഷ്ഫലമായതിലൂടെ അവന്റെ രണ്ട് കൈകളും നശിച്ചിരിക്കുന്നു. കാരണം അയാൾ നബി-ﷺ-യെ ഉപദ്രവിക്കാറുണ്ടായിരുന്നു. അവൻ്റെ എല്ലാ പരിശ്രമങ്ങളും പരാജയപ്പെടുകയും ചെയ്തിരിക്കുന്നു.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111002.mp3"></audio> 2- "അവൻ്റെ ധനമോ അവൻ സമ്പാദിച്ചുവെച്ചതോ അവനു ഉപകാരപ്പെട്ടില്ല." - അവൻ്റെ സമ്പാദ്യവും സന്താനങ്ങളും എന്ത് നേട്ടമാണ് അവന് നേടിക്കൊടുത്തത്? അവയൊന്നും അല്ലാഹുവിൻ്റെ ശിക്ഷയെ തടുക്കുകയോ, അവൻ്റെ കാരുണ്യം നേടിക്കൊടുക്കുകയോ ചെയ്തില്ല.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111003.mp3"></audio> 3- "തീജ്വാലകളുള്ള നരകാഗ്നിയിൽ അവൻ പ്രവേശിക്കുന്നതാണ്." - ഖിയാമത്ത് നാളിൽ കത്തിയെരിയുന്ന തീജ്വാലകളുള്ള നരകത്തിൽ അവൻ പ്രവേശിക്കുന്നതാണ്. അതിൻ്റെ കടുത്ത ചൂട് അവൻ അനുഭവിക്കുകയും ചെയ്യും.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111004.mp3"></audio> 4- "വിറകുചുമട്ടുകാരിയായ അവൻ്റെ ഭാര്യയും." - അവൻ്റെ ഭാര്യ -ഉമ്മു ജമീലും- <span class="c2">(കത്തിയെരിയുന്ന തീജ്വാലകളുള്ള)</span> നരകത്തിൽ പ്രവേശിക്കുന്നതാണ്. നബി-ﷺ-യുടെ വഴികളിൽ മുള്ളുകൾ വിതറി അവൾ അവിടുത്തെ ഉപദ്രവിക്കാറുണ്ടായിരുന്നു.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111005.mp3"></audio> 5- "അവളുടെ കഴുത്തിൽ ഈന്തപ്പനനാരുകൊണ്ടുള്ള ഒരു കയറുണ്ടായിരിക്കും." - കെട്ടിമെടഞ്ഞ ഒരു കയർ അവളുടെ കഴുത്തിലുണ്ടായിരിക്കും; അതിൽ പിടിച്ച് അവളെ നരകത്തിലേക്ക് വലിച്ചിഴക്കുന്നതാണ്. </p>',
            ],
            14 => [
                'question' => 'ചോദ്യം 2: സൂറ. ഇഖ്\'ലാസ് പാരായണം ചെയ്യുകയും അതിൻ്റെ വിശദീകരണം പറയുകയും ചെയ്യുക.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8650.mp3',
                'answer' => '<p> ഉത്തരം: സൂറത്തുൽ ഇഖ്\'ലാസിലെ ആയത്തുകളും, അവയുടെ വിശദീകരണവും ഇപ്രകാരമാണ്.<br /> <br /> പരമകാരുണികനും കരുണാനിധിയുമായ അല്ലാഹുവിൻ്റെ നാമത്തിൽ.<br /> <br /> <span class="c2">(നബിയേ,)</span> പറയുക: കാര്യം അല്ലാഹു ഏകനാണ് എന്നതാകുന്നു. അല്ലാഹു സർവ്വരുടെയും ആശ്രയമായ, എന്നാൽ സ്വയം നിരാശ്രയനായ <span class="c2">(സ്വമദ്)</span> ആകുന്നു. അവൻ <span class="c2">(ആർക്കും)</span> ജന്മം നല്കിയിട്ടില്ല. <span class="c2">(ആരുടെയും സന്തതിയായി)</span> ജനിച്ചിട്ടുമില്ല. അവന്ന് തുല്യനായി ആരും ഇല്ലതാനും <span class="c2">(ഇഖ്\'ലാസ്: 1-4)</span><br /> വിശദീകരണം:<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112001.mp3"></audio> 1- "<span class="c2">(നബിയേ,)</span> പറയുക: കാര്യം അല്ലാഹു ഏകനാണ് എന്നതാകുന്നു." - പറയുക; -അല്ലാഹുവിൻ്റെ റസൂലേ!- അവനാകുന്നു അല്ലാഹു; ആരാധിക്കപ്പെടാൻ അർഹതയുള്ള ഒരേയൊരുവൻ. അവനല്ലാതെ മറ്റൊരു ആരാധ്യനില്ല.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112002.mp3"></audio> 2- "അല്ലാഹു സർവ്വരുടെയും ആശ്രയമായ, എന്നാൽ സ്വയം നിരാശ്രയനായ <span class="c2">(സ്വമദ്)</span> ആകുന്നു." - പൂർണതയുടെയും ഭംഗിയുടെയും എല്ലാ വിശേഷണങ്ങളും അതിൻ്റെ ഏറ്റവും മഹത്വത്തോടെയും ഉയർച്ചയോടെയും ഉള്ളവനായ \'സയ്യിദ്\' ആണ് അല്ലാഹു. എല്ലാ സൃഷ്ടികളും അവനിലേക്ക് ആശ്രയം തേടുന്നു.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112003.mp3"></audio> 3- "അവൻ <span class="c2">(ആർക്കും)</span> ജന്മം നല്കിയിട്ടില്ല. <span class="c2">(ആരുടെയും സന്തതിയായി)</span> ജനിച്ചിട്ടുമില്ല." - അവൻ ആർക്കും ജന്മം നൽകിയിട്ടില്ല. ആരുടെയും മകനുമല്ല അവൻ. അവന് സന്താനവുമില്ല; പിതാവുമില്ല.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112004.mp3"></audio> 4- "അവന്ന് തുല്യനായി ആരും ഇല്ലതാനും." - അവനോട് തുല്യനായ ഒരാളും തന്നെ അവൻ്റെ സൃഷ്ടികളിലില്ല. </p>',
            ],
            15 => [
                'question' => 'ചോദ്യം 2: സൂറതുൽ ഫലഖ് പാരായണം ചെയ്യുകയും അതിൻ്റെ വിശദീകരണം പറയുകയും ചെയ്യുക.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8750.mp3',
                'answer' => '<p> ഉത്തരം: സൂറത്തുൽ ഫലഖിലെ ആയത്തുകളും, അവയുടെ വിശദീകരണവും ഇപ്രകാരമാണ്.<br /> <br /> പരമകാരുണികനും കരുണാനിധിയുമായ അല്ലാഹുവിൻ്റെ നാമത്തിൽ.<span class="c6"><br /> <br /> പറയുക:</span> മനുഷ്യരുടെ രക്ഷിതാവിനോട് ഞാൻ ശരണം തേടുന്നു. അവൻ സൃഷ്ടിച്ചിട്ടുള്ളവയുടെ കെടുതിയിൽ നിന്ന്. ഇരുളടയുമ്പോഴുള്ള രാത്രിയുടെ കെടുതിയിൽ നിന്നും. കെട്ടുകളിൽ ഊതുന്ന സ്ത്രീകളുടെ കെടുതിയിൽ നിന്നും അസൂയാലു അസൂയപ്പെടുമ്പോൾ അവൻ്റെ കെടുതിയിൽ നിന്നും. <span class="c2">(ഫലഖ്: 1-5)</span><br /> വിശദീകരണം:<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113001.mp3"></audio> 1-<span class="c6"> "പറയുക:</span> മനുഷ്യരുടെ രക്ഷിതാവിനോട് ഞാൻ ശരണം തേടുന്നു." - പറയുക; -അല്ലാഹുവിൻ്റെ റസൂലേ!- പുലരിയുടെ രക്ഷിതാവിനോട് ഞാൻ അഭയം തേടുകയും, അവനോട് ഞാൻ രക്ഷ ചോദിക്കുകയും ചെയ്യുന്നു.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113002.mp3"></audio> 2- "അവൻ സൃഷ്ടിച്ചിട്ടുള്ളവയുടെ കെടുതിയിൽ നിന്ന്." - ഉപദ്രവകാരികളായ സൃഷ്ടികളുടെ കെടുതിയിൽ നിന്ന്.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113003.mp3"></audio> 3- "ഇരുളടയുമ്പോഴുള്ള രാത്രിയുടെ കെടുതിയിൽ നിന്നും." - രാത്രിയിൽ പുറത്തു വരുന്ന ഉപദ്രവങ്ങളിൽ നിന്നും - വിഷജന്തുക്കൾ, കള്ളന്മാർ തുടങ്ങിയവ - ഞാൻ അല്ലാഹുവിൽ അഭയം തേടുന്നു.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113004.mp3"></audio> 4- "കെട്ടുകളിൽ ഊതുന്ന സ്ത്രീകളുടെ കെടുതിയിൽ നിന്നും." - കെട്ടുകളിൽ ഊതുന്ന മാരണക്കാരികളായ സ്ത്രീകളുടെ കെടുതിയിൽ നിന്നും.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113005.mp3"></audio> 5- "അസൂയാലു അസൂയപ്പെടുമ്പോൾ അവൻ്റെ കെടുതിയിൽ നിന്നും." - അസൂയക്കാരൻ തൻ്റെ അസൂയ കാരണത്താൽ ചെയ്യുന്ന ഉപദ്രവങ്ങളിൽ നിന്നും. അല്ലാഹു ജനങ്ങൾക്ക് നൽകിയ അനുഗ്രഹങ്ങളുടെ പേരിൽ അവന് അവരോട് അസൂയയാണ്. അങ്ങനെ അവരോട് അവൻ വിദ്വേഷം വെച്ചുപുലർത്തുന്നു. അവർക്ക് ലഭിച്ച അനുഗ്രഹങ്ങൾ ഇല്ലാതാകണമെന്നും അവർക്ക് പ്രയാസങ്ങൾ വന്നുഭവിക്കണമെന്നും അവൻ ആഗ്രഹിക്കുന്നു. </p>',
            ],
            16 => [
                'question' => 'ചോദ്യം 3: സൂറ. നാസ് പാരായണം ചെയ്യുകയും അതിൻ്റെ വിശദീകരണം പറയുകയും ചെയ്യുക.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8870.mp3',
                'answer' => '<p> ഉത്തരം: സൂറ. നാസിലെ ആയത്തുകളും, അവയുടെ വിശദീകരണവും ഇപ്രകാരമാണ്.<br /> <br /> പരമകാരുണികനും കരുണാനിധിയുമായ അല്ലാഹുവിൻ്റെ നാമത്തിൽ.<span class="c6"><br /> <br /> പറയുക:</span> മനുഷ്യരുടെ രക്ഷിതാവിനോട് ഞാൻ ശരണം തേടുന്നു. മനുഷ്യരുടെ രാജാവിനോട്. മനുഷ്യരുടെ സാക്ഷാൽ ആരാധ്യനോട്. ദുർബോധനം നടത്തി പിന്മാറിക്കളയുന്നവരെക്കൊണ്ടുള്ള കെടുതിയിൽ നിന്ന്. മനുഷ്യരുടെ ഹൃദയങ്ങളിൽ ദുർബോധനം നടത്തുന്നവർ. മനുഷ്യരിലും ജിന്നുകളിലും പെട്ടവർ. <span class="c2">(നാസ്: 1-6)</span><br /> വിശദീകരണം:<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114001.mp3"></audio> 1-<span class="c6"> "പറയുക:</span> മനുഷ്യരുടെ രക്ഷിതാവിനോട് ഞാൻ ശരണം തേടുന്നു." - പറയുക; -അല്ലാഹുവിൻ്റെ റസൂലേ!- പുലരിയുടെ രക്ഷിതാവിനോട് ഞാൻ അഭയം തേടുകയും, അവനോട് ഞാൻ രക്ഷ ചോദിക്കുകയും ചെയ്യുന്നു.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114002.mp3"></audio> 2- "മനുഷ്യരുടെ രാജാവിനോട്." - ജനങ്ങളുടെ കാര്യത്തിൽ ഉദ്ദേശം പോലെ കൈകാര്യകർതൃത്വം നിർവ്വഹിക്കുന്ന, ജനങ്ങളുടെ രാജാവിനോട്. മനുഷ്യർക്ക് അവനല്ലാതെ മറ്റൊരു രാജാധിരാജനില്ല.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114003.mp3"></audio> 3- "മനുഷ്യരുടെ ആരാധ്യനോട്." - അവരുടെ യഥാർഥ ആരാധ്യനോട്; ആരാധിക്കപ്പെടാൻ അർഹതയുള്ള മറ്റൊരു ആരാധ്യനും അവർക്കില്ല.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114004.mp3"></audio> 4- "ദുർബോധനം നടത്തി പിന്മാറിക്കളയുന്നവരെക്കൊണ്ടുള്ള കെടുതിയിൽ നിന്ന്." - അല്ലാഹുവിനെ കുറിച്ചുള്ള സ്മരണയിൽ നിന്ന് അശ്രദ്ധമായാൽ ദുർമന്ത്രണം നടത്തുന്ന പിശാചിൻ്റെ ഉപദ്രവത്തിൽ നിന്ന്. അല്ലാഹുവിനെ സ്മരിച്ചാൽ അതിൽ നിന്ന് പിന്മാറുന്നവനുമാണവൻ.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114005.mp3"></audio> 5- "മനുഷ്യരുടെ ഹൃദയങ്ങളിൽ ദുർബോധനം നടത്തുന്നവർ." - മനുഷ്യരുടെ ഹൃദയങ്ങളിൽ അവൻ തൻ്റെ ദുർബോധനം ഇട്ടുകൊടുക്കുന്നു.<br /> <br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114006.mp3"></audio> 6- "മനുഷ്യരിലും ജിന്നുകളിലും പെട്ടവർ." - ജിന്നുകളിൽ പിശാച് ഉള്ളതു പോലെ മനുഷ്യരിലും പിശാചുക്കൾ ഉണ്ട്. </p>',
            ],
        ],
        5 => [
            0 => [
                'question' => 'ചോദ്യം: "പ്രവർത്തനങ്ങൾ നിയ്യത്തുകളുടെ അടിസ്ഥാനത്തിൽ മാത്രമാണ്." - ഈ ഹദീഥ് പൂർണ്ണമായും, അതിൽ നിന്നുള്ള ചില പാഠങ്ങളും പറയുക.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9030.mp3',
                'answer' => '<p> ഉത്തരം: അമീറുൽ മുഅ്മിനീൻ ഉമർ ബ്നുൽ ഖത്താബ് -رَضِيَ اللَّهُ عَنْهُ-<span class="c6"> നിവേദനം:</span> നബി -ﷺ-<span class="c6"> പറയുന്നതായി ഞാൻ കേട്ടു:</span> "പ്രവർത്തനങ്ങൾ ഉദ്ദേശങ്ങളുടെ അടിസ്ഥാനത്തിൽ മാത്രമാണ്. ഓരോ വ്യക്തിക്കും അവൻ ഉദ്ദേശിച്ചത് മാത്രമാണ് ഉണ്ടായിരിക്കുക. ആരുടെയെങ്കിലും പലായനം അല്ലാഹുവിലേക്കും അവൻ്റെ റസൂലിലേക്കുമാണെങ്കിൽ അവൻ്റെ ആ പലായനം അല്ലാഹുവിലേക്കും റസൂലിലേക്കുമാണ്. ആരുടെയെങ്കിലും പലായനം നേടാനുദ്ദേശിക്കുന്ന എന്തെങ്കിലും ഐഹികവിഭവത്തിനോ, വിവാഹം കഴിക്കാൻ ഉദ്ദേശിക്കുന്ന സ്ത്രീക്ക് വേണ്ടിയോ ആണെങ്കിൽ അവൻ്റെ പലായനം അവൻ എന്തിലേക്കാണോ ചെയ്തത്; അതിലേക്കാണ്.<span class="c6">" ഇത് ബുഖാരിയും മുസ്ലിമും ഉദ്ധരിച്ചിരിക്കുന്നു<br /> ഹദീഥിൽ നിന്നുള്ള ഗുണപാഠങ്ങൾ:</span><br /> <br /> 1- ഏതൊരു പ്രവർത്തിക്കും മുൻപ് നിയ്യത്ത് ഉണ്ടായിരിക്കണം. നിസ്കാരവും നോമ്പും ഹജ്ജും മറ്റു പ്രവർത്തനങ്ങൾക്കുമെല്ലാം നിയ്യത്ത് ഉണ്ടായിരിക്കണം.<br /> <br /> 2- നിയ്യത്ത് വെക്കുമ്പോൾ അല്ലാഹുവിന് വേണ്ടി മാത്രമാണ് ഞാൻ ഈ പ്രവർത്തനം ചെയ്യുന്നത് എന്ന ഉദ്ദേശ്യം ഉണ്ടായിരിക്കണം.<br /> <br /> ഹദീഥ് <span class="c2">(2)</span> </p>',
            ],
            1 => [
                'question' => 'ചോദ്യം 2: "നമ്മുടെ ഈ കാര്യത്തിൽ ആരെങ്കിലും എന്തെങ്കിലും പുതുതായി ഉണ്ടാക്കിയാൽ" എന്ന ഹദീഥ് പൂർണ്ണമായി പറയുകയും, അതിൽ നിന്നുള്ള ചില പാഠങ്ങൾ വിവരിക്കുകയും ചെയ്യുക.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9090.mp3',
                'answer' => '<p> ഉത്തരം: ഉമ്മുൽ മുഅ്മിനീൻ ഉമ്മു അബ്ദില്ലാഹ് ആഇശാ -رَضِيَ اللَّهُ عَنْهَا-<span class="c6"> നിവേദനം:</span> നബി -ﷺ-<span class="c6"> പറഞ്ഞു:</span> നമ്മുടെ ഇക്കാര്യത്തിൽ <span class="c2">(ഇസ്ലാം ദീനിൽ)</span> അതിലില്ലാത്ത വല്ലതും ആരെങ്കിലും പുതുതായി നിർമ്മിച്ചുവിട്ടാൽ അത് തള്ളപ്പെടേണ്ടതാണ്.<span class="c6">" ഇത് ബുഖാരിയും മുസ്ലിമും ഉദ്ധരിച്ചിരിക്കുന്നു<br /> ഹദീഥിൽ നിന്നുള്ള ഗുണപാഠങ്ങൾ:</span><br /> <br /> 1- ദീനിൽ പുതിയ കാര്യങ്ങൾ നിർമ്മിക്കുന്നത് നബി -ﷺ- വിലക്കിയിരിക്കുന്നു.<br /> <br /> 2- ഇസ്ലാമിൽ കടത്തികൂട്ടപ്പെട്ട പുതിയ കാര്യങ്ങൾ തള്ളിക്കളയേണ്ടതാണ്; അവ സ്വീകരിക്കരുത്.<br /> <br /> ഹദീഥ് <span class="c2">(3)</span> </p>',
            ],
            2 => [
                'question' => 'ചോദ്യം 3: \'ഞങ്ങൾ നബി -ﷺ- യുടെ അരികിൽ ഇരിക്കുമ്പോൾ..." എന്ന് തുടങ്ങുന്ന ഹദീഥ് പൂർണ്ണമായി പറയുക. അതിലെ ചില പാഠങ്ങളും വിവരിക്കുക.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9160.mp3',
                'answer' => '<p> ഉമർ -رَضِيَ اللَّهُ عَنْهُ-<span class="c6"> നിവേദനം:</span> ഒരു ദിവസം ഞങ്ങൾ നബി -ﷺ- യുടെ അരികിൽ ഇരിക്കുന്ന വേളയിൽ ഒരു വ്യക്തി ഞങ്ങൾക്കിടയിലേക്ക് കടന്നു വന്നു. തൂവെള്ള നിറമുള്ള വസ്ത്രവും, കറുകറുത്ത മുടിയുമാണ് അദ്ദേഹത്തിൻ്റേത്. യാത്രയുടെ അടയാളങ്ങളൊന്നും അദ്ദേഹത്തിൽ കാണപ്പെട്ടില്ല. ഞങ്ങളിലാർക്കും അദ്ദേഹത്തെ അറിയുകയുമില്ല. അങ്ങനെ അദ്ദേഹം നബി -ﷺ- യുടെ അരികിലേക്ക് വന്നിരിക്കുകയും, തൻ്റെ കാൽമുട്ട് നബി -ﷺ- യുടെ കാൽമുട്ടിനോട് ചേർത്തു വെക്കുകയും, തൻ്റെ കൈപ്പത്തികൾ അവിടുത്തെ തുടമേൽ വെക്കുകയും ചെയ്തു.<span class="c6"> അദ്ദേഹം പറഞ്ഞു:</span> മുഹമ്മദ്! ഇസ്ലാമിനെ കുറിച്ച് എനിക്ക് പറഞ്ഞു തരിക?! നബി -ﷺ-<span class="c6"> പറഞ്ഞു:</span> "ഇസ്ലാം എന്നാൽ താങ്കൾ അല്ലാഹുവല്ലാതെ ആരാധനക്ക് അർഹനായി മറ്റാരുമില്ലെന്നും മുഹമ്മദ് -ﷺ- അല്ലാഹുവിൻ്റെ ദൂതനാണെന്നും സാക്ഷ്യം വഹിക്കലും, നമസ്കാരം നിലനിർത്തലും, സകാത്ത് നൽകലും, റമദാൻ മാസത്തിൽ നോമ്പനുഷ്ഠിക്കലും, സാധ്യമാണെങ്കിൽ ഹജ്ജ് നിർവ്വഹിക്കുകയും ചെയ്യലാണ്.<span class="c6">" അദ്ദേഹം പറഞ്ഞു:</span> "താങ്കൾ പറഞ്ഞത് ശരിയാണ്." ഞങ്ങൾ അയാളുടെ കാര്യത്തിൽ അത്ഭുതപ്പെട്ടു; നബി -ﷺ- യോട് ചോദിക്കുകയും, പറഞ്ഞത് ശരിയാണെന്ന് അയാൾ തന്നെ സത്യപ്പെടുത്തുകയും ചെയ്യുകയോ?! <span class="c2">(ശേഷം)</span> അദ്ദേഹം ചോദിച്ചു: എങ്കിൽ ഈമാനിനെ കുറിച്ച് എനിക്ക് പറഞ്ഞു തരിക? നബി -ﷺ-<span class="c6"> പറഞ്ഞു:</span> "ഈമാൻ എന്നാൽ നീ അല്ലാഹുവിലും, അവൻ്റെ മലക്കുകളിലും, അവൻ്റെ ഗ്രന്ഥങ്ങളിലും, അവൻ്റെ ദൂതന്മാരിലും, അന്ത്യനാളിലും വിശ്വസിക്കലാണ്. അല്ലാഹുവിൻ്റെ വിധിനിർണ്ണയത്തിൽ -അതിൻ്റെ നന്മയിലും തിന്മയിലും- വിശ്വസിക്കലുമാണ്.<span class="c6">" അദ്ദേഹം പറഞ്ഞു:</span> താങ്കൾ പറഞ്ഞത് ശരിയാണ്. എങ്കിൽ എനിക്ക് ഇഹ്സാനിനെ കുറിച്ച് പറഞ്ഞു തരിക! നബി -ﷺ-<span class="c6"> പറഞ്ഞു:</span> "<span class="c2">(ഇഹ്സാൻ എന്നാൽ)</span> അല്ലാഹുവിനെ കാണുന്നത് പോലെ താങ്കൾ അവനെ ആരാധിക്കലാണ്. താങ്കൾ അവനെ കാണുന്നില്ലെങ്കിലും അവൻ താങ്കളെ കാണുന്നുണ്ട്.<span class="c6">" അദ്ദേഹം പറഞ്ഞു:</span> "എങ്കിൽ അന്ത്യനാളിനെ കുറിച്ച് എനിക്ക് അറിയിച്ചു തരിക." നബി -ﷺ-<span class="c6"> പറഞ്ഞു:</span> "ചോദിക്കപ്പെടുന്ന വ്യക്തി ചോദ്യകർത്താവിനേക്കാൾ കൂടുതലായി അതിനെ കുറിച്ച് യാതൊരു അറിവുമുള്ളവനല്ല.<span class="c6">" അദ്ദേഹം പറഞ്ഞു:</span> "എങ്കിൽ അതിൻ്റെ അടയാളങ്ങളെ കുറിച്ച് എനിക്ക് പറഞ്ഞു തരിക." നബി -ﷺ-<span class="c6"> പറഞ്ഞു:</span> "അടിമ സ്ത്രീ തൻ്റെ ഉടമസ്ഥയെ പ്രസവിക്കലും, നഗ്നരും നഗ്നപാദരും ദരിദ്രരുമായ ആട്ടിടയന്മാർ ഉയർന്ന കെട്ടിടങ്ങൾ നിർമ്മിക്കുന്നതിൽ പരസ്പരം മത്സരിക്കലുമാണ്." ശേഷം അദ്ദേഹം അവിടെ നിന്ന് പോയി. അങ്ങനെ കുറച്ച് കഴിഞ്ഞപ്പോൾ നബി -ﷺ-<span class="c6"> പറഞ്ഞു:</span> "ഉമർ! ആ ചോദ്യകർത്താവ് ആരാണെന്ന് നിനക്കറിയുമോ?!" ഞാൻ പറഞ്ഞു: "അല്ലാഹുവിനും റസൂലിനുമാണ് ഏറ്റവും അറിയുക.<span class="c6">" അവിടുന്ന് പറഞ്ഞു:</span> "അത് ജിബ്രീലാണ്. നിങ്ങൾക്ക് നിങ്ങളുടെ മതം പഠിപ്പിച്ചു നൽകുന്നതിനായി വന്നതാണ്." <span class="c2">(മുസ്ലിം)</span><br /> ഹദീഥിൽ നിന്നുള്ള ഗുണപാഠങ്ങൾ:<br /> <br /> 1- ഇസ്ലാമിൻ്റെ അഞ്ച് സ്തംഭങ്ങൾ ഈ ഹദീഥിൽ വിവരിക്കപ്പെട്ടിരിക്കുന്നു.<span class="c6"> അവ താഴെ പറയുന്നതാണ്:</span><br /> <br /> ലാ ഇലാഹ ഇല്ലല്ലാഹ്, മുഹമ്മദുൻ റസൂലുല്ലാഹ്\' <span class="c2">(അല്ലാഹുവല്ലാതെ ആരാധനക്ക് അർഹനായി ആരുമില്ല, മുഹമ്മദ് നബി അല്ലാഹുവിൻ്റെ ദൂതനാണ്)</span> എന്ന് സാക്ഷ്യം വഹിക്കൽ.<br /> <br /> നിസ്കാരം നിലനിർത്തൽ.<br /> <br /> സകാത്ത് നൽകൽ.<br /> <br /> റമദാൻ മാസത്തിൽ നോമ്പെടുക്കൽ.<br /> <br /> അല്ലാഹുവിൻ്റെ ഭവനമായ കഅ്ബയിൽ ഹജ്ജ് നിർവ്വഹിക്കൽ.<br /> <br /> 2- ഈമാനിൻ്റെ ആറ് സ്തംഭങ്ങൾ ഈ ഹദീഥിൽ വിവരിക്കപ്പെട്ടിരിക്കുന്നു.<span class="c6"> അവ താഴെ പറയുന്നതാണ്:</span><br /> <br /> അല്ലാഹുവിലുള്ള വിശ്വാസം<br /> <br /> അല്ലാഹുവിൻ്റെ മലക്കുകളിലുള്ള വിശ്വാസം.<br /> <br /> അല്ലാഹുവിൻ്റെ വേദഗ്രന്ഥങ്ങളിലെ വിശ്വാസം.<br /> <br /> അല്ലാഹുവിൻ്റെ റസൂലുകളിലുള്ള വിശ്വാസം.<br /> <br /> അന്ത്യനാളിലുള്ള വിശ്വാസം.<br /> <br /> ഖദാ ഖദറിലുള്ള <span class="c2">(അല്ലാഹുവിൻ്റെ വിധിയിലുള്ള)</span> -അതിൻ്റെ നന്മയിലും തിന്മയിലുമുള്ള- വിശ്വാസം.<br /> <br /> 3-<span class="c6"> ഇഹ്സാനിൻ്റെ സ്തംഭം ഈ ഹദീഥിൽ വിവരിക്കപ്പെട്ടിരിക്കുന്നു:</span> അല്ലാഹുവിനെ നീ കാണുന്നുണ്ട് എന്നത് പോലെ അവനെ ആരാധിക്കലാണത്; നീ അവനെ കാണുന്നില്ലെങ്കിലും അവൻ നിന്നെ കണ്ടുകൊണ്ടിരിക്കുന്നുണ്ട്.<br /> <br /> 4- അന്ത്യനാൾ സംഭവിക്കുന്ന സമയമോ ദിവസമോ ഒരാൾക്കും അറിയുന്നതല്ല.<br /> <br /> ഹദീഥ് <span class="c2">(4)</span> </p>',
            ],
            3 => [
                'question' => 'ചോദ്യം: "മുഅ്മിനീങ്ങളിൽ ഏറ്റവും പൂർണ്ണതയുള്ളവൻ..." - ഈ ഹദീഥ് പൂർത്തീകരിക്കുകയും, അതിൽ നിന്നുള്ള ചില പാഠങ്ങൾ പറയുകയും ചെയ്യുക.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9360.mp3',
                'answer' => '<p> ഉത്തരം: അബൂ സഈദ് അൽ ഖുദ്രി <span class="c2">(رَضِيَ اللَّهُ عَنْهُ)</span> നിവേദനം: അല്ലാഹുവിൻ്റെ റസൂൽ <span class="c2">(ﷺ)</span> പറഞ്ഞിരിക്കുന്നു: "മുഅ്മിനീങ്ങളിൽ ഏറ്റവും പൂർണ്ണമായും ഈമാനുള്ളവൻ അവരിൽ ഏറ്റവും നല്ല സ്വഭാവമുള്ളവനാണ്." <span class="c2">(തിർമിദി)</span><br /> ഹദീസിൽ നിന്നുള്ള ഗുണ പാഠങ്ങൾ<br /> <br /> 1- സൽസ്വഭാവം പുലർത്താനുള്ള പ്രോത്സാഹനവും പ്രേരണയും.<br /> <br /> 2- സൽസ്വഭാവത്തിൻ്റെ പൂർണ്ണത ഈമാനിൻ്റെ പൂർണ്ണതയിൽ പെട്ടതാണ്.<br /> <br /> 3- ഈമാൻ വർദ്ധിക്കുകയും കുറയുകയും ചെയ്യുന്നതാണ്.<br /> <br /> ഹദീഥ് <span class="c2">(5)</span> </p>',
            ],
            4 => [
                'question' => 'ചോദ്യം 5: "ആരെങ്കിലും അല്ലാഹുവിന് പുറമെയുള്ളവരെ കൊണ്ട് സത്യം ചെയ്താൽ..." എന്ന ഹദീഥിൽ നിന്ന് ചില പാഠങ്ങൾ പറയുക.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9440.mp3',
                'answer' => '<p> ഉത്തരം: അബ്ദുല്ലാഹി ബ്നു ഉമർ -رَضِيَ اللَّهُ عَنْهُمَا-<span class="c6"> നിവേദനം:</span> നബി -ﷺ-<span class="c6"> പറഞ്ഞു:</span> "ആരെങ്കിലും അല്ലാഹുവിന് പുറമെയുള്ളവരെ കൊണ്ട് സത്യം ചെയ്താൽ അവൻ കുഫ്ർ പ്രവർത്തിച്ചിരിക്കുന്നു; അല്ലെങ്കിൽ ശിർക് ചെയ്തിരിക്കുന്നു." <span class="c2">(തിർമിദി)</span><br /> ഹദീസിൽ നിന്നുള്ള ഗുണപാഠങ്ങൾ<br /> <br /> - അല്ലാഹുവല്ലാത്തവരുടെ പേരിൽ സത്യം ചെയ്യുക എന്നത് അനുവദനീയമല്ല.<br /> <br /> - അല്ലാഹുവിന് പുറമെയുള്ളവരെ കൊണ്ട് സത്യം ചെയ്യുക എന്നത് ശിർകിൽ പെടുന്ന കാര്യമാണ്.<br /> <br /> ഹദീഥ് <span class="c2">(6)</span> </p>',
            ],
            5 => [
                'question' => 'ചോദ്യം 6: "ഞാൻ അവന് ഏറ്റവും പ്രിയങ്കരനായി തീരുന്നത് വരെ..." എന്ന ഹദീഥിൽ നിന്ന് ചില പാഠങ്ങൾ പറയുക.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9510.mp3',
                'answer' => '<p> ഉത്തരം: അനസ് <span class="c2">(رَضِيَ اللَّهُ عَنْهُ)</span> നിവേദനം: അല്ലാഹുവിൻ്റെ റസൂൽ <span class="c2">(ﷺ)</span> പറഞ്ഞിരിക്കുന്നു: "തൻ്റെ സന്താനത്തേക്കാളും, മാതാപിതാക്കളേക്കാളും, സർവ്വ മനുഷ്യരേക്കാളും ഞാൻ പ്രിയങ്കരനായി തീരുന്നത് വരെ നിങ്ങളിലൊരാളും വിശ്വാസിയാവുകയില്ല.<span class="c6">" ഇത് ബുഖാരിയും മുസ്ലിമും ഉദ്ധരിച്ചിരിക്കുന്നു<br /> ഹദീഥിൽ നിന്നുള്ള ഗുണപാഠങ്ങൾ:</span><br /> <br /> - എല്ലാ ജനങ്ങളെക്കാളും നബി -ﷺ- യെ സ്നേഹിക്കുക എന്നത് നിർബന്ധമാണ്.<br /> <br /> - ഈമാനിൻ്റെ പൂർണ്ണതയിൽ പെട്ടതാണ് ഇക്കാര്യം.<br /> <br /> ഹദീഥ് <span class="c2">(7)</span> </p>',
            ],
            6 => [
                'question' => 'ചോദ്യം 7: "തൻ്റെ സ്വന്തത്തിന് ഇഷ്ടപ്പെടുന്നത് തൻ്റെ സഹോദരനും ഇഷ്ടപ്പെടുന്നതുവരെ നിങ്ങളാരും വിശ്വാസികളാവുകയില്ല." എന്ന ഹദീഥിൽ നിന്ന് ചില പാഠങ്ങൾ പറയുക.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9580.mp3',
                'answer' => '<p> ഉത്തരം: അനസ് <span class="c2">(رَضِيَ اللَّهُ عَنْهُ)</span> നിവേദനം: അല്ലാഹുവിൻ്റെ റസൂൽ <span class="c2">(ﷺ)</span> പറഞ്ഞിരിക്കുന്നു: "തൻ്റെ സ്വന്തത്തിന് ഇഷ്ടപ്പെടുന്നത് തൻ്റെ സഹോദരനും ഇഷ്ടപ്പെടുന്നതുവരെ നിങ്ങളാരും വിശ്വാസികളാവുകയില്ല.<span class="c6">" ഇത് ബുഖാരിയും മുസ്ലിമും ഉദ്ധരിച്ചിരിക്കുന്നു<br /> ഹദീഥിൽ നിന്നുള്ള ഗുണപാഠങ്ങൾ:</span><br /> <br /> 1- നിൻ്റെ സ്വന്തത്തിന് വേണ്ടി നീ ആഗ്രഹിക്കുന്ന നല്ല കാര്യം നിൻ്റെ സഹോദരങ്ങളായ മുസ്ലിംകൾക്ക് ലഭിക്കണമെന്നും നിനക്ക് ആഗ്രഹമുണ്ടായിരിക്കണം.<br /> <br /> - ഈമാനിൻ്റെ പൂർണ്ണതയിൽ പെട്ടതാണ് ഇക്കാര്യം.<br /> <br /> ഹദീഥ് <span class="c2">(8)</span> </p>',
            ],
            7 => [
                'question' => 'ചോദ്യം 8: "എൻ്റെ ആത്മാവ് ആരുടെ കയ്യിലാണോ, അവൻ തന്നെ സത്യം!" - ഈ ഹദീഥ് പൂർണ്ണമായി പറയുക. അതിൽ നിന്നുള്ള ചില പാഠങ്ങൾ വിവരിക്കുക.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9650.mp3',
                'answer' => '<p> ഉത്തരം: അബൂ സഈദ് <span class="c2">(رَضِيَ اللَّهُ عَنْهُ)</span> നിവേദനം: അല്ലാഹുവിൻ്റെ റസൂൽ <span class="c2">(ﷺ)</span> പറഞ്ഞിരിക്കുന്നു: "എൻ്റെ ആത്മാവ് ആരുടെ കയ്യിലാണോ അവൻ തന്നെ സത്യം! തീർച്ചയായും അത് <span class="c2">(സൂറതുൽ ഇഖ്\'ലാസ്)</span> ഖുർആനിൻ്റെ മൂന്നിലൊന്നിന് തുല്യമാണ്." <span class="c2">(ബുഖാരി)</span><br /> ഹദീഥിൽ നിന്നുള്ള ഗുണപാഠങ്ങൾ:<br /> <br /> 1- സൂറതുൽ ഇഖ്\'ലാസിൻ്റെ ശ്രേഷ്ഠത.<br /> <br /> 2- ഖുർആനിൻ്റെ മൂന്നിലൊന്നിന് തുല്യമാണ് സൂറ. ഇഖ്\'ലാസ്.<br /> <br /> ഹദീഥ് <span class="c2">(9)</span> </p>',
            ],
            8 => [
                'question' => 'ചോദ്യം 9: \'ലാ ഹൗല വലാ ഖുവ്വത ഇല്ലാ ബില്ലാഹ്\' എന്ന ദിക്റിനെ കുറിച്ച് ഒരു ഹദീഥ് പറയുക. അതിൽ നിന്നുള്ള ചില പാഠങ്ങളും വിവരിക്കുക.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9720.mp3',
                'answer' => '<p> ഉത്തരം: അബൂ മൂസാ <span class="c2">(رَضِيَ اللَّهُ عَنْهُ)</span> നിവേദനം: അല്ലാഹുവിൻ്റെ റസൂൽ <span class="c2">(ﷺ)</span> പറഞ്ഞിരിക്കുന്നു: "ലാ ഹൗല വലാ ഖുവ്വത ഇല്ലാ ബില്ലാഹ് <span class="c2">(അല്ലാഹുവിനെ കൊണ്ടല്ലാതെ യാതൊരു ശക്തിയോ കഴിവോ ഇല്ല)</span> എന്ന വാക്ക് സ്വർഗത്തിലെ നിധികളിലൊരു നിധിയാണ്.<span class="c6">" ഇത് ബുഖാരിയും മുസ്ലിമും ഉദ്ധരിച്ചിരിക്കുന്നു<br /> ഹദീഥിൽ നിന്നുള്ള ഗുണപാഠങ്ങൾ:</span><br /> <br /> 1- ഈ ദിക്റിൻ്റെ ശ്രേഷ്ഠതയും, അത് സ്വർഗത്തിലെ നിധികളിലൊരു നിധിയാണെന്നതും.<br /> <br /> 2- ഒരാളും തന്റെ കഴിവിലോ ശക്തിയിലോ അല്ല അവലംബമർപ്പിക്കേണ്ടത്. അവൻ്റെ കാര്യങ്ങളെല്ലാം അവൻ അല്ലാഹുവിൻ്റെ മേലാണ് ഏൽപ്പിക്കേണ്ടത്.<br /> <br /> ഹദീഥ് <span class="c2">(10)</span> </p>',
            ],
            9 => [
                'question' => 'ചോദ്യം 2: "അറിയുക! ശരീരത്തിൽ ഒരു മാംസക്കഷ്ണമുണ്ട്." എന്ന ഹദീഥ് പൂർണ്ണമായി പറയുകയും, അതിൽ നിന്നുള്ള ചില പാഠങ്ങൾ വിവരിക്കുകയും ചെയ്യുക.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9790.mp3',
                'answer' => '<p> ഉത്തരം: നുഅ്മാൻ ബ്നു ബശീർ -رَضِيَ اللَّهُ عَنْهُ-<span class="c6"> നിവേദനം:</span> നബി -ﷺ-<span class="c6"> പറഞ്ഞു:</span> "അറിയുക! തീർച്ചയായും ശരീരത്തിൽ ഒരു മാംസക്കഷ്ണമുണ്ട്. അത് ശരിയായാൽ ശരീരം മുഴുവൻ ശരിയാകും. അത് മോശമായാൽ ശരീരം മുഴുവൻ മോശമാകും. അറിയുക! ഹൃദയമാകുന്നു അത്.<span class="c6">" ഇത് ബുഖാരിയും മുസ്ലിമും ഉദ്ധരിച്ചിരിക്കുന്നു<br /> ഹദീഥിൽ നിന്നുള്ള ഗുണപാഠങ്ങൾ:</span><br /> <br /> 1- ഹൃദയം ശരിയാകുന്നതോടെ മനുഷ്യൻ്റെ ഉള്ളും പുറവും നന്നാകും.<br /> <br /> 2- ഹൃദയം നന്നാക്കാൻ ശ്രദ്ധയോടെ പരിശ്രമിക്കണം; കാരണം മനുഷ്യൻ നന്നാകുന്നത് അതിലൂടെയാണ്.<br /> <br /> ഹദീഥ് <span class="c2">(11)</span> </p>',
            ],
            10 => [
                'question' => 'ചോദ്യം 11: "ആരുടെയെങ്കിലും അവസാന വാക്ക് ലാ ഇലാഹ ഇല്ലല്ലാഹ് എന്നായാൽ..." - ഈ ഹദീഥ് പൂർത്തീകരിക്കുകയും, അതിൽ നിന്ന് ചില പാഠങ്ങൾ വിവരിക്കുകയും ചെയ്യുക.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9860.mp3',
                'answer' => '<p> ഉത്തരം: മുആദ് ബ്നു ജബൽ <span class="c2">(رَضِيَ اللَّهُ عَنْهُ)</span> നിവേദനം: അല്ലാഹുവിൻ്റെ റസൂൽ <span class="c2">(ﷺ)</span> പറഞ്ഞിരിക്കുന്നു: "ആരുടെയെങ്കിലും അവസാന വാക്ക് ലാ ഇലാഹ ഇല്ലല്ലാഹ് എന്നായാൽ അവൻ സ്വർഗത്തിൽ പ്രവേശിക്കുന്നതാണ്." <span class="c2">(അബൂദാവൂദ്)</span><br /> ഹദീഥിൽ നിന്നുള്ള ഗുണപാഠങ്ങൾ:<br /> <br /> 1- ലാ ഇലാഹ ഇല്ലല്ലാഹ് എന്നതിൻ്റെ ശ്രേഷ്ഠതയും, അതു മുഖേന അടിമകൾ സ്വർഗത്തിൽ പ്രവേശിക്കുമെന്നതും.<br /> <br /> 2- ലാ ഇലാഹ ഇല്ലല്ലാഹ് എന്ന വാക്ക് പറഞ്ഞു കൊണ്ട് മരിക്കുന്നവർക്കുള്ള ശ്രേഷ്ഠത.<br /> <br /> ഹദീഥ് <span class="c2">(12)</span> </p>',
            ],
            11 => [
                'question' => 'ചോദ്യം 12: "ഒരു മുഅ്മിൻ ഒരിക്കലും കുത്തിപ്പറയുന്നവനോ..." എന്ന ഹദീഥ് പൂർത്തീകരിക്കുകയും, അതിൽ നിന്നുള്ള ചില പാഠങ്ങൾ വിവരിക്കുകയും ചെയ്യുക.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9940.mp3',
                'answer' => '<p> ഉത്തരം: അബ്ദുല്ലാഹി ബ്നു മസ്ഊദ് <span class="c2">(رَضِيَ اللَّهُ عَنْهُ)</span> നിവേദനം: അല്ലാഹുവിൻ്റെ റസൂൽ <span class="c2">(ﷺ)</span> പറഞ്ഞിരിക്കുന്നു: "ഒരു മുഅ്മിൻ ഒരിക്കലും കുത്തിപ്പറയുന്നവനോ, അധികമായി ശപിക്കുന്നവനോ, വൃത്തികേടു പറയുന്നവനോ, മ്ലേഛനോ അല്ല." <span class="c2">(തിർമിദി)</span><br /> ഹദീഥിൽ നിന്നുള്ള ഗുണപാഠങ്ങൾ:<br /> <br /> 1- നിരർത്ഥകമോ മോശമോ ആയ ഒരു വാക്കും പറയരുത്.<br /> <br /> 2- മുഅ്മിനിൻ്റെ നാവ് കൊണ്ട് നല്ലത് മാത്രമേ പറയാവൂ.<br /> <br /> ഹദീഥ് <span class="c2">(13)</span> </p>',
            ],
            12 => [
                'question' => 'ചോദ്യം 13: "ഒരാളുടെ ഇസ്ലാമിൻ്റെ മേന്മയിൽ പെട്ടതാണ്" എന്ന ഹദീഥ് പൂർത്തീകരിക്കുകയും, അതിൽ നിന്ന് ചില പാഠങ്ങൾ വിവരിക്കുകയും ചെയ്യുക.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10020.mp3',
                'answer' => '<p> ഉത്തരം: അബൂ ഹുറൈറ <span class="c2">(رَضِيَ اللَّهُ عَنْهُ)</span> നിവേദനം: അല്ലാഹുവിൻ്റെ റസൂൽ <span class="c2">(ﷺ)</span> പറഞ്ഞിരിക്കുന്നു: "ഒരാളുടെ ഇസ്ലാമിൻ്റെ മേന്മയിൽ പെട്ടതാണ് അവന് ആവശ്യമില്ലാത്ത കാര്യങ്ങളെ അവൻ ഉപേക്ഷിക്കുക എന്നത്." <span class="c2">(തിർമിദി)</span><br /> ഹദീഥിൽ നിന്നുള്ള ഗുണപാഠങ്ങൾ:<br /> <br /> 1- ഒരാൾക്ക് പ്രയോജനകരമല്ലാത്ത മറ്റുള്ളവരുടെ മതകാര്യത്തിൽ നിന്നോ, ദുനിയാവിൻ്റെ കാര്യത്തിൽ നിന്നോ വിട്ടുനിൽക്കുക.<br /> <br /> 2- ഒരാളുടെ ഇസ്ലാമിൻ്റെ പൂർണ്ണതയിൽ പെട്ടതാണ് അവന് പ്രയോജനകരമല്ലാത്ത കാര്യങ്ങളിൽ നിന്ന് വിട്ടുനിൽക്കുക എന്നത്.<br /> <br /> ഹദീഥ് <span class="c2">(14)</span> </p>',
            ],
            13 => [
                'question' => 'ചോദ്യം 14: "ആരെങ്കിലും അല്ലാഹുവിൻ്റെ കിതാബിൽ നിന്ന് ഒരക്ഷരം " എന്ന ഹദീഥ് പൂർത്തീകരിക്കുകയും, അതിൽ നിന്ന് ചില പാഠങ്ങൾ വിവരിക്കുകയും ചെയ്യുക.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10100.mp3',
                'answer' => '<p> ഉത്തരം: അബ്ദുല്ലാഹി ബ്നു മസ്ഊദ് -رَضِيَ اللَّهُ عَنْهُ-<span class="c6"> നിവേദനം:</span> നബി -ﷺ-<span class="c6"> പറഞ്ഞു:</span> "ആരെങ്കിലും അല്ലാഹുവിൻ്റെ കിതാബിൽ നിന്ന് ഒരക്ഷരം പാരായണം ചെയ്താൽ അവന് അതുമുഖേന ഒരു നന്മയുണ്ടായിരിക്കും. ആ നന്മക്ക് സമാനമായി പത്തെണ്ണവും. അലിഫ് ലാം മീം എന്നത് ഒരക്ഷരമാണെന്ന് ഞാൻ പറയുകയില്ല. മറിച്ച്, അലിഫ് ഒരക്ഷരവും, ലാം മറ്റൊരു അക്ഷരവും, മീം വേറൊരു അക്ഷരവുമാണ്." <span class="c2">(തിർമിദി)</span><br /> ഹദീഥിൽ നിന്നുള്ള ഗുണപാഠങ്ങൾ:<br /> <br /> 1- ഖുർആൻ പാരായണത്തിൻ്റെ ശ്രേഷ്ഠത.<br /> <br /> 2- ഖുർആനിലെ ഓരോ വാക്കുകൾ പാരായണം ചെയ്യുമ്പോഴും അവന് അനേകം നന്മകൾ രേഖപ്പെടുത്തപ്പെടുന്നതാണ്. </p>',
            ],
        ],
        6 => [
            0 => [
                'question' => 'ചോദ്യം 1: അല്ലാഹുവിനോടുള്ള മര്യാദ പാലിക്കേണ്ടത് എങ്ങനെയാണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10190.mp3',
                'answer' => '<p> ഉത്തരം: 1- അല്ലാഹുവിനോട് ആദരവും ബഹുമാനവും ഉണ്ടായിരിക്കുക.<br /> <br /> 2- അല്ലാഹുവിനെ മാത്രം ആരാധിക്കുകയും, അവനിൽ പങ്കുചേർക്കാതിരിക്കുകയും ചെയ്യുക.<br /> <br /> 3- അല്ലാഹുവിനെ അനുസരിക്കുക.<br /> <br /> 4- അല്ലാഹുവിനെ ധിക്കരിക്കാതിരിക്കുക.<br /> <br /> 5- അല്ലാഹു നൽകിയ എണ്ണമില്ലാത്ത അനുഗ്രഹങ്ങൾക്കും ഔദാര്യങ്ങൾക്കും അവനോട് നന്ദി കാണിക്കുകയും അവനെ സ്തുതിക്കുകയും ചെയ്യുക.<br /> <br /> 6- അല്ലാഹുവിൻ്റെ വിധിയിൽ ക്ഷമിക്കുക. </p>',
            ],
            1 => [
                'question' => 'ചോദ്യം 1: അല്ലാഹുവിൻ്റെ റസൂലിനോടുള്ള മര്യാദ പാലിക്കേണ്ടത് എങ്ങനെയാണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10270.mp3',
                'answer' => '<p> ഉത്തരം: 1- നബി -ﷺ- യെ പിൻപറ്റുകയും, അവിടുത്തെ മാതൃകയാക്കുകയും ചെയ്യുക.<br /> <br /> 2- നബി -ﷺ- യെ അനുസരിക്കുക.<br /> <br /> 3- നബി -ﷺ- യെ ധിക്കരിക്കാതിരിക്കുക.<br /> <br /> 4- നബി -ﷺ- അറിയിച്ച കാര്യങ്ങളിൽ വിശ്വസിക്കുക.<br /> <br /> 5- നബി -ﷺ- യുടെ ചര്യയിൽ യാതൊന്നും അധികരിപ്പിക്കാതെ, ബിദ്അത്തുകൾ ഉപേക്ഷിക്കുക.<br /> <br /> 6- നബി -ﷺ- യെ നിൻ്റെ സ്വന്തത്തേക്കാളും സർവ്വജനങ്ങളേക്കാളും സ്നേഹിക്കുക.<br /> <br /> 7- നബി -ﷺ- യെ ആദരിക്കുകയും, അവിടുത്തെയും അവിടുത്തെ സുന്നത്തിനെയും സഹായിക്കുകയും ചെയ്യുക. </p>',
            ],
            2 => [
                'question' => 'ചോദ്യം 3: മാതാപിതാക്കളോടുള്ള മര്യാദകൾ എന്തെല്ലാമാണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10360.mp3',
                'answer' => '<p> ഉത്തരം: 1- മാതാപിതാക്കളെ അനുസരിക്കുക; അവർ തിന്മ ചെയ്യാൻ പറഞ്ഞാലൊഴികെ.<br /> <br /> 2- മാതാപിതാക്കളെ സേവിക്കുക.<br /> <br /> 3- മാതാപിതാക്കളെ സഹായിക്കുക.<br /> <br /> 4- അവരുടെ ആവശ്യങ്ങൾ നിറവേറ്റി കൊടുക്കുക.<br /> <br /> 5- അവർക്ക് വേണ്ടി പ്രാർത്ഥിക്കുക.<br /> <br /> 6- മര്യാദ പാലിച്ചു കൊണ്ട് മാത്രം അവരോട് സംസാരിക്കുക; ഛെ എന്നു പോലും അവരോട് പറഞ്ഞു കൂടാ; അതാകട്ടെ, ഏറ്റവും നിസ്സാരമായ വാക്കുകളിലൊന്നാണ്.<br /> <br /> 7- മാതാപിതാക്കളെ പുഞ്ചിരിച്ചു കൊണ്ട് മാത്രം അഭിമുഖീകരിക്കുക; അവരോട് ഒരിക്കലും മുഖം ചുളിക്കരുത്.<br /> <br /> 8- മാതാപിതാക്കളുടെ ശബ്ദത്തിന് മുകളിൽ ശബ്ദം ഉയർത്തരുത്. അവർ സംസാരിക്കുമ്പോൾ അത് ശ്രദ്ധയോടെ കേൾക്കണം. അവരുടെ സംസാരം തടസ്സപ്പെടുത്തരുത്. അവരെ പേരു പറഞ്ഞ് വിളിക്കരുത്. മറിച്ച്, \'അബീ\' <span class="c2">(എൻ്റെ ഉപ്പാ)</span>, \'ഉമ്മീ\' <span class="c2">(എൻ്റെ ഉമ്മാ)</span> എന്നിങ്ങനെയാണ് വിളിക്കേണ്ടത്.<br /> <br /> 9- ഉപ്പയും ഉമ്മയും ഒരു മുറിയിലായിരിക്കുമ്പോൾ സമ്മതം ചോദിച്ചു കൊണ്ടേ അവിടേക്ക് പ്രവേശിക്കാൻ പാടുള്ളൂ.<br /> <br /> 10- മാതാപിതാക്കളുടെ ശിരസ്സിലും കൈകളിലും ചുംബനം നൽകുക. </p>',
            ],
            3 => [
                'question' => 'ചോദ്യം 4: എങ്ങനെയാണ് ഞാൻ കുടുംബബന്ധം ചേർക്കേണ്ടത്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10490.mp3',
                'answer' => '<p> ഉത്തരം: 1- എൻ്റെ കുടുംബങ്ങളെ ഞാൻ സന്ദർശിക്കണം. എൻ്റെ സഹോദരനെയും സഹോദരിയെയും മൂത്താപ്പയെയും മൂത്തമ്മയെയും എളാപ്പയെയും എളാമയെയും അമ്മാവനെയും അമ്മായിയെയും മറ്റു കുടുംബക്കാരെയുമെല്ലാം ഞാൻ സന്ദർശിക്കണം.<br /> <br /> 2- കുടുംബത്തിൽ പെട്ടവരോട് നല്ല വാക്കുകൾ പറയുകയും, നല്ല കാര്യങ്ങൾ പ്രവർത്തിക്കുകയും വേണം. അവരെ സഹായിക്കണം.<br /> <br /> 3- അവരെ ഫോണിൽ വിളിച്ചു ബന്ധപ്പെടുകയും, അവർക്ക് സുഖമാണോ എന്ന് ചോദിച്ചറിയുകയും വേണം. </p>',
            ],
            4 => [
                'question' => 'ചോദ്യം 5: എൻ്റെ സഹോദരങ്ങളോടും സുഹൃത്തുക്കളോടും ഞാൻ എങ്ങനെയാണ് പെരുമാറേണ്ടത്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10550.mp3',
                'answer' => '<p> ഉത്തരം: 1- നല്ലവരെ സ്നേഹിക്കുകയും, അവരോട് കൂട്ടുകൂടുകയും ചെയ്യുക.<br /> <br /> 2- അധർമ്മികളിൽ നിന്ന് അകന്നു നിൽക്കുകയും, അവരോടുള്ള കൂട്ടുകെട്ട് ഉപേക്ഷിക്കുകയും ചെയ്യുക.<br /> <br /> 3- സുഹൃത്തുക്കൾക്ക് സലാം പറയുകയും, അവരുമായി ഹസ്തദാനം നടത്തുകയും ചെയ്യുക.<br /> <br /> 4- അവർക്ക് രോഗമായാൽ അവരെ സന്ദർശിക്കുകയും, അവരുടെ രോഗം മാറാൻ വേണ്ടി പ്രാർത്ഥിക്കുകയും ചെയ്യുക.<br /> <br /> 5- ഒരാൾ തുമ്മുകയും, അൽഹംദുലില്ലാഹ് എന്ന് പറയുകയും ചെയ്താൽ, \'യർഹമുകല്ലാഹ്\' എന്ന് പറഞ്ഞു കൊണ്ട് അവർക്കായി പ്രാർത്ഥിക്കണം.<br /> <br /> 6- അവർ ക്ഷണിച്ചാൽ ആ ക്ഷണം സ്വീകരിക്കണം.<br /> <br /> 7- അവരോട് ഗുണകാംക്ഷാപൂർവ്വം വർത്തിക്കണം.<br /> <br /> 8- ആരെങ്കിലും അവരോട് അതിക്രമം പ്രവർത്തിച്ചാൽ അതിക്രമിക്കെതിരെ അവരെ സഹായിക്കണം. അവർ അതിക്രമം കാണിക്കുന്നുവെങ്കിൽ അതിൽ നിന്ന് അവരെ തടയണം.<br /> <br /> 10- നിൻ്റെ സ്വന്തത്തിന് നീ ഇഷ്ടപ്പെടുന്ന കാര്യം നിൻ്റെ സഹോദരന് വേണ്ടിയും നീ ഇഷ്ടപ്പെടുക.<br /> <br /> 11- അവന് സഹായം ആവശ്യമായി വരുന്ന ഘട്ടത്തിൽ അവനെ സഹായിക്കണം.<br /> <br /> 12- വാക്ക് കൊണ്ടോ പ്രവർത്തി കൊണ്ടോ അവനെ ഉപദ്രവിക്കരുത്.<br /> <br /> 13- അവൻ്റെ രഹസ്യങ്ങൾ പരസ്യമാക്കരുത്.<br /> <br /> 14- നിൻ്റെ കൂട്ടുകാരനെ ചീത്തപറയുകയോ, അവനെ കുറിച്ച് പരദൂഷണം പറയുകയോ, അവനെ ഇകഴ്ത്തുകയോ, അവനോട് അസൂയ വെക്കുകയോ, അവനെതിരെ ചാരപ്പണി നടത്തുകയോ, അവനെ വഞ്ചിക്കുകയോ ചെയ്യരുത്. </p>',
            ],
            5 => [
                'question' => 'ചോദ്യം 6: അയൽവാസിയോടുള്ള മര്യാദകൾ ഏതെല്ലാമാണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10710.mp3',
                'answer' => '<p> ഉത്തരം: 1- അയൽവാസിയോടുള്ള വാക്കും പ്രവർത്തിയും നന്നാക്കുക. അവർക്ക് സഹായം ആവശ്യമാണെങ്കിൽ സഹായിക്കുക.<br /> <br /> 2- പെരുന്നാളോ വിവാഹമോ മറ്റോ പോലുള്ള സന്തോഷങ്ങൾ വന്നെത്തിയാൽ അവന് ആശംസകൾ നേരുക.<br /> <br /> 3- രോഗമായാൽ അവനെ സന്ദർശിക്കുകയും, എന്തെങ്കിലും പ്രയാസം ബാധിച്ചാൽ അവനെ ആശ്വസിപ്പിക്കുകയും ചെയ്യുക.<br /> <br /> 4- നീ ഉണ്ടാക്കുന്ന ഭക്ഷണത്തിൽ നിന്ന് സാധ്യമായത് അവനുമായി പങ്കുവെക്കുക.<br /> <br /> 5- അവനെ വാക്ക് കൊണ്ടോ പ്രവർത്തി കൊണ്ടോ ഉപദ്രവിക്കരുത്.<br /> <br /> 6- ഉച്ചത്തിൽ ശബ്ദമുണ്ടാക്കി കൊണ്ടോ, അവനെതിരെ ചാരപ്പണി നടത്തിക്കൊണ്ടോ അയൽവാസിക്ക് പ്രയാസം സൃഷ്ടിക്കരുത്. അവൻ്റെ ഭാഗത്തു നിന്നുള്ള പ്രയാസങ്ങളിൽ നീ ക്ഷമ കൈക്കൊള്ളുക. </p>',
            ],
            6 => [
                'question' => 'ചോദ്യം 7: അതിഥികളും ആതിഥേയരും പാലിക്കേണ്ട മര്യാദകൾ എന്തെല്ലാമാണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10800.mp3',
                'answer' => '<p> ഉത്തരം: 1- ഒരാൾ ക്ഷണിച്ചാൽ ക്ഷണം സ്വീകരിക്കുക.<br /> <br /> 2- ഒരാളെ സന്ദർശിക്കാൻ ഉദ്ദേശിക്കുമ്പോൾ അവനോട് അനുവാദം ചോദിക്കുകയും, മുൻകൂട്ടി സമയം വാങ്ങുകയും ചെയ്യുക.<br /> <br /> 3- ആതിഥേയൻ്റെ അടുത്ത് പ്രവേശിക്കുന്നതിന് മുൻപ് സമ്മതം ചോദിക്കുക.<br /> <br /> 4- സന്ദർശിക്കുമ്പോൾ പറഞ്ഞ സമയത്തിൽ നിന്ന് വൈകരുത്.<br /> <br /> 5- ആതിഥേയൻ്റെ വീട്ടുകാരെ നോക്കാതെ കണ്ണുകൾ താഴ്ത്തുക.<br /> <br /> 6- അതിഥിയെ സ്വാഗതം ചെയ്യുകയും, നല്ല രൂപത്തിൽ സ്വീകരിച്ചിരുത്തുകയും ചെയ്യുക. പുഞ്ചിരിക്കുന്ന മുഖത്തോടെയും, നല്ല വാക്കുകളോടെയും അദ്ദേഹത്തെ വരവേൽക്കുക.<br /> <br /> 7- അതിഥിയെ ഏറ്റവും നല്ല സ്ഥലത്ത് ആനയിച്ചിരുത്തുക.<br /> <br /> 8- ഭക്ഷണവും പാനീയങ്ങളും നൽകി അദ്ദേഹത്തെ മനോഹരമായി ആദരിക്കുക. </p>',
            ],
            7 => [
                'question' => 'ചോദ്യം 8: രോഗവേളയിൽ ശ്രദ്ധിക്കേണ്ട മര്യാദകളും, രോഗികളെ സന്ദർശിക്കുമ്പോൾ പാലിക്കേണ്ട മര്യാദകളും ഏതെല്ലാമാണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10900.mp3',
                'answer' => '<p> ഉത്തരം: വേദന അനുഭവിച്ചാൽ വലതു കൈ വേദനയുള്ള ഭാഗത്ത് വെക്കുകയും, \'ബിസ്മില്ലാഹ്\' എന്ന് മൂന്നു തവണ പറയുകയും വേണം. ശേഷം \'അല്ലാഹുവിൻ്റെ പ്രതാപവും കഴിവും മുൻനിർത്തി കൊണ്ട് ഞാൻ അനുഭവിക്കുന്നതും ഭയപ്പെടുന്നതുമായ ഈ പ്രയാസത്തിൽ നിന്ന് ഞാൻ രക്ഷ ചോദിക്കുന്നു\' എന്ന അർത്ഥം വരുന്ന പ്രാർത്ഥന ഏഴുതവണ ചൊല്ലുക.<br /> <br /> 2- അല്ലാഹു വിധിച്ചതിൽ തൃപ്തിയടയുകയും, ക്ഷമ കൈക്കൊള്ളുകയും ചെയ്യുക.<br /> <br /> 3- സഹോദരന് രോഗമായാൽ ഉടനടി അവനെ സന്ദർശിക്കുകയും, അവന് വേണ്ടി പ്രാർത്ഥിക്കുകയും വേണം. രോഗിയെ സന്ദർശിച്ചാൽ അവിടെ അധികനേരം ഇരിക്കാൻ പാടില്ല.<br /> <br /> 4- അവൻ മന്ത്രിച്ചു കൊടുക്കാൻ ആവശ്യപ്പെടാതെ തന്നെ അവന് വേണ്ടി മന്ത്രിച്ചു കൊടുക്കുക.<br /> <br /> 5- ക്ഷമ കൈക്കൊള്ളാനും, അല്ലാഹുവിനോട് പ്രാർത്ഥിക്കാനും അവനെ ഉപദേശിക്കുക. നിസ്കാരവും ശുദ്ധീകരണവും സാധ്യമായ രൂപത്തിൽ നിലനിർത്താൻ ഓർമ്മിപ്പിക്കുക.<br /> <br /> 6-<span class="c6"> രോഗിക്ക് വേണ്ടി ഈയർത്ഥം വരുന്ന പ്രാർത്ഥന പ്രാർത്ഥിക്കുക:</span> "അതിമഹാനും പ്രതാപം നിറഞ്ഞ സിംഹാസനത്തിൻ്റെ ഉടമയുമായ അല്ലാഹുവിനോട് ഞാൻ പ്രാർത്ഥിക്കുന്നു; അവൻ നിന്നെ സുഖപ്പെടുത്തട്ടെ." ഈ പ്രാർത്ഥന ഏഴു തവണ പ്രാർത്ഥിക്കണം. </p>',
            ],
            8 => [
                'question' => 'ചോദ്യം 9: മതവിജ്ഞാനം തേടുന്നതിൻ്റെ മര്യാദകൾ പറയുക.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10990.mp3',
                'answer' => '<p> ഉത്തരം: 1- അല്ലാഹുവിന് വേണ്ടി മാത്രമായി, നിഷ്കളങ്കമായ <span class="c2">(ഇഖ്\'ലാസുള്ള)</span> നിയ്യത്ത് കരുതുക.<br /> <br /> 2- പഠിക്കുന്ന വിജ്ഞാനം ജീവിതത്തിൽ പ്രാവർത്തികമാക്കുക.<br /> <br /> 3- അദ്ധ്യാപകനെ ആദരിക്കുകയും, അദ്ദേഹത്തിൻ്റെ സാന്നിധ്യത്തിലും അസാന്നിധ്യത്തിലും അദ്ദേഹത്തോടുള്ള ബഹുമാനം കാത്തുസൂക്ഷിക്കുകയും ചെയ്യുക.<br /> <br /> 4- അദ്ധ്യാപകൻ്റെ മുൻപിൽ മര്യാദകളോടെ ഇരിക്കുക.<br /> <br /> 5- അദ്ധ്യാപകൻ്റെ സംസാരം നിശബ്ദമായിരുന്ന് കേൾക്കുകയും, അദ്ദേഹത്തിൻ്റെ സംസാരം മുറിക്കാതിരിക്കുകയും ചെയ്യുക.<br /> <br /> 6- മര്യാദകൾ പാലിച്ചു കൊണ്ട് ചോദ്യങ്ങൾ ചോദിക്കുക.<br /> <br /> 7- അദ്ധ്യാപകൻ്റെ പേര് വിളിക്കരുത്. </p>',
            ],
            9 => [
                'question' => 'ചോദ്യം 10: സദസ്സിൽ പാലിക്കേണ്ട മര്യാദകൾ എന്തെല്ലാമാണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11090.mp3',
                'answer' => '<p> ഉത്തരം: 1- സദസ്സിലേക്ക് പ്രവേശിക്കുമ്പോൾ അവിടെ ഇരിക്കുന്നവരോട് സലാം പറയുക.<br /> <br /> 2- സദസ്സിൽ ഇരിക്കാൻ കഴിയുന്ന ആദ്യഭാഗത്ത് ഇരിക്കുക. ഒരാളെയും അദ്ദേഹത്തിൻ്റെ ഇരിപ്പിടത്തിൽ നിന്ന് എഴുന്നേൽപ്പിക്കുകയും, രണ്ടാളുകൾക്ക് ഇടയിൽ അവരുടെ അനുമതിയില്ലാതെ ഇരിക്കുകയോ ചെയ്യരുത്.<br /> <br /> 3- മറ്റുള്ളവർക്ക് ഇരിക്കാൻ സാധിക്കുന്ന വിധത്തിൽ സദസ്സിൽ വിശാലതയുണ്ടാക്കുക.<br /> <br /> 4- സദസ്സിൽ നടന്നു കൊണ്ടിരിക്കുന്ന സംസാരം മുറിക്കരുത്.<br /> <br /> 5- സദസ്സിൽ നിന്ന് പിന്തിരിഞ്ഞു പോകുന്നതിന് മുൻപ് അനുവാദം ചോദിക്കുകയും, സലാം പറയുകയും ചെയ്യുക.<br /> <br /> 6- സദസ്സ് പിരിയുന്ന സന്ദർഭത്തിൽ ചൊല്ലാൻ പഠിപ്പിക്കപ്പെട്ട കഫ്ഫാറതുൽ മജ്ലിസിൻ്റെ പ്രാർത്ഥന ചൊല്ലുക. <span class="c2">(സാരം:)</span> അല്ലാഹുവേ! നിൻ്റെ പരിശുദ്ധിയെ ഞാൻ വാഴ്ത്തുകയും, നിന്നെ ഞാൻ സ്തുതിക്കുകയും ചെയ്യുന്നു. നീയല്ലാതെ ആരാധനക്ക് അർഹനായി മറ്റാരുമില്ലെന്ന് ഞാൻ സാക്ഷ്യം വഹിക്കുന്നു. നിന്നോട് ഞാൻ പാപമോചനം തേടുകയും, നിന്നിലേക്ക് ഞാൻ പശ്ചാത്തപിച്ചു മടങ്ങുകയും ചെയ്യുന്നു. </p>',
            ],
            10 => [
                'question' => 'ചോദ്യം 11: ഉറക്കത്തിൻ്റെ വേളയിൽ പാലിക്കേണ്ട മര്യാദകൾ വിവരിക്കുക.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11180.mp3',
                'answer' => '<p> ഉത്തരം: 1- നേരത്തെ ഉറങ്ങുക.<br /> <br /> 2- ശുദ്ധിയോടെ കിടന്നുറങ്ങുക.<br /> <br /> 3- കമിഴ്ന്ന് കിടന്നുറങ്ങരുത്.<br /> <br /> 4- വലതു ഭാഗത്തേക്ക് തിരിഞ്ഞു കിടക്കുക; വലതു കൈപ്പത്തി വലതു കവിളിൻ്റെ താഴെ വെക്കുകയും ചെയ്യുക.<br /> <br /> 5- വിരിപ്പ് കുടയുക.<br /> <br /> 6- ഉറങ്ങുന്നതിന് മുൻപുള്ള ദിക്റുകൾ ചൊല്ലുക. ആയതുൽ കുർസിയ്യും, സൂറതുൽ ഇഖ്\'ലാസ്, സൂറതുൽ ഫലഖ്, സൂറതുന്നാസ് എന്നീ സൂറത്തുകൾ മൂന്നു തവണയും പാരായണം ചെയ്യുക.<span class="c6"> ശേഷം പറയുക:</span> "അല്ലാഹുവേ! നിൻ്റെ നാമത്തിൽ ഞാൻ മരിക്കുകയും ജീവിക്കുകയും ചെയ്യുന്നു."<br /> 7- ഫജ്ർ നിസ്കാരത്തിന് വേണ്ടി എഴുന്നേൽക്കുക.<br /> <br /> 8-<span class="c6"> ഉറക്കത്തിൽ നിന്ന് എഴുന്നേറ്റാൽ ഇപ്രകാരം പറയുക:</span> "നമ്മെ മരിപ്പിച്ചതിനുശേഷം ജീവിപ്പിച്ചവനായ അല്ലാഹുവിനാകുന്നു സർവ്വസ്തുതിയും. അവനിലേക്ക് തന്നെയാകുന്നു പുനരുത്ഥാനം." </p>',
            ],
            11 => [
                'question' => 'ചോദ്യം 6: ഭക്ഷണവേളയിൽ പാലിക്കേണ്ട മര്യാദകൾ ഏതെല്ലാമാണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11290.mp3',
                'answer' => '<p> ഉത്തരം:<br /> <br /> 1- ഭക്ഷണം കഴിക്കുമ്പോഴും വെള്ളം കുടിക്കുമ്പോഴും അല്ലാഹുവിനെ അനുസരിക്കാൻ ഇതിലൂടെ ഞാൻ ശക്തി സംഭരിക്കുന്നു എന്ന നിയ്യത്ത് കരുതുക.<br /> <br /> 2- ഭക്ഷണം കഴിക്കുന്നതിന് മുൻപ് രണ്ട് കൈകളും കഴുകുക.<br /> <br /> 3- \'ബിസ്മില്ലാഹ്\' എന്ന് പറഞ്ഞു കൊണ്ട് ഭക്ഷണം കഴിച്ചു തുടങ്ങുക. വലതു കൈ കൊണ്ട്, അടുത്തു നിന്നുള്ളത് ഭക്ഷിക്കുക. പാത്രത്തിൻ്റെ നടുവിൽ നിന്നോ, മറ്റുള്ളവരുടെ മുൻപിലുള്ള ഭാഗത്ത് നിന്നോ ഭക്ഷണം കഴിക്കരുത്.<br /> <br /> 4- ബിസ്മി ചൊല്ലാൻ മറന്നാൽ \'ബിസ്മില്ലാഹി അവ്വലഹു വആഖിറഹു\' <span class="c2">(ആദ്യത്തിലും അവസാനത്തിലും അല്ലാഹുവിൻ്റെ നാമം ഉച്ചരിച്ചു കൊണ്ട്)</span> എന്ന് പറയുക.<br /> <br /> 5- ലഭിച്ച ഭക്ഷണത്തിൽ തൃപ്തിയുള്ളവനാവുക; ഒരു ഭക്ഷണത്തെയും കുറ്റം പറയരുത്. ഇഷ്ടപ്പെട്ടാൽ ഭക്ഷിക്കുക; ഇല്ലെങ്കിൽ കഴിക്കാതിരിക്കുക.<br /> <br /> 6- ഭക്ഷണം അധികരിപ്പിക്കരുത്; കുറഞ്ഞ കൈക്കുമ്പിൾ ഭക്ഷണത്തിൽ മതിയാക്കുക.<br /> <br /> 7- ഭക്ഷണത്തിലോ പാനീയത്തിലോ ഊതരുത്; ചൂടുണ്ടെങ്കിൽ തണുക്കുന്നത് വരെ കാത്തുനിൽക്കുക.<br /> <br /> 8- കുടുംബത്തോടും അതിഥികളോടുമൊപ്പം ഭക്ഷണം കഴിക്കുക.<br /> <br /> 9- നിന്നേക്കാൾ പ്രായമുള്ളവർ ഭക്ഷണം കഴിച്ചു തുടങ്ങുന്നതിന് മുൻപ് ഭക്ഷണം കഴിക്കരുത്.<br /> <br /> 10- വെള്ളം കുടിക്കുമ്പോൾ അല്ലാഹുവിൻ്റെ നാമം ഉച്ചരിക്കുക; ഇരുന്ന് കൊണ്ട്, മൂന്ന് കവിളുകളായാണ് വെള്ളം കുടിക്കേണ്ടത്.<br /> <br /> 11- ഭക്ഷണം കഴിച്ചു കഴിഞ്ഞാൽ അല്ലാഹുവിനെ സ്തുതിക്കുക. </p>',
            ],
            12 => [
                'question' => 'ചോദ്യം 13: വസ്ത്രധാരണത്തിലെ മര്യാദകൾ പറയുക.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11440.mp3',
                'answer' => '<p> ഉത്തരം: 1- വലതു ഭാഗം ആദ്യം വസ്ത്രം ധരിക്കണം. വസ്ത്രം എന്ന അനുഗ്രഹത്തിന് അല്ലാഹുവിനോട് നന്ദി പറയണം.<br /> <br /> 2- നെരിയാണിക്ക് താഴേക്ക് വസ്ത്രം താഴ്ത്തിയുടുക്കരുത്.<br /> <br /> 3- ആൺകുട്ടികൾ പെൺകുട്ടികളുടെയോ പെൺകുട്ടികൾ ആൺകുട്ടികളുടെയോ വസ്ത്രം ധരിക്കരുത്.<br /> <br /> 4- മുസ്ലിംകളല്ലാത്തവരുടെയോ മോശം പ്രവർത്തികൾ ചെയ്യുന്നവരുടെയോ അടയാളമായ വസ്ത്രങ്ങൾ ധരിക്കരുത്.<br /> <br /> 5- വസ്ത്രം ഊരുമ്പോൾ ബിസ്മി ചൊല്ലുക.<br /> <br /> 6- ചെരുപ്പ് ധരിക്കുമ്പോൾ ആദ്യം വലതു കാലിൽ ധരിക്കുക. ഊരുമ്പോൾ ഇടതു കാലിലേത് ആദ്യം ഊരിവെക്കുക. </p>',
            ],
            13 => [
                'question' => 'ചോദ്യം 14: വാഹനത്തിൽ കയറുമ്പോൾ പാലിക്കേണ്ട മര്യാദകൾ പറയുക.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11540.mp3',
                'answer' => '<p> ഉത്തരം: 1- \'ബിസ്മില്ലാഹ്, അൽഹംദുലില്ലാഹ്\' എന്ന് പറയുക. "ഞങ്ങൾക്കിത് സൗകര്യപ്പെടുത്തിത്തന്നവനാരോ അവൻ എത്ര പരിശുദ്ധൻ! ഞങ്ങൾക്കതിന് സാധിക്കുമായിരുന്നില്ല. തീർച്ചയായും ഞങ്ങൾ ഞങ്ങളുടെ രക്ഷിതാവിങ്കലേക്ക് തിരിച്ചു പോകുന്നവർ തന്നെയാകുന്നു." <span class="c2">(സുഖ്റുഫ്: 13-14)</span><br /> 2- മുസ്ലിമായ ഒരാളുടെ അടുത്തു കൂടെ പോകുമ്പോൾ അവനോട് സലാം പറയുക. </p>',
            ],
            14 => [
                'question' => 'ചോദ്യം 15: വഴിയിൽ പാലിക്കേണ്ട മര്യാദകൾ പറയുക.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11590.mp3',
                'answer' => '<p> ഉത്തരം: 1- നടത്തത്തിൽ മിതത്വം പാലിക്കുകയും, വിനയം കാത്തുസൂക്ഷിക്കുകയും വേണം. വഴിയുടെ വലതുഭാഗം ചേർന്നു കൊണ്ടാണ് നടക്കേണ്ടത്.<br /> <br /> 2- കണ്ടുമുട്ടുന്നവരോട് സലാം പറയണം.<br /> <br /> 3- കണ്ണുകൾ താഴ്ത്തണം; ഒരാളെയും ഉപദ്രവിക്കരുത്.<br /> <br /> 4- നന്മ കൽപ്പിക്കുകയും തിന്മ വിരോധിക്കുകയും വേണം.<br /> <br /> 5- വഴിയിലുള്ള ഉപദ്രവങ്ങൾ എടുത്തു നീക്കണം. </p>',
            ],
            15 => [
                'question' => 'ചോദ്യം 16: വീട്ടിൽ പ്രവേശിക്കുമ്പോഴും പുറത്തു പോകുമ്പോഴുമുള്ള മര്യാദകൾ വിവരിക്കുക.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11670.mp3',
                'answer' => '<p> ഉത്തരം: 1- ഇടതു കാൽ വെച്ചു കൊണ്ടാണ് വീട്ടിൽ നിന്ന് പുറത്തേക്ക് ഇറങ്ങേണ്ടത്.<span class="c6"> ഇപ്രകാരം പ്രാർത്ഥിക്കുകയും വേണം:</span> "അല്ലാഹുവിൻ്റെ നാമത്തിൽ, ഞാൻ അവൻ്റെ മേൽ ഭരമേൽപ്പിച്ചിരിക്കുന്നു. അല്ലാഹുവിനെ കൊണ്ടല്ലാതെ യാതൊരു ശക്തിയും കഴിവുമില്ല. അല്ലാഹുവേ! ഞാൻ വഴിതെറ്റുന്നതിൽ നിന്നും <span class="c2">(മറ്റുള്ളവർ എന്നെ)</span> വഴിതെറ്റിക്കുന്നതിൽ നിന്നും, എനിക്ക് അബദ്ധം പിണയുന്നതിൽ നിന്നും <span class="c2">(മറ്റുള്ളവർ എന്നെ)</span> അബദ്ധത്തിൽ വീഴ്ത്തുന്നതിൽ നിന്നും, ഞാൻ അതിക്രമം കാണിക്കുന്നതിൽ നിന്നും എന്നോട് അതിക്രമം കാണിക്കപ്പെടുന്നതിൽ നിന്നും, ഞാൻ വിവരക്കേട് പ്രവർത്തിക്കുന്നതിൽ നിന്നും എന്നോട് വിവരക്കേട് പ്രവർത്തിക്കപ്പെടുന്നതിൽ നിന്നും ഞാൻ നിന്നോട് രക്ഷ ചോദിക്കുന്നു." 2- വലതു കാൽ വെച്ചു കൊണ്ടാണ് വീട്ടിലേക്ക് പ്രവേശിക്കേണ്ടത്.<span class="c6"> ഇപ്രകാരം പറയുകയും വേണം:</span> "അല്ലാഹുവിൻ്റെ നാമം ഉച്ചരിച്ചു കൊണ്ട് നാം പ്രവേശിക്കുന്നു. അല്ലാഹുവിൻ്റെ നാമം ഉച്ചരിച്ചു കൊണ്ട് നാം പുറത്തു പോവുകയും ചെയ്തു. നമ്മുടെ റബ്ബിൻ്റെ മേൽ നാം ഭരമേൽപ്പിക്കുകയും ചെയ്തിരിക്കുന്നു."<br /> 3- വീട്ടിലേക്ക് കയറിയാൽ ആദ്യം ചെയ്യേണ്ടത് പല്ലുതേക്കലാണ്. ശേഷം വീട്ടുകാർക്ക് സലാം പറയണം. </p>',
            ],
            16 => [
                'question' => 'ചോദ്യം 17: മലമൂത്ര വിസർജ്ജനത്തിൽ ശ്രദ്ധിക്കേണ്ട മര്യാദകൾ പറയുക.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11730.mp3',
                'answer' => '<p> ഉത്തരം: 1- ഇടതു കാൽ വെച്ചു കൊണ്ടാണ് വിസർജ്ജന സ്ഥലത്തേക്ക് പ്രവേശിക്കേണ്ടത്.<br /> <br /> 2-<span class="c6"> വിസർജ്ജന സ്ഥലത്തേക്ക് പ്രവേശിക്കുന്നതിന് മുൻപ് ഇപ്രകാരം പറയണം:</span> "അല്ലാഹുവിൻ്റെ നാമത്തിൽ. അല്ലാഹുവേ, ആൺ പിശാചുക്കളുടെയും പെൺ പിശാചുക്കളുടെയും കെടുതികളിൽ നിന്ന് ഞാൻ നിന്നോട് രക്ഷ തേടുന്നു."<br /> 3- അല്ലാഹുവിൻ്റെ നാമമുള്ള യാതൊന്നും വിസർജ്ജന സ്ഥലത്തേക്ക് പ്രവേശിപ്പിക്കരുത്.<br /> <br /> 4- വിസർജ്ജനവേളയിൽ മറ സ്വീകരിക്കണം.<br /> <br /> 5- വിസർജ്ജനസ്ഥലത്ത് വെച്ചു കൊണ്ട് സംസാരിക്കരുത്.<br /> <br /> 6- ഖിബ്\'ലക്ക് നേരെ തിരിഞ്ഞു കൊണ്ടോ, അതിന് വിരുദ്ധമായി ഇരുന്നു കൊണ്ടോ മലമൂത്ര വിസർജ്ജനം നിർവ്വഹിക്കരുത്.<br /> <br /> 7- വൃത്തികേടുകൾ നീക്കാൻ ഇടതു കൈയ്യാണ് ഉപയോഗപ്പെടുത്തേണ്ടത്. വലതു കൈ അതിനായി ഉപയോഗിക്കരുത്.<br /> <br /> 8- ജനങ്ങൾ സഞ്ചരിക്കുന്ന വഴികളിലോ അവർ തണലു കൊള്ളുന്ന സ്ഥലങ്ങളിലോ മലമൂത്ര വിസർജ്ജനം നടത്തരുത്.<br /> <br /> 9- മലമൂത്ര വിസർജ്ജനം നിർവ്വഹിച്ചതിന് ശേഷം രണ്ട് കൈകളും കഴുകണം.<br /> <br /> 10- ഇടതു കാൽ വെച്ചു കൊണ്ടാണ് വിസർജ്ജന സ്ഥലത്ത് നിന്ന് പുറത്തേക്ക് വരേണ്ടത്. \'അല്ലാഹുവേ! നിന്നോട് പൊറുക്കൽ തേടുന്നു\' എന്ന് പ്രാർത്ഥിക്കുകയും വേണം. </p>',
            ],
            17 => [
                'question' => 'ചോദ്യം 18: മസ്ജിദിൽ പാലിക്കേണ്ട മര്യാദകൾ പറയുക.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11860.mp3',
                'answer' => '<p> ഉത്തരം: 1- വലതു കാൽ വെച്ചു കൊണ്ടാണ് മസ്ജിദിലേക്ക് പ്രവേശിക്കേണ്ടത്.<span class="c6"> അപ്പോൾ ഇപ്രകാരം പ്രാർത്ഥിക്കുകയും വേണം:</span> "അല്ലാഹുവിൻ്റെ നാമം ഉച്ചരിച്ചു കൊണ്ട്. അല്ലാഹുവേ! നിൻ്റെ കാരുണ്യത്തിൻ്റെ കവാടങ്ങൾ നീയെനിക്ക് തുറന്നു നൽകേണമേ!"<br /> 2- രണ്ട് റക്അത്തുകൾ നിസ്കരിക്കാതെ മസ്ജിദിൽ ഇരിക്കരുത്.<br /> <br /> 3- നിസ്കരിക്കുന്നവരുടെ മുന്നിലൂടെ നടക്കരുത്. നഷ്ടപ്പെട്ട വസ്തു മസ്ജിദിൽ വെച്ച് അന്വേഷിക്കുകയോ, മസ്ജിദിൽ വെച്ച് വാങ്ങലും വിൽക്കലും നടത്തുകയോ ചെയ്യരുത്.<br /> <br /> 4- മസ്ജിദിൽ നിന്ന് പുറത്തിറങ്ങുമ്പോൾ ആദ്യം ഇടതുകാലാണ് വെക്കേണ്ടത്.<span class="c6"> ഈ പ്രാർത്ഥന ചൊല്ലുകയും വേണം:</span> "അല്ലാഹുവേ! നിൻ്റെ ഔദാര്യത്തിൽ നിന്ന് ഞാൻ നിന്നോട് ചോദിക്കുന്നു." </p>',
            ],
            18 => [
                'question' => 'ചോദ്യം 19: സലാം പറയുന്നതിൻ്റെ മര്യാദകൾ വിവരിക്കുക.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11930.mp3',
                'answer' => '<p> ഉത്തരം: 1- ഒരു മുസ്ലിമിനെ കണ്ടുമുട്ടിയാൽ സലാം പറഞ്ഞു കൊണ്ട് ആരംഭിക്കുക. \'അസ്സലാമു അലൈക്കും വ റഹ്മതുല്ലാഹി വബറകാതുഹ്\' എന്നാണ് പറയേണ്ടത്. സലാം അല്ലാതെയുള്ള അഭിവാദ്യങ്ങൾ പറയുകയോ, കൈകൾ കൊണ്ട് മാത്രം അഭിവാദനം നടത്തുകയോ ചെയ്യരുത്.<br /> <br /> 2- സലാം പറയുമ്പോൾ പുഞ്ചിരിയോടെ പറയുക.<br /> <br /> 3- വലതു കൈ കൊണ്ട് ഹസ്തദാനം ചെയ്യുക.<br /> <br /> 4- എന്നോട് ഒരാൾ അഭിവാദ്യം പറഞ്ഞാൽ അയാളുടേതിനേക്കാൾ നല്ല രൂപത്തിൽ ഞാൻ തിരിച്ച് അഭിവാദ്യം പറയണം; അതല്ലെങ്കിൽ തുല്യമായ അഭിവാദ്യമെങ്കിലും പറയണം.<br /> <br /> 5- കുഫ്ഫാറുകളോട് അങ്ങോട്ട് സലാം പറയരുത്. അവർ സലാം പറഞ്ഞാൽ തുല്യമായത് തിരിച്ചു മടക്കാം.<br /> <br /> 6- ചെറിയവർ മുതിർന്നവരോടും, വാഹനത്തിലുള്ളവൻ നടക്കുന്നവനോടും, നടക്കുന്നവൻ ഇരിക്കുന്നവനോടും, കുറച്ചു പേരുള്ള സംഘം കൂടുതൽ പേരുള്ള സംഘത്തോടും സലാം പറയണം. </p>',
            ],
            19 => [
                'question' => 'ചോദ്യം 20: സമ്മതം ചോദിക്കുമ്പോൾ പാലിക്കേണ്ട മര്യാദകൾ പറയുക.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12020.mp3',
                'answer' => '<p> ഉത്തരം: 1- ഒരു സ്ഥലത്തേക്ക് പ്രവേശിക്കുന്നതിന് മുൻപ് സമ്മതം ചോദിക്കണം.<br /> <br /> 2- മൂന്നു തവണയാണ് സമ്മതം ചോദിക്കേണ്ടത്. അതിൽ അധികരിപ്പിക്കാൻ പാടില്ല. അതിന് ശേഷവും കയറാൻ അനുമതി ലഭിച്ചില്ലെങ്കിൽ തിരിച്ചു പോവുകയാണ് വേണ്ടത്.<br /> <br /> 3- സൗമ്യമായ രൂപത്തിൽ മാത്രമേ വാതിലിൽ മുട്ടാൻ പാടുള്ളൂ. വാതിലിൻ്റെ നേർക്കു നേരെ നിൽക്കുക എന്നത് പാടില്ല. മറിച്ച്, അതിൻ്റെ വലതു ഭാഗത്തോ ഇടതു ഭാഗത്തോ ആയി നിൽക്കണം.<br /> <br /> 4- എൻ്റെ പിതാവോ മാതാവോ മറ്റു വല്ലവരുമോ ഒരു മുറിയിലുണ്ടെങ്കിൽ സമ്മതം ചോദിക്കാതെ അവിടേക്ക് പ്രവേശിക്കരുത്. പ്രത്യേകിച്ചും സുബ്ഹിന് മുൻപുള്ള സമയത്തും, ഉച്ചയുറക്കത്തിൻ്റെ വേളയിലും, ഇശാ നിസ്കാരത്തിന് ശേഷമുള്ള സമയത്തും.<br /> <br /> 5- ജനങ്ങൾ സ്ഥിരതാമസമില്ലാത്ത സ്ഥലങ്ങളിലേക്ക് പ്രവേശിക്കുന്നതിന് മുൻപ് അനുവാദം ചോദിക്കേണ്ടതില്ല. കച്ചവട സ്ഥലങ്ങളിലേക്കോ ഹോസ്പിറ്റലിലേക്കോ പ്രവേശിക്കുന്നത് ഉദാഹരണം. </p>',
            ],
            20 => [
                'question' => 'ചോദ്യം 21: മൃഗങ്ങളോട് സൗമ്യതയിൽ പെരുമാറേണ്ട രൂപം വിവരിക്കൂ.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12100.mp3',
                'answer' => '<p> ഉത്തരം: 1- മൃഗത്തിന് ഭക്ഷണം നൽകുകയും വെള്ളം കൊടുക്കുകയും വേണം.<br /> <br /> 2- അവയോട് കരുണയും അനുകമ്പയും പുലർത്തണം. സാധിക്കാത്ത ഭാരങ്ങൾ അവയുടെ മേൽ വെക്കരുത്.<br /> <br /> 3- മൃഗങ്ങളെ യാതൊരു തരത്തിലും ശിക്ഷിക്കുകയോ ഉപദ്രവിക്കുകയോ ചെയ്യരുത്. </p>',
            ],
            21 => [
                'question' => 'ചോദ്യം 22: കളിക്കുമ്പോൾ പാലിക്കേണ്ട മര്യാദകൾ ഏതെല്ലാമാണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12160.mp3',
                'answer' => '<p> ഉത്തരം: 1- അല്ലാഹുവിനെ അനുസരിക്കുകയും അവനെ തൃപ്തിപ്പെടുത്തുകയും ചെയ്യുന്ന ആരാധനകൾ നിർവ്വഹിക്കാനുള്ള ശക്തി സംഭരിക്കുന്നതിന് വേണ്ടിയാണ് കളികളിൽ ഏർപ്പെടുന്നത് എന്ന നിയ്യത്ത് <span class="c2">(ഉദ്ദേശ്യം)</span> ഉണ്ടായിരിക്കുക.<br /> <br /> 2- നിസ്കാര സമയത്ത് കളികൾ പാടില്ല.<br /> <br /> 3- ആൺകുട്ടികൾ പെൺകുട്ടികളോടൊപ്പം കളിക്കരുത്.<br /> <br /> 4- ഔറത്തുകൾ മറക്കുന്ന തരത്തിലുള്ള വസ്ത്രങ്ങളേ കളിക്കുമ്പോൾ ധരിക്കാൻ പാടുള്ളൂ.<br /> <br /> 5- നിഷിദ്ധമായ കളികളിൽ ഏർപ്പെടാൻ പാടില്ല. മുഖത്ത് അടിക്കുകയോ, ഔറത്തുകൾ വെളിവാവുകയോ ചെയ്യുന്ന കളികൾ പാടില്ല. </p>',
            ],
            22 => [
                'question' => 'ചോദ്യം 23: തമാശ പറയുമ്പോൾ പാലിക്കേണ്ട മര്യാദകൾ വിവരിക്കുക.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12240.mp3',
                'answer' => '<p> ഉത്തരം: 1- തമാശയിൽ പോലും കളവ് പറയരുത്. സത്യമേ പറയാവൂ.<br /> <br /> 2- പരിഹാസമോ കളിയാക്കലോ മറ്റുള്ളവരെ ഉപദ്രവിക്കലോ ഭയപ്പെടുത്തലോ അടങ്ങുന്ന തരത്തിലുള്ള തമാശകൾ പാടില്ല.<br /> <br /> 3- തമാശകൾ അധികരിപ്പിക്കാൻ പാടില്ല. </p>',
            ],
            23 => [
                'question' => 'ചോദ്യം 24: തുമ്മുമ്പോൾ പാലിക്കേണ്ട മര്യാദകൾ വിവരിക്കുക.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12300.mp3',
                'answer' => '<p> ഉത്തരം: 1- തുമ്മുമ്പോൾ കൈ കൊണ്ടോ വസ്ത്രം കൊണ്ടോ ടവ്വൽ കൊണ്ടോ മുഖം പൊത്തുക.<br /> <br /> 2- തുമ്മിയതിന് ശേഷം അല്ലാഹുവിനെ സ്തുതിച്ചു കൊണ്ട് അൽഹംദുലില്ലാഹ് എന്ന് പറയുക.<br /> <br /> 3- അത് കേൾക്കുന്ന വ്യക്തി \'യർഹമുകല്ലാഹ്\' <span class="c2">(അല്ലാഹു നിനക്ക് കരുണ ചൊരിയട്ടെ)</span> എന്ന് പറയണം.<br /> <br /> അങ്ങനെ പറഞ്ഞാൽ അവനോട് \'യഹ്ദീകുമുല്ലാഹു വ യുസ്ലിഹ് ബാലകും\' <span class="c2">(അല്ലാഹു നിന്നെ നേർമാർഗത്തിലാക്കുകയും നിന്റെ അവസ്ഥ നന്നാക്കിത്തരികയും ചെയ്യുമാറാകട്ടെ)</span> എന്ന് പറയണം. </p>',
            ],
            24 => [
                'question' => 'ചോദ്യം 25: കോട്ടുവായ ഇടുമ്പോൾ പാലിക്കേണ്ട മര്യാദകൾ ഏതെല്ലാമാണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12360.mp3',
                'answer' => '<p> ഉത്തരം: 1- കോട്ടുവായ പരമാവധി പിടിച്ചു വെക്കാൻ ശ്രമിക്കുക.<br /> <br /> 2- ആഹ് എന്ന് ഉച്ചത്തിൽ ശബ്ദമുണ്ടാക്കാതിരിക്കുക.<br /> <br /> 3- വായ കൈ കൊണ്ട് പൊത്തിപ്പിടിക്കുക. </p>',
            ],
            25 => [
                'question' => 'ചോദ്യം 26: ഖുർആൻ പാരായണത്തിൻ്റെ മര്യാദകൾ വിവരിക്കുക.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12420.mp3',
                'answer' => '<p> ഉത്തരം: 1- വുദൂഅ് എടുത്ത ശേഷം ശുദ്ധിയുള്ള അവസ്ഥയിലാണ് ഖുർആൻ പാരായണം ചെയ്യേണ്ടത്.<br /> <br /> 2- മര്യാദയോടും ഗാംഭീര്യത്തോടും കൂടിയാണ് ഖുർആൻ പാരായണം ചെയ്യാനായി ഇരിക്കേണ്ടത്.<br /> <br /> 3- ഖുർആൻ പാരായണം തുടങ്ങുന്നതിന് മുൻപ് \'അഊദു\' ചൊല്ലണം.<br /> <br /> 4- ഖുർആനിൻ്റെ അർത്ഥത്തെ കുറിച്ചും ഉദ്ദേശ്യത്തെ കുറിച്ചും ചിന്തിക്കണം. </p>',
            ],
        ],
        7 => [
            0 => [
                'question' => 'ചോദ്യം 1: സൽസ്വഭാവത്തിൻ്റെ ശ്രേഷ്ഠത വിവരിക്കുക.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12500.mp3',
                'answer' => '<p> ഉത്തരം: നബി -ﷺ-<span class="c6"> പറഞ്ഞിരിക്കുന്നു:</span> "മുഅ്മിനീങ്ങളിൽ ഏറ്റവും പൂർണ്ണ ഈമാനുള്ളത് അവരിൽ ഏറ്റവും നല്ല സ്വഭാവമുള്ളവനാണ്." <span class="c2">(തിർമിദി, അഹ്മദ്)</span> </p>',
            ],
            1 => [
                'question' => 'ചോദ്യം 2: എന്തിനാണ് നാം ഇസ്ലാമിക സ്വഭാവമര്യാദകൾ പാലിക്കുന്നത്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12530.mp3',
                'answer' => '<p> ഉത്തരം: 1- കാരണം നല്ല സ്വഭാവം പാലിക്കുന്നത് അല്ലാഹുവിൻ്റെ സ്നേഹം ലഭിക്കാൻ കാരണമാകും.<br /> <br /> 2- മറ്റുള്ളവർ നമ്മെ സ്നേഹിക്കാനും അത് കാരണമാകും.<br /> <br /> 3- അല്ലാഹുവിൻ്റെ തുലാസിൽ ഏറ്റവും കനം തൂങ്ങുന്ന കാര്യം നല്ല സ്വഭാവമാണ്.<br /> <br /> 4- സൽസ്വഭാവത്തിനുള്ള പ്രതിഫലം ഇരട്ടിയിരട്ടിയായി നൽകപ്പെടുന്നതാണ്.<br /> <br /> 5- ഈമാനിൻ്റെ പൂർണ്ണതക്കുള്ള അടയാളമാണ് സൽസ്വഭാവം. </p>',
            ],
            2 => [
                'question' => 'ചോദ്യം 3: എവിടെ നിന്നാണ് നല്ല സ്വഭാവങ്ങൾ പഠിക്കാൻ കഴിയുക?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12600.mp3',
                'answer' => '<p> ഉത്തരം: - വിശുദ്ധ ഖുർആനിൽ നിന്ന്.<span class="c6"> അല്ലാഹു പറഞ്ഞിരിക്കുന്നു:</span> "തീർച്ചയായും ഈ ഖുർആൻ ഏറ്റവും നേരായതിലേക്ക് വഴികാട്ടുന്നു." <span class="c2">(ഇസ്റാഅ്: 9)</span> നബി -ﷺ- യുടെ സുന്നത്തിൽ നിന്നും നല്ല സ്വഭാവങ്ങൾ പഠിക്കാൻ കഴിയും.<span class="c6"> അവിടുന്ന് പറഞ്ഞു:</span> "നല്ല സ്വഭാവഗുണങ്ങൾ പൂർണ്ണമാക്കുന്നതിനത്രെ ഞാൻ നിയോഗിക്കപ്പെട്ടത്." <span class="c2">(അഹ്മദ്)</span> </p>',
            ],
            3 => [
                'question' => 'ചോദ്യം 4: എന്താണ് \'ഇഹ്സാൻ\' എന്ന സ്വഭാവം? അതിൻ്റെ രൂപങ്ങൾ ഏതെല്ലാമാണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12640.mp3',
                'answer' => '<p> ഉത്തരം: എല്ലാ സന്ദർഭത്തിലും അല്ലാഹു തന്നെ വീക്ഷിച്ചു കൊണ്ടിരിക്കുന്നുണ്ട് എന്ന തിരിച്ചറിവോടെ ജീവിക്കലാണ് ഇഹ്സാൻ. അതോടൊപ്പം ചുറ്റുപാടുമുള്ള മനുഷ്യർക്കും ജീവജാലങ്ങൾക്കും നന്മകൾ ചെയ്യലുമാണ്.<span class="c6"><br /> <br /> നബി ﷺ പറഞ്ഞിരിക്കുന്നു:</span> "അല്ലാഹു എല്ലാ കാര്യത്തിലും ഇഹ്സാൻ നിശ്ചയിച്ചിരിക്കുന്നു." <span class="c2">(മുസ്ലിം)</span><br /> ഇഹ്സാനിൻ്റെ ചില രൂപങ്ങൾ താഴെ പറയാം:<br /> <br /> - അല്ലാഹുവിനുള്ള ആരാധനയിൽ പാലിക്കേണ്ട ഇഹ്സാൻ; അവനുള്ള ആരാധനകൾ പരിപൂർണ്ണ നിഷ്കളങ്കതയോടെ നിർവ്വഹിക്കലാണ് അത് കൊണ്ട് ഉദ്ദേശ്യം.<br /> <br /> - മാതാപിതാക്കളോടുള്ള ഇഹ്സാൻ; അവരോട് നല്ല വാക്കുകൾ പറയലും, നല്ല നിലയിൽ വർത്തിക്കലും അതിൽ പെടുന്നു.<br /> <br /> - കുടുംബത്തോടും ബന്ധക്കാരോടുമുള്ള ഇഹ്സാൻ.<br /> <br /> - അയൽവാസിയോട്...<br /> <br /> - അനാഥരോടും ദരിദ്രരോടും...<br /> <br /> - നിന്നോട് അതിക്രമം പ്രവർത്തിച്ചവരോട്...<br /> <br /> - സംസാരത്തിൽ പാലിക്കേണ്ട ഇഹ്സാൻ.<br /> <br /> - തർക്കത്തിലും സംവാദത്തിലും പാലിക്കേണ്ട ഇഹ്സാൻ.<br /> <br /> - മൃഗങ്ങളോട്... </p>',
            ],
            4 => [
                'question' => 'ചോദ്യം 5: ഇഹ്സാനിൻ്റെ വിരുദ്ധസ്വഭാവം ഏതാണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12780.mp3',
                'answer' => '<p> ഉത്തരം: ഇഹ്സാൻ എന്നാൽ എല്ലാ കാര്യവും ഏറ്റവും നന്നാക്കലാണെങ്കിൽ അതിൻ്റെ വിപരീതം കാര്യങ്ങൾ മോശമാക്കലാണ്.<br /> <br /> അല്ലാഹുവിനോടുള്ള ആരാധനയിൽ നിഷ്കളങ്കത ഇല്ലാതിരിക്കുക എന്നത് അതിൽ പെടും.<br /> <br /> - മാതാപിതാക്കളെ ദ്രോഹിക്കൽ...<br /> <br /> - കുടുംബബന്ധം മുറിക്കൽ.<br /> <br /> - അയൽവാസിയെ ഉപദ്രവിക്കൽ<br /> <br /> - ദരിദ്രരോടും പാവപ്പെട്ടവരോടും നന്മ ചെയ്യുന്നത് ഉപേക്ഷിക്കൽ... ഇതു പോലെ എല്ലാ മോശം വാക്കുകളും പ്രവർത്തികളും ഇഹ്സാനിന് വിരുദ്ധമാണ്. </p>',
            ],
            5 => [
                'question' => 'ചോദ്യം 6: വിശ്വസ്തത (അമാനത്ത്) എന്ന സ്വഭാവം എങ്ങനെയാണ്? അതിൻ്റെ രൂപങ്ങൾ ഏതെല്ലാമാണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12860.mp3',
                'answer' => '<p> ഉത്തരം:<br /> <br /> 1- അല്ലാഹുവിനോടുള്ള ബാധ്യതകൾ നിറവേറ്റുന്നതിൽ വിശ്വസ്തത കാത്തുസൂക്ഷിക്കണം.<br /> <br /> 2- അല്ലാഹു നമ്മുടെ മേൽ നിർബന്ധമാക്കിയ ആരാധനാകർമ്മങ്ങളായ നിസ്കാരവും സകാത്തും നോമ്പും ഹജ്ജും മറ്റുമെല്ലാം നിർവ്വഹിക്കുന്നതിൽ വിശ്വസ്തത പാലിക്കണം.<br /> <br /> 3- മനുഷ്യരോടുള്ള ബാധ്യതകളിൽ വിശ്വസ്തത പുലർത്തണം.<br /> <br /> - ജനങ്ങളുടെ അഭിമാനങ്ങൾ കാത്തുസൂക്ഷിക്കൽ.<br /> <br /> - അവരുടെ സമ്പത്തിൽ വിശ്വസ്തത കാത്തുസൂക്ഷിക്കൽ.<br /> <br /> - അവരുടെ ജീവൻ്റെ കാര്യത്തിൽ വിശ്വസ്തത ഉണ്ടാവൽ.<br /> <br /> - അവരുടെ രഹസ്യങ്ങൾ കാത്തുസൂക്ഷിക്കുക; ജനങ്ങൾ നിന്നെ വിശ്വസിച്ചേൽപ്പിച്ച ഏതൊരു കാര്യത്തിലും വിശ്വസ്തത പുലർത്തുക.<span class="c6"><br /> <br /> വിജയികളായ മനുഷ്യരുടെ വിശേഷണങ്ങൾ വിവരിച്ചു കൊണ്ട് അല്ലാഹു പറഞ്ഞു:</span> "തങ്ങളുടെ അമാനത്തുകളും <span class="c2">(വിശ്വസിച്ചേൽപ്പിക്കപ്പെട്ട കാര്യങ്ങൾ)</span> കരാറുകളും പാലിക്കുന്നവരുമാണ് അവർ." <span class="c2">(മുഅ്മിനൂൻ: 8)</span> </p>',
            ],
            6 => [
                'question' => 'ചോദ്യം 7: അമാനത്തിൻ്റെ വിരുദ്ധസ്വഭാവം ഏതാണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12980.mp3',
                'answer' => '<p> ഉത്തരം: വഞ്ചനയാണത്. അല്ലാഹുവിനോടുള്ള ബാധ്യതകളിലും ജനങ്ങളോടുള്ള ബാധ്യതകളിലും ഇത് സംഭവിക്കാം.<br /> <br /> നബി -ﷺ-<span class="c6"> പറഞ്ഞു:</span> "കപടവിശ്വാസിയായ മുനാഫിഖിൻ്റെ സ്വഭാവം മൂന്നാണ്.<span class="c6">" അക്കൂട്ടത്തിൽ അവിടുന്ന് പറഞ്ഞു:</span> "അവൻ വിശ്വസിച്ചേൽപ്പിക്കപ്പെട്ടാൽ വഞ്ചിക്കും." <span class="c2">(ബുഖാരി, മുസ്ലിം)</span> </p>',
            ],
            7 => [
                'question' => 'ചോദ്യം 8: സത്യസന്ധത എന്ന സൽസ്വഭാവത്തെ കുറിച്ച് വിവരിക്കുക.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13020.mp3',
                'answer' => '<p> ഉത്തരം: യാഥാർത്ഥ്യത്തോട് യോജിക്കുന്ന സംസാരമാണ് സത്യം. അതല്ലെങ്കിൽ, എല്ലാ കാര്യവും എങ്ങനെയാണോ അതു പോലെത്തന്നെ പറയുക.<span class="c6"><br /> <br /> അതിൻ്റെ ചില രൂപങ്ങൾ താഴെ പറയാം:</span><br /> <br /> - ജനങ്ങളോടുള്ള സംസാരത്തിൽ സത്യം പറയുക.<br /> <br /> - വാഗ്ദാനം നൽകിയാൽ അത് പാലിക്കുക.<br /> <br /> - എല്ലാ വാക്കുകളിലും പ്രവർത്തികളിലും സത്യസന്ധത പാലിക്കുക.<br /> <br /> നബി -ﷺ-<span class="c6"> പറഞ്ഞു:</span> "തീർച്ചയായും സത്യസന്ധത നന്മയിലേക്ക് നയിക്കും. തീർച്ചയായും നന്മ സ്വർഗത്തിലേക്ക് നയിക്കും. ഒരാൾ സത്യം പറഞ്ഞു കൊണ്ടേയിരിക്കുകയും, അങ്ങനെ സ്വിദ്ദീഖ് <span class="c2">(അതീവ സത്യസന്ധൻ)</span> ആയിത്തീരുകയും ചെയ്യുന്നതാണ്." <span class="c2">(ബുഖാരി, മുസ്ലിം)</span> </p>',
            ],
            8 => [
                'question' => 'ചോദ്യം 9: സത്യസന്ധതയുടെ വിപരീതം എന്താണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13100.mp3',
                'answer' => '<p> ഉത്തരം: കളവ്. യാഥാർത്ഥ്യത്തിന് വിരുദ്ധം പറയുക എന്നതാണ് അതിൻ്റെ ഉദ്ദേശ്യം. ജനങ്ങളുടെ മേൽ കളവ് കെട്ടിപ്പറയലും, വാഗ്ദാനങ്ങൾ ലംഘിക്കലും, കള്ളസത്യം ചെയ്യലും അതിൽ പെട്ടതാണ്.<br /> <br /> നബി -ﷺ-<span class="c6"> പറഞ്ഞിരിക്കുന്നു:</span> "നിങ്ങൾ കളവിനെ സൂക്ഷിക്കുക; കാരണം തീർച്ചയായും കളവ് തിന്മകളിലേക്ക് നയിക്കും; തിന്മകൾ ഉറപ്പായും നരകത്തിലേക്കും നയിക്കും. ഒരാൾ കളവ് പറഞ്ഞു കൊണ്ടേയിരുന്നാൽ അല്ലാഹുവിങ്കൽ പെരുംകള്ളൻ എന്ന് അവനെ കുറിച്ച് രേഖപ്പെടുത്തപ്പെടുന്നതാണ്." <span class="c2">(ബുഖാരി, മുസ്ലിം)</span> നബി -ﷺ-<span class="c6"> പറഞ്ഞു:</span> "കപടവിശ്വാസിയായ മുനാഫിഖിൻ്റെ സ്വഭാവം മൂന്നാണ്.<span class="c6">" അക്കൂട്ടത്തിൽ അവിടുന്ന് പറഞ്ഞു:</span> "സംസാരിച്ചാൽ അവൻ കളവ് പറയും. വാഗ്ദാനം നൽകിയാൽ അവൻ ലംഘിക്കും." <span class="c2">(ബുഖാരി, മുസ്ലിം)</span> </p>',
            ],
            9 => [
                'question' => 'ചോദ്യം 10: ക്ഷമയുടെ ഇനങ്ങൾ ഏതെല്ലാമാണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13140.mp3',
                'answer' => '<p> ഉത്തരം: - അല്ലാഹുവിനെ അനുസരിക്കുന്നതിൽ വേണ്ട ക്ഷമ.<br /> <br /> - തിന്മയിൽ നിന്ന് വിട്ടുനിൽക്കാൻ വേണ്ട ക്ഷമ.<br /> <br /> - പ്രയാസകരമായ വിധിയിൽ ക്ഷമ കൈക്കൊള്ളുക. എല്ലാ സന്ദർഭത്തിലും അല്ലാഹുവിനെ സ്തുതിക്കുക.<span class="c6"><br /> <br /> അല്ലാഹു പറയുന്നു:</span> "അല്ലാഹു ക്ഷമാശീലരെ ഇഷ്ടപ്പെടുന്നു." <span class="c2">(ആലു ഇംറാൻ: 146)</span> നബി -ﷺ-<span class="c6"> പറഞ്ഞു:</span> "മുഅ്മിനിൻ്റെ കാര്യം അത്ഭുതം തന്നെ! അവൻ്റെ എല്ലാ കാര്യവും അവന് നന്മയാണ്. അതൊരു മുഅ്മിനിന് അല്ലാതെ ഉണ്ടാവുകയില്ല. അവനൊരു സന്തോഷം ബാധിച്ചാൽ അവൻ അല്ലാഹുവിന് നന്ദി കാണിക്കും; അതോടെ അതവനൊരു നന്മയായി മാറും. അവനൊരു പ്രയാസം ബാധിച്ചാൽ അവൻ ക്ഷമിക്കും; അപ്പോൾ അതും അവന് നന്മയായി മാറും." <span class="c2">(മുസ്ലിം)</span> </p>',
            ],
            10 => [
                'question' => 'ചോദ്യം 11: ക്ഷമയുടെ വിരുദ്ധമാകുന്ന കാര്യം എന്താണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13210.mp3',
                'answer' => '<p> ഉത്തരം: അല്ലാഹുവിനെ അനുസരിക്കുന്നതിലോ, അവൻ വിലക്കിയ കാര്യങ്ങളിൽ നിന്ന് വിട്ടുനിൽക്കുന്നതിലോ ക്ഷമ കൈവെടിയുന്നതും, അല്ലാഹുവിൻ്റെ വിധിയിൽ വാക്കുകൾ കൊണ്ടോ പ്രവർത്തി കൊണ്ടോ അക്ഷമ കാണിക്കുന്നതും ക്ഷമയുടെ നേർവിപരീതമാണ്.<span class="c6"><br /> <br /> അതിൻ്റെ രൂപങ്ങളിൽ പെട്ടതാണ്:</span><br /> <br /> - മരണം ആഗ്രഹിക്കൽ.<br /> <br /> - കവിളത്തടിക്കൽ.<br /> <br /> - വസ്ത്രം വലിച്ചു കീറൽ.<br /> <br /> - മുടി പരത്തിയിടൽ.<br /> <br /> - സ്വന്തത്തിനെതിരെ നാശത്തിനായി പ്രാർത്ഥിക്കൽ.<br /> <br /> നബി -ﷺ-<span class="c6"> പറഞ്ഞു:</span> "പ്രതിഫലത്തിൻ്റെ വലിപ്പം പരീക്ഷണത്തിൻ്റെ കാഠിന്യം അനുസരിച്ചായിരിക്കും. അല്ലാഹു ഒരു കൂട്ടരെ ഇഷ്ടപ്പെട്ടാൽ അവരെ പരീക്ഷിക്കുന്നതായിരിക്കും. ആരെങ്കിലും അതിൽ തൃപ്തി കാണിച്ചാൽ അവർക്ക് <span class="c2">(അല്ലാഹുവിൻ്റെ)</span> തൃപ്തിയുണ്ട്. ആരെങ്കിലും അതിൽ ഈർഷ്യത കാണിച്ചാൽ അവർക്ക് അല്ലാഹുവിൻ്റെ കോപവുമുണ്ട്." <span class="c2">(തിർമിദി, ഇബ്നു മാജഃ)</span> </p>',
            ],
            11 => [
                'question' => 'ചോദ്യം 12: പരസ്പര സഹകരണം എന്ന നല്ല സ്വഭാവം എങ്ങനെയാണ് പുലർത്തേണ്ടത്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13310.mp3',
                'answer' => '<p> ഉത്തരം: സത്യത്തിനു വേണ്ടിയും നന്മകൾക്ക് വേണ്ടിയും മനുഷ്യർ പരസ്പരം സഹകരിക്കണം.<span class="c6"><br /> <br /> പരസ്പര സഹകരണത്തിൻ്റെ രൂപങ്ങളിൽ പെട്ട ചിലത് താഴെ പറയാം:</span><br /> <br /> - മനുഷ്യരുടെ അവകാശങ്ങൾ നേടിക്കൊടുക്കാൻ വേണ്ടി പരസ്പരം സഹകരിക്കൽ.<br /> <br /> - അതിക്രമിയുടെ കയ്യിൽ നിന്ന് അന്യായമായി നേടിയത് തിരിച്ചെടുക്കാൻ വേണ്ടി പരസ്പരം സഹകരിക്കൽ.<br /> <br /> - മനുഷ്യരുടെ ആവശ്യങ്ങളും ദരിദ്രരുടെ പ്രയാസങ്ങളും നീക്കാൻ വേണ്ടി പരസ്പരം സഹകരിക്കൽ.<br /> <br /> - എല്ലാ നന്മകളിലും പുലർത്തേണ്ട പരസ്പര സഹകരണം.<br /> <br /> - തിന്മകളിലും ഉപദ്രവങ്ങളിലും ശത്രുതയിലും പരസ്പരം സഹകരണം നടത്താതിരിക്കൽ.<span class="c6"><br /> <br /> അല്ലാഹു പറയുന്നു:</span> "നിങ്ങൾ നന്മയിലും ധർമ്മനിഷ്ഠയിലും പരസ്പരം സഹകരിക്കുക; നിങ്ങൾ തിന്മയിലും ശത്രുതയിലും പരസ്പരം സഹകരിക്കരുത്. അല്ലാഹുവിനെ നിങ്ങൾ സൂക്ഷിക്കുകയും ചെയ്യുക. തീർച്ചയായും അല്ലാഹു കഠിനമായി ശിക്ഷിക്കുന്നവനാണ്." <span class="c2">(മാഇദ: 2)</span> നബി -ﷺ-<span class="c6"> പറഞ്ഞു:</span> "ഒരു മുഅ്മിനിന് മറ്റൊരു മുഅ്മിനിനുമായുള്ള ബന്ധം ഒരു കെട്ടിടം പോലെയാണ്; അവ പരസ്പരം ബലം പകരുന്നു." <span class="c2">(ബുഖാരി, മുസ്ലിം)</span> നബി -ﷺ-<span class="c6"> പറഞ്ഞു:</span> "ഒരു മുസ്ലിം മറ്റൊരു മുസ്ലിമിൻ്റെ സഹോദരനാണ്. അവൻ തൻ്റെ സഹോദരനെ അക്രമിക്കുകയോ അവനെ <span class="c2">(ശത്രുവിൻ്റെ കയ്യിൽ)</span> വിട്ടുകളയുകയോ ഇല്ല. ആരെങ്കിലും തൻ്റെ സഹോദരൻ്റെ ആവശ്യം നിർവ്വഹിക്കുന്നെങ്കിൽ അല്ലാഹു അവൻ്റെ ആവശ്യം നിറവേറ്റുന്നതായിരിക്കും. ആരെങ്കിലും ഒരു മുസ്ലിമിൻ്റെ പ്രയാസം നീക്കിക്കൊടുത്താൽ അല്ലാഹു അവൻ്റെ മേൽ നിന്ന് അന്ത്യനാളിലെ പ്രയാസം എടുത്തു നീക്കുന്നതാണ്. ആരെങ്കിലും ഒരു മുസ്ലിമിൻ്റെ തിന്മകൾ മറച്ചു പിടിച്ചാൽ അല്ലാഹു അന്ത്യനാളിൽ <span class="c2">(അവൻ്റെ തിന്മകളെ)</span> മറച്ചു പിടിക്കുന്നതാണ്." <span class="c2">(ബുഖാരി, മുസ്ലിം)</span> </p>',
            ],
            12 => [
                'question' => 'ചോദ്യം 13: ലജ്ജ എന്ന സ്വഭാവം കൊണ്ട് ഉദ്ദേശ്യം എന്താണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13420.mp3',
                'answer' => '<p> ഉത്തരം: 1- അല്ലാഹുവിനോട് ലജ്ജ പാലിക്കൽ; അല്ലാഹുവിനെ ധിക്കരിക്കുന്നതിൽ നിനക്ക് ലജ്ജയുണ്ടായിരിക്കണം.<br /> <br /> 2- ജനങ്ങളോടുള്ള ലജ്ജ; വൃത്തികെട്ട സംസാരങ്ങൾ ഉപേക്ഷിക്കലും, മോശത്തരങ്ങൾ പറയാതിരിക്കലും, ഔറത്ത് വെളിവാക്കാതെ സൂക്ഷിക്കലുമെല്ലാം അതിൻ്റെ ഭാഗമാണ്.<br /> <br /> നബി -ﷺ-<span class="c6"> പറഞ്ഞിരിക്കുന്നു:</span> "ഈമാൻ എഴുപതിൽ ചില്ലാനം ശാഖയാകുന്നു. അതിൽ ഏറ്റവും ഉന്നതമായത് ലാ ഇലാഹ ഇല്ലല്ലാഹു എന്നതും ഏറ്റവും താഴെയുള്ളത് വഴിയിൽ നിന്നും ഉപദ്രവങ്ങൾ നീക്കം ചെയ്യലുമാകുന്നു. ലജ്ജ ഈമാനിൻ്റെ ഒരു ശാഖയാകുന്നു." <span class="c2">(മുസ്ലിം)</span> </p>',
            ],
            13 => [
                'question' => 'ചോദ്യം 14: കാരുണ്യം എന്ന സ്വഭാവത്തെ കുറിച്ച് വിവരിക്കുക.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13470.mp3',
                'answer' => '<p> ഉത്തരം: - പ്രായത്തിൽ മുതിർന്നവരോട് കരുണ കാണിക്കുകയും അവരെ ആദരിക്കുകയും വേണം.<br /> <br /> - ചെറിയ പ്രായത്തിലുള്ളവരോടും കുട്ടികളോടും കരുണ കാണിക്കണം.<br /> <br /> - ദരിദ്രരോടും പാവപ്പെട്ടവരോടും ആവശ്യക്കാരായ ജനങ്ങളോടും കരുണ കാണിക്കണം.<br /> <br /> - മൃഗങ്ങളോട് കരുണ കാണിക്കണം; അവർക്ക് ഭക്ഷണം നൽകുകയും അവരെ ഉപദ്രവിക്കാതിരിക്കുകയും വേണം.<br /> <br /> നബി -ﷺ-<span class="c6"> പറഞ്ഞതു പോലെ:</span> "പരസ്പര സ്നേഹത്തിലും, ദയയിലും, കാരുണ്യത്തിലും മുസ്ലിംകളുടെ ഉപമ ഒരൊറ്റ ശരീരത്തിൻ്റെ ഉപമയാണ്. അതിലെ ഒരു അവയവം രോഗത്താൽ പ്രയാസമനുഭവിക്കുമ്പോൾ മറ്റു അവയവങ്ങൾ അതിനു വേണ്ടി ഉറക്കമൊഴിഞ്ഞും പനിപിടിച്ചും വേദനയിൽ പങ്കുചേരും." <span class="c2">(ബുഖാരി, മുസ്ലിം)</span> അല്ലാഹുവിൻ്റെ റസൂൽ -ﷺ-<span class="c6"> പറഞ്ഞിരിക്കുന്നു:</span> "കരുണ ചൊരിയുന്നവരോട് റഹ്മാനായ അല്ലാഹു കരുണ ചൊരിയുന്നതാണ്. നിങ്ങൾ ഭൂനിവാസികളോട് കരുണ ചൊരിയുക; ഉപരിയിലുള്ളവൻ നിങ്ങളോട് കരുണ ചൊരിയുന്നതാണ്." <span class="c2">(അബൂദാവൂദ്, തിർമിദി)</span> </p>',
            ],
            14 => [
                'question' => 'ചോദ്യം 13: സ്നേഹം എന്നത് ഏതൊക്കെ രൂപത്തിലുണ്ട്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13550.mp3',
                'answer' => '<p> ഉത്തരം: ഒന്നാമതായി അല്ലാഹുവിനെ സ്നേഹിക്കണം.<span class="c6"><br /> <br /> അല്ലാഹു പറയുന്നു:</span> മുഅ്മിനീങ്ങൾ ഏറ്റവും കഠിനമായി അല്ലാഹുവിനെ സ്നേഹിക്കുന്നവരാകുന്നു." <span class="c2">(ബഖറ: 165)</span><br /> - രണ്ടാമതായി അല്ലാഹുവിൻ്റെ റസൂൽ -ﷺ- യെ സ്നേഹിക്കണം.<br /> <br /> നബി -ﷺ-<span class="c6"> പറഞ്ഞു:</span> "എൻ്റെ ആത്മാവ് ആരുടെ കയ്യിലാണോ അവൻ തന്നെ സത്യം! നിങ്ങളിലൊരാളും തൻ്റെ മാതാപിതാക്കളേക്കാളും തൻ്റെ മക്കളേക്കാളും എന്നെ സ്നേഹിക്കുന്നത് വരെ വിശ്വാസികളാവുകയില്ല." <span class="c2">(ബുഖാരി)</span><br /> - മുഅ്മിനീങ്ങളെ സ്നേഹിക്കുക; നിനക്ക് നന്മ ആഗ്രഹിക്കുന്നതു പോലെ നീ അവർക്കും നന്മ ആഗ്രഹിക്കുക.<br /> <br /> നബി -ﷺ-<span class="c6"> പറഞ്ഞു:</span> "നിങ്ങളാരും വിശ്വാസികളാവുകയില്ല. താൻ തനിക്ക് ഇഷ്ടപ്പെടുന്നത് തൻ്റെ സഹോദരനും ഇഷ്ടപ്പെടുന്നതുവരെ." <span class="c2">(ബുഖാരി)</span> </p>',
            ],
            15 => [
                'question' => 'ചോദ്യം 16: മുഖപ്രസന്നത എന്ന സ്വഭാവം എങ്ങനെ കാത്തുസൂക്ഷിക്കണം?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13630.mp3',
                'answer' => '<p> ഉത്തരം: മുഖം എപ്പോഴും പ്രസന്നമായിരിക്കണം; സന്തോഷവും പുഞ്ചിരിയും അനുകമ്പയും ജനങ്ങളെ കാണുമ്പോഴുള്ള ആഹ്ളാദവും കാത്തുസൂക്ഷിക്കുമ്പോൾ മുഖം പ്രസന്നമാകും.<br /> <br /> എന്നാൽ മുഖം ചുളിച്ചു പിടിക്കുകയോ ജനങ്ങൾ അകന്നു പോകുന്ന തരത്തിൽ മുഖം വികൃതമാക്കുകയോ ചെയ്യുന്നത് ഈ സ്വഭാവത്തിൻ്റെ നേർവിപരീതമാണ്.<br /> <br /> ഈ സൽസ്വഭാവം പഠിപ്പിക്കുന്ന അനേകം ഹദീഥുകളുണ്ട്. അബൂ ദർ -رَضِيَ اللَّهُ عَنْهُ-<span class="c6"> നിവേദനം:</span> നബി -ﷺ-<span class="c6"> എന്നോട് പറഞ്ഞു:</span> "നന്മയിൽ ഒന്നിനെയും നീ നിസ്സാരമാക്കരുത്. നിൻ്റെ സഹോദരനെ സുസ്മേരവദനനായി കണ്ടുമുട്ടുക എന്നത് പോലും." <span class="c2">(മുസ്ലിം)</span> അല്ലാഹുവിൻ്റെ റസൂൽ -ﷺ-<span class="c6"> പറഞ്ഞിരിക്കുന്നു:</span> "നിൻ്റെ സഹോദരൻ്റെ മുഖത്ത് നോക്കി നീ പുഞ്ചിരിക്കുക എന്നത് ഒരു ദാനധർമ്മമാണ്." <span class="c2">(തിർമിദി)</span> </p>',
            ],
            16 => [
                'question' => 'ചോദ്യം 17: അസൂയ എന്ന ദുസ്വഭാവം എങ്ങനെയാണ് ഒഴിവാക്കുക?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13690.mp3',
                'answer' => '<p> ഉത്തരം: അസൂയയെന്നാൽ മറ്റൊരാളുടെ നന്മകൾ നഷ്ടപ്പെട്ടു കാണാനുള്ള ആഗ്രഹമോ, അവന് നന്മ ലഭിക്കുന്നത് കാണുമ്പോഴുള്ള അനിഷ്ടമോ ആണ്.<span class="c6"><br /> <br /> അല്ലാഹു പറയുന്നു:</span> "അസൂയക്കാരൻ അസൂയപ്പെടുമ്പോൾ അവൻ്റെ ഉപദ്രവത്തിൽ നിന്നും <span class="c2">(ഞാൻ അല്ലാഹുവിനോട് രക്ഷ തേടുന്നു.<span class="c6">" (ഫലഖ്:</span> 5)</span><br /> <br /> അനസ് ബ്നു മാലിക് -رَضِيَ اللَّهُ عَنْهُ-<span class="c6"> നിവേദനം:</span> നബി -ﷺ-<span class="c6"> പറഞ്ഞു:</span> "നിങ്ങൾ പരസ്പരം വെറുപ്പ് കാണിക്കുകയോ, പരസ്പരം അസൂയ കാണിക്കുകയോ, പരസ്പരം കണ്ടാൽ തിരിഞ്ഞു കളയുകയോ ചെയ്യരുത്. പരസരസഹോദരങ്ങളെന്നോണം, അല്ലാഹുവിൻ്റെ അടിമകളായി നിങ്ങൾ മാറുക." <span class="c2">(ബുഖാരി, മുസ്ലിം)</span> </p>',
            ],
            17 => [
                'question' => 'ചോദ്യം 18: പരിഹാസം എന്ന ദുസ്വഭാവം എങ്ങനെയാണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13740.mp3',
                'answer' => '<p> ഉത്തരം: നിൻ്റെ സഹോദരനായ മുസ്ലിമിനെ കളിയാക്കുകയോ ഇകഴ്ത്തി കാണിക്കുകയോ ചെയ്യുന്നത് പരിഹാസമാണ്. അതൊരിക്കലും അനുവദനീയമല്ല.<span class="c6"><br /> <br /> അല്ലാഹു അക്കാര്യം വിലക്കി കൊണ്ട് പറഞ്ഞു:</span> "സത്യവിശ്വാസികളേ, ഒരു ജനവിഭാഗവും മറ്റൊരു ജനവിഭാഗത്തെ പരിഹസിക്കരുത്. ഇവർ <span class="c2">(പരിഹസിക്കപ്പെടുന്നവർ)</span> അവരേക്കാൾ നല്ലവരായിരുന്നേക്കാം. ഒരുവിഭാഗം സ്ത്രീകൾ മറ്റൊരു വിഭാഗം സ്ത്രീകളേയും പരിഹസിക്കരുത്. ഇവർ <span class="c2">(പരിഹസിക്കപ്പെടുന്ന സ്ത്രീകൾ)</span> മറ്റവരേക്കാൾ നല്ലവരായിരുന്നേക്കാം. നിങ്ങൾ അന്യോന്യം കുത്തുവാക്കുകൾ പറയരുത്. നിങ്ങൾ പരിഹാസപ്പേരുകൾ വിളിച്ച് പരസ്പരം അപമാനിക്കുകയും അരുത്. സത്യവിശ്വാസം കൈകൊണ്ടതിനുശേഷം അധാർമ്മികമായ പേര് <span class="c2">(വിളിക്കുന്നത്)</span> എത്ര ചീത്ത. വല്ലവനും പശ്ചാതപിക്കാത്ത പക്ഷം അത്തരക്കാർ തന്നെയാകുന്നു അക്രമികൾ." <span class="c2">(ഹുജുറാത്ത്: 11)</span> </p>',
            ],
            18 => [
                'question' => 'ചോദ്യം 19: വിനയം എന്ന സ്വഭാവത്തെ കുറിച്ച് വിവരിക്കുക.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13780.mp3',
                'answer' => '<p> ഉത്തരം: മറ്റു ജനങ്ങളേക്കാൾ തനിക്ക് എന്തെങ്കിലും ഔന്നത്യമുണ്ടെന്ന് ഒരാൾ ധരിക്കാതിരിക്കലാണ് വിനയം. ജനങ്ങളെ അവൻ തരംതാഴ്ത്തി കാണുകയോ, സത്യത്തെ നിരസിക്കുകയോ ചെയ്യരുത്.<span class="c6"><br /> <br /> അല്ലാഹു പറയുന്നു:</span> "ഭൂമിയിലൂടെ താഴ്മയോടെ നടക്കുന്നവരാണ് റഹ്മാനായ അല്ലാഹുവിൻ്റെ ദാസന്മാർ." <span class="c2">(ഫുർഖാൻ: 63)</span> അതായത്, അവർ വിനയമുള്ളവരായിരിക്കും. അല്ലാഹുവിൻ്റെ റസൂൽ -ﷺ-<span class="c6"> പറഞ്ഞിരിക്കുന്നു:</span> "ഒരാൾ അല്ലാഹുവിന് വേണ്ടി വിനയം കാണിച്ചാൽ അവനെ അല്ലാഹു ഉയർത്താതിരിക്കുകയില്ല." <span class="c2">(മുസ്ലിം)</span> നബി -ﷺ-<span class="c6"> പറഞ്ഞു:</span> "ഒരാളും മറ്റൊരാളോട് അതിക്രമം കാണിക്കുകയോ, ഒരു വ്യക്തിയും മറ്റൊരാളുടെ മേൽ പൊങ്ങച്ചം നടിക്കുകയോ ചെയ്യാത്ത രൂപത്തിൽ നിങ്ങൾ വിനയമുള്ളവരാകൂ എന്ന് അല്ലാഹു എനിക്ക് സന്ദേശം നൽകിയിരിക്കുന്നു." <span class="c2">(മുസ്ലിം)</span> </p>',
            ],
            19 => [
                'question' => 'ചോദ്യം 20: നിഷിദ്ധമായ അഹങ്കാരം എന്ന ദുസ്വഭാവത്തിൻ്റെ രൂപങ്ങൾ പറയുക.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13840.mp3',
                'answer' => '<p> ഉത്തരം: 1- സത്യത്തിന് മുൻപിൽ അഹങ്കാരം നടിക്കൽ. സത്യത്തെ തിരസ്കരിക്കലും അതിനെ സ്വീകരിക്കാതിരിക്കലും ഈ പറഞ്ഞതിൽ പെടും.<br /> <br /> 2- ജനങ്ങളുടെ മേൽ അഹങ്കാരം നടിക്കൽ. അവരെ താഴ്ത്തി കാണുകയോ, ഇകഴ്ത്തുകയോ ചെയ്യുന്നത് അതിൻ്റെ പരിധിയിൽ പെടും.<br /> <br /> നബി -ﷺ-<span class="c6"> പറഞ്ഞിരിക്കുന്നു:</span> "ഹൃദയത്തിൽ തരിമ്പു പോലും അഹങ്കാരമുള്ളവൻ സ്വർഗത്തിൽ പ്രവേശിക്കുകയില്ല.<span class="c6">" അപ്പോൾ ഒരാൾ പറഞ്ഞു:</span> "ചിലർ തൻ്റെ വസ്ത്രവും ചെരുപ്പും നല്ലതായിരിക്കാൻ ആഗ്രഹിക്കാറുണ്ടല്ലോ?" നബി -ﷺ-<span class="c6"> പറഞ്ഞു:</span> "തീർച്ചയായും അല്ലാഹു ഭംഗിയുള്ളവനാണ്. അവൻ ഭംഗിയെ ഇഷ്ടപ്പെടുന്നു. അഹങ്കാരമെന്നാൽ സത്യത്തെ തിരസ്കരിക്കലും ജനങ്ങളെ തരംതാഴ്ത്തലുമാണ്." <span class="c2">(മുസ്ലിം)</span><br /> - സത്യത്തെ തിരസ്കരിക്കൽ എന്നാൽ അതിനെ തള്ളിക്കളയലാണ്.<br /> <br /> - ജനങ്ങളെ ഇകഴ്ത്തുക എന്നാൽ അവരെ തരംതാഴ്ന്നവരായി കാണലാണ്.<br /> <br /> - നല്ല വസ്ത്രമോ നല്ല ചെരുപ്പോ ധരിക്കുന്നത് ഒരിക്കലും അഹങ്കാരത്തിൻ്റെ പരിധിയിൽ പെടില്ല. </p>',
            ],
            20 => [
                'question' => 'ചോദ്യം 21: നിഷിദ്ധമായ സ്വഭാവങ്ങളിൽ പെട്ട വഞ്ചനയെ കുറിച്ച് വിവരിക്കുക.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13910.mp3',
                'answer' => '<p> ഉത്തരം: കച്ചവടത്തിലും കൊടുക്കൽ വാങ്ങലുകളിലും വഞ്ചന സംഭവിക്കാം. വിൽക്കുന്ന വസ്തുവിൻ്റെ ന്യൂനത പറയാതിരിക്കുക എന്നത് ഉദാഹരണം.<br /> <br /> - പഠിക്കുന്ന കാര്യത്തിലും ചിലർ വഞ്ചന കാണിക്കും; ഉദാഹരണത്തിൽ പരീക്ഷകളിൽ കോപ്പിയടിക്കുക എന്നത് വഞ്ചനയാണ്.<br /> <br /> - സംസാരത്തിലുള്ള വഞ്ചനക്ക് ഉദാഹരണമാണ് കള്ളസാക്ഷ്യവും കളവു പറയലും.<br /> <br /> - നീ പറയുന്നത് പാലിക്കാതിരിക്കുകയും, ജനങ്ങളോട് ചെയ്ത കരാറുകൾ ലംഘിക്കലും അതിൻ്റെ മറ്റു രൂപങ്ങളിൽ പെടും.<br /> <br /> ഇക്കാര്യം വിവരിക്കുന്ന ഒരു ഹദീഥ് നോക്കൂ! ഒരിക്കൽ നബി -ﷺ- ഭക്ഷണം കൂട്ടിയിട്ടു വിൽക്കുന്ന ഒരാൾക്ക് അരികിലൂടെ നടന്നു പോയി. തൻ്റെ കൈ അതിൻ്റെ ഉള്ളിലേക്ക് അവിടുന്ന് പ്രവേശിപ്പിച്ചപ്പോൾ അവിടുത്തെ വിരലുകളിൽ നനവ് തട്ടി.<span class="c6"> അവിടുന്ന് ചോദിച്ചു:</span> "എന്താണിത് കച്ചവടക്കാരാ?!" അയാൾ പറഞ്ഞു: "മഴ ബാധിച്ചതാണ് നബിയേ! അവിടുന്ന് പറഞ്ഞു: "എങ്കിൽ നിനക്ക് അത് ഭക്ഷണത്തിൻ്റെ മുകളിൽ -ജനങ്ങൾക്ക് കാണാൻ കഴിയുന്ന വിധത്തിൽ- വെച്ചുകൂടായിരുന്നോ? ആരെങ്കിലും വഞ്ചന കാണിച്ചാൽ അവൻ നമ്മിൽ പെട്ടവനല്ല." <span class="c2">(മുസ്ലിം)</span><br /> ഹദീഥിൽ വന്ന സുബ്റ എന്ന പദത്തിന്റെ അർഥം കൂട്ടിയിട്ട ഭക്ഷണസാധനം എന്നാണ്. </p>',
            ],
            21 => [
                'question' => 'ചോദ്യം 22: എന്താണ് ഗീബത്ത് എന്നത് കൊണ്ട് ഉദ്ദേശ്യം?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13990.mp3',
                'answer' => '<p> ഉത്തരം: നിൻ്റെ സഹോദരൻ്റെ അസാന്നിധ്യത്തിൽ അവനെ കുറിച്ച് അവന് ഇഷ്ടമല്ലാത്ത കാര്യം പറയലാണ് ഗീബത്ത്.<span class="c6"><br /> <br /> അല്ലാഹു പറയുന്നു:</span> "<span class="c2">(വിശ്വാസികളേ!)</span> നിങ്ങളിൽ ചിലർ ചിലരെപ്പറ്റി അവരുടെ അഭാവത്തിൽ ദുഷിച്ചുപറയരുത്. തൻ്റെ സഹോദരൻ മരിച്ചുകിടക്കുമ്പോൾ അവൻ്റെ മാംസം ഭക്ഷിക്കുവാൻ നിങ്ങളാരെങ്കിലും ഇഷ്ടപ്പെടുമോ? എന്നാൽ അത് <span class="c2">(ശവം തിന്നുന്നത്)</span> നിങ്ങൾ വെറുക്കുകയാണു ചെയ്യുന്നത്. അല്ലാഹുവെ നിങ്ങൾ സൂക്ഷിക്കുക. തീർച്ചയായും അല്ലാഹു പശ്ചാത്താപം സ്വീകരിക്കുന്നവനും കരുണാനിധിയുമാകുന്നു." <span class="c2">(ഹുജുറാത്ത്: 12)</span> </p>',
            ],
            22 => [
                'question' => 'ചോദ്യം 23: എന്താണ് നമീമത്ത്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14030.mp3',
                'answer' => '<p> ഉത്തരം: ജനങ്ങൾ തമ്മിലുള്ള ബന്ധം തകർക്കുക എന്ന ഉദ്ദേശ്യത്തോടെ അവരുടെ സംസാരം അങ്ങോട്ടുമിങ്ങോട്ടും എത്തിച്ചു കൊടുക്കലാണ് നമീമത്ത്.<br /> <br /> അല്ലാഹുവിൻ്റെ റസൂൽ -ﷺ-<span class="c6"> പറഞ്ഞിരിക്കുന്നു:</span> "ഏഷണിയുമായി നടക്കുന്നവൻ സ്വർഗത്തിൽ പ്രവേശിക്കുകയില്ല." <span class="c2">(മുസ്ലിം)</span> </p>',
            ],
            23 => [
                'question' => 'ചോദ്യം 24: എന്താണ് അലസത?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14070.mp3',
                'answer' => '<p> ഉത്തരം: നന്മകളും തൻ്റെ മേൽ നിർബന്ധമായ ബാധ്യതകളും ചെയ്യാനുള്ള താൽപ്പര്യക്കുറവിനാണ് അലസത എന്ന് പറയുക.<br /> <br /> അല്ലാഹു നിർബന്ധമാക്കിയ കർമ്മങ്ങൾ ചെയ്യാനുള്ള മടി അതിൽ പെട്ടതാണ്.<span class="c6"><br /> <br /> അല്ലാഹു പറയുന്നു:</span> "തീർച്ചയായും കപടവിശ്വാസികൾ അല്ലാഹുവെ വഞ്ചിക്കാൻ നോക്കുകയാണ്. യഥാർത്ഥത്തിൽ അല്ലാഹു അവരെയാണ് വഞ്ചിക്കുന്നത്. അവർ നമസ്കാരത്തിന് നിന്നാൽ മടിയന്മാരായിക്കൊണ്ടും, ആളുകളെ കാണിക്കാൻ വേണ്ടിയുമാണ് നിൽക്കുന്നത്. കുറച്ച് മാത്രമേ അവർ അല്ലാഹുവെ ഓർമ്മിക്കുകയുള്ളൂ." <span class="c2">(നിസാഅ്: 142)</span><br /> അതിനാൽ മടി ഉപേക്ഷിക്കുകയും ചടഞ്ഞിരിക്കുന്നത് ഒഴിവാക്കുകയും ചെയ്യേണ്ടവനാണ് ഓരോ മുസ്ലിമും. പ്രവർത്തിക്കാനും കാര്യങ്ങൾ ചെയ്യാനും അല്ലാഹുവിന് തൃപ്തികരമായ കാര്യങ്ങൾ ചെയ്യാൻ ഉന്മേഷത്തോടെ പരിശ്രമിക്കാനും ഈ ജീവിതത്തിൽ നമുക്ക് സാധിക്കണം. </p>',
            ],
            24 => [
                'question' => 'ചോദ്യം 25: ദേഷ്യത്തിൻ്റെ ചില ഇനങ്ങൾ പറയുക.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14130.mp3',
                'answer' => '<p> ഉത്തരം: 1- ദേഷ്യം ചിലപ്പോൾ നല്ലതാണ്; അല്ലാഹുവിന് വേണ്ടി ദേഷ്യപ്പെടുക എന്നത് അതിൽ പെട്ടതാണ്. അല്ലാഹുവിനെ നിഷേധിക്കുന്നവരോ കപടവിശ്വാസികളോ മറ്റോ ഇസ്ലാമിക വിധിവിലക്കുകൾ ധിക്കരിക്കുമ്പോഴുണ്ടാകുന്ന ദേഷ്യം ഉദാഹരണം.<br /> <br /> 2- ദേഷ്യം വെറുക്കപ്പെട്ടതാകുന്ന സമയവുമുണ്ട്; ഒരാൾക്ക് അനുയോജ്യമല്ലാത്ത വാക്കുകൾ പറയാനും പ്രവർത്തിക്കാനും പ്രേരിപ്പിക്കുന്ന തരത്തിലുള്ള ദേഷ്യം അതിൽ പെടുന്നതാണ്.<span class="c6"><br /> <br /> അല്ലാഹുവിന് ഇഷ്ടമില്ലാത്ത തരത്തിൽ ദേഷ്യം പിടിക്കുന്നത് ഒഴിവാക്കാനുള്ള വഴി ഇതാണ്:</span><br /> <br /> - വുദൂഅ് ചെയ്യുക.<br /> <br /> - ദേഷ്യം വരുമ്പോൾ നിൽക്കുകയാണെങ്കിൽ ഇരിക്കുക; ഇരിക്കുകയാണെങ്കിൽ കിടക്കുക.<br /> <br /> - നബി -ﷺ-<span class="c6"> യുടെ ഉപദേശം ഓർക്കുക; അവിടുന്ന് പറഞ്ഞു:</span> "നീ ദേഷ്യപ്പെടരുത്."<br /> <br /> - ദേഷ്യത്തിൻ്റെ സന്ദർഭത്തിൽ ശരീരം കൊണ്ട് എന്തെങ്കിലും പ്രവർത്തിക്കുന്നതിൽ നിന്ന് സ്വയം നിയന്ത്രിക്കുക.<br /> <br /> - എറിഞ്ഞകറ്റപ്പെട്ട പിശാചിൽ നിന്ന് അല്ലാഹുവിനോട് രക്ഷ ചോദിക്കുക.<br /> <br /> - നിശബ്ദത പാലിക്കുക. </p>',
            ],
            25 => [
                'question' => 'ചോദ്യം 26: എന്താണ് ചാരപ്പണി എന്ന സ്വഭാവം കൊണ്ട് അർത്ഥമാക്കുന്നത്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14240.mp3',
                'answer' => '<p> ഉത്തരം: ജനങ്ങളുടെ രഹസ്യങ്ങൾ തപ്പിനടക്കുകയും അവർ മറച്ചു വെക്കാൻ ആഗ്രഹിക്കുന്നത് കണ്ടെത്താൻ ശ്രമിക്കലും പ്രചരിപ്പിക്കലും ചാരപ്പണിയിൽ പെടും.<span class="c6"><br /> <br /> നിഷിദ്ധമായ ചാരപ്പണിയുടെ രൂപത്തിൽ പെട്ടതാണ്:</span><br /> <br /> - ജനങ്ങളുടെ രഹസ്യങ്ങളിലേക്ക് -അവരുടെ വീടുകൾക്ക് ഉള്ളിലേക്ക്- ഏന്തിവലിഞ്ഞു നോക്കുക എന്നത്.<br /> <br /> - ഒരു കൂട്ടരുടെ സംസാരം അവർ അറിയാതെ കേൾക്കാൻ ശ്രമിക്കുക എന്നത്.<span class="c6"><br /> <br /> അല്ലാഹു പറയുന്നു:</span> "നിങ്ങൾ ചാരപ്പണി നടത്തരുത്." <span class="c2">(ഹുജുറാത്ത്: 12)</span> </p>',
            ],
            26 => [
                'question' => 'ചോദ്യം 27: ധൂർത്ത്, പിശുക്ക്, ഉദാരത എന്നീ സ്വഭാവങ്ങളെ കുറിച്ച് വിവരിക്കുക.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14310.mp3',
                'answer' => '<p> ഉത്തരം: അനാവശ്യമായി പണം ചെലവഴിക്കുന്നതിന് ധൂർത്ത് എന്ന് പറയും.<br /> <br /> പിശുക്ക് അതിന് നേർവിപരീതമാണ്. ചെലവാക്കേണ്ട കാര്യങ്ങളിൽ വരെ പണം ചെലവഴിക്കാതെ പിടിച്ചു വെക്കലാണ് അത് കൊണ്ട് ഉദ്ദേശ്യം.<br /> <br /> ഈ പറഞ്ഞതിന് രണ്ടിനും ഇടയിലാണ് മദ്ധ്യമ നിലപാട്. അതിനാണ് ഉദാരത എന്ന് പറയുക.<span class="c6"><br /> <br /> അല്ലാഹു പറയുന്നു:</span> "ചെലവഴിക്കുന്നെങ്കിൽ അമിതവ്യയം നടത്തുകയോ, പിശുക്കിപ്പിടിക്കുകയോ ചെയ്യാതെ അതിനിടക്കുള്ള മിതമായ മാർഗം സ്വീകരിക്കുന്നവരുമാകുന്നു അവർ." <span class="c2">(ഫുർഖാൻ: 67)</span> </p>',
            ],
            27 => [
                'question' => 'ചോദ്യം 28: ധീരതയും ഭീരുത്വവും എങ്ങനെ വിവരിക്കാം?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14370.mp3',
                'answer' => '<p> ഉത്തരം: ഭയപ്പെടാൻ പാടില്ലാത്ത കാര്യങ്ങളെ വരെ ഭയപ്പെടുന്നതാണ് ഭീരുത്വം.<br /> <br /> സത്യം തുറന്നു പറയാനും, തിന്മകളെ എതിർക്കാനുമുള്ള ഭയം ഉദാഹരണം.<br /> <br /> ധീരതയെന്നാൽ സത്യത്തിന് വേണ്ടി മുന്നോട്ടു കുതിക്കലാണ്. അല്ലാഹുവിൻ്റെ മാർഗത്തിലുള്ള യുദ്ധത്തിലും, ഇസ്ലാമിനും മുസ്ലിമീങ്ങളെയും പ്രതിരോധിക്കുന്നതിനും വേണ്ടി നിലകൊള്ളുന്നത് ഉദാഹരണം.<br /> <br /> നബി -ﷺ-<span class="c6"> യുടെ പ്രാർത്ഥനയിൽ ഇപ്രകാരം വന്നിട്ടുണ്ട്:</span> "അല്ലാഹുവേ! ഞാൻ ഭീരുത്വത്തിൽ നിന്ന് രക്ഷതേടുന്നു." അല്ലാഹുവിൻ്റെ റസൂൽ -ﷺ-<span class="c6"> പറഞ്ഞിരിക്കുന്നു:</span> "ശക്തനായ മുഅ്മിനിനാണ് ദുർബലനായ മുഅ്മിനിനേക്കാൾ ഉൽകൃഷ്ടനും അല്ലാഹുവിന് പ്രിയങ്കരനും. എല്ലാ <span class="c2">(വിശ്വാസിയിലും)</span> നന്മയുണ്ട്." <span class="c2">(മുസ്ലിം)</span> </p>',
            ],
            28 => [
                'question' => 'ചോദ്യം 29: നിഷിദ്ധമായ വാക്കുകളിൽ പെടുന്ന ചില കാര്യങ്ങൾ വിവരിക്കുക.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14440.mp3',
                'answer' => '<p> ഉത്തരം: - ശാപവാക്കുകളും ആക്ഷേപവാക്കുകളും പറയുന്നത് ഉദാഹരണം.<br /> <br /> - ഉദാഹരണത്തിന് ഒരാളെ മൃഗത്തിൻ്റെ പേരുകളിൽ വിളിക്കലും, സമാനമായ വാക്കുകൾ ഉപയോഗിക്കലും.<br /> <br /> - മ്ലേഛമായ വാക്കുകൾ പറയുന്നതും, വൃത്തികെട്ട വാക്കുകൾ പറയുന്നതും, രഹസ്യഭാഗങ്ങളുടെ പേരുകൾ വിളിക്കുന്നതും.<br /> <br /> - നബി -ﷺ- ഈ പറഞ്ഞതെല്ലാം വിലക്കിയിട്ടുണ്ട്.<span class="c6"> അവിടുന്ന് പറഞ്ഞു:</span> "ഒരു മുഅ്മിൻ ഒരിക്കലും കുത്തിപ്പറയുന്നവനോ, അധികമായി ശപിക്കുന്നവനോ, വൃത്തികേടു പറയുന്നവനോ, മ്ലേഛനോ അല്ല." <span class="c2">(തിർമിദി, ഇബ്നു ഹിബ്ബാൻ)</span> </p>',
            ],
            29 => [
                'question' => 'ചോദ്യം 30: നല്ല സ്വഭാവമുള്ളവനാകാൻ സഹായിക്കുന്ന ചില കാര്യങ്ങൾ വിവരിക്കുക.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14500.mp3',
                'answer' => '<p> ഉത്തരം: 1- അല്ലാഹു നിനക്ക് നല്ല സ്വഭാവം നൽകുന്നതിന് വേണ്ടിയും അക്കാര്യത്തിൽ നിന്നെ സഹായിക്കുന്നതിനും വേണ്ടി അവനോട് ദുആ ചെയ്യുക.<br /> <br /> 2- എപ്പോഴും അല്ലാഹു തന്നെ വീക്ഷിച്ചു കൊണ്ടിരിക്കുന്നുണ്ട് എന്ന ചിന്ത നിലനിർത്തുക. നിന്നെ കുറിച്ച് അവൻ അറിയുന്നുണ്ട് എന്നും, നിന്നെ അവൻ എപ്പോഴും കാണുകയും കേൾക്കുകയും ചെയ്തു കൊണ്ടിരിക്കുന്നുണ്ട് എന്നും ഓർക്കുക.<br /> <br /> 3- സൽസ്വഭാവത്തിനുള്ള പ്രതിഫലത്തെ കുറിച്ച് ഓർക്കുകയും, അത് സ്വർഗപ്രവേശനത്തിന് വഴിയൊരുക്കും എന്ന് മനസ്സിലാക്കുകയും ചെയ്യുക.<br /> <br /> 4- മോശം സ്വഭാവത്തിൻ്റെ പര്യവസാനത്തെ കുറിച്ച് ചിന്തിക്കുകയും, അത് നരകപ്രവേശനത്തിന് കാരണമാകുമെന്ന് അറിയുകയും ചെയ്യുക.<br /> <br /> 5- സൽസ്വഭാവത്തിലൂടെ അല്ലാഹുവിൻ്റെ സ്നേഹവും അവൻ്റെ സൃഷ്ടികളുടെ സ്നേഹവും നേടിയെടുക്കാൻ സാധിക്കും. എന്നാൽ മോശം സ്വഭാവം അല്ലാഹുവിൻ്റെ കോപവും മനുഷ്യരുടെ ദേഷ്യവുമാണ് നേടിത്തരുക.<br /> <br /> 6- നബി -ﷺ- യുടെ ചരിത്രം വായിക്കുകയും, അവിടുത്തെ മാതൃകയാക്കുകയും ചെയ്യുക.<br /> <br /> 7- സൽസ്വഭാവികളെ പിൻപറ്റുകയും, മോശം കൂട്ടുകാരെ അകറ്റി നിർത്തുകയും ചെയ്യുക. </p>',
            ],
        ],
        8 => [
            0 => [
                'question' => 'ചോദ്യം 1: ദിക്ർ ചൊല്ലുന്നതിൻ്റെ ശ്രേഷ്ഠത വിവരിക്കുക.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14630.mp3',
                'answer' => '<p> ഉത്തരം: നബി ﷺ പറഞ്ഞിരിക്കുന്നു: "തൻ്റെ റബ്ബിനെ സ്മരിക്കുന്നവൻ്റെയും തൻ്റെ റബ്ബിനെ സ്മരിക്കാത്തവൻ്റെയും ഉദാഹരണം ജീവിച്ചിരിക്കുന്നവൻ്റെയും മരിച്ചവൻ്റെയും ഉദാഹരണമാണ്." <span class="c2">(ബുഖാരി)</span><br /> കാരണം അല്ലാഹുവിനെ കുറിച്ചുള്ള സ്മരണയുടെ തോതനുസരിച്ചാണ് ഒരാളുടെ മഹത്വവും മൂല്യവും വർദ്ധിക്കുന്നത്. </p>',
            ],
            1 => [
                'question' => 'ചോദ്യം 2: ദിക്ർ ചൊല്ലുന്നതിൻ്റെ ചില ഉപകാരങ്ങൾ വിവരിക്കുക.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14670.mp3',
                'answer' => '<p> ഉത്തരം: 1- അത് റഹ്മാനായ അല്ലാഹുവിന് തൃപ്തികരമായ കാര്യമാണ്.<br /> <br /> 2- ദിക്ർ പിശാചിനെ അകറ്റുന്നതാണ്.<br /> <br /> 3- ഉപദ്രവങ്ങളിൽ നിന്ന് തടുക്കുന്നതാണ്.<br /> <br /> 4- മഹത്തരമായ പ്രതിഫലവും പുണ്യവും ലഭിക്കാൻ കാരണമാണ്. </p>',
            ],
            2 => [
                'question' => 'ചോദ്യം 3: ഏറ്റവും മഹത്തരമായ ദിക്ർ ഏതാണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14730.mp3',
                'answer' => '<p> ഉത്തരം: അല്ലാഹുവല്ലാതെ ആരാധനക്ക് അർഹനായി മറ്റാരുമില്ല എന്നറിയിക്കുന്ന ലാ ഇലാഹ ഇല്ലല്ലാഹ് എന്ന ദിക്റാണ് ഏറ്റവും ശ്രേഷ്ഠതയുള്ള ദിക്ർ. <span class="c2">(തിർമിദി, ഇബ്നു മാജഃ)</span> </p>',
            ],
            3 => [
                'question' => 'ചോദ്യം 4: ഉറക്കത്തിൽ നിന്ന് എഴുന്നേറ്റാൽ എന്താണ് ചൊല്ലേണ്ടത്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14760.mp3',
                'answer' => '<p> ഉത്തരം: "നമ്മെ മരിപ്പിച്ചതിനുശേഷം ജീവിപ്പിച്ചവനായ അല്ലാഹുവിനാകുന്നു സർവ്വസ്തുതിയും. അവനിലേക്ക് തന്നെയാകുന്നു പുനരുത്ഥാനം." <span class="c2">(ബുഖാരി, മുസ്ലിം)</span> </p>',
            ],
            4 => [
                'question' => 'ചോദ്യം 5: വസ്ത്രം ധരിച്ചാൽ എന്താണ് ചൊല്ലേണ്ടത്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14790.mp3',
                'answer' => '<p> ഉത്തരം: "ഈ വസ്ത്രം എന്നെ ഉടുപ്പിക്കുകയും എനിക്കിത് എൻ്റെ യാതൊരു കഴിവോ ശക്തിയോ കൂടാതെ നൽകുകയും ചെയ്ത അല്ലാഹുവിനാകുന്നു സർവ സ്തുതിയും..." <span class="c2">(അബൂദാവൂദ്, തിർമിദി തുടങ്ങിയവർ)</span> </p>',
            ],
            5 => [
                'question' => 'ചോദ്യം 6: വസ്ത്രം ഊരിവെക്കുമ്പോൾ എന്താണ് ചൊല്ലേണ്ടത്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14820.mp3',
                'answer' => '<p> ഉത്തരം: ബിസ്മില്ലാഹ്. <span class="c2">(അല്ലാഹുവിൻ്റെ നാമത്തിൽ)</span> <span class="c2">(തിർമിദി)</span> </p>',
            ],
            6 => [
                'question' => 'ചോദ്യം 7: പുതിയ വസ്ത്രം ധരിച്ചാൽ എന്താണ് ചൊല്ലേണ്ടത്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14850.mp3',
                'answer' => '<p> ഉത്തരം: "അല്ലാഹുവേ, നിനക്കാണ് സർവ സ്തുതിയും. നീയാണ് എന്നെയിത് ഉടുപ്പിച്ചത്. ഇതിൻ്റെ നന്മ ഞാൻ നിന്നോട് ചോദിക്കുന്നു. ഇത് ഏതൊരു നന്മക്ക് വേണ്ടി നിർമിക്കപ്പെട്ടുവോ ആ നന്മയിൽ നിന്നും ഞാൻ ചോദിക്കുന്നു. ഇതിൻ്റെ തിന്മയിൽ നിന്നും ഞാൻ നിന്നോട് രക്ഷ തേടുന്നു. ഇത് ഏതൊരു തിന്മക്ക് വേണ്ടി നിർമിക്കപ്പെട്ടുവോ ആ തിന്മയിൽ നിന്നും ഞാൻ രക്ഷ തേടുന്നു." <span class="c2">(അബൂദാവൂദ്, തിർമിദി)</span> </p>',
            ],
            7 => [
                'question' => '4. പുതുവസ്ത്രം ധരിച്ചയാൾക്കു വേണ്ടിയുള്ള പ്രാർത്ഥന എങ്ങനെയാണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14880.mp3',
                'answer' => '<p> ഉത്തരം: മറ്റൊരാൾ പുതിയ വസ്ത്രം ധരിച്ചതായി കണ്ടാൽ നീ അയാൾക്ക് വേണ്ടി പ്രാർത്ഥിക്കണം.<span class="c6"> ഇപ്രകാരമാണ് അത്:</span> "ഇത് ദ്രവിക്കുകയും അല്ലാഹു പകരം നൽകുകയും ചെയ്യുമാറാകട്ടെ" <span class="c2">(അഥവാ ദ്രവിച്ചുപോകുന്നതുവരെ ദീർഘകാലം ധരിക്കാൻ അല്ലാഹു ആയുസ് നൽകട്ടെ. ശേഷം അല്ലാഹു പകരം വേറെ വസ്ത്രം നൽകട്ടെ.)</span> <span class="c2">(അബൂദാവൂദ്)</span> </p>',
            ],
            8 => [
                'question' => 'ചോദ്യം 9: വിസർജ്ജന സ്ഥലത്തേക്ക് പ്രവേശിക്കുമ്പോൾ ചൊല്ലേണ്ട പ്രാർത്ഥന ഏതാണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14910.mp3',
                'answer' => '<p> ഉത്തരം: അല്ലാഹുവേ! ആൺപിശാചുക്കളിൽ നിന്നും പെൺപിശാചുക്കളിൽ നിന്നും ഞാൻ നിന്നോട് രക്ഷ തേടുന്നു. <span class="c2">(ബുഖാരി, മുസ്ലിം)</span> </p>',
            ],
            9 => [
                'question' => 'ചോദ്യം 10: വിസർജ്ജന സ്ഥലത്ത് നിന്ന് പുറത്തു വരുമ്പോൾ ചൊല്ലേണ്ട പ്രാർത്ഥന എന്താണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14940.mp3',
                'answer' => '<p> ഉത്തരം: "അല്ലാഹുവേ! നിൻ്റെ പൊറുക്കലിനെ ഞാൻ ചോദിക്കുന്നു." <span class="c2">(അബൂദാവൂദ്, തിർമിദി)</span> </p>',
            ],
            10 => [
                'question' => 'ചോദ്യം 11: വുദൂഅ് എടുക്കുന്നതിന് മുൻപ് എന്താണ് ചൊല്ലേണ്ടത്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14970.mp3',
                'answer' => '<p> ഉത്തരം: ബിസ്മില്ലാഹ്. <span class="c2">(അല്ലാഹുവിൻ്റെ നാമത്തിൽ)</span> <span class="c2">(അബൂദാവൂദ്)</span> </p>',
            ],
            11 => [
                'question' => 'ചോദ്യം 12: വുദൂഇനു ശേഷമുള്ള ദിക്ർ എന്താണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15000.mp3',
                'answer' => '<p> ഉത്തരം: "അല്ലാഹുവല്ലാതെ ആരാധനക്ക് അർഹനായി മറ്റാരുമില്ലെന്ന് ഞാൻ സാക്ഷ്യം വഹിക്കുന്നു. അവൻ മാത്രമാണ് ആരാധനക്കർഹൻ. അവന് യാതൊരു പങ്കുകാരനുമില്ല. മുഹമ്മദ് നബി<span class="c2">(ﷺ)</span> അല്ലാഹുവിൻ്റെ അടിമയും അവൻ്റെ ദൂതനുമാണെന്നും ഞാൻ സാക്ഷ്യം വഹിക്കുന്നു." <span class="c2">(മുസ്ലിം)</span> </p>',
            ],
            12 => [
                'question' => 'ചോദ്യം 13: വീട്ടിൽ നിന്ന് പുറത്തിറങ്ങുമ്പോഴുള്ള ദിക്ർ എന്താണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15020.mp3',
                'answer' => '<p> ഉത്തരം: "അല്ലാഹുവിൻ്റെ നാമത്തിൽ, അല്ലാഹുവിൽ ഞാൻ ഭരമേല്പിച്ചിരിക്കുന്നു, അല്ലാഹുവിനെക്കൊണ്ടല്ലാതെ യാതൊരു കഴിവോ ശക്തിയോ ഇല്ല." <span class="c2">(അബൂദാവൂദ്, തിർമിദി)</span> </p>',
            ],
            13 => [
                'question' => 'ചോദ്യം 14: വീട്ടിലേക്ക് പ്രവേശിക്കുമ്പോഴുള്ള ദിക്ർ എന്താണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15050.mp3',
                'answer' => '<p> ഉത്തരം: "അല്ലാഹുവിൻ്റെ നാമത്തിൽ നാം കയറുകയും അല്ലാഹുവിൻ്റെ നാമത്തിൽ നാം പുറത്തിറങ്ങുകയും, നമ്മുടെ റബ്ബായ അല്ലാഹുവിൻ്റെ മേൽ നാം ഭരമേല്പിക്കുകയും ചെയ്തിരിക്കുന്നു. <span class="c2">(ശേഷം വീട്ടുകാരോട് സലാം പറയുക.)</span>" <span class="c2">(അബൂദാവൂദ്)</span> </p>',
            ],
            14 => [
                'question' => 'ചോദ്യം 15: മസ്ജിദിലേക്ക് പ്രവേശിക്കുമ്പോൾ പ്രാർത്ഥിക്കേണ്ടത് എന്താണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15080.mp3',
                'answer' => '<p> ഉത്തരം: "അല്ലാഹുവേ! നിൻ്റെ കാരുണ്യത്തിൻ്റെ കവാടങ്ങൾ നീ എനിക്കായി തുറന്നു തരേണമേ!" <span class="c2">(മുസ്ലിം)</span> </p>',
            ],
            15 => [
                'question' => 'ചോദ്യം 16: മസ്ജിദിൽ നിന്ന് പുറത്തിറങ്ങുമ്പോഴുള്ള പ്രാർത്ഥന എന്താണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15110.mp3',
                'answer' => '<p> ഉത്തരം: "അല്ലാഹുവേ! നിൻ്റെ ഔദാര്യത്തിൽ നിന്ന് ഞാൻ നിന്നോട് തേടുന്നു." <span class="c2">(മുസ്ലിം)</span> </p>',
            ],
            16 => [
                'question' => 'ചോദ്യം 17: ബാങ്ക് വിളി കേൾക്കുമ്പോൾ എന്താണ് ചൊല്ലേണ്ടത്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15140.mp3',
                'answer' => '<p> ഉത്തരം: ബാങ്ക് വിളിക്കുന്ന വ്യക്തി പറയുന്നതു പോലെ പറയണം. \'ഹയ്യ അലസ്സ്വലാഹ്\', \'ഹയ്യ അലൽ ഫലാഹ്\' എന്നിങ്ങനെ പറയുമ്പോൾ \'ലാ ഹൗല വലാ ഖുവ്വത ഇല്ലാ ബില്ലാഹ്\' എന്ന് പറയണം. <span class="c2">(ബുഖാരി, മുസ്ലിം)</span> </p>',
            ],
            17 => [
                'question' => 'ചോദ്യം 18: ബാങ്ക് വിളി കഴിഞ്ഞതിന് ശേഷം എന്താണ് ചൊല്ലേണ്ടത്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15170.mp3',
                'answer' => '<p> ഉത്തരം: നബി -ﷺ- ക്ക് മേൽ സ്വലാത്ത് ചൊല്ലുക. <span class="c2">(മുസ്ലിം)</span> ശേഷം ഇപ്രകാരം പറയുക: "ഈ പരിപൂർണമായ വിളിയുടെയും, നിർവഹിക്കാൻ പോകുന്ന നിസ്കാരത്തിൻ്റെയും റബ്ബായ അല്ലാഹുവേ! മുഹമ്മദ് നബിﷺക്ക് നീ വസീലത് നൽകേണമേ. ശ്രേഷ്ഠതയും നൽകേണമേ. അവിടുത്തേക്ക് വാഗ്ദാനം നൽകിയ മഖാമുൻ മഹ്മൂദിൽ <span class="c2">(സ്തുത്യർഹമായ സ്ഥാനത്ത്)</span> നീ മുഹമ്മദ് നബിﷺയെ നിയോഗിക്കേണമേ!" <span class="c2">(സ്വർഗ്ഗത്തിലെ ഉന്നതമായ ഒരു സ്ഥാനമാണ് \'വസീല\')</span> <span class="c2">(ബുഖാരി)</span><br /> ബാങ്കിനും ഇഖാമത്തിനും ഇടയിൽ പ്രാർത്ഥിക്കാം; ഈ സമയത്തുള്ള പ്രാർത്ഥന തള്ളപ്പെടുന്നതല്ല. </p>',
            ],
            18 => [
                'question' => 'ചോദ്യം 19: രാവിലെയും വൈകുന്നേരവും നീ ചൊല്ലേണ്ട ദിക്റുകൾ ഏതെല്ലാമാണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15220.mp3',
                'answer' => '<p> ഉത്തരം: 1- ആയത്തുൽ കുർസിയ്യ് പാരായണം ചെയ്യുക. "അല്ലാഹു - അവനല്ലാതെ ആരാധനക്കർഹനില്ല. എന്നെന്നും ജീവിച്ചിരിക്കുന്നവൻ. എല്ലാം നിയന്ത്രിക്കുന്നവൻ. മയക്കമോ ഉറക്കമോ അവനെ ബാധിക്കുകയില്ല. അവന്റേതാണ് ആകാശഭൂമികളിലുള്ളതെല്ലാം. അവൻ്റെ അനുവാദപ്രകാരമല്ലാതെ അവൻ്റെയടുക്കൽ ശുപാർശ നടത്താനാരുണ്ട്? അവരുടെ മുമ്പിലുള്ളതും അവർക്ക് പിന്നിലുള്ളതും അവനറിയുന്നു. അവൻ്റെ അറിവിൽ നിന്ന് അവൻ ഇച്ഛിക്കുന്നതല്ലാതെ <span class="c2">(മറ്റൊന്നും)</span> അവർക്ക് സൂക്ഷ്മമായി അറിയാൻ കഴിയില്ല. അവൻ്റെ കുർസിയ്യ് <span class="c2">(പാദപീഠം)</span> ആകാശഭൂമികളെ മുഴുവൻ ഉൾക്കൊള്ളുന്നതാകുന്നു. അവയുടെ സംരക്ഷണം അവന്ന് ഒട്ടും ഭാരമുള്ളതല്ല. അവൻ ഉന്നതനും മഹാനുമത്രെ." <span class="c2">(ബഖറ: 255)</span> 2- ശേഷം സൂറതുൽ ഇഖ്\'ലാസ് പാരായണം ചെയ്യുക. <span class="c2">(നബിയേ,)</span> പറയുക: കാര്യം അല്ലാഹു ഏകനാണ് എന്നതാകുന്നു. അല്ലാഹു സർവ്വരുടെയും ആശ്രയമായ, എന്നാൽ സ്വയം നിരാശ്രയനായ <span class="c2">(സ്വമദ്)</span> ആകുന്നു. അവൻ <span class="c2">(ആർക്കും)</span> ജന്മം നല്കിയിട്ടില്ല. <span class="c2">(ആരുടെയും സന്തതിയായി)</span> ജനിച്ചിട്ടുമില്ല. അവന്ന് തുല്യനായി ആരും ഇല്ലതാനും ഇത് മൂന്നു തവണ പാരായണം ചെയ്യണം.<span class="c6"> പരമകാരുണികനും കരുണാനിധിയുമായ അല്ലാഹുവിൻ്റെ നാമത്തിൽ പറയുക:</span> മനുഷ്യരുടെ രക്ഷിതാവിനോട് ഞാൻ ശരണം തേടുന്നു. അവൻ സൃഷ്ടിച്ചിട്ടുള്ളവയുടെ കെടുതിയിൽ നിന്ന്. ഇരുളടയുമ്പോഴുള്ള രാത്രിയുടെ കെടുതിയിൽ നിന്നും. കെട്ടുകളിൽ ഊതുന്ന സ്ത്രീകളുടെ കെടുതിയിൽ നിന്നും. അസൂയാലു അസൂയപ്പെടുമ്പോൾ അവൻ്റെ കെടുതിയിൽ നിന്നും. ഇത് മൂന്നു തവണ പാരായണം ചെയ്യണം.<span class="c6"> പരമകാരുണികനും കരുണാനിധിയുമായ അല്ലാഹുവിൻ്റെ നാമത്തിൽ പറയുക:</span> മനുഷ്യരുടെ രക്ഷിതാവിനോട് ഞാൻ ശരണം തേടുന്നു. മനുഷ്യരുടെ രാജാവിനോട്. മനുഷ്യരുടെ ആരാധ്യനോട്. ദുർബോധനം നടത്തി പിന്മാറിക്കളയുന്നവരെക്കൊണ്ടുള്ള കെടുതിയിൽ നിന്ന്. മനുഷ്യരുടെ ഹൃദയങ്ങളിൽ ദുർബോധനം നടത്തുന്നവർ. മനുഷ്യരിലും ജിന്നുകളിലും പെട്ടവർ. ഇത് മൂന്നു തവണ പാരായണം ചെയ്യണം. 3- "അല്ലാഹുവേ! നീയാണ് എൻ്റെ റബ്ബ്! നീയല്ലാതെ ആരാധനക്കർഹനായി മറ്റാരുമില്ല. നീയാണ് എന്നെ പടച്ചത്. ഞാൻ നിൻ്റെ അടിമയാണ്. ഞാൻ എനിക്ക് സാധിക്കുന്നത്രയും നിന്നോടുള്ള കരാറിലും വാഗ്ദാനത്തിലുമാണ്. ഞാൻ ചെയ്തുപോയതിൻ്റെ കെടുതികളിൽ നിന്ന് ഞാൻ നിന്നിലഭയം തേടുന്നു. നീയെനിക്ക് നൽകിയ അനുഗ്രഹങ്ങളെല്ലാം നിന്റെ മുന്നിൽ ഞാനിതാ സമ്മതിക്കുന്നു. എൻ്റെ കുറ്റങ്ങളും ഞാനിതാ സമ്മതിക്കുന്നു. അതിനാൽ നീയെനിക്ക് പൊറുത്തുതരേണമേ! നീയല്ലാതെ പാപങ്ങൾ പൊറുക്കാൻ മറ്റാരും തന്നെയില്ല." <span class="c2">(ബുഖാരി)</span> </p>',
            ],
            19 => [
                'question' => 'ചോദ്യം 20: ഉറങ്ങുന്നതിന് മുൻപ് എന്താണ് ചൊല്ലേണ്ടത്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15290.mp3',
                'answer' => '<p> ഉത്തരം: "അല്ലാഹുവേ! നിൻ്റെ നാമത്തിൽ ഞാൻ മരിക്കുകയും ജീവിക്കുകയും ചെയ്യുന്നു." <span class="c2">(ബുഖാരി, മുസ്ലിം)</span> </p>',
            ],
            20 => [
                'question' => 'ചോദ്യം 21: ഭക്ഷണം കഴിക്കുന്നതിന് മുൻപ് എന്താണ് ചൊല്ലേണ്ടത്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15320.mp3',
                'answer' => '<p> ഉത്തരം: ബിസ്മില്ലാഹ്. <span class="c2">(അല്ലാഹുവിൻ്റെ നാമത്തിൽ)</span><br /> <br /> തുടക്കത്തിൽ ബിസ്മി ചൊല്ലാൻ മറന്നാൽ ഇങ്ങനെ പറയുക:<br /> <br /> "ആരംഭത്തിലും അവസാനത്തിലും അല്ലാഹുവിൻ്റെ നാമത്തിൽ." <span class="c2">(അബൂദാവൂദ്, തിർമിദി)</span> </p>',
            ],
            21 => [
                'question' => 'ചോദ്യം 22: ഭക്ഷണം കഴിച്ച ശേഷമുള്ള പ്രാർത്ഥന എന്താണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15370.mp3',
                'answer' => '<p> ഉത്തരം: "എന്നെ ഇത് ഭക്ഷിപ്പിക്കുകയും. എനിക്കിത് എൻ്റെ യാതൊരു കഴിവോ ശക്തിയോ കൂടാതെ നൽകുകയും ചെയ്ത അല്ലാഹുവിനാകുന്നു സർവ സ്തുതിയും..." <span class="c2">(അബൂദാവൂദ്, ഇബ്നു മാജഃ)</span> </p>',
            ],
            22 => [
                'question' => 'ചോദ്യം 23: വിരുന്നുകാരൻ ആതിഥേയന് വേണ്ടി പ്രാർത്ഥിക്കേണ്ടത് എങ്ങനെയാണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15400.mp3',
                'answer' => '<p> ഉത്തരം: "അല്ലാഹുവേ! അവർക്ക് നീ നൽകിയ ഉപജീവനത്തിൽ നീ ബറകത്ത് നൽകേണമേ! അവർക്ക് പൊറുത്തുകൊടുക്കുകയും കരുണ ചൊരിയുകയും ചെയ്യേണമേ!" <span class="c2">(മുസ്ലിം)</span> </p>',
            ],
            23 => [
                'question' => 'ചോദ്യം 24: ഒരാൾ തുമ്മിയാൽ പറയേണ്ടത് എന്താണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15430.mp3',
                'answer' => '<p> ഉത്തരം: "അൽഹംദുലില്ലാഹ്."<br /> <br /> അത് കേൾക്കുന്ന വ്യക്തി \'യർഹമുകല്ലാഹ്\' എന്ന് പറയണം.<br /> <br /> അങ്ങനെ പറഞ്ഞാൽ അവനോട് \'യഹ്ദീകുമുല്ലാഹു വ യുസ്ലിഹു ബാലകും\' എന്ന് പറയണം. <span class="c2">(ബുഖാരി)</span> </p>',
            ],
            24 => [
                'question' => 'ചോദ്യം 25: ഒരു സദസ്സിൽ നിന്ന് എഴുന്നേൽക്കുമ്പോൾ പറയേണ്ട കഫ്ഫാറതുൽ മജ്\'ലിസ് എന്ന പ്രാർത്ഥന എങ്ങനെയാണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15480.mp3',
                'answer' => '<p> ഉത്തരം: "അല്ലാഹുവേ! നിൻ്റെ പരിശുദ്ധിയെ ഞാൻ വാഴ്ത്തുകയും, നിന്നെ ഞാൻ സ്തുതിക്കുകയും ചെയ്യുന്നു. നീയല്ലാതെ ആരാധനക്ക് അർഹനായി മറ്റാരുമില്ലെന്ന് ഞാൻ സാക്ഷ്യം വഹിക്കുന്നു. നിന്നോട് ഞാൻ പാപമോചനം തേടുകയും, നിന്നിലേക്ക് ഞാൻ പശ്ചാത്തപിച്ചു മടങ്ങുകയും ചെയ്യുന്നു." <span class="c2">(അബൂദാവൂദ്, തിർമിദി തുടങ്ങിയവർ)</span> </p>',
            ],
            25 => [
                'question' => 'ചോദ്യം 26: വാഹനത്തിൽ കയറുമ്പോഴുള്ള പ്രാർത്ഥന എങ്ങനെയാണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15510.mp3',
                'answer' => '<p> ഉത്തരം: "ബിസ്മില്ലാഹ്, അൽഹംദുലില്ലാഹ്, ഞങ്ങൾക്ക് വേണ്ടി ഇതിനെ വിധേയമാക്കിത്തന്നവൻ എത്ര പരിശുദ്ധൻ! ഞങ്ങൾക്കതിനെ ഇണക്കുവാൻ കഴിയുമായിരുന്നില്ല.തീർച്ചയായും ഞങ്ങൾ ഞങ്ങളുടെ രക്ഷിതാവിങ്കലേക്ക് തിരിച്ചെത്തുന്നവർ തന്നെയാകുന്നു." അൽഹംദുലില്ലാഹ്, അൽഹംദുലില്ലാഹ്, അൽഹംദുലില്ലാഹ്, അല്ലാഹു അക്ബർ, അല്ലാഹു അക്ബർ, അല്ലാഹു അക്ബർ, അല്ലാഹുവേ! നിന്റെ പരിശുദ്ധിയെ ഞാൻ പ്രകീർത്തിക്കുന്നു. ഞാൻ എന്നോട് തന്നെ അതിക്രമം ചെയ്തിരിക്കുന്നു. അതിനാൽ നീ എനിക്ക് പൊറുത്തു തരേണമേ! തീർച്ചയായും നീയല്ലാതെ തെറ്റുകൾ പൊറുക്കുന്നവനായില്ല." <span class="c2">(അബൂദാവൂദ്, തിർമിദി)</span> </p>',
            ],
            26 => [
                'question' => 'ചോദ്യം 27: യാത്രയിലുള്ള പ്രാർത്ഥന എങ്ങനെയാണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15540.mp3',
                'answer' => '<p> ഉത്തരം: അല്ലാഹു അക്ബർ, അല്ലാഹു അക്ബർ, അല്ലാഹു അക്ബർ, ഞങ്ങൾക്ക് വേണ്ടി ഇതിനെ വിധേയമാക്കിത്തന്നവൻ എത്ര പരിശുദ്ധൻ! ഞങ്ങൾക്കതിനെ ഇണക്കുവാൻ കഴിയുമായിരുന്നില്ല.തീർച്ചയായും ഞങ്ങൾ ഞങ്ങളുടെ രക്ഷിതാവിങ്കലേക്ക് തിരിച്ചെത്തുന്നവർ തന്നെയാകുന്നു. അല്ലാഹുവേ! ഈ യാത്രയിൽ നന്മയും ധർമ്മനിഷ്ഠയും നിനക്ക് തൃപ്തികരമായ പ്രവർത്തനവും ഞങ്ങൾ നിന്നോട് തേടുന്നു. അല്ലാഹുവേ! ഞങ്ങളുടെ യാത്ര ഞങ്ങൾക്ക് ലളിതമാക്കണമേ! അതിൻ്റെ ദൂരം ഞങ്ങൾക്ക് കുറച്ചു തരികയും ചെയ്യേണമേ! അല്ലാഹുവേ! നീയാകുന്നു യാത്രയിലെ ഞങ്ങളുടെ സഹചാരിയും, ഞങ്ങളുടെ ഉറ്റവരിൽ ഞങ്ങൾ വിട്ടേച്ചു പോകുന്നവനും. അല്ലാഹുവേ! യാത്രയുടെ ക്ലേശത്തിൽ നിന്നും, പ്രയാസകരമായ കാഴ്ച്ചയിൽ നിന്നും, സമ്പത്തിലും കുടുംബത്തിലും മോശം പര്യവസാനം ഉണ്ടാകുന്നതിൽ നിന്നും ഞങ്ങൾ നിന്നോട് രക്ഷ ചോദിക്കുന്നു."<br /> <br /> മടക്കയാത്രയിൽ ഇതുതന്നെ ചൊല്ലുകയും ഒപ്പം ഇങ്ങനെയും പറയുകയും ചെയ്യുക.<br /> <br /> "<span class="c2">(ഞങ്ങൾ)</span> മടങ്ങിപ്പോകുന്നവരും, ഖേദിച്ചുമടങ്ങുകയും ഞങ്ങളുടെ റബ്ബിനെ ആരാധിക്കുകയും അവനെ സ്തുതിക്കുകയും ചെയ്യുന്നവരാകുന്നു." <span class="c2">(മുസ്ലിം)</span> </p>',
            ],
            27 => [
                'question' => 'ചോദ്യം 28: യാത്ര പോകുമ്പോൾ നാട്ടിൽ നിൽക്കുന്നവരോട് എന്തു പറയണം?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15590.mp3',
                'answer' => '<p> ഉത്തരം: "നിങ്ങളെ ഞാൻ അല്ലാഹുവിനെ ഏൽപ്പിക്കുന്നു. ഏതൊരുവനെ ഏൽപിക്കുന്ന കാര്യങ്ങൾ പാഴായിപ്പോവുകയില്ലയോ ആ അല്ലാഹുവിനെ." <span class="c2">(തിർമിദി, ഇബ്നു മാജഃ)</span> </p>',
            ],
            28 => [
                'question' => 'ചോദ്യം 29: യാത്ര പോകുന്നവനെ യാത്രയയക്കുമ്പോൾ പറയേണ്ടത് എന്താണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15620.mp3',
                'answer' => '<p> ഉത്തരം: "താങ്കളുടെ ദീനും, വിശ്വാസ്യതയും, പ്രവർത്തനങ്ങളുടെയെല്ലാം പരിണിതിയും ഞാൻ അല്ലാഹുവിനെ ഏൽപിക്കുന്നു." <span class="c2">(അഹ്മദ്, തിർമിദി)</span> </p>',
            ],
            29 => [
                'question' => 'ചോദ്യം 30: അങ്ങാടിയിലേക്ക് പ്രവേശിക്കുമ്പോൾ പ്രാർത്ഥിക്കേണ്ടത് എന്താണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15650.mp3',
                'answer' => '<p> ഉത്തരം: "അല്ലാഹുവല്ലാതെ ആരാധനക്കർഹനായി മറ്റാരുമില്ല. അവൻ ഏകനാണ്. അവന് യാതൊരു പങ്കുകാരുമില്ല. അവനാണ് എല്ലാ ആധിപത്യവും. അവന്നാണ് എല്ലാ സ്തുതിയും. അവൻ ജീവിപ്പിക്കുകയും മരിപ്പിക്കുകയും ചെയ്യുന്നു. അവൻ എന്നെന്നും ജീവിച്ചിരിക്കുന്നവനും മരിക്കാത്തവനുമാകുന്നു. അവൻ്റെ കൈയിലാകുന്നു നന്മ. അവൻ എല്ലാ കാര്യത്തിനും കഴിവുള്ളവനാകുന്നു." <span class="c2">(തിർമിദി, ഇബ്നു മാജഃ)</span> </p>',
            ],
            30 => [
                'question' => 'ചോദ്യം 31: ദേഷ്യം പിടിക്കുമ്പോഴുള്ള പ്രാർത്ഥന എന്താണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15680.mp3',
                'answer' => '<p> ഉത്തരം: ആട്ടിയോടിക്കപ്പെട്ട പിശാചിൽ നിന്നും അല്ലാഹുവിനോട് ഞാൻ ശരണം തേടുന്നു. <span class="c2">(ബുഖാരി, മുസ്ലിം)</span> </p>',
            ],
            31 => [
                'question' => 'ചോദ്യം 32: ഉപകാരം ചെയ്തുതന്നവർക്കുവേണ്ടിയുള്ള ദുആ എങ്ങനെയാണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15710.mp3',
                'answer' => '<p> ഉത്തരം: അല്ലാഹു താങ്കൾക്ക് നന്മ പ്രതിഫലം നൽകട്ടെ. <span class="c2">(തിർമിദി)</span> </p>',
            ],
            32 => [
                'question' => 'ചോദ്യം 33: ഒരാളുടെ വാഹനം തകരാറിലായാൽ എന്തു പറയണം?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15740.mp3',
                'answer' => '<p> ഉത്തരം: ബിസ്മില്ലാഹ്. <span class="c2">(അല്ലാഹുവിൻ്റെ നാമത്തിൽ)</span> <span class="c2">(അബൂദാവൂദ്)</span> </p>',
            ],
            33 => [
                'question' => 'ചോദ്യം 34: നിനക്ക് സന്തോഷകരമായ ഒരു കാര്യം സംഭവിച്ചാൽ എന്തു പറയണം?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15770.mp3',
                'answer' => '<p> ഉത്തരം: അല്ലാഹുവിനാകുന്നു സർവ്വസ്തുതിയും. അവൻ്റെ അനുഗ്രഹം കൊണ്ടാകുന്നു സൽക്കർമങ്ങൾ പൂർണ്ണമാവുന്നത്. <span class="c2">(ഹാകിം)</span> </p>',
            ],
            34 => [
                'question' => 'ചോദ്യം 35: നിനക്ക് വെറുപ്പുള്ള എന്തെങ്കിലും സംഭവിച്ചാൽ എന്തു ചെയ്യണം?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15800.mp3',
                'answer' => '<p> ഉത്തരം: എല്ലാ അവസ്ഥകളിലും സ്തുതികൾ മുഴുവനും അല്ലാഹുവിനാകുന്നു <span class="c2">(സ്വഹീഹുൽ ജാമിഅ്)</span> </p>',
            ],
            35 => [
                'question' => 'ചോദ്യം 36: സലാം പറയുകയും മടക്കുകയും ചെയ്യേണ്ട രൂപം എങ്ങനെയാണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15830.mp3',
                'answer' => '<p> ഉത്തരം: ഓരോ മുസ്ലിമും മറ്റൊരു മുസ്ലിമിനെ കണ്ടുമുട്ടിയാൽ ഇപ്രകാരം പറയണം: "അസ്സലാമു അലൈകും വറഹ്മതുല്ലാഹി വ ബറകാതുഹ്.<span class="c6">"<br /> <br /> അപ്പോൾ ഇത് കേട്ട വ്യക്തി പറയണം:</span> "വ അലൈകുമുസ്സലാം വ റഹ്മതുല്ലാഹി വ ബറകാതുഹ്." <span class="c2">(തിർമിദി, അബൂദാവൂദ്)</span> </p>',
            ],
            36 => [
                'question' => 'ചോദ്യം 37: മഴ പെയ്യുമ്പോൾ പ്രാർത്ഥിക്കേണ്ടത് എന്താണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15870.mp3',
                'answer' => '<p> ഉത്തരം: അല്ലാഹുവേ! ഉപകാരപ്രദമായ മഴ നൽകേണമേ! <span class="c2">(ബുഖാരി)</span> </p>',
            ],
            37 => [
                'question' => 'ചോദ്യം 38: മഴ പെയ്തു കഴിഞ്ഞാൽ പ്രാർത്ഥിക്കേണ്ടത് എന്താണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15900.mp3',
                'answer' => '<p> ഉത്തരം: അല്ലാഹുവിൻ്റെ ഔദാര്യവും കാരുണ്യവും കൊണ്ട് നമുക്ക് മഴ ലഭിച്ചു. <span class="c2">(ബുഖാരി, മുസ്ലിം)</span> </p>',
            ],
            38 => [
                'question' => 'ചോദ്യം 39: കാറ്റു വീശുമ്പോൾ പ്രാർത്ഥിക്കേണ്ടത് എന്താണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15930.mp3',
                'answer' => '<p> ഉത്തരം: "അല്ലാഹുവേ! നിന്നോട് ഞാൻ ഇതിൻ്റെ നന്മയെ ചോദിക്കുന്നു. ഇതിൻ്റെ കെടുതികളിൽ നിന്ന് ഞാൻ നിന്നിലഭയം തേടുകയും ചെയ്യുന്നു." <span class="c2">(അബൂദാവൂദ്, ഇബ്നു മാജഃ)</span> </p>',
            ],
            39 => [
                'question' => 'ചോദ്യം 40: ഇടിവെട്ടുന്നത് കേട്ടാൽ എന്താണ് പ്രാർത്ഥിക്കേണ്ടത്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15960.mp3',
                'answer' => '<p> ഉത്തരം: "ഇടിനാദം അവനെ <span class="c2">(അല്ലാഹുവിനെ)</span> സ്തുതിക്കുന്നതോടൊപ്പം അവൻ്റെ പരിശുദ്ധിയെ പ്രകീർത്തിക്കുന്നു. അവനെ ഭയപ്പെട്ടുകൊണ്ട് മലക്കുകളും. അങ്ങനെയുള്ളവൻ എത്ര പരിശുദ്ധൻ!" <span class="c2">(മുവത്വ / ഇമാം മാലിക്)</span> </p>',
            ],
            40 => [
                'question' => 'ചോദ്യം 41: പ്രയാസത്തിൽ അകപ്പെട്ട ഒരാളെ കണ്ടാൽ എന്തു പ്രാർത്ഥിക്കണം?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15990.mp3',
                'answer' => '<p> ഉത്തരം: "അല്ലാഹുവിനാകുന്നു സർവസ്തുതിയും! നിന്നെ പരീക്ഷിച്ച കാര്യത്തിൽ നിന്ന് എനിക്ക് സൗഖ്യമേകുകയും, അവൻ സൃഷ്ടിച്ച ധാരാളം സൃഷ്ടികൾക്കുമേൽ എനിക്ക് ശ്രേഷ്ഠത നൽകുകയും ചെയ്ത അല്ലാഹുവിന്!" <span class="c2">(തിർമിദി)</span> </p>',
            ],
            41 => [
                'question' => 'ചോദ്യം 42: തൻ്റെ കണ്ണേറ് ആർക്കെങ്കിലും ബാധിക്കുമെന്ന് ഭയപ്പെട്ടാൽ എന്തു പ്രാർത്ഥിക്കണം?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16020.mp3',
                'answer' => '<p> ഉത്തരം: നബി -ﷺ-<span class="c6"> പറഞ്ഞിട്ടുണ്ട്:</span> "നിങ്ങളിലാരെങ്കിലും തൻ്റെ സഹോദരനിലോ അവൻ്റെ ശരീരത്തിലോ സമ്പത്തിലോ ആശ്ചര്യപ്പെടുത്തുന്ന വല്ല കാര്യവും കണ്ടാൽ അവന് ബറകത് ലഭിക്കാനായി പ്രാർത്ഥിക്കുക. കാരണം കണ്ണേറ് സത്യമാണ്." <span class="c2">(അഹ്മദ്, ഇബ്നു മാജഃ)</span> </p>',
            ],
            42 => [
                'question' => 'ചോദ്യം 43: എങ്ങനെയാണ് നബി -ﷺ- ക്ക് മേൽ സ്വലാത്ത് ചൊല്ലേണ്ടത്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16050.mp3',
                'answer' => '<p> ഉത്തരം: അല്ലാഹുവേ! ഇബ്രാഹീം നബിയുടെ മേലും അവിടുത്തെ അനുയായികൾക്ക് മേലും നീ സ്വലാത്ത് വർഷിച്ചതു പോലെ, മുഹമ്മദ് നബിയുടെ മേലും അവിടുത്തെ അനുയായികൾക്ക് മേലും നീ സ്വലാത്ത് വർഷിക്കേണമേ! തീർച്ചയായും നീ അങ്ങേയറ്റം സ്തുത്യർഹനും, ഏറ്റവും മഹത്വമുള്ളവനുമാകുന്നു. അല്ലാഹുവേ! ഇബ്രാഹീം നബിയുടെ മേലും അവിടുത്തെ അനുയായികൾക്ക് മേലും നീ അനുഗ്രഹം ചൊരിഞ്ഞതു പോലെ, മുഹമ്മദ് നബിയുടെ മേലും അവിടുത്തെ അനുയായികൾക്ക് മേലും നീ അനുഗ്രഹം ചൊരിയേണമേ! തീർച്ചയായും നീ അങ്ങേയറ്റം സ്തുത്യർഹനും, ഏറ്റവും മഹത്വമുള്ളവനുമാകുന്നു. <span class="c2">(ബുഖാരി, മുസ്ലിം)</span> </p>',
            ],
        ],
        9 => [
            0 => [
                'question' => 'ചോദ്യം 1: ഏതെല്ലാമാണ് ഇസ്ലാമിലെ അഞ്ച് വിധിവിലക്കുകൾ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16090.mp3',
                'answer' => '<p> ഉത്തരം:<br /> <br /> 1- വാജിബ് <span class="c2">(നിർബന്ധം)</span><br /> <br /> 2- മുസ്തഹബ്ബ് <span class="c2">(ഐഛികം)</span><br /> <br /> 3- ഹറാം <span class="c2">(നിഷിദ്ധം)</span><br /> <br /> 4- മക്റൂഹ് <span class="c2">(വെറുക്കപ്പെട്ടത്)</span><br /> <br /> 5- മുബാഹ് <span class="c2">(അനുവദനീയം)</span> </p>',
            ],
            1 => [
                'question' => 'ചോദ്യം 2: ഈ വിധിവിലക്കുകളുടെ വിശദീകരണം പറയാമോ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16170.mp3',
                'answer' => '<p> ഉത്തരം:<br /> <br /> 1-<span class="c6"> വാജിബ്:</span> അഞ്ചു നേരത്തെ നിസ്കാരവും റമദാൻ മാസത്തിലെ നോമ്പും മാതാപിതാക്കൾക്ക് നന്മ ചെയ്യലും പോലെ നിർബന്ധമായ കാര്യങ്ങൾക്കാണ് വാജിബ് എന്ന് പറയുക.<br /> <br /> - വാജിബുകൾ ചെയ്തവർക്ക് പ്രതിഫലവും, ഉപേക്ഷിച്ചവർക്ക് ശിക്ഷയുമുണ്ട്.<br /> <br /> 2-<span class="c6"> മുസ്തഹബ്ബ്:</span> റവാതിബ് നിസ്കാരങ്ങളും, രാത്രി നിസ്കാരവും, ഭക്ഷണം നൽകലും സലാം ചൊല്ലലും പോലെ ഐഛികമായി പ്രവർത്തിക്കേണ്ട നന്മകളാണ് മുസ്തഹബ്ബുകൾ. സുന്നത്ത്, മൻദൂബ് എന്നിങ്ങനെയും മുസ്തഹബ്ബിന് പേര് പറയാറുണ്ട്.<br /> <br /> - മുസ്തഹബ്ബായ കാര്യം ചെയ്യുന്നവർക്ക് പ്രതിഫലമുണ്ട്; ഉപേക്ഷിക്കുന്നവർ ശിക്ഷാർഹരല്ല.<span class="c6"><br /> <br /> പ്രത്യേകം ശ്രദ്ധിക്കുക:</span><br /> <br /> ഒരു കാര്യം സുന്നത്താണെന്നോ മുസ്തഹബ്ബാണെന്നോ കേൾക്കുമ്പോൾ അത് ചെയ്യാനും, നബി -ﷺ- യുടെ മാതൃക പിൻപറ്റാനും താൽപ്പര്യത്തോടെ മുന്നോട്ടു വരികയാണ് ഓരോ മുസ്ലിമും ചെയ്യേണ്ടത്.<br /> <br /> 2-<span class="c6"> ഹറാം:</span> മദ്യം കുടിക്കുക, മാതാപിതാക്കളെ ധിക്കരിക്കുക, കുടുംബബന്ധം മുറിക്കുക പോലെ നിഷിദ്ധങ്ങളായ പ്രവർത്തികളാണ് ഹറാമുകൾ.<br /> <br /> - ഹറാം ഉപേക്ഷിക്കുന്നതിന് പ്രതിഫലമുണ്ട്. ചെയ്യുന്നതിന് ശിക്ഷയും.<br /> <br /> 4-<span class="c6"> മക്റൂഹ്:</span> ഇടതു കൈ കൊണ്ട് നൽകുകയും വാങ്ങുകയും ചെയ്യുക, നിസ്കാരത്തിൽ വസ്ത്രം മടക്കിവെക്കുക പോലുള്ള കാര്യങ്ങൾ മക്റൂഹുകളാണ്.<br /> <br /> - മക്റൂഹ് ചെയ്യുന്നതിന് ശിക്ഷയില്ല; ഉപേക്ഷിക്കുന്നതിന് പ്രതിഫലമുണ്ട് താനും.<br /> <br /> 5-<span class="c6"> മുബാഹ്:</span> ആപ്പിൾ ഭക്ഷിക്കുക, ചായ കുടിക്കുക പോലെ അനുവദനീയമായ കാര്യങ്ങൾക്ക് മുബാഹ് എന്ന് പറയും. ജാഇസ്, ഹലാൽ എന്നീ പേരുകളും അതിന് പറയാറുണ്ട്.<br /> <br /> - മുബാഹ് ഉപേക്ഷിക്കുന്നതിന് പ്രതിഫലമോ ചെയ്യുന്നതിന് ശിക്ഷയോ ഇല്ല. </p>',
            ],
            2 => [
                'question' => '3- കച്ചവടങ്ങളുടെയും ഇടപാടുകളുടെയും വിധി എന്താണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16320.mp3',
                'answer' => '<p> ഉത്തരം: എല്ലാ കച്ചവടങ്ങളും ഇടപാടുകളും അനുവദനീയമാണ് എന്നതാണ് ഇസ്ലാമിലെ പൊതുവായ വിധി. അല്ലാഹു നിഷിദ്ധമാക്കിയ കാര്യങ്ങൾ അതിൽ നിന്ന് ഒഴിച്ചു നിർത്തണമെന്ന് മാത്രം.<span class="c6"><br /> <br /> അല്ലാഹു പറയുന്നു:</span> "അല്ലാഹു കച്ചവടം അനുവദിക്കുകയും പലിശ നിഷിദ്ധമാക്കുകയും ചെയ്തിരിക്കുന്നു." <span class="c2">(ബഖറ: 275)</span> </p>',
            ],
            3 => [
                'question' => 'ചോദ്യം 4: നിഷിദ്ധമായ ചില കച്ചവടങ്ങളും ഇടപാടുകളും പറയാമോ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16360.mp3',
                'answer' => '<p> ഉത്തരം:<br /> <br /> 1- വഞ്ചന. ഉദാഹരണത്തിന് കച്ചവട മുതലിൻ്റെ ന്യൂനത മറച്ചു വെച്ച് കച്ചവടം ചെയ്യുക എന്നത്.<br /> <br /> അബൂ ഹുറൈറ -رَضِيَ اللَّهُ عَنْهُ-<span class="c6"> നിവേദനം:</span> നബി -ﷺ- ഭക്ഷണം കൂട്ടിയിട്ടു വിൽക്കുന്ന ഒരാൾക്ക് അരികിലൂടെ നടന്നു പോയി. തൻ്റെ കൈ അതിൻ്റെ ഉള്ളിലേക്ക് അവിടുന്ന് പ്രവേശിപ്പിച്ചപ്പോൾ അവിടുത്തെ വിരലുകളിൽ നനവ് തട്ടി.<span class="c6"> അവിടുന്ന് ചോദിച്ചു:</span> "എന്താണിത് കച്ചവടക്കാരാ?!" അയാൾ പറഞ്ഞു: മഴ ബാധിച്ചതാണ് നബിയേ! അവിടുന്ന് പറഞ്ഞു: "എങ്കിൽ നിനക്ക് അത് ഭക്ഷണത്തിൻ്റെ മുകളിൽ -ജനങ്ങൾക്ക് കാണാൻ കഴിയുന്ന വിധത്തിൽ- വെച്ചുകൂടായിരുന്നോ? ആരെങ്കിലും വഞ്ചന കാണിച്ചാൽ അവൻ നമ്മിൽ പെട്ടവനല്ല." <span class="c2">(മുസ്ലിം)</span><br /> 2-<span class="c6"> പലിശ:</span> ഉദാഹരണത്തിന് ഒരാളുടെ പക്കൽ നിന്ന് ഞാൻ ആയിരം കടം വാങ്ങിക്കുകയും പകരം രണ്ടായിരം തിരിച്ചു തരാം എന്ന് പറയുകയും ചെയ്താൽ അത് പലിശയാണ്.<br /> <br /> അധികമായി നൽകിയ ആ പണം പലിശയാണ്.<span class="c6"><br /> <br /> അല്ലാഹു പറയുന്നു:</span> "അല്ലാഹു കച്ചവടം അനുവദിക്കുകയും പലിശ നിഷിദ്ധമാക്കുകയും ചെയ്തിരിക്കുന്നു." <span class="c2">(ബഖറ: 275)</span><br /> 3- അവ്യക്തതയും <span class="c2">(കച്ചവട വസ്തുവിനെ കുറിച്ചുള്ള)</span> അറിവില്ലായ്മയും. ഉദാഹരണത്തിന് ആടിൻ്റെ അകിടിലുള്ള പാൽ കറക്കുന്നതിന് മുൻപ് വിൽക്കുകയോ, വെള്ളത്തിലുള്ള മത്സ്യത്തെ പിടിക്കുന്നതിന് മുൻപ് അതിനെ വിൽക്കുകയോ ചെയ്യുക.<span class="c6"><br /> <br /> ഹദീഥിൽ കാണാം:</span> "നബി -ﷺ- അജ്ഞമായത് വിൽക്കുന്നത് നിരോധിച്ചിരിക്കുന്നു." <span class="c2">(മുസ്ലിം)</span> </p>',
            ],
            4 => [
                'question' => 'ചോദ്യം 5: അല്ലാഹു നിനക്ക് മേൽ ചെയ്ത ചില അനുഗ്രഹങ്ങൾ പറയുക!',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16460.mp3',
                'answer' => '<p> ഉത്തരം: 1- ഇസ്ലാമാകുന്ന അനുഗ്രഹം; അല്ലാഹു എന്നെ കുഫ്ഫാറുകളിൽ പെടുത്തിയില്ല.<br /> <br /> 2- സുന്നത്താകുന്ന അനുഗ്രഹം; അല്ലാഹു എന്നെ ബിദ്അത്തുകാരിൽ ഉൾപ്പെടുത്തിയില്ല.<br /> <br /> 3- ആരോഗ്യവും സൗഖ്യവുമാകുന്ന അനുഗ്രഹം; കേൾക്കാനും കാണാനും നടക്കാനും മറ്റും എനിക്ക് സാധിക്കുന്നു.<br /> <br /> 4- ഭക്ഷണവും വെള്ളവും വസ്ത്രവും അല്ലാഹുവിൻ്റെ അനുഗ്രഹമാണ്.<br /> <br /> അല്ലാഹു നമുക്ക് നൽകിയ അനുഗ്രഹങ്ങൾ അനേകമുണ്ട്; അവ എണ്ണിത്തിട്ടപ്പെടുത്തുക എന്നത് സാധ്യമല്ല.<span class="c6"><br /> <br /> അല്ലാഹു പറയുന്നു:</span> "അല്ലാഹുവിൻ്റെ അനുഗ്രഹം നിങ്ങൾ എണ്ണുകയാണെങ്കിൽ നിങ്ങൾക്കതിൻ്റെ കണക്കെടുക്കാനാവില്ല. തീർച്ചയായും അല്ലാഹു ഏറെ പൊറുക്കുന്നവനും <span class="c2">(ഗഫൂർ)</span> ധാരാളമായി കരുണ ചൊരിയുന്നവനും <span class="c2">(റഹീം)</span> ആകുന്നു." <span class="c2">(നഹ്ൽ: 18)</span> </p>',
            ],
            5 => [
                'question' => 'ചോദ്യം 6: അല്ലാഹു നൽകിയ അനുഗ്രഹങ്ങളുടെ കാര്യത്തിൽ നിൻ്റെ മേലുള്ള ബാധ്യതയെന്താണ്? എങ്ങനെയാണ് നീ അല്ലാഹുവിനോട് ഈ കാര്യങ്ങളിൽ നന്ദി കാണിക്കുക?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16540.mp3',
                'answer' => '<p> ഉത്തരം: അല്ലാഹു നൽകിയ എല്ലാ അനുഗ്രഹങ്ങൾക്കും ഞാൻ നന്ദി കാണിക്കുകയും, അല്ലാഹുവിനെ സ്തുതിക്കുകയും, അവന് മാത്രമാണ് അതിലെല്ലാം ഔദാര്യമുള്ളത് എന്ന് വിശ്വസിക്കുകയും വേണം. ഈ അനുഗ്രഹങ്ങളെല്ലാം അല്ലാഹുവിനെ അനുസരിക്കുന്നതിന് വേണ്ടി മാത്രമേ ഞാൻ ഉപയോഗിക്കാവൂ; അവനെ ധിക്കരിക്കാൻ വേണ്ടി ഇതൊന്നും ഉപയോഗിക്കരുത്. </p>',
            ],
            6 => [
                'question' => 'ചോദ്യം 7: ഏതെല്ലാമാണ് മുസ്ലിംകളുടെ ആഘോഷങ്ങൾ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16570.mp3',
                'answer' => '<p> ഉത്തരം: വലിയ പെരുന്നാളും ചെറിയ പെരുന്നാളും.<br /> <br /> അനസ് -رَضِيَ اللَّهُ عَنْهُ-<span class="c6"> വിൻ്റെ ഹദീഥിൽ പറഞ്ഞതു പോലെ:</span> നബി -ﷺ- മദീനയിൽ എത്തുന്ന കാലഘട്ടത്തിൽ അവിടെയുള്ളവർ ആഘോഷമായി കൊണ്ടാടിയിരുന്ന രണ്ട് പെരുന്നാളുകൾ ഉണ്ടായിരുന്നു. നബി -ﷺ-<span class="c6"> ചോദിച്ചു:</span> "എന്താണ് ഈ രണ്ട് ദിവസങ്ങൾ?!" അവർ പറഞ്ഞു: "ജാഹിലിയ്യഃ കാലഘട്ടത്തിൽ ഞങ്ങൾ ഈ രണ്ട് ദിവസങ്ങളിൽ ആഘോഷിക്കാറുണ്ടായിരുന്നു." അപ്പോൾ നബി -ﷺ-<span class="c6"> പറഞ്ഞു:</span> "തീർച്ചയായും അല്ലാഹു നിങ്ങൾക്ക് ഈ രണ്ട് ആഘോഷങ്ങൾക്ക് പകരം അതിനേക്കാൾ നല്ല രണ്ട് ആഘോഷങ്ങൾ നൽകിയിരിക്കുന്നു. വലിയ പെരുന്നാളും ചെറിയ പെരുന്നാളുമാണവ." <span class="c2">(അബൂദാവൂദ്)</span><br /> ഈ രണ്ട് പെരുന്നാളുകൾക്ക് പുറമെയുള്ളതെല്ലാം അകറ്റി നിർത്തപ്പെടേണ്ട ബിദ്അത്തുകളാണ്. </p>',
            ],
            7 => [
                'question' => 'ചോദ്യം 8: ഏറ്റവും ശ്രേഷ്ഠമായ മാസം ഏതാണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16620.mp3',
                'answer' => '<p> ഉത്തരം: റമദാൻ മാസം. </p>',
            ],
            8 => [
                'question' => 'ചോദ്യം 9: ഏറ്റവും ശ്രേഷ്ഠമായ ദിവസം ഏതാണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16650.mp3',
                'answer' => '<p> ഉത്തരം: വെള്ളിയാഴ്ച്ച. </p>',
            ],
            9 => [
                'question' => 'ചോദ്യം 10: ഒരു വർഷത്തിലെ ഏറ്റവും ശ്രേഷ്ഠമായ ദിവസം ഏതാണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16680.mp3',
                'answer' => '<p> ഉത്തരം: അറഫ ദിനം. </p>',
            ],
            10 => [
                'question' => 'ചോദ്യം 11: ഒരു വർഷത്തിലെ ഏറ്റവും ശ്രേഷ്ഠമായ രാത്രി ഏതാണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16710.mp3',
                'answer' => '<p> ഉത്തരം: ലൈലതുൽ ഖദ്ർ. </p>',
            ],
            11 => [
                'question' => 'ചോദ്യം 12: അന്യസ്ത്രീയെ കാണുമ്പോൾ നീ നിർബന്ധമായും ചെയ്യേണ്ട കാര്യമെന്താണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16740.mp3',
                'answer' => '<p> ഉത്തരം: കണ്ണു താഴ്ത്തണം.<span class="c6"> അല്ലാഹു പറഞ്ഞിരിക്കുന്നു:</span> "<span class="c2">(നബിയേ)</span> നീ സത്യവിശ്വാസികളോട് അവരുടെ ദൃഷ്ടികൾ താഴ്ത്തുവാൻ പറയുക." <span class="c2">(നൂർ: 30)</span> </p>',
            ],
            12 => [
                'question' => 'ചോദ്യം 13: ആരാണ് മനുഷ്യരുടെ ശത്രുക്കൾ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16770.mp3',
                'answer' => '<p> ഉത്തരം: 1- തിന്മക്ക് പ്രേരിപ്പിക്കുന്ന നമ്മുടെ മനസ്സ്. കാരണം മനസ്സ് മന്ത്രിച്ചു നൽകുകയും ആഗ്രഹിപ്പിക്കുകയും ചെയ്യുന്ന കാര്യങ്ങളാണ് അല്ലാഹുവിനെ ധിക്കരിക്കുമ്പോൾ മനുഷ്യർ പിൻപറ്റുന്നത്.<span class="c6"> അല്ലാഹു പറഞ്ഞതു പോലെ:</span> "തീർച്ചയായും മനസ്സ് ദുഷ്പ്രവൃത്തിക്ക് പ്രേരിപ്പിക്കുന്നത് തന്നെയാകുന്നു. എൻ്റെ രക്ഷിതാവിൻ്റെ കരുണ ലഭിച്ച മനസ്സൊഴികെ. തീർച്ചയായും എൻ്റെ രക്ഷിതാവ് ഏറെ പൊറുക്കുന്നവനും കരുണാനിധിയുമാകുന്നു." <span class="c2">(യൂസുഫ്: 53)</span> 2- പിശാച് <span class="c2">(ശയ്ത്വാൻ)</span>: ആദം സന്തതികളുടെ വ്യക്തമായ ശത്രുവാണ് പിശാച്. മനുഷ്യരെ വഴിപിഴവിലാക്കുകയും, തിന്മകൾ ചെയ്യാൻ അവൻ്റെ മനസ്സിൽ പ്രേരണ ചെലുത്തുകയും, അതിലൂടെ അവനെ നരകത്തിൽ പ്രവേശിപ്പിക്കുകയും ചെയ്യുക എന്നതാണ് അവൻ്റെ പ്രഖ്യാപിത ലക്ഷ്യം.<span class="c6"> അല്ലാഹു പറയുന്നു:</span> "നിങ്ങൾ പിശാചിൻ്റെ കാൽപ്പാടുകളെ പിൻപറ്റരുത്. തീർച്ചയായും അവൻ നിങ്ങൾക്ക് വ്യക്തമായ ശത്രുവാകുന്നു." <span class="c2">(ബഖറ: 168)</span> 3- തിന്മ ചെയ്യാൻ പ്രേരിപ്പിക്കുന്ന, നന്മയിൽ നിന്ന് തടയുന്ന മോശം കൂട്ടുകാർ.<span class="c6"> അല്ലാഹു പറയുന്നു:</span> "സുഹൃത്തുക്കൾ ആ ദിവസം അന്യോന്യം ശത്രുക്കളായിരിക്കും. സൂക്ഷ്മത പാലിക്കുന്നവരൊഴികെ." <span class="c2">(സുഖ്റുഫ്: 67)</span> </p>',
            ],
            13 => [
                'question' => 'ചോദ്യം 14: എന്താണ് തൗബ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16820.mp3',
                'answer' => '<p> ഉത്തരം: തിന്മകൾ ഉപേക്ഷിച്ചു കൊണ്ട് അല്ലാഹുവിലേക്ക് മടങ്ങുകയും, നന്മകളിലേക്ക് മുന്നേറുകയും ചെയ്യലാണ് തൗബ <span class="c2">(പശ്ചാത്താപം)</span>.<span class="c6"> അല്ലാഹു പറയുന്നു:</span> "പശ്ചാത്തപിക്കുകയും, വിശ്വസിക്കുകയും, സൽകർമ്മം പ്രവർത്തിക്കുകയും, പിന്നെ നേർമാർഗത്തിൽ നിലകൊള്ളുകയും ചെയ്തവർക്ക് തീർച്ചയായും ഞാൻ ഏറെ പൊറുത്തുകൊടുക്കുന്നവനത്രെ." <span class="c2">(ത്വാഹാ: 82)</span> </p>',
            ],
            14 => [
                'question' => 'ചോദ്യം 15: തൗബ ശരിയായി നിർവ്വഹിക്കാനുള്ള നിബന്ധനകൾ ഏതെല്ലാമാണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16850.mp3',
                'answer' => '<p> ഉത്തരം: 1- തിന്മകൾ ഉപേക്ഷിക്കുക.<br /> <br /> 2- സംഭവിച്ചു പോയ തെറ്റുകളിൽ ഖേദമുണ്ടാവുക.<br /> <br /> 3- പ്രസ്തുത തിന്മയിലേക്ക് ഇനിയൊരിക്കലും തിരിച്ചു പോകില്ലെന്ന ഉറച്ച തീരുമാനം ഉണ്ടാവുക.<br /> <br /> 4- മറ്റുള്ളവരുടെ അവകാശങ്ങൾ കവർന്നിട്ടുണ്ടെങ്കിൽ അത് തിരിച്ചേൽപ്പിക്കുക.<span class="c6"><br /> <br /> അല്ലാഹു പറയുന്നു:</span> "വല്ല നീചകൃത്യവും ചെയ്തു പോയാൽ, അല്ലെങ്കിൽ സ്വന്തത്തോട് തന്നെ വല്ല ദ്രോഹവും ചെയ്തു പോയാൽ അല്ലാഹുവെ ഓർക്കുകയും തങ്ങളുടെ പാപങ്ങൾക്ക് മാപ്പുതേടുകയും ചെയ്യുന്നവർക്ക് വേണ്ടി. -പാപങ്ങൾ പൊറുക്കുവാൻ അല്ലാഹുവല്ലാതെ ആരാണുള്ളത്?- ചെയ്തുപോയ <span class="c2">(ദുഷ്)</span> പ്രവൃത്തിയിൽ അറിഞ്ഞുകൊണ്ട് ഉറച്ചു നിൽക്കാത്തവരുമാകുന്നു അവർ." <span class="c2">(ആലു ഇംറാൻ: 135)</span> </p>',
            ],
            15 => [
                'question' => 'ചോദ്യം 16: നബി -ﷺ- യുടെ മേലുള്ള സ്വലാത്ത് എന്നത് കൊണ്ട് ഉദ്ദേശ്യം എന്താണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16920.mp3',
                'answer' => '<p> ഉത്തരം: അല്ലാഹു അവൻ്റെ ഉന്നതരായ മലക്കുകളുടെ സദസ്സിൽ നബി -ﷺ- യെ പുകഴ്ത്തിപ്പറയാൻ വേണ്ടി നീ പ്രാർത്ഥിക്കലാണ് നബി -ﷺ- യുടെ മേലുള്ള സ്വലാത്ത് കൊണ്ട് ഉദ്ദേശ്യം. </p>',
            ],
            16 => [
                'question' => 'ചോദ്യം 17: സുബ്ഹാനല്ലാഹ് എന്ന വാക്കിൻ്റെ അർത്ഥം എന്താണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16950.mp3',
                'answer' => '<p> ഉത്തരം: എല്ലാ ന്യൂനതകളിൽ നിന്നും, കുറവുകളിൽ നിന്നും, മോശമായ വിശേഷണങ്ങളിൽ നിന്നും അല്ലാഹു പരിശുദ്ധനാണെന്ന് വാഴ്ത്തലാണ് സുബ്ഹാനല്ലാഹ് <span class="c2">(തസ്ബീഹ്)</span> എന്നത് കൊണ്ട് ഉദ്ദേശ്യം. </p>',
            ],
            17 => [
                'question' => 'ചോദ്യം 18: അൽഹംദുലില്ലാഹ് എന്നതിൻ്റെ അർത്ഥം എന്താണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16980.mp3',
                'answer' => '<p> ഉത്തരം: അല്ലാഹുവിനെ സ്തുതിക്കലും, എല്ലാ പൂർണ്ണതയുടെ വിശേഷണങ്ങൾ കൊണ്ടും അവനെ വിശേഷിപ്പിക്കലുമാണ് ഹംദ് കൊണ്ട് ഉദ്ദേശ്യം. </p>',
            ],
            18 => [
                'question' => 'ചോദ്യം 19: അല്ലാഹു അക്ബർ എന്നതിൻ്റെ അർത്ഥം എന്താണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/17000.mp3',
                'answer' => '<p> ഉത്തരം: അല്ലാഹു എല്ലാത്തിനേക്കാളും വലിയവനും, എല്ലാത്തിനേക്കാളും മഹത്വവും പ്രതാപവും ഔന്നത്യവും ഉള്ളവനുമാണെന്നാണ് അതിൻ്റെ അർത്ഥം. </p>',
            ],
            19 => [
                'question' => 'ചോദ്യം 20: \'ലാ ഹൗല വലാ ഖുവ്വത ഇല്ലാ ബില്ലാഹ്\' എന്നതിൻ്റെ അർത്ഥം എന്താണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/17030.mp3',
                'answer' => '<p> ഉത്തരം: ഒരു മനുഷ്യന് ഏതൊരവസ്ഥയിൽ നിന്നും മറ്റൊരു അവസ്ഥയിലേക്ക് മാറാനുള്ള ശേഷിയോ, എന്തെങ്കിലുമൊരു ശക്തിയോ അല്ലാഹുവിനെ കൊണ്ടല്ലാതെ ഇല്ല എന്നാണർത്ഥം. </p>',
            ],
            20 => [
                'question' => 'ചോദ്യം 21: അസ്തഗ്ഫിറുല്ലാഹ് എന്ന വാക്കിൻ്റെ അർത്ഥം എന്താണ്?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/17060.mp3',
                'answer' => '<p> ഉത്തരം: തൻ്റെ തിന്മകൾ പൊറുത്തു തരാനും തൻ്റെ ന്യൂനതകൾ മറച്ചു വെക്കാനും അല്ലാഹുവിനോട് പ്രാർത്ഥിക്കലാണ് ഈ വാക്കിൻ്റെ അർത്ഥം. </p>',
            ],
        ],
    ],
];
