<?php
$data = [
    'title' => 'آنچه کودکان مسلمان نمی توانند از آن غافل شوند',
    'description' => 'پروژه ای که شامل رویکردی ساده و آسان به مسائلی است که مسلمان نمی تواند از آن غافل باشد و شامل مسائل اعتقادی، فقهی، سیره، آداب، تفسیر، حدیث، اخلاق و ذکر است.',
    'source' => 'https://kids.islamenc.com/prs/home',
    'author' => 'Yazan Abdul Razzaq Raziq Alghanim',
    'sections' => [
        0 => 'بخش عقیده',
        1 => 'بخش فقه',
        2 => 'بخش سیرت النبی',
        3 => 'بخش تفسیر',
        4 => 'بخش حدیث',
        5 => 'بخش آداب اسلامی',
        6 => 'بخش اخلاق',
        7 => 'بخش دعاها و اذکار',
        8 => 'بخش موارد مختلف',
    ],
    'data' => [
        1 => [
            0 => [
                'question' => 'س 1: پروردگار تو کیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/200.mp3',
                'answer' => '<p> ج- پروردگار من ذاتی است که من و همه جهانیان را به نعمت خود پرورش داده است.<br /> و دلیل بر آن،<span class="c6"> این فرمودۀ الله متعال است:</span> <span class="c4">﴿الْحَمْدُ لِلَّهِ رَبِّ الْعَالَمِينَ 2﴾</span><br /> ستایش الله را است که پروردگار جهانیان است. <span class="c5">[سورة الفاتحة: 2]</span>. </p>',
            ],
            1 => [
                'question' => 'س 2: دین تو چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/240.mp3',
                'answer' => '<p> ج- دین من اسلام است،<span class="c6"> که عبارت است از:</span> تسلیم شدن در برابر الله با توحید، وگردن نهادن در برابر اطاعت او وبی زاری از شرک و اهل آن.<span class="c6"><br /> الله متعال فرموده اند:</span> <span class="c4">﴿إِنَّ الدِّينَ عِنْدَ اللَّهِ الْإِسْلَامُ ...﴾</span><br /> <br /> همانا دین <span class="c2">(پسندیده)</span> نزد الله آیین اسلام است... <span class="c5">[سورة آل عمران: 19]</span>. </p>',
            ],
            2 => [
                'question' => 'س3: پیامبر تو کیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/280.mp3',
                'answer' => '<p> ج- محمد ﷺ .<span class="c6"><br /> الله متعال فرموده اند:</span> <span class="c4">﴿مُّحَمَّدٌ رَّسُولُ ٱللَّهِۚ ...﴾</span><br /> محمد فرستادۀ الله است <span class="c5">[سورة الفتح: 29]</span>. </p>',
            ],
            3 => [
                'question' => 'س4: کلمۀ توحید را ذکر کنید، و معنای آن چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/310.mp3',
                'answer' => '<p> ج - کلمۀ توحید <span class="c3">«لا اله الا الله»</span> می باشد،<span class="c6"> و معنای آن:</span> نیست معبود بر حق جز الله متعال.<span class="c6"><br /> الله متعال فرموده اند:</span> <span class="c4">﴿فَاعْلَمْ أَنَّهُ لَا إِلَهَ إِلَّا اللَّهُ ...﴾</span><br /> باز هم بدان که هیچ معبودی جز الله نیست <span class="c5">[سورة محمد: 19]</span>. </p>',
            ],
            4 => [
                'question' => 'س 5: الله عز و جل کجاست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/350.mp3',
                'answer' => '<p> ج – الله متعال در آسمان بالاى عرش، بالاتر از همه مخلوقات می باشد،<span class="c6"> الله متعال فرموده است:</span> <span class="c4">﴿الرَّحْمَنُ عَلَى الْعَرْشِ اسْتَوَى 5﴾</span><br /> <span class="c2">(الله)</span> رحمان <span class="c2">(است که)</span> بر عرش قرار گرفت. <span class="c5">[سورة طه: 5]</span>.<span class="c6"> و فرموده است:</span> <span class="c4">﴿وَهُوَ ٱلۡقَاهِرُ فَوۡقَ عِبَادِهِۦۚ وَهُوَ ٱلۡحَكِيمُ ٱلۡخَبِيرُ 18﴾</span><br /> او است مقتدر و توانا بر بندگان و او درستکار و آگاه است. <span class="c5">[سورة الأنعام: 18]</span>. </p>',
            ],
            5 => [
                'question' => 'س6: منظور از گواهی دادن بر این که محمد رسول الله است چه می باشد؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/380.mp3',
                'answer' => '<p> ج -<span class="c6"> معنی آن :</span> این که الله او را بشارت دهنده و بیم دهنده به سوی جهانیان فرستاد.<span class="c6"><br /> پس لازم است تا:</span><br /> 1- در آنچه امر فرمود از او اطاعت کرد.<br /> 2- تصدیق وی در آنچه خبر داده است.<br /> 3- عدم نافرمانی او.<br /> 4- الله متعال عبادت نشود مگر با آنچه مشروع گردانیده است، و آن پیروی از سنت و ترک بدعت است.<span class="c6"><br /> الله متعال فرموده اند:</span> <span class="c4">﴿مَنْ يُطِعِ الرَّسُولَ فَقَدْ أَطَاعَ اللَّهَ ...﴾</span> <span class="c5">[سورة النساء: 80]</span>، <br /> هر که رسول را اطاعت کند الله را اطاعت کرده است ...،<span class="c6"> <br /> الله متعال فرموده اند:</span> <span class="c4">﴿وَمَا يَنْطِقُ عَنِ الْهَوَى 3 إِنْ هُوَ إِلَّا وَحْيٌ يُوحَى 4﴾</span><br /> و هرگز به هوای نفس سخن نمی‌ گوید، سخن او جز وحی الله نیست. <span class="c5">[سورة النجم: 3، 4]</span>.<span class="c6"> الله متعال فرموده اند:</span> <span class="c4">﴿لَقَدْ كَانَ لَكُمْ فِي رَسُولِ اللَّهِ أُسْوَةٌ حَسَنَةٌ لِمَنْ كَانَ يَرْجُو اللَّهَ وَالْيَوْمَ الْآخِرَ وَذَكَرَ اللَّهَ كَثِيرًا 21﴾</span><br /> البته شما را به رسول الله اقتدای نیکوست، برای آن کس که به الله و روز قیامت امیدوار باشد و یاد الله را بسیار کند. <span class="c5">[سورة الأحزاب: 21]</span>. </p>',
            ],
            6 => [
                'question' => 'س 7: چرا الله متعال ما را آفرید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/480.mp3',
                'answer' => '<p> ج - ما را آفریده است تا او را تنها و بدون شریک بپرستیم.<br /> نه برای لهو و بازی.<span class="c6"><br /> الله متعال فرموده اند:</span> <span class="c4">﴿وَمَا خَلَقْتُ الْجِنَّ وَالْإِنْسَ إِلَّا لِيَعْبُدُونِ 56﴾</span><br /> و من جنّ و انس را نیافریدم مگر برای اینکه مرا <span class="c2">(به یکتایی)</span> پرستش کنند. <span class="c5">[سورة الذاريات: 56]</span>. </p>',
            ],
            7 => [
                'question' => 'س 8: عبادت چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/530.mp3',
                'answer' => '<p> ج- اسم جامع همۀ آنچه الله دوست دارد و از آن راضی باشد اعم از گفتار و کردار باطنی و ظاهری.<span class="c6"><br /> ظاهری:</span> مانند ذکر الله با زبان از قبیل تسبیح، تحمید و تکبیر، و نماز و حج.<span class="c6"><br /> باطنی:</span> مانند توکل و خوف و امید. </p>',
            ],
            8 => [
                'question' => 'س 9: بزرگترین وظیفۀ ما چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/580.mp3',
                'answer' => '<p> ج- بزرگترین وظیفۀ ما یگانه پنداشتن الله متعال است. </p>',
            ],
            9 => [
                'question' => 'س10: انواع توحید کدام ها اند؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/610.mp3',
                'answer' => '<p> ج-1-<span class="c6"> توحید ربوبیت:</span> عبارت است از اعتقاد به اینکه الله خالق و روزی دهنده و مالک و مدبر تنها و بی شریک است.<br /> 2-<span class="c6"> توحید الوهیت:</span> و آن یگانه پنداشتن الله متعال در عبادت است، پس جز الله متعال کسی دیگر عبادت نشود.<br /> 3-<span class="c6"> توحید اسماء و صفات:</span> عبارت است از اعتقاد به اسماء و صفات الله متعال که در قرآن و سنت آمده است، بدون تمثیل و تشبیه و تعطیل.<span class="c6"><br /> و دلیل بر انواع توحید سه گانه:</span> این فرمودۀ الله متعال است: <span class="c4">﴿رَّبُّ ٱلسَّمَـوَ ⁠تِ وَٱلۡأَرۡضِ وَمَا بَيۡنَهُمَا فَٱعۡبُدۡهُ وَٱصۡطَبِرۡ لِعِبَـدَتِهِۦۚ هَلۡ تَعۡلَمُ لَهُۥ سَمِيًّا 65﴾</span><br /> همان الله که آفرینندۀ آسمانها و زمین است و هر چه بین آنهاست، پس وی را پرستش کن و در راه بندگی او صبر و تحمل کن، آیا همنامی برای او میشناسی؟ <span class="c5">[سورة مريم: 65]</span>. </p>',
            ],
            10 => [
                'question' => 'س 11: بزرگترین گناه کدام است؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/670.mp3',
                'answer' => '<p> ج - شرک ورزیدن با الله متعال.<span class="c6"><br /> الله متعال فرموده اند:</span> <span class="c4">﴿إِنَّ اللَّهَ لَا يَغْفِرُ أَنْ يُشْرَكَ بِهِ وَيَغْفِرُ مَا دُونَ ذَلِكَ لِمَنْ يَشَاءُ وَمَنْ يُشْرِكْ بِاللَّهِ فَقَدِ افْتَرَى إِثْمًا عَظِيمًا 48﴾</span><br /> به تحقیق که الله شرک به وی را نخواهد بخشید و بجز از آن برای هر که خواهد می‌ بخشد، و هر کس به الله شرک آورد به دروغی که بافته گناهی بزرگ مرتکب شده است. <span class="c5">[سورة النساء: 48]</span> </p>',
            ],
            11 => [
                'question' => 'س12: شرک و انواع آن را ذکر کنید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/710.mp3',
                'answer' => '<p> ج-<span class="c6"> شرک:</span> آن گردانیدن هر نوع از انواع عبادت بجز برای الله متعال است.<span class="c6"><br /> انواع آن:</span><br /> شرک اکبر؛<span class="c6"> مانند:</span> فراخواندن غیر الله متعال، و یا سجده برای غیر او ذات پاک، و یا ذبح برای غیر الله عز و جل.<br /> شرک اصغر؛<span class="c6"> مانند:</span> سوگند به غیر الله متعال، و یا تعویذها، و آن را برای منفعت یا دفع ضرر آویزان می شود، و مقدار کمی از ریا، مانند این که نمازگزار وقتی می بیند مردم به او نگاه می کنند، نمازش را بهتر می کند. </p>',
            ],
            12 => [
                'question' => 'س 13: آیا جز الله متعال کسی دیگر غیب را می داند؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/770.mp3',
                'answer' => '<p> ج – غیب را جز الله متعال کسی دیگر نمی داند.<span class="c6"><br /> الله متعال فرموده اند:</span> <span class="c4">﴿قُل لَّا يَعۡلَمُ مَن فِي ٱلسَّمَـوَ ⁠تِ وَٱلۡأَرۡضِ ٱلۡغَيۡبَ إِلَّا ٱللَّهُۚ وَمَا يَشۡعُرُونَ أَيَّانَ يُبۡعَثُونَ 65﴾</span><br /> بگو که آنانی که در آسمانها و زمین اند غیب را نمی دانند بجز الله و اینان هیچ نمی‌دانند که چه هنگام زنده و برانگیخته خواهند شد. <span class="c5">[سورة النمل: 65]</span>. </p>',
            ],
            13 => [
                'question' => 'س 14: تعداد ارکان ایمان؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/810.mp3',
                'answer' => '<p> ج- 1- ایمان به الله متعال.<br /> 2- و فرشتگان او.<br /> 3- کتاب های او.<br /> 4- فرستادگان او.<br /> 5- و روز آخرت<br /> 6- قضا و قدر، خیر و شر آن.<span class="c6"><br /> و دلیل:</span> حدیث معروف جبرئیل در صحیح مسلم است،<span class="c6"> جبرئیل به پیامبر صلی الله علیه وسلم گفت:</span> پس از ایمان به من بگو،<span class="c6"> فرمود:</span><br /> اینکه به الله و فرشتگانش و کتابها و رسولانش و روز آخرت ایمان بیاوری و به قضا و قدر ایمان داشته باشی. </p>',
            ],
            14 => [
                'question' => 'س 15: ارکان ایمان را توضیح دهید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/900.mp3',
                'answer' => '<p> ج-<span class="c6"> ایمان به الله متعال:</span><br /> § اینکه ایمان داشته باشی که الله تو را آفریده و به تو روزی داده است و او تنها مالک و فرمانروای همه موجودات است.<br /> § او معبود است و معبودی جز او نیست.<br /> § او عظیم و بزرگ و کامل است و همه حمد و ستایش از آن اوست، و برای او نام های نیکو و والاترین صفات است، او همتایی ندارد و چیزی شبیه او نیست، و او منزه است.<span class="c6"><br /> ایمان به فرشتگان:</span><br /> آنها مخلوقاتی هستند که الله ایشان را از نور خلق کرده است تا او را بپرستند و کاملاً تابع فرمان او باشند.<br /> - و از جملۀ آنان جبرئیل علیه السلام است که بر پیامبران وحی نازل می کند.<span class="c6"><br /> ایمان به کتاب ها:</span><br /> آنها کتابهایی هستند که الله بر پیامبرانش نازل کرده است.<span class="c6"><br /> مانند قرآن:</span> بر محمد صلی الله علیه وسلم.<span class="c6"><br /> انجیل:</span> بر عیسی علیه السلام.<span class="c6"><br /> تورات:</span> بر موسی علیه السلام.<span class="c6"><br /> زبور:</span> بر داود علیه السلام.<span class="c6"><br /> صحیفه های ابراهیم و موسی:</span> بر ابراهیم و موسی.<span class="c6"><br /> ایمان به رسولان:</span><br /> و آنها کسانی هستند که الله متعال آنها را به سوی بندگانش فرستاده تا به آنها بیاموزاند و آنها را به نیکی و بهشت بشارت دهد و از بدی و جهنم بیم دهد.<span class="c6"><br /> بهترین آنها:</span> اولو العزم هستند،<span class="c6"> که عبارتند از:</span><br /> نوح عَلَيْهِ السَّلَامُ.<br /> إبراهيم عَلَيْهِ السَّلَامُ.<br /> موسى عَلَيْهِ السَّلَامُ.<br /> عيسى عَلَيْهِ السَّلَامُ.<br /> محمد ﷺ .<span class="c6"><br /> ایمان به روز آخرت:</span><br /> و آن بعد از مرگ در قبر می باشد، و در روز قیامت و روز برانگیخته شدن و حساب که اهل بهشت در خانه‌های خود ساکن شوند و اهل دوزخ در خانه‌های خود خواهند شدند.<br /> ایمان به قضا و قدر؛ خیر و شر آن.<span class="c6"><br /> قدر:</span> عقیده بر این که الله هر آنچه را که در عالم واقع می شود می داند و آن را در لوح محفوظ نوشته و وجود و خلقت آن را اراده کرده است.<span class="c6"><br /> الله متعال فرموده اند:</span> <span class="c4">﴿إِنَّا كُلَّ شَيْءٍ خَلَقۡنَـٰهُ بِقَدَر 49﴾</span> <br /> <span class="c5">[سورة القمر ٤٩]</span>.<br /> ما هر چه آفریدیم به اندازه آفریدیم.<span class="c6"><br /> و آن دارای چهار مرتبه می باشد:</span><br /> اول: علم الله متعال، از جمله علم قبلی او به همه چیز قبل و بعد از رخ دادن آن.<span class="c6"><br /> و دلیل آن قول الله متعال:</span> <span class="c4">﴿إِنَّ اللَّهَ عِنْدَهُ عِلْمُ السَّاعَةِ وَيُنَزِّلُ الْغَيْثَ وَيَعْلَمُ مَا فِي الْأَرْحَامِ وَمَا تَدْرِي نَفْسٌ مَاذَا تَكْسِبُ غَدًا وَمَا تَدْرِي نَفْسٌ بِأَيِّ أَرْضٍ تَمُوتُ إِنَّ اللَّهَ عَلِيمٌ خَبِيرٌ 34﴾</span><br /> همانا علم قیامت نزد الله است و او باران را فرو می آورد و او آنچه که در رحم های آبستن است می‌داند و هیچ کس نمی‌داند که فردا چه خواهد کرد و هیچ کس نمی‌داند که به کدام سرزمین مرگش فرا می‌رسد، که تنها الله دانا و آگاه است. <span class="c5">[سورة لقمان: 34]</span>.<span class="c6"><br /> دوم:</span> الله متعال آن را در لوح محفوظ نوشته است،<br /> همه چیز که اتفاق افتیده و یا اتفاق خواهد افتید در کتابی نزد او نوشته است.<br /> دلیل آن،<span class="c6"> قول الله متعال:</span> <span class="c4">﴿وَعِنْدَهُ مَفَاتِحُ الْغَيْبِ لَا يَعْلَمُهَا إِلَّا هُوَ وَيَعْلَمُ مَا فِي الْبَرِّ وَالْبَحْرِ وَمَا تَسْقُطُ مِنْ وَرَقَةٍ إِلَّا يَعْلَمُهَا وَلَا حَبَّةٍ فِي ظُلُمَاتِ الْأَرْضِ وَلَا رَطْبٍ وَلَا يَابِسٍ إِلَّا فِي كِتَابٍ مُبِينٍ 59﴾</span><br /> و کلیدهای خزائن غیب نزد اوست، کسی جز او بر آن آگاه نیست و نیز آنچه در خشکی و دریاست همه را می‌داند و هیچ برگی از درخت نمی‌افتد مگر آنکه او آگاه است و نه هیچ دانه‌ای در زیر تاریکی‌های زمین و نه هیچ تر و خشکی، جز آنکه در کتابی مبین مسطور است. <span class="c5">[سورة الأنعام: 59]</span>.<span class="c6"><br /> سوم:</span> اینکه همه چیز به خواست الله اتفاق می افتد، هیچ چیز از او و از خلقش جز به خواست او اتفاق نمی افتد.<br /> دلیل آن،<span class="c6"> قول الله متعال:</span> <span class="c4">﴿لِمَنْ شَاءَ مِنْكُمْ أَنْ يَسْتَقِيمَ 28 وَمَا تَشَاءُونَ إِلَّا أَنْ يَشَاءَ اللَّهُ رَبُّ الْعَالَمِينَ 29﴾</span><br /> تا هر که از شما بندگان بخواهد راه راست پیش گیرد. و شما نمی‌خواهید مگر آنچه الله آفرینندۀ عالمیان بخواهد. <span class="c5">[سورة التكوير: 28، 29]</span>.<span class="c6"><br /> چهارم:</span> اعتقاد به اینکه همه موجودات مخلوقات الله هستند، و او نفس و صفات و حرکات آنها و همه چیز که در آنها است را آفریده است.<br /> دلیل آن،<span class="c6"> قول الله متعال:</span> <span class="c4">﴿وَاللَّهُ خَلَقَكُمْ وَمَا تَعْمَلُونَ 96﴾</span><br /> درحالی‌ که الله سبحانه هم خود شما، و هم اعمال‌ تان را آفریده،<span class="c2">( و این بت‌ها یکی از اعمال شما هستند، پس او تعالی سزاوار است که به تنهایی عبادت شود، و دیگران با او شریک قرار داده نشوند)</span> <span class="c5">[سورة الصافات: 96]</span>. </p>',
            ],
            15 => [
                'question' => 'س 16: تعریف قرآن چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1300.mp3',
                'answer' => '<p> ج - آن کلام الله متعال است، و مخلوق نیست.<span class="c6"><br /> الله متعال فرموده اند:</span> <span class="c4">﴿وَإِنْ أَحَدٌ مِنَ الْمُشْرِكِينَ اسْتَجَارَكَ فَأَجِرْهُ حَتَّى يَسْمَعَ كَلَامَ اللَّهِ ...﴾</span><br /> <br /> و اگر یکی از مشرکان به تو پناه آورد <span class="c2">(که از دین آگاه شود)</span> به او پناه ده تا کلام الله را بشنود. <span class="c5">[سورة التوبة: 6]</span>. </p>',
            ],
            16 => [
                'question' => 'س 17: سنت چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1330.mp3',
                'answer' => '<p> ج- سنت عبارت از هر گفتار، فعل، تقریر و صفت خَلقی و یا خُلقی پیامبرﷺ است. </p>',
            ],
            17 => [
                'question' => 'س 18: بدعت چیست؟ آیا قبولش داریم؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1350.mp3',
                'answer' => '<p> ج- تمام آنچه مردم وارد دین کرده اند، که<br /> در زمان پیامبر و یارانش نبوده باشد بدعت است.<br /> * ما آن را نمی پذیریم و رد می کنیم.<span class="c6"><br /> به دلیل این قول پیامبر اکرم صلی الله علیه وسلم که فرمودند:</span> "هر بدعت گمراهی است" ابو داود روایت نموده است.<span class="c6"><br /> مثال آن:</span> زیادت در عبادات، مانند زیادت در وضو با شستن بار چهارم، و مانند جشن میلاد پیامبر اکرم صلی الله علیه وسلم که از پیامبر صلی الله علیه وسلم و یارانش روایت نشده است. </p>',
            ],
            18 => [
                'question' => 'س 19: عقیدۀ پشتیبانی و بی زاری (ولاء و براء) را ذکر کنید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1410.mp3',
                'answer' => '<p> ج- پشتیبانی <span class="c2">(ولاء)</span>: محبت و حمایت مؤمنان است.<span class="c6"><br /> الله متعال فرموده اند:</span> <span class="c4">﴿وَالْمُؤْمِنُونَ وَالْمُؤْمِنَاتُ بَعْضُهُمْ أَوْلِيَاءُ بَعْضٍ ...﴾</span><br /> <br /> و مردان و زنان مؤمن همه یاور و دوستدار یکدیگرند. <span class="c5">[سورة التوبة: 71]</span>.<br /> بی زاری <span class="c2">(براء)</span>: کینه و دشمنی با کافران است.<span class="c6"><br /> الله متعال فرموده اند:</span> <span class="c4">﴿قَدْ كَانَتْ لَكُمْ أُسْوَةٌ حَسَنَةٌ فِي إِبْرَاهِيمَ وَالَّذِينَ مَعَهُ إِذْ قَالُوا لِقَوْمِهِمْ إِنَّا بُرَآءُ مِنْكُمْ وَمِمَّا تَعْبُدُونَ مِنْ دُونِ اللَّهِ كَفَرْنَا بِكُمْ وَبَدَا بَيْنَنَا وَبَيْنَكُمُ الْعَدَاوَةُ وَالْبَغْضَاءُ أَبَدًا حَتَّى تُؤْمِنُوا بِاللَّهِ وَحْدَهُ﴾</span>.<br /> ای مؤمنان- به یقین که برای شما الگویی نیکو در ابراهیم علیه السلام و مؤمنانی که همراهش بودند است،<span class="c6"> آن‌گاه که به قوم کافر خویش گفتند:</span> ما از شما و بت‌هایی که به جای الله عبادت می‌کنید بیزار هستیم، به دینی که شما بر آن هستید کفر ورزیدیم، و دشمنی و نفرت میان ما و شما آشکار شد تا اینکه فقط به الله ایمان آورید، <span class="c5">[سورة الممتحنة: 4]</span>. </p>',
            ],
            19 => [
                'question' => 'س20: آیا الله دینی غیر از اسلام را می پذیرد؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1480.mp3',
                'answer' => '<p> ج - الله جز اسلام را نمی پذیرد.<span class="c6"><br /> الله متعال فرموده اند:</span> <span class="c4">﴿وَمَن یَبتَغِ غَیرَ ٱلإِسلَـٰمِ دِینا فَلَن یُقبَلَ مِنهُ وَهُوَ فِی ٱلـَٔاخِرَةِ مِنَ ٱلخَـٰسِرِینَ 85﴾</span><br /> هر کس غیر از اسلام دینی اختیار کند هرگز از وی پذیرفته نیست، و او در آخرت از زیانکاران است. <span class="c5">[سورة آل عمران ٨٥]</span>. </p>',
            ],
            20 => [
                'question' => 'س 21: کفر در گفتار، عمل و عقیده می باشد، بر آن مثال بدهید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1520.mp3',
                'answer' => '<p> ج – مثال گفتار: دشنام دادن به الله متعال و یا به رسول الله صلی الله علیه وسلم.<span class="c6"><br /> مثال عمل:</span> اهانت به قرآن یا سجده به غیر الله متعال.<span class="c6"><br /> مثال عقیده:</span> اعتقاد به اینکه غیر از الله متعال کسی شایستۀ پرستش وجود دارد و یا خالقی با الله متعال وجود دارد. </p>',
            ],
            21 => [
                'question' => 'س 22: نفاق چیست و انواع آن کدام ها اند؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1570.mp3',
                'answer' => '<p> ج-<br /> 1-<span class="c6"> بزرگ ترین نفاق:</span> کتمان کفر و آشکار ساختن ایمان است.<br /> از اسلام خارج می گرداند و آن کفر بزرگ است.<span class="c6"><br /> الله متعال فرموده اند:</span> <span class="c4">﴿إِنَّ ٱلمُنَـٰفِقِینَ فِی ٱلدَّركِ ٱلأَسفَلِ مِنَ ٱلنَّارِ وَلَن تَجِدَ لَهُم نَصِیرًا 145﴾</span><br /> البته منافقان در پست‌ترین جایگاه جهنم هستند و برای آنان هرگز یاری نخواهی یافت. <span class="c5">[سورة النساء ١٤٥]</span>.<br /> 2-<span class="c6"> نفاق کوچک:</span><br /> مانند: دروغ، عهدشکنی و خیانت در امانت.<br /> از اسلام خارج نمی گرداند، و از جمله گناهانی است که صاحبش مجازات می شود.<br /> -<span class="c6"> رسول الله ﷺ فرموده است:</span> <span class="c3">«نشانۀ منافق سه است: هرگاه سخن بگوید دروغ می گوید، هرگاه وعده بگذارد آن را میشکند، هرگاه امانتی برایش داده شود در آن خیانت می کند»</span>. بخاری و مسلم روایت نمودند. </p>',
            ],
            22 => [
                'question' => 'س 23: خاتم پیامبران و رسولان کیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1680.mp3',
                'answer' => '<p> ج- او محمد ﷺ است.<span class="c6"><br /> الله متعال فرموده اند:</span> <span class="c4">﴿مَّا كَانَ مُحَمَّدٌ أَبَا أَحَد مِّن رِّجَالِكُم وَلَـٰكِن رَّسُولَ ٱللَّهِ وَخَاتَمَ النَّبِيِّينَۗ...﴾</span><br /> محمد صلی اللّه علیه وسلم پدر هیچ یک از مردان شما نیست لیکن او رسول الله و خاتم انبیاست. <span class="c5">[سورة الأحزاب ٤٠]</span>. -<span class="c6"> رسول الله ﷺ فرموده اند:</span> <span class="c3">«من خاتم پیامبران هستم، پس از من پیامبری نیست»</span>. روایت ابوداود و ترمذی و دیگران. </p>',
            ],
            23 => [
                'question' => 'س24: معجزه چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1730.mp3',
                'answer' => '<p> ج ـ معجزه : هر آن چیزی خارق العادۀ است که الله متعال جهت دلالت راستگویی پیامبران خود به آنان داده است،<span class="c6"> مانند:</span><br /> شکافتن ماه برای پیامبر ﷺ.<br /> و شکافتن دریا برای موسی علیه السلام و غرق شدن فرعون و سپاهیانش. </p>',
            ],
            24 => [
                'question' => 'س 25: صحابه چه کسانی هستند؟ و آیا باید آنها را دوست بدارم؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1780.mp3',
                'answer' => '<p> ج-<span class="c6"> صحابی:</span> کسی است که با ایمان با پیامبر صلی الله علیه وسلم ملاقات کرده و با اسلام از دنیا رفته باشد.<br /> ما آنها را دوست داریم و از آنها پیروی می کنیم و آنها بهترین و افضل ترین مردم بعد از پیامبران هستند.<span class="c6"><br /> و بهترین آنها:</span> خلفای چهارگانه هستند:<br /> ابو بکر رضی الله عنه.<br /> عمر رضی الله عنه.<br /> عثمان رضی الله عنه.<br /> علی رضی الله عنه. </p>',
            ],
            25 => [
                'question' => 'س 26: مادران مؤمنان چه کسانی هستند؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1870.mp3',
                'answer' => '<p> ج - آنان همسران پیامبر صلی الله علیه وسلم هستند.<span class="c6"><br /> الله متعال می فرماید:</span> <span class="c4">﴿ٱلنَّبِيُّ أَوۡلَى بِٱلۡمُؤۡمِنِينَ مِنۡ أَنفُسِهِمۡۖ وَأَزۡوَجُهُۥٓ أُمَّهَتُهُمۡۗ﴾</span><br /> پیامبر اولی و سزاوارتر به مؤمنان است از خود آنها، و زنان او مادران مؤمنان هستند <span class="c5">[سورة الأحزاب: ٦ ]</span>. </p>',
            ],
            26 => [
                'question' => 'س 27: حق آل بیت (خانواده) پیامبر صلی الله علیه وسلم بر ما چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1910.mp3',
                'answer' => '<p> ج - ما آنها را دوست می داریم و از آنها حمایت می کنیم و از کسانی که با آنها دشمنی دارند متنفریم و در مورد آنها افراط و تفریط نمی کنیم، و آنها همسران او و فرزندان او و بنی هاشم و بنی المطلب از مؤمنان هستند. </p>',
            ],
            27 => [
                'question' => 'س 28: مسئولیت ما در قبال حاکمان مسلمانان چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1940.mp3',
                'answer' => '<p> ج-<span class="c6"> مسولیت ما:</span> احترام به آنان، شنیدن و اطاعت از آنان در غیر معصیت، عدم قیام بر ضد آنها، دعا و نصیحت آنان در خفا می باشد. </p>',
            ],
            28 => [
                'question' => 'س 29: سرای مؤمنان چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1970.mp3',
                'answer' => '<p> ج- جنت است،<span class="c6"> الله متعال فرموده اند:</span> <span class="c4">﴿إِنَّ اللَّهَ يُدْخِلُ الَّذِينَ آمَنُوا وَعَمِلُوا الصَّالِحَاتِ جَنَّاتٍ تَجْرِي مِنْ تَحْتِهَا الْأَنْهَارُ ...﴾</span><br /> به‌راستی الله کسانی را که به الله و رسولش ایمان آورده‌اند و اعمال صالح انجام داده‌اند، به بهشت‌هایی که نهرها از زیر کاخ‌ها و درختانش جاری است وارد می‌کند، <span class="c5">[سورة محمد: 12]</span>. </p>',
            ],
            29 => [
                'question' => 'س 30: سرای کافران چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2000.mp3',
                'answer' => '<p> ج- جهنم،<span class="c6"> الله متعال فرموده اند:</span> <span class="c4">﴿فَاتَّقُوا النَّارَ الَّتِي وَقُودُهَا النَّاسُ وَالْحِجَارَةُ أُعِدَّتْ لِلْكَافِرِينَ 24﴾</span><br /> از آتشی بترسید که هیزم آن مردم بدکار و سنگهای خارا است که برای کافران مهیا شده است. <span class="c5">[سورة البقرة: 24]</span>. </p>',
            ],
            30 => [
                'question' => 'س31: ترس چیست؟ و امید چیست؟ و دلیل بر آنها چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2020.mp3',
                'answer' => '<p> ج-<span class="c6"> ترس:</span> ترس از الله و عذاب اوست.<span class="c6"><br /> امید:</span> امید به اجر و مغفرت و رحمت الله متعال است.<span class="c6"><br /> دلیل:</span> فرمودۀ الله متعال است: <span class="c4">﴿أُولَئِكَ الَّذِينَ يَدْعُونَ يَبْتَغُونَ إِلَى رَبِّهِمُ الْوَسِيلَةَ أَيُّهُمْ أَقْرَبُ وَيَرْجُونَ رَحْمَتَهُ وَيَخَافُونَ عَذَابَهُ إِنَّ عَذَابَ رَبِّكَ كَانَ مَحْذُورًا 57﴾</span><br /> و مانند آنها که مشرکان آنها را می‌خوانند اعمال صالحی را که آنها را به الله نزدیک می‌سازند می‌جویند، و مسابقه می‌دهند تا هر یک از آنها با طاعت به او نزدیکتر باشند، و امیدوارند که بر آنها رحم کند، و می‌ترسند از اینکه آنها را عذاب کند، - ای رسول- همانا عذاب پروردگارت سزاوار ترسیدن است <span class="c5">[سورة الإسراء: 57]</span>.<span class="c6"> و الله متعال فرموده اند:</span> <span class="c4">﴿نَبِّئْ عِبَادِي أَنِّي أَنَا الْغَفُورُ الرَّحِيمُ 49 وَأَنَّ عَذَابِي هُوَ الْعَذَابُ الْأَلِيمُ 50﴾</span><br /> <span class="c2">(ای رسول ما)</span> بندگان مرا آگاه ساز که من بسیار آمرزنده و مهربانم. و نیز عذاب من بسیار سخت و دردناک است. <span class="c5">[سورة الحجر: 49، 50]</span> </p>',
            ],
            31 => [
                'question' => 'س 32: برخی از نامها و صفات الله متعال را ذکر کنید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2070.mp3',
                'answer' => '<p> ج- الله، پروردگار، بخشنده، شنوا، بینا، دانا، روزی دهنده، زنده‌ که حیاتی کامل و بدون مرگ و نقص دارد، بزرگ .... و سایر اسماء و صفات عالی دیگر او تعالی. </p>',
            ],
            32 => [
                'question' => 'س33: این نامها را توضیح دهید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2100.mp3',
                'answer' => '<p> ج-<span class="c6"> الله:</span> یعنی معبودی که بر حق پرستش می شود، تنها و بدون شریک است.<span class="c6"><br /> پروردگار:</span> یعنی او تعالی تنها آفریدگار و مالک و روزی دهنده و تدبیر کنندۀ تنهای منزه؛ .<span class="c6"><br /> شنوا:</span> کسی که شنوایی او همه چیز را احاطه می کند، و همه آواز ها را با وجود اختلاف و انواع آن می شنود.<span class="c6"><br /> بینا:</span> آنکه همه چیز را می بیند و همه چیز را چه کوچک باشد یا بزرگ؛ می بیند.<span class="c6"><br /> دانا:</span> اوست که علمش بر همه چیز در گذشته و حال و آینده احاطه دارد.<span class="c6"><br /> بخشنده:</span> که رحمتش هر موجود و زنده را احاطه کرده است، پس همه بندگان و مخلوقات تحت رحمت او هستند.<span class="c6"><br /> روزی دهنده:</span> رزق همه موجودات اعم از انس و جن و همه جانوران بر عهدۀ اوست.<span class="c6"><br /> زنده:</span> زنده ای که نمی میرد در حالی که همه خلق می میرند.<span class="c6"><br /> بزرگ:</span> آن که تمام کمالات برای اوست، و تمام عظمت در اسماء و صفات و افعال اوست. </p>',
            ],
            33 => [
                'question' => 'س 34: وظیفۀ ما در قبال علمای مسلمان چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2210.mp3',
                'answer' => '<p> ج - ما آنها را دوست داریم و در مسائل و مشکلات شرعی به آنها مراجعه می کنیم، ما آنها را جز با خوبی یاد نمی کنیم و کسی که آنها را غیر از آن به بدی یاد می کنند در راه درست نیست.<span class="c6"><br /> الله متعال فرموده اند:</span> <span class="c4">﴿يَرۡفَعِ ٱللَّهُ ٱلَّذِينَ ءَامَنُوا مِنكُمۡ وَٱلَّذِينَ أُوتُوا ٱلۡعِلۡمَ دَرَجَـٰتۚ وَٱللَّهُ بِمَا تَعۡمَلُونَ خَبِير 11﴾</span><br /> الله مقام اهل ایمان و عالمان شما را رفیع گرداند، و الله به هر آنچه کنید آگاه است. <span class="c5">[سورة المجادلة ١١]</span>. </p>',
            ],
            34 => [
                'question' => 'س 35- اولیا (دوستان) الله متعال چه کسانی هستند؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2240.mp3',
                'answer' => '<p> ج- آنها مؤمنان پرهیزکار هستند.<span class="c6"><br /> الله متعال فرموده اند:</span> <span class="c4">﴿أَلَا إِنَّ أَوْلِيَاءَ اللَّهِ لَا خَوْفٌ عَلَيْهِمْ وَلَا هُمْ يَحْزَنُونَ 62 الَّذِينَ آمَنُوا وَكَانُوا يَتَّقُونَ 63﴾</span><br /> آگاه باشید که دوستان الله هرگز هیچ ترسی و هیچ حسرت و اندوهی در دل آنها نیست. آنان اهل ایمان اند و از الله مى ترسند. <span class="c5">[سورة يونس: 62، 63]</span>. </p>',
            ],
            35 => [
                'question' => 'س 36: آیا ایمان، قول و عمل است؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2280.mp3',
                'answer' => '<p> ج ـ ایمان، قول و عمل و اعتقاد است. </p>',
            ],
            36 => [
                'question' => 'س 37: آیا ایمان کم و زیاد می شود؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2310.mp3',
                'answer' => '<p> ج - ایمان با اطاعت زیاد و با نافرمانی کاهش می یابد.<span class="c6"><br /> الله متعال فرموده اند:</span> <span class="c4">﴿إِنَّمَا الْمُؤْمِنُونَ الَّذِينَ إِذَا ذُكِرَ اللَّهُ وَجِلَتْ قُلُوبُهُمْ وَإِذَا تُلِيَتْ عَلَيْهِمْ آيَاتُهُ زَادَتْهُمْ إِيمَانًا وَعَلَى رَبِّهِمْ يَتَوَكَّلُونَ 2﴾</span><br /> همانا مؤمنان واقعی کسانی هستند که وقتی الله یاد شود دل‌های‌شان بترسد؛ آن‌گاه دل‌ها و بدن‌های‌شان به انجام طاعت جهت‌دهی می‌شود، و هرگاه آیات الله بر آنها خوانده شود در آن می‌اندیشند، آن‌گاه ایمانی بر ایمان‌شان افزوده می‌شود، و برای جلب مصالح و دفع مفاسد شان فقط به پروردگارشان اعتماد می‌کنند. <span class="c5">[سورة الأنفال: 2]</span>. </p>',
            ],
            37 => [
                'question' => 'س 38: احسان چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2350.mp3',
                'answer' => '<p> ج- الله را چنان عبادت کن که گویا او را می بینی و اگر او را نمی بینی، او تو را می بیند. </p>',
            ],
            38 => [
                'question' => 'س 39: چه زمانی اعمال مورد قبول الله متعال قرار می گیرد؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2370.mp3',
                'answer' => '<p> ج-<span class="c6"> به دو شرط:</span><br /> 1- اگر صرفاً برای رضای الله متعال باشد.<br /> 2- اگر طبق سنت رسول الله ﷺ باشد. </p>',
            ],
            39 => [
                'question' => 'س40: توکل بر الله متعال چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2420.mp3',
                'answer' => '<p> ج - توکل بر الله متعال برای جلب منفعت و دفع ضرر البته با گرفتن اسباب .<span class="c6"><br /> الله متعال فرموده اند:</span> <span class="c4">﴿وَمَنْ يَتَوَكَّلْ عَلَى اللَّهِ فَهُوَ حَسْبُهُ ...﴾</span><br /> و هر که بر الله توکل کند الله او را کافیست <span class="c5">[سورة الطلاق: 3]</span>.<br /> <span class="c4">﴿حَسْبُهُ﴾</span>: یعنی او را کافیست. </p>',
            ],
            40 => [
                'question' => 'س 41: واجب امر به معروف و نهی از منکر چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2470.mp3',
                'answer' => '<p> ج ـ معروف: امر به هر اطاعت و پیروی از الله متعال است و منکر: نهی از هر گونه نافرمانی از الله متعال می باشد.<span class="c6"><br /> الله متعال فرموده اند:</span> <span class="c4">﴿كُنتُمۡ خَيۡرَ أُمَّةٍ أُخۡرِجَتۡ لِلنَّاسِ تَأۡمُرُونَ بِٱلۡمَعۡرُوفِ وَتَنۡهَوۡنَ عَنِ ٱلۡمُنكَرِ وَتُؤۡمِنُونَ بِٱللَّهِۗ ...﴾</span><br /> شما نیکوترین امتی هستید که پدیدار گشته‌اید، به نیکوکاری امر می‌کنید و از بدکاری باز می‌دارید، و ایمان به الله دارید. <span class="c5">[سورة آل عمران ١١٠]</span>. </p>',
            ],
            41 => [
                'question' => 'س 42: اهل سنت و جماعت چه کسانی هستند؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2510.mp3',
                'answer' => '<p> ج - آنها کسانی هستند بر چیزی که پیامبر صلی الله علیه وسلم و یارانش در گفتار و عمل و اعتقاد بودند آنها هم می باشند.<span class="c6"><br /> اهل سنت نامیده شدند:</span> زیرا از سنت پیامبر صلی الله علیه وسلم پیروی نموده و بدعت را ترک نمودند.<span class="c6"><br /> و جماعت:</span> چون بر حق متحد شدند و در آن تفرقه نکردند. </p>',
            ],
        ],
        2 => [
            0 => [
                'question' => 'س1: طهارت را تعریف کن؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2580.mp3',
                'answer' => '<p> ج-<span class="c6"> طهارت:</span> دور نمودن ناپاکی و زوال نجاست است.<span class="c6"><br /> پاکی نجاست:</span> بر مسلمان لازم است هر نجاستی را که بر بدن، لباس، یا در جای و محل نمازش افتاده است برطرف کند.<span class="c6"><br /> طهارت بی وضویی:</span> با وضو یا غسل با آب پاک یا تیمم برای کسى که آب در اختیار نداشته باشد و یا نتواند از آن استفاده کند، انجام مى گیرد. </p>',
            ],
            1 => [
                'question' => 'س 2: چگونه آنچه را که نجس شده است پاک می کنید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2630.mp3',
                'answer' => '<p> ج- با شستن با آب تا پاک شود.<br /> - در مورد آنچه سگ لیسیده است؛ هفت مرتبه باید شسته شود، بار اول باید با خاک شسته شود. </p>',
            ],
            2 => [
                'question' => 'س 3: فضیلت وضو چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2660.mp3',
                'answer' => '<p> ج-<span class="c6"> پیامبر اکرم صلی الله علیه وسلم فرمودند:</span> هرگاه بندۀ مسلمان - یا مؤمن - وضو بگیرد، باید روی خود را بشوید؛ هر گناهی را که با نگاه کردن با چشم نموده است با آب از رویش بیرون می شود» - یا <span class="c3">«با آخرین قطره آب»</span> - <span class="c3">«اگر دستش را بشوید، هر گناهی که دستانش انجام داده اند، بیرون می شود»</span> - یا <span class="c3">«با آخرین قطره آب»</span> - «وقتی پاهایش را بشوید هر گناهی که پاهایش به سمت آن رفته باشد بیرون می شود- یا با آخرین قطره آب - تا این که از گناهان پاک بیرون آید. مسلم روايت نموده است. </p>',
            ],
            3 => [
                'question' => 'س4: چگونه وضو می گیرید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2690.mp3',
                'answer' => '<p> ج- سه بار شستن دست ها <span class="c2">(تا بندها)</span>.<br /> سه بار شستن دهن <span class="c2">(مضمضه)</span>، کشیدن آب به بینی <span class="c2">(استنشاق)</span> و خارج ساختن آب از بینی به فشار <span class="c2">(استنثار)</span> را انجام می دهید.<span class="c6"><br /> شستن دهن:</span> آب را در دهن گذاشته و آن را حرکت می دهی سپس بیرون می اندازی.<br /> و کشیدن آب به بینی <span class="c2">(استنشاق)</span>: کشیدن آب با هوا به داخل بینی با دست راست.<br /> و خارج ساختن آب از بینی با فشار <span class="c2">(استنثار)</span>: بیرون کردن آب از بینی پس از استنشاق با دست چپ.<br /> سپس شستن رو سه بار.<br /> سپس شستن دست ها تا آرنج سه بار.<br /> سپس مسح سر به سمت جلو و عقب و مسح دو گوش.<br /> سپس شستن پاها تا مچ پا سه بار.<br /> این کاملترین وضو است و این از پیامبر صلی الله علیه وسلم در احادیث بخاری و مسلم به روایت عثمان و عبدالله بن زید و دیگران ثابت شده است.<span class="c6"> در بخاری و غیره نیز از او ثابت شده است که:</span> <span class="c3">«رسول الله صلی الله علیه وسلم یک یک بار وضو گرفته است و دو دو بار وضو گرفته است»</span> یعنی: هر یک از اعضای وضو را یک یک و یا دو دو بار شسته است. </p>',
            ],
            4 => [
                'question' => 'س 5: فرض های وضو کدام ها اند و آن را بشمارید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2810.mp3',
                'answer' => '<p> ج – آنها مواردی هستند که وضوی مسلمان با ترک یکی از آن درست نمی شود.<br /> 1- شستن رو از آن جمله مضمضه و استنشاق.<br /> 2- شستن دست ها تا آرنج ها.<br /> 3- مسح سر از آن جمله گوش ها.<br /> 4- شستن پاها تا مچ پاها.<br /> 5- ترتیب بین اعضا، با شستن رو، سپس دست ها، سپس مسح سر و سپس شستن پاها.<br /> 6-<span class="c6"> موالات:</span> وضو گرفتن بشکل پیهم، بدون فاصله زمانی به شکلی که اعضای بدن از آب خشک شوند.<br /> - مانند این که نصف وضو را بگیرد، و نصف دیگر را در وقت دیگری تمام کند، در این صورت وضوی او درست نمی شود. </p>',
            ],
            5 => [
                'question' => 'س6: سنت های وضو کدام ها اند و آن را بشمارید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2910.mp3',
                'answer' => '<p> ج -<span class="c6"> سنت های وضو:</span> که اگر آن را انجام داد؛ اورا ثواب بیشتری است، ولی اگر آن را ترک کرد؛ گناهی بر او نیست و وضوی او درست می باشد.<br /> 1- بسم الله گفتن.<br /> 2- مسواک زدن.<br /> 3- شستن دست ها تا بندها.<br /> 4- خلال انگشتان.<br /> 5- دو و یا سه بار شستن اعضای وضو.<br /> 6- از راست شروع کردن.<br /> 7-<span class="c6"> دعای بعد از وضو:</span> <span class="c3">«أشهد أن لا إله إلا الله، وحده لا شريك له، وأشهد أن محمدًا عبده ورسوله»</span>.<br /> گواهی می‌دهم که معبودی جز الله نیست و او شریکی ندارد و گواهی می‌دهم که محمد بنده و فرستادۀ اوست.<br /> 8- بعد از آن خواندن دو رکعت نماز. </p>',
            ],
            6 => [
                'question' => 'س7: شکننده های وضو را نام ببرید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3020.mp3',
                'answer' => '<p> ج- آنچه از سبیلین فرج و مقعد خارج می شود، از قبیل ادرار، مدفوع یا باد.<br /> به خواب رفتن، یا دیوانه شدن یا بی هوشی.<br /> خوردن گوشت اشتر.<br /> لمس کردن فرج یا مقعد با دست بدون مانع. </p>',
            ],
            7 => [
                'question' => 'س 8: تیمم چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3080.mp3',
                'answer' => '<p> ج-<span class="c6"> تیمم:</span>استفاده از خاک وغیره از سایر نقاط زمین، زمانی که آب موجود نباشد یا قابل استفاده نباشد. </p>',
            ],
            8 => [
                'question' => 'س 9: چگونه تیمم می کنید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3110.mp3',
                'answer' => '<p> ج- یک مرتبه ضربه زدن خاک با کف دست ها، و یک مرتبه مسح صورت و پشت دست ها. </p>',
            ],
            9 => [
                'question' => 'س10: شکننده های تیمم کدامند؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3140.mp3',
                'answer' => '<p> ج ـ هر آن چه وضو را می شکناند.<br /> اگر آب پیدا شود. </p>',
            ],
            10 => [
                'question' => 'س11:ماسی(خفین) و جوراب چیست؟ آیا بالای آنها مسح می شود؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3180.mp3',
                'answer' => '<p> ج – ماسی <span class="c2">(خفین)</span>: چرمی که در پا پوشیده می شود.<span class="c6"><br /> جوراب:</span> آنچه در پا به غیر از پوست پوشیده می شود.<br /> مسح بر آنها عوض شستن پاها مشروع می باشد. </p>',
            ],
            11 => [
                'question' => 'س12- حکمت مسح روی ماسی (خفین) را ذکر کنید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3230.mp3',
                'answer' => '<p> ج - تسهیل و آسانی بر بندگان، به ویژه در زمان سرما و زمستان و مسافرت، که کشیدن آنچه در پاها است مشکل می باشد. </p>',
            ],
            12 => [
                'question' => 'س13- شرایط صحت مسح روی ماسی (خفین) چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3260.mp3',
                'answer' => '<p> ج-1- ماسی <span class="c2">(خفین)</span> را در حالت طهارت یعنی بعد از وضو بپوشد.<br /> 2- ماسی <span class="c2">(خفین)</span> باید پاک باشد، چون مسح روی چیز نجس جایز نیست.<br /> 3- ماسی <span class="c2">(خفین)</span> باید محل فرض شستشو در وضو را بپوشاند.<br /> 4- مسح در مدت معین برای مقیم غیر مسافر یک شبانه روز و برای مسافر سه شبانه روز می باشد. </p>',
            ],
            13 => [
                'question' => 'س 14- صفت مسح روی ماسی (خفین) چه گونه است؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3320.mp3',
                'answer' => '<p> ج ـ و اما وصف مسح این است که: انگشتان دست خود را خیس آب کرده بر انگشتان پا بگذارد، سپس تا ساق پایش بکشاند، با دست راست پای راست و با دست چپ پای چپ را مسح کند، و هنگام مسح انگشتانش را باز نموده و تکرار ننماید. </p>',
            ],
            14 => [
                'question' => 'س15- چه چیز مسح بالای ماسی (خفین) را باطل می کند؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3350.mp3',
                'answer' => '<p> ج-1- گذشتن مدت مسح، پس مسح بر خفین پس از انقضای مدت مسح شرعا جایز نیست، یک شبانه روز برای مقیم و سه شبانه روز برای مسافر.<br /> 2 ـ کشیدن ماسی <span class="c2">(خفین)</span>، هرگاه انسان پس از مسح، خفین یا یکی از آنها را بیرون آورد، مسح باطل می شود. </p>',
            ],
            15 => [
                'question' => 'س 16: معنای نماز؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3390.mp3',
                'answer' => '<p> ج ـ نماز: عبادت الله متعال با اقوال و افعال خاص است که با تکبیر آغاز و با تسلیم به پایان رسید. </p>',
            ],
            16 => [
                'question' => 'س 17: حکم نماز؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3420.mp3',
                'answer' => '<p> ج- نماز بر هر مسلمان فرض است.<span class="c6"><br /> الله متعال فرموده اند:</span> <span class="c4">﴿إِنَّ الصَّلَاةَ كَانَتْ عَلَى الْمُؤْمِنِينَ كِتَابًا مَوْقُوتًا 103﴾</span><br /> نماز بر مؤمنان در اوقات معين مقرر شده است <span class="c5">[سورة النساء: 103]</span>. </p>',
            ],
            17 => [
                'question' => 'س 18: ترک نماز چه حکمی دارد؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3460.mp3',
                'answer' => '<p> ج- ترک نماز کفر است،<span class="c6"> پیامبر صلی الله علیه وسلم فرموده اند:</span> <span class="c3">«پیمان بین ما و آنان نماز است، پس هر که آن را ترک کند، کفر ورزیده است»</span>. روایت احمد و ترمذی و دیگران. </p>',
            ],
            18 => [
                'question' => 'س 19- یک مسلمان در شبانه روز چند وقت نماز را باید ادا نماید؟ و هر نماز چند رکعت است؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3500.mp3',
                'answer' => '<p> ج- پنج وقت نماز در یک شبانه روز فرض است،<span class="c6"> نماز صبح:</span> دو رکعت،<span class="c6"> نماز ظهر:</span> چهار رکعت،<span class="c6"> نماز عصر:</span> چهار رکعت،<span class="c6"> نماز شام:</span> سه رکعت،<span class="c6"> و نماز خفتن:</span> چهار رکعت. </p>',
            ],
            19 => [
                'question' => 'س 20: شرط های نماز چند است؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3530.mp3',
                'answer' => '<p> ج- 1- اسلام؛ از کافر قبول نمی شود.<br /> 2- عقل، پس نماز شخص دیوانه قبول نمی شود.<br /> 3. تمیز و رشد؛ پس نماز کودک غیر رشید قبول نمی شود.<br /> 4- نیت.<br /> 5- داخل شدن وقت.<br /> 6- طهارت برای رفع ناپاکی.<br /> 7- پاکی از نجاست.<br /> 8- پوشانیدن عورت.<br /> 9 - رو به قبله ایستاده شدن. </p>',
            ],
            20 => [
                'question' => 'س 21: ارکان نماز را بشمارید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3640.mp3',
                'answer' => '<p> ج-<span class="c6"> چهارده رکن است به شرح زیر:</span><br /> یکی از آنها: ایستاد شدن در نماز فرض برای کسی که توان آن را دارد.<span class="c6"><br /> تکبیر تحریمه:</span> <span class="c3">«الله اکبر»</span>.<br /> خواندن سورۀ فاتحه.<br /> رکوع، پشت باید صاف دراز کشیده شود، و سرش را به سمت خودش بچرخاند.<br /> از رکوع بلند شدن.<br /> راست ایستاد شدن.<br /> سجده، تمکین و چسپاندن پیشانی و بینی و دستها و زانوها و نوک انگشتان پاها به محل سجده.<br /> بلند شدن از سجده<br /> نشستن بین دو سجده.<span class="c6"><br /> و سنت این است که:</span> روی پای چپ بنشیند، و پای راست را ایستاده و به سمت قبله نگه دارد.<br /> حفظ آرامش، و آن سکون در همه ارکان فعلی می باشد.<br /> تشهد اخير.<br /> برای آن نشستن.<br /> دو تسلیم،<span class="c6"> که باید دو بار:</span> <span class="c3">« السَّلام عليكم ورحمة الله»</span> گفته شود.<br /> ترتیب رکن ها - چنانکه اشاره کردیم - مثلاً اگر قصدا قبل از سجده رکوع نماید؛ نمازش باطل می شود، اما اگر سهوا رخ دهد؛ باید بر گردد و رکوع وسجده را انجام دهد. </p>',
            ],
            21 => [
                'question' => 'س 22: واجبات نماز را ذکر کنید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3820.mp3',
                'answer' => '<p> ج ـ واجبات نماز هشت است،<span class="c6"> و قرار ذیل می باشد:</span><br /> 1- تکبیرها، غیر تکبیر تحریمه.<br /> 2-<span class="c6"> گفتن:</span> <span class="c3">«سمع الله لمن حمده»</span> برای امام و برای منفرد.<br /> 3-<span class="c6"> گفتن:</span> <span class="c3">«ربنا ولك الحمد»</span>.<br /> 4-<span class="c6"> گفتن:</span> <span class="c3">«سبحان ربي العظيم»</span> یک مرتبه در حال رکوع.<br /> 5-<span class="c6"> گفتن:</span> <span class="c3">«سبحان ربي الأعلى»</span> یک مرتبه در سجده.<br /> 6-<span class="c6"> گفتن:</span> <span class="c3">«رب اغفر لي»</span> بین دو سجده.<br /> 7- تشهد اول.<br /> 8- نشستن برای تشهد اول. </p>',
            ],
            22 => [
                'question' => 'س 23: سنت های نماز چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3930.mp3',
                'answer' => '<p> ج - یازده سنت است،<span class="c6"> به شرح زیر:</span><br /> 1- پس از تکبیر تحریمه،<span class="c6"> باید:</span> سبحانك اللهم وبحمدك، وتبارك اسمك، وتَعَالَىٰ جدك، ولا إله غيرك » گفته شود، بعد از آن دعای استفتاح بگوید.<br /> 2- گفتن اعوذ بالله من الشیطان الرجیم.<br /> 3- گفتن بسم الله الرحمن الرحیم.<br /> 4-<span class="c6"> گفتن:</span> آمین.<br /> 5- خواندن سوره بعد از فاتحه .<br /> 6- بلند خواندن برای امام.<br /> 7- بعد از ربنا ولک الحمد،<span class="c6"> گفتن:</span> "ملء السَّمٰوات، وملء الأرض، وملء ما شئت من شيء بعد".<br /> 8- آنچه در تسبیح رکوع بیش از یک بار باشد.<span class="c6"> یعنی:</span> تسبیح دوم و سوم و بیشتر از آن.<br /> 9- آنچه در تسبیح سجده بیش از یک بار باشد.<br /> 10-<span class="c6"> آنچه در بین دو سجده بیش از یک بار گفته شود:</span> <span class="c3">«رب اغفر لي»</span>.<br /> 11- درود در تشهد اخیر برای خانواده رسول الله علیهم السلام، و برکت بر وی و اهل وی، و دعای بعد از آن.<span class="c6"><br /> چهارم:</span> سنت های فعلی و آن را هیئات می گویند:<br /> 1- بالا بردن هر دو دستان با تکبیرۀ احرام.<br /> 2- و هنگام رکوع.<br /> 3- و هنگام بلند شدن از آن.<br /> 4- و بعدا آنرا بسوی زمین رها کردن.<br /> 5- قرار دادن دست راست روی دست چپ.<br /> 6- نگاه كردن به محل سجده.<br /> ۷- دور ماندن پاها از یکدیگر در وقت ایستادن.<br /> ۷- مشت کردن هر دو زانوها توسط دستان هنگام رکوع کردن، و هموار ساختن پشت در آن، و برابر نگاه داشتن سر با پشت.<br /> 9- قرار دادن اعضای سجده به زمین،و رساندن آنها به محل سجده.<br /> 10- بازوها را از پهلوها، و شکم را از ران ها، و ران ها را از پاها جدا ساختن، و جدا نمودن وی بین زانوهایش، و ایستاد گرفتن کف پاهایش، و گذاشتن کف انگشتان گشاده شده روی زمین، و ماندن هر دو دستان برابر با هر دو شانه ها در حالی که انگشتان اش جم کرده باشد.<br /> 11- به شکل افتراش نشستن بین دو سجده و تشهد اول، و به شکل تورک در تشهد دوم.<br /> 12- گذاشتن دستها روی ران ها بشکل کشیده شده وانگشتان با هم جمع شده بین دو سجده، و همچنان در تشهد نیز همینطور انجام گیرد، جز اینکه انگشت کوچک <span class="c2">(خنصر)</span> و انگشت حلقه <span class="c2">(بنصر)</span> دست راست را جم کرده باشد، و انگشت شست <span class="c2">(ابهام)</span> و انگشت وسطی <span class="c2">(وسطی)</span> را حلقه نموده و توسط انگشت اشاره <span class="c2">(سبابه)</span> هنگام ذکر الله اشاره می نماید.<br /> 13- نگاه کردن به راست و چپ هنگام سلام. </p>',
            ],
            23 => [
                'question' => 'س 24: شکننده های نماز را بشمارید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4210.mp3',
                'answer' => '<p> ج- <span class="c2">(1)</span> ترک رکن یا شرط از شروط نماز.<br /> <span class="c2">(2)</span> صحبت عمدی.<br /> <span class="c2">(3)</span> خوردن یا آشامیدن.<br /> <span class="c2">(4)</span> حرکت های زیاد و پی هم.<br /> <span class="c2">(5)</span> ترک کردن واجب از واجبات نماز به شکل عمدی. </p>',
            ],
            24 => [
                'question' => 'س 25: یک مسلمان چگونه نماز می خواند؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4280.mp3',
                'answer' => '<p> ج-<span class="c6"> چگونگی نماز خواندن:</span><br /> 1- با تمام بدن رو به قبله باشد، بدون میلان و نگاه کردن.<br /> 2 - سپس نمازی را که می خواهد ادا نماید در دل نیت نموده بدون اینکه به زبان بیاورد.<br /> 3 -<span class="c6"> سپس تکبیر تحریمه را بجا میاورد و می گوید:</span> <span class="c2">(الله اکبر)</span> و هنگام گفتن تکبیر، دستان خود را به برابری شانه هایش بلند می کند.<br /> 4- سپس كف دست راست را بر پشت كف دست چپ بالای سینه می گذارد.<br /> 5-<span class="c6"> سپس آغاز می کند و می گوید:</span> <span class="c3">«الهی مرا از گناهانم دور کن چنانکه مشرق را از مغرب دور کردی، الهی مرا از گناهانم پاک کن چنانکه جامۀ سفیدی از پلیدی پاک می شود، الهی مرا از گناهانم با آب و برف و ژاله بشوی»</span>.<span class="c6"><br /> و یا می گوید:</span> <span class="c3">«سبحانك اللهم وبحمدك، وتبارك اسمك، وتَعَالَىٰ جدك، ولا إله غيرك»</span>.<br /> «الهی تو منزهی و ستایش تراست، و نامت مبارک، و جایگاهت بلند است، و معبودی <span class="c2">(برحق)</span>جز تو نیست».<br /> 6 -<span class="c6"> سپس پناه می برد و می گوید:</span> أعوذ بالله من الشيطان الرجيم».<br /> <span class="c3">«به الله پناه می برم از شیطان رانده شده»</span>. 7-<span class="c6"> سپس بسمله را خوانده و فاتحه را تلاوت می کند و می گوید:</span> ﴿بِسْمِ اللهِ الرَّحْمنِ الرَّحِيمِ 1<br /> بنام الله بخشاینده و مهربان الْحَمْدُ للّهِ رَبِّ الْعَالَمِينَ 2<br /> ستایش الله را که پروردگار جهانیان است. الرَّحْمـنِ الرَّحِيمِ 3<br /> الله که بخشنده و مهربان است. مَالِكِ يَوْمِ الدِّينِ<br /> مالک <span class="c2">(و پادشاه)</span> روز جزاست. 4 إِيَّاكَ نَعْبُدُ وإِيَّاكَ نَسْتَعِينُ 5<br /> <span class="c2">(پروردگارا)</span> تنها تو را می‌پرستیم، و تنها از تو یاری می‌جوییم. اهدِنَــــا الصِّرَاطَ المُستَقِيمَ 6<br /> تو ما را به راه راست هدایت فرما. صِرَاطَ الَّذِينَ أَنعَمتَ عَلَيهِمْ غَيرِ المَغضُوبِ عَلَيهِمْ وَلاَ الضَّالِّينَ 7﴾<br /> راه آنانی که به آنها انعام فرمودی، نه راه کسانی که بر آنها خشم فرمودی <span class="c2">(قوم یهود)</span> و نه گمراهان <span class="c2">(چون اغلب نصاری)</span>. <span class="c5">[سورة الفاتحة:1-7]</span>.<span class="c6"><br /> سپس می گوید:</span> <span class="c2">(آمین)</span> یعنی: الهی اجابت کن.<br /> 8 - سپس تا حد توان از قرآن تلاوت می کند و تلاوت نماز صبح را طولانی می کند.<br /> 9 - سپس رکوع می کند،<span class="c6"> یعنی:</span> برای تسبیح الله پشتش را خم می کند و هنگام رکوع تکبیر می گوید و دست ها را به اندازۀ شانه هایش بلند می کند.<span class="c6"> و سنت این است که:</span> پشتش را هموار نموده، سرش را به طرف خود بگرداند و دستها را روی زانو بگذارد و انگشتان را از هم جدا کند.<br /> 10 -<span class="c6"> در رکوع سه مرتبه می گوید:</span> <span class="c3">« سبحان ربي العظيم»</span> و اگر اضافه کند: <span class="c3">« سبحانك اللهم وبحمدك، اللهم اغفر لي»</span> بهتر است.<br /> 11 -<span class="c6"> سپس سر خود را از رکوع بلند می کند و می گوید:</span> <span class="c3">« سمع الله لمن حمده»</span> سپس دستان خود را به اندازۀ شانه هایش بلند می کند.<span class="c6"> مقتدی نمی گوید:</span> <span class="c3">« سمع الله لمن حمده »</span>،<span class="c6"> بلکه در عوض آن می گوید:</span> <span class="c3">« ربنا ولك الحمد»</span>.<br /> 12 -<span class="c6"> سپس پس از بلند شدن از رکوع می‌گوید:</span> ربنا ولك الحمد، ملء السماوات والأرض، وملء ما شئت من شيء بعد».<br /> <span class="c3">«پروردگارا، حمد و ستایش از آن تو است، به اندازه پُری آسمان‌ها و زمین و پُری هر چه را تو بخواهی»</span>.<br /> 13 - سپس سجده اول را بجا می آورد،<span class="c6"> هنگام رفتن به سجده می‌گوید:</span> <span class="c3">«الله اکبر»</span> و بر هفت عضوش سجده می‌کند: پیشانی، بینی، کف دو دست، زانوها، اطراف پاها، و بازوها را از پهلوها دور نگه می دارد، و دستها را روی زمین دراز نکشد، و نوک انگشتانش رو به قبله باشد.<br /> 14 -<span class="c6"> در سجده سه مرتبه می گوید:</span> <span class="c3">« سبحان ربي الأعلى»</span>.<span class="c6"><br /> و اگر اضافه کرد:</span> سبحانك اللهم ربنا وبحمدك، اللهم اغفر لي، بهتر است.<br /> 15 -<span class="c6"> سپس سر خود را از سجده بلند نموده و می گوید:</span> الله اکبر.<br /> 16 - سپس بین دو سجده روی پای چپ می نشیند،<br /> پای راستش را ایستاد می کند و دست راست را روی گوشۀ ران راستش که کنار زانویش است می گذارد، و انگشتان کوچک و حلقه را با هم می گیرد و هنگام دعا انگشت اشاره را بالا می آورد و حرکت می دهد،و نوک انگشت شست را با انتهای میانی مانند یک حلقه جفت می کند و دست چپ خود را با انگشتان کشیده روی نوک ران چپ، زیر زانو قرار می دهد.<span class="c6"><br /> 17 – و بین دو سجده در نشست مي گوید:</span> <span class="c3">«رب اغفر لي، وارحمني، واهدني، وارزقني، واجبرني، وعافني»</span>.<br /> <span class="c3">«پروردگارا مرا ببخش، و هدایتم کن، به من روزی بده، و جبرانم کن،و مرا عافیت ببخش»</span><br /> 18 - سپس سجدۀ دوم را مانند سجدۀ اول در گفتار و عمل انجام می دهد، و هنگام سجده تکبیر می گوید.<br /> 19 -<span class="c6"> سپس از سجده دوم برمی‌خیزد و می‌گوید:</span> <span class="c3">«الله اکبر»</span> و رکعت دوم را در گفتار و عمل مانند رکعت اول می‌خواند، جز اینکه در آن دعای استفتاح را نمی خواند.<br /> 20 -<span class="c6"> بعد از پایان رکعت دوم می نشیند و می گوید:</span> <span class="c3">«الله اکبر»</span> و همان طور که بین دو سجده می نشیند.<span class="c6"><br /> 21 – و تشهد را در این قعده می خواند و می گوید:</span> <span class="c3">«التحيات لله والصلوات والطيبات، السلام عليك أيها النبي ورحمة الله وبركاته، السلام علينا وعلى عباد الله الصالحين، أشهد أن لا إله إلا الله، وأشهد أن محمداً عبده ورسوله، اللهم صلِّ على محمد وعلى آل محمد، كما صليت على إبراهيم وعلى آل إبراهيم، إنك حميد مجيد، وبارك على محمد وعلى آل محمد، كما باركت على إبراهيم وعلى آل إبراهيم، إنك حميد مجيد.<br /> تمام اوصاف، دعاها و الفاظ نیک از برای الله تعالی است، سلام بر شما ای پیامبر، همچنان رحمت و برکات الله بر شما، سلامتی تو بر ما و بر بنده های صالح باشد، شهادت می دهم که بدون از الله معبودی برحق نیست، و شهادت می دهم که محمد بنده و پیامبر او هست، یا الله! نزول رحمت فرما برمحمد و خاندان محمد به مثل رحمت که بر ابراهیم و بر خاندان او فرموده ای، بی شک تو قابل ستایش و بزرگ هستی، یا الله! نزول برکت فرما برمحمد و خاندان محمد به مثل برکت که بر ابراهیم و بر خاندان او فرموده ای ، بی شک تو قابل ستایش و بزرگ هستی.<br /> »</span>أعوذ بالله من عذاب جهنم، ومن عذاب القبر، ومن فتنة المحيا والممات، ومن فتنة المسيح الدجال».<br /> »به الله پناه می برم از عذاب جهنم، از عذاب قبر، از آزمایش مرگ و زندگی، و از آزمایش مسیح دجال». سپس پروردگارش را به آنچه دوست دارد از خیر دنیا و آخرت فرا می خواند.<br /> 22 -<span class="c6"> سپس سمت راست سلام می کند و می گوید:</span> <span class="c3">«السلام علیکم و رحمة الله»</span> و در سمت چپ همچنان.<br /> 23 - اگر نماز سه یا چهار رکعتی باشد؛<span class="c6"> در پایان تشهد اول توقف می نماید و آن:</span> أشهد أن لا إله إلا الله، وأشهد أن محمداً عبده ورسوله.<br /> گواهی می دهم که معبودی جز الله نیست و گواهی می دهم که محمد بنده و فرستاده اوست.<br /> 24 -<span class="c6"> سپس برمی‌خیزد و می‌گوید:</span> <span class="c3">«الله اکبر»</span> و دست‌هایش را به اندازۀ شانه‌هایش بلند می‌کند.<br /> 25 - سپس باقيمانده نماز را مانند ركعت دوم می خواند مگر اينكه به خواندن فاتحه اکتفا می کند.<br /> 26 - سپس متورک می نشیند؛ و پای راستش را صاف می کند و پای چپ را از زیر پای راست بیرون می آورد و مقعدش را روی زمین می گذارد، و دست هایش را روی ران خود می گذارد، همان گونه که در تشهد اول گذاشته بود.<br /> 27 - و در این جلسه تمام تشهد را می خواند.<br /> 28 -<span class="c6"> سپس سمت راست سلام می کند و می گوید:</span> <span class="c3">«السلام علیکم و رحمة الله»</span> و نیز در سمت چپ سلام می گوید. </p>',
            ],
            25 => [
                'question' => 'س 26: بعد از سلام دادن نماز کدام اذکار را می خوانید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4610.mp3',
                'answer' => '<p> ج- <span class="c3">« گفتن: أَسْـتَغْفِرُ الله سه مرتبه <br /> «از الله آمرزش می‌خواهم»</span>.<br /> - <span class="c3">«اللّهُـمَّ أَنْـتَ السَّلامُ، وَمِـنْكَ السَّلام، تَبارَكْتَ يا ذا الجَـلالِ وَالإِكْـرام»</span>.<br /> بارالها! تو سلامتی دهنده ای وسلامتی از طریق تو خواهد رسید با برکت هستی ای ذات بزرگوار و با عظمت)<br /> - <span class="c3">«لا إلهَ إلاّ اللّهُ وحدَهُ لا شريكَ لهُ، لهُ المُـلْكُ ولهُ الحَمْد، وهوَ على كلّ شَيءٍ قَدير، اللّهُـمَّ لا مانِعَ لِما أَعْطَـيْت، وَلا مُعْطِـيَ لِما مَنَـعْت، وَلا يَنْفَـعُ ذا الجَـدِّ مِنْـكَ الجَـد»</span>.<br /> - <span class="c3">«هیچ معبودی جز الله نیست و شریکی ندارد،<br /> فرمانروایی و ستایش از آن اوست، و او بر هر چیزی تواناست، الهی چیزی را که عطا نمودی باز دارندۀ ندارد، و از چیزی که منع کردی عطا کنندۀ ندارد، و صاحب مال و جاه دنیوی صاحبش از تو نجات داده نمی تواند جز عمل صالح او»</span>.<br /> - <span class="c3">«لا إلهَ إلاّ الله، وحدَهُ لا شريكَ لهُ، لهُ الملكُ ولهُ الحَمد، وهوَ على كلّ شيءٍ قدير، لا حَـوْلَ وَلا قـوَّةَ إِلاّ بِاللهِ، لا إلهَ إلاّ الله، وَلا نَعْـبُـدُ إِلاّ إيّـاه، لَهُ النِّعْـمَةُ وَلَهُ الفَضْل وَلَهُ الثَّـناءُ الحَـسَن، لا إلهَ إلاّ الله مخْلِصـينَ لَـهُ الدِّينَ وَلَوْ كَـرِهَ الكـافِرون»</span>.<br /> <span class="c3">«هیچ معبودی جز الله نیست، تنها و بی شریک، فرمانروایی از آن اوست و حمد و ستایش از آن اوست و او بر هر چیزی تواناست، هیچ نیرو و قدرتی نیست مگر با الله، معبودی جز الله نیست و ما جز او را نمی پرستیم، نعمت، فضل و ستایش نیک از آن اوست،هیچ معبودی جز الله نیست، مخلص دین او هستیم و لو اگر کافران از آن متنفر باشند.»</span><br /> - <span class="c3">«سُـبْحانَ اللهِ»</span> <span class="c2">(پاکیست الله را)</span> سی و سه مرتبه.<br /> <span class="c3">«الحَمْـدُ لله»</span> <span class="c2">(ثنا و ستایش است الله را)</span> سی و سه مرتبه.<br /> <span class="c3">«اللهُ أكْـبَر»</span> <span class="c2">(الله بزرگتر است)</span> سی و سه مرتبه.<span class="c6"><br /> سپس برای تکمیل شدن صد می گوید:</span> <span class="c3">«لا إله إلا الله وحده لا شريك له، له الملك وله الحمد، وهو على كل شيء قدير»</span>.<br /> «هیچ معبودی جز الله نیست، تنها و بی شریک، فرمانروایی از آن اوست و حمد و ستایش از آن اوست و او بر هر چیزی تواناست.<br /> سورۀ اخلاص <span class="c2">(قل هو الله أحد)</span> و معوذات <span class="c2">(قل أعوذ برب الفلق و قل أعوذ برب الناس)</span> را می خواند. سه مرتبه بعد از نماز صبح و شام و یک بار بعد از نمازهای دیگر.<br /> - ویک بار آیت الکرسی را می خواند </p>',
            ],
            26 => [
                'question' => 'س 27: سنت های همیشگی چیست؟ و فضیلت آنها چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4730.mp3',
                'answer' => '<p> ج - دو رکعت قبل از نماز صبح.<br /> چهار رکعت قبل از ظهر.<br /> دو رکعت بعد از ظهر.<br /> دو رکعت بعد از مغرب.<br /> دو رکعت بعد از خفتن.<span class="c6"><br /> فضیلت آن:</span> پیامبر فرمود: <span class="c3">«هر که در شبانه روز دوازده رکعت نماز نفل بخواند، الله برای او خانه‌ای در بهشت می‌سازد»</span>. مسلم و احمد و دیگران روایت نمودند. </p>',
            ],
            27 => [
                'question' => 'س28: بهترین روزهای هفته کدامند؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4800.mp3',
                'answer' => '<p> ج- روز جمعه ،<span class="c6"> پیامبر صلی الله علیه وسم فرمود:</span> <span class="c3">«یکی از بهترین روزهای شما روز جمعه است که آدم در آن آفریده شد و در آن روز از دنیا رفت و در آن روز در صور دمیده می شود و در آن صاعقه رخ می دهد، پس در این روز برایم بیشتر درود بفرستید و درود شما برای من عرضه می گردد.»</span> گفت: گفتند ای رسول الله چگونه درود ما بر تو عرضه می شود در حالی که خاک شده یی؟ - می گویند خاک شده ای -<span class="c6"> گفت:</span> <span class="c3">«الله عزوجل اجساد پیامبران را بر زمین حرام گردانیده است»</span>. روایت ابوداود و دیگران. </p>',
            ],
            28 => [
                'question' => 'س 29: نماز جمعه چه حکمی دارد؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4840.mp3',
                'answer' => '<p> ج- بر هر مسلمان بالغ، عاقل، مقیم، فرض عین می باشد.<span class="c6"><br /> الله متعال فرموده اند:</span> <span class="c4">﴿ يَٓأَيُّهَا ٱلَّذِينَ ءَامَنُوٓاْ إِذَا نُودِيَ لِلصَّلَوةِ مِن يَوۡمِ ٱلۡجُمُعَةِ فَٱسۡعَوۡاْ إِلَى ذِكۡرِ ٱللَّهِ وَذَرُواْ ٱلۡبَيۡعَۚ ذَلِكُمۡ خَيۡرٞ لَّكُمۡ إِن كُنتُمۡ تَعۡلَمُونَ 9﴾</span><br /> اى كسانى كه ايمان آورده‏ ايد چون براى نماز جمعه ندا درداده شد به سوى ذكر الله بشتابيد و داد و ستد را واگذاريد اگر بدانيد اين براى شما بهتر است. <span class="c5">[سورة المنافقون: ٩]</span>. </p>',
            ],
            29 => [
                'question' => 'س 30: نماز جمعه چند رکعت است؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4880.mp3',
                'answer' => '<p> ج - تعداد رکعت های نماز جمعه دو رکعت است که امام در آن با صدای بلند می خواند و دو خطبه معروف قبل از آن می باشد. </p>',
            ],
            30 => [
                'question' => 'س 31: آیا ترک نماز جمعه جایز است؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4910.mp3',
                'answer' => '<p> ج - ترک نماز جمعه جز عذر شرعی جایز نیست،<span class="c6"> پیامبر صلی الله علیه وسلم فرمود:</span> <span class="c3">«کسی که سه جمعه از لحاظ سهل انگاری ترک نماید، الله متعال بر قلبش مهر می نهد.»</span> روایت ابوداود و دیگران. </p>',
            ],
            31 => [
                'question' => 'س 32: سنت های روز جمعه را بیان کنید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4940.mp3',
                'answer' => '<p> ج-<br /> 1- غسل کردن.<br /> 2- استفاده از خوشبویی.<br /> 3- پوشیدن بهترین لباس ها.<br /> 4- زود رفتن به مسجد.<br /> 5- درود بسیار بر پیامبر صلی الله علیه وسلم.<br /> 6- تلاوت سوره کهف.<br /> 7- پیاده رفتن به مسجد.<br /> 8- دریافت ساعت اجابت دعا. </p>',
            ],
            32 => [
                'question' => 'س 33: فضیلت نماز جماعت را ذکر کنید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5050.mp3',
                'answer' => '<p> ج-<span class="c6"> از عبدالله بن عمر رضی الله عنهم روایت است که رسول الله صلی الله علیه وسلم فرمود:</span> <span class="c3">«نماز جماعت بیست و هفت مرتبه بهتر از نماز تنهایی است»</span>. مسلم روایت نموده است. </p>',
            ],
            33 => [
                'question' => 'س 34: خشوع در نماز چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5080.mp3',
                'answer' => '<p> ج - حضور دل و سکون اعضای بدن در نماز می باشد.<span class="c6"><br /> الله متعال فرموده اند:</span> ﴿قَدْ أَفْلَحَ الْمُؤْمِنُونَ 1<br /> به راستى كه مؤمنان رستگار شدند <span class="c2">(۱)</span> الَّذِينَ هُمْ فِي صَلَاتِهِمْ خَاشِعُونَ 2﴾<br /> همانان كه در نمازشان فروتن اند <span class="c2">(۲)</span> <span class="c5">[سورة المؤمنون: 1، 2]</span>. </p>',
            ],
            34 => [
                'question' => 'س 35: زکات را تعریف کنید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5120.mp3',
                'answer' => '<p> حق واجب است در مال ويژه، برای گروه ویژه در وقت ویژه.<br /> یکی از ارکان اسلام و صدقه فرض است که از ثروتمندان گرفته و به فقیران داده می شود.<span class="c6"><br /> الله متعال فرموده اند:</span> <span class="c4">﴿وَآتُوا الزَّكَاةَ﴾</span><br /> و زكات را بدهید <span class="c5">[سورة البقرة: 43]</span>. </p>',
            ],
            35 => [
                'question' => 'س 36: صدقۀ مستحب چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5170.mp3',
                'answer' => '<p> ج – صدقه، زکات نیست،<span class="c6"> مانند:</span> صدقه دادن هر چیزی در راه خیر در هر زمان.<span class="c6"><br /> الله متعال فرموده اند:</span> <span class="c4">﴿وَأَنْفِقُوا فِي سَبِيلِ اللَّهِ﴾</span><br /> و در راه الله انفاق كنيد <span class="c5">[سورة البقرة: 195]</span>. </p>',
            ],
            36 => [
                'question' => 'س 37: روزه را تعریف کن؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5210.mp3',
                'answer' => '<p> ج- عبادت الله است با اجتناب از چیزهایی که روزه را می شکناند از طلوع فجر تا غروب آفتاب با نیت می باشد،<span class="c6"> و بر دو قسم است:</span><br /> روزه فرض: مانند روزۀ ماه رمضان که از ارکان اسلام است.<span class="c6"><br /> الله متعال فرموده اند:</span> <span class="c4">﴿يَا أَيُّهَا الَّذِينَ آمَنُوا كُتِبَ عَلَيْكُمُ الصِّيَامُ كَمَا كُتِبَ عَلَى الَّذِينَ مِنْ قَبْلِكُمْ لَعَلَّكُمْ تَتَّقُونَ 183﴾</span><br /> ای کسانی‌که به الله ایمان آورده‌اید و از رسولش پیروی کرده‌اید، روزه از جانب پروردگارتان بر شما فرض شده است همان‌گونه که بر امت‌های قبل از شما فرض شده بود؛ تا - با انجام اعمال صالح که روزه از بزرگترین آنهاست، با قرار دادن سپری میان خود و عذاب الله، - تقوای الهی را پیشه کنید. <span class="c5">[سورة البقرة: 183]</span>.<span class="c6"><br /> و روزه غیر فرض:</span> مانند روزه روزهای دوشنبه و پنج شنبه از هر هفته، و روزه سه روز از هر ماه که بهترین آنها ایام البیض روزهای<span class="c2">(13، 14، 15)</span> هر ماه قمری است. </p>',
            ],
            37 => [
                'question' => 'س 38: فضیلت روزه ماه رمضان را ذکر کنید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5270.mp3',
                'answer' => '<p> ج-<span class="c6"> از ابوهریره رضی الله عنه روایت است که رسول الله صلی الله علیه وسلم فرمود:</span> <span class="c3">«کسی که رمضان را از روی ایمان و به امید ثواب روزه بگیرد، گناهان قبلی او بخشیده می شود.»</span> متفق عليه. </p>',
            ],
            38 => [
                'question' => 'س 39: فضيلت روزه های نفلی غير از ماه رمضان را بيان كنيد؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5300.mp3',
                'answer' => '<p> ج -<span class="c6"> از ابوسعید خدری رضی الله عنه روایت است گفت:</span> رسول الله صلی الله علیه وسلم فرمود: «هیچ بنده ای نیست که یک روز را در راه الله روزه بگیرد، جز این که الله بوسیلۀ آن روز تا هفتاد خزان صورت او را از آتش جهنم دور نگه می دارد. متفق عليه.<br /> هفتاد خزان یعنی هفتاد سال. </p>',
            ],
            39 => [
                'question' => 'س40: برخی از شکننده های روزه را ذکر کنید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5330.mp3',
                'answer' => '<p> ج-1- خوردن و آشامیدن قصدا.<br /> 2- استفراغ عمدی.<br /> 3- ارتداد از اسلام. </p>',
            ],
            40 => [
                'question' => 'س 41: سنت های روزه چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5380.mp3',
                'answer' => '<p> ج-1- عجله کردن در افطار.<br /> 2- سحری و تأخیر آن.<br /> 3- زیادت در عبادات و کارهای نیک.<br /> 4-<span class="c6"> گفتن روزه دار:</span> من روزه هستم، وقتی به او دشنام داده شود.<br /> 5- دعا در وقت افطار.<br /> 6- افطار با خرمای تازه یا خرما، اگر پیدا نشد، با آب صورت گیرد. </p>',
            ],
            41 => [
                'question' => 'س 42: حج چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5460.mp3',
                'answer' => '<p> ج -<span class="c6"> حج:</span> عبارت است از عبادت الله متعال، به قصد رفتن به بیت الله الحرام برای اعمال خاص در وقت معین.<span class="c6"><br /> الله متعال فرموده اند:</span> <span class="c4">﴿وَلِلَّهِ عَلَى النَّاسِ حِجُّ الْبَيْتِ مَنِ اسْتَطَاعَ إِلَيْهِ سَبِيلًا وَمَنْ كَفَرَ فَإِنَّ اللَّهَ غَنِيٌّ عَنِ الْعَالَمِينَ 97﴾</span><br /> و براى الله حج آن خانه بر عهدۀ مردم است <span class="c5">[البته بر]</span> كسى كه بتواند به سوى آن راه يابد و هر كه كفر ورزد يقينا الله از جهانيان بى ‏نياز است. <span class="c5">[سورة آل عمران: 97]</span>. </p>',
            ],
            42 => [
                'question' => 'س 43: ارکان حج را بشمارید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5500.mp3',
                'answer' => '<p> ج-1- احرام.<br /> 2- ایستادن در عرفات.<br /> 3- طواف افاضه.<br /> 4- سعی بین صفا و مروه. </p>',
            ],
            43 => [
                'question' => 'س 44: فضیلت حج چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5560.mp3',
                'answer' => '<p> ج -<span class="c6"> از ابوهریره رضی الله عنه روایت است که گفت:</span> از رسول الله صلی الله علیه وسلم شنیدم که می فرمود: <span class="c3">«کسی که برای الله حج را ادا نماید، و مرتکب ناسزاگویی و فسق نگردد، در حالی بر میگردد گویا تازه مادرش او را به دنیا آورده باشد»</span>. بخاری و دیگران آن را روایت کرده اند.<br /> -<span class="c6"> مانند روزی که مادرش او را به دنیا آورد:</span> یعنی بدون گناه. </p>',
            ],
            44 => [
                'question' => 'س 45: عمره چیست؟|',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5600.mp3',
                'answer' => '<p> ج ـ عمره: عبارت از عبادت الله متعال به قصد رفتن به بیت الله الحرام برای اعمال خاص در هر زمان است. </p>',
            ],
            45 => [
                'question' => 'س 46: ارکان عمره را بشمارید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5630.mp3',
                'answer' => '<p> ج-1- احرام.<br /> 2- طواف خانۀ کعبه.<br /> 3- سعی بین صفا و مروه. </p>',
            ],
            46 => [
                'question' => 'س 47: جهاد در راه الله چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5690.mp3',
                'answer' => '<p> ج - تلاش و کوشش برای گسترش اسلام و دفاع از آن و اهل آن، و یا مبارزه با دشمن اسلام و اهل آن است.<span class="c6"><br /> الله متعال فرموده اند:</span> <span class="c4">﴿وَجَاهِدُوا بِأَمْوَالِكُمْ وَأَنْفُسِكُمْ فِي سَبِيلِ اللَّهِ ذَلِكُمْ خَيْرٌ لَكُمْ إِنْ كُنْتُمْ تَعْلَمُونَ 41﴾</span><br /> و با مال و جانتان در راه الله جهاد كنيد اگر بدانيد اين براى شما بهتر است <span class="c2">(۴۱)</span> <span class="c5">[سورة التوبة: 41]</span>. </p>',
            ],
        ],
        3 => [
            0 => [
                'question' => 'س 1: نسب پیامبر ما حضرت محمد ﷺ چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5740.mp3',
                'answer' => '<p> ج - او محمد بن عبدالله بن عبدالمطلب بن هاشم است. هاشم از قریش، قریش از عرب است، و عرب از اولاد اسماعیل و اسماعیل فرزند ابراهیم عليه وعلى نبينا افضل الصلاة والسلام است. </p>',
            ],
            1 => [
                'question' => 'س 2: نام مادر پیامبرمان صلی الله علیه وسلم چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5770.mp3',
                'answer' => '<p> ج- آمنه بنت وهب. </p>',
            ],
            2 => [
                'question' => 'س3: پدرش چه زمانی فوت کرد؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5800.mp3',
                'answer' => '<p> ج- پدرش در مدینه در حالی وفات کرد که وی صلی الله علیه وسلم در شکم مادرش بود، و به دنیا نیامده بود. </p>',
            ],
            3 => [
                'question' => 'س 4: پیامبر اکرم صلی الله علیه وسلم چه زمانی به دنیا آمد؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5830.mp3',
                'answer' => '<p> ج- در سال فیل روز دوشنبه ماه ربیع الاول. </p>',
            ],
            4 => [
                'question' => 'س5: در کدام سرزمین متولد شد؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5850.mp3',
                'answer' => '<p> ج- در مکه. </p>',
            ],
            5 => [
                'question' => 'Q6:  شیردهندگان و پرستاران وی چه کسانی بودند، غیر از مادرش؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5880.mp3',
                'answer' => '<p> ج- کنیزۀ پدرش، ام ایمن.<br /> - کنیزۀ کاکایش ابولهب ثویبه.<br /> - حلیمه سعدیه. </p>',
            ],
            6 => [
                'question' => 'س7: مادرش چه زمانی فوت کرد؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5930.mp3',
                'answer' => '<p> ج - مادرش در شش سالگی فوت کرد و جدش عبدالمطلب سرپرستی او را بر عهده گرفت. </p>',
            ],
            7 => [
                'question' => 'س 8: پس از مرگ پدر کلانش عبدالمطلب؛ چه کسی او را کفالت کرد؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5960.mp3',
                'answer' => '<p> ج- پدربزرگش عبدالمطلب هنگامی از دنیا رفت که او هشت سال داشت و کاکایش ابوطالب کفالت او را بر عهده گرفت. </p>',
            ],
            8 => [
                'question' => 'س 9: چه زمانی با کاکایش به شام سفر کرد؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5990.mp3',
                'answer' => '<p> ج - در دوازده سالگی با کاکایش به شام سفر کرد. </p>',
            ],
            9 => [
                'question' => 'س10: سفر دوم او چه زمانی بود؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6020.mp3',
                'answer' => '<p> ج - سفر دومش تجارت با مال خدیجه رضی الله عنها بود و چون برگشت در بیست و پنج سالگی با او رضی الله عنها ازدواج کرد. </p>',
            ],
            10 => [
                'question' => 'س 11: قریش چه زمانی کعبه را بازسازی کردند؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6050.mp3',
                'answer' => '<p> ج - قریش خانۀ کعبه را بازسازی کردند که او سی پنج ساله بود.<br /> زمانی که آنان در مورد اینکه چه کسی حجرالاسود را در جایش بگذارد باهم اختلاف نمودند، وی را برای قضاوت برگزیدند، بنابرین وی آن را در پارچۀ گذاشت،و به بزرگ هر قوم امر کرد که یک گوشۀ پارچه را بردارند و چهار طایفه بودند، هرگاه آن را تا جایش بلند کردند، رسول الله صلی الله علیه وسلم با دست خود آن را گرفته و در جایش گذاشت. </p>',
            ],
            11 => [
                'question' => 'س 12: رسول الله صلی الله علیه وسلم در زمان فرستاده شدنش چند سال داشت؟ و برای کی فرستاده شد؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6080.mp3',
                'answer' => '<p> ج - چهل سال داشت ، و برای همه مردم بشارت دهنده و بیم دهنده فرستاده شد. </p>',
            ],
            12 => [
                'question' => 'س 13: اولین چیزی که وحی با آن آغاز شد چه بود؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6110.mp3',
                'answer' => '<p> ج – رویایی صادق بود، وقتی خواب می دید مانند طلوع فجر به حقیقت می پیوست. </p>',
            ],
            13 => [
                'question' => 'س 14: حال او قبل از بعثت چگونه بود؟
  و اولین بار چه زمانی بر وی وحی نازل شد؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6140.mp3',
                'answer' => '<p> ج- در غار حرا الله را عبادت می کرد و برای آن خود را آماده می نمود.<br /> در حالی که در غار مشغول عبادت بود وحی بر او نازل شد. </p>',
            ],
            14 => [
                'question' => 'س 15: اولین چیزی که از قرآن بر او نازل شد چه بود؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6180.mp3',
                'answer' => '<p> الله متعال فرموده اند: ﴿ٱقۡرَأۡ بِٱسۡمِ رَبِّكَ ٱلَّذِي خَلَقَ 1<br /> بخوان به نام پروردگارت كه آفريد <span class="c2">(۱)</span> خَلَقَ ٱلۡإِنسَـنَ مِنۡ عَلَقٍ 2<br /> انسان را از علق آفريد <span class="c2">(۲)</span> ٱقۡرَأۡ وَرَبُّكَ ٱلۡأَكۡرَمُ 3<br /> بخوان و پروردگار تو كريمترين <span class="c5">[كريمان]</span> است <span class="c2">(۳)</span> ٱلَّذِي عَلَّمَ بِٱلۡقَلَمِ 4<br /> همان كسی كه به وسيله قلم آموخت <span class="c2">(۴)</span> عَلَّمَ ٱلۡإِنسَـنَ مَا لَمۡ يَعۡلَمۡ 5﴾<br /> آنچه را كه انسان نمى‏ دانست به وی آموخت <span class="c2">(۵)</span> <span class="c5">[سورة العلق: 1 - 5]</span>. </p>',
            ],
            15 => [
                'question' => 'س 16: اولین کسی که به رسالت او ایمان آورد چه کسی بود؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6200.mp3',
                'answer' => '<p> ج -<span class="c6"> از مردان:</span> ابوبکر صدیق،<span class="c6"> از زنان:</span> خدیجه بنت خویلد،<span class="c6"> از پسران:</span> علی بن ابی طالب،<span class="c6"> و از وفاداران:</span> زید بن حارثه،<span class="c6"> و از غلامان:</span> بلال الحبشی رضی الله عنهم، وغیرهم. </p>',
            ],
            16 => [
                'question' => 'س 17: دعوت به اسلام چگونه بود؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6230.mp3',
                'answer' => '<p> ج - حدود سه سال دعوت مخفیانه بود، سپس به پیامبر صلی الله علیه وسلم دستور داده شد که دعوت را آشکارا انجام دهند. </p>',
            ],
            17 => [
                'question' => 'س 18: حال پیامبر صلی الله علیه وسلم و کسانی که به او ایمان آوردند پس از دعوت آشکار چگونه بود؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6260.mp3',
                'answer' => '<p> ج - مشرکان در ضرر و زیان رسانیدن به او و به مسلمانان مبالغه کردند، تا اینکه برای مؤمنان اجازۀ هجرت بسوی نجاشی در حبشه صادر نمود.<br /> مشرکان جهت آزار و کشتن پیامبر صلی الله علیه وسلم باهم موافقت کردند، پس الله وی را حفظ کرد و وی را توسط کاکایش ابوطالب محافظت کرد تا وی را از شر آنان حفظ کند. </p>',
            ],
            18 => [
                'question' => 'س 19: چه کسی در سال دهم بعثت او صلی الله علیه وسلم از دنیا رفت؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6300.mp3',
                'answer' => '<p> ج- کاکایش ابوطالب و همسرش خدیجه رضی الله عنها از دنیا رفتند. </p>',
            ],
            19 => [
                'question' => 'س20: سفر اسراء و معراج چه زمانی بود؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6330.mp3',
                'answer' => '<p> ج - پنجاه سال داشت که اتفاق افتید، و نمازهای پنجگانه نیز بر او فرض گردید.<span class="c6"><br /> سفر شب:</span> از مسجد حرام تا مسجد اقصی.<span class="c6"><br /> معراج:</span> از مسجد اقصی تا آسمان تا سدرة المنتهی بود. </p>',
            ],
            20 => [
                'question' => 'س 21: پیامبر اکرم صلی الله علیه وسلم چگونه مردم خارج از مکه را دعوت می نمود؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6380.mp3',
                'answer' => '<p> ج - اهل طائف را دعوت می کرد، در مواسم و گردهمایی مردم حاضر می شد تا اینکه اهل مدینه از انصار آمدند، و به پیامبر اکرم صلی الله علیه وسلم ایمان آوردند و بر حمایت او همرایش بیعت کردند. </p>',
            ],
            21 => [
                'question' => 'س 22: پیامبر صلی الله علیه وسلم چه مدت را برای دعوت در مکه سپری نموده؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6410.mp3',
                'answer' => '<p> ج - سیزده سال باقی ماند. </p>',
            ],
            22 => [
                'question' => 'س 23: پیامبر اکرم صلی الله علیه وسلم به کجا هجرت کردند؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6440.mp3',
                'answer' => '<p> ج - از مکه به مدینه. </p>',
            ],
            23 => [
                'question' => 'س 24: چه مدت در مدینه ماندند؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6470.mp3',
                'answer' => '<p> ج- ده سال. </p>',
            ],
            24 => [
                'question' => 'س 25: در مدینه بر وی کدام احکام اسلام فرض گردید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6490.mp3',
                'answer' => '<p> ج - بر او زکات، روزه، حج، جهاد، اذان و سایر احکام اسلام فرض گردید. </p>',
            ],
            25 => [
                'question' => 'س 26: مهمترین جنگ های آن حضرت ﷺ کدام بود؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6520.mp3',
                'answer' => '<p> ج- غزوۀ بزرگ بدر.<br /> غزوۀ احد.<br /> غزوۀ احزاب.<br /> غزوۀ فتح مكه. </p>',
            ],
            26 => [
                'question' => 'س 27: آخرین چیزی که از قرآن نازل شده چه بود؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6580.mp3',
                'answer' => '<p> الله متعال فرموده اند: <span class="c4">﴿ وَٱتَّقُوا يوۡمًا تُرۡجَعُونَ فِيهِ إِلَى ٱللَّهِۖ ثُمَّ تُوَفَّى كُلُّ نَفۡسٍ مَّا كَسَبَتۡ وَهُمۡ لَا يُظۡلَمُونَ 281﴾</span><br /> و بترسيد از روزى كه در آن‏، به سوى الله بازگردانده مى ‏شويد، سپس به هر كسى <span class="c2">(پاداش‏)</span> آنچه به دست آورده‏، تمام داده شود؛ و آنان مورد ستم قرار نمى‏ گيرند. <span class="c2">(۲۸۱)</span> <span class="c5">[سورة البقرة: 281]</span>. </p>',
            ],
            27 => [
                'question' => 'س 28: پیامبر اکرم صلی الله علیه وسلم چه زمانی از دنیا رحلت نمود؟ و چند سال داشت؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6610.mp3',
                'answer' => '<p> ج- در ماه ربیع الاول سال یازدهم هجری در شصت و سه سالگی از دنیا رحلت نمود. </p>',
            ],
            28 => [
                'question' => 'س 29: همسران پیامبر صلی الله علیه وسلم را نام ببرید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6640.mp3',
                'answer' => '<p> ج-1- خدیجه بنت خویلد رضی الله عنها.<br /> 2- سوده بنت زمعه رضی الله عنها.<br /> 3- عایشه بنت ابی بکر صدیق رضی الله عنها.<br /> 4- حفصه بنت عمر رضی الله عنها.<br /> 5- زینب بنت خزیمه رضی الله عنها.<br /> 6- ام سلمه هند بنت ابی امیه رضی الله عنها.<br /> 7- ام حبیبه رمله بنت ابی سفیان رضی الله عنها.<br /> 8- جویریه بنت الحارث رضی الله عنها.<br /> 9- میمونه بنت الحارث رضی الله عنها.<br /> 10- صفیه بنت حیّی رضی الله عنها.<br /> 11- زینب دختر جحش رضی الله عنها. </p>',
            ],
            29 => [
                'question' => 'س 30: فرزندان او صلی الله علیه وسلم چه کسانی بودند؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6760.mp3',
                'answer' => '<p> ج-<span class="c6"> سه تن از طبقۀ ذکور می باشد:</span><br /> قاسم، که به او ملقب بود.<span class="c6"><br /> و عبدالله<br /> و ابراهیم<br /> از طبقۀ اناث:</span><br /> فاطمه.<br /> رقیه.<br /> ام کلثوم.<br /> زینب.<br /> همه فرزندانش از خدیجه رضی الله عنها بودند به جز ابراهیم و همه قبل از وی وفات نمودند، بجز فاطمه شش ماه بعد از وی وفات نمود. </p>',
            ],
            30 => [
                'question' => 'س 31: برخی از خصوصیات پیدایشی پیامبر اکرم صلی الله علیه وسلم را ذکر کنید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6880.mp3',
                'answer' => '<p> ج - او از مردان قد میانه بود، نه کوتاه قد و نه بلند قد، بلکه بین آن دو قرار داشت، سفید رنگ با میلان به سرخی بود صلی الله علیه وسلم، و ریش انبوه و چشمان گشاد داشت، دهان بزرگ و موهایش بسیار سیاه بود، شانه های بزرگ و بوی خوش داشت، و غیره ویژگی های پیدایشی زیبای او صلی الله علیه وسلم. </p>',
            ],
            31 => [
                'question' => 'س 31: پیامبر اکرم صلی الله علیه وسلم امت خود را با چه چیزی ترک نمود؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6910.mp3',
                'answer' => '<p> ج - امتش را به جادۀ واضح و روشن ترک کرد، که شب آن مانند روز آن است، جز هلاک شده از آن منحرف نمی شود، نیکی را نگذاشته مگر این که امتش را به سوی آن هدایت نموده، و هیچ بدی را نگذاشته مگر این که آنان را از آن در حذر داشته است. </p>',
            ],
        ],
        4 => [
            0 => [
                'question' => 'س 1: فاتحه را بخوانید و تفسیر کنید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6960.mp3',
                'answer' => '<p> ج-<span class="c6"> سوره فاتحه وتفسير آن:</span><br /> ﴿بِسْمِ اللَّهِ الرَّحْمَنِ الرَّحِيمِ 1 به نام الله بخشاینده و مهربان الْحَمْدُ لِلَّهِ رَبِّ الْعَالَمِينَ 2 تمام ثنا و ستایش از الله <span class="c2">(ج)</span> پروردگار عالمیان است، الرَّحْمَنِ الرَّحِيمِ 3 بی نهایت بخشاینده و مهربان مَالِكِ يَوْمِ الدِّينِ 4<br /> مالک روز قیامت إِيَّاكَ نَعْبُدُ وَإِيَّاكَ نَسْتَعِينُ 5 <br /> تنها تورا<br /> عبادت می کنیم، و تنها از تو کمک می خواهيم اهْدِنَا الصِّرَاطَ الْمُسْتَقِيمَ 6 <br /> ما را به راه راست هدایت کن صِرَاطَ الَّذِينَ أَنْعَمْتَ عَلَيْهِمْ غَيْرِ الْمَغْضُوبِ عَلَيْهِمْ وَلَا الضَّالِّينَ 7﴾<br /> راه کسانیکه بر ایشان فضل و کرم کرده اید، نه راه آنانکه سزاوار غضب ات شده اند و نه انانکه گمراه شده اند <span class="c5">[سورة الفاتحة: 1 - 7]</span>.<span class="c6"><br /> تفسير:</span><br /> سورۀ فاتحه نامیده شده است چون کتاب الله به آن آغاز می شود.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001001.mp3"></audio> 1- <span class="c4">﴿بِسْمِ اللَّهِ الرَّحْمَنِ الرَّحِيمِ 1﴾</span> بسم الله، شروع به خواندن قرآن می کنم، به یاری حق تعالی که با ذکر نامش مبارک می شود.<br /> <span class="c4">﴿الله﴾</span> يعنى: معبود بر حق، و کسی ديگر به آن یاد نمی شود سبحانه و تعالی.<br /> <span class="c4">﴿الرَّحْمَن﴾</span> یعنى: ذاتی که رحمت وسیع دارد رحمتی که همه چیز را فرا گرفته است.<br /> <span class="c4">﴿الرَّحِيم﴾</span> یعنی بر مؤمنان مهربان است.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001002.mp3"></audio> 2- <span class="c4">﴿الْحَمْدُ لِلَّهِ رَبِّ الْعَالَمِينَ 2﴾</span> یعنی: همه انواع حمد و کمال فقط مخصوص الله است.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001003.mp3"></audio> 3- <span class="c4">﴿الرَّحْمَنِ الرَّحِيمِ 3﴾</span> یعنی صاحب رحمت وسیع که همه چیز را فرا گرفته است، و مهربانی واصلۀ وی بر مؤمنان می باشد.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001004.mp3"></audio> 4- <span class="c4">﴿مَالِكِ يَوْمِ الدِّينِ 4﴾</span>: آن روز قیامت است.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001005.mp3"></audio> 5- <span class="c4">﴿إِيَّاكَ نَعْبُدُ وَإِيَّاكَ نَسْتَعِينُ 5﴾</span> <br /> یعنی: تنها تو را می پرستیم و تنها از تو یاری می جوییم.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001006.mp3"></audio> 6- <span class="c4">﴿اهْدِنَا الصِّرَاطَ الْمُسْتَقِيمَ 6﴾</span>: <br /> و آن هدایت به سوی اسلام و سنت است.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001007.mp3"></audio> 7- <span class="c4">﴿صِرَاطَ الَّذِينَ أَنْعَمْتَ عَلَيْهِمْ غَيْرِ الْمَغْضُوبِ عَلَيْهِمْ وَلَا الضَّالِّينَ 7﴾</span> یعنی راه بندگان صالح الله از پیامبران و کسانی که از آنها پیروی کردند، نه راه نصارا و یهود.<span class="c6"><br /> سنت است که بعد از خواندن آن بگوید:</span> <span class="c2">(آمین)</span> یعنی: استجابت کن برای ما. </p>',
            ],
            1 => [
                'question' => 'س 2: سوره زلزله را بخوانید و تفسیر کنید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7130.mp3',
                'answer' => '<p> ج-<span class="c6"> سوره زلزله و تفسیر آن:</span><br /> بِسۡمِ ٱللَّهِ ٱلرَّحۡمَـٰنِ ٱلرَّحِمِ <br /> بنام الله بخشاینده و مهربان<br /> ﴿إِذَا زُلْزِلَتِ الْأَرْضُ زِلْزَالَهَا 1<br /> آنگاه كه زمين به لرزش <span class="c5">[شديد]</span> خود لرزانيده شود <span class="c2">(۱)</span> وَأَخْرَجَتِ الْأَرْضُ أَثْقَالَهَا 2<br /> و زمين بارهاى سنگين خود را بيرون افكند <span class="c2">(۲)</span> وَقَالَ الْإِنْسَانُ مَا لَهَا 3<br /> و انسان گويد <span class="c5">[زمين]</span> را چه شده است <span class="c2">(۳)</span> يَوْمَئِذٍ تُحَدِّثُ أَخْبَارَهَا 4<br /> آن روز است كه <span class="c5">[زمين]</span> خبرهاى خود را باز گويد <span class="c2">(۴)</span> بِأَنَّ رَبَّكَ أَوْحَى لَهَا 5<br /> <span class="c5">[همان گونه]</span> كه پروردگارت بدان وحى كرده است <span class="c2">(۵)</span> يَوْمَئِذٍ يَصْدُرُ النَّاسُ أَشْتَاتًا لِيُرَوْا أَعْمَالَهُمْ 6<br /> آن روز مردم <span class="c5">[به حال]</span> پراكنده برآيند تا <span class="c5">[نتيجه]</span> كارهايشان به آنان نشان داده شود <span class="c2">(۶)</span> فَمَنْ يَعْمَلْ مِثْقَالَ ذَرَّةٍ خَيْرًا يَرَهُ 7<br /> پس هر كه هموزن ذره‏ اى نيكى كند <span class="c5">[نتيجه]</span> آن را خواهد ديد <span class="c2">(۷)</span> وَمَنْ يَعْمَلْ مِثْقَالَ ذَرَّةٍ شَرًّا يَرَهُ 8﴾<br /> و هر كه هموزن ذره‏ اى بدى كند <span class="c5">[نتيجه]</span> آن را خواهد ديد <span class="c2">(۸)</span> <span class="c5">[سورة الزلزلة: 1 - 8]</span>.<span class="c6">بيا<br /> تفسير:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099001.mp3"></audio> 1- <span class="c4">﴿إِذَا زُلْزِلَتِ الْأَرْضُ زِلْزَالَهَا 1﴾</span>: هرگاه زمین حرکت کند حرکت شدیدی که در قیامت برای آن اتفاق می افتد.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099002.mp3"></audio> 2- <span class="c4">﴿وَأَخْرَجَتِ الْأَرْضُ أَثْقَالَهَا 2﴾</span>: و زمین آنچه را که در شکمش بود از مردگان و دیگران بیرون آورد.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099003.mp3"></audio> 3- <span class="c4">﴿وَقَالَ الْإِنْسَانُ مَا لَهَا 3﴾</span>: و انسان در حال حیرت گفت: چه شد که زمین متحرک و آشفته شد.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099004.mp3"></audio> 4- <span class="c4">﴿يَوْمَئِذٍ تُحَدِّثُ أَخْبَارَهَا 4﴾</span>: در آن روز بزرگ، زمین از خوبی ها و بدی هایی که در آن صورت گرفته است خبر می دهد.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099005.mp3"></audio> 5- <span class="c4">﴿بِأَنَّ رَبَّكَ أَوْحَى لَهَا 5﴾</span>: چون الله متعال برایش آموخت و به آن امر نمود.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099006.mp3"></audio> 6- <span class="c4">﴿يَوْمَئِذٍ يَصْدُرُ النَّاسُ أَشْتَاتًا لِيُرَوْا أَعْمَالَهُمْ 6﴾</span>: در آن روز بزرگ که زمین می لرزد، مردم از موقف حساب بشکل گروهی بیرون می آیند، برای دیدن اعمالی که در دنیا انجام داده اند.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099007.mp3"></audio> 7- <span class="c4">﴿فَمَنْ يَعْمَلْ مِثْقَالَ ذَرَّةٍ خَيْرًا يَرَهُ 7﴾</span>: هر که به وزن مورچۀ کوچک عمل کند از اعمال نیک و صالح؛ آن را می ببیند.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099008.mp3"></audio> 8- <span class="c4">﴿وَمَنْ يَعْمَلْ مِثْقَالَ ذَرَّةٍ شَرًّا يَرَهُ 8﴾</span>: هر که به وزن آن عمل زشت انجام دهد؛ آن را می ببیند. </p>',
            ],
            2 => [
                'question' => 'س 3: سورۀ عادیات را تلاوت و تفسیر کنید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7270.mp3',
                'answer' => '<p> ج-<span class="c6"> سوره عاديات و تفسير آن:</span><br /> بِسۡمِ ٱللَّهِ ٱلرَّحۡمَـٰنِ ٱلرَّحِمِ<br /> بنام الله بخشاینده و مهربان<br /> ﴿وَالْعَادِيَاتِ ضَبْحًا 1<br /> سوگند به اسبان تيز تك <span class="c5">[جهادگر]</span> كه نفس نفس مى ‏زنند<span class="c2">(۱)</span> فَالْمُورِيَاتِ قَدْحًا 2<br /> و سوگند به آنها <span class="c2">(كه بر اثر برخورد سمشان به سنگهاي بيابان)</span> جرقه‏ هاي آتش افروختند. <span class="c2">(۲)</span> فَالْمُغِيرَاتِ صُبْحًا 3<br /> و با دميدن صبح بر دشمن يورش بردند. <span class="c2">(۳)</span> فَأَثَرْنَ بِهِ نَقْعًا 4<br /> و با آن <span class="c5">[يورش]</span> گردى برانگيزند <span class="c2">(۴)</span> فَوَسَطْنَ بِهِ جَمْعًا 5<br /> و <span class="c2">(ناگهان)</span> در ميان دشمن ظاهر شدند. <span class="c2">(۵)</span> إِنَّ الْإِنْسَانَ لِرَبِّهِ لَكَنُودٌ 6<br /> كه انسان نسبت به پروردگارش سخت ناسپاس است <span class="c2">(۶)</span> وَإِنَّهُ عَلَى ذَلِكَ لَشَهِيدٌ 7<br /> و او خود بر اين <span class="c5">[امر]</span> نيك گواه است <span class="c2">(۷)</span> وَإِنَّهُ لِحُبِّ الْخَيْرِ لَشَدِيدٌ 8<br /> و راستى او سخت‏ شيفته مال است <span class="c2">(۸)</span> أَفَلَا يَعْلَمُ إِذَا بُعْثِرَ مَا فِي الْقُبُورِ 9<br /> مگر نمى‏ داند كه چون آنچه در گورهاست بيرون ريخته گردد <span class="c2">(۹)</span> وَحُصِّلَ مَا فِي الصُّدُورِ 10<br /> و آنچه در سينه‏ هاست فاش شود <span class="c2">(۱۰)</span> إِنَّ رَبَّهُمْ بِهِمْ يَوْمَئِذٍ لَخَبِيرٌ 11﴾<br /> در چنان روزى پروردگارشان به <span class="c5">[حال]</span> ايشان نيك آگاه است <span class="c2">(۱۱)</span> <span class="c5">[سورة العاديات: ١ - ١١]</span>.<span class="c6"><br /> تفسير:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100001.mp3"></audio> ١- <span class="c4">﴿وَالْعَادِيَاتِ ضَبْحًا 1﴾</span>: الله سوگند یاد می کند به اسبانی که می دوند تا صدای نفس های شان از شدت دویدن شنیده شود.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100002.mp3"></audio> ٢- <span class="c4">﴿فَالْمُورِيَاتِ قَدْحًا 2﴾</span>: او به اسب‌هایی سوگند یاد می‌کند که هرگاه نال های شان به صخره‌ها برخورد کنند آتش می‌افروزند، از شدت ضربه‌شان که بر آنها می‌خورد.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100003.mp3"></audio> ٣- <span class="c4">﴿فَالْمُغِيرَاتِ صُبْحًا 3﴾</span>: و سوگند یاد می کند به اسبانی که صبح بر دشمنان می تازند.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100004.mp3"></audio> ٤- <span class="c4">﴿فَأَثَرْنَ بِهِ نَقْعًا 4﴾</span>: با دویدن خود گرد و خاک را در حرکت آوردند.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100005.mp3"></audio> ٥- <span class="c4">﴿فَوَسَطْنَ بِهِ جَمْعًا 5﴾</span>: پس توسط اسب های خود سپاه دشمن در میان گرفتند.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100006.mp3"></audio> ٦- <span class="c4">﴿إِنَّ الْإِنْسَانَ لِرَبِّهِ لَكَنُودٌ 6﴾</span>: انسان مانع خیری می شود که پروردگارش از او می خواهد.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100007.mp3"></audio> ٧- <span class="c4">﴿وَإِنَّهُ عَلَى ذَلِكَ لَشَهِيدٌ 7﴾</span>: و او برای مانع خیر گواه است، به دلیل روشن بودن آن نمی تواند آن را انکار کند.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100008.mp3"></audio> ٨- <span class="c4">﴿وَإِنَّهُ لِحُبِّ الْخَيْرِ لَشَدِيدٌ 8﴾</span>: و این که او به سبب محبت بیش از حد به مال در آن بخیلی می کند.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100009.mp3"></audio> ٩- <span class="c4">﴿أَفَلَا يَعْلَمُ إِذَا بُعْثِرَ مَا فِي الْقُبُورِ 9﴾</span>: پس آیا انسان فریب خورده به این زندگانی دنیوی نمی‌داند که هرگاه الله مردگان را از قبر بیرون کند و آنان را برای محاسبه و جزا از زمین بیرون بیاورد موضوع آنچه او گمان می کرد نخواهد بود؟<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100010.mp3"></audio> ١٠- <span class="c4">﴿وَحُصِّلَ مَا فِي الصُّدُورِ 10﴾</span>: آنچه را که در دل از نیت ها و عقاید و غیره است برجسته و روشن شدند.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100011.mp3"></audio> ١١- <span class="c4">﴿إِنَّ رَبَّهُمْ بِهِمْ يَوْمَئِذٍ لَخَبِيرٌ 11﴾</span>: یقینا آن روز پروردگارشان از آنها کاملا آگاه است، هیچ کاری از بندگانش بر وی پوشیده نیست، و بر اساس آن به آنها پاداش و یا مجازات می دهد. </p>',
            ],
            3 => [
                'question' => 'س4: سورۀ قارعه را تلاوت و تفسیر کنید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7450.mp3',
                'answer' => '<p> ج-<span class="c6"> سورۀ قارعه و تفسیر آن:</span><br /> بِسۡمِ ٱللَّهِ ٱلرَّحۡمَـٰنِ ٱلرَّحِمِ<br /> بنام الله بخشاینده و مهربان<br /> ﴿الْقَارِعَةُ 1<br /> كوبنده <span class="c2">(۱)</span> مَا الْقَارِعَةُ 2<br /> چيست كوبنده <span class="c2">(۲)</span> وَمَا أَدْرَاكَ مَا الْقَارِعَةُ 3<br /> و تو چه دانى كه كوبنده چيست <span class="c2">(۳)</span> يَوْمَ يَكُونُ النَّاسُ كَالْفَرَاشِ الْمَبْثُوثِ 4<br /> روزى كه مردم چون پروانه<span class="c5">[هاى]</span> پراكنده گردند <span class="c2">(۴)</span> وَتَكُونُ الْجِبَالُ كَالْعِهْنِ الْمَنْفُوشِ 5<br /> و كوه ‏ها مانند پشم زده‏ شده رنگين شود <span class="c2">(۵)</span> فَأَمَّا مَنْ ثَقُلَتْ مَوَازِينُهُ 6<br /> اما هر كه ترازوی اعمالش سنگين برآيد <span class="c2">(۶)</span> فَهُوَ فِي عِيشَةٍ رَاضِيَةٍ 7<br /> پس وى در زندگى خوشى خواهد بود <span class="c2">(۷)</span> وَأَمَّا مَنْ خَفَّتْ مَوَازِينُهُ 8<br /> و اما هر كه ترازوی اعمالش سبك بر آيد <span class="c2">(۸)</span> فَأُمُّهُ هَاوِيَةٌ 9<br /> پس جايش هاويه باشد <span class="c2">(۹)</span> وَمَا أَدْرَاكَ مَا هِيَهْ 10<br /> و تو چه دانى كه آن چيست <span class="c2">(۱۰)</span> نَارٌ حَامِيَةٌ 11﴾<br /> آتشى است‏ سوزنده <span class="c2">(۱۱)</span> <span class="c5">[سورة القارعة: ١ - ١١]</span>.<span class="c6"><br /> تفسير:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101001.mp3"></audio> ١- <span class="c4">﴿الْقَارِعَةُ 1﴾</span>: ساعتی بنابر عظمت و وحشت دل های مردم را می کوبد.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101002.mp3"></audio> ٢- <span class="c4">﴿مَا الْقَارِعَةُ 2﴾</span>: این چه ساعتی است که دل مردم را از وحشت می کوبد؟!<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101003.mp3"></audio> ٣- <span class="c4">﴿وَمَا أَدْرَاكَ مَا الْقَارِعَةُ 3﴾</span>: و چه می دانی - ای پیامبر- این چه ساعتی است که از عظمت وحشتش دل مردم را می کوبد؟! آن روز قیامت است.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101004.mp3"></audio> ٤- <span class="c4">﴿يَوْمَ يَكُونُ النَّاسُ كَالْفَرَاشِ الْمَبْثُوثِ 4﴾</span>: روزی که دلهای مردم به تپش بیفتد، مانند پروانۀ پراکنده و منتشر شده اینجا و آنجا.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101005.mp3"></audio> ٥- <span class="c4">﴿وَتَكُونُ الْجِبَالُ كَالْعِهْنِ الْمَنْفُوشِ5﴾</span>: کوه ها در سبکی و حرکتشان مانند پشم غلتانده و تکانده شده می باشند.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101006.mp3"></audio> ٦- <span class="c4">﴿فَأَمَّا مَنْ ثَقُلَتْ مَوَازِينُهُ 6﴾</span>: و اما کسانی که حسناتشان بر اعمال بدشان بیشتر است.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101007.mp3"></audio> ٧- <span class="c4">﴿فَهُوَ فِي عِيشَةٍ رَاضِيَةٍ 7﴾</span>: او در زندگی رضایت بخشی در بهشت می باشد.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101008.mp3"></audio> ٨- <span class="c4">﴿وَأَمَّا مَنْ خَفَّتْ مَوَازِينُهُ 8﴾</span>: و اما کسی اعمال بد او بر اعمال نیک او بیشتر باشد.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101009.mp3"></audio> ٩- <span class="c4">﴿فَأُمُّهُ هَاوِيَةٌ 9﴾</span>: جایگاه و آرامگاه او در روز قیامت جهنم است.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101010.mp3"></audio> ١٠- <span class="c4">﴿وَمَا أَدْرَاكَ مَا هِيَهْ 10﴾</span>: و تو چه می دانی – ای پیامبر- که آن چه است؟<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101011.mp3"></audio> ١١- <span class="c4">﴿نَارٌ حَامِيَةٌ 11﴾</span>: آتش بسیار داغی است. </p>',
            ],
            4 => [
                'question' => 'س5: سوره تکاثر را تلاوت و تفسیر کنید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7610.mp3',
                'answer' => '<p> ج/ -<span class="c6"> سورۀ تکاثر و تفسیر آن:</span><br /> بِسۡمِ ٱللَّهِ ٱلرَّحۡمَـٰنِ ٱلرَّحِمِ<br /> بنام الله بخشاينده و مهربان<br /> ﴿أَلْهَاكُمُ التَّكَاثُرُ 1<br /> تفاخر به بيشتر داشتن شما را غافل داشت <span class="c2">(1)</span> حَتَّى زُرْتُمُ الْمَقَابِرَ 2<br /> تا اینکه مُردید و وارد قبرهای‌تان شدید كَلَّا سَوْفَ تَعْلَمُونَ 3<br /> نه چنين است زودا كه بدانيد <span class="c2">(۳)</span> ثُمَّ كَلَّا سَوْفَ تَعْلَمُونَ 4<br /> باز هم نه چنين است زودا كه بدانيد <span class="c2">(۴)</span> كَلَّا لَوْ تَعْلَمُونَ عِلْمَ الْيَقِينِ 5<br /> هرگز چنين نيست اگر علم ‏اليقين داشتيد <span class="c2">(۵)</span> لَتَرَوُنَّ الْجَحِيمَ 6<br /> به يقين دوزخ را مى ‏بينيد <span class="c2">(۶)</span> ثُمَّ لَتَرَوُنَّهَا عَيْنَ الْيَقِينِ 7<br /> سپس آن را قطعا به عين ‏اليقين درمى‏ يابيد <span class="c2">(۷)</span> ثُمَّ لَتُسْأَلُنَّ يَوْمَئِذٍ عَنِ النَّعِيمِ﴾<br /> سپس در همان روز است كه از نعمت <span class="c5">[روى زمين]</span> پرسيده خواهيد شد <span class="c2">(۸)</span> <span class="c5">[سورة التكاثر: ١ - ٨]</span>.<span class="c6"><br /> تفسير:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102001.mp3"></audio> ١- <span class="c4">﴿أَلْهَاكُمُ التَّكَاثُرُ 1﴾</span>: شغل شما - ای مردم - به جای اطاعت از الله، افتخار به دارایی و فرزندان است.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102002.mp3"></audio> ٢- <span class="c4">﴿حَتَّى زُرْتُمُ الْمَقَابِرَ 2﴾</span>: تا اینکه وفات نمودید و وارد قبرت شدید.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102003.mp3"></audio> ٣- <span class="c4">﴿كَلَّا سَوْفَ تَعْلَمُونَ 3﴾</span>: فخر فروشی شما را از اطاعت الله مشغول نکند، زود است که عاقبت آن مشغله را بدانید.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102004.mp3"></audio> ٤- <span class="c4">﴿ثُمَّ كَلَّا سَوْفَ تَعْلَمُونَ 4﴾</span>: سپس زود است عاقبت آن را بدانید.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102005.mp3"></audio> ٥- <span class="c4">﴿كَلَّا لَوْ تَعْلَمُونَ عِلْمَ الْيَقِينِ 5﴾</span>: همانا اگر به یقین بدانید که به سوی الله برانگیخته می شوید و او جزای اعمال تانرا به شما می دهد، به فخر فروشی به دارایی و فرزند مشغول نمی شدید.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102006.mp3"></audio> ٦- <span class="c4">﴿لَتَرَوُنَّ الْجَحِيمَ 6﴾</span>: به الله سوگند در روز قیامت آتش را خواهید دید.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102007.mp3"></audio> ٧- <span class="c4">﴿ثُمَّ لَتَرَوُنَّهَا عَيْنَ الْيَقِينِ 7﴾</span>: سپس آن را به شکل یقینی و بدون شک مشاهده می کنید.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102008.mp3"></audio> ٨- <span class="c4">﴿ثُمَّ لَتُسْأَلُنَّ يَوْمَئِذٍ عَنِ النَّعِيمِ﴾</span>: سپس الله در آن روز از شما خواهد پرسید، از سلامتی، مال و چیزهای دیگر که به شما ارزانی داشته است. </p>',
            ],
            5 => [
                'question' => 'س6: سورۀ عصر را تلاوت و آن را تفسیر نمایید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7750.mp3',
                'answer' => '<p> ج-<span class="c6"> سورۀ عصر و تفسیر آن:</span><br /> بِسۡمِ ٱللَّهِ ٱلرَّحۡمَـٰنِ ٱلرَّحِمِ<br /> بنام الله بخشاينده ومهربان<br /> ﴿وَالْعَصْرِ 1<br /> سوگند به عصر <span class="c2">(۱)</span> إِنَّ الْإِنْسَانَ لَفِي خُسْرٍ 2<br /> كه واقعا انسان دستخوش زيان است <span class="c2">(۲)</span> إِلَّا الَّذِينَ آمَنُوا وَعَمِلُوا الصَّالِحَاتِ وَتَوَاصَوْا بِالْحَقِّ وَتَوَاصَوْا بِالصَّبْرِ 3﴾<br /> مگر كسانى كه ایمان آورده اند و كارهاى شايسته كرده و همديگر را به حق سفارش و به شكيبايى توصيه كرده‏ اند <span class="c2">(۳)</span> <span class="c5">[سورة العصر: 1 - 3]</span>.<span class="c6"><br /> تفسير:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/103001.mp3"></audio> 1- <span class="c4">﴿وَالْعَصْرِ 1﴾</span>: الله متعال به زمان سوگند یاد نمود.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/103002.mp3"></audio> 2- <span class="c4">﴿إِنَّ الْإِنْسَانَ لَفِي خُسْرٍ 2﴾</span>: یعنی: همه انسانها در حال نقصان و زیان هستند.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/103003.mp3"></audio> 3- <span class="c4">﴿إِلَّا الَّذِينَ آمَنُوا وَعَمِلُوا الصَّالِحَاتِ وَتَوَاصَوْا بِالْحَقِّ وَتَوَاصَوْا بِالصَّبْرِ 3﴾</span>: مگر كسانى كه ايمان آوردند و كارهاى شايسته انجام دادند و به سوى حق دعوت كردند و بر آن شكيبايى كردند، آنها از خسارت در امان هستند. </p>',
            ],
            6 => [
                'question' => 'س 7: سورۀ همزه را تلاوت و تفسیر نمایید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7830.mp3',
                'answer' => '<p> ج-<span class="c6"> سورۀ همزه و تفسیر آن:</span><br /> بِسۡمِ ٱللَّهِ ٱلرَّحۡمَـٰنِ ٱلرَّحِمِ<br /> بنام الله بخشاينده و مهربان<br /> ﴿وَيْلٌ لِكُلِّ هُمَزَةٍ لُمَزَةٍ 1<br /> واى بر هر بدگوى عيبجوی <span class="c2">(۱)</span> الَّذِي جَمَعَ مَالًا وَعَدَّدَهُ 2<br /> همان كس كه مال را جمع آوری و شماره كرده <span class="c2">(۲)</span> يَحْسَبُ أَنَّ مَالَهُ أَخْلَدَهُ 3<br /> پندارد كه مالش او را جاويد كرده <span class="c2">(۳)</span> كَلَّا لَيُنْبَذَنَّ فِي الْحُطَمَةِ 4<br /> چنين نيست كه او مي‏پندارد، به زودي در آتش خرد كننده پرتاب مي‏شود <span class="c2">(۴)</span> وَمَا أَدْرَاكَ مَا الْحُطَمَةُ 5<br /> و تو چه دانى كه آن آتش خردكننده چيست <span class="c2">(۵)</span> نَارُ اللَّهِ الْمُوقَدَةُ 6<br /> به‌راستی‌که آتشِ افروختۀ الله است. الَّتِي تَطَّلِعُ عَلَى الْأَفْئِدَةِ 7<br /> <span class="c5">[آتشى]</span> كه به دلها مى ‏رسد <span class="c2">(۷)</span> إِنَّهَا عَلَيْهِمْ مُؤْصَدَةٌ 8<br /> به‌راستی‌که آن آتش، کسانی را که در آن عذاب می‌شوند، از هر طرف محاصره ‌کرده است. <br /> <span class="c2">(۸)</span> فِي عَمَدٍ مُمَدَّدَةٍ 9﴾<br /> در ستونهای كشيده و طولانی! <span class="c2">(۹)</span> <span class="c5">[سورة الهمزة: ١ - ٩]</span>.<span class="c6"><br /> تفسير:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104001.mp3"></audio> ١- <span class="c4">﴿وَيْلٌ لِكُلِّ هُمَزَةٍ لُمَزَةٍ 1﴾</span>: عذاب بد و سخت برای غیبت کنندگان زیاد و طعن به آنان.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104002.mp3"></audio> ٢- <span class="c4">﴿الَّذِي جَمَعَ مَالًا وَعَدَّدَهُ 2﴾</span>: کسی که به فکر جمع آوری و شمارش مال است، و دغدغه دیگری ندارد.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104003.mp3"></audio> ٣- <span class="c4">﴿يَحْسَبُ أَنَّ مَالَهُ أَخْلَدَهُ 3﴾</span>: او فکر می کند مالی را که جمع کرده او را از مرگ نجات می دهد، و در زندگی این دنیا جاودانه می ماند.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104004.mp3"></audio> ٤- <span class="c4">﴿كَلَّا لَيُنْبَذَنَّ فِي الْحُطَمَةِ 4﴾</span>: چنان نیست که این جاهل تصور می کرد، در آتش جهنم افکنده می شود و هر چیزی که در آن افکنده شود از شدت نیرو ریز شده و می شکند.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104005.mp3"></audio> ٥- <span class="c4">﴿وَمَا أَدْرَاكَ مَا الْحُطَمَةُ 5﴾</span>: و تو چه دانی - ای رسول - این چه آتشی است که هر چه در آن افکنده شود نابود می کند؟!<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104006.mp3"></audio> ٦- <span class="c4">﴿نَارُ اللَّهِ الْمُوقَدَةُ 6﴾</span>: آتش خروشان الله است.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104007.mp3"></audio> ٧- <span class="c4">﴿الَّتِي تَطَّلِعُ عَلَى الْأَفْئِدَةِ 7﴾</span>: که از بدن مردم تا قلبشان نفوذ می کند.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104008.mp3"></audio> ٨- <span class="c4">﴿إِنَّهَا عَلَيْهِمْ مُؤْصَدَةٌ 8﴾</span>: به روی عذاب دیده ها بسته است.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104009.mp3"></audio> ٩- <span class="c4">﴿فِي عَمَدٍ مُمَدَّدَةٍ 9﴾</span>: با کشش طولانی، تا از آن خارج نشوید. </p>',
            ],
            7 => [
                'question' => 'س 8: سوره فیل را تلاوت نموده و آن را تفسیر نمایید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7970.mp3',
                'answer' => '<p> ج-<span class="c6"> سوره فیل و تفسیر آن:</span><br /> بِسۡمِ ٱللَّهِ ٱلرَّحۡمَـٰنِ ٱلرَّحِمِ<br /> بنام الله بخشاینده و مهربان<br /> ﴿أَلَمْ تَرَ كَيْفَ فَعَلَ رَبُّكَ بِأَصْحَابِ الْفِيلِ 1<br /> مگر نديدى پروردگارت با اصحاب فیل چه كرد <span class="c2">(۱)</span> أَلَمْ يَجْعَلْ كَيْدَهُمْ فِي تَضْلِيلٍ 2<br /> آيا نيرنگشان را بر باد نداد <span class="c2">(۲)</span> وَأَرْسَلَ عَلَيْهِمْ طَيْرًا أَبَابِيلَ 3<br /> و بر سر آنها دسته دسته پرندگانى ابابيل فرستاد <span class="c2">(۳)</span> تَرْمِيهِمْ بِحِجَارَةٍ مِنْ سِجِّيلٍ 4<br /> <span class="c5">[كه]</span> بر آنان سنگهايى از گل <span class="c5">[سخت]</span> مى‏ افكندند <span class="c2">(۴)</span> فَجَعَلَهُمْ كَعَصْفٍ مَأْكُولٍ 5﴾<br /> و آنان را مانند كاه جويده‏ شده گردانيد <span class="c2">(۵)</span> <span class="c5">[سورة الفيل: ١ - ٥]</span>.<span class="c6"><br /> تفسير:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105001.mp3"></audio> ١- <span class="c4">﴿أَلَمْ تَرَ كَيْفَ فَعَلَ رَبُّكَ بِأَصْحَابِ الْفِيلِ 1﴾</span>: آیا نمی‌دانستی – ای رسول - پروردگارت با ابرهه و اصحاب فیل که می‌خواستند کعبه را ویران کنند، چگونه رفتار کرد؟!<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105002.mp3"></audio> ٢- <span class="c4">﴿أَلَمْ يَجْعَلْ كَيْدَهُمْ فِي تَضْلِيلٍ 2﴾</span>: الله نقشه بد آنها را برای از بین بردن آن ضایع نمود، پس آنچه آرزو داشتند بدست نیاورند از قبیل برگرداندن مردم از کعبه، و نتوانستند به آن آسیب برسانند.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105003.mp3"></audio> ٣- <span class="c4">﴿وَأَرْسَلَ عَلَيْهِمْ طَيْرًا أَبَابِيلَ 3﴾</span>: و پرندگانی را بر آنان فرستاد و دسته دسته نزد آنان آمدند.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105004.mp3"></audio> ٤- <span class="c4">﴿تَرْمِيهِمْ بِحِجَارَةٍ مِنْ سِجِّيلٍ 4﴾</span>: به سمت اونها سنگ پرتاب می کردند که از خاک آتشین ساخته شده بود.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105005.mp3"></audio> ٥- <span class="c4">﴿فَجَعَلَهُمْ كَعَصْفٍ مَأْكُولٍ 5﴾</span>: پس الله متعال آنها را مانند برگهای زرع شده قرار داد که توسط چارپایان خورده و پایمال شده باشد. </p>',
            ],
            8 => [
                'question' => 'س 9: سوره قریش را تلاوت و تفسیر نمایید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8070.mp3',
                'answer' => '<p> ج-<span class="c6"> سوره قریش و تفسیر آن:</span><br /> بِسۡمِ ٱللَّهِ ٱلرَّحۡمَـٰنِ ٱلرَّحِمِ<br /> بنام الله بخشایندۀ و مهربان<br /> ﴿لِإِيلَافِ قُرَيْشٍ 1<br /> براى الفت‏ دادن قريش <span class="c2">(۱)</span> إِيلَافِهِمْ رِحْلَةَ الشِّتَاءِ وَالصَّيْفِ 2<br /> الفتشان هنگام كوچ زمستان و تابستان <span class="c2">(۲)</span> فَلْيَعْبُدُوا رَبَّ هَذَا الْبَيْتِ 3<br /> پس بايد پروردگار اين خانه را بپرستند <span class="c2">(۳)</span> الَّذِي أَطْعَمَهُمْ مِنْ جُوعٍ وَآمَنَهُمْ مِنْ خَوْفٍ 4﴾<br /> همان كه در گرسنگى غذايشان داد و از بيم آسوده ‏خاطرشان كرد <span class="c2">(۴)</span> <span class="c5">[سورة قريش: ١ - ٤]</span>.<span class="c6"><br /> تفسير:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106001.mp3"></audio> ١- <span class="c4">﴿لِإِيلَافِ قُرَيْشٍ 1﴾</span>: منظور این است که اونها آنچه از سفر در زمستان و تابستان علاقمند بودند.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106002.mp3"></audio> ٢- <span class="c4">﴿إِيلَافِهِمْ رِحْلَةَ الشِّتَاءِ وَالصَّيْفِ 2﴾</span>: سفر زمستانی به یمن و سفر تابستانی به شام بطور امن.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106003.mp3"></audio> ٣- <span class="c4">﴿فَلْيَعْبُدُوا رَبَّ هَذَا الْبَيْتِ 3﴾</span>: پس الله را بپرستند که تنها پروردگار این بیت الله الحرام است، که این سفر را برایشان آسان کرد و کسی را شریک او قرار ندهند.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106004.mp3"></audio> ٤- <span class="c4">﴿الَّذِي أَطْعَمَهُمْ مِنْ جُوعٍ وَآمَنَهُمْ مِنْ خَوْفٍ 4﴾</span>: ذاتی که آنها را از گرسنگی سیر کرد و از ترس ایمن ساخت، به سبب آنچه در دل عرب ها از حرمت حرم، و حرمت اهل آن نهاده شد. </p>',
            ],
            9 => [
                'question' => 'س10: سوره ماعون را تلاوت و تفسیر نمایید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8160.mp3',
                'answer' => '<p> ج: سوره ماعون و تفسیر آن:<br /> بِسۡمِ ٱللَّهِ ٱلرَّحۡمَـٰنِ ٱلرَّحِمِ <br /> بنام الله بخشاینده و مهربان<br /> ﴿أَرَأَيْتَ الَّذِي يُكَذِّبُ بِالدِّينِ 1<br /> آيا كسى را كه <span class="c5">[روز]</span> جزا را دروغ مى‏ خواند ديدى <span class="c2">(۱)</span> فَذَلِكَ الَّذِي يَدُعُّ الْيَتِيمَ 2<br /> اين همان كس است كه يتيم را به سختى مى ‏راند <span class="c2">(۲)</span> وَلَا يَحُضُّ عَلَى طَعَامِ الْمِسْكِينِ 3<br /> و به خوراك‏ دادن بينوا ترغيب نمى ‏كند <span class="c2">(۳)</span> فَوَيْلٌ لِلْمُصَلِّينَ 4<br /> پس واى بر نمازگزارانى <span class="c2">(۴)</span> الَّذِينَ هُمْ عَنْ صَلَاتِهِمْ سَاهُونَ 5<br /> كه از نمازشان غافلند <span class="c2">(۵)</span> الَّذِينَ هُمْ يُرَاءُونَ 6<br /> آنان كه ريا مى كنند <span class="c2">(۶)</span> وَيَمْنَعُونَ الْمَاعُونَ 7﴾<br /> و <span class="c2">(از پرداخت زکات و)</span> عاریت دادن وسایل ضروری زندگی دریغ می‌ورزند <span class="c2">(۷)</span> <span class="c5">[سورة الماعون: ١ - ٧]</span>.<span class="c6"><br /> تفسير:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107001.mp3"></audio> ١- <span class="c4">﴿أَرَأَيْتَ الَّذِي يُكَذِّبُ بِالدِّينِ 1﴾</span>: آیا می دانستی چه کسی جزای روز قیامت را تکذیب می کند؟!<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107002.mp3"></audio> ٢- <span class="c4">﴿فَذَلِكَ الَّذِي يَدُعُّ الْيَتِيمَ 2﴾</span>: آن کسی است که یتیم را از حاجتش با خشونت دفع می کند.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107003.mp3"></audio> ٣- <span class="c4">﴿وَلَا يَحُضُّ عَلَى طَعَامِ الْمِسْكِينِ 3﴾</span>: نه خود را و نه دیگران را به اطعام مساکین ترغیب می کند.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107004.mp3"></audio> ٤- <span class="c4">﴿فَوَيْلٌ لِلْمُصَلِّينَ 4﴾</span>: هلاکت و عذاب بر نمازگزاران.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107005.mp3"></audio> ٥- <span class="c4">﴿الَّذِينَ هُمْ عَنْ صَلَاتِهِمْ سَاهُونَ 5﴾</span>: کسانی که در نمازهای خود سهل انگاری می کردند، و به آن اهمیتی نمی دادند تا این که وقت آن تمام می شد.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107006.mp3"></audio> ٦- <span class="c4">﴿الَّذِينَ هُمْ يُرَاءُونَ 6﴾</span>: کسانی که با نماز و اعمال خود خودنمایی می نمودند، و آن را برای الله انجام نمی دادند.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107007.mp3"></audio> ٧- <span class="c4">﴿وَيَمْنَعُونَ الْمَاعُونَ 7﴾</span>: و دیگران را از همکاری مانع می شدند، بدون این که در کمک کردن به او ضرر متوجه نشود. </p>',
            ],
            10 => [
                'question' => 'س 11: سورۀ کوثر را تلاوت و تفسیر نمایید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8280.mp3',
                'answer' => '<p> ج: سورۀ کوثر و تفسیر آن:<br /> بِسۡمِ ٱللَّهِ ٱلرَّحۡمَـٰنِ ٱلرَّحِيمِ<br /> بنام الله بخشاینده و مهربان<br /> ﴿إِنَّا أَعْطَيْنَاكَ الْكَوْثَرَ 1<br /> ما تو را <span class="c5">[چشمه]</span> كوثر داديم <span class="c2">(۱)</span> فَصَلِّ لِرَبِّكَ وَانْحَرْ 2<br /> پس براى پروردگارت نماز گزار و قربانى كن <span class="c2">(۲)</span> إِنَّ شَانِئَكَ هُوَ الْأَبْتَرُ 3﴾<br /> که محققا دشمن تو مقطوع النسل است <span class="c5">[سورة الكوثر: ١- ٣]</span>.<span class="c6"><br /> تفسير:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/108001.mp3"></audio> ١- <span class="c4">﴿إِنَّا أَعْطَيْنَاكَ الْكَوْثَرَ 1﴾</span>: ما به تو - ای رسول - خیر بسیار می دهیم و از آن نهر الکوثر در بهشت است.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/108002.mp3"></audio> ٢- <span class="c4">﴿فَصَلِّ لِرَبِّكَ وَانْحَرْ 2﴾</span>: پس الله را به خاطر این نعمت سپاس گذاری کن، تنها برای او نماز را ادا نموده و تنها برای او ذبح کن، بر خلاف آنچه مشرکان از طریق ذبح به بت های خود خود را به آنها نزدیک می سازند.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/108003.mp3"></audio> ٣- <span class="c4">﴿إِنَّ شَانِئَكَ هُوَ الْأَبْتَرُ 3﴾</span>: کسی که از تو متنفر است کسی است که از همه خوبی های فراموش شده و بریده شده است، اگر یاد شود به بدی یاد می شود. </p>',
            ],
            11 => [
                'question' => 'س12: سورۀ کافرون را تلاوت و تفسیر نمایید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8360.mp3',
                'answer' => '<p> ج: سوره کافرون و تفسیر آن:<br /> بِسۡمِ ٱللَّهِ ٱلرَّحۡمَـٰنِ ٱلرَّحِيمِ<br /> بنام الله بخشاينده و مهربان<br /> ﴿قُلْ يَا أَيُّهَا الْكَافِرُونَ 1<br /> بگو اى كافران <span class="c2">(۱)</span> لَا أَعْبُدُ مَا تَعْبُدُونَ 2<br /> آنچه مى ‏پرستيد نمى ‏پرستم <span class="c2">(۲)</span> وَلَا أَنْتُمْ عَابِدُونَ مَا أَعْبُدُ 3<br /> و آنچه مى ‏پرستم شما نمى ‏پرستيد <span class="c2">(۳)</span> وَلَا أَنَا عَابِدٌ مَا عَبَدْتُمْ 4<br /> و نه آنچه پرستيديد من مى ‏پرستم <span class="c2">(۴)</span> وَلَا أَنْتُمْ عَابِدُونَ مَا أَعْبُدُ 5<br /> و نه آنچه مى ‏پرستم شما مى ‏پرستيد <span class="c2">(۵)</span> لَكُمْ دِينُكُمْ وَلِيَ دِينِ 6﴾<br /> دين شما براى خودتان و دين من براى خودم <span class="c2">(۶)</span> <span class="c5">[سورة الكافرون: ١ - ٦]</span>.<span class="c6"><br /> تفسير:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109001.mp3"></audio> ١- <span class="c4">﴿قُلْ يَا أَيُّهَا الْكَافِرُونَ 1﴾</span>: بگو اى پيامبر: اى كسانى كه به الله کفر ورزیده اید.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109002.mp3"></audio> ٢- <span class="c4">﴿لَا أَعْبُدُ مَا تَعْبُدُونَ 2﴾</span>: من اکنون و در آینده بت هایی را که شما می پرستید نمی پرستم.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109003.mp3"></audio> ٣- <span class="c4">﴿وَلَا أَنْتُمْ عَابِدُونَ مَا أَعْبُدُ 3﴾</span>: و شما آنچه را که من می پرستم نمی پرستید، و او الله یگانه است.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109004.mp3"></audio> ٤- <span class="c4">﴿وَلَا أَنَا عَابِدٌ مَا عَبَدْتُمْ 4﴾</span>: و من نمی پرستم آنچه را شما از بت ها می پرستید.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109005.mp3"></audio> ٥- <span class="c4">﴿وَلَا أَنْتُمْ عَابِدُونَ مَا أَعْبُدُ 5﴾</span>: و شما آنچه را که من می پرستم نمی پرستید و او الله یگانه است.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109006.mp3"></audio> ٦- <span class="c4">﴿لَكُمْ دِينُكُمْ وَلِيَ دِينِ 6﴾</span>: برای شما دینی که برای خود اختراع کردید و برای من دینی که الله آن را بر من نازل نموده است. </p>',
            ],
            12 => [
                'question' => 'س13: سورۀ نصر را تلاوت و تفسیر نمایید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8470.mp3',
                'answer' => '<p> ج: سوره نصر و تفسیر آن:<br /> بِسۡمِ ٱللَّهِ ٱلرَّحۡمَـٰنِ ٱلرَّحِيمِ<br /> بنام الله بخشاينده و مهربان<br /> ﴿إِذَا جَاءَ نَصْرُ اللَّهِ وَالْفَتْحُ 1<br /> چون يارى الله و پيروزى فرا رسد <span class="c2">(۱)</span> وَرَأَيْتَ النَّاسَ يَدْخُلُونَ فِي دِينِ اللَّهِ أَفْوَاجًا 2<br /> و ببينى كه مردم دسته‏ دسته در دين الله درآيند <span class="c2">(۲)</span> فَسَبِّحْ بِحَمْدِ رَبِّكَ وَاسْتَغْفِرْهُ إِنَّهُ كَانَ تَوَّابًا 3﴾<br /> پس به ستايش پروردگارت نيايشگر باش و از او آمرزش خواه كه وى همواره توبه‏ پذير است <span class="c2">(۳)</span> <span class="c5">[سورة النصر: ١ - ٣]</span>.<span class="c6"><br /> تفسير:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/110001.mp3"></audio> ١- <span class="c4">﴿إِذَا جَاءَ نَصْرُ اللَّهِ وَالْفَتْحُ 1﴾</span>: اگر یاری الله به دینت رسید - ای رسول - و آن را معزز نمود، و فتح مکه صورت گرفت.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/110002.mp3"></audio> ٢- <span class="c4">﴿وَرَأَيْتَ النَّاسَ يَدْخُلُونَ فِي دِينِ اللَّهِ أَفْوَاجًا 2﴾</span>: و مردمی را دیدی که گروه پس از گروه وارد اسلام شدند.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/110003.mp3"></audio> ٣- <span class="c4">﴿فَسَبِّحْ بِحَمْدِ رَبِّكَ وَاسْتَغْفِرْهُ إِنَّهُ كَانَ تَوَّابًا 3﴾</span>: بدان که این نشانه آن است که مسوليت که به آن اعزام شده اید نزدیک به اتمام است، پس حمد و ثنای پروردگارت را ادا کن، و نعمت پیروزی و فتح را سپاسگذاری کن، و از او طلب آمرزش کن، او آمرزنده است توبۀ بندگانش را می پذیرفت و آنها را می بخشد. </p>',
            ],
            13 => [
                'question' => 'س 14: سوره مسد را تلاوت و تفسیر نمایید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8550.mp3',
                'answer' => '<p> ج: سوره مسد و تفسیر آن:<br /> بِسۡمِ ٱللَّهِ ٱلرَّحۡمَـٰنِ ٱلرَّحِيمِ<br /> بنام الله بخشاینده و مهربان<br /> ﴿تَبَّتْ يَدَا أَبِي لَهَبٍ وَتَبَّ 1<br /> بريده باد دو دست ابولهب و مرگ بر او باد <span class="c2">(۱)</span> مَا أَغْنَى عَنْهُ مَالُهُ وَمَا كَسَبَ 2<br /> دارايى او و آنچه اندوخت‏ سودش نكرد <span class="c2">(۲)</span> سَيَصْلَى نَارًا ذَاتَ لَهَبٍ 3<br /> بزودى در آتشى پرزبانه درآيد <span class="c2">(۳)</span> وَامْرَأَتُهُ حَمَّالَةَ الْحَطَبِ 4<br /> و نیز همسرش که هیزم آتش افروز دوزخ باشد <span class="c2">(۴)</span> فِي جِيدِهَا حَبْلٌ مِنْ مَسَدٍ 5﴾<br /> بر گردنش طنابى از ليف خرماست <span class="c2">(۵)</span> <span class="c5">[سورة المسد: ١ - ٥]</span>.<span class="c6"><br /> تفسير:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111001.mp3"></audio> ١- <span class="c4">﴿تَبَّتْ يَدَا أَبِي لَهَبٍ وَتَبَّ 1﴾</span>: دست عموی پیامبر صلی الله علیه وسلم ابولهب بن عبدالمطلب خسارت دید براساس خسارت عملش، چون پیامبر صلی الله علیه وسلم را اذیت می کرد، تلاش او نا امید شد.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111002.mp3"></audio> ٢- <span class="c4">﴿مَا أَغْنَى عَنْهُ مَالُهُ وَمَا كَسَبَ 2﴾</span>: هیچ چیزی ا زمال و فرزندان برایش سود نرسانید، نه عذابی را از او دفع کرد و نه رحمت را برایش به ارمغان آوردند.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111003.mp3"></audio> ٣- <span class="c4">﴿سَيَصْلَى نَارًا ذَاتَ لَهَبٍ 3﴾</span>: در روز قیامت به آتش شعله دار وارد می شود، که از حرارتش رنج می برد.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111004.mp3"></audio> ٤- <span class="c4">﴿وَامْرَأَتُهُ حَمَّالَةَ الْحَطَبِ 4﴾</span>: و همسرش ام جمیل که به پیامبر صلی الله علیه وسلم آسیب می رساند و بر سر راه وی خار می انداخت.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111005.mp3"></audio> ٥- <span class="c4">﴿فِي جِيدِهَا حَبْلٌ مِنْ مَسَدٍ 5﴾</span>: در گردن او طناب محکمی می باشد که با آن او را به داخل آتش می برند. </p>',
            ],
            14 => [
                'question' => 'س 15: سوره اخلاص را تلاوت و تفسیر نمایید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8650.mp3',
                'answer' => '<p> ج-<span class="c6"> سوره اخلاص و تفسیر آن:</span><br /> بِسۡمِ ٱللَّهِ ٱلرَّحۡمَـٰنِ ٱلرَّحِيمِ<br /> بنام الله بخشاينده و مهربان<br /> ﴿قُلْ هُوَ اللَّهُ أَحَدٌ 1<br /> بگو اوست‏ الله يگانه <span class="c2">(۱)</span> اللَّهُ الصَّمَدُ 2<br /> الله بی نیاز است <span class="c2">(۲)</span> لَمْ يَلِدْ وَلَمْ يُولَدْ 3<br /> <span class="c5">[كسى را]</span> نزاده و زاده نشده است <span class="c2">(۳)</span> وَلَمْ يَكُنْ لَهُ كُفُوًا أَحَدٌ 4﴾<br /> و هيچ كس او را همتا نيست <span class="c2">(۴)</span> <span class="c5">[سورة الإخلاص: 1 - 4]</span>.<span class="c6"><br /> تفسير:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112001.mp3"></audio> 1- <span class="c4">﴿قُلْ هُوَ اللَّهُ أَحَدٌ 1﴾</span>: بگو - ای رسول - او الله است، معبودی جز او نیست.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112002.mp3"></audio> 2- <span class="c4">﴿اللَّهُ الصَّمَدُ 2﴾</span>: یعنی: نیازهای مخلوقات به او راجع می شود.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112003.mp3"></audio> 3- <span class="c4">﴿لَمْ يَلِدْ وَلَمْ يُولَدْ 3﴾</span>: او نه پسری دارد و نه پدری.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112004.mp3"></audio> 4- <span class="c4">﴿وَلَمْ يَكُنْ لَهُ كُفُوًا أَحَدٌ 4﴾</span>: برای او تعالی در مخلوقات وی مانندی نیست. </p>',
            ],
            15 => [
                'question' => 'س 16: سوره فلق را تلاوت و تفسیر نمایید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8750.mp3',
                'answer' => '<p> ج-<span class="c6"> سوره فلق و تفسیر آن:</span><br /> بِسۡمِ ٱللَّهِ ٱلرَّحۡمَـٰنِ ٱلرَّحِیمِ<br /> بنام الله بخشاینده و مهربان<br /> ﴿قُلْ أَعُوذُ بِرَبِّ الْفَلَقِ 1<br /> بگو پناه مى برم به پروردگار سپيده دم <span class="c2">(۱)</span> مِنْ شَرِّ مَا خَلَقَ 2<br /> از شر آنچه آفريده است <span class="c2">(۲)</span> وَمِنْ شَرِّ غَاسِقٍ إِذَا وَقَبَ 3<br /> و از شر تاريكى چون فراگيرد <span class="c2">(۳)</span> وَمِنْ شَرِّ النَّفَّاثَاتِ فِي الْعُقَدِ 4<br /> و از شر آنها كه در گره‏ ها مي‏دمند <span class="c2">(۴)</span> وَمِنْ شَرِّ حَاسِدٍ إِذَا حَسَدَ 5﴾<br /> و از شر <span class="c5">[هر]</span> حسود آنگاه كه حسد ورزد <span class="c2">(۵)</span> <span class="c5">[سورة الفلق: 1 - 5]</span>.<span class="c6"><br /> تفسير:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113001.mp3"></audio> 1- <span class="c4">﴿قُلْ أَعُوذُ بِرَبِّ الْفَلَقِ 1﴾</span>: بگو اى رسول: من به پروردگار صبح چنگ مى زنم، و به او پناه مى برم.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113002.mp3"></audio> 2- <span class="c4">﴿مِنْ شَرِّ مَا خَلَقَ 2﴾</span>: از شری مخلوقاتی که ضرر می رسانند.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113003.mp3"></audio> 3- <span class="c4">﴿وَمِنْ شَرِّ غَاسِقٍ إِذَا وَقَبَ 3﴾</span>: و پناه می برم به الله از بلاهایی که در شب از حیوانات و دزدان ظاهر می شوند.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113004.mp3"></audio> 4- <span class="c4">﴿وَمِنْ شَرِّ النَّفَّاثَاتِ فِي الْعُقَدِ 4﴾</span>: و به او پناه می برم از شر جادوگرانی که در گره ها می دمند.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113005.mp3"></audio> 5- <span class="c4">﴿وَمِنْ شَرِّ حَاسِدٍ إِذَا حَسَدَ 5﴾</span>: و از شر حسودی که از مردم بدش می آید، چون بر نعمت‌هایی که الله به آنها داده است حسد می‌ورزد، او خواهان نابودی آنها و آسیب رساندن به آنها می باشد. </p>',
            ],
            16 => [
                'question' => 'س 17: سورۀ ناس را تلاوت و تفسیر نمایید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8870.mp3',
                'answer' => '<p> ج-<span class="c6"> سوره ناس و تفسیر آن:</span><br /> بِسۡمِ ٱللَّهِ ٱلرَّحۡمَـٰنِ ٱلرَّحِيمِ<br /> بنام الله بخشاینده ومهربان<br /> ﴿قُلْ أَعُوذُ بِرَبِّ النَّاسِ 1<br /> بگو پناه مى برم به پروردگار مردم <span class="c2">(۱)</span> مَلِكِ النَّاسِ 2<br /> پادشاه مردم <span class="c2">(۲)</span> إِلَهِ النَّاسِ 3<br /> معبود مردم <span class="c2">(۳)</span> مِنْ شَرِّ الْوَسْوَاسِ الْخَنَّاسِ 4<br /> از شر وسوسه‏ گر نهانى <span class="c2">(۴)</span> الَّذِي يُوَسْوِسُ فِي صُدُورِ النَّاسِ 5<br /> آن كس كه در سينه‏ هاى مردم وسوسه مى ‏كند <span class="c2">(۵)</span> مِنَ الْجِنَّةِ وَالنَّاسِ 6﴾<br /> چه از جن و <span class="c5">[چه از]</span> انس <span class="c2">(۶)</span> <span class="c5">[سورة الناس: 1 - 6]</span>.<span class="c6"><br /> تفسير:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114001.mp3"></audio> 1- <span class="c4">﴿قُلْ أَعُوذُ بِرَبِّ النَّاسِ 1﴾</span>: بگو اى رسول: من به پروردگار مردم چنگ مى زنم و از او پناه مى جويم.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114002.mp3"></audio> 2- <span class="c4">﴿مَلِكِ النَّاسِ 2﴾</span>: هر طور که بخواهد در آنها تصرف می کند، آنها مالک دیگری جز او ندارند.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114003.mp3"></audio> 3- <span class="c4">﴿إِلَهِ النَّاسِ 3﴾</span>: معبود واقعی آنها است، هیچ معبودی بر حق برای آنها جز او نیست.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114004.mp3"></audio> 4- <span class="c4">﴿مِنْ شَرِّ الْوَسْوَاسِ الْخَنَّاسِ 4﴾</span>: از شر شیطان به مردم وسوسه می اندازد.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114005.mp3"></audio> 5- <span class="c4">﴿الَّذِي يُوَسْوِسُ فِي صُدُورِ النَّاسِ 5﴾</span>: وسوسۀ خودش را در دلهای مردم می اندازد.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114006.mp3"></audio> 6- <span class="c4">﴿مِنَ الْجِنَّةِ وَالنَّاسِ 6﴾</span> یعنی فرد وسواسی می توان انسان و می توان جن باشد. </p>',
            ],
        ],
        5 => [
            0 => [
                'question' => 'س 1: حديث « إنما الأعمال بالنيات...» را تکمیل نموده و برخی از فوايد آن را ذكر كنيد؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9030.mp3',
                'answer' => '<p> ج -<span class="c6"> از امیرالمؤمنین ابوحفص عمر بن الخطاب رضی الله عنه روایت است که فرمود:</span> از رسول الله صلی الله علیه وسلم شنیدم که می فرمود: <span class="c3">«عمل از روی نیت است، و هر کس به آنچه اراده کرده است می رسد، پس هر که به سوی الله و رسولش هجرت کرد، هجرت او برای الله و رسولش است، و هر کس که هجرت او به خاطر منافع دنیا یا برای ازدواج زنی باشد، پس هجرت او برای همان چیزی است که به آن هجرت کرده است.»</span> بخاری و مسلم روایت نمودند.<span class="c6"><br /> فواید حدیث:</span><br /> 1- هر عمل باید نیت داشته باشد مانند نماز و روزه و حج و غیره اعمال دیگر.<br /> 2- اخلاص به الله در نیت لازم است.<span class="c6"><br /> *حدیث دوم:</span> </p>',
            ],
            1 => [
                'question' => 'س 2: حديث «من أحدث في أمرنا هذا ...» را تکمیل نموده و فوائد آن را ذكر كنيد؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9090.mp3',
                'answer' => '<p> ج ـ از مادر مؤمنان ام عبدالله عایشه رضی الله عنها روایت است که می گوید: رسول الله صلی الله علیه وسلم فرمود: <span class="c3">«کسی که در دین ما نوآوری کند که در آن نباشد، مردود است»</span>. بخاری و مسلم روایت نمودند.<span class="c6"><br /> فواید حدیث:</span><br /> 1- نهی از نوآوری در دین.<br /> 2- اعمال نو ایجاد شده مردود بوده و پذیرفته نمی شوند.<span class="c6"><br /> *حدیث سوم:</span> </p>',
            ],
            2 => [
                'question' => 'س 3: حديث (بينما نحن جلوس عند رسول الله ﷺ ...) را تکمیل نموده و برخی از فوايد آن را ذكر كنيد؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9160.mp3',
                'answer' => '<p> ج ـ عمر بن خطاب رضی الله عنه می فرماید: در حالی که روزی نزد رسول الله صلی الله علیه وسلم نشسته بودیم، مردی با لباس بسیار سفید، موهای بسیار سیاه بر ما ظاهر شد. هیچ اثری از سفر بر او دیده نمی شد و هیچ یک از ما او را نمی شناخت، تا اینکه نزد پیامبر صلی الله علیه وسلم نشست و زانوی خود را بر زانوهایش گذاشت و کف دست خود را بر ران های خود گذاشت.<span class="c6"> و گفت:</span> اى محمد از اسلام به من خبر بده،<span class="c6"> به او گفت:</span> اسلام: گواهی بدهی به اينكه معبودى برحق جز الله نيست و محمد فرستادۀ الله است، نماز را بر پا دارى، زكات را بدهى،<span class="c6"> رمضان را روزه بگیری و زیارت خانۀ کعبه را اگر راهی به سوی آن یافتی ادا کنی» گفت:</span> <span class="c3">«راست گفتی»</span> ما از این که از او می پرسد و تصدیق می کند، شگفت زده شدیم،<span class="c6"> گفت:</span> از ایمان به من خبر بده.<span class="c6"> گفت:</span> اینکه به الله، فرشتگان، کتابها، پیامبران، روز آخرت، و ایمان به قدر خیر و شر آن .<span class="c6"> گفت:</span> راست می گویی.<span class="c6"> گفت:</span> از احسان به من خبر بده،<span class="c6"> گفت:</span>آنکه الله را چنان عبادت کنی که گویا او را می بینی و اگر او را نمی بینی پس او تو را می بیند».<span class="c6"> گفت:</span> <span class="c3">«پس مرا از قیامت خبر بده»</span>.<span class="c6"> گفت:</span> <span class="c3">«سوال شونده از سوال کننده داناتر نیست؟»</span> گفت: <span class="c3">«پس از نشانه های آن به من خبر بده.»</span> گفت: اینکه کنیزی بادارش را به دنیا بیاورد، و این که پابرهنه ها و بی چاره ها چوپانانی را ببینی که ساختمان های بلند اعمار می کنند.» سپس رفت و اندکی درنگ کرد،<span class="c6"> گفت:</span> <span class="c3">«ای عمر! آیا می دانی سوال کننده چه کسی بود؟»</span> گفتم: <span class="c3">«الله و رسولش داناترند.»</span> گفت: <span class="c3">« او جبرئیل بود، آمد تا دین شما را به شما بیاموزد»</span>.<span class="c6"> روايت مسلم<br /> از فوائد حديث:</span><br /> 1- ذکر ارکان پنج گانه اسلام،<span class="c6"> و آن:</span><br /> گواهی بر اینکه معبودی جز الله نیست و محمد فرستادۀ الله است.<br /> برپایی نماز<br /> ادای زکات<br /> و روزۀ رمضان.<br /> و حج بیت الله الحرام.<br /> 2- ذکر اركان ايمان،<span class="c6"> و آنها شش هستند:</span><br /> ایمان به الله.<br /> و فرشتگانش.<br /> و کتاب هایش.<br /> و فرستادگانش.<br /> و روز آخرت.<br /> و خیر و شر قدر.<br /> 3- ذکر رکن احسان، و آن یک رکن است، این كه الله را چنان عبادت كنی كه گويا او را می بينی و اگر او را نمی بينی او تو را می بيند.<br /> 4- وقت برپایی قیامت را کسی بجز الله نمی داند.<span class="c6"><br /> حدیث چهارم:</span> </p>',
            ],
            3 => [
                'question' => 'س 4: حديث «أكمل المؤمنين إيماناً ...» را تکمیل و فوايد آن را ذكر كنيد؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9360.mp3',
                'answer' => '<p> ج-<span class="c6"> از ابوهریره رضی الله عنه روایت است که گفت:</span> رسول الله صلی الله علیه وسلم فرمود: <span class="c3">«کاملترین مؤمنان از نگاه ایمان، نیکوترین شان از نگاه اخلاق هستند»</span>.<span class="c6"> ترمذی روایت کرده و گفت:</span> حدیث حسن صحیح است.<span class="c6"><br /> فواید حدیث:</span><br /> 1- تشویق به اخلاق نیک.<br /> 2- کمال اخلاق از کمال ایمان است.<br /> 3- و این که ایمان کم و زیاد می شود.<span class="c6"><br /> حدیث پنجم:</span> </p>',
            ],
            4 => [
                'question' => 'س 5: حديث «من حلف بغير الله ...» را تکمیل نموده و برخی از فوايد آن را ذكر كنيد؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9440.mp3',
                'answer' => '<p> ج ـ از ابن عمر رضی الله عنهم روایت است که پیامبر صلی الله علیه وسلم فرمود: <span class="c3">«کسی که به غیر الله سوگند یاد کند؛ کافر شده و یا شرک نموده است.»</span> ترمذی روایت نموده است.<span class="c6"><br /> از فوائد حديث:</span><br /> - سوگند جز به الله متعال جایز نیست.<br /> - سوگند به غیر الله متعال شرک اصغر است.<span class="c6"><br /> حدیث ششم:</span> </p>',
            ],
            5 => [
                'question' => 'س 6: حديث  «لا يؤمن أحدكم حتى أكون أحب إليه ...»،را تکمیل نموده و فوايد آن را بيان كنيد؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9510.mp3',
                'answer' => '<p> ج -<span class="c6"> از انس رضی الله عنه روایت است که رسول الله صلی الله علیه وسلم فرمود:</span> <span class="c3">«هیچ یک از شما ایمان نمی آورد تا اینکه من نزد او از پدر و پسرش و همه مردم عزیزتر باشم»</span>. به روایت بخاری و مسلم.<span class="c6"><br /> فواید حدیث:</span><br /> پیامبر اکرم صلی الله علیه وسلم را باید از همه مردم بیشتر دوست داشت.<br /> و این از کمال ایمان است.<span class="c6"><br /> حدیث هفتم:</span> </p>',
            ],
            6 => [
                'question' => 'س 7: حديث: «لا يؤمن أحدكم حتى يحب لأخيه ...»،را تکمیل نموده و برخی از فوايد آن را ذكر كنيد؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9580.mp3',
                'answer' => '<p> ج-<span class="c6"> از انس رضی الله عنه روایت است که رسول الله صلی الله علیه وسلم فرمود:</span> <span class="c3">«هیچ یک از شما مومن بوده نمی تواند، تا اینکه آنچه را که برای خود می پسندد برای برادرش نیز بپسندد.»</span> روایت بخاری و مسلم.<span class="c6"><br /> فوائد حديث:</span><br /> 1- مؤمن باید خوبی هایی را که برای خود می پسندد برای مؤمنان نیز بپسندد.<br /> و این کمال ایمان است.<span class="c6"><br /> حدیث هشتم:</span> </p>',
            ],
            7 => [
                'question' => 'س 8: حدیث «والذي نفسي بيده! ...» را تکمیل نموده و برخی از فواید آن را ذکر کنید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9650.mp3',
                'answer' => '<p> ج -<span class="c6"> از ابوسعید رضی الله عنه روایت است که رسول الله صلی الله علیه وسلم فرمود:</span> <span class="c3">«سوگند به ذاتی که جان من در اختیار اوست! آن معادل یک سوم قرآن است.»</span> روایت بخاری.<span class="c6"><br /> برخی از فواید حدیث:</span><br /> 1- فضیلت سورۀ اخلاص.<br /> 2- آن معادل یک سوم قرآن است.<span class="c6"><br /> حدیث نهم:</span> </p>',
            ],
            8 => [
                'question' => 'س 9: حديث «لا حول ولا قوة إلا بالله ...»، را تکمیل نموده و برخی از فوايد آن را ذكر كنيد؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9720.mp3',
                'answer' => '<p> ج -<span class="c6"> از ابوموسی رضی الله عنه روایت است که رسول الله صلی الله علیه وسلم فرمود:</span> <span class="c3">« لا حول ولا قوة إلا بالله، یکی از گنج های بهشت است»</span>. بخاری و مسلم روایت نمودند.<span class="c6"><br /> فوائد حديث:</span><br /> 1- فضیلت این کلمه، و اینکه از گنج های بهشت است.<br /> 2- بنده خود را از توانایی و قوت خود مبرا می کند، و اعتماد خودرا تنها به الله متعال بیان می نماید.<span class="c6"><br /> حدیث دهم:</span> </p>',
            ],
            9 => [
                'question' => 'س10: حديث «ألا إن في الجسد مضغة...» را تکمیل نموده و برخی از فوايد آن را ذكر كنيد؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9790.mp3',
                'answer' => '<p> ج -<span class="c6"> از نعمان بن بشیر رضی الله عنه روایت است که گفت:</span> از رسول الله صلی الله علیه وسلم شنیدم که می فرمود: <span class="c3">«همانا پاره‌ای در بدن است اگر سالم شود تمام بدن سالم می شود، و اگر فاسد شود تمام بدن فاسد می شود و آن دل است»</span>. بخاری و مسلم روایت نمودند.<span class="c6"><br /> برخی از فواید حدیث:</span><br /> 1- اصلاح دل <span class="c2">(قلب)</span> شامل اصلاح ظاهر و باطن است.<br /> 2- توجه به اصلاح دل، زیرا اصلاح انسان به آن وابسته است.<span class="c6"><br /> * حدیث یازدهم:</span> </p>',
            ],
            10 => [
                'question' => 'س 11: حديث «من كان آخر كلامه من الدنيا: لا إله إلا الله..»
  را تکمیل نموده و برخی از فوايد آن ذكر كنيد؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9860.mp3',
                'answer' => '<p> ج-<span class="c6"> از معاذ بن جبل رضی الله عنه روایت است که فرمود:</span> رسول الله صلی الله علیه وسلم فرمود: هر که آخرین سخنش این بود: لا اله الا الله؛ وارد بهشت می گردد » به روایت ابوداود.<span class="c6"><br /> برخی از فواید حدیث:</span><br /> 1- فضیلت لا اله الا الله و اینکه بنده از طریق آن وارد بهشت می شود.<br /> 2- فضیلت کسی که آخرین سخنش از دنیا لا اله الا الله است.<span class="c6"><br /> *حدیث دوازدهم:</span> </p>',
            ],
            11 => [
                'question' => 'س 12: حديث «ليس المؤمن بالطعان، ولا اللعان ...» را تکمیل نموده و برخی از فوايد آن بیان كنيد؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9940.mp3',
                'answer' => '<p> ج -<span class="c6"> از عبدالله بن مسعود رضی الله عنه روایت است که فرمود:</span> رسول الله صلی الله علیه وسلم فرمود: " مومن نمی تواند طعنه و لعنت دهنده، فُحش دهنده، و بد زبان باشد" به روایت ترمذی.<span class="c6"><br /> از فواید این حدیث:</span><br /> 1- نهی از هرگونه گفتار نادرست و ناسزا.<br /> - این صفت مؤمن در زبان اوست.<span class="c6"><br /> حدیث سیزدهم:</span> </p>',
            ],
            12 => [
                'question' => 'س13: حديث «من حسن إسلام المرء ...» را تکمیل نموده و برخی از فوايد آن ذكر كنيد؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10020.mp3',
                'answer' => '<p> ج-<span class="c6"> از ابوهریره رضی الله عنه روایت است که فرمود:</span> رسول الله صلی الله علیه وسلم فرمود: "از خوبی اسلام انسان،<span class="c6"> ترک آنچه است که به او مربوط نمی شود" به روایت ترمذی و دیگران<br /> از فواید این حدیث:</span><br /> 1- ترک آنچه به انسان در مسائل دین و دنیای دیگران مربوط نمی شود.<br /> 2- از کمال اسلام انسان، ترک چیزی است که مربوط به او نمی شود.<span class="c6"><br /> * حدیث چهاردهم:</span> </p>',
            ],
            13 => [
                'question' => 'س 14: حديث: «من قرأ حرفاً من كتاب الله...» را تکمیل نموده و برخی از فوايد آن ذكر كنيد؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10100.mp3',
                'answer' => '<p> ج -<span class="c6"> از عبدالله بن مسعود روایت است که:</span> پیامبر صلی الله علیه وسلم فرمود: «کسی که حرفی از کتاب الله را بخواند یک حسنه برایش داده می شود، و یک حسنه با ده برابر است،<span class="c6"> نمی گویم:</span> الف لام میم حرف است، بلکه الف حرف است، لام حرف است، و میم حرف است. به روایت ترمذی.<span class="c6"><br /> برخی از فواید این حدیث:</span><br /> 1- فضیلت تلاوت قرآن.<br /> 2- و اینکه هر حرفی که می خوانی حسنه ها دارد. </p>',
            ],
        ],
        6 => [
            0 => [
                'question' => 'س1- ادب با الله متعال چگونه می باشد؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10190.mp3',
                'answer' => '<p> ج- 1- تعظیم الله سبحانه و تعالی.<br /> 2- وی را تنها و بدون شریک پرستیدند.<br /> 3- طاعت وی.<br /> 4- ترک نافرمانی وی.<br /> 5- سپاس و حمد و ثنای وی بخاطر مهربانی و نعمت های بی شمارش.<br /> 6- صبر در برابر تقدیرات الهی </p>',
            ],
            1 => [
                'question' => 'ادب با پیامبر ﷺ چگونه می باشد؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10270.mp3',
                'answer' => '<p> 2- اطاعت وی و اقتدا به وی.<br /> 3- طاعت وی.<br /> 4- ترک نافرمانی وی.<br /> 5- تصديق وی در آنچه وی خبر می دهد.<br /> 6- . عدم نو آوری و زیادت در سنت وی.<br /> 7- دوست داشتن وی بیشتر از خویشتن و همه مردم.<span class="c6"><br /> س3:</span> بزرگ پنداشتن، نصرت وی و نصرت سنت وی صلی الله علیه وسلم. </p>',
            ],
            2 => [
                'question' => 'س3: ادب با والدین چگونه می باشد؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10360.mp3',
                'answer' => '<p> ج- 1- اطاعت والدین در عدم معصیت.<br /> 2- خدمت والدین.<br /> 3- همکاری با والدین .<br /> 4- مرفوع ساختن نیازهای والدین.<br /> 5- دعاء برای والدین.<br /> 6- مراعات ادب هنگام سخن گفتن با ایشان، و به زبان آوردن کلمه <span class="c2">(اف)</span> در برابر والدین جواز ندارد، و این ناچیزترین سخن هاست.<br /> 7- تبسم در برابر والدین و عدم پیشانی ترشی با آنان.<br /> 8- صدایم را بالاتر از صدای پدر و مادر نمی‌برم، به حرفشان گوش می‌دهم، حرفشان را قطع نمی‌کنم و آنها را به اسم شان صدا نمی‌کنم،<span class="c6"> بلکه می‌گویم:</span> پدرم، مادرم.<br /> 9- قبل از داخل شدن به پدر و مادرم در حالی که در اتاق باشند اجازه می‌گیرم.<br /> 10- بوسیدن دست و سر والدین. </p>',
            ],
            3 => [
                'question' => 'س4: رحم را چگونه وصل نمایم ؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10490.mp3',
                'answer' => '<p> ج- 1- زیارت نزدیکان اعم از برادر، خواهر، کاکا، عمه، ماما، خاله و بقیه نزدیکان.<br /> 2- با آنها در گفتار و عمل احسان کردن و کمک نمودن آنان.<br /> 3- از آن جمله برقراری تماس با آنها و جویا شدن احوال ایشان می باشد. </p>',
            ],
            4 => [
                'question' => 'س5: با برادران و دوستانم چگونه باید باشم؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10550.mp3',
                'answer' => '<p> ج- 1- دوست می دارم و خوبان را همراهی می کنم.<br /> 2- از همراهی با مردم بد دوری کرده دوستی با آنان را ترک می کنم.<br /> 3- به برادرانم سلام می دهم و با آنها مصافحه می کنم.<br /> 4- اگر مریض باشند آنها را عیادت می کنم و برایشان دعای شفا می کنم.<br /> 5- جواب عطسه کننده را می دهم.<br /> 6- اگر مرا به زیارت خود دعوت کند، دعوت او را می پذیرم.<br /> 7- به او نصیحت می کنم.<br /> 8- اگر به او ظلم شد کمکش می کنم و از ظلم بر دیگران بازش می دارم.<br /> 10- آنچه را برای خود دوست دارم برای برادر مسلمانم دوست می دارم.<br /> 11- اگر به کمک من نیاز داشت به او کمک می کنم.<br /> 12- با گفتار و فعل به او اذیت نمی رسانم.<br /> 13- راز او را حفظ می کنم.<br /> 14- او را دشنام نمی‌دهم، اورا غیبت نمی‌کنم، او را تحقیر نمی‌کنم، به او حسد نمی‌ورزم، علیه او جاسوسی نمی‌کنم و فریبش نمی‌دهم. </p>',
            ],
            5 => [
                'question' => 'س6: آداب همسایه چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10710.mp3',
                'answer' => '<p> الف- 1- به همسایه در گفتار و عمل نیکی می کنم و اگر به کمک من نیاز داشت کمکش می کنم.<br /> 2- هرگاه به عید، ازدواج یا چیز دیگری خوشحال باشد به او تبریک می گویم.<br /> 3- اگر مریض باشد او را عیادت می کنم، و اگر مصیبت زده باشد از او دلجویی می کنم.<br /> 4- تا حد امکان هر چه برای خود غذا آماده می کنم برای او هم می دهم.<br /> 5- با گفتار و با عمل به او اذیت نمی رسانم.<br /> 6- با صدای بلند مزاحم او نمی شوم و بر او جاسوسی نمی کنم، و با او صبور می باشم. </p>',
            ],
            6 => [
                'question' => 'س7: آداب مهمان نوازی و مهمان چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10800.mp3',
                'answer' => '<p> ج- 1- هرگاه مرا به مهمانی دعوت نماید او را اجابت می کنم.<br /> 2- اگر بخواهم به ملاقات کسی بروم، اجازه می گیرم و قرار ملاقات می گذارم.<br /> 3- قبل از ورود اجازه می گیرم.<br /> 4- در زیارت دیر نمی کنم.<br /> 5- چشمانم را از اهل خانه می بندم.<br /> 6- از مهمان پذیرایی می کنم و با بهترین استقبال و با چهره ای بشاش و بهترین خوشامدگویی وپذیرایی می کنم.<br /> 7- مهمان را در بهترین مکان می نشانم.<br /> 8- و او را به مهمان نوازی به غذا و نوشیدنی تکریم می نمایم. </p>',
            ],
            7 => [
                'question' => 'س 8: آداب بیماری و عیادت از بیماران را ذکر کنید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10900.mp3',
                'answer' => '<p> ج- 1- هنگام احساس درد می کنم؛ دست راستم را بر سر جای درد می گذارم،<span class="c6"> و سه مرتبه می گویم:</span> بسم الله،<span class="c6"> هفت مرتبه می گویم:</span> <span class="c3">«أعوذ بعزة الله وقدرته من شر ما أجد وأحاذر»</span> از شر آنچه می یابم به عزت و قدرت خدا پناه می برم.<br /> 2- به آنچه الله مقدر کرده راضی و شکیبا می باشم.<br /> 3- به عیادت برادر بیمارم می شتابم و برایش دعا می کنم و مدت زیادی با او نمی نشینم.<br /> 4- بدون اینکه از من بخواهد او را دم می نمایم.<br /> 5- او را به صبر و دعا و نماز و طهارت در حد توانش توصیه می کنم.<br /> 6-<span class="c6"> دعا برای مریض:</span> <span class="c3">«أسأل الله العظيم رب العرش العظيم أن يشفيك»</span> هفت مرتبه </p>',
            ],
            8 => [
                'question' => 'س9: آداب فراگیری علم را ذکر کنید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10990.mp3',
                'answer' => '<p> ج - 1- اخلاص نیت به الله متعال.<br /> 2- به علمی که آموخته ام عمل می کنم.<br /> 3- معلم را در حضور و غیاب احترام و تکریم می کنم.<br /> 4- در برابر او با ادب می نشینم.<br /> 5- به او خوب گوش می دهم و در درس او را قطع نمی کنم.<br /> 6- در سوال کردن با ادب می باشم.<br /> 7- با اسمش او را صدا نمی زنم. </p>',
            ],
            9 => [
                'question' => 'س10: آداب مجلس چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11090.mp3',
                'answer' => '<p> ج - 1- به اهل مجلس سلام می دهم.<br /> 2- در جایی که مجلس تمام می شود آنجا می نشینم، هیچ کسی را از جایش بلند نمی کنم و بدون اجازه بین دو نفر نمی نشینم.<br /> 3- در مجلس برای نشستن دیگران جا می دهم.<br /> 4- سخنان مجلس را قطع نمی کنم.<br /> 5- قبل از خروج از مجلس اجازه می گیرم و سلام می دهم.<br /> 6- وقتی مجلس تمام می شود دعای کفارۀ مجلس را می خوانم. <span class="c3">«سبحانك اللهم وبحمدك، أشهد أن لا إله إلا أنت، أستغفرك وأتوب إليك»</span>.<br /> پاکیست و ستایش است ترا ای پروردگار، گواهی می دهم که معبود برحقی جز تو نیست، از تو طلب مغفرت می کنم و به تو توبه می کنم. </p>',
            ],
            10 => [
                'question' => 'س 11: آداب خواب را ذکر کنید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11180.mp3',
                'answer' => '<p> الف- زود میخوابم.<br /> 2- در حالت طهارت می خوابم.<br /> 3- به روی شکم نمی خوابم.<br /> 4- به پهلوی راست می خوابم و دست راستم را زیر گونۀ راستم می گذارم.<br /> 5- بستر خوابم را تکان می دهم.<br /> 6- اذکار خواب را از قبیل آیت کرسی، سورۀ اخلاص و معوذتین سه مرتبه می خوانم.<span class="c6"> و می گویم:</span> <span class="c3">«باسمك اللهم أموت وأحيا»</span>.<br /> الهی به نام تو می میرم و زنده می شوم.<br /> 7- برای نماز صبح بر می خیزم.<br /> 8-<span class="c6"> بعد از بیدار شدن از خواب می گویم:</span> <span class="c3">«الحمد لله الذي أحيانا بعدما أماتنا وإليه النشور»</span>.<br /> سپاس الله را که پس از مرگ ما را زنده نمود و بسوی وی حشر می شویم. </p>',
            ],
            11 => [
                'question' => 'س12: آداب غذا خوردن چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11290.mp3',
                'answer' => '<p> ج-<br /> 1- با خوردن و آشامیدن نیت میکنم که برای عبادت الله متعال تقویت شوم.<br /> 2- شستن دست ها قبل از خوردن غذا.<br /> 3- بسم الله می گویم و با دست راست و آنچه نزدیکم است می خورم، از وسط ظرف ها و از جلو دیگران نمی خورم.<br /> 4-<span class="c6"> اگر بسم الله گفتن فراموش کنم می گویم:</span> بسم الله أوله وآخره .<br /> 5- به آنچه از غذا موجود است راضی می باشم، و بر غذا ایراد نمی گیرم، اگر آن را دوست داشتم می خورم و اگر دوست نداشتم ترکش می کنم.<br /> 6- چند لقمه می خورم و زیاد نمی خورم.<br /> 7- بر غذا و نوشیدنی پف نمی کنم و می گذارم تا سرد شود.<br /> 8- در غذا با خانواده یا مهمان یکجا می شوم.<br /> 9- قبل از دیگران که از خودم بزرگتر اند شروع به خوردن نمی کنم.<br /> 10- وقتی می نوشم نام الله را به زبان آورده و نشسته و در سه دفعه می نوشم.<br /> 11- وقتی غذا را تمام کردم الله را شکر می کنم. </p>',
            ],
            12 => [
                'question' => 'س13: آداب لباس را بشمارید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11440.mp3',
                'answer' => '<p> ج- 1 لباسم را با دست راست می پوشم و از این بابت الله را شکر می کنم.<br /> 2- لباس را تا زیر مچ پا دراز نمی کنم.<br /> 3- پسران لباس دخترانه نمی پوشند و دختران لباس پسرانه نمی پوشند.<br /> 4- تقلید نکردن لباس کافران یا فاسقان.<br /> 5- گفتن بسم الله هنگام در آوردن لباس.<br /> 6- پوشیدن کفش از سمت راست و در درآوردن آن از سمت چپ. </p>',
            ],
            13 => [
                'question' => 'س 14: آداب سواری را ذکر کنید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11540.mp3',
                'answer' => '<p> ج- 1-<span class="c6"> می گویم:</span> بسم الله الحمدلله. ﴿سُبْحَانَ الَّذِي سَخَّرَ لَنَا هَذَا وَمَا كُنَّا لَهُ مُقْرِنِينَ 13<br /> پاك است ذاتی كه اين را براى ما رام كرد و<span class="c5">[گرنه]</span> ما را ياراى <span class="c5">[رام‏ ساختن]</span> آنها نبود <span class="c2">(۱۳)</span> وَإِنَّا إِلَى رَبِّنَا لَمُنْقَلِبُونَ 14﴾<br /> و به راستى كه ما به سوى پروردگارمان بازخواهيم گشت <span class="c2">(۱۴)</span> <span class="c5">[سورة الزخرف: 13، 14]</span>.<br /> 2- اگر از کنار مسلمانی بگذرم؛ به او سلام می دهم. </p>',
            ],
            14 => [
                'question' => 'س15:  آداب جاده (راه) را ذکر کنید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11590.mp3',
                'answer' => '<p> ج - 1 - در جاده رفتن میانه رو و متواضع می باشم و در سمت راست جاده می روم.<br /> 2- با کسی که روبرو می شوم سلام می دهم.<br /> 3- نگاهم را پایین می اندازم و به کسی آسیب نمی‌رسانم.<br /> 4- امر به معروف و نهی از منکر می کنم.<br /> 5- هر چیزی اذیت دهنده را از جاده دور می کنم. </p>',
            ],
            15 => [
                'question' => 'س 16: آداب دخول و خروج از منزل را ذکر کنید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11670.mp3',
                'answer' => '<p> ج- 1-<span class="c6"> با پای چپ بیرون می روم و می گویم:</span> <span class="c3">«بسم الله، توكلت على الله، لا حول ولا قوة إلا بالله، اللهم إني أعوذ بك أن أضل أو أضل، أو أزل أو أزل، أو أظلم أو أظلم، أو أجهل أو يجهل علي»</span>.<br /> به نام الله توکل کردم بر الله هیچ قوت و نیرویی جز به الله نیست، الهی به تو پناه می برم این که گمراه شوم یا دیگری را گمراه کنم، یا به سبب ارتکاب گناه پاهایم بلغزد و یا سبب لغزش پاهای دیگری شوم، یا مورد ستم قرار گیرم و یا سبب ستم بر دیگران شوم، و یا مانند جاهلان عمل کنم و یا دیگران کار جاهلانه را بر من عملی کنند.» 2-<span class="c6"> با پای راست داخل خانه می شوم و می گویم:</span> <span class="c3">«بسم الله ولجنا، وبسم الله خرجنا، وعلى ربنا توكلنا»</span>.<br /> <span class="c3">«به نام الله وارد شدیم و به نام الله بیرون آمدیم و بر پروردگارمان توکل کردیم»</span>.<br /> 3- با مسواک زدن شروع می کنم سپس به اهل خانه سلام می دهم. </p>',
            ],
            16 => [
                'question' => 'س17:  آداب قضای حاجت را ذکر کنید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11730.mp3',
                'answer' => '<p> ج- 1- با پای چپ داخل می شوم.<br /> 2-<span class="c6"> قبل از داخل شدن می گویم:</span> <span class="c3">«بسم الله، اللهم إني أعوذ بك من الخبث والخبائث»</span>.<br /> <span class="c3">«بسم الله، بار الها از شر شياطين نر و ماده، يا هر پليدی و نا پاكی ديگر به تو پناه می برم»</span>.<br /> 3- چیزی که در آن ذکر الله باشد داخل نمی کنم.<br /> 4- هنگام قضای حاجب خود را پوشش می دهم.<br /> 5- در جای قضای حاجت حرف نمی زنم.<br /> 6- هنگام ادرار و یا غایط رو و یا پشت خود را بسمت قبله قرار نمی دهم.<br /> 7- از دست چپ برای رفع نجاست استفاده می کنم و از دست راست استفاده نمی کنم.<br /> 8- قضای حاجت خود را در راه و در مکان سایه بان مردم انجام نمی دهم.<br /> 9- بعد از قضای حاجت دست هایم را می شویم.<br /> 10-<span class="c6"> با پای چپم بیرون می‌روم و می‌گویم:</span> "غفرانك". <br /> یعنی ای الله مرا ببخش. </p>',
            ],
            17 => [
                'question' => 'س 18: آداب مسجد را ذکر کنید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11860.mp3',
                'answer' => '<p> ج- 1-<span class="c6"> با پای راست وارد مسجد می شوم و می گویم:</span> <span class="c3">«بسم الله، اللهم افتح لي أبواب رحمتك»</span>.<br /> به نام الله، الهی درهای رحمتت را به رویم بگشا.<br /> 2- تا دو رکعت نماز نخوانم نمی نشینم.<br /> 3- از جلو نماز گذاران عبور نمی کنم، و گمشده ام را در مسجد اعلام نمی کنم، و خرید و فروش را در مسجد انجام نمی دهم.<br /> 4-<span class="c6"> با پای چپ از مسجد بیرون می شوم و می گویم:</span> <span class="c3">«اللهم إني أسألك من فضلك»</span>.<br /> "الهی فضل تو را می خواهم" </p>',
            ],
            18 => [
                'question' => 'س19:  آداب سلام را ذکر کنید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11930.mp3',
                'answer' => '<p> ج- 1- وقتی با مسلمانی روبرو می شوم، به سلام شروع می کنم،<span class="c6"> و می گویم:</span> <span class="c3">«السلام عليكم ورحمة الله وبركاته»</span> نه بدون سلام، و تنها با دست اشاره نمی کنم.<br /> 2- بر روی کسی که سلام دهم تبسم می کنم.<br /> 3- با دست راستم مصافحه می کنم.<br /> 4- اگر کسی به من سلام دهد، جواب بهتری به او می دهم يا همان را برمی گردانم.<br /> 5- با سلام دادن به کافر پیشتازی نمی کنم، و اگر سلام کرد به مانند سلامش جواب می دهم.<br /> 6- کوچکتر به بزرگتر سلام می دهد، و سوار بر پیاده، و راه رو به نشسته، و کم به زیاد. </p>',
            ],
            19 => [
                'question' => 'س 20: آداب اجازه گرفتن را ذکر کنید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12020.mp3',
                'answer' => '<p> ج- 1- قبل از ورود به محل اجازه می گیرم.<br /> 2- سه بار اجازه می گیرم نه بیشتر، و بعد از آن می روم.<br /> 3- به آرامی در را می کوبم و جلوی در نمی ایستم، بلکه در سمت راست یا چپ آن قرار می گیرم.<br /> 4- قبل از اجازه گرفتن به اتاق پدر و مادر و یا کسی دیگر داخل نمی شوم، به ویژه قبل از طلوع فجر و استراحت ظهر و بعد از نماز خفتن.<br /> 5- می توانم بدون اجازه وارد جاهای خالی از ساکنین مانند بیمارستان یا فروشگاه شوم. </p>',
            ],
            20 => [
                'question' => 'س 21: آداب مهربانی با حیوان را ذکر کنید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12100.mp3',
                'answer' => '<p> ج- 1- به حیوان غذا و آب می دهم.<br /> 2- رحمت وشفقت با حیوان، و عدم حمل کردن بالای آن بیش از تحملش.<br /> 3- حیوانات را با هیچ عذاب و آزاری شکنجه نمی کنم. </p>',
            ],
            21 => [
                'question' => 'س 22: آداب ورزش را ذکر کنید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12160.mp3',
                'answer' => '<p> ج-1- با ورزش نیت تقویت جهت اطاعت و رضامندی الله متعال می کنم.<br /> 2- در وقت نماز بازی نمی کنیم.<br /> 3- پسرها با دختران ورزش نمی کنند.<br /> 4- به لباس ورزش که عورتم را بپوشاند ملتزم می باشم.<br /> 5- از ورزش های حرام مانند ضربه زدن به صورت و آشکار کردن عورت پرهیز می کنم. </p>',
            ],
            22 => [
                'question' => 'س 23: برخی آداب مزاح کردن را ذکر کنید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12240.mp3',
                'answer' => '<p> 1- راستی در مزاح و دروغ نگفتن.<br /> 2- مزاح هایی که عاری از تمسخر و استهزا و بدرفتاری و ترساندن باشد.<br /> 3- عدم مزاح زیاد. </p>',
            ],
            23 => [
                'question' => 'س 24: آداب عطسه را ذکر کنید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12300.mp3',
                'answer' => '<p> ج-1- گذاشتن دست یا لباس یا دستمال هنگام عطسه.<br /> 2- حمد و ثنای الله بعد از عطسه، <br /> <span class="c3">«الحمدلله»</span>. ثنا وصفت الله را است.<br /> 3-<span class="c6"> برادر یا همراهش به او بگوید:</span> <br /> <span class="c3">«يرحمك الله»</span> <span class="c3">«الله تو را رحمت کند»</span>.<span class="c6"><br /> و اگر چنین گفت در جواب بگوید:</span> <span class="c3">«يهديكم الله ويصلح بالكم»</span>.<br /> <span class="c3">« يعنی: الله شما را هدايت کند و احوال تان را اصلاح بگرداند»</span>. </p>',
            ],
            24 => [
                'question' => 'س 25: آداب خمیازه چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12360.mp3',
                'answer' => '<p> ج-1- تلاش برای کنترول کردن خمیازه.<br /> 2- بلند نکردن صدا با گفتن <span class="c3">«هاااا»</span>.<br /> 3- گذاشتن دست روی دهان. </p>',
            ],
            25 => [
                'question' => 'س 26: آداب تلاوت را ذکر کنید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12420.mp3',
                'answer' => '<p> ج - 1 - بعد از وضو با طهارت تلاوت کردن.<br /> 2- مؤدبانه و با وقار نشستن.<br /> 3- در آغاز تلاوت از شیطان به الله پناه می برم.<br /> 4- در قرائت تدبر می کنم. </p>',
            ],
        ],
        7 => [
            0 => [
                'question' => 'س 1: فضیلت اخلاق نیکو را ذکر کنید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12500.mp3',
                'answer' => '<p> ج: پیامبر صلی الله علیه وسلم فرمود: <span class="c3">«کامل ترین مؤمنان از لحاظ ایمان، نیکوترین شان از لحاظ اخلاق هستند»</span>. روایت ترمذی و احمد. </p>',
            ],
            1 => [
                'question' => 'س2: چرا به اخلاق اسلامی پابند باشیم؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12530.mp3',
                'answer' => '<p> ج-1- زیرا سبب محبت الله متعال می گردد.<br /> 2- سبب محبت مردم می گردد.<br /> 3- سنگین ترین چیز در ترازو است.<br /> 4- اجر و ثواب با اخلاق نیک چند برابر می گردد.<br /> 5- نشانه ایمان کامل است. </p>',
            ],
            2 => [
                'question' => 'س3: اخلاق را از کجا باید بگیریم؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12600.mp3',
                'answer' => '<p> ج- از قرآن کریم،<span class="c6"> الله متعال می فرماید:</span> <span class="c4">﴿إِنَّ هَذَا الْقُرْآَنَ يَهْدِي لِلَّتِي هِيَ أَقْوَمُ﴾</span><br /> همانا این قرآن به راست و استوارترین طریقه هدایت می‌کند <span class="c5">[سورة الإسراء: ٩]</span>.<span class="c6"> و از سنت نبوی:</span> آنجا که رسول الله صلی الله علیه وسلم فرمود: <span class="c3">«من مبعوث شدم تا اخلاق نیکو را کامل کنم»</span> به روایت احمد. </p>',
            ],
            3 => [
                'question' => 'س4: اخلاق احسان و اشکال آن چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12640.mp3',
                'answer' => '<p> ج-<span class="c6"> احسان:</span> مراقبت الله متعال بشکل دوامدار ، تلاش در امور خیر ، و نیکی با مخلوق می باشد.<span class="c6"><br /> پیامبر ﷺ فرمود:</span> <span class="c3">«الله متعال احسان را بر هر چیزی قرار داده است»</span>. به روایت مسلم.<span class="c6"><br /> از نمونه های احسان:</span><br /> - احسان در عبادت الله متعال و اخلاص در عبادت اوست.<br /> - احسان به پدر و مادر در گفتار و عمل.<br /> - احسان به نزدیکان و خویشاوندان.<br /> - احسان با همسایه.<br /> - احسان با یتیمان و نیازمندان.<br /> - احسان با کسی که با تو رفتار بد می کند.<br /> - احسان در گفتار.<br /> - احسان در گفتگو.<br /> - احسان با حیوان. </p>',
            ],
            4 => [
                'question' => 'س5: ضد احسان چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12780.mp3',
                'answer' => '<p> ج – ضد احسان بدی است.<span class="c6"><br /> * از آن جمله:</span> ترک اخلاص در عبادت الله متعال.<br /> * نافرمانی والدین.<br /> • و قطع صلۀ رحم با نزدیکان.<br /> • همسایگی بد.<br /> • ترک احسان با فقیران و مسکینان و دیگران از جمله کارها و گفتارهای بد می باشد. </p>',
            ],
            5 => [
                'question' => 'س6: انواع و اشکال امانت چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12860.mp3',
                'answer' => '<p> ج-<br /> 1- امانت در حفظ حقوق الله متعال.<span class="c6"><br /> اشکال آن:</span> امانت در انجام عبادات مانند نماز، زکات، روزه، حج و غیره که الله متعال بالای ما فرض گردانیده است.<br /> 2-<span class="c6"> امانت در حفظ حقوق مردم:</span><br /> · نگه داشتن نوامیس مردم.<br /> · مال های مردم.<br /> · خون شان.<br /> و رازهاى آنها، و همه چیزهایی که مردم به شما امانت سپرده اند.<span class="c6"><br /> الله متعال در بیان ویژگی های رستگاران می فرماید:</span> <span class="c4">﴿وَالَّذِينَ هُمْ لِأَمَانَاتِهِمْ وَعَهْدِهِمْ رَاعُونَ 8﴾</span><br /> و كسانى كه امانتها و پيمان خود را مراعات مى كنند <span class="c5">[سورة المؤمنون: ٨]</span>. </p>',
            ],
            6 => [
                'question' => 'س 7: ضد امانت چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12980.mp3',
                'answer' => '<p> ج - خیانت عبارت است از ضايع نمودن حقوق الله متعال و مردم.<span class="c6"><br /> پیامبر اکرم صلی الله علیه وسلم فرمودند:</span> نشانۀ منافق سه است – از آن جمله - اگر به او امانت داده شود خیانت می کند. متفق عليه. </p>',
            ],
            7 => [
                'question' => 'س 8: اخلاق راستگویی چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13020.mp3',
                'answer' => '<p> ج- بیان آن چیزی که مطابق واقعیت و یا چیزی که همانطور هست، باشد.<span class="c6"><br /> از اشکال آن:</span><br /> راستگویی در صحبت با مردم<br /> راستگویی در وعده<br /> راستگویی در هر گفتار و کردار.<span class="c6"><br /> پیامبر اکرم صلی الله علیه وسلم فرمودند:</span> <span class="c3">«راستگویی به نیکی، و نیکی به بهشت رهنمایی می کند، و انسان راستگویی را پیشه می کند تا این که راستگویی خصلت او قرار گیرد »</span>. متفق عليه. </p>',
            ],
            8 => [
                'question' => 'س 9: ضد راستگویی چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13100.mp3',
                'answer' => '<p> ج – دروغ، که خلاف حقیقت است، از جمله، دروغ به مردم، و عهدشکنی، و سوگند دروغ می باشد.<span class="c6"><br /> پیامبر ﷺ فرمود:</span> <span class="c3">«دروغ به فسق رهنمایی می کند، و فسق به آتش رهنمایی می کند، و انسان دروغ می گوید تا این که نزد الله به عنوان دروغگو نوشته شود»</span>. متفق عليه.<span class="c6"> و پیامبر صلی الله علیه وسلم فرمود:</span> نشانهء منافق سه است - و از آن جمله ذکر کرد - هرگاه سخن بگوید دروغ می گوید، و هرگاه عهد بگذارد وعده خلافی می کند. متفق عليه. </p>',
            ],
            9 => [
                'question' => 'س10: انواع صبر را بیان کن؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13140.mp3',
                'answer' => '<p> ج - صبر در طاعت الله متعال.<br /> صبر از معصیت و گناه.<br /> صبر بر قدر دردناک، و ستایش الله را در هر حال بجا آوردن.<span class="c6"><br /> الله متعال فرموده اند:</span> <span class="c4">﴿وَٱللَّهُ يُحِبُّ ٱلصَّـبِرِينَ 146﴾</span><br /> الله صبر کننده گان را دوست می دارد. <span class="c5">[سورة آل عمران: ١٤٦]</span>.<span class="c6"> و پیامبر صلی الله علیه وسلم فرمود:</span> <span class="c3">«چه شگفت‌انگیز است امر مؤمن، زیرا همه امور او نیکو است، و این برای کسی جز مؤمن نیست»</span>. اگر به او سعادت می رسد، شکر می‌کند و برایش خیر است، و اگر مصیبت به او می ‌رسد، صبر می‌کند و این برایش خیر است». به روایت مسلم. </p>',
            ],
            10 => [
                'question' => 'س١١:  ضد صبر چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13210.mp3',
                'answer' => '<p> ج - عدم صبر در طاعت و عدم صبر از معصیت و نارضایتی قدر به گفتار یا عمل می باشد.<span class="c6"><br /> از اشکال آن:</span><br /> § آرزوی مرگ.<br /> § زدن به صورت.<br /> § پاره کردن لباس.<br /> § پخش احساسات.<br /> § دعای بد برای از بین رفتن خویش.<span class="c6"><br /> پیامبر اکرم صلی الله علیه وسلم فرمودند:</span> پاداش با تناسب بزرگی مصیبت می باشد، و اگر الله متعال قومی را دوست بدارد آنها را می آزماید، پس هر که راضی باشد برای او رضامندیست، و هر که بی قراری نماید برای او بی قراریست. از ترمذی و ابن ماجه روایت شده است. </p>',
            ],
            11 => [
                'question' => 'س12: اخلاق همکاری را ذکر کنید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13310.mp3',
                'answer' => '<p> ج - آن عبارت از همکاری مردم در میان خود در امور حق و خیر می باشد.<span class="c6"><br /> اشکال همکاری:</span><br /> o همکاری در اعاده حقوق.<br /> o همکاری در دفع ظالم.<br /> o همکاری در رفع نیازهای مردم و نیازمندان.<br /> o همکاری در همه امور خیر.<br /> o عدم همکاری در گناه و ضرر و تجاوز.<span class="c6"><br /> الله متعال می فرماید:</span> <span class="c4">﴿وَتَعَاوَنُوا عَلَى الْبِرِّ وَالتَّقْوَى وَلَا تَعَاوَنُوا عَلَى الْإِثْمِ وَالْعُدْوَانِ وَاتَّقُوا اللَّهَ إِنَّ اللَّهَ شَدِيدُ الْعِقَابِ 2﴾</span><br /> و در نيكوكارى و پرهيزگارى با يكديگر همكارى كنيد و در گناه و تعدى دستيار هم نشويد و از الله خوف كنيد كه الله سخت ‏كيفر است <span class="c2">(۲)</span> <span class="c5">[سورۀ مائده: 2]</span>.<span class="c6"> پیامبر اکرم صلی الله علیه وسلم فرمودند:</span> <span class="c3">«مؤمن نسبت به مؤمن مانند ساختمان است، که یکدیگر را استحکام می بخشند»</span> متفق عليه.<span class="c6"> و پیامبر صلی الله علیه وسلم فرمود:</span> <span class="c3">«مسلمان برادر مسلمان است، به او ستم نمی کند، او را به دشمن تسلیم نمی کند، و هر کس نیاز برادرش را مرفوع نماید، الله متعال نیاز او را مرفوع می دارد، و هر کس یک سختی مسلمان را دور کند، الله متعال یکی از سختی‌های روز قیامت را از او دور می کند، و هر که عیب مسلمانی را پنهان کند، الله متعال عیب او را در روز قیامت می‌پوشاند»</span>. متفق علیه. </p>',
            ],
            12 => [
                'question' => 'س13: انواع اخلاق حيا کدام ها اند؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13420.mp3',
                'answer' => '<p> الف-1-<span class="c6"> حیا از الله متعال:</span> آن است که او تعالی را نافرمانی نکنی.<br /> 2-<span class="c6"> حیا از مردم:</span> از آن جمله پرهیز از سخنان ناپسندیده و ناسزا و آشکار کردن عورت است.<span class="c6"><br /> رسول الله ﷺ فرمود:</span> «ایمان هفتاد و چند و یا <span class="c2">(شصت و چند)</span> شاخه می باشد،<span class="c6"> که بالاترین آن گفتن:</span> لا اله الا الله است،<span class="c6"> و پایین ترین آن:</span> برداشتن چیزی اذیت کننده از راه می باشد، و حیا شاخه ای از ایمان است.» به روایت مسلم. </p>',
            ],
            13 => [
                'question' => 'س 14: اشکال اخلاق رحمت را ذکر کنید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13470.mp3',
                'answer' => '<p> ج - - ترحم و احترام به سالمندان.<br /> - شفقت بر کم سنان و کودکان.<br /> - ترحم بر فقرا و مساکین و نیازمندان.<br /> - ترحم بر حیوان با غذا دادن و آسیب نرساندن به آن.<span class="c6"><br /> از آن جمله فرمودۀ پیامبر صلی الله علیه وسلم که می فرماید:</span> مؤمنان را در شفقت و محبت و همدردی با یکدیگر مانند یک بدن هستند، اگر یک عضو آن به درد آید، بقیه بدنش را بی‌خوابی و تب فرا می گیرد. متفق عليه.<span class="c6"> رسول الله ﷺ فرمود:</span> <span class="c3">«رحم کننده گان را رحمان مورد رحمت خود قرار می دهد، بر اهل زمین رحم کنید، تا ذاتی که در آسمان است به شما رحم کند.»</span> از ابوداود و ترمذی روایت شده است. </p>',
            ],
            14 => [
                'question' => 'س 15: انواع اخلاق محبت کدام ها اند؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13550.mp3',
                'answer' => '<p> ج- محبت الله متعال.<span class="c6"><br /> الله می فرماید:</span> <span class="c4">﴿وَالَّذِينَ آَمَنُوا أَشَدُّ حُبًّا لِلَّهِ﴾</span><br /> كسانى كه ايمان آورده‏ اند به الله محبت بيشترى دارند. <span class="c5">[سوره بقره: 165]</span>.<br /> محبت پیامبر ﷺ.<span class="c6"><br /> فرمود:</span> <span class="c3">«سوگند به کسی که جان من در اختیار اوست، هیچ یک از شما ایمان نمی‌آورد، مگر اینکه من نزد او از پدر و پسرش عزیزتر باشم»</span>. روایت بخاری.<br /> دوستی با مومنان ، و دوست داشتن خیر برای آنها همانطوری که تو برای خود دوست داری.<span class="c6"><br /> پیامبر اکرم صلی الله علیه وسلم فرمودند:</span> <span class="c3">«هیچ یک از شما ایمان نمی‌ آورد تا آنکه برای برادرش آنچه را دوست بدارد که برای خود دوست می دارد»</span>. به روایت بخاری. </p>',
            ],
            15 => [
                'question' => 'س 16: بشاشت و پیشانی باز را تعریف کن؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13630.mp3',
                'answer' => '<p> ج – آن عبارت از پیشانی بازی، همراه با شادی و تبسم و مهربانی، و ابراز خوشی هنگام ملاقات با مردم است.<br /> این برعکس پیشانی ترشی در مقابل مردم است که آنها را از خود دور می کند.<br /> و در فضیلت آن حدیث های وجود دارد،<span class="c6"> و از ابوذر رضی الله عنه روایت شده که گفت:</span> پیامبر صلی الله علیه وسلم به من فرمود: <span class="c3">«هیچ چیز خوبی را تحقیر مکن، حتی اگر برادرت را با چهره ای بشاش و گشاده رویی ملاقات کنی»</span>. به روایت مسلم.<span class="c6"> رسول الله ﷺ فرمود:</span> لبخند تو در مقابل برادرت برای تو صدقه است. به روایت ترمذی. </p>',
            ],
            16 => [
                'question' => 'س 17: حسد چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13690.mp3',
                'answer' => '<p> ج- آرزوی زوال نعمت از دیگران یا خوش نداشتن نعمت بر دیگران است.<span class="c6"><br /> الله متعال فرمود:</span> <span class="c4">﴿وَمِنْ شَرِّ حَاسِدٍ إِذَا حَسَدَ 5﴾</span><br /> و از شر <span class="c5">[هر]</span> حسود آنگاه كه حسد ورزد <span class="c2">(۵)</span><br /> از انس بن مالک رضی الله عنه روايت است که رسول الله صلی الله علیه وسلم فرمود: <span class="c3">«از یکدیگر متنفر نباشید، به یکدیگر حسادت نکنید، از یکدیگر رونگردانید، و با هم –بنده گان الله - برادر باشید»</span>. روايت از بخاری و مسلم. </p>',
            ],
            17 => [
                'question' => 'س18: تمسخر چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13740.mp3',
                'answer' => '<p> ج - آن عبارت از تمسخر و تحقیر برادر مسلمانت است، و این جایز نیست.<span class="c6"><br /> الله متعال در مورد حرام بودن آن فرمود:</span> <span class="c4">﴿يَا أَيُّهَا الَّذِينَ آَمَنُوا لَا يَسْخَرْ قَومٌ مِنْ قَوْمٍ عَسَى أَنْ يَكُونُوا خَيْرًا مِنْهُمْ وَلَا نِسَاءٌ مِنْ نِسَاءٍ عَسَى أَنْ يَكُنَّ خَيْرًا مِنْهُنَّ وَلَا تَلْمِزُوا أَنْفُسَكُمْ وَلَا تَنَابَزُوا بِالْأَلْقَابِ بِئْسَ الِاسْمُ الْفُسُوقُ بَعْدَ الْإِيمَانِ وَمَنْ لَمْ يَتُبْ فَأُولَئِكَ هُمُ الظَّالِمُونَ 11﴾</span><br /> اى كسانى كه ايمان آورده‏ ايد نبايد قومى قوم ديگر را تمسخر كند شايد آنها از اينها بهتر باشند و نبايد زنانى زنان <span class="c5">[ديگر]</span> را <span class="c5">[تمسخر كنند ]</span> شايد آنها از اينها بهتر باشند و از يكديگر عيب مگيريد و به همديگر لقب هاى زشت مدهيد چه ناپسنديده است نام زشت پس از ايمان و هر كه توبه نكرد آنان خود ستمكارند <span class="c2">(۱۱)</span> <span class="c5">[سورة الحجرات: ١١]</span>. </p>',
            ],
            18 => [
                'question' => 'س 19: تواضع را تعریف کنید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13780.mp3',
                'answer' => '<p> ج- آن است که انسان در برابر مردم نفس خود را برتر نبیند، و مردم را حقیر نشمارد و حق را رد نکند.<br /> -<span class="c6"> الله متعال می فرماید:</span> <span class="c4">﴿وَعِبَادُ الرَّحْمَنِ الَّذِينَ يَمْشُونَ عَلَى الْأَرْضِ هَوْنًا﴾</span><br /> و بندگان رحمان کسانی هستند که در زمین با فروتنی راه می روند. <span class="c5">[سورة الفرقان: ٦٣]</span>،<span class="c6"> یعنی:</span> فروتنان. -<span class="c6"> رسول الله ﷺ فرمود:</span> <span class="c3">«هیچ کس در برابر الله فروتنی نمی کند مگر اینکه الله او را رفعت و بلندی بخشد»</span>. به روایت مسلم. -<span class="c6"> و او صلی الله علیه وسلم فرمود:</span> <span class="c3">«الله به من وحی کرد که فروتن باشیم، تا هیچ کس به دیگری مغرور نگردد و به دیگری ستم نکند»</span>. به روایت مسلم. </p>',
            ],
            19 => [
                'question' => 'س 20: انواع تکبر حرام کدامند؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13840.mp3',
                'answer' => '<p> ج-1- تکبر در برابر حق، و آن رد نمودن حق و عدم پذیرش آن است.<br /> 2- تکبّر نسبت به مردم، و به چشم حقارت دیدن و کوچک شمردن آنان است.<span class="c6"><br /> رسول الله ﷺ فرمود:</span> <span class="c3">«کسی که ذره‌ای تکبر در دلش باشد وارد بهشت نمی‌شود»</span>.<span class="c6"> مردی گفت:</span> یک مرد دوست دارد لباس و کفشش خوب باشد؟<span class="c6"> او گفت:</span> <span class="c3">«إنَّ اللهَ جَميلٌ يُحِبُّ الجَمالَ،<span class="c6"> الكِبْرُ:</span> بَطَرُ الحَقِّ، وَغَمْطُ النَّاسِ»</span><br /> <span class="c3">«الله زیباست و زیبایی را دوست می‌دارد،<span class="c6"> تکبر:</span> رد نمودن حق، و تحقیر مردم است»</span>. به روایت مسلم.<span class="c6"><br /> بطرالحق:</span> رد نمودن حق.<span class="c6"><br /> غمط الناس:</span> تحقیر مردم.<br /> لباس خوب و کفش خوب تکبر نیست. </p>',
            ],
            20 => [
                'question' => 'س 21: بعضی از انواع تقلب حرام را ذکر کنید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13910.mp3',
                'answer' => '<p> ج- تقلب در خرید و فروش، و آن کتمان عیب در کالا می باشد.<br /> تقلب در فراگیری علم، مانند نقل کردن دانش آموزان در امتحانات.<br /> تقلب در گفتار مانند گواهی دروغ و دروغ گفتن است.<br /> وفا نکردن به آنچه می گویید و آنچه با مردم توافق کرده ایید.<br /> در مورد نهی از تقلب، رسول الله صلی الله علیه وسلم از جلو انباری <span class="c2">(کومه)</span> از غذا عبور می کرد، دستش را در آن نهاد، انگشتانش خیس شد،<span class="c6"> گفت:</span> این چیست ای صاحب غذا؟<span class="c6"> گفت:</span> باران بر آن رسیده یا رسول الله.<span class="c6"> وی گفت:</span> <span class="c3">«آیا آن را روی غذا قرار ندادی تا مردم آن را ببینند؟ هر که خیانت کند از من نیست.»</span> <span class="c3">«آیا آن را روی غذا قرار ندادی تا مردم آن را ببینند؟ هر که خیانت کند از من نیست.»</span> به روایت مسلم<br /> الصبرة: انبار و یا كومۀ غذا. </p>',
            ],
            21 => [
                'question' => 'س 22: غیبت چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13990.mp3',
                'answer' => '<p> ج - یاد کردن برادر مسلمانت به آنچه را که دوست ندارد در حالی که حضور نداشته باشد.<span class="c6"><br /> الله متعال می فرماید:</span> <span class="c4">﴿وَلَا يَغْتَبْ بَعْضُكُمْ بَعْضًا أَيُحِبُّ أَحَدُكُمْ أَنْ يَأْكُلَ لَحْمَ أَخِيهِ مَيْتًا فَكَرِهْتُمُوهُ وَاتَّقُوا اللَّهَ إِنَّ اللَّهَ تَوَّابٌ رَحِيمٌ 12﴾</span><br /> و بعضى از شما غيبت بعضى نكند آيا كسى از شما دوست دارد كه گوشت برادر مرده‏ اش را بخورد از آن كراهت داريد <span class="c5">[پس]</span> از الله بترسيد كه الله توبه‏ پذير مهربان است <span class="c2">(۱۲)</span> <span class="c5">[سورة الحجرات: ١٢]</span>. </p>',
            ],
            22 => [
                'question' => 'س23: سخن چینى را تعریف کنید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14030.mp3',
                'answer' => '<p> ج- نقل سخنان بین مردم جهت ايجاد فساد در میان ایشان.<br /> -<span class="c6"> رسول الله ﷺ فرمود:</span> سخن چین وارد بهشت نمی شود. به روایت مسلم. </p>',
            ],
            23 => [
                'question' => 'س 24: کسالت چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14070.mp3',
                'answer' => '<p> ج- تنبلی از انجام نمودن کار خیر و هر آنچه که انسان آن را باید انجام دهد.<span class="c6"><br /> از آن جمله:</span> تنبلی در کارهای واجب.<span class="c6"><br /> الله متعال فرموده اند:</span> <span class="c4">﴿إِنَّ الْمُنَافِقِينَ يُخَادِعُونَ اللَّهَ وَهُوَ خَادِعُهُمْ وَإِذَا قَامُوا إِلَى الصَّلَاةِ قَامُوا كُسَالَى يُرَاءُونَ النَّاسَ وَلَا يَذْكُرُونَ اللَّهَ إِلَّا قَلِيلًا 142﴾</span><br /> منافقان با الله نيرنگ مى كنند و حال آنكه او با آنان نيرنگ خواهد كرد و چون به نماز ايستند با كسالت برخيزند با مردم ريا مى كنند و الله را جز اندكى ياد نمى كنند <span class="c2">(۱۴۲)</span> <span class="c5">[سورة النساء: ١٤٢]</span>.<br /> مؤمن باید تنبلی و سستی و نشستن را ترک کند، برای کار و حرکت در این زندگی در اموری سعی و مجاهدت نماید که الله متعال راضی باشد. </p>',
            ],
            24 => [
                'question' => 'س25: انواع غضب را ذکر کنید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14130.mp3',
                'answer' => '<p> ج-1-<span class="c6"> خشم پسندیده:</span> و آن خشمی است که برای الله متعال باشد، هرگاه كفار و منافقان و ديگران هتک حرمت الله متعال را مرتکب شوند.<br /> 2-<span class="c6"> خشم ناپسند:</span> خشمی است که انسان را وادار به کار و یا گفتاری نماید که مناسب نباشد.<span class="c6"><br /> درمان خشم ناپسند:</span><br /> وضوء.<br /> اگر ایستاده باشد بنشیند، و اگر نشسته باشد دراز بکشد.<span class="c6"><br /> به دستور پیامبر اکرم صلی الله علیه وسلم در این زمینه عمل کند:</span> <span class="c3">«قهر مکن»</span>.<br /> هنگام خشم نفس خود را از واکنش نشان دادند منع کند.<br /> پناه بردن به الله از شر شیطان رانده شده.<br /> خاموشی. </p>',
            ],
            25 => [
                'question' => 'س26: جاسوسی چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14240.mp3',
                'answer' => '<p> ج - کشف و جستجوی عیب ها و رازهای مردم و آنچه را پنهان می دارند.<span class="c6"><br /> از اشکال حرام آن:</span><br /> - مطلع شدن از عیب ها و رازهای مردم در خانه ها.<br /> - گوش دادن به سخنان مردم بدون اطلاع آنان.<span class="c6"><br /> الله متعال می فرماید:</span> "و جاسوسی نکنید..." <span class="c5">[سورة الحجرات: ١٢]</span>. </p>',
            ],
            26 => [
                'question' => 'س 27: اسراف چیست؟ و بخل چیست؟ و سخاوت چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14310.mp3',
                'answer' => '<p> ج-<span class="c6"> اسراف:</span> مصرف نمودن مال بغیر حق آن.<span class="c6"><br /> و ضد آن:</span> بخل: عدم مصرف نمودن حق خود .<br /> آنچه درست است وسط آن دو است، و اينكه مسلمان باید سخاوتمند باشد.<span class="c6"><br /> الله متعال فرموده اند:</span> <span class="c4">﴿وَٱلَّذِينَ إِذَاۤ أَنفَقُوا لَمۡ يُسۡرِفُوا وَلَمۡ يَقۡتُرُوا وَكَانَ بَيۡنَ ذَ لِكَ قَوَامًا 67﴾</span><br /> و كسانى‏ اند كه چون انفاق كنند نه اسراف مى كنند و نه تنگ مى‏ گيرند و ميان اين دو <span class="c5">[روش]</span> حد وسط را برمى‏ گزينند <span class="c2">(۶۷)</span> <span class="c5">[سوره فرقان، آیه 67]</span>. </p>',
            ],
            27 => [
                'question' => 'س28: بزدلی چیست؟ و شجاعت چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14370.mp3',
                'answer' => '<p> ج-<span class="c6"> بزدلی:</span> ترس از آنچه که نباید از آن ترسید<br /> مانند ترس از گفتن حق و انکار منکر.<span class="c6"><br /> شجاعت :</span> پیشتازی در حق می باشد، مانند پیشقدم شدن در جبهه های جهاد برای دفاع از اسلام و مسلمانان .<span class="c6"><br /> پیامبر اکرم صلی الله علیه وسلم در دعای خود می فرمودند:</span> الهی از بزدلی به تو پناه می برم...».<span class="c6"> رسول الله ﷺ فرمود:</span> مؤمن قوی نزد الله بهتر و محبوبتر از مؤمن ضعیف است، و در همۀ آنها خیر است. به روایت مسلم. </p>',
            ],
            28 => [
                'question' => 'س29: برخی از گفتارهای حرام زبانی را ذکر کنید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14440.mp3',
                'answer' => '<p> ج - مانند لعن گفتن و دشنام دادن.<br /> و مانند اين كه فلان بگوید <span class="c3">«حیوان»</span> یا شبیه این حرف ها.<br /> یا ذکر عورت ها از حرف های فحش و بد زبانی.<span class="c6"><br /> پیامبر اکرم صلی الله علیه وسلم از همه اینها نهی کرد و فرمود:</span> <span class="c3">«مؤمن نمی توان طعنه دهنده، فُحش دهنده، و بد زبان باشد»</span>. از ترمذی و ابن حبان روایت شده است. </p>',
            ],
            29 => [
                'question' => 'س 30: عواملی را ذکر کنید که باعث اخلاق نیکو در مسلمان می گردد؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14500.mp3',
                'answer' => '<p> ج-1- دعا كردن، این كه الله به شما خلق نیکو عنایت فرماید و شما را در آن یاری دهد.<br /> 2- مراقبت الله متعال، و اینکه وی از شما آگاه است و می شنود و شما را می بیند.<br /> 3- ثواب خوش اخلاقی را به خاطر بسپار و اینکه سبب ورود به بهشت می شود.<br /> 4- عاقبت بد اخلاقی را به خاطر بسپار، و این که سبب ورود به آتش می شود.<br /> 5- اخلاق نیک، محبت الله متعال و محبت مخلوق وی را به همراه دارد، و بد اخلاقی، بی زاری الله و مخلوق وی را به همراه دارد.<br /> 6- خواندن سیرت پیامبر صلی الله علیه وسلم و پیروی از وی.<br /> 7- همنشینی با افراد خوب، و دوری از همنشینی با افراد بد. </p>',
            ],
        ],
        8 => [
            0 => [
                'question' => 'س 1: فضیلت ذکر چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14630.mp3',
                'answer' => '<p> ج-<span class="c6"> پیامبر اکرم صلی الله علیه وسلم فرمودند:</span> <span class="c3">« مثال کسی که ذکر پروردگارش را می کند و کسی که ذکر وی را نمی کند، مانند زنده و مرده اند»</span>. به روایت بخاری.<br /> - به همین دلیل ارزش زندگی انسان به اندازۀ ذکر او از الله متعال است. </p>',
            ],
            1 => [
                'question' => 'س2: برخی از فواید ذکر را تذکر دهید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14670.mp3',
                'answer' => '<p> ج-1- الله را خشنود می سازد.<br /> 2- شیطان را می راند.<br /> 3- مسلمان را از بدی ها حفظ می کند.<br /> 4- سبب حصول اجر و پاداش می گردد. </p>',
            ],
            2 => [
                'question' => 'س3: بهترین ذکر چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14730.mp3',
                'answer' => '<p> ج - لا اله الا الله. از ترمذی و ابن ماجه روایت شده است. </p>',
            ],
            3 => [
                'question' => 'س4: وقتی از خواب بلند می شوی چه می گویي؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14760.mp3',
                'answer' => '<p> ج – <span class="c3">«الحمد لله الذي أحيانا بعد ما أماتنا، وإليه النشور»</span><br /> حمد و ستایش مخصوص الله است که ما را پس از مردن زنده نمود، و دوباره زنده شدن بسوی او است. متفق عليه. </p>',
            ],
            4 => [
                'question' => 'س5: هنگام لباش پوشیدن چه می گویی؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14790.mp3',
                'answer' => '<p> ج – <span class="c3">«الحمد لله الذي كساني هذا الثوب ورزقنيه من غير حول مني ولا قوة»</span><br /> <br /> سپاس الله را که این جامه را بر من پوشاند و ارزانی فرمود، بدون این که هیچ توان و قدرتی بر آن داشته باشم. روایت ابوداود و ترمذی و دیگران. </p>',
            ],
            5 => [
                'question' => 'س6: هنگام درآوردن لباس چه می گویید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14820.mp3',
                'answer' => '<p> ج- <span class="c3">«بسم الله»</span><br /> به نام الله به روایت ترمذی. </p>',
            ],
            6 => [
                'question' => 'س 7: دعایی پوشیدن جامه نو چه است؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14850.mp3',
                'answer' => '<p> ج – <span class="c3">«اللهم لك الحمد أنت كسوتنيه، أسألك خيره وخير ما صنع له، وأعوذ بك من شره وشر ما صنع له»</span><br /> «الهی همه ستایش تو را است، تو مرا لباس پوشانيدی، از تو می خواهم خیر آن و خیر آنچه را برای آن آفریده شده است، و به تو پناه می برم از شر آن و بدی که برای آن آفریده شده است. " از ابوداود و ترمذی روایت شده است. </p>',
            ],
            7 => [
                'question' => 'س 8: کسى که جامه نو بپوشد چه دعاى دارد؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14880.mp3',
                'answer' => '<p> ج -<span class="c6"> اگر جامه نو بر تن کسی دیدی برای آن دعا کن و بگو:</span> <span class="c3">«تُبْلِي ويُخلف الله تعالى»</span><br /> <span class="c3">«فرسوده می شود و الله متعال دیگری عنایت می کند»</span> روایت ابوداود. </p>',
            ],
            8 => [
                'question' => 'س 9: دعای دخول بیت الخلاء که محل قضای حاجت است را ذکر کنید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14910.mp3',
                'answer' => '<p> ج – <span class="c3">«اللهم إني أعوذ بك من الخبث والخبائث»</span><br /> الهی از شیطانان <span class="c2">(جن های)</span> مرد و زن به تو پناه می‌برم. متفق علیه </p>',
            ],
            9 => [
                'question' => 'س10: دعای خروج از بیت الخلاء چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14940.mp3',
                'answer' => '<p> ج – <span class="c3">«غفرانك»</span><br /> "الهی ببخشا" از ابوداود و ترمذی روایت شده است. </p>',
            ],
            10 => [
                'question' => 'س 11: قبل از وضو چه می گویی؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14970.mp3',
                'answer' => '<p> ج- <span class="c3">«بسم الله»</span><br /> به نام الله روایت ابوداود و دیگران. </p>',
            ],
            11 => [
                'question' => 'س 12: دعای بعد از وضو چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15000.mp3',
                'answer' => '<p> ج – <span class="c3">«أشهد أن لا إله إلا الله وحده لا شريك له، وأشهد أن محمدا عبده ورسوله»</span><br /> شهادت می‌دهم که معبودی جز الله نیست و تنها بی همتا است، و شهادت می‌دهم که محمد بنده و فرستاده اوست. به روایت مسلم. </p>',
            ],
            12 => [
                'question' => 'س13: دعای خروج از منزل چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15020.mp3',
                'answer' => '<p> ج – <span class="c3">«بسم الله، توكلت على الله، ولا حول ولا قوة إلا بالله»</span><br /> بسم الله، بر الله توکل کردم، و هیچ نیرو و قدرتی جز به الله نیست. از ابوداود و ترمذی روایت شده است. </p>',
            ],
            13 => [
                'question' => 'س 14: دعای ورود به خانه چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15050.mp3',
                'answer' => '<p> ج – <span class="c3">«"بسم الله ولجنا، وبسم الله خرجنا، وعلى الله ربنا توكلنا"، ثم ليسلم على أهله»</span><br /> <br /> <span class="c3">«بنام الله داخل شدیم، و بنام الله خارج شدیم، و بر الله؛ پروردگارمان توکل کردیم.»</span> سپس به خانواده خود سلام دهد. روایت ابوداود. </p>',
            ],
            14 => [
                'question' => 'س 15: دعای ورود به مسجد چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15080.mp3',
                'answer' => '<p> ج – <span class="c3">«اللهم افتح لي أبواب رحمتك»</span> <br /> <span class="c3">«الهی درهای رحمتت را بر من بگشا»</span> <br /> به روایت مسلم. </p>',
            ],
            15 => [
                'question' => 'س 16: دعای خروج از مسجد را ذکر کنید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15110.mp3',
                'answer' => '<p> ج – <span class="c3">«اللهم إني أسألك من فضلك»</span> رواه مسلم.<br /> <span class="c3">«الهی فضل تو را می طلبم»</span> به روایت مسلم. </p>',
            ],
            16 => [
                'question' => 'س 17: هنگام شنیدن اذان چه می گویید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15140.mp3',
                'answer' => '<p> ج – همان را می گویم که مؤذن می گوید مگر در: <span class="c3">«حي على الصلاة»</span> و<span class="c3">«حي على الفلاح»</span>،<span class="c6"> می گویم که:</span> <span class="c3">«لا حول ولا قوة إلا بالله»</span>. متفق عليه. </p>',
            ],
            17 => [
                'question' => 'س 18: بعد از اذان چه می گویید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15170.mp3',
                'answer' => '<p> ج- <span class="c2">(بر پیامبر صلی الله علیه وسلم درود بفرست)</span> به روایت مسلم.<span class="c6"> و بگو:</span> <span class="c3">«اللهم رب هذه الدعوة التامة، والصلاة القـائـمـة، آت محـمـدًا الـوسـيلة والفـضـيلـة، وابـعثه مقامًا محمودًا الذي وعدته»</span><br /> <span class="c3">«الهی پروردگار این اذان و نماز برپا شده، به محمد وسیله و فضیلت عطا کن، و او را به جایگاه ستوده‌ای که به او وعده داده‌ای بفرست»</span>. بخاری.<br /> و بین اذان و اقامت دعا کن، چون زمان استجابت دعا می باشد. </p>',
            ],
            18 => [
                'question' => 'س 19: در اذکار صبح و شام چه می گویید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15220.mp3',
                'answer' => '<p> ج-1-<span class="c6"> آیت کرسی را تلاوت می کنم:</span> <span class="c4">﴿اللَّهُ لَا إِلَهَ إِلَّا هُوَ الْحَيُّ الْقَيُّومُ لَا تَأْخُذُهُ سِنَةٌ وَلَا نَوْمٌ لَهُ مَا فِي السَّمَاوَاتِ وَمَا فِي الْأَرْضِ مَنْ ذَا الَّذِي يَشْفَعُ عِنْدَهُ إِلَّا بِإِذْنِهِ يَعْلَمُ مَا بَيْنَ أَيْدِيهِمْ وَمَا خَلْفَهُمْ وَلَا يُحِيطُونَ بِشَيْءٍ مِنْ عِلْمِهِ إِلَّا بِمَا شَاءَ وَسِعَ كُرْسِيُّهُ السَّمَاوَاتِ وَالْأَرْضَ وَلَا يَئُودُهُ حِفْظُهُمَا وَهُوَ الْعَلِيُّ الْعَظِيمُ 255﴾</span><br /> <br /> الله است كه معبودى جز او نيست زنده و برپا دارنده است نه خوابى سبك او را فرو مى‏ گيرد و نه خواب گران. آنچه در آسمانها و آنچه در زمين است از آن اوست. كيست آن كس كه جز به اذن او در پيشگاهش شفاعت كند. آنچه در پيش روى آنان و آنچه در پشت‏ سرشان است مى‏ داند و به چيزى از علم او جز به آنچه بخواهد احاطه نمى‏ يابند كرسى او آسمانها و زمين را در بر گرفته و نگهدارى آنها بر او دشوار نيست و اوست والاى بزرگ <span class="c2">(۲۵۵)</span> [سوره بقره: 255. 2-<span class="c6"> و می خوانم:</span> بِسۡمِ ٱللَّهِ ٱلرَّحۡمَـٰنِ ٱلرَّحِيمِ<br /> بنام الله بخشاینده و مهربان ﴿قُلْ هُوَ اللَّهُ أَحَدٌ 1 <br /> بگو اوست‏ الله يگانه <span class="c2">(۱)</span> اللَّهُ الصَّمَدُ 2<br /> الله بی نیاز <span class="c2">(۲)</span> لَمْ يَلِدْ وَلَمْ يُولَدْ 3<br /> نزاده و زاده نشده است <span class="c2">(۳)</span> وَلَمْ يَكُنْ لَهُ كُفُوًا أَحَدٌ 4﴾<br /> و هيچ كس او را همتا نيست <span class="c2">(۴)</span> سه مرتبه بِسۡمِ ٱللَّهِ ٱلرَّحۡمَـٰنِ ٱلرَّحِيمِ<br /> بنام الله بخشاینده و مهربان ﴿قُلْ أَعُوذُ بِرَبِّ الْفَلَقِ 1<br /> بگو پناه مى برم به پروردگار سپيده دم <span class="c2">(۱)</span> مِنْ شَرِّ مَا خَلَقَ 2<br /> از شر آنچه آفريده <span class="c2">(۲)</span> وَمِنْ شَرِّ غَاسِقٍ إِذَا وَقَبَ 3<br /> و از شر تاريكى چون فراگيرد <span class="c2">(۳)</span> وَمِنْ شَرِّ النَّفَّاثَاتِ فِي الْعُقَدِ 4<br /> و از شر دمندگان افسون در گره ‏ها <span class="c2">(۴)</span> وَمِنْ شَرِّ حَاسِدٍ إِذَا حَسَدَ 5﴾<br /> و از شر <span class="c5">[هر]</span> حسود آنگاه كه حسد ورزد <span class="c2">(۵)</span> سه مرتبه. بِسۡمِ ٱللَّهِ ٱلرَّحۡمَـٰنِ ٱلرَّحِيمِ<br /> بنام الله بخشاینده و مهربان ﴿قُلْ أَعُوذُ بِرَبِّ النَّاسِ 1<br /> بگو پناه مى برم به پروردگار مردم <span class="c2">(۱)</span> مَلِكِ النَّاسِ 2<br /> پادشاه مردم <span class="c2">(۲)</span> إِلَهِ النَّاسِ 3<br /> معبود مردم <span class="c2">(۳)</span> مِنْ شَرِّ الْوَسْوَاسِ الْخَنَّاسِ 4<br /> از شر وسوسه ‏گر پنهان كار<span class="c2">(4)</span> الَّذِي يُوَسْوِسُ فِي صُدُورِ النَّاسِ 5<br /> آن كس كه در سينه‏ هاى مردم وسوسه مى ‏كند <span class="c2">(۵)</span> مِنَ الْجِنَّةِ وَالنَّاسِ 6﴾<br /> چه از جن و <span class="c5">[چه از]</span> انس <span class="c2">(۶)</span> سه مرتبه. 3- <span class="c3">«اللهم أنت ربي لا إله إلا أنت، خلقتني وأنا عبدك، وأنا على عهدك ووعدك ما استطعت، أعوذ بك من شر ما صنعت، أبوء لك بنعمتك علي، وأبوء بذنبي، فاغفر لي، فإنه لا يغفر الذنوب إلا أنت»</span>.<br /> <span class="c3">«الهی تو پروردگار من هستی، معبودی جز تو نیست، تو مرا آفریدی و من بندۀ تو هستم، و تا می توانم به عهد و وعدۀ تو پایبندم، از شر چیزی که انجام داده ام به تو پناه می برم، نعمت تو را بر من اعتراف نموده، و به گناهم نیز اعتراف می‌کنم، پس مرا ببخش که جز تو بخشایندۀ گناهان نیست»</span>. به روایت بخاری. </p>',
            ],
            19 => [
                'question' => 'س20: هنگام خواب چه می گویید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15290.mp3',
                'answer' => '<p> ج – <span class="c3">«باسمك اللهم أموت وأحيا»</span><br /> الهی به نام تو می میرم و زنده می شوم. متفق علیه. </p>',
            ],
            20 => [
                'question' => 'س 21: قبل از خوردن غذا چه می گویید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15320.mp3',
                'answer' => '<p> ج- بسم الله. بنام الله<br /> و اگر در ابتدا فراموش کردید،<span class="c6"> بگویید:</span><br /> <span class="c3">«بسم الله في أوله وآخره»</span><br /> <br /> <span class="c3">«به نام الله در آغاز غذا و پایان آن»</span> از ابوداود و ترمذی روایت شده است. </p>',
            ],
            21 => [
                'question' => 'س22: وقتی غذا را تمام می کنید چه می گویید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15370.mp3',
                'answer' => '<p> ج – <span class="c3">«الحمد لله الذي أطعمني هذا، ورزقنيه، من غير حول مني ولا قوة»</span><br /> <br /> ستایش الله را که این را به من اطعام کرد، و به من روزی داد، بدون هیچ نیرو و قدرتم. از ابوداود و ابن ماجه و دیگران روایت شده است. </p>',
            ],
            22 => [
                'question' => 'س 23: دعای مهمان برای صاحب غذا چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15400.mp3',
                'answer' => '<p> ج- <span class="c3">«اللـهم بـارك لهـم فيما رزقتهـم، واغـفر لهم وارحمهم»</span><br /> <span class="c3">«الله به آنچه روزی شان کرده‌ای برکت بده و آنها را بیامرز و رحمتشان کن»</span>. به روایت مسلم. </p>',
            ],
            23 => [
                'question' => 'س24: هرگاه انسان عطسه بزند چه باید بگویید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15430.mp3',
                'answer' => '<p> ج- <span class="c3">«الحمد لله»</span><br /> <span class="c3">«ثنا و ستایش الله را است»</span>.<span class="c6"><br /> و برادر یا همراهش به او بگوید:</span> <span class="c3">«یرحمک الله»</span><br /> الله شما را رحمت کند.<span class="c6"><br /> و برادر یا همراهش به او بگوید:</span> <span class="c3">«يهديكم الله ويصلح بالكم»</span><br /> <span class="c3">«الله تو را هدایت نموده و امورت را اصلاح کند»</span>. به روایت بخاری. </p>',
            ],
            24 => [
                'question' => 'س 25: هرگاه مجلس را تمام و از آن بلند می شوید چه می گویید «دعای کفاره مجلس»؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15480.mp3',
                'answer' => '<p> ج – <span class="c3">«سبحانك اللهم وبحمدك، أشهد أن لا إله إلا أنت، أستغفرك وأتوب إليك»</span><br /> منزهی یا الله و ستایش از آن تو است، گواهی می دهم که معبودی جز تو نیست، از تو آمرزش می خواهم و به سوی تو بر می گردم. روایت ابوداود و ترمذی و دیگران. </p>',
            ],
            25 => [
                'question' => 'س 26: دعای سواری چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15510.mp3',
                'answer' => '<p> ج-<span class="c6"> بسم الله و الحمدلله:</span> <span class="c4">﴿سُبْحَانَ الَّذِي سَخَّرَ لَنَا هَذَا وَمَا كُنَّا لَهُ مُقْرِنِينَ 13 وَإِنَّا إِلَى رَبِّنَا لَمُنْقَلِبُونَ 14﴾</span>، <span class="c3">«الحمد لله، الحمد لله، الحمد لله، الله أكبر، الله أكبر، الله أكبر، سبحانك اللهم إني ظلمت نفسي فاغفر لي؛ فإنه لا يغفر الذنوب إلا أنت»</span>.<span class="c6"><br /> بنام الله و ستایش الله را:</span> پاک است ذاتی كه اين را براى ما رام كرد و<span class="c5">[گرنه]</span> ما را توانمندی <span class="c5">[رام ‏ساختن]</span> آنها نبود <span class="c2">(۱۳)</span> و به راستى كه ما به سوى پروردگارمان بازخواهيم گشت <span class="c2">(۱۴)</span> .<br /> ستایش الله را، ستایش الله را، ستایش الله را، الله بزرگ است، الله بزرگ است، الله بزرگ است، الله تو منزهی، من به خود ستم کردم، مرا ببخش؛ هیچ کس جز تو گناهان را نمی بخشد.» از ابوداود و ترمذی روایت شده است. </p>',
            ],
            26 => [
                'question' => 'س 27: دعای سفر را ذکر کنید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15540.mp3',
                'answer' => '<p> ج – <span class="c3">«الله أكبر، الله أكبر، الله أكبر <span class="c4">﴿سُبْحَانَ الَّذِي سَخَّرَ لَنَا هَذَا وَمَا كُنَّا لَهُ مُقْرِنِينَ 13 وَإِنَّا إِلَى رَبِّنَا لَمُنْقَلِبُونَ 14﴾</span>، اللهم إنا نسألك في سفرنا هذا البر والتقوى ومن العمل ما ترضى، اللهم هون علينا سفرنا هذا، واطو عنا بعده، اللهم أنت الصاحب في السفر، والخليفة في الأهل، اللهم إني أعوذ بك من وعثاء السفر، وكآبة المنظر، وسوء المنقلب، في المال والأهل»</span><br /> «الله بزرگ است، الله بزرگ است، الله بزرگ است) پاک است كسى كه اين را براى ما رام كرد و<span class="c5">[گرنه]</span> ما را توانمندی <span class="c5">[رام ‏ساختن]</span> آنها نبود <span class="c2">(۱۳)</span> و به راستى كه ما به سوى پروردگارمان بازخواهيم گشت (،الهی در این سفر مان از تو نیکی و تقوا و عملی که تو از آن راضی باشد می خواهیم، الهی سختی های سفر را برای ما آسان نما، و دوری آن را از ما برچین، الهی تو همنشین در سفری، و خلیفه در خانواده هستی، الهی به تو پناه می بریم از مشقت سفر و منظرۀ بد و تغییر ناپسند در مال و خانواده.<br /> و هرگاه برگشت همین دعا را تکرار نموده،<span class="c6"> و اضافه می نماید:</span><br /> <span class="c3">«ما درحالی باز می گرديم که توبه کنندگان، عبادت گزاران و ستايش گران پروردگارمان هستيم»</span>. روایت مسلم. </p>',
            ],
            27 => [
                'question' => 'س 29: دعای مقیم برای مسافر چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15590.mp3',
                'answer' => '<p> ج – <span class="c3">«أستودعكم الله الذي لا تضيع ودائعه»</span>.<br /> شما را به الله می سپارم که نزد او امانت ها ضایع نمی گردند. روایت احمد و ترمذی. </p>',
            ],
            28 => [
                'question' => 'س30: دعای مقیم به مسافر چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15620.mp3',
                'answer' => '<p> ج – <span class="c3">«أستودع الله دينك، وأمانتك، وخواتيم عملك»</span>.<br /> دین، امانت، و خاتمۀ کار شما را به الله می سپارم. روایت احمد و ترمذی. </p>',
            ],
            29 => [
                'question' => 'س30: دعای ورود به بازار چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15650.mp3',
                'answer' => '<p> ج – <span class="c3">«لا إله إلا الله وحده لا شريك له، له الملك، وله الحمد، يحيي ويميت، وهو حي لا يموت، بيده الخير، وهو على كل شيء قدير»</span><br /> <br /> <span class="c3">«نیست معبود بر حق جز الله یگانه و بی همتا، پادشاهی از آن اوست، و حمد و ستایش از آن اوست، زنده می کند و می میراند، و او زنده است و نمی میرد، خیر در دست اوست، و او بر همه چیز توانا است.»</span> از ترمذی و ابن ماجه روایت شده است. </p>',
            ],
            30 => [
                'question' => 'س 31: دعای هنگام خشم را ذکر کنید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15680.mp3',
                'answer' => '<p> ج – <span class="c3">«أعوذ بالله من الشيطان الرجيم»</span><br /> پناه می برم به الله از شیطان رانده شده. متفق علیه. </p>',
            ],
            31 => [
                'question' => 'س 32: کسی که به شما نیکی نماید چه باید بگویید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15710.mp3',
                'answer' => '<p> ج- <span class="c3">«جزاك الله خيرا»</span><br /> <span class="c3">«الله خیرت دهد»</span> به روایت ترمذی. </p>',
            ],
            32 => [
                'question' => 'س 33: هرگاه وسیله نقل حالت طبیعی نداشته باشد، چه دعایی دارد؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15740.mp3',
                'answer' => '<p> ج- <span class="c3">«بسم الله»</span><br /> <br /> بنام الله به روایت ابوداود. </p>',
            ],
            33 => [
                'question' => 'س34: اگر برای تو چیزی خوش آیند رخ دهد چه می گویید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15770.mp3',
                'answer' => '<p> ج – <span class="c3">«الحمد لله الذي بنعمته تتم الصالحات»</span><br /> حمد و ستایش مخصوص الله است که اعمال نیک به فضل او انجام می شود. روایت حاکم و دیگران. </p>',
            ],
            34 => [
                'question' => 'س35: اگر برای تو چیزی ناخوش آیند رخ دهد چه می گویید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15800.mp3',
                'answer' => '<p> ج- <span class="c3">«الحمد لله على كل حال»</span><br /> <span class="c3">«الهی تو را به هر حال ثنا و ستایش است»</span>. صحیح جامع. </p>',
            ],
            35 => [
                'question' => 'س 36: نحوۀ سلام و جواب آن چگونه است؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15830.mp3',
                'answer' => '<p> ج -<span class="c6"> مسلمان می گوید:</span> <span class="c3">«السَّلَامُ عَلَيْكُمْ وَرَحْمَةُ اللَّهِ وَبَرَكَاتُهُ»</span>.<span class="c6"><br /> و برادرش به او پاسخ می دهد:</span> <span class="c3">«وَعَلَيْكُمُ السَّلَامُ وَرَحْمَةُ اللهِ وَبَرَكَاتُهُ»</span> در ترمذی و ابوداود و دیگران. </p>',
            ],
            36 => [
                'question' => 'س 37: دعاء هنگام بارش باران چه می باشد؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15870.mp3',
                'answer' => '<p> ج – <span class="c3">«اللهم صيباً نافعاً»</span><br /> <span class="c3">«الهی این باران را سودمند بگردان»</span>. بخاری. </p>',
            ],
            37 => [
                'question' => 'س 38: پس از باریدن باران چه دعایی می‌شود؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15900.mp3',
                'answer' => '<p> ج – <span class="c3">«مطرنا بفضل الله ورحمته»</span><br /> <span class="c3">« برای ما به فضل و رحمت الله باران بارید»</span>. بخاری و مسلم. </p>',
            ],
            38 => [
                'question' => 'س 39: دعای باد (طوفان) را ذکر کنید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15930.mp3',
                'answer' => '<p> ج – <span class="c3">«اللهم إني أسألك خيرها وأعوذ بك من شرها»</span><br /> الهی خیر آن را از تو می خواهم و از شر آن به تو پناه می برم. ابو داود و ابن ماجه. </p>',
            ],
            39 => [
                'question' => 'س40: دعای رعد و برق را ذکر کنید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15960.mp3',
                'answer' => '<p> ج – <span class="c3">«سبحان الذي يسبح الرعد بحمده والملائكة من خيفته»</span>.<br /> منزه است ذاتی که رعد به ستایش او تسبیح می گوید و فرشتگان از ترس او تسبیح می گویند. موطأ مالک </p>',
            ],
            40 => [
                'question' => 'س 41: هرگاه مصیبت زده را دیدی، چه دعایی دارد؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15990.mp3',
                'answer' => '<p> ج – <span class="c3">«الحمد لله الذي عافاني مما ابتلاك به، وفضلني على كثيرٍ ممن خلق تفضيلاً»</span><br /> سپاس الله را که مرا از آنچه تو را گرفتار نموده نجات داد، و بر بسیاری از مخلوق برتری داد. به روایت ترمذی. </p>',
            ],
            41 => [
                'question' => 'س 42: دعا براى کسى که مى ترسد توسط چشم او اتفاقى بيفتد؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16020.mp3',
                'answer' => '<p> ج -<span class="c6"> در حديث:</span> <span class="c3">«اگر يكى از شما چيزى از برادرش يا از خود يا از مال خود ببيند و برایش شگفت آور بود <span class="c5">[برای او دعا بركت كند]</span> چون چشم بد حق است»</span>. از احمد و ابن ماجه و دیگران روایت کرده اند. </p>',
            ],
            42 => [
                'question' => 'س 43: چگونه بر پیامبر صلی الله علیه وسلم درود می فرستید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16050.mp3',
                'answer' => '<p> <span class="c2">(ج)</span> – <span class="c3">«اللَّهُمَّ صَلِّ عَلَى مُحَمَّدٍ وَعَلَى آلِ مُحَمَّدٍ، كَمَا صَلَّيْتَ عَلَى إِبْرَاهِيمَ، وَعَلَى آلِ إِبْرَاهِيمَ، إِنَّكَ حَمِيدٌ مَجِيدٌ، اللَّهُمَّ بَارِكْ عَلَى مُحَمَّدٍ وَعَلَى آلِ مُحَمَّدٍ، كَمَا بَارَكْتَ عَلَى إِبْرَاهِيمَ، وَعَلَى آلِ إِبْرَاهِيمَ إِنَّكَ حَمِيدٌ مَجِيدٌ»</span><br /> <br /> یا الله نزول رحمت فرما برمحمد و خاندان محمد به مثل رحمت که بر ابراهیم و بر خاندان آن فرموده ای بی شک تو قابل ستایش و بزرگ هستی. یا الله نزول برکت فرما برمحمد و خاندان محمد به مثل برکت که بر ابراهیم و بر خاندان آن فرموده ای بی شک تو قابل ستایش و بزرگ هستی. متفق علیه. </p>',
            ],
        ],
        9 => [
            0 => [
                'question' => 'س1: پنج احکام تکلیفی کدام ها اند؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16090.mp3',
                'answer' => '<p> ج-<br /> 1- واجب.<br /> 2- مستحب.<br /> 3- حرام.<br /> 4- مکروه.<br /> 5- مباح. </p>',
            ],
            1 => [
                'question' => 'س2: این پنج احكام را توضیح دهید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16170.mp3',
                'answer' => '<p> ج-<br /> 1- واجب <span class="c2">(فرض)</span>: مانند نمازهای پنجگانه، روزه ماه مبارک رمضان و نیکی با پدر و مادر.<br /> انجام دهندۀ واجب <span class="c2">(فرض)</span> مستحق ثواب می شود و ترک کنندۀ آن مجازات مى شود.<br /> 2-<span class="c6"> مستحب:</span> مانند نمازهای سنت، نماز تهجد، غذا دادن و سلام دادن. و آن را سنت و مندوب گویند.<br /> انجام دهندۀ مستحب مستحق ثواب می گردد و ترک کنندۀ آن مجازات نمى شود.<span class="c6"><br /> یادداشت مهم:</span><br /> هرگاه مسلمان بشنود که این کار سنت یا مستحب است، باید در انجام دادن آن بشتابد، و از پیامبر صلی الله علیه وسلم پیروی بکند.<br /> 3-<span class="c6"> حرام:</span> مانند نوشیدن شراب، نافرمانی پدر و مادر و قطع پیوند خویشاوندی.<br /> - ترک کنندۀ حرام مستحق پاداش می شود و انجام دهندۀ آن مجازات مى شود.<br /> 4-<span class="c6"> مکروه:</span> مانند گرفتن و دادن با دست چپ، و جمع کردن لباس در نماز.<br /> - ترک کنندۀ مکروه مستحق پاداش می باشد و مرتکب آن مجازات نمی شود.<br /> 5-<span class="c6"> مباح:</span> مانند خوردن سیب و نوشیدن چای و به آن می گویند: حلال و مباح.<br /> ترک کنندۀ مباح مستحق پاداش نمی گردد و مرتکب آن مجازات نمى شود. </p>',
            ],
            2 => [
                'question' => 'س3: خرید و فروش و معاملات چه حکمی دارد؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16320.mp3',
                'answer' => '<p> ج - اصل در همه خرید و فروش و معاملات، حلال بودن آنهاست، مگر برخی از چیزهایی که الله متعال از آنها نهی کرده است.<span class="c6"><br /> الله متعال می فرماید:</span> <span class="c4">﴿وَأَحَلَّ اللَّهُ الْبَيْعَ وَحَرَّمَ ٱلرِّبَوٰاۚ﴾</span><br /> و الله داد و ستد را حلال و سود را حرام کرده است. <span class="c5">[سوره بقره: 275]</span>. </p>',
            ],
            3 => [
                'question' => 'س4: انواع معاملات و بیع حرام را ذکر کنید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16360.mp3',
                'answer' => '<p> ج-<br /> 1- فریب دادن،<span class="c6"> از جمله:</span> پنهان کردن عیب کالا.<br /> از ابوهریره رضی الله عنه روایت است که رسول الله صلی الله علیه وسلم از انبار غذا -<span class="c6"> گذشت و دستش را در آن گذاشت انگشتانش خیس شد گفت:</span> ای صاحب غذا این چیست؟<span class="c6"> گفت:</span> آب باران برایش رسیده یا رسول الله.<span class="c6"> وی گفت:</span> <span class="c3">«آیا ممکن نبود آن را روی غذا بگذاری تا مردم آن را ببینند؟ هر که فریب دهد از من نیست.»</span> به روایت مسلم.<br /> 2-<span class="c6"> سود:</span> از آن جمله، این که از کسی مقدار هزار قرض بگیرم مشروط بر این که هنگام برگرداندن دو هزار تحویل بدهم.<br /> این افزایش، سود حرام است.<span class="c6"><br /> الله متعال می فرماید:</span> <span class="c4">﴿وَأَحَلَّ اللَّهُ الْبَيْعَ وَحَرَّمَ ٱلرِّبَوٰاۚ﴾</span><br /> <span class="c2">(و الله داد و ستد را حلال و سود را حرام نموده است.)</span> <span class="c5">[سوره بقره: 275]</span>.<br /> 3-<span class="c6"> غرر و جهالت:</span> مانند این که در پستان گوسفند، یا ماهی را که در آب است و هنوز آن را شکار نکرده باشم به تو بفروشم.<span class="c6"><br /> در حدیث آمده است:</span> <span class="c2">(رسول الله صلی الله علیه وسلم از خرید و فروش غرر نهی کرده است)</span> به روایت مسلم. </p>',
            ],
            4 => [
                'question' => 'س5: برخی از نعمت های الله که برای تو داده است ذکر کنید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16460.mp3',
                'answer' => '<p> ج - 1 - نعمت اسلام، و این که تو از اهل کفر نیستی.<br /> 2- نعمت سنت، و این که تو از اهل بدعت نیستی.<br /> 3- نعمت سلامتی و تندرستی، از جمله شنیدن، دیدن، راه رفتن و غیره.<br /> 4- نعمت خوردن و نوشیدن و پوشاک.<br /> و نعمت های الله متعال بر ما بسیار و بی حساب است.<span class="c6"><br /> الله متعال می فرماید:</span> <span class="c4">﴿وإن تَعُدُّوا نِعمَةَ ٱللَّهِ لَا تُحصُوهَاإِنَّ ٱللَّهَ لَغَفُورٌ رَحِيمٌ 18﴾</span><br /> و اگر نعمت<span class="c5">[هاى]</span> الله را شمارش كنيد آن را نمى‏ توانيد بشماريد قطعا الله آمرزنده مهربان است)۱۸( <span class="c5">[سورة النحل: ١٨]</span>. </p>',
            ],
            5 => [
                'question' => 'س6: واجب در نعمت ها چيست؟ و چگونه شکر آن را ادا می کنید؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16540.mp3',
                'answer' => '<p> ج ـ واجب در نعمت: بیان شكر آن با حمد و ثناى الله متعال توسط زبان، و اين كه او تنها صاحب فضل این نعمت هاست، و از اين نعمت ها در راه رضاى الله متعال استفاده شود نه در معصیت و نافرمانی او. </p>',
            ],
            6 => [
                'question' => 'س7: عید های مسلمانان کدام ها اند؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16570.mp3',
                'answer' => '<p> ج- عید فطر و عید قربان.<br /> -<span class="c6"> چنانکه در حدیث انس آمده که می گوید:</span> رسول الله صلی الله علیه وسلم به مدینه آمد و اهل مدینه دو روز داشتند که در آن بازی می نمودند،<span class="c6"> فرمود:</span> <span class="c3">«این دو روز چیست؟»</span> گفتند: <span class="c3">«در زمان جاهلیت در این دو روز بازی می کردیم،<span class="c6"> رسول الله صلی الله علیه وسلم فرمود:</span> «الله آنها را برای شما با چیزی بهتر از آنها عوض کرده است: روز قربان و روز فطر»</span>. روایت ابوداود.<br /> و اضافه از این دو روز از عیدهای، بدعت است. </p>',
            ],
            7 => [
                'question' => 'س8: بهترین ماه ها کدام است؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16620.mp3',
                'answer' => '<p> ج- ماه رمضان. </p>',
            ],
            8 => [
                'question' => 'س9: بهترین روزها کدام است؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16650.mp3',
                'answer' => '<p> ج- روز جمعه. </p>',
            ],
            9 => [
                'question' => 'س10: بهترین روز سال چه روزی است؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16680.mp3',
                'answer' => '<p> ج- روز عرفه. </p>',
            ],
            10 => [
                'question' => 'س 11: بهترین شب سال کدام است؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16710.mp3',
                'answer' => '<p> ج- شب قدر. </p>',
            ],
            11 => [
                'question' => 'س12: اگر زن نامحرم را دیدید چه باید کرد؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16740.mp3',
                'answer' => '<p> ج: واجب پایان انداختن نگاه است،<span class="c6"> الله متعال فرمود:</span> <span class="c4">﴿قُلْ لِلْمُؤْمِنِينَ يَغُضُّوا مِنْ أَبْصَارِهِمْ﴾</span><br /> به مردان با ايمان بگو ديده فرو نهند <span class="c5">[سوره نور: 30]</span>. </p>',
            ],
            12 => [
                'question' => 'س13: دشمنان انسان چه کسانی هستند؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16770.mp3',
                'answer' => '<p> 1-<span class="c6"> نفس امر کننده به بدی:</span> آن است که انسان در معصیت الله تبارک و تعالی از آنچه نفس و امیالش به او حکم می کند پیروی کند،<span class="c6"> الله متعال فرمود:</span> <span class="c4">﴿إِنَّ ٱلنَّفسَ لَأَمَّارَةُبالسُّوءِ إِلَّا مَا رَحِمَ رَبِّي إِنَّ رَبِّي غَفُورٌ رَّحِيمٌ﴾</span><br /> هر آئینه نفس به بدى امر مى ‏كند مگر كسى را كه الله رحم كند زيرا پروردگار من آمرزنده مهربان است <span class="c5">[سوره یوسف: 53]</span>. 2-<span class="c6"> شیطان:</span> او دشمن ابن آدم است و هدفش گمراه کردن انسان و آنان را به بدی وسوسه نمودن است تا وارد آتش جهنم گردند.<span class="c6"> الله متعال می فرماید:</span> <span class="c4">﴿وَلَا تَتَّبِعُوا خُطُوَ ٰ⁠تِ ٱلشَّيطَـٰنِۚ إِنَّهُۥ لَكُمۡ عَدُوٌّ مُّبِينٌ﴾</span><br /> و گامهاى شيطان را دنبال مكنيد كه او براى شما دشمنى آشكار است <span class="c5">[سوره بقره: 168]</span>. 3-<span class="c6"> دوستان بد:</span> تشویق کنندگان به بدی و جلوگیری کننده گان از خیر.<span class="c6"> الله متعال می فرماید:</span> <span class="c4">﴿الْأَخِلَّاءُ يَوْمَئِذٍ بَعْضُهُمْ لِبَعْضٍ عَدُوٌّ إِلَّا الْمُتَّقِينَ﴾</span><br /> در آن روز ياران جز پرهيزگاران بعضی‏ شان دشمن بعضى ديگرند <span class="c2">(۶۷)</span> <span class="c5">[سورۀ زخرف: 67]</span>. </p>',
            ],
            13 => [
                'question' => 'س 14: توبه چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16820.mp3',
                'answer' => '<p> ج -<span class="c6"> توبه:</span> بازگشت از نافرمانی الله متعال به اطاعت از وی می باشد.<span class="c6"> الله متعال می فرماید:</span> <span class="c4">﴿وَإِنِّي لَغَفَّارٌ لِّمَن تَابَ وَءَامَنَ وَعَمِلَ صَـٰلِحًا ثُمَّ ٱهۡتَدَىٰ﴾</span><br /> <span class="c3">«و به يقين من آمرزندۀ كسى هستم كه توبه كند و ايمان بياورد و كار شايسته نمايد و به راه راست راهسپر شود »</span>. <span class="c5">[سوره طه: 82]</span>. </p>',
            ],
            14 => [
                'question' => 'س 15: شرایط توبه صحیح چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16850.mp3',
                'answer' => '<p> ج-1- ترک گناه.<br /> 2- پشیمانی از آنچه گذشت.<br /> 3- عزم به عدم بازگشت به آن.<br /> 4- برگرداندن حقوق و مظالم به اهل آن.<span class="c6"><br /> الله متعال می فرماید:</span> <span class="c4">﴿وَٱلَّذِينَ إِذَا فَعَلُوا فَـاحِشَةً أَو ظَلَمُوا أَنفُسَهُم ذَكَرُوا ٱللَّهَ فَٱستَغفَرُوا لِذُنُوبِهِم وَمَن يَغفِرُ ٱلذُّنُوبَ إِلَّا ٱللَّهُ وَلَم يصِرُّوا عَلَى مَا فَعَلُوا وَهُم يَعلَمُونَ 135﴾</span><br /> و آنان كه چون كار زشتى كنند يا بر خود ستم روا دارند الله را به ياد مى ‏آورند و براى گناهانشان آمرزش مى‏ خواهند و چه كسى جز الله گناهان را مى ‏آمرزد و بر آنچه مرتكب شده‏ اند با آنكه مى‏ دانند <span class="c5">[كه گناه است]</span> پافشارى نمى كنند <span class="c2">(۱۳۵)</span> <span class="c5">[سورة آل عمران: ١٣٥]</span>. </p>',
            ],
            15 => [
                'question' => 'س 16: معنای درود بر پیامبر صلی الله علیه وسلم چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16920.mp3',
                'answer' => '<p> ج - معنای آن اینست که شما به الله متعال دعا می کنید تا ستایش پیامبرش صلی الله علیه وسلم را در الملأ الأعلى عنایت بفرماید. </p>',
            ],
            16 => [
                'question' => 'س 17: معنای سبحان الله چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16950.mp3',
                'answer' => '<p> ج- تسبیح به معنی به پاکیزگی یاد کردن الله متعال از هر نقص و عیب و بدی است. </p>',
            ],
            17 => [
                'question' => 'س 18: معنای الحمد لله چيست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16980.mp3',
                'answer' => '<p> ج- حمد و ثنای الله متعال، و وصف وی با تمام صفات کمال می باشد. </p>',
            ],
            18 => [
                'question' => 'س 19: معنای الله اکبر چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/17000.mp3',
                'answer' => '<p> ج- یعنى او تعالی از همه چیز بزرگتر و والاتر، عظیم تر، و عزیزتر است. </p>',
            ],
            19 => [
                'question' => 'س 20: معناى لا حول ولا قوة الا بالله چه است؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/17030.mp3',
                'answer' => '<p> ج -<span class="c6"> معنی آن:</span> بنده از حالتی به حالت دیگر تبدیل نمی شود و بر آن قدرتی نمی داشته باشد جز به وسیله الله متعال. </p>',
            ],
            20 => [
                'question' => 'س 21: معنای استغفر الله چیست؟',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/17060.mp3',
                'answer' => '<p> ج -<span class="c6"> یعنی:</span> خواست بنده از پروردگارش که گناهانش را پاک کند و عیب هایش را بپوشاند. </p>',
            ],
        ],
    ],
];
