<?php
$data = [
    'title' => 'What Muslim Children Must Know',
    'description' => 'A project that contains a simple and easy curriculum for issues that a Muslim must know. It includes issues of belief, jurisprudence, prophetic biography, etiquette, tafsir, hadith, morals, and remembrance of Allah. It is suitable for young children in particular, for all ages, and newcomers to Islam.',
    'source' => 'https://kids.islamenc.com/pt/home',
    'author' => 'Yazan Abdul Razzaq Raziq Alghanim',
    'sections' => [
        0 => 'Sessão da crença',
        1 => 'Sessão de Fiqh',
        2 => 'Sessão de Biografia do Profeta',
        3 => 'Sessão de Tafssir',
        4 => 'Seção de Hadith',
        5 => 'Seção de ética Islâmica',
        6 => 'Seção de Ética',
        7 => 'Sessão de súplicas e recordações',
        8 => 'Seção diversa',
    ],
    'data' => [
        1 => [
            0 => [
                'question' => 'Q1: Quem é o seu Senhor?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/200.mp3',
                'answer' => '<p> R - Meu Senhor é ALLAH, que me cuidou e cuidou de todos os mundos pela Sua graça.<span class="c6"><br /> E a evidência disso é o dito de Allah:</span> Louvor a Allah, O Senhor dos mundos. Surat Al-Fátihah </p>',
            ],
            1 => [
                'question' => 'Q2: Qual é a sua religião?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/240.mp3',
                'answer' => '<p> Consiste <span class="c2">(aos muçulmanos)</span> conhecerem a religião do Isslam com as suas respectivas evidências. O Isslam é a submissão voluntária a Allah através do monoteísmo e a submissão a Ele através da obediência e afastamento da idolatria <span class="c2">(shirk)</span> e seus seguidores.<span class="c6"><br /> O Altíssimo diz:</span> Na verdade, a religião perante Allah é o Isslam; Surat Al-<span class="c6">Imran:</span> 19. </p>',
            ],
            2 => [
                'question' => 'Q3: Quem é o seu Profeta?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/280.mp3',
                'answer' => '<p> R-<span class="c6"> Muhammmadﷺ<br /> O Altíssimo diz:</span> Muhammad é mensageiro de ALLAH <span class="c5">[Surat Al-<span class="c6">Fath:</span> 29]</span>. </p>',
            ],
            3 => [
                'question' => 'Q4: Mencione a palavra do monoteísmo e qual é o seu significado?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/310.mp3',
                'answer' => '<p> O significado do testemunho \'\'Não há Deus excepto ALLAH\'\' i.e.<span class="c6"> Ninguém é digno de adoração excepto ALLAH<br /> O Altíssimo diz:</span> Saibam que Ele,<span class="c6"> não há divindade além d\'Ele Surat Muhammad:</span>19 </p>',
            ],
            4 => [
                'question' => 'Q 5: Onde está ALLAH, o Poderoso e Sublime?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/350.mp3',
                'answer' => '<p> C - ALLAH está no céu acima do trono, acima de todas as criaturas, disse o Todo-<span class="c6">Poderoso:</span> O Misericordioso estabeleceu-se no Trono.<span class="c6"> Surat Tahá:</span>5 E diz: E Ele é O Dominador sobre Seus servos e Ele é O Sábio, O Conhecedor.<span class="c6"> O Gado:</span>18 </p>',
            ],
            5 => [
                'question' => 'P6: O significado de (Testemunho que Muhammad é mensageiro de Allah):',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/380.mp3',
                'answer' => '<p> R -<span class="c6"> Seu significado:</span> que ALLAH o enviou aos mundos como arauto e admoestador.<span class="c6"><br /> E é obrigatório:</span><br /> 1- Obedeça-o no que ele ordenou.<br /> 2- Acreditar no que ele disse.<br /> 3- Não o desobedecer.<br /> 4- ALLAH não é adorado a não ser com o que ele legislou, que é seguir a Sunnah e abandonar a inovação.<br /> O Todo-<span class="c6">Poderoso disse:</span> <span class="c1">“Aquele que obedece ao Mensageiro obedeceu a ALLAH...”</span> <span class="c5">[Surat An-<span class="c6">Nissa:</span> 80]</span>, e Ele, Glória a Ele,<span class="c6"> disse:</span> "Não fala por capricho, mas sim, é uma inspiração que lhe foi revelada.<span class="c6">" Surat Najm:</span>3-<span class="c6">4 E ALLAH disse:</span> - Com efeito, há, para vós, no Mensageiro de Allah, belo paradigma, para quem espera em Allah, e no Derradeiro Dia, e se lembra amiúde de Allah. - Surat Al-<span class="c6">Ahzab:</span> 21 </p>',
            ],
            6 => [
                'question' => 'Q 7: Por que ALLAH Todo-Poderoso nos criou?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/480.mp3',
                'answer' => '<p> C - Fomos criados para adorá-Lo exclusivamente,<span class="c6"> sem parceiro<br /> Não para diversão e brincadeiras<br /> O Altíssimo diz:</span> E não criei os jinns e os humanos senão para Me adorarem exclusivamente. Surat Záriat 56 </p>',
            ],
            7 => [
                'question' => 'Q8: O que é adoração?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/530.mp3',
                'answer' => '<p> C- É um substantivo abrangente para tudo o que ALLAH ama e se agrada, de palavras e ações, tanto internas quanto externas.<span class="c6"><br /> O externo:</span> como a lembrança de ALLAH com a língua de glorificação, louvor e takbir, oração e Hajj.<span class="c6"><br /> O interno:</span> Como confiança, medo e esperança. </p>',
            ],
            8 => [
                'question' => 'Q 9: Qual é o nosso maior dever?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/580.mp3',
                'answer' => '<p> R- Nosso maior dever é adorar exclusivamente a ALLAH Todo-Poderoso </p>',
            ],
            9 => [
                'question' => 'Q10: Quais são os tipos de monoteísmo?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/610.mp3',
                'answer' => '<p> R-1-<span class="c6"> Monoteísmo do Senhorio:</span> É a crença de que ALLAH é o Criador, o Provedor, o Proprietário e Controlador, sozinho e sem parceiro.<br /> 2- Tawhid al-<span class="c6">Uluhiyyah:</span> É destacar Deus em adoração, então ninguém é adorado, exceto Deus Todo-Poderoso.<br /> 3-<span class="c6"> Unificação dos Nomes e Atributos:</span> É a crença nos Nomes e Atributos do Deus Todo-Poderoso mencionados no Livro e na Sunnah, sem representação, analogia ou ruptura.<span class="c6"><br /> E a evidência para os três tipos de monoteísmo é o ditado do Altíssimo:</span> "É O Senhor dos céus e da terra e do que há entre ambos. Então, adora-O e pacienta, em Sua adoração. Acaso, conheces-<span class="c6">Lhe algum homónimo?" Surat Maryam:</span>65 </p>',
            ],
            10 => [
                'question' => 'Q 11: Qual é o maior pecado?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/670.mp3',
                'answer' => '<p> C - Shirk com ALLAH Todo-Poderoso.<span class="c6"><br /> O Altíssimo diz:</span> Por certo, Allah não perdoa que Lhe associem outra divindade, e perdoa tudo o que for, afora isso, a quem quer. E quem associa a Allah, com efeito, forjará formidável pecado. An-<span class="c6">Nissá:</span> 48 </p>',
            ],
            11 => [
                'question' => 'Q12: Mencione o politeísmo e seus tipos?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/710.mp3',
                'answer' => '<p> R-<span class="c6"> Shirk:</span> É passar qualquer tipo de adoração a outro que não seja ALLAH Todo-Poderoso.<span class="c6"><br /> Seus tipos:</span><br /> Shirk maior; Tais como: súplica a outro que não seja ALLAH Todo-Poderoso, ou prostração a outro que não Ele, Glória a Ele, ou sacrifício de um animal em nome de outro fora ALLAH, o Poderoso e Sublime.<span class="c6"><br /> Shirk Menor:</span> Tais como: jurar por outro que não ALLAH, o Exaltado, ou amuletos, que estão pendurados nas coisas para trazer benefício ou repelir o mal, e se exibir, como melhorar sua oração quando vê pessoas olhando para ele. </p>',
            ],
            12 => [
                'question' => 'Q 13: Alguém conhece o invisível, exceto ALLAH Todo-Poderoso?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/770.mp3',
                'answer' => '<p> R - Só ALLAH conhece o invisível.<span class="c6"><br /> O Altíssimo diz:</span> Dize: "Ninguém daqueles que estão nos céus e na terra conhece ao Invisível, exceto Allah." E eles não percebem quando serão ressuscitados.<span class="c6"> Surat Naml:</span>65 </p>',
            ],
            13 => [
                'question' => 'Q 14: O número de pilares da fé?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/810.mp3',
                'answer' => '<p> R - 1- Crença em ALLAH Todo-Poderoso.<br /> 2- E seus anjos.<br /> 3- Seus livros<br /> 4- Seus mensageiros.<br /> 5- No Dia do Juízo Final<br /> 6- O destino é bom e máu.<span class="c6"><br /> E a evidência:</span> o famoso Hadith de Jibrail no Musslim, Jibrail disse ao Profeta,<span class="c6"> que a paz e bênçãos de ALLAH estejam com ele:</span> "Então me fale sobre a fé,<span class="c6"> ele disse:</span> Acreditar em Deus, Seus anjos, Seus livros, Seus mensageiros, e no Dia do Juízo." </p>',
            ],
            14 => [
                'question' => 'Q 15: Explique os pilares da fé?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/900.mp3',
                'answer' => '<p> R: Crença em Deus Todo-<span class="c6">Poderoso:</span><br /> § Acreditar que ALLAH é Aquele que te criou e te deu provisão, e Ele é o único dono e governante de todas as criaturas.<br /> § Ele é a divindade, e não há outra divindade além Dele.<br /> § E Ele é o Grande, o Grande, o Completo, a quem é todo louvor, e a quem pertencem os Nomes Mais Belos e os Atributos Altíssimos, não tem igual, e nada é semelhante a Ele, Glória a Ele.<span class="c6"><br /> A crença nos anjos:</span><br /> São criaturas criadas por Deus a partir da luz, para adorá-Lo e estar completamente sujeitas ao Seu comando.<br /> E entre eles está Jibrail, que a paz esteja com ele, que envia revelação aos profetas.<span class="c6"><br /> A crença nos livros:</span><br /> São os livros que ALLAH enviou aos Seus Mensageiros.<br /> Como o Al Qur\'án foi revelado para Muhammad ﷺ.<br /> O Evangelho revelado para Jesus - que a paz esteja sobre ele .<br /> A Torá, para Moisés, que a paz esteja com ele.<br /> Zabur, para David, que a paz esteja com ele.<span class="c6"><br /> Os Livros de Ibrahim e Moisés:</span> Para Ibrahim e Moisés.<span class="c6"><br /> A crença nos mensageiros:</span><br /> E eles são aqueles que ALLAH enviou a Seus servos para ensiná-los, dar-lhes boas novas de bondade e Paraíso, e avisá-los do mal e do fogo.<span class="c6"><br /> Os melhores deles são:</span> Ulú Al-Azm,<span class="c6"> e são:</span><br /> Noé - que a paz esteja sobre ele -.<br /> Ibrahim, que a paz esteja com ele.<br /> Mussa - que a paz esteja sobre ele -.<br /> Issa - que a paz esteja sobre ele -.<br /> Muhammad ﷺ.<br /> A crença no Derradeiro Dia<br /> É após a morte na sepultura, e o Dia do Juízo Final, e o Dia da Ressurreição e Julgamento, quando as pessoas do Paraíso se estabelecerão em suas casas e as pessoas do Inferno em seus destinos.<br /> A fé no destino é bom e ruim.<br /> Al-<span class="c6">Qadar:</span> É a crença de que ALLAH sabe tudo o que acontece no Universo, e que Ele escreveu isso na Tábua Preservada,<br /> E Ele O Todo-<span class="c6">Poderoso disse:</span> <span class="c1">“Em verdade, criamos tudo com uma medida”</span> <span class="c5">[Surat Al-Qamar 49]</span><br /> É de quatro categorias:<br /> A primeira: O conhecimento de ALLAH Todo-Poderoso, incluindo Seu conhecimento prévio de tudo, antes e depois das coisas acontecerem.<span class="c6"><br /> E a evidência disso é o dito de ALLAH:</span> Por certo, junto de ALLAH, está a ciência da Hora, e Ele faz descer a chuva; e sabe o que há nas matrizes. E pessoa alguma se inteira do que logrará amanhã, e pessoa alguma se inteira sobre em que terra morrerá. Por certo, ALLAH é Onisciente, Conhecedor.<span class="c6"> Surat Luqman:</span>34<br /> A segunda: ALLAH escreveu isso na Tábua Preservada, então tudo o que aconteceu e vai acontecer está escrito com Ele em um livro.<span class="c6"><br /> E a evidência disso é o dito de ALLAH:</span> E Ele tem as chaves do Invisível; ninguém sabe delas senão Ele. E Ele sabe o que há na terra e no mar. E nenhuma folha tomba sem que Ele saiba disso, e não há grão algum nas trevas da terra nem algo, húmido nem seco, que não estejam no evidente livro.<span class="c6"> O Gado/59<br /> A terceira:</span> É que tudo acontece pela vontade de ALLAH, e nada Dele ou de Sua criação acontece a não ser por Sua vontade.<span class="c6"><br /> E a evidência disso é o dito de ALLAH:</span> Para quem de vós se quiser encaminhar. Porém, não vos encaminhareis, salvo se Allah, o Senhor do Universo, assim o permitir.<span class="c6"> Takwir:</span> 28 e 29.<span class="c6"><br /> Quarto:</span> A crença de que todos os seres são criados por ALLAH, e Ele criou suas estruturas, atributos, movimentos e tudo neles.<span class="c6"><br /> E a evidência disso é o dito de ALLAH:</span> Enquanto ALLAH vos criou e ao que fazeis?" Surat Sáffát:96 </p>',
            ],
            15 => [
                'question' => 'Q 16: Qual é a definição do Al Qur\'an?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1300.mp3',
                'answer' => '<p> R - É a palavra de ALLAH Todo-Poderoso, não de uma criatura.<span class="c6"><br /> O Altíssimo diz:</span> E se algum dos politeístas pedir-te proteção, então dá-lhe proteção para que ouça palavras de ALLAH.<span class="c6"> Surat Taubah:</span>6 </p>',
            ],
            16 => [
                'question' => 'Q 17: O que é a Sunnah?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1330.mp3',
                'answer' => '<p> R- É todo dito, feito, determinação, característica física ou caráter do Profeta, que a paz esteja com ele. </p>',
            ],
            17 => [
                'question' => 'Q 18: O que é heresia? Aceitamos?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1350.mp3',
                'answer' => '<p> R- Tudo que o povo inovou na religião, e não foi na época do Profeta, que a paz esteja com ele, e seus companheiros.<br /> * Não aceitamos e rejeitamos<br /> E o Profeta - que a paz e bênçãos de Allah estejam sobre ele -<span class="c6"> disse:</span> "Toda inovação é perdição" Narrado por Abu Daud;<br /> Por exemplo: Um aumento na adoração, como um aumento na ablução por uma quarta ablução e uma celebração do aniversário do Profeta, mas não foi narrado pelo Profeta, que a paz e as bênçãos de ALLAH estejam com ele e seus companheiros. </p>',
            ],
            18 => [
                'question' => 'Q 19: Mencione a doutrina da lealdade e repúdio?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1410.mp3',
                'answer' => '<p> R-<span class="c6"> Lealdade:</span> É o amor e apoio dos crentes.<span class="c6"><br /> O Altíssimo diz:</span> "Os fiéis e as fiéis são protectores uns dos outros.<span class="c6">" Surat Taubah:</span>71<br /> Al-<span class="c6">Bará:</span> É o ódio e a inimizade pelos incrédulos.<span class="c6"><br /> O Altíssimo diz:</span> "Tivestes um excelente exemplo em Abraão e naqueles que o seguiram,<span class="c6"> quando disseram ao seu povo:</span> Em verdade, não somos responsáveis por vossos atos e por tudo quando adorais, em lugar de Allah, Renegamos-vos e iniciar-se-á inimizade e um ódio duradouros entre nós e vós, a menos que creiais unicamente em Allah!" <span class="c5">[Surat Al-<span class="c6">Mumtahina:</span> 4]</span>. </p>',
            ],
            19 => [
                'question' => 'Q20: ALLAH aceita uma religião diferente do Isslam?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1480.mp3',
                'answer' => '<p> R - ALLAH não aceita nada além do Islam.<span class="c6"><br /> O Altíssimo diz:</span> E quem procurar religião além do Isslam, então jamais será aceite dele, e no Além ele será dentre os perdedores. Surat Al-<span class="c6">Imran:</span> 85 </p>',
            ],
            20 => [
                'question' => 'Q 21: A descrença se manifesta na fala, na ação e na crença, seu exemplo?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1520.mp3',
                'answer' => '<p> R -<span class="c6"> Um exemplo de dizer:</span> Insultar a ALLAH, Glória a Ele, ou Seu Mensageiro, que ALLAH o abençoe e lhe dê paz.<span class="c6"><br /> Exemplo de ação:</span> Insultar o Al Qur\'an ou prostrar-se a outro que não seja ALLAH Todo-Poderoso.<span class="c6"><br /> Exemplo de crença:</span> Acreditar que existe alguém digno de adoração além de ALLAH Todo-Poderoso, ou que existe um Criador com Deus Todo-Poderoso. </p>',
            ],
            21 => [
                'question' => 'Q22: O que é hipocrisia e quais são os seus tipos?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1570.mp3',
                'answer' => '<p> R-<br /> 1-<span class="c6"> A hipocrisia maior:</span> É esconder a incredulidade e manifestar a fé.<span class="c6"><br /> E tira a pessoa do Isslam e é descrença maior<br /> O Altíssimo diz:</span> Certamente, os hipócritas ocuparão o piso mais baixo do Inferno e jamais encontrarás socorredor para eles. An-<span class="c6">Nissá:</span> ١45<br /> 2-<span class="c6"> A hipocrisia menor<br /> Exemplo:</span> Mentir, quebrar uma promessa e quebra de confiança.<br /> Não tira a pessoa do Isslam, é um pecado e seu dono está sujeito a punição.<span class="c6"><br /> O Mensageiro de ALLAH disse:</span> "O hipócrita será reconhecido por três instâncias: Quando conta algo, mente; quando se compromete com algo, não cumpre, e quando nele se confia, trai a confiança." Narrado por Bukhari e Musslim. </p>',
            ],
            22 => [
                'question' => 'Q 23: Quem é o Selo dos Profetas e Mensageiros?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1680.mp3',
                'answer' => '<p> R-<span class="c6"> Muhammmadﷺ<br /> O Altíssimo diz:</span> Muhammad não é pai de nenhum de vossos homens, mas o Mensageiro de Allah e o selo dos Profetas. Surat Al-<span class="c6">Ahzab:</span> 40 O Mensageiro de ALLAH disse: "Eu sou o selo dos profetas, não haverá profeta depois de mim." Narrado por Abu Daud e Tirmizi. </p>',
            ],
            23 => [
                'question' => 'Q24: O que é um milagre?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1730.mp3',
                'answer' => '<p> R-<span class="c6"> O milagre:</span> É tudo o que ALLAH deu aos seus profetas de hábitos sobrenaturais para indicar sua sinceridade,<span class="c6"> tais como:</span><br /> A divisão da lua para o Profeta ﷺ.<br /> E abrindo o mar para Moisés, que a paz esteja com ele, e afogando Faraó e seus soldados. </p>',
            ],
            24 => [
                'question' => 'Q 25: Quem são os Companheiros (Sahabas)? E devo amá-los?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1780.mp3',
                'answer' => '<p> C-<span class="c6"> O Companheiro:</span> É aquele que conheceu o Profeta, que a paz esteja com ele, acreditando nele e morreu no Isslam.<br /> Nós os amamos e os seguimos, e eles são as melhores e melhores pessoas depois dos profetas.<span class="c6"><br /> E o melhor deles:</span> os quatro califas:<br /> Abu Bakr, que ALLAH esteja satisfeito com ele.<br /> Umar, que ALLAH esteja satisfeito com ele.<br /> Uthman, que ALLAH esteja satisfeito com ele.<br /> Áliy, que ALLAH esteja satisfeito com ele. </p>',
            ],
            25 => [
                'question' => 'Q 26: Quem são as mães dos crentes?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1870.mp3',
                'answer' => '<p> R - São as esposas do Profeta ﷺ.<span class="c6"><br /> O Altíssimo diz:</span> O Profeta tem mais direito sobre os crentes do que eles próprios; e suas esposas são mães deles. Surat Al-<span class="c6">Ahzab:</span> 6 </p>',
            ],
            26 => [
                'question' => 'Q 27: Qual é o direito da família do Profeta, que a paz esteja com ele, para nós?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1910.mp3',
                'answer' => '<p> R - Nós os amamos e cuidamos deles e odiamos aqueles que os odeiam e não vão a extremos neles, e eles são suas esposas, seus descendentes, Banu Hashim e Banu al-Muttalib dentre os crentes. </p>',
            ],
            27 => [
                'question' => 'Q 28: Qual é o nosso dever para com os governantes dos muçulmanos?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1940.mp3',
                'answer' => '<p> R-<span class="c6"> Nosso dever:</span> respeitá-los, ouvi-los e obedecê-los sem desobediência, não se rebelar contra eles, orar e aconselhá-los em segredo. </p>',
            ],
            28 => [
                'question' => 'Q 29: Qual é a casa dos crentes?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1970.mp3',
                'answer' => '<p> R - Paraíso, o Todo-<span class="c6">Poderoso disse:</span> Por certo, Allah, aos que crêem e fazem as boas obras, fará entrar em Jardins, abaixo dos quais correm os rios.<span class="c6"> Surat Muhammad:</span>12 </p>',
            ],
            29 => [
                'question' => 'Q 29: Qual é a casa dos descrentes?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2000.mp3',
                'answer' => '<p> R - O Inferno, o Todo-<span class="c6">Poderoso disse:</span> Mas se não o fizerdes – e jamais o podereis fazer, então temei o Fogo – aquele cujo combustível serão as pessoas e as pedras – preparado para os descrentes. Surat Al-<span class="c6">Bacara:</span> 24 </p>',
            ],
            30 => [
                'question' => 'Q31: O que é medo? E o que é esperançar? E qual é a evidência?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2020.mp3',
                'answer' => '<p> C-<span class="c6"> Medo:</span> É o temor a ALLAH e Seu castigo<br /> Esperança: É a esperança da recompensa, perdão e misericórdia de ALLAH.<span class="c6"><br /> E a evidência disso é o dito de Allah:</span> Esses que eles invocam, buscam meios de aproximar-se de seu Senhor, cada qual ansiando estar mais próximo d\'Ele, e esperam por Sua misericórdia e temem Seu castigo. Por certo, o castigo de teu Senhor é temível.<span class="c6"> Capitulo da viagem noturna/ 57 E o Altíssimo diz:</span> Informa a Meus servos que Eu sou o Perdoador, o Misericordioso. Mas que o Meu castigo é que é um castigo doloroso. Al-<span class="c6">Hijr:</span>49-50 </p>',
            ],
            31 => [
                'question' => 'Q 32: Mencione alguns dos nomes e atributos de ALLAH Todo-Poderoso?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2070.mp3',
                'answer' => '<p> R- ALLAH, o Senhor, o Clemente, o Oniouvinte, o Onividente, o Onisciente, o Sustentador, o Vivo, o Grande... etc. </p>',
            ],
            32 => [
                'question' => 'Q33: Explique esses nomes?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2100.mp3',
                'answer' => '<p> R-<span class="c6"> ALLAH:</span> Significa Deus que é verdadeiramente adorado, sozinho sem parceiro.<span class="c6"><br /> O Senhor:</span> isto é, o Criador, o Proprietário, o Provedor e o Governante somente. Glória para Ele.<br /> Al-<span class="c6">Sami\':</span> Aquele cuja audição expandiu tudo, e ele ouve todas as vozes diferentes e variadas.<span class="c6"><br /> O vidente:</span> Aquele que vê tudo, seja pequeno ou grande.<span class="c6"><br /> O Onisciente:</span> Ele é Aquele cujo conhecimento abrange tudo no passado, presente e futuro.<br /> Ar-<span class="c6">Rahman:</span> Cuja misericórdia se estende a toda criatura viva, e todas as criaturas estão sob sua misericórdia.<br /> Ar-<span class="c6">Razzaq:</span> Aquele que é responsável pelo sustento de todas as criaturas, incluindo humanos, génios e todos os animais.<br /> Al-<span class="c6">Hayy:</span> O Vivo que não morre, e toda a criação morre.<span class="c6"><br /> O Grande:</span> Aquele que tem toda perfeição e toda grandeza em Seus Nomes, Atributos e Ações. </p>',
            ],
            33 => [
                'question' => 'Q 28: Qual é o nosso dever para com os sábios muçulmanos?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2210.mp3',
                'answer' => '<p> R - Nós os amamos, e a eles nos referimos em assuntos e calamidades legais, e não os lembramos senão do bem, e aqueles que os mencionam de outra forma são maus; Ele está fora do caminho.<span class="c6"><br /> O Altíssimo diz:</span> ALLAH elevará em graus, os crentes dentre vós e aqueles que foram dados o conhecimento. E ALLAH está Informado do que praticais. Al-<span class="c6">Mujádalah:</span>11 </p>',
            ],
            34 => [
                'question' => 'Q 35- Quem são os amigos de ALLAH Todo-Poderoso?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2240.mp3',
                'answer' => '<p> R: - São os crentes piedosos.<span class="c6"><br /> O Altíssimo diz:</span> "Ora, por certo, os aliados a Allah, por eles nada haverá que temer, e eles não se entristecerão.<span class="c6">" Surat Yúnuss:</span> 62-63 </p>',
            ],
            35 => [
                'question' => 'Q 36: A fé é uma declaração e uma ação?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2280.mp3',
                'answer' => '<p> R- Crença é afirmação, ação e crença. </p>',
            ],
            36 => [
                'question' => 'Q 37: A fé aumenta e diminui?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2310.mp3',
                'answer' => '<p> R - A fé aumenta com a obediência e diminui com a desobediência.<span class="c6"><br /> O Altíssimo diz:</span> Os verdadeiros crentes são apenas aqueles cujos corações se atemorizam, quando é mencionado Allah, e, quando são recitados para eles, Seus versículos, acrescentam-lhes fé; e eles confiam em seu Senhor. Surat Al-<span class="c6">Anfal:</span>2 </p>',
            ],
            37 => [
                'question' => 'Q 38: O que é a bondade?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2350.mp3',
                'answer' => '<p> R: Adorar a Allah como se O visses e se tu não vês Ele te vê </p>',
            ],
            38 => [
                'question' => 'Q 39: Quando as obras são aceitáveis a Deus, Glória a Ele?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2370.mp3',
                'answer' => '<p> R: Com duas condições:<br /> 1- Se for puramente por causa de ALLAH Todo-Poderoso.<br /> 2- Se estiver de acordo com a Sunnah do Profeta ﷺ. </p>',
            ],
            39 => [
                'question' => 'Q40: O que é a confiança em ALLAH Todo-Poderoso?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2420.mp3',
                'answer' => '<p> R - É confiar em ALLAH Todo-Poderoso para trazer benefícios e repelir danos, levando em conta os motivos.<span class="c6"><br /> O Altíssimo diz:</span> E quem confia em Allah,<span class="c6"> Ele lhe bastará Talaq:</span>3<br /> Hassbuh: isto é, o suficiente. </p>',
            ],
            40 => [
                'question' => 'Q 41: Qual é o dever de ordenar o bem e proibir o mal?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2470.mp3',
                'answer' => '<p> C - Al-<span class="c6">Ma\'ruf:</span> é o mandamento de toda obediência a ALLAH, o Poderoso e Sublime,<span class="c6"> e o Munkar:</span> é a proibição de toda desobediência a ALLAH, o Poderoso e Sublime.<span class="c6"><br /> O Altíssimo diz:</span> Sois a melhor nação que surgiu para a humanidade: ordenais o bem, proibis o mal e credes em ALLAH. Surat Al-<span class="c6">Imran:</span> 110. </p>',
            ],
            41 => [
                'question' => 'P42: Quem são Ahl Sunnah Wal\'jamãah?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2510.mp3',
                'answer' => '<p> R - Eles são os que estavam sobre o mesmo que o Profeta, que a paz e bênçãos de ALLAH estejam com ele, e seus companheiros, em ditos, práticas e crenças.<br /> E foram chamados de Ahl al-<span class="c6">Sunnah:</span> por seguirem a Sunnah do Profeta, que a paz e bênçãos de ALLAH estejam sobre ele, e pelo abandono da inovação.<br /> E Al-<span class="c6">Jamaah:</span> porque estavam unidos na verdade e não estavam divididos nela. </p>',
            ],
        ],
        2 => [
            0 => [
                'question' => 'P1: Defina a pureza?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2580.mp3',
                'answer' => '<p> R-<span class="c6"> Pureza:</span> É a remoção da impureza e sujidade.<span class="c6"><br /> Remoção da sujidade:</span> Cabe ao muçulmano remover qualquer impureza que tenha caído em seu corpo, em suas roupas, ou no local e no lugar onde reza.<span class="c6"><br /> Remoção de impureza não palpável:</span> É feito por ablução ou ghussl, com água purificadora, ou tayammum para quem perdeu água, ou não conseguiu usá-la. </p>',
            ],
            1 => [
                'question' => 'P2: Como você purifica o que foi atingido pela impureza?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2630.mp3',
                'answer' => '<p> R: Lavando-o com água até ficar puro.<br /> - Quanto ao que o cachorro lambe; Lavando sete vezes a primeira com terra. </p>',
            ],
            2 => [
                'question' => 'P 3: Qual é o mérito da ablução?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2660.mp3',
                'answer' => '<p> E o Profeta - que a paz e bênçãos de Allah estejam sobre ele -<span class="c6"> disse:</span> "Quando um muçulmano ou - um crente - faz ablução, ao lavar o rosto, todos os pecados que cometeu com os seus olhos são lavados com a água, ou com a última gota de água; quando ele lava as mãos, todo pecado que ele cometeu é lavado de suas mãos com a água, ou com a última gota de água; e quando ele lava os seus pés, todo pecado que seus pés caminharam é lavado com a água, ou com a última gota de água, até que ele saia limpo de todos os pecados." Narrado por Musslim. </p>',
            ],
            3 => [
                'question' => 'P4: Como você realiza a ablução?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2690.mp3',
                'answer' => '<p> R- Lavando as mãos três vezes.<br /> Gorgolejando e inspirar e expirar três vezes.<span class="c6"><br /> O gorgolejar:</span> Colocando água na boca, misturar e tirar fora.<span class="c6"><br /> Inalação:</span> Atrair água com ar para o nariz com a mão direita.<span class="c6"><br /> Inspiração:</span> É a tiragem de água do nariz após inalação com a esquerda.<br /> Em seguida, lave o rosto três vezes.<br /> Em seguida, lave as mãos até os cotovelos três vezes.<br /> Em seguida, faça o mass\'h da cabeça, de frente para trás com a mão, e passando a mão sobre as orelhas.<br /> Em seguida, lave os pés até os tornozelos três vezes.<br /> Este é o mais completo, e isso foi comprovado pela autoridade do Profeta, que a paz e as bênçãos de ALLAH estejam com ele, em Hadiths em Al-Bukhari e Musslim, narrados por Othman, Abdullah bin Zaid e outros. Também foi comprovado dele no Al-<span class="c6">Bukhari e outros:</span> <span class="c1">“Ele realizou a ablução uma vez, e ele realizou a ablução duas vezes”</span>,<span class="c6"> significando:</span> ele lavou cada uma das partes da ablução uma ou duas vezes. </p>',
            ],
            4 => [
                'question' => 'P 5: Quais são as obrigações de ablução, e quantas são?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2810.mp3',
                'answer' => '<p> R: São aquelas que não vale a ablução de um muçulmano se deixar uma delas.<br /> Lavar o rosto, enxaguar <span class="c2">(a boca)</span> e lavar as narinas.<br /> Lavar os braços até os cotovelos;<br /> 3- Passar a mão molhada em toda a cabeça <span class="c2">(mas’há)</span>, incluindo as orelhas;<br /> 4- Lavar os pés até os tornozelos.<br /> 5- A ordem entre os membros, lavando o rosto, depois as mãos, depois enxugando a cabeça, depois lavando os pés.<br /> 6- Al-<span class="c6">Muwaalat:</span> É a ablução em tempo contínuo, sem intervalo de tempo até que as partes sequem da água.<br /> - Se ele fizer a metade da ablução e a completar em outro momento, sua ablução não é válida. </p>',
            ],
            5 => [
                'question' => 'P 6: Quais são os Sunan da ablução, e quantos são?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2910.mp3',
                'answer' => '<p> R: Sunnahs de ablução: São aqueles se os fizer; Ele tem mais recompensa, e se as deixar; Não há pecado sobre ele, e sua ablução está correta.<br /> 1-<span class="c6"> Nome:</span> Em nome de ALLAH.<br /> 2- Miswak.<br /> 3- Lavagem das palmas<br /> 4- Passar a mão sobre os dedos<br /> 5- A segunda e terceira lavagem dos órgãos.<br /> 6- Iniciar com a direita<br /> 7- A recordação após o wudhu Testemunho que não há divindade que merece adoração senão Allah, o Único que não tem parceiro, e testemunho que Muhammad é Seu servo e Mensageiro<br /> 8- Dois rakats após </p>',
            ],
            6 => [
                'question' => 'P7: Quantas coisas invalidam a ablução?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3020.mp3',
                'answer' => '<p> R: O que sai das duas vias\'; Frontal e trazeira, como urina, fezes ou gases.<br /> Dormir, ou enlouquecer ou desmaiar.<br /> consumo da carne do camelo<br /> Tocar no órgao genital e no traseiro com a mão sem barreira. </p>',
            ],
            7 => [
                'question' => 'P8: O que é Tayammum?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3080.mp3',
                'answer' => '<p> R: Tayammum: É o uso do solo e de outras partes da terra, na inexistência de água ou se for possível utilizá-la. </p>',
            ],
            8 => [
                'question' => 'P9: Como você executa Tayammum?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3110.mp3',
                'answer' => '<p> R: Bater a terra de uma só vez com a parte interna das mãos, e limpar o rosto e o dorso das mãos uma vez. </p>',
            ],
            9 => [
                'question' => 'P10: Quais são os anuladores de Tayammum?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3140.mp3',
                'answer' => '<p> R: Tudo o que anula a ablução.<br /> Se a água for encontrada. </p>',
            ],
            10 => [
                'question' => 'P11: O que são khuf e meias? Será que se faz o Mass\'h sobre elas?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3180.mp3',
                'answer' => '<p> R: Khuff: É o que é calçado de pele<br /> R: Meias: É o que é calçado de outros materiais<br /> E é permitido fazer o Mass\'h sobre elas </p>',
            ],
            11 => [
                'question' => 'P12: Mencione a prudência da sua instituição?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3230.mp3',
                'answer' => '<p> C - Facilitar e aliviar as pessoas, principalmente em épocas de frio, inverno e viagens, quando é difícil retirar o que está nas pernas. </p>',
            ],
            12 => [
                'question' => 'P13- Quais sao as condições para fazer o Mass\'h sobre as meias?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3260.mp3',
                'answer' => '<p> R: Usar o khuffayn em estado de pureza, ou seja, após a ablução.<br /> 2- Os khuff devem ser puros, portanto não é permitido enxugar sobre os impuros.<br /> 3- Os khuff devem cobrir o local que deve ser lavado durante a ablução.<br /> 4- Que o Mass\'h seja feito dentro do prazo especificado,<span class="c6"> para um residente não viajante:</span> um dia e uma noite,<span class="c6"> e para um viajante:</span> três dias e noites. </p>',
            ],
            13 => [
                'question' => 'Q14- O que invalida o Mass\'h sobre as meias?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3320.mp3',
                'answer' => '<p> R: Colocar os dedos da mão molhada sobre os dedos dos pés e friccionar levemente até ao tornozelo, usar a mão direita para o pé direito, e mão esquerda para o pé esquerdo, e deve fazer isso com os dedos separados, e não pode fazer repetidamente. </p>',
            ],
            14 => [
                'question' => 'Q15- O que invalida o Mass\'h sobre as meias?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3350.mp3',
                'answer' => '<p> R-1- Terminado o período de mass\'h sobre as meias, não é permitido limpar as meias após o término do período de limpeza especificado pela Sharia, um dia e uma noite para o residente e três dias e noites para o viajante.<br /> 2- Tirar o khuffayn, se uma pessoa tirar um ou os dois depois do Mass\'h,então torna-se inválido. </p>',
            ],
            15 => [
                'question' => 'Q 16: O significado do Salah?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3390.mp3',
                'answer' => '<p> C-<span class="c6"> Salah:</span> É a devoção a ALLAH com palavras e ações específicas, começando com o takbir e terminando com o tassleem. </p>',
            ],
            16 => [
                'question' => 'Q 17: A decisão sobre a oração?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3420.mp3',
                'answer' => '<p> C- A oração é uma obrigação para todo muçulmano.<span class="c6"><br /> O Altíssimo diz:</span> Por certo, a oração foi prescrita aos fiéis para ser cumprida em seu devido tempo. An-<span class="c6">Nissá:</span> 103 </p>',
            ],
            17 => [
                'question' => 'P 18: Qual é a decisão sobre o abandono do Salah?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3460.mp3',
                'answer' => '<p> R: Abandono do Salah é descrença. O Profeta, que a paz bênçãos de ALLAH estejam com ele,<span class="c6"> disse:</span> O acordo entre nós e eles reside no salah, quem abandoná-la, certamente que desobedeceu. Narrado por Ahmad e Tirmizi confirmou a veracidade. </p>',
            ],
            18 => [
                'question' => 'Q 19- Quantas orações são exigidas de um muçulmano por dia e noite? Quantas rak\'ahs existem para cada oração?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3500.mp3',
                'answer' => '<p> C- Cinco orações por dia e noite,<span class="c6"> oração Fajr:</span> duas unidades,<span class="c6"> oração Dhuhr:</span> quatro unidades,<span class="c6"> oração Asr:</span> quatro unidades,<span class="c6"> oração Maghrib:</span> três unidades e oração da noite: quatro unidades. </p>',
            ],
            19 => [
                'question' => 'Q 20: Quantas são as condições para a oração?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3530.mp3',
                'answer' => '<p> C- 1- Isslam; Não é válido de um infiel.<br /> 2- O juizo; nao é aceite do demente.<br /> 3. A distinção; nao é válido do pequeno<br /> 4- A intenção<br /> 5- A entrada da hora<br /> 6- A pureza<br /> 7- A remoção da sujidade<br /> 8- A cobertura da vergonha<br /> 9- Direcionar-se para o Qiblah </p>',
            ],
            20 => [
                'question' => 'Q 21: O número de pilares de salah?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3640.mp3',
                'answer' => '<p> C- São quatorze pilares,<span class="c6"> conforme segue:</span><br /> A primeira deles : A posição em pé na oração obrigatória, para quem é capaz de manter-se verticalmente.<br /> O Takbir de início, i.e. ALLAHU AKBAR<br /> Leitura do Capitulo da al-fátiha <span class="c2">(abertura)</span>.<br /> O ruku, esticando as costas e virando a cabeça para ele.<br /> Levantar-se do mesmo<br /> Permancer firme de pé<br /> A prostração, firmar sua testa, nariz, mãos, joelhos e as pontas dos dedos dos pés do local de prostração.<br /> levantar-<span class="c6">ve da prostração<br /> Sentar entre as duas prostrações:</span><br /> A Sunnah: É sentar-se na perna esquerda, erguer o pé direito e direcioná-lo para a Qiblah.<br /> Tranquilidade, que é quietude em cada pilar.<br /> Último testemunho<br /> A sentada para o primeiro testemunho.<br /> Os dois salams; dizer duas vezes Assalamu Alaikum Warahmatullah<br /> A ordem dos pilares - como mencionamos - Se, por exemplo, ele se prostra deliberadamente antes de se curvar; torna-se inválido; se for por engano Ele deve voltar a fazer o ruku, depois se prostrar. </p>',
            ],
            21 => [
                'question' => 'Q22: Mencione as obrigações do salah?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3820.mp3',
                'answer' => '<p> R: São oito,<span class="c6"> conforme o seguinte:</span><br /> 1-<span class="c6"> Todos os Takbirs fora o primeiro<br /> O dito:</span> Allah ouve quem O louva,<span class="c6"> para o imam e aquele que reza individualmente<br /> O dito:</span> Nosso Senhor, para Ti é o louvor.<br /> 4.<span class="c6"> A expressão:</span> <span class="c1">“subhana rabbil adhiim”</span> <span class="c2">(Quão perfeito Tu és meu Senhor, o Poderosíssimo)</span>, uma vez na genuflexão<br /> 5.<span class="c6"> A expressão:</span> <span class="c1">“ subhana rabiil alaa”</span> <span class="c2">(Quão perfeito Tu és meu Senhor, o Altíssimo)</span>, uma vez na prostração<br /> 6. A expressão Meu Senhor, perdoa-me!, entre as duas prostrações.<br /> 7. O primeiro Tashahhud<br /> 8- Sentar-se para o primeiro Tashahhud </p>',
            ],
            22 => [
                'question' => 'P23: Quais são os Sunan do Salah?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3930.mp3',
                'answer' => '<p> R: São onze,<span class="c6"> conforme os seguintes:</span><br /> 1-<span class="c6"> Seu dizer após o takbir de abertura:</span> <span class="c1">“Glória a ti, ó ALLAH, e louvor a ti, e bendito seja o teu nome, e exaltado seja a Sua Magestade, e não há outro Deus além de ti”</span>. súplica de abertura.<br /> 2- O pedido de refúgio<br /> 3- Início com o nome de ALLAH<br /> 4- Dizer Ámin<br /> 5- Recitar outro capítulo após o Al-Fatihah<br /> 6- Recitar de forma audivel para o Imam<br /> 7-<span class="c6"> Dizer após o dua de ruku:</span> "mila\' alssamwat, wamil\' al\'arda, wamil\' ma shit min shay\' bad".<br /> 8- O segundo e o terceiro tasbeeh, e mais do que isso.<br /> 9- O que é mais de uma vez na glorificação da prostração.<br /> 10-<span class="c6"> O que disse mais de uma vez entre as duas prostrações:</span> <span class="c1">“Senhor, perdoa-me”</span>.<br /> 11- A oração no último tashahhud por sua família, que a paz esteja com eles, e bênçãos sobre ele e eles, e a súplica depois disso.<span class="c6"><br /> Quarto:</span> Sunan em práticas:<br /> 1- Levantar a mão ao dizer o primeiro Takbir<br /> 2- Ao ir para o ruku<br /> 3- Ao voltar do Ruku<br /> 4- Soltá-las depois disso.<br /> 5- Colocar a mão direita sobre a esquerda<br /> 6- Olhar para o local de Sajdah<br /> 7- Separar os pés quando estiver em pé<br /> 8- Segurar os joelhos com as mãos, dedos separados, em sua reverência, e esticar as costas para ele, e fazer a cabeça de frente para ele.<br /> 9- Habilitar os membros a se prostrarem do chão, e encaminhá-los ao local da prostração.<br /> 10- Separar os braços das laterais, a barriga das coxas e as coxas das pernas, separar os joelhos, endireitar os pés, colocar as barrigas dos dedos dos pés no chão, separar e colocar as mãos junto aos ombros , estendido, dedos entrelaçados.<br /> 11- Iftirash em sentar-se entre as duas prostrações, e no primeiro tashahhud, e tawarruk no segundo.<br /> 12- Colocando as mãos nas coxas, estendidas, dedos entrelaçados entre as duas prostrações, e o mesmo no tashahhud exceto que ele agarra o dedo mindinho direito e o dedo anelar, raspa o polegar dela com o meio, e aponta com o dedo indicador quando lembra de ALLAH.<br /> 13- Virar a direita e a esquerda </p>',
            ],
            23 => [
                'question' => 'P24: Número de coisas que invalidam o Salah?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4210.mp3',
                'answer' => '<p> R1: Abandonar um pilar ou condição do Salah<br /> 2- Falar propositadamente<br /> 3- Comer e beber<br /> 4- Muitos movimentos consecutivos<br /> 5- Abandonar um wajib propositadamnete do Salah </p>',
            ],
            24 => [
                'question' => 'P25: Como o musslim observa o Salah?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4280.mp3',
                'answer' => '<p> R: O modo de observar o Salah:<br /> 1- Encarar a Qiblah com todo o corpo, sem desvios ou voltas.<br /> 2 - Então ele tenciona realizar a oração que deseja rezar com o coração sem proferir a intenção.<br /> 3 -<span class="c6"> Então ele diz o Ihram takbir e diz:</span> <span class="c2">(ALLAH é o Maior)</span>, e levanta as mãos para acompanhar seus ombros ao dizer o takbir.<br /> 4- Em seguida, ele coloca a palma da mão direita no dorso da palma da mão esquerda acima do peito.<br /> 5-<span class="c6"> Então ele inicia e diz:</span> Ó Allah, distancia-me de meus pecados, assim como Tu distanciaste o nascente do poente, ó Allah purifica-me de meus pecados como a roupa branca é purificada da sujeira, ó Allah lava-me de meus pecados com a neve,<span class="c6"> a água e o granizo<br /> Ou diz:</span> Glorificado sejas, Ó Allah, o louvor é para Ti. Abençoado seja Teu nome, e altíssimo é Teu poder, e não há divindade real além de Ti;<br /> 6-<span class="c6"> Em seguida diz Auzu billah e diz:</span> Procuro refúgio diante de Allah contra o satanás o malvado 7- Diz o Bissmillah e recita o Al-<span class="c6">Fatihah e diz:</span> Em nome de ALLAH, o Clemente, o Misericordioso Louvor a Allah, O Senhor dos mundos. Clemente, o Misericordioso, O Soberano do Dia do Juízo . Só a Ti adoramos e só de Ti imploramos ajuda Guia-nos à senda reta À senda dos que agraciaste; não à dos incursos em Tua ira nem à dos descaminhados <span class="c2">(sirata anladzina an amta alahim ghairil maghdub alaihim waladdalin)</span> [Al-<span class="c6">Fátihah:</span>1-7<br /> Depois diz Ámin. I.e. Ó ALLAH aceite<br /> 8- Então ele recita o que puder do Al Qur\'an e prolonga a recitação na oração da manhã.<br /> 9 - Então ele observa o Rukú,<span class="c6"> ou seja:</span> ele dobra as costas em glorificação a ALLAH, diz o takbir ao se curvar, e levanta as mãos na altura de seus ombros.<span class="c6"> A Sunnah:</span> para esticar as costas, trazer a cabeça para ele e colocar as mãos sobre os joelhos, dedos separados.<br /> 10 - Em sua reverência,<span class="c6"> ele diz:</span> <span class="c1">“Glória ao meu Senhor, o Grande”</span> três vezes,<span class="c6"> e se acrescenta:</span> <span class="c1">“Glória a ti, ó ALLAH, e louvor a ti, ó ALLAH, perdoa-me”</span>. é bom.<br /> 11 - Então ele levanta a cabeça de se curvar,<span class="c6"> dizendo:</span> <span class="c1">“ALLAH ouve aquele que O louva.”</span> Então ele levanta as mãos para seguir seus ombros.<span class="c6"> O seguidor não diz:</span> <span class="c1">“ALLAH ouve aqueles que o louvam”</span>,<span class="c6"> mas diz:</span> <span class="c1">“Senhor nosso, a Ti seja o louvor”</span>.<br /> 12 - Depois, depois de levantá-lo,<span class="c6"> diz:</span> <span class="c1">“Senhor nosso, a Ti seja o louvor, a plenitude dos céus e da terra, e a plenitude de tudo o que desejares”</span>.<br /> 3 - Então ele se prostra na primeira prostração e, ao se prostrar,<span class="c6"> diz:</span> <span class="c1">“ALLAH é o Maior.”</span> Ele se prostra sobre seus sete membros: testa, nariz, mãos, joelhos e extremidades dos pés. Ele deve manter seus braços mais afastados do corpo, seus braços não devem estar estendidos no chão, e ele deve encarar a qiblah com as pontas dos pés.<br /> 14 - Em sua reverência,<span class="c6"> ele diz:</span> <span class="c1">“Glória ao meu Senhor, o Grande”</span> três vezes,<span class="c6"> e se acrescenta:</span> <span class="c1">“Glória a Ti, ó ALLAH, e louvor a Ti, ó ALLAH, perdoa-me”</span>. é bom.<br /> 15 -<span class="c6"> Então ele levanta a cabeça da prostração e diz:</span> <span class="c1">“ALLAH é o Maior”</span><br /> 16- Em seguida, ele se senta entre as duas prostrações do pé esquerdo, endireita o pé direito, coloca a mão direita na ponta da coxa direita, que fica ao lado do joelho, e dele pega o dedo mindinho e o anelar. da coxa esquerda abaixo do joelho. Ele segura o dedo mindinho e o anelar, levanta o dedo indicador e o move ao suplicar, e faz a ponta do polegar acoplada com a ponta do meio como um anel, e coloca a mão esquerda, dedos estendidos, na ponta da esquerda coxa, que fica ao lado do joelho.<br /> 17-<span class="c6"> Ele diz sentado entre as duas prostrações:</span> <span class="c1">“Senhor, perdoa-me, tem piedade de mim, guia-me, sustenta-me, emenda-me e cura-me”</span>.<br /> 18- Então ele prostra a segunda prostração como a primeira no que é dito e feito, e ele diz o takbir ao se prostrar.<br /> 19 - Então ele se levanta da segunda prostração,<span class="c6"> dizendo:</span> <span class="c1">“ALLAH é o Maior”</span> e reza a segunda rak\'ah como a primeira no que é dito e feito, exceto que ele não a abre nela.<br /> 20 - Então ele se senta após o final da segunda rak\'ah,<span class="c6"> dizendo:</span> "ALLAH é o Maior", e senta-se como se senta entre as duas prostrações, o mesmo.<br /> 21- O tashahhud é recitado nesta sessão,<span class="c6"> e ele diz:</span> <span class="c2">(Attahiyaat (isto é, todas as palavras que indicam a glorificação de Allah, Sua Eterna Existência, Sua Perfeição, Sua Soberania)</span> são para Allah, Todos os atos de adoração e boas ações são para Allah. A paz, a misericórdia, e as bênçãos de Allah estejam sobre você, ó Profeta. A paz esteja sobre nós e todos os virtuosos servos de Allah. Eu testemunho que não há divindade real além de Allah, e eu testemunho que Muhammad é Seu servo e Mensageiro. Ó Allah exalta Muhammad, suas esposas e seus descendentes assim como Tu exaltaste a família de Abraão. E abençoa Muhammad, suas esposas e seus descendentes como abençoaste a família de Abrão. Em verdade Tu és Laudabilíssimo, Munificente. Então ele clama ao seu Senhor pelo que ele ama da bondade deste mundo e do outro.<span class="c6"><br /> Depois efectuava o primeiro tasslim virando para a direita dizendo:</span> <span class="c1">“Assalamu alaikum warahmatullah”</span> <span class="c2">(Que a paz e misericórdia de Allah estejam contigo)</span>; depois vira a esquerda dizendo o mesmo.<br /> 23 - Se a oração for composta por três ou quatro; Ele para no final do primeiro tashahhud,<span class="c6"> que é:</span> <span class="c1">“Testemunho que não há outro deus além de ALLAH, e testemunho que Muhammad é Seu servo e Mensageiro”</span>.<br /> 24 -<span class="c6"> Então ele se levanta e diz:</span> <span class="c1">“ALLAH é o Maior”</span> e levanta as mãos para acompanhar seus ombros naquele momento.<br /> 25 - Então ele observa o restante de sua oração da mesma forma que a segunda rak\'ah, exceto que ele se limita a recitar Al-Fatihah.<br /> 26- Então ele se senta mutawark, endireita o pé direito, e tira o pé esquerdo de debaixo da perna direita, e permite que ele descanse no chão, e coloca as mãos nas coxas da maneira que colocou no primeiro tashahhud.<br /> 27- Todo o tashahhud é recitado durante esta sessão.<span class="c6"><br /> Depois efectuava o primeiro tasslim virando para a direita dizendo:</span> <span class="c1">“Assalamu alaikum warahmatullah”</span> <span class="c2">(Que a paz e misericórdia de Allah estejam contigo)</span>; depois virava a esquerda dizendo o mesmo. </p>',
            ],
            25 => [
                'question' => 'Q 26: O que você diz das recordações após o salam no salah?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4610.mp3',
                'answer' => '<p> R: Asstagfirullah três vezes<br /> Ó Allah! Por certo, Tu és a Assalam <span class="c2">(Provedor da paz)</span> e de Ti provém a paz, abençoado sejas, ó Possuidor da majestade e honra<br /> "Não outra há outro deus digno de adoração além de Allah, o Único, Que não tem parceiros; Sua é a soberania e Seu é o louvor, e Ele tem poder sobre todas as coisas. Ó Allah, ninguém pode obstruir o que Tu concedes. E ninguém pode conceder o que Tu retiras; quanto ao homem de posses, essas de nada poderão servir."<br /> Não há divindade real além de Allah, o Único que não possui sócio, Ele é o Possuidor de toda soberania e louvores, Ele é quem possui poder sobre todas as coisas, não há mudança nem poder a não ser por Allah, não adoramos a não ser Ele, a Ele pertencem a graça, o favor, e a virtude do louvor, não há divindade real a não ser Allah, somos sinceros na Sua crença e devoção, mesmo que isso desgoste os incrédulos<br /> - Sub\'hanallah trinta e três vezes<br /> Al-Hamdulillah trinta e três vezes<br /> ALLAH Akbar trinta e três vezes<br /> Em seguida completa cem Não há divindade real além de Allah, o Único que não possui sócio, Ele é o Possuidor de toda soberania e louvores, Ele é quem possui poder sobre todas as coisas<br /> Ele recita Surat Al-Ikhlas e Al-Ma\'widhaat. Três vezes após as orações do amanhecer e do pôr-do-sol, e uma vez após as outras orações.<br /> - Ele recita Ayat al-Kursi, uma vez. </p>',
            ],
            26 => [
                'question' => 'P27: O que é Sunan Rawátib? E quais são suas virtudes?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4730.mp3',
                'answer' => '<p> Dois Rakats antes do Al-Fajr<br /> Quatro rakates antes de Zuhr.<br /> Dois rakates depois de Zuhr.<br /> Dois rakates depois de Maghrib.<br /> Dois rakates depois de Isha.<span class="c6"><br /> Seu mérito:</span> O Profeta disse: <span class="c1">“Quem observa doze rak\'ahs voluntariamente durante o dia e a noite, ALLAH construirá para ele uma casa no Paraíso.”</span> Narrado por Musslim, Ahmad e outros. </p>',
            ],
            27 => [
                'question' => 'Q28: Quais são os melhores dias da semana?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4800.mp3',
                'answer' => '<p> R: A sexta-Feira. E o Profeta - Que a paz e bênçãos de Allah estejam sobre ele -<span class="c6"> disse:</span> <span class="c1">“Um dos seus melhores dias é a sexta-feira, nele Adão foi criado, nele ele morreu, nele a trombeta foi tocada e nele o raio, então aumente suas orações sobre mim, pois suas orações são apresentadas a mim.”</span> Ele disse: Eles disseram, ó Mensageiro de ALLAH, como nossas orações podem ser apresentadas a você quando você tornou-se pó? -<span class="c6"> Ele disse:</span> <span class="c1">“ALLAH, o Poderoso e Sublime, proibiu que a terra comesse os corpos dos profetas.”</span> Narrado por Abu Daud e outros; </p>',
            ],
            28 => [
                'question' => 'Q 29: Qual é a decisão sobre a oração de sexta-feira?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4840.mp3',
                'answer' => '<p> c- É uma obrigação individual de todo muçulmano adulto, são e residente do sexo masculino.<span class="c6"><br /> O Altíssimo diz:</span> Ó vós que credes! Quando se chama à oração da Sexta-feira, ide, depressa, para a lembrança de Allah, e deixai a venda. Isto vos é melhor. Se soubésseis! Al-<span class="c6">Munáfikún:</span>9 </p>',
            ],
            29 => [
                'question' => 'Q 30: Quantas unidades são de oração de sexta-feira?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4880.mp3',
                'answer' => '<p> C - O número de rak\'ahs da oração de sexta-feira é de duas rak\'ahs em que o imam recita em voz alta, onde dois sermões bem conhecidos os precedem. </p>',
            ],
            30 => [
                'question' => 'Q 31: É permitido perder a oração de sexta-feira?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4910.mp3',
                'answer' => '<p> C - Não é permitido faltar à oração de sexta-feira, exceto por uma desculpa legítima.O Profeta, que a paz e as bênçãos de ALLAH estejam com ele,<span class="c6"> disse:</span> "Aquele que não rezar três orações de sexta-feira <span class="c2">(de forma consecutiva)</span> por negligência, Allah sela o seu coração\'\' Narrado por Abu Daud e outros; </p>',
            ],
            31 => [
                'question' => 'P22: Menciona os Sunan de dia de Jumuah?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4940.mp3',
                'answer' => '<p> R-<br /> 1- Tomar banho<br /> 2- Perfumar-se<br /> 3- Usar melhor roupa<br /> 4- Ir cedo ao Massgid<br /> 5- Enviar saudação ao Profeta abundantemente<br /> 6- Recitar Surat Al-Kahf<br /> 7- Ir ao massgid a pé<br /> 8- Procurar a hora em que as súplicas são aceites </p>',
            ],
            32 => [
                'question' => 'Q 33: Mencione a virtude da oração congregacional?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5050.mp3',
                'answer' => '<p> R: Pela autoridade de Ibn Umar, que ALLAH esteja satisfeito com ele, que o Mensageiro de ALLAH, paz e bênçãos estejam sobre ele,<span class="c6"> disse:</span> A recompensa para a oração praticada em congregação é vinte e sete vezes maior do que a da praticada individualmente Narrado por Musslim. </p>',
            ],
            33 => [
                'question' => 'P34: O que signficia a calma no Salah?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5080.mp3',
                'answer' => '<p> R: É a presença do coração e a quietude da presa.<span class="c6"><br /> O Altíssimo diz:</span> Com efeito, bem-aventurados os crentes, Que são humildes em suas orações, Al-<span class="c6">Múminun:</span>1-2 </p>',
            ],
            34 => [
                'question' => 'Q 35: Defina o zakat?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5120.mp3',
                'answer' => '<p> R: - É um direito obrigatório a um dinheiro especial de um determinado grupo em um determinado momento.<br /> É um dos pilares do Isslam, e é caridade obrigatória que se tira dos ricos e se dá aos pobres.<span class="c6"><br /> O Altíssimo diz:</span> E concedem o zakat Surat Al-<span class="c6">Bacara:</span> 43 </p>',
            ],
            35 => [
                'question' => 'Q36: O que é caridade recomendável?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5170.mp3',
                'answer' => '<p> C - É tudo além do Zakat,<span class="c6"> como por exemplo:</span> doar para causas beneficentes a qualquer momento.<span class="c6"><br /> O Altíssimo diz:</span> E gastai no caminho de Allah. Surat Al-<span class="c6">Bacara:</span> 195 </p>',
            ],
            36 => [
                'question' => 'P37: Defina o jejum?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5210.mp3',
                'answer' => '<p> R- É adorar a ALLAH abstendo-se das coisas que quebram o jejum do amanhecer ao pôr do sol, com a intenção,<span class="c6"> e é de dois tipos:</span><br /> Jejum obrigatório: Como jejuar no mês do Ramadhan, que é um dos pilares do Isslam.<span class="c6"><br /> O Altíssimo diz:</span> Ó vós que credes! É-vos prescrito o jejum como foi prescrito aos que foram antes de vós, para serdes piedosos. Surat Al-<span class="c6">Bacara:</span> 183<br /> E jejum não obrigatório: como jejuar às segundas e quintas-feiras de cada semana e jejuar três dias de cada mês, sendo os melhores os dias de al-Beed <span class="c2">(13, 14, 15)</span> de cada mês lunar. </p>',
            ],
            37 => [
                'question' => 'Q 38: Mencione a virtude de jejuar no mês do Ramadhan?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5270.mp3',
                'answer' => '<p> R: Pela autoridade de Abu Hurairah, que ALLAH esteja satisfeito com ele, que o Mensageiro de ALLAH, paz e bênçãos estejam sobre ele,<span class="c6"> disse:</span> Aquele que jejuar durante o mês de Ramadhan, com senso profundo de crença e auto-análise, terá perdoados os pecados passados. Bukhari e Musslim. </p>',
            ],
            38 => [
                'question' => 'P 39: Mencione a virtude do jejum voluntário em outro período que não o Ramadhan?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5300.mp3',
                'answer' => '<p> R: Pela autoridade de Abu Said Al-Khudri, que ALLAH esteja satisfeito com ele, que o Mensageiro de ALLAH, paz e bênçãos estejam sobre ele,<span class="c6"> disse:</span> "Quando a pessoa jejua por um dia, em prol de Allah, Ele transporta o Inferno para uma distância de setenta anos de viagem <span class="c2">(da pessoa)</span>." Bukhari e Musslim.<br /> - o significado de <span class="c1">“setenta outonos”</span>; Ou seja: setenta anos. </p>',
            ],
            39 => [
                'question' => 'Q40: Mencione alguns dos invalidadores do jejum?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5330.mp3',
                'answer' => '<p> C-1- Comer e beber intencionalmente.<br /> 2- Vómito intencional.<br /> 3- Apostasia do Isslam. </p>',
            ],
            40 => [
                'question' => 'Q 41: Quais são as Sunnahs do jejum?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5380.mp3',
                'answer' => '<p> C-1- Apressar o Iftar<br /> 2- Suhoor e seu atraso.<br /> 3- Um aumento nas ações de caridade e adoração<br /> 4- Quando um jejuador é insultado,<span class="c6"> dizer:</span> Estou jejuando.<br /> 5- Súplica na hora de quebrar o jejum.<br /> 6- Quebrar o jejum em tâmaras frescas ou tâmaras, se não for encontrado; Na água. </p>',
            ],
            41 => [
                'question' => 'Q 42: O que é Hajj?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5460.mp3',
                'answer' => '<p> C -<span class="c6"> Hajj:</span> É a adoração a ALLAH Todo-Poderoso, com a intenção de Sua Sagrada Casa para ações específicas em um momento específico.<span class="c6"><br /> O Altíssimo diz:</span> E por Allah impende aos homens a peregrinação à Casa, a quem até ela possa chegar. E quem renega, por certo Allah é bastante a Si mesmo, prescindindo dos homens. Surat Al-<span class="c6">Imran:</span> 97. </p>',
            ],
            42 => [
                'question' => 'Q 43: O número de pilares do Hajj?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5500.mp3',
                'answer' => '<p> C-1- Ihram.<br /> 2- Permanecer em Arafat.<br /> 3- Tawaf al-Ifadah.<br /> 4- Sa\'i entre Safa e Marwa. </p>',
            ],
            43 => [
                'question' => 'P 3: Qual é a virtude de Hajj?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5560.mp3',
                'answer' => '<p> R: Pela autoridade de Abu Hurairah, que ALLAH esteja satisfeito com ele, que o Mensageiro de ALLAH, paz e bênçãos estejam sobre ele,<span class="c6"> disse:</span> Aquele que realizar a peregrinação nesta Casa e abster-se da obscenidade e da depravação, voltará <span class="c2">(da peregrinação)</span> como o dia em que nasceu Narrado por Bukhari e outros.<span class="c6"><br /> Como o dia em que nasceu:</span> I.e. Sem pecado </p>',
            ],
            44 => [
                'question' => 'Q 45: Defina Umrah?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5600.mp3',
                'answer' => '<p> C -<span class="c6"> Umrah:</span> É a adoração a ALLAH Todo-Poderoso, com a intenção de Sua Sagrada Casa para ações específicas em um momento específico. </p>',
            ],
            45 => [
                'question' => 'Q 46: O número de pilares da Umrah?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5630.mp3',
                'answer' => '<p> C-1- Ihram.<br /> 2- Tawaf em torno da casa<br /> 3- Sa\'i entre Safa e Marwa. </p>',
            ],
            46 => [
                'question' => 'P47: O que é Jihad no caminho de ALLAH?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5690.mp3',
                'answer' => '<p> C - É exercer esforço na divulgação do Isslam e na defesa dele e de seu povo, ou combater um inimigo do Isslam e seu povo.<span class="c6"><br /> O Altíssimo diz:</span> Saí a campo armados, leve ou pesadamente, e lutai com vossas riquezas e vós mesmos, no caminho de Allah. Isso vos é melhor.<span class="c6"> Se soubésseis! Surat Taubah:</span>41 </p>',
            ],
        ],
        3 => [
            0 => [
                'question' => 'P1: Qual é a linhagem do nosso Profeta Muhammad?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5740.mp3',
                'answer' => '<p> C - Ele é Muhammad bin Abdullah bin Abdul Muttalib bin Hashem, Hashem é do Quraish, o Quraish é dos árabes, e os árabes são dos descendentes de Ismail e Ismail, filho de Ibrahim, sobre ele e sobre nosso Profeta, as melhores orações e que a paz esteja com ele. </p>',
            ],
            1 => [
                'question' => 'P 2: Qual é o nome da mãe do nosso Profeta, que a paz esteja com ele?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5770.mp3',
                'answer' => '<p> R: Ámina bint Wahb. </p>',
            ],
            2 => [
                'question' => 'P3: Quando seu pai morreu?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5800.mp3',
                'answer' => '<p> R: Seu pai morreu em Madinah enquanto ele estava no ventre da sua mãe e não tinha nascido. </p>',
            ],
            3 => [
                'question' => 'P4: Quando o Profeta ﷺ nasceu?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5830.mp3',
                'answer' => '<p> R: No Ano do Elefante, na segunda-feira do mês de Rabi’ al-Awwal. </p>',
            ],
            4 => [
                'question' => 'P5: Em que cidade ele nasceu?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5850.mp3',
                'answer' => '<p> R: Em Makkah </p>',
            ],
            5 => [
                'question' => 'P 6: Quem é sua lactante e ama além de sua mãe?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5880.mp3',
                'answer' => '<p> R: Escrava de seu pai, Umm Ayman.<br /> Escrava de seu tio Abu Lahab, Thuwaibah<br /> - Halimah al-Sa\'diyah. </p>',
            ],
            6 => [
                'question' => 'R7: Quando sua mãe morreu?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5930.mp3',
                'answer' => '<p> R: Sua mãe morreu quando ele tinha seis anos, e seu avô Abdul Muttalib cuidou dele. </p>',
            ],
            7 => [
                'question' => 'P8: Quem cuidou dele após a morte do seu avô Abdul Muttalib?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5960.mp3',
                'answer' => '<p> R: Seu avô Abd al-Muttalib morreu quando ele tinha oito anos, e seu tio Abu Talib o cuidou. </p>',
            ],
            8 => [
                'question' => 'P 9: Quando ele viajou com seu tio para a Síria?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5990.mp3',
                'answer' => '<p> R: Viajou com o tio para a Síria quando tinha doze anos. </p>',
            ],
            9 => [
                'question' => 'P10: Quando foi sua segunda viagem?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6020.mp3',
                'answer' => '<p> R: Sua segunda viagem foi no comércio com o dinheiro de Khadija, que ALLAH se agrade com ela, e quando ele voltou, casou-se com ela, que a paz esteja com ele, aos vinte e cinco anos. </p>',
            ],
            10 => [
                'question' => 'P 11: Quando os coraixitas reconstruíram a Kaaba?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6050.mp3',
                'answer' => '<p> R: Quraysh reconstruiu a Kaaba, e ele tem trinta e cinco anos.<br /> E eles o tomaram como juiz quando discordaram sobre quem deveria colocar a Pedra Negra, então ele a colocou em uma roupa, e ordenou que cada tribo pegasse uma ponta da roupa, e eram quatro tribos. </p>',
            ],
            11 => [
                'question' => 'Q12: Quantos anos ele tinha quando foi enviado? E para quem foi enviado?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6080.mp3',
                'answer' => '<p> R: Tinha quarenta anos e foi enviado a todos um arauto e admoestador. </p>',
            ],
            12 => [
                'question' => 'P 13: Qual foi a primeira coisa com que a revelação começou?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6110.mp3',
                'answer' => '<p> R: A visão verdadeira, então ele não viu um sonho que não veio como o amanhecer da manhã. </p>',
            ],
            13 => [
                'question' => 'Q 14: Como era sua condição antes da revelação? E quando a revelação lhe foi revelada pela primeira vez?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6140.mp3',
                'answer' => '<p> R: Ele adorava a ALLAH na caverna de Hira e se provia para isso.<br /> A revelação lhe foi dada, enquanto ele estava na caverna adorando. </p>',
            ],
            14 => [
                'question' => 'Q 15: Qual foi a primeira coisa que foi revelada a ele do Al Qur\'an?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6180.mp3',
                'answer' => '<p> E a evidência disso é o dito de Allah: Lê, em nome de teu Senhor, que criou, Que criou o ser humano de uma aderência. Lê, e teu Senhor é O mais Generoso Que ensinou a escrever com o cálamo, Ensinou ao ser humano o que ele não sabia. Surat Al-<span class="c6">Alaq:</span>5-1 </p>',
            ],
            15 => [
                'question' => 'Q 16: Quem foi o primeiro a acreditar em sua mensagem?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6200.mp3',
                'answer' => '<p> R -<span class="c6"> Entre os homens:</span> Abu Bakr Al-Siddiq,<span class="c6"> entre as mulheres:</span> Khadija bint Khuwaylid,<span class="c6"> entre os meninos:</span> Ali bin Abi Talib,<span class="c6"> e entre os legalistas:</span> Zaid bin Haritha,<span class="c6"> e entre os escravos:</span> Bilal Al-Habashi, que ALLAH estar satisfeito com eles, e outros. </p>',
            ],
            16 => [
                'question' => 'Q 17: Como foi o convite para o Isslam?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6230.mp3',
                'answer' => '<p> C - O convite ficou em segredo por cerca de três anos, então ele ordenou ao Profeta, que a paz e as bênçãos estejam com ele, para fazer o chamado em voz alta. </p>',
            ],
            17 => [
                'question' => 'Q 18: Qual era a condição do Profeta, que a paz e as bênçãos estejam sobre ele, e aqueles que acreditaram nele depois de falar o chamado?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6260.mp3',
                'answer' => '<p> C - Os politeístas exageraram em seus malefícios e malefícios aos muçulmanos, até que ele autorizou os crentes a imigrar para o Negus na Abissínia.<br /> Os politeístas concordaram unânimemente em prejudicar e matar o Profeta, que a paz e bênçãos de ALLAH estejam sobre ele, então ALLAH protegeu-o e o cercou com seu tio Abu Talib para protegê-lo deles. </p>',
            ],
            18 => [
                'question' => 'P 19: Quem morreu no décimo ano de sua missão, a paz esteja com ele?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6300.mp3',
                'answer' => '<p> C- Seu tio, Abu Talib, e sua esposa Khadija, que ALLAH esteja satisfeito com ela, faleceram. </p>',
            ],
            19 => [
                'question' => 'Q20: Quando foi a Viagem Noturna e Al-Miraj?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6330.mp3',
                'answer' => '<p> C - Ele tinha cinquenta anos, e as cinco orações diárias lhe foram impostas.<span class="c6"><br /> A Jornada Noturna:</span> Da Grande Mesquita à Mesquita de Al-Aqsa.<br /> Al-<span class="c6">Miraj:</span> Foi da Mesquita de Al-Aqsa ao céu para Sidrat Al-Muntaha. </p>',
            ],
            20 => [
                'question' => 'Q 21: Como o Profeta ﷺ chamou as pessoas fora de Makkah?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6380.mp3',
                'answer' => '<p> R - Ele costumava convidar o povo de Taif, e se apresentar nas estações e reuniões de pessoas, até que o povo de Madinah veio do Ansar, e eles acreditaram no Profeta, que a paz esteja com ele, e juraram fidelidade a ele por seu apoio. </p>',
            ],
            21 => [
                'question' => 'Q 22: Quanto tempo o Profeta, que a paz e as bênçãos estejam sobre ele, ficou em Makkah, convidando?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6410.mp3',
                'answer' => '<p> C- Ficou treze anos. </p>',
            ],
            22 => [
                'question' => 'Q 23: Para onde o Profeta, que a paz esteja com ele, migrou?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6440.mp3',
                'answer' => '<p> c) De Makkah a Madinah </p>',
            ],
            23 => [
                'question' => 'Q24: Quanto tempo ele ficou em Madinah?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6470.mp3',
                'answer' => '<p> R: Dez anos </p>',
            ],
            24 => [
                'question' => 'P 25: Quais são as leis do Isslam impostas a ele em Madinah?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6490.mp3',
                'answer' => '<p> C - Ele é obrigado a dar zakat, jejum, Hajj, jihad, o chamado à oração e outras leis do Isslam. </p>',
            ],
            25 => [
                'question' => 'Q 26: Qual foi a mais importante de suas guerras, a paz esteja com ele?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6520.mp3',
                'answer' => '<p> C- A Grande Batalha de Badr.<br /> Uhud<br /> Batalha de Ahzab<br /> Guerra da conquista de Makkah </p>',
            ],
            26 => [
                'question' => 'Q 15: Qual foi a última coisa que foi revelada a ele do Al Qur\'an?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6580.mp3',
                'answer' => '<p> E a evidência disso é o dito de Allah: E guardai-vos de um dia, em que sereis retornados a Allah. Em seguida, cada alma será compensada com o que logrou e eles não sofrerão injustiça. Surat Al-<span class="c6">Bacara:</span> 281 </p>',
            ],
            27 => [
                'question' => 'Q 28: Quando o Profeta ﷺ morreu? E quantos anos ele tinha?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6610.mp3',
                'answer' => '<p> C- Ele morreu no mês de Rabi\' al-Awwal, no décimo primeiro ano da Hégira, com a idade de sessenta e três anos. </p>',
            ],
            28 => [
                'question' => 'Q 29: Nomeie as esposas do Profeta ﷺ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6640.mp3',
                'answer' => '<p> C-1- Khadija bint Khuwaylid, que ALLAH esteja satisfeito com ela.<br /> 2- Sawdah bint Zam\'ah, que ALLAH esteja satisfeito com ela.<br /> 3- Aisha, filha de Abi Bakr Al-Siddiq, que ALLAH esteja satisfeito com ela.<br /> 4- Hafsah bint Umar, que ALLAH esteja satisfeito com ela.<br /> 5- Zainab bInt Khuzaimah, que ALLAH esteja satisfeito com ela.<br /> 6- Umm Salamah Hind, filha de Abi Umayyah, que ALLAH esteja satisfeito com ela.<br /> 7- Umm Habiba Ramla, filha de Abi Sufyan, que ALLAH esteja satisfeito com ela.<br /> 8- Juwayriyah bint Al-Harith, que ALLAH esteja satisfeito com ela<br /> 9- Maymoona bint Al-Harith, que ALLAH esteja satisfeito com ela.<br /> 10- Safiya bint Hayyi, que ALLAH esteja satisfeito com ela<br /> 11- Zainab bint Jahsh, que ALLAH esteja satisfeito com ela </p>',
            ],
            29 => [
                'question' => 'Q 30: Quem são seus filhos, a paz esteja com ele?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6760.mp3',
                'answer' => '<p> c-<span class="c6"> Dos rapazes:</span><br /> Al-Qasim, e com este foi apelidado.<br /> e Abdullah.<span class="c6"><br /> Ibrahim<br /> Das meninas:</span><br /> Fátimah<br /> Rukaia<br /> Ummu Kulsum<br /> Zainab<br /> Todos os seus filhos eram de Khadija, que ALLAH esteja satisfeito com ela, exceto Ibrahim, e todos morreram antes dele, exceto Fátima, seis meses depois dele. </p>',
            ],
            30 => [
                'question' => 'Q 31: Mencione algumas das características físicas do Profeta, a paz esteja com ele?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6880.mp3',
                'answer' => '<p> C - Ele era de uma classe média de homens, nem baixo nem alto, mas sim entre isso, e ele era branco com um tom avermelhado nele, que a paz e as bênçãos de ALLAH estejam com ele, e ele tinha uma barba espessa, olhos arregalados, boca grande, seu cabelo era muito preto, ombros grandes, cheiro bom e outros de sua bela criação, a paz esteja com ele. </p>',
            ],
            31 => [
                'question' => 'Q 31: Em que o Profeta, a paz esteja com ele, deixou sua nação?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6910.mp3',
                'answer' => '<p> c- Deixando sua nação, que a paz e as bênçãos estejam sobre ele, na peregrinação branca, sua noite é como seu dia, ninguém se desvia dela, exceto um perecível. </p>',
            ],
        ],
        4 => [
            0 => [
                'question' => 'P1: Recita Al-Fatihah e faça sua interpretação',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6960.mp3',
                'answer' => '<p> R: Capítulo Al-<span class="c6">Fatihah e sua interpretação:</span><br /> Em nome de ALLAH, o Clemente, o Misericordioso Louvor a Allah, O Senhor dos mundos. O Clemente, o Misericordioso O Soberano do Dia do Juízo . Só a Ti adoramos e só de Ti imploramos ajuda Guia-nos à senda reta À senda dos que agraciaste; não à dos incursos em Tua ira nem à dos descaminhados [Al-<span class="c6">Fátihah:</span>1-7<br /> Tafssir<br /> Chama-se Surat Al-Fatihah; Por ALLAH ter iniciado seu livro com o mesmo<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001001.mp3"></audio> 1 - Em nome de ALLAH, o Compassivo, o Misericordioso 1 Em nome de ALLAH, começo a recitar o Al Qur\'an, buscando a ajuda de ALLAH Todo-Poderoso, que é abençoado por mencionar seu nome.<br /> ALLAH,<span class="c6"> significando:</span> aquele que é verdadeiramente adorado, e ninguém menos que Ele, Glória a Ele, é chamado por Ele.<br /> Al-Rahman <span class="c2">(o Mais Gracioso)</span> significa: o possuidor de vasta misericórdia, cuja misericórdia abrange todas as coisas.<br /> Al-Rahim, ou seja, Aquele que tem misericórdia dos crentes.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001002.mp3"></audio> 2- <span class="c1">“Louvado seja ALLAH, Senhor dos mundos 2”</span> significando: todos os tipos de louvor e perfeição são somente para ALLAH.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001003.mp3"></audio> 3- <span class="c1">“O Compassivo, o Misericordioso.”</span> ou seja, o possuidor de vasta misericórdia que abrange todas as coisas, e o possuidor de misericórdia que se estende aos crentes.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001004.mp3"></audio> 4- <span class="c1">“Malik do Dia do Juízo 4”</span>: É o Dia da Ressurreição.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001005.mp3"></audio> 5- <span class="c1">“É a Ti que adoramos e a Ti buscamos ajuda 5”</span> Ou seja, adoramos a Ti somente e buscamos ajuda somente de Ti.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001006.mp3"></audio> 6- <span class="c1">“Guia-nos para o caminho reto 6”</span>: É a orientação para o Isslam e a Sunnah.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001007.mp3"></audio> 7- <span class="c1">“O caminho daqueles a quem você concedeu graça, não daqueles com ira, nem daqueles que se desviam. 7”</span> ou seja, o caminho dos justos servos de ALLAH desde os profetas e aqueles que os seguiram, exceto os caminho de cristãos e judeus.<br /> É Sunnah dizer depois de lê-<span class="c6">lo:</span> “Ameen” significando: Atenda-nos </p>',
            ],
            1 => [
                'question' => 'Q 2: Leia Surat Al-Zalzalah e explique?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7130.mp3',
                'answer' => '<p> C- Sura Al-<span class="c6">Zalzalah e sua interpretação:</span><br /> Em nome de Allah, O Misericordioso, O Misericordiador<br /> Surat Az Zalzalah. Quando a terra for tremida por seu tremor, E a terra fizer sair seus pesos, E o ser humano dirá o que se passa com ela Nesse dia, ela contará suas notícias, Conforme seu Senhor lho inspirou. Nesse dia os humanos camparecerão, separadamente, para os fazerem ver suas obras. Então, quem houver feito um peso de um átomo de bem o verá. E quem houver feito um peso de átomo de mal o verá.<span class="c6"> Zalzalah:</span>1-8<br /> Tafssir<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099001.mp3"></audio> 1 - <span class="c1">“Quando a terra for tremida por seu temor 1”</span>: Quando a terra se comove pelo intenso movimento que lhe acontecerá no Dia da Ressurreição.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099002.mp3"></audio> 2- <span class="c1">“E a terra fizer sair seus pesos 2”</span>: E a terra remover o que estava em seu ventre dos mortos e outros.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099003.mp3"></audio> 3-<span class="c6"> (E o homem dirá:</span>: <span class="c1">“Qual é o problema com ela?”</span> O homem dirá,<span class="c6"> perplexo:</span> Qual é o problema com a terra se movendo e turbulenta?!<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099004.mp3"></audio> 4- <span class="c2">(Naquele dia serão reveladas suas notícias 4)</span>: Nesse grande dia a terra informará sobre o bem e o mal que fez nela.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099005.mp3"></audio> 5- <span class="c1">“que o teu Senhor lhe revelou 5”</span>: porque ALLAH a conhecia e assim lhe ordenou.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099006.mp3"></audio> 6- <span class="c2">( Nesse dia os humanos camparecerão, separadamente, para os fazerem ver suas obras.6)</span>: Naquele grande dia, quando a terra tremer, as pessoas sairão da situação de acerto de contas com diferença; Para ver o que eles fizeram neste mundo.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099007.mp3"></audio> 7- <span class="c1">“Assim, quem fizer o bem do peso de um átomo o verá.”</span> 7 vê-lo na frente dele.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099008.mp3"></audio> 8- <span class="c1">“E quem fizer o peso de um átomo de mal o verá.”</span> 8: E quem fizer o peso de maldades de um átomo; vê-lo na frente dele. </p>',
            ],
            2 => [
                'question' => 'Q 2: Leia Surat Al-Adiyát e explique?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7270.mp3',
                'answer' => '<p> R: Capítulo Al-<span class="c6">Adiyat e sua interpretação:</span><br /> Em nome de Allah, O Misericordioso, O Misericordiador<br /> Pelos corcéis resfolegantes <span class="c2">(1)</span> Que lanças chispas de fogo Que atacam ao amanhecer E que levantam, com isso, nuvens de poeira E permeiam, com isso, uma inimiga multidão. Por certo, o ser humano é ingrato a seu Senhor; E, por certo, ele é testemunha disso; E, por certo, ele é veemente no amor à riqueza. Então, não sabe ele que será recompensado, quando for revolvido o que há nos sepulcros, E for recolhido o que há nos peitos? Por certo, nesse dia, o seu Senhor deles será Conhecedor. Al-Ádiyat<br /> Tafssir<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100001.mp3"></audio> 1 - <span class="c1">“Pelos corcéis resfolegantes <span class="c2">(1)</span>”</span>: ALLAH jurou pelos cavalos que correm até se ouvirem da intensidade da corrida.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100002.mp3"></audio> 2- <span class="c1">“Que lanças chispas de fogo 2”</span>: Ele jura pelos cavalos que incendiarão seus cascos se tocarem nas rochas por causa da gravidade do impacto sobre eles.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100003.mp3"></audio> 3- <span class="c1">“Que atacam ao amanhecer 3”</span>: Ele jura pelos cavalos que atacam os inimigos pela manhã.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100004.mp3"></audio> 4- <span class="c1">“E que levantam, com isso, nuvens de poeira. 4”</span>: Então eles agitaram poeira por suas corridas.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100005.mp3"></audio> 5- <span class="c1">“E permeiam, com isso, uma inimiga multidão 5”</span>: Assim eles intercedem junto aos seus cavaleiros, uma multidão de inimigos.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100006.mp3"></audio> 6- <span class="c1">“Por certo, o ser humano é ingrato a seu Senhor; 6”</span>: A pessoa é variada para o bem que seu Senhor quer dela.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100007.mp3"></audio> 7- <span class="c2">(e ele é testemunha disso 7)</span> e ele é testemunha de sua prevenção do bem, e ele não pode negar isso por causa de sua clareza.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100008.mp3"></audio> 8- <span class="c2">(E, de fato, ele ama muito o bem. 8)</span> É por causa de seu amor excessivo ao dinheiro que ele é mesquinho com ele.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100009.mp3"></audio> 9- Então, não sabe ele que será recompensado, quando for revolvido o que há nos sepulcros,<span class="c6">?” 9:</span> Essa pessoa que é enganada pela vida deste mundo não sabe, se Deus ressuscita os mortos nas sepulturas e os tira da terra pela conta e pela recompensa que o assunto não foi como ele havia imaginado?!<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100010.mp3"></audio> 10 -<span class="c6"> E for recolhido o que há nos peitos? 10”:</span> Ele deixou claro e esclareceu o que está no coração de intenções, crenças e outros.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100011.mp3"></audio> 11 - <span class="c1">“De fato, seu Senhor é perito sobre eles naquele dia 11”</span>: Seu Senhor é perito sobre eles naquele dia, e nada lhe é oculto sobre os assuntos de seus servos, e ele os recompensará por isso. </p>',
            ],
            3 => [
                'question' => 'Q 2: Leia Surat Al-Qáriah e explique?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7450.mp3',
                'answer' => '<p> R: Capítulo Al-<span class="c6">Qáriah e sua interpretação:</span><br /> Em nome de Allah, O Misericordioso, O Misericordiador<br /> A Calamidade O que te fará entender o que é a calamidade? E o que te faz inteirar-te do que é o estrondo? Ocorrerá, um dia, quando os humanos forem como as borboletas espalhadas, E as montanhas, como a lã corada, cardada. Então, quanto àquele, cujos pesos em boas ações forem pesados,<span class="c6"> Estará em vida agradável:</span> E quanto áquele, cujos pesos em boas ações forem leves, Terá como lar um <span class="c2">(profundo)</span> precipício. E o que te faz inteirar-te do que é este Abismo? E o fogo ardente Al-Qáriah<br /> Tafssir<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101001.mp3"></audio> 1 - Al-<span class="c6">Qari\'ah 1:</span> A hora que sacode o coração das pessoas pela grandeza de seu horror.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101002.mp3"></audio> 2- <span class="c1">“O que te fará entender o que é a calamidade? 2”</span>: Que hora é essa que atinge o coração das pessoas pela grandeza de seu horror?!<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101003.mp3"></audio> 3- E o que te faz inteirar-<span class="c6">te do que é o estrondo?? 3”:</span> E o que te ensinei - Ó Mensageiro - que hora é esta que bate no coração das pessoas pela grandeza do seu horror?! É dia do Juízo Final.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101004.mp3"></audio> 4- <span class="c1">“Ocorrerá, um dia, quando os humanos forem como as borboletas espalhadas,”</span> 4: No dia em que o coração das pessoas estiver batendo, elas serão como borboletas espalhadas aqui e ali.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101005.mp3"></audio> 5- <span class="c1">“E as montanhas, como a lã corada, cardada. 5”</span>: Os montes serão como lã enrolada em sua leveza e movimento.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101006.mp3"></audio> 6- <span class="c1">“Quanto àquele cuja balança está pesada, 6”</span>: Quanto àquele cujas boas ações superam suas más ações.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101007.mp3"></audio> 7- <span class="c1">“ Estará em vida agradável:7”</span>: Ele está em uma vida satisfatória que obterá no Paraíso.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101008.mp3"></audio> 8- E quanto áquele, cujos pesos em boas ações forem leves,<span class="c2">( 8)</span>: E quanto àquele cujas más ações superam suas boas ações.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101009.mp3"></audio> 9- <span class="c2">(Terá como lar um (profundo)</span> precopício.<span class="c6"> 9):</span> Sua morada e seu local de residência no Dia da Ressurreição serão o Inferno.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101010.mp3"></audio> 10 - <span class="c1">“E o que te fez saber o que é?”</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101011.mp3"></audio> 11- <span class="c2">(um fogo ardente 11)</span>: É um fogo muito quente. </p>',
            ],
            4 => [
                'question' => 'Q 2: Leia Surat Takátuhur e explique?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7610.mp3',
                'answer' => '<p> R: Capítulo Takathur e sua interpretação:<br /> Em nome de Allah, O Misericordioso, O Misericordiador<br /> A Cobiça vos entreterá Até visitardes os sepulcros. Em absoluto, não vos ostenteis! Vós logo sabereis! Mais uma vez, em absoluto, não vos ostenteis! Vós logo sabereis! Ora, se soubésseis a ciência da Certeza, renunciaríeis a ostentação. Verdadeiramente então, havieis de ver a fogueira do Inferno. Em seguida, certamente, vê-lo-eis, com os olhos da certeza. Depois, sereis, em verdade, nesse dia, interrogados das delícias da vida. Takathur<br /> Tafssir<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102001.mp3"></audio> 1- <span class="c1">“A Cobiça vos entreterá1”</span>: Sua preocupação - ó povo - é se orgulhar do dinheiro e dos filhos ao invés de obedecer a ALLAH.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102002.mp3"></audio> 2-<span class="c6"> :</span> Até visitardes os sepulcros. Até que você morreu e entrou em seus túmulos.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102003.mp3"></audio> 3-Em absoluto, não vos ostenteis! Vós logo sabereis! .<span class="c6">” 3:</span> Se gabar-se disso não deve distraí-lo de obedecer a ALLAH, você conhecerá as consequências dessa preocupação.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102004.mp3"></audio> 4- <span class="c1">“Mais uma vez, em absoluto, não vos ostenteis! Vós logo sabereis!”</span>: Então você saberá sua consequência.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102005.mp3"></audio> 5- <span class="c1">“ Ora, se soubésseis a ciência da Certeza, renunciaríeis a ostentação.5”</span>: De fato, se você soubesse com certeza que você é enviado a ALLAH, e que Ele o recompensará por seus atos, você não estaria ocupado se gabando de dinheiro e filhos.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102006.mp3"></audio> 6- <span class="c1">“Verdadeiramente então, havieis de ver a fogueira do Inferno.”</span>: Por ALLAH, você verá o Inferno no Dia da Ressurreição.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102007.mp3"></audio> 7- <span class="c1">“Em seguida, certamente, vê-lo-eis, com os olhos da certeza.”</span>: Então você vai ver com certeza sem dúvida.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102008.mp3"></audio> 8- <span class="c1">“Depois, sereis, em verdade, nesse dia, interrogados das delícias da vida.”</span>: Então ALLAH lhe perguntará naquele dia o que Ele te concedeu de saúde, riqueza e outras coisas. </p>',
            ],
            5 => [
                'question' => 'Q 2: Leia Surat Al-Assr e explique?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7750.mp3',
                'answer' => '<p> R: Capítulo Al-<span class="c6">Assr e sua interpretação:</span><br /> Em nome de Allah, O Misericordioso, O Misericordiador<br /> Pelo tempo <span class="c2">(1)</span> Por certo, o ser humano está em perdição, Exceto aos que crêem e fazem as boas obras e se recomendam mutuamente a verdade, e se recomendam mutuamente a paciência. Assr<br /> Tafssir<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/103001.mp3"></audio> 1 - <span class="c1">“Pelo Tempo1”</span>: ALLAH, juro pelo tempo.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/103002.mp3"></audio> 2- Por certo, o ser humano está em perdição,<span class="c6">“”:</span> ou seja: todos os seres humanos estão em perda e destruição.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/103003.mp3"></audio> 3- “Exceto aos que crêem e fazem as boas obras e se recomendam mutuamente a verdade, e se recomendam mutuamente a paciência. <span class="c2">(3)</span>: Exceto aqueles que acreditam e praticam ações justas, eles invocam aqueles que sofrem perdas e são pacientes com isso. </p>',
            ],
            6 => [
                'question' => 'Q 2: Leia Surat Al-Humazah e explique?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7830.mp3',
                'answer' => '<p> C- Sura Al-<span class="c6">Humazah e sua interpretação:</span><br /> Em nome de Allah, O Misericordioso, O Misericordiador<br /> Ai de todo difamador, caluniador. Que junta riquezas e, com deleite, as conta, Supõe que suas riquezas o tornarão eterno. Em absoluto, não o tornarão! Em verdade, ele será deitado fora, em al-Hutama. - E o que te faz inteirar-te do que é al-Hutamah? É o fogo aceso, de Allah, O qual sobe até os corações. Por certo, será cerrado sobre eles, Em colunas extensas. Al-Humazah<br /> Tafssir<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104001.mp3"></audio> 1 - <span class="c1">“Ai de todo difamador, caluniador.”</span>: Prejuízo e a severidade do tormento para as muitas pessoas caluniadoras e difamadoras.,<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104002.mp3"></audio> 2- <span class="c1">“Que junta riquezas e, com deleite, as conta,”</span>: Aquele que se preocupa em arrecadar dinheiro e contá-lo, não tem outra preocupação com ele.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104003.mp3"></audio> 3- <span class="c1">“Supõe que suas riquezas o tornarão eterno\'\': Ele pensa que o dinheiro que ele coletou o salvará da morte, então ele permanecerá imortal na vida deste mundo.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104004.mp3"></audio> 4- “Em absoluto, não o tornarão! Em verdade, ele será deitado fora, em al-<span class="c6">Hutama\'\':</span> A questão não é como este ignorante imaginou, pois serão lançados no fogo do Inferno que bate e quebra tudo o que nele foi lançado por causa de sua severidade.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104005.mp3"></audio> 5- “E o que te faz inteirar-te do que é al-Hutamah?5”</span>: E o que te ensinei - Ó Mensageiro - que fogo é esse que destrói tudo o que nele se atira?!<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104006.mp3"></audio> 6- É o fogo aceso, de Allah,: É o fogo furioso de ALLAH.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104007.mp3"></audio> 7- O qual sobe até os corações.: que penetra no corpo das pessoas até o coração.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104008.mp3"></audio> 8- <span class="c1">“Por certo, será cerrado sobre eles,”</span>: É fechado para aqueles que nele são atormentados.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104009.mp3"></audio> 9- <span class="c2">(Em pilares estendidos 9)</span>: com pilares longos para que não saiam deles. </p>',
            ],
            7 => [
                'question' => 'Q 2: Leia Surat Al-Fíl e explique?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7970.mp3',
                'answer' => '<p> R: Capítulo Al-<span class="c6">fiil e sua interpretação:</span><br /> Em nome de Allah, O Misericordioso, O Misericordiador<br /> Não viste como teu Senhor agiu com os donos do elefante? Não fez Ele sua insídia ficar em descaminho? E contra eles enviou pássaros, em bandos, Que lhes atiravam pedras de sijjil? Então, tornou-os como folhas devoradas. Al-Fiil<br /> Tafssir<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105001.mp3"></audio> 1 - <span class="c1">“Não viste como teu Senhor agiu com os donos do elefante?”</span>: Não sabias - ó Mensageiro - como teu Senhor tratou com Abraha e seus companheiros, os donos dos elefantes, quando quiseram destruir o Caaba?!<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105002.mp3"></audio> 2- <span class="c1">“Não fez Ele sua insídia ficar em descaminho?”</span>: ALLAH fez seu plano ruim de demolir as terras, então eles não conseguiram o que desejavam afastando as pessoas da Caaba, e eles não ganharam nada com isso.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105003.mp3"></audio> 3- E contra eles enviou pássaros, em bandos,: E Ele lhes enviou pássaros, e eles vieram a eles em grupos.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105004.mp3"></audio> 4- <span class="c1">“Que lhes atiravam pedras de sijjil?”</span>: Você joga pedras neles do barro petrificado.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105005.mp3"></audio> 5- “Então, tornou-<span class="c6">os como folhas devoradas:</span> Então ALLAH os fez como folhas de plantação que foram comidas pelos animais e pisadas nelas. </p>',
            ],
            8 => [
                'question' => 'Q 2: Leia Surat Quraish e explique?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8070.mp3',
                'answer' => '<p> R: Surah Quraish e sua interpretação<br /> Em nome de Allah, O Misericordioso, O Misericordiador<br /> Pelo convénio do Quraish De seu pacto da viagem de inverno e de verão. Que eles adorem, então, o Senhor desta Casa, Que os alimentou contra a fome e os pôs em segurança contra o medo! Quraish<br /> Tafssir<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106001.mp3"></audio> 1 - <span class="c1">“Pelo convenio do Quraish”</span>: O que se quer dizer com isso é o que eles estavam familiarizados durante a viagem no inverno e no verão.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106002.mp3"></audio> 2- <span class="c1">“De seu pacto da viagem de inverno e de verão.”</span>: a jornada de inverno para o Iêmen e a jornada de verão para o Levante em segurança.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106003.mp3"></audio> 3- <span class="c1">“Que eles adorem, então, o Senhor desta Casa,”</span>: Portanto, adorem somente a ALLAH, o Senhor desta Casa Sagrada, que lhes facilitou esta jornada, e não associem ninguém a Ele.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106004.mp3"></audio> 4- <span class="c1">“Que os alimentou contra a fome e os pôs em segurança contra o medo!”</span>: Quem os alimentou da fome e os salvou do medo, pelo que colocou nos corações dos árabes de venerar o Haram e venerar seus habitantes. </p>',
            ],
            9 => [
                'question' => 'Q 2: Leia Surat Al-Máún e explique?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8160.mp3',
                'answer' => '<p> R: Capítulo Al-<span class="c6">Máún e sua interpretação:</span><br /> Em nome de Allah, O Misericordioso, O Misericordiador<br /> Viste quem desmente o Dia do Juízo? Esse é o que repele o órfão, E não incitava ninguém a alimentar o necessitado." Ai dos oradores <span class="c2">(4)</span> Que são distraídos de suas orações, Que, por ostentação, só querem ser vistos orando, Negando-se, contudo, a prestar obséquios! Al-Máún<br /> Tafssir<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107001.mp3"></audio> 1 - <span class="c1">“Viste quem desmente o Dia do Juízo?”</span>: Você conhece aquele que nega a recompensa no Dia da Ressurreição?!<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107002.mp3"></audio> 2- <span class="c1">“Esse é o que repele o órfão,”</span>: É ele que empurra o órfão para fora de sua ira.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107003.mp3"></audio> 3- E não incitava ninguém a alimentar o necessitado." Ele não exorta a si mesmo, nem exorta os outros a alimentar os pobres.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107004.mp3"></audio> 4-<span class="c6"> Ai dos oradores:</span> destruição e tormento para os adoradores.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107005.mp3"></audio> 5- <span class="c4">{Aqueles que são descuidados com suas orações 5}</span>: Aqueles que são descuidados com suas orações, não se importam com eles até que seu tempo termine.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107006.mp3"></audio> 6- Que, por ostentação,<span class="c6"> só querem ser vistos orando:</span> não dedicam suas ações a Deus.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107007.mp3"></audio> 7- <span class="c1">“Negando-se, contudo, a prestar obséquios!”</span>: Impedem que outros ajudem os outros de uma forma que não prejudique em ajudá-los. </p>',
            ],
            10 => [
                'question' => 'Q 2: Leia Surat Al-Kawthr e explique?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8280.mp3',
                'answer' => '<p> R: Capítulo Al-<span class="c6">Kawthar e sua interpretação:</span><br /> Em nome de Allah, O Misericordioso, O Misericordiador<br /> Por certo, Nós te demos Al-Kawthar. Então, ora a teu Senhor e imola as oferendas. Por certo, quem te odeia será ele o sem posteridade. Kawthar<br /> Tafssir<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/108001.mp3"></audio> 1- <span class="c1">“Por certo, Nós te demos Al-Kawthar.”</span>: Nós te demos – ó Mensageiro – muito bem, e dele é o Rio Al-Kawthar no Paraíso.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/108002.mp3"></audio> 2- <span class="c1">“Ore ao seu Senhor e sacrifique 2”</span>: Agradeça a ALLAH por esta bênção, orar somente por Ele e sacrificar, ao contrário do que os politeístas fazem de se aproximar de seus ídolos com o sacrifício.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/108003.mp3"></audio> 3- Por certo,<span class="c6"> quem te odeia será ele o sem posteridade:</span> Aquele que te odeia é que fará parte dos esquecidos, que, se for mencionado, é lembrado com maldade. </p>',
            ],
            11 => [
                'question' => 'Q 2: Leia o Surat Al-Káfirún e explique?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8360.mp3',
                'answer' => '<p> R: Capítulo Al-<span class="c6">Káfirun e sua interpretação:</span><br /> Em nome de Allah, O Misericordioso,<span class="c6"> O Misericordiador<br /> Dize:</span> "Ó renegadores da Fé!" "Não adoro o que adorais." "Nem adorareis o que adoro." "Nem adorarei o que adorastes." "Nem adorareis o que adoro." "A vós vossa religião e, a mim, minha religião." Al-Káfirun<br /> Tafssir<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109001.mp3"></audio> 1 - <span class="c1">“Dize: Ó incrédulos 1”</span>: Diga - Ó Mensageiro -: Ó vós que descredes em Deus.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109002.mp3"></audio> 2 - <span class="c1">“Não adoro o que vocês adoram”</span>: Não adoro no presente nem no futuro o que vocês adoram de ídolos.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109003.mp3"></audio> 3- <span class="c2">(Nem vocês adoram o que eu adoro. 3)</span>: Nem você adoram o que eu adoro, e Ele é somente Deus.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109004.mp3"></audio> 4- <span class="c1">“Nem eu sou adorador do que vocês adoram 4”</span>: Nem sou adorador dos ídolos que vocês adoram.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109005.mp3"></audio> 5- <span class="c2">(Nem vocês adoram o que eu adoro. 3)</span>: Nem você adora o que eu adoro, e Ele é somente Deus.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109006.mp3"></audio> 6- <span class="c1">“Para você é a sua religião, e para mim é a minha.”</span> 6: Para você é a sua religião, que você criou para si mesmo, e para mim é a minha religião, que Deus me revelou. </p>',
            ],
            12 => [
                'question' => 'Q 2: Leia Surat Al-Nassr e explique?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8470.mp3',
                'answer' => '<p> R: Capítulo Al-<span class="c6">Nassr e sua interpretação:</span><br /> Em nome de Allah, O Misericordioso, O Misericordiador<br /> Quando chegar o socorro de Allah e também a vitória, E vires os homens entrar na religião de Allah, em turbas, Então glorifica, com louvor, a teu Senhor e implora-Lhe perdão. Por certo, Ele é O Remissório. Nassr<br /> Tafssir<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/110001.mp3"></audio> 1- <span class="c1">“Quando chegar o socorro de Allah e também a vitória,”</span>: Se a vitória de Deus vier para a sua religião – ó Mensageiro – e a Sua Glória vier para ele, e a conquista de Makkah acontece.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/110002.mp3"></audio> 2- <span class="c1">“ E vires os homens entrar na religião de Allah, em turbas,2”</span>: E você viu as pessoas entrando no Isslam, grupo após grupo.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/110003.mp3"></audio> 3- <span class="c1">“Então glorifica, com louvor, a teu Senhor e implora-Lhe perdão. Por certo, Ele é O Remissório.”</span> 3 Então saiba que isso é um sinal de que a missão na qual você foi enviado está próxima do fim, então glorifique com o louvor do seu Senhor , agradecimentos e ações de graças Dele e Seu perdão, e Ele aceita Seu perdão, pois Ele é uma bênção para eles. </p>',
            ],
            13 => [
                'question' => 'Q 2: Leia Surat Al-Massad e explique?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8550.mp3',
                'answer' => '<p> R: Capítulo Al-<span class="c6">Massad e sua interpretação:</span><br /> Em nome de Allah, O Misericordioso, O Misericordiador<br /> Que pereçam ambas as mãos de Abu Lahab, e que ele mesmo pereça. De nada lhe valerá sua riqueza e o que ele logrou. Queimar-se-á em Fogo de labaredas, E, também, sua mulher, a carregadora de lenha, Em seu pescoço, haverá uma corda de massad. Massad<br /> Tafssir<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111001.mp3"></audio> 1- <span class="c1">“Que pereçam ambas as mãos de Abu Lahab, e que ele mesmo pereça.”</span>: Perdi a mão do tio do Profeta, Abu Lahab bin Abdul Muttalib, ao perder o emprego, pois ele estava prejudicando o Profeta, que a paz esteja com ele, e sua busca foi decepcionada.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111002.mp3"></audio> 2- <span class="c1">“De nada lhe valerá sua riqueza e o ele logrou.”</span> 2: Qual é a riqueza de seu dinheiro e de seus filhos? Não lhe pagaram tormento, nem lhe trouxeram misericórdia.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111003.mp3"></audio> 3-Queimar-se-á em Fogo de labaredas,<span class="c6"> :</span> Ele entrará no Dia da Ressurreição em um fogo com chama, cujo calor sofrerá.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111004.mp3"></audio> 4- <span class="c1">“E, também, sua mulher, a carregadora de lenha,”</span>: Sua esposa, Umm Jamil, que estava prejudicando o Profeta, que a paz esteja com ele, entrará nele jogando espinhos em seu caminho.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111005.mp3"></audio> 5- <span class="c1">“Em seu pescoço, haverá uma corda de massad.”</span>: Em seu pescoço há uma corda bem giratória com a qual ela será conduzida ao Fogo. </p>',
            ],
            14 => [
                'question' => 'Q 2: Leia Surat Al-Ikhlass e explique?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8650.mp3',
                'answer' => '<p> R: Capítulo Al-<span class="c6">Ikhlass e sua interpretação:</span><br /> Em nome de Allah, O Misericordioso,<span class="c6"> O Misericordiador<br /> {Dize:</span> "Ele é Allah, Único.<span class="c2">(1)</span> Allah, o Absoluto, <span class="c2">(2)</span> "Não gerou e não foi gerado, <span class="c2">(3)</span> "E não há ninguém igual a Ele.} <span class="c2">(4)</span> Al-Ikhláss<br /> Tafssir<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112001.mp3"></audio> 1- <span class="c1">“Dize: Ele é Deus, o Único.”</span> Diga -<span class="c6"> Ó Mensageiro:</span> Ele é Deus, não há deus senão Ele.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112002.mp3"></audio> 2- <span class="c1">“Allah, o Independente2”</span> significa: as necessidades da criação são levantadas a Ele.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112003.mp3"></audio> 3-<span class="c6"> Ele não gerou e não foi gerado 3:</span> Ele não tem filho nem pai, Glória a Ele.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112004.mp3"></audio> 4- <span class="c1">“E não havia ninguém igual a Ele.”</span> 4: Ele não foi semelhante a Ele em Sua criação. </p>',
            ],
            15 => [
                'question' => 'Q 2: Leia Surat Al-Falaq e explique?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8750.mp3',
                'answer' => '<p> R: Capítulo Al-<span class="c6">Falaq e sua interpretação:</span><br /> Em nome de Allah, O Misericordioso, O Misericordiador<br /> Surat Al Falaq.<span class="c6"> Dize:</span> "Refugio-me nO Senhor dos homens," "Contra o mal daquilo que Ele criou," "E contra o mal da noite<span class="c2">(1)</span>quando entenebrece," "E contra o mal das sopradoras<span class="c2">(1)</span> dos nós." "E contra o mal do invejoso, quando inveja."<span class="c2">(1)</span> Surat Al-<span class="c6">Alaq:</span>5-1<br /> Tafssir<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113001.mp3"></audio> 1- <span class="c1">“Dize: Busco refúgio no Senhor da aurora 1”</span>: Diga - Ó Mensageiro -: Busco refúgio no Senhor da manhã e busco Sua proteção.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113002.mp3"></audio> 2- <span class="c1">“Do mal do que Ele criou”</span>: Do mal do que prejudica as criaturas.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113003.mp3"></audio> 3 -"E contra o mal da noite<span class="c2">(1)</span>quando entenebrece,<span class="c6">":</span> Busco refúgio em Deus dos males que aparecem à noite, como bestas e ladrões.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113004.mp3"></audio> 4- <span class="c1">“E da maldade dos sopradores nos nós 4”</span>: nele busco refúgio da maldade dos feiticeiros que fazem os nós.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113005.mp3"></audio> 5- <span class="c1">“E da maldade do invejoso quando inveja 5”</span>: E da maldade do invejoso que odeia as pessoas quando as inveja pelas bênçãos que Deus lhes deu, querendo que sejam afastadas delas, e infligindo prejudicá-los. </p>',
            ],
            16 => [
                'question' => 'Q 17: Leia Surat An-Nas e explique?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8870.mp3',
                'answer' => '<p> R: Capítulo An-<span class="c6">Nass e sua interpretação:</span><br /> Em nome de Allah, O Misericordioso,<span class="c6"> O Misericordiador<br /> Diz:</span> "Refugio-me no Senhor dos homens," O Rei dos homens Deus dos homens "Contra o mal do sussurrador<span class="c2">(1)</span>, o absconso" "Que sussurra perfídias nos peitos dos homens," "Seja ele dos jinns, seja ele dos homens.<span class="c6">" Annáss:</span> 1-6<br /> Tafssir<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114001.mp3"></audio> 1 - <span class="c1">“Dize: Eu busco refúgio no Senhor dos homens1”</span>: Diga,<span class="c6"> ó Mensageiro:</span> Eu busco refúgio no Senhor dos povos, e busco Sua proteção.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114002.mp3"></audio> 2- <span class="c1">“O Rei dos homens 2”</span>: Ele os dispõe como quer, e eles não têm dono senão ele.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114003.mp3"></audio> 3- <span class="c1">“O Deus dos homens 3”</span>: São cultuados por direito, não são cultuados por nenhum outro direito.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114004.mp3"></audio> 4- <span class="c1">“Do mal do murmurador assediado 4”</span>: Do mal de Satanás, que lança seus sussurros às pessoas.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114005.mp3"></audio> 5- <span class="c2">(Aquele que sussurra no coração das pessoas 5)</span>: Ele lança seus sussurros no coração das pessoas.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114006.mp3"></audio> 6- <span class="c1">“Dos Jinn e das pessoas 6”</span> ou seja, a pessoa obsessiva é da humanidade e dos génios. </p>',
            ],
        ],
        5 => [
            0 => [
                'question' => 'Q1: Complete o Hadith: “As ações são por intenções...” e mencione alguns de seus benefícios?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9030.mp3',
                'answer' => '<p> C - Sob a autoridade do Comandante dos Fiéis, Abu Hafs Umar Ibn Al-Khattab, que ALLAH esteja satisfeito com ele,<span class="c6"> que disse:</span> Eu ouvi o Mensageiro de ALLAH, que a paz e bênçãos de ALLAH estejam com ele,<span class="c6"> a dizer:</span> As obras são avaliadas pelas intenções. Assim, cada pessoa alcançará o que busca, de acordo com suas intenções. Desse modo, aquele cuja emigração acontecer pela causa de Allah e do Seu Mensageiro, essa emigração será considerada como sendo pela causa de Allah e do Seu Mensageiro. Porém, aquele<br /> que emigrar em busca de algum benefício material, ou para desposar uma mulher, sem dúvida a sua emigração será para aquilo para o que emigrou. Narrado por Bukhari e Musslim.<br /> Notas do Hadith<br /> 1- Toda ação deve ter uma intenção, como Oração, Jejum, Hajj e outras ações.<br /> 2- É necessário ter sinceridade na intenção a ALLAH Todo-Poderoso.<br /> Segundo Hadith </p>',
            ],
            1 => [
                'question' => 'Q 2: Complete o Hadith “Quem introduzir em este nosso assunto...” e mencione alguns de seus benefícios?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9090.mp3',
                'answer' => '<p> C- Sob a autoridade da Mãe dos Crentes, Umm Abdullah Aisha, que ALLAH esteja satisfeito com ela,<span class="c6"> disse:</span> O Mensageiro de ALLAH, que a paz e as bênçãos de ALLAH estejam com ele,<span class="c6"> disse:</span> <span class="c1">“Aquele que introduzir algo que não está em conformidade com a nossa religião, será rechaçado.”</span> Narrado por Bukhari e Musslim.<br /> Notas do Hadith<br /> 1- Proibição de inovação na religião.<br /> 2- As práticas inovadoras não são aceitos.<br /> Terceiro Hadith </p>',
            ],
            2 => [
                'question' => 'Q 3: Complete o Hadith (enquanto estavamos sentados com o Mensageiro de ALLAH, que a paz esteja com ele...), e mencione alguns de seus benefícios?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9160.mp3',
                'answer' => '<p> R: Umar Ibn Al-Khattab -<span class="c6"> que ALLAH esteja satisfeito com ele relata:</span> "Num certo dia, estavámos sentados na companhia do profeta <span class="c2">(Muhammad)</span> - que paz e bênção de Allah estejam sobre ele - quando aproximou-se de nós um homem com roupa de resplandecente brancura, e tinha cabelos intensamente pretos. Não se notavam sinais se fosse um viajante, e ninguém o conhecia dentre nós. Sentou-se em frente ao Profeta - que a paz e bênçãos de Allah estejam sobre ele - apoiando os seus joelhos com os do Profeta; e, colocou as mãos sobre as coxas dele,<span class="c6"> e disse:</span> Ó Muhammad, fala-<span class="c6">me a cerca do Isslam! O Mensageiro de Allah lhe respondeu:</span>O Isslam exige que prestes testemunho de que não há outra divindade digna de ser adorada além de Allah, e de que Muhammad é o Seu Mensageiro; que observes a oração, que pagues o zakat; que jejues no mês de Ramadan e que realizes a Peregrinação à Kaaba, se tiveres meios para isso.<span class="c6"> O homem disse:</span> Falaste a verdade. A nós surpreendeu-nos que lhe perguntasse, e que logo confirmasse a verdade.<span class="c6"> O homem voltou a perguntar:</span> Fala-<span class="c6">me sobre a fé! E o Profeta lhe respondeu:</span> Que creias em Allah, em Seus anjos, em Seus mensageiros e no Dia do Juízo. E que creias na predestinação, tanto no bom como no mau.<span class="c6"> E o homem disse:</span> Falaste a verdade! Fala-<span class="c6">me agora sobre a virtude! O Mensageiro de Allah respondeu:</span> Que adores a Allah como se estivesse vendo-O, pois se não O vês, Ele te vê.<span class="c6"> O homem disse:</span> Fala-me acerca da Hora <span class="c2">(do juízo)</span>.<span class="c6"> O Profeta disse:</span> Quem está sendo interrogado disso não tem melhor conhecimento do que quem está fazendo a pergunta.<span class="c6"> O homem insistiu:</span> Fala-me, então,<span class="c6"> dos seus sinais! O Mensageiro disse:</span> Será quando a escrava der a luz a sua própria senhora, e quando vires os descamisados e desamparados pastores de ovelhas competindo nas construções de altos edifícios. Aquele homem se foi, deixando-me pensativo por um bom tempo.<span class="c6"> O Profeta me perguntou:</span> Ó Umar,<span class="c6"> sabes quem era o questionador? Eu disse:</span> Allah e o seu Mensageiro sabem melhor! Ele disse: Era o Anjo Gabriel, que veio ensinar-vos a vossa religião. Narrado por Musslim.<br /> Notas do Hadith<br /> 1-<span class="c6"> Mencione os cinco pilares do Isslam; Que:</span><br /> Testemunho que não há ser digno de adoração excepto Allah e testemunho que Muhammad é Mensageiro de Allah<br /> A prática do Salah<br /> Entregar o Zakat<br /> Jejum de Ramadhan<br /> A peregrinação à Santa Casa de ALLAH.<br /> 2- Ele mencionou os pilares da fé,<span class="c6"> que são seis:</span><br /> A fé em Allah:<br /> Seus anjos<br /> Seus Livros<br /> Seus mensageiros<br /> Último Dia<br /> O destino, bom e máu.<br /> 3- Ele mencionou a coluna da caridade, e é uma coluna, que é adorar a ALLAH como se você O visse, e se você não o vê, então Ele vê você.<br /> 4- O tempo da Hora da Ressurreição, só ALLAHTodo-Poderoso sabe.<br /> O quarto Hadith </p>',
            ],
            3 => [
                'question' => 'Q4: Complete o Hadith “Os crentes mais completos na fé...” e mencione alguns de seus benefícios?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9360.mp3',
                'answer' => '<p> R: Pela autoridade de Abu Hurairah, que ALLAH esteja satisfeito com ele, que o Mensageiro de ALLAH, paz e bênçãos estejam sobre ele,<span class="c6"> disse:</span> <span class="c1">“Os crentes com a fé mais completa são aqueles com as melhores maneiras.”</span> <span class="c5">[Narrado por Tirmizi, e disse Hadith hassan sahih]</span><br /> Notas do Hadith<br /> 1- Incentivar as boas maneiras.<br /> 2- A perfeição do caráter faz parte da perfeição da fé.<br /> 3. A fé aumenta e diminui<br /> Quinto Hadith </p>',
            ],
            4 => [
                'question' => 'Q 5: Complete o Hadith: “Quem jura por algo que não seja ALLAH...” e mencione alguns de seus benefícios?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9440.mp3',
                'answer' => '<p> R: Pela autoridade de Ibn Umar, que ALLAH esteja satisfeito com ele, que o Mensageiro de ALLAH, paz e bênçãos estejam sobre ele,<span class="c6"> disse:</span> "Aquele que jurar em outro nome além de Allah, descreu ou cometeu idolatria.” Narrado por Tirmizi.<br /> Notas do Hadith<br /> Não é permitido jurar, exceto por ALLAH Todo-Poderoso<br /> Jurar por outro além de ALLAH Todo-Poderoso é do politeísmo menor.<br /> Sexto Hadith </p>',
            ],
            5 => [
                'question' => 'Q6: Complete o Hadith: “Nenhum de vocês acredita até que eu seja mais querido por ele...” e mencione alguns de seus benefícios?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9510.mp3',
                'answer' => '<p> R: Pela autoridade de Anass, que ALLAH esteja satisfeito com ele, que o Mensageiro de ALLAH, paz e bênçãos estejam sobre ele,<span class="c6"> disse:</span> <span class="c1">“Nenhum de vós é verdadeiramente crente até que eu seja o mais amado por ele do que seu filho, seu pai e todas as pessoas.”</span> Narrado por Bukhari e Musslim.<span class="c6"><br /> Notas do Hadith:</span><br /> O Profeta ﷺ deve ser amado mais do que todas as pessoas.<br /> Essa é a perfeição da fé.<br /> Sétimo Hadith </p>',
            ],
            6 => [
                'question' => 'Q 7: Complete o Hadith: “Nenhum de vocês acredita até que ele ame por seu irmão...” e mencione alguns de seus benefícios?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9580.mp3',
                'answer' => '<p> R: Pela autoridade de Anass, que ALLAH esteja satisfeito com ele, que o Mensageiro de ALLAH, paz e bênçãos estejam sobre ele,<span class="c6"> disse:</span> "Nenhum de vós chegará a ser um verdadeiro crente, até que deseje para o seu irmão o que deseja para si mesmo." Narrado por Bukhari e Musslim.<span class="c6"><br /> Notas do Hadith:</span><br /> 1- O crente deve amar os crentes do bem como ama a si mesmo.<br /> Essa é a perfeição da fé.<br /> Oitavo Hadith </p>',
            ],
            7 => [
                'question' => 'Q 8: Complete o Hadith: “Por Aquele em Cuja Mão está minha alma! ...", e citar alguns de seus benefícios?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9650.mp3',
                'answer' => '<p> R: Pela autoridade de Abu Said, que ALLAH esteja satisfeito com ele, que o Mensageiro de ALLAH, paz e bênçãos estejam sobre ele,<span class="c6"> disse:</span> <span class="c1">“Por Aquele em Cuja Mão está minha alma! É equivalente a um terço do Al Qur\'an.”</span> Narrado por Bukhari.<span class="c6"><br /> Notas do Hadith:</span><br /> 1- A virtude de Surat Al-Ikhlas.<br /> 2- Equivale a um terço do Al Qur\'an.<br /> Nono Hadith </p>',
            ],
            8 => [
                'question' => 'Q 9: Complete o Hadith “Não há força ou poder exceto com ALLAH...” e mencione alguns de seus benefícios?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9720.mp3',
                'answer' => '<p> R: Pela autoridade de Abu Mussa, que ALLAH esteja satisfeito com ele, que o Mensageiro de ALLAH, que a paz e bênçãos de ALLAH estejam sobre ele,<span class="c6"> disse:</span> <span class="c1">“Não há força nem poder a não ser em ALLAH, é um dos tesouros do Paraíso”</span> Narrado por Bukhari e Musslim.<span class="c6"><br /> Notas do Hadith:</span><br /> 1- A virtude desta palavra, e que é um dos tesouros do Paraíso.<br /> 2- O servo exonera aqueles ao seu redor, sua força e sua dependência somente de ALLAH Todo-Poderoso.<br /> Décimo Hadith </p>',
            ],
            9 => [
                'question' => 'Q10: Complete o Hadith “Não há um pedaço de carne no corpo...” e mencione alguns de seus benefícios?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9790.mp3',
                'answer' => '<p> R: Pela autoridade de Nooman Ibn Bashir, que ALLAH esteja satisfeito com ele, que o Mensageiro de ALLAH, paz e bênçãos de ALLAH estejam sobre ele,<span class="c6"> disse:</span> Cuidado! Há um pedaço de carne no corpo se ficar bom <span class="c2">(reformado)</span> todo o corpo fica bom, mas se ficar estragado todo o corpo fica estragado e esse é o coração. Narrado por Bukhari e Musslim.<span class="c6"><br /> Notas do Hadith:</span><br /> 1- A justiça do coração inclui a justiça exterior e interior.<br /> 2- Prestar atenção à bondade do coração, porque contém a bondade do ser humano.<br /> Décimo primeiro Hadith </p>',
            ],
            10 => [
                'question' => 'Q 11: Complete o Hadith: “Quem diria as últimas palavras deste mundo: Não há deus senão ALLAH...” e mencione alguns de seus benefícios?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9860.mp3',
                'answer' => '<p> R: Pela autoridade de Muazh Ibn Jabal, que ALLAH esteja satisfeito com ele, que o Mensageiro de ALLAH, que a paz e bênçãos de ALLAH estejam sobre ele,<span class="c6"> disse:</span> Àquele cuja a última palavra for a afirmação do testemunho de fé <span class="c2">(La ilaha illaAllah)</span> entrará no Paraíso.<span class="c6"> Narrado por Abu Daud;<br /> Notas do Hadith:</span><br /> 1- A virtude de que não há deus real senão ALLAH, e que o servo entra no Paraíso através dele.<br /> 2-<span class="c6"> A virtude daquele cujas últimas palavras são do mundo:</span> Não há deus senão ALLAH.<br /> Décimo segundo Hadith </p>',
            ],
            11 => [
                'question' => 'Q 12: Complete o Hadith “O crente não é apunhalado, nem amaldiçoado…” e alguns de seus benefícios?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9940.mp3',
                'answer' => '<p> R: Pela autoridade de Ibn Mass\'úd, que ALLAH esteja satisfeito com ele, que o Mensageiro de ALLAH, que a paz e bênçãos de ALLAH estejam sobre ele,<span class="c6"> disse:</span> "O muçulmano nunca é sarcástico, xingador ou abusivo nem tampouco é dado a conversas vulgares." Narrado por Tirmidhi.<span class="c6"><br /> Notas do Hadith:</span><br /> 1- Proibir todo discurso falso e feio.<br /> Esse é o atributo do crente em sua língua.<span class="c6"><br /> Décimo terceiro Hadith:</span> </p>',
            ],
            12 => [
                'question' => 'Q13: Complete o Hadith “Faz parte do bom Isslam da pessoa…” e mencione alguns de suas notas?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10020.mp3',
                'answer' => '<p> R: Pela autoridade de Abu Hurairah, que ALLAH esteja satisfeito com ele, que o Mensageiro de ALLAH, paz e bênçãos estejam sobre ele,<span class="c6"> disse:</span> <span class="c1">“Faz parte do bom Isslam da pessoa que ela deixa o que não lhe diz respeito.”</span> Narrado por Tirmizi e outros.<span class="c6"><br /> Notas do Hadith:</span><br /> 1- Deixar o que não interessa a uma pessoa em assuntos relacionados à religião e assuntos mundanos de outros.<br /> 2- Que ele abandone o que não significa que ele seja um muçulmano perfeito.<br /> Décimo quarto Hadith </p>',
            ],
            13 => [
                'question' => 'Q 14: Complete o Hadith: “Quem lê uma letra do Livro de ALLAH...” e mencione alguns de seus benefícios?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10100.mp3',
                'answer' => '<p> C -<span class="c6"> Pela autoridade de Abdullah bin Mas\'oud:</span> O Profeta, que a paz e bênçãos de ALLAH esteja com ele,<span class="c6"> disse:</span> Quem ler uma letra no livro de ALLAH, terá como recompensa equivalente a dez, não digo que "alif, lam, mim" é uma letra, mais alif é uma letra, lam é uma letra e mim é uma letra. Narrado por Tirmidhi.<span class="c6"><br /> Notas do Hadith:</span><br /> 1- A virtude de recitar o Al Qur\'an<br /> 2- E que por cada letra que recitas tem recompensa </p>',
            ],
        ],
        6 => [
            0 => [
                'question' => 'Q 2: Como é o Adab com ALLAH?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10190.mp3',
                'answer' => '<p> C-1- Glória a Ele, o Altíssimo.<br /> C - Fomos criados para adorá-Lo exclusivamente, sem parceiro<br /> 3- Obedecê-lo<br /> 4- Abandonar o pecado<br /> 5- Seus agradecimentos e louvores, o Todo-Poderoso, por suas inúmeras graças e bênçãos.<br /> 6- Paciência com sua predestinação. </p>',
            ],
            1 => [
                'question' => 'Q 2: Como é o Adab com o Mensageiro ﷺ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10270.mp3',
                'answer' => '<p> C- 1- Seguindo-o<br /> 2- Obedecendo-o<br /> 3- Abandonar sua desobediência<br /> 4- Acreditar no que ele disse.<br /> 5- 5- Não ser inovado em exceder sua Sunnah.<br /> 6- Seu amor é mais do que a alma e todas as pessoas.<br /> 7- Respeitá-lo, ajuda-o e ajudar a sua sunnah </p>',
            ],
            2 => [
                'question' => 'Q3: Como é o adab com os pais?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10360.mp3',
                'answer' => '<p> C - 1 - Obediência aos pais na não desobediência<br /> 2- Servir os pais<br /> 3- Ajudar os pais<br /> 4- Suprir suas necessidades<br /> 5- Duã para os pais<br /> 6-<span class="c6"> Ser educado com eles ao falar; Não é permitido dizer:</span> <span class="c1">“Af”, que é o menor dos ditos.<br /> 7- Sorrir na cara dos pais e não franzir a testa.<br /> 8- Não levanto a voz acima da voz dos pais, não os escuto, não os interrompo com palavras, não os chamo pelo nome,<span class="c6"> mas digo:</span> “Meu pai”</span>, “Minha mãe”.<br /> 9- Peço permissão antes de entrar meu pai e minha mãe enquanto eles estão no quarto.<br /> 10- Beijar as mãos e a cabeça dos pais. </p>',
            ],
            3 => [
                'question' => 'R: Como juntar os laços familiares?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10490.mp3',
                'answer' => '<p> C-1- Visitar parentes do irmão, irmã, tio, tia, tio, tia e demais parentes.<br /> 2- Seja gentil com eles em palavras e ações e ajude-os.<br /> 3- Inclui entrar em contato com eles e perguntar sobre suas condições. </p>',
            ],
            4 => [
                'question' => 'Q5: Como posso estar com meus irmãos e amigos?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10550.mp3',
                'answer' => '<p> A- 1- Amo e ando com bons companheiros.<br /> 2- Evito e deixo a companhia dos ímpios.<br /> 3- Saúdo meus irmãos e aperto a mão deles.<br /> 4- Eu os visito se estiverem doentes e rezo para que se recuperem.<br /> 5- Oro a favor da pessoa que aspiou.<br /> 6- Atendo o convite dele se ele me convidar para visitá-lo.<br /> 7- Eu dou conselhos a ele.<br /> 8- Ajudo-o se for injustiçado e impeço-o de injustiça<br /> 10- Eu amo para meu irmão muçulmano o que amo para mim.<br /> 11- Eu o ajudo se ele precisar da minha ajuda.<br /> 12- Não o assolo com nenhum mal, por palavra ou ação.<br /> 13- Guardo o segredo dele.<br /> 14- Não o insulto, não o calunio, não o desprezo, nem o invejo, não o espio nem o engano. </p>',
            ],
            5 => [
                'question' => 'Q6: Qual é a etiqueta do vizinho?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10710.mp3',
                'answer' => '<p> A- 1- Faço o bem ao próximo em palavras e obras e ajudo-o se precisar da minha ajuda.<br /> 2- Parabenizo-o quando realiza uma festa de comemoração, casamento ou qualquer outra coisa <span class="c2">(lícita)</span>.<br /> 3- Eu o devolverei se estiver doente e o consolarei se estiver ferido.<br /> 4- Eu ofereço a ele o máximo de comida possível.<br /> 5- Não prejudico-o com palavra ou ação.<br /> 6- Não o perturbo em voz alta nem o espio, e seja paciente com ele. </p>',
            ],
            6 => [
                'question' => 'Q7: Qual é a etiqueta de hospitalidade e convidado?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10800.mp3',
                'answer' => '<p> A- 1- Atendo a quem me convidou.<br /> 2- Se pretendo visitar alguém, peço autorização e marcação.<br /> 3- Peço permissão antes de entrar.<br /> 4- Não me atraso para uma visita.<br /> 5- Faço vista grossa para as pessoas da casa.<br /> 6- Recebo o hóspede e recebo a melhor recepção, com rosto alegre, e as melhores palavras de boas-vindas.<br /> 7- Sento com o convidado no melhor lugar.<br /> 8- E honro-o com hospitalidade de comida e bebida. </p>',
            ],
            7 => [
                'question' => 'Q 8: Quais são as etiqueta de doença e visitas a pacientes?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10900.mp3',
                'answer' => '<p> C-1-<span class="c6"> Quando sinto dor; Coloco minha mão direita no lugar da dor e digo:</span> <span class="c1">“Em nome de ALLAH”</span> três vezes,<span class="c6"> e digo:</span> <span class="c1">“Procuro refúgio na glória e no poder de ALLAH do mal do que encontro”</span> sete vezes.<br /> 2- Fico satisfeito com o que ALLAH decretou e sou paciente.<br /> 3- Apresso-me em visitar meu irmão doente, oro por ele, e não me sento com ele por muito tempo.<br /> 4- Eu rezo por ele <span class="c2">(Ruqya)</span> sem me pedir.<br /> 5- Aconselho-o a ser paciente e suplicar, orar e purificar-se o quanto puder.<br /> 6-<span class="c6"> Súplica pelos enfermos:</span> <span class="c1">“Peço a ALLAH Todo-Poderoso, Senhor do Grande Trono, que te cure”</span> sete vezes. </p>',
            ],
            8 => [
                'question' => 'Q 9: Qual é a etiqueta de buscar conhecimento?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10990.mp3',
                'answer' => '<p> C - 1- Sinceridade de intenção a ALLAH Todo-Poderoso<br /> 2- Pratico com o conhecimento que aprendi.<br /> 3- Respeito e honro o professor em sua presença e ausência.<br /> 4- Sento-me educadamente em frente dele.<br /> 5- Eu o escuto bem e não o interrompo em sua aula.<br /> 6- Sou educado ao fazer a pergunta.<br /> 7- Não o chamo pelo nome. </p>',
            ],
            9 => [
                'question' => 'Q10: Qual é a etiqueta da sentada?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11090.mp3',
                'answer' => '<p> C - 1- Saúdo o povo da sentada.<br /> 2- Eu me sento onde a assembleia termina, não faço ninguém levantar nem me sento entre duas pessoas sem a permissão delas.<br /> 3-Amplio a sentada para outra pessoa sentar.<br /> 4- Não interrompo o discurso do conselho.<br /> 5- Procuro permissão antes de sair do conselho.<br /> 6- Terminado, suplico a oração de expiação da sentada Glorificado seja Tu oh Allah, louvado sejas, testemunho que não há divindade real a não ser Tu, procuro por Teu perdão, eu me arrependo a Ti. </p>',
            ],
            10 => [
                'question' => 'Q 11: Mencione a etiqueta de dormir?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11180.mp3',
                'answer' => '<p> A- Eu durmo cedo.<br /> 2- Eu durmo em estado de pureza.<br /> 3- Eu não durmo de barriga.<br /> 4- Eu durmo do lado direito, e minha mão direita está embaixo da bochecha direita.<br /> 5- Sacudo minha cama.<br /> 6- Recito o adhkaar de dormir, de Ayat al-Kursi, Surat Al-Ikhlas e Al-Ma\'widhatayn três vezes.<span class="c6"> Eu digo:</span> R: &lt;&lt;bissmika allahuma \'amutu wa\'ahya&gt;&gt;<br /> 7- Eu me levanto para a oração do Fajr.<br /> 8-<span class="c6"> Digo depois de acordar do sono:</span> R: &lt;&lt;alhamd lilah aladhi \'ahyanan báda ma \'amatana, wa\'iilayh alnushur&gt;&gt; </p>',
            ],
            11 => [
                'question' => 'Q6: Qual é a etiqueta de comer?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11290.mp3',
                'answer' => '<p> R-<br /> 1 - Tenciono, comendo e bebendo piedade, obedecer a ALLAH, o Poderoso e o Sublime.<br /> 2- Lavar as mãos antes de comer<br /> 3-<span class="c6"> Digo:</span> <span class="c1">“Em nome de ALLAH”</span>, e como com a mão direita e o que está do meu lado, e não como no meio dos pratos, nem na frente de ninguém.<br /> 4- Se eu esquecer o nome,<span class="c6"> eu digo:</span> <span class="c1">“Em nome de ALLAH, o começo e o fim disso.”</span><br /> 5- Estou satisfeito com o que está disponível da comida e não tiro defeitos da comida, se gosto, como, e se não gosto, deixo.<br /> 6- Eu como pouca quantidade, e não como muito.<br /> 7- Não sopro na comida ou na bebida, e deixo até esfriar.<br /> 8- Reúno-me com outras pessoas para comer com a família ou com o convidado.<br /> 9- Não como antes de alguém mais velho que eu.<br /> 10- Menciono o nome de ALLAH quando bebo, e bebo sentado e em três porções.<br /> 11- Agradeço a ALLAH quando termino de comer. </p>',
            ],
            12 => [
                'question' => 'Q13: Quantas etiquetas existem de vestimentas?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11440.mp3',
                'answer' => '<p> A- 1- uso meu vestido com a mão direita, e agradeço a ALLAH por isso.<br /> 2- Não estendo a roupa abaixo dos tornozelos.<br /> 3- Meninos não usam roupas de meninas e meninas não usam roupas de meninos.<br /> 4- Não imitar a roupa dos incrédulos ou dos pecadores.<br /> 5- Etiqueta ao despir.<br /> 6- Colocando os chinelos primeiro à direita e tirando pela esquerda. </p>',
            ],
            13 => [
                'question' => 'Q 14: Mencione a etiqueta ao montar?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11540.mp3',
                'answer' => '<p> A- 1-<span class="c6"> Digo:</span> <span class="c1">“Em nome de ALLAH, louvado seja ALLAH”</span>. Quão perfeito é Aquele que no-los submeteu, o que jamais teríamos logrado a fazer" "E Por certo, seremos tornados a nosso Senhor.<span class="c6">" Zukhruf:</span> 13-14<br /> 2- Quando passo por um muçulmano digo; Paz esteja com ele. </p>',
            ],
            14 => [
                'question' => 'Q 15: Mencione a etiqueta da estrada?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11590.mp3',
                'answer' => '<p> A - 1 - Sou moderado e humilde no meu andar, e ando à direita da estrada.<br /> 2- A paz esteja com aquele que o saudou.<br /> 3- Baixo a vista e não faço mal a ninguém.<br /> 4-<span class="c6"> A ordem para a prática do bem e a proibição do mal:</span><br /> 5- Removo os danos da estrada. </p>',
            ],
            15 => [
                'question' => 'Q 16: Mencione a etiqueta de entrar e sair de casa?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11670.mp3',
                'answer' => '<p> A- 1-<span class="c6"> Saio com o pé esquerdo e digo:</span> Eu começo com o Nome de Allah, eu confio em Allah; Ó ALLAH! Eu busco refúgio em Ti para não sair ou ser desviado, ou contra escorregar ou ser levado a escorregar; ou fazendo injustiça ou sendo injustiçado; ou fazendo errado ou tendo errado feito para mim) 2-<span class="c6"> Entro na casa com o pé direito e digo:</span> <span class="c1">“Bismillah walajna, wa bismillah kharajna, wa ala rabbuna tawakkalna”</span> <span class="c2">(Em nome de Allah, nós entramos e em nome de Allah nós saímos e em nosso Senhor nos confiamos)</span>; depois cumprimentava sua família.<br /> 3- Começo com o Siwaq, depois saúdo as pessoas da casa com o salaam. </p>',
            ],
            16 => [
                'question' => 'Q 17: Mencione a etiqueta de se aliviar?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11730.mp3',
                'answer' => '<p> A- 1-<span class="c6"> Saio com o pé esquerdo e digo:</span><br /> 2-<span class="c6"> Digo antes de entrar:</span> O Allah eu protejo-me em Ti de todo os males e de seus causadores <span class="c2">(Allahumma inni auzhu bika mina al-khubth wa al-khabá\'ith)</span><br /> 3- Não entro com nada que contenha a lembrança de ALLAH.<br /> 4- Cubro ao suprir as necessidades biológicas<br /> 5- Não falo ao suprir as necessidades<br /> 6- Não enfrento a qiblah, nem viro ao urinar ou defecar.<br /> 7- Uso a mão esquerda para remover impurezas, e não uso a mão direita.<br /> 8- Não me alivio no caminho das pessoas ou em suas sombras.<br /> 9- Lavo as mãos depois de me aliviar.<br /> A- 10-<span class="c6"> Saio com o pé esquerdo e digo:</span> Gufrának </p>',
            ],
            17 => [
                'question' => 'Q 18: Quais são as etiquetas da mesquita?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11860.mp3',
                'answer' => '<p> A- 1-<span class="c6"> Entro na mesquita com o pé direito e digo:</span> <span class="c1">“Em nome de ALLAH, ó ALLAH, abre-me as portas da Tua misericórdia.”</span><br /> 2- Eu não me sento até rezar duas rak\'ahs.<br /> 3 - Não ordeno na presença dos fiéis, nem canto o perdido na mesquita, nem vendo e compro na mesquita.<br /> 4-<span class="c6"> Saio da mesquita com o pé esquerdo e digo:</span> "Oh ALLAH, eu te peço por favor." </p>',
            ],
            18 => [
                'question' => 'Q 19: Quais são as etiquetas de Salam?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11930.mp3',
                'answer' => '<p> A - 1 - Quando encontro um muçulmano,<span class="c6"> começo dizendo:</span> <span class="c1">“A paz esteja com você, e a misericórdia e as bênçãos de ALLAH estejam com você”</span>, não sem paz, e não aponto apenas com a mão.<br /> 2- Sorrio para quem cumprimenta.<br /> 3- Aperto a mão usando a mão direita.<br /> 4- Se alguém me cumprimentar com uma saudação, eu o saúdo com uma melhor, ou devolvo a mesma.<br /> 5- Não começo o infiel com a saudação, e se ele me cumprimentar, respondo com o mesmo.<br /> 6- O mais novo saúda o mais velho, o que anda ao pedestre, o que anda ao sentado, e os poucos saúdam os muitos. </p>',
            ],
            19 => [
                'question' => 'Q 20: Mencione a etiqueta de pedir permissão?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12020.mp3',
                'answer' => '<p> A- 1- Peço permissão antes de entrar no local.<br /> 2- Peço permissão três vezes e nada mais, e depois vou embora.<br /> 3- Bato na porta suavemente, e não fico na frente da porta, mas à direita ou à esquerda dela.<br /> 4- Não entro no quarto dos meus pais e de outros antes de pedir licença, principalmente antes do amanhecer e da sesta ao meio-dia, e depois da oração da noite.<br /> 5- Posso entrar em locais desabitados,<span class="c6"> como:</span> hospital ou loja, sem permissão. </p>',
            ],
            20 => [
                'question' => 'Q 21: Mencione a etiqueta de bondade para com os animais?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12100.mp3',
                'answer' => '<p> C- 1- Alimentar e dar água ao animal.<br /> 2- Compaixão e ternura pelos animais, e não sobrecarregá-los com o que não podem suportar.<br /> 3- Não torturo animais com nenhum tipo de tormento ou dano. </p>',
            ],
            21 => [
                'question' => 'Q22: Mencione a etiqueta para esportes?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12160.mp3',
                'answer' => '<p> C-1- Pretendo praticar a piedade para obedecer e agradar a ALLAH.<br /> 2- Não brincamos na hora da oração.<br /> 3- Meninos não praticam esportes com meninas.<br /> 4- Fico com o uniforme esportivo que cobre minha nudez.<br /> 5- Evito esportes proibidos, como bater no rosto e revelar as partes íntimas. </p>',
            ],
            22 => [
                'question' => 'Q23: Mencione alguma etiqueta para brincar?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12240.mp3',
                'answer' => '<p> C-1- Honestidade na brincadeira e não na mentira.<br /> 2- Piadas livres de ridicularização, zombaria, abuso e intimidação.<br /> 3- Não brincar muito. </p>',
            ],
            23 => [
                'question' => 'Q 24: Lembre-se da etiqueta de espirrar?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12300.mp3',
                'answer' => '<p> C-1- Colocar a mão, roupa ou lenço ao espirrar.<br /> 2-<span class="c6"> Louvar a ALLAH depois de espirrar:</span> <span class="c1">“Louvado seja ALLAH”</span>.<span class="c6"><br /> E que seu irmão ou companheiro lhe diga:</span> <span class="c1">“Que ALLAH tenha misericórdia de você.<span class="c6"><br /> Se ele lhe disser:</span> Deixe-<span class="c6">o dizer:</span> “Que ALLAH o guie e acerte seus negócios”</span>. </p>',
            ],
            24 => [
                'question' => 'Q 25: Qual é a etiqueta de bocejar?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12360.mp3',
                'answer' => '<p> C-1- Tente suprimir o bocejo.<br /> 2- Não levantar a voz dizendo “ah” ah.<br /> 3- Colocar a mão sobre a boca. </p>',
            ],
            25 => [
                'question' => 'Q 26: Mencione a etiqueta da recitação?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12420.mp3',
                'answer' => '<p> C - 1- Recitando a ablução ritual após a ablução.<br /> 2- Sente-se educadamente e com dignidade.<br /> 3- Busco refúgio em Allah de Satanás no início da recitação.<br /> 4- Medito na recitação </p>',
            ],
        ],
        7 => [
            0 => [
                'question' => 'P1:Menciona a virtude do bom comportamento?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12500.mp3',
                'answer' => '<p> R: E o Profeta - que a paz e bênçãos de Allah estejam sobre ele -<span class="c6"> disse:</span> O crente com a fé mais completa é aquele que mais aperfeiçoa seu comportamento. Narrado por Tirmizi </p>',
            ],
            1 => [
                'question' => 'P2: Porquê adotamos o comportamento Islâmico?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12530.mp3',
                'answer' => '<p> R: Porque é razão de atrair o amor de ALLAH<br /> 2- E razão para atrair o amor das pessoas.<br /> 3- É a coisa mais pesada da balança.<br /> 4- Recompensa e recompensa são multiplicadas pelas boas maneiras.<br /> 5- E um indicador da perfeição da fé </p>',
            ],
            2 => [
                'question' => 'P3: De onde tomamos o comportamento?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12600.mp3',
                'answer' => '<p> R: Do Nobre Al-Qur\'án.<span class="c6"> ALLAH diz:</span> Certamente este Al Qur\'an guia para aquilo que é melhor Al-<span class="c6">Issrá:</span>9 E da Sunnah do Profeta: Onde o Mensageiro de ALLAH, que a paz e bênçãos de ALLAH estejam sobre ele,<span class="c6"> disse:</span> &lt;&lt; Na verdade fui enviado para complementar as boas maneiras. &gt;&gt; Narrado por Ahmad. </p>',
            ],
            3 => [
                'question' => 'P4: Qual é o comportamento de Al-Ihssan e suas formas?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12640.mp3',
                'answer' => '<p> C-<span class="c6"> Ihsan:</span> É estar ciente da vigilância de ALLAH, e fazer o bem e benevolência às criaturas.<span class="c6"><br /> E o Profeta ﷺ disse:</span> <span class="c1">“ALLAH decretou bondade sobre todas as coisas.”</span> Narrado por Musslim.<span class="c6"><br /> Dentre as formas do Ihssan:</span><br /> Ihssan na adoração de ALLAH Todo-Poderoso, e isso é sinceridade em sua adoração.<br /> A bondade com os pais, ditos e práticas<br /> A bondade com os familiares e próximos<br /> A bondade com os vizinhos<br /> A bondade com os órfãos e pobres<br /> A bondade com aquele que te fez mal<br /> A bondade na palavra<br /> A bondade na discussão<br /> A bondade com os animais </p>',
            ],
            4 => [
                'question' => 'P5: Qual é o antónimo da bondade?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12780.mp3',
                'answer' => '<p> R: É a maldade<br /> * Entre isso: abandonar a sinceridade na adoração a ALLAH Todo-Poderoso.<br /> A desobediência aos pais<br /> O rompimento de relações familiares<br /> Má vzinhança<br /> * Abandonar a caridade aos pobres e necessitados e outras palavras e ações ruins. </p>',
            ],
            5 => [
                'question' => 'P6: Quais sao os tipos de Amanah e suas formas?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12860.mp3',
                'answer' => '<p> R-<br /> 1-<span class="c6"> Amanah na preservação dos direitos de ALLAH<br /> Suas formas:</span> Honestidade em realizar atos de adoração como oração, zakat, jejum, peregrinação e outras coisas que ALLAH nos ordenou.<br /> 2- Amanah na preservação de direitos das criaturas<br /> Aquele que preserva a honra das pessoas<br /> Suas riquezas<br /> Seu sangue<br /> Seus segredos e tudo que lhe foi confiado.<br /> ALLAH Todo-Poderoso disse, descrevendo as características do bem-<span class="c6">sucedido:</span> E que respeitam fielmente seus depósitos, a eles confiados, e honram seus pactos, Al-<span class="c6">Múminun:</span>8 </p>',
            ],
            6 => [
                'question' => 'P7: Qual é o antónimo de Amanah?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12980.mp3',
                'answer' => '<p> C - Traição, que é a perda dos direitos de ALLAH Todo-Poderoso e dos direitos das pessoas.<br /> E o Profeta - que a paz e bênçãos de Allah estejam sobre ele -<span class="c6"> disse:</span> Sinais do hipócrita são tres: e disse: Quando lhe é confiado trai Bukhari e Musslim. </p>',
            ],
            7 => [
                'question' => 'Q8: Qual é a natureza da honestidade?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13020.mp3',
                'answer' => '<p> C- É dizer o que corresponde à realidade ou à coisa como ela é.<span class="c6"><br /> E suas formas:</span><br /> Falar a verdade com as pessoas<br /> A verdade na promessa<br /> A verdade em todo dito e prática<br /> E o Profeta - que a paz e bênçãos de Allah estejam sobre ele -<span class="c6"> disse:</span> <span class="c1">“A veracidade leva à justiça, e a justiça leva ao Paraíso, e um homem dá caridade até que seja verdadeiro.”</span> Bukhari e Musslim. </p>',
            ],
            8 => [
                'question' => 'P9: Qual é o contrário da verdade?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13100.mp3',
                'answer' => '<p> C - Mentir, o que é contrário à verdade, incluindo mentir para as pessoas, quebrar promessas e perjúrio.<span class="c6"><br /> E o Profeta ﷺ disse:</span> <span class="c1">“A mentira leva à imoralidade, e a imoralidade leva ao fogo, e o homem mentirá até que seja registado com ALLAH como mentiroso.”</span> Bukhari e Musslim. E o Profeta - que a paz e bênçãos de Allah estejam sobre ele -<span class="c6"> disse:</span> <span class="c1">“Os sinais de um hipócrita são três”</span> – e ele mencionou a partir dele – <span class="c1">“Quando ele fala, mente, e se faz uma promessa, a quebra”</span>. Bukhari e Musslim. </p>',
            ],
            9 => [
                'question' => 'P10: Menciona os tipos de paciência?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13140.mp3',
                'answer' => '<p> R: A paciência na obediência a ALLAH<br /> - A paciência contra o pecado<br /> Paciência sobre destinos dolorosos, e louvado seja ALLAH em todos os casos.<span class="c6"><br /> O Altíssimo diz:</span> ALLAH ama os pacientes Surat Áli-<span class="c6">Imran:</span> 146 E o Profeta - que a paz e bênçãos de Allah estejam sobre ele -<span class="c6"> disse:</span> É admirável o caso do crente, pois tudo é bom para ele; e isto não ocorre com ninguém mais, a não ser com o crente. Se é objeto de um bem e dá graças, isto é um bem para ele; e se sofre alguma desgraça e se arma de paciência, isto também é um benefício para ele Narrado por Musslim. </p>',
            ],
            10 => [
                'question' => 'P11: Qual é o antónimo da paciência?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13210.mp3',
                'answer' => '<p> R - É a falta de paciência na obediência, falta de paciência na desobediência e descontentamento com a predestinação por palavra ou ação.<span class="c6"><br /> Das suas formas:</span><br /> Desejar a morte<br /> Bater na face<br /> Rasgar a roupa<br /> Arrancar o cabelo<br /> Suplicar para auto destruição<br /> E o Profeta - que a paz e bênçãos de Allah estejam sobre ele -<span class="c6"> disse:</span> <span class="c1">“A recompensa é com a grande aflição, e se ALLAH ama um povo, Ele o aflige, de modo que quem está satisfeito terá contentamento, e quem se zangar será desonrado.”</span> Narrado por Abu Daud e Ibn Majah. </p>',
            ],
            11 => [
                'question' => 'P12: Menciona a atitude de cooperação',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13310.mp3',
                'answer' => '<p> C - É a cooperação das pessoas entre si na verdade e no bem.<span class="c6"><br /> Formas de cooperação:</span><br /> A cooperação na devolução de direitos<br /> A cooperação na devolução de injustiças<br /> A cooperação no suprimento de necessidades<br /> A cooperação em todo bem<br /> Não cooperar em pecado e inimizade<br /> O Altíssimo diz: E ajudai-vos mutuamente na virtuosidade e na piedade, e não vos ajudeis mutuamente no pecado e na transgressão. Capítulo da Mesa servida, ٢. E o Profeta - que a paz e bênçãos de Allah estejam sobre ele -<span class="c6"> disse:</span> "O crente é, para os outros crentes, como um edifício onde as suas diferentes partes se reforçam reciprocamente." Bukhari e Musslim. E o Profeta - que a paz e bênçãos de Allah estejam sobre ele -<span class="c6"> disse:</span> "Um muçulmano é irmão de outro muçulmano; nunca é injusto para com ele, nem o entrega ao inimigo. A quem acudir um irmão necessitado, Allah acudirá em sua ajuda; e a quem aliviar a angústia de um muçulmano, Allah aliviará, por isso, uma de suas angústias no Dia da Ressurreição; e a quem encobrir a falta de um muçulmano, Allah encobrirá as suas faltas no Dia do Juízo." Bukhari e Musslim. </p>',
            ],
            12 => [
                'question' => 'P13: Quais são os tipos de vergonha?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13420.mp3',
                'answer' => '<p> R: A vergonha de ALLAH: Não o desobedecendo<br /> 2-<span class="c6"> Modéstia por parte das pessoas:</span> Isso inclui evitar o discurso obsceno e abusivo e expôr as partes íntimas.<span class="c6"><br /> O Mensageiro de ALLAH disse:</span> "Os atos da fé se compõem de umas sessenta ou setenta classes; o que tem mais mérito é o de se proclamar: \'Não há outra divindade além de Allah.\' E o de menor importância é<br /> o de se retirar os obstáculos dos caminhos. Mas sabei que o pudor é um ramo da fé." Narrado por Musslim. </p>',
            ],
            13 => [
                'question' => 'P14: Menciona formas de misericordia?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13470.mp3',
                'answer' => '<p> R: Compaixão com os idosos e respeitá-los<br /> Compaixão com os mais novos e crianças<br /> Compaixão com os pobre e necessitados<br /> Compaixão com os animais<br /> E o dito do Profeta - que a paz e bênçãos de ALLAH estejam com ele -<span class="c6"> disse:</span> "O exemplo dos crentes em sua compaixão, afeição e simpatia como o corpo. Se um membro reclama, o resto de seu corpo responde a isso com insónia e febre." Bukhari e Musslim.<span class="c6"> O Mensageiro de ALLAH disse:</span> Os Compassivos serão cobertos pela misericórdia do Misericordioso, sejam compassivos com aqueles que estão na terra, que aquele que está nos céus será compassivo convosco Narrado por Abu Daud e Tirmizi; </p>',
            ],
            14 => [
                'question' => 'P15: Quais são os tipos de amor?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13550.mp3',
                'answer' => '<p> R: O Amor de ALLAH<br /> O Altíssimo diz: Mas os fiéis só amam fervorosamente a ALLAH Surat Al-<span class="c6">Bacara:</span> ١٦٥<br /> Amor pelo Profeta<br /> Ele disse: <span class="c1">“Por Aquele em Cujas Mãos está minha alma, nenhum de vocês tem fé até que eu seja mais querido para ele do que seu pai e filho.”</span> Narrado por Bukhari<br /> Amar os crentes e desejar o bem para eles tal como deseja para si mesmo<br /> E o Profeta - que a paz e bênçãos de Allah estejam sobre ele -<span class="c6"> disse:</span> "Nenhum de vós chegará a ser um verdadeiro crente, até que deseje para o seu irmão o que deseja para si mesmo." Narrado por Bukhari </p>',
            ],
            15 => [
                'question' => 'P16: Defina o sorriso?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13630.mp3',
                'answer' => '<p> C - É a fluência do rosto, com alegria, sorriso, gentileza e prazer ao conhecer as pessoas.<br /> É o antónimo de cara amarrada, o que os distancia<br /> E na virtude disso constam Hadiths, sob a autoridade de Abu Dharr, que ALLAH esteja satisfeito com ele,<span class="c6"> que disse:</span> O Profeta, que a paz esteja com ele,<span class="c6"> me disse:</span> "Não menosprezes qualquer ato de bondade, inclusive o de receberes o teu próximo com semblante alegre." Narrado por Musslim.<span class="c6"> O Mensageiro de ALLAH disse:</span> Seu sorriso na face do seu irmão é uma caridade Narrado por Tirmidhi. </p>',
            ],
            16 => [
                'question' => 'P17: O que é inveja?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13690.mp3',
                'answer' => '<p> R- É desejar que a bênção seja retirada dos outros ou odiar a bênção dos outros.<span class="c6"><br /> ALLAH diz:</span> E contra o mal do invejoso quando inveja <span class="c5">[Al-<span class="c6">Falaq:</span>5]</span><br /> Anass Ibn Málik - que ALLAH esteja satisfeito com ele -<span class="c6"> relata que o Mensageiro de ALLAH disse:</span> Nao odieis, nao invejeis, nao deis costas, sejam servos de ALLAH irmãos uns dos outros Narrado por Bukhari e Musslim. </p>',
            ],
            17 => [
                'question' => 'P18: O que é o gozo?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13740.mp3',
                'answer' => '<p> R: É fazer pouco do seu irmãos e desprezá-los,<span class="c6"> e isso não é permitido<br /> ALLAH diz proibindo isso:</span> Ó vós que credes! Que um grupo não escarneça de outro grupo - quiçá, este seja melhor que aquele - nem mulheres, de mulheres - quiçá, estas sejam melhores que aquelas - e não vos difameis, mutuamente, e não vos injurieis, com epítetos depreciativos. Que execrável a designação de "perversidade", depois da Fé! E os que se não arrependem, esses são os injustos. Al-<span class="c6">Hujurat:</span>11 </p>',
            ],
            18 => [
                'question' => 'P19: Defina a humildade',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13780.mp3',
                'answer' => '<p> R- É que a pessoa não se ache melhor que as pessoas, que não despreze as pessoas e não rejeite a verdade.<span class="c6"><br /> O Altíssimo diz:</span> E os servos de ALLAH andam pela terra humildemente Al-<span class="c6">Furqan:</span> 63 I.e. De forma mansa E o mensageiro de ALLAH - que a paz e bênçãos de ALLAH estejam com ele -<span class="c6"> disse:</span> E todo aquele que se humilha por ALLAH, ALLAH o honra Narrado por Musslim.<span class="c6"> E disse:</span> &lt;&lt; Allah, o Altíssimo, inspirou-me que devemos adotar a modéstia e a humildade, e que ninguém se exceda nem seja ostentoso com os demais. &gt;&gt; Narrado por Musslim. </p>',
            ],
            19 => [
                'question' => 'Q20: Quais são os tipos de arrogância proibida?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13840.mp3',
                'answer' => '<p> R:O orgulho que impede a pessoa de seguir a verdade<br /> 2- O orgulho para as pessoas, desprezando-os e gozando-os.<span class="c6"><br /> O Mensageiro de ALLAH disse:</span> <span class="c1">“Jamais entrará no Paraíso aquele que tiver em seu coração a soberbia, nem que seja do peso de um átomo”</span>.<span class="c6"> Um homem disse:</span> "Algumas pessoas gostam de belas<br /> roupas e lindos calçados.<span class="c6">" O Profeta disse:</span> "Allah é Formoso, e ama formosura! Porém, a soberbia é o desprezo pela verdade e menosprezo para com as pessoas." Narrado por Musslim.<br /> Batar al-<span class="c6">Haqq:</span> Refutar a verdade<br /> Desprezando as pessoas: desrespeitando-as<br /> Um bom vestido e um bom sapato não fazem parte da arrogância. </p>',
            ],
            20 => [
                'question' => 'Q21: Mencione alguns tipos de fraudes proibidas?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13910.mp3',
                'answer' => '<p> C- Fraude na compra e venda, que é ocultar o defeito da mercadoria.<br /> Fraude no aprendizado de ciências, assim como alunos trapaceando nas provas.<br /> Trapacear no discurso é como falso testemunho e mentira.<br /> Não cumprir o que você diz e o que você acorda com as pessoas.<br /> Sobre a proibição de trapacear, o Mensageiro de ALLAH, que a paz e bênçãos de ALLAH estejam com ele, passou por um pedaço de comida, e ele colocou a mão nele, e seus dedos ficaram molhados,<span class="c6"> então ele disse:</span> <span class="c1">“O que é isso, ó dono da comida?”</span> Ele disse: O céu o atingiu, ó Mensageiro de ALLAH.<span class="c6"> Ele disse:</span> <span class="c1">“Porque não colocaste em cima para que as pessoas pudessem ver? Quem engana não faz parte dos meus.”</span> Narrado por Musslim.<br /> Al-<span class="c6">Sub\'ra:</span> É o monte de comida. </p>',
            ],
            21 => [
                'question' => 'Q22: O que é calúnia?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13990.mp3',
                'answer' => '<p> C - É falar de seu irmão muçulmano do que ele não gosta enquanto está ausente.<span class="c6"><br /> O Altíssimo diz:</span> 12 E não caluniem uns aos outros; Algum de vocês gostaria de comer a carne de seu irmão morto? Nao, temei a ALLAH? ALLAH é o mais perdoador, o mais misericordioso. <span class="c2">(12)</span> Al-<span class="c6">Hujurat:</span>12 </p>',
            ],
            22 => [
                'question' => 'Q23: Defina a intriga?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14030.mp3',
                'answer' => '<p> C- É a transmissão de conversas entre as pessoas para corrompê-las.<span class="c6"><br /> O Mensageiro de ALLAH disse:</span> "Jamais entrará no Paraíso o intriguista." Narrado por Musslim. </p>',
            ],
            23 => [
                'question' => 'Q24: O que é preguiça?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14070.mp3',
                'answer' => '<p> c- É a preguiça de fazer o bem e o que a pessoa deve fazer.<span class="c6"><br /> Incluindo:</span> preguiça no cumprimento dos deveres.<br /> Allah - o Altíssimo - diz Por certo, os hipócritas procuram enganar a Allah mas Ele é quem os engana. E, quando se levantam para a oração, levantam-se preguiçosos querem ser vistos pelos outros, por ostentação, e não se lembram de Allah, exceto poucos. An-<span class="c6">Nissá:</span> ١٤٢<br /> O crente deve abandonar a preguiça, letargia e lentidão, e se esforçar no trabalho e movimento, e diligência nesta vida de uma maneira que agrade aALLAH Todo-Poderoso. </p>',
            ],
            24 => [
                'question' => 'P25: Quais são os tipos de zanga?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14130.mp3',
                'answer' => '<p> R-1-<span class="c6"> Zanga louvável:</span> É para Deus quando os infiéis, hipócritas ou outros violarem Suas santidades, Glória seja a Ele.<br /> 2-<span class="c6"> Uma raiva censurável:</span> É a raiva que leva uma pessoa a fazer e dizer o que não deve.<span class="c6"><br /> Tratamento da zanga detestável:</span><br /> Al-Wudhu<br /> Sentar se estiver em pé e deitar-se se estiver sentado.<br /> Para cumprir o mandamento do Profeta, que a paz e as bênçãos estejam sobre ele,<span class="c6"> neste sentido:</span> <span class="c1">“Não fique com raiva”</span>.<br /> Para controlar o impulso da raiva.<br /> Procuro refúgio diante de Allah contra o satanás o malvado<br /> O Silêncio </p>',
            ],
            25 => [
                'question' => 'Q26: O que é espionagem?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14240.mp3',
                'answer' => '<p> C - É a detecção e busca das falhas das pessoas e do que elas escondem.<span class="c6"><br /> De suas formas proibidas:</span><br /> Ver as partes íntimas das pessoas em casa.<br /> Ouvir o discurso de um povo sem o seu conhecimento.<span class="c6"><br /> O Altíssimo diz:</span> E não espieis Al-<span class="c6">Hujurat:</span>12 </p>',
            ],
            26 => [
                'question' => 'Q 27: O que é extravagância? E o que é avareza? E o que é generosidade?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14310.mp3',
                'answer' => '<p> C-<span class="c6"> Extravagância:</span> é gastar dinheiro ilegalmente.<span class="c6"><br /> E o contrário:</span> avareza: que é negar o direito.<br /> O correto é o meio termo entre eles, e que o muçulmano seja generoso.<span class="c6"><br /> O Altíssimo diz:</span> 67 E aqueles que, quando gastam, não são extravagantes nem mesquinhos, e são moderados. Al-<span class="c6">Furqan:</span>67 </p>',
            ],
            27 => [
                'question' => 'Q28: O que é ser medroso? E o que é coragem?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14370.mp3',
                'answer' => '<p> C-<span class="c6"> Covardia:</span> ter medo do que não deve ter medo<br /> Como o medo de dizer a verdade e negar o mal.<span class="c6"><br /> Coragem:</span> É a busca da verdade, como assumir a liderança nos campos de batalha da jihad para defender o Isslam e os muçulmanos.<br /> Em sua súplica,<span class="c6"> o Profeta ﷺ disse:</span> &lt;&lt; O Allah eu protejo-me em Ti de todo os males e de seus causadores <span class="c2">(Allahumma inni auzhu bika mina al-khubth wa al-khabá\'ith)</span> &gt;&gt; O Mensageiro de ALLAH disse: <span class="c1">“Um crente forte é melhor e mais amado por ALLAH do que um crente fraco, e há bem em todos.”</span> Narrado por Musslim. </p>',
            ],
            28 => [
                'question' => 'Q 29: Mencione algumas das palavras proibidas?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14440.mp3',
                'answer' => '<p> C - como amaldiçoar e insultar<br /> E o mesmo que dizer de fulano de “animal” ou expressões semelhantes.<br /> Ou mencionando as palavras de obscenidade e indecentes<br /> O Profeta, que a paz e as bênçãos de ALLAH estejam com ele, proibiu tudo isso,<span class="c6"> dizendo:</span> "O muçulmano nunca é sarcástico, xingador ou abusivo nem tampouco é dado a conversas vulgares." Narrado por Al-Tirmidhi e Ibn Hibban. </p>',
            ],
            29 => [
                'question' => 'Q 30: Quais são os meios que ajudam um muçulmano a adotar bons costumes?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14500.mp3',
                'answer' => '<p> C-1- Orando para que ALLAH te abençoe com bom caráter e te ajude com isso.<br /> 2- A vigilância de ALLAH, o Poderoso e Sublime, e que Ele te conhece, te ouve e te vê.<br /> 3- Lembre-se da recompensa das boas maneiras e que é um motivo para entrar no Paraíso.<br /> 4- Lembre-se da consequência das más maneiras e que é motivo para entrar no Fogo.<br /> 5- Que boas maneiras trazem amor a ALLAH Todo-Poderoso e amor à Sua criação, e que o mau comportamento traz ódio a ALLAH e ódio à Sua criação.<br /> 6- Lendo a biografia do Profeta, que a paz e bênçãos de ALLAH estejam sobre ele, e imitá-lo.<br /> 7- Mantenha a companhia de pessoas boas e evite companhia de pessoas ruins. </p>',
            ],
        ],
        8 => [
            0 => [
                'question' => 'P 3: Qual é o mérito do zikr?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14630.mp3',
                'answer' => '<p> R: E o profeta ﷺ disse: "O exemplo daquele que se lembra do seu Senhor e daquele que não se lembra Dele é como o exemplo de uma pessoa viva e uma pessoa morta. " Narrado por Bukhari<br /> - Isso porque o valor da vida de uma pessoa é tanto quanto ela se lembra de ALLAH Todo-Poderoso. </p>',
            ],
            1 => [
                'question' => 'Q2: Mencione alguns dos benefícios do dhikr?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14670.mp3',
                'answer' => '<p> C-1- Satisfaz o Misericordioso.<br /> 2- Ele expulsa Satanás.<br /> 3- Protege o muçulmano do mal.<br /> 4- Ele recebe recompensa e recompensa. </p>',
            ],
            2 => [
                'question' => 'Q3: Qual é o melhor dhikr?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14730.mp3',
                'answer' => '<p> <span class="c1">“La ilaha illa Allah”</span> <span class="c2">(Não há outra divindade além de Deus)</span>, Narrado por Abu Daud e Ibn Majah. </p>',
            ],
            3 => [
                'question' => 'Q22: O que você diz quando acorda?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14760.mp3',
                'answer' => '<p> R: &lt;&lt;alhamd lilah aladhi \'ahyanan báda ma \'amatana, wa\'iilayh alnushur&gt;&gt; Bukhar e Musslim. </p>',
            ],
            4 => [
                'question' => 'Q5: O que você diz ao vestir?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14790.mp3',
                'answer' => '<p> R: &lt;&lt;alhamd lilah aladhi kasani hadha althawb warazqanihi min ghayr hawl miniy wala quwwata&gt;&gt; Narrado por Abu Daud e Tirmizi. </p>',
            ],
            5 => [
                'question' => 'Q6: O que você diz ao tirar a roupa?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14820.mp3',
                'answer' => '<p> R: Bissmillah Narrado por Tirmidhi. </p>',
            ],
            6 => [
                'question' => 'Q 7: Qual é a súplica para vestir a roupa nova?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14850.mp3',
                'answer' => '<p> R: &lt;&lt;allahumma lak alhamd \'ant kassautanih, \'as\'aluk khayrah wakhayr ma sunia lah, wa\'aeudh bik min sharih washarri ma sunia lah&gt;&gt; Narrado por Abu Daud e Tirmizi; </p>',
            ],
            7 => [
                'question' => 'Q 8: Qual é a súplica para alguém que veste uma roupa nova?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14880.mp3',
                'answer' => '<p> C - Se você vir uma roupa nova em outra pessoa,<span class="c6"> você vai orar por ela e dizer:</span> "Possa você usá-la até exaurir-se e possa Allah te conceder outra". Narrado por Abu Daud; </p>',
            ],
            8 => [
                'question' => 'Q9: Mencione a súplica para entrar no banheiro, que é o lugar para se aliviar?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14910.mp3',
                'answer' => '<p> O Allah eu protejo-me em Ti de todo os males e de seus causadores <span class="c2">(Allahumma inni auzhu bika mina al-khubth wa al-khabá\'ith)</span> Bukhar e Musslim. </p>',
            ],
            9 => [
                'question' => 'P10: Qual é a súplica ao sair da retrete?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14940.mp3',
                'answer' => '<p> &lt;&lt;Ghufranaka&gt;&gt; Narrado por Abu Daud e Tirmizi; </p>',
            ],
            10 => [
                'question' => 'P11: O que dizes antes do wudhu?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14970.mp3',
                'answer' => '<p> R: Bissmillah Narrado por Abu Daud e outros; </p>',
            ],
            11 => [
                'question' => 'Q12: Qual é o dhikr após completar a ablução?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15000.mp3',
                'answer' => '<p> Testemunho que não há divindade que merece a adoração senão Allah, o Único que não tem parceiro, e testemunho que Muhammad é Seu servo e Mensageiro; Narrado por Musslim. </p>',
            ],
            12 => [
                'question' => 'Q13: Qual é o dhikr ao sair de casa?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15020.mp3',
                'answer' => '<p> R: <span class="c1">“Em nome de ALLAH, coloco minha confiança em ALLAH, e não há força ou poder exceto em ALLAH.”</span> Narrado por Abu Daud e Tirmizi; </p>',
            ],
            13 => [
                'question' => 'Q13: Qual é o dhikr ao entrar em casa?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15050.mp3',
                'answer' => '<p> <span class="c1">“Bismillah walajna, wa bismillah kharajna, wa ala rabbuna tawakkalna”</span> <span class="c2">(Em nome de Allah, nós entramos e em nome de Allah nós saímos e em nosso Senhor nos confiamos)</span>; depois cumprimentava sua família. Narrado por Abu Daud; </p>',
            ],
            14 => [
                'question' => 'P30: Qual é a súplica ao entrar no massgid?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15080.mp3',
                'answer' => '<p> C - <span class="c1">“Oh ALLAH, abre-me as portas da tua misericórdia.”</span> Narrado por Musslim. </p>',
            ],
            15 => [
                'question' => 'Q 16: Mencione a súplica para sair da mesquita?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15110.mp3',
                'answer' => '<p> C - <span class="c1">“Oh ALLAH, eu te peço por favor.”</span> Narrado por Musslim. </p>',
            ],
            16 => [
                'question' => 'Q 17: O que você diz ao ouvir o chamado para a oração?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15140.mp3',
                'answer' => '<p> R - Digo o mesmo que o muazin diz,<span class="c6"> exceto em:</span> <span class="c1">“atendam o salah”</span> e <span class="c1">“aproximem do sucesso”</span>,<span class="c6"> então digo:</span> <span class="c1">“não há força nem poder a não ser com ALLAH”</span>. Bukhar e Musslim. </p>',
            ],
            17 => [
                'question' => 'P18: O que dizes após o Azhan?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15170.mp3',
                'answer' => '<p> R - Envio saudação ao Profeta ﷺ. Narrado por Musslim.<span class="c6"> E ela diz:</span> <span class="c1">“Oh ALLAH, Senhor deste chamado perfeito e oração estabelecida, dê a Muhammad os meios e a virtude, e envie-o para a posição de louvor que você prometeu a ele”</span>. Bukhari<br /> E súplicas entre o chamado para a oração <span class="c2">(Azhan)</span> e o Iqamah, a súplica não é respondida. </p>',
            ],
            18 => [
                'question' => 'Q 19: O que você diz durante ás manhã e ás noite das lembranças?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15220.mp3',
                'answer' => '<p> C-1- Leia Ayat al-<span class="c6">Kursi:</span> Allah, não existe deus senão Ele, O Vivente, Aquele que subsiste por Si mesmo. Não O tomam nem sonolência nem sono. dEle é o que há nos céus e o que há na terra. Quem intercederá junto dEle senão com Sua permissão? Ele sabe seu passado e seu futuro<span class="c2">(1)</span>, e nada abarcam de Sua ciência senão aquilo que Ele quer. Seu Trono abrange os céus e a terra e não O afadiga custodiá-los. E Ele é O Altíssimo, O Magnífico<span class="c2">(2)</span>. Surat Al-<span class="c6">Bacara:</span> ٢٥٥ E recito em nome de ALLAH o Misericordioso,<span class="c6"> o Misericordiosíssimo {Dize:</span> "Ele é Allah, Único.<span class="c2">(1)</span> Allah, o Absoluto, <span class="c2">(2)</span> "Não gerou e não foi gerado, <span class="c2">(3)</span> "E não há ninguém igual a Ele.} <span class="c2">(4)</span> Três vezes Em nome de Allah, O Misericordioso, O Misericordiador Surat Al Falaq.<span class="c6"> Dize:</span> "Refugio-me nO Senhor dos homens," "Contra o mal daquilo que Ele criou," "E contra o mal da noite<span class="c2">(1)</span>quando entenebrece," "E contra o mal das sopradoras<span class="c2">(1)</span> dos nós." "E contra o mal do invejoso, quando inveja."<span class="c2">(1)</span> Três vezes Em nome de Allah, O Misericordioso, O Misericordiador Surat Al Falaq.<span class="c6"> Dize:</span> "Refugio-me nO Senhor dos homens," O Rei dos homens Deus dos homens "Contra o mal do sussurrador<span class="c2">(1)</span>, o absconso" "Que sussurra perfídias nos peitos dos homens," "Seja ele dos jinns, seja ele dos homens." Três vezes <span class="c2">(Ó Allah, Tu és meu Senhor, não há divindade além de Ti. Tu me criaste e eu sou Teu escravo e estou cumprindo minha promessa e aliança contigo tanto quanto posso. Busco refúgio em Ti do mal da Eu reconheço sua bênção e reconheço meu pecado, então me perdoe, pois não há ninguém que possa perdoar o pecado, exceto você.)</span>\' Narrado por Bukhari </p>',
            ],
            19 => [
                'question' => 'P20: O que dizes ao dormir?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15290.mp3',
                'answer' => '<p> R: &lt;&lt;bissmika allahuma \'amutu wa\'ahya&gt;&gt; Bukhari e Musslim. </p>',
            ],
            20 => [
                'question' => 'Q21: O que você diz antes de comer?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15320.mp3',
                'answer' => '<p> R: Bissmillah<br /> E se você esqueceu no começo,<span class="c6"> diga:</span><br /> &lt;&lt;basam allah fi \'awalih wakhrihi&gt;&gt; Narrado por Abu Daud e Tirmizi; </p>',
            ],
            21 => [
                'question' => 'Q22: O que você diz quando termina de comer?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15370.mp3',
                'answer' => '<p> R: &lt;&lt;alhamd lilah aladhi kasani hadha althawb warazqanihi min ghayr hawl miniy wala quwwata&gt;&gt; Narrado por Abu Daud e ibn Majah; </p>',
            ],
            22 => [
                'question' => 'Q 23: Qual é a súplica de um convidado para o dono da comida?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15400.mp3',
                'answer' => '<p> P– <span class="c1">“Ó ALLAH, abençoa-os pelo que lhes concedeste, perdoa-os e tem misericórdia deles”</span>. Narrado por Musslim. </p>',
            ],
            23 => [
                'question' => 'Q 24: O que uma pessoa diz quando espirra?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15430.mp3',
                'answer' => '<p> "E dize: Louvado seja Allah.<span class="c6">"<br /> E que seu irmão ou companheiro lhe diga:</span> <span class="c1">“Que Deus tenha misericórdia de você.<span class="c6"><br /> Se ele lhe disser:</span> Deixe-<span class="c6">o dizer:</span> “Que Deus o guie e acerte seus negócios”</span>. Narrado por Bukhari </p>',
            ],
            24 => [
                'question' => 'Q 25: O que você diz ao se levantar e sair da reunião, “a oração de expiação pelo conselho”?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15480.mp3',
                'answer' => '<p> Glorificado seja Tu oh Allah, louvado sejas, testemunho que não há divindade real a não ser Tu, procuro por Teu perdão, eu me arrependo a Ti Narrado por Abu Daud e Tirmizi. </p>',
            ],
            25 => [
                'question' => 'Q 26: Qual é a súplica para montar?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15510.mp3',
                'answer' => '<p> R: Em nome de ALLAH,<span class="c6"> todos os Louvores pertencem a ALLAH:</span> Glória é para Aquele que providenciou isso para nós embora nunca pudéssemos tê-lo por nossos esforços. Glória a ALLAH <span class="c2">(três vezes)</span>, ALLAHU Akbar <span class="c2">(três vezes)</span> Livre estás de todos os defeitos, ó ALLAH Eu injusticei a mim mesmo, então me perdoe. Ninguém perdoa pecados, exceto você.” Narrado por Abu Daud e Tirmizi; </p>',
            ],
            26 => [
                'question' => 'Q 27: Qual é a súplica para viajar?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15540.mp3',
                'answer' => '<p> Allah é o Maior. Allah é o Maior. Allah é o Maior. Glória é para Aquele que providenciou isso para nós embora nunca pudéssemos tê-lo por nossos esforços. Certamente, para nosso Senhor estamos voltando. Ó Allah, nós Te pedimos nesta nossa jornada por bondade e piedade, e para as obras que te agradam. Ó Allah, ilumine esta jornada para nós e faça sua distância fácil para nós. Ó Allah, você é nosso companheiro na estrada e Aquele em Cujo cuidado deixamos nossa família. Ó Allah, eu busco refúgio em Ti das dificuldades desta jornada, e das visões perversas guardadas e de encontrar nossa família e propriedade em desgraça ao retornar.<br /> E se ele voltar, ele as diz,<span class="c6"> e acrescenta:</span><br /> Áyibun, taibuna, ábiduna, lirabina hamidun&gt;&gt; Narrado por Musslim. </p>',
            ],
            27 => [
                'question' => 'Q 28: Qual é a súplica de um viajante por um residente?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15590.mp3',
                'answer' => '<p> &lt;&lt;\'astawdieukum allah aladhi la tadie wadayieahu&gt;&gt; Narrado por An-Nassai e ibn Majah. </p>',
            ],
            28 => [
                'question' => 'Q 29: Qual é a súplica de um residente para um viajante?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15620.mp3',
                'answer' => '<p> "Eu confio a Allah a sua religião, sua confiança e o fim de seus atos". Narrado por Ahmad e Tirmidhi. </p>',
            ],
            29 => [
                'question' => 'P30: Qual é a súplica ao entrar no mercado?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15650.mp3',
                'answer' => '<p> "Laa ilaha illaa Allah wahdahu laa shariika lahu, lahul mulku, wa lahul hamdu wa hua alaa kulli shai‘in qadiir." <span class="c2">(Não há divindade real além de Allah, o Único que não possui sócio, Ele é o Possuidor de toda soberania e louvores, Ele é quem possui poder sobre todas as coisas)</span>. Narrado por Abu Daud e Ibn Majah. </p>',
            ],
            30 => [
                'question' => 'Q 31: Lembre-se da súplica quando estiver com raiva? Qual é a súplica para o momento de zanga?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15680.mp3',
                'answer' => '<p> R:Procuro refúgio diante de Allah contra o satanás o malvado. Bukhar e Musslim. </p>',
            ],
            31 => [
                'question' => 'Q 32: O que você diz a alguém que lhe fez um favor?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15710.mp3',
                'answer' => '<p> R: Jazakallahu Khairan Narrado por Tirmidhi. </p>',
            ],
            32 => [
                'question' => 'Q 33: Qual é a súplica se o veículo estiver insatisfeito?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15740.mp3',
                'answer' => '<p> R: Bissmillah Narrado por Abu Daud; </p>',
            ],
            33 => [
                'question' => 'Q34: O que você diria se algo lhe agradasse?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15770.mp3',
                'answer' => '<p> C – <span class="c1">“Louvado seja ALLAH, por cuja graça se realizam as boas obras”</span>. Narrado por Hákim e outros. </p>',
            ],
            34 => [
                'question' => 'Q35: O que você diria se algo que você odeia acontecesse?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15800.mp3',
                'answer' => '<p> &lt;&lt;Alhamd lilah alaa kuli hali&gt;&gt; Sahih Al-Jámi </p>',
            ],
            35 => [
                'question' => 'P36: Qual é a maneira de saudar e responder?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15830.mp3',
                'answer' => '<p> R: O muçulmano diz: <span class="c1">“A paz esteja convosco e a misericórdia e bênçãos de ALLAH”</span>.<span class="c6"><br /> E seu irmão lhe responde:</span> <span class="c1">“E sobre ti estejam a paz, a misericórdia e as bênçãos de ALLAH”</span>. Narrado por Ahmad, Abu Daud e outros; </p>',
            ],
            36 => [
                'question' => 'Q 37: Qual é a súplica quando chove?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15870.mp3',
                'answer' => '<p> R: \'\'Ó ALLAH Sayyiban Náfian\'\' Allahuma sayyiban náfiãn Bukhari </p>',
            ],
            37 => [
                'question' => 'Q 38: Qual é a súplica após o término da chuva?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15900.mp3',
                'answer' => '<p> C – <span class="c1">“Choveu com a graça e misericórdia de ALLAH”</span>. Bukhari e Musslim </p>',
            ],
            38 => [
                'question' => 'P 39: Mencione a súplica do vento?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15930.mp3',
                'answer' => '<p> R – <span class="c1">“Ó ALLAH, peço-te o bem e busco refúgio em ti do mal”</span>. Narrado por Abu Daud e Ibn Majah; </p>',
            ],
            39 => [
                'question' => 'Q40: Mencione a súplica ao ouvir trovões?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15960.mp3',
                'answer' => '<p> Quão perfeito é Ele, por Quem o trovão declara Sua perfeição com Seu louvor e os anjos Seu temor Muwatta Málik </p>',
            ],
            40 => [
                'question' => 'Q 41: Qual é a súplica se você vir uma pessoa aflita?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15990.mp3',
                'answer' => '<p> &lt;&lt;Alhamd lilah aladhi eafani mimaa abtalak bihi, wafadalni ealaa kathyraan miman khalaq tafdylaan&gt;&gt; Narrado por Tirmidhi. </p>',
            ],
            41 => [
                'question' => 'Q 42: Súplica para alguém que teme que algo aconteça com ele?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16020.mp3',
                'answer' => '<p> R -<span class="c6"> No Hadith:</span> <span class="c1">“Se um de vocês vê algo de seu irmão ou de si mesmo, ou de seu dinheiro que ele gosta, <span class="c5">[deixe-o orar por bênção]</span> pois o mau-olhado é verdadeiro”</span>. Narrado por An-Nassai e Ibn Majah. </p>',
            ],
            42 => [
                'question' => 'Q 43: Como você ora pelo Profeta, que a paz e bênçãos de ALLAH estejam com ele?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16050.mp3',
                'answer' => '<p> "Ó Allah exalta Muhammad e sua família assim como Tu exaltaste Abraão e a familia de Abraão, em verdade Tu és o Laudabilíssimo, Munificente. Ó Allah Abençoa Muhammad e sua família assim como Tu abençoaste Abraão e a família de Abraão, em verdade Tu és o Laudabilíssimo, Munificente". Bukhari e Musslim. </p>',
            ],
        ],
        9 => [
            0 => [
                'question' => 'Q1: Quais são as cinco disposições obrigatórias?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16090.mp3',
                'answer' => '<p> R-<br /> 1- Al-Wájib<br /> 2- Al-Musstahab<br /> 3- Al-Muharram<br /> 4- Al-Makruh<br /> 5- Al-Mubah </p>',
            ],
            1 => [
                'question' => 'Q2: Explique essas cinco disposições?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16170.mp3',
                'answer' => '<p> R-<br /> 1-<span class="c6"> Obrigação:</span> Como as cinco orações diárias, jejum do Ramadhan e homenagem - respeito aos pais.<br /> Al-<span class="c6">Wájib:</span> O fazedor é recompensado e aquele que negligencia é punido.<br /> 2-<span class="c6"> Mustahabb:</span> como as orações regulares da Sunnah, a oração da noite, alimentação e paz. É chamado de Sunnah e Mandub.<br /> O desejável que aquele que o faz seja recompensado e aquele que não faz, não seja punido.<span class="c6"><br /> Nota importante:</span><br /> Quando um muçulmano ouve que este assunto é Sunnah ou desejável, ele deve se apressar em fazê-lo e seguir o exemplo do Profeta, que a paz e as bênçãos de ALLAH estejam com ele.<br /> 3-<span class="c6"> Muharram:</span> como beber álcool, desobedecer aos pais e cortar laços de parentesco.<br /> - Muharram é recompensado quem o abandona e quem o faz é punido.<br /> 4-<span class="c6"> O Detestável:</span> como pegar e dar com a mão esquerda, enrolar a roupa durante a oração.<br /> -<span class="c6"> O Detestável:</span> é recompensado por deixá-lo, e quem o faz não é punido.<br /> 5-<span class="c6"> Permissível:</span> como comer uma maçã e tomar chá,<span class="c6"> e se chama:</span> Jáiz e Halal<br /> -<span class="c6"> O Mubáh:</span> nao é recompensado quem o abandona e nem é punido quem o pratica </p>',
            ],
            2 => [
                'question' => 'P3: Qual é a decisão sobre as transações?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16320.mp3',
                'answer' => '<p> R: O princípio básico em todas as vendas e transações é que elas são permitidas, exceto por alguns tipos de coisas que ALLAH Todo-Poderoso proibiu.<span class="c6"><br /> O Altíssimo diz:</span> <span class="c2">(ALLAH proíbe a Riba e consente o comércio)</span> Surat Al-<span class="c6">Bacara:</span> 275 </p>',
            ],
            3 => [
                'question' => 'Q4: Mencione alguns tipos de transações e vendas proibidas?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16360.mp3',
                'answer' => '<p> R-<br /> 1- Fraude,<span class="c6"> incluindo:</span> ocultar o defeito da mercadoria.<br /> Segundo Abu Hurairah, que ALLAH esteja satisfeito com ele, o Mensageiro de ALLAH, que ALLAH o abençoe e lhe dê paz, passou por Subra -<span class="c6"> isto é:</span> um monte de comida - e ele colocou a mão nele, e seus dedos ficaram molhados.<span class="c6"> Ele disse:</span> "O que é isso,<span class="c6"> ó dono da comida?" Ele disse:</span> O céu o atingiu, ó Mensageiro de ALLAH.<span class="c6"> Ele disse:</span> <span class="c1">“Porque não colocaste em cima para que as pessoas pudessem ver? Quem engana não faz parte dos meus.”</span> Narrado por Musslim.<br /> 2-<span class="c6"> Usura:</span> Inclui levar mil de um devedor e devolver a ele por dois mil.<br /> O aumento é usura proibida.<span class="c6"><br /> O Altíssimo diz:</span> <span class="c2">(ALLAH proíbe a Riba e consente o comércio)</span> Surat Al-<span class="c6">Bacara:</span> 275<br /> 3-<span class="c6"> Gharar e desconhecimento:</span> se eu te vender leite no úbere de uma ovelha, ou um peixe na água e ainda não o peguei.<span class="c6"><br /> No Hadith:</span> <span class="c2">(O Mensageiro de ALLAH, que a paz e as bênçãos estejam com ele, proibiu a venda de gharar)</span> Narrado por Musslim. </p>',
            ],
            4 => [
                'question' => 'Q5: Mencione algumas das bênçãos de ALLAH sobre você?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16460.mp3',
                'answer' => '<p> A - 1 - A bênção do Isslam, e que você não é do povo da incredulidade.<br /> 2- A benção da Sunnah, e que você não é do povo da heresia.<br /> 3- A bênção da saúde e bem-estar, da audição, visão, caminhada e outros.<br /> 4- A bênção de alimentos, bebidas e roupas.<br /> E as bênçãos de ALLAH Todo-Poderoso sobre nós são muitas e incalculáveis.<span class="c6"><br /> O Altíssimo diz:</span> E, se contais as graças de Allah, não podereis enumerá-las. Por certo, Allah é Perdoador, Misericordiador. As abelhas/18 </p>',
            ],
            5 => [
                'question' => 'Q6: Qual é o dever com as bênçãos? Como você agradece por elas?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16540.mp3',
                'answer' => '<p> R-<span class="c6"> O dever:</span> agradecer-lhe louvando a ALLAH e louvando-O com a língua e que só Ele tem o mérito, e usar essas bênçãos de uma forma que agrade a ALLAH Todo-Poderoso, não desobedecendo a Ele. </p>',
            ],
            6 => [
                'question' => 'Q 7: Quais são os dias festivais dos muçulmanos?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16570.mp3',
                'answer' => '<p> C- Eid al-Fitr e Eid al-Adha.<br /> - Como no Hadith de Anas,<span class="c6"> ele disse:</span> O Mensageiro de ALLAH ﷺ quando veio a Madinah eles tinham dois dias festivos e,<span class="c6"> ele disse:</span> <span class="c1">“O que são estes dias?”</span> Eles disseram: Costumávamos brincar nesses dias na Jahiliyyah, então o Mensageiro de ALLAH, que a paz e as bênçãos estejam com ele,<span class="c6"> disse:</span> <span class="c1">“ALLAH os trocou para vós com algo melhor do que eles: o dia de Al-Adha e o dia de Al-Fitr.”</span> Narrado por Abu Daud.<br /> E tudo o resto das festas faz parte da heresia </p>',
            ],
            7 => [
                'question' => 'P8: Quais são os melhores meses?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16620.mp3',
                'answer' => '<p> R:" Mês de Ramadhan." </p>',
            ],
            8 => [
                'question' => 'P8: Quais são os melhores dias?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16650.mp3',
                'answer' => '<p> R: Sexta-feira </p>',
            ],
            9 => [
                'question' => 'Q10: Qual é o melhor dia do ano?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16680.mp3',
                'answer' => '<p> R: O Dia de Árafah </p>',
            ],
            10 => [
                'question' => 'Q10: Qual é a melhor noite do ano?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16710.mp3',
                'answer' => '<p> R- Noite de Qadr </p>',
            ],
            11 => [
                'question' => 'Q12: Qual é o dever quando você vê uma mulher estranha?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16740.mp3',
                'answer' => '<p> R: É obrigatório baixar o olhar. O Todo-<span class="c6">Poderoso disse:</span> .<span class="c6"> Diz aos crentes que baixem seus olhares Noor:</span> 30 </p>',
            ],
            12 => [
                'question' => 'Q13: Quem são os inimigos do homem?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16770.mp3',
                'answer' => '<p> 1-<span class="c6"> A alma que ordena o mal:</span> isto é para uma pessoa seguir o que sua alma e desejos lhe ditam em desobediência a ALLAH, o Bendito e Altíssimo,<span class="c6"> disse:</span> Glória a Ele: Na verdade, a alma é uma persistente incitadora ao mal, à exceção de quem meu Senhor tiver misericórdia.<span class="c6"> Surat Yússuf:</span> 53 2-<span class="c6"> Satanás:</span> Ele é o inimigo do filho de Adão e seu objetivo é enganar o homem e sussurrar para ele sobre o mal e colocá-lo no Inferno.<span class="c6"> ALLAH diz:</span> E não sigais os passos de Shaytán; certamente ele é para vós um inimigo declarado Surat Al-<span class="c6">Bacara:</span> 168 3-<span class="c6"> Maus companheiros:</span> aqueles que incentivam o mal e impedem o bem.<span class="c6"> ALLAH diz:</span> Nesse dia, os amigos serão inimigos uns dos outros, exceto os piedosos.<span class="c6"> Zukhruf:</span> 67 </p>',
            ],
            13 => [
                'question' => 'P14: O que é Taubah?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16820.mp3',
                'answer' => '<p> R: Arrependimento é regresso da desobediência à ALLAH à Sua obediência.<span class="c6"> ALLAH diz:</span> "E, por certo, sou Perdoador de quem se volta arrependido e crê e faz o bem, em seguida, se guia.<span class="c6">" Surat Tahá:</span>82 </p>',
            ],
            14 => [
                'question' => 'Q 15: Quais são as condições para um arrependimento correcto?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16850.mp3',
                'answer' => '<p> C-1- Abandonar o pecado.<br /> 2- Arrependimento pelo que passou.<br /> 3- Determinado a não voltar a ele.<br /> 4- Restituição de direitos e agravos ao seu dono.<span class="c6"><br /> O Altíssimo diz:</span> E que, quando cometem obscenidade, ou são injustos com eles mesmos, lembram-se de Allah e imploram perdão de seus delitos e quem perdoa os delitos senão Allah? - e não se obstinam no que fizeram, enquanto sabem. Surat Al-<span class="c6">Imran:</span> 135 </p>',
            ],
            15 => [
                'question' => 'P: O que significa enviar saudação ao profeta?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16920.mp3',
                'answer' => '<p> C - Significa que você está clamando a ALLAH para louvar o Seu Profeta, que a paz e as bênçãos estejam com ele, no Altíssimo. </p>',
            ],
            16 => [
                'question' => 'Q 17: Qual é o significado de Subhanallah?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16950.mp3',
                'answer' => '<p> c- Glória a Ele, que é Sua exaltação, está acima de todas as faltas, defeitos e males. </p>',
            ],
            17 => [
                'question' => 'Q 18: Qual é o significado de Alhamdulillah?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16980.mp3',
                'answer' => '<p> c- É louvar a ALLAH, o Exaltado, e descrevê-lo com todos os atributos da perfeição. </p>',
            ],
            18 => [
                'question' => 'Q 19: Qual é o significado de Deus é maior?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/17000.mp3',
                'answer' => '<p> c- Ou seja, Glória a Ele, maior que tudo, maior, maior e mais Nobre que tudo. </p>',
            ],
            19 => [
                'question' => 'Q 20: Qual é o significado de não há poder ou força exceto com ALLAH?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/17030.mp3',
                'answer' => '<p> C -<span class="c6"> Seu significado:</span> o servo não se transforma de um estado para outro, e ele não tem poder sobre isso a não ser por Deus. </p>',
            ],
            20 => [
                'question' => 'Q 17: Qual é o significado de Asstagfirullah?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/17060.mp3',
                'answer' => '<p> C -<span class="c6"> Isto é:</span> o servo pediu ao seu Senhor que apagasse seus pecados e cobrisse suas faltas. </p>',
            ],
        ],
    ],
];
