<?php
$data = [
    'title' => 'What Muslim Children Must Know',
    'description' => 'A project that contains a simple and easy curriculum for issues that a Muslim must know. It includes issues of belief, jurisprudence, prophetic biography, etiquette, tafsir, hadith, morals, and remembrance of Allah. It is suitable for young children in particular, for all ages, and newcomers to Islam.',
    'source' => 'https://kids.islamenc.com/ro/home',
    'author' => 'Yazan Abdul Razzaq Raziq Alghanim',
    'sections' => [
        0 => 'Secțiunea - Credință',
        1 => 'Secțiunea - Jurisprudență',
        2 => 'Capitolul despre Biografia Profetului Mohammed (As-Sira An-Nabauia)',
        3 => 'Secțiunea de Tafsir (Interpretarea Sensurilor Coranului)',
        4 => 'Secțiunea de hadis (relatări profetice)',
        5 => 'Secțiunea - Maniere islamice',
        6 => 'Secțiunea - Atitudini și caracter',
        7 => 'Secțiunea - Rugi (du\'a) și pomeniri (dzikr)',
        8 => 'Secțiunea - Diverse',
    ],
    'data' => [
        1 => [
            0 => [
                'question' => 'Întrebarea nr. 1: Cine este Domnul tău?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/200.mp3',
                'answer' => '<p> Răspuns: Domnul meu este Allah, Cel care, prin binecuvântările Sale, este Suveran asupra mea și asupra tuturor lumilor.<span class="c6"><br /> Indiciul pentru aceasta este Cuvântul Celui Preaînalt:</span> „Slavă lui Allah, Domnul lumilor,” <span class="c5">[Coran,<span class="c6"> 1:</span>2]</span> </p>',
            ],
            1 => [
                'question' => 'Întrebarea nr. 2: Care este religia ta?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/240.mp3',
                'answer' => '<p> Răspuns: Religia mea este Islamul. Acesta reprezintă supunerea arătată față de Allah prin mărturisirea Unicității Sale și a ascultării poruncilor Sale și delăsarea de politeism și de cei care îl practică.<span class="c6"><br /> A spus Allah Preaînaltul:</span> Cu adevărat <span class="c5">[unica]</span> religie acceptată de Allah este Islamul <span class="c5">[Coran,<span class="c6"> 3:</span>19]</span> </p>',
            ],
            2 => [
                'question' => 'Întrebarea nr. 3: Cine este Profetul tău?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/280.mp3',
                'answer' => '<p> Răspuns: Mohammed <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span>.<span class="c6"><br /> A spus Allah Preaînaltul:</span> Mohammed este Trimisul lui Allah <span class="c5">[Coran,<span class="c6"> 48:</span>29]</span> </p>',
            ],
            3 => [
                'question' => 'Care este formula unicității (kalimat at-atuhid) și sensul acesteia?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/310.mp3',
                'answer' => '<p> Răspuns: Formula unicității <span class="c2">(kalimat at-atuhid)</span> este „La ilaha illah Allah” <span class="c2">(Nu există altă divinitate demnă de a fi adorată în afară de Allah)</span> și sensul acesteia este că nimeni și nimic în afară de Allah nu este îndreptățit pentru a fi adorat.<span class="c6"><br /> A spus Allah Preaînaltul:</span> Deci să știi <span class="c5">[Mohammed]</span> că nu există altă divinitate afară de Allah <span class="c5">[Coran,<span class="c6"> 47:</span>19]</span> </p>',
            ],
            4 => [
                'question' => 'Întrebarea nr. 5: Unde este Allah Cel Atotputernic?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/350.mp3',
                'answer' => '<p> Răspuns: Allah este deasupra Cerurilor, deasupra Tronului Său,<span class="c6"> mai presus de toate creațiile Sale:</span> Cel Milostiv care s-a înălțat deasupra Tronului <span class="c5">[Coran,<span class="c6"> 20:</span>5]</span> Și a spus: El este Al-Qahir <span class="c5">[Stăpânul Suprem]</span> peste robii Lui și El este Al-Hakim<br /> <span class="c5">[Înțeleptul]</span> <span class="c5">[și]</span> Al-Khabir <span class="c5">[Bine Știutorul]</span>. <span class="c5">[Coran,<span class="c6"> 6:</span>18]</span> </p>',
            ],
            5 => [
                'question' => 'Întrebarea nr. 6: Ce înseamnă mărturisirea că Mohammed este Mesagerul lui Allah?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/380.mp3',
                'answer' => '<p> Răspuns: Aceasta înseamnă că Allah l-a trimis pe el întregii lumi ca vestitor și prevenitor.<br /> Astfel,<br /> 1. trebuie să ascultăm de cele pe care el ni le-a poruncit<br /> 2. trebuie să credem în cele pe care el le-a vestit<br /> 3. trebuie să ne ferim de la a arăta neascultare față de el<br /> 4. Allah trebuie adorat doar în modalitatea în care El a prescris aceasta, prin urmarea Tradițiilor Profetice <span class="c2">(Sunnah)</span> și părăsirea inovațiilor fără temei în religie <span class="c2">(bid\'a)</span>.<span class="c6"><br /> A spus Allah Preaînaltul:</span> „Cel care i se supune Trimisului I se<br /> supune lui Allah” <span class="c5">[Coran,<span class="c6"> 4:</span>80]</span> și a spus, de asemenea,<span class="c6"> Preaslăvitul:</span> 3. Nici nu rostește nimic după pofta lui. <br /> 4. El <span class="c5">[Coranul]</span> nu este decât o revelație trimisă. <span class="c5">[Coran,<span class="c6"> 53:</span>3-4]</span> Și tot astfel a spus Allah Cel Preaputernic: Ați avut voi în Trimisul lui Allah un exemplu frumos, pentru cel care nădăjduiește în <span class="c5">[întâlnirea cu]</span> Allah și în Ziua de Apoi și Îl pomenește pe<br /> Allah mereu. <span class="c5">[Coran,<span class="c6"> 33:</span>21]</span> </p>',
            ],
            6 => [
                'question' => 'Întrebarea nr. 7: De ce am fost creați de Allah Preaînaltul?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/480.mp3',
                'answer' => '<p> Răspuns: Noi am fost creați pentru a-L adora numai pe El, Unicul, fără a-I face Lui niciun asociat.<br /> Și nu pentru a face din viață doar un prilej de joacă și desfătare.<span class="c6"><br /> A spus Preaînaltul:</span> Eu nu i-am creat pe djinni și oameni decât pentru ca ei să Mă adore <span class="c5">[Coran,<span class="c6"> 51:</span>56]</span> </p>',
            ],
            7 => [
                'question' => 'Întrebarea nr. 8: Ce este adorarea?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/530.mp3',
                'answer' => '<p> Răspuns: Adorarea este un concept care cuprinde tot ceea ce Îi este plăcut lui Allah și Îl mulțumește pe El, dintre vorbele și faptele ascunse sau vădite, interioare sau exterioare.<br /> Actele de adorare vădite, exterioare sunt precum pomenirea lui Allah prin cuvinte, preaslavindu-L, mulțumindu-I și preamărindu-L, Rugăciunea, Pelerinajul etc.<br /> Actele de adorare ascunse, interioare, sunt cele precum încrederea în Allah, teama și speranța pusă în El. </p>',
            ],
            8 => [
                'question' => 'Întrebarea nr. 9: Care este cea mai mare îndatorire a noastră?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/580.mp3',
                'answer' => '<p> Răspuns: Cea mai măreață și însemnată îndatorire a noastră este credința în Unicitatea lui Allah, Unicul - at-Tauhid. </p>',
            ],
            9 => [
                'question' => 'Întrebarea nr. 10: Care sunt tipurile de Tauhid?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/610.mp3',
                'answer' => '<p> Răspuns: 1. Tauhid ar-Rububia <span class="c2">(Unicitatea Suveranității)</span> - care reprezintă credința că Allah, Unicul, este Creatorul, Îndestulătorul, Stăpânul, Orânduitorul și El nu are niciun asociat întru aceasta.<br /> 2. Tauhid al-Uluhia <span class="c2">(Unicitatea Divinității)</span> - care reprezintă acordarea adorării numai lui Allah, Unicul, fără a adora pe nimeni altcineva împreună cu Allah Preaînaltul.<br /> 3. Tauhid al-Asma ua as-Sifaat <span class="c2">(Unicitatea Preafrumoaselor Sale Nume și Atribute)</span> - care reprezintă credința în Numele și Atributele lui Allah Preaînaltul care au fost menționate în Coran și în Sunnah <span class="c2">(Tradițiile Profetice)</span>, fără a reprezenta, asemăna sau nega vreuna dintre acestea.<span class="c6"><br /> Indiciul existenței acestor trei forme de Tauhid se regăsește în Cuvântul lui Allah Preaînaltul:</span> El este Stăpânul Cerurilor și al Pământului și al celor ce se află între<br /> cele două. Adoră-L pe El și fii statornic în adorarea Lui! Oare știi<br /> tu pe altcineva asemenea Lui?” <span class="c5">[Coran,<span class="c6"> 19:</span>65]</span> </p>',
            ],
            10 => [
                'question' => 'Întrebarea nr. 11: Care este cel mai mare păcat?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/670.mp3',
                'answer' => '<p> Răspuns: A-I face asociați lui Allah Preaînaltul.<span class="c6"><br /> A spus Allah Preaînaltul:</span> Cu adevărat, Allah nu iartă să I se facă asociați, dar iartă ce este mai<br /> puțin de atât oricui voiește. Iar cel care îi face asociați lui Allah, a făcut<br /> un mare păcat! <span class="c5">[Coran,<span class="c6"> 4:</span>48]</span> </p>',
            ],
            11 => [
                'question' => 'Întrebarea nr. 12: Ce este politeismul (aș-șirk) și care sunt formele și tipurile sale?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/710.mp3',
                'answer' => '<p> Răspuns: Aș-șirk este împlinirea unui act de adorare pentru altcineva în afară de Allah Preaînaltul.<span class="c6"><br /> Tipurile de șirk:</span><br /> Șirk-ul major - precum a face rugi la altcineva în afară de Allah Preaînaltul, a se prosterna altcuiva în afară de Allah Preaslăvitul sau a sacrifica animale în numele altcuiva decât în numele lui Allah Cel Atotputernic.<br /> Șirk-ul minor - precum a jura pe altcineva în afară de Allah Preaînaltul, folosirea amuletelor care sunt atârnate cu intenția de a atrage binele și a respinge ceea ce este rău, sau ipocrizia în actele de adorare realizate, cum ar fi, spre exemplu, îmbunătățirea sau înfrumusețarea de către cineva a modalității de efectuare a Rugăciunii atunci când știe că este văzut de către oameni. </p>',
            ],
            12 => [
                'question' => 'Întrebarea nr. 13: Cunoaște altcineva necunoscutul în afară de Allah?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/770.mp3',
                'answer' => '<p> Răspunsul: Nimeni altcineva în afară de Allah nu știe ceea ce se află în lumea nevăzută, a necunoscutului.<span class="c6"><br /> A spus Preaînaltul:</span> Cu adevărat, Allah nu iartă să I se facă asociați, dar iartă ce este mai<br /> puțin de atât oricui voiește. Iar cel care îi face asociați lui Allah, a făcut<br /> un mare păcat! <span class="c5">[Coran,<span class="c6"> 27:</span>65]</span> </p>',
            ],
            13 => [
                'question' => 'Întrebarea nr. 14: Care sunt Stâlpii credinței islamice?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/810.mp3',
                'answer' => '<p> 1. Credința în Allah Preaînaltul<br /> 2. Și în Îngerii Săi<br /> 3. În Scripturile Sale<br /> 4. În Profeții Săi<br /> 5. În Ziua de Apoi<br /> 6 - Și în destin, cu ceea ce este bun și rău în el.<br /> Evidența pentru aceasta este binecunoscutul hadis în care apare Îngerul Gavriil și care a fost relatat de Muslim. Gavriil i-a spus Profetului <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span>: „Spune-mi,<span class="c6"> ce este credința?” Profetul a spus:</span> „<span class="c2">(Credința este)</span> crezul în Allah, în Îngerii Săi, în Scripturile Sale, în Profeții Săi, în Ziua de Apoi și în Destin, cu ceea ce este bun și rău în el.” </p>',
            ],
            14 => [
                'question' => 'Întrebarea nr. 15: Cum se pot explica Stâlpii credinței?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/900.mp3',
                'answer' => '<p> Răspuns: Credința în Allah Preaînaltul înseamnă să crezi că:<br /> - Allah este Cel care te-a creat și îți oferă cele necesare traiului. El este Unicul Stăpân și Orânduitor al tuturor creațiilor.<br /> - El este Unicul Adorat și nimic nu poate fi adorat întru dreptate în afară de El.<br /> - El este Cel mai presus de toate, Cel Preamăreț și Preaperfect. A Lui este toată Slava și Lauda și El are cele mai frumoase Nume și cele mai înalte Atribute. El, Preaslăvitul, nu are pe nimeni egal sau asemenea Lui.<span class="c6"><br /> Credința în Îngeri:</span><br /> Aceștia sunt făpturi pe care Allah le-a creat din lumină, pentru a-L adora pe El și pentru a se supune pe deplin poruncilor Sale.<br /> Dintre ei face parte și Gavriil <span class="c2">(Pacea fie asupra sa)</span>, care are sarcina de a le aduce Profeților revelația <span class="c2">(trimisă de Allah)</span>.<span class="c6"><br /> Credința în Scripturi:</span><br /> Acestea sunt Cărțile Sfinte pe care Allah le-a pogorât Profeților Săi,<span class="c6"> precum:</span><br /> - Coranul revelat lui Mohammed <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span><br /> - al-Injil <span class="c2">(Evanghelia)</span> pogorâtă lui Iisus <span class="c2">(Pacea fie asupra sa)</span><br /> - Tora revelată lui Moise <span class="c2">(Pacea fie asupra sa)</span>.<br /> - Psalmii dați lui David <span class="c2">(Pacea fie asupra sa)</span>.<br /> - Filele <span class="c2">(foile)</span> date lui Avraam și lui Moise <span class="c2">(Pacea fie asupra lor)</span>.<span class="c6"><br /> Credința în Profeți:</span><br /> Ei sunt cei pe care Allah i-a trimis robilor Săi pentru a-i învăța pe aceștia religia lor, pentru a le vesti Paradisul și tot ceea ce este bun și pentru a-i avertiza în legătură cu ceea ce este rău și în privința Iadului.<span class="c6"><br /> Cei mai de seamă dintre aceștia sunt și cei mai statornici dintre ei în urmarea Legii lui Allah:</span><br /> Noe <span class="c2">(Pacea fie asupra sa)</span><br /> Avraam <span class="c2">(Pacea fie asupra sa)</span><br /> Moise <span class="c2">(Pacea fie asupra sa)</span><br /> Iisus <span class="c2">(Pacea fie asupra sa)</span><br /> Mohammed <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span>.<span class="c6"><br /> Credința în Ziua de Apoi:</span><br /> Aceasta presupune credința în existența, după moarte, a unei perioade de tranziție între mormânt și Ziua Judecății <span class="c2">(Ziua Învierii și a Socotelii)</span>, atunci când oamenii Raiului vor primi lăcașurile lor, iar oamenilor Iadului, de asemenea, le vor fi date locurile lor.<br /> Credința în Destin,<span class="c6"> cu ceea ce este bun și rău în el:</span><br /> Destinul presupune credința că Allah știe tot ceea ce se petrece în Univers. El a înscris aceasta în Tablele cele bine păstrate <span class="c2">(al-Lauh al-mahfudz)</span> și prin Voia Sa tot ceea ce există a fost adus în ființare și a fost creat.<span class="c6"><br /> A spus Preaînaltul:</span> „Și Noi am creat toate lucrurile bine întocmite” <span class="c5">[Coran,<span class="c6"> 54:</span>49]</span>.<span class="c6"><br /> Credința în Destin presupune 4 niveluri:</span><br /> Primul: Știința lui Allah Preaînaltul, care presupune că Știința Sa precede totul și ea a existat dintotdeauna, înainte ca lucrurile să se întâmple și după ce s-au petrecut.<span class="c6"><br /> Dovada pentru aceasta este Cuvântul lui Allah Preaînaltul:</span> Numai la Allah se află cunoașterea Ceasului. El face să coboare ploaia<br /> îmbelșugată și El știe ce se află în pântece. Niciun suflet nu știe ce va<br /> dobândi mâine și niciun suflet nu știe în care <span class="c5">[loc de pe]</span> pământ va<br /> muri. Allah este ‘Alim <span class="c5">[Atoateștiutor]</span> <span class="c5">[și]</span> Khabir <span class="c5">[Bineștiutor]</span>. <span class="c5">[Coran,<span class="c6"> 31:</span> 34]</span><br /> Al doilea: Faptul că Allah a înscris aceasta în Tablele cele bine păstrate <span class="c2">(al-Lauh al-Mahfudz)</span> și astfel, tot ceea ce s-a petrecut sau se va petrece este înscris în această Carte la El.<span class="c6"><br /> Evidența pentru aceasta este Cuvântul lui Allah Preaînaltul:</span> Și la El sunt cheile necunoscutului și nu le știe decât El. Și El cunoaște<br /> ceea ce este pe uscat și ceea ce este pe mare. Nu cade nicio frunză fără<br /> ca El să o știe. Și nu există bob în întunecimile pământului, nimic<br /> proaspăt și nimic uscat, fără ca ele să fie <span class="c5">[însemnate]</span> într-o Carte<br /> Limpede. <span class="c5">[Coran,<span class="c6"> 6:</span>59]</span><br /> Al treilea: Faptul că totul se produce prin Voia lui Allah și nimic din ceea ce El sau vreuna dintre creațiile Sale fac nu se întâmplă decât prin Voia Sa, Preaînaltul.<span class="c6"><br /> Dovada pentru aceasta este Cuvântul Preaînaltului:</span> 28. Pentru acela dintre voi care voiește să meargă pe drumul cel drept.<br /> 29. Dar voi nu puteți voi decât dacă voiește Allah, Stăpânul lumilor. <span class="c5">[Coran,<span class="c6"> 81:</span>28-29]</span><br /> Al patrulea: Credința în faptul că tot ceea ce există a fost creat de către Allah. El a creat înfățișarea, caracteristicile lor, mișcarea lor și tot ce le este specific.<span class="c6"><br /> Dovada pentru aceasta este Cuvântul lui Allah Preaînaltul:</span> În vreme ce Allah v-a creat pe voi, precum și ceea ce faceți voi? <span class="c5">[Coran,<span class="c6"> 37:</span>96]</span> </p>',
            ],
            15 => [
                'question' => 'Întrebarea nr. 16: Care este definiția Coranului?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1300.mp3',
                'answer' => '<p> Răspuns: El este Cuvântul lui Allah și nu este o creație a Lui.<span class="c6"><br /> A spus Allah Preaînaltul:</span> Și dacă vreunul dintre idolatri te roagă să-i dai adăpost, atunci dă-i<br /> lui adăpost, pentru ca el să audă cuvintele lui Allah <span class="c5">[Coranul]</span>... <span class="c5">[Coran,<span class="c6"> 9:</span>6]</span> </p>',
            ],
            16 => [
                'question' => 'Întrebarea nr. 17: Ce este Sunnah (Tradiția Profetică)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1330.mp3',
                'answer' => '<p> Răspuns: Ea reprezintă toate vorbele, faptele, aprecierile și calitățile fizice sau morale aparținând Profetului <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span>. </p>',
            ],
            17 => [
                'question' => 'Întrebarea nr. 18: Ce este inovația în religie (bid\'a)? Este permis să acceptăm aceste inovații?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1350.mp3',
                'answer' => '<p> Răspuns: Aceasta reprezintă tot ceea ce oamenii au introdus în religie, fără ca aceasta să fi existat în vremea Profetului <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> și în timpul Companionilor săi.<br /> * Aceasta nu trebuie acceptată, ci, dimpotrivă, ea trebuie respinsă.<br /> Conform spuselor Profetului <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span>: Fiecare inovație este o rătăcire. Consemnat de Abu Daud.<span class="c6"><br /> Exemple de bid\'a pot fi întâlnite în:</span> adăugiri în anumite acte de adorare, cum ar fi spre exemplu adăugarea la abluțiune a spălării de patru ori <span class="c2">(în loc de trei, așa cum este Sunnah)</span> sau sărbătorirea zilei de naștere a Profetului, chestiuni care nu au fost consemnate a fi fost practicate de către Profet <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> sau de către Companionii săi. </p>',
            ],
            18 => [
                'question' => 'Întrebarea nr. 19: Menționează ce reprezintă conceptul (doctrina) loialității (alianței - „al-uala\'a”), precum și cea a disocierii (și respingerii - „al-bara\'a”)',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1410.mp3',
                'answer' => '<p> Loialitatea <span class="c2">(alianța - „al-uala\'a”)</span> reprezintă dragostea arătată față de musulmani și suportul oferit acestora.<span class="c6"><br /> A spus Allah Preaînaltul:</span> Dreptcredincioșii și dreptcredincioasele își sunt aliați unii altora. <span class="c5">[Coran,<span class="c6"> 9:</span>71]</span><br /> Disocierea <span class="c2">(și respingerea - „al-bara\'a”)</span> presupune ura și ostilitatea arătată față de necredincioșii <span class="c2">(care luptă împotriva Islamului)</span>.<span class="c6"><br /> A spus Allah Preaînaltul:</span> Ați avut voi un exemplu frumos în Avraam și în cei care au fost alături<br /> de el,<span class="c6"> atunci când ei au spus către neamul lor:</span> „Cu adevărat, noi ne<br /> lepădăm de voi și de cele pe care voi le venerați în locul lui Allah. Ne<br /> lepădăm de voi. Dușmănia și vrajba s-au ivit între noi pentru totdeauna,<br /> până când voi veți crede numai în Unicul Allah!” <span class="c5">[Coran,<span class="c6"> 60:</span>4]</span> </p>',
            ],
            19 => [
                'question' => 'Întrebarea nr. 20: Există altă religie acceptată de către Allah în afară de Islam?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1480.mp3',
                'answer' => '<p> Răspuns: Allah nu acceptă nicio altă religie în afară de Islam.<span class="c6"><br /> A spus Allah Preaînaltul:</span> Acela care își dorește altă religie decât Islamul, nu-i va fi acceptată, și el se va afla în Lumea de Apoi printre cei pierduți. <span class="c5">[Coran,<span class="c6"> 3:</span>85]</span> </p>',
            ],
            20 => [
                'question' => 'Întrebarea nr. 21: „Al-Kufr” (necredința) se expimă în vorbe, fapte și credințe. Dă-mi un exemplu pentru aceasta.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1520.mp3',
                'answer' => '<p> Răspuns: Exemplu pentru exprimarea necredinței prin vorbe sunt înjurăturile îndreptate la adresa lui Allah Preaslăvitul și a Mesagerului Său <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span>.<br /> Exemplu pentru exprimarea necredinței prin fapte poate fi un comportament înjositor față de Coran și prosternarea în semn de adorare pentru altcineva în afară de Allah Preaînaltul.<br /> Exemplu pentru exprimarea „al-Kufr” în credințe este considerarea faptului că există altcineva demn de a fi adorat în afară de Allah și că mai există și un alt creator împreună cu Allah. </p>',
            ],
            21 => [
                'question' => 'Întrebarea nr. 22: Ce este ipocrizia și care sunt formele ei?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1570.mp3',
                'answer' => '<p> Răspuns:<br /> 1 - Ipocrizia majoră, care presupune ascunderea în inimă a necredinței, în vreme ce omul se înfățișează ca fiind un dreptcredincios.<br /> Aceasta îl scoate din Islam pe cel care îi dă curs și este considerat un act de necredință majoră.<span class="c6"><br /> A spus Preaînaltul:</span> Cu adevărat, ipocriții vor ajunge în fundul cel mai de jos al Iadului și nu<br /> vei afla niciodată ajutor pentru ei, <span class="c5">[Coran,<span class="c6"> 4:</span>145]</span><br /> 2 - Ipocrizia minoră<br /> Precum minciuna, încălcarea promisiunii date și trădarea încrederii acordate.<br /> Aceasta nu îl scoate pe om din Islam, însă este considerat un păcat, iar cel care îi dă curs este supus pedepsei.<br /> Mesagerul lui Allah <span class="c2">(Pacea și binecuvântarea lui Alalh fie asupra sa)</span> a spus: „Semnele ipocritului sunt trei: când vorbește minte, când promite își încalcă promisiunea, când ceva este pus în grija lui și i se acordă încredere, o trădează.” <span class="c2">(Consemnat de Bukhari și Muslim)</span>. </p>',
            ],
            22 => [
                'question' => 'Întrebarea 23: Cine este încheietorul Profeților și al Mesagerilor?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1680.mp3',
                'answer' => '<p> Răspuns: Acesta este Mohammed <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span>.<span class="c6"><br /> A spus Allah Preaînaltul:</span> Mohammed nu este tată nici unuia dintre bărbații voștri, ci el este<br /> Trimisul lui Allah și încheietorul Profeților... <span class="c5">[Coran,<span class="c6"> 33:</span>40]</span> Și a spus Trimisul lui Allah <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span>: „Eu sunt încheietorul Profeților și niciun Profet nu va mai veni după mine.” Consemnat de Abu Daud, Tirmidhi și alții. </p>',
            ],
            23 => [
                'question' => 'Întrebarea nr. 24: Ce este un miracol?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1730.mp3',
                'answer' => '<p> Răspuns: Miracolele reprezintă toate aspectele care transgresează granițele normalității, și pe care Allah le-a dat Profeților Săi - o dovadă a sincerității misiunii lor profetice.<span class="c6"> Dintre acestea putem aminti:</span><br /> - Despicarea Lunii de către Profet <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span><br /> - Despicarea mării pentru Moise <span class="c2">(Pacea fie asupra sa)</span> și înnecarea lui Faraon și a armatei sale </p>',
            ],
            24 => [
                'question' => 'Întrebarea nr. 25: Cine sunt Companionii Profetului (as-Sahaba)? Trebuie să îi iubim?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1780.mp3',
                'answer' => '<p> Răspuns: Companionul Profetului <span class="c2">(as-Sahabiy)</span> este acea persoană care a trăit în timpul Profetului <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span>, care a crezut în el și care a murit musulman.<br /> Noi îi iubim și îi urmăm. Ei sunt cei mai buni dintre oameni, după Profeți.<br /> Cei mai buni dintre as-<span class="c6">Sahaba sunt Califii cei bine călăuziți:</span><br /> Abu Bakr <span class="c2">(Allah să fie mulțumit de el)</span>.<br /> Omar <span class="c2">(Allah să fie mulțumit de el)</span>.<br /> Othman <span class="c2">(Allah să fie mulțumit de el)</span>.<br /> Ali <span class="c2">(Allah să fie mulțumit de el)</span>. </p>',
            ],
            25 => [
                'question' => 'Întrebarea nr. 26: Cine sunt „Mamele dreptcredincioșilor”?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1870.mp3',
                'answer' => '<p> Răspuns: Ele sunt soțiile Profetului <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span>.<span class="c6"><br /> A spus Allah Preaînaltul:</span> Profetul este mai apropiat față de dreptcredincioși decât își sunt ei<br /> înșiși, iar soțiile sale sunt mamele lor. <span class="c5">[Coran,<span class="c6"> 33:</span>6]</span> </p>',
            ],
            26 => [
                'question' => 'Întrebarea nr. 27: Care este obligația noastră față de „ahlu al-bait” (familia Profetului - Pacea și binecuvântarea lui Allah fie asupra sa)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1910.mp3',
                'answer' => '<p> Noi îi iubim și îi susținem și suntem împotriva celor care îi urăsc. Cu toate acestea, noi nu îi ridicăm mai presus de statutul lor. Din „ahlu al-bait” fac parte soțiile Profetului și urmașii săi, precum și descendenții dreptcredincioși din neamul Hașim și al-Muttalib. </p>',
            ],
            27 => [
                'question' => 'Întrebarea nr. 28: Care este obligația noastră față de Conducătorii musulmanilor?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1940.mp3',
                'answer' => '<p> Răspuns: Obligația noastră este aceea de a-i respecta, a-i asculta și de a ne supune lor, atâta vreme cât ei nu cheamă la ceea ce este interzis în religie. Nu ne este permis să ne răzvrătim împotriva lor, ci trebuie să facem rugi la Allah pentru ei și să îi sfătuim cu bunătate. </p>',
            ],
            28 => [
                'question' => 'Întrebarea nr. 29: Care este Casa (sălașul) dreptcredincioșilor („dar al-mu\'minin”)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1970.mp3',
                'answer' => '<p> Răspuns: Aceasta este Paradisul.<span class="c6"> A spus Allah Preaînaltul:</span> Cu adevărat, Allah îi duce pe cei care cred și săvârșesc fapte bune în<br /> grădini pe sub care curg râuri <span class="c5">[Coran,<span class="c6"> 47:</span>12]</span> </p>',
            ],
            29 => [
                'question' => 'Întrebarea nr. 30: Care este Casa (sălașul) necredincioșilor („dar al-kafirin”)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2000.mp3',
                'answer' => '<p> Răspuns: Aceasta este focul Iadului.<span class="c6"> A spus Allah Preaînaltul:</span> ... atunci feriți-vă de Focul care mistuie oamenii și pietrele,<br /> pregătit pentru necredincioși! <span class="c5">[Coran,<span class="c6"> 2:</span>24]</span> </p>',
            ],
            30 => [
                'question' => 'Întrebarea nr. 31: Ce este teama față de Allah („al-khauf”)? Ce este speranța pusă în Allah („ar-raja\'a”)? Care este evidența pentru acestea?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2020.mp3',
                'answer' => '<p> Răspuns: „Al-khauf” reprezintă teama față de Allah și de pedeapsa Sa.<br /> „Ar-raja\'a” reprezintă speranța la răsplata oferită de către Allah, la iertarea și Îndurarea Sa.<span class="c6"><br /> Evidența pentru aceasta este Cuvântul lui Allah Preaînaltul:</span> Cei pe care îi cheamă ei caută și ei mijlocul <span class="c5">[care să-i conducă pe ei]</span><br /> cât mai aproape de Domnul lor, nădăjduiesc în îndurarea Sa și se<br /> tem de pedeapsa Lui. Cu adevărat, pedeapsa Domnului tău este cu<br /> adevărat de temut <span class="c5">[Coran,<span class="c6"> 17:</span>57]</span> Și a spus Allah Preaînaltul: 49. <span class="c5">[O, Mohammed]</span> vestește-le robilor Mei că Eu sunt Al-Ghafur<br /> <span class="c5">[Iertătorul]</span>, Ar-Rahim <span class="c5">[Îndurătorul]</span>.<br /> 50. Și că aceasta este pedeapsa Mea care este un chin dureros. <span class="c5">[Coran,<span class="c6"> 15:</span>49-50]</span> </p>',
            ],
            31 => [
                'question' => 'Întrebarea nr. 32: Menționează câteva dintre Numele și Atributele lui Allah Preaînaltul:',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2070.mp3',
                'answer' => '<p> Răspuns: Acestea sunt: Allah, Ar-Rabb <span class="c2">(Domnul, Stăpânul)</span>, Ar-Rahman <span class="c2">(Cel Milostiv)</span>, As-Sami\' <span class="c2">(Cel care aude totul)</span>, Al-Basir <span class="c2">(Cel care vede totul)</span>, Al-\'Alim <span class="c2">(Cel care știe totul)</span>, Ar-Razzaq <span class="c2">(Îndestulătorul, Cel care oferă cele necesare traiului)</span>, Al-Hayy <span class="c2">(Cel Viu)</span>, Al-Adhim <span class="c2">(Cel Preamăreț)</span>, precum și altele dintre Preafrumoasele Sale Nume și Atribute Mărețe. </p>',
            ],
            32 => [
                'question' => 'Întrebarea nr. 33: Explică semnificația acestor Nume ale lui Allah.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2100.mp3',
                'answer' => '<p> Răspuns: Allah are sensul de Dumnezeu, Cel adorat întru dreptate, Unicul, Care nu are pe nimeni asociat.<br /> Ar-Rabb are sensul că numai Allah Preaslăvitul, Unicul este Creatorul, Stăpânitorul, Îndestulătorul și Orânduitorul a tot și a toate.<br /> As-Sami\' înseamnă că Allah cuprinde totul cu Auzul Său și El aude toate sunetele, în pofida varietății și diversității acestora.<br /> Al-Basir este Cel care cuprinde totul cu privirea Sa și El vede totul, indiferent cât de mare sau mic ar fi acel lucru.<br /> Al-Alim este Cel care cuprinde cu știința Sa totul din trecut, prezent sau viitor.<br /> Ar-Rahman este Cel care a cuprins cu Îndurarea Sa fiece ființă, toți supușii Săi și toate creațiile Sale aflându-se sub Îndurarea Sa.<br /> Ar-<span class="c6">Razzaq este Cel care oferă cele necesare traiului tururor creațiilor:</span> oameni, djini și animale.<br /> Al-Hayy este Cel care nu moare nicodată, în vreme ce toată creația Sa este muritoare.<br /> Al-Adhim este Cel care deține toate atributele perfecțiunii în Numele, Atributele și acțiunile Sale. </p>',
            ],
            33 => [
                'question' => 'Întrebarea nr. 34: Care este obligația noastră față de învățații musulmani?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2210.mp3',
                'answer' => '<p> Răspuns: Noi îi iubim pe aceștia și îi consultăm în chestiuni și probleme legate de jurisprudența islamică. Ei trebuie menționați doar într-o modalitate plăcută, iar cel care nu respectă aceste aspecte a deviat de la calea cea dreaptă.<span class="c6"><br /> Allah Preaînaltul a spus:</span> Allah îi va ridica cu <span class="c5">[câteva]</span> trepte pe aceia care cred dintre voi și<br /> pe aceia cărora li s-a dat știința, căci Allah este bine știutor a ceea ce<br /> faceți! <span class="c5">[Coran,<span class="c6"> 58:</span>11]</span> </p>',
            ],
            34 => [
                'question' => 'Întrebarea nr. 35: Cine sunt „\'aulia\'a Allah” (aliații lui Allah) Preaînaltul?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2240.mp3',
                'answer' => '<p> Răspuns: Ei sunt dreptcredincioșii pioși.<span class="c6"><br /> A spus Allah Preaînaltul:</span> 62. Cu adevărat, aliații lui Allah nu au motive să se teamă și nici nu vor fi<br /> mâhniți -<br /> 63. Cei care cred și care au frică de Allah. <span class="c5">[Coran,<span class="c6"> 10:</span>62-63]</span> </p>',
            ],
            35 => [
                'question' => 'Întrebarea nr. 36: Credința („al-iman”) se exprimă în vorbe, dar și fapte?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2280.mp3',
                'answer' => '<p> Răspuns: Credința se exprimă în vorbe, fapte și principii de credință. </p>',
            ],
            36 => [
                'question' => 'Întrebarea nr. 37: Credința poate crește și scădea?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2310.mp3',
                'answer' => '<p> Răspuns: Credința crește prin supunerea arătată față de Allah și scade prin neascultarea arătată față de El.<span class="c6"><br /> A spus Allah Preaînaltul:</span> Credincioșii sunt doar cei ale căror inimi se cutremură când se<br /> pomenește <span class="c5">[numele lui]</span> Allah și a căror credință sporește când li se<br /> citesc versetele Lui și se încred în Domnul Lor - <span class="c5">[Coran,<span class="c6"> 8:</span>2]</span> </p>',
            ],
            37 => [
                'question' => 'Întrebarea nr. 38: Ce este „al-ihsan” (perfecțiunea, perfecționarea)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2350.mp3',
                'answer' => '<p> Răspuns: „Al-ihsan” înseamnă să Îl adori pe Allah ca și cum L-ai vedea, căci, deși tu nu Îl vezi, cu siguranță El te vede pe tine. </p>',
            ],
            38 => [
                'question' => 'Întrebarea nr. 39: Care sunt condițiile pentru ca faptele să fie acceptate de către Allah Preaslăvitul?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2370.mp3',
                'answer' => '<p> Răspuns: Există două condiții:<br /> 1 - să fie devotate în mod sincer lui Allah Preaînaltul<br /> 2 - să urmeze prescripțiile existente în Sunnah <span class="c2">(Tradițiile Profetului - Pacea și binecuvântarea lui Allah fie asupra sa)</span> </p>',
            ],
            39 => [
                'question' => 'Întrebarea nr. 40: Ce este „at-Tauakul” (punerea încrederii) în Allah Preaînaltul?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2420.mp3',
                'answer' => '<p> Răspuns: Acesta reprezintă a-și pune încrederea și a se baza pe Allah <br /> Preaînaltul în sensul atragerii a ceea ce este bun și respingerii a ceea ce este rău, în condițiile în care omul trebuie să ia în considerare toți factorii care îi pot favoriza succesul și să dea curs acestora.<span class="c6"><br /> A spus Allah Preaînaltul:</span> Iar celui care se încrede în Allah, El îi este de ajuns <span class="c5">[Coran,<span class="c6"> 65:</span>3]</span><br /> <span class="c2">(îi este de ajuns)</span>, adică îi este suficient </p>',
            ],
            40 => [
                'question' => 'Întrebarea nr. 41: Ce presupune obligația de a îndemna la ceea ce este bun („al-\'amr bi-l-ma\'aruf") și de a opri de la ceea ce este rău („an-nahy \'an al-munkar”)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2470.mp3',
                'answer' => '<p> Răspuns: „Al-ma\'aruf” <span class="c2">(binele)</span> - este îndemnarea la tot ceea ce presupune supunerea față de Allah Cel Atotputernic, iar „al-munkar” sunt toate cele de la care trebuie să te oprești, pentru că ele reprezintă o formă de nesupunere față de Allah Preaînaltul.<span class="c6"><br /> A spus Allah Preaînaltul:</span> Sunteți cea mai bună comunitate care s-a făcut <span class="c5">[drept exemplu]</span><br /> pentru oameni. Voi porunciți ceea ce este drept și interziceți ceea ce<br /> este nedrept și credeți în Allah. <span class="c5">[Coran,<span class="c6"> 3:</span>110]</span> </p>',
            ],
            41 => [
                'question' => 'Întrebarea nr. 42: Cine este „ahlu as-Sunnaa ua al-Jama\'a” (neamul Tradițiilor profetice și al consensului întru acestea) ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2510.mp3',
                'answer' => '<p> Răspuns: Ei sunt cei care au urmat vorbele, faptele și credințele ce aparțineau Profetului <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> și Companionilor săi.<br /> Ei s-au numit „ahlu as-Sunna” pentru că ei urmează Sunnah Profetului <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> și se delasă de orice inovație fără temei în religie <span class="c2">(bid\'a)</span>;<br /> și „al-Jama\'a” pentru că ei sunt în acord unanim în urmarea religiei adevărate și nu se scindează în privința acesteia. </p>',
            ],
        ],
        2 => [
            0 => [
                'question' => 'Întrebarea nr. 1: Definește „tahara” (starea de puritate).',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2580.mp3',
                'answer' => '<p> Răspuns: „Tahara” este anularea stării de impuritate și îndepărtarea murdăriei.<br /> Purificarea prin îndepărtarea murdăriei presupune faptul că musulmanul îndepărtează murdăria <span class="c2">(„najasa”)</span> aflată pe corpul și hainele lui sau în locul în care dorește să îndeplinească rugăciunea.<br /> Purificarea prin anularea stării de impuritate se produce prin realizarea abluțiunii <span class="c2">(„udu\'u”)</span> sau a îmbăierii generale <span class="c2">(„ghusl”)</span> cu apă curată, pură, sau prin purificarea uscată în cazul celor care nu găsesc apă sau nu o pot folosi. </p>',
            ],
            1 => [
                'question' => 'Întrebarea nr. 2: Cum se purifică cel care este atins de o murdărie spurcată (najasa)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2630.mp3',
                'answer' => '<p> Răspuns: Prin spălarea cu apă, până ce este curat <span class="c2">(pur)</span>.<br /> Cât despre lucrul lins de câine, acesta trebuie spălat de șapte ori, prima oară folosind pământ curat. </p>',
            ],
            2 => [
                'question' => 'Întrebarea nr. 3: Care sunt virtuțile abluțiunii?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2660.mp3',
                'answer' => '<p> Răspuns: Profetul <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> a spus: „Dacă robul musulman” sau „dreptcredinciosul” a făcut abluțiunea „și și-a spălat fața, toate păcatele săvârșite cu ochii săi au fost spălate de pe fața sa împreună cu apa" - sau „odată cu ultima picătură de apă...". „Și dacă și-a spălat mâinile, toate păcatele săvârșite cu acestea au fost spălate împreună cu apa" - sau „odată cu ultima picătură de apă...". „Și dacă și-a spălat picioarele, toate păcatele înspre care picioarele sale au pășit au fost spălate împreună cu apa" - sau „odată cu ultima picătură de apă...", până ce el devine pur și curățit de păcate". <span class="c2">(Consemnat de Muslim)</span> </p>',
            ],
            3 => [
                'question' => 'Întrebarea nr. 4: Cum fac abluțiunea?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2690.mp3',
                'answer' => '<p> Răspuns: Se spală mâinile de trei ori.<br /> Se clătește gura, se trage apă pe nas și se suflă nasul de trei ori.<br /> Clătirea gurii presupune ca apa să fie introdusă în gură și apoi eliminată.<span class="c6"><br /> Tragerea apei pe nas:</span> presupune faptul că apa este adusă cu mâna dreaptă și inhalată în interiorul nasului.<span class="c6"><br /> Suflarea nasului:</span> presupune eliminarea apei din nas cu mâna stângă, după inhalare.<br /> Apoi spălarea feței de trei ori.<br /> După care urmează spălarea de trei ori a mâinilor până la coate, inclusiv.<br /> Apoi capul este șters cu mâinile, din față spre spate și înapoi, așa cum și urechile sunt șterse <span class="c2">(cu vârful degetelor)</span>.<br /> După aceea se spală picioarele până la glezne de trei ori.<br /> Aceasta este modalitatea completă de realizare a abluținii, confirmată de comportamentul Profetului <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> în hadisuri consemnate de Bukhari și Muslim și relatate de Uthman și Abdullah ibn Zaid <span class="c2">(Allah să aibă milă de ei)</span>. De asemenea, în Bukhari, precum și în alți naratori de hadisuri, s-<span class="c6">a confirmat că:</span> „<span class="c2">(Profetul - pacea și binecuvântarea lui Allah fie asupra sa)</span> făcea abluțiunea una câte una, dar și două câte două.”, însemnând că spăla fiecare parte a corpului care trebuie spălată în timpul abluțiunii o singură dată sau de două ori. </p>',
            ],
            4 => [
                'question' => 'Întrebarea nr. 5: Care sunt acțiunile obligatorii (fard) în efectuarea abluțiunii și numărul lor?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2810.mp3',
                'answer' => '<p> Răspuns: Acestea sunt acele acțiuni care, dacă au fost omise de către un musulman,<span class="c6"> abluțiunea lui nu este considerată validă:</span><br /> 1 - spălarea feței, incluzând clătirea gurii și spălarea și suflarea nasului.<br /> 2 - spălarea mâinilor până la coate, inclusiv.<br /> 3 - ștergerea capului și a urechilor.<br /> 4 - spălarea picioarelor până la glezne.<br /> 5 - respectarea ordinii spălării sau ștergerii, după caz, a părților corpului - fața, mâinile, capul, picioarele.<br /> 6 - continuitatea - abluțiunea se realizează în mod continuu, fără a se lăsa un timp în care părțile corpului spălate să apuce să se usuce între o acțiune și alta.<br /> - cum ar fi, spre exemplu, situația cuiva care îndeplinește jumătate de abluțiune, iar după un timp îndeplinește cealaltă jumătate. Aceasta nu este considerată o abluțiune validă. </p>',
            ],
            5 => [
                'question' => 'Întrebarea nr. 6: Care sunt acțiunile voluntare și preferabile (sunnah) în abluțiune și care este numărul lor?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2910.mp3',
                'answer' => '<p> Răspuns: Acțiunile voluntare și preferabile <span class="c2">(sunnah)</span> în abluțiune reprezintă acele acțiuni care, dacă sunt împlinite, aduc un plus de recompensă și răsplată, iar dacă nu sunt îndeplinite, nu aduc păcate.<span class="c6"> Acestea sunt:</span><br /> 1 - Rostirea formulei „Bismillah” <span class="c2">(În numele lui Allah)</span>.<br /> 2 - Folosirea „siuak-ului” <span class="c2">(bețișorul pentru curățat dinții)</span>.<br /> 3 - Spălarea palmelor.<br /> 4 - curățarea între degete <span class="c2">(răsfirarea degetelor)</span>.<br /> 5 - spălarea părților corpului de două sau trei ori.<br /> 6 - începerea cu partea dreaptă.<br /> 7 -<span class="c6"> rostirea rugii de pomenire a lui Allah după abluțiune:</span> „Așhadu an la ilaha illa Allah uahdahu la sharika lah, ua așhadu anna Muhammadan abduhu ua rasulah.” <span class="c2">(Mărturisesc că nu există altă divinitate demnă de a fi adorată în afară de Allah, Unicul, Care nu are pe nimeni egal și mărturisesc că Mohammed este robul și Mesagerul Său)</span><br /> 8 - împlinirea după abluțiune a două unități de rugăciune. </p>',
            ],
            6 => [
                'question' => 'Întrebarea nr. 7: Care sunt acțiunile care anulează abluțiunea?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3020.mp3',
                'answer' => '<p> Răspuns: Excrețiile urinare, fecale și gazele.<br /> Somnul, starea de nebunie și inconștiența.<br /> Mâncarea cărnii de cămilă.<br /> Atingerea directă a părților intime fără o barieră. </p>',
            ],
            7 => [
                'question' => 'Întrebare: Ce este purificarea uscată („tayammum”)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3080.mp3',
                'answer' => '<p> Răspuns: „At-Tayammum” reprezintă folosirea pământului sau a oricărei materii solide de la suprafața solului, atunci când persoana în cauză nu găsește apă sau este oprit de la utilizarea acesteia, din anumite considerente. </p>',
            ],
            8 => [
                'question' => 'Întrebarea nr. 9: Cum fac purificarea uscată?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3110.mp3',
                'answer' => '<p> Răspuns: Se lovește pământul cu palmele, după care se șterge o dată fața și partea exterioară a mâinilor. </p>',
            ],
            9 => [
                'question' => 'Întrebarea nr. 10: Care cunt acțiunile care invalidează purificarea uscată?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3140.mp3',
                'answer' => '<p> Răspuns: Ea este invalidată de tot ceea ce invalidează abluțiunea, în general.<br /> La care se adaugă și găsirea apei pentru abluțiune. </p>',
            ],
            10 => [
                'question' => 'Întrebarea nr. 11: Ce sunt încălțările („al-khaffain”) și ciorapii („al-giurabain”)? Este permis să ștergem picioarele pe deasupra lor în timpul efectuării abluțiunii?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3180.mp3',
                'answer' => '<p> Răspuns: „Al-khaffain” sunt încalțările confenționate din piele <span class="c2">(sau ceva asemănator acestora)</span>.<br /> „Al-giurabain” sunt încălțările confecționate din altceva decât pielea <span class="c2">(sau din ce este asemănător acestora)</span>.<br /> Este permis să se șteargă deasupra lor în schimbul spălării picioarelor în timpul realizării abluțiunii. </p>',
            ],
            11 => [
                'question' => 'Întrebarea nr. 12: Amintește înțelepciunea aflată în spatele permisiunii de a șterge deasupra „al-khaffain” în timpul abluțiunii.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3230.mp3',
                'answer' => '<p> Răspuns: Facilitarea și ușurarea oferită oamenilor, mai ales în condiții de frig din timpul iernii sau atunci când omul călătorește și îi este greu să își dea jos încălțările. </p>',
            ],
            12 => [
                'question' => 'Întrebarea nr. 14: Care sunt condițiile pentru ca ștergerea pe deasupra încălțărilor din timpul efectuării abluțiunii să fie validă?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3260.mp3',
                'answer' => '<p> Răspuns: 1 - Încălțările să fie purtate în stare de purificare, adică după efectuarea abluțiunii.<br /> 2 - Încălțările să fie curate, pure, pentru că nu este permis să se șteargă în timpul abluțiunii peste încălțări atinse de impurități <span class="c2">(„nageasa”)</span>.<br /> 3 - Încălțările să acopere zona piciorului care se impune a fi spălată în timpul abluțiunii.<br /> 4 - Ștergerea încălțărilor să se facă în perioada de timp delimitată pentru aceasta - pentru rezidentul care nu se află în calătorie o zi și o noapte, iar pentru călător trei zile și trei nopți. </p>',
            ],
            13 => [
                'question' => 'Întrebarea nr. 14: Cum se realizează ștergerea pe deasupra încălțărilor din timpul efectuării abluțiunii?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3320.mp3',
                'answer' => '<p> Răspuns: Ștergerea pe deasupra încălțărilor din timpul realizării abluțiunii se face udând degetele de la mâini cu apă, după care se șterge laba piciorului, începând dinspre degetele piciorului, către tibie. Piciorul drept se șterge cu mâna dreaptă, iar piciorul stâng se șterge cu mâna stângă concomitent, doar o singură dată, răsfirând degetele. </p>',
            ],
            14 => [
                'question' => 'Întrebarea nr. 15: Ce invalidează ștergerea pe deasupra încălțărilor realizată în timpul abluțiunii?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3350.mp3',
                'answer' => '<p> Răspuns: 1 - Terminarea perioadei de validitate a ștergerii pe deasupra încălțărilor - nu mai este permis să se șteargă pe deasupra încălțărilor după ce s-a terminat perioada delimitată din punct de vedere islamic pentru valabilitatea acesteia, care este de o zi și o noapte în cazul persoanei rezidente și trei zile și trei nopți pentru cel aflat în călătorie.<br /> 2 - Scoaterea încălțărilor - dacă omul și-a scos încălțările sau una dintre ele după ce a șters pe deasupra lor în timpul realizării abluțiunii, ștergerea deasupra încălțărilor devine invalidă. </p>',
            ],
            15 => [
                'question' => 'Întrebarea nr. 16: Ce este Rugăciunea?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3390.mp3',
                'answer' => '<p> Răspuns: Rugăciunea este actul de adorare efectuat prin rostirea anumitor vorbe și efectuarea unor mișcări specifice. Ea începe prin „Takbir” <span class="c2">(rostirea formulei „Allahu Akbar” - Allah este Cel mai Măreț)</span> și se încheie cu „at-taslim” <span class="c2">(rostirea formulei „As-salamu aleykum ua rahmatullah” - Pacea și Îndurarea lui Allah fie asupra voastră)</span>. </p>',
            ],
            16 => [
                'question' => 'Întrebare: În care categorie de acte de adorare se încadrează Rugăciunea din punctul de vedere al jurisprudenței islamice?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3420.mp3',
                'answer' => '<p> Răspuns: Rugăciunea este obligatorie pentru fiecare musulman.<span class="c6"><br /> A spus Allah Preaînaltul:</span> Cu adevărat, Rugăciunea <span class="c5">[As-Salat]</span> este stabilită pentru dreptcredincioși la timpuri hotărâte. Coran,<span class="c6"> 4:</span>103 </p>',
            ],
            17 => [
                'question' => 'Întrebarea nr. 18: În care categorie de acte de adorare se încadrează delăsarea de Rugăciunea (neefectuare ei) din punctul de vedere al jurisprudenței islamice?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3460.mp3',
                'answer' => '<p> Răspuns: Delăsarea de Rugăciune echivalează necredinței <span class="c2">(„kufr”)</span>. Profetul <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> a spus: „Legământul care face diferența între noi și ei <span class="c2">(necredincioșii - „kuffar”)</span> este Rugăciunea, iar cel care s-a delăsat de aceasta a căzut în necredință.” Consemnat de Ahmad, Tirmidhi și alții </p>',
            ],
            18 => [
                'question' => 'Întrebarea nr. 19: Câte rugăciuni trebuie să îndeplinească un musulman într-o zi și o noapte? Câte unități de Rugăciune („raka\'a”) sunt în fiecare Rugăciune obligatorie?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3500.mp3',
                'answer' => '<p> Răspuns: Sunt 5 Rugăciuni obligatorii într-o zi și o noapte.<span class="c6"> Acestea sunt:</span> Rugăciunea de la ivirea zorilor <span class="c2">(Fajr)</span> - 2 unități de Rugăciune, Rugăciunea de la amiază <span class="c2">(Dhuhr)</span> - 4 unități de Rugăciune, Rugăciunea de după-amiază <span class="c2">(Asr)</span> - 4 unități de Rugăciune, Rugăciunea de la apusul soarelui <span class="c2">(Maghreb)</span> - 3 unități de Rugăciune și Rugăciunea de seară <span class="c2">(\'Ișa\')</span> - 4 unități de Rugăciune. </p>',
            ],
            19 => [
                'question' => 'Întrebarea nr. 20: Care sunt condițiile rugăciunii („șurut as-salat”)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3530.mp3',
                'answer' => '<p> Răspuns: 1. Apartenența la Islam, pentru că Rugăciunea nu este acceptată de la un necredincios <span class="c2">(„kafir”)</span>.<br /> 2. Deplinătatea facultăților mintale, pentru că Rugăciunea nu este primită de la o persoană fără discernământ <span class="c2">(nebun)</span>.<br /> 3. Maturitatea intelectuală și capacitatea de a discerne, pentru că rugăciunea nu este acceptată de la un copil care nu are încă maturiratea intelectuală și capacitatea de a discerne.<br /> 4. Intenția de a efectua Rugăciunea.<br /> 5. Intrarea timpului destinat unei anumite Rugăciuni.<br /> 6. Purificarea prin anularea stării de impuritate.<br /> 7. Purificarea prin îndepărtarea murdăriei.<br /> 8. Acoperirea părților din corp care nu trebuie dezvăluite în timpul Rugăciunii <span class="c2">(„aura”)</span>.<br /> 9. Îndreptarea către „Qibla” <span class="c2">(direcția Ka\'abah)</span>. </p>',
            ],
            20 => [
                'question' => 'Întrebarea nr. 21: Care sunt stâlpii Rugăciunii și numărul acestora?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3640.mp3',
                'answer' => '<p> Răspuns: Stâlpii Rugăciunii <span class="c2">(actele obligatoriu de realizat în timpul acesteia)</span> sunt în număr de 24,<span class="c6"> după cum urmează:</span><br /> Ridicarea în picioare în momentul îndeplinirii Rugăciunilor obligatorii pentru cel care este capabil de aceasta.<br /> Rostirea formulei „Allahu Akbar” <span class="c2">(Allah este Cel Mai Măreț)</span> la începutul Rugăciunii.<br /> Citirea capitolului al- Fatiha.<br /> Aplecarea <span class="c2">(plecăciunea)</span> în Rugăciune <span class="c2">(ar-ruku)</span> - cu spatele drept și capul îndreptat la același nivel cu spatele.<br /> Ridicarea din plecăciune.<br /> Statul drept în picioare.<br /> Prosternarea <span class="c2">(„sujud”)</span> în decursul căreia musulmanul trebuie să atingă pământul cu fruntea, vârful nasului, palmele, genunchii și vârful degetelor de la picioare.<br /> Ridicarea din prosternare.<br /> Așezarea între două prosternări.<br /> Dintre actele preferabile <span class="c2">(„Sunnah”)</span> efectuate în timpul Rugăciunii amintim: la așezarea finală statul așezat pe piciorul stâng și îndoirea degetelor piciorului drept, ridicând călcâiul de pe sol și având degetele îndreptate către Qibla.<br /> Calmitatea, care presupune liniștea resimțită în împlinirea fiecăruia dintre stâlpii Rugăciunii.<br /> Ultimul Tașahud.<br /> Așezarea pentru ultimul Tașahud.<br /> Cele două „taslim”-uri, adică a spune de 2 ori „Assalamu aleykum ua rahmatullah” - Pacea și binecuvântarea lui Allah fie asupra voastră <span class="c2">(întorcându-se spre dreapta și spre stânga)</span>.<br /> Stâlpii Rugăciunii sunt ordonați așa cum a fost menționat anterior, iar dacă cineva schimbă în mod intenționat ordinea lor, spre exemplu prosternându-se înainte de plecăciune, atunci aceasta este o greșeală ce trebuie corectată de către cel care se roagă, făcând plecăciunea din nou și apoi prosternându-se <span class="c2">(sujud)</span>. </p>',
            ],
            21 => [
                'question' => 'Întrebarea nr. 22: Menționează care sunt „uagibaat as-salat” (actele obligatorii în Rugăciune).',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3820.mp3',
                'answer' => '<p> Răspuns: „Uagibaat as-Salat” sunt 8 la număr,<span class="c6"> după cum urmează:</span><br /> 1 - celelalte „Takbirat” în afara „Takbir”-ului inițial <span class="c2">(„takbitrat al-ihram”)</span><br /> 2 - rostirea formulei „Sami\'a Allahu li-man hamidah” <span class="c2">(Allah îl aude pe cel care Îi aduce laude)</span>, atât pentru cel care conduce Rugăciunea în congregație, cât și pentru cel care se roagă singur.<br /> 3 - Rostirea formulei „Rabbana ua laka al-hamd” <span class="c2">(O, Domnul nostru, a Ta este toată lauda!”)</span><br /> 4 - Rostirea formulei „Subhana Rabbi al-Adhim” <span class="c2">(Slavă Domnului meu, Cel Preamăreț)</span> o singură dată în timpul efectuării plecăciunii.<br /> 5 - Rostirea formulei „Subhana Rabbi al-\'A\'ala” <span class="c2">(Slavă Domnului meu, Preaînaltul)</span> o singură dată în timpul prosternării <span class="c2">(sujud)</span>.<br /> 6 - Rostirea formulei „Rabbi ghfir ly” între două prosternări.<br /> 7 - Rostirea primului „Tașahud”.<br /> 8 - Statul așezat pentru rostirea primului „Tașahud”. </p>',
            ],
            22 => [
                'question' => 'Întrebarea nr. 23: Care sunt „sunan as-salat” (acțiunile preferabile, dar neobligatorii din timpul efectuării Rugăciunii)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3930.mp3',
                'answer' => '<p> Răspuns: În efectuarea Rugăciunii sunt 21 de acțiuni Sunnah,<span class="c6"> după cum urmează:</span><br /> 1 - Rostirea după „Takbirat al-ihram” a invocației de deschidere a Rugăciunii - „Subhanaka Allahumma ua bi-hamdika, ua tabaraka -smuka, ua ta\'ala geadduka, ua la ilaha ghairuka” <span class="c2">(Preaslăvit ești Tu, o, Allah și toată lauda Ți se cuvine numai Ție! Preabinecuvântat este numele Tău și Preaînalt este Rangul Tău! Și nu există niciun dumnezeu demn de a fi adorat în afară de Tine)</span><br /> 2 - „At-Ta\'audh” - adică rostirea formulei „A\'udhu billahi min aș-șaitani r-ragim” <span class="c2">(Caut adăpost la Allah de Satana cel alungat)</span> înainte de începerea recitării Surat al-Fatiha<br /> 3 - „Al-Basmala” - rostirea formulei „Bismillah” <span class="c2">(În numele lui Allah)</span><br /> 4 - A spune „Amin” la sfârșitul Surat al-Fatiha<br /> 5 - Citirea unei alte Sure <span class="c2">(fragment sau capitol din Coran)</span> după Surat al-Fatiha<br /> 6 - Citirea cu voce tare de către cel care conduce Rugăciunea<br /> 7 - Adăugarea la ridicarea din plecăciune, după rostirea formulei „Rabbana ua laka al-hamd”, în completarea acesteia - „Mal\'u as-samauati ua mal\'u al-\'ard ua mal\'u ma și\'ta ba\'ad” <span class="c2">(Domnul nostru, Ție Ți se cuvine toată lauda. Cerurile şi Pământul cu tot ce se află în ele şi între ele <span class="c5">[Îți aduc laudă]</span>, şi tot ceea ce Tu doreşti Îți aduce laudă)</span><br /> 8 - Ceea ce este în plus față de primul tasbih spus în plecăciune <span class="c2">(„ruku\'”)</span>, adică al doilea și al treilea tasbih sau ce este spus în plus față de acesta.<br /> 9 - Ce este în plus față de primul tasbih din prosternare <span class="c2">(„sujud”)</span>.<br /> 10 - Ce este în plus față de rostirea formulei „Rabbi ghfir ly” spusă între două prosternări.<br /> 11- A trimite, în ultimul tașahud, salutări asupra neamului Profetului Muhamad, și binecuvântări asupra lui și asupra lor, și ruga <span class="c2">(dua\')</span> de după aceasta.<br /> În al patrulea rând - acțiunile Sunnan,<span class="c6"> sau ipostaze:</span><br /> 1 - Ridicarea mâinilor la rostirea „Takbirat al-ihram”<br /> 2 - Ridicarea mâinilor înainte de coborârea în plecăciune<br /> 3 - Ridicarea mâinilor la ridicarea din plecăciune<br /> 4 - Coborârea mâinilor după aceasta<br /> 5 - Punerea mâinii drepte peste mâna stângă<br /> 6 - Privirea îndreptată spre punctul în care se face prosternarea - sujud<br /> 7 - Depărtarea picioarelor atunci când omul se află stând în Rugăciune<br /> 8 - Prinderea genunchilor cu palmele cu degetele răsfirate în timpul plecăciunii <span class="c2">(„ruku\'”)</span>, ținând spatele drept, paralel cu solul, și capul la acelasi nivel<br /> 9 - Atingerea directă a solului de către părțile corpului care trebuie să facă aceasta în timpul prosternării<br /> 10 - Depărtarea de trup a brațelor, în lateral, depărtarea abdomenului de coapse, depărtarea coapselor de partea inferioară a picioarelor, îndepărtarea genunchilor, ridicarea de pe sol a călcâielor, atingerea solului cu buricul degetelor <span class="c2">(de la picioare)</span>, așezarea palmelor în dreptul umerilor, cu degetele apropiate <span class="c2">(în timpul prosternării - „sujud”)</span><br /> 11- Poziția luată între două prosternări și la rostirea primului „Tașahud” - „al-iftiraș” și poziția de „at-tauarruk” luată în momentul rostirii celui de-al doilea „Tașahud”<br /> 12 - Între două prosternări, punerea palmelor, cu degetele apropiate, pe pulpele picioarelor <span class="c2">(coapse)</span>; și tot astfel în timpul rostirii „Tașahad”-ului, cu diferența că atunci degetul mic și inelarul sunt închise în palmă, degetul mare și cel mijlociu de la mâna dreaptă sunt unite împreună formând un cerc, iar degetul arătător este îndreptat în direcția Qibla și mișcat în timp ce credinciosul Îl pomenește pe Allah<br /> 13 - Întoarcerea către dreapta și stânga în momentul „taslim”-ului la sfârșitul Rugăciunii </p>',
            ],
            23 => [
                'question' => 'Întrebarea nr. 24: Menționează care sunt actele care invalidează Rugăciunea („mubattilat as-salah”).',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4210.mp3',
                'answer' => '<p> Răspuns: <span class="c2">(1)</span> neîndeplinirea unui stâlp al Rugăciunii<br /> <span class="c2">(2)</span> a vorbi în mod intenționat în timpul Rugăciunii<br /> <span class="c2">(3)</span> mâncatul sau băutul în timpul efectuării Rugăciunii<br /> <span class="c2">(4)</span> multe mișcări care nu aparțin Rugăciunii, efectuate în mod repetat<br /> <span class="c2">(5)</span> neîndeplinirea în mod intenționat a unui act care face parte din „uagibaat as-salah” </p>',
            ],
            24 => [
                'question' => 'Întrebarea nr. 25: Cum face un musulman Rugăciunea?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4280.mp3',
                'answer' => '<p> Răspuns: Modalitatea de realizare a Rugăciunii este următoarea:<br /> 1 - Credinciosul se îndreptă cu tot corpul către Ka\'abah, fără a se întoarce în niciun fel de la această poziție<br /> 2 - El are înteția de a îndeplini Rugăciunea pe care dorește să o realizeze în inima sa, fără a rosti această intenție cu voce tare<br /> 3 - Rostește „takbirat al-<span class="c6">ihram”:</span> „Allahu Akbar” <span class="c2">(Allah este Cel mai Măreț)</span> și ridică palmele până la nivelul umerilor<br /> 4 - Apoi pune palma stângă pe piept iar palma dreaptă deasupra ei.<br /> 5 -<span class="c6"> Apoi rostește ruga de deschidere a Rugăciunii spunând:</span> Allahumma ba’id bayni uabayna khatayaya kama ba’adta baynal-maşriqi ualmaghrib, allahumma naqqini min khatayaya kama yunaqqath –thaubul -abyadu minad-danas, allahumma gh-silni min khatayaya bi ththalgi<br /> ualma’i ualbarad. <span class="c2">(O, Allah, îndepărtează-mă pe mine de păcatele mele aşa cum ai îndepărtat Estul de Vest. O, Allah, curăţă-mă <span class="c5">[și purifică-<br /> mă]</span> de păcate aşa cum o haină albă este curățată de murdărie. O, Allah, curăţă-mă de păcate cu zăpadă, apă şi gheață.)</span><br /> Sau spune: „Subhanakal-lahumma uabihamdika uatabarakas-muka ua ta’ala geadduka ua la ilaha ghayruka” <span class="c2">(Cât de Perfect <span class="c5">[şi Măreţ]</span> eşti Tu,<br /> o, Allah, şi Ţie Ţi se cuvine toată lauda. Binecuvântat este Numele Tău şi Preaînalt este Rangul Tău şi nu există altă divinitate demnă de a fi adorată în afară de Tine.)</span><br /> 6 -<span class="c6"> Apoi caută adăpost la Allah de Satana spunând:</span> „A’udhu billahi min aş-şaytanir-ragim” <span class="c2">(Caut adăpost la Allah de Satana cel alungat)</span> 7 - După aceea rostește formula de „basmala” și citește Surat al-<span class="c6">Fatiha spunând:</span> Bismillah ir-rahman ir-rahim - În numele lui Allah Cel Milostiv <span class="c5">[Ar-Rahman]</span>, Îndurător <span class="c5">[Ar-Rahim]</span> Al hamdu lillahi rabbil ‘alamin - <span class="c5">[Toată]</span> Lauda <span class="c5">[I se cuvine]</span> lui Allah, Stăpânitorul lumilor Arrahman ir-Rahim - Cel Milostiv, Îndurător Maliki yaumiddin - Suveranul Zilei Judecății Iyyaka na’budu ua iyyaka nasta\'in - Numai pe Tine Te adorăm, numai la Tine cerem ajutor Ihdinas siratal mustaqim - Călăuzește-ne pe noi către Calea cea Dreaptă Siratal ladhina an‘amta ‘alaihim, Ghairil maghdubi ‘alaihim ua lad daallin - Calea celor asupra cărora Tu ai revărsat Îndurarea Ta, nu a celor pe care Tu Te-ai mâniat, și nici a celor care au rătăcit. <span class="c5">[Surat al Fatiha, 1-7]</span><br /> Apoi se spune: „Amin”, adică „O Allah, răspunde rugii mele”.<br /> 8 - Apoi citește ce poate din Coran, iar în Rugăciunea de dimineață se prelungește recitarea<br /> 9 - Apoi face plecăciunea <span class="c2">(„ruku\' ”)</span> - adică își pleacă spatele în semn de preamărire a lui Allah, rostind, în timp ce se pleacă, formula „Allahu Akbar” <span class="c2">(Allah este Cel mai Măreț)</span><br /> 10 - În timpul plecăciunii spune „Subhna Rabbi-l Adhim” - <span class="c2">(Slavă Domnului meu, Cel Preamăreț)</span>,<span class="c6"> iar dacă dorește să adauge în plus la aceasta va spune:</span> „Subhanaka Allahumma ua bi-hamdika, Allahumma -ghfir ly” <span class="c2">(Slavă Ție, o Allah și toată lauda se cuvine numai Ție. O Allah, iartă-mă!)</span><br /> 11 - Apoi,<span class="c6"> ridicând capul din plecăciune spune:</span> „Sami Allahu liman hamidah” <span class="c2">(Allah îl aude pe cel care-L laudă)</span>, ridicând în același timp palmele până la nivelul umerilor. Cel care este condus în Rugăciune nu spune aceasta, ci spune „Rabbana ua lakal- hamd” <span class="c2">(Domnul nostru, Ție Ți se cuvine toată lauda )</span>.<br /> 12 - După ce s-<span class="c6">a ridicat din plecăciune spune:</span> „Rabbana ua lakal-hamd, mil-as-samauati uamil-al-ard, uama baynahuma, uamil’a ma şi’ta min şay-in b’ad” <span class="c2">(Domnul nostru, Ție Ți se cuvine toată lauda. Cerurile şi Pământul cu tot ce se află în ele şi între ele <span class="c5">[Îți aduc laudă]</span>, şi tot ceea<br /> ce Tu doreşti Îți aduce laudă)</span><br /> 13 -<span class="c6"> Apoi coboară în prosternare spunând în acest timp:</span> „Allahu Akbar” <span class="c2">(Allah este Cel mai Măreț)</span>,<span class="c6"> după care se prosternează atingând pământul cu șapte părți ale corpului:</span> fruntea și nasul, palmele, genunchii și buricele degetelor de la picioare, depărtând de corp partea superioară și interioară a brațelor, fără a se sprijini cu antebrațele pe sol, iar vârfurile degetelor sunt îndreptate către Qibla<br /> 14 -<span class="c6"> În timpul prosternării se spune:</span> „Subhana Rabbyial ’A’la” <span class="c2">(Slavă Domnului meu, Cel Preaînalt)</span> de 3 ori, și dacă dorește,<span class="c6"> se poate spune în plus:</span> „Subhanaka Allahumma Rabbana ua bihamdika. Allahumma -ghfir ly” <span class="c2">(Slavă Ție, Domnul nostru, o, Allah, și Ție Ți se cuvine toată Lauda. O, Allah, iartă-mă)</span>.<br /> 15 -<span class="c6"> Apoi își ridică capul din prosternare spunând:</span> „Allahu Akbar” <span class="c2">(Allah este Cel mai Măreț)</span><br /> 16 - Apoi se așează între două prosternări în vreme ce stă așezat pe piciorul stâng, cu laba piciorului drept ridicată vertical <span class="c2">(sprijinându-se pe buricele degetelor de la picioare)</span>, și punând mâna dreaptă pe piciorul drept, aproape de genunchi. Degetul mic și degetul inelar de la mâna dreaptă sunt închise în palmă, degetul mijlociu și degetul mare sunt împreunate sub forma unui cerc, iar degetul arătător rămâne ridicat și este mișcat atunci când se fac rugi. Palma stângă o pune pe piciorul stâng, cu degetele întinse, un pic mai sus de genunchi.<br /> 17 -<span class="c6"> Atunci când stă așezat între două prosternări spune:</span> „Rabbi -gh-fir li, uarhamni, uahdini, uarzuqni uagiburni ua’afini” <span class="c2">(O, Allah, iartă-mă, ai milă de mine, călăuzeşte-mă, dă-mi cele necesare traiului, împuterniceşte-mă și dă-mi sănătate)</span>.<br /> 18 - Apoi îndeplinește și cea de-a doua prosternare, ca și pe prima, spunând și făcând același lucru și preamărindu-L pe Allah <span class="c2">(prin rostirea formulei „Allahu Akbar” - Allah este Cel mai Măreț)</span> atunci când coboară în prosternare.<br /> 19 - Apoi se ridică din cea de-a doua prosternare spunând „Allahu Akbar” <span class="c2">(Allah este Cel mai Măreț)</span> și îndeplinește cea de-a doua „Raka\'a” <span class="c2">(unitate de Rugăciune)</span> ca și pe prima, cu diferența că nu rostește în aceasta ruga specifică pentru deschiderea Rugăciunii.<br /> 20 - După ce a terminat și cea de a doua „Raka\'a” rămâne așezat așa cum a stat și între cele două prosternări, spunând „Allahu Akbar” <span class="c2">(Allah este Cel mai Măreț)</span> în timp ce se așează.<br /> 21 - După aceasta spune „at-<span class="c6">Tașahud” în timp ce stă așezat:</span> Attahiyyatu lillahi uassalauatu uattayyibat, assalamu ‘alayka ayyuhannabiyyu ua rahmatul-lahi ua barakatuh, assalamu ‘alayna ua’ala ‘ibadil-lahis-salihin. Aş-hadu an la ilaha illal-lah, ua-aşhadu anna<br /> Muhammadan ‘abduhu ua rasuluh. Allahumma salli ‘ala Muhammad, ua-’ala ali Muhammad, kama sallayta ‘ala Ibrahimaua-’ala ali Ibrahim, innaka Hamidun Magid, allahumma barik ‘ala Muhammad, ua-’ala ali Muhammad, kama barakta ‘ala Ibrahim ua-’ala ali Ibrahim, innaka Hamidun Magid. <span class="c2">(Toate salutările „At-Tahiyyaat”, cuvintele care fac referire la glorificarea lui Allah, existenţa Sa veşnică, Perfecţiunea Sa, Supremaţia Sa sunt pentru Allah. Toate actele de slăvire şi adorare şi faptele bune sunt pentru El. Pacea, mila şi binecuvântarea lui Allah fie asupra ta, o, Profetule! Pacea fie asupra noastră şi asupra tuturor robilor dreptcredincioşi ai lui Allah. Mărturisesc că nu există altă divinitate demnă de a fi adorată în afară de Allah şi mărturisesc că Mohammed este robul şi Trimisul Său! O, Allah, trimite salutări asupra lui Mohammed şi asupra urmaşilor lui Mohammed, aşa cum ai trimis salutările Tale asupra lui Avraam şi asupra urmaşilor lui Avraam. Cu adevărat, Tu eşti plin de Slavă şi Măreţie. O, Allah, trimite binecuvântarea Ta asupra lui Mohammed şi asupra urmaşilor lui Mohammed, aşa cum ai trimis binecuvântări asupra lui Avraam şi asupra urmaşilor lui Avraam. Cu adevărat, Tu eşti plin de Slavă şi Măreţie!)</span> Apoi poate spune următoarea rugă: „A\'udhu billahi min ‘adhabi giahannam, uamin ‘adhabil-qabr, <br /> uamin fitnatil-mahya ualmamat, uamin şarri fitnatil-masihid-dajjal” <span class="c2">(Caut adăpost la Allah de pedeapsa chinuitoare a Iadului, de pedeapsa chinuitoare a mormântului, de înşelăciunile vieţii şi morţii şi de răul ispitei lui Al-Masih Al-Dajjal <span class="c5">[Anticristul]</span>)</span>. Apoi se poate ruga pentru orice dorește din binele acestei lumi și al lumii de Apoi.<br /> 22 -<span class="c6"> Apoi își întoarce capul către dreapta spunând:</span> „Assalamu aleykum ua rahmatu-llah” <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra voastră)</span>, și tot astfel în partea stângă.<br /> 23 - În cazul în care Rugăciunea are 3 sau 4 unități, el se va opri la sfârșitul primului „Tașahud”,<span class="c6"> atunci când spune:</span> Aş-hadu an la ilaha illal-lah, ua-aşhadu anna Muhammadan ‘abduhu ua rasuluh. <span class="c2">(Mărturisesc că nu există altă divinitate demnă de a fi adorată în afară de Allah şi mărturisesc că Mohammed este robul şi Trimisul Său!)</span><br /> 24 -<span class="c6"> Apoi se ridică spunând:</span> „Allahu Akbar” <span class="c2">(Allah este Cel mai Măreț)</span> și ridică mâinile până în dreptul umerilor<br /> 25 - Apoi continuă Rugăciunea, așa cum a făcut și cea de a două raka\'a, dar fără a mai citi și altceva din Coran după Surat al Fatiha.<br /> 26 - Apoi la sfârșitul Rugăciunii se așează, cu talpa piciorului drept ridicată și sprijinită pe degetele de la picioare, iar piciorul stâng este așezat lateral sub piciorul drept și se poate așeza pe pământ, iar mâinile și le pune pe coapse ca la primul „Tașahud”.<br /> 27 - În timpul aceastei așezări citește „Tașahud”-ul întreg.<br /> 28 -<span class="c6"> Apoi salută în partea dreaptă spunând:</span> „Assalamu aleykum ua rahmatullah” <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra voastră)</span> și, de asemenea, în partea stângă. </p>',
            ],
            25 => [
                'question' => 'Întrebarea nr. 26: Care sunt pomenirile („adhkar”) care se spun imediat după încheierea Rugăciunii, după „taslim”?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4610.mp3',
                'answer' => '<p> Răspuns: „Astaghfiru-llah” <span class="c2">(Caut iertarea lui Allah)</span> de 3 ori<br /> Allahumma antas-salam uaminkas-salam, tabarakta ya dhal-gialali ual-ikram. „O, Allah, Tu eşti As-Salaam <span class="c2">(Pacea – Făcătorul de pace şi sursa păcii, Cel lipsit de orice deficit)</span> şi de la Tine este toată pacea. Slăvit eşti Tu, o, Cel a Căruia este Măreţia şi Cinstea!<br /> „La ilaha illal-lahu uahdahu la şarika lah, lahul-mulku ualahul-hamd, uahuua ‘ala kulli şayin qadir, allahumma la mani’a lima ‘atayt, uala mu’tiya lima mana’t, uala yanfa’u dhal-giaddi minkal-giadd. <span class="c2">(Nu există altă divinitate demnă de a fi adorată în afară de Allah, Unicul, care nu are pe nimeni asociat, a Lui este Împărăţia şi a Lui este Lauda şi El este cu putere peste toate, Atotputernic. O, Allah, nimeni nu poate opri ceea ce Tu ai dăruit şi nimeni nu poate dărui ceea ce Tu ai oprit, și nicio bogăție sau măreție nu poate fi de niciun folos nimănui <span class="c5">[decât prin Voia Ta]</span>, căci de la Tine sunt toate bogățiile și mărețiile.)</span><br /> „La ilaha illal-lah, uahdahu la şarika lah, lahul-mulku ualahul-hamd, uahuua ‘ala kulli şayin qadir. la haula uala quuuata illa billah, la ilaha illal-lah, uala na’budu illa iyyah, lahun-ni’amatu ualahul-fadl ualahu th-thana-ul- hasan, la ilaha illal-lah mukhlisina lahud-din ualau karihal-kafirun.” <span class="c2">(Nu există altă divinitate demnă de a fi adorată în afară de Allah, Unicul, Care nu are pe nimeni asociat, a Lui este Împărăţia şi a Lui este Lauda şi El este cu putere peste toate, Atotputernic. Nu există forţă și nici putere decât cu Allah, nu există altă divinitate demnă de a fi adorată în afară <br /> de Allah şi noi nu Îl adorăm decât pe El. Ale Lui sunt toate binecuvântările, virtuțile şi glorificarea cea frumoasă. Nu există altă <br /> divinitate demnă de a fi adorată în afară de Allah şi noi numai Lui Îi suntem devotați întru religia cea adevărată, chiar şi dacă aceasta nu le este plăcută necredincioşilor.)</span><br /> 69. „Subhan Allah” <span class="c2">(Cât de Perfect și Măreţ este Allah)</span> de 33 de ori<br /> „Alhamdulillah” <span class="c2">(Laudă lui Allah)</span> de 33 de ori<br /> „Allahu akbar” <span class="c2">(Allah este Cel mai Măreţ)</span> de 33 de ori<br /> Apoi spune fraza care întregește o sută: „La ilaha ill-allahu uahdahu la şarika lah, lahul-mulku ualahul-hamd, uahuua ‘ala kulli şayin qadir.” <span class="c2">(Nu există altă divinitate demnă de a fi <br /> adorată în afară de Allah, Unicul, Care nu are pe nimeni asociat, a Lui este Împărăţia şi a Lui este Lauda şi El este cu Putere peste toate, Atotputernic.)</span><br /> - Și citește ultimele 3 Surat din Coran de 3 ori după Salat Fajr și Salat Maghrib și o singură dată după celelalte rugăciuni.<br /> Citește, de asemenea, o dată versetul al-Kursi <span class="c2">(Coran,<span class="c6"> 2:</span>255)</span> </p>',
            ],
            26 => [
                'question' => 'Întrebarea nr. 27: Care sunt Rugăciunile voluntare (Sunnan ar-rauatib) care se fac împreună cu Rugăciunile obligatorii? Care sunt virtuțile acestora?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4730.mp3',
                'answer' => '<p> Răspuns: - 2 raka\'a <span class="c2">(unități de Rugăciune)</span> după Salat Fajr<br /> - 4 raka\'a înainte de Salat Dhuhr<br /> - 2 raka\'a după Salat Dhuhr<br /> - 2 raka\'a după Salat Maghrib<br /> - 2 raka\'a după Salat Ișa<br /> Virtuțile acestora, conform spuselor Profetului <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> sunt: „Aceluia care a îndeplinit într-o zi și o noapte 12 raka\'a voluntare, Allah i-a construit o casă în Paradis.” Relatat de Muslim, Ahmad și alții </p>',
            ],
            27 => [
                'question' => 'Întrebarea nr. 28: Care este cea mai binecuvântată zi a săptămânii?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4800.mp3',
                'answer' => '<p> Răspuns: Ziua de Vineri. Profetul <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> a spus: „Cea mai bună dintre zilele voastre este Ziua de Vineri. În această zi a fost creat Adam, și tot în această zi i-a fost luat sufletul. În această zi, în Ziua de Apoi se va sufla în trâmbiță și tot în această zi va avea loc și „strigătul” <span class="c2">(asurzitor)</span>. Așadar, sporiți în decursul acesteia salutările trimise asupra mea, pentru că acestea îmi vor fi înfățișate.<span class="c6">” Companionii au spus:</span> „O, Trimis al lui Allah,<span class="c6"> cum îți vor fi înfățișate salutările noastre după ce vei fi trecut?” Profetul a răspuns:</span> „Cu adevărat, Allah Atotputernicul i-a interzis pământului să consume trupurile Profeților.” Consemnat de Abu Daud și alții </p>',
            ],
            28 => [
                'question' => 'Întrebarea nr. 39: Care este verdictul (din punctul de vedere al jurisprudenței islamice) pentru Rugăciunea al-Jumu\'a?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4840.mp3',
                'answer' => '<p> Răspuns: Este „fard \'ain” <span class="c2">(o obligație individuală)</span> pentru fiecare musulman bărbat, matur, în deplinătatea facultăților mintale, rezident.<span class="c6"><br /> A spus Allah Preaînaltul:</span> O, voi cei care credeți! Să nu vă abată averile voastre și copiii voștri<br /> de la pomenirea lui Allah! Cei care fac aceasta, aceia vor fi pierduți! <span class="c5">[Coran,<span class="c6"> 64:</span>9]</span> </p>',
            ],
            29 => [
                'question' => 'Întrebarea nr. 30: Câte raka\'a (unități de Rugăciune) are Salat al-Jumu\'a?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4880.mp3',
                'answer' => '<p> Răspuns: Rugăciunea al-Jumu\'a are două unități de Rugăciune, rostite de către imam cu voce tare și precedate de două cuvântări <span class="c2">(khutba)</span>. </p>',
            ],
            30 => [
                'question' => 'Întrebarea nr. 31: Este permisă neparticiparea la Rugăciunea de Jumu\'a?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4910.mp3',
                'answer' => '<p> Răspuns: Nu îi este permisă neparticiparea la rugăciunea de Jumu\'a, decât celui care are un motiv valid în Legislația islamică. Profetul <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> a spus: „Allah a pus o pecete <span class="c2">(rea)</span> pe inima celui care din neglijență nu a participat la trei rugăciuni de Jumu\'a <span class="c2">(consecutive)</span>.” Consemnat de Abu Daud și alții </p>',
            ],
            31 => [
                'question' => 'Întrebarea nr. 32: Menționează care sunt Sunan (actele voluntare recomandate) pentru Ziua de Vineri?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4940.mp3',
                'answer' => '<p> Răspuns:<br /> 1 - Baia totală rituală a corpului.<br /> 2 - Parfurmarea <span class="c2">(pentru bărbați)</span>.<br /> 3 - Îmbrăcarea celor mai bune haine.<br /> 4 - Ajungerea devreme la moschee<br /> 5 - Sporirea salutărilor trimise asupra Profetului <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span>.<br /> 6 - Recitarea Surat al-Kahf<br /> 7 - Mersul pe jos la moschee<br /> 8 - Căutarea intervalului orar în care rugile sunt acceptate. </p>',
            ],
            32 => [
                'question' => 'Întrebarea nr. 33: Menționează care sunt virtuțile rugăciunii în congregație',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5050.mp3',
                'answer' => '<p> Abdullah ibn Omar <span class="c2">(Allah să fie mulțumit de el)</span> a relatat că mesagerul lui Allah <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> a spus: „Rugăciunea în congregație este cu 27 de ranguri mai bună decât rugăciunea efectuată individual.” Consemnat de Muslim. </p>',
            ],
            33 => [
                'question' => 'Întrebarea nr. 34: Ce înseamnă „khușu\' ” (reverenţa) în Rugăciune?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5080.mp3',
                'answer' => '<p> Răspuns: Aceasta presupune prezența inimii și liniștirea trupului în timpul Rugăciunii.<span class="c6"><br /> A spus Allah Preaînaltul:</span> Cu adevărat, credincioșii vor avea izbândă, Cei care în Rugăciunea lor sunt smeriți întru supunere <span class="c5">[Coran,<span class="c6"> 23:</span>1-2]</span> </p>',
            ],
            34 => [
                'question' => 'Întrebarea nr. 35: Care este definiția Zakatului?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5120.mp3',
                'answer' => '<p> Răspuns: Este o obligație impusă asupra averii personale pentru o anumită categorie de oameni, pe o anumită perioadă de timp.<br /> Este unul dintre stâlpii Islamului și reprezintă un act de caritate obligatorie, din averea celor bogați, fiind oferită celor săraci.<span class="c6"><br /> A spus Allah Preaînaltul:</span> <span class="c2">(...)</span> oferiți Dania! <span class="c2">(Coran,<span class="c6"> 2:</span>43)</span> </p>',
            ],
            35 => [
                'question' => 'Întrebarea nr. 36: Ce este actul de caritate preferabil, oferit în mod voluntar (sadaqa)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5170.mp3',
                'answer' => '<p> Aceasta este milostenia oferită în afară de Zakat, precum oferirea oricărui lucru bun, oricând se dorește.<span class="c6"><br /> Allah Preaînaltul a spus:</span> „Dăruiţi pe calea lui Allah” <span class="c5">[Coran,<span class="c6"> 2:</span>195]</span> </p>',
            ],
            36 => [
                'question' => 'Întrebarea nr. 37: Definește Postul (as-siyam).',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5210.mp3',
                'answer' => '<p> Răspuns: Postul este adorarea lui Allah prin abținerea de la cele care invalidează postul, de la ivirea zorilor și până la apus.<span class="c6"><br /> Post obligatoriu:</span> precum postul în luna Ramadan, care este unul dintre stâlpii Islamului.<span class="c6"><br /> A spus Allah Preaînaltul:</span> O, voi cei care credeţi, v-a fost poruncit vouă postul, aşa cum le-a<br /> fost prescris şi celor dinaintea voastră, poate că veţi fi dintre cei<br /> dreptcredincioși! <span class="c5">[Coran,<span class="c6"> 2:</span>183]</span><br /> Și post voluntar <span class="c2">(neobligatoriu)</span>: precum postul în zilele de luni și joi ale săptămânii, postul a 3 zile din fiecare lună islamică, în zilele cele mai bune de 13,14,15 ale lunii. </p>',
            ],
            37 => [
                'question' => 'Întrebare: Menționează virtuțile Postului în luna Ramadan.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5270.mp3',
                'answer' => '<p> Răspuns: Abu Huraira <span class="c2">(Allah să fie mulțumit de el)</span> a relatat că Mesagerul lui Allah <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> a spus: „Aceluia care a postit Ramadanul cu credință și cu speranța <span class="c2">(la răsplata lui Allah)</span>, îi vor fi iertate păcatele.” Convenit asupra sa </p>',
            ],
            38 => [
                'question' => 'Întrebarea nr. 39: Menționează care sunt virtuțile Postului voluntar, în afara Ramadanului.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5300.mp3',
                'answer' => '<p> Răspuns: Abu Sa\'id al-Khudri <span class="c2">(Allah să fie mulțumit de el)</span> a relatat că Mesagerul lui Allah <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> a spus: „Niciun rob <span class="c2">(al lui Allah)</span> nu postește o zi pe calea lui Allah, fără ca El să îi îndepărteze fața de Focul Iadului cu o distanță de 70 de ani.” Convenit asupra sa<br /> Textul hadisului face referire la „70 de toamne”, cu sensul de „70 de ani”. </p>',
            ],
            39 => [
                'question' => 'Întebarea nr. 40: Menționează câteva dintre actele care anulează Postul.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5330.mp3',
                'answer' => '<p> Răspuns: 1 - mâncarea și băutura<br /> 2 - vomitatul produs în mod intenționat<br /> 3 - renunțarea la Islam <span class="c2">(apostazia)</span> </p>',
            ],
            40 => [
                'question' => 'Întrebarea nr. 41: Care sunt actele Sunnah legate de Post?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5380.mp3',
                'answer' => '<p> Răspuns: 1 - grăbirea în a rupe Postul la sfârșitul zilei de post<br /> 2 - luarea mesei de dinaintea postului <span class="c2">(suhur)</span> și întârzierea acesteia cât mai aproape de intrarea timpului de post<br /> 3 - sporirea faptelor bune și a actelor de adorare<br /> 4 -<span class="c6"> rostirea de către cel care postește a expresiei:</span> „Inni sa\'im” <span class="c2">(Cu adevărat, eu țin post!)</span> atunci când este jignit <span class="c2">(ca o formă de abținere de la a răspunde cu ceea ce este rău)</span><br /> 5 - rostirea de rugi la terminarea postului<br /> 6 - încheierea postului cu curmale proaspete sau uscate sau cu apă, dacă omul nu are la dispoziție curmale. </p>',
            ],
            41 => [
                'question' => 'Întrbarea nr. 42: Definește Pelerinajul (Hajj).',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5460.mp3',
                'answer' => '<p> Răspuns: Hajj-ul este un act de adorare a lui Allah Preaînaltul realizat de către musulmani prin călătoria la Preasfînta Sa Casă, cu scopul de a împlini anumite acte de adorare specifice, într-o perioadă de timp specifică.<span class="c6"><br /> A spus Allah Preaînaltul:</span> Și este o datorie a oamenilor față de Allah <span class="c5">[să împlinească]</span> Pelerinajul la<br /> această Casă, dacă au mijloacele necesare. Cât despre cei care nu cred <span class="c5">[refuză]</span>, Allah nu are nevoie de aceste lumi. <span class="c5">[Coran,<span class="c6"> 3:</span>97]</span> </p>',
            ],
            42 => [
                'question' => 'Întrebarea nr. 43: Care sunt stâlpii Pelerinajului?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5500.mp3',
                'answer' => '<p> Răspuns: 1 - ihramul <span class="c2">(intrarea în starea de sacralizare)</span><br /> 2 - poposirea pe Muntele Arafa<br /> 3 - tauaf al-ifada - încercuirea rituală a Ka\'abei după ce pelerinii s-au întors la Mecca<br /> 4 - as-sa\'y - parcurgerea distanței dintre Safa și Marua </p>',
            ],
            43 => [
                'question' => 'Întrebarea nr. 44: Care sunt virtuțile Pelerinajului?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5560.mp3',
                'answer' => '<p> Răspuns: Abu Huraira <span class="c2">(Allah să fie mulțumit de el)</span> a relatat că l-a auzit pe Mesagerul lui Allah <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> spunând: „Cel care a efectuat Pelerinajul de dragul lui Allah, fără a rosti vorbe rușinoase sau a se purta cu răutate, se va întoarce <span class="c2">(de la Hajj)</span> la fel ca în ziua în care a fost născut de mama sa <span class="c2">(adică fără păcate)</span>.” Relatat de Bukhari și alții<br /> Expresia „ca în ziua în care a fost născut de mama sa” - are sensul de fără păcate. </p>',
            ],
            44 => [
                'question' => 'Întrebarea nr. 45: Definește „Omrah” (Pelerinajul Mic la Ka\'aba).',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5600.mp3',
                'answer' => '<p> Răspuns: Omrah este un act de adorare a lui Allah Preaînaltul realizat prin vizitarea Casei Sale Sacre. Poate fi efectuat oricând, fără a exista un timp fix, prestabilit. </p>',
            ],
            45 => [
                'question' => 'Întrebarea nr. 46: Care sunt stâlpii Omrah?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5630.mp3',
                'answer' => '<p> Răspuns: 1 - al-ihram <span class="c2">(intrarea în starea de sacralizare)</span><br /> 2 - înconjurarea rituală a Ka\'abah <span class="c2">(tauaf)</span><br /> 3 - parcugerea traseului dintre Safa și Marua <span class="c2">(as-sa\'y)</span> </p>',
            ],
            46 => [
                'question' => 'Întrebarea nr. 47: Ce este Jihad-ul pe calea lui Allah?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5690.mp3',
                'answer' => '<p> Răspuns: El presupune străduința și efortul depus în sensul răspândirii și apărării Islamului și a musulmanilor sau lupta împotriva dușmanilor <span class="c2">(și agresorilor)</span> Islamului și ai musulmanilor.<span class="c6"><br /> A spus Allah Preaînaltul:</span> <span class="c5">[...]</span> și luptați cu averile și sufletele voastre pe calea lui Allah! Aceasta este mai bine pentru voi, dacă pricepeți. <span class="c5">[Coran,<span class="c6"> 9:</span>41]</span> </p>',
            ],
        ],
        3 => [
            0 => [
                'question' => 'Întrebarea nr. 1: Care este descendența Profetului Mohammed (Pacea și binecuvântarea lui Allah fie asupra sa)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5740.mp3',
                'answer' => '<p> Răspuns: El este Mohammed, fiul lui Abdullah, fiul lui Abdul Muttalib, fiul lui Hașim, din tribul Quraiș, de origine arabă, care sunt dintre descendenții profetului Ismail, fiul profetului Avraam, pacea și binecuvântarea lui Allah fie asupra lor și a Profetului nostru. </p>',
            ],
            1 => [
                'question' => 'Întrebarea nr. 2: Care este numele mamei Profetului nostru (Pacea și binecuvântarea lui Allah fie asupra sa)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5770.mp3',
                'answer' => '<p> Răspuns: Amina, fiica lui Uahab. </p>',
            ],
            2 => [
                'question' => 'Întrebarea nr. 3: Când a murit tatăl său?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5800.mp3',
                'answer' => '<p> Răspuns: Tatăl său a murit în Medina, înainte ca Profetul <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> să se nască. </p>',
            ],
            3 => [
                'question' => 'Întrebarea nr. 4: Când s-a născut Profetul (Pacea și binecuvântarea lui Allah fie asupra sa)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5830.mp3',
                'answer' => '<p> Răspuns: În anul Elefantului, într-o zi de luni, în luna islamică Rabi\' al-Auual. </p>',
            ],
            4 => [
                'question' => 'Întrebarea nr. 5: În ce oraș s-a născut?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5850.mp3',
                'answer' => '<p> Răspuns: În Mecca. </p>',
            ],
            5 => [
                'question' => 'Întrebarea nr. 6: Cine l-a alăptat și a a avut grijă de el în afară de mama sa?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5880.mp3',
                'answer' => '<p> Răspuns: - Servitoarea tatălui său, Um Aiman.<br /> - Servitoarea unchiului său patern Abu Lahab, Thaubiah.<br /> - Halimah as-Sa\'adiah </p>',
            ],
            6 => [
                'question' => 'Întrebarea nr. 7: Când a murit mama sa?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5930.mp3',
                'answer' => '<p> Răspuns: Mama sa a murit atunci când el avea vârsta de 6 ani. Apoi a fost luat în grijă de bunicul său patern Abdul Muttalib. </p>',
            ],
            7 => [
                'question' => 'Întrebarea nr. 10: Cine l-a luat în grijă după moartea bunicului său Abdul Muttalib?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5960.mp3',
                'answer' => '<p> Răspuns: Bunicul său a murit atunci când el avea 8 ani, fiind luat în grijă de unchiul său patern Abu Talib. </p>',
            ],
            8 => [
                'question' => 'Întrebarea nr. 9: Când a călătorit cu unchiul său în ținutul Levantului?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5990.mp3',
                'answer' => '<p> Răspuns: A călătorit cu unchiul său în ținutul Levantului la vârsta de 12 ani. </p>',
            ],
            9 => [
                'question' => 'Întrebarea nr. 10: Când a călătorit pentru a doua oară?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6020.mp3',
                'answer' => '<p> Răspuns: A călătorit pentru a doua oară în scopuri comerciale în serviciul Khadijei <span class="c2">(Allah să fie mulțumit de ea)</span>, iar atunci când s-a întors din călătorie, el <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> s-a căsătorit cu ea, la vârsta de 25 de ani. </p>',
            ],
            10 => [
                'question' => 'Întrebarea nr. 11: Când a reconsolidat tribul Quraiș Ka\'abah?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6050.mp3',
                'answer' => '<p> Răspuns: Quraiș a reconsolidat Ka\'abah atunci când Profetul avea vârsta de 35 de ani.<br /> Atunci când au apărut dispute între ei cu privire la cine trebuie să pună la locul ei Piatra cea Neagră, ei i-au cerut lui Mohammed <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> să hotărască aceasta. Atunci, el a așezat Piatra cea Neagră pe o mantie și a cerut fiecărui lider de trib să apuce de un colț al acesteia. Ei erau în total patru triburi, iar atunci când au ridicat piatra la locul ei, Profetul a apucat-o și a pus-o la locul ei cu mâna sa. </p>',
            ],
            11 => [
                'question' => 'Întrebarea nr. 12: Ce vârstă a avut Profetul atunci când a primit profeția? Cui a fost trimis drept Profet?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6080.mp3',
                'answer' => '<p> Răspuns: Atunci când i-a fost trimisă Profeția, el avea vârsta de 40 de ani și a fost trimis ca Profet, vestitor și prevenitor, pentru întreaga omenire. </p>',
            ],
            12 => [
                'question' => 'Întrebarea nr. 13: Cum a început revelația?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6110.mp3',
                'answer' => '<p> Răspuns: Prin visul prevestitor adevărat, astfel încât tot ceea ce visa se adeverea în mod limpede, ca și zorii zilei. </p>',
            ],
            13 => [
                'question' => 'Întrebarea nr. 14: Care era situația sa înainte de a primi revelația? Când s-a pogorât asupra sa pentru prima oară revelația?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6140.mp3',
                'answer' => '<p> Răspuns: El mergea să Îl adore pe Allah în peștera Hira și acolo sporea actele de adorare.<br /> Revelația s-a pogorât asupra sa în vreme ce el se afla în peștera Hira, adorându-l pe Allah. </p>',
            ],
            14 => [
                'question' => 'Întrebarea nr. 15: Care este primul pasaj din Coran care i-a fost revelat?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6180.mp3',
                'answer' => '<p> Răspuns: Acesta este Cuvântul lui Allah Preaînaltul: 1. Citește! În Numele Domnului tău care a creat <span class="c5">[tot ceea ce există]</span>, 2. Care l-a creat pe om din sânge închegat! 3. Citește! Domnul tău este Cel mai Nobil, 4. Este Cel care l-a învățat cu calemul, 5. L-a învățat pe om ceea ce el nu a știut! <span class="c5">[Coran,<span class="c6"> 96:</span>1-5]</span> </p>',
            ],
            15 => [
                'question' => 'Întrebarea nr. 16: Cine a fost prima persoană care a crezut în Mesajul său profetic?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6200.mp3',
                'answer' => '<p> Răspuns: - Dintre bărbați Abu Bakr as-Siddiq, dintre femei Khadija bint Khuailid, dintre băieții tineri Ali ibn Abi Talib, dintre servitori Zaid ibn Haritha, iar dintre sclavi Bilal al-Habași <span class="c2">(Allah să fie mulțumit de ei toți)</span>. </p>',
            ],
            16 => [
                'question' => 'Întrebarea nr. 17: Cum se desfășura chemarea la Islam?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6230.mp3',
                'answer' => '<p> Răspuns: În primii 13 ani chemarea la Islam s-a desfășurat în mod secret, iar apoi Profetului <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> i s-a poruncit să cheme la Islam în mod deschis. </p>',
            ],
            17 => [
                'question' => 'Întrebarea nr. 18: Care era situația Profetului (Pacea și binecuvântarea lui Allah fie asupra sa) și cine a crezut în el după ce chemarea la Islam a devenit publică?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6260.mp3',
                'answer' => '<p> Răspuns: Persecutarea Profetului și a dreptcredincioșilor de către politeiști ajunsese la apogeu atunci când li s-a permis să emigreze în ținuturile regelui Negus în Abisinia.<br /> Politeiștii au convenit asupra asupririi și uciderii Profetului <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span>, însă Allah l-a protejat și l-a înconjurat cu protecția unchiului său patern, pentru a-l apăra de aceștia. </p>',
            ],
            18 => [
                'question' => 'Întrebarea nr. 19: Cine a murit în cel de al 10-lea an de la primirea Profeției?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6300.mp3',
                'answer' => '<p> Răspuns: În acel an a murit unchiul său patern Abu Talib și soția sa Khadija <span class="c2">(Allah să fie mulțumit de ea)</span>. </p>',
            ],
            19 => [
                'question' => 'Întrebarea nr. 20: Când a fost călătoria nocturnă (isra\') și înălțarea la ceruri (miraj)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6330.mp3',
                'answer' => '<p> Răspuns: Acestea au avut loc atunci când el avea vârsta de 50 de ani. Cu această ocazie a fost impusă obligativitatea celor 5 Rugăciuni zilnice.<br /> Al-Isra este călătoria nocturnă de la Moscheea cea Sfântă <span class="c2">(din Mecca)</span> la Moscheea al-Aqsa <span class="c2">(Ierusalim)</span>.<br /> Al-Miraj este înălțarea la Ceruri, care s-a produs din Moscheea al-Aqsa pănă în Ceruri, la Sidrat ul-Muntaha <span class="c2">(„lotusul de la capăt”, un pom în al șaptelea Cer)</span>. </p>',
            ],
            20 => [
                'question' => 'Întrebarea nr. 21: Cum îi chema Profetul (Pacea și binecuvântarea lui Allah fie asupra sa) la Islam pe oamenii din afara Meccăi?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6380.mp3',
                'answer' => '<p> Răspuns: El îi chema la Islam pe locuitorii din Taif și obișnuia să se prezinte oamenilor la întâlnirile acestora și cu anumite ocazii sezoniere. Până când oameni din Medina <span class="c2">(al-Ansar)</span> au venit la Mecca și au crezut în Profet <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> și i-au jurat credință și susținere. </p>',
            ],
            21 => [
                'question' => 'Întrebarea nr. 22: Cât a persistat chemarea la Islam a Profetului (Pacea și binecuvântarea lui Allah fie asupra sa) în Mecca?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6410.mp3',
                'answer' => '<p> Răspuns: A persistat 13 ani. </p>',
            ],
            22 => [
                'question' => 'Întrebarea nr. 23: Unde a emigrat Profetul (Pacea și binecuvântarea lui Allah fie asupra sa)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6440.mp3',
                'answer' => '<p> Răspuns: De la Mecca la Medina. </p>',
            ],
            23 => [
                'question' => 'Întrebarea nr. 24: Cât a rămas în Medina?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6470.mp3',
                'answer' => '<p> Răspuns: 10 ani. </p>',
            ],
            24 => [
                'question' => 'Întrebarea nr. 25: Ce obligații islamice i-au fost impuse pe perioada șederii sale în Medina?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6490.mp3',
                'answer' => '<p> Răspuns: I-a fost impus Zakatul, postul în Ramadan, Pelerinajul la Mecca, jihad-ul, adhan-ul <span class="c2">(chemarea la Rugăciune)</span>, precum și alte acte de adorare, impuneri și reglementări islamice. </p>',
            ],
            25 => [
                'question' => 'Întrebarea nr. 26: Care sunt cele mai importante bătălii duse de Profet (Pacea și binecuvântarea lui Allah fie asupra sa)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6520.mp3',
                'answer' => '<p> Răspuns: Marea bătălie de la Badr.<br /> Bătălia de la Uhud.<br /> Bătălia al-Ahzab.<br /> Bătălia cuceririi Meccăi. </p>',
            ],
            26 => [
                'question' => 'Întrebarea nr. 27: Care este ultimul pasaj care a fost revelat din Coran?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6580.mp3',
                'answer' => '<p> Răspuns: Cuvântul lui Allah: Şi fiţi cu frică de Ziua în care vă veţi întoarce la Allah, atunci când<br /> fiecare suflet va fi răsplătit după ceea ce a agonisit, iar ei nu vor fi<br /> nedreptăţiţi. <span class="c5">[Coran,<span class="c6"> 2:</span>281]</span> </p>',
            ],
            27 => [
                'question' => 'Întrebarea nr. 28: Când a murit Profetul (Pacea și binecuvântarea lui Allah fie asupra sa)? Ce vârstă avea?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6610.mp3',
                'answer' => '<p> Răspuns: A murit în luna islamică Rabia al-Auual, în anul 10 Hijri, la vârsta de 63 de ani. </p>',
            ],
            28 => [
                'question' => 'Întrebarea nr. 29: Menționează numele soțiilor Profetului (Pacea și binecuvântarea lui Allah fie asupra sa).',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6640.mp3',
                'answer' => '<p> Răspuns: 1 - Khadija bint Khuailid <span class="c2">(Allah să fie mulțumit de ea)</span><br /> 2 - Sauda bint Zam\'ah <span class="c2">(Allah să fie mulțumit de ea)</span><br /> 3 - Aișa bint Abu Bakr AsSiddiq <span class="c2">(Allah să fie mulțumit de ea)</span><br /> 4 - Hafsa bint Omar <span class="c2">(Allah să fie mulțumit de ea)</span><br /> 5 - Zainab bint Khuzaimah <span class="c2">(Allah să fie mulțumit de ea)</span><br /> 6 - Um Salama, Hind bint Abu Umaiah <span class="c2">(Allah să fie mulțumit de ea)</span><br /> 7 - Um Habibah bint Abu Sufian <span class="c2">(Allah să fie mulțumit de ea)</span><br /> 8 - Jueiriah bint al-Harith <span class="c2">(Allah să fie mulțumit de ea)</span><br /> 9 - Maimuna bint al-Harith <span class="c2">(Allah să fie mulțumit de ea)</span><br /> 10 - Safia bint Huyayi <span class="c2">(Allah să fie mulțumit de ea)</span><br /> 11 - Zeinab bint Jahș <span class="c2">(Allah să fie mulțumit de ea)</span> </p>',
            ],
            29 => [
                'question' => 'Întrebarea nr. 30: Cine sunt copiii Profetului (Pacea și binecuvântarea lui Allah fie asupra sa)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6760.mp3',
                'answer' => '<p> Răspuns: El a avut 3 băieți:<br /> Al-Qasim, după care era și Profetul denumit „Abu Al-Qasim„ <span class="c2">(tatăl lui Qasim)</span><br /> Abdullah<br /> și Ibrahim<br /> Și fete:<br /> Fatima<br /> Ruqayyah<br /> Um Kulthum<br /> și Zainab<br /> Toți copii săi au fost de la Khadijah <span class="c2">(Allah să fie mulțumit de ea)</span>, în afară de Ibrahim. Cu toții au murit înainte de el, în afară de Fatima, care a murit la 6 luni după acesta. </p>',
            ],
            30 => [
                'question' => 'Întrebarea nr. 31: Menționează câteva dintre trăsăturile fizice ale  Profetului (Pacea și binecuvântarea lui Allah fie asupra sa):',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6880.mp3',
                'answer' => '<p> El <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> nu era nici prea înalt, dar nici prea scund, ci avea o statură medie pentru un bărbat iar pielea era albă rozalie. Avea barba bogată, ochii mari, buzele cărnoase și părul de un negru intens. Avea umerii lați, mirosul plăcut și o înfățișare frumoasă. </p>',
            ],
            31 => [
                'question' => 'Întrebarea nr. 31: Ce a lăsat Profetul (Pacea și binecuvântarea lui Allah fie asupra sa) comunității sale?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6910.mp3',
                'answer' => '<p> Răspuns: Profetul <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> și-a lăsat comunitatea îndrumată pe o cale dreaptă și luminată, limpede precum se delimitează ziua de noapte, de la care nu deviază decât cel care este cu adevărat pierdut. El nu a lăsat nimic din ceea ce este bun, fără a ne îndruma către el, și nimic din ceea ce este rău fără a ne avertiza împotriva sa. </p>',
            ],
        ],
        4 => [
            0 => [
                'question' => 'Întrebarea nr. 1: Citește Capitolul (Surat) al-Fatiha și explică sensurile versetelor acestuia.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6960.mp3',
                'answer' => '<p> Răspuns: Aceasta este Capitolul <span class="c2">(Surat)</span> al-<span class="c6">Fatiha și sensurile acestuia:</span><br /> 1. În numele lui Allah Cel Milostiv <span class="c5">[Ar-Rahman]</span>, Îndurător <span class="c5">[Ar-Rahim]</span>, 2. <span class="c5">[Toată]</span> Lauda <span class="c5">[I se cuvine]</span> lui Allah, Stăpânitorul lumilor, 3. Cel Milostiv, Îndurător, 4. Suveranul Zilei Judecății. 5. Numai pe Tine Te adorăm, numai la Tine cerem ajutor, 6. Călăuzește-ne pe noi către Calea cea Dreaptă, 7. Calea celor asupra cărora Tu ai revărsat Îndurarea Ta, nu a celor pe care Tu Te-ai mâniat, și nici a celor care au rătăcit. <span class="c5">[Coran,<span class="c6"> 1:</span>1-7]</span><br /> Tafsir:<br /> A fost numit Capitolul <span class="c2">(Surat)</span> al Fatiha <span class="c2">(Deschizătoarea)</span> pentru că el este primul capitol din Cartea lui Allah.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001001.mp3"></audio> 1 - <span class="c2">(În numele lui Allah Cel Milostiv <span class="c5">[Ar-Rahman]</span>, Îndurător <span class="c5">[Ar-Rahim]</span>)</span> - în numele lui Allah încep recitarea Coranului, căutând ajutor la Acesta și căutând binecuvântările ce se revarsă prin pomenirea Numelui Său.<br /> <span class="c2">(Allah)</span>, adică Unicul adorat întru dreptate, Nume cu care nimeni altcineva în afară de El nu este numit, Preaslăvitul.<br /> <span class="c2">(Ar-Rahman)</span>, adică Cel a Cărui Milă <span class="c2">(și Îndurare)</span> este vastă și El cuprinde totul cu Mila Sa.<br /> <span class="c2">(Ar-Rahim)</span>, adică Cel care Îi cuprinde pe dreptcredincioși cu Mila și Îndurarea Sa.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001002.mp3"></audio> 2 - <span class="c2">(<span class="c5">[Toată]</span> Lauda <span class="c5">[I se cuvine]</span> lui Allah, Stăpânitorul lumilor)</span>,<span class="c6"> adică:</span> toate formele de Preamărire, precum și Perfecțiunea Îi aparțin doar lui Allah, Unicul.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001003.mp3"></audio> 3 - <span class="c2">(Cel Milostiv, Îndurător,)</span>,<span class="c6"> adică:</span> Cel a Cărui Milă și Îndurare vastă a cuprins totul, și Care i-a cuprins cu Îndurarea Sa <span class="c2">(într-un mod special)</span> pe dreptcredincioși.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001004.mp3"></audio> 4 - <span class="c2">(Suveranul Zilei Judecății.)</span>, adică Ziua de Apoi.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001005.mp3"></audio> 5 - <span class="c2">(Numai pe Tine Te adorăm, numai la Tine cerem ajutor)</span>, adică doar pe Tine, Unicul, Te adorăm și numai la Tine, Unicul, căutăm ajutor.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001006.mp3"></audio> 6 - <span class="c2">(Călăuzește-ne pe noi către Calea cea Dreaptă)</span>, adică îndrumarea și călăuzirea către Islam și către urmarea Tradițiilor Profetului <span class="c2">(Sunnah)</span>.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001007.mp3"></audio> 7 - <span class="c2">(Calea celor asupra cărora Tu ai revărsat Îndurarea Ta, nu a celor pe care Tu Te-ai mâniat, și nici a celor care au rătăcit)</span>, adică Calea robilor dreptcredincioși ai lui Allah, dintre Profeți și cei care i-au urmat pe aceștia, și nu calea urmată de creștini și de evrei.<br /> - după recitarea acesteia este din Sunnah să se spună „Amin”, adică „O, Allah, răspunde rugii noastre!”. </p>',
            ],
            1 => [
                'question' => 'Întrebarea nr. 2: Citește Capitolul (Surat) az-Zalzala și explică sensurile acestuia.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7130.mp3',
                'answer' => '<p> Răspuns: Aceasta este Capitolul <span class="c2">(Surat)</span> az-<span class="c6">Zalzala și interpretarea sensurilor acestuia:</span><br /> În numele lui Allah Cel Milostiv, Îndurător<br /> 1. Când Pământul va fi zgâlțâit de cutremurul său <span class="c5">[cel final]</span> 2. Și Pământul va scoate poverile lui 3.<span class="c6"> Și omul va zice:</span> „Ce se întâmplă cu el?”, 4. În ziua aceea, va spune el veștile ce le are, 5. Pentru că Domnul tău îi va inspira lui. 6. În Ziua aceea, oamenii vor ieși în cete, pentru ca să li se arate faptele<br /> lor. 7. Cel care a făcut un bine cât un grăunte de colb, îl va vedea, 8. După cum, cel care a făcut un rău cât un grăunte de colb, îl va vedea. Coran, <span class="c5">[99:1-8]</span><br /> Tafsir:<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099001.mp3"></audio> 1 - <span class="c2">(Când Pământul va fi zgâlțâit de cutremurul său <span class="c5">[cel final]</span>)</span>, adică Pământul va fi mișcat cu o zguduitură puternică, produsă în Ziua de Apoi.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099002.mp3"></audio> 2 - <span class="c2">(Și Pământul va scoate poverile lui)</span>, adică Pământul îi va scoate din adâncurile sale pe cei morți și toate cele ce se află în acesta.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099003.mp3"></audio> 3 - <span class="c2">(Și omul va zice: „Ce se întâmplă cu el?”)</span>, adică omul va spune uimit <span class="c2">(buimăcit)</span>: Ce se întâmplă cu Pământul de se mișcă și se zbuciumă?!<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099004.mp3"></audio> 4 - <span class="c2">(În ziua aceea, va spune el veștile ce le are)</span>, adică în acea Zi măreață <span class="c2">(înfricoșătoare)</span> Pământul va da de știre despre binele și răul ce s-au petrecut pe el.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099005.mp3"></audio> 5 - <span class="c2">(Pentru că Domnul tău îi va inspira lui.)</span>, adică, pentru că Allah l-a înștiințat despre aceasta și i-a poruncit să facă acest lucru.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099006.mp3"></audio> 6 - <span class="c2">(În Ziua aceea, oamenii vor ieși în cete, pentru ca să li se arate faptele<br /> lor)</span>, adică în acea Zi măreață <span class="c2">(înfricoșătoare)</span> în care Pământul se va zgudui, oamenii vor ieși în grupuri la locul de Judecată, pentru a privi faptele cărora ei le-au dat curs în viața lumească.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099007.mp3"></audio> 7 - <span class="c2">(Cel care a făcut un bine cât un grăunte de colb, îl va vedea)</span>, adică cel care va săvârși o faptă bună și evlavioasă chiar și atât de mică cât greutatea unei furnici minuscule, o va vedea înfățișată în fața lui.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099008.mp3"></audio> 8 - <span class="c2">(După cum, cel care a făcut un rău cât un grăunte de colb, îl va vedea)</span>, adică acela care va săvârși dintre faptele rele chiar și cât greutatea acesteia, le va vedea înfățișate în fața lui. </p>',
            ],
            2 => [
                'question' => 'Întrebarea nr. 3: Citește Capitolul (Surat) al-\'Adiyat și explică sensurile acestuia.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7270.mp3',
                'answer' => '<p> Răspuns: Capitolul <span class="c2">(Surat)</span> al-<span class="c6">\'Adiyat și sensurile acestuia:</span><br /> În numele lui Allah Cel Milostiv, Îndurător<br /> 1. Pe alergătorii gâfâind, 2. Ce scot scântei, 3. Și pornesc la atac dimineața, 4. Stârnind colbul, 5. Și pătrund cu el în mijlocul mulțimii! 6. Omul <span class="c5">[necredincios]</span> este nemulțumitor față de Domnul său! 7. Și el este martor pentru aceasta. 8. Și iubirea lui pentru bogăție este puternică! 9. Oare el nu știe că atunci când se va risipi ceea ce este în morminte <span class="c5">[la<br /> momentul Învierii]</span> 10. Și se va dezvălui ceea ce este în piepturi, 11. Cu adevărat, atunci Domnul lor, în Ziua aceea, va fi Khabir<br /> <span class="c5">[Bineștiutor]</span> al lor?! <span class="c5">[Coran,<span class="c6"> 100:</span>1-11]</span><br /> Tafsir:<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100001.mp3"></audio> 1 - <span class="c2">(Pe alergătorii gâfâind)</span>: Allah a jurat pe caii ce aleargă atât de grăbiți încât se poate auzi sunetul respirației lor.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100002.mp3"></audio> 2 - <span class="c2">(Ce scot scântei)</span>: și a jurat, de asemenea, pe caii care, datorită lovituri puternice a acestora scot scântei atunci când ating stâncile cu copitele lor,<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100003.mp3"></audio> 3 - <span class="c2">(Și pornesc la atac dimineața)</span>: și a jurat și pe caii care se avântă asupra inamicilor dis-de-dimineață.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100004.mp3"></audio> 4 - <span class="c2">(Stârnind colbul)</span>: împrăștiind țărâna atunci când aleargă.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100005.mp3"></audio> 5 - <span class="c2">(Și pătrund cu el în mijlocul mulțimii!)</span>: și cu călăreții lor pătrund în mijlocul mulțimii vrăjmașilor.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100006.mp3"></audio> 6 - <span class="c2">(Omul <span class="c5">[necredincios]</span> este nemulțumitor față de Domnul său!)</span>: omul se zgârcește în privința binelui pe care Domnul său i-l cere <span class="c2">(să îl facă)</span>.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100007.mp3"></audio> 7 - <span class="c2">(Și el este martor pentru aceasta)</span>: și el oprește și interzice cu putere ceea ce este bun și nu poate în niciun fel să nege acest fapt, datorită clarității lui.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100008.mp3"></audio> 8 - <span class="c2">(Și iubirea lui pentru bogăție este puternică)</span>: și din cauza iubirii nemăsurate pentru avere, el este zgârcit în privinta acesteia.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100009.mp3"></audio> - <span class="c2">(Oare el nu știe că atunci când se va risipi ceea ce este în morminte <span class="c5">[la<br /> momentul Învierii]</span>)</span>: oare acest om care este acaparat de viața lumească, nu știe că, atunci când Allah îi va învia pe cei morți din mormintele lor și îi va scoate din pământ pentru a fi judecați și recompensați pentru faptele lor, lucrurile nu vor sta nicidecum așa cum își imaginează el?!<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100010.mp3"></audio> - 10 <span class="c2">(Și se va dezvălui ceea ce este în piepturi)</span>: și vor fi scoase în evidență și făcute cunoscute intențiile, credințele și toate cele aflate în inimi.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100011.mp3"></audio> 11 <span class="c2">(Cu adevărat, atunci Domnul lor, în Ziua aceea, va fi Khabir <span class="c5">[Bineștiutor]</span> al lor)</span>: în acea Zi, cu adevărat, Domnul lor va fi Bineștiutor asupra lor. Nimic din ceea ce îi privește pe robii Săi nu Îi este ascuns Lui și El îi va răsplăti pe ei pentru aceasta. </p>',
            ],
            3 => [
                'question' => 'Întrebarea nr. 4: Citește Capitolul (Surat) al-Qari\'a și explică sensurile acestuia.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7450.mp3',
                'answer' => '<p> Răspuns: Capitolul <span class="c2">(Surat)</span> al-<span class="c6">Qari\'a și sensurile acestuia:</span><br /> În numele lui Allah Cel Milostiv, Îndurător<br /> 1. „Ziua aceea care lovește” <span class="c5">[Ora, Învierea]</span>! 2. Ce este „Ziua aceea care lovește”? 3. Și de unde să știi tu ce este „Ziua aceea care lovește”? 4. În Ziua aceea, oamenii vor fi ca fluturii risipiți, 5. Iar munții vor fi ca lâna scărmănată! 6. Cât despre cel ale cărui balanțe vor fi grele <span class="c5">[cu fapte bune]</span>, 7. El va avea parte de o viață plăcută, 8. Iar cât despre cel ale cărui balanțe vor fi ușoare, 9. Locul lui de veci va fi un abis. 10. Și de unde să știi tu ce este el? 11. El este un Foc fierbinte! <span class="c5">[Coran,<span class="c6"> 101:</span>1-11]</span><br /> Tafsir:<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101001.mp3"></audio> 1. „Ziua aceea care lovește” <span class="c5">[Ora, Învierea]</span>! - Ora care lovește inimile oamenilor din cauza groazei sale imensei<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101002.mp3"></audio> 2. Ce este „Ziua aceea care lovește”? - Ce este această Zi care lovește inimile oamenilor prin groaza imensă pe care o produce?!<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101003.mp3"></audio> 3. Și de unde să știi tu ce este „Ziua aceea care lovește”? - Și de unde să știi tu ce este această Oră care lovește inimile oamenilor prin groaza imensă pe care o produce?! Ea este cu adevărat Ziua de Apoi.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101004.mp3"></audio> 4. În Ziua aceea, oamenii vor fi ca fluturii risipiți, - În Ziua care lovește inimile oamenilor, ei vor fi asemenea fluturilor răvășiți și împrăștiați peste tot.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101005.mp3"></audio> 5. Iar munții vor fi ca lâna scărmănată! - Și munții vor fi asemenea lânei scărmănate, în usurința trecerii si mișcării lor<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101006.mp3"></audio> <span class="c2">(6. Cât despre cel ale cărui balanțe vor fi grele <span class="c5">[cu fapte bune]</span>)</span>: Însă în ceea ce îl privește pe cel ale cărui fapte bune le-au întrecut pe cele rele<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101007.mp3"></audio> <span class="c2">(7. El va avea parte de o viață plăcută)</span>: El va avea o viață plăcută în Paradis<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101008.mp3"></audio> <span class="c2">(8. Iar cât despre cel ale cărui balanțe vor fi ușoare)</span>: Însă în ceea ce îl privește pe cel ale cărui fapte rele au întrecut faptele bune<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101009.mp3"></audio> <span class="c2">(9. Locul lui de veci va fi un abis)</span>: Locul și destinația lui în Ziua Învierii va fi Iadul<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101010.mp3"></audio> <span class="c2">(10. Și de unde să știi tu ce este el?)</span>: Și de unde să știi tu, o, Profetule, ce este aceasta?!<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101011.mp3"></audio> <span class="c2">(11. El este un Foc fierbinte!)</span>: Acesta este un Foc de o fierbințeală cruntă. </p>',
            ],
            4 => [
                'question' => 'Cerința nr. 5: Citește Surat at-Takathur și explică sensurile acesteia.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7610.mp3',
                'answer' => '<p> Răspuns: Surat at-<span class="c6">Takathur și sensurile acesteia:</span><br /> În numele lui Allah Cel Milostiv, Cel Îndurător<br /> 1. Vă abate goana după înmulțire, 2. Până când veți vizita mormintele. 3. Nu! Voi veți ști curând! 4.<span class="c6"> Și încă o dată:</span> Nu! Voi veți ști curând! 5. Nu! Dacă ați ști cu siguranță! 6. Voi veți vedea Iadul! 7.<span class="c6"> Încă o dată:</span> Îl veți vedea, cu siguranță! 8. Apoi veți fi întrebați, în Ziua aceea, despre plăceri! <span class="c5">[Coran,<span class="c6"> 102:</span>1-8]</span><br /> Tafsir:<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102001.mp3"></audio> <span class="c2">(1. Vă abate goana după înmulțire)</span>: O, voi, oameni, v-a acaparat fala și lăudorășenia cu averile și urmașii voștri și ați lăsat supunerea față de Allah.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102002.mp3"></audio> <span class="c2">(2. Până când veți vizita mormintele)</span>: Până când veți muri și veți intra în mormintele voastre.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102003.mp3"></audio> .<br /> <span class="c2">(3. Nu! Voi veți ști curând!)</span>: Nu ar fi trebuit să vă acapareze lăudăroșenia cu acestea în defavoarea supunerii față de Allah și voi veți ști în curând care va fi consecința acestei abateri<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102004.mp3"></audio> <span class="c2">(4.<span class="c6"> Și încă o dată:</span> Nu! Voi veți ști curând!)</span>: Și apoi voi veți ști care este consecința acesteia.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102005.mp3"></audio> <span class="c2">(5. Nu! Dacă ați ști cu siguranță!)</span> - Cu adevărat, dacă voi ați ști cu siguranță că veți fi înviați și aduși la Allah și că veți fi răsplătiți pentru faptele voastre, nu v-ar fi acaparat lauda cu averile și copiii voștri.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102006.mp3"></audio> <span class="c2">(6. Voi veți vedea Iadul!)</span>: Jur pe Allah că voi veți vedea Focul în Ziua Învierii.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102007.mp3"></audio> <span class="c2">(7.<span class="c6"> Încă o dată:</span> Îl veți vedea, cu siguranță!)</span>: Apoi îl veți vedea cu siguranță și nu este nicio îndoială în această privință.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102008.mp3"></audio> <span class="c2">(8. Apoi veți fi întrebați, în Ziua aceea, despre plăceri!)</span>: Apoi, în acea Zi, Allah vă va întreba despre cele cu care El v-a binecuvântat, precum sănătatea, bogăția și altele. </p>',
            ],
            5 => [
                'question' => 'Cerința nr. 6: Citește Surat al-Asr și explică sensurile acesteia.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7750.mp3',
                'answer' => '<p> Răspuns: Surat al-<span class="c6">Asr și sensurile acesteia:</span><br /> În numele lui Allah Cel Milostiv, Cel Îndurător<br /> 1. Jur pe timp! 2. Că omul va fi în pierdere, 3. În afară de cei care cred și împlinesc fapte bune și se îndeamnă unul pe altul către Adevăr și se îndeamnă unul pe altul la răbdare. <span class="c5">[Coran,<span class="c6"> 103:</span>1-3]</span><br /> Tafsir:<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/103001.mp3"></audio> <span class="c2">(1. Jur pe timp!)</span>: Allah Preaslăvitul a jurat pe timp.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/103002.mp3"></audio> <span class="c2">(2. Că omul va fi în pierdere)</span>: Adică, fiecare om este în piedere și este supus pieirii<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/103003.mp3"></audio> <span class="c2">(3. În afară de cei care cred și împlinesc fapte bune și se îndeamnă unul pe altul către Adevăr și se îndeamnă unul pe altul la răbdare.)</span>: În afară de cei care au crezut și au făcut fapte bune și, de asemenea, au chemat la adevăr și au fost răbdători pe această cale, pentru că aceia sunt cei care vor fi salvați de la pieire. </p>',
            ],
            6 => [
                'question' => 'Cerința nr. 7: Citește Surat al-Humaza și explică sensurile ei.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7830.mp3',
                'answer' => '<p> Răspuns: Surat al-<span class="c6">Hamaza și sensurile ei:</span><br /> În numele lui Allah Cel Milostiv, Îndurător<br /> 1. Vai pentru tot clevetitorul și defăimătorul 2. Care strânge avere și o socotește, 3. Crezând că averea sa îl va face nemuritor! 4. Dar nu! El va fi aruncat în Al-Hutama! 5. Și de unde să știi tu ce este Al-Hutama? 6. Focul aprins al lui Allah, 7. Care se înalță peste inimi. 8. El se va închide deasupra lor, 9. În coloane întinse! <span class="c5">[Coran,<span class="c6"> 104:</span>1-9]</span><br /> Tafsir:<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104001.mp3"></audio> <span class="c2">(1. Vai pentru tot clevetitorul și defăimătorul)</span>: Ce oroare și ce chinuri crunte vor avea parte cei care îi bârfesc și îi insultă pe oameni<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104002.mp3"></audio> <span class="c2">(2. Care strânge avere și o socotește)</span>: Care nu a fost preocupat de nimic altceva în afară de strângerea averii și dobândirea ei.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104003.mp3"></audio> <span class="c2">(3. Crezând că averea sa îl va face nemuritor!)</span>: El crede că averea strânsă îl va salva de la moarte și că va rămâne veșnic în viața lumească.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104004.mp3"></audio> <span class="c2">(4. Dar nu! El va fi aruncat în al-Hutama!)</span>: Însă lucrurile nu stau așa cum presupune acest ignorant neștiutor, ci el va fi aruncat în Focul iadului, care, prin chinului lui, lovește și zdrobește tot ceea ce este aruncat în el<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104005.mp3"></audio> <span class="c2">(5. Și de unde să știi tu ce este al-Hutama?)</span>: Și de unde să știi tu, o, Profetule, ce este acest Foc, care distruge tot ce este aruncat în el?!<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104006.mp3"></audio> <span class="c2">(6. Focul aprins al lui Allah)</span>: Cu adevărat, acesta este Focul cel înverșunat al lui Allah.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104007.mp3"></audio> <span class="c2">(7. Care se înalță peste inimi.)</span>: Care pătrunde prin trupurile oamenilor către inimile lor.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104008.mp3"></audio> <span class="c2">(8. El se va închide deasupra lor,)</span>: El închide în interiorul ei pe cei păcătoși.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104009.mp3"></audio> <span class="c2">(9. În coloane întinse!)</span>: Cu stâlpi întinși înalți pentru a nu putea să iasă din el. </p>',
            ],
            7 => [
                'question' => 'Cerința nr. 8: Citește Surat al-Fil și explică sensurile acesteia.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7970.mp3',
                'answer' => '<p> Răspuns: Surat al-<span class="c6">Fil și sensurile ei:</span><br /> În numele lui Allah Cel Milostiv, Cel Îndurător<br /> 1. Oare n-ai văzut tu <span class="c5">[Mohammed]</span> ce a făcut Domnul tău cu oamenii<br /> elefantului? 2. Oare nu a făcut El vicleșugul lor să fie în deșert? 3. Și a trimis peste ei păsări în stoluri, 4. Ca să arunce asupra lor cu pietre din lut ars! 5. Și i-a făcut pe ei asemenea paielor mâncate <span class="c5">[Coran,<span class="c6"> 105:</span>1-5]</span><br /> Tafsir:<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105001.mp3"></audio> <span class="c2">(1. Oare n-ai văzut tu <span class="c5">[Mohammed]</span> ce a făcut Domnul tău cu oamenii<br /> elefantului?)</span>: Oare știi tu, o, Trimisule, ce a făcut Domnul tău cu Abrahama și oamenii elefantului atunci când ei au dorit să demoleze Ka\'abah?!<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105002.mp3"></audio> <span class="c2">(2. Oare nu a făcut El vicleșugul lor să fie în deșert?)</span>: Allah a făcut ca planurile lor diabolice de a demola Ka\'abah să eșueze, și astfel ei nu au reușit să îi îndepărteze pe oameni de la Ka\'abah, așa cum își doreau și nu au obținut nimic din ceea ce intenționau.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105003.mp3"></audio> <span class="c2">(3. Și a trimis peste ei păsări în stoluri,)</span>: Și a trimis păsări care s-au abătut asupra lor în stoluri<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105004.mp3"></audio> <span class="c2">(4. Ca să arunce asupra lor cu pietre din lut ars!)</span>: Ca să arunce asupra lor cu pietre din lut întărit.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105005.mp3"></audio> <span class="c2">(5. Și i-a făcut pe ei asemenea paielor mâncate)</span>: Și astfel Allah i-a făcut asemenea frunzelor plantelor care au fost mâncate <span class="c2">(și mestecate)</span> și strivite în picioare de animale. </p>',
            ],
            8 => [
                'question' => 'Cerința nr. 9: Citește Surat Quraiș și explică sensurile acesteia.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8070.mp3',
                'answer' => '<p> Răspuns: Surat Quraiș și sensurile acesteia:<br /> În numele lui Allah Cel Milostiv, Cel Îndurător<br /> 1. Pentru obiceiul <span class="c5">[poporului]</span> Quraiș 2. Obiceiul lor pentru călătoria de iarnă și cea de vară, 3. Să-L adore ei pe Stăpânul acestei Case, 4. Care-i hrănește, păzindu-i de foame și-i ferește pe ei de spaimă! <span class="c5">[Coran,<span class="c6"> 106:</span>1-4]</span><br /> Tafsir:<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106001.mp3"></audio> <span class="c2">(1. Pentru obiceiul <span class="c5">[poporului]</span> Quraiș,)</span>: Aceasta face referire la obiceiul lor de a călători iarna, dar și vara<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106002.mp3"></audio> <span class="c2">(2. Obiceiul lor pentru călătoria de iarnă și cea de vară)</span>: Călătoria în siguranță - iarna în Yemen, iar vara în ținutul Levantului.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106003.mp3"></audio> <span class="c2">(3. Să-L adore ei pe Stăpânul acestei Case)</span>: Să Îl adore numai pe Allah Unicul, Domnul acestei Case Sfinte, Cel care le-a facilitat aceste călătorii și să nu Îi facă pe nimeni asociat Lui.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106004.mp3"></audio> <span class="c2">(4. Care-i hrănește, păzindu-i de foame și-i ferește pe ei de spaimă!)</span>: Care le-a potolit foamea și le-a îndepărtat teama prin sădirea în inimile arabilor a măreției Casei Sfinte și a locuitorilor ei. </p>',
            ],
            9 => [
                'question' => 'Cerința nr. 10: Citește Surat al-Ma\'aun și explică sensurile acesteia.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8160.mp3',
                'answer' => '<p> Răspuns: Surat al-<span class="c6">Ma\'un și interpretarea sensurilor ei:</span><br /> În numele lui Allah Cel Milostiv, Îndurător<br /> 1. Îl vezi tu pe cel care tăgăduiește Judecata? 2. El este cel care-l alungă pe orfan <span class="c5">[cu duritate]</span> 3. Și nu încurajează hrănirea sărmanului. 4. Și vai celor care fac Rugăciunea <span class="c5">[fiind fără de grijă față de ea]</span> 5. Cei care întârzie Rugăciunea lor <span class="c5">[până la timpul în care aceasta iese]</span> 6. Care sunt numai ipocriți 7. Și opresc de la ajutor. <span class="c5">[Coran,<span class="c6"> 107:</span>1-7]</span><br /> Tafsir:<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107001.mp3"></audio> <span class="c2">(1. Îl vezi tu pe cel care tăgăduiește Judecata?)</span>: Oare ai tu cunoștință despre cel care minte în privința Zilei Învierii?<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107002.mp3"></audio> <span class="c2">(2. El este cel care-l alungă pe orfan <span class="c5">[cu duritate]</span>)</span>: El este cel care îl respinge puternic și cu răutate pe orfanul aflat în nevoie<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107003.mp3"></audio> <span class="c2">(3. Și nu încurajează hrănirea sărmanului.)</span>: Și nu se îndeamnă pe sine însuși și nici pe ceilalți să ofere hrană celor săraci<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107004.mp3"></audio> <span class="c2">(4. Și vai celor care fac Rugăciunea <span class="c5">[fiind fără de grijă față de ea]</span>)</span>: Celor care fac Rugăciunea <span class="c2">(fiind neglijenți față de ea)</span> le este destinată pieirea și pedeapsa cruntă.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107005.mp3"></audio> <span class="c2">(5. Cei care întârzie Rugăciunea lor <span class="c5">[până la timpul în care aceasta iese]</span>)</span>: Care sunt distrași de la Rugăciunea lor și sunt neglijenți în privința ei, până ce trece timpul ei<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107006.mp3"></audio> <span class="c2">(6. Care sunt numai ipocriți)</span>: Care înfăptuiesc Rugăciunile și faptele lor numai de ochii lumii și nu le împlinesc în mod sincer, doar de dragul lui Allah<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107007.mp3"></audio> <span class="c2">(7. Și opresc de la ajutor.)</span>: Și interzic ajutorarea celorlalți cu ceea ce nu îl afectează pe el cu nimic. </p>',
            ],
            10 => [
                'question' => 'Cerința nr. 11: Citește Surat Al-Kauthar și explică sensurile ei.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8280.mp3',
                'answer' => '<p> Răspuns: Surat Al-<span class="c6">Kauthar și sensurile ei:</span><br /> În numele lui Allah Cel Milostiv, Îndurător<br /> 1. Cu adevărat, Noi ți-am dat ție <span class="c5">[Mohammed]</span> prisosință <span class="c5">[al-Kawthar]</span>. 2. Deci împlinește Rugăciunea pentru Domnul tău și jertfește <span class="c5">[doar Lui]</span>! 3. Cu adevărat, cel ce te urăște va fi fără copii! <span class="c5">[Coran,<span class="c6"> 108:</span>1-3]</span><br /> Tafsir:<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/108001.mp3"></audio> <span class="c2">(1. Cu adevărat, Noi ți-am dat ție <span class="c5">[Mohammed]</span> prisosință <span class="c5">[al-Kawthar]</span>.)</span>: O, tu, Profetule! Noi ți-am dat mult bine și binecuvântări și printre acestea și râul al-Kauthar în Paradis<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/108002.mp3"></audio> <span class="c2">(2. Deci împlinește Rugăciunea pentru Domnul tău și jertfește <span class="c5">[doar Lui]</span>!)</span>: Așadar mulțumește-i lui Allah pentru această binecuvântare prin îndreptarea Rugăciunilor tale numai către El, Unicul, și jertfirea animalelor de sacrificiu numai în numele Său, și nu așa cum politeiștii îi adoră pe idolii lor, făcându-le sacrificii<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/108003.mp3"></audio> <span class="c2">(3. Cu adevărat, cel ce te urăște va fi fără copii!)</span>: Într-adevăr, cel care îți poartă pizmă va fi privat de orice binecuvântare și va fi uitat, pomenirea sa făcându-se doar prin ceea ce este rău </p>',
            ],
            11 => [
                'question' => 'Cerința nr. 13: Citește Surat Al-Kafirun și explică sensurile acesteia.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8360.mp3',
                'answer' => '<p> Răspuns: Surat Al-<span class="c6">Kafirun și sensurile ei:</span><br /> În numele lui Allah Cel Milostiv, Îndurător<br /> 1.<span class="c6"> Spune:</span> „O, voi, necredincioșilor! 2. Eu nu ador ceea ce voi adorați 3. Și nici voi nu adorați ceea ce ador eu. 4. Și eu nu voi adora ceea ce voi adorați 5. Și nici voi nu veți adora ceea ce ador eu 6. Voi aveți religia voastră, iar eu am religia mea!” <span class="c5">[Coran,<span class="c6"> 109:</span>1-6]</span><br /> Tafsir:<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109001.mp3"></audio> <span class="c2">(1.<span class="c6"> Spune:</span> „O, voi, necredincioșilor!)</span>: O, Profetule,<span class="c6"> spune:</span> O, voi, cei care nu credeți în Allah!<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109002.mp3"></audio> <span class="c2">(2. Eu nu ador ceea ce voi adorați)</span>: Eu nu ador, nici acum și nu voi adora nici în viitor, idolii pe care voi îi adorați<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109003.mp3"></audio> <span class="c2">(3. Și nici voi nu adorați ceea ce ador eu.)</span> Și nici voi nu Îl adorați pe Allah, Unicul, Cel pe care eu Îl ador<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109004.mp3"></audio> <span class="c2">(4. Și eu nu voi adora ceea ce voi adorați)</span>: Și nici eu nu sunt adoratorul idolilor pe care voi i-ați adorat<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109005.mp3"></audio> <span class="c2">(5. Și nici voi nu veți adora ceea ce ador eu)</span>: Și nici voi nu Îl adorați pe Allah Unicul, Cel pe care eu Îl ador<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109006.mp3"></audio> <span class="c2">(6. Voi aveți religia voastră, iar eu am religia mea!)</span>: Voi aveți religia pe care ați inventat-o pentru voi înșivă și eu am religia mea, cea pe care Allah mi-a revelat-o </p>',
            ],
            12 => [
                'question' => 'Cerința nr. 13: Citește Surat an-Nasr și explică sensurile acesteia.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8470.mp3',
                'answer' => '<p> Răspuns: Surat An-<span class="c6">Nasr și sensurile acesteia:</span><br /> În numele lui Allah Cel Milostiv, Îndurător<br /> 1. Când vine biruința lui Allah și cucerirea 2. Și-i vezi pe oameni intrând în religia lui Allah în cete, 3. Atunci slăvește-L cu laudă pe Domnul tău și roagă-L pe El de<br /> iertare, fiindcă El este Tauuab <span class="c5">[Iertător]</span> <span class="c5">[cu cel care se căiește]</span>! <span class="c5">[Coran,<span class="c6"> 103:</span>1-3]</span><br /> Tafsir:<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/110001.mp3"></audio> <span class="c2">(1. Când vine biruința lui Allah și cucerirea)</span>: O, Trimisule, dacă a venit izbânda garantată de Allah religiei Sale și înălțarea ei și a avut loc deschiderea Mekkăi<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/110002.mp3"></audio> <span class="c2">(2. Și-i vezi pe oameni intrând în religia lui Allah în cete,)</span>: Și îi vezi pe oameni acceptând Islamul în grupuri<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/110003.mp3"></audio> <span class="c2">(3. Atunci slăvește-L cu laudă pe Domnul tău și roagă-L pe El de<br /> iertare, fiindcă El este Tauuab <span class="c5">[Iertător]</span> <span class="c5">[cu cel care se căiește]</span>!)</span>: Ia cunoștință că acesta este un semn că se apropie încheierea misiunii cu care ai fost trimis, așadar, preamărește-L pe Domnul tău, mulțumindu-I pentru binecuvântarea victoriei și a izbândei și roagă-te la El pentru iertare, căci El, cu adevărat, este Iertător și primește căința robilor Săi și îi iartă pe ei. </p>',
            ],
            13 => [
                'question' => 'Cerința nr. 14: Citește Surat al-Masad și menționează sensurile acesteia.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8550.mp3',
                'answer' => '<p> Răspuns: Surat al-<span class="c6">Masad și sensurile acesteia:</span><br /> În numele lui Allah Cel Milostiv, Îndurător<br /> 1. Să piară mâinile lui Abu Lahab și să piară și el! 2. Averea lui să nu-i fie de niciun folos și nici ce a agonisit! 3. Va arde în Focul cu flăcări, 4. Împreună cu muierea lui, aducătoarea de vreascuri, 5. Care va avea la gâtul ei o funie de fire <span class="c5">[de palmier]</span>. <span class="c5">[Coran,<span class="c6"> 111:</span>1-5]</span><br /> Tafsir:<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111001.mp3"></audio> <span class="c2">(1. Să piară mâinile lui Abu Lahab și să piară și el!)</span>: Mâna unchiului Profetului <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span>, Abu Lahab ibn Abdu al-Muttalib, va fi sortită pierzaniei, drept consecință a faptelor sale prin care îl rănea pe Profet <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span>, însă intenția sa nu a fost împlinită<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111002.mp3"></audio> <span class="c2">(2. Averea lui să nu-i fie de niciun folos și nici ce a agonisit!)</span> - Oare îi va fi de folos averea sau urmașii săi? Acestea nu vor putea să-i îndepărteze pedeapsa și nici să-i aducă îndurare<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111003.mp3"></audio> <span class="c2">(3. Va arde în Focul cu flăcări,)</span>: În Ziua Învierii el va ajunge în Focul cu flăcări aprinse, de o fierbințeală cruntă<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111004.mp3"></audio> <span class="c2">(4. Împreună cu muierea lui,aducătoarea de vreascuri,)</span> - și va intra în el și soția sa, Um Jamil, care îl rănea pe Profet <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span>, aruncând spini în calea sa<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111005.mp3"></audio> <span class="c2">(5. Care va avea la gâtul ei o funie de fire <span class="c5">[de palmier]</span>.)</span>: Ea are împrejurul gâtului ei o frânghie bine strânsă, cu care este târâtă către Focul iadului </p>',
            ],
            14 => [
                'question' => 'Cerința nr. 15: Citește Surat al-Ikhlas și explică sensurile acestei.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8650.mp3',
                'answer' => '<p> Răspuns: Surat al-<span class="c6">Ikhlas și sensurile acesteia:</span><br /> În numele lui Allah Cel Milostiv, Îndurător<br /> 1.<span class="c6"> Spune:</span> „El este Allah, Cel Unic! 2. Allah-us-Samad! 3. El nu zămislește și nu este născut 4. Și El nu are pe nimeni egal!” <span class="c5">[Coran,<span class="c6"> 112:</span>1-4]</span><br /> Tafsir:<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112001.mp3"></audio> <span class="c2">(1.<span class="c6"> Spune:</span> „El este Allah, Cel Unic!)</span>: Spune, o,<span class="c6"> Mesagerule:</span> El este Allah în afară de care nu există alt Dumnezeu<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112002.mp3"></audio> <span class="c2">(2. Allah-us-Samad!)</span>: Spre El se îndreaptă cererile tuturor făpturilor, pe care El le-a creat, pentru a le fi satisfăcute nevoile<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112003.mp3"></audio> <span class="c2">(3. El nu zămislește și nu este născut)</span>: El, Preaslăvitul, nu are un fiu și nici nu are tată<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112004.mp3"></audio> <span class="c2">(4. Și El nu are pe nimeni egal!)</span>: Nimic din ceea ce El a creat nu I se aseamănă </p>',
            ],
            15 => [
                'question' => 'Cerința nr. 16: Citește Surat al-Falaq și explică sesnurile acesteia.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8750.mp3',
                'answer' => '<p> Răspuns: Surat al-<span class="c6">Falaq și sensurile acesteia:</span><br /> În numele lui Allah Cel Milostiv, Îndurător<br /> 1.<span class="c6"> Spune:</span> „Eu caut adăpost la Stăpânul revărsatului zorilor 2. Împotriva răului <span class="c5">[venind]</span> de la ceea ce El a creat 3. Și împotriva răului întunericului care se așterne 4. Și împotriva răului vrăjitoarelor care suflă în noduri 5. Și împotriva răului pizmuitorului, când pizmuiește.” <span class="c5">[Coran,<span class="c6"> 113:</span>1-5]</span><br /> Tafsir:<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113001.mp3"></audio> <span class="c2">(1.<span class="c6"> Spune:</span> „Eu caut adăpost la Stăpânul revărsatului zorilor)</span>: Spune, o,<span class="c6"> Trimisule:</span> Eu caut forța și protecția la Domnul dimineții<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113002.mp3"></audio> <span class="c2">(2. Împotriva răului <span class="c5">[venind]</span> de la ceea ce El a creat)</span>: De răul pe care îl produc creațiile Sale<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113003.mp3"></audio> <span class="c2">(3. Și împotriva răului întunericului care se așterne)</span>: Și caut adăpost la Allah de relele care se ivesc noaptea, de fiare și de hoți.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113004.mp3"></audio> <span class="c2">(4. Și împotriva răului vrăjitoarelor care suflă în noduri)</span>: Și caut adăpost la Allah de răul vrăjitoarelor care suflă în noduri<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113005.mp3"></audio> <span class="c2">(5. Și împotriva răului pizmuitorului, când pizmuiește.)</span>: Și de răul celui invidios, care îi urăște pe oameni și îi invidiază pentru binecuvântările primite de la Allah și care își dorește ca acestea să dispară și să se abată asupra lor ceea ce este rău. </p>',
            ],
            16 => [
                'question' => 'Cerința nr. 17: Citește Surat an-Nas și explică sensurile acesteia.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8870.mp3',
                'answer' => '<p> Răspuns: Surat An-<span class="c6">Nas și sensurile acesteia:</span><br /> În numele lui Allah Cel Milostiv, Îndurător<br /> 1.<span class="c6"> Spune:</span> „Eu caut adăpost la Domnul oamenilor, 2. Stăpânul oamenilor, 3. Dumnezeul oamenilor 4. Împotriva răului ademenitorului fugar 5. Care șoptește în piepturile oamenilor 6. Dintre djinni și oameni <span class="c5">[Coran,<span class="c6"> 114:</span>1-6]</span><br /> Tafsir:<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114001.mp3"></audio> <span class="c2">(1.<span class="c6">Spune:</span> „Eu caut adăpost la Domnul oamenilor)</span>: Spune, o, tu, Mesagerule, eu caut adăpost și protecție la Domnul tuturor oamenilor<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114002.mp3"></audio> <span class="c2">(2. Stăpânul oamenilor)</span>: Cel care are Putere asupra lor în tot ce voiește și nu există niciun alt Stăpân pentru ei în afară de El<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114003.mp3"></audio> <span class="c2">(3. Dumnezeul oamenilor)</span>: Cel adorat întru dreptate și în afară de Care nu există nimeni altcineva adorat întru dreptate<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114004.mp3"></audio> <span class="c2">(4. Împotriva răului ademenitorului fugar)</span>: De răul Șeitanului care le insuflă oamenilor rătăcirea sa<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114005.mp3"></audio> <span class="c2">(5. Care șoptește în piepturile oamenilor)</span>: Ale cărui insinuări ajung la inimile oamenilor<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114006.mp3"></audio> <span class="c2">(6. Dintre djinni și oameni)</span>: Adică cel care le insuflă oamenilor poate fi și dintre oameni și dintre djini </p>',
            ],
        ],
        5 => [
            0 => [
                'question' => 'Cerința nr. 1: Completează următorul hadis și menționează câteva dintre semnificațiile benefice ale acestuia: „Cu adevărat, faptele sunt (judecate) după intențiile lor....”.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9030.mp3',
                'answer' => '<p> Răspuns: Conducătorul dreptcredincioșilor, Abu Hafs Omar ibn al-Khattab <span class="c2">(Allah să fie mulțumit de el)</span> a spus: „L-am auzit pe Mesagerul lui Allah <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> spunând: „Cu adevărat, faptele sunt <span class="c2">(judecate)</span> după intențiile lor și fiecare va obține ceea ce a intenționat. Astfel, cel care a emigrat pentru Allah și pentru Mesagerul Său, emigrarea sa va fi <span class="c2">(primită)</span> pentru Allah și pentru Mesagerul Său; iar cel care a emigrat pentru a obține un avantaj în viața lumească sau pentru o femeie cu care dorește să se căsătorească, el va avea <span class="c2">(ca răsplată)</span> pentru emigrarea sa ceea ce El a intenționat.<span class="c6">" Consemnat de Bukhari și Muslim<br /> Semnificațiile benefice ale hadisului:</span><br /> 1. Pentru fiecare faptă, precum Rugăciune, Post, Pelerinaj și celelalte fapte <span class="c2">(de adorare)</span> trebuie să fie formulată o intenție.<br /> 2. Este absolut necesar ca intenția formulată să fie sinceră, de dragul lui Allah Preaînaltul.<span class="c6"><br /> * Al doilea hadis:</span> </p>',
            ],
            1 => [
                'question' => 'Cerința nr. 2: Completează următorul hadis și menționează semnificațiile benefice ale acestuia: „Cel care a introdus o inovație în religie, aceasta îi va fi respinsă și neacceptată de către Allah.”',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9090.mp3',
                'answer' => '<p> Răspuns: Mama dreptcredincioșilor, Aișa <span class="c2">(Allah să fie mulțumit de ea)</span>, a relatat că Mesagerul lui Allah <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> a spus: „Cel care a introdus o inovație în religie, aceasta îi va fi respinsă și neacceptată de către Allah.<span class="c6">” Relatat de Bukhari și Muslim<br /> Semnificațiile benefice ale hadisului:</span><br /> 1 - interzicerea introducerii inovațiilor în religie<br /> 2 -<span class="c6"> faptele care presupun inovații sunt respinse și nu sunt acceptate<br /> * Al treilea hadis:</span> </p>',
            ],
            2 => [
                'question' => 'Cerința nr. 3: Completează următorul hadis și menționează câteva dintre semnificațiile benefice ale acestuia: „Într-o zi, în vreme ce ședeam împreună cu Mesagerul lui Allah (Pacea și binecuvântarea lui Allah fie asupra sa)...”',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9160.mp3',
                'answer' => '<p> Răspuns: „Într-o zi, în vreme ce ședeam împreună cu Mesagerul lui Allah <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span>, și-a făcut apariția printre noi un om îmbrăcat cu haine albe, curate și părul de un negru intens, pe care nu se vedea urma vreunei călătorii și pe care niciunul dintre noi nu îl cunoștea. El s-a așezat lângă Profet <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span>, și-a sprijinit genunchiul de genunchiul Profetului, și-<span class="c6">a pus mâinile pe coapsele lui și a zis:</span> „O, Mohammad, spune-<span class="c6">mi despre Islam!” El a spus:</span> „Islamul înseamnă să mărturisești că nu există altă divinitate demnă de a fi adorată în afară de Allah și că Mohammad este Mesagerul lui Allah, să îndeplinești Rugăciunea, să plătești Dania, să postești în luna Ramadan și să faci Pelerinajul la Casa cea Sfântă, dacă ai această posibilitate.<span class="c6">” Omul a spus:</span> „<span class="c2">(Așa este!)</span> Ai spus adevărul.” Iar noi ne-am mirat că el îi punea întrebări, iar apoi tot el aproba răspunsul primit.<span class="c6"> Apoi a zis:</span> „Spune-<span class="c6">mi ce este credința!” El a răspuns:</span> „Credința înseamnă să crezi în Allah, în Îngerii Săi, în Scripturile Sale, în Profeții trimiși de El, în Ziua de Apoi și în Destin, cu ceea ce este bun și rău în el.<span class="c6">” A spus:</span> „<span class="c2">(Așa este!)</span> Ai spus adevărul.<span class="c6">” Și apoi a spus:</span> „Înștiințează-mă despre ihsan <span class="c2">(perfecționare)</span>!” <span class="c2">(Profetul)</span> a spus: „Să Îl adori pe Allah ca și cum L-ai vedea, pentru că dacă tu nu Îl vezi, El cu adevărat te vede.” <span class="c2">(Străinul)</span> a spus: „Spune-<span class="c6">mi despre Ceasul de Apoi!” El a răspuns:</span> „Cel căruia îi este adresată întrebarea nu știe nimic mai mult decât cel care îl întreabă.<span class="c6">” El a spus:</span> „Înștiințează-<span class="c6">mă atunci despre semnele sale!” A răspuns:</span> „Atunci când sclava va da naștere stăpânului ei și vei vedea oameni desculți, dezbrăcați, nevoiași și păstori de oi întrecându-se în construirea de clădiri tot mai înalte.” Apoi, străinul s-a îndepărtat și, după ce am așteptat îndelung, Profetul <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> a spus: „O, Omar,<span class="c6"> știi cine era cel care îmi punea întrebări?” Am spus:</span> „Allah și Mesagerul Său știu mai bine!” Profetul <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> a răspuns: „Acesta era Îngerul Gavriil, care a venit să vă învețe religia voastră.<span class="c6">” Consemnat de Muslim<br /> Dintre semnificațiile benefice ale hadisului:</span><br /> 1 - Menționarea celor 5 stâlpi ai Islamului,<span class="c6"> și anume:</span><br /> Mărturisirea că nu există altă divinitate demnă de a fi adorată în afară de Allah și că Mohammad este Mesagerul lui Allah.<br /> Împlinirea Rugăciunii.<br /> Plătirea Daniei <span class="c2">(Zakat)</span>.<br /> Postul în luna Ramadan <span class="c2">(Saum)</span>.<br /> Pelerinajul la Casa cea Sfântă <span class="c2">(Hajj)</span>.<br /> 2 - Menționarea stâlpilor credinței,<span class="c6"> în număr de 6:</span><br /> Credința în Allah.<br /> Și în Îngeri Săi<br /> Și în Cărțile Sale<br /> Și în Profeții Săi<br /> Și în Ziua de Apoi<br /> Și în Destin, cu ceea ce este bun și rău în el.<br /> 3 - Menționarea stâlpului de bază al „ihsan”-ului, și anume adorarea lui Allah ca și cum L-ai vedea, pentru că dacă tu nu Îl poți vedea, cu adevărat El te vede.<br /> 4 - Timpul în care va veni Ceasul de Apoi nu este cunoscut decât de către Allah Preaînaltul.<span class="c6"><br /> Cel de al patrulea hadis:</span> </p>',
            ],
            3 => [
                'question' => 'Cerința nr. 4: Completează următorul hadis și menționează semnificațiile benefice ale acestuia: „Dreptcredinciosul cu cea mai deplină credință...”.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9360.mp3',
                'answer' => '<p> Răspuns: Abu Huraira <span class="c2">(Allah să fie mulțumit de el)</span> a relatat că Mesagerul lui Allah <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> a spus: „Dreptcredinciosul cu cea mai deplină credință este acela cu cel mai bun caracter.<span class="c6">” Consemnat de Tirmidhi și catalogat ca hadis hasan sahih<br /> Semnificațiile benefice ale hadisului:</span><br /> 1 - Încurajarea dobândirii unui caracter ales<br /> 2 - Perfecțiunea caracterului este un semn al perfecțiunii credinței<br /> 3 - Credința crește și scade<br /> Cel de-<span class="c6">al cincilea hadis:</span> </p>',
            ],
            4 => [
                'question' => 'Cerința nr. 5: Completează și menționează semnificațiile benefice ale următorului hadis: „Cel care a jurat pe altcineva în afară de Allah...”',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9440.mp3',
                'answer' => '<p> Răspuns: Ibn Omar <span class="c2">(Allah să fie mulumit de ei)</span> a relatat că Profetul <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> a spus: „Cel care a jurat pe altcineva în afară de Allah a comis un act de necredință sau politeism.<span class="c6">” Consemnat de Tirmidhi<br /> Semnificațiile benefice ale hadisului:</span><br /> - Nu este permis să se jure pe altcineva în afară de Allah Preaînaltul<br /> - A jura pe altcineva în afară de Allah Preaînaltul este un act de politeism minor<br /> Cel de-<span class="c6">al șaselea hadis:</span> </p>',
            ],
            5 => [
                'question' => 'Cerința nr. 6: Completează și menționează semnificațiile benefice ale următorului hadis: „Nu este (cu adevărat) dreptcredincios acela pentru care eu nu sunt mai iubit decât....”',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9510.mp3',
                'answer' => '<p> Răspuns: Anas <span class="c2">(Allah să fie mulțumit de el)</span> a relatat că Mesagerul lui Allah <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> a spus: „Nu este <span class="c2">(cu adevărat)</span> dreptcredincios cel pentru care eu sunt mai puțin iubit decât părintele său, fiul său și toți oamenii la un loc.<span class="c6">” Consemnat de Bukhari și Muslim<br /> Dintre semnificațiile benefice ale hadisului:</span><br /> - Trebuie să îl iubim pe Profet <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> mai presus decât toți oamenii<br /> -<span class="c6"> Aceasta este o expresie a perfecțiunii credinței<br /> Al șaptelea hadis:</span> </p>',
            ],
            6 => [
                'question' => 'Cerința nr. 7: Completează și menționează semnificațiile benefice ale următorului hadis: „Nu crede (cu adevărat) cel dintre voi care nu iubește pentru fratele său ....”',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9580.mp3',
                'answer' => '<p> Răspuns: Anas <span class="c2">(Allah să fie mulțumit de el)</span> a relatat că Mesagerul lui Allah <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> a spus: „Nu crede <span class="c2">(cu adevărat)</span> cel dintre voi care nu iubește pentru fratele său ceea ce iubește și pentru sine însuși.<span class="c6">” Consemnat de Bukhari și Muslim<br /> Dintre semnificațiile benefice ale hadisului:</span><br /> 1 - Dreptcredinciosul trebuie să iubească pentru ceilalți dreptcredincioși ceea ce iubește și pentru sine însuși<br /> -<span class="c6"> iar aceasta este o expresie a credinței<br /> Al optulea hadis:</span> </p>',
            ],
            7 => [
                'question' => 'Cerința nr. 8: Completează și menționează semnificațiile benefice ale următorului hadis: „Jur pe (Allah) Cel în Mâna Căruia se află sufletul meu....”',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9650.mp3',
                'answer' => '<p> Răspuns: Abu Sa\'id <span class="c2">(Allah să fie mulțumit de el)</span> a relatat că Mesagerul lui Allah <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> a spus: „Jur pe Allah, Cel în Mâna Căruia se află sufletul meu, că Surat al-Ikhlas este echivalentă cu o treime din Coran.<span class="c6">” Consemnat de Bukhari<br /> Dintre semnificațiile benefice ale hadisului:</span><br /> 1 - Virtuțile Surat al-Ikhlas<br /> 2 -<span class="c6"> Faptul că aceasta este echivalentă cu o treime de Coran<br /> Cel de al nouălea hadis:</span> </p>',
            ],
            8 => [
                'question' => 'Cerința nr. 9: Completează următorul hadis și menționează câteva dintre semnificațiile sale benefice: „La haula ua la quata illa billah (nu există tărie și nici putere decât cu și prin Allah)....”',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9720.mp3',
                'answer' => '<p> Răspuns: Abu Musa <span class="c2">(Allah să fie mulțumit de el)</span> a relatat că Mesagerul lui Allah <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> a spus: „La haula ua la quata illa billah <span class="c2">(nu există tărie și nici putere decât cu și prin Allah)</span> este una dintre comorile Paradisului.<span class="c6">” Consemnat de Bukhari și Muslim<br /> Dintre beneficiile hadisului:</span><br /> 1 - Virtuțile acestei expresii și faptul că ea este o comoară dintre comorile Paradisului<br /> 2 - Detașarea robului față de puterea proprie și depenedența sa doar de Allah Preaînaltul, Unicul.<span class="c6"><br /> Cel de al zecelea hadis:</span> </p>',
            ],
            9 => [
                'question' => 'Cerința nr. 10: Completează și menționează câteva dintre beneficiile următorului hadis: „Ia aminte! Cu adevărat în corp există o bucățică (de carne)...”',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9790.mp3',
                'answer' => '<p> Răspuns: Nu\'man ibn Bașir <span class="c2">(Allah să fie mulțumit de ei)</span> a relatat că l-a auzit pe Mesagerul lui Allah <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> spunând: „Ia aminte! Cu adevărat în corp există o bucățică <span class="c2">(de carne)</span> care, dacă este bună și dreaptă, tot corpul este bun și drept, iar dacă este stricată, tot corpul este stricat <span class="c2">(odată cu ea)</span>. Cu adevărat, aceasta este inima.<span class="c6">” Consemnat de Bukhari și Muslim<br /> Dintre beneficiile hadisului:</span><br /> 1 - Atunci când inima este bună și dreaptă tot ceea ce este vizibil sau ascuns este bun și drept<br /> 2 - Importanța acordării unei atenții deosebite inimii,<span class="c6"> pentru că de bunătatea și dreptatea acesteia depinde bunătatea și dreptatea omului<br /> Al unsprezecelea hadis:</span> </p>',
            ],
            10 => [
                'question' => 'Cerința nr. 11: Completează și menționează câteva dintre beneficiile următorului hadis: „Cel ale cărui ultime cuvinte în această viață au fost «La ilaha illa Allah (Nu există alt dumnezeu demn de a fi adorat în afară de Allah)»...”',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9860.mp3',
                'answer' => '<p> Răspuns: Mu\'adh ibn Jabal <span class="c2">(Allah să fie mulțumit de el)</span> a relatat că Mesagerul lui Allah <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> a spus: „Cel ale cărui ultime cuvinte în această viață au fost «La ilaha illa Allah <span class="c2">(Nu există alt dumnezeu demn de a fi adorat în afară de Allah)</span>», va intra în Paradis.<span class="c6">” Consemnat de Abu Daud<br /> Dintre beneficiile hadisului:</span><br /> 1 - Virtuțile expresiei „La ilaha illa Allah”, prin care omul va intra în Paradis<br /> 2 -<span class="c6"> Virtuțile de care se bucură cel ale cărui ultime cuvinte în această viață sunt „La ilaha illa Allah”<br /> Al doisprezecelea hadis:</span> </p>',
            ],
            11 => [
                'question' => 'Cerința nr. 12: Completează și menționează câteva dintre beneficiile următorului hadis: „Un adevărat dreptcredincios nu este calomniator, nici blestemător...”',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9940.mp3',
                'answer' => '<p> Răspuns: Abdullah ibn Mas\'ud <span class="c2">(Allah să fie mulțumit de el)</span> a relatat că Mesagerul lui Allah <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> a spus: „Un adevărat dreptcredincios nu este calomniator, nici blestemător, nici imoral și nici nerușinat.<span class="c6">” Consemnat de Tirmidhi<br /> Dintre beneficiile hadisului:</span><br /> 1 - Interzicerea vorbelor neadevărate și urâte<br /> 2 -<span class="c6"> Aceasta este calitatea de bază a vorbelor unui dreptcredincios<br /> Al treisprezecelea hadis:</span> </p>',
            ],
            12 => [
                'question' => 'Cerința nr. 13: Completează și menționează câteva dintre beneficiile următorului hadis: „Un semn al perfecțiunii Islamului la un om...”',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10020.mp3',
                'answer' => '<p> Răspuns: Abu Huraira <span class="c2">(Allah să fie mulțumit de el)</span> a relatat că Mesagerul lui Allah <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> a spus: „Un semn al perfecțiunii Islamului la un om este detașarea de lucrurile care nu îl privesc.<span class="c6">” Consemnat de Tirmidhi și alții<br /> Dintre beneficiile hadisului:</span><br /> 1 - Omul trebuie să se detașaze și să nu acorde importanță lucrurilor care nu îl privesc referitor la religia și viața celorlalți<br /> 2 - Detașarea de cele care nu îl privesc este o expresie a perfecțiunii religiei sale <span class="c2">(a Islamului său)</span><br /> Al patrusprezecelea hadis: </p>',
            ],
            13 => [
                'question' => 'Cerința nr. 14: Completează și menționează câteva dintre semnificațiile benefice ale următorului hadis: „Cel care a citit o literă din Cartea lui Allah (Coran)...”',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10100.mp3',
                'answer' => '<p> Abdullah ibn Mas\'ud <span class="c2">(Allah să fie mulțumit de el)</span> a relatat că Profetul <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> a spus: „Cel care a citit o literă din Cartea lui Allah <span class="c2">(Coran)</span> are pentru ea o faptă bună consemnată și pentru fiecare faptă bună îi sunt consemnate încă zece asemenea ei. Eu nu spun că <span class="c3">«alif, lam, mim»</span> sunt toate împreună o literă, ci <span class="c3">«alif»</span> este o literă de sine stătătoare, <span class="c3">«lam»</span> este o literă de sine stătătoare și <span class="c3">«mim»</span> este o literă de sine stătătoare.<span class="c6">" Consemnat de Tirmidhi<br /> Dintre beneficiile hadisului:</span><br /> 1 - Virtuțile recitării Coranului<br /> 2 - Pentru fiecare literă din Coran pe care o citești îți sunt consemnate <span class="c2">(mai multe)</span> fapte bune </p>',
            ],
        ],
        6 => [
            0 => [
                'question' => 'Întrebarea nr. 1: Care sunt manierele relaționarii cu Allah Preaînaltul?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10190.mp3',
                'answer' => '<p> 1 - Preamărirea Lui Preaslăvitul și Preaînaltul.<br /> 2 - Adorarea numai a Sa, Unicul, fără de nimeni altcineva<br /> 3 - Supunerea arătată față de El<br /> 4 - Neîncălcarea poruncilor Sale<br /> 5 - Mulțumirea ce se cuvine numai Lui, Preaslăvitul, pentru oferirea Harului și a Binecuvântărilor Sale nenumărate.<br /> 6 - Răbdarea în întâmpinarea destinului pe care El l-a prescris </p>',
            ],
            1 => [
                'question' => 'Întrebarea nr. 2: Care sunt manierele relaționarii cu Profetul Mohammad (Pacea și binecuvântarea lui Allah fie asupra sa)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10270.mp3',
                'answer' => '<p> Răspuns: 1 - Urmarea exemplului său<br /> 2 - Ascultarea<br /> 3 - Neîncălcarea poruncilor sale<br /> 4 - Credința în autenticitatea celor pe care el le-a vestit<br /> 5 - A nu aduce inovații în religie<br /> 6 - Iubirea față de el mai presus de iubirea de sine și de ceilalți oameni<br /> 7 - Acordarea respectului și statutului cuvenit lui, susținerea sa și a Tradițiilor sale </p>',
            ],
            2 => [
                'question' => 'Întrebarea nr. 3: Care sunt manierele relaționarii cu părinții?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10360.mp3',
                'answer' => '<p> Răspuns: 1 - Supunerea arătată față de părinți și ascultarea lor în tot ceea ce nu presupune un păcat.<br /> 2 - Servirea părinților<br /> 3 - Ajutorul acordat părinților<br /> 4 - Împlinirea nevoilor părinților<br /> 5 - Rugile pentru părinți<br /> 6 - Adresarea într-o manieră respectuoasă, fără a rosti nici măcar expresia „Uf!” atunci când se discută cu ei, unul dintre cele mai neînsemnate cuvinte <span class="c2">(de nemulțumire)</span><br /> 7 - Zâmbetul permanent în fața părinților, fără a manifesta față de ei nicio formă de încruntare<br /> 8 - Interzicerea ridicării vocii la aceștia, ascultarea cu atenție a ceea ce ei spun, fără a îi întrerupe atunci când vorbesc. Ei nu trebuie chemați după numele lor, ci folosind apelativele „mama” și ”tata”<br /> 9 - Cererea permisiunii de a intra în camera în care ei se află<br /> 10 - Sărutarea mâinii și capului părinților </p>',
            ],
            3 => [
                'question' => 'Întrebarea nr. 4: Care sunt manierele relaționarii cu rudele de sânge?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10490.mp3',
                'answer' => '<p> Răspuns: 1 - Vizitarea rudelor, precum fratele, sora, mătușile și unchii materni și paterni și celelalte rude de sânge<br /> 2 - A arăta bunătate față de aceștia prin vorbe și fapte și prin ajutorarea lor<br /> 3 - A întreba despre situația lor </p>',
            ],
            4 => [
                'question' => 'Întrebarea nr. 5: Care sunt manierele relaționarii cu frații și prietenii mei?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10550.mp3',
                'answer' => '<p> Răspuns: 1 - Trebuie să îi iubesc și să mă întovărășesc cu cei buni și drepți<br /> 2 - Mă feresc și mă îndepărtez de cei răi<br /> 3 - Îi întâmpin cu salutul păcii și dau mâna cu frații mei întru credință<br /> 4 - Dacă sunt bolnavi îi vizitez și mă rog pentru însănătoșirea lor<br /> 5 - Atunci când strănută și Îl laudă pe Allah, le răspund și mă rog ca Allah să le arate iertare și îndurare<br /> 6 - Răspund invitației dacă m-au chemat să îi vizitez<br /> 7 - Le ofer sfatul meu sincer<br /> 8 - Dacă sunt nedreptățiți îi sprijin, iar dacă ei nedreptățesc pe cineva, îi opresc<br /> 9 - Le doresc ceea ce iubesc și pentru mine însumi<br /> 10 - Îi ajut atunci când au nevoie de ajutor<br /> 11 - Nu îi rănesc prin vorbe sau fapte<br /> 12 - Păstrez secretele lor<br /> 13 - Nu îi insult, nu îi vorbesc de rău, nu îi disprețuiesc, nu îi invidiez, nu îi spionez și nu îi trădez. </p>',
            ],
            5 => [
                'question' => 'Întrebarea nr. 6: Care sunt manierele relaționarii cu vecinii?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10710.mp3',
                'answer' => '<p> Răspuns: 1 - Arăt bunătate față de vecini prin vorbe și fapte și îi ajut dacă au nevoie de ajutorul meu<br /> 2 - Îi felicit cu ocazia Sărbătorilor islamice, a căsătoriei sau a altor ocazii fericite<br /> 3 - Îi vizitez dacă sunt bolnavi și le transmit condoleanțe în cazul unui deces<br /> 4 - Le ofer ceea ce este posibil din mâncarea pe care o pregătesc<br /> 5 - Nu îi rănesc prin vorbele sau faptele mele<br /> 6 - Nu îi deranjez făcând gălăgie, nu îi spoinez și sunt răbdător cu ei </p>',
            ],
            6 => [
                'question' => 'Întrebarea nr. 7: Care sunt manierele referitoare la ospitalitate?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10800.mp3',
                'answer' => '<p> Răspuns: 1 - Onorez invitațiile<br /> 2 - Dacă doresc să vizitez pe cineva, îi cer permisiunea și stabilesc anterior o anumită dată<br /> 3 - Cer permisiunea de a intra<br /> 4 - Nu prelungesc prea mult vizita<br /> 5 - Nu privesc la ceea ce nu este permis în casa gazdei<br /> 6 - Le urez bun venit musafirilor și îi întâmpin în cel mai bun mod cu putință, cu zâmbetul pe buze și cu cele mai frumoase cuvinte<br /> 7 - Îl invit pe musafir să ia loc în cel mai bun loc posibil<br /> 8 - Îl onorez cu ospitalitatea mea atunci când îi ofer de mâncat și de băut </p>',
            ],
            7 => [
                'question' => 'Întrebarea nr. 8: Care sunt manierele referitoare la cel bolnav și la vizitarea lui?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10900.mp3',
                'answer' => '<p> Răspuns: 1 -<span class="c6"> Atunci când simt o durere pun mâna pe locul unde simt durerea şi spun:</span> „Bismillah” de 3 ori <span class="c2">(În numele lui Allah)</span>,<span class="c6"> apoi spun de 7ori:</span> „‘Audhu bi-\'izzati-llahi ua qudratih min şarri ma agidu ua-uhadhir” <span class="c2">(Caut adăpost în Măreția lui Allah şi în Atotputernicia Lui de răul a ceea ce resimt şi de care mă feresc)</span><br /> 2 - Accept cele pe care Allah mi le-a prescris și sunt răbdător<br /> 3 - Îl vizitez fără ezitare și fără întârziere pe fratele meu bolnav, mă rog pentru vindecarea lui și fac în așa fel încât vizita mea să nu fie lungă<br /> 4 - Citesc pentru el versete din Coran cu intenția tămăduirii lui prin acestea, fără a aștepta ca el să îmi ceară acest lucru<br /> 5 - Îl sfătuiesc să fie răbdător și să facă rugi către Allah, precum și să păstreze starea de purificare și să își îndeplinească rugăciunile, atât cât poate<br /> 6 -<span class="c6"> Ruga pentru cel bolnav este:</span> „As’alu Allaha l-’adhim rabbal-’arşil-<br /> ’adhim an yaşfik” <span class="c2">(Îi cer lui Allah cel Preamăreţ, Stăpânul Tronului cel Mare, să te vindece)</span> și se repetă de 7 ori </p>',
            ],
            8 => [
                'question' => 'Întrebarea nr. 9: Care sunt manierele referitoare la căutarea științei?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10990.mp3',
                'answer' => '<p> Răspuns: 1 - Intenția sinceră de dragul lui Allah Atotputernicul<br /> 2 - Punerea în practică a cunoașterii dobândite<br /> 3 - Respectul arătat față de profesor și elogierea lui, atât în prezența, cât și în absența sa<br /> 4 - Stau în fața sa cu respect<br /> 5 - Ascult cu atenție ceea ce spune și nu îl întrerup în decursul lecției<br /> 6 - Pun întrebări cu respect<br /> 7 - Nu îl strig pe nume </p>',
            ],
            9 => [
                'question' => 'Întrebarea nr. 10: Care sunt manierele referiotare la întruniri?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11090.mp3',
                'answer' => '<p> Răspuns: 1 - Îi salut pe cei care se află deja în întrunire<br /> 2 - Mă așez acolo unde este loc, fără a ridica pe cineva pentru a mă așeza eu și nu mă așez între două persoane, decât după ce le-am cerut permisiunea<br /> 3 - Le fac loc altora să se așeze în întrunire<br /> 4 - Nu întrerup discuția care are loc în întrunire<br /> 5 - Înainte de a părăsi întrunirea cer permisiunea de a pleca și îi salut pe cei prezenți<br /> 6 - La sfârșitul întrunirii spun ruga pentru ispășirea păcatelor „Subhanak allahumma ua bihamdik, aşhadu an la ilaha illa ant, astaghfiruka uaatubu ilayk” <span class="c2">(Cât de Măreţ şi Perfect eşti Tu, O, Allah, şi toată Lauda fie a Ta! Mărturisesc că nu există altă divinitate demnă de a fi adorată în afară de Tine. Caut iertarea Ta şi mă întorc la Tine cu căinţă)</span> </p>',
            ],
            10 => [
                'question' => 'Întrebarea nr. 11: Care sunt manierele referitoare la dormit?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11180.mp3',
                'answer' => '<p> Răspuns: 1 - Merg la culcare devreme<br /> 2 - Mă culc în stare de purificare<br /> 3 - Nu dorm pe burtă<br /> 4 - Dorm pe partea dreaptă, cu palma dreaptă sub obrazul drept<br /> 5 - Scutur salteaua înainte de a dormi<br /> 6 - Rostesc pomenirile de dinainte de a dormi, precum versetul al-Kursy <span class="c2">(Coran,<span class="c6"> 2:</span>255)</span>, Surat al-Ikhlas, Surat al-Falaq și Surat an-<span class="c6">Nas de 3 ori și spun:</span> „Bismika-llahumma amutu ua-ahya.” <span class="c2">(În numele Tău O, Allah, mor şi<br /> trăiesc <span class="c5">[adorm şi mă trezesc]</span>!)</span><br /> 7 - Mă trezesc pentru îndeplinirea rugăciunii de Fajr<br /> 8 -<span class="c6"> La trezirea din somn spun:</span> „Alhamdu lillahil-ladhi ahyana ba’da ma amatana ua-ilayhin-nuşur.” <span class="c2">(Laudă lui Allah, Care ne-a dăruit viaţa după ce ne-a luat-o şi la El este Învierea!)</span> </p>',
            ],
            11 => [
                'question' => 'Întrebarea nr. 12: Care sunt manierele referitoare la mâncare?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11290.mp3',
                'answer' => '<p> Răspuns:<br /> 1 - Îmi propun ca prin cele pe care le mănânc și le beau să devin mai puternic în supunerea mea față de Allah Preaputernicul<br /> 2 - Mă spăl pe mâini înainte de a mânca<br /> 3 - Spun „Bismillah” <span class="c2">(În numele lui Allah)</span> și mănânc cu mâna dreaptă din cele care se află în fața mea. Nu mănânc din mijlocul platoului și nici din ceea ce se află în fața altcuiva.<br /> 4 - Dacă am uitat să spun „Bismillah” la început,<span class="c6"> atunci spun când îmi aduc aminte:</span> „Bismillah aualihi ua akhirihi” <span class="c2">(În numele lui Allah, la început și la sfârșit)</span><br /> 5 - Mă mulțumesc cu mâncarea care există și nu fac remarci răutăcioase cu privire la aceasta; dacă îmi place mănânc, iar dacă nu, nu mănânc<br /> 6 - Mănânc o porție mică și nu mănânc cantități mari de mâncare<br /> 7 - Nu suflu în mâncare sau în băutură, ci aștept până se răcește<br /> 8 - Mânânc împreună cu ceilalți din familie sau musafiri<br /> 9 - Nu încep să mănânc înaintea celor care sunt mai în vârstă ca mine<br /> 10 - Pomenesc numele lui Allah atunci când beau ceva, beau așezat și din trei înghițituri<br /> 11 - Îl laud pe Allah și Îi mulțumesc atunci când termin de mâncat </p>',
            ],
            12 => [
                'question' => 'Întrebarea nr. 13: Care sunt manierele referitoare la îmbrăcăminte?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11440.mp3',
                'answer' => '<p> Răspuns: 1 - Încep îmbrăcarea hainelor cu partea dreaptă și Îi mulțumesc lui Allah pentru acestea<br /> 2 - În cazul bărbaților nu las ca lungimea veșmântului să ajungă sub glezne, pentru femei însă, trebuie să ajungă la pământ, pentru a acoperi corpul în întregime<br /> 3 - Băieții nu trebuie să îmbrace haine de fete, iar fetele nu trebuie să îmbrace haine de băieți<br /> 4 - Interzicerea asemănării hainelor cu cele specifice necredincioșilor sau nelegiuiților<br /> 5 - Pomenirea numelui lui Allah la dezbrăcarea veșmintelor<br /> 6 - Încălțarea se începe cu piciorul drept, iar descălțarea cu cel stâng </p>',
            ],
            13 => [
                'question' => 'Întrebarea nr. 14: Care sunt manierele referitoare la urcarea într-un vehicul?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11540.mp3',
                'answer' => '<p> Răspuns: 1 - „Bismillah, ualhamdulillah” <span class="c2">(În numele lui Allah şi Laudă lui<br /> Allah!)</span> „Subhanalladhi sakh-khara lana hadha uama kunna lahu muqrinin” <span class="c2">(Cât de Măreţ şi Perfect este El, Cel care a pus la dispoziţia noastră acest mijloc de transport, în vreme ce noi n-am fi fost capabili de acest lucru)</span> „uainna ila rabbina lamunqalibun” <span class="c2">(şi, cuadevărat, la Domnul nostru este întoarcerea noastră finală!)</span> <span class="c2">(Coran,<span class="c6"> 43:</span>13-14)</span><br /> 2 - Dacă trec pe lângă un musulman îl salut cu salutul islamic „Assalamu aleykum„ <span class="c2">(Pace vouă)</span> </p>',
            ],
            14 => [
                'question' => 'Întrebarea nr. 15: Care sunt manierele referitoare la drumurile publice?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11590.mp3',
                'answer' => '<p> 1 - Merg pe partea dreaptă a drumului meu, având o ținută dreaptă, moderată și modestă în același timp<br /> 2 - Îi salut pe cei pe care îi întâlnesc<br /> 3 - Îmi feresc privirea de la cele nepermise și nu fac rău nimănui<br /> 4 - Îndemn la ceea ce este bun și opresc de la ceea ce este rău<br /> 5 - Îndepărtez obstacolele sau ceea ce este dăunător de pe drumurile publice </p>',
            ],
            15 => [
                'question' => 'Întrebarea nr. 16: Care sunt manierele referitoare la intrarea și ieșirea din casă?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11670.mp3',
                'answer' => '<p> Răspuns: 1 -<span class="c6"> Ies din casă cu piciorul stâng și spun:</span> „Bismillah, tauakkaltu ‘alallah, ua la haula ua la quuuata illa billah. Allahumma inni ‘audhu bika an adilla au udall, au azilla au uzall, au adhlima au udhlam, au agihala au yugihala ‘alay.”<br /> <span class="c2">(În numele lui Allah! Mă încred în Allah şi mărturisesc că nu există forţă sau putere decât cu Allah! O Allah, caut adăpost la Tine de a rătăci sau de a fi rătăcit, de a greşi sau de a fi atras în greşeală, de a asupri sau de a fi asuprit, de a mă purta nesăbuit sau a fi tratat cu nesăbuinţă.)</span> 2 -<span class="c6"> Intru în casă cu piciorul drept și spun:</span> „Bismillahi ualagina, ua bismillahi kharagina, ua’ala rabbina tauakkalna.” <span class="c2">(În numele lui Allah am intrat şi în numele lui Allah am ieşit şi în Domnul nostru ne încredem!)</span><br /> 3 - Folosesc siwak-ul și îi salut pe cei din casă </p>',
            ],
            16 => [
                'question' => 'Întrebarea nr. 17: Care sunt manierele referitoare la satisfacerea nevoilor?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11730.mp3',
                'answer' => '<p> Răspuns: 1 - Intrarea la baie se face cu piciorul stâng<br /> 2 -<span class="c6"> Înainte de a intra la toaletă se spune următoarea rugă:</span> <span class="c2">(Bismillah)</span> allahumma inni ‘Audhu bika minal-khubthi ual-khaba-ith. - <span class="c2">(În numele lui Allah!)</span> O, Allah, caut adăpost la Tine de necurat şi de necurate<br /> <span class="c5">[de diavoli]</span>!<br /> 3 - Nu iau cu mine la toaletă nimic pe care să fie menționat numele lui Allah<br /> 4 - Nu îmi fac nevoile în public<br /> 5 - Nu port conversații în locul în care îmi fac nevoile<br /> 6 - Nu mă îndrept în direcția Qiblei și nici nu întorc spatele către ea în timp ce îmi fac nevoile<br /> 7 - Folosirea mâinii stângi și nicidecum a mâinii drepte la îndepărtarea murdăriei după ce îmi fac nevoile<br /> 8 - Nu îmi fac nevoile pe cărările pe unde merg oamenii și nici în locurile unde aceștia caută umbră sau unde se odihnesc<br /> 9 - Mă spăl pe mâini după ce mi-am făcut nevoile<br /> 10 -<span class="c6"> Ies de la baie cu piciorul stâng și spun:</span> „Ghufranak” <span class="c2">(O, Allah, iartă-mă!)</span> </p>',
            ],
            17 => [
                'question' => 'Întrebarea nr. 18: Care sunt manierele referitoare la  moschee?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11860.mp3',
                'answer' => '<p> Răspuns: 1 -<span class="c6"> Intru în moschee cu piciorul drept și spun:</span> „Bismillah! Allahumma iftah li abuaba rahmatik!” <span class="c2">(În numele lui Allah. <br /> O Allah, deschide-mi porțile Îndurării Tale!)</span><br /> 2 - Nu mă așez înainte de a mă ruga 2 unități de rugăciune<br /> 3 - Nu merg prin fața celor care fac rugăciunea, nu intonez cântece interzise în moschee și nici nu vând sau cumpăr ceva în interiorul moscheii<br /> 4 -<span class="c6"> Ies din moschee cu piciorul stâng și spun:</span> „Allahuma inni as\'aluka min fadlak” <span class="c2">(O Allah, îți cer din binecuvântările Tale!)</span> </p>',
            ],
            18 => [
                'question' => 'Întrebarea nr. 19: Care sunt manierele referitoare la salutul islamic?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11930.mp3',
                'answer' => '<p> Răspuns: 1 - Atunci când întâlnesc un musulman îl salut spunându-<span class="c6">i:</span> „Assalamu aleykum ua rahmatullahi ua barakatuhu” <span class="c2">(Pacea, îndurarea și binecuvântarea lui Allah fie asupra voastră)</span> și nu înlocuiesc salutul rostit cu salutarea prin gesticulare<br /> 2 - Îi zâmbesc celui pe care îl salut<br /> 3 - Dau mâna cu el folosind mâna dreaptă<br /> 4 - Îi răspund celui care mă salută cu un salut mai bun decât cel cu care m-a salutat sau cel puțin cu unul asemănător acestuia<br /> 5 - Nu îl salut pe un nemusulman cu salutul islamic, iar dacă el m-a salutat cu un alt salut îi răspund întocmai cum m-a salutat el<br /> 6 - Trebuie să salute mai întâi cel tânăr pe cel mai în vârstă, cel care este într-un mijloc de transport pe cel care merge pe jos, cel care merge pe cel care este așezat, un grup mai mic pe un grup mai mare de persoane </p>',
            ],
            19 => [
                'question' => 'Întrebarea nr. 20: Care sunt manierele referitoare la cererea permisiunii?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12020.mp3',
                'answer' => '<p> Răspuns: 1 - Cer permisiunea înainte de a intra într-un loc anume<br /> 2 - Cer permisiunea de a intra <span class="c2">(spre exemplu sunând sau bătând la ușă)</span> de 3 ori și dacă nu mi se răspunde plec<br /> 3 - Bat la ușă încet și nu mă poziționez exact în fața ușii, ci în dreapta sau în stânga acesteia<br /> 4 - Nu intru în încăperea în care se află mama mea, tatăl meu sau oricine alcineva fără a cere permisiunea, mai ales în timpul de dinainte de rugăciunea de Fajr, în timpul perioadei de odihnă de dinainte de rugăciunea de Dhuhr sau după rugăciunea de \'Ișa<br /> 5 - În locurile publice și care nu sunt locuințe, precum spitalele sau magazinele, pot intra fără a cere permisiunea </p>',
            ],
            20 => [
                'question' => 'Întrebarea nr. 21: Care sunt manierele referitoare la bunătatea arătată față de animale?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12100.mp3',
                'answer' => '<p> Răspuns: 1 - Le dau de mâncare și de băut animalelor<br /> 2 - Arăt îndurare și milă față de animale și nu mă port cu ele într-o manieră nepotrivită<br /> 3 - Nu le fac rău animalelor sub nicio formă </p>',
            ],
            21 => [
                'question' => 'Întrebarea nr. 22: Care sunt manierele referitoare la  practicarea sportului?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12160.mp3',
                'answer' => '<p> Răspuns: 1 - Îmi pun intenția ca prin activitățile sportive efectuate să devin mai puternic pentru a mă putea supune și mai bine lui Allah și pentru a-L mulțumi<br /> 2 - Nu practic activitățile sportive în intervalul destinat timpului pentru rugăciune <span class="c2">(neglijându-mi rugăciunea)</span><br /> 3 - Fetele și băieții nu desfășoară activități sportive împreună<br /> 4 - Port un echipament sportiv potrivit, care să acopere toate părțile corpului care trebuie acoperite <span class="c2">(aura)</span><br /> 5 - Nu practic sporturile care sunt interzise, precum cele care presupun lovire feței sau dezgolirea corpului </p>',
            ],
            22 => [
                'question' => 'Întrebarea nr. 23: Care sunt manierele referitoare la modalitatea de a face glume?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12240.mp3',
                'answer' => '<p> Răspuns: 1 - Glumele nu trebuie să presupună niciun fel de minciună<br /> 2 - Glumele nu trebuie să presupună ridiculizarea cuiva, batjocura, abuzul sau înfricoșarea sa<br /> 3 - Glumele trebuie să fie moderate și să nu li se dea curs în exces </p>',
            ],
            23 => [
                'question' => 'Întrebarea nr. 24: Care sunt manierele referitoare la strănut?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12300.mp3',
                'answer' => '<p> Răspuns: 1 - Acoperirea gurii cu mâna, cu marginea hainei sau cu un șervețel în timpul strănutului<br /> 2 -<span class="c6"> Să Îl lauzi pe Allah după ce ai strănutat spunând:</span> „Alhamdulillah” <span class="c2">(Laudă lui Allah)</span><br /> 3 - Apoi, fratele sau însoţitorul său <span class="c5">[care îl aude]</span> trebuie să îi spună: „Iarhamuka Allah” <span class="c2">(Allah să aibă milă de tine <span class="c5">[şi să te ierte]</span>!<br /> Iar dacă acesta i-a spus „Allah să aibă milă de tine <span class="c5">[şi să te ierte]</span>!”,<span class="c6"> el trebuie să îi răspundă:</span> „Iahdikumu-llahu ua iuslih balakum.” (Allah să te călăuzească şi să îndrepte situația ta <span class="c5">[îndrumându-te pe calea cea<br /> dreaptă]</span>)</span> </p>',
            ],
            24 => [
                'question' => 'Întrebarea nr. 25: Care sunt manierele referitoare la căscat?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12360.mp3',
                'answer' => '<p> Răspuns: 1 - Încercarea de a opri căscatul (prin închiderea gurii sau acoperirea ei cu mâna<br /> 2 - Nu trebuie să ridici vocea atunci când caști spunând „a...a....”<br /> 3 - Punerea mâinii la gură </p>',
            ],
            25 => [
                'question' => 'Întrebarea nr. 26: Care sunt manierele referitoare la  recitarea Coranului?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12420.mp3',
                'answer' => '<p> Răspuns: 1 - Citirea Coranului în stare de purificare, după îndeplinirea abluțiunii<br /> 2 - A sta așezat într-o modalitate manierată și solemnă<br /> 3 - Înainte de a începe recitarea Coranului caut adăpost la Allah de Satana<br /> 4 - Caut să înțeleg și să pricep sensurile a ceea ce citesc </p>',
            ],
        ],
        7 => [
            0 => [
                'question' => 'Întrebarea nr. 1: Care sunt virtuțile unui caracter ales?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12500.mp3',
                'answer' => '<p> Răspuns: Profetul <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> a spus: „Dreptcredincioșii cu cea mai deplină credință sunt cei care au cel mai bun caracter.” Consemnat de Tirmidhi și Ahmad </p>',
            ],
            1 => [
                'question' => 'Întrebarea nr. 2: De ce trebuie să ne însușim atitudini islamice și să urmăm un caracter islamic?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12530.mp3',
                'answer' => '<p> Răspuns: 1 - Pentru că el este unul dintre motivele prin care se obține dragostea lui Allah Preaînaltul<br /> 2 - Și, de asemenea, un motiv pentru a obține dragostea oamenilor<br /> 3 - Este una dintre cele mai cu greutate fapte pe talerul faptelor bune<br /> 4 - Un caracter ales sporește recompensa și răsplata obținute<br /> 5 - Este un indiciu al deplinătății credinței </p>',
            ],
            2 => [
                'question' => 'Întrebarea nr. 3: Care sunt sursele care ne îndrumă către atitudinile și caracterul pe care trebuie să le avem?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12600.mp3',
                'answer' => '<p> Răspuns: - În Nobilul Coran,<span class="c6"> Allah Preaînaltul a spus:</span> Cu adevărat acest Coran călăuzește către ceea ce este mai drept <span class="c5">[Coran,<span class="c6"> 17:</span>9]</span> În Tradițiile profetice, Profetul <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> a spus: „Cu adevărat, eu am fost trimis pentru a împlini un caracter desăvârșit.” Consemnat de Ahmad </p>',
            ],
            3 => [
                'question' => 'Întrebarea nr. 4: Ce reprezintă trăsătura de caracter a „ihsan”-ului (perfecțiune și bunătate) și care sunt modalitățile în care aceasta se manifestă?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12640.mp3',
                'answer' => '<p> Răspuns: „Al-Ihsan” reprezintă conștientizarea prezenței permanente a lui Allah prin Știința Sa și oferirea a tot ceea ce reprezintă bunătate, binefacere și bunăvoință pentru creațiile Sale.<br /> Profetul <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> a spus: „Cu adevărat, Allah a prescris al-ihsan față de tot ce există.” Consemnat de Muslim<br /> Dintre manifestările ihsan-<span class="c6">ului amintim:</span><br /> Bunăvoința și deplinătatea adorării lui Allah Preaînaltul prin devoțiunea arătată în adorarea Sa<br /> Bunăvoința și deplinătatea în relaționarea cu părinții, atât în vorbe, cât și în fapte<br /> Bunăvoința și deplinătatea în relaționarea cu rudele de sânge și cu cei apropiați<br /> Bunăvoința și deplinătatea în relaționarea cu vecinii<br /> Bunăvoința și deplinătatea faptelor cărora li se dă curs față de orfani și nevoiași<br /> Bunăvoința și deplinătatea faptelor cărora li se dă curs față de cel care s-a purtat rău cu tine<br /> Bunăvoința și deplinătatea în vorbire<br /> Bunăvoința și deplinătatea caracterului atunci când te afli într-o dispută<br /> Bunăvoința și deplinătatea comportamentului față de animale </p>',
            ],
            4 => [
                'question' => 'Întrebarea nr. 5: Care este opusul „ihsan”-ului?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12780.mp3',
                'answer' => '<p> Răspuns: Opusul „ihsan”-ului este „al-\'isa\'a” <span class="c2">(încălcarea normelor, abuzul, nelegiuirea)</span><br /> * Printre acestea se numără și: A nu avea o intenție sinceră, de dragul lui Allah Preaînaltul, în actele de adorare efectuate<br /> * Precum și neascultarea și comportamentul urât față de părinți<br /> * Ruperea legăturilor cu rudele de sânge<br /> * Un comportament rău față de vecini<br /> * Neadoptarea unui comportament binevoitor față de cei săraci și nevoiași, precum și alte vorbe și comportamente necorespunzătoare </p>',
            ],
            5 => [
                'question' => 'Întrebarea nr. 6: Care sunt formele „al-\'amana” (onestitatea și loialitatea) și modalitățile în care aceasta se manifestă?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12860.mp3',
                'answer' => '<p> Răspuns:<br /> 1 - Onestitatea și loialitatea în conservarea dreptului lui Allah Preaînaltul <span class="c2">(prin respectarea poruncilor Sale)</span><br /> Modalitatea în care aceasta ia forma onestității și loialității în împlinirea actelor de adorare, ca Rugăciunea, Dania, Postul, Pelerinajul, precum și în alte fapte pe care Allah ni le-a poruncit.<br /> 2 - Onestitatea și loialitatea în conservarea drepturilor creațiilor lui Allah<br /> Precum protejarea onoarei oamenilor<br /> a averii lor<br /> și a vieții lor<br /> precum și a secretelor lor și tot ceea ce oamenii pun în grija ta.<br /> Atunci când a menționat atributele celor care vor fi izbânditori,<span class="c6"> Allah Preaînalui a spus:</span> <span class="c5">[...]</span> cei care sunt cu grijă față de cele care le-au fost încredințate și<br /> față de făgăduința lor <span class="c5">[Coran,<span class="c6"> 23:</span>8]</span> </p>',
            ],
            6 => [
                'question' => 'Întrebarea numărul 7: Care este opusul pentru „amanah”?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12980.mp3',
                'answer' => '<p> Răspuns: Opusul pentru „amanah” <span class="c2">(onestitate și loialitate)</span> este „khianah” <span class="c2">(trădarea)</span>, care presupune încălcarea drepturilor pe care Allah le are asupra ta, precum și încălcarea drepturilor oamenilor.<br /> Profetul <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> a spus: „Semnele unui ipocrit sunt trei...” și printre ele a menționat și - „dacă îi este dat ceva în grijă, el trădează încrederea primită” Bukhari și Muslim </p>',
            ],
            7 => [
                'question' => 'Întrebarea nr. 8: Care este trăsătura de caracter a sincerității?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13020.mp3',
                'answer' => '<p> Răspuns: Aceasta este calitatea de a spune ceea ce corespunde cu realitatea sau situația concretă în care omul se află.<span class="c6"><br /> Dintre modalitățile de manifestare ale acesteia amintim:</span><br /> Sinceritatea în vorbirea cu oamenii<br /> Sinceritatea în promisiunile făcute<br /> Sinceritatea în vorbe și în fapte<br /> Profetul <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> a spus: „Cu adevărat, sinceritatea conduce către evlavie, iar evlavia conduce către Paradis; iar omul care persistă în a spune adevărul <span class="c2">(dobândește această calitate aleasă de caracter și)</span> devine întru totul sincer.” Bukhari și Muslim </p>',
            ],
            8 => [
                'question' => 'Întrebarea nr. 9: Care este opusul „as-sidq” (sinceritatea)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13100.mp3',
                'answer' => '<p> Răspuns: Opusul sincerității este „al-kizb” <span class="c2">(minciuna)</span>, care reprezintă ceea ce nu este asemenea realității, precum mințirea oamenilor, nepunctualitatea și nerespectarea programărilor asupra cărora s-a convenit și mărturia mincinoasă.<br /> Profetul <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> a spus: „Cu adevărat, minciuna conduce către nelegiuire și nelegiuirea conduce către focul Iadului; iar omul care persistă în minciună va fi scris la Allah ca fiind <span class="c2">(cu desăvârșire)</span> un mincinos.” Bukhari și Muslim Și, de asemenea, a spus Profetul <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span>: „Semnele ipocritului sunt trei....” și printre acestea a menționat și „dacă vorbește minte, iar dacă promite nu își ține promisiunea.” Bukhari și Muslim </p>',
            ],
            9 => [
                'question' => 'Cerința nr. 10: Menționează tipurile de răbdare.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13140.mp3',
                'answer' => '<p> Răspuns: - Răbdarea arătată în supunerea față de Allah Preaînaltul<br /> Răbdarea manifestată în opunerea față de săvârșirea de păcate<br /> Răbdarea cu care este întâmpinat un destin dureros și Slăvirea lui Allah in toate circumstanțele.<span class="c6"><br /> Allah Preaînaltul a spus:</span> Și Allah îi iubește pe cei răbdători <span class="c5">[Coran,<span class="c6"> 3:</span>146]</span> Și, tot astfel, Profetul <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> a spus: „Minunată este situația dreptcredinciosului! Tot ceea ce i se întâmplă este un lucru bun pentru el! Și această situație nu îi este specifică decât celui dreptcredincios; cel care, dacă a avut parte de o bucurie, I-a mulțumit lui Allah și acesta a fost un lucru bun pentru el, iar dacă a fost atins de o suferință, a fost răbdător și acesta a fost un lucru bun pentru el.” Consemnat de Muslim </p>',
            ],
            10 => [
                'question' => 'Întrebarea nr. 11: Care este opusul răbdării?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13210.mp3',
                'answer' => '<p> Răspuns: Acesta reprezintă lipsa de răbdare manifestată în supunerea față de Allah, sau în a se opune săvârșirii păcatelor, sau indignarea sau respingerea exprimate în vorbe sau fapte față de ceea ce îi este predestinat.<br /> Printre formele în care aceasta se manifestă,<span class="c6"> amintim:</span><br /> * dorirea morții<br /> * lovirea feței <span class="c2">(atunci când i se întâmplă o nenorocire)</span><br /> * sfâșierea hainelor<br /> * smulgerea părului din cap<br /> * rugi distrugătoare îndreptate asupra propriei persoane<br /> Profetul <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> a spus: „Răsplata este pe măsura încercării și suferinței, iar dacă Allah a iubit un popor, l-a încercat prin suferință; astfel încât cel care a acceptat-o a primit Mulțumirea <span class="c2">(lui Allah)</span>, iar cel care a arătat indignare și nemulţumire va avea parte de respingere <span class="c2">(de la Allah)</span>.” <span class="c5">[Consemnat de Tirmidhi și Ibn Majah]</span> </p>',
            ],
            11 => [
                'question' => 'Cerința nr. 12: Spune care este trăsătura de caracter a cooperării („at-ta\'aun”).',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13310.mp3',
                'answer' => '<p> Răspuns: Aceasta reprezintă cooperarea oamenilor și unirea lor în ceea ce este drept și bun.<br /> Dintre formele de manifestare ale „at-<span class="c6">ta\'aun” menționăm:</span><br /> * Cooperarea în scopul restituirii drepturilor<br /> * Cooperarea în sensul respingerii și opririi celui care nedreptățește<br /> * Cooperarea în acoperirea nevoilor oamenilor și celor nevoiași<br /> * Cooperarea în tot ceea ce este bun și drept<br /> * Oprirea de la a coopera în păcat,<span class="c6"> agresiune și vătămare<br /> Allah Preaînaltul a spus:</span> Și ajutați-vă în împlinirea faptelor bune și în evlavie, dar să nu vă ajutați la păcat și la nedreptate! Și fiți cu frică de Allah, căci Allah este aspru la<br /> pedeapsă. <span class="c5">[Coran,<span class="c6"> 5:</span>2]</span> Și a spus Profetul <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span>: „Un dreptcredincios este pentru un alt dreptcredincios asemenea cărămizilor unei zidiri care se susțin una pe cealaltă.” Bukhari și Muslim Și, de asemenea, a spus Profetul Mohammad <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span>: „Un musulman este fratele altui musulman - el nu trebuie să îl asuprească și nici să îl trădeze. Celui care împlinește nevoile fratelui său, Allah îi va împlini nevoile sale. Cel care îndepărtează greutatea și necazul unui musulman, Allah va îndepărta de la el unul dintre necazurile Zilei de Apoi. Iar celui care <span class="c2">(l-a protejat și)</span> a acoperit greșelile unui musulman, Allah îi va acoperi greșelile sale în Ziua Învierii.” Bukhari și Muslim </p>',
            ],
            12 => [
                'question' => 'Întrebarea nr. 13: Care sunt tipurile comportamentului „al-haiaa\' ” (modestie și sfială)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13420.mp3',
                'answer' => '<p> Răspuns: 1 -<span class="c6"> Modestia și sfiala arătate față de Allah:</span> manifestate în oprirea de la a arăta nesupunere față de El, Preaslăvitul.<br /> 2 -<span class="c6"> Modestia și sfiala arătate față de oameni:</span> dintre manifestările căreia amintim delăsarea de limbajul care exprimă obscenitate și desfrânare și dezgolirea trupului.<br /> Mesagerul lui Allah <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> a spus: „Credința are peste șaptezeci sau peste șaizeci de ramuri, dintre care cea mai înaltă este mărturisirea că nu există altă divinitate demnă de a fi adorată în afară de Allah și cea mai joasă este îndepărtarea a ceea ce este vătămător de pe un drum public; iar modestia <span class="c2">(și sfiala)</span> este o ramură a credinței.” <span class="c2">(Consemnat de Muslim)</span> </p>',
            ],
            13 => [
                'question' => 'Întrebarea nr. 14: Menționează unele dintre modalitățile în care se manifestă trăsătura de caracter a milei și îndurării („ar-Rahma”).',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13470.mp3',
                'answer' => '<p> Răspuns: - Îndurarea și mila arătate față de cei vârstnici și respectarea lor<br /> Îndurarea și mila arătate față de cei mici și față de copii<br /> - Îndurarea și mila arătate față de cel sărac, sărman și nevoiaș<br /> - Îndurarea și mila arătate față de animale prin hrănirea lor și oprirea de la a le provoca suferință<br /> Și la aceasta se referă și vorbele Profetului <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> care a spus: „Îi poți vedea pe dreptcredincioși în mila și îndurarea, dragostea și afecțiunea dintre ei, asemenea unui singur trup care, atunci când una dintre părțile sale suferă, întregul trup suferă alături de ea, prin neputința de a dormi și febră.” Bukhari și Muslim Și a spus, de asemenea, Mesagerul lui Allah <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span>: „Celor milostivi, Cel mai Milostiv le va arăta îndurare. Fiți milostivi și îndurători cu cei de pe Pământ, și vă va arăta milă și îndurare Cel de deasupra Cerurilor!” <span class="c2">(Consemnat de Abu Daud și Tirmidhi)</span> </p>',
            ],
            14 => [
                'question' => 'Întrebarea nr. 15: Care sunt tipurile trăsăturii de caracter a dragostei și afecțiunii („mahabbah”)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13550.mp3',
                'answer' => '<p> Răspuns: -<span class="c6"> Dragostea față de Allah Preaînaltul<br /> A spus Allah Preaînaltul:</span> Dar cei care cred sunt mai stăruitori în iubirea pentru Allah. <span class="c5">[Coran,<span class="c6"> 2:</span>165]</span><br /> - Dragostea față de Mesager <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span><br /> Profetul <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> a spus: „Jur pe Cel în Mâna căruia se află sufletul meu, niciunul dintre voi nu crede cu adevărat până ce nu mă iubește mai mult decât pe fiul și părintele său.” Consemnat de Bukhari<br /> - Dragostea arătată față de dreptcredincioși și a iubi pentru aceștia ceea ce iubești și pentru tine însuți.<br /> Profetul <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> a spus: „Niciunul dintre voi nu crede cu adevărat până ce nu iubește pentru fratele său ceea ce iubește pentru sine însuși.” Consemnat de Bukhari </p>',
            ],
            15 => [
                'question' => 'Cerința nr. 16: Definește jovialitatea („al-bașașah”).',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13630.mp3',
                'answer' => '<p> Răspuns: - Aceasta presupune întâmpinarea oamenilor cu o față relaxată și binevoitoare, cu bucurie, zâmbet, blândețe și exprimarea plăcerii întâlnirii lor.<br /> Ea este opusul întâmpinării oamenilor cu o față încruntată, ceea ce face ca aceștia să se îndepărteze de tine.<br /> Referitor la virtuțile acesteia au fost consemnate numeroase hadisuri. Abu Dharr <span class="c2">(Allah să fie mulțumit de el)</span> a relatat că Profetul <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> a spus: „Nu considerați nicio faptă bună <span class="c2">(oricât de mică ar fi)</span> ca fiind neînsemnată, chiar dacă aceasta ar presupune doar să îl întâmpini pe fratele tău cu o față binevoitoare.” Consemnat de Muslim Și, de asemenea, Mesagerul lui Allah <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> a spus: „A zâmbi în fața fratelui tău este un act de caritate.” Consemnat de Tirmidhi </p>',
            ],
            16 => [
                'question' => 'Întrebarea nr. 17: Ce este invidia („al-hasad”)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13690.mp3',
                'answer' => '<p> Răspuns: - Aceasta presupune să îți dorești ca binecuvântările cu care sunt dăruiți ceilalți să dispară sau să urăști să vezi binecuvântările pogorâte asupra celorlalți.<span class="c6"><br /> Allah Preaînaltul a spus:</span> „Și împotriva răului pizmuitorului,<br /> când pizmuiește” <span class="c5">[Coran,<span class="c6"> 113:</span>5]</span><br /> Anas ibn Malik <span class="c2">(Allah să fie mulțumit de el)</span> a relatat că Mesagerul lui Allah <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> a spus: „Nu purtați ură între voi, nu vă pizmuiti unul pe celălat și nici nu vă purtați cu îndărătnicie, ci fiți, o, robi ai lui Allah, frați unii cu alții.” Consemnat de Bukhari și Muslim </p>',
            ],
            17 => [
                'question' => 'Întrebarea nr. 18: Ce este batjocorirea („al-istihza\' ”)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13740.mp3',
                'answer' => '<p> Răspuns: - Aceasta presupune să îți bați joc de fratele tău musulman și să îl înjosești, lucru care nu este permis.<br /> Allah Preaînaltul a spus,<span class="c6"> oprind de la aceasta:</span> O, voi cei care credeți! Să nu râdă un popor de alt popor, care s-ar<br /> putea să fie mai bun decât el, nici femeile <span class="c5">[să nu râdă]</span> de alte femei,<br /> care s-ar putea să fie mai bune decât ele! Nu vă ocărâți și nu vă<br /> batjocoriți cu porecle unii pe alții. Ce rău este numele urât și rușinos,<br /> după credință! Iar cei care nu se căiesc, aceia sunt nelegiuiți. <span class="c5">[Coran,<span class="c6"> 49:</span>11]</span> </p>',
            ],
            18 => [
                'question' => 'Cerința nr. 19: Definește smerenia („at-tauad\'a”).',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13780.mp3',
                'answer' => '<p> Răspuns: - Aceasta presupune să nu te crezi superior celorlalți, să nu îi înjosești pe oameni și să nu respingi ceea ce este adevărat și drept.<span class="c6"><br /> Allah Preaînaltul a spus:</span> „Robii Celui Milostiv sunt cei care merg pe Pământ cu smerenie” <span class="c5">[Coran,<span class="c6"> 25:</span>63]</span> Adică: umili <span class="c2">(fără îngâmfare)</span> Mesagerul lui Allah <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> a spus,<span class="c6"> de asemenea:</span> „Niciunul dintre voi nu va arăta smerenie de dragul lui Allah, fără ca Allah să îl înalțe pe el <span class="c2">(prin aceasta)</span>.” Consemnat de Muslim Și tot astfel a spus Profetul <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span>: „O, oameni! Cu adevărat, Allah Preaînalt mi-a revelat că voi trebuie să fiți smeriți, astfel încât niciunul dintre voi să nu îl înșele pe celălalt și nici să nu se semețească vreunul dintre voi față de celălalt.” Consemnat de Muslim </p>',
            ],
            19 => [
                'question' => 'Întrebarea nr. 21: Care sunt formele de aroganță, semețire și îngâmfare care sunt interzise?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13840.mp3',
                'answer' => '<p> Răspuns: - 1 - Aroganța arătată față de ceea ce este adevărat și drept, în forma respingerii adevărului și a neacceptării acestuia.<br /> 2 - Aroganța arătată față de oameni, în sensul înjosirii și disprețuirii acestora.<br /> Mesagerul lui Allah <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> a spus: Nu va intra în Paradis cel în a cărui inimă se află chiar și greutatea unui atom de îngâmfare.<span class="c6"> Un om a spus:</span> „Cu adevărat, omul iubește ca veșmintele și încălțările sale să fie frumoase.” A răspuns <span class="c2">(Profetul - Pacea și binecuvântarea lui Allah fie asupra sa)</span>: Cu adevărat Allah este Cel Preafrumos și iubește ceea ce este frumos. Îngâmfarea presupune respingerea adevărului <span class="c2">(din cauza preaplinului de sine)</span> și înjosirea oamenilor. Consemnat de Muslim<br /> -<span class="c6"> disprețuirea adevărului:</span> adică respingerea lui<br /> -<span class="c6"> disprețuirea oamenilor:</span> adică înjosirea lor<br /> - purtarea unor veșminte și încălțări frumoase nu presupune îngâmfarea și aroganța </p>',
            ],
            20 => [
                'question' => 'Cerința nr. 21: Menționează câteva dintre tipurile de înșelăciune care sunt interzise în Islam.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13910.mp3',
                'answer' => '<p> Răspuns: - Înșelăciunea în procesul de vânzare - cumpărare, prin ascunderea deficitelor sau defectelor pe care le deține anumite mărfuri.<br /> - Înșelăciunea în procesul de învățare a științei, studenții trișând la examene, spre exemplu.<br /> - Înșelăciunea în vorbire, prin oferirea unor mărturii false sau prin minciună.<br /> - A nu îndeplini promisiunile făcute și a nu onora înțelegerile făcute cu ceilalți<br /> Referitor la interzicerea înșelăciunii, s-a relatat că Mesagerul lui Allah <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> a trecut pe lângă o grămadă de grâne <span class="c2">(expuse pentru vânzare)</span> și și-a trecut mâna prin ea, iar degetele sale s-au umezit.<span class="c6"> Atunci a spus:</span> „Ce e aceasta?!” Omul a răspuns: „A plouat peste ele, o, Mesager al lui Allah!” <span class="c2">(Atunci, Profetul - Pacea și binecuvântarea lui Allah fie asupra sa)</span> a spus: „De ce nu ai pus grânele umede deasupra, pentru ca oamenii să le poată vedea? Cel care înșală nu este dintre ai mei <span class="c2">(și nu are nicio legătură cu mine)</span>!” Consemnat de Muslim<br /> În arabă „as-<span class="c6">subrah”:</span> o grămadă de grâne <span class="c2">(alimente)</span> </p>',
            ],
            21 => [
                'question' => 'Întrebarea nr. 22: Ce este bârfa („al-ghibah”)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13990.mp3',
                'answer' => '<p> Răspuns: Aceasta presupune a vorbi despre fratele tău musulman ceva ce îi este neplăcut, în absența lui.<span class="c6"><br /> Allah Preaînaltul a spus:</span> „<span class="c5">[...]</span> și nu vă ponegriți unii pe alții! Oare voiește vreunul dintre voi<br /> să mănânce carnea fratelui său mort? <span class="c5">[Nu!]</span> Voi ați urât aceasta! Și<br /> fiți cu frică de Allah, fiindcă Allah este Tauuab <span class="c5">[Iertător]</span> și Rahim<br /> <span class="c5">[Îndurător]</span>.” <span class="c5">[Coran,<span class="c6"> 49:</span>12]</span> </p>',
            ],
            22 => [
                'question' => 'Cerința nr. 23: Definește calomnierea și defăimarea („an-namimah”).',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14030.mp3',
                'answer' => '<p> Răspuns: Aceasta presupune a duce vorba de la un om la altul pentru a strica relațiile dintre ei.<br /> Mesagerul lui Allah <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> a spus: „Nu va intra în Paradis cel care îi defăimează și îi calomniază pe oameni.” Consemnat de Muslim </p>',
            ],
            23 => [
                'question' => 'Întrebarea nr. 24: Ce este lenea și indolența? („al-kasl”)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14070.mp3',
                'answer' => '<p> Răspuns: - Ea reprezintă întârzierea și încetineala excesivă în împlinirea a ceea ce i se impune omului să înfăptuiască.<br /> Dintre acestea putem aminti și indolența și lenea în împlinirea acțiunilor care sunt obligatorii.<span class="c6"><br /> Allah Preaînaltul a spus:</span> „Cu adevărat, ipocriții <span class="c5">[se gândesc să]</span> Îl înșele pe Allah, dar El întoarce<br /> înșelătoria lor <span class="c5">[împotriva lor înșiși]</span>. Iar când se ridică pentru Rugăciune<br /> <span class="c5">[As-Salat]</span>, se ridică cu lene, ca să fie văzuți de oameni și nu pomenesc<br /> numele lui Allah decât foarte puțin.” <span class="c5">[Coran,<span class="c6"> 4:</span>142]</span><br /> Adevăratul crendincios trebuie să renunțe la dezinteres și lene. El trebuie depună tot efortul și dăruirea în munca sa, realizând fapte plăcute lui Allah. </p>',
            ],
            24 => [
                'question' => 'Cerința nr. 25: Menționează care sunt tipurile de furie („al-ghadab”).',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14130.mp3',
                'answer' => '<p> Răspuns: 1 - Furia lăudabilă,<span class="c6"> demnă de apreciat:</span> Este cea care se manifestă de dragul lui Allah atunci când necredincioșii, ipocriții sau alți oameni încalcă limitele puse de Allah Preaslăvitul <span class="c2">(și cele pe care El le-a interzis)</span>.<br /> 2 -<span class="c6"> Furia condamnabilă:</span> Este cea care determină o persoană să facă și să spună ceea ce nu se cuvine.<span class="c6"><br /> Tratamentul furiei condamnabile se face prin următoarele:</span><br /> Abluțiune<br /> Așezarea dacă cel care se înfurie stă în picioare și întinderea și relaxarea dacă este de dinainte așezat<br /> Să urmeze sfatul Profetului <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span>,<span class="c6"> care a spus:</span> „Nu te înfuria!”<br /> Să se controleze atunci când simte impulsul furiei<br /> Să caute adăpost la Allah de Diavolul cel alungat<br /> Păstrarea tăcerii </p>',
            ],
            25 => [
                'question' => 'Întrebarea nr. 26: Ce este spionarea („at-tageassus”)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14240.mp3',
                'answer' => '<p> Răspuns: Aceasta presupune să dezvălui și să cauți să cunoști chestiunile private ale oamenilor și ceea ce ei țin ascuns.<span class="c6"><br /> Dintre acestea amintim:</span><br /> - A se uita în casele oamenilor și a vedea astfel aurah <span class="c2">(părțile corpului care trebuie acoperite)</span> celor ce locuiesc înăuntru<br /> - A asculta cele pe care oamenii le vorbesc,<span class="c6"> fără ca ei să aibă știință de aceasta<br /> Allah Preaînaltul a spus:</span> „Nu vă iscodiți...” <span class="c5">[Coran,<span class="c6"> 49:</span>12]</span> </p>',
            ],
            26 => [
                'question' => 'Întrebarea nr. 27: Ce este extravaganța și risipa („al-israf”) zgârcenia și avariția („al-bukhl”) și ce este generozitatea („al-karam”)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14310.mp3',
                'answer' => '<p> Răspuns: - Extravaganța presupune cheltuirea averii pe nedrept <span class="c2">(pe ceea ce nu este necesar)</span><br /> La polul opus acesteia se află zgârcenia și avariția: care presupune abținerea de la cheltuirea averii pe ceea ce este necesar și drept<br /> Opțiunea corectă pentru un musulman este urmarea căii de mijloc între acestea, moderația și generozitatea.<span class="c6"><br /> Allah Preaînaltul a spus:</span> „Și cei care, atunci când cheltuiesc, nu sunt nici risipitori nici zgârciți, ci<br /> fac aceasta cu măsură” <span class="c5">[Coran,<span class="c6"> 25:</span>67]</span> </p>',
            ],
            27 => [
                'question' => 'Întrebarea nr. 28: Ce este lașitatea („al-jubun”) curajul și vitejia („aș-șugea\'a”)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14370.mp3',
                'answer' => '<p> Răspuns: Lașitatea presupune ca cineva să aibă frică de ceva de care nu ar trebui să se teamă.<br /> Precum frica de a spune adevărul și de a respinge ceea ce este rău.<br /> Vitejia și curajul presupun a plini ceea ce este adevărat și drept, cum ar fi participarea la lupta împotriva inamicilor Islamului, pentru apărarea Islamului și a musulmanilor <span class="c2">(atunci când condițiile obiective o impun, fără a încălca reglementările islamice referitor la aceste aspecte)</span>.<br /> Profetul <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> obișnuia să se roage spunând: „O, Allah, cu adevărat, caut adăpost la Tine de lașitate...” Iar Mesagerul lui Allah <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> a spus: „Dreptcredinciosul puternic este mai bun și mai iubit de Allah decât dreptcredinciosul slab, însă în amândoi se află ceea ce este bun.” Consemnat de Muslim </p>',
            ],
            28 => [
                'question' => 'Cerința nr. 29: Menționează câteva dintre expresiile interzise să fie rostite.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14440.mp3',
                'answer' => '<p> Răspuns: Printre acestea amintim blestemele și înjurăturile.<br /> - Precum și a te adresa cuiva spunându-i „animalule” sau alte vorbe asemenea acesteia.<br /> - Sau menționarea părților intime în expresii obsece și josnice.<br /> Profetul <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> a oprit de la aceasta și a spus: „Dreptcredinciosul nu este un calomniator, nici blestemător, nici imoral și nici nerușinat." Consemnat de Tirmidhi și Ibn Hibban </p>',
            ],
            29 => [
                'question' => 'Întrebarea nr. 30: Care sunt factorii care ajută un musulman să dobândească și să păstreze un caracter ales?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14500.mp3',
                'answer' => '<p> Răspuns: - 1 - Rugi îndreptate către Allah pentru a-l binecuvânta cu un caracter ales și a-l ajuta să îl păstreze<br /> 2 - Conștientizarea faptului că Allah este întotdeauna prezent prin Știința Sa și El știe ceea ce faci, te aude și te vede.<br /> 3 - Reamintirea răsplății obținute pentru un caracter ales și a faptului că acesta ne va ajuta să intrăm în Paradis.<br /> 4 - Reamintirea pedepsei primite pentru un caracter rău și a faptului că acesta conduce către focul Iadului.<br /> 5 - Reamintirea faptului că un caracter ales atrage dragostea lui Allah Preaînaltul și a creațiilor Sale, iar un caracter rău aduce mânia lui Allah și a creațiilor Sale.<br /> 6 - Citirea biografiei Profetului <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> și urmarea exemplului acestuia.<br /> 7 - Întovărășirea cu oamenii buni și îndepărtarea de oamenii răi. </p>',
            ],
        ],
        8 => [
            0 => [
                'question' => 'Întrebarea nr. 1: Care sunt virtuțile pomenirii lui Allah?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14630.mp3',
                'answer' => '<p> Răspuns: Profetul <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> a spus: „Pilda celui care îl pomenește pe Domnul său și a aceluia care nu îl pomenește pe Domnul său este asemenea pildei celui care este viu și a celui care este mort.” Consemnat de Bukhari<br /> - Acest lucru se datorează faptului că valoarea vieții unei persoane este direct proproțională cu măsura în care el îl pomenește pe Domnul său Cel Atotputernic. </p>',
            ],
            1 => [
                'question' => 'Cerința nr. 2: Menționează cateva dintre beneficiile pomenirii lui Allah.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14670.mp3',
                'answer' => '<p> Răspuns: - 1 - Aduce Mulțumirea Celui Preamilostiv<br /> 2 - Îndepărtează Diavolul<br /> 3 - Îl protejează pe musulman de ceea ce este rău<br /> 4 - Prin intermediul ei este obținută o bună răsplată și recompensă </p>',
            ],
            2 => [
                'question' => 'Întrebarea nr. 3: Care este cel mai bun dhikr?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14730.mp3',
                'answer' => '<p> Răspuns: Cel mai bun dhikr este „La ilaha illa Allah” <span class="c2">(Nu există altă divinitate demnă de a fi adorată în afară de Allah)</span>. Consemnat de Tirmidhi și Ibn Majah </p>',
            ],
            3 => [
                'question' => 'Întrebarea nr. 4: Ce se spune atunci când te trezești din somn?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14760.mp3',
                'answer' => '<p> Răspuns: „Alhamdulillahil-ladhi ahyana ba’da ma<br /> amatana ua-ilayhin-nuşur.” <span class="c2">(Laudă lui Allah, Care ne-a dăruit viaţa<br /> după ce ne-a luat-o şi la El este Învierea!)</span> Bukhari și Muslim </p>',
            ],
            4 => [
                'question' => 'Întrebarea nr. 5: Ce spui atunci când te îmbraci?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14790.mp3',
                'answer' => '<p> „Alhamdulillahil-ladhi kasany hadha-th thaub ua razaqany \'iiah min ghair haulin minni ua la quuah” <span class="c2">(Laudă lui Allah care m-a îmbrăcat cu acest veșmânt, fără vreo forță sau putere din partea mea)</span> Consemnat de Abu Daud, Tirmidhi și alții </p>',
            ],
            5 => [
                'question' => 'Întrebarea nr. 6: Ce se spune atunci când te dezbraci?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14820.mp3',
                'answer' => '<p> Răspuns: „Bismillah” <span class="c2">(În numele lui Allah)</span> Consemnat de Tirmidhi </p>',
            ],
            6 => [
                'question' => 'Întrebarea nr. 7: Care este ruga la purtarea unui veșmânt nou?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14850.mp3',
                'answer' => '<p> Răspuns: „Allahumma lakal-hamdu anta kasautanih, as-aluka min khayrihi ua khayri ma suni’a lah, ua-’audhu bika min şarrihi uaşarri ma<br /> suni’a lah.” <span class="c2">(O Allah, a Ta este toată Lauda, Tu m-ai îmbrăcat cu acest <span class="c5">[veşmânt]</span>. Îţi cer din binele lui şi din binele din care a fost făcut<br /> acesta şi caut adăpost la Tine de răul lui şi de răul din care a fost făcut acesta.)</span> Consemnat de Abu Daud și Tirmidhi </p>',
            ],
            7 => [
                'question' => 'Întrebarea nr. 8: Care este ruga spusă aceluia care îmbracă un veșmânt nou?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14880.mp3',
                'answer' => '<p> Răspuns: Atunci când vezi pe cineva îmbrăcat cu un veșmânt nou, trebuie să te rogi pentru el, spunându-<span class="c6">i:</span> „Tubli ua yukhliful-lahu Ta’ala.” [Să-l porţi până când se învechește şi<br /> Allah să ţi-l schimbe <span class="c2">(cu altul nou)</span>]. Consemnat de Abu Daud </p>',
            ],
            8 => [
                'question' => 'Întrebarea nr. 9: Menționează care este ruga spusă înainte de a intra la toaletă, în locul în care îți faci nevoile.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14910.mp3',
                'answer' => '<p> Răspuns: „Allahumma inni ‘Audhu bika minal-khubthi ual-khaba-ith.” (O, Allah, caut adăpost la Tine de necurat şi de necurate <span class="c5">[de diavoli]</span>! Bukhari și Muslim </p>',
            ],
            9 => [
                'question' => 'Întrebarea nr. 10: Care este ruga spusă la ieșirea de la toaletă?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14940.mp3',
                'answer' => '<p> Răspuns: - „Ghufranak” <span class="c2">(O Allah, Iartă-mă! )</span> Consemnat de Abu Daud și Tirmidhi </p>',
            ],
            10 => [
                'question' => 'Întrebarea nr. 11: Ce se spune înainte de abluțiune?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14970.mp3',
                'answer' => '<p> Răspuns: „Bismillah” <span class="c2">(În numele lui Allah)</span>. Consemnat de Abu Daud și alții </p>',
            ],
            11 => [
                'question' => 'Întrebarea nr. 13: Care este pomenirea spusă după abluțiune?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15000.mp3',
                'answer' => '<p> Răspuns: - „Aş hadu an la ilaha illallahu uahdahu la şarika lah, ua-aş hadu anna Muhammadan ‘abduhu ua rasuluh.” <span class="c2">(Mărturisesc că nu există altă divinitate demnă de a fi adorată în afară de Allah, Unicul, Care nu are pe nimeni egal, şi mărturisesc că Muhammad este robul şi Trimisul Lui.)</span> Consemnat de Muslim </p>',
            ],
            12 => [
                'question' => 'Întrebarea nr. 13: Care este pomenirea spusă la ieșirea din casă?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15020.mp3',
                'answer' => '<p> Răspuns: „Bismillah, tauakkaltu ‘alallah, ua la haula ua la quuuata illa billah.” <span class="c2">(În numele lui Allah! Mă încred în Allah şi <span class="c5">[mărturisesc că]</span> nu există forţă sau putere decât cu Allah!)</span> Consemnat de Abu Daud și Tirmidhi </p>',
            ],
            13 => [
                'question' => 'Întrebarea nr. 14: Care este pomenirea spusă la intrarea în casă?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15050.mp3',
                'answer' => '<p> Răspuns: - „Bismillahi ualagina, ua bismillahi kharagina, ua’ala rabbina tauakkalna.” <span class="c2">(În numele lui Allah am intrat şi în numele lui Allah am ieşit şi în Domnul nostru ne încredem!)</span> Consemnat de Abu Daud </p>',
            ],
            14 => [
                'question' => 'Întrebarea nr. 15: Care este ruga spusă la intrarea în moschee?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15080.mp3',
                'answer' => '<p> Răspuns: - „Allahumma iftah li abuaba rahmatik” <span class="c2">(O, Allah, deschide-mi porțile Îndurării Tale)</span>. </p>',
            ],
            15 => [
                'question' => 'Întrebarea nr. 16: Menționează ruga care se spune la ieșirea din moschee.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15110.mp3',
                'answer' => '<p> Răspuns: - „Allahumma inni as-aluka min fadlik” <span class="c2">(O, Allah, Îţi cer din binecuvântările <span class="c5">[și favorurile]</span> Tale.)</span> </p>',
            ],
            16 => [
                'question' => 'Întrebarea nr. 17: Ce se spune atunci când auzi adhan-ul (chemarea la rugăciune)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15140.mp3',
                'answer' => '<p> Răspuns: - Repet ceea ce spune muezinul,<span class="c6"> mai puţin atunci când el spune:</span> „Hayya ‘alas-salah <span class="c2">(sau)</span> hayya ‘alal-falah.” <span class="c2">(„Veniţi la rugăciune, veniţi la izbândă!”)</span>,<span class="c6"> eu spun în schimb:</span> ِ„La haula ua la quuuata illa billah.” <span class="c2">(Nu există tărie și putere decât prin Allah!)</span> Bukhari și Muslim </p>',
            ],
            17 => [
                'question' => 'Întrebarea nr.18: Ce se spune după adhan?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15170.mp3',
                'answer' => '<p> Răspuns: - Se transmit salutări asupra Profetului <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span>.<span class="c6"> Consemnat de Muslim Și se spune:</span> „Allahumma rabba hadhihidda’uatit-tammah, uassalatil-qa-imah ati Muhammadan aluasilata ual-fadilah, uab’ath-hu maqaman mahmudan alladhi ua’adtah, innaka la tukhliful-mi’ad.” <span class="c2">(O, Allah, Stăpân al acestei chemări perfecte şi Stăpân al acestei rugăciuni ce va fi înfăptuită, acordă-i lui Muhammad „al-uasila” şi „al-fadila” <span class="c5">[adică un rang mai presus de întreaga creaţie]</span> şi dă-i statutul binecuvântat pe care l-ai promis. Cu adevărat, Tu Îți ţii întotdeauna promisiunile.)</span> Consemnat de Bukhari<br /> Iar între adhan <span class="c2">(chemarea la rugăciune)</span> și iqamah <span class="c2">(chemarea pentru începerea rugăciunii)</span> se fac rugi, pentru că aceasta este o perioadă de timp în care rugile sunt acceptate. </p>',
            ],
            18 => [
                'question' => 'Întrebarea nr. 19: Care sunt pomenirile rostite dimineața și seara?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15220.mp3',
                'answer' => '<p> Răspuns: - 1 - Recitarea versetului Ayat al-Kursy <span class="c5">[Coran,<span class="c6"> 2:</span>255]</span> în limba arabă „Allah! Nu există altă divinitate în afară de El, Al-Hayy <span class="c5">[Cel Viu]</span>, Al-Qayyum <span class="c5">[Veșnicul]</span>! Nici aţipirea, nici somnul nu-L cuprind! Ale Lui sunt cele din Ceruri şi de pe Pământ! Cine este acela care ar putea mijloci la El fără de îngăduinţa Lui? El le ştie pe cele de dinaintea lor şi pe cele după ei. Şi ei nu pricep nimic din ştiinţa Sa în afară de ceea ce El voieşte. Scaunul <span class="c2">(În arabă al-Kursi. A nu se confunda cu al-Arș (Tronul)</span>, ce este infinit mai măreț decât al-Kursi) Lui se întinde peste Ceruri şi peste Pământ şi păzirea lor nu-I este grea. El este Al-Aliy <span class="c5">[Preaînaltul]</span>, Al-Azim <span class="c5">[Mărețul]</span>!” <span class="c5">[Coran,<span class="c6"> 2:</span>255]</span> 2 -<span class="c6"> Apoi recită:</span> În numele lui Allah, Cel Milostiv Îndurător 1.<span class="c6"> Spune:</span> „El este Allah, Cel Unic! 2. Allah-us-Samad! 3. El nu zămislește și nu este născut 4. Și El nu are pe nimeni egal!” <span class="c5">[Coran, 112]</span> De 3 ori în limba arabă În numele lui Allah, Cel Milostiv, Cel Îndurător 1.<span class="c6"> Spune:</span> „Eu caut adăpost la Stăpânul revărsatului zorilor 2. Împotriva răului <span class="c5">[venind]</span> de la ceea ce El a creat 3. Și împotriva răului întunericului care se așterne 4. Și împotriva răului vrăjitoarelor care suflă în noduri 5. Și împotriva răului pizmuitorului, când pizmuiește.” <span class="c5">[Coran, 113]</span> De 3 ori în limba arabă În numele lui Allah Cel Milostiv, Cel Îndurător 1.<span class="c6"> Spune:</span> „Eu caut adăpost la Domnul oamenilor, 2. Stăpânul oamenilor, 3. Dumnezeul oamenilor 4. Împotriva răului ademenitorului fugar 5. Care șoptește în piepturile oamenilor, 6. Dintre djinni și oameni.” <span class="c5">[Coran, 114]</span> De 3 ori 3 - „Allahumma anta rabbi la ilaha illa ant, khalaqtani ua-ana ‘abduk, ua-ana ‘ala ‘ahdika uaua’dika mas-tata’tu, ‘audhu bika min şarri ma sana’tu, abu’u laka bini’matika ‘alay, ua-abu’u bidhanbi, faghfir li fa-innahu la<br /> yaghfiru dh-dhunuba illa ant.” <span class="c2">(O, Allah, Tu eşti Domnul meu, nu există altă divinitate demnă de a fi adorată în afară de Tine, Tu m-ai creat şi eu sunt robul Tău şi mă supun legământului şi poruncilor Tale pe cât pot (sperând la răsplata Ta)</span>. Caut adăpost la Tine de răul pe care l-am<br /> comis, Îți sunt recunoscător pentru toate binecuvântările cu care m-ai dăruit, şi îmi recunosc păcatul, aşadar, iartă-mă, căci, cu adevărat, nimeni nu poate ierta păcatele în afară de Tine!) Consemnat de Bukhari </p>',
            ],
            19 => [
                'question' => 'Întrebarea nr. 30: Ce se spune înainte de culcare?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15290.mp3',
                'answer' => '<p> „Bismika Alahumma amutu ua-ahya.” <span class="c2">(În numele Tău, O, Allah, mor şi<br /> trăiesc <span class="c5">[adorm şi mă trezesc]</span>!)</span> Bukhari și Muslim </p>',
            ],
            20 => [
                'question' => 'Întrebarea nr. 21: Ce se spune înainte de a mânca?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15320.mp3',
                'answer' => '<p> Răspuns: „Bismillah” <span class="c2">(În numele lui Allah)</span><br /> Îar dacă ai uitat să spui de la început,<span class="c6"> se spune:</span><br /> „Bismillah fi auualihi ua akhirihi” <span class="c2">(În numele lui Allah, la început și la sfârșit)</span> Consemnat de Abu Daud și Tirmidhi </p>',
            ],
            21 => [
                'question' => 'Întrebarea nr. 22: Ce se spune după ce ai terminat de mâncat?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15370.mp3',
                'answer' => '<p> Răspuns: - „Alhamdu lillahil-ladhi at’amani hadha ua razaqani-hi min ghayri haulin minni uala quuah.” <span class="c2">(Laudă lui Allah, Cel care m-a hrănit<br /> şi m-a îndestulat cu această hrană, fără ca eu să am vreo forţă sau vreo putere <span class="c5">[întru aceasta]</span>.)</span> Consemnat de Abu Daud, Ibn Majah și alții </p>',
            ],
            22 => [
                'question' => 'Întrebarea nr. 23: Care este ruga pe care musafirul trebuie să o facă pentru gazdă?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15400.mp3',
                'answer' => '<p> Răspuns: - „Allahumma barik lahum fima razaqtahum, uaghfir lahum uarhamhum.” <span class="c2">(O, Allah, binecuvântează pentru ei ceea ce Tu le-ai dăruit, Iartă-i şi fii Milostiv cu ei.)</span> Consemnat de Muslim </p>',
            ],
            23 => [
                'question' => 'Întrebarea nr. 24: Ce spune cel care strănută?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15430.mp3',
                'answer' => '<p> Răspuns: - „Alhamdulillah” <span class="c2">(Laudă lui Allah)</span>.<br /> Iar fratele sau însoţitorul său <span class="c5">[care îl aude]</span> să îi spună: „Iarhamuka Allah.” <span class="c2">(Allah să aibă milă de tine <span class="c5">[şi să te ierte]</span>!)</span><br /> Și dacă acesta i-a spus „Allah să aibă milă de tine <span class="c5">[şi să te ierte]</span>!”, el să-<span class="c6">i răspundă:</span> „Iahdikumu-llahu ua iuslih balakum” <span class="c2">(Allah să te călăuzească şi să îndrepte situația ta <span class="c5">[îndrumându-te pe calea cea dreaptă]</span>!)</span> Consemnat de Bukhari </p>',
            ],
            24 => [
                'question' => 'Întrebarea nr. 25: Ce se spune la părăsirea unei întruniri - ruga spusă pentru ispășirea păcatelor la sfârșitul unei întruniri?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15480.mp3',
                'answer' => '<p> Răspuns: „Subhanakal-lahumma ua bihamdik, aşhadu an la ilaha illa ant, astaghfiruka uaatubu ilayk.” <span class="c2">(Cât de Măreţ şi Perfect eşti Tu, O, Allah, şi toată Lauda fie a Ta! Mărturisesc că nu există altă divinitate demnă de a fi adorată în afară de Tine. Caut iertarea Ta şi mă întorc la Tine cu căinţă.)</span> Consemnat de Abu Daud, Tirmidhi și alții </p>',
            ],
            25 => [
                'question' => 'Întrebarea nr. 26: Care este ruga spusă la urcarea pe un animal sau
  într-un mijloc de transport?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15510.mp3',
                'answer' => '<p> Răspuns: - „Bismillah, ua-lhamdulillah, subhanalladhi sakh-khara lana hadha uama kunna lahu muqrinin, uainna ila rabbina lamunqalibun,<br /> alhamdulillah, alhamdulillah, alhamdu lillah, Allahu akbar, Allahu akbar, Allahu akbar, subhanakal-lahumma inni dhalamtu nafsi faghfir li fainnahu la yaghfirudhdhunuba illa ant.” <span class="c2">(În numele lui Allah şi Laudă lui Allah! Cât de Măreţ şi Perfect este El, Cel care a pus la dispoziţia noastră <span class="c5">[acest mijloc de transport]</span>, în vreme ce prin noi înşine n-am fi fost capabili de acest lucru, şi, cu adevărat, la Domnul nostru este întoarcerea noastră finală! Laudă lui Allah! Laudă lui Allah! Laudă lui Allah! Allah este Cel mai<br /> Măreţ! Allah este Cel mai Măreţ! Allah este Cel mai Măreţ! Cât de Măreţ şi Perfect eşti Tu, o, Allah, cu adevărat, eu mi-am nedreptăţit sufletul. <span class="c5">[Te rog,]</span> iartă-mă, căci, cu adevărat, nimeni nu poate ierta păcatele în afară de Tine.”)</span> Consemnat de Abu Daud și Tirmidhi </p>',
            ],
            26 => [
                'question' => 'Întrebarea nr. 27: Care este ruga pentru călătorie?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15540.mp3',
                'answer' => '<p> „Allahu akbar, Allahu akbar, Allahu akbar, subhanal-ladhi sakh-khara lana<br /> hadha uama kunna lahu muqrinin, ua-inna ila rabbina lamunqalibun, allahumma inna nas’aluka fi safarina hadha albirra uattaqua,<br /> uaminal-’amali ma tarda, allahumma hauuin ‘alayna safarana hadha, uatui ‘anna bu’dah, allahumma antas-sahibu fis-safar, ualkhalifatu fil-ahl, allahumma inni ‘audhu bika min ua’tha-is-safar, uaka’abatil mandhar, uasu-il-munqalabi fil-mali ual-ahl.„ <span class="c2">(Allah este Cel mai Măreţ! Allah este Cel mai Măreţ! Allah este Cel mai Măreţ! Cât de Măreţ şi Perfect este El, Cel care a pus la dispoziţia noastră <span class="c5">[acest mijloc de transport]</span> în vreme ce prin noi înşine n-am fi fost capabili de acest lucru şi, cu adevărat,<br /> la Domnul nostru este întoarcerea noastră finală! O, Allah, Îţi cerem în această călătorie a noastră supunerea şi evlavia <span class="c5">[faţă de Tine]</span> şi dintre fapte ceea ce Te mulţumeşte pe Tine. O, Allah, uşurează pentru noi această călătorie şi ajută-ne să parcurgem distanţa ei cu repeziciune. O, Allah, Tu eşti Cel ce ne însoţeşte în călătorie şi Cel în grija Căruia se află familia <span class="c5">[lăsată acasă]</span>. O, Allah, cu adevărat eu caut adăpost la Tine<br /> de dificultăţile călătoriei, de priveliştile rele <span class="c5">[care ne-ar întrista]</span> şi de un rău abătut asupra averii şi a familiei <span class="c5">[mele]</span>)</span><br /> Iar dacă s-<span class="c6">a întors din călătorie a spus același lucru și a adăugat la sfârșit:</span><br /> „Ayibuna, ta‘ibuna, ‘abiduna, lirabbina hamidun.” <span class="c2">(Noi ne întoarcem şi ne căim, şi pe Domnul nostru Îl adorăm şi Îl lăudăm.)</span> Consemnat de Muslim </p>',
            ],
            27 => [
                'question' => 'Întrebarea nr. 28: Care este ruga călătorului pentru cel care
  rămâne acasă?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15590.mp3',
                'answer' => '<p> Răspuns: „Astaudi’ukumul-lah, alladhi la tadi’u uada’i’uh.” <span class="c2">(Vă pun în grija lui Allah, căci nimic din ceea ce este pus în grija Sa nu este pierdut.)</span> Consemnat de Ahmad și Ibn Majah </p>',
            ],
            28 => [
                'question' => 'Întrebarea nr. 29:  Care este ruga celor care rămân acasă pentru
  călător?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15620.mp3',
                'answer' => '<p> Răspuns: - „Astaudi’ul-laha dinak, ua-amanatak, uakhauatima ‘amalik.” <span class="c2">(Pun religia ta, <span class="c5">[onestitatea şi]</span> siguranţa ta, precum şi cele din urmă fapte<br /> ale tale în grija lui Allah!)</span> Consemnat de Ahmad și Tirmidhi </p>',
            ],
            29 => [
                'question' => 'Întrebarea nr. 30: Care este ruga spusă la intrarea în piață (centru comercial)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15650.mp3',
                'answer' => '<p> Răspuns: „La ilaha ill allah, uahdahu la şarika lah, lahul-mulku ualahul-hamd, yuhyi ua yumitu uahuua hayyun la yamut, biyadihil- khayru<br /> uahuua ‘ala kulli şayin qadir.” <span class="c2">(Nu există altă divinitate demnă de a<br /> fi adorată în afară de Allah, Unicul, care nu are pe nimeni asociat. A Lui este Împărăţia şi Lauda! El dăruieşte viaţa şi moartea, şi El este Cel Veşnic, fără de moarte. În Mâna Sa se află tot binele şi El este cu putere peste toate <span class="c5">[Atotputernic]</span>.)</span> Consemnat de Tirmidhi și Ibn Majah </p>',
            ],
            30 => [
                'question' => 'Întrebarea nr. 31: Care este ruga care trebuie spusă la mânie?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15680.mp3',
                'answer' => '<p> Răspuns: - „‘Audhu billahi minaş- şaytanir- ragiim” <span class="c2">(Caut adăpost la Allah de Satana cel alungat!)</span> Bukhari și Muslim </p>',
            ],
            31 => [
                'question' => 'Întrebarea nr. 32: Ce i se spune celui care ți-a făcut un bine?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15710.mp3',
                'answer' => '<p> Răspuns: - „Giazakal-lahu khayran.” <span class="c2">(Allah să te răsplătească cu tot ce e mai bun!)</span> Consemnat de Tirmidhi </p>',
            ],
            32 => [
                'question' => 'Întrebarea nr. 33: Care este ruga spusă atunci când animalul
  încălecat se împiedică (sau mijlocul de transport se defectează)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15740.mp3',
                'answer' => '<p> Răspuns: „Bismillah” <span class="c2">(În numele lui Allah)</span> Consemnat de Abu Daud </p>',
            ],
            33 => [
                'question' => 'Întrebarea nr. 34: Ce se spune dacă ți s-a întâmplat ceva care te bucură?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15770.mp3',
                'answer' => '<p> Răspuns: - „Alhamdulillahil-ladhi bi ni’matihi tatimmus-salihat.” <span class="c2">(Laudă lui Allah prin ale Cărui binecuvântări toate cele bune se împlinesc!)</span> Consemnat de Al-Hakim și alții </p>',
            ],
            34 => [
                'question' => 'Întrebarea nr. 25: Ce se spune dacă ți s-a întâmplat ceva neplăcut?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15800.mp3',
                'answer' => '<p> Răspuns: - „Alhamdu lillahi ‘ala kulli hal.” <span class="c2">(Lăudat fie Allah în orice împrejurare <span class="c5">[fie bună sau rea]</span>!)</span> Sahih Al-Jami\'a </p>',
            ],
            35 => [
                'question' => 'Întrebarea nr. 36: Care este modalitatea islamică de salut și răspunsul la acesta?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15830.mp3',
                'answer' => '<p> Răspuns: -<span class="c6"> Musulmanul trebuie să spună:</span> „Assalamu aleykum ua rahmatullahi ua barakatuhu” <span class="c2">(Pacea, Îndurarea și Binecuvântarea lui Allah fie asupra voastră)</span><br /> Iar fratele său trebuie să îi răspundă: „Ua aleykum assalam ua rahmatullahi ua barakatuhu” <span class="c2">(Și asupra voastră să fie Pacea, Îndurarea și Binecuvântarea lui Allah)</span> Consemnat de Tirmidhi, Abu Daud și alții </p>',
            ],
            36 => [
                'question' => 'Întrebarea nr. 37: Care este ruga spusă atunci când plouă?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15870.mp3',
                'answer' => '<p> Răspuns: - „Allahumma sayyiban nafi’an” <span class="c2">(O, Allah, <span class="c5">[fă-l]</span> un nor de ploaie<br /> binefăcătoare)</span> Consemnat de Bukhari </p>',
            ],
            37 => [
                'question' => 'Întrebarea nr. 38: Care este ruga spusă după ploaie?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15900.mp3',
                'answer' => '<p> Răspuns: - „Mutirna bifadlil-lahi uarahmatih.” <span class="c2">(Ploaia a fost revărsată asupra noastră prin Harul <span class="c5">[binecuvântarea]</span> şi Îndurarea lui Allah!)</span> Bukhari și Muslim </p>',
            ],
            38 => [
                'question' => 'Întrebarea nr. 39: Care este pomenirea spusă când vântul se întețește sau în timpul unei furtuni?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15930.mp3',
                'answer' => '<p> Răspuns: „Allahumma inni as-aluka khayraha ua-’audhu bika min şarriha.” <span class="c2">(O, Allah, îţi cer ce este bun în el <span class="c5">[în acest vânt]</span> şi caut adăpost la Tine de răul din el.)</span> Consemnat de Abu Daud și Ibn Majah </p>',
            ],
            39 => [
                'question' => 'Întrebarea nr. 40: Care este ruga spusă atunci când auzi un tunet?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15960.mp3',
                'answer' => '<p> Răspuns: - „Subhanal-ladhi yusabbihur- ra’adu bihamdih, ualmala-ikatu min khifatih.” <span class="c2">(Cât de Măreţ şi Perfect este El, Cel pe care tunetul Îl slăveşte aducându-I laude, precum şi Îngerii, de teama Lui.)</span> Consemnat de Muta\'a Malik </p>',
            ],
            40 => [
                'question' => 'Întrebarea nr. 41: Ce rugă se spune dacă ai văzut un om care trece printr-o suferință?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15990.mp3',
                'answer' => '<p> Răspuns: - „Alhamdulillahil-ladhi ‘afani mimmabtalaka bih, ua faddalani ‘ala kathirin mimman khalaqa tafdila.” <span class="c2">(Laudă lui Allah, Cel care m-a ferit<br /> de cele cu care tu ai fost încercat şi m-a favorizat cu o bună binecuvântare peste mulţi dintre cei pe care El i-a creat.)</span> Consemnat de Tirmidhi </p>',
            ],
            41 => [
                'question' => 'Întrebarea nr. 34: Care este ruga spusă de cel care se teme să deoache ceva sau pe cineva?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16020.mp3',
                'answer' => '<p> Răspuns: - A fost relatat într-<span class="c6">un hadis:</span> „Dacă unul dintre voi a văzut la fratele său sau la sine însuşi sau printre cele care îi aparţin ceva care îi este plăcut lui, să se roage pentru binecuvântarea acestui lucru,<br /> căci deochiul există cu adevărat.” Consemnat de Ahmad, Ibn Majah și alții </p>',
            ],
            42 => [
                'question' => 'Întrebarea nr. 34: Cum se transmit salutări asupra Profetului (Pacea și binecuvântarea lui Allah fie asupra sa)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16050.mp3',
                'answer' => '<p> Răspuns: - „Allahumma salli ‘ala Mohammed, ua-’ala ali Mohammed, kama sallayta ‘ala Ibrahim ua-’ala ali Ibrahim, innaka Hamidun Magid,<br /> allahumma barik ‘ala Mohammed, ua-’ala ali Mohammed, kama barakta ‘ala Ibrahim ua- ’ala ali Ibrahim, innaka Hamidun Magid.” <span class="c2">(O, Allah, trimite salutări asupra lui Mohammed şi asupra urmaşilor lui Mohammed, aşa cum ai trimis salutările Tale asupra lui Avraam şi asupra urmaşilor<br /> lui Avraam. Cu adevărat, Tu eşti plin de Slavă şi Măreţie. O, Allah, trimite<br /> binecuvântarea Ta asupra lui Mohammed şi asupra urmaşilor lui Mohammed, aşa cum ai trimis binecuvântări asupra lui Avraam şi<br /> asupra urmaşilor lui Avraam. Cu adevărat, Tu eşti plin de Slavă şi Măreţie!)</span> Bukhari și Muslim </p>',
            ],
        ],
        9 => [
            0 => [
                'question' => 'Întrebarea nr. 1: Care sunt cele 5 nivele ale reglementărilor religioase?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16090.mp3',
                'answer' => '<p> Răspuns:<br /> 1 - „Uagib” <span class="c2">(obligatoriu)</span><br /> 2 - „Mustahab” <span class="c2">(preferabil)</span><br /> 3 - „Muharram” <span class="c2">(interzis)</span><br /> 4 - „Makruh” <span class="c2">(neplăcut, neindicat)</span><br /> 5 - „Mubah” <span class="c2">(permis)</span> </p>',
            ],
            1 => [
                'question' => 'Întrebarea nr. 2: Explică aceste 5 niveluri ale reglementărilor religioase.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16170.mp3',
                'answer' => '<p> Răspuns:<br /> 1 -<span class="c6"> „Uagib”:</span> asemenea celor 5 rugăciuni obligatorii, postul în Ramadan, buna purtare arătată față de părinți<br /> - Pentru acțiunile „uagib” cel care le împlinește este răsplătit, iar cel care nu le împlinește este pedepsit.<br /> 2 -<span class="c6"> „Mustahab”:</span> precum rugăciunile voluntare, rugăciunea voluntară de noapte, hrănirea oamenilor, răspândirea salutului islamic. Acestea se numesc „sunnah” sau „mandub”.<br /> - Pentru acțiunile „mustahab” cel care le împlinește este răsplătit, iar cel care nu le împlinește nu e pedepsit.<span class="c6"><br /> Mențiune importantă:</span><br /> Musulmanul ar trebui ca atunci când ia cunoștință de o acțiune sunnah sau mustahab să se grăbească în împlinirea acesteia pentru a urma exemplul Profetului <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span>.<br /> 3 -<span class="c6"> „Muharram”:</span> precum consumul de alcool, comportamentul rău față de părinți, ruperea legăturilor cu rudele de sânge.<br /> - Pentru acțiunile „muharram” cel care se ferește de ele este răsplătit, iar cel care le dă curs este pedepsit.<br /> 4 -<span class="c6"> „Makruh”:</span> precum a lua ceva sau a da ceva cu mâna stângă sau a sufleca hainele în timpul rugăciunii.<br /> - Pentru acțiunile „makruh”, cel care le părăsește este răsplătit, iar cel care le împlinește nu este pedepsit.<br /> 5 - „Mubah” - precum a mânca mere, a bea ceai etc, și este numit și „gea\'iz” și „halal”.<br /> - Pentru acțiunile „mubah”, cel care nu le împlinește nu este răsplătit, iar cel care le împlinește nu este pedepsit. </p>',
            ],
            2 => [
                'question' => 'Întrebarea nr. 3: Care este nivelul de încadrare a tranzacțiilor și acțiunilor comerciale?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16320.mp3',
                'answer' => '<p> Răspuns: - La bază, toate tranzacțiile și acțiunile comerciale sunt permise, cu excepția anumitor tipuri care au fost interzise de Allah Preaînaltul.<span class="c6"><br /> A spus Allah Preaînaltul:</span> „Dar Allah a permis comerțul, însă a interzis dobânda” <span class="c5">[Coran,<span class="c6"> 2:</span>275]</span> </p>',
            ],
            3 => [
                'question' => 'Întrebarea nr. 4: Menționează câteva dintre tranzacțiile și acțiunile comerciale interzise.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16360.mp3',
                'answer' => '<p> Răspuns:<br /> 1 - Înșelăciunea și frauda, cum ar fi ascunderea defectelor mărfurilor<br /> Abu Huraira <span class="c2">(Allah să fie mulțumit de el)</span> a relatat că Mesagerul lui Allah <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> a trecut pe lângă o grămadă de grâne <span class="c2">(expuse pentru vânzare)</span> și și-a trecut mâna prin ea, iar degetele sale s-au umezit.<span class="c6"> Atunci a spus:</span> „Ce e aceasta?!” Omul a răspuns: „A plouat peste ele, o, Mesager al lui Allah!” <span class="c2">(Atunci, Profetul - Pacea și binecuvântarea lui Allah fie asupra sa)</span> a spus: „De ce nu ai pus grânele umede deasupra, pentru ca oamenii să le poată vedea? Cel care înșeală nu este dintre ai mei <span class="c2">(și nu are nicio legătură cu mine)</span>!” Consemnat de Muslim<br /> 2 -<span class="c6"> Camăta:</span> cum ar fi spre exemplu să iau o mie <span class="c2">(de lei)</span> de la cineva cu înțelegerea de a-i înapoia două mii.<br /> Acest surplus la împrumutul luat este camăta sau dobânda, care este interzisă.<span class="c6"><br /> Allah Preaînaltul a spus:</span> „Dar Allah a permis comerțul, însă a interzis dobânda” <span class="c5">[Coran,<span class="c6"> 2:</span>275]</span><br /> 3 - Incertitudinea,<span class="c6"> înșelăciunea și neștiința:</span> precum a vinde laptele din ugerul unei oi sau a vinde peștele care se află în apă și pe care nu l-am pescuit încă.<br /> Într-un hadis, Mesagerul lui Allah <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> a interzis tranzacțiile comerciale incerte. Consemnat de Muslim </p>',
            ],
            4 => [
                'question' => 'Întrebarea nr. 5: Amintește câteva dintre binecuvântările pogorâte de Allah asupra ta.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16460.mp3',
                'answer' => '<p> Răspuns: - 1 - Binecuvântarea cu Islamul și faptul că nu ești dintre necredincioși<br /> 2 - Binecuvântarea cu urmarea exemplului Profetului Mohammed - sunnah, și că nu ești dintre cei ce dau curs inovațiilor în religie<br /> 3 - Binecuvântarea cu sănătate și o stare de bine și faptul că poți auzi, vedea, merge etc<br /> 4 - Binecuvântarea de a avea ceea ce ai nevoie să mănânci, să bei și să te îmbraci<br /> Iar binecuvântările lui Allah Preaînaltul asupra noastră sunt numeroase și nu pot fi numărate.<span class="c6"><br /> A spus Allah Preaînaltul:</span> „Și de ați <span class="c5">[vrea să]</span> socotiți binefacerile lui Allah, voi nu veți reuși să le numărați. Cu adevărat, Allah este Ghafur <span class="c5">[Iertător]</span>, Rahim <span class="c5">[Îndurător]</span>” <span class="c5">[Coran,<span class="c6"> 16:</span>18]</span> </p>',
            ],
            5 => [
                'question' => 'Întrebarea nr. 6: Care este obligația noastră în raportarea la binecuvântările cu care am fost dăruiți? Cum trebuie să mulțumim pentru ele?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16540.mp3',
                'answer' => '<p> Răspuns: Mulțumirea pentru acestea prin elogierea lui Allah și arătarea mulțumirii față de El în vorbe, prin exprimarea faptului că Harul Îi aparține numai Lui, Unicul; precum și prin folosirea acestor binecuvântări într-o modalitate care să atragă Mulțumirea lui Allah, Preaînaltul, și nu în modalități care încalcă poruncile Sale. </p>',
            ],
            6 => [
                'question' => 'întrebarea nr. 7: Care sunt Sărbătorile musulmanilor?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16570.mp3',
                'answer' => '<p> Răspuns: Sărbătoarea de după Ramadan <span class="c2">(Aid al-Fitr)</span> și sărbătoarea de după Hajj <span class="c2">(Aid al-Adha - Sărbătoarea Sacrificiului)</span>.<br /> Într-un hadis, Anas a relatat că atunci când Mesagerul lui Allah <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> a venit la Medina, aceștia aveau două zile de distracție și celebrare.<span class="c6"> Atunci el a spus:</span> „Ce sunt aceste două zile?” Au răspuns: „În aceste zile obișnuiam să ne distrăm în perioada preislamică.” Iar Mesagerul lui Allah <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> a spus: „Allah vi le-<span class="c6">a schimbat pe acestea cu două zile mai bune decât ele:</span> Yaum al-Adha <span class="c2">(Sărbătoarea Sacrificiului)</span> și Yaum al-Fitr <span class="c2">(Sărbătoarea de Fitr, de după Ramadan)</span>. Consemnat de Abu Daud<br /> Și orice alte sărbători în afară de acestea sunt inovație <span class="c2">(în religie și nu sunt permise)</span>. </p>',
            ],
            7 => [
                'question' => 'Întrebarea nr. 8: Care este cea mai bună lună a anului?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16620.mp3',
                'answer' => '<p> Răspuns: Luna Ramadan. </p>',
            ],
            8 => [
                'question' => 'Întrebarea nr. 9: Care este cea mai bună zi?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16650.mp3',
                'answer' => '<p> Răspuns: Ziua de vineri. </p>',
            ],
            9 => [
                'question' => 'Întrebarea nr. 10: Care este cea mai bună zi din an?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16680.mp3',
                'answer' => '<p> Răspuns: Ziua de Arafah <span class="c2">(a noua zi din luna Dhul Hijjah)</span>. </p>',
            ],
            10 => [
                'question' => 'Întrebarea nr. 11: Care este cea mai bună noapte din an?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16710.mp3',
                'answer' => '<p> Răspuns: Lailatul Qadr <span class="c2">(Noaptea Destinului - din ultimele zece nopți din Ramadan)</span>. </p>',
            ],
            11 => [
                'question' => 'Întrebarea nr. 12: Care este obligația care se impune dacă ai văzut o femeie străină de tine?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16740.mp3',
                'answer' => '<p> Răspuns: Trebuie să îți ferești privirea.<span class="c6"> Allah Preaînaltul a spus:</span> „Spune dreptcredincioșilor să-și plece privirile.” <span class="c5">[Coran,<span class="c6"> 24:</span>30]</span> </p>',
            ],
            12 => [
                'question' => 'Întrebarea nr. 13: Cine sunt dușmanii oamenilor?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16770.mp3',
                'answer' => '<p> 1 -<span class="c6"> Propriul sine care te împinge la a face rău:</span> precum urmarea de către om a celor spre care îl împinge sinele său și poftele și dorințele sale în neascultarea lui Allah Preaslăvitul și Preaînaltul.<span class="c6"> A spus Allah Preaslăvitul:</span> „<span class="c5">[...]</span><br /> căci sufletul este înclinat către rău, în afară de cel pe care îl păzește<br /> Domnul meu prin Îndurarea Lui, căci Domnul meu este Ghafur <span class="c5">[Iertător]</span> și Rahim <span class="c5">[Îndurător]</span>.” <span class="c5">[Coran,<span class="c6"> 12:</span>53]</span> 2 -<span class="c6"> Șeitan:</span> care este dușmanul omenirii, al cărui scop este rătăcirea omului și îndemnarea sa la ceea ce este rău pentru a-l face să pătrundă în focul Iadului.<span class="c6"> Allah Preaînaltul a spus:</span> „<span class="c5">[...]</span> şi nu urmaţi paşii lui Şeitan. Cu adevărat el vă este duşman mărturisit.” <span class="c5">[Coran,<span class="c6"> 2:</span>168]</span> 3 -<span class="c6"> Prietenii răi:</span> care încurajează la ceea ce este rău și opresc de la ceea ce este bun.<span class="c6"> A spus Allah Preaînaltul:</span> Prietenii apropiați își vor fi în Ziua aceea dușmani unii altora, în afară de cei cu frică <span class="c5">[Coran,<span class="c6"> 43:</span>67]</span> </p>',
            ],
            13 => [
                'question' => 'Întrebarea nr. 14: Ce este „Tauba” (căința)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16820.mp3',
                'answer' => '<p> Răspuns: - „Tauba” <span class="c2">(căința)</span>: Este întoarcerea de la neascultarea lui Allah Preaînaltul la ascultarea Sa.<span class="c6"> A spus Allah Preaînaltul:</span> „Dar, cu adevărat, Eu sunt iertător cu Cel care se căiește, crede și<br /> împlinește fapte bune și apoi se lasă călăuzit pe calea cea bună.” <span class="c5">[Coran,<span class="c6"> 20:</span>82]</span> </p>',
            ],
            14 => [
                'question' => 'Întrebarea nr. 15: Care sunt condițiile unei căințe corecte?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16850.mp3',
                'answer' => '<p> Răspuns: - 1- Părăsirea păcatului<br /> 2 - Regretul pentru cele care s-au petrecut<br /> 3 -Consecvența și fermitatea în hotărârea de a nu se întoarce la păcat<br /> 4 -<span class="c6"> Restituirea drepturilor celor care au fost nedreptățiți<br /> Allah Preaînaltul a spus:</span> „Și pe cei care, dacă au săvârșit o faptă josnică sau au fost nedrepți cu<br /> propriile lor suflete, își aduc aminte de Allah și Îi cer iertare pentru păcatele lor - și cine poate ierta păcatele decât Allah? - și care nu<br /> persistă cu bună știință în ceea ce săvârșesc.” <span class="c5">[Coran,<span class="c6"> 3:</span>135]</span> </p>',
            ],
            15 => [
                'question' => 'Întrebarea nr. 16: Ce însemnă „as-salat \'ala an-nabiy” (trimiterea de salutări asupra Profetului)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16920.mp3',
                'answer' => '<p> Răspuns: Aceasta înseamnă să te rogi la Allah ca Profetul <span class="c2">(Pacea și binecuvântarea lui Allah fie asupra sa)</span> să fie elogiat în cele mai înalte întruniri <span class="c2">(ale Îngerilor)</span>. </p>',
            ],
            16 => [
                'question' => 'Întrebarea nr. 17: Ce înseamnă „Subhan Allah” (Slavă lui Allah)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16950.mp3',
                'answer' => '<p> Răspuns: - Aceasta este o formă de preamărire a lui Allah Preaînaltul și afirmă depărtărea Sa Preaslăvitul și Preaînaltul de orice deficit, defect sau răutate. </p>',
            ],
            17 => [
                'question' => 'Întrebarea nr. 18: Ce înseamnă „Alhamdulillah” (Laudă lui Allah)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16980.mp3',
                'answer' => '<p> Răspuns: Aceasta este o formă de elogiere a lui Allah Preaînaltul și caracterizarea Sa prin toate Atributele Perfecțiunii. </p>',
            ],
            18 => [
                'question' => 'Întrebarea nr. 19: Ce înseamnă „Allahu Akbar” (Allah este Cel mai Măreț)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/17000.mp3',
                'answer' => '<p> Răspuns: Aceasta înseamnă că Allah Preaslăvitul este mai Mare, mai Venerabil, mai Măreț și mai presus decât tot și toate. </p>',
            ],
            19 => [
                'question' => 'Întrebarea nr. 30: Ce înseamnă „La haula ua la quuata illa billah” (Nu există tărie și nici putere în afară de Allah)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/17030.mp3',
                'answer' => '<p> Răspuns: Aceasta înseamnă: Nu există nicio putere de transformare a omului dintr-un statut la altul și nici vreo putere a acestuia de a face acest lucru decât prin <span class="c2">(Puterea și Forța lui)</span> Allah. </p>',
            ],
            20 => [
                'question' => 'Întrebarea nr. 31: Ce înseamnă „Astaghfirullah” (O Allah, îți cer să mă ierți!)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/17060.mp3',
                'answer' => '<p> Răspuns: - Aceasta înseamnă că omul cere de la Domnul său să îi șteargă păcatele și să îi ascundă lipsurile <span class="c2">(și greșelile)</span>. </p>',
            ],
        ],
    ],
];
