<?php
$data = [
    'title' => 'То, что непозволительно не знать детям мусульман',
    'description' => 'Данный проект содержит простую программу по изучению вопросов, которые необходимо знать каждому мусульманину. Он включает в себя вопросы по вероубеждению, исламскому праву (фикх), биографии Пророка, да восхвалит его Аллах и приветствует, этикету, толкованию Корана, хадисам, нравственности и поминаниям Аллаха. Данный проект подготовлен специально для детей, но он также подходит мусульманам всех возрастов и новообращённым мусульманам.',
    'source' => 'https://kids.islamenc.com/ru/home',
    'author' => 'Yazan Abdul Razzaq Raziq Alghanim',
    'sections' => [
        0 => 'Раздел об убеждении (акыда)',
        1 => 'Раздел о исламском праве (фикхе)',
        2 => 'Раздел о жизнеописании Пророка (мир ему и благословение Аллаха)',
        3 => 'Раздел о толковании Корана (тафсир)',
        4 => 'Раздел о хадисах',
        5 => 'Раздел об исламском этикете (адаб)',
        6 => 'Раздел о нравственности',
        7 => 'Раздел о мольбах и словах поминания Аллаха',
        8 => 'Раздел о разном',
    ],
    'data' => [
        1 => [
            0 => [
                'question' => '1. Вопрос: кто твой Господь?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/200.mp3',
                'answer' => '<p> Ответ: мой Господь — Аллах, Который заботится обо мне и обо всём сущем посредством Своих милостей.<span class="c6"><br /> Доказательство — Слова Всевышнего:</span> <span class="c3">«Хвала Аллаху, Господу миров»</span> [Сура 1 <span class="c3">«Открывающая»</span>, аят 2]. </p>',
            ],
            1 => [
                'question' => '2. Вопрос: какова твоя религия?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/240.mp3',
                'answer' => '<p> Ответ: моя религия — ислам, то есть смирение пред Аллахом через единобожие, покорность Ему и отречение от ширка <span class="c2">(поклонения не Аллаху)</span> и его приверженцев.<span class="c6"><br /> Всевышний Аллах сказал:</span> <span class="c3">«Поистине, религия пред Аллахом — ислам…»</span> [Сура 3 <span class="c3">«Род Имрана»</span>, аят 19]. </p>',
            ],
            2 => [
                'question' => '3. Вопрос: кто твой пророк?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/280.mp3',
                'answer' => '<p> Ответ: Мухаммад <span class="c2">(мир ему и благословение Аллаха)</span>.<span class="c6"><br /> Всевышний Аллах сказал:</span> <span class="c3">«Мухаммад — Посланник Аллаха…»</span> [Сура 48 <span class="c3">«Победа»</span>, аят 29]. </p>',
            ],
            3 => [
                'question' => '4. Вопрос: что такое формула единобожия и каков её смысл?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/310.mp3',
                'answer' => '<p> Ответ: формула единобожия — это слова: «Нет бога, кроме Аллаха <span class="c2">(Ля иляха илляЛлах)</span>». Они означают, что нет никого достойного поклонения, кроме Аллаха.<span class="c6"><br /> Всевышний Аллах сказал:</span> <span class="c3">«Знай же, что нет бога, кроме Аллаха…»</span> [Сура 47 <span class="c3">«Мухаммад»</span>, аят 19]. </p>',
            ],
            4 => [
                'question' => '5. Вопрос: где Всевышний Аллах?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/350.mp3',
                'answer' => '<p> Ответ: Аллах в небесах над Троном, над всеми творениями.<span class="c6"> Всевышний Аллах сказал:</span> <span class="c3">«Милостивый вознёсся над Троном»</span> [Сура 20 <span class="c3">«Та. Ха»</span>, аят 5].<span class="c6"> И Он сказал:</span> <span class="c3">«Он — Одолевающий <span class="c5">[и находится]</span> над Своими рабами. Он — Мудрый, Ведающий»</span> [Сура 6 <span class="c3">«Скот»</span>, аят 18]. </p>',
            ],
            5 => [
                'question' => '6. Вопрос: что означает свидетельство о том, что Мухаммад — Посланник Аллаха?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/380.mp3',
                'answer' => '<p> Ответ: оно означает, что Аллах послал его к мирам добрым вестником и предостерегающим увещевателем.<span class="c6"><br /> Мы обязаны:</span><br /> 1) подчиняться его велениям;<br /> 2) верить тому, что он говорил;<br /> 3) не ослушиваться его;<br /> 4) поклоняться Аллаху только так, как он узаконил, то есть следовать его Сунне и отказываться от нововведений <span class="c2">(бидъа)</span>.<span class="c6"><br /> Всевышний Аллах сказал:</span> <span class="c3">«Кто покорен Посланнику, тот покорен Аллаху…»</span> [Сура 4 <span class="c3">«Женщины»</span>, аят 80].<span class="c6"> И Всевышний Аллах сказал:</span> <span class="c3">«Он не говорит по пристрастию: это только Откровение, которое внушается <span class="c5">[ему]</span>»</span> [Сура 53 <span class="c3">«Звезда»</span>, аяты 3–4].<span class="c6"> И Всевышний Аллах сказал:</span> <span class="c3">«Посланник Аллаха был прекрасным примером для вас, для тех, кто надеется на <span class="c5">[милость]</span> Аллаха и <span class="c5">[преуспеяние в]</span> Последний день и много поминает Аллаха»</span> [Сура 33 <span class="c3">«Союзники»</span>, аят 21]. </p>',
            ],
            6 => [
                'question' => '7. Вопрос: зачем Всевышний Аллах сотворил нас?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/480.mp3',
                'answer' => '<p> Ответ: Он сотворил нас, чтобы мы поклонялись Ему Одному, не придавая Ему никаких сотоварищей,<br /> а не для того, чтобы мы развлекались и забавлялись.<span class="c6"><br /> Всевышний Аллах сказал:</span> <span class="c3">«Я сотворил джиннов и людей только для того, чтобы они поклонялись Мне <span class="c5">[и не поклонялись никому иному]</span>»</span> [Сура 51 <span class="c3">«Рассеивающие»</span>, аят 56]. </p>',
            ],
            7 => [
                'question' => '8. Вопрос: что такое поклонение?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/530.mp3',
                'answer' => '<p> Ответ: так называется всё угодное Аллаху из слов и дел, тайных и явных.<span class="c6"><br /> Явные виды поклонения:</span> например, поминание Аллаха языком <span class="c2">(произнесение слов: <span class="c3">«СубханаЛлах»</span>, <span class="c3">«Аль-хамду лиЛлях»</span>, <span class="c3">«Аллаху акбар»</span> и так далее)</span>, молитва, хадж.<span class="c6"><br /> Тайные:</span> упование, страх, надежда. </p>',
            ],
            8 => [
                'question' => '9. Вопрос: какова наша главная обязанность?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/580.mp3',
                'answer' => '<p> Ответ: наша главная обязанность — исповедовать единобожие <span class="c2">(таухид)</span>. </p>',
            ],
            9 => [
                'question' => '10. Вопрос: на какие категории делится единобожие?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/610.mp3',
                'answer' => '<p> Ответ: 1) единственность Аллаха в Господстве — это вера в то, что именно Аллах является Творцом, даёт удел, Ему подвластно всё и Он распоряжается всем, и у Него нет никаких сотоварищей.<br /> 2) единственность Аллаха в Божественности — это вера в то, что только Аллах достоин поклонения и нельзя поклоняться никому, кроме Всевышнего Аллаха.<br /> 3) единственность Аллаха в именах и качествах — это вера в имена и качества Всевышнего Аллаха, упомянутые в Коране и Сунне. При этом мы никак не представляем их, не сравниваем с качествами творений и не отрицаем их.<span class="c6"><br /> Доказательство этих трёх категорий единобожия — Слова Всевышнего:</span> <span class="c3">«Господь небес, земли и того, что между ними! Поклоняйся Ему и будь стоек в поклонении Ему. Знаешь ли ты другого с таким именем <span class="c5">[или подобного Ему]</span>?»</span> [Сура 19 <span class="c3">«Марьям»</span>, аят 65]. </p>',
            ],
            10 => [
                'question' => '11. Вопрос: какой грех самый тяжкий?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/670.mp3',
                'answer' => '<p> Ответ: придавание Аллаху сотоварищей <span class="c2">(ширк)</span>.<span class="c6"><br /> Всевышний Аллах сказал:</span> <span class="c3">«Поистине, Аллах не прощает, когда к Нему приобщают сотоварищей, но прощает все остальные <span class="c5">[или менее тяжкие]</span> грехи, кому пожелает. Кто же приобщает сотоварищей к Аллаху, тот измышляет великий грех»</span> [Сура 4 <span class="c3">«Женщины»</span>, аят 48]. </p>',
            ],
            11 => [
                'question' => '12. Вопрос: что такое многобожие (ширк)? Назови его виды.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/710.mp3',
                'answer' => '<p> Ответ: многобожие — это обращение любого вида поклонения не к Аллаху.<br /> Виды многобожия таковы.<br /> Большое многобожие — это, например, обращение с мольбами не к Аллаху, совершение земного поклона не Аллаху, жертвоприношение не Аллаху.<br /> Малое многобожие — это, например, клятва не Аллахом, использование талисманов, амулетов, оберегов для того, чтобы получить пользу и отвести вред, а также небольшое совершение дел напоказ <span class="c2">(например, человек старается совершить молитву получше, когда на него кто-то смотрит)</span>. </p>',
            ],
            12 => [
                'question' => '13. Вопрос: знает ли сокровенное кто-то, кроме Всевышнего Аллаха?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/770.mp3',
                'answer' => '<p> Ответ: никто, кроме Аллаха, не знает сокровенного.<span class="c6"><br /> Всевышний Аллах сказал:</span> «Скажи: <span class="c1">“Никто из тех, кто на небесах и на земле, не ведает сокровенное, кроме Аллаха, и они даже не подозревают, когда их воскресят”</span>» [Сура 27 <span class="c3">«Муравьи»</span>, аят 65]. </p>',
            ],
            13 => [
                'question' => '14. Вопрос: перечисли столпы веры (иман).',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/810.mp3',
                'answer' => '<p> Ответ: 1) вера во Всевышнего Аллаха;<br /> 2) вера в Его ангелов;<br /> 3) вера в Его Писания;<br /> 4) вера в Его посланников;<br /> 5) вера в Судный день;<br /> 6) вера в предопределение всего хорошего и плохого.<br /> Доказательство — известный хадис Джибриля, который приводится в сборнике Муслима. В этом хадисе Джибриль сказал Пророку <span class="c2">(мир ему и благословение Аллаха)</span>: «Расскажи мне о вере <span class="c2">(иман)</span>».<span class="c6"> Он ответил:</span> <span class="c3">«Ты должен верить в Аллаха, Его ангелов, Его Писания, Его посланников и Судный день, а также верить в предопределение всего хорошего и плохого»</span>. </p>',
            ],
            14 => [
                'question' => '15. Вопрос: расскажи о столпах веры.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/900.mp3',
                'answer' => '<p> Ответ: вера в Аллаха:<br /> — мы верим в то, что именно Аллах — Творец и Дарующий удел, и лишь Ему подвластны все творения, и только Он распоряжается ими;<br /> — только Он достоин поклонения; и не достоин поклонения никто, кроме Него;<br /> — Он — Великий и Совершенный, Ему вся хвала, и у Него есть прекрасные имена и возвышенные качества, и нет равных и подобных Ему.<span class="c6"><br /> Вера в ангелов:</span><br /> — Аллах сотворил их из света для того, чтобы они поклонялись Ему, и они никогда не ослушиваются Его;<br /> — Среди них есть Джибриль <span class="c2">(мир ему)</span>,<span class="c6"> который передавал Откровение пророкам;<br /> Вера в Писания:</span><br /> — это Писания, которые Аллах ниспосылал Своим посланникам;<br /> — Коран Он ниспослал Мухаммаду <span class="c2">(мир ему и благословение Аллаха)</span>;<br /> — Инджиль <span class="c2">(Евангелие)</span> — Исе <span class="c2">(мир ему)</span>;<br /> — Таурат <span class="c2">(Тору)</span> — Мусе <span class="c2">(мир ему)</span>;<br /> — Забур <span class="c2">(Псалтырь)</span> — Дауду <span class="c2">(мир ему)</span>;<br /> — Свитки Ибрахима и Мусы — соответственно, Ибрахиму и Мусе <span class="c2">(мир им обоим)</span>.<span class="c6"><br /> Вера в посланников:</span><br /> — Аллах послал их к Своим рабам, чтобы они учили их, а также несли им благую весть о Рае и предостерегали их от зла и Ада;<br /> — Лучшие из них — твёрдые духом.<span class="c6"> Вот они:</span><br /> — Нух <span class="c2">(мир ему)</span>;<br /> — Ибрахим <span class="c2">(мир ему)</span>;<br /> — Муса <span class="c2">(мир ему)</span>;<br /> — Иса <span class="c2">(мир ему)</span>;<br /> — Мухаммад <span class="c2">(мир ему и благословение Аллаха)</span>.<span class="c6"><br /> Вера в Судный день:</span><br /> — это вера в то, что будет после смерти в могиле и в день Воскрешения и расчёта, когда обитатели Рая войдут в Рай, а обитатели Ада — в Ад.<span class="c6"><br /> Вера в предопределение всего хорошего и плохого:</span><br /> — это вера в то, что Аллах знает обо всём, что произошло, происходит и будет происходить в бытие, записал всё это на Хранимой Скрижали, пожелал и сотворил.<span class="c6"><br /> Всевышний Аллах сказал:</span> <span class="c3">«Поистине, Мы сотворили каждую вещь согласно предопределению»</span> [Сура 54 <span class="c3">«Месяц»</span>, аят 49].<br /> У него четыре этапа.<span class="c6"><br /> Первый:</span> знание Всевышнего Аллаха. Он знает обо всём до того, как оно произойдёт, и после.<span class="c6"><br /> Доказательство — Слова Всевышнего:</span> <span class="c3">«Поистине, только Аллах обладает знанием о Часе, ниспосылает дождь и знает о том, что в утробах. Ни один человек не знает, что он приобретёт завтра, и ни один человек не знает, в какой земле он умрёт. Поистине, Аллах — Знающий, Ведающий»</span> [Сура 31 <span class="c3">«Люкман»</span>, аят 34].<span class="c6"><br /> Второй этап:</span> Аллах записал всё это на Хранимой Скрижали. Там записано всё, что было, есть и будет.<span class="c6"><br /> Доказательство — Слова Всевышнего:</span> <span class="c3">«У Него ключи к сокровенному, и знает о них только Он. Ему известно то, что на суше и в море. Даже лист падает только с Его ведома. Нет ни зёрнышка во мраках земли, ни чего-либо свежего или сухого, чего бы не было в ясном Писании»</span> [Сура 6 <span class="c3">«Скот»</span>, аят 59].<span class="c6"><br /> Третий этап:</span> всё происходит по воле Аллаха и всё, что делает Он и Его творения не выходит за пределы Его воли.<span class="c6"><br /> Доказательство — Слова Всевышнего:</span> <span class="c3">«тем из вас, кто желает следовать прямым путём. Но вы не пожелаете этого, если этого не пожелает Аллах, Господь миров»</span> [Сура 81 <span class="c3">«Скручивание»</span>, аяты 28–29].<span class="c6"><br /> Четвёртый этап:</span> вера в то, что всё сущее сотворил Аллах. Он создал и сами творения, и их качества, и их действия, и всё в них.<span class="c6"><br /> Доказательство — Слова Всевышнего:</span> <span class="c3">«Аллах сотворил вас и то, что вы делаете»</span> [Сура 37 <span class="c3">«Стоящие в ряд»</span>, аят 96]. </p>',
            ],
            15 => [
                'question' => '16. Вопрос: что такое Коран?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1300.mp3',
                'answer' => '<p> Ответ: это несотворённые Слова Аллаха.<span class="c6"><br /> Всевышний Аллах сказал:</span> <span class="c3">«Если же какой-либо многобожник попросит у тебя убежища, то предоставь ему убежище, чтобы он мог услышать Слово Аллаха»</span> [Сура 9 <span class="c3">«Покаяние»</span> аят 6]. </p>',
            ],
            16 => [
                'question' => '17. Вопрос: что такое Сунна?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1330.mp3',
                'answer' => '<p> Ответ: это все слова, действия, молчаливые одобрения, а также описания внешности и нрава Пророка <span class="c2">(мир ему и благословение Аллаха)</span>. </p>',
            ],
            17 => [
                'question' => '18. Вопрос: что такое нововведение (бидъа)? И принимаем ли мы её?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1350.mp3',
                'answer' => '<p> Ответ: это всё, что люди привнесли в религию и чего не было в ней во времена Пророка <span class="c2">(мир ему и благословение Аллаха)</span> и его сподвижников.<br /> Мы не принимаем это, а, наоборот, отвергаем.<br /> Пророк <span class="c2">(мир ему и благословение Аллаха)</span> сказал: <span class="c3">«Всякое нововведение — заблуждение»</span> <span class="c5">[Абу Дауд]</span>.<span class="c6"><br /> Примеры нововведений:</span> добавление чего-либо в поклонение, например, четырёхкратное омывание органов при совершении малого омовения, празднование дня рождения Пророка <span class="c2">(мир ему и благословение Аллаха)</span> <span class="c2">(маулид)</span>. Ни Пророк <span class="c2">(мир ему и благословение Аллаха)</span>, ни его сподвижники этого не делали. </p>',
            ],
            18 => [
                'question' => '19. Вопрос: что такое лояльность (валя) и отречение (бара)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1410.mp3',
                'answer' => '<p> Ответ: лояльность <span class="c2">(валя)</span> — это любовь к верующим и помощь им.<span class="c6"><br /> Всевышний Аллах сказал:</span> <span class="c3">«Верующие мужчины и женщины являются помощниками и друзьями друг другу»</span> [Сура 9 <span class="c3">«Покаяние»</span>, аят 71].<br /> Отречение <span class="c2">(бара)</span> — это ненависть к неверующим и враждебное отношение к ним.<span class="c6"><br /> Всевышний Аллах сказал:</span> «Прекрасным примером для вас были Ибрахим <span class="c5">[Авраам]</span> и те, кто был с ним.<span class="c6"> Они сказали своему народу:</span> <span class="c1">“Мы отрекаемся от вас и тех, кому вы поклоняетесь вместо Аллаха. Мы отвергаем вас, и между нами и вами установились вражда и ненависть навеки, пока вы не уверуете в одного Аллаха”</span>» [Сура 60 <span class="c3">«Испытуемая»</span>, аят 4]. </p>',
            ],
            19 => [
                'question' => '20. Вопрос: примет ли Аллах иную религию, кроме ислама?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1480.mp3',
                'answer' => '<p> Ответ: Аллах не принимает ничего, кроме ислама.<span class="c6"><br /> Всевышний Аллах сказал:</span> <span class="c3">«От того, кто ищет иную религию помимо ислама, это никогда не будет принято, и в Последней жизни он окажется среди потерпевших урон»</span> [Сура 3 <span class="c3">«Род Имрана»</span>, аят 85]. </p>',
            ],
            20 => [
                'question' => '21. Вопрос: неверие бывает посредством слов, действий и убеждений. Приведи примеры.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1520.mp3',
                'answer' => '<p> Ответ: пример слова — богохульство, когда ругают Аллаха или Его Посланника <span class="c2">(мир ему и благословение Аллаха)</span>.<br /> Пример действий — осквернение мусхафа <span class="c2">(Корана)</span> или земной поклон не Аллаху.<br /> Пример убеждений — вера в то, что есть кто-то достойный поклонения, кроме Всевышнего Аллаха, или что есть творец помимо Аллаха. </p>',
            ],
            21 => [
                'question' => '22. Вопрос: расскажи о лицемерии (нифак) и его видах.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1570.mp3',
                'answer' => '<p> Ответ:<br /> 1. Великое лицемерие — это когда человек притворяется верующим, скрывая в душе неверие.<br /> Такой человек не является мусульманином, это великое неверие.<span class="c6"><br /> Всевышний Аллах сказал:</span> <span class="c3">«Поистине, лицемеры окажутся на нижайшей ступени Огня, и ты не найдёшь для них помощника»</span> [Сура 4 <span class="c3">«Женщины»</span>, аят 145].<br /> 2.<span class="c6"> Малое лицемерие:</span><br /> это, например, ложь, нарушение обещания, вероломный, нечестный поступок.<br /> Этот вид лицемерия не делает человека неверующим. Такие поступки являются грехами, за которые совершившему их грозит наказание от Аллаха.<br /> Посланник Аллаха <span class="c2">(мир ему и благословение Аллаха)</span> сказал: <span class="c3">«У лицемера три признака: говоря, он лжёт; обещая, нарушает обещание; а когда ему доверяют, он предаёт доверие»</span> <span class="c5">[аль-Бухари; Муслим]</span>. </p>',
            ],
            22 => [
                'question' => '22. Вопрос: кто является последним пророком?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1680.mp3',
                'answer' => '<p> Ответ: Мухаммад <span class="c2">(мир ему и благословение Аллаха)</span>.<span class="c6"><br /> Всевышний Аллах сказал:</span> <span class="c3">«Мухаммад не является отцом кого-либо из ваших мужей, но он —посланник Аллаха и последний из пророков»</span> [Сура 33 <span class="c3">«Союзники»</span>, аят 40]. Посланник Аллаха <span class="c2">(мир ему и благословение Аллаха)</span> сказал: <span class="c3">«Поистине, я — последний из пророков, и после меня не будет пророков»</span>. <span class="c5">[Абу Дауд; ат-Тирмизи и другие]</span>. </p>',
            ],
            23 => [
                'question' => '24. Вопрос: что такое знамение (муаджиза)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1730.mp3',
                'answer' => '<p> Ответ: знамения это чудеса, которые Всевышний Аллах явил через Своих пророков в подтверждение их правдивости.<span class="c6"> Вот примеры таких чудес:</span><br /> — раскалывание луны для нашего Пророка <span class="c2">(мир ему и благословение Аллаха)</span>;<br /> — расступившееся море для Мусы <span class="c2">(мир ему)</span> и потопление Фараона и его воинства. </p>',
            ],
            24 => [
                'question' => '25. Вопрос: кто такие сподвижники? Должны ли мы их любить?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1780.mp3',
                'answer' => '<p> Ответ: сподвижник — этот каждый, кто встречался с Пророком <span class="c2">(мир ему и благословение Аллаха)</span>, будучи уверовавшим в него, и умер мусульманином.<br /> Мы любим их и берём с них пример. Они — лучшие люди после пророков.<span class="c6"><br /> Лучшие из них — четыре праведных халифа:</span><br /> Абу Бакр <span class="c2">(да будет доволен им Аллах)</span>;<br /> Умар <span class="c2">(да будет доволен им Аллах)</span>;<br /> Усман <span class="c2">(да будет доволен им Аллах)</span>;<br /> Али <span class="c2">(да будет доволен им Аллах)</span>. </p>',
            ],
            25 => [
                'question' => '26. Вопрос: кто такие матери верующих?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1870.mp3',
                'answer' => '<p> Ответ: это жёны Пророка <span class="c2">(мир ему и благословение Аллаха)</span>.<span class="c6"><br /> Всевышний Аллах сказал:</span> <span class="c3">«Пророк ближе к верующим, чем они сами, а его жёны — их матери»</span> [Сура 33 <span class="c3">«Союзники»</span>, аят 6]. </p>',
            ],
            26 => [
                'question' => '27. Вопрос: каковы права семейства Пророка (мир ему и благословение Аллаха) (ахлю-ль-бейт) перед нами?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1910.mp3',
                'answer' => '<p> Ответ: мы их любим и лояльны к ним, и мы ненавидим тех, кто ненавидит их, и не проявляем чрезмерности в отношении к ним. Семья Пророка <span class="c2">(мир ему и благословение Аллаха)</span> — это жёны Пророка <span class="c2">(мир ему и благословение Аллаха)</span> и верующие из числа его потомков, бану Хашим и бану аль-Мутталиб. </p>',
            ],
            27 => [
                'question' => '28. Вопрос: каковы наши обязанности по отношению к правителям-мусульманам?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1940.mp3',
                'answer' => '<p> Ответ: мы обязаны уважать их, слушаться и повиноваться им в том, что не является ослушанием Аллаха, не выступать против них, обращаться к Аллаху с мольбами за них и давать им благие советы с глазу на глаз. </p>',
            ],
            28 => [
                'question' => '29. Вопрос: какова обитель верующих?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1970.mp3',
                'answer' => '<p> Ответ: Рай.<span class="c6"> Всевышний Аллах сказал:</span> <span class="c3">«Поистине, Аллах введёт тех, которые уверовали и совершали праведные деяния, в Райские сады, в которых текут реки»</span> [Сура 47 <span class="c3">«Мухаммад»</span>, аят 12]. </p>',
            ],
            29 => [
                'question' => '30. Вопрос: какова обитель неверующих?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2000.mp3',
                'answer' => '<p> Ответ: Ад.<span class="c6"> Всевышний Аллах сказал:</span> <span class="c3">«побойтесь Огня, растопкой которого являются люди и камни. Он уготован неверующим»</span> [Сура 2 <span class="c3">«Корова»</span>, аят 24]. </p>',
            ],
            30 => [
                'question' => '31. Вопрос: что такое страх? Что такое надежда? Приведи доказательство.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2020.mp3',
                'answer' => '<p> Ответ: страх — это страх перед Аллахом и перед Его наказанием.<br /> Надежда — это надежда на награду, прощение и милость от Аллаха.<span class="c6"><br /> Доказательство — Слова Всевышнего:</span> <span class="c3">«Те, к кому они взывают с мольбой, сами ищут пути приближения к своему Господу, пытаясь опередить других. Они надеются на Его милость и страшатся Его мучений. Поистине, мучений твоего Господа надлежит остерегаться»</span> [Сура 17 <span class="c3">«Ночное путешествие»</span>, аят 57].<span class="c6"> Всевышний Аллах сказал:</span> <span class="c3">«Сообщи Моим рабам, что Я — Прощающий, Милующий, но наказание Моё — наказание мучительное»</span> [Сура 15 <span class="c3">«Хиджр»</span>, аяты 49–50]. </p>',
            ],
            31 => [
                'question' => '32. Вопрос: назовите некоторые имена и качества Всевышнего Аллаха?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2070.mp3',
                'answer' => '<p> Ответ: Аллах, ар-Рахман, Ас-Сами, Аль-Басыр, Аль-Алим, Ар-Раззак, Аль-Хайй, Аль-Азым. Есть и другие имена и качества Всевышнего. </p>',
            ],
            32 => [
                'question' => '33. Вопрос: объясни эти имена.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2100.mp3',
                'answer' => '<p> Ответ: Аллах — Бог; только Он достоин поклонения, и у Него нет сотоварищей.<br /> Ар-Рабб — Господь; единственный Творец и Властелин, дарующий удел и распоряжающийся Своими творениями.<br /> Ас-Сами — Слышащий; Он слышит всё, все без исключения звуки и голоса несмотря на их разновидности.<br /> Аль-Басыр — Видящий; Он видит абсолютно всё, как большое, так и малое.<br /> Аль-Алим — Знающий; Он знает абсолютно всё, Ему известно прошлое, настоящее и будущее.<br /> Ар-Рахман — Милостивый; Его милость объемлет все творения и распространяется на всех Его рабов, на всех, кого Он сотворил.<br /> Ар-Раззак — Дарующий удел; Он дарует удел всем творениям — людям, джиннам, животным.<br /> Аль-Хайй — Живой; Он бессмертен, тогда как все творения смертны.<br /> Аль-Азым — Великий; Ему присуще абсолютное совершенство и величие в Его именах, качествах и действиях. </p>',
            ],
            33 => [
                'question' => '34. Вопрос: каковы наши обязанности перед мусульманскими учёными?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2210.mp3',
                'answer' => '<p> Ответ: мы любим их, обращаемся к ним с вопросами по религии, говорим о них только хорошее, а тот, кто говорит о них плохое, поступает неправильно.<span class="c6"><br /> Всевышний Аллах сказал:</span> <span class="c3">«и тогда Аллах возвысит по степеням тех из вас, кто уверовал, и тех, кому даровано знание. Аллах ведает о том, что вы совершаете»</span> [Сура 58 <span class="c3">«Препирательство»</span>, аят 11]. </p>',
            ],
            34 => [
                'question' => '35. Вопрос: кто такие приближённые Аллаха?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2240.mp3',
                'answer' => '<p> Ответ: это богобоязненные верующие.<span class="c6"><br /> Всевышний Аллах сказал:</span> <span class="c3">«Поистине, приближённые Аллаха не познают страха и не будут опечалены. Которые уверовали и были богобоязненны»</span> [Сура 10 <span class="c3">«Юнус»</span>, аяты 62–63]. </p>',
            ],
            35 => [
                'question' => '36. Вопрос: разве вера это слова и дела?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2280.mp3',
                'answer' => '<p> Ответ: вера — это слова, дела и убеждения. </p>',
            ],
            36 => [
                'question' => '37. Вопрос: разве вера увеличивается и уменьшается?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2310.mp3',
                'answer' => '<p> Ответ: вера увеличивается посредством покорности Аллаху и уменьшается посредством грехов.<span class="c6"><br /> Всевышний Аллах сказал:</span> <span class="c3">«Верующими являются только те, сердца которых испытывают страх при упоминании Аллаха, вера которых усиливается, когда им читают Его аяты, которые уповают на своего Господа»</span> [Сура 8 <span class="c3">«Добыча»</span>, аят 2]. </p>',
            ],
            37 => [
                'question' => '38. Вопрос: что такое ихсан?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2350.mp3',
                'answer' => '<p> Ответ: это когда ты поклоняешься Аллаху так, будто видишь Его; даже если ты Его не видишь, то ведь Он видит тебя. </p>',
            ],
            38 => [
                'question' => '39. Вопрос: когда Всевышний Аллах принимает наши благие дела?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2370.mp3',
                'answer' => '<p> Ответ: когда соблюдаются два условия:<br /> 1) когда дело совершается с искренним намерением, ради Аллаха;<br /> 2) когда дело соответствует Сунне Пророка <span class="c2">(мир ему и благословение Аллаха)</span>. </p>',
            ],
            39 => [
                'question' => '40. Вопрос: что такое упование на Всевышнего Аллаха?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2420.mp3',
                'answer' => '<p> Ответ: это когда ты полагаешься на Аллаха в обретении благого и избавлении от вреда, используя при этом причины.<span class="c6"><br /> Всевышний Аллах сказал:</span> <span class="c3">«Тому, кто уповает на Аллаха, достаточно Его»</span> [Сура 65 <span class="c3">«Развод»</span>, аят 3].<br /> То есть ему довольно Его. </p>',
            ],
            40 => [
                'question' => '41. Вопрос: что такое обязанность побуждать к одобряемому религией и удерживать от порицаемого ею?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2470.mp3',
                'answer' => '<p> Ответ: побуждение к одобряемому — это побуждение к покорности Аллаху. Удержание от порицаемого — запрещение всякого ослушания Аллаха.<span class="c6"><br /> Всевышний Аллах сказал:</span> <span class="c3">«Вы лучшая из общин,<span class="c6"> появившаяся на благо человечества:</span> побуждаете к одобряемому, удерживаете от порицаемого и веруете в Аллаха»</span> [Сура 3 <span class="c3">«Род Имрана»</span>, аят 110]. </p>',
            ],
            41 => [
                'question' => '42. Вопрос: кто такие Ахлю-с-сунна ва-ль-джамаа (приверженцы Сунны и общины)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2510.mp3',
                'answer' => '<p> Ответ: это те, чьи слова, дела и убеждения соответствуют словам, делам и убеждениям Пророка <span class="c2">(мир ему и благословение Аллаха)</span> и его сподвижников.<br /> Они названы приверженцами Сунны потому, что они следуют Пророку <span class="c2">(мир ему и благословение Аллаха)</span> и отвергают нововведения.<br /> А приверженцами общины они названы потому, что они единогласны в отношении истины и не разногласят о ней. </p>',
            ],
        ],
        2 => [
            0 => [
                'question' => '1. Вопрос: что такое очищение (тахара)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2580.mp3',
                'answer' => '<p> Ответ: очищение — это избавление от осквернения и устранение нечистот.<br /> Устранение нечистоты — это когда мусульманин очищает своё тело, одежду или место, в котором молится, от любых нечистот.<br /> Избавление от осквернения — это совершение малого либо полного омовения очищающей водой, либо очищение землёй <span class="c2">(таяммум)</span> в случае, если у человека нет воды или нет возможности её использовать. </p>',
            ],
            1 => [
                'question' => '2. Вопрос: как следует устранять нечистоты?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2630.mp3',
                'answer' => '<p> Ответ: их смывают водой до их исчезновения.<br /> Если речь идёт о посуде, из которой ела или пила собака, то её моют семь раз, первый раз — с землёй. </p>',
            ],
            2 => [
                'question' => '3. Вопрос: каковы достоинства малого омовения (вуду)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2660.mp3',
                'answer' => '<p> Ответ: Посланник Аллаха <span class="c2">(мир ему и благословение Аллаха)</span> сказал: «Когда раб <span class="c5">[Аллаха]</span>, исповедующий ислам <span class="c2">(или: верующий)</span>, совершает омовение и омывает лицо, с лица его вместе с водой <span class="c2">(или: вместе с последней каплей воды)</span> сходит всё греховное, на что он смотрел своими глазами; когда он омывает руки, вместе с водой <span class="c2">(или: вместе с последней каплей воды)</span> с рук его сходит всё греховное, что он ими брал, а когда он омывает ноги, вместе с водой <span class="c2">(или: вместе с последней каплей воды)</span> с ног его сходит всё греховное, к чему они направлялись, и так продолжается до тех пор, пока он не выходит свободным от грехов» <span class="c5">[Муслим]</span>. </p>',
            ],
            3 => [
                'question' => '4. Вопрос: как мы совершаем малое омовение (вуду)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2690.mp3',
                'answer' => '<p> Ответ: 1) Моем кисти рук трижды.<br /> 2) Полоскаем рот, промываем нос и высмаркиваем воду трижды.<br /> Полоскание рта — набирание воды в рот, затем полоскание ею полость рта и затем её выплёвывание.<br /> Промывание носа — это втягивание воды в нос при помощи вдоха из правой руки.<br /> Высмаркивание предполагает, что мы высмаркиваем воду, которую набрали в нос, с помощью левой руки.<br /> 3) Моем лицо трижды.<br /> 4) Моем руки до локтей трижды.<br /> 5) Протираем голову влажными руками ото лба к затылку и обратно и протираем уши.<br /> 6) Моем ноги до щиколоток включительно трижды.<br /> Это самый совершенный способ делать омовение. О том, что Пророк <span class="c2">(мир ему и благословение Аллаха)</span> совершал омовение именно так, упоминается в хадисах, которые мы находим в сборниках аль-Бухари и Муслима, со слов Усмана, Абдуллаха ибн Зейда и других. У аль-Бухари и других приводятся также хадисы о том, что иногда Посланник Аллаха <span class="c2">(мир ему и благословение Аллаха)</span> проделывал упомянутые действия по одному либо по два раза. Имеется ввиду, что он омывал каждую часть тела омываемую в омовении один или два раза. </p>',
            ],
            4 => [
                'question' => '5. Вопрос: что такое обязательные (фард) составляющие вуду? Назови их.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2810.mp3',
                'answer' => '<p> Ответ: это те действия, которые при оставлении даже одного из них,<span class="c6"> делают омовение недействительным:</span><br /> 1) омывание лица вместе с полосканием рта и промыванием носа;<br /> 2) мытьё рук до локтей включительно;<br /> 3) протирание головы и ушей;<br /> 4) мытьё ног до щиколоток;<br /> 5) порядок выполнения действий: сначала моем лицо, потом — руки, потом протираем голову,<span class="c6"> потом моем ноги;<br /> 6) непрерывность действий:</span> между действиями не должно быть таких промежутков времени, за которые омытые части тела успеют высохнуть.<br /> Например, человек совершает половину омовения, а заканчивает его спустя какое-то время. Такое омовение недействительно. </p>',
            ],
            5 => [
                'question' => '6. Вопрос: что такое желательные действия (сунны) омовения? Перечисли их.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2910.mp3',
                'answer' => '<p> Ответ: желательные действия омовения — это действия, выполняя которые, мы получаем дополнительную награду, а пропуская их, мы не совершаем греха, то есть наше омовение действительно и без них.<span class="c6"><br /> 1) произнесение слов:</span> <span class="c3">«Бисмиллях»</span>;<br /> 2) сивак;<br /> 3) мытьё кистей рук;<br /> 4) промывание области между пальцами;<br /> 5) второе и третье обмывание частей тела;<br /> 6) начинание с правой стороны;<br /> 7) поминание Аллаха после омовения: «Свидетельствую, что нет бога, кроме Аллаха, у Которого нет сотоварищей, и свидетельствую, что Мухаммад — Его раб и посланник <span class="c2">(Ашхаду алля иляха илляЛлаху ва ашхаду анна мухаммадан абдуху ва расулюху)</span>»;<br /> 8) молитва в два ракаата после омовения. </p>',
            ],
            6 => [
                'question' => '7. Вопрос: перечисли то, что нарушает вуду.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3020.mp3',
                'answer' => '<p> Ответ: 1) то,<span class="c6"> что выходит из двух путей:</span> моча, кал, кишечные газы;<br /> 2) сон, безумие или потеря сознания;<br /> 3) употребление в пищу верблюжатины;<br /> 4) прикосновение к тем местам, откуда выходят моча и кал, напрямую, без преграды. </p>',
            ],
            7 => [
                'question' => '8. Вопрос: что такое таяммум?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3080.mp3',
                'answer' => '<p> Ответ: таяммум — это использование земной поверхности для очищения в случае отсутствия воды или невозможности её использовать. </p>',
            ],
            8 => [
                'question' => '9. Вопрос: как делается таяммум?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3110.mp3',
                'answer' => '<p> Ответ: мы ударяем по земле один раз ладошками и по одному разу протираем лицо и внешние стороны кистей рук. </p>',
            ],
            9 => [
                'question' => '10. Вопрос: что нарушает таяммум?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3140.mp3',
                'answer' => '<p> Ответ: 1) всё,<span class="c6"> что нарушает вуду:</span><br /> 2) наличие воды. </p>',
            ],
            10 => [
                'question' => '11. Вопрос: что такое хуффы и обычные носки? Можем ли мы протирать их вместо мытья ног при совершении омовения?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3180.mp3',
                'answer' => '<p> Ответ: хуффы — это то, что мы надеваем на ноги, изготовленное из кожи.<br /> Обычные носки — это то, что мы надеваем на ноги, из других материалов, кроме кожи.<br /> Мы можем протирать их вместо мытья ног при совершении омовения. </p>',
            ],
            11 => [
                'question' => '12. Вопрос: в чём смысл разрешения протирать хуффы и носки?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3230.mp3',
                'answer' => '<p> Ответ: облегчение людям, особенно в холодную погоду или в пути, когда трудно снимать носки или иную обувь для совершения омовения. </p>',
            ],
            12 => [
                'question' => '13. Вопрос: назови непременные условия протирания хуффов.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3260.mp3',
                'answer' => '<p> Ответ: 1) хуффы должны быть надеты в состоянии чистоты, то есть после совершения вуду;<br /> 2) хуфф должен быть чистым; протирать нечистое нам не разрешено;<br /> 3) хуфф должен скрывать ту область, которая подлежит омовению при совершении омовения;<br /> 4) протирать можно в течение строго определённого периода. Если мы не в пути, то сутки, а если в пути, то трое суток. </p>',
            ],
            13 => [
                'question' => '14. Вопрос: как мы протираем хуффы?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3320.mp3',
                'answer' => '<p> Ответ: мы прикладываем смоченные водой пальцы к пальцам ног и проводим по всей поверхности хуффа к ноге. Правую ногу мы протираем правой рукой, а левую — левой. Пальцы во время протирания расставлены. Это действие мы совершаем только один раз, то есть не повторяем его. </p>',
            ],
            14 => [
                'question' => '15. Вопрос: что нарушает протирание хуффов?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3350.mp3',
                'answer' => '<p> Ответ: 1) истечение срока протирания, поэтому нельзя протирать хуффы после истечения установленного шариатом срока <span class="c2">(трое суток в пути и одни сутки не в пути)</span>;<br /> 2) снимание хуффов. Если человек снимет оба хуффа или один из них, то протирание, совершённое ранее станет недействительным </p>',
            ],
            15 => [
                'question' => '16. Вопрос: что такое молитва?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3390.mp3',
                'answer' => '<p> Ответ: молитва — это поклонение Аллаху посредством определённых слов и действий, начинающееся с такбира и завершающееся таслимом. </p>',
            ],
            16 => [
                'question' => '17. Вопрос: обязательна ли молитва?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3420.mp3',
                'answer' => '<p> Ответ: да, молитва является обязанностью каждого мусульманина.<span class="c6"><br /> Всевышний Аллах сказал:</span> <span class="c3">«Поистине, верующим предписано совершать молитву в определённое время»</span> [Сура 4 <span class="c3">«Женщины»</span>, аят 103]. </p>',
            ],
            17 => [
                'question' => '18. Вопрос: каково постановление религии в отношении того, кто не совершает молитву?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3460.mp3',
                'answer' => '<p> Ответ: оставление молитвы — неверие. Посланник Аллаха <span class="c2">(мир ему и благословение Аллаха)</span> сказал:<br /> <span class="c3">«Нас от них <span class="c5">[неверующих]</span> отделяет совершение молитвы, и кто оставил её, тот неверующий»</span><br /> <span class="c5">[Ахмад; ат-Тирмизи и другие]</span>. </p>',
            ],
            18 => [
                'question' => '19. Вопрос: сколько раз в день молится мусульманин? Из скольких ракатов состоит каждая молитва?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3500.mp3',
                'answer' => '<p> Ответ: мы молимся пять раз в день: утренняя молитва <span class="c2">(фаджр)</span> <span class="c2">(2 раката)</span>, полуденная молитва <span class="c2">(зухр)</span> <span class="c2">(4 раката)</span>, предвечерняя молитва <span class="c2">(аср)</span> <span class="c2">(4 раката)</span>; вечерняя молитва <span class="c2">(магриб)</span> <span class="c2">(3 раката)</span>; ночная молитва <span class="c2">(иша)</span> <span class="c2">(4 раката)</span>. </p>',
            ],
            19 => [
                'question' => '20. Вопрос: перечисли непременные условия молитвы.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3530.mp3',
                'answer' => '<p> Ответ: 1) ислам — молитва немусульманина недействительна;<br /> 2) разум — молитва сумасшедшего недействительна;<br /> 3) сознательность — молитва ребёнка, не достигшего сознательного возраста, недействительна;<br /> 4) намерение;<br /> 5) наступление времени молитвы;<br /> 6) чистота в смысле отсутствия осквернения;<br /> 7) чистота в смысле отсутствия нечистот;<br /> 8) сокрытие аурата;<br /> 9) обращение в сторону киблы. </p>',
            ],
            20 => [
                'question' => '21. Вопрос: перечисли непременные составляющие (рукн) молитвы.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3640.mp3',
                'answer' => '<p> Ответ: их 14.<span class="c6"> Это:</span><br /> 1) стояние в обязательной молитве, если человек способен;<br /> 2) открывающий такбир <span class="c2">(Аллаху акбар)</span>;<br /> 3) чтение суры <span class="c3">«Аль-Фатиха»</span>;<br /> 4) поясной поклон <span class="c2">(с выпрямлением спины так, чтобы голова и спина находились на одном уровне)</span>;<br /> 5) выпрямление после поясного поклона;<br /> 6) полное распрямление стоя;<br /> 7) земной поклон с приложением к полу лба с носом, ладоней, коленей и кончиков пальцев ног.<br /> 8) выпрямление после земного поклона;<br /> 9) сидение между двумя земными поклонами,<br /> причём сунной является сидеть на левой ступне, поставив правую вертикально, так чтобы пальцы были обращены в сторону киблы;<br /> 10) спокойствие при совершении каждого действия;<br /> 11) последний ташаххуд;<br /> 12) сидение во время него;<br /> 13) два таслима,<span class="c6"> то есть произнесение дважды слов:</span> <span class="c3">«Ас-саляму алейкум ва рахматуЛлах»</span>;<br /> 14) порядок, то есть совершение всех действий в упомянутом порядке. Так, если человек, к примеру, совершил земной поклон прежде поясного умышленно, то его намаз становится недействительным. Если же он поступил так случайно, то он обязан вернуться и совершить поясной поклон, а потом уже совершить земной. </p>',
            ],
            21 => [
                'question' => '22. Вопрос: назови обязательные действия молитвы (ваджиб).',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3820.mp3',
                'answer' => '<p> Ответ: их 8.<span class="c6"> Это:</span><br /> 1) все такбиры, кроме открывающего;<br /> 2) слова <span class="c3">«самиаЛлаху ли-ман хамидах»</span> для имама и того, кто молится в одиночку;<br /> 3) слова <span class="c3">«раббана ва ля-ка-ль-хамд»</span>;<br /> 4) слова <span class="c3">«субхана раббия-ль-азым»</span> один раз в поясном поклоне;<br /> 5) слова <span class="c3">«субхана раббия-ль-а‘ля»</span> один раз в земном поклоне;<br /> 6) слова <span class="c3">«рабби-гфир-ли»</span> между двумя земными поклонами;<br /> 7) первый ташаххуд;<br /> 8) сидение во время совершения первого ташаххуда. </p>',
            ],
            22 => [
                'question' => '23. Вопрос: назови желательные действия (сунны) молитвы.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3930.mp3',
                'answer' => '<p> Ответ: словесных желательных действий 11.<span class="c6"> Это:</span><br /> 1) слова после открывающего такбира «Субхана-ка-Ллахумма, ва би-хамди-ка, ва табарака-сму-ка, ва та‘аля джадду-ка, ва ля иляха гайру-ка <span class="c2">(Пречист Ты, о Аллах, и хвала Тебе; благодатно имя Твоё, превыше всего величие Твоё и нет бога, кроме Тебя!)</span>»;<br /> 2) испрашивание защиты от шайтана <span class="c2">(истиаза)</span>;<br /> 3) слова <span class="c3">«бисмиЛлях»</span> <span class="c2">(басмаля)</span>;<br /> 4) слово <span class="c3">«амин»</span>;<br /> 5) чтение суры после <span class="c3">«Аль-Фатихи»</span>;<br /> 6) чтение вслух для имама;<br /> 7) добавление «миль’а-с-самавати, ва миль’а-ль-арды, ва миль’а ма ши’та мин шайин ба‘д <span class="c2">(наполняющая собой небеса, землю и всё, что ещё Тебе будет угодно)</span>» к словам «раббана ва ля-ка-ль-хамд <span class="c2">(Господь наш, Тебе хвала)</span>»;<br /> 8) больше одного восхваления в поясном поклоне <span class="c2">(то есть второе, третье и последующие восхваления)</span>;<br /> 9) больше одного восхваления в земном поклоне <span class="c2">(то есть второе, третье и последующие восхваления)</span>;<br /> 10) больше одного произнесения слов «рабби-гфир-ли <span class="c2">(Господи, прости мне)</span>» между двумя земными поклонами;<br /> 11) призыв благословения и приветствия на Пророка и его семейство <span class="c2">(мир им и благословение Аллаха)</span> в последнем ташаххуде и мольба после него.<br /> Действия-сунны.<span class="c6"> Это:</span><br /> 1) поднятие рук в открывающем такбире;<br /> 2) поднятие рук перед поясным поклоном;<br /> 3) поднятие рук при выпрямлении после поясного поклона;<br /> 4) опускание рук после этого;<br /> 5) возложение правой руки на левую;<br /> 6) обращение взгляда на то место, которого коснётся голова при совершении земного поклона;<br /> 7) расставление ступней во время стояния;<br /> 8) возложение рук с расставленными пальцами на колени при совершении поясного поклона и выпрямление спины так, чтобы голова находилась на одной линии со спиной;<br /> 9) плотное прикладывание всех соответствующих частей тела к полу во время земного поклона;<br /> 10) отстранение локтей от боков, живота от бёдер и бёдер от голеней, а также расставление коленей, вертикальная постановка ступней, постановка нижней части расставленных пальцев ног на землю, постановка рук напротив плеч с соединёнными пальцами.<br /> 11) поза-ифтираш <span class="c2">(простирая левую ногу и усаживаясь на неё, правую ставя вертикально таким образом, чтобы пальцы были направлены в сторону киблы)</span> между двумя земными поклонами и в первом ташаххуде и поза-таваррук <span class="c2">(молящийся простирает левую ногу, ставит вертикально правую, так что обе они оказываются с правой стороны, а ягодицы его при этом прижаты к земле)</span> — во втором;<br /> 12) возложение рук на бёдра с прижатыми друг к другу пальцами между двумя земными поклонами и в первом ташаххуде, но при этом следует соединить большой и безымянный пальцы на правой руки в форме кольца и указывать вперёд указательным пальцем при поминании Аллаха;<br /> 13) поворот головы направо и налево при произнесении таслима. </p>',
            ],
            23 => [
                'question' => '24. Вопрос: перечисли то, что нарушает молитву.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4210.mp3',
                'answer' => '<p> Ответ: 1) несовершение непременной составляющей <span class="c2">(рукн)</span> или несоблюдение непременного условия <span class="c2">(шарт)</span> намаза;<br /> 2) умышленный разговор;<br /> 3) еда и питьё;<br /> 4) множество последовательных лишних движений;<br /> 5) умышленное несовершение обязательного <span class="c2">(ваджиб)</span> действия молитвы. </p>',
            ],
            24 => [
                'question' => '25. Вопрос: как мусульманин совершает молитву?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4280.mp3',
                'answer' => '<p> Ответ: молитва совершается следующим образом:<br /> 1) молящийся поворачивается в сторону киблы всем телом, вставая прямо напротив киблы, не отклоняясь от неё телом и не отворачиваясь лицом;<br /> 2) делает намерение совершить определённую молитву в сердце, не произнося это намерение;<br /> 3) произносит открывающий такбир,<span class="c6"> то есть говорит:</span> <span class="c3">«Аллаху акбар»</span>, при этом поднимая руки до уровня плеч;<br /> 4) возлагает ладонь правой руки на внешнюю сторону кисти левой и складывает их на груди;<br /> 5) произносит мольбу-<span class="c6">истифтах:</span> «О Аллах, удали меня от прегрешений моих, как удалил Ты восток от запада! О Аллах, очисти меня от прегрешений моих, как очищают белую одежду от грязи! О Аллах, смой с меня мои прегрешения снегом, водой и градом <span class="c2">(Аллахумма, ба‘ид байни ва байна хатайайа ка-ма ба‘адта байна-ль-машрикы ва-ль-магриб, Аллахумма, наккы-ни мин хатайайа ка-ма йунакка-с-саубу-ль-абйаду мина-д-данас, Аллахумма-гсиль-ни мин хатайа-йа би-ль-маи, ва-с-сальджи ва-ль-барад)</span>»<br /> или: «Пречист Ты, о Аллах, и хвала Тебе, благословенно имя Твоё, превыше всего величие Твоё и нет бога, кроме Тебя <span class="c2">(Субханака-Ллахумма, ва би-хамди-ка, ва табарака-сму-ка, ва та‘аля джадду-ка, ва ля иляха гайру-ка)</span>»;<br /> 6) испрашивает у Аллаха защиты,<span class="c6"> говоря:</span> «Прошу у Аллаха защиты от проклятого шайтана <span class="c2">(А‘узу би-Лляхи мина-ш-шайтани-р-раджим)</span>»; 7) произносит басмалю и читает суру <span class="c3">«Аль-Фатиха»</span>: <span class="c3">«С именем Аллаха, Милостивого, Милующего! Хвала Аллаху, Господу миров, Милостивому, Милующему, Властелину Дня воздаяния! Только Тебе мы поклоняемся и только у Тебя испрашиваем помощи. Наставь нас на прямой путь, путь тех, кого Ты облагодетельствовал, не тех, на кого Ты разгневан, и не заблудших»</span> [Сура 1 <span class="c3">«Аль-Фатиха»</span>, аяты 1–7],<span class="c6"><br /> после чего говорит:</span> <span class="c3">«Амин»</span>,<span class="c6"> что означает:</span> <span class="c3">«О Аллах, ответь на мольбу!»</span>;<br /> 8) читает то, что может, из Корана, читая дольше в молитве-фаджр;<br /> 9) совершает поясной поклон, склоняясь перед Всевышним и возвеличивая Его таким образом, произнося такбир и поднимая руки до плеч, причём желательно — выпрямить спину так, чтобы голова и спина находились на одном уровне,<span class="c6"> и возлагает руки с расставленными пальцами на колени;<br /> 10) говорит в поясном поклоне:</span> «Пречист Господь мой Величайший <span class="c2">(Субхана Раббийа-ль-‘Азым)</span>» три раза,<span class="c6"> и если он добавит:</span> «Пречист Ты, о Аллах, и хвала Тебе, о Аллах, прости мне <span class="c2">(Субханака-Ллахумма ва би-хамдика, Аллахумма-гфир-ли)</span>»,<span class="c6"> то это будет хорошо;<br /> 11) поднимается из поясного поклона со словами:</span> «Да услышит Аллах тех, кто восхваляет Его <span class="c2">(Сами‘а-Ллаху ли-ман хамида-ху)</span>» и поднимает руки до уровня плеч,<span class="c6"> причём молящийся под руководством имама вместо этих слов говорит:</span> «Господь наш, хвала Тебе <span class="c2">(Рабба-на, ва ля-ка-ль-хамд)</span>»;<br /> 12) полностью выпрямившись,<span class="c6"> он говорит:</span> «Господь наш, Тебе хвала, наполняющая собой небеса, землю, и всё, что ещё Тебе будет угодно <span class="c2">(Рабба-на, ва ля-ка-ль-хамду миль’а-с-самавати, ва миль’а-ль-арды, ва миль’а ма ши’та мин шайин ба‘д)</span>»;<br /> 13) говорит: «Аллах Велик <span class="c2">(Аллаху акбар)</span>», совершает земной поклон, опираясь на кончики пальцев ног, колени, руки и лоб с носом, отводя при этом локти от боков, не кладя предплечья на пол, а пальцы ставя так,<span class="c6"> чтобы их кончики были направлены в сторону киблы;<br /> 14) говорит в поклоне:</span> «Пречист Господь мой Высочайший <span class="c2">(Субхана Раббийа-ль-А‘ля)</span>» три раза,<span class="c6"> и если он добавит:</span> «Пречист Ты, о Аллах, Господь наш, и хвала Тебе, о Аллах, прости мне <span class="c2">(Субханака-Ллахумма раббана ва би-хамдика, Аллахумма-гфир-ли)</span>»,<span class="c6"> то это будет хорошо;<br /> 15) затем садится со словами:</span> «Аллах Велик <span class="c2">(Аллаху акбар)</span>»;<br /> 16) затем садится между двумя земными поклонами, простирая левую ногу и усаживаясь на неё, а правую ставя вертикально; правую руку он при этом возлагает на правое бедро возле колена, поджав мизинец и безымянный палец и соединив кольцом большой и средний пальцы, и вытянув указательный, когда произносит мольбу,<span class="c6"> а левую руку с вытянутыми пальцами он возлагает на левое бедро у колена;<br /> 17) во время сидения говорит:</span> «Господи, прости мне, помилуй меня, веди меня прямым путём, даруй мне удел, поддержи меня и даруй мне благополучие <span class="c2">(Аллахумма-гфир ли ва-рхам-ни ва-хди-ни ва-рзук-ни ва-джбур-ни ва ‘афи-ни)</span>»;<br /> 18) совершает второй земной поклон, говоря и делая всё то же самое, что и в первом, и предваряя его такбиром;<br /> 19) поднимается из второго земного поклона и оказывается в положении стоя,<span class="c6"> говоря при этом:</span> «Аллах Велик <span class="c2">(Аллаху Акбар)</span>». Далее он совершает второй ракат, идентичный первому, то есть состоящий из стояния, чтения аятов, поясного и двух земных поклонов, но уже не читает открывающую мольбу <span class="c2">(ду‘а-истифтах)</span>.<br /> 20) после второго земного поклона во втором ракате он произносит такбир и остаётся сидеть так же, как и между земными поклонами;<br /> 21) произносит первый ташаххуд,<span class="c6"> говоря:</span> «Приветствия, молитвы и всё благое Аллаху, мир тебе, о пророк, милость Аллаха и благодать Его, мир нам и всем праведным рабам Аллаха. Свидетельствую, что нет бога, кроме Аллаха, и свидетельствую, что Мухаммад — Его раб и Посланник <span class="c2">(Ат-тахиййату ли-Лляхи, ва-с-салявату ва-т-таййибату, ас-саляму ‘аляй-ка, аййуха-н-набиййу, ва рахмату-Ллахи ва баракату-ху, ас-саляму ‘аляй-на ва ‘аля ‘ибади-Лляхи-с-салихин. Ашхаду ан ля иляха илля-Ллаху ва ашхаду анна Мухаммадан ‘абду-ху ва расулю-ху)</span>»; затем саляват: «О Аллах, благослови Мухаммада и семейство Мухаммада, как благословил Ты Ибрахима и семейство Ибрахима, поистине, Ты — Достойный хвалы, Славный! И пошли благодать Мухаммаду и семейству Мухаммада, как послал Ты её Ибрахиму и семейству Ибрахима, поистине, Ты — Достойный хвалы, Славный <span class="c2">(Аллахумма, салли ‘аля Мухаммадин ва ‘аля али Мухаммадин ка-ма салляйта ‘аля Ибрахима ва ‘аля али Ибрахима, инна-ка Хамидун, Маджид! Ва барик ‘аля Мухаммадин ва ‘аля али Мухаммадин ка-ма баракта ‘аля Ибрахима ва ‘аля али Ибрахима, инна-ка Хамидун, Маджид)</span>»,<span class="c6"> затем мольбу:</span> «Я прошу у Аллаха защиты от мук в Огне, и от мук в могиле, и от искушений жизни и смерти и от искушений Даджжаля <span class="c2">(А‘узу биЛляхи мин ‘азаби джаханнама ва мин ‘азаби-ль-кабри ва мин фитнати-ль-махйа ва-ль-мамати ва мин фитнати-ль-масихи-д-даджжаль)</span>»; затем он может просить у Аллаха чего пожелает из благ этого мира и мира вечного;<br /> 22) после этого он поворачивает голову вправо со словами: «Мир вам и милость Аллаха <span class="c2">(Ассаляму алейкум ва рахматуЛлах)</span>», затем поворачивает голову влево и произносит те же слова;<br /> 23) если молитва из трёх или четырёх ракатов, то нужно ограничиться произнесением ташаххуда,<span class="c6"> который завершается словами:</span> «Свидетельствую, что нет бога, кроме Аллаха, и свидетельствую, что Мухаммад — Его раб и Посланник <span class="c2">(Ашхаду ан ля иляха илля-Ллаху ва ашхаду анна Мухаммадан ‘абду-ху ва расулю-ху)</span>»;<br /> 24) затем он поднимается,<span class="c6"> говоря при этом:</span> «Аллах Велик <span class="c2">(Аллаху Акбар)</span>», и оказывается в положении стоя;<br /> 25) делает всё то же самое, как и во втором ракате, однако ограничивается в третьем и четвёртом ракатах чтением суры <span class="c3">«Аль-Фатиха»</span>;<br /> 26) затем садится для второго ташаххуда в позу таваррук: простирает левую ногу, ставит вертикально правую, так что обе они оказываются с правой стороны, а ягодицы его при этом прижаты к земле, а руки кладёт на бёдра таким же образом,<span class="c6"> как и для первого ташаххуда;<br /> 27) в этом сидении он читает ташаххуд полностью;<br /> 28) затем поворачивает голову вправо со словами:</span> «Мир вам и милость Аллаха <span class="c2">(Ассаляму алейкум ва рахматуЛлах)</span>», затем поворачивает голову влево и произносит те же слова. </p>',
            ],
            25 => [
                'question' => '26. Вопрос: какие поминания говорят после окончания молитвы?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4610.mp3',
                'answer' => '<p> Ответ: — «Господи, прости мне <span class="c2">(Рабби-гфир-ли)</span>» три раза;<br /> — «О Аллах, Ты — Совершенный <span class="c2">(Ас-Салям)</span>, и от Тебя — благополучие <span class="c2">(салям)</span>, благословен Ты, о Обладатель величия и щедрости <span class="c2">(Аллахумма Анта-с-Саляму ва мин-ка-с-саляму, табаракта, йа За-ль-джаляли ва-ль-икрам)</span>»;<br /> — «Нет бога, кроме одного лишь Аллаха, у Которого нет сотоварища. Ему принадлежит власть и Ему хвала, и Он всё может! О Аллах, никто не лишит того, что Ты даровал, и никто не дарует того, чего Ты лишил, и бесполезным перед Тобой окажется богатство обладающего богатством <span class="c2">(Ля иляха илля-Ллаху вахда-ху ля шарика ля-ху, ля-ху-ль-мульку, ва ля-ху-ль-хамду ва хува ‘аля кулли шайин кадир. Аллахумма, ля мани‘а ли-ма а‘тайта, ва ля му‘тыйа ли-ма мана‘та ва ля йанфа‘у за-ль-джадди мин-ка-ль-джадд)</span>»;<br /> — «Нет бога, кроме одного лишь Аллаха, у Которого нет сотоварища, Ему принадлежит власть, и Ему хвала, и Он всё может! И нет способности изменить что-либо и силы для этого ни у кого, кроме как от Аллаха, нет бога, кроме Аллаха, и мы не поклоняемся никому, кроме Него, Ему принадлежит благо и милость, и Ему — прекрасная похвала. Нет бога, кроме Аллаха, а мы посвящаем религию Ему одному, даже если это и ненавистно неверующим <span class="c2">(Ля иляха илля-Ллаху вахда-ху ля шарика ля-ху, ля-ху-ль-мульку, ва ля-ху-ль-хамду ва хува ‘аля кулли шайин кадир! Ля хауля ва ля куввата илля би-Лляхи, ля иляха илля-Ллаху ва ля на‘буду илля иййа-ху, ля-ху-н-ни‘мату, ва ля-ху-ль-фадлю ва ля-ху-с-санау-ль-хасану, ля иляха илля-Ллаху, мухлисына ля-ху-д-дина ва ляу кариха-ль-кафирун)</span>»;<br /> — «Пречист Аллах <span class="c2">(Субхана-Ллах)</span>» 33 раза,<br /> «Хвала Аллаху <span class="c2">(Аль-хамду ли-Ллях)</span> 33 раза,<br /> «Аллах велик <span class="c2">(Аллаху акбар)</span> 33 раза.<span class="c6"><br /> А на сотый раз следует сказать:</span> «Нет бога, кроме одного лишь Аллаха, у Которого нет сотоварища. Ему принадлежит власть, и Ему хвала, и Он всё может <span class="c2">(Ля иляха илля-Ллаху вахда-ху ля шарика ля-ху, ля-ху-ль-мульку, ва ля-ху-ль-хамду, ва хува ‘аля кулли шайин кадир)</span>»;<br /> — суры 112, 113 и 114 по три раза после утренней молитвы <span class="c2">(фаджр)</span> и вечерней молитвы <span class="c2">(магриб)</span>, и по одному разу после других молитв;<br /> — аят <span class="c3">«аль-Курси»</span> один раз. </p>',
            ],
            26 => [
                'question' => '27. Вопрос: что такое молитвы-сунны, совершаемые до и после обязательных? И каковы их достоинства?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4730.mp3',
                'answer' => '<p> Ответ: 2 раката перед утренней молитвой <span class="c2">(фаджр)</span>;<br /> 4 раката перед полуденной молитвой <span class="c2">(зухр)</span>;<br /> 2 раката после полуденной молитвы <span class="c2">(зухр)</span>;<br /> 2 раката после вечерней молитвы <span class="c2">(магриб)</span>;<br /> 2 раката после ночной молитвы <span class="c2">(иша)</span>.<br /> Об их достоинствах Посланник Аллаха <span class="c2">(мир ему и благословение Аллаха)</span> сказал: <span class="c3">«Кто совершает в течении дня и ночи двенадцать дополнительных рак‘атов, тому Аллах построит дом в Раю»</span> <span class="c5">[Муслим; Ахмад и другие]</span>. </p>',
            ],
            27 => [
                'question' => '28. Вопрос: назови лучший день недели.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4800.mp3',
                'answer' => '<p> Ответ: это пятница. Посланник Аллаха <span class="c2">(мир ему и благословение Аллаха)</span> сказал: <span class="c3">«Поистине, пятница относится к числу наилучших дней ваших. В этот день был сотворён Адам, и в этот день он скончался, и в этот день раздастся трубный глас, и в этот день <span class="c5">[всё живое]</span> будет поражено… Так почаще призывайте на меня благословение в этот день, ибо, поистине, ваши благословения будут представляться мне»</span>.<span class="c6"> Люди спросили:</span> <span class="c3">«О Посланник Аллаха, как же наши благословения будут представляться тебе, когда ты уже истлеешь?!»</span> Он сказал: <span class="c3">«Поистине, Аллах запретил земле пожирать тела пророков»</span> <span class="c5">[Абу Дауд и другие]</span>. </p>',
            ],
            28 => [
                'question' => '29. Вопрос: каково постановление религии в отношении пятничной молитвы?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4840.mp3',
                'answer' => '<p> Ответ: это индивидуальная обязанность <span class="c2">(фард айн)</span> для каждого мужчины-мусульманина, достигшего совершеннолетия, разумного и не находящегося в пути.<span class="c6"><br /> Всевышний Аллах сказал:</span> <span class="c3">«О те, которые уверовали! Когда призывают на молитву в пятничный день, то устремляйтесь к поминанию Аллаха и оставьте торговлю. Так лучше для вас, если бы вы только знали»</span> [Сура 63 <span class="c3">«Лицемеры»</span>, аят 9]. </p>',
            ],
            29 => [
                'question' => '30. Вопрос: сколько ракатов в пятничной молитве?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4880.mp3',
                'answer' => '<p> Ответ: два раката, в которых имам читает аяты вслух и которым предшествует проповедь <span class="c2">(хутба)</span>, состоящая из двух частей. </p>',
            ],
            30 => [
                'question' => '31. Вопрос: можно ли не ходить на пятничную молитву?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4910.mp3',
                'answer' => '<p> Ответ: не разрешается пропускать пятничную молитву без уважительной причины. Пророк <span class="c2">(мир ему и благословение Аллаха)</span> сказал: <span class="c3">«Аллах запечатает сердце того, кто пропустил три пятничные молитвы без уважительной причины»</span> <span class="c5">[Абу Дауд и другие]</span>. </p>',
            ],
            31 => [
                'question' => '32. Вопрос: назови сунны пятницы.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4940.mp3',
                'answer' => '<p> Ответ:<br /> 1) полное омовение <span class="c2">(гусль)</span>;<br /> 2) использование благовоний;<br /> 3) облачение в лучшую одежду;<br /> 4) ранний приход в мечеть;<br /> 5) многократный призыв благословения на Пророка <span class="c2">(мир ему и благословение Аллаха)</span>;<br /> 6) чтение суры 18 <span class="c3">«Пещера»</span>;<br /> 7) отправление в мечеть пешком;<br /> 8) стремление использовать тот период, когда мольба не остаётся без ответа. </p>',
            ],
            32 => [
                'question' => '33. Вопрос: назови достоинства коллективной молитвы.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5050.mp3',
                'answer' => '<p> Ответ: Абдуллах ибн Умар <span class="c2">(да будет доволен Аллах им и его отцом)</span> передаёт, что Посланник Аллаха <span class="c2">(мир ему и благословение Аллаха)</span> сказал: <span class="c3">«Коллективная молитва превосходит молитву, совершаемую в одиночку, на двадцать семь степеней»</span> <span class="c5">[Муслим]</span>. </p>',
            ],
            33 => [
                'question' => '34. Вопрос: что такое смирение в молитве?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5080.mp3',
                'answer' => '<p> Ответ: это сосредоточенность сердца и спокойствие органов тела в молитве.<span class="c6"><br /> Всевышний Аллах сказал:</span> <span class="c3">«Поистине, преуспели верующие, которые смиренны во время своих молитв»</span> [Сура 23 <span class="c3">«Верующие»</span>, аяты 2–3]. </p>',
            ],
            34 => [
                'question' => '35. Вопрос: что такое закят?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5120.mp3',
                'answer' => '<p> Ответ: это определённая доля определённого имущества, которую обязательно отдавать определённой категории людей в определённое время.<br /> Это один из столпов ислама и обязательная милостыня, которая взимается с состоятельного в пользу нуждающегося.<span class="c6"><br /> Всевышний Аллах сказал:</span> <span class="c3">«и выплачивайте закят»</span> [Сура 2 <span class="c3">«Корова»</span>, аят 43]. </p>',
            ],
            35 => [
                'question' => '36. Вопрос: что такое желательная милостыня?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5170.mp3',
                'answer' => '<p> Ответ: это подаяние помимо закята.<span class="c6"> Пример:</span> человек отдаёт что-нибудь с благой целью в любое время.<span class="c6"><br /> Всевышний Аллах сказал:</span> <span class="c3">«И расходуйте на пути Аллаха»</span> [Сура 2 <span class="c3">«Корова»</span>, аят 195]. </p>',
            ],
            36 => [
                'question' => '37. Вопрос: что такое пост?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5210.mp3',
                'answer' => '<p> Ответ: это поклонение Аллаху посредством воздержания от всего, что нарушает пост, с рассвета до захода солнца с определённым намерением.<span class="c6"> Он бывает двух видов:</span><br /> 1) Обязательный пост. Например, пост в рамадане, он является одним из столпов ислама.<span class="c6"><br /> Всевышний Аллах сказал:</span> <span class="c3">«О те, которые уверовали! Вам предписан пост, подобно тому, как он был предписан вашим предшественникам, — быть может, вы будете богобоязненными»</span> [Сура 2 <span class="c3">«Корова»</span>, аят 183].<br /> 2) Необязательный пост. Например, пост по понедельникам и четвергам, пост по три дня в месяц, причём лучше в <span class="c3">«белые»</span> дни <span class="c2">(13, 14 и 15 дни каждого лунного месяца)</span>. </p>',
            ],
            37 => [
                'question' => '38. Вопрос: назови достоинства поста в месяце рамадан.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5270.mp3',
                'answer' => '<p> Ответ: Абу Хурайра <span class="c2">(да будет доволен им Аллах)</span> передаёт, что Посланник Аллаха <span class="c2">(мир ему и благословение Аллаха)</span> сказал: <span class="c3">«Кто постился рамадан с верой и надеждой на награду от Аллаха, тому простятся его прошлые прегрешения»</span> <span class="c5">[аль-Бухари; Муслим]</span>. </p>',
            ],
            38 => [
                'question' => '39. Вопрос: назови достоинства дополнительного поста.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5300.mp3',
                'answer' => '<p> Ответ: <span class="c3">«Аллах отдалит от Огня на семьдесят харифов лицо любого раба, который постится день на пути Аллаха»</span> <span class="c5">[аль-Бухари; Муслим]</span>.<br /> <span class="c3">«Семьдесят харифов»</span> означает <span class="c3">«семьдесят лет <span class="c5">[пути]</span>»</span>. </p>',
            ],
            39 => [
                'question' => '40. Вопрос: что нарушает пост?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5330.mp3',
                'answer' => '<p> Ответ: 1) намеренный приём еды и питья;<br /> 2) умышленное вызывание рвоты;<br /> 3) вероотступничество. </p>',
            ],
            40 => [
                'question' => '41. Вопрос: каковы сунны поста?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5380.mp3',
                'answer' => '<p> Ответ: 1) спешить с разговением;<br /> 2) утренний приём пищи <span class="c2">(сухур)</span>, который следует совершать попозже;<br /> 3) активное совершение благих дел и поклонения;<br /> 4) слова постящегося, если ему сказали что-<span class="c6">то плохое:</span> <span class="c3">«Поистине, я пощусь»</span>;<br /> 5) мольба при разговении;<br /> 6) разговение свежими или сушёными финиками, а если их нет, то водой. </p>',
            ],
            41 => [
                'question' => '42. Вопрос: что такое хадж?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5460.mp3',
                'answer' => '<p> Ответ: хадж — это поклонение Всевышнему Аллаху посредством путешествия к Его Заповедному Дому для совершения определённых действий в определённое время.<span class="c6"><br /> Всевышний Аллах сказал:</span> <span class="c3">«Люди обязаны перед Аллахом совершить хадж к Дому <span class="c5">[Каабе]</span>, если они способны проделать этот путь. Если же кто не уверует, то ведь Аллах не нуждается в мирах»</span> [Сура 3 <span class="c3">«Род Имрана»</span>, аят 97]. </p>',
            ],
            42 => [
                'question' => '43. Вопрос: перечисли непременные составляющие (рукн) хаджа.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5500.mp3',
                'answer' => '<p> Ответ: 1) ихрам;<br /> 2) пребывание на Арафате;<br /> 3) таваф аль-ифада<br /> 4) пробег между холмами ас-Сафа и аль-Марва. </p>',
            ],
            43 => [
                'question' => '44. Вопрос: каковы достоинства хаджа?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5560.mp3',
                'answer' => '<p> Ответ: от Абу Хурейры, да будет доволен им Аллах, передаётся,<span class="c6"> что он сказал:</span> я слышал как Посланник Аллаха, да благословит его Аллах и приветствует,<span class="c6"> сказал:</span> <span class="c3">«Тот, кто совершил хадж, не говоря и не делая ничего неподобающего, вернётся таким <span class="c5">[же чистым от грехов]</span>, каким был он в тот день, когда мать родила его»</span> <span class="c5">[аль-Бухари и другие]</span>.<br /> <span class="c3">«Как в день, когда его родила мать»</span> то есть он остаётся без прегрешений. </p>',
            ],
            44 => [
                'question' => '45. Вопрос: что такое умра?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5600.mp3',
                'answer' => '<p> Ответ: умра — это поклонение Всевышнему Аллаху посредством путешествия к Его Заповедному Дому для совершения определённых действий в любое время. </p>',
            ],
            45 => [
                'question' => '46. Вопрос: перечисли непременные составляющие (рукн) умры.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5630.mp3',
                'answer' => '<p> Ответ: 1) ихрам;<br /> 2) обход вокруг Каабы;<br /> 3) ходьба между холмами ас-Сафа и аль-Марва. </p>',
            ],
            46 => [
                'question' => '47. Вопрос: что такое джихад на пути Аллаха?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5690.mp3',
                'answer' => '<p> Ответ: это приложение усилий для распространения ислама и защиты его и исповедующих его людей либо сражение с тем, кто враждебен к исламу и мусульманам.<span class="c6"><br /> Всевышний Аллах сказал:</span> <span class="c3">«Выступайте в поход, легко ли это вам будет или обременительно, и сражайтесь на пути Аллаха своим имуществом и своими душами. Так будет лучше для вас, если бы вы только знали»</span> [Сура 9 <span class="c3">«Покаяние»</span>, аят 41]. </p>',
            ],
        ],
        3 => [
            0 => [
                'question' => '1. Вопрос: каково происхождение нашего Пророка Мухаммада (мир ему и благословение Аллаха)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5740.mp3',
                'answer' => '<p> Ответ: его звали Мухаммад ибн Абдуллах ибн Абду-ль-Мутталиб ибн Хашим. Хашим был из племени Курайш, племя Курайш — из арабов, а арабы — потомки пророка Исмаиля, сына пророка Ибрахима, ему и нашему Пророку мир и благословение Аллаха. </p>',
            ],
            1 => [
                'question' => '2. Вопрос: как звали мать нашего Пророка (мир ему и благословение Аллаха)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5770.mp3',
                'answer' => '<p> Ответ: Амина бинт Вахб. </p>',
            ],
            2 => [
                'question' => '3. Вопрос: когда скончался его отец?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5800.mp3',
                'answer' => '<p> Ответ: его отец скончался в Медине ещё до рождения Мухаммада <span class="c2">(мир ему и благословение Аллаха)</span>. </p>',
            ],
            3 => [
                'question' => '4. Вопрос: когда родился Пророк (мир ему и благословение Аллаха)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5830.mp3',
                'answer' => '<p> Ответ: в <span class="c3">«год слона»</span>, в понедельник в месяце раби аль-авваль. </p>',
            ],
            4 => [
                'question' => '5. Вопрос: где родился Пророк (мир ему и благословение Аллаха)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5850.mp3',
                'answer' => '<p> Ответ: в Мекке. </p>',
            ],
            5 => [
                'question' => '6. Вопрос: кто, кроме матери, заботился о нём и вскармливал его?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5880.mp3',
                'answer' => '<p> Ответ: 1) рабыня его отца Умм Айман;<br /> 2) рабыня его дяди Абу Ляхаба Сувайба;<br /> 3) Халима ас-Саадийя. </p>',
            ],
            6 => [
                'question' => '7. Вопрос: когда скончалась его мать?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5930.mp3',
                'answer' => '<p> Ответ: она умерла, когда ему было шесть лет, и заботу о нём перенял на себя его дед Абду-ль-Мутталиб. </p>',
            ],
            7 => [
                'question' => '8. Вопрос: кто заботился о нём после смерти его деда Абду-ль-Мутталиба?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5960.mp3',
                'answer' => '<p> Ответ: его дед Абду-ль-Мутталиб умер, когда ему было восемь лет, и о нём стал заботиться его дядя Абу Талиб. </p>',
            ],
            8 => [
                'question' => '9. Вопрос: когда он ездил в Шам со своим дядей?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5990.mp3',
                'answer' => '<p> Ответ: он ездил с дядей в Шам, когда ему было двенадцать лет. </p>',
            ],
            9 => [
                'question' => '10. Вопрос: когда состоялась его следующая поездка?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6020.mp3',
                'answer' => '<p> Ответ: второй раз он поехал в Шам вести торговлю на средства Хадиджи <span class="c2">(да будет доволен ею Аллах)</span>, а по возвращении женился на ней. Ему тогда было двадцать пять лет. </p>',
            ],
            10 => [
                'question' => '11. Вопрос: когда курайшиты перестраивали Каабу?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6050.mp3',
                'answer' => '<p> Ответ: курайшиты перестроили Каабу, когда ему было тридцать пять лет.<br /> Они попросили его рассудить их в том, кто должен положить на место Чёрный камень, и он положил его на кусок ткани и велел представителям каждого из четырёх племён взяться за края этой ткани, а когда они подняли камень до того места, где он должен был находиться, он возложил его на место своими руками. </p>',
            ],
            11 => [
                'question' => '12. Вопрос: в каком возрасте началась его пророческая миссия? И к кому он был послан?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6080.mp3',
                'answer' => '<p> Ответ: ему было сорок лет, и он был послан ко всему человечеству. </p>',
            ],
            12 => [
                'question' => '13. С чего началось Откровение?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6110.mp3',
                'answer' => '<p> Ответ: с вещих снов, и всякий увиденный им сон был подобен ясному рассвету. </p>',
            ],
            13 => [
                'question' => '14. Вопрос: что он делал до ниспослания Откровения? Когда ему было ниспослано первое Откровение?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6140.mp3',
                'answer' => '<p> Ответ: он поклонялся Господу в пещере Хира, беря запасы из дома.<br /> Ему было ниспослано Откровение, когда он находился в этой пещере, занятый поклонением. </p>',
            ],
            14 => [
                'question' => '15. Вопрос: что первым было ниспослано из Корана?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6180.mp3',
                'answer' => '<p> Ответ: Слова Всевышнего: <span class="c3">«Читай во имя твоего Господа, Который сотворил всё сущее. Он сотворил человека из сгустка крови. Читай, ведь твой Господь — Наищедрейший. Он научил посредством письменной трости — научил человека тому, чего тот не знал»</span> [Сура 96 <span class="c3">«Сгусток»</span>, аяты 1–5]. </p>',
            ],
            15 => [
                'question' => '16. Вопрос: кто первым уверовал в его послание?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6200.mp3',
                'answer' => '<p> Ответ: из мужчин — Абу Бакр ас-Сыддик, из женщин — Хадиджа бинт Хувайлид, из детей — Али ибн Абу Талиб, из вольноотпущенников — Зейд ибн Хариса, из рабов — эфиоп Биляль <span class="c2">(да будет доволен Аллах ими всеми)</span>. </p>',
            ],
            16 => [
                'question' => '17. Вопрос: как вёлся призыв к исламу?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6230.mp3',
                'answer' => '<p> Ответ: призыв вёлся тайно около трёх лет, после чего Пророк <span class="c2">(мир ему и благословение Аллаха)</span> получил веление вести призыв открыто. </p>',
            ],
            17 => [
                'question' => '18. Вопрос: каким было положение Пророка (мир ему и благословение Аллаха) и кто уверовал в него после начала открытого призыва?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6260.mp3',
                'answer' => '<p> Ответ: многобожники обижали и мучили мусульман, и в конце концов уверовавшим было дано разрешение переселиться к справедливому правителю в Эфиопию.<br /> Многобожники долго обижали Пророка <span class="c2">(мир ему и благословение Аллаха)</span> и решили убить его, но Аллах защитил его и сделал так, чтобы его дядя Абу Талиб защищал его от них. </p>',
            ],
            18 => [
                'question' => '19. Вопрос: кто скончался в десятом году от начала пророческой миссии Мухаммада (мир ему и благословение Аллаха)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6300.mp3',
                'answer' => '<p> Ответ: его дядя Абу Талиб и его жена Хадиджа <span class="c2">(да будет доволен ею Аллах)</span>. </p>',
            ],
            19 => [
                'question' => '20. Вопрос: когда состоялось ночное путешествие в Иерусалим с последующим вознесением на небеса (аль-исра ва аль-мирадж)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6330.mp3',
                'answer' => '<p> Ответ: ему было пятьдесят лет, и как раз была вменена в обязанность мусульманам пятикратная молитва.<br /> Аль-исра — это путешествие из Мекки в мечеть аль-Акса.<br /> Аль-мирадж — путешествие из мечети аль-Акса на небеса к Лотосу крайнего предела. </p>',
            ],
            20 => [
                'question' => '21. Вопрос: как Пророк (мир ему и благословение Аллаха) призывал людей к исламу за пределами Мекки?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6380.mp3',
                'answer' => '<p> Ответ: он призывал жителей Таифа, а также обращался к разным племенам в сезон хаджа и посещал другие собрания людей, пока в него не уверовали жители Медины <span class="c2">(ансары)</span>, которые присягнули ему и поклялись помогать ему. </p>',
            ],
            21 => [
                'question' => '22. Вопрос: сколько лет Посланник Аллаха (мир ему и благословение Аллаха) вёл призыв в Мекке?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6410.mp3',
                'answer' => '<p> Ответ: тринадцать лет. </p>',
            ],
            22 => [
                'question' => '23. Вопрос: куда переселился Посланник Аллаха (мир ему и благословение Аллаха)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6440.mp3',
                'answer' => '<p> Ответ: из Мекки он переселился в Медину. </p>',
            ],
            23 => [
                'question' => '24. Вопрос: сколько лет Посланник Аллаха (мир ему и благословение Аллаха) прожил в Медине?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6470.mp3',
                'answer' => '<p> Ответ: десять лет. </p>',
            ],
            24 => [
                'question' => '25. Вопрос: какие нормы ислама были ниспосланы в Медине?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6490.mp3',
                'answer' => '<p> Ответ: закят, пост, хадж, джихад, азан и другие. </p>',
            ],
            25 => [
                'question' => '26. Вопрос: назови важнейшие военные походы и сражения Посланника Аллаха (мир ему и благословение Аллаха).',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6520.mp3',
                'answer' => '<p> Ответ: 1) великая битва при Бадре;<br /> 2) битва при Ухуде;<br /> 3) битва у Рва;<br /> 4) покорение Мекки. </p>',
            ],
            26 => [
                'question' => '27. Вопрос: назови последний ниспосланный аят из Корана?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6580.mp3',
                'answer' => '<p> Ответ: Слова Всевышнего: <span class="c3">«Бойтесь того дня, когда вы будете возвращены к Аллаху. Тогда каждый человек получит сполна то, что приобрёл, и сними не поступят несправедливо»</span> [Сура 2 <span class="c3">«Корова»</span>, аят 281]. </p>',
            ],
            27 => [
                'question' => '28. Вопрос: когда и в каком возрасте скончался Посланник Аллаха (мир ему и благословение Аллаха)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6610.mp3',
                'answer' => '<p> Ответ: он скончался в месяце раби аль-авваль в 11 году от хиджры, в возрасте 63 лет. </p>',
            ],
            28 => [
                'question' => '29. Вопрос: перечисли имена жён Пророка (мир ему и благословение Аллаха).',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6640.mp3',
                'answer' => '<p> Ответ: 1) Хадиджа бинт Хувайлид <span class="c2">(да будет доволен ею Аллах)</span>;<br /> 2) Сауда бинт Замъа <span class="c2">(да будет доволен ею Аллах)</span>;<br /> 3) Аиша бинт Абу Бакр ас-Сыддик <span class="c2">(да будет доволен ею Аллах)</span>;<br /> 4) Хафса бинт Умар <span class="c2">(да будет доволен ею Аллах)</span>;<br /> 5) Зейнаб бинт Хузайма <span class="c2">(да будет доволен ею Аллах)</span>;<br /> 6) Умм Саляма Хинд бинт Абу Умайя <span class="c2">(да будет доволен ею Аллах)</span>;<br /> 7) Умм Хабиба Рамля бинт Абу Суфьян <span class="c2">(да будет доволен ею Аллах)</span>;<br /> 8) Джувайрия бинт аль-Харис <span class="c2">(да будет доволен ею Аллах)</span>;<br /> 9) Маймуна бинт аль-Харис <span class="c2">(да будет доволен ею Аллах)</span>;<br /> 10) Сафийя бинт Хуяйй <span class="c2">(да будет доволен ею Аллах)</span>;<br /> 11) Зейнаб бинт Джахш <span class="c2">(да будет доволен ею Аллах)</span>. </p>',
            ],
            29 => [
                'question' => '30. Вопрос: перечисли детей Посланника Аллаха (мир ему и благословение Аллаха).',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6760.mp3',
                'answer' => '<p> Ответ: трое сыновей:<br /> — Аль-Касим <span class="c2">(по имени которого Посланник Аллаха (мир ему и благословение Аллаха)</span> носил кунью Абу аль-Касим);<br /> — Абдуллах;<br /> — Ибрахим.<span class="c6"><br /> Дочери:</span><br /> — Фатыма;<br /> — Рукайя;<br /> — Умм Кульсум;<br /> — Зейнаб.<br /> Все его дети были от Хадиджи <span class="c2">(да будет доволен ею Аллах)</span>, кроме Ибрахима, и все они умерли при его жизни, за исключением Фатымы, которая умерла через полгода после него. </p>',
            ],
            30 => [
                'question' => '31. Вопрос: опиши Пророка (мир ему и благословение Аллаха).',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6880.mp3',
                'answer' => '<p> Ответ: он был среднего роста, светлокожим, с густой бородой, большими глазами, широким ртом, иссиня-чёрными волосами, широкоплечим, и от него исходил приятный запах. У него было ещё много прекрасных черт. </p>',
            ],
            31 => [
                'question' => '31. Вопрос: на чём оставил Посланник Аллаха (мир ему и благословение Аллаха) свою общину?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6910.mp3',
                'answer' => '<p> Ответ: он оставил свою общину на пути, ясно видном днём и ночью, отклоняется от которого только пропащий, и не осталось такого блага, на которое бы он не указал своей общине и не осталось такого зла, от которого он бы не предостерёг свою общину. </p>',
            ],
        ],
        4 => [
            0 => [
                'question' => '1. Вопрос: прочитай суру «Аль-Фатиха» и объясни её смысл.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6960.mp3',
                'answer' => '<p> Ответ: сура <span class="c3">«аль-Фатиха»</span> и её толкование:<br /> <span class="c3">«С именем Аллаха, Милостивого, Милующего! Хвала Аллаху, Господу миров, Милостивому, Милующему, Властелину Дня воздаяния! Только Тебе мы поклоняемся и только у Тебя испрашиваем помощи. Наставь нас на прямой путь, путь тех, кого Ты облагодетельствовал, не тех, на кого Ты разгневан, и не заблудших»</span> [Сура 1 <span class="c3">«Аль-Фатиха»</span>, аяты 1–7].<span class="c6"><br /> Толкование:</span><br /> Сура <span class="c3">«Аль-Фатиха»</span> названа открывающей, потому что она открывает собой Книгу Аллаха.<br /> 1) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001001.mp3"></audio> <span class="c4">{بِسۡمِ ٱللَّهِ ٱلرَّحۡمَٰنِ ٱلرَّحِيمِ}</span> <span class="c3">«С именем Аллаха, Милостивого, Милующего!»</span> — с именем Аллаха начинаю читать Коран, испрашивая у Него помощи и ища благодать в поминании Его имени.<br /> <span class="c3">«Аллах»</span> — единственный достойный поклонения; этим именем не называют никого, кроме Него.<br /> <span class="c3">«Милостивый»</span> — Обладатель великой милости, Которая объемлет всё сущее.<br /> <span class="c3">«Милующий»</span> — Милующий верующих.<br /> 2) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001002.mp3"></audio> <span class="c4">{ٱلۡحَمۡدُ لِلَّهِ رَبِّ ٱلۡعَٰلَمِينَ}</span> <span class="c3">«Хвала Аллаху, Господу миров»</span> — хвала в любом виде и всё совершенство принадлежат исключительно Аллаху.<br /> 3) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001003.mp3"></audio> <span class="c4">{ٱلرَّحۡمَٰنِ ٱلرَّحِيمِ}</span> <span class="c3">«Милостивому, Милующему»</span> — Обладателю великой милости, Которая объемлет всё сущее, Милующему верующих.<br /> 4) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001004.mp3"></audio> <span class="c4">{مَٰلِكِ يَوۡمِ ٱلدِّينِ}</span> <span class="c3">«Властелину Дня воздаяния!»</span> — то есть Судного дня.<br /> 5) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001005.mp3"></audio> <span class="c4">{إِيَّاكَ نَعۡبُدُ وَإِيَّاكَ نَسۡتَعِينُ}</span> <span class="c3">«Только Тебе мы поклоняемся и только у Тебя испрашиваем помощи»</span> — Тебе Одному мы поклоняемся и лишь у Тебя просим помощи.<br /> 6) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001006.mp3"></audio> <span class="c4">{ٱهۡدِنَا ٱلصِّرَٰطَ ٱلۡمُسۡتَقِيمَ}</span> <span class="c3">«Наставь нас на прямой путь»</span> — это путь ислама и Сунны.<br /> 7) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001007.mp3"></audio> <span class="c4">{صِرَٰطَ ٱلَّذِينَ أَنۡعَمۡتَ عَلَيۡهِمۡ غَيۡرِ ٱلۡمَغۡضُوبِ عَلَيۡهِمۡ وَلَا ٱلضَّآلِّينَ}</span> <span class="c3">«путь тех, кого Ты облагодетельствовал, не тех, на кого Ты разгневан, и не заблудших»</span> — путь праведных рабов Аллаха из числа пророков и их последователей, а не путь христиан и иудеев.<span class="c6"><br /> После её чтения желательно сказать:</span> <span class="c3">«Амин»</span>,<span class="c6"> что означает:</span> <span class="c3">«Ответь на наши мольбы»</span>. </p>',
            ],
            1 => [
                'question' => '2. Вопрос: прочитай суру «Землетрясение» и объясни её смысл.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7130.mp3',
                'answer' => '<p> Ответ: сура <span class="c3">«Землетрясение»</span> и её толкование<br /> С именем Аллаха Милостивого, Милующего!<br /> <span class="c3">«Когда земля содрогнётся от сотрясений, когда земля извергнет свою ношу, и человек спросит, что же с нею, в тот день она поведает свой рассказ, потому что Господь твой внушит ей это. В тот день люди выйдут толпами, чтобы узреть свои деяния. Тот, кто сделал добро весом в мельчайшую частицу, увидит его. И тот, кто сделал зло весом в мельчайшую частицу, увидит его»</span> [Сура 99 <span class="c3">«Землетрясение»</span>, аят 1–8].<span class="c6"><br /> Толкование:</span><br /> 1) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099001.mp3"></audio> <span class="c4">{إِذَا زُلۡزِلَتِ ٱلۡأَرۡضُ زِلۡزَالَهَا}</span> <span class="c3">«Когда земля содрогнётся от сотрясений»</span> — когда земля сильно задрожит в Судный день.<br /> 2) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099002.mp3"></audio> <span class="c4">{وَأَخۡرَجَتِ ٱلۡأَرۡضُ أَثۡقَالَهَا}</span> <span class="c3">«когда земля извергнет свою ношу»</span> — извергнет находящихся в её недрах умерших и так далее.<br /> 3) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099003.mp3"></audio> <span class="c4">{وَقَالَ ٱلۡإِنسَٰنُ مَا لَهَا}</span> <span class="c3">«и человек спросит, что же с нею»</span> — человек спросит в растерянности: что же это, почему земля движется и содрогается?<br /> 4) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099004.mp3"></audio> <span class="c4">{يَوۡمَئِذٖ تُحَدِّثُ أَخۡبَارَهَا}</span> <span class="c3">«в тот день она поведает свой рассказ»</span> — в тот день земля сообщит о том добре и зле, которое творили на ней.<br /> 5) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099005.mp3"></audio> <span class="c4">{بِأَنَّ رَبَّكَ أَوۡحَىٰ لَهَا}</span> <span class="c3">«потому что Господь твой внушит ей это»</span> — потому что Аллах сообщит ей об этом и велит ей сделать это.<br /> 6) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099006.mp3"></audio> <span class="c4">{يَوۡمَئِذٖ يَصۡدُرُ ٱلنَّاسُ أَشۡتَاتٗا لِّيُرَوۡاْ أَعۡمَٰلَهُمۡ}</span> <span class="c3">«В тот день люди выйдут толпами, чтобы узреть свои деяния»</span> — в тот великий день, когда земля содрогнётся, люди выйдут к месту расчёта, чтобы увидеть дела, совершённые ими в этом мире.<br /> 7) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099007.mp3"></audio> <span class="c4">{فَمَن يَعۡمَلۡ مِثۡقَالَ ذَرَّةٍ خَيۡرٗا يَرَهُۥ}</span> <span class="c3">«Тот, кто сделал добро весом в мельчайшую частицу, увидит его»</span> — кто совершил доброе, богоугодное дело хотя бы на вес маленького муравья, тот увидит его перед собой.<br /> 8) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099008.mp3"></audio> <span class="c4">{وَمَن يَعۡمَلۡ مِثۡقَالَ ذَرَّةٖ شَرّٗا يَرَهُۥۥ}</span> <span class="c3">«И тот, кто сделал зло весом в мельчайшую частицу, увидит его»</span> — кто совершил скверное, неугодное Аллаху дело хотя бы на вес маленького муравья, тот увидит его перед собой. </p>',
            ],
            2 => [
                'question' => '3. Вопрос: прочитай суру «Мчащиеся» и объясни её смысл.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7270.mp3',
                'answer' => '<p> Ответ: сура <span class="c3">«Мчащиеся»</span> и её толкование:<br /> С именем Аллаха Милостивого, Милующего!<br /> <span class="c3">«Клянусь скачущими во весь дух! Клянусь высекающими искры! Клянусь нападающими на заре, которые поднимают пыль и врываются с ним <span class="c5">[со всадником]</span> в гущу. Поистине, человек неблагодарен своему Господу, и он сам является тому свидетелем. Поистине, он страстно любит блага. Неужели он не знает, что, когда будет извергнуто то, что в могилах, и когда обнаружится то, что в груди, в тот день Господь их будет осведомлён о них?»</span> [Сура 100 <span class="c3">«Мчащиеся»</span>, аяты 1–11].<span class="c6"><br /> Толкование:</span><br /> 1) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100001.mp3"></audio> <span class="c4">{وَٱلۡعَٰدِيَٰتِ ضَبۡحٗا}</span> <span class="c3">«Клянусь скачущими во весь дух!»</span> — Аллах клянётся лошадьми, которые тяжело дышат из-за быстрой скачки.<br /> 2) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100002.mp3"></audio> <span class="c4">{فَٱلۡمُورِيَٰتِ قَدۡحٗا}</span> <span class="c3">«Клянусь высекающими искры!»</span> — и Он клянётся лошадьми, из-под копыт которых летят искры, когда они скачут по камням.<br /> 3) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100003.mp3"></audio> <span class="c4">{فَٱلۡمُغِيرَٰتِ صُبۡحٗا}</span> <span class="c3">«Клянусь нападающими на заре»</span> — и Он поклялся конницей, которая нападает на врага ранним утром.<br /> 4) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100004.mp3"></audio> <span class="c4">{فَأَثَرۡنَ بِهِۦ نَقۡعٗا}</span> <span class="c3">«которые поднимают пыль»</span> — скачут, поднимая пыль.<br /> 5) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100005.mp3"></audio> <span class="c4">{فَوَسَطۡنَ بِهِۦ جَمۡعًا}</span> <span class="c3">«и врываются с ним <span class="c5">[со всадником]</span> в гущу»</span> — они влетают на скорости в гущу врагов, неся на себе своих всадников.<br /> 6) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100006.mp3"></audio> <span class="c4">{إِنَّ ٱلۡإِنسَٰنَ لِرَبِّهِۦ لَكَنُودٞ}</span> <span class="c3">«Поистине, человек неблагодарен своему Господу»</span> — человек скуп на добро, к которому Господь побуждает его.<br /> 7) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100007.mp3"></audio> <span class="c4">{وَإِنَّهُۥ عَلَىٰ ذَٰلِكَ لَشَهِيدٞ}</span> <span class="c3">«и он сам является тому свидетелем»</span> — и сам он свидетель своей скупости на добро, к которому Господь побуждает его, и не может отрицать её.<br /> 8) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100008.mp3"></audio> <span class="c4">{وَإِنَّهُۥ لِحُبِّ ٱلۡخَيۡرِ لَشَدِيدٌ}</span> <span class="c3">«Поистине, он страстно любит блага»</span> — его чрезмерная любовь к имуществу побуждает его к скупости.<br /> 9) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100009.mp3"></audio> <span class="c4">{أَفَلَا يَعۡلَمُ إِذَا بُعۡثِرَ مَا فِي ٱلۡقُبُورِ}</span> <span class="c3">«Неужели он не знает, что, когда будет извергнуто то, что в могилах»</span> — разве не узнает этот человек, обольщённый земной жизнью, когда Аллах воскресит тех, кто в могилах, и выведет их из земли для расчёта и воздаяния, что всё не так, как он ошибочно полагал?<br /> 10) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100010.mp3"></audio> <span class="c4">{وَحُصِّلَ مَا فِي ٱلصُّدُورِ}</span> <span class="c3">«и когда обнаружится то, что в груди»</span> — станет явным и очевидным то, что в сердцах — намерения, убеждения и так далее.<br /> 11) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100011.mp3"></audio> <span class="c4">{إِنَّ رَبَّهُم بِهِمۡ يَوۡمَئِذٖ لَّخَبِيرُۢ}</span> <span class="c3">«в тот день Господь их будет осведомлён о них?»</span> — в тот день Господь будет знать о них всё, и ничто из связанного с ними не укроется от Него, и Он воздаст им за это. </p>',
            ],
            3 => [
                'question' => '4. Вопрос: прочитай суру «Поражающее» и объясни её смысл.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7450.mp3',
                'answer' => '<p> Ответ: сура <span class="c3">«Поражающее»</span> и её толкование:<br /> С именем Аллаха Милостивого, Милующего!<br /> <span class="c3">«Великое бедствие <span class="c5">[День воскресения]</span>! Что такое Великое бедствие <span class="c5">[День воскресения]</span>? Откуда ты мог знать, что такое Великое бедствие <span class="c5">[День воскресения]</span>? В тот день люди будут подобны рассеянным мотылькам, а горы будут подобны расчёсанной шерсти. Тогда тот, чья чаша Весов окажется тяжёлой, обретёт приятную жизнь. Тому же, чья чаша Весов окажется лёгкой, пристанищем будет Пропасть. Откуда ты мог знать, что это такое? Это — жаркий Огонь!»</span> [Сура 101 <span class="c3">«Поражающее»</span>, аяты 1–11].<span class="c6"><br /> Толкование:</span><br /> 1) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101001.mp3"></audio> <span class="c4">{ٱلۡقَارِعَةُ}</span> <span class="c3">«Великое бедствие <span class="c5">[День воскресения]</span>!»</span> — Час, который поражает сердца людей, ибо так он ужасен.<br /> 2) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101002.mp3"></audio> <span class="c4">{مَا ٱلۡقَارِعَةُ}</span> <span class="c3">«Что такое Великое бедствие <span class="c5">[День воскресения]</span>?»</span> — что это за Час, который поражает сердца людей, ибо так он ужасен?<br /> 3) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101003.mp3"></audio> <span class="c4">{وَمَآ أَدۡرَىٰكَ مَا ٱلۡقَارِعَةُ}</span> <span class="c3">«Откуда ты мог знать, что такое Великое бедствие <span class="c5">[День воскресения]</span>?»</span> — откуда тебе знать, о Посланник, что это за Час, который поражает сердца людей, ибо так он ужасен?<br /> 4) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101004.mp3"></audio> <span class="c4">{يَوۡمَ يَكُونُ ٱلنَّاسُ كَٱلۡفَرَاشِ ٱلۡمَبۡثُوثِ}</span> <span class="c3">«В тот день люди будут подобны рассеянным мотылькам»</span> — в день, когда сердца людей будут поражены, люди будут как разлетевшиеся в разные стороны бабочки.<br /> 5) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101005.mp3"></audio> <span class="c4">{وَتَكُونُ ٱلۡجِبَالُ كَٱلۡعِهۡنِ ٱلۡمَنفُوشِ}</span> <span class="c3">«а горы будут подобны расчёсанной шерсти»</span> — горы будут как распушённая шерсть — так легко они будут двигаться.<br /> 6) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101006.mp3"></audio> <span class="c4">{فَأَمَّا مَن ثَقُلَتۡ مَوَٰزِينُهُۥ}</span> <span class="c3">«Тогда тот, чья чаша Весов окажется тяжёлой»</span> — у кого хорошие дела перевесят скверные.<br /> 7) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101007.mp3"></audio> <span class="c4">{فَهُوَ فِي عِيشَةٖ رَّاضِيَةٖ}</span> <span class="c3">«обретёт приятную жизнь»</span> — его ждёт прекрасная и приятная жизнь в Раю.<br /> 8) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101008.mp3"></audio> <span class="c4">{وَأَمَّا مَنۡ خَفَّتۡ مَوَٰزِينُهُۥ}</span> <span class="c3">«Тому же, чья чаша Весов окажется лёгкой»</span> — у кого скверные дела перевесят хорошие.<br /> 9) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101009.mp3"></audio> <span class="c4">{فَأُمُّهُۥ هَاوِيَةٞ}</span> <span class="c3">«пристанищем будет Пропасть»</span> — его обителью в Судный день станет Ад.<br /> 10) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101010.mp3"></audio> <span class="c4">{وَمَآ أَدۡرَىٰكَ مَا هِيَهۡ}</span> <span class="c3">«Откуда ты мог знать, что это такое?»</span> — откуда тебе знать, о Посланник, что представляет собой Ад?<br /> 11) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101011.mp3"></audio> <span class="c4">{نَارٌ حَامِيَةُۢ}</span> <span class="c3">«Это — жаркий Огонь!»</span> — это очень горячее пламя. </p>',
            ],
            4 => [
                'question' => '5. Вопрос: прочитай суру «Страсть к приумножению» и объясни её смысл.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7610.mp3',
                'answer' => '<p> Ответ: сура <span class="c3">«Страсть к приумножению»</span> и её толкование:<br /> С именем Аллаха, Милостивого, Милующего!<br /> <span class="c3">«Страсть к приумножению <span class="c5">[мирских благ]</span> отвлекает вас, пока вы не посетите могилы. Но нет <span class="c5">[не пристало вам отвлекаться так]</span>! Скоро вы узнаете <span class="c5">[о страшных последствиях этого]</span>! Ещё раз нет! Скоро вы узнаете! О нет! Если бы вы только обладали знанием с полной убеждённостью! Вы непременно увидите Ад. Вы увидите его своими глазами по-настоящему. В тот день вы будете спрошены о благах»</span> [сура 102 <span class="c3">«Страсть к приумножению»</span>, аяты 1–8].<span class="c6"><br /> Толкование:</span><br /> 1) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102001.mp3"></audio> <span class="c4">{أَلۡهَىٰكُمُ ٱلتَّكَاثُرُ}</span> <span class="c3">«Страсть к приумножению <span class="c5">[мирских благ]</span> отвлекает вас»</span> — о люди, ваша похвальба друг перед другом имуществом и сыновьями отвлекает вас от покорности Аллаху.<br /> 2) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102002.mp3"></audio> <span class="c4">{حَتَّىٰ زُرۡتُمُ ٱلۡمَقَابِرَ}</span> <span class="c3">«пока вы не посетите могилы»</span> — пока вы не умрёте и не окажетесь в могилах.<br /> 3) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102003.mp3"></audio> <span class="c4">{كَلَّا سَوۡفَ تَعۡلَمُونَ}</span> <span class="c3">«Но нет <span class="c5">[не пристало вам отвлекаться так]</span>! Скоро вы узнаете <span class="c5">[о страшных последствиях этого]</span>!»</span> — вы не должны позволять этой похвальбе отвлекать вас от покорности Аллаху; и вы узнаете о скверных последствиях того, что она вас отвлекала.<br /> 4) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102004.mp3"></audio> <span class="c4">{ثُمَّ كَلَّا سَوۡفَ تَعۡلَمُونَ}</span> <span class="c3">«Ещё раз нет! Скоро вы узнаете!»</span> — потом вы узнаете о скверных последствиях того, что она вас отвлекала.<br /> 5) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102005.mp3"></audio> <span class="c4">{كَلَّا لَوۡ تَعۡلَمُونَ عِلۡمَ ٱلۡيَقِينِ}</span> <span class="c3">«О нет! Если бы вы только обладали знанием с полной убеждённостью!»</span> — действительно, если бы вы точно знали, что Аллах воскресит вас и воздаст вам за ваши дела, вы бы не отвлекались от покорности Ему на похвальбу имуществом и сыновьями.<br /> 6) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102006.mp3"></audio> <span class="c4">{لَتَرَوُنَّ ٱلۡجَحِيمَ}</span> <span class="c3">«Вы непременно увидите Ад»</span> — клянусь Аллахом, вы непременно увидите Ад в Судный день.<br /> 7) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102007.mp3"></audio> <span class="c4">{ثُمَّ لَتَرَوُنَّهَا عَيۡنَ ٱلۡيَقِينِ}</span> <span class="c3">«Вы увидите его своими глазами по-настоящему»</span> — затем вы непременно увидите его, и в этом нет сомнений.<br /> 8) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102008.mp3"></audio> <span class="c4">{ثُمَّ لَتُسۡـَٔلُنَّ يَوۡمَئِذٍ عَنِ ٱلنَّعِيمِ}</span> <span class="c3">«В тот день вы будете спрошены о благах»</span> — затем Аллах спросит вас в тот день о милостях, которыми наделил вас — здоровье, богатстве и так далее. </p>',
            ],
            5 => [
                'question' => '6. Вопрос: прочитай суру «Время» и объясни её смысл.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7750.mp3',
                'answer' => '<p> Ответ: сура <span class="c3">«Время»</span> и её толкование:<br /> С именем Аллаха Милостивого, Милующего!<br /> <span class="c3">«Клянусь временем, что все люди несут убытки, кроме тех, которые уверовали, совершали благие деяния, заповедали друг другу истину и заповедали друг другу терпение!»</span> [Сура 103 <span class="c3">«Время»</span>, аяты 1–3].<span class="c6"><br /> Толкование:</span><br /> 1) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/103001.mp3"></audio> <span class="c4">{وَٱلۡعَصۡرِ}</span> <span class="c3">«Клянусь временем»</span> — Всевышний Аллах поклялся временем.<br /> 2) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/103002.mp3"></audio> <span class="c4">{إِنَّ ٱلۡإِنسَٰنَ لَفِي خُسۡرٍ}</span> <span class="c3">«что все люди несут убытки»</span> — каждый человек в убытке и погибели.<br /> 3) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/103003.mp3"></audio> <span class="c4">{إِلَّا ٱلَّذِينَ ءَامَنُواْ وَعَمِلُواْ ٱلصَّٰلِحَٰتِ وَتَوَاصَوۡاْ بِٱلۡحَقِّ وَتَوَاصَوۡاْ بِٱلصَّبۡرِ}</span> <span class="c3">«кроме тех, которые уверовали, совершали благие деяния, заповедали друг другу истину и заповедали друг другу терпение!»</span> — за исключением тех, которые уверовали и совершали благие дела и при этом призывали к истине и проявляли терпение ради неё — они не окажутся в убытке. </p>',
            ],
            6 => [
                'question' => '7. Вопрос: прочитай суру «Хулитель» и объясни её смысл.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7830.mp3',
                'answer' => '<p> Ответ: сура <span class="c3">«Хулитель»</span> и её толкование:<br /> С именем Аллаха Милостивого, Милующего!<br /> <span class="c3">«Горе всякому хулителю злословящему, который копит состояние и подсчитывает его, думая, что богатство увековечит его. О нет! Он будет ввергнут в Огонь сокрушающий. Откуда ты мог знать, что такое Огонь сокрушающий? Это — разожжённый Огонь Аллаха, который вздымается над сердцами. Он сомкнётся над ними высокими сводами»</span> [Сура 104 <span class="c3">«Хулитель»</span>, аяты 1–9].<span class="c6"><br /> Толкование:</span><br /> 1) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104001.mp3"></audio> <span class="c4">{وَيۡلٞ لِّكُلِّ هُمَزَةٖ لُّمَزَةٍ}</span> <span class="c3">«Горе всякому хулителю злословящему»</span> — беда и суровое наказание тому, кто много злословит о людях и очерняет их.<br /> 2) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104002.mp3"></audio> <span class="c4">{ٱلَّذِي جَمَعَ مَالٗا وَعَدَّدَهُۥ}</span> <span class="c3">«который копит состояние и подсчитывает его»</span> — его единственная забота — собирать да подсчитывать богатство.<br /> 3) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104003.mp3"></audio> <span class="c4">{يَحۡسَبُ أَنَّ مَالَهُۥٓ أَخۡلَدَهُۥ}</span> <span class="c3">«думая, что богатство увековечит его»</span> — он полагает, что собранное им богатство спасёт его от смерти и он будет жить в этом мире вечно.<br /> 4) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104004.mp3"></audio> <span class="c4">{كَلَّاۖ لَيُنۢبَذَنَّ فِي ٱلۡحُطَمَةِۥ}</span> <span class="c3">«О нет! Он будет ввергнут в Огонь сокрушающий»</span> — всё не так, как представляет себе этот невежда. Он будет брошен в пламя Геенны, которое сокрушает всё, что в него попадает.<br /> 5) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104005.mp3"></audio> <span class="c4">{وَمَآ أَدۡرَىٰكَ مَا ٱلۡحُطَمَةُ}</span> <span class="c3">«Откуда ты мог знать, что такое Огонь сокрушающий?»</span> — откуда тебе знать, о Посланник, каков этот огонь, сокрушающий всё, что в него попадает?<br /> 6) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104006.mp3"></audio> <span class="c4">{نَارُ ٱللَّهِ ٱلۡمُوقَدَةُ}</span> <span class="c3">«Это — разожжённый Огонь Аллаха»</span> — это пылающее пламя Аллаха.<br /> 7) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104007.mp3"></audio> <span class="c4">{ٱلَّتِي تَطَّلِعُ عَلَى ٱلۡأَفۡـِٔدَةِ}</span> <span class="c3">«который вздымается над сердцами»</span> — которое проникает через тела людей к их сердцам.<br /> 8) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104008.mp3"></audio> <span class="c4">{إِنَّهَا عَلَيۡهِم مُّؤۡصَدَةٞ}</span> <span class="c3">«Он сомкнётся над ними»</span> — те, кто подвергнется мукам в этом пламени, будут заперты в нём.<br /> 9) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104009.mp3"></audio> <span class="c4">{فِي عَمَدٖ مُّمَدَّدَةِۭ}</span> <span class="c3">«высокими сводами»</span> — очень высокими сводами, дабы они не смогли выйти оттуда. </p>',
            ],
            7 => [
                'question' => '8. Вопрос: прочитай суру «Слон» и объясни её смысл.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7970.mp3',
                'answer' => '<p> Ответ: сура <span class="c3">«Слон»</span> и её толкование:<br /> С именем Аллаха Милостивого, Милующего!<br /> <span class="c3">«Разве ты не видел, что сделал твой Господь с владельцами слона? Разве Он не запутал их козни и не наслал на них птиц стаями? Они бросали в них каменья из обожжённой глины и превратили их в подобие изъеденных иссохших злаковых листьев»</span> [Сура 105 <span class="c3">«Слон»</span>, аяты 1–5].<span class="c6"><br /> Толкование:</span><br /> 1) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105001.mp3"></audio> <span class="c4">{أَلَمۡ تَرَ كَيۡفَ فَعَلَ رَبُّكَ بِأَصۡحَٰبِ ٱلۡفِيلِ}</span> <span class="c3">«Разве ты не видел, что сделал твой Господь с владельцами слона?»</span> — разве не знаешь ты, о Посланник, что сделал твой Господь с Абрахой и его приспешниками, владельцами слона, когда те решили разрушить Каабу?<br /> 2) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105002.mp3"></audio> <span class="c4">{أَلَمۡ يَجۡعَلۡ كَيۡدَهُمۡ فِي تَضۡلِيلٖ}</span> <span class="c3">«Разве Он не запутал их козни»</span> — Аллах сделал так, что их попытки потерпели неудачу и они не смогли отвратить людей от Каабы и не нанесли ей никакого вреда.<br /> 3) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105003.mp3"></audio> <span class="c4">{وَأَرۡسَلَ عَلَيۡهِمۡ طَيۡرًا أَبَابِيلَ}</span> <span class="c3">«и не наслал на них птиц стаями?»</span> — Аллах наслал на них птиц большими группами.<br /> 4) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105004.mp3"></audio> <span class="c4">{تَرۡمِيهِم بِحِجَارَةٖ مِّن سِجِّيلٖ}</span> <span class="c3">«Они бросали в них каменья из обожжённой глины»</span> — то есть твёрдой.<br /> 5) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105005.mp3"></audio> <span class="c4">{فَجَعَلَهُمۡ كَعَصۡفٖ مَّأۡكُولِۭ}</span> <span class="c3">«и превратили их в подобие изъеденных иссохших злаковых листьев»</span> — в подобие злаков, которые скотина объела и истоптала. </p>',
            ],
            8 => [
                'question' => '9. Вопрос: прочитай суру «Курайш» и объясни её смысл.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8070.mp3',
                'answer' => '<p> Ответ: сура <span class="c3">«Курайш»</span> и её толкование:<br /> С именем Аллаха Милостивого, Милующего!<br /> <span class="c3">«Ради единения курайшитов, единения их во время зимних и летних поездок. Пусть же они поклоняются Господу этого Дома <span class="c5">[Каабы]</span>, Который накормил их после голода и избавил их от страха»</span> [Сура 106 <span class="c3">«Курайш»</span>, аяты 1–4].<span class="c6"><br /> Толкование:</span><br /> 1) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106001.mp3"></audio> <span class="c4">{لِإِيلَٰفِ قُرَيۡشٍ}</span> <span class="c3">«Ради единения курайшитов»</span> — они собирались, организовывая зимние и летние торговые поездки.<br /> 2) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106002.mp3"></audio> <span class="c4">{إِۦلَٰفِهِمۡ رِحۡلَةَ ٱلشِّتَآءِ وَٱلصَّيۡفِ}</span> <span class="c3">«единения их во время зимних и летних поездок»</span> — зимой они предпринимали торговую поездку в Йемен, а летом — в Шам.<br /> 3) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106003.mp3"></audio> <span class="c4">{فَلۡيَعۡبُدُواْ رَبَّ هَٰذَا ٱلۡبَيۡتِ}</span> <span class="c3">«Пусть же они поклоняются Господу этого Дома <span class="c5">[Каабы]</span>»</span> — пусть же они поклоняются только Аллаху, Господу этого Заповедного Дома, Который облегчил им эти торговые поездки, и не придают Ему никаких сотоварищей.<br /> 4) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106004.mp3"></audio> <span class="c4">{ٱلَّذِيٓ أَطۡعَمَهُم مِّن جُوعٖ وَءَامَنَهُم مِّنۡ خَوۡفِۭ}</span> <span class="c3">«Который накормил их после голода и избавил их от страха»</span> — Он избавил их от голода и страха, внушив арабам возвеличивать священный город — Мекку — и с почтением относиться к её жителям. </p>',
            ],
            9 => [
                'question' => '10. Вопрос: прочитай суру «Утварь» и объясни её смысл.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8160.mp3',
                'answer' => '<p> Ответ: сура <span class="c3">«Утварь»</span> и её толкование:<br /> С именем Аллаха, Милостивого, Милующего!<br /> <span class="c3">«Видел ли ты того, кто считает ложью воздаяние? Это — тот, кто гонит сироту и не побуждает накормить бедняка. Горе молящимся, которые небрежны к своим молитвам, которые совершают дела напоказ и отказывают даже в мелочи!»</span> [Сура 107 <span class="c3">«Утварь»</span>, аяты 1–7].<span class="c6"><br /> Толкование:</span><br /> 1) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107001.mp3"></audio> <span class="c4">{أَرَءَيۡتَ ٱلَّذِي يُكَذِّبُ بِٱلدِّينِ}</span> <span class="c3">«Видел ли ты того, кто считает ложью воздаяние?»</span> — знаешь ли ты того, кто считает воздаяние в Судный день ложью?<br /> 2) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107002.mp3"></audio> <span class="c4">{فَذَٰلِكَ ٱلَّذِي يَدُعُّ ٱلۡيَتِيمَ}</span> <span class="c3">«Это — тот, кто гонит сироту»</span> — он грубо отталкивает нуждающегося сироту.<br /> 3) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107003.mp3"></audio> <span class="c4">{وَلَا يَحُضُّ عَلَىٰ طَعَامِ ٱلۡمِسۡكِينِ}</span> <span class="c3">«и не побуждает накормить бедняка»</span> — он не побуждает ни себя, ни других кормить бедных.<br /> 4) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107004.mp3"></audio> <span class="c4">{فَوَيۡلٞ لِّلۡمُصَلِّينَ}</span> <span class="c3">«Горе молящимся»</span> — погибель и мучения тем молящимся.<br /> 5) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107005.mp3"></audio> <span class="c4">{ٱلَّذِينَ هُمۡ عَن صَلَاتِهِمۡ سَاهُونَ}</span> <span class="c3">«которые небрежны к своим молитвам»</span> — которые отвлекаются от молитвы, не считая её чем-то важным, и не совершают её, пока время её не закончится.<br /> 6) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107006.mp3"></audio> <span class="c4">{ٱلَّذِينَ هُمۡ يُرَآءُونَ}</span> <span class="c3">«которые совершают дела напоказ»</span> — это те, которые совершают молитвы и благие дела напоказ, а не искренне, ради Аллаха.<br /> 7) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107007.mp3"></audio> <span class="c4">{وَيَمۡنَعُونَ ٱلۡمَاعُونَ}</span> <span class="c3">«и отказывают даже в мелочи!»</span> — они отказываются помогать другим даже в том, в чём им не составляет никакого труда помочь. </p>',
            ],
            10 => [
                'question' => '11. Вопрос: прочитай суру «Каусар» и объясни её смысл.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8280.mp3',
                'answer' => '<p> Ответ: сура <span class="c3">«Каусар»</span> и её толкование:<br /> С именем Аллаха, Милостивого, Милующего!<br /> <span class="c3">«Мы даровали тебе аль-Каусар. Посему совершай молитву ради своего Господа и совершай заклание. Поистине, твой ненавистник сам окажется безвестным»</span> [Сура 108 <span class="c3">«Каусар»</span>, аяты 1–3].<span class="c6"><br /> Толкование:</span><br /> 1) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/108001.mp3"></audio> <span class="c4">{إِنَّآ أَعۡطَيۡنَٰكَ ٱلۡكَوۡثَرَ}</span> <span class="c3">«Мы даровали тебе аль-Каусар»</span> — поистине, Мы даровали тебе, о Посланник, огромное благо, в том числе и реку Каусар в Раю.<br /> 2) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/108002.mp3"></audio> <span class="c4">{فَصَلِّ لِرَبِّكَ وَٱنۡحَرۡ}</span> <span class="c3">«Посему совершай молитву ради своего Господа и совершай заклание»</span> — благодари же Аллаха за эту милость — молись Ему одному и совершай жертвоприношение, в противоположность тому, что делают многобожники, которые ищут приближения к своим идолам, совершая жертвоприношение им.<br /> 3) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/108003.mp3"></audio> <span class="c4">{إِنَّ شَانِئَكَ هُوَ ٱلۡأَبۡتَرُ}</span> <span class="c3">«Поистине, твой ненавистник сам окажется бездетным»</span> — поистине, ненавидящий тебя сам отрезан от всякого блага и забыт так, что если его и помянут, то помянут недобрым словом. </p>',
            ],
            11 => [
                'question' => '12. Вопрос: прочитай суру «Неверующие» и объясни её смысл.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8360.mp3',
                'answer' => '<p> Ответ: сура <span class="c3">«Неверующие»</span> и её толкование:<br /> С именем Аллаха, Милостивого,<span class="c6"> Милующего!<br /> «Скажи:</span> <span class="c1">“О неверующие! Я не поклоняюсь тому, чему поклоняетесь вы, а вы не поклоняетесь Тому, Кому поклоняюсь я. Я не поклоняюсь тому, чему поклоняетесь вы, а вы не поклоняетесь Тому, Кому поклоняюсь я. Вы исповедуете свою религию, а я исповедую свою!”</span>» [Сура 109 <span class="c3">«Неверующие»</span>, аяты 1–6].<span class="c6"><br /> Толкование:</span><br /> 1) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109001.mp3"></audio> <span class="c4">{قُلۡ يَٰٓأَيُّهَا ٱلۡكَٰفِرُونَ}</span> <span class="c3">«Скажи: о неверующие!»</span> — о те, кто не верует в Аллаха!<br /> 2) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109002.mp3"></audio> <span class="c4">{لَآ أَعۡبُدُ مَا تَعۡبُدُونَ}</span> <span class="c3">«Я не поклоняюсь тому, чему поклоняетесь вы»</span> — я не поклоняюсь сейчас и не буду поклоняться в будущем идолам, которым поклоняетесь вы.<br /> 3) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109003.mp3"></audio> <span class="c4">{وَلَآ أَنتُمۡ عَٰبِدُونَ مَآ أَعۡبُدُ}</span> <span class="c3">«а вы не поклоняетесь Тому, Кому поклоняюсь я»</span> — и вы не поклоняетесь Одному лишь Аллаху, Которому поклоняюсь я.<br /> 4) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109004.mp3"></audio> <span class="c4">{وَلَآ أَنَا۠ عَابِدٞ مَّا عَبَدتُّمۡ}</span> <span class="c3">«Я не поклоняюсь тому, чему поклоняетесь вы»</span> — я не поклоняюсь идолам, которым вы поклонялись.<br /> 5) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109005.mp3"></audio> <span class="c4">{وَلَآ أَنتُمۡ عَٰبِدُونَ مَآ أَعۡبُدُ}</span> <span class="c3">«а вы не поклоняетесь Тому, Кому поклоняюсь я»</span> — и вы не поклоняетесь Одному лишь Аллаху, Которому поклоняюсь я.<br /> 6) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109006.mp3"></audio> <span class="c4">{لَكُمۡ دِينُكُمۡ وَلِيَ دِينِ}</span> <span class="c3">«Вы исповедуете свою религию, а я исповедую свою!»</span> — у вас есть ваша религия, которую вы сами придумали для себя, а у меня есть моя религия, которую Аллах ниспослал мне. </p>',
            ],
            12 => [
                'question' => '13. Вопрос: прочитай суру «Помощь» и объясни её смысл.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8470.mp3',
                'answer' => '<p> Ответ: сура <span class="c3">«Помощь»</span> и её толкование:<br /> С именем Аллаха, Милостивого, Милующего!<br /> <span class="c3">«Когда придёт помощь Аллаха и победа, когда ты увидишь, как люди толпами входят в религию Аллаха, восславь же хвалой Господа своего и проси у Него прощения. Поистине, Он — Принимающий покаяние»</span> [Сура 110 <span class="c3">«Помощь»</span>, аяты 1–3].<span class="c6"><br /> Толкование:</span><br /> 1) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/110001.mp3"></audio> <span class="c4">{إِذَا جَآءَ نَصۡرُ ٱللَّهِ وَٱلۡفَتۡحُ}</span> <span class="c3">«Когда придёт помощь Аллаха и победа»</span> — когда придёт помощь Аллаха к религии твоей, и когда Он сделает её самой могущественной и случится завоевание Мекки, о Посланник.<br /> 2) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/110002.mp3"></audio> <span class="c4">{وَرَأَيۡتَ ٱلنَّاسَ يَدۡخُلُونَ فِي دِينِ ٱللَّهِ أَفۡوَاجٗا}</span> <span class="c3">«когда ты увидишь, как люди толпами входят в религию Аллаха»</span> — и ты увидишь, как люди целыми группами принимают ислам.<br /> 3) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/110003.mp3"></audio> <span class="c4">{فَسَبِّحۡ بِحَمۡدِ رَبِّكَ وَٱسۡتَغۡفِرۡهُۚ إِنَّهُۥ كَانَ تَوَّابَۢا}</span> <span class="c3">«восславь же хвалой Господа своего и проси у Него прощения. Поистине, Он — Принимающий покаяние»</span> — знай, что это признак того, что твоя миссия близка к завершению. Славь же Господа твоего, благодаря Его за милость помощи и победы, и испрашивай у Него прощения, ведь Он — Принимающий покаяния, и Он принимает покаяние Своих рабов и прощает им. </p>',
            ],
            13 => [
                'question' => '14. Вопрос: прочитай суру «Пальмовое волокно» и объясни её смысл.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8550.mp3',
                'answer' => '<p> Ответ: сура <span class="c3">«Пальмовое волокно»</span> и её толкование:<br /> С именем Аллаха, Милостивого, Милующего!<br /> <span class="c3">«Да отсохнут руки Абу Ляхаба, и сам он да сгинет. Не помогло ему богатство, и он ничего не приобрёл. Он попадёт в пламенный Огонь. Жена его будет носить дрова, а на шее у неё будет плетёная верёвка из пальмового волокна»</span> [Сура 111 <span class="c3">«Пальмовое волокно»</span>, аяты 1–5].<span class="c6"><br /> Толкование:</span><br /> 1) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111001.mp3"></audio> <span class="c4">{تَبَّتۡ يَدَآ أَبِي لَهَبٖ وَتَبَّ}</span> <span class="c3">«Да отсохнут руки Абу Ляхаба, и сам он да сгинет»</span> — останутся ни с чем руки дяди Пророка <span class="c2">(мир ему и благословение Аллаха)</span> Абу Ляхаба ибн Абду-ль-Мутталиба, потому что дела его будут тщетными, ведь он обижал Пророка <span class="c2">(мир ему и благословение Аллаха)</span>, но все его усилия были напрасны.<br /> 2) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111002.mp3"></audio> <span class="c4">{مَآ أَغۡنَىٰ عَنۡهُ مَالُهُۥ وَمَا كَسَبَ}</span> <span class="c3">«Не помогло ему богатство, и он ничего не приобрёл»</span> — чем могут помочь ему его богатство и сыновья? Они не избавят его от наказания и не помогут ему обрести милость Аллаха.<br /> 3) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111003.mp3"></audio> <span class="c4">{سَيَصۡلَىٰ نَارٗا ذَاتَ لَهَبٖ}</span> <span class="c3">«Он попадёт в пламенный Огонь»</span> — в Судный день он войдёт в пылающий Огонь и вкусит жар его.<br /> 4) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111004.mp3"></audio> <span class="c4">{وَٱمۡرَأَتُهُۥ حَمَّالَةَ ٱلۡحَطَبِ}</span> <span class="c3">«Жена его будет носить дрова»</span> — его жена Умм Джамиль, которая беспокоила Пророка <span class="c2">(мир ему и благословение Аллаха)</span>, рассыпая на его пути колючки, тоже войдёт в Ад.<br /> 5) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111005.mp3"></audio> <span class="c4">{فِي جِيدِهَا حَبۡلٞ مِّن مَّسَدِۭ}</span> <span class="c3">«а на шее у неё будет плетёная верёвка из пальмовых волокон»</span> — на шее у неё будет крепкая верёвка, за которую её потащат в Огонь. </p>',
            ],
            14 => [
                'question' => '15. Вопрос: прочитай суру «Искренность» и объясни её смысл.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8650.mp3',
                'answer' => '<p> Ответ: сура <span class="c3">«Искренность»</span> и её толкование:<br /> С именем Аллаха, Милостивого,<span class="c6"> Милующего!<br /> «Скажи:</span> <span class="c1">“Он — Аллах Единственный, Аллах Самодостаточный. Он не родил и не был рождён, и не равен Ему ни один”</span>» [Сура 112 <span class="c3">«Искренность»</span>, аяты 1–4].<span class="c6"><br /> Толкование:</span><br /> 1) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112001.mp3"></audio> <span class="c4">{قُلۡ هُوَ ٱللَّهُ أَحَدٌ}</span> <span class="c3">«Скажи: Он — Аллах Единственный»</span> — скажи,<span class="c6"> о Посланник:</span> Он — Аллах, кроме Которого нет иного бога.<br /> 2) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112002.mp3"></audio> <span class="c4">{ٱللَّهُ ٱلصَّمَدُ}</span> <span class="c3">«Аллах Самодостаточный»</span> — к Нему обращаются творения со Своими потребностями и нуждами.<br /> 3) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112003.mp3"></audio> <span class="c4">{لَمۡ يَلِدۡ وَلَمۡ يُولَدۡ}</span> <span class="c3">«Он не родил и не был рождён»</span> — у Всевышнего Аллаха нет ни детей, ни родителей.<br /> 4) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112004.mp3"></audio> <span class="c4">{وَلَمۡ يَكُن لَّهُۥ كُفُوًا أَحَدُۢ}</span> <span class="c3">«и не равен Ему ни один»</span> — и у Него нет равных и подобных среди Его творений. </p>',
            ],
            15 => [
                'question' => '16. Вопрос: прочитай суру «Рассвет» и объясни её смысл.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8750.mp3',
                'answer' => '<p> Ответ: сура <span class="c3">«Рассвет»</span> и её толкование:<br /> С именем Аллаха Милостивого,<span class="c6"> Милующего!<br /> «Скажи:</span> <span class="c1">“Прибегаю к защите Господа рассвета от зла того, что Он сотворил, от зла мрака, когда он наступает, от зла колдуний, дующих на узлы, от зла завистника, когда он завидует”</span>» [Сура 113 <span class="c3">«Рассвет»</span>, аяты 1–5].<span class="c6"><br /> Толкование:</span><br /> 1) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113001.mp3"></audio> <span class="c4">{قُلۡ أَعُوذُ بِرَبِّ ٱلۡفَلَقِ}</span> <span class="c3">«Скажи: прибегаю к защите Господа рассвета»</span> — скажи,<span class="c6"> о Посланник:</span> я ищу защиты у Господа рассвета.<br /> 2) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113002.mp3"></audio> <span class="c4">{مِن شَرِّ مَا خَلَقَ}</span> <span class="c3">«от зла того, что Он сотворил»</span> — от зла, которое может исходить от Его творений.<br /> 3) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113003.mp3"></audio> <span class="c4">{وَمِن شَرِّ غَاسِقٍ إِذَا وَقَبَ}</span> <span class="c3">«от зла мрака, когда он наступает»</span> — и я ищу у Аллаха защиты от зла, которое случается ночью и исходит от животных и разбойников.<br /> 4) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113004.mp3"></audio> <span class="c4">{وَمِن شَرِّ ٱلنَّفَّٰثَٰتِ فِي ٱلۡعُقَدِ}</span> <span class="c3">«от зла колдуний, дующих на узлы»</span> — и я ищу у Аллаха защиты от колдуний, которые, колдуя, дуют на узлы.<br /> 5) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113005.mp3"></audio> <span class="c4">{وَمِن شَرِّ حَاسِدٍ إِذَا حَسَدَ}</span> <span class="c3">«от зла завистника, когда он завидует»</span> — и от зла завистника, который ненавидит людей, завидуя им из-за милостей, которыми наделил их Аллах, и желает, чтобы они лишились этих милостей и чтобы с ними случилось что-то плохое. </p>',
            ],
            16 => [
                'question' => '17. Вопрос: прочитай суру «Люди» и объясни её смысл.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8870.mp3',
                'answer' => '<p> Ответ: сура <span class="c3">«Люди»</span> и её толкование:<br /> С именем Аллаха Милостивого,<span class="c6"> Милующего!<br /> «Скажи:</span> <span class="c1">“Прибегаю к защите Господа людей, Царя людей, Бога людей, от зла искусителя отступающего при поминании Аллаха, который наущает в груди людей, от джиннов и людей”</span>» [Сура 114 <span class="c3">«Люди»</span>, аяты 1–6].<span class="c6"><br /> Толкование:</span><br /> 1) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114001.mp3"></audio> <span class="c3">«Скажи: прибегаю к защите Господа людей»</span> — скажи,<span class="c6"> о Посланник:</span> я ищу защиты у Господа людей.<br /> 2) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114002.mp3"></audio> <span class="c3">«Царя людей»</span> — Он распоряжается ими как пожелает, и нет у них иного Властелина, кроме Него.<br /> 3) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114003.mp3"></audio> <span class="c3">«Бога людей»</span> — Он единственный достоин поклонения и нет никого достойного поклонения, кроме Него.<br /> 4) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114004.mp3"></audio> <span class="c3">«от зла искусителя отступающего при поминании Аллаха»</span> — от зла шайтана, который наущает людей.<br /> 5) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114005.mp3"></audio> <span class="c3">«который наущает в груди людей»</span> — он внушает свои наущения сердцам людей.<br /> 6) <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114006.mp3"></audio> <span class="c3">«от джиннов и людей»</span> — наущающие бывают из числа людей, а бывают из числа джиннов. </p>',
            ],
        ],
        5 => [
            0 => [
                'question' => '1. Вопрос: закончи хадис: «Поистине, дела оцениваются по намерениям…» и назови некоторые выводы из него.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9030.mp3',
                'answer' => '<p> Ответ: повелитель верующих Абу Хафс Умар ибн аль-Хаттаб <span class="c2">(да будет доволен им Аллах)</span> передаёт: «Я слышал, как Посланник Аллаха <span class="c2">(мир ему и благословение Аллаха)</span> сказал: <span class="c1">“Поистине, дела оцениваются по намерениям, и каждому человеку достанется лишь то, что он намеревался обрести, и кто переселялся к Аллаху и Его Посланнику, его переселение — к Аллаху и Его Посланнику, а кто переселялся ради мирских благ или женщины, на которой он желает жениться, его переселение — к тому, ради чего он переселялся”</span>» <span class="c5">[аль-Бухари; Муслим]</span>.<span class="c6"><br /> Выводы из хадиса:</span><br /> 1) для каждого дело, будь то намаз, пост, хадж или что-то другое, необходимо намерение;<br /> 2) необходима искренность намерения, то есть совершение дел ради Аллаха.<span class="c6"><br /> Хадис второй:</span> </p>',
            ],
            1 => [
                'question' => '2. Вопрос: закончи хадис: «Если кто-то внесёт в это наше дело…» и назови некоторые выводы из него.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9090.mp3',
                'answer' => '<p> Ответ: мать верующих Аиша <span class="c2">(да будет доволен ею Аллах)</span> передаёт, что Посланник Аллаха <span class="c2">(мир ему и благословение Аллаха)</span> сказал: <span class="c3">«Если кто-то внесёт в это наше дело то, что к нему не относится, то это будет отвергнуто»</span> <span class="c5">[аль-Бухари; Муслим]</span>.<span class="c6"><br /> Выводы из хадиса:</span><br /> 1) запрет вносить нововведения в религию;<br /> 2) нововведения неприемлемы, и Всевышний Аллах не примет дела-нововведения.<span class="c6"><br /> Хадис третий:</span> </p>',
            ],
            2 => [
                'question' => '3. Вопрос: закончи хадис: «Однажды, когда мы сидели у Посланника Аллаха (мир ему и благословение Аллаха)…» и назови некоторые выводы из него.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9160.mp3',
                'answer' => '<p> Ответ: ‘Умар ибн аль-Хаттаб <span class="c2">(да будет доволен им Аллах)</span> передаёт: «Однажды, когда мы сидели у Посланника Аллаха <span class="c2">(мир ему и благословение Аллаха)</span> перед нами появился человек в белоснежной одежде, с иссиня-чёрными волосами. На нём не было следов путешествия, и никто из нас не знал его. Он сел перед Пророком <span class="c2">(мир ему и благословение Аллаха)</span>,<span class="c6"> прислонившись своими коленями к его коленям и положив руки себе на бёдра и сказал:</span> <span class="c1">“О Мухаммад, расскажи мне о покорности Аллаху <span class="c2">(ислам)</span>”</span>.<span class="c6"> Он сказал:</span> <span class="c1">“Это когда ты свидетельствуешь, что нет бога, кроме Аллаха, и что Мухаммад — Посланник Аллаха, выстаиваешь молитву, даёшь очистительную подать <span class="c2">(закят)</span>, соблюдаешь пост в рамадан и совершаешь паломничество к Дому <span class="c2">(хадж)</span>, если имеешь возможность”</span>.<span class="c6"> Тот человек сказал:</span> <span class="c1">“Ты сказал правду”</span>.<span class="c6"> Мы удивились:</span> ведь он и спрашивает [Посланника Аллаха <span class="c2">(мир ему и благословение Аллаха)</span>], и подтверждает его правоту.<span class="c6"> Он сказал:</span> <span class="c1">“Расскажи мне о вере <span class="c2">(иман)</span>”</span>.<span class="c6"> Он сказал:</span> <span class="c1">“Это когда ты веруешь в Аллаха, в Его ангелов, в Его Писания, в Его посланников, в Последний День и в предопределённость и добра, и зла”</span>.<span class="c6"> Он сказал:</span> <span class="c1">“Расскажи мне о стремлении к совершенству в поклонении Аллаху <span class="c2">(ихсан)</span>”</span>. [Посланник Аллаха <span class="c2">(мир ему и благословение Аллаха)</span>] сказал: <span class="c1">“Это когда ты поклоняешься Аллаху так, как будто ты Его видишь. Ведь если ты и не видишь Его, то, воистину, Он видит тебя”</span>.<span class="c6"> Тот сказал:</span> <span class="c1">“Расскажи мне о Часе”</span>. [Посланник Аллаха <span class="c2">(мир ему и благословение Аллаха)</span>] сказал: <span class="c1">“Вопрошаемый знает о нём не больше вопрошающего”</span>.<span class="c6"> Он сказал:</span> <span class="c1">“Расскажи мне о его признаках”</span>.<span class="c6"> Он ответил:</span> <span class="c1">“Когда рабыня родит свою госпожу, и когда ты увидишь босых, раздетых, нуждающихся пастухов овец состязающимися в строительстве высоких домов”</span>. <span class="c5">[Тот человек]</span> ушёл, а спустя время [Посланник Аллаха <span class="c2">(мир ему и благословение Аллаха)</span>] сказал: <span class="c1">“‘Умар, знаешь ли, кто задавал вопросы?”</span> Я сказал: <span class="c1">“Аллаху и Его Посланнику известно лучше”</span>.<span class="c6"> Тогда он сказал:</span> <span class="c1">“Это Джибриль приходил к вам, дабы научить вас вашей религии!”</span>» <span class="c5">[Муслим]</span>.<span class="c6"><br /> Выводы из хадиса:</span><br /> 1) Упоминание пяти столпов ислама.<span class="c6"> Это:</span><br /> — свидетельство о том, что нет бога, кроме Аллаха, и что Мухаммад — Посланник Аллаха;<br /> — выстаивание молитвы;<br /> — выплата закята;<br /> — пост в месяце рамадан;<br /> — хадж к Заповедному Дому Аллаха.<br /> 2) Упоминание шести столпов веры.<span class="c6"> Это вера:</span><br /> — в Аллаха;<br /> — в Его ангелов;<br /> — в Его Писания;<br /> — в Его посланников;<br /> — в Судный день;<br /> — в предопределение всего хорошего и плохого.<br /> 3) Упоминание столпа ихсана. У него один столп — поклонение Аллаху так, будто ты Его видишь, ведь даже если ты Его не видишь, то Он видит тебя.<br /> 4) Никто, кроме Всевышнего Аллаха, не знает время наступления Судного дня.<span class="c6"><br /> Хадис четвёртый:</span> </p>',
            ],
            3 => [
                'question' => '4. Вопрос: закончи хадис: «Самой совершенной верой…» и назови некоторые выводы из него.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9360.mp3',
                'answer' => '<p> Ответ: Абу Хурайра <span class="c2">(да будет доволен им Аллах)</span> передаёт, что Посланник Аллаха <span class="c2">(мир ему и благословение Аллаха)</span> сказал: <span class="c3">«Самой совершенной верой обладают самые благонравные из верующих»</span> <span class="c5">[ат-Тирмизи; хороший достоверный хадис]</span>.<span class="c6"><br /> Выводы из хадиса:</span><br /> 1) побуждение к благонравию;<br /> 2) совершенство нрава — признак совершенства веры;<br /> 3) вера увеличивается и уменьшается.<span class="c6"><br /> Хадис пятый:</span> </p>',
            ],
            4 => [
                'question' => '5. Вопрос: закончи хадис: «Кто поклялся не Аллахом…» и назови некоторые выводы из него.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9440.mp3',
                'answer' => '<p> Ответ: Ибн Умар <span class="c2">(да будет доволен Аллах им и его отцом)</span> передаёт, что Пророк <span class="c2">(мир ему и благословение Аллаха)</span> сказал: <span class="c3">«Кто поклялся не Аллахом, тот не уверовал или придал Аллаху сотоварищей»</span> <span class="c5">[ат-Тирмизи]</span>.<span class="c6"><br /> Выводы из хадиса:</span><br /> 1) разрешается клясться только Аллахом;<br /> 2) клятва не Аллахом относится к малому многобожию.<span class="c6"><br /> Хадис шестой:</span> </p>',
            ],
            5 => [
                'question' => '6. Вопрос: закончи хадис: «Не уверует никто из вас [по-настоящему], пока не станет любить меня…» и назови некоторые выводы из него.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9510.mp3',
                'answer' => '<p> Ответ: Анас <span class="c2">(да будет доволен им Аллах)</span> передаёт, что Посланник Аллаха <span class="c2">(мир ему и благословение Аллаха)</span> сказал: <span class="c3">«Не уверует никто из вас <span class="c5">[по-настоящему]</span>, пока не станет любить меня больше, чем своих родителей, детей и всех людей вообще»</span> <span class="c5">[аль-Бухари; Муслим]</span>.<span class="c6"><br /> Выводы из хадиса:</span><br /> 1) мы обязаны любить Пророка <span class="c2">(мир ему и благословение Аллаха)</span> больше других людей;<br /> 2) это признак совершенства веры.<span class="c6"><br /> Хадис седьмой:</span> </p>',
            ],
            6 => [
                'question' => '7. Вопрос: закончи хадис: «Не уверует никто из вас [по-настоящему] до тех пор, пока не станет желать своему брату по вере…» и назови некоторые выводы из него.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9580.mp3',
                'answer' => '<p> Ответ: Анас <span class="c2">(да будет доволен им Аллах)</span> передаёт, что Посланник Аллаха <span class="c2">(мир ему и благословение Аллаха)</span> сказал: <span class="c3">«Не уверует никто из вас <span class="c5">[по-настоящему]</span> до тех пор, пока не станет желать своему брату по вере того же, чего желает он самому себе»</span> <span class="c5">[аль-Бухари; Муслим]</span>.<span class="c6"><br /> Выводы из хадиса:</span><br /> 1) верующий должен желать другим мусульманам блага, как желает он блага самому себе;<br /> 2) это — признак совершенства веры.<span class="c6"><br /> Хадис восьмой:</span> </p>',
            ],
            7 => [
                'question' => '8. Вопрос: закончи хадис: «Клянусь Тем, в Чьей руке душа моя…» и назови некоторые выводы из него.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9650.mp3',
                'answer' => '<p> Ответ: Абу Саид <span class="c2">(да будет доволен им Аллах)</span> передаёт, что Посланник Аллаха <span class="c2">(мир ему и благословение Аллаха)</span> сказал: <span class="c3">«Клянусь Тем, в Чьей руке душа моя, поистине, она соответствует трети Корана»</span> <span class="c5">[аль-Бухари]</span>.<span class="c6"><br /> Выводы из хадиса:</span><br /> 1) достоинство суры <span class="c3">«Искренность»</span>;<br /> 2) она соответствует трети Корана.<span class="c6"><br /> Хадис девятый:</span> </p>',
            ],
            8 => [
                'question' => '9. Вопрос: закончи хадис: «Слова “нет силы и способности изменить что-либо, кроме как от Аллаха”…» и назови некоторые выводы из него.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9720.mp3',
                'answer' => '<p> Ответ: Абу Муса <span class="c2">(да будет доволен им Аллах)</span> передаёт, что Посланник Аллаха <span class="c2">(мир ему и благословение Аллаха)</span> сказал: «Слова <span class="c1">“нет силы и способности изменить что-либо, кроме как от Аллаха”</span> — одно из сокровищ Рая» <span class="c5">[аль-Бухари; Муслим]</span>.<span class="c6"><br /> Выводы из хадиса:</span><br /> 1) достоинство этих слов; они — одно из сокровищ Рая;<br /> 2) раб Аллаха признаёт, что не обладает силой и способностью изменить что-либо и полностью полагается на Одного лишь Аллаха.<span class="c6"><br /> Хадис десятый:</span> </p>',
            ],
            9 => [
                'question' => '10. Вопрос: закончи хадис: «Поистине, есть в теле кусочек плоти…» и назови некоторые выводы из него.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9790.mp3',
                'answer' => '<p> Ответ: ан-Нуаман ибн Башир <span class="c2">(да будет доволен Аллах им и его отцом)</span> передаёт: «Я слышал, как Посланник Аллаха <span class="c2">(мир ему и благословение Аллаха)</span> сказал: <span class="c1">“Поистине,<span class="c6"> есть в теле кусочек плоти:</span> если он благой, то и всё тело будет благим, а если он скверный, то и всё тело будет скверным. Поистине, это — сердце”</span>» <span class="c5">[аль-Бухари; Муслим]</span>.<span class="c6"><br /> Выводы из хадиса:</span><br /> 1) праведность сердца обеспечивает праведность внешнюю и внутреннюю;<br /> 2) нужно заботиться о праведности сердца, потому что именно она делает человека праведным.<span class="c6"><br /> Хадис одиннадцатый:</span> </p>',
            ],
            10 => [
                'question' => '11. Вопрос: закончи хадис: «Тот, чьими последними словами были слова “нет бога, кроме Аллаха”…» и назови некоторые выводы из него.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9860.mp3',
                'answer' => '<p> Ответ: Муаз ибн Джабаль <span class="c2">(да будет доволен им Аллах)</span> передаёт, что Посланник Аллаха <span class="c2">(мир ему и благословение Аллаха)</span> сказал: «Тот, чьими последними словами были слова <span class="c1">“нет бога, кроме Аллаха”</span>, войдёт в Рай» <span class="c5">[Абу Дауд]</span>.<span class="c6"><br /> Выводы из хадиса:</span><br /> 1) достоинство слов <span class="c3">«нет бога, кроме Аллаха»</span> и то, что благодаря им человек входит в Рай;<br /> 2) достоинство того, чьими последними словами в этом мире были слова <span class="c3">«нет бога, кроме Аллаха»</span>.<span class="c6"><br /> Хадис двенадцатый:</span> </p>',
            ],
            11 => [
                'question' => '12. Вопрос: закончи хадис: «Верующий не является очерняющим, проклинающим…» и назови некоторые выводы из него.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9940.mp3',
                'answer' => '<p> Ответ: Абдуллах ибн Масуд <span class="c2">(да будет доволен им Аллах)</span> передаёт, что Посланник Аллаха <span class="c2">(мир ему и благословение Аллаха)</span> сказал: <span class="c3">«Верующий не является очерняющим, проклинающим, совершающим непристойности и сквернословящим»</span> <span class="c5">[ат-Тирмизи]</span>.<span class="c6"><br /> Выводы из хадиса:</span><br /> 1) запрет всех ложных и скверных слов;<br /> 2) это свойства языка верующего.<span class="c6"><br /> Хадис тринадцатый:</span> </p>',
            ],
            12 => [
                'question' => '13. Вопрос: закончи хадис: «К признакам совершенства исповедания религии человеком относится…» и назови некоторые выводы из него.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10020.mp3',
                'answer' => '<p> Ответ: Абу Хурайра <span class="c2">(да будет доволен им Аллах)</span> передаёт, что Посланник Аллаха <span class="c2">(мир ему и благословение Аллаха)</span> сказал: <span class="c3">«К признакам совершенства исповедания религии человеком относится оставление им того, что его не касается»</span> <span class="c5">[ат-Тирмизи и другие]</span>.<span class="c6"><br /> Выводы из хадиса:</span><br /> 1) не следует лезть в дела других людей мирские и религиозные, которые нас не касаются;<br /> 2) оставление того, что нас не касается, — признак совершенства исповедания религии.<span class="c6"><br /> Хадис четырнадцатый:</span> </p>',
            ],
            13 => [
                'question' => '14. Вопрос: закончи хадис: «Кто прочитает букву из Книги Аллаха…» и назови некоторые выводы из него.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10100.mp3',
                'answer' => '<p> Ответ: Абдуллах ибн Масуд передаёт, что Пророк <span class="c2">(мир ему и благословение Аллаха)</span> сказал: «Кто прочитает букву из Книги Аллаха, тому запишется одно благое дело, а за каждое благое дело воздаётся десятикратно. И я не говорю, что <span class="c1">“алиф, лям, мим”</span> — это одна буква. Нет, <span class="c1">“алиф” — это буква, “лям”</span> — это буква и “мим” — это буква» <span class="c5">[ат-Тирмизи]</span>.<span class="c6"><br /> Выводы из хадиса:</span><br /> 1) достоинство чтения Корана;<br /> 2) за каждую прочитанную букву записывается одно доброе дело. </p>',
            ],
        ],
        6 => [
            0 => [
                'question' => '1. Вопрос: каков этикет по отношению к Аллаху?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10190.mp3',
                'answer' => '<p> Ответ: 1) возвеличивание Его;<br /> 2) поклонение Ему Одному без придавания Ему сотоварищей;<br /> 3) покорность Ему;<br /> 4) отказ от ослушания Его;<br /> 5) благодарность Ему и восхваление Его за Его бесчисленные милости;<br /> 6) терпение в отношении Его предопределения. </p>',
            ],
            1 => [
                'question' => '2. Вопрос: каков этикет по отношению к Посланнику (мир ему и благословение Аллаха)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10270.mp3',
                'answer' => '<p> Ответ: 1) следование его примеру;<br /> 2) покорность ему;<br /> 3) отказ от ослушания его;<br /> 4) вера в то, что он говорил;<br /> 5) отказ от нововведений, то есть добавления чего-либо к его Сунне;<br /> 6) мы должны любить его больше самих себя и больше всех людей;<br /> 7) почтительное отношение к нему и поддержка его и его Сунны. </p>',
            ],
            2 => [
                'question' => '3. Вопрос: каков этикет по отношению к родителям?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10360.mp3',
                'answer' => '<p> Ответ: 1) покорность им в том, что не является ослушанием Аллаха;<br /> 2) прислуживание родителям;<br /> 3) помощь родителям;<br /> 4) обеспечение нужд родителей;<br /> 5) обращение к Аллаху с мольбой за родителей;<br /> 6) благовоспитанность в словах; нельзя говорить родителям даже <span class="c3">«уф»</span>, хотя это самое безобидное из нехороших слов;<br /> 7) следует улыбаться родителям и не хмуриться им в лицо;<br /> 8) нельзя повышать голос над голосами родителей, нужно внимательно слушать их, не перебивать, не звать их по именам, но говорить <span class="c3">«папа»</span> и <span class="c3">«мама»</span>;<br /> 9) следует испрашивать разрешения зайти в комнату родителей;<br /> 10) следует целовать руку и голову родителей. </p>',
            ],
            3 => [
                'question' => '4. Вопрос: как нужно поддерживать родственные связи?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10490.mp3',
                'answer' => '<p> Ответ: 1) навещать родных — брата, сестру, дядю и тётю со стороны папы и со стороны мамы, а также остальных родственников;<br /> 2) делать им добро словами и делами и помогать им;<br /> 3) поддерживать связь с ними и интересоваться их положением. </p>',
            ],
            4 => [
                'question' => '5. Вопрос: как следует вести себя с братьями и сёстрами по вере?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10550.mp3',
                'answer' => '<p> Ответ: 1) любить хороших людей и дружить с ними;<br /> 2) избегать дружбы и общения с плохими людьми;<br /> 3) здороваться с братьями по вере и обмениваться рукопожатием;<br /> 4) навещать их, если они заболеют, и просить у Аллаха исцеления для них;<br /> 5) произносить благопожелание чихнувшему;<br /> 6) принимать приглашение в гости от них;<br /> 7) давать им добрый совет;<br /> 8) помогать им, если их притесняют, и останавливать их, если сами они поступают несправедливо;<br /> 10) желать брату по вере того же, чего желаем мы самим себе;<br /> 11) помогать им, когда они нуждаются в помощи;<br /> 12) не обижать их ни словом, ни делом;<br /> 13) хранить их секреты;<br /> 14) не ругать их, не злословить о них, не относиться к ним пренебрежительно, не завидовать им, не выслеживать их, не обманывать их. </p>',
            ],
            5 => [
                'question' => '6. Вопрос: каков этикет по отношению к соседям?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10710.mp3',
                'answer' => '<p> Ответ: 1) делать добро соседу словом и делом и помогать ему, когда он нуждается в помощи;<br /> 2) поздравлять его с праздником, свадьбой и другими радостными событиями;<br /> 3) навещать его, если он заболел, и выражать ему соболезнования, если он понёс утрату;<br /> 4) угощать его едой, которую мы готовим, по мере возможности;<br /> 5) не обижать его ни словом, ни делом.<br /> 6) не беспокоить его шумом, не выслеживать его и проявлять терпение в отношении него. </p>',
            ],
            6 => [
                'question' => '7. Вопрос: каков этикет по отношению к приглашающему и к гостям?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10800.mp3',
                'answer' => '<p> Ответ: 1) принимать приглашение в гости;<br /> 2) желая посетить кого-то, спрашивать разрешения и договариваться на определённое время;<br /> 3) испрашивать разрешения, прежде чем войти;<br /> 4) не задерживаться в гостях;<br /> 5) не разглядывать обитателей дома;<br /> 6) радушно принимать гостя, с приветливым выражением лица и наилучшими словами приветствия;<br /> 7) усаживать гостя на лучшее место;<br /> 8) оказывать ему гостеприимство, предлагая ему еду и напитки. </p>',
            ],
            7 => [
                'question' => '8. Вопрос: каков этикет, во время болезни и посещения больного?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10900.mp3',
                'answer' => '<p> Ответ: 1) чувствуя боль, возлагать правую руку на больное место и говорить три раза <span class="c3">«бисмиЛлях»</span>,<span class="c6"> а потом семь раз:</span> «Прибегаю к защите величия Аллаха и Его могущества от зла того, что я ощущаю и чего опасаюсь <span class="c2">(‘Аузу би-‘иззати-Лляхи ва кудрати-хи мин шарри ма аджиду ва ухазир)</span>»;<br /> 2) проявлять довольство и терпение в отношении предопределённого Аллахом;<br /> 3) спешить навестить заболевшего брата по вере, обратиться с мольбой за него и не засиживаться у него;<br /> 4) читать ему заклинание <span class="c2">(рукъю)</span> без просьб с его стороны;<br /> 5) наказывать ему терпеть и обращаться к Аллаху с мольбами,<span class="c6"> а также молиться и очищаться по мере возможностей;<br /> 6) обращаться к Аллаху с такой мольбой за больного семь раз:</span> «<span class="c1">“Прошу Великого Аллаха, Господа великого Трона, исцелить тебя!”</span> <span class="c2">(Ас’алю-Ллаха-ль-‘Азыма, Рабба-ль-‘арши-ль-‘азыми ан йашфийа-ка)</span>». </p>',
            ],
            8 => [
                'question' => '9. Вопрос: каков этикет, в приобретении знаний?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10990.mp3',
                'answer' => '<p> Ответ: 1) искренность намерения: мы приобретаем знания ради Аллаха;<br /> 2) поступать согласно приобретённым знаниям;<br /> 3) уважать учителя и относиться к нему с почтением, как в его присутствии, так и в его отсутствие;<br /> 4) сидеть пристойным образом в присутствии учителя;<br /> 5) внимательно слушать его и не перебивать его во время урока;<br /> 6) задавать вопросы вежливо и воспитанно;<br /> 7) не называть учителя по имени. </p>',
            ],
            9 => [
                'question' => '10. Вопрос: каков этикет во время собраний?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11090.mp3',
                'answer' => '<p> Ответ: 1) приветствовать присутствующих;<br /> 2) садиться там, где есть свободное место, не поднимая никого с его места и не садясь между двумя сидящими иначе как с их разрешения;<br /> 3) садиться плотнее друг к другу, чтобы оставалось место другим;<br /> 4) не перебивать выступающих на собрании;<br /> 5) испрашивать разрешения и произносить исламское приветствие на прощание перед уходом;<br /> 6) по окончании собрания произносить мольбу-<span class="c6">искупление собрания:</span> 7) «Пречист Ты, о Аллах, и хвала Тебе, нет бога, кроме Тебя, прошу у Тебя прощения и каюсь пред Тобой <span class="c2">(Субхана-ка-Ллахумма ва би-хамди-ка, ля иляха илля Анта астагфиру-ка ва атубу иляйка)</span>». </p>',
            ],
            10 => [
                'question' => '11. Вопрос: каков этикет, связанный со сном?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11180.mp3',
                'answer' => '<p> Ответ: 1) рано отходить ко сну;<br /> 2) ложиться спать в состоянии ритуальной чистоты;<br /> 3) не спать на животе;<br /> 4) спать на правом боку, подкладывая правую руку под правую щёку;<br /> 5) отряхивать постель перед сном;<br /> 6) произносить слова поминания Аллаха, которые предписано произносить перед сном — аят <span class="c3">«Аль-курси»</span>, и суры 112, 113 и 114 по три раза,<span class="c6"> а также слова:</span> «С именем Твоим, о Аллах, умираю и оживаю <span class="c2">(Би-смика-Ллахумма амуту ва ахйа)</span>»;<br /> 7) просыпаться для совершения утренней молитвы <span class="c2">(фаджр)</span>;<br /> 8) после пробуждения ото сна говорить: «Хвала Аллаху, Который оживил нас после того, как умертвил, и к Нему возвращение <span class="c2">(Аль-хамду ли-Лляхи-ллязи ахйана ба‘да ма амата-на ва иляйхи-н-нушур)</span>». </p>',
            ],
            11 => [
                'question' => '12. Вопрос: каков этикет во время принятия пищи?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11290.mp3',
                'answer' => '<p> Ответ:<br /> 1) есть и пить с намерением набраться сил для покорности Аллаху;<br /> 2) мыть руки перед едой;<br /> 3) говорить: <span class="c3">«БисмиЛлях»</span>, есть правой рукой, брать то, что лежит прямо перед нами, и не брать еду с центра блюда или с того края,<span class="c6"> который находится напротив другого человека;<br /> 4) если мы забыли сказать:</span> <span class="c3">«БисмиЛлях»</span> перед едой,<span class="c6"> говорим:</span> «С именем Аллаха в начале и в конце её <span class="c2">(Бисми-Лляхи фи аввали-хи ва ахыри-хи)</span>»;<br /> 5) довольствоваться имеющейся пищей,<span class="c6"> не порицать пищу:</span> есть её, если она нам нравится, и оставлять, если она нам не нравится;<br /> 6) не переедать;<br /> 7) не дуть на пищу и питьё, а просто оставлять их, чтобы они остыли;<br /> 8) собираться вместе с семьёй или гостями во время трапез;<br /> 9) не начинать есть, пока не начнут старшие;<br /> 10) произносить имя Аллаха <span class="c2">(говорить: <span class="c3">«БисмиЛлях»</span>)</span> перед питьём и пить сидя в три приёма;<br /> 11) восхвалять Аллаха после еды. </p>',
            ],
            12 => [
                'question' => '13. Вопрос: каков этикет, связанный с одеждой?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11440.mp3',
                'answer' => '<p> Ответ: 1) начинать одеваться с правой стороны, восхваляя при этом Аллаха;<br /> 2) не опускать одежду ниже щиколоток;<br /> 3) мальчики не надевают одежду, предназначенную для девочек, а девочки не надевают одежду, предназначенную для мальчиков;<br /> 4) не уподобляться в одежде неверующим или нечестивым людям;<br /> 5) произносить имя Аллаха, когда снимаем одежду;<br /> 6) надевать обувь сначала на правую ногу, а потом — на левую; </p>',
            ],
            13 => [
                'question' => '14. Вопрос: каков этикет во время пользования транспортом?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11540.mp3',
                'answer' => '<p> Ответ: 1) говорить: «С именем Аллаха, хвала Аллаху <span class="c2">(бисмиЛлях аль-хамду лиЛлях)</span>» и: <span class="c3">«Пречист Тот, Кто подчинил нам это, ведь нам такое не под силу, и, поистине, мы вернёмся к Господу нашему»</span> [Сура 43 <span class="c3">«Украшения»</span>, аяты 13–14].<br /> 2) проезжая мимо мусульманина, поприветствовать его. </p>',
            ],
            14 => [
                'question' => '15. Вопрос: каков этикет на дороге?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11590.mp3',
                'answer' => '<p> Ответ: 1) идти спокойно и скромно, по правой стороне дороги;<br /> 2) приветствовать встречных;<br /> 3) опускать взор и никого не обижать;<br /> 4) побуждать к одобряемому и удерживать от порицаемого;<br /> 5) убирать с дороги то, что мешает ходить людям. </p>',
            ],
            15 => [
                'question' => '16. Вопрос: каков этикет при входе и выходе из дома?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11670.mp3',
                'answer' => '<p> Ответ: 1) выходить из дома с левой ноги со словами: «О Аллах, поистине, я прошу у Тебя защиты от того, чтобы впасть в заблуждение или быть введённым в заблуждение, от того, чтобы самому допустить ошибку, и от того, чтобы меня склонили к ошибке, от того, чтобы поступать несправедливо, и от того, чтобы со мной поступали несправедливо, от того, чтобы поступать как невежды, и от того, чтобы со мной поступали невежественно <span class="c2">(Аллахумма, инни а‘узу би-ка ан адылля ау удалля, ау азилля ау узалля, ау азлима ау узляма, ау аджхаля ау йуджхаля ‘аляййа)</span>»; 2) входить в дом с правой ноги со словами: «С именем Аллаха мы зашли и с именем Аллаха вышли, и на Господа нашего, уповаем мы <span class="c2">(бисми-Лляхи валяджна ва бисми-Лляхи хараджна ва ‘аля Рабби-на таваккальна)</span>»;<br /> 3) начинать при входе в дом с использования сивака, а потом приветствовать обитателей дома. </p>',
            ],
            16 => [
                'question' => '17. Вопрос: каков этикет при посещении туалета?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11730.mp3',
                'answer' => '<p> Ответ: 1) входить с левой ноги;<br /> 2) сказать перед входом: «С именем Аллаха, о Аллах, поистине, я прошу у Тебя защиты от шайтанов мужского и женского пола <span class="c2">(Бисми-Лляхи, Аллахумма инни а‘узу би-ка мина-ль-хубуси ва-ль-хабаис)</span>»;<br /> 3) не брать с собой в туалет ничего из того, в чём или на чём есть поминание Аллаха;<br /> 4) укрываться от чужих глаз во время справления нужды;<br /> 5) не разговаривать в месте справления нужды;<br /> 6) не поворачиваться в сторону киблы ни передом, ни задом при справлении большой или малой нужды;<br /> 7) использовать только левую руку для очищения после справления нужды;<br /> 8) не справлять нужду на дороге, по которой ходят люди, и в тени,<span class="c6"> которой они пользуются;<br /> 9) мыть руки после справления нужды;<br /> 10) выходить с правой ноги со словами:</span> «Прости мне <span class="c2">(Гуфрана-ка)</span>». </p>',
            ],
            17 => [
                'question' => '18. Вопрос: каков этикет при посещении мечети?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11860.mp3',
                'answer' => '<p> Ответ: 1) входить в мечеть с правой ноги со словами: «С именем Аллаха. О Аллах, открой для меня врата Твоей милости <span class="c2">(БисмиЛлях Аллахумма-фтах ли абваба рахмати-ка)</span>»;<br /> 2) не садиться до совершения двух ракатов приветствия мечети;<br /> 3) не проходить перед молящимися, не объявлять в мечети о пропаже,<span class="c6"> не продавать и не покупать в мечети;<br /> 4) выходить из мечети с левой ноги со словами:</span> «О Аллах, поистине, я прошу Тебя о благах, даруемых Тобой <span class="c2">(Аллахумма, инни ас’алю-ка мин фадли-ка)</span>». </p>',
            ],
            18 => [
                'question' => '19. Вопрос: каков этикет, связанный с приветствием?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11930.mp3',
                'answer' => '<p> Ответ: 1) встречая мусульманина,<span class="c6"> приветствовать его исламским приветствием:</span> «Мир вам, милость Аллаха и благодать Его <span class="c2">(Ассаляму алейкум ва рахмату-Ллахи ва баракату-ху)</span>», не использовать другие приветствия вместо него и не ограничиваться приветственным жестом.<br /> 2) улыбаться тому, кого мы приветствуем;<br /> 3) обмениваться рукопожатием <span class="c2">(правой рукой)</span>;<br /> 4) отвечать на приветствие лучшим <span class="c2">(более полным)</span> или таким же приветствием;<br /> 5) не приветствовать неверующих первыми,<span class="c6"> а на их приветствие отвечать:</span> <span class="c3">«И вам»</span>;<br /> 6) младшему следует приветствовать старшего, едущему следует приветствовать идущего, идущему следует приветствовать сидящего, а малочисленной группе следует приветствует многочисленную. </p>',
            ],
            19 => [
                'question' => '20. Вопрос: каков этикет, связанный с испрашиванием разрешения войти?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12020.mp3',
                'answer' => '<p> Ответ: 1) испрашивать разрешения до того, как войти в какое-то место;<br /> 2) испрашивать разрешения войти не более трёх раз, после чего уходить <span class="c2">(если мы не получили разрешение войти)</span>;<br /> 3) стучать в дверь негромко и вставать не прямо напротив двери, а справа или слева от неё;<br /> 4) не входить в комнату к родителям или ещё к кому-то, не спросив разрешения войти, особенно до наступления времени молитвы-фаджр, во время полуденного отдыха и после молитвы-иша;<br /> 5) в места, в которых никто не живёт, вроде больницы или магазина, можно входить, не спрашивая разрешения. </p>',
            ],
            20 => [
                'question' => '21. Вопрос: каков этикет, связанный с милосердием к животным?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12100.mp3',
                'answer' => '<p> Ответ: 1) кормить и поить животных;<br /> 2) милосердное отношение к животным и жалость к ним; нельзя нагружать их тем, что им не под силу;<br /> 3) никоим образом не мучить животных. </p>',
            ],
            21 => [
                'question' => '22. Вопрос: каков этикет, связанный со спортом?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12160.mp3',
                'answer' => '<p> Ответ: 1) заниматься спортом с намерением укрепить своё тело для покорности Аллаху и угодных Аллаху дел;<br /> 2) не играть во время молитвы;<br /> 3) мальчикам не заниматься спортом вместе с девочками;<br /> 4) носить спортивную форму, закрывающую аурат;<br /> 5) остерегаться запретных видов спорта, предполагающих удары по лицу и открытие аурата. </p>',
            ],
            22 => [
                'question' => '23. Вопрос: каков этикет, связанная с шутками?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12240.mp3',
                'answer' => '<p> Ответ: 1) шутка не должна быть ложью;<br /> 2) шутки не должны быть злыми, обидными, пугающими;<br /> 3) не следует слишком много шутить. </p>',
            ],
            23 => [
                'question' => '24. Вопрос: каков этикет, связанный с чиханием?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12300.mp3',
                'answer' => '<p> Ответ: 1) прикрывать рот рукой,<span class="c6"> одеждой или платком при чихании;<br /> 2) говорить после чихания:</span> «Хвала Аллаху <span class="c2">(аль-хамду лиЛлях)</span>»;<br /> 3) услышавший нас говорит нам: «Да помилует тебя Аллах <span class="c2">(йархамукаЛлах)</span>»;<br /> 4) мы говорим в ответ: «Да ведёт вас Аллах правильным путём и да исправит Он ваши помыслы <span class="c2">(Йахди-куму-Ллаху ва йуслиху баля-кум)</span>». </p>',
            ],
            24 => [
                'question' => '25. Вопрос: каков этикет, связанный с зеванием?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12360.mp3',
                'answer' => '<p> Ответ: 1) стараться подавлять зевоту;<br /> 2) не говорить громко: <span class="c3">«А-а-ах»</span> во время зевания;<br /> 3) прикрывать рот рукой. </p>',
            ],
            25 => [
                'question' => '26. Вопрос: каков этикет во время чтения Корана?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12420.mp3',
                'answer' => '<p> Ответ: 1) ритуальная чистота, то есть совершение малого омовения перед чтением;<br /> 2) сидеть с достоинством и торжественным спокойствием;<br /> 3) испрашивать у Аллаха защиты от шайтана перед чтением;<br /> 4) размышлять над тем, что мы читаем. </p>',
            ],
        ],
        7 => [
            0 => [
                'question' => '1. Вопрос: назови достоинства благонравия.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12500.mp3',
                'answer' => '<p> Ответ: Пророк <span class="c2">(мир ему и благословение Аллаха)</span> сказал: <span class="c3">«Самой совершенной верой обладают самые благонравные из верующих»</span> <span class="c5">[ат-Тирмизи; Ахмад]</span>. </p>',
            ],
            1 => [
                'question' => '2. Вопрос: почему мы соблюдаем нравственные нормы ислама?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12530.mp3',
                'answer' => '<p> Ответ: 1) это помогает нам снискать любовь Всевышнего;<br /> 2) это помогает заслужить любовь людей;<br /> 3) в Судный день не будет на Весах на чаше с благими делами ничего тяжелее благонравия;<br /> 4) награда за благонравие умножается;<br /> 5) это признак совершенства веры. </p>',
            ],
            2 => [
                'question' => '3. Вопрос: откуда мы берём нравственные нормы?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12600.mp3',
                'answer' => '<p> Ответ: из Корана.<span class="c6"> Всевышний Аллах сказал:</span> <span class="c3">«Поистине, этот Коран указывает самый правильный путь»</span> [Сура 17 <span class="c3">«Ночное путешествие»</span>, аят 9]. И из Сунны. Посланник Аллаха <span class="c2">(мир ему и благословение Аллаха)</span> сказал: <span class="c3">«Поистине, я был послан довести до совершенства нравственные достоинства»</span> <span class="c5">[Ахмад]</span>. </p>',
            ],
            3 => [
                'question' => '4. Вопрос: что такое ихсан и каковы его проявления?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12640.mp3',
                'answer' => '<p> Ответ: ихсан — это когда ты постоянно помнишь о том, что Аллах наблюдает за тобой, и делаешь добро творениям.<br /> Пророк <span class="c2">(мир ему и благословение Аллаха)</span> сказал: <span class="c3">«Поистине, Аллах предписал ихсан во всём»</span> <span class="c5">[Муслим]</span>.<span class="c6"><br /> К видам ихсана относятся:</span><br /> — ихсан в поклонении Аллаху, то есть искреннее поклонение Ему Одному;<br /> — ихсан к родителям словами и делами;<br /> — ихсан к родным и близким;<br /> — ихсан к соседям;<br /> — ихсан к сиротам и беднякам;<br /> — ихсан к тому, кто поступил с тобой некрасиво;<br /> — ихсан в словах;<br /> — ихсан в споре;<br /> — ихсан к животным. </p>',
            ],
            4 => [
                'question' => '5. Вопрос: что является противоположностью ихсана?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12780.mp3',
                'answer' => '<p> Ответ: противоположно ихсану, когда человек поступает неподобающе, скверно.<br /> Например, он отказывается от искренности в поклонении Аллаху.<br /> Или же он непочтителен к родителям.<br /> Или порывает родственные связи.<br /> Или скверно относится к соседям.<br /> Или он отказывается делать добро бедным и нуждающимся. Или совершает иные скверные поступки. </p>',
            ],
            5 => [
                'question' => '6. Вопрос: каковы виды и проявления верности (амана)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12860.mp3',
                'answer' => '<p> Ответ:<br /> 1) Верность в соблюдении прав Аллаха.<span class="c6"><br /> Её проявления:</span> верность в совершении обрядов — намаза, закята, поста, хаджа и других религиозных обязанностей.<span class="c6"><br /> 2) Верность в соблюдении прав людей:</span><br /> — оберегание чести людей;<br /> — оберегание их имущества;<br /> — оберегание их жизни;<br /> — оберегание их секретов и всего того, что они вверили тебе.<br /> Всевышний Аллах сказал,<span class="c6"> перечисляя качества преуспевших:</span> <span class="c3">«которые оберегают вверенное им и соблюдают договоры»</span> [Сура 23 <span class="c3">«Верующие»</span>, аят 8]. </p>',
            ],
            6 => [
                'question' => '7. Вопрос: что противоположно верности?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12980.mp3',
                'answer' => '<p> Ответ: вероломство, то есть несоблюдение прав Всевышнего Аллаха и прав людей.<br /> Пророк <span class="c2">(мир ему и благословение Аллаха)</span> сказал: <span class="c3">«Признаков лицемерия три»</span> — и среди них упомянул: <span class="c3">«когда ему доверяют, он поступает вероломно»</span> <span class="c5">[аль-Бухари; Муслим]</span>. </p>',
            ],
            7 => [
                'question' => '8. Вопрос: что такое правдивость?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13020.mp3',
                'answer' => '<p> Ответ: это когда мы говорим всё как оно есть, или когда наши слова соответствуют действительности.<span class="c6"><br /> К её проявлениям относится:</span><br /> — правдивость в беседах с людьми;<br /> — правдивость в обещаниях;<br /> — правдивость во всех словах и действиях.<br /> Пророк <span class="c2">(мир ему и благословение Аллаха)</span> сказал: <span class="c3">«Поистине, правдивость приводит к благочестию, и, поистине, благочестие приводит к Раю, и будет человек говорить правду и стараться быть правдивым, пока не будет <span class="c5">[записан у Аллаха как]</span> правдивейший»</span> <span class="c5">[аль-Бухари; Муслим]</span>. </p>',
            ],
            8 => [
                'question' => '9. Вопрос: что противоположно правдивости?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13100.mp3',
                'answer' => '<p> Ответ: ложь, в том числе возведение лжи на людей, нарушение обещаний, лжесвидетельство.<br /> Пророк <span class="c2">(мир ему и благословение Аллаха)</span> сказал: <span class="c3">«Поистине, лживость приводит к грехам, и, поистине, грехи приводят к Огню, и станет человек лгать, пока не будет записан пред Аллахом как отъявленный лжец»</span> <span class="c5">[аль-Бухари; Муслим]</span>. Пророк <span class="c2">(мир ему и благословение Аллаха)</span> сказал: <span class="c3">«Признаков лицемерия три»</span> — и среди них упомянул: <span class="c3">«говоря, человек лжёт, обещая, нарушает обещание»</span> <span class="c5">[аль-Бухари; Муслим]</span>. </p>',
            ],
            9 => [
                'question' => '10. Вопрос: назови виды терпения.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13140.mp3',
                'answer' => '<p> Ответ: — терпение в покорности Аллаху;<br /> — терпение в воздержании от ослушания Аллаха;<br /> — терпение в отношении неприятного нам предопределения и восхваление Аллаха в любом случае.<span class="c6"><br /> Всевышний Аллах сказал:</span> <span class="c3">«Аллах любит терпеливых»</span> [Сура 3 <span class="c3">«Род Имрана»</span>, аят 146]. Пророк <span class="c2">(мир ему и благословение Аллаха)</span> сказал: <span class="c3">«Сколь удивительно положение верующего! Всё в его положении — благо для него, и не дано это никому, кроме верующего. Если с ним случается что-то хорошее, он благодарит Аллаха, и это становится для него благом. А если его постигает беда, он проявляет терпение, и это также становится для него благом»</span> <span class="c5">[Муслим]</span>. </p>',
            ],
            10 => [
                'question' => '11. Вопрос: что противоположно терпению?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13210.mp3',
                'answer' => '<p> Ответ: ему противоположно отсутствие терпения в покорности Аллаху, воздержании от ослушания Его и недовольство в отношении предопределённого словами или действиями.<br /> К его проявлениям относится,<span class="c6"> когда человек:</span><br /> — желает себе смерти;<br /> — бьёт себя по щекам;<br /> — рвёт на себе одежду;<br /> — рвёт на себе волосы;<br /> — призывает на себя погибель.<br /> Пророк <span class="c2">(мир ему и благословение Аллаха)</span> сказал: <span class="c3">«Воздаяние соответствует испытаниям. Поистине, когда Аллах любит каких-то людей, Он подвергает их испытаниям, и кто проявит довольство, тому довольство, а кто проявит недовольство, тому недовольство»</span> <span class="c5">[ат-Тирмизи; Ибн Маджа]</span>. </p>',
            ],
            11 => [
                'question' => '12. Вопрос: расскажи о взаимопомощи.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13310.mp3',
                'answer' => '<p> Ответ: это помощь людей друг другу в хорошем и правильном.<span class="c6"><br /> Виды взаимопомощи:</span><br /> — взаимопомощь в восстановлении ущемлённых прав;<br /> — взаимопомощь в отпоре притеснителю;<br /> — взаимопомощь в удовлетворении нужд и потребностей людей;<br /> — взаимопомощь во всяком благе;<br /> — отказ от взаимопомощи в грехе, причинении вреда людям и агрессии.<span class="c6"><br /> Всевышний Аллах сказал:</span> <span class="c3">«Помогайте друг другу в благочестии и богобоязненности, но не помогайте друг другу в грехе и вражде. Бойтесь Аллаха, ведь Аллах суров в наказании»</span> [Сура 5 <span class="c3">«Трапеза»</span>, аят 2]. Пророк <span class="c2">(мир ему и благословение Аллаха)</span> сказал: <span class="c3">«Верующий для верующего — как кирпичи в одном строении, укрепляющие и поддерживающие друг друга»</span> <span class="c5">[аль-Бухари; Муслим]</span>. И Пророк <span class="c2">(мир ему и благословение Аллаха)</span> сказал: <span class="c3">«Мусульманин мусульманину брат. Он не притесняет его и не предаёт. Аллах будет помогать Своему рабу до тех пор, пока сам он помогает своему брату по вере. Того, кто избавит верующего от одной из печалей мира этого, Аллах избавит от одной из печалей Судного дня. А того, кто покроет мусульманина, Аллах покроет в Судный день»</span> <span class="c5">[аль-Бухари; Муслим]</span>. </p>',
            ],
            12 => [
                'question' => '13. Вопрос: назови виды стыдливости.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13420.mp3',
                'answer' => '<p> Ответ: 1) стыдливость пред Аллахом — мы не ослушиваемся Его;<br /> 2) стыдливость перед людьми, в том числе отказ от злословия и открывания аурата.<br /> Посланник Аллаха <span class="c2">(мир ему и благословение Аллаха)</span> сказал: «Вера имеет более семидесяти <span class="c5">[или: более шестидесяти]</span> ответвлений. Наилучшее из них — слова <span class="c1">“Нет бога, кроме Аллаха”</span>, а наименьшее — устранение с дороги того, что мешает проходить людям, и стыдливость — одно из ответвлений веры» <span class="c5">[Муслим]</span>. </p>',
            ],
            13 => [
                'question' => '14. Вопрос: назови виды милосердия.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13470.mp3',
                'answer' => '<p> Ответ: — милосердие к пожилым людям и уважение к ним.<br /> — милосердие к младшим и детям;<br /> — милосердие к бедным и нуждающимся;<br /> — милосердие к животным — мы кормим их и не обижаем.<br /> Пророк <span class="c2">(мир ему и благословение Аллаха)</span> сказал: <span class="c3">«В своей любви,<span class="c6"> милосердии и сочувствии друг к другу верующие подобны единому телу:</span> когда одну из частей его поражает болезнь, всё тело отзывается бессонницей и горячкой»</span> <span class="c5">[аль-Бухари; Муслим]</span>. И Посланник Аллаха <span class="c2">(мир ему и благословение Аллаха)</span> сказал: <span class="c3">«Милосердных помилует Милостивый. Проявляйте милосердие к тем, кто на земле, и помилует вас Тот, Кто в небесах»</span> <span class="c5">[Абу Дауд; ат-Тирмизи]</span>. </p>',
            ],
            14 => [
                'question' => '15. Вопрос: какие виды любви бывают?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13550.mp3',
                'answer' => '<p> Ответ: любовь к Всевышнему Аллаху.<span class="c6"><br /> Всевышний Аллах сказал:</span> <span class="c3">«Те, которые уверовали, больше <span class="c5">[всего]</span> любят Аллаха»</span> [Сура 2 <span class="c3">«Корова»</span>, аят 165].<br /> Любовь к Пророку <span class="c2">(мир ему и благословение Аллаха)</span>.<br /> Посланник Аллаха <span class="c2">(мир ему и благословение Аллаха)</span> сказал: <span class="c3">«Не уверует никто из вас <span class="c5">[по-настоящему]</span>, пока не станет любить меня больше, чем своих родителей, детей и всех людей вообще»</span> <span class="c5">[аль-Бухари]</span>.<span class="c6"><br /> Любовь к верующим:</span> мы желаем им блага так же, как желаем его самим себе.<br /> Пророк <span class="c2">(мир ему и благословение Аллаха)</span> сказал: <span class="c3">«Не уверует никто из вас <span class="c5">[по-настоящему]</span> до тех пор, пока не станет желать своему брату по вере того же, чего желает он самому себе»</span> <span class="c5">[аль-Бухари]</span>. </p>',
            ],
            15 => [
                'question' => '16. Вопрос: что такое приветливость?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13630.mp3',
                'answer' => '<p> Ответ: это приветливое выражение лица, улыбка и проявления радости и радушия при встрече с людьми.<br /> Она является противоположностью хмурости, которая отталкивает людей от нас.<br /> О достоинстве приветливости говорится в хадисах. Так, Абу Зарр <span class="c2">(да будет доволен им Аллах)</span> передаёт: «Пророк <span class="c2">(мир ему и благословение Аллаха)</span> сказал мне: <span class="c1">“Не пренебрегайте ни одним благим делом, даже если речь идёт о том, чтобы встретить брата по вере с приветливым выражением лица”</span>» <span class="c5">[Муслим]</span>. Посланник Аллаха <span class="c2">(мир ему и благословение Аллаха)</span> сказал: <span class="c3">«Когда ты улыбаешься своему брату по вере, это запишется тебе как поданная милостыня»</span> <span class="c5">[ат-Тирмизи]</span>. </p>',
            ],
            16 => [
                'question' => '17. Вопрос: что такое зависть?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13690.mp3',
                'answer' => '<p> Ответ: это когда мы желаем, чтобы другой лишился какого-то блага или чтобы у другого не было какого-то блага.<span class="c6"><br /> Всевышний Аллах сказал:</span> <span class="c3">«и от зла завистника, когда он завидует»</span> [Сура 113 <span class="c3">«Рассвет»</span>, аят 5].<br /> Анас ибн Малик <span class="c2">(да будет доволен им Аллах)</span> передаёт, что Посланник Аллаха <span class="c2">(мир ему и благословение Аллаха)</span> сказал: <span class="c3">«Откажитесь от взаимной ненависти, не завидуйте друг другу, не поворачивайтесь друг к другу спиной и будьте, о рабы Аллаха, братьями!»</span> <span class="c5">[аль-Бухари; Муслим]</span>. </p>',
            ],
            17 => [
                'question' => '18. Вопрос: что такое насмешки?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13740.mp3',
                'answer' => '<p> Ответ: это насмешки над братом-мусульманином и уничижительное отношение к нему. Всё это не дозволено.<br /> Всевышний Аллах сказал,<span class="c6"> запрещая это:</span> <span class="c3">«О те, которые уверовали! Пусть одни люди не насмехаются над другими, ведь может быть, те лучше них. И пусть одни женщины не насмехаются над другими, ведь может быть, те лучше них. Не обижайте друг друга и не называйте друг друга оскорбительными прозвищами. Скверно называться нечестивцем после того, как уверовал. А те, которые не раскаются, окажутся несправедливыми»</span> [Сура 49 <span class="c3">«Комнаты»</span>, аят 11]. </p>',
            ],
            18 => [
                'question' => '19. Вопрос: что такое скромность?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13780.mp3',
                'answer' => '<p> Ответ: это когда человек не ставит себя выше других людей, не относится к людям презрительно и не отвергает истину.<span class="c6"><br /> Всевышний Аллах сказал:</span> <span class="c3">«А рабами Милостивого являются те, которые ступают по земле смиренно <span class="c5">[с торжественным спокойствием, без надменности и высокомерия]</span>»</span> [Сура 25 <span class="c3">«Различение»</span>, аят 63]. То есть проявляют скромность. Посланник Аллаха <span class="c2">(мир ему и благословение Аллаха)</span> сказал: <span class="c3">«Аллах непременно возвысит того, кто проявляет скромность ради Него»</span> <span class="c5">[Муслим]</span>. Также Посланник Аллаха <span class="c2">(мир ему и благословение Аллаха)</span> сказал: <span class="c3">«Поистине, Аллах внушил мне, что вы должны быть скромными — так, чтобы никто ни над кем не превозносился и никто никого не притеснял»</span> <span class="c5">[Муслим]</span>. </p>',
            ],
            19 => [
                'question' => '20. Вопрос: назови виды запретного высокомерия.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13840.mp3',
                'answer' => '<p> Ответ: 1) высокомерие в отношении истины, то есть отрицание истины и отказ принимать её;<br /> 2) высокомерие по отношению к людям — это пренебрежительное, уничижительное отношение к ним.<br /> Посланник Аллаха <span class="c2">(мир ему и благословение Аллаха)</span> сказал: <span class="c3">«Не войдёт в Рай человек, в сердце которого есть высокомерие хотя бы весом с пылинку»</span>.<span class="c6"> Один человек воскликнул:</span> <span class="c3">«Но ведь человеку хочется, чтобы его одежда и обувь были красивыми!»</span> Пророк <span class="c2">(мир ему и благословение Аллаха)</span> сказал: <span class="c3">«Поистине, Аллах прекрасен, и Он любит прекрасное. А высокомерие — это неприятие истины и презрительное отношение к людям»</span> <span class="c5">[Муслим]</span>.<br /> — неприятие истины — это отказ принимать её;<br /> — презрительно относиться к людям — значит смотреть на них свысока;<br /> — хорошая одежда и обувь не относятся к проявлениям высокомерия. </p>',
            ],
            20 => [
                'question' => '21. Вопрос: назови виды запретного обмана?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13910.mp3',
                'answer' => '<p> Ответ: — обман в купле-продаже, то есть сокрытие недостатков товара;<br /> — недобросовестность в приобретении знаний, например, мошенничество студентов на экзаменах;<br /> — нечестность в словах — лжесвидетельство, ложь;<br /> — неисполнение обещаний, обязательств, договоров.<br /> Обманывать запрещено. Однажды Посланник Аллаха <span class="c2">(мир ему и благословение Аллаха)</span>, проходивший мимо выставленного на продажу зерна, погрузил в него руку, и пальцы его ощутили влажность.<span class="c6"> Он спросил:</span> <span class="c3">«Что это, о хозяин зерна?»</span> Тот сказал: <span class="c3">«Его попортило небо, о Посланник Аллаха»</span>. Пророк <span class="c2">(мир ему и благословение Аллаха)</span> воскликнул: <span class="c3">«Так почему же ты не положил подмоченное сверху, чтобы люди видели его?! Обманывающий не имеет ко мне отношения!»</span> <span class="c5">[Муслим]</span>.<br /> Имеется в виду зерно, ссыпанное в кучу. </p>',
            ],
            21 => [
                'question' => '22. Вопрос: что такое злословие?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13990.mp3',
                'answer' => '<p> Ответ: это когда ты говоришь о своём брате-мусульманине за его спиной то, что ему было бы неприятно услышать.<span class="c6"><br /> Всевышний Аллах сказал:</span> <span class="c3">«и не злословьте за спиной друг друга. Разве понравится кому-либо из вас есть мясо своего покойного брата? Ведь вы чувствуете к этому отвращение! Бойтесь Аллаха! Поистине, Аллах — Принимающий покаяния, Милующий»</span> [Сура 49 <span class="c3">«Комнаты»</span>, аят 12]. </p>',
            ],
            22 => [
                'question' => '23. Вопрос: что такое сплетни?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14030.mp3',
                'answer' => '<p> Ответ: это передача слов одних людей другим с целью испортить их отношения, поссорить их.<br /> Посланник Аллаха <span class="c2">(мир ему и благословение Аллаха)</span> сказал: <span class="c3">«Не войдёт в Рай сплетник»</span> <span class="c5">[Муслим]</span>. </p>',
            ],
            23 => [
                'question' => '24. Вопрос: что такое лень?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14070.mp3',
                'answer' => '<p> Ответ: это уклонение от совершения благих дел и исполнения обязанностей.<br /> Сюда относится лень в исполнении религиозных обязанностей.<span class="c6"><br /> Всевышний Аллах сказал:</span> <span class="c3">«Поистине, лицемеры пытаются обмануть Аллаха, но сами оказываются обманутыми Им. Когда они встают на молитву, то встают неохотно, делая это напоказ людям и поминая Аллаха лишь немного»</span> [Сура 4 <span class="c3">«Женщины»</span>, аят 142].<br /> Верующему надлежит избавляться от лени, бездействия и не сидеть сложа руки. Напротив, он должен быть активным, двигаться, трудиться, прилагать усилия и проявлять усердие в своей земной жизни, стремясь снискать довольство Аллаха. </p>',
            ],
            24 => [
                'question' => '25. Вопрос: назови виды гнева.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14130.mp3',
                'answer' => '<p> Ответ: 1) похвальный гнев: это гнев ради Аллаха, когда неверующие, лицемеры или ещё кто-<span class="c6">то нарушает Его запреты и установленные Им ограничения;<br /> 2) порицаемый гнев:</span> это гнев, который побуждает человека говорить и делать нечто неподобающее.<span class="c6"><br /> Средства избавления от порицаемого гнева:</span><br /> — совершить малое омовение <span class="c2">(вуду)</span>;<br /> — сесть, если мы стоим, или лечь, если мы сидим;<br /> — стараться исполнять наказ Пророка <span class="c2">(мир ему и благословение Аллаха)</span>: <span class="c3">«Не гневайся»</span>;<br /> — сдерживать гнев, не давать ему воли;<br /> — испрашивать у Аллаха защиты от проклятого шайтана;<br /> — молчать. </p>',
            ],
            25 => [
                'question' => '26. Что такое выслеживание?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14240.mp3',
                'answer' => '<p> Ответ: это раскрытие или стремление узнать того, что люди стараются скрыть или чего стыдятся.<span class="c6"><br /> К его запретным проявлениям относится:</span><br /> — слежка или подглядывание за тем, что люди делают в своих домах;<br /> — подслушивание чужих разговоров.<span class="c6"><br /> Всевышний Аллах сказал:</span> <span class="c3">«…и не выслеживайте»</span> [Сура 49 <span class="c3">«Комнаты»</span>, аят 12]. </p>',
            ],
            26 => [
                'question' => '27. Вопрос: что такое расточительство (исраф)? Что такое скупость? И что такое щедрость?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14310.mp3',
                'answer' => '<p> Ответ: исраф — расходование денег или имущества ненадлежащим образом.<br /> Его противоположность — скупость, то есть отказ расходовать средства надлежащим образом.<br /> Правильно же придерживаться золотой середины между ними. А ещё мусульманину надлежит быть щедрым.<span class="c6"><br /> Всевышний Аллах сказал:</span> <span class="c3">«Когда они делают пожертвования, то не расточительствуют и не скупятся, а придерживаются середины между этими крайностями»</span> [Сура 25 <span class="c3">«Различение»</span>, аят 67]. </p>',
            ],
            27 => [
                'question' => '28. Вопрос: что такое трусость? И что такое храбрость?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14370.mp3',
                'answer' => '<p> Ответ: это когда человек боится того, чего бояться не следует.<br /> Пример — бояться сказать правду или осудить порицаемое.<br /> Храбрость — это решительное совершение того, что правильно. Примером храбрости может служить наступление во время сражения с целью защиты ислама и мусульман.<br /> Пророк <span class="c2">(мир ему и благословение Аллаха)</span> говорил в своей мольбе: «О Аллах, поистине, я прибегаю к Твоей защите от трусости <span class="c2">(Аллахумма, инни а‘узу би-ка мина-ль-джубни)</span>». И Посланник Аллаха <span class="c2">(мир ему и благословение Аллаха)</span> сказал: <span class="c3">«Сильный верующий лучше и любимее для Аллаха, чем слабый верующий, хотя в каждом из них благо»</span> <span class="c5">[Муслим]</span>. </p>',
            ],
            28 => [
                'question' => '29. Вопрос: приведи примеры запретных речей.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14440.mp3',
                'answer' => '<p> Ответ: — говорить проклятия и ругательства;<br /> — обзываться, называть человека животным, скотиной и так далее;<br /> — произносить неприличные, непристойные слова;<br /> Посланник Аллаха <span class="c2">(мир ему и благословение Аллаха)</span> запретил всё это: <span class="c3">«Верующий не является очерняющим, проклинающим, совершающим непристойности и сквернословящим»</span> <span class="c5">[ат-Тирмизи; Ибн Хиббан]</span>. </p>',
            ],
            29 => [
                'question' => '30. Вопрос: назови то, что помогает мусульманину быть благонравным.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14500.mp3',
                'answer' => '<p> Ответ: 1) испрашивание у Аллаха благонравия и помощи в его обретении;<br /> 2) не забывать о том, что Аллах видит и слышит нас везде и всегда и знает о нас всё;<br /> 3) не забывать о том, как велика награда за благонравие и что оно помогает нам войти в Рай;<br /> 4) не забывать о том, как сурово наказание за скверный нрав и что оно приводит человека в Ад;<br /> 5) благонравие приносит нам любовь Всевышнего и любовь людей, а скверный нрав — ненависть Аллаха и ненависть людей;<br /> 6) чтение жизнеописания Посланника Аллаха <span class="c2">(мир ему и благословение Аллаха)</span> и следование его примеру;<br /> 7) общение и дружба с хорошими людьми и отдаление от скверных. </p>',
            ],
        ],
        8 => [
            0 => [
                'question' => '1. Вопрос: каково достоинство слов поминания Аллаха?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14630.mp3',
                'answer' => '<p> Ответ: Пророк <span class="c2">(мир ему и благословение Аллаха)</span> сказал: <span class="c3">«Тот, кто поминает своего Господа, и тот, кто не поминает Его, подобны живому и мёртвому»</span> <span class="c5">[аль-Бухари]</span>.<br /> Потому что ценность жизни человека соответствует тому, сколько он поминает Аллаха. </p>',
            ],
            1 => [
                'question' => '2. Вопрос: приведи примеры пользы, которую приносит поминание Аллаха.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14670.mp3',
                'answer' => '<p> Ответ: 1) помогает снискать довольство Милостивого;<br /> 2) прогоняет шайтана;<br /> 3) оберегает мусульманина от зла;<br /> 4) приносит награду. </p>',
            ],
            2 => [
                'question' => '3. Вопрос: какое поминание Аллаха наилучшее?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14730.mp3',
                'answer' => '<p> Ответ: «Нет бога, кроме Аллаха <span class="c2">(Ля иляха илля-Ллах)</span>» <span class="c5">[ат-Тирмизи; Ибн Маджа]</span>. </p>',
            ],
            3 => [
                'question' => '4. Вопрос: что мы говорим, просыпаясь ото сна?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14760.mp3',
                'answer' => '<p> Ответ: «Хвала Аллаху, Который оживил нас после того, как умертвил, и к Нему возвращение <span class="c2">(Аль-хамду ли-Лляхи-ллязи ахйана ба‘да ма амата-на ва иляйхи-н-нушур)</span>» <span class="c5">[аль-Бухари; Муслим]</span>. </p>',
            ],
            4 => [
                'question' => '5. Вопрос: что мы говорим, надевая одежду?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14790.mp3',
                'answer' => '<p> Ответ: «Хвала Аллаху, Который облачил меня в эту одежду и одарил меня ею, тогда как у меня самого не было для этого ни способности, ни силы <span class="c2">(Аль-хамду ли-Лляхи-ллязи каса-ни хаза-с-сауба ва разака-ни-хи мин гайри хаулин мин-ни ва ля кувва)</span>» <span class="c5">[Абу Дауд; ат-Тирмизи и другие]</span>. </p>',
            ],
            5 => [
                'question' => '6. Вопрос: что мы говорим, снимая одежду?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14820.mp3',
                'answer' => '<p> Ответ: «С именем Аллаха! <span class="c2">(Бисми-Ллях)</span>» <span class="c5">[ат-Тирмизи]</span>. </p>',
            ],
            6 => [
                'question' => '7. Вопрос: что мы говорим, надевая новую одежду?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14850.mp3',
                'answer' => '<p> Ответ: «О Аллах, Тебе хвала, Ты надел на меня это, прошу Тебя о благе её и о благе того, для чего она была изготовлена, и прошу у Тебя защиты от зла её и от зла того, для чего она была изготовлена <span class="c2">(Аллахумма, ля-ка-ль-хамду, Анта касаута-ни-хи, асалю-ка мин хайри-хи уа хайри ма суни‘а ля-ху, уа а‘узу би-ка мин шарри-хи уа шарри ма суни‘а ля-ху)</span>» <span class="c5">[Абу Дауд; ат-Тирмизи]</span>. </p>',
            ],
            7 => [
                'question' => '8. Вопрос: что мы говорим тому, кто надел новую одежду?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14880.mp3',
                'answer' => '<p> Ответ: увидев на ком-то новую одежду,<span class="c6"> мы говорим:</span> «Сноси, и да заменит Всевышний Аллах тебе её новой одеждой! <span class="c2">(Тубли ва йухлифу-Ллаху та‘аля)</span>» <span class="c5">[Абу Дауд]</span>. </p>',
            ],
            8 => [
                'question' => '9. Вопрос: что мы говорим перед тем, как войти в отхожее место (туалет)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14910.mp3',
                'answer' => '<p> Ответ: «О Аллах, поистине, я прошу у Тебя защиты от шайтанов мужского и женского пола <span class="c2">(Аллахумма инни а‘узу би-ка мина-ль-хубуси уа-ль-хабаис)</span>» <span class="c5">[аль-Бухари; Муслим]</span>. </p>',
            ],
            9 => [
                'question' => '10. Вопрос: что мы говорим после выхода из туалета?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14940.mp3',
                'answer' => '<p> Ответ: «Прошу у Тебя прощения <span class="c2">(Гуфрана-ка)</span>» <span class="c5">[Абу Дауд; ат-Тирмизи]</span>. </p>',
            ],
            10 => [
                'question' => '11. Вопрос: что мы говорим перед малым омовением (вуду)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14970.mp3',
                'answer' => '<p> Ответ: «С именем Аллаха <span class="c2">(Бисми-Ллях)</span>» <span class="c5">[Абу Дауд и другие]</span>. </p>',
            ],
            11 => [
                'question' => '12. Вопрос: что мы говорим после малого омовения?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15000.mp3',
                'answer' => '<p> Ответ: «Свидетельствую, что нет бога, кроме одного лишь Аллаха, у Которого нет сотоварищей, и что Мухаммад — Его раб и Посланник <span class="c2">(Ашхаду алля иляха илля-Ллаху уахда-ху ля шарика ля-ху, уа ашхаду анна Мухаммадан ‘абду-ху уа расулю-ху)</span>» <span class="c5">[Муслим]</span>. </p>',
            ],
            12 => [
                'question' => '13. Вопрос: что мы говорим перед выходом из дома?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15020.mp3',
                'answer' => '<p> Ответ: «С именем Аллаха, уповаю на Аллаха, и нет способности изменить что-либо и силы ни у кого, кроме как от Аллаха <span class="c2">(Бисми-Лляхи, таваккальту ‘аля-Ллахи, ва ля хауля уа ля куввата илля би-Лляхи)</span>» <span class="c5">[Абу Дауд; ат-Тирмизи]</span>. </p>',
            ],
            13 => [
                'question' => '14. Вопрос: что мы говорим, входя в дом?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15050.mp3',
                'answer' => '<p> Ответ: «С именем Аллаха мы зашли и с именем Аллаха вышли, и на Аллаха, Господа нашего, уповаем мы <span class="c2">(бисми-Лляхи уаляджна уа бисми-Лляхи хараджна ва ‘аля-Ллахи Рабби-на таваккальна)</span>», а потом приветствуем обитателей дома. <span class="c5">[Абу Дауд]</span>. </p>',
            ],
            14 => [
                'question' => '15. Вопрос: что мы говорим, входя в мечеть?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15080.mp3',
                'answer' => '<p> Ответ: «О Аллах, открой для меня врата Твоей милости <span class="c2">(Аллахумма-фтах ли абваба рахмати-ка)</span>» <span class="c5">[Муслим]</span>. </p>',
            ],
            15 => [
                'question' => '16. Вопрос: что мы говорим, выходя из мечети?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15110.mp3',
                'answer' => '<p> Ответ: «О Аллах, поистине, я прошу Тебя о благах, даруемых Тобой <span class="c2">(Аллахумма, инни ас’алю-ка мин фадли-ка)</span>» <span class="c5">[Муслим]</span>. </p>',
            ],
            16 => [
                'question' => '17. Вопрос: что мы говорим, слыша азан?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15140.mp3',
                'answer' => '<p> Ответ: повторяем всё за муаззином, только вместо слов «спешите на молитву <span class="c2">(хаййа аля-с-салят)</span>» и «спешите к успеху <span class="c2">(хаййа аля-ль-фалях)</span>» говорим: «нет силы и способности изменить что-либо, кроме как от Аллаха <span class="c2">(ля хауля уа ля куввата илля биЛлях)</span>» <span class="c5">[аль-Бухари; Муслим]</span>. </p>',
            ],
            17 => [
                'question' => '18. Вопрос: что мы говорим после азана?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15170.mp3',
                'answer' => '<p> Ответ: мы призываем благословение на Пророка <span class="c2">(мир ему и благословение Аллаха)</span>. <span class="c5">[Муслим]</span>.<span class="c6"> И говорим:</span> «О Аллах, Господь этого совершенного призыва и этой совершающейся молитвы, приведи Мухаммада к <span class="c5">[высшей степени в Раю]</span> Василе и высокому положению и направь его к месту достохвальному, которое Ты обещал ему! <span class="c2">(Аллахумма, Рабба хазихи-д-да‘вати-т-таммати уа-с-саляти-ль-каимати, ати Мухаммадани-ль-василята уа-ль-фадылята уа-б‘ас-ху макаман махмудани-ллязи ва‘адта-ху!)</span>» <span class="c5">[аль-Бухари]</span>.<br /> А между азаном и икаматом мы обращаемся к Аллаху с мольбами, ибо в это время мольба обычно не остаётся без ответа. </p>',
            ],
            18 => [
                'question' => '19. Вопрос: какие слова поминания Аллаха мы говорим по утрам и вечерам?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15220.mp3',
                'answer' => '<p> Ответ: 1) читаем аят аль-<span class="c6">Курси:</span> <span class="c3">«Аллах — нет бога, кроме Него, Живого, Вседержителя. Им не овладевают ни дремота, ни сон. Ему принадлежит то, что на небесах, и то, что на земле. Кто станет заступаться перед Ним иначе как с Его дозволения? Он знает их будущее и прошлое. Они постигают из Его знания только то, что Он пожелает <span class="c5">[открыть им]</span>. Престол Его объемлет небеса и землю, и не тяготит Его оберегание их. И Он — Возвышенный, Великий»</span> [Сура 2 <span class="c3">«Корова»</span>, аят 255].<span class="c6"> 2) читаем:</span> с именем Аллаха Милостивого,<span class="c6"> Милующего! «Скажи:</span> <span class="c1">“Он — Аллах Единственный, Аллах Самодостаточный. Он не родил и не был рождён, и не равен Ему ни один”</span>» 3 раза. С именем Аллаха Милостивого,<span class="c6"> Милующего! «Скажи:</span> <span class="c1">“Прибегаю к защите Господа рассвета от зла того, что Он сотворил, от зла мрака, когда он наступает, от зла колдуний, дующих на узлы, от зла завистника, когда он завидует”</span>» 3 раза. С именем Аллаха Милостивого,<span class="c6"> Милующего! «Скажи:</span> <span class="c1">“Прибегаю к защите Господа людей, Царя людей, Бога людей, от зла искусителя отступающего при поминании Аллаха, который наущает в груди людей, от джиннов и людей”</span>» 3 раза. «О Аллах, Ты — Господь мой, нет бога, кроме Тебя; Ты сотворил меня, и я Твой раб, и я буду верен завету с Тобой и буду полагаться на обещанное Тобой, сколько смогу. Прошу у Тебя защиты от зла того, что я сделал, признаю милости, оказанные Тобой мне, и признаю грех свой. Прости же меня, ибо, поистине, никто не прощает грехов, кроме Тебя! <span class="c2">(Аллахумма, Анта Рабби, ля иляха илля Анта, халякта-ни уа ана ‘абду-ка, уа ана ‘аля ‘ахди-ка уа уа‘ди-ка ма-стата‘ту. А‘узу би-ка мин шарри ма сана‘ту, абуу ля-ка би-ни‘мати-ка ‘аляййа, уа абуу би-занби, фа-гфир ли, фа-инна-ху ля йагфиру-з-зунуба илля Анта!)</span>» <span class="c5">[аль-Бухари]</span>. </p>',
            ],
            19 => [
                'question' => '20. Вопрос: что мы говорим перед сном?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15290.mp3',
                'answer' => '<p> Ответ: «С именем Твоим, о Аллах, умираю и оживаю <span class="c2">(Би-смика Аллахумма амуту уа ахйа)</span>» <span class="c5">[аль-Бухари; Муслим]</span>. </p>',
            ],
            20 => [
                'question' => '21. Вопрос: что мы говорим перед едой?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15320.mp3',
                'answer' => '<p> Ответ: «С именем Аллаха <span class="c2">(Бисми-Лляхи)</span>»<br /> Если же человек забудет помянуть имя Всевышнего Аллаха в начале еды,<span class="c6"> он говорит:</span><br /> «С именем Аллаха в начале и конце её! <span class="c2">(Бисми-Лляхи фи аввали-хи уа ахыри-хи)</span>» <span class="c5">[Абу Дауд; ат-Тирмизи]</span>. </p>',
            ],
            21 => [
                'question' => '22. Вопрос: что мы говорим после еды?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15370.mp3',
                'answer' => '<p> Ответ: «Хвала Аллаху, Который накормил меня этой едой, тогда как у меня самого не было ни способности, ни силы <span class="c2">(Аль-хамду ли-Лляхи-ллязи ат‘ама-ни хаза-т-та‘ама уа разака-ни-хи мин гайри хаулин мин-ни уа ля кувва)</span>» <span class="c5">[Абу Дауд; Ибн Маджа]</span>. </p>',
            ],
            22 => [
                'question' => '23. Вопрос: с какой мольбой обращается к Аллаху гость за пригласившего его на угощение?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15400.mp3',
                'answer' => '<p> Ответ: «О Аллах, сделай благодатным для них то, чем Ты наделил их, прости им и помилуй их <span class="c2">(Аллахумма барик ляхум фи-ма разактахум уа-гфир ляхум уа-рхамхум)</span>» <span class="c5">[Муслим]</span>. </p>',
            ],
            23 => [
                'question' => '24. Вопрос: что мы говорим, чихнув?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15430.mp3',
                'answer' => '<p> Ответ: <span class="c3">«Хвала Аллаху»</span> <span class="c2">(Аль-хамду ли-Ллях)</span>.<span class="c6"><br /> И пусть брат или товарищ чихнувшего скажет ему:</span> «Да помилует тебя Аллах <span class="c2">(Йархаму-ка-Ллах)</span>».<span class="c6"><br /> И когда он скажет ему:</span> <span class="c3">«Да помилует тебя Аллах»</span>,<span class="c6"> пусть чихнувший скажет ему в ответ:</span> «Да ведёт вас Аллах правильным путём и да исправит Он ваши помыслы! <span class="c2">(Йахди-куму-Ллаху уа йуслиху баля-кум)</span>» <span class="c5">[аль-Бухари]</span>. </p>',
            ],
            24 => [
                'question' => '25. Вопрос: что мы говорим, когда встаём и покидаем собрание (мольба — искупление собрания)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15480.mp3',
                'answer' => '<p> Ответ: «Пречист Ты, о Аллах, и хвала Тебе, свидетельствую, что нет бога, кроме Тебя, прошу у Тебя прощения и приношу Тебе своё покаяние! <span class="c2">(Субхана-ка, Аллахумма, уа би-хамди-ка, ашхаду алля иляха илля Анта, астагфиру-ка уа атубу иляй-ка!)</span>» <span class="c5">[Абу Дауд; ат-Тирмизи]</span>. </p>',
            ],
            25 => [
                'question' => '26. Вопрос: что мы говорим, когда садимся в транспорт?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15510.mp3',
                'answer' => '<p> Ответ: «С именем Аллаха <span class="c2">(Бисми-Ллях)</span>»; «Хвала Аллаху <span class="c2">(аль-хамду ли-Ллях)</span>»; <span class="c3">«Пречист Тот, Кто подчинил нам это, ведь нам такое не под силу, и, поистине, мы вернёмся к Господу нашему!»</span>; трижды произносим: «Хвала Аллаху <span class="c2">(аль-хамду лиЛлях)</span>»; трижды говорим: «Аллах Велик <span class="c2">(Аллаху акбар)</span>»; «Пречист Ты! Поистине, я притеснил самого себя, прости же меня, ведь никто не прощает грехов, кроме Тебя!” <span class="c2">(Бисми-Ллях, аль-хамду ли-Ллях, субхана-Ллязи саххара ля-на хаза уа ма кунна ля-ху мукринин, уа инна иля Рабби-на ля-мункалибуна, аль-хамду ли-Ллях, аль-хамду ли-Ллях, аль-хамду ли-Ллях, Аллаху Акбар, Аллаху Акбар, Аллаху Акбар, субхана-ка, инни залямту нафси, фа-гфир ли, фа-инна-ху ля йагфиру-з-зунуба илля Анта)</span>» <span class="c5">[Абу Дауд; ат-Тирмизи]</span>. </p>',
            ],
            26 => [
                'question' => '27. Вопрос: что мы говорим, отправляясь в путь?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15540.mp3',
                'answer' => '<p> Ответ: трижды произносим: <span class="c3">«Аллах велик»</span>,<span class="c6"> а потом говорим:</span> «Пречист Тот, Кто подчинил нам это, ведь нам такое не под силу, и, поистине, мы вернёмся к Господу нашему! О Аллах, поистине, мы просим у Тебя благочестия и богобоязненности в этом нашем путешествии и совершения таких дел, которыми Ты останешься доволен! О Аллах, облегчи нам это наше путешествие и сократи для нас его дальность! О Аллах, Ты будешь спутником в этом путешествии и останешься с семьёй. О Аллах, поистине, я прошу у Тебя защиты от трудностей пути, от печали, которую может навеять увиденное, и от несчастья, которое может случиться с имуществом и семьёй! <span class="c2">(Аллаху Акбар, Аллаху Акбар, Аллаху Акбар, субхана-ллязи саххара ля-на хаза, уа ма кунна ля-ху мукринина, уа инна иля Рабби-на ля-мункалибуна, Аллахумма, инна нас’алю-ка фи сафари-на хаза-ль-бирра, уа-т-таква, уа мина-ль-‘амали ма тарда, Аллахумма, хаввин ‘аляй-на сафара-на хаза, уа-тви ‘анна бу‘да-ху! Аллахумма, Анта-с-сахибу фи-с-сафари уа-ль-халифату фи-ль-ахли, Аллахумма, инни а‘узу би-ка мин уа‘са’и-с-сафари, уа каабати-ль-манзари, уа су’и-ль-мункаляби фи-ль-мали уа-ль-ахль)</span>»<br /> А возвращаясь,<span class="c6"> говорим это и добавляем:</span><br /> «Мы возвращаемся <span class="c5">[благополучно]</span>, каемся <span class="c5">[в грехах]</span>, поклоняемся <span class="c5">[только Ему]</span> и воздаём хвалу Господу нашему <span class="c5">[за благополучное возвращение]</span> <span class="c2">(Айибуна, таибуна, ‘абидуна ли-Рабби-на хамидун)</span>» <span class="c5">[Муслим]</span>. </p>',
            ],
            27 => [
                'question' => '28. Вопрос: что мы говорим остающимся, когда отправляемся в путь?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15590.mp3',
                'answer' => '<p> Ответ: «Вверяю вас Аллаху, у Которого не пропадает вверенное Ему <span class="c2">(Астауди‘укуму-Ллаха-ллязи ля тады‘у вадаи‘у-ху)</span>» <span class="c5">[Ахмад; Ибн Маджа]</span>. </p>',
            ],
            28 => [
                'question' => '29. Вопрос: что говорит остающийся отправляющемуся в путь?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15620.mp3',
                'answer' => '<p> Ответ: «Вверяю Аллаху твою религию и оставленное тобой и исход дел твоих <span class="c2">(Астауди‘у-Ллаха динака уа аманата-ка уа хаватима ‘амали-ка)</span>» <span class="c5">[Ахмад; ат-Тирмизи]</span>. </p>',
            ],
            29 => [
                'question' => '30. Вопрос: что мы говорим перед входом на рынок?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15650.mp3',
                'answer' => '<p> Ответ: «Нет бога, кроме одного лишь Аллаха, у Которого нет сотоварищей, ему принадлежит власть и Ему хвала, Он даёт жизнь и умерщвляет, а Сам Он — Живой и не умирает. В руке Его благо, и Он всё может <span class="c2">(Ля иляха илля-Ллаху уахда-ху ля шарика ля-ху, ля-ху-ль-мульку уа ля-ху-ль-хамду, йухйи уа йумиту уа хува хаййун ля йамуту, би-йади-хи-ль-хайру уа хува ‘аля кулли шайин кадир)</span>» <span class="c5">[ат-Тирмизи; Ибн Маджа]</span>. </p>',
            ],
            30 => [
                'question' => '31. Вопрос: что мы говорим в гневе?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15680.mp3',
                'answer' => '<p> Ответ: «Прибегаю к защите Аллаха от побиваемого шайтана <span class="c2">(А‘узу би-Лляхи мина-ш-шайтани-р-раджим)</span>» <span class="c5">[аль-Бухари; Муслим]</span>. </p>',
            ],
            31 => [
                'question' => '32. Вопрос: что мы говорим тому, кто сделал нам добро?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15710.mp3',
                'answer' => '<p> Ответ: «Да воздаст тебе Аллах благом <span class="c2">(ДжазакаЛлаху хайран)</span>» <span class="c5">[ат-Тирмизи]</span>. </p>',
            ],
            32 => [
                'question' => '33. Вопрос: что нужно говорить, когда оступается верховое животное?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15740.mp3',
                'answer' => '<p> Ответ: «С именем Аллаха <span class="c2">(Бисми-Ллях)</span>» <span class="c5">[Абу Дауд]</span>. </p>',
            ],
            33 => [
                'question' => '34. Вопрос: что мы говорим, когда случается радостное событие?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15770.mp3',
                'answer' => '<p> Ответ: «Хвала Аллаху, по милости Которого вершится благое! <span class="c2">(Аль-хамду ли-Лляхи-Ллязи би-ни‘мати-хи татимму-с-салихат)</span>» <span class="c5">[аль-Хаким и другие]</span>. </p>',
            ],
            34 => [
                'question' => '35. Вопрос: что мы говорим, когда случается нечто неприятное?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15800.mp3',
                'answer' => '<p> Ответ: «Хвала Аллаху в любом случае <span class="c2">(Аль-хамду ли-Лляхи ‘аля кулли халь)</span>» <span class="c5">[Сахих аль-джами]</span>. </p>',
            ],
            35 => [
                'question' => '36. Вопрос: как нужно приветствовать и отвечать на приветствие?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15830.mp3',
                'answer' => '<p> Ответ: мусульманин говорит: «Мир вам, милость Аллаха и благодать Его <span class="c2">(Ассаляму алейкум уа рахматуЛлахи уа баракатуху)</span>».<span class="c6"><br /> Его брат по вере отвечает ему:</span> «И вам мир, милость Аллаха и благодать Его <span class="c2">(Ва алейкум ассалям ва рахматуЛлахи ва баракатуху)</span>» <span class="c5">[ат-Тирмизи; Абу Дауд и другие]</span>. </p>',
            ],
            36 => [
                'question' => '37. Вопрос: что мы говорим, когда идёт дождь?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15870.mp3',
                'answer' => '<p> Ответ: «О Аллах! <span class="c5">[Да будет этот дождь]</span> обильным, приносящим пользу <span class="c2">(Аллахумма саййибан нафи‘ан)</span>» <span class="c5">[аль-Бухари]</span>. </p>',
            ],
            37 => [
                'question' => '38. Вопрос: что мы говорим после дождя?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15900.mp3',
                'answer' => '<p> Ответ: «Нам был послан дождь по милости Аллаха и благоволению Его <span class="c2">(Мутырна би-фадли-Лляхи уа рахмати-хи)</span>» <span class="c5">[аль-Бухари; Муслим]</span>. </p>',
            ],
            38 => [
                'question' => '39. Вопрос: какую мольбу следует произносить, когда поднимается ветер?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15930.mp3',
                'answer' => '<p> Ответ: О Аллах! Воистину, я прошу Тебя о его благе и прибегаю к Тебе от его зла. <span class="c2">(Аллахумма инни ас’алю-ка хайра-ха уа а‘узу би-ка мин шарри-ха)</span> <span class="c5">[Абу Дауд; Ибн Маджа]</span>. </p>',
            ],
            39 => [
                'question' => '40. Вопрос: какую мольбу следует произносить, когда слышишь гром?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15960.mp3',
                'answer' => '<p> Ответ: «Пречист Тот, Кого <span class="c1">“гром прославляет хвалой, а также ангелы от страха перед Ним”</span> <span class="c2">(Субхана-Ллязи йусаббиху-р-ра‘ду би-хамди-хи уа-ль-маляикату мин хифати-хи)</span>» <span class="c5">[Малик]</span>. </p>',
            ],
            40 => [
                'question' => '41. Вопрос: какую мольбу следует произносить при виде застигнутого испытанием?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15990.mp3',
                'answer' => '<p> Ответ: «Хвала Аллаху, Который уберёг меня от того, чем испытал тебя, и превознёс меня над многими из тех, кого Он сотворил <span class="c2">(Аль-хамду ли-Лляхи-ллязи ‘афа-ни мимма-бталя-ка би-хи уа фаддаля-ни ‘аля касирин мимман халяка тафдылян)</span>» <span class="c5">[ат-Тирмизи]</span>. </p>',
            ],
            41 => [
                'question' => '42. Вопрос: какую мольбу следует произносить тому, кто боится что-то сглазить?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16020.mp3',
                'answer' => '<p> Ответ: в хадисе говорится: <span class="c3">«Когда кто-то из вас видит у брата своего, у себя или в своём имуществе что-то, что ему нравится, пусть он призовёт на это благодать, ибо, поистине, сглаз — истина»</span> <span class="c5">[Ахмад; Ибн Маджа и другие]</span>. </p>',
            ],
            42 => [
                'question' => '43. Вопрос: прочитай саляват (призыв благословения на Пророка (мир ему и благословение Аллаха)).',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16050.mp3',
                'answer' => '<p> Ответ: «О Аллах, благослови Мухаммада и семейство Мухаммада, как благословил Ты семейство Ибрахима, поистине, Ты — Достойный хвалы, Славный! О Аллах, пошли благодать Мухаммаду и семейству Мухаммада, как послал Ты её семейству Ибрахима, поистине, Ты — Достойный хвалы, Славный! <span class="c2">(Аллахумма, салли ‘аля Мухаммадин уа ‘аля али Мухаммадин ка-ма салляйта ‘аля али Ибрахима, инна-ка Хамидун, Маджид! Аллахумма, барик ‘аля Мухаммадин уа ‘аля али Мухаммадин ка-ма баракта ‘аля али Ибрахима, инна-ка Хамидун, Маджид)</span>» <span class="c5">[аль-Бухари; Муслим]</span>. </p>',
            ],
        ],
        9 => [
            0 => [
                'question' => '1. Вопрос: назови пять постановлений шариата.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16090.mp3',
                'answer' => '<p> Ответ:<br /> 1) обязательное <span class="c2">(ваджиб)</span>;<br /> 2) желательное <span class="c2">(мустахабб)</span>;<br /> 3) запретное <span class="c2">(мухаррам)</span>;<br /> 4) нежелательное <span class="c2">(макрух)</span>;<br /> 5) разрешённое <span class="c2">(мубах)</span>. </p>',
            ],
            1 => [
                'question' => '2. Вопрос: разъясни эти постановления.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16170.mp3',
                'answer' => '<p> Ответ:<br /> 1) обязательное: например, пять молитв, пост и уважение к родителям.<br /> За совершение обязательного полагается награда, а за несовершение — наказание.<span class="c6"><br /> 2) желательное:</span> например, дополнительные молитвы, совершаемые до и после обязательных, добровольная ночная молитва, кормление людей, приветствие. Эта категория называется ещё сунна или мандуб.<br /> За совершение желательного полагается награда, а за его несовершение не будет наказания.<span class="c6"><br /> Важное замечание:</span><br /> узнавая, что какое-то действие является сунной или желательным, мусульманин должен спешить совершить его, следуя примеру Пророка <span class="c2">(мир ему и благословение Аллаха)</span>.<span class="c6"><br /> 3) запретное:</span> например, употребление алкоголя, неуважение к родителям, разрыв родственных связей.<br /> За совершение запретного полагается наказание, а за его оставление — награда.<span class="c6"><br /> 4) нежелательное:</span> например, брать и давать левой рукой, подбирать одежду в молитве.<br /> За оставление нежелательного полагается награда, а за его совершение не будет наказания.<span class="c6"><br /> 5) разрешённое:</span> например, есть яблоко или пить чай. Эту категорию называют ещё халяль или джаиз.<br /> За совершение разрешённого не полагается наказание, а за его оставление не полагается награда. </p>',
            ],
            2 => [
                'question' => '3. Вопрос: каково постановление шариата в отношении договора купли- продажи и других деловых операций?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16320.mp3',
                'answer' => '<p> Ответ: основой во всех этих сделках является дозволенность, и лишь некоторые их виды запретны.<span class="c6"><br /> Всевышний Аллах сказал:</span> <span class="c3">«Но Аллах дозволил торговлю и запретил ростовщичество»</span> [Сура 2 <span class="c3">«Корова»</span>, аят 275]. </p>',
            ],
            3 => [
                'question' => '4. Вопрос: приведи примеры запретных продаж и сделок.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16360.mp3',
                'answer' => '<p> Ответ:<br /> 1) Мошенничество: например, сокрытие недостатков товара.<br /> Абу Хурайра <span class="c2">(да будет доволен им Аллах)</span> передаёт, что однажды Посланник Аллаха <span class="c2">(мир ему и благословение Аллаха)</span>, проходивший мимо выставленного на продажу зерна, погрузил в него руку, и пальцы его ощутили влажность.<span class="c6"> Он спросил:</span> <span class="c3">«Что это, о хозяин зерна?»</span> Тот сказал: <span class="c3">«Его попортило небо, о Посланник Аллаха»</span>. Пророк <span class="c2">(мир ему и благословение Аллаха)</span> воскликнул: <span class="c3">«Так почему же ты не положил подмоченное сверху, чтобы люди видели его?! Обманывающий не имеет ко мне отношения!»</span> <span class="c5">[Муслим]</span>.<span class="c6"><br /> 2) Ростовщичество:</span> например, человек берёт в долг у другого тысячу с условием, что вернёт через некоторое время уже не одну, а две.<br /> Это добавление и есть запретное ростовщичество.<span class="c6"><br /> Всевышний Аллах сказал:</span> <span class="c3">«Но Аллах дозволил торговлю и запретил ростовщичество»</span> [Сура 2 <span class="c3">«Корова»</span>, аят 275].<span class="c6"><br /> 3) сделки с большим риском и некой неизвестностью:</span> например, продажа молока в вымени овцы или ещё непойманной рыбы.<br /> Пророк <span class="c2">(мир ему и благословение Аллаха)</span> запретил продажу-гарар.<span class="c6"> Примечание:</span> продажа-гарар — это продажа, которой сопутствует неизвестность или при которой продавец не может передать покупателю товар. Сюда относится продажа рыбы или жемчуга в море, птиц в воздухе, потерявшегося верблюда, одежды в чехле, который не позволяет её увидеть, еды в доме, который нельзя открыть, плода в утробе самки скота, плодов дерева, которое ещё не дало плодов. Подобные сделки недействительны. <span class="c5">[Муслим]</span>. </p>',
            ],
            4 => [
                'question' => '5. Вопрос: приведи примеры милостей Аллаха.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16460.mp3',
                'answer' => '<p> Ответ: 1) милость ислама, то, что мы не из числа неверующих;<br /> 2) милость Сунны, то, что мы не являемся приверженцами нововведений;<br /> 3) милость здоровья и благополучия — способность слышать, видеть, ходить и так далее;<br /> 4) милость еды, питья и одежды;<br /> Милостей, которыми Аллах одаряет нас, не счесть.<span class="c6"><br /> Всевышний Аллах сказал:</span> <span class="c3">«Если вы станете считать милости Аллаха, то не пересчитаете их! Поистине, Аллах — Прощающий, Милующий»</span> [Сура 16 <span class="c3">«Пчела»</span>, аят 18]. </p>',
            ],
            5 => [
                'question' => '6. Вопрос: какова наша обязанность по отношению к милостям Аллаха? И как мы должны благодарить за них?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16540.mp3',
                'answer' => '<p> Ответ: мы обязаны благодарить за них, то есть восхвалять Одного лишь Аллаха своим языком и признавать, что эти милости — от Него Одного, а также использовать эти милости угодным Аллаху образом, а не для ослушания Его. </p>',
            ],
            6 => [
                'question' => '7. Вопрос: каковы праздники мусульман?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16570.mp3',
                'answer' => '<p> Ответ: Праздник разговения и Праздник жертвоприношения.<br /> Анас <span class="c5">[ибн Малик]</span> передаёт, что, когда Посланник Аллаха <span class="c2">(мир ему и благословение Аллаха)</span> прибыл в Медину, у её жителей было два дня, в которые они устраивали игры.<span class="c6"> Он спросил:</span> <span class="c3">«Что это за дни?»</span> Люди сказали: <span class="c3">«Мы устраивали игры в эти дни во времена невежества»</span>. Посланник Аллаха <span class="c2">(мир ему и благословение Аллаха)</span> сказал: <span class="c3">«Поистине, Аллах заменил вам это на нечто лучшее,<span class="c6"> а именно:</span> на Праздник жертвоприношения и Праздник разговения»</span> <span class="c5">[Абу Дауд]</span>.<br /> Остальные праздники являются нововведениями. </p>',
            ],
            7 => [
                'question' => '8. Вопрос: какой месяц наилучший?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16620.mp3',
                'answer' => '<p> Ответ: месяц рамадан. </p>',
            ],
            8 => [
                'question' => '9. Вопрос: какой день наилучший?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16650.mp3',
                'answer' => '<p> Ответ: пятница. </p>',
            ],
            9 => [
                'question' => '10. Вопрос: какой день в году наилучший?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16680.mp3',
                'answer' => '<p> Ответ: день Арафата. </p>',
            ],
            10 => [
                'question' => '11. Вопрос: какая ночь в году наилучшая?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16710.mp3',
                'answer' => '<p> Ответ: Ночь предопределения. </p>',
            ],
            11 => [
                'question' => '12. Вопрос: что мы обязаны сделать, когда видим постороннюю женщину?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16740.mp3',
                'answer' => '<p> Ответ: мы обязаны опустить взор.<span class="c6"> Всевышний Аллах сказал:</span> <span class="c3">«Скажи верующим <span class="c5">[мужчинам]</span>, чтобы они опускали свои взоры»</span> [Сура 24 <span class="c3">«Свет»</span>, аят 30]. </p>',
            ],
            12 => [
                'question' => '13. Вопрос: каковы враги человека?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16770.mp3',
                'answer' => '<p> Ответ: 1) душа, побуждающая к дурному. Человек следует тому, к чему склоняет его душа и страсти, ослушиваясь Аллаха.<span class="c6"> Всевышний Аллах сказал:</span> <span class="c3">«ведь душа человека повелевает зло, если только мой Господь не проявит к ней милости. Поистине, мой Господь — Прощающий, Милующий»</span> [Сура 12 <span class="c3">«Юсуф»</span>, аят 53]. 2) Шайтан. Он враг рода человеческого, и его цель — сбивать человека с пути истинного, подталкивать его к скверным поступкам и к Аду.<span class="c6"> Всевышний Аллах сказал:</span> <span class="c3">«и не следуйте по стопам шайтана. Поистине, он для вас — явный враг»</span> [Сура 2 <span class="c3">«Корова»</span>, аят 168]. 3) Скверные товарищи. Это побуждающие к скверному и отвращающие от хорошего и правильного.<span class="c6"> Всевышний Аллах сказал:</span> <span class="c3">«В тот день врагами станут все любящие друзья, кроме богобоязненных»</span> [Сура 43 <span class="c3">«Украшения»</span>, аят 67]. </p>',
            ],
            13 => [
                'question' => '14. Вопрос: что такое покаяние?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16820.mp3',
                'answer' => '<p> Ответ: это возвращение от ослушания Аллаха к покорности Ему.<span class="c6"> Всевышний Аллах сказал:</span> <span class="c3">«Поистине, Я прощаю тех, кто раскаялся, уверовал, стал поступать праведно, а потом последовал прямым путём»</span> [Сура 20 <span class="c3">«Та. Ха»</span>, аят 82]. </p>',
            ],
            14 => [
                'question' => '15. Вопрос: каковы непременные условия правильного покаяния?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16850.mp3',
                'answer' => '<p> Ответ: 1) прекращение совершения греха;<br /> 2) сожаление о содеянном;<br /> 3) решительное намерение не поступать так впредь;<br /> 4) восстановление ущемлённых прав, заглаживание нанесённых обид, возмещение причинённого ущерба.<span class="c6"><br /> Всевышний Аллах сказал:</span> <span class="c3">«Тем же, которые, совершив мерзкий поступок или несправедливо поступив против самих себя, помянули Аллаха и попросили прощения за свои грехи, — ведь кто прощает грехи, кроме Аллаха? — и тем, которые сознательно не упорствуют в том, что они совершили»</span> [Сура 3 <span class="c3">«Род Имрана»</span>, аят 135]. </p>',
            ],
            15 => [
                'question' => '16. Вопрос: как мы призываем благословение на Пророка (мир ему и благословение Аллаха) (саляват)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16920.mp3',
                'answer' => '<p> Ответ: мы просим Аллаха похвалить Пророка <span class="c2">(мир ему и благословение Аллаха)</span> в высшем, небесном обществе. </p>',
            ],
            16 => [
                'question' => '17. Вопрос: что означает «СубханаЛлах»?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16950.mp3',
                'answer' => '<p> Ответ: этими словами мы признаём, что Аллах свободен от любых недостатков и пороков. </p>',
            ],
            17 => [
                'question' => '18. Вопрос: что означает «Аль-хамду лиЛлях»?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16980.mp3',
                'answer' => '<p> Ответ: это восхваление Всевышнего и признание того, что Ему присущи все качества совершенства. </p>',
            ],
            18 => [
                'question' => '19. Вопрос: что означает «Аллаху акбар»?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/17000.mp3',
                'answer' => '<p> Ответ: то есть Аллах более велик и величествен, чем всё остальное. Он превосходит всех и вся Своим величием. </p>',
            ],
            19 => [
                'question' => '20. Вопрос: что означает «Ля хауля уа ля куввата илля би-Ллях»?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/17030.mp3',
                'answer' => '<p> Ответ: у нас нет способности изменить что-то в нашем положении и силы для этого, кроме как от Аллаха. </p>',
            ],
            20 => [
                'question' => '21. Вопрос: что означает «АстагфируЛлах»?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/17060.mp3',
                'answer' => '<p> Ответ: так мы просим Аллаха стереть наши грехи и скрыть наши пороки. </p>',
            ],
        ],
    ],
];
