<?php
$data = [
    'title' => 'What Muslim Children Must Know',
    'description' => 'A project that contains a simple and easy curriculum for issues that a Muslim must know. It includes issues of belief, jurisprudence, prophetic biography, etiquette, tafsir, hadith, morals, and remembrance of Allah. It is suitable for young children in particular, for all ages, and newcomers to Islam.',
    'source' => 'https://kids.islamenc.com/rw/home',
    'author' => 'Yazan Abdul Razzaq Raziq Alghanim',
    'sections' => [
        0 => 'IGICE CY\'IMYEMERERE (IMYIZERERE).',
        1 => 'IGICE CY\'AMATEGEKO Y\'IDINI (AL FIQ\'H).',
        2 => 'IGICE CYEREKERANYE N\'IMIBEREHO Y\'INTUMWA Y\'IMANA (IMANA IYIHE AMAHORO N\'IMIGISHA).',
        3 => 'IGICE CYEREKERANYE N\'IBISOBANURO BY\'IMWE MU MIRONGO YA QUR\'AN (TAFSIIR).',
        4 => 'IGICE CY\'IMVUGO Z\'INTUMWA Y\'IMANA (HADITHI).',
        5 => 'IGICE CYEREKERANYE N\'IMICO N\'IMYIFATIRE YA KISILAMU.',
        6 => 'IGICE CYEREKERANYE N\'IMICO MYIZA.',
        7 => 'IGICE CYEREKERANYE N\'UBUSABE NO GUSINGIZA ALLAH.',
        8 => 'IGICE CY\'UBUMENYI BUTANDUKANYE.',
    ],
    'data' => [
        1 => [
            0 => [
                'question' => 'Ikibazo cya mbere: Nyagasani wawe ni nde?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/200.mp3',
                'answer' => '<p> Igisubizo: Nyagasani wanjye ni Allah, wandeze akanarera ibindi biremwa byose ku bw\'ingabire ze.<span class="c6"><br /> Gihamya y\'ibi ni imvugo ya Allah igira iti:</span> <span class="c4">{Ishimwe n’ikuzo byose bikwiye Allah, Nyagasani w’ibiremwa byose.}</span>2 <span class="c5">[Suratul Fatihat:]</span>2 </p>',
            ],
            1 => [
                'question' => 'Ikibazo cya kabiri: Idini ryawe ni irihe?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/240.mp3',
                'answer' => '<p> Igisubizo: Idini ryanjye ni Isilamu,<span class="c6"> bisobanuye:</span> Kwicisha bugufi kubera Allah wenyine, no kubahiriza ibyo yagutegetse umwumvira, ndetse no kwitandukanya n\'ibangikanyamana n\'abarikora.<span class="c6"><br /> Allah Nyiricyubahiro aragira ati:</span> ﴾Mu by’ukuri idini <span class="c2">(ry’ukuri)</span> imbere ya Allah ni Isilamu...﴿ <span class="c5">[Surat Al imran:19]</span>. </p>',
            ],
            2 => [
                'question' => 'Ikibazo cya gatatu: Intumwa yawe ni iyihe?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/280.mp3',
                'answer' => '<p> Igisubizo: Ni Muhamadi <span class="c2">(Imana imuhe amahoro n\'imigisha)</span>.<span class="c6"><br /> Allah Nyiricyubahiro aragira ati:</span> {Muhamad ni Intumwa ya Allah﴿ <span class="c5">[Suratul Fat\'h: 29]</span> </p>',
            ],
            3 => [
                'question' => 'Ikibazo cya kane: Vuga ijambo rya Tawhid, n\'ibisobanuro byaryo?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/310.mp3',
                'answer' => '<p> Ibisobanuro by\'ubuhamya bw\'uko nta yindi mana ikwiye gusengwa by\'ukuri: Nta wundi ukwiye kugaragirwa by\'ukuri usibye Allah.<span class="c6"><br /> Allah Nyir\'ubutagatifu yaravuze ati:</span> ﴾Bityo <span class="c2">(yewe Muhamadi)</span> menya ko nta yindi mana ikwiye gusengwa by’ukuri uretse Allah,...﴿ <span class="c5">[Surat Muhamadi:19.]</span> </p>',
            ],
            4 => [
                'question' => 'Ikibazo cya gatanu: Allah aba he?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/350.mp3',
                'answer' => '<p> Igisubizo: Allah ari mu ijuru hejuru ya Arshi iri hejuru y\'ibiremwa byose.<span class="c6"> Allah Nyir\'ubutagatifu aragira ati:</span> ﴾<span class="c2">(Allah)</span> Nyirimpuhwe uganje hejuru ya Ar’shi<span class="c4">﴿. <span class="c5">[Surat Twaha: 5]</span> Allah na none yaravuze ati : ﴾</span>Ni We Munyembaraga z’ikirenga ku bagaragu be, kandi ni We Nyirubugenge buhambaye, Uzi byose.﴿ <span class="c5">[Suratul An\'am: 18]</span> </p>',
            ],
            5 => [
                'question' => 'Ikibazo cya gatandatu: Guhamya ko Muhamadi ari Intumwa ya Allah; bisobanuye iki?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/380.mp3',
                'answer' => '<p> Igisubizo: Bisobanuye ko Allah yamwohereje ku biremwa byose, abiha inkuru nziza ndetse aranabiburira.<span class="c6"><br /> Ni n\'itegeko:</span><br /> 1- Kumwumvira mu byo yategetse.<br /> 2- Guhamya ukuri kw\'ibyo yavuze.<br /> 3- Kutamwigomekaho.<br /> 4- Kutagaragira Allah mu bundi buryo butari ubwo yigishije, ari byo bisobanuye gukurikiza imigenzo ye, no kureka ibihimbano.<span class="c6"><br /> Allah aragira ati:</span> ﴾Uwumviye Intumwa <span class="c2">(Muhamadi)</span>, mu by’ukuri aba yumviye Allah,...<span class="c4">﴿ <span class="c5">[Surat A-Nisa-<span class="c6">u:</span> 80]</span>; Allah nanone aragira ati: ﴾</span>Nta n’ubwo avuga ashingiye ku marangamutima ye. 3; Ahubwo <span class="c2">(ibyo avuga)</span> ni ibyo ahishurirwa <span class="c2">(na Allah)</span>. 4} <span class="c5">[Surat A-<span class="c6">Najm:</span>3-4]</span> Allah Nyirubutagatifu nanone yaravuze ati: ﴾Rwose mufite urugero rwiza mukomora ku Ntumwa ya Allah <span class="c2">(Muhamadi)</span>. Ibyo ni kuri wa wundi wizera Allah <span class="c2">(akemera)</span> n’umunsi w’imperuka kandi agasingiza Allah kenshi. ﴿.21 <span class="c5">[Surat Al Ah\'zab: 21]</span> </p>',
            ],
            6 => [
                'question' => 'Ikibazo cya karindwi: Kuki Allah Nyirubutagatifu yaturemye?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/480.mp3',
                'answer' => '<p> Igisubizo: yaturemye kugira ngo tumugaragire wenyine ntawe tumubangikanyije nawe.<br /> Ntabwo yaturemeye gukina nta mpamvu.<span class="c6"><br /> Allah Nyirubutagatifu aragira ati:</span> ﴾Kandi nta kindi naremeye amajini n’abantu bitari ukugira ngo bangaragire﴿56 <span class="c5">[Surat A-<span class="c6">Dhariyat:</span>56]</span> </p>',
            ],
            7 => [
                'question' => 'Ikibazo cya munani: Kugaragira Allah (Ibadat) bisobanuye iki?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/530.mp3',
                'answer' => '<p> Ni izina rusange rikusanyije icyo ari cyo cyose Allah akunda kandi yishimira, cyaba mu mvugo,no mu bikorwa bigaragara cyangwa se ibitagaragara.<br /> Mu bikorwa bigaragara harimo nko gusingiza Allah ku rurimi, umusingiza, umuha ikuzo, unavuga ubukuru bwe, gusali ndetse no gukora umutambagiro mutagatifu.<span class="c6"><br /> Naho mu bikorwa bitagaragara harimo:</span> Kumwiringira, kumutinya, ndetse no kumwizera. </p>',
            ],
            8 => [
                'question' => 'Ikibazo cya cyenda: Ni irihe tegeko kuri twe rihambaye kuruta ayandi?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/580.mp3',
                'answer' => '<p> Igisubizo: Itegeko rirusha ayandi gukomera ni ukwemera ko Allah Nyirubutagatifu ari we Mana yonyine. </p>',
            ],
            9 => [
                'question' => 'Ikibazo cya cumi: Ni ayahe moko ya Tawhiid?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/610.mp3',
                'answer' => '<p> Igisubizo: 1) Kwemera ko Allah ari we Mana yonyine <span class="c2">(Tawhiid Rububiyat)</span>: Bisobanuye kwemera ko Allah ari we wenyine Muremyi, ubeshaho ibiremwa bye, akaba umwami wabyo, akaba ari nawe mugenga wabyo, udafite uwo babangikanye.<br /> 2) Kwemera ko Allah ari we wenyine wo kugaragirwa <span class="c2">(Tawhiid al Uluhiyat)</span>: Bisobanuye ko Allah ari we wenyine ukwiye kugaragirwa; bityo nta wundi ukwiye kugaragirwa uretse Allah wenyine Nyirubutagatifu.<br /> 3) Kwemera ko Allah ari we wenyine ufite amazina meza n\'ibisingizo yihariye adahuje n\'ibindi biremwa nkuko byavuzwe muri Qur\'an no mu migenzo y\'Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span>.<span class="c6"><br /> Gihamya y\'aya moko ya Tawuhid atatu ni imvugo ya Allah igira iti:</span> ﴾Nyagasani w’ibirere n’isi n’ibiri hagati yabyo. Bityo, jya umugaragira <span class="c2">(wenyine)</span> kandi ujye uhozaho kumugaragira <span class="c2">(kabone n’iyo byaba bikugoye)</span>. Ese hari uwo waba uzi witiranwa na we?﴿ <span class="c5">[Surat Mariyam: 65]</span> </p>',
            ],
            10 => [
                'question' => 'Ikibazo cya cumi na rimwe: Ni ikihe cyaha gihambaye kuruta ibidi?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/670.mp3',
                'answer' => '<p> Igisubizo: Ni ibangikanyamana.<span class="c6"><br /> Allah Nyirubutagatifu aragira ati:</span> ﴾Mu by’ukuri, Allah ntababarira icyaha cyo kumubangikanya, ahubwo ababarira <span class="c2">(ibindi)</span> bitari icyo k’uwo ashaka. Kandi ubangikanya Allah rwose aba ahimbye icyaha gihambaye﴿48. <span class="c5">[Surat A-Nisa-<span class="c6">i:</span>48]</span> </p>',
            ],
            11 => [
                'question' => 'Ikibazo cya cumi na kabiri: Vuga ibangikanyamana n\'amoko yaryo?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/710.mp3',
                'answer' => '<p> Igisubizo: Ibangikanyamana ni ugukora icyo ari cyo cyose mu moko yo kugaragira Allah, ukagikorera abandi batari Allah Nyirubutagatifu.<span class="c6"><br /> Amoko y\'ibangikanyamana:</span><br /> Ibangikanyamana rikuru: Urugero: Ni nko gusaba ikindi kitari Allah, cyangwa kubamira ikindi kitari Allah, cyangwa kubagira ikindi kitari Allah Nyirubutagatifu.<span class="c6"><br /> Ibangikanyamana rito:</span> Urugero: Ni nko kurahirira ikindi kitari Allah Nyirubutagatifu, cyangwa kwambara amahirizi n\'ibindi byambarwa bibwira ko hari icyo byabarinda cyangwa se ngo bigire icyo bibatwara, no gukorera ijisho nko kuba yasali neza kuko abona ko abantu bamureba. </p>',
            ],
            12 => [
                'question' => 'Ikibazo cya cumi na gatatu: Ese hari undi uzi ibitagaragara usibye Allah wenyine?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/770.mp3',
                'answer' => '<p> Igisubizo: Nta wundi uzi ibitagaragara usibye Allah wenyine.<span class="c6"><br /> Allah Nyirubutagatifu aragira ati:</span> ﴾Vuga <span class="c2">(yewe Muhamadi)</span> uti “Nta n’umwe mu bari mu birere no ku isi uzi ibyihishe uretse Allah, kandi ntibazi igihe bazazurirwa﴿65. <span class="c5">[Surat A-<span class="c6">Nam\'l:</span>65]</span> </p>',
            ],
            13 => [
                'question' => 'Ikibazo cya cumi na kane: Inkingi z\'ukwemera ni zingahe?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/810.mp3',
                'answer' => '<p> Igisubizo:- 1- Kwemera Allah Nyirubutagatifu.<br /> 2- Kwemera abamalayika be.<br /> 3- Kwemera ibitabo bye.<br /> 4- Kwemera intumwa ze.<br /> 5- Kwemera umunsi w\'imperuka.<br /> 6- Kwemera igeno ry\'ikiza n\'iki ko biva ku Mana.<span class="c6"><br /> Na gihamya yabyo:</span> Hadithi ya Djibril izwi iri mu gitabo cya Muslim; Djibril yabwiye Intumwa Muhamadi <span class="c2">(Imana imuhe amahoro n\'imigisha)</span>: "Mbwira ku byerekeranye n\'ukwemera? Intumwa iramusubiza iti: Ni ukwemera Allah, abamalayika be, ibitabo bye, Intumwa ze, umunsi w\'imperuka, ndetse no kwemera igeno rya Allah ry\'ibyiza n\'ibibi". </p>',
            ],
            14 => [
                'question' => 'Ikibazo cya cumi na gatanu: Sobanura inkingi z\'ukwemera.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/900.mp3',
                'answer' => '<p> Igisubizo: Ni ukwemera Allah Nyirubutagatifu:<br /> * Ni uko wemera ko Allah ari we wakuremye, akaguha n\'amafunguro akubeshaho, akaba ari na we Mwami, Umugenga wenyine w\'ibiremwa byose.<br /> * Ni na we wo kugaragirwa, nta mugaragirwa wundi w\'ukuri usibye we.<br /> * Ni na we Uhambaye uruta byose, wuzuye ukwiye ikuzo n\'ishimwe byose, ufite amazina n\'ibisingizo byiza bihebuje, ntawe bareshya, ndetse nta n\'icyo asa nacyo Nyirubutagatifu.<span class="c6"><br /> Kwemera abamalayika:</span><br /> Abamalayika ni ibiremwa Allah yaremye mu rumuri, no kugira ngo bimugaragire binamwicisheho bugufi mu buryo bwuzuye.<br /> Muri bo harimo Djibril <span class="c2">(Imana imuhe amahoro)</span> uzana ubutumwa ku bahanuzi ba Allah mu bantu.<span class="c6"><br /> Kwemera ibitabo:</span><br /> Ni ibitabo Allah yahishuriye Intumwa ze.<br /> -<span class="c6"> Nka Qur\'an:</span> yahishuriwe Intumwa Muhamadi <span class="c2">(Imana imuhe amahoro)</span> n\'imigisha).<br /> -<span class="c6"> Ivanjili :</span> yahishuriwe Intumwa Issa <span class="c2">(Imana imuhe amahoro)</span><br /> -<span class="c6"> Tawurati:</span> yahishuriwe Mussa <span class="c2">(Imana imuhe amahoro)</span>.<br /> -<span class="c6"> Zaburi:</span> yahishuriwe Dawudi <span class="c2">(Imana imuhe amahoro)</span>.<br /> -<span class="c6"> Suhufi Ibrahiim na Mussa:</span> yahishuriwe Ibrahim na Mussa <span class="c2">(Imana ibahundagazeho amahoro)</span>.<span class="c6"><br /> Kwemera Intumwa:</span><br /> Intumwa z\'Imana ni abantu Allah yohereje ku bagaragu be, kugira ngo babigishe, banabahe inkuru nziza n\'ijuru, banababurire ibibi n\'umuriro.<span class="c6"><br /> Abeza kurusha izindi Ntumwa:</span> Ni Intumwa zari zifite ubutagamburuzwa,<span class="c6"> ari zo izi zikurikira:</span><br /> Nuhu <span class="c2">(Imana imuhe amahoro)</span>.<br /> Ibrahim <span class="c2">(Imana imuhe amahoro)</span>.<br /> Mussa <span class="c2">(Imana imuhe amahoro)</span>.<br /> Issa <span class="c2">(Imana imuhe amahoro)</span>.<br /> Muhamadi <span class="c2">(Imana imuhe amahoro n\'imigisha)</span>.<span class="c6"><br /> Kwemera umunsi w\'imperuka:</span><br /> Ni ubuzima bwa nyuma y\'urupfu mu mva. Umunsi w\'imperuka, ni na wo munsi w\'izuka n\'ibarura, ubwo abantu bo mu ijuru bazinjizwa mu ijuru, n\'abantu bo mu muriro binjizwe mu muriro.<span class="c6"><br /> Kwemera igeno ry\'ikiza n\'ikibi ko biva ku Mana:</span><br /> Igeno: Ni ukwemera ko Allah azi buri kintu kiba mu biremwa bye, no kwemera ko yabyanditse ku rubaho rurinzwe, ndetse ko ari we ushaka ko kibaho kandi yakiremye.<span class="c6"><br /> Allah aragira ati:</span> ﴾Mu by’ukuri buri kintu twakiremye ku rugero twagennye <span class="c2">(igeno ryacyo)</span><span class="c4">﴿. <span class="c5">[Surat Al Qamar: 49]</span>.<span class="c6"><br /> Igeno riri mu nzego enye:</span><br /> Urwego rwa mbere: Ubumenyi bwa Allah Nyirubutagatifu; no muri byo ni ukuba ari we ufite ubumenyi bwabanje bwa buri kintu, na mbere na nyuma y\'uko ibyo bintu bibaho.<span class="c6"><br /> Gihamya yabyo ni aho Allah agira ati:</span> ﴾</span>Mu by’ukuri Allah ni We ufite ubumenyi bw’igihe imperuka izabera; <span class="c2">(ni na We)</span> umanura imvura kandi azi n’ibiri muri nyababyeyi. Nta muntu ushobora kumenya icyo azabona <span class="c2">(azageraho)</span> ejo, ndetse nta n’umenya aho azagwa. Mu by’ukuri Allah ni Umumenyi uhebuje, Uzi byose﴿34. <span class="c5">[Surat Luqman: 34]</span><br /> Urwego rwa kabiri: Ibyo Allah yabyanditse ku rubaho rurinzwe <span class="c2">(Lawuhu Mahfudhwi)</span>; bityo buri kintu kibaho kandi kizabaho kiranditse iwe kuri urwo rubaho.<span class="c6"><br /> Gihamya yabyo ni aho Allah agira ati:</span> ﴾Ni na We ufite imfunguzo z’ibitagaragara, ntawe uzizi uretse We <span class="c2">(Allah)</span>. Kandi azi ibiri imusozi no mu nyanja, ndetse nta n’ikibabi gihanuka usibye ko aba akizi. Nta mbuto iri mu mwijima wo mu butaka, nta kibisi cyangwa icyumye usibye ko cyavuzwe mu gitabo gisobanutse<span class="c4">﴿.59 <span class="c5">[Surat An\'am: 59]</span>.<span class="c6"><br /> Urwego rwa gatatu:</span> Ni ukwemera ko buri kintu kibaho ku bushake bwa Allah, kandi ko nta na kimwe kimuturukaho cyangwa se gituruka ku biremwa bye bitari ku bushake bwe Nyirubutagatifu.<span class="c6"><br /> Gihamya yabyo ni imvugo ya Allah igira iti:</span> ﴾</span>... Kuri wa wundi muri mwe ushaka gukurikira inzira igororotse. <span class="c2">(28)</span> Kandi nta cyo mwashaka <span class="c2">(ngo kibe)</span> keretse Allah, Nyagasani w’ibiremwa <span class="c2">(byose)</span> aramutse agishatse.<span class="c2">(29)</span>}. <span class="c5">[Surat A-<span class="c6">Tak\'wiir:</span> 28-29]</span>.<span class="c6"><br /> Urwego rwa kane:</span> Kwemera ko ibiremwa byose byaremwe na Allah, niwe wabiremye ubwabyo, anarema imiterere yabyo, n\'ibyo bikora, na buri kintu kibikomokaho.<span class="c6"><br /> Gihamya yabyo ni aho Allah agira ati:</span> ﴾Kandi Allah yarabaremye, mwe n’ibyo mukora﴿ <span class="c5">[Surat Swafaat: 96]</span> </p>',
            ],
            15 => [
                'question' => 'Ikibazo cya cumi na gatandatu: Qur\'ani ni iki?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1300.mp3',
                'answer' => '<p> igisubizo: Ni amagambo ya Allah Nyirubutagatifu, ntabwo yaremwe.<span class="c6"><br /> Allah Nyirubutagatifu yaravuze ati:</span> ﴾No mu babangikanyamana nihagira ugusaba <span class="c2">(yewe Muhamadi)</span> ubuhungiro, ujye ubumuha kugira ngo yumve amagambo ya Allah...﴿ <span class="c5">[Surat Tawubat:6]</span> </p>',
            ],
            16 => [
                'question' => 'Ikibazo cya cumi na karindwi: Imigenzo y\'Intumwa y\'Imana [Sunat] (Imana iyihe amahoro n\'imigisha) ni iki?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1330.mp3',
                'answer' => '<p> Igisubizo: Ni buri mvugo, na buri gikorwa, na buri icyo Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> yemeye ko gikorwa n\'ubwo itagikora, ndetse na buri icyayiranze mu mico yayo, na mu miterere yayo karemano. </p>',
            ],
            17 => [
                'question' => 'Ikibazo cya cumi n\'umunani: Igihimbano ni iki? Ese turacyemera?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1350.mp3',
                'answer' => '<p> Igisubizo: Ni buri kintu cyose abantu bihimbiye mu idini, kitakozwe n\'Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> cyangwa se ngo gikorwe n\'abasangirangendo bayo.<br /> * Ntabwo tucyemera ahubwo turacyamagana.<br /> Kubera imvugo y’Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> igira iti: "Buri gihimbano cyose ni ubuyobe" Yakiriwe na Abu Dawudi.<span class="c6"><br /> Urugero rwabyo:</span> Ni ukongera mu bikorwa byo kwiyegereza Allah <span class="c2">(Ibadat)</span> nko kongera ikindi gice cyo gukaraba ku ngingo zo gutawaza zizwi, cyangwa se kwizihiza umunsi w\'amavuko w\'Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span>, kubera ko ntaho tubikomora ku Ntumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> cyangwa se ku basangirangendo bayo. </p>',
            ],
            18 => [
                'question' => 'Ikibazo cya cumi n\'icyenda: Vuga ku bijyanye no gukunda ndetse no kwanga kubera Allah (Al Wala-u wal Bara-u)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1410.mp3',
                'answer' => '<p> Igisubizo: Al Wala-<span class="c6">u:</span> Ni ugukunda abemeramana ndetse no kubatabara.<span class="c6"><br /> Allah Nyirubutagatifu aragira ati:</span> <span class="c4">{Abemeramana n\'abemeramanakazi ni inshuti hagati yabo. }</span> <span class="c5">[Surat Tawbat: 71]</span><br /> Naho Al Bara-<span class="c6">u:</span> Ni ukwanga abahakanyi no kutabakunda.<span class="c6"><br /> Allah Nyirubutagatifu aragira ati:</span> <span class="c4">{Mu by’ukuri mwagize urugero rwiza kuri Ibrahim n’abari kumwe nawe, ubwo babwiraga abantu babo bati “Rwose twitandukanyije namwe ndetse n’ibyo mugaragira bitari Allah. Turabahakanye, kandi hagati yacu namwe havutse ububisha n’ubugome bihoraho, kugeza ubwo muzemera Allah wenyine...}</span> <span class="c5">[Surat Al Mumtahinat: 4]</span> </p>',
            ],
            19 => [
                'question' => 'Ikibazo cya makumyabiri: Ese Allah hari irindi dini azemera ritari Isilamu?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1480.mp3',
                'answer' => '<p> Igisubizo: Allah ntazemera irindi dini ritari Isilamu.<span class="c6"><br /> Allah Nyirubutagatifu aragira ati:</span> <span class="c4">{Uzahitamo idini ritari Isilamu, ntabwo azaryakirirwa, kandi ku munsi w’imperuka azaba mu banyagihombo. 85}</span> <span class="c5">[Surat Al Imran: 85]</span> </p>',
            ],
            20 => [
                'question' => 'Ikibazo cya makumyabiri na rimwe: Ubuhakanyi bugaragara mu mvugo, mu bikorwa, no mu myemerere. Tanga urugero rwabyo?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1520.mp3',
                'answer' => '<p> Igisubizo: Urugero rw\'ubuhakanyi mu mvugo: Ni nko gutuka Allah Nyirubutagatifu cyangwa se Intumwa ye <span class="c2">(Imana iyihe amahoro n\'imigisha)</span>.<br /> Naho urugero rw\'ubuhakanyi mu bikorwa, ni nko gutesha agaciro Musw\'haf yanditsemo Qur\'an cyangwa kubamira ikindi kitari Allah Nyirubutagatifu.<br /> Naho urugero rw\'ubuhakanyi mu myemerere, ni nko kwemera ko hari undi ukwiye kugaragirwa utari Allah Nyirubutagatifu cyangwa se kwemera ko hari undi Muremyi ubangikanye na Allah Nyirubutagatifu. </p>',
            ],
            21 => [
                'question' => 'Ikibazo cya makumyabiri na kabiri: Uburyarya ni iki? Ni n\'ayahe moko yabwo?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1570.mp3',
                'answer' => '<p> Igisubizo:<br /> 1- Uburyarya bukuru <span class="c2">(A-Nifaqul Akbar)</span>: Ni uguhisha ubuhakanyi ukagaragaza ukwemera.<br /> Ubu bwoko bw\'uburyarya bukura nyirabwo mu buyisilamu, kandi ni kimwe mu bigaragaza ubuhakanyi bukuru <span class="c2">(Al Kufru Al Akbar)</span>.<span class="c6"><br /> Allah Nyirubutagatifu aragira ati:</span> {Mu by’ukuri indyarya zizaba ziri mu ndiba y’umuriro, kandi <span class="c2">(yewe Muhamadi)</span> ntuzababonera umutabazi. 145} <span class="c5">[Surat A-Nisa-<span class="c6">i:</span>145]</span><br /> 2- Uburyarya buto <span class="c2">(A-Nifaqul Asw\'ghar)</span>:<br /> Urugero: Kubeshya no kutuzuza isezerano ndetse no kutarinda indagizo.<br /> Ubu buryarya ntibukura nyirabwo mu buyisilamu, ahubwo ni kimwe mu byaha nyirabwo yazahanirwa.<br /> Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> yaravuze iti: "Ibimenyetso biranga indyarya ni bitatu: Iyo iganira irabeshya, yatanga isezerano ikaryica, yakwizerwa igahemuka." Yakiriwe na Bukhari na Muslim. </p>',
            ],
            22 => [
                'question' => 'Ikibazo cya makumyabiri na gatatu: Ninde wasozereje Intumwa n\'abahanuzi?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1680.mp3',
                'answer' => '<p> Igisubizo: Ni Muhamadi <span class="c2">(Imana imuhe amahoro n\'imigisha)</span>.<span class="c6"><br /> Allah Nyirubutagatifu aragira ati:</span> ﴾Ntabwo Muhamadi ari se w’uwo ari we wese muri mwe, ahubwo ni Intumwa ya Allah akaba n’uwasozereje abahanuzi...﴿ <span class="c5">[Surat Al Ah\'zab: 40]</span> Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> yaravuze iti: "Ni nanjye wasozereje abahanuzi, nta muhanuzi uzaza nyuma yanjye." Yakiriwe na Abu Dawudi na Tirmidhi ndetse n\'abandi. </p>',
            ],
            23 => [
                'question' => 'Ikibazo cya makumyabiri na kane: Igitangaza ni iki?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1730.mp3',
                'answer' => '<p> Igisubizo: Igitangaza ni buri icyo ari cyo cyose Allah yahaye abahanuzi be mu bitangaza bidasanzwe ndengakamere kugira ngo bihamye ukuri kwabo,<span class="c6"> Ingero:</span><br /> - Gusaduka k\'ukwezi ku gihe cy\'Intumwa Muhamadi <span class="c2">(Imana iyihe amahoro n\'imigisha)</span><br /> - Gucikamo kabiri kw\'inyanja ku gihe cy\'Intumwa y\'Imana Mussa <span class="c2">(Imana imuhe amahoro)</span>, no korama kwa Farawo n\'ingabo ze. </p>',
            ],
            24 => [
                'question' => 'IKibazo cya makumyabiri na gatanu: Abasangirangendo b\'Intumwa y\'Imana (Imana iyihe amahoro n\'imigisha) ni bantu ki? Ese ngomba kubakunda?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1780.mp3',
                'answer' => '<p> Igisubizo: Umusangirangendo ni uwahuye n\'Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span>, akayemera ndetse akanapfa akiri ku buyisilamu.<br /> - Tugomba kubakunda no kubigana, kandi ni bo beza kuruta abandi bantu nyuma y\'abahanuzi ba Allah.<span class="c6"><br /> Abeza muri bo kurusha abandi ni:</span> Abayobozi bane bayoboye nyuma y\'Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span>:<br /> Abubakar <span class="c2">(Imana imwishimire)</span><br /> Umar <span class="c2">(Imana imwishimire)</span><br /> Uth\'man <span class="c2">(Imana imwishimire)</span><br /> Ally <span class="c2">(Imana imwishimire)</span> </p>',
            ],
            25 => [
                'question' => 'Ikibazo cya makumyabiri na gatandatu: Ni bande ba nyina b\'abemera?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1870.mp3',
                'answer' => '<p> Igisubizo: Ni abagore b\'Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span><br /> Allah Nyiricyubahiro aragira ati: {Umuhanuzi <span class="c2">(Muhamadi)</span> ni we ufite agaciro ku bemeramana kurusha ako bifiteho ubwabo, ndetse n’abagore be ni ababyeyi babo <span class="c2">(ku bw’icyubahiro bakwiye ndetse no kuba batashakwa n’abandi bagabo)</span>.} <span class="c5">[Surat Al Ah\'zab: 6]</span> </p>',
            ],
            26 => [
                'question' => 'Ikibazo cya makumyabiri na karindwi: Ni ubuhe burenganzira bw\'abantu bo mu muryango w\'Intumwa y\'Imana (Imana iyihe amahoro n\'imigisha) tubagomba?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1910.mp3',
                'answer' => '<p> Igisubizo: Tugomba kubakunda, tukanga ababanga, ariko ntitubakabirize. Abo nta bandi ni abagore b\'Intumwa y\'Imana n\'urubyaro rwayo, na bene Hashim, na bene Abdul Mutwalib mu bemeramana. </p>',
            ],
            27 => [
                'question' => 'Ikibazo cya makumyabiri n\'umunani: Ni iki tugomba abayobozi b\'abayisilamu?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1940.mp3',
                'answer' => '<p> Igisubizo: Icyo tubagomba ni ukububaha, kubumva ndetse no kubumvira bitarimo kuduhamagarira kwigomeka kuri Allah, no kutabigomekaho, ndetse no kubasabira no kubagira inama mu ibanga. </p>',
            ],
            28 => [
                'question' => 'Ikibazo cya makumyabiri n\'icyenda: Ni ubuhe buturo bw\'abemeramana?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1970.mp3',
                'answer' => '<p> Igisubizo: Ni ijuru.<span class="c6">Allah aragira ati:</span> {Mu by’ukuri ba bandi bemeye bakanakora ibikorwa byiza, Allah azabinjiza mu busitani butembamo imigezi <span class="c2">(Ijuru)</span>...} <span class="c5">[Surat Muhamadi:12.]</span> </p>',
            ],
            29 => [
                'question' => 'Ikibazo cya mirongo itatu: Ni ubuhe buturo bw\'abahakanyi?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2000.mp3',
                'answer' => '<p> Igisubizo: Ni umuriro; Allah aragira ati: {ngaho nimwirinde umuriro, wo ibicanwa byawo <span class="c2">(bizaba ari)</span> abantu n’amabuye; wateguriwe abahakanyi.} <span class="c5">[Surat Al Baqarat: 24.]</span> </p>',
            ],
            30 => [
                'question' => 'Ikibazo cya mirongo itatu na rimwe: Gutinya ni iki? Kwizera ni iki? Ni n\'izihe gihamya zabyo?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2020.mp3',
                'answer' => '<p> Igisubizo: Gutinya ni ugutinya Allah no gutinya ibihano bye.<br /> Naho Kwizera ni ukwizera ingororano za Allah, imbabazi ze ndetse n\'impuhwe ze.<span class="c6"><br /> Gihamya y\'ibi ni imvugo ya Allah igira iti:</span> {Abo basenga <span class="c2">(bababangikanyije na Allah; nka Ezra, Yesu n’abandi biyeguriye Imana)</span> na bo ubwabo <span class="c2">(basengaga Allah)</span> bakanashaka uburyo bwo kumwiyegereza, bizera impuhwe ze ndetse bakanatinya ibihano bye. Mu by’ukuri ibihano bya Nyagasani wawe biratinyitse.} <span class="c5">[Surat Al Is\'ra-i; 57.]</span> Allah Nyirubutagatifu na none aragira ati: {<span class="c2">(Yewe Muhamadi)</span> bwira abagaragu banjye ko mu by’ukuri ndi Ubabarira ibyaha, Nyirimpuhwe. 49. Kandi ko n’ibihano byanjye ari ibihano bibabaza cyane. 50} <span class="c5">[Surat Al Hidj\'ri: 49-50]</span> </p>',
            ],
            31 => [
                'question' => 'Ikibazo cya mirongo itatu na kabiri: Vuga amwe mu mazina ya Allah n\'ibisingizo bye Nyirubutagatifu.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2070.mp3',
                'answer' => '<p> Igisubizo: Allah, Nyagasani, Nyirimbabazi, Uwumva bihebuje, Ubona bihebuje, Umumenyi uhebuje, Utanga amafunguro, Uhoraho, Uw\'ikirenga,... n\'andi mazina meza n\'ibisingizo bihebuje. </p>',
            ],
            32 => [
                'question' => 'Ikibazo cya mirongo itatu na gatatu: Sobanura aya mazina?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2100.mp3',
                'answer' => '<p> Igisubizo: Allah: bisobanuye Ugaragirwa, usengwa by\'ukuri wenyine udafite uwo babangikanye.<br /> Rabbu <span class="c2">(Nyagasani)</span> bisobanuye ko ari we Muremyi wenyine, Umwami, Utanga amafunguro, Umugenga.<br /> A-Sami\'u <span class="c2">(Uwumva bihebuje)</span> bisobanuye ko yumva buri kintu, ndetse akumva n\'amajwi yose n\'uburyo aba atandukanye.<br /> Al Baswiir <span class="c2">(Ubona bihebuje)</span> bisobanuye ubona buri kintu, akabona buri kintu cyaba gito cyangwa se kinini.<br /> Al Aliim <span class="c2">(Umumenyi uhebuje)</span> bisobanuye ufite ubumenyi bwa buri kintu cyahise, kiriho ndetse n\'ikizabaho.<br /> A-Rahman <span class="c2">(Nyirimpuhwe)</span> bisobanuye uwo impuhwe ze zikwiriye buri kiremwa cyose na buri kinyabuzima cyose; bityo abagaragu bose n\'ibiremwa byose biri munsi y\'impuhwe ze.<br /> A-Razaaq <span class="c2">(Utanga amafunguro)</span> bisobanuye uha amafunguro ibiremwa bye byose byaba abantu cyangwa se amajini n\'ibindi binyabuzima byose.<br /> Al Hayyu <span class="c2">(Uhoraho)</span> bisobanuye ko adapfa, nyamara ibiremwa byo bizapfa byose.<br /> Al Adhwiim <span class="c2">(Uw\'ikirenga)</span> bisobanuye ufite ubutungane bwose n\'ubuhambare mu mazina ye, mu bisingizo bye ndetse no mu bikorwa bye. </p>',
            ],
            33 => [
                'question' => 'Ikibazo cya mirongo itatu na kane: Ni iki tugomba abamenyi b\'abayisilamu?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2210.mp3',
                'answer' => '<p> Igisubizo: Tugomba kubakunda, ndetse tukaba ari nabo tugarukaho mu bibazo by\'idini ducyeneye gusobanukirwa, kandi tukabavuga ibyiza gusa. N\'uzabavugaho ibitandukanye n\'ibi bibi, uwo azaba ayobye inzira nyayo.<span class="c6"><br /> Allah Nyiricyubahiro aragira ati:</span> <span class="c4">{...Allah azamura mu ntera abemeye n’abahawe ubumenyi muri mwe. Kandi Allah ni Umumenyi uhebuje w’ibyo mukora.11}</span> <span class="c5">[Surat Al Mudjadalat: 11]</span> </p>',
            ],
            34 => [
                'question' => 'Ikibazo cya mirongo itatu na gatanu: Abakunzi ba Allah Nyirubutagatifu ni bantu ki?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2240.mp3',
                'answer' => '<p> Igisubizo: Ni abemeramana kandi bayitinya.<span class="c6"><br /> Allah Nyiricyubahiro aragira ati:</span> {Nta gushidikanya ko mu by’ukuri inshuti za Allah zitazigera zigira ubwoba ndetse n’agahinda.62 <span class="c2">(Abo ni)</span> ba bandi bemeye kandi bakaba baratinyaga Allah.} <span class="c5">[Surat Yunus: 62-63]</span> </p>',
            ],
            35 => [
                'question' => 'Ikibazo cya mirongo itatu na gatandatu: Ese Ukwemera (Imani) ni mu mvugo no mu bikorwa gusa?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2280.mp3',
                'answer' => '<p> Igisubizo: Ukwemera <span class="c2">(Imani)</span> ni mu mvugo no mu bikorwa ndetse no mu myizerere. </p>',
            ],
            36 => [
                'question' => 'Ikibazo cya mirongo itatu na karindwi: Ese Ukwemera (Imani) kuriyongera kukanagabanuka?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2310.mp3',
                'answer' => '<p> Igisubizo: Ukwemera kongerwa n\'ibikorwa byo kumvira Allah, kukagabanywa n\'ibikorwa byo kumwigomekaho.<span class="c6"><br /> Allah Nyiricyubahiro aragira ati:</span> "Mu by’ukuri abemeramana nyabo ni ba bandi iyo Allah avuzwe, imitima yabo ikangarana, banasomerwa amagambo ye akabongerera ukwemera; kandi bakiringira Nyagasani wabo <span class="c2">(wenyine)</span>"; <span class="c5">[Surat Al Anfal: 2]</span>. </p>',
            ],
            37 => [
                'question' => 'Ikibazo cya mirongo itatu n\'umunani: Gukora neza (Ih\'saan) ni gute?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2350.mp3',
                'answer' => '<p> Igisubizo: Ni ukugaragira Allah nkaho umureba, waba utamubona ukazirikana ko we akureba. </p>',
            ],
            38 => [
                'question' => 'Ikibazo cya mirongo itatu n\'icyenda: Ni ryari ibikorwa umuntu akora byakirwa imbere ya Allah?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2370.mp3',
                'answer' => '<p> Igisubizo: Byakirwa ku mpamvu ebyiri:<br /> 1- Kuba yabikoze agamije gushimisha Allah wenyine.<br /> 2- Kandi akabikora biri ku murongo n\'umugenzo w\'Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> </p>',
            ],
            39 => [
                'question' => 'Ikibazo cya mirongo ine: Kwiringira Allah ni gute?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2420.mp3',
                'answer' => '<p> Igisubizo: Ni ukwishingikiriza Allah wenyine mu gukora ibigufitiye akamaro, no kwirinda ibikugiraho ingaruka, kandi ugakora iyo bwabaga ngo ubigereho.<span class="c6"><br /> Allah Nyiricyubahiro aragira ati:</span> <span class="c4">{Kandi uwiringira Allah, aramuhagije.}</span> <span class="c5">[Surat A-<span class="c6">Twalaq:</span> 3]</span><br /> Aramuhagirije: Nta wundi acyeneye. </p>',
            ],
            40 => [
                'question' => 'Ikibazo cya mirongo ine na rimwe: Ni irihe tegeko ryo kubwiriza ibyiza no kubuza ibibi?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2470.mp3',
                'answer' => '<p> Igisubizo: Kubwiriza ibyiza bisobanuye kubwiriza kumvira amategeko ya Allah Nyirubutagatifu, naho kubuza ibibi bisobanuye kubuza ibyo ari byo byose bituma umuntu yigomeka kuri Allah Nyirubutagatifu.<span class="c6"><br /> Allah Nyiricyubahiro aragira ati:</span> <span class="c4">{Muri umuryango uboneye watoranyirijwe abantu; mubwirizanya ibyiza mukabuzanya ibibi kandi mukanemera Allah...}</span> <span class="c5">[Surat Al Imran:110]</span> </p>',
            ],
            41 => [
                'question' => 'Ikibazo cya mirongo ine na kabiri: Abakurikiye imigenzo y\'Intumwa y\'Imana kandi bari hamwe (Ahl Sunat wal Djama\'at) ni bantu ki?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2510.mp3',
                'answer' => '<p> Igisubizo: Ni uwo ari we wese ukurikiza Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> n\'abasangirangendo bayo mu mvugo, mu bikorwa n\'imyizerere.<br /> Biswe iyi nyito kubera ko bakurikira Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span>, ndetse bakirinda ibihimbano <span class="c2">(Bid\'at)</span>.<br /> Naho kuba hamwe <span class="c2">(Al Djama\'at)</span> ni ukubera ko bahurije ku kuri, ntibagutandukaneho. </p>',
            ],
        ],
        2 => [
            0 => [
                'question' => 'Ikibazo cya mbere: Sobanura ijambo TWAHARAT?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2580.mp3',
                'answer' => '<p> Igisubizo: Twaharat ni isuku umuntu akora yisukura umwanda wamusohotsemo <span class="c2">(Al Hadath)</span> cyangwa se umwanda wamugiyeho <span class="c2">(Al Khabath)</span>.<span class="c6"><br /> Twaharat ul Khabath:</span> Ikorwa umuyisilamu yikuraho umwanda wamugiye ku mubiri we, ku myambaro ye, cyangwa se ahantu agiye gusalira.<span class="c6"><br /> Twaharat ul Hadath:</span> Ikorwa umuyisilamu atawaza <span class="c2">(Udhu)</span> cyangwa se yiyuhagira umubiri wose n\'amazi asukuye, cyangwa se yisukuza itaka <span class="c2">(Tayamum)</span> igihe yabuze amazi cyangwa se adashoboye kwisukuza amazi. </p>',
            ],
            1 => [
                'question' => 'Ikibazo cya kabiri: Ni gute wisukura umwanda wakugiyeho (Nadjasat)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2630.mp3',
                'answer' => '<p> Igisubizo: Wiyuhagira n\'amazi kugeza ucyeye.<br /> Naho icyakozweho n\'izuru ry\'imbwa, cyokozwa inshuro zirindwi zibanza n\'itaka. </p>',
            ],
            2 => [
                'question' => 'Ikibazo cya gatatu: Ni ibihe byiza byo gutawaza (Udhu)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2660.mp3',
                'answer' => '<p> Igisubizo: Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> yaravuze iti: "Iyo umugaragu w\'umuyisilamu cyangwa se w\'umwemeramana atawaje, agakaraba mu maso he, buri cyaha yarebesheje amaso ye kimuvaho hamwe na ya mazi cyangwa se n\'igitonyanga cya nyuma cya ya mazi amwumukaho. Iyo akarabye amaboko ye, buri cyaha yakoresheje amaboko ye kimuvaho hamwe na ya mazi cyangwa se n\'igitonyanga cya nyuma cya ya mazi amwumukaho. Iyo akarabye ibirenge bye, buri cyaha yakoresheje ibirenge bye agenda kimuvaho hamwe na ya mazi cyangwa se igitonyanga cya nyuma cya ya mazi amwumukaho, kugeza ubwo arangiza asukutse nta cyaha afite. \\Yakiriwe na Muslim. </p>',
            ],
            3 => [
                'question' => 'Ikibazo cya kane: Ni gute nisukura (Udhu)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2690.mp3',
                'answer' => '<p> Igisubizo: Ni ugukaraba ibiganza gatatu.<br /> Warangiza ukajuguta amazi mu kanwa, ukanayashoreza, nyuma ukayapfuna. Ibyo ukabikora inshuro eshatu.<span class="c6"><br /> Kujuguta amazi:</span> Ni ukuyashyira mu kanwa, ukayakura mu itama rimwe uyashyira mu rindi warangiza ukayacira.<br /> Naho kuyashoreza ni ukuyinjiza mu izuru uyashoreze ukoresheje ikiganza cyawe cy\'indyo.<br /> Naho kuyapfuna ni ukuyasohora mu izuru ukoresheje ikiganza cyawe cy\'imoso.<br /> Iyo urangije ukaraba mu buranga bwawe inshuro eshatu.<br /> Hanyuma ugakaraba amaboko yawe yombi ugeza mu nkokora inshuro eshatu.<br /> Warangiza ugahanagura mu mutwe wawe n\'ibiganza byawe uhereye mu ruhanga ujyana inyuma, ukanabigarura, maze ugahanagura n\'amatwi.<br /> Hanyuma agakaraba ibirenge byawe byombi ugeza ku tubumbankore.<br /> Ubu buryo nibwo butunganye kandi bwuzuye. Byanakomowe mu buryo bwizewe ku Ntumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> muri Hadithi za Bukhari na Muslim, bakiriye bakuye kuri Uth\'man na Abdallah Ibun Zayd ndetse n\'abandi. Nkuko na none byashimangiwe biturutse kwa Uth\'man mu mvugo ya Bukhari n\'abandi ivuga ko yatawaje inshuro imwe imwe, nanone ko yatawaje inshuro ebyiri ebyiri. Bisobanuye ko buri rugingo mu ngingo batawaza yarwozaga inshuro imwe cyangwa ebyiri. </p>',
            ],
            4 => [
                'question' => 'Ikibazo cya gatanu: Ni ibihe bice by\'itegeko umuntu ategetswe gutawaza, vuga n\'umubare wabyo?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2810.mp3',
                'answer' => '<p> Igisubizo: Ni ibice gutawaza k\'umuyisilamu kutakwemerwa aramutse aretse kimwe muri byo ntagitawaze.<br /> 1- Gukaraba uburanga ari naho hashamikiye kujuguta amazi mu kanwa no kuyashoreza mu zuru.<br /> 2- Gukaraba amaboko yombi kugeza mu nkokora.<br /> 3- Guhanagura mu mutwe, hashamikiyeho no guhanagura amatwi yombi.<br /> 4- Gukaraba ibirenge byombi ugeza ku tubumbankore.<br /> 5- Kubikurikiranya hagati y\'izo ngingo uko zikurikiranye uhereye ku gukaraba uburanga, ugakurikizaho amaboko, ugakurikizaho guhanagura ku mutwe, ugaherukira ku gukaraba ibirenge.<br /> 6- Kubyungikanya ukabikorera mu gihe kimwe, utanyujijemo umwanya watuma ingingo wakarabye zumuka.<br /> Nko kuba watawaza wagera hagati ukarekeraho ukaza gukomeza nyuma, ubu buryo ntabwo bwemewe. </p>',
            ],
            5 => [
                'question' => 'Ikibazo cya gatandatu: Ni ibihe bice by\'umugereka bitari itegeko umuntu ategetswe gutawaza, vuga n\'umubare wabyo?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2910.mp3',
                'answer' => '<p> Igisubizo: Ibice by\'umugereka mu gutawaza ni bya bindi iyo ubikoze bikongerera ibihembo n\'ingororano ariko iyo ubiretse ntabwo ubihanirwa, no gutawaza kwawe icyo gihe kuba kwemewe.<br /> 1-<span class="c6"> Kuvuga Bismillah:</span> Ku izina rya Allah.<br /> 2- Koza mu kanwa n\'umuswaki <span class="c2">(uburoso,...)</span><br /> 3- Gukaraba ibiganza byombi.<br /> 4- Gutosa hagati y\'intoki.<br /> 5- Gukaraba ingingo inshuro ebyiri cyangwa se eshatu<br /> 6- Guhera iburyo.<br /> 7-<span class="c6"> Kuvuga ubusabe nyuma yo gutawaza:</span> "ASH\'HADU ALA ILAHA ILALLAH,<span class="c6"> WAHDAHU LA SHARIKA LAHU WA ASHAHADU ANA MUHAMADAN ABDUHU WA RASULUHU:</span> Ndahamya ko nta yindi mana ikwiye gusengwa usibye Allah wenyine, udafite uwo babangikanye, nkanahamya ko Muhamadi ari umugaragu wayo n\'Intumwa yayo."<br /> 8- Gusali raka ebyiri nyuma yaho. </p>',
            ],
            6 => [
                'question' => 'Ikibazo cya karindwi: Vuga umubare w\'ibyangiza Udhu?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3020.mp3',
                'answer' => '<p> Igisubizo: Ni icyo ari cyo cyose gisohotse muri imwe mu nzira ebyiri: Iy\'imbere cyangwa se iy\'inyuma nk\'inkari, amabyi, cyangwa se umusuzi.<br /> Ibitotsi, gusara, no guta ubwenge by\'amarabira.<br /> Kurya inyama y\'ingamiya.<br /> Gukora ku gitsina, cyangwa se mu kibuno n\'intoki nta kizikingirije. </p>',
            ],
            7 => [
                'question' => 'Ikibazo cya munani: Tayamum ni iki?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3080.mp3',
                'answer' => '<p> Igisubizo: Ni ukwisukuza itaka n\'ikindi nkaryo nk\'umucanga igihe amazi yabuze cyangwa se igihe bitashobokera umuntu kwisukuza amazi. </p>',
            ],
            8 => [
                'question' => 'Ikibazo cya cyenda: Ni gute wisukuza itaka (Tayamum)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3110.mp3',
                'answer' => '<p> Igisubizo: Ni ugukoza ibiganza ku butaka inshuro imwe ukoresheje ibiganza, no kubihanaguza mu buranga, n\'inyuma y\'ibiganza inshuro imwe. </p>',
            ],
            9 => [
                'question' => 'Ikibazo cya cumi: Ni ibiki byangiza isuku yo gutayamamu?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3140.mp3',
                'answer' => '<p> Igisubizo: Ibyangiza isuku y\'amazi byose byangiza Tayamum.<br /> - Iyo amazi abonetse. </p>',
            ],
            10 => [
                'question' => 'Ikibazo cya cumi na rimwe: Khofu n\'amasogisi ni iki? Ese nabyo birahanagurwa?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3180.mp3',
                'answer' => '<p> Igisubizo: Khofu ni nk\'amasogisi yambarwa ku birenge aba akoze mu ruhu.<br /> Naho amasogisi yo ntabwo aba akoze mu ruhu.<br /> Biremewe ku bihanaguraho byombi mu mwanya wo gukaraba ibirenge. </p>',
            ],
            11 => [
                'question' => 'Ikibazo cya cumi na kabiri: Garagaza ubugenge buri mu guhanagura Khofu ebyiri?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3230.mp3',
                'answer' => '<p> Igisubizo: Ni mu rwego rwo koroshya no korohereza abagaragu by\'umwihariko mu bihe by\'imbeho n\'imvura nyinshi ndetse no mugihe cy\'urugendo, kubera ko biba bigoye kubyiyambura. </p>',
            ],
            12 => [
                'question' => 'Ikibazo cya cumi na gatatu: Ni ibiki bisabwa kugira ngo guhanagura Khofu bibe byemewe?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3260.mp3',
                'answer' => '<p> Igisubizo: -1- Nuko uba wambaye Khofu ufite isuku, ndetse watawaje.<br /> 2- Nuko Khofu na zo zigomba kuba zisukuye, kuko ntibyemewe guhanagura Khofu zifite umwanda.<br /> 3- Khofu zigomba kuba zikwiriye ikirenge cyose bakaraba igihe bari gutawaza <span class="c2">(ntaho zacitse)</span>.<br /> 4- Guhanagura byemerwa mu gihe kingana n\'amanywa n\'ijoro ku muntu utari ku rugendo . Naho uri ku rugendo ni iminsi itatu n\'amajoro yayo. </p>',
            ],
            13 => [
                'question' => 'Ikibazo cya cumi: Guhanagura Khofu bikorwa bite?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3320.mp3',
                'answer' => '<p> Igisubizo: Guhanagura Khofu bikorwa mu buryo bukurikira: Ni ukunyuza intoki zitose n\'amazi, ku mano y\'ibirenge bye hanyuma akabinyuza hejuru y\'ibirenge bye, agahanagura ikirenge cye cy\'iburyo akoresheje ikiganza cy\'iburyo, n\'ikirenge cye cy\'ibumoso akoresheje ikiganza cy\'ibumoso; agatandukanya intoki ze igihe ari guhanagura kandi ntasubiremo. </p>',
            ],
            14 => [
                'question' => 'Ikibazo cya cumi na gatanu: Ni ibiki byangiza isuku yo guhanagura Khofu?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3350.mp3',
                'answer' => '<p> Igisubizo: 1- Ni ukuba igihe cyo guhanagura cyarangiye; icyo gihe ntibiba byemewe guhanagura Khofu nyuma y\'uko igihe cyayo ntarengwa cyemewe n\'amategeko cyarangiye, ari cyo kingana n\'amanywa n\'ijoro ku muntu utari ku rugendo, n\'iminsi itatu n\'amajoro yayo ku muntu uri ku rugendo.<br /> 2- Kwiyambura Khofu; iyo umuntu aziyambuye cyangwa agakuramo imwe muri izi ebyiri nyuma y\'uko yari yazihanaguye, icyo gihe kuzihanagura kwe biba bibaye impfabusa. </p>',
            ],
            15 => [
                'question' => 'Ikibazo cya cumi na gatandatu: Iswala ni iki?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3390.mp3',
                'answer' => '<p> Igisubizo: Iswala ni ukugaragira Allah wifashishije amagambo n\'ibikorwa runaka bitangirwa n\'ijambo Allahu Akbaru bigasozwa n\'indamutso y\'amahoro <span class="c2">(A-Salamu)</span>. </p>',
            ],
            16 => [
                'question' => 'Ikibazo cya cumi na karindwi: Ni irihe tegeko ry\'Iswala?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3420.mp3',
                'answer' => '<p> Iswala ni itegeko kuri buri muyisilamu.<span class="c6">)<br /> Allah Nyirubutagatifu aragira ati:</span> <span class="c2">(Mu by\'ukuri Iswala ku bemeramana ni itegeko ryashyiriweho igihe kigenwe. (103)</span> <span class="c5">[Surat A-Nisa-<span class="c6">i:</span>103]</span> </p>',
            ],
            17 => [
                'question' => 'Ikibazo cya cumi n\'umunani: Ni irihe tegeko ry\'umuntu ureka Iswala?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3460.mp3',
                'answer' => '<p> Igisubizo: Kureka Iswala ni ubuhakanyi; Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> yaravuze iti:<br /> <span class="c1">“Itandukaniro riri hagati yacu na bo ni iswala, bityo urireka aba ahakanye.”</span><br /> Yakiriwe na Ahmad na Tirmidhi ndetse n\'abandi. </p>',
            ],
            18 => [
                'question' => 'Ikibazo cya cumi n\'icyenda: Umuyisilamu ategetswe Iswala zingahe ku manywa n\'ijoro?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3500.mp3',
                'answer' => '<p> Igisubizo: Ni Iswala eshanu ku manywa na nijoro; Iswala ya mu gitondo ni raka ebyiri, iya ku manywa ni raka enye, iyo ku gicamunsi ni raka enye, iya nimugoroba ni raka eshatu, n\'iyo mu ijoro ni raka enye. </p>',
            ],
            19 => [
                'question' => 'Ikibazo cya makumyabiri: Vuga umubare w\'ibisabwa kugira ngo Iswala ikorwe.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3530.mp3',
                'answer' => '<p> Igisubizo: 1- Ubuyisilamu; kubera ko Iswala itakwemerwa iramutse ikozwe n\'umuhakanyi.<br /> 2- Ubwenge; Iswala ikozwe n\'umusazi ntabwo yakwemerwa.<br /> 3- Kuba aciye akenge akuze; kuko Iswala y\'umwana muto utaraca akenge ntabwo yemerwa.<br /> 4- Kugira umugambi <span class="c2">(Niyat)</span>.<br /> 5- Kuba igihe cyo gusali cyageze.<br /> 6- Isuku yo kwikuraho umwanda.<br /> 7- Isuku yo kwikuraho umwanda wakugiyeho.<br /> 8- Guhisha ubwambure.<br /> 9- Kwerekera ku ngoro ya Al Kaabat i Maka <span class="c2">(Qib\'lat)</span>. </p>',
            ],
            20 => [
                'question' => 'Ikibazo cya makumyabiri na rimwe: Vuga umubare w\'inkingi z\'Iswala.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3640.mp3',
                'answer' => '<p> Igisubizo: Ni inkingi cumi n\'enye,<span class="c6"> ni izi zikurikira:</span><br /> Iya mbere: Gusali uhagaze ku muntu ubishoboye.<br /> Kuvuga ijambo Allahu Akbar, Takbiratul Ihram <span class="c2">(iziririza ikindi icyo ari cyo cyose wakora kitari mu Iswala)</span>.<br /> Gusoma Surat Al Fatihat.<br /> Kunama <span class="c2">(Ruku\'u)</span> umugongo urambuye n\'umutwe we ukaba uteganye n\'umugongo.<br /> Kunamuka.<br /> Guhagarara wemye.<br /> Kubama no gutuma uruhanga, izuru, ibiganza byombi, amavi yombi n\'intoki zikora hasi ku butaka aho yubamye.<br /> Kubamuka.<br /> Kwicara hagati y\'ibyubamo bibiri.<br /> Ikiri mu mugenzo w\'Intumwa y\'Imana <span class="c2">(Sunat)</span> ni ukwicarira ukuguru kw\'ibumoso, no gushinga ukw\'iburyo ukwerekeje Qib\'lat.<br /> Kugira ituze muri buri nkingi ukoze.<br /> Kuvuga ubuhamya bwa nyuma.<br /> Kwicara uri kuvuga ubwo buhamya.<br /> Kuvuga indamutso <span class="c2">(A-Salam)</span> inshuro ebyiri ugira uti: "A-<span class="c6">Salamu Alaykum wa Rahmatullah:</span> Amahoro n\'imigisha bya Allah bibe kuri rimwe".<br /> Gukurikiranya izi nkingi nk\'uko twabivuze, kuko aramutse yubamye <span class="c2">(Sujud)</span> mbere yo kunama <span class="c2">(Ruku)</span> abishaka, Iswala ntiyemerwa; n\'iyo yibagiwe agomba kongera kunama <span class="c2">(Ruku\'u)</span> hanyuma akabona kubama <span class="c2">(Sudjud)</span>. </p>',
            ],
            21 => [
                'question' => 'Ikibazo cya makumyabiri na kabiri: Vuga ibice by\'itegeko by\'Iswala.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3820.mp3',
                'answer' => '<p> Igisubizo: Ibice by\'itegeko by\'Iswala ni umunani,<span class="c6"> ni ibi bikurikira:</span><br /> 1- Kuvuga Takbirat <span class="c2">(Ijambo Allah Akbar)</span> itari Takbirat itangira Iswala <span class="c2">(Takbirat Al Ihram)</span>.<br /> 2-<span class="c6"> Kuvuga ijambo "SAMIALLAHU LIMAN HAMIDAHU:</span> Allah yumva umusingiza" kuri Imam no ku muntu usali ari wenyine.<br /> 3-<span class="c6"> Kuvuga ijambo :</span>RABANA WA LAKAL HAMD: Nyagasani wacu ni wowe Nyirugusingizwa".<br /> 4-<span class="c6"> Kuvuga ijambo:</span> SUB\'HANA RABIYAL ADHWIIM: Ubutagatifu ni ubwa Nyagasani wanjye Uhambaye." inshuro imwe igihe wunamye <span class="c2">(Ruku\'u)</span>.<br /> 5-<span class="c6"> Kuvuga ijambo:</span> SUB\'HANA RABIYAL A\'ALA: Ubutagatifu ni ubwa Nyagasani wanjye w\'ikirenga." inshuro imwe igihe wubamye <span class="c2">(Ruku\'u)</span>.<br /> 6-<span class="c6"> Kuvuga ijambo:</span> RABI GH\'FIR LII: Nyagasani mbabarira, hagati yo kubama kabiri.<br /> 7- Kuvuga ubuhamya bwa mbere.<br /> 8- Kwicara uvuga ubuhamya bwa mbere. </p>',
            ],
            22 => [
                'question' => 'Ikibazo cya makumyabiri na gatatu: Ni ibihe bice by\'umugereka by\'Iswala?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3930.mp3',
                'answer' => '<p> Igisubizo: Ni cumi na kimwe,<span class="c6"> ari byo bikurikira:</span><br /> 1-<span class="c6"> Kuvuga nyuma ya Takbirat yo gutangira Iswala:</span> SUB\'HANAKA LLAHUMA WA BIHAMDIKA WA TABARAKA ISMUKA WA TA\'ALA DJADUKA WA LA ILAHA GHAYRUKA:<br /> 2- Kwikinga kuri Allah ngo akurinde Shitani wavumwe.<br /> 3-<span class="c6"> Kuvuga Bismillah Rahman Rahiim:</span> Ku izina rya Allah Nyirimpuhwe Nyirimbabazi.<br /> 4- Kuvuga ijambo AMINA "Mana akira ubusabe".<br /> 5- Gusoma isura runaka nyuma yo gusoma Surat Al Fatihat.<br /> 6- Kurangurura ijwi mu gisomo igihe ari Imam.<br /> 7-<span class="c6"> Nyuma yo kuva ku mavi uvuze Samiallahu liman hamidah:</span> "Allah yumva umusingije"; kongeraho aya magambo: MIL\'A SAMAWATI WA MIL\'AL AR\'DHWI,<span class="c6"> WA MIL\'A MA SHIITA MIN SHAY\'IN BA\'AD:</span> Gusingizwa gukwire ibirere n\'isi na buri icyo ari cyo cyose ushatse nyuma yaho.<br /> 8- Kurenza inshuro imwe mu gusingiza Allah igihe umuntu yunamye <span class="c2">(Ruku\'u)</span>; nko kubisubiramo bwa kabiri n\'ubwa gatatu, no kurenzaho.<br /> 9- Kurenza inshuro imwe mu gusingiza Allah igihe umuntu yubamye <span class="c2">(Sujud)</span>.<br /> 10-<span class="c6"> Kurenza inshuro imwe uvuga amagambo avugwa hagati y\'ibyubamo bibiri:</span> RABI GH\'FIR LII: Nyagasani Mana Mbabarira!"<br /> 11- Gusabira amahoro n\'imigisha umuryango w\'Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> mu buhamya bwa nyuma, no gusaba nyuma yaho.<span class="c6"><br /> Icya kane:</span> Imigenzo myiza yo mu ngiro mu iswala.<br /> 1- Kuzamura amaboko yombi unavuga Takbiiratul Ihram <span class="c2">(ALLAH AKBAR)</span>.<br /> 2- Igihe ugiye kunama <span class="c2">(Ruku)</span>.<br /> 3- Igihe ugiye kunamuka <span class="c2">(Uvuye Ruku)</span>.<br /> 4- Nyuma yaho ukamanura ayo maboko.<br /> 5- Gushyira ukuboko kw\'iburyo hejuru y\'ukw\'ibumoso.<br /> 6- Kureba aho uri bushyire uruhanga wubama.<br /> 7- Gutandukanya ibirenge igihe uhagaze.<br /> 8- Gufata ku mavi utandukanyije intoki z\'ibiganza igihe wunamye <span class="c2">(Ruku)</span>, no kugorora umugongo, no gushyira umutwe ahateganye n\'umugongo.<br /> 9- Kugeza neza hasi ingingo z\'umubiri umuntu atwegetswe kugeza hasi igihe yubamye.<br /> 10- Gutandukanya ibiganza bye n\'ahateganye n\'imisaya ye, n\'inda ye akayitandukanya n\'ibibero bye, n\'ibibero bye akabitandukanya n\'imirundi ye, ndetse akanatandukanya hagati y\'amavi ye, agashinga amano y\'ibirenge bye, ndetse no gushyira ibiganza bye ku butaka bitandukanye, n\'amaboko ye akayashyira ahateganye n\'intugu ze arambuye afatanye n\'intoki ze.<br /> 11- Kwicarira ukuguru kw\'imoso ugashinga amano y\'ukw\'indyo hagati y\'ibyubamo bibiri <span class="c2">(Saj\'datayni)</span>, no mu buhamya bwa mbere, hanyuma mu buhamya bwa kabiri ukicarira ikirenge cy\'ukuguru kw\'imoso, amano y\'ukuguru kw\'indyo ashinze.<br /> 12- Gushyira ibiganza byombi ku bibero birambuye ariko intoki zifatanye, hagati y\'ibyubamo bibiri. Ni nk\'uko ubigenza mu gihe cyo kuvuga ubuhamya, usibye ko ho dukoresha ikiganza cy\'iburyo, igikumwe n\'urutoki rugikurikira, ugafunga izindi ntoki urambuye urutoki rwa mukuru wa meme igihe uvuze Allah.<br /> 13- Kwerekera iburyo n\'ibumoso igihe uri gusoza utora Salamu <span class="c2">(uvuga A-Salam Alaykum)</span>. </p>',
            ],
            23 => [
                'question' => 'Ikibazo cya makumyabiri na kane: Ibyangiza Iswala ni bingahe?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4210.mp3',
                'answer' => '<p> Igisubizo: 1) Kureka imwe mu nkingi, cyangwa se ibwiriza mu mabwiriza y\'Iswala.<br /> 2) Kuvuga ibitajyanye n\'iswala ubigambiriye.<br /> 3) Kurya cyangwa se kunywa.<br /> 4) Ibikorwa byinshi bikurikiranye kandi ukiri mu Iswala.<br /> 5) Kureka kimwe mu bikorwa by\'itegeko mu iswala ku bushake. </p>',
            ],
            24 => [
                'question' => 'Ikibazo cya makumyabiri na gatanu:Umuyisilamu ni gute asali?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4280.mp3',
                'answer' => '<p> Igisubizo: Uburyo Iswala ikorwamo.<br /> 1- Kwerekera aho abayisilamu berekera basali <span class="c2">(Qib\'la)</span> utaberamiye ahandi cyangwa se ngo uhindukire.<br /> 2- Kugira umugambi <span class="c2">(Niyat)</span> wo gusali.<br /> 3- Hanyuma akavuga ijambo Allahu Akbar <span class="c2">(Takbiratul Ihram)</span>, azamura amaboko ye aharinganiye n\'intugu ze igihe ari kuvuga aya magambo.<br /> 4- hanuma agashyira ikiganza cye cy\'iburyo hejuru y\'icy\'ibumoso ku gituza cye.<br /> 5-<span class="c6"> agatangira Iswala avuga aya magambo:</span> ALLAHUMA BA\'ID BAYNII WA BAYNA KHATWAYAYA KAMA BAA\'D\'TA BAYNAL MASH\'RIQ WAL MAGH\'RIB; ALLAHUMA NAQINII MIN KHATWAYAYA KAMA YUNAQA A-THAWUBUL AB\'YADW MINA DANASI,<span class="c6"> ALLAHUMA GH\'SIL\'NII MIN KHATWAYAYA BIL MAI WATHAL\'DJI WAL BARADI:</span> "Mana nyagasani ndagusabye ko wantandukanya n’ibyaha byanjye nk\'uko watandukanyije iburasirazuba n’iburengerazuba, Mana nyeza ibyaha byanjye nk\'uko wejeje umwambaro wera ibizinga, Mana mpanaguraho ibyaha byanjye ukoresheje amazi n’urubura.<span class="c6">"<br /> Cyangwa se akavuga ati:</span> SUB\'HANAKALLAHUMA WA BIHAMDIKA WA TABARAKASMUKA WA TA\'ALA DJADUKA WALA ILAHA GHAYRUKA: Ugusingizwa n’ishimwe ni ibyawe Mana, izina ryawe ryuje imigisha, ubuhambare bwawe burahebuje, kandi nta yindi Mana ikwiwe gusengwa by’ukuri uretse wowe.<br /> 6-<span class="c6"> Hanyuma akikinga kuri Allah agira ati:</span> <span class="c1">“AUDHU BILAHI MINA SHAY’TWANI RADJIIM, BISMILAHI RAH’MANI RAHIM.”</span> Nikinze ku mana ngo indinde Shitani wavumwe, ku izina ry’Imana Nyirimpuhwe Nyirimbabazi." 7- Hanyuma agatangiza izina rya Allah,<span class="c6"> agasoma Surat Al Fatihat agira ati:</span> BISMILLAHI RAH’MANI RAHIM: Ku izina rya Allah Nyirimpuhwe Nyirimbabazi <span class="c2">(1)</span>. <span class="c1">“ALHAMDU LILAHI RABIL ALAMIINA: Ishimwe n’ikuzo byuzuye bikwiye Allah, Nyagasani w’ibiremwa byose <span class="c2">(2)</span>. A-<span class="c6">RAHMANI RAHIIM:</span> Nyirimpuhwe, Nyirimbabazi <span class="c2">(3)</span>.<span class="c6"> MALIKI YAWUMIDINI:</span> Umwami wihariye wo ku munsi w’imperuka. IYYAKA NA-ABDUDU WA IYYAKA NAS’TA-<span class="c6">INU:</span> Ni wowe wenyine dusenga, ni wowe <span class="c2">(wenyine)</span> twiyambaza <span class="c2">(5)</span>.<span class="c6"> IHDINA SWIRATWA AL MUS’TAQIIM:</span> Tuyobore inzira igororotse <span class="c2">(6)</span>. SWIRATWA LADHINA AN-AM’TA ALAY’HIM,<span class="c6"> GHAY’RIL MAGH’DWUBI ALAY’HIM WALA DHWAALIINA:</span> Inzira y’abo wahundagajeho inema, itari iy’abarakariwe cyangwa abayobye <span class="c2">(7)</span>. <span class="c5">[Al Fatihat 1-7]</span><br /> Hanyuma akavuga ijambo <span class="c2">(AMIINA)</span>; bisobanuye ngo Nyagasani twakirire ubusabe.<br /> 8- Iyo arangije asoma ibimworoheye muri Qur\'an, agasoma birebire ku iswala ya mu gitondo<br /> 9- Nyuma akunama <span class="c2">(Ruku-u)</span> agaragaza ubuhambare bwa Allah,<span class="c6"> igihe yunamye akavuga ati “Allahu Akbar:</span> Imana ni yo nkuru, azamura amaboko ye ahateganye n\'intugu ze. Biri no mu mugenzo mwiza dukura ku Ntumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> kugorora umugongo we ahateganye n\'umutwe we, maze agashyira ibiganza bye ku mavi ye atandukanyije intoki.<br /> 10-<span class="c6"> Hanyuma akavuga ati:</span> “SUB’HANA RABIYAL ADHWIMI: Ugusingizwa ni ukwa Allah Nyirubuhambare, akabivuga inshuro eshatu,<span class="c6"> niyo yongeyeho aya magambo:</span> SUB\'HANAKA ALLAHUMA WA BIHAMDIKA,<span class="c6"> ALLAHUMA GH\'FIR LII:</span> Ubutagatifu no gusingizwa ni ibyawe Nyagasani, Nyagasani mbabarira." byaba byiza.<br /> 11- Nyuma akunamuka avuga ati “SAMI-ALLAHU LIMAN HAMIDAH.”</span> Bisobanuye: Allah yumva umusingiza. Ibi abivuga igihe ari gusengesha <span class="c2">(Imam)</span> abandi, cyangwa ari gusenga wenyine <span class="c2">(Mun’farida)</span>, ariko uri gusengeshwa <span class="c2">(Ma\'amum)</span> ntabyo avuga,<span class="c6"> ahubwo we mu mwanya w\'aya magambo aravuga ati:</span> RABANA WALAKAL HAMDU: Nyagasani wacu ni wowe ukwiye ishimwa n’ikuzo bihebuje.<br /> 12- Hanyuma amaze guhagarara neza yemye akavuga ati <span class="c1">“RABANA WALAKAL HAMDU, HAM’DAN KATHIRAN TWAYIBAN MUBARAKAN FIHI, MILA- SAMAWATI WA MIL AL ARDWI WA MIL AMAA SHI-ITA MIN SHAY’IN BA’DAHU”</span> Nyagasani wacu ni wowe ukwiye ishimwa n’ikuzo bihebuje, byiza, by’uje imigisha, bingana n’ibyuzuye ibirere n’isi n’ibindi washaka.<br /> 13- Nyuma akubama ashyira uruhanga hasi <span class="c2">(SUDJUDU)</span> kubama bwa mbere avuga ati <span class="c1">“ALLAHU AKBAR”</span> Imana niyo nkuru. Agatandukanya amaboko ye n’imbavu ze ndetse n’ibibero bye,<span class="c6"> akubamira ku ngingo ze zirindwi:</span> Agahanga hamwe n’izuru, ibiganza bye byombi, amavi ye yombi, ndetse n’amano ye ashinze.<br /> 14- Maze akavuga ati <span class="c1">“SUB’HANA RABIYAL ALA." Ugisingizwa ni ukwa Allah Uwikirenga. Inshuro eshatu cyangwa akarenzaho,<span class="c6"> akavuga ati:</span> SUB\'HANAKA ALLAHUMA RABANA WA BIHAMDIKA,<span class="c6"> ALLAHUMA GH\'FIR LII:</span> Ubutagatifu no gusingizwa ni ibyawe Nyagasani, Nyagasani mbabarira." byaba byiza.<br /> 15- Nyuma akubamuka avuga ati “Allahu Akbaru”</span> Imana niyo nkuru.<br /> 16- Hanyuma akicarira ikirenge cye cy’ibumoso agashinga amano y’ikirenge cy’iburyo, agashyira ibiganza bye ku bibero bye cyangwa ku mavi ye, akazamura urutoki rukurikira igikumwe, akaruzunguza igihe ari gusaba, maze igikumwe cye akagifatisha urutoki rwa musumbazose, izindi yazikunje, ikiganza cye cy\'ibumoso akakirambura hejuru y\'ikibero cy\'ibumoso ahegeranye n\'ivi.<br /> 17-<span class="c6"> Maze icyo gihe yicaye hagati y\'ibyubamo bibiri akavuga ati:</span> <span class="c1">“RABI GH’FIR’LI WAR’HAM’NI WA AFINI WAR’ZUQUNI WAH’DINI WADJ’BUR’NI: Mana yanjye mbabarira, unangirire impuhwe, umpe ubuzima buzira umuze, unampe amafunguro, unyobore, unankomeze.<br /> 18- Hanyuma akongera akubama bwa kabiri nk\'uko yabigenje bwa mbere byaba ibyo yakoze n\'ibyo yavuze, ndetse akavuga Allahu Akbaru igihe agiye kubama.<br /> 19- Hanyuma akubamuka avuga ati Allahu Akbaru, agasali raka ya kabiri nk\'uko yakoze iya mbere mu byo yakoze n\'ibyo yavuze, ariko ho ntavuga ubusabe bwo gutangira iswala.<br /> 20-<span class="c6"> Hanyuma akicara amaze gukora raka ya kabiri avuga ati:</span> Allahu Akbaru, akicara nk\'uko yicara hagati y\'ibyubamo bibiri mu buryo bumwe.<br /> 21- Nyuma akavuga ubuhamya <span class="c2">(A-Tashahud)</span> agira ati: (A-TAHIYATU LILLAH, WA SWALAWATU, WA TWAYIBATU, ASALAMU ALAY’KA AYUHA NABIYU WA RAH’MATULLAHI WABARAKATUHU, ASALAMU ALAY’NA WA ALA IBADILAHI SWALIHINA, ASH’HADU AN LA ILAHA ILA LLAH WA ASH’HADU ANA MUHAMADAN AB’DUHU WA RASULUHU.”</span> Bisobanuye ngo: Ibyubahiro byose, amasengesho ndetse n’ibyiza byose ni ibya Allah, amahoro n’imigisha n’impuhwe z’Imana bikubeho yewe ntumwa, amahoro y’Imana n’imbabazi zayo bitubeho, zibe no kubagaragu b’Imana bakora ibyiza. Ndahamya ko nta yindi mana ikwiye gusengwa by’ukuri uretse Imana imwe rukumbi, nkanahamya ko na Muhamad ari umugaragu wa Allah ndetse akaba n’Intumwa ye.<span class="c6"> Akongeraho ayo magambo:</span> <span class="c1">“ALLAHUMA SWALI ALA MUHAMADI WA ALA ALI MUHAMADI KAMA SWALAY’TA ALA IBRAHIM WA ALA ALI IB’RAHIMA WA BARIKI ALA MUHAMADI WA ALA ALI MUHAMADI KAMA BARAKTA ALA IB’RAHIM WA ALA ALI IBRAAHIM, INAKA HAMIDUN MADJIID.”</span> Mana ha amahoro n’imbabazi Muhamad n’umuryango we, nk\'uko wabihaye Intumwa y’Imana Ibrahim n’umuryango we. Unahe Muhamad imigisha n’umuryango we, nk\'uko wayihaye Intumwa y’Imana Ibrahim n’umuryango we. Ni wowe Nyirugushimwa Nyirikuzo. Yarangiza akikinga kuri Allah ngo amurinde ibintu bine agira ati <span class="c1">“ALLAHUMA INI AUDHU BIKA MIN ADHABI DJAHANAMA, WA MIN ADHABILQAB’RI, WA MIN FIT’NATIL MAH’YA WAL’ MAMATI WA MIN FIT’NATIL MASIHI DADJAL.”</span> Mana nkwikinzeho ngo undinde ibihano by’umuriro wa Jahanamu, n’ibihano byo mu mva, Mana undinde n’ibigeragezo by’ubuzima n\'iby’urupfu, undinde n’ibigeragezo bya Masihi Dadjal. Hanyuma agasaba Nyagasani we mu byiza byo kuri iyi si no ku munsi w\'imperuka;<br /> 22-<span class="c6"> Nyuma agahindukira iburyo bwe akavuga ati:</span> <span class="c1">“ASALAMU ALAYKUM WARAH’MATULLAH.<span class="c6"> Bisobanuye ngo:</span> Amahoro y’Imana n’impuhwe zayo bibabeho”</span>, yarangiza agahindukira n’ibumoso bwe akavuga ati <span class="c1">“ASALAMU ALAYKUM WA RAH’MATULLAH”</span>.<br /> 23- Iyo arangije kuvuga <span class="c2">(A-Tashahud)</span> kuri raka ya kabiri mu isengesho rifite raka eshatu nk’isengesho rya Magh’rib, cyangwa rifite raka enye nk’irya A-dhuh’ri, Al Asw’ri ndetse n’isengesho rya Al Isha, agarukira ku buhamya bwa mbere ari bwo ASHAHADU AN LA ILAHA ILA LLAH,<span class="c6"> WA ASHAHADU ANA MUHAMADAN ABDUHU WA RASULUHU:</span> Ndahamya ko nta yindi mana ikwiye gusengwa by\'ukuri uretse Allah nkanahamya ko Muhamadi ari Intumwa ye akaba n\'umugaragu we.<br /> 24- Hanyuma agahaguruka akavuga ati <span class="c1">“Allahu Akbar: Imana niyo nkuru”</span>, azamuye amaboko ye kugera ahateganye n\'intugu ze.<br /> 25- Hanyuma agasali ibice bisigaye asoma Suratu Al Fatiha yonyine, nyuma akunama <span class="c2">(Ruku)</span> akanubama <span class="c2">(Sujud)</span> nk\'uko yabikoze kuri raka ebyiri zabanje.<br /> 26- Nyuma yo kubama bwa nyuma yicara icyicaro cya TAWARUK, ashinze amano y’ikirenge cy’iburyo akicarira itako ry’ukuguru kw’ibumoso, ku buryo ashobora kwicara hasi, ibiganza bye akabishyira ku bibero bye nk\'uko yabigenje mu buhamya bwa mbere.<br /> 27- Muri iyi nyicaro avuga ubuhamya bwose.<br /> 28- Nyuma agahindukira iburyo bwe akavuga ati <span class="c1">“ASALAMU ALAYKUM WARAH’MATULLAH.<span class="c6"> Bisobanuye ngo:</span> Amahoro y’Imana n’impuhwe zayo bibabeho”</span>, yarangiza agahindukira n’ibumoso bwe akavuga ati <span class="c1">“ASALAMU ALAYKUM WA RAH’MATULLAH”</span>. </p>',
            ],
            25 => [
                'question' => 'Ikibazo cya makumyabiri na gatandatu: Ni ayahe magambo yo gusingiza Allah uvuga urangije Iswala?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4610.mp3',
                'answer' => '<p> Igisubizo: "ASTAGH\'FIRULLAH: Mana mbabarira", bivugwa inshuro eshatu.<br /> ALLAHUMA ANTA SALAMU WA MIN\'KA SALAMU,<span class="c6"> TABARAK\'TA YA DHAL DJALAL WAL IK\'RAM:</span> MANA ni wowe mahoro kandi ni wowe amahoro aturukaho, ubutagatifu ni ubwawe yewe Nyirikuzo Nyiricyubahiro.<br /> LA ILAHA ILA LLAHU WAH\'DAHU LA SHARIKA LAHU, LAHUL MUL\'KU WA LAHUL HAMDU WA HUWA ALA KULI SHAY\'IN QADIIR.<span class="c6"> ALLAHUMA LA MANI\'A LIMA A\'TWAYTA WALA MU\'UTWIYA LIMA MANA\'ATA WALA YAN\'FA\'U DHAL DJAD MINKAL DJAD:</span> Nta yindi mana ibaho ikwiye gusengwa by\'ukuri uretse Imana imwe <span class="c2">(Allah)</span> yonyine itagira umufasha babangikanye, yo yihariye ubwami, ikwiye gushimwa, yo ifite ubushobozi kuri buri kintu. MANA ntawe ushobora kwima uwo wahaye, nta n\'ushobora guha uwo wimye <span class="c2">(ntawe ushobora kubuza igeno ry\'imana kugera kucyo cyangwa uwo yarigeneye)</span>, nta n\'ushobora gutanga ubukire n\'icyubahiro kuko byose ari wowe ubigenga kandi ubigena Mana.<br /> LA ILAHA ILA LLAHU WAH\'DAHU LA SHARIKA LAHU, LAHUL MUL\'KU WA LAHUL HAMDU WA HUWA ALA KULI SHAY\'IN QADIIR. LA HAWLA WALA QUWATA ILA BILLAHI, LA ILAHA ILALLAHU WALA NA\'ABUDU ILA IYAHU, LAHU NI\'IMAT WA LAHUL FADHW\'LU, WA LAHU THANA\'UL HASAN,<span class="c6"> LA ILAHA ILA LLAHU MUKH\'LISWIINA LAHU DINA WA LAW KARIHAL KAFIRUNA:</span> Nta yindi mana ibaho ikwiye gusengwa by\'ukuri uretse Imana imwe <span class="c2">(Allah)</span> yonyine itagira umufasha babangikanye, yo yihariye ubwami, ikwiye gushimwa. Yo ifite ubushobozi kuri buri kintu. Nta bushobozi nta n\'imbaraga zibaho uretse iby\'Imana, nta yindi mana ibaho ikwiye gusengwa by\'ukuri uretse Imana imwe rukumbi <span class="c2">(Allah)</span>, nta n\'icyo dushobora gusenga uretse yo yonyine, yo yihariye ibisingizo byose, yo yihariye inema zose n\'ibyiza, yo yihariye gusengwa by\'ukuri, yo kubwayo dutunganya idini yacu kabone n\'iyo byababaza abahakanyi.<span class="c6"><br /> SUBHANALLAH:</span> Ubutagatifu ni ubwa Allah <span class="c2">(inshuro mirongo itatu n\'eshatu)</span>.<span class="c6"><br /> AL HAMDULILLAH:</span> Ikuzo n\'ishimwe ni ibya Allah <span class="c2">(inshuro mirongo itatu n\'eshatu)</span>.<span class="c6"><br /> ALLAHU AKBAR:</span> Imana ni yo nkuru <span class="c2">(inshuro mirongo itatu n\'eshatu)</span>.<span class="c6"><br /> Hanyuma yakuzuza inshuro y\'ijana akavuga ati:</span> LA ILAHA ILA LLAHU WAH\'DAHU LA SHARIKA LAHU,<span class="c6"> LAHUL MULKU WA LAHUL HAMDU WA HUWA ALA KULI SHAY\'IN QADIR:</span> Nta yindi mana ibaho ikwiye gusengwa by\'ukuri uretse Imana imwe Allah, yo yonyine itagira umufasha cyangwa se uwo babangikanye. Yo yihariye ubwami n\'ubutegetsi bwa byose. Yo yonyine yihariye inakwiye gushimwa kandi ni na yo ifite ubushobozi kuri buri kintu.<br /> - Asoma Surat Al Ikh\'lasw na Surat Al Falaq ndetse na Surat Nas inshuro eshatu nyuma ya buri Swalat Al Fadj\'r, na nyuma ya Swalat Al Magrib, n\'inshuro imwe nyuma y\'izindi swalat.<br /> - Asoma Ayatul Kur\'siyu inshuro imwe. </p>',
            ],
            26 => [
                'question' => 'Ikibazo cya makumyabiri na karindwi: Ni izihe Swalat z\'imigereka (Sunan A-Rawatib)? ibyiza byazo ni ibihe?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4730.mp3',
                'answer' => '<p> Igisubizo: Ni Raka ebyiri usali mbere ya Al Fadj\'ri.<br /> Raka enye za mbere ya A-Dhuhuri.<br /> Raka ebyiri za nyuma ya A-Dhuhuri.<br /> Raka ebyiri za nyuma ya Al Magrib.<br /> Raka ebyiri za nyuma ya Al Isha.<br /> Ibyiza by\'izi Swalat z\'umugereka. Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> yaravuze iti: "Uzasali ku manywa n\'ijoro raka cumi n\'ebyiri z\'umugereka, Allah azamwubakira ingoro mu ijuru. Yakiriwe na Muslim na Ahmad ndetse n\'abandi. </p>',
            ],
            27 => [
                'question' => 'Ikibazo cya makumyabiri n\'umunani: Ni uwuhe munsi mwiza kuruta indi minsi igize icyumweru?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4800.mp3',
                'answer' => '<p> Igisubizo: Ni umunsi wa gatanu <span class="c2">(wa Idjuma)</span>; Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> yaravuze iti: "Umunsi mwiza kuruta indi minsi yanyu ni umunsi wa gatanu; ni wo munsi Adamu yaremweho, ni na wo yapfiriyeho, ni na wo impanda izavuzwaho, ndetse ni na wo ijwi rikura umutima <span class="c2">(Swa\'iqat)</span> rizumvikaniraho, bityo mujye mwongera kuri uwo munsi inshuro munsabira imigisha, kubera ko kunsabira kwanyu bingeraho.<span class="c6">" Uwakiriye iyi Hadithi aravuga ati:</span> Nuko babaza Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> bati: Ni gute kugusabira bizakugeraho kandi warapfuye bikarangira? Intumwa irabasubiza iti: "Mu by\'ukuri Allah yaziririje ubutaka kurya imibiri y\'abahanuzi be." Yakiriwe na Abu Daud n\'abandi. </p>',
            ],
            28 => [
                'question' => 'Ikibazo cya makumyabiri n\'icyenda: Ni irihe tegeko rijyanye n\'iswala yo ku munsi wa gatanu, umunsi wa Idjuma?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4840.mp3',
                'answer' => '<p> Igisubizo: Ni itegeko rireba buri musilamu wujuje imyaka y\'ubukure ufite ubwenge kdi utuye.<span class="c6"><br /> Allah Nyirubutagatifu aragira ati:</span> "Yemwe abemeye! Ngihe muzajya mwumva Umuhamagaro w’isengesho ry’umunsi wa gatanu <span class="c2">(Ijuma)</span> mujye mwihuta mujya gusingiza Allah, kandi muhagarike ubucuruzi <span class="c2">(n’ibindi bintu byose)</span>. Ibyo ni byo byiza kuri mwe, iyaba mwari mubizi.<span class="c6">" Al Djumuat:</span> 9. </p>',
            ],
            29 => [
                'question' => 'Ikibazo cya mirongo itatu: Iswala y\'Idjuma igizwe na Raka zingahe?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4880.mp3',
                'answer' => '<p> Igisubizo: Igizwe na Raka ebyiri, Imam asoma mu ijwi riranguriye, ariko zikabanzirizwa n\'inyigisho ziri mu bice bibiri bizwi. </p>',
            ],
            30 => [
                'question' => 'Ikibazo cya mirongo itatu na rimwe: Ese biremewe kutitabira Iswala y\'Idjuma?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4910.mp3',
                'answer' => '<p> Igisubizo: Ntabwo byemewe kutitabira Iswala y\'idjuma cyeretse umuntu afite impamvu yemewe n\'amategeko, ndetse hari n\'imvugo y\'Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> igira iti: "Uzareka gusali idjuma eshatu kubera kutaziha agaciro, Allah azadanangira umutima we <span class="c2">(ntiwemere ukuri ngo ugukurikire)</span>. Yakiriwe na Abu Daud n\'abandi. </p>',
            ],
            31 => [
                'question' => 'Ikibazo cya mirongo itatu na kabiri: Vuga imigenzo (Sunani) ikorwa ku munsi wa Idjuma?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4940.mp3',
                'answer' => '<p> Ibisubizo:<br /> 1- Kwiyuhagira.<br /> 2- Kwisiga umubavu.<br /> 3- Kwambara imyambaro myiza.<br /> 4- Kuzinduka ujya ku musigiti.<br /> 5- Gusabira kenshi Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> imigisha.<br /> 6- Gusoma Surat Al Kah\'fi.<br /> 7- Kujya ku musigiti n\'amaguru.<br /> 8- Gushakisha kuri uwo munsi isaha Allah yakiramo ubusabe <span class="c2">(ukora ibikorwa byiza byo kwiyegereza Allah)</span>. </p>',
            ],
            32 => [
                'question' => 'Ikibazo cya mirongo itatu na gatatu: Vuga ibyiza by\'Iswala ukoreye mu mbaga?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5050.mp3',
                'answer' => '<p> Imvugo yaturutse kwa Abdullah Ibun Umar <span class="c2">(Imana ibishimire bombi)</span> yavuze ko Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> yavuze iti: "Iswala ikorewe mu mbaga iruta iyo ukoze uri wenyine ho inzego makumyabiri na zirindwi." Yakiriwe na Muslim. </p>',
            ],
            33 => [
                'question' => 'Ikibazo cya mirongo itatu na kane: Kwibombarika mu Iswala bivuze iki?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5080.mp3',
                'answer' => '<p> Igisubizo: Ni ukuba uri mu Iswala n\'umutima wawe wose, n\'ingingo zawe z\'umubiri zituje.<span class="c6"><br /> Allah Nyiricyubahiro aragira ati:</span> "Rwose abemeramana barahiriwe" <span class="c2">(1)</span> "Ba bandi bakora iswala zabo bibombaritse" <span class="c2">(2)</span> <span class="c5">[Surat Al Mu\'uminuna: 1,2]</span> </p>',
            ],
            34 => [
                'question' => 'Ikibazo cya mirongo itatu na gatanu: Sobanura Zakat icyo ari cyo.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5120.mp3',
                'answer' => '<p> Igisubizo: Ni umugabane wategetswe gukurwa mu mutungo runaka, ugenewe abantu runaka, mu gihe runaka.<br /> Gutanga Zakat ni imwe mu nkingi z\'ubuyisilamu, ndetse ni n\'ituro ry\'itegeko ritangwa n\'uwishoboye rigahabwa umukene.<span class="c6"><br /> Allah Nyiricyubahiro aragira ati:</span> "...munatange amaturo <span class="c2">(Zakat)</span>..." <span class="c5">[Surat Al Baqarat: 43.]</span> </p>',
            ],
            35 => [
                'question' => 'Ikibazo cya mirongo itatu na gatandatu: Ni irihe turo biba byiza kuritanga?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5170.mp3',
                'answer' => '<p> Ni ituro ryo mu bundi bwoko butari Zakat, nko kuba wakwitanga kucyo ari cyo cyose mu nzira nziza igihe icyo ari cyo cyose.<span class="c6"><br /> Allah Nyiricyubahiro aragira ati:</span> "Munatange <span class="c2">(amaturo)</span> mu nzira ya Allah..." <span class="c5">[Surat Al Baqarat: 195.]</span> </p>',
            ],
            36 => [
                'question' => 'Ikibazo cya mirongo itatu na karindwi: Sobanura Swaw\'mu icyo ari cyo?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5210.mp3',
                'answer' => '<p> Igisubizo: Swaw\'mu <span class="c2">(kwiyiriza)</span> ni ukugaragira Allah wigomwa ibituma usiburuka guhera umuseke utambitse kugeza izuba rirenze,<span class="c6"> ariko ukabikorana umugambi; kwiyiriza birimo amoko abiri:</span><br /> - Igisibo cy\'itegeko nko gusiba ukwezi kwa Ramadhan, bikaba ari n\'imwe mu nkingi zigize ubuyisilamu.<span class="c6"><br /> Allah Nyiricyubahiro aragira ati:</span> "Yemwe abemeye! Mwategetswe gusiba nk’uko byari byarategetswe abababanjirije, kugira ngo mugandukire Allah. <span class="c2">(183)</span>" <span class="c5">[Surat Al Baqarat: 183.]</span><br /> -<span class="c6"> Igisibo kitari itegeko:</span> nko gusiba kuwa mbere no kuwa kane bya buri cyumweru, gusiba iminsi itatu mu kwezi, amatariki meza wasibaho ni <span class="c2">(13,14,15)</span> ya buri kwezi ukurikije imboneko z\'ukwezi. </p>',
            ],
            37 => [
                'question' => 'Ikibazo cya mirongo itatu n\'umunani: Vuga ibyiza byo gusiba ukwezi kwa Ramadhan?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5270.mp3',
                'answer' => '<p> Imvugo yaturutse kwa Abi Hurayrat <span class="c2">(Imana imwishimire)</span> yavuze ko Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> yavuze iti: "Uzasiba ukwezi kwa Ramadhan, afite ukwemera no kwiringira ibihembo bya Allah, azababarirwa ibyaha bye byose byabanje." Yakiriwe na Bukhari na Muslim. </p>',
            ],
            38 => [
                'question' => 'Ikibazo cya mirongo itatu n\'icyenda: Vuga ibyiza byo gusiba bitari itegeko, igisibo kitari icy\'ukwezi kwa Ramadhan.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5300.mp3',
                'answer' => '<p> Hadithi yaturutse kwa Abi Said Al Khud\'riyu <span class="c2">(Imana imwishimire)</span> yaravuze ati: Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> yaravuze iti: "Nta mugaragu usiba umunsi umwe kubera Allah, usibye ko Allah amugororera kumushyira kure y\'umuriro ho intera ingana n\'imyaka mirongo irindwi." Yakiriwe na Bukhari na Muslim.<br /> Imyaka mirongo irindwi ni yo igamijwe muri iyi mvugo. </p>',
            ],
            39 => [
                'question' => 'Ikibazo cya mirongo ine: Vuga ibyangiza igisibo.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5330.mp3',
                'answer' => '<p> Igisubizo: 1- Kurya no kunywa ku bushake.<br /> 2- Kuruka ku bushake.<br /> 3- Kuva mu buyisilamu. </p>',
            ],
            40 => [
                'question' => 'Ikibazo cya mirongo ine na rimwe: Ni ibihe bikorwa by\'umugereka bikorwa n\'uwasibye?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5380.mp3',
                'answer' => '<p> 1- Kwihutira gusiburuka <span class="c2">(Iftari)</span>.<br /> 2- Gucyerereza gufata ifunguro ryo mu rucyerera <span class="c2">(Idaku)</span>.<br /> 3- Kongera ibikorwa byiza no kurushaho kwiyegereza Allah.<br /> 4-<span class="c6"> Uwasibye gusubiza umututse ati:</span> Nasibye!<br /> 5- Ubusabe igihe cyo gusiburuka.<br /> 6- Gusiburukira ku biryohereye nk\'itenge n\'ibindi, utaba ubifite ugasiburukira ku mazi. </p>',
            ],
            41 => [
                'question' => 'Ikibazo cya mirongo ine na kabiri: Sobanura Hadji icyo ari cyo.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5460.mp3',
                'answer' => '<p> Igisubizo: Ni ukugaragira Allah Nyirubutagatifu ujya gusura ingoro ye ntagatifu <span class="c2">(iri i Maka)</span>, ukora ibikorwa runaka mu gihe runaka.<span class="c6"><br /> Allah Nyiricyubahiro aragira ati:</span> {Allah yategetse abantu gukora umutambagiro mutagatifu <span class="c2">(Hija)</span> kuri iyo ngoro k’ubifitiye ubushobozi. Uzahakana <span class="c2">(itegeko rya Hija)</span>, mu by’ukuri Allah arihagije ntacyo akeneye ku biremwa.} <span class="c5">[Surat Al Imran:97]</span>. </p>',
            ],
            42 => [
                'question' => 'Ikibazo cya mirongo ine na gatatu: Vuga inkingi zigize umutambagiro (Hadj).',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5500.mp3',
                'answer' => '<p> Igisubizo: 1) Kugira umugambi.<br /> 2) Igihagararo ahitwa Arafat.<br /> 3) Gukora umuzenguruko kuri Al Ka\'abat wo mu bwoko bwa Ifadwat.<br /> 4) Gukora umuzenguruko <span class="c2">(Sa\'ayi)</span> hagati y\'ahitwa Swafa na Maruwa. </p>',
            ],
            43 => [
                'question' => 'Ikibazo cya mirongo ine na kane: Ni ibihe byiza byo gukora umutambagiro (Hadj)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5560.mp3',
                'answer' => '<p> Hadithi yaturutse kwa Abi Hurayrat <span class="c2">(Imana imwishimire)</span> yavuze ko yumvise Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> ivuga iti: "Uzakora umutambagiro <span class="c2">(Hadj)</span>, akirinda imvugo mbi n\'ibindi bikorwa bibi, agaruka mu be ameze nk\'umunsi Nyina yamubyayeho <span class="c2">(nta cyaha afite)</span>." Yakiriwe na Bukhari n\'abandi.<br /> Kugaruka ameze nk\'uko ku munsi Nyina yamubyayeho yari ameze, bivuze ko nta cyaha aba afite. </p>',
            ],
            44 => [
                'question' => 'Ikibazo cya mirongo ine na gatanu: Sobanura Umrat icyo ari cyo.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5600.mp3',
                'answer' => '<p> Igisubizo: Umrat ni ukugaragira Allah Nyirubutagatifu ujya gusura ingoro ye ntagatifu <span class="c2">(iri i Maka)</span>, ukora ibikorwa runaka mu gihe icyo ari cyo cyose. </p>',
            ],
            45 => [
                'question' => 'Ikibazo cya mirongo ine na gatandatu: Vuga inkingi za Umrat.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5630.mp3',
                'answer' => '<p> Igisubizo: 1) Kugira umugambi.<br /> 2) Gukora umuzenguruko <span class="c2">(Twawaf)</span> ku ngoro ya Allah ya Al Ka\'abat.<br /> 4) Gukora umuzenguruko <span class="c2">(Sa\'ayi)</span> hagati y\'ahitwa Swafa na Maruwa. </p>',
            ],
            46 => [
                'question' => 'Ikibazo cya mirongo ine na karindwi: Guharanira inzira ya Allah (DJihadi) ni iki?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5690.mp3',
                'answer' => '<p> Igisubizo: Ni ukwitanga n\'imbaraga zawe zose wamamaza ubuyisilamu unaburengera ndetse unarengera abayisilamu, no kurwanya abanzi babwo ndetse n\'abanzi b\'abayisilamu.<span class="c6"><br /> Allah Nyiricyubahiro aragira ati:</span> "Muhagurukane ibakwe, mwaba mworohewe <span class="c2">(mufite ubuzima bwiza, imbaraga, umutungo)</span> cyangwa muremerewe <span class="c2">(murwaye, mufite imbaraga nke, ubukene)</span>, muharanire inzira ya Allah mukoresheje imitungo yanyu namwe ubwanyu. Ibyo ni byo byiza kuri mwe iyaba mwari mubizi." <span class="c2">(41)</span> <span class="c5">[Surat Tawubat:41]</span> </p>',
            ],
        ],
        3 => [
            0 => [
                'question' => 'Ikibazo cya mbere: Ni ikihe gisekuru cy\'Intumwa y\'Imana (Imana iyihe amahoro n\'imigisha)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5740.mp3',
                'answer' => '<p> Igisubizo: Ni Muhamadi mwene Abdillah mwene Abdul Mutwalib mwene Hashim, Hashim uyu yakomokaga mu bwoko bw\'abakurayishi, bumwe mu moko y\'abarabu. Kandi abarabu bakomokaga mu rubyaro rwa Ismail mwene Ibrahim <span class="c2">(Allah abahundagazeho bose amahoro, ndetse anayahundagaze ku Ntumwa yacu)</span>. </p>',
            ],
            1 => [
                'question' => 'Ikibazo cya kabiri: Ni irihe zina rya Nyina w\'Intumwa y\'Imana (Imana iyihe amahoro n\'imigisha)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5770.mp3',
                'answer' => '<p> Igisubizo: Ni Aminat umukobwa wa Wahab. </p>',
            ],
            2 => [
                'question' => 'Ikibazo cya gatatu: Ise w\'Intumwa y\'Imana (Imana iyihe amahoro n\'imigisha) yapfuye ryari?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5800.mp3',
                'answer' => '<p> Igisubizo: Ise yapfiriye i Madina, nyina amutwite ataravuka. </p>',
            ],
            3 => [
                'question' => 'Ikibazo cya kane: Intumwa y\'Imana (Imana iyihe amahoro n\'imigisha) yavutse ryari?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5830.mp3',
                'answer' => '<p> Igisubizo: Yavutse mu mwaka wiswe uw\'inzovu ari mu kwezi kwa gatatu <span class="c2">(Rabiul Awal)</span>. </p>',
            ],
            4 => [
                'question' => 'Ikibazo cya gatanu: Yavukiye mu wuhe mujyi?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5850.mp3',
                'answer' => '<p> Igisubizo: Yavukiye i Maka. </p>',
            ],
            5 => [
                'question' => 'Ikibazo cya gatandatu: Ni bande bayonkeje bakanayirera batari nyina?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5880.mp3',
                'answer' => '<p> Igisubizo: Yonkejwe n\'uwari umuja wahawe ubwigenge na se ari we Umu Aymani.<br /> Hakurikiraho uwari umuja wahawe ubwigenge na se wabo Abu Twalibi ari we Thuwayibat.<br /> Hakurikiraho Halimat A-Saadiyat. </p>',
            ],
            6 => [
                'question' => 'Ikibazo cya karindwi: Nyina yapfuye ryari?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5930.mp3',
                'answer' => '<p> Igisubizo: Nyina w\'Intumwa y\'Imana yapfuye Intumwa y\'Imana ifite imyaka itandatu y\'amavuko, yishingirwa na sekuru Abdul Mutwalibi. </p>',
            ],
            7 => [
                'question' => 'Ikibazo cya munani: Ninde wamwishingiye nyuma y\'urupfu rwa sekuru Abdul Mutwalibi?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5960.mp3',
                'answer' => '<p> Igisubizo: Sekuru Abdul Mutwalibi yapfuye afite imyaka umunani, maze yishingirwa na se wabo Abu Twalibi. </p>',
            ],
            8 => [
                'question' => 'Ikibazo cya cyenda: Intumwa y\'Imana (Imana iyihe amahoro n\'imigisha) yajyanye na Abu Twalib mu rugendo rujya i Shami ryari?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5990.mp3',
                'answer' => '<p> Igisubizo: Yajyanye na se wabo i Shami afite imyaka cumi n\'ibiri y\'amavuko. </p>',
            ],
            9 => [
                'question' => 'Ikibazo cya cumi: Ni ryari yakoze urugendo rwe rwa kabiri?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6020.mp3',
                'answer' => '<p> Igisubizo: Urugendo rwe rwa kabiri rwabaye ari mu bucuruzi bwa Khadidjat <span class="c2">(Imana imwishimire)</span>, ubwo yari akubutse mu rugendo yashyingiranwe na Khadidjat, icyo gihe yari yujuje imyaka mirongo ine. </p>',
            ],
            10 => [
                'question' => 'Ikibazo cya makumyabiri na rimwe: Abakurayishi ni ryari bavuguruye inyubako ya Al Ka\'abat?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6050.mp3',
                'answer' => '<p> Igisubizo: Abakurayishi bavuguruye inyubako ya Al Ka\'abat Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> ifite imyaka mirongo itatu n\'itanu.<br /> Banamugize umukemurampaka ubwo batavugaga rumwe k\'uri bushyire ibuye ry\'umukara mu mwanya waryo, nuko Intumwa irarifata irishyira ku gitambaro, maze itegeka ko buri bwoko bufata uruhande rwa cya gitambaro, icyo gihe yari amoko ane. Ubwo bateruraga barigejeje mu mwanya waryo, Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> yararifashe iba ari yo irishyira mu mwanya waryo. </p>',
            ],
            11 => [
                'question' => 'Ikibazo cya cumi na kabiri: Intumwa y\'Imana (Imana iyihe amahoro n\'imigisha) yahawe ubutumwa ifite imyaka ingahe? Yoherejwe kuri bande?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6080.mp3',
                'answer' => '<p> Igisubizo: Yahawe ubutumwa ifite imyaka mirongo ine, kandi yatumwe ku bantu bose ngo ibabere ubaha inkuru nziza <span class="c2">(y\'ijuru)</span>, n\'umuburizi <span class="c2">(w\'ibihano)</span>. </p>',
            ],
            12 => [
                'question' => 'Ikibazo cya cumi na gatatu: Ni ubuhe buryo bwa mbere Intumwa y\'Imana (Imana iyihe amahoro n\'imigisha) yatangiye kwakiramo ubutumwa?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6110.mp3',
                'answer' => '<p> Igisubizo: Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> yatangiye kwakira ubutumwa iroteshwa indoto z\'ukuri, ku buryo nta ndoto yarotaga usibye ko yazikabyaga zikaza zimeze nk\'igitondo gitangaje. </p>',
            ],
            13 => [
                'question' => 'Ikibazo cya cumi na kane: Intumwa y\'Imana (Imana iyihe amahoro n\'imigisha) mbere yo guhishurirwa ubutumwa yari ibayeho ubuhe buzima? Ni na ryari yatangiye guhishurirwa bwa mbere?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6140.mp3',
                'answer' => '<p> Igisubizo: Yajyaga igaragira Allah mu buvumo bw\'ahitwa Hira-i ndetse ikanitwaza impamba.<br /> Ubutumwa yabuhishuriwe bwa mbere iri muri ubwo buvumo igaragira Umuremyi. </p>',
            ],
            14 => [
                'question' => 'Ikibazo cya cumi na gatanu: Ni iyihe mirongo ya mbere yo muri Qur\'an yamanuriwe?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6180.mp3',
                'answer' => '<p> Igisubizo: Ni imvugo ya Allah igira iti: {Soma ku izina rya Nyagasani wawe waremye <span class="c2">(ibiriho byose)</span>} <span class="c2">(1)</span>, <span class="c4">{Yaremye umuntu mu rusoro rw’amaraso}</span><span class="c2">(2)</span>, <span class="c4">{Soma! Kandi Nyagasani wawe ni Nyirubuntu uhebuje}</span><span class="c2">(3)</span>, {We wigishije <span class="c2">(umuntu kwandika)</span> akoresheje ikaramu}<span class="c2">(4)</span>, <span class="c4">{Yigishije umuntu ibyo atari azi}</span><span class="c2">(5)</span>. <span class="c5">[Surat Al Alaq: 1-5]</span> </p>',
            ],
            15 => [
                'question' => 'Ikibazo cya cumi na gatandatu: Ni bande bemeye ubutumwa bw\'Intumwa y\'Imana (Imana iyihe amahoro n\'imigisha) mbere y\'abandi?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6200.mp3',
                'answer' => '<p> Igisubizo: Mu bagabo ni Abubakar A-Swidiq; naho mu bagore ni Khadidjat bint Khuwaylidi; mu bana ni Ally Ibun Abi Twalib, naho mu bakuwe mu bucakara ni Zayd Ibun Al Harithat. Mu bacakara ni Bilal Al Habashiyi <span class="c2">(Allah abishimire bose)</span> ndetse n\'abandi. </p>',
            ],
            16 => [
                'question' => 'Ikibazo cya cumi na karindwi: Guhamagarira abantu kuyoboka Isilamu byakorwaga bite muri icyo gihe?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6230.mp3',
                'answer' => '<p> Igisubizo: Muri icyo gihe ivugabutumwa ryakorwaga mu ibanga mu gihe kingana n\'imyaka itatu, nyuma yaho nibwo Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> yategetse kubutangaza. </p>',
            ],
            17 => [
                'question' => 'Ikibazo cya cumi n\'umunani: Nyuma yo gutangaza ubutumwa Intumwa y\'Imana (Imana iyihe amahoro n\'imigisha) yo n\'abayemeye bafashwe bate?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6260.mp3',
                'answer' => '<p> Igisubizo: Ababangikanyamana bongereye umurego mu kubagirira nabi, kubabuza amahoro ndetse no kubatoteza kugeza ubwo Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> ahaye uburenganzira abemera bwo guhungira ku mwami wa Habasha witwaga Nadjashi.<br /> Ababangikanyamana bahurije hamwe umugambi wabo wo gutoteza Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> ndetse bagera ku rwego bashatse no kumwica, ariko Allah yaramurinze abinyujije kuri Se wabo Abu Twalib, kugira ngo amubarinde. </p>',
            ],
            18 => [
                'question' => 'Ikibazo cya cumi n\'icyenda: Ninde wapfuye Intumwa y\'Imana (Imana iyihe amahoro n\'imigisha) imaze imyaka icumi ihawe ubutumwa?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6300.mp3',
                'answer' => '<p> Igisubizo: Se wabo Abu Twalib nibwo yapfuye ndetse n\'umugore we Khadidjat <span class="c2">(Imana imwishimire)</span>. </p>',
            ],
            19 => [
                'question' => 'Ikibazo cya makumyabiri: Urugendo rwa Is\'ra-i na Al Mi\'iradji rwabaye ryari?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6330.mp3',
                'answer' => '<p> Igisubizo: Uru rugendo rwabaye Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> yujuje imyaka mirongo itanu y\'amavuko, ari nabwo yategekwaga iswala eshanu.<br /> Ijambo Is\'ra-<span class="c6">i:</span> Ni urugendo Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> yakoze iva ku musigiti mutagatifu w\'i Maka ijya ku musigiti mutagatifu wa Al Aq\'swa <span class="c2">(uri i Yeruzalemu)</span>.<span class="c6"><br /> Naho Al Mi\'iradji:</span> rwo yarukoze iva ku musigiti wa Al Aq\'swa ijya mu ijuru kugeza igeze ahitwa Sid\'ratil Mun\'taha. </p>',
            ],
            20 => [
                'question' => 'Ikibazo cya makumyabiri na rimwe: Intumwa y\'Imana (Imana iyihe amahoro n\'imigisha) yahamagariraga ite ubuyisilamu abantu bo hanze y\'umujyi wa Maka?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6380.mp3',
                'answer' => '<p> Igisubizo: Yajyaga ijya kwibonanira n\'abantu b\'ahitwa Twaif, mu biterane ndetse n\'ahandi abantu bahurira, kugeza ubwo yageze no ku bantu b\'i Madina bitwa An\'swar, nuko baramwemera banamuha igihango cyo kuzamwumvira ndetse no kuzamurinda. </p>',
            ],
            21 => [
                'question' => 'Ikibazo ya makumyabiri na kabiri: Intumwa y\'Imana (Imana iyihe amahoro n\'imigisha) yamaze i Maka igihe kingana iki ihamagarira abantu ubuyisilamu?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6410.mp3',
                'answer' => '<p> Igisubizo: Yahamaze imyaka cumi n\'itatu. </p>',
            ],
            22 => [
                'question' => 'Ikibazo cya makumyabiri na gatatu: Intumwa y\'Imana (Imana iyihe amahoro n\'imigisha) yahungiye he?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6440.mp3',
                'answer' => '<p> Igisubizo: Yahunze iva i Maka ijya i Madina. </p>',
            ],
            23 => [
                'question' => 'Ikibazo cya makumyabiri na kane: I Madina yahamaze igihe kingana iki?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6470.mp3',
                'answer' => '<p> Igisubizo: Yahamaze imyaka icumi. </p>',
            ],
            24 => [
                'question' => 'Ikibazo cya makumyabiri na gatanu: Ni ayahe mategeko mu mategeko y\'ubuyisilamu Intumwa y\'Imana (Imana iyihe amahoro n\'imigisha) yategetswe ubwo yari i Madina?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6490.mp3',
                'answer' => '<p> Igisubizo: Yategetswe gutanga amaturo <span class="c2">(Zakat)</span>, igisibo <span class="c2">(Swiyam)</span>, umutambagiro mutagatifu <span class="c2">(Hadj)</span>, guharanira inzira ya Allah <span class="c2">(Djihad)</span>, umuhamagaro w\'igihe cyo gusali <span class="c2">(Adhana)</span> n\'andi mategeko tutarondora. </p>',
            ],
            25 => [
                'question' => 'Ikibazo cya makumyabiri na gatandatu: Ni izihe ntambara z\'ingenzi Intumwa y\'Imana (Imana iyihe amahoro n\'immigisha) yarwanye?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6520.mp3',
                'answer' => '<p> Igisubizo: Urugamba rwitwa Bad\'rul Kub\'ra,<br /> Urugamba rwabereye ahitwa Uhudi,<br /> Urugamba rwiswe urw\'amatsinda <span class="c2">(Al Ah\'zaab)</span>,<br /> Urugamba rwo kubohora umujyi wa Maka <span class="c2">(Fat\'h Makat)</span>. </p>',
            ],
            26 => [
                'question' => 'Ikibazo cya makumyabiri na karindwi: Ni iyihe mirongo yamanutse bwa nyuma muri Qur\'an?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6580.mp3',
                'answer' => '<p> Igisubizo: Ni imvugo ya Allah igira iti: {Munatinye umunsi muzasubizwaho kwa Allah, maze buri muntu agahemberwa mu buryo bwuzuye ibyo yakoze, kandi bo ntibazahuguzwa.<span class="c2">(281)</span>} <span class="c5">[Surat Al Baqarat: 281.]</span> </p>',
            ],
            27 => [
                'question' => 'Ikibazo cya makumyabiri n\'umunani: Intumwa y\'Imana (Imana iyihe amahoro n\'imigisha) yapfuye ryari? yari ifite imyaka ingahe?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6610.mp3',
                'answer' => '<p> Igisubizo: Yapfuye mu kwezi kwa Rabi\'il Awal <span class="c2">(kwa gatatu)</span>, mu mwaka wa 11 nyuma y\'uko yimukiye i Madina, icyo gihe yari ifite imyaka mirongo itandatu y\'amavuko. </p>',
            ],
            28 => [
                'question' => 'Ikibazo cya makumyabiri n\'icyenda: Vuga abagore Intumwa y\'Imana (Imana iyihe amahoro n\'imigisha) yabanye nabo?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6640.mp3',
                'answer' => '<p> Igisubizo:1- Khadidjat bint Khuwaylid <span class="c2">(Imana imwishimire)</span>.<br /> 2- Saw\'dat bint Zamu\'at <span class="c2">(Imana imwishimire)</span>.<br /> 3- Aishat bint Abu Bak\'ri A-Swidiq <span class="c2">(Imana imwishimire)</span>.<br /> 4- Haf\'swat bint Umar <span class="c2">(Imana imwishimire)</span>.<br /> 5- Zaynab bint Khuzaymat <span class="c2">(Imana imwishimire)</span>.<br /> 6- Umu Salamat Hindu bint Abi Umayat <span class="c2">(Imana imwishimire)</span>.<br /> 7- Umu Habibat bint Abi Sufiyan <span class="c2">(Imana imwishimire)</span>.<br /> 8- Djuwayriyat bint Al Harith <span class="c2">(Imana imwishimire)</span>.<br /> 9- Maymunat bint Al Harith <span class="c2">(Imana imwishimire)</span>.<br /> 10- Swafiyat bint Huyay <span class="c2">(Imana imwishimire)</span>.<br /> 11- Zaynab bint Djah\'shi <span class="c2">(Imana imwishimire)</span>. </p>',
            ],
            29 => [
                'question' => 'Ikibazo cya mirongo itatu: Vuga abana b\'Intumwa y\'Imana (Imana iyihe amahoro n\'imigisha).',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6760.mp3',
                'answer' => '<p> Igisubizo: Abahungu ni batatu,<span class="c6"> aribo aba bakurikira:</span><br /> Al Qasim ari na we Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> yitirirwaga.<br /> Abdullah.<br /> Ibrahim.<span class="c6"><br /> Naho abakobwa ni:</span><br /> Fatwimat.<br /> Ruqayat<br /> Umu Kul\'thum.<br /> Zaynab.<br /> Abana be bose babyarwaga na Khadidjat <span class="c2">(Imana imwishimire)</span>, usibye Ibrahim, kandi bose bapfuye mbere ya se usibye Fatwimat wapfuye nyuma ye ho amezi atandatu. </p>',
            ],
            30 => [
                'question' => 'Ikibazo cya mirongo itatu na rimwe: Vuga bimwe mu byaranze imiterere n\'imiremekere y\'Intumwa y\'Imana (Imana iyihe amahoro n\'imigisha).',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6880.mp3',
                'answer' => '<p> Igisubizo: Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> yari mu bagabo baringaniye, ntiyari mugufi cyangwa se ngo abe muremure, ahubwo yari hagati no hagati. Yari ifite uburanga bwererana ariko ibara ryabwo ryenda gusa n\'umutuku. Yari afite ubwanwa bwinshi, amaso manini, iminwa minini, umusatsi wirabura, intugu ngari ndetse n\'ibindi mu miterere n\'imiremekere myiza ye. </p>',
            ],
            31 => [
                'question' => 'Ikibazo cya mirongo itatu na kimwe: Intumwa y\'Imana (Imana iyihe amahoro n\'imigisha) yasigiye iki abayoboke bayo?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6910.mp3',
                'answer' => '<p> Igisubizo: Yasigiye abayoboke umuyoboro ugaragara, weruruka, ijoro ryawo ni nk\'amanywa yawo, ntawe ujya aca ukubiri na wo usibye ko aba arimbutse, nta cyiza na kimwe usibye ko yacyeretse abayoboke be, nta n\'ikibi usibye ko yakibujije abayoboke be. </p>',
            ],
        ],
        4 => [
            0 => [
                'question' => 'Ikibazo cya mbere: Soma Surat Al Fatihat unayisobanure.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6960.mp3',
                'answer' => '<p> Igisubizo:<br /> "BISMILLAH RAH\'MAN RAHIIM: Ku izina rya Allah , Nyirimpuhwe, Nyirimbabazi <span class="c2">(1)</span>.<span class="c6"> “ALHAMDU LILAHI RABIL ALAMIINA:</span> Ishimwe n’ikuzo byuzuye bikwiye Allah, Nyagasani w’ibiremwa byose <span class="c2">(2)</span>. A-<span class="c6">RAHMANI RAHIIM:</span> Nyirimpuhwe, Nyirimbabazi <span class="c2">(3)</span>.<span class="c6"> MALIKI YAW\'MI DIINI:</span> Umwami w’ikirenga wo ku munsi w’imperuka <span class="c2">(4)</span>.<span class="c6"> IYAKA NA\'ABUDU WA IYAKA NASTA\'INU:</span> Ni wowe <span class="c2">(wenyine)</span> dusenga, kandi ni wowe <span class="c2">(wenyine)</span> twiyambaza <span class="c2">(5)</span>.<span class="c6"> IHDINA SWIRATWAL MUS’TAQIIM:</span> Tuyobore inzira igororotse. SWIRATWA LADHINA AN\'AM’TA ALAY’HIM,<span class="c6"> GHAY’RIL MAGH’DWUBI ALAY’HIM WALA DWAALIIN:</span> Inzira y’abo wahundagajeho inema, itari iy’abarakariwe cyangwa se abayobye<span class="c2">(7)</span>. <span class="c5">[Surat Al Fatihat 1-7]</span>.<span class="c6"><br /> IBISOBANURO BYAYO:</span><br /> Iyi Surat yiswe iri zina <span class="c2">(Al Fatihat: Urufunguzo)</span>, kubera ko ari yo itangira mu gitabo cya Allah.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001001.mp3"></audio> 1- Bismillah Rahman Rahiim <span class="c2">(Ku izina rya Allah, Nyirimpuhwe,<span class="c6"> Nyirimbabazi:</span> Ku izina rya Allah ntangiye gusoma Qur\'an, ari we nsaba inkunga n\'umugisha kubera izina rye ntangije.<span class="c6"><br /> Allah:</span> Ni we mugaragirwa w\'ukuri, iri zina nta wundi uryitwa uretse Allah.<span class="c6"><br /> Rahman:</span> Niwe Nyirimpuhwe zihambaye zagutse kuri buri kintu.<span class="c6"><br /> Rahiim:</span> Niwe Nyirimpuhwe zihariye ku bemeramana.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001002.mp3"></audio> 2-<span class="c6"> AL HAMDULILLAH RABBIL ALAMINA:</span> Ikuzo n\'ishimwe ni ibya Allah; amashimwe yose n\'ubutungane ni ibya Allah wenyine.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001003.mp3"></audio> 3- A-RAHMAN, A-RAHIIM (Nyirimpuhwe, Nyirimbabazi)</span>: Nyirimpuhwe zagutse kuri buri kintu, n\'impuhwe zihariye ku bemeramana.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001004.mp3"></audio> 4-<span class="c6"> MALIK YAWMI DIIN:</span> Umwami w\'ikirenga ku munsi w\'ingororano, ari wo munsi w\'imperuka.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001005.mp3"></audio> 5-<span class="c6"> IYAKA NA\'ABUDU WA IYAKA NASTA\'INU:</span> Ni wowe wenyine tugaragira, ndetse ni nawe wenyine dusaba inkunga.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001006.mp3"></audio> 6-<span class="c6"> IH\'DINA SWIRATWAL MUSTAQIIM:</span> Tuyobore inzira igororotse, ari yo nzira y\'ubuyisilamu n\'umuyoboro w\'Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span>.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001007.mp3"></audio> 7-<span class="c6"> SWIRATWA LADHINA AN\'AMTA ALAYHIM GHAYRIL MAGH\'DWUBI ALAYHIM WALA DWALIINA:</span> Inzira y\'abo wahaye impano mu bahanuzi ba Allah, n\'ababakurikiye batari abayobye n\'abarakariwe.<br /> Biri mu mugenzo mwiza w\'Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span>, ko nyuma yo kuvuga aya magambo, kuvuga ati <span class="c2">(AAMIIN)</span>; bisobanuye ngo twakirire ubusabe. </p>',
            ],
            1 => [
                'question' => 'Ikibazo cya kabiri: Soma Surat A-Zilzalat, unayisobanure.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7130.mp3',
                'answer' => '<p> Igisubizo:<br /> "BISMILLAH RAH\'MAN RAHIIM: Ku izina rya Allah , Nyirimpuhwe, Nyirimbabazi.<span class="c6"><br /> IDHA ZUL\'ZILATIL AR\'DWU ZIL\'ZALAHA:</span> Ubwo isi izatigiswa n’umutingito ukomeye <span class="c2">(1)</span>.<span class="c6"> WA AKH\'RADJATIL AR\'DWU ATH\'QALAHA:</span> Nuko isi igasohora imitwaro yayo <span class="c2">(ibiyirimo)</span> <span class="c2">(2)</span>.<span class="c6"> WA QALAL IN\'SANU MA LAHA:</span> Umuntu azavuga ati <span class="c1">“Ese noneho <span class="c2">(isi)</span> yabaye iki? <span class="c2">(3)</span>”</span>.<span class="c6"> YAWMA IDHIN TUHADITHU AKH\'BARAHA:</span> Uwo munsi <span class="c2">(isi)</span> izavuga inkuru zayo <span class="c2">(z’ibyayibereyeho)</span> <span class="c2">(4)</span>.<span class="c6"> BI ANA RABAKA AW\'HA LAHA:</span> Kubera ko Nyagasani wawe azaba yayibitegetse <span class="c2">(5)</span>.<span class="c6"> YAWMA IDHIN YASW\'DURU NASU ASH\'TATAN LIYURAWU A\'AMALAHUM:</span> Kuri uwo munsi, abantu bazasohoka <span class="c2">(mu mva)</span> batatanye kugira ngo berekwe ibikorwa byabo <span class="c2">(6)</span>.<span class="c6"> FAMAN YA\'AMAL MITH\'QALA DHARATIN KHAYRAN YARAHU:</span> Icyo gihe uzaba yarakoze icyiza gifite uburemere bungana n’akantu gato cyane kurusha ibindi, azakibona <span class="c2">(agihemberwe)</span> <span class="c2">(7)</span>.<span class="c6"> WAMAN YA\'AMAL MITH\'QALA DHARATIN SHARAN YARAHU:</span> N’uzaba yarakoze ikibi gifite uburemere bungana n’akantu gato cyane kurusha ibindi azakibona <span class="c2">(agihanirwe)</span> <span class="c2">(8)</span>. <span class="c5">[Surat Zil\'zalat: 1-8]</span><br /> IBISOBANURO BYAYO:<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099001.mp3"></audio> 1-<span class="c6"> IDHA ZUL\'ZILATIL AR\'DWU ZIL\'ZALAHA:</span> Ubwo isi izatigiswa n’umutingito ukomeye; ibi bizaba ku munsi w\'imperuka.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099002.mp3"></audio> 2-<span class="c6"> WA AKH\'RADJATIL AR\'DWU ATH\'QALAHA:</span> Nuko isi igasohora imitwaro yayo <span class="c2">(ibiyirimo)</span>, baba abapfuye n\'ibindi.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099003.mp3"></audio> 3-<span class="c6"> WA QALAL IN\'SANU MA LAHA:</span> Umuntu azavuga ati <span class="c1">“Ese noneho <span class="c2">(isi)</span> yabaye iki?”</span>, icyo gihe umuntu azaba yayobewe maze yibaze icyo isi yabaye ku buryo igira umutingito nk\'uwo.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099004.mp3"></audio> 4-<span class="c6"> YAWMA IDHIN TUHADITHU AKH\'BARAHA:</span> Uwo munsi <span class="c2">(isi)</span> izavuga inkuru zayo <span class="c2">(z’ibyayibereyeho)</span>, kuri uwo munsi uhambaye, isi izivugira ibyayikoreweho byaba byiza cyangwa se bibi;<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099005.mp3"></audio> 5-<span class="c6"> BI ANA RABAKA AW\'HA LAHA:</span> Kubera ko Nyagasani wawe azaba yayibitegetse. Allah azaba yabiyibwiye ndetse yabiyitegetse.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099006.mp3"></audio> 6-<span class="c6"> YAWMA IDHIN YASW\'DURU NASU ASH\'TATAN LIYURAWU A\'AMALAHUM:</span> Kuri uwo munsi, abantu bazasohoka <span class="c2">(mu mva)</span> batatanye kugira ngo berekwe ibikorwa byabo; kugira ngo bibonere ibikorwa bikoreye hano ku isi.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099007.mp3"></audio> 7-<span class="c6"> FAMAN YA\'AMAL MITH\'QALA DHARATIN KHAYRAN YARAHU:</span> Icyo gihe uzaba yarakoze icyiza gifite uburemere bungana n’akantu gato cyane kurusha ibindi, azakibona imbere ye maze agihemberwe.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099008.mp3"></audio> 8-<span class="c6"> WAMAN YA\'AMAL MITH\'QALA DHARATIN SHARAN YARAHU:</span> N’uzaba yarakoze ikibi gifite uburemere bungana n’akantu gato cyane kurusha ibindi, azakibona imbere ye maze agihanirwe. </p>',
            ],
            2 => [
                'question' => 'Ikibazo cya kabiri: Soma Surat Al Adiyati, unayisobanure.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7270.mp3',
                'answer' => '<p> Igisubizo: suratu al adiyat n\'ibisobanuro byayo:<br /> "BISMILLAH RAH\'MAN RAHIIM: Ku izina rya Allah, Nyirimpuhwe, Nyirimbabazi.<span class="c6"><br /> WAL ADIYATI DWAB\'HAN:</span> Ndahiye amafarasi yiruka cyane avuza imirindi <span class="c2">(1)</span>.<span class="c6"> FAL MURIYAT QAD\'HAN:</span> Akubita <span class="c2">(ibinono)</span> bigatarutsa ibishashi by’umuriro <span class="c2">(2)</span>.<span class="c6"> FAL MUGHIIRAT SWUB\'HAN:</span> N’amafarasi agaba igitero mu rukerera <span class="c2">(3)</span>.<span class="c6"> FA ATHAR\'NA BIHI NAQ\'AN:</span> Akanatumura umukungugu <span class="c2">(4)</span>.<span class="c6"> FAWASATW\'NA BIHI DJAM\'AN:</span> Akinjira hagati mu ngabo z’umwanzi <span class="c2">(5)</span>.<span class="c6"> INAL IN\'SANA LIRABIHI LAKANUD:</span> Mu by’ukuri umuntu ni indashima kuri Nyagasani we <span class="c2">(6)</span>.<span class="c6"> WA INAHU ALA DHALIKA LASHAHID:</span> Kandi rwose ibyo yabibera umuhamya <span class="c2">(7)</span>.<span class="c6"> WA INAHU LIHUBIL KHAYRI LASHADIID:</span> Ndetse akunda imitungo bikabije <span class="c2">(8)</span>.<span class="c6"> AFALA YA\'ALAMU IDHA BU\'UTHIRA MAA FIL QUBUR:</span> Ese ntazi ko hari igihe abari mu mva bazazurwa?<span class="c2">(9)</span> WA HUSWILA MA FISWUDURI: N’ibiri mu bituza <span class="c2">(by’abantu)</span> bigashyirwa ahagaragara?<span class="c2">(10)</span> INA RABAHUM BIHIM YAW\'MA IDHIN LAKHABIIR: Mu by’ukuri uwo munsi Nyagasani wabo azaba azi neza ibyabo <span class="c2">(11)</span>. <span class="c5">[SURAT AL ADIYAT: 1-11]</span><br /> IBISOBANURO BYAYO:<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100001.mp3"></audio> 1-<span class="c6"> WAL ADIYATI DWAB\'HAN:</span> Ndahiye amafarasi yiruka cyane avuza imirindi. Allah ararahirira ku mafarasi yiruka kugeza ubwo wumva umurundi wayo kubera kwiruka cyane.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100002.mp3"></audio> 2-<span class="c6"> FAL MURIYAT QAD\'HAN:</span> Akubita <span class="c2">(ibinono)</span> bigatarutsa ibishashi by’umuriro; no ku mafarasi iyo akandagiye ku bitare by\'amabuye aturitsa ibishashi.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100003.mp3"></audio> 3-<span class="c6"> FAL MUGHIIRAT SWUB\'HAN:</span> N’amafarasi agaba igitero mu gitondo cya kare butaracya.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100004.mp3"></audio> 4-<span class="c6"> FA ATHAR\'NA BIHI NAQ\'AN:</span> Ibyo bigatuma atumura umukungugu.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100005.mp3"></audio> 5-<span class="c6"> FAWASATW\'NA BIHI DJAM\'AN:</span> Akinjira hagati mu ngabo z’umwanzi.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100006.mp3"></audio> 6-<span class="c6"> INAL INSANA LIRABIHI LAKANUD:</span> Mu by’ukuri umuntu ni indashima ku byiza Nyagasani we amuhitiramo.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100007.mp3"></audio> 7-<span class="c6"> WA INAHU ALA DHALIKA LASHAHID:</span> Kandi rwose ibyo yabibera umuhamya; ntashobora kubihakana kuko ni ibintu bigaragara.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100008.mp3"></audio> 8-<span class="c6"> WA INAHU LIHUBIL KHAYRI LASHADIID:</span> akunda imitungo bikabije, ndetse akanayigiraho ubugugu bukomeye.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100009.mp3"></audio> 9-<span class="c6"> AFALA YA\'ALAMU IDHA BU\'UTHIRA MAFIL QUBUR:</span> Ese uyu muntu ushukwa n\'isi, ntazi ko hari igihe abari mu mva bazazurwa, kugira ngo babarurirwe anabagororere? Bityo ibintu bizaba bitandukanye n\'uko yibwira.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100010.mp3"></audio> 10-<span class="c6"> WA HUSWILA MA FISWUDURI:</span> N’ibiri mu bituza <span class="c2">(by’abantu)</span> byaba imigambi n\'imyizerere ndetse n\'ibindi bigashyirwa ahagaragara?<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100011.mp3"></audio> 11-<span class="c6"> INA RABAHUM BIHIM YAW\'MA IDHIN LAKHABIIR:</span> Mu by’ukuri uwo munsi Nyagasani wabo azaba azi neza ibyabo, nta kimwisoba kandi byose azabibahembera. </p>',
            ],
            3 => [
                'question' => 'Ikibazo cya kane: Soma Surat Al Qariat unayisobanure.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7450.mp3',
                'answer' => '<p> Igisubizo:suratul al qariat n\'ibisobanuro byayo.<span class="c6"><br /> "BISMILLAH RAH\'MAN RAHIIM:</span> Ku izina rya Allah , Nyirimpuhwe, Nyirimbabazi.<span class="c6"><br /> AL QARI\'AT:</span> Ikizahonda <span class="c2">(umunsi w’imperuka)</span> <span class="c2">(1)</span>! MAL QARI\'AT: Ikizahonda ni iki <span class="c2">(2)</span>? WAMA AD\'RAKA MAL QARI\'AT: Ni iki kizakumenyesha ikizahonda <span class="c2">(3)</span>? YAW\'MA YAKUNU NASU KAL FARASHIL MAB\'THUTH: Ni umunsi <span class="c2">(w’imperuka)</span>, ubwo abantu bazamera nk’ibinyugunyugu binyanyagiye <span class="c2">(4)</span>.<span class="c6"> WA TAKUNUL DJIBALU KAL\'IH\'NIL MAN\'FUSH:</span> N’imisozi ikamera nk’amoya <span class="c2">(akemurwa ku matungo)</span> atumuka <span class="c2">(5)</span>.<span class="c6"> FA AMA MAN THAQULAT MAWAZINUHU:</span> Bityo, uwo umunzani we <span class="c2">(w’ibikorwa byiza)</span> uzaremera <span class="c2">(bikaruta ibibi)</span> <span class="c2">(6)</span>.<span class="c6"> FAHUWA FI ISHATIN RADWIYAT:</span> Azaba mu buzima bw’umunezero <span class="c2">(Ijuru)</span> <span class="c2">(7)</span>.<span class="c6"> WA AMA MAN KHAFAT MAWAZINUHU:</span> Ariko uwo umunzani we <span class="c2">(w’ibikorwa byiza)</span> uzaba utaremereye <span class="c2">(bikarutwa n’ibibi)</span><span class="c2">(8)</span>.<span class="c6"> FA UMUHU HAWIYAT:</span> Ubuturo bwe buzaba ari mu muriro witwa Hawiya <span class="c2">(9)</span>.<span class="c6"> WAMA AD\'RAKA MA HIYAH:</span> Ni iki cyawukumenyesha <span class="c2">(umuriro wa Hawiya)</span> <span class="c2">(10)</span>? NAARUN HAMIYAT: Ni umuriro ugurumana bikabije <span class="c2">(11)</span>! <span class="c5">[SURATUL QARI\'AT: 1-11]</span>.<span class="c6"><br /> IBISOBANURO BYAYO:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101001.mp3"></audio> 1-<span class="c6"> AL QARI\'AT:</span> Ikizahonda gikura abantu imitima ku munsi w’imperuka!<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101002.mp3"></audio> 2-<span class="c6"> MAL QARI\'AT:</span> Ni iki cyakumenyesha icyo kizahonda kigakura imitima?<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101003.mp3"></audio> 3-<span class="c6"> WAMA AD\'RAKA MAL QARI\'AT:</span> Ni iki cyakumenyesha icyo kizahonda kigakura imitima <span class="c2">(yewe Ntumwa y\'Imana?)</span> Ni umunsi w\'imperuka.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101004.mp3"></audio> 4-<span class="c6"> YAW\'MA YAKUNU NASU KAL FARASHIL MAB\'THUTH:</span> Ni umunsi w’imperuka uzakura abantu imitima, bakamera nk’ibinyugunyugu binyanyagiye ahantu hose.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101005.mp3"></audio> 5-<span class="c6"> WA TAKUNUL DJIBALU KAL\'IH\'NIL MAN\'FUSH:</span> Imisozi izamera nk’amoya akemurwa ku matungo atumuka, kuko izaba yorohejwe cyane.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101006.mp3"></audio> 6-<span class="c6"> FA AMA MAN THAQULAT MAWAZINUHU:</span> Bityo, uwo umunzani we w’ibikorwa byiza uzaremera bikaruta ibibi,<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101007.mp3"></audio> 7-<span class="c6"> FAHUWA FI ISHATIN RADWIYAT:</span> Azaba mu buzima bw’umunezero bw\'ijuru,<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101008.mp3"></audio> 8-<span class="c6"> WA AMA MAN KHAFAT MAWAZINUHU:</span> Ariko uwo umunzani we w’ibikorwa byiza uzaba utaremereye bikarutwa n’ibibi;<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101009.mp3"></audio> 9-<span class="c6"> FA UMUHU HAWIYAT:</span> Ku munsi w\'imperuka ubuturo bwe buzaba ari mu muriro witwa Hawiya, ari wo wa Jahanamu.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101010.mp3"></audio> 10-<span class="c6"> WAMA AD\'RAKA MA HIYAH:</span> Ni iki cyawukumenyesha <span class="c2">(yewe Ntumwa y\'Imana)</span> umuriro wa Hawiya?<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101011.mp3"></audio> 11-<span class="c6"> NARUN HAMIYAT:</span> Ni umuriro waka cyane kandi ugurumana bikabije! </p>',
            ],
            4 => [
                'question' => 'Ikibazo cya gatanu: Soma Suratu takathur unayisobanure.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7610.mp3',
                'answer' => '<p> Igisubizo: suratu takathur n\'ibisobanuro byayo<br /> "BISMILLAH RAH\'MAN RAHIIM: Ku izina rya Allah , Nyirimpuhwe, Nyirimbabazi.<span class="c6"><br /> AL HAKUM TAKATHUR:</span> Mwarangajwe no gushaka kwigwizaho ubutunzi <span class="c2">(1)</span>.<span class="c6"> HATA ZUR\'TUMUL MAQABIR:</span> Kugeza ubwo mugeze mu mva <span class="c2">(2)</span>.<span class="c6"> KALA SAWUFA TA\'ALAMUNA:</span> Oya ntibikwiye! Bidatinze muzamenya <span class="c2">(ko ubuzima bw’imperuka ari bwo bwiza kuri mwe)</span> <span class="c2">(3)</span>.<span class="c6"> THUMA KALA SAWUFA TA\'ALAMUNA:</span> Oya na none! Bidatinze muzamenya <span class="c2">(4)</span>.<span class="c6"> KALA LAW TA\'ALAMUNA I\'L\'MAL YAQIIN:</span> Oya! Iyo muza kugira ubumenyi budashidikanywaho <span class="c2">(bw’ibijyanye n’iherezo ryo kurangazwa no kwigwizaho imitungo, ntimwari guhugira mu by’isi)</span><span class="c2">(5)</span>.<span class="c6"> LATARAWUNAL DJAHIM:</span> Mu by’ukuri muzabona umuriro wa Jahiim! <span class="c2">(6)</span> THUMA LATARAWUNAHA AY\'NAL YAQIIN: Rwose muzawibonera imbonankubone <span class="c2">(7)</span>.<span class="c6"> THUMA LATUS\'ALUNA YAWMA IDHIN AN NAIIM:</span> Kandi rwose, kuri uwo munsi muzabazwa ku ngabire <span class="c2">(mwahawe muri ku isi)</span> <span class="c2">(8)</span>. <span class="c5">[Surat Takathur: 1-8]</span>.<span class="c6"><br /> IBISOBANURO BYAYO:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102001.mp3"></audio> 1-<span class="c6"> AL HAKUM TAKATHUR:</span> Mwarangajwe yemwe bantu no gushaka kwigwizaho ubutunzi kubwiratana butuma bubibagiza kumvira Allah.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102002.mp3"></audio> 2-<span class="c6"> HATA ZUR\'TUMUL MAQABIR:</span> Kugeza ubwo mupfuye mukinjizwa mu mva zanyu.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102003.mp3"></audio> 3-<span class="c6"> KALA SAWUFA TA\'ALAMUNA:</span> Oya ntibikwiye! Bidatinze muzamenya ko ubuzima bw’imperuka ari bwo bwiza kuri mwe, ko ubutunzi atari bwo bwari bukwiye kubarangaza no kubibagiza imperuka.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102004.mp3"></audio> 4-<span class="c6"> THUMA KALA SAWUFA YA\'ALAMUNA:</span> Oya na none! Bidatinze muzamenya iherezo ryabyo,<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102005.mp3"></audio> 5-<span class="c6"> KALA LAW TA\'ALAMUNA I\'L\'MAL YAQIIN:</span> Oya! Iyo muza kugira ubumenyi budashidikanywaho bw’ibijyanye n’iherezo ryo kurangazwa no kwigwizaho imitungo n\'urubyaro, ntimwari guhugira mu iby’isi.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102006.mp3"></audio> 6-<span class="c6"> LATARAWUNAL DJAHIM:</span> Mu by’ukuri byanze bikunze muzibonera imbonankubone umuriro wa Jahiim ku munsi w\'imperuka!<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102007.mp3"></audio> 7-<span class="c6"> THUMA LATARAWUNAHA AY\'NAL YAQIIN:</span> Rwose muzawibonera imbonankubone mu buryo budashidikanywaho.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102008.mp3"></audio> 8-<span class="c6"> THUMA LATUS\'ALUNA YAWMA IDHIN ANI NAIIM:</span> Kandi rwose, kuri uwo munsi muzabazwa ku ngabire z\'ubuzima n\'ubutunzi mwahawe muri ku isi. </p>',
            ],
            5 => [
                'question' => 'Ikibazo cya gatandatu: Soma Surat Al As\'r unayisobanure.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7750.mp3',
                'answer' => '<p> Igisubizo: Surat Al As\'r n\'ibisobanuro byayo.<span class="c6"><br /> "BISMILLAH RAH\'MAN RAHIIM:</span> Ku izina rya Allah, Nyirimpuhwe, Nyirimbabazi.<span class="c6"><br /> WAL ASR:</span> Ndahiye igihe <span class="c2">(1)</span>.<span class="c6"> INAL IN\'SANA LAFI KHUS\'RI:</span> Mu by’ukuri umuntu ari mu gihombo <span class="c2">(2)</span>.<span class="c6"> ILA LADHINA AMANU WA AMILU SWALIHATI WA TAWASWAWU BIL HAQ WA TAWASWAW BISWAB\'RI:</span> Uretse abemeye bagakora ibikorwa byiza, bakagirana inama z’ukuri kandi bakanagirana inama zo kwihangana <span class="c2">(3)</span>. <span class="c5">[Surat Al As\'r: 1-3]</span><br /> IBISOBANURO BYAYO:<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/103001.mp3"></audio> 1-<span class="c6"> WAL ASR:</span> Allah yarahiriye ku gihe.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/103002.mp3"></audio> 2-<span class="c6"> INAL INS\'ANA LAFI KHUS\'RI:</span> Avuga ko buri muntu wese ari mu gihombo no kurimbuka.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/103003.mp3"></audio> 3-<span class="c6"> ILA LADHINA AMANU WA AMILU SWALIHATI WA TAWASWAWU BIL HAQ WA TAWASWAW BISWAB\'RI:</span> Uretse babandi bemeye bagakora ibikorwa byiza, bakagirana inama z’ukuri kandi bakanagirana inama zo kwihangana. Abo nibo batazaba mu gihombo cyangwa se ngo barimbuke. </p>',
            ],
            6 => [
                'question' => 'Ikibazo cya karindwi: Soma Surat Al Humazat unayisobanure.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7830.mp3',
                'answer' => '<p> Igisubizo: suratu al humazat n\'ibisobanuro byayo.<span class="c6"><br /> "BISMILLAH RAH\'MAN RAHIIM:</span> Ku izina rya Allah, Nyirimpuhwe Nyirimbabazi.<span class="c6"><br /> WAY\'LUN LIKULI HUMAZATIN LUMAZAT:</span> Ibihano bikomeye bizaba kuri buri wese unegura abandi, usebanya <span class="c2">(1)</span>. A-<span class="c6">LADHI DJAMA\'A MALAN WA A\'DADAH:</span> Urundanya imitungo agahora ayibara <span class="c2">(2)</span>.<span class="c6"> YAH\'SABU ANA MALAHU AKH\'LADAH:</span> Yibwira ko umutungo we uzatuma abaho ubuziraherezo <span class="c2">(3)</span> ! KALA LAYUN\'BADHANA FIL HUTWAMAT: Oya! Mu by’ukuri azajugunywa mu muriro witwa Hutwama <span class="c2">(ushwanyaguza)</span> <span class="c2">(4)</span>.<span class="c6"> WAMA AD\'RAKA MAL HUTWAMAT:</span> Ni iki kizakumenyesha Hutwama icyo ari cyo <span class="c2">(5)</span>? NARULLAHIL MUQADAT: Ni umuriro wa Allah wenyegejwe <span class="c2">(6)</span>, A-<span class="c6">LATI TATWALI\'U ALAL AF\'IDAT:</span> Uwo muriro uzajya uzamuka ugere ku mitima <span class="c2">(y’abazaba bawurimo)</span> <span class="c2">(7)</span>, INAHA ALAY\'HIM MU-<span class="c6">USWADAT:</span> Mu by’ukuri bazaba bawufungiwemo <span class="c2">(8)</span>,<span class="c6"> FII AMADIN MUMADADAT:</span> <span class="c2">(Baziritse)</span> ku nkingi ndende <span class="c2">(kugira ngo batawusohokamo)</span> <span class="c2">(9)</span>. <span class="c5">[Surat Al Humazat: 1-9]</span><br /> IBISOBANURO BYAYO:<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104001.mp3"></audio> 1-<span class="c6"> WAY\'LUN LIKULI HUMAZATIN LUMAZAT:</span> Ibihano bikomeye bizaba kuri buri wese unegura abandi, usebanya.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104002.mp3"></audio> 2- A-<span class="c6">LADHI DJAMA\'A MALAN WA A\'DADAH:</span> Urundanya imitungo agahora ayibara, nta kindi arangamiye;<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104003.mp3"></audio> 3-<span class="c6"> YAH\'SABU ANA MALAHU AKH\'LADAH:</span> Yibwira ko umutungo we uzatuma abaho ubuziraherezo! mu buzima bw\'iyi si.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104004.mp3"></audio> 4-<span class="c6"> KALA LAYUN\'BADHANA FIL HUTWAMAT:</span> Oya! Mu by’ukuri azajugunywa mu muriro witwa Hutwama <span class="c2">(ushwanyaguza)</span>. nta kibazo kirimo nkuko uyu muntu w\'injiji abitekereza, mu kujugunywa mu muriro utazima,ukubita kandi umena ibintu byose byajugunywemo kubera ubukana bwawo.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104005.mp3"></audio> 5-<span class="c6"> WAMA AD\'RAKA MAL HUTWAMAT:</span> Ni iki kizakumenyesha Hutwama icyo ari cyo icyo wamenya - Yewe Ntumwa - uyu muriro urimbura ibintu byose wajugunywemo?!<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104006.mp3"></audio> 6-<span class="c6"> NARULLAHIL MUQADAT:</span> Ni umuriro wa Allah wenyegejwe kandi waka cyane.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104007.mp3"></audio> 7- A-<span class="c6">LATI TATWALI\'U ALAL AF\'IDAT:</span>Uwo muriro uzajya uzamuka ugere ku mitima y’abazaba bawurimo.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104008.mp3"></audio> 8- INAHA ALAY\'HIM MU-<span class="c6">USWADAT:</span> Mu by’ukuri bazaba bawufungiwemo mu mfunganwa.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104009.mp3"></audio> 9-<span class="c6"> FII AMADIN MUMADADAT:</span> Baziritse ku nkingi ndende kugira ngo batawusohokamo. </p>',
            ],
            7 => [
                'question' => 'Ikibazo cya munani: Soma Surat Al Fiili, unayisobanure.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7970.mp3',
                'answer' => '<p> Igisubizo:surat al fiili n\'ibisobanuro byayo.<span class="c6"><br /> "BISMILLAH RAH\'MAN RAHIIM:</span> Ku izina rya Allah , Nyirimpuhwe, Nyirimbabazi,<span class="c6"><br /> ALAM TARA KAYFA FA\'ALA RABUKA BI ASW\'HABIL FIILI:</span> Ese <span class="c2">(yewe Muhamadi)</span> ntiwamenye uko Nyagasani wawe yagize abagabye igitero bari ku nzovu <span class="c2">(baje gusenya ingoro ya Al Kaabat iri i Maka)</span>? <span class="c2">(1)</span> ALAM YADJ\'AL KAYDAHUM FII TADW\'LIL: Ese umugambi wabo mubisha ntiyawuburijemo? <span class="c2">(2)</span> WA AR\'SALA ALAYHIM TWAYRAN ABABIILI: Nuko akaboherereza uruhuri rw’inyoni <span class="c2">(3)</span>,<span class="c6"> TAR\'MIHIM BIHIDJARATIN MIN SIDJIIL:</span> Zikabatera amabuye y’ibumba yacaniriwe <span class="c2">(4)</span>, FADJA\'ALAHUM KA\'ASWIFIN MA-<span class="c6">AKUL:</span> Maze akabagira nk’ibyatsi byakanjakanjwe <span class="c2">(5)</span>. <span class="c5">[Surat Al Fiili: 1-5]</span><br /> IBISOBANURO BYAYO:<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105001.mp3"></audio> 1-<span class="c6"> ALAM TARA KAYFA FA\'ALA RABUKA BI ASW\'HABIL FIILI:</span> Ese yewe Ntumwa y\'Imana, ntiwamenye uko Nyagasani wawe yagize uwitwa Ab\'rahat n\'ingabo ze bagabye igitero bagendera ku nzovu baje gusenya ingoro ya Al Kaabat iri i Maka?<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105002.mp3"></audio> 2-<span class="c6"> ALAM YADJ\'AL KAYDAHUM FII TADW\'LIL:</span> Ese umugambi wabo mubisha ntiyawuburijemo, maze ibyo bifuzaga ntibabigeraho.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105003.mp3"></audio> 3-<span class="c6"> WA AR\'SALA ALAYHIM TWAYRAN ABABIILI:</span> Nuko akaboherereza uruhuri rw’inyoni.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105004.mp3"></audio> 4-<span class="c6"> TAR\'MIHIM BIHIDJARATIN MIN SIDJIIL:</span> Zikabatera amabuye y’ibumba yacaniriwe,<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105005.mp3"></audio> 5- FADJA\'ALAHUM KAA\'ASWIFIN MA-<span class="c6">AKUL:</span> Maze akabagira nk’ibyatsi byakanjakanjwe n\'inyamaswa zikanabikandangira. </p>',
            ],
            8 => [
                'question' => 'Ikibazo cya cyenda: Soma Surat Qurayshi, unayisobanure.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8070.mp3',
                'answer' => '<p> Igisubizo:Surat Qurayshi, n\'ibisobanuro byayo.<span class="c6"><br /> "BISMILLAH RAH\'MAN RAHIIM:</span> Ku izina rya Allah , Nyirimpuhwe, Nyirimbabazi,<span class="c6"><br /> LI ILAFI QURAYSHI:</span>Kubera akamenyero k’Abakurayishi<span class="c2">(mu mujyi wabo)</span> <span class="c2">(1)</span> ILAFIHIM RIH\'LATA SHITA\'I WA SWAYF: No kubera amasezerano yabo arebana n’ingendo <span class="c2">(z’ubucuruzi)</span> zo mu gihe cy’ubukonje no mu gihe cy’impeshyi <span class="c2">(batekanye)</span> <span class="c2">(2)</span>,<span class="c6"> FAL YA\'ABUDU RABA HADHAL BAYTI:</span> Ngaho nibagaragire <span class="c2">(Allah)</span> Nyagasani nyir’iyi ngoro <span class="c2">(Al Ka’abat)</span> <span class="c2">(3)</span>,<span class="c6"> ALADHI ATW\'AMAHUM MIN DJU\'IN WA AMANAHUM MIN KHAWFI:</span> <span class="c2">(We)</span> wabagaburiye mu gihe cy’amapfa, ndetse akanabaha umutekano mu gihe cy’ubwoba <span class="c2">(4)</span>. <span class="c5">[Surat Qurayshi: 1-4]</span><br /> IBISOBANURO BYAYO:<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106001.mp3"></audio> 1-<span class="c6"> LI ILAFI QURAYSHI:</span>Kubera akamenyero k’Abakurayishi,<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106002.mp3"></audio> 2-<span class="c6"> ILAFIHIM RIH\'LATA SHITA\'I WA SWAYF:</span> No kubera amasezerano yabo arebana n’ingendo z’ubucuruzi zo mu gihe cy’ubukonje bajya Yemeni, n\'izo mu mpeshyi bajya ahitwa Shami kandi batekanye,<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106003.mp3"></audio> 3-<span class="c6"> FAL YA\'ABUDU RABA HADHAL BAYTI:</span> Kubera ibyo, ngaho nibagaragire Allah Nyagasani Nyir’iyi ngoro ya Al Ka’abat,<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106004.mp3"></audio> 4-<span class="c6"> ALADHI ATW\'AMAHUM MIN DJU\'I WA AMANAHUM MIN KHAWFI:</span> We wabagaburiye mu gihe cy’amapfa, ndetse akanabaha umutekano mu gihe cy’ubwoba kubera icyubahiro n\'igitinyiro yashyize mu mitima y\'abandi barabu cy\'ingoro ye, n\'igitinyiro bo ubwabo yabahaye. </p>',
            ],
            9 => [
                'question' => '5- Ikibazo cya cumi: Soma Surat Al Ma\'un, unayisobanure.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8160.mp3',
                'answer' => '<p> Igisubizo:Surat Al Ma\'un, n\'ibisobanuro byayo.<span class="c6"><br /> "BISMILLAH RAH\'MAN RAHIIM:</span> Ku izina rya Allah, Nyirimpuhwe, Nyirimbabazi,<br /> ARA-<span class="c6">AYTA LADHI YUKADHIBU BIDIINI:</span> Ese wamenye uhinyura umunsi w’ibihembo? <span class="c2">(1)</span> FADHALIKA LADHI YADU\'UL YATIMA:Uwo ni wa wundi uhutaza imfubyi <span class="c2">(2)</span>,<span class="c6"> WALA YAHUDHWU ALA TWAAMIL MISKINA:</span> Ntanashishikarize <span class="c2">(abandi)</span> kugaburira abakene <span class="c2">(3)</span>,<span class="c6"> FAWAYLUN LIL MUSWALINA:</span> Bityo, ibihano bikomeye biri ku basenga <span class="c2">(4)</span>,<span class="c6"> ALADHINA HUM AN SWALATIHIM SAHUNA:</span> Ba bandi birengagiza iswala zabo <span class="c2">(ntibazikorere ku bihe byazo byagenwe)</span> <span class="c2">(5)</span> ALADHINA HUM YURA\'UNA:Ba bandi bakora ibyiza bagamije kwiyerekana <span class="c2">(6)</span>,<span class="c6"> WA YAM\'NAUNAL MA\'UNA:</span> Kandi bakanga <span class="c2">(gutiza)</span> ibikoresho byo mu rugo <span class="c2">(ababikeneye)</span> <span class="c2">(7)</span>. <span class="c5">[Surat Al Ma\'una: 1-7]</span><br /> IBISOBANURO BYAYO:<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107001.mp3"></audio> 1- ARA-<span class="c6">AYTA LADHI YUKADHIBU BIDIINI:</span>Ese wamenye uhinyura umunsi w’ibihembo, ari wo munsi w\'imperuka?<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107002.mp3"></audio> 2-<span class="c6"> FADHALIKA LADHI YADU\'UL YATIMA:</span> Uwo ni wa wundi uhutaza imfubyi n\'umushiha, nta mucyemurire icyo yifuza.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107003.mp3"></audio> 3-<span class="c6"> WALA YAHUDHWU ALA TWAAMIL MISKINA:</span> Ntanashishikarize abandi kugaburira abakene.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107004.mp3"></audio> 4-<span class="c6"> FAWAYLUN LIL MUSWALINA:</span>Bityo, ibihano bikomeye biri ku basenga.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107005.mp3"></audio> 5-<span class="c6"> ALADHINA HUM AN SWALATIHIM SAHUNA:</span> Ba bandi birengagiza iswala zabo ntibazikorere ku bihe byazo byagenwe.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107006.mp3"></audio> 6-<span class="c6"> ALADHINA HUM YURA\'UNA:</span> Ba bandi bakora ibyiza bagamije kwiyerekana mu iswala zabo no mu bikorwa byabo, ntibabikore kubera Allah.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107007.mp3"></audio> 7-<span class="c6"> WA YAM\'NAUNAL MA\'UNA:</span> Kandi bakanga gutiza ibikoresho byo mu rugo n\'ibindi bikoresho biciriritse bidafite icyo bitwaye kubitiza ababikeneye. </p>',
            ],
            10 => [
                'question' => 'Ikibazo cya cumi na rimwe: Soma Surat Al Kaw\'thar, unayisobanure.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8280.mp3',
                'answer' => '<p> Igisubizo: Surat Al Kaw\'thar, n\'ibisobanuro byayo.<span class="c6"><br /> "BISMILLAH RAH\'MAN RAHIIM:</span> Ku izina rya Allah , Nyirimpuhwe, Nyirimbabazi,<span class="c6"><br /> INA A\'ATWA\'YNAKAL KAWTHAR:</span> Mu by’ukuri <span class="c2">(yewe Muhamadi)</span> twaguhaye <span class="c2">(ibyiza byinshi birimo)</span> umugezi wo mu Ijuru witwa Kawthar <span class="c2">(1)</span>.<span class="c6"> FASWALI LIRABIKA WAN\'HAR:</span> Bityo, ujye usali unatange ibitambo kubera Nyagasani wawe <span class="c2">(2)</span>.<span class="c6"> INA SHANI\'AKA HUWAL AB\'TAR:</span> Mu by’ukuri ukwanga ni we nyakamwe <span class="c2">(ntazigera abona ibyiza haba ku isi ndetse no ku mperuka)</span> <span class="c2">(3)</span>. <span class="c5">[Surat Al Kaw\'thar: 1-3]</span><br /> IBISOBANURO BYAYO:<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/108001.mp3"></audio> 1-<span class="c6"> INA ATWA\'YNAKAL KAWTHAR:</span> Mu by’ukuri <span class="c2">(yewe Muhamadi)</span> twaguhaye <span class="c2">(ibyiza byinshi birimo)</span> umugezi wo mu Ijuru witwa Kawthar.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/108002.mp3"></audio> 2-<span class="c6"> FASWALI LIRABIKA WAN\'HAR:</span> Bityo, ujye ushimira Allah, usali kubera we wenyine, unatange ibitambo kubera we, bitandukanye n\'ibyo ababangikanyamana bakora babikorera ibigirwamana.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/108003.mp3"></audio> 3-<span class="c6"> INA SHANI\'AKA HUWAL AB\'TAR:</span> Mu by’ukuri ukwanga ni we nyakamwe, ntazigera abona ibyiza haba hano ku isi ndetse no ku mperuka. mu kui ukwanga niwe utazabona n\'ikiza na kimwe wibagiranye iyo avuzwe avugwa ibibi gusa. </p>',
            ],
            11 => [
                'question' => 'Ikibazo cya cumi na kabiri: Soma Surat Al Kafiruna, unayisobanure.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8360.mp3',
                'answer' => '<p> Igisubizo:Soma Surat Al Kafiruna, n\'ibisobanuro byayo.<span class="c6"><br /> "BISMILLAH RAH\'MAN RAHIIM:</span> Ku izina rya Allah , Nyirimpuhwe, Nyirimbabazi,<span class="c6"><br /> QUL YA AYUHAL KAFIRUNA:</span> Vuga <span class="c2">(yewe Muhamadi)</span> uti “Yemwe bahakanyi! <span class="c2">(1)</span> LA A\'ABUDU MA TA\'ABUDUNA: Singaragira ibyo mugaragira <span class="c2">(2)</span>,<span class="c6"> WALA AN\'TUM ABIDUNA MA A\'BUDU:</span> Kandi namwe ntimugaragira uwo ngaragira <span class="c2">(3)</span>.<span class="c6"> WALA ANA ABIDUN MA ABAD\'TUM:</span> Ndetse nanjye sinzigera ngaragira ibyo mugaragira <span class="c2">(4)</span>,<span class="c6"> WALA ANTUM ABIDUNA MA A\'BUDU:</span> Kandi namwe ntimugaragira uwo ngaragira <span class="c2">(5)</span>.<span class="c6"> LAKUM DINUKUM WA LIYA DINI:</span> Mufite idini ryanyu, nanjye nkagira idini ryanjye <span class="c2">(6)</span>. <span class="c5">[Surat Al Kafiruna: 1-6]</span><br /> IBISOBANURO BYAYO:<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109001.mp3"></audio> 1-<span class="c6"> QUL YA AYUHAL KAFIRUNA:</span> Vuga <span class="c2">(yewe Muhamadi)</span> uti “Yemwe bahakanyi, muhakana Allah!<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109002.mp3"></audio> 2-<span class="c6"> LA A\'ABUDU MA TA\'ABUDUNA:</span> Singaragira byaba ubu ndetse no mu bihe bizaza ibyo mugaragira by\'ibigirwamana;<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109003.mp3"></audio> 3-<span class="c6"> WALA AN\'TUM ABIDUNA MA A\'BUDU:</span> Kandi namwe ntimugaragira uwo ngaragira ari we Allah wenyine;<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109004.mp3"></audio> 4-<span class="c6"> WALA ANA ABIDUN MA ABAD\'TUM:</span> Ndetse nanjye sinzigera ngaragira ibyo mugaragira by\'ibigirwamana,<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109005.mp3"></audio> 5-<span class="c6"> WALA ANTUM ABIDUNA MA A\'BUDU:</span> Kandi namwe ntimugaragira uwo ngaragira ari we Allah wenyine;<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109006.mp3"></audio> 6-<span class="c6"> LAKUM DINUKUM WA LIYA DINI:</span> Mufite idini ryanyu mwihimbiye, nanjye nkagira idini ryanjye Allah yanyoboyemo. </p>',
            ],
            12 => [
                'question' => 'Ikibazo cya cumi na gatatu: Soma Surat A-Nas\'r, unayisobanure.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8470.mp3',
                'answer' => '<p> Igisubizo:Surat A-Nas\'r, n\'ibisobanuro byayo.<span class="c6"><br /> "BISMILLAH RAH\'MAN RAHIIM:</span> Ku izina rya Allah, Nyirimpuhwe, Nyirimbabazi,<br /> IDHA DJA-<span class="c6">A NAS\'RULLAHI WAL FAT\'H:</span> Igihe ubutabazi bwa Allah <span class="c2">(kuri wowe Muhamadi)</span> buzaza,ndetse n’intsinzi <span class="c2">(yo kubohora umujyi wa Maka)</span> <span class="c2">(1)</span>,<span class="c6"> WA RA\'AYTA NASA YAD\'KHULUNA FI DINILLAHI AF\'WAJAN:</span> Nuko ukabona abantu binjira mu idini rya Allah ku bwinshi <span class="c2">(2)</span>,<span class="c6"> FASABIH BIHAMDI RABIKA WASTAGH\'FIRUHU INAHU KANA TAWABAN:</span> Uzasingize ikuzo rya Nyagasani wawe <span class="c2">(aho uri hose)</span>, unamusabe imbabazi; kuko ari We Uwakira ukwicuza <span class="c2">(kw’abagaragu be)</span>. <span class="c2">(3)</span> <span class="c5">[Surat A-<span class="c6">Nasw\'r:</span> 1-3]</span><br /> IBISOBANURO BYAYO:<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/110001.mp3"></audio> 1- IDHA DJA-<span class="c6">A NAS\'RULLAHI WAL FAT\'H:</span> Igihe ubutabazi bwa Allah kuri wowe Muhamadi buzaba bukugezeho, ndetse n’intsinzi yo kubohora umujyi wa Maka ikagera;<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/110002.mp3"></audio> 2-<span class="c6"> WA RA\'AYTA NASA YAD\'KHULUNA FI DINILLAHI AF\'WAJAN:</span> Ukabona abantu binjira mu idini rya Allah ku bwinshi,<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/110003.mp3"></audio> 3-<span class="c6"> FASABIH BIHAMDI RABIKA WASTAGH\'FIRUHU INAHU KANA TAWABAN:</span> Uzamenye ko icyo ari ikimenyetso cy\'uko inshingano zawe z\'ubutumwa ziri kugana ku musozo, maze usingize ikuzo rya Nyagasani wawe umushimira ku bw\'inema ze zo kuba yaraguteye inkunga akaguha n\'intsinzi, unamusabe imbabazi; kuko ari We Uwakira ukwicuza kw’abagaragu be. </p>',
            ],
            13 => [
                'question' => 'Ikibazo cya cumi na kane: Soma Surat Al Masad, unayisobanure.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8550.mp3',
                'answer' => '<p> Igisubizo:Surat Al Masad, n\'ibisobanuro byayo.<span class="c6"><br /> "BISMILLAH RAH\'MAN RAHIIM:</span> Ku izina rya Allah, Nyirimpuhwe, Nyirimbabazi,<span class="c6"><br /> TABAT YADA ABI LAHABIN WA TABA:</span> Amaboko yombi ya Abu Lahab arakorama<span class="c2">(kubera ko yayakoreshaga abangamira intumwa y\'imana)</span> ndetse na we ubwe azorame <span class="c2">(1)</span>.<span class="c6"> MA AGH\'NAA AN\'HU MALUHU WA MA KASABA:</span> Umutungo we n’urubyaro rwe nta cyo bizamumarira <span class="c2">(2)</span>.<span class="c6"> SAYASW\'LA NARAN DHATA LAHABIN:</span> Azahira mu muriro ugurumana <span class="c2">(3)</span>,<span class="c6"> WAM\'RA ATUHU HAMALATAL HATWABI:</span> Ndetse n’umugore we watwaraga ibiti <span class="c2">(by’amahwa yajyaga atega mu nzira Intumwa y’Imana yanyuragamo)</span> <span class="c2">(4)</span>.<span class="c6"> FII DJIIDIHA HAB\'LUN MIN MASADI:</span> Mu ijosi rye <span class="c2">(uwo mugore)</span> hazaba hari umurunga wo mu muriro <span class="c2">(5)</span>. <span class="c5">[Suratul Masad: 1-5]</span><br /> IBISOBANURO BYAYO:<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111001.mp3"></audio> 1-<span class="c6"> TABAT YADA ABI LAHABIN WA TABA:</span> Amaboko yombi ya se wabo w\'Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> ari we Abu Lahab Ibun Abdul Mutwalib, arakorama ndetse na we ubwe azorame, kubera gutoteza Intumwa y\'Imana no kuyibuza amahoro.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111002.mp3"></audio> 2-<span class="c6"> MA AGH\'NAA AN\'HU MALUHU WA MA KASABA:</span> Umutungo we n’urubyaro rwe nta cyo bizamumarira, ntibizamurinda ibihano cyangwa se ngo bitume yagerwaho n\'impuhwe.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111003.mp3"></audio> 3-<span class="c6"> SAYASW\'LA NARAN DHATA LAHABIN:</span> Ku munsi w\'imperuka azinjizwa mu muriro ugurumana maze azawuhiremo,<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111004.mp3"></audio> 4-<span class="c6"> WAM\'RA ATUHU HAMALATAL HATWABI:</span> Ndetse n’umugore we watwaraga ibiti by’amahwa yajyaga atega mu nzira Intumwa y’Imana yanyuragamo;<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111005.mp3"></audio> 5-<span class="c6"> FII DJIIDIHA HAB\'LUN MIN MASADI:</span> Mu ijosi ry\'uwo mugore azanigirizwamo umurunga bazamukuruza bamujyana mu muriro. </p>',
            ],
            14 => [
                'question' => 'Ikibazo cya cumi na gatanu: Soma Surat Al Ikh\'lasw, unayisobanure.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8650.mp3',
                'answer' => '<p> Igisubizo:Surat Al Ikh\'lasw, n\'ibisobanuro byayo.<span class="c6"><br /> "BISMILLAH RAH\'MAN RAHIIM:</span> Ku izina rya Allah, Nyirimpuhwe, Nyirimbabazi,<span class="c6"><br /> QUL HUWALLAHU AHAD:</span> Vuga <span class="c2">(yewe Muhamadi)</span> uti <span class="c1">“We ni Allah, umwe Rukumbi, <span class="c2">(1)</span>”</span> ALLAHU SWAMAD: Allah, Uwishingikirizwa <span class="c2">(2)</span>,<span class="c6"> LAM YALID WA LAM YULAD:</span> Ntiyabyaye kandi ntiyanabyawe <span class="c2">(3)</span>,<span class="c6"> WA LAM YAKUN LAHU KUF\'WAN AHAD:</span> Ndetse nta na kimwe ahwanye na cyo <span class="c2">(4)</span>. <span class="c5">[Surat Al Ikh\'lasw: 1-4]</span><br /> IBISOBANURO BYAYO:<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112001.mp3"></audio> 1-<span class="c6"> QUL HUWALLAHU AHAD:</span> Vuga yewe Muhamadi uti <span class="c1">“We ni Allah umwe Rukumbi”</span>.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112002.mp3"></audio> 2-<span class="c6"> ALLAHU SWAMAD:</span> Allah, Nyir\'ukwishingikirizwa no kwiyambazwa n\'ibiremwa bye byose.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112003.mp3"></audio> 3-<span class="c6"> LAM YALID WA LAM YULAD:</span> Ntiyabyaye kandi ntiyanabyawe, nta se agira nta n\'urubyaro agira;<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112004.mp3"></audio> 4-<span class="c6"> WA LAM YAKUN LAHU KUF\'WAN AHAD:</span> Ndetse nta na kimwe ahwanye na cyo, nta n\'icyo asa nacyo mu byo yaremye. </p>',
            ],
            15 => [
                'question' => 'Ikibazo cya cumi na gatandatu: Soma Surat Al Falaq, unayisobanure.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8750.mp3',
                'answer' => '<p> Igisubizo:Surat Al Falaq, n\'ibisobanuro byayo.<span class="c6"><br /> "BISMILLAH RAH\'MAN RAHIIM:</span> Ku izina rya Allah, Nyirimpuhwe, Nyirimbabazi,<span class="c6"><br /> QUL AUDHU BIRABIL FALAQ:</span> Vuga <span class="c2">(yewe Muhamadi)</span> uti <span class="c1">“Niragije <span class="c2">(Allah)</span>, Nyagasani w’umuseke”</span>, <span class="c2">(1)</span> MIN SHARI MA KHALAQA: Ngo andinde inabi y’ibyo yaremye.<span class="c2">(2)</span> WA MIN SHARI GHASIQIN IDHA WAQABA: Anandinde ikibi cyo mu ijoro ryijimye igihe riguye<span class="c2">(3)</span>.<span class="c6"> WA MIN SHARI NAFATHATI FIL UQADI:</span> Anandinde ikibi cy’abarozikazi bahuha ku mapfundo <span class="c2">(4)</span>.<span class="c6"> WA MIN SHARI HASIDIN IDHA HASADA:</span> Ndetse anandinde inabi y’umunyeshyari igihe arigize <span class="c2">(5)</span>. <span class="c5">[Surat Al Alaq: 1-5]</span><br /> IBISOBANURO BYAYO:<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113001.mp3"></audio> 1-<span class="c6"> QUL AUDHU BIRABIL FALAQ:</span> Vuga yewe Muhamadi uti <span class="c1">“Nsabye ubuhungiro, naniragije Allah, Nyagasani w’umuseke”</span>,<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113002.mp3"></audio> 2-<span class="c6"> MIN SHARI MA KHALAQA:</span> Ngo andinde inabi y’ibyo yaremye,<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113003.mp3"></audio> 3-<span class="c6"> WA MIN SHARI GHASIQIN IDHA WAQABA:</span> Anandinde ikibi cyo mu ijoro ryijimye igihe riguye cyaba icyo naterwa n\'abajura, inyamaswa, udusimba, n\'indi myuka mibi bikunze kugaragara mu ijoro.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113004.mp3"></audio> 4-<span class="c6"> WA MIN SHARI NAFATHATI FIL UQADI:</span> Anandinde ikibi cy’abarozikazi bahuha mu mapfundo batongera;<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113005.mp3"></audio> 5-<span class="c6"> WA MIN SHARI HASIDIN IDHA HASADA:</span> Ndetse anandinde inabi y’umunyeshyari, wanga abantu abagirira ishyari ry\'ibyo Allah yabahaye we ntabimuhe, akaba yifuza ko babibura bakamera nkawe. </p>',
            ],
            16 => [
                'question' => 'Ikibazo cya cumi na karindwi: Soma Surat A-Nas, unayisobanure.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8870.mp3',
                'answer' => '<p> Igisubizo:Surat A-Nas, n\'ibisobanuro byayo.<span class="c6"><br /> "BISMILLAH RAH\'MAN RAHIIM:</span> Ku izina rya Allah, Nyirimpuhwe, Nyirimbabazi,<span class="c6"><br /> QUL AWUDHU BIRABI NASI:</span> Vuga <span class="c2">(yewe Muhamadi)</span> uti <span class="c1">“Niragije <span class="c2">(Allah)</span>, Nyagasani w’abantu, <span class="c2">(1)</span>”</span> MALIKI NASI: Umwami w’abantu <span class="c2">(2)</span>” ILAHI NASI: Imana y’abantu <span class="c2">(3)</span>" MIN SHARIL WAS\'WASIL KHANAS: Ngo andinde ububi bwa <span class="c2">(shitani)</span> yoshya gukora ibibi, nyuma ikabireka <span class="c2">(igihe umuntu yibutse Allah)</span>, <span class="c2">(4)</span>” ALADHI YUWAS\'WISU FI SWUDURI NASI: <span class="c1">“Yoshya imitima y’abantu gukora ibibi <span class="c2">(5)</span>”</span> MINAL DJINATI WA NASI: <span class="c1">“Yaba <span class="c2">(shitani)</span> yo mu majini cyangwa mu bantu. <span class="c2">(6)</span>”</span> <span class="c5">[Surat A-<span class="c6">Nas:</span> 1-6]</span><br /> IBISOBANURO BYAYO:<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114001.mp3"></audio> 1-<span class="c6"> QUL AWUDHU BIRABI NASI:</span> Vuga yewe Muhamadi uti <span class="c1">“Niragije Allah, Nyagasani w’abantu”</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114002.mp3"></audio> 2-<span class="c6"> MALIKI NASI:</span> Umwami w’abantu, ubagenza uko ashatse, nta wundi mwami bafite utari we”<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114003.mp3"></audio> 3-<span class="c6"> ILAHI NASI:</span> Imana y’abantu y\'ukuri, nta yindi mana bafite itari we.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114004.mp3"></audio> 4-<span class="c6"> MIN SHARIL WAS\'WASIL KHANAS:</span> Ngo andinde ububi bwa shitani yoshya gukora ibibi, nyuma ikabireka igihe umuntu yibutse Allah."<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114005.mp3"></audio> 5-<span class="c6"> ALADHI YUWAS\'WISU FI SWUDURI NASI:</span> <span class="c1">“Yoshya imitima y’abantu gukora ibibi"<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114006.mp3"></audio> 6-<span class="c6"> MINAL DJINATI WA NASI:</span> “Yaba shitani yo mu majini cyangwa mu bantu.”</span> </p>',
            ],
        ],
        5 => [
            0 => [
                'question' => 'Ikibazo cya mbere: Uzuza Hadithi ivuga ko ibikorwa byose bigendana n\'umugambi bikoranywe, unavuge inyungu tuyikuramo.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9030.mp3',
                'answer' => '<p> Igisubizo: Hadithi yaturutse ku Muyobozi w’abemera, Ise wa Haf’swa, Umar Ibun Al Khatwabi <span class="c2">(Imana imwishimire)</span> yaravuze ati <span class="c1">“Numvise Intumwa y’Imana <span class="c2">(Imana iyihe amahoro n’imigisha)</span> ivuga iti: “Mu by’ukuri ibikorwa byose bigomba kujyana n’umugambi, kandi buri wese ahemberwa icyo yakoranye umugambi. Bityo, uzimuka kubera Imana n’Intumwa yayo, uwo ukwimuka kwe kuzaba ari ukw’Imana n’Intumwa yayo. Ariko uzimuka agamije indonke z’isi, cyangwa umugore yifuza kurongora, uwo ukwimuka kwe kuzaba gushingiye kuri ibyo byatumye yimuka.”</span> Yakiriwe na Bukhari na Muslim.<br /> Inyungu dukura muri iyi Hadithi.<br /> 1- Buri gikorwa cyose, cyaba gusali, gusiba, gukora umutambagiro n\'ibindi kigomba kugendana n\'umugambi gikoranywe.<br /> 2- Ni ngombwa kwegurira ibikorwa Allah Nyirubutagatifu wenyine.<span class="c6"><br /> HADITHI YA KABIRI:</span> </p>',
            ],
            1 => [
                'question' => 'Ikibazo cya kabiri: Uzuza iyi Hadithi: "Uzazana igihimbano mu idini ryacu kitayirimo...", uvuge n\'inyungu tuyikuramo.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9090.mp3',
                'answer' => '<p> Igisubizo: Hadithi yaturutse kwa Nyina w’abemera, Nyina wa Abdillah, Aishat <span class="c2">(Imana imwishimire)</span> yaravuze ati: Intumwa y’Imana <span class="c2">(Imana iyihe amahoro n’imigisha)</span> yaravuze iti: "Uzadukana igihimbano mu idini ryacu kitayirimo, kizamugarukira.” Yakiriwe na Bukhari na Muslim.<span class="c6"><br /> Inyungu dukura muri iyi Hadithi:</span><br /> 1- Kubuza guhimba mu idini ibitaririmo.<br /> 2- Ibikorwa byose by\'ibihimbano ntibyakirwa ahubwo bigarukira nyirabyo.<br /> HADITHI YA GATATU. </p>',
            ],
            2 => [
                'question' => 'Ikibazo cya gatatu: Uzuza iyi Hadithi: "Ubwo twari twicaranye n\'Intumwa y\'Imana ...", unagaragaze inyungu tuyikuramo.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9160.mp3',
                'answer' => '<p> Igisubizo: Hadithi yaturutse kwa Umar Ibun Al Khatwabi <span class="c2">(Imana imwishimire)</span> yaravuze ati: "Umunsi umwe ubwo twari twicaranye n’Intumwa y’Imana <span class="c2">(Imana iyihe amahoro n’imigisha)</span>, twagenderewe n’umuntu wambaye imyenda yera cyane, n’imisatsi yirabura cyane. Nta kimenyetso na kimwe yari afite cyagaragazaga ko ari ku rugendo, ndetse nta n’umwe muri twe wari umuzi. Yarakomeje araza, nuko yicara imbere y’Intumwa Muhamadi, maze amavi ye ayegereza ay’Intumwa y’Imana, arambika ibiganza bye ku bibero by’Intumwa y’Imana, maze aravuga ati "Yewe Muhamadi! Mbwira ku byerekeye Islam".<span class="c6"> Intumwa y’Imana iravuga iti:</span> "Islam ni uguhamya ko nta yindi mana ibaho ikwiriye gusengwa mu kuri usibye Allah wenyine, ukanahamya ko Muhamadi <span class="c2">(Allah amuhe amahoro n’imigisha)</span> ari Intumwa ya Allah, ugahozaho amasengesho, ugatanga amaturo, ugasiba ukwezi kwa Ramadwani, ugakora umutambagiro mutagatifu i Makat, igihe ubifitiye ubushobozi." <span class="c2">(Uwo muntu)</span> aravuga ati: "Uvuze ukuri",<span class="c6"> Umar aravuga ati:</span> Nuko turatangara tubonye abaza hanyuma akemeza ko ibivuzwe ari ukuri. <span class="c2">(Arongera)</span> arayibaza ati: "Mbwira ku byerekeye ukwemera." Intumwa y’Imana <span class="c2">(Imana iyihe amahoro n’imigisha)</span> iravuga iti: "Ni ukwemera Imana, Abamalayika bayo, Ibitabo byayo, Intumwa zayo, Umunsi w’imperuka, ndetse no kwemera igeno ryaba iry’ibyiza cyangwa iry’ibibi." <span class="c2">(Wa muntu)</span> aravuga ati "Uvuze ukuri", <span class="c2">(Arongera)</span> ati: "Noneho mbwira ku byerekeye Ihsan," Iravuga iti "Ni ugusenga Imana nk’aho uyireba kuko iyo utayireba yo iba ikureba." <span class="c2">(Wa muntu)</span> ati: "Mbwira ku byerekeye umunsi w’imperuka”, <span class="c2">(Intumwa Muhamadi)</span> iti: "Ntabwo uwubazwa awuzi kurusha uwubaza." <span class="c2">(Wa muntu)</span> ati: "Ngaho mbwira ku byerekeye ibimenyetso byawo." Iravuga iti "Ni igihe umuja azabyara shebuja, ndetse n’igihe uzabona abantu batambaye inkweto, bambaye ubusa, b’abatindi, b’abashumba, barushanwa kuzamura amazu y’imiturirwa". Nuko <span class="c2">(wa muntu)</span> arigendera, maze mara umwanya muto. Nuko,<span class="c6"> Intumwa y’Imana irambaza iti "Yewe Umar! Ese uzi uwabazaga uwo ari we?" Ndavuga nti:</span> "Imana n’Intumwa yayo ni bo bamuzi neza." Aravuga ati "Uriya yari Jibril wari waje kubigisha idini ryanyu." Yakiriwe na Muslim.<span class="c6"><br /> Inyungu dukura muri iyi Hadithi:</span><br /> 1-<span class="c6"> Kutwigisha inkingi eshanu z\'ubuyisilamu ari zo:</span><br /> Kwemera ko nta yindi mana iriho uretse Allah kandi ko Muhamad ari Intumwa ye.<br /> Guhozaho iswala.<br /> Gutanga amaturo.<br /> Gusiba ukwezi kwa Ramadhan.<br /> Gukora umutambagiro ku ngoro ntagatifu ya Allah.<br /> 2-<span class="c6"> Kutwigisha inkingi esheshatu z\'ukwemera ari zo:</span><br /> Kwemera Allah.<br /> N\'abamalayika be.<br /> N’ibitabo bye.<br /> N\'intumwa ze<br /> N\'umunsi w\'imperuka.<br /> N\'igeno rya Allah ry\'ibyiza n\'ibibi.<br /> 3- Kutwigisha inkingi yo kugira neza, ikaba ari inkingi imwe ari yo y\'uko ugomba kugaragira Allah nkaho umureba, n\'ubwo waba utamureba ariko ukazirikana ko we akureba.<br /> 4- Igihe imperuka izabera ntawe ukizi uretse Allah Nyirubutagatifu.<span class="c6"><br /> HADITHI YA KANE:</span> </p>',
            ],
            3 => [
                'question' => 'Ikibazo cya kane: Uzuza iyi Hadithi: "Umwemeramana ufite ukwemera kuzuye,..." unagaragaze zimwe mu nyungu dukuramo.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9360.mp3',
                'answer' => '<p> Igisubizo: Hadithi yaturutse kwa Abi Said Al Khud\'riyu <span class="c2">(Imana imwishimire)</span> yaravuze ati: Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> yaravuze iti: "Umwemeramana ufite ukwemera kuzuye kuruta abandi ni ubarusha imico myiza." Yakiriwe naTirmidhi anavuga ko ari Hadith nziza y’impamo.<br /> Inyungu dukura muri iyi Hadithi.<br /> 1- Gushishikariza kurangwa n\'imico myiza.<br /> 2- Gutungana kw\'imico myiza ni kimwe mu biranga gutungana k\'ukwemera.<br /> 3- Ukwemera kuriyongera ndetse kukanagabanuka.<br /> HADITHI YA GATANU. </p>',
            ],
            4 => [
                'question' => 'Ikibazo cya gatanu: Uzuza iyi Hadithi: "Uzarahira ku kindi kitari Allah,..." ugaragaze n\'inyungu tuyikuramo.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9440.mp3',
                'answer' => '<p> Igisubizo: Imvugo yaturutse kwa Abdullah Ibun Umar <span class="c2">(Imana imwishimire we na se)</span> yavuze ko Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> yavuze iti: "Uzarahira ku kindi kitari Allah azaba ahakanye cyangwa se abangikanyije Allah." Yakiriwe na Thir\'midhi.<br /> Inyungu dukura muri iyi Hadithi.<br /> 1- Ntibyemewe kurahirira ku kindi usibye kuri Allah.<br /> 2- Kurahirira ku kindi kitari Allah Nyirubutagatifu bibarwa nk\'ibangikanyamana rito.<br /> HADITHI YA GATANDATU. </p>',
            ],
            5 => [
                'question' => 'Ikibazo cya gatandatu: Uzuza iyi Hadithi: "Umwe muri mwe ntaremera kugeza ubwo azankunda,..."unagaragaze inyungo dukuramo.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9510.mp3',
                'answer' => '<p> Igisubizo: Hadithi yaturutse kwa Anas <span class="c2">(Imana imwishimire)</span> yaravuze ati: Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> yaravuze iti: "Umwe muri mwe ntaremera kugeza ubwo azankunda kuruta uko akunda umubyeyi we, umwana we ndetse n\'abantu bose muri rusange." Yakiriwe na Bukhari na Muslim.<br /> Inyungu dukura muri iyi Hadithi.<br /> 1- Ni itegeko gukunda Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> kuruta uko dukunda abandi bantu.<br /> 2- Ibi ni mu biranga ukwemera nyako.<br /> HADITHI YA KARINDWI. </p>',
            ],
            6 => [
                'question' => 'Ikibazo cya karindwi: Uzuza iyi Hadithi: "Umwe muri mwe ntaremera kugeza ubwo akunda umuvandimwe we,...", ugaragaze na zimwe mu nyungu dukuramo.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9580.mp3',
                'answer' => '<p> Igisubizo: Hadithi yaturutse kwa Anas <span class="c2">(Imana imwishimire)</span> yaravuze ati: Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> yaravuze iti: "Umwe muri mwe ntaraba umwemera kugeza ubwo azakunda umuvandimwe we nkuko nawe yikunda." Yakiriwe na Bukhari na Muslim.<br /> Inyungu dukura muri iyi Hadithi.<br /> 1- Umwemeramana agomba gukunda abandi bemeramana akabifuriza ibyiza nk\'ibyo nawe yiyifuriza.<br /> 2- Ibi ni mu biranga ukwemera nyako.<span class="c6"><br /> HADITHI YA MUNANI:</span> </p>',
            ],
            7 => [
                'question' => 'Ikibazo cya munani: Uzuza Hadithi igira iti: Ndahiye k\'ufire roho yanjye mu kuboko kwe,,...!", unagaragaze inyungu dukuramo.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9650.mp3',
                'answer' => '<p> Igisubizo: Imvugo yaturutse kwa Abi Said <span class="c2">(Imana imwishimire)</span> yavuze ko Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> yavuze iti: "Ndahiye k\'ufite roho yanjye mu kuboko kwe, ko <span class="c2">(Surat Al Ikh\'lasw)</span> ingana na kimwe cya gatatu cya Qur\'an yose." Yakiriwe na Bukhari.<br /> Inyungu dukura muri iyi Hadithi.<br /> 1- Ibyiza byo gusoma Surat Al Ikh\'lasw <span class="c2">(Qul Huwallahu ahad)</span>.<br /> 2- Surat Al IKh\'lasw ingana na kimwe cya gatatu cya Qur\'an.<span class="c6"><br /> HADITHI YA CYENDA:</span> </p>',
            ],
            8 => [
                'question' => 'Ikibazo cya cyenda: Uzuza iyi Hadithi: "Kuvuga LA HAWLA WALA QUWATA ILA BILLAH: Nta bubasha cyangwa se ubushobozi usibye ko ari ibya Allah...", unavuge zimwe mu nyungu dukuramo.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9720.mp3',
                'answer' => '<p> Igisubizo: Hadithi yaturutse kwa Abi Mussa <span class="c2">(Imana imwishimire)</span> yaravuze ati: Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> yaravuze iti: "Kuvuga LA HAWLA WALA QUWATA ILA BILLAH: Nta bubasha cyangwa se ubushobozi usibye ko ari ibya Allah, ni bumwe mu butunzi bwo mu ijuru." Yakiriwe na Bukhari na Muslim.<br /> Zimwe mu nyungu dukura muri iyi Hadithi.<br /> 1- Ibyiza byo kuvuga iri jambo, kandi ko kurivuga ari bumwe mu butunzi bw\'ijuru.<br /> 2- Umugaragu kwiyambura ububasha ubwo ari bwo bwose n\'imbaraga ze ahubwo akiringira Allah wenyine.<span class="c6"><br /> HADITHI YA CUMI:</span> </p>',
            ],
            9 => [
                'question' => 'Ikibazo cya cumi: Uzuza iyi Hadithi: "Mu by\'ukuri mu mubiri harimo inyama,...", unavuge n\'inyungu tuyikuramo.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9790.mp3',
                'answer' => '<p> Hadithi yaturutse kwa Abi Abdillah A-Nu’uman Ibun Bashiri <span class="c2">(Imana ibishimire bombi)</span> yaravuze ati: Numvise Intumwa y’Imana <span class="c2">(Imana iyihe amahoro n’imigisha)</span> ivuga iti <span class="c1">“ Nta gushidikanya ko mu mubiri habamo inyama, iyo itunganye umubiri wose uratungana, yakwangirika umubiri wose ukangirika, iyo nyama nta yindi ni umutima.”</span> Yakiriwe na Bukhari na Muslim.<br /> Zimwe mu nyungu dukura muri iyi Hadithi.<br /> 1- Gutungana k\'umutima bifasha gutungana kw\'ingingo z\'umubiri z\'inyuma n\'iz\'imbere.<br /> 2- Kwita ku gutunganya umutima, kuko niwo utuma umuntu wese nawe atungana.<span class="c6"><br /> HADITHI YA CUMI NA RIMWE:</span> </p>',
            ],
            10 => [
                'question' => 'Ikibazo cya cumi na rimwe: Uzuza iyi Hadithi: Uwo amagambo ye ya nyuma mu buzima bwa hano mu isi azaba ari: LA ILAHA ILALLAH: Nta yindi mana ikwiye gusengwa by\'ukuri uretse Allah,...", unagaragaze inyungu dukuramo.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9860.mp3',
                'answer' => '<p> Igisubizo: Hadithi yaturutse kwa Muadh Ibun Djabal <span class="c2">(Imana imwishimire)</span> yaravuze ati: Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> yaravuze iti: Uwo amagambo ye ya nyuma mu buzima bwa hano mu isi azaba ari: LA ILAHA ILALLAH: Nta yindi mana ikwiye gusengwa by\'ukuri uretse Allah, azinjira mu ijuru." Yakiriwe na Abu Daudi.<span class="c6"><br /> Inyungu dukura muri iyi Hadithi:</span><br /> 1-<span class="c6"> Ibyiza byo kuvuga ijambo LA ILAHA ILALLAH:</span> Nta yindi mana ikwiye gusengwa by\'ukuri uretse Allah.<br /> 2- Ibyiza by\'uwo amagambo ye ya nyuma yo mu buzima bw\'iyi si azaba iri jambo.<span class="c6"><br /> HADITHI YA CUMI NA KABIRI:</span> </p>',
            ],
            11 => [
                'question' => 'Ikibazo cya cumi na kabiri: Uzuza iyi Hadithi: "Umwemeramana si wa wundi usebya abandi, cyangwa ubavuma,...", uvuge n\'inyungu dukuramo?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9940.mp3',
                'answer' => '<p> Igisubizo: Hadithi yaturutse kwa Ibun Mas’udi <span class="c2">(Imana imwishimire)</span> yaravuze ati: Intumwa y’Imana <span class="c2">(Imana imuhe amahoro n’imigisha)</span> yaravuze iti: <span class="c1">“Umwemera si wa wundi usebya abandi, cyangwa ubavuma, cyangwa umunyabikorwa by’urukozasoni, cyangwa uvuga amagambo mabi.”</span> Yakiriwe na Tir\'midhi.<span class="c6"><br /> Inyungu dukura muri iyi Hadithi:</span><br /> 1- Kubuza amagambo yose y\'ibinyoma ndetse n\'andi mabi.<br /> 2- Ibi biri mu biranga umwemeramana by\'umwihariko ku rurimi rwe.<span class="c6"><br /> HADITHI YA CUMI NA GATATU:</span> </p>',
            ],
            12 => [
                'question' => 'Ikibazo cya cumi na gatatu: Uzuza iyi Hadithi:... mu bitunganya ubuyisilamu bw\'umuntu..., ugaragaze n\'inyungu tuyikuramo?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10020.mp3',
                'answer' => '<p> Hadithi yaturutse kwa Abi Hurayirat <span class="c2">(Allah amwishimire)</span> yaravuze ati Intumwa y’Imana <span class="c2">(Imana imuhe amahoro n’imigisha)</span> yaravuze iti: "Mu bitunganya ubuyisilamu bw’umuntu ni uko areka ibitamureba." Yakiriwe na Tirmidhi ndetse na Ahmad.<span class="c6"><br /> Inyungu dukura muri iyi Hadithi:</span><br /> 1- Umuntu akwiye kureka ibitamureba byaba mu idini rye no mu buzima bwe.<br /> 2- Umuntu kureka ibitamureba biri mu bituma ubuyisilamu bw\'umuntu butungana.<span class="c6"><br /> HADITHI YA CUMI NA KANE:</span> </p>',
            ],
            13 => [
                'question' => 'Ikibazo cya cumi na kane: Uzuza iyi Hadithi: "Uzasoma inyuguti imwe mu gitabo cya Allah,...", ugaragaze n\'inyungu dukuramo.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10100.mp3',
                'answer' => '<p> Igisubizo: Hadithi yaturutse kwa Ibun Mas\'udi <span class="c2">(Imana imwishimire)</span> yaravuze ati: Intumwa y’Imana <span class="c2">(Imana imuhe amahoro n’imigisha)</span> yaravuze iti: "Uzasoma inyuguti mu gitabo cya Allah, azahabwa icyiza, kandi icyiza gihemberwa ibyiza icumi nka cyo. Ntabwo mvuze ngo Alif Lam Mim ni inyuguti, ahubwo Alif ni inyuguti, Lam ni inyuguti na Mim ikaba inyuguti." Yakiriwe na Tir\'midhi.<br /> Inyungu dukura muri iyi Hadithi.<br /> 1- Ibyiza byo gusoma Qur\'an.<br /> 2- Buri nyuguti usomye iyibonera ibihembo. </p>',
            ],
        ],
        6 => [
            0 => [
                'question' => 'Ikibazo cya mbere: Ni iyihe myifatire ikwiye kuranga umuntu imbere ya Allah Nyirubutagatifu?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10190.mp3',
                'answer' => '<p> Igisubizo: 1- Gukuza Allah Nyirubutagatifu<br /> 2- Kumugaragira wenyine ntawe tumubangikanyije nawe.<br /> 3- Kumwumvira.<br /> 4- Kureka kumwigomekaho.<br /> 5- Kumushimira no kumukuza kubera ingabire ze n\'ibyiza bye bitarondoreka.<br /> 6- Kwihanganira igeno rye. </p>',
            ],
            1 => [
                'question' => 'Ikibazo cya kabiri: Ni iyihe myifatire ikwiye kuranga umuntu imbere y\'Intumwa ya Allah (Imana iyihe amahoro n\'imigisha)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10270.mp3',
                'answer' => '<p> Igisubizo: 1- Kuyikurikira no kugera ikirenge mu cyayo.<br /> 2- Kuyumvira.<br /> 3- Kureka kuyigomekaho<br /> 4- Guhamya ukuri kw\'ibyo yavuze.<br /> 5- Kutihimbira ibyawe wongera mu byo yigishije <span class="c2">(Bid\'at)</span>.<br /> 6- Kuyikunda kuruta uko wikunda no kuruta uko ukunda abandi bantu.<br /> 7- Kuyiha agaciro, kuyirengera, ndetse no kurengera imigenzo yayo. </p>',
            ],
            2 => [
                'question' => 'Ikibazo cya gatatu: Ni iyihe myifatire ikwiye kurangwa hagati y\'umuntu n\'ababyeyi be?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10360.mp3',
                'answer' => '<p> Igisubizo: 1- Kumvira ababyeyi bombi utabigomekaho.<br /> 2- Gukorera imirimo ababyeyi.<br /> 3- Gufasha ababyeyi.<br /> 4- Gucyemura bimwe mu byo ababyeyi bacyeneye.<br /> 5- Gusabira ibyiza n\'imigisha ababyeyi.<br /> 6- Kurangwa n\'ikinyabupfura mu mvugo imbere y\'ababyeyi, kuko bitemewe gukoresha imbere yabo imvugo yo kubinuba, kandi ari yo yoroheje.<br /> 7- Kumwenyurira ababyeyi ntuzinge umunya.<br /> 8- Kutabazamuraho ijwi ahubwo ukabatega amatwi, ntubace mu ijambo, ndetse ntunabahamagare mu mazina yabo,<span class="c6"> ahubwo ukavuga uti:</span> \'Papa\', \'Mama\'.<br /> 9- Gusaba uburenganzira bwo kwinjira aho bari nk\'igihe bari mu cyumba.<br /> 10- Gusoma ikiganza cyangwa se mu mutwe h\'ababyeyi bombi. </p>',
            ],
            3 => [
                'question' => 'Ikibazo cya kane: Ni gute nakunga isano ryo mu muryango?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10490.mp3',
                'answer' => '<p> Igisubizo: 1- Gusura abanyamuryango babugufi nk\'abavandimwe bawe na bashiki bawe, ba so wanyu, ba nyogosenge, na ba nyorokome, na ba nyokowanyu ndetse n\'abandi ba hafi b\'abanyamuryango.<br /> 2- Kubagirira neza mu mvugo no mu bikorwa ndetse no kubafasha uko ubishoboye.<br /> 3- Kubavugisha, no kubaza amakuru yabo. </p>',
            ],
            4 => [
                'question' => 'Ikibazo cya gatanu: Ni gute nabanira abavandimwe n\'inshuti zanjye?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10550.mp3',
                'answer' => '<p> Igisubizo:1 - Gukunda no kubanira neza inshuti zanjye nziza.<br /> 2- Kwirinda kungendana no kubana n\'inshuti mbi.<br /> 3- Gusuhuza abavandimwe banjye no kubaha ikiganza.<br /> 4- Kubasura igihe barwaye no kubasabira ko Allah yabakiza.<br /> 5- Kwifuriza gukira n\'impuhwe kuwitsamuye mubo turi kumwe.<br /> 6- Kwitabira ubutumire bw\'untumiye muri bo nkamusura.<br /> 7- Kugira inama umwe muri bo igihe bicyenewe.<br /> 8- Gutabara no kurengera umwe muri bo igihe yahemukiwe, no kumubuza guhemuka igihe ashaka guhemuka.<br /> 10- Kwifuriza umuvandimwe wanjye w\'umuyisilamu ibyo nanjye niyifuriza.<br /> 11- Gufasha umuvandimwe wanjye w\'umuyisilamu igihe acyeneye ubufasha bwanjye.<br /> 12- Kutamubangamira byaba mu mvugo cyangwa se mu bikorwa.<br /> 13- Kurinda ibanga rye yambikije.<br /> 14- Kwirinda kumutuka, kumuvuga nabi adahari,kumusuzugura,kumugirira ishyari, kumuneka, cyangwa se kumuriganya. </p>',
            ],
            5 => [
                'question' => 'Ikibazo cya gatandatu: Ni iyihe myifatire ikwiye kuranga abaturanyi?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10710.mp3',
                'answer' => '<p> Igisubizo: 1- Kubanira umuturanyi neza mu mvugo no mu ngiro, no kumufasha igihe acyeneye ko umufasha.<br /> 2- Kumwifuriza ishya n\'ihirwe igihe cy\'ibyishimo nko ku munsi w\'irayidi, umunsi we w\'ubukwe, no mu bindi.<br /> 3- Kumusura yarwaye no kumutabara yagize ibyago.<br /> 4- Gusangira nawe ibyo kurya uko byashoboka kose.<br /> 5- Kutamubangamira mu mvugo no mu ngiro.<br /> 6- Kutamubangamira musakuriza, cyangwa se muneka, ndetse no kumwihanganira. </p>',
            ],
            6 => [
                'question' => 'Ikibazo cya karindwi: Ni iyihe myifatire ikwiye kuranga umuyisilamu mu kwakira abashyitsi?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10800.mp3',
                'answer' => '<p> Igisubizo: 1- Nitabira ubutumire bw\'untumiye.<br /> 2- Iyo nshatse kugira uwo nsura muri bo mbisabira uburenganzira na gahunda mbere.<br /> 3- Nsaba uburenganzira mbere yo kwinjira.<br /> 4- Simfata umwanya muremure igihe nasuye abantu.<br /> 5- Nubika amaso sindangamire abari mu nzu.<br /> 6- Mpa ikaze umushyitsi, nkamwakira mu buryo bwiza, mumwenyuriye, nanakoresheje imvugo nziza.<br /> 7- Nicaza umushyitsi ahantu heza hamukwiye.<br /> 8- Nakiriza umushyitsi ibyo nshoboye mu byo kurya no kunywa. </p>',
            ],
            7 => [
                'question' => 'Ikibazo cya munani: Ni iyihe myifatire ikwiye kuranga abantu mu burwayi no gusura abarwayi?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10900.mp3',
                'answer' => '<p> Igisubizo: 1- Igihe numva uburwayi cyangwa se uburibwe,<span class="c6"> nshyira ikiganza cyanjye cy\'iburyo aho mfite uburibwe maze nkavuga nti:</span> "BISMILLAH: Ku izina rya Allah",<span class="c6"> inshuro eshatu maze nkavuga nti:</span> "AUDHU BI IZATILLAH WA QUD\'RATIHI MIN SHARI MA ADJIDU WA UHADHIR: Nikinze ku cyubahiro cya Allah n’ubushobozi bwe ngo andinde ibibi by’uburwayi numva n’inkurikizi zabwo" <span class="c2">(inshuro zirindwi)</span>.<br /> 2- Nakira igeno Allah yangeneye nkanihangana.<br /> 3- Nihutira gusura umuvandimwe wanjye urwaye, nkamusabira kandi sinicare aho ngaho umwanya muremure.<br /> 4- Musabira ko Allah yamukiza uburwayi atarinze kubinsaba.<br /> 5- Muha impanuro zo kwihangana, kurushaho gusaba ubusabe, gusari ndetse no kugira isuku uko ashoboye.<br /> 6-<span class="c6"> Nsabira umurwayi ubusabe bugira buti:</span> AS\'ALULLAHA AL ADHWIIM RABAL AR\'SHIL ADHWIIM AN YASHFIIKA: <span class="c1">“Ndasaba Allah Uhambaye, Nyiri Ar\'shi y’icyubahiro ko yagukiza <span class="c2">(inshuro zirindwi)</span>.”</span> </p>',
            ],
            8 => [
                'question' => 'Ikibazo cya cyenda: Ni iyihe myifatire ikwiye kuranga abashaka ubumenyi?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10990.mp3',
                'answer' => '<p> Igisubizo: 1- Kweza umugambi wawe kubera Allah Nyirubutagatifu.<br /> 2- Nshyira mu bikorwa ubumenyi bw\'ibyo nize.<br /> 3- Nubaha umwarimu wanjye nkanamuha agaciro yaba ahari ndetse yaba atanahari.<br /> 4- Nicara imbereye mu kinyabupfura.<br /> 5- Mutega amatwi neza kandi simuce mu ijambo.<br /> 6- Mu gihe mubaza ikibazo ngomba kugira ikinyabupfura.<br /> 7- Simuhamagara mu izina rye. </p>',
            ],
            9 => [
                'question' => 'Ikibazo cya cumi: Ni iyihe myifatire ikwiye kuranga abari mu cyicaro?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11090.mp3',
                'answer' => '<p> Igisubizo:1- Mbanza gusuhuza abari mu cyicaro.<br /> 2- Nicara aho icyicaro nsanze kigeze, ntawe mpagurutsa mu mwanya we, cyangwa se ngo nicare hagati y\'abantu babiri cyeretse mbanje kubisabira uburenganzira.<br /> 3- Mpa umwanya abandi mu cyicaro ngo bicare.<br /> 4- Ntabwo nca mu ijambo abo turi kumwe mu cyicaro.<br /> 5- Nsaba uburenganzira nkanasezera mbere y\'uko mpaguruka mu cyicaro.<br /> 6- Iyo dusoje icyicaro, nsaba ubusabe busabwa igihe icyicaro kirangiye <span class="c2">(Kafaratul Madj\'lis)</span>. "“SUB’HANAKA AlLLAHUMA WA BIHAM’DIKA, ASHAHADU AN LA ILAHA ILA AN’TA,<span class="c6"> ASTAGH\'FIRUKA WA ATUBU ILAYKA:</span> Ubutagatifu ni ubwawe Allah no gushimwa ni ibyawe, ndahamya ko nta yindi mana ikwiye gusengwa by\'ukuri uretse wowe Mana, Mana ngusabye imbabazi kandi ni wowe nicujijeho". </p>',
            ],
            10 => [
                'question' => 'Ikibazo cya cumi na rimwe: Ni iyihe myifatire ikwiye kuranga abantu igihe cyo kuryama?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11180.mp3',
                'answer' => '<p> Igisubizo: 1- Ndyama kare.<br /> 2- Ndyama mfite isuku.<br /> 3- Sindyama nubitse inda.<br /> 4- Ndyamira urubavu rwanjye rw\'iburyo, maze umusaya wanjye w\'iburyo nkawuseguza ukuboko kw\'iburyo.<br /> 5- Mpungura mu buryamo bwanjye.<br /> 6- Nsoma ubusabe bwo kuryama nkasoma Ayatul Kur\'siyu, Surat Al Ikh\'lasw, Surat Al Falaq, ndetse na Surat A-Nas inshuro eshatu,<span class="c6"> maze nkavuga nti:</span> <span class="c1">“BIS’MILLAHI ALLAHUMA AMUTU WA AH’YA: Ku izina rya Allah, Mana Nyagasani mvuye mu buzima <span class="c2">(ndasinziriye)</span> kandi ndongera ngaruke mu buzima”</span>.<br /> 7- Mbyuka kare kugira ngo nsali Swalat Al Faj\'ri.<br /> 8-<span class="c6"> Namara gukanguka nkavuga nti:</span> “AL HAM’DULILLAHI LADHI AH’YANA BAADA MA AMATANA WA ILAY’HI NUSHURU: Nihashimwe Imana yo idusubije ubuzima nyuma yo kuba twari twapfuye kandi kuriyo niho tuzasubira." </p>',
            ],
            11 => [
                'question' => 'Ikibazo cya cumi na kabiri: Ni iyihe myifatire ikwiye kuranga abantu mu gihe cyo kurya?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11290.mp3',
                'answer' => '<p> Igisubizo:<br /> 1- Kurya kwanjye no kunywa kwanjye ngambirira kugira imbaraga zo kumvira Allah Nyirubutagatifu.<br /> 2- Gukaraba amaboko yombi mbere yo kurya.<br /> 3-<span class="c6"> Ndavuga nti:</span> "Bismillah: Ku izina rya Allah", nkarisha ukuboko kwanjye kw\'iburyo ndetse nkarya imbere yanjye, kandi ntabwo mfata ibyo kurya biri hagati mu isahani cyangwa se biri imbere y\'undi utari njye.<br /> 4- Iyo nibagiwe gutangiza izina rya Allah <span class="c2">(Bismillah)</span>,<span class="c6"> ndavuga nti:</span> "Bismillah Awaluhu wa Akhiruhu: Ku izina ry’Imana mu ntangiriro no mu mpera".<br /> 5- Nyurwa n\'ibyo kurya bihari, kandi simbinegure, iyo binyuze ndabirya, iyo bitanejeje ndabireka.<br /> 6- Ntamira ibiringaniye, sintamira byinshi.<br /> 7- Ntabwo mpuha mu byo kurya cyangwa se kunywa ahubwo ndabireka bigahora.<br /> 8- Nicarana n\'abandi ku byo kurya ndi hamwe n\'ab\'iwanjye cyangwa se abashyitsi.<br /> 9- Ntabwo mbanza kurya mbere y\'abankuriye.<br /> 10-<span class="c6"> Mvuga Bismillah:</span> Ku izina rya Allah igihe ngiye kunywa, kandi nkanywa nicaye, kandi nkanywa mu byiciro bitatu.<br /> 11- Nshimira Allah iyo nsoje kurya. </p>',
            ],
            12 => [
                'question' => 'Ikibazo cya cumi na gatatu: Vuga imyifatire ku bijyanye n\'imyambarire ikwiye kuranga umuyisilamu.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11440.mp3',
                'answer' => '<p> Igisubizo: 1- Igihe ndi kwambara mpera iburyo kandi nkanabishimira Allah.<br /> 2- Ntabwo nambara imyambaro miremire irenze utubombankore.<br /> 3- Abana b\'abahungu ntibambara imyambaro y\'abakobwa, nta n\'ubwo ab\'abakobwa bambara iy\'abahungu.<br /> 4- Kutisanisha mu myambarire n\'abahakanyi ndetse n\'inkozi z\'ibibi.<br /> 5-<span class="c6"> Kuvuga Bismillah:</span> Ku izina rya Allah igihe ndi kwiyambura.<br /> 6- Iyo nambara inkweto mpera ku kirenge cy\'iburyo, naba ndi kwiyambura nkahera ku cy\'ibumoso. </p>',
            ],
            13 => [
                'question' => 'Ikibazo cya cumi na kane: Vuga imyifatire ku bijyanye no kurira ikigenderwaho.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11540.mp3',
                'answer' => '<p> Igisubizo: 1-<span class="c6"> Ndavuga nti:</span> "Bismillah: Alhamdulillah: Ku izina rya Allah, Ikuzo n\'ishimwe ni ibya Allah",<span class="c6"> "SUB\'HANA LADHI SAKHARA LANA HADHA WA MA KUNA LAHU MUQ\'RININA:</span> Ubutagatifu ni ubwa Allah, We watworohereje ibi; kuko tutari kubyishoboza <span class="c2">(13)</span>,<span class="c6"> WA INA ILA RABINA LAMUNQALIBUNA:</span> Kandi kwa Nyagasani wacu ni ho tuzasubira. <span class="c2">(14)</span>” <span class="c5">[Surat Zukh\'ruf: 13-14]</span>.<br /> 2- Iyo ntambutse ku muyisilamu, ndamusuhuza mu ndamutso y\'amahoro. </p>',
            ],
            14 => [
                'question' => 'Ikibazo cya cumi na gatanu: Vuga imyifatire ikwiye kuranga umuyisilamu igihe ari mu nzira.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11590.mp3',
                'answer' => '<p> Igisubizo: 1- Nshyira mu rugero, nkaca bugufi mu ngendo yanjye nkanagendera iburyo bw\'inzira.<br /> 2- Nsuhuza uwo mpuye nawe wese.<br /> 3- Nubika indoro yanjye kandi singire n\'umwe mbangamira.<br /> 4- Mbwiriza ibyiza nkabuza ibibi.<br /> 5- Nkura ikibangamira abantu mu nzira. </p>',
            ],
            15 => [
                'question' => 'Ikibazo cya cumi na gatandatu: Ni iyihe imyifatire ikwiye kuranga umuyisilamu igihe yinjira n\'igihe asohoka mu nzu?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11670.mp3',
                'answer' => '<p> Igisubizo: 1-<span class="c6"> Nsohoka mbanje ukuguru kw\'imoso maze nkavuga nti:</span> BISMILLAH, TAWAKALTU ALA LLAH, WALA HAWLA WALA QUWATA ILA BILLAH, ALLAHUMA INI AUDHU BIKA AN ADWILA, AW UDWALA. AW AZILA AW UZALA, AW ADHW\'LIMA AW UDHW\'LAMA,<span class="c6"> AW ADJ\'HALA AW YUDJ\'HALA ALAYA:</span> Ku izina rya Allah, niringiye Allah Nyagasani. Mana yanjye nkwikinzeho ngo undinde ko nayoba cyangwa nkayobywa, cyangwa nkaba nacikwa <span class="c2">(mu mvugo no mu bikorwa)</span> cyangwa nkaba nabikorerwa, cyangwa nkaba nahuguza cyangwa nkaba nahuguzwa, cyangwa nkaba nakwirengagiza cyangwa nakwirengagizwa." 2-<span class="c6"> Ninjira mu rugo n\'ukuguri kw\'indyo nkavuga nti:</span> "BISMILLAH WALADJ\'NA, WA BISMILLAH KHARADJ\'NA,<span class="c6"> WA ALA RABINA TAWAKAL\'NA:</span> Ku izina rya Allah turinjiye, no ku izina rya Allah twasohotse, kandi kwa Nyagasani wacu niho twiringiye."<br /> 3- Mpera ku koza mu kanwa <span class="c2">(Siwak)</span>, hanyuma nkasuhuza ab\'iwanjye mu rugo. </p>',
            ],
            16 => [
                'question' => 'Ikibazo cya cumi na karindwi: Vuga imyifatire yo kujya mu bwiherero.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11730.mp3',
                'answer' => '<p> Igisubizo: 1- Nsohoka mbanje ukuguru kw\'imoso.<br /> 2-<span class="c6"> Mbere yo kwinjira nkavuga nti:</span> "BISMILLAHI,<span class="c6"> ALLAHUMA INI AUDHU BIKA MINAL KHUBUTHI WAL KHABAITH:</span> Ku izina rya Allah, Nyagasani nkwikinzeho ngo undinde amashitani y\'amagano n\'amashitani y\'amagore."<br /> 3- Ntabwo ninjirana icyanditseho izina rya Allah.<br /> 4- Ndihishira igihe ndi mu bwiherero.<br /> 5- Ndaceceka singire icyo mvuga igihe ndi mu bwiherero.<br /> 6- Ntabwo nerekera Qib\'lat cyangwa se ngo mpatere umugongo igihe ndi kwihagarika cyangwa se ndi kwituma.<br /> 7- Nkoresha ukuboko kw\'imoso igihe ndi kwikiza umwanda, sinkoreshe ukuboko kw\'indyo.<br /> 8- Ntabwo nihagarika mu nzira y\'abantu cyangwa se mu bwugamo bwabo.<br /> 9- Nkaraba intoki zanjye iyo maze kwiherera.<br /> 10-<span class="c6"> Nsohoka mbanje ukuguru kw\'imoso maze nkavuga nti:</span> GHUF\'RANAKA: Nyagasani ngusabye imbabazi". </p>',
            ],
            17 => [
                'question' => 'Ikibazo cya cumi n\'umunani: Vuga imyifatire ikwiye kuranga umuyisilamu igihe cyo kwinjira mu musigiti.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11860.mp3',
                'answer' => '<p> Igisubizo: 1- Ninjira mu musigiti mbanje ukuguru kw\'indyo,<span class="c6"> maze nkavuga nti:</span> "BISMILLAH,<span class="c6"> ALLAHUMA IFTAH LI AB\'WABA RAHMATIKA:</span> Ku izina rya Allah, Nyagasani mfungurira imiryango y\'impuhwe zawe."<br /> 2- Ntabwo njya nicara ntabanje gusari raka ebyiri.<br /> 3- Ntabwo ntambuka imbere y\'uri gusali cyangwa se ngo ntange amatangazo y\'ibyabuze mu musigiti, cyangwa se ngo ngure cyangwa ngo ngurishe mu musigiti.<br /> 4-<span class="c6"> Nsohoka mu musigiti mbanje ukuguru kwanjye kw\'imoso nkavuga nti:</span> "ALLAHUMA INI AS\'ALUKA MIN FADW\'LIKA: Nyagasani Mana ndagusaba mu ngabire zawe." </p>',
            ],
            18 => [
                'question' => 'Ikibazo cya cumi n\'icyenda: Vuga imyitwarire ikwiye kuranga umuyisilamu igihe ari gusuhuzanya.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11930.mp3',
                'answer' => '<p> Igisubizo: 1-<span class="c6"> Iyo mpuye n\'umuyisilamu ndabanza nkamusuhuza ngira nti:</span> "ASSALAM ALAYKUM WA RAHMATULLAHI WA BARAKATUH: Amahoro ya Allah n\'imigisha ye bibane namwe."<br /> 2- Mwenyurira unsuhuje.<br /> 3- Muha ikiganza cyanjye cy\'iburyo.<br /> 4- Iyo uwo ari we wese ansuhuje, nanjye musubiza mu ndamutso nziza kurushaho, cyangwa nkamusubiza iyo yansuhuje.<br /> 5- Ntabwo njya mbanza umuhakanyi indamutso y\'amahoro n\'iyo ansuhuje musubiza iyo yansuhujemo.<br /> 6- Umuto asuhuza umukuru, uri ku kigenderwaho agasuhuza ugenda n\'amaguru, n\'ugenda n\'amaguru agasuhuza uwicaye, n\'abacye bagasuhuza abenshi. </p>',
            ],
            19 => [
                'question' => 'Ikibazo cya makumyabiri: Vuga imyifatire ikwiye kuranga umuyisilamu igihe ari gusaba uburenganzira bwo kwinjira ahatari iwe.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12020.mp3',
                'answer' => '<p> Igisubizo: 1- Nsaba uburenganzira mbere yo kugira aho ninjira hose.<br /> 2- Nsaba uburenganzira inshuro eshatu sinzirenze, batanyikiriza nkasubira aho naturutse.<br /> 3- Nkomanga umuryango mu buryo bworoheje, kandi simpagarara ahateganye n\'umuryango, ahubwo mpagarara iburyo bwawo cyangwa se ibumoso bwawo.<br /> 4- Ntabwo ninjira aho Data cyangwa se Mama cyangwa se undi uwo ari we wese bari ntabanje kubisabira uburenganzira, by\'umwihariko igihe bakiryamye mbere y\'uko bucya, cyangwa se baruhutse nyuma y\'amafunguro yo ku manywa, cyangwa se nyuma y\'isengesho rya ninjoro, Al Isha.<br /> 5- Nshobora kwinjira ahantu hadatuwe nko kwa muganga, mu maguriro <span class="c2">(isoko)</span> ntabanje kubisabira uburenganzira. </p>',
            ],
            20 => [
                'question' => 'Ikibazo cya makumyabiri na rimwe: Ni iyihe myifatire ukwiye kuranga umuyisilamu mu korohera inyamaswa?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12100.mp3',
                'answer' => '<p> Igisubizo: 1- Ngaburira inyamaswa ndetse nkayiha n\'icyo kunywa.<br /> 2- Nyigirira impuhwe nkanayorohera, kandi sinyikoreze ibyo idashoboye kwikorera.<br /> 3- Nirinda kuyihana n\'ubugome mu buryo ubwo ari bwo bwose bwo kuyigirira nabi. </p>',
            ],
            21 => [
                'question' => 'Ikibazo cya makumyabiri na kabiri: Ni iyihe myifatire ikwiye kuranga umuyisilamu igihe arimo gukora imyitozo ngorora mubiri?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12160.mp3',
                'answer' => '<p> Igisubizo: 1- Mu gukora imyitozo ngorora mubiri, ngambirira kugira imbaraga zinshoboza kumvira Allah no kumushimisha.<br /> 2- Ntabwo dukina iyo igihe cyo gusali kigeze.<br /> 3- Abahungu muri twe ntibakinana n\'abakobwa.<br /> 4- Nitwararika imyambaro yo gukorana imyitozo ariko ikaba impishira ubwambure bwanjye.<br /> 5- Nirinda gukora imyitozo nziririjwe, nko gukubita mu maso no kugaragaza ubwambure. </p>',
            ],
            22 => [
                'question' => 'Ikibazo cya makumyabiri na gatatu: Ni iyihe myifatire ikwiye kuranga umuyisilamu igihe ari gutebya n\'abandi?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12240.mp3',
                'answer' => '<p> Igisubizo: 1- Kurangwa n\'ukuri mu gutebya kwe no kwirinda kubeshya.<br /> 2- Gutebya bitarimo kunnyega, gusuzugura, gutera ubwoba, gucyerensa ndetse no gutesha agaciro abandi.<br /> 3- Kudatebya kenshi. </p>',
            ],
            23 => [
                'question' => 'Ikibazo cya makumyabiri na kane: Vuga imyifatire ikwiye kuranga umuyisilamu witsamuye.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12300.mp3',
                'answer' => '<p> Igisubizo: 1- Gushyira ikiganza cye, umwenda se, cyangwa se igitambaro ku munwa we igihe yitsamuye.<br /> 2-<span class="c6"> Gushimira Allah igihe witsamuye ugira uti:</span> "Alhamdulillah: Ikuzo n\'ishimwe ni ibya Allah."<br /> 3-<span class="c6"> Umuvandimwe we umuri iruhande iyo amwumvise aramubwira ati:</span> "Yar\'hamkallah: Allah akugirire impuhwe."<br /> 4-<span class="c6"> Iyo abimubwiye nawe aramusubiza ati:</span> "Yahdiikumullahu wa yusw\'lihu balakum: Allah namwe abayobore kandi abatunganyirize imigambi yanyu." </p>',
            ],
            24 => [
                'question' => 'Ikibazo cyamakumyabiri na gatanu: Ni iyihe myifatire ikwiye kuranga umuyisilamu igihe yayuye?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12360.mp3',
                'answer' => '<p> Igisubizo: 1- Kubirwanya uko ashoboye kose.<br /> 2-<span class="c6"> Kutayura mu ijwi ryo hejuru nko kuvuga ngo:</span> Aaaah! Aaaah!<br /> 3- Gushyira ikiganza cye ku munwa we. </p>',
            ],
            25 => [
                'question' => 'Ikibazo cya makumyabiri na gatandatu: Vuga imyifatire iranga umuyisilamu igihe ari gusoma Qur\'an Ntagatifu.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12420.mp3',
                'answer' => '<p> Igisubizo: 1- Akwiye gusoma Qur\'an yabanje gufata isuku <span class="c2">(Udhu)</span>.<br /> 2- Kwicara mu kinyabupfura kivanzemo no kwiyubaha.<br /> 3- Kwikinga kuri Allah ngo akurinde Shitani wavumwe ugitangira gusoma.<br /> 4- Gutekereza ku byo uri gusoma. </p>',
            ],
        ],
        7 => [
            0 => [
                'question' => 'Ikibazo cya mbere: Vuga ibyiza byo kurangwa n\'imico myiza.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12500.mp3',
                'answer' => '<p> Igisubizo: Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> yaravuze iti: "Umwemeramana ufite ukwemera kuzuye kuruta abandi ni ubarusha imico myiza." Yakiriwe na Tirmidhi ndetse na Ahmad. </p>',
            ],
            1 => [
                'question' => 'Ikibazo cya kabiri: Kubera iki twitwararika imico dutwoza n\'ubuyisilamu?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12530.mp3',
                'answer' => '<p> Igisubizo: 1- Kubera ko ari imwe mu mpamvu zituma twishimirwa na Allah Nyirubutagatifu.<br /> 2- Ni n\'imwe mu mpamvu zatuma abantu badukunda.<br /> 3- Ni nacyo kintu kizaremereza iminzani y\'ibikorwa byacu ku munsi w\'imperuka.<br /> 4- Ibihembo n\'ingororano byongerwa kubera imico myiza.<br /> 5- Ni nabyo kimenyetso cyo kuzura k\'ukwemera. </p>',
            ],
            2 => [
                'question' => 'Ikibazo cya gatatu: Ni hehe dukomora imico myiza?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12600.mp3',
                'answer' => '<p> Igisubizo: Muri Qur\'an ntagatifu.<span class="c6"> Allah aragira ati:</span> "Mu by’ukuri iyi Qur’an iyobora <span class="c2">(abantu)</span> mu nzira itunganye kurusha izindi ..." <span class="c5">[Surat Al Is\'ra-<span class="c6">i:</span> 9]</span>. No mu mvugo z\'Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span>: Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> yaravuze iti: "Mu by\'ukuri noherejwe kuzuriza imico itunganye." Yakiriwe na Ahmad. </p>',
            ],
            3 => [
                'question' => 'Ikibazo cya kane: Umuco wo kugira neza ni uwuhe? Garagaza n\'ingero zawo.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12640.mp3',
                'answer' => '<p> Igisubizo: Umuco wo kugira neza <span class="c2">(Ih\'san)</span> ni ukuzirikana Allah ibihe byose, ukora ibyiza, unagirira neza ibiremwa bya Allah.<br /> Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> yaravuze iti: "Mu by\'ukuri Allah yategetse kugira neza <span class="c2">(gutunganya)</span> muri buri kintu." Yakiriwe na Muslim.<span class="c6"><br /> Zimwe mu ngero zo kugira neza:</span><br /> Kugira neza <span class="c2">(utunganya neza)</span> mu kugaragira Allah, ari we ubikorera wenyine.<br /> Kugirira neza ababyeyi bombi mu mvugo no mu bikorwa.<br /> Kugirira neza abo mufitanye isano ndetse n\'aba hafi mu muryango wawe.<br /> Kugirira neza umuturanyi.<br /> Kugirira neza imfubyi n\'abacyene.<br /> Kugirira neza ukugiriye nabi.<br /> Kugira neza mu magambo.<br /> Kugira neza mu mpaka n\'intonganya.<br /> Kugirira neza inyamaswa. </p>',
            ],
            4 => [
                'question' => 'Ikibazo cya gatanu: Ikinyuranyo cyo kugira neza ni ikihe?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12780.mp3',
                'answer' => '<p> Igisubizo: Ikinyuranyo cyo kugira neza ni ukugira nabi.<span class="c6"><br /> Zimwe mu ngero z\'ibyo:</span> Ni nko kureka kwegurira ibikorwa byawe Allah Nyirubutagatifu.<br /> Gusuzugura ababyeyi.<br /> Guca isano ry\'umuryango.<br /> Kubanira nabi umuturanyi.<br /> Kureka kugirira neza abacyene n\'abatishoboye ndetse n\'abandi, n\'izindi mvugo cyangwa se ibikorwa bibi. </p>',
            ],
            5 => [
                'question' => 'Ikibazo cya gatandatu: Ni ayahe moko y\'indangizo, yatangire n\'ingero.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12860.mp3',
                'answer' => '<p> Igisubizo:<br /> 1- Indagizo yo kurinda ibyo umugaragu agomba Allah Nyirubutagatifu.<span class="c6"><br /> Ingero zabyo:</span> Nko kwitwararika kubahiriza amategeko ye: usali, usiba, utanga amaturo, ukora umutambagiro n\'andi mategeko yadutegetse.<br /> 2- Indagizo yo kurinda ibyo umugaragu agomba ibiremwa bya Allah.<br /> Nko kurinda icyubahiro cy\'abantu.<br /> Imitungo yabo.<br /> Amaraso yabo.<br /> Amabanga yabo, n\'ibindi byose bashobora kukuragiza.<span class="c6"><br /> Allah Nyirubutagatifu avuga ibigwi by\'abafite intsinzi ku munsi w\'imperuka yaravuze ati:</span> "Na ba bandi barinda ibyo baragijwe kandi bakubahiriza amasezerano, " <span class="c2">(8)</span> <span class="c5">[Surat Al Mu\'uminuna: 8]</span> </p>',
            ],
            6 => [
                'question' => 'Ikibazo cya karindwi: Ni ikihe kinyuranyo cyo kurinda indagizo?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12980.mp3',
                'answer' => '<p> Igisubizo: Ni ubuhemu, ari byo bisobanuye kureka ibyo umugaragu agomba Allah Nyagasani we n\'ibyo agomba abantu bagenzi be.<br /> Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> yaravuze iti: "Ibimenyetso biranga indyarya ni bitatu: yanavuzemo ko iyo yizewe ahemuka akica isezerano." Hadithi yemeranyijweho na Bukhari na Muslim. </p>',
            ],
            7 => [
                'question' => 'Ikibazo cya munani: Ni uwuhe muco wo kuvuga ukuri?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13020.mp3',
                'answer' => '<p> Igisubizo: Ni ukuvuga uko ibintu bimeze bihuye n\'ibyabayeho cyangwa se biriho.<span class="c6"><br /> Zimwe mu ngero zabyo:</span><br /> Kuba umunyakuri mu biganiro ugirana n\'abantu.<br /> Kuba umunyakuri mu kuzuza isezerano.<br /> Kuba umunyakuri mu mvugo no mu bikorwa.<br /> Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> yaravuze iti: "Mu by’ukuri kuvugisha ukuri biyobora nyirabyo bimuganisha ku byiza <span class="c2">(kumvira Imana no gukora ibikorwa byiza)</span>, kandi ibyiza biganisha nyirabyo mu ijuru. Umuntu akomeza kuvuga ukuri kugeza ubwo yandikwa ku Mana ko ari umunyakuri.” Hadith yemeranyijweho na Bukhari na Muslim. </p>',
            ],
            8 => [
                'question' => 'Ikibazo cya cyenda: Ikinyuranyo cyo kuvugisha ukuri ni ikihe?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13100.mp3',
                'answer' => '<p> Ni ukubeshya; bikaba ari ikinyuranyo cyo kuvuga ukuri. Nko kubeshya abantu, kwica amasezerano, no guhamya ibinyoma.<br /> Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> yaravuze iti: "... Kandi ikinyoma kiyobora nyiracyo kimuganisha ku bwigomeke, kandi ubwigomeke buganisha mu muriro. Ndetse umuntu akomeza kubeshya bikagera aho yandikwa ku Mana ko ari umunyabinyoma.” Hadith yemeranyijweho na Bukhari na Muslim. Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> yaravuze iti: "Ibimenyetso biranga indyarya ni bitatu: yanavuzemo ko n\'iyo iganira irabeshya, yanatanga isezerano ntiryubahirize." Hadith yemeranyijweho na Bukhari na Muslim. </p>',
            ],
            9 => [
                'question' => 'Ikibazo cya cumi: Vuga amako yo kwihangana.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13140.mp3',
                'answer' => '<p> Igisubizo: 1- Kwihangana wumvira Allah ibyo yagutegetse gukora.<br /> 2- Kwihangana wumvira Allah ibyo yagutegetse kureka.<br /> 3- Kwihanganira ibikubaho mu byo yakugeneye bikubabaza, ndetse ukanashimira Allah ibihe byose.<span class="c6"><br /> Allah Nyiricyubahiro aragira ati:</span> "...Kandi Allah akunda abihangana. <span class="c2">(146)</span>" <span class="c5">[Surat Al Imran: 146]</span>. Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> nayo yaravuze iti: "Mbega ukuntu gahunda z\'umwemeramana ari nziza! Mu byukuri, ibintu bye byose ni byiza kuri we. Ibi kandi nta wundi ubigira uretse umwemeramana. Iyo hari ikintu cyiza kimubayeho ashimira Allah, bikaba byiza kuri we. Hagira ikintu kibi kimubaho akihangana, nabyo bikaba byiza kuri we. " Yakiriwe na Muslim. </p>',
            ],
            10 => [
                'question' => 'Ikibazo cya cumi na rimwe: Ni ikihe kinyuranyo cyo kwihangana?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13210.mp3',
                'answer' => '<p> Igisubizo: Ni ukutihangana wumvira Allah ukora ibyo yagutegetse, ureka ibyo yakubujije, winubira igeno rye mu mvugo no mu bikorwa.<span class="c6"><br /> Zimwe mu ngero zabyo:</span><br /> 1- Kwifuza urupfu.<br /> 2- Kwikubita <span class="c2">(wananiwe kwakira igeno rya Allah)</span>.<br /> 3- Kwiciraho imyambaro.<br /> 4- Gushwambaguza imisatsi.<br /> 5- Kwisabira gupfa no korama.<br /> Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> yaravuze iti: "Ibihembo bihambaye bigendana n\'ubukana bw\'ibigeragezo, kandi iyo Allah akunze abantu arabagerageza; bityo uzakira igeno azishimirwa, n\'utazaryakira nawe azarakarirwa." Yakiriwe na Tirmidhi na Ibun Madjah. </p>',
            ],
            11 => [
                'question' => 'Ikibazo cya cumi na kabiri: Vuga umuco w\'ubufatanye.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13310.mp3',
                'answer' => '<p> Igisubizo: Ni ugufatanya n\'abandi mu byo bahuriyeho byiza kandi biri mu kuri.<span class="c6"><br /> Zimwe mu ngero zabyo:</span><br /> 1- Gufatanya mu gusubiza iby\'abandi.<br /> 2- Gufatanya mu gukumira umunyamahugu.<br /> 3- Gufatanya mu gucyemura ibibazo by\'abantu n\'abatishoboye.<br /> 4- Gufatanya mu byiza.<br /> 5- Kudafatanya mu bibi, ibyaha ndetse n\'ibikorwa by\'ubugizi bwa nabi.<span class="c6"><br /> Allah Nyiricyubahiro aragira ati:</span> <span class="c2">(...Ndetse muterane inkunga mu byiza no mu gutinya Allah kandi ntimuzaterane inkunga mu byaha n’ubugizi bwa nabi. Munatinye Allah, mu by’ukuri Allah ni Nyiribihano bikaze.)</span> <span class="c5">[Surat Al Maidat:2]</span>. Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> yaravuze iti: "Umwemeramana kuri mugenzi we ni nk\'inyubako imwe, yubakiye ku yindi..." Yemeranyijweho na Bukhari na Muslim. Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> nanone yaravuze iti: "Umuyisilamu ni umuvandimwe wa mugenzi we. Ntagomba kumuhuguza cyangwa ngo amushyikirize umwanzi we. Uwita ku bibazo bya mugenzi we Imana nayo izita ku bibazo bye. N’uzakuriraho ingorane mugenzi we, nawe Imana izamukuriraho ingorane zo ku munsi w’imperuka. N’uzahishira mugenzi we, nawe Imana izamuhishira ku munsi w’imperuka.” Hadith yemeranyijweho na Bukhari na Muslim. </p>',
            ],
            12 => [
                'question' => 'Ikibazo cya cumi na gatatu: Ni ayahe moko yo kugira umuco wo kurangwa n\'isoni?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13420.mp3',
                'answer' => '<p> Igisubizo: 1- Kugirira isoni Allah wirinda kumukosereza.<br /> 2- Kugirira isoni abantu wirinda amagambo mabi asebanya ndetse anubahuka abantu.<br /> Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> yaravuze iti: <span class="c1">“Ukwemera kugizwe n’ibice birenga mirongo irindwi <span class="c2">(cyangwa birenga mirongo itandatu)</span>. Ikiruta ibindi muri byo ni ukuvuga ijambo rigira riti ‘Nta yindi mana ibaho uretse Allah <span class="c2">(La ilaha ila llahu)</span>; naho igito muri byo ni ugukura mu nzira icyabangamira abantu. No Kugira isoni ni kimwe mu bice by’ukwemera.”</span> Yakiriwe na Muslim. </p>',
            ],
            13 => [
                'question' => 'Ikibazo cya cumi na kane: Vuga ingero zo kurangwa n\'umuco wo kugira impuhwe.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13470.mp3',
                'answer' => '<p> Igisubizo: 1- Kugirira impuhwe abakuze ndetse n\'abasheshe akanguhe no kububaha.<br /> 2- Kugirira impuhwe abato n\'abana.<br /> 3- Kugirira impuhwe abacyene, abatishoboye ndetse n\'abababaye.<br /> 4- Kugirira impuhwe inyamaswa uzigaburira wirinda no kuzibuza amahoro.<br /> No muri ibyo ni imvugo y\'Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> igira iti: <span class="c1">“Uzabona abemera bagirirana impuhwe, bakundana, boroherana bameze nk’umubiri; iyo urugingo rumwe rwawo rurwaye, umubiri wose ugira umuriro ukanakubuza ibitotsi.”</span> Hadith yemeranyijweho na Bukhari na Muslim. Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> yaravuze iti: "Abagira impuhwe Allah Nyirimpuhwe nawe azazibagirira; mujye mugirira impuhwe abo ku isi, kugira ngo uri mu ijuru nawe azazibagirire." Yakiriwe na Abu Daud na Tirmidhi. </p>',
            ],
            14 => [
                'question' => 'Ikibazo cya cumi na gatanu: Ni ayahe moko yo kugira umuco w\'urukundo?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13550.mp3',
                'answer' => '<p> Igisubizo: Ni ugukunda Allah Nyirubutagatifu.<span class="c6"><br /> Allah Nyiricyubahiro aragira ati:</span> "...Nyamara abemera bakunda Allah kurushaho..." <span class="c5">[Surat Al Baqarat: 165.]</span><br /> Gukunda Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span>.<span class="c6"><br /> Intumwa yaravuze iti:</span> "Ndahiye ku izina ry\'ufite roho yanjye mu kuboko kwe ko umwe muri mwe ataremera kugeza ubwo azankunda kuruta uko akunda umubyeyi we n\'abana be,..." Yakiriwe na Bukhari.<br /> Gukunda abemeramana no kubifuriza ibyiza nkuko nawe ubyiyifuriza.<br /> Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> yaravuze iti: "Umwe muri mwe ntaremera kugeza ubwo azifuriza umuvandimwe we ibyo yiyifuriza we ubwe. Yakiriwe na Bukhari. </p>',
            ],
            15 => [
                'question' => 'Ikibazo cya cumi na gatandatu: Sobanura kumwenyura icyo ari cyo.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13630.mp3',
                'answer' => '<p> Igisubizo: Ni ugucya mu buranga, ukishimira ndetse ukamwenyurira abantu muhuye unabagaragariza ko ubishimiye.<br /> Ni ikinyuranyo cyo kuzingira abantu umunya no gutuma baguhunga.<br /> No kubera ibyiza byabyo hari imvugo nyinshi z\'Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> zabishishikarije. Hadithi yaturutse kwa Abi Dhari <span class="c2">(Imana imwishimire)</span> yaravuze ati: Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> yarambwiye iti: "Ntuzagire igikorwa cyiza usuzugura kabone n\'iyo cyaba ari uguhura n\'umuvandimwe wawe ukamumwenyurira." Yakiriwe na Muslim. Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> yaravuze iti: "Kumwenyurira umuvandimwe wawe bibarwa nko gutanga ituro." Yakiriwe na Tir\'midhi. </p>',
            ],
            16 => [
                'question' => 'Ikibazo cya cumi na karindwi: Ishyari ni iki?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13690.mp3',
                'answer' => '<p> Igisubizo: Ni ukutifuza ingabire ziri ku wundi utari wowe cyangwa ukifuza ko zirangira.<span class="c6"><br /> Allah Nyirubutagatifu aragira ati:</span> "Ndetse anandinde inabi y’umunyeshyari igihe arigize.<span class="c6">” Surat Al Falaq:</span> 5.<br /> Hadithi yaturutse kwa Anas Ibun Malik <span class="c2">(Imana imwishimire)</span> yavuze ko Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> yavuze iti: "Ntimukangane, ntimukagirirane ishyari, ntimukagirane amakimbirane, ntimugacane umubano. Ahubwo mujye muba abagaragu b’Imana b’abavandimwe.” Yakiriwe na Bukhari na Muslim. </p>',
            ],
            17 => [
                'question' => 'Ikibazo cya cumi n\'umunani: Gucyerensa ni iki?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13740.mp3',
                'answer' => '<p> Igisubizo: Ni ugusuzugura umuvandimwe wawe w\'umuyisilamu ukamutesha agaciro, ariko ibi ntabwo byemewe.<span class="c6"><br /> Allah Nyirubutagatifu mu kubuza ibi yaravuze ati:</span> "Yemwe abemeye! Ntihakagire abantu basuzugura abandi, kuko hari ubwo <span class="c2">(abasuzuguwe)</span> baba ari bo beza kubarusha. Kandi n’abagore ntibagasuzugure abagore bagenzi babo, kuko hari ubwo <span class="c2">(abasuzuguwe)</span> baba ari bo beza kubarusha. Ntimugasebanye kandi ntimugahimbane amazina mabi <span class="c2">(atesha agaciro abandi)</span>. Mbega ukuntu ari amazina mabi <span class="c2">(kuyita bagenzi banyu)</span> nyuma y’uko mubaye abemeramana! Kandi ba bandi baticuza, abo ni bo nkozi z’ibibi." <span class="c5">[Surat Al Hudjurat: 11]</span>. </p>',
            ],
            18 => [
                'question' => 'Ikibazo cya cumi n\'icyenda: Sobanura kwicisha bugufi icyo ari cyo.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13780.mp3',
                'answer' => '<p> Igisubizo: Ni umuntu kutibonamo ko aruta abandi, ntabasuzugure ntiyange no kwemera ukuri.<span class="c6"><br /> Allah Nyiricyubahiro aragira ati:</span> "Kandi abagaragu ba <span class="c2">(Allah)</span> Nyirimpuhwe ni ba bandi bagenda ku isi biyoroheje...” <span class="c5">[Surat Al Fur\'qan: 63.]</span> Bisobanuye ngo bicishije bugufi. Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> yaravuze iti: "Kandi ntawe uzicisha bugufi kubera Allah, usibye ko Allah amwubahisha. Yakiriwe na Muslim. Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> nanone yaravuze iti: <span class="c1">“Imana yampishuriye ko mugomba kwicisha bugufi ku buryo nta wishongora ku wundi, cyangwa ngo yirate ku wundi.”</span> Yakiriwe na Muslim. </p>',
            ],
            19 => [
                'question' => 'Ikibazo cya makumyabiri: Vuga amoko y\'ubwibone buziririjwe.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13840.mp3',
                'answer' => '<p> Igisubizo: 1- Kwibona ku kuri, ukanga ku kumva.<br /> 2- Kwibona ku bantu, ubasuzugura, unabatesha agaciro.<br /> Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> yaravuze iti: “Ntazinjira mu ijuru wawundi ufite mu mutima we akantu n\'ubwo kaba gato cyane k’ubwibone; umuntu umwe aravuga ati "Nonese umuntu aramutse yikundira ko umwambaro we usa neza ndetse n’inkweto ze zikaba nziza?" Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n’imigisha)</span> iramubwira iti: Imana ni nziza kandi ikunda ibyiza. Kwibona ni ukwihunza ukuri no gusuzugura abantu." Yakiriwe na Muslim.<span class="c6"><br /> Kwihunza ukuri:</span> ni ukukwanga.<span class="c6"><br /> Gusuzugura abantu:</span> Ni ukutabaha agaciro.<br /> Imyambaro myiza n\'inkweto nziza ntabwo bibarwa nk\'ubwibone. </p>',
            ],
            20 => [
                'question' => 'Ikibazo cya makumyabiri na rimwe: Vuga amoko y\'uburiganya buziririjwe.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13910.mp3',
                'answer' => '<p> Igisubizo: Uburiganya mu bucuruzi <span class="c2">(kugura no kugurisha)</span> ni uguhisha inenge igicuruzwa gifite.<br /> Naho uburiganya mu kwiga ubumenyi, ni nko gukopera kw\'abanyeshuri mu bizamini.<br /> Naho uburiganya mu mvugo ni nko guhamya ibinyoma no kubeshya.<br /> No kutubahiriza ibyo wasezeranyije ndetse n\'ibyo wemeranyijweho n\'abantu.<br /> Naho ku bijyanjye no kubuza uburiganya, nuko umunsi umwe Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> yanyuze ku kirundo cy’ingano maze yinjizamo ikiganza cyayo intoki zayo ziratoha.<span class="c6"> Intumwa iravuga iti:</span> <span class="c1">“Ibi ni ibiki yewe nyir’izi ngano? Arayibwira ati: Zanyagiwe yewe Ntumwa y’Imana.<span class="c6"> Intumwa iramubwira iti:</span> Kuki utazishyize hejuru kugira ngo abantu bazibone? Uzarimanganya ntari muri twe.”</span> Yakiriwe na Muslim.<span class="c6"><br /> Swub\'ra:</span> ni ikirundo cyangwa umufungo w\'ibyo kurya. </p>',
            ],
            21 => [
                'question' => 'Ikibazo cya makumyabiri na kabiri: Ghibat ni iki?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13990.mp3',
                'answer' => '<p> Igisubizo: Ni ukuvuga umuvandimwe wawe adahari ukamuvuga ibyo adakunda.<span class="c6"><br /> Allah Nyiricyubahiro aragira ati:</span> "...Kandi ntimugasebanye. Ese umwe muri mwe yakwemera kurya inyama y’umuvandimwe we wapfuye? <span class="c2">(Ntawabyemera!)</span> Ngaho nimubireke kandi mugandukire Allah. Mu by’ ukuri, Allah ni Uwakira bihebuje ukwicuza, Nyirimbabazi.12" <span class="c5">[Surat Al Hudjurat: 12]</span> </p>',
            ],
            22 => [
                'question' => 'Ikibazo cya makumyabiri na gatatu: Namiimat ni iki?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14030.mp3',
                'answer' => '<p> Igisubizo: Ni ukubunza amagambo hagati y’abantu ugamije kubateranya.<br /> Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> yaravuze iti: "Ubunza amagambo ntazinjira mu ijuru." Yakiriwe na Muslim. </p>',
            ],
            23 => [
                'question' => 'Ikibazo cya makumyabiri na kane: Ubunebwe ni iki?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14070.mp3',
                'answer' => '<p> Igisubizo: Ni ukuzarira no kutihutira gukora igikorwa cyiza n\'ibyo umuntu ategetswe gukora.<span class="c6"><br /> Urugero rwabyo:</span> Kunebwa mu gukora ibyategetswe.<span class="c6"><br /> Allah Nyirubutagatifu aragira ati:</span> "Mu by’ukuri indyarya zishaka kuryarya Allah, ariko We akaburizamo uburyarya bwazo. N’iyo bahagurutse bagiye gusali, bahagurukana ubunebwe biyereka abantu, kandi ntibibuka Allah uretse gake.142" <span class="c5">[Surat A-Nisa-<span class="c6">i:</span>142]</span><br /> Umwemeramana rero akwiye kureka ubunebwe no kuzarira, no gushishikarira umurimo no gukora, ndetse no kugira umuhate mu bishimisha Allah Nyirubutagatifu muri ubu buzima. </p>',
            ],
            24 => [
                'question' => 'Ikibazo cya makumyabiri na gatanu: Vuga amoko y\'uburakari?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14130.mp3',
                'answer' => '<p> Igisubizo: 1-<span class="c6"> Uburakari bwiza:</span> Ni uburakari n\'umujinya nyirabyo agize kubera Allah, igihe abahakanyi, indyarya ndetse n\'abandi bavogereye amategeko ye.<br /> 2-<span class="c6"> Uburakari bubi:</span> Ni uburakari butuma umuntu avuga cyangwa se agakora ibidakwiye.<span class="c6"><br /> Umuti w\'uburakari bubi:</span><br /> Gutawaza <span class="c2">(Udhu)</span>.<br /> Kiwcara niba wari uhagaze, no kwegama niba wari wicaye.<br /> Kwitwararika impanuro z\'Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> kuri ibi: "Ntukarakare".<br /> Kwifata wirinda uburakari.<br /> Kwiragiza Allah ngo akurinde Shitani w\'ikivume.<br /> Guceceka. </p>',
            ],
            25 => [
                'question' => 'Ikibazo cya makumyabiri na gatandatu: Kuneka ni iki?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14240.mp3',
                'answer' => '<p> Igisubizo: Ni ugucukumbura no gushaka kumenya iby\'abandi badashaka ko bimenyekana.<span class="c6"><br /> Zimwe mu ngero zabyo:</span><br /> - Kureba ibyo abantu babitse mu mazu yabo.<br /> - Kumva ibiganiro by\'abantu batabizi ko uri kubumva.<span class="c6"><br /> Allah Nyiricyubahiro aragira ati:</span> "...Kandi ntimukanekane..." <span class="c5">[Surat Al Hudjurat: 12]</span> </p>',
            ],
            26 => [
                'question' => 'Ikibazo cya makumyabiri na karindwi: Gusesagura ni iki? Ubugugu ni iki? Ubuntu ni iki?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14310.mp3',
                'answer' => '<p> - Gusesagura ni ugutagaguza umutungo bitari mu kuri.<span class="c6"><br /> Ikinyuranyo cyabyo ni:</span> Ukugundira no kwanga kugira icyo utanga.<br /> Igikwiye rero ni ukuba hagati ntusesagure kandi ntunagundire.<span class="c6"><br /> Allah Nyiricyubahiro aragira ati:</span> "Ni na bo batanga <span class="c2">(mu byo batunze)</span> badasesagura, cyangwa ngo bagundire. Ahubwo bajya hagati y’ibyo byombi.<span class="c2">(67)</span>" <span class="c5">[Surat Al Fur\'qan: 67.]</span> </p>',
            ],
            27 => [
                'question' => 'Ikibazo cya makumyabiri n\'umunani: Ubugwari ni iki? N\'ubutwari ni iki?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14370.mp3',
                'answer' => '<p> Igisubizo: Ubugwari ni ugutinya ikidakwiye gutinywa.<span class="c6"><br /> Urugero rwabyo:</span> Nko gutinya kuvuga ukuri no kubuza ikibi.<span class="c6"><br /> Naho ubutwari:</span> Ni ugutinyuka no gushirika ubwoba, nk\'igihe cy\'urugamba ushaka kurengera ubuyisilamu n\'abayisilamu.<br /> Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> mu busabe bwayo yajyaga ivuga iti: "Mana yanjye nkwikinzeho ngo undinde ubugwari..." Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> yaravuze iti: "Umwemeramana w\'umunyembaraga niwe mwiza kandi ukunze na Allah kuruta umwemeramana w\'umunyantege nke; ariko bose ni beza." Yakiriwe na Muslim. </p>',
            ],
            28 => [
                'question' => 'Ikibazo cya makumyabiri n\'icyenda: Vuga zimwe mu mvugo zivugwa n\'ururimi ziziririjwe.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14440.mp3',
                'answer' => '<p> Igisubizo: Nko kuvuma no gutuka mugenzi wawe.<span class="c6"><br /> Urugero rwabyo:</span> Nko kwita mugenzi wawe ko ari inyamaswa, n\'izindi mvugo zimeze nk\'iyi.<br /> Cyangwa se kuvuga amagambo y\'urukozasoni n\'andi magambo mabi.<br /> Ibi byose Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> yarabibujije aho yagize iti: <span class="c1">“Umwemera si usebanya <span class="c2">(utera urwikekwe ku nkomoko y’abandi)</span>, uvumana, ukora ibikorwa by\'urukozasoni ndetse n’umunyakinyabupfura gike.”</span> Yakiriwe na Tirmidhi na Ibun Hiban. </p>',
            ],
            29 => [
                'question' => 'Ikibazo cya mirongo itatu: Vuga impamvu zafasha umuyisilamu kurangwa n\'imico myiza.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14500.mp3',
                'answer' => '<p> Igisubizo: 1- Gusaba Allah ko yamuha kurangwa n\'imico myiza ndetse ko yanabimufashamo.<br /> 2- Kwitwararika wubahiriza amategeko ya Allah, ukazirikana ko akuzi, akumva ndetse akubona.<br /> 3- Kuzirikana ingororano zo kurangwa n\'imico myiza kandi ko ari impamvu yo kuzajya mu ijuru.<br /> 4- Kuzirikana iherezo ribi ry\'abarangwa n\'imico mibi kandi ko ari n\'impamvu yo kujya mu muriro.<br /> 5- Kurangwa n\'imico myiza ni impamvu yo gukundwa na Allah ndetse no gukundwa n\'ibiremwa, kandi kurangwa n\'imico mibi bitera kwangwa na Allah ndetse no kwangwa n\'ibiremwa.<br /> 6- Kwiga imibereho y\'Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span>no kuyikurikira.<br /> 7- Kugendana n\'abeza, no kwirinda kugendana n\'ababi. </p>',
            ],
        ],
        8 => [
            0 => [
                'question' => 'Ikibazo cya mbere: Ni ibihe byiza byo gusingiza Allah?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14630.mp3',
                'answer' => '<p> Igisubizo: Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> yaravuze iti: <span class="c1">“Urugero rw\'usingiza Imana n\'utayisingiza, ni nk\'urugero rw\'umuzima n’umupfu.”</span> Yakiriwe na Bukhari.<br /> Ibi ni ukubera ko agaciro k\'umuntu gashingira ku buryo asingiza Allah Nyirubutagatifu. </p>',
            ],
            1 => [
                'question' => 'Ikibazo cya kabiri: Vuga zimwe mu nyugu zo gusingiza Allah.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14670.mp3',
                'answer' => '<p> Igisubizo: 1- Bishimisha Allah.<br /> 2- Byirukana Shitani.<br /> 3- Birinda umuyisilamu ibibi.<br /> 4- Bituma abona ingororano n\'ibihembo. </p>',
            ],
            2 => [
                'question' => 'Ikibazo cya gatatu: Ni ayahe magambo meza kuruta ayandi yo gusingiza Allah?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14730.mp3',
                'answer' => '<p> Igisubizo: Ni LA ILAHA ILALLAH: Nta yindi mana ikwiye gusengwa by\'ukuri uretse Allah. Yakiriwe na Tirmidhi na Ibun Madjah. </p>',
            ],
            3 => [
                'question' => 'Ikibazo cya kane: Igihe ubyutse uvuga ubuhe busabe?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14760.mp3',
                'answer' => '<p> "ALHAMDULILLAH LADHI AH\'YANA BA\'ADA MA AMATANA WA ILAY\'HI NUSHUR: Nihashimwe Allah we udusubije ubuzima nyuma y\'uko twari mu marenga y\'urupfu kandi iwe niho tuzasubira." Hadith yemeranyijweho na Bukhari na Muslim. </p>',
            ],
            4 => [
                'question' => 'Ikibazo cya gatanu: Ni ubuhe busabe uvuga iyo ugiye kwambara umwambaro wawe?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14790.mp3',
                'answer' => '<p> Igisubizo: "ALHAMDULILLAHI LADHI KASANI HADHA THAWUBA,<span class="c6"> WA RAZAQANIHI MIN GHAYRI HAWLI MINI WALA QUWAT:</span> Nihashimwe Allah we unshoboje kwambara uyu mwambaro akaba yawumpaye nk\'ingabire ye nta bubasha ndetse n\'ubushobozi mfite." Yakiriwe na Abu Dawudi na Tirmidhi ndetse n\'abandi. </p>',
            ],
            5 => [
                'question' => 'Ikibazo cya gatandatu: Ni ubuhe busabe uvuga igihe uri kwiyambura imyambaro?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14820.mp3',
                'answer' => '<p> Igisubizo: "BISMILLAH: Ku izina rya Allah". Yakiriwe na Tir\'midhi. </p>',
            ],
            6 => [
                'question' => 'Ikibazo cya karindwi: Ni ubuhe busabe uvuga igihe ugiye kwambara umwambaro mushya?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14850.mp3',
                'answer' => '<p> "ALLAHUMA LAKAL HAMDU AN’TA KASAWUTANIIHI, AS’ALUKA KHAYRAHU WAKHAYRA MA SWUNIA LAHU,<span class="c6"> WA AUDHUBIKA MIN SHARIHI WA SHARI MA SWUNIA LAHU:</span> Nyagasani Mana ishimwe ni iryawe wowe uwunyambitse, ndagusaba ibyiza byawo n’ibyiza wakorewe, unandinde ibibi byawo n’ibibi wakorewe.” Yakiriwe na Abu Daud na Tirmidhi. </p>',
            ],
            7 => [
                'question' => 'Ikibazo cya munani: Ni ubuhe busabe usabira uwambaye umwenda mushya?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14880.mp3',
                'answer' => '<p> Igihe ubonye uwambaye umwambaro mushya,<span class="c6"> umusabira ubusabe bugira buti:</span> "TUB\'LII WA YUKH\'LIFULLAHA TA\'ALA: Uzawusane ndetse Allah azakuguraniremo umwiza." Yakiriwe na Abu Dawudi. </p>',
            ],
            8 => [
                'question' => 'Ikibazo cya cyenda: Vuga ubusabe buvugwa igihe winjiye mu bwiherero.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14910.mp3',
                'answer' => '<p> "ALLAHUMA INI AUDHU BIKA MINAL KHUBUTHI WAL KHABAITH.<span class="c6">" Bisobanuye ngo:</span> "Mana Nyagasi, nkwikinzeho ngo undinde amashitani y\'amagabo n\'amashitani y\'amagore." Hadith yemeranyijweho na Bukhari na Muslim. </p>',
            ],
            9 => [
                'question' => 'Ikibazo cya cumi: Ni ubuhe busabe uvuga igihe usohotse mu bwiherero?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14940.mp3',
                'answer' => '<p> Igisubizo: "GHUF\'RANAKA: Nyagasani, imbabazi zawe!" Yakiriwe na Abu Dawud na Tirmidhi. </p>',
            ],
            10 => [
                'question' => 'Ikibazo cya cumi na rimwe: Ni ubuhe busabe uvuga mbere yo gutawaza (Udhu)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14970.mp3',
                'answer' => '<p> Igisubizo: "BISMILLAH: Ku izina rya Allah". Yakiriwe na Abu Dawud n\'abandi. </p>',
            ],
            11 => [
                'question' => 'Ikibazo cya cumi na kabiri: Ni ubuhe busabe uvuga nyuma yo gutawaza?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15000.mp3',
                'answer' => '<p> "ASH\'HADU AN LA ILAHA ILA LLAH WAH\'DAHU LA SHARIKA LAHU,<span class="c6"> WA ASH\'HADU ANA MUHAMADAN AB\'DUHU WA RASULUHU:</span> Ndahamya ko nta yindi Mana ikwiye gusengwa by\'ukuri uretse Imana imwe rukumbi Allah, yo idafite uwo babangikanye, nkanahamya ko Muhamadi ari umugaragu wayo akaba n\'intumwa yayo." Yakiriwe na Muslim. </p>',
            ],
            12 => [
                'question' => 'Ikibazo cya cumi na gatatu: Ni ubuhe busabe uvuga igihe uvuye mu rugo?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15020.mp3',
                'answer' => '<p> Igisubizo: "BISMILLAHI TAWAKALTU ALA LLAHI WALA HAWLA WALA QUWATA ILA BILAH: Ku izina rya Allah, niringiye Allah kandi nta bushobozi cyangwa se imbaraga uretse gushobozwa na Allah." Yakiriwe na Abu Dawud na Tirmidhi. </p>',
            ],
            13 => [
                'question' => 'Ikibazo cya cumi na kane: Ni ubuhe busabe uvuga igihe winjiye mu rugo?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15050.mp3',
                'answer' => '<p> "BISMILLAHI WALADJ\'NA WA BISMILLAHI KHARADJ\'NA,<span class="c6"> WALALLAHI RABUNA TAWAKAL\'NA:</span> Ku izina rya Allah turagarutse, no ku izina rya Allah twari twasohotse, kandi Allah Nyagasani ni we twiringiye." Yakiriwe na Abu Dawudi. </p>',
            ],
            14 => [
                'question' => 'Ikibazo cya cumi na gatanu: Ni ubuhe busabe uvuga igihe winjiye mu musigiti?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15080.mp3',
                'answer' => '<p> Igisubizo:"ALLAHUMA F\'TAH LI AB\'WABA RAH\'MATIKA: Mana Nyagasani nyugururira imiryango y\'impuhwe zawe." Yakiriwe na Muslim. </p>',
            ],
            15 => [
                'question' => 'Ikibazo cya cumi na gatandatu: Vuga ubusabe uvuga igihe usohotse mu musigiti.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15110.mp3',
                'answer' => '<p> Igisubizo: "ALLAHUMA INI AS\'ALUKA MIN FADHW\'LIKA: Mana Nyagasani ndagusaba ingabire zawe." </p>',
            ],
            16 => [
                'question' => 'Ikibazo cya cumi na karindwi: Ni ubuhe busabe usaba igihe wumvise umuhamagaro w\'Iswala?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15140.mp3',
                'answer' => '<p> Igisubizo: Nsubiramo amagambo umuhamagazi yavuze usibye: "HAYA ALA SWALATI: Mwitabire Iswala",<span class="c6"> "HAYA ALAL FALAH:</span> Mwitabire umunezero",<span class="c6"> niho mvuga nti:</span> "LA HAWULA WALA QUWATA ILA BILLAH: Nta bubasha nta n\'ubushobozi usibye ko ari ugushobozwa na Allah." Hadith yemeranyijweho na Bukhari na Muslim. </p>',
            ],
            17 => [
                'question' => 'Ikibazo cya cumi n\'umunani: Ni ubuhe busabe uvuga nyuma y\'umuhamagaro w\'Iswala?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15170.mp3',
                'answer' => '<p> Igisubizo: Ni ugusabira imigisha Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span>. Yakiriwe na Muslim. ALLAHUMA RABA HADHIHI DAAWATI TAMAT, WASWALATUL QAIMAT, ATI MUHAMADA AL WASILATA WAL FADHWILATA WABAATH’HU MAQAMAN MAHMUDAN ALADHI WAADITAHU) <span class="c1">“Mana Nyagasani w’uyu muhamagaro utunganye, n’isengesho rigiye gukorwa, ha Muhamadi urwego rwo hejuru rushoboka, n’ibyiza, unamuzamure mu rwego rwubahitse wamusezeranyije”</span> Yakiriwe na Bukhari.<br /> Hanyuma hagati y\'umuhamagaro mukuru <span class="c2">(Adhana)</span> n\'umuto <span class="c2">(Iqamat)</span>, muri icyo gihe ubusabe ntibusubizwa inyuma. </p>',
            ],
            18 => [
                'question' => 'Ikibazo cya cumi n\'icyenda: Ni ubuhe busabe uvuga buri uko bucyeye na buri uko bwije?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15220.mp3',
                'answer' => '<p> Igisubizo: Nsoma Ayatul Kur\'siy. "ALLAHU LA ILAHA ILA HUWAL HAYUL QAYUM, LA TA\'AKHUDHUHU SINATUN WALA NAWM, LAHU MA FI SAMAWATI WAMA FIL AR\'DHWI, MAN DHA LADHI YASH\'FA\'U IN\'DAHU ILA BI IDHINIHI, YA\'ALAMU MA BAYNA AYDIHIM WAMA KHAL\'FAHUM, WALA YUHITWUNA BISHAY\'IN MIN IL\'MIHI ILA BIMA SHA\'A, WASI\'A KUR\'SIYUHU SAMAWATI WAL AR\'DHWA,<span class="c6"> WALA YA\'UDUHU HIF\'DHWUHUMA WA HUWAL ALIYUL ADHWIIM:</span> Allah <span class="c2">(ni we Mana y’ukuri)</span> nta yindi mana ikwiye gusengwa by’ukuri uretse We, Uhoraho <span class="c2">(Nyirubuzima bwuzuye buzira inenge)</span>, Uwigize, akanabeshaho ibiriho byose. Ntafatwa no guhunyiza habe n’ibitotsi. Ibiri mu birere n’ibiri mu isi ni ibye. Ni inde wagira uwo avuganira iwe uretse ku burenganzira bwe? Azi ibyababayeho <span class="c2">(ku isi)</span> n’ibizababaho <span class="c2">(ku mperuka)</span>. Kandi nta n’icyo bamenya mu bumenyi bwe uretse icyo ashaka. Kursiyu ye ikwiriye ibirere n’isi, kandi ntananizwa no kubirinda <span class="c2">(ibirere n’isi)</span>. Ni na We Uwikirenga, Uhambaye.<span class="c6">" Al Baqarat:</span> 255.<span class="c6"> Warangiza ugasoma aya magambo:</span> BISMILLAHI RAH\'MAN RAHIIM: Ku izina rya Allah, Nyirimpuhwe, Nyirimbabazi.<span class="c6"> QUL HUWALLAHU AHAD:</span> Vuga <span class="c2">(yewe Muhamadi)</span> uti <span class="c1">“We ni Allah, umwe Rukumbi,”</span> ALLAHU SWAMAD: Allah, Uwishingikirizwa,<span class="c6"> LAM YALID WA LAM YULAD:</span> Ntiyabyaye kandi ntiyanabyawe,<span class="c6"> WA LAM YAKUN LAHU KUF\'WAN AHAD:</span> Ndetse nta na kimwe ahwanye na cyo. Inshuro eshatu. Ku izina rya Allah, Nyirimpuhwe, Nyirimbabazi.<span class="c6"> QUL AUDHU BIRABIL FALAQ:</span> Vuga uti nikinze kuri nyagasani w\'igitondo. <span class="c2">(1)</span> MIN SHARI MA KHALAQA: Andinde ikibi cy\'ibyo yaremye.<span class="c2">(2)</span> WA MIN SHARI GHASIQIN IDHA WAQABA: Anandinde ikibi cy\'ijoro ryijimye iyo rigwa. <span class="c2">(3)</span> WA MIN SHARI NAFATHATI FIL UQADI: Anandinde ikibi cy’abarozikazi bahuha ku mapfundo. <span class="c2">(4)</span> WA MIN SHARI HASIDINI IDHA HASADA: Ndetse anandinde inabi y’umunyeshyari igihe arigize. <span class="c2">(5)</span> Inshuro eshatu. Ku izina rya Allah, Nyirimpuhwe, Nyirimbabazi.<span class="c6"> QUL AWUDHU BIRABI NASI:</span> Vuga <span class="c2">(yewe Muhamadi)</span> uti <span class="c1">“Niragije <span class="c2">(Allah)</span>, Nyagasani w’abantu,”</span> MALIKI NASI: Umwami w’abantu,<span class="c6"> ILAHI NASI:</span> Imana y’abantu,<span class="c6"> MIN SHARIL WAS\'WASIL KHANAS:</span> Ngo andinde ububi bwa <span class="c2">(shitani)</span> yoshya gukora ibibi, nyuma ikabireka <span class="c2">(igihe umuntu yibutse Allah)</span>,<span class="c6">” ALADHI YUWAS\'WISU FI SWUDURINASI:</span> Yoshya imitima y’abantu gukora ibibi; MINAL DJINATI WA NASI: <span class="c1">“Yaba <span class="c2">(shitani)</span> yo mu majini cyangwa mu bantu.”</span> Inshuro eshatu. "ALLAHUMA ANTA RABI LA ILAHA ILA ANTA KHALAQ\'TANI WA ANA AB\'DUKA, WA ANA ALA AH\'DIKA WA WA\'DIKA MASTATWA\'ATU, AUDHU BIKA MIN SHARI MA SWANA\'ATU, ABUU- U LAKA BINI\'IMATIKA ALAYA WA ABUU- U BIDHANBII FAGH\'FIR LII,<span class="c6"> FA INAHU LA YAGH\'FIRU DHUNUBA ILA ANTA:</span> "Mana ni Wowe Nyagasani wanjye. Nta yindi mana ibaho itari wowe. Warandemye nanjye ndi umugaragu wawe. Nubahiriza isezerano ryawe n’ibyo nakwemereye uko nshoboye kose. Nkwikinzeho ngo undinde ibibi nakoze. Nemera inema zawe kuri njye, ndetse nemera ibyaha byanjye; none mbabarira kuko nta wundi ubabarira ibyaha utari Wowe". "Uyavuze ku manywa ayafitiye icyizere, apfuye kuri uwo munsi mbere y’uko bugoroba, aba ari umwe mu bantu bo mu ijuru. N’uyavuze mu ijoro ayafitiye icyizere, maze agapfa butaracya, aba ari umwe mu bantu bo mu ijuru.” Yakiriwe na Bukhari. </p>',
            ],
            19 => [
                'question' => 'Ikibazo cya makumyabiri: Ni ubuhe busabe uvuga igihe ugiye kuryama?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15290.mp3',
                'answer' => '<p> “BIS’MILLAHI ALLAHUMA AMUTU WA AH’YA: Ku izina rya Allah, Mana Nyagasani mvuye mu buzima <span class="c2">(ndasinziriye)</span> kandi ndongera ngaruke mu buzima." Hadith yemeranyijweho na Bukhari na Muslim. </p>',
            ],
            20 => [
                'question' => 'Igisubizo cya makumyabiri na kimwe: Ni ubuhe busabe uvuga mbere yo kurya?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15320.mp3',
                'answer' => '<p> Igisubizo: "BISMILLAH: Ku izina rya Allah.<span class="c6">"<br /> Iyo wibagiwe mu ntangiriro uravuga uti:</span><br /> "BISMILLAH FI AWALIHI WA AKHIRIHI: Ku izina rya Allah mu ntangiriro no mu mpera." Yakiriwe na Abu Daud na Tirmidhi. </p>',
            ],
            21 => [
                'question' => 'Ikibazo cya makumyabiri na kabiri: Ni ubuhe busabe uvuga igihe umaze kurya?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15370.mp3',
                'answer' => '<p> Igisubizo: "ALHAMDULILLAHI LADHI ATW\'AMANI HADHA WA RAZAQANIHI MIN GHAYRI HAWLI MINII WA LA QUWAT: Ikuzo n\'ishimwe ni ibya Allah we wampaye aya mafunguro, akayanshoboza nta bubasha cyangwa se ubushobozi mfite. Yakiriwe na Abu Dawud na Ibun Madjah ndetse n\'abandi. </p>',
            ],
            22 => [
                'question' => 'Ikibazo cya makumyabiri na gatatu: Ni ubuhe busabe umushyitsi asabira uwamuzimaniye?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15400.mp3',
                'answer' => '<p> "ALLAHUMA BARIK LAHUM FIMA RAZAQ\'TAHUM, WAGH\'FIR LAHUM,<span class="c6"> WAR\'HAM\'HUM:</span> Mana Nyagasani bahe umugisha mu byo wabafunguriye, unabababarire kandi ubagirire impuhwe." Yakiriwe na Muslim. </p>',
            ],
            23 => [
                'question' => 'Ikibazo cya makumyabiri na kane: Iyo umuntu yitsamuye avuga ubuhe busabe?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15430.mp3',
                'answer' => '<p> Igisubizo: "AL HAMDULILLAH: Ikuzo n\'ishimwe ni ibya Allah.<span class="c6">"<br /> Umuvandimwe we cyangwa se umuvandimwe we umuri iruhande iyo amwumvise aramubwira ati:</span> "YAR\'HAM\'KALLAH: Allah akugirire impuhwe.<span class="c6">"<br /> Nawe akamusubiza ati:</span> "YAHDIIKUMULLAH WA YUSW\'LIH BALAKUM: Allah namwe abayobore kandi abatunganyirize ibyanyu." Yakiriwe na Bukhari. </p>',
            ],
            24 => [
                'question' => 'Ikibazo cya makumyabiri na gatanu: Ni ubuhe busabe uvuga igihe uhagurutse mu cyicaro ugisoje (DUA-U KAFARATUL MADJ\'LIS)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15480.mp3',
                'answer' => '<p> "SUBUHANAKA ALLAHUMA WABIHAMDIKA, ASHAHADU AN LA ILAHA ILA AN’TA,<span class="c6"> ASTAGH’FIRUKA WA ATUBU ILAYKA:</span> Ubutagatifu Ni ubwawe Mana n’ishimwe ni iryawe, Ndahamya ko nta yindi mana ikwiye gusengwa uretse Wowe, nkwicujijeho ndetse nsabye imbabazi zawe. Yakiriwe na Abu Dawudi na Tirmidhi ndetse n\'abandi. </p>',
            ],
            25 => [
                'question' => 'Ikibazo cya makumyabiri na gatandatu: Ni ubuhe busabe uvuga igihe wuriye ikigenderwaho?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15510.mp3',
                'answer' => '<p> Igisubizo: BISMILLAH, WAL HAMDULILLAH <span class="c4">{SUB\'HANA LADHI SAKHARA LANA HADHA WAMA KUNA LAHU MUQ\'RINIINA WA INA ILA RABINA LAMUNQALIBUNA}</span>; AL HAMDULILLAH, ALHAMDULILLAH, AL HAMDULILLAH, ALLAH AKBAR, ALLAH AKBAR, ALLAH AKBAR. SUB\'HANAKA LLAHUMA INI DHWALAM\'TU NAF\'SII FAGH\'FIR LII,<span class="c6"> FA INAHU LA YAGH\'FIRU DHUNUBA ILA AN\'TA:</span> Ku izina rya Allah, ikuzo n\'ishimwe ni ibya Allah {Ubutagatifu ni ubwa Allah, We watworohereje ibi; kandi ntitwari kubyishoborera. Kandi kwa Nyagasani wacu ni ho tuzasubira.” Ikuzo n\'ishimwe ni ibya Allah, ikuzo n\'ishimwe ni ibya Allah. ikuzo n\'ishimwe ni ibya Allah. Allah asumba byose, Allah asumba byose, Allah asumba byose. Ubutagatifu ni ubwawe Nyagasani narihemukiye, bityo mbabarira, kubera ko nta wundi ubabarira ibyaha utari wowe. Yakiriwe na Abu Dawud na Tirmidhi. </p>',
            ],
            26 => [
                'question' => 'Ikibazo cya makumyabiri na karindwi: Vuga ubusabe uvuga ugiye mu rugendo.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15540.mp3',
                'answer' => '<p> Igisubizo: "ALLAH AKBAR, ALLAH AKBAR, ALLAH AKBAR, SUB\'HANA LADHI SAKHARA LANA HADHA WAMA KUNA LAHU MUQ\'RINIINA WA INA ILA RABINA LAMUNQALIBUNA. ALLAHUMA INA NAS\'ALUKA FI SAFARINA HADHA AL BIRA WA TAQ\'WA, WA MINAL AMALI MA TAR\'DHWA. ALLAHUMA HAWIN ALAYNA SAFARANA HADHA, WATW\'WI ANA BU\'UDAHU. ALLAHUMA ANTA SWAHIBU FI SAFARI WAL KHALIFATU FIL AH\'LI. ALLAHUMA INI AUDHUBIKA MIN WA\'ATHA-I SAFARI, WA KA-ABATIL MAN\'DHWARI, WA SU-<span class="c6">IL MUN\'QABALI FIL MALI WAL AH\'LI:</span> Allah asumba byose, Allah asumba byose, Allah asumba byose. Ubutagatifu ni ubwa Allah, We watworohereje ibi tutari kubyishoborera, kandi kwa Nyagasani wacu ni ho tuzasubira. Mana Nyagasani turagusaba muri uru rugendo rwacu ibyiza no kugutinya, no gukora ibikorwa wishimira. Mana Nyagasani tworohereze uru rugendo, unaruduhinire rube rugufi. Mana Nyagasani ni wowe Muherekeza mu rugendo, n\'umusigire ku banjye nsinze mu rugo. Mana Nyagasani nkwikinzeho ngo undinde imvune z\'urugendo n\'indoro mbi, ndetse n\'iherezo ribi mu mutungo no mu muryango."<br /> N\'iyo ahindukiye avuye mu rugendo avuga ya magambo,<span class="c6"> ukanongeraho agira ati:</span><br /> "AYIBUNA, TAIBUNA, ABIDUNA,<span class="c6"> LIRABINA HAMIDUNA:</span> Turagarutse, twicuza, turi abagaragu, kandi dusingiza Nyagasani wacu." Yakiriwe na Muslim. </p>',
            ],
            27 => [
                'question' => 'Ikibazo cya makumyabiri n\'umunani: Ni ubuhe busabe bw\'umugenzi uri ku rugendo asabira utari ku rugendo?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15590.mp3',
                'answer' => '<p> "ASTAW\'DIUKUMULLAH ALADHI LA TADWI\'U WADA\'IUHU: Mbasezeyeho mbaragiza Allah we utajya atererana abe n\'ibye." Yakiriwe na Tirmidhi na Ibun Madjah. </p>',
            ],
            28 => [
                'question' => 'Ikibazo cya makumyabiri n\'icyenda: Ni ubuhe busabe utari ku rugendo asabira uri ku rugendo?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15620.mp3',
                'answer' => '<p> "ASTAW\'DIULLAH DINAKA, WA AMANATAKA,<span class="c6"> WA KHAWATIMA AMALIKA:</span> Ngusezeye ngusabira ku Mana ko wakomeza idini ryawe, no gucunga indagizo kwawe, n\'iherezo ry\'ibikorwa byawe." Yakiriwe na Ahmad na Tirmidhi. </p>',
            ],
            29 => [
                'question' => 'Ikibazo cya mirongo itatu: Ni ubuhe busabe uvuga igihe winjiye mu isoko?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15650.mp3',
                'answer' => '<p> Igisubizo: LA ILAHA ILALLAHU WAH\'DAHU LA SHARIKA LAHU, LAHUL MUL\'KU WA LAHUL HAMDU, YUH\'YI WA YUMITU, WA HUWA HAYU LA YAMUTU, BIYAD\'HIL KHAYR,<span class="c6"> WA HUWA ALA KULI SHAY\'IN QADIIR:</span> Nta yindi mana ibaho ikwiye gusengwa mu kuri uretse Allah we wenyine utagira uwo babangikanye, we wihariye ubutware bwose, ni nawe wihariye ishimwe ryuzuye, ni nawe utanga ubuzima n\'urupfu kandi ni we Uhoraho udapfa, ibyiza byose biri mu kuboko kwe kandi afite ubushobozi kuri buri kintu." Yakiriwe na Tirmidhi na Ibun Madjah. </p>',
            ],
            30 => [
                'question' => 'Ikibazo cya mirongo itatu na rimwe: Vuga ubusabe uvuga igihe cy\'uburakari.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15680.mp3',
                'answer' => '<p> <span class="c1">“AUDHU BILAHI MINA SHAY’TWANI RADJIIM, BISMILAHI RAH’MANI RAHIM.”</span> Nikinze ku mana ngo indinde Shitani wavumwe, ku izina ry’Imana Nyirimpuhwe Nyirimbabazi." Byemejwe na Bukhari na Muslim. </p>',
            ],
            31 => [
                'question' => 'Ikibazo cya mirongo itatu na kabiri: Ni ubuhe busabe usabira ukugiriye neza?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15710.mp3',
                'answer' => '<p> Igisubizo: "DJAZAKALLAHU KHAYRAN: Allah aguhe ibyiza." Yakiriwe na Tirmidhi. </p>',
            ],
            32 => [
                'question' => 'Ikibazo cya mirongo itatu na gatatu: Ni ubuhe busabe usaba igihe icyo ugenderaho gitsikiye?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15740.mp3',
                'answer' => '<p> Igisubizo: "BISMILLAH: Ku izina rya Allah." Yakiriwe na Abu Daudi. </p>',
            ],
            33 => [
                'question' => 'Ikibazo cya mirongo itatu na kane: Ni ubuhe busabe uvuga igihe ubonye ibigushimisha?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15770.mp3',
                'answer' => '<p> Igisubizo: "ALHAMDULILLAH LADHI BI NI\'IMATIHI TATIMU SWALIHATI: Ugushimwa n\'ugusingizwa ni ibya Allah we ku bw\'inema ze ibikorwa byiza bigerwaho." Yakiriwe na Al Hakim ndetse n\'abandi. </p>',
            ],
            34 => [
                'question' => 'Ikibazo cya mirongo itatu na gatanu: Ni ubuhe busabe uvuga igihe uhuye n\'ibitagushimishije?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15800.mp3',
                'answer' => '<p> Igisubizo: "AL HAMDULILLAHI ALA KULI HALI: Ugushimwa n\'ugusingizwa ni ibya Allah ibihe byose, mu buryo ubwo ari bwo bwose." Yavuzwe mu gitabo Swahihul Djami\'u. </p>',
            ],
            35 => [
                'question' => 'Ikibazo cya mirongo itatu na gatandatu: Ni ubuhe buryo bwo gusuhuzanya no kwikiriza indamutso?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15830.mp3',
                'answer' => '<p> Igisubizo: Umuyisilamu asuhuzanya agira ati: "ASALAMU ALAYKUM WA RAHMATULLAHI WA BARAKATUH: Amahoro, impuhwe, n\'imigisha bya Allah bibe kuri mwe.<span class="c6">"<br /> Uwo asuhuje nawe akamusubiza ati:</span> WA ALAYKUM SALAMU WA RAHMATULLAHI WA BARAKATUH: Namwe amahoro, impuhwe, n\'imigisha bya Allah bibabeho. Yakiriwe na Tirmidhi na Abu Dawud ndetse n\'abandi. </p>',
            ],
            36 => [
                'question' => 'Ikibazo cya mirongo itatu na karindwi: Ni ubuhe busabe uvuga igihe imvura iguye?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15870.mp3',
                'answer' => '<p> Igisubizo: ALLAHUMA SWAYIBAN NAFIAN: Nyagasani Mana utugushirize imvura ifite umumaro." Yakiriwe na Bukhari. </p>',
            ],
            37 => [
                'question' => 'Ikibazo cya mirongo itatu na karindwi: Ni ubuhe busabe uvuga igihe imvura imaze kugwa?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15900.mp3',
                'answer' => '<p> Igisubizo: MUTWIR\'NA BIFADW\'LILLAH WA RAHMATIHI: Duhawe imvura ku bw\'ingabire za Allah n\'impuhwe ze." Yakiriwe na Bukhari na Muslim. </p>',
            ],
            38 => [
                'question' => 'Ikibazo cya mirongo itatu n\'icyenda: Ni ubuhe busabe uvuga iyo inkubi y\'umuyaga ije?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15930.mp3',
                'answer' => '<p> Igisubizo: "ALLAHUMA INI AS\'ALUKA KHAYRAHA WA AUDHU BIKA MIN SHARIHA: Mana Nyagasani ndagusaba ngo umpe ibyiza biri muri uyu muyaga kandi nkwikinzeho ngo undinde ibibi biwurimo. Yakiriwe na Abu Dawud na Ibun Madjah. </p>',
            ],
            39 => [
                'question' => 'Ikibazo cya mirongo ine: Ni ubuhe busabe uvuga igihe wumvise inkuba?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15960.mp3',
                'answer' => '<p> Igisubizo: SUB\'HANA LADHI YUSABIHU RA\'ADU BIHAMDIHI WAL MALAIKATU MIN KHIFATIHI: Ubutagatifu ni ubwa Allah we inkuba n\'abamalayika bamusingiza kubera kumutinya." Yakiriwe mu gitabo Muwatwa-u cya Imam Malik. </p>',
            ],
            40 => [
                'question' => 'Ikibazo cya mirongo ine na kimwe: Ni ubuhe busabe uvuga iyo ubonye umuntu wageragejwe?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15990.mp3',
                'answer' => '<p> "ALHAMDULILLAH LADHI A\'FANI MIMA BTALAAKA BIHI WA FADWALANI ALA KATHIIRIN MIMAN KHALAQA TAF\'DWILAN: Nihashimwe Allah wandinze ibyo yakugerageresheje akanandutisha byinshi mu byo yaremye." Yakiriwe na Tir\'midhi. </p>',
            ],
            41 => [
                'question' => 'Ikibazo cya mirongo ine na kabiri: Ni ubuhe busabe uvuga igihe utinya kugerwaho n\'ikijisho (giterwa n\'ishyari)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16020.mp3',
                'answer' => '<p> Igisubizo: Ni Hadithi igira iti: "Umwe muri mwe nabona kuri mugenzi we cyangwa kuri we ubwe, cyangwa se mu mutungo we ikimushimishije azamusabire imigisha ituruka kwa Allah, kubera ko ikijisho ari ukuri." Yakiriwe na Tirmidhi na Ibun Madjah. </p>',
            ],
            42 => [
                'question' => 'Ikibazo cya mirongo ine na gatatu: Ni gute usabira Intumwa y\'Imana (Imana iyihe amahoro n\'imigisha)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16050.mp3',
                'answer' => '<p> Igisubizo: <span class="c1">“ALLAHUMA SWALI ALA MUHAMADI WA ALA ALI MUHAMADI KAMA SWALAY’TA ALA IBRAHIM WA ALA ALI IB’RAHIMA WA BARIKI ALA MUHAMADI WA ALA ALI MUHAMADI KAMA BARAKTA ALA IB’RAHIM WA ALA ALI IBRAAHIM, INAKA HAMIDUN MADJIID.”</span> Bisobanuye ngo: "Mana ha amahoro n’imbabazi Muhamad n’umuryango we, nkuko wabihaye Intumwa y’Imana Ibrahim n’umuryango we. Unahe Muhamad imigisha n’umuryango we, nkuko wayihaye Intumwa y’Imana Ibrahim n’umuryango we. Ni wowe Nyirugushimwa Nyirikuzo." Yemeranyijweho na Bukhari na Muslim. </p>',
            ],
        ],
        9 => [
            0 => [
                'question' => 'Ikibazo cya mbere: Ni ubuhe bwoko butanu bw\'amategeko shingiro y\'idini ya Isilamu?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16090.mp3',
                'answer' => '<p> Igisubizo:<br /> 1-<span class="c6"> AL WAJIB:</span> Ni ikintu kiba ari itegeko cyangwa se ari ngombwa ku muyisilamu ko agikora.<br /> 2-<span class="c6"> AL MUSTAHABU:</span> Ni ikintu kiba atari itegeko ariko umuyisilamu aramutse agikoze yagihemberwa, atagikora ntagihanirwe.<br /> 3-<span class="c6"> AL MUHARAM:</span> Ni ikintu kiba kizira, umuyisilamu aziririjwe gukora.<br /> 4-<span class="c6"> AL MAK\'RUH:</span> Ni ikintu kiba atari cyiza ko umuyisilamu agikora, ariko kitari ku rwego rwo kuba kizira, gusa aba akwiye kucyirinda.<br /> 5-<span class="c6"> AL MUBAH:</span> Ni ikintu umuyisilamu aba aziruriwe gukora. </p>',
            ],
            1 => [
                'question' => 'Ikibazo cya kabiri: Sobanura aya mategeko atanu.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16170.mp3',
                'answer' => '<p> Ibisubizo:<br /> 1-<span class="c6"> AL WAJIB:</span> Ni ikintu kiba ari itegeko cyangwa se ari ngombwa ku muyisilamu ko agikora. Nko gusali gatanu ku munsi, gusiba igisibo cya Ramadhan no kumvira ababyeyi bombi.<br /> Igikorwa cy\'itegeko ugikoze arabihemberwa, ukiretse akabihanirwa.<br /> 2-<span class="c6"> AL MUSTAHABU:</span> Ni ikintu kiba atari itegeko ariko umuyisilamu aramutse agikoze yagihemberwa, atagikora ntagihanirwe. Nko gusali iswala z\'imigereka <span class="c2">(Sunan Rawatib)</span>, iswala yo mu ijoro, kugaburira abantu, no gusuhuza abantu. Banabyita Sunat cyangwa se Al Mandub.<br /> Ikintu kiba ari Mustahabu kugikora, ugikoze aragihemberwa, ariko iyo ukiretse ntabwo abihanirwa.<span class="c6"><br /> Icyitonderwa:</span><br /> Ni ngombwa ko umuyisilamu wumvise ko igikorwa runaka ari Sunat cyangwa se Mustahabu, yihutira ku gikora no kugera ikirenge mu cy\'Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span>.<br /> 3-<span class="c6"> AL MUHARAM:</span> Ni ikintu kiba kizira umuyisilamu aziririjwe kugikora. Nko kunywa inzoga, gusuzugura ababyeyi bombi no guca isano ry\'imiryango.<br /> Ikintu kizira <span class="c2">(Haramu)</span>, ukiretse arabihemberwa ariko ugikoze akagihanirwa.<br /> 4-<span class="c6"> AL MAK\'RUH:</span> Ni ikintu kiba atari cyiza ko umuyisilamu agikora, ariko kitari ku rwego rwo kuba kizira, gusa aba akwiye kucyirinda. Nko gutanga cyangwa se kwakiriza ukuboko kw\'imoso, gusali imyambaro wambaye ikubye,...<br /> Ikintu kitari cyiza ku muyisilamu <span class="c2">(Makruh)</span>, iyo ukiretse urabihemberwa, ariko iyo ugikoze ntabwo ubihanirwa.<br /> 5-<span class="c6"> AL MUBAH:</span> Ni ikintu umuyisilamu aba aziruriwe gukora. Nko kurya urubuto rwa pome, kunywa icyayi,... Banabyita kandi DJAIZ cyangwa se HALAL.<br /> Ikintu umuyisilamu aziruriwe <span class="c2">(Mubah)</span>, ugikoze ntabihemberwa, n\'ukiretse ntabihanirwa. </p>',
            ],
            2 => [
                'question' => 'Ikibazo cya gatatu: Ni irihe tegeko rirebana n\'ubucuruzi ndetse n\'indi mikoranire?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16320.mp3',
                'answer' => '<p> Igisubizo: Ubusanzwe ubucuruzi bwose n\'imikoranire yose biremewe, usibye amwe mu moko yabyo Allah Nyirubutagatifu yaziririje.<span class="c6"><br /> Allah Nyiricyubahiro aragira ati:</span> "...Nyamara Allah yaziruye ubucuruzi aziririza Riba <span class="c2">(inyongera)</span>..." <span class="c5">[Surat Al Baqarat: 275]</span> </p>',
            ],
            3 => [
                'question' => 'Ikibazo cya kane: Vuga amwe mu moko y\'imikoranire n\'ubucuruzi biziririjwe.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16360.mp3',
                'answer' => '<p> Ibisubizo:<br /> 1- Kuriganya, hanakubiyebo guhisha inenge igicuruzwa gifite.<br /> Hadithi yaturutse kwa Abi Hurayrat <span class="c2">(Imana imwishimire)</span> yavuze ko Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> umunsi umwe yanyuze ku kirundo cy’ingano maze yinjizamo ikiganza cyayo intoki zayo ziratoha.<span class="c6"> Intumwa iravuga iti:</span> <span class="c1">“Ibi ni ibiki yewe nyir’izi ngano? Arayibwira ati: Zanyagiwe yewe Ntumwa y’Imana.<span class="c6">" Intumwa iramubwira iti:</span> Kuki utazishyize hejuru kugira ngo abantu bazibone? Uzarimanganya ntari muri twe.”</span> Yakiriwe na Muslim.<br /> 2-<span class="c6"> Riba:</span> Nko kuba umuntu yafata kuri mugenzi we ideni ry\'amafaranga igihumbi, akamusaba ko najya kwishyura azamuha ibihumbi bibiri.<br /> Iyi nyongera niyo iziririjwe.<span class="c6"><br /> Allah Nyiricyubahiro aragira ati:</span> "...Nyamara Allah yaziruye ubucuruzi aziririza Riba.<span class="c2">(inyongera)</span>.." <span class="c5">[Surat Al Baqarat: 275.]</span><br /> 3- Ubucuruzi buteye urujijo <span class="c2">(Al Gharar wal Djahalat)</span>: Nko kuba nakugurisha amata akiri mu icebe ry\'itungo , cyangwa se nkakugurisha isamake ntararoba ikiri mu mazi.<span class="c6"><br /> Hadithi iragira iti:</span> "Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> yabujije ubucuruzi bwose burimo urujijo n\'ibidasobanutse." Yakiriwe na Muslim. </p>',
            ],
            4 => [
                'question' => 'Ikibazo cya gatanu: Vuga zimwe mu nema za Allah yaguhundagajeho.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16460.mp3',
                'answer' => '<p> Igisubizo: 1- Inema y\'ubuyisilamu, ukaba utari umwe mu bahakanyi.<br /> 2- Inema yo gukurikiza imigenzo y\'Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span>, ukaba udakurikiza ibihimbano.<br /> 3- Inema y\'ubuzima bwiza no kuba wumva, ubona, ugenda n\'ibindi.<br /> 4- Inema yo kubona ibyo kurya, no kunywa, no kwambara.<br /> N\'izindi nema za Allah zitabarika, tutarondora.<span class="c6"><br /> Allah Nyiricyubahiro aragira ati:</span> "Kandi muramutse mushatse kubarura ingabire za Allah <span class="c2">(yabahaye)</span> ntimwazihetura. Mu by’ukuri Allah ni Ubabarira ibyaha, Nyirimpuhwe." <span class="c5">[A-<span class="c6">Nah\'li:</span> 18]</span>. </p>',
            ],
            5 => [
                'question' => 'Ikibazo cya gatandatu: Ni iki dutegetswe gukora ku bijyanye n\'inema? Ni nagute wazishimira?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16540.mp3',
                'answer' => '<p> Igisubizo: Icyo dutegetswe ni ugushimira Allah kubera zo, tugashimira ku rurimi ndetse no mu bikorwa, ndetse ko ari we wenyine Nyirukugaba ingabire, twongeyeho no kuzikoresha mu bishimisha Allah gusa, bitarimo kumwigomekaho. </p>',
            ],
            6 => [
                'question' => 'Ikibazo cya karindwi: Ni iyihe minsi mikuru abayisilamu bizihiza?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16570.mp3',
                'answer' => '<p> Igisubozo: Ni irayidi yo gusiburuka igisibo cya Ramadhan <span class="c2">(Eidul Fitri)</span>, n\'irayidi y\'igitambo <span class="c2">(Eidul Adw\'ha)</span>.<br /> Nk\'uko byaje muri Hadithi yaturutse kwa Anas <span class="c2">(Imana imwishimire)</span> yaravuze ati: Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> yageze i Madina isanga bafite iminsi ibiri bakinamo,<span class="c6"> nuko irababaza iti:</span> Iyi minsi ibiri ni iy\'iki? Baramusubiza bati: Iyi minsi twajyaga tuyikinamo no mu gihe cy\'ubujiji <span class="c2">(cya mbere y\'ubuyisilamu)</span>! Nuko Intumwa y\'Imana <span class="c2">(Imana iyihe amahoro n\'imigisha)</span> iravuga iti: "Mu by\'ukuri Allah yayibahinduriyemo indi minsi myiza kuyirusha ariyo Eidul Adw\'ha na Eidul Fitri." Yakiriwe na Abu Daud.<br /> Naho indi minsi mikuru itari iyi ni ibihimbano. </p>',
            ],
            7 => [
                'question' => 'Ikibazo cya munani: Ni ukuhe kwezi kwiza kuruta amezi yose y\'umwaka?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16620.mp3',
                'answer' => '<p> Igisubizo: Ni ukwezi kwa Ramadhan. </p>',
            ],
            8 => [
                'question' => 'Ikibazo cya cyenda: Ni uwuhe munsi mwiza kuruta iyindi yose?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16650.mp3',
                'answer' => '<p> Igisubizo: Ni umunsi wa gatanu <span class="c2">(idjuma)</span>. </p>',
            ],
            9 => [
                'question' => 'Ikibazo cya cumi: Ni uwuhe munsi mwiza mu mwaka?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16680.mp3',
                'answer' => '<p> Igisubizo: Ni umunsi wa cyenda w\'ukwezi kwa cumi n\'abiri kwa Kisilamu <span class="c2">(Arafat)</span>. </p>',
            ],
            10 => [
                'question' => 'ikibazo cya cumi na kimwe: Ni irihe joro ryiza kuruta ayandi majoro y\'umwaka?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16710.mp3',
                'answer' => '<p> Igisubizo: Ni ijoro ry\'igeno <span class="c2">(Laylatul Qad\'ri)</span> ryo mu minsi icumi ya nyuma isoza igisibo cya Ramadhan. </p>',
            ],
            11 => [
                'question' => 'Ikibazo cya cumi na kabiri: Iyo uhuye n\'igitsinagore mudafitanye isano ni iki utegetswe?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16740.mp3',
                'answer' => '<p> Igisubizo: Kubika amaso,<span class="c6"> Allah aragira ati:</span> "...<span class="c2">(Yewe Muhamadi)</span> bwira abemeramana b’abagabo bajye bubika amaso yabo <span class="c2">(birinda kureba ibyaziririjwe)</span>..." <span class="c5">[Surat Nuur:30]</span> </p>',
            ],
            12 => [
                'question' => 'ikibazo cya cumi na gatatu: Ni abahe banzi b\'umuntu?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16770.mp3',
                'answer' => '<p> 1-<span class="c6"> Ni umutima we umwoshya ibibi:</span> Igihe umuntu akurikiye irari rye n\'ibyo umutima we umubwiriza gukora byo kugomera Allah Nyirubutagatifu.<span class="c6"> Allah aragira ati:</span> "Kandi sinigira umwere <span class="c2">(kuko nanjye naburaga gato ngo mwifuze)</span>. Mu by’ukuri umutima akenshi utegeka gukora ibibi, uretse uwo Nyagasani wanjye yagiriye impuhwe. Rwose Nyagasani wanjye ni Ubabarira ibyaha, Nyirimpuhwe.” <span class="c5">[Surat Yusuf:53]</span> 2-<span class="c6"> Shitani:</span> Akaba ari we mwanzi wa mwene Adamu, kandi intego ye nuko agomba kumuyobya no kumushuka kugira ngo akore ibibi azinjire mu muriro.<span class="c6"> Allah Nyirubutagatifu aragira ati:</span> "...kandi ntimuzanakurikire inzira za Shitani. Mu by’ukuri, yo ni umwanzi wanyu ugaragara." <span class="c5">[Suratul Baqarat:168]</span>. 3-<span class="c6"> Inshuti mbi:</span> Zishishikariza umuntu gukora ibibi, zimukumira gukora icyiza.<span class="c6"> Allah Nyirubutagatifu aragira ati:</span> "Kuri uwo munsi abari inshuti magara bazaba abanzi, usibye gusa abagandukira Allah)." <span class="c5">[Surat Zukh\'ruf:67]</span>. </p>',
            ],
            13 => [
                'question' => 'Ikibazo cya cumi na kane: Kwicuza (Tawubat) ni iki?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16820.mp3',
                'answer' => '<p> Igisubizo: Ni ukwisubiraho ukareka ibyaha, ukumvira Allah Nyirubutagatifu.<span class="c6"> Allah Aragira ati:</span> "Kandi mu by’ukuri mbabarira uwicujije, akemera, agakora ibikorwa byiza, hanyuma akayoboka <span class="c2">(inzira igororotse)</span>." <span class="c5">[Surat Twaha:82]</span>. </p>',
            ],
            14 => [
                'question' => 'Ikibazo cya cumi na gatanu: Kugira ngo kwicuza kube kwuzuye kandi kwemewe ni iki gisabwa?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16850.mp3',
                'answer' => '<p> Igisubizo: 1- Ni ukureka ibyaha.<br /> 2- Kwicuza ibyabaye.<br /> 3- Gufata umugambi wo kutabisubira.<br /> 4- Gusubiza ibyahugujwe ba nyirabyo.<span class="c6"><br /> Allah Nyiricyubahiro aragira ati:</span> "Na ba bandi iyo bakoze icyaha cy’urukozasoni cyangwa bakihemukira <span class="c2">(batumvira Allah)</span>, bibuka Allah maze bagasaba imbabazi z’ibyaha byabo, ese ninde wababarira ibyaha uretse Allah?, ntibanagume mu byo bakoraga kandi babizi <span class="c2">(ko ari ibyaha)</span>." <span class="c5">[Surat Al Im\'rani:135]</span>. </p>',
            ],
            15 => [
                'question' => 'ikibazo cya cumi na gatandatu: Gusabira Intumwa y\'Imana (Imana iyihe amahoro n\'imigisha) bivuze iki?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16920.mp3',
                'answer' => '<p> Igisubizo: Bisobanuye gusaba Allah ko yayivuga ibigwi mu bamalayika be. </p>',
            ],
            16 => [
                'question' => 'Ikibazo cya cumi na karindwi: Ijambo Subhanallah risobanuye iki?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16950.mp3',
                'answer' => '<p> Igisubizo: Risobanuye gutagatifuza Allah Nyirubutagatifu, umushyira kure y\'inenge iyo ari yo yose ndetse n\'ikibi icyo ari cyo cyose. </p>',
            ],
            17 => [
                'question' => 'Ikibazo cya cumi n\'umunani: Ijambo Alhamdulillah risobanuye iki?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16980.mp3',
                'answer' => '<p> Igisubizo: Risobanuye kuvuga ibigwi n\'ibisingizo byuzuye bya Allah Nyirubutagatifu. </p>',
            ],
            18 => [
                'question' => 'Ikibazo cya cumi n\'icyenda: Ijambo Allahu Akbar, risobanuye iki?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/17000.mp3',
                'answer' => '<p> Igisubizo: Risobanuye ko Allah asumba byose kandi ko ari we mukuru ndetse uhambaye wubahitse kuruta ikintu icyo ari cyo cyose. </p>',
            ],
            19 => [
                'question' => 'Ikibazo cya makumyabiri: Ijambo La hawula wala quwata ila bilah risobanuye iki?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/17030.mp3',
                'answer' => '<p> Igisubizo: Nta bubasha n\'ubushobozi bw\'umugaragu ku kintu icyo ari cyo cyose usibye ku bwo gushobozwa na Allah. </p>',
            ],
            20 => [
                'question' => 'Ikibazo cya makumyabiri na rimwe: Ijambo Astagh\'firullah risobanura iki?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/17060.mp3',
                'answer' => '<p> Risobanuye ko umugaragu asaba Nyagasani we ko yamubabarira ibyaha bye ndetse akanamuhishira inenge ze. </p>',
            ],
        ],
    ],
];
