<?php
$data = [
    'title' => 'What Muslim Children Must Know',
    'description' => 'A project that contains a simple and easy curriculum for issues that a Muslim must know. It includes issues of belief, jurisprudence, prophetic biography, etiquette, tafsir, hadith, morals, and remembrance of Allah. It is suitable for young children in particular, for all ages, and newcomers to Islam.',
    'source' => 'https://kids.islamenc.com/sv/home',
    'author' => 'Yazan Abdul Razzaq Raziq Alghanim',
    'sections' => [
        0 => 'Avsnittet om troslära',
        1 => 'Fiqh-sektionen',
        2 => 'Avsnittet om profetens ﷺ biografi',
        3 => 'Avsnittet om Tafsir (förklaringen av Koranen)',
        4 => 'Avsnittet om Hadith',
        5 => 'Avsnittet om islamiskt uppförande',
        6 => 'Avsnittet om gott beteende',
        7 => 'Avsnittet om åkallelser och åminnelser',
        8 => 'Avsnittet om diverse ämnen',
    ],
    'data' => [
        1 => [
            0 => [
                'question' => 'F1: Vem är din Herre?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/200.mp3',
                'answer' => '<p> S: Allah är min Herre, som fostrat mig och hela skapelsen med sina välsignelser.<span class="c6"><br /> Beviset för det är Allahs ord:</span> "All lovprisning tillkommer Allah, världarnas Herre." <span class="c2">(1:2)</span>. </p>',
            ],
            1 => [
                'question' => 'F2: Vilken är din religion?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/240.mp3',
                'answer' => '<p> S: Islam är min religion, vilket innbär att man underkastar sig till Allah med monoteism, underkuvar sig honom med lydnad och avsvär sig avgudadyrkan och dess utövare.<span class="c6"><br /> Allah säger:</span> "För Allah är <span class="c5">[den sanna]</span> religionen islam." <span class="c2">(3:19)</span>. </p>',
            ],
            2 => [
                'question' => 'F3: Vem är din profet?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/280.mp3',
                'answer' => '<p> S: Muhammed ﷺ.<span class="c6"><br /> Allah säger:</span> "Muhammed är Allahs sändebud" <span class="c2">(48:29)</span>. </p>',
            ],
            3 => [
                'question' => 'F4: Vad är monoteismens uttryck och vad innebär det?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/310.mp3',
                'answer' => '<p> S: Monoteismens uttryck är "la ilaha illallah" <span class="c2">(det finns ingen sann gud utom Allah)</span> och det betyder att ingen har rätt att dyrkas utom Allah.<span class="c6"><br /> Allah säger:</span> "Du ska veta att det inte finns någon sann gud utom Allah" <span class="c2">(47:19)</span>. </p>',
            ],
            4 => [
                'question' => 'F5: Var är Allah?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/350.mp3',
                'answer' => '<p> S: Allah är ovanför himlen, tronen och hela skapelsen.<span class="c6"> Han säger:</span> "Den Nåderike höjde sig över tronen." <span class="c2">(20:5)</span>.<span class="c6"> Han säger även:</span> "Han är den Överlägsne, ovan sina tjänare, och han är den Allvise, den Underkunnige." <span class="c2">(6:18)</span>. </p>',
            ],
            5 => [
                'question' => 'F6: Vad betyder vittnesmålet att Muhammed ﷺ är Allahs sändebud?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/380.mp3',
                'answer' => '<p> S: Det betyder att Allah skickade honom till hela världen, för att förkunna ett glädjebudskap och som en varnare.<span class="c6"><br /> Det är obligatoriskt att:</span><br /> 1. Lyda honom i det han beordrar.<br /> 2. Bekräfta det han informerar om.<br /> 3. Inte vara olydig mot honom.<br /> 4. Enbart dyrka Allah enligt det han föreskrivit, vilket innebär att följa hans Sunnah och undvika innovationer i religionen.<span class="c6"><br /> Allah säger:</span> "Den som lyder sändebudet har säkerligen lytt Allah" <span class="c2">(4:80)</span>.<span class="c6"> Han säger även:</span> "Och han talar inte utifrån sina egna begär. Det är inte annat än en uppenbarelse som uppenbaras." <span class="c2">(53:3-4)</span>.<span class="c6"> Allah säger även:</span> "Ni har ett gott föredöme i Allahs sändebud för alla som hoppas på <span class="c5">[belöning från]</span> Allah och <span class="c5">[att möta honom på]</span> den yttersta dagen och minns Allah mycket." <span class="c2">(33:21)</span>. </p>',
            ],
            6 => [
                'question' => 'F7: Varför har Allah skapat oss?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/480.mp3',
                'answer' => '<p> S: Han skapade oss för att vi ska särskilja honom i vår dyrkan och inte dyrka någon vid hans sida.<br /> Han skapade inte oss för skoj eller lek.<span class="c6"><br /> Allah säger:</span> "Jag har endast skapat jinnerna och människorna för att dyrka mig." <span class="c2">(51:56)</span>. </p>',
            ],
            7 => [
                'question' => 'F8: Vad är dyrkan?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/530.mp3',
                'answer' => '<p> S: Dyrkan är en omfattande term som inkluderar allt det Allah älskar och är nöjd med. Detta omfattar såväl tal som handling, och det dolda såväl som det synliga.<br /> Exempel på synliga handlingar är dhikr åminnas Allah genom att glorifiera och prisa honom. Det inkluderar även bönen och pilgrimsfärden.<br /> Exempel på dolda handlingar är att sätta sin lit till Allah, frukta honom och att hoppas på hans belöning. </p>',
            ],
            8 => [
                'question' => 'F9: Vad är vår största skyldighet?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/580.mp3',
                'answer' => '<p> S: Vår största skyldighet är att vara sanna monoteister. </p>',
            ],
            9 => [
                'question' => 'F10: Vilka kategorier kan monoteism delas upp i?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/610.mp3',
                'answer' => '<p> S: 1.<span class="c6"> Monoteism i herraväldet:</span> detta refererar till tron på att det endast är Allah som är Skaparen, Försörjaren, Ägaren och Den som styr.<br /> 2.<span class="c6"> Monoteism i gudomlighet:</span> detta refererar till Allahs ensamrätt till dyrkan. Ingen dyrkan får riktas till någon annan än Allah.<br /> 3.<span class="c6"> Tawhid i namnen och egenskaperna:</span> detta refererar till tron på Allahs namn och egenskaper, som förekommer i Koranen och profetens ﷺ sunnah. Man ska tro på dessa namn och attribut, utan att likna Allah vid skapelsen eller förneka det som har bekräftats.<span class="c6"><br /> Beviset för de tre kategorier av monoteism är att Allah har sagt:</span> "Herren över himlarna och jorden och allt som finns mellan dem. Dyrka därför <span class="c5">[endast]</span> honom och var ståndaktig i <span class="c5">[din]</span> dyrkan av Honom! Vet du någon som är hans namne?" <span class="c2">(19:65)</span>. </p>',
            ],
            10 => [
                'question' => 'F11: Vad är den största synden?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/670.mp3',
                'answer' => '<p> S: Avgudadyrkan, att tillskriva medgudar vid Allahs sida.<span class="c6"><br /> Allah säger:</span> "Allah förlåter inte att något sätts vid hans sida, men han förlåter vem han vill för mindre än det. Den som sätter något vid Allahs sida har sannerligen framkallat en oerhörd synd." <span class="c2">(4:48)</span>. </p>',
            ],
            11 => [
                'question' => 'F12: Nämn vad definitionen av avgudadyrkan är och vilka kategorier den har?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/710.mp3',
                'answer' => '<p> S: Avgudadyrkan är att rikta någon form av dyrkan till andra än Allah.<span class="c6"><br /> Dess kategorier:</span><br /> Större form av avgudadyrkan sker exempelvis genom att åkalla någon annan än Allah, att göra sujud <span class="c2">(gå ned med pannan på marken)</span> eller att slakta till någon annan än honom.<br /> Mindre form av avgudadyrkan sker exempelvis genom att svära vid andra än Allah och att använda amuletter. Ordet amulett syftar på saker som kan hängas eller bäras för att att bringa nytta eller avvärja skada. Ytterligare ett exempel är ögontjäneri av mindre art, såsom att en person förbättrar sin bön när andra människor ser honom. </p>',
            ],
            12 => [
                'question' => 'F13: Känner någon annan än Allah till det fördolda?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/770.mp3',
                'answer' => '<p> S: Nej, det är endast Allah som känner till det fördolda.<span class="c6"><br /> Allah säger:</span> "Säg: \'Endast Allah känner till det fördolda i himlarna och på jorden, och de har ingen aning om när de ska uppväckas.\'\'" <span class="c2">(27:65)</span>. </p>',
            ],
            13 => [
                'question' => 'F14: Hur många pelare har tron?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/810.mp3',
                'answer' => '<p> S: 1. Tron på Allah.<br /> 2. Hans änglar.<br /> 3. Hans böcker.<br /> 4. Hans sändebud.<br /> 5. Den yttersta dagen.<br /> 6. Och tron på det goda och det dåliga som ödet medför.<br /> Beviset för detta är den kända hadithen om Gabriel rapporterad av Muslim. I den hadithen sa Gabriel till profeten <span class="c2">(sallallahu \'alayhi wa sallam)</span>: "Berätta för mig vad tron är?" Han svarade: "Att du tror på Allah, hans änglar, hans böcker, hans sändebud, den yttersta dagen och att du tror på det goda och det dåliga ödet medför." </p>',
            ],
            14 => [
                'question' => 'F15: Förklara vad trons pelare är?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/900.mp3',
                'answer' => '<p> S: Tron på Allah är:<br /> Att du tror att det är Allah som skapat och försörjt dig, och att han är ägaren och den ende som styr skapelsen.<br /> Att han är Guden som förtjänar att dyrkas, ingen dyrkas i sanning utom honom.<br /> Att han är den Väldige och den Store som är perfekt och förtjänar all lovprisning. Han har de vackraste namnen och de högsta egenskaperna, och han har ingen partner och inget är honom lik.<span class="c6"><br /> Tron på änglarna:</span><br /> De är varelser som Allah har skapat från ljus, för att de ska dyrka honom och lyda hans befallning.<br /> - Bland dessa änglar är Gabriel <span class="c2">(frid vare med honom)</span> som kommer till profeterna med uppenbarelsen.<span class="c6"><br /> Tron på böckerna:</span><br /> Det är de böckerna som Allah uppenbarade för sina sändebud.<br /> - Koranen uppenbarades för Muhammed ﷺ.<br /> - Injil uppenbarades för Jesus <span class="c2">(frid vare med honom)</span>.<br /> - Tawrah uppenbarades för Moses <span class="c2">(frid vare med honom)</span>.<br /> - Zabur uppenbarades för David <span class="c2">(frid vare med honom)</span>.<br /> -<span class="c6"> Abrahams och Moses skrifter:</span> uppenbarades för Abraham och Mose.<span class="c6"><br /> Tron på sändebuden:</span><br /> Sändebuden har sänts från Allah till hans tjänare, för att de ska lära dem och ge dem det glada budskapet om godhet och paradiset, och för att varna för ondska och för elden.<br /> - De bästa bland dem är sändebuden med stark vilja.<span class="c6"> Dessa är:</span><br /> Noa <span class="c2">(frid vare med honom)</span>.<br /> Abraham <span class="c2">(frid vare med honom)</span>.<br /> Moses <span class="c2">(frid vare med honom)</span>.<br /> Jesus <span class="c2">(frid vare med honom)</span>.<br /> Muhammed ﷺ.<span class="c6"><br /> Tron på den yttersta dagen:</span><br /> Det omfattar allt som inträffar efter döden, i graven och på domedagen då människorna återuppstår för att ställas till svars. Efter det kommer paradisets invånare att bosätta sig i sina boningar och helvetets invånare bosätta sig i sina.<br /> Tron på det goda och det dåliga som ödet medför.<span class="c6"><br /> Ödet:</span> tron på att Allah vet allt som ska inträffa i världen. Han skrev ned det i den bevarade tavlan, ville att det skulle ske och skapade det.<span class="c6"><br /> Allah säger:</span> "Allt vi har skapat är i bestämt enligt ödet" <span class="c2">(54:49)</span>.<span class="c6"><br /> Ödet har fyra nivåer:</span><br /> 1. Tron på Allahs kunskap, vilket är hans kunskap om allting både innan och efter det inträffar.<span class="c6"><br /> Beviset för detta är att Allah säger:</span> "Det är hos Allah kunskapen om den yttersta stunden finns och det är han som låter regnet falla och som vet vad som döljs i moderlivet. Ingen själ vet vad den ska skörda under morgondagen, och ingen själ vet var på jorden hon ska dö. Allah är sannerligen den Allvetande, den Underrättade" <span class="c2">(31:34)</span>.<br /> 2. Tron på att Allah skrev ner detta i den bevarade tavlan. Allt som har skett och ska ske är redan nedskrivet i en bok som finns hos honom.<span class="c6"><br /> Beviset för detta är att Allah säger:</span> "Hos honom finns nycklarna till det fördolda. Ingen har vetskap om det utom han. Han vet vad som finns på land och i haven. Det finns inte ett löv som faller utan att han vet det, inte ett frö i jordens mörker, inte något vått eller något torrt utan att det står i en klar skrift" <span class="c2">(6:59)</span>.<br /> 3. Allt som sker inträffar med Allahs vilja. Allt som han eller hans skapelse gör sker med hans vilja.<span class="c6"><br /> Beviset för detta är att Allah säger:</span> "Till den av er som vill leva rättfärdigt, men ni kan inte vilja om inte Allah, världarnas Herre, vill" <span class="c2">(81:28-29)</span>.<br /> 4. Tron på att skapelser är skapade av Allah. Han skapade dem, deras egenskaper, rörelser och allt som finns i dem.<span class="c6"><br /> Beviset för detta är att Allah säger:</span> "Allah har skapat både er och det ni gör" <span class="c2">(37:96)</span>. </p>',
            ],
            15 => [
                'question' => 'F16: Vad är Koranen för något?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1300.mp3',
                'answer' => '<p> S: Koranen är Allahs tal och den är inte skapad.<span class="c6"><br /> Allah säger:</span> "Om någon bland avgudadyrkarna söker skydd hos dig ska du ge honom skydd och låta honom höra Allahs tal" <span class="c2">(9:6)</span>. </p>',
            ],
            16 => [
                'question' => 'F17: Vad är sunnah för något?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1330.mp3',
                'answer' => '<p> S: Sunnah är profetens ﷺ utlåtanden, handlingar, godkännanden, fysiska egenskaper och uppföranden. </p>',
            ],
            17 => [
                'question' => 'F18: Vad är bid\'ah (innovation i religionen) och är det något vi godtar?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1350.mp3',
                'answer' => '<p> S: Bid\'ah är alla innovationer människor introducerat till religionen och som inte existerade under profetens ﷺ eller hans följeslagares tid.<br /> *Vi godtar och accepterar dem inte.<span class="c6"><br /> Anledningen till det är att profeten ﷺ sa:</span> "Varje innovation är en villfarelse." <span class="c2">(återberättad av Abu Dawud)</span>.<br /> Exempel på innovationer i religionen är att lägga till moment i dyrkan, som att tvätta sig en fjärde gång i wudu <span class="c2">(tvagningen)</span>. Ännu ett exempel är att fira profetens ﷺ födelsedag eftersom det inte är något som förekommit från varken profeten ﷺ eller hans följeslagare. </p>',
            ],
            18 => [
                'question' => 'F19: Nämn trosläran som berör al-Wala\' (tillgivenhet) och al-Bara\' (avståndstagande)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1410.mp3',
                'answer' => '<p> S: Al-Wala\' refererar till att älska och stötta de troende.<span class="c6"><br /> Allah säger:</span> "Troende män och troende kvinnor är alla varandras beskyddare" <span class="c2">(9:71)</span>.<br /> Al-Bara\' refererar till att ogilla de otrogna för deras otro och att ta avstånd från dem.<span class="c6"><br /> Allah säger:</span> "Ni har förvisso ett gott föredöme i Abraham och de som följde honom,<span class="c6"> när de sa till sitt folk:</span> \'Vi tar avstånd från er och dem ni dyrkar vid Allahs sida. Vi fördömer er, och mellan oss och er råder hädanefter fiendskap och ovänskap tills ni tror på Allah allena.\'" <span class="c2">(60:4)</span>. </p>',
            ],
            19 => [
                'question' => 'F20: Accepterar Allah någon annan religion än islam?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1480.mp3',
                'answer' => '<p> S: Islam är den enda religionen som Allah accepterar.<span class="c6"><br /> Allah säger:</span> "Om någon vill anta en annan religion än islam kommer det inte accepteras från honom, och han kommer att vara bland förlorarna i det kommande livet" <span class="c2">(3:85)</span>. </p>',
            ],
            20 => [
                'question' => 'F21: Kufr (otro) kan ju ske genom tal, handling och troslära. Kan du ge exempel på det?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1520.mp3',
                'answer' => '<p> S: Exempel på tal är att förtala Allah eller hans sändebud ﷺ.<br /> Exempel på handling är att förnedra Koranen eller att göra sujud <span class="c2">(prostration)</span> till någon annan än Allah.<br /> Exempel på troslära är att tro att det finns någon som förtjänar att dyrkas vid sidan av Allah, eller att det finns någon annan än Allah som skapar. </p>',
            ],
            21 => [
                'question' => 'F22: Vad är nifaq (hyckleri) och vad är dess former?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1570.mp3',
                'answer' => '<p> S:<br /> 1. Större hyckleri genom att visa att man är troende utåt sätt, men samtidigt dölja otro inombords.<br /> Personen som gör detta lämnar islam, eftersom det är en form av kufr akbar <span class="c2">(större otro)</span>.<span class="c6"><br /> Allah säger:</span> "Hycklarna ska sannerligen hamna i eldens djupaste avgrund, och för dem kan du aldrig finna någon hjälpare" <span class="c2">(4:145)</span>.<br /> 2.<span class="c6"> Mindre hyckleri:</span><br /> Exempelvis att ljuga, att svika sitt löfte och att bedra.<br /> Personen som gör detta lämnar inte islam, men det räknas som en synd och den som gör det kan straffas av Allah.<span class="c6"><br /> Allahs sändebud ﷺ sade:</span> "Hycklarens kännetecken är tre; när han talar, ljuger han, när han lovar, bryter han löftet och när han tar på sig ett ansvar, bedrar han." <span class="c2">(återberättad av al-Bukhari och Muslim)</span>. </p>',
            ],
            22 => [
                'question' => 'F23: Vem är den sista profeten och det sista sändebudet?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1680.mp3',
                'answer' => '<p> S: Det är Muhammed ﷺ.<span class="c6"><br /> Allah säger:</span> "Muhammed är inte fader till någon av era män, utan är Allahs sändebud och den siste av profeterna" <span class="c2">(33:40)</span>. -<span class="c6"> Allahs sändebud ﷺ sa:</span> "Jag är den sista profeten, det finns ingen profet efter mig." <span class="c2">(Återberättad av Abu Dawud, at-Tirmidhi och andra)</span>. </p>',
            ],
            23 => [
                'question' => 'F24: Vad är mirakel?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1730.mp3',
                'answer' => '<p> S: Mirakel är övernaturliga händelse som Allah stödde sina profeter med för att visa att de verkligen var profeter och talade sanning.<span class="c6"> Exempel på dessa är:</span><br /> - Månen delades för profeten ﷺ.<br /> - Havet delades för Mose <span class="c2">(frid vare med honom)</span>, och Farao dränktes tillsammans med sina trupper. </p>',
            ],
            24 => [
                'question' => 'F25: Vilka är följeslagarna och måste jag älska dem?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1780.mp3',
                'answer' => '<p> S: En följeslagare är den som träffade profeten ﷺ, trodde på honom och dog som muslim.<br /> - Vi älskar och följer dem eftersom de var de bästa människorna efter profeterna som existerat.<span class="c6"><br /> De bästa bland dem är de fyra kaliferna:</span><br /> Abu Bakr <span class="c2">(må Allah vara nöjd med honom)</span>.<br /> Umar <span class="c2">(må Allah vara nöjd med honom)</span>.<br /> Uthman <span class="c2">(må Allah vara nöjd med honom)</span>.<br /> Ali <span class="c2">(må Allah vara nöjd med honom)</span>. </p>',
            ],
            25 => [
                'question' => 'F26: Vilka är de troendes mödrar?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1870.mp3',
                'answer' => '<p> S: De är profetens fruar.<span class="c6"><br /> Allah säger:</span> "Profeten står de troende närmare än de gör sig själva och hans hustrur är som deras mödrar." <span class="c2">(33:6)</span>. </p>',
            ],
            26 => [
                'question' => 'F27: Vad har profetens familj för rättigheter över oss?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1910.mp3',
                'answer' => '<p> S: Vi älskar och försvarar dem, och ogillar de som ogillar dem, utan att gå till överdrift i vår kärlek till dem. Hans familj omfattar hans fruar, barn och de troende bland Banu Hashim och Banu al-Muttalib. </p>',
            ],
            27 => [
                'question' => 'F29: Vad har vi för skyldigheter gentemot de muslimska ledarna?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1940.mp3',
                'answer' => '<p> S: Våra skyldigheter gentemot dem är att vi respekterar dem och lyder dem i det som inte är en synd. Vi gör inte uppror mot dem utan snarare ber vi för dem och ger dem råd privat. </p>',
            ],
            28 => [
                'question' => 'F29: Vart kommer de troende att vara i det kommande livet?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1970.mp3',
                'answer' => '<p> S: I paradiset.<span class="c6"> Allah säger:</span> "Allah ska låta dem som tror och gör goda gärningar träda in i paradis genomflutna av floder." <span class="c2">(47:12)</span>. </p>',
            ],
            29 => [
                'question' => 'F30: Var kommer de icke-troende att vara i det kommande livet?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2000.mp3',
                'answer' => '<p> S: I elden.<span class="c6"> Allah säger:</span> "Frukta elden vars bränsle är människor och stenar. Den har förberetts för de otrogna." <span class="c2">(2:24)</span>. </p>',
            ],
            30 => [
                'question' => 'F31: Vad är fruktan och hopp, och vad är beviset för att de är egenskaper den troende ska ha?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2020.mp3',
                'answer' => '<p> S: Fruktan är att frukta Allah och hans straff.<br /> Hopp är att hoppas på Allahs belöning, förlåtelse och barmhärtighet.<span class="c6"><br /> Beviset är Allahs att Allah säger:</span> "Dessa som de åkallar strävar själva efter att närmas sin Herre, <span class="c5">[och tävla om]</span> vem av dem som kommer närmast. De hoppas på hans nåd och räds hans straff. Din Herres straff är sannerligen fruktansvärt." <span class="c2">(17:57)</span>.<span class="c6"> Allah säger även:</span> "Tala om för mina tjänare att jag är den Förlåtande, den Barmhärtige, men också att mitt straff är det smärtsammaste straffet" <span class="c2">(15:49-50)</span>. </p>',
            ],
            31 => [
                'question' => 'F32: Nämn några av Allahs namn och egenskaper?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2070.mp3',
                'answer' => '<p> S: Från Allahs namn är: Herren, den Nåderike, den Allhörande, den Allseende, den Allvetande, Försörjaren, den Levande, den Väldige. Utöver det har han flera andra namn och attribut. </p>',
            ],
            32 => [
                'question' => 'F33: Förklara innebörden av dessa namn?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2100.mp3',
                'answer' => '<p> S:<br /> Allah: den ende sanne guden som förtjänar att dyrkas utan att ha någon vid sin sida.<span class="c6"><br /> Herren:</span> betyder den ende Skaparen, Ägaren, Försörjaren och att han är den enda som styr allting.<span class="c6"><br /> Den Allhörande:</span> den vars hörsel omfattar allting. Han hör alla ljud trots att de skiljer sig åt och är olika.<span class="c6"><br /> Den Allseende:</span> den som ser allt, oavsett om det är litet eller stort.<span class="c6"><br /> Den Allvetande:</span> den vars kunskap omfattar allt som skett tidigare, som sker nu och ska ske i framtiden.<span class="c6"><br /> Den Nåderike:</span> den vars nåd omfattar varje levande skapelse, alla tjänare och varelser. Alla dessa skapelser omsluts av hans nåd.<span class="c6"><br /> Försörjaren:</span> den som försörjer alla skapelser, vilket inkluderar människor, jinner och alla andra varelser.<span class="c6"><br /> Den Levande:</span> han har ett fullbordat liv och kommer aldrig dö, medan alla skapelser dör.<span class="c6"><br /> Den Väldige:</span> som är perfekt på alla sätt och vis, alla hans namn, egenskaper och handlingar är väldiga. </p>',
            ],
            33 => [
                'question' => 'F34: Vad har vi för skyldigheter gentemot muslimska lärda?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2210.mp3',
                'answer' => '<p> S: Vi älskar dem och vänder oss tillbaka till dem i islamiska frågor och hur vi ska förstå otydliga situationer. Vi nämner dem enbart med gott, och vi anser att de som talar illa om dem gör fel.<span class="c6"><br /> Allah säger:</span> "Allah höjer dem av er som tror, och dem som getts kunskap, i ranggrader. Allah är fullt underrättad om allt ni gör" <span class="c2">(58:11)</span>. </p>',
            ],
            34 => [
                'question' => 'F35: Vilka är Allahs nära tjänare?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2240.mp3',
                'answer' => '<p> S: De är troende som är gudfruktiga.<span class="c6"><br /> Allah säger:</span> "Allahs nära tjänare behöver verkligen inte känna rädsla och inte heller ska de sörja. De som tror och visar gudsfruktan" <span class="c2">(10:62-63)</span>. </p>',
            ],
            35 => [
                'question' => 'F36: Består tron av tal och handling?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2280.mp3',
                'answer' => '<p> S: Tron består av tal, handling och trosövertygelse. </p>',
            ],
            36 => [
                'question' => 'F37: Kan tron bli starkare och svagare?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2310.mp3',
                'answer' => '<p> S: Tron blir starkare när man lyder Allah och blir svagare när man är olydig mot honom.<span class="c6"><br /> Allah säger:</span> "De verkligt troende är de vars hjärtan skälver när Allah nämns, och när hans verser reciteras för dem ökar deras tro och till Allah sätter de all sin tillit" <span class="c2">(8:2)</span>. </p>',
            ],
            37 => [
                'question' => 'F38: Vad är ihsan (trons perfektion)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2350.mp3',
                'answer' => '<p> S: Att du dyrkar Allah som om du ser honom, och om du inte kan nå den nivå så ska du vara övertygad att han ser dig. </p>',
            ],
            38 => [
                'question' => 'F39: Vilka handlingar accepterar Allah?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2370.mp3',
                'answer' => '<p> S: De handlingar som uppfyller två villkor:<br /> 1. Att de görs uppriktigt för Allahs skull.<br /> 2. Att görs i enlighet med profetens ﷺ vägledning. </p>',
            ],
            39 => [
                'question' => 'F40: Vad innebär det att sätt sin lit till Allah?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2420.mp3',
                'answer' => '<p> S: Att sätt sin lit till Allah innebär att man förlitar sig på att kommer få det som är bra och skyddas från det som är dåligt, samtidigt som man använder de föreskrivna medlen för att uppnå det.<span class="c6"><br /> Allah säger:</span> "Allah är tillräcklig för den som sätter sin lit till honom" <span class="c2">(65:3)</span>.<br /> "Tillräcklig" det vill säga att personen inte kommer att behöva någon annan än honom. </p>',
            ],
            40 => [
                'question' => 'F41: Vad innebär skyldigheten att kalla till det goda och förbjuda det onda?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2470.mp3',
                'answer' => '<p> S: Att kalla till det goda är att uppmana andra att lyda Allah, och att förbjuda det onda är att hindra all form av olydnad till Allah.<span class="c6"><br /> Allah säger:</span> "Ni är det bästa samfundet som låtits uppstå för människorna; ni påbjuder det goda och förbjuder det onda och ni tror på Allah" <span class="c2">(3:110)</span>. </p>',
            ],
            41 => [
                'question' => 'F42: Vilka är Ahlus-Sunnah wal-Jama\'ah?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2510.mp3',
                'answer' => '<p> S: Det är dem som följer det som profeten ﷺ och hans följeslagare sade, gjorde och trodde på.<br /> De kallas för Ahlus-Sunnah eftersom de följer profetens väg och lämnar innovationer i religionen.<br /> Wal-Jama\'ah syftar på att de enas på sanningen och inte splittras. </p>',
            ],
        ],
        2 => [
            0 => [
                'question' => 'F1: Vad är rituell renlighet?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2580.mp3',
                'answer' => '<p> S: Rituell renlighet innebär att både rituell och fysisk orenlighet avlägsnas.<br /> Fysisk renlighet uppnås när en person tar bort orenheter från kroppen, kläderna och böneplatsen.<br /> Rituell renlighet uppnås genom wudhu <span class="c2">(mindre tvagning)</span> eller ghusl <span class="c2">(större tvagning)</span> med rent vatten, eller genom tayammum <span class="c2">(torr tvagning)</span> när vatten saknas eller det inte är möjligt att använda. </p>',
            ],
            1 => [
                'question' => 'F2: Hur renas orenligheter?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2630.mp3',
                'answer' => '<p> S: Genom att tvätta det som har något orent på sig tills det blir rent.<br /> - Det som fått hundsaliv på sig måste däremot tvättas sju gånger, varav den första tvätten görs med jord. </p>',
            ],
            2 => [
                'question' => 'F3: Vad har tvagning för dygd?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2660.mp3',
                'answer' => '<p> S: Profeten ﷺ sade: "När den muslimske, eller troende, tjänaren gör wudhu genom att tvätta sitt ansikte, lämnar alla hans synder som han har begått med ögonen hans ansikte tillsammans med vattnet, eller till den sista vattendroppen. När han tvättar sina händer, lämnar alla hans synder som han har begått med händerna hans händer med vattnet, eller till den sista vattendroppen. När han tvättar sina fötter, lämnar alla hans synder som han har begått med fötterna hans fötter med vattnet, eller till den sista vattendroppen. Till sist går han syndfri därifrån." <span class="c2">(återberättad av Muslim)</span>. </p>',
            ],
            3 => [
                'question' => 'F4: Hur utförs tvagningen?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2690.mp3',
                'answer' => '<p> S: Händerna tvättas tre gånger.<br /> Vatten förs in i munnen, sköljs runt och spottas sedan ut. Vatten ska även föras in i näsborrarna och fräsas ut. Detta görs tre gånger.<span class="c6"><br /> Madmadah:</span> att skölja munnen med vatten och sedan spotta ut det.<span class="c6"><br /> Istinshaq:</span> att föra in vatten i näsborrarna med höger hand.<span class="c6"><br /> Istinthar:</span> att fräsa ut vatten ur näsan med hjälp av vänster hand efter att det förts in.<br /> Sedan tvättas ansiktet tre gånger.<br /> Därefter tvättas underarmarna tre gånger, vilket även inkluderar armbågarna.<br /> Efter det stryks huvudet med våta händer från hårfästet till nacken. Man ska utöver det stryka med händerna över öronen.<br /> Sedan ska fötterna och anklarna tvättas tre gånger.<br /> Detta är det bästa sättet att tvaga sig på, och denna tvagning har återberättats från profeten ﷺ i hadither som rapporterats av al-Bukhari och Muslim genom \'Uthman, \'Abdullah bin Zayd m.fl. Al-Bukhari m.fl rapporterade även att han ﷺ brukade tvätta kroppsdelarna en eller två gånger under tvagningen. </p>',
            ],
            4 => [
                'question' => 'F5: Vilka är de obligatoriska handlingarna vid tvagning och hur många är ska de utföras?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2810.mp3',
                'answer' => '<p> S: Det är de handlingar som gör tvagningen ogiltig om någon av de uteblir.<br /> 1. Att tvätta ansiktet samt att skölja munnen och föra in vatten i näsan.<br /> 2. Att tvätta underarmarna, vilket även inkluderar armbågarna.<br /> 3. Att stryka huvudet, vilket inkluderar öronen.<br /> 4. Att tvätta fötterna, vilket även inkluderar anklarna.<br /> 5. Att följa ordningsföljden; ansiktet tvättas först, sedan armarna, därefter stryks huvudet och slutligen tvättas fötterna.<br /> 6. Momenten ska utföras direkt efter varandra, utan uppehåll eftersom kroppsdelarna inte får bli torra under tvagningen.<br /> - Tvagningen blir ogiltig om någon exempelvis utför första hälften av tvagningen, och skjuter upp den andra hälften till en annan tid. </p>',
            ],
            5 => [
                'question' => 'F6: Vilka är de rekommenderade handlingarna i tvagningen och hur många är dem?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2910.mp3',
                'answer' => '<p> S: De rekommenderade handlingarna i tvagningen är de handlingar som, om en person utför dem, blir belönad. Om han däremot inte gör dem syndar han inte. Tvagning är med andra ord fortfarande giltig om detta sker.<br /> 1. Att säga "Bismillah" <span class="c2">(I Allahs namn)</span>.<br /> 2. Att använda siwak <span class="c2">(eller annan rengöring av tänderna)</span>.<br /> 3. Att tvätta händerna.<br /> 4. Att tvätta mellan fingrarna.<br /> 5. Att tvätta kroppsdelarna en andra eller tredje gång.<br /> 6. Att börja med kroppsdelarna på höger sida.<br /> 7.<span class="c6"> Att minnas Allah efter tvagning genom att säga:</span> "Ash-hadu an la ilaha illallah, wahdahu la sharika lah, wa ash-hadu anna Muhammadan \'abduhu wa rasuluh" <span class="c2">(Jag bär vittne att det inte finns någon sann gud utom Allah, och jag bär vittne att Muhammed är hans tjänare och sändebud)</span>.<br /> 8. Att be två böneenheter efter tvagning. </p>',
            ],
            6 => [
                'question' => 'F7: Vilka saker avbryter ens rituella renlighet efter tvagning?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3020.mp3',
                'answer' => '<p> S: Det som kommer ut ifrån de privata delarna; urin, avföring och att släppa vind.<br /> Sömn, att tappa förståndet genom någon form av mental sjukdom, eller medvetslöshet.<br /> Att äta kamelkött.<br /> Att röra de privata delarna med sina händer utan någon barriär. </p>',
            ],
            7 => [
                'question' => 'F8: Vad är tayammum (torr tvagning)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3080.mp3',
                'answer' => '<p> S: Tayammum innebär att man använder sand eller annat som finns på jordytan när vatten saknas eller inte kan användas. </p>',
            ],
            8 => [
                'question' => 'F9: Hur utförs tayammum?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3110.mp3',
                'answer' => '<p> S: Genom att stryka handflatorna över sanden en gång och sedan stryka över ansiktet och baksidan av händerna. </p>',
            ],
            9 => [
                'question' => 'F10: Vilka orsaker saker avbryter den rituella renligheter efter att man gjort tayammum?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3140.mp3',
                'answer' => '<p> S: Allt som nämndes i samband med tvagning.<br /> När vatten finns. </p>',
            ],
            10 => [
                'question' => 'F11: Vad är khuff och jawrab? Är det tillåtet att stryka över dem under tvagning?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3180.mp3',
                'answer' => '<p> S: - Khuff är strumpor gjorda av läder.<span class="c6"><br /> Jawrab:</span> är strumpor gjorda av annat än läder.<br /> Det är föreskrivet att stryka över dem istället för att tvätta fötterna. </p>',
            ],
            11 => [
                'question' => 'F12: Vad finns det för visdom med att stryka över strumporna?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3230.mp3',
                'answer' => '<p> S: Detta är något som underlättar för människorna, särskilt i tider av extrem kyla, vinter, resa och andra tillfällen då det blir svårt att ta av sig strumporna. </p>',
            ],
            12 => [
                'question' => 'F13: Vad är villkoren för att på ett giltigt sätt stryka över strumporna?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3260.mp3',
                'answer' => '<p> S: 1. Att man sätter på sig strumporna när man är rituellt ren, vilket är när man har utfört tvagning.<br /> 2. Att strumporna är rituellt rena. Det är med andra ord inte tillåtet att stryka över strumpor som är rituellt orena.<br /> 3. Att strumporna täcker det område som tvättas under tvagning.<br /> 4. Att strumporna stryks över under en specifikt utsatt tid. Den bosatte kan göra detta under en dag och en natt, den resande kan däremot göra det under tre dagar och tre nätter. </p>',
            ],
            13 => [
                'question' => 'F14: Hur bör man stryka över strumporna?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3320.mp3',
                'answer' => '<p> S: Detta görs genom att placera våta fingrar över tårna och sedan stryka bak till benet. Den högra foten stryks med den högra handen, och den vänstra foten men den vänstra handen. </p>',
            ],
            14 => [
                'question' => 'F15: När är det inte tillåtet att stryka över strumporna längre?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3350.mp3',
                'answer' => '<p> S: 1. Det är inte tillåtet att stryka över strumporna när tiden för det är över. Den bosatte kan stryka över strumporna under ett dygn, och den resande under tre dygn.<br /> 2. Att ta av ena eller båda strumporna efter att personen strukit över dem. </p>',
            ],
            15 => [
                'question' => 'F16: Vad är bönen för något?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3390.mp3',
                'answer' => '<p> S: Bönen innebär att man dyrkar Allah genom särskilda uttryck och rörelser. Den inleds med att säga "Allahu akbar" <span class="c2">(Allah är större)</span> och avslutas med taslim <span class="c2">(As-salamu \'alaykum)</span>. </p>',
            ],
            16 => [
                'question' => 'F17: Vilken bestämmelse har bönen?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3420.mp3',
                'answer' => '<p> S: Bönen är obligatorisk för varje muslim.<span class="c6"><br /> Allah säger:</span> "Bönen är en tidsbunden plikt för de troende" <span class="c2">(4:103)</span>. </p>',
            ],
            17 => [
                'question' => 'F18: Vad är bestämmelsen för att lämna bönen?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3460.mp3',
                'answer' => '<p> S: Att lämna bönen är en form av otro.<span class="c6"> Profeten ﷺ sa:</span><br /> "Pakten som är mellan oss och dem är bönen. Den som lämnar den har begått otro."<br /> <span class="c2">(återberättad av Ahmad, at-Tirmidhi m.fl.)</span>. </p>',
            ],
            18 => [
                'question' => 'F19: Hur många böner måste en muslim be under ett dygn? Och hur många böneenheter består varje bön av?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3500.mp3',
                'answer' => '<p> S: Muslimen ska be fem böner om dygnet.<span class="c6"> Dessa böner är:</span><br /> Fajr-<span class="c6">bönen:</span> två böneenheter.<br /> Dhuhr-<span class="c6">bönen:</span> fyra böneenheter.<br /> \'Asr-<span class="c6">bönen:</span> fyra böneenheter.<br /> Maghrib-<span class="c6">bönen:</span> tre böneenheter.<br /> \'Isha\'-<span class="c6">bönen:</span> fyra böneenheter. </p>',
            ],
            19 => [
                'question' => 'F20: Vilka vilkor har bönen?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3530.mp3',
                'answer' => '<p> S: 1. Att man är muslim. Bönen accepteras inte från en icke-muslim.<br /> 2. Att man är vid sina sinnes fulla bruk. Bönen accepteras inte från en person som lider av grava mentala sjukdomar.<br /> 3. Att man nått en ålder där man har urskiljningsförmåga. Bönen accepteras inte från ett barn som saknar detta.<br /> 4. Att man har avsikt i bönen.<br /> 5. Att tiden för bönen är inne.<br /> 6. Att man renar sig så att man inte befinner sig i ett orent tillstånd.<br /> 7. Att vara ren från fysiska orenheter.<br /> 8. Att täcka de delar av kroppen som måste täckas.<br /> 9. Att vända sig mot böneriktningen. </p>',
            ],
            20 => [
                'question' => 'F21: Hur många pelare har bönen?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3640.mp3',
                'answer' => '<p> S: Fjorton pelare,<span class="c6"> dessa är:</span><br /> 1. Att stå upp under de obligatoriska bönerna, för den som är kapabel att göra det.<br /> 2. Att säga "Allahu akbar" <span class="c2">(Allah är större)</span> när bönen påbörjas.<br /> 3. Att läsa Koranens första kapitel al-Fatihah.<br /> 4. Ruku\' som är att böja sig så att rygg och bakhuvud bildar en rak linje.<br /> 5. Att resa sig från Ruku\'.<br /> 6. Att stå upprätt.<br /> 7. Sujud, som är att placera panna, näsa, handflator, knä och tår på marken.<br /> 8. Att resa sig från Sujud.<br /> 9. Att sitta mellan de två Sujud.<br /> Det är rekommenderat att sitta på den vänstra foten och ha den högra foten upprätt med tårna riktade mot böneriktningen.<br /> 10. Att vara lugn när bönens pelare utförs.<br /> 11. Att läsa den sista Tashahhud.<br /> 12. Att sitta under Tashahhud.<br /> 13. Att säga "As-salamu \'alaykum wa rahmatullah" <span class="c2">(Må frid och Allahs barmhärtighet vara över er)</span> två gånger.<br /> 14. Att följa denna ordningsföljd när pelarna utförs. Om någon medvetet exempelvis gör Sujud innan Ruku\' nollställs bönen. Om någon däremot gör detta omedvetet måste han gå tillbaka till Ruku\' och sedan göra Sujud. </p>',
            ],
            21 => [
                'question' => 'F22: Vilka är bönens obligatoriska delar?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3820.mp3',
                'answer' => '<p> S: Bönens obligatoriska moment är åtta i antal.<span class="c6"> Dessa är:</span><br /> 1. Att säga alla Takbirs <span class="c2">(Allahu akbar)</span>, förutom den som bönen inleds med <span class="c2">(eftersom den är en pelare)</span>.<br /> 2. Att säga "Sami\'allahu liman hamidah" <span class="c2">(Allah besvarar den som prisar honom)</span>. Detta är obligatoriskt för den som leder bönen eller ber ensam.<br /> 3. Att säga "Rabbana lakal hamd" <span class="c2">(Vår Herre! Dig tillkommer all lovprisning)</span>.<br /> 4. Att säga "Subhana Rabbiyal-\'Adhim" <span class="c2">(Glorifierad är min Herre, den Väldige)</span> en gång i Ruku\'.<br /> 5. Att säga "Subhana Rabbiyal-A\'la" <span class="c2">(Glorifierad är min Herre, den Högste)</span> en gång i Sujud.<br /> 6. Att säga "Rabbi-ghfir li" <span class="c2">(Min Herre! Förlåt mig)</span> mellan de två Sujud.<br /> 7. Att uttala den första Tashahhud.<br /> 8. Att sitta under den första Tashahhud. </p>',
            ],
            22 => [
                'question' => 'F23: Vilka är de rekommenderade momenten av bönen?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3930.mp3',
                'answer' => '<p> S: Det finns elva rekommenderademoment i bönen .<span class="c6"> Dessa är:</span><br /> 1. Att man efter den första Takbir säger en inledningsåkallan,<span class="c6"> vilken lyder:</span> "Subhanak Allahumma wa bihamdika wa tabarak ismukaa wa ta\'ala jadduka wa la ilaha ghayruk" <span class="c2">(Allah! Fri är du från alla brister, och lovprisad! Välsignat vare ditt namn och upphöjt vare din majestät. Ingen har rätt att dyrkas förutom du."<br /> 2.<span class="c6"> Att säga Ta\'awwudh:</span> "A\'udhu billahi minash-shaytanir rahim" (Jag tar skydd hos Allah från Satan, den utstötte)</span>.<br /> 3.<span class="c6"> Att säga Basmalah:</span> "Bismillahir-Rahmanir-Rahim" <span class="c2">(I Allahs namn, den Nåderike, den Barmhärtige")</span>.<br /> 4.<span class="c6"> Att säga:</span> "Amin".<br /> 5. Att läsa ett kapitel efter Surat ul-Fatihah.<br /> 6. Att imamen som leder bönen reciterar Koranen högt.<br /> 7. Att man säger efter att ha sagt Tahmid <span class="c2">(Rabbana wa lakal hamd)</span> följande mening: "Mil\'as-samawati wa mil\'al-ardi wa mil\'a ma shi\'ta min shay\'in ba\'d" <span class="c2">(<span class="c5">[En lovprisning]</span> som fyller himlarna och jorden och allt däremellan, samt fyller allt som du vill efter det)</span>.<br /> 8. Att säga Tasbih <span class="c2">(Glorifierad är du <span class="c5">[Allah]</span>)</span> mer än en gång i Ruku\'.<br /> 9. Att säga Tasbih <span class="c2">(Glorifierad är du <span class="c5">[Allah]</span>)</span> mer än en gång i Sujud.<br /> 10. Att säga "Rabbi-ghfir li" <span class="c2">(Min Herre! Förlåt mig)</span> mer än en gång mellan de två Sujud.<br /> 11. Att i den sista Tashahud be Allah hylla, välsigna och sända frid över profeten ﷺ och hans familj, samt att säga olika typer av åkallelser efter det.<span class="c6"><br /> Fjärde:</span> De rekommenderade handlingarna:<br /> 1. Att lyfta händerna när den inledande Takbir sägs.<br /> 2. Att lyfta händerna innan Ruku\'.<br /> 3. Att lyfta händerna i samband med resningen från Ruku\'.<br /> 4. Att ta ner händerna efter det.<br /> 5. Att placera den högra handen över den vänstra handen.<br /> 6. Att fästa blicken vid platsen för Sujud.<br /> 7. Att ha avstånd mellan fötterna vid stående position.<br /> 8. Att placera händerna på knäskålarna med fingrarna separerade under Ruku\' med rak rygg och bakhuvudet i samma höjd.<br /> 9. Att kroppsdelarna som Sujud utförs har fått fäste på marken.<br /> 10. Att det finns avstånd mellan armar och kropp, mage och lår, lår och vader. Knäna ska vara separerade och fötterna upprätta med tårnas undersida på marken. Händerna ska placeras i axelnivå med avstånd från kroppen och med fingrarna sammansatta.<br /> 11. Att sitta på vänster ben med högra foten upprätt mellan de två Sujud och den första Tashahhud, medan man sitter på vänster höft och bakdel med högra foten upprätt i den andra Tashahhud.<br /> 12. Att placera händerna på låren med sammansatta fingrar mellan de två Sujud. Detta görs även i Tashahhud, men då ska den högra handen forma en knytnäve förutom pekfingret som pekar mot böneriktningen när Allah nämns.<br /> 13. Att vända huvudet åt höger och sedan åt vänster vid Taslim. </p>',
            ],
            23 => [
                'question' => 'F24: Vad gör bönen ogiltig?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4210.mp3',
                'answer' => '<p> S: 1. Att lämna en av bönens pelare eller villkor.<br /> 2. Att avsiktligt tala.<br /> 3. Att äta eller dricka.<br /> 4. Att röra sig mycket och oavbrutet.<br /> 5. Att lämna en av bönens obligatoriska delar avsiktligen. </p>',
            ],
            24 => [
                'question' => 'F25: Hur bör en muslim be?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4280.mp3',
                'answer' => '<p> S: Bönen utförs på följande sätt:<br /> 1. Han ska vända hela kroppen så den är riktad mot böneriktningen utan att vända sig ifrån den.<br /> 2. Han ska avse att be den specifika bönen. Avsikten sker i hjärtat utan att den uttalas med tungan.<br /> 3.<span class="c6"> Därefter säger han den inledande Takbir sägandes:</span> "Allahu akbar" <span class="c2">(Allah är större)</span> och lyfter samtidigt sina händer till axelhöjd.<br /> 4. Sedan placerar han sin högra handflata över sin vänstra hand på bröstkorgen.<br /> 5.<span class="c6"> För att sedan läsa en inledningsbön som kan vara följande:</span> "Allahumma ba\'id bayni wa bayna khatayaya kama ba\'adta baynal-mashriqi wal-maghrib, Allahumma naqqini min khatayaya kama yunaqqath-thawbul-abyadhu minad-danas, Allahum-maghsilni min khatayay, bil-ma´i wath-thalji wal-barad" <span class="c2">(Allah! Avlägsna mina synder från mig så som du avlägsnat öst från väst. Allah! Rena mig från mina synder så som det vita plagget renas från fläckar. Allah! Tvätta bort mina synder med vatten, is och hagel)</span>.<span class="c6"><br /> Alternativt kan han säga:</span> "Subhanak Allahumma wa bihamdik, wa tabarak-ismuk, wa ta\'ala jadduk, wa la ilaha ghayruk" <span class="c2">(Allah! Fri är du från brister och lovprisad, välsignat vare ditt namn, och upphöjt vare ditt majestät. Det finns ingen sann gud utom du)</span>.<br /> 6.<span class="c6"> Därefter söker han skydd hos Allah och säger:</span> "A\'udhu billahi minash-shaytanir-rajim" <span class="c2">(Jag söker skydd hos Allah från Satan, den utstötte)</span>. 7. Efter det läser han al-Basmalah och al-<span class="c6">Fatihah genom att säga:</span> Bismillahir-Rahmanir-Rahim<br /> <span class="c2">(I Allahs namn, den Nåderike, den Barmhärtige)</span>. Alhamdulillahi Rabbil-\'Alamin<br /> <span class="c2">(All lovprisning tillkommer Allah, världarnas Herre,)</span> ar-Rahmanir-Rahim<br /> <span class="c2">(den Nåderike, den Barmhärtige,)</span> Maliki Yawm id-Din<br /> <span class="c2">(domedagens Ägare.)</span> Iyyaka na\'budu wa iyyaka nasta\'in<br /> <span class="c2">(Endast dig dyrkar vi och endast dig ber vi om hjälp.)</span> Ihdinas-siratal-mustaqim<br /> <span class="c2">(Led oss på den raka vägen!)</span> Siratal-ladhina an\'amta \'alayhim ghayril-maghdubi \'alayhim wa lad-dalin<br /> <span class="c2">(Den väg som de du har välsignat följde; inte de som har drabbats av <span class="c5">[din]</span> vrede och inte heller de vilsna.)</span> <span class="c2">(1:1 - 7)</span>.<span class="c6"><br /> Sedan säger han:</span> "Amin",<span class="c6"> vilket betyder:</span> Allah! Bönhör oss.<br /> 8. Han kan läsa det han vill från Koranen, och det är rekommenderat att förlänga läsningen under Fajr-bönen.<br /> 9. Därefter gör han Ruku\', då han bugar sig i högaktning till Allah. Han säger Takbir, lyfter händerna till axelhöjd och böjer sig ner. Det är rekommenderat att ha ryggen rak och bakhuvudet i samma nivå som den. Han ska placera händerna på knäskålarna med fingrarna separerade.<br /> 10. Under Ruku\' ska han säga "Subhana Rabbiyal-\'Adhim" <span class="c2">(Min Herre, den Väldige, är fri från brister)</span> tre gånger. Det är även bra att tillägga "Subhanak-Allahumma wa bihamdik, Allahummagh-fir li" <span class="c2">(Allah! Du är fri från brister, och all lovprisning tillkommer dig. Allah! Förlåt mig)</span>.<br /> 11.<span class="c6"> Efter det lyfter han huvudet från Ruku\' och säger samtidigt som han lyfter händerna till axelnivå:</span> "Sami\' Allahu liman hamidah" <span class="c2">(Allah hör den som prisar honom)</span>. Den som ber bakom en Imam säger inte "Sami\' Allahu liman hamidah",<span class="c6"> utan säger istället:</span> "Rabbana wa lakal-hamd" <span class="c2">(Vår Herre! All lovprisning tillkommer dig)</span>.<br /> 12.<span class="c6"> När han står upp säger han:</span> "Rabbana wa lakal-hamd, mil\'as-samawati wa mil\'al-ardi wa mil\'a ma shi\'ta min shay\'in ba\'d" <span class="c2">(Vår Herre! Till dig tillkommer alla lovprisningar. <span class="c5">[Lovprisningar]</span> som fyller himlarna och jorden och allt däremellan, samt fyller allt som du vill efter det)</span>.<br /> 13. Sedan faller han ner i Sujud för första gången samtidigt som han säger Takbir.<span class="c6"> Han gör Sujud med sju kroppsdelar:</span> panna och näsa, handflator, knän och tåspetsar. Han bör ha ett avstånd mellan armar och kropp, och ska inte låta armarna vila på marken. Tåspetsarna ska vara riktade mot böneriktningen.<br /> 14. I Sujud säger han "Subhana Rabbiyal-A\'la" <span class="c2">(Min Herre, den Högste, är fri från brister)</span> tre gånger. Det är även bra att tillägga "Subhanak-Allahumma wa bihamdik, Allahummagh-fir li" <span class="c2">(Allah! Du är fri från brister, och all lovprisning tillkommer dig. Allah! Förlåt mig)</span>.<br /> 16. Sedan lyfter han huvudet från Sujud och säger Takbir.<br /> 16. Därefter sitter han mellan de två Sujud på sin vänstra fot, har den högra foten upprätt och placerar den högra handen på slutet av låret ovanför knäna. Han ska forma sin högra hand till en knytnäve utom pekfingret som ska peka mot böneriktningen och röra på sig i samband med åkallan. Den vänstra handen ska vida på slutet av det vänstra låret ovanför knät med fingrarna utspridda.<br /> 17.<span class="c6"> I den positionen ska han säga:</span> "Rabbigh-fir li, warhamni, wahdini, warzuqni, wajburni wa \'afini" <span class="c2">(Min Herre! Förlåt mig, ha barmhärtighet över mig, vägled mig, försörj mig, stärk mig och skona mig)</span>.<br /> 19. Efter det går han ned i den andra Sujud på samma sätt som han gjorde i den första och säger Takbir.<br /> 19. När han reser sig från den andra Sujud och säger Takbir ber han den andra böneenheten på samma sätt som han bad den första böneenheten, utan att läsa inledningsbönen.<br /> 20. Efter att han avslutat den andra böneenheten säger han Takbir och sätter sig på samma sätt som han satt mellan de två Sujud.<br /> 21.<span class="c6"> Då läser han Tashahhud och säger:</span> "At-tahiyyatu lillahi was-salawatu , wat-tayyibat, as-salamu \'alayka ayyuhan-Nabiyyu wa rahmatullahi wa barakatuhu, as-salamu \'alayna wa \'ala \'ibadillahis-salihin. Ash-hadu an la \'ilaha \'illallahu wa ash-hadu anna Muhammadan \'abduhu wa rasuluh.<br /> Allahumma salli \'ala Muhammadin wa \'ala ali Muhammad, kama sallayta \'ala Ibrahima wa \'ala ali Ibraham, innaka Hamidun Majid.<br /> Wa barik \'ala Muhammadin wa \'ala ali Muhammad kama barakta \'ala Ibrahima wa \'ala ali Ibrahim, innaka Hamidun Majid.<br /> Allahumma inni a\'udhu bika min \'adhabil-qabr, wa min \'adhabi jahannam, wa min fitnatil-mahya wal-mamat, wa min sharri fitnatil-masihid-dajjal" <span class="c2">(Alla vördnadshälsningar, samtliga böner, alla goda ord och handlingar hör till Allah. Må Allah bevara dig profeten och sända sin barmhärtighet och välsignelser över dig. Må Allah bevara oss och Allahs rättfärdiga tjänare. Jag vittnar om att det inte finns någon sann gud utom Allah, och att Muhammed är hans tjänare och sändebud.<br /> Allah! Upphöj och ära Muhammed och Muhammeds familj, så som du upphöjde och ärade Ibrahim och Ibrahims familj, sannerligen är du värd all pris, Glorifierad. <br /> Allah! Välsigna Muhammed och Muhammeds familj, så som du välsignade Ibrahim och Ibrahims familj, sannerligen är du värd all pris, Glorifierad.<br /> Allah! Jag söker ditt skydd från gravens straff och från helvetets straff, från livets och dödens prövningar, samt från den falske Messias <span class="c5">[Dajjals]</span> onda prövning)</span>. Sen kan han be Allah skänka honom det han önskar från det goda i detta liv såväl som i det kommande livet.<br /> 22.<span class="c6"> Slutligen gör han Taslim åt höger sägande:</span> "As-salamu \'alaykum wa rahmatullah" <span class="c2">(Må Allahs frid och barmhärtighet vila över dig)</span>, och likaså åt vänster.<br /> 23. Om bönen består av tre eller fyra böneenheter tar den första Tashahhud slut vid "Ash-hadu an la ilaha illallah, wa ash-hadu anna Muhammadan \'abduhu wa rasuluh" <span class="c2">(Jag bär vittne att det inte finns någon sann gud utom Allah, och jag bär vittne att Muhammed är hans slav och sändebud)</span>.<br /> 24. Efter det ställer han sig upp, säger Takbir och lyfter händerna till axelhöjd.<br /> 25. Sedan ber han resterande bön likt han bad den andra böneenheten, men han läser däremot inget efter al-Fatihah.<br /> 26. Därefter ska han sitta med höger fot upprätt, placera den vänstra foten under den högra vaden eller på marken, och placera händerna på låren på samma sätt som han gjort i den första Tashahhud.<br /> 27. I denna position ska han läsa hela Tashahhud.<br /> 28.<span class="c6"> Slutligen gör han Taslim åt höger sägande:</span> "As-salamu \'alaykum wa rahmatullah" <span class="c2">(Må Allahs frid och barmhärtighet vila över dig)</span>, och likaså åt vänster. </p>',
            ],
            25 => [
                'question' => 'F26: Vilka åminnelser läses efter bönens Taslim?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4610.mp3',
                'answer' => '<p> S: "Astaghfirullah" <span class="c2">(Jag söker Allahs förlåtelse)</span> tre gånger.<br /> - "Allahumma antas-salam, wa minkas-salam, tabarakta ya dhal-jalali wal-ikram" <span class="c2">(Allah! Du är Salam, från dig kommer as-Salam. Du är Välsignad, Du Majestätiske, Du Givmilde)</span>.<br /> - "La ilaha illallahu wahdahu la sharika lah, lahul-mulku wa lahul-hamdu wa huwa \'ala kulli shay´in qadir. Allahumma la mani\'a lima a\'tayt, wa la mu\'tiya lima mana\'t, wa la yanfa\'u dhal-jaddi minkal-jadd" <span class="c2">(Det finns ingen sann gud utom Allah. Han är en och han har ingen vid Sin sida. Till honom hör herraväldet och all pris och han är kapabel till allting. Allah! Ingen kan hindra det som du ger och ingen kan ge det som du hindrar, och den rikes rikedom gynnar honom inte mot dig)</span>.<br /> - "La ilaha illallahu wahdahu la sharika lah, lahul-mulku, wa lahul-hamdu wa huwa \'ala kulli shay´in qadir. La hawla wa la quwwata illa billah, la ilaha illallah, wa la na\'budu illa iyyah, lahun-ni\'matu wa lahul-fadhlu wa lahuth-thana\'ul-hasan, la ilaha illallahu mukhlisina lahud-din wa law karihal-kafirun" <span class="c2">(Det finns ingen sann gud utom Allah. Han är en och han har ingen vid sin sida. Till honom hör herraväldet och allt lovpris och han är kapabel till allting. Det finns ingen rörelse och ingen styrka förutom med Allahs hjälp och vilja. Det finns ingen sann gud utom Allah och vi dyrkar ingen annan än honom. Gåvorna hör till honom. Det goda hör till honom. Allt lovpris och tack tillkommer honom. Det finns ingen sann gud utom Allah; vi dyrkar endast honom, med uppriktighet, även om de otrogna ogillar det)</span>.<br /> - "Subhanallah" <span class="c2">(Fri är Allah från brister)</span> 33 gånger.<br /> - "Alhamdulillah" <span class="c2">(Alla lovprisningar tillkommer Allah)</span> 33 gånger.<br /> - "Allahu akbar" <span class="c2">(Allah är större)</span> 33 gånger.<span class="c6"><br /> För att uppnå 100 uttryck säger han:</span> "La ilaha illallahu wahdahu la sharika lah, lahul-mulku, wa lahul-hamdu wa huwa \'ala kulli shay´in qadir" <span class="c2">(Det finns ingen sann gud utom Allah. Han är en och han har ingen vid sin sida. Till honom hör herraväldet och all lovpris och han är kapabel till allting."<br /> - Han kan läsa de tre sista kapitlen i Koranen (al-Ikhlas, al-Falaq och an-Nas)</span> tre gånger efter Fajr- och Maghrib-bönen, och en gång efter de resterande bönerna.<br /> - Han kan även läsa Ayatul-Kursi <span class="c2">(vers 2:255)</span> en gång. </p>',
            ],
            26 => [
                'question' => 'F27: Vilka är de regelbundna rekommenderade bönerna och vad har de för dygder?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4730.mp3',
                'answer' => '<p> S: - Två böneenheter innan Fajr.<br /> - Fyra böneenheter innan Dhuhr.<br /> - Två böneenheter efter Dhuhr.<br /> - Två böneenheter efter Maghrib.<br /> - Två böneenheter efter \'Isha\'.<span class="c6"><br /> Dess dygd:</span> Profeten ﷺ sa: ِ"Allah kommer att bygga ett hus i paradiset åt den som frivilligt ber tolv böneenheter under ett dygn." <span class="c2">(återberättad av Muslim, Ahmad m.fl.)</span>. </p>',
            ],
            27 => [
                'question' => 'F28: Vad är den bästa dagen i veckan?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4800.mp3',
                'answer' => '<p> S: Fredagen.<span class="c6"> Profeten ﷺ sa:</span> "Fredagen är er bästa dag. Då skapades Adam och då dog han. Då sker stöten <span class="c2">(i hornet)</span> och då sker döden <span class="c5">[när domedagen börjar]</span>. Be därför ofta om hyllning för mig. Er hyllning presenteras för mig.<span class="c6">" De sa:</span> "Hur presenteras vår hyllning för dig, Allahs sändebud,<span class="c6"> när du har förtvinat?" Då svarade han:</span> "Allah har förbjudit jorden att förtvina profeternas kroppar" <span class="c2">(återberättad av Abu Dawud m.fl.)</span>. </p>',
            ],
            28 => [
                'question' => 'F29: Vad är bestämmelsen för att be fredagsbönen?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4840.mp3',
                'answer' => '<p> S: Den är obligatorisk för varje person som är muslim, man, könsmogen, mentalt frisk och inte resande.<span class="c6"><br /> Allah säger:</span> "Troende! Låt inte era tillgångar och era barn få er att glömma att minnas Allah. De som gör så är de verkliga förlorarna." <span class="c2">(63:9)</span>. </p>',
            ],
            29 => [
                'question' => 'F30: Hur många böneenheter består fredagsbönen av?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4880.mp3',
                'answer' => '<p> S: Fredagsbönen består av två böneenheter. Imamen leder bönen och läser Koranen högt. Innan bönen hålls två predikningar. </p>',
            ],
            30 => [
                'question' => 'F31: Är det tillåtet att missa fredagsbönen?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4910.mp3',
                'answer' => '<p> S: Det är inte tillåtet att lämna fredagsbönen utan en enligt islam giltig orsak.<span class="c6"> Profeten ﷺ sa:</span> "Allah förseglar hjärtat på den som lämnar tre fredagsböner av försumlighet" <span class="c2">(återberättad av Abu Dawud m.fl.)</span> </p>',
            ],
            31 => [
                'question' => 'F32: Nämn de handlingar som är rekommenderade att göra på fredagen?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4940.mp3',
                'answer' => '<p> S:<br /> 1. Att göra Ghusl <span class="c2">(den större rituella tvagningen)</span>.<br /> 2. Att parfymera sig.<br /> 3. Att klä upp sig.<br /> 4. Att gå till moskén tidigt.<br /> 5. Att vid upprepande tillfällen be Allah att hylla profeten ﷺ.<br /> 6. Att läsa suratul-Kahf.<br /> 7. Att ta sig till moskén till fots.<br /> 8. Att vara mån om att åkalla Allah under den timmen då åkallan besvaras. </p>',
            ],
            32 => [
                'question' => 'F33: Vilka dygder har församlingsbönen?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5050.mp3',
                'answer' => '<p> S. \'Abdullah bin \'Umar <span class="c2">(må Allah vara nöjd med honom)</span> sa att Allahs sändebud ﷺ sa: "Församlingsbönen är tjugosju gånger bättre än bönen som bes på egen hand" <span class="c2">(återberättad av Muslim)</span>. </p>',
            ],
            33 => [
                'question' => 'F34: Vad betyder det att ha Khushu\' i bönen?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5080.mp3',
                'answer' => '<p> S: Det är att be med ett närvarande hjärta och att man är lugn i sina kroppsdelar.<span class="c6"><br /> Allah säger:</span> "De troende är de framgångsrika, de som är ödmjuka <span class="c2">(och fokuserade)</span> i sin bön" <span class="c2">(23:1-2)</span>. </p>',
            ],
            34 => [
                'question' => 'F35: Vad är allmosa?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5120.mp3',
                'answer' => '<p> S: Det är en obligatorisk plikt som berör en viss typ av egendom, som ska ges av vissa personer under en bestämd tid.<br /> - Allmosan är en av islams pelare. Den är en form av obligatorisk välgörenhet som tas från den rike och ges till den fattige.<span class="c6"><br /> Allah säger:</span> "Ge allmosa" <span class="c2">(2:43)</span>. </p>',
            ],
            35 => [
                'question' => 'F36: Vad är den rekommenderade välgörenheten?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5170.mp3',
                'answer' => '<p> S: Den skiljer sig från allmosan. Det kan vara att skänka något till ett gott ändamål under valfri tid.<span class="c6"><br /> Allah säger:</span> "Spendera för Allahs sak" <span class="c2">(2:195)</span>. </p>',
            ],
            36 => [
                'question' => 'F37: Vad är fasta?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5210.mp3',
                'answer' => '<p> S: Det är att dyrka Allah genom att avsiktligt avstå från det som bryter fastan, från soluppgång till solnedgång.<span class="c6"> Fastan kan delas upp i två kategorier:</span><br /> Obligatorisk fasta: Som att fasta under Ramadan, vilket är en av islams pelare.<span class="c6"><br /> Allah säger:</span> "Troende! Det är föreskrivet för er är att fasta, liksom det var föreskrivet för dem före er, så att ni kan visa gudsfruktan" <span class="c2">(2:183)</span>.<span class="c6"><br /> Frivillig fasta:</span> Som att fasta på måndag och torsdag varje vecka, eller tre dagar varje månad. Det bästa sättet att fasta på är att göra det under de vita dagarna <span class="c2">(13, 14 och 15)</span> av varje islamisk månad. </p>',
            ],
            37 => [
                'question' => 'F38: Vad finns det för dygd i att fasta månaden Ramadan?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5270.mp3',
                'answer' => '<p> S: Abu Hurayrah <span class="c2">(må Allah vara nöjd med honom)</span> berättade att Allahs sändebud ﷺ sa: "Den som fastar Ramadan med tro och hopp <span class="c2">(om belöning)</span> kommer att få sina tidigare synder förlåtna" <span class="c2">(återberättad av al-Bukhari och Muslim)</span>. </p>',
            ],
            38 => [
                'question' => 'F39: Vad finns det för dygd i att fasta frivillig fasta?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5300.mp3',
                'answer' => '<p> S: Abu Said al-Khudri <span class="c2">(må Allah vara nöjd med honom)</span> berättade att Allahs sändebud ﷺ sa: "Om en tjänare fastar en dag för Allahs skull kommer Allah att ta bort honom från helveteselden ett sjuttio höstars avstånd" <span class="c2">(återberättad av al-Bukhari och Muslim)</span>.<br /> - Betydelsen av "sjuttio höstar" är sjuttio år. </p>',
            ],
            39 => [
                'question' => 'F40: Nämn några saker som gör fastan ogiltig?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5330.mp3',
                'answer' => '<p> S: 1. Att äta eller dricka avsiktligt.<br /> 2. Att spy avsiktligt.<br /> 3. Att lämna islam. </p>',
            ],
            40 => [
                'question' => 'F41: Vad är rekommenderat i samband med fastan?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5380.mp3',
                'answer' => '<p> S: 1. Att skynda med att bryta fastan.<br /> 2. Att äta en måltid innan fastan påbörjas, som bör ätas så sent som möjligt.<br /> 3. Att göra mer goda handlingar och dyrkan.<br /> 4.<span class="c6"> Om den fastande förolämpas av någon ska han säga:</span> "Jag fastar."<br /> 5. Att åkalla Allah i samband med att fastan bryts.<br /> 6. Att bryta fastan med omogna eller mogna dadlar om det finns tillgängligt, annars med vatten. </p>',
            ],
            41 => [
                'question' => 'F42: Vad är Hajj?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5460.mp3',
                'answer' => '<p> S: Hajj innebär att man dyrkar Allah genom att besöka hans heliga hus <span class="c2">(Kaba)</span> för att utföra särskilda handlingar under en specifik tid.<span class="c6"><br /> Allah säger:</span> "Gentemot Allah är det en plikt för människorna att vallfärda till huset, <span class="c5">[för]</span> dem som finner möjlighet till det. Och de som förnekar plikten <span class="c5">[ska veta att]</span>, Allah är oberoende av sin skapelse" <span class="c2">(3:19)</span>. </p>',
            ],
            42 => [
                'question' => 'F43:  Vilka är Hajjs pelare?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5500.mp3',
                'answer' => '<p> S: 1. Ihram <span class="c2">(att träda in det rituella tillståndet innan Hajj)</span>.<br /> 2. Att befinna sig vid \'Arafah.<br /> 3. Att göra Tawaful-Ifadah.<br /> 4. Att göra Sa\'y och gå mellan as-Safa wal-Marwah. </p>',
            ],
            43 => [
                'question' => 'F44: Vad finns det för dygd i att utföra Hajj?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5560.mp3',
                'answer' => '<p> S: Abu Hurayrah <span class="c2">(må Allah vara nöjd med honom)</span> berättade att han hörde Allahs sändebud ﷺ säga: "Den som gör Hajj för Allahs skull, utan att vara oanständig eller syndig återvänder som den dag hans moder födde honom" <span class="c2">(återberättad av al-Bukhari och andra)</span>.<span class="c6"><br /> "Som den dag hans moder födde honom":</span> det vill säga syndfri. </p>',
            ],
            44 => [
                'question' => 'F45: Vad är \'Umrah?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5600.mp3',
                'answer' => '<p> S: \'Umrah innebär att man dyrkar Allah genom att besöka hans heliga hus <span class="c2">(Kaba)</span> för att utföra särskilda handlingar under en specifik tid. </p>',
            ],
            45 => [
                'question' => 'F46: Vilka är \'Umrahs pelare?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5630.mp3',
                'answer' => '<p> S: 1. Ihram <span class="c2">(att träda in det rituella tillståndet innan \'Umrah)</span>.<br /> 2. Att göra Tawaf <span class="c2">(cirkulera kring Kaba)</span>.<br /> 4. Att göra Sa\'y och gå mellan as-Safa wal-Marwah. </p>',
            ],
            46 => [
                'question' => 'F47: Vad innebär att kämpa för Allahs skull?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5690.mp3',
                'answer' => '<p> S: Det är att kämpa för att sprida och försvara islam och muslimer, eller att strida mot islams och muslimernas fiender.<span class="c6"><br /> Allah säger:</span> "Och kämpa med era tillgångar och era liv för Allahs sak. Detta är bäst för er - om ni bara visste" <span class="c2">(9:41)</span>. </p>',
            ],
        ],
        3 => [
            0 => [
                'question' => 'F1: Vad har vår profet Muhammed ﷺ för härkomst?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5740.mp3',
                'answer' => '<p> S: Han är Muhammed bin \'Abdillah bin \'Abdilmuttalib bin Hashim. Hashim kommer från Quraysh, Quraysh är araber, och araberna härstammar från Ismael son till Abraham <span class="c2">(må Allah hylla och sända frid över honom och över vår profet)</span>. </p>',
            ],
            1 => [
                'question' => 'F2: Vad heter vår profets ﷺ mamma?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5770.mp3',
                'answer' => '<p> S: Aminah bint Wahb. </p>',
            ],
            2 => [
                'question' => 'F3: När dog hans pappa?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5800.mp3',
                'answer' => '<p> S: Hans pappa dog i Medina innan han ﷺ föddes. </p>',
            ],
            3 => [
                'question' => 'F4: När föddes profeten ﷺ ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5830.mp3',
                'answer' => '<p> S: Han föddes i elefantåret på en måndag under den islamiska månaden Rabi\' al-Awwal. </p>',
            ],
            4 => [
                'question' => 'F5: Var föddes han?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5850.mp3',
                'answer' => '<p> S: I Mecka. </p>',
            ],
            5 => [
                'question' => 'F6: Vilka ammade och tog hand om honom utöver hans mamma?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5880.mp3',
                'answer' => '<p> S: - Umm Ayman, hans pappas tjänarinna.<br /> - Thuwaybah, hans farbror Abu Lahabs tjänarinna.<br /> - Halimah as-Sa\'diyyah. </p>',
            ],
            6 => [
                'question' => 'F7: När dog hans mamma?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5930.mp3',
                'answer' => '<p> S: Hans mamma dog när han var sex år, och då tog hans farfar \'Abdul-Muttalib hand om honom. </p>',
            ],
            7 => [
                'question' => 'F8: Vem tog hand om honom efter att hans farfar \'Abdul-Muttalib dött?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5960.mp3',
                'answer' => '<p> S: Hans farfar \'Abdul-Muttalib dog när profeten ﷺ var åtta år, varpå hans farbror Abu Talib tog hand om honom. </p>',
            ],
            8 => [
                'question' => 'F9: När reste han med sin farbror till Levanten?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5990.mp3',
                'answer' => '<p> S: Han reste med sin farbror till Levanten när han var tolv år. </p>',
            ],
            9 => [
                'question' => 'F10: När reste han efter det?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6020.mp3',
                'answer' => '<p> S: Efter det åkte han på en affärsresa med Khadijahs pengar. När han återvände gifte han sig med henne då han var 25 år gammal. </p>',
            ],
            10 => [
                'question' => 'F11: När återuppbyggde Quraysh Kaba?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6050.mp3',
                'answer' => '<p> S: Quraysh återuppbyggde Kaba när profeten ﷺ var 35 år.<br /> När Quraysh var oense om vem som skulle lägga tillbaka den svarta stenen till Kaba vände de sig till honom för att besluta. Han placerade stenen på ett tygstycke och sa åt de fyra stammarna att hålla varsin ände av det. När de lyfte stenen la han tillbaka den med sina egna händer. </p>',
            ],
            11 => [
                'question' => 'F12: Hur gammal var han när han blev profet och till vilka sändes han?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6080.mp3',
                'answer' => '<p> S: Han var 40 år, och sändes till hela mänskligheten för att ge dem ett glatt budskap om paradiset och varnade dem för helveteselden. </p>',
            ],
            12 => [
                'question' => 'F13: Hur började uppenbarelsen komma till honom?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6110.mp3',
                'answer' => '<p> S: Genom sanna drömmar. Han brukade inte ha någon dröm förutom att den inträffade precis som han såg den. </p>',
            ],
            13 => [
                'question' => 'F14: Vad brukade han göra innan han fick uppenbarelsen, och när började uppenbarelsen komma?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6140.mp3',
                'answer' => '<p> S: Han brukade dyrka Allah i Hira\'-grottan.<br /> Uppenbarelsen kom till honom då han var i grottan. </p>',
            ],
            14 => [
                'question' => 'F15: Vad var det första som uppenbarades från Koranen?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6180.mp3',
                'answer' => '<p> S: Det var verserna: "Läs i din Herres namn, som skapat - skapat människan av en blodklump. Läs! Din Herre är den Givmildaste, som har lärt <span class="c5">[hur man skriver]</span> med pennan, lärt människan vad hon inte visste" <span class="c2">(96:1-5)</span>. </p>',
            ],
            15 => [
                'question' => 'F16: Vem var den första som trodde på hans budskap?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6200.mp3',
                'answer' => '<p> S: Den första mannen som trodde på honom var Abu Bakr as-Siddiq. Den första kvinnan var Khadijah bin Khuwaylid. Det första barnet var \'Ali bin Abi Talib. Den första frisläppta slaven var Zayd bin Harithah. Den första slaven var Bilal al-Habashi <span class="c2">(må Allah vara nöjd med dem alla)</span>. </p>',
            ],
            16 => [
                'question' => 'F17: Hur spreds islams budskap?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6230.mp3',
                'answer' => '<p> S: Budskapet spreds till en början i hemlighet, och det fortsatte så i cirka tre år. Därefter blev profeten ﷺ beordrad att sprida budskapet och kalla till islam offentligt. </p>',
            ],
            17 => [
                'question' => 'F18: Hur var profetens ﷺ och hans anhängares tillstånd efter att de börjat kalla till islam offentligt?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6260.mp3',
                'answer' => '<p> S: Avgudadyrkarna började tortera honom ﷺ och muslimerna, och därför tilläts de troende att utvandra till kungen Negus i Abessinien.<br /> Avgudadyrkarna kom då överens om att mörda profeten ﷺ, men Allah skyddade honom och stöttade honom genom hans farbror Abu Talib som försvarade honom. </p>',
            ],
            18 => [
                'question' => 'F19: Vem dog under det tionde året efter profetskapets början?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6300.mp3',
                'answer' => '<p> S: Då dog hans farbror Abu Talib och hans hustru Khadijah <span class="c2">(må Allah vara nöjd med henne)</span>. </p>',
            ],
            19 => [
                'question' => 'F20: När inträffade al-Isra\' wal-Mi\'raj?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6330.mp3',
                'answer' => '<p> S: När han ﷺ var 50 år. I samband med denna resa föreskrevs de fem dagliga bönerna.<br /> Al-<span class="c6">Isra\':</span> Resan från al-Masjid al-Haram i Mecka till al-Aqsa-moskén i Jerusalem.<br /> Al-<span class="c6">Mi\'raj:</span> Resan från al-Aqsa-moskén till himlen och sedan till det yttersta lotusträdet <span class="c2">(som ligger ovanför de sju himlarna)</span>. </p>',
            ],
            20 => [
                'question' => 'F21: Hur brukade profeten ﷺ kalla människor utanför Mecka till islam?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6380.mp3',
                'answer' => '<p> S: Han brukade kalla Ta\'ifs invånare till islam genom att närvara och presentera sitt kall under stora folksamlingar och säsonger. När Medinas invånare, al-Ansar, kom trodde de på profeten ﷺ och lovade honom en trohetsed om att stödja honom. </p>',
            ],
            21 => [
                'question' => 'F22: Hur länge stannade profeten ﷺ i Mecka och kallade till islam?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6410.mp3',
                'answer' => '<p> S: Han stannade där under tretton år. </p>',
            ],
            22 => [
                'question' => 'F23: Vart utvandrade profeten ﷺ till?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6440.mp3',
                'answer' => '<p> S: Han utvandrade från Mecka till Medina. </p>',
            ],
            23 => [
                'question' => 'F24: Hur länge stannade han i Medina?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6470.mp3',
                'answer' => '<p> S: Tio år. </p>',
            ],
            24 => [
                'question' => 'F25: Vilka islamiska påbud föreskrevs i Medina?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6490.mp3',
                'answer' => '<p> S: Allmosan, fastan, pilgrimsfärden, att kämpa för Allahs skull, böneutropet och flera andra påbud. </p>',
            ],
            25 => [
                'question' => 'F26: Vilka är hans ﷺ viktigaste strider?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6520.mp3',
                'answer' => '<p> S: Det stora slaget vid Badr.<br /> - Slaget vid Uhud.<br /> - al-Ahzab slaget.<br /> - Slaget då Mecka erövrades. </p>',
            ],
            26 => [
                'question' => 'F27: Vad var det sista som uppenbarades för honom från Koranen?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6580.mp3',
                'answer' => '<p> S: Det var versen: "Och frukta dagen då ni ska föras åter till Allah. Då kommer varje själ få sin lön för vad den gjort, och ingen ska bli orättvist behandlad" <span class="c2">(2:281)</span>. </p>',
            ],
            27 => [
                'question' => 'F28: När dog profeten ﷺ och hur gammal var han då?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6610.mp3',
                'answer' => '<p> S: Han dog i den islamiska månaden Rabi\' al-Awwal år 11, och var 63 år gammal. </p>',
            ],
            28 => [
                'question' => 'F29: Vilka var profetens fruar?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6640.mp3',
                'answer' => '<p> S: 1. Khadijah bint Khuwaylid <span class="c2">(må Allah vara nöjd med henne)</span>.<br /> 2. Sawdah bint Zam\'ah <span class="c2">(må Allah vara nöjd med henne)</span>.<br /> 3. \'A\'ishah bint Abi Bakr as-Siddiq <span class="c2">(må Allah vara nöjd med henne)</span>.<br /> 4. Hafsah bint \'Umar <span class="c2">(må Allah vara nöjd med henne)</span>.<br /> 5. Zaynab bint Khuzaymah <span class="c2">(må Allah vara nöjd med henne)</span>.<br /> 6. Umm Salamah Hind bint Abi Umayyah <span class="c2">(må Allah vara nöjd med henne)</span>.<br /> 7. Umm Habibah Ramlah bint Abi Sufyan <span class="c2">(må Allah vara nöjd med henne)</span>.<br /> 8. Juwayriyah bint al-Harith <span class="c2">(må Allah vara nöjd med henne)</span>.<br /> 9. Maymunah bint al-Harith <span class="c2">(må Allah vara nöjd med henne)</span>.<br /> 10. Safiyyah bint Huyayy <span class="c2">(må Allah vara nöjd med henne)</span>.<br /> 11. Zaynab bint Jahsh <span class="c2">(må Allah vara nöjd med henne)</span>. </p>',
            ],
            29 => [
                'question' => 'F30: Vilka var hans barn?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6760.mp3',
                'answer' => '<p> S: Han hade tre söner:<br /> Al-Qasim, och profeten ﷺ kallades därför Abul-Qasim.<br /> Abdullah.<br /> Ibrahim.<span class="c6"><br /> Hans döttrar var:</span><br /> Fatimah.<br /> Ruqayyah.<br /> Umm Kalthum.<br /> Zaynab.<br /> Khadijah <span class="c2">(må Allah vara nöjd med henne)</span> var mamman till alla hans barn förutom Ibrahim. De alla dog innan honom, förutom Fatimah, hon dog sex månader efter honom. </p>',
            ],
            30 => [
                'question' => 'F31: Hur såg profeten ﷺ ut?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6880.mp3',
                'answer' => '<p> S: Han var medellång, varken kort eller lång. Hans hudfärg var ljus med röda inslag. Han hade tjockt hår, vida ögon och bred mun. Hans hårfärg var kolsvart, han var bredaxlad, hade en ljuvlig doft och ett vackert utseende. </p>',
            ],
            31 => [
                'question' => 'F31: Vad lämnade profeten ﷺ sitt samfund på för väg?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6910.mp3',
                'answer' => '<p> S: Han lämnade dem på en tydlig väg, dess natt är lika tydlig som dess dag, ingen avviker från den förutom att den går under. Det fanns inget gott som han inte uppmanade sitt samfund till, och inget dåligt som han inte varnade sitt samfund från. </p>',
            ],
        ],
        4 => [
            0 => [
                'question' => 'F1: Läs suratul-Fatihah och förklara den?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6960.mp3',
                'answer' => '<p> S: Suratul-<span class="c6">Fatihah och dess förklaring:</span><br /> "I Allahs namn, den Nåderike, den Barmhärtige. All lovprisning tillkommer Allah, världarnas Herre, den Nåderike, den Barmhärtige, Domedagens Ägare. Endast dig dyrkar vi och endast dig ber vi om hjälp. Led oss på den raka vägen! Den väg som de du har välsignat följde; inte de som har drabbats av <span class="c5">[din]</span> vrede och inte heller de vilsna" <span class="c2">(1-7)</span>.<span class="c6"><br /> Förklaring:</span><br /> Den kallas för Suratul-Fatihah <span class="c2">(Inledningskapitlet)</span> eftersom Allahs bok börjar med den.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001001.mp3"></audio> 1. "I Allahs namn, den Nåderike,<span class="c6"> den Barmhärtige":</span> Jag börjar läsa Koranen i Allahs namn, jag söker hans hjälp och välsignelse genom det.<span class="c6"><br /> "Allah":</span> Den som dyrkas i sanning. Endast han heter det.<span class="c6"><br /> "Den Nåderike":</span> Den som har en omfattande barmhärtighet som når allt.<span class="c6"><br /> "Den Barmhärtige":</span> Den som visar de troende nåd.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001002.mp3"></audio> 2. "All lovprisning tillkommer Allah,<span class="c6"> världarnas Herre":</span> Alla former av lovprisningar och perfektion tillkommer endast Allah.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001003.mp3"></audio> 3. "Den Nåderike,<span class="c6"> den Barmhärtige":</span> Den som har en omfattande barmhärtighet som når allt, den vars barmhärtighet når de troende.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001004.mp3"></audio> 4.<span class="c6"> "Domedagens Ägare":</span> den yttersta dagen.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001005.mp3"></audio> 5.<span class="c6"> "Endast dig dyrkar vi och endast dig ber vi om hjälp":</span> Det är dig vi dyrkar och ingen annan, det är dig vi söker hjälp från och ingen annan.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001006.mp3"></audio> 6.<span class="c6"> "Led oss på den raka vägen!":</span> Att vägledas till islam och Sunnah.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001007.mp3"></audio> 7. "Den väg som de du har välsignat följde; inte de som har drabbats av <span class="c5">[din]</span> vrede och inte heller de vilsna": Vägen av Allahs rättfärdiga tjänare som profeterna och dem som följer dem följer, inte de kristnas och judarnas väg.<br /> - Det är rekommenderat att säga "Amin" <span class="c2">(Besvara oss!)</span> efter läsningen av Suratul-Fatihah. </p>',
            ],
            1 => [
                'question' => 'F2: Läs Suratuz-Zalzalah och förklara den?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7130.mp3',
                'answer' => '<p> S: Suratuz-<span class="c6">Zalzalah och dess förklaring:</span><br /> "I Allahs namn, den Nåderike, den Barmhärtige.<br /> "När jorden skälver i sitt <span class="c5">[sista]</span> skalv, och jorden kastar upp sina bördor,<span class="c6"> och människan säger:</span> \'Vad är det med den?\'. Den dagen ska den berätta vad som skett på den, för så har din Herre ingett den. Den dagen ska människorna stiga fram i skilda skaror för att få se sina gärningar. Ja, den som gör den minsta myras vikt av gott ska se det, Och den som gör den minsta myras vikt av ont skall se det" <span class="c2">(99:1-8)</span>.<span class="c6"><br /> Förklaring:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099001.mp3"></audio> 1. "När jorden skälver i sitt <span class="c5">[sista]</span> skalv": När jorden skakas kraftigt vilket kommer att ske på domedagen.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099002.mp3"></audio> 2.<span class="c6"> "Och jorden kastar upp sina bördor":</span> När jorden tar ut allt som finns i den som de döda och annat.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099003.mp3"></audio> 3.<span class="c6"> "Och människan säger:</span> \'Vad är det med den?\': Människan kommer förvirrat att fråga varför jorden rör på sig och skakar?!<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099004.mp3"></audio> 4.<span class="c6"> "Den dagen ska den berätta vad som skett på den":</span> Under denna väldiga dag kommer jorden att berätta vilka goda och dåliga handlingar som begåtts på den.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099005.mp3"></audio> 5.<span class="c6"> "För så har din Herre ingett den":</span> Eftersom Allah underrättat den om det och befallt den att berätta.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099006.mp3"></audio> 6.<span class="c6"> "Den dagen ska människorna stiga fram i skilda skaror för att få se sina gärningar":</span> Under denna väldiga dag som jorden kommer att skaka på kommer människor att stiga fram i skaror för räkenskap så att de kan vittna om de handlingar de begått i det tidigare livet.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099007.mp3"></audio> 7. "Ja,<span class="c6"> den som gör den minsta myras vikt av gott ska se det":</span> Han kommer att se sina goda handlingar framför sig, även om de väger så lite som en liten myra.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099008.mp3"></audio> 8.<span class="c6"> "Och den som gör den minsta myras vikt av ont skall se det":</span> Den som gör onda handlingar, även om det vore så lite som en myras vikt, kommer även att få se det framför sig. </p>',
            ],
            2 => [
                'question' => 'F3: Läs Suratul-\'Adiyat och förklara den?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7270.mp3',
                'answer' => '<p> S: Suratul-<span class="c6">\'Adiyat och dess förklaring:</span><br /> "I Allahs namn, den Nåderike, den Barmhärtige.<br /> Vid de galopperande hästarna som frustar, och skapar gnistar, då de rids till anfall på morgonen, och virvlar upp moln av damm, och stormar rakt in i fiendeskaran! Människan är sannerligen djupt otacksam mot sin Herre. Och om detta är hon ju själv ett vittne. Och i sin kärlek till rikedom är hon förvisso ivrig. Inser hon inte, när gravarnas innehåll slungas ut, och allt som dolts i bröstet visas upp, att deras Herre den dagen säkerligen är underrättad om dem?" <span class="c2">(100:1-11)</span>.<span class="c6"><br /> Förklaring:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100001.mp3"></audio> 1.<span class="c6"> "Vid de galopperande hästarna som frustar":</span> Allah svär vid hästen som galopperar så snabbt att den flåsar ljudligt.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100002.mp3"></audio> 2.<span class="c6"> "Och skapar gnistar":</span> Han svor även vid de galopperande hästarna, som skapar gnistor med sina hovar då de slår till stenarna med full kraft.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100003.mp3"></audio> 3.<span class="c6"> "Då de rids till anfall på morgonen":</span> Han svor också vid de hästar som attackerar fienden i gryningen.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100004.mp3"></audio> 4.<span class="c6"> "Och virvlar upp moln av damm":</span> Eftersom de rör sig så snabbt.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100005.mp3"></audio> 5.<span class="c6"> "Och stormar rakt in i fiendeskaran!":</span> Ryttarna för hästarna stormar rakt in i fiendeskaran.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100006.mp3"></audio> 6.<span class="c6"> "Människan är sannerligen djupt otacksam mot sin Herre":</span> Hon håller girigt fast vid det hennes Herre befallt henne att spendera från.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100007.mp3"></audio> 7.<span class="c6"> "Och om detta är hon ju själv ett vittne":</span> Hon själv vittnar om hur hon håller tillbaka det goda hon givits, och hon kan inte förneka det eftersom det är uppenbart.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100008.mp3"></audio> 8.<span class="c6"> "Och i sin kärlek till rikedom är hon förvisso ivrig":</span> På grund av hennes extrema kärlek till pengar vägrar hon att dela med sig av rikedomen.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100009.mp3"></audio> 9. "Inser hon inte,<span class="c6"> när gravarnas innehåll slungas ut":</span> Vet inte denna människa, som förblindats av detta världsliga liv, att när Allah tar ut de döda från gravarna i jorden för räkenskap och vedergällning - att saker inte kommer att vara som hon inbillat sig?<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100010.mp3"></audio> 10.<span class="c6"> "Och allt som dolts i bröstet visas upp":</span> Det som funnits i hjärtat av avsikter, trosuppfattningar och annat kommer att exponeras.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100011.mp3"></audio> 11.<span class="c6"> "Att deras Herre den dagen säkerligen är underrättad om dem?":</span> Den dagen är deras Herre fullt underrättad om dem. Hans tjänares angelägenheter kommer inte att vara dolda för honom, och han kommer att vedergälla dem för vad de gjort. </p>',
            ],
            3 => [
                'question' => 'F4: Läs Suratul-Qari\'ah och förklara den?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7450.mp3',
                'answer' => '<p> S: Suratul-<span class="c6">Qari\'ah och dess förklaring:</span><br /> "I Allahs namn, den Nåderike, den Barmhärtige.<br /> Det väldiga slaget! Vad är det väldiga slaget? Och vad kan få dig att inse vad det väldiga slaget är? <span class="c5">[Det är]</span> den dag då människorna ska bli som kringspridda nattfly, och bergen ska bli som kardad ull. Den som då har en tung vågskål, han ska leva ett lycksaligt liv. Men den som då har en lätt vågskål, hans tillflykt blir avgrunden. Och vad kan få dig att inse vad den är? En het eld" <span class="c2">(101:1-11)</span>.<span class="c6"><br /> Förklaring:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101001.mp3"></audio> 1.<span class="c6"> "Det väldiga slaget!":</span> Stunden som kommer att paralysera människors hjärtan av extrem rädsla.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101002.mp3"></audio> 2.<span class="c6"> "Vad är det väldiga slaget?":</span> Vad är då denna stund som kommer att paralysera människors hjärtan av extrem rädsla?!<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101003.mp3"></audio> 3.<span class="c6"> "Och vad kan få dig att inse vad det väldiga slaget är?":</span> Hur ska du, sändebudet, veta vad denna stund är som paralyserar människors hjärtan? Stunden syftar på domedagen.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101004.mp3"></audio> 4. <span class="c5">[Det är]</span> den dag då människorna ska bli som kringspridda nattflyn": Den dag då människors hjärtan paralyseras blir de som utspridda nattfly som flyger omkring.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101005.mp3"></audio> 5.<span class="c6"> "Och bergen ska bli som kardad ull":</span> Bergen blir som kardad ull och bomull eftersom de så lätt förflyttar och rör på sig.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101006.mp3"></audio> 6.<span class="c6"> "Den som då har en tung vågskål":</span> Den vars goda handlingar överväger de dåliga handlingarna.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101007.mp3"></audio> 7.<span class="c6"> "Han ska leva ett lyckligt liv":</span> Han kommer att njuta av ett härligt liv i paradiset.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101008.mp3"></audio> 8.<span class="c6"> "Men den som då har en lätt vågskål":</span> Den vars dåliga handlingar överväger de bra handlingarna.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101009.mp3"></audio> 9.<span class="c6"> "Hans tillflykt blir avgrunden":</span> Hans vistelse och plats kommer att vara helvetet på domedagen.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101010.mp3"></audio> 10.<span class="c6"> "Och vad kan få dig att inse vad den är?":</span> Hur ska du, sändebudet, veta vad det är?<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101011.mp3"></audio> 11.<span class="c6"> "En het eld":</span> En flammande och brännande eld. </p>',
            ],
            4 => [
                'question' => 'F5: Läs Suratut-Takathur och förklara den?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7610.mp3',
                'answer' => '<p> S: Suratut-<span class="c6">Takathur och dess förklaring:</span><br /> "I Allahs namn, den Nåderike, den Barmhärtige.<br /> Ni distraheras av er tävlan i rikedom, ända tills ni besöker era gravar. Nej! Ni ska få veta. Igen, nej! Ni ska få veta. Nej! Om ni bara visste med övertygande kunskap, ni ska sannerligen få skåda den djupa elden. Igen, ni ska sannerligen få skåda den med ögats visshet. Sedan ska ni säkerligen tillfrågas, den dagen, om er välmåga" <span class="c2">(102:1-8)</span>.<span class="c6"><br /> Förklaring:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102001.mp3"></audio> 1.<span class="c6"> "Ni distraheras av er tävlan i rikedom":</span> Människor! Ert skrytande om egendomar och barn distraherar er från att lyda Allah.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102002.mp3"></audio> 2.<span class="c6"> "Ända tills ni besöker era gravar":</span> Tills ni dör och träder in i era gravar.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102003.mp3"></audio> 3.<span class="c6"> "Nej! Ni ska få veta":</span> Att ni inte borde ha distraherats av ert skryt och försummat lydnaden till Allah. Då kommer ni att veta konsekvenserna av denna distraktion.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102004.mp3"></audio> 4. "Igen,<span class="c6"> nej! Ni ska få veta":</span> Då ska ni inse konsekvensen av det.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102005.mp3"></audio> 5.<span class="c6"> "Nej! Om ni bara visste med övertygande kunskap":</span> Om ni var övertygade om att ni ska återföras till Allah och att han ska vedergälla er för era handlingar skulle ni inte distraherats av att skryta om egendomar och barn.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102006.mp3"></audio> 6.<span class="c6"> "Ni ska sannerligen få skåda den djupa elden":</span> Vid Allah! Ni ska få se helvetet på domedagen.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102007.mp3"></audio> 7. "Igen,<span class="c6"> ni ska sannerligen få skåda den med ögats visshet":</span> Ni kommer att se den med full övertygelse.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102008.mp3"></audio> 8. "Sedan ska ni säkerligen tillfrågas, den dagen,<span class="c6"> om ert välstånd":</span> På den dagen kommer Allah att fråga er om de välsignelser han skänkt er, som hälsa, förmögenhet och annat. </p>',
            ],
            5 => [
                'question' => 'F6: Läs Suratul-\'Asr och förklara den?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7750.mp3',
                'answer' => '<p> S: Suratul-<span class="c6">\'Asr och dess förklaring:</span><br /> "I Allahs namn, den Nåderike, den Barmhärtige.<br /> Vid tiden! Människan är sannerligen förlorad. Utom de som tror och gör goda gärningar och uppmanar varandra att hålla fast vid sanningen och uppmanar varandra att ha tålamod" <span class="c2">(103:1-3)</span>.<span class="c6"><br /> Förklaring:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/103001.mp3"></audio> 1.<span class="c6"> "VId tiden!":</span> Allah svär vid tiden.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/103002.mp3"></audio> 2.<span class="c6"> "Människan är sannerligen förlorad":</span> Varje människa är bristfällig och förlorad.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/103003.mp3"></audio> 3.<span class="c6"> "Utom de som tror och gör goda gärningar och uppmanar varandra att hålla fast vid sanningen och uppmanar varandra att ha tålamod":</span> Förutom de som tror och gör goda handlingar samt kallar till sanningen och har tålamod med det. Det är dessa som är de framgångsrika och räddade. </p>',
            ],
            6 => [
                'question' => 'F7: Läs Suratul-Humazah och förklara den?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7830.mp3',
                'answer' => '<p> S: Suratul-<span class="c6">Humazah och dess förklaring:</span><br /> "I Allahs namn, den Nåderike, den Barmhärtige.<br /> "Ett hårt straff ska möta varje baktalare och felfinnare, som samlar rikedomar och håller räkning på dem. Han tror att hans rikedomar ska ge honom evigt liv. Nej! Han kommer att slängas i krossaren. Och vad kan få dig att inse vad krossaren är? Allahs tända eld, som tränger in i <span class="c5">[dess invånares hjärtan]</span>. Den ska sannerligen vara sluten kring dem, bland uttänjda pelare" <span class="c2">(104:1-9)</span>.<span class="c6"><br /> Förklaring:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104001.mp3"></audio> 1.<span class="c6"> "Ett hårt straff ska möta varje baktalare och felfinnare":</span> Fördärv och ett strängt straff väntar den som ständigt baktalar och förtalar andra.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104002.mp3"></audio> 2.<span class="c6"> "Som samlar rikedomar och håller räkning på dem":</span> Den vars intresse endast kretsar kring att samla pengar och räkna dem.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104003.mp3"></audio> 3.<span class="c6"> "Han tror att hans rikedomar ska ge honom evigt liv":</span> Han tror att pengarna han samlat ihop kommer att skydda honom från döden, så att han alltså kan vara kvar i detta liv för evigt.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104004.mp3"></audio> 4.<span class="c6"> "Nej! Han kommer att slängas i krossaren":</span> Det är inte som denna okunniga person föreställt sig. Han kommer istället att kastas i helvetet, som kommer att krossa honom fullständigt.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104005.mp3"></audio> 5.<span class="c6"> "Och vad kan få dig att inse vad krossaren är?":</span> Vad ska få dig, sändebudet, att veta vad elden är som krossar allt som slängs i den?<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104006.mp3"></audio> 6.<span class="c6"> "Allahs tända eld":</span> Det är elden som Allah har tänt.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104007.mp3"></audio> 7. "Som tränger in i <span class="c5">[dess invånares hjärtan]</span>": Den som penetrerar människors kroppar tills den når deras hjärtan.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104008.mp3"></audio> 8.<span class="c6"> "Den ska sannerligen vara sluten kring dem":</span> Den ska omsluta och stänga in de som straffas i den.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104009.mp3"></audio> 9.<span class="c6"> "Bland uttänjda pelare":</span> Den är sluten och låst med långa pelare så att ingen kan fly från den. </p>',
            ],
            7 => [
                'question' => 'F8: Läs Suratul-Fil och förklara den?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7970.mp3',
                'answer' => '<p> S: Suratul-<span class="c6">Fil och dess förklaring:</span><br /> "I Allahs namn, den Nåderike, den Barmhärtige.<br /> Har du inte fått veta hur din Herre gjorde med elefantens män? Lät han inte deras onda plan gå i stöpet? Han sände fåglar i svärmar över dem. Som överöste dem med stenar av hård lera. Sedan lät han dem bli som <span class="c5">[rester av]</span> uppäten säd" <span class="c2">(105:1-5)</span>.<span class="c6"><br /> Förklaring:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105001.mp3"></audio> 1.<span class="c6"> "Har du inte fått veta hur din Herre gjorde med elefantens män?":</span> Vet du, sändebudet, inte vad din Herre gjorde med Abraha och hans följeslagare, elefantens män, när de ville förstöra Kaba?<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105002.mp3"></audio> 2.<span class="c6"> "Lät han inte deras onda plan gå i stöpet?":</span> Allah förstörde deras onda planer så de kunde inte uppnå sin önskan att avleda människor från Kaba.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105003.mp3"></audio> 3.<span class="c6"> "Han sände fåglar i svärmar över dem":</span> Han skickade en stor mängd fåglar, som kom till dem.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105004.mp3"></audio> 4.<span class="c6"> "Som överöste dem med stenar av hård lera:</span>" De släppte stenar av hård lera över dem.<span class="c6"><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105005.mp3"></audio> 5:</span> "Sedan lät han dem bli som <span class="c5">[rester av]</span> uppäten säd": Så Allah gjorde de till likt löv som djur har ätit från och trampat på. </p>',
            ],
            8 => [
                'question' => 'F9: Läs Surat Quraysh och förklara den?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8070.mp3',
                'answer' => '<p> S: Surat Quraysh och dess förklaring:<br /> "I Allahs namn, den Nåderike, den Barmhärtige.<br /> Hur förvånande är inte sedvanan hos Quraysh! Deras sedvana är att färdas under vinter och sommar. Låt dem därför endast dyrka Herren till detta hus <span class="c2">(Kaba)</span>, han som ger dem föda i tider av hunger och gör dem trygga från fara" <span class="c2">(106:1-4)</span>.<span class="c6"><br /> Förklaring:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106001.mp3"></audio> 1.<span class="c6"> "Hur förvånande är inte sedvanan hos Quraysh!":</span> Detta syftar på deras välbekanta resor under vinter och sommar.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106002.mp3"></audio> 2.<span class="c6"> "Deras sedvana är att färdas under vinter och sommar":</span> De reste tryggt till Jemen under vintern, och till Levanten under sommaren.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106003.mp3"></audio> 3. "Låt dem därför endast dyrka Herren till detta hus <span class="c2">(Kaba)</span>:" Därför ska de enbart dyrka Herren till detta heliga hus eftersom det är han som har underlättat för dem att bege sig på dessa resor.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106004.mp3"></audio> 4.<span class="c6"> "Han som ger dem föda i tider av hunger och gör dem trygga från fara":</span> Genom det gjorde han att araberna respekterade Meckas helighet och dess invånare. </p>',
            ],
            9 => [
                'question' => 'F10: Läs Suratul-Ma\'un och förklara den?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8160.mp3',
                'answer' => '<p> S: Suratul-<span class="c6">Ma\'un och dess förklaring:</span><br /> "I Allahs namn, den Nåderike, den Barmhärtige.<br /> Har du sett han som vägrar tro på domen? För det är han som stöter bort den faderlöse, och inte uppmanar att ge mat till den behövande. Ett hårt straff ska möta dem som förrättar bönen, dem som är slarviga med sina böner. Dem som bara vill ses av andra, och som vägrar <span class="c5">[andra]</span> den minsta hjälp" <span class="c2">(107:1-7)</span>.<span class="c6"><br /> Förklaring:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107001.mp3"></audio> 1.<span class="c6"> "Har du sett han som vägrar tro på domen?":</span> Känner du till den som förnekar vedergällningen på domedagen?<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107002.mp3"></audio> 2.<span class="c6"> "För det är han som stöter bort den faderlöse":</span> Han är den som onådigt stöter bort den behövande faderlöse.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107003.mp3"></audio> 3.<span class="c6"> "Och inte uppmanar att ge mat till den behövande":</span> Han uppmanar varken sig själv eller andra att ge mat till den behövande.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107004.mp3"></audio> 4.<span class="c6"> "Ett hårt straff ska möta dem som förrättar bönen":</span> De bedjande ska få straff och lidande.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107005.mp3"></audio> 5.<span class="c6"> "Dem som är slarviga med sina böner":</span> De bedjande som struntar i sina böner tills tiden för bönen har gått ut.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107006.mp3"></audio> 6.<span class="c6"> "Dem som bara vill ses av andra":</span> De som ber och gör goda handlingar för ögontjäneri, och inte gör dem uppriktigt för Allahs skull.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107007.mp3"></audio> 7. "Och som vägrar <span class="c5">[andra]</span> den minsta hjälp": Som nekar andra hjälp fastän det inte är svårt att hjälpa dem. </p>',
            ],
            10 => [
                'question' => 'F11: Läs Suratul-Kawthar och förklara den?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8280.mp3',
                'answer' => '<p> S: Suratul-<span class="c6">Kawthar och dess förklaring:</span><br /> "I Allahs namn, den Nåderike, den Barmhärtige.<br /> Vi har sannerligen gett dig det rikliga goda. Be därför till din Herre och slakta. Det är han som hatar dig, som är den avskurne" <span class="c2">(108:1-3)</span>.<span class="c6"><br /> Förklaring:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/108001.mp3"></audio> 1.<span class="c6"> "Vi har sannerligen gett dig det rikliga goda":</span> Vi har säkerligen gett dig, sändebudet, ofantlig godhet. Från denna godhet är floden al-Kawthar i paradiset.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/108002.mp3"></audio> 2.<span class="c6"> "Be därför till din Herre och slakta":</span> Var därför tacksam till Allah för denna välsignelse genom att endast be till honom och slakta. Detta står i kontrast till vad avgudadyrkarna gör när de närmar sig sina avgudar genom att offra och slakta till dem.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/108003.mp3"></audio> 3. "Det är han som hatar dig,<span class="c6"> som är den avskurne":</span> Den som avskyr dig, som är berövad all godhet och kommer antingen att glömmas bort eller minnas negativt. </p>',
            ],
            11 => [
                'question' => 'F12: Läs Suratul-Kafirun och förklara den?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8360.mp3',
                'answer' => '<p> S: Suratul-<span class="c6">Kafirun och dess förklaring:</span><br /> "I Allahs namn, den Nåderike, den Barmhärtige.<span class="c6"><br /> Säg:</span> \'Ni otrogna! Jag dyrkar inte det ni dyrkar. Och inte heller dyrkar ni den jag dyrkar. Och jag kommer aldrig att dyrka det ni har dyrkat. Och inte heller kommer ni att dyrka den jag dyrkar. Ni har er religion och jag har min religion\'" <span class="c2">(109:1-6)</span>.<span class="c6"><br /> Förklaring:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109001.mp3"></audio> 1.<span class="c6"> "Säg:</span> \'Ni otrogna!\'": Sändebudet! Säg "Ni som inte har sann tro på Allah."<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109002.mp3"></audio> 2.<span class="c6"> "Jag dyrkar inte det ni dyrkar":</span> Jag dyrkar varken nu eller i framtiden de avgudar ni dyrkar.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109003.mp3"></audio> 3.<span class="c6"> "Och inte heller dyrkar ni den jag dyrkar":</span> Ni dyrkar inte heller den jag dyrkar, vilken är Allah enbart.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109004.mp3"></audio> 4.<span class="c6"> "Och jag kommer aldrig att dyrka det ni har dyrkat":</span> Inte heller dyrkar jag de avgudar ni dyrkar.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109005.mp3"></audio> 5.<span class="c6"> "Och inte heller kommer ni att dyrka den jag dyrkar":</span> Ni dyrkar inte heller den jag dyrkar, vilken är Allah enbart.<span class="c6"><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109006.mp3"></audio> 6:</span> "Ni har er religion och jag har min religion": Ni har er påhittade religion, och jag har min religion, som Allah har uppenbarat för mig. </p>',
            ],
            12 => [
                'question' => 'F13: Läs Suratun-Nasr och förklara den?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8470.mp3',
                'answer' => '<p> S: Suratun-<span class="c6">nasr och dess förklaring:</span><br /> "I Allahs namn, den Nåderike, den Barmhärtige.<br /> När Allahs hjälp kommer tillsammans med segern, och du ser människorna övergå till Allahs religion i mängder. Glorifiera då din Herre med lovprisningar och be honom om förlåtelse. Han godtar alltid <span class="c5">[den ångerfulles]</span> ånger" <span class="c2">(110:1-3)</span>.<span class="c6"><br /> Förklaring:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/110001.mp3"></audio> 1.<span class="c6"> "När Allahs hjälp kommer tillsammans med segern":</span> När Allah ger seger och stöd till din, sändebudets, religion och när Mecka erövras.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/110002.mp3"></audio> 2.<span class="c6"> "Och du ser människorna övergå till Allahs religion i mängder":</span> Och du ser människor konvertera till islam flera delegationer efter varandra.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/110003.mp3"></audio> 3. "Glorifiera då din Herre med lovprisningar och be honom om förlåtelse. Han godtar alltid <span class="c5">[den ångerfulles]</span> ånger": Då ska du veta att detta är ett tecken på att ditt uppdrag håller på att nå sitt slut. Därför ska du glorifiera din Herre med lovprisningar av tacksamhet för segern och erövringen. Sök även hans förlåtelse eftersom han alltid godtar sina tjänares ånger och han förlåter dem. </p>',
            ],
            13 => [
                'question' => 'F14: Läs Suratul-Masad och förklara den?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8550.mp3',
                'answer' => '<p> S: Suratul-<span class="c6">Masad och dess förklaring:</span><br /> "I Allahs namn, den Nåderike, den Barmhärtige.<br /> Må Abu Lahabs båda händer förstöras, ja hela han är förstörd! Han kan inte gagnas av sin rikedom och allt han förvärvat. Han ska brinna i en eld med blossande lågor. Och <span class="c5">[likaså]</span> hans hustru, som ständigt bär på ved. Runt sin hals har hon ett tvinnat rep" <span class="c2">(111:1-5)</span>.<span class="c6"><br /> Förklaring:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111001.mp3"></audio> 1. "Må Abu Lahabs båda händer förstöras,<span class="c6"> ja hela han är förstörd!":</span> Må profetens ﷺ farbror Abu Lahab \'Abdul-Mutallibs händer förstöras likt hans handlingar förstörts! Anledningen till detta var att han brukade sträva efter att skada profeten ﷺ, men hans strävan var förgäves.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111002.mp3"></audio> 2. "Han kan inte gagnas av sin rikedom och allt han förvärvat.<span class="c6">":</span> Hur ska hans egendom och barn gynna honom? De kunde inte ens avvärja något straff från honom, eller lyckas medföra någon barmhärtighet.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111003.mp3"></audio> 3. "Han ska brinna i en eld med blossande lågor.<span class="c6">":</span> På domedagen kommer Abu Lahab att träda in i helvetet och plågas av dess svidande hetta.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111004.mp3"></audio> 4. "Och <span class="c5">[likaså]</span> hans hustru,<span class="c6"> som ständigt bär på ved":</span> Även hans hustru, Umm Jamil, ska träda in i helveteselden då hon också brukade skada profeten ﷺ. Hon brukade lägga taggar på den väg han gick på.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111005.mp3"></audio> 5.<span class="c6"> Runt sin hals har hon ett tvinnat rep":</span> Hon kommer att föras till helvetet med ett åtstramat rep runt halsen. </p>',
            ],
            14 => [
                'question' => 'F15: Läs Suratul-Ikhlas och förklara den?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8650.mp3',
                'answer' => '<p> S: Suratul-<span class="c6">Ikhlas och dess förklaring:</span><br /> "I Allahs namn, den Nåderike, den Barmhärtige.<span class="c6"><br /> Säg:</span> \'Han är Allah, <span class="c5">[och han är]</span> En. Allah är den Suveräne. Han har inte avlat, och inte heller är han avlad, och det finns ingen som är lik honom\'" <span class="c2">(111:1-4)</span>.<span class="c6"><br /> Förklaring:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112001.mp3"></audio> 1.<span class="c6"> "Säg:</span> \'Han är Allah, <span class="c5">[och han är]</span> En": Sändebudet! Säg att det inte finns någon sann gud utom Allah.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112002.mp3"></audio> 2.<span class="c6"> "Allah är den Suveräne":</span> Den som skapelsen vänder sig till för sina behov.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112003.mp3"></audio> 3. "Han har inte avlat,<span class="c6"> och inte heller är han avlad":</span> Därför har han varken någon son eller far.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112004.mp3"></audio> 4.<span class="c6"> "Och det finns ingen som är lik honom":</span> Ingen skapelse liknar honom. </p>',
            ],
            15 => [
                'question' => 'F16: Läs Suratul-Falaq och förklara den?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8750.mp3',
                'answer' => '<p> S: Suratul-<span class="c6">Falaq och dess förklaring:</span><br /> "I Allahs namn, den Nåderike, den Barmhärtige.<span class="c6"><br /> Säg:</span> \'Jag tar skydd hos dagbräckningens Herre, mot ondskan hos det han skapat, och mot ondskan hos den mörknande <span class="c5">[natten]</span> när den faller på, och mot ondskan hos dem som blåser på knutar, och mot ondskan hos den avundsamme när han avundas\'" <span class="c2">(113:1-5)</span>.<span class="c6"><br /> Förklaring:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113001.mp3"></audio> 1.<span class="c6"> "Säg:</span> \'Jag tar skydd hos dagbräckningens Herre\'": Sändebudet! Säg att du håller fast vid och söker skydd hos morgonens Herre.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113002.mp3"></audio> 2.<span class="c6"> "Mot ondskan hos det han skapat":</span> Mot det onda som finns i skadliga skapelser.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113003.mp3"></audio> 3. "Och mot ondskan hos den mörknande <span class="c5">[natten]</span> när den faller på": Jag söker även Allahs skydd mot det onda som dyker upp under natten, som djur och tjuvar.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113004.mp3"></audio> 4.<span class="c6"> "Och mot ondskan hos dem som blåser på knutar":</span> Jag söker även hans skydd mot magikernas ondska, de som blåser i knutar.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113005.mp3"></audio> 5.<span class="c6"> "Och mot ondskan hos den avundsamme när han avundas":</span> Och mot den avundsammes ondska, han som hatar att se att Allah skänker andra människor välsignelser. Han vill därför att dessa välsignelser ska upphöra och skadar andra avsiktligt. </p>',
            ],
            16 => [
                'question' => 'F17: Läs Suratun-Nas och dess förklaring?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8870.mp3',
                'answer' => '<p> S: Suratun-<span class="c6">Nas och dess förklaring:</span><br /> "I Allahs namn, den Nåderike, den Barmhärtige.<span class="c6"><br /> Säg:</span> \'Jag tar skydd hos människornas Herre, människornas Konung, människornas Gud, mot den viskande smitarens ondska. Han som viskar i människornas bröst, bland <span class="c5">[både]</span> jinnerna och människorna\'" <span class="c2">(114:1-6)</span>.<span class="c6"><br /> Förklaring:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114001.mp3"></audio> 1.<span class="c6"> "Säg:</span> \'Jag tar skydd hos människornas Herre\'": Sändebudet! Säg att du håller fast vid och söker skydd hos människornas Herre.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114002.mp3"></audio> 2.<span class="c6"> "Människornas Konung":</span> Han styr dem som han vill och det är endast han som äger dem alla.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114003.mp3"></audio> 3.<span class="c6"> "Människornas Gud":</span> Deras sanna gud, ingen förtjänar att dyrkas förutom han.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114004.mp3"></audio> 4.<span class="c6"> "Mot den viskande smitarens ondska":</span> Mot Satans ondska, de som viskar och uppmuntrar människor till synd.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114005.mp3"></audio> 5.<span class="c6"> "Han som viskar i människornas bröst":</span> Han som viskar i människors hjärtan.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114006.mp3"></audio> 6. "Bland <span class="c5">[både]</span> jinnerna och människorna": Den som viskar kan vara antingen en människa eller en jinn. </p>',
            ],
        ],
        5 => [
            0 => [
                'question' => 'F1: Komplettera följande Hadith: "Handlingar bedöms efter avsikten", och nämn några nyttor?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9030.mp3',
                'answer' => '<p> S: Troendes ledare Abu Hafs \'Umar bin al-Khattab <span class="c2">(må Allah vara nöjd med honom)</span> berättade att han hörde Allahs sändebud ﷺ säga: "Handlingarna räknas endast i enlighet avsikterna, och var och en får vad han har avsett. Den som utvandrar för Allah och Hans sändebuds skull, så räknas hans utvandring för Allah och Hans sändebuds skull. Men den som utvandrar för någon världslig anledning eller för en kvinna som han vill gifta sig med, så räknas hans utvandring utefter det som han har utvandrat till." <span class="c2">(återberättad av al-Bukhari och Muslim)</span>.<span class="c6"><br /> Vad vi lär oss från Hadithen:</span><br /> 1. Det ska finnas en avsikt till varje handling, vare sig det är bön, fasta, pilgrimsfärd eller annat.<br /> 2. Avsikten ska vara att handlingen utförs med uppriktighet till Allah.<span class="c6"><br /> * Andra Hadithen:</span> </p>',
            ],
            1 => [
                'question' => 'F2: Komplettera följande Hadith: "Den som utför en handling som inte överensstämmer med vår angelägenhet...", och nämn några nyttor?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9090.mp3',
                'answer' => '<p> S: De troendes moder Umm \'Abdullah \'A\'ishah <span class="c2">(må Allah vara nöjd med henne)</span> berättade att Allahs sändebudet ﷺ sa: "Den som utför en handling som inte överensstämmer med vår angelägenhet, får den avvisad" <span class="c2">(Återberättad av al-Bukhari och Muslim)</span>.<span class="c6"><br /> Vad vi lär oss från Hadithen:</span><br /> 1. Det är förbjudet att innovera och hitta på nya saker i religionen.<br /> 2. Att innoverade och påhittade religiösa handlingar avvisas, och kommer inte att accepteras.<span class="c6"><br /> * Tredje Hadithen:</span> </p>',
            ],
            2 => [
                'question' => 'F3: Komplettera följande Hadith: "En dag när vi satt med Allahs sändebud ﷺ...", och nämn några nyttor?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9160.mp3',
                'answer' => '<p> S: \'Umar bin al-Khattab <span class="c2">(må Allah vara nöjd med honom)</span> sa: "En dag när vi satt med Allahs sändebud ﷺ, dök en man upp bland oss. Han hade oerhört vita kläder och kolsvart hår. Det såg inte ut som att han var resande, men ingen av oss kände honom heller. Han satte sig hos profeten ﷺ, placerade sina knän intill hans knän och lade sina handflator på sina lår.<span class="c6"> Han sa:</span> \'Muhammed! Underrätta mig om islam.<span class="c6">\' Allahs sändebud ﷺ sa:</span> \'Islam är att du vittnar att det inte finns någon sann gud utom Allah och att Muhammed är Allahs sändebud, förrättar bönen, betalar allmosan, fastar Ramadan och vallfärdar till huset om du har möjlighet att genomföra det.<span class="c6">\' Han svarade:</span> \'Du har talat sanning.\' Vi blev förvånade över att han frågade honom och sedan bekräftade att han hade talat sanning.<span class="c6"> Sedan sa han:</span> \'Underrätta mig om Iman <span class="c2">(tron)</span>!\' Profeten ﷺ svarade: \'Det är att du tror på Allah, hans änglar, hans skrifter, hans sändebud, den yttersta dagen och att du tror på ödet, det goda i det såväl som det onda.<span class="c6">\' Han svarade:</span> \'Du har talat sanning!\',<span class="c6"> och sa:</span> \'Underrätta mig om Ihsan <span class="c2">(perfektion)</span>!\' Profeten ﷺ sa: ”Att du dyrkar Allah som om du ser honom, om du inte dyrkar honom som du ser honom så vet att han ser dig.<span class="c6">\' Han svarade:</span> \'Underrätta mig om timmen <span class="c2">(domedagen)</span>.<span class="c6">\' Profeten ﷺ sa:</span> \'Den tillfrågade vet inte mer än frågeställaren.<span class="c6">\' Han svarade:</span> \'Underrätta mig om dess tecken!\' Profeten ﷺ sa: \'Att slavinnan föder sin ägarinna, och att du ser de barfota, nakna och utfattiga fårherdarna tävla om att bygga höga byggnader.\' Sedan gick frågeställaren sin väg medan vi förblev sittande en lång stund.<span class="c6"> Därefter sa profeten ﷺ:</span> \'´Umar! Vet du vem den frågande var?\' Jag svarade: ”Allah och hans sändebud vet bättre.<span class="c6">” Han sa:</span> \'Det var Gabriel som kom till er för att lära er er religion.\'" <span class="c2">(Återberättad av Muslim)</span>.<span class="c6"><br /> Vad vi lär oss från Hadithen:</span><br /> 1. Att islam har fem pelare,<span class="c6"> och de är:</span><br /> - Vittnesmålet att det inte finns någon sann gud utom Allah, och att Muhammed är Allahs sändebud.<br /> - Att förrätta bönen.<br /> - Att ge allmosa.<br /> - Att fasta under Ramadan.<br /> - Att besöka Allahs heliga hus för pilgrimsfärd.<br /> 2. Att Iman <span class="c2">(tron)</span> har sex pelare,<span class="c6"> och de är:</span><br /> - Tron på; Allah.<br /> - Hans änglar.<br /> - Hans skrifter.<br /> - Hans sändebud.<br /> - Den yttersta dagen.<br /> - Ödet, det goda i det såväl som det onda.<br /> 3. Att Ihsan <span class="c2">(perfektion)</span> har en pelare, och det är att dyrka Allah som att du ser honom, och om du inte kan dyrka honom som om du ser honom så vet att han ser dig.<br /> 4. Att ingen, utom Allah, vet när domedagen kommer att inträffa.<span class="c6"><br /> Fjärde Hadithen:</span> </p>',
            ],
            3 => [
                'question' => 'F4: Komplettera följande Hadith: "De troende med den fullkomligaste tron ...", och nämn några nyttor?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9360.mp3',
                'answer' => '<p> S: Abu Hurayrah <span class="c2">(må Allah vara nöjd med honom)</span> berättade att Allahs sändebud ﷺ sa: "De troende med den fullkomligaste tron är de med den bästa karaktären." <span class="c2">(Återberättad av at-Tirmidhi som ansåg att Hadithen var godtagbar och autentisk)</span>.<span class="c6"><br /> Vad vi lär oss från Hadithen:</span><br /> 1. Att det är uppmanat att ha en god karaktär.<br /> 2. Att en bra karaktär tyder på en stark tro.<br /> 3. Att tron ökar och minskar.<span class="c6"><br /> Femte Hadithen:</span> </p>',
            ],
            4 => [
                'question' => 'F5: Komplettera följande Hadith: "Den som svär vid andra än Allah...", och nämn några nyttor?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9440.mp3',
                'answer' => '<p> S: Ibn \'Umar <span class="c2">(må Allah vara nöjd med honom)</span> berättade att profeten ﷺ sa: "Den som svär vid andra än Allah har utfört en handling som räknas som otro eller avguderi." <span class="c2">(Återberättad av at-Tirmidhi)</span>.<span class="c6"><br /> Vad vi lär oss från Hadithen:</span><br /> - Det är inte tillåtet att svära vid andra än Allah.<br /> - Att svära vid andra än Allah är en form av mindre avguderi.<span class="c6"><br /> Sjätte Hadithen:</span> </p>',
            ],
            5 => [
                'question' => 'F6: Komplettera följande Hadith: "Ingen av er tror förrän han älskar mig mer...", och nämn några nyttor?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9510.mp3',
                'answer' => '<p> S: Anas <span class="c2">(må Allah vara nöjd med honom)</span> berättade att Allahs sändebud ﷺ sa: "Ingen av er tror förrän han älskar mig mer än sin far, sin son och alla andra människor." <span class="c2">(Återberättad av al-Bukhari och Muslim)</span>.<span class="c6"><br /> Vad vi lär oss från Hadithen:</span><br /> - Det är obligatoriskt att älska profeten ﷺ mer än någon annan människa.<br /> - Att detta är från trons fullkomlighet.<span class="c6"><br /> Sjunde Hadithen:</span> </p>',
            ],
            6 => [
                'question' => 'F7: Komplettera följande Hadith: "Ingen av er tror förrän han önskar för sin broder...", och nämn några nyttor?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9580.mp3',
                'answer' => '<p> S: Anas <span class="c2">(må Allah vara nöjd med honom)</span> berättade att Allahs sändebud ﷺ sa: "Ingen av er tror förrän han önskar för sin broder det han önskar för sig själv." <span class="c2">(Återberättad av al-Bukhari och Muslim)</span>.<span class="c6"><br /> Vad vi lär oss från Hadithen:</span><br /> 1. En troende ska önska väl för de troende, såsom han önskar för sig själv.<br /> 2. Detta är från trons fullkomlighet.<span class="c6"><br /> Åttonde Hadithen:</span> </p>',
            ],
            7 => [
                'question' => 'F8: Komplettera följande Hadith: "Vid honom i vars hand min själ vilar...", och nämn några nyttor?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9650.mp3',
                'answer' => '<p> S: Abu Sa\'id <span class="c2">(må Allah vara nöjd med honom)</span> berättade att Allahs sändebud ﷺ sa: "Vid den vars hand min själ vilar! Den <span class="c2">(Suratul-Ikhlas)</span> motsvarar en tredjedel av Koranen." <span class="c2">(Återberättad av al-Bukhari)</span>.<span class="c6"><br /> Vad vi lär oss från Hadithen:</span><br /> 1. Suratul-Ikhlas förträfflighet.<br /> 2. Att den motsvarar en tredjedel av Koranen.<span class="c6"><br /> Nionde Hadithen:</span> </p>',
            ],
            8 => [
                'question' => 'F9: Komplettera följande Hadith: "La hawla wa la quwwata illa billah (Det finns ingen rörelse och ingen styrka förutom med Allahs hjälp och vilja)", och nämn några nyttor?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9720.mp3',
                'answer' => '<p> S: Abu Musa <span class="c2">(må Allah vara nöjd med honom)</span> berättade att Allahs sändebud ﷺ sa: "La hawla wa la quwwata illa billah <span class="c2">(Det finns ingen rörelse och ingen styrka förutom med Allahs hjälp och vilja)</span> är en skatt från paradisets skatter." <span class="c2">(Återberättad av al-Bukhari och Muslim)</span>.<span class="c6"><br /> Vad vi lär oss från Hadithen:</span><br /> 1. Det tyder på denna menings förträfflighet, då den är en av paradisets skatter.<br /> 2. Att en tjänare inte ska förlita sig på sin egen styrka och kapacitet, utan istället endast förlita sig på Allah.<span class="c6"><br /> *Tionde Hadithen:</span> </p>',
            ],
            9 => [
                'question' => 'F10: Komplettera följande Hadith: ”Det finns en bit kött i kroppen; om den är sund är resten av kroppen också sund, och om den är osund är resten av kroppen också osund. Det är helt visst hjärtat", och nämn några nyttor?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9790.mp3',
                'answer' => '<p> S: An-Nu\'man bin Bashir <span class="c2">(må Allah vara nöjd med honom)</span> berättade att Allahs sändebud ﷺ sa: ”Det finns en bit kött i kroppen; om den är sund är resten av kroppen också sund, och om den är osund är resten av kroppen också osund. Det är helt visst hjärtat" <span class="c2">(återberättad av al-Bukhari och Muslim)</span>.<span class="c6"><br /> Vad vi lär oss från Hadithen:</span><br /> 1. När hjärtat korrigeras, korrigeras ens dolda och synliga sidor.<br /> 2. Vikten av att korrigera hjärtat eftersom kroppens sundhet baseras på det.<span class="c6"><br /> * Elfte Hadithen:</span> </p>',
            ],
            10 => [
                'question' => 'F11: Komplettera följande Hadith: "Den vars sista ord i detta liv är "La ilaha illallah" (Det finns ingen sann gud utom Allah)...", och nämn några nyttor?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9860.mp3',
                'answer' => '<p> S: Mu\'adh bin Jabal <span class="c2">(må Allah vara nöjd med honom)</span> berättade att Allahs sändebud ﷺ sa: "Den vars sista ord i detta liv är: "La ilaha illallah" <span class="c2">(Det finns ingen sann gud utom Allah)</span> kommer att träda in i paradiset" <span class="c2">(återberättad av Abu Dawud)</span>.<span class="c6"><br /> Vad vi lär oss från Hadithen:</span><br /> 1. "La ilaha illallah"s förträfflighet, och att den kommer att vara anledningen till att tjänaren kommer att träda in i paradiset.<br /> 2. Vilken förträfflighet det finns i att det sista en person säger innan den lämnar livet är "La ilaha illallah.<span class="c6">"<br /> *Tolfte Hadithen:</span> </p>',
            ],
            11 => [
                'question' => 'F12: Komplettera följande Hadith: "Den troende är varken den som förtalar mycket eller förbannar mycket ...", och nämn några nyttor?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9940.mp3',
                'answer' => '<p> S: \'Abdullah bin Mas\'ud <span class="c2">(må Allah vara nöjd med honom)</span> berättade att Allahs sändebud ﷺ sa: "Den troende är varken den som förtalar eller förbannar mycket, inte heller den som är oanständig eller ful i mun" <span class="c2">(återberättad av at-Tirmidhi)</span>.<span class="c6"><br /> Vad vi lär oss från Hadithen:</span><br /> 1. Det är förbjudet att säga något som är falskt eller dåligt.<br /> 2. Hur den troende istället bör tala.<span class="c6"><br /> * Trettonde Hadithen:</span> </p>',
            ],
            12 => [
                'question' => 'F13: Komplettera följande Hadith: "Från en muslims goda karaktär är", och nämns några nyttor?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10020.mp3',
                'answer' => '<p> S: Abu Hurayrah <span class="c2">(må Allah vara nöjd med honom)</span> berättade att Allahs sändebud ﷺ sa: "Från en muslims goda karaktär är att lämna det som inte angår en" <span class="c2">(återberättad av at-Tirmidhi m.fl)</span>.<span class="c6"><br /> Vad vi lär oss från Hadithen:</span><br /> 1. Att en person inte ska lägga sig i det som inte angår honom gällande andras religion och liv.<br /> 2. Att lämna det som inte angår en är ett sätt att fullända ens praktiserande av islam.<span class="c6"><br /> * Fjortonde Hadithen:</span> </p>',
            ],
            13 => [
                'question' => 'F14: Komplettera följande Hadith: "Den som läser en bokstav från Koranen...", och nämn några nyttor?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10100.mp3',
                'answer' => '<p> S: \'Abdullah bin Mas\'ud <span class="c2">(må Allah vara nöjd med honom)</span> berättade att profeten ﷺ sa: "Den som läser en bokstav från Koranen får tio belöningar för varje bokstav. Jag säger inte att Alif, Lam och Mim är bokstäver. Snarare är Alif en bokstav, Lam är en bokstav och Mim är en bokstav" <span class="c2">(återberättad av at-Tirmidhi)</span>.<span class="c6"><br /> Vad vi lär oss från Hadithen:</span><br /> 1. Vilken dygd det finns i att läsa Koranen.<br /> 2. Att du får belöning för varje bokstav du läser. </p>',
            ],
        ],
        6 => [
            0 => [
                'question' => 'F1: Hur uppför man sig med Allah?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10190.mp3',
                'answer' => '<p> S: Genom att: <br /> 1. Högakta honom.<br /> 2. Enbart dyrka honom utan att sätta någon vid hans sida.<br /> 3. Lyda honom.<br /> 4. Avstå från att trotsa honom.<br /> 5. Tacka enbart honom för hans otaliga gåvor och välsignelser.<br /> 6. Ha tålamod med det han förutbestämt. </p>',
            ],
            1 => [
                'question' => 'F2: Hur uppför man sig med sändebudet ﷺ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10270.mp3',
                'answer' => '<p> S: Genom att: <br /> 1. Följa honom och ha honom som förebild.<br /> 2. Lyda honom.<br /> 3. Avstå från att trotsa honom.<br /> 4. Tro på allt han berättat om.<br /> 5. Avstå från påhittade saker i religionen.<br /> 6. Älska honom mer än sig själv och mer än alla andra människor.<br /> 7. Högakta honom och stötta honom och det han kom med. </p>',
            ],
            2 => [
                'question' => 'F3: Hur uppför man sig mot föräldrarna?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10360.mp3',
                'answer' => '<p> S: Genom att: <br /> 1. Lyda dem, så länge de inte uppmanar till synd.<br /> 2. Ta hand om dem.<br /> 3. Hjälpa dem.<br /> 4. Se efter deras behov.<br /> 5. Be för dem.<br /> 6. Tala med dem respektfull. Det är inte ens tillåtet att säga "Uff" till dem, trots att det är ett mindre uttryck för irritation.<br /> 7. Le mot dem och inte se sur ut.<br /> 8. Inte höja rösten över deras röst och lyssna på dem utan att avbryta. Ropa inte på dem med deras förnamn, kalla dem istället för "mamma" och "pappa".<br /> 9. Söka deras tillåtelse innan man går in i deras sovrum.<br /> 10. Pussa deras händer och huvud. </p>',
            ],
            3 => [
                'question' => 'F4: Hur uppför man sig mot sina släktingar?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10490.mp3',
                'answer' => '<p> S: Genom att: <br /> 1. Besöka släktingar, som kan vara ens bror, syster, farbror, faster, morbror, moster och resterade släktingar.<br /> 2. Visa dem vänlighet i tal och handling, och att hjälpa dem.<br /> 3. Kontakta dem för att se hur det står till med dem. </p>',
            ],
            4 => [
                'question' => 'F5: Hur bör man vara mot sina bröder och vänner?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10550.mp3',
                'answer' => '<p> S: Genom att: <br /> 1. Tycka om och umgås med bra människor.<br /> 2. Undvika dåligt umgänge.<br /> 3. Att hälsa på dem genom att säga "As-salamu ´alaykum" och skaka hand med dem.<br /> 4. Besöka dem om de blir sjuka och be för deras tillfrisknande.<br /> 5. Säga "Yarhamakallah" <span class="c2">(Må Allah vara barmhärtig mot dig)</span> när någon nyser.<br /> 6. Besvara inbjudan när någon bjuder hem en.<br /> 7. Ge dem goda råd.<br /> 8. Stötta dem om de blir felbehandlade, och att hindra dem från att behandla andra fel.<br /> 9. Älska det som är gott för dem, så som man älskar det goda för sig själv.<br /> 10. Hjälpa dem när det behövs.<br /> 11. Inte skada dem varken i tal eller handling.<br /> 12. Hålla deras hemligheter för sig själv.<br /> 13. Undvika att förolämpa dem, eller att baktala dem, se ner på dem, vara avundsjuk på dem, spionera på dem eller lura dem. </p>',
            ],
            5 => [
                'question' => 'F6: Hur uppför man sig mot grannarna?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10710.mp3',
                'answer' => '<p> S: Genom att: 1. Vara god mot dem i tal och handling, och erbjuda dem hjälp vid behov.<br /> 2 Gratulera dem vid högtider som Eid, vid bröllop och annat.<br /> 3. Besöka dem när de är sjuka och trösta dem vid sorg och svårigheter.<br /> 4. Ge dem från maten som tillagats när tillfället ges.<br /> 5. Inte skada dem varken genom ord eller handling.<br /> 6. Inte störa dem genom att vara högljudd eller spionera på dem, snarare ska de visas tålamod. </p>',
            ],
            6 => [
                'question' => 'F7: Hur uppför man sig som gäst?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10800.mp3',
                'answer' => '<p> S: Genom att: <br /> 1. Besvara värdens inbjudan.<br /> 2. Att söka tillstånd för besöket och fråga vilken tid som är lämplig för det.<br /> 3. Be om att få komma in innan man går in i huset.<br /> 4. Inte stanna för länge under besöket.<br /> 5. Sänka blicken och inte titta på värdens familj.<br /> 6. Värden ska välkomna gästen på bästa sätt genom att le och uttrycka välkomnande ord.<br /> 7. Värden ska låta gästen sitta på den finaste platsen.<br /> 8. Värden ska ära gästen genom att förse denne med mat och dryck. </p>',
            ],
            7 => [
                'question' => 'F8: Nämn olika uppföranden relaterat till sjukdom och att besöka de sjuka?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10900.mp3',
                'answer' => '<p> S: 1. Vid smärta ska den högra handen placeras på platsen som gör ont.<span class="c6"> Därefter sägs följande:</span> "Bismillah" <span class="c2">(I Allahs namn)</span>, tre gånger.<span class="c6"> Sedan:</span> "A\'udhu bi \'izzatillahi wa qudratihi min sharri ma ajidu wa uhadhir" <span class="c2">(Jag tar skydd i Allahs styrka och makt från det onda jag känner och fruktar)</span>, sju gånger.<br /> 2. ِAtt känna belåtenhet och ha tålamod med Allahs bestämmelse att detta skulle ske.<br /> 3. Skynda med att besöka den sjuke, be för honom, och inte låta besöket bli utdraget.<br /> 4. Göra Ruqyah <span class="c2">(läsa Koran, åkallan och åminnelser)</span> över den sjuke utan att han ska behöva be om det själv.<br /> 5. Uppmana den sjuke att ha tålamod, göra åkallan, be och utföra den rituella renligheten enligt kapacitet.<br /> 6.<span class="c6"> Be för den sjuke genom att säga:</span> "As\'alullah al-\'Adhim Rabb al-\'arshil-\'adhim an yashfiyak" <span class="c2">(Jag ber Allah den Väldige, Herren över den väldige tronen, att bota dig)</span>, sju gånger. </p>',
            ],
            8 => [
                'question' => 'F9: Nämn olika uppföranden vid sökande av kunskap?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10990.mp3',
                'answer' => '<p> S: 1. Att göra det uppriktigt för Allahs skull.<br /> 2. Att praktisera den kunskapen man har lärt sig.<br /> 3. Att respektera läraren både när han är närvarande och frånvarande.<br /> 4. Att sitta respektfullt vid hans närvaro.<br /> 5. Lyssna uppmärksamt på det han säger utan att avbryta honom.<br /> 6. Ställa frågor respektfullt.<br /> 7. Kallar inte på honom genom att nämna hans namn. </p>',
            ],
            9 => [
                'question' => 'F10: Hur uppför man sig vid sammankomster?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11090.mp3',
                'answer' => '<p> S: Genom att: 1. Hälsa på de närvarande.<br /> 2. Sitta på första lediga plats, utan att be om någon annans plats eller sitta mellan två personer utan deras tillstånd.<br /> 3. Gör plats för andra.<br /> 4. Avbryter inte det pågående samtalet.<br /> 5. Ber om tillåtelse innan man vill lämna platsen och säger farväl till de närvarande.<br /> 6. När sammankomsten avslutas läses Du\'a al-<span class="c6">Kaffarah som är följande:</span> "Subhanak allahumma wa bihamdik, ash-hadu an la ilaha illa ant, astaghfiruka wa atubu ilayk" <span class="c2">(Allah! Du är fri från brister och all lovprisning tillkommer dig. Jag söker din förlåtelse och vänder mig till dig i ånger)</span>. </p>',
            ],
            10 => [
                'question' => 'F11: Nämn olika uppföranden relaterade till när det är dags att sova?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11180.mp3',
                'answer' => '<p> S: Genom att: 1. Sova tidigt.<br /> 2. Sova i ett tillstånd av rituell renlighet.<br /> 3. Inte sova på magen.<br /> 4. Sova på höger sida, och lägga höger hand under höger kind.<br /> 5. Damma av sängen.<br /> 6. Säga åminnelser innan det är dags att sova,<span class="c6"> likt att recitera delar av Koranen som:</span> Ayatul-Kursi en gång, suratul-Ikhlas, suratul-Falaq och suratun-Nasr tre gånger var.<span class="c6"> Även säga:</span> "Bismik allahumma amutu wa ahya" <span class="c2">(Allah! I ditt namn dör jag och lever)</span>.<br /> 7. Vakna för Fajr-bönen.<br /> 8.<span class="c6"> När det är dags att vakna sägs:</span> "Al-hamdu lillahi lladhi ahyana ba\'da ma amatana wa ilayhin-nushur" <span class="c2">(Prisad vare Allah som gav oss liv efter vi varit döda, och till honom ska vi återföras)</span>. </p>',
            ],
            11 => [
                'question' => 'F12: Vilka är de islamiska uppföranden man bör ha i samband med måltider?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11290.mp3',
                'answer' => '<p> S:<br /> 1. Att äta och dricka för att få kraft och ork att dyrka Allah.<br /> 2. Tvätta händerna innan måltiden.<br /> 3.<span class="c6"> Säga:</span> "Bismillah" <span class="c2">(I Allahs namn)</span> innan man börjar äta, därefter äta med höger hand och från det som är framför en. Man ska inte äta från det gemensamma fatets mittersta del eller från det som är framför andra.<br /> 4.<span class="c6"> Ifall det glömts säga "Bismillah" innan måltiden sägs:</span> "Bismillahi awwaluhu wa akhiruh" <span class="c2">(I Allahs namn, från början till slutet)</span>.<br /> 5. Att vara nöjd med den maten som finns tillgänglig utan att kritisera den. Ifall den faller en i smaken ska den ätas, annars ska den lämnas.<br /> 6. Att äta tillräckligt och undvika att äta för mycket.<br /> 7. Undvika att blåsa på maten och drickan, och istället låta det svalna själv.<br /> 8. Att äta tillsammans med familj och gäster.<br /> 9. Att inte äta förrän de äldre börjat äta.<br /> 10. Nämna Allahs namn innan msn dricker, och att dricka sittande och i tre omgångar.<br /> 11. Tacka Allah efter måltiden. </p>',
            ],
            12 => [
                'question' => 'F13: Nämn olika uppföranden relaterade till klädsel?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11440.mp3',
                'answer' => '<p> S: 1. Att klä höger sida först, och prisa Allah för klädseln.<br /> 2. Inte låta klädseln vara under ankeln <span class="c2">(för män)</span>.<br /> 3. Pojkar ska inte klä sig i flickkläder, och flickor ska inte klä sig i pojkkläder.<br /> 4. Inte klä sig som de otrogna eller syndare.<br /> 5. Att nämna Allahs namn innan kläderna tas av.<br /> 6. Sätta på sig höger sko först, och ta av vänster sko först. </p>',
            ],
            13 => [
                'question' => 'F14: Nämn olika uppföranden relaterade till transportmedel?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11540.mp3',
                'answer' => '<p> S: 1.<span class="c6"> Att säga:</span> "Bismillah, alhamdulillah" <span class="c2">(I Allahs namn, all lovprisning tillkommer Allah)</span>. "Upphöjd vare han som har skänkt oss dessa; själva hade vi inte haft förmågan till det. Och det är sannerligen till vår Herre vi ska återvända" <span class="c2">(43:13-14)</span>.<br /> 2. Om du passerar en muslim ska du hälsa på honom med "as-Salamu \'alaykum". </p>',
            ],
            14 => [
                'question' => 'F15: Nämn olika uppföranden relaterade till vägar?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11590.mp3',
                'answer' => '<p> S: 1. Att gå rakryggad och ödmjuk på höger sida av vägen.<br /> 2. Att säga "as-Salamu \'alaykum" för att hälsa på förbipasserande.<br /> 3. Sänka blicken och inte skada någon.<br /> 4. Uppmana till det goda och förbjuda det onda.<br /> 5. Avlägsna skadliga saker från vägen. </p>',
            ],
            15 => [
                'question' => 'F16: Nämn olika uppföranden relaterade till att gå in i hemmet eller ut från det?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11670.mp3',
                'answer' => '<p> S: 1.<span class="c6"> Att gå ut från huset med vänster fot sägandes:</span> "Bismillahi tawakkaltu \'alallahi wa la hawla wa la quwwata illa billah. Allahumma inni a\'udhu bika an adilla aw udall, aw azilla aw uzall, aw adhlima aw udhlam, aw ajhala aw yujhala \'alayy" <span class="c2">(I Allahs Namn. Jag har satt all min lit till Allah. Det finns ingen rörelse och ingen styrka förutom med Allahs hjälp och vilja. Allah! Jag söker skydd hos dig från att vilseleda eller vilseledas. Från att få andra att fela eller själv fela <span class="c5">[på grund av andra]</span>. Från att förtrycka eller förtryckas. Från att bete mig ignorant eller bli bemött med ignorans)</span>. 2.<span class="c6"> Träda in i huset med höger fot sägandes:</span> "Bismillahi walajna, wa bismillahi kharajna, wa \'ala Rabbina tawakkalna" <span class="c2">(I Allahs namn går vi in, och i Allahs namn går vi ut, och vi sätter all vår lit till vår Herre)</span>.<br /> 3. Använda Siwak och "as-Salamu \'alaykum" för att hälsa på dem som är i huset. </p>',
            ],
            16 => [
                'question' => 'F17: Nämn olika uppförande relaterade till toalettbesök?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11730.mp3',
                'answer' => '<p> S: 1. Gå in till toaletten med vänster fot.<br /> 2.<span class="c6"> Säga följande innan inträde:</span> "Bismillah, Allahumma inni a\'udhu bika minal-khubthi wal-kaba\'ith" <span class="c2">(I Allahs namn. Allah! Jag tar skydd hos dig från de manliga och kvinnliga djävlarna)</span>.<br /> 3. Inte ta in något som har Allahs namn skrivet på det.<br /> 4. Se till att ingen annan kan se en när behoven uträttas.<br /> 5. Inte prata på toaletten.<br /> 6. Att inte vara riktad mot Qiblah <span class="c2">(böneriktningen)</span> eller ha ryggen mot den när behoven uträttas.<br /> 7. Rengöra sig med vänster hand, och inte med höger hand.<br /> 8. Inte uträtta sina behov på en allmän plats där andra går eller tar skugga.<br /> 9. Tvätta händerna efter behoven har uträttats.<br /> 10.<span class="c6"> Gå ut från toaletten med höger fot sägandes:</span> "Ghufranak" <span class="c2">(Jag ber om din förlåtelse)</span>. </p>',
            ],
            17 => [
                'question' => 'F18: Nämn olika uppföranden relaterade till moskén?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11860.mp3',
                'answer' => '<p> S: 1.<span class="c6"> Gå in i moskén med höger fot sägandes:</span> "Bismillah, Allahumma-ftah li abwaba rahmatik" <span class="c2">(I Allahs namn. Allah! Öppna för mig dörrarna till din nåd)</span>.<br /> 2. Be två böneenheter innan man sätter sig.<br /> 3. Man ska inte gå framför de bedjande, inte heller efterlysa försvunna saker, eller köpa och sälja i moskén.<br /> 4.<span class="c6"> Gå ut ur moskén med vänster fot sägandes:</span> "Allahumma inni as\'aluka min fadlik" <span class="c2">(Allah! Jag ber dig om din godhet)</span>. </p>',
            ],
            18 => [
                'question' => 'F19: Nämn olika uppföranden relaterade till att hälsa genom att säga "as-Salamu \'alaykum"?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11930.mp3',
                'answer' => '<p> S: 1.<span class="c6"> När man träffar en muslim ska man hälsa på honom genom att säga:</span> "as-Salamu \'alaykum wa rahmatullahi wa barakatuh" <span class="c2">(må frid, Allahs nåd och hans välsignelser vara över dig)</span>. Man ska inte hälsa med annat än att säga "as-Salamu \'alaykum", och inte heller bara vinka med handen.<br /> 2. Att le när man hälsar på andra med att säga "as-Salamu \'alaykum."<br /> 3. Skaka hand med höger hand.<br /> 4. När någon hälsar på mig med att säga "as-Salamu \'alaykum" ska jag besvara den med en bättre eller liknande hälsning.<br /> 5. Man ska inte påbörja hälsningsfrasen med att säga "as-Salamu \'alaykum" till en icke-muslim, om han däremot inleder hälsningsfrasen med att säga "as-Salamu \'alaykum" ska man svara med en liknande hälsning.<br /> 6. Den unge hälsar på den gamle, den ridande hälsar på den gående, den gående hälsar på den sittande, gruppen som består av ett litet antal hälsar på gruppen som består av ett större antal. </p>',
            ],
            19 => [
                'question' => 'F20: Nämn olika uppföranden relaterade till att söka tillåtelse?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12020.mp3',
                'answer' => '<p> S: 1. Att söka tillåtelse innan man går in till en plats.<br /> 2. Att söka tillåtelse tre gånger max, och inte mer, därefter får man gå därifrån.<br /> 3. Knacka försiktig och stå vid sidan av dörren, till höger eller vänster.<br /> 4. Man får inte gå in i föräldrarnas eller någon annans rum innan man sökt tillåtelse, särskilt innan gryningen, under vilan eller på natten.<br /> 5. Det är tillåtet att gå in till allmänna platser, som sjukhus eller affärer, utan att söka tillåtelse. </p>',
            ],
            20 => [
                'question' => 'F21: Nämn olika uppföranden relaterade till djurens välbefinnande?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12100.mp3',
                'answer' => '<p> S: 1. Att förse djuren med mat och dryck.<br /> 2. Att vara vänlig och omtänksam mot djuren, och att inte belasta dem med det de inte klarar av.<br /> 3. Att aldrig tortera djuren eller skada dem på något sätt. </p>',
            ],
            21 => [
                'question' => 'F22: Nämn olika uppföranden relaterade till idrott?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12160.mp3',
                'answer' => '<p> S: 1. Att idrotta för att få kraft och ork att dyrka Allah.<br /> 2. Undvika att idrotta och spela när det är tid för bön.<br /> 3. Pojkar och flickor ska inte idrotta tillsammans.<br /> 4. Klä sig i sportkläder som täcker \'Awrahn <span class="c2">(de områden som varje person måste täcka)</span>.<br /> 5. Undvika förbjudna idrottsaktiviteter, exempelvis de aktiviteter som involverar slag i ansiktet eller att \'Awrahn syns. </p>',
            ],
            22 => [
                'question' => 'F23: Nämn olika islamiska uppföranden relaterade till att skämta?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12240.mp3',
                'answer' => '<p> S: 1. Att tala sanning vid skämt, och inte ljuga.<br /> 2. Att skämta utan att mobba, förlöjliga, skada eller skrämmas.<br /> 3. Undvika att skämta för mycket. </p>',
            ],
            23 => [
                'question' => 'F24: Nämn olika islamiska uppföranden relaterade till att nysa?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12300.mp3',
                'answer' => '<p> S: 1. Att täcka munnen med handen, klädseln eller en servett vid nysning.<br /> 2.<span class="c6"> Att prisa Allah efter nysningen sägandes:</span> "Al-hamdu lillah" <span class="c2">(All lovprisning tillkommer Allah)</span>.<br /> 3.<span class="c6"> Personen som hör någon nysa ska säga:</span> "Yarhamakallah" <span class="c2">(Må Allah visa dig nåd)</span>.<span class="c6"><br /> Då svarar den som nyst:</span> "Yahdikumullahu wa yuslihu balakum" <span class="c2">(Må Allah vägleda er och korrigera er situation)</span>." </p>',
            ],
            24 => [
                'question' => 'F25: Vad är de islamiska uppföranden relaterade till gäspning?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12360.mp3',
                'answer' => '<p> S: 1. Att försöka hålla tillbaka gäspningen.<br /> 2. Att inte göra ljud i samband med gäspningen.<br /> 3. Täcka munnen med handen. </p>',
            ],
            25 => [
                'question' => 'F26: Nämn olika uppföranden relaterade till Koranläsning?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12420.mp3',
                'answer' => '<p> S: 1. Att läsa Koranen i ett tillstånd av rituell renlighet efter tvagning.<br /> 2. Att sitta respektfullt.<br /> 3. Att söka skydd hos Allah från Satan i början av läsningen.<br /> 4. Reflektera över innebörden. </p>',
            ],
        ],
        7 => [
            0 => [
                'question' => 'F1: Vad finns det för dygd i att visa ett gott beteende?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12500.mp3',
                'answer' => '<p> S: Profeten ﷺ sa: "De troende som har mest fullkomlig tro är de som har den bästa karaktären." <span class="c2">(Återberättad av at-Tirmidhi och Ahmad)</span>. </p>',
            ],
            1 => [
                'question' => 'F2: Varför måste vi hålla fast vid den islamiska karaktären?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12530.mp3',
                'answer' => '<p> S: Eftersom den är: 1. Ett sätt att uppnå Allahs kärlek.<br /> 2. Ett sätt att uppnå andra människors kärlek.<br /> 3. Det som väger tyngst på vågskålen på domedagen.<br /> 4. Belöningar multipliceras på grund av det.<br /> 5. Det är ett tecken på fullkomlig tro. </p>',
            ],
            2 => [
                'question' => 'F3: Var beskrivs den islamiska karaktären?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12600.mp3',
                'answer' => '<p> S: I Koranen.<span class="c6"> Allah säger:</span> "Denna Koran vägleder sannerligen till det mest rätta" <span class="c2">(17:9)</span>. Och i profetens vägledning.<span class="c6"> Allahs sändebud ﷺ sa:</span> "Jag har enbart sänts för att fullborda rättfärdigt uppförande." <span class="c2">(Återberättad av Ahmad)</span>. </p>',
            ],
            3 => [
                'question' => 'F4: Hur har man karaktär av Ihsan (religionens högsta nivå), och vad har det för exempel?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12640.mp3',
                'answer' => '<p> S: Ihsan är att konstant vara medveten om Allah, och att visa godhet och vänlighet mot alla skapelser.<span class="c6"><br /> Profeten ﷺ sa:</span> "Allah har föreskrivit Ihsan i alla angelägenheter" <span class="c2">(återberättad av Muslim)</span>.<span class="c6"><br /> Exempel på Ihsan är:</span><br /> Att ha Ihsan i dyrkan av Allah, genom att vara uppriktig i dyrkan av honom.<br /> Att visa Ihsan mot föräldrarna och vara vänlig i tal och handling.<br /> Ihsan mot släkt.<br /> Ihsan mot grannen.<br /> Ihsan mot faderlösa och behövande.<br /> Ihsan mot den som dig illa.<br /> Ihsan i sitt tal.<br /> Ihsan under diskussioner.<br /> Ihsan mot djuren. </p>',
            ],
            4 => [
                'question' => 'F5: Vad är motsatsen till Ihsan?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12780.mp3',
                'answer' => '<p> S: Motsatsen till Ihsan är Isa\'ah <span class="c2">(att bete sig illa)</span>.<br /> *Exempel på Isa\'ah är att inte vara uppriktig till Allah i dyrkan av honom.<br /> *Bete sig illa mot föräldrarna.<br /> *Bryta släktbanden.<br /> *Bete sig illa mot grannar.<br /> *Att inte ha Ihsan mot fattiga och behövande, samt att yttra dåliga ord och göra andra dåliga handlingar. </p>',
            ],
            5 => [
                'question' => 'F6: Vad finns det för typer av Amanah (integritet och pålitlighet), samt exempel på det?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12860.mp3',
                'answer' => '<p> S:<br /> 1. Amanah i att uppfylla Allahs rättigheter.<span class="c6"><br /> Exempel:</span> Amanah i utförandet av olika former av dyrkan som bön, allmosa, fasta, Hajj och andra handlingar som Allah har gjort obligatoriskt för oss.<br /> 2. Amanah i att se efter andras rättigheter,<span class="c6"> genom att:</span><br /> Inte förstöra andra människors anseende.<br /> Deras egendomar.<br /> Deras liv.<br /> Deras hemligheter, och allt som man anförtrotts.<br /> Allah säger,<span class="c6"> då han beskriver de framgångsrika:</span> "Och som är måna om sina förtroendeuppdrag och avtal" <span class="c2">(23:8)</span>. </p>',
            ],
            6 => [
                'question' => 'F7: Vad är motsatsen till Amanah?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12980.mp3',
                'answer' => '<p> S: Khiyanah <span class="c2">(bedrägeri)</span>, att försumma Allahs rättigheter och människors rättigheter.<span class="c6"><br /> Profeten ﷺ sa:</span> "Hycklarens kännetecken är tre", varpå han nämnde "när han anförtros bedrar han" <span class="c2">(återberättad av al-Bukhari och Muslim)</span>. </p>',
            ],
            7 => [
                'question' => 'F8: Vad är ärlighet?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13020.mp3',
                'answer' => '<p> S: Det är att berätta om något som det verkligen är.<span class="c6"><br /> Exempel på det:</span><br /> Att tala sanning när man talar med människor.<br /> Att hålla sitt ord.<br /> Att vara sanningsenlig i tal och handling.<span class="c6"><br /> Profeten ﷺ sa:</span> "Ärlighet leder till rättfärdighet, och rättfärdighet leder till paradiset. En man kommer att vara ärlig till dess att han skrivs upp som ärlig hos Allah" <span class="c2">(återberättad av al-Bukhari och Muslim)</span>. </p>',
            ],
            8 => [
                'question' => 'F9: Vad är motsatsen till ärlighet?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13100.mp3',
                'answer' => '<p> S: Lögn, vilket är att inte tala sanning. Exempel på det är att ljuga för människor, bryta löften och vittna falskt.<span class="c6"><br /> Profeten ﷺ sa:</span> "Lögn leder till synder, och synder leder till elden. En man kommer att ljuga till dess att han skrivs upp som obotlig lögnare hos Allah" <span class="c2">(återberättad av al-Bukhari och Muslim)</span>.<span class="c6"> Profeten ﷺ sa:</span> "Hycklarens kännetecken är tre" och nämnde "när han talar, ljuger han, och när han lovar, bryter han löftet" <span class="c2">(återberättad av al-Bukhari och Muslim)</span>. </p>',
            ],
            9 => [
                'question' => 'S10: Vad finns det för former av tålamod?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13140.mp3',
                'answer' => '<p> S: - Tålamod med att lyda Allah.<br /> - Tålamod med att hålla sig borta från synder.<br /> - Tålamod med det smärtsamma i ödet, och att prisa Allah oavsett situation.<span class="c6"><br /> Allah säger:</span> "Allah älskar de tålmodiga" <span class="c2">(3:146)</span>.<span class="c6"> Profeten ﷺ sa:</span> "Den troendes tillstånd är häpnadsväckande. Hans tillstånd är alltid bra, detta gäller däremot endast den troende. Om han upplever något gott, visar han tacksamhet, vilket är bra för honom. Och om han upplever något ont, har han tålamod, vilket är bra för honom" <span class="c2">(återberättad av Muslim)</span>. </p>',
            ],
            10 => [
                'question' => 'F11: Vad är motsatsen till tålamod?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13210.mp3',
                'answer' => '<p> S: Att inte ha tålamod med att lyda Allah, eller att avstå från synd, eller att genom tal och handling visa ilska över ödet.<span class="c6"><br /> Exempel på det:</span><br /> § Dödsönskan.<br /> § Slå på kinder och ansikte.<br /> § Riva kläderna.<br /> § Rycka i håret.<br /> § Att be om förstörelse och om att gå under.<span class="c6"><br /> Profeten ﷺ sa:</span> "Den belöningen man får är i enlighet med hur stor prövningen är. Om Allah älskar ett folk prövar han det. Den som visar att han är nöjd, kommer Allah att vara nöjd med, och den som visar att han känner vrede, kommer drabbas av Allahs vrede" <span class="c2">(återberättad av at-Tirmidhi och Ibn Majah)</span>. </p>',
            ],
            11 => [
                'question' => 'F13: Vad innebär det att samarbeta?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13310.mp3',
                'answer' => '<p> S: Det är att människor samarbetar tillsammans för att främja sanningen och godhet.<span class="c6"><br /> Exempel på hur samarbete förekommer:</span><br /> o Att samarbeta för att återge rättigheter.<br /> o Att samarbeta för att motverka förtryck.<br /> o Att samarbeta för att möta människors och i synnerhet de fattigas behov.<br /> o Att samarbeta för att främja allt som är gott.<br /> o Att inte samarbeta i det som leder till synd, skada och överträdelse.<span class="c6"><br /> Allah säger:</span> "Hjälp varandra till rättfärdighet och gudsfruktan och hjälp inte varandra till synd och överträdelse. Och frukta Allah! Allah är sannerligen sträng i att straffa" <span class="c2">(5:2)</span>.<span class="c6"> Profeten ﷺ sa:</span> "De troende sinsemellan är som en enda byggnad; de stärker varandra" <span class="c2">(återberättad av al-Bukhari och Muslim)</span>.<span class="c6"> Profeten ﷺ sa:</span> "En muslim är broder till en annan muslim; han behandlar honom varken orättvist och sviker heller inte honom. Allah kommer att hjälpa den som hjälper sin broder. Allah kommer att avvärja svårigheter på domdedagen för den som avvärjer svårigheter för en muslim i detta liv. Allah kommer att dölja <span class="c5">[de dåliga sakerna någon begått]</span> i detta liv och det efterkommande för den som gör detta för en annan muslim" <span class="c2">(återberättad av al-Bukhari och Muslim)</span>. </p>',
            ],
            12 => [
                'question' => 'F13: Hur kan blygsamhet praktiseras?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13420.mp3',
                'answer' => '<p> S: 1. Att vara blyg inför Allah och därför inte trotsa honom.<br /> 2. Att vara blyg inför människor genom att undvika oanständigt och fult tal och genom att inte visa sin \'Awrah <span class="c2">(den del av kroppen som måste täckas)</span>.<span class="c6"><br /> Allahs sändebud ﷺ sa:</span> "Tron består av drygt sextio eller sjuttio nivåer.<span class="c6"> Dess högsta nivå är att uttala:</span> \'Det finns ingen sann gud utom Allah\', och dess lägsta nivå är att avlägsna något skadligt från vägen. Blyghet är också en nivå av tron" <span class="c2">(återberättad av Muslim)</span>. </p>',
            ],
            13 => [
                'question' => 'F14: Ge exempel på hur barmhärtighet visas?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13470.mp3',
                'answer' => '<p> S: - Att vara barmhärtig mot äldre och att visa dem respekt.<br /> - Att vara barmhärtig mot barn och yngre.<br /> - Att vara barmhärtig mot fattiga och behövande.<br /> - Att vara barmhärtig mot djur genom att mata dem och inte skada dem.<span class="c6"><br /> Beträffande barmhärtighet så sa profeten ﷺ:</span> "De troende är i sin ömsesidiga kärlek, barmhärtighet och medkänsla är som en enda kropp. Om en kroppsdel värker, lider resten av kroppen av feber och sömnlöshet" <span class="c2">(återberättad av al-Bukhari och Muslim)</span>.<span class="c6"> Allahs sändebud ﷺ sa:</span> "De barmhärtiga kommer den Nåderike att visa nåd över. Var barmhärtiga mot dem som är på jorden, så kommer han som är ovanför himlen att visa er nåd" <span class="c2">(återberättad av Abu Dawud, at-Tirmidhi och andra)</span>. </p>',
            ],
            14 => [
                'question' => 'F15: Vad finns det för olika former av kärlek?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13550.mp3',
                'answer' => '<p> S: - Att älska Allah.<span class="c6"><br /> Allah säger:</span> "De troende har starkare kärlek till Allah" <span class="c2">(2:165)</span>.<br /> - Att älska sändebudet ﷺ.<span class="c6"><br /> Profeten ﷺ sa:</span> "Vid den vars hand min själ vilar i! Ingen av er kommer att tro förrän jag är mer älskad till honom än hans förälder och barn" <span class="c2">(återberättad av al-Bukhari)</span>.<br /> - Att älska de troende och att önska gott för dem på samma sätt som man önskar gott för sig själv.<span class="c6"><br /> Profeten ﷺ sa:</span> "Ingen av er tror förrän han önskar för sin broder det han önskar för sig själv" <span class="c2">(återberättad av al-Bukhari)</span>. </p>',
            ],
            15 => [
                'question' => 'F16: Definiera vad det innebär att visa upp glädje?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13630.mp3',
                'answer' => '<p> S: Det är att ha ett glatt leende ansikte som visar upprymdhet och vänlighet, samtidigt som man har ett välkomnande beteende när man träffar andra.<br /> Det är motsatsen till att se sur ut när man träffar andra, eftersom det stöter bort dem.<br /> Flera Hadither visar dygden i att visa upp glädje. Abu Dharr <span class="c2">(må Allah vara nöjd med honom)</span> berättade att profeten ﷺ sa: "Se aldrig ner på någon god handling, även om det skulle vara att möta din broder med ett leende ansikte" <span class="c2">(återberättad av Muslim)</span>.<span class="c6"> Allahs sändebud ﷺ sa:</span> "Att du ler mot din broder räknas som välgörenhet" <span class="c2">(återberättad av at-Tirmidhi)</span>. </p>',
            ],
            16 => [
                'question' => 'F17: Vad är avundsjuka?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13690.mp3',
                'answer' => '<p> S: Det är att önska att andras välsignelser upphör, eller att hata att se andra människor få välsignelser.<span class="c6"><br /> Allah säger:</span> "Och <span class="c5">[jag tar skydd hos Allah]</span> från ondskan hos den avundsamme när han avundas" <span class="c2">(113:5)</span>.<br /> Anas bin Malik <span class="c2">(må Allah vara nöjd med honom)</span> berättade att Allahs sändebud ﷺ sa: "Hata inte varandra, var inte avundsamma mot varandra, vänd inte ryggen mot varandra. Allahs tjänare! Var istället bröder" <span class="c2">(återberättad av al-Bukhari och Muslim)</span>. </p>',
            ],
            17 => [
                'question' => 'F18: Vad innebär det att göra narr av andra?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13740.mp3',
                'answer' => '<p> S: Det innebär att du gör narr av din muslimska broder och ser ner på honom, och detta är inte tillåtet.<span class="c6"><br /> Allah säger då han förbjuder detta:</span> "Troende! Inga män ska göra narr av andra män - det må hända att de är bättre än dem själva. Inte heller ska kvinnor <span class="c5">[göra narr]</span> av andra kvinnor - det må hända att även de är bättre än dem själva. Ni ska inte smäda varandra och inte ge varandra öknamn. Det är en ond sak att bära syndighetens namn efter att man antagit tron. Och de som inte visar ånger - dessa är de orättfärdiga" <span class="c2">(49:11)</span>. </p>',
            ],
            18 => [
                'question' => 'F19: Definiera ödmjukhet?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13780.mp3',
                'answer' => '<p> S: Det innebär att en person inte ser sig överlägsen andra människor, därför ser han inte ner på andra eller förkastar sanningen.<span class="c6"><br /> Allah säger:</span> "Den Nåderikes tjänare är de som vandrar ödmjukt på jorden" <span class="c2">(25:63)</span>. Vilket innebär att de är ödmjuka. -<span class="c6"> Allahs sändebud ﷺ sa:</span> "Ingen ödmjukar sig för Allahs skull utan att Allah upphöjer honom" <span class="c2">(återberättad av Muslim)</span>. -<span class="c6"> Profeten ﷺ sade även:</span> "Allah uppenbarade för mig att ni ska vara ödmjuka, så att ingen begår förtryck mot någon annan, eller skryter och trycker ned en annan" <span class="c2">(återberättad av Muslim)</span>. </p>',
            ],
            19 => [
                'question' => 'F20: Vad finns det för former av förbjudet högmod?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13840.mp3',
                'answer' => '<p> S: 1. Högmod kopplat till sanningen, vilket är att avvisa sanningen och vägra att acceptera den.<br /> 2. Högmod mot människor genom att se ner på dem och förminska dem.<span class="c6"><br /> Allahs sändebud ﷺ sa:</span> "Den som har minsta lilla högmod i sitt hjärta kommer inte att träda in i paradiset.<span class="c6">" Då sa en man:</span> "Hur är det om man gillar att ha fina kläder och skor?" Profeten ﷺ svarade: "Allah är vacker och älskar det som är vackert. Högmod är att avvisa sanningen och att se ner på människor" <span class="c2">(återberättad av Muslim)</span>.<br /> -<span class="c6"> Avvisa sanningen:</span> förkasta den.<br /> -<span class="c6"> Se ner på människor:</span> förminska dem.<br /> - Att ha fina kläder och skor är alltså inte högmodigt. </p>',
            ],
            20 => [
                'question' => 'F21: Nämn olika former av förbjuden lurendrejeri?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13910.mp3',
                'answer' => '<p> S: - Att luras vid köp och försäljning genom att dölja varans defekt.<br /> - Att luras vid studier, som när elever fuskar på prov.<br /> - Att luras i tal, som att vittna falskt eller ljuga.<br /> - Att bryta mot sina avtal med andra.<br /> Att lurendrejeri är förbjudet tydliggörs i Hadithen då Allahs sändebud ﷺ passerade staplar av mat. När han la sin hand i det kom det fukt på hans fingrar.<span class="c6"> Han frågade:</span> "Du som äger maten! Vad är detta?" Han svarade: "Allahs sändebud! Det kom regn på det.<span class="c6">" Då sa profeten ﷺ:</span> "Varför la du inte den fuktiga delen överst så att människor kan se det? Den som lurar har inget med mig att göra" <span class="c2">(återberättad av Muslim)</span>.<span class="c6"><br /> Staplar av mat:</span> mat som placerats över varandra. </p>',
            ],
            21 => [
                'question' => 'F22: Vad är baktal?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13990.mp3',
                'answer' => '<p> S: Det är att nämna din frånvarande broder på ett sätt som han skulle ogilla.<span class="c6"><br /> Allah säger:</span> "Baktala inte varandra. Skulle någon av er tycka om att äta sin döda broders kött? Nej, ni skulle avsky det. Frukta därför Allah! Allah godtar ständigt ånger och är benådande" <span class="c2">(49:12)</span>. </p>',
            ],
            22 => [
                'question' => 'S23: Vad är skvaller?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14030.mp3',
                'answer' => '<p> S: Det är att sprida vad människor säger om varandra för att skapa problem mellan dem.<span class="c6"><br /> Allahs sändebud ﷺ sa:</span> "Skvallraren kommer inte att träda in i paradiset" <span class="c2">(återberättad av Muslim)</span>. </p>',
            ],
            23 => [
                'question' => 'F24: Vad är lathet?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14070.mp3',
                'answer' => '<p> S: Det är att vara slö när det kommer till att utföra goda handlingar, som människan måste utföra.<br /> Exempel på det är att lata sig när det kommer till att utföra obligatoriska handlingar.<span class="c6"><br /> Allah säger:</span> "Hycklarna tror att de kan bedra Allah, men det är han som bedrar dem. När de väl reser sig för att be är de slöa, och de gör det bara för att bli sedda av andra människor och de minns knappt Allah överhuvudtaget" <span class="c2">(4:142)</span>.<br /> Därför ska den troende undvika att vara lat, slö eller stillasittande. Han ska vara ivrig att göra gott, vara aktiv och sträva efter att göra det Allah är nöjd med i detta liv. </p>',
            ],
            24 => [
                'question' => 'F25: Nämn olika former av ilska?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14130.mp3',
                'answer' => '<p> S: 1.<span class="c6"> Prisvärd ilska:</span> Att bli arg för Allahs skull när någon överskrider hans gränser.<br /> 2.<span class="c6"> Klandervärd ilska:</span> Ilskan som får en människa att göra och säga saker som hon inte borde göra och säga.<span class="c6"><br /> Hur klandervärd ilska dämpas:</span><br /> Genom att utföra Wudu <span class="c2">(tvagning)</span>.<br /> Genom att sätta sig om man står upp, eller lägga sig ner om man redan sitter.<span class="c6"><br /> Genom att hålla fast vid rådet som profeten ﷺ gav:</span> "Bli inte arg".<br /> Genom självkontroll vid ilska.<br /> Genom att skydd hos Allah från den fördömde djävulen.<br /> Genom att vara tyst. </p>',
            ],
            25 => [
                'question' => 'F26: Vad är spioneri?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14240.mp3',
                'answer' => '<p> S: Det är att snoka och försöka avslöja människors brister och det som de egentligen vill dölja.<span class="c6"><br /> Exempel på förbjuden spioneri:</span><br /> - Att titta in i folks hem och privata angelägenheter.<br /> - Att tjuvlyssna på andra när de inte är uppmärksamma.<span class="c6"><br /> Allah säger:</span> "Spionera inte på varandra.." <span class="c2">(49:12)</span>. </p>',
            ],
            26 => [
                'question' => 'F27: Vad är slöseri? Vad är snålhet? Vad är generositet?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14310.mp3',
                'answer' => '<p> S: Slöseri är att spendera pengar fel.<br /> Motsatsen till det är snålhet, vilket är att hålla tillbaka pengar och inte spendera de rätt.<br /> Det korrekta beteendet är att ta en mellanväg mellan slöseri och snålhet, muslimen ska alltså vara generös.<span class="c6"><br /> Allah säger:</span> "Och när de ger åt andra är de inte slösaktiga och inte heller snåla, utan de finner en medelväg däremellan" <span class="c2">(25:67)</span>. </p>',
            ],
            27 => [
                'question' => 'F28: Vad är feghet?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14370.mp3',
                'answer' => '<p> S: Feghet är att vara rädd för något som man egentligen inte bör vara rädd för.<br /> Som att vara rädd för att säga sanningen eller att fördöma det onda.<br /> Mod är att våga göra det som är rätt, som att gå ut på slagfältet för att försvara islam och muslimer.<span class="c6"><br /> Och profeten ﷺ brukade säga i åkallan:</span> "Allah! Jag söker skydd hos dig från feghet.<span class="c6">" Allahs sändebud ﷺ sa även:</span> "Den starke troende är bättre och mer älskad till Allah än den svage troende, även om det finns gott i båda" <span class="c2">(återberättad av Muslim)</span>. </p>',
            ],
            28 => [
                'question' => 'F29: Nämn vissa saker som är förbjudna att uttala?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14440.mp3',
                'answer' => '<p> S: - Att förbanna och förolämpa andra.<br /> - Som att en person kallar någon annan för djur eller liknande ord.<br /> - Att säga fula och snuskiga ord.<br /> -<span class="c6"> Profeten ﷺ förbjöd från allt liknande då han sa:</span> "Den troende är varken den som förtalar eller förbannar mycket, inte heller den som är oanständig eller ful i mun" <span class="c2">(återberättad av at-Tirmidh och Ibn Hibban)</span>. </p>',
            ],
            29 => [
                'question' => 'F30: Nämn olika verktyg en muslim kan använda sig av för att förbättra sin karaktär?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14500.mp3',
                'answer' => '<p> S: 1. Att be Allah skänka dig en god karaktär och att han hjälper dig uppnå det.<br /> 2. Att vara medveten om Allah; att han vet vad du gör, hör och ser dig.<br /> 3. Att minnas belöningen för god karaktär och att den är en av orsakerna till att man kommer till paradiset.<br /> 4. Att minnas konsekvenserna av en dålig karaktär och att den är en av anledningarna till att man kommer till helvetet.<br /> 5. Att god karaktär leder till att Allah älskar dig och att människor också älskar dig. Likaså att dålig karaktär leder till att Allah ogillar dig och att människor också dig.<br /> 6. Att läsa profetens ﷺ biografi och att ha honom som förebild.<br /> 7. Att ha ett bra umgänge och undvika ett dåligt umgänge. </p>',
            ],
        ],
        8 => [
            0 => [
                'question' => 'F1: Vad är dygden med att minnas Allah?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14630.mp3',
                'answer' => '<p> S: Profeten ﷺ sa: "Liknelsen av den som minns sin Herre och den som inte minns sin Herre är liknelsen av en levande och en död" <span class="c2">(återberättad av al-Bukhari)</span>.<br /> - Anledningen till detta är att det sanna värdet i människans liv går tillbaka till hur mycket hon minns Allah. </p>',
            ],
            1 => [
                'question' => 'F2: Nämn olika fördelar med att minnas Allah?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14670.mp3',
                'answer' => '<p> S: 1. Det behagar Allah.<br /> 2. Det stöter bort Satan.<br /> 3. Det skyddar muslimen mot ondska.<br /> 4. Det leder till belöning. </p>',
            ],
            2 => [
                'question' => 'F3: Vad är den bästa åminnelsen?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14730.mp3',
                'answer' => '<p> S: "La ilaha illallah" <span class="c2">(Det finns ingen sann gud utom Allah)</span>, <span class="c2">(återberättad av at-Tirmidhi och Ibn Majah)</span>. </p>',
            ],
            3 => [
                'question' => 'F4: Vad ska man säga när man vaknat från sömnen?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14760.mp3',
                'answer' => '<p> S: "Al-hamdu lillahi lladhi ahyana ba\'da ma amatana wa ilayhin-nushur" <span class="c2">(All lovprisning tillkommer Allah som gav oss liv efter att han fått oss att dö, och till honom är återvändandet)</span>, <span class="c2">(återberättad av al-Bukhari och Muslim)</span>. </p>',
            ],
            4 => [
                'question' => 'F5: Vad ska man säga när man klätt på sig?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14790.mp3',
                'answer' => '<p> S: "Al-hamdu lillahi lladhi kasani hadhath-thawba wa razaqnihi min ghayri hawlin minni wa la quwwah" <span class="c2">(All lovprisning tillkommer Allah som klätt mig med detta plagg och försett mig med det. Min rörelse och styrka är endast med Allahs vilja)</span>, <span class="c2">(återberättad av Abu Dawud, at-Tirmidhi och andra)</span>. </p>',
            ],
            5 => [
                'question' => 'F6: Vad säger man när man klär av sig sina kläder?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14820.mp3',
                'answer' => '<p> S: "Bismillah" <span class="c2">(I Allahs namn)</span>, <span class="c2">(återberättad av at-Tirmidhi)</span>. </p>',
            ],
            6 => [
                'question' => 'F7: Vad säger man när man sätter på sig nya kläder?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14850.mp3',
                'answer' => '<p> S: "Allahumma lakal hamd, anta kasawtanih, as\'aluka khayrahu wa khayra ma suni\'a yahu wa a\'udhu bika min sharrihi wa sharri ma suni\'a lah" <span class="c2">(Allah! Dig tillkommer alla lovprisningar du har klätt mig med detta plagg. Jag ber dig om dess godhet och det goda som det gjorts för och jag söker ditt skydd från det onda i det och det onda som det gjorts för)</span>, <span class="c2">(återberättad av Abu Dawud, at-Tirmidhi och andra)</span>. </p>',
            ],
            7 => [
                'question' => 'F8: Vad säger man till någon som har på sig nya kläder?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14880.mp3',
                'answer' => '<p> S: Om man ser någon ha på sig nya kläder ber man för den och säger: "Tubli wa yukhlifullahu ta\'ala" <span class="c2">(Må Allah ersätta den <span class="c5">[med bättre]</span> när den kommer att bli gammal <span class="c5">[och utsliten]</span>", (återberättad av Abu Dawud)</span>. </p>',
            ],
            8 => [
                'question' => 'F9: Nämn den åkallan som man säger när man går in på toaletten?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14910.mp3',
                'answer' => '<p> S: "Allahumma inni a\'udhu bik minal-khubthi wal-kaba\'ith" <span class="c2">(Allah! Jag söker tillflykt hos dig från de manliga och kvinnliga djävlarna)</span>, <span class="c2">(återberättad av al-Bukhari och Muslim)</span>. </p>',
            ],
            9 => [
                'question' => 'F10: Vilken åkallan säger man när man går ut från toaletten?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14940.mp3',
                'answer' => '<p> S: "Ghufranak" <span class="c2">(Jag söker din förlåtelse)</span>, <span class="c2">(återberättad av Abu Dawud, at-Tirmidhi och andra)</span>. </p>',
            ],
            10 => [
                'question' => 'F11: Vad säger man innan Wudu (tvagning)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14970.mp3',
                'answer' => '<p> S: "Bismillah" <span class="c2">(I Allahs namn)</span>, <span class="c2">(återberättad av Abu Dawud m.fl.)</span>. </p>',
            ],
            11 => [
                'question' => 'F12: Vilken åkallan säger man när man utfört sin Wudu (tvagning)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15000.mp3',
                'answer' => '<p> "Ash-hadu an la ilaha illallah, wahdahu la sharika lah, wa ash-hadu anna Muhammadan \'abduhu wa rasuluh" <span class="c2">(Jag bär vittne att det inte finns någon sann gud utom Allah, och jag bär vittne att Muhammed är hans tjänare och sändebud)</span>, <span class="c2">(återberättad av Muslim)</span>. </p>',
            ],
            12 => [
                'question' => 'F13: Vilken åkallan säger man när man går ut från hemmet?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15020.mp3',
                'answer' => '<p> S: "Bismillahi tawakkaltu \'alallahi wa la hawla wa la quwwata illa billah" <span class="c2">(I Allahs namn, jag sätter min lit till Allah, och det finns ingen rörelse eller styrka utom från Allah)</span>, <span class="c2">(återberättad av Abu Dawud, at-Tirmidhi och andra)</span>. </p>',
            ],
            13 => [
                'question' => 'F14: Vilken åkallan säger man när man träder in i huset?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15050.mp3',
                'answer' => '<p> S: "Bismillahi walajna wa bismillahi kharajna wa \'ala Rabbina tawakkalna" <span class="c2">(I Allahs namn stiger vi in och i Allahs namn lämnar vi <span class="c5">[hemmet]</span> och till Allah vår Herre har vi satt vår tillit)</span>, <span class="c2">(återberättad av Abu Dawud)</span>. </p>',
            ],
            14 => [
                'question' => 'F15: Vilken åkallan säger man när man går in i moskén?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15080.mp3',
                'answer' => '<p> S: "Allahumma-ftah li abwaba rahmatik" <span class="c2">(Allah! Öppna för mig dörrarna till din nåd)</span>, <span class="c2">(återberättad av Muslim)</span>. </p>',
            ],
            15 => [
                'question' => 'F16: Vilken åkallan säger man när man går ut ifrån moskén?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15110.mp3',
                'answer' => '<p> S: "Allahumma inni as\'aluka min fadlik" <span class="c2">(Allah! Jag ber dig om din godhet)</span>, <span class="c2">(återberättad av Muslim)</span>. </p>',
            ],
            16 => [
                'question' => 'F17: Vad säger man när man hört Adhan?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15140.mp3',
                'answer' => '<p> S: Säger samma ord som böneroparen säger förutom vid "Hayya \'alas-salah" <span class="c2">(Kom till bönen)</span> och "Hayya \'alal-falah" <span class="c2">(Kom till framgång)</span>.<span class="c6"> Då säger man:</span> "La hawla wa la quwwata illa billah" <span class="c2">(Det finns ingen rörelse eller styrka utom från Allah)</span>, <span class="c2">(återberättad av al-Bukhari och Muslim)</span>. </p>',
            ],
            17 => [
                'question' => 'F18: Vad säger man efter Adhan (bönekallelsen)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15170.mp3',
                'answer' => '<p> S: Du ber Allah hylla profeten ﷺ, <span class="c2">(återberättad av Muslim)</span>.<span class="c6"> Sen säger du:</span> "Allahumma Rabba hadhihid-da\'watit-tammah was-salatil-qa\'imah, ati Muhammadanil-wasilata wal-fadhilah, wab\'ath-hu maqamam-mahmudanil-lati wa\'adtahu" <span class="c2">(Allah! Herren till detta fullkomliga kall och den bestående bönen. Ge Muhammed högsta nivån i paradiset, upphöj hans status, och låt honom återuppstå på den plats där han prisas som du lovat honom)</span> <span class="c2">(återberättad av al-Bukhari)</span>.<br /> Man bör åkalla Allah mellan Adhan och Iqamah <span class="c2">(andra bönekallet)</span>, eftersom åkallan inte avvisas då. </p>',
            ],
            18 => [
                'question' => 'F19: Vilka åminnelser borde man säga på morgonen och kvällen?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15220.mp3',
                'answer' => '<p> S: Läs Ayatul-<span class="c6">Kursi:</span> "Allah! - det finns ingen sann gud utom han, den Levande, skapelsens evige Vidmakthållare. Slummer överraskar honom inte och inte heller sömn. Honom tillhör allt det som himlarna rymmer och det som jorden bär. Vem är den som vågar tala <span class="c5">[för någon]</span> inför honom utan hans tillstånd? Han vet allt vad <span class="c5">[människor]</span> kan veta och allt som är dolt för dem och av hans kunskap kan de inte omfatta mer än han tillåter. Hans fotpall omsluter himlarna och jorden. Att värna och bevara dem är för honom ingen börda. Han är den Höge, den Väldige" <span class="c2">(2:255)</span>. 2.<span class="c6"> Att läsa:</span> "I Allahs namn, den Nåderike, den Barmhärtige.<span class="c6"> Säg:</span> \'Han är Allah, <span class="c5">[och han är]</span> En. Allah är den Suveräne. Han har inte avlat, och inte heller är han avlad, och det finns ingen som är lik honom\'" tre gånger. I Allahs namn, den Nåderike, den Barmhärtige.<span class="c6"> Säg:</span> \'Jag tar skydd hos dagbräckningens Herre, mot ondskan hos det han skapat, och mot ondskan hos den mörknande <span class="c5">[natten]</span> när den faller på, och mot ondskan hos dem som blåser på knutar, och mot ondskan hos den avundsamme när han avundas\'" tre gånger. I Allahs namn, den Nåderike, den Barmhärtige.<span class="c6"> Säg:</span> \'Jag tar skydd hos människornas Herre, människornas Konung, människornas Gud, mot den viskande smitarens ondska. Han som viskar i människornas bröst, bland <span class="c5">[både]</span> jinnerna och människorna\'" tre gånger. "Allahumma anta Rabbi la ilaha illa Ant, khalaqtani wa ana \'abduk, wa ana \'ala \'ahdika wa wa\'dika mas-tata\'t, a\'udhu bika min sharri ma sana\'t, abu´u laka bini\'matika \'alayy, wa abu´u bidhanbi faghfir li fa\'innahu la yaghfirudh-dhunuba illa Ant"<br /> <br /> <span class="c2">(Allah! Du är min Herre. Ingen har rätt att dyrkas förutom du. Du har skapat mig och jag är din tjänare. Jag fullgör min plikt <span class="c5">[gentemot dig]</span> i hopp om belöning, enligt min förmåga. Jag söker skydd hos dig för det onda jag gjort. Jag erkänner dina välsignelser över mig och jag erkänner mina synder, så förlåt mig, för sannerligen förlåter ingen synder utom du)</span>, <span class="c2">(återberättad av al-Bukhari)</span>. </p>',
            ],
            19 => [
                'question' => 'F20: Vad säger man innan det är dags att sova?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15290.mp3',
                'answer' => '<p> S: "Bismika allahumma amutu wa ahya" <span class="c2">(Allah! I ditt namn dör jag och lever)</span>, <span class="c2">(återberättad av al-Bukhari och Muslim)</span>. </p>',
            ],
            20 => [
                'question' => 'F21: Vad säger man innan man äter?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15320.mp3',
                'answer' => '<p> S: "Bismillah" <span class="c2">(I Allahs namn)</span>,<span class="c6"><br /> Om man glömmer att säga det i början säger man:</span><br /> "Bismillahi fi awwalihi wa akhirih" <span class="c2">(I Allahs namn i början och i slutet)</span>, <span class="c2">(återberättad av Abu Dawud, at-Tirmidhi och andra)</span>. </p>',
            ],
            21 => [
                'question' => 'F22: Vad säger man när man ätit klart?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15370.mp3',
                'answer' => '<p> S: "Al-hamdu lillahi lladhi at\'amani hadha wa razaqnihi min ghayri hawlin minni wa la quwwah" <span class="c2">(All lovprisning tillkommer Allah som försett mig med denna mat och gav mig det utan någon rörelse eller styrka från mig)</span>, <span class="c2">(återberättad av Abu Dawud, Ibn Majah och andra)</span>. </p>',
            ],
            22 => [
                'question' => 'F23: Vad bör gästen säga i sin bön för värden?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15400.mp3',
                'answer' => '<p> S: "Allahumma bark lahum fima razaqtahum waghfir lahum warhamhum" <span class="c2">(Allah! Välsigna det du försörjt dem med, förlåt dem och visa dem nåd)</span>, <span class="c2">(återberättad av Muslim)</span>. </p>',
            ],
            23 => [
                'question' => 'F24: Vad säger man när man har nyst?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15430.mp3',
                'answer' => '<p> S: "Alhamdulillah" <span class="c2">(All lovprisning tillkommer Allah)</span>,<span class="c6"><br /> Då ska hans bror och följeslagare svara honom med:</span> "Yarhamakallah" <span class="c2">(Må Allah visa dig nåd)</span>.<span class="c6"><br /> Då svarar den som nyst:</span> "Yahdikumullahu wa yuslihu balakum" <span class="c2">(Må Allah vägleda er och korrigera er situation)</span>, <span class="c2">(återberättad av al-Bukhari)</span>. </p>',
            ],
            24 => [
                'question' => 'F25: Vad säger man innan man lämnar eller avslutar en samling (Du\'a al-kaffarah)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15480.mp3',
                'answer' => '<p> "Subhanak allahumma wa bihamdik, ash-hadu an la ilaha illa ant, astaghfiruka wa atubu ilayk" <span class="c2">(Allah! Du är fri från brister och all lovprisning tillkommer dig. Jag söker din förlåtelse och vänder mig till dig i ånger)</span>, <span class="c2">(återberättad av Abu Dawud, at-Tirmidhi och andra)</span>. </p>',
            ],
            25 => [
                'question' => 'F26: Vilken åkallan säger man när man ska åka något färdmedel?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15510.mp3',
                'answer' => '<p> S: "Bismillah, walhamdu lillah. \'Subhanal-ladhi sakhkhara lana hadha wa ma kunna lahu muqrinin. Wa inna ila Rabbina lamunqalibun.\' Alhamdulillah, alhamdulillah, alhamdulillah, Allahu Akbar, Allahu Akbar, Allahu Akbar, subhanakal-lahumma inni dhalamtu nafsi faghfir li, fa innahu la yaghfirudh-dhunuba illa ant"<br /> <span class="c2">(I Allahs Namn. Alla lovprisningar tillkommer Allah. Fri från alla brister är han som låter oss förfoga över detta; själva skulle vi inte ha kunnat ta det i vår tjänst, och vi skall vända tillbaka till vår Herre. Alla lovprisningar tillkommer Allah. Alla lovprisningar tillkommer Allah. Alla lovprisningar tillkommer Allah. Allah är större. Allah är större. Allah är större. Allah! Fri är du från alla brister. Jag har varit orättvis mot mig själv, så förlåt mig, ingen annan än du förlåter synder)</span>, <span class="c2">(återberättad av Abu Dawud, at-Tirmidhi och andra)</span>. </p>',
            ],
            26 => [
                'question' => 'F27: Vilken åkallan säger man vid resa?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15540.mp3',
                'answer' => '<p> S: "Allahu akbar, Allahu akbar, Allahu akbar, Subhanal-ladhi sakhkhara lana hadha wa ma kunna lahu muqrinin. Wa inna ila Rabbina lamunqalibun.” Allahumma inna nas\'aluka fi safarina hadhal-birra wattaqwa, wa minal-\'amali ma tarda, Allahumma hawwin \'alayna safarana hadha watwi \'anna bu\'dah, Allahumma antas-sahibu fis-safar, walkhalifatu fil-ahl, Allahumma inni a\'udhu bika min wa\'tha´is-safar, wa ka\'abatil-mandhar, wa su´il-munqalabi fil-mali wal-ahl"<br /> <span class="c2">(Allah är större. Allah är större. Allah är större. Fri från alla brister är han som låter oss förfoga över detta <span class="c5">[färdmedel]</span>; själva skulle vi inte ha kunnat ta det i vår tjänst, och vi skall <span class="c5">[en dag]</span> vända tillbaka till vår Herre <span class="c5">[efter döden]</span>. Allah! Vi ber dig om fromhet, gudsfruktan och handlingar som behagar dig under vår resa. Allah! Underlätta för oss vår resa och förkorta för oss det långa avståndet. Du är den som vakar över oss under resan och bevarar familjen vi lämnat bakom oss. Allah! Jag söker skydd hos dig mot resans svårigheter, en tragisk syn och en dålig återkomst till min egendom och familj)</span>.<span class="c6"><br /> Och när man återvänder från resan lägger man till:</span><br /> "Ayibuna, ta\'ibuna, \'abidun, li Rabbina hamidun" <span class="c2">(Vi återvänder, ångrar oss, dyrkar och lovprisar vår Herre)</span>, <span class="c2">(återberättad av Muslim)</span>. </p>',
            ],
            27 => [
                'question' => 'F28: Vilken åkallan säger den resande för den bosatte?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15590.mp3',
                'answer' => '<p> "Astawdi\'ukumullah lladhi la tadi\'u wada\'i\'uh" <span class="c2">(Jag lämnar er i Allahs förvar och skydd, det som är i hans förvar försvinner inte)</span>, <span class="c2">(återberättad av Ahmad och Ibn Majah)</span>. </p>',
            ],
            28 => [
                'question' => 'F29: Vilken åkallan säger den bosatte för den resande?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15620.mp3',
                'answer' => '<p> S: "Astawdi\'ullaha dinaka wa amanataka wa khawatima \'amalik" <span class="c2">(Jag lämnar din religion, ditt ansvarsområde och dina sista handlingar i Allahs förvar)</span>, <span class="c2">(återberättad av Ahmad och at-Tirmidhi)</span>. </p>',
            ],
            29 => [
                'question' => 'F30: Vilken åkallan läses när man går in på marknaden?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15650.mp3',
                'answer' => '<p> "La ilaha illallahu wahdahu la sharika lah, lahul-mulku wa lahul-hamd, yuhyi wa yumit, wa huwa hayyun la yamut, biyadihil-khayru, wa huwa \'ala kulli shay´in qadir" <span class="c2">(Ingen har rätt att dyrkas förutom Allah. Han är En och han har ingen vid sin sida. Till honom hör herraväldet och all lovpris. Han ger liv och död och han lever och dör inte. I hans hand ligger det goda och han är kapabel till allting)</span>, <span class="c2">(återberättad av at-Tirmidhi och Ibn Majah)</span>. </p>',
            ],
            30 => [
                'question' => 'F31: Nämn den åkallan som sägs vid ilska?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15680.mp3',
                'answer' => '<p> S: "A\'udhu billahi minash-shaytanir-rajim" <span class="c2">(Jag söker skydd hos Allah från Satan, den utstötte)</span>, <span class="c2">(återberättad av al-Bukhari och Muslim)</span>. </p>',
            ],
            31 => [
                'question' => 'F32: Vad säger du till den som varit snäll mot dig?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15710.mp3',
                'answer' => '<p> S: "Jazakallahu khayran" <span class="c2">(Må Allah belöna dig med gott)</span>, <span class="c2">(återberättad av at-Tirmidhi)</span>. </p>',
            ],
            32 => [
                'question' => 'F32: Vilken åkallan säger man om transportmedlet skakar till?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15740.mp3',
                'answer' => '<p> S: "Bismillah" <span class="c2">(I Allahs namn)</span>, <span class="c2">(återberättad av Abu Dawud)</span>. </p>',
            ],
            33 => [
                'question' => 'F32: Vad säger du om något glädjande händer dig?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15770.mp3',
                'answer' => '<p> S: "Alhamdulillahil-ladhi bi ni\'matihi tatimmus-salihat" <span class="c2">(Lovprisad vare Allahs vars genom hans välsignelse goda saker fullbordas)</span>, <span class="c2">(återberättad av al-Hakim och andra)</span>. </p>',
            ],
            34 => [
                'question' => 'F35: Vad säger du om drabbas av något du ogillar?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15800.mp3',
                'answer' => '<p> S: "Alhamdulillahi \'ala kulli hal" <span class="c2">(Allah är lovprisad i alla situationer)</span>, <span class="c2">(Sahih al-Jami\')</span>. </p>',
            ],
            35 => [
                'question' => 'F36: Hur hälsar du på andra och hur besvarar du hälsningen?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15830.mp3',
                'answer' => '<p> S: Genom att säga: "As-salamu \'alaykum wa rahmatullahi wa barakatuh" <span class="c2">(Frid vare med er och Allahs nåd och välsignelser)</span>,<span class="c6"><br /> Då ska den som fått hälsningen svara:</span> "Wa \'alaykumus-salamu wa rahmatullahi wa barakatuh" <span class="c2">(Må frid, Allahs nåd och välsignelse vara över er med)</span>, <span class="c2">(återberättad av at-Tirmidhi, Abu Dawud m.fl.)</span>. </p>',
            ],
            36 => [
                'question' => 'F37: Vilken åkallan ska nämnas i samband med regn?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15870.mp3',
                'answer' => '<p> S: "Allahumma sayyiban nafi\'a" <span class="c2">(Allah! Gör det till ett gynnsamt regn)</span>, <span class="c2">(återberättad av al-Bukhari)</span>. </p>',
            ],
            37 => [
                'question' => 'F38: Vad säger man när det slutat regna?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15900.mp3',
                'answer' => '<p> S: "Mutirna bi fadlillahi wa rahmatih" <span class="c2">(Vi gavs regn genom Allahs godhet och nåd)</span>, <span class="c2">(återberättad av al-Bukhari och Muslim)</span>. </p>',
            ],
            38 => [
                'question' => 'F39: Vilken åkallan sägs när det blåser?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15930.mp3',
                'answer' => '<p> S: "Allahumma inni as\'aluka khayraha wa a\'udhu bika min sharriha" <span class="c2">(Allah! Jag ber dig om dess goda och jag söker skydd hos dig från dess onda)</span>, <span class="c2">(återberättad av Abu Dawud och Ibn Majah)</span>. </p>',
            ],
            39 => [
                'question' => 'F40: Nämn åkallan som sägs när man hör åska?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15960.mp3',
                'answer' => '<p> S: "Subhanalladhi yusabbihur-ra\'du bi hamdihi wal-mala\'ikatu min khifatih" <span class="c2">(Glorifierad vare han som åskan upphöjer med lovprisningar och likaså änglarna av vördnad för honom)</span>, <span class="c2">(Muwatta\' Malik)</span>. </p>',
            ],
            40 => [
                'question' => 'F41: Vilken åkallan säger man om man ser en person som är svårt drabbad?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15990.mp3',
                'answer' => '<p> S: "Alhamdulillahil-ladhî \'afani mimmab-talaka bih wa faddalani \'ala kathirin mimman khalaqa tafdila" <span class="c2">(Alla lovprisningar tillkommer Allah, som har skonat mig från det som han har prövat dig med och som verkligen gett mig företräde framför många andra som han har skapat)</span>, <span class="c2">(återberättad av at-Tirmidhi)</span>. </p>',
            ],
            41 => [
                'question' => 'F42: Åkallan för den som fruktar att något ska drabbas av ens onda öga?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16020.mp3',
                'answer' => '<p> S: Hadithen säger: "Om någon av er ser något som ni blir förtjusta av hos er broder, er själva eller er egendom, så ska ni be Allah att välsigna det. För sannerligen är det onda ögat verkligt" <span class="c2">(återberättad av Ahmad, Ibn Majah m.fl.)</span>. </p>',
            ],
            42 => [
                'question' => 'F43: Vad säger man när man vill att Allah ska upphöja profeten ﷺ ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16050.mp3',
                'answer' => '<p> S: "Allahumma salli \'ala Muhammadin wa \'ala ali Muhammad, kama sallayta \'ala Ibrahima wa \'ala ali Ibrahim, innaka Hamidum-Majid.<br /> Allahumma barik \'ala Muhammadin wa \'ala ali Muhammad kama barakta \'ala Ibrahima wa \'ala ali Ibrahim, innaka Hamidum-Majid" <span class="c2">(Allah! Upphöj och ära Muhammed och Muhammeds familj, så som du upphöjde och ärade Ibrahim och Ibrahims familj, sannerligen är Lovprisad, Glorifierad. <br /> Allah! Välsigna Muhammed och Muhammeds familj, så som du välsignade Ibrahim och Ibrahims familj, sannerligen är du Lovprisad, Glorifierad)</span>, <span class="c2">(återberättad av al-Bukhari och Muslim)</span>. </p>',
            ],
        ],
        9 => [
            0 => [
                'question' => 'F1: Vilka är de fem bestämmelserna för handlingar?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16090.mp3',
                'answer' => '<p> S:<br /> 1. Obligatoriskt.<br /> 2. Rekommenderat.<br /> 3. Förbjudet.<br /> 4. Ogillat.<br /> 5. Tillåtet. </p>',
            ],
            1 => [
                'question' => 'F2: Förklara betydelsen av dessa fem bestämmelser?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16170.mp3',
                'answer' => '<p> S:<br /> 1.<span class="c6"> Obligatoriskt:</span> Så som de fem bönerna, fastan under Ramadan och att vara god mot sina föräldrar.<br /> - När en person gör det som är obligatoriskt belönas han för det, om han inte gör det kan han straffas för det.<br /> 2.<span class="c6"> Rekommenderat:</span> Så som att be utöver de fem dagliga bönerna och under natten, att ge andra människor mat och att hälsa på dem med fredshälsningen. Detta kallas även för Sunnah eller Mandub.<br /> - När en person gör en rekommenderad handling belönas han, men om han inte gör det straffas han inte.<span class="c6"><br /> En viktig punkt:</span><br /> När en muslim hör att någon handling är rekommenderad eller Sunnah bör han skynda med att utföra den, för att följa profetens riktlinjer.<br /> 3.<span class="c6"> Förbjudet:</span> Så som att dricka alkohol, bete sig illa mot föräldrarna eller bryta släktbanden.<br /> - En person som lämnar det förbjudna belönas för det, och den som gör det förbjudna kan straffas för det.<br /> 4.<span class="c6"> Ogillat:</span> Så som att ta eller ge något med vänster hand eller att ha sin klädsel knuten under bönen.<br /> - När en person lämnar det ogillade belönas han för det, men om han gör något ogillat straffas han inte för det.<br /> 5.<span class="c6"> Tillåtet:</span> Så som att äta ett äpple eller dricka te. Det kallas även för Ja\'iz och Halal.<br /> - En person som lämnar det tillåtna belönas inte för det, och den som gör det tillåtna straffas inte för det. </p>',
            ],
            2 => [
                'question' => 'F3: Vad har sälja och köpa för bestämmelse?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16320.mp3',
                'answer' => '<p> S: Den generella principen när det kommer till att köpa och sälja är att det är tillåtet, det är endast ett fåtal undantag som Allah förbjudit ifrån.<span class="c6"><br /> Allah säger:</span> "Allah har tillåtit handel och förbjudit ränta" <span class="c2">(2:275)</span>. </p>',
            ],
            3 => [
                'question' => 'F4: Nämn några former av handel som är förbjudna?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16360.mp3',
                'answer' => '<p> S:<br /> 1.<span class="c6"> Att luras:</span> Så som att dölja varans defekt.<br /> Abu Hurayrah <span class="c2">(må Allah vara nöjd med honom)</span> berättade att Allahs sändebud ﷺ passerade staplar av mat. När han la sin hand i det kom det fukt på hans fingrar.<span class="c6"> Han frågade:</span> "Du som äger maten! Vad är detta?" Han svarade: "Allahs sändebud! Det kom regn på det.<span class="c6">" Då sa profeten ﷺ:</span> "Varför la du inte den fuktiga delen överst så att människor kan se det? Den som lurar har inget med mig att göra" <span class="c2">(återberättad av Muslim)</span>.<br /> 2.<span class="c6"> Ränta:</span> Så som att låna tusen kronor från någon och betala tillbaka tvåtusen kronor.<br /> Att kräva mer tillbaka är förbjuden ränta.<span class="c6"><br /> Allah säger:</span> "Allah har tillåtit handel och förbjudit ränta" <span class="c2">(2:275)</span>.<br /> 3.<span class="c6"> Oviss och obestämd handel:</span> Som att sälja mjölken som fortfarande finns i tackan, eller fisken som en person inte fångat från havet än.<span class="c6"><br /> I en hadith har det nämnts att:</span> "Allahs sändebud ﷺ förbjöd oviss handel" <span class="c2">(återberättad av Muslim)</span>. </p>',
            ],
            4 => [
                'question' => 'F5: Nämn några välsignelser Allah har skänkt dig?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16460.mp3',
                'answer' => '<p> S: 1. Välsignelsen av att vara muslim och att inte vara icke-muslim.<br /> 2. Välsignelsen av att följa profetens väg, och att inte följa innovationer i religionen.<br /> 3. Välsignelsen av att vara frisk och välmående, att kunna höra, se, gå, med mera.<br /> 4. Välsignelsen av att ha mat, dryck och kläder.<br /> Allahs välsignelser, som han har skänkt oss, är så många att de inte går att räkna.<span class="c6"><br /> Allah säger:</span> "Om ni vill räkna Allahs välsignelser skulle ni aldrig kunna ange dem i antal" <span class="c2">(16:18)</span>. </p>',
            ],
            5 => [
                'question' => 'F6: Vad har man för plikt när det kommer till välsignelser och hur visar man tacksamhet för dem?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16540.mp3',
                'answer' => '<p> S: Det är obligatoriskt att visa tacksamhet för dem genom att prisa Allah och tacka honom i tal, eftersom all godhet enbart kommer från honom. Dessa välsignelser ska användas på ett sätt som Allah är nöjd med, och de ska inte användas för att trotsa honom. </p>',
            ],
            6 => [
                'question' => 'F7: Vad har muslimer för högtider?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16570.mp3',
                'answer' => '<p> S: Eid al-Fitr och Eid al-Ad\'ha.<br /> - Anas berättade att när Allahs sändebud ﷺ kom till Madinah brukade folket ha två dagar som de roade sig under.<span class="c6"> Profeten ﷺ frågade:</span> "Vilka dagar är dessa två dagar för?".<span class="c6"> De svarade:</span> "Vi brukade roa oss under dessa dagar innan islam".<span class="c6"> Då sa Allahs sändebud ﷺ:</span> "Allah har gett er något som är bättre än dessa två dagar: Ad\'ha-dagen och Fitr-dagen" <span class="c2">(återberättad av Abu Dawud)</span>.<br /> Alla högtider utöver dessa två Eid räknas som en innovation i religionen. </p>',
            ],
            7 => [
                'question' => 'F8: Vilken månad är bäst?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16620.mp3',
                'answer' => '<p> S: Månaden Ramadan. </p>',
            ],
            8 => [
                'question' => 'F9: Vilken dag är bäst?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16650.mp3',
                'answer' => '<p> S: Fredag. </p>',
            ],
            9 => [
                'question' => 'F10: Vilken är årets bästa dag?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16680.mp3',
                'answer' => '<p> S: \'Arafah-dagen. </p>',
            ],
            10 => [
                'question' => 'F11: Vilken är årets bästa natt?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16710.mp3',
                'answer' => '<p> S: Laylatul-Qadr. </p>',
            ],
            11 => [
                'question' => 'F12: Vad ska man göra om man ser en kvinna som inte är Mahram till en?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16740.mp3',
                'answer' => '<p> S: Man ska sänka blicken.<span class="c6"> Allah säger:</span> "Säg till de troende att de bör sänka sin blick" <span class="c2">(24:30)</span>. </p>',
            ],
            12 => [
                'question' => 'F13: Vilka är människans fiender?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16770.mp3',
                'answer' => '<p> 1. Själen som uppmanar till ondska. Det är när människan följer sina onda begär, som uppmanar henne att trotsa Allah.<span class="c6"> Allah säger:</span> "Sannerligen driver människans inre henne till det onda, utom hos den som min Herre visar nåd. Min Herre är förvisso förlåtande, benådande" <span class="c2">(12:53)</span>. 2.<span class="c6"> Satan:</span> han är människans fiende och hans mål är att vilseleda henne och uppmana henne till ont så att hon hamnar i helvetet.<span class="c6"> Allah säger:</span> "Följ inte Satans spår; han är, utan tvekan, er uppenbara fiende" <span class="c2">(2:168)</span>. 3. Ett dåligt umgänge som uppmanar en till ont och hindrar en från gott.<span class="c6"> Allah säger:</span> "De närmaste vännerna ska den dagen vara fiender till varandra - utom de gudfruktiga" <span class="c2">(43.67)</span>. </p>',
            ],
            13 => [
                'question' => 'F14: Vad är ånger?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16820.mp3',
                'answer' => '<p> S: Ånger är att återvända till Allah med lydnad efter att man syndat.<span class="c6"> Allah säger:</span> "Och jag är evigt förlåtande mot den som vänder sig <span class="c5">[till mig]</span> i ånger och antar tron och gör det goda, och sedan håller sig på rätt väg" <span class="c2">(20:82)</span>. </p>',
            ],
            14 => [
                'question' => 'F15: Vilka villkor har en korrekt ånger?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16850.mp3',
                'answer' => '<p> S: 1. Att sluta med synden.<br /> 2. Att känner sig ångerfull för att man begått synden.<br /> 3. Att vara fast besluten att inte göra synden igen.<br /> 4. Se till att ge tillbaka andras rättigheter.<span class="c6"><br /> Allah säger:</span> "De som, om de begår en skamlös handling eller gör orätt mot sig själva, minns Allah och ber honom om förlåtelse för sina synder – ja, vem kan förlåta synder utom Allah? – och som inte fortsätter att begå sådana handlingar mot bättre vetande" <span class="c2">(3:135)</span>. </p>',
            ],
            15 => [
                'question' => 'F16: Vad innebär det att be för profeten ﷺ ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16920.mp3',
                'answer' => '<p> S: Det innebär att du ber Allah prisa sin profet ﷺ i det högsta sällskapet. </p>',
            ],
            16 => [
                'question' => 'F17: Vad betyder "Subhanallah"?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16950.mp3',
                'answer' => '<p> S: Det är att säga att Allah är fri från alla brister, fel och ondska. </p>',
            ],
            17 => [
                'question' => 'F18: Vad betyder "Alhamdulillah"?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16980.mp3',
                'answer' => '<p> S: Det innebär att prisa Allah och beskriva honom med alla perfekta egenskaper. </p>',
            ],
            18 => [
                'question' => 'F19: Vad betyder "Allahu akbar"?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/17000.mp3',
                'answer' => '<p> S: Det innebär att Allah är större, väldigare och mäktigare än allting annat. </p>',
            ],
            19 => [
                'question' => 'F20: Vad betyder "La hawla wa la quwwata illa billah"?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/17030.mp3',
                'answer' => '<p> S: Det betyder att tjänaren inte kan gå från en situation till en annan eller ha någon styrka förutom om det kommer från Allah. </p>',
            ],
            20 => [
                'question' => 'F21: Vad betyder "Astaghfirullah"?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/17060.mp3',
                'answer' => '<p> S: Att tjänaren söker sin Herres förlåtelse genom att Allah suddar bort syndens spår och täcker för tjänarens brister. </p>',
            ],
        ],
    ],
];
