<?php
$data = [
    'title' => 'What Muslim Children Must Know',
    'description' => 'A project that contains a simple and easy curriculum for issues that a Muslim must know. It includes issues of belief, jurisprudence, prophetic biography, etiquette, tafsir, hadith, morals, and remembrance of Allah. It is suitable for young children in particular, for all ages, and newcomers to Islam.',
    'source' => 'https://kids.islamenc.com/ta/home',
    'author' => 'Yazan Abdul Razzaq Raziq Alghanim',
    'sections' => [
        0 => 'பகுதி (1) இஸ்லாமிய நம்பிக்கைக் (இறையியல்) கோட்பாடு',
        1 => 'பிக்ஹ் (இஸ்லாமிய சட்டப்) பகுதி',
        2 => 'நபி (ஸல்) அவர்களின் வரலாற்றுப் பிரிவு',
        3 => 'தப்ஸீர் (அல் குர்ஆன் விளக்கவுரை) பகுதி',
        4 => 'ஹதீஸ் (நபிமொழிகள்) பகுதி',
        5 => 'இஸ்லாமிய ஒழுக்க விழுமியங்கள் பற்றிய பகுதி',
        6 => 'நற்குணங்கள் பண்பாடுகள் பற்றிய பகுதி :',
        7 => 'துஆக்கள் மற்றும் திக்ர்கள் பற்றிய பகுதி :',
        8 => 'பல்வகை அம்சங்களை உள்ளடக்கிய பகுதி :',
    ],
    'data' => [
        1 => [
            0 => [
                'question' => 'கேள்வி 1: உனது இரட்சகன் யார்?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/200.mp3',
                'answer' => '<p> பதில் : எனது இரட்சகன் அல்லாஹ். அவனே தனது அருளினால் என்னையும் அகிலத்தாரையும் இரட்சித்து போசிப்பவனாவான்.<span class="c6"><br /> ஆதாரம் :</span> அல்லாஹ்வின் பின்வரும் கூற்றாகும் : "அல்ஹ்ம்து லில்லாஹி ரப்பில் ஆலமீன்" <span class="c2">(அகிலத்தார் அனைவரையும் படைத்து பரிபாலிக்கும் அல்லாஹ்வுக்கே எல்லாப் புகழும்)</span>. [ஸூறதுல் பாதிஹா <span class="c2">(2)</span>] </p>',
            ],
            1 => [
                'question' => 'உனது மார்க்கம் என்ன ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/240.mp3',
                'answer' => '<p> பதில் : இஸ்லாம் என்பது : ஏகத்துவப்படுத்துவதன் மூலம் அல்லாஹ்வுக்கு முழுமையாக சரணடைதல், வழிபடுவதன்மூலம் அவனுக்கு கட்டுப்படுதல், இணைவைத்தல் மற்றும் இணைவைப்பாளர்களைவிட்டும் முழுமையாக விலகி இருப்பதுமாகும்.<span class="c6"><br /> அல்லாஹ் கூறுகிறான் :</span> "நிச்சயமாக அல்லாஹ்விடத்தில் ஏற்றுக்கொள்ளப்பட்ட மார்க்கம் இஸ்லாம் மார்க்கமாகும்". <span class="c2">(ஆல இம்ரான் : 19)</span>. </p>',
            ],
            2 => [
                'question' => 'கேள்வி: 3 உனது நபி யார்?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/280.mp3',
                'answer' => '<p> பதில்: முஹம்மத் ஸல்லல்லாஹு அலைஹிவஸல்லம்<br /> அல்லாஹ் கூறுகிறான் : "முஹம்மத் அல்லாஹ்வின் தூதராவார்". <span class="c2">(ஸூறதுல்பத்ஹ் (29)</span>) </p>',
            ],
            3 => [
                'question' => 'கேள்வி 4 : ஒரிறைக் கொள்கையின் வார்த்தையையும் (திருக்கலிமாவையும்). அதன் கருத்து யாது என்பதையும் குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/310.mp3',
                'answer' => '<p> ஓரிறைக்கொள்கையின் வார்த்தை <span class="c2">(கலிமதுத் தவ்ஹீத் )</span> \'லாஇலாஹ இல்லல்லாஹ்; \'என்பதாகும் அதன் கருத்து உண்மையான வணக்கத்திற்குரியவன் அல்லாஹ்வதைதவிர வேறு யாருமில்லை என்பதாகும்.<span class="c6"><br /> அல்லாஹ் கூறுகிறான்:</span> இது குறித்து அல்லாஹ் பின்வருமாறு குறிப்பிடுகிறான் : "அல்லாஹ்வைத்தவிர உண்மையான வணக்கத்திற்குரியவன் வேறு யாருமில்லை என்பதை அறிந்து கொள்வீராக". <span class="c2">(ஸூறா முஹம்மத் : 19)</span>). </p>',
            ],
            4 => [
                'question' => 'கேள்வி 5 : அல்லாஹ் எங்கிருக்கிறான் ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/350.mp3',
                'answer' => '<p> பதில் : அல்லாஹ் வானத்தில் அர்ஷிற்கும் அனைத்து படைப்பினங்களுக்கு அப்பால் உள்ளான்.<span class="c6"> அல்லாஹ் கூறுகின்றான்:</span> "அளவற்ற அருளாளனாகிய அல்லாஹ்) அர்ஷின் மீது <span class="c2">(தன் மகிமைக்குத் தக்கவாறு)</span> உயர்ந்துவிட்டான்". <span class="c2">(ஸூறா தாஹா : 5)</span> மேலும் அல்லாஹ் கூறுகிறான்: "அவனே தனது அடியார்களுக்கு மேலிருந்து அடக்கி ஆள்பவன், மேலும் அவன் ஞானமிக்கவன் நன்கறிந்தவன்". <span class="c2">(ஸூறதுல் அன்ஆம் :18)</span> </p>',
            ],
            5 => [
                'question' => 'கேள்வி 6 : அல்லாஹ்வின் தூதர் முஹம்மத் ஆவார்கள் என்று சாட்சி கூறுவதன் கருத்து யாது?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/380.mp3',
                'answer' => '<p> பதில் : அதன் கருத்தாவது, அல்லாஹ் அவர்களை உலகத்தாருக்கு நன்மாராயம் கூறக்கூடியவர்களாகவும், அச்சமூட்டி எச்சரிக்கை செய்யக்கூடியவர்களாகவும் அனுப்பியுள்ளான் என்பதாகும்.<span class="c6"><br /> பின்வருவன அதில் கடமையாகும் :</span><br /> 1-அவர்களின் <span class="c2">(நபியவர்களின்)</span> கட்டளைகளை ஏற்று நடத்தல்.<br /> 2-அவர்கள் அறிவித்தவற்றை உண்மைப்படுத்துதல்.<br /> 3-அவர்களுக்கு மறுசெய்யாது இருத்தல்.<br /> 4-அவர்கள் மார்க்கமாக குறிப்பிட்டவற்றை கொண்டு மாத்திரமே அல்லாஹ்வை தூய்மையாக வணங்குதல். அதாவது அவர்களின் ஸுன்னாவை <span class="c2">(வழிமுறையை)</span> பின்பற்றி <span class="c2">(பித்ஆவை)</span> புதிதாக மார்க்கம் என்றபெயரில் உருவாக்கப்பட்டவற்றை விட்டும் விலகி நடத்தல்.<span class="c6"><br /> அல்லாஹ் இது குறித்து பின்வருமாறு பிரஸ்தாபிக்கிறான் :</span> "யார் இறைத்தூதருக்குக் கட்டுப்படுகிறாரோ அவர் அல்லாஹ்வுக்கு கட்டுப்பட்டவராவார்" <span class="c2">(ஸூறதுன்நிஸா: 80)</span> மேலும் அல்லாஹ் குறிப்பிடுகையில் : "அவர் மனோ இச்சையின் படி பேசுவதில்லை.அது அவருக்கு அறிவிக்கப்படும் வஹியே தவிர வேறில்லை". [ஸூறதுன் நஜ்ம் <span class="c2">(3,4)</span>] மேலும் அல்லாஹ் பின்வருமாறு குறிப்பிடுகிறான் : "உங்களில் அல்லாஹ்வையும் இறுதிநாளையும் ஆதரவு வைத்து அல்லாஹ்வை அதிகம் நினைவு கூறுவோருக்கு அல்லாஹ்வின் தூதரிடம் நிச்சயமாக அழகிய முன்மாதிரி இருக்கிறது". <span class="c5">[ஸூறதுல் அஹ்ஸாப்: 21)]</span> </p>',
            ],
            6 => [
                'question' => 'கேள்வி 7 : அல்லாஹுதஆலா எம்மை எதற்காகப் படைததுள்ளான்?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/480.mp3',
                'answer' => '<p> பதில் : இணையில்லாத அவன் ஒருவனை மாத்திரம் வணங்கி வழிப்படுவதற்கே எம்மைப் படைத்தான்.<br /> வீண் கேளிக்கையிலோ விளையாட்டிலோ ஈடுபடுவதற்காகவல்ல.<span class="c6"><br /> அல்லாஹ் கூறுகிறான் :</span> "நான் ஜின் மற்றும் மனித இனத்தை என்னை வணங்கி வழிபடுவதற்காகவேயன்றி படைக்கவில்லை". <span class="c2">(ஸூறதுஸ் ஸாரியாத் : 56)</span>. </p>',
            ],
            7 => [
                'question' => 'கேள்வி 8 : இபாதத் (வணக்க வழிபாடு) என்றால் என்ன?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/530.mp3',
                'answer' => '<p> பதில் : இபாதத் <span class="c2">(வணக்க வழிபாடு)</span> என்பது வெளிப்படையான, மறைவான வார்த்தைகள் மற்றும் செயல்களில் அல்லாஹ் விரும்புகின்ற, அவன் பொருந்திக் கொள்கின்ற அனைத்திற்குமான ஒரு பொதுவான பெயராகும். <span class="c2">(அதாவது இறைவனின் விருப்பத்திற்கேற்ப அமையும் மனிதனின் சொல், செயல் அனைத்தும் இறைவழிபாடேயாகும்.)</span><br /> வெளிப்படையான இபாத்திற்கு, அல்லாஹ்வை நாவால் துதிசெய்தல், புகழ்தல், பெருமைப்படுத்தல், தொழுதல், ஹஜ் செய்தல் போன்றவை உதாரணங்களாகும்.<br /> மறைவான இபாதத்திற்கு அல்லாஹ்வின் மீது பொறுப்புச்சாட்டுதல், அவனைப் பயப்படுதல், அவனிடமே எதிர்பார்த்து ஆதரவு வைத்தல் போன்றவை உதாரணங்களாகும். </p>',
            ],
            8 => [
                'question' => 'கேள்வி 9 : எம்மீதான மிகப் பெரும் கடமை யாது?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/580.mp3',
                'answer' => '<p> பதில் : எம்மீதுள்ள மிகப்பெரும் கடமை தவ்ஹீத் ஆகும். அதாவது அல்லாஹ்வை -ஒருமைப்படுத்துவதாகும்- ஒருவன் என ஏற்று வாழ்வதாகும். </p>',
            ],
            9 => [
                'question' => 'கேள்வி 10 : தவ்ஹீதின் வகைகள் என்ன ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/610.mp3',
                'answer' => '<p> பதில் : தவ்ஹீது மூன்று வகைப்படும்,<span class="c6"> 1:</span> தவ்ஹீதுர் ருபூபிய்யா. அதாவது, அல்லாஹ்வே சிருஷ;டிப்பவன், ரிஸ்க் அளிப்பவன், அதிபதி, அனைத்தையும் நிருவகிப்பவன் என்றும் இவை அனைத்திலும் அவனுக்கு எந்த இணையாளரும் இல்லை எனவும் இறைவிசுவாசம் கொள்ளல்.<br /> 2-<span class="c6">தவ்ஹீதுல் உலூஹிய்யா :</span> வணக்க வழிபாடுகளின் மூலம் அல்லாஹ்வை ஒருமைப்படுத்துவதாகும். அவனைத் தவிர வணங்கி வழிபடுவதற்கு எவரும் கிடையாது.<br /> 3-தவ்ஹீதுல் அஸ்மாஇ வஸ்ஸிஃபாத். இது <span class="c2">(அல்குர்ஆனிலும் அஸ்ஸுன்னாவிலும் வந்துள்ள அல்லாஹ்வின் பெயர்களையும் பண்புகளையும் உதாரணம் கூறாமல்; உவமைப்படுத்தாமல்; மறுக்காமல்; விசுவாசுப்பதைக் குறிக்கும்.<span class="c6"><br /> தவ்ஹீதின் மூன்று வகைகளுக்குமான ஆதாரம்; அல்லாஹ்வின் பின்வரும் கூற்றாகும் :</span> "அவனே வானங்கள் பூமி மற்றும் அவையிரண்டுக்கம் இடைப்பட்டவற்றினதும் இரட்சகன்,<span class="c6"> அவனையே நீர் வணங்குவீராக! மேலும் அவனை வணங்குவதில் பொறுமையைக் கடைப்பிடிப்பீராக! அவனுக்கு நிகரானவர் எவரையேனும் நீர் அறிவீரா?!" (ஸூறா மர்யம் :</span> 65 )</span> </p>',
            ],
            10 => [
                'question' => 'கேள்வி 11 : மிகப்பெரிய பாவம் எது?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/670.mp3',
                'answer' => '<p> பதில் - தூயோனாகிய அல்லாஹ்விற்கு இணைவைப்பது ஆகும்.<span class="c6"><br /> அல்லாஹ் கூறினான் :</span> "நிச்சயமாக அல்லாஹ் தனக்கு இணைவைக்கப்படுவதை மன்னிக்கவே மாட்டான். இதைத் தவிர <span class="c2">(மற்ற)</span> எதையும் தான் நாடியவர்களுக்கு மன்னிப்பான். எவர்கள் அல்லாஹ்வுக்கு இணைவைக்கிறார்களோ அவர்கள் நிச்சயமாக மிகப்பெரும் பாவத்தையே கற்பனை செய்கிறார்கள்". <span class="c2">(ஸூறதுன்னிஸா :48)</span> </p>',
            ],
            11 => [
                'question' => 'கேள்வி 12 : ஷிர்க் பற்றியும் அதன் வகைகளையும் குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/710.mp3',
                'answer' => '<p> பதில் : வணக்கவழிபாடுகளில் ஏதாவது ஒன்றை அல்லாஹ் அல்லாதவருக்கு திருப்புதல்.<br /> ஷிர்கின் <span class="c2">(இணைவைத்தலின்)</span> வகைகள் :<br /> 1) ஷிர்குன் அக்பர் : <span class="c2">(பெரியவகை ஷிர்கிற்கு)</span> உதாரணம் அல்லாஹ் அல்லாதவரிடம் பிரார்த்தித்தல், அல்லாஹ் அல்லாதவருக்கு ஸுஜூது செய்தல் மற்றும் அறுத்துப் பலியிடுதல் போன்றவைகளாகும்.<span class="c6"><br /> 2) ஷிர்குன் அஸ்கர் :</span> சிறியவகை ஷிர்கிற்கு உதாரணம் அல்லாஹ் அல்லாத ஒன்றின் மீது சத்தியம் செய்தலும் , அல்லது ஏதாவது ஒரு நன்மையைப் பெற்றுக் கொள்ள அல்லது ஒரு தீங்கிலிருந்து பாதுகாப்புப் பெற நாடி தாயத்துக் கட்டிக்கொள்வதும், சாதாரண முகஸ்துதியும் ஆகும். முகஸ்துதிக்கான உதாரணம் மக்கள் தன்னைப் பார்க்கிறார்கள் என்பதற்காக தொழுகையை அழகாக தொழுவதைக் குறிப்பிடலாம். </p>',
            ],
            12 => [
                'question' => 'கேள்வி 13 : உயர்தோனாகிய அல்லாஹ்வைத் தவிர வேறு யாராவது மறைவான விடயங்களை அறிவார்களா?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/770.mp3',
                'answer' => '<p> பதில் : இல்லை அல்லாஹ் மாத்திரமே மறைவானவற்றை அறிகிறான்<br /> அல்லாஹ் கூறுகிறான் : "அல்லாஹ்வைத் தவிர வானங்கள் மற்றும் பூமியில் இருப்பவர்கள் எவரும் மறைவானவற்றை அறியமாட்டார்கள். <span class="c2">(மரணித்தோர்)</span> எப்போது மீண்டும் எழுப்பப்படுவார்கள் என்பதையும் அவர்கள் உணரமாட்டார்கள் என்று நபியே நீர் கூறுவீராக!". <span class="c2">(ஸூறதுன் நம்ல் : 65)</span> </p>',
            ],
            13 => [
                'question' => 'கேள்வி 14: ஈமானின் அடிப்படைகளை சுருக்கமாக குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/810.mp3',
                'answer' => '<p> பதில் : ஈமானின் அடிப்படைகள் ஆறு,<span class="c6"> அவைகள் பின்வருமாறு :</span> 1- அல்லாஹ்வை நம்புதல்.<br /> 2-மலக்குமார்களை நம்புதல்.<br /> 3-வேதங்களை நம்புதல்.<br /> 4-நபிமார்களை –தீர்கதரிசிகளை- நம்புதல்.<br /> 5- மறுமை நாளை நம்புதல்.<br /> 6-நன்மை தீமை இறைவிதியின் படியே நிகழும் என்பதை நம்புதல்.<br /> இதற்கான ஆதாரமாக முஸ்லிமில் இடம்பெற்றுள்ள பிரபல்யமான ஜிப்ரீல் <span class="c2">(அலை)</span> அவர்களின் ஹதீஸ் உள்ளது. அதில் ஜிப்ரீல் அவர்கள் நபியவர்களிடம், "ஈமான் பற்றி அறிவித்துத் தாருங்கள் என கேட்டதற்கு, நபியவர்கள் நீங்கள் அல்லாஹ்வையும் அவனின் மலக்குகளையும் அவனின் வேதங்களையும் அவனின் தூதர்களையும் நம்பவேண்டும் மேலும் நன்மை தீமை இறைவிதியின் படியே நிகழும் என்பதையும் நம்ப வேண்டும்" எனக் கூறினார்கள். </p>',
            ],
            14 => [
                'question' => 'கேள்வி 15 : ஈமானின் அடிப்படைகளை விளக்குக.?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/900.mp3',
                'answer' => '<p> பதில் : அல்லாஹ்வை நம்புதல்.<span class="c6"> அது பின்வரும் விடயங்களை உள்ளடக்குகிறது :</span><br /> - அல்லாஹ் மாத்திரமே உன்னை படைத்து, உனக்கான வாழ்வாதாரத்தை தருபவன் என்பதையும், அவன் ஒருவன் மாத்திரமே படைப்பினங்களின் உரிமையாளன்; என்றும் அவைகளின் விவகாரங்களை திட்டமிடுபவன் என்றும் உறுதியாக நம்புதல் வேண்டும்.<br /> - மேலும் அவன்தான் உண்மையாக வணங்கி வழிபடத் தகுதியானவன். அவனைத் தவிர உண்மையாக வணங்கப்படுபவன் வேறு யாருமில்லை என்று நம்பவேண்டும்.<br /> அல்லாஹ் மகத்தானவன் பெரியவன், பரிபூரணமானவன் புகழனைத்தும் அவனுக்குரியவை என்றும், அவனுக்கு அழகிய திருநாமங்களும் உயர் பண்புகளும் உள்ளன என்றும், அவற்றில் அவனுக்கு நிகரான அவனுக்கு ஒப்பான எதுவும் கிடையாது என்பதை ஏற்றுக்கொள்ளவேண்டும்.<br /> 2- மலக்குகளை நம்புதல் <span class="c2">(ஈமான் கொள்ளுதல்)</span> :<br /> மலக்குகள் அல்லாஹ்வின் படைப்பாகும். அவர்களை அவன் ஒளியினால் படைத்தான். மேலும் அவர்கள் அவனை வணங்கி வழிபடவும் அவனின் கட்டளைக்கு முற்றாக அடிபணிந்து நடக்கவுமே படைக்கப்பட்டுள்ளனர்.<br /> அவர்களுள் ஜிப்ரீல் <span class="c2">(அலை)</span> பிரதானமானவர். அவரே வஹியெனும் இறைச்செய்தியை அல்லாஹ்விடமிருந்து நபிமார்களுக்கு கொண்டுவருபவர்.<br /> 3- வேதங்களை நம்புதல் <span class="c2">(ஈமான் கொள்ளுதல்)</span> :<br /> அல்லாஹ் தனது தூதர்களுக்கு இறக்கி அருளிய இறைச்செய்தி அடங்கிய நூல்களே வேதங்களாகும். அந்த வகையில்,<br /> முஹம்மத் <span class="c2">(ஸல்)</span> அவர்களுக்கு இறக்கியருளப்பட்ட அல் குர் ஆன்,<br /> நபி ஈஸா <span class="c2">(அலை)</span> மீது அருளப்பட்ட இன்ஜீல் வேதம்,<br /> நபி மூஸா <span class="c2">(அலை)</span> மீது அருளப்பட்ட தவ்ராத் வேதம்,<br /> நபி தாவூத் <span class="c2">(அலை)</span> மீது அருளப்பட்ட ஸபூர் வேதம்,<br /> இப்ராஹீம் மற்றும் மூஸா இருவருக்கும் வழங்கப்பட்ட ஏடுகள் போன்றவை இதற்கான எடுத்துக்காட்டுகள் ஆகும்.<br /> 4-<span class="c6"> இறைத்தூதர்களை நம்புதல் :</span><br /> இறைத்தூதர்கள் என்போர் அல்லாஹ் தனது அடியார்களுக்கு கற்றுகொடுப்பதற்காகவும், அவர்களுக்கு நன்மை மற்றும் சுவர்க்கம் குறித்து நன்மாராயம் கூறவும், தீமை மற்றும் நரகம் குறித்து அச்சமூட்டி எச்சரிக்கை செய்யவும் அவனின் புறத்திலிருந்து அனுப்பிய உத்தம மனிதர்களைக் குறிக்கும்,<br /> அவர்களுள் மிகவும் சிறப்புக்குரியோர் <span class="c2">(உலுல் அஸ்ம்)</span> திட உறுதிபூண்டோர் என்போர் ஆவர்.<span class="c6"> அவர்களின் பெயர்கள் பின்வருமாறு :</span><br /> நூஹ் அலைஹிஸ்ஸலாம்,<br /> இப்ராஹீம் அலைஹிஸ்ஸலாம்,<br /> மூஸா அலைஹிஸ்ஸலாம்,<br /> ஈஸா அலைஹிஸ்ஸலாம்,<br /> முஹம்மத் ஸல்லல்லாஹு அலைஹி வஸல்லம் ஆகியோர் ஆவர்.<br /> 5- இறுதி நாளை விசுவாசம் கொள்ளுதல் <span class="c2">(மறுமை நாளை நம்புதல்)</span> :<br /> அதாவது மரணத்தின் பின்னுள்ள மண்ணறை வாழ்வு, மற்றும் மறுமை நாள், மீண்டும் உயிர் கொடுத்து எழுப்பபட்டு விசாரணை செய்யப்படும் நாள் போன்றவற்றை இது குறிக்கும். அந்நாளில் சுவர்க்கவாதிகள் அவர்களுக்குரிய தங்குமிடங்களிலும் நரகவாதிகள் அவர்களுக்குரிய தங்குமிடங்களிலும் நிரந்தரமாக தங்கிவிடுவர் என்பதை நம்புவதாகும்.<br /> 6- நன்மை,<span class="c6"> தீமை இறைவிதியின் படியே நடக்கும் என்பதை ஈமான் கொள்ளுதல் :</span><br /> விதி என்பது இப்பிரபஞ்சத்தில் நடைபெறும் அனைத்தையும் முழுமையாக அல்லாஹ் நன்கறிவான் என்றும், பிரபஞ்ச நிகழ்வுகள் குறித்து லவ்ஹுல் மஹ்பூல் எனும் பாதுகாக்கப்பட்ட ஏட்டில் பதிந்து வைத்துள்ளான் என்றும், அவன் இவ்வாறான ஒழுங்கு இருக்க வேண்டுமென நாடி அதனை உருவாக்கினான் என்றும் நம்புவதாகும்.<span class="c6"><br /> இது குறித்து அல்லாஹ் :</span> "நாம் ஒவ்வொரு பொருளையும் அதற்குரிய அளவோடு படைத்துள்ளோம்". <span class="c2">(ஸூறதுல் கமர் 49)</span><br /> கழாகத்ர் எனும் நம்பிக்கையானது நான்கு படித்தரங்களை கொண்டுள்ளது.<span class="c6"> அவைகள் பின்வருமாறு :</span><br /> முதலாவது : அல்லாஹ்வின் அறிவுபற்றியதாகும். அவற்றில் இப்பிரபஞ்சத்தில் நிகழும் எல்லா நிகழ்வுகள் அதாவது அவை நிகழ்வதற்கு முன்னும் நிகழ்ந்த பின்னரும் அது குறித்த அவனின் முன்னறிவை குறிப்பிடலாம்.<span class="c6"><br /> இதற்கான ஆதாரம் அல்லாஹ்வின் பின்வரும் கூற்றாகும் :</span> "நிச்சயமாக மறுமைநாள் பற்றிய அறிவு அல்லாஹ்விடமே உள்ளது. அவனே மழையை இறக்கிவைக்கிறான், அவனே கருவறையில் உள்ளவைகளையும் நனகறிவான். எந்த ஆன்மாவும்; தான் நாளை எதைச் சம்பாதிக்கும் என அறியமாட்டாது. மேலும், எந்த ஆன்மாவும் தான் எந்தப் பூமியில் மரணிக்கும் என்பதை அறியமாட்டாது. நிச்சயமாக அல்லாஹ் நன்கறிந்தவன், மிக நுட்பமானவன்". <span class="c2">(ஸுறது லுக்மான்:34)</span><br /> இரண்டாவது : இவற்றை அல்லாஹ் லவ்ஹுல் மஹ்பூலில் ஆரம்பத்தில் எழுதி விட்டான். அதாவது நடந்தவை நடக்கவிருப்பவை யாவும் அதில் எழுதப்பட்டுவிட்டன.<span class="c6"><br /> இதற்கான ஆதாரம் அல்லாஹ்வின் பின்வரும் கூற்றாகும் :</span> "மறைவானவற்றின் திறவுகோள்கள் அவனிடமே இருக்கின்றன. அவற்<span class="c2">(றில் உள்ளவற்)</span>றை அவனைத் தவிர வேறெவரும் அறியமாட்டார். தரையிலும், கடலும் உள்ளவற்றையும் அவன் நன்கறிவான். எந்த ஓர் இலையும் அதை அவன் அறியாமல் உதிருவதில்லை. பூமியின் இருள்களில் உள்ள விதையோ, பசுமையானதோ, உலர்ந்ததோ எதுவாயினும் அவனுடைய தெளிவான ஏட்டில் இல்லாமலில்லை". <span class="c2">(ஸூறதுல் அன்ஆம் :59)</span><br /> மூன்றாவது : எல்லா விடயங்களும் அவனின் நாட்டபடியே நிகழும். அவனிடமிருந்தும் படைப்பினங்களிடமிருந்தும் நிகழ்பவை யாவும் அவனின் நாட்டப்படியே நிகழ்கிறது.<span class="c6"><br /> இதற்கான ஆதாரம் அல்லாஹ்வின் பின்வரும் கூற்றாகும் :</span> "இது உங்களில் யார் நேர் வழி நடக்கவிரும்புகிறாறோ அவருக்குரியதாகும். இதை அகிலத்தாரின் இரட்சகனாகிய அல்லாஹ் நாடினாலேயன்றி நீங்கள் நாடமாட்டீர்கள்". <span class="c2">(ஸுறதுத் தக்வீர் 28-29)</span><br /> நான்காவது : அனைத்து படைப்பினங்களையும் அல்லாஹ்வே படைத்தான் என்றும் அவற்றை அவன் படைக்கும் போது அவற்றின் தனித்தன்மைகளையும் குணங்களையும் அங்க அசைவுகளையும், அவற்றின் அனைத்து விடயங்ளையும் அவனே படைத்தான் என்பதையும் உறுதியாக நம்புதல் <span class="c2">(ஈமான் கொள்ளுதல்)</span>.<span class="c6"><br /> இதற்கான ஆதாரம் அல்லாஹ்வின் பின்வரும் கூற்றாகும் :</span> "அல்லாஹ்வே உங்களையும், நீங்கள் செய்து கொண்டிருப்பவற்றையும் படைத்தான்". <span class="c2">(ஸூறதுஸ்ஸாப்பாத் : 96)</span>. </p>',
            ],
            15 => [
                'question' => 'கேள்வி 16 : அல்குர்ஆனின் வரைவிலக்கணம் யாது?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1300.mp3',
                'answer' => '<p> பதில் - அல்குர்ஆன் என்பது உயர்ந்தோனாகிய அல்லாஹ்வின் பேச்சாகும் -வார்த்தையாகும்-, அது படைக்கப்பட்டதல்ல.<span class="c6"><br /> அல்லாஹ் கூறுகிறான் :</span> "இணைவைப்பாளர்களில் எவராவது ஒருவர் உன்னிடம் புகழிடம் கோரினால் அவர் அல்லாஹ்வின் வார்த்தையை செவியேற்கும் வரையில் அவருக்கு புகழிடம் வழங்குங்கள்". <span class="c2">(ஸூறதுத் தவ்பா : 6)</span> </p>',
            ],
            16 => [
                'question' => 'கேள்வி 17 : அஸ்ஸுன்னா என்றால் என்ன?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1330.mp3',
                'answer' => '<p> அஸ்ஸுன்னா என்பது நபி <span class="c2">(ஸல்)</span> அவர்களின் ஒவ்வொரு சொல்லும், செயலும், அங்கீகாரமும் அவர்களது குணாதிசயமும் உடல் கட்டமைப்பும் தொடர்பான விடயங்களுமாகும். </p>',
            ],
            17 => [
                'question' => 'கேள்வி 18 : பித்அத் என்றால் என்ன? அதனை நாம் ஏற்கலாமா?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1350.mp3',
                'answer' => '<p> பதில் - பித்அத் என்பது நபி <span class="c2">(ஸல்)</span> அவர்கள் மற்றும் ஸஹாபாக்களின் காலத்தில் இல்லாத ஒன்றை மார்க்கத்தில் மனிதர்கள் புதிதாக தோற்றுவித்த அனைத்தையும் குறிக்கும்.<br /> இவ்வாறு மார்க்கத்தின் பெயரால் உருவாக்கப்பட்டவற்றை ஏற்றுக்கொள்ளாது புறக்கணிப்போம்.<br /> ஏனெனில், நபி <span class="c2">(ஸல்)</span> அவர்கள் : "<span class="c2">(மார்க்கத்தின் பெயரால்)</span> புதிதாக உருவாக்கப்படும் எல்லா பித்அத்துக்களும் <span class="c2">(நூதன அனுஷ்டானங்களும்)</span> வழிகேடாகும்" என்று குறிப்பிட்டுள்ளார்கள்.<span class="c6"> ஆதாரம் :</span> அபூதாவூத்<br /> இதற்கான உதாரணங்களாக வணக்கத்தில் குறிப்பிடப்பட்ட வற்றிற்கு மேலதிகமாக செய்தலை குறிப்பிடலாம். அதாவது வுழு செய்கின்ற போன்று நாளாவது முறை உறுப்புகளை கழுவுதல், அதே போன்று நபியவர்களின் பிறந்த தின விழாக் கொண்டாடுதல், இவற்றிற்கான வழிகாட்டல்கள் நபியவர்களிடமிருந்தோ அல்லது அவர்களது தோழர்களிடமிருந்தோ கிடைக்கவில்லை. </p>',
            ],
            18 => [
                'question' => 'கேள்வி 19 : அல்வலாஉ (நேசம் வைத்தல்) வல்பராஉ (நீங்கிக்கொள்ளல்-விலகி நடத்தல்-) கோட்பாடு குறித்துக் குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1410.mp3',
                'answer' => '<p> பதில் : அல்வலாஉ <span class="c2">(நேசம் வைத்தல்)</span> என்பது முஃமின்களை -இறைவிசுவாசிகளை- நேசித்து அவர்களுக்கு உதவிபுரிதல் ஆகும்.<span class="c6"><br /> அல்லாஹ் கூறுகிறான் :</span> "நம்பிக்கையாளர்களான ஆண்களும் பெண்களும் அவர்களில் சிலர் மற்றும் சிலருக்கு உதவியாளர்களாவர்". <span class="c2">(ஸூறதுத் தவ்பா:71)</span>.<span class="c6"><br /> அல்பராஉ\' :</span> என்பது <span class="c2">(உபதேசம், அச்சமூட்டி எச்சரிக்கை செய்வதன் மூலம் நேர்வழியை தெளிவுபடுத்தியதன் பின்)</span> இறை நிராகரிப்பாளர்களை அல்லாஹ்வுக்காக வெறுத்து தூரமாக விலகிக் கொள்ளலை குறிக்கும்.<span class="c6"><br /> அல்லாஹ் கூறுகிறான் :</span> "நிச்சயமாக இப்ராஹீமிடமும் அவருடன் இருந்தோரிடமும் உங்களுக்கு அழகிய முன்மாதிரி உள்ளது. அவர்கள் தமது சமூகத்தாரிடம் நிச்சயமாக நாம் உங்களை விட்டும், அல்லாஹ்வையன்றி நீங்கள் வணங்குவதை விட்டும் விலகிக் கொண்டவர்களாவோம். உங்களை நாம் நிராகரித்து விட்டோம். மேலும் நீங்கள் அல்லாஹ் ஒருவனை ஈமான் கொள்ளும் வரையில் எங்களுக்கும் உங்களுக்கும் மத்தியில் பகைமையும், விரோதமும் என்றென்றும் ஏற்பட்டுவிட்டது!". <span class="c2">(ஸூறதுல் மும்தஹினா :4)</span> </p>',
            ],
            19 => [
                'question' => 'கேள்வி 20 : இஸ்லாம் தவிர வேறு மார்க்கத்தை அல்லாஹ் ஏற்றுக்கொள்வானா?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1480.mp3',
                'answer' => '<p> பதில் : இஸ்லாம் அல்லாத எந்த மார்க்கத்தையும் அல்லாஹ் ஏற்றுக்கொள்ளமாட்டான்<br /> அல்லாஹ் கூறுகிறான் : "யார் இஸ்லாம் அல்லாததை மார்க்கமாக ஏற்க விரும்புகின்றானோ அது அவனிடமிருந்து அங்கீகரிக்கப்பட மாட்டாது. அவன் மறுமையில் நஷ்டவாளர்களில் உள்ளவனாவான்". <span class="c2">(ஸூறது ஆல இம்ரான் :85)</span> </p>',
            ],
            20 => [
                'question' => 'கேள்வி 21 : இறை நிராகரிப்பு (குப்ர்) சொல், செயல், நம்பிக்கை ஆகியவற்றின் மூலம் நிகழும். உதாரணம் தருக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1520.mp3',
                'answer' => '<p> பதில்: சொல் ரீதியான <span class="c2">(குப்ர்)</span> இறை நிராகரிப்பிற்கான உதாரணம், அல்லாஹ்வை அல்லது அவனின் தூதரை நிந்தித்தல் மற்றும் திட்டுதல்.<br /> செயல் சார்ந்த <span class="c2">(குப்ருக்கு)</span> இறை நிராகரிப்பிற்கான உதாரணம் அல்குர்ஆனை அவமதித்தல் அல்லது அல்லாஹ்வைத் தவிர்த்து பிறருக்கு ஸுஜுது செய்தல் <span class="c2">(வணக்கம் செலுத்துதல்)</span>.<br /> நம்பிக்கை சார் <span class="c2">(குப்ருக்கான)</span> இறை நிராகரிப்பிற்கான உதாரணம், அல்லாஹ்வைத் தவிர வணக்கத்திற்கு தகுதியானோர் உள்ளனர் அல்லது அல்லாஹ்வுக்கு நிகராக வேறு படைப்பாளன் உள்ளான் என நம்புதல். </p>',
            ],
            21 => [
                'question' => 'கோள்வி 22 : நிபாக் (நயவஞ்சகம்) என்றால் என்ன? அதன் வகைகள் யாது?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1570.mp3',
                'answer' => '<p> பதில் : நிபாக் என்றால் நயவஞ்சகம் என்பது பொருளாகும்.<span class="c6"> அது இரு வகைப்படும :</span> அந்நிபாகுல் அக்பர் <span class="c2">(பெரிய நிபாக்)</span> அந்நிபாகுல் அஸ்கர் <span class="c2">(சிறிய நிபாக்)</span>.<br /> 1. அந்நிபாகுல் அக்பர் <span class="c2">(பெரிய நயவஞ்சகத்தனம்)</span> என்பது உள்ளத்தில் <span class="c2">(குப்ரை)</span> இறைநிராகாரிப்பை மறைத்து வெளிப்படையில் இறைவிசுவாசத்தை வெளிக்காட்டுவதாகும்.<br /> இவ்வகை <span class="c2">(குப்ர்)</span> நிராகரிப்பு இஸ்லாத்ததை விட்டும் முழுமையாக ஒரு மனிதனை வெளியேற்றிவிடுகிறது. இது பெரியவகை இறைநிராகரிப்பில் <span class="c2">(அல்குப்ருல் அக்பர்)</span> உள்ள ஒன்றாகும்.<span class="c6"><br /> அல்லாஹ் கூறியுள்ளான் :</span> "நிசயமாக நயவஞ்கர்கள் நரகத்தின் அடித்தட்டில் இருப்பார்கள். அவர்களுக்கு எந்த ஒரு உதவியாளரையும் நீர் காணமாட்டீர்". <span class="c2">(ஸூறதுன்னிஸா :145)</span><br /> 2-<span class="c6"> அந்நிபாகுல் அஸ்கர் :</span> சிறிய நிபாக்<br /> இதற்கு உதாரணமாக பொய் கூறுதல், வாக்கிற்கு மாறு செய்தல் அமானித மோசடி <span class="c2">(நம்பிக்கைத் துரோகம்)</span> ஆகியவற்றைக் கூறலாம்.<br /> இவ்வகை நிபாகானது இஸ்லாத்தை விட்டு வெளியேற்றிவிடாது. இது பாவமாக கருதப்படும், இச்செயலை செய்வோர் தண்டனைக்கு உட்படுவர்.<br /> நபி <span class="c2">(ஸல்)</span> அவர்கள் இது குறித்து பின்வருமாறு குறிப்பிடுகிறார்கள் : நயவஞ்கனின் அடையாளம் மூன்று : பேசினால் பொய் பேசுவான், வாக்களித்தால் மாறுசெய்வான், நம்பினால் துரோகம் இழைப்பான்\'. <span class="c2">(புஹாரி, முஸ்லிம்)</span> </p>',
            ],
            22 => [
                'question' => 'கேள்வி 23 : நபிமார்களில், இறைதூதர்களில் இறுதியானவர் யார்?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1680.mp3',
                'answer' => '<p> பதில்: முஹம்மத் ஸல்லல்லாஹு அலைஹிவஸல்லம்<br /> அல்லாஹ் கூறுகிறான் : "முஹம்மத் உங்களது ஆண்களில் எவருக்கும் தந்தையாக இருக்கவில்லை. எனினும் அவர் அல்லாஹ்வின் தூதராகவும் நபிமார்களின் முத்திரையாகவும் இருக்கின்றார்". <span class="c2">(ஸூறதுல் அஹ்ஸாப்: 40)</span> நபி <span class="c2">(ஸல்)</span> கூறுகிறார்கள் : நான் நபிமார்களின் <span class="c2">(முத்திரையாக)</span> இறுதியானவராக உள்ளேன், எனக்குப்பிறகு எந்த நபியும் கிடையாது\'. அபு தாவூத், திரிமிதி மற்றும் ஏனையோர் இதனை அறிவித்துள்ளனர். </p>',
            ],
            23 => [
                'question' => 'கேள்வி 24 : முஃஜிஸா (அற்புதம்) என்றால் என்ன?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1730.mp3',
                'answer' => '<p> பதில் : முஃஜிஸா என்பது அல்லாஹ் நபிமார்களுக்கு தங்களின் உண்மைநிலையை உறுதிப்படுத்துவதற்காக வழங்கிய வழமைக்கு மாறான விடயங்கள் அனைத்தையும் குறிக்கும்.<span class="c6"> இதற்கான உதாரணங்களாக பின்வருவனவற்றை குறிப்பிட முடியும் :</span><br /> முஹம்மத் நபியவர்களுக்காக சந்திரன் பிளந்தமை,<br /> மூஸா <span class="c2">(அலை)</span> அவர்களுக்கு கடல் பிளந்தமை, பிர்அவ்னும் அவனின் படையினரும் மூழ்கடிக்கப்பட்டமை. </p>',
            ],
            24 => [
                'question' => 'கேள்வி 25 : ஸஹாபாக்கள் (நபித்தோழர்) என்போர் யார்? நான் அவர்களை நேசிக்க வேண்டுமா?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1780.mp3',
                'answer' => '<p> பதில் : நபியவர்களை ஈமான் கொண்ட நிலையில் சந்தித்து புனித இஸ்லாத்தில் மரணித்தவரே ஸஹாபியாவார்<br /> நாம் அவர்களை நேசிக்க வேண்டும், அவர்களை பின்பற்றி நடக்க வேண்டும். அவர்கள்தான் நபிமார்களுக்குப் பிறகு மனிதர்களில் மிகவும் சிறப்புக்குரியோர் ஆவார்கள்.<span class="c6"><br /> அவர்களில் மிகவும் சிறந்தோர் நான்கு கலீபாக்களாவார்கள்:</span><br /> அபூபக்கர் ரழியல்லாஹு அன்ஹு,<br /> உமர் ரலியல்லாஹு அன்ஹு,<br /> உஸ்மான் ரழியல்லாஹு அன்ஹு,<br /> அலி ரழியல்லாஹு அன்ஹு ஆகியோராவர். </p>',
            ],
            25 => [
                'question' => 'கேள்வி 26 : உம்மஹாதுல் முஃமினீன் (இறைவிசுவாசிகளின் தாய்மார்கள்) என்போர் யார் ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1870.mp3',
                'answer' => '<p> பதில் : நபி <span class="c2">(ஸல்)</span> அவர்களின் மனைவியர் ஆவர்.<span class="c6"><br /> அல்லாஹ் கூறுகிறான் :</span> "நம்பிக்கையாளர்களுக்கு தமது உயிர்களைவிட நபியே மிக்க மேலானவராவார். அவரது மனைவியர் அவர்களின் தாய்மார்களாவர்". <span class="c2">(ஸூறதுல் அஹ்ஸாப்: 6)</span> </p>',
            ],
            26 => [
                'question' => 'கேள்வி 27 : நபியவர்ளின் குடும்பத்தினருக்கு எம்மீதுள்ள கடமை என்ன?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1910.mp3',
                'answer' => '<p> பதில் : நாம் அவர்களை நேசிக்க வேண்டும், கண்ணியப்படுத்த வேண்டும், அவர்களை யார் வெறுக்கிறார்களோ அவர்களை வெறுத்து நடக்க வேண்டும்; அவர்களை நேசிக்கும் விடயத்தில் எல்லை மீறாது நடந்து கொள்ள வேண்டும். நபியவர்களின் குடும்பத்தில் அவர்களின் மனைவியர், சந்ததிகள், பனூஹாஷிம் குடும்பத்தினர் பனுல்முத்தலிப் குடும்பத்தினரில் உள்ள இறைவிசுவாசிகள் அடங்குவர். </p>',
            ],
            27 => [
                'question' => 'கேள்வி 28 : முஸ்லிம் ஆட்சியாளர்களின் பால் எம்மீதுள்ள கடமை –பொறுப்பு- என்ன?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1940.mp3',
                'answer' => '<p> பதில்: அவர்களை மதித்து நடந்து கொள்வதும், பாவகாரியமல்லாத விடயங்களிள் அவர்களுக்கு கட்டுப்பட்டு அவர்களின் கட்டளைகளுக்கு செவிசாய்ப்பதும், அவர்களுக்கு எதிராக கிளர்ச்சி செய்யாதிருப்பதும், அவர்களுக்காக பிரார்த்தனை புரிவதும், அவர்கள் நலன் நாடி இரகசியமாக அறிவுறை கூறுவதும் எம்மீதுள்ள கடமையாகும். </p>',
            ],
            28 => [
                'question' => 'கேள்வி 29 : (முஃமின்களின்) இறைவிசுவாசிகளின் வீடு தங்குமிடம் எது?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1970.mp3',
                'answer' => '<p> பதில் : இறைவிசுவாசிகளின் வீடு சுவர்க்கமாகும்.<span class="c6"> இது குறித்து அல்லாஹ் பின்வருமாறு கூறுகிறான் :</span> "நிச்சயமாக அல்லாஹ் ஈமான் <span class="c2">(நம்பிக்கை)</span> கொண்டு ஸாலிஹான நல்லறங்கள் புரிவோரை சுவர்க்கங்களில் பிரவேசிக்கச் செய்கிறான்; அவற்றின் கீழே ஆறுகள் ஓடிக் கொண்டிருக்கும்". <span class="c2">(ஸூறா முஹம்மத் : 12)</span> </p>',
            ],
            29 => [
                'question' => 'கேள்வி 30 : காபிர்களின் (இறை நிராகரிப்பாளர்களின்) வீடு தங்குமிடம் எது?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2000.mp3',
                'answer' => '<p> பதில் :காபிர்களின் <span class="c2">(இறை நிராகரிப்பாளர்களின்)</span> வீடு தங்குமிடம் நரகமாகும்.<span class="c6"> இது குறித்து அல்லாஹ் பின்வருமாறு கூறுகிறான் :</span> "தீய மனிதர்களையும், கற்களையும் எரிபொருளாகக் கொண்ட நரக நெருப்பை அஞ்சிக் கொள்ளுங்கள். <span class="c2">(அந்த நெருப்பு, இறைவனையும் அவன் வேதத்தையும் ஏற்க மறுக்கும்)</span> காஃபிர்களுக்காகவே அது தயார் செய்யப்பட்டுள்ளது". <span class="c2">(ஸூறதுல் பகரா :24)</span> </p>',
            ],
            30 => [
                'question' => 'கேள்வி 31: (அல் கவ்ப்) பயம் என்றால் என்ன? ஆதரவு வைப்பது என்பது யாது? அவற்றிற்கான ஆதாரங்களைக் குறிப்பிடுக.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2020.mp3',
                'answer' => '<p> பதில் : பயமென்பது <span class="c2">(அல் கவ்ப்)</span> அல்லாஹ்வையும் அவனது தண்டனையும் பயப்படுவதைக் குறிக்கும்.<br /> <span class="c2">(அர்ரஜாஉ)</span> ஆதரவு வைப்பது என்பது அல்லாஹ்வின் வெகுமதியையும் மன்னிப்பையும் மற்றும் கருணையையும் ஆதரவு வைப்பதைக் குறிக்கும்.<span class="c6"><br /> இதற்கான ஆதாரம் பின்வரும் இறைவசனமாகும் :</span> "<span class="c2">(அல்லாஹ்வையன்றி)</span> இவர்கள் யாரை அழைத்துப் பிரார்த்திக்கின்றார்களோ அவர்களில் <span class="c2">(அல்லாஹ்வுக்கு)</span> மிகவும் நெருக்கமானவர்களாய் ஆவதற்கு தமது இரட்சகனின் பால் நெருங்கும் வழியைத் தேடுகின்றனர். அவனது அருளை எதிர்பார்த்து ஆதரவு வைக்கின்றனர்.மேலும் அவனது தண்டனையை அஞ்சுகின்றனர். நிச்சயமாக உமது இறைவனின் தண்டனை அச்சப்படத் தக்கதாகவே உள்ளது". <span class="c2">(ஸூறதுல் இஸ்ரா : 57)</span> மேலும் அல்லாஹ் இவ்வாறு கூறுகிறான் : "நிச்சயமாக நான் மிக்க மன்னிப்போனும் நிகரற்ற அன்புடையோனுமாவேன், மேலும் எனது தண்டனை நோவினை தரக்கூடிய தண்டனையாகும் என்று எனது அடியார்களுக்கு நபியே நீர் அறிவிப்பீராக!". <span class="c2">(ஸூறதுல் ஹிஜ்ர் :49-50)</span> </p>',
            ],
            31 => [
                'question' => 'கேள்வி :32 : அல்லாஹ்வின் சில பெயர்களையும் பண்புகளையும் குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2070.mp3',
                'answer' => '<p> பதில் : அல்லாஹ், அர்ரப்பு <span class="c2">(இரட்சகன்)</span>, அர்ரஹ்மான் <span class="c2">(அளவற்ற அருளாளன்)</span>, அல்பஸீரு <span class="c2">(யாவற்றையும் பார்ப்பவன்)</span>, அஸ்ஸமீஉ <span class="c2">(யவற்றையும் செவியுறுபவன்)</span>, அல் அலீம் <span class="c2">(யவற்றையும் நன்கறிபவன்)</span>, அர்ரஸ்ஸாக் <span class="c2">(யாவற்றுக்கும் வாழ்வாதாரத்தை வழங்குபவன்)</span>, அல் ஹய்யு <span class="c2">(நித்திய ஜீவன்)</span>, அல் அழீம் <span class="c2">(மகத்தானவன்)</span>, போன்ற இன்னும் பல திருநாமங்களும் உயர் பண்புகளும் அல்லாஹ்வுக்கு உண்டு. </p>',
            ],
            32 => [
                'question' => 'கேள்வி 33: மேலே குறிப்பிடப்பட்ட அல்லாஹ்வின் பெயர்களை விவரிக்குக.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2100.mp3',
                'answer' => '<p> பதில் : அல்லாஹ் என்பதன் அர்த்தம் உண்மையாக வணங்கப்படக்கூடிய இறைவன் என்பதாகும். அவன் தனித்தவன் அவனுக்கு இணையாளன் எவரும் கிடையாது.<span class="c6"><br /> அர்ரப்பு :</span> <span class="c2">(இரட்சகன்)</span> என்பது படைத்து ஆட்சி செய்பவன், வாழ்வாதரத்தை வழங்கி, திட்டமிட்டு நிர்வகிக்கும் ஒருவன் என்பதைக் குறிக்கும்.<span class="c6"><br /> அஸ்ஸமீஉ :</span> <span class="c2">(நன்கு செவியுறுபவன்)</span> அதாவது எல்லாவற்றிலும் அல்லாஹ்வின் செவியேற்கும் ஆற்றல் விரிந்து காணப்படுகிறது. ஆகையால் அவன் பல்வகையான வேறுபட்ட வித்தியாசமான அனைத்து சப்தங்களையும், ஓசைகளையும் கேட்கிறான் என்பது இதன் கருத்தாகும்.<span class="c6"><br /> அல்பஸீரு :</span> <span class="c2">(நன்கு பார்ப்பவன்)</span> அதாவது, எல்லா விடயங்களையும் பார்ப்பவன். சிறிய பெரிய அனைத்து விடயங்களையும் நன்கு பார்த்துக்கொண்டிருக்கிறான் என்பது இதன் கருத்தாகும்.<span class="c6"><br /> அல் அலீம் :</span> <span class="c2">(நன்கறிபவன்)</span> என்பது, அல்லாஹ் இறந்த காலம் நிகழ்காலம் எதிர்காலம் பற்றிய அனைத்தையும் முழுமையாக அறிந்தவன் என்பது பொருளாகும்.<br /> அர்ரஹ்மான் <span class="c2">(அளவற்ற அருளாளன்)</span> என்பது, அவனின் அருளானது -கருணை- அனைத்து படைப்பினங்கள் மற்றும் உயிரினங்களை உள்ளடக்கியுள்ளது –ஆகவே எல்லா அடியார்களும் படைப்பினங்களும் அவனின் அருளின் -கருணையின்- கீழ்தான் உள்ளனர்.<br /> அர்ரஸ்ஸாக் <span class="c2">(வாழ்வாதாரத்தை வழங்குபவன்)</span> : அதாவது அவனது படைப்புகளான மனித இனம், ஜின் இனம் மிருகங்கள் போன்ற எல்லாப் படைப்புகளுக்கும் வாழ்வாதாரத்தை வழங்குபவன் என்பது பொருளாகும்.<br /> அல் ஹய்யு <span class="c2">(நித்திய ஜீவன்)</span> என்பது : மரணிக்காது உயிர் வாழ்பவன். அனைத்துப் படைப்பினங்களும் மரணித்துவிடும்.<br /> அல் அழீம் <span class="c2">(மகத்தானவன்)</span>: பெயர்கள், பண்புகள், செயல்கள் ஆகிய அனைத்திலும் மகத்துவமும் பரீபூரண நிலையும் அவனுக்கு –அல்லாஹ்விற்கு- மாத்திரமே உரியது. </p>',
            ],
            33 => [
                'question' => 'கேள்வி 28 : முஸ்லிம் ஆட்சியாளர்களின் பால் எம்மீதுள்ள கடமை –பொறுப்பு- என்ன?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2210.mp3',
                'answer' => '<p> பதில் : நாம் அவர்களை நேசிக்க வேண்டும், அத்துடன் சட்டப் பிரச்சினைகள் மற்றும் புதிதாக தோன்றும் <span class="c2">(இடர்கால)</span> பிரச்சினைகள் தொடர்பாக அவர்களிடம் சென்று உரிய மார்க்க விளக்கத்தைப் பெற்றுக்கொள்ள வேண்டும். அவர்கள் குறித்து நல்லதையே பேச வேண்டும். அவர்கள் பற்றி யார் மோசமாக பேசுகிறாரோ அவர்கள் நல்லோர் பாதையில் செல்வோர் அல்லர்.<span class="c6"><br /> அல்லாஹ் கூறுகிறான் :</span> "உங்களில் எவர் ஈமான் கொண்டு அறிவும் வழங்கப்பட்டு உள்ளார்களோ அவர்களுக்கு அல்லாஹ் அந்தஸ்துக்களை உயர்த்துகிறான் மேலும் நீங்கள் செய்பவற்றை அல்லாஹ் நன்கறிந்தவன்". <span class="c2">(ஸூறதுல் முஜாதிலா :11)</span> </p>',
            ],
            34 => [
                'question' => 'கேள்வி 35 : அல்லாஹ்வின் நேசர்கள் என்போர் யார்?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2240.mp3',
                'answer' => '<p> பதில் : அல்லாஹ்வின் நேசர்கள் என்போர் அல்லாஹ்வை பயந்து நடக்கும் இறையச்சமுள்ள முஃமின்கள் ஆவர்.<span class="c6"><br /> அல்லாஹ் கூறுகிறான் :</span> "அறிந்து கொள்ளுங்கள்! நிச்சயமாக அல்லாஹ்வின் நேசர்களுக்கு யாதொரு பயமுமில்லை, அவர்கள் கவலைப்படவும் மாட்டார்கள். அவர்கள் நம்பிக்கை கொண்டு அல்லாஹ்வை அஞ்சி நடப்போராக இருப்பார்கள்". <span class="c2">(ஸூறா யூனுஸ் :61-62)</span> </p>',
            ],
            35 => [
                'question' => 'ஈமான் (இறைவிசுவாசம்) என்பது, சொல் செயல் விடயங்களை உள்ளடக்கியுள்ளதா?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2280.mp3',
                'answer' => '<p> ஆம், ஈமான் <span class="c2">(இறைவிசுவாசம்)</span> என்பது சொல், செயல் மற்றும் நம்பிக்கை ஆகிய விடயங்களை உள்ளடக்கியுள்ளது. </p>',
            ],
            36 => [
                'question' => 'கேள்வி 37 : ஈமான், அதிகரித்தல் குறைந்துவிடுதல் என்ற நிலையை கொண்டுள்ளதா?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2310.mp3',
                'answer' => '<p> பதில் : ஆம், ஈமான் வணக்கத்தின் மூலம் அதிகரிக்கிறது பாவத்தின் மூலம் குறைந்து விடுகிறது.<span class="c6"><br /> அல்லாஹ் கூறுகிறான் :</span> "நம்பிக்கையாளர்கள் யாரெனில் அல்லாஹ்வைப்பற்றி ஞாபகமூட்டப்பட்டால் அவர்களது உள்ளங்கள் நடு நடுங்கும். அவனது வசனங்கள் ஓதிக் காண்பிக்கப்பட்டால் அது அவர்களின் ஈமானை <span class="c2">(நம்பிக்கையை)</span> அதிகரிக்கச் செய்யும். மேலும், அவர்கள் தங்களுடைய இறைவனையே முழுவதும் சார்ந்திருப்பார்கள்". <span class="c2">(ஸூறதுல் அன்பால்: 2)</span> </p>',
            ],
            37 => [
                'question' => 'கேள்வி 38: இஹ்ஸான் என்றால் என்ன?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2350.mp3',
                'answer' => '<p> பதில் : இஹ்ஸான் என்பது அல்லாஹ்வை நீ பார்ப்பது போல் வணங்குவதாகும். நீ அவனைப் பார்க்காவிட்டாலும் அவன் உன்னைப் பார்க்கிறான். </p>',
            ],
            38 => [
                'question' => 'கேள்வி 39 : செயல்கள் எப்போது அல்லாஹ்விடம் ஏற்றுக் கொள்ளப் படத்தக்கதாக மாறுகிறது?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2370.mp3',
                'answer' => '<p> பதில் : செயல்கள் அல்லாஹ்விடத்தில் ஏற்றுக்கொள்ளப்பட இரு நிபந்தனைகள் உள்ளன:<br /> 1- அல்லாஹ்வின் திருமுகம் நாடி தூய்மையான முறையில் செய்யப்பட்டதாக இருக்க வேண்டும்.<br /> 2- நபியவர்களின் வழிமுறைப்படி செய்யப்பட்டதாக இருக்க வேண்டும். </p>',
            ],
            39 => [
                'question' => 'கேள்வி 40 : அல்லாஹ்வின் மீது தவக்குல் வைத்தல் (அல்லாஹ்வின் பொறுப்பில் விட்டுவிடுதல்) என்றால் என்ன?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2420.mp3',
                'answer' => '<p> பதில் : காரணகாரியங்களை மேற்கொண்டு நன்மையை அடைந்து கொள்ளவதிலும் தீங்கிலிருந்து தடுத்துக்கொள்வதிலும் அல்லாஹ்வின் மீது முழுமையாக சார்ந்து இருப்பதையே \'தவக்குல்\' என்று கூறப்படும்.<span class="c6"><br /> அல்லாஹ் கூறுகிறான் :</span> "யார் அல்லாஹ்வின் மீது பொறுப்பை ஒப்படைக்கிறானோ அவனே அவருக்கு போதுமானவன்" <span class="c2">(ஸூறதுத் தலாக் : 3)</span><br /> <span class="c2">(ஹஸ்புஹு)</span> என்றால் போதுமானவன் என்பது பொருளாகும். </p>',
            ],
            40 => [
                'question' => 'கேள்வி 41 : \'அல் அம்ரு பில் மஃரூப் வன்னஹ்யு அனில் முன்கர்\' (நன்மையை ஏவி தீமையை தடுத்தல்) என்றால் என்ன?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2470.mp3',
                'answer' => '<p> பதில் : \'அல் மஃரூப்\'; என்பது அல்லாஹ்வுக்கு கட்டுப்பட்டு கீழ்பணிந்து நடக்கக் கூடிய அனைத்து நன்மையான காரியங்களையும் ஏவுதல் என்பது பொருளாகும், \'அல் முன்கர்\' என்பது அல்லாஹ்வுக்கு முரணான பாவகாரியங்கள் அனைத்தை விட்டும் தடுப்பதைக் குறிக்கும்.<span class="c6"><br /> அல்லாஹ் கூறுகிறான் :</span> "மனிதர்களுக்காக தோற்றுவிக்க்கப்பட்ட சிறந்த சமூகமாக நீங்கள் இருக்கிறீர்கள். ஏனெனில் நீங்கள் நன்மையை ஏவுகின்றீர்கள் தீமையை தடுக்கின்றீர்கள் அல்லாஹ்வை நம்பிக்கை கொள்கிறீர்கள்". <span class="c2">(ஸூறது ஆலி இம்ரான் :110)</span> </p>',
            ],
            41 => [
                'question' => 'கேள்வி 42 : அஹ்லுஸ்ஸுன்னா வல்ஜமாஆ என்போர் யார்?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2510.mp3',
                'answer' => '<p> பதில்: சொல், செயல் மற்றும் நம்பிக்கை சார் விடயங்களில் நபியவர்களும், அவர்களின் தோழர்களும் எந்நிலைப்பாட்டை கொண்டிருந்தார்களோ அதே நிலைப்பாட்டை கொண்டோரே அஹ்லுஸ்ஸுன்னா வல்ஜமாஆ என்போர் ஆவர்.<br /> இவர்கள் அஹ்லுஸ்ஸுன்னா என்ற சிறப்புப் பெயரால்; அழைக்கப்படுவது நபியவர்களின் ஸுன்னாவை பின்பற்றி பித்அத்தை விட்டு விட்டதினாலாகும்.<br /> அல்ஜமாஆ என்பதன் மூலம் கருதப்படுவது, அவர்கள் சத்தியத்தில் ஒன்றுபட்டு அதில் தங்களுக்கு மத்தியில் பிரிந்து விடாதிருப்போர் என்பதாகும். </p>',
            ],
        ],
        2 => [
            0 => [
                'question' => 'கேள்வி 1 : \'அத்தஹாரா\' (சுத்தம்) என்பதை வரைவிலக்கணப்படுத்துக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2580.mp3',
                'answer' => '<p> பதில் : \'அத்தஹாரா\' என்பது தொடக்கை நீக்கி, அழுக்கை அகற்றுதல் என்பதாகும்.<br /> அழுக்கை அகற்றி துய்மைப்படுத்தல் என்பது ஒரு முஸ்லிம் தனது மேனியில் அல்லது ஆடையில் அல்லது தரையில் மற்றும் அவன்தொழுமிடத்தில் ஏற்பட்ட நஜிஸை –அழுக்கு அசுத்தம் போன்றவற்றை –அகற்றுவதாகும்.<br /> தொடக்கிலிருந்து தூய்மைபெறுதல் <span class="c2">(தொடக்கை நீக்குதல்)</span> என்பது பரிசுத்தமான நீரினால் வுழு செய்தல், மற்றும் குளித்தல். நீர் கிடைக்காவிட்டால் அல்லது நீரைப் பயண்படுத்துவது சிரமமாக இருப்பின் தயம்மும் செய்வதன் மூலம் தொடக்கிலிருந்து விடுபடுவதைக் குறிக்கும் <span class="c2">(தொடக்கு என்பது மனிதன் தனது உடலில் உணரக் கூடிய,உடலிருந்து வெளியாகக்கூடிய அசுத்தமானவைகளைக் குறிக்கும். இதிலிருந்து தூய்மை பெற குளித்தல் வுழு செய்தல் அல்லது தயம்மும் செய்தல் போன்ற விடயங்களை அசுத்ததின் நிலைக்கேட்ப மேற்கொள்ளுதல் வேண்டும்)</span> <span class="c2">(பெயர்பாளர்)</span>. </p>',
            ],
            1 => [
                'question' => 'கேள்வி 2 : நஜிஸ் \'அழுக்கு\' பட்ட இடத்தை எவ்வாறு சுத்தம் செய்ய வேண்டும்?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2630.mp3',
                'answer' => '<p> பதில் : அதனை சுத்தமாகும் வரை தண்ணீரால் கழுவவேண்டும்.<br /> நாய் <span class="c2">(வாய்விட்ட)</span> நக்கிய பாத்திரங்களைப் பொருத்தவரை ஏழு தடவைகள் கழுவ வேண்டும், அதில் முதலாவது தடவை கழுவும் போது மண்ணைப் பயண்படுத்தல் வேண்டும். </p>',
            ],
            2 => [
                'question' => 'கேள்வி : 3 : வுழுவின் சிறப்பு என்ன?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2660.mp3',
                'answer' => '<p> பதில் : அல்லாஹ்வின் தூதர் <span class="c2">(ஸல்)</span> அவர்கள் கூறினார்கள்: "ஒரு முஸ்லிம் அல்லது இறைநம்பிக்கை கொண்ட அடியார் வுழு செய்யும்போது முகத்தைக் கழுவினால், இரு கண்களால் செய்த பாவங்கள் அனைத்தும் <span class="c2">(முகத்தைக் கழுவிய)</span> நீருடன் அல்லது நீரின் கடைசித் துளியுடன் முகத்திலிருந்து வெளியேறுகின்றன. அவர் கைகளைக் கழுவும்போது கைகளால் செய்திருந்த பாவங்கள் அனைத்தும் <span class="c2">(கைகளைக் கழுவிய)</span> தண்ணீருடன் அல்லது தண்ணீரின் கடைசித் துளியுடன் வெளியேறுகின்றன.<br /> அவர் கால்களைக் கழுவும்போது, கால்களால் செய்த பாவங்கள் அனைத்தும் <span class="c2">(கால்களைக் கழுவிய)</span> நீரோடு அல்லது நீரின் கடைசித் துளியோடு வெளியேறுகின்றன. இறுதியில், அவர் பாவங்களிலிருந்து தூய்மை அடைந்தவராக வெளியேறுகிறார்". <span class="c5">[இந்த ஹதீஸை முஸ்லிம் பதிவு செய்துள்ளார்]</span> </p>',
            ],
            3 => [
                'question' => 'கேள்வி 4 : நீ எப்படி வுழு செய்கிறீர்? (நீ வுழு செய்யும் முறையை குறிப்பிடுக?)',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2690.mp3',
                'answer' => '<p> பதில் : இரு கைகளையும் மணிக்கட்டு வரை மூன்று முறை கழுவுதல்.<br /> மூன்று தடவைகள் நாசுக்கு நீர் செலுத்தி, நன்றாக சீரி வாய் கொப்பளித்தல்.<br /> வாய்க்கொப்பளித்தல் என்பது நீரை வாய்க்குள் செலுத்தி அதனை நன்கு அலசி வெளியேற்றல்,<br /> இஷ்தின்ஷாக் என்பது வலது கையால் நீரை மூக்கினுள் செலுத்தி நன்கு உள்ளிழுப்பதைக் குறிக்கும்.<br /> அல் இஸ்தின்ஸார் என்பது மூக்கின் உள்ளே உற்செலுத்திய நீரை இடது கையால் வெளியேற்றுவதைக் குறிக்கும்.<br /> பின்னர் முககத்தை மூன்று முறை கழுவுதல்.<br /> பின்னர் இரு கைகளையும் இரு முழங்கை உட்பட மூன்று முறை கழுவுதல்<br /> பிறகு உனது இரண்டு கைகளையும் முன் தலையிருந்து ஆரம்பித்து பிற்பகுதிவரை கொண்டு சென்று தலை முழுவதைiயும் மஸ்ஹு <span class="c2">(நீரால் தடவுதல்)</span> செய்வதோடு இரண்டு காதுகளையும் மஸ்ஹு செய்தல்.<br /> பின்னர் உனது இருகால்களையும் கரண்டை உட்பட மூன்று முறை கழுவுதல் வேண்டும்.<br /> இதுதான் வுழு செய்வதன் முழுமையான முறையாகும். இது தொடர்பான ஹதீஸ்கள் புஹாரி மற்றும் முஸ்லிம் கிரந்தங்களில் பதிவாகியுள்ளன. அவைகளை உஸ்மான் <span class="c2">(ரழி)</span> மற்றும் அப்துல்லாஹ் இப்னு ஸைத் <span class="c2">(ரழி)</span> போன்றோரும் ஏனைய ஸஹாபாக்களும் அறிவித்துள்ளனர். நபி <span class="c2">(ஸல்)</span> வுழுவை ஒரு தடவை அல்லது இரண்டு தடவைகள் செய்வார்கள் என்றும் புஹாரி மற்றும் ஏனைய கிரந்தங்களில் பதிவாகியுள்ளது. அதாவது நபி <span class="c2">(ஸல்)</span> வுழுவின் உறுப்புகளை ஒரு தடவை அல்லது இரு தடவைகள் கழுவுவார்கள் என்பதே இதன் கருத்தாகும். </p>',
            ],
            4 => [
                'question' => 'கேள்வி 5: வுழுவின் பர்ளுகள் என்றால் என்ன? அவற்றை சுருக்கமாக குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2810.mp3',
                'answer' => '<p> பதில் : வுழுவின் பர்ளுகள் என்பது : வுழுவின் போது கட்டாயம் செய்யப்பட வேண்டிய ஒன்றை ஒரு முஸ்லிம் செய்யாது விட்டால் வுழு நிறைவேறாது என்றிருக்கும் காரியங்களைக் குறிக்கும்.<span class="c6"> அவை பின்வருமாறு :</span><br /> 1- முகத்தைக் கழுவுதல். அதில் வாய்கொப்பளித்தல், நாசுக்கு நீர் செலுத்தல் போன்றவை அடங்கும்.<br /> 2- இரு கைகளையும் இரு முழங்கைகள் உட்படக் கழுவுதல்.<br /> 3- இரு காதுகள் உட்பட தலை முழுவதையும் மஸ்ஹு செய்தல்.<br /> 4- கரண்டை- கணுக்கால் - உட்பட இரு கால்களையும் கழுவுதல்.<br /> 5- உறுப்புகளை கழுவுவதில் ஒழுங்கை கடைப்பித்தல். அதாவது முகத்தைக் கழுவுதல், பின்னர் இரு கைகளையும் கழுவுதல், பின்னர் தலையை மஸ்ஹு செய்தல், பின்னர் இரு கால்களையும் கழுவுதல்.<br /> 6- தொடராகச் செய்தல், அதாவது வுழுவின்போது கழுவிய உறுப்பு காய முன் மற்றைய உறுப்பை கால இடை வெளியின்றி கழுவ வேண்டும்.<br /> அதாவது வுழுவின் போது கழுவ வேண்டிய உறுப்புகளிள் சிலதை ஒரு நேரத்திலும் எஞ்சியவற்றை இன்னொரு நேரத்திலும் கழுவுவதை இதற்கு உதாரணமாக குறிப்பிடலாம். அவ்வாறு செய்தால் ஒருவரின் வுழு நிறைவேறாது. </p>',
            ],
            5 => [
                'question' => 'கேள்வி 6 : வுழுவின் ஸுன்னத்துக்கள் என்றால் என்ன? அவற்றை சுருக்கமாகக் குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2910.mp3',
                'answer' => '<p> பதில் : வுழுவின் ஸுன்னத்துகள் என்பது அவற்றை ஒருவர் வுழுவின் போது செய்தால் அதற்கு அதிக கூலியும் நன்மையும் கிடைக்கும். அவற்றை செய்யாது விட்டால் அவர் மீது எவ்விதக் குற்றமுமில்லை. அவரின் வுழு நிறைவேறிவிடும்.<span class="c6"> அவை பின்வருமாறு :</span><br /> 1- பிஸ்மில்லாஹ் கூறுதல்.<br /> 2- பல் துலக்குதல்.<br /> 3- இருகைகளையும் மணிக்கட்டுவரை கழுவுதல்.<br /> 4- கை,கால் விரல்களை குடைந்து கழுவுதல்.<br /> 5- உறுப்புக்களை இரண்டு முறை அல்லது மூன்று முறை கழுவதல்.<br /> 6- வலது புறத்திலிருந்து ஆரம்பித்தல்.<br /> 7-வுழு செய்த பின் பின்வரும் திக்ரை-துஆவை-<span class="c6"> ஓதுதல் :</span> <span class="c1">“அஷ்ஹது அல்லாஇலாஹ இல்லல்லாஹு வஹ்தஹூ லா ஷரீக லஹூ, வஅஷ்ஹது அன்ன முஹம்மதன் அப்துஹு வரஸூலுஹு”</span> பொருள்: உண்மையான வணக்கத்திற்குரியவன் அல்லாஹ்வைத் தவிர வேறு யாருமில்லை அவன் தனித்தவன்; அவனுக்கு யாளனில்லை என்றும்;.மேலும் முஹம்மத் ஸல்லல்லாஹு அலைஹிவஸல்லம் அவனின் அடியாரும் துதருமாவார் என்றும் சாட்சி கூறுகிறேன்.<br /> 8- வுழுவின் பின் இரண்டு ரக்அத்துக்களை தொழுதல் <span class="c2">(வுழுவின் ஸுன்னத்தான இரண்டு ரக்அத்துக்களை தொழுதல்)</span> </p>',
            ],
            6 => [
                'question' => 'கேள்வி 7 : வுழுவை முறிக்கும் காரியங்களை குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3020.mp3',
                'answer' => '<p> பதில் : 1- முன் பின் துவரத்தினால் சிறுநீர் அல்லது மலம் அல்லது காற்று வெளியாகுதல்.<br /> 2- <span class="c2">(ஆழ்ந்த)</span> தூக்கம் அல்லது பைத்தியம் அல்லது மயக்கம் ஏற்படுதல்.<br /> 3- ஒட்டக இறைச்சி சாப்பிடுல்.<br /> 4- முன் பின் துவாரங்களை கையால் திரையின்றி தொடுதல். </p>',
            ],
            7 => [
                'question' => 'கேள்வி 8 : தயம்மும் என்றால் என்ன?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3080.mp3',
                'answer' => '<p> பதில் : தயம்மும் என்பது நீர் இல்லாத போது அல்லது நீரைப்-பயன்படுத்துவது- உபயோகிப்பது சிரமமானது என்ற நிலையில் இருக்கும் போது மண்ணைப் பயண்படுத்துவதைக் குறிக்கும். </p>',
            ],
            8 => [
                'question' => 'கேள்வி 9 : தயம்மும் செய்வதன் முறையைக் குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3110.mp3',
                'answer' => '<p> பதில் : இரு உள்ளங்கைகளையும் ஒரு தடவை மண்ணில் அழுத்தி, முகத்தையும் இரு முன்னங்கைகளையும் ஒரு முறை <span class="c2">(மஸ்ஹு)</span> தடவிக்கொள்வதாகும். </p>',
            ],
            9 => [
                'question' => 'கேள்வி 10 : தயம்முமை முறிக்கும் காரியங்கள் எவை?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3140.mp3',
                'answer' => '<p> பதில் : 1- வுழுவை முறிக்கும் அனைத்துக் காரியங்களும் தயம்முமை முறிக்கும் காரியங்களாகும்.<br /> 2- அத்தோடு நீர் கிடைத்தாலும் தயம்மும் முறிந்து விடும். </p>',
            ],
            10 => [
                'question' => 'கேள்வி 11 : ஹுப், ஜவ்ரப் என்றால் என்ன ? வுழு செய்யும் பொழுது அவைகளின் மீது மஸ்ஹு செய்ய முடியுமா?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3180.mp3',
                'answer' => '<p> பதில் : தோளினாலான காலில் அணியப்படுகின்றவை ஹுப் என்று அழைக்கப்படும்.<br /> ஜவ்ரப்\' என்பது காலில் அணிவதற்கு தோள் அல்லாதவற்றால் செய்யப்பட்ட காலுரையாகும்.<br /> கால்களை கழுவுவதற்குப் பதிலாக இவ்விரண்டின் மீது மஸ்ஹு செய்வதை மார்க்கம் அனுமதித்துள்ளது. </p>',
            ],
            11 => [
                'question' => 'கேள்வி 12 : ஹுப்பின் மீது மஸ்ஹ் செய்வதனை மார்க்கம் அனுமதித்ததன் நோக்கத்தைக் குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3230.mp3',
                'answer' => '<p> பதில் : குறிப்பாக மாரி, குளிர் காலங்களிலும் பயணத்தின் போதும் காலணிகள் காலுறைகள் போன்றவற்றை கலற்றுவது சிரமம் என்பதனால் இலகுபடுத்தி சிரமங்களை குறைப்பதுதான் ஹுப்பின் பிரதான நோக்கமாகும். </p>',
            ],
            12 => [
                'question' => 'கேள்வி 13 : காலணிகள் மீது மஸ்ஹு செய்வதற்கான நிபந்தனைகள் யாது?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3260.mp3',
                'answer' => '<p> பதில் : 1- ஹுப்பை <span class="c2">(காலணிகளை)</span> வுழு செய்ததன் பின் அணிந்திருத்தல் வேண்டும்.<br /> 2- ஹுப் <span class="c2">(காலணி)</span> துய்மையானதாக இருத்தல் வேண்டும். அசுத்தமான பாதணி மீது மஸ்ஹு செய்வது அனுமதிக்கப் பட்டதல்ல.<br /> 3- ஹுப்பானது வுழுவின் போது காலில் கட்டாயம் கழுவப்பட வேண்டிய பகுதியை மறைத்து இருத்தல் வேண்டும்.<br /> 4- மஸ்ஹு செய்வது, அனுமதிக்கப்பட்ட காலப்பகுதிக்குள் இருக்க வேண்டும். அதாவது ஊரில் இருப்பவருக்கு ஒரு நாளும் பிரயாணிக்கு மூன்று நாட்களுக்கும் ஆகும். </p>',
            ],
            13 => [
                'question' => 'கேள்வி 14 : ஹுப்பின் மீது மஸ்ஹு செய்யும் முறை யாது?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3320.mp3',
                'answer' => '<p> பதில் : நனைந்த இரு கைவிரல்களையும் கால்விரல்களின் மீது வைத்து கெண்டைக்கால் வரை தடவுதல், மேலும் வலது காலை வலது கையினாலும் இடது காலை இடது கையினாலும் தடவுதல். மஸ்ஹு செய்யும் போது கை விரல்களை இடைவெளிவிட்டு அகற்றி வைப்பதுடன் பல தடவைகள் செய்வது அனுமதிக்கப்டட்டதல்ல. </p>',
            ],
            14 => [
                'question' => 'கேள்வி 15 : ஹுப்பின் மீது மஸ்ஹ் செய்வதை முறிக்கும் காரியங்கள் எவை?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3350.mp3',
                'answer' => '<p> பதில் : 1- மஸ்ஹு செய்வதற்கான காலம் முடிவடைதல். இஸ்லாமிய ஷரீஆ வரையறுத்த மஸ்ஹுக்கான கால எல்லையான ஊர்வாசிக்கு ஒரு நாளும் பிரயாணிக்கு மூன்று நாள் என்பது முடிவடைதல்.<br /> 2-<span class="c6"> காலணிகளை கழற்றுதல்:</span> ஒருவர் மஸ்ஹு செய்ததன் பின் தனது <span class="c2">(ஹுப்)</span> காலணியின் ஒன்றை அல்லது இரண்டையும் கழற்றினால் அவரின் மஸ்ஹ் முறிந்து விடும். </p>',
            ],
            15 => [
                'question' => 'கேள்வி 16 : தொழுகை என்பதன் கருத்து யாது?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3390.mp3',
                'answer' => '<p> பதில்: தொழுகையென்பது குறிப்பிட்ட வார்த்தைகள், செயற்பாடுகளினூடாக அல்லாஹ்வை வணங்குவதாகும். இவ்வணக்கமானது தக்பீர் கூறி ஆரம்பிக்கப்பட்டு ஸலாமுடன் முடிவடையும். </p>',
            ],
            16 => [
                'question' => 'கேள்வி 17 : தொழுகையின் சட்ட நிலை யாது ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3420.mp3',
                'answer' => '<p> பதில் : தொழுகை ஒவ்வொரு முஸ்லிமின்; மீதுள்ள கட்டாயக் கடமையாகும்.<span class="c6"><br /> அல்லாஹ் கூறுகிறான் :</span> "நிசயமாக தொழுகை முஃமின்கள் மீது நேரங்குறிப்பிடப்பட்ட கடமையாக உள்ளது". <span class="c2">(ஸூறதுன்னிஸா :103)</span> </p>',
            ],
            17 => [
                'question' => 'கேள்வி 18 : தொழுகையை விடுவதன் சட்ட நிலை யாது?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3460.mp3',
                'answer' => '<p> பதில் : தொழுகையை விட்டுவிடுவது குப்ராகும் <span class="c2">(இறைநிராகரிப்பாகும்)</span>. நபி <span class="c2">(ஸல்)</span> இது குறித்து பின்வருமாறு கூறுகிறார்கள் :<br /> "எமக்கும் அவர்களுக்கும் <span class="c2">(இறை மறுப்பாளர்களுக்கும்)</span> இடையிலான ஒப்பந்தம் - உடன்படிக்கை – தொழுகையாகும். எனவே அதனை யார் விட்டு விடுகிறாரோ அவர் காஃபிராகி விட்டார்".<br /> இந்த ஹதீஸை அஹ்மத், திர்மிதி மற்றும் ஏனையோர் பதிவு செய்துள்ளனர். </p>',
            ],
            18 => [
                'question' => 'கேள்வி 19 : ஒரு நாளைக்கு முஸ்லிமின் மீது கடமையான தொழுகைகள் எத்தனை ? ஒவ்வொரு தொழுகையின் ரக்அத்துக்களின் எண்ணிக்கை யாது ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3500.mp3',
                'answer' => '<p> பதில் : ஐந்து நேரத் தொழுகைகள் ஆகும்.<span class="c6"> ஒவ்வொரு தொழுகையினதும் ரக்அத்துக்களின் எண்ணிக்கை விபரம் :</span> ஸுப்ஹ் தொழுகை இரண்டு ரக்அத்துக்கள், லுஹர் தொழுகை நான்கு ரக்அத்துக்கள், அஸ்ர் தொழுகை நான்கு ரக்அத்துக்கள், மஃரிப் தொழுகை மூன்று ரக்அத்துக்கள், இஷாத் தொழுகை நான்கு ரக்அத்துக்கள் ஆகும். </p>',
            ],
            19 => [
                'question' => 'கேள்வி 20 : தொழுகையின் நிபந்தனைகளைக் குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3530.mp3',
                'answer' => '<p> பதில் : 1- முஸ்லிமாக இருத்தல், காபிரின் தொழுகை நிறை வேற மாட்டாது.<br /> 2- புத்தி சுவாதீனமுள்ளவராக இருத்தல் பைத்தியகாரனின் தொழுகை நிறைவேறமாட்டாது.<br /> 3- நல்லதையும் கெட்டததையும் பிரித்தறிந்து விளங்கும் பருவத்தை அடைந்திருத்தல். அதனடிப்படையில் பிரித்தறியும் பருவத்தை அடையாத சிறுவரின் தொழுகை நிறைவேற மாட்டாது.<br /> 4- நிய்யத் வைத்தல் <span class="c2">(மனதால் நினைத்தல்)</span><br /> 5- தொழுகைக்குரிய நேரத்தை அடைந்திருத்தல்.<br /> 6- தொடக்கை விட்டும் நீங்கி சுத்தமாய் இருத்தல்.<br /> 7- நஜிஸை விட்டும் சுத்தமாயிருத்தல்.<br /> 8- உடலில் அவசியம் மறைக்க வேண்டிய பகுதியை மறைத்தல்.<br /> 9- கிப்லாவை முன்னோக்குதல். </p>',
            ],
            20 => [
                'question' => 'கேள்வி 21 : தொழுகையின் ருகுன்களைக் (பர்ளுகளைக்) குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3640.mp3',
                'answer' => '<p> பதில் : தொழுகையின் <span class="c2">(பர்ளுகள் )</span> 14 ஆகும்.<span class="c6"> அவை பின்வருமாறு :</span><br /> 1- பர்ளான தொழுகையில் நின்று தொழ சக்தியுள்ளவர் நின்று தொழுதல்.<br /> 2- இஹ்ராம் தக்பீர், அதாவது அல்லாஹு அக்பர் எனக் கூறல்.<br /> 3- சூறா அல் பாத்திஹாவை ஓதுதல்.<br /> 4- ருகூஊ செய்தல். <span class="c2">(குணிதல்)</span> அதாவது முதுகை வலைத்து நேராக தலையை முதுகு மட்டத்திற்கு சமமாக முன்னோக்கி வைத்தல்.<br /> 5- ருகூவிலிருந்து மீண்டும் நிலைக்கு வருதல்.<br /> 6- இஃதிலாலில் நேராக நிற்றல். <span class="c2">(ருகூவிற்குப்பின் நிலையாக நிற்றல்)</span>.<br /> 7-<span class="c6"> ஸுஜூத் செய்தல்:</span> ஸுஜூதின் போது நெற்றி மற்றும் மூக்கு இரு உள்ளங்கைகள் முட்டுக்கால்கள் இரு கால் விரல்களின் உட்பகுதிகள் போன்றவை தரையில் படும் நிலையில் இருத்தல் வேண்டும்.<br /> 8- ஸுஜூதிலிருந்து இருப்புக்கு வருதல்.<br /> 9- இரண்டு ஸஜ்தாக்களுக்கு இடையில் அமர்தல்.<br /> வலது காலை நட்டி இடது காலை விரித்து அதன் மீது அமர்வதோடு அதனை கிப்லாவை நோக்கி வைப்பதும் ஸுன்னாவாகும்.<br /> 10- அனைத்து செயல் சார்ந்த பர்ளுகளிலும் தாமதித்திருத்தல்.<br /> 11- இறுதி அத்தஹிய்யாத்து<br /> 12-அதற்காக அமர்தல்.<br /> 13- ஸலாம் கூறுதல். அதாவது இரண்டு முறை \'அஸ்ஸலாமு அலைக்கும் வரஹ்மதுல்லாஹ்\' என்று கூறுதல்.<br /> 14- இங்கு விபரிக்கப்பட்ட பர்ளுகளை <span class="c2">(ருகுன்களை)</span> சொல்லப்பட்ட ஒழுங்கு முறைப்படி கிரமமாகச் செய்தல். உதாரணத்திற்கு ஒருவர் ருகூஉ செய்வதற்கு முன் ஸுஜுத் செய்தால் அவரின் தொழுகை வீணாகி விடும். மறந்து செய்தால் மீண்டும் எழுந்து ருகூ செய்து விட்டு பின்னர் ஸுஜூத் செய்தல் வேண்டும். </p>',
            ],
            21 => [
                'question' => 'கேள்வி 22 : தொழுகையின் வாஜிப்களை குறிப்பிடுக.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3820.mp3',
                'answer' => '<p> பதில் : தொழுகையின் வாஜிப்கள் எட்டாகும்.<span class="c6"> அவையாவன:</span><br /> 1- இஹ்ராம் தக்பீர் தவிர்ந்த ஏனைய தக்பீர்கள்.<br /> 2- இமாமும் தனித்து தொழுபவரும் \'ஸமிஅல்லாஹுலிமன் ஹமிதஃ\' என்று கூறுதல்.<br /> 3- \'ரப்பனா வலகல் ஹம்து\' என்று கூறுதல்.<br /> 4- ருகூவில் ஒரு தடவை \'ஸுப்ஹான ரப்பியல் அழீம்\' என்று கூறுதல்.<br /> 5- ஸுஜுதில் ஒரு தடவை \'ஸுப்ஹான ரப்பியல் அஃலா\' என்று கூறுதல்.<br /> 6- இரு ஸஜ்தாக்களுக்குமிடையில் \' ரப்பிஃபிர்லி \' என்று கூறுதல்.<br /> 7- முதலாவது அத்தஹிய்யாத்.<br /> 8- முதலாவது அத்தஹிய்யாத்திற்காக அமர்தல். </p>',
            ],
            22 => [
                'question' => 'கேள்வி 23 : தொழுகையின் ஸுன்னத்துகள் எவை ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3930.mp3',
                'answer' => '<p> பதில் : அவை 11 ஆகும்.<span class="c6"> அவைகள் பின்வருமாறு :</span><br /> 1-இஹ்ராம் தக்பீருக்குப்பின் \' ஸுப்ஹானகல்லாஹும்ம வபிஹம்திக வதபாரகஸ்முக வதஆலா ஜத்துக வலா இலாஹ கய்ருக\' எனக் கூறுவது. இது துஆ அல் இஸ்திப்தாஹ் என்றழைக்கப்படுகிறது. பொருள் <span class="c2">( யா அல்லாஹ் உன்னைப் புகழ்வதுடன் துதிக்கவும் செய்கிறேன். உனது திருப்பெயர் அருட்பேர் மிக்கது. உனது ஆற்றல் மிகவும் உயர்ந்தது. உன்னைத் தவிர உண்மையான வணக்கத்திற்குரிய இறைவன் வேறு யாருமில்லை.)</span>.<br /> 2- இஸ்திஆதா கூறுதல் <span class="c2">(அஊது பில்லாஹி மினஷ்ஷைத்தானிர் ரஜீம்)</span> என்று கூறுதல்.<br /> 3- பிஸ்மில்லாஹ் கூறுதல் <span class="c2">( பிஸ்மில்லாஹிர் ரஹ்மானிர் ரஹீம்)</span>.<br /> 4- ஆமின் கூறுதல்.<br /> 5- ஸூறா பாத்திஹாவை ஒதி முடிந்ததும் ஏதாவது ஒரு ஸூறாவை ஓதுதல்.<br /> 6- சப்தமாக ஒதித் தொழும் தொழுகையில் இமாம் சப்தமாக ஓதுதல்.<br /> 7- "ரப்பனா வலகல் ஹம்து" என்ற வார்த்தைக்குப்பின் "மில்அஸ்ஸமாவாதி வமில்அல் அர்ழி வமில்அ மாஷி.ஃத மின ஷைஇன் பஃது" என்று கூறுதல்.<br /> 8- ருகூவில் ஒதும் தஸ்பீஹை ஒரு தடவைக்கு மேல் அதிகமாக கூறுதல்.<br /> 9- ஸுஜூதின் தஸ்பீஹை ஒரு முறைக்கு மேல் அதிகமாக கூறுதல்.<br /> 10- இரண்டு ஸஜ்தாவுக்கு இடையில் அமர்ந்திருக்கும் போது கூறும் \'ரப்பிஃபிர்லி\' என்ற துஆவை ஒரு தடவைக்கும் மேல் அதிகமாக கூறுதல்.<br /> 11- இறுதி அத்தஹிய்யாத்தில் ஸலவாத் சொல்வதும் அதனைத் தொடர்ந்து துஆ இறைஞ்சுவதும்.<span class="c6"><br /> நான்காவது :</span> செயல்ரீதியான ஸுன்னத்துக்கள் :<br /> 1- இஹ்ராம் தக்பீரின் போது இரு கைகளையும் உயர்த்துதல்.<br /> 2- ருகூவிற்கு செல்லும் போதும்.<br /> 3- ருகூவிலிருந்து மீண்டும் நிலைக்கு செல்லும் போதும் இரு கைகளையும் உயர்த்துதல்.<br /> 4- அதன் பின் இரு கைகளையும் கீழே விட்டுவிடுதல்.<br /> 5- வலது கையை இடது கையின் மீது வைத்தல்.<br /> 6- ஸுஜூத் செய்யும் இடத்தைப் பார்த்தல்<br /> 7- நின்ற நிலையில் இருக்கும் போது இரு கால்களுக்கு மிடையில் இடைவெளிவிடுதல்.<br /> 8- ருகூவில் இருக்கும் போது இரு முழங்கால்களையும் இரண்டு கைகளினால் விரல்களை விரித்த நிலையில் பிடித்தல். முதுகை நேராக வைத்து தலையை அதற்கு நேராக வைத்தல்.<br /> 9- ஸுஜூதின் போது தரையில் கட்டாயம் பட வேண்டிய உறுப்புகளை தரையில் படுமாறு வைத்தல்.<br /> 10- ஸுஜூத் செய்யும் போது <span class="c2">(மேற் கைகளை (மேற்கை (Arm)</span> என்பது தோள் பட்டைக்கும் முழங்கை மூட்டிற்கும் இடைப்பட்ட பகுதியாகும்) விலாவை விட்டும் தூரமாக வைத்தல், வயிற்றை இரு தொடைகளை விட்டும் தூரப்படுத்துதல், தொடையை இரு கெண்டை கால்களை விட்டும் தூரப்படுத்தல், முட்டுக்கால்களை அகற்றி வைத்தல், பாதங்களை நிமிர்த்தி நட்டிவைத்தல், இரு கால் விரல்களின் உட்புறத்தை தரையில் பிரித்து வைத்தல், இரு கைகளையும் தோள்பட்டைக்கு நேராக விரிக்கப்படட்டதாகவும் விரல்களை சேர்த்தும் வைத்தல்.<br /> 11- இரு ஸஜ்தாக்கிடையிலான இருப்பிலும் முதல் அத்தஹிய்யாத் இருப்பிலும் இப்திராஷ் இருப்பு இருத்தல். இரண்டாவது அத்தஹிய்யாத்தில் தவர்ருக் இருப்பு இருத்தல். <span class="c2">(குறிப்பு)</span> இப்திராஷ் இருப்பு என்பது இடது கால் மீது அமர்ந்து வலது காலை நாட்டி வைத்து அதன் விரல்களை கஅபாவை நோக்கி மடக்கி வைத்தல். தவர்ருக் இருப்பு என்பது தரையில் இருப்பிடம் படியுமாறு அமர்ந்து இடது காலை, வலது காலுக்குக் கீழ் வெளிப்படுத்தி, வலது காலை நாட்டி, அதன் விரல்களை கஅபாவை நோக்கி வைத்தல்). <span class="c2">(மொழிபெயர்ப்பாளர்)</span>.<br /> 12- இரு ஸஜ்தாக்கிடையிலான இருப்பில் இரு தொடைகளின் மேல் இருகைகளையும் விரித்து கைவிரல்களை சேர்த்தும் வைத்தல். அவ்வாறே அத்தஹிய்யாத்திலும் வைக்க வேண்டும். என்றாலும் வலது கையின் சின்ன விரலையும் மோதிர விரலையும் மடித்து நடுவிரலை பெரும் விரலோடு சேர்த்து வட்டமாக்கி அல்லாஹ்வின் பெயர் கூறும்போது ஆள்காட்டி விரலால் சைக்கினை செய்தல் வேண்டும்.<br /> 13- <span class="c2">(தொழுகையை முடிப்பதற்கு ஸலாம் கூறும் போது)</span> முதலாவது ஸலாமில் தலையை வலப்பக்கமாகவும் இரண்டாவது ஸலாமில் இடப்பக்கமாகவும் திருப்புதல். </p>',
            ],
            23 => [
                'question' => 'கேள்வி 24 : தொழுகையை முறிக்கும் காரியங்களை குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4210.mp3',
                'answer' => '<p> பதில் : 1- தொழுகையின் நிபந்தனைகளில் ஏதாவது ஒன்றை அல்லது -பர்ளுகளிள் ஏதாவது ஒன்றை விட்டு விடுதல்.<br /> 2- வேண்டுமென்றே தொழுகையில் பேசுதல் <span class="c2">(கதைத்தல்)</span>.<br /> 3- சாப்பிடுதல் அல்லது குடித்தல்.<br /> 4- தொடரான அதிக அசைவுகள்.<br /> 5- வேண்டுமென்றே தொiழுகையின் வாஜிப்களில் ஒன்றை விடுதல். </p>',
            ],
            24 => [
                'question' => 'கேள்வி 25 : ஒரு முஸ்லிம் எவ்வாறு தொழுகையை நிறைவேற்றுவான்?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4280.mp3',
                'answer' => '<p> பதில் : தொழும் முறை <span class="c2">(ஒரு முஸ்லிம் பின்வரும் ஒழுங்கில் தொழுகையை நிறைவோற்றுவான்)</span> :<br /> 1- கிப்லா என்னும் கஃபா ஆலயத்தை தனது முழு உடலினாலும் நேராக நின்று முன்னோக்க வேண்டும்.<br /> 2- பின்னர் தொழவிரும்பும் தொழுகையை நாவினால் மொழியாமல் மனதில் நினைக்க வேண்டும்.<br /> 3- பின்னர் அல்லாஹு அக்பர் என்று கூறி தக்பீர் கூறும்போது இரு கைகளையும் தோள்பட்டைக்கு நேராக உயர்த்த வேண்டும்.<br /> 4- வலது கை மணிக்கட்டை இடது கை மணிக்கட்டின் மீது வைத்து நெஞ்சின் மீது கட்டிக்கொள்ள வேண்டும்.<br /> 5- பிறகு பின்வரும் பிராத்தனைகளில் <span class="c2">(துஆக்களில்)</span> ஒன்றை ஆரம்பமாக ஓதவேண்டும். அல்லாஹும்ம பாஇத் பைனீ வபைன கதாயாய கமா பாஅத்த பைனல் மஷ்ரிகி வல் மக்ரிப். அல்லாஹும்ம நக்கினீ மினல் கதாயா கமா யுனக்கஸ் ஸவ்புல் அப்யலு மினத் தனஸ்.<span class="c6"> அல்லாஹும்மக்ஸில்னீ மின் கதாயாய பில்மாஇ வஸ்ஸல்ஜி வல்பரத்\' பொருள் :</span><br /> யாஅல்லாஹ்! கிழக்குக்கும், மேற்குக்கும் இடையே வெகு தூரத்தை நீ ஏற்படுத்தியதைப் போல் எனக்கும், என் தவறுகளுக்குமிடையே நீ தூரத்தை ஏற்படுத்துவாயாக! யாஅல்லாஹ்! வெண்மையான ஆடை அழுக்கிலிருந்து தூய்மைப்படுத்தப்படுவது போல் என்னை என் தவறுகளிலிருந்து தூய்மைப்படுத்துவாயாக! இறைவா! தண்ணீராலும், பனிக்கட்டியாலும், ஆலங்கட்டியாலும் என் தவறுகளைக் கழுவி விடுவாயாக!.<span class="c6"><br /> அல்லது:</span> \'ஸுப்ஹானகல்லாஹும்ம வபிஹம்திக வதபாரகஸ்முக வதஆலா ஜத்துக வலா இலாஹ கைருக\'. <span class="c2">(பொருள் : யா அல்லாஹ்! உன்னை புகழ்ந்து, நீ மிகவும் பரிசுத்தமானவன் எனத் துதிசெய்கிறேன். உனது பெயர் சுபிட்சம் வாய்ந்ததும் அருட்பேறு உடையதுமாகும். உனது புகழ் (பெருமை)</span> மிகவும் உயர்ந்தது. உன்னைத் தவிர உண்மையான வணக்கத்திற்குரிய இறைவன் வேறு யாரும் இல்லை.)<br /> 6-<span class="c6"> பின்னர் இஸ்திஆதா ஓதுவார் அதாவது :</span> அஊது பில்லாஹி மினஷ்ஷைத்தானிர் ரஜீம்\' என ஓதுவார். <span class="c2">(எறியப்பட்ட ஷைத்தானை விட்டும் அல்லாஹ்விடம் பாதுகாவல் தேடுகின்றேன்)</span> 7- பிறகு பிஸ்மிலுடன் ஃபாத்திஹா ஸூராவை ஓதவேண்டும்.<span class="c6"> அது பின்வருமாறு :</span> பிஸ்மில்லாஹிர் ரஹ்மானிர் ரஹீம் <span class="c2">(அளவற்ற அருளாளனும், நிகரற்ற அன்புடையோனுமாகிய அல்லாஹ்வின் திருப்பெயரால் (துவங்குகிறேன்)</span>). அல்ஹ்ம்து லில்லாஹி ரப்பில் ஆலமீன் <span class="c2">(அகிலத்தார் அனைவரையும் படைத்து பரிபாலிக்கும் அல்லாஹ்வுக்கே எல்லாப் புகழும்)</span>. அர்ரஹ்மானிர் ரஹீம். <span class="c2">(அவன் அளவற்ற அருளாளனும், நிகரற்ற அன்புடையோனுமாவான்)</span>. மாலிகி யவ்மித்தீன். <span class="c2">(தீர்ப்பு நாளின் அதிபதி(யும் அவனே)</span>). இய்யாக நஃபுது வஇய்யாக நஸ்தஈன் <span class="c2">(நாங்கள் உன்னையே வணங்குகிறோம். உன்னிடமே உதவி தேடுகிறோம்.)</span> இஹ்தினஸ் ஸிராதல் முஸ்தகீம். <span class="c2">(நீ எங்களை நேரான வழியில் நடத்துவாயாக!)</span>. ஸிராதல்லதீன அன்அம்த அலைஹிம் கைரில் மஃழூபி அலைஹிம் வலழ் ழால்லீன். <span class="c2">((அவ்வழி)</span> எவர்களுக்கு நீ அருள் புரிந்தாயோ அவர்கள் <span class="c2">(சென்ற)</span> வழி. <span class="c2">(உன்)</span> கோபத்திற்குள்ளானவர்களோ வழிதவறியவர்களோ சென்ற வழியல்ல.) <span class="c2">(பாதிஹா : 1 - 7)</span>.<br /> பிறகு <span class="c2">(ஆமீன்)</span> என கூறுவார். ஆமீன் என்பதன் கருத்து <span class="c2">(யாஅல்லாஹ் எனது பிரார்த்தனையை ஏற்றுக்கொள்வாயாக)</span> என்பதாகும்.<br /> 8- பிறகு அல் குர்ஆனில் அவருக்கு முடியுமான சில வசனங்களை ஓத வேண்டும். மேலும் ஸுப்ஹ் தொழுகையில் <span class="c2">(சற்று)</span> அதிகமாக ஓதுவார்.<br /> 9- பிறகு அவர் ருகூஃ செய்வார். அதாவது அல்லாஹ்வை மகிமைப்படுத்தும் முகமாக அவர் முதுகை வளைத்து குனிவார். இவ்வாறு ருகூ செய்யும் போது அல்லாஹு அக்பர் என்று கூறி தனது இரு கைகளையும் தோள்பட்டைக்கு நேராக உயர்த்துவார். முதுகை வளைத்து தலையை நேராக முதுகின் மட்டத்திற்கு சமமாக வைப்பார். இரண்டு கைகளையும்- விரல்களை விரித்தவாறு- முட்டுக்கால்களின் மீது வைப்பார்.<br /> 10- ருகூவில் \'ஸுப்ஹான ரப்பியல் அழீம்\' <span class="c2">(பொருள்: மகத்தான எனது இரட்சகனை நான் தூய்மைப்படுத்துகிறேன்)</span> என்று மூன்று தடவைகள் கூறுவார். மேலும் இந்த தஸ்பீஹுடன் \'ஸுப்ஹானகல்லாஹும்ம ரப்பனா வபிஹம்திக அல்லாஹும்ம ஃபிர்லீ\'. <span class="c2">(பொருள் : யாஅல்லாஹ் என் இரட்சகனே! உன்னைப் புகழ்வதுடன் நீ தூய்மையானவன் என்றும் போற்றுகிறேன். யா அல்லாஹ் என்னை மன்னித்தருள்வாயாக!)</span> என்ற துஆவை மேலதிகமாக ஓதுவது சிறந்ததாகும்!.<br /> 11- \'ஸமிஅல்லாஹு லிமன் ஹமிதஃ\' <span class="c2">(பொருள் : தன்னைப் புகழ்பவனின் புகழுரையை அல்லாஹ் செவிமடுத்து அங்கீகரித்தான்)</span> என்று கூறியவாறு ருகூவிலிருந்து எழும்புவார். அந் நேரம் இரு கைகளையும் புயத்திற்கு நேராக உயர்த்தி \'ரப்பனா வலகல்ஹம்து\' என்று கூறுவார். ஜமாஅத்தாக தொழும் மஃமூம் \'ஸமிஅல்லாஹு லிமன் ஹமிதஃ\' என்று கூறாது அதற்குப் பதிலாக \'ரப்பனா வலகல் ஹம்து\' <span class="c2">(பொருள்: எங்கள் இரட்சகனே, புகழ் அனைத்தும் உனக்கே உரியன)</span> என்று கூறுவார்.<span class="c6"> குறிப்பு :</span> தனித்துத் தொழுபவர் ருகூவிலிருந்து எழும்பும் போது \'ஸமிஅல்லாஹு லிமன் ஹமிதஃ\' கூறுவதுடன் அதனைத் தொடர்ந்து \'ரப்பனா வலகல் ஹம்து\' என்றும் கூற வேண்டும்.<br /> 12- ருகூவிலிருந்து எழுந்ததும் \'ரப்பனா வலகல் ஹம்து மில்அஸ்ஸமாவாதி வமில்அல் அர்ழி வமில்அ மாஷி.ஃத மின் ஷைஇன் பஃத்\' என்று கூறுவார். <span class="c2">(பொருள் : எங்கள் இரட்சகனே, புகழ் அனைத்தும் உனக்கே உரியன வானங்களும் பூமியும் அவ்விரண்டுக்கும் இடைப்பட்டவைகளும் நிரம்புமளவிற்கும் மேலும் நீ எதை நாடுகிறாயோ அது நிரம்பும் அளவுக்கு (உனக்கே புகழனைத்தும்)</span>).<br /> 13- பிறகு அல்லாஹு அக்பர் என்று கூறி முதலாவது ஸஜ்தா செய்வார். முகம் <span class="c2">(மூக்கு,நெற்றி)</span> இரண்டு உள்ளங்கைகள், இரண்டு முட்டுக்கால்கள், இரண்டு கால் விரல்களின் உட்பகுதி ஆகிய ஏழு உறுப்புக்களும் பூமியில் படும் வகையில் ஸுஜூது செய்வார். கைகளை விலாவோடு சேர்த்து வைக்கவோ முழங்கைகளை தரையில் படுமாறு வைக்கவோ கூடாது. அவரின் கைவிரல்கள் கிப்லா திசையை நோக்கியதாக வைக்க வேண்டும்.<br /> 14- \'ஸுஜூதில் ஸுப்ஹான ரப்பியல் அஃலா\' <span class="c2">(பொருள்: மிக உயர்ந்தவனாகிய என் இரட்சகனை துதிசெய்கிறேன்)</span> என்று மூன்று முறை கூறவேண்டும். மேலும் இந்த தஸ்பீஹுடன் \'ஸுப்ஹானகல்லாஹும்ம ரப்பன வபிஹம்திக அல்லாஹும்ம ஃபிர்லீ\' <span class="c2">(பொருள் :யாஅல்லாஹ் என் இரட்சகனே! உன்னை புகழ்வதுடன் நீ தூய்மையானவன் எனவும் துதிக்கின்றேன். யா அல்லாஹ் என்னை மன்னித்தருள்வாயாக!)</span> என்ற துஆவை மேலதிகமாக ஓதுவது சிறந்ததாகும்!<br /> 15- பிறகு அல்லாஹு அக்பர் என்று கூறியவாறு ஸுஜூதிலிருந்து தலையை உயர்த்துவார்<br /> 16- பின்னர் இரண்டு ஸஜ்தாவுக்குமிடையில் வலது காலை நட்டி இடது காலை மடித்து அதன் மீது அமர்வார். வலது கையை வலது பக்க தெடையின் மீது முழங்காலின் ஒரத்தில் வைத்து வலது கையின் சின்ன விரலையும் மோதிர விரலையும் மடித்து ஆள்காட்டி விரலை உயர்த்தி, பிரார்த்தனை செய்யும் போது அதை அசைப்பார், மேலும் கட்டைவிரலின் நுனியை நடுவிரல் நுனியுடன் இணைத்து வட்டம் போல் ஆக்கிக்கொள்வார், அத்துடன்; அவர் தனது இடது கையை தனது இடது தொடையின் மீது விரல்களை விரித்த நிலையில் நீட்டி முழங்கால் ஓரத்தில் வைப்பார்.<br /> 17-<span class="c6"> இரண்டு ஸஜ்தாவுக்கு இடையில் அமர்ந்து பின்வரும் துஆவை ஓதுவார் :</span> ரப்பிஃபிர்லீ, வர்ஹம்னீ, வஹ்தினீ, வர்ஸுக்னீ, வஜ்புர்னீ, வஆபினீ\' <span class="c2">(பொருள் : யா அல்லாஹ் ! என்னை மன்னித்து எனக்கு அருள்புரிந்து நேர்வழிகாட்டுவாயாக! எனக்கு வாழ்வாதாரத்தை தருவாயாக! என்குறைகளை மறைத்து எனக்கு ஆறுதலைத் தந்திடுவாயாக! எனக்கு ஆரோக்கியத்தை வழங்குவாயாக!)</span>.<br /> 18- பிறகு முதல் ஸஜ்தா செய்தது போன்று இரண்டாவது ஸஜ்தாவை அல்லாஹு அக்பர் என்று கூறி முதலில் சொன்னது, செய்ததைப்போன்று மீண்டும் செய்வார். <span class="c2">(இத்துனுடன் முதல் ரக்அத் முடிந்துவிடும்)</span><br /> 19- பிறகு அல்லாஹு அக்பர் என்று கூறியவாறு எழுந்து, மீண்டும் நிலைக்கு வருவார். இரண்டாவது ரக்அத்தை முதல் ரக்அத்தைப் போன்றே தொழுவார். எனினும் இதில் ஃபாத்திஹா ஸூராவுக்கு முன்னுள்ள துஆஉல் இஸ்திப்தாஹ் பிராத்தனையை மீண்டும் ஓதமாட்டார்.<br /> 20- இரண்டாவது ரக்அத் முடிந்த பிறகு அல்லாஹு அக்பர் என்று கூறியவாறு இரண்டு ஸஜ்தாவிற்கும் இடையில் அமர்ந்தது போன்று அமர்வார்.<br /> 21-<span class="c6"> இந்த அமர்வில் அத்தஹிய்யாத் எனும் பின்வரும் பிரார்த்தனையை ஓதுவார் :</span> அத்தஹிய்யாது லில்லாஹி வஸ்ஸலவாது வத்தய்யிபாது அஸ்ஸலாமு அலைக அய்யுஹந் நபிய்யு வரஹ்மதுல்லாஹி வபரகாதுஹூ அஸ்ஸலாமு அலைனா வஅலா இபாதில்லாஹிஸ் ஸாலிஹீன். அஷ்ஹது அல்லாஇலாஹ இல்லல்லாஹ் வஅஷ்ஹது அன்ன முஹம்மதன் அப்துஹூ வரஸூலுஹூ\'. <span class="c2">(அதனைத் தொடர்ந்து பின்வரும் ஸலவாத்தை ஓதுவார்)</span> \'அல்லாஹும்ம ஸல்லி அலா முஹம்மதின் வஅலா ஆலி முஹம்மதின் கமா ஸல்லைத அலா இப்ராஹீம வஅலா ஆலி இப்ராஹீம இன்னக ஹமீதுன் மஜீத் - வபாரிக் அலா முஹம்மதின் வஅலா ஆலி முஹம்மதின் - கமா பாரக்த அலா இப்ராஹீம வஅலா ஆலி இப்ராஹீம இன்னக ஹமீதுன் மஜீத். <span class="c2">(இதன் பிறகு பின்வரும் துஆவை ஓதுவார்)</span>. அஊது பில்லாஹி மின் அதாபி ஜஹன்னம வமின் அதாபில் கப்ரி வமின் பித்னதில் மஹ்யா வல்மமாதி வமின் பித்னதில் மஸீஹித் தஜ்ஜால்\' . <span class="c2">(பொருள் : காணிக்கைகளும் வணக்கங்களும் பாராட்டுக்களும் அல்லாஹ்வுக்கே உரியன. நபியே உங்களின் மீது ஸலாமும் அல்லாஹ்வின் ரஹ்மத்தும் பரகத்தும் ஏற்படட்டுமாக! எங்களின் மீதும் அல்லாஹ்வின் நல்லடியார்கள் அனைவர் மீதும் ஸலாம் உண்டாகட்டும், வணக்கத்திற்குரியவன் அல்லாஹ்வைத் தவிர யாருமில்லை என்று சான்று பகர்கிறேன். மேலும், முஹம்மத் (ஸல்)</span> அவர்கள் அல்லாஹ்வின் அடியாரும் தூதருமாக இருக்கிறார்கள் என்றும் சான்று பகர்கிறேன். யா அல்லாஹ்! இப்ராஹீம் <span class="c2">(அலை)</span> அவர்கள் மீதும் அவர்களின் குடும்பத்தவர்கள் மீதும் அருள் புரிந்தது போல், முஹம்மத் <span class="c2">(ஸல்)</span> அவர்கள் மீதும் அவர்கள் குடும்பத்தவர்; மீதும் அருள்புரிவாயாக. யா அல்லாஹ்! நீ இப்ராஹீம் <span class="c2">(அலை)</span> மீதும், அவரின் குடும்பத்தார் மீதும் உன் அருள்வளத்தையும்,செழிப்பையும் அள்ளிப் பொழிந்தது போல் முஹம்மது <span class="c2">(ஸல்)</span> அவர்கள் மீதும் அவர்களின் குடும்பத்தார் மீதும் உன் அருள்வளத்தையும செழிப்பையும் பொழிவாயாக !நீயே புகழுக்குரியவன் கீர்த்திமிக்கவன். யா அல்லாஹ்! மண்ணறையின் வேதனையில் இருந்தும் நரகத்தின் வேதனையில் இருந்தும் வாழ்க்கை மற்றும் மரணத்தின் குழப்பத்தில் இருந்தும் தஜ்ஜாலின் குழப்பத்தில் இருந்தும் நான் உன்னிடம் பாதுகாவல் தேடுகிறேன்). இதன் பிறகு இம்மை மறுமைக்குரிய நலன்களில் தான் விரும்பியதை தனது இரட்சகனிடம் வேண்டிப் பிரார்த்திப்பார்.<br /> 22- பிறகு வலது புறம் முகத்தைத் திருப்பி "அஸ்ஸலாமு அலைக்கும் வரஹ்மத்துல்லாஹ்" என்று கூறுவார்;. பிறகு இடது புறம் முகத்தைத் திருப்பி அது போன்றே கூறுவார் <span class="c2">(இத்துடன் இரண்டு ரக்அத் தொழுகை முடிவடைகிறது.)</span><br /> 23- மூன்று அல்லது நான்கு ரக்அத்துக்கள் கொண்ட தொழுகைகளைத் தொழும்போது முதலாவது அத்தஹியாத்தில் \'அஷ்ஹது அல்லா இலாஹ இல்லல்லாஹு வஅஷ்ஹது அன்ன முஹம்மதன் அப்துஹூ வரஸூலுஹூ\' என்ற வார்த்தை வரை ஒதி நிறுத்திக்கொள்வார்;<br /> 24- பிறகு அல்லாஹு அக்பர் எனக் கூறி நிலைக்கு வர வேண்டும். அப்போது இரு கைகளையும் தோள் புயத்திற்கு நேராக உயர்த்த வேண்டும்.<br /> 25- எஞ்சிய ரக்அத்துக்களை இரண்டாம் ரக்அத்தை தொழுத முறையில் தொழ வேண்டும். அதில் ஸூறதுல் பாத்திஹாவை மாத்திரம் ஓதிக் கொள்வார்.<br /> 26- பிறகு \'தவர்ருக்\' முறையில் அமர்வார். அதாவது வலது காலை நட்டி வைத்து, இடது காலை வலது காலுக்கு கீழ் வெளிப்படுத்தி தமது இருப்பிடத்தை <span class="c2">(பித்தட்டை)</span> தரையில் வைத்து அமர்ந்து கொள்வதே \'தவர்ருக்\' முறையாகும். பின்னர் தனது இரு கைகளையும் முதலாவது அத்தஹிய்யாத்தில் தொடையின் மீது வைத்த முறையில் வைக்க வேண்டும்.<br /> 27- இந்த இருப்பில் அத்தஹிய்யாத் முழுவதையும் <span class="c2">(துஆக்களுடன்)</span> ஓதுவார்.<br /> 28- பிறகு வலது புறம் <span class="c2">(முகத்தைத் திருப்பி)</span> அஸ்ஸலாமு அலைக்கும் வரஹ்மத்துல்லாஹ் என்று கூறுவார். பிறகு இடது புறம் முகத்தைத் திருப்பி அது போன்றே ஸலாம் கூறுவார். </p>',
            ],
            25 => [
                'question' => 'கேள்வி 26: தொழுது ஸலாம் கொடுத்ததின் பின் ஓதுபவை என்ன?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4610.mp3',
                'answer' => '<p> பதில்- \'அஸ்தஃபிருல்லாஹ்\' என்று மூன்று முறை கூறுவார்.<br /> அல்லாஹும்ம அன்தஸ் ஸலாம், வமின்கஸ் ஸலாம், தபாரக்த யாதல் ஜலாலி வல்இக்ராம்\'. <span class="c2">(பொருள்: இறைவா! நீயே சாந்தியுடைவன். உன்னிடமிருந்தே சாந்தி ஏற்படுகிறது, மகத்துவமும், கண்ணியமும் உடையவனே! நீ மகத்துவமிக்கவனாய் உள்ளாய்.)</span><br /> லாஇலாஹ இல்லல்லாஹு வஹ்தஹூ லாஷரீகலஹூ லஹுல்முல்கு வலஹுல்ஹம்து வஹுவ அலா குல்லி ஷைஇன் கதீர், லாஹெளல வலாகுவ்வத இல்லாபில்லாஹ், அல்லாஹும்ம லாமானிஅ லிமா அஃதைத வலா முஃதிய லிமா மனஃத வலாயன்பஉ தல்ஜத்தி மின்கல் ஜத்து\' <span class="c2">(பொருள் : வணக்கத்திற்குரியவன் அல்லாஹ்வைத் தவிர வேறு இறைவனில்லை, அவன் தனித்தவன், அவனுக்கு இணை, துணை எதுவுமில்லை, அரசாட்சி அனைத்தும் அவனுக்கே உரியது, இன்னும் புகழனைத்தும் அவனுக்கே உரியது, மேலும் அவன் அனைத்துப் பொருட்கள் மீதும் சக்தி வாய்ந்தவன், தீமையிலிருந்து விலகுவதும் நன்மையின் மீது ஆற்றல் பெறுவதும் அல்லாஹ்வின் உதவி கொண்டே தவிர இல்லை. எங்கள் இரட்சகனே! நீ கொடுப்பதைத் தடுப்பவர் எவரும் இல்லை, நீ தடுப்பதைக் கொடுப்பவர் எவரும் இல்லை, மதிப்புடைய எவரும் எந்தப் பலனும் அளிக்க மாட்டார், மதிப்பு உன்னிடமே உள்ளது.)</span><br /> லாஇலாஹ இல்லல்லாஹு வஹ்தஹு லாஷரீக்க லஹு லஹுல் முல்க்கு வலஹுல் ஹம்து வஹுவ அலா குல்லி ஷைய்யின் கதீர் லா ஹவ்ல வலா குவ்வத இல்லா பில்லாஹ், லாஇலாஹ இல்லல்லாஹ் வலா நஃபுது இல்லா இய்யாஹு லஹுன் நிஃமது வலஹுல் பழ்லு வலஹுஸ்ஸனாஉல் ஹஸன் லாஇலாஹ இல்லல்லாஹு முக்லிஸீன லஹுத்தீன வலவ் கரிஹல் காபிரூன்\'.<br /> <span class="c2">(பொருள் :உண்மையான வணக்கத்திற்குரிய இறைவன் அல்லாஹ்வைத் தவிர வேறுயாருமில்லை. அவன் தனித்தவன்; அவனுக்கு யாதொரு இணையுமில்லை. ஆட்சியதிகாரமும் அனைத்துப் புகழும் அவனுக்கே உரியன. அவன் அனைத்தின் மீதும் பேராற்றல் உடையவன். அல்லாஹ்வின் நாட்டமும் வல்லமையுமின்றி எதுவொன்றும் அசையவும் முடியாது, எதற்கும் எந்த சக்தியும் கிடையாது. உண்மையான வணக்கத்திற்குரிய இறைவன் அல்லாஹ்வைத் தவிர வேறு யாருமில்லை. அவனைத்தவிர வேறு எவரையும் வணங்கமாட்டோம். அருட்கொடைகள் யாவும் அவனுக்கே உரியன. சிறப்பும் அவனுக்கே உரியது. அழகிய புகழும் பாராட்டும் அவனுக்கே உரியது. உண்மையான வணக்கத்திற்குரிய இறைவன் அல்லாஹ்வைத் தவிர வேறுயாருமில்லை. காபிர்கள் வெறுத்த போதிலும் கீழ்படிதலை அவனுக்கே உரித்தாக்குகிறோம்.)</span><br /> சுப்ஹானல்லாஹ் <span class="c2">(அல்லாஹ் மிகத்தூயவன்)</span> என்று <span class="c2">(33)</span> முப்பத்து மூன்று தடவைகளும்,<br /> அல்ஹம்துலில்லாஹ் <span class="c2">(புகழனைத்தும் அல்லாஹ்வுக்கு உரியன)</span> என்று <span class="c2">(33)</span> முப்பத்து மூன்று தடவைகளும்,<br /> அல்லாஹு அக்பர் <span class="c2">(அல்லாஹ் மிகப்பெரியவன்)</span> என்று <span class="c2">(33)</span> முப்பத்து மூன்று தடவைகளும் ஆக மொத்தம் 99 தடவைகள் கூறிவிட்டு<br /> <span class="c2">(100)</span> நூறாவதை பூரணப்படுத்துவதற்கு பின்வரும் திக்ரை ஓதுவார்: லாஇலாஹ இல்லல்லாஹூ வஹ்தஹூ லாஷரீக லஹு லஹுல் முல்கு வலஹுல் ஹம்து வஹுவ அலா குல்லி ஷைஇன் கதீர்\' <span class="c2">(பொருள்: உண்மையான வணக்கத்திற்குரிய இறைவன் அல்லாஹ்வைத் தவிர வேறுயாருமில்லை அவன் தனித்தவன்; அவனுக்கு எந்த இணையாளருமில்லை. ஆட்சியதிகாரமும் அனைத்துப் புகழும் அவனுக்கே உரியன. அவன் அனைத்தின் மீதும் பேராற்றல் உடையவன்)</span>.<br /> மேலும், ஸுறதுல் இக்லாஸ் முஅவ்விதாத் <span class="c2">(ஸூறதுல் பலக் ஸூறதுன் நாஸ்)</span> ஆகிய ஸூறாக்களை ஸுப்ஹ் மற்றும் மஃரிப் தொழுகைகளின் பின் மூன்று தடவைகளும், ஏனைய தொழுகைகளின் பின் ஒரு தடவையும் ஓதுவார்.<br /> மேலும், ஆயதுல் குர்ஸியை ஒரு தடவை ஓதுவார். \'அல்லாஹு லாஇலாஹ இல்லா ஹுவல் ஹய்யுல் கய்யூம், லா தஃஹுதுஹு ஸினத்துவ்வலா நவ்ம், லஹு மாபிஃஸ் ஸமாவாதி வமாபில் அர்லி, மன்தல்லதி யஷ்பஃஉ இன்தஹு இல்லா பி இத்னிஹி, யஃலமு மாபயின அய்தீஹிம் வமா கல்பஹும், வலா யுஹீதூன பிஷய்இம்மின் இல்மிஹி இல்லா பிமா ஷாஅ, வஸிஅ குர்ஸிய்யுஹுஸ் ஸமாவாதி வல்அர்ல, வலா யஊதுஹு ஹிப்லுஹுமா வஹுவல் அலிய்யுல் அழீம்\' <span class="c2">(பகரா 2:255)</span>. <span class="c2">(பொருள் :(உண்மையாக)</span> வணங்கப்படத் தகுதியானவன் அல்லாஹ்வைத் தவிர வேறு யாரும் இல்லை. அவன் என்றும் உயிருடன் இருப்பவன், நிலைத்திருப்பவன். சிறுதூக்கமோ, உறக்கமோ அவனை ஆட்கொள்ளாது. வானங்களில் உள்ளவையும் பூமியில் உள்ளவையும் அவனுக்கே உரியன. அவனது அனுமதியின்றி அவனிடம் யார்தான் பரிந்துரை செய்யமுடியும்?<span class="c2">(படைப்பினங்களான)</span> அவர்களுக்கு முன் உள்ளவற்றையும் அவர்களுக்குப்பின் உள்ளவற்றையும் அவன் நன்கறிவான். அவன் நாடியவற்றைத் தவிர அவன் அறிந்திருப்பவற்றில் எதையும் அவர்களால் அறியமுடியாது. அவனது குர்ஸி வானங்களையும் பூமியையும் வியாபித்திருக்கின்றது. அவையிரண்டையும் பாதுகாப்பது அவனுக்கு சிரமமன்று. அவன் மிக உயர்ந்தவன்; மிக்க மகத்துவமானவன்) </p>',
            ],
            26 => [
                'question' => 'கேள்வி: ராதிபத்தான சுன்னத் தொழுகைகள் (ஐவேளை தொழுகைகளின் முன் பின் ஸுன்னத்துக்கள்) எவை? அவற்றின் சிறப்பு என்ன?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4730.mp3',
                'answer' => '<p> பதில் - ஸுப்ஹுக்கு முன்னர் <span class="c2">(2)</span> இரண்டு ரக்அத்துக்கள்<br /> ழுஹருக்கு முன்னர் <span class="c2">(4)</span> நான்கு ரக்அத்துக்கள்.<br /> ழுஹருக்குப் பின்னர் <span class="c2">(2)</span> நான்கு ரக்அத்துக்கள்.<br /> மஃரிபுக்குப் பின் <span class="c2">(2)</span> இரண்டு ரக்அத்துக்கள்<br /> இஷாவுக்குப் பின் <span class="c2">(2)</span> இரண்டு ரக்அத்துக்கள்<br /> இதன் சிறப்பு : நபி <span class="c2">(ஸல்)</span> அவர்கள் கூறினார்கள் : யார் தினமும் பர்ழ் அல்லாத சுன்னத்தான தொழுகைகள் <span class="c2">(12)</span> பன்னிரண்டு ரக்அத்துக்கள் தொழுதுவந்தால் அவனுக்கு சுவனத்தில் ஒரு வீட்டை அல்லாஹ் அமைப்பான்\'. இந்த ஹதீஸ் முஸ்லிம், அஹ்மத் மற்றும் ஏனைய ஹதீஸ் நூல்களில் பதிவு செய்யப்பட்டுள்ளது. </p>',
            ],
            27 => [
                'question' => 'கேள்வி 28 : கிழமை நாட்களில் மிகவும் சிறந்த நாள் எது?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4800.mp3',
                'answer' => '<p> பதில் - ஜும்ஆத் தினமாகும் <span class="c2">( வெள்ளிக்கிழமையாகும்)</span><br /> நபி <span class="c2">(ஸல்)</span> கூறினார்கள் : உங்களது நாட்களில் மிகச் சிறந்த நாள் வெள்ளிக்கிழமையாகும். அந்நாளில் தான் ஆதம் நபி படைக்கப்பட்டார்கள். அந்நாளில் அவர்களது உயிர் கைப்பற்றப்பட்டது. அந்நாளில் ஸூர் ஊதப்படும். அந்நாளில் மக்கள் அதிர்ச்சிக்குள்ளவாகுவர்,.எனவே அந்நாளில் என் மீது அதிகமாக ஸலவாத் சொல்லுங்கள். ஏனெனில் உங்களது ஸலவாத்கள் எனக்கு காண்பிக்கப்படுகிறது\'. அல்லாஹ்வின் தூதரே! நீங்கள் மரணித்து உங்களின் எலும்பெல்லாம் மண்ணில் உக்கிப்போன நிலையில் எங்களது ஸலவாத் உங்களுக்கு எப்படி காண்பிக்கப்படுகிறது?! என்று நபித்தோழர்கள் கேட்ட போது, நிச்சயமாக அல்லாஹ் நபிமார்களின் உடல்களை பூமி அரிப்பதை விட்டும் தடுத்து விட்டான் என்று பதிலளித்தார்கள்\'. இந்த ஹதீஸ் அபூதாவூத் மற்றும் ஏனைய ஹதீஸ் நூல்களில் பதிவு செய்யப்பட்டுள்ளது. </p>',
            ],
            28 => [
                'question' => 'கேள்வி 29 : ஜும்ஆ தொழுகையின் சட்ட நிலை யாது?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4840.mp3',
                'answer' => '<p> பதில் - பருவ வயதை அடைந்த புத்திசாலியான ஊரில் உள்ள அனைத்து முஸ்லிம் ஆண்களுக்கும் கட்டாயக் கடமையாகும் <span class="c2">(பர்ளு அய்ன்)</span><br /> அல்லாஹ் கூறுகிறான் : "ஈமான் கொண்டவர்களே! ஜுமுஆ உடைய நாளில் தொழுகைக்காக நீங்கள் அழைக்கப்பட்டால், கொடுக்கல் வாங்கலை விட்டுவிட்டு, அல்லாஹ்வை நினைவுகூர்வதன் பால் விரைந்து செல்லுங்கள்- நீங்கள் அறிந்தவர்களாக இருந்தால் இதுவே உங்களுக்கு மிகவும் சிறந்ததாகும்". <span class="c2">(ஸுறதுல் ஜுமுஆ : 9)</span>. </p>',
            ],
            29 => [
                'question' => 'கேள்வி 30 :ஜுமுஆ தொழுகையின் ரக்அத்துக்கள் எத்தனை?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4880.mp3',
                'answer' => '<p> பதில் - ஜுமுஆத் தொழுகை இரண்டு ரக்அத்துக்களைக் கொண்டதாகும். அதில் இமாம் சப்தமிட்டு ஓதுவார். தொழுவதற்கு முன் இரண்டு குத்பாக்கள்- உரைகள்- உண்டு. </p>',
            ],
            30 => [
                'question' => 'கேள்வி 31: ஜுமுஆத் தொழுகைக்கு சமூகம் தராது இருப்பது கூடுமா?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4910.mp3',
                'answer' => '<p> பதில் - ஷரீஆ ரீதியான நியாயமான காரணங்களுக்காகவேயன்றி எவ்விதத்திலும் ஜுமுஆத் தொழுகைக்கு சமூகம் தராது இருப்பது கூடாது. இது பற்றி நபி <span class="c2">(ஸல்)</span> பின்வருமாறு எச்சரிக்கை செய்துள்ளார்கள் : "யார் ஒருவர் அலட்சியமாக மூன்று ஜுமுஆக்களை விட்டு விடுகிறாறோ அல்லாஹ் அவரின் உள்ளத்திற்கு திரையிட்டு விடுவான்". இந்த ஹதீஸ் அபூதாவூத் மற்றும் ஏனைய ஹதீஸ் நூல்களில் பதிவு செய்யப்பட்டுள்ளது. </p>',
            ],
            31 => [
                'question' => 'கேள்வி 32 : ஜும்ஆத் தினத்தில் செய்யக் கூடிய சில சுன்னத்தான விடயங்களைக் குறிப்பிடுக.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4940.mp3',
                'answer' => '<p> பதில் :<br /> 1- குளித்தல்.<br /> 2- வாசனை பூசுதல்.<br /> 3- இருப்பதில் மிக நல்ல ஆடைகளை அணிதல்.<br /> 4- பள்ளிக்கு ஆரம்ப நேரத்தில் செல்லுதல்.<br /> 5- நபி <span class="c2">(ஸல்)</span> அவர்களின் மீது அதிகமாக ஸலவாத் சொல்லுதல்.<br /> 6- ஸுறதுல் கஹ்பை ஓதுதல்.<br /> 7- பள்ளிக்கு நடந்து செல்லுதல்.<br /> 8- துஆ ஏற்றுக்கொள்ளப்படும் நேரத்தை தேடுவதில் ஈடுபாடு காட்டல். </p>',
            ],
            32 => [
                'question' => 'கேள்வி 33 : ஜமாஅத் தொழுகையின் (கூட்டுத் தொழுகையின்) சிறப்பைக் குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5050.mp3',
                'answer' => '<p> பதில் : அல்லாஹ்வின் தூதர் <span class="c2">(ஸல்)</span> அவர்கள் கூறியதாக அப்துல்லாஹ் இப்னு உமர் ரழியல்லாஹு அன்ஹுமா அறிவிக்கிறார்கள் : "ஜமாஅத்தாக -கூட்டாகத்- தொழுவது தனித்துத் தொழுவதை விட <span class="c2">(27)</span> இருபத்தேழு மடங்கு மேலானதாகும்".<span class="c6"> ஆதாரம் :</span> முஸ்லிம். </p>',
            ],
            33 => [
                'question' => 'கேள்வி :34 : உள்ளச்சமாக தொழுவது என்றால் என்ன?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5080.mp3',
                'answer' => '<p> பதில்: தொழுகையில் உள்ளத்தின் ஈடுபாட்டையும் உடலுறுப்புக்கள் அதில் அடக்கமாக இருப்பதையும் குறிக்கும்.<span class="c6"><br /> அல்லாஹ் கூறுகின்றான் :</span> "நிச்சயமாக நம்பிக்கையாளர்கள் <span class="c2">(முஃமின்கள்)</span> வெற்றி பெற்றுவிட்டார்கள். அவர்கள் தொழுகையில் உள்ளச்சம் உடையவர்களாக இருப்பார்கள்". <span class="c2">(ஸூறதுல் முஃமினூன் :1,2)</span>. </p>',
            ],
            34 => [
                'question' => 'கேள்வி 35 : ஸகாத் என்பதை வரைவிலக்கணப்படுத்துக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5120.mp3',
                'answer' => '<p> பதில் : ஸகாத் என்பது குறிப்பிட்ட செல்வத்தில் குறிப்பிட்ட பிரிவினருக்கு குறிப்பிட்ட நேரத்தில்-காலத்தில்- நிறைவேற்றும் ஒரு கட்டாயக் கடமையாகும்.<br /> இது இஸ்லாத்தின் அடிப்படைக் கடமைகளில் ஒன்றாகும் வசதியுள்ளோரிடமிருந்து பெற்று ஏழைகளுக்கு வழங்கப்படும் கட்டாய தர்மமாகும்.<span class="c6"><br /> அல்லாஹ் கூறுகின்றான் :</span> "ஸகாத்தை நிறைவேற்றுங்கள்". <span class="c2">(ஸூறதுல் பகரா :43)</span>. </p>',
            ],
            35 => [
                'question' => 'கேள்வி :36 : விரும்பத்தக்க தர்மம் என்றால் என்ன?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5170.mp3',
                'answer' => '<p> பதில் : ஸகாத் தவிர்ந்த ஏனைய தர்மங்கள்.<span class="c6"> அதாவது நல்ல காரியங்களுக்காக எந்த வேளையிலும் ஏதாவது ஒன்றை தர்மமாகக் கொடுத்தல்<br /> அல்லாஹ் கூறுகின்றான் :</span> "அல்லாஹ்வின் பாதையில் செலவு செய்யயுங்கள்". <span class="c2">(ஸூறதுல் பகரா :195)</span>. </p>',
            ],
            36 => [
                'question' => 'கேள்வி 37 : நோன்பை வரைவிலக்கப்ப்டுத்துக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5210.mp3',
                'answer' => '<p> பதில் : நோன்பு நோற்றல் என்ற நிய்யத்துடன் பஜ்ர் உதயம் முதல் சூரியன் மறையும் வரையில் நோன்பை முறிக்கும் காரியங்களை விட்டும் தவிர்ந்து அல்லாஹ்வுக்கு கட்டுப்பட்டு நடப்பதாகும்.<span class="c6"><br /> அது இரு வகைப்படும் :</span><br /> முதலாவது வகை : கடமையான நோன்பு : ரமழான் மாத நோன்பு இதற்கான உதாரணமாகும். இது இஸ்லாத்தின் அடிப்படைக் கடமைகளில் ஒன்றாகும்.<span class="c6"><br /> அல்லாஹ் கூறுகிறான் :</span> "ஈமான் கொண்டோரே! நீங்கள் இறையச்சமுடையவர்களாக இருக்க உங்களுக்கு முன்னிருந்தவர்களுக்குக் கடமையாக்கப்பட்டதைப் போன்று உங்களுக்கும் நோன்பு கடமையாக்கப்பட்டுள்ளது". <span class="c2">(ஸூறதுல் பகரா :183)</span><br /> இரண்டாவது வகை : ஸுன்னத்தான நோன்பு : வாரத்தில் திங்கள் மற்றும் வியாழன் நோன்பு நோற்றல், அடுத்ததாக மாதாந்தம் மூன்று தினங்கள் நோன்பு நோற்பதாகும். அதில் மிகச்சிறப்புக்குரியது ஒவ்வொரு அரபு மாதத்திலும்; அய்யாமுல் பீழ் நாட்களான <span class="c2">(13,14,15)</span> ஆகிய தினங்களில் நோன்பு நோற்றல் போன்றவை இதற்கான உதாரணங்களாகும். </p>',
            ],
            37 => [
                'question' => 'கேள்வி 38 : ரமழான் மாத நோன்பின் சிறப்பைக் குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5270.mp3',
                'answer' => '<p> பதில் : நபி <span class="c2">(ஸல்)</span> அவர்கள் கூறியதாக அபூஹுரைரா ரழியல்லாஹு அன்ஹு அவர்கள் அறிவிக்கிறார்கள் : "இறை நம்பிக்கையுடனும், நன்மையை எதிர்பார்த்தும் ரமழானில் யார் நோன்பு நோற்கிறாரோ அவரின் முன்சென்ற பாவங்கள் மன்னிக்கப்படும்". <span class="c2">(புஹாரி முஸ்லிம்)</span> </p>',
            ],
            38 => [
                'question' => 'கேள்வி 39 : ரமழான் அல்லாத காலங்களில் நோற்கும் சுன்னத்தான நோன்பின் சிறப்பைக் குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5300.mp3',
                'answer' => '<p> பதில் : நபி <span class="c2">(ஸல்)</span> அவர்கள் கூறியதாக அபூ ஸஈத் அல் குத்ரி ரழியல்லாஹு அன்ஹு அவர்கள் அறிவிக்கிறார்கள் : "எந்த ஒரு அடியான் அல்லாஹ்வின் பாதையில் ஒரு நாள் நோன்பு நோற்கிறானோ அவனது முகத்தை நரகிலிருந்து எழுவது வருடங்கள் அல்லாஹ் தூரப்படுத்துகிறான்". <span class="c2">(புஹாரி முஸ்லிம்)</span><br /> ஹதீஸில் இடம்பெற்ற <span class="c2">((ஸப்ஈன கரீபன்)</span>) என்பதன் கருத்து எழுவது வருடங்கள் என்பதாகும். </p>',
            ],
            39 => [
                'question' => 'கேள்வி 40 : நோன்பை முறிக்கும் காரியங்கள் சிலதை குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5330.mp3',
                'answer' => '<p> பதில் : 1- வேண்டுமென்றே உண்ணுதல் பருகுதல்.<br /> 2- வேண்டுமென்றே வாந்தியெடுத்தல்.<br /> 3- இஸ்லாத்தை துறந்து செல்லல். </p>',
            ],
            40 => [
                'question' => 'கேள்வி 41 : நோன்பின் ஸுன்னத்துக்கள் எவை?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5380.mp3',
                'answer' => '<p> பதில் : 1- நோன்பு துறப்பதை அவசரப்படுத்துதல்.<br /> 2- ஸஹர் செய்தல், அதனைப் பிற்படுத்துதல்.<br /> 3- நல்ல காரியங்கள் மற்றும் வணக்கங்களை அதிகரித்துக் கொள்ளல்.<br /> 4- ஒருவர்; ஏசினால் அவரைப் பார்த்து நான் ஒரு நோன்பாளி என்று கூறுதல்.<br /> 5- நோன்பு துறக்கும் நேரத்தில் துஆ ஓதுதல்.<br /> 6- கணிந்த பேரீத்தம் பழம் அல்லது காய்ந்த பேரீத்தம் பழத்தினால் நோன்பு துறத்தல். அது கிடைக்காது விட்டால் தண்ணீரால் நோன்பு துறத்தல். </p>',
            ],
            41 => [
                'question' => 'கேள்வி 42 : ஹஜ் என்பதை வரைவிலக்கணப்படுத்துக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5460.mp3',
                'answer' => '<p> பதில் : ஹஜ் என்பது புனித ஆலயமான கஃபாவுக்கு குறிப்பிட்ட காலத்தில் சென்று குறிப்பிட்ட சில <span class="c2">(செயற்பாடுகளை)</span> கிரியைகளை செய்வதன் மூலம் அல்லாஹ்வுக்கு கட்டுப்பட்டு வணங்குவதைக் குறிக்கும்.<span class="c6"><br /> அல்லாஹ் கூறுகிறான் :</span> "மனிதர்களில் ஹஜ்ஜுக்கு சென்று வர சக்தி பெற்றுள்ளவர் மீது அல்லாஹ்வுக்காக அவ்வீட்டை ஹஜ் செய்வது கடமையாகும். எவர் நிராகரிக்கின்றாரோ நிச்சயமாக அல்லாஹ் அகிலத்தாரை விட்டும் தேவையற்றவன்". <span class="c2">(ஸூறா ஆல இம்ரான் 97)</span> </p>',
            ],
            42 => [
                'question' => 'கேள்வி 43: ஹஜ்ஜின் ருகுன்களை –கடமைகளை- குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5500.mp3',
                'answer' => '<p> பதில் - 1- இஹ்ராம் <span class="c2">(ஹஜ்ஜுக்காக நிய்யத் வைத்தல்)</span>.<br /> 2- அரபாவில் தரித்தல்.<br /> 3- தவாபுல் இபாழா செய்தல் <span class="c2">(ஹஜ்ஜின் கடமையான தவாப்)</span>.<br /> 4- ஸஈ செய்தல். அதாவது ஸபா மர்வா குன்றுகளுக்கிடையில் சற்று விரைவாக நடத்தல் </p>',
            ],
            43 => [
                'question' => 'கேள்வி 44 : ஹஜ்ஜின் சிறப்பு என்ன ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5560.mp3',
                'answer' => '<p> பதில் : நபி <span class="c2">(ஸல்)</span> அவர்கள் கூறியதை தான் செவிமடுத்ததாக<br /> அபூஹுரைரா ரழியல்லாஹு அன்ஹு அறிவிக்கிறார்கள் : "உடலுறவு கொள்ளாமல், தீயகாரியங்களில் ஈடுபடாமல் யாரேனும் ஹஜ் செய்தால் அன்று பிறந்த பாலகன் போன்று <span class="c2">(பாவமற்றவராக)</span> அவர் திரும்புவார்". இந்த ஹதீஸை புஹாரி மற்றும் ஏனையோர் பதிவு செய்துள்ளனர்.<br /> இந்த ஹதீஸில் இடம்பெற்ற "அன்று பிறந்த பாலகன்" என்ற வாசகத்தின் கருத்து எவ்விதப்பாவமுமின்றி –புனிதராக –என்பதாகும். </p>',
            ],
            44 => [
                'question' => 'கேள்வி 45 : உம்ரா என்பதை வரைவிலக்கணப்படுத்துக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5600.mp3',
                'answer' => '<p> பதில் : உம்ரா என்பது புனித ஆலயமான கஃபாவுக்கு எந்த நேரத்திலும் சென்று குறிப்பிட்ட சில <span class="c2">(செயற்பாடுகளை)</span> கிரியைகளை செய்வதன் மூலம் அல்லாஹ்வுக்கு கட்டுப்பட்டு வணங்குவதைக் குறிக்கும். </p>',
            ],
            45 => [
                'question' => 'கேள்வி 46 : உம்ராவின் ருகுன்களை -கடமைகளை- குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5630.mp3',
                'answer' => '<p> பதில் : 1- இஹ்ராம். அதாவது உம்ராக் கடமையை நிறைவேற்றுவதற்காக நிய்யத்து வைத்தல்.<br /> 2- கஃபாவை தவாப் செய்தல்.<br /> 3- ஸஈ செய்தல். அதாவது ஸபா மர்வா குன்றுகளுக்கிடையில் சற்று விரைவாக நடத்தல். </p>',
            ],
            46 => [
                'question' => 'கேள்வி 47: அல்லாஹ்வின் பாதையில் ஜிஹாத் செய்தல்; என்றால் என்ன?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5690.mp3',
                'answer' => '<p> பதில் : இஸ்லாத்தை பரப்புதல், இஸ்லாத்தையும்; முஸ்லிம்களையும் பாதுகாத்தல், அல்லது இஸ்லாம் மற்றும் முஸ்லிம்களின் எதிரிகளுடன் போராடுதல் போன்ற செயற்பாடுகளுக்காக மேற்கொள்ளப்படும் அதீத முயற்சிகள் மற்றும் உழைப்புகளில் ஈடுபவதைக் குறிக்கும்.<span class="c6"><br /> அல்லாஹ் கூறுகிறான் :</span> "உங்கள் செல்வங்களாலும், உங்கள் உயிர்களாலும் அல்லாஹ்வின் பாதையில் அறப்போர் புரியுங்கள். நீங்கள் அறிபவர்களாக இருந்தால் இதுவே உங்களுக்குச் சிறந்ததாகும்". <span class="c2">(ஸூறதுத் தவ்பா : 41)</span>. </p>',
            ],
        ],
        3 => [
            0 => [
                'question' => 'கேள்வி 1: எங்கள் நபி முஹம்மத் (ஸல்) அவர்களின் வம்சம்,பரம்பரை என்ன?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5740.mp3',
                'answer' => '<p> பதில் : எங்கள் நபி முஹம்மத் <span class="c2">(ஸல்)</span> அவர்கள் அப்துல்லாஹ்வின் மகனாவார்,அப்துல்லாஹ் அப்துல் முத்தலிபின் மகனவார், அப்துல் முத்தலிப் அவர்கள் ஹாஷிமின் மகனாவார். ஹாஷிம் அவர்கள் குறைஷிக் குலத்தைச் சேர்ந்தவர். குறைஷிகள் அரபிகளாவர். அரபிகள் இப்ராஹீம் நபியின் மகனான இஸ்மாயில் <span class="c2">(அலை)</span> அவர்களின் வழித்தோன்றலில் வந்தோராவர். அவர்களின் மீதும் எங்கள் நபி மீதும் ஸலாத்தும் ஸலாமும் உண்டாவதாக. </p>',
            ],
            1 => [
                'question' => 'கேள்வி 2- எங்கள் நபி (ஸல்) அவர்களின் தாயின் பெயர் என்ன?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5770.mp3',
                'answer' => '<p> பதில் : ஆமினா பின்த் வஹ்ப். </p>',
            ],
            2 => [
                'question' => 'கேள்வி 3: நபியவர்களின் தந்தை எப்போது மரணித்தார்கள்?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5800.mp3',
                'answer' => '<p> பதில் : நபியவர்கள் தாயின் கருவரையில் இருக்கும்போது மதீனாவில் அவர்களின் தந்தை மரணித்துவிட்டார். </p>',
            ],
            3 => [
                'question' => 'கேள்வி 4 : நபியவர்கள் எப்போது பிறந்தார்கள்?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5830.mp3',
                'answer' => '<p> பதில்- யானை வருடம் ரபீஉனில் அவ்வல் மாதம் திங்கட் கிழமை. </p>',
            ],
            4 => [
                'question' => 'கேள்வி 5 : நபியவர்கள் எந்த ஊரில் பிறந்தார்கள்?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5850.mp3',
                'answer' => '<p> பதில் : மக்காவில் பிறந்தார்கள். </p>',
            ],
            5 => [
                'question' => 'கேள்வி 6 : நபியவர்களுக்கு பாலூட்டி அரவனைத்த, செவிலித் தாய்மார்கள் யார்?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5880.mp3',
                'answer' => '<p> பதில் : - நபியவர்களின் தந்தையின் அடிமை பெண்ணான உம்மு அய்மன்.<br /> - நபியவர்களின் பெரிய தந்தையான அபூலஹபின் அடிமை ஸுவைபா.<br /> - ஹலிமதுத் ஸஃதியா. </p>',
            ],
            6 => [
                'question' => 'கேள்;வி 7 : நபியவர்களின் தாயார் எப்போது மரணித்தார்கள்?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5930.mp3',
                'answer' => '<p> பதில்- நபியவர்கள் ஆறு வயதாக இருக்கும் போது அவர்களின் தாயார் மரணமடைந்தார்கள். பின்னர் நபியவர்களை அவர்களின் பாட்டனாரான அப்துல் முத்தலிப் அவர்கள் பொறுப்பேற்றார்கள். </p>',
            ],
            7 => [
                'question' => 'கேள்வி 8 :அப்துல் முத்தலிப் அவர்களின் மரணத்திற்குப்பிறகு நபியவர்களை பொறுப்பேற்றவர் யார்?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5960.mp3',
                'answer' => '<p> பதில்: நபியவர்களின் எட்டாது வயதில்; பாட்டனார் அப்துல் முத்தலிப் மரணமடைந்ததைத் தொடர்;ந்து அன்னாரின் சிறிய தந்தை அபூதாலிப் அவர்களின் பராமரிப்பில் வளர்ந்தார்கள். </p>',
            ],
            8 => [
                'question' => 'கேள்வி 9: நபியவர்கள் தனது சிறிய தந்தையுடன் ஷாமுக்கு -சிரியாவுக்குப்- பயணம் சென்றது எப்போது?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5990.mp3',
                'answer' => '<p> பதில் - நபிவர்களின் <span class="c2">(12)</span> பன்னிரண்டாவது வயதில் தனது சிறிய தந்தையுடன் ஷாமுக்குச் சென்றார்கள். </p>',
            ],
            9 => [
                'question' => 'கேள்வி 10 : நபியவர்களின் இரண்டாவது பயணம் எப்போது?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6020.mp3',
                'answer' => '<p> பதில் - கதீஜா <span class="c2">(ரழி)</span> அவர்களின் வியாபாரப்பொருட்களை விற்பனை செய்யவே இரண்டாவது தடவையாக சிரியாவுக்குச் சென்றார்கள். நபியவர்கள் அப்பயணத்திலிருந்து திரும்பி வந்ததும் அன்னை கதீஜா <span class="c2">(ரழி)</span> அவர்களை திருமனம் செய்துகொண்டார்கள். அப்போது அவர்களின் வயது இருபத்தைந்தாகும். </p>',
            ],
            10 => [
                'question' => 'கேள்வி 11 : குறைஷிகள் கஃபாவை புணர்நிர்மானம் செய்தார்கள்?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6050.mp3',
                'answer' => '<p> பதில் - நபியவர்களின் <span class="c2">(35)</span> முப்பத்தைந்தாவது வயதில் குறைஷிகள் கஃபாவை புணர்நிர்மானம் செய்தார்கள்.<br /> இக்கட்டுமானப் பணியின் போது ஹஜருல் அஸ்வத் கல்லை உரிய இடத்தில் யார் வைப்பது என்ற சர்ச்சை ஏற்பட்டபோது குறைஷிகள் நபியவர்களை மத்தியஸ்தராக நியமித்தனர். நபியவர்கள் அக்கல்லை ஒரு பிடவையில் வைத்து அப்பிடவையின் ஒரப் பகுதியை ஒவ்வொரு கோத்திரத் தலைவர்களும் பிடிக்குமாறு கட்டளையிட்டார்கள். அவர்கள் நான்கு கோத்திரத்தினராக இருந்தனர். அவர்கள் அனைவரும் ஹஜருல் அஸ்வத் கல் வைக்கப்படும் இடத்திற்கு உயர்த்தியபோது நபியவர்கள் தனது கையால் அதனை எடுத்து வைத்தார்கள். </p>',
            ],
            11 => [
                'question' => 'கேள்வி :12 : நபியவர்கள் எத்தனையாம் வயதில் தூதராக அனுப்பப்பட்டார்கள்? அவர்கள் யாருக்கு தூதராக அனுப்பப்பட்டார்கள்?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6080.mp3',
                'answer' => '<p> பதில் : நபியவர்கள் இறைதூதராக அனுப்பப்பட்டபோது அவர்களுக்கு வயது நாற்பதாகும், அவர்கள் ஒட்டுமொத்த மனிதர்களுக்கும் நன்மாராயம் கூறக்கூடியவர்களாகவும் அச்சமூட்டி எச்சரிக்கை செய்யக்கூடியவர்களாகவும் அனுப்பப்பட்டார்கள். </p>',
            ],
            12 => [
                'question' => 'கேள்வி 13 : நபியவர்களுக்கு எதன் மூலம் ஆரம்பத்தில் இறைச்செய்தி (வஹி) கிடைத்தது ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6110.mp3',
                'answer' => '<p> பதில்- தூக்கத்தில் தோன்றும் நல்ல கனவின் மூலம் கிடைத்தது. அப்போது அவர்கள் எந்தக் கனவு கண்டாலும் அது காலைப் பொழுதின் விடியலைப் போன்று தெளிவாக இருக்கும். </p>',
            ],
            13 => [
                'question' => 'கேள்வி 14: இறைச்செய்தி கிடைப்பதற்கு முன் நபியவர்களின் நிலை எவ்வாறு இருந்தது? முதலாவது தடவை அவர்களுக்கு இறைச்செய்தி –வஹி- எப்போது இறங்கியது?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6140.mp3',
                'answer' => '<p> பதில் : நபியவர்கள் ஹிராக் குகையில் வணக்கவழிபாடுகளில் ஈடுபடக் கூடியவர்களாக இருந்தார்கள். அதற்குத் தேவையான கட்டுச்சாதனங்களை தங்களுடன் எடுத்துச் செல்வார்கள்.<br /> நபியவர்கள் ஹிராக் குகையில் வணக்கவழிபாடுகளில் ஈடுபட்டுக்கொண்டிருக்கும் வேளையில் அவர்களுக்கு வஹி -இறைச்செய்தி- இறங்கியது. </p>',
            ],
            14 => [
                'question' => 'கேள்வி 15 : நபியவர்களுக்கு முதலில் இறங்கிய அல்குர்ஆன் வசனங்கள் எவை?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6180.mp3',
                'answer' => '<p> பதில் :ஸூறதுல் அலகின் முதல் ஐந்து வசனங்களே நபியவர்களுக்கு முதலாவது இறங்கிய இறைவசனங்களாகும்: "இக்ரஃபிஸ்மி ரப்பிகல்லதீ கலக்".<span class="c2">((யாவற்றையும்)</span> படைத்த உம்முடைய இறைவனின் திருநாமத்தைக் கொண்டு ஓதுவீராக). "கலகல் இன்ஸான மின் அலக்" <span class="c2">(அவன் மனிதனை கருவறை சுவரில் ஒட்டிக்கொள்ளக்கூடியதிலிருந்து படைத்தான்)</span>. "இக்ரஃ வரப்புகல் அக்ரம்" <span class="c2">(நீர் ஓதுவீராக ! உமது இரட்சகன் மிகவும் கண்ணியமானவன்)</span>. "அல்லதீ அல்லம பில் கலம்" <span class="c2">(அவன் எழுது கோள் கொண்டு கற்றுக் கொடுத்தான்)</span>. "அல்லமல் இன்ஸான மாலம் யஃலம்" <span class="c2">(மனிதனுக்கு அவன் அறியாதவற்றையெல்லாம் கற்றுக் கொடுத்தான்)</span>. <span class="c2">(ஸூறத்துல் அலக் 1-5)</span>. </p>',
            ],
            15 => [
                'question' => 'கேள்வி 16 : இறைத்தூதை -இஸ்லாத்தை- முதன் முதலில் ஏற்றுக் கொண்டோர் யார்?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6200.mp3',
                'answer' => '<p> பதில் : ஆண்களில் : அபூபக்கர் அஸ்ஸித்தீக் <span class="c2">(ரழி)</span>,<span class="c6"> பெண்களில் :</span> கதீஜா பின்த் குவைலித் <span class="c2">(ரழி)</span>,<span class="c6"> சிறுவர்களில்:</span> அலி இப்னு அபீ தாலிப் <span class="c2">(ரழி)</span>, உரிமையிடப்பட்ட அடிமைகளில் ஸைத் இப்னு ஹாரிஸா <span class="c2">(ரழி)</span>,<span class="c6"> அடிமைகளில் :</span> பிலால் அல் ஹபஷி ரழியல்லாஹு அன்ஹும் போன்றோர் முதன் முதலில் இஸ்லாத்தைத் தழுவிக் கொண்டோராவர். </p>',
            ],
            16 => [
                'question' => 'கேள்வி 17: இஸ்லாத்திற்கான பிரச்சாரம் ஆரம்பத்தில் எவ்வாறு காணப்பட்டது?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6230.mp3',
                'answer' => '<p> பதில் : மூன்று வருடங்கள் பிரச்சார நடவடிக்கை இரகசியமாக இருந்தது. பின்னர் பகிரங்கப் பிரச்சாரத்தில் ஈடுபடுபடுமாறு நபியவர்களுக்கு இறை கட்டளை பிரப்பிக்கப்பட்டது. </p>',
            ],
            17 => [
                'question' => 'கேள்வி : பகிரங்க பிரச்சாரத்தின் பின் நபியவர்களின் நிலையும் அவர்களை ஏற்றுக்கொண்டோரின் நிலையும் எவ்வாறு இருந்தது?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6260.mp3',
                'answer' => '<p> பதில் : இணைவைப்பாளர்கள் நபியவர்களையும்; முஸ்லிம்களையும்; மிகவும் துன்புறுத்தினர். அதனால் நபியவர்கள் அபீஸீனியா மன்னனான நஜாஷியிடம் ஹிஜ்ரத் செல்ல முஸ்லிம்களுக்கு அனுமதி வழங்கினார்கள்.<br /> இணைவைப்பாளர்களான முஷ்ரிகுகள் நபியவர்களை துன்புறுத்தி கொலை செய்வதற்கு ஒன்றுபட்ட வேளை அல்லாஹ் அவர்களை பாதுகாத்தான். தம்மை அவர்களிடமிருந்து பாதுகாத்துக் கொள்வதற்கு நபியவர்கள் தனது சிறிய தந்தையை அனுகினார்கள். </p>',
            ],
            18 => [
                'question' => 'கேள்வி 19 :நபித்துவத்தின் பத்தாம் வருடத்தில் மரணித்தோர் யாவர்?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6300.mp3',
                'answer' => '<p> பதில் : இவ்வருடத்தில் அவர்களின் சிறிய தந்தை அபூதாலிபும் அவர்களின் மனைவி கதீஜா <span class="c2">(ரழி)</span> அவர்களும் மரணித்தார்கள். </p>',
            ],
            19 => [
                'question' => 'கேள்வி 20 : இஸ்ராஃ மிஃராஜ் விண்னுலகப் பயணம் எப்போது நிகழ்ந்தது?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6330.mp3',
                'answer' => '<p> பதில்- நபியவர்களின் ஐம்பதாவது வயதில் இடம் பெற்றது. அந்நிகழ்வின் போது ஐவேளைத் தொழுகை அவர்களின் மீது கடமையாக்கப்பட்டது.<br /> அல் இஸ்ராஉ என்பது மக்காவில் உள்ள அல் மஸ்ஜிதுல் ஹராமிலிருந்து பலஸ்தீனில் அமைந்துள்ள அல் மஸ்ஜிதுல் அக்ஸாவிற்கு சென்றதைக் குறிக்கும்.<br /> அல் மிஃராஜ் என்பது அல்மஸ்ஜிதுல் அக்ஸாவிலிருந்து வானுலகத்திற்கும் அங்கு ஸித்ரதுல் முன்தஹா என்ற இடம் வரையிலும் சென்றதைக் குறிக்கும். </p>',
            ],
            20 => [
                'question' => 'கேள்வி 21 : மக்காவிற்கு வெளியே உள்ளவர்ளை நபியவர்கள் எப்படி இஸ்லாத்தின் பால் அழைப்பு விடுத்தார்கள்?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6380.mp3',
                'answer' => '<p> பதில் :நபியர்வர்கள் தாஇப் மக்களை இஸ்லாத்தை நோக்கி அழைத்தார்கள். பருவகாலங்களிலும் மக்கள் ஒன்று கூடுமிடங்களிலும் தன்னை முன்னிருத்திப் பிரச்சாரம் செய்தார்கள். இவ்வேளை மதீனாவைச் சேர்ந்த அன்ஸாரிகளில் சிலர் அவர்களை ஏற்றுக்கொண்டு <span class="c2">(ஈமான் கொண்டு)</span> அவர்களுக்கு உதவி செய்வதாக சத்தியப்பிரமானம் செய்தார்கள். </p>',
            ],
            21 => [
                'question' => 'கேள்வி 22: மக்காவில் நபியவர்கள் எத்தனை வருடங்கள் தங்கியிருந்து பிரச்சாரம் செய்தார்கள்?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6410.mp3',
                'answer' => '<p> பதில் : <span class="c2">(13)</span> பதின்மூன்று வருடங்கள் இருந்தார்கள். </p>',
            ],
            22 => [
                'question' => 'கேள்வி 23: நபியவர்கள் எங்கு ஹிஜ்ரத் சென்றார்கள்?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6440.mp3',
                'answer' => '<p> பதில் : மக்காவிலிருந்து மதீனாவிற்கு ஹிஜ்ரத் சென்றார்கள். </p>',
            ],
            23 => [
                'question' => 'கேள்வி 24 : மதீனாவில் நபியவர்கள் எத்தனை வருடங்கள் வாழ்ந்தார்கள்?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6470.mp3',
                'answer' => '<p> பதில் : பத்து வருடங்கள் </p>',
            ],
            24 => [
                'question' => 'கேள்வி 25 : மதீனாவில் விதியாக்கப்பட்ட மார்க்கக்கடமைகள் எவை?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6490.mp3',
                'answer' => '<p> பதில் : ஸகாத், நோன்பு, ஹஜ், ஜிஹாத், அதான் மற்றும் இஸ்லாத்தின் ஏனைய சட்டதிட்டங்கள் விதியாக்கப்பட்டன. </p>',
            ],
            25 => [
                'question' => 'கேள்வி 26 : நபியவர்கள் கலந்து கொண்ட மிகவும் முக்கியமான யுத்தங்கள் எவை?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6520.mp3',
                'answer' => '<p> பதில் - பெரிய பத்ர் யுத்தம்.<br /> உஹுத் யுத்தம்.<br /> அஹ்ஸாப் யுத்தம்.<br /> மக்காவை வெற்றிக்கொள்வதற்கான போர். </p>',
            ],
            26 => [
                'question' => 'கேள்வி 27 : அல் குர்ஆனில் இறுதியாக இறங்கிய வசனம் எது?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6580.mp3',
                'answer' => '<p> பதில் : பின்வரும் வசனம் : "நீங்களனைவரும் அல்லாஹ்விடம் மீட்டப்படும் அந்த நாளை அஞ்சிக் கொள்ளுங்கள். பின்னர் ஒவ்வோர் ஆத்மாவுக்கும் அது சம்பாதித்ததற்குரிய <span class="c2">(கூலி)</span> பூரணமாகக் கொடுக்கப்படும்; <span class="c2">(கூலி)</span> வழங்கப்படுவதில் அவை அநியாயம் செய்யப்படமாட்டாது". <span class="c2">(ஸூறதுல் பகரா :281)</span> </p>',
            ],
            27 => [
                'question' => 'கேள்வி 28 : நபி (ஸல்) அவர்கள் எப்போது மரணித்தார்கள்? அப்போது அவர்களுக்கு வயது எத்தனை?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6610.mp3',
                'answer' => '<p> நபி <span class="c2">(ஸல்)</span> அவர்கள் ஹிஜ்ரி <span class="c2">(11)</span> பதினொராவது வருடம் ரபீஉனில் அவ்வல் மாதம் மரணித்தார்கள். அப்போது அவர்களின் வயது <span class="c2">(63)</span> அறுபத்து மூன்றாகும். </p>',
            ],
            28 => [
                'question' => 'கேள்வி 29 : நபி (ஸல்) அவர்களின் மனைவியரின் பெயர்களைக் குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6640.mp3',
                'answer' => '<p> பதில் : 1- கதீஜா பின்த் குவைலிது <span class="c2">(ரழியல்லாஹு அன்ஹா)</span>.<br /> 2- சவ்தா பின்த் ஸம்ஆ <span class="c2">(ரழியல்லாஹு அன்ஹா)</span>.<br /> 3-ஆயிஷா பின்த் அபீபக்ர் அஸ்ஸித்தீக் <span class="c2">(ரழியல்லாஹு அன்ஹா)</span>.<br /> 4- ஹஃப்ஸா பின்த் உமர் <span class="c2">(ரழியல்லாஹு அன்ஹா)</span>.<br /> 5- ஸைனப் பின்த் குஸைமா <span class="c2">(ரழியல்லாஹு அன்ஹா)</span>.<br /> 6- உம்மு ஸலமா ஹின்த் பின்த் அபீ உமைய்யா <span class="c2">(ரழியல்லாஹு அன்ஹா)</span>.<br /> 7- உம்மு ஹபீபா ரம்லா பின்த் அபீஸுப்யான் <span class="c2">(ரழியல்லாஹு அன்ஹா)</span>.<br /> 8- ஜுவைரியா பின்த் அல்ஹாரிஸ் <span class="c2">(ரழியல்லாஹு அன்ஹா)</span>.<br /> 9- மய்மூனா பின்த் அல்ஹாரிஸ் <span class="c2">(ரழியல்லாஹு அன்ஹா)</span>.<br /> 10- ஸஃபிய்யா பின்த் ஹுயைய் <span class="c2">(ரழியல்லாஹு அன்ஹா)</span>.<br /> 11- ஸைனப் பின்த் ஜஹ்ஷ் <span class="c2">(ரழியல்லாஹு அன்ஹா)</span>. </p>',
            ],
            29 => [
                'question' => 'கேள்வி 30 : நபி (ஸல்) அவர்களின் பிள்ளைகள் யார்?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6760.mp3',
                'answer' => '<p> பதில் : ஆண் குழந்தைகள் மூவர் ஆவர்.<span class="c6"> அவர்களின் பெயர்கள் பின்வருமாறு :</span><br /> அல் காஸிம், நபியவர்கள் இவரின் பெயரைக் கொண்டே புனைப்பெயர் சூட்டி அழைக்கப்பட்டார்கள் .<span class="c2">(அபுல் காஸிம்)</span>.<br /> அப்துல்லாஹ்.<br /> இப்ராஹீம்.<span class="c6"><br /> பெண்பிள்ளைகளில் :</span><br /> பாத்திமா.<br /> ருகைய்யா.<br /> உம்மு குல்ஸூம்.<br /> ஸைனப் ஆகியோர்களாவர்.<br /> இப்ராஹீமைத் தவிர மற்ற அனைத்துப் பிள்ளைகளும் கதீஜா <span class="c2">(ரழி)</span> அவர்களின் மூலம் கிடைத்த பிள்ளைகளாகும். பாத்திமா <span class="c2">(ரழி)</span> அவர்களைத் தவிர ஏனைய அனைத்துப் பிள்ளைகளும் நபியவர்களுக்கு முன்னரே மரணித்துவிட்டார்கள். அவர்கள் நபியவர்கள் மரணித்து 6 ஆறு மாதங்களின் பின் மரணித்தார்கள். </p>',
            ],
            30 => [
                'question' => 'கேள்வி 31: நபி (ஸல்) அவர்களின் இயற்கைத் தோற்றம் குறித்த சில பண்புகளைக் குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6880.mp3',
                'answer' => '<p> பதில் : நபி <span class="c2">(ஸல்)</span> அவர்கள் அதிகம் குட்டயராகவோ அதிகம் உயரம் கொண்டவராகவோ இருக்கவில்லை, மாறாக நடுத்தர உயரமுடயவராகவும், சிவப்பு நிற சாயல் கொண்ட வெள்ளை நிற மேனியை உடைவராகவும் இருந்தார். அத்துடன் அடர்ந்த தாடியும், அகலமான இருகண்களும், பெரிய வாயையும் உடயவராகவும் காணப்பட்டாரகள். அவர்களின் முடி மிகவும் கருமையானதாக இருந்தது, அத்துடன் அழகான அகன்ற இரு புயங்களையும் நறுமனம் கொண்டவராகவும் காணப்பட்டார். இவை அல்லாத அவர்களின் அழகான தோற்றம் குறித்த பல விடயங்கள் உள்ளன. </p>',
            ],
            31 => [
                'question' => '31- கேள்வி : நபி (ஸல்) தனது சமூகத்தை எதில் விட்டுவிட்டுச் சென்றார்கள்?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6910.mp3',
                'answer' => '<p> பதில் : நபி <span class="c2">(ஸல்)</span> தனது சமூகத்தை மிகவும் தெளிவான ஒரு பாதையில் விட்டுவிட்டுச் சென்றார்கள். அதன் இரவோ பகல் போன்று பிரகாசமாக உள்ளது. அதனை மனமுரண்டாக புறக்கணித்து நடந்தவன் தவிர வேறு எவரும் நெறிதவரி வழிதவறமாட்டான். எந்த ஒரு நன்மையான நல்ல காரியமாக இருந்தாலும் அதனை காட்டித்தராமலோ, எந்த ஒரு தீமையான காரியமாக இருந்தாலும் அது குறித்து எச்சரிக்கை செய்யாமலோ இந்த சமூகத்தை அவர்கள் விட்டுச்செல்லவில்லை. </p>',
            ],
        ],
        4 => [
            0 => [
                'question' => 'கேள்வி 1 : ஸூறதுல் பாத்திஹாவை ஓதி அதற்கான விளக்கத்தைக் குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6960.mp3',
                'answer' => '<p> பதில் : ஸூறதுல் பாத்திஹாவும் அதன் விளக்கவுரையும் :<br /> பிஸ்மில்லாஹிர் ரஹ்மானிர் ரஹீம். அல்ஹம்து லில்லாஹி ரப்பில் ஆலமீன். அர்ரஹ்மானிர் ரஹீம். மாலிகி யவ்மித்தீன். இய்யாக நஃபுது வஇய்யாக நஸ்தஈன். இஹ்தினஸ் ஸிராதல் முஸ்தகீம். <span class="c2">(நீ எங்களை நேரான வழியில் நடத்துவாயாக!)</span>. ஸிராதல்லதீன அன்அம்த அலைஹிம் கைரில் மஃழூபி அலைஹிம் வலழ் ழால்லீன். <span class="c2">((அவ்வழி)</span> எவர்களுக்கு நீ அருள் புரிந்தாயோ அவர்கள் <span class="c2">(சென்ற)</span> வழி. <span class="c2">(உன்)</span> கோபத்திற்குள்ளானவர்களோ வழிதவறியவர்களோ சென்ற வழியல்ல). <span class="c2">(பாதிஹா : 1 - 7)</span>.<br /> விளக்கவுரை <span class="c2">(தப்ஸீர்)</span> :<br /> ஸூறதுல் பாதிஹா மூலம் அல்குர்ஆன் ஆரம்பிக்கப்பட்டதால் அல் பாத்திஹா-திறவுகோள்- என்றபெயரால் இவ்வத்தியாயம் அழைக்கப்படுகிறது.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001001.mp3"></audio> 1- <span class="c2">(அளவற்ற அருளாளனும் நிகரற்ற அன்புடையோனுமாகிய அல்லாஹ்வின் திருநாமத்தால்)</span> என்பதன் கருத்து, அல்லாஹ்வின் பெயரை கூறுவதன் மூலம் பரக்கத்தை வேண்டியவனாகவும் அவனைக்கொண்டு உதவிதேடியவனாகவும் அல்குர்ஆனை ஓத ஆரம்பிக்கிறேன்.<br /> <span class="c2">(அல்லாஹ்)</span> என்பது உண்மையாக வணங்கப்படக் கூடியவன் என்பது பொருளாகும். இப்பெயர் அல்லாஹ்வுக்கு மாத்திரம் உரியது. அவனைத் தவிர வேறு எவறும் இப்பெயர் மூலம் அழைக்கப்படமாட்டார்கள்.<br /> <span class="c2">(அர்ரஹ்மான்)</span>- <span class="c2">(அளவற்ற அருளாளன்)</span> என்பது விசாலமான பரந்த அருளுக்குச்சொந்தக்காரன். அவனின் அருள் எல்லாவற்றிலும் வியாபித்துக்காணப்படுகிறது.<br /> <span class="c2">(அர்ரஹீம்)</span>- <span class="c2">(நிகரற்ற அன்புடையோன்)</span> என்பது இறைவிசுவாசிகளான முஃமின்களுக்கு விசேடமாக அருள்பாளிப்பவன் என்பதைக் குறிக்கிறது.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001002.mp3"></audio> 2- <span class="c2">(அகிலத்தாரைப் படைத்துப் பரிபாலிக்கும் அல்லாஹ்வுக்கே புகழனைத்தும்)</span> என்ற வசனம் அனைத்து வகையான புகழும் பாராட்டும் பரிபூரணத்தன்மையும் அல்லாஹ் ஒருவனுக்கு மாத்திரமே உரியன என்பதாகும்.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001003.mp3"></audio> 3- <span class="c2">(அர்ரஹ்மானிர்ரஹீம்)</span> "அளவற்ற அருளாளன் நிகரற்ற அன்புடையோன்" என்பது அல்லாஹ் விசாலாமான பரந்த அருளுக்குச்சொந்தக்காரன். அவனின் அருள் எல்லாவற்றிலும் வியாபித்துக்காணப்படுகிறது என்பதையும், அவன் இறைவிசுவாசிகளான முஃமின்களுக்கு விசேடமாக அருள்பாளிப்பவன் என்பதையும் காட்டுகிறது.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001004.mp3"></audio> 4- <span class="c2">(மாலிகி யவ்மித்தீன்)</span>- <span class="c2">(மறுமை நாளின் அதிபதி)</span> என்பது மறுமை நாளைக் குறிக்கிறது.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001005.mp3"></audio> 5- <span class="c2">(இய்யாக நஃபுது வஇய்யாக நஸ்தஈன்)</span>- <span class="c2">(உன்னையே வணங்குகிறோம் உன்னிடமே உதவியும் தேடுகிறோம்)</span> அதாவது, உன்னை மாத்திரமே வணங்குகிறோம். உன்னிடம் மாத்திரமே உதவியும் தேடுகிறோம் என்பதாகும்.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001006.mp3"></audio> 6- <span class="c2">(இஹ்தினஸ்ஸிராதல் முஸ்தகீம்)</span>- <span class="c2">(இறைவா எங்களுக்கு நேரான வழியை காட்டுவாயாக)</span> என்பதன் கருத்து: இஸ்லாம் மற்றும் நபிவழியின் பால் நேர்வழி பெருவதைக் குறிக்கும்.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001007.mp3"></audio> 7- <span class="c2">(ஸிராதல்லதீன அன்அம்த அலைஹிம் கைரில் மஃழூபி அலைஹிம் வலல்ழால்லீன்)</span> <span class="c2">(நீ அருள்புரிந்தோர் வழியில்.(அது உன்)</span> கோபத்திற்குள்ளானவர்களினதோ வழிதவறியவர்களினதோ வழி அன்று.) அல்லாஹ் அருள்புரிந்தோரின் வழி என்பது, நபிமார்கள் மற்றும் அவர்களைப் பின்பற்றி வாழ்ந்த நல்லடியார்கள் சென்ற பாதையாகும். மாறாக யூத கிறிஸ்தவர்கள் சென்ற பாதைகள் அல்ல என்பது இவ்வசனத்தின் கருத்தாகும்.<br /> இவ்வத்தியாயத்தை ஓதி முடித்ததும் <span class="c2">(ஆமீன்)</span> என்று கூறுவது நபிவழியாகும் ஆமீன் என்பதன் பொருள் இறைவா! எங்கள் பிரார்த்தனையை ஏற்றுக்கொள்வாயாக என்பதாகும். </p>',
            ],
            1 => [
                'question' => 'கேள்வி: ஸூறா ஸல்ஸலாவை ஓதி அதற்கான விளக்கத்தைத் கூறுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7130.mp3',
                'answer' => '<p> பதில் : ஸூறா ஸல்ஸலாவும் அதன் விளக்கவுரையும் :<br /> பிஸ்மில்லாஹிர் ரஹ்மானிர் ரஹீம்<br /> 1- இதா zஸுல்zஸிலதில் அர்ழுzஸில் zஸாலஹா. 2- வஅக்ரஜதில் அர்ழு அஸ்காலஹா. 3- வகாலல் இன்ஸானு மாலஹா. 4. யவ்மஇஃதின் துஹத்திஸு அக்பாரஹா. 5- bபிஅன்ன ரbப்பக அவ்ஹாலஹா. 6- யவ்மஇஃதிய் யஸ்dதுருன்னாஸு அஷ்தாதல் லியுரவ் அஃமாலஹும். 7- பமய்யஃமல் மிஸ்கால ஃதர்ரதின் கய்ரன்யரஹ். 8- வமய்யஃமல் மிஸ்கால ஃதர்ரதின் ஷர்ரன்யரஹ். <span class="c2">(ஸூறதுஸ்ஸல்ஸலா : 1-8)</span><br /> விளக்கவுரை <span class="c2">(தப்ஸீர்)</span> :<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099001.mp3"></audio> பொருள்: <span class="c2">(1)</span> <span class="c2">(பூகம்பத்திற்குட்பட்டு மிகக் கடுமையாக உலுக்கி விடப்படும் போது)</span> அதாவது, மறுமை நாள் நிகழ்வதற்காக இந்தப் பூமி மிகக்கடுமையாக அசைக்கப்படும்போது என்பது இதன் கருத்தாகும். இவ்வுலகம் அழிக்கப்படுவதற்கு முன் மிகப்பெரும் ஒரு பூகம்பம் நிகழும் என்பதை இவ்வசனம் குறித்து நிற்கிறது.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099002.mp3"></audio> 2- <span class="c2">(பூமி தன் சுமைகளை வெளியே தள்ளி விடும் போது,)</span> அதாவது பூமியானது தனக்குள் புதைந்து கிடக்கும் பிரேதங்கள் மற்றும் ஏனைய பொருட்களை வெளியேற்றிவிடும்.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099003.mp3"></audio> 3- <span class="c2">(மனிதன் இதற்கென்ன நடந்து விட்டது எனக் கூறுவான்)</span><br /> அதாவது அசைவின்றி இருந்த இந்தப் பூமி ஏன் அசைந்து நிலையின்றி இருக்கிறது? இதற்கு என்ன நிகழந்து விட்டது என மனிதன் தட்டுத்தடுமாறியவனாகவும் அதிர்ச்சிக்குள்ளாகிய நிலையிலும் கூறுவான்?<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099004.mp3"></audio> 4- <span class="c2">(அந்நாளில்; அது தன் செய்திகளை வெளியிடும்)</span>.<span class="c6"> இதன் கருத்தாவது:</span> அந்த மாபெரும் நாளில் பூமியானது தன் மீது நிகழ்ந்த நல்ல தீய காரியங்கள் குறித்த செய்திகளை அறிவிக்கும் என்பதாகும்.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099005.mp3"></audio> 5- <span class="c2">(ஏனெனில் உமது இரட்சகன் (அவ்வாறு கூறுமாறு)</span> அதற்கு கட்டளையிட்டுள்ளான் என்று கூறும்). ஏனெனில் அல்லாஹ் இவ்வாறு கூறுமாறு அதற்கு அறிவித்து அதற்கு கட்டளையுமிட்டுள்ளான் என்பதாகும்.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099006.mp3"></audio> 6- <span class="c2">(அந்நாளில் மனிதர்கள் தம் செயல்களைப் பார்ப்பதற்காக கூட்டங் கூட்டங்களாகச் சிதறுண்டு செல்வர்.)</span> பூமியானது பலமான அதிர்வுக்குள்ளாகும். அம்மாபெரும் நாளில் இவ்வுலகில் செய்த காரியங்களுக்கான முடிவைப் பார்ப்பதறக்காக குழுக்களாக விசாரணை மன்றை நோக்கிப் புறப்பட்டுச் செல்வார்கள்.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099007.mp3"></audio> 7- <span class="c2">(எனவே எவர்அணுவளவேனும் நன்மை செய்திருப்பினும் அதனை அவர் கண்டுகொள்வார்)</span>. அதாவது யார் ஒரு சிற்றெரும்பின் அளவு நன்மையான நல்ல காரியத்தை செய்திருப்பினும் அதனை தன் முன்னால் கண்டுகொள்வார் என்பது இதன் கருத்தாகும்.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099008.mp3"></audio> 8- <span class="c2">(எவர்அணுவளவேனும் தீமை செய்திருப்பினும் அதனை அவர் கண்டுகொள்வார்)</span> அதாவது யார் ஒருவர் அணுவளவேனும் தீய காரியத்தை செய்திருப்பினும் அதனை தன் முன்னால் கண்டுகொள்வார் என்பது இதன் கருத்தாகும். </p>',
            ],
            2 => [
                'question' => 'கேள்வி 3 : ஸூறதுல் ஆதியாத்தை ஓதீ அதன் விளக்கத்தை குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7270.mp3',
                'answer' => '<p> பதில் : ஸூறதுல் ஆதியாத்தும் அதன் விளக்கமும் :<br /> பிஸ்மில்லாஹிர் ரஹ்மானிர் ரஹீம்.<br /> 1. வல்ஆdதியாதி ழப்ஹா 2. fபல்மூரியாதி கdத்ஹா. 3. fபல்முகீராதி ஸுbப்ஹா. 4. fபஅஸர் னபிஹீ நக்ஆ. 5. fபவஸத்ன bபிஹீ ஜம்ஆ. 6. இன்னல் இன்ஸான லிரbப் bபிஹீ லகனூத். 7. வஇன்னஹு அலா தாலிக லஷஹீத். 8. வஇன்னஹு லிஹுbப் bபில் கைரி லஷdதீத். 9. அfபலா யஃலமு இஃதா bபுஃஸிர மாfபில் குbபூர். 10. வஹூஸ்ஸில மாபிஸ்ஸு dதூர். 11. இன்ன ரbப்பஹும் bபிஹிம் யவ்மஇஃதில் லகபீர். <span class="c2">(ஸூறதுல் ஆதியாத் 1-11)</span>.<br /> விளக்கவுரை <span class="c2">(தப்ஸீர்)</span> :<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100001.mp3"></audio> 1- <span class="c2">(மூச்சுத்தினற அதி வேகமாக ஓடும் குதிரைகள் மீது சத்தியமாக !)</span> இந்த வசனத்தில் அல்லாஹ் மிக வேகமாக மூச்சுத்தினற ஓடும் குதிரைகள் மீது சத்தியம் செய்துள்ளான். அவ்வாறு மிக வேகமாக ஓடும் வேளையில் அது மூச்சிரைக்கும் சப்தம் கேட்கும் என்று கூறுகிறான்.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100002.mp3"></audio> 2- <span class="c2">(தீப்பொறிகளை பறக்கச்செய்பவற்றின் மீது சத்தியமாக!)</span> மேலும் அல்லாஹ் மிக வேகமாக ஓடும் குதிரைகள் குளம்புகளை அடித்து ஓடும் போது அதன் குளம்புகள் பாரங்கல்லின் மீது பட்டு தீப்பொறியை ஏற்படுத்தும் குதிரைகளின் மீது அல்லாஹ் சத்தியம் செய்கிறான்.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100003.mp3"></audio> 3- <span class="c2">(அதிகாலை வேளையில் தாக்குதல் நடத்தும் குதிரைகளின் மீது சத்தியமாக)</span> அதாவது எதிரிகளை அதிகாலையில் தாக்கும் குதிரைகளின் மீது சத்தியம் செய்கிறான்.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100004.mp3"></audio> 4- <span class="c2">(புழுதிப் படலத்தை கிளப்பி விடுபவற்றின் மீதும் சத்தியமாக)</span> அதாவது அக் குதிரைகள் அதன் ஓட்டத்தின் மூலம் புழுதியைக் கிளப்பி விடுகின்றன.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100005.mp3"></audio> 5- <span class="c2">(அதன் மூலம் எதிரிப் படை நடுவில் நுழைந்து விடும் குதிரைகள் மீது சத்தியமாக!)</span> அவைகள் எதிரிகளின் கூட்டத்தினுள் நடுவில் சென்று தாக்குதல் நடத்துகின்றன. அவ்வாறான குதிரைகள் மீது சத்தியமாக!.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100006.mp3"></audio> 6- <span class="c2">(நிச்சயமாக, மனிதன் தன் இறைவனுக்கு நன்றி கெட்டவனாக இருக்கின்றான்)</span>. அதவாது உண்மையில் மனிதன் தனது இரட்சகன் விரும்புகின்றவைகளை பிறருக்கு கொடுக்காது தடுத்துக்கொண்டிருக்கின்றான் என்பதை இவ்வசனம் உணர்த்துகிறது.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100007.mp3"></audio> 7- <span class="c2">(அதற்கு அவனே சான்றாகவும் உள்ளான்)</span> அதாவது தன்னிடம் உள்ளவற்றை பிறருக்கு கொடுத்துதவாது தடுத்துக் கொள்ளும் இச்செயலுக்க அவனே சாட்சியாளனாக உள்ளான். இந்த விடயம் மிகத்தெளிவான விடயம் என்பதனால் அதனை ஒரு போதும் மறுக்க முடியாது.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100008.mp3"></audio> 8- <span class="c2">(நிச்சயமாக அவன் செல்வத்தை நேசிப்பதில் மிகவும் தீவிரமாக உள்ளான்)</span>. அதாவது தனது செல்வத்தின் மீதான மோகமானது அவனை நல்ல காரியங்களில் செலவளிக்காது கஞ்சத்தனம் காட்டுவதற்கு காரணமாக அமைகிறது.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100009.mp3"></audio> 9- <span class="c2">(புதைகுழிக்குள் உள்ளவை வெளியே தள்ளப்படும் போது தனது நிலை குறித்து அவன் அறிய வேண்டாமா?)</span>. அதாவது உலக வாழ்வின் மோகத்தால் தற்பெருமை கொண்ட இந்த மனிதன் விசாரணைக்காவும் கூலி வழங்குவதற்காகவும் மண்ணறைகளிலிருந்து மரணித்தோரை பூமியிலிருந்து வெளியேற்றி மீண்டும் உயிர்கொடுத்து எழுப்பாட்டப்படும் போது அவன் உலகில் கற்பனை செய்தது போல் நிலைமை இருக்காது)? என்பதை மனிதன் அறிந்து கொள்ள வேண்டாமா?.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100010.mp3"></audio> 10- <span class="c2">(நெஞ்சங்களில் உள்ளவையும் வெளியாக்கப்படும்)</span>. அதாவது உள்ளங்களில் தோன்றிய எண்ணங்கள் மற்றும் நம்பிக்கைகள் இவையல்லாத விடயங்கள் அனைத்தும் தெளிவுபடுத்தப்பட்டு எடுத்துக்காட்டப்படும் .<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100011.mp3"></audio> 11- <span class="c2">(அந்தாளில், நிச்சயமாக அவர்களது இரட்சகன் அவர்களைப்பற்றி நன்கறிந்தவனாக இருப்பான்.)</span> இதன் கருத்தாவது : நிச்சயமாக அந்நாளில் அவர்களின் இரட்சகன் அவர்கள் பற்றி ஆழ்ந்தறிந்தவனாக இருப்பான். தனது அடியார்களின் விவகாரம் எதுவும் அவனின் அறிவிலிருந்து மறைந்து போகாது. ஆதலால் அவர்களின் செயற்பாடுகளுக்கு ஏற்ப கூலி வழங்குவான். </p>',
            ],
            3 => [
                'question' => 'கேள்வி: ஸூறா காரிஆவை ஓதி அதற்கான விளக்கத்தைத் கூறுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7450.mp3',
                'answer' => '<p> பதில்: ஸூறதுல் காரிஆவும் அதன் விளக்கவுரையும் :<br /> பிஸ்மில்லாஹிர் ரஹ்மானிர் ரஹீம்.<br /> 1. அல்காரிஅஹ். 2. மல்காரிஅஹ். 3. வமா அத்ராக மல்காரிஅஹ். 4. யவ்ம யகூனுன்னாஸு கல்பராஷில் மப்ஸூஸ். 5. வதகூனுல் ஜிபாளு கல்இஹ்னில் மன்பூஷ். 6. பஅம்மா மன் ஸகுலத் மவாணுஸீனுஹு. 7. பஹுவ பீ ஈஷதிர் ராழியா. 8. வஅம்மா மன் கப்பத் மவாஸீனுஹூ. 9. பஉம்முஹூ ஹாவியா. 10. வமா அமத்ராக மாஹியஃ. 11. நாருன் ஹாமியஃ. ஸூறதுல் காரிஆஃ 1-11<br /> விளக்கவுரை <span class="c2">(தப்ஸீர்)</span> :<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101001.mp3"></audio> 1- <span class="c2">(திடுக்கிடச் செய்யும் பயங்கர நிகழ்வு!)</span> கருத்து : உள்ளங்களை திடுக்கிடச்செய்யக்கூடிய மிகவும் பயங்கரங்கள் நிறைந்த நாளை குறிக்கிறது.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101002.mp3"></audio> 2- <span class="c2">(திடுக்கிடச் செய்யும் பயங்கர நிகழ்வு என்றால் என்ன?)</span> கருத்து : அதாவது உள்ளங்களை திடுக்கிடச்செய்யக்கூடிய மிகவும் பயங்கரங்கள் நிறைந்த நாள் என்றால் என்ன?.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101003.mp3"></audio> 3- <span class="c2">(அந்தப் பயங்கர நிகழ்வு என்ன என்பதை உமக்கு அறிவித்தது எது?)</span> கருத்து: நபியே மக்களின் உள்ளங்களை திடுக்கிடச் செய்யக்கூடிய மிகவும் பயங்கரங்கள் நிறைந்த நாள் பற்றி அறிவித்தது எது?! அது தான் மறுமை நாள்,<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101004.mp3"></audio> 4- <span class="c2">(அந்நாளில், மக்கள் சிதறிக்கிடக்கும் ஈசல்கள் போன்று ஆகிவிடுவார்கள்)</span>.<span class="c6"> கருத்து :</span> மக்களின் உள்ளங்களை திடுக்கிடச்செய்யும் அந்நாளில் மக்களெல்லாம அங்கும் இங்கும் சிதரிய ஈசல்கள் போன்றிருப்பார்கள்.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101005.mp3"></audio> 5- <span class="c2">(மலைகள் கடையப்பட்ட கம்பளி போன்று ஆகிவிடும்!)</span> கருத்து : அதாவது மலைகள் அவற்றின் மெதுவான நகர்வு மற்றும் இயக்கத்தில் கடையப்பட்ட கம்பளி போன்று மென்மையானதாக ஆகிவிடும்.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101006.mp3"></audio> 6- <span class="c2">(யாரின் செயல்களது எடை அந்நாளில் கனத்துப் பாரமாக உள்ளதோ)</span> . அதாவது யாரின் நன்மைகளின் எடை தீமையான காரியங்களின் எடையை விட அதிகரிக்கிறதோ<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101007.mp3"></audio> 7- <span class="c2">(அவர் திருப்திகரமான வாழ்வைப் பெறுவார்)</span>.<span class="c6"> கருத்து :</span> அவர் சுவர்க்கத்தில் திருப்திகரமான வாழ்வை பெற்றுக்கொள்வார்.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101008.mp3"></audio> 8- <span class="c2">(யாரின் செயல்களது எடை பாரமற்று இலேசாக இருக்குமோ)</span> கருத்து : அதாவது எவரின் தீமையான காரியங்களின் எடை நல்லமல்களின் எடையை விட அதிகரிக்கிறதோ<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101009.mp3"></audio> 9- <span class="c2">(அவர் தங்குமிடம் \'ஹாவியா\' எனும் பாதாளப் படுகுழியாகும்.)</span> கருத்து : மறுமையில் அவரின் நிரந்தர தங்குமிடம் நரகமாகும்.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101010.mp3"></audio> 10- <span class="c2">( ஹாவியா எனும் அது என்னவென்று உமக்கு அறிவித்தது எது?)</span> கருத்து : நபியே ஹாவியா என்றால் என்ன என்பது பற்றி உமக்குத் தெரியுமா?<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101011.mp3"></audio> 11- <span class="c2">(அது கடும் சூடான நெருப்பாகும்)</span> கருத்து : அது கடும் வெப்பம் கொண்ட நரக நெருப்பாகும். </p>',
            ],
            4 => [
                'question' => 'கேள்வி 5 : ஸூறதுத் தகாஸுரை ஓதி அதற்கான விளக்கத்தைக் குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7610.mp3',
                'answer' => '<p> பதில் : ஸூறதுத் தகாஸுரும் அதன் விளக்கவுரையும் :<br /> பிஸ்மில்லாஹிர் ரஹ்மானிர் ரஹீம்<br /> 1- அல்ஹாகு முத்தகாஸுர். 2- ஹத்தா ஸுர்துமுல் மகாபிர். 3- கல்லா ஸவ்ப தஃலமூன். 4- ஸும்ம கல்லா ஸவ்ப தஃலமூன். 5- கல்லா லவ் தஃலமூன இல்மல் யகீன். 6- லதரவுன்னல் ஜஹீம். 7- ஸும்ம லதரவுன்னஹா ஐனல் யகீன். 8- ஸும்ம லதுஸ்அலுன்ன யவ்மஇதின் அனின்னஈம். <span class="c2">(ஸூறதுத் தகாஸுர் 1-8)</span>.<br /> விளக்கவுரை <span class="c2">(தப்ஸீர்)</span> :<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102001.mp3"></audio> <span class="c2">(1)</span> <span class="c2">(அதிகமதிகம் பொருள் சேர்த்துக் குவிக்க வேண்டும் என்ற பேராசை உங்களின் கவனத்தை திருப்பிவிட்டது)</span>.<span class="c6"> விளக்கம்:</span> மனிதர்களே !! செல்வத்தின் மூலமும் பிள்ளைகள் மூலமும் பெருமையடிப்பது அல்லாஹ்விற்கு கீழ்படிந்து நடப்பதை விட்டும் உங்களை திசை திருப்பிவிட்டது.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102002.mp3"></audio> <span class="c2">(2)</span> <span class="c2">(நீங்கள் மண்ணரைகளைச் சந்திக்கும் வரை)</span> விளக்கம் : நீங்கள் மரணித்து மண்ணரைகளுக்கு செல்லும் வரையில் இது உங்கள் கவனத்தை திருப்பிக்கொண்டிருக்கும்.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102003.mp3"></audio> <span class="c2">(3)</span> <span class="c2">(அவ்வாறன்று. இதன் (விளைவை)</span> நீங்கள் நிச்சயம் அறிந்து கொள்வீர்கள்! ) விளக்கம் : இவ்வாறு பெருமையடிப்பது அல்லாஹ்வுக்கு கீழ்படிந்து நடப்பதை விட்டும் உங்களை திசைதிருப்பி விடுவதன் விளைவை நீங்கள் மறுமையில் நன்கறிந்து கொள்வீர்கள்!.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102004.mp3"></audio> <span class="c2">(4)</span> <span class="c2">(பின்பும் அவ்வாறன்று. இதன் (விளைவை)</span> நீங்கள் நிச்சயம் அறிந்து கொள்வீர்கள்!) விளக்கம் : அதாவது இதன் விளைவை உண்மையாக அறிந்து கொள்வீர்கள்.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102005.mp3"></audio> <span class="c2">(5)</span> <span class="c2">(அவ்வாறன்று! நீங்கள் இதனை (விளைவை)</span> உறுதியாக அறிந்திருந்தால் <span class="c2">(உங்களை அது பராக்காக்கியிருக்காது)</span>).<span class="c6"> விளக்கம் :</span> அதாவது நீங்கள் மீண்டும் உயிர்கொடுத்து எழுப்பப்பட்டு உங்களின் செயல்களுக்கான கூலியும் உங்களுக்கு கிடைக்கும் என்று உறுதியாக அறிவீர்களாயின் செல்வங்கள் மற்றும் பிள்ளைகளின் மூலம் பெருமையடிக்கும் விடயங்களில் மூழ்கியிருக்கமாட்டீர்கள்.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102006.mp3"></audio> <span class="c2">(6)</span> <span class="c2">(நிச்சயம் நீங்கள் நரகத்தைக் காண்பீர்கள்!)</span> விளக்கம் : அதாவது நீங்கள் மறுமையில் நரகத்தை நேரடியாகப் பார்ப்பீர்கள்.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102007.mp3"></audio> <span class="c2">(7)</span> <span class="c2">(பின்பும் அதை நீங்கள் மிக உறுதியாகக் காண்பீர்கள்!)</span> விளக்கம் : அதாவது நீங்கள் எவ்வித சந்தேகமும் இல்லாமல் உறுதியாக அந்நரகத்தைப் பார்ப்பீர்கள்.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102008.mp3"></audio> <span class="c2">(8)</span> <span class="c2">(பின்னர் நீங்கள், அருட்கொடைகள் குறித்து விசாரிக்கப்படுவீர்கள்!)</span> விளக்கம் : பின்பு அந்த நாளில் அல்லாஹ் உங்களுக்கு அருளாகத்தந்த ஆரோக்கியம், செல்வம் போன்ற அனைத்தைப் பற்றியும் உங்களிடம் விசாரிப்பான். </p>',
            ],
            5 => [
                'question' => 'கேள்வி 6 : ஸூறதுல் அஸ்ரை ஓதி அதற்கான விளக்கத்தைக் குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7750.mp3',
                'answer' => '<p> பதில் : ஸூறதுல் அஸ்ரும் அதன் விளக்கவுரையும் :<br /> பிஸ்மில்லாஹிர் ரஹ்மானிர் ரஹீம்.<br /> 1- வல் அஸ்ர். 2- இன்னல் இன்ஸான லபீ குஸ்ர். 3- இல்லல்லதீன ஆமனூ வஅமிலுஸ் ஸாலிஹாதி வதவாஸவ் பில்ஹக்கி வதவாஸவ் பிஸ்ஸப்ர். <span class="c2">(ஸூறதுல் அஸ்ர்: 1-3)</span>.<br /> விளக்கவுரை <span class="c2">(தப்ஸீர்)</span> :<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/103001.mp3"></audio> 1- <span class="c2">(காலத்தின் மீது சத்தியமாக!)</span> விளக்கம் : அல்லாஹ் இவ்வசனத்தில் காலத்தின் மீது சத்தியம் செய்கிறான்.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/103002.mp3"></audio> 2- <span class="c2">(நிச்சயமாக மனிதன் நஷ்டத்திலேயே இருக்கிறான்!)</span> விளக்கம் : அதாவது, மனிதர்கள் யாவரும் குறையிலும் நஷ்டத்திலும் உள்ளனர்.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/103003.mp3"></audio> 3- <span class="c2">(நம்பிக்கை கொண்டு, நற்கருமங்கள் புரிந்து, சத்தியத்தையும், பொறுமையையும் தம்மிடையே உபதேசித்துக் கொண்டிருப்போரைத் தவிர)</span>.<span class="c6"> விளக்கம் :</span> அதாவது யார் ஈமான் கொண்டு நற்கருமங்கள் புரிந்து சத்தியத்தின் பால் ஏனையோரை அழைத்து அதில் எதிர்நோக்கும் சிரமங்களை பொறுமையுடன் ஏற்று வாழ்கிறார்களோ அவர்கள் இந்நஷ்டத்திலிருந்து தப்பித்துக்கொள்வார்கள். </p>',
            ],
            6 => [
                'question' => 'கேள்வி : ஸூறதுல் ஹுமஸாவை ஓதி அதற்கான விளக்கத்தைக் குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7830.mp3',
                'answer' => '<p> பதில் : ஸூறதுல் ஹுமஸாவும் அதன் விளக்கவுரையும் :<br /> பிஸ்மில்லாஹிர் ரஹ்மானிர் ரஹீம்.<br /> 1- வைலுல் லிகுல்லி ஹுமஸதில் லுமஸஹ். 2- அல்லஃதீ ஜமஅ மாலவ் வஅத்ததஹ். 3- யஹ்ஸபு அன்ன மாலஹு அக்லதஹ். 4- கல்லா லயுன் பதன்ன பில் ஹுதமஹ். 5- வமா அத்ராக மல் ஹுதமஹ். 6- நாருழ்ழாஹில் மூகதஹ். 7- அல்லதீ தத்தலிஉ அலல் அப்இதஹ். 8- இன்னஹா அலைஹிம் முஃஸதஹ். 9- ஃபீ அமதிம் முமத்ததஹ். <span class="c2">(ஸூறதுல் ஹுமஸஃ 1-9)</span>.<br /> விளக்கவுரை <span class="c2">(தப்ஸீர்)</span> :<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104001.mp3"></audio> <span class="c2">(1)</span> <span class="c2">(குறை கூறி புறம் பேசித்திரியும் அனைவருக்கும் கேடு உண்டாகட்டும்!)</span> விளக்கம் : மனிதர்கள் குறித்து புறம் பேசி குறை கூறித் திரிவோருக்கும் அழிவும் நாசமும் உண்டாகட்டும் என்று இந்த வசனம் குறிப்பிடுகிறது.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104002.mp3"></audio> <span class="c2">(2)</span> <span class="c2">(அவன் செல்வத்தைத் திரட்டி அதனைக் கணக்கிட்டுக் கொண்டிருக்கிறான்!)</span> விளக்கம் : அதாவதுஅவனது கவலை செல்வத்தை சேகரிப்பதும் அதனை எண்ணி எண்ணி பாதுகாப்பதும்தான். அதனைத் தவிர வேறு கவலை அவனுக்கு இல்லை.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104003.mp3"></audio> <span class="c2">(3)</span> <span class="c2">(தனது செல்வம் தன்னை நிலைத்திருக்கச் செய்யும் என அவன் நினைத்துக் கொண்டிருக்கின்றான்)</span>.<span class="c6"> விளக்கம் :</span> அவன் திரட்டிய செல்வமானது மரணித்திலிருந்து தன்னை பாதுகாத்து இவ்வுலக வாழ்வில் நிரந்தரமாக வாழச் செய்யும் என எண்ணிக் கொண்டிருக்கிறான்.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104004.mp3"></audio> <span class="c2">(4)</span> <span class="c2">(அவ்வாறன்று! நிச்சயம் அவன் \'ஹுதமா\' என்றழைக்கப்படும் (சிதைத்து சின்னாபின்னமாக்கும்)</span> நரகிற்கு வீசி எறியப்படுவான்!) விளக்கம் : இது இந்த அறிவற்றவன் கற்பனை செய்வது போன்ற விவகாகரமல்ல. மாறாக இப்படிப்பட்டவர்கள் நரக நெருப்பில் வீசி எறியப்படுவார்கள். அந்நரகத்திற்கு, அதனுள் போடப்படுகின்ற அனைத்தையும் சிதைத்து துகல்களாக மாற்றிவிடும் வல்லமை உண்டு.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104005.mp3"></audio> <span class="c2">(5)</span> <span class="c2">(ஹுதமா என்றால் என்ன என்பது பற்றி உமக்குத் தெரியுமா?)</span> இதன் கருத்தாவது : நபியே வீசி எறியப்படுகின்ற அனைத்தையும் சின்னாபின்னமாக்கிவிடும் இந்நரகத்தைப்பற்றி உமக்குத் தெரியுமா? என்பதாகும்.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104006.mp3"></audio> <span class="c2">(6)</span> <span class="c2">(அது மூட்டிவிடப்பட்டிருக்கும் அல்லாஹ்வின் நெருப்பாகும்.)</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104007.mp3"></audio> <span class="c2">(7)</span> <span class="c2">(அது இதயங்கள் வரை சென்று பரவும்!)</span> விளக்கம் : அதாவது அந்த நெருப்பானது மனிதர்களின் மேனி முதல் இதயங்கள் வரை சென்று பாயக்கூடிய நெருப்பாகும்.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104008.mp3"></audio> <span class="c2">(8)</span> <span class="c2">(நிச்சயமாக அதனால் அவர்கள் சூழப்பட்டு மூடப்படுவார்கள்.)</span> கருத்து : அதாவது அந்த நெருப்பானது வேதனை செய்யப்படுவோரின் மீது முழுமையாக மூடப்பட்டு விடும்.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104009.mp3"></audio> <span class="c2">(9)</span> <span class="c2">(அவர்கள் உயரமான தூண்களில் கட்டப்பட்டிருப்பர்)</span> அதாவது அவர்கள் வெளிவரவே முடியாத வகையில் நீண்ட மிக உயராமான தூண்களில் கட்டப்பட்டிருப்பர் என்பது இதன் கருத்தாகும். </p>',
            ],
            7 => [
                'question' => 'கேள்வி 8 : ஸூறதுல் பீலை ஓதி அதற்கான விளக்கத்தைக் குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7970.mp3',
                'answer' => '<p> பதில்: ஸூறதுல் பீலும் அதற்கான தப்ஸீர் விளக்கமும் :<br /> பிஸ்மில்லாஹிர் ரஹ்மானிர் ரஹீம்<br /> <span class="c2">(1)</span> அலம் தர கைப பஅல ரப்புக பிஅஸ்ஹாபில் பீல். <span class="c2">(2)</span> அலம் யஜ்அல் கைதஹும் பீ தழ்லீல். <span class="c2">(3)</span> வஅர்ஸல அலைஹிம் தய்ரன் அபாபீல். <span class="c2">(4)</span> தர்மீஹிம் பிஹிஜாரதின் மின் ஸிஜ்ஜீல். <span class="c2">(5)</span> பஜஅலஹும் கஅஸ்பிம் மஃகூல். <span class="c2">(ஸூறதுல் பீல் 1-5)</span> <span class="c2">(யானை)</span>.<br /> விளக்கவுரை <span class="c2">(தப்ஸீர்)</span> :<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105001.mp3"></audio> <span class="c2">(1)</span> <span class="c2">(உமது இரட்சகன் யானைப்படையினரை என்ன செய்தான் என்பதனை நீர் பார்க்க வில்லையா?)</span> கருத்து : நபியே உமது இரட்சகன் கஃபாவை இடிக்க நாடி படைதிரட்டி வந்த அப்ரஹாவிற்கும் அவனின் பட்டாளமான யானைப் படையினருக்கும் என்ன செய்தான் என்பதை நீர் அறியவில்லையா?<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105002.mp3"></audio> <span class="c2">(2)</span> <span class="c2">(அவர்களது சூழ்ச்சியை அவன் வீணாக்கிவிடவில்லையா?)</span> விளக்கம் : அதனை இடிப்பதற்கான அவர்களின் தீய சூழ்ச்சியை அல்லாஹ் தோல்வியடையச் செய்தான். அதனால் கஅபாவை விட்டும் மக்களைத் திருப்பிவிட வேண்டும் என்ற அவர்களின் ஆசை நிறைவேறவில்லை. அதில் எதனையும் அவர்களால் செய்ய முடியவில்லை.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105003.mp3"></audio> <span class="c2">(3)</span> <span class="c2">(அவர்கள் மீது கூட்டங் கூட்டமாகப் பறவைகளை அனுப்பினான்)</span>. அதாவது, அவர்கள் மீது அல்லாஹ் பறவைகளை அனுப்பினான். அவை கூட்டங் கூட்டமாக அவர்களை நோக்கி வந்தன.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105004.mp3"></audio> <span class="c2">(4)</span> அவை அவர்கள் மீது சுட்ட களிமண் கற்களை எறிந்து கொண்டிருந்தன.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105005.mp3"></audio> <span class="c2">(5)</span> <span class="c2">(அதனால் மெல்லப்பட்ட வைக்கோலைப் போன்று அவன் அவர்களை ஆக்கிவிட்டான்)</span> விளக்கம் : அதனால் மிருகங்கள் மென்று கால்களால் மிதித்து நாசப்படுத்திய வைக்கோல் போன்று அவர்களை ஆக்கிவிட்டான். </p>',
            ],
            8 => [
                'question' => 'கேள்வி 9 : ஸூறதுல் குறைஷை ஓதி அதற்கான விளக்கத்தைக் குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8070.mp3',
                'answer' => '<p> பதில் : ஸூறதுல் குறைஷும் அதற்கான தப்ஸீர் விளக்கமும்?<br /> பிஸ்மில்லாஹிர் ரஹ்மானிர் ரஹீம்.<br /> <span class="c2">(1)</span> லிஈலாபி குறைஷ். <span class="c2">(2)</span> ஈலாபிஹிம் ரிஹ்லதஷ் ஷிதாஇ வஸ்ஸைப். <span class="c2">(3)</span> பல்யஃபுதூ ரப்பஹாதல் பைத். <span class="c2">(4)</span> அல்லதீ அத்அமஹும் மின் ஜூஇவ் வஆமனஸஹும் மின் கவ்ப். ஸூறது குறைஷ் 1-4 <span class="c2">(குறைஷிகள்)</span><br /> விளக்கவுரை <span class="c2">(தப்ஸீர்)</span> :<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106001.mp3"></audio> <span class="c2">(1)</span> <span class="c2">(குறைஷியர்களுக்கு விருப்பம் உண்டாக்கியமைக்காக)</span>,<span class="c6"> இதன் கருத்தாவது :</span> அவர்கள் கோடை காலத்திலும் மாரிகாலத்திலும் பிரயாணம் செய்வதற்கான பழக்கத்தை விருப்பமாகக் கொண்டிருந்தனர்.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106002.mp3"></audio> <span class="c2">(2)</span> <span class="c2">(மாரி காலத்துடையவும் கோடைக்காலத்துடையவும் பிரயாணத்தில் அவர்களுக்கு மன விருப்பத்தை உண்டாக்கியமைக்காக)</span>.<span class="c6"> விளக்கம் :</span> குறைஷிகள் வியாபாரத்தை தொழிலாகக் கொண்டோர் என்ற வகையில் அவர்கள் மாரி காலத்தில் யமனுக்கும், கோடைகாலத்தில் ஷாம் பிரதேசத்திற்கும்; எவ்வித அச்சுருத்தல் ஏதுமின்றி பாதுகாப்பாக சென்று வருவார்கள்.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106003.mp3"></audio> <span class="c2">(3)</span> <span class="c2">(எனவே அவர்கள் இந்த இல்லத்தின் இரட்சகனை வணங்கி வழிபடட்டும்)</span>.<span class="c6"> விளக்கம் :</span> அதாவது அவர்களின் இப்பிரயாணத்தை இலகுபடுத்திக் கொடுத்த, இந்த கஃபாவாகிய புனித ஆலயத்தின் இரட்சகனை மாத்திரம் எவரையும் அவனுடன் இணைவைக்காது வணங்கட்டும்.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106004.mp3"></audio> <span class="c2">(4)</span> <span class="c2">(அவனே அவர்களுக்கு பசியின் போது உணவளித்தான், அச்சத்தின் போது அவர்களுக்கு பாதுகாப்பு வழங்கினான்)</span>.<span class="c6"> கருத்து :</span> கஃபாவையும் அதை அண்டி வாழ்வோரையும் மதித்தல் என்ற எண்ணத்தை அறபுகளின் உள்ளத்தில் ஏற்படுத்தியதன் விளைவாக அவர்களுக்கு பசியின் போது உணவளித்தான், அச்சத்தின் போது அவர்களுக்கு பாதுகாப்பு வழங்கினான். </p>',
            ],
            9 => [
                'question' => 'கேள்வி 10 : ஸூறதுல் மாஊனை ஓதி அதற்கான விளக்கத்தைக் குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8160.mp3',
                'answer' => '<p> பதில் : ஸூறதுல் மாஊனும் அதன் விளக்கமும் :<br /> பிஸ்மில்லாஹிர் ரஹ்மானிர் ரஹீம்.<br /> <span class="c2">(1)</span> அரஅய்தல்லதீ யுகத்திபு பித்தீன். <span class="c2">(2)</span> பதாலிகல்லஃதீ யதுஃஉல் யதீம். <span class="c2">(3)</span> வலா யஹுழ்ழு அலா தஆமில் மிஸ்கீன். <span class="c2">(4)</span> பவய்லுல் லில்முஸல்லீன். <span class="c2">(5)</span> அல்லதீன ஹும் அன் ஸலாதிஹிம் ஸாஹூன். <span class="c2">(6)</span> அல்லஃதீன ஹும் யுராஊன். <span class="c2">(7)</span> வயம்னஊனல் மாஊன். <span class="c2">(ஸூறதுல் மாஊன் 1-7)</span> <span class="c2">(கைமாறாகப் பரிமாறப்படும் சிறு பொருட்கள்)</span>.<br /> விளக்கவுரை <span class="c2">(தப்ஸீர்)</span> :<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107001.mp3"></audio> <span class="c2">(1)</span> <span class="c2">(தீர்ப்பு நாளை பொய்பிப்பவனை நபியே நீர் பார்த்தீரா?)</span> விளக்கம் : மறுமையில் நற்கூலி - தண்டனை கொடுக்கப்படுவதென்பதை பொய்யெனக் கூறுபவனை உனக்குத் தெரியுமா!.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107002.mp3"></audio> <span class="c2">(2)</span> <span class="c2">(அவன் தான் அநாதையை மிரட்டுகிறான்)</span> விளக்கம் : அதாவது அநாதையின் தேவையை நிறைவேற்றாது கடுமையாக நடந்து கொள்கிறான்.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107003.mp3"></audio> <span class="c2">(3)</span> <span class="c2">(ஏழைக்கு உணவளிக்க அவன் தூண்டவுமாட்டான்)</span> விளக்கம் : அவன் எளியோருக்கு உணவளிக்க தன்னையோ பிறரையோ தூண்டமாட்டான்.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107004.mp3"></audio> <span class="c2">(4)</span> <span class="c2">(தொழுகையாளிகளுக்குக் கேடே உண்டாகட்டும்)</span>. அதாவது தொழுகையாளிக்கு வேதனையும் அழிவும் உண்டாகட்டும்.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107005.mp3"></audio> <span class="c2">(5)</span> <span class="c2">(அவர்கள் தொழுகையில் அலட்சியமாக இருக்கிறார்கள்.)</span> அதாவது தமது தொழுகையில் பராமுகமாக இருக்கிறார்கள். தொழுகையின் நேரம் முடிவடையும் வரையில் அதனைப் பொருட்படுத்தாது இருப்பார்கள்.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107006.mp3"></audio> <span class="c2">(6)</span> <span class="c2">(அவர்கள் பிறருக்குக் காட்டவே தொழுகிறார்கள்.)</span> அதாவது, அவர்கள் தமது செயல்களை அல்லாஹ்வுக்காக தூய்மையாக நிறைவேற்றாது பிறருக்கு காண்பிக்கவே தமது தொழுகையையும் செயற்பாடுகளையும் மேற்கொள்கின்றனர்.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107007.mp3"></audio> <span class="c2">(7)</span> <span class="c2">(அவர்கள் சாதாரண சிறிய பொருட்களைக் கொடுத்துதவுவதைத் தடுக்கின்றார்கள்.)</span> உதவுவதால் தங்களுக்கு எவ்விதப் பாதிப்பையும் ஏற்படுத்தாதவற்றினாலும் கூட மற்றவர்களுக்கு உதவுவதை தடுக்கிறார்கள். </p>',
            ],
            10 => [
                'question' => 'கேள்வி 11 : ஸூறதுல் கவ்ஸரை ஓதி அதற்கான விளக்கத்தைக் குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8280.mp3',
                'answer' => '<p> பதில் : ஸூறதுல் கவ்ஸரும் அதன் விளக்கவுரையும் :<br /> பிஸ்மில்லாஹிர் ரஹ்மானிர் ரஹீம்.<br /> <span class="c2">(1)</span> இன்னா அஃதைனாகல் கௌஸர். <span class="c2">(2)</span> பஸல்லி லிரப்பிக வன்ஹர். <span class="c2">(3)</span> இன்ன ஷானிஅக ஹுவல் அப்தர். <span class="c2">(ஸுறதுல் கவ்ஸர் 1-3)</span>.<br /> விளக்கவுரை <span class="c2">(தப்ஸீர்)</span> :<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/108001.mp3"></audio> <span class="c2">(1)</span> <span class="c2">(நிச்சயமாக நாம் உங்களுக்கு \'கவ்ஸர்\' எனும் பெரும் செல்வத்தைத் தந்தோம்.)</span> நபியே உமக்கு பெரும் செல்வத்தை தந்தோம். அதில் ஒன்றுதான் சுவர்க்த்தில் உள்ள கவ்ஸர் எனும் நீர்த்தடாகமாகும்.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/108002.mp3"></audio> <span class="c2">(2)</span> <span class="c2">(எனவே நீர் உமது இரட்சகனுக்காகத் தொழுது பலி (குர்பானி)</span>யும் கொடுப்பீராக.) இணைவைப்பாளர்கள் தமது சிலைகளுக்கு அறுத்துப்பலியிடுவதற்கு மாற்றமாக அல்லாஹ்வுக்கு மாத்திரம் தொழுது அறுத்துப் பலியிடுவதன் மூலம் இவ்வருளை தந்த அவனுக்கு நன்றி செலுத்துவீராக.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/108003.mp3"></audio> <span class="c2">(3)</span> <span class="c2">(நிச்சயமாக உமது எதிரிதான் சந்ததியற்றவன்.)</span> நிச்சயமாக உம்மை வெறுப்பவன்தான் எல்லா நன்மைகளையும் இழந்தவனாவான். அவன் மறக்கப்பட்டுவிட்டான். அவன் நினைவுகூறப்பட்டாலும் தீய முறையிலேயே நினைவுகூறப்படுகிறான். </p>',
            ],
            11 => [
                'question' => 'கேள்வி 12 : ஸூறதுல் காபிரூனை ஓதி அதற்கான விளக்கத்தைக் குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8360.mp3',
                'answer' => '<p> பதில் : ஸூறதுல் காபிரூனும் அதன் விளக்கமும்:<br /> பிஸ்மில்லாஹிர் ரஹ்மானிர் ரஹீம்.<br /> <span class="c2">(1)</span> குல் யா அய்யுஹல் காபிரூன். <span class="c2">(2)</span> லா அஃபுது மாதஃபுதூன். <span class="c2">(3)</span> வலா அன்தும் ஆஃபிதூன மா அஃபுது. <span class="c2">(4)</span> வலா அன ஆஃபிதும் மா அபத்தும். <span class="c2">(5)</span> வலா அன்தும் ஆபிதூன மா அஃபுது. <span class="c2">(6)</span> லகும் தீனுகும் வலிய தீன். ஸூறதுல் காபிரூன் <span class="c2">(1-6)</span>.<br /> விளக்கவுரை <span class="c2">(தப்ஸீர்)</span> :<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109001.mp3"></audio> <span class="c2">(1)</span> <span class="c2">(நபியே நீர் கூறிவிடுவீராக, \' ஓ நிராகரிப்பாளர்களே !\')</span> அதாவது : நபியே நீர் கூறுவீராக, அல்லாஹ்வை நிராகரிப்பவர்களே!<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109002.mp3"></audio> <span class="c2">(2)</span> <span class="c2">(நீங்கள் வணங்குபவற்றை நான் வணங்கமாட்டேன்.)</span> அதாவது : தற்போதும் எதிர்காலத்திலும் நீங்கள் வணங்கும் சிலைகளை நான் ஒரு போதும் வணங்கமாட்டேன்.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109003.mp3"></audio> <span class="c2">(3)</span> <span class="c2">(நான் வணங்குபவனை நீங்கள் வணங்குபார்களாகவும் இல்லை.)</span> அதாவது : நான் வணங்கும் அல்லாஹ் ஒருவனை நீங்கள் வணங்குவோராக இல்லை.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109004.mp3"></audio> <span class="c2">(4)</span> <span class="c2">(நீங்கள் வணங்குபவற்றை நான் வணங்குவனுமல்லன்.)</span> அதாவது : நீங்கள் வணங்கும் சிலைகளை நான் வணங்கக் கூடியவன் அல்லன்.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109005.mp3"></audio> <span class="c2">(5)</span> <span class="c2">(நான் வணங்குபவனை நீங்கள் வணங்குவோர்களாகவும் இல்லை)</span> அதாவது : நான் வணங்கும் ஓர் இறைவனான அல்லாஹ்வை நீங்கள் வணங்குவோர்களாக இல்லை.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109006.mp3"></audio> <span class="c2">(6)</span> <span class="c2">(உங்களுக்கு உங்களுடைய மார்க்கம், எனக்கு எனது மார்க்கம்)</span> நீங்களே உங்களுக்காக உருவாக்கிக்கொண்ட உங்கள் மார்க்கம் உங்களுக்குரியது , அல்லாஹ்வினால் எனக்கு இறக்கியருளப்பட்ட மார்க்கம் எனக்குரியது. </p>',
            ],
            12 => [
                'question' => 'கேள்வி 10 :ஸூறதுன்னஸ்ரை ஓதி அதற்கான விளக்கத்தைக் குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8470.mp3',
                'answer' => '<p> பதில் : ஸூறதுன்னஸ்ரும் அதன் விளக்கவுரையும் :<br /> பிஸ்மில்லாஹிர் ரஹ்மானிர் ரஹீம்.<br /> <span class="c2">(1)</span> இதா ஜாஅ நஸ்ருல்லாஹி வல்பத்ஹ். <span class="c2">(2)</span> வரஅய்தன்னாஸ யத்குலூன பீ தீனில்லாஹி அப்வாஜா. <span class="c2">(3)</span> பஸப்பிஹ் பிஹம்தி ரப்பிக வஸ்தஃபிர்ஹு, இன்னஹூ கான தவ்வாபா. ஸூறதுன்னஸ்ர் <span class="c2">(1-3)</span>.<br /> விளக்கவுரை <span class="c2">(தப்ஸீர்)</span> :<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/110001.mp3"></audio> <span class="c2">(1)</span> <span class="c2">(அல்லாஹ்வின் உதவியும் வெற்றியும் வந்து விடும்போது,)</span> அதாவது : நபியே! உமது மார்க்கத்திற்கான உதவியும்,அதற்கான உயர்வும், கண்ணியமும் கிடைத்து, மக்கா வெற்றி நிகழும் போது,<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/110002.mp3"></audio> <span class="c2">(2)</span> <span class="c2">(அல்லாஹ்வுடைய மார்க்கத்தில் மக்கள் கூட்டங் கூட்டமாக நுழைவதையும் நீர் கண்டால்,)</span> கூட்டம் கூட்டமாக இஸ்லாமிய மார்க்கத்தில் நுழைவதை நீர் கண்டால்,<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/110003.mp3"></audio> <span class="c2">(3)</span> <span class="c2">(உமது இரட்சகனைப் புகழ்ந்து அவனைத் துதிப்பீராக! அவனிடம் பாவமன்னிப்புக் கேட்பீராக! நிச்சயமாக அவன் பாவமன்னிப்பை மிகவும் ஏற்கக் கூடியவனாக உள்ளான்.)</span> இதன் கருத்து : இவ்வாறு நிகழ்வது நீர் எப்பணியை நிறைவேற்றுவதற்காக அனுப்பப்பட்டீரோ அப்பணியானது நிறைவுக்கு வந்துவிட்டது என்பதற்கான அறிகுறியாகும் என்பதை அறிந்து கொள்வீராக. எனவே அல்லாஹ்வின் உதவி மற்றும் வெற்றி எனும் அருள் கிடைத்தமைக்கு நன்றி செலுத்தும் முகமாக உனது இரட்சகனை புகழ்ந்து துதிசெய்வீராக. மேலும் அவனிடம் மன்னிப்பும் கோருவீராக. ஏனெனில் அவன் அடியார்களின் தவ்பாவை பாவமன்னிப்பை ஏற்று அவர்களுக்கு மன்னிப்பளிப்பவனாகவும் உள்ளான். </p>',
            ],
            13 => [
                'question' => 'கேள்வி 14 :ஸூறதுல் மஸதை ஓதி அதற்கான விளக்கத்தைக் குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8550.mp3',
                'answer' => '<p> பதில் : ஸூறதுல் மஸதும் அதன் விளக்கவுரையும் :<br /> பிஸ்மில்லாஹிர் ரஹ்மானிர் ரஹீம்.<br /> <span class="c2">(1)</span> தப்பத் யதா அபீ லஹபிவ் வதப். <span class="c2">(2)</span> மா அஃனா அன்ஹு மாலுஹு வமா கஸப். <span class="c2">(3)</span> ஸயஸ்லா நாரன் தாத லஹப். <span class="c2">(4)</span> வம்ரஅதுஹூ ஹம்மாலதல் ஹதப். <span class="c2">(5)</span> பீ ஜீதிஹா ஹப்லும் மிம் மஸத். <span class="c2">(ஸுறதுல் மஸத் : 1-5)</span>.<br /> விளக்கவுரை <span class="c2">(தப்ஸீர்)</span> :<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111001.mp3"></audio> <span class="c2">(1)</span> <span class="c2">(அபூ லஹபின் இரு கைகளும் நாசமடையட்டும்; அவனும்<br /> அழியட்டும்)</span> நபி <span class="c2">(ஸல்)</span> அவர்களின் பெரியதந்தையான அபூலஹபின் இரு கரங்களும் அவனின் தீய செயலின் காரணத்தினால் நாசமாகட்டும். ஏனெனில் அவன் நபி <span class="c2">(ஸல்)</span> அவர்களை துன்புறுத்திக் கொண்டிருந்தான். இறுதியில் அவனின் முயற்சி பயனற்று தோற்றுப்போனது.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111002.mp3"></audio> <span class="c2">(2)</span> <span class="c2">(அவனது செல்வமோ, அவன் சம்பாதித்தவையோ அவனுக்குப் பயனளிக்கவில்லை.)</span> அதாவது, அவனது செல்வமும் பிள்ளைகளும் அவனுக்கு என்ன பயனை கொடுத்தது? அவைகள் அவனுக்கு கிடைத்த தண்டனையை விட்டும் பாதுகாக்கவுமில்லை, அவனுக்கு எந்த அருளையும் பெற்றுக்கொடுக்கவுமில்லை.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111003.mp3"></audio> <span class="c2">(3)</span> <span class="c2">(விரைவில் அவன் கொழுந்து விட்டெரியும் நரகில் நுழைந்து விடுவான்.)</span> அதாவது, மறுமையில் அவன் தீச்சுவாலையுடய நரகத்தில் நுழைந்து அதன் வெப்பத்தை வேதனையோடு அனுபவிப்பான்.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111004.mp3"></audio> <span class="c2">(4)</span> <span class="c2">(விறகு சுமக்கும் அவனுடைய மனைவியும் கொழுந்து விட்டெரியும் நரகில் நுழைந்துவிடுவாள்)</span> அதாவது, நபியவர்கள் செல்லும் பாதையில் முற்களை போட்டு நபியவர்ளுக்கு தொல்லை கொடுத்து நோவினை செய்த அபூலஹபின் மனைவி உம்மு ஜமீலும் நரகினுள் நுழைவாள்.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111005.mp3"></audio> <span class="c2">(5)</span> <span class="c2">(அவளது கழுத்தில் நன்கு முறுக்கப்பட்ட ஈச்சம் கயிறு இருக்கும்.)</span> அதாவது, அவளின் கழுத்தில் மிக இறுக்கமாக கட்டப்பட்ட கயிறு இருக்கும், அக்கயிற்றின் மூலமே நரகத்திற்கு அவள் இழுத்துச் செல்லப்படுவாள். </p>',
            ],
            14 => [
                'question' => 'கேள்வி 15 : ஸூறதுல் இக்லாஸை ஓதி அதற்கான விளக்கத்தைக் குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8650.mp3',
                'answer' => '<p> பதில் : ஸூறதுல் இக்லாஸும்; அதன் விளக்கவுரையும் :<br /> பிஸ்மில்லாஹிர் ரஹ்மானிர் ரஹீம்.<br /> <span class="c2">(1)</span> குல் ஹுவல்லாஹு அஹத். <span class="c2">(2)</span> அல்லாஹுஸ்ஸமத். <span class="c2">(3)</span> லம் யலித், வலம் யூலத். <span class="c2">(4)</span> வலம் யகுல்லஹு குபுவன் அஹத். <span class="c2">(ஸூறதுல் இக்லாஸ் : 1-4)</span><br /> விளக்கவுரை <span class="c2">(தப்ஸீர்)</span> :<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112001.mp3"></audio> <span class="c2">(1)</span> <span class="c2">(நபியே அவன் அல்லாஹ் ஒருவன்தான் எனக் கூறுவீராக!)</span> கருத்து: அதாவது நபியே! அல்லாஹ் ஒருவன், அவனைத்தவிர உண்மையான கடவுள் வேறு யாருமில்லை.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112002.mp3"></audio> <span class="c2">(2)</span> <span class="c2">(அல்லாஹ் எவ்வித தேவையுமற்றவன்)</span> அதாவது, படைப்புகளின் தேவைகள் அவனை நோக்கியே உயர்த்தப்படுகின்றன.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112003.mp3"></audio> <span class="c2">(3)</span> <span class="c2">(அவன் யாரையும் பெறவுமில்லை, எவருக்கும் பிறக்கவுமில்லை.)</span> அதாவது, அவனுக்கு சந்ததியோ பெற்றோரோ கிடையாது. அவன் அவை அனைத்தையும் விட்டு தூய்மையானவனாக உள்ளான்.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112004.mp3"></audio> <span class="c2">(4)</span> <span class="c2">(அவனுக்கு நிகராக யாருமில்லை)</span>. அவனின் படைப்பில் அவனுக்கு ஒப்பாக யாருமில்லை </p>',
            ],
            15 => [
                'question' => 'கேள்வி 16: ஸூறதுல் பலகை ஓதி அதற்கான விளக்கத்தைக் குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8750.mp3',
                'answer' => '<p> பதில் : ஸூறதுல் பலகும் அதன் விளக்கவுரையும் :<br /> பிஸ்மில்லாஹிர் ரஹ்மானிர் ரஹீம்.<br /> <span class="c2">(1)</span> குல் அஊது பிரப்பில் பலக். <span class="c2">(2)</span> மின் ஷர்ரி மா கலக். <span class="c2">(3)</span> வமின் ஷர்ரி காசிகின் இஃதா வகப். <span class="c2">(4)</span> வமின் ஷர்ரின் னப்பாஸாதி பில்உகத். <span class="c2">(5)</span> வமின் ஷர்ரி ஹாஸிதின் இஃதா ஹஸத். <span class="c2">(ஸூறதுல் பலக் 1-5)</span><br /> விளக்கவுரை <span class="c2">(தப்ஸீர்)</span> :<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113001.mp3"></audio> <span class="c2">(1)</span> <span class="c2">(அதிகாலை நேரத்தின் இரட்சகனிடம் பாதுகாப்புத் தேடுகிறேன்)</span>. நான் வைகரையின் இரட்சகனிடம் பாதுகாப்பும் அடைக்கலமும் தேடுகிறேன் என நபியே நீங்கள் கூறுங்கள்.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113002.mp3"></audio> <span class="c2">(2)</span> <span class="c2">(அவன் படைத்தவற்றின் தீங்குகளிலிருந்தும்; (பாதுகாப்புத்<br /> தேடுகிறேன்)</span>. நோவினை செய்யும் அனைத்து படைப்பினங்களின் தீங்கை விட்டும் <span class="c2">(பாதுகாப்புத்தேடுகிறேன்)</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113003.mp3"></audio> <span class="c2">(3)</span> <span class="c2">(இருள் படரும் போது ஏற்படும் தீங்கை விட்டும் அவ்விரவின் தீங்கிலிருந்தும்; (பாதுகாப்புத்தேடுகிறேன்)</span>).<span class="c6"> கருத்து :</span> இரவில் வெளிப்படும் மிருகங்கள் மற்றும் கள்வர்களின் தொல்லைகளை விட்டும் அல்லாஹ்விடம் அடைக்கலம் தேடுகிறேன்.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113004.mp3"></audio> <span class="c2">(4)</span> <span class="c2">(மேலும், முடிச்சுகளில் (மந்திரித்து)</span> ஊதும் பெண்களின் தீங்கைவிட்டும் <span class="c2">(பாதுகாப்புத் தேடுகிறேன்)</span>). முடிச்சுக்களில் ஊதி சூனியம் செய்யும் பெண்களின் தீங்கிலிருந்து நான் பாதுகாப்புத்தேடுகிறேன்.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113005.mp3"></audio> <span class="c2">(5)</span> <span class="c2">(பொறாமைக்காரன் பொறாமைப் படும் போது ஏற்படும் அவனது தீங்கிலிருந்தும் (பாதுகாப்புத்தேடுகிறேன்.)</span> மக்களுடன் வெறுப்புக் கொண்டு அவர்களுக்கு அல்லாஹ்வினால் வழங்கப்பட்டுள்ள அருள்கள் அழிந்து, நோவினை செய்திட வேண்டுமென விரும்பி பொறாமை கொள்ளும் பொறாமைக்காரனின் கெடுதியை விட்டும் நான் பாதுகாப்புத் தேடுகிறேன். </p>',
            ],
            16 => [
                'question' => 'கேள்வி 17 : ஸூறதுன்னாஸை ஓதி அதற்கான விளக்கத்தைக் குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8870.mp3',
                'answer' => '<p> பதில் : ஸூறதுன்னாஸும் விளக்கவுரையும் :<br /> பிஸ்மில்லாஹிர் ரஹ்மானிர் ரஹீம்.<br /> <span class="c2">(1)</span> குல் அஊது பிரப்பின் னாஸ். <span class="c2">(2)</span> மலிகின் னாஸ். <span class="c2">(3)</span> இலாஹின் னாஸ். <span class="c2">(4)</span> மின் ஷர்ரில் வஸ்வாஸில் கன்னாஸ். <span class="c2">(5)</span> அல்லஃதீ யுவஸ்விஸு பீஸுதூரின் னாஸ். <span class="c2">(6)</span> மினல் ஜின்னதி வன்னாஸ். <span class="c2">(ஸூறதுன்னாஸ் 1-6)</span><br /> விளக்கவுரை <span class="c2">(தப்ஸீர்)</span> :<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114001.mp3"></audio> <span class="c2">(1)</span> <span class="c2">((நபியே!)</span> நீர் கூறுவீராக! மனிதர்களின் இரட்சகனிடம் நான் பாதுகாவல் தேடுகிறேன்.) நபியே நான் மனிதர்களின் இரட்சகனிடம் பாதுகாப்பும் அடைக்கலமும் தேடுகிறேன்.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114002.mp3"></audio> <span class="c2">(2)</span> <span class="c2">(மனிதர்களின் அரசனிடம் நான் பாதுகாப்புத் தேடுகிறேன்)</span>) அவன் நாடியவிதத்தில் அவர்களின் விவகாரங்களை கையாள்கிறான். அவனைத் தவிர அவர்களுக்கு வேறு அரசன் யாருமில்லை.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114003.mp3"></audio> <span class="c2">(3)</span> <span class="c2">(மக்களின் உண்மையான இறைவனிடம் நான் பாதுகாப்புத் தேடுகிறேன்)</span>. அவன்தான் அவர்களின் உண்மையாக வணங்படக்கூடிய இறைவன், அவனைத் தவிர அவர்களுக்கு எவரும் உண்மையாக வணங்கப்படக்கூடிய இறைவன் கிடையாது.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114004.mp3"></audio> <span class="c2">(4)</span> மனிதர்களுடைய உள்ளங்களில் ஊசலாட்டங்களை ஏற்படுத்தி விட்டு, மறைந்து கொள்பவனின் தீங்கைவிட்டும் <span class="c2">(பாதுகாப்புத் தேடுகிறேன்)</span> கருத்து : மனிதர்களின் உள்ளத்தில் வீணான சந்தேகங்களையும் ஊசலாட்டங்களையும் ஏற்படுத்தும் ஷைத்தான்களின் தீங்கை விட்டும் பாதுகாப்புத் தேடுகிறேன்.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114005.mp3"></audio> <span class="c2">(5)</span> <span class="c2">(அவன் மனிதர்களின் உள்ளங்களில் சந்தேகங்களை உண்டுபன்னுகிறான்)</span> அதாவது, மனிதர்களின் உள்ளங்களில் வீணான எண்ணங்களை அவன் ஏற்படுத்துகிறான்.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114006.mp3"></audio> <span class="c2">(6)</span> <span class="c2">(இத்தகையோர் ஜின்களிலும் மனிதர்களிலும் உள்ளனர்.)</span> இவ்வாறு தீய எண்ணங்களை ஏற்படுத்துவோர் ஜின்களிலும் மனிதர்களிலும் உள்ளனர். </p>',
            ],
        ],
        5 => [
            0 => [
                'question' => 'கேள்வி 1 : (இன்னமல் அஃமாலு பின்னிய்யாத் ) என்ற ஹதீஸை முழுமையாக எழுதி அதன் சில பயன்களையும் குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9030.mp3',
                'answer' => '<p> பதில் : அமீருல் முஃமினீன் அபூ ஹப்ஸ் உமர் இப்னுல் கத்தாப் ரழியல்லாஹு அன்ஹு அவர்கள் நபி ஸல்லல்லாஹு அலைஹி வஸல்லம் கூறியதை தான் கேட்டதாக அறிவிக்கிறார்கள் : செயல்கள் அனைத்தும் எண்ணங்களைப் பொருத்தே அமைகின்றன. ஒவ்வொருவருக்கும் அவர் எண்ணியதற்கேற்பவே கூலி கிடைக்கிறது. எவரின் ஹிஜ்ரத் <span class="c2">( தேசம் துறந்து செல்லல்)</span> அல்லாஹ்வையும் அவனின் தூதரையும் நோக்காகக் கொண்டமைந்தால் அவரின் ஹிஜ்ரத் அல்லாஹ்வுக்கும் அவனின் திருத்தூதருக்குமானதாக அமையும். எவரின் ஹிஜ்ரத் உலக நலன்களை அடைந்து கொள்வதை நோக்காகக் கொண்டிருந்தால் அல்லது ஒரு பெண்ணை திருமணம் முடிக்கவேண்டும் என்றிருந்தால். அவரின் ஹிஜ்ரத் அதற்குரியதாகவே அமையும்\'. <span class="c2">(ஆதாரம் : புஹாரி, முஸ்லிம்)</span>.<span class="c6"><br /> இந்த ஹதீஸிலிருந்து பெறப்படும் பயன்கள் :</span><br /> 1- எல்லா அமல்களுக்கும் நிய்யத் - அவசியமாகும். தொழுகை நோன்பு ஹஜ் மற்றும் ஏனைய எல்லா வணக்களுக்கும் நிய்யத் என்பது அவசியமாகும்.<br /> 2- அல்லாஹ்வுக்காக நிய்யத் வைப்பதில் மனத்தூய்மையை கடைப்பிடிப்பது அவசியமாகும்.<br /> நபிமொழி -2 </p>',
            ],
            1 => [
                'question' => 'கேள்வி :2 ( மன் அஹதஸ பீ அம்ரரினா ஹாதா) என்ற ஹதீஸை முழுமையாக எழுதி அதன் சில பயன்களையும் குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9090.mp3',
                'answer' => '<p> பதில் : நபி ஸல்லல்லாஹு அலைஹி வஸல்லம் கூறியதாக உம்மு அப்தில்லாஹ் உம்முல் முஃமினீன் ஆஇஷா ரழியல்லாஹு அன்ஹா அறிவிக்கிறார்கள் : எமது இந்த மார்க்த்தில் இல்லாத புதிய ஒரு விடயத்தை மார்க்கமாக யார் உண்டாக்குகிறானோ அவருடைய அந்தப் புதுமை நிராகரிக்கப்படும்\'. <span class="c2">(ஆதாரம் : புஹாரி, முஸ்லிம்)</span>.<span class="c6"><br /> இந்த ஹதீஸிலிருந்து பெறப்படும் பயன்கள் :</span><br /> 1- மார்க்கத்தில் நூதன அனுஷ்டானங்கள் - புதுமைகள் -உருவாக்கப்படுவதை தடை செய்தல்.<br /> 2- மார்க்கம் என்ற பெயரில் புதிதாக உருவாக்கப்பட்ட செயல்கள் யாவும் ஏற்றுக்கொள்ளபடாது, அவைகள் நிராகரிக்கப்பட வேண்டியவைகளாகும்.<br /> நபிமொழி -3 </p>',
            ],
            2 => [
                'question' => 'கேள்வி :3 (பைனமா நஹ்னு ஜுலூஸுன் இன்த ரஸுலில்லாஹ் ஸல்லல்லாஹு அலைஹிவஸல்லம்) என்ற ஹதீஸை முழுமையாக எழுதி அதன் சில பயன்களையும் குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9160.mp3',
                'answer' => '<p> பதில் : உமர் ரழியல்லாஹு அன்ஹு அவர்கள் பின்வருமாறு கூறுகிறார்கள் : <span class="c2">(ஒருநாள் நாங்கள்; இறைத்தூதர் ஸல்லல்லாஹு அலைஹிவஸல்லம். அவர்களுடன் உட்கார்ந்திருந்த வேளை மிக வெண்மையான ஆடை அணிந்த, மிகவும் கருப்பான தலைமுடியையுடைய ஒரு மனிதர் வந்தார். அவரிடம் பிரயாணம் செய்ததற்கான அறிகுறிகள் எதுவும் தென்படவில்லை. எங்களில் எவரும் அவரை அறிந்திருக்கவுமில்லை அவர் நபி ஸல்லல்லாஹு அலைஹிவஸல்லம் அவர்களின் அருகில் சென்று, தனது முழங்கால்களை நபியவர்களின் முழங்கால்களோடு சேர்த்து தனது கைகளைத் தன் தொடைகள்மீது வைத்து அமர்ந்தார். பிறகு முஹம்மதே! இஸ்லாம் என்றால் என்னவென்று எனக்குத் கற்றுத்தாருங்கள்\' என்று கேட்டார். அதற்கு அல்லாஹ்வின் தூதர் ஸல்லல்லாஹுஅலைஹிவஸல்லம் அவர்கள், \'இஸ்லாம் என்பது அல்லாஹ்வைத் தவிர உண்மையாக வணங்கப்படக் கூடிய இறைவன் வேறு யாருமில்லை என்றும் முஹம்மத் அல்லாஹ்வின் தூதர் என்றும் நீர்; சாட்சி கூறுவதாகும். மேலும்,தொழுகையைக் கடை பிடிப்பதும், ஸகாத்தை வழங்கி வருவதும்,ரமளான் மாதத்தில் நோன்பு நோற்பதும், உங்களால் முடிந்தால் இறைவன் இல்லத்திற்கு ஹஜ் கடமையை நிறைவேற்றுவதும்\' என்று பதிலளித்தார்கள். அதற்கு அந்த மனிதர் \'நீங்கள் உண்மை (சரியாகவே)</span> சொன்னீர்கள்\' என்றார். அவரே கேள்வியும் கேட்டு அதற்குரிய பதில் சரியானது என்று கூறியதினால் நாங்கள் வியப்படைந்தோம்.<br /> அடுத்து அவர், \'ஈமான் பற்றி எனக்குத் கற்றுத்தாருங்கள் என்று கேட்டார். அதற்கு நபி ஸல்லல்லாஹு அலைஹிவஸல்லம் அவர்கள், \'அல்லாஹ்வையும் அவனுடைய மலக்குகளாகிய வானவர்களையும் அவனுடைய வேதங்களையும் அவனுடைய தூதர்களையும் இறுதி நாளையும் நீங்கள் நம்புவதாகும்.மேலும் நன்மை, தீமை அனைத்தும் இறை விதியின்படியே நடக்கின்றன என்றும் நீங்கள் நம்புவதுமாகும்\' என்று கூறினார்கள். அதற்கும் அம்மனிதர் நீங்கள் உண்மை <span class="c2">(சரியாகவே)</span> சொன்னீர்கள் என்றார். அதனைத் தொடர்ந்து அம்மனிதர், இஹ்ஸான் என்றால் என்ன என்பது பற்றி எனக்குத் தெரிவியுங்கள் <span class="c2">(கற்றுத்தாருங்கள்)</span> என்றார். அதற்கு நபி <span class="c2">(ஸல்லல்லாஹு அலைஹிவஸல்லம்)</span> அவர்கள், \'<span class="c2">(இஹ்ஸான் என்பது)</span> அல்லாஹ்வை நீங்கள் பார்க்கா விட்டாலும் அவனைப் பார்த்துக் கொண்டிருப்பதைப் போன்ற உணர்வுடன் வணங்குவதாகும். நீங்கள் அவனை பார்க்கவில்லையாயினும், அவன் உங்களைப் பார்த்துக்கொண்டிருக்கிறான்\' என்று பதிலளித்தார்கள். பின்னர் அவர் ‘எனக்கு நியாயத் தீர்ப்பு நாள் குறித்துச் சொல்லுங்கள்’ என்றார். அதற்கு நபி <span class="c2">(ஸல்)</span> அவர்கள் \'இந்தக் கேள்வி கேட்கப்படுபவர் கேட்பவரை விட அதிகமாக அறிந்தவர் அல்லர்” என்றார்கள்.<br /> பின்னர் அவர், அதன் அடையாளங்கள் குறித்து எனக்குச் சொல்லுங்கள் என்றார். நபி <span class="c2">(ஸல்)</span> அவர்கள் சொன்னதாவது, \'அடிமைப்பெண் தனது எஜமானியைப் பெற்றெடுப்பாள். மேலும் காலணிகளில்லாத, முறையான ஆடைகளற்ற, வறியவர்களான ஆடுமேய்ப்போர் ஆடம்பரமாக கட்டிடங்களைக் கட்டுவதில் போட்டி போட்டுக் கொண்டிருப்பதைப் பார்ப்பீர்கள்’.<br /> பிறகு அவர் போய் விட்டார். நான் அங்கேயே தாமதித்தேன். பிறகு நபி <span class="c2">(ஸல்)</span> அவர்கள், \'உமரே கேள்விகளைக் கேட்டவர் யாரென்று உங்களுக்குத் தெரியுமா?” எனக் கேட்டார்கள். \'அல்லாஹ்வும் அவனது தூதருமே நன்றாக அறிவார்கள்” என்றேன் நான். அதற்கு நபி <span class="c2">(ஸல்)</span> அவர்கள், அவர் ஜிப்ரீல் <span class="c2">(அலை)</span> ஆவார். அவர் உங்களுக்கு உங்கள் மார்க்கத்தைக் கற்றுத் தருவதற்காக வந்தார்” என்று கூறினார்கள். <span class="c2">(ஆதாரம் : முஸ்லிம்.)</span><br /> இந்த ஹதீஸிலிருந்து பெறப்படுகின்ற சில பயன்கள் :<br /> 1-இஸ்லாத்தின் ஐந்து அடிப்படைக் கடமைகள் குறிப்பிடப்பட்டுள்ளமை.<span class="c6"> அவைகளாவன :</span><br /> "உண்மையாக வணங்கப்படத் தகுதியானவன் அல்லாஹ்வைத் தவிர யாருமில்லை, முஹம்மத் <span class="c2">(ஸல்)</span> அவர்கள் அல்லாஹ்வின் தூதர் என்றும் சாட்சியம் கூறுதல்".<br /> தொழுகையைக் கடைப்பிடிப்பிடித்தல் <span class="c2">(நிலைநாட்டுதல்)</span>,<br /> ஸகாத்தை தகுதியானோருக்கு கொடுத்தல்<br /> ரமளான் மாதத்தில் நோன்பு நோற்றல்,<br /> புனித ஹஜ் கடமையை இறைஆலயத்திற்குச் சென்று நிறைவேற்றுதல்.<br /> 2- ஈமானின் அடிப்படை அம்சங்கள் குறிப்பிடப்பட்டுள்ளமை. அவை 6 ஆகும்.<br /> அல்லாஹ்வை நம்புவதல்.<br /> அவனுடைய மலக்குகளாகிய வானவர்களை நம்புதல்.<br /> அவனுடைய வேதங்களை நம்புதல்.<br /> அவனுடைய தூதர்களை நம்புதல்.<br /> இறுதி நாளை நம்புதல்.<br /> நன்மை, தீமை அனைத்தும் அல்லாஹ்வின் விதிப்படியே நடக்கின்றன என்று நம்புதல்.<br /> 3-இஹ்ஸானின் அடிப்படை குறிப்பிடப்படப்பட்டிருத்தல். இஹ்ஸானின் அடிப்படை ஒன்றாகும். அதாவது அல்லாஹ்வை நீ பார்ப்பது போன்ற உள்ளுணர்வுடன் வணங்குவதாகும். நீ அவனைக் காணாவிட்டாலும் அவன் உன்னை பார்த்துக் கொண்டிருக்கிறான்.<br /> 4- மறுமை நாள் ஏற்படும் நேரம் குறித்து அல்லாஹ்வைத்தவிர வேறு யாரும் அறியமாட்டார்கள்.<br /> நபிமொழி -4 </p>',
            ],
            3 => [
                'question' => 'கேள்வி 4 : (அக்மலுல் முஃமினீன ஈமானன்) என்ற ஹதீஸை முழுமையாக எழுதி அதன் சில பயன்களையும் தருக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9360.mp3',
                'answer' => '<p> பதில் : நபி <span class="c2">(ஸல்)</span> அவர்கள் கூறியதாக அபூஹுரைரா ரழியல்லாஹு அன்ஹு அவர்கள் அறிவிக்கிறார்கள் : முஃமின்களில் ஈமானில் பூரணத்துவம் அடைந்தோர் யாரெனில் அவர்களில் மிக அழகிய நற்குணத்தை உடையவர் ஆவார்\'. <span class="c2">(ஆதாரம் : திர்மிதி, இந்த ஹதீஸ் குறித்து இமாம் திர்மிதி அவர்கள் ஹஸன் ஸஹீஹ் எனத் தீர்ப்பளித்துள்ளார்.)</span><br /> இந்த ஹதீஸிலிருந்து பெறப்படும் பயன்கள் :<br /> 1- நற்குணத்தைக் கடைபிடிக்குமாறு தூண்டுதல்.<br /> 2- ஈமானின் பரிபூரணத்துவம் நிறைவான நற்குணத்தில் உள்ளது.<br /> 3- ஈமான் <span class="c2">(நற்குணத்தால்)</span> அதிகரிக்கும். <span class="c2">(துர்குணங்களால்)</span> குறைந்து விடும்.<br /> நபிமொழி -5 </p>',
            ],
            4 => [
                'question' => 'கேள்வி 5 (மன் ஹலப பிகய்ரில்லாஹ்) என்ற ஹதீஸை முழுமையாக எழுதி அதன் சில பயன்களையும் தருக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9440.mp3',
                'answer' => '<p> பதில் : நபிஸல்லல்லாஹு அலைஹிவஸல்லம் அவர்கள் கூறியதாக இப்னு உமர் ரழியல்லாஹு அன்ஹுமா அறிவிக்கிறார்கள் : யார் அல்லாஹ் அல்லாதவற்றின் மீது சத்தியம் செய்கிறாரோ அவர் அவனை நிராகரித்து விட்டார். அல்லது அவனுக்கு இணைவைத்துவிட்டார்\'. <span class="c2">(ஆதாரம் : திர்மிதி)</span>.<span class="c6"><br /> இந்த ஹதீஸிலிருந்து பெறப்படும் பயன்கள் :</span><br /> 1- அல்லாஹ்வைத் தவிர வேறு எவற்றிலும் சத்தியம் செய்வது கூடாது.<br /> 2- அல்லாஹ் அல்லாதவற்றின் மீது சத்தியம் செய்வது சிறிய வகை ஷிர்க்காகும்.<br /> நபிமொழி -6 </p>',
            ],
            5 => [
                'question' => 'கேள்வி 6 : (லா யுஃமினு அஹதுகும் ஹத்தா அகூன அஹப்ப இலைஹி) என்று ஆரம்பிக்கும் ஹதீஸை முழுமையாக எழுதி அதன் சில பயன்களையும் தருக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9510.mp3',
                'answer' => '<p> பதில் : நபிஸல்லல்லாஹு அலைஹிவஸல்லம் அவர்கள் கூறியதாக அனஸ் ரழியல்லாஹு அன்ஹு அறிவிக்கிறார்கள் : தன் பெற்றோர், பிள்ளை மற்றும் எல்லா மனிதர்களை விடவும் நான் மிகவும் நேசத்துக்குரியராக ஆகும் வரை உங்களில் எவரும் உண்மையான முஃமினாக முடியாது\'. <span class="c2">(ஆதாரம் : புஹாரி, முஸ்லிம்)</span>.<span class="c6"><br /> இந்த ஹதீஸிலிருந்து பெறப்படும் பயன்கள் :</span><br /> -அனைத்து மனிதர்களையும் விடவும் நபியவர்களை மிக அதிகமாக நேசிப்பது கட்டாயமாகும் - வாஜிபாகும்.<br /> -இவ்வாறு நேசம் கொள்வது ஈமானின் பரிபூரணதன்மைக்கான அடையாளமாகும்.<br /> நபிமொழி -7 </p>',
            ],
            6 => [
                'question' => 'கேள்வி 7: (லா யுஃமினு அஹதுகும் ஹத்தா யுஹிப்ப லி அகீஹி.) என்று ஆரம்பிக்கும் ஹதீஸை முழுமையாக எழுதி அதன் சில பயன்களையும் தருக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9580.mp3',
                'answer' => '<p> பதில் : நபி ஸல்லல்லாஹு அலைஹிவஸல்லம் அவர்கள் கூறியதாக அனஸ் ரழியல்லாஹு அன்ஹு அறிவிக்கிறார்கள் : தான் விரும்புவதை தனது சகோதரனுக்கு விரும்பாத வரையில் உங்களில் எவரும் ஈமான் கொண்டவாரக ஆகமாட்டார்\'. <span class="c2">(ஆதாரம் : புஹாரி, முஸ்லிம்)</span>.<span class="c6"><br /> இந்த ஹதீஸிலிருந்து பெறப்படும் சில பயன்கள் :</span><br /> 1- நல்லவிடயங்கள் அனைத்திலும் ஒரு முஃமின் தனக்கு விரும்புபவற்றை பிற முஃமின்களுக்கும் விரும்வது அவசியமாகும்.<br /> அவ்வாறு விரும்புவது ஈமானின் பரிபூரணதன்மைக்கான அடையாளமாகும்.<br /> நபிமொழி -8 </p>',
            ],
            7 => [
                'question' => 'கேள்வி 8 : (வல்லதீ நப்ஸீ பியதிஹி) என்று ஆரம்பிக்கும் ஹதீஸை முழுமையாக எழுதி அதன் சில பயன்களையும் தருக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9650.mp3',
                'answer' => '<p> பதில் : நபி <span class="c2">(ஸல்)</span> அவர்கள் கூறியதாக அபூ ஸஈத் ரழியல்லாஹு அன்ஹு அவர்கள் அறிவிக்கிறார்கள் : எனது ஆன்மா எவனின் கைவசம் உள்ளதோ அவனின் மீது ஆணையாக! ஸூறதுல் இஹ்லாஸ் அல்குர்ஆனின் மூன்றில் ஒரு பகுதிக்கு நிகரானது\'. <span class="c2">(ஆதாரம் : புஹாரி)</span>.<span class="c6"><br /> இந்த ஹதீஸிலிருந்து பெறப்படும் சில பயன்கள் :</span><br /> 1- இந்த ஹதீஸ் ஸூறதுல் இக்லாஸின் சிறப்பை எடுத்துக்காட்டுகிறது.<br /> 2- இந்த ஸூறாவை ஓதுவது அல்குர்ஆனின் மூன்றில் ஒரு பகுதிக்கு நிகரானதாகும்.<br /> நபிமொழி -9 </p>',
            ],
            8 => [
                'question' => 'கேள்வி 9 : (லா ஹவ்ல வலா குவ்வத இல்லா பில்லாஹ்) என்று ஆரம்பிக்கும் ஹதீஸை முழுமையாக எழுதி அதன் சில பயன்களையும் தருக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9720.mp3',
                'answer' => '<p> பதில் : நபிஸல்லல்லாஹு அலைஹிவஸல்லம் அவர்கள் கூறியதாக அபூமூஸா ரழியல்லாஹு அன்ஹு அறிவிக்கிறார்கள் : <span class="c2">(லா ஹவ்ல வலா குவ்வத இல்லா பில்லாஹ்)</span> என்ற வார்த்தை சுவர்கத்தின் பொக்கிசங்களின் ஒன்றாகும்\'.<span class="c6"> [இதன் கருத்து :</span> அல்லாஹ்வின் நாட்டமும் வல்லமையுமின்றி எதுவொன்றும் அசையவும் முடியாது, எதற்கும் எந்த சக்தியும் கிடையாது. <span class="c2">(அல்லாஹ்வின் உதவியில்லாமல் (பாவங்களிலிருந்து)</span> விலகிச்செல்லவோ <span class="c2">(நல்லறங்கள் புரிய)</span> ஆற்றல்பெறவோ மனிதனால் முடியாது)] <span class="c2">(ஆதாரம் : புஹாரி, முஸ்லிம்)</span>.<span class="c6"><br /> இந்த ஹதீஸிலிருந்து பெறப்படும் சில பயன்கள் :</span><br /> 1- "லா ஹவ்ல வலா குவ்வத இல்லா பில்லாஹ்" என்ற வார்த்தையின் சிறப்பு அது சுவர்கத்தின் பொக்கிசங்களில் ஒன்றாக குறிப்பிடப்பட்டுள்ளமை.<br /> 2- ஒரு அடியான் அவனது ஆற்றல் பலத்தில் நம்பிக்கை கொள்வதை விட்டு விலகி, முற்றிலும் அல்லாஹ் ஒருவனின் மீது மாத்திரமே நம்பிக்கை கொள்ளல்.<br /> நபிமொழி -10 </p>',
            ],
            9 => [
                'question' => 'கேள்வி 10 : (அலா வஇன்ன பில் ஜஸதி முழ்கதன்) என்று ஆரம்பிக்கும் ஹதீஸை முழுமையாக எழுதி அதன் சில பயன்களையும் தருக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9790.mp3',
                'answer' => '<p> பதில் : நபிஸல்லல்லாஹு அலைஹிவஸல்லம் அவர்கள் கூறியதை தான் செவிமடுத்ததாக அன்நுஃமான் இப்னு பஷீர் ரழியல்லாஹு அன்ஹு அறிவிக்கிறார்கள் : உடலில் ஒரு சதைத்துண்டு உண்டு, அது சீராகிவிட்டால் உடல் அனைத்தும் சீராகிவிடும், அது கெட்டுவிட்டால் உடல் அனைத்தும் கெட்டுவிடும். அதுதான் உள்ளமாகும்\'. <span class="c2">(ஆதாரம் : புஹாரி, முஸ்லிம்)</span>.<span class="c6"><br /> இந்த ஹதீஸிலிருந்து பெறப்படும் சில பயன்கள் :</span><br /> 1- உள்ளம் சீர்பெறுவதில்தான் மனிதனின் அகமும் புறமும் சீர்பெறுவது தங்கியுள்ளது.<br /> 2- மனிதனின் சீர்திருத்தம் உள்ளத்தை சீர்செய்வதில் தங்கியுள்ளதால் அதில் கூடுதல் கவனம் செலுத்துதல்.<br /> ஹதீஸ் - 11 </p>',
            ],
            10 => [
                'question' => 'கேள்வி 11 : (மன் கான ஆகிரு கலாமிஹீ மினத்துன்யா லாஇலாஹ இல்லல்லாஹ்) என்று ஆரம்பிக்கும் ஹதீஸை முழுமையாக எழுதி அதன் சில பயன்களையும் தருக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9860.mp3',
                'answer' => '<p> பதில் : நபிஸல்லல்லாஹு அலைஹிவஸல்லம் அவர்கள் கூறியதாக முஆத் இப்னு ஜபல் ரழியல்லாஹு அன்ஹு அறிவிக்கிறார்கள் : எவரது இறுதி வார்த்தை லாஇலாஹ இல்லல்லாஹ் என்று உள்ளதோ அவர் சுவர்க்கம் நுழைவார்\'. <span class="c2">(ஆதாரம் : அபூதாவூத்)</span>.<span class="c6"><br /> இந்த ஹதீஸிலிருந்து பெறப்படும் சில பயன்கள் :</span><br /> 1- லாஇலாஹ இல்லல்லாஹ் என்ற வார்த்தையின் சிறப்பு மற்றும் இவ்வார்த்தையின் மூலம் ஒரு அடியான் சுவர்க்கம் செல்வான் என்பதும் இங்கே குறிப்பிடப்பட்டுள்ளது.<br /> 2- இவ்வுலகை விட்டும் பிரியும் தருவாயில் "லாஇலாஹ இல்லல்லாஹ்" என்ற வார்த்தையைக் கூறுவதன் சிறப்பு இந்த ஹதீஸில் கூறப்பட்டுள்ளது.<br /> ஹதீஸ் - 12 </p>',
            ],
            11 => [
                'question' => 'கேள்வி 12 : (லைஸல் முஃமினு பித்தஃஆன் வலல் லஃஆன் ,, ) என்று ஆரம்பிக்கும் ஹதீஸை முழுமையாக எழுதி அதன் சில பயன்களையும் தருக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9940.mp3',
                'answer' => '<p> பதில் : நபி ஸல்லல்லாஹு அலைஹிவஸல்லம் அவர்கள் கூறியதாக அப்துல்லாஹ் இப்னு மஸ்ஊத் ரழியல்லாஹு அன்ஹு அறிவிக்கிறார்கள் : ஒரு உண்மை முஃமின் மற்றவர்களை குறைகூறபவனாகவோ சபிப்பவனாகவே மாணக்கேடான செயல்களை செய்பவனாகவோ அசிங்கமானவற்றைப் பேசுபவனாகவோ இருக்கமாட்டான்\'. <span class="c2">(ஆதாரம் : திர்மிதி)</span>.<span class="c6"><br /> இந்த ஹதீஸிலிருந்து பெறப்படும் சில பயன்கள் :</span><br /> 1- அசிங்கமான பயணற்ற அனைத்து பேச்சுகள், வார்த்தைகளையும் இந்த ஹதீத் தடை செய்கிறது.<br /> 2- இத்தீய விடயங்களை தவிர்ந்து நடப்பது ஒரு முஃமின் தனது நாவை பேணி நடப்பதன் பண்பாக கொள்ளப்படுகிறது.<br /> ஹதீஸ் - 13 </p>',
            ],
            12 => [
                'question' => 'கேள்வி 13 : (மின் ஹுஸ்னி இஸ்லாமில் மர்இ,, ) என்று ஆரம்பிக்கும் ஹதீஸை முழுமையாக எழுதி அதன் சில பயன்களையும் தருக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10020.mp3',
                'answer' => '<p> பதில் : நபி <span class="c2">(ஸல்)</span> அவர்கள் கூறியதாக அபூஹுரைரா ரழியல்லாஹு அன்ஹு அவர்கள் அறிவிக்கிறார்கள் : ஒரு முஸ்லிம் தனக்கு அவசியமல்லாதவற்றை விட்டு விடுவது இஸ்லாத்தின் சிறந்த காரியங்களில் ஒன்றாகும்\'. இந்த ஹதீஸை இமாம் திர்மிதி மற்றும் ஏனையோர் பதிவு செய்துள்ளனர்.<span class="c6"><br /> இந்த ஹதீஸிலிருந்து பெறப்படும் சில பயன்கள் :</span><br /> 1- உலக மற்றும் மார்க்க விவகாரகங்களில் தனக்கு அவசியமற்ற பிறர் விவகாரங்களை விட்டுவிடுதல்.<br /> 2- அவசியமல்லாதவற்றை விட்டுவிடுவது ஒரு சிறந்த முஸ்லிமுக்குரிய நிறைவான பண்பாகும்.<br /> ஹதீஸ் - 14 </p>',
            ],
            13 => [
                'question' => 'கேள்வி 14 : (மன் கரஅ ஹர்பன் மின் கிதாபில்லாஹ்) என்று ஆரம்பிக்கும் ஹதீஸை முழுமையாக எழுதி அதன் சில பயன்களையும் தருக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10100.mp3',
                'answer' => '<p> நபிஸல்லல்லாஹு அலைஹிவஸல்லம் அவர்கள் கூறியதாக அப்துல்லாஹ் இப்னு மஸ்ஊத் ரழியல்லாஹு அன்ஹு அறிவிக்கிறார்கள் : அல்லாஹ்வின் அருள் மறையான அல்குர்ஆனிலிருந்து ஓர் எழுத்தை ஓதினால் அதற்கு ஒரு நன்மை உண்டு. ஒரு நன்மை என்பது அது போன்ற பத்து மடங்காகும். "அலிஃப், லாம், மீம்" என்பதை ஒரு எழுத்து என்று கூறமாட்டேன். எனினும் அலிஃப் என்பது ஒரு எழுத்து, லாம் என்பது ஒரு எழுத்து ,மீம் என்பது ஒரு எழுத்து ஆகும்\'. <span class="c2">(ஆதாரம் : திர்மிதி)</span>.<span class="c6"><br /> இந்த ஹதீஸிலிருந்து பெறப்படும் சில பயன்கள் :</span><br /> 1- அல்குர்ஆனை ஓதுவதன் சிறப்பு பற்றி இந்த ஹதீஸ் எடுத்துரைக்கிறது.<br /> 2- நீர் ஓதும் ஒவ்வொரு எழுத்திற்கும் உமக்கு பல நன்மைகள் கிடைக்கிறன. </p>',
            ],
        ],
        6 => [
            0 => [
                'question' => 'கேள்வி 1 : அல்லாஹ்வுடன் ஒழுக்கம் பேணி நடந்து கொள்வது எவ்வாறு?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10190.mp3',
                'answer' => '<p> பதில் : 1- அல்லாஹ்வை உரிய முறையில் கண்ணியப்படுத்தல்.<br /> 2- இணையில்லாத அவன் ஒருவனை மாத்திரம் வணங்கி வழிப்படுதல்.<br /> 3- அல்லாஹ்வின் கட்டளைகளை ஏற்று அவனுக்குக்கட்டுபட்டு நடத்தல்.<br /> 4- அல்லாஹ்வுக்கு மாறுசெய்வதை விட்டுவிடுதல்.<br /> 5 – எம்மீது சொரிந்துள்ள கருணை மற்றும் கணக்கிடமுடியாத அவனின் அருள்களுக்காக அவனைப் புகழ்ந்து நன்றி செலுத்துதல்.<br /> 6- அவனின் விதிகளை பொறுமையாக ஏற்று வாழ்தல். </p>',
            ],
            1 => [
                'question' => 'கேள்வி 2 : நபியவர்களுடன் ஒழுக்கம் பேணி நடந்து கொள்வது எவ்வாறு ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10270.mp3',
                'answer' => '<p> பதில் : 1- நபியவர்களை பின்பற்றுவதும் அவர்களை முன்மாதியாரியாக கொள்வதும்.<br /> 2- அவர்களின் கட்டளைகளை ஏற்று கட்டுப்பட்டு நடத்தல்.<br /> 3- அவர்களுக்கு மாறுசெய்யாது இருத்தல்.<br /> 4- அவர்கள் அறிவித்தவற்றை உண்மைப்படுத்தல்.<br /> 5- அவர்களின் ஸுன்னாவுக்கு <span class="c2">(வழிமுறைக்கு)</span> அதிகமாக மார்க்கத்தின் பெயரால் புதிதாக உருவாக்காது இருத்தல்.<br /> 6- எமது உயிர் மற்றும் அனைத்து மனிதர்களை விடவும் அதிகமாக அவர்களை நேசித்தல்.<br /> 7- அவர்களை கண்ணியப்படுத்துவதுடன், அவர்களின் வழிமுறைகளை பின்பற்றி அவற்றின் பால் அழைத்து உதவியாக இருத்தல். </p>',
            ],
            2 => [
                'question' => 'கேள்வி 3 : எவ்வாறு பெற்றோர்களுடன்; ஒழுக்கம் பேணி நடந்து கொள்வது?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10360.mp3',
                'answer' => '<p> பதில் :1- பாவ காரியங்கள் தவிர்ந்த நல்ல காரியங்களில் பெற்றோர்களுக்கு கட்டுப்பட்டு நடந்து கொள்ளல்.<br /> 2- பெற்றோருக்கு பணிவிடை செய்தல்.<br /> 3- பெற்றோருக்கு உதவுதல்.<br /> 4- பெற்றோரின் தேவைகளை நிறைவேற்றுதல்.<br /> 5- பெற்றோருக்காக பிரார்த்தனை செய்தல்.<br /> 6- அவர்களுடன் உறவாடும் போது நல்ல முறையில் உறவாடுதல். மிகச்சாதாரன வார்த்தையாக கருதப்படுகின்ற \'சீ\' என்ற வார்த்தையைக் கூட அவர்களுக்கு பாவிப்பதை தவிர்ந்து கொள்ளுதல்.<br /> 7- பெற்றோருடன் புன்சிரிப்போடு இருப்பதுடன் முகம் சுழித்து கடுகடுப்பாக இருக்கக் கூடாது.<br /> 8- பெற்றோரின் சப்தத்தைவிட எனது சப்தத்தை உயர்த்திப் பேசமாட்டேன், அவர்களின் பேச்சை காது தாழ்த்திக் கேட்பேன், அவர்கள் பேசும் போது அவர்களின் பேச்சுக்கு இடையூறு செய்யாது நடந்து கொள்வேன். அத்துடன் ஒரு போதும் அவர்களின் பெயர் கூறி அவர்களை அழைக்கமாட்டேன், அவர்களை எனது தந்தையே, எனது தாயே என இங்கிதமாக அன்பாக அழைப்பேன்.<br /> 9- எனது பெற்றோர் அறையில் இருக்கும் போது அனுமதிபெற்றே உள்ளே செல்வேன்.<br /> 10- பெற்றோரின் கையையும் தலையையும் முத்தமிடுதல். </p>',
            ],
            3 => [
                'question' => 'கேள்வி 4 : இரத்த உறவுகளுடன் நடந்து கொள்வது எவ்வாறு?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10490.mp3',
                'answer' => '<p> பதில் :1- தனது நெருங்கிய உறவுகளான சகோதரன் சகோதரி, தந்தையின் சகோதர சகோதரிகள், தாயின் சகோதர சகோதரிகள் மற்றும் ஏனைய உறவுகளை சந்திக்கச் செல்லுதல்.<br /> 2- பேச்சிலும் செயலிலும் அவர்களுடன் அழகிய முறையில் நடந்து கொள்வதுடன் அவர்களுக்கு உதவி உபகாரம் புரிதல்.<br /> 3- அவர்களுடன் நல்ல முறையில் நடந்து கொள்ளல் என்பதில் அவர்களுடன் நவீன தொடர்புசாதனங்கள் ஊடாக தொடர்பு கொண்டு, அவர்களின் நிலமைகள் குறித்து விசாரிப்பதும் உள்ளடங்கும். </p>',
            ],
            4 => [
                'question' => 'கேள்வி 5 : எனது இஸ்லாமிய சகோதரர்கள் மற்றும் நண்பர்களுடன் நான் நடந்து கொள்வது எவ்வாறு?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10550.mp3',
                'answer' => '<p> பதில் : 1- நான் <span class="c2">(அவர்களில்)</span> நல்லோர்களை நேசித்து அவர்ககளுடன் தோழமை கொள்வேன்.<br /> 2- அவர்களில் தீயவர்களுடன் தோழமை கொள்வதை விட்டு விலகி நடப்பேன்.<br /> 3- எனது சகோதரர்களுக்கு ஸலாம் கூறுவதுடன் அவர்களை கைலாகு கொடுத்து வரவேற்பேன்.<br /> 4- அவர்கள் நோயுற்றிருந்தால் அவர்களை சுகம் விசாரித்து அவர்களின் சுகத்திற்காக பிரார்த்தனை செய்வேன்.<br /> 5- தும்மியவர் அல்ஹம்துலில்லாஹ் எனக்கூறினால் அதற்கு யர்ஹமுகல்லாஹ் எனப்பதில் கூறுவேன். <span class="c2">(அல்லாஹ்வின் ரஹ்மத் கிடைக்கப்பிரார்திப்பேன்)</span><br /> 6- ஒரு சகோதர முஸ்லிம் அவரை சந்திக்க வருமாறு என்னை அழைத்தால் அவரின் அழைப்பை ஏற்று அதற்கு பதிலளிப்பேன்.<br /> 7- தேவையான அறிவுரைகளை அவருக்கு வழங்குவேன்.<br /> 8- அவர் அநீதி இழைக்கப்பட்டால் அவருக்கு உதவி செய்வதுடன் அந்த அநீதியிலிருந்து அவரைப் பாதுகாப்பேன்.<br /> 10- எனக்கு விரும்புவதை எனது சகோதர முஸ்லிமுக்கும் விரும்புவேன்.<br /> 11- எனது உதவி தேவைப்பட்டால் அவருக்கு உதவுவேன்.<br /> 12- எனது சொல்லாலோ செயலாலோ அவரை காயப்படுத்த மாட்டேன்.<br /> 13- அவரின் இரகசியங்களைப் பாதுகாப்பேன்.<br /> 14- அவரை ஏசவோ அவர் பற்றி புறம் பேசவோ தரக்குறைவாக கருதவோ பொறாமைக்கொள்ளவோ மாட்டேன். அது போல் அவரின் குறைகளை துருவி ஆய்வு செய்யவோ அவருக்கு துரோகம் இழைக்கவோ மாட்டேன். </p>',
            ],
            5 => [
                'question' => 'கேள்வி 6 : அண்டைவீட்டாருடன் நடந்துகொள்ள வேண்டிய ஒழுங்குகள் யாவை ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10710.mp3',
                'answer' => '<p> பதில் :1- சொல்லாலும் செயலாலும் அண்டை வீட்டாருடன் அழகிய முறையில் நடந்து கொள்வேன். எனது உதவி அவருக்கு தேவைப்பட்டால் அவருக்கு உதவிசெய்வேன்.<br /> 2- பெருநாள் மற்றும் திருமணம் அல்லது இது போன்ற மகிழ்சியான சந்தர்ப்பங்களில் அவருக்கு வாழ்த்துவேன்.<br /> 3- அவர் சுகயீனமுற்றிருந்தால் நோய்விசாரிக்கச் செல்வேன். துன்பம் ஏற்பட்டால் அவருக்கு ஆர்தல் கூறுவேன்.<br /> 4- நான் சமைத்த உணவில் எனக்கு முடியுமானதை அவருக்கு வழங்குவேன்.<br /> 5- சொல்லாலோ, செயலாலோ அவர் அசௌகரியப்டும் விதத்தில் நடந்து கொள்ளமாட்டேன்.<br /> 6- மிக சப்தமாக பேசி அவரை தொந்தரவு செய்யமாட்டேன், அத்துடன் அவரின் குறைகளை துருவித்துருவி தேட மாட்டேன், அவரின் விடயத்தில் சகிப்புடன் நடந்து கொள்வேன். </p>',
            ],
            6 => [
                'question' => 'கேள்வி 7 : விருந்தோம்பல் மற்றும் விருந்தாளியின் ஒழுக்கங்கள் யாவை?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10800.mp3',
                'answer' => '<p> பதில் : 1- யார் என்னை விருந்துக்காக அழைக்கிறாரோ அவரின் அழைப்புக்கு பதிலளிப்பேன்.<br /> 2- நான் ஒருவரை சந்திக்க செல்வதாயின் அவரிடம் அனுமதி கேட்பதுடன் அதற்கான நேரத்தையும் கேட்பேன்.<br /> 3- வீட்டினுள் நுழைய முன் அனுமதி கேட்பேன்.<br /> 4- சந்திப்பதற்கான அனுமதி கிடைத்தால் தாமதிக்கமாட்டேன்.<br /> 5- சந்திக்கச் சென்றால் அவ்வீட்டார்களுக்கு அசௌகரியம் கொடுக்காதவாறு எனது பார்வையைத் தாழ்த்திக் கொள்வேன்.<br /> 6- எனது வீட்டிற்கு வரும் விருந்தாளியை இன்முகத்துடன் மிக அழகிய முறையில் மிகச்சிறந்த வரவேற்பு வாசகங்களைப் பயன்படுத்தி வரவேற்பேன்.<br /> 7- விருந்தாளியை மிகவும் அழகான இடத்தில் அமரவைப்பேன்.<br /> 8- உணவு மற்றும் பானம் போன்றவற்றை வழங்கி விருந்தாளியை நல்ல முறையில் கவனிப்பேன். </p>',
            ],
            7 => [
                'question' => 'கேள்வி 8 : நோயின் போதும் நோயாளர்களை சுகம் விசாரிக்கச் செல்லும் போதும் நடந்து கொள்ளவேண்டிய ஒழுக்கங்களை குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10900.mp3',
                'answer' => '<p> பதில் : 1- நான் எனது உடம்பில் வலியை உணரும் வேளை அவ்விடத்தில் எனது வலது கையை வைத்து \'பிஸ்மில்லாஹ்\' என்று மூன்று தடவைகள் கூறிவிட்டு ,<span class="c2">((அஊது பிஇஸ்ஸதில்லாஹி வகுத்ரதிஹீ மின் ஷர்ரி மா அஜிது வஉஹாதிரு)</span>) என்ற துஆவை ஏழு <span class="c2">(7)</span> தடவைகள் ஓதுவேன்.<span class="c6"><br /> பொருள்:</span> அல்லாஹ்வின் கண்ணியத்தையும் அவனது வல்லமையையும் முன்வைத்து, நான் <span class="c2">(தற்போது)</span> உணர்கின்ற தீங்கிலிருந்தும் <span class="c2">(எதிர்காலத்தில் ஏற்பட்டுவிடக் கூடாது என)</span> அஞ்சுகின்ற தீங்கிலிருந்தும் நான் பாதுகாப்புக் கோருகிறேன்.<br /> 2- அல்லாஹ் விதித்ததை திருப்தியோடு ஏற்று அதில் பொறுமையுடன் நடந்து கொள்வேன்.<br /> 3- எனது சகோதரன் நோயாளியாக இருந்தால் அவரை சுகம் விசாரிப்பதற்காக விரைந்து சென்று அவருக்காகப் பிரார்த்திப்பேன். <span class="c2">(நேயாளியான எனது சகோதரருக்கு சிரமம் ஏற்படலாம் என்பதால்)</span> அவரிடம் நீண்ட நேரம் அமர்ந்து கொண்டிருக்கமாட்டேன்.<br /> 4- நோயாளியின் வேண்டுதல் இன்றி அவர் சுகம் பெற ஓதி ஊதுவேன் - ஓதிப்பார்ப்பேன்.<br /> 5- நோயாளிக்கு பொறுமையை கைகொள்ளுமாறும் பிரார்த்தனை செய்யுமாறும் அவரின் சக்திக்கு ஏற்ப தொழுது சுத்தமாக இருக்குமாறும் அவருக்கு உபதேசம் செய்வேன்.<br /> 6-<span class="c6"> நோயாளியைப் பார்க்க செல்பவர் நோயாளிக்கு ஓத வேண்டிய துஆ :</span> <span class="c2">(அஸ்அலுழ்ழாஹல் அழீம் ரப்பல் அர்ஷில் அழீம் அன் யஷ்பியக)</span> என்று 7 தடவைகள் ஓதவேண்டும்.<span class="c6"> துஆவின் பொருள் :</span> மகத்துவமும் மாட்சிமையும் மிக்க அல்லாஹ்விடம் பிரமாண்டமான இறை சிம்மாசனத்தின் அதிபதியிடம் நான் உனக்கு ஆரோக்கியம் வழங்குமாறு வேண்டுகிறேன். </p>',
            ],
            8 => [
                'question' => 'கேள்வி 9 : கல்வி கற்பவர் கடைபிடிக்க வேண்டிய சில ஒழுக்கங்களைக் குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10990.mp3',
                'answer' => '<p> பதில் : 1- அல்லாஹ்வுக்காக கற்கிறேன் என்ற தூய எண்ணம் <span class="c2">(மனத்தூய்மை)</span> இருத்தல் வேண்டும்.<br /> 2- நான் கற்ற அறிவைக்கொண்டு செயற்படுவேன்.<br /> 3- எனக்குக் கற்றுத்தந்த ஆசானை மதித்து நடப்பதுடன் அவர் இருக்கும் போதும் இல்லாத போதும் அவரை கண்ணியப்படுத்துவேன்.<br /> 4- அவருக்கு முன்னால் ஒழுக்கமாக உட்காருவேன்.<br /> 5- ஆசிரியர் கற்றுத் தரும்போது காது தாழ்த்திக் கேட்பேன், அவர் பாடத்தை கற்பிக்கும் வேளை இடையில் அவருக்கு குறுக்கீடு செய்யமாட்டேன்.<br /> 6- ஆசிரியரிடம் கேள்வி கேட்கும் போது ஒழுக்கமாக நடந்து கொள்வேன்.<br /> 7- அவரின் பெயரை கூறி அழைக்க மாட்டேன். </p>',
            ],
            9 => [
                'question' => 'கேள்வி :10 : சபையில் கடைப்பபிடிக்கவேண்டிய ஒழுக்க முறைகள் யாது?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11090.mp3',
                'answer' => '<p> பதில் : 1- சபையோருக்கு <span class="c2">(அவையில் உள்ளோருக்கு)</span> ஸலாம் கூறுவேன்.<br /> 2- சபையில் அமர்வதற்கு எங்கு இடம் கிடைக்கிறதோ அந்த இடத்தில் அமர்ந்து கொள்வேன். எவரையும் அவர் அமர்ந்திருக்கும் இடத்திலிருந்து எழுப்பமாட்டேன். அல்லது இருவருக்கு மத்தியில் உட்கார நாடினால் அவர்கள் இருவரிடமும் அனுமதியில்லாது உட்கார மாட்டேன்.<br /> 3- மற்றவர்களும் அமர வேண்டும் என்பதற்காக நான் உட்காரும்போது மற்றவர்களுக்கும் இடம்விட்டு உட்காருவேன்.<br /> 4- சபையில் நடைபெறும் உரையின் போது குறுக்கிட்டு பேச மாட்டேன்.<br /> 5- சபையிலிருந்து வெளியேற முன் அனுமதி பெற்று, சபையினருக்கு ஸலாம் கூறுவேன்.<br /> 6- சபையின் முடிவில் பின்வரும் கப்பாரதுல் மஜ்லிஸ் துஆவை ஓதுவேன். "ஸுப்ஹானகல்லாஹும்ம வபிஹம்திக அஷ்ஹது அல்லா இலாஹ இல்லா அன்த, அஸ்தஃபிருக வஅதூபு இலைக".<span class="c6"> பொருள் :</span> இறைவா! நீ தூயவன். உன்னைப் புகழ்கிறேன். உண்மையான வணக்கத்திற்குரியவன் உன்னைத் தவிர யாருமில்லை. உன்னிடமே பாவ மன்னிப்புத் தேடுகிறேன். உன்னிடமே மீளுகிறேன். </p>',
            ],
            10 => [
                'question' => 'கேள்வி 11 : தூங்குவதின் ஓழுங்குகள் பற்றி குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11180.mp3',
                'answer' => '<p> பதில்: 1- நேரகாலத்தோடு தூங்குவேன்.<br /> 2- வுழுச் செய்து சுத்தமான நிலையில் உறங்குவேன்.<br /> 3- நான் வயிற்றின் மீது <span class="c2">(குப்புறப்படுத்து)</span> உறங்க மாட்டேன்.<br /> 4- எனது வலப்புறமாக சாய்ந்து உறங்குவேன், வலது கையை வலது கண்ணத்தின் மீது வைத்து உறங்குவேன்.<br /> 5- எனது விரிப்பை உதறிக் கொள்வேன்.<br /> 6- தூங்கும் போது ஓதப்படும் துஆக்கள் மற்றும் திக்ருகளான ஆயதுல் குர்ஸியை ஒரு தடவையும், குல் ஸூறாக்களான ஸூறதுல் இக்லாஸையும் முஅவ்விததான் என்றழைக்கப்படும் ஸூறதுல் பலக் மற்றும் ஸூறதுன்னாஸ் ஆகிய ஸூறாக்களையும் மும்மூன்று தடவைகள் ஓதுவதுடன்,<span class="c6"> பின்வரும் திக்ரையும் ஓதுவேன் :</span> <span class="c2">((பிஸ்மிகல்லாஹும்ம அமூது வஅஹ்யா)</span>) பொருள்: யா அல்லாஹ்! உன்னுடைய பெயரைக் கொண்டே நான் உறங்கி விழித்தெழுகிறேன்.<br /> 7- ஸுப்ஹ் தொழுகைக்காக துயிலெழுவேன்.<br /> 8-<span class="c6"> தூக்கத்திலிருந்து எழுந்ததும் பின்வரும் திக்ரை ஓதுவேன் :</span> <span class="c2">(அல்ஹம்து லில்லாஹில்லதீ அஹ்யானா பஃதமா அமாதனா வஇலைஹின்னுஷூர்)</span> பொருள்: எங்களை மரணிக்கச் செய்த பின் உயிர்பெற்று எழச்செய்த அல்லாஹ்வுக்கே புகழனைத்தும் உரித்தாகட்டும். மேலும் அவனிடமே <span class="c2">(நமது)</span> மீளுதல் உள்ளது. </p>',
            ],
            11 => [
                'question' => 'கேள்வி 12 :உண்ணுதல் பருகுதலின் போது கடைப்பிடிக்க வேண்டிய ஓழுங்கு முறைகள் யாது?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11290.mp3',
                'answer' => '<p> பதில் :<br /> 1- உண்ணும் போதும் பருகும்போதும் அல்லாஹ்வுக்கு கட்டுப்பட்டு வாழ்வதற்கான ஊட்ட சக்தி கிடைக்கவேண்டும் என்று <span class="c2">(நிய்யத்)</span> மனதால் நினைத்துக் கொள்வேன்.<br /> 2- உண்ணுவதற்கு முன்பாக எனது இரு கைகளையும் கழுவிக்கொள்வேன்<br /> 3- \'பிஸ்மில்லாஹ்\' என்று <span class="c2">(அல்லாஹ்வின் திருநாமம்)</span> கூறி எனது வலது கையால் உண்ண ஆரம்பிப்பேன். கூட்டாக சாப்பிடும் போது தட்டில் எனக்கு அருகாமையில் உள்ளதை சாப்பிடுவேன். தட்டின் நடுப்பகுதியிலிருந்தோ அல்லது எனக்கு எதிரில் உள்ளவரின் இடத்திலிருந்து எடுத்து சாப்பிட மாட்டேன்.<br /> 4- \'பிஸ்மில்லாஹ்\' கூற மறந்து விட்டால் \'பிஸ்மில்லாஹி அவ்வலஹு வஆகிரஹு\' என்று கூறிக்கொள்வேன். <span class="c2">(இதன் பொருள் : ஆரம்பத்திலும் இறுதியிலும் அல்லாஹ்வின் பெயரைக்கொண்டு (உணவு உட்கொள்கிறேன்)</span>).<br /> 5- இருக்கும் உணவை திருப்தியுடன் ஏற்றுக்கொள்வேன், உணவை குறைகூற மாட்டேன். விரும்பினால் உண்ணுவேன் விரும்பாது விட்டால் குறைகூறாது விட்டுவிடுவேன்.<br /> 6- அதிகம் சாப்பிடாது எனக்கு போதுமான உணவின் சிறு கவளங்களை மாத்திரம் சாப்பிடுவேன்.<br /> 7- சூடான உணவு அல்லது பாணம் ஆகியவற்றில் சூட்டைத் தனிப்பதற்காக அதில் ஊதமாட்டேன். அதன் சூடு ஆறும் வரை விட்டுவிடுவேன்.<br /> 8- உணவு உட்கொள்ளும் போது எனது குடும்பத்தினர் அல்லது விருந்தாளியுடன் சேர்ந்து உண்ணுவேன்.<br /> 9- என்னை விட வயதில் மூத்தோர் சாப்பிடுவதற்காக என்னுடன் அமர்ந்திருந்தால் அவர்கள் சாப்பிட முன் ஆரம்பிக்கமாட்டேன்.<br /> 10- ஏதாவது ஒரு பானத்தை அருந்தும்போது "பிஸ்மில்லாஹ்" கூறி அமர்ந்த நிலையில், ஒரே மூச்சில் பருகாது மூன்று முறை மூச்சை நிறுத்தி நிறுத்தி அருந்துவேன்.<br /> 11- சாப்பிட்டு -குடித்து– முடிந்ததும் அல்லாஹ்வைப் புகழ்வேன். அதாவது \'அல்ஹம்து லில்லாஹ்\' என்று கூறுவேன். </p>',
            ],
            12 => [
                'question' => 'கேள்வி 13 : ஆடை அணியும்போது கடைப்பிடிக்கவேண்டிய ஒழுங்கு முறைகளை குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11440.mp3',
                'answer' => '<p> பதில்: 1- எனது ஆடையை அணியும் போது அல்லாஹ்வை புகழ்ந்து வலப்பக்கத்திலிருந்து அணிவேன்.<br /> 2- கரண்டைக்குகீழால் நீழும் வகையில் எனது ஆடையை அணிய மாட்டேன்.<br /> 3- பெண் குழந்தைகளின் ஆடைகளை ஆண்குழந்தைகளுக்கோ ஆண்குழந்தைகளின் ஆடைகளை பெண்குழந்தைகளுக்கோ அணிவிக்கலாகாது.<br /> 4- எனது ஆடைகள் பிறமதத்தினருக்குரிய குறிப்பான ஆடைகள் அல்லது நாகரீம் என்ற பெயரில் புதுப்புது ஆடைகளை அணியும் நாகரீமற்றவர்களின் ஆடைகள் போன்றவைகளுக்கு ஒப்பாக ஆடைகள் அணியலாகாது.<br /> 5- ஆடைகளை களையும் போது "பிஸ்மில்லாஹ்" கூறி களைவேன்.<br /> 6- காலணியை அணியும் போது முதலில் வலதையும் களையும் போது இடது காலணியையும் முற்படுத்துவேன். </p>',
            ],
            13 => [
                'question' => 'கேள்வி14 : வாகனத்தில் பிரயாணம் செய்யும் போது கடைப்பிடிக்க வேண்டு ஒழுங்குகளைக் குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11540.mp3',
                'answer' => '<p> பதில் : 1- \'பிஸ்மில்லாஹ், அல்ஹம்துலில்லாஹ்\' என்று வாகனத்தில் ஏறும் போது கூறி அதில் அமர்ந்ததும் பின்வருமாறு கூறுவேன், <span class="c2">(ஸுப்ஹானல்லதீ ஸக்கரலனா ஹாதா வமா குன்னா லஹு முக்ரினீன்)</span> பொருள் : இதன் மீது ஏற சக்தியற்றவர்களாக இருந்த எங்களுக்கு இதனை வசப்படுத்தித் தந்த அல்லாஹ் மிகத்தூயவன் எனத் துதிக்கிறேன். <span class="c2">(வஇன்னா இலா ரப்பினா லமுன்கலிபூன்)</span>.<span class="c6"> பொருள் :</span> நிச்சயமாக நாம் எங்கள் இரட்சகனிடம் திரும்பிச்செல்வோராக உள்ளோம். <span class="c2">(ஸூறதுஸ் ஸுஹ்ருப் : 13,14)</span><br /> 2- நான் ஓரு முஸ்லிமை கடந்து சென்றால் அவருக்கு ஸலாம் கூறுவேன். </p>',
            ],
            14 => [
                'question' => 'கேள்வி 15 : பாதையில் கடைப்பிடிக்க வேண்டிய ஓழுங்குளைக் குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11590.mp3',
                'answer' => '<p> பதில் : 1- பாதையில் நடக்கும் போது அதிவேகமாக நடக்காது பணிவோடு, நடையில் நடு நிலைபேணுவதுடன், பாதையின் வலது பக்கமாக நடந்து செல்வேன்.<br /> 2- பாதையில் செல்லும் போது சந்திக்கின்ற சகோதரர்களுக்கு ஸலாம் கூறுவேன்.<br /> 3- பாதையில் செல்லும் போது எனது பார்வையை தாழ்த்திக் கொள்வேன், எவருக்கும் தொந்தரவாக இடைஞ்சலாக நடந்து கொள்ள மாட்டேன்.<br /> 4- பாதையில் செல்லும் போது நன்மையை ஏவி தீமையை தடுத்தல் எனும் பணியை மேற்கொள்வேன்.<br /> 5- தொந்தரவும் இடைஞ்சலும் தரக்ககூடியவற்றை பாதையிலிருந்து அப்புறப்படுத்துவேன். </p>',
            ],
            15 => [
                'question' => 'கேள்வி 16 : வீட்டினுள் நுழையும் போதும் வெளியே செல்லும் போதும் கடைப்பிக்க வேண்டிய ஒழுங்குகளைக் குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11670.mp3',
                'answer' => '<p> பதில் : 1- வீட்டிலிருந்து வெளியேறும் போது வலது காலை முன்வைத்து வெளியேறுவேன்,<span class="c6"> அப்போது பின்வரும் துஆவை ஓதிக்கொள்வேன் :</span> <span class="c2">(பிஸ்மில்லாஹி தவக்கல்த்து அலல்லாஹ், லா ஹவ்ல வலா குவ்வத இல்லா பில்லாஹ், அல்லாஹும்ம இன்னீ அஊது பிக அன் அழில்ல அவ் உழல்ல, அவ் அஸில்ல அவ் அவ் உஸல்ல, அவ் அழ்லிம அவ் உழ்லம, அவ் அஜ்ஹல அவ் யுஜ்ஹல அலய்ய)</span>.<span class="c6"> இதன் பொருள் :</span> அல்லாஹ்வின் திருப்பெயரால் <span class="c2">(புறப்பட்டுச் செல்கிறேன்)</span>, என் காரியங்களை அல்லாஹ்வின் மீது முழுமையாக ஒப்படைத்து அவன் மீது நம்பிக்கை வைத்து விட்டேன். மேலும், அல்லாஹ்வின் உதவியில்லாமல் எதிலிருந்தும்; தப்பிப்பதற்கான சக்தியோ வல்லமையோ எனக்குக் கிடையாது, யா அல்லாஹ்! நான் வழி தவறிச் செல்வதில் இருந்தும், அல்லது <span class="c2">(பிறரால்)</span> நான் வழிகெடுக்கப்படுவதிலிருந்தும், நான் தவறுசெய்வதை விட்டும் அல்லது <span class="c2">(பிறரால்)</span> நான் தவறுக்கு உட்படுத்தப்படுவதைவிட்டும், நான் பிறருக்கு அநீதி இழைப்பதை விட்டும்; அல்லது <span class="c2">(பிறரால்)</span> நான் அநீதி இழைக்கப்படுவதை விட்டும், நான் அறிவீனமாக நடந்துகொள்வதைவிட்டும் அல்லது <span class="c2">(பிறர்)</span> என்மீது அறிவீனமாக நடந்துகொள்வதை விட்டும் நிச்சயமாக நான் உன்னிடம் பாதுகாவல் தேடுகிறேன். 2-<span class="c6"> வீட்டினுள் நுழையும் வலது காலை வைத்து நுழைவேன் அவ்வேளை பின்வரும் திக்ரை ஓதுவேன் :</span> <span class="c2">(பிஸ்மில்லாஹி வலஜ்னா வபிஸ்மில்லாஹி கரஜ்னா வஅலா ரப்பினா தவக்கல்னா)</span>.<span class="c6"> பொருள் :</span> அல்லாஹ்வின் திருப்பெயர் கொண்டு நுழைந்தோம். அல்லாஹ்வின் திருப்பெயர் கொண்டு வெளியேறினோம்.மேலும் எங்கள் காரியங்களையும் அல்லாஹ்விடம் ஒப்படைத்து அவனின் மீதே நம்பிக்கை வைத்துள்ளோம்.<br /> 3- வீட்டினுள் நுழைய முன் மிஸ்வாக் செய்துகொள்வேன், பின் குடும்பத்தாருக்கு ஸலாம் கூறுவேன். </p>',
            ],
            16 => [
                'question' => 'கேள்வி 17 : இயற்கைத்தேவைகளை நிறைவேற்றும் போது பேண வேண்டிய ஓழுங்குமுறைகளைக் குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11730.mp3',
                'answer' => '<p> பதில் : 1- கழிவறையினுள் நுழையும் போது இடது காலை முன்வைத்து நுழைவேன்.<span class="c6"><br /> கழிவறையினுள் நுழைய முன் பின்வரும் துஆவை ஓதுவேன் :</span> <span class="c2">(பிஸ்மில்லாஹ், அல்லாஹும்ம இன்னீ<br /> அஊது பிக மினல் குப்ஸி வல் கபாஇஸ்)</span> பொருள் : அல்லாஹ்வின் திருப்பெயரால் <span class="c2">(நான் நுழைகிறேன்)</span> யாஅல்லாஹ் ! ஆண் பெண் ஷைத்தான்களை விட்டும் உன்னிடம் பாதுகாவல் தேடுகிறேன்.<br /> 3- அல்லாஹ்வின் திருநாமம் உள்ள பொருட்களை கழிவறையின் உள்ளே எடுத்துச் செல்ல மாட்டேன்.<br /> 4- <span class="c2">(மலசலம் கழிக்கும் போது)</span> இயற்கைத் தேவையை நிறைவேற்றும் போது என்னை மறைத்துக் கொள்வேன்.<br /> 5- கழிவறையில் யாருடனும் கதைக்க மாட்டேன்.<br /> 6- கழிவறையில் மலசலம் கழிக்கும் போது கிப்லாவை முன்னோக்கியோ பின்னோக்கியோ உட்காரமாட்டேன்.<br /> 7- மலசலம் கழித்தபின் சுத்தம் செய்வதற்கு வலக்கரத்தை பயன்படுத்தாது இடக்கரத்தைப் பயன்படுத்துவேன்.<br /> 8- மனிதர்கள் செல்லும் பாதை ஓரங்களிலும், நிழல் தரும் இடங்களிலும் எனது இயற்கைத் தேவையை நிறைவேற்ற மாட்டேன்.<br /> 9- மலசலம் கழித்து சுத்தம் செய்த பின் எனது கையை கழுவிக்கொள்வேன்.<br /> 10- கழிவறையிலிருந்து வெளியே வரும் போது இடது காலை முன்வைத்து \'குப்ரானக\' என்ற திக்ரை ஒதுவேன்.<span class="c6"> பொருள் :</span> யா அல்லாஹ் ! என்னை நீ மன்னிப்பாயாக! </p>',
            ],
            17 => [
                'question' => 'மஸ்ஜிதில் -இறை இல்லத்தில்- கடைப்பிடிக்க வேண்டிய ஓழுங்கு முறைகளைக் குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11860.mp3',
                'answer' => '<p> பதில்: 1-<span class="c6"> பள்ளிக்குள் நுழையும் போது எனது வலது காலை முன்வைத்து பின்வரும் துஆவை ஓதியவனாக உட்செல்வேன் :</span> பிஸ்மில்லாஹி,<span class="c6"> அல்லாஹும்மப்தஹ்லீ அப்வாப ரஹ்மதிக\' பொருள் :</span> அல்லாஹ்வின் திருப்பெயரினால் <span class="c2">(மஸ்ஜிதில் நுழைகிறேன்)</span> யா அல்லாஹ்! உனது அருளின் வாயில்களை எனக்காகத் திறந்துவிடுவாயாக!.<br /> 2- பள்ளிக்குள் நுழைந்ததும் தஹிய்யதுல் மஸ்ஜித் <span class="c2">(பள்ளிக்கான காணிக்கை தொழுகை)</span> இரண்டு ரக்அத்துக்களை தொழாத வரை உட்காரமாட்டேன்.<br /> 3- தொழுவோருக்கு முன் நடந்து செல்ல மாட்டேன். அல்லது காணமல் போன பொருளென்றை தேடுவதற்காக பள்ளியில் அறிவிப்புச் செய்யமாட்டேன். பள்ளியினுள் கொடுக்கல் வாங்கல் போன்ற வியாபார நடவடிககைகளில் ஈடுபட மாட்டேன்.<br /> 4-<span class="c6"> இடது காலை முன்வைத்து பள்ளியிலிருந்து பின்வரும் துஆவை ஓதியவனாக வெளியேறுவேன் :</span> அல்லாஹும்ம இன்னீ அஸ்அலுக மின் பழ்லிக\',<span class="c6"> பொருள்:</span> யா அல்லாஹ்! நிச்சயமாக நான் உனது அருளை வேண்டுகிறேன். </p>',
            ],
            18 => [
                'question' => 'கேள்வி 19 : ஸலாம் கூறுவதன் ஒழுங்குகளைக் குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11930.mp3',
                'answer' => '<p> பதில் :1- நான் ஒரு முஸ்லிமை சந்திக்கும் வேளையில் <span class="c2">(அஸ்ஸலாமு அலைக்கும் வரஹ்மதுல்லாஹி வபரகாதுஹு)</span> என்று கூறுவேன்.<span class="c6"> பொருள் :</span> உங்கள் மீது அல்லாஹ்வின் ஈடேற்றமும்- அவனின் கருணையும் அருள்வளமும் கிட்டட்டுமாக! ஸலாம் அல்லாத வேறு முகமன்களை கூற மாட்டேன். அதே போல் ஸலாத்திற்குப் பதிலாக எனது கையால் மாத்திரம் சைக்கினை செய்யவும் மாட்டேன்.<br /> 2- நான் யாருக்கு ஸலாம் கூறுகிறேனோ அவரின் முகத்தை முகமலர்ச்சியோடு பார்த்து புன்முறுவல் பூப்பேன்.<br /> 3- சந்திப்பவருக்கு வலது கையால் கைலாகு கொடுப்பேன்.<br /> 4- எனக்கொருவர் வாழ்த்துத் தெரிவித்தால் அவருக்கு அதைவிட மிக நல்ல முறையில் வாழ்த்துத் தெரிவிப்பேன், அல்லது அவர் வாழ்த்தியது போன்று வாழ்த்துத்துவேன்.<br /> 5- முஸ்லிம் அல்லாத ஒருவருக்கு ஸலாம் கூறுவதில் முந்திக் கொள்வதை தவிர்ந்து கொள்வேன். அவ்வாறு அவர் ஸலாம் கூறினால் அதே போன்று பதில் கூறுவேன்.<br /> 6- சிறியோர் மூத்தோருக்கும், வாகனத்தில் செல்வோர் நடந்து செல்பருக்கும், நடந்து செல்பவர் உட்கார்ந்து இருப்பவருக்கும், குறைவான எண்ணிக்கையில் இருப்போர் அதிக எண்ணிக்கையில் உள்ளவர்களுக்கும் ஸலாம் கூற வேண்டும். </p>',
            ],
            19 => [
                'question' => 'கேள்வி : 20 :அனுமதி பெறுவதின் ஓழுங்குகள் பற்றி குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12020.mp3',
                'answer' => '<p> பதில் :1- ஒரு இடத்திற்குள் நுழைய முன் நான் அனுமதி கேட்டு நுழைவேன்.<br /> 2- ஒரு இடத்தினுள் நுழைவதற்கு மூன்று தடவைகள் அனுமதி கோருவேன். அதைவிட அதிகரிக்கமாட்டேன். அனுமதி கிடைக்காத பட்சத்தில் திரும்பி விடுவேன்.<br /> 3- அனுமதி கேட்டு கதவை மெதுவாகத் தட்டுவேன். அப்போது கதவுக்கு நேராக நிற்காது கதவின் வலது பக்கத்திலோ அல்லது இடது பக்கத்திலோ நின்று கொள்வேன்.<br /> 4- எனது தாயும் தந்தையும் அல்லது அவர்களில் எவராவது ஒருவர் அறையினுள் இருக்கும் போது அவர்களிடம் அனுமதி பெற முன் அவர்களின் அறையினுள் நுழைய மாட்டேன். குறிப்பாக ஸுப்ஹ் தொழுகைக்கு முன், லுகருக்கு முன்னுள்ள நேரம், இஷாவிற்குப் பின் ஆகிய வேளைகளில் அவர்களிடம் அனுமதி பெற முன் அவர்களின் அறையினுள் நுழைய மாட்டேன்.<br /> 5- குடியமர்த்தப்படாத பொது மருத்துவ நிலையங்கள் வியாபாரஸ்தளங்கள் போன்ற இடங்களில அனுமதியுமின்றி நுழையலாம். </p>',
            ],
            20 => [
                'question' => 'கேள்வி 21 : விலங்கினங்களுடன் பேண வேண்டிய ஓழுக்க முறைகள் பற்றி குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12100.mp3',
                'answer' => '<p> பதில் :1- விலங்கினங்களுக்கு உணவு கொடுத்து நீர் புகட்டுவேன்.<br /> 2- அவைகளுடன் அன்பாகவும் பரிவோடும் நடந்து கொள்வேன். அவைகளின் சக்திக்கு அப்பாற்பட்ட சுமைகளை அவற்றின் மீது சுமத்த மாட்டேன்.<br /> 3- விலங்கினங்களுக்கு அடித்து தொந்தரவு செய்யவோ துன்புறுத்தவோ மாட்டேன். </p>',
            ],
            21 => [
                'question' => 'கேள்வி 22 : விளையாட்டின் போது கடைப்பிடிக்க வேண்டிய ஒழுங்கு முறைகள் பற்றிக் குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12160.mp3',
                'answer' => '<p> பதில் : 1- விளையாடுவதின் மூலம் அல்லாஹ்வுக்கு கட்டுப்பட்டு அவனின் திருப்தியை பெற்றுக்கொள்வதற்கான ஆற்றலை சக்தியை பெற்றுக்கொள்ள வேண்டும் என நிய்யத் வைத்துக் கொள்வேன்.<br /> 2- தொழுகை நேரத்தில் விளையாடமாட்டோம்.<br /> 3- ஆண்பிள்ளைகள் பெண் பிள்ளளைகளுடன் சேர்ந்து விளையாடுதல் கூடாது.<br /> 4- விளையாடும் போது எனது அவ்ரத்தை –கட்டாயம் மறைக்க வேண்டிய பகுதி- மறைக்கும் விளையாட்டு சீருடைகளை அணிந்து கொள்வேன்.<br /> 5- முகத்தை தாக்குதல், வெட்கத்தளங்கள் வெளியே தெரிபடுதல் போன்ற ஹராமான –தடைசெய்யப்பட்ட –விளையாட்டுக்களில் ஈடுபடுவதை தவிர்ந்து கொள்வேன். </p>',
            ],
            22 => [
                'question' => 'கேள்வி 23 : நகைச்சுவையின் போது கடைப்பிடிக்க வேண்டிய சில ஓழுங்கு முறைகள் பற்றிக் குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12240.mp3',
                'answer' => '<p> பதில்: 1- நகைச்சுவையில் உண்மையை கடைப்பிடித்தல், பொய்யானவற்றை தவிர்ந்து கொள்ளல்.<br /> 2- நகைச்சுவை என்பது கேலி செய்தல், கிண்டலடித்தல்,தொந்தரவு செய்தல், மிரட்டல் ஆகியவை அற்றதாக இருக்க வேண்டும்.<br /> 3- எல்லை மீறி அதிகமாக நகைச்சுவையில் ஈடுபடக் கூடாது. </p>',
            ],
            23 => [
                'question' => 'கேள்வி 24 : தும்மலின் ஒழுங்குகள் குறித்து குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12300.mp3',
                'answer' => '<p> பதில் : 1- தும்மும் போது கை அல்லது துணி அல்லது கைக்குட்டையை வைத்து மூகத்தை மூடிக் கொள்ளுதல்.<br /> 2- தும்மியதன் பின் <span class="c2">(அல்ஹம்துலில்லாஹ்)</span>, <span class="c2">(எல்லாப் புகழும் அல்லாஹ்வுக்கே)</span> என்று கூறி அல்லாஹ்வைப் புகழ வேண்டும்.<br /> 3- அதற்கு அதனை கேட்ட சகோதரன் அல்லது நண்பர் <span class="c2">(யர்ஹமுகல்லாஹ்)</span>, <span class="c2">(அல்லாஹ் உனக்கு அருள் புரிவானாக!)</span> என்று கூற வேண்டும்.<br /> அதற்கு தும்மியவர் <span class="c2">(யஹ்தீகுமுல்லாஹு வயுஸ்லிஹு பாலகும்)</span>, <span class="c2">(அல்லாஹ் உங்களுக்கு நேர்வழிகாட்டுவானாக! உங்கள் நிலமைகளை சீராக்குவானாக!)</span> என்று கூற வேண்டும். </p>',
            ],
            24 => [
                'question' => 'கேள்வி 25 :கொட்டாவி விடும் போது பேண வேண்டிய ஒழுங்குகள் எவை?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12360.mp3',
                'answer' => '<p> பதில் : 1- கொட்டாவி வருகின்ற வேலை முடியுமானவரை தடுத்துக் கொள்ள முயற்சி செய்ய வேண்டும்.<br /> 2- \'ஹா\' \'ஹா\' என்று சம்பதமிடக் கூடாது.<br /> 3- கையை வாயில் வைத்து மறைத்துக் கொள்ளல் வேண்டும். </p>',
            ],
            25 => [
                'question' => 'கேள்வி 26 : அல் குர்ஆன் ஓதும் போது கடைப்பிடிக்க வேண்டிய ஓழுங்குகளைக் குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12420.mp3',
                'answer' => '<p> பதில் : 1- அல்குர்ஆனை வுழூச்செய்த பின் சுத்தமான நிலையில் ஓதுதல்.<br /> 2- கண்ணியமாகவும் ஒழுக்கமாகவும் உட்கார்ந்து ஓதுதல்.<br /> 3- அல்குர்ஆனை ஒதுவதற்கு ஆரம்பிக்கும் போது أعوذ بالله من الشيطان الرجيم என்று ஓதி ஷைத்தானைவிட்டும் பாதுகாப்புத் தேடிக் கொள்வேன்.<br /> 4- ஓதிய வசனங்கள் குறித்து சிந்திப்பேன். </p>',
            ],
        ],
        7 => [
            0 => [
                'question' => 'கேள்வி 1- நற்குணங்களின் சிறப்பைக் குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12500.mp3',
                'answer' => '<p> பதில் : நபி ஸல்லல்லாஹு அலைஹிவஸல்லம் கூறினார்கள் : முஃமின்களில் நற்குணங்களில் பரிபூரணம் பெற்றவரே இறை நம்பிக்கையில் பரிபூரணம் பெற்றவராவார்\'. திர்மிதீ மற்றும் அஹ்மத் ஆகியோர் பதிவு செய்துள்ளார்கள். </p>',
            ],
            1 => [
                'question' => 'கேள்வி 2 : நாம் ஏன் இஸ்லாமிய நெறிமுறைகளை கடைபிடிக்க வேண்டும்?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12530.mp3',
                'answer' => '<p> பதில் : 1- அவை அல்லாஹ்வின் நேசத்தைப் பெற்றுக்கொள்ள காரணமாக அமைந்துள்ளமை.<br /> 2- அவை மக்களின் அன்பை பெற்றுக்கொள்ள காரணமாக அமைந்துள்ளமை.<br /> 3- நற்பண்புகள் மீஸானில் மிகக் கணதியானவையாக இருக்கின்றமை.<br /> 4- நற்பண்புகளை கடைபிடித்து ஓழுகுவதால் அதற்குக் கிடைக்கும் கூலியும் வெகுமதியும் பல மடங்காக கிடைக்கின்றமை.<br /> 5- இறை நம்பிக்கையின் பரிபூரணத் தன்மைக்கான அடையளாமாக இருக்கின்றமை. </p>',
            ],
            2 => [
                'question' => 'கேள்வி 3 : பண்பாடுகளை நாம் எவற்றிலிருந்து பெற்றுக் கொள்கிறோம்?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12600.mp3',
                'answer' => '<p> பதில் : நாம் பண்பாடுகளை –நற்குணங்களை- அல்குர்ஆனிலிருந்தும் நபி வழிமுறைகளிலிருந்தும் பெற்றுக்கொள்ள வேண்டும்.<span class="c6"> இது குறித்து அல்லாஹ் பின்வருமாறு பிரஸ்தாபிக்கிறான்:</span> "நிச்சயமாக இந்தக் குர்ஆன் முற்றிலும் நேரான வழியினைக் காண்பிக்கிறது" <span class="c2">(ஸூறதுல் இஸ்ரா : ٩)</span> மேலும் இது குறித்து நபி ஸல்லல்லாஹு அலைஹி வஸல்லம் பின்வருமாறு குறிப்பிடுகிறார்கள் : "நற்குணங்களைப் பூரணப்படுத்தவே நான் அனுப்பப்பட்டுள்ளேன்". <span class="c2">(ஆதாரம் : அஹ்மத்)</span> </p>',
            ],
            3 => [
                'question' => 'கேள்வி: 4 : இஹ்ஸான் என்றால் என்ன? அதன் வடிவங்கள் யாது?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12640.mp3',
                'answer' => '<p> பதில் : இஹ்ஸான் என்பது அதி உயர்பண்பாடாகும். அது ஒரு அடியான் பெற்றிருக்க வேண்டிய அல்லாஹ்வின் தொடர் அவதானம் பற்றிய உணர்வையும், படைப்பினங்களுடன் நல்ல முறையில் நடந்து அவர்களுக்கு நன்மை செய்தல் ஆகியவற்றைக் குறிக்கிறது.<span class="c6"><br /> நபி ஸல்லல்லாஹு அலைஹி வஸல்லம் கூறினார்கள் :</span> "நிச்சயமாக அல்லாஹ் அனைத்து விடயங்களிலும் நல்லமுறையில் நடந்து கொள்ள வேண்டும் என்பதை விதியாக்கியுள்ளான்". <span class="c2">(ஆதாரம் : முஸ்லிம் .)</span><br /> இஹ்ஸான் எனும் பண்பின் வடிவங்கள் சில பின்வருமாறு :<br /> அல்லாஹ்வை வணங்கி வழிபடுதல் என்ற விடயத்தில் இஹ்ஸானைக் கடைப்பிடித்தல் என்பது அவனை வணங்குவதில் இக்லாஸ் எனும் உளத்தூய்மையை கடைப்பிடித்து ஓழுகுவதைக் குறிக்கும்.<br /> சொல்லாலும் செயலாலும் பெற்றோருடன் நல்ல முறையில் நடந்து கொள்வது.<br /> இரத்த உறவுகளுடனும் உறவினர்களுடனும் நல்ல முறையில் நடந்து உபகாரம் செய்தல்.<br /> அண்டை வீட்டாருடன் நல்ல முறையில் நடந்து கொள்ளல்.<br /> அநாதைகள் மற்றும் ஏழைகளுடன் நல்ல முறையில் நடந்து உதவி உபகராரம் செய்தல்.<br /> உம்மோடு மோசமான முறையில் நடந்து கொண்டவருடன் நல்ல முறையில் நடந்து கொள்தல்.<br /> பேசும் போது அழகிய முறையில் பேசுதல்.<br /> தர்க்கம் புரியும் போது அழகிய வழிமுறையைக் கடைப்பிடித்தல்<br /> விலங்கினத்தோடு நல்ல முறையில் நடந்து கொள்தல். </p>',
            ],
            4 => [
                'question' => 'கேள்வி :5 :இஹ்ஸானின் எதிர் பதம் என்ன?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12780.mp3',
                'answer' => '<p> பதில்- அல் இஹ்ஸான் <span class="c2">(நல்ல முறையில் நடந்து கொள்ளல், சிறப்பாகச் செய்தல்)</span> என்பதன் எதிர் பதம் அல் இஸாஆ <span class="c2">(தீங்கிழைத்தல், மோசமாக நடந்து கொள்ளல்)</span> என்பதாகும்.<br /> அவற்றில் பின்வரும் வடிவங்களைக்குறிப்பிட முடியும். அல்லாஹ்வை வணங்கி வழிப்படடும் போது உளத்தூய்மையின்றி வணங்குதல்.<br /> பெற்றோரைத் துன்புறுத்தல்.<br /> உறவைத் துண்டித்தல்.<br /> அயளவருடன் மோசமாக நடந்து கொள்ளுதல்.<br /> ஏழை எளியவருக்கு உபகாரம் செய்யாதிருத்தல், தீய செயல்களில் ஈடுபடுதல் மற்றும தீய வார்த்தைகள் பேசுதல் போன்றன இதில் அடங்குகின்றன. </p>',
            ],
            5 => [
                'question' => 'கேள்வி : 6 : அமானிதத்தின் வகைகள் மற்றும் அதன் வடிவங்கள் யாவை?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12860.mp3',
                'answer' => '<p> பதில் :<br /> பதில் :1- அல்லாஹ்வின் கடமைகளில் அமானிதம் பேணுதல்.<span class="c6"><br /> அதன் வடிவங்கள் :</span> அல்லாஹ் எங்கள் மீது விதித்துள்ள கடமைகளான தொழுகை, ஸகாத், நோன்பு, ஹஜ் போன்றவற்றை அதற்குரிய விதத்தில் நிறைவேற்றுதல் போன்றவை அல்லாஹ்வின் விடயத்தில் அமானிதத்தைக் கடைப்பிடித்தலுக்குரிய வடிவங்களாகும்.<br /> 2-<span class="c6"> படைப்பினங்களின் உரிமைகளில் அமானிதம் பேணுதல் என்பது பின்வரும் விடயங்களைக் குறிக்கிறது :</span><br /> மனிதர்களின் மானங்கள்,<br /> செல்வங்கள்,<br /> உயிர்கள்,<br /> மற்றும் அவர்களின் இரகசியங்கள் ஆகியவற்றைப் பாதுகாப்பதுடன் உன்னிடம் அடைக்களமாக மக்களால் தரப்பட்ட அனைத்தையும் இது குறிக்கிறது.<span class="c6"><br /> அல்லாஹ் வெற்றியாளர்களின் பண்புகளைக் குறிப்பிடுகையில் பின்வருமாறு குறிப்பிடுகிறான் :</span> "மேலும் அவர்கள் தங்களின் அமானிதங்களையும் தமது வாக்குறுதிகளையும் பேணி நடப்பார்கள்". <span class="c2">(முஃமினூன் : 8)</span>. </p>',
            ],
            6 => [
                'question' => 'கேள்வி 7: அமானிதத்திற்கு எதிரானது எவை?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12980.mp3',
                'answer' => '<p> பதில் : கியானா\' துரோகம், மோசடி என்பது அல்லாஹ்வினதும் மக்களினதும் உரிமைகளை வீணடிப்பதாகும்.<span class="c6"><br /> நபி ஸல்லல்லாஹு அலைஹிவஸல்லம் கூறினார்கள் :</span> "முனாபிகின் <span class="c2">(நயவஞ்சகனின்)</span> பண்புகள் மூன்றாகும். என்று குறிப்பிட்டுவிட்டு அவற்றில் ஒன்றாக "நம்பிக்கைவைக்கப்பட்டால் துரோகம் மோசடி செய்வான்" என்று சொன்னார்கள்.<span class="c6"> ஆதராம் :</span> புஹாரி முஸ்லிம். </p>',
            ],
            7 => [
                'question' => 'கேள்வி 8 : உண்மை என்பது யாது?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13020.mp3',
                'answer' => '<p> பதில் : நடைமுறைக்கு ஒத்து போகிறவிதத்திலும் அல்லது ஒரு விடயத்தை உள்ளவாறே எடுத்துக் கூறுதலை குறிக்கிறது.<span class="c6"><br /> அதன் வடிவங்களில் சில :</span><br /> மனிதர்களுடன் பேசும்போது உண்மை பேசுதல்.<br /> ஒரு விடயத்தில் வாக்குக்கொடுத்தால் அதில் உண்மையாக நடந்து கொள்ளல்.<br /> சொல் செயல் அனைத்திலும் உண்மையாக வெளிப்படைத்தன்மையுடன் நடந்து கொள்ளுதல்.<span class="c6"><br /> நபி ஸல்லல்லாஹு அலைஹிவஸல்லம் கூறினார்கள் :</span> "நிச்சயமாக உண்மை பேசுதல் நற்செயலுக்கு வழிகாட்டுகிறது. நற்செயல் சுவர்கம் செல்ல வழிகாட்டுகிறது, ஒரு மனிதன் அவன் உண்மையே பேசிக்கொண்டிருப்பான். இறுதியில் அவன் அல்லாஹ்விடத்தில் உண்மையாளன் என்று எழுதப்படுவான்".<span class="c6"> ஆதராம் :</span> புஹாரி முஸ்லிம். </p>',
            ],
            8 => [
                'question' => 'கேள்வி 9 :உண்மை பேசுதலுக்கு எதிரானது என்ன?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13100.mp3',
                'answer' => '<p> பதில் : பொய் பேசுதல், இது யதார்த்திற்கு முரணானது. அதாவது மக்களிடம் பொய் சொல்வது, காலக்கெடுக்கு மாற்றம் செய்தல், பொய்சாட்சியம் கூறுவது போன்றன இதில் அடங்கும்.<span class="c6"><br /> நபி ஸல்லல்லாஹு அலைஹி வஸல்லம் கூறினார்கள் :</span> "நிச்சயமாக பொய் தீமை செய்ய வழிகாட்டுகிறது. தீமை செய்வது நரகத்திற்கு வழிகாட்டுகிறது. ஒரு மனிதன் பொய்சொல்லிக் கொண்டே இருப்பான். இறுதியில் அவன் மிகப்பெரும் பொய்யன் என்று அல்லாஹ்விடத்தில் எழுதப்படுவான்".<span class="c6"> ஆதராம் :</span> புஹாரி முஸ்லிம்.<span class="c6"> நபி ஸல்லல்லாஹு அலைஹிவஸல்லம் கூறினார்கள் :</span> "நயவஞ்சகனின் பண்பு மூன்றாகும், அவற்றில் ஒன்று அவன் பேசினால் பொய்யுரைப்பான், வாக்களித்தால் மாறு செய்வான்".<span class="c6"> ஆதராம் :</span> புஹாரி முஸ்லிம். </p>',
            ],
            9 => [
                'question' => 'கேள்வி: 10 : பொறுமையின் வகைகளைக் குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13140.mp3',
                'answer' => '<p> பதில் : அல்லாஹ்வுக்கு கட்டுப்படுவதில் பொறுமையைக் கடைப்பிடித்தல்.<br /> பாவம் செய்வதைவிட்டும் மனதை அடக்கி பொறுமை கொள்தல்.<br /> இறைவிதியின் படி நிகழும் துன்பங்களில் பொறுமையாக இருந்து அல்லாஹ்வை எல்லா நிலைகளிலும் புகழ்தல்.<span class="c6"><br /> அல்லாஹ் கூறுகிறான் :</span> "அல்லாஹ் பொறுமையாளர்களை விரும்புகிறான்". <span class="c2">(ஸூறா ஆல இம்ரான் : 146)</span>.<span class="c6"> நபி ஸல்லல்லாஹு அலைஹிவஸல்லம் கூறினார்கள் :</span> "ஓர் இறை விசுவாசியின் காரியங்கள் ஆச்சரியமானவை. அவனது விவகாரம் அனைத்தும் அவனுக்கு நன்மையாக அமைந்துவிடுகிறது. இது ஓர் இறை விசுவாசியைத் தவிர மற்றெவருக்கும் அவ்வாறு அமைவதில்லை. அவனுக்கு மகிழ்ச்சியூட்டும் விடயம் ஏற்பட்டால், அல்லாஹ்வுக்கு நன்றி செலுத்துகிறான். அது அவனுக்கு நன்மையாக அமைகிறது. அவனுக்குத் தீங்கு ஏற்பட்டால் பொறுமை செய்கிறான். அதுவும் அவனுக்கு நன்மையாக அமைகிறது". <span class="c2">(ஆதாரம் : முஸ்லிம் .)</span> </p>',
            ],
            10 => [
                'question' => 'கேள்வி 11: பொறுமைக்கு எதிரானது எது?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13210.mp3',
                'answer' => '<p> பதில்: அல்லாஹ்வுக்கு கட்டுப்பட்டு நடப்பதில் பொறுமையின்மை, மேலும் அல்லாஹ்வுக்கு மாறு செய்வதில் வேகமாக செயற்படுதல், மற்றும் சொல் செயல் மூலம் அல்லாஹ்வின் விதியை வெறுத்து கோபம் கொள்ளுதல் போன்றவற்றைக் குறிக்கிறது.<span class="c6"><br /> இதன் வடிவங்களில் சில :</span><br /> மரணத்தை ஆசை கொள்ளுதல்.<br /> கன்னத்தில் அரைந்து கொள்ளல்.<br /> ஆடையைக் கிழித்தல்.<br /> தலை விரிகோலமாக இருத்தல்.<br /> அழிவு ஏற்பட வேண்டும் என தனக்கு எதிராகப் பிரார்த்தித்தல் போன்றவைகளாகும்.<span class="c6"><br /> நபி ஸல்லல்லாஹு அலைஹிவஸல்லம் கூறினார்கள் :</span> "சோதனையின் தரத்திற்கு ஏற்பவே கூலியும் நிர்ணயிக்கப்பட்டுள்ளது. அல்லாஹ் ஒரு கூட்டத்தை விரும்பினால் அவர்களை சோதிப்பான். அவ்வேளை யார் குறிப்பிட்ட சோதனையை மனத்திருப்தியுடன் ஏற்கிறாரோ அவருக்கு அல்லாஹ்வின் திருப்தி கிடைக்கிறது. யார் கோபம் கொள்கிறாரோ அவருக்கு அல்லாஹ்வின் கோபம் உள்ளது".<span class="c6"> ஆதாரம் :</span> திர்மிதி மற்றும் இப்னு மாஜா. </p>',
            ],
            11 => [
                'question' => 'கேள்வி : பரஸ்பரம் ஒத்துழைப்பாக நடந்து கொள்ளல் (அத்தஆவுன்) எனும் பண்பு குறித்து குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13310.mp3',
                'answer' => '<p> பதில் : மக்கள் தங்களுக்கு மத்தியில் சத்தியம் மற்றும் நன்மையான காரியங்களில் ஒத்துழைத்து நடந்து கொள்வதையே அத்தஆவுன் என்பது குறிக்கிறது.<span class="c6"><br /> ஒத்துழைப்பாக நடந்து கொள்வதின் சில வடிவங்கள் :</span><br /> - உரிமைகளை திருப்பி ஒப்படைப்பதில் பரஸ்பரம் ஒத்துழைத்தல்.<br /> - அநியாயக்காரனின் அநியாத்தைத் தடுப்பதில் பரஸ்பரம் ஒத்துழைத்தல்.<br /> - மக்களின் மற்றும் ஏழைகளின் தேவைகளை நிறைவேற்றுவதில் ஒத்துழைப்பாக நடந்து கொள்ளுதல்.<br /> - நன்மையான எல்லா காரியங்களிலும் பரஸ்பரம் ஓத்துழைத்தல்.<br /> பாவமான காரியம், தொந்தரவு செய்தல் அத்துமீறி நடத்தல் போன்றவற்றில் ஓத்துழைப்பு வழங்காது நடந்து கொள்ளுதல்.<span class="c6"><br /> அல்லாஹ் கூறுகின்றான் :</span> "நன்மை செய்வதிலும் அல்லாஹ்வை அஞ்சி நடப்பதிலும் பரஸ்பரம் உதவியாக இருந்து கொள்ளுங்கள், மேலும் பாவம் செய்வதிலும் வரம்பு மீறுவதிலும் பரஸ்பரம் உதவியாக இருக்காதீர்கள். நிச்சயமாக அல்லாஹ் தண்டிப்பதில் மிகவும் கடுமையானவனாவான்". <span class="c2">(ஸூரா அல்மாஇதா : 2)</span>.<span class="c6"> நபி ஸல்லல்லாஹு அலைஹிவஸல்லம் கூறினார்கள் :</span> "இறை நம்பிக்கையாளர்கள் ஒருவருக்கொருவர் ஒத்துழைக்கும் விடயத்தில் ஒரு கட்டடத்தைப் போன்றோர் ஆவர். கட்டடத்தின் ஒரு பகுதி மற்றைய பகுதிக்கு வழுச்சேர்க்கிறது".<span class="c6"> ஆதராம் :</span> புஹாரி முஸ்லிம்.<span class="c6"> மேலும் நபி ஸல்லல்லாஹு அலைஹிவஸல்லம் கூறினார்கள் :</span> "ஒரு முஸ்லிம் பிற முஸ்லிமுக்கு சகோதரர் ஆவார். அவர் மற்றவருக்கு அநியாயம் செய்யமாட்டார். அவர் மற்றவருக்கு உதவி செய்வதையும் கைவிடமாட்டார். யார் தமது சகோதரனின் தேவையை நிறைவேற்றுவாரோ, அவரின் தேவையை இறைவன் நிறைவேற்றுகிறான். யார் ஒரு முஸ்லிமுடைய கஷ்டத்தை நீக்குவாரோ, அவரின் மறுமைநாளின் கஷ்டங்களை இறைவன் நீக்கிவிடுகின்றான். யார் ஒரு முஸ்லிமுடைய குறையை மறைக்கிறாரோ, அவரின் குறைகளை இறைவன் மறுமைநாளில் மறைத்துவிடுவான்".<span class="c6"> ஆதராம் :</span> புஹாரி முஸ்லிம். </p>',
            ],
            12 => [
                'question' => 'கேள்வி 13 : வெட்கம் எனும் ஒழுக்கப்பண்பின் வகைகள் எவை?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13420.mp3',
                'answer' => '<p> பதில் :1- அல்லாஹ்வின் விடயத்தில் வெட்கம் பேணல் என்பது அல்லாஹ்வுக்கு மாறு செய்யாது இருப்பதாகும்.<br /> 2- மனிதர்களுடன் நடந்து கொள்ளும் விடயத்தில் வெட்கம் பேணல் என்பது அசிங்கமான தரக்குறைவான பேச்சுக்களை பேசுவதை விட்டுவிடுதல் மற்றும் அவ்ரத்தை –வெட்கத்தளங்களை –வெளிக்காட்டுவதை விட்டுவிடுதல் போன்றவைகளைக் குறிக்கும்.<br /> நபி <span class="c2">(ஸல்)</span> கூறுகிறார்கள் : "ஈமான் அறுபது அல்லது எழுபதற்கும் மேற்பட்ட கிளைகளை கொண்டதாகும். அதில் முதன்மையானது "லாஇலாஹ இல்லல்லாஹ்" எனும் ஏகத்துவக் கலிமாவாகும். அதில் தாழ்ந்தது துன்பம் தரும் பொருளை பாதையிலிருந்து அகற்றுவதாகும். வெட்கமும் ஈமானில் ஒரு பகுதியாகும்". <span class="c2">(ஆதாரம் : முஸ்லிம் .)</span> </p>',
            ],
            13 => [
                'question' => 'கேள்வி : கருணை காட்டுதல் எனும் நற்குணத்தின் வடிவங்களைக் குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13470.mp3',
                'answer' => '<p> பதில் : வயதில் மூத்தோருக்கு கருணை காட்டுவதுடன் அவர்களை மதித்து நடந்து கொள்ளுதல்.<br /> சிறியோர் மற்றும் குழந்தைகளுக்கு இரக்கம் காட்டுதல்.<br /> வரியவர் எளியவர் தேவையுடைவர் ஆகியோருக்கு கருணை காட்டல்.<br /> விலங்கினங்களுக்கு துன்பம் இழைக்காது உணவளிப்பதன் மூலம் கருணை காட்டல்.<span class="c6"><br /> இது குறித்து நபி ஸல்லல்லாஹு அலைஹிவஸல்லம் பின்வருமாறு கூறினார்கள் :</span> "முஃமின்கள் தங்களுக்கு மத்தியில் பரஸ்பரம் அன்பு காட்டுவதிலும் பாசத்தோடு நடந்து கொள்வதிலும் பரிவு காட்டுவதிலும் ஒரு உடலைப் போன்றவராய் காண்பீர். அந்த உடம்பில் ஏதாவது ஒரு உறுப்பிற்கு வலி ஏற்பட்டுவிட்டால் ஏனைய உறுப்புகளும் தூக்கமின்மையாலும் கஷ்டத்தாலும் அவதிப்படுகின்றன".<span class="c6"> ஆதராம் :</span> புஹாரி முஸ்லிம். மேலும் நபி <span class="c2">(ஸல்)</span> அவர்கள் கூறினார்கள் : "இரக்கம் காட்டுபவர்களுக்கு ரஹ்மானாகிய அல்லாஹ் இரக்கம் காட்டுவான், பூமியிலுள்ளவர்களுக்கு இரக்கம் காட்டுங்கள், வானிலுள்ளவன் உங்களுக்கு இரக்கம் காட்டுவான்".<span class="c6"> ஆதாரம் :</span> அபு தாவூத், திர்மிதி. </p>',
            ],
            14 => [
                'question' => 'கேள்வி 15 : நேசம் வைத்தலின் வகைகள் எவை?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13550.mp3',
                'answer' => '<p> பதில் : 1- அல்லாஹ்வை நேசித்தல்.<span class="c6"><br /> அல்லாஹ் கூறுகின்றான் :</span> "இறைநம்பிக்கை கொண்டவர்களோ அல்லாஹ்வை அனைவரையும்விட அதிகமாக நேசிக்கிறார்கள்". <span class="c2">(ஸூறதுல் பகரா :165 )</span>.<br /> 2- இறைத்தூதரை நேசித்தல்.<span class="c6"><br /> நபி ஸல்லல்லாஹு அலைஹிவஸல்லம் கூறினார்கள் :</span> "எனது உயிர் எவனது கைவசம் உள்ளதோ அவன் மீது ஆணையாக! உங்களில் ஒருவருக்கு அவரது பெற்றோரையும், அவரது குழந்தையையும் விட நான் மிக்க நேசத்திற்குரியவராக ஆகும் வரை அவர் <span class="c2">(உண்மையான)</span> ஈமான் உள்ளவராக மாட்டார்". <span class="c2">(ஆதாரம் : புஹாரி)</span>.<br /> 3- முஃமின்களை நேசித்தல். அதாவது நீ உனக்கு நன்மையை விரும்புவது போல் அவர்களுக்கும் நன்மையை விரும்புதல்.<span class="c6"><br /> நபி ஸல்லல்லாஹு அலைஹிவஸல்லம் கூறினார்கள் :</span> "தான் விரும்புபவற்றை தனது சகோதரனுக்கும் விரும்பாத வரையில் உங்களில் ஒருவரும் உண்மை விசுவாசியாக மாட்டார்". <span class="c2">(ஆதாரம் : புஹாரி)</span>. </p>',
            ],
            15 => [
                'question' => 'கேள்வி 16 : முகமலர்ச்சி என்றால் என்ன?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13630.mp3',
                'answer' => '<p> பதில் : மனிதர்களை சந்திக்கும் வேளை ஏற்படுகின்ற மகிழ்ச்சி புன்னகை, இரக்கம், சந்தோச வெளிப்பாடு ஆகியவைவைகளால் முகத்தில் தோன்றும் மலர்ந்த நிலையே முகமலர்ச்சி எனக் கூறப்படுகிறது.<br /> அதாவது ஒரு மனிதனை சக மனிதர்களிலிருந்தும் அந்நியப்படுத்தும் விதத்தில் அவர்களுக்கு வெறுப்பேற்படுமாறு முகம் சுளித்து கடுகடுப்பாக இருத்தல் என்ற பண்பிற்கு எதிரானது.<br /> இதன் சிறப்புக் குறித்து பல ஹதீஸ்கள் வந்துள்ளன. அவற்றுள் பின்வருவன முக்கியமானவைகளாகும். அபூதர் அல்கிபாரி ரழியல்லாஹு அன்ஹு அவர்கள் கூறுகிறார்கள்.<span class="c6"> நபிஸல்லல்லாஹு அலைஹி வஸல்லம் என்னிடம் பின்வருமாறு கூறினார்கள் :</span> <span class="c2">(அபூதர்ரே!)</span> நன்மையான காரியங்கள் எதுவாயினும் அவற்றை அற்பமாகக் கருதாதே! அது உனது சகோதரனை இன்முகத்துடன் சந்திப்பதாக இருந்தாலும் சரியே!\'. <span class="c2">(ஆதாரம் : முஸ்லிம் .)</span> மேலும் நபி <span class="c2">(ஸல்)</span> கூறினார்கள் : உனது சகோதரனின் முகத்தைப்பார்த்து புன்னகைப்பதும் உனக்கு தர்மமாகும்\'. <span class="c2">(ஆதாரம் : திர்மிதி)</span>. </p>',
            ],
            16 => [
                'question' => 'கேள்வி 17 : \'\'ஹஸத்\' பொறாமை என்றால் என்ன?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13690.mp3',
                'answer' => '<p> பதில் : பிறரிடம் உள்ள அருள் நீங்கிட வேண்டும் என்று ஆசைவைப்பது, அல்லது பிறரிடம் காணப்படும் அருளை வெறுப்பதே பொறாமையாகும்.<span class="c6"><br /> அல்லாஹ் கூறுகின்றான் :</span> "பொறாமைக்காரன் பொறாமைப்படும்போது ஏற்படுகின்ற தீங்கிலிருந்து <span class="c2">(நான் பாதுகாவல் தேடுகிறேன்)</span>". <span class="c2">(பலக் : 5)</span>.<span class="c6"><br /> நபி ஸல்லல்லாஹு அலைஹிவஸல்லம் கூறியதாக அனஸ் ரழியல்லாஹு அன்ஹு கூறினார்கள் :</span> நீங்கள் ஒருவருக்கொருவர் பகைத்துக் <span class="c2">(கோபித்துக்)</span> கொள்ளாதீர்கள். பொறாமை கொள்ளாதீர்கள். புறக்கணித்து நடக்காதீர்கள். <span class="c2">(மாறாக,)</span> அல்லாஹ்வின் அடியார்களே! <span class="c2">(அன்பு பாராட்டுவதில்)</span> சகோதரர்களாய் இருங்கள்\'. <span class="c2">(ஆதாரம் : புஹாரி, முஸ்லிம்)</span>. </p>',
            ],
            17 => [
                'question' => 'கேள்வி 18 : ஏளனம் என்றால் என்ன?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13740.mp3',
                'answer' => '<p> பதில் : ஏளனம் என்பது உனது சகோதர முஸ்லிமை கேலி செய்வதும் அற்பமாக –தரக்குறைவாக கருதுவதுமாகும். இது தடைசெய்யப்பட்ட ஒரு விடயமாகும்.<span class="c6"><br /> இது தடுக்கப்பட்டது என்ற விடயத்தை அல்லாஹ் பின்வருமாறு குறிப்பிடுகிறான் :</span> "இறைநம்பிக்கையாளர்களே, <span class="c2">(முஃமின்களே!)</span> எந்த ஆண்களும் மற்றெந்த ஆண்களையும் பரிகாசம் செய்ய வேண்டாம். ஒரு வேளை அவர்கள் <span class="c2">(பரிகசிக்கப்படுவோர்)</span>, இவர்களைவிட மேலானவர்களாக இருக்கலாம். எந்தப் பெண்களும் மற்றெந்தப் பெண்களையும் பரிகாசம் செய்ய வேண்டாம். ஒருவேளை அவர்கள் இவர்களைவிடச் சிறந்தவர்களாயிருக்கலாம். நீங்கள் ஒருவரையொருவர் குத்திப் பேசாதீர்கள். ஒருவருக்கொருவர் மோசமான பட்டப் பெயர்களைச் சூட்டி அழைக்காதீர்கள். இறைநம்பிக்கை கொண்டதன் பின்னர் மோசமான பெயர்களைச் சூட்டுவது மிகவும் கெட்ட விஷயமாகும். எவர்கள் இந்த நடத்தையைக் கைவிடவில்லையோ அவர்கள்தாம் கொடுமைக்காரரகள்". <span class="c2">(ஸூறதுல் ஹுஜுராத் :11)</span> </p>',
            ],
            18 => [
                'question' => 'கேள்வி 19 : பணிவு என்பதை வரைவிலக்கப்படுத்துக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13780.mp3',
                'answer' => '<p> பதில் : ஒரு நபர் தான் பிறரை விட மேலானவர் எனக் காட்டிக் கொள்ளாத நிலையே பணிவாகும். எனவே இவ்வாறான ஒருவர் மக்களை தரக்குறைவாக பார்க்கமாட்டான், சத்தியத்தை புறக்கணித்து நடக்கவும்மாட்டான்.<span class="c6"><br /> அல்லாஹ் கூறுகின்றான் :</span> "அர்ரஹ்மானின் <span class="c2">(உண்மையான)</span> அடியார்கள்; எத்தகையவர்களெனில் அவர்கள் பூமியில் பணிவுடன் நடப்பார்கள்". <span class="c2">(ஸூறதுல் புர்கான் : 63)</span>. அதாவது "ஹெளனன்" என்றால் பணிவுள்ளவர்களாக நடப்பார்கள் என்பதாகும். நபி <span class="c2">(ஸல்)</span> கூறுகிறார்கள் : யார் அல்லாஹ்வுக்காக பணிவுடன் நடந்துகொள்கிறாரோ அவரை அல்லாஹ் உயர்த்தி விடுவான்\'. <span class="c2">(ஆதாரம் : முஸ்லிம் .)</span> மேலும் நபி <span class="c2">(ஸல்)</span> கூறுகிறார்கள் : உங்களில் ஒருவர் இன்னொருவர் மீது பெருமையடித்துக் கொள்ளாதிருப்பதற்காகவும் மற்றவர் மீது அத்துமீறி நடக்காது இருப்பதற்காகவும் நீங்கள் பணிவை கடைப்பித்து ஒழுக வேண்டும் என அல்லாஹ் எனக்கு வஹி அறிவித்துள்ளான்\'. <span class="c2">(ஆதாரம் : முஸ்லிம் .)</span> </p>',
            ],
            19 => [
                'question' => 'கேள்வி 20 : தடைசெய்யப்பட்ட பெருமையின் -ஆணவத்தின் வகைகள் எவை?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13840.mp3',
                'answer' => '<p> பதில் : 1- சத்தியத்தியத்தின் மீது ஆணவம் கொள்ளுதல். அதாவது, சத்தியத்தை மறுத்து அதனை ஏற்காமல் இருப்பதாகும்.<br /> 2- மனிதர்களிடத்தில் பெருமையாக நடந்து கொள்ளுதல் என்பது அவர்களை அற்பமாக கருதி அவர்களை இழிபடுத்துவதாகும்.<br /> நபி <span class="c2">(ஸல்)</span> கூறுகிறார்கள் : "எவனுடைய மனதில் அனு அளவு பெருமை இருக்குமோ அவன் சுவர்க்கம் புகமாட்டான்". அப்போது அருகில் இருந்தவர், ஒருவர் தனது ஆடை அழகாக இருக்கவேண்டும்; தமது காலணி அழகாக இருக்கவேண்டும் என விரும்புவது பெருமையாகாதா? என வினவினார்.<span class="c6"> அதற்கு நபியவர்கள :</span> "அல்லாஹ் அழகானவன், அவன்<br /> அழகை விரும்புகிறான். <span class="c2">(இவ்வாறு விரும்புவது பெருமையாகாது)</span> பெருமை என்பது சத்தியத்தை ஏற்க மறுப்பதும், மக்களை இழிவாக நினைப்பதும் ஆகும்". <span class="c2">(ஆதாரம் : முஸ்லிம் .)</span><br /> <span class="c2">(பதருல் ஹக்)</span> என்பது சத்தியத்தை மறுப்பதைக் குறிக்கிறது.<br /> <span class="c2">(கம்துன்னாஸ்)</span> என்பது மனிதர்களை இழிவாகக் கருதுதல் என்பதாகும்.<br /> அழகான ஆடை மற்றும் அழகான காலணி ஆகியன பெருமையில் உள்ளடங்காது. </p>',
            ],
            20 => [
                'question' => 'கேள்வி 21 : ஹறாமாக்கப்பட்ட மோசடியின் (ஏமாற்றின்) சில வகைகளைக் குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13910.mp3',
                'answer' => '<p> பதில் - கொடுக்கல் வாங்கலின் போது பொருட்களின் குறைகளை மறைத்து நுகர்வோருக்கு மோசடி செய்தல்.<br /> - கல்வியை கற்பதில் மோசடி செய்தல் . மாணவர்கள் பரீட்சைகளின் போது மோசடி செய்வது இதற்கான உதாரணம்.<br /> - பேச்சில் மோசடி செய்வது, பொய்சாட்சியம் மற்றும் பொய்யுரைத்தல் போன்றதே.<br /> - மனிதர்களுடன் சேர்ந்து முடிவு செய்து பேசியதை நிறைவேற்றாமையும் மோசடியாகும்.<span class="c6"><br /> மோசடி தடை செய்யப்பட்டுள்ளது பற்றிய ஹதீஸ் பின்வருமாறு :</span> நபி ஸல்லல்லாஹு அலைஹிவஸல்லம் அவர்கள்; உணவு தானியம் விற்பனை செய்யும் ஒரு வியாபாரியை கடந்து சென்றார்கள். தங்களின் கரத்தை தானியக் குவியலுக்குள் நுழைத்தார்கள். உள்ளே ஈரப்பதம் தென்பட்டது. <span class="c2">(தானியச்)</span> சொந்தக்காரரே! இது என்ன ஈரம் எனக் கேட்டபொழுது, யாரசூலல்லாஹ் மழை பொழிந்து நனைந்து விட்டது என்றார்.<span class="c6"> அதற்கு நபிகளார் :</span> மக்கள் பார்த்து வாங்குவதற்காக இந்த உணவை மேலால் வைத்திருக்கலாமே, என்று கூறிவிட்டு யார் மோசடி செய்கிறாரோ அவர் என்னை சார்ந்தவர் அல்ல\' என்று கூறினார்கள். <span class="c2">(ஆதாரம் : முஸ்லிம் .)</span><br /> "அஸ்ஸுப்ரது" என்பது உணவுக் குவியல் என்பதைக் குறிக்கிறது. </p>',
            ],
            21 => [
                'question' => 'கேள்வி 22 : புறம் பேசுதல் என்றால் என்ன?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13990.mp3',
                'answer' => '<p> பதில் - உனது சகோதரன் இல்லாத போது அவனைப்பற்றி அவன் வெறுப்பதைக் கூறுவதாகும்.<span class="c6"><br /> அல்லாஹ் கூறுகின்றான் :</span> "உங்களில் ஒருவர் மற்றவரைப் பற்றி புறம்பேச வேண்டாம். உங்களில் எவரேனும் இறந்து விட்ட சகோதரனின் மாமிசத்தை உண்ண விரும்புவாரா? அதனை நீங்கள் வெறுத்து விடுவீர்கள். மேலும் நீங்கள் அல்லாஹ்வை அஞ்சிக் கொள்ளுங்கள் நிச்சயமாக அல்லாஹ் மிக்க மன்னிப்பவன்,நிகரற்ற அன்புடையோன்". <span class="c2">(ஸூறதுல் ஹுஜுராத் :12)</span> </p>',
            ],
            22 => [
                'question' => 'கேள்வி 22 : கோள் சொல்லுதல் என்றால் என்ன என்பதைக் குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14030.mp3',
                'answer' => '<p> பதில் : மக்களுக்கு மத்தியில் குழப்பத்தை ஏற்படுத்த வேண்டும் என்ற நோக்கில் ஒருவர் பிறர் பற்றி இன்னொருவரிடம் கூறுதல் கோள் ஆகும். <span class="c2">(குழப்பம் விளைவிப்பதற்காக ஒருவர் கூறியதை இன்னொருவரிடம் சொல்வதே கோள் ஆகும்.)</span><br /> நபி <span class="c2">(ஸல்)</span> கூறினார்கள் : கோள் சொல்லுபவன் சுவனம் நுழைய மாட்டான்\'. <span class="c2">(ஆதாரம் : முஸ்லிம் .)</span> </p>',
            ],
            23 => [
                'question' => 'கேள்வி 24 : சோம்பல் என்றால் என்ன?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14070.mp3',
                'answer' => '<p> பதில் : நல்லதைச் செய்வதிலும், ஒருவன் அவசியம் செய்யவேண்டிய விடயங்களில் ஆர்வமற்று மந்த நிலையில் இருத்தல்.<br /> அவ்வாறான விடயங்களில் ஒன்றுதான் கட்டாயக் கடமைகளைச் செய்வதில் சோம்பரித்தனமாக இருத்தல்.<span class="c6"><br /> அல்லாஹ் கூறுகிறான் :</span> "நிச்சயமாக நயவஞ்சகர்கள் அல்லாஹ்வை ஏமாற்றுவதாக நினைக்கின்றனர். அவனோ அவர்களை ஏமாற்றி விடுகின்றான், அவர்கள் தொழுகைக்காக நின்றால் சோம்பேரிகளாகவும் மக்களுக்கு காட்டுவோராகவும் நிற்கின்றனர். அவர்கள் அல்லாஹ்வைக் குறைவாகவே நினைவு கூறுகின்றனர்". <span class="c2">(ஸூறதுன்னிஸா : 142)</span><br /> எனவே ஒரு இறை விசுவாசி <span class="c2">(முஃமின்)</span> சோம்பல், மனச்சோர்வு, மந்தம் ஆகியவற்றைக் கைவிட்டு, இவ்வுலகவாழ்வில் எல்லாம் வல்ல அல்லாஹ்வை திருப்திப்படுத்தும் உழைப்பு, ஈடுபாடு, கடின உழைப்பு, விடா முயற்சி, போன்றவற்றில் தன்னை ஈடுபடுத்திக் கொள்ளுதல் அவசியமாகும். </p>',
            ],
            24 => [
                'question' => 'கேள்வி 25 : கோபத்தின் வகைகளைக் குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14130.mp3',
                'answer' => '<p> பதில் :கோபம் இரண்டு வகைப்படும் அவைகளாவன,<br /> 1- வரவேற்கத்தக்க <span class="c2">(புகழத்தக்க)</span> கோபம் : இது அல்லாஹ்வுக்காக கோபம் கொள்வதாகும். அதாவது இறைநிராகரிப்பாளர்களும் நயவஞ்சகர்களும் ஏனையோரும் அல்லாஹ்வினால் தடைசெய்ய்பட்டவற்றை மதிக்காது நடக்கும் போது அல்லாஹ்வுக்காக கோபம் கொள்வதையே வரவேற்கத்தக்க கோபம் எனப்படும்.<br /> 2-<span class="c6"> கண்டிக்கத்தக்க கோபம் :</span> அதாவது ஒரு மனிதன் தனக்கு அவசியமில்லாத விடயங்களை கூறவும் செய்யவும் தூண்டும் கோபமே கண்டிக்கத்தக்க கோபமாகும்.<span class="c6"><br /> கண்டிக்கத்தக்க கோபத்திற்கான சிகிச்சை முறைகள் :</span><br /> 1- வுழு செய்தல்.<br /> 2- நின்று கொண்டிருந்தால் உட்காருதல். உட்கார்ந்திருந்தால் சாய்ந்து கொள்ளளுதல்.<br /> 3- \'கோபம் கொள்ளாதே\' என்ற நபியவர்களின் அறிவுரையை கடைப்பித்து ஒழுகுதல்.<br /> 4- கோபம் ஏற்படும் போது மனதைக் கட்டுப்படுத்திக்கொள்ளுதல்.<br /> 5- அஊது பில்லாஹி மினஷ்ஷைத்தானிர்ரஜீம் என்று கூறி அல்லாஹ்விடம் பாதுகாப்புத் தேடுதல்.<br /> 6- மௌனமாக இருத்தல். </p>',
            ],
            25 => [
                'question' => 'கேள்வி 26 : உளவு பார்த்தல் என்றால் என்ன?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14240.mp3',
                'answer' => '<p> பதில் : மனிதர்களது தவறுகளையும் அவர்கள் அவசியம் மறைக்க வேண்டியவற்றையும் தேடிக் கண்டறிதல். <span class="c2">(துருவித்துருவி ஆராய்தல்)</span><br /> அதில் தடைசெய்யப்பட்ட சில வடிவங்கள் :<br /> - வீட்டினுள் நடைபெறும் மனிதர்களின் அந்தரங்கங்களை நோட்டமிடுதல்.<br /> - ஒருவர் ஒரு கூட்டத்தினரின் உரையாடலை அவர்களுக்கு தெரியாமல் செவிசாய்ப்பது.<span class="c6"><br /> அல்லாஹ் கூறுகின்றான் :</span> "நீங்கள் <span class="c2">(பிறர் குறைகளை)</span> துப்பறிவதில் ஈடுபடாதீர்கள்". <span class="c2">(ஸூறதுல் ஹுஜுராத் :12)</span> </p>',
            ],
            26 => [
                'question' => 'கேள்வி 27 : ஊதாரித்தனம் (வீண்விரயம்) என்றால் என்ன?; கஞ்சத்தனம் என்றால் என்ன? மற்றும் தயாளகுணம் என்றால் என்ன?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14310.mp3',
                'answer' => '<p> பதில் : ஊதாரித்தனம் <span class="c2">(வீண்விரயம்)</span> என்பது செல்வத்தை முறை கேடாக செலவு செய்தல்.<br /> அதன் எதிர் பதம் கஞ்சத்தனம் ஆகும், அதாவது செல்வத்தை உரியவற்றிற்கு செலவு செய்யாது இருத்தலே கஞ்சத்தனமாகும்.<br /> இதில் சரியான நிலைப்பாடு யாதெனில் இவ்விரண்டுக்கும் மத்தியில் நடு நிலைமை பேணி நடந்து கொள்வதாகும். ஒரு முஸ்லிம் பெருந்தன்மையோடு தயாள குணத்தோடு நடந்து கொள்ள வேண்டும்.<span class="c6"><br /> அல்லாஹ் கூறுகின்றான் :</span> "மேலும் அவர்கள் செலவு செய்தால் வீண் விரயம் செய்யமாட்டார்கள். <span class="c2">(கஞ்சத்தனமாக)</span> குறைக்கவும் மாட்டார்கள், இவற்றுக்கிடையே நடுத்தரத்திலானதாக இருக்கும்". <span class="c2">(ஸூறதுல் புர்கான் : 67)</span> </p>',
            ],
            27 => [
                'question' => 'கேள்வி : கோழைத்தனம் என்றால் என்ன? தைரியம் (வீரம்) என்றால் என்ன?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14370.mp3',
                'answer' => '<p> பதில் : கோளைத்தனம் என்பது பயப்பட தேவையில்லாத விடயங்களுக்கு பயப்படுதல்.<span class="c6"><br /> உதாரணம் :</span> உண்மையை சொல்வதற்கு பயப்படுதல், ஒரு தீமையைத் தடுப்பதற்கு பயப்படுதல்.<br /> தைரியம் <span class="c2">(வீரம்)</span> என்பது சத்தியத்தியத்தை நிலைநாட்டுவதற்கு துணிவு கொள்ளுதல் ,<span class="c6"> உதாரணம் :</span> போரட்டக்களத்தில் இஸ்லாத்தையும் முஸ்லிம்களையும் பாதுகாப்பதற்காக முன்வருதல்.<span class="c6"><br /> நபி ஸல்லல்லாஹு அலைஹி வஸல்லம் அவர்கள் தமது பிரார்தனையில் பின்வருமாறு கூறக்கூடியவர்களாக இருந்தார்கள் :</span> "யா அல்லாஹ் ! கோழைத் தனத்திலிருந்து உன்னிடம் பாதுகாப்புத் தேடுகிறேன்". மேலும் நபி <span class="c2">(ஸல்)</span> கூறுகிறார்கள் : பலசாலியான முஃமின் பலவீனமான முஃமினை விட சிறந்தவனும் அல்லாஹ்வுக்கு மிகவும் விருப்பமானவனுமாவான். மேலும் இருவரிலும் நன்மை உண்டு\'. <span class="c2">(ஆதாரம் : முஸ்லிம் .)</span> </p>',
            ],
            28 => [
                'question' => 'கேள்வி 29 : தடுக்கப்பட்ட வார்த்தைகள் சிலவற்றைக் குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14440.mp3',
                'answer' => '<p> பதில் : - திட்டுதல், ஏசுதல் போன்றன.<br /> - ஒருவரைப் பார்த்து மிருகம் என்றோ அது போன்ற வார்த்தைகளைக் கூறுதல்.<br /> - மனிதர்களின் மானங்களுடன் சம்பந்தப்பட்ட மோசமான அருவருக்கத்தக்க வார்த்தைகளைக் குறிப்பிடுதல்.<br /> இவைகள் அனைத்தையும் நபியவர்கள் தடைசெய்துள்ளார்கள்.<span class="c6"> நபி ஸல்லல்லாஹு அலைஹிவஸல்லம் கூறினார்கள் :</span> ஒரு உண்மை முஃமின் மற்றவர்களை குறை கூறுபவனாகவோ சபிப்பவனாகவோ மானக்கேடான செயல்களை செய்பவனாகவோ அசிங்கமானவற்றைப் பேசுபவனாகவோ இருக்கமாட்டான்\'.<span class="c6"> ஆதாரம் :</span> திர்மிதி, இப்னு ஹிப்பான். </p>',
            ],
            29 => [
                'question' => 'கேள்வி 30 : ஒரு முஸ்லிம் நற்பண்புகளை கடைப்பிடித்து ஒழுகிட துணைசெய்யும் காரணிகளைக் குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14500.mp3',
                'answer' => '<p> பதில் 1 : அல்லாஹ் உனக்கு நற்பண்புளை தந்து அவற்றை கடைப்பிடித்து ஒழுகிட துணைசெய்ய வேண்டும் என்று பிரார்த்தித்தல்.<br /> 2- எப்போதும் அல்லாஹ் தன்னை காண்காணித்து, உன்னை பற்றி அறிந்து உனது எல்லா விவகாரகங்களையும் கேட்டும் பார்த்தும் கொண்டிருக்கிறான் என்ற உணர்வோடு இருத்தல்.<br /> 3- நற்பண்புகளினால் கிடைக்கும் வெகுமதி குறித்து சிந்தித்தல். ஏனெனில் அவை சுவர்க்கத்திற்கு செல்வதற்கான வழிகளில் ஒன்றாகும்.<br /> 4- துர்குணங்களால் கிடைக்கும் தீய முடிவு குறித்து சிந்தித்தல். ஏனெனில் அவை நரகத்திற்கு செல்வதற்கான வழிகளில் ஒன்றாகும்.<br /> 5- நற்குணங்கள் அல்லாஹ்வினதும் மனிதர்களினதும் நேசத்தைப் பெற்றுத்தரவல்லது. தீய குணங்களோ அல்லாஹ்வின் கோபத்தையும் மனிதர்களின் வெறுப்பையும் பெற்றுத்தரவல்லது.<br /> 6- நபியவர்களின் வாழ்க்கை வரலாற்றை வாசித்து அதனை முன்மாதிரியாகக் கொள்ளல்.<br /> 7- நல்லோர்களுடன் தோழமை கொண்டு, தீயவர்களுடன் தோழமை கொள்வதை விட்டும் தவிர்ந்திருத்தல். </p>',
            ],
        ],
        8 => [
            0 => [
                'question' => 'கேள்வி 1: திக்ரின் சிறப்பு என்ன?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14630.mp3',
                'answer' => '<p> நபி ஸல்லல்லாஹு அலைஹி வஸல்லம் கூறினார்கள் : தன் இறைவனை நினைவு கூறுகிற மனிதனுக்கும் மற்றும் தன் இறைவனை நினைவு கூறாத மனிதனுக்கும் உதாரணம் உயிருள்ளவனையும் உயிரற்றவனையும் போன்றதாகும்\'. <span class="c2">(ஆதாரம் : புஹாரி)</span>.<br /> இவ்வாறு நபியவர்கள் வரணித்தமைக்கு காரணம் மனித வாழ்வின் பெறுமானம் அல்லாஹ்வை திக்ர் செய்யும் அளவில்தான் தங்கியுள்ளது என்பதினாலாகும். </p>',
            ],
            1 => [
                'question' => 'கேள்வி 2 : திக்ர் (இறைவனை நினைத்து வாழ்வதால்) செய்வதால் கிடைக்கும் பயன்கள் சிலதைக் குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14670.mp3',
                'answer' => '<p> பதில் :1 – திக்ர் செய்வது அல்லாஹ்வை திருப்திப்படுத்தும்.<br /> 2- ஷைத்தானை துரத்தும்.<br /> 3- தீங்குகளிலிருந்து ஒரு முஸ்லிமுக்கு பாதுகாப்புக் கிடைக்கும்.<br /> 4- திக்ர் செய்வதனால் <span class="c2">(மகத்தான)</span> கூலியும் வெகுமதியும் கிடைக்கும். </p>',
            ],
            2 => [
                'question' => 'கேள்வி 3 : மிகச்சிறந்த திக்ர் எது ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14730.mp3',
                'answer' => '<p> பதில் : \' லாஇலாஹ இல்லல்லாஹ் \' என்ற திக்ராகும். <span class="c2">(உண்மையான வணங்கத்துக்குரியவன் அல்லாஹ்வைத் தவிர வேறு எவருமில்லை)</span> ஆதாரம் : திர்மிதி, இப்னு மாஜா. </p>',
            ],
            3 => [
                'question' => 'கேள்வி 4 : தூக்கத்தை விட்டு எழும்பும்போது என்ன கூறுவாய்?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14760.mp3',
                'answer' => '<p> அல்ஹம்து லில்லாஹில்லதி அஹ்யானா பஃதமா அமாதனா வஇலைஹின்னுஷூர்\'.<span class="c6"> பொருள்:</span> எங்களை மரணிக்கச் செய்த பின் உயிர்பெற்று எழச்செய்த அல்லாஹ்வுக்கே புகழனைத்தும் உரித்தாகட்டும். மேலும் அவனிடமே <span class="c2">(நமது)</span> மீளுதல் உள்ளது.<span class="c6"> ஆதராம் :</span> புஹாரி முஸ்லிம். </p>',
            ],
            4 => [
                'question' => 'கேள்வி 5 : நீ உனது ஆடையை அணியும் போது என்ன கூறுவீர்?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14790.mp3',
                'answer' => '<p> அல்ஹம்து லில்லாஹில்லதி கஸானீ ஹாதஸ்ஸவ்ப வரஸகனீஹி மின் கைரி ஹவ்லின் மின்னீ வலா குவ்வா\'.<span class="c6"> பொருள் :</span> இந்த ஆடையை அணியச் செய்து இதனை எனது எவ்வித ஆற்றலோ சக்தியோ இன்றி வழங்கிய அல்லாஹ்விற்கே எல்லாப்புகழும்.<span class="c6"> ஆதாரம் :</span> அபு தாவூத், திர்மிதி, மற்றும் ஏனைய ஹதீத் கிரந்தங்கள் </p>',
            ],
            5 => [
                'question' => 'கேள்வி : ஆடையை களையும் போது என்ன கூறுவீர் ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14820.mp3',
                'answer' => '<p> பதில் : பிஸ்மில்லாஹ் <span class="c2">(என்று கூறுவேன்)</span>. <span class="c2">(ஆதாரம் : திர்மிதி)</span> . </p>',
            ],
            6 => [
                'question' => 'கேள்வி 7 : புத்தாடை அணியும் போது ஓதும் துஆ எது?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14850.mp3',
                'answer' => '<p> பதில் : \'அல்லாஹும்ம லகல் ஹம்து, அன்த கஸவ்தனீஹி, அஸ்அலுக கைரஹு வகைர மா ஸுனிஅ லஹு, வஅஊது பிக மின் ஷர்ரிஹி வஷர்ரி மா ஸுனிஅ லஹு\'<br /> யா அல்லாஹ்! உனக்கே புகழனைத்தும் உரித்தாகட்டும். நீதான் எனக்கு இதனை அணியத்தந்தாய். இதன் நன்மையையும் இது எந்த நன்மைக்காக தயாரிக்கபட்டதோ அதனையும் நான் உன்னிடம் கேட்கிறேன். மேலும் இதன் தீங்கை விட்டும், இது எத்தீங்குக்காக தயாரிக்கப்பட்டதோ அதன் தீங்கை விட்டும் நான் உன்னிடம் பாதுகாப்புத் தேடுகிறேன்.<span class="c6"> ஆதாரம் :</span> அபு தாவூத், திர்மிதி. </p>',
            ],
            7 => [
                'question' => 'கேள்வி 8 : புத்தாடை அணிந்தவருக்கு ஓதும் துஆ என்ன?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14880.mp3',
                'answer' => '<p> பதில் : புத்தாடை அணிந்த ஒருவரைக் கண்டால் அவருக்காக பின்வருமாறு பிரார்த்திக்கவும் : "துப்லீ வயுஹ்லிபுல்லாஹு தஆலா", <span class="c2">(நீ இதனை பழுதாகும் வரை அணிந்திடுவாய். மேலும் இதற்கு பகரமாக அல்லாஹ் ஆடைகளை உமக்கு வழங்கிடுவானாக.)</span>. <span class="c2">(ஆதாரம் : அபூதாவூத்)</span>. </p>',
            ],
            8 => [
                'question' => 'கேள்வி 9 : கழிவறைக்குள் நுழையும் போது ஓதும் துஆவைக் குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14910.mp3',
                'answer' => '<p> அல்லாஹும்ம இன்னீ அஊதுபிக மினல் குப்ஸி வல் கபாஇஸ்\' பொருள் : யாஅல்லாஹ் ! ஆண் பெண் ஷைத்தான்களை விட்டும் உன்னிடம் பாதுகாவல் தேடுகிறேன்.<span class="c6"> ஆதராம் :</span> புஹாரி முஸ்லிம். </p>',
            ],
            9 => [
                'question' => 'கேள்வி 10 : கழிவறையிலிருந்து வெளியேறும்போது ஓதும் துஆவைக் குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14940.mp3',
                'answer' => '<p> குஃப்ரானக\' என்பதாகும். <span class="c2">(யா அல்லாஹ் ! என்னை நீ மன்னிப்பாயாக)</span>.<span class="c6"> ஆதாரம் :</span> அபு தாவூத், திர்மிதி. </p>',
            ],
            10 => [
                'question' => 'கேள்வி 11 : வுழு செய்ய முன் என்ன கூறுவீர்?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14970.mp3',
                'answer' => '<p> பதில்: பிஸ்மில்லாஹ் <span class="c2">(என்று கூறுவேன்)</span>. இந்த ஹதீஸ் அபூதாவூத் மற்றும் ஏனைய ஹதீஸ் நூல்களில் பதிவு செய்யப்பட்டுள்ளது. </p>',
            ],
            11 => [
                'question' => 'கேள்வி 12 : வுழு செய்து முடிந்ததும் ஓதும் திக்ர் என்ன?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15000.mp3',
                'answer' => '<p> பதில் : <span class="c1">“அஷ்ஹது அல்லாஇலாஹ இல்லல்லாஹு வஹ்தஹூ லா ஷரீக லஹூ, வஅஷ்ஹது அன்ன முஹம்மதன் அப்துஹு வரஸூலுஹு”</span> <span class="c2">(பொருள்: உண்மையான வணக்கத்திற்குரியவன் அல்லாஹ்வைத் தவிர வேறு யாருமில்லை. அவன் தனித்தவன்; அவனுக்கு இணையாளன் யாருமில்லை என்றும்; மேலும் முஹம்மத் ஸல்லல்லாஹு அலைஹிவஸல்லம் அவனின் அடியாரும் துதருமாவார் என்றும் சாட்சி கூறுகிறேன்.<span class="c6"> (ஆதாரம் :</span> முஸ்லிம்.)</span> </p>',
            ],
            12 => [
                'question' => 'கேள்வி 13 : வீட்டிலிருந்து வெளியே செல்லும் போது ஓதும் திக்ர் என்ன?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15020.mp3',
                'answer' => '<p> பதில் : "பிஸ்மில்லாஹி தவக்கல்து அலல்லாஹ், லாஹவ்ல வல குவ்வத இல்லா பில்லாஹ்". <span class="c2">(அல்லாஹ்வின் திருப்பெயரால் (புறப்பட்டுச் செல்கிறேன்)</span> என் காரியங்களை அல்லாஹ்விடம் முழுமையாக ஒப்படைத்து அவன் மீது நம்பிக்கை வைத்து விட்டேன். மேலும், அல்லாஹ்வின் உதவியில்லாமல் எதிலிருந்தும்; தப்பிப்பதற்கான சக்தியோ வல்லமையோ <span class="c2">(எனக்குக்குக்)</span> கிடையாது).<span class="c6"> ஆதாரம் :</span> அபு தாவூத், திர்மிதி. </p>',
            ],
            13 => [
                'question' => 'கேள்வி 14 : வீட்டினுள் நுழையும் போது ஓதும் திக்ர் யாது?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15050.mp3',
                'answer' => '<p> பதில் : \'பிஸ்மில்லாஹி வலஜ்னா வபிஸ்மில்லாஹி கரஜ்னா வஅலல்லாஹி ரப்பினா தவக்கல்னா\' <span class="c2">(அல்லாஹ்வின் திருப்பெயர் கொண்டு நுழைந்தோம் . அல்லாஹ்வின் திருப்பெயர் கொண்டு வெளியேறினோம். மேலும் எங்கள் காரியங்களையும் அல்லாஹ்விடம் ஒப்படைத்து அவனின் மீது நம்பிக்கை வைத்தோம்)</span> எனக் கூறிவிட்டு தனது குடும்பத்தினருக்கு ஸலாம் கூறவேண்டும். <span class="c2">(ஆதாரம் : அபூதாவூத்)</span>. </p>',
            ],
            14 => [
                'question' => 'கேள்வி 15 : பள்ளிவாயிலுக்குள் நுழையும் போது ஓதும் துஆ யாது?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15080.mp3',
                'answer' => '<p> பதில் : \'அல்லாஹும்மப்தஹ்லி அப்வாப ரஹ்மதிக\' <span class="c2">(யா அல்லாஹ்! உனது அருளின் வாயில்களை எனக்காகத் திறந்துவிடுவாயாக!)</span>. <span class="c2">(ஆதாரம் : முஸ்லிம்)</span> </p>',
            ],
            15 => [
                'question' => 'கேள்வி 16 : பள்ளிவாயிலிருந்து வெளியேறும் போது ஓதும் துஆ யாது?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15110.mp3',
                'answer' => '<p> பதில் : \'அல்லாஹும்ம இன்னீ அஸ்அலுக மின் பழ்லிக\'.<span class="c6"> பொருள் :</span> யா அல்லாஹ்! நிச்சயமாக நான் உனது அருளிலிருந்து கேட்கிறேன். </p>',
            ],
            16 => [
                'question' => 'கேள்வி 17 : அதானை -பாங்கு- செவிமடுக்கும் வேளை என்ன கூறுவீர்?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15140.mp3',
                'answer' => '<p> பதில் : முஅஸ்ஸின் கூறுவது போல் நானும் கூறுவேன். அவர் ஹய்ய அலஸ்ஸலாஹ் - ஹய்ய அலல்பலாஹ் - என்று கூறினால் \'லாஹவ்ல வலா குவ்வத இல்லா பில்லாஹ்\' என்று கூறுவேன்.<span class="c6"> ஆதராம் :</span> புஹாரி முஸ்லிம். </p>',
            ],
            17 => [
                'question' => 'கேள்வி : 18 : அதான் கூறி முடிந்ததும் என்ன கூறுவீர்?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15170.mp3',
                'answer' => '<p> பதில் : நபி ஸல்லல்லாஹு அலைஹி வஸல்லம் அவர்கள் மீது ஸலவாத் கூறுவாய். <span class="c2">(ஆதாரம் : முஸ்லிம் .)</span> அல்லாஹம்ம ரப்பஹாதிஹித் தஃவதித் தாம்மஹ், வஸ்ஸலாதில் காஇமா, ஆதி முஹம்மதனில் வஸீலத வல் பழீலத, வப்அஸ்ஹு மகாமன் மஹ்மூதனில்லதீ வஅத்தஹ்\' <span class="c2">(யா அல்லாஹ் ! இந்த முழுமையான அழைப்பிற்கும், நிலையான தொழுகைக்கும் சொந்தக்காரனே! முஹம்மத் ஸல்லல்லாஹு அலைஹி வஸல்லம் அவர்களுக்கு (சொர்க்கத்தின் மிக உயர்ந்த பதவியான)</span> வஸீலா எனும் பதவியினையும், சிறப்பையும் வழங்குவாயாக! நீ அவர்களுக்காக வாக்களித்த புகழப்பட்ட இடத்தில் அவர்களை எழுப்புவாயாக!. <span class="c2">(ஆதாரம் : புஹாரி.)</span><br /> பாங்கிற்கும் இகாமத்திற்கு இடையில் பிரார்தனையில் ஈடுபடு, ஏனெனில் அவ்வேளை கேட்கும் பிரார்த்தனை மறுக்கப்படாது. அல்லாஹ்வால் ஏற்றுக்கொள்ளப்படுகிறது. </p>',
            ],
            18 => [
                'question' => 'கேள்வி 19 : காலை மாலையில் ஓதும் திக்ருகளை எவை?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15220.mp3',
                'answer' => '<p> பதில் : 1 ஆயதுல் குர்ஸி ஒதுதல். "அல்லாஹூ லாஇலாஹ இல்லா ஹூவல் ஹய்யுல் கய்யூம், லா தஃஹுதுஹு ஸினத்துவ்வலா நவ்ம், லஹு மாபிஃஸ் ஸமாவாதி வமாபில் அர்லி, மன்தல்லதி யஷ்பஃஉ இன்தஹு இல்லா பி இத்னிஹி, யஃலமு மாபயின அய்தீஹிம் வமா கல்பஹும், வலா யுஹீதூன பிஷய்இம்மின் இல்மிஹி இல்லா பிமா ஷாஅ, வஸிஅ குர்ஸிய்யுஹுஸ் ஸமாவாதி வல்அர்ல, வலா யஊதுஹு ஹிப்லுஹுமா வஹுவல் அலிய்யுல் அழீம" <span class="c2">(பகரா 2:255)</span>.<span class="c2">(உண்மையாக)</span> வணங்கப்படத் தகுதியானவன் அல்லாஹ்வைத் தவிர வேறு யாரும் இல்லை. அவன் என்றும் உயிருடன் இருப்பவன், நிலைத்திருப்பவன். சிறுதூக்கமோ, உறக்கமோ அவனை ஆட்கொள்ளாது. வானங்களில் உள்ளவையும் பூமியில் உள்ளவையும் அவனுக்கே உரியன. அவனது அனுமதியின்றி அவனிடம் யார்தான் பரிந்துரை செய்யமுடியும்? <span class="c2">(படைப்பினங்களான)</span> அவர்களுக்கு முன் உள்ளவற்றையும் அவர்களுக்குப்பின் உள்ளவற்றையும் அவன் நன்கறிவான். அவன் நாடியவற்றைத் தவிர அவன் அறிந்திருப்பவற்றில் எதையும் அவர்களால் அறியமுடியாது. அவனது குர்ஸி வானங்களையும் பூமியையும் வியாபித்திருக்கின்றது. அவையிரண்டையும் பாதுகாப்பது அவனுக்கு சிரமமன்று. அவன் மிக உயர்ந்தவன்; மிக்க மகத்துவமானவன். <span class="c2">(ஸூறதுல் பகரா :255)</span> 2- பின்வரும் சூறாக்களை ஓதுவீராக. பிஸ்மில்லாஹிர் ரஹ்மானிர் ரஹீம். <span class="c2">(1)</span> "குல் ஹுவல்லாஹு அஹத்" . <span class="c2">(2)</span> "அல்லாஹுஸ்ஸமத்" . <span class="c2">(3)</span> "லம் யலித் வலம் யூலத்" . <span class="c2">(4)</span> "வலம் யகுல்லஹு குகுபுவன் அஹத்" . மூன்று தடவைகள். பிஸ்மில்லாஹிர் ரஹ்மானிர் ரஹீம். <span class="c2">(1)</span> "குல் அஊது பிரப்பில் பலக்". <span class="c2">(2)</span> "மின் ஷர்ரி மா கலக்". <span class="c2">(3)</span> "வமின் ஷர்ரி காசிகின் இதா வகப்". <span class="c2">(4)</span> "வமின் ஷர்ரின் னப்பாஸாதி பில்உகத்". <span class="c2">(5)</span> "வமின் ஷர்ரி ஹாஸிதின் இதா ஹஸத்". மூன்று தடவைகள் பிஸ்மில்லாஹிர் ரஹ்மானிர் ரஹீம். <span class="c2">(1)</span> "குல் அஊது பிரப்பின்னாஸ்". <span class="c2">(2)</span> "மலிகின்னாஸ்". <span class="c2">(3)</span> "இலாஹின்னாஸ்". <span class="c2">(4)</span> "மின் ஷர்ரில் வஸ்வாஸில் கன்னாஸ்". <span class="c2">(5)</span> "அல்லஃதீ யுவஸ்விஸு பீ ஸுதூரின்னாஸ்". <span class="c2">(6)</span> "மினல் ஜின்னதி வன்னாஸ்". மூன்று தடவைகள் 3- \'அல்லாஹும்ம அன்த ரப்பீ லா இலாஹ இல்லா அன்த, கலக்தனீ, வஅன அப்துக, வஅன அலா அஹ்திக வவஃதிக மஸ்தத ஃது, அவூது பிக மின்ஷர்ரி மா ஸனஃது, அஃபூவு லக பினிஃமதிக அலய்ய, வஅபூஃவு பிதன்<span class="c2">(ம்)</span>பீ, ஃபக்ஃபிர்லீ; ஃபஇன்னஹு லா யஃக்ஃபிருத் துனூப இல்லா அன்<span class="c2">(த்)</span>த\'. <span class="c2">(யா அல்லாஹ்! நீயே என் எஜமான். உன்னைத் தவிர உண்மையான வணக்கத்திற்குரியவன் வேறு யாருமில்லை. என்னை நீ அடிமையாகவே படைத்தாய், உனது உடன்படிக்கையின் படியும், வாக்குறுதியின் படியும் என்னால் இயன்ற வரை நடப்பேன். நான் செய்த தீமைகளை விட்டும் பாதுகாவல் தேடுகிறேன். எனக்கு உன்னால் வழங்கப்பட்ட அருள்களை நான் ஏற்றுக் கொள்கிறேன். நான் செய்த குற்றத்தை ஒப்புக்கொள்கிறேன். ஆகவே என்னை மன்னிப்பாயாக! உன்னைத் தவிர யாரும் பாவங்களை மன்னிக்கக் கூடியவன் வேறு யாருமில்லை)</span>. <span class="c2">(ஆதாரம் : புஹாரி)</span>. </p>',
            ],
            19 => [
                'question' => 'கேள்வி 20 : தூங்கும் போது என்ன கூறுவாய் ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15290.mp3',
                'answer' => '<p> பிஸ்மிகல்லாஹும்ம அமூது வஅஹ்யா\'.<span class="c6"> பொருள் :</span> யா அல்லாஹ்! உன்னுடைய பெயரைக் கொண்டே நான் உறங்கி விழித்தெழுகிறேன்.<span class="c6"> ஆதராம் :</span> புஹாரி முஸ்லிம். </p>',
            ],
            20 => [
                'question' => 'கேள்வி 20 : சாப்பிட முன் என்ன கூறுவாய் ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15320.mp3',
                'answer' => '<p> பதில் : \'பிஸ்மில்லாஹ்\' என்று கூறுவேன்.<span class="c6"><br /> ஆரம்பத்தில் பிஸ்மில் கூற மறந்து விட்டால் பின்வருமாறு கூறவும் :</span><br /> பிஸ்மில்லாஹி பீ அவ்வலிஹீ வஆகிரிஹீ\' . <span class="c2">(ஆரம்பத்திலும் இறுதியிலும் அல்லாஹ்வின் திருநாமத்தைக் கூறி உண்ணுகிறேன்)</span>.<span class="c6"> ஆதாரம் :</span> அபு தாவூத், திர்மிதி. </p>',
            ],
            21 => [
                'question' => 'கேள்வி 22 – சாப்பிட்டு முடிந்ததும் என்ன கூறுவாய்?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15370.mp3',
                'answer' => '<p> பதில் : \'அல்ஹம்து லில்லாஹில்லதீ அத்அமனீ ஹாதா வரஸகனீஹி மின் கைரி ஹவ்லின் மின்னீ வலா குவ்வஃ\'. <span class="c2">(எனது எவ்வித சக்தியோ ஆற்றலோ இன்றி எனக்கு இந்த உணவை வழங்கி உண்ணச் செய்த அல்லாஹ்வுக்கே எல்லாப் புகழும்.)</span> ஆதாரம் : அபு தாவூத், இப்னு மாஜா, மற்றும் ஏனைய ஹதீத் கிரந்தங்கள் </p>',
            ],
            22 => [
                'question' => 'கேள்வி 23 : விருந்தாளி விருந்தளித்தவருக்கு ஓதும் துஆ என்ன?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15400.mp3',
                'answer' => '<p> பதில் : \'அல்லாஹும்ம பாரிக் லஹும் ஃபீமா ரஸக்தஹும், வஃக்ஃபிர் லஹும் வர்ஹம்ஹும்\'.<span class="c6"> பொருள் :</span> <span class="c2">(யா அல்லாஹ்! நீ அவர்களுக்கு அளித்தவற்றில் பரகத் (அபிவிருத்தி)</span> செய்வாயாக! மேலும் அவர்களின் குற்றங்களை மன்னித்து, அவர்களுக்கு கிருபை செய்வாயாக!). <span class="c2">(ஆதாரம் : முஸ்லிம் .)</span> </p>',
            ],
            23 => [
                'question' => 'கேள்வி 24: ஒருவர் தும்மினால் கூற வேண்டியவை?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15430.mp3',
                'answer' => '<p> பதில் - தும்மியவர் அல்ஹம்துலில்லாஹ் என்று கூறுவார். <span class="c2">(நிச்சயமாக புகழ் யாவும் அல்லாஹ்வுக்கே சொந்தம்)</span><br /> அதற்கு அவரின் சகோதரர் அல்லது தோழர் யர்ஹமுகல்லாஹ் <span class="c2">(அல்லாஹ் உன்மீது கருனைபொழிவானாக)</span> என்று கூறட்டும்.<br /> அதற்கு தும்மியவர் \'யஹ்தீகுமுல்லாஹு வயுஸ்லிஹு பாலகும்\' <span class="c2">(அல்லாஹ் உங்களுக்கு நேர்வழிகாட்டுவானாக! உங்கள் நிலமைகளை சீராக்குவானாக!)</span> என்று கூற வேண்டும். <span class="c2">(ஆதாரம் : புஹாரி)</span>. </p>',
            ],
            24 => [
                'question' => 'கேள்வி 25 : சபை முடிந்து எழும்போது ஓதும் (கப்பாரதுல் மஜ்லிஸ்) துஆ என்ன?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15480.mp3',
                'answer' => '<p> பதில் : \'ஸுப்ஹானகல்லாஹம்ம வபிஹம்திக அஷ்ஹது அல்லா இலாஹ இல்லா அன்த அஸ்தக்பிருக வஅதூபு இலைக\'.<span class="c6"> இதன் பொருள்:</span> இறைவா! நீ தூயவன். உன்னைப் புகழ்கிறேன். உண்மையான வணக்கத்திற்குரியவன் உன்னைத் தவிர வேறு யாருமில்லை. உன்னிடமே பாவ மன்னிப்புத் கோரி உன்னிடமே மீள்கிறேன்.<span class="c6"> ஆதாரம் :</span> அபு தாவூத், திர்மிதி மற்றும் ஏனைய ஹதீத் கிரந்தங்கள் </p>',
            ],
            25 => [
                'question' => 'கேள்வி 26 : வாகனத்தில் ஏறும் போது ஓதும் துஆ எது?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15510.mp3',
                'answer' => '<p> பதில் : பிஸ்மில்லாஹ், வல்ஹம்துலில்லாஹ் "ஸுப்ஹானல்லதீ ஸக்கர லனா ஹாதா வமா குன்னா லஹூ முக்ரினீன், வஇன்னா இலா ரப்பினா லமுன்கலிபூன்", அல்ஹம்துலில்லாஹ் அல்ஹம்துலில்லாஹ் அல்ஹம்துலில்லாஹ், அல்லாஹு அக்பர் அல்லாஹு அக்பர் அல்லாஹு அக்பர், ஸுப்ஹானகல்லாஹும்ம இன்னி ழலம்து நப்ஸீ பஃபிர்லீ பஇன்னஹு லா யஃபிருத்துனூப இல்லா அன்த.<span class="c6"> பொருள் :</span> \'பிஸ்மில்லாஹ்\'; - அல்லாஹ்வின் திருப்பெயர்கூறி இப்பயணத்தை ஆரம்பிக்கிறேன் \'அல்ஹம்து லில்லாஹ்\' எல்லாப் புகழும் அல்லாஹ்வுக்கே உரியது. இதன் மீது ஏற எவ்விதச் சக்தியுமற்றவர்களாக இருந்த எமக்கு இதனை வசப்படுத்தித் தந்த அல்லாஹ் மிகத்தூயவன் எனத் துதிக்கிறேன். நிச்சயமாக நாம் எங்கள் இரட்சகனிடமே திரும்பிச் செல்லக் கூடியவர்களாக உள்ளோம். <span class="c2">(அல்ஹம்து லில்லாஹ், அல்ஹம்து லில்லாஹ், அல்ஹம்து லில்லாஹ் (எல்லாப் புகழும் அல்லாஹ்வுக்கே)</span>, <span class="c2">(3 தடவை)</span> அல்லாஹு அக்பர் அல்லாஹு அக்பர் அல்லாஹு அக்பர் <span class="c2">(அல்லாஹ் மிகப் பெரியவன்)</span> <span class="c2">( 3 தடவை)</span>. யா அல்லாஹ்! நீ தூயவன்! எனக்கே நான் அநீதி இழைத்து கொண்டேன்! நீ என்னை மன்னித்தருள்வாயாக! ஏனெனில் பாவங்களை மன்னிப்பவன்; உன்னைத் தவிர வேறு யாருமில்லை.<span class="c6"> ஆதாரம் :</span> அபு தாவூத், திர்மிதி. </p>',
            ],
            26 => [
                'question' => 'கேள்வி 27 : பயணத்தின் போது ஓதும் துஆவை குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15540.mp3',
                'answer' => '<p> பதில் :\'அல்லாஹு அக்பர், அல்லாஹு அக்பர், அல்லாஹு அக்பர். "ஸுப்ஹானல்லதீ ஸக்கரலனா ஹாதா வமா குன்னா லஹு முக்ரினீன்.வஇன்னா இலா ரப்பினா லமுன்கலிபூன்". அல்லாஹும்ம இன்னா நஸ்அலுக பீ ஸபரினா ஹாதா அல்பிர்ர வத்தக்வா, வமினல் அமலி மாதர்ழா. அல்லாஹும்ம ஹவ்வின் அலைனா ஸபரனா ஹாதா, வத்வி அன்னா புஃதஹு, அல்லாஹும்ம அன்தஸ் ஸாஹிபு பிஸ்ஸபரி வல் கலீபது பில் அஹ்லி, அல்லாஹும்ம இன்னீ அஊது பிக மின் வஃஸாஇஸ் ஸபர், வகஆபதில் மன்ளரி, வஸூஇல் முன்கலபி பில் மாலி வல் அஹ்லி\'.<span class="c6"> பொருள்:</span> அல்லாஹு அக்பர்: அல்லாஹ் மிகப் பெரியவன் <span class="c2">( 3 தடவை)</span> இதன் மீது ஏற சக்தியற்றவர்களாக இருந்த எங்களுக்கு இதனை வசப்படுத்தித் தந்த அல்லாஹ் மிகத்தூயவன் எனத் துதிக்கிறேன். நிச்சயமாக நாம் எங்கள் இரட்சகனிடம் திரும்பிச்செல்வோராக உள்ளோம். யா அல்லாஹ்! எங்களின் இந்தப் பயணத்தில் நன்மையையும், இறையச்சத்தையும், நீ பொருந்திக் கொள்கின்ற நல்லறத்தையும் உன்னிடம் வேண்டுகிறோம். யா அல்லாஹ்!! எங்களின் இந்தப் பயணத்தை எங்களுக்கு இலகுபடுத்திடுவாயாக! இதன் தொலைவை எங்களுக்குச் குறைத்து விடுவாயாக! <span class="c2">(இதன் தூரத்தை இலகுவாக கடக்கக்கூடியதாக ஆக்கிடுவாயாக!)</span> யா அல்லாஹ்!! நீயே பயணத்தில் தோழனாகவும் எமது குடும்பத்தின் பிரதிநிதியாகவும் இருக்கிறாய். யா அல்லாஹ்! இப்பயணத்தின் சிரமத்திலிருந்தும், மோசமான காட்சிளிலிருலுந்தும், மேலும் செல்வத்திலும் குடும்பத்திலும் தீய விளைவுகள் ஏற்படுவதிலிருந்தும் உன்னிடம் பாதுகாப்புத் தேடுகிறேன்.<span class="c6"><br /> பயணத்திலிருந்து திரும்பி வந்தால் இந்த துஆவுடன் சேர்த்து பின்வரும் துஆவை ஓதவும் :</span><br /> ஆயிபூன, தாயிபூன, ஆபிதூன, லிரப்பினா ஹாமிதூன்\'.<span class="c6"> பொருள் :</span> எங்கள் இறைவனை வணங்கியவர்களாகவும், புகழ்ந்தவர்களாகவும் மன்னிப்புக் கேட்பவர்களாகவும் திரும்புகிறோம். <span class="c2">(ஆதாரம் : முஸ்லிம் .)</span> </p>',
            ],
            27 => [
                'question' => 'கேள்வி 28 : பயணம் செய்பவர் வழியனுப்புவருக்கு ஓதும் துஆ என்ன?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15590.mp3',
                'answer' => '<p> பதில் : \'அஸ்தவ்திஉகுமுல்லாஹல்லதி லா தழீஉ வதாஇஉஹு\'.<span class="c6"> பொருள் :</span> அல்லாஹ்விடம் நான் உங்களை ஒப்படைக்கிறேன். அவனிடம் ஒப்படைக்கப்பட்டவைகள் எதுவும் வீணாகிவிடுவதில்லை.<span class="c6"> ஆதாரம் :</span> அஹ்மத், இப்னு மாஜா. </p>',
            ],
            28 => [
                'question' => 'கேள்வி 29 : பயணம் செல்பவருக்கு வழியனுப்புபவர் ஓதும் துஆ என்ன?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15620.mp3',
                'answer' => '<p> பதில் : \'அஸ்தவ்திஉல்லாஹ தீனக வஅமானதக வகாவதீம அமலிக\'.<span class="c6"> பொருள் :</span> உமது மார்க்த்தையும் உமது அமானிதத்தையும் <span class="c2">(பொறுப்பு மற்றும் கடமை)</span> உமது செயலின் முடிவுகளையும் அல்லாஹ்விடம் ஒப்படைக்கிறேன். <span class="c2">(ஆதாரம் : அஹ்மத், திர்மிதி.)</span>. </p>',
            ],
            29 => [
                'question' => 'கேள்வி 30 : கடைத்தெருவில் (சந்தைக்குள்); நுழையும் போது ஓதும் துஆ என்ன?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15650.mp3',
                'answer' => '<p> பதில் : \'லா இலாஹ இல்லல்லாஹு வஹ்தஹு லா ஷரீக லஹு லஹுல் முல்கு வலஹூல் ஹம்து, யுஹ்யீ வயுமீது, வஹுவ ஹய்யுன் லா யமூது, பியதிஹில் கைர், வஹுவ அலா குல்லி ஷைய்இன் கதீர்\'.<span class="c6"> பொருள் :</span> உண்மையான வணக்கத்திற்குரிய இறைவன் அல்லாஹ்வைத் தவிர வேறுயாருமில்லை, அவன் தனித்தவன்; அவனுக்கு எந்த இணையாளருமில்லை. ஆட்சியதிகாரமும் அனைத்துப் புகழும் அவனுக்கே உரியன. அவனே உயிரளித்து மரணிக்கவும் செய்கிறான், அவன் மரணிக்காத நித்திய ஜீவன், அவன் கைவசமே எல்லா பாக்கியமும் நிறைந்திருக்கிறது, மேலும் அவன் எல்லாவற்றின்மீதும் பேராற்றல் உடையவன்.<span class="c6"> ஆதாரம் :</span> திர்மிதி, இப்னு மாஜா. </p>',
            ],
            30 => [
                'question' => 'கேள்வி 31 : கோபத்தின் போது ஓதும் துஆவை குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15680.mp3',
                'answer' => '<p> பதில் : \'அஊது பில்லாஹி மினஷ்ஷைத்தானிர் ரஜீம்\' என ஓதுவார்.<span class="c6"> பொருள் :</span> சபிக்கப்பட்ட ஷைத்தானை விட்டும் அல்லாஹ்விடம் பாதுகாவல் தேடுகின்றேன்.<span class="c6"> ஆதராம் :</span> புஹாரி முஸ்லிம். </p>',
            ],
            31 => [
                'question' => 'கேள்வி 32 : உனக்கு உதவி உபகாரம் புரிந்தவருக்கு என்ன கூறுவாய்?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15710.mp3',
                'answer' => '<p> பதில் : \'ஜஸாகல்லாஹு கைரா\' என்று கூறுவேன்.<span class="c6"> பொருள் :</span> அல்லாஹ் உங்களுக்கு கூலி தருவானாக. <span class="c2">(ஆதாரம் : திர்மிதி)</span> . </p>',
            ],
            32 => [
                'question' => 'கேள்வி : பயணம் செய்யும் வாகனம் ஆபத்தில் சிக்கிவிட்டால் ஓதும் துஆ (வாகனம் பழுதடைந்து விட்டால் ஓதும் துஆ) என்ன?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15740.mp3',
                'answer' => '<p> பதில் : பிஸ்மில்லாஹ் <span class="c2">(என்று கூறுவேன்)</span> <span class="c2">(ஆதாரம் : அபூதாவூத்)</span>. </p>',
            ],
            33 => [
                'question' => 'கேள்வி 34 : உமக்கு மகிழ்ச்சியூட்டும் ஒரு செய்தி கிடைத்துவிட்டால் நீ என்ன கூறுவாய்?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15770.mp3',
                'answer' => '<p> பதில் : \'அல்ஹம்துலில்லாஹில்லதீ பிநிஃமதிஹீ ததிம்முஸ் ஸாலிஹாத்\'.<span class="c6"> பொருள் :</span> எல்லாப் புகழும் அல்லாஹ்வுக்கே உரியது !அவனது அருளினாலேயே நற்செயல்கள் யாவும் முழுமை பெறுகின்றன!\'. <span class="c2">(ஹாகிமும் ஏனையோரும் இதனை அறிவித்துள்ளனர்.)</span> </p>',
            ],
            34 => [
                'question' => 'கேள்வி 35 : மகிழ்சியற்ற செய்தி கிடைக்கும் போது என்ன கூறுவாய்?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15800.mp3',
                'answer' => '<p> பதில் : \'அல்ஹம்துலில்லாஹி அலா குல்லி ஹால்\'.<span class="c6"> பொருள் :</span> எல்லா நிலையிலும் அல்லாஹ்வைப் போற்றுகிறேன்!. <span class="c2">(ஆதாரம் : ஸஹீஹுல் ஜாமிஃ)</span>. </p>',
            ],
            35 => [
                'question' => 'கேள்வி : 36 : ஸலாம் கூறும் முறையும் அதற்கு பதில் கூறும் முறையும் யாது?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15830.mp3',
                'answer' => '<p> பதில் : ஒரு முஸ்லிம் \'அஸ்ஸலாமு அலைக்கும் வரஹ்மதுல்லாஹி வபராகாதுஹு\' என்று கூறுவார். <span class="c2">(உங்கள் மீது அல்லாஹ்வின் சாந்தியும், அருளும் அருள்வளமும் உண்டாகட்டும்)</span>.<br /> அதற்கு பதிலாக தனது சகோதரன் "வஅலைக்குமு ஸ்ஸலாம் வரஹ்மதுல்லாஹி வபராகாதுஹு" என்று கூறுவார். <span class="c2">(உங்கள் மீதும் சாந்தியும் அவனது அருளும் அவனது அருள்வளமும் உண்டாகட்டும்)</span>. <span class="c2">(ஆதாரம் : அபூதாவூத், திர்மிதி)</span>. </p>',
            ],
            36 => [
                'question' => 'கேள்வி 37 :மழை பொழியும் போது ஓதும் துஆ என்ன?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15870.mp3',
                'answer' => '<p> பதில் : \'அல்லாஹும்ம ஸய்யிபன் நாபிஆ\'. <span class="c2">(யா அல்லாஹ்! பயனளிக்கும் மழையைப் பொழியச் செய்வாயாக!)</span>. <span class="c2">(ஆதாரம் : புஹாரி.)</span> </p>',
            ],
            37 => [
                'question' => 'கேள்வி : மழை பெய்த பின் ஓதும் துஆ என்ன?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15900.mp3',
                'answer' => '<p> பதில் : \'முதிர்னா பிபழ்லில்லாஹி வரஹ்மதிஹி\'. <span class="c2">(அல்லாஹ்வின் அருளினாலும், அவனது கிருபையினாலும் எமக்கு மழை கிடைத்தது)</span>.<span class="c6"> ஆதாரம் :</span> புஹாரி முஸ்லிம். </p>',
            ],
            38 => [
                'question' => 'கேள்வி 39 : (வேகமாக) காற்றடிக்கும் போது ஓதும் துஆவைக் குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15930.mp3',
                'answer' => '<p> பதில் : \'அல்லாஹும்ம இன்னீ அஸ்அலுக கைரஹா வஅஊதுபிக மின் ஷர்ரிஹா\'.<span class="c6"> பொருள் :</span> யா அல்லாஹ்! இந்தக் காற்றின் நன்மையை நான் உன்னிடம் கோருகிறேன். மேலும் இதன் தீமையை விட்டு உன்னிடம் பாதுகாவல் தேடுகிறேன்.<span class="c6"> ஆதாரம் :</span> அபூதாவூத், இப்னுமாஜா. </p>',
            ],
            39 => [
                'question' => 'கேள்வி 40: இடி முழக்கத்தைக் கேட்கும் போது ஓதும் துஆவைக் குறிப்பிடுக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15960.mp3',
                'answer' => '<p> பதில் : \'ஸுப்ஹானல்லதீ யுஸப்பிஹுர் ரஃது பிஹம்திஹீ வல்மலாஇகது மின் கீபதிஹீ\'.<span class="c6"> பொருள்:</span> எவனது புகழைக்கொண்டு இடி துதிக்கின்றதோ, எவனைப் பயந்து வானவர்கள் துதி செய்து புகழ்கின்றார்களோ அத்தகைய அல்லாஹ்வை நான் துதிக்கிறேன்.<span class="c6"> ஆதாரம் :</span> முஅத்தா மாலிக். </p>',
            ],
            40 => [
                'question' => 'கேள்வி :41 :(நோய் மற்றும் அங்கவீனம் போன்றவற்றால்) சோதனைக்குள்ளாக்கப்ட்டவரை கண்டால் ஓத வேண்டிய துஆ என்ன?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15990.mp3',
                'answer' => '<p> பதில் : \'அல்ஹம்து லில்லாஹில்லதீ ஆபானி மிம்மப்தலாக பிஹி வபழ்ழனீ அலா கஸீரின் மிம்மன் கலக தப்ழீலா\'. <span class="c2">(எதனைக் கொண்டு உன்னைச் சோதித்தானோ அதிலிருந்து எனக்கு அல்லாஹ் ஆரோக்கியமளித்து, அவன் படைத்த பெரும்பாலான படைப்புகளை விட என்னை சிறப்பாக்கி வைத்த அவனுக்கே எல்லாப் புகழும்)</span>. <span class="c2">(ஆதாரம் : திர்மிதி)</span> . </p>',
            ],
            41 => [
                'question' => 'கேள்வி 42 : தனது பார்வையால் ஏதும் நிகழ்ந்து விடும் என்று பயந்தவருக்கு ஓதும் துஆ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16020.mp3',
                'answer' => '<p> பதில் : ஹதீஸில் பின்வருமாறு இடம்பெற்றுள்ளது \'உங்களில் ஒருவர் தனது சகோதரனில் அல்லது தன்னில் அல்லது தனது செல்வத்தில் ஆச்சரியப்படத்தக்க விடயங்களை கண்டால் அருள்வளம் கிட்ட வேண்டும் என பிரார்த்தனை செய்யுங்கள்; ஏனென்றால் கண்ணேறு உண்மையானது\'.<span class="c6"> ஆதாரம் :</span> அஹ்மத், இப்னு மாஜா. </p>',
            ],
            42 => [
                'question' => 'கேள்வி 43 : நபியவர்கள் மீது ஸலவாத் சொல்வது எப்படி?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16050.mp3',
                'answer' => '<p> பதில் : \'அல்லாஹும்ம ஸல்லி அலா முஹம்மதின் வஅலா ஆலி முஹம்மதின், கமா ஸல்லைத அலா இப்ராஹீம வஅலா ஆலி இப்ராஹீம இன்னக ஹமீதும் மஜீத். அல்லாஹும்ம பாரிக் அலா முஹம்மதின் வஅலா ஆலி முஹம்மதின், கமா பாரக்த அலா இப்ராஹீம வஅலா ஆலி இப்ராஹீம இன்னக ஹமீதும் மஜீத். <span class="c2">(யா அல்லாஹ்! இப்ராஹீம் (அலைஹிஸ்ஸலாம்)</span> அவர்கள் மீதும், அன்னார் குடும்பத்தினர் மீதும் அருள் புரிந்தது போல்,முஹம்மத் ஸல்லல்லாஹு அலைஹி வஸல்லம் அவர்கள் மீதும் அவர்கள் குடும்பத்தவர் மீதும் அருள்புரிவாயாக. நீயே புகழுக்குரியவன் கீர்த்திமிக்கவன். யா அல்லாஹ்! நீ இப்ராஹீம் <span class="c2">(அலைஹிஸ்ஸலாம்)</span> மீதும், அவரின் குடும்பத்தார் மீதும் உன் அருள்வளத்தையும், செழிப்பையும் அள்ளிப் பொழிந்தது போல் முஹம்மது ஸல்லல்லாஹு அலைஹி வஸல்லம் அவர்கள் மீதும் அவர்களின் குடும்பத்தார் மீதும் உன் அருள்வளத்தையும செழிப்பையும் பொழிவாயாக ! நீயே புகழுக்குரியவன் கீர்த்திமிக்கவன்).<span class="c6"> ஆதராம் :</span> புஹாரி முஸ்லிம். </p>',
            ],
        ],
        9 => [
            0 => [
                'question' => 'கேள்வி : அல்லாஹ்வினால் அடியார்களுக்கு விதிக்கப்பட்டுள்ள கட்டளைகளில் காணப்படும் ஜந்து சட்ட நிலைகள் யாவை ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16090.mp3',
                'answer' => '<p> பதில் :<br /> 1- வாஜிப் <span class="c2">(கட்டாயக் கடமை)</span>.<br /> 2- முஸ்தஹப் <span class="c2">(விரும்பத்தக்கவை)</span>.<br /> 3- <span class="c2">(முஹர்ரம்)</span> கட்டாயம் தவிர்ந்து கொள்ள வேண்டியவை.<br /> 4- <span class="c2">(மக்ரூஹ்)</span> வெறுக்கத்தக்கவை.<br /> 5- முபாஹ் <span class="c2">(ஆகுமானவை)</span>. </p>',
            ],
            1 => [
                'question' => 'கேள்வி : மேலே குறிப்பிடப்பட்ட ஐந்து சட்ட நிலைகளையும் விவரிக்குக?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16170.mp3',
                'answer' => '<p> பதில் :<br /> 1- வாஜிப் கட்டாயம் செய்யவேண்டியவை என்பதற்கு உதாரணங்கள் ஜவேளைத் தொழுகை, ரமழானில் நோன்பு நோற்றல், பெற்றோருக்கு உபகாரம் செய்தல் போன்றவைகளாகும்.<br /> வாஜிப் என்பது செய்தவருக்கு நற்கூலியும் செய்யாதவருக்கு தண்டனையும் வழங்கப்படுகின்ற இறை கட்டளையை குறிக்கும்.<br /> 2- முஸ்தஹப் விரும்பத்தக்கது என்ற சட்ட நிலைக்கான உதாரணம், பர்ழான தொழுகையின் முன் பின் ஸுன்னத்துக்கள், கியாமுல்லைல் தொழுகை, உணவளித்தல், ஸலாம் கூறுதல் போன்றனவாகும். முஸ்தஹப் என்பது ஸுன்னத் அல்லது மன்தூப் என்ற பெயராலும் அழைக்கப்படுகிறது.<br /> முஸ்தஹப் <span class="c2">(விரும்பத்தக்கது)</span> என்பது செய்தவருக்கு நற்கூலி வழங்கப்படுவதுடன் செய்யாதிருந்தவருக்கு தண்டனையேதும் வழங்கப்படாத இறை கட்டளைகளாகும்.<span class="c6"><br /> முக்கிய குறிப்பு :</span><br /> ஒரு முஸ்லிமைப் பொருத்தவரை ஓரு விடயம் ஸுன்னா அல்லது முஸ்தஹப்பான செயல் என்று கேள்விப்பட்டால் அதனை நபியவர்களை பின்பற்றிச் செய்யவதற்கு விரைய வேண்டும். <span class="c2">(இது சுன்னாதானே என பொடுபோக்காக இருத்தலாகாது. அவ்வாறு இருந்தால் காலப்போக்கில் அவர் கட்டாயக்கடமைகளையும் படிப்படியாக விட்டுவிடுகின்ற நிலை ஏற்படலாம்.)</span><br /> 3-<span class="c6"> \'அல் முஹர்ரம்\'; முற்றாக தடுக்கப்பட்டது என்பதற்கான உதாரணம் :</span> மது அருந்துதல், பெற்றோரை துன்புறுத்தல் , உறவுகளை துண்டித்து நடத்தல் போன்றவைகள்.<br /> அல் முஹர்ரம்\' குறிப்பிட்ட தடுக்கப்பட்ட விடயத்தை செய்யாதிருந்தால் மறுமையில் அதற்கான நற்கூலியும் அதனைச் செய்தால் தண்டனையும் கிடைக்கும்.<br /> 4-<span class="c6"> \'அல் மக்ரூஹ்\' வெறுக்கத்தக்கவற்றிற்கு உதாரணம் :</span> இடது கையால் ஒரு பொருளை எடுப்பதும் கொடுப்பதும் , தொழுகையில் ஆடையை மடித்துக் கொள்வது போன்றவைகளாகும்.<br /> <span class="c2">(அல் மக்ரூஹ்)</span> என்பது குறிப்பிட்ட செயலை செய்யாதிருந்தால் மறுமையில் நற்கூலி கிடைப்பதுடன் அதனை செய்வதால் தண்டனை வழங்கப்படமாட்டாது.<br /> 5- \'அல்முபாஹ்\' ஆகுமானவை என்பதற்கான உதாரணம் அப்பிள் பழம் சாப்பிடுதல், தேநீர் அருந்துதல் போன்றவைகளாகும். இது \'ஜாஇஸ்\'; \'ஹலால்\'; என்ற பெயர்களாலும் அழைக்கப்படும்.<br /> குறிப்பிட்ட ஆகுமான <span class="c2">(முபாஹ்)</span> விடயத்தை விட்டுவிடுவதால் மறுமையில் நற்கூலியோ அதனை செய்வதால் தண்டணையோ கிடைக்கமாட்டாது என்பதைக் குறிக்கும். </p>',
            ],
            2 => [
                'question' => 'கேள்வி : வியாபாரம் மற்றும் கொடுக்கல் வாங்கல்; நடவடிக்கைகள் போன்றவற்றின் மார்க்க சட்ட நிலை யாது?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16320.mp3',
                'answer' => '<p> பதில் : வியாபாரம், இதர கொடுக்கல் வாங்கல்களில் அல்லாஹ் தடை செய்துள்ள சிலவற்றைத் தவிர ஏனையவற்றின் அடிப்படைச் சட்டம் ஹலாலாகும்.<span class="c6"><br /> அல்லாஹ் கூறுகின்றான் :</span> "அல்லாஹ் வியாபாரத்தை அனுமதித்து வட்டியை தடை செய்துள்ளான்". <span class="c2">(ஸூறதுல் பகரா : 275)</span>. </p>',
            ],
            3 => [
                'question' => 'கேள்வி 4 : தடைசெய்யப்பட்ட சில வகையான கொடுக்கல் வாங்கல் மற்றும் விற்பனை முறைகளைக் குறிப்பிடவும்?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16360.mp3',
                'answer' => '<p> பதில் :<br /> 1- மோசடி செய்தல். வியாபாரப் பொருளின் குறையை மறைத்து விற்றல் வியாபாரத்தில் மோசடி செய்வதில் உள்ளதாகும்.<span class="c6"><br /> அபூஹுரைரா ரழியல்லாஹு அன்ஹு அவர்கள் அறிவிக்கிறார்கள் :</span> நபி ஸல்லல்லாஹு அலைஹிவஸல்லம் அவர்கள், உணவு தானியம் விற்பனை செய்யும் ஒரு வியாபாரியை கடந்து சென்றார்கள். தங்களின் கரத்தை தானியக் குவியலுக்குள் நுழைத்தார்கள். உள்ளே ஈரப்பதம் தென்பட்டது. இது என்ன ஈரம் எனக் கேட்டபொழுது யாரசூலல்லாஹ் மழை பொழிந்து நனைந்து விட்டது என்றார்.<span class="c6"> அதற்கு நபியவர்கள்:</span> "அதை மக்கள் பார்த்து வாங்குவதற்காக மேலே வைக்க வேண்டாமா? எவர் மோசடி செய்கிறாரோ அவர் நம்மைச் சார்ந்தவரல்ல" என்றார்கள். <span class="c2">(ஆதாரம் : முஸ்லிம் .)</span><br /> 2-<span class="c6"> வட்டி:</span> அதாவது ஒருவரிடம் ஆயிரம் ரூபாவை கடனாக வாங்கும் போது அதனை திருப்பி செலுத்தும் சமயம்இரண்டாயிரம் ரூபா கொடுப்பதாக் கூறி கடன் பெறுவது வட்டிசார்ந்த பரிவர்ந்தனை முறையாகும்.<br /> அதாவது கடன் பெறும் போது பெற்றதை விட மேலதிகமாக தருவதாக நிபந்தனையிடுவது வட்டியாகும்.<span class="c6"><br /> அல்லாஹ் கூறுகின்றான் :</span> "அல்லாஹ் வியாபாரத்தை அனுமதித்து வட்டியை தடை செய்துள்ளான்". <span class="c2">(ஸூறதுல் பகரா :275)</span>.<br /> 3-<span class="c6"> ஏமாற்றுதல் மற்றும் காணாத அல்லது அறியாத ஒன்றை விற்றல் வாங்குதல் :</span> உதாரணமாக ஆட்டின் பால் மடியில் உள்ள பாலை உனக்கு விற்கிறேன். அல்லது நீர் நிலையொன்றைக் காட்டி இதில் உள்ள மீன்களை விற்கிறேன் என்று கூறி வியாபாரம் செய்தலைக் குறிக்கும்.<br /> அல்லாஹ்வின் தூதர் ஸல்லல்லாஹு அலைஹிவஸல்லம் அவர்கள் மோசடி வியாபாரத்தை தடை செய்தார்கள்\' என ஹதீஸில் இடம்பெற்றுள்ளது. <span class="c2">(ஆதாரம் : முஸ்லிம் .)</span> </p>',
            ],
            4 => [
                'question' => 'கேள்வி 5 : உனக்கு அல்லாஹ் வழங்கியிருக்கும் சில அருட்கொடைகளைக் குறிப்பிடுக.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16460.mp3',
                'answer' => '<p> பதில் : 1- இஸ்லாம் எனும் அருளாகும். ஏனெனில் நீ ஒரு முஸ்லிமாய் இருக்கிறாய், நீ காபிர்களின் ஒருவன் அல்ல.<br /> 2- ஸுன்னா எனும் அருள், ஏனெனில் நீ நபிவழியைப் பின்பற்றும் ஒருவனாக உள்ளாய், நீ பித்அத் வாதிகளில் உள்ளவனல்ல.<br /> 3- கேட்டல், பார்த்தல், நடத்தல் போன்ற ஆரோக்கியம் சார்ந்த அருள்கள்.<br /> 4- உணவு, குடிபானம், உடை சார்ந்த அருள்கள்.<br /> எம் மீதான அல்லாஹ்வின் அருள்கள் அதிகமானவை. அவற்றை எண்ணி கணக்கிட முடியாது.<span class="c6"><br /> அல்லாஹ் கூறுகின்றான் :</span> "நீங்கள் அல்லாஹ்வின் அருள்களை எண்ணினால் அதனை கணக்கிட்டுகொள்ளமாட்டீர்கள். நிச்சயமாக அல்லாஹ் மாபெரும் மன்னிப்பாளனும் கருணையாளனுமாவான்". <span class="c2">(ஸூறதுன் நஹ்ல் :18)</span> </p>',
            ],
            5 => [
                'question' => 'கேள்வி 6 : அல்லாஹ்வின் அருட்கொடைகளுக்கான எமது கடமை என்ன? அவற்றிற்கு நன்றி செலுத்துவது எவ்வாறு?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16540.mp3',
                'answer' => '<p> பதில் - எமது நாவால் அவனை போற்றிப் புகழ்ந்து நன்றி செலுத்துவதே அவ்வருள்களுக்கு நாம் செய்யும் கடமையாகும், ஏனென்றால் அவனுக்கு மாத்திரமே அதன் சிறப்பு இருக்கிறது, மேலும் அவனால் தரப்பட்டுள்ள அருள்களினால் அவனுக்கு மாறு செய்யாது அவற்றை அவன் திருப்தியுரும் செயற்பாடுகளில் பயன்படுத்துதல் வேண்டும். </p>',
            ],
            6 => [
                'question' => 'கேள்வி 7 : முஸ்லிம்களின் பெருநாட் தினங்கள் எவை?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16570.mp3',
                'answer' => '<p> பதில் : முஸ்லிம்களுக்கு இருபெருநாட்கள் உள்ளன.1-நோன்புப் பெருநாள், 2- ஹஜ்ஜுப் பெருநாள்.<span class="c6"><br /> இது குறித்து பின்வரும் ஹதீஸ் இடம் பெற்றுள்ளது :</span> அனஸ் ரழியல்லாஹு அன்ஹு அறிவிக்கிறார்கள் : நபி ஸல்லல்லாஹு அலைஹிவஸல்லம் அவர்கள் மதீனாவுக்கு வந்த போது மதீனா வாசிகளுக்கு விளையாடி மகிழ்வதற்கான விஷேடமான இரு தினங்கள் இருந்தன, அப்போது நபியவர்கள் இந்த இரு தினங்கள் குறித்து அவர்களிடம் விசாரித்த போது அவர்கள் நாங்கள் ஜாஹிலிய்யாக் காலத்தில் இவ்விரு தினங்களிலும் விளையாடுபவர்களாக இருந்தோம்,<span class="c6"> என்று கூறவே அதற்கு நபி ஸல்லல்லாஹு அலைஹிவஸல்லம் அவர்கள் :</span> நிச்சயமாக அல்லாஹ் இந்த இரண்டு நாட்களுக்கும் பதிலாக ஈதுல் அழ்ஹா மற்றும் ஈதுல் பித்ர் எனும் பெருநாட்களை அளித்துள்ளான்\' என்று கூறினார்கள். <span class="c2">(ஆதாரம் : அபூதாவூத்)</span>.<br /> இவ்விரு பெருநாட்கள் தவிர்ந்த ஏனைய பெருநாட்கள் பித்அத்ஆவாகும். அதாவது நபிவழிக்கு முரணாண பெருநாட்களாகும். </p>',
            ],
            7 => [
                'question' => 'கேள்வி 08: மாதங்களில் மிகச் சிறந்த மாதம் எது?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16620.mp3',
                'answer' => '<p> பதில் : ரமழான் மாதம். </p>',
            ],
            8 => [
                'question' => 'கேள்வி 09 : நாட்களில் மிகச் சிறந்த நாள் எது?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16650.mp3',
                'answer' => '<p> பதில் : ஜும்ஆ நாளாகும் <span class="c2">(வெள்ளிக்கிழமையாகும்)</span>. </p>',
            ],
            9 => [
                'question' => 'கேள்வி 10 : வருடத்தில் மிகச் சிறந்த நாள் எது?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16680.mp3',
                'answer' => '<p> பதில் : அறபா நாளாகும் <span class="c2">(துல் ஹஜ் மாதம் 09ம் நாள்)</span>. </p>',
            ],
            10 => [
                'question' => 'கேள்வி 11 : வருடத்தில் மிகச் சிறந்த இரவு எது ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16710.mp3',
                'answer' => '<p> பதில் : லைலதுல் கத்ர் இரவாகும். </p>',
            ],
            11 => [
                'question' => 'கேள்வி 12 : ஒரு அன்னியப்பெண்ணைக் கண்டால் என்ன செய்ய வேண்டும் ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16740.mp3',
                'answer' => '<p> பதில் : பார்வைத் தாழ்த்திக் கொள்ள வேண்டும்.<span class="c6"> அல்லாஹ் கூறுகின்றான் :</span> "முஃமினான ஆண்களுக்கு அவர்களின் பார்வைகளைப் பேணிக் கொள்ளுமாறு நபியே நீர் கூறுவீராக". <span class="c2">(ஸூறதுன் நூர் : 30)</span> </p>',
            ],
            12 => [
                'question' => 'கேள்வி 13 : மனிதனின் மிகப் பெரும் எதிரிகள் யார்?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16770.mp3',
                'answer' => '<p> 1- பாவத்தைத் தூண்டும் உள்ளம். அதாவது மனிதன் தனது உள்ளம் கூறுவதற்கு கட்டுப்பட்டு மனோ இச்சையைப்பின்பற்றி அல்லாஹ்வின் கட்டளைகளுக்கு முரணான செயற்பாடுகளில் ஈடுபடுதல்.<span class="c6"> இது குறித்து அல்லாஹ் பின்வருமாறு கூறுகின்றான் :</span> "எனது இரட்சகன் அருள்புரிந்தாலேயன்றி மனம் தீமையைத் துண்டக் கூடியதாவே உள்ளது. நிச்சயமாக எனது இரட்சகன் மிக்க மன்னிப்பவன் நிகரற்ற அன்புடையோன்". <span class="c2">(ஸுறா யூஸுப் : 53)</span>. 2-<span class="c6"> ஷைத்தான் :</span> அவன் ஆதமின் மகனின் எதிரியாவான், அவனின் இலக்கு அவர்களை வழிதவறச் செய்து தீய ஊசாலாட்டங்களை அவர்களின் உள்ளத்தில் ஏற்படுத்தி நரகத்தினுள் நுழைவிப்பதாகும்.<span class="c6"> அல்லாஹ் பின்வருமாறு கூறுகின்றான் :</span> "நீங்கள் ஷைத்தானின் அடிச்சுவடுகளைப் பின்பற்றாதீர்கள். நிச்சயமாக அவன் உங்களுக்கு பகிரங்க விரோதியாவான்". <span class="c2">(ஸூறதுல் பகரா : 168)</span>. 3-<span class="c6"> தீய நண்பர்கள்:</span> நன்மையான காரியங்களைவிட்டும் தடுத்து, தீய காரியங்களில் ஈடுபடத் தூண்டுபவர்கள்.<span class="c6"> அல்லாஹ் பின்வருமாறு கூறுகின்றான் :</span> "அந்நாளில் பயபக்தியாளர்களைத் தவிர நண்பர்களில் சிலர் மற்றும் சிலருக்கு எதிரிகளாக இருப்பர்". <span class="c2">(ஸுறதுஸ் ஸுஹ்ருப் : 67)</span> </p>',
            ],
            13 => [
                'question' => 'கேள்வி 14 - தவ்பா என்றால் என்ன?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16820.mp3',
                'answer' => '<p> பதில் : தவ்பா என்றால் அல்லாஹ்வுக்கு மாறு செய்வதைவிட்டும் அவனை வழிபடுவதின்பால் திரும்புதல்.<span class="c6"> அல்லாஹ் பின்வருமாறு கூறுகின்றான் :</span> "எவர் பாவமன்னிப்புக் கோரி நம்பிக்கை கொண்டு நல்லறங்களைப் புரிந்து பின்பு நேர்வழி நடக்கின்றானோ அவரை நான் நிச்சயம் மன்னிப்பவனாக இருக்கிறேன்". <span class="c2">(ஸூறா தாஹா : 82)</span> </p>',
            ],
            14 => [
                'question' => 'கேள்வி: தூய்மையான தவ்பாவின் நிபந்தனைகள் என்ன?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16850.mp3',
                'answer' => '<p> பதில் - 1-<span class="c6">பாவத்தை விடுதல்:</span> உடனே பாவத்தைக் கைவிட வேண்டும்.<br /> 2- செய்த பாவத்தைக் குறித்து வருந்துதல்.<br /> 3- இனியும் அப்பாவத்தை எக்காலத்திலும் செய்வதில்லை என்று உறுதி கொள்ளுதல்.<br /> 4- அடியார்களின் உரிமைகளில் அநியாயம் நிகழ்ந்திருந்தால் அவ்வுரிமைகளை அவர்களுக்கு மீளளித்தல்.<span class="c6"><br /> அல்லாஹ் கூறுகின்றான் :</span> "மானக் கேடான ஏதேனும் ஒரு செயலை அவர்கள் செய்துவிட்டாலும், அல்லது <span class="c2">(ஏதேனும் பாவத்தினால்)</span> தமக்குத் தாமே தீங்கிழைத்துக் கொண்டாலும் உடனே அவர்கள் <span class="c2">(மனப்பூர்வமாக)</span> அல்லாஹ்வை நினைத்து தங்கள் பாவங்களுக்காக மன்னிப்புத் தேடுவார்கள்; அல்லாஹ்வைத் தவிர வேறு யார் பாவங்களை மன்னிக்க முடியும்? மேலும், அவர்கள் அறிந்து கொண்டே தங்கள் <span class="c2">(பாவ)</span> காரியங்களில் நிலைத்திருக்க மாட்டார்கள்". <span class="c2">(ஸூறா ஆலி இம்ரான் : 135)</span>. </p>',
            ],
            15 => [
                'question' => 'கேள்வி 16 : நபி ஸல்லல்லாஹு அலைஹி வஸல்லம் அவர்களின் மீது ஸலவாத் சொல்லுதல் என்பதன் கருத்து யாது?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16920.mp3',
                'answer' => '<p> பதில் : அல்லாஹ் தனது நபியை மிகச்சிறந்த கூட்டத்தில் பாராட்டுமாறு அவனிடம் பிரார்த்திப்பதே இதன் கருத்தாகும். </p>',
            ],
            16 => [
                'question' => 'கேள்வி :17 : \'ஸுப்ஹானல்லாஹ்\' என்பதன் கருத்து யாது?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16950.mp3',
                'answer' => '<p> பதில் : தஸ்பீஹ் என்பது அல்லாஹ் எல்லாவகையான தீங்குகள், குறைகளைவிட்டும் தூய்மையானவன் என அவனைத் துதிப்பதாகும். </p>',
            ],
            17 => [
                'question' => 'கேள்வி 18 : \'அல்ஹம்துலில்லாஹ்\' என்பதன் கருத்து யாது?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16980.mp3',
                'answer' => '<p> பதில் - அல்லாஹ்வை புகழ்ந்து பாராட்டி நிறைவான அனைத்து பண்புகளினாலும் அவனை வர்ணித்தல். </p>',
            ],
            18 => [
                'question' => 'கேள்வி : 19 : \'அல்லாஹு அக்பர்\' என்பதன் கருத்து யாது?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/17000.mp3',
                'answer' => '<p> பதில் - அந்த பரிசுத்தமான இரட்சகன் எல்லாவற்றைவிடவும் மிகப் பெரியவன், எல்லாவற்றைவிடவும் மிக உயர்வானவனாகவும் கண்ணியமிக்கவனாகவும் உன்னதமானவனாவும் உள்ளான் என்பதாகும். </p>',
            ],
            19 => [
                'question' => 'கேள்வி 20 : \'லா ஹவ்ல வலா குவ்வத இல்லா பில்லாஹ்\' என்பதன் கருத்து யாது?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/17030.mp3',
                'answer' => '<p> பதில் : ஒரு நிலையிலிருந்து இன்னொரு நிலைக்கு ஒரு அடியான் மாறுவதற்கான எந்த சக்தியும் அல்லாஹ்வின் உதவியினாலேயன்றி வேறு யாராலும் முடியாது எந்பதாகும். </p>',
            ],
            20 => [
                'question' => 'கேள்வி 21 : \'அஸ்தஃபிருல்லாஹ்\' என்பதன் அர்த்தம் யாது?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/17060.mp3',
                'answer' => '<p> பதில் : பாவத்தை நீக்கி குறைகளை மறைத்து விட வேண்டும் என்று அடியான் தனது இரட்சகனிடத்தில் வேண்டுவதாகும். </p>',
            ],
        ],
    ],
];
