<?php
$data = [
    'title' => 'Ang Kinakailangang Malaman ng mga Batang Muslim',
    'description' => 'Isang proyektong naglalaman ng isang simpleng madaling kurikulum para sa mga usaping kinakailangang malaman ng Muslim. Naglalaman ito ng mga usapin sa paniniwala, fiqh, talambuhay ng Propeta, mga etiketa, pagpapakahulugan ng Qur\'an, hadith, mga kaasalan, at mga dhikr. Nababagay ito lalo na sa mga bata, at sa lahat ng mga edad at mga baguhan sa Islam.',
    'source' => 'https://kids.islamenc.com/tl/home',
    'author' => 'Yazan Abdul Razzaq Raziq Alghanim',
    'sections' => [
        0 => 'Sangay ng Aqīdah',
        1 => 'Sangay ng Fiqh',
        2 => 'Sangay ng Talambuhay ng Propeta',
        3 => 'Sangay ng Tafsīr (Pagpapakahulugan sa Qur\'ān)',
        4 => 'Sangay ng Ḥadīth',
        5 => 'Sangay ng mga Magagandang Kaasalang Islāmiko',
        6 => 'Sangay ng mga Kaasalan',
        7 => 'Sangay ng mga Du`ā\' at mga Dhikr',
        8 => 'Sangay ng mga Samut-sari',
    ],
    'data' => [
        1 => [
            0 => [
                'question' => 'T1: Sino ang Panginoon mo?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/200.mp3',
                'answer' => '<p> S: Ang Panginoon ko ay si Allāh na nag-aruga sa akin at nag-aruga sa lahat ng mga nilalang sa pamamagitan ng biyaya Niya.<span class="c6"><br /> Ang patunay ay ang sabi ni Allāh:</span> <span class="c4">{2. Ang papuri ay ukol kay Allāh, ang Panginoon ng mga nilalang,}</span> <span class="c2">(Qur\'ān 1:2)</span> </p>',
            ],
            1 => [
                'question' => 'T2: Ano ang Relihiyon mo?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/240.mp3',
                'answer' => '<p> S: Ang Relihiyon ko ay ang Islām. Ito ay ang pagsuko kay Allāh sa pamamagitan ng Tawḥīd, ang pagpapaakay sa Kanya sa pamamagitan ng pagtalima, at ang kawalang-kaugnayan sa Shirk at sa mga alagad ng Shirk.<span class="c6"><br /> Nagsabi si Allāh:</span> <span class="c4">{Tunay na ang relihiyon sa ganang kay Allāh ay ang Islām.}</span> <span class="c2">(Qur\'ān 3:19)</span> </p>',
            ],
            2 => [
                'question' => 'T3: Sino ang Propeta mo?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/280.mp3',
                'answer' => '<p> S: Si Muḥammad <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span>.<span class="c6"><br /> Nagsabi si Allāh:</span> {Si Muḥammad, ang Sugo ni Allāh...) <span class="c2">(Qur\'ān 48:29)</span> </p>',
            ],
            3 => [
                'question' => 'T4: Mababanggit mo ba ang Pangungusap ng Tawḥīd at ang kahulugan nito?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/310.mp3',
                'answer' => '<p> S: Ang Pangungusap ng Tawḥīd ay <span class="c5">[ang pagsabi ng]</span> Walang Diyos kundi si Allāh. Ang kahulugan nito ay walang sinasambang totoo kundi si Allāh.<span class="c6"><br /> Nagsabi si Allāh:</span> <span class="c4">{Kaya alamin mo na walang Diyos kundi si Allāh}</span> <span class="c2">(Qur\'ān 47:19)</span> </p>',
            ],
            4 => [
                'question' => 'T5: Nasaan si Allāh (kamahal-mahalan Siya at kapita-pitagan)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/350.mp3',
                'answer' => '<p> S: Si Allāh ay nasa langit sa ibabaw ng Trono, sa ibabaw ng lahat ng mga nilikha.<span class="c6"> Nagsabi Siya:</span> <span class="c4">{Ang Napakamaawain ay sa trono lumuklok.}</span> <span class="c2">(Qur\'ān 20:5)</span> Nagsabi pa Siya: <span class="c4">{Siya ay ang Tagagapi sa ibabaw ng mga lingkod Niya at Siya ay ang Marunong, ang Mapagbatid.}</span> <span class="c2">(Qur\'ān 6:18)</span> </p>',
            ],
            5 => [
                'question' => 'T6: Ano ang kahulugan ng pagsaksi na si Muḥammad ay Sugo ni Allāh?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/380.mp3',
                'answer' => '<p> S: Ang kahulugan nito ay na si Allāh ay nagsugo sa kanya sa mga nilalang bilang mapagbalita ng nakagagalak at bilang mapagbabala<br /> at kinakailangan:<br /> 1. ang pagtalima sa kanya sa ipinag-utos niya;<br /> 2. ang Paniniwala sa kanya sa ipinabatid niya;<br /> 3. ang hindi pagsuway sa kanya;<br /> 4. na hindi sambahin si Allāh maliban ayon sa isinabatas, na pagsunod sa sunnah at pag-iwan sa bid`ah.<span class="c6"><br /> Nagsabi si Allāh:</span> <span class="c4">{Ang sinumang tumatalima sa Sugo ay tumalima nga kay Allāh.}</span> <span class="c2">(Qur\'ān 4:80)</span> Nagsabi pa siya <span class="c2">(kaluwalhatian sa Kanya)</span>: <span class="c4">{Hindi siya bumibigkas ayon sa pithaya. Walang iba ito kundi isang kasi na ikinakasi sa kanya.}</span> <span class="c2">(Qur\'ān 53:3-4)</span> Nagsabi pa Siya <span class="c2">(kamahal-mahalan Siya at kataas-taasan)</span>: <span class="c4">{Talaga ngang nagkaroon para sa inyo sa Sugo ni Allāh ng isang magandang huwaran para sa sinumang naging nag-aasam kay Allāh at sa Huling Araw at nag-alaala kay Allāh nang madalas. }</span> <span class="c2">(Qur\'ān 33:21)</span> </p>',
            ],
            6 => [
                'question' => 'T7: Bakit nilikha tayo ni Allāh?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/480.mp3',
                'answer' => '<p> S: Nilikha tayo para sa pagsamba sa kanya – tanging sa Kanya: walang katambal para sa Kanya,<br /> hindi para sa paglilibang at hindi para sa paglalaro.<span class="c6"><br /> Nagsabi si Allāh:</span> <span class="c4">{Hindi Ako lumikha ng jinn at tao kundi upang sumamba sila sa Akin.}</span> <span class="c2">(Qur\'ān 51:56)</span> </p>',
            ],
            7 => [
                'question' => 'T8: Ano ang kahulugan ng pagsamba?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/530.mp3',
                'answer' => '<p> S: Isang pangngalang tagatipon ng bawat naiibigan ni Allāh at kinalulugdan niya mula sa mga sinasabi at mga ginagawang lantaran at pakubli.<br /> Ang lantaran ay ang tulad ng pagbanggit kay Allāh sa pamamagitan ng dila gaya ng tasbīḥ <span class="c2">(pagsambit ng subḥāna –llāh)</span>, taḥmīd <span class="c2">(pagsambit ng alḥamdu lillāh)</span>, at takbīr <span class="c2">(pagsambit ng Allāhu akbar)</span>, at ng pagsasagawa ng ṣalāh at ḥajj.<br /> Ang pakubli ay tulad ng pananalig, pangamba, at pag-aasam <span class="c5">[sa Kanya]</span>. </p>',
            ],
            8 => [
                'question' => 'T9: Ano ang pinakamabigat na tungkulin sa atin?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/580.mp3',
                'answer' => '<p> S: Ang pinakamabigat na tungkulin sa atin ay ang Tawḥīd <span class="c2">(Paniniwala sa Kaisahan ni Allāh)</span>. </p>',
            ],
            9 => [
                'question' => 'T10: Ano ang mga uri ng Tawḥīd?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/610.mp3',
                'answer' => '<p> S: 1. Ang Tawḥīd Rubūbīyah <span class="c2">(Kaisahan sa Pagkapanginoon)</span>. Ito ay ang pananampalataya na si Allāh ay ang Tagalikha, ang Tagapagtustos, ang Tagapagmay-ari,<span class="c6"> ang Tagapangasiwa – tanging Siya:</span> walang katambal para sa Kanya.<br /> 2. Ang Tawḥīd Ulūhīyah <span class="c2">(Kaisahan sa Pagkadiyos)</span>. Ito ay ang pagbubukod-tangi kay Allāh sa pagsamba kaya walang sinasambang isa man kundi si Allāh <span class="c2">(napakataas Siya)</span>.<br /> 3. Ang Tawḥīd Asmā wa Ṣifāt <span class="c2">(Kaisahan sa mga Pangalan at mga Katangian)</span>. Ito ay ang pananampalataya sa mga pangalan at mga katangian para kay Allāh <span class="c2">(napakataas Siya)</span>, na nasasaad sa Qur\'ān at Sunnah nang walang tamthīl <span class="c2">(pagtutulad)</span> ni tashbīh <span class="c2">(pagwawangis)</span> ni ta`ṭīl <span class="c2">(pag-aalis ng kahulugan)</span>.<span class="c6"><br /> Ang patunay ng tatlong uri ng Tawḥīd ay ang sabi ni Allāh:</span> <span class="c4">{Ang Panginoon ng mga langit at lupa at anumang nasa pagitan ng mga ito, kaya sumamba ka sa Kanya at magpakamatiisin ka para sa pagsamba sa Kanya. Nakaaalam ka kaya para sa Kanya ng isang kapangalan?"}</span> <span class="c2">(Qur\'ān 19:65)</span> </p>',
            ],
            10 => [
                'question' => 'T11: Ano ang pinakamabigat na pagkakasala?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/670.mp3',
                'answer' => '<p> S: Ang Shirk <span class="c2">(pagtatambal)</span> kay Allāh <span class="c2">(napakataas Siya)</span>.<br /> Nagsabi Siya <span class="c2">(napakataas Siya)</span>: <span class="c4">{Tunay na si Allāh ay hindi magpapatawad na tambalan Siya, at magpapatawad naman Siya sa anumang mababa pa roon sa sinumang loloobin Niya. Ang sinumang nagtatambal kay Allāh ay gumawa-gawa nga ng isang kasalanang sukdulan.}</span> <span class="c2">(Qur\'ān 4:48)</span> </p>',
            ],
            11 => [
                'question' => 'T12:Mababanggit mo ba ang [kahulugan ng] Shirk at ang mga uri nito?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/710.mp3',
                'answer' => '<p> S: Ang Shirk ay ang pagbaling ng alinmang uri kabilang sa mga uri ng pagsamba sa iba pa kay Allāh <span class="c2">(napakataas Siya)</span>.<span class="c6"><br /> Ang mga uri nito ay:</span><br /> Shirk Akbar <span class="c2">(Malaking Shirk)</span>, na tulad ng pagdalangin sa iba pa kay Allāh <span class="c2">(napakataas Siya)</span> o pagpapatirapa sa iba pa sa Kanya <span class="c2">(kaluwalhatian sa Kanya)</span> o pagkakatay para sa iba pa kay Allāh <span class="c2">(kamahal-mahalan Siya at kapita-pitagan)</span>.<br /> Shirk Aṣghar <span class="c2">(Maliit na Shirk)</span>, na tulad ng panunumpa <span class="c5">[ng tao]</span> sa iba pa kay Allāh <span class="c2">(napakataas Siya)</span> o pagsusuot niya ng mga agimat, na anumang isinasabit na mga bagay pinaniniwalaang para sa pagtamo ng pakinabang at pagtulak ng pinsala, at kaunting pagpapakitang-tao gaya ng pagpapaganda niya ng pagdarasal dahil sa nakikita niya na pagtingin ng mga tao sa kanya. </p>',
            ],
            12 => [
                'question' => 'T13: May nakaaalam ba sa Ghayb (Nakalingid) na isa man bukod kay Allāh?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/770.mp3',
                'answer' => '<p> S: Walang nakaaalam sa Ghayb kundi si Allāh – tanging Siya.<br /> Nagsabi Siya <span class="c2">(napakataas Siya)</span>: <span class="c4">{Sabihin mo: "Hindi nalalaman ng sinumang nasa mga langit at lupa ang nakalingid maliban kay Allāh, at hindi nila nararamdaman kung kailan sila bubuhayin."}</span> <span class="c2">(Qur\'ān 27:65)</span> </p>',
            ],
            13 => [
                'question' => 'T14: Ano ang mga haligi ng Pananampalataya?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/810.mp3',
                'answer' => '<p> S: 1. Ang pananampalataya kay Allāh <span class="c2">(napakataas Siya)</span>,<br /> 2. sa mga anghel Niya,<br /> 3. sa mga kasulatan Niya,<br /> 4. sa mga sugo Niya,<br /> 5. sa Huling Araw,<br /> 6.<span class="c6"> at sa pagtatakda:</span> sa kabutihan nito at kasamaan nito.<span class="c6"><br /> Ang patunay ay ang tumanyag na ḥadīth ni Anghel Gabriel ayon kay Imām Muslim:</span> {Nagsabi si Anghel Gabriel sa Propeta <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span>: "Kaya magpabatid ka sa akin tungkol sa pananampalataya.<span class="c6">" Nagsabi siya:</span> "Na sumampalataya ka kay Allāh, sa mga anghel Niya, sa mga kasulatan Niya, sa mga sugo Niya, sa Huling Araw,<span class="c6"> at sumampalataya ka sa pagtatakda:</span> sa kabutihan nito at kasamaan nito."} </p>',
            ],
            14 => [
                'question' => '15. Maipaliliwanag mo ba ang mga haligi ng pananampalataya?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/900.mp3',
                'answer' => '<p> S: Ang pananampalataya kay Allāh <span class="c2">(napakataas Siya)</span> ay:<br /> § na sumampalataya ka na si Allāh ay ang lumikha sa iyo at nagtustos sa iyon at Siya ay ang Tagapagmay-ari at ang Tagapangasiwa – tanging Siya;<br /> § na Siya ay ang sinasamba, na walang sinasambang ayon sa karapatan bukod sa Kanya;<br /> § na Siya ay ang Sukdulan, ang Dakila, ang Ganap, na ukol sa Kanya ang papuri sa kabuuan nito at ukol sa Kanya ang mga pangalang pinakamagaganda at ang mga katangiang pinakamatataas, na walang ukol sa Kanya na kaagaw at walang nakawawangis sa Kanya na anuman <span class="c2">(kaluwalhatian sa Kanya)</span>.<span class="c6"><br /> Ang pananampalataya sa mga anghel ay:</span><br /> <span class="c5">[ang paniniwala na]</span> ang mga ito ay mga nilikha na nilikha ni Allāh mula sa isang liwanag at para sa pagsamba sa Kanya at lubos ng pagpapaakay sa utos Niya.<br /> * Kabilang sa kanila si Anghel Gabriel <span class="c2">(sumakanya ang pangangalaga)</span> na nagbababa ng kasi sa mga propeta.<span class="c6"><br /> Ang pananampalataya sa mga kasulatan ay:</span><br /> <span class="c5">[ang paniniwala na]</span> ang mga ito ay ang mga kasulatan na pinababa ni Allāh sa mga sugo Niya<br /> gaya ng Qur\'ān kay Muḥammad <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span>,<br /> ng Ebanghelyo kay Jesus <span class="c2">(pangalagaan siya ni Allāh)</span>,<br /> ng Torah kay Moises <span class="c2">(pangalagaan siya ni Allāh)</span>,<br /> ng Salmo kay David <span class="c2">(pangalagaan siya ni Allāh)</span>,<br /> ng mga Kalatas nina Abraham at Moises kina Abraham at Moises.<span class="c6"><br /> Ang pananampalataya sa mga sugo ay:</span><br /> <span class="c5">[ang paniniwala na]</span> ang mga ito ay mga isinugo ni Allāh sa mga lingkod Niya upang magturo sa kanila, magbalita ng nakagagalak sa kanila hinggil sa kabutihan at Paraiso, at magbabala sa kanila tungkol sa kasamaan at Impiyerno.<span class="c6"><br /> Ang pinakamainam sa kanila at ang mga may pagtitika ay sina:</span><br /> Noe <span class="c2">(sumakanya ang pangangalaga)</span>,<br /> Abraham <span class="c2">(sumakanya ang pangangalaga)</span>,<br /> Moises <span class="c2">(sumakanya ang pangangalaga)</span>,<br /> Jesus <span class="c2">(sumakanya ang pangangalaga)</span>,<br /> Muḥammad <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span>.<span class="c6"><br /> Ang pananampalataya sa Huling Araw ay:</span><br /> <span class="c5">[ang paniniwala sa]</span> anumang mangyayari matapos ng kamatayan sa libingan, Araw ng Pagbangon, at Araw ng Pagbuhay at Pagtutuos kung kailan manunuluyan ang mga maninirahan sa Paraiso sa mga tahanan nila at ang mga maninirahan sa Impiyerno sa mga tahanan nila.<span class="c6"><br /> Ang pananampalataya sa pagtatakda:</span> sa kabutihan nito at kasamaan nito ay:<br /> <span class="c5">[ang paniniwala sa]</span> pagtatakda: ang maniwala na si Allāh ay nakaaalam sa bawat bagay na magaganap sa Sansinukob at na Siya ay nagtala niyon sa Tablerong Pinag-iingatan at lumuob ng pag-iral nito at paglikha nito.<span class="c6"><br /> Nagsabi si Allāh:</span> <span class="c4">{Tunay na Kami sa bawat bagay ay lumikha ayon sa isang takda.}</span> <span class="c2">(Qur\'ān 54:49)</span><br /> Ito ay ayon sa apat na antas:<br /> Una. Ang Kaalaman ni Allāh. Kabilang doon ang kaalaman Niyang nakauna sa bawat bagay bago ng pagkaganap ng lahat ng mga bagay at matapos ng pagkaganap ng mga ito.<span class="c6"><br /> Ang patunay nito ay ang sabi ni Allāh:</span> <span class="c4">{Tunay na si Allāh ay may taglay ng kaalaman sa Huling Sandali. Nagbababa Siya ng ulan at nakaaalam Siya sa anumang nasa mga sinapupunan. Hindi nababatid ng isang kaluluwa kung ano ang kakamtin niya kinabukasan at hindi nababatid ng isang kaluluwa kung sa aling lupain siya mamamatay. Tunay na si Allāh ay Maalam, Mapagbatid.}</span> <span class="c2">(Qur\'ān 31:34)</span><br /> Ikalawa. Ang Pagsulat. Si Allāh ay sumulat niyon sa Tablerong pinag-iingatan. Kaya naman ang bawat bagay na naganap at magaganap, ito ay nakatala sa ganang Kanya sa isang talaan.<span class="c6"><br /> Ang patunay nito ay ang sabi ni Allāh:</span> <span class="c4">{Taglay Niya ang mga susi ng nakalingid; walang nakaaalam sa mga iyon kundi Siya. Nalalaman Niya ang anumang nasa katihan at karagatan. Walang nalalaglag na anumang dahon malibang nalalaman Niya ito. Walang butil sa mga kadiliman ng lupa at walang mahalumigmig ni tuyot malibang nasa isang aklat na malinaw.}</span> <span class="c2">(Qur\'ān 6:59)</span><br /> Ikatlo. Ang Kalooban. Ang bawat bagay na nagaganap ay ayon sa kalooban ni Allāh at walang nagaganap na anuman mula sa Kanya o mula sa nilikha Niya kundi ayon sa kalooban Niya <span class="c2">(napakataas Siya)</span>.<span class="c6"><br /> Ang patunay nito ay ang sabi ni Allāh:</span> <span class="c4">{para sa sinumang lumoob kabilang sa inyo na magpakatuwid, at hindi kayo magloloob maliban na lumuob si Allāh, ang Panginoon ng mga nilalang.}</span> <span class="c2">(Qur\'ān 81:28-29)</span><br /> Ikaapat. Ang Paglikha. Ang pananampalataya na ang lahat ng mga nilalang ay nilikhang nilikha ni Allāh, na nilikha Niya ang mga katawan ng mga ito, ang mga katangian ng mga ito, ang mga kilos ng mga ito, at ang bawat bagay na nasa mga ito.<span class="c6"><br /> Ang patunay nito ay ang sabi ni Allāh:</span> <span class="c4">{samantalang si Allāh ay lumikha sa inyo at sa ginagawa ninyo?}</span> <span class="c2">(Qur\'ān 37:96)</span> </p>',
            ],
            15 => [
                'question' => 'T16: Ano ang pagpapakahulugan sa Qur\'ān?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1300.mp3',
                'answer' => '<p> S: Ito ay pananalita ni Allāh <span class="c2">(napakataas Siya)</span>, na hindi isang nilikha.<span class="c6"><br /> Nagsabi si Allāh:</span> <span class="c4">{Kung may isa kabilang sa mga tagapagtambal na nagpakalinga sa iyo ay kalingain mo siya hanggang sa makarinig siya ng pananalita ni Allāh.}</span> <span class="c2">(Qur\'ān 9:6)</span> </p>',
            ],
            16 => [
                'question' => 'T17: Ano ang Sunnah?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1330.mp3',
                'answer' => '<p> S: Ito ay ang bawat sinabi o ginawa o sinang-ayunan o paglalarawang pangkaasalan o pampisikal ng Propeta <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span>. </p>',
            ],
            17 => [
                'question' => 'T18: Ano ang bid`ah? Tinatanggap ba natin ito?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1350.mp3',
                'answer' => '<p> S: Ang bawat pinauso ng mga tao sa Relihiyon, na hindi umiral sa panahon ng Propeta <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span> at mga Kasamahan niya.<br /> Hindi tayo tumatanggap ng mga ito at tumatanggi tayo sa mga ito<br /> batay sa sabi ng Propeta <span class="c2">(sumakanya ang basbas at ang pangangalaga)</span>: "Ang bawat bid`ah ay kaligawan." Nagsalaysay nito si Imām Abū Dāwud.<br /> Ang halimbawa nito ay ang pagdaragdag sa pagsamba gaya ng pagdaragdag sa wuḍū\' ng ikaapat ng paghugas at gaya ng pagdiriwang ng kaarawan ng Propeta <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span> sapagkat hindi nasaad ito buhat sa Propeta <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span> at mga Kasamahan niya. </p>',
            ],
            18 => [
                'question' => 'T19: Mababanggit mo ba ang paniniwala sa walā\' (pagtangkilik) at barā\' (pagpapawalang-kaugnayan)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1410.mp3',
                'answer' => '<p> S: Ang walā\' <span class="c2">(pagtangkilik)</span> ay ang pag-ibig sa mga mananampalataya at ang pag-aadya sa kanila.<span class="c6"><br /> Nagsabi si Allāh:</span> <span class="c4">{Ang mga lalaking mananampalataya at ang mga babaing mananampalataya ay mga katangkilik ng isa\'t isa sa kanila.}</span> <span class="c2">(Qur\'ān 9:71)</span><br /> Ang barā\' <span class="c2">(pagpapawalang-kaugnayan)</span> ay ang pagkasuklam sa mga tagatangging-sumampalataya at ang pagkalaban sa kanila.<span class="c6"><br /> Nagsabi si Allāh:</span> <span class="c4">{Nagkaroon nga para sa inyo ng isang magandang huwaran sa kay Abraham at sa mga kasama sa kanya noong nagsabi sila sa mga kababayan nila: "Tunay na kami ay mga walang-kaugnayan sa inyo at sa sinasamba ninyo bukod pa kay Allāh; tumanggi kami sa inyo at lumantad na sa pagitan namin at ninyo ang poot at ang suklam magpakailanman hanggang sa sumampalataya kayo kay Allāh lamang,"}</span> <span class="c2">(Qur\'ān 60:4)</span> </p>',
            ],
            19 => [
                'question' => 'T20: Tatanggap ba si Allāh ng iba pa sa Islām bilang relihiyon?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1480.mp3',
                'answer' => '<p> S: Hindi tatanggap si Allāh ng iba pa sa Islām.<span class="c6"><br /> Nagsabi si Allāh:</span> <span class="c4">{Ang sinumang naghahangad ng iba pa sa Islām bilang relihiyon ay hindi ito matatanggap mula sa kanya at siya sa Kabilang-buhay ay kabilang sa mga lugi.}</span> <span class="c2">(Qur\'ān 3:85)</span> </p>',
            ],
            20 => [
                'question' => 'T21: Ang kawalang-pananampalataya ay sa pagsasabi, paggawa, at paniniwala. Makapaghahalimbawa ka ba niyon?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1520.mp3',
                'answer' => '<p> Ang halimbawa ng pagsasabi ay ang pag-aalipusta kay Allāh <span class="c2">(kaluwalhatian sa Kanya)</span> o sa Sugo Niya <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span>.<br /> Ang halimbawa ng paggawa ay ang paghamak sa Qur\'ān o pagpapatirapa sa iba pa kay Allāh <span class="c2">(napakataas Siya)</span>.<br /> Ang halimbawa ng paniniwala ay ang paniniwala na mayroong naging karapat-dapat sa pagsamba na iba pa kay Allāh <span class="c2">(napakataas Siya)</span> o na mayroong tagalikha kasama kay Allāh <span class="c2">(napakataas Siya)</span>. </p>',
            ],
            21 => [
                'question' => 'T22: Ano ang pagpapaimbabaw (nifāq) at ang mga uri nito?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1570.mp3',
                'answer' => '<p> S:<br /> 1. Ang Malaking Pagpapaimbabaw. Ito ay ang pagkukubli ng kawalang-pananampalataya at ang pagpapakita ng pananampalataya.<br /> Nakapagpapalabas ito mula sa Islām. Ito ay kabilang sa Malaking Kawalang-pananampalataya.<span class="c6"><br /> Nagsabi si Allāh:</span> <span class="c4">{Tunay na ang mga mapagpaimbabaw ay nasa pinakamababang palapag ng Apoy. Hindi ka makatatagpo para sa kanila ng isang mapag-adya,}</span> <span class="c2">(Qur\'ān 4:145)</span><br /> 2. Ang Maliit na Pagpapaimbabaw.<span class="c6"><br /> Halimbawa:</span> ang pagsisinungaling, ang pagsira sa pangako, at ang pagtataksil sa ipinagkatiwala.<br /> Hindi ito nakapagpapalabas mula sa Islām. Ito ay kabilang sa mga pagkakasala at ang nakagagawa nito ay masasalang sa pagdurusa <span class="c5">[sa Impiyerno]</span>.<br /> Nagsabi ang Sugo ni Allāh <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span>: "Ang tanda ng mapagpaimbabaw ay tatlo. Kapag nagsalita siya, nagsisinungaling siya. Kapag nangako siya, sumisira siya. Kapag pinagkatiwalaan siya, nagtataksil siya." Nagsalaysay nito sina Imām Al-Bukhārīy at Imām Muslim. </p>',
            ],
            22 => [
                'question' => 'T23: Sino ang pangwakas sa mga propeta at mga isinugo?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1680.mp3',
                'answer' => '<p> S: Siya ay si Muḥammad <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span>.<span class="c6"><br /> Nagsabi si Allāh:</span> <span class="c4">{Si Muḥammad ay hindi ama ng isa sa mga lalaki ninyo, subalit ang Sugo ni Allāh at ang pangwakas sa mga propeta.}</span> <span class="c2">(Qur\'ān 33:40)</span> Nagsabi naman ang Sugo ni Allāh <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span>: "Ako ay ang pangwakas sa mga isinugo; walang propeta matapos ko." Nagsalaysay nito sina Imām Abū Dāwud, Imām At-Tirmidhīy, at ang iba pa sa kanila. </p>',
            ],
            23 => [
                'question' => 'T24: Ano ang himala?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1730.mp3',
                'answer' => '<p> S: Ang himala ay ang bawat ibinigay ni Allāh sa mga propeta niya kabilang sa mga naiiba sa mga karaniwan para sa pagpapatunay sa katapatan nila.<span class="c6"> Halimbawa:</span><br /> - ang pagbiyak ng buwan para kay Propeta Muḥammad <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span>;<br /> - ang pagbiyak ng dagat para kay Propeta Moises <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span> at ang paglunod kay Paraon at mga kawal nito. </p>',
            ],
            24 => [
                'question' => 'T25: Sino ang mga Ṣaḥābīy (Kasamahan ng Propeta)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1780.mp3',
                'answer' => '<p> S: Ang Ṣaḥābīy ay ang sinumang nakipagkita sa Propeta bilang mananampalataya sa kanya at namatay sa Islām.<br /> - Iniibig natin sila at tinutularan natin sila. Sila ay ang pinakamabuti at ang pinakamainam sa mga tao matapos ng mga propeta.<br /> -<span class="c6"> Ang pinakamainam sa kanila ay ang Apat na Khalīfah ay sina:</span><br /> Abū Bakr <span class="c2">(malugod si Allāh sa kanya)</span>,<br /> `Umar <span class="c2">(malugod si Allāh sa kanya)</span>,<br /> `Uthmān <span class="c2">(malugod si Allāh sa kanya)</span>,<br /> `Alīy <span class="c2">(malugod si Allāh sa kanya)</span>. </p>',
            ],
            25 => [
                'question' => 'T26: Sino ang mga ina ng mga mananampalataya?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1870.mp3',
                'answer' => '<p> S: Sila ay ang mga maybahay ng Propeta <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span>.<span class="c6"><br /> Nagsabi si Allāh:</span> <span class="c4">{Ang Propeta ay higit na karapat-dapat sa mga mananampalataya kaysa sa mga sarili nila. Ang mga maybahay niya ay mga ina nila.}</span> <span class="c2">(Qur\'ān 33:6)</span> </p>',
            ],
            26 => [
                'question' => 'T27: Ano ang karapatan ng sambahayan ng Propeta (basbasan siya ni Allāh at pangalagaan) sa atin?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1910.mp3',
                'answer' => '<p> S: Iniibig natin sila, tinatangkilik natin sila, nasusuklam tayo sa sinumang nasusuklam sa kanila, hindi tayo nagpapakalabis-labis sa kanila. Sila ay ang mga maybahay ng Propeta at ang mga supling niya, ang angkan ni Hāshim, at ang angkan ni Al-Muṭṭalib na mga mananampalataya. </p>',
            ],
            27 => [
                'question' => 'T28: Ano ang kinakailangan sa atin tungo sa mga tagapangasiwa ng kapakanan ng mga Muslim?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1940.mp3',
                'answer' => '<p> S: Ang kinakailangan sa atin ay ang paggalang sa kanila, ang pagdinig sa kanila, ang pagtalima sa kanila sa hindi pagsuway, ang hindi paghihimagsik sa kanila, at ang pagdalangin at ang pagpayo para sa kanila nang palihim. </p>',
            ],
            28 => [
                'question' => 'T29: Ano ang tahanan ng mga mananampalataya?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1970.mp3',
                'answer' => '<p> S: Ang Paraiso.<span class="c6"> Nagsabi si Allāh:</span> <span class="c4">{Tunay na si Allāh ay magpapapasok sa mga sumampalataya at gumawa ng mga maayos sa mga hardin na dumadaloy mula sa ilalim ng mga ito ang mga ilog.}</span> <span class="c2">(Qur\'ān 47:12)</span> </p>',
            ],
            29 => [
                'question' => 'T29: Ano ang tahanan ng mga tagatangging-sumampalataya?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2000.mp3',
                'answer' => '<p> S: Ang Impiyerno.<span class="c6"> Nagsabi si Allāh:</span> <span class="c4">{mangilag kayo sa Apoy na ang panggatong nito ay ang mga tao at ang mga bato. Inihanda ito para sa mga tagatangging sumampalataya.}</span> <span class="c2">(Qur\'ān 2:24)</span> </p>',
            ],
            30 => [
                'question' => 'T31: Ano ang khawf (pangamba)? Ano ang rajā\'(pag-aasam)? Ano ang patunay?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2020.mp3',
                'answer' => '<p> S: Ang khawf <span class="c2">(pangamba)</span> ay ang pangamba kay Allāh at sa parusa Niya.<br /> Ang rajā\' <span class="c2">(pag-aasam)</span> ay ang pag-aasam sa gantimpala ni Allāh, kapatawaran Niya, at awa Niya.<span class="c6"><br /> Ang patunay ay ang sabi ni Allāh:</span> <span class="c4">{Yaong mga dinadalanginan nila ay naghahangad tungo sa Panginoon nila ng pampalapit, <span class="c5">[na nagtatagisan]</span> kung alin sa kanila ang <span class="c5">[magiging]</span> pinakamalapit, nag-aasam ng awa Niya, at nangangamba sa pagdurusa mula sa Kanya. Tunay na ang parusa ng Panginoon mo ay laging pinangingilagan.}</span> <span class="c2">(Qur\'ān 17:57)</span> Nagsabi pa Siya <span class="c2">(napakataas Siya)</span>: <span class="c4">{Magbalita ka sa mga lingkod Ko na Ako ay ang Mapagpatawad, ang Maawain, at na ang pagdurusang dulot Ko ay ang pagdurusang masakit.}</span> <span class="c2">(Qur\'ān :49-50)</span> </p>',
            ],
            31 => [
                'question' => 'T32: Makababanggit ka ba ng ilan sa mga pangalan at mga katangian ni Allāh (napakataas Siya)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2070.mp3',
                'answer' => '<p> S: Allāh, Ar-Rabb <span class="c2">(ang Panginoon)</span>, Ar-Raḥmān <span class="c2">(ang Napakamaawain)</span>, As-Samī` <span class="c2">(ang Madinigin)</span>, Al-Baṣīr <span class="c2">(ang Nakakikita)</span>, Al-`Alīm <span class="c2">(ang Maalam)</span>, Ar-Razzāq <span class="c2">(ang Palatustos)</span>, Al-Ḥayy <span class="c2">(ang Buhay)</span>, Al-`Aḍ̆īm <span class="c2">(ang Sukdulan)</span>, at iba pa kabilang sa mga pangalang pinakamagaganda at mga katangiang pinakamatataas. </p>',
            ],
            32 => [
                'question' => 'T33: Maipaliliwanag mo ba ang mga pangalang ito?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2100.mp3',
                'answer' => '<p> S: Ang pangalang Allāh ay nangangahulugang ang sinasamba ayon sa katapatan – tanging Siya: walang katambal para sa Kanya.<br /> Ang pangalang Ar-Rabb <span class="c2">(ang Panginoon)</span> ay ang Tagalikha, ang Tagapagmay-ari,<span class="c6"> ang Tagapagtustos – tanging Siya:</span> kaluwalhatian sa Kanya.<br /> Ang pangalang As-Samī` <span class="c2">(ang Madinigin)</span> ay ang nakasakop ang pandinig Niya sa bawat bagay at nakaririnig sa lahat ng mga tunog sa kabila ng pagkakaiba-iba ng mga ito at pagkauri-uri ng mga ito.<br /> Ang pangalang Al-Baṣīr <span class="c2">(ang Nakakikita)</span> ay ang nakatitingin sa bawat bagay at nakakikita sa bawat bagay malaki man o maliit.<br /> Ang pangalang Al-`Alīm <span class="c2">(ang Maalam)</span> at ang nakatatalos ang kaalaman Niya sa bawat bagay sa nakaraan, kasalukuyan, at hinaharap.<br /> Ang pangalang Ar-Raḥmān <span class="c2">(ang Napakamaawain)</span> ay ang nakasakop ang awa Niya sa bawat nilikha at buhay kaya ang lahat ng mga tao at mga nilikha ay nasa ilalim ng awa Niya.<br /> Ang pangalang Ar-Razzāq <span class="c2">(ang Palatustos)</span> ay ang kinasalalayan ng panustos ng lahat ng mga nilikha kabilang sa tao at jinn at lahat ng mga hayop.<br /> Ang pangalang Al-Ḥayy <span class="c2">(ang Buhay)</span> ay ang hindi namamatay samantalang ang lahat ng nilikha ay namamatay.<br /> Ang pangalang Al-`Aḍ̆īm <span class="c2">(ang Sukdulan)</span> ay ang nagtataglay ng kaganapan sa kabuuan nito at kasukdulan sa kabuuan nito sa mga pangalan Niya, mga katangian Niya, at mga gawain Niya. </p>',
            ],
            33 => [
                'question' => 'T34: Ano ang kinakailangan sa atin tungo sa mga maalam ng mga Muslim?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2210.mp3',
                'answer' => '<p> S: Umiibig tayo sa kanila at sumasangguni tayo sa kanila hinggil sa mga usapin at mga kasong legal. Hindi tayo bumabanggit sa kanila malibang sa maganda. Ang sinumang bumanggit sa kanila sa iba pa roon kabilang sa kasagwaan, siya ay nasa hindi tamang landas.<span class="c6"><br /> Nagsabi si Allāh:</span> <span class="c4">{mag-aangat si Allāh ng mga antas sa mga sumampalataya kabilang sa inyo at mga binigyan ng kaalaman. Si Allāh sa anumang ginagawa ninyo ay Mapagbatid.}</span> <span class="c2">(Qur\'ān 58:11)</span> </p>',
            ],
            34 => [
                'question' => 'T35: Sino ang mga katangkilik ni Allāh (napakataas Siya)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2240.mp3',
                'answer' => '<p> S: Sila ay ang mga mananampalatayang tagapangilag magkasala.<span class="c6"><br /> Nagsabi si Allāh:</span> <span class="c4">{Pansinin, tunay na ang mga katangkilik ni Allāh ay walang pangamba sa kanila ni sila ay malulungkot. <span class="c5">[Sila]</span> ang mga sumampalataya at sila noon ay nangingilag magkasala kay Allāh.}</span> <span class="c2">(Qur\'ān 10:62-63)</span> </p>',
            ],
            35 => [
                'question' => 'T35: Ang pananampalataya ba ay salita at gawa?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2280.mp3',
                'answer' => '<p> S: Ang pananampalataya ay salita, gawa, at paniniwala. </p>',
            ],
            36 => [
                'question' => 'T37: Ang pananampalataya ba ay nadaragdagan at nababawasan?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2310.mp3',
                'answer' => '<p> S: Ang pananampalataya ay nadaragdagan sa pamamagitan ng pagtalima at nababawasan sa pamamagitan ng pagsuway.<span class="c6"><br /> Nagsabi si Allāh:</span> <span class="c4">{Tanging ang mga mananampalataya ay ang mga kapag binanggit si Allāh ay nasisindak ang mga puso nila at kapag binigkas sa kanila ang mga tanda Niya ay nadaragdagan sila ng pananampalataya at sa Panginoon nila nananalig sila,}</span> <span class="c2">(Qur\'ān 8:2)</span> </p>',
            ],
            37 => [
                'question' => 'T38: Ano ang Iḥsān (Paggawa ng Maganda)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2350.mp3',
                'answer' => '<p> S: Na sumamba ka kay Allāh na para bang ikaw ay nakakikita sa Kanya ngunit kung hindi ka man nakakikita sa Kanya, tunay na Siya ay nakakikita sa iyo. </p>',
            ],
            38 => [
                'question' => 'T39: Kailan ang mga gawain nagiging tanggap sa ganang kay Allāh (kaluwalhatian sa Kanya)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2370.mp3',
                'answer' => '<p> S: Ayon sa dalawang kundisyon:<br /> 1. kapag ito ay naging wagas ukol sa ikalulugod ng mukha ni Allāh <span class="c2">(napakataas Siya)</span> at<br /> 2. kapag ito ay naging ayon sa Sunnah ng Propeta <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span>. </p>',
            ],
            39 => [
                'question' => 'T40: Ano ang pananalig kay Allāh (napakataas Siya)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2420.mp3',
                'answer' => '<p> S: Ito ay ang pagsalig kay Allāh <span class="c2">(napakataas Siya)</span> sa pagtamo ng mga pakinabang at pagtulak sa mga pinsala kalakip ng pagsasagawa ng mga kadahilanan.<span class="c6"><br /> Nagsabi si Allāh:</span> <span class="c4">{Ang sinumang nananalig kay Allāh, Siya ay kasapatan dito.}</span> <span class="c2">(Qur\'ān 65:3)</span><br /> Ang <span class="c4">{kasapatan dito}</span> ay nangangahulugang nakasasapat dito. </p>',
            ],
            40 => [
                'question' => 'T41: Ano ang kinakailangan sa pag-uutos ng nakabubuti at pagsaway sa nakasasama?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2470.mp3',
                'answer' => '<p> S: Ang nakabubuti ay ang pag-uutos ng bawat pagtalima kay Allāh <span class="c2">(kamahal-mahalan Siya at kapita-pitagan)</span> at ang nakasasama ay ang pagsaway sa bawat pagsuway kay Allāh <span class="c2">(kamahal-mahalan Siya at kapita-pitagan)</span>.<span class="c6"><br /> Nagsabi si Allāh:</span> <span class="c4">{Kayo ay pinakamabuting kalipunang pinalabas para sa mga tao. Nag-uutos kayo ng nakabubuti, sumasaway kayo ng nakasasama, at sumasampalataya kayo kay Allāh.}</span> <span class="c2">(Qur\'ān 3:110)</span> </p>',
            ],
            41 => [
                'question' => 'T42: Sino ang mga Alagad ng Sunnah at Bukluran (Ahlussunnah wal Jamaah)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2510.mp3',
                'answer' => '<p> S: Sila ay ang mga nakabatay sa tulad ng kung sa ano nakabatay ang Propeta <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span> at ang mga Kasamahan niya <span class="c2">(napakataas Siya)</span> sa salita, gawa, at paniniwala.<br /> Tinawag silang mga Alagad ng Sunnah dahil sa pagsunod nila sa Sunnah ng Propeta <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span> at pag-iwan nila ng paggawa ng bid`ah<br /> at Bukluran dahil sila ay nagbuklod sa katotohanan at hindi nagkawatak-watak dito. </p>',
            ],
        ],
        2 => [
            0 => [
                'question' => 'T1: Maipapakahulugan mo ba ang ṭahārah (kadalisayan)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2580.mp3',
                'answer' => '<p> S: Ang ṭahārah <span class="c2">(kadalisayan)</span> ay ang pag-alis ng ḥadath at ang paglaho ng karumihan.<br /> Ang ṭahārah sa karumihan ay ang pagpawi ng Muslim ng napunta na najāsah <span class="c2">(karumihan)</span> sa katawan niya o sa kasuutan niya sa puwesto o lugar na pagdarasalan niya.<br /> Ang ṭahārah sa ḥadath ay ang sa pamamagitan ng pagsasagawa ng wuḍū\' o ghusl sa pamamagitan ng tubig na naipandadalisay o ng tayammum para sa sinumang nawalan ng tubig o naging imposible sa kanya ang gumamit nito. </p>',
            ],
            1 => [
                'question' => 'T2: Papaano kang magsasagawa ng ṭahārah sa tinamaan ng najāsah?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2630.mp3',
                'answer' => '<p> S: Sa pamamagitan ng paghuhugas dito gamit ng tubig hanggang sa madalisay.<br /> Hinggil naman sa dinilaan ng aso, huhugasan ito ng pitong ulit, na ang unang paghugas ay may lupa. </p>',
            ],
            2 => [
                'question' => 'T3: Ano ang kainaman ng pagsasagawa ng wuḍū\'?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2660.mp3',
                'answer' => '<p> S: Nagsabi ang Propeta <span class="c2">(sumakanya ang basbas at ang pangangalaga)</span>: "Kapag nagsagawa ng wuḍū\' ang taong Muslim – o ang Mananampalataya – kaya naghugas siya ng mukha niya, lalabas mula sa mukha niya ang bawat pagkakamali na tiningnan ng mga mata niya kasabay ng tubig o kasabay ng huling patak ng tubig; saka kapag naghugas siya ng mga kamay niya, lalabas mula sa mga kamay niya ang bawat pagkakamali na hinagupit ng mga kamay niya kasabay ng tubig o kasabay ng huling patak ng tubig; saka kapag naghugas siya ng mga paa niya, lalabas ang bawat pagkakamali na nilakad ng mga paa niya kasabay ng tubig o kasabay ng huling patak ng tubig, hanggang sa lumabas siya na malinis sa mga pagkakasala." Nagsalaysay nito si Imām Muslim. </p>',
            ],
            3 => [
                'question' => 'T4: Papaano kang magsasagawa ng wuḍū\'?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2690.mp3',
                'answer' => '<p> S: Maghuhugas ka ng mga kamay nang tatlong ulit.<br /> Magmumumog ka, sisinghot ka ng tubig, magsisinga ka nito nang tatlong ulit.<br /> Ang pagmumumog ay ang paglalagay ng tubig sa bibig, pagpapagalaw nito, at ang pagbuga nito.<br /> Ang pagsinghot ay ang paghatak ng tubig sa pamamagitan ng paghinga paloob sa ilong sa pamamagitan ng paglalagay nito ng kanang kamay.<br /> Ang pagsinga ay ang pagpapalabas ng tubig mula sa ilong matapos ng pagsinghot.<br /> Pagkatapos maghuhugas ng mukha nang tatlong ulit.<br /> Pagkatapos maghuhugas ng mga kamay at mga braso hanggang sa lampas sa siko nang tatlong ulit.<br /> Pagkatapos ang pagpahid sa ulo sa pamamagitan ng pagpaparaan ng mga kamay mo mula sa harapan at pagbabalik ng mga ito mula sa likod ng ulo, at pagpapahid sa mga tainga.<br /> Pagkatapos maghuhugas ka ng mga paa mo hanggang sa mga bukungbukong nang tatlong ulit.<br /> Ito ay ang pinakakumpleto. Napagtibay nga iyon ayon sa Propeta <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span> sa mga ḥadīth sa Ṣaḥīḥ Al-Bukhārīy at Ṣaḥīḥ Muslim. Nagsalaysay ng mga ito buhat sa Propeta sina `Uthmān, `Abdullāh bin Zayd, at iba sa dalawang ito. Napagtibay nga rin buhat sa Propeta sa Ṣaḥīḥ Al-<span class="c6">Bukhārīy at iba pa rito:</span> "Na siya ay nagsagawa ng wuḍū\' nang tigdadalawang ulit," na nangangahulugan na siya ay naghuhugas sa bawat bahagi mula sa mga bahagi ng wuḍū\' nang isang ulit o dalawang ulit. </p>',
            ],
            4 => [
                'question' => 'T5: Ano ang mga tungkulin sa wuḍū\' at ang bilang ng mga ito?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2810.mp3',
                'answer' => '<p> T: Ang mga ito ay ang mga gawaing hindi natutumpak ang wuḍū\' ng Muslim kapag nag-iwan siya ng isa sa mga ito.<br /> 1. Ang paghuhugas ng mukha at bahagi nito ang pagmumumog at ang pagsinghot ng tubig.<br /> 2. Ang paghuhugas ng mga kamay at mga braso hanggang sa lampas sa siko.<br /> 3. Ang pagpahid sa ulo at bahagi nito ang mga tainga.<br /> 4. Ang paghuhugas ng mga paa hanggang sa mga bukungbukong.<br /> 5. Ang pagsusunud-sunod ng mga hinuhugasang bahagi sa pamamagitan ng paghuhugas ng mukha, pagkatapos mga kamay at mga braso, pagkatapos pagpahid ng ulo, pagkatapos paghuhugas ng mga paa.<br /> 6. Ang pagtutuluy-tuloy. Ito ay ang pagsasagawa ng wuḍū\' sa sandaling nagkakasunud-sunuran nang walang patlang ng sandali hanggang sa matuyuan ng tubig ang mga hinuhugasang bahagi,<br /> gaya ng pagsasagawa ng kalahating wuḍū\' at pagkukumpleto nito sa ibang sandali, kaya naman hindi tutumpak ang wuḍū\' niya. </p>',
            ],
            5 => [
                'question' => 'T6: Ano ang mga sunnah sa wuḍū\' at ang bilang ng mga ito?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2910.mp3',
                'answer' => '<p> Ang mga sunnah ng wuḍū\' ay ang mga gawaing kung sakaling ginawa niya ay magkakaroon siya ng isang karagdagan sa pabuya at gantimpala at kung sakaling iniwan niya ay hindi magkakaroon ng kasalanan sa kanya at ang wuḍū\' niya ay tumpak.<br /> 1. Ang pagsambit ng bismi –llāh <span class="c2">(sa ngalan ni Allāh)</span>.<br /> 2. Ang paggamit ng siwāk.<br /> 3. Ang paghugas ng mga kamay.<br /> 4. Ang pagsingit ng mga daliri sa mga daliri.<br /> 5. Ang paghuhugas nang makalawa o makatatlo sa mga hinuhugasang bahagi.<br /> 6. Ang pagsisimula sa kanan.<br /> 7. Ang <span class="c5">[pagsambit ng]</span> dhikr matapos ng wuḍū\': "Ashhadu an lā ilāha illa -llāh, waḥdahu lā sharīka lah, wa ashhadu anna muḥammadan `abduhu wa rasūluh. <span class="c2">(Sumasaksi ako na walang Diyos kundi si Allāh – tanging Siya: walang katambal para sa Kanya; at sumasaksi ako na si Muḥammad ay Lingkod Niya at Sugo Niya.)</span>"<br /> 8. Ang pagsasagawa ng ṣalāh na dalawang rak`ah matapos ng wuḍū\'. </p>',
            ],
            6 => [
                'question' => 'T7: Ano ang mga tagasira ng wuḍū\'?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3020.mp3',
                'answer' => '<p> S: Ang anumang lumabas mula sa dalawang labasan, ang ari at ang tumbong, ng ihi at dumi na ihi o dumi o hangin.<br /> Ang pagkatulog o ang pagkabaliw o ang pagkawala ng malay.<br /> Ang pagkain ng karne ng kamelyo.<br /> Ang paghipo ng ari o tumbong sa pamamagitan ng kamay nang walang harang. </p>',
            ],
            7 => [
                'question' => 'T8: Ano ang tayammum?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3080.mp3',
                'answer' => '<p> S: Ang tayammum ay ang paggamit ng alikabok at iba pa rito mula sa tuyong lupa sa sandali ng kawalan ng tubig o pagkaimposible ng paggamit nito. </p>',
            ],
            8 => [
                'question' => 'T9: Papaano kang magsasagawa ng tayammum?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3110.mp3',
                'answer' => '<p> S: Ang pagtapik sa alabok nang nag-iisang ulit sa pamamagitan ng mga palad at ang pagpahid sa mukha at ibabaw ng mga kamay nang nag-iisang ulit. </p>',
            ],
            9 => [
                'question' => 'T10: Ano ang mga tagasira ng tayammum?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3140.mp3',
                'answer' => '<p> S: Ang lahat ng mga tagasira ng wuḍū\'.<br /> Kapag nakatagpo ng tubig. </p>',
            ],
            10 => [
                'question' => 'T11: Ano ang khuff at ang jawrab? Magpapahid ba sa mga ito?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3180.mp3',
                'answer' => '<p> S: Ang khuff ay ang anumang isinusuot sa paa na yari sa katad <span class="c5">[gaya ng sapatos]</span>.<br /> Ang jawrab ay ang anumang isinusuot sa paa na yari sa iba pa sa katad <span class="c5">[gaya ng medyas]</span>.<br /> Isinasabatas ang pagpapahid sa ibabaw ng mga ito sa halip ng paghuhugas ng mga paa. </p>',
            ],
            11 => [
                'question' => 'T12: Bumanggit ka ng kasanhian ng pagpapahid sa khuff.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3230.mp3',
                'answer' => '<p> S: Ang pagpapadali at ang pagpapagaan sa mga tao, lalo na sa mga oras ng ginaw, taglamig, at paglalakbay kung saan humihirap ang paghuhubad ng suot sa mga paa. </p>',
            ],
            12 => [
                'question' => 'T13: Ano ang mga kundisyon ng katumpakan ng pagpapahid sa ibabaw ng khuff?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3260.mp3',
                'answer' => '<p> S: 1. Na isuot ang khuff habang nasa isang ṭahārah <span class="c2">(kadalisayan)</span>,<span class="c6"> ibig sabihin:</span> matapos magsagawa ng wuḍū\'.<br /> 2. Na ang khuff ay ṭāhir <span class="c2">(walang najis)</span> sapagkat hindi pinapayagan ang pagpahid sa may najis.<br /> 3. Na ang khuff ay nakatatakip sa bahagi ng paa na isinasatungkulin hugasan sa wuḍū\'.<br /> 4.<span class="c6"> Na ang pagpahid ay sa loob ng yugtong itinakda:</span> para sa residente na hindi naglalakbay ay isang araw at isang gabi at para sa naglalakbay ay tatlong araw at mga gabi ng mga ito. </p>',
            ],
            13 => [
                'question' => 'T14: Ano ang paraan ng pagpapahid sa ibabaw ng khuff?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3320.mp3',
                'answer' => '<p> S: Hinggil sa paraan ng pagpapahid, ito ay ang maglagay ng mga daliring binasa sa tubig sa ibabaw ng mga daliri ng mga paa, pagkatapos padaraanin ang mga palad hanggang sa lulod, na pinapahiran ang kanang paa ng kanang kamay at ang kaliwang paa ng kaliwang paa habang pinaghihiwalay ang mga daliri kapag nagpahid at hindi ito inuulit. </p>',
            ],
            14 => [
                'question' => 'T15: Ano ang nakasisira sa pagkapahid sa ibabaw ng khuff?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3350.mp3',
                'answer' => '<p> S: 1. Ang pagkawakas ng yugto <span class="c5">[ng bisa]</span> ng pagpapahid kaya naman hindi pinapayagan ang pagpahid <span class="c5">[na muli]</span> sa khuff matapos ng pagkawakas ng yugto <span class="c5">[ng bisa]</span> ng pagpapahid na itinakda ayon sa Sharī`ah, na isang araw at isang gabi para sa residente at tatlong araw at mga gabi ng mga ito para sa naglalakbay.<br /> 2. Ang pagkahubad ng khuff kaya naman kapag inalis ng tao ang khuff o ang isa sa dalawang bahagi nito matapos ng pagpahid sa paa, mawawalang-bisa ang pagkapahid sa mga ito. </p>',
            ],
            15 => [
                'question' => 'T16: Ano ang kahulugan ng ṣalāh?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3390.mp3',
                'answer' => '<p> S: Ang ṣalāh ay ang pagsasamba kay Allāh sa pamamagitan ng mga sinasabi at mga ginagawang itinakda, na pinasisimulan ng takbīr at pinawawakasan ng taslīm. </p>',
            ],
            16 => [
                'question' => 'T17: Ano ang hatol sa ṣalāh?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3420.mp3',
                'answer' => '<p> S: Ang ṣalāh ay isang tungkulin sa bawat Muslim.<span class="c6"><br /> Nagsabi si Allāh:</span> <span class="c4">{Tunay na ang pagdarasal, laging para sa mga mananampalataya, ay isang atas na tinakdaan ng panahon.}</span> <span class="c2">(Qur\'ān 4:103)</span> </p>',
            ],
            17 => [
                'question' => 'T18: Ano ang hatol sa pag-iwan ng ṣalāh?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3460.mp3',
                'answer' => '<p> S: Ang pag-iwan ng ṣalāh ay isang kufr <span class="c2">(kawalang-pananampalataya)</span>. Nagsabi ang Propeta <span class="c2">(sumakanya ang basbas at ang pangangalaga)</span>:<br /> "Ang kasunduan na nasa pagitan natin at nila ay ang ṣalāh, kaya ang sinumang umiwan nito ay tumanggi ngang sumampalataya."<br /> Nagsalaysay nito sina Imām Aḥmad at Imām At-Timidhīy, at iba pa sa kanilang dalawa. </p>',
            ],
            18 => [
                'question' => 'T19: May ilang ṣalāh na kinakailangan sa Muslim sa araw at gabi? Ilan ang bilang ng mga rak`ah ng bawat ṣalāh?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3500.mp3',
                'answer' => '<p> S: Limang ṣalāh sa araw at gabi: sa ṣalāh sa fajr <span class="c2">(madaling-araw)</span> ay dalawang rak`ah, sa ṣalāh sa ḍ̆uhr <span class="c2">(tanghali)</span> ay apat na rak`ah, sa ṣalāh sa `aṣr <span class="c2">(hapon)</span> ay apat na rak`ah, sa ṣalāh sa maghrib <span class="c2">(pagkalubog ng araw)</span> ay tatlong rak`ah, at sa ṣalāh sa `ishā\' <span class="c2">(gabi)</span> ay apat na rak`ah. </p>',
            ],
            19 => [
                'question' => 'T20: Ano ang mga kundisyon ng ṣalāh?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3530.mp3',
                'answer' => '<p> S: 1. Ang pagkaanib sa Islām, kaya hindi natutumpak ito mula sa isang tagatangging-sumampalataya sa Islām.<br /> 2. Ang pagkakaroon ng isip, kaya hindi natutumpak ito mula sa isang baliw.<br /> 3. Ang pagkakaroon ng kamalayan, kaya hindi natutumpak ito mula sa isang bata na walang malay.<br /> 4. Ang layunin.<br /> 5. Ang pagpasok ng oras ng ṣalāh.<br /> 6. Ang pagkakaroon ng ṭahārah dahil sa pagkaalis ng ḥadath.<br /> 7. Ang pagkadalisay mula sa najāsah.<br /> 8. Ang pagtatakip ng `awrah.<br /> 9. Ang pagharap sa qiblah. </p>',
            ],
            20 => [
                'question' => 'T21: Ano ang bilang ng mga haligi ng ṣalāh?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3640.mp3',
                'answer' => '<p> S: Ito ay 14 haligi,<span class="c6"> ayon sa sumusunod:</span><br /> 1. Ang pagtindig sa tungkuling ṣalāh sa nakakakaya;<br /> 2. Ang takbīratul\'iḥrām <span class="c2">(panimulang takbīr)</span> at ito ay ang pagsabi ng Allāhu akbar;<br /> 3. Ang pagbigkas ng Al-Fātiḥah;<br /> 4. Ang rukū\' <span class="c2">(pagyukod)</span>: iuunat niya ang likod niya nang tuwid at ilalagay ang ulo niya nang kanibel ng likod niya;<br /> 5. Ang pag-angat mula sa rukū\';<br /> 6. Ang pagtindig nang tuwid;<br /> 7. Ang sujūd <span class="c2">(pagpapatirapa)</span> at ang paglapag ng noo at ilong, mga palad, mga tuhod, at mga dulo ng mga daliri ng mga paa mula sa lugar ng pagpapatirapa;<br /> 8. Ang pag-angat mula sa sujūd;<br /> 9. Ang pagkakaupo sa pagitan ng dalawang pagpapatirapa,<span class="c6"><br /> na ang sunnah ay na maupo sa upong muftarish:</span> nakaupo sa kaliwang paa at nakatukod ang kanang paa habang naghaharap nito sa qiblah;<br /> 10. Ang kapanatagan at ito ay ang katiwasayan sa haliging panggawain;<br /> 11. Ang huling tashahhud;<br /> 12. Ang pag-upo para sa tashahhud;<br /> 13. Ang dalawang taslīm at ito ay ang pagsabi nang dalawang beses ng "assalāmu `alaykum wa-raḥmatu –llāh";<br /> 14. Ang pagkakasunud-sunod ng mga haligi – gaya ng nabanggit natin – kaya kung sakaling nagpatirapa siya bago ng pagyukod niya, halimbawa, mawawalang-saysay ang ṣalāh kung sinadya iyon at kakailanganin ang bumalik upang yumukod pagkatapos magpapatirapa siya kung nakalimot. </p>',
            ],
            21 => [
                'question' => 'T22: Mababanggit mo ba ang mga kinakailangan sa ṣalāh?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3820.mp3',
                'answer' => '<p> S: Ang mga kinakailangan sa ṣalāh. Ang mga ito ay walo,<span class="c6"> ayon sa sumusunod:</span><br /> 1. Ang lahat ng mga takbīr na iba pa sa takbīratul\'iḥrām <span class="c2">(panimulang takbīr)</span>;<br /> 2. Ang pagsabi ng "Sami`a –llāhu liman ḥamidah <span class="c2">(Duminig si Allāh sa sinumang nagpuri sa Kanya)</span>";<br /> 3. Ang pagsabi ng "Rabbanā wa-laka –lḥamd <span class="c2">(Panginoon namin, at ukol sa iyo ang papuri)</span>";<br /> 4. Ang pagsabi ng "Subḥāna rabbiya –­l`ađīm <span class="c2">(Kaluwalhatian sa Panginoon ko, ang Sukdulan)</span>" nang isang ulit habang nasa pagkakayukod;<br /> 5. Ang pagsabi ng "subḥāna rabbiya –­l\'a`lā <span class="c2">(kaluwalhatian sa Panginoon ko, ang Pinakamataas)</span>" nang isang ulit habang nasa pagkakapatirapa;<br /> 6. Ang pagsabi ng "Rabbi –ghfir lī <span class="c2">(Panginoon ko, magpatawad Ka sa akin)</span>" sa pagitan ng dalawang pagpapatirapa;<br /> 7. Ang unang tashahhud;<br /> 8. Ang pag-upo para sa unang tashahhud. </p>',
            ],
            22 => [
                'question' => 'T23: Ano ang mga sunnah ng ṣalāh?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3930.mp3',
                'answer' => '<p> S: Labing-isang sunnah,<span class="c6"> ayon sa sumusunod:</span><br /> 1. Ang pagsabi matapos ng takbīratul\'iḥrām <span class="c2">(panimulang takbīr)</span>: "Subḥānaka –llāhumma wa-bi-ḥamdika wa-tabāraka –smuka wa-ta`ālā jadduka wa-lā ilāha ghayruk. <span class="c2">(Kaluwalhatian sa Iyo, O Allāh, kalakip ng papuri sa Iyo; napakamapagpala ang ngalan Mo, napakataas ang kabunyian Mo, at walang Diyos na iba pa sa Iyo.)</span>" Tinatawag ito ng panalangin ng pagbubukas.<br /> 2. Ang ta`awwudh <span class="c2">(panalangin ng pagpapakupkop)</span>.<br /> 3. Ang basmalah.<br /> 4. Ang pagsabi ng āmīn.<br /> 5. Ang pagbigkas ng sūrah matapos ng Al-Fātiḥah.<br /> 6. Ang pagbigkas nang malakas para sa imām.<br /> 7. Ang pagsabi, matapos ng taḥmīd,<span class="c6"> ng:</span> "mil\'a -l\'arḍi wa-mil\'a mā shi\'ta min shay\'im ba`d <span class="c2">(Makapupuno ng mga langit, makapupuno ng lupa, at makapupuno ng anumang bagay na niloob Mo pagkatapos)</span>".<br /> 8. Ang anumang lumabis sa isang beses sa tasbīḥ ng pagkakayukod,<span class="c6"> ibig sabihin:</span> ang unang tasbīḥ, ang ikalawang tasbīḥ, at anumang lumabis doon.<br /> 9. Ang anumang lumabis sa isang beses sa tasbīḥ ng pagkapatirapa.<br /> 10.<span class="c6"> Ang anumang lumabis sa isang beses sa sinasabi sa pagitan ng dalawang pagpapatirapa na:</span> rabbi –ghrif lī.<br /> 11. Sa huling tashahhud, ang pagbigkas ng ṣalāh <span class="c2">(panalangin ng basbas)</span> sa mag-anak ng Propeta <span class="c2">(sumakanila ang pangangalaga)</span> at barakah <span class="c2">(panalangin ng pagpapala)</span> sa kanya at sa kanila at pagdalangin matapos nito.<span class="c6"><br /> Ikaapat:</span> Ang mga sunnah ng mga gawain. Tinatawag ang mga ito na mga anyo.<br /> 1. Ang pag-angat ng mga kamay kasama ng takbīratul\'iḥrām.<br /> 2. Ang pag-angat ng mga kamay sa sandali ng pagyukod.<br /> 3. Ang pag-angat ng mga kamay sa sandali ng pag-angat mula sa pagkakayukod.<br /> 4. Ang pagbaba ng mga kamay matapos niyon.<br /> 5. Ang pagpatong ng kanang kamay sa kaliwang kamay.<br /> 6. Ang pagtingin sa nilalapagan ng pagpapatirapa.<br /> 7. Ang paghihiwalay ng mga paa habang nakatayo.<br /> 8. Ang paghawak ng mga kamay sa mga tuhod habang magkakahiwalay ang mga daliri sa pagkakayukod, ang pag-unat ng likod, at ang paglalagay ng ulo nang kanibel ng likod.<br /> 9. Ang paglapag ng mga bahagi ng katawan para sa pagpapatirapa sa lapag at ang pagdikit ng mga ito sa kinalalagyan ng pagpapatirapa.<br /> 10. Ang paghihiwalay ng mga braso sa mga tagiliran, ng tiyan sa mga hita, at ng mga hita sa mga binti. Ang pagpapahiwalay ng mga tuhod. Ang pagtutukod ng mga paa. Ang paglalagay ng mga ilalim ng mga daliri ng mga paa sa lapag nang magkakahiwalay. Ang paglalagay ng mga kamay nang pantay sa mga balikat habang nakaunat na nakadikit ang mga daliri.<br /> 11. Ang upong iftirāsh sa pag-upo sa pagitan ng dalawang patirapa, sa unang tashahhud at ang upong tawarruk sa ikalawang tashahhud.<br /> 12. Ang paglalagay ng mga kamay sa mga hita habang nakaunat na nakadikit ang mga daliri sa pagitan ng dalawang patirapa at gayon din sa tashahhud subalit siya ay magkukuyom, mula sa kanang kamay, ng hinliliit at palasingsingan, magbibilog ng hinlalaki kasama ng hinggigitna, at magtuturo ng hintuturo sa sandali ng pagbanggit kay Allāh.<br /> 13. Ang paglingon sa kanan at kaliwa sa pagsasagawa ng taslīm. </p>',
            ],
            23 => [
                'question' => 'T24: Ano ang mga bilang ng mga tagapawalang-saysay ng ṣalāh?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4210.mp3',
                'answer' => '<p> S: 1. Ang pag-iwan sa isang haligi o isang kundisyon mula sa mga kundisyon ng ṣalāh.<br /> 2. Ang pagsasalita nang sadyaan.<br /> 3. Ang pagkain at ang pag-inom.<br /> 4. Ang maraming magkakasunud-sunod na pagkilos.<br /> 5. Ang pag-iwan sa isang kinakailangan mula sa mga kinakailangan sa ṣalāh nang sadyaan. </p>',
            ],
            24 => [
                'question' => 'T25:',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4280.mp3',
                'answer' => '<p> S: Ang Pamamaraan ng Pagsasagawa ng Ṣalāh<br /> 1. Na humarap siya sa qiblah kasama ng buong katawan niya nang walang paglihis o paglingon;<br /> 2. Pagkatapos maglalayon siya ng ṣalāh na ninanais na dasalin sa puso niya nang walang pagbanggit ng layunin.<br /> 3. Pagkatapos magsasagawa siya ng takbīratul\'iḥrām kaya magsasabi siya ng Allāhu akbar habang nag-aangat ng mga kamay niya nang pantay sa mga balikat niya sa sandali ng takbīr.<br /> 4. Pagkatapos maglalagay siya ng palad ng kanang kamay niya sa ibabaw ng kaliwang kamay niya sa ibabaw ng dibdib niya.<br /> 5. Pagkatapos dadalangin siya <span class="c5">[nang tahimik]</span> ng du`ā\'ul\'istiftāḥ <span class="c2">(panalangin ng pagbubukas)</span> kaya magsasabi siya: 6. "Allāhumma bā`id baynī wa bayna khaṭāyāya kamā bā`adta bayna -lmashriqi wa -lmaghribi. Allāhumma naqqinī min khaṭāyāya kamā yunaqqa -ththawbu -l\'abyaḍu mina -ddanasi. Allāhumma -ghsil khaṭāyāya bi-lmā\'i wa -ththalji wa -lbarad. <span class="c2">(O Allāh, magpalayo Ka sa pagitan ko at ng mga kamalian ko kung paanong nagpalayo Ka sa pagitan ng silangan at kanluran. O Allāh, magdalisay Ka sa akin mula sa mga kamalian ko kung paanong dinadalisay ang puting kasuutan mula sa karumihan. O Allāh, maghugas Ka sa akin ng mga kamalian ko ng tubig, niyebe, at namuong yelo.)</span>"<br /> O magsasabi siya: "Subḥānaka -llāhumma wa biḥamdika wa tabāraka -smuka wa ta`ālā jadduka wa lā ilāha ghayruk. <span class="c2">(Kaluwalhatian sa Iyo, o Allāh, at kalakip ng papuri sa Iyo. Mapagpala ang ngalan Mo, pagkataas-taas ang kabunyian Mo, at walang Diyos na iba pa sa Iyo.)</span>"<br /> 6,<span class="c6"> Pagkatapos mananalangin siya ng pagpapakupkop kaya magsasabi siya:</span> "<span class="c2">(Nagpapakupkop ako kay Allāh laban sa isinumpang Demonyo)</span>" 7. Pagkatapos sasambitin niya ang basmalah at bibigkasin ang Al-<span class="c6">Fātiḥah kaya magsasabi siya:</span> 1. <span class="c2">(Sa ngalan ni Allāh, ang Napakamaawain, ang Maawain.)</span> 2. <span class="c2">(Ang papuri ay ukol kay Allāh, ang Panginoon ng mga nilalang,)</span> 3. <span class="c2">(ang Napakamaawain, ang Maawain,)</span> 4. <span class="c2">(ang Tagapagmay-ari ng Araw ng Pagtutumbas.)</span> 5. <span class="c2">(Sa Iyo <span class="c5">[lamang]</span> kami sumasamba at sa Iyo <span class="c5">[lamang]</span> kami nagpapatulong.)</span> 6. <span class="c2">(Patnubayan Mo kami sa landasing tuwid:)</span> 7. <span class="c2">(ang landasin ng mga biniyayaan Mo, hindi ng mga kinagalitan, at hindi ng mga naliligaw.)</span> <span class="c2">(Qur\'ān 1:1-7)</span><br /> Pagkatapos magsasabi ako ng: "Āmīn.<span class="c6">" Nangangahulugan ito:</span> "O Allāh, tugunin Mo."<br /> 8. Pagkatapos bibigkas siya ng anumang madali mula sa Qur\'ān at magpapahaba siya ng pagbigkas sa ṣalāh sa fajr.<br /> 9. Pagkatapos yuyukod siya, ibig sabihin, magbababa siya ng likod niya bilang pagdakila kay Allāh. Sasambit siya ng takbīr sa sandali ng pagyukod niya. Mag-aangat siya ng mga kamay niya nang pantay sa balikat niya. Ang sunnah ay na mag-unat siya ng likod niya, maglagay siya ng ulo niya nang kanibel ng likod, at maglagay ng mga kamay niya sa mga tuhod niya nang magkakahiwalay ang mga daliri.<br /> 10. Magsasabi siya, sa pagkakayukod niya,<span class="c6"> ng:</span> "Subḥāna rabbiya –l\'adhim <span class="c2">(Kaluwalhatian sa Panginoon ko, ang Pinakadakila)</span>" nang tatlong ulit.<span class="c6"> Kung magdaragdag siya ng:</span> "Subḥānaka –llāhumma wa bi-ḥamdik, Allāhumma –ghfir lī <span class="c2">(Kaluwalhatian sa Iyo, O Allāh, at kalakip ng papuri sa Iyo. O Allāh, magpatawad Ka sa akin)</span>," ay maganda.<br /> 11. Pagkatapos mag-<span class="c6">aangat siya ng ulo niya mula sa pagkakayukod habang nagsasabi:</span> "Sami`a –llāhu liman ḥamidah <span class="c2">(Duminig si Allāh sa sinumang nagpuri sa Kanya)</span>" at mag-aangat siya ng mga kamay niya sa sandaling iyon nang pantay sa balikat niya.<span class="c6"> Ang ma\'mūm naman ay hindi magsasabi ng:</span> "Sami`a –llāhu liman ḥamidah" at magsasabi lamang siya ng kapalit nito: "Rabbanā wa-laka –lḥamd".<br /> 12.<span class="c6"> Pagkatapos magsasabi siya ng:</span> "Rabbanā wa laka -lḥamd, mil\'a -ssamāwāti wa mil\'a -l\'arḍ, wa mil\'a mā shi\'ta min shay\'im ba`d <span class="c2">(Panginoon namin, at ukol sa Iyo ang papuri, na kasimpuno ng mga langit, kasimpuno ng lupa, at kasimpuno ng anumang bagay na niloob Mo matapos niyon.)</span>"<br /> 13. Pagkatapos magpapatirapa siya ng unang pagpapatirapa. Magsasabi siya, sa sandali ng pagkakapatirapa niya, ng Allāhu akbar.<span class="c6"> Magpapatirapa siya na nakadikit sa lapag ang pitong bahagi ng katawan:</span> ang noo at ilong, ang mga palad ng kamay, ang mga tuhod, at ang mga dulo ng mga paa. Maglalayo siya ng mga braso niya sa mga tagiliran ng katawan at hindi siya maglalatag ng mga braso niya sa lapag. Maghaharap siya sa qiblah ng mga dulo ng mga daliri niya.<br /> 14. Magsasabi siya, sa pagkapatirapa niya,<span class="c6"> ng:</span> "Subḥāna rabbiya -­l\'a`lā <span class="c2">(Kaluwalhatian sa Panginoon ko, ang Pinakamataas)</span>" nang tatlong ulit.<span class="c6"> Kung magdaragdag siya ng:</span> "Subḥānaka -llāhumma wa biḥamdik, Allāhumma -ghfir lī <span class="c2">(Kaluwalhatian sa Iyo, O Allāh, at kalakip ng papuri sa Iyo. O Allāh, magpatawad Ka sa akin)</span>," ay maganda.<br /> 15. Pagkatapos mag-aangat siya ng ulo niya <span class="c5">[kasama ng katawan]</span> mula sa pagkakapatirapa habang nagsasabi ng Allāhu akbar.<br /> 16. Pagkatapos uupo siya sa pagitan ng dalawang pagpapatirapa sa kaliwang paa niya at magtutukod siya ng kanang paa niya. Maglalagay siya ng kanang kamay niya sa dulo ng kanang hita niya nang malapit sa tuhod niya at magkukuyom siya, mula sa kanang kamay, ng hinliliit at palasingsingan. Mag-aangat siya ng hintuturo at magpapagalaw nito sa sandali ng pagdalangin niya. Maglalagay siya ng dulo ng hinlalaki na nakaugnay sa dulo ng hinggigitna gaya ng aro <span class="c2">(loop)</span>. Maglalagay siya ng kaliwang kamay niya na nakalatag ang mga daliri sa dulo ng kaliwang hita niya nang malapit sa tuhod.<br /> 17.<span class="c6"> Magsasabi siya sa pagkakaupo niya sa pagitan ng dalawang patirapa:</span> "Rabbi –ğfir lī, wa-rḥamnī, wa-hdinī, wa-rzuqnī, wa-jburnī, at wa-`āfinī <span class="c2">(Panginoon ko, magpatawad Ka sa akin, maawa Ka sa akin, magpatnubay Ka sa akin, magtustos Ka sa akin, magpuno Ka sa akin, at magpalusog Ka sa akin.)</span>"<br /> 18. Pagkatapos magpapatirapa siya ng ikalawang pagpapatirapa gaya ng una sa sinasabi at ginagawa. Magsasagawa siya ng takbīr sa sandali ng pagpapatirapa niya.<br /> 19. Pagkatapos babangon siya mula sa ikalawang pagpapatirapa habang nagsasabi ng Allāhu Akbar. Magdarasal siya ng ikalawang rak`ah gaya ng una sa sinasabi at ginagawa maliban na siya ay hindi dadalangin <span class="c5">[nang tahimik]</span> ng du`ā\'ul\'istiftāḥ dito.<br /> 20. Pagkatapos uupo siya matapos ng pagwawakas ng ikalawang rak`ah habang nagsasabi ng Allāhu Akbar at uupo siya gaya ng pag-upo niya sa pagitan ng dalawang pagkakapatirapa.<br /> 21.<span class="c6"> Bibigkas siya ng tashahhud sa pagkakaupong ito kaya magsasabi siya ng:</span> "Attaḥīyātu lillāhi wa-ṣṣalawātu wa-ṭṭayyibāt, assalāmu `alayka ayyuha –nnabīyu wa-raḥmatu –llāhi wa-barakātuh, assalāmu `alaynā wa-`alā `ibādi –llāhi –ṣṣālihīn, ashhadu an lā ilāha illa –llāh, wa-ashhadu anna muḥammadan `abduhu wa-rasūluh. Allāhumma ṣalli `alā Muḥammadin wa-`alā āli Muḥammadin kamā ṣallayta `alā Ibrāhīm wa-`alā āli Ibrāhīm, innaka ḥamīdum majīd; Allāhumma bārik `alā Muḥammadin wa-`alā āli Muḥammadin kamā bārakta `alā Ibrāhīm wa-`alā āli Ibrāhīm; innaka ḥamīdum majīd. <span class="c2">(Ang mga pagbati ay ukol kay Allāh, at ang mga dasal at ang mga kaaya-ayang gawain. Ang pagbati ay ukol sa iyo, O Propeta, at ang awa ni Allāh at ang mga pagpapala Niya. Ang pagbati ay ukol sa atin at ukol sa mga maayos na lingkod ni Allāh. Sumasaksi ako na walang Diyos kundi si Allāh at sumasaksi ako na si Muḥammad ay Lingkod Niya at Sugo Niya. O Allāh, basbasan Mo si Muḥammad at ang mag-anak ni Muḥammad gaya ng pagbasbas Mo kay Abraham at sa mag-anak ni Abraham; tunay na Ikaw ay Kapuri-puri, Maringal. O Allāh, biyayaan Mo si Muḥammad at ang mag-anak ni Muḥammad gaya ng pagbiyaya Mo kay Abraham at sa mag-anak ni Abraham; tunay na Ikaw ay Kapuri-puri, Maringal.)</span> Pagkatapos dadalangin siya sa Panginoon niya ng anumang naiibigan niya mula sa mabuti sa Mundo at mabuti sa Kabilang-buhay.<br /> 22.<span class="c6"> Pagkatapos magsasagawa siya ng taslīm sa dakong kanan niya habang nagsasabi ng:</span> "Assalāmu `alaykum wa raḥmatu ­-llāh." Pagkatapos gayon din sa dakong kaliwa naman.<br /> 23. Kapag ang ṣalāh ay tatluhang rak`ah o apatang rak`ah,<span class="c6"> hihinto siya sa katapusan ng unang tashahhud:</span> ang pagsabi ng: Ashhadu an lā ilāha illa –llāh, wa-ashhadu anna muḥammadan `abduhu wa-rasūluh.<br /> 24. Pagkatapos babangon siya para tumayo habang nagsasabi ng Allāhu akbar at mag-aangat siyang mga kamay niya nang pantay sa balikat niya sa sandaling iyon.<br /> 25. Pagkatapos dadasalin niya ang natira mula sa ṣalāh niya ayon sa pagsasagawa ng ikalawang rak`ah subalit siya ay magkakasya sa pagbigkas ng Al-Fātiḥah.<br /> 26.<span class="c6"> Pagkatapos uupo siya nang upong tawarruk:</span> magtutukod siya ng kanang paa niya, maglalabas siya ng kaliwang paa niya mula sa ilalim ng kanang binti niya, maglalapag siya ng pigi niya sa lapag, maglalagay siya ng mga kamay niya sa hita niya ayon sa pagkalarawan ng pagkalagay nito sa unang tashahhud.<br /> 27. Bibigkasin niya sa pagkakaupong ito ang tashahhud sa kabuuan nito.<br /> 28.<span class="c6"> Pagkatapos magsasagawa siya ng taslīm sa dakong kanan niya habang nagsasabi ng:</span> "Assalāmu `alaykum wa raḥmatu ­-llāh." Pagkatapos gayon din sa dakong kaliwa naman. </p>',
            ],
            25 => [
                'question' => 'T26: Ano ang sasabihin na mga dhikr matapos ng taslīm ng ṣalāh?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4610.mp3',
                'answer' => '<p> S: Astaghfiru –llāh <span class="c2">(Humihingi ako ng tawad kay Allāh)</span>, tatlong beses.<br /> Allāhumma anta –ssalāmu wa-minka –ssalām, tabārakta yā dha –ljalāli wa –l\'ikrām. <span class="c2">(O Allāh, Ikaw ang Sakdal at mula sa Iyo ang kapayapaan. Napakamapagpala Mo, o pinag-uukulan ng pagpipitagan at pagpaparangal.)</span><br /> Lā ilāha illa –llāhu waḥdahu lā sharīka lah, lahu –lmulku wa-lahu –lḥamd, wa-huwa `alā kulli shay\'in qadīr. Allāhumma lā māni`a limā a`ṭayta, wa-lā mu`ṭiya limā mana`ta, wa-lā yanfa`u dha –ljaddi minka –ljadd. <span class="c2">(Walang Diyos kundi si Allāh – tanging Siya, walang katambal para sa Kanya. Ukol sa Kanya ang paghahari at ukol sa Kanya ang papuri. Siya sa bawat bagay ay May-kapangyarihan. O Allāh, walang makapipigil sa anumang ibinigay Mo at walang makapagbibigay sa anumang pinigil Mo. Hindi makapagpapakinabang sa may yaman laban sa Iyo ang yaman)</span>.<br /> Lā ilāha illa –llāhu waḥdahu lā sharīka lah, lahu –lmulku wa lahu –lḥamd, wa-huwa `alā kulli shay\'in qadīr. Lā hawla wa-lā qūwata illā bi-llāh. Lā llāha illa –llāh, wa-lā na`budu illā iyyāh, lahu –nni`matu wa-lahu –lfaḍlu wa-lahu –ththanā\'u –lḥasan. Lā ilāha illa –llāhu mukhliṣīna lahu –ddīna wa-law kariha -lkāfirūn. <span class="c2">(Walang Diyos kundi si Allāh – tanging Siya: walang katambal para sa Kanya. Ukol sa Kanya ang paghahari at ukol sa Kanya ang papuri, at Siya sa bawat bagay ay May-kakayahan. Walang kapangyarihan at walang lakas kundi sa pamamagitan ni Allāh. Walang Diyos kundi si Allāh, at wala tayong sinasamba kundi Siya. Ukol sa Kanya ang pagbibiyaya at ukol sa Kanya ang pagmamabuting-loob at ukol sa Kanya ang magandang pagbubunyi. Walang Diyos kundi si Allāh. <span class="c5">[Tayo ay]</span> mga nagpapakawagas sa Kanya sa pagtalima, kahit pa man masuklam ang mga tagatangging-sumampalataya.)</span><br /> Subḥāna -llāhi wa biḥamdihi <span class="c2">(Kaluwalhatian kay Allāh.)</span>, 33 beses.<br /> Alḥamdu lillāh <span class="c2">(Ang papuri ay ukol kay Allāh.)</span> 33 beses.<br /> Allāhu akbar <span class="c2">(Si Allāh ay pinakadakila.)</span> 33 beses.<span class="c6"><br /> Pagkatapos magsasabi siya sa paglulubos ng isandaan:</span> Lā ilāha illa –­llāhu waḥdahu lā sharīka lah, lahu –­lmulku wa lahu –lḥamd, wa huwa `alā kulli shay\'in qadīr <span class="c2">(Walang Diyos kundi si Allāh – tanging Siya, walang katambal para sa Kanya. Ukol sa Kanya ang paghahari at ukol sa Kanya ang papuri. Siya sa bawat bagay ay May-kapangyarihan)</span>.<br /> Bibigkasin ang Sūrah Al-Ikhlāṣ <span class="c2">(Qur\'ān 112)</span>, ang Sūrah Al-Falaq <span class="c2">(Qur\'ān 113)</span>, at ang Sūrah An-Nās <span class="c2">(Qur\'ān 114)</span> nang tigtatlong beses matapos ng ṣalāh na fajr at ṣalāh na maghrib at nang tig-isang beses matapos ng mga iba pang ṣalāh.<br /> Bibigkasin ang Āyatulkursīy <span class="c2">(Qur\'ān 2:255)</span> nang isang beses. </p>',
            ],
            26 => [
                'question' => 'T27: Ano ang mga sunnah rātibah? Ano ang kainaman ng mga ito?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4730.mp3',
                'answer' => '<p> S: Dalawang rak`ah bago ng ṣalāh na fajr;<br /> Apat na rak`ah bago ng ṣalāh na ḍ̆uhr;<br /> Dalawang rak`ah matapos ng ṣalāh na ḍ̆uhr;<br /> Dalawang rak`ah matapos ng ṣalāh na maghrib;<br /> Dalawang rak`ah matapos ng ṣalāh na `ishā\'.<br /> Ang kainaman ng mga ito ay sinabi ng Propeta <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span>: "Ang sinumang nagdarasal sa araw at gabi nang labindalawang rak`ah bilang pagkukusang-loob, magpapatayo si Allāh para sa kanya ng isang bahay sa Paraiso." Nagsalaysay nito sina Imām Muslim, Imām Aḥmad, at iba pa sa kanilang dalawa. </p>',
            ],
            27 => [
                'question' => 'T28: Ano ang pinakamainam sa mga araw ng linggo.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4800.mp3',
                'answer' => '<p> S: Ang araw ng Biyernes. Nagsabi ang Propeta <span class="c2">(sumakanya ang basbas at ang pangangalaga)</span>: "Tunay na kabilang sa pinakamainam sa mga araw ninyo ang araw ng Biyernes; dito nilikha si Adan, dito siya kinuha, dito ang <span class="c5">[huling]</span> pag-ihip <span class="c5">[sa tambuli]</span>, at dito <span class="c5">[magaganap]</span> ang hiyaw, kaya magpadalas kayo ng panalangin ng basbas sa akin dito sapagkat tunay na ang panalangin ninyo ng basbas ay inilalahad sa Akin.<span class="c6">" Nagsabi sila:</span> "O Sugo ni Allāh,<span class="c6"> papaano pong inilalahad ang panalangin namin ng basbas sa iyo samantalang nabukbok ka na?" Iniibig nilang sabihin:</span> "Nabulok ka na.<span class="c6">" Kaya nagsabi siya:</span> "Tunay na si Allāh <span class="c2">(kamahal-mahalan Siya at kapita-pitagan)</span> ay nagkait sa lupa ng mga katawan ng mga propeta." Nagsalaysay nito sina Imām Abū Dāwud at iba pa sa kanya. </p>',
            ],
            28 => [
                'question' => 'T29: Ano ang hatol sa ṣalāh sa Biyernes?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4840.mp3',
                'answer' => '<p> S: Isang tungkulin ng individuwal sa bawat Muslim na lalaki, nasa hustong gulang, nakapag-uunawa, at residente.<span class="c6"><br /> Nagsabi si Allāh:</span> <span class="c4">{O mga sumampalataya, kapag nanawagan para sa pagdarasal sa araw ng Biyernes ay magmadali kayo sa pag-alaala kay Allāh at iwan ninyo ang pagtitinda. Iyon ay higit na mabuti para sa inyo kung kayo ay nakaaalam.}</span> <span class="c2">(Qur\'ān 62:9)</span> </p>',
            ],
            29 => [
                'question' => 'T30: Ilan ang bilang ng mga rak`ah ng ṣalāh sa Biyernes?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4880.mp3',
                'answer' => '<p> S: Ang bilang ng mga rak`ah ng ṣalāh sa Biyernes ay dalawang rak`ah, na nagpapalakas sa dalawang ito ang imām ng pagbigkas, kung saan nauunahan ang dalawang ito ng dalawang kilalang khuṭbah. </p>',
            ],
            30 => [
                'question' => 'T31: Pinapayagan ba ang pagliban sa ṣalāh sa Biyernes?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4910.mp3',
                'answer' => '<p> S: Hindi pinapayagan ang pagliban sa ṣalāh sa Biyernes maliban may isang legal na maidadahilan. Nasaad sa Propeta <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span> ang sabi niya: "Ang sinumang nag-iwan ng tatlong ṣalāh sa biyernes dala ng pagwawalang-bahala, magpipinid si Allāh sa puso niya." Nagsalaysay nito sina Imām Abū Dāwud at iba pa sa kanya. </p>',
            ],
            31 => [
                'question' => 'T32: Makababanggit ka ba ng mga sunnah ng araw ng Biyernes?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4940.mp3',
                'answer' => '<p> S:<br /> 1. Ang pagpaligo;<br /> 2. Ang pagpapabango;<br /> 3. Ang pagsusuot ng pinakamagandang damit;<br /> 4. Ang pagpapaaga ng pagpunta sa masjid;<br /> 5. Ang pagpaparami ng pagdalangin ng basbas sa Propeta <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span>;<br /> 6. Ang pagbigkas ng Sūrah Al-Kahf;<br /> 7. Ang pagpunta sa masjid nang naglalakad;<br /> 8. Ang paghahanap ng oras ng pagtugon sa panalangin. </p>',
            ],
            32 => [
                'question' => 'T33: Makababanggit ka ba ng kainaman ng ṣalāh sa jamā`ah (konggregasyon)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5050.mp3',
                'answer' => '<p> S: Ayon kay `Abdullāh bin `Umar <span class="c2">(malugod si Allāh sa kanilang dalawa)</span>, ang Sugo ni Allāh <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span> ay nagsabi: "Ang pagdarasal sa jamā`ah ay higit na mainam mula sa pagdarasal ng nag-iisa nang dalawampu\'t pitong antas." Nagsalaysay nito si Imām Muslim. </p>',
            ],
            33 => [
                'question' => 'T34: Ano ang kataimtiman sa ṣalāh?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5080.mp3',
                'answer' => '<p> S: Ito ay ang pagkadalo ng puso at ang katiwasayan ng mga bahagi ng katawan sa ṣalāh.<span class="c6"><br /> Nagsabi si Allāh:</span> <span class="c4">{Nagtagumpay nga ang mga mananampalataya, na sila sa pagdarasal nila ay mga taimtim,}</span> <span class="c2">(Qur\'ān 23:1-2)</span> </p>',
            ],
            34 => [
                'question' => 'T35: Maipapakahulugan mo ba ang zakāh?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5120.mp3',
                'answer' => '<p> S: Ito ay isang karapatang kinakailangan sa isang natatanging yaman ng isang itinanging pangkatin sa isang itinanging oras.<br /> Ito ay isang haligi mula sa mga haligi ng Islām at isang kawanggawang kinakailangan, na kinukuha sa mayaman at ibinibigay sa maralita.<span class="c6"><br /> Nagsabi si Allāh:</span> <span class="c4">{magbigay kayo ng zakāh}</span> <span class="c2">(Qur\'ān 2:43)</span> </p>',
            ],
            35 => [
                'question' => 'T36: Ano ang kawanggawang itinuturing na kaibig-ibig?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5170.mp3',
                'answer' => '<p> S: Ito ay hindi ang zakāh, tulad ng pagkakawanggawa ng anumang bagay alang-alang sa mga uri ng kabutihan sa alinmang oras.<span class="c6"><br /> Nagsabi si Allāh:</span> <span class="c4">{Gumugol kayo ayon sa landas ni Allāh}</span> <span class="c2">(Qur\'ān 2:195)</span> </p>',
            ],
            36 => [
                'question' => 'T37: Maipapakahulugan mo ba ang pag-aayuno?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5210.mp3',
                'answer' => '<p> S: Ito ay ang pagpapakamananamba kay Allāh sa pamamagitan ng pagpigil sa mga tagapagpatigil-ayuno mula sa pagsapit ng madaling-araw hanggang sa paglubog ng araw kalakip ng layunin.<span class="c6"> Ito ay dalawang uri:</span><br /> Pag-aayunong kinakailangan, tulad ng pag-aayuno sa buwan ng Ramaḍān, na isang haligi mula sa mga haligi ng Islām.<span class="c6"><br /> Nagsabi si Allāh:</span> <span class="c4">{O mga sumampalataya, isinatungkulin sa inyo ang pag-aayuno kung paanong isinatungkulin ito sa mga *bago pa ninyo,* nang sa gayon kayo ay mangingilag magkasala.}</span> <span class="c2">(Qur\'ān 2:183)</span><br /> Pag-aayunong hindi kinakailangan, tulad ng pag-aayuno sa Lunes at Huwebes ng bawat linggo, pag-aayuno ng tatlong araw sa bawat buwan, na ang pinakamainam sa mga ito ay ang mga araw ng kaputian <span class="c2">(ika-13, ika-14, at ika-15)</span> mula sa bawat buwang Islāmiko. </p>',
            ],
            37 => [
                'question' => 'T38: Makababanggit ka ba ng kainaman ng buwan ng Ramaḍān?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5270.mp3',
                'answer' => '<p> S: Ayon kay Abū Hurayrah <span class="c2">(malugod si Allāh sa kanya)</span>,<span class="c6"> ang Sugo ni Allāh ay nagsabi:</span> "Ang sinumang nag-ayuno sa Ramaḍān dahil sa pananampalataya at pag-asang gagantimpalaan, magpapatawad sa kanya sa anumang nauna sa pagkakasala niya." Napagkaisahan ang katumpakan. </p>',
            ],
            38 => [
                'question' => 'T39: Makababanggit ka ba ng kainaman ng pag-aayuno ng pagkukusang-loob sa hindi Ramaḍān?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5300.mp3',
                'answer' => '<p> Ayon kay Abū Sa`īd Al-Khudrīy <span class="c2">(malugod si Allāh sa kanya)</span> na nagsabi: {Nagsabi ang Sugo ni Allāh <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span>: "Walang isang taong nag-aayuno ng isang araw sa landas ni Allāh malibang maglalayo si Allāh dahil sa araw na iyon ng mukha nito sa apoy nang pitumpung taglagas."} Napagkaisahan ang katumpakan.<br /> Ang kahulugan ng pitumpung taglagas ay pitumpung taon. </p>',
            ],
            39 => [
                'question' => 'T40: Makababanggit ka ba ng ilan sa mga tagasira ng pag-aayuno?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5330.mp3',
                'answer' => '<p> S: 1. Ang pagkain at ang pag-inom nang sadyaan;<br /> 2. Ang pagsusuka nang sadyaan;<br /> 3. Ang pagtalikod sa Islām; </p>',
            ],
            40 => [
                'question' => 'T41: Ano ang mga sunnah ng pag-aayuno?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5380.mp3',
                'answer' => '<p> S: 1. Ang pagdadali-dali sa pagtigil-ayuno;<br /> 2. Ang pagkain ng saḥūr at ang pagpapahuli nito;<br /> 3. Ang pagdaragdag sa mga gawain ng kabutihan at pagsamba;<br /> 4. Ang pagsabi ng nag-<span class="c6">ayuno kapag nilait:</span> Ako ay nag-aayuno;<br /> 5. Ang pagdalangin sa sandali ng pagtigil-ayuno;<br /> 6. Ang pagtigil-ayuno sa manibalang na datiles o hinog na datiles, ngunit kung hindi nakatagpo nito ay sa tubig. </p>',
            ],
            41 => [
                'question' => 'T42: Maipapakahulugan mo ba ang ḥajj?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5460.mp3',
                'answer' => '<p> S: Ang ḥajj ay ang pagpapakamananamba kay Allāh <span class="c2">(napakataas Siya)</span> sa pamamagitan ng pagsasadya sa Bahay Niyang Pinakababanal para sa mga itinakdang gawain sa isang itinakdang panahon.<span class="c6"><br /> Nagsabi si Allāh:</span> <span class="c4">{Sa kay Allāh tungkulin ng mga tao ang pagsagawa ng ḥajj sa Bahay: ng sinumang nakayang <span class="c5">[magkaroon]</span> patungo roon ng isang landas. Ang sinumang tumangging sumasampalataya, tunay na si Allāh ay Walang-pangangailangan sa mga nilalang.}</span> <span class="c2">(Qur\'ān 3:97)</span> </p>',
            ],
            42 => [
                'question' => 'T43: Ano ang bilang ng mga haligi ng ḥajj?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5500.mp3',
                'answer' => '<p> S: 1. Ang pagsasagawa ng iḥrām;<br /> 2. Ang pagtigil sa `Arafah;<br /> 3. Ang pagsasagawa ng ṭawāf ng ifāḍah;<br /> 4. Ang pagsasagawa ng sa`y sa pagitan ng Ṣafā at Marwah; </p>',
            ],
            43 => [
                'question' => 'T44: Ano ang kainaman ng pagsasagawa ng ḥajj?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5560.mp3',
                'answer' => '<p> S: Ayon kay Abū Hurayrah <span class="c2">(malugod si Allāh sa kanya)</span> na nagsabi: <span class="c4">{Nakarinig ako sa Sugo ni Allāh na nagsabi: "Ang sinumang nagsagawa ng ḥajj para kay Allāh at hindi humalay ni nagpakasuwail, uuwi siya gaya ng araw na ipinanganak siya ng ina niya."}</span> Nagsalaysay nito sina Imām Al-Bukhārīy at iba pa sa kanya.<br /> Ang pararilang "gaya ng araw na ipinanganak siya ng ina niya" ay nangangahulugang "nang walang pagkakasala". </p>',
            ],
            44 => [
                'question' => 'T45: Maipapakahulugan mo ba ang `umrah?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5600.mp3',
                'answer' => '<p> S: Ang `umrah ay ang pagpapakamananamba kay Allāh <span class="c2">(napakataas Siya)</span> sa pamamagitan ng pagsasadya sa Bahay Niyang Pinakababanal para sa mga itinakdang gawain sa isang itinakdang panahon. </p>',
            ],
            45 => [
                'question' => 'T46: Ano ang bilang ng mga haligi ng `umrah?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5630.mp3',
                'answer' => '<p> S: 1. Ang pagsasagawa ng iḥrām;<br /> 2. Ang pagsasagawa ng ṭawāf sa Bahay <span class="c5">[ni Allāh]</span>;<br /> 3. Ang pagsasagawa ng sa`y sa pagitan ng Ṣafā at Marwah. </p>',
            ],
            46 => [
                'question' => 'T47: Ano ang pakikibaka sa landas ni Allāh?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5690.mp3',
                'answer' => '<p> S: Ito ay ang pag-uukol ng pagpupunyagi at makakaya sa pagpapalaganap ng Islām at pagtatanggol dito at sa mga alagad nito o pakikipaglaban sa kaaway ng Islām at mga alagad ng Islām.<span class="c6"><br /> Nagsabi si Allāh:</span> <span class="c4">{at makibaka kayo sa pamamagitan ng mga yaman ninyo at mga sarili ninyo ayon sa landas ni Allāh. Iyon ay mabuti para sa inyo kung kayo ay nakaaalam.}</span> <span class="c2">(Qur\'ān 9:41)</span> </p>',
            ],
        ],
        3 => [
            0 => [
                'question' => 'T1: Ano ang kaangkan ng Propeta nating si Muḥammad (basbasan siya ni Allāh at pangalagaan)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5740.mp3',
                'answer' => '<p> S: Siya ay si Muḥammad na anak ni Abdullāh na anak ni Abdulmuṭṭalib na anak ni Hāshim. Si Hāshim ay kabilang sa <span class="c5">[liping]</span> Quraysh. Ang Quraysh ay kabilang sa mga Arabe. Ang mga Arabe ay kabilang sa mga inapo ni Ismael. Si Ismael ay anak ni Abraham, sumakanya at sa Propeta natin ang pinakamainam na basbas at pangangalaga. </p>',
            ],
            1 => [
                'question' => 'T2: Ano ang pangalan ng ina ng Propeta natin (basbasan siya ni Allāh at pangalagaan)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5770.mp3',
                'answer' => '<p> S: Āminah bint Wahb. </p>',
            ],
            2 => [
                'question' => 'T3: Kailan pinapanaw ang ama niya?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5800.mp3',
                'answer' => '<p> S: Pinapanaw ang ama niya sa Madīnah habang siya ay isang dinadalang-taong hindi pa ipinanganak <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span>. </p>',
            ],
            3 => [
                'question' => 'T4: Kailan ipinanganak ang Propeta (basbasan siya ni Allāh at pangalagaan)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5830.mp3',
                'answer' => '<p> S: Sa Taon ng Elepante, sa araw ng Lunes ng buwan ng Rabī`ul\'awwal. </p>',
            ],
            4 => [
                'question' => 'T5: Sa aling bayan siya ipinanganak?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5850.mp3',
                'answer' => '<p> S: Sa Makkah. </p>',
            ],
            5 => [
                'question' => 'T6: Sino ang mga tagapagpasuso niya at ang mga tagapag-alaga niya bukod pa sa ina niya?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5880.mp3',
                'answer' => '<p> S: - Ang babaing alipin ng ama niya, si Umm Ayman.<br /> - Ang babaing alipin ng tiyuhin niyang si Abū Lahab, si Thuwaybah;<br /> - Si Ḥalīmah As-Sa`dīyah. </p>',
            ],
            6 => [
                'question' => 'T7: Kailan pinapanaw ang ina niya?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5930.mp3',
                'answer' => '<p> S: Pinapanaw ang ina niya noong siya ay anim na taong gulang at inaruga siya ng lolo niyang si `Abdulmuṭṭalib. </p>',
            ],
            7 => [
                'question' => 'T8: Sino ang nag-aruga sa kanya matapos ng pagpanaw ng lolo niyang si `Abdulmuṭṭalib?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5960.mp3',
                'answer' => '<p> S: Pinapanaw ang lolo niyang si `Abdulmuṭṭalib noong siya ay walong taong gulang at inaruga siya ng tiyuhin niyang si Abū Ṭālib. </p>',
            ],
            8 => [
                'question' => 'T9: Kailan siya naglakbay kasama ng tiyuhin niya patungo sa Sirya?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5990.mp3',
                'answer' => '<p> S: Naglakbay siya kasama ng tiyuhin patungo sa Sirya noong ang edad niya ay sampung taon,. </p>',
            ],
            9 => [
                'question' => 'T10: Kailan ang ikalawang paglalakbay niya?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6020.mp3',
                'answer' => '<p> S: Ang ikalawang paglalakbay niya ay sa pangangalakal ng yaman ni Khadījah <span class="c2">(malugod si Allāh sa kanya)</span> at noong bumalik siya ay pinakasalan niya ito noong siya ay may edad na 25 taon. </p>',
            ],
            10 => [
                'question' => 'T11: Kailan muling ipinatayo ng Liping Quraysh ang Ka`bah?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6050.mp3',
                'answer' => '<p> S: Muling ipinatayo ng Liping Quraysh ang Ka`bah noong siya ay may edad na 35 taon.<br /> Nagpahatol sila sa kanya noong nagkaiba-iba sila sa kung sino ang maglalagay ng batong itim. Inilagay niya ito sa isang tela at inutusan niya ang bawat angkan na humawak sa gilid ng tela. Sila noon ay apat na angkan. Noong naiangat nila ang batong itim sa lagayan nito, inilagay niya ito sa pamamagitan ng kamay niya <span class="c2">(sumakanya ang basbas at ang pangangalaga)</span>. </p>',
            ],
            11 => [
                'question' => 'T12: Ano ang edad niya noong araw na ipinadala? Kanino siya ipinadala?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6080.mp3',
                'answer' => '<p> S: Ang edad niya noon ay 40 taon. Ipinadala siya sa mga tao sa kalahatan mapagbalita ng nakagagalak at bilang mapagbabala. </p>',
            ],
            12 => [
                'question' => 'T13: Ano ang una na sinimulan ng pagkakasi?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6110.mp3',
                'answer' => '<p> S: Ang panaginip na nagkakatotoo sapagkat siya noon ay hindi nakapapanaginip ng isang panaginip malibang nangyayari ang mga ito tulad ng pagbukang-liwayway ng madaling-araw. </p>',
            ],
            13 => [
                'question' => 'T14: Papaano ang kalagayan niya bago ng pagkakasi? Kailan bumaba sa kanya ang pagkakasi sa unang pagkakataon?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6140.mp3',
                'answer' => '<p> S: Siya noon ay sumasamba kay Allāh sa yungib ng Ḥirā\' at nagbabaon siya para roon.<br /> Bumaba sa kanya ang pagkakasi habang siya ay nasa yungib samantalang sumasamba. </p>',
            ],
            14 => [
                'question' => 'T15: Ano ang unang bumaba sa kanya mula sa Qur\'ān?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6180.mp3',
                'answer' => '<p> S: Ang Sabi ni Allāh: <span class="c4">{1. Bumasa ka sa ngalan ng Panginoon mo na lumikha, 2. lumikha sa tao mula sa isang malalinta. 3. Bumasa ka at ang Panginoon mo ay ang Pinakamapagbigay, 4. na nagturo sa pamamagitan ng panulat, 5. nagturo sa tao ng hindi nito nalaman.}</span> <span class="c2">(Qur\'ān 96:1-5)</span> </p>',
            ],
            15 => [
                'question' => 'T16: Sino ang una sa sumampalataya sa mensahe niya?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6200.mp3',
                'answer' => '<p> S: Mula sa mga lalaki ay si Abū Bakr Aṣ-Ṣiddīq, mula sa mga babae ay si Khadījah bint Khuwaylid, mula sa mga bata ay si `Alīy bin Abī Ṭālib, mula sa mga alila ay si Zayd bin Ḥārithah, at mula sa mga alipin ay si Bilāl Al-Ḥabashīy – malugod si Allāh sa kanila at sa iba pa sa kanila. </p>',
            ],
            16 => [
                'question' => 'T17: Papaano ang pag-aanyaya noon tungo sa Islām?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6230.mp3',
                'answer' => '<p> S: Ang pag-aanyaya noon ay palihim sa loob ng mga tatlong taon. Pagkatapos nag-utos ang Propeta <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span> ng paghahayag ng pag-aanyaya. </p>',
            ],
            17 => [
                'question' => 'T18: Ano ang kalagayan noon ng Propeta (basbasan siya ni Allāh at pangalagaan) at ng mga sumampalataya sa kanya matapos ng paghahayag ng pag-aanyaya?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6260.mp3',
                'answer' => '<p> S: Nagpalabis-labis ang mga tagapagtambal sa pananakit sa kanya at pananakit sa mga Muslim hanggang sa nagpahintulot siya sa mga mananampalataya ng paglikas kay Negus sa Etyopiya.<br /> Nagkaisa ang mga kampon ng Shirk sa pananakit at pagpatay sa Propeta <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span> ngunit nagsanggalang sa kanya si Allāh at ipinaligid sa kanya ang tiyuhin niyang si Abū Ṭālib upang magsanggalang sa kanya laban sa kanila. </p>',
            ],
            18 => [
                'question' => 'T19: Sino ang pinapanaw sa ikasampung taon ng pagpapadala sa Propeta (basbasan siya ni Allāh at pangalagaan)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6300.mp3',
                'answer' => '<p> S: Pinapanaw ang tiyuhin niyang si Abū Ṭālib at ang maybahay niyang si Khadījah – malugod si Allāh sa kanya. </p>',
            ],
            19 => [
                'question' => 'T20: Kailan nangyari ang Isrā\' at ang Mi`rāj?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6330.mp3',
                'answer' => '<p> S: Nangyari ito ika-50 taon ng edad niya at isinatungkulin sa kanya ang limang pagdarasal.<br /> Ang Isrā\' ay mula sa Masjid na Pinakababanal patungo sa Masjid na Pinakamalayo.<br /> Ang Mi`rāj ay mula sa Masjid na Pinakamalayo hanggang sa Sidrah ng Pinagwawakasan. </p>',
            ],
            20 => [
                'question' => 'T21: Papaano noon ang Propeta (basbasan siya ni Allāh at pangalagaan) nag-aanyaya sa mga tao sa labas ng Makkah?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6380.mp3',
                'answer' => '<p> S: Siya noon ay nag-aanyaya sa mga mamamayan ng Ṭā\'if at nag-aalok ng sarili niya sa mga panahon ng pagtitinda at mga pagtitipon ng mga tao hanggang sa dumating ang mga mamamayan ng Madīnah na mga tagaadya saka sumampalataya sila sa Propeta <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span> at nangako sila ng katapatan sa kanya sa pag-aadya sa kanya. </p>',
            ],
            21 => [
                'question' => 'T22: Gaano katagal nanatili ang Propeta (basbasan siya ni Allāh at pangalagaan) sa Makkah na nag-aanyaya?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6410.mp3',
                'answer' => '<p> S: Nanatili siya ng 13 taon. </p>',
            ],
            22 => [
                'question' => 'T23: Saan lumikas ang Propeta (basbasan siya ni Allāh at pangalagaan)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6440.mp3',
                'answer' => '<p> S: Mula sa Makkah lumikas siya sa Madīnah. </p>',
            ],
            23 => [
                'question' => 'T24: Gaano katagal siya nanatili sa Madīnah?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6470.mp3',
                'answer' => '<p> S: Sampung taon. </p>',
            ],
            24 => [
                'question' => 'T25: Ano ang isinatungkulin sa kanya sa Madīnah mula sa mga batas ng Islām?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6490.mp3',
                'answer' => '<p> S: Isinatungkulin sa kanya ang zakāh, ang pag-aayuno, ang ḥajj, ang jihād <span class="c2">(pakikibaka)</span>, ang adhān, at ang iba pa sa mga ito kabilang sa mga batas ng Islām. </p>',
            ],
            25 => [
                'question' => 'T26: Ano ang pinakamahalaga sa mga labanan niya (basbasan siya ni Allāh at pangalagaan).',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6520.mp3',
                'answer' => '<p> S: Ang malaking labanan sa Badr;<br /> Ang labanan sa Uḥud;<br /> Ang laban ng mga lapian;<br /> Ang labanan sa pagsakop sa Makkah. </p>',
            ],
            26 => [
                'question' => 'T27: Ano ang huling bumaba mula sa Qur\'ān?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6580.mp3',
                'answer' => '<p> S: Ang Sabi ni Allāh: <span class="c4">{Mangilag kayo sa Araw na pababalikin kayo roon tungo kay Allāh. Pagkatapos lulubus-lubusin ang bawat kaluluwa sa <span class="c5">[kabayaran ng]</span> anumang nakamit nito at sila ay hindi lalabagin sa katarungan.}</span> <span class="c2">(Qur\'ān 2:281)</span> </p>',
            ],
            27 => [
                'question' => 'T28: Kailan pinapanaw ang Propeta (basbasan siya ni Allāh at pangalagaan)? Ano ang edad niya?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6610.mp3',
                'answer' => '<p> S: Pinapanaw siya sa buwan ng Rabbī`ul\'awwal ng ika-11 ng Hijrah. Siya ay may edad na 63 taon. </p>',
            ],
            28 => [
                'question' => 'T29: Mababanggit mo ba ang mga maybahay ng Propeta (basbasan siya ni Allāh at pangalagaan)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6640.mp3',
                'answer' => '<p> S: 1. Khadījah bint Khuwaylid <span class="c2">(malugod si Allāh sa kanya)</span>;<br /> 2. Sawdah bint Zam`ah <span class="c2">(malugod si Allāh sa kanya)</span>;<br /> 3. `Ā\'ishah bint Abī Bakr <span class="c2">(malugod si Allāh sa kanilang dalawa)</span>;<br /> 4. Ḥafṣah bint `Umar <span class="c2">(malugod si Allāh sa kanya)</span>;<br /> 5. Zaynab bint Khuzaymah <span class="c2">(malugod si Allāh sa kanya)</span>;<br /> 6. Umm Salamah Hind bint Abī Umayyah <span class="c2">(malugod si Allāh sa kanya)</span>;<br /> 7. Umm Ḥabībah bint Abī Sufyān <span class="c2">(malugod si Allāh sa kanya)</span>;<br /> 8. Juwayrīyah bint Al-Ḥārith <span class="c2">(malugod si Allāh sa kanya)</span>;<br /> 9. Maymūnah bint Al-Ḥārith <span class="c2">(malugod si Allāh sa kanya)</span>;<br /> 10. Ṣafīyah bint Ḥuyayy <span class="c2">(malugod si Allāh sa kanya)</span>;<br /> 11. Zaynab bint Jaḥsh <span class="c2">(malugod si Allāh a kanya)</span>; </p>',
            ],
            29 => [
                'question' => 'T30: Sino ang mga anak niya (basbasan siya ni Allāh at pangalagaan)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6760.mp3',
                'answer' => '<p> S: Sa mga lalaki ay tatlo:<br /> Al-Qāsim, na batay rito ang kunyah niya;<br /> `Abdullāh;<br /> Ibrāhīm.<span class="c6"><br /> Sa mga babae:</span><br /> Fāṭimah;<br /> Ruqayyah;<br /> Ummu Kulthūm;<br /> Zaynab.<br /> Ang lahat ng mga anak niya ay mula kay Khadījah <span class="c2">(malugod si Allāh sa kanya)</span> maliban kay Ibrāhīm. Lahat sila ay namatay bago niya maliban kay Fāṭimah na namatay anim na buwan matapos niya. </p>',
            ],
            30 => [
                'question' => 'T31: Makababanggit ka ba ng ilan sa mga pisikal na katangian ng Propeta (basbasan siya ni Allāh at pangalagaan)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6880.mp3',
                'answer' => '<p> S: Siya <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span> ay katamtaman sa mga lalaki: hindi pandak at hindi matangkad; bagkus nasa pagitan niyon. Siya ay maputing nahahaluan ng pamumula <span class="c2">(sumakanya ang basbas at ang pangangalaga)</span>. Siya ay makapal ang balbas, malapad ang mga mata, malaki ang bibig. Ang buhok niya ay matindi ang kaitiman, malaki ang mga balikat, mabango ang amoy. May iba pa roon na marikit na pisikal na katangian niya <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span>. </p>',
            ],
            31 => [
                'question' => 'T31: Sa ano iniwan ng Propeta (basbasan siya ni Allāh at pangalagaan) ang Kalipunan niya?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6910.mp3',
                'answer' => '<p> Iniwan niya ang Kalipunan niya sa malinaw na katwiran, na ang gabi nito ay gaya ng maghapon nito. Walang naliliko palayo rito malibang mapahahamak. Hindi siya nagwalang-bahala ng isang mabuti maliban gumabay siya sa Kalipunan tungo roon ni ng isang kasamaan malibang nagbigay-babala siya laban doon. </p>',
            ],
        ],
        4 => [
            0 => [
                'question' => 'T1: Makabibigkas ka ba ng Al-Fātiḥah at makapagpapakahulugan nito?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6960.mp3',
                'answer' => '<p> S: Ang Sūrah Al-<span class="c6">Fātiḥah at ang pagpapakahulugan dito:</span><br /> 1. <span class="c2">(Sa ngalan ni Allāh, ang Napakamaawain, ang Maawain.)</span> 2. <span class="c2">(Ang papuri ay ukol kay Allāh, ang Panginoon ng mga nilalang,)</span> 3. <span class="c2">(ang Napakamaawain, ang Maawain,)</span> 4. <span class="c2">(ang Tagapagmay-ari ng Araw ng Pagtutumbas.)</span> 5. <span class="c2">(Sa Iyo <span class="c5">[lamang]</span> kami sumasamba at sa Iyo <span class="c5">[lamang]</span> kami nagpapatulong.)</span> 6. <span class="c2">(Patnubayan Mo kami sa landasing tuwid:)</span> 7. <span class="c2">(ang landasin ng mga biniyayaan Mo, hindi ng mga kinagalitan, at hindi ng mga naliligaw.)</span> <span class="c2">(Qur\'ān 1:1-7)</span><br /> Ang Pagpapakahulugan<br /> Tinawag itong Sūrah Al-Fātiḥah dahil sa pagkakabukas ng Aklat ni Allāh sa pamamagitan nito.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001001.mp3"></audio> 1. <span class="c4">{Sa ngalan ni Allāh, ang Napakamaawain, ang Maawain.}</span> Sa ngalan ni Allāh, nagsisimula ako ng pagbigkas ng Qur\'ān habang nagpapatulong sa pamamagitan nito kay Allāh habang tumatanggap ng pagpapala sa pamamagitan ng pagbanggit sa pangalan Niya.<br /> <span class="c4">{Allāh}</span> ay nangangahulugang ang sinasamba ayon sa karapatan at hindi tinatawag sa pamamagitan nito ang iba pa sa Kanya <span class="c2">(kaluwalhatian sa Kanya)</span>.<br /> <span class="c4">{ang Napakamaawain}</span> ay nangangahulugang: ang may masaklaw na awa na sumaklaw sa bawat bagay.<br /> <span class="c4">{ang Maawain}</span> ay nangangahulugang: ang may awa sa mga mananampalataya.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001002.mp3"></audio> 2. <span class="c4">{Ang papuri ay ukol kay Allāh, ang Panginoon ng mga nilalang}</span> ay nangangahulugang ang lahat ng mga pagpapapuri at kalubusan ay ukol kay Allāh – tanging sa Kanya.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001003.mp3"></audio> 3. <span class="c4">{ang Napakamaawain, ang Maawain}</span> ay nangangahulugang: ang may masaklaw na awa na sumaklaw sa bawat bagay, ang may awang nauugnay sa mga mananampalataya.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001004.mp3"></audio> 4. <span class="c4">{ang Tagapagmay-ari ng Araw ng Pagtutumbas}</span> Ito ay ang Araw ng Pagbangon.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001005.mp3"></audio> 5. <span class="c4">{Sa Iyo <span class="c5">[lamang]</span> kami sumasamba at sa Iyo <span class="c5">[lamang]</span> kami nagpapatulong.}</span> ay nangangahulugang: sumasamba kami sa Iyo – tanging sa Iyo – at nagpapatulong kami sa Iyo – tanging sa Iyo.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001006.mp3"></audio> 6. <span class="c4">{Patnubayan Mo kami sa landasing tuwid}</span> Ito ay ang kapatnubayan tungo sa Islām at Sunnah.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001007.mp3"></audio> 7. <span class="c4">{ang landasin ng mga biniyayaan Mo, hindi ng mga kinagalitan, at hindi ng mga naliligaw.}</span> ay nangangahulugang ang daan ng mga maayos na lingkod ni Allāh kabilang sa mga propeta at sinumang sumunod sa kanila, hindi ang daan ng mga Kristiyano at mga Hudyo.<br /> Ibinibilang na sunnah na magsabi matapos ng pagbigkas nito ng āmīn,<span class="c6"> na nangangahulugang:</span> Tumugon ka sa amin. </p>',
            ],
            1 => [
                'question' => 'T2: Makabibigkas ka ba ng Sūrah Az-Zalzalah at makapagpapakahulugan nito?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7130.mp3',
                'answer' => '<p> S: Ang Sūrah Az-<span class="c6">Zalzalah at ang pagpapakahulugan dito:</span><br /> <span class="c2">(Sa ngalan ni Allāh, ang Napakamaawain, ang Maawain.)</span><br /> 1. <span class="c2">(Kapag niyanig ang lupa sa pagyanig nito,)</span> 2. <span class="c2">(at nagpalabas ang lupa ng mga pabigat nito,)</span> 3. <span class="c2">(at magsasabi ang tao: "Ano ang nangyari dito?" –)</span> 4. <span class="c2">(sa Araw na iyon ay magsasaysay ito ng mga ulat nito)</span> 5. <span class="c2">(dahil ang Panginoon mo ay nagkasi rito.)</span> 6. <span class="c2">(Sa Araw na iyon ay hahayo ang mga tao nang hiwa-hiwalay upang pakitaan sila ng mga gawa nila.)</span> 7. <span class="c2">(Kaya ang sinumang gumawa ng kasimbigat ng isang katiting na kabutihan ay makikita niya iyon,)</span> 8. <span class="c2">(at ang sinumang gumawa ng kasimbigat ng isang katiting na kasamaan ay makikita niya iyon.)</span> <span class="c2">(Qur\'ān 99:1-8)</span><br /> Ang Pagpapakahulugan<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099001.mp3"></audio> 1. <span class="c4">{Kapag niyanig ang lupa sa pagyanig nito,}</span>: Kapag pinagalaw ang lupa sa pagpapagalaw na matindi na mangyayari rito sa Araw ng Pagbangon,<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099002.mp3"></audio> 2. <span class="c4">{at nagpalabas ang lupa ng mga pabigat nito,}</span>: at nagpalabas ang lupa ng nasa loob nito na mga patay at iba pa sa kanila,<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099003.mp3"></audio> 3. <span class="c4">{at magsasabi ang tao: "Ano ang nangyari dito?" –: at nagsabi ang tao habang nalilito: "Ano ang pumapatungkol sa lupa na gumagalaw-galaw at nauuga?" –<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099004.mp3"></audio> 4. {sa Araw na iyon ay magsasaysay ito ng mga ulat nito}</span>: sa dakilang Araw na iyon ay magpapabatid ang lupa ng ginawa sa ibabaw nito na kabutihan at kasamaan<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099005.mp3"></audio> 5. <span class="c4">{dahil ang Panginoon mo ay nagkasi rito.}</span>: dahil si Allāh ay nagpaalam dito at nag-utos dito niyon.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099006.mp3"></audio> 6. <span class="c4">{Sa Araw na iyon ay hahayo ang mga tao nang hiwa-hiwalay upang pakitaan sila ng mga gawa nila.}</span>: Sa dakilang Araw na iyon na mayayanig roon ang lupa, lalabas ang mga tao mula sa tigilan ng pagtutuos nang pangkat-pangkat upang makasaksi sila sa mga gawa nila na ginawa nila sa Mundo.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099007.mp3"></audio> 7. <span class="c4">{Kaya ang sinumang gumawa ng kasimbigat ng isang katiting na kabutihan ay makikita niya iyon,}</span>: Kaya ang sinumang gumawa ng isang katimbang ng isang munting langgam na mga gawain ng kabutihan at pagpapakabuti ay makikita niya iyon sa harapan niya,<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099008.mp3"></audio> 8. <span class="c4">{at ang sinumang gumawa ng kasimbigat ng isang katiting na kasamaan ay makikita niya iyon.}</span>: at ang sinumang gumawa ng isang katimbang niyon na mga gawain ng kasamaan ay makikita niya iyon gayon din. </p>',
            ],
            2 => [
                'question' => 'T3: Makabibigkas ka ba ng Sūrah Al-`Ādiyāt at makapagpapakahulugan nito?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7270.mp3',
                'answer' => '<p> S: Ang Sūrah Al-<span class="c6">`Ādiyāt at ang pagpapakahulugan dito:</span><br /> <span class="c2">(Sa ngalan ni Allāh, ang Napakamaawain, ang Maawain.)</span><br /> 1. <span class="c2">(Sumpa man sa mga <span class="c5">[kabayong]</span> tumatakbo habang humihingal,)</span> 2. <span class="c2">(saka sa mga nagpapaningas habang nakikiskis <span class="c5">[ang mga kuko]</span>,)</span> 3.<span class="c2">(saka mga nanlulusob sa madaling-araw,)</span> 4. <span class="c2">(saka bumulabog ang mga ito sa pamamagitan nito ng mga alikabok,)</span> 5. <span class="c2">(saka pumagitna ang mga ito dahil dito sa isang pagtitipon;)</span> 6. <span class="c2">(tunay na ang tao, sa Panginoon niya, ay talagang isang mapagkaila.)</span> 7. <span class="c2">(Tunay na siya roon ay talagang isang saksi.)</span> 8. <span class="c2">(Tunay na siya, sa pag-ibig sa kayamanan, ay talagang matindi.)</span> 9. <span class="c2">(Kaya hindi ba siya nakaaalam kapag hinalukay ang nasa mga puntod)</span> 10. <span class="c2">(at itinanghal ang nasa mga dibdib,)</span> 11. <span class="c2">(tunay na ang Panginoon nila sa kanila, sa Araw na iyon, ay talagang Mapagbatid.)</span> <span class="c2">(Qur\'ān 100:1-11)</span><br /> Ang Pagpapakahulugan<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100001.mp3"></audio> 1.<span class="c4">{Sumpa man sa mga <span class="c5">[kabayong]</span> tumatakbo habang humihingal,}</span>: Sumumpa si Allāh sa mga kabayong tumatakbo hanggang sa may marinig, dahil sa paghinga nito, na isang tunog dala ng tindi ng pagtakbo.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100002.mp3"></audio> 2. <span class="c4">{saka sa mga nagpapaningas habang nakikiskis <span class="c5">[ang mga kuko]</span>,}</span>: Sumumpa Siya sa mga kabayong nagpapaningas ng apoy sa pamamagitan ng mga kuko ng mga ito, kapag sumaling ang mga <span class="c5">[kabayong]</span> ito sa pamamagitan ng <span class="c5">[mga paa ng]</span> mga ito sa mga bato, dahil sa tindi ng pagsalpok ng mga <span class="c5">[kukong]</span> ito sa mga <span class="c5">[batong]</span> ito.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100003.mp3"></audio> 3. <span class="c4">{saka mga nanlulusob sa madaling-araw,}</span>: Sumumpa Siya sa mga kabayong nanlulusob sa mga kaaway sa oras ng madaling-araw.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100004.mp3"></audio> 4. <span class="c4">{saka bumulabog ang mga ito sa pamamagitan nito ng mga alikabok,}</span>: Saka nagpagalaw ang mga ito, sa pamamagitan ng pagtakbo ng mga ito, ng mga alikabok.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100005.mp3"></audio> 5. <span class="c4">{saka pumagitna ang mga ito dahil dito sa isang pagtitipon;}</span>: Saka pumagitna ang mga ito sa pamamagitan ng mga mangangabayo ng mga ito sa isang pagtitipon ng mga kaaway.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100006.mp3"></audio> 6. <span class="c4">{tunay na ang tao, sa Panginoon niya, ay talagang isang mapagkaila.}</span>: Tunay na ang tao ay talagang mapagkait ng kabutihang ninanais mula sa kanya ng Panginoon niya.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100007.mp3"></audio> 7. <span class="c4">{Tunay na siya roon ay talagang isang saksi.}</span>: Tunay na siya, sa pagkakait niya ng kabutihan, ay talagang isang tagasaksi, na hindi nakakakaya ng pagkakaila niyon dahil sa kaliwanagan niyon.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100008.mp3"></audio> 8. <span class="c4">{Tunay na siya, sa pag-ibig sa kayamanan, ay talagang matindi.}</span>: Tunay na siya, dahil sa pagkalabis ng pag-ibig niya sa yaman, ay nagmamaramot nito.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100009.mp3"></audio> 9. <span class="c4">{Kaya hindi ba siya nakaaalam kapag hinalukay ang nasa mga puntod}</span>: Kaya hindi ba nakaaalam ang taong ito na nalilinlang ng buhay na pangmundo – kapag bumuhay si Allāh ng anumang nasa mga puntod na mga patay at nagpalabas Siya sa kanila mula sa lupa para sa pagtutuos at pagganti – na ang usapin ay hindi magiging gaya ng dati nilang hinahaka-haka.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100010.mp3"></audio> 10. <span class="c4">{at itinanghal ang nasa mga dibdib,}</span>: <span class="c4">{at pinalantad at nilinaw ang anumang nasa mga puso na mga layunin, mga paniniwala, at iba pa sa mga ito,}</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100011.mp3"></audio> 11. <span class="c4">{tunay na ang Panginoon nila sa kanila, sa Araw na iyon, ay talagang Mapagbatid.}</span>: tunay na ang Panginoon nila sa kanila, sa Araw na iyon,<span class="c6"> ay talagang Mapagbatid:</span> walang nakakukubli sa Kanya na anuman mula sa nauukol sa mga lingkod Niya at gaganti sa kanila roon. </p>',
            ],
            3 => [
                'question' => 'T4: Makabibigkas ka ba ng Sūrah Al-Qāri`āh at makapagpapakahulugan nito?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7450.mp3',
                'answer' => '<p> S: Ang Sūrah Al-<span class="c6">Qāri`āh at ang pagpapakahulugan dito:</span><br /> <span class="c2">(Sa ngalan ni Allāh, ang Napakamaawain, ang Maawain.)</span><br /> 1. <span class="c2">(Ang Tagakalampag.)</span> 2. <span class="c2">(Ano ang Tagakalampag?)</span> 3. <span class="c2">(Ano ang nagpabatid sa iyo kung ano ang Tagakalampag?)</span> 4. <span class="c2">(Sa Araw na <span class="c5">[iyon]</span>, ang mga tao ay magiging para bang mga gamugamong pinakalat)</span> 5. <span class="c2">(at ang mga bundok ay magiging para bang mga lanang nahimulmol.)</span> 6. <span class="c2">(Kaya hinggil naman sa sinumang bumigat <span class="c5">[sa kabutihan]</span> ang mga timbangan niya,)</span> 7. <span class="c2">(siya ay nasa isang pamumuhay na nakalulugod.)</span> 8. <span class="c2">(Hinggil naman sa sinumang gumaan <span class="c5">[sa kabutihan]</span> ang mga timbangan niya,)</span> 9. <span class="c2">(ang kanlungan niya ay kailaliman.)</span> 10. <span class="c2">(Ano ang nagpabatid sa iyo kung ano iyon?)</span> 11. <span class="c2">(<span class="c5">[Iyon ay]</span> isang Apoy na napakainit.)</span> <span class="c2">(Qur\'ān 101:1-11)</span><br /> Ang Pagpapakahulugan<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101001.mp3"></audio> 1. <span class="c4">{Ang Tagakalampag.}</span>: Ang oras na kakalampag sa mga puso ng mga tao dahil sa kasukdulan ng hilakbot dito.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101002.mp3"></audio> 2. <span class="c4">{Ano ang Tagakalampag?}</span>: Ano ang oras na ito na kakalampag sa mga puso ng tao dahil sa kasukdulan ng hilakbot dito?<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101003.mp3"></audio> 3. <span class="c4">{Ano ang nagpabatid sa iyo kung ano ang Tagakalampag?}</span>: Ano ang nagpaalam sa iyo, O Sugo, kung ano ang oras na ito na kakalampag sa mga puso ng mga tao dahil sa kasukdulan ng hilakbot dito? Tunay na ito ay ang Araw ng Pagbangon.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101004.mp3"></audio> 4. <span class="c4">{Sa Araw na <span class="c5">[iyon]</span>, ang mga tao ay magiging para bang mga gamugamong pinakalat}</span>: Sa Araw na kakalampagin ang mga puso ng mga tao, sila ay magiging para bang mga gamugamong kumakalat na naglilipana dito at doon,<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101005.mp3"></audio> 5. <span class="c4">{at ang mga bundok ay magiging para bang mga lanang nahimulmol.}</span>: at ang mga bundok ay magiging tulad ng mga lanang hinimaymay sa kagaanan ng pag-usad ng mga ito at paggalaw ng mga ito.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101006.mp3"></audio> 6. <span class="c4">{Kaya hinggil naman sa sinumang bumigat <span class="c5">[sa kabutihan]</span> ang mga timbangan niya,}</span>: Kaya hinggil naman sa sinumang tumimbang ang mga gawa niyang maayos higit sa mga gawa niyang masagwa,<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101007.mp3"></audio> 7. <span class="c4">{siya ay nasa isang pamumuhay na nakalulugod.}</span>: siya ay nasa isang pamumuhay na kinalulugdan, na matatamo niya ito sa Paraiso.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101008.mp3"></audio> 8. <span class="c4">{Hinggil naman sa sinumang gumaan <span class="c5">[sa kabutihan]</span> ang mga timbangan niya,}</span>: Hinggil naman sa sinumang tumimbang ang mga gawa niyang masagwa higit sa mga gawa niyang maayos,<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101009.mp3"></audio> 9. <span class="c4">{ang kanlungan niya ay kailaliman.}</span>: ang tirahan niya at pagtitigilan niya sa Araw ng Pagbangon ay Impiyerno.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101010.mp3"></audio> 10. <span class="c4">{Ano ang nagpabatid sa iyo kung ano iyon?}</span>: Ano ang nagpaalam sa iyo, O Sugo, kung ano iyon?<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101011.mp3"></audio> 11. <span class="c4">{<span class="c5">[Iyon ay]</span> isang Apoy na napakainit.}</span>: Iyon ay isang Apoy na matindi ang init. </p>',
            ],
            4 => [
                'question' => 'T5: Makabibigkas ka ba ng Sūrah At-Takāthur at makapagpapakahulugan nito?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7610.mp3',
                'answer' => '<p> S: Ang Sūrah At-<span class="c6">Takāthur at ang pagpapakahulugan dito:</span><br /> <span class="c2">(Sa ngalan ni Allāh, ang Napakamaawain, ang Maawain.)</span><br /> 1. <span class="c2">(Nagpalibang sa inyo ang pagpaparamihan)</span> 2. <span class="c2">(hanggang sa dumalaw kayo sa mga pinaglilibingan.)</span> 3. <span class="c2">(Aba\'y hindi! Malalaman ninyo.)</span> 4. <span class="c2">(Pagkatapos, aba\'y hindi! Malalaman ninyo.)</span> 5. <span class="c2">(Aba\'y hindi! Kung sakaling nalalaman ninyo nang may kaalaman ng katiyakan,)</span> 6. <span class="c2">(talagang makikita nga ninyo ang Impiyerno.)</span> 7. <span class="c2">(Pagkatapos talagang makikita nga ninyo iyon nang may mata ng katiyakan.)</span> 8. <span class="c2">(Pagkatapos talagang tatanungin nga kayo sa Araw na iyon tungkol sa kaginhawahan.)</span> <span class="c2">(Qur\'ān 102:1-8)</span><br /> Ang Pagpapakahulugan<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102001.mp3"></audio> 1. <span class="c4">{Nagpalibang sa inyo ang pagpaparamihan}</span>: Umabala sa inyo, O mga tao, ang pagyayabangan sa mga yaman at mga anak palayo sa pagtalima kay Allāh.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102002.mp3"></audio> 2. <span class="c4">{hanggang sa dumalaw kayo sa mga pinaglilibingan.}</span>: hanggang sa namatay kayo at pumasok kayo sa mga libingan ninyo.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102003.mp3"></audio> 3. <span class="c4">{Aba\'y hindi! Malalaman ninyo.}</span>: Hindi naging ukol sa inyo na umabala sa inyo ang pagyayabangan sa mga iyon palayo sa pagtalima kay Allāh. Malalaman ninyo ang kahihinatnan ng pagpapakaabalang iyon.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102004.mp3"></audio> 4. <span class="c4">{Pagkatapos, aba\'y hindi! Malalaman ninyo.}</span>: Pagkatapos, aba\'y hindi! Malalaman ninyo ang kahihinatnan niyon.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102005.mp3"></audio> 5. <span class="c4">{Aba\'y hindi! Kung sakaling nalalaman ninyo nang may kaalaman ng katiyakan,}</span>: Sa katotohanan, kung sakaling kayo ay nakaalam nang tiyakan na kayo ay mga bubuhayin tungo kay Allāh at na Siya ay gaganti sa inyo sa mga gawa ninyo, talagang hindi sana kayo nagpakaabala sa pagyayabangan sa mga yaman at mga anak.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102006.mp3"></audio> 6. <span class="c4">{talagang makikita nga ninyo ang Impiyerno.}</span>: Sumpa man kay Allāh, talagang makasasaksi nga kayo sa Apoy sa Araw ng Pagbangon.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102007.mp3"></audio> 7. <span class="c4">{Pagkatapos talagang makikita nga ninyo iyon nang may mata ng katiyakan.}</span>: Pagkatapos talagang makasasaksi nga kayo niyon ayon sa pagkakasaksi ng katiyakan na walang pagdududa hinggil dito.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102008.mp3"></audio> 8. <span class="c4">{Pagkatapos talagang tatanungin nga kayo sa Araw na iyon tungkol sa kaginhawahan.}</span>: Pagkatapos talagang magtatanong nga sa inyo si Allāh sa Araw na iyon tungkol sa ibiniyaya Niya sa inyo na kalusugan, pagkayaman, at iba pa sa dalawang ito. </p>',
            ],
            5 => [
                'question' => 'T6: Makabibigkas ka ba ng Sūrah Al-`Aṣr at makapagpapakahulugan nito?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7750.mp3',
                'answer' => '<p> S: Ang Sūrah Al-<span class="c6">`Aṣr at ang pagpapakahulugan dito:</span><br /> <span class="c2">(Sa ngalan ni Allāh, ang Napakamaawain, ang Maawain.)</span><br /> 1. <span class="c2">(Sumpa man sa panahon,)</span> 2. <span class="c2">(tunay na ang tao ay talagang nasa isang pagkalugi,)</span> 3. <span class="c2">(maliban sa mga sumampalataya, gumawa ng mga maayos, nagtagubilinan ng katotohanan, at nagtagubilinan ng pagtitiis.)</span> <span class="c2">(Qur\'ān 103:1-3)</span><br /> Ang Pagpapakahulugan<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/103001.mp3"></audio> 1. <span class="c4">{Sumpa man sa panahon,}</span>: Sumumpa Siya (kaluwalhatian sa Kanya sa oras ng panahon.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/103002.mp3"></audio> 2. <span class="c4">{tunay na ang tao ay talagang nasa isang pagkalugi,}</span>: Tunay na ang tao ay talagang nasa isang pagkakulang at isang kapahamakan,<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/103003.mp3"></audio> 3. <span class="c4">{maliban sa mga sumampalataya, gumawa ng mga maayos, nagtagubilinan ng katotohanan, at nagtagubilinan ng pagtitiis.}</span>: maliban sa mga sumampalataya at gumawa ng maayos, at sa kabila niyon ay nag-anyaya sila tungo sa katotohanan at nagtiis sila rito kaya ang mga ito ay ang mga maliligtas mula sa kalugihan. </p>',
            ],
            6 => [
                'question' => 'T7: Makabibigkas ka ba ng Sūrah Al-Humazah at makapagpapakahulugan nito?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7830.mp3',
                'answer' => '<p> S: Ang Sūrah Al-<span class="c6">Humazah at ang pagpapakahulugan dito:</span><br /> <span class="c2">(Sa ngalan ni Allāh, ang Napakamaawain, ang Maawain.)</span><br /> 1. <span class="c2">(Kapighatian ay ukol sa bawat palalibak na mapanirang-puri,)</span> 2. <span class="c2">(na nag-ipon ng yaman at bumilang-bilang nito,)</span> 3. <span class="c2">(habang nag-aakala na ang yaman niya ay magpapanatili sa kanya.)</span> 4. <span class="c2">(Aba\'y hindi! Talagang ihahagis nga siya sa Mapangwasak.)</span> 5. <span class="c2">(Ano ang nagpabatid sa iyo kung ano ang Mapangwasak?)</span> 6. <span class="c2">(<span class="c5">[Ito ay]</span> ang Apoy ni Allāh, na ginagatungan,)</span> 7. <span class="c2">(na nanunuot sa mga puso.)</span> 8. <span class="c2">(Tunay na ito sa kanila ay itataklob,)</span> 9. <span class="c2">(sa mga haliging pinahaba.)</span> <span class="c2">(Qur\'ān 104:1-9)</span><br /> -<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104001.mp3"></audio> 1. <span class="c4">{Kapighatian ay ukol sa bawat palalibak na mapanirang-puri,}</span>: Kasaklapan at katindihan ng pagdurusa ay ukol sa madalas ang panlilibak sa mga tao at ang paninirang-puri sa kanila.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104002.mp3"></audio> 2. <span class="c4">{na nag-ipon ng yaman at bumilang-bilang nito,}</span>: na ang pinahahalagahan niya ay ang pag-iipon ng yaman at pag-isa-<span class="c6">isa nito:</span> walang pinahahalagahan para sa kanya na iba pa roon,<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104003.mp3"></audio> 3. <span class="c4">{habang nag-aakala na ang yaman niya ay magpapanatili sa kanya.}</span>: habang nagpapalagay na ang yaman niya na tinipon niya ay magliligtas sa kanya mula sa kamatayan para mamalagi siyang nananatili sa buhay na pangmundo.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104004.mp3"></audio> 4. <span class="c4">{Aba\'y hindi! Talagang ihahagis nga siya sa Mapangwasak.}</span>: Ang usapin ay hindi gaya ng ginuniguni ng mangmang na ito. Talagang itatapon nga siya sa Apoy ng Impiyerno na dumudurog at bumabasag sa bawat itatapon doon dahil sa tindi ng lakas niyon.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104005.mp3"></audio> 5. <span class="c4">{Ano ang nagpabatid sa iyo kung ano ang Mapangwasak?}</span>: At ano ang nagpaalam sa iyo, O Sugo, kung ano ang Apoy na ito na magwawasak sa bawat itatapon doon?<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104006.mp3"></audio> 6. <span class="c4">{<span class="c5">[Ito ay]</span> ang Apoy ni Allāh, na ginagatungan,}</span>: Ito ay ang Apoy ni Allāh, na nagliliyab,<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104007.mp3"></audio> 7. <span class="c4">{na nanunuot sa mga puso.}</span>: na tumatagos sa mga katawan ng mga tao patungo sa mga puso nila.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104008.mp3"></audio> 8. <span class="c4">{Tunay na ito sa kanila ay itataklob}</span>: Tunay na ito sa mga pinagdurusa roon ay isasara<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104009.mp3"></audio> 9. <span class="c4">{sa mga haliging binanat.}</span>: sa mga haliging nabanat na mahaba upang hindi sila makalabas mula roon. </p>',
            ],
            7 => [
                'question' => 'T8: Makabibigkas ka ba ng Sūrah Al-Fīl at makapagpapakahulugan nito?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7970.mp3',
                'answer' => '<p> S: Ang Sūrah Al-<span class="c6">Fīl at ang pagpapakahulugan dito:</span><br /> <span class="c2">(Sa ngalan ni Allāh, ang Napakamaawain, ang Maawain.)</span><br /> 1. <span class="c2">(Hindi mo ba napag-alaman kung papaano ang ginawa ng Panginoon mo sa mga kasamahan ng elepante?)</span> 2. <span class="c2">(Hindi ba Siya gumawa sa *panlalansi nila <span class="c5">[na mauwi]</span> sa isang pagkawala?)</span> 3. <span class="c2">(Nagsugo Siya sa kanila ng mga ibon na kawan-kawan,)</span> 4. <span class="c2">(na nagpupukol sa kanila ng mga batong mula sa luwad na nanigas.)</span> 5. <span class="c2">(Kaya gumawa Siya sa kanila gaya ng uhay na kinainan.)</span> <span class="c2">(Qur\'ān 105:1-5)</span><br /> Ang Pagpapakahulugan<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105001.mp3"></audio> 1. <span class="c4">{Hindi mo ba napag-alaman kung papaano ang ginawa ng Panginoon mo sa mga kasamahan ng elepante?}</span>: Hindi mo ba nalaman, O Sugo, kung papaano ang ginawa ng Panginoon mo kay Abrahah at sa mga kasamahan niyang mga kasamahan ng elepante nang nagnais sila ng pagwasak ng Ka`bah?<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105002.mp3"></audio> 2. <span class="c4">{Hindi ba Siya gumawa sa panlalansi nila <span class="c5">[na mauwi]</span> sa isang pagkawala? }</span>: Talaga ngang gumawa si Allāh sa pagpapanukala nilang masagwa para sa pagwasak ng Ka`bah <span class="c5">[na mauwi]</span> sa isang pagkasayang sapagkat hindi sila nagtamo ng minithi nila na pagpapabaling sa mga tao palayo sa Ka`bah at hindi sila nagtamo mula roon ng anuman.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105003.mp3"></audio> 3. <span class="c4">{Nagsugo Siya sa kanila ng mga ibon na kawan-kawan,}</span>: Nagpadala Siya sa kanila ng mga ibon na pumunta sa kanila nang pangkat-pangkat,<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105004.mp3"></audio> 4. <span class="c4">{na nagpupukol sa kanila ng mga batong mula sa luwad na nanigas.}</span>: na nagpupukol sa kanila ng mga batong mula sa luwad na nagsabato.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105005.mp3"></audio> 5. <span class="c4">{Kaya gumawa Siya sa kanila gaya ng uhay na kinainan.}</span>: Kaya gumawa sa kanila si Allāh gaya ng mga dahon ng pananim na kinainan ng mga hayop at tinapakan ng mga ito. </p>',
            ],
            8 => [
                'question' => 'T9: Makabibigkas ka ba ng Sūrah Quraysh at makapagpapakahulugan nito?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8070.mp3',
                'answer' => '<p> S: Ang Sūrah Quraysh at ang pagpapakahulugan dito:<br /> <span class="c2">(Sa ngalan ni Allāh, ang Napakamaawain, ang Maawain.)</span><br /> 1. <span class="c2">(Dahil sa pagkahirati sa Quraysh –)</span> 2. <span class="c2">(sa pagkahirati nila sa paglalakbay sa taglamig at tag-init –)</span> 3. <span class="c2">(ay sumamba sila sa Panginoon ng Bahay na ito,)</span> 4. <span class="c2">(na nagpakain sa kanila mula sa pagkagutom at nagpatiwasay sa kanila mula sa pangamba.)</span> <span class="c2">(Qur\'ān 106:1-4)</span><br /> Ang Pagpapakahulugan<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106001.mp3"></audio> 1. <span class="c4">{Dahil sa pagkahirati sa Quraysh –}</span>: Alang-alang sa kaugalian ng Quraysh at pagkahirati nila –<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106002.mp3"></audio> 2. <span class="c4">{sa pagkahirati nila sa paglalakbay sa taglamig at tag-init –}</span>: sa paglalakbay sa taglamig patungo sa Yemen at sa paglalakbay sa tag-init patungo sa Sirya habang mga natitiwasay –<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106003.mp3"></audio> 3. <span class="c4">{ay sumamba sila sa Panginoon ng Bahay na ito,}</span>: ay sumamba sila kay Allāh lamang, ang Panginoon ng Bahay na Pinakababanal na nagpadali para sa kanila ng paglalakbay na ito, at huwag silang magtambal sa Kanya ng isa man,<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106004.mp3"></audio> 4. <span class="c4">{na nagpakain sa kanila mula sa isang pagkagutom at nagpatiwasay sa kanila mula sa isang pangamba.}</span>: na nagpakain sa kanila mula sa isang pagkagutom at nagpatiwasay sa kanila mula sa isang pangamba dahil sa inilagay Niya sa mga puso ng mga Arabe na paggalang sa lugar ng Ka`bah at paggalang sa mga naninirahan doon. </p>',
            ],
            9 => [
                'question' => 'T10: Makabibigkas ka ba ng Sūrah Al-Mā`ūn at makapagpapakahulugan nito?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8160.mp3',
                'answer' => '<p> S: Ang Sūrah Al-<span class="c6">Mā`ūn at ang pagpapakahulugan dito:</span><br /> <span class="c2">(Sa ngalan ni Allāh, ang Napakamaawain, ang Maawain.)</span><br /> 1. <span class="c2">(Nakakita ka ba sa nagpapasinungaling sa pagtutumbas?)</span> 2. <span class="c2">(Sapagkat iyon ay ang nagsasalya sa ulila)</span> 3. <span class="c2">(at hindi nanghihikayat sa pagpapakain sa dukha.)</span> 4. <span class="c2">(Kaya kapighatian ay ukol sa mga tagapagdasal,)</span> 5. n <span class="c2">(na sila sa pagdarasal nila ay mga nagpapabaya,)</span> 6. <span class="c2">(na sila ay nagpapakitang-tao)</span> 7. <span class="c2">(at nagkakait ng munting tulong.)</span> <span class="c2">(Qur\'ān 107:1-7)</span><br /> Ang Pagpapakahulugan<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107001.mp3"></audio> 1. <span class="c4">{Nakakita ka ba sa nagpapasinungaling sa *pagtutumbas?}</span>: Nakakilala ka ba sa nagpapasinungaling sa pagganti sa Araw ng Pagbangon?<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107002.mp3"></audio> 2. <span class="c4">{Sapagkat iyon ay ang nagsasalya sa ulila}</span>: Sapagkat siya ay yaong tumutulak sa ulila nang may kagaspangan palayo sa pangangailangan nito,<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107003.mp3"></audio> 3. <span class="c4">{at hindi nanghihikayat sa pagpapakain sa dukha.}</span>: at hindi nag-uudyok sa sarili niya at hindi nag-uudyok sa iba sa kanya sa pagpapakain sa maralita.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107004.mp3"></audio> 4. <span class="c4">{Kaya kapighatian ay ukol sa mga tagapagdasal,}</span>: Kaya kapahamakan at pagdurusa ay ukol sa mga tagapagdasal,<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107005.mp3"></audio> 5. <span class="c4">{na sila sa pagdarasal nila ay mga nagpapabaya,}</span>: na sila sa pagdarasal nila ay mga naglilibang, hindi pumapansin dito hanggang sa matapos ang oras nito,<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107006.mp3"></audio> 6. <span class="c4">{na sila ay nagpapakitang-<span class="c6">tao):</span> na sila ay nagpapakitang-<span class="c6">tao sa pagdarasal nila at mga gawa nila:</span> hindi nagpapakawagas ng gawain nila para kay Allāh,<span class="c6"><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107007.mp3"></audio> 7:</span> {at nagkakait ng munting tulong. }</span>: at nagkakait ng pagtulong sa iba pa sa kanila ng bagay na walang kapinsalaan sa pagtulong sa pamamagitan nito. </p>',
            ],
            10 => [
                'question' => 'T11: Makabibigkas ka ba ng Sūrah Al-Kawthar at makapagpapakahulugan nito?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8280.mp3',
                'answer' => '<p> S: Ang Sūrah Al-<span class="c6">Kawthar at ang pagpapakahulugan dito:</span><br /> <span class="c2">(Sa ngalan ni Allāh, ang Napakamaawain, ang Maawain.)</span><br /> 1. <span class="c2">(Tunay na Kami ay nagbigay sa iyo ng Kawthar.)</span> 2. <span class="c2">(Kaya magdasal ka sa Panginoon mo at mag-alay.)</span> 3. <span class="c2">(Tunay na ang nasusuklam sa iyo ay siya ang lagot sa pagpapala.)</span> <span class="c2">(Qur\'ān 108:1-3)</span><br /> Ang Pagpapakahulugan<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/108001.mp3"></audio> 1. <span class="c4">{Tunay na Kami ay nagbigay sa iyo ng Kawthar.}</span>: Tunay na Kami ay nagbigay sa iyo, O Sugo, ng kabutihang marami, at kabilang dito ang ilog ng Kawthar sa Paraiso.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/108002.mp3"></audio> 2. <span class="c4">{Kaya magdasal ka sa Panginoon mo at mag-alay.}</span>: Kaya magsagawa ka ng pasasalamat kay Allāh sa biyayang ito, na magdasal ka sa Kanya lamang at magkatay ka <span class="c5">[ng alay]</span>, na salungat sa ginagawa ng mga tagapagtambal na pagpapakalapit-loob sa mga diyus-diyusan nila sa pamamagitan ng pagkakatay <span class="c5">[ng alay]</span>.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/108003.mp3"></audio> 3. <span class="c4">{Tunay na ang nasusuklam sa iyo ay siya ang lagot sa pagpapala.}</span>: Tunay na ang namumuhi sa iyo ay siya ang naputol sa bawat kabutihan, ang nakalimutan, na kung naalaala man ay naaalaala sa kasagwaan. </p>',
            ],
            11 => [
                'question' => 'T12: Makabibigkas ka ba ng Sūrah Al-Kāfirūn at makapagpapakahulugan nito?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8360.mp3',
                'answer' => '<p> S: Ang Sūrah Al-<span class="c6">Kāfirūn at ang pagpapakahulugan dito:</span><br /> <span class="c2">(Sa ngalan ni Allāh, ang Napakamaawain, ang Maawain.)</span><br /> 1. <span class="c2">(Sabihin mo: "O mga tagatangging sumampalataya,)</span> 2. <span class="c2">(hindi ako sumasamba sa sinasamba ninyo,)</span> 3. <span class="c2">(ni kayo ay mga sasamba sa sinasamba ko;)</span> 4. <span class="c2">(ni ako ay sasamba sa sinamba ninyo,)</span> 5. <span class="c2">(ni kayo ay mga sasamba sa sinasamba ko.)</span> 6. <span class="c2">(Ukol sa inyo ang relihiyon ninyo at ukol sa akin ang relihiyon ko.")</span> <span class="c2">(Qur\'ān 109:1-6)</span><br /> Ang Pagpapakahulugan<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109001.mp3"></audio> 1. <span class="c4">{Sabihin mo: "O mga tagatangging sumampalataya,}</span>: Sabihin mo,<span class="c6"> O Sugo:</span> "O mga tagatangging sumampalataya kay Allāh,<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109002.mp3"></audio> 2. <span class="c4">{hindi ako sumasamba sa sinasamba ninyo,}</span>: hindi ako sumasamba sa kasalukuyan at sa hinaharap sa sinasamba ninyo na mga anito,<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109003.mp3"></audio> 3. <span class="c4">{ni kayo ay mga sasamba sa sinasamba ko;}</span>: ni kayo ay mga sasamba sa sinasamba ko mismo ay Siya ay si Allāh lamang,<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109004.mp3"></audio> 4. <span class="c4">{ni ako ay sasamba sa sinamba ninyo,}</span>: ni ako ay sasamba sa sinamba ninyo, na mga anito,<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109005.mp3"></audio> 5. <span class="c4">{ni kayo ay mga sasamba sa sinasamba ko.}</span>: ni kayo ay mga sasamba sa sinasamba ko mismo ay Siya ay si Allāh lamang,<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109006.mp3"></audio> 6. <span class="c4">{Ukol sa inyo ang relihiyon ninyo at ukol sa akin ang relihiyon ko."}</span>: Ukol sa inyo ang relihiyon ninyo na pinauso ninyo para sa mga sarili ninyo at ukol sa akin ang relihiyon ko na pinababa ni Allāh sa akin." </p>',
            ],
            12 => [
                'question' => 'T13: Makabibigkas ka ba ng Sūrah An-Naṣr at makapagpapakahulugan nito?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8470.mp3',
                'answer' => '<p> S: Ang Sūrah An-<span class="c6">Naṣr at ang pagpapakahulugan dito:</span><br /> <span class="c2">(Sa ngalan ni Allāh, ang Napakamaawain, ang Maawain.)</span><br /> 1. ̣ <span class="c2">(Kapag dumating ang pag-aadya ni Allāh at ang pagsakop)</span> 2. <span class="c2">(at nakakita ka sa mga tao na pumapasok sa Relihiyon ni Allāh nang mga pulu-pulutong)</span> 3. <span class="c2">(ay magluwalhati ka kalakip ng papuri sa Panginoon mo at humingi ka ng tawad sa Kanya. Tunay na Siya ay laging Palatanggap ng pagbabalik-loob.)</span> <span class="c2">(Qur\'ān 110:1-3)</span><br /> Ang Pagpapakahulugan<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/110001.mp3"></audio> 1. <span class="c4">{Kapag dumating ang pag-aadya ni Allāh at ang pagsakop}</span>: Kapag dumating ang pag-aadya ni Allāh sa Relihiyon mo, O Sugo, ang pagpapalakas Niya rito, at ang pagkaganap ng pagsakop sa Makkah<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/110002.mp3"></audio> 2. <span class="c4">{at nakakita ka sa mga tao na pumapasok sa Relihiyon ni Allāh nang mga pulu-pulutong}</span>: at nakakita ka sa mga tao na pumapasok sa Islām sa isang delegasyon matapos ng isang delegasyon<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/110003.mp3"></audio> 3. <span class="c4">{ay magluwalhati ka kalakip ng papuri sa Panginoon mo at humingi ka ng tawad sa Kanya. Tunay na Siya ay laging Palatanggap ng pagbabalik-loob.}</span>: ay alamin mo na iyon ay isang palatandaan sa pagkalapit ng pagwawakas ng misyon na ipinadala ka dahil doon kaya magluwalhati ka kalakip ng papuri sa Panginoon mo bilang pasasalamat sa Kanya sa biyaya ng pag-aadya at pagsakop <span class="c5">[sa Makkah]</span>, at humiling ka mula sa Kanya ng kapatawaran. Tunay na Siya ay laging Palatanggap ng pagbabalik-loob, na tumatanggap ng pagbabalik-loob ng mga lingkod Niya at nagpapatawad sa kanila. </p>',
            ],
            13 => [
                'question' => 'T9: Makabibigkas ka ba ng Sūrah Al-Masad at makapagpapakahulugan nito?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8550.mp3',
                'answer' => '<p> S: Ang Sūrah Al-<span class="c6">Masad at ang pagpapakahulugan dito:</span><br /> <span class="c2">(Sa ngalan ni Allāh, ang Napakamaawain, ang Maawain.)</span><br /> 1. <span class="c2">(Napahamak ang dalawang kamay ni Abū Lahab at napahamak siya!)</span> 2. <span class="c2">(Hindi nakapagdulot para sa kanya ang yaman niya at ang anumang nakamit niya.)</span> 3. <span class="c2">(Masusunog siya sa isang Apoy na may lagablab)</span> 4. <span class="c2">(at ang maybahay niya <span class="c5">[rin]</span>, na tagapasan ng kahoy na panggatong,)</span> 5. <span class="c2">(habang sa leeg nito ay may tali mula sa linubid na himaymay.)</span> <span class="c2">(Qur\'ān 111:1-5)</span><br /> Ang Pagpapakahulugan<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111001.mp3"></audio> 1. <span class="c4">{Napahamak ang dalawang kamay ni Abū Lahab at napahamak siya!}</span>: Nalugi ang dalawang kamay ng tiyuhin ng Propeta – basbasan siya ni Allāh at pangalagaan – na si Abū Lahab bin `Abdulmuṭṭalib dahil sa pagkalugi ng gawain niya yayamang siya noon ay nananakit sa Propeta – basbasan siya ni Allāh at pangalagaan – at nabigo ang pagpupunyagi niya.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111002.mp3"></audio> 2. <span class="c4">{Hindi nakapagdulot para sa kanya ang yaman niya at ang anumang nakamit niya.}</span>: Aling bagay ang naidulot para sa kanya ng yaman niya at anak niya? Hindi magtutulak ang mga ito palayo sa kanya ng isang pagdurusa at hindi maghahatak ang mga ito para sa kanya ng isang awa.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111003.mp3"></audio> 3. <span class="c4">{Masusunog siya sa isang Apoy na may lagablab}</span>: Papasok siya sa Araw ng Pagbangon sa isang apoy na may lagablab, na magdurusa siya sa init niyon,<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111004.mp3"></audio> 4. <span class="c4">{at ang maybahay niya <span class="c5">[rin]</span>, na tagapasan ng kahoy na panggatong,}</span>: Papasok <span class="c5">[din]</span> doon ang maybahay niyang si Umm Jamīl, na dating nananakit sa Propeta – basbasan siya ni Allāh at pangalagaan – sa pamamagitan ng pagtatapon ng mga tinik sa daan niya,<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111005.mp3"></audio> 5. <span class="c4">{habang sa leeg nito ay may tali mula sa linubid na himaymay.}</span>: habang sa leeg nito ay may tali na mahigpit ang pagkalubid, na ipang-aakay rito tungo sa Apoy. </p>',
            ],
            14 => [
                'question' => 'T15: Makabibigkas ka ba ng Sūrah Al-Ikhlāṣ at makapagpapakahulugan nito?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8650.mp3',
                'answer' => '<p> S: Ang Sūrah Al-<span class="c6">Ikhlāṣ at ang pagpapakahulugan dito:</span><br /> <span class="c2">(Sa ngalan ni Allāh, ang Napakamaawain, ang Maawain.)</span><br /> 1. <span class="c2">(Sabihin mo: "Siyang si Allāh ay Kaisa-isa.)</span> 2. <span class="c2">(Si Allāh ay ang Dulugan <span class="c5">[sa pangangailangan]</span>.)</span> 3. <span class="c2">(Hindi Siya nagkaanak at hindi Siya ipinanganak.)</span> 4. <span class="c2">(Hindi nagkaroon sa Kanya ng isang kapantay na isa man.")</span> <span class="c2">(Qur\'ān 112:1-4)</span><br /> Ang Pagpapakahulugan<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112001.mp3"></audio> 1. <span class="c4">{Sabihin mo: "Siyang si Allāh ay Kaisa-isa.}</span>: Sabihin mo,<span class="c6"> O Sugo:</span> "Siyang si Allāh, ang namumukod-tangi sa pagkadiyos, ay walang diyos na iba pa sa Kanya.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112002.mp3"></audio> 2. <span class="c4">{Si Allāh ay ang Dulugan <span class="c5">[sa pangangailangan]</span>.}</span>: Siya ay ang Amo na nagwakas sa Kanya ang pagkaamo sa mga katangian ng kaganapan at karikitan, na dinudulugan ng mga nilikha.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112003.mp3"></audio> 3. <span class="c4">{Hindi Siya nagkaanak at hindi Siya ipinanganak.}</span>: Hindi Siya nagkaanak ng isa man at hindi Siya ipinanganak ng isa, kaya naman walang anak para sa Kanya – kaluwalhatian sa Kanya – at walang nag-anak.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112004.mp3"></audio> 4. <span class="c4">{Hindi nagkaroon sa Kanya ng isang kapantay na isa man."}</span>: Hindi nagkaroon sa Kanya ng isang nakikitulad sa paglikha Niya." </p>',
            ],
            15 => [
                'question' => 'T16: Makabibigkas ka ba ng Sūrah Al-Falaq at makapagpapakahulugan nito?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8750.mp3',
                'answer' => '<p> S: Ang Sūrah Al-<span class="c6">Falaq at ang pagpapakahulugan dito:</span><br /> <span class="c2">(Sa ngalan ni Allāh, ang Napakamaawain, ang Maawain.)</span><br /> 1. <span class="c2">(Sabihin mo: "Nagpapakupkop ako sa Panginoon ng bukang-liwayway)</span> 2. <span class="c2">(laban sa kasamaan ng anumang nilikha Niya)</span> 3. <span class="c2">(at laban sa kasamaan ng pusikit kapag lumaganap ito,)</span> 4. <span class="c2">(at laban sa kasamaan ng mga babaing <span class="c5">[manggagaway na]</span> palaihip sa mga buhol,)</span> 5. <span class="c2">(at laban sa kasamaan ng naiinggit kapag nainggit ito.")</span> <span class="c2">(Qur\'ān 113:1-5)</span><br /> Ang Pagpapakahulugan<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113001.mp3"></audio> 1. <span class="c4">{Sabihin mo: "Nagpapakupkop ako sa Panginoon ng bukang-liwayway}</span>: Sabihin mo,<span class="c6"> O Sugo:</span> "Nagpapasanggalang ako sa Panginoon ng madaling-araw at nagpapakalinga ako sa Kanya<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113002.mp3"></audio> 2. <span class="c4">{laban sa kasamaan ng anumang nilikha Niya}</span>: laban sa kasamaan ng nakasasakit kabilang sa mga nilikha.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113003.mp3"></audio> 3. <span class="c4">{at laban sa kasamaan ng pusikit kapag lumaganap ito,}</span>: Nagpapasanggalang ako kay Allāh laban sa mga kasamaan na lumilitaw sa gabi gaya ng mga hayop at mga magnanakaw.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113004.mp3"></audio> 4. <span class="c4">{at laban sa kasamaan ng mga babaing <span class="c5">[manggagaway na]</span> palaihip sa mga buhol,}</span>: Nagpapasanggalang ako sa Kanya laban sa kasamaan ng mga babaing manggagaway na umiihip sa mga buhol.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113005.mp3"></audio> 5. <span class="c4">{at laban sa kasamaan ng naiinggit kapag nainggit ito."}</span>: Nagpapasanggalang ako sa Kanya laban sa kasamaan ng isang naiinggit kapag gumawa ito ng itinutulak sa kanya ng inggit." </p>',
            ],
            16 => [
                'question' => 'T17: Makabibigkas ka ba ng Sūrah An-Nās at makapagpapakahulugan nito?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8870.mp3',
                'answer' => '<p> S: Ang Sūrah An-<span class="c6">Nās at ang pagpapakahulugan dito:</span><br /> <span class="c2">(Sa ngalan ni Allāh, ang Napakamaawain, ang Maawain.)</span><br /> 1. <span class="c2">(Sabihin mo: "Nagpapakupkop ako sa Panginoon ng mga tao,)</span> 2. <span class="c2">(na Hari ng mga tao,)</span> 3. <span class="c2">(na Diyos ng mga tao,)</span> 4. <span class="c2">(laban sa kasamaan ng tagapasaring na palaurong,)</span> 5. <span class="c2">(na nagpapasaring sa mga dibdib ng mga tao,)</span> 6. <span class="c2">(kabilang sa mga jinn at mga tao.)</span> <span class="c2">(Qur\'ān 114:1-6)</span><br /> Ang Pagpapakahulugan<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114001.mp3"></audio> 1. <span class="c4">{Sabihin mo: "Nagpapakupkop ako sa Panginoon ng mga tao,}</span>: Sabihin mo,<span class="c6"> O sugo:</span> "Nagpapasanggalang ako sa Panginoon ng mga tao at nagpapakalinga ako sa Kanya,<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114002.mp3"></audio> 2. <span class="c4">{na Hari ng mga tao, }</span>: na namamatnugot sa kanila ng anumang niloloob Niya, na walang naghahari para sa kanila na iba pa sa Kanya,<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114003.mp3"></audio> 3. <span class="c4">{na Diyos ng mga tao,}</span>: na sinasamba nila ayon sa karapatan, na walang sinasamba para sa kanila ayon sa karapatan na iba pa sa Kanya,<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114004.mp3"></audio> 4. <span class="c4">{laban sa kasamaan ng tagapasaring na palaurong,}</span>: laban sa kasamaan ng demonyo na nagpupukol ng pasaring niya sa mga tao,<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114005.mp3"></audio> 5. <span class="c4">{na nagpapasaring sa mga dibdib ng mga tao,}</span>: na nagpupukol ng pasaring niya sa mga puso ng mga tao,<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114006.mp3"></audio> 6. <span class="c4">{kabilang sa mga jinn at mga tao.}</span> ay nangangahulugang: ang tagapasaring ay nagiging kabilang sa mga tao at nagiging kabilang sa mga jinn." </p>',
            ],
        ],
        5 => [
            0 => [
                'question' => 'T1: Mabubuo mo ba ang ḥadīth: {Ang mga gawain ay ayon sa mga layunin lamang...} at mababanggit mo ba ang ilan sa mga katuturan nito?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9030.mp3',
                'answer' => '<p> S: Ayon sa Pinuno ng mga Mananampalataya na si Abū Ḥafṣ `Umar bin Al-Khaṭṭāb <span class="c2">(malugod si Allāh sa kanya)</span> na nagsabi: {Narinig ko ang Sugo ni Allāh <span class="c2">(basbasan siya ni Allāh at ang mag-anak niya at pangalagaan)</span> na nagsasabi: "Ang mga gawain ay ayon sa mga layunin lamang. Ukol sa bawat tao ang nilayon niya lamang. Kaya ang sinumang ang paglikas niya ay tungo kay Allāh at sa Sugo Niya, ang paglikas niya ay tungo kay Allāh at sa Sugo Niya. Ang sinumang ang paglikas niya ay para sa kamunduhan na tatamuhin niya o sa isang babaing pakakasalan niya, ang paglikas niya ay tungo sa inilikas niya."} Nagsalaysay nito sina Imām Al-Bukhārīy at Imām Muslim.<span class="c6"><br /> Ang mga Katuturan ng Ḥadīth:</span><br /> 1. Ang bawat gawa ay kailangan nito ng isang layunin, gaya ng ṣalāh, pag-aayuno, ḥajj, at iba pa sa mga ito na mga gawain.<br /> 2. Kailangan ng pagpapakawagas sa layunin kay Allāh <span class="c2">(napakataas Siya)</span>.<span class="c6"><br /> * Ang Ikalawang Ḥadīth:</span> </p>',
            ],
            1 => [
                'question' => 'T2: Mabubuo mo ba ang ḥadīth: {Ang sinumang nagpauso kaugnay sa nauukol sa aming ito...} at mababanggit mo ba ang ilan sa mga katuturan nito?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9090.mp3',
                'answer' => '<p> S: Ayon sa Ina ng mga Mananampalataya na si Umm `Abdillāh `A\'ishah <span class="c2">(malugod si Allāh sa kanya)</span> na nagsabi: {Nagsabi ang Sugo ni Allāh <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span>: "Ang sinumang nagpauso kaugnay sa nauukol sa aming ito ng hindi bahagi nito, ito ay tatanggihan."} Nagsalaysay nito sina Imām Al-Bukhārīy at Imām Muslim.<span class="c6"><br /> Ang mga Katuturan ng Ḥadīth:</span><br /> 1. Ang pagsaway laban sa paggawa ng bid`ah sa Relihiyon.<br /> 2. Ang mga gawang batay sa bid`ah ay tinatanggihan at hindi tinatanggap.<span class="c6"><br /> * Ang Ikatlong Ḥadīth:</span> </p>',
            ],
            2 => [
                'question' => 'T3: Mabubuo mo ba ang ḥadīth: {Samantalang kami ay nakaupo sa tabi ng Propeta (basbasan siya ni Allāh at pangalagaan),...} at mababanggit mo ba ang ilan sa mga katuturan nito?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9160.mp3',
                'answer' => '<p> S: Ayon kay `Umar <span class="c2">(malugod si Allāh sa kanya)</span> na nagsabi: {Samantalang kami ay nakaupo sa tabi ng Propeta <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span>, pagkaraka may sumulpot sa amin na isang lalaking matindi ang kaputian ng mga kasuutan, na matindi ang kaitiman ng buhok, na hindi nakikita rito ang bakas ng paglalakbay, na walang nakakikilala rito na isa man sa amin. Naupo ito sa harap ng Propeta <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span>, saka nagsandal ito ng mga tuhod nito sa mga tuhod niya, at naglagay ito ng mga kamay nito sa ibabaw ng mga hita nito.<span class="c6"> Nagsabi ito:</span> "O Muḥammad, magpabatid ka sa akin tungkol sa Islām.<span class="c6">" Nagsabi siya:</span> "Na sumaksi ka na walang ibang Diyos kundi si Allāh at na si Muḥammad ay Sugo ni Allāh, magpanatili ka ng ṣalāh, magbigay ka ng zakāh, mag-ayuno ka sa Ramaḍān, at magsagawa ka ng ḥajj sa Bahay <span class="c5">[ni Allāh]</span> kung nakaya mo <span class="c5">[na magkaroon]</span> papunta roon ng isang daan.<span class="c6">" Nagsabi ito:</span> "Nagsabi ka ng totoo." Kaya nagulat kami rito; nagtatanong ito sa kanya at nagpapatotoo ito sa kanya.<span class="c6"> Nagsabi ito:</span> "Magpabatid ka sa akin tungkol sa Īmān.<span class="c6">" Nagsabi siya:</span> "Na sumampalataya ka kay Allāh, sa mga anghel Niya, sa mga kasulatan Niya, sa mga sugo Niya, sa Huling Araw,<span class="c6"> at sa pagtatakda:</span> sa mabuti nito at masama nito.<span class="c6">" Nagsabi ito:</span> "Magpabatid ka sa akin tungkol sa Iḥsān.<span class="c6">" Nagsabi siya:</span> "Na sumamba ka kay Allāh na para bang ikaw ay nakakikita sa Kanya ngunit kung hindi ka man nakakikita sa Kanya, tunay na Siya ay nakakikita sa iyo.<span class="c6">" Nagsabi ito:</span> "Magpabatid ka sa akin tungkol sa Huling Sandali?" Nagsabi siya: "Ang tinatanong tungkol dito ay hindi higit na nakaaalam kaysa sa nagtatanong.<span class="c6">" Nagsabi ito:</span> "Kaya magpabatid ka sa akin tungkol sa mga palatandaan nito.<span class="c6">" Nagsabi siya:</span> "Na manganganak ang babaing alipin ng amo niya, at na makakikita ka ng mga nakayapak, na mga nakahubad, na mga naghihikahos, na mga pastol ng mga tupa, na nagpapataasan sa pagpapatayo <span class="c5">[ng mga gusali]</span>." Nagsabi <span class="c5">[si `Umar]</span>: "Pagkatapos lumisan ito at nanatili naman kami nang saglit." Nagsabi <span class="c5">[ang Sugo]</span>: "O `Umar,<span class="c6"> nakaaalam ba kayo sa nagtatanong?" Nagsabi kami:</span> "Si Allāh at ang Sugo Niya ay higit na nakaaalam.<span class="c6">" Nagsabi siya:</span> "Iyon ay si Gabriel; pumunta siya sa inyo upang magturo sa inyo ng relihiyon ninyo."} Nagsalaysay nito si Imām Muslim.<span class="c6"><br /> Ang mga Katuturan ng Ḥadīth:</span><br /> A. Ang Pagbanggit sa Limang Haligi ng Islām <span class="c2">(Pagpapasakop)</span><br /> 1. Ang pagsaksi na walang Diyos kundi si Allāh at na si Muḥammad ay Sugo ni Allāh;<br /> 2. Ang pagpapanatili ng ṣalāh <span class="c2">(pagdarasal)</span>;<br /> 3. Ang pagbibigay ng zakāh;<br /> 4. Ang pag-ayuno sa Ramaḍān;<br /> 5. Ang pagsasagawa ng ḥajj sa Pinakababanal na Bahay ni Allāh.<br /> B. Ang Pagbanggit sa Anim na Haligi ng Īmān <span class="c2">(Pananampalataya)</span><br /> 1. Ang pananampalataya kay Allāh;<br /> 2. Sa mga anghel Niya;<br /> 3. Sa mga kasulatan Niya;<br /> 4. Sa mga sugo Niya;<br /> 5. Sa Huling Araw;<br /> 6.<span class="c6"> Sa pagtatakda:</span> sa kabutihan nito at kasamaan nito.<br /> C. Ang pagbanggit sa haligi ng Iḥsān <span class="c2">(Paggawa ng Maganda)</span>. Ito ay nag-iisang haligi. Ito ay na sumamba ka kay Allāh na para bang ikaw ay nakakikita sa Kanya; ngunit kung hindi mo man siya nakikita, tunay na Siya ay nakakikita sa Iyo.<br /> D. Ang oras ng pagsapit ng Huling Sandali ay walang nakaaalam kundi si Allāh <span class="c2">(napakataas Siya)</span>.<span class="c6"><br /> * Ang Ikaapat na Ḥadīth:</span> </p>',
            ],
            3 => [
                'question' => 'T4: Mabubuo mo ba ang ḥadīth: {Ang pinakaganap sa mga mananampalataya sa pananampalataya...} at mababanggit mo ba ang ilan sa mga katuturan nito?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9360.mp3',
                'answer' => '<p> S: Ayon kay Abū Hurayrah <span class="c2">(malugod si Allāh sa kanya)</span> na nagsabi: {Nagsabi ang Sugo ni Allāh <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span>: "Ang pinakaganap sa mga mananampalataya sa pananampalataya ay ang pinakamaganda sa kanila sa kaasalan."} Nagsalaysay nito si Imām At-Tirmidhīy at nagsabi siya na isang magandang ḥadīth ito.<span class="c6"><br /> Ang mga Katuturan ng Ḥadīth:</span><br /> 1. Ang paghimok sa kagandahan ng kaasalan.<br /> 2. Ang kalubusan ng kaasalan ay bahagi ng kalubusan ng pananampalataya.<br /> 3. Ang pananampalataya ay nadaragdagan at nababawasan.<span class="c6"><br /> * Ang Ikalimang Ḥadīth:</span> </p>',
            ],
            4 => [
                'question' => 'T5: Mabubuo mo ba ang ḥadīth: {Ang sinumang nanumpa sa iba pa kay Allāh...} at mababanggit mo ba ang ilan sa mga katuturan nito?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9440.mp3',
                'answer' => '<p> S: Ayon kay Ibnu `Umar <span class="c2">(malugod si Allāh sa kanilang dalawa)</span>: {Ang Propeta <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span> ay nagsabi: "Ang sinumang nanumpa sa iba pa kay Allāh ay tumanggi ngang sumampalataya o nagtambal nga <span class="c5">[kay Allāh]</span>."} Nagsalaysay nito si Imām At-Tirmidhīy.<span class="c6"><br /> Ang mga Katuturan ng Ḥadīth:</span><br /> 1. Hindi pinapayagan ang panunumpa kundi kay Allāh <span class="c2">(napakataas Siya)</span>.<br /> 2. Ang panunumpa sa iba pa kay Allāh <span class="c2">(napakataas Siya)</span> ay kabilang sa Maliit na Shirk.<span class="c6"><br /> * Ang Ikaanim na Ḥadīth:</span> </p>',
            ],
            5 => [
                'question' => 'T6: Mabubuo mo ba ang ḥadīth: {Hindi sumasampalataya ang isa sa inyo hanggang sa ako ay maging higit na iniibig sa kanya...} at mababanggit mo ba ang ilan sa mga katuturan nito?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9510.mp3',
                'answer' => '<p> S: Ayon kay Anas <span class="c2">(malugod si Allāh sa kanya)</span> na nagsabi: {Nagsabi ang Sugo ni Allāh <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span>: "Hindi sumasampalataya ang isa sa inyo hanggang sa ako ay maging higit na iniibig sa kanya kaysa sa anak niya, magulang niya, at mga tao sa kalahatan."} Nagsalaysay nito sina Imām Al-Bukhārīy at Imām Muslim.<span class="c6"><br /> Ang mga Katuturan ng Ḥadīth:</span><br /> 1. Kinakailangan ang pag-ibig sa Propeta <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span> nang higit kaysa sa lahat ng mga tao.<br /> 2. Iyon ay bahagi ng kalubusan ng pananampalataya.<span class="c6"><br /> * Ang Ikapitong Ḥadīth:</span> </p>',
            ],
            6 => [
                'question' => 'T7: Mabubuo mo ba ang ḥadīth: {Hindi sumasampalataya ang isa sa inyo hanggang sa ibigin niya para sa kapatid niya...} at mababanggit mo ba ang ilan sa mga katuturan nito?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9580.mp3',
                'answer' => '<p> S: Ayon kay Anas <span class="c2">(malugod si Allāh sa kanya)</span> na nagsabi: {Nagsabi ang Sugo ni Allāh <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span>: "Hindi sumasampalataya ang isa sa inyo hanggang sa ibigin niya para sa kapatid niya ang iniibig niya para sa sarili niya."} Nagsalaysay nito sina Imām Al-Bukhārīy at Imām Muslim.<span class="c6"><br /> Ang mga Katuturan ng Ḥadīth:</span><br /> 1. Kailangan sa mananampalataya na umibig para sa mga mananampalataya ng kabutihan gaya ng pag-ibig niya nito para sa sarili niya.<br /> 2. Iyon ay bahagi ng kalubusan ng pananampalataya.<span class="c6"><br /> * Ang Ikawalong Ḥadīth:</span> </p>',
            ],
            7 => [
                'question' => 'T8: Mabubuo mo ba ang ḥadīth: {Sumpa man sa Kanya na ang kaluluwa ko ay nasa kamay Niya,...} at mababanggit mo ba ang ilan sa mga katuturan nito?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9650.mp3',
                'answer' => '<p> S: Ayon kay Abū Sa`īd <span class="c2">(malugod si Allāh sa kanya)</span>: <span class="c4">{Ayon sa Sugo ni Allāh na nagsabi: "Sumpa man sa Kanya na ang kaluluwa ko ay nasa kamay Niya, tunay na ito ay talagang nakatutumbas sa ikatlong bahagi ng Qur\'ān."}</span> Nagsalaysay nito si Imām Al-Bukhārīy.<span class="c6"><br /> Ang mga Katuturan ng Ḥadīth:</span><br /> 1. Ang kainaman ng Sūrah Al-Ikhlāṣ.<br /> 2. Ito ay nakatutumbas sa ikatlong bahagi ng Qur\'ān.<span class="c6"><br /> * Ang Ikasiyam na Ḥadīth:</span> </p>',
            ],
            8 => [
                'question' => 'T9: Mabubuo mo ba ang ḥadīth: {[Ang pagsambit ng] Lā ḥawla wa-lā qūwata illā bi-llāh (Walang kapangyarihan at walang lakas kundi sa pamamagitan ni Allāh)...} at mababanggit mo ba ang ilan sa mga katuturan nito?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9720.mp3',
                'answer' => '<p> S: Ayon kay Abū Mūsā <span class="c2">(malugod si Allāh sa kanya)</span> na nagsabi: {Nagsabi ang Sugo ni Allāh <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span>: "<span class="c5">[Ang pagsambit ng]</span> Lā ḥawla wa-lā qūwata illā bi-llāh <span class="c2">(Walang kapangyarihan at walang lakas kundi sa pamamagitan ni Allāh)</span> ay kabilang sa mga tagong yaman ng Paraiso."} Nagsalaysay nito sina Imām Al-Bukhārīy at Imām Muslim.<span class="c6"><br /> Ang mga Katuturan ng Ḥadīth:</span><br /> 1. Ang kainaman ng pangungusap na ito at ito ay isang tagong yaman kabilang sa mga tagong yaman ng Paraiso.<br /> 2. Ang pagwawalang-kaugnayan ng tao sa kapangyarihan niya at lakas niya at ang pagsandal niya kay Allāh <span class="c2">(napakataas Siya)</span> lamang.<span class="c6"><br /> * Ang Ikasampung Ḥadīth:</span> </p>',
            ],
            9 => [
                'question' => 'T10: Mabubuo mo ba ang ḥadīth: {Pansinin at tunay na sa katawan ay may isang laman...} at mababanggit mo ba ang ilan sa mga katuturan nito?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9790.mp3',
                'answer' => '<p> S: Ayon kay An-Nu`mān bin Bashīr <span class="c2">(malugod si Allāh sa kanilang dalawa)</span> na nagsabi: {Nakarinig ako sa Sugo ni Allāh <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span> na nagsabi: "Pansinin at tunay na sa katawan ay may isang laman na kapag umayos ay umaayos ang katawan sa kabuuan nito at kapag tumiwali ay tumitiwali ang katawan sa kabuuan nito. Pansinin at ito ay ang puso."} Nagsalaysay nito sina Imām Al-Bukhārīy at Imām Muslim.<span class="c6"><br /> Ang mga Katuturan ng Ḥadīth:</span><br /> 1. Ang kaayusan ng puso ay nakabatay rito ang kaayusan ng panlabas at panloob.<br /> 2. Ang pagpapahalaga sa kaayusan ng puso dahil sa pamamagitan nito ang kaayusan ng tao.<br /> * Ang Ikalabing-<span class="c6">isang Ḥadīth:</span> </p>',
            ],
            10 => [
                'question' => 'T11: Mabubuo mo ba ang ḥadīth: {Ang sinumang ang huli sa pananalita niya mula sa Mundo ay Lā ilāha illa ­llāh (Walang Diyos kundi si Allāh),...} at mababanggit mo ba ang ilan sa mga katuturan nito?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9860.mp3',
                'answer' => '<p> S: Ayon kay Mu`ādh bin Jabal <span class="c2">(malugod si Allāh sa kanya)</span> na nagsabi: {Nagsabi ang Sugo ni Allāh <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span>: "Ang sinumang ang huli sa pananalita niya mula sa Mundo ay Lā ilāha illa ­llāh <span class="c2">(Walang Diyos kundi si Allāh)</span>, papasok siya sa Paraiso."} Nagsalaysay nito si Imām Abū Dāwud.<span class="c6"><br /> Ang mga Katuturan ng Ḥadīth:</span><br /> 1.<span class="c6"> Ang kainaman ng pangungusap na:</span> "Lā ilāha illa ­llāh <span class="c2">(Walang Diyos kundi si Allāh)</span>" at ang tao ay papasok dahil dito sa Paraiso.<br /> 2.<span class="c6"> Ang kainaman ng sinumang ang huli sa pananalita niya mula sa Mundo ay ang pangungusap na:</span> Lā ilāha illa ­llāh <span class="c2">(Walang Diyos kundi si Allāh)</span> ay papasok sa Paraiso.<span class="c6"><br /> * Ang Ikalabindalawang Ḥadīth:</span> </p>',
            ],
            11 => [
                'question' => 'T12: Mabubuo mo ba ang ḥadīth: {Ang mananampalataya ay hindi ang palapanirang-puri, ni ang palasumpa,...} at mababanggit mo ba ang ilan sa mga katuturan nito?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9940.mp3',
                'answer' => '<p> S: Ayon kay `Abdullāh bin Mas`ūd <span class="c2">(malugod si Allāh sa kanya)</span> na nagsabi: {Nagsabi ang Sugo ni Allāh <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span>: "Ang mananampalataya ay hindi ang palapanirang-puri, ni ang palasumpa, ni ang mahalay, ni ang bastos."} Nagsalaysay nito si Imām At-Tirmidhīy.<span class="c6"><br /> Ang mga Katuturan ng Ḥadīth:</span><br /> 1. Ang pagsaway laban sa bawat pananalitang walang-kabuluhan at pangit.<br /> 2. Iyon ay katangian ng mananampalataya sa dila niya.<span class="c6"><br /> * Ang Ikalabintatlong Ḥadīth:</span> </p>',
            ],
            12 => [
                'question' => 'T13: Mabubuo mo ba ang ḥadīth: {Bahagi ng kagandahan ng pagkaanib sa Islām ng tao...} at mababanggit mo ba ang ilan sa mga katuturan nito?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10020.mp3',
                'answer' => '<p> S: Ayon kay Abū Hurayrah <span class="c2">(malugod si Allāh sa kanya)</span> na nagsabi: {Nagsabi ang Sugo ni Allāh <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span>: "Bahagi ng kagandahan ng pagkaanib sa Islām ng tao ang pag-iwan niya ng hindi pumapatungkol sa kanya."} Nagsalaysay nito si Imām At-Tirmidhīy at ang iba pa sa kanya.<span class="c6"><br /> Ang mga Katuturan ng Ḥadīth:</span><br /> 1. Ang pag-iwan ng hindi nauukol sa tao kabilang sa mga nauukol sa buhay panrelihiyon ng iba pa sa kanya at buhay pangmundo nito.<br /> 2. Ang pag-iwan sa hindi pumapatungkol sa sarili ay bahagi ng kalubusan ng pagkakaanib niya sa Islām.<br /> * Ang Ikalabing-<span class="c6">apat na Ḥadīth:</span> </p>',
            ],
            13 => [
                'question' => 'T14: Mabubuo mo ba ang ḥadīth: {Ang sinumang bumigkas ng isang titik mula sa Aklat ni Allāh...} at mababanggit mo ba ang ilan sa mga katuturan nito?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10100.mp3',
                'answer' => '<p> S: Ayon kay `Abdullāh bin Mas`ūd <span class="c2">(malugod si Allāh sa kanya)</span>: {Ang Propeta <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span> ay nagsabi <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span>: "Ang sinumang bumigkas ng isang titik mula sa Aklat ni Allāh ay magkakaroon siya ng isang gawang maganda. Ang gawang maganda ay <span class="c5">[may gantimpalang]</span> katumbas sa sampung tulad nito. Hindi ko sinasabing ang alif lām mīm ay isang titik, bagkus ang alif ay isang titik, ang lām ay isang titik at ang mīm ay isang titik."} Nagsalaysay nito si Imām At-Tirmidhīy.<span class="c6"><br /> Ang mga Katuturan ng Ḥadīth:</span><br /> 1. Ang kainaman ng pagbigkas ng Qur\'ān.<br /> 2. Sa bawat titik na bibigkasin mo ay may mga magandang gawa para sa iyo dahil doon. </p>',
            ],
        ],
        6 => [
            0 => [
                'question' => 'T1: Papaano ang etiketa kay Allāh (napakataas Siya)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10190.mp3',
                'answer' => '<p> S: 1. Ang pagdakila sa Kanya <span class="c2">(kaluwalhatian sa Kanya at napakataas Siya)</span>;<br /> 2.<span class="c6"> Ang pagsamba sa kanya – tanging sa Kanya:</span> walang katambal para sa Kanya;<br /> 3. Ang pagtalima sa Kanya;<br /> 4. Ang pagtigil sa pagsuway sa Kanya;<br /> 5. Ang pagpapasalamat sa Kanya, ang pagpupuri sa Kanya sa kabutihang-loob Niya at mga biyaya Niya na hindi maisa-isa;<br /> 6. Ang pagtitiis sa mga pagtatakda Niya. </p>',
            ],
            1 => [
                'question' => 'T2: Papaano ang etiketa sa Sugo (basbasan siya ni Allāh at pangalagaan)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10270.mp3',
                'answer' => '<p> S: 1. Ang pagsunod sa kanya at ang pagtulad sa kanya;<br /> 2. Ang pagtalima sa kanya;<br /> 3. Ang pagtigil sa pagsuway sa kanya;<br /> 4. Ang paniniwala sa kanya sa anumang ipinabatid niya;<br /> 5. Ang hindi paggawa ng bid`ah sa pagdaragdag sa sunnah niya;<br /> 6. Ang pag-ibig sa kanya higit kaysa sa sarili at kaysa sa lahat ng mga tao;<br /> 7. Ang pagdakila sa kanya, ang pag-adya sa kanya, at ang pag-adya sa Sunnah niya. </p>',
            ],
            2 => [
                'question' => 'T3: Papaano ang etiketa sa mga magulang?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10360.mp3',
                'answer' => '<p> S: 1. Ang pagtalima sa mga magulang sa hindi pagsuway <span class="c5">[kay Allāh]</span>;<br /> 2. Ang paglilingkod sa mga magulang;<br /> 3. Ang pag-alalay sa mga magulang;<br /> 4. Ang pagtugon sa mga pangangailangan ng magulang;<br /> 5. Ang pagdalangin para sa mga magulang;<br /> 6. Ang pagmamagandang-asal sa kanila sa salita kaya naman hindi pinapayagan kahit ang pagsabi ng "pwe" at ay pinakamaliit sa mga salita;<br /> 7. Ang pagngiti sa harap ng mga magulang at hindi ako sisimangot;<br /> 8. Hindi ako magtaas ng tinig ko higit sa tinig ng mga magulang, makikinig ako sa kanila, hindi ako sasabat sa kanila sa pagsasalita, at hindi ako tatawag sa kanila sa pangalan nila, bagkus sasabihin kong "Ama ko" o "Ina ko".<br /> 9. Magpapaalam ako bago pumasok sa ama ko at ina ko habang sila ay nasa silid;<br /> 10. Ang paghalik sa kamay at ulo ng mga magulang; </p>',
            ],
            3 => [
                'question' => 'T4: Papaano akong makikiugnay sa kaanak?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10490.mp3',
                'answer' => '<p> 1. Ang pagdalaw sa mga kamag-anak gaya ng lalaking kapatid, babaing kapatid, tiyuhin sa ama, tiyahin sa ama, tiyuhin sa ina, tiyahin sa ina, at nalalabi sa mga kamag-anak;<br /> 2. Ang paggawa ng maganda sa kanila sa salita at gawa at ang pag-alalay sa kanila;<br /> 3. Kabilang dito ang pakikipagtalastasan sa kanila at ang pagtatanong tungkol sa mga kalagayan nila. </p>',
            ],
            4 => [
                'question' => 'T5: Papaano ako sa mga kapatid ko at mga kaibigan ko?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10550.mp3',
                'answer' => '<p> S: 1. Iibig ako at makikisama ako sa mga mabuti.<br /> 2. Iiwas ako at titigil ako sa pakikisama sa mga masama.<br /> 3. Babati ako sa mga kapatid ko at makikipagkamay ako sa kanila.<br /> 4. Dadalaw ako sa kanila kapag nagkasakit sila at dadalangin ako para sa kanila ng paggaling.<br /> 5. Mananalangin ako na kaawaan ni Allāh ang bumahin.<br /> 6. Tutugon ako sa paanyaya niya kapag nag-anyaya siya sa akin na dumalaw sa kanya.<br /> 7. Maghahain ako sa kanya ng payo.<br /> 8. Mag-aadya ako sa kanya kapag nilabag siya sa katarungan at pipigil ako sa kanya laban sa kawalang-katarungan.<br /> 9. Iibigin ko para sa kapatid kong Muslim ang iniibig ko para sa sarili ko.<br /> 10. Aalalay ako sa kanya kapag nangailangan siya ng pag-alalay ko.<br /> 11. Hindi ako magpapalasap sa kanya ng isang pananakit sa salita o gawa.<br /> 12. Pag-iingatan ko ang lihim niya.<br /> 13. Hindi ako manlalait sa kanya at hindi ako manlilibak sa kanya o manghahamak sa kanya o maiinggit sa kanya at hindi ako maniniktik sa kanya o mandaraya sa kanya. </p>',
            ],
            5 => [
                'question' => 'T6: Ano ang mga etiketa ng pakikitungo sa kapitbahay?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10710.mp3',
                'answer' => '<p> 1. Makikitungo ako ng maganda sa kapitbahay sa salita at gawa at aalalay ako sa kanya kapag nangailangan siya ng pag-alalay ko.<br /> 2. Babati ako sa kanya kapag natuwa siya dahil sa `īd o kasal o iba pa sa mga ito.<br /> 3. Dadalaw ako sa kanya kapag nagkasakit siya at makikiramay ako sa kanya kapag dinapuan siya ng kasawian.<br /> 4. Magkakaloob ako sa kanya ng ginagawa kong pagkain sa abot ng makakaya ko.<br /> 5. Hindi ako magdudulot sa kanya ng pananakit sa salita o gawa.<br /> 6. Hindi ako mambubulabog sa kanya sa pamamagitan ng isang mataas na tinig o maniniktik sa kanya at titiisin ko siya. </p>',
            ],
            6 => [
                'question' => 'T7: Ano ang mga etiketa ng pakikitungo sa panauhin?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10800.mp3',
                'answer' => '<p> S: 1. Tutugon ako sa sinumang nag-anyaya sa akin para maging panauhin.<br /> 2. Kapag nagnais akong dumalaw sa isang tao, hihiling ako ng pahintulot at tipanan.<br /> 3. Magpapaalam ako bago pumasok.<br /> 4. Hindi ako mananatili nang matagal sa pagdalaw.<br /> 5. Magbababa ako ng paningin sa mga tao ng bahay <span class="c5">[na dinadalaw]</span>.<br /> 6. Tatanggap ako ng panauhin at sasalubong ako sa kanya sa pinakamagandang pagsalubong nang may pagkamasayahin ng mukha at pinakamaganda sa mga pahayag ng pagtanggap.<br /> 7. Magpapaupo ako sa panauhin sa pinakamagandang lugar.<br /> 8. Magpaparangal ako sa kanya sa pamamagitan ng magiliw na pagkakaloob ng pagkain at inumin. </p>',
            ],
            7 => [
                'question' => 'T8: Makababanggit ka ba ng mga etiketa ng pagkakasakit at pagdalaw sa mga maysakit?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10900.mp3',
                'answer' => '<p> S: 1. Kapag nakadama ako ng isang pananakit,<span class="c6"> maglalagay ako ng kanang kamay ko sa kinalalagyan ng pananakit at magsasabi ako ng:</span> "Bismi –llāh <span class="c2">(sa ngalan ni Allāh)</span>" nang tatlong beses at magsasabi ako ng: "A`ūdhu bi-`izzati –llāhi wa-qudratihi min sharri mā ajidu wa-uḥādhir <span class="c2">(Nagpapakupkop ako sa kapangyarihan ni Allāh at kakayahan Niya laban sa kasamaan ng natatagpuan ko at pinangingilagan ko" nang pitong beses.<br /> 2. Malulugod ako sa anumang itinakda ni Allāh at magtitiis ako.<br /> 3. Magmamabilis ako sa pagdalaw sa kapatid kong maysakit, dadalangin ako para sa kanya, at hindi ako magpapatagal ng pananatili sa piling niya.<br /> 4. Magsasagawa ako ng ruqyah sa kanya nang hindi humihiling nito mula sa akin.<br /> 5. Magtatagubilin ako sa kanya ng pagtitiis, pagdalangin, pagdarasal, at kadalisayan sa abot ng makakaya niya.<br /> 6.<span class="c6"> Ang panalangin para sa maysakit:</span> "As\'alu ­llāha –­l`aḍ̆īma rabba –l`arshi -­l`aḍ̆īmi an yashfiyak (Humihiling ako kay Allāh, ang Sukdulan, ang Panginoon ng tronong sukdulan, na magpagaling Siya sa iyo.)</span>" <span class="c2">(Pitong beses.)</span> </p>',
            ],
            8 => [
                'question' => 'T9: Makababanggit ka ba ng mga etiketa ng paghahanap ng kaalaman?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10990.mp3',
                'answer' => '<p> S: 1. Ang pagpapakawagas ng layunin para kay Allāh <span class="c2">(kamahal-mahalan Siya at kapita-pitagan)</span>.<br /> 2. Gagawa ako ayon sa kaalaman na natutuhan ko.<br /> 3. Igagalang ko ang tagapagturo at magpipitagan ako sa kanya sa kapag nariyan siya at kapag wala siya.<br /> 4. Uupo ako sa harapan niya nang may etiketa.<br /> 5. Pakikinggan ko siya nang maigi at hindi ko siya puputulin sa aralin niya.<br /> 6. Magmamagandang-asal ako sa paglalahad ng tanong.<br /> 7. Hindi ko siya tatawagin sa pangalan niya. </p>',
            ],
            9 => [
                'question' => 'T10: Ano ang mga etiketa ng pagtitipon?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11090.mp3',
                'answer' => '<p> S: 1. Babati ako sa mga tao sa pagtitipon.<br /> 2.<span class="c6"> Uupo ako sa kung saan maghahatid sa akin ang pagtitipon:</span> hindi ako magpapatayo ng isang tao mula sa kinauupuan niya at hindi ako uupo sa pagitan ng dalawang tao malibang may pahintulot nilang dalawa.<br /> 3. Magbibigay-puwang ako sa pagtitipon upang makaupo ang iba pa sa akin.<br /> 4. Hindi ko puputulin ang pag-uusap sa pagtitipon.<br /> 5. Magpapaalam ako at babati ako bago lumisan mula sa pagtitipon.<br /> 6. Kapag nagwakas ang pagtitipon, mananalangin ako ng panalangin ng panakip-<span class="c6">sala sa pagtitipon:</span> "Subḥānaka –llāhumma wa-bi-ḥamdik, ashhadu an lā ilāha illā anta, astaghfiruka wa-atūbu ilayk <span class="c2">(Kaluwalhatian sa Iyo, O Allāh, kalakip ng papuri sa Iyo. Sumasaksi ako na walang Diyos kundi Ikaw. Humihingi ako ng tawad sa Iyo at nagbabalik-loob ako sa Iyo.)</span>" </p>',
            ],
            10 => [
                'question' => 'T11: Makababanggit ka ba ng mga etiketa ng pagtulog?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11180.mp3',
                'answer' => '<p> S: 1. Matutulog ako nang maaga.<br /> 2. Matutulog ako nang may ṭahārah.<br /> 3. Hindi ako matutulog nang nakadapa.<br /> 4. Matutulog ako sa kanang tagiliran ko at maglalagay ako ng kanang kamay ko sa ilalim ng kanang pisngi ko.<br /> 5. Magpapagpag ako ng higaan ko.<br /> 6. Bibigkas ako ng mga dhikr ng pagtulog gaya ng Āyatulkursīy <span class="c2">(Qur\'ān 2:255)</span> at ng Sūrah Al-Ikhlāṣ <span class="c2">(Qur\'ān 112)</span>, Sūrah Al-Falaq <span class="c2">(Qur\'ān 113)</span>, at Sūrah An-Nās <span class="c2">(Qur\'ān 114)</span> nang tigtatatlong beses.<span class="c6"> Magsasabi ako:</span> "Bi-smika –llāhumma, amūtu wa-aḥyā. <span class="c2">(Sa ngalan Mo, O Allāh, mamamatay ako at mabubuhay ako.)</span>"<br /> 7. Magigising ako para sa ṣalāh na fajr.<br /> 8. Matapos magising sa pagkatulog,<span class="c6"> magsasabi ako:</span> "Alḥamdu lillāhi –lladhī aḥyānā ba`da mā amātanā wa ilayhi –nnushūr. <span class="c2">(Ang papuri ay ukol kay Allāh na nagbigay-buhay sa atin matapos nagbigay-kamatayan sa atin at tungo sa Kanya ang pagkabuhay.)</span>" </p>',
            ],
            11 => [
                'question' => 'T12: Ano ang mga etiketa ng pagkain?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11290.mp3',
                'answer' => '<p> S:<br /> 1. Maglalayon ako sa pagkain ko at pag-inom ko ng pangingilag magkasala sa pagtalima kay Allāh <span class="c2">(kamahal-mahalan Siya at kapita-pitagan)</span>.<br /> 2. Ang paghuhugas ng mga kamay bago kumain.<br /> 3.<span class="c6"> Magsasabi ako ng:</span> "Bismi –llāh <span class="c2">(sa ngalan ni Allāh)</span>", kakain ako sa pamamagitan ng kanang kamay ko at mula sa malapit sa akin, at hindi ako kakain mula sa gitna ng bandehado o mula sa harapan ng iba pa sa akin.<br /> 4. Kapag nakalimutan kong magsabi ng basmalah <span class="c5">[sa simula]</span>,<span class="c6"> magsasabi ako ng:</span> "Bismi –llāhi awwalahu wa-ākhirah <span class="c2">(sa ngalan ni Allāh sa simula nito at sa katapusan nito)</span>."<br /> 5.<span class="c6"> Malulugod ako sa nakahaing pagkain at hindi ako mamimintas ng pagkain:</span> kung nagustuhan ko ito, kakainin ko ito; at kung hindi ko nagustuhan ito, hahayaan ko ito.<br /> 6. Kakain ako ng ilang munting subo at hindi ako kakain ng marami.<br /> 7. Hindi ako iihip sa pagkain o inumin at hahayaan ko ito hanggang sa lumamig <span class="c5">[nang bahagya]</span>.<br /> 8. Sasalo ako sa iba pa sa akin sa pagkain kasama ng mag-anak o panauhin.<br /> 9. Hindi ako magsisimula sa pagkain bago ng iba pa sa akin na higit na matanda kaysa sa akin.<br /> 10. Sasambit ako ng pangalan ni Allāh kapag iinom ako at iinom ako nang nakaupo at sa tatlong lagok.<br /> 11. Magpupuri ako kay Allāh kapag natapos ako sa pagkain. </p>',
            ],
            12 => [
                'question' => 'T13: Ano ang mga etiketa ng kasuutan?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11440.mp3',
                'answer' => '<p> S: 1. Magsisimula ako sa pagsusuot ng damit ko sa kanan at magpupuri ako kay Allāh dahil doon.<br /> 2. Hindi ako magpapahaba ng damit nang lampas sa mga bukungbukong.<br /> 3. Hindi magsusuot ang mga lalaki ng kasuutan ng mga babae at hindi magsusuot ang mga babae ng kasuutan ng mga lalaki.<br /> 4. Ang hindi pagpapakawangis sa kasuutan ng mga tagatangging-sumampalataya o mga suwail.<br /> 4. Ang pagsambit ng basmalah sa paghuhubad ng mga kasuutan.<br /> 5. Ang pagsusuot ng sapatos sa kanan muna at ang paghuhubad nito mula sa kaliwa muna. </p>',
            ],
            13 => [
                'question' => 'T14: Makababanggit ka ba ng mga etiketa ng pagsakay?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11540.mp3',
                'answer' => '<p> S: 1.<span class="c6"> Magsasabi ako ng:</span> "Bismi –llāh, alḥamdu lillāh <span class="c2">(Sa ngalan ni Allāh; ang papuri ay ukol kay Allāh)</span>" at "Subḥāna ­–lladhī sakhkhara lanā hādhā, wa-mā kunnā lahū muqrinīn. <span class="c2">(Kaluwalhatian sa Kanya na nagpasunud-sunuran para sa atin nito at tayo rito ay hindi sana makakakaya.)</span>, wa-innā ilā rabbinā la-munqalibūn <span class="c2">(Tunay na kami sa Panginoon namin ay talagang magbabalik.)</span>" <span class="c2">(Qur\'ān 43:13-14)</span><br /> 2. Kapag naparaan ako sa isang Muslim, magbibigay ako sa kanya ng pagbati. </p>',
            ],
            14 => [
                'question' => 'T15: Makababanggit ka ba ng mga etiketa sa daan?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11590.mp3',
                'answer' => '<p> S: 1. Magpapakakatamtaman ako at magpapakumbaba ako sa paglalakad ko at maglalakad ako sa kanang bahagi ng daan.<br /> 2. Magbibigay ako ng pagbati sa sinumang masasalubong ko.<br /> 3. Magbababa ako ng paningin ko at hindi ako mananakit sa isa man.<br /> 4. Mag-uutos ako ng nakabubuti at sasaway ako sa nakasasama.<br /> 5. Mag-aalis ako sa daan ng nakasasakit. </p>',
            ],
            15 => [
                'question' => 'T16: Makababanggit ka ba ng mga etiketa ng pagpasok sa masjid at paglabas mula roon?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11670.mp3',
                'answer' => '<p> S: 1.<span class="c6"> Lalabas ako sa pamamagitan ng kaliwang paa ko at magsasabi ako ng:</span> "Bismi –llāh, tawakkaltu `ala –llāh; lā ḥawla wa-lā qūwata illā bi-llāh; Allāhumma innī a`udhu bika an aḍilla aw uḍalla aw azilla aw uzalla aw aḍ̆lima aw uḍ̆lama aw ajhala aw yujhala `alayya. <span class="c2">(Sa ngalan ni Allāh, sumampalataya ako kay Allāh. Walang kapangyarihan at walang lakas kundi si pamamagitan ni Allāh. O Allāh, tunay na ako ay nagpapakupkop sa Iyo upang huwag akong maligaw o mailigaw ako, o matisod ako o maitisod ako, o mang-api ako o maapi ako, o makagawa ako ng kamangmangan o magawa ang kamangmangan sa akin.)</span>" 2.<span class="c6"> Papasok ako sa bahay sa pamamagitan ng kanang paa ko at magsasabi ako ng:</span> "Bismi –llāhi walajnā wa bismi –llāhi kharajnā wa `alā rabbinā tawakkalnā. <span class="c2">(Sa ngalan ni Allāh, pumasok tayo; sa ngalan ni Allāh, lumabas tayo; at sa Panginoon natin, nanalig tayo.)</span>"<br /> 3. Magsisimula ako sa paggamit ng siwāk, pagkatapos babati ako sa mga tao ng bahay. </p>',
            ],
            16 => [
                'question' => 'T17: Makababanggit ka ba ng mga etiketa ng pagtugon sa tawag ng kalikasan?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11730.mp3',
                'answer' => '<p> S: 1. Papasok ako sa pamamagitan ng kaliwang paa ko.<br /> 2. Bago pumasok,<span class="c6"> magsasabi ako ng:</span> "Bismi –llāh, Allāhumma innī a`ūdhu bika mina –lkhubthi wa –lkhabā\'ith. <span class="c2">(Sa ngalan ni Allāh; O Allāh, tunay na ako ay nagpapakupkop sa Iyo laban sa mga lalaking demonyo at mga babaing demonyo.)</span>"<br /> 3. Hindi ako magpapasok <span class="c5">[sa palikuran]</span> ng isang bagay na may pagbanggit ng pangalan ni Allāh.<br /> 4. Magtatakip ako sa sandali ng pagtugon sa tawag ng kalikasan.<br /> 5. Hindi ako magsasalita sa lugar ng pagtugon sa tawag ng kalikasan?<br /> 6. Hindi ako haharap sa qiblah at hindi ako tatalikod doon sa sandali ng pag-ihi o pagdumi.<br /> 7. Gagamit ako ng kaliwang kamay ko sa pag-aalis ng najāsah at hindi ako gagamit ng kanang kamay.<br /> 8. Hindi ako tutugon sa tawag ng kalikasan ko sa daan ng mga tao o sa sinisilungan nila.<br /> 9. Maghuhugas ako ng mga kamay ko matapos ng pagtugon sa tawag ng kalikasan.<br /> 10.<span class="c6"> Lalabas ako sa pamamagitan ng kaliwang paa ko at magsasabi ako ng:</span> "Ghufrānak. <span class="c2">(<span class="c5">[Humihingi ako ng]</span> kapatawaran Mo.)</span>" </p>',
            ],
            17 => [
                'question' => 'T18: Makababanggit ka ba ng mga etiketa sa masjid?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11860.mp3',
                'answer' => '<p> S: 1.<span class="c6"> Papasok ako sa masjid sa pamamagitan ng kanang paa ko at magsasabi ako ng:</span> "Allāhumma –­ftaḥ lī abwāba raḥmatik. <span class="c2">(O Allāh, magbukas Ka para sa akin ng mga pintuan ng awa Mo)</span>."<br /> 2. Hindi ako uupo hanggang sa makapagdasal ako ng dalawang rak`ah.<br /> 3. Hindi ako dadaan sa harap ng mga nagdarasal o maghahanap ng nawawala sa masjid o magtitinda o bibili sa masjid.<br /> 5.<span class="c6"> Lalabas ako mula sa masjid sa pamamagitan ng kaliwang paa ko at magsasabi ako ng:</span> "Allāhumma innī as\'aluka min faḍlik. <span class="c2">(O Allāh, tunay na ako ay humihingi sa Iyo mula sa kabutihang-loob Mo.)</span>" </p>',
            ],
            18 => [
                'question' => 'T15: Makababanggit ka ba ng mga etiketa ng pagbati?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11930.mp3',
                'answer' => '<p> S: Kapag may nakasalubong akong isang Muslim,<span class="c6"> magsisimula ako ng pagbati sa pamamagitan ng pagsabi ng:</span> "Assalāmu `alaykum wa-raḥamatu –llāhi wa-barakātuh. <span class="c2">(Ang kapayapaan ay sumainyo at ang awa ni Allāh at ang mga pagpapala Niya.)</span>" hindi sa pamamagitan ng walang pagbati at hindi ako magsesenyas ng mga kamay ko lamang.<br /> 2. Ngingiti ako sa harap ng sinumang binati ko.<br /> 3. Makikikapagkamay ako sa pamamagitan ng kanang kamay ko.<br /> 4. Kapag may isang bumati sa akin ng isang pagbati, babati ako sa kanya ng higit na maganda kaysa roon o tutugon ako ng tulad niyon.<br /> 5. Hindi ako magsisimula sa Kāfir ng pagbati ng salām at kapag bumati siya ay tutugon ako sa kanya ng tulad niyon.<br /> 6. Babati ang nakababata sa nakatatanda, ang nakasakay sa naglalakad, ang naglalakad sa nakaupo, at ang kaunti sa marami. </p>',
            ],
            19 => [
                'question' => 'T20: Makababanggit ka ba ng mga etiketa ng pagpaalam?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12020.mp3',
                'answer' => '<p> S: 1. Magpapaalam ako bago pumasok sa isang lugar.<br /> 2. Magpapaalam ako nang tatlong beses at matapos nito ay lilisan ako.<br /> 3. Kakatok ako sa pinto nang banayad at hindi ako tatayo nang nakaharap sa pintuan, bagkus sa kanan nito o kaliwa nito.<br /> 4. Bago makapagpaalam, hindi ako papasok sa silid na kinaroroonan ng ama ko at ina ko o ng sinuman, lalo na bago ng madaling-araw, sa sandali ng pag-idlip sa tanghali, at matapos ng ṣalāh na `ishā\'.<br /> 5. Maaaring pumasok ako sa mga lugar na hindi tinitirahan tulad ng ospital o tindahan nang walang pagpapaalam. </p>',
            ],
            20 => [
                'question' => 'T21: Makababanggit ka ba ng mga etiketa ng kabaitan sa hayop?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12100.mp3',
                'answer' => '<p> S: Pakakainin ko ang hayop at paiinumin ko ito.<br /> 2. Ang pagkaawa at ang pagkahabag sa hayop at ang hindi pagpapasan dito ng hindi nito nakakaya.<br /> 3. Hindi ako magdudulot ng pagdurusa sa hayop sa pamamagitan ng alinmang uri ng pagdurusa at pananakit. </p>',
            ],
            21 => [
                'question' => 'T22: Makababanggit ka ba ng mga etiketa ng palakasan?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12160.mp3',
                'answer' => '<p> S: 1. Maglalayon ako sa palakasan ng pangingilag magkasala alang-alang sa pagtalima kay Allāh at kaluguran Niya.<br /> 2. Hindi kami maglalaro sa oras ng ṣalāh.<br /> 3. Hindi magsasagawa ang mga lalaki ng palakasan sa mga babae.<br /> 4. Magsusuot ako ng kasuutang pampalakasan na nakatatakip sa `awrah ko.<br /> 5. Iiwas ako sa palakasang ipinagbabawal gaya ng may panununtok sa mukha at paglalantad ng mga `awrah. </p>',
            ],
            22 => [
                'question' => 'T23: Makababanggit ka ba ng mga etiketa ng pagbibiro?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12240.mp3',
                'answer' => '<p> S: 1. Ang pagsasabi ng totoo sa pagbibiro at ang hindi pagsisinungaling.<br /> 2. Ang pagbibirong walang halong panunuya, pangungutya, pananakit, at paninindak.<br /> 3. Ang hindi magparami ng pagbibiro. </p>',
            ],
            23 => [
                'question' => 'T24: Makababanggit ka ba ng mga etiketa ng pagbahin?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12300.mp3',
                'answer' => '<p> S: 1. Ang pagtatakip ng kamay o panyo o tissue sa sandali ng pagbahin.<br /> 2.<span class="c6"> Na magpuri ka kay Allāh matapos ng pagbahin sa pamamagitan ng pagsabi ng:</span> "Alḥamdu lillāh <span class="c2">(Ang papuri ay ukol kay Allāh.)</span>"<br /> 3.<span class="c6"> Magsabi naman sa kanya ang kapatid niya o ang kasamahan niya ng:</span> "Yarḥamuka –llāh. <span class="c2">(Kaawaan ka ni Allāh.)</span>"<br /> 4. Kaya kapag nagsabi naman ito niyan sa kanya,<span class="c6"> magsabi naman siya ng:</span> "Yahdīkumu –llāhu wa-yuṣlihu bālakum. <span class="c2">(Patnubayan kayo ni Allāh at pabutihin Niya ang lagay ninyo.)</span>" </p>',
            ],
            24 => [
                'question' => 'T25: Ano ang mga etiketa ng paghikab?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12360.mp3',
                'answer' => '<p> S: 1. Ang pagtatangka ng pagpigil ng paghikab.<br /> 2.<span class="c6"> Ang hindi pagtataas ng tinig sa pamamagitan ng pagsabi ng:</span> "Ah. Ah."<br /> 3. Ang pagtatakip ng kamay sa bibig. </p>',
            ],
            25 => [
                'question' => 'T26: Makababanggit ka ba ng mga etiketa ng pagbigkas ng Marangal na Qur\'ān?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12420.mp3',
                'answer' => '<p> S: 1. Ang pagbigkas ng Marangal na Qur\'ān habang may ṭahārah matapos magsagawa ng wuḍū\'.<br /> 2. Ang pag-upo nang may etiketa at pagpipitagan.<br /> 3. Ang pagdalangin ng pagkupkop ni Allāh laban sa demonyo sa simula ng pagbigkas ng Marangal na Qur\'ān.<br /> 4. Ang pagmumuni-muni sa pagbabasa ng Marangal na Qur\'ān. </p>',
            ],
        ],
        7 => [
            0 => [
                'question' => 'T1: Makababanggit ka ba ng kainaman ng kagandahan ng kaasalan?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12500.mp3',
                'answer' => '<p> S: Nagsabi ang Propeta <span class="c2">(sumakanya ang basbas at ang pangangalaga)</span>: "Ang pinakaganap sa mga mananampalataya sa pananampalataya ay ang pinakamaganda sa kanila sa kaasalan." Isinalaysay ito nina Imām At-Tirmidhīy at Imām Aḥmad. </p>',
            ],
            1 => [
                'question' => 'T2: Bakit tayo mananatili sa mga kaasalang Islāmiko?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12530.mp3',
                'answer' => '<p> S: 1. Dahil ito ay isang kadahilanan ng pag-ibig ni Allāh <span class="c2">(napakataas Siya)</span>;<br /> 2. Isang kadahilanan ng pag-ibig ng nilikha;<br /> 3. Ito ay pinakamabigat na bagay sa timbangan ng mga gawa;<br /> 4. Nag-iibayo ang pabuya at ang mga gantimpala dahil sa kagandahan ng kaasalan;<br /> 5. Isang palatandaan ng kalubusan ng pananampalataya; </p>',
            ],
            2 => [
                'question' => '5. Mula saan tayo kumukuha ng mga kaasalan?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12600.mp3',
                'answer' => '<p> S: Mula sa Marangal na Qur\'ān.<span class="c6"> Nagsabi si Allāh:</span> <span class="c4">{Tunay na ang Qur\'ān na ito ay nagpapatnubay para sa siyang pinakaangkop}</span> <span class="c2">(Qur\'ān 17:9)</span> Mula sa Sunnah ng Propeta yayamang nagsabi ang Sugo ni Allāh <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span>: "Ipinadala lamang ako upang maglubos ako ng maayos sa mga kaasalan." Nagsalaysay nito si Imām Aḥmad. </p>',
            ],
            3 => [
                'question' => 'T4: Ano ang kaasalan ng paggawa ng maganda at mga anyo nito?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12640.mp3',
                'answer' => '<p> S: Ang paggawa ng maganda ay ang kamalayan kay Allāh sa palagi at ang pagkakaloob ng kabutihan at paggawa ng maganda sa mga nilikha.<br /> Nagsabi ang Propeta <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span>: "Tunay na si Allāh ay nag-atas ng paggawa ng maganda sa bawat bagay." Nagsalaysay nito si Imām Muslim.<span class="c6"><br /> Ilan sa mga anyo ng paggawa ng maganda:</span><br /> * Ang paggawa ng maganda sa pagsamba kay Allāh <span class="c2">(napakataas Siya)</span> at iyon ay sa pamamagitan ng pagpapakawagas sa pagsamba sa Kanya.<br /> * Ang paggawa ng maganda sa magulang sa salita at gawa.<br /> * Ang paggawa ng maganda sa mga kaanak at mga kamag-anak.<br /> * Ang paggawa ng maganda sa kapitbahay.<br /> * Ang paggawa ng maganda sa mga ulila at mga dukha.<br /> * Ang paggawa ng maganda sa tagagawa ng masagwa sa iyo.<br /> * Ang paggawa ng maganda sa pagsasalita.<br /> * Ang paggawa ng maganda sa pakikipagtalo.<br /> * Ang paggawa ng maganda sa hayop. </p>',
            ],
            4 => [
                'question' => 'T5: Ano ang kabaliktaran ng paggawa ng maganda?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12780.mp3',
                'answer' => '<p> S: Ang kabaliktaran ng paggawa ng maganda ay ang paggawa ng masagwa.<br /> * Kabilang doon ang pag-iwan ng pagpapakawagas sa pagsamba kay Allāh <span class="c2">(napakataas Siya)</span>.<br /> * Ang kasuwailan sa mga magulang.<br /> * Ang pagputol ng ugnayan sa mga kaanak.<br /> * Ang kasagwaan ng pakikitungo sa kapitbahay.<br /> * Ang pag-iwan ng paggawa ng maganda sa mga maralita at mga dukha at iba pa roon kabilang sa masagwa sa mga sinasabi at mga ginagawa. </p>',
            ],
            5 => [
                'question' => 'T6: Ano ang mga uri ng pagkamapagkakatiwalaan at ang mga anyo nito?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12860.mp3',
                'answer' => '<p> S:<br /> 1. Ang pagkamapagkakatiwalaan sa pangangalaga sa mga karapatan ni Allāh <span class="c2">(napakataas Siya)</span>.<br /> Ang mga anyo nito ay ang pagkamapagkakatiwalaan sa pagsasagawa ng mga pagsamba gaya ng ṣalāh, zakāh, ayuno, ḥajj, at iba pa sa mga ito kabilang sa isinatungkulin ni Allāh sa atin.<br /> 2. Ang pagkamapagkakatiwalaan sa pangangalaga sa mga karapatan ng nilikha.<br /> * gaya ng pangangalaga sa mga dangal ng mga tao;<br /> * sa mga ari-arian nila;<br /> * sa mga buhay nila;<br /> * sa mga lihim nila at lahat ng ipinagkatiwala sa iyo ng mga tao.<span class="c6"><br /> Nagsabi si Allāh kaugnay sa pagbanggit ng mga katangian ng mga nagtagumpay:</span> <span class="c4">{na sila sa mga ipinagkatiwala sa kanila at kasunduan sa kanila ay mga tagapag-alaga,}</span> <span class="c2">(Qur\'ān 23:8)</span> </p>',
            ],
            6 => [
                'question' => 'T7: Ano ang kabaliktaran ng pagkamapagkakatiwalaan?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12980.mp3',
                'answer' => '<p> S: Ang kataksilan. Ito ay ang pagwawala sa mga karapatan ni Allāh <span class="c2">(napakataas Siya)</span> at mga karapatan ng mga tao.<br /> Nagsabi ang Propeta <span class="c2">(sumakanya ang basbas at ang pangangalaga)</span>: "Ang tanda ng mapagpaimbabaw ay tatlo: ...at kapag pinagkatiwalaan siya, nagtataksil siya." Napagkaisahan ang katumpakan. </p>',
            ],
            7 => [
                'question' => 'T8: Ano ang kaasalan ng katapatan?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13020.mp3',
                'answer' => '<p> S: Ito ay ang pagpapabatid ng umaayon sa reyalidad o ng bagay ayon sa kung ano ito.<span class="c6"><br /> Kabilang sa mga anyo nito:</span><br /> Ang katapatan sa pagsasalita sa mga tao;<br /> Ang katapatan sa pangako;<br /> Ang katapatan sa salita at gawa.<br /> Nagsabi ang Propeta <span class="c2">(sumakanya ang basbas at ang pangangalaga)</span>: "Tunay na ang katapatan ay pumapatnubay tungo sa pagsasamabuting-loob, tunay na ang pagsasamabuting-loob ay pumapatnubay tungo sa Paraiso, at tunay na ang tao ay talagang nagsasabi nang tapat hanggang sa siya ay maging napakatapat." Napagkaisahan ang katumpakan. </p>',
            ],
            8 => [
                'question' => 'T9: Ano ang kabaliktaran ng katapatan?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13100.mp3',
                'answer' => '<p> S: Ang kasinungalingan. Ito ay ang salungat sa reyalidad. Kabilang doon ang pagsisinungaling sa mga tao, ang pagsira sa mga pangako, at ang pagsaksi sa kabulaanan.<br /> Nagsabi ang Propeta <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span>: "Tunay na ang kasinungalingan ay pumapatnubay tungo sa pagsasamasamang-loob, tunay na ang pagsasamasamang-loob ay pumapatnubay tungo sa Impiyerno, at tunay na ang tao ay talagang nagsisinungaling hanggang sa itala siya sa ganang kay Allāh bilang palasinungaling." Napagkaisahan ang katumpakan. Nagsabi ang Propeta <span class="c2">(sumakanya ang basbas at ang pangangalaga)</span>: "Ang tanda ng mapagpaimbabaw ay tatlo: Kapag nagsalita siya, nagtataksil siya; kapag nangako siya, sumisira siya;" Napagkaisahan ang katumpakan. </p>',
            ],
            9 => [
                'question' => 'T10: Makababanggit ka ba ng mga uri ng pagtitiis?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13140.mp3',
                'answer' => '<p> S: - Ang pagtitiis sa pagtalima kay Allāh <span class="c2">(napakataas Siya)</span>;<br /> - Ang pagtitiis laban sa pagsuway;<br /> - Ang pagtitiis sa mga itinakdang nakasasakit at ang pagpuri kay Allāh sa bawat kalagayan.<span class="c6"><br /> Nagsabi si Allāh:</span> <span class="c4">{Si Allāh ay umiibig sa mga nagtitiis.}</span> <span class="c2">(Qur\'ān 3:146)</span> Nagsabi ang Propeta <span class="c2">(sumakanya ang basbas at ang pangangalaga)</span>: "Pagkamangha ay ukol sa lagay ng mananampalataya! Tunay na ang lagay niya sa kabuuan nito ay kabutihan. Iyon ay hindi ukol sa isa man maliban sa mananampalataya. Kapag may dumapo sa kanya na kariwasaan ay nagpapasalamat siya, ito ay kabutihan para sa kanya; at kapag may dumapo sa kanya na kariwaraan ay nagtitiis siya, ito ay kabutihan para sa kanya." Nagsalaysay nito si Imām Muslim. </p>',
            ],
            10 => [
                'question' => 'T11: Ano ang kabaliktaran ng pagtitiis?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13210.mp3',
                'answer' => '<p> S: Ito ay ang kawalan ng pagtitiis sa pagtalima, ang kawalan ng pagtitiis sa pagsuway, at ang pagpapakainis sa mga itinakda sa pamamagitan ng salita at gawa.<span class="c6"><br /> Kabilang sa mga anyo nito:</span><br /> § Ang pagmimithi ng kamatayan;<br /> § Ang pagtampal ng mga pisngi;<br /> § Ang pagpunit ng mga damit;<br /> § Ang paglalathala ng damdamin;<br /> § Ang pagdalangin ng kasawian laban sa sarili.<br /> Nagsabi ang Propeta <span class="c2">(sumakanya ang basbas at ang pangangalaga)</span>: "Tunay na ang <span class="c5">[bigat ng]</span> ganti ay kaalinsabay ng bigat ng pagsubok at tunay na si Allāh, kapag umibig sa mga tao, ay sumusubok sa kanila. Kaya ang sinumang nalugod, ukol sa kanya ang lugod; at ang sinumang nainis, ukol sa kanya ang pagkainis." Nagsalaysay nito sina Imām At-Tirmidhīy at Imām Ibnu Mājah. </p>',
            ],
            11 => [
                'question' => 'T12: Makababanggit ka ba ng kaasalan ng pakikipagtulungan?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13310.mp3',
                'answer' => '<p> S: Ito ay ang pakikipagtulungan sa mga tao sa ukol sa kanila sa katotohanan at kabutihan.<span class="c6"><br /> Ang mga anyo ng pakikipagtulungan:</span><br /> * Ang pakikipagtulungan sa pagtugon sa mga karapatan;<br /> * Ang pakikipagtulungan sa pagtugon sa tagalabag sa katarungan;<br /> * Ang pakikipagtulungan sa pagpuno sa mga pangangailangan ng mga tao at mga dukha;<br /> * Ang pakikipagtulungan sa bawat kabutihan;<br /> * Ang hindi pakikipagtulungan sa kasalanan, pananakit, at pangangaway.<span class="c6"><br /> Nagsabi si Allāh:</span> <span class="c4">{Magtulungan kayo sa pagsasamabuting-loob at pangingilag magkasala at huwag kayong magtulungan sa kasalanan at pangangaway. Mangilag kayong magkasala kay Allāh. Tunay na si Allāh ay matindi ang parusa.}</span> <span class="c2">(Qur\'ān 5:2)</span> Nagsabi ang Propeta <span class="c2">(sumakanya ang basbas at ang pangangalaga)</span>: "Tunay na ang mananampalataya para sa mananampalataya ay gaya ng gusali, na nagpapalakas ang isa sa isa." Napagkaisahan ang katumpakan. Nagsabi ang Propeta <span class="c2">(sumakanya ang basbas at ang pangangalaga)</span>: "Ang Muslim ay kapatid ng Muslim; hindi siya nang-aapi nito at hindi siya nagsusuko nito <span class="c5">[sa mang-aapi]</span>. Ang sinumang nasa pagtugon sa pangangailangan ng kapatid niya, si Allāh ay nasa pagtugon sa pangangailangan niya. Ang sinumang nagpaluwag sa isang Muslim sa isang dalamhati, magpapaluwag si Allāh sa kanya sa isang dalamhati kabilang sa mga dalamhati ng Araw ng Pagbangon. Ang sinumang nagtakip sa isang Muslim, magtatakip sa kanya si Allāh sa Araw ng Pagbangon." Napagkaisahan ang katumpakan. </p>',
            ],
            12 => [
                'question' => 'T13: Ano ang mga uri ng kaasalan ng pagkahiya?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13420.mp3',
                'answer' => '<p> S: 1. Ang pagkahiya kay Allāh. Ito ay sa pamamagitan ng hindi pagsuway sa Kanya <span class="c2">(kaluwalhatian sa Kanya)</span>.<br /> 2. Ang pagkahiya sa mga tao. Kabilang doon ang pagtigil sa mahalay na bastos na pananalita at ang paglalantad ng `awrah.<br /> Nagsabi ang Sugo ni Allāh <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span>: "Ang Pananampalataya ay higit sa pitumpu o higit sa animnapung sangay. Ang pinakamainam sa mga ito ay ang pagsabi ng Walang Diyos kundi si Allāh at ang pinakamababa sa mga ito ay ang pag-aalis ng nakasasakit palayo sa daan. Ang pagkahiya ay isang sangay ng Pananampalataya." Nagsalaysay nito si Imām Muslim. </p>',
            ],
            13 => [
                'question' => 'T12: Makababanggit ka ba ng mga anyo ng kaasalan ng pagkaawa?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13470.mp3',
                'answer' => '<p> S: - Ang pagkaawa sa mga nakatatanda sa edad at ang pagpipitagan sa kanila;<br /> - Ang pagkaawa sa mga nakababata sa edad at mga paslit;<br /> - Ang pagkaawa sa maralita, dukha, at nangangailangan;<br /> - Ang pagkaawa sa hayop sa pamamagitan ng pagpapakain dito at hindi pananakit dito.<br /> Kabilang doon ang sabi ng Propeta <span class="c2">(sumakanya ang basbas at ang pangangalaga)</span>: "Makakikita ka na ang mga mananampalataya sa pag-aawaan nila, pagmamahalan nila, at pagdadamayan nila ay katulad ng katawan; kapag dumaing ang isang bahagi ay magkakaisa para rito ang nalalabi sa katawan sa puyat at lagnat." Napagkaisahan ang katumpakan. Nagsabi ang Sugo ni Allāh <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span>: "Ang mga naaawa ay maaawa sa kanila ang Napakamaawain. Maawa kayo sa mga naninirahan sa lupa, maaawa sa inyo ang sinumang nasa langit." Nagsalaysay nito sina Imām Abū Dāwud at Imām At-Tirmidhīy. </p>',
            ],
            14 => [
                'question' => 'T15: Ano ang mga uri ng kaasalan ng pag-ibig?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13550.mp3',
                'answer' => '<p> S: Ang pag-ibig kay Allāh <span class="c2">(napakataas Siya)</span>.<span class="c6"><br /> Nagsabi si Allāh:</span> <span class="c4">{samantalang ang mga sumampalataya ay higit na matindi sa pag-ibig kay Allāh.}</span> <span class="c2">(Qur\'ān 2:165)</span><br /> Ang pag-ibig sa Sugo <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span>.<span class="c6"><br /> Nagsabi siya:</span> "Sumpa man sa Kanya na ang kaluluwa ko ay nasa kamay Niya, hindi sumasampalataya ang isa sa inyo hanggang sa ako ay maging higit na iniibig sa kanya kaysa sa magulang niya at anak niya." Nagsalaysay nito si Imām Al-Bukhārīy.<br /> Ang pag-ibig sa mga mananampalataya at ang pag-ibig ng kabutihan para sa kanila gaya ng pagkaibig mo rito para sa sarili mo.<br /> Nagsabi ang Propeta <span class="c2">(sumakanya ang basbas at ang pangangalaga)</span>: "Hindi sumasampalataya ang isa sa inyo hanggang sa umibig siya para sa kapatid niya ng iniibig niya para sa sarili niya." Nagsalaysay nito si Imām Al-Bukhārīy. </p>',
            ],
            15 => [
                'question' => 'T16: Maipapakahulugan mo ba ang pagkamasayahin?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13630.mp3',
                'answer' => '<p> S: Ito ay ang kaaliwalasan ng mukha kasabay ng pagkatuwa, pagngiti, kalumayan, at pagpapakita ng pagkagalak sa sandali ng pakikipagkita sa mga tao.<br /> Ito ay kasalungat ng pagsimangot sa harap ng mga tao, na kabilang sa nakapagpapalayo ng loob nila.<br /> Kaugnay sa kainaman niyon, nasaad ang mga ḥadīth sapagkat ayon kay Abū Dharr <span class="c2">(malugod si Allāh sa kanya)</span> na nagsabi: {Nagsabi sa akin ang Propeta <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span>: "Huwag ka ngang magmaliit ng anuman mula sa kabutihan kahit pa man sumalubong ka sa kapatid mo nang may isang mukhang maaliwalas." Nagsalaysay nito si Imām Muslim. Nagsabi ang Sugo ni Allāh <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span>: "Ang pagngiti mo sa harap ng kapatid mo, para sa iyo ay isang kawanggawa." Nagsalaysay nito si Imām At-Tirmidhīy. </p>',
            ],
            16 => [
                'question' => 'T17: Ano ang inggit?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13690.mp3',
                'answer' => '<p> S: Ito ay ang pagmimithi ng paglaho ng biyaya sa ibang tao o ang pagkasuklam sa biyaya sa ibang tao.<span class="c6"><br /> Nagsabi si Allāh:</span> <span class="c4">{at laban sa kasamaan ng isang naiinggit kapag nainggit ito.}</span> <span class="c2">(Qur\'ān 113:5)</span><br /> Ayon kay Anas bin Mālik <span class="c2">(malugod si Allāh sa kanya)</span>: {Ang Sugo ni Allāh <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span> ay nagsabi: "Huwag kayong magmuhian, huwag kayong mag-inggitan, huwag kayong magtalikuran, at maging magkakapatid kayo, mga lingkod ni Allāh."} Nagsalaysay nito sina Imām Al-Bukhārīy at Imām Muslim. </p>',
            ],
            17 => [
                'question' => 'T18: Ano ang pangungutya?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13740.mp3',
                'answer' => '<p> T: Ito ay ang panunuya sa kapatid mong Muslim at ang pagmamaliit sa kanya. Ito ay hindi pinapayagan.<span class="c6"><br /> Nagsabi si Allāh kaugnay sa pagsaway laban doon:</span> <span class="c4">{O mga sumampalataya, huwag manuya ang ilang lalaki sa ilang lalaki; baka ang mga <span class="c5">[tinutuyang]</span> ito ay higit na mabuti kaysa sa kanila <span class="c5">[na nanunuya]</span>. Huwag <span class="c5">[manuya]</span> ang ilang babae sa ilang babae; baka ang mga <span class="c5">[tinutuyang]</span> ito ay higit na mabuti sa kanila <span class="c5">[na nanunuya]</span>. Huwag kayong manuligsa sa isa\'t isa sa inyo at huwag kayong magtawagan ng mga <span class="c5">[masamang]</span> taguri. Kay saklap bilang pangalan ang kasuwailan matapos ng pananampalataya. Ang sinumang hindi nagbalik-loob, ang mga iyon ay ang mga tagalabag sa katarungan. }</span> <span class="c2">(Qur\'ān 49:11)</span> </p>',
            ],
            18 => [
                'question' => 'T19: Maipapakahulugan mo ba ang pagpapakumbaba?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13780.mp3',
                'answer' => '<p> S: Ito ay ang hindi magturing ang tao sa sarili niya bilang higit sa mga ibang tao kaya hindi niya mamaliitin ang mga tao at hindi niya tatanggihan ang katotohanan.<span class="c6"><br /> Nagsabi si Allāh:</span> <span class="c4">{Ang mga lingkod ng Napakamaawain ay ang mga naglalakad sa lupa sa kababaang-loob...}</span> <span class="c2">(Qur\'ān 25:63)</span> Ibig sabihin: "naglalakad bilang mga mapagpakumbaba". Nagsabi naman ang Sugo ni Allāh <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span>: "Walang nagpakumbaba na isa man kay Allāh bilang mag-aangat sa kanya si Allāh." Nagsalaysay nito si Imām Muslim. Nagsabi pa siya <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span>: "Tunay na si Allāh ay nagkasi sa akin na magpakumbaba kayo nang sa gayon hindi magmayabang ang isa sa isa at hindi lumabag ang isa sa isa." Nagsalaysay nito si Imām Muslim. </p>',
            ],
            19 => [
                'question' => 'T20: Ano ang mga uri ng pagmamalaking ipinagbabawal?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13840.mp3',
                'answer' => '<p> S: 1. Ang pagmamalaki sa katotohanan at ito ay ang pagtulak sa katotohanan at ang hindi pagtanggap dito.<br /> 2. Ang pagmamalaki sa mga tao at ito ang pagmamaliit sa kanila at ang paghamak sa kanila.<br /> Nagsabi ang Sugo ni Allāh <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span>: "Hindi papasok sa Paraiso ang sinumang sa puso niya ay may kasimbigat ng isang katiting na pagmamalaki.<span class="c6">" Kaya may nagsabing isang lalaki:</span> "Tunay na ang tao ay nakaiibig na ang damit niya ay maging maganda at ang sapatos niya ay maging maganda.<span class="c6">" Nagsabi naman siya:</span> "Tunay na si Allāh ay marikit na nakaiibig ng karikitan. Ang pagmamalaki ay ang pag-ayaw sa katotohanan at ang pang-aaba sa mga tao." Nagsalaysay nito si Imām Muslim.<br /> - Ang pag-ayaw sa katotohanan ay ang pagtanggi rito.<br /> - Ang pang-aaba sa mga tao" ay ang paghamak sa kanila.<br /> - Ang magandang damit at ang magandang sapatos ay hindi bahagi ng pagmamalaki. </p>',
            ],
            20 => [
                'question' => 'T21: Makababanggit ka ba ng ilan sa mga uri ng ipinagbabawal na pandaraya?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13910.mp3',
                'answer' => '<p> S: - Ang pandaraya sa pagtitinda at pagbili at ito ay ang pagkukubli ng kapintasan ng paninda.<br /> - Ang pandaraya sa pag-aaral ng kaalaman at ang tulad niyon ay ang pandaraya ng mga estudyante sa mga pagsusulit.<br /> - Ang pandaraya sa sinasabi gaya ng pagsaksi sa kabulaanan at kasinungalingan.<br /> - Ang hindi pagtupad sa sinasabi mo at pinagkasunduan mo sa mga tao.<span class="c6"><br /> Kaugnay sa pagsaway laban sa pandaraya:</span> {Ang Sugo ni Allāh <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span> ay naparaan sa isang bunton ng pagkain saka nagpasok siya ng kamay sa loob nito saka nakakapa ang mga daliri niya ng pamamasa kaya nagsabi siya: "Ano ito, O may-<span class="c6">ari ng pagkain?" Nagsabi naman ito:</span> "Tumama po riyan ang ulan, O Sugo ni Allāh.<span class="c6">" Nagsabi siya:</span> "Kaya ba hindi ka naglagay nito sa ibabaw ng pagkain upang makita ng mga tao? Ang sinumang nandaya ay hindi kabilang sa akin."} Nagsalaysay nito si Imām Muslim.<br /> Ang bunton ng pagkain ay ang tumpok ng pagkain. </p>',
            ],
            21 => [
                'question' => 'T22: Ano ang panlilibak?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13990.mp3',
                'answer' => '<p> S: Ito ay ang pagbanggit sa kapatid mong Muslim ng anumang kasusuklaman niya samantalang siya ay nakaliban.<span class="c6"><br /> Nagsabi si Allāh:</span> <span class="c4">{Huwag manlibak ang ilan sa inyo sa iba. Iibigin ba ng isa sa inyo na kumain ng laman ng kapatid niya kapag patay na? Masusuklam kayo rito. Mangilag kayong magkasala kay Allāh. Tunay na si Allāh ay Palatanggap ng pagbabalik-loob, Maawain.}</span> <span class="c2">(Qur\'ān 49:12)</span> </p>',
            ],
            22 => [
                'question' => 'T23: Maipapakahulugan mo ba ang satsat (namīmah)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14030.mp3',
                'answer' => '<p> S: Ito ay ang paglilipat ng mga usapan sa gitna ng mga tao para makapanira sa kanila.<br /> Nagsabi ang Sugo ni Allāh <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span>: "Walang papasok sa Paraiso na isang palasatsat." Nagsalaysay nito si Imām Muslim. </p>',
            ],
            23 => [
                'question' => 'T24: Ano ang katamaran?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14070.mp3',
                'answer' => '<p> S: Ito ay ang pagbibigat-bigatan sa paggawa ng kabutihan at anumang kinakailangan sa tao ang paggawa niyon.<br /> Kabilang doon ang pagtatamad-tamaran sa paggawa ng mga kinakailangan.<br /> Nagsabi si Allāh <span class="c2">(napakataas Siya)</span>: <span class="c4">{Tunay na ang mga mapagpaimbabaw ay nagtatangkang manlinlang kay Allāh samantalang Siya ay lumilinlang sa kanila. Kapag tumayo sila patungo sa dasal ay tumatayo sila bilang mga tamad na nagpapakitang-gilas sa mga tao at hindi sila umaalaala kay Allāh malibang madalang,}</span> <span class="c2">(Qur\'ān 4:142)</span><br /> Kaya nararapat para sa mananampalataya ang pagwaksi ng katamaran, kabatuganan, at kawalang-gawain; ang pagpupunyagi sa trabaho; ang pagkilos, ang kaseryosohan; at ang pagsisikap sa buhay na ito sa pamamagitan ng kinalulugdan ni Allāh <span class="c2">(napakataas Siya)</span>. </p>',
            ],
            24 => [
                'question' => 'T25: Makababanggit ka ba ng mga uri ng galit?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14130.mp3',
                'answer' => '<p> S: 1. Galit na mapupuri at ito ay para kay Allāh kapag nilabag ng mga tagatangging-sumampalataya o mga mapagpaimbabaw o mga iba pa sa kanila ang mga pinakababanal Niya <span class="c2">(kaluwalhatian sa Kanya)</span>.<br /> 2. Galit na mapupulaan at ito ay ang galit na nagsasanhi sa tao na gumawa at magsabi ng hindi nararapat.<br /> Ang Lunas sa Galit na Mapupulaan<br /> Ang pagsasagawa ng wuḍū\';<br /> Ang pag-upo kung nakatayo at ang paghiga kung nakaupo.<br /> Ang pananatili sa tagubilin ng Propeta <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span> kaugnay roon: "Huwag kang magalit."<br /> Ang pagkontrol sa sarili sa pagsilakbo sa sandali ng pagkagalit.<br /> Ang paghiling ng pagkupkop ni Allāh laban sa demonyong isinumpa.<br /> Ang pananahimik. </p>',
            ],
            25 => [
                'question' => 'T26: Ano ang paniniktik?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14240.mp3',
                'answer' => '<p> S: Ang pagbubunyag at ang pagsasaliksik sa mga kahihiyan ng mga tao at mga pinagtatakpan nila.<span class="c6"><br /> Kabilang sa mga anyo nitong ipinagbabawal:</span><br /> - Ang paninilip sa mga kahihiyan ng mga tao sa mga bahay.<br /> - Ang pakikinig ng tao sa pag-uusap ng mga ibang tao nang walang pagkaalam nila.<span class="c6"><br /> Nagsabi si Allāh:</span> <span class="c4">{Huwag kayong maniktik.}</span> <span class="c2">(Qur\'ān 49:12)</span> </p>',
            ],
            26 => [
                'question' => 'T27: Ano ang pag-aaksaya? Ano ang karamutan? Ano ang pagkamapagbigay?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14310.mp3',
                'answer' => '<p> S: Ang pag-aaksaya ay ang paggugol ng salapi nang wala sa katwiran.<br /> Ang kabaliktaran nito ay ang karamutan, ang pagpigil sa paggugol nang wala sa katwiran.<br /> Ang tumpak ay ang pagkakatamtaman sa pagitan ng dalawang ito at na ang Muslim ay maging mapagbigay.<span class="c6"><br /> Nagsabi si Allāh:</span> <span class="c4">{<span class="c5">[Sila]</span> ang mga kapag gumugol ay hindi nag-aaksaya at hindi sila nagkukuripot, at laging nasa pagitan niyon ay katamtaman.}</span> <span class="c2">(Qur\'ān 25:67)</span> </p>',
            ],
            27 => [
                'question' => 'T28: Ano ang karuwagan? Ano ang katapangan?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14370.mp3',
                'answer' => '<p> S: Ang karuwagan ay ang mangamba sa hindi nararapat na pangambahan,<br /> tulad ng pangamba sa pagsasabi ng katotohanan at pagmamasama ng nakasasama.<br /> Ang katapangan ay ang paglalakas-loob sa pagsasabi ng katotohanan at iyon ay tulad ng paglalakas-loob sa mga larangan ng pakikibaka para sa pagtatanggol sa Islām at mga Muslim.<br /> Ang Propeta <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span> ay nagsasabi noon sa panalangin niya ng: "O Allāh, tunay na ako ay nagpapakupkop sa Iyo laban sa karuwagan." Nagsabi pa ang Sugo ni Allāh <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span>: "Ang malakas na mananampalataya ay higit na mabuti at higit na kaibig-ibig kay Allāh kaysa sa mahinang mananampalataya. Sa bawat iba ay may kabutihan. Nagsalaysay nito si Imām Muslim. </p>',
            ],
            28 => [
                'question' => 'T29: Makababanggit ka ba ng ilan sa mga ipinagbabawal na sinasabi ng bibig?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14440.mp3',
                'answer' => '<p> S: - Tulad ng pagmumura at pag-aalipusta.<br /> -<span class="c6"> Tulad ng pagsabi kay Polano ng:</span> "Hayop ka!" at tulad nito na mga pananalita.<br /> - O pagbanggit ng mga kahihiyan kabilang sa mga salita ng kahalayan at kabastusan.<br /> - Sumuway nga ang Propeta <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span> laban doon sa kabuuan niyon sapagkat nagsabi siya: "Ang mananampalataya ay hindi ang palapanirang-puri, hindi ang palasumpa, hindi ang mahalay, at hindi ang bastos." Nagsalaysay nito sina Imām At-Tirmidhīy at Imām Ibnu Ḥibbān. </p>',
            ],
            29 => [
                'question' => 'T30: Makababanggit ka ba ng mga kadahilanang nakatutulong sa Muslim sa pagsasaasal ng mga magandang kaasalan?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14500.mp3',
                'answer' => '<p> S: 1. Ang pagdalangin na pagkalooban ka ni Allāh ng kagandahan ng kaasalan at tulungan ka Niya roon.<br /> 2. Ang kamalayan kay Allāh <span class="c2">(kamahal-mahalan Siya at kapita-pitagan)</span> at na Siya ay nakaaalam sa iyo, nakaririnig sa iyo, at nakakikita sa iyo.<br /> 3. Ang pagsasaalaala sa gantimpala ng kagandahan ng kaasalan at na ito ay isang kadahilanan para sa pagpasok sa Paraiso.<br /> 4. Ang pagsasaalaala sa kahihinatnan ng kasagwaan ng kaasalan at na ito ay isang kadahilanan para sa pagpasok sa Impiyerno.<br /> 5. Na ang kagandahan ng kaasalan ay humahatak ng pag-ibig ni Allāh at pag-ibig ng nilikha Niya at na ang kasagwaan ng kaasalan ay humahatak ng galit ni Allāh at galit ng nilikha Niya.<br /> 6. Ang pagbabasa ng talambuhay ng Propeta <span class="c2">(sumakanya ang basbas at ang pangangalaga)</span> at ang pagtulad sa kanya.<br /> 7. Ang pakikisama sa mabubuti at ang pag-iwas sa pagsama sa masasama. </p>',
            ],
        ],
        8 => [
            0 => [
                'question' => 'T1: Ano ang kainaman ng dhikr?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14630.mp3',
                'answer' => '<p> Nagsabi ang Propeta <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span>: "Ang paghahalintulad sa umalaala sa Panginoon niya at hindi umalaala sa Panginoon niya ay ang paghahalintulad sa buhay at patay." Nagsalaysay nito si Imām Al-Bukhārīy.<br /> Ito ay dahil ang halaga ng buhay ng tao ay ayon sa sukat ng pag-alaala niya kay Allāh <span class="c2">(napakataas Siya)</span>. </p>',
            ],
            1 => [
                'question' => 'T2: Makababanggit ka ba ng ilan sa mga katuturan ng dhikr?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14670.mp3',
                'answer' => '<p> S: 1. Nagpapalugod ito sa Napakamaawain.<br /> 2. Nagtataboy ito sa demonyo.<br /> 3. Nagpapatibay ito sa Muslim laban sa mga kasamaan.<br /> 4. Natatamo dahil dito ang pabuya at ang gantimpala. </p>',
            ],
            2 => [
                'question' => 'T3: Ano ang pinakamainam na dhikr?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14730.mp3',
                'answer' => '<p> Ang pagsambit ng: "Lā ilāha illa –llāh. <span class="c2">(Walang Diyos kundi si Allāh,)</span>" Nagsalaysay nito sina Imām At-Tirmidhīy at Imām Ibnu Mājah. </p>',
            ],
            3 => [
                'question' => 'T4: Ano ang sasabihin mo sa sandali ng pagkagising mula sa tulog?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14760.mp3',
                'answer' => '<p> S: Alḥamdu lillāhi –lladhī aḥyānā ba`da mā amātanā wa-ilayhi –nnushūr. <span class="c2">(Ang papuri ay ukol kay Allāh na nagbigay-buhay sa atin matapos nagbigay-kamatayan sa atin at tungo sa Kanya ang pagkabuhay.)</span> Napagkaisahan ang katumpakan. </p>',
            ],
            4 => [
                'question' => 'T5: Ano ang sasabihin mo kapag nagsuot ka ng damit mo?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14790.mp3',
                'answer' => '<p> S: Alḥamdu lillāhi –lladhī kasānī hādha –ththawba wa-razaqanīhi min ghayri ḥawlim minnī wa lā qūwah. <span class="c2">(Ang papuri ay ukol kay Allāh na nagpasuot sa akin ng damit na ito at nagkaloob sa akin nito nang walang kapangyarihan mula sa akin at walang lakas.)</span> Nagsalaysay nito sina Imām Abū Dāwud, Imām At-Tirmidhīy, at iba pa sa kanila. </p>',
            ],
            5 => [
                'question' => 'T6: Ano ang sasabihin mo kapag naghubad ka ng damit mo?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14820.mp3',
                'answer' => '<p> S: Bismi –llāh. <span class="c2">(Sa ngalan ni Allān.)</span> Nagsalaysay nito si Imām At-Tirmidhīy. </p>',
            ],
            6 => [
                'question' => 'T7: Ano ang panalangin ng pagsusuot ng bagong damit?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14850.mp3',
                'answer' => '<p> Allāhumma laka –lḥamdu anta kasawtanīhi, as\'aluka min khayrihi wa-khayri mā ṣuni`a lahu, wa-a`ūdhu bika min sharrihi wa sharri mā ṣuni`a lahu. <span class="c2">(O Allāh, ukol sa Iyo ang papuri. Ikaw ay nagpasuot sa akin nito. Humihingi ako sa Iyo ng kabutihan nito at kabutihan ng kung para sa ano niyari ito. Nagpapakupkop ako sa Iyo laban sa kasamaan nito at kasamaan ng kung para sa ano niyari ito.)</span> Nagsalaysay nito sina Imām Abū Dāwud at Imām At-Tirmidhīy. </p>',
            ],
            7 => [
                'question' => 'T8: Ano ang panalangin para sa sinumang nagsuot ng isang bagong damit?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14880.mp3',
                'answer' => '<p> S: Kapag nakakita ng isang bagong damit sa iba pa sa iyo,<span class="c6"> mananalangin ka para sa kanya at magsasabi ka ng:</span> "Tublī wa-yukhlifu –llāhu ta`ālā. <span class="c2">(Lumain mo nawa at palitan nawa ni Allāh – napakataas Siya.)</span> Nagsalaysay nito si Imām Abū Dāwud. </p>',
            ],
            8 => [
                'question' => 'T9: Makababanggit ka ba ng panalangin ng pagpasok sa palikuran, ang lugar ng pagtugon sa tawag ng kalikasan?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14910.mp3',
                'answer' => '<p> S: "Allāhumma innī a`ūdhu bika mina –lkhubthi wa –lkhabā\'ith. <span class="c2">(O Allāh, tunay na ako ay nagpapakupkop sa Iyo laban sa mga lalaking demonyo at mga babaing demonyo.)</span>" Napagkaisahan ang katumpakan. </p>',
            ],
            9 => [
                'question' => 'T10: Ano ang panalangin ng paglabas mula sa palikuran?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14940.mp3',
                'answer' => '<p> Ghufrānak. <span class="c2">(<span class="c5">[Humihingi ako ng]</span> kapatawaran Mo.)</span>" Nagsalaysay nito sina Imām Abū Dāwud at Imām At-Tirmidhīy. </p>',
            ],
            10 => [
                'question' => 'T11: Ano ang sasabihin mo bago magsagawa ng wuḍū\'?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14970.mp3',
                'answer' => '<p> S: Bismi –llāh. <span class="c2">(Sa ngalan ni Allān.)</span> Nagsalaysay nito sina Imām Abū Dāwud at iba pa sa kanya. </p>',
            ],
            11 => [
                'question' => 'T12: Ano ang dhikr matapos ng pagkatapos ng wuḍū\'?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15000.mp3',
                'answer' => '<p> Ashhadu an lā ilāha illa –llāhu waḥdahu lā sharīka lah, wa ashhadu anna muḥammadan `abduhu wa rasūluh. <span class="c2">(Sumasaksi ako na walang Diyos kundi si Allāh – tanging Siya: walang katambal para sa Kanya; at sumasaksi ako na si Muḥammad ay Lingkod Niya at Sugo Niya.)</span>" Nagsalaysay nito si Imām Muslim. </p>',
            ],
            12 => [
                'question' => 'T13: Ano ang dhikr sa sandali ng paglabas mula sa tirahan?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15020.mp3',
                'answer' => '<p> Bismi -llāh, tawakkaltu `ala –llāh, wa lā ḥawla wa lā qūwata illā bi-llāh. <span class="c2">(Sa ngalan ni Allāh, nanalig ako kay Allāh. Walang kapangyarihan at walang lakas kundi sa pamamagitan ni Allāh.)</span> Nagsalaysay nito sina Imām Abū Dāwud at Imām At-Tirmidhīy. </p>',
            ],
            13 => [
                'question' => 'T14: Ano ang dhikr sa sandali ng pagpasok sa tirahan?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15050.mp3',
                'answer' => '<p> Bismi –llāhi walajnā wa bismi –llāhi kharajnā wa `alā rabbinā tawakkalnā. <span class="c2">(Sa ngalan ni Allāh, pumasok tayo; sa ngalan ni Allāh, lumabas tayo; at sa Panginoon natin, nanalig tayo.)</span> Nagsalaysay nito si Imām Abū Dāwud. </p>',
            ],
            14 => [
                'question' => 'T15: Ano ang panalangin ng pagpasok sa masjid?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15080.mp3',
                'answer' => '<p> S: Allāhumma –ftaḥ lī abwāba raḥmatik. <span class="c2">(O Allāh, magbukas Ka para sa akin ng mga pintuan ng awa Mo.)</span> Nagsalaysay nito si Imām Muslim. </p>',
            ],
            15 => [
                'question' => 'T16: Makababanggit ka ba ng panalangin ng paglabas mula sa masjid?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15110.mp3',
                'answer' => '<p> Allāhumma innī as\'aluka min faḍlik. <span class="c2">(O Allāh, tunay na ako ay humihingi sa Iyo mula sa kabutihang-loob Mo.)</span> Nagsalaysay nito si Imām Muslim. </p>',
            ],
            16 => [
                'question' => 'T17: Ano ang sasabihin mo sa sandali ng pagkarinig ng adhān?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15140.mp3',
                'answer' => '<p> S: Magsasabi ako ng tulad ng sinasabi ng mu\'adhdhin maliban sa "ḥayya `ala –ṣṣalāh" at "ḥayya `ala –lfalāḥ" sapagkat magsasabi ako ng "lā ḥawla wa-lā qūwata illā bi-llāh". Napagkaisahan ang katumpakan. </p>',
            ],
            17 => [
                'question' => 'T18: Ano ang sasabihin mo matapos ng adhān?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15170.mp3',
                'answer' => '<p> S: Mananalangin ako ng basbas sa Propeta <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span>. Nagsalaysay nito si Imām Muslim.<span class="c6"> Magsasabi ka ng:</span> "Allāhumma rabba hādhihi –dda`wati –ttāmmati wa-ṣṣalāti –lqā\'imah, āti muḥammadani –lwasīlata wa-lfaḍīlah, wa-b`athhu maqāmam maḥmūdani –lladhī wa`attahu. <span class="c2">(O Allāh, Panginoon nitong ganap na panawagan at ng ṣalāh na isasagawa, ibigay Mo kay Muḥammad ang kaparaanan at ang kalamangan at ibangon Mo siya sa isang tatayuang pupurihin, na ipinangako Mo.)</span>" Al-Bukhārīy.<br /> Dadalangin ka sa pagitan ng adhān at iqāmah sapagkat tunay na ang panalangin dito ay hindi tinatanggihan. </p>',
            ],
            18 => [
                'question' => 'T19: Ano ang sasabihin mo sa umaga at gabi mula sa mga dhikr?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15220.mp3',
                'answer' => '<p> S: 1. Bibigkas ako ng Āyatulkursīy <span class="c2">(Qur\'ān 2:255)</span>: "Allāhu lā ilāha illā huwa –lḥayyu –lqayyūm, lā ta\'khudhuhū sinatuw wa-lā nawm, lahū mā fi –ssamāwāti wa-mā fi –l\'arḍ; man dhā –lladhī yashfa`u `indahū illā bi\'idhnih, ya`lamu mā bayna aydīhim wa-<span class="c6">mā khalfahum:</span> wa-lā yuḥīṭūna bi-shay\'im min `ilmihī illā bimā shā\', wasi‘a kursīyuhu –ssamāwāti wa-<span class="c6">l\'arḍ:</span> wa-lā ya\'ūduhū hifđuhumā, wa-huwa –l`alīyu –l`ađīm. <span class="c2">(Si Allāh, walang Diyos kundi Siya, ang Buháy, ang Mapagpanatili. Walang nakatatangay sa Kanya na isang antok ni isang pagkatulog. Sa Kanya ang anumang nasa mga langit at ang anumang nasa lupa. Sino itong mamamagitan sa piling Niya malibang ayon sa pahintulot Niya? Nakaaalam Siya sa anumang nasa harapan nila at anumang nasa likuran nila. Hindi sila nakapapaligid sa anuman mula sa kaalaman Niya malibang ayon sa niloob Niya. Sumakop ang silya Niya sa mga langit at lupa at hindi nakabibigat sa Kanya ang pangangalaga sa mga ito. Siya ay ang Mataas, ang Sukdulan.)</span>" <span class="c2">(Qur\'ān 2:255)</span> 2.<span class="c6"> Bibigkas ako ng:</span> <span class="c2">(Sa ngalan ni Allāh, ang Napakamaawain, ang Maawain.)</span> 1. Qul huwa –llāhu aḥad <span class="c2">(Sabihin mo: "Siyang si Allāh ay Kaisa-isa.)</span> 2. Allāhu –ṣṣamad <span class="c2">(Si Allāh ay ang Dulugan <span class="c5">[sa pangangailangan]</span>.)</span> 3. Lam yalid wa-lam yūlad <span class="c2">(Hindi Siya nagkaanak at hindi Siya ipinanganak.)</span> 4. Wa-lam yakul lahū kufuwan aḥad <span class="c2">(Hindi nagkaroon sa Kanya ng isang kapantay na isa man.")</span>} nang tatlong beses; <span class="c2">(Sa ngalan ni Allāh, ang Napakamaawain, ang Maawain.)</span> 1. <span class="c2">(Sabihin mo: "Nagpapakupkop ako sa Panginoon ng bukang-liwayway)</span> 2. <span class="c2">(laban sa kasamaan ng anumang nilikha Niya)</span> 3. <span class="c2">(at laban sa kasamaan ng pusikit kapag lumaganap ito,)</span> 4. <span class="c2">(at laban sa kasamaan ng mga babaing <span class="c5">[manggagaway na]</span> palaihip sa mga buhol,)</span> 5. <span class="c2">(at laban sa kasamaan ng naiinggit kapag nainggit ito.")</span>} nang tatlong beses; <span class="c2">(Sa ngalan ni Allāh, ang Napakamaawain, ang Maawain.)</span> 1. <span class="c2">(Sabihin mo: "Nagpapakupkop ako sa Panginoon ng mga tao,)</span> 2. <span class="c2">(na Hari ng mga tao,)</span> 3. <span class="c2">(na Diyos ng mga tao,)</span> 4. <span class="c2">(laban sa kasamaan ng tagapasaring na palaurong,)</span> 5. <span class="c2">(na nagpapasaring sa mga dibdib ng mga tao,)</span> 6. <span class="c2">(kabilang sa mga jinn at mga tao.)</span>} nang tatlong beses; "Allāhumma anta rabbī, lā ilāha illā anta, khalaqtanī wa anā `abduka, wa-anā `alā `ahdika wa-wa`dika ma –staṭa`tu, a`ūdhu bika min sharri mā ṣana`tu, abū\'u laka bi-ni`matika `alayya, wa-abū\'u bi-dhambī, fa-ghfir lī fa-innahū lā yaghfiru –dhdhunūba illā ant. <span class="c2">(O Allāh, Ikaw ay Panginoon ko. Walang Diyos kundi Ikaw. Nilikha Mo ako at ako ay alipin Mo. Ako ay nasa ilalim ng kasunduan sa Iyo at pangako sa Iyo hanggang sa abot ng makakaya ko. Nagpapakupkop ako sa Iyo laban sa masama sa nagawa ko. Kinikilala ko sa Iyo ang biyaya Mo sa akin. Kinikilala ko sa Iyo ang kasalanan ko kaya patawarin Mo ako sapagkat walang nagpapatawad sa mga pagkakasala kundi Ikaw.)</span>" Nagsalaysay nito si Imām Al-Bukhārīy. </p>',
            ],
            19 => [
                'question' => 'T20: Ano ang sasabihin mo sa sandali ng pagtulog?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15290.mp3',
                'answer' => '<p> S: "Bi-smika –llāhumma, amūtu wa-aḥyā. <span class="c2">(Sa ngalan Mo, O Allāh, mamamatay ako at mabubuhay ako.)</span>" Napagkaisahan ang katumpakan. </p>',
            ],
            20 => [
                'question' => 'T21:Ano ang sasabihin mo bago kumain ng pagkain?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15320.mp3',
                'answer' => '<p> S: Bismi –llāh. <span class="c2">(Sa ngalan ni Allān.)</span><br /> Kapag nakalimutan mo sa simula nito,<span class="c6"> magsabi ka ng:</span><br /> "Bismi –llāhi fī awwalihi wa-ākhirih. <span class="c2">(Sa ngalan ni Allāh sa simula nito at sa katapusan nito.)</span>" Nagsalaysay nito sina Imām Abū Dāwud at Imām At-Tirmidhīy. </p>',
            ],
            21 => [
                'question' => 'T22: Ano ang sasabihin mo sa sandali ng pagkatapos ng pagkain?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15370.mp3',
                'answer' => '<p> S: Alḥamdu lillāhi ­–lladhī aṭ`amanī hādhā, wa-razaqanīhi min ghayri ḥawlim minnī wa-lā qūwah. <span class="c2">(Ang papuri ay ukol kay Allāh na nagpakain sa akin nito at nagtustos sa akin nito nang walang kapangyarihan mula sa akin at walang lakas.)</span> Nagsalaysay nito sina Imām Abū Dāwud, Imām Ibnu Mājah, at iba pa sa kanilang dalawa. </p>',
            ],
            22 => [
                'question' => 'T23: Ano ang panalangin ng panauhin sa may-ari ng pagkain?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15400.mp3',
                'answer' => '<p> Allāhumma bārik lahum fīmā razaqtahum wa-ghfir lahum wa­rḥamhum. <span class="c2">(O Allāh, biyayaan Mo sila sa anumang itinustos Mo sa kanila, patawarin Mo sila, at kaawaan Mo sila.)</span> Nagsalaysay nito si Imām Muslim. </p>',
            ],
            23 => [
                'question' => 'T24: Ano ang sasabihin ng tao kapag bumahin siya?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15430.mp3',
                'answer' => '<p> S: Alḥamdu lillāh. <span class="c2">(Ang papuri ay ukol kay Allāh.)</span><br /> Magsabi naman sa kanya ang kapatid niya o ang kasamahan niya ng: "Yarḥamuka –llāh. <span class="c2">(Kaawaan ka ni Allāh.)</span>"<br /> 4. Kaya kapag nagsabi naman ito niyan sa kanya,<span class="c6"> magsabi naman siya ng:</span> "Yahdīkumu –llāhu wa-yuṣlihu bālakum. <span class="c2">(Patnubayan kayo ni Allāh at pabutihin Niya ang lagay ninyo.)</span>" Nagsalaysay nito si Imām Al-Bukhārīy. </p>',
            ],
            24 => [
                'question' => 'T25: Ano ang sasabihin mo sa sandali ng pagtayo at pagkatapos ng pagtitipon na panalangin ng panakip-sala sa pagtitipon?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15480.mp3',
                'answer' => '<p> S: "Subḥānaka –llāhumma wa-bi-ḥamdik, ashhadu an lā ilāha illā anta, astaghfiruka wa-atūbu ilayk <span class="c2">(Kaluwalhatian sa Iyo, O Allāh, kalakip ng papuri sa Iyo. Sumasaksi ako na walang Diyos kundi Ikaw. Humihingi ako ng tawad sa Iyo at nagbabalik-loob ako sa Iyo.)</span>" Nagsalaysay nito sina Imām Abū Dāwud, Imām At-Tirmidhīy, at iba pa sa kanilang dalawa. </p>',
            ],
            25 => [
                'question' => 'T26: Ano ang panalangin ng pagsakay?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15510.mp3',
                'answer' => '<p> S: "Bismi –llāh, alḥamdu lillāh. <span class="c2">(Sa ngalan ni Allāh; ang papuri ay ukol kay Allāh.)</span>" at "Subḥāna ­–lladhī sakhkhara lanā hādhā, wa-mā kunnā lahū muqrinīn, wa-innā ilā rabbinā la-munqalibūn. <span class="c2">(Kaluwalhatian sa Kanya na nagpasunud-sunuran para sa atin nito at tayo rito ay hindi sana makakakaya. Tunay na kami sa Panginoon namin ay talagang magbabalik.)</span>" Nagsalaysay nito sina Imām Abū Dāwud at Imām At-Tirmidhīy. </p>',
            ],
            26 => [
                'question' => 'T27: Makababanggit ka ba ng panalangin ng paglalakbay?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15540.mp3',
                'answer' => '<p> "Allāhu akbar, Allāhu akbar, Allāhu akbar; subḥāna –­lladhī sakhkhara lanā hādhā, wamā kunnā lahū muqrinīn, wa-innā ilā rabbinā la-munqalibūn; Allāhumma innā nas\'aluka fī safarinā hādha ­lbirra wa ­ttaqwā wa mina ­l`amali mā tarḍā; Allāhumma hawwin `alaynā safaranā hādhā, wa-­ṭwi `annā bu`dah; Allāhumma anta –­ṣṣāhibu fi ­–ssafar, wa-­lkhalīfatu fi –­l\'ahli; Allāhumma innī a`ūdhu bika min wa`thā\'i –­ssafar, wa ka\'ābati –­lmanḍ̆ar, wa sū\'i –lmunqalabi fi –­lmāli wa-­l\'ahli. <span class="c2">(Si Allāh ay pinakadakila, si Allāh ay pinakadakila, si Allāh ay pinakadakila. Kaluwalhatian sa Kanya na nagpasunud-sunuran para sa atin nito at tayo rito ay hindi sana makakakaya. Tunay na kami sa Panginoon namin ay talagang magbabalik. O Allāh, tunay na kami ay humihiling sa Iyo sa paglalakbay naming ito ng kabutihan, pangingilag sa pagkakasala, at gawang ikalulugod Mo. O Allāh, pagaanin Mo sa amin ang paglalakbay naming ito at paiksiin Mo para sa amin ang layo nito. O Allāh, Ikaw ang kasama sa paglalakbay at ang pinag-iwanan sa mag-anak. O Allāh, tunay na ako ay nagpapakupkop sa Iyo laban sa hirap ng paglalakbay, laban sa panglaw ng tanawin, laban sa kasaklapan ng madadatnan sa ari-arian at mag-anak.)</span>"<br /> Kapag pauwi na,<span class="c6"> muling magsasabi ng mga panalanging ito at magdagdag ng sumusunod:</span><br /> "Āyibūna, tā\'ibūna, `ābidūna, li-rabbinā ḥāmidūn. <span class="c2">(<span class="c5">[Tayo ay]</span> mga umuuwi, na mga nagbabalik-loob, na mga sumasamba, na sa Panginoon natin ay mga nagpupuri.)</span> Nagsalaysay nito si Imām Muslim. </p>',
            ],
            27 => [
                'question' => '28. Ano ang panalangin ng maglalakbay para sa magpapaiwan?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15590.mp3',
                'answer' => '<p> S: Astawdi`ukumu –­­llāha –­­lladhī lā taḍī`u wadā\'i`uh. <span class="c2">(Naglalagak ako sa inyo kay Allāh na hindi mawawala sa piling Niya ang mga lagak sa Kanya.)</span> Nagsalaysay nito sina Imām Aḥmad at Imām Ibnu Mājah. </p>',
            ],
            28 => [
                'question' => '29. Ano ang panalangin ng magpapaiwan para sa maglalakbay?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15620.mp3',
                'answer' => '<p> Astawdi`u ­llāha dīnak, wa amānatak, wa khawātīma `amalik. <span class="c2">(Naglalagak ako kay Allāh ng relihiyon mo, ipinagkatiwala mo, at mga pangwakas ng gawain mo.)</span> Nagsalaysay nito sina Imām Aḥmad at Imām At-Tirmidhīy. </p>',
            ],
            29 => [
                'question' => 'T30: Ano ang panalangin ng pagpasok sa palengke?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15650.mp3',
                'answer' => '<p> Lā ilāha illa –llāhu waḥdahu lā sharīka lah, lahu –lmulku wa-lahu –lḥamd, yuhyī wa-yumīt, wa-huwa ḥayyun lā yamūt, bi-yadhi –lkhayr, wa-huwa `alā kulli shay\'in qadīr. <span class="c2">(Walang Diyos kundi si Allāh – tanging Siya: walang katambal para sa Kanya. Ukol sa Kanya ang paghahari at ukol sa Kanya ang papuri. Nagbibigay Siya ng buhay at bumabawi Siya ng buhay. Siya ay Buhay, hindi mamamatay. Nasa kamay Niya ang kabutihan. Siya sa bawat bagay ay May-kakayahan.)</span> Nagsalaysay nito sina Imām At-Tirmidhīy at Imām Ibnu Mājah. </p>',
            ],
            30 => [
                'question' => 'T31: Makababanggit ka ba ng panalangin sa sandali ng pagkagalit?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15680.mp3',
                'answer' => '<p> A`ūdhu bi-llāhi mina –shshayṭāni –rrajīm. <span class="c2">(Nagpapakupkop ako kay Allāh laban sa isinumpang Demonyo.)</span> Napagkaisahan ang katumpakan. </p>',
            ],
            31 => [
                'question' => 'T32: Ano ang sasabihin mo para sa sinumang nakagawa sa iyo ng isang nakabubuti?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15710.mp3',
                'answer' => '<p> S: Jazāka –­llāhu khayrā. <span class="c2">(Gantihan ka ni Allāh ng mabuti.)</span> Nagsalaysay nito si Imām At-Tirmidhīy. </p>',
            ],
            32 => [
                'question' => 'T33: Ano ang panalangin kapag nagloko ang sinasakyan?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15740.mp3',
                'answer' => '<p> S: Bismi –llāh. <span class="c2">(Sa ngalan ni Allān.)</span> Nagsalaysay nito si Imām Abū Dāwud. </p>',
            ],
            33 => [
                'question' => 'T34: Ano ang sasabihin mo kapag nangyari sa iyo ang nagpapagalak sa iyo?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15770.mp3',
                'answer' => '<p> S: Alḥamdu –lillāhi –­lladhī bi-ni`matihi tatimmu –­ṣṣāliḥāt. <span class="c2">(Ang papuri ay ukol kay Allāh na sa pamamagitan ng biyaya Niya ay nalulubos ang mga gawang maayos.)</span> Nagsalaysay nito si Imām Al-Ḥākim at ang iba pa sa kanya. </p>',
            ],
            34 => [
                'question' => 'T35: Ano ang sasabihin mo kapag nangyari ang kinasusuklaman mo?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15800.mp3',
                'answer' => '<p> S: Alḥamdu –lillāhi `alā kulli ḥāl. <span class="c2">(Ang papuri ay ukol kay Allāh sa bawat kalagayan.)</span> Ṣaḥīḥ Al-Jāmi` </p>',
            ],
            35 => [
                'question' => 'T36: Ano ang pamamaraan ng pagbati at pagtugon sa pagbati?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15830.mp3',
                'answer' => '<p> S: Magsasabi ang Muslim ng: "Assalāmu `alaykum wa-raḥamatu –llāhi wa-barakātuh. <span class="c2">(Ang kapayapaan ay sumainyo at ang awa ni Allāh at ang mga pagpapala Niya.)</span>"<br /> Tutugon naman sa kanya ang kapatid niya ng: "Wa-`alaykumu –ssalāmu wa-raḥamatu –llāhi wa-barakātuh. <span class="c2">(At sumaiyo ang kapayapaan at ang awa ni Allāh at ang mga pagpapala Niya.)</span>" Nagsalaysay nito sina Imām At-Tirmidhīy, Imām Abū Dāwud, at ang iba pa sa kanilang dalawa. </p>',
            ],
            36 => [
                'question' => 'T37: Ano ang panalangin sa sandali ng pagbaba ng ulan?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15870.mp3',
                'answer' => '<p> S: Allāhumma ṣayyiban nāfi`ā. <span class="c2">(O Allāh, <span class="c5">[gawin Mo ito na]</span> isang ulan na napakikinabangan.)</span> Al-Bukhārīy. </p>',
            ],
            37 => [
                'question' => 'T38: Ano ang panalangin matapos ng pagbaba ng ulan?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15900.mp3',
                'answer' => '<p> S: Muṭirnā bi-faḍli –­llāhi wa-raḥmatih. <span class="c2">(Inulan tayo dahil sa kabutihang-loob ni Allāh at awa Niya.)</span> Imām Al-Bukhārīy at Imām Muslim. </p>',
            ],
            38 => [
                'question' => 'T39: Makababanggit ka ba ng panalangin sa pag-ihip ng hangin?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15930.mp3',
                'answer' => '<p> S: Allāhumma innī as\'aluka khayrahā, wa-a`ūdhu bika min sharrihā. <span class="c2">(O Allāh, tunay na ako ay humihingi sa Iyo ng kabutihan nito at nagpapakupkop sa Iyo laban sa kasamaan nito.)</span> Nagsalaysay nito sina Imām Abū Dāwud at Imām Ibnu Mājah. </p>',
            ],
            39 => [
                'question' => 'T40: Makababanggit ka ba ng panalangin ng pagkarinig ng kulog?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15960.mp3',
                'answer' => '<p> Subḥāna –­lladhī yusabbiḥu ­–rra`du bi-ḥamdihi wa-­lmalā\'ikatu min khīfatihi. <span class="c2">(Kaluwalhatian sa Kanya na nagluluwalhati ang kulog kalakip ng papuri sa Kanya at ang mga anghel dahil sa pangangamba sa Kanya.)</span> Muwaṭṭa Mālik. </p>',
            ],
            40 => [
                'question' => 'T41: Ano ang panalangin kapag nakakita ka ng isang dinapuan ng kasawian?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15990.mp3',
                'answer' => '<p> Alḥamdu lillāhi ­–lladhī `āfānī mimmā ­–btalāka bihi wa-faḍḍalanī `alā kathīrim mimman khalaqa tafḍīlā. <span class="c2">(Ang papuri ay ukol kay Allāh na nagligtas sa akin mula sa kasawiang dumapo sa iyo at nagtangi sa akin nang higit na pagtangi kaysa sa marami sa nilikha Niya.)</span> Nagsalaysay nito si Imām At-Tirmidhīy. </p>',
            ],
            41 => [
                'question' => '42: Ano ang panalangin para sinumang dumanas ng anuman dahil sa usog?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16020.mp3',
                'answer' => '<p> S: Nasaad sa ḥadīth: "Kapag nakakita ang isa sa inyo mula sa kapatid niya o mula sa sarili nito o mula sa yaman nito ng nagpapahanga sa kanya, dumalangin siya para rito ng pagpapala sapagkat tunay na ang usog ay totoo." Nagsalaysay nito sina Imām Aḥmad, Imām Ibnu Mājah, at iba pa sa kanilang dalawa. </p>',
            ],
            42 => [
                'question' => 'T43: Papaano kang mananalangin ng basbas sa Propeta (sumakanya ang basbas at ang pangangalaga) ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16050.mp3',
                'answer' => '<p> S: Allāhumma ṣalli `alā Muḥammadin wa-`alā āli Muḥammad, kamā ṣallayta `alā Ibrāhīm wa-`alā āli Ibrāhīm, innaka ḥamīdum majīd. Allāhumma bārik `alā Muḥammadin wa-`alā āli Muḥammad, kamā bārakta `alā Ibrāhīm wa-`alā āli Ibrāhīm, innaka ḥamīdum majīd. <span class="c2">(O Allāh, pagpalain Mo si Muḥammad at ang mag-anak ni Muḥammad gaya ng pagpapala Mo kay Ibrāhīm at sa mag-anak ni Ibrāhīm; tunay na Ikaw ay Kapuri-puri, Maringal. O Allāh, biyayaan Mo si Muḥammad at ang mag-anak ni Muḥammad gaya ng pagbiyaya Mo kay Ibrāhīm at sa mag-anak ni Ibrāhīm; tunay na Ikaw ay Kapuri-puri, Maringal.)</span> Napagkaisahan ang katumpakan. </p>',
            ],
        ],
        9 => [
            0 => [
                'question' => 'T1: Ano ang limang patakarang pangnakaatang (ḥukm taklīfīy)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16090.mp3',
                'answer' => '<p> S:<br /> 1. Ang wājib <span class="c2">(kinakailangan)</span>;<br /> 2. Ang mustaḥabb <span class="c2">(naiibigan)</span>;<br /> 3. Ang muḥarram <span class="c2">(ipinagbabawal)</span>;<br /> 4. Ang makrūh <span class="c2">(di-kanaisnais)</span>;<br /> 5. Ang mubāḥ <span class="c2">(pinapayagan)</span>. </p>',
            ],
            1 => [
                'question' => 'T2: Maipaliliwanag mo ba ang limang patakarang ito?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16170.mp3',
                'answer' => '<p> S:<br /> 1. Ang wājib <span class="c2">(kinakailangan)</span> ay tulad ng limang ṣalāh, pag-aayuno sa Ramaḍān, at pagsasamabuting-loob sa mga magulang.<br /> - Ang wājib ay ginagantimpalaan ang tagagawa nito at pinarurusahan ang tagaiwan nito.<br /> 2. Ang mustaḥabb <span class="c2">(naiibigan)</span> ay tulad ng mga sunnah rātibah, pagdarasal sa gabi <span class="c2">(qiyāmullayl)</span>, pagbibigay ng pagkain, at pagbati. Tinatawag din ito na sunnah <span class="c2">(kalakaran)</span> at mandūb <span class="c2">(minamagaling)</span>.<br /> - Ang mustaḥabb ay ginagantimpalaan ang tagagawa nito at hindi pinarurusahan ang tagaiwan nito.<span class="c6"><br /> Mahalagang Puna:</span><br /> Nararapat para sa Muslim, kapag naririnig niya na ang bagay na ito ay sunnah o mustaḥabb na magdali-dali sa paggawa nito at pagtulad sa Propeta <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span>.<br /> 3. Ang muḥarram <span class="c2">(ipinagbabawal)</span> ay tulad ng pag-inom ng alak, kasuwailan sa mga magulang, at pagputol ng ugnayan sa kaanak.<br /> - Ang muḥarram ay ginagantimpalaan ang tagaiwan nito at pinarurusahan ang tagagawa nito.<br /> 4. Ang makrūh <span class="c2">(di-kanaisnais)</span> ay tulad ng pagkuha at pagbibigay sa pamamagitan ng kaliwang kamay at paglililis ng damit sa ṣalāh.<br /> - Ang makrūh ay ginagantimpalaan ang tagaiwan nito at hindi pinarurusahan ang tagagawa nito.<br /> 5. Ang mubāḥ <span class="c2">(pinapayagan)</span> ay tulad ng pagkain ng mansanas at pag-inom ng tsaa. Tinatawag din ito na jā\'iz <span class="c2">(pwede)</span> at ḥalāl <span class="c2">(pinahihintulutan)</span>.<br /> Ang mubāḥ ay hindi ginagantimpalaan ang tagaiwan nito at hindi pinarurusahan ang tagagawa nito. </p>',
            ],
            2 => [
                'question' => 'T3: Ano ang hatol sa pagtitinda at transaksiyon?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16320.mp3',
                'answer' => '<p> S: Ang batayang panuntunan sa lahat ng mga pagtitinda at mga transaksiyon ay na ang mga ito ay ḥalāl <span class="c2">(pinahihintulutan)</span> maliban sa ilan sa mga uri mula sa ipinagbawal ni Allāh.<span class="c6"><br /> Nagsabi si Allāh:</span> <span class="c4">{Nagpahintulot si Allāh ng pagtitinda at nagbawal Siya ng patubo.}</span> <span class="c2">(Qur\'ān 2:275)</span> </p>',
            ],
            3 => [
                'question' => 'T4: Makababanggit ka ba ng ilan sa mga uri ng mga transaksiyon at mga pagtitindang ipinagbabawal?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16360.mp3',
                'answer' => '<p> S:<br /> 1.<span class="c6"> Ang pandaraya:</span> ang pagkukubli ng kapintasan ng paninda.<br /> Ayon kay Abū Hurayrah <span class="c2">(malugod si Allāh sa kanya)</span>: {Ang Sugo ni Allāh <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span> ay naparaan sa isang bunton ng pagkain saka nagpasok siya ng kamay sa loob nito saka nakakapa ang mga daliri ng pamamasa kaya nagsabi siya: "Ano ito, O may-<span class="c6">ari ng pagkain?" Nagsabi naman ito:</span> "Tumama po riyan ang ulan, O Sugo ni Allāh.<span class="c6">" Nagsabi siya:</span> "Kaya ba hindi ka naglagay nito sa ibabaw ng pagkain upang makita ng mga tao? Ang sinumang nandaya ay hindi kabilang sa akin."} Nagsalaysay nito si Imām Muslim.<br /> 2. Ang ribā <span class="c2">(patubo o interes)</span> at tulad nito na kukuha ang isang tao ng 1,000 Piso na pautang sa kundisyon na babayaran niya ito ng 1,200 Piso.<br /> Ang karagdagan ay ang patubong ipinagbabawal.<span class="c6"><br /> Nagsabi si Allāh:</span> <span class="c4">{Nagpahintulot si Allāh ng pagtitinda at nagbawal Siya ng patubo.}</span> <span class="c2">(Qur\'ān 2:275)</span><br /> 2. Ang gharar <span class="c2">(panlalalang)</span> at ang pagkamangmang gaya ng pagtitinda sa iyo ng gatas samantalang nasa suso pa ng tupa o ng isda samantalang nasa tubig pa at hindi pa nahuhuli.<span class="c6"><br /> Nasaad sa ḥadīth:</span> {Sumaway ang Sugo ni Allāh <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span> laban sa pagtitinda ng panlalalang.} Nagsalaysay nito si Imām Muslim. </p>',
            ],
            4 => [
                'question' => 'T5: Makababanggit ka ba ng ilan sa mga biyaya ni Allāh sa iyo?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16460.mp3',
                'answer' => '<p> S: 1. Ang biyaya ng Islām at na ikaw ay hindi kabilang sa mga kampon ng kufr <span class="c2">(kawalang-pananampalataya)</span>.<br /> 2. Ang biyaya ng Sunnah at na ikaw hindi kabilang sa mga kampon ng mga bid`ah.<br /> 3. Ang biyaya ng kalusugan at kagalingan sa pandinig, paningin, paglalakad, at iba pa sa mga ito.<br /> 4. Ang biyaya ng pagkain, inumin, at isinusuot.<br /> Ang mga biyaya ni Allāh <span class="c2">(napakataas Siya)</span> sa atin ay marami na hindi nabibilang at hindi naiisa-isa.<span class="c6"><br /> Nagsabi si Allāh:</span> <span class="c4">{Kung magbibilang kayo ng biyaya ni Allāh ay hindi kayo makapag-iisa-isa nito. Tunay na si Allāh ay talagang Mapagpatawad, Maawain.}</span> <span class="c2">(Qur\'ān 16:18)</span> </p>',
            ],
            5 => [
                'question' => 'T6: Ano ang kinakailangan sa mga biyaya? Papaano kang magpapasalamat sa mga ito?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16540.mp3',
                'answer' => '<p> S: Ang kinakailangan ay ang magpasalamat sa mga ito. Iyon ay sa pamamagitan ng pagbubunyi kay Allāh at pagpupuri sa kanya sa pamamagitan ng dila yayamang sa Kanya – tanging sa Kanya – ang kabutihang-loob at ng paggamit ng mga biyayang ito sa nakapagpapalugod kay Allāh <span class="c2">(napakataas Siya)</span> hindi sa pagsuway sa Kanya. </p>',
            ],
            6 => [
                'question' => 'T7: Ano ang mga `id (pagdiriwang) ng mga Muslim?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16570.mp3',
                'answer' => '<p> S: Ang `Idul fiṭr <span class="c2">(Pagdiriwang ng Pagtigil-ayuno)</span> at ang `Idul \'aḍḥā <span class="c2">(Pagdiriwang ng Pag-aalay)</span>.<span class="c6"><br /> Nasaad sa ḥadīth ni Anas na nagsabi:</span> {Dumating ang Sugo ni Allāh <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span> sa Madīnah at mayroon silang dalawang araw na naglalaro sila sa dalawang ito kaya nagsabi siya: "Ano ang dalawang araw na ito?" Nagsabi sila: "Kami noon ay naglalaro sa dalawang ito sa Panahon ng Kamangmangan." Kaya nagsabi ang Sugo ni Allāh <span class="c2">(basbasan siya ni Allāh at pangalagaan)</span>: "Tunay na si Allāh ay nagpalit nga sa inyo sa dalawang ito ng higit na mabuti kaysa sa dalawang ito: ang araw ng pag-aalay at ang araw ng pagtigil-ayuno."} Nagsalaysay nito si Imām Abū Dāwūd.<br /> Ang anumang iba pa sa dalawang ito na mga `īd ay kabilang sa mga bid`ah. </p>',
            ],
            7 => [
                'question' => 'T8: Ano ang pinakamainam sa mga buwan?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16620.mp3',
                'answer' => '<p> S: Ang buwan ng Ramaḍān. </p>',
            ],
            8 => [
                'question' => 'T9: Ano ang pinakamainam sa mga araw?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16650.mp3',
                'answer' => '<p> S: Ang araw ng Biyernes. </p>',
            ],
            9 => [
                'question' => 'T10: Ano ang pinakamainam na araw sa taon?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16680.mp3',
                'answer' => '<p> S: Ang Araw ng `Arafah. </p>',
            ],
            10 => [
                'question' => 'T11: Ano ang pinakamainam na gabi sa taon?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16710.mp3',
                'answer' => '<p> S: Ang Laylatul qadr <span class="c2">(Gabi ng Pagtatakda)</span>. </p>',
            ],
            11 => [
                'question' => 'T12: Ano ang kinakailangan kapag nakakita ka ng babaing estranghera (hindi kaanu-ano)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16740.mp3',
                'answer' => '<p> S: Ang kinakailangan ay ang magbaba ng paningin.<span class="c6"> Nagsabi si Allāh:</span> <span class="c4">{Sabihin mo sa mga lalaking mananampalataya na magbaba sila ng mga paningin nila...}</span> <span class="c2">(Qur\'ān 24:30)</span> </p>',
            ],
            12 => [
                'question' => 'T13: Sino ang mga kaaway ng tao?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16770.mp3',
                'answer' => '<p> 1. Ang sariling palautos ng kasagwaan. Iyon ay ang pagsunod ng tao sa idinidikta sa kanya ng sarili niya at pithaya niya sa pagsuway kay Allāh <span class="c2">(napakamapagpala Siya at napakataas)</span>. Nagsabi si Allāh <span class="c2">(kaluwalhatian sa Kanya)</span>: <span class="c4">{Tunay na ang sarili ay talagang palautos ng kasagwaan, maliban sa kinaawaan ng Panginoon ko. Tunay na ang Panginoon ko ay Mapagpatawad, Maawain.}</span> <span class="c2">(Qur\'ān 12:53)</span> 2. Ang demonyo. Ito ay kaaway ng anak ni Adan at ang layon nito ay magligaw sa tao, magpasaring sa kanya sa kasamaan, at magpasok sa kanya sa Impiyerno.<span class="c6"> Nagsabi si Allāh:</span> <span class="c4">{at huwag kayong sumunod sa mga yapak ng demonyo. Tunay na siya para sa inyo ay isang kaaway na malinaw.}</span> <span class="c2">(Qur\'ān 2:168)</span> 3. Ang mga kasamahan sa kasagwaan na mga humihimok sa kasamaan at bumabalakid sa kabutihan.<span class="c6"> Nagsabi si Allāh:</span> <span class="c4">{Ang mga matalik na magkaibigan, sa Araw na iyon, ang iba sa kanila para sa iba pa ay kaaway, maliban sa mga tagapangilag magkasala.}</span> <span class="c2">(Qur\'ān 43:67)</span> </p>',
            ],
            13 => [
                'question' => 'T14: Ano ang tawbah (pagbabalik-loob)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16820.mp3',
                'answer' => '<p> S: Ang tawbah <span class="c2">(pagbabalik-loob)</span> ay ang pagbabalik buhat sa pagsuway kay Allāh <span class="c2">(napakataas Siya)</span> tungo sa pagtalima sa Kanya.<span class="c6"> Nagsabi si Allāh:</span> <span class="c4">{Tunay na Ako ay talagang Palapatawad para sa sinumang nagbalik-loob, sumampalataya, at gumawa ng maayos, pagkatapos ay nagpagabay.}</span> <span class="c2">(Qur\'ān 20:82)</span> </p>',
            ],
            14 => [
                'question' => '15. Ano ang mga kundisyon ng tumpak na pagbabalik-loob?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16850.mp3',
                'answer' => '<p> S: 1. Ang pagkalas sa pagkakasala;<br /> 2. Ang pagsisisi sa nagdaang pagkakasala;<br /> 3. Ang pagtitika sa hindi panunumbalik doon;<br /> 4. Ang pagpapanumbalik ng mga karapatan at mga kawalang-katarungan sa mga kinauukulan ng mga ito.<span class="c6"><br /> Nagsabi si Allāh:</span> <span class="c4">{na mga kapag nakagawa ng isang mahalay o lumabag sa katarungan sa mga sarili nila ay umaalaala kay Allāh kaya humihingi ng tawad para sa mga pagkakasala nila – at sino ang nagpapatawad sa mga pagkakasala kundi si Allāh – at hindi nagpupumilit sa nagawa nila habang sila ay nakaaalam.}</span> <span class="c2">(Qur\'ān 3:135)</span> </p>',
            ],
            15 => [
                'question' => 'T16: Ano ang kahulugan ng panalangin ng basbas sa Propeta (basbasan siya ni Allāh at pangalagaan)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16920.mp3',
                'answer' => '<p> S: Ang kahulugan nito ay na ikaw ay dumadalangin kay Allāh na magbunyi siya sa Propeta Niya <span class="c2">(basbasan Niya ito at pangalagaan)</span> sa pinakamataas na konseho. </p>',
            ],
            16 => [
                'question' => 'T17: Ano ang kahulugan ng: Subḥāna –llāh (Kaluwalhatian kay Allāh)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16950.mp3',
                'answer' => '<p> S: Ang pagluluwalhati. Ito ang pagpapawalang-kinalaman kay Allāh <span class="c2">(kaluwalhatian sa Kanya at napakataas Siya)</span> sa bawat kakulangan, kapintasan, at kasagwaan. </p>',
            ],
            17 => [
                'question' => 'T18: Ano ang kahulugan ng: Alḥamdu lillāh (Ang papuri ay ukol kay Allāh)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16980.mp3',
                'answer' => '<p> S: Ito ay ang pagbubunyi kay Allāh <span class="c2">(napakataas Siya)</span> at ang paglalarawan sa Kanya sa lahat ng mga katangian ng pagkalubos. </p>',
            ],
            18 => [
                'question' => 'T19: Ano ang kahulugan ng: Allāhu akbar (Si Allāh ay pinakadakila)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/17000.mp3',
                'answer' => '<p> S: Nangangahulugan ito na Si Allāh <span class="c2">(kaluwalhatian sa Kanya)</span> ay pinakadakila sa bawat bagay, pinakakapita-pitagan, pinakasukdulan, at pinakamakapangyarihan sa bawat bagay. </p>',
            ],
            19 => [
                'question' => 'T20: Ano ang kahulugan ng: Lā ḥawla wa-lā qūwata illaā bi-llāh (Walang kapangyarihan at walang lakas kundi sa pamamagitan ni Allāh)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/17030.mp3',
                'answer' => '<p> S: Ang kahulugan nito ay walang pagpapakabagong-anyo para sa tao mula sa isang kalagayan patungo sa isang kalagayan at walang lakas para sa kanya roon kundi sa pamamagitan ni Allāh. </p>',
            ],
            20 => [
                'question' => 'T21: Ano ang kahulugan ng: Astaghfiru –llāh (Humihingi ako ng tawad kay Allāh)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/17060.mp3',
                'answer' => '<p> Nangangahulugan ito na humihiling ang tao mula sa Panginoon niya na burahin at pagtakpan ang mga kapintasan niya. </p>',
            ],
        ],
    ],
];
