<?php
$data = [
    'title' => 'What Muslim Children Must Know',
    'description' => 'A project that contains a simple and easy curriculum for issues that a Muslim must know. It includes issues of belief, jurisprudence, prophetic biography, etiquette, tafsir, hadith, morals, and remembrance of Allah. It is suitable for young children in particular, for all ages, and newcomers to Islam.',
    'source' => 'https://kids.islamenc.com/yo/home',
    'author' => 'Yazan Abdul Razzaq Raziq Alghanim',
    'sections' => [
        0 => '“Abala igbagbọ”',
        1 => '"Abala imọ agboye ẹṣin "',
        2 => 'Ipin Itan Anabi.',
        3 => 'Ipin Tafsīr',
        4 => 'Ipin Hadīth',
        5 => '"Abala awọn ẹkọ ti Isilaamu"',
        6 => '"Ipin àwọn iwa"',
        7 => '"Ipin awọn adua ati awọn iranti"',
        8 => '"Ipin awọn nkan oríṣiríṣi"',
    ],
    'data' => [
        1 => [
            0 => [
                'question' => 'Ìbéèrè àkọ́kọ́: Ta ni Ọlọhun Rẹ? “',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/200.mp3',
                'answer' => '<p> “Idahun- Allahu ni Oluwa mi ẹni ti o ṣe pe Oun ni O n tọju mi ti O si n tọju gbogbo agbaye pẹlu idẹra Rẹ.<span class="c6"> “<br /> “Ẹri ni:</span> Ọ̀rọ̀ Rẹ -Ọba ti ọla Rẹ ga-: “ Gbogbo ọpẹ́ ń jẹ́ ti Allāhu, Olúwa gbogbo ẹ̀dá, 2 <span class="c5">[Surah Al-<span class="c6">Fâtihah:</span> 2]</span> </p>',
            ],
            1 => [
                'question' => '"Ibeere ẹlẹẹkeji: ki ni ẹsin rẹ? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/240.mp3',
                'answer' => '<p> "Idahun- Ẹsin mi ni Isilaamu,<span class="c6"> oun ni:</span> Jijupa-jusẹ fun Ọlọhun pẹlu igbagbọ ninu Ẹ ni Oun nikan ṣoṣo, ati itẹriba fun Un pẹlu itẹle, ati mimọ kuro nibi ẹbọ ati awọn ẹlẹbọ.<span class="c6"> "<br /> Ọba ti ọla Rẹ ga sọ pe:</span> Dájúdájú ẹ̀sìn t’ó wà lọ́dọ̀ Allāhu ni ’Islām. <span class="c5">[Surah Âl-<span class="c6">`Imrân:</span> 19]</span>" </p>',
            ],
            2 => [
                'question' => '"Ibeere ẹlẹẹkẹta: Ta ni Anọbi rẹ? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/280.mp3',
                'answer' => '<p> "Idahun- Anọbi Muhammad <span class="c2">(ki ikẹ Ọlọhun ati ọla Rẹ maa ba a)</span>.<span class="c6"> "<br /> Ọba ti ọla Rẹ ga sọ pe:</span> <span class="c4">{Muhammad ni Òjíṣẹ́ Allāhu ...}</span> "<span class="c5">[Surah Al-<span class="c6">Fath:</span> 29]</span>" </p>',
            ],
            3 => [
                'question' => '"Ibeere ẹlẹẹkẹrin: Darukọ Kalmatut Taohīd (gbolohun igba Ọlọhun gbọ ni ọkan ṣoṣo), ati pe ki ni itumọ ẹ? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/310.mp3',
                'answer' => '<p> "Idahun- Kalmatut Taohīd ni "Laa ilaaha illallahu",<span class="c6"> itumọ ẹ ni pe:</span> Ko si ẹni tí ijọsin ododo tọ si afi Allahu.<span class="c6"> "<br /> Ọba ti ọla Rẹ ga sọ pe:</span> Nítorí náà, mọ̀ pé dájúdájú kò sí ọlọ́hun tí ìjọ́sìn tọ́ sí àfi Allāhu. "<span class="c5">[Suuratu Muhammad: 19]</span>" </p>',
            ],
            4 => [
                'question' => '"Ibeere ẹlẹẹkarun-un: Ibo ni Ọlọhun - ti O lágbára ti O gbọnngbọn - wa? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/350.mp3',
                'answer' => '<p> "Idahun- Ọlọhun n bẹ ni sanmọ lori itẹ-ọla, lori gbogbo ẹda, Ọba -ti ọla Rẹ ga-<span class="c6"> sọ pe:</span> " "<span class="c4">{Àjọkẹ́-ayé gúnwà sórí Ìtẹ́-ọlá 5}</span> "<span class="c5">[Surah Tâ-<span class="c6">hâ:</span> 5]</span>" O sọ pe: "<span class="c4">{Òun sì ni Olùborí t’Ó wà lókè àwọn ẹrú Rẹ̀. Òun ni Ọlọ́gbọ́n, Onímọ̀-ìkọ̀kọ̀ 18}</span> "<span class="c5">[Surah Al-<span class="c6">An`âm:</span> 18]</span>" </p>',
            ],
            5 => [
                'question' => '"Ibeere ẹlẹẹkẹfa: Ki ni itumọ jijẹrii pe dajudaju Muhammad ni Ojiṣẹ Ọlọhun? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/380.mp3',
                'answer' => '<p> "Idahun-<span class="c6"> Itumọ ẹ ni pe:</span> Ọlọhun ni O ran an si gbogbo aye ni olufunni ni iro ìdùnnú ati olukilọ "<br /> "O si jẹ dandan: "<br /> "Titẹle e nibi nnkan to ba pa laṣẹ. "<br /> "Gbigba a lododo nibi nnkan ti o ba sọ. "<br /> "Ki a ma ṣẹ ẹ. "<br /> "Ki a ma jọsin fun Ọlọhun afi pẹlu nnkan ti O ṣe lofin, oun ni itẹle oju-ọna ojiṣẹ Ọlọhun ati gbigbe adadaalẹ ju silẹ. "<br /> "Ọba -ti ọla Rẹ ga- sọ pe-: {Ẹnikẹ́ni t’ó bá tẹ̀lé Òjíṣẹ́ náà, ó ti tẹ̀lé <span class="c2">(àṣẹ)</span> Allāhu...} <span class="c5">[Suuratun Nisâ\': 80]</span>, O tun sọ- mimọ ni fun Un-<span class="c6"> pe:</span> <span class="c4">{Àti pé kò níí sọ̀rọ̀ ìfẹ́-inú 3 Kò níí sọ ohun kan tayọ ìmísí tí A fi ránṣẹ́ sí i 4}</span> "<span class="c5">[Suuratun Najm: 3, 4]</span> "Ọba - ti O lágbára ti O gbọnngbọn -<span class="c6"> sọ pe:</span> " "{Dájúdájú àwòkọ́ṣe rere wà fun yín lára Òjíṣẹ́ Allāhu fún ẹnikẹ́ni tí ó bá ń retí <span class="c2">(ẹ̀san)</span> Allāhu àti Ọjọ́ Ìkẹ́yìn, tí ó sì rántí Allāhu ní ọ̀pọ̀lọ́pọ̀ <span class="c2">(ìgbà)</span> 21} <span class="c5">[Surah Al-<span class="c6">Ahzâb:</span> 21]</span>" </p>',
            ],
            6 => [
                'question' => '"Ibeere ẹlẹẹkeje: Nitori ki ni Ọlọhun -ti ọla Rẹ ga- ṣe da wa?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/480.mp3',
                'answer' => '<p> "Idahun- O da wa fun ijọsin Rẹ ni Oun nikan ṣoṣo ti ko si orogun kankan fun Un. "<br /> "Ko kii ṣe tori iranu ati ere.<span class="c6"> "<br /> Ọba ti ọla Rẹ ga sọ pe:</span> "<span class="c4">{Àti pé Èmi kò ṣẹ̀dá àlùjànnú àti ènìyàn bí kò ṣe pé kí wọ́n lè jọ́sìn fún Mi 56}</span> "<span class="c5">[Surah Adh-<span class="c6">Dhâriyât:</span> 56]</span>" </p>',
            ],
            7 => [
                'question' => '"Ibeere ẹlẹẹkẹjọ: Kí ni o n jẹ ijọsin? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/530.mp3',
                'answer' => '<p> "Idahun- Oun ni orukọ kan to ko gbogbo nnkan ti Ọlọhun nífẹ̀ẹ́ rẹ ati nnkan ti O yọnu si ninu awọn ọrọ ati iṣẹ ti o pamọ ati èyí tí o han sinu.<span class="c6">"<br /> "Eyi to han:</span> Gẹgẹ bii iranti Ọlọhun pẹlu ahọn ninu iṣe afọmọ, ati idupẹ, ati igbe Ọlọhun tobi, ati kiki irun ati ṣiṣe Hajj.<span class="c6"> "<br /> "Eyi to pamọ:</span> Gẹgẹ bii igbarale Ọlọhun ati ibẹru ati agbiyele. " </p>',
            ],
            8 => [
                'question' => '"Ibeere ẹlẹẹkẹsan-an: Ki ni nnkan to tobi julọ ti o jẹ dandan fun wa? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/580.mp3',
                'answer' => '<p> Idahun-<span class="c6"> "Nnkan to tobi julọ ti o jẹ dandan fun wa ni:</span> Nini igbagbọ ninu Ọlọhun -ti ọla Rẹ ga- ni Òun nikan ṣoṣo. " </p>',
            ],
            9 => [
                'question' => '"Ibeere ẹlẹẹkẹwaa: Ki ni awọn iran Taohīd (nini igbagbọ ninu Ọlọhun nikan ṣoṣo)? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/610.mp3',
                'answer' => '<p> "Idahun-1-<span class="c6"> Taohīdur Rubūbiyyah:</span> Oun ni nini igbagbọ pe dajudaju Ọlọhun ni Adẹdaa, Olupese, Olukapa, Oluṣeto, ni Oun nikan ṣoṣo ti ko si orogun kankan fun Un. "<br /> "2-<span class="c6"> Taohīdul \'Ulūhiyyah:</span> Oun ni imu Ọlọhun ni ọkan ṣoṣo pẹlu ijọsin, ti a o si nii jọsin fun ẹnikankan afi Allahu -ti ọla Rẹ ga- "<br /> "3-<span class="c6"> Taohīdul ’Asmā’i was Sifāt:</span> Oun ni nini igbagbọ ninu awọn orukọ ati awọn iroyin ti Ọlọhun -ti ọla Rẹ ga- ti o wa ninu iwe Ọlọhun ati ọrọ ojiṣẹ Ọlọhun, laisi isafiwe tabi afijọ tabi sisọ pe ko ri bẹẹ.<span class="c6"> "<br /> "Ẹri awọn iran nini igbagbọ ninu Ọlọhun nikan ṣoṣo mẹtẹẹta ni:</span> ọrọ Ọba ti ọla Rẹ ga -<span class="c6"> to sọ pe:</span>" <span class="c4">{Olúwa àwọn sánmọ̀ àti ilẹ̀ àti ohun tí ń bẹ láààrin àwọn méjèèjì. Nítorí náà, jọ́sìn fún Un, kí ó sì ṣe sùúrù lórí ìjọ́sìn Rẹ̀. Ǹjẹ́ o mọ ẹni tí ó tún ń jẹ́ orúkọ Rẹ̀? 65}</span> " <span class="c5">[Surah Maryam: 65]</span>" </p>',
            ],
            10 => [
                'question' => '"Ibeere ẹlẹẹkọọkanla: Ki ni ẹṣẹ ti o tobi julọ? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/670.mp3',
                'answer' => '<p> "Idahun-<span class="c6"> mimu orogun pẹlu Ọlọhun ti ọla Rẹ ga”<br /> Ọba ti ọla Rẹ ga sọ pe:</span> "{Dájúdájú Allāhu kò níí foríjin <span class="c2">(ẹni tí)</span> ó bá ń ṣẹbọ sí I. Ó sì máa ṣàforíjìn fún ohun mìíràn yàtọ̀ sí ìyẹn fún ẹni tí Ó bá fẹ́. Ẹni tí ó bá ń ṣẹbọ sí Allāhu, dájúdájú ó ti dá àdápa irọ́ <span class="c2">(tí ó jẹ́)</span> ẹ̀ṣẹ̀ ńlá 48}" "<span class="c5">[Surah An-<span class="c6">Nisâ\':</span> 48]</span>" </p>',
            ],
            11 => [
                'question' => '"Ibeere ẹlẹẹkejila: Darukọ ẹbọ ati awọn iran rẹ?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/710.mp3',
                'answer' => '<p> "Idahun- Ash-<span class="c6">Shirku:</span> Oun ni gbigbe eyikeyi iran ninu awọn iran ijọsin fun ẹlomiran yatọ si Ọlọhun ti ọla Rẹ ga”<br /> "Awọn iran ẹ: "<br /> "Ẹbọ nla; gẹgẹ bii: Pipe ẹni ti o yatọ si Ọlọhun -ti ọla Rẹ ga-, tabi fifi ori balẹ fun ẹni ti o yatọ si I -mimọ fun Un-, abi didu ẹran fun ẹni ti o yatọ si Ọlọhun - ti O lágbára ti O si tun gbọnngbọn-.<span class="c6"> "<br /> "Ẹbọ kekere; gẹgẹ bii:</span> Bibura pẹlu nǹkan ti o yatọ si Ọlọhun -ti ọla Rẹ ga-, tabi At-Tamā’im <span class="c2">(asokọrun)</span>, oun naa ni nnkan ti wọn maa n so kọ lati fi fa anfaani wa tabi ti aburu danu, ati eyi to kere ninu ṣekarimi, gẹgẹ bii ki o maa ki irun rẹ dáadáa latari pe o n ri awọn ti wọn n wo o. " </p>',
            ],
            12 => [
                'question' => '"Ibeere ẹlẹẹkẹtala: Ǹjẹ́ ẹnikankan yatọ si Ọlọhun -ti ọla Rẹ ga- ni imọ ikọkọ? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/770.mp3',
                'answer' => '<p> "Idahun- ẹnikankan o ni imọ ikọkọ afi Ọlọhun nikan ṣoṣo.<span class="c6"> "<br /> Ọba ti ọla Rẹ ga sọ pe:</span> "<span class="c4">{Sọ pé: “Àwọn t’ó wà nínú àwọn sánmọ̀ àti ilẹ̀ kò nímọ̀ ìkọ̀kọ̀ àfi Allāhu. Àti pé wọn kò sì mọ àsìkò wo ni A máa gbé àwọn òkú dìde 65}</span> " "<span class="c5">[Suuratun Naml: 65]</span>" </p>',
            ],
            13 => [
                'question' => '"Ibeere ẹlẹẹkẹrinla: Onka awọn origun igbagbọ? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/810.mp3',
                'answer' => '<p> "Idahun- 1- Nini igbagbọ ninu Ọlọhun ti ọla Rẹ ga”<br /> "2- Ati awọn Malaika Rẹ."<br /> "3- Ati awọn iwe Rẹ. "<br /> "4- Ati awọn Ojiṣẹ Rẹ."<br /> "5- Ati ọjọ ikẹyin. "<br /> "Ati kadara eyi ti o daa nibẹ ati eyi ti o buru.<span class="c6">"<br /> "Ẹri ni:</span> Hadisi Jibril ti o gbajumọ lọdọ Muslim, Jibril sọ fun Anọbi -ki ikẹ Ọlọhun ati ọla Rẹ maa ba a-<span class="c6"> pe:</span> " "<span class="c3">«Fun mi ni iro nipa igbagbọ,<span class="c6"> o sọ pe:</span> Ki o ni igbagbọ ninu Ọlọhun, ati awọn Malaika Rẹ, ati awọn iwe Rẹ, ati awọn Ojiṣẹ Rẹ, ati ọjọ ikẹyin, ki o ni igbagbọ ninu kadara eyi ti o daa nibẹ ati eyi ti o buru»</span>. " </p>',
            ],
            14 => [
                'question' => '"Ibeere ẹlẹẹkarundinlogun: Ṣe alaye awọn origun igbagbọ? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/900.mp3',
                'answer' => '<p> "Idahun-<span class="c6"> Nini igbagbọ ninu Ọlọhun ti ọla Rẹ ga:</span> "<br /> "Ki o ni igbagbọ pe dajudaju Allahu ni O da ọ ti O si n pese fun ọ, Oun nikan ṣoṣo ni Olukapa ati Oluṣeto gbogbo ẹda. "<br /> "Oun ni Ẹni ti a n jọsin fun, ko si ẹni ti ijọsin ododo tọ si yatọ si I."<br /> "Dajudaju Oun ni Ọba ti O tobi, Ọba nla, Ọba ti O pe julọ ti O ṣe pe gbogbo ọpẹ patapata n jẹ tiRẹ, awọn orukọ to rẹwa ati awọn iroyin to ga n jẹ tiRẹ, ko si orogun fun Un, nnkankan o si jọ Ọ <span class="c2">(mimọ ni fun Un)</span>.<span class="c6"> "<br /> " Nini igbagbọ ninu awọn Malaika:</span> "<br /> "Awọn ni ẹda ti Ọlọhun da wọn latara imọle, ati fun ijọsin Rẹ ati fun itẹle to pe fun aṣẹ Rẹ"<br /> "Ninu wọn ni Jibrīl -ki ikẹ Ọlọhun maa ba a- wa, ẹni ti o ṣe pe o maa n sọkalẹ pẹlu imisi fun awọn Anọbi.<span class="c6">"<br /> "Nini igbagbọ ninu awọn iwe:</span> "<br /> Awọn ni awọn iwe ti Ọlọhun sọ wọn kalẹ fun awọn Ojiṣẹ Rẹ.<span class="c6"> "<br /> "Gẹgẹ bii Kuraani:</span> Ti a sọkalẹ fun Muhammad -ki ikẹ Ọlọhun ati ọla Rẹ maa ba a-<span class="c6">"<br /> "Injīl:</span> Ti a sọkalẹ fun Isa -ki ikẹ Ọlọhun maa ba a-<span class="c6">"<br /> "Taorah:</span> Ti a sọkalẹ fun Musa -ki ikẹ Ọlọhun maa ba a-<span class="c6">"<br /> "Zabūr:</span> Ti a sọkalẹ fun Dāud -ki ikẹ Ọlọhun maa ba a-<span class="c6"> "<br /> Awọn takada Ibrāhīm ati Mūsa:</span> Ti a sọkalẹ fun Ibrohim ati Musa."<br /> Nini igbagbọ si awọn ojiṣẹ <span class="c5">[Ọlọhun]</span><br /> "Awọn ni ẹni ti Ọlọhun ran wọn si awọn ẹru Rẹ lati kọ wọn <span class="c2">(ni ẹsin)</span>, ati lati fun wọn ni iro idunnu pẹlu daadaa ati alujanna, ati lati ṣe ikilọ fun wọn kuro nibi aburu ati ina.<span class="c6"> "<br /> "Awọn ti wọn lọla julọ ninu wọn ni:</span> Awọn onipinnu,<span class="c6"> awọn si ni:</span><br /> " Nūh -ki ikẹ Ọlọhun maa ba a- "<br /> " Ibrāhīm -ki ikẹ Ọlọhun maa ba a- "<br /> Mūsa -ki ikẹ Ọlọhun maa ba a-"<br /> "Ēsa -ki ikẹ Ọlọhun maa ba a- "<br /> Muhammad -ki ikẹ Ọlọhun ati ọla Rẹ maa ba a-."<br /> Nini igbagbọ si ọjọ ikẹyin.<br /> "Oun ni nnkan to wa lẹyin iku ninu sàréè, ati ni ọjọ ajinde, ati ọjọ igbende ati iṣiro, ni ibi ti awọn ero alujanna o ti maa wa ni awọn ibugbe wọn ti awọn ero ina naa o si maa wa ninu awọn ibugbe wọn.<span class="c6">"<br /> "Nini igbagbọ ninu kadara eyi to daa ninu ẹ ati eyi to buru:</span> "<br /> "Al-Qadar <span class="c2">(Kadara)</span>: Oun ni nini adisọkan pe dajudaju Ọlọhun ni imọ nipa gbogbo nnkan ti o n ṣẹlẹ ninu aye, ati pe O ti kọ yẹn sinu Laohul Mahfūdh <span class="c2">(ọpọn ti A n ṣọ ti akọsilẹ gbogbo nkan wa ninu rẹ)</span>, O si tun fẹ bibẹ rẹ ati dida a. "<br /> "Ọba ti ọla Rẹ ga- sọ pe <span class="c4">{Dájúdájú A ṣẹ̀dá gbogbo n̄ǹkan pẹ̀lú kádàrá 49}</span><span class="c5">[Surah Al-<span class="c6">Qamar:</span> 49]</span>.<span class="c6">"<br /> " Ipele mẹrin ni o ni:</span> "<br /> "Alakọkọ: Imọ Ọlọhun -ti ọla Rẹ ga-, ninu iyẹn ni imọ Rẹ to ti ṣaaju gbogbo nnkan, ṣíwájú ṣiṣẹlẹ awọn nnkan ati lẹyin ṣiṣẹlẹ rẹ.<span class="c6"> "<br /> "Ẹri ẹ ni:</span> Ọrọ Ọba ti ọla Rẹ ga-: " Dájúdájú Allāhu, ọ̀dọ̀ Rẹ̀ ni ìmọ̀ Àkókò náà wà. Ó ń sọ òjò kalẹ̀. Ó mọ ohun t’ó wà nínú àpòlùkẹ́. Ẹ̀mí kan kò sì mọ ohun tí ó máa ṣe níṣẹ́ ní ọ̀la. Ẹ̀mí kan kò sì mọ ilẹ̀ wo l’ó máa kú sí. Dájúdájú Allāhu ni Onímọ̀, Alámọ̀tán. 34 <span class="c5">[Suuratu Luqman: 34]</span>.<span class="c6"><br /> "Ẹlẹẹkeji:</span> Dajudaju Ọlọhun ti kọ yẹn sinu Laohul Mahfūdh <span class="c2">(ọpọn ti A n ṣọ ti akọsilẹ gbogbo nkan wa ninu rẹ)</span>,<span class="c6"> ati pe gbogbo nnkan to sẹlẹ ati èyí tí yoo ṣẹlẹ jẹ nnkan ti wọn ti kọ si ọdọ Rẹ sinu iwe "<br /> "Ẹri ẹ ni:</span> Ọrọ Ọba ti ọla Rẹ ga-: " Ọ̀dọ̀ Rẹ̀ sì ni àwọn kọ́kọ́rọ́ ìkọ̀kọ̀ wà. Kò sí ẹni t’ó nímọ̀ rẹ̀ àfi Òun. Ó nímọ̀ ohun tí ń bẹ nínú ilẹ̀ àti odò. Ewé kan kò sì níí já bọ́ àfi kí Ó nímọ̀ rẹ̀. Kò sì sí kóró èso kan nínú òkùnkùn <span class="c2">(inú)</span> ilẹ̀, kò sí ohun tútù tàbí gbígbẹ kan àfi kí ó wà nínú àkọsílẹ̀ t’ó yanjú. 59 <span class="c5">[Suuratul-<span class="c6">An’am:</span> 59]</span>.<span class="c6"><br /> "Ẹlẹẹkẹta:</span> Oun ni pe gbogbo nnkan n ṣẹlẹ pẹlu ifẹ Ọlọhun, nnkankan o nii ṣẹlẹ lati ọdọ Rẹ tabi lati ọdọ ẹda Rẹ afi pẹlu ifẹ Rẹ -Ọba ti ọla Rẹ ga-<span class="c6"> "<br /> "Ẹri ẹ ni:</span> Ọrọ Ọba ti ọla Rẹ ga-: " "{<span class="c2">(Ó wà)</span> fún ẹni tí ó bá fẹ́ nínú yín láti dúró déédé 28 Ẹ̀yin kò sì níí fẹ́ <span class="c2">(láti dúró déédé)</span> àyàfi tí Allāhu bá fẹ́, Olúwa gbogbo ẹ̀dá 29} "<span class="c5">[Suuratut Takwîr: 28]</span>"<br /> "Ẹlẹẹkẹrin: Nini igbagbọ pe gbogbo nnkan ti o n bẹ ẹda ni wọn ti Ọlọhun da wọn, ti O si da awọn paapaa wọn ati awọn iroyin wọn ati lilọ bibọ wọn, ati gbogbo nnkan ti o n bẹ ninu wọn.<span class="c6"> "<br /> "Ẹri ẹ ni:</span> Ọrọ Ọba ti ọla Rẹ ga-: " "<span class="c4">{Allāhu l’Ó sì dá ẹ̀yin àti n̄ǹkan tí ẹ̀ ń ṣe níṣẹ́ 96}</span> <span class="c5">[Surah As-<span class="c6">Sâffât:</span> 96]</span> </p>',
            ],
            15 => [
                'question' => '"Ibeere ẹlẹẹkẹrindinlogun: Ki ni alaye (itumọ) Al-Qur\'ān? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1300.mp3',
                'answer' => '<p> "Idahun- Ọrọ Ọlọhun -ti ọla Rẹ ga- ni, kii ṣe nnkan ti a da.<span class="c6"> "<br /> Ọba ti ọla Rẹ ga sọ pe:</span> <span class="c4">{Tí ẹnì kan nínú àwọn ọ̀sẹbọ bá wá ètò ààbò wá sọ́dọ̀ rẹ, ṣ’ètò ààbò fún un títí ó fi máa gbọ́ ọ̀rọ̀ Allāhu...}</span> <span class="c5">[Suuratu At-<span class="c6">Tawbah:</span> 6]</span>. </p>',
            ],
            16 => [
                'question' => 'Ibeere 17: Ki ni n jẹ Sunnah?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1330.mp3',
                'answer' => '<p> Idahun- Oun ni gbogbo ọrọ tabi iṣe tabi ifirinlẹ tabi iroyin ti dida tabi ti iwa ti n bẹ fun Anabi <span class="c2">(ki ikẹ ati ọla Ọlọhun maa ba a)</span>. </p>',
            ],
            17 => [
                'question' => 'Ibeere 18: Ki ni a n pe ni adadaalẹ? Ati pe ṣe a maa gba a?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1350.mp3',
                'answer' => '<p> Idahun- Gbogbo nkan ti awọn eeyan ba daalẹ sinu ẹsin, ti ko si si nigba aye Anabi - ki ikẹ ati ọla Ọlọhun maa ba a - ati awọn saabe rẹ.<br /> A o nii gba a, ati pe a maa da a pada ni.<br /> Fun ọrọ Anabi - ki ikẹ ati ọla maa ba a -<span class="c6"> pe:</span> Gbogbo adadaalẹ pata anu ni Abu Daud ni o gba a wa.<span class="c6"><br /> Apejuwe rẹ:</span> Alekun nibi ijọsin, gẹ́gẹ́ bíi ṣiṣe alekun fifọ ẹlẹẹkẹrin nibi aluwala, ati ṣiṣe ayẹyẹ ọjọ-ibi Anabi, ko wa lati ọdọ Anabi - ki ikẹ ati ọla Ọlọhun maa ba a - ati awọn saabe rẹ. </p>',
            ],
            18 => [
                'question' => 'Ibeere 19: Sọ nkan ti n jẹ adisọkan Al-Walā’a ati Al-Barā’u?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1410.mp3',
                'answer' => '<p> Idahun- Al-<span class="c6">Walā’u:</span> Oun ni nini ifẹ awọn onigbagbọ ododo ati ṣiṣe iranwọ fun wọn.<span class="c6"><br /> Ọba ti ọla Rẹ ga sọ pe:</span> <span class="c4">{Àwọn onígbàgbọ́ òdodo lọ́kùnrin àti àwọn onígbàgbọ́ òdodo lóbìnrin, apá kan wọn lọ̀rẹ́ apá kan...}</span>. <span class="c5">[Suuratu At-<span class="c6">Tawbah:</span> 71]</span>.<br /> Al-<span class="c6">Barāhu:</span> Oun ni ikorira awọn alaigbagbọ ati iba wọn ṣọta.<span class="c6"><br /> Ọba ti ọla Rẹ ga sọ pe:</span> Dájúdájú àwòkọ́ṣe rere ti wà fun yín ní ara <span class="c2">(Ànábì)</span> ’Ibrọ̄hīm àti àwọn t’ó wà pẹ̀lú rẹ̀.<span class="c6"> Nígbà tí wọ́n sọ fún ìjọ wọn pé:</span> "Dájúdájú àwa yọwọ́-yọsẹ̀ kúrò nínú ọ̀rọ̀ yín àti ohun tí ẹ̀ ń jọ́sìn fún lẹ́yìn Allāhu. A takò yín. Ọ̀tá àti ìkórira sì ti hàn láààrin wa títí láéláé àyàfi ìgbà tí ẹ bá tó gbàgbọ́ nínú Allāhu nìkan ṣoṣo. <span class="c5">[Suuratul-<span class="c6">Mumtahina:</span> 4]</span>. </p>',
            ],
            19 => [
                'question' => 'Ibeere 20: Njẹ Ọlọhun o gba nkan to yatọ si Isilaamu ni ẹsin?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1480.mp3',
                'answer' => '<p> Idahun- Ọlọhun o nii gba nkan ti o yatọ si Isilaamu.<span class="c6"><br /> Ọba ti ọla Rẹ ga sọ pe:</span> <span class="c4">{Ẹnikẹ́ni tí ó bá wá ẹ̀sìn kan ṣe yàtọ̀ sí ’Islām, A ò níí gbà á lọ́wọ́ rẹ̀. Ní Ọjọ́ Ìkẹ́yìn, ó sì máa wà nínú àwọn ẹni òfò 85}</span>. <span class="c5">[Suuratu Al-Imran 85]</span>" </p>',
            ],
            20 => [
                'question' => '"Ibeere ẹlẹẹkọkanlelogun: Aigbagbọ a maa jẹ pẹlu ọrọ ati ìṣẹ ati adisọkan, mu àpẹrẹ wa fun iyẹn? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1520.mp3',
                'answer' => '<p> "Idahun-<span class="c6"> Àpẹrẹ ọrọ:</span> Bibu Ọlọhun -mimọ ni fun Un- tabi Ojiṣẹ Rẹ -ki ikẹ Ọlọhun ati ọla Rẹ maa ba a-.<span class="c6">"<br /> "Àpẹrẹ iṣẹ:</span> Yiyẹpẹrẹ Kuraani tabi fifi ori kanlẹ fun ẹni ti o yatọ si Ọlọhun -ti ọla Rẹ ga-<span class="c6"> "<br /> "Àpẹrẹ adisọkan:</span> Didi adisọkan pe nnkankan n bẹ ti o lẹ́tọ̀ọ́ si ijọsin yatọ si Allahu -ti ọla Rẹ ga- tabi pe adẹda kan nbẹ pẹlu Allahu -ti ọla Rẹ ga-. " </p>',
            ],
            21 => [
                'question' => '"Ibeere ẹlẹẹkejilelogun: Ki ni ṣọbẹ-ṣelu ati awọn iran rẹ? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1570.mp3',
                'answer' => '<p> "Idahun- "<br /> "1- Sọbẹ-<span class="c6">ṣelu nla:</span> Oun ni fifi aigbagbọ pamọ ati ifi igbagbọ han. "<br /> "Yio maa mu ni kuro ninu Isilaamu, o wa ninu aigbagbọ nla.<span class="c6"> "<br /> Ọba ti ọla Rẹ ga sọ pe:</span> "<span class="c4">{Dájúdájú àwọn ṣọ̀be-ṣèlu mùsùlùmí yóò wà nínú àjà ìsàlẹ̀ pátápátá nínú Iná. O ò sì níí rí alárànṣe kan fún wọn 145}</span> "<span class="c5">[Suuratun Nisaa: 145]</span>"<br /> "2- Sọbẹ-ṣelu <span class="c2">(Oju eji)</span> kekere: "<br /> "Gẹgẹ bii: Irọ ati iyapa adehun ati ijanba afọkantan. "<br /> "Ko nii mu ni kuro ninu Isilaamu, o wa ninu awọn ẹṣẹ ati pe ẹni ti o n ṣe e maa lẹ́tọ̀ọ́ si iya. "<br /> "Ojiṣẹ Ọlọhun -ki ikẹ Ọlọhun ati ọla Rẹ maa ba a-<span class="c6"> sọ pe:</span> " Àmì ti a fi n da munafiki mọ mẹta ni: Ti o ba sọrọ yóò parọ, ti o ba ṣe àdéhùn yóò yapa, ti wọn ba gbára le e yóò jamba "Bukhari ati Muslim ni wọn gba a wa. " </p>',
            ],
            22 => [
                'question' => '"Ibeere ẹlẹẹkẹtalelogun: Ta ni opin awọn Anabi ati awọn Ojiṣẹ? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1680.mp3',
                'answer' => '<p> "Idahun- oun ni Muhammad <span class="c2">(ki ikẹ Ọlọhun ati ọla Rẹ maa ba a)</span>.<span class="c6"> "<br /> Ọba ti ọla Rẹ ga sọ pe:</span> "{<span class="c2">(Ànábì)</span> Muhammad kì í ṣe bàbá ẹnì kan kan nínú àwọn ọkùnrin yín, ṣùgbọ́n <span class="c2">(ó jẹ́)</span> Òjíṣẹ́ Allāhu àti òpin àwọn Ànábì...} " <span class="c5">[Suuratul-<span class="c6">Ahzaab:</span> 40]</span>. "- Ojiṣẹ Ọlọhun -ki ikẹ Ọlọhun ati ọla Rẹ maa ba a-<span class="c6"> sọ pe:</span> " <span class="c3">«Emi ni opin awọn Anabi, ko si Anabi kankan lẹyin mi»</span> " "Abu Daud ati Tirmidhi ati ẹni ti o yatọ si wọn ni wọ́n gba a wa. " </p>',
            ],
            23 => [
                'question' => '"Ibeere ẹlẹẹkẹrinlelogun: Ki ni iṣẹ-iyanu? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1730.mp3',
                'answer' => '<p> "Idahun- iṣẹ-<span class="c6">iyanu ni:</span> Gbogbo nnkan ti Ọlọhun fun awọn Anabi Rẹ ninu awọn nǹkan eemọ lati da lori ododo wọn,<span class="c6"> gẹgẹ bii:</span> "<br /> "Lila oṣupa si meji fun Anabi -ki ikẹ Ọlọhun ati ọla Rẹ maa ba a-. "<br /> "- Pinpin odo si meji fun Musa -ki ikẹ Ọlọhun maa ba a- ati titẹri Fir\'aun ati awọn ọmọ ogun rẹ. " </p>',
            ],
            24 => [
                'question' => '"Ibeere ẹlẹẹkarundinlọgbọn: Ta ni awọn sọhaba? Àti pe ṣe maa nífẹ̀ẹ́ wọn? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1780.mp3',
                'answer' => '<p> "Idahun-<span class="c6"> Sàábé ni:</span> Ẹni ti o ba pade Anabi -ki ikẹ Ọlọhun ati ọla Rẹ maa ba a- ti o gba a gbọ ti o si ku sori Isilaamu. "<br /> "- A maa nífẹ̀ẹ́ wọn, a si maa kọ iṣe wọn, awọn ni ẹni ti o dara julọ ti wọn si lọla julọ ninu awọn eeyan lẹyin awọn Anabi.<span class="c6"> "<br /> "Awọn ti wọn lọla julọ ninu wọn ni awọn arole mẹrẹẹrin:</span> "<br /> "Abu Bakr -ki Ọlọhun yọnu si i-."<br /> "Umar -ki Ọlọhun yọnu si i-.<br /> "Uthman -ki Ọlọhun yọnu si i-.<br /> "Aliy- ki Ọlọhun yọnu si i-. " </p>',
            ],
            25 => [
                'question' => '"Ibeere ẹlẹẹkẹrindinlọgbọn: Àwọn wo ni awọn iya awọn onigbagbọ? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1870.mp3',
                'answer' => '<p> "Idahun- awọn ni awọn iyawo Anabi -ki ikẹ Ọlọhun ati ọla Rẹ maa ba a-.<span class="c6"> "<br /> Ọba ti ọla Rẹ ga sọ pe:</span> "{Ànábì ní ẹ̀tọ́ sí àwọn onígbàgbọ́ òdodo ju ẹ̀mí ara wọn lọ <span class="c2">(nípa ìfẹ́ rẹ̀ àti ìdájọ́ rẹ̀)</span>. Àwọn aya rẹ̀ sì ni ìyá wọn} <span class="c5">[Suuratul-<span class="c6">Ahzaab:</span> 6]</span>. </p>',
            ],
            26 => [
                'question' => '"Ibeere ẹlẹẹkẹtadinlọgbọn: Ki ni iwọ awọn ara ile Anabi -ki ikẹ Ọlọhun ati ọla Rẹ maa ba a- ti o jẹ dandan fun wa?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1910.mp3',
                'answer' => '<p> "Idahun- A maa nífẹ̀ẹ́ wọn, a si maavmu wọn ni ọrẹ, a si maa korira ẹni ti o ba korira wọn, a o si nii kọja aala nipa wọn, awọn ni awọn iyawo rẹ ati awọn arọmọdọmọ rẹ, ati awọn ọmọ Hashim ati awọn ọmọ Mutollib ninu awọn onigbagbọ. " </p>',
            ],
            27 => [
                'question' => '"Ibeere ẹlẹẹkejidinlọgbọn: Ki ni ojuṣe wa si awọn adari alamọri awọn musulumi? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1940.mp3',
                'answer' => '<p> "Idahun-<span class="c6"> Ojuṣe wa ni:</span> Ṣíṣe apọnle wọn, ati gbigbọ ati titẹle wọn nibi nnkan to yatọ si yiyapa Ọlọhun, ki a si ma jáde le wọn lori, ki a si maa ṣe adura ati iṣiti fun wọn ni kọrọ." </p>',
            ],
            28 => [
                'question' => '"Ibeere ẹlẹẹkọkandinlọgbọn: Ki ni ile awọn onigbagbọ? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/1970.mp3',
                'answer' => '<p> "Idahun- alujanna <span class="c2">(ọgba idẹra)</span>" "<span class="c4">{Dájúdájú Allāhu yóò mú àwọn t’ó gbàgbọ́ ní òdodo, tí wọ́n sì ṣe àwọn iṣẹ́ rere wọ inú Ọgbà Ìdẹ̀ra tí àwọn odò ń ṣàn ní ìsàlẹ̀ rẹ̀...}</span> <span class="c5">[Suuratu Muhammad: 12]</span>. </p>',
            ],
            29 => [
                'question' => 'Nibo ni ile awọn alaigbagbọ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2000.mp3',
                'answer' => '<p> Ina ni,<span class="c6"> Ọlọhun ti O ga sọ pe:</span> nítorí náà ẹ ṣọ́ra fún Iná, èyí tí ìkoná rẹ̀ jẹ́ àwọn ènìyàn àti òkúta tí Wọ́n pa lésè sílẹ̀ de àwọn aláìgbàgbọ́. 24 <span class="c5">[Suuratul-<span class="c6">Baqarah:</span> 24]</span>. </p>',
            ],
            30 => [
                'question' => 'Ki ni wọn n pe ni ibẹru? Ki ni wọn n pe ni agbiyele? Ki si ni ẹri?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2020.mp3',
                'answer' => '<p> Ibẹru: Oun ni bibẹru Ọlọhun ati iya Rẹ.<span class="c6"><br /> Ṣíṣe agbiyele:</span> Oun ni ṣiṣe agbiyele ẹsan lọdọ Ọlọhun ati aforijin Rẹ ati ikẹ Rẹ.<span class="c6"><br /> Ẹri:</span> Ọ̀rọ̀ Ọlọhun Ọba ti O ga: Àwọn wọ̀nyẹn tí wọ́n ń pè <span class="c2">(lẹ́yìn Rẹ̀)</span> ń wá àtẹ̀gùn sọ́dọ̀ Olúwa wọn ni! - Èwo nínú wọn l’ó súnmọ́ <span class="c2">(Allāhu)</span> jùlọ <span class="c2">(báyìí)</span>? – Àwọn náà ń retí ìkẹ́ Allāhu, wọ́n sì ń páyà ìyà Rẹ̀. Dájúdájú ìyà Olúwa rẹ jẹ́ ohun tí wọ́n gbọ́dọ̀ ṣọ́ra fún. 57 <span class="c5">[Suuratul-<span class="c6">Israa:</span> 57]</span>.<span class="c6"> Allah tun sọ pe:</span> Fún àwọn ẹrúsìn Mi ní ìró pé dájúdájú Èmi ni Aláforíjìn, Àṣàkẹ́-ọ̀run. 49 Àti pé dájúdájú ìyà Mi ni ìyà ẹlẹ́ta-eléro 50 <span class="c5">[Suuratul-<span class="c6">Hijr:</span> 49, 50]</span>. </p>',
            ],
            31 => [
                'question' => 'Ibeere ẹlẹẹkejilelọgbọn: Dárúkọ apa kan awọn orukọ ati awọn iroyin Ọlọhun ti O ga julọ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2070.mp3',
                'answer' => '<p> Idahun- Ọlọhun, Ọba Olutọju, Onikẹẹ, Olugbọ, Oluriran, Onimimọ, Olupese, Alaaye, Ọba ti O tobi.... ati bẹẹ bẹẹ lọ ninu awọn orukọ ti o dara ati awọn iroyin ti o ga. </p>',
            ],
            32 => [
                'question' => 'Ibeere ẹlẹẹkẹtalelọgbọn: Ṣe alaye awọn orukọ yii?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2100.mp3',
                'answer' => '<p> Idahun-<span class="c6"> ALLAAHU:</span> Ìtumọ̀ rẹ ni pe Ọba ti a n sin ni ododo, Oun nikan ni O da wa ti ko si ni akẹgbẹ.<br /> AR-<span class="c6">ROBB:</span> Ìtumọ̀ rẹ ni Oludẹdaa, Olukapa, Olupese, Oluṣeto ni Oun nikan ṣoṣo, mimọ fun Un.<br /> AS-<span class="c6">SAMIIHU:</span> Ẹni tí igbọran Rẹ kari gbogbo nnkan, O si n gbọ gbogbo ohun tòun ti bi o ṣe pe oríṣiríṣi.<br /> AL-<span class="c6">BASIIR:</span> Ẹni tí O ṣe pe O n ri gbogbo nnkan, O si n ri gbogbo nnkan boya o kere ni tabi o tobi.<br /> AL-<span class="c6">HALIIM:</span> Oun ni imọ Rẹ kari gbogbo nnkan lori ohun ti o ti lọ tabi ti n ṣẹlẹ lọwọ tabi ti yoo pada ṣẹlẹ lọjọ iwaju.<br /> AR-<span class="c6">RAHMAAN:</span> Ẹni tí O ṣe pe ikẹ Rẹ kari gbogbo ẹda Rẹ ati gbogbo nǹkan ti n ṣẹmi, gbogbo ẹrusin ati ẹda ni n bẹ labẹ ikẹ Rẹ.<br /> AR-<span class="c6">ROZZAAQ:</span> Ọba ti ijẹẹmu gbogbo ẹda ninu eeyan, alijannu ati gbogbo ẹranko n bẹ ni ọwọ Rẹ.<br /> AL-<span class="c6">HAYY:</span> Alaaye ti ko nii ku, gbogbo ẹda ni yoo si ku.<span class="c6"><br /> "Ọba Ńlá:</span> Ẹni ti O jẹ pe gbogbo pipe nbẹ fun Un ati gbogbo titobi nibi awọn orukọ Rẹ ati awọn iroyin Rẹ ati awọn iṣẹ Rẹ." </p>',
            ],
            33 => [
                'question' => '"Ibeere ẹlẹẹkẹrinlelọgbọn: Ki ni ojuṣe wa si awọn onimimọ musulumi? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2210.mp3',
                'answer' => '<p> "Idahun- a maa nífẹ̀ẹ́ wọn, a maa ṣẹri pada si ọdọ wọn nipa awọn àlámọ̀rí ati awọn iṣẹlẹ ọtun ti sharia, ki a ma darukọ wọn afi pẹlu daada, ẹnikẹ́ni ti o ba darukọ wọn pẹlu nnkan miiran to yatọ si iyẹn ninu aburu; ko si ni oju-ọna.<span class="c6"> "<br /> Ọba ti ọla Rẹ ga sọ pe:</span> <span class="c4">{Allāhu yóò ṣàgbéga àwọn ipò fún àwọn t’ó gbàgbọ́ ní òdodo àti àwọn tí A fún ní ìmọ̀ nínú yín. Allāhu sì ni Alámọ̀tán nípa ohun tí ẹ̀ ń ṣe níṣẹ́ 11}</span> <span class="c5">[Suuratul-Mujadila 11]</span>. </p>',
            ],
            34 => [
                'question' => '"Ibeere ẹlẹẹkarundinlogoji: Ta ni awọn ọrẹ ayo Ọlọhun -ti ọla Rẹ ga-? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2240.mp3',
                'answer' => '<p> "Idahun- awọn ni onigbagbọ olubẹru.<span class="c6"> "<br /> Ọba ti ọla Rẹ ga sọ pe:</span> "{Gbọ́, dájúdájú àwọn ọ̀rẹ́ Allāhu, kò níí sí ìbẹ̀rù <span class="c2">(ìyà ọ̀run)</span> fún wọn, wọn kò sì níí banújẹ́ <span class="c2">(lórí oore ayé)</span> 62 <span class="c2">(Àwọn ni)</span> àwọn t’ó gbàgbọ́ lódodo, wọ́n sì máa ń bẹ̀rù <span class="c2">(Allāhu)</span> 63} " <span class="c5">[Suuratu Yunus: 62, 63]</span>. </p>',
            ],
            35 => [
                'question' => '"Ibeere ẹlẹẹkẹrindinlogoji: Ǹjẹ́ igbagbọ jẹ ọrọ ati iṣẹ bí? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2280.mp3',
                'answer' => '<p> "Idahun- igbagbọ jẹ ọrọ ati iṣẹ ati adisọkan. " </p>',
            ],
            36 => [
                'question' => '"Ibeere ẹlẹẹkẹtadinlogoji: Ǹjẹ́ igbagbọ a maa lekun a si tun maa dínkù? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2310.mp3',
                'answer' => '<p> "Idahun- igbagbọ maa n lekun pẹlu itẹle a si maa dínkù pẹlu ẹṣẹ.<span class="c6"> "<br /> Ọba ti ọla Rẹ ga sọ pe:</span> "{Àwọn onígbàgbọ́ òdodo ni àwọn t’ó jẹ́ pé nígbà tí wọ́n bá fi <span class="c2">(ìyà)</span> Allāhu ṣe ìrántí <span class="c2">(fún wọn)</span>, ọkàn wọn yóò wárìrì, nígbà tí wọ́n bá sì ké àwọn āyah Rẹ̀ fún wọn, wọn yóò lékún ní ìgbàgbọ́ òdodo. Olúwa wọn sì ni wọ́n ń gbáralé 2} " "<span class="c5">[Surah Al-<span class="c6">Anfâl:</span> 2]</span>" </p>',
            ],
            37 => [
                'question' => '"Ibeere ẹlẹẹkejidinlogoji: Ki ni dáadáa? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2350.mp3',
                'answer' => '<p> "Idahun- ki o maa jọsin fun Ọlọhun gẹgẹ bii pe o n ri I, ti o o ba ri I; dajudaju Oun n ri ẹ. " </p>',
            ],
            38 => [
                'question' => '"Ibeere ẹlẹẹkọkandinlogoji: Ìgbà wo ni awọn iṣẹ yio di itẹwọgba lọdọ Ọlọhun -mimọ ni fun Un-?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2370.mp3',
                'answer' => '<p> "Idahun-<span class="c6"> pẹlu majẹmu meji:</span> "<br /> "1- ti o ba mọ́ kangá nitori ojú rere Ọlọhun -ti ọla Rẹ ga- "<br /> "2- Ti o ba jẹ lori oju-ọna Anabi -ki ikẹ Ọlọhun ati ọla Rẹ maa ba a-. " </p>',
            ],
            39 => [
                'question' => '"Ibeere ogoji: Ki ni igbarale Ọlọhun -ti ọla Rẹ ga- "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2420.mp3',
                'answer' => '<p> "Ibeere ogoji: Ki ni igbarale Ọlọhun -ti ọla Rẹ ga-<span class="c6"> "<br /> Ọba ti ọla Rẹ ga sọ pe:</span> "<span class="c4">{Àti pé ẹnikẹ́ni tí ó bá gbẹ́kẹ̀lé Allāhu, Ó máa tó o }</span> "<span class="c5">[Surah At-<span class="c6">Talâq:</span> 3]</span>"<br /> "<span class="c4">{Hasbuhu}</span> : tabi O maa to fun un. " </p>',
            ],
            40 => [
                'question' => '"Ibeere ẹlẹẹkọkanlelogoji: Ki ni nǹkan to n jẹ ojúṣe pipaṣe dáadáa ati kíkọ ohun buruku? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2470.mp3',
                'answer' => '<p> "Idahun-<span class="c6"> AL’MAHRUUF:</span> Oun ni pipaṣe lati ṣe gbogbo itẹle Ọlọhun- Alagbara ti O gbọnngbọn-, AL-<span class="c6">MUNKAR:</span> Oun ni kikọ kuro nibi gbogbo ṣiṣẹ Ọlọhun Alagbara ti O gbọnngbọn.<span class="c6"><br /> Ọba ti ọla Rẹ ga sọ pe:</span> "<span class="c4">{Ẹ jẹ́ ìjọ t’ó lóore jùlọ, tí A gbé dìde fún àwọn ènìyàn; ẹ̀ ń pàṣẹ ohun rere, ẹ̀ ń kọ ohun burúkú, ẹ sì gbàgbọ́ nínú Allāhu }</span> "<span class="c5">[Surah Âl-<span class="c6">`Imrân:</span> 110]</span>" </p>',
            ],
            41 => [
                'question' => '"Ibeere ẹlẹẹkejilelogoji: Àwọn wo ni Ahlus Sunna Wal Jamaa’ah?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2510.mp3',
                'answer' => '<p> "Idahun- awọn ni awọn to wa lori nnkan ti Anabi- ki ikẹ Ọlọhun ati ọla Rẹ maa ba a- wa lori ẹ ati awọn sàábé rẹ nibi ọrọ ati iṣẹ ati adisọkan.<span class="c6"> "<br /> "Wọn sọ wọn ni oni sunnah:</span> Torí itẹle wọn ti wọn n tẹle oju-ọna Anabi- ki ikẹ Ọlọhun ati ọla Rẹ maa ba a- ati gbigbe adadaalẹ ju silẹ.<span class="c6"> "<br /> "Wal Jamaa\'ah:</span> Torí pe wọn kojọ lori ododo ti wọn ko si yapa nibẹ. </p>',
            ],
        ],
        2 => [
            0 => [
                'question' => '"Ibeere kini: Ṣàlàyé imọra?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2580.mp3',
                'answer' => '<p> "Imọra: Oun ni gbigbe ẹgbin ti a ko le fi ojú ri,<span class="c6"> ati ẹgbin ti a le fi ojú ri"<br /> "Mimọ ẹgbin ti a le fi ojú ri:</span> Oun ni ki musulumi mu nnkan ti o wa ni ara rẹ ninu ẹgbin kuro, tabi to wa ni aṣọ rẹ, tabi to wa lori ilẹ ati aye ti o fẹ kirun nibẹ.<span class="c6"> "<br /> "Mimọ ẹgbin ti a ko le fi ojú ri:</span> Oun maa jẹ pẹlu aluwala tabi iwẹ, pẹlu omi ti o mọ tabi imọra oni erupẹ fun ẹni ti ko ri omi, tabi ti lilo ẹ ni i lara. " </p>',
            ],
            1 => [
                'question' => '"Ibeere keji: Báwo ni a ṣe maa mọ nnkan ti ẹgbin ba wa lara ẹ? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2630.mp3',
                'answer' => '<p> "Idahun- pẹlu fifọ ọ pẹlu omi titi o fi maa mọ "<br /> "-Sugbọn nnkan ti aja ba ti ẹnu bọ; a maa fọ ọ ni ẹẹmeje ti àkọ́kọ́ maa jẹ pẹlu erupẹ. " </p>',
            ],
            2 => [
                'question' => '"Ibeere kẹta: Ki ni ọla ti o wa fun aluwala? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2660.mp3',
                'answer' => '<p> "Anabi -ki ikẹ ati ọla maa ba a-<span class="c6"> sọ pe:</span> <span class="c1">“Ti musulumi ba ṣe aluwala, tabi olugbagbọ, ti o wa fọ oju rẹ; gbogbo ẹṣẹ ti o fi oju rẹ wo a jade pọ mọ omi, tabi pẹlu ekikan omi to kẹyin, ti o ba fọ ọwọ rẹ mejeeji; gbogbo ẹṣẹ ti o fi ọwọ rẹ mejeeji gbamu a jade pọ mọ omi, tabi pẹlu ekikan omi to kẹyin, ti o ba fọ ẹsẹ rẹ mejeeji; gbogbo ẹṣẹ ti o fi ẹsẹ rẹ mejeeji rin lọ sibẹ a jade pọ mọ omi, tabi pẹlu ekikan omi to kẹyin, titi yoo fi jade ni ẹni ti o mọ kuro nibi awọn ẹṣẹ”</span> Muslim ni o gba a wa. </p>',
            ],
            3 => [
                'question' => '"Ibeere kẹrin: Báwo ni waa ṣe ṣe aluwala? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2690.mp3',
                'answer' => '<p> "Idahun- fifọ ọwọ lẹẹmẹta "<br /> "Waa fi omi yọ ẹnu, waa si fa omi si imu, waa si fin omi si ita lẹẹmẹta."<br /> AL-<span class="c6">MADMADỌ ni:</span> Fífi omi si ẹnu, ati titu u sita"<br /> AL-<span class="c6">ISTINSHAAQ:</span> Fífa omi pẹlu atẹgun lọ si inu imu pẹlu ọwọ ọtun rẹ."<br /> AL-<span class="c6">ISTINTHAAR:</span> Oun ni mimu omi jade lati inu imu lẹyin fifa a simu pẹlu ọwọ osi.<br /> "Lẹyin naa ni fifọ oju lẹẹmẹta. "<br /> "Lẹyin naa ni fifọ ọwọ mejeeji titi de igunpa mejeeji lẹẹmẹta"<br /> "Lẹyin naa ni pipa ori lọ si iwaju pẹlu ọwọ rẹ mejeeji ati lọ si ẹyin, waa si pa eti mejeeji."<br /> "Lẹyin naa waa fọ ẹsẹ rẹ mejeeji titi de kokosẹ mejeeji lẹẹmẹta "<br /> "Eleyii ni eyi ti o pe julọ, iyẹn si fi ẹsẹ rinlẹ lati ọdọ Anabi -ki ikẹ Ọlọhun ati ọla Rẹ maa ba a- ninu awọn hadisi ninu Bukhari ati Muslim, ti awọn mejeeji gba a wa lati ọdọ Uthman ati Abdulahi Bn Zaid ati awọn to yatọ si awọn mejeeji, " O tun fi ẹsẹ rinlẹ bakannaa lati ọdọ rẹ ninu Bukhari ati ẹni ti o yatọ si i pe o ṣe aluwala ni ẹyọ kọọkan,<span class="c6"> ati pe o ṣe e ni ẹẹmeji meji pẹlu itumọ pe:</span> O n fọ gbogbo oríkèé kọọkan ninu awọn oríkèé aluwala lẹẹkan, tabi lẹẹmeji. " </p>',
            ],
            4 => [
                'question' => '"Ibeere karun-un: Ki ni awọn ọranyan aluwala, ati onka wọn? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2810.mp3',
                'answer' => '<p> "Idahun- Oun ni eyi ti aluwala musulumi ko nii ni alaafia ti o ba gbe ẹyọkan ju silẹ ninu ẹ. "<br /> "1- Fifọ oju ti yiyọ ẹnu ati fifa omi si imu n bẹ ninu ẹ. "<br /> "2- Fifọ ọwọ mejeeji titi de igunpa mejeeji. "<br /> "3- Pipa ori ti eti mejeeji n bẹ ninu ẹ<br /> "4- Fifọ ẹsẹ mejeeji titi de kokosẹ mejeeji. "<br /> "5- Tito tẹle ara wọn laarin awọn oríkèé, pẹlu pe ki o fọ oju, lẹyin naa ọwọ mejeeji, lẹyin naa pipa ori, lẹyin naa fifọ ẹsẹ mejeeji. "<br /> "6-<span class="c6"> Isopọ:</span> Oun ni ki aluwala waye ni asiko to sopọ mọ ara wọn, laisi alagata laarin asiko titi awọn oríkèé o fi gbẹ fun omi"<br /> "- Gẹgẹ bii ki o ṣe idaji aluwala, ki o wa pari ẹ ni asiko miiran, aluwala rẹ o ni alaafia. " </p>',
            ],
            5 => [
                'question' => '"Ibeere kẹfa: Ki ni awọn sunnah aluwala, ati onka wọn? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/2910.mp3',
                'answer' => '<p> "Idahun- awọn sunnah aluwala” ni eyi to jẹ pe ti o ba ṣe e, alekun ninu ẹsan o maa bẹ fun un, ti o ba gbe e ju silẹ; ko si ẹṣẹ fun un, aluwala rẹ ni alaafia. "<br /> 1-<span class="c6"> Didarukọ Ọlọhun:</span> mo bẹrẹ pẹlu orukọ Ọlọhun.<br /> 2- Rirun pako<br /> 3- Fifọ ọwọ mejeeji.<br /> 4- Fifi ọwọ ya awọn ọmọnika<br /> 5- Fifọ oríkèé ara ẹlẹẹkeji ati ẹlẹẹkẹta.<br /> 6- Bibẹrẹ pẹlu ọtun<br /> 7-<span class="c6"> Ṣíṣe iranti lẹyin aluwala:</span> Ash’hadu an laa ilaaha illal Loohu, wahdahuu laa shariika lahuu, wa ash’hadu anna Muhammadan abduhuu wa rosuuluhuu<br /> 8- Kiki irun rakah meji lẹyin rẹ. </p>',
            ],
            6 => [
                'question' => 'Ibeere keje: Ki ni awọn onka ohun ti o maa n ba aluwala jẹ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3020.mp3',
                'answer' => '<p> Idahun- Ohun ti n jade lati oju ara mejeeji; oju ara ati oju idi bii itọ abi igbẹ abi iso.<br /> Oorun ati yiya were ati hihunrira<br /> Jijẹ ẹran rakunmi.<br /> Gbigba oju-ara abi idi mu pẹlu ọwọ laisi gaga kankan. </p>',
            ],
            7 => [
                'question' => 'Ki ni Tayammum?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3080.mp3',
                'answer' => '<p> Idahun-<span class="c6"> Tayammum:</span> Oun ni lilo erupẹ abi nnkan miran ni ori ilẹ nigba ti ko ba si omi abi ti ko ba rọrùn lati lo o. </p>',
            ],
            8 => [
                'question' => 'Ibeere kẹsàn-án: Bawo ni waa ṣe ṣe Tayammum?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3110.mp3',
                'answer' => '<p> Idahun- Fifi oju ọwọ lu ilẹ ni lilu ẹẹkan ṣoṣo, ati pipa oju ati ẹyin ọwọ méjèèjì ni ẹẹkan ṣoṣo. </p>',
            ],
            9 => [
                'question' => 'Ìbéèrè kẹwaa: Ki ni awọn nnkan ti o le ba Tayammum jẹ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3140.mp3',
                'answer' => '<p> Idahun- Gbogbo ohun ti o ba ti le ba aluwala jẹ.<br /> Ti wọn ba ri omi </p>',
            ],
            10 => [
                'question' => 'Ibeere kọkànlá: Ki ni wọn n pe ni khuffu ati ibọsẹ? Njẹ yoo pa awọn mejeeji?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3180.mp3',
                'answer' => '<p> Idahun-<span class="c6"> Khuffu mejeeji:</span> Ni ohun ti wọn ba n wọ si ẹsẹ ti wọn ṣe latara awọ.<span class="c6"><br /> Ibọsẹ:</span> Ohun ti wọn ba n wọ si ẹsẹ ti kii ṣe latara awọ.<br /> Wọn ṣe e ni ofin lati pa awọn mejeeji ni ifirọpo fifọ ẹsẹ mejeeji. </p>',
            ],
            11 => [
                'question' => 'Ibeere 12 - Darukọ ọgbọn ti n bẹ nibi pipa khuffi (abọsẹsẹ alawọ) mejeeji?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3230.mp3',
                'answer' => '<p> Idahun - ṣiṣe idẹkun ati ṣiṣe ẹdẹ fun awọn ẹrusin, agaga julọ ni awọn asiko otutu ati ọyẹ ati irin-ajo, l\'eyiti o ṣe wipe bibọ nkan ti o wa ni ẹsẹ mejeeji maa nira. </p>',
            ],
            12 => [
                'question' => 'Ibeere 13 – Kí ni awọn majẹmu nini alaafia pipa khuffi (abọsẹsẹ alawọ) mejeeji?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3260.mp3',
                'answer' => '<p> Idahun - 1 - ki o wọ abọsẹsẹ alawọ mejeeji lori imọra, itumọ rẹ ni lẹyin aluwala.<br /> 2- Ki abọsẹsẹ alawọ o jẹ nǹkan ti o mọ; nitori naa ko lẹ́tọ̀ọ́ ki o pa a lori ẹgbin.<br /> 3- Ki abọsẹsẹ alawọ jẹ nkan ti o bo aaye ti fifọ rẹ jẹ dandan nibi aluwala.<br /> 4- Ki pipa naa o jẹ laarin asiko ti a ti fi gbedeke sí, fun ẹniti o wa ni ile ti kii ṣe arinrin-<span class="c6">ajo:</span> Ọjọ kan ati oru kan, fun arìnrìn-<span class="c6">àjò:</span> Ọjọ mẹta pẹlu àwọn oru wọn. </p>',
            ],
            13 => [
                'question' => 'Ibeere 14- Ki ni iroyin (alaye) pipa abọsẹsẹ alawọ mejeeji?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3320.mp3',
                'answer' => '<p> Nípa iroyin <span class="c2">(alaye)</span> pipa abọsẹsẹ alawọ mejeeji oun naa ni: Ki o gbe awọn ọmọnika ọwọ rẹ mejeeji eleyii ti o ti tutu rẹ pẹlu omi lori awọn ọmọnika ẹsẹ rẹ mejeeji, lẹyin naa ki o wọ́ mejeeji lọ sibi ojúgun rẹ, yio pa ẹsẹ ọtun pẹlu ọwọ ọtún, yio si pa ẹsẹ osi pẹlu ọwọ osi, yio si ya awọn ọmọnika rẹ nígbà tí o ba n pa a, ko si nii paara rẹ. </p>',
            ],
            14 => [
                'question' => 'Ibeere 15- Ki ni nkan ti o maa n ba pipa abọsẹsẹ alawọ mejeeji jẹ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3350.mp3',
                'answer' => '<p> Idahun-1- Pipari asiko pipa, nitori naa pipa abọsẹsẹ alawọ mejeeji o lẹ́tọ̀ọ́ lẹyin pipari asiko pipa tí a ti paala rẹ ninu sheriah <span class="c2">(ofin ẹsin)</span>, ọjọ kan ati oru kan fun ẹniti n bẹ nile, ati ọjọ mẹta pẹlu awọn oru wọn fun arìnrìn-àjò.<br /> 2- Bibọ abọsẹsẹ alawọ mejeeji, ti ọmọnìyàn ba ti le bọ́ abọsẹsẹ alawọ mejeeji tabi ọkan ninu wọn lẹyin ti o ti pa a, pipa mejeeji ti bajẹ. </p>',
            ],
            15 => [
                'question' => 'Ibeere 16- Itumọ Irun?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3390.mp3',
                'answer' => '<p> Idahun-<span class="c6"> Irun:</span> Oun ni ṣiṣe ijọsin fun Ọlọhun pẹlu awọn ọrọ ati awọn iṣẹ ti wọn sa l\'ẹsa, ti o bẹrẹ pẹlu ki kabara <span class="c2">(gbigbe titobi fun Ọlọhun)</span>, ti o si pari pẹlu sí salamọ. </p>',
            ],
            16 => [
                'question' => 'Ibeere 17: Idajọ Irun?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3420.mp3',
                'answer' => '<p> Idahun- Irun ọranyan lo jẹ lori gbogbo Musulumi.<span class="c6"><br /> Ọba ti ọla Rẹ ga sọ pe:</span> ﴾Dájúdájú ìrun kíkí jẹ́ ọ̀ran-anyàn tí A fi àkókò sí fún àwọn onígbàgbọ́ òdodo 103﴿ <span class="c5">[Sūratun Nisā‘i: 103]</span>. </p>',
            ],
            17 => [
                'question' => 'Ibeere 18: Ki ni idajọ gbigbe Irun ju silẹ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3460.mp3',
                'answer' => '<p> Idahun- Gbigbe Irun ju silẹ iṣe keferi ni, Anabi - kí ikẹ ati ọla maa ba a -<span class="c6"> sọ pe:</span> «Adehun ti n bẹ laarin wa ati laarin wọn <span class="c2">(awọn keferi)</span> ni Irun, ẹniti o ba wa gbe Irun ju silẹ ti di keferi». Ahmad ati Tirimidhi ati awọn mii yatọ si awọn mejeeji ni wọ́n gba a wa. </p>',
            ],
            18 => [
                'question' => 'Ibeere 19- Irun mélòó lo jẹ dandan lori Musulumi ni ojumọ (aarọ ati alẹ)? Melo si ni awọn onka Irun kọọkan?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3500.mp3',
                'answer' => '<p> Idahun- Irun márùn-ún ni ni ojumọ <span class="c2">(aarọ ati alẹ)</span>, Irun Al-<span class="c6">fajri:</span> Rakah meji,<span class="c6"> Irun Dhuri:</span> Rakah mẹẹrin,<span class="c6"> Irun Asri:</span> Rakah mẹẹrin,<span class="c6"> Irun Magrib:</span> Rakah mẹta,<span class="c6"> Irun Ishai:</span> Rakah mẹẹrin. </p>',
            ],
            19 => [
                'question' => 'Ibeere 20: Onka awọn majẹmu Irun?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3530.mp3',
                'answer' => '<p> Idahun- 1- Isilaamu; ko <span class="c2">(Irun)</span> si nii ni alaafia lati ọdọ keferi.<br /> 2-<span class="c6"> Laakaye:</span> ko si nii ni alaafia lati ọdọ weere.<br /> 3- Isẹ adayanri; ko si nii ni alaafia lati ọdọ ọmọde ti ko i tii le ṣe adayanri.<br /> 4- Aniyan.<br /> 5- Wíwọlé asiko.<br /> 6- Imọra nibi mímú ẹgbin aifojuri kúrò.<br /> 7- Imọra kuro nibi idọti <span class="c2">(ẹgbin afojuri)</span>.<br /> 8- Bibo ihoho.<br /> 9- Didaju kọ Qiblah. </p>',
            ],
            20 => [
                'question' => 'Ibeere 21: Onka awọn origun Irun?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3640.mp3',
                'answer' => '<p> Idahun- Mẹrinla ni i,<span class="c6"> gẹ́gẹ́ bí o ṣe n bọ̀ yii:</span><br /> Akọkọ rẹ: Diduro níbi Irun ọranyan fun ẹniti o ni ikapa.<br /> Kabara imura,<span class="c6"> oun naa ni:</span> <span class="c1">“Allāhu Akbar”</span>.<br /> Kika Fātiah.<br /> Itẹkọkọ, yio wàá na ẹyin rẹ tọọ ti yio si gbe ori rẹ si deedee rẹ.<br /> Gbigbe ori kuro nibẹ <span class="c2">(Itẹkọkọ)</span>.<br /> Diduro dede.<br /> Iforikanlẹ, gbigbe iwaju ori rẹ, ati imu rẹ, ati atẹlẹwọ rẹ mejeeji, ati orunkun rẹ mejeeji, ati awọn ọmọnika ẹsẹ rẹ mejeeji le aaye iforikanlẹ rẹ daadaa.<br /> Gbigbe ori kúrò ni iforikanlẹ.<br /> Ìjókòó laarin iforikanlẹ mejeeji.<span class="c6"><br /> Sunnah ni:</span> Ki o jókòó ni ẹniti yio tẹ ẹsẹ osi rẹ silẹ, ti yio si na ẹsẹ ọtun rẹ duro, ti yio si da a kọ Qibla.<br /> Ifarabalẹ, oun naa ni isinmi ara nibi gbogbo orígun ti o jẹ iṣẹ ṣiṣe.<br /> Ataaya Igbẹyin.<br /> Jíjókòó fun un <span class="c2">(Ataaya igbẹyin)</span>.<br /> Salamọ Mejeeji,<span class="c6"> oun naa ni ki o sọ ni ẹẹmeji pe:</span> <span class="c1">“As salāmu alaykum wa rahmotulloohi wa barakaatuhu”</span>.<br /> Tito awọn orígun tẹle ara wọn- gẹ́gẹ́ bí a ti wi - ti o ba wa fi orikanlẹ ṣíwájú ki o to rukuu lẹniti o mọ̀ọ́mọ̀ ṣe e; o <span class="c2">(Irun)</span> ti bajẹ, ti o ba wa jẹ ti igbagbe; o jẹ dandan fun un pipada lati lọ rukuu, lẹyin naa ki o wa fi ori kanlẹ. </p>',
            ],
            21 => [
                'question' => 'Ibeere 22: Darukọ awọn ọranyan Irun?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3820.mp3',
                'answer' => '<p> Idahun- Awọn ọranyan Irun, mẹjọ ni,<span class="c6"> gẹ́gẹ́ bí o ṣe n bọ yii:</span><br /> 1- Awọn kabara yàtọ̀ si kabara imura.<br /> 2-<span class="c6"> Gbólóhùn:</span> <span class="c3">«Sami‘a Allāhu liman hamidahu»</span> fun imaamu ati ẹniti n da Irun ki.<br /> 3-<span class="c6"> Gbolohun:</span> <span class="c3">«Robbanā wa lakal hamdu»</span>.<br /> 4-<span class="c6"> Gbolohun:</span> <span class="c3">«Subhāna robbiyal ‘adhīm»</span> ni ẹẹkan ni rukuu .<br /> 5-<span class="c6"> Gbolohun:</span> <span class="c3">«Subhāna robbiyal ’a‘lā»</span> ni ẹẹkan ni iforikanlẹ.<br /> 6-<span class="c6"> Gbolohun:</span> <span class="c3">«Robbi igfir lī»</span> laarin iforikanlẹ mejeeji.<br /> 7- Ataaya àkọ́kọ́.<br /> 8- Jíjókòó fun ataaya àkọ́kọ́. </p>',
            ],
            22 => [
                'question' => 'Ibeere 23: Ki ni awọn sunnah (aṣegbọrẹ) Irun?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/3930.mp3',
                'answer' => '<p> Idahun- Mọkanla ni i,<span class="c6"> gẹ́gẹ́ bí o ti ṣe n bọ yii:</span><br /> 1-<span class="c6"> Gbolohun rẹ lẹyin kabara imura pe:</span> <span class="c3">«Subhānaka allāhummo wa bi hamdika, wa tabāraka ismuka,wa ta‘ālā jadduka, wa lā ilāha gayruka»</span> wọn sì tun maa n pe e ni adua ìṣírun.<br /> 2- Wiwa iṣọra <span class="c2">(Sisọ gbólóhùn "a‘udhu billāhi minash Shaytānir rajīm")</span>.<br /> 3- Ṣiṣe bismillahi.<br /> 4-<span class="c6"> Gbolohun:</span> Āmīn.<br /> 5- Kika Sūrah lẹyin fātiha.<br /> 6- Gbigbe ohun soke pẹlu kika fun Imāmu.<br /> 7-<span class="c6"> Sisọ lẹyin gbolohun "Robbanā wa lakal hamdu" pe:</span> <span class="c3">«Mil’as Samāwāti, wa mil’al ardi, wa mil’a mā shita min shay\'in ba‘d»</span>.<br /> 8- Ohun ti o ju ẹyọkan lọ nibi ṣiṣe afọmọ ni rukuu,<span class="c6"> ìyẹn tumọ si:</span> Ṣiṣe afọmọ ẹlẹẹkeji ati ẹlẹẹkẹta, ati ohun ti o ba ju ìyẹn lọ.<br /> 9- Ohun ti o ju ẹyọkan lọ nibi ṣiṣe afọmọ iforikanlẹ.<br /> 10-<span class="c6"> Ohun ti o ba ju ẹyọkan lọ nibi gbolohun rẹ laarin iforikanlẹ mejeeji pe:</span> "Robbi igfir lī".<br /> 11- Ṣíṣe asalaatu fun awọn ara-ile rẹ ki alaafia maa ba wọn, ati titọrọ alubarika fun un ati fun wọn, ati ṣiṣe adua lẹyin rẹ.<span class="c6"><br /> "Ẹlẹẹkẹrin:</span> Sunna nibi awọn iṣẹ,<span class="c6"> ati pe wọn n pe e ni awọn iṣesi:</span> "<br /> "1- Gbigbe ọwọ mejeeji soke pẹlu ki kabara iwọ inu irun. "<br /> "2- Ati nibi rukuu. "<br /> "3- Ati nibi gbígbé orí kuro nibẹ. "<br /> "4- Ati gbígbé mejeeji sílẹ̀ lẹyin iyẹn"<br /> "5- Gbigbe ọtun lori osi. "<br /> "6- Ki o maa wo ààyè ifi-ori-kanlẹ rẹ"<br /> "7- Fífi àlàfo si àárín ẹsẹ rẹ mejeeji ni ẹni ti o duro"<br /> 8- Fifi ọwọ rẹ méjèèjì di orunkun rẹ méjèèjì mu ni ẹni tí ó máa ya àwọn ọmọnika nibi rukuu rẹ, ati títẹ́ ẹyin rẹ nibẹ, ati jijẹ ki ori rẹ ṣe déédéé ẹyin rẹ.<br /> Fifi àwọn oríkèé iforikanlẹ kan ilẹ̀ daadaa, ki wọn si lé ilẹ̀ láìsí gàgá kankan.<br /> "10- Mimu ọwọ́ rẹ mejeeji jina si ẹgbẹ rẹ mejeeji, ati ikun rẹ jina si itan rẹ mejeeji, ati itan rẹ mejeeji jina si ojugun rẹ mejeeji, ati fifi àlàfo si aarin orunkun rẹ mejeeji, ati ninaro ẹsẹ rẹ mejeeji, ati gbigbe awọn inu awọn ọmọ ika ọwọ rẹ mejeeji lori ilẹ ti o maa ya a, ati gbigbe ọwọ rẹ mejeeji si deede ejika rẹ mejeeji pẹlu titẹ awọn ọmọ ika rẹ ti o si maa lẹ àwọn ọmọ-ìka papọ. "<br /> "11- Jíjókòó le ori ẹsẹ nibi ìjókòó laarin iforikanlẹ mejeeji, ati nibi ataya àkọ́kọ́, ati fifi idi jókòó nibi ẹlẹẹkeji. "<br /> 12- Gbígbé ọwọ méjèèjì lórí itan méjèèjì ni títẹ́ ti àwọn ọmọ-ika si maa wa ni lilẹ papọ láàrin iforikanlẹ méjèèjì, gẹgẹ bẹẹ naa ni nibi ataya, ṣùgbọ́n yoo ka ika kẹrin ati karùn-ún ko, yio ṣe atanpako pẹlu ìka aarin róbótó, yio maa fi ika keji tọka nibi iranti Ọlọhun. "<br /> "13- Yio maa wo ọtun ati osi nibi sisalamọ rẹ. " </p>',
            ],
            23 => [
                'question' => '"Ibeere ẹlẹẹkẹrinlelogun: Onka awọn nnkan ti o n ba irun jẹ? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4210.mp3',
                'answer' => '<p> "Idahun- <span class="c2">(1)</span> gbigbe origun kan tabi majẹmu kan ju silẹ ninu awọn majẹmu irun. "<br /> "<span class="c2">(2)</span> Mimọọmọ sọrọ. "<br /> "<span class="c2">(3)</span> Jijẹ tabi mimu. "<br /> "<span class="c2">(4)</span> Lilọ-bibọ to pọ to tẹle ara wọn. "<br /> <span class="c2">(5)</span> Gbigbe ọranyan kan ninu awọn ọranyan irun ju silẹ ni ti amọọmọ ṣe. " </p>',
            ],
            24 => [
                'question' => '"Ibeere ẹlẹẹkarundinlọgbọn: Báwo ni musulumi ṣe maa kirun? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4280.mp3',
                'answer' => '<p> "Idahun-<span class="c6"> bi a ṣe n kirun:</span> "<br /> "1- Didojukọ qiblah pẹlu gbogbo ara rẹ, láìní yẹ̀ tabi yíjú. "<br /> "2- Lẹyin naa yoo dàníyàn irun ti o fẹ ki pẹlu ọkan rẹ laini wi aniyan naa jáde. "<br /> "3- Lẹyin naa yoo kabara iwọ irun,<span class="c6"> yio sọ pe:</span> <span class="c2">(Allahu Akbar)</span>, yio gbe ọwọ rẹ mejeeji soke titi de ejika rẹ mejeeji nibi kikabara. "<br /> 4- Lẹyin naa yio gbe atẹlẹwọ ọtun rẹ lori ẹyin atẹlẹwọ osi rẹ lori aya rẹ.<br /> 5- Lẹyin naa yio bẹrẹ Irun lẹniti yio maa sọ pe <span class="c3">«Allāhumma bā‘id baynī wa bayna khatāyāya kamā bā‘adta baynal mashriq wal Magrib, allāhumma naqqinī min khatāyāya kamā yunnaqqa thaobul abyadu minad danas, allāhumma igsilnī min khatāyāya bil mā’i wath-thalji wal barad»</span>.<span class="c6"><br /> Tabi ki o sọ pe:</span> <span class="c3">«Subhānaka allāhumma wa bi amdika, wa tabāraka ismuka wa ta‘ālā jadduka, wa lā ilāha gayruka»</span>.<br /> 6-<span class="c6"> lẹyin naa yio wa iṣọra ti yio si maa sọ pe:</span> <span class="c3">«A‘ūdhu billāhi minash Shaytānir rajīm»</span>. 7-<span class="c6"> Lẹyin naa yio ṣe bismiLlāhi yio si ka Fātiha ti yio maa sọ pe:</span> "BismiLlāhir Rahmānir Rahīm" 1 "Alhamdulillāhi robbil aalamiin" 2 "Ar-<span class="c6">Rahmānir Rahīm" 3 "Māliki yaomid dīn" 4 "Iyyāka na‘budu wa iyyāka nasta‘īn" 5 "Ihdinas Sirātal mustaqiim" 6 "Sirātal Ladhīna an‘amta ‘alayhim gayril magdūbi ‘alayhim walad dālīn" 7 Sūratul Fātiha:</span> 1-7.<span class="c6"><br /> Lẹyin naa yio sọ pe:</span> <span class="c2">(Āmīn)</span> itumọ rẹ ni wipe: Irẹ Ọlọhun jẹ ipe.<br /> 8- Lẹyin naa yio ka eyikeyi ti o ba rọ ọ lọrun ninu Al-Qur\'āni, yio si fa kika nkan gun nibi Irun Subhi".<br /> 9- Lẹyin naa yio rukuu,<span class="c6"> iyẹn tumọ si wipe:</span> Yoo tẹ ẹyin rẹ lati gbe titobi fun Ọlọhun, yio si kabara nígbà tí o ba fẹ rukuu, ti yio si gbe ọwọ rẹ mejeeji si deedee ejika rẹ mejeeji.<span class="c6"> Àti pé sunnah ni:</span> Ki o na ẹyin rẹ, ki o si fi ori rẹ ṣe deedee rẹ, yio si tun gbe ọwọ rẹ mejeeji le orunkun rẹ mejeeji l\'ẹniti yio ya awọn ọmọnika ọwọ.<br /> 10-<span class="c6"> Yio si tun sọ nibi rukuu rẹ pe:</span> <span class="c3">«Subhāna robbiyal adhīm»</span> ni ẹẹmẹta,<span class="c6"> ti o ba wa fi kun un pe:</span> "Subhānaka allāhumma wa bi amdik, allāhumma igfir li», ìyẹn náà dáa.<br /> 11-<span class="c6"> Lẹyin naa yio gbe ori rẹ soke lati rukuu lẹniti yio maa sọ pe:</span> <span class="c3">«Sami‘a Llāhu liman hamidahu»</span> ti yio si gbe ọwọ rẹ mejeeji si deedee ejika rẹ mejeeji. Ẹniti o jẹ ero ẹyin <span class="c2">(ti n kirun lẹyin Imāmu)</span> o nii sọ pe: <span class="c3">«Sami‘a Llāhu liman hamidahu»</span> bi ko ṣe pe yio sọ lati fi jirọ rẹ pe: <span class="c3">«Rabbanā walakal amdu»</span><br /> 12-<span class="c6"> Lẹyin naa yio wa sọ lẹyin ti o ba ti gbe ori soke pe:</span> <span class="c3">«Rabbanā wa lakal amdu mil’as samāwāti wal ardi, wa mil’a mā shita min shay’in ba‘d»</span>.<br /> 13- Lẹyin naa yio ṣe iforikanlẹ àkọ́kọ́,<span class="c6"> yio waa maa sọ nígbà tí o ba fẹ fi orikanlẹ rẹ pe:</span> <span class="c1">“Allāhu Akbar”</span> ti yio si fi oríkèé ara meje kanlẹ: Iwaju ori ati imu, atẹlẹwọ mejeeji, orunkun mejeeji, ati awọn ọmọnika ẹsẹ mejeeji, yio si gbe apa rẹ mejeeji jina si ẹgbẹ rẹ, ko si nii tẹ apa rẹ mejeeji silẹ, ti yio si tun da oju awọn ọmọnika ẹsẹ rẹ mejeeji kọ Qibla.<br /> 14-<span class="c6"> Yio waa maa sọ ni iforikanlẹ pe:</span> <span class="c3">«Subhāna robbiyal a’lā»</span> ni ẹẹmẹta,<span class="c6"> ti o ba si tun fi kun un pe:</span> <span class="c3">«Subhānaka allāhumma robbāna wa bi amdika, allāhumma igfir lii»</span> o daa.<br /> 15-<span class="c6"> Lẹyin naa yoo gbe ori soke lati iforikanlẹ lẹniti yio maa sọ pe:</span> <span class="c1">“Allāhu Akbar”</span>.<br /> 16- Lẹyin naa yio jókòó laarin iforikanlẹ mejeeji lori ẹsẹ osi rẹ ti yio si na ẹsẹ ọtun rẹ, ti yio si gbe ọwọ ọtun rẹ si eti itan rẹ ọtun ti o tẹle orunkun, yio waa ka ìka oruka-yẹmi ati kurumbete kò, yio waa na ìka odun-unlabẹ rẹ soke ti yio si maa mi in nibi adua, ti yio si fi eti atampako rẹ ko eti ogajuwọnlọ gẹ́gẹ́ bíi òrùka róbótó, yio waa gbe ọwọ́ rẹ osi lori eti itan òsì rẹ ti o sunmọ orunkun ni ẹni tí yio tẹ́ awọn ọmọnika rẹ silẹ.<br /> 17-<span class="c6"> Yio si tun sọ nibi ìjókòó rẹ laarin iforikanlẹ mejeeji pe:</span> <span class="c3">«Robbi igfir lī, warhamnī, wahdinī, warzuqnī, wajburnī, wa ‘āfinī»</span>.<br /> 18- Lẹyin naa yio ṣe iforikanlẹ ẹlẹẹkeji gẹgẹ bii àkọ́kọ́ nibi nkan ti wọn n sọ ti wọn si maa n ṣe nibẹ, yio si kabara nibi iforikanlẹ rẹ.<br /> 19-<span class="c6"> Lẹyin naa yio dide nibi iforikanlẹ ẹlẹẹkeji lẹniti yio maa sọ pe:</span> <span class="c3">«Allāhu Akbar»</span> yio si ki rakah ẹlẹẹkeji bíi àkọ́kọ́ nibi nkan ti wọn n sọ ti wọn si maa n ṣe nibẹ, ṣùgbọ́n ko nii sọ adua iṣirun nibẹ.<br /> 20-<span class="c6"> Lẹyin naa yio jókòó ti o ba ti pari raka‘ ẹlẹẹkeji lẹniti yio maa sọ pe:</span> <span class="c3">«Allāhu Akbar»</span>, yio si tun jókòó gẹgẹ bi o ṣe jókòó laarin iforikanlẹ mejeeji gẹlẹ.<br /> 21- Yio si ka ataaya nibi ìjókòó yii,<span class="c6"> ti yio maa sọ pe:</span> At-Tahiyyātu lillāh was sọlawātu wat Tọyyibāt, As-salaamu alayka ayyuhan nabiyyu warahmatulloohi wabarokaatuh, as’salāmu ‘alaynā wa ‘alā ‘ibādillāhis soolihiin, ’Ashhadu ’an lā ’ilāha ’illāLlāhu, wa ’ashhadu ’anna Muhammadan ‘abduhu wa rọsūluhu, allāhummọ solli ‘alā Muhammadin wa ‘alā āli Muhammadin, kamā sollayta ‘alā ’Ibrāhīm wa ‘alā āli ’Ibrāhim, ’innaka Hamīdun Majīd, wa bārik ‘alā Muhammadin wa ‘alā āli Muhammadin, kamā bārakta ‘alā ’Ibrāhīm wa ‘alā āli ’Ibrāhim, ’innaka Hamīdun Majīd. ’A‘ūdhu bil Lāhi min ‘adhābi jahannam, wa min ‘adhābil qobri, wa min fitnatil mahyā wal mamāti, wa min fitnatil masīhid dajjāl»<br /> "Gbogbo kiki ti Ọlọhun ni, gbogbo Irun ati gbogbo dáadáa tí Ọlọhun ni, ọla Ọlọhun ki o maa ba ọ iwọ Anabi ati ikẹ Rẹ ati awọn oore Rẹ, ọla Ọlọhun ki o maa ba awa naa ati gbogbo awọn ẹrusin Ọlọhun ti wọn jẹ ẹni ire, mo jẹri wipe ki ẹnití ìjọsìn ododo tọ sí ayaafi Allōhu, mo sì tun jẹri wipe Muhammad ẹru Rẹ ni òjíṣẹ Rẹ sì ni pẹlu, Iwọ Oluwa wa ṣe ikẹ fún Anabi Muhammad, ati awọn ara ile Anabi Muhammad, gẹgẹbi O ṣe ṣe ikẹ fún Anabi Ibrōhēm ati awọn ara ile Anabi Ibrōhēm dajudaju Irẹ ni Ọba ẹlẹyin Ọba ti o tobi, Oluwa wa ṣe Ìbùkún fún Anabi Muhammad ati awọn ara ile Anabi Muhammad, gẹgẹbi O ṣe ṣe Ìbùkún fún Anabi Ibrōhēm ati awọn ara ile Anabi Ibrōhēm, dajudaju Irẹ ni Ọba ẹlẹyin Ọba ti o tobi" Lẹyin naa yio wa kepe Oluwa rẹ pẹlu nkan ti o ba fẹ ninu oore aye ati ti ọjọ ikẹhin.<br /> 22-<span class="c6"> Lẹyin naa yio waa salamọ si ọtun rẹ l\'ẹniti yio maa sọ pe:</span> <span class="c3">«As Salāmu alaykum wa rahmotulloohi»</span>, ati osi rẹ bákannáà.<br /> 23- Ti Irun ba wa jẹ olopoo mẹta tabi mẹẹrin; yio duro nibi ipari ataaya àkọ́kọ́,<span class="c6"> oun naa ni:</span> <span class="c3">«’Ashhadu ’an lā ’ilāha ’illāLlāhu, wa ’ashhadu ’anna Muhammadan ‘abduhu wa rọsūluhu»</span><br /> 24-<span class="c6"> Lẹyin naa yio waa dide duro l\'ẹniti yio maa sọ pe:</span> <span class="c3">«Allāhu Akbar»</span>, ti yio si gbe ọwọ rẹ mejeeji si deedee ejika rẹ mejeeji nígbà náà.<br /> 25- Lẹyin naa yio ki èyí tí o ṣẹku nibi Irun rẹ lori iroyin rakah ẹlẹẹkeji, ṣùgbọ́n Fātiah nikan ni yio ka.<br /> 26- Lẹyin naa yio jókòó ni ìjókòó tawarruk, ti yio gbe ẹsẹ ọtun rẹ soke, yio si yọ ẹsẹ osi rẹ jade labẹ ojugun rẹ ọtun, ti yio si fi idi rẹ le\'lẹ dáadáa, yio waa gbe ọwọ rẹ mejeeji lori itan rẹ mejeeji lori iroyin bi o ṣe gbe e nibi ataaya àkọ́kọ́.<br /> 27- Yio waa ka gbogbo ataaya nibi ìjókòó yii.<br /> 28-<span class="c6"> Lẹyin naa yio wàá salamọ si ọtun rẹ l\'ẹniti yio maa sọ pe:</span>: <span class="c3">«As Salāmu alaykum wa rahmotulloohi»</span>, ati osi rẹ bákannáà. </p>',
            ],
            25 => [
                'question' => 'Ibeere 26: Ki ni nkan ti waa maa sọ ninu awọn asikiri lẹyin salamọ nibi Irun?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4610.mp3',
                'answer' => '<p> Idahun- <span class="c3">«Astagfirullāha»</span> ni ẹẹmẹta.<br /> <span class="c3">«Allāhummọ ’Antas Salām, wa minKas salām, tabārakTa, yā Dhal jalāli wal ikrām»</span>.<br /> <span class="c1">“Laa ilaaha illa laah, Wah\'dahu laa shariika lahu, lahul Mulku wa lahul Hamdu Wa uwa ala kulli shaein Qodiir,Allahuma la maaniha lima A\'tayta Wa la mu\'tiya lima mana\'ta wa la yan\'fahu zal jaddi Minkal jaddu”</span> <span class="c2">(Ko si eniti ijosin to si ayafi Allah nikan, ko si orogun fun Un, ti E ni ola se, atipe ti E ni eyin se, atipe O je alagbara lori gbogbo nkan, Ire Oluwa, ko si oludena fun nkan ti O ba fun ni, atipe ko si olufunni ni ohun ti O ba ko funni atipe oro kole wulo fun oloro ni odo Re)</span>.<br /> <span class="c3">«Lā ’ilāha ’illāLlāhu wahdahu lā sharīka lahu, lahul mulku wa lahul amdu, wa huwa ‘alā kulli shay’in qodīr, lā haola walā quwwata illā bilLāh, lā ’ilāha ’illāLlāhu, walā na‘budu illā Iyyāhu, laHun ni‘matu wa laHul fadlu wa laHuth thanā’ul hasan, lā ’ilāha ’illāLlāhu mukhlisiina laHud dīn wa lao karihal kāfirūn»</span>.<br /> <span class="c3">«Subhānallāhi»</span> ni igba mẹtalelọgbọn.<br /> <span class="c3">«Alhamdulillāhi»</span> ni igba mẹtalelọgbọn.<br /> <span class="c3">«Allāhu Akbar»</span> ni igba mẹtalelọgbọn.<br /> Lẹyin naa yio sọ ni ipari ọgọ́rùn-<span class="c6">ún pe:</span> <span class="c3">«Lā ilāha illāLlāhu wahdahu lā sharīka lahu, lahul mulku wa lahul amdu, wa huwa ‘alā kulli shay’in qodīr»</span>.<br /> Yio ka Sūratul Ikhlās <span class="c2">(qul Uwa Allāhu Ahad)</span> ati Al-Mu‘awwidhāt <span class="c2">(qul a‘ūdhu bi robbil falaqi ati qul a‘ūdhu bi robbin nās)</span> ni ẹẹmẹta lẹyin Irun Al-fajri ati Irun Magrib, ati ni ẹẹkan lẹyin awọn Irun yoku.<br /> Yio si tun ka āyatal qursiyyu ni ẹẹkan. </p>',
            ],
            26 => [
                'question' => 'Ibeere 27: Ki ni awọn sunnah (asegbọrẹ) awọn Irun wakati márùn-ún? Kí sì ni ọla ti n bẹ fun un?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4730.mp3',
                'answer' => '<p> Idahun- Raka‘a meji ṣíwájú Al-fajri.<br /> Raka‘a mẹẹrin ṣíwájú irun aila.<br /> Raka‘a meji lẹyin irun aila.<br /> Raka‘a meji lẹyin Magrib.<br /> Raka‘a meji lẹyin Ishai.<span class="c6"><br /> Ọla rẹ:</span> Anabi sọ pe: «Ẹniti o ba ki Raka‘a akigbọrẹ mejila ni ojumọ <span class="c2">(aarọ ati alẹ)</span> Ọlọhun maa kọ ile kan fun un ninu ọgba alujanna» Muslim ati Ahmad ati ẹlomiran yatọ si awọn mejeeji ni wọn gba a wa. </p>',
            ],
            27 => [
                'question' => 'Ibeere 28: Ewo lo ni ọla ju ninu awọn ọjọ ọsẹ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4800.mp3',
                'answer' => '<p> Idahun- Ọjọ Jumu‘ah, Anabi - ki ikẹ ati ọla maa ba a -<span class="c6"> sọ pe:</span> «Dajudaju ninu awọn ọjọ yin to daa julọ ni ọjọ Jumu‘ah, ninu ẹ ni wọn da Ādam, ninu ẹ ni wọn gba ẹmi rẹ, ninu ẹ feere fifun o ti waye, ninu ẹ ni kiku <span class="c2">(gbogbo ẹda)</span> o ti waye; nitori naa ẹ pọ ni ṣiṣe assalātu fun mi ninu ẹ; nítorí pé dajudaju wọn yio maa fi assalātu yin han mi» O sọ pe: Wọn sọ pe irẹ Ojiṣẹ Ọlọhun, bawo ni wọn o ṣe maa fi awọn assalātu wa han ọ ti o si jẹ wipe o ti kẹfun - nkan ti wọn n sọ ni pe o ti jẹra -<span class="c6"> o wa sọ pe:</span> <span class="c3">«Dajudaju Ọlọhun - ti O biyi ti O si tun gbọnngbọn - ti ṣe awọn ara awọn Anabi Rẹ ni eewọ fun ilẹ»</span>. Abu Daūd ati ẹlomiran yatọ si i ni wọ́n gba a wa. </p>',
            ],
            28 => [
                'question' => 'Ibeere 29: Ki ni idajọ Irun Jumu‘a?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4840.mp3',
                'answer' => '<p> Ọranyan ojulowo ni i lori gbogbo Musulumi ti o jẹ ọkunrin ti o ti balaga ti o ni laakaye ti o n bẹ ninu ilu <span class="c2">(ti kii ṣe arinrin-ajo)</span>.<span class="c6"><br /> Ọba ti ọla Rẹ ga sọ pe:</span> ﴾Ẹ̀yin tí ẹ gbàgbọ́ ní òdodo, nígbà tí wọ́n bá pe ìrun ní ọjọ́ Jum‘ah, ẹ yára lọ síbi ìrántí Allāhu, kí ẹ sì pa kátà-kárà tì. Ìyẹn lóore jùlọ fun yín tí ẹ bá mọ̀.9﴿ <span class="c5">[Sūratul Kāfirūn: 9]</span>. </p>',
            ],
            29 => [
                'question' => 'Ibeere 30: Melo ni onka Raka‘a Irun Jumu‘a?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4880.mp3',
                'answer' => '<p> Idahun- Onka Raka‘a Irun Jumu‘a meji ni, ti Imāmu o si gbe ohun s\'oke nibẹ, l\'eyi ti o ṣe wipe khutubah meji ti a ti mọ o ṣaaju rẹ. </p>',
            ],
            30 => [
                'question' => 'Ibeere 31: Njẹ o lẹ́tọ̀ọ́ lati má ki irun Jimọh bi?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4910.mp3',
                'answer' => '<p> "Idahun- Pipa irun ọjọ jimọh jẹ o lẹ́tọ̀ọ́ afi pẹlu idi kan to jẹ ti sharia, o wa lati ọdọ Anabi -ki ikẹ Ọlọhun ati ọla Rẹ maa ba a-<span class="c6"> pe:</span> " <span class="c1">“Ẹnikẹni ti o ba gbe irun ọjọ jimọh mẹta ju silẹ ni ti ailakakun pẹlu ẹ; Ọlọhun maa fi edidi di ọkan rẹ”</span>. " Abu Daud ati ẹni ti o yatọ si i ni wọn gba a wa" </p>',
            ],
            31 => [
                'question' => '"Ibeere ẹlẹẹkejilelọgbọn: Dárúkọ awọn sunnah ọjọ jimọh? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/4940.mp3',
                'answer' => '<p> Idahun<br /> "1- Wiwẹ "<br /> "2- Lilo lọfinda"<br /> "3- Wiwọ eyi to daa julọ ninu aṣọ"<br /> "4- Titete lọ si mọsalasi"<br /> "5- Pipọ ni ṣíṣe asalaatu fun Anabi -ki ikẹ Ọlọhun ati ọla Rẹ maa ba a- "<br /> "6- Kika suratul kahf."<br /> "7- Lilọ si mọsalasi ni ẹni ti o n rin"<br /> "8- Wiwa asiko gbigba adura." </p>',
            ],
            32 => [
                'question' => '"Ibeere ẹlẹẹkẹtalelọgbọn: Dárúkọ ọla ti o n bẹ fun irun Janmọọn? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5050.mp3',
                'answer' => '<p> "Idahun- Lati ọdọ Abdulahi ọmọ Umar -ki Ọlọhun yọnu si awọn mejeeji-, pe Ojiṣẹ Ọlọhun -ki ikẹ Ọlọhun ati ọla Rẹ maa ba a-<span class="c6"> sọ pe:</span> " <span class="c1">“Irun janmọọn ni ọla ju irun adaki lọ pẹlu ipò mẹtadinlọgbọn”</span>. " Muslim ni o gba a wa. </p>',
            ],
            33 => [
                'question' => '"Ibeere ẹlẹẹkẹrinlelọgbọn: ki ni irẹlẹ nibi irun? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5080.mp3',
                'answer' => '<p> "Idahun- oun ni ki ọkàn wà nibẹ, ki ara o sì balẹ.<span class="c6"><br /> Ọba ti ọla Rẹ ga sọ pe:</span> {Dájúdájú àwọn onígbàgbọ́ òdodo ti jèrè 1 " "{Àwọn t’ó ń páyà <span class="c2">(Allāhu)</span> nínú ìrun wọn 2} "<span class="c5">[Surah Al-<span class="c6">Mu’minûn:</span> 1, 2]</span>" </p>',
            ],
            34 => [
                'question' => '"Ibeere ẹlẹẹkarundinlogoji: Ṣalaye Zakah? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5120.mp3',
                'answer' => '<p> "Idahun- oun ni iwọ kan to jẹ dandan nibi dúkìá kan pàtó, fun àwọn kan pàtó, ni asiko kan pàtó.<br /> Origun kan ni in ninu awọn origun Isilaamu, saara ti o jẹ ọranyan si tun ni in ti wọn gbọdọ yọ lọwọ eeyan abọrọ ti wọn o si ko o fun alaini.<span class="c6"><br /> Ọba ti ọla Rẹ ga sọ pe:</span> Ẹ yọ Zakāh. <span class="c5">[Suuratul-<span class="c6">Baqarah:</span> 43]</span>. </p>',
            ],
            35 => [
                'question' => 'Ibeere kẹrindinlogoji: Ki ni wọn n pe ni saara ti a fẹ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5170.mp3',
                'answer' => '<p> Idahun: Oun yatọ si Zakah,<span class="c6"> gẹgẹ bii:</span> Ṣíṣe saara pẹlu èyíkéyìí nǹkan si àwọn ọna oore ni eyikeyii akoko.<span class="c6"><br /> Ọba ti ọla Rẹ ga sọ pe:</span> <span class="c4">{Ẹ nawo si oju ọna Ọlọhun}</span>. <span class="c5">[Suuratul-<span class="c6">Baqarah:</span> 195]</span>. </p>',
            ],
            36 => [
                'question' => 'Ibeere kẹtadinlọgbọn: Sọ itumọ Aawẹ gbigba?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5210.mp3',
                'answer' => '<p> Idahun: Oun ni ṣiṣe ijọsin fun Ọlọhun pẹlu kikoraro kuro nibi ohun ti o le ba aawẹ jẹ lati igba ti alufajari ba ti yọ titi di igba ti oorun yoo fi wọ pẹlu dida aniyan,<span class="c6"> o si ni iran meji:</span><br /> Aawẹ ọranyan: Bii gbigba aawẹ oṣu Ramadan, o si jẹ origun kan ninu awọn origun Isilaamu.<span class="c6"><br /> Ọba ti ọla Rẹ ga sọ pe:</span> Ẹ̀yin tí ẹ gbàgbọ́ ní òdodo, A ṣe ààwẹ̀ náà ní ọ̀ran-anyàn fun yín, gẹ́gẹ́ bí A ti ṣe é ní ọ̀ran-anyàn fún àwọn t’ó ṣíwájú yín, nítorí kí ẹ lè bẹ̀rù <span class="c2">(Allāhu)</span>. 183 <span class="c5">[Suuratul-<span class="c6">Baqarah:</span> 183]</span>.<span class="c6"><br /> Aawẹ ti kii ṣe ọranyan:</span> Gẹ́gẹ́ bii gbigba aawẹ ọjọ aje ati ọjọbọ ni gbogbo ọsẹ, ati gbigba aawẹ ọjọ mẹta ni gbogbo oṣu, awọn ọjọ ti o si lọla ju ninu rẹ naa ni <span class="c2">(13, 14, 15)</span> ni gbogbo oṣu oju ọrun. </p>',
            ],
            37 => [
                'question' => 'Ibeere kejidinlogoji: Darukọ ọla ti n bẹ fun gbigba awẹ oṣu Ramadan?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5270.mp3',
                'answer' => '<p> Idahun- Lati ọdọ Abu Hurairah <span class="c2">(ki Ọlọhun yọnu si i)</span>, dajudaju ojiṣẹ Ọlọhun <span class="c2">(ki ikẹ ati ọla Ọlọhun maa ba a)</span> sọ pe: Ẹnikẹni ti o gba aawẹ Ramadan pẹlu igbagbọ ati ni ẹni tí ń rankan ẹsan lọdọ Ọlọhun; wọn yoo ṣe aforijin ohun ti o ti lọ ninu ẹṣẹ rẹ. Wọn fi ẹnu ko le e lori. </p>',
            ],
            38 => [
                'question' => 'Ibeere kọkandinlogoji: Darukọ ọla ti n bẹ fun gbigba aawẹ aṣegbọrẹ ni awọn oṣu ti kii ṣe Ramadan?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5300.mp3',
                'answer' => '<p> Idahun- Lati ọdọ Abu Sa\'eed Al-Khud\'riy <span class="c2">(ki Ọlọhun yọnu si i)</span> o sọ pe: Ojiṣẹ Ọlọhun <span class="c2">(ki ikẹ ati ọla Ọlọhun maa ba a)</span> sọ pe: Ko si ẹru kankan ti yoo gba aawẹ ọjọ kan ni oju ọna Ọlọhun ayafi ki Ọlọhun titori rẹ gbe oju rẹ jina si ina ni dedee aadọrin ọdun Wọn fi ẹnu ko le e lori.<br /> Itumọ <span class="c1">“aadọrin Khareef”</span>; iyẹn ni pe: Aadọrin ọdun. </p>',
            ],
            39 => [
                'question' => 'Ibeere ogójì: Darukọ apa kan ninu awọn nnkan ti o le ba aawẹ jẹ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5330.mp3',
                'answer' => '<p> Idahun- 1- Mimọọmọ jẹun ati mimọọmọ mu.<br /> 2- Mimọọmọ bi.<br /> 3- Kikuro ninu Isilaamu. </p>',
            ],
            40 => [
                'question' => 'Ìbéèrè kọkanlelogoji: Ki ni awọn sunnah aawẹ gbigba?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5380.mp3',
                'answer' => '<p> Idahun- 1- Yiyara ṣinu<br /> 2- Saari jijẹ ati lilọ ọ lara.<br /> 3- Nini alekun lori awọn iṣẹ rere ati ijọsin.<br /> 4-<span class="c6"> Ki alaawẹ sọ nigba ti wọn ba bu u pe:</span> Alaawẹ ni mi.<br /> 5- Ṣiṣe adua nigba ti a ba fẹ ṣinu.<br /> 6- Fifi eso dabinu tutu abi gbigbẹ ṣinu, ti ko ba si; ni o too kan omi. </p>',
            ],
            41 => [
                'question' => 'Ìbéèrè kejilelogoji: Sọ itumọ Hajj?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5460.mp3',
                'answer' => '<p> Idahun-<span class="c6"> Hajj:</span> Oun ni jijọsin fun Ọlọhun Ọba ti O ga pẹlu ero lilọ si ile Rẹ abeewọ lati ṣe awọn iṣẹ kan pàtó ni asiko kan pàtó.<span class="c6"><br /> Ọba ti ọla Rẹ ga sọ pe:</span> <span class="c4">{Allāhu ṣe àbẹ̀wò sí Ilé náà ní dandan fún àwọn ènìyàn, t’ó lágbára ọ̀nà tí ó máa gbà débẹ̀. Ẹnikẹ́ni tí ó bá sì ṣàì gbàgbọ́,dájúdájú Allāhu ni Ọlọ́rọ̀ tí kò bùkátà sí gbogbo ẹ̀dá. 97}</span> <span class="c5">[Suuratul Aal Im\'raan: 97]</span> </p>',
            ],
            42 => [
                'question' => 'Ibeere kẹtalelogoji: Mélòó ni awọn origun Hajj?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5500.mp3',
                'answer' => '<p> Idahun- 1 - Gbigbe aṣọ áràmí wọ.<br /> 2 - Diduro si oke arafa<br /> 3 – Tawaaful Ifaadọ.<br /> 4 - Sisa safa ati mar\'wa </p>',
            ],
            43 => [
                'question' => 'Ibeere kẹrinlelogoji: Ki ni ọla ti n bẹ fun Hajj?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5560.mp3',
                'answer' => '<p> Idahun- Lati ọdọ Abu Huraira <span class="c2">(ki Ọlọhun yọnu si i)</span> o sọ pe: Ẹni tí o ba ṣe hajj nitori Ọlọhun ti ko ba iyawo rẹ sun oorun ìfẹ́, ti ko si dá ẹ̀ṣẹ̀; yoo pada gẹgẹ bi ọjọ ti iya Rẹ bi i. Bukhaari ati awọn ẹlomiran ni wọ́n gba a wa.<br /> <span class="c3">«Gẹgẹ bii ọjọ ti iya rẹ bi i»</span>: itumọ rẹ ni pe lai ni ẹṣẹ kankan. </p>',
            ],
            44 => [
                'question' => 'Ibeere 45: Salaye ‘Umrah?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5600.mp3',
                'answer' => '<p> Idahun-<span class="c6"> ‘Umrah:</span> Oun ni jijọsin fun Ọlọhun - ti ọla Rẹ ga - pẹlu gbigbero ile Rẹ abọwọ fun awọn iṣẹ kan ti wọn jẹ ẹsa ni eyikeyi akoko. </p>',
            ],
            45 => [
                'question' => 'Ibeere 46: Onka awọn origun ‘Umrah?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5630.mp3',
                'answer' => '<p> Idahun -1- Gbigbe Harami.<br /> 3- Rirọkirika ile Ọlọhun.<br /> 3- Sísá Safa ati Marwa. </p>',
            ],
            46 => [
                'question' => 'Ibeere 47: Ki ni a n pe ni ijagun si oju-ọna Ọlọhun?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5690.mp3',
                'answer' => '<p> Idahun- Oun naa ni nina igbiyanju ati ikapa si ibi titan Isilāmu ka ati dida aabo bo o ati awọn Musulumi, tabi biba ọta Isilaamu ati awọn Mùsùlùmí jagun.<span class="c6"><br /> Ọba ti ọla Rẹ ga sọ pe:</span> ﴾Kí ẹ sì fi àwọn dúkìá yín àti ẹ̀mí yin jagun fún ẹ̀sìn Allāhu. Ìyẹn lóore jùlọ fun yín tí ẹ bá mọ̀. 41﴿ <span class="c5">[Suuratu At-<span class="c6">Tawbah:</span> 41]</span>. </p>',
            ],
        ],
        3 => [
            0 => [
                'question' => 'Ibeere 1: Ki ni ìdílé Anabi wa Muhammad (ki ikẹ ati ọla Ọlọhun maa ba a)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5740.mp3',
                'answer' => '<p> Idahun- Oun ni Muhammad ọmọ Abdullah ọmọ Abdul Muttalib ọmọ Hāshim, ti Hāshim wa lati idile Quraysh, ti Quraysh wa lati iran larubawa, ti larubawa si jẹ arọmọdọmọ Ismā‘īl ti Ismā‘īl si jẹ ọmọ Ibrāhīm, ki ikẹ ati ọla ti o lọla julọ maa ba oun ati Anabi wa. </p>',
            ],
            1 => [
                'question' => 'Ibeere 2: Ki ni orukọ iya Anabi wa (ki ikẹ ati ọla Ọlọhun maa ba a)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5770.mp3',
                'answer' => '<p> Idahun- Āminatu ọmọ Wahb. </p>',
            ],
            2 => [
                'question' => 'Ibeere 3: Ìgbà wo ni baba rẹ ku?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5800.mp3',
                'answer' => '<p> Idahun- Baba rẹ ku ni Mẹdina, ti oun si wa ni oyún, ti wọn o tii bi i <span class="c2">(ki ikẹ ati ọla Ọlọhun maa ba a)</span>. </p>',
            ],
            3 => [
                'question' => 'Ibeere 4: Ìgbà wo ni wọn bi Anabi (ki ikẹ ati ọla Ọlọhun maa ba a)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5830.mp3',
                'answer' => '<p> Idahun- Ni ọdún eleerin, ni ọjọ Monday <span class="c2">(aje)</span> ninu oṣù Rabī‘ul awwal. </p>',
            ],
            4 => [
                'question' => 'Ibeere 5: Ilu wo ni wọn ti bi i?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5850.mp3',
                'answer' => '<p> Idahun- Ni Mẹka. </p>',
            ],
            5 => [
                'question' => 'Ibeere 6: Awọn wo ni awọn ti wọn fun un ni ọyàn ati awọn ti wọn tọju rẹ lẹyin iya rẹ.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5880.mp3',
                'answer' => '<p> Idahun- Ẹrubinrin ti baba rẹ sọ di ọmọluabi ti n jẹ Ummu Ayman.<br /> - Ẹrubinrin ti ọmọ-ìyá baba rẹ Abū Lahab sọ di ọmọluabi ti n jẹ Thuwaybah.<br /> - Halīmatu As-Sa‘diyyah. </p>',
            ],
            6 => [
                'question' => 'Ibeere 7: Ìgbà wo ni ìyá rẹ ku?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5930.mp3',
                'answer' => '<p> Idahun- Iya rẹ ku nígbà tí o wa ni ọmọ ọdun meji, ti baba baba rẹ Abdul Muttalib si gba a tọ. </p>',
            ],
            7 => [
                'question' => 'Ibeere 8: Ta ni o gba a tọ lẹyin iku baba baba rẹ Abdul Muttalib?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5960.mp3',
                'answer' => '<p> Idahun- Baba baba rẹ ti n ṣe Abdul Muttalib ku nígbà tí o wa ni ọmọ ọdun mẹjọ, ti ọmọ-ìyá baba rẹ Abū Tālib si gba a tọ. </p>',
            ],
            8 => [
                'question' => 'Ibeere 9: Ìgbà wo ni o ṣe irin-ajo pẹlu ọmọ-ìyá baba rẹ lọ si ilu Shām?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/5990.mp3',
                'answer' => '<p> Idahun- O ṣe irin-ajo pẹlu ọmọ-ìyá baba rẹ lọ si Shām ti ọjọ ori rẹ si jẹ ọdun mejila. </p>',
            ],
            9 => [
                'question' => 'Ibeere 10: Ìgbà wo ni irin-ajo rẹ eleekeji wáyé?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6020.mp3',
                'answer' => '<p> Idahun- Irin-ajo rẹ ẹlẹẹkeji wáyé nipa òwò kan ti o ṣe pẹlu owó Khadījah - ki Ọlọhun yọnu si i -, nígbà tí o wa ṣẹri pada, o- ki ikẹ ati ọla Ọlọhun maa ba a- wa fẹ ẹ <span class="c2">(Khadījah)</span>. </p>',
            ],
            10 => [
                'question' => 'Ibeere 11: Ìgbà wo ni awọn Quraysh tun Ka‘bah mọ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6050.mp3',
                'answer' => '<p> Idahun- Awọn Quraysh tun Ka‘bah mọ nígbà tí ó wà ní ọmọ ọdun marunlelọgbọn.<br /> Wọn si fi ṣe adajọ nígbà tí wọn yapa nipa ẹniti yio gbe okuta dudu si aaye rẹ, ni o wa gbe e si inu aṣọ, o wa pa idile kọọkan laṣẹ ki wọn mu eti kọọkan nibi aṣọ náà, ti wọn si jẹ idile mẹẹrin, nígbà tí wọn wa gbe e de aaye rẹ, o fi ọwọ rẹ gbe e si ibẹ <span class="c2">(ki ikẹ ati ọla maa ba a)</span>. </p>',
            ],
            11 => [
                'question' => 'Ibeere 12: Ọmọ ọdun melo ni i nígbà tí wọn gbe e dide? Ta ni wọn si ran an si?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6080.mp3',
                'answer' => '<p> Idahun- Ọjọ ori rẹ jẹ ogoji ọdun, wọn si gbe e dide si gbogbo eeyan patapata ni Olufunni niroo idunnu ati olukilọ iya fun ni. </p>',
            ],
            12 => [
                'question' => 'Ibeere 13: Ki ni akọkọ nkan ti Wahyi (Imisi) bẹrẹ pẹlu rẹ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6110.mp3',
                'answer' => '<p> Idahun- Ala ododo, ko waa nii la ala kankan ayaafi ki o wa gẹgẹ bii imọlẹ owurọ. </p>',
            ],
            13 => [
                'question' => 'Ibeere 14: Bawo ni ìṣesí rẹ ṣíwájú Wahyi (Imisi)? Àti pé ìgbà wo ni Wahyi sọkalẹ fun un ni igba akọkọ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6140.mp3',
                'answer' => '<p> Idahun- O jẹ ẹni tí maa n ṣe ijọsin fun Ọlọhun ninu kòtò Hirā ti o si maa mú èsè dání fun un.<br /> Wahyi <span class="c2">(imisi)</span> si sọkalẹ fun un, nígbà tí o wa nínú koto naa lẹniti n ṣe ijọsin. </p>',
            ],
            14 => [
                'question' => 'Ibeere 15: Kí ni akọkọ nkan ti Ọlọhun sọkalẹ ninu Al-Qur\'āni?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6180.mp3',
                'answer' => '<p> Idahun-<span class="c6"> Gbolohun Ọba ti ọla Rẹ ga pe:</span> Ké <span class="c2">(al-Ƙur’ān)</span> pẹ̀lú orúkọ Olúwa rẹ, Ẹni tí Ó dá ẹ̀dá. 1 Ó ṣẹ̀dá ènìyàn láti ara ẹ̀jẹ̀ dídì. 2 Ké e. Olúwa rẹ ni Alápọ̀n-ọ́nlé jùlọ. 3 Ẹni tí Ó fi ìmọ̀ nípa gègé ìkọ̀wé mọ ènìyàn. 4 Ó fi ìmọ̀ tí ènìyàn kò mọ̀ mọ̀ ọ́n. 5 <span class="c5">[Suuratul Alaq: 1 - 5]</span> </p>',
            ],
            15 => [
                'question' => 'Ibeere 16: Ta ni ẹni akọkọ ti o ni igbagbọ si iranṣẹ rẹ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6200.mp3',
                'answer' => '<p> Idahun: Nínú awọn ọkunrin: Abubakr\' As-sideeq,<span class="c6"> ninu awọn obinrin:</span> Khadijah ọmọ Khuwaylid,<span class="c6"> ninu awọn ọmọ keekeeke:</span> Aliyy ọmọ Abuu Taalib,<span class="c6"> ninu awọn ẹru ti o ti di ọmọ:</span> Zaid ọmọ Haaritha,<span class="c6"> ninu awọn ẹru:</span> Bilaal Al-Habashiy <span class="c2">(ki Ọlọhun yọnu si wọn)</span> ati awọn miran. </p>',
            ],
            16 => [
                'question' => 'Ibeere 17: Bawo ni ipepe sinu Isilaamu ṣe waye?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6230.mp3',
                'answer' => '<p> Idahun: Ipepe waye ni kọkọ fun nǹkan bíi ọdún mẹta, lẹyin naa ni o <span class="c2">(ki ikẹ ati ọla Ọlọhun maa ba a)</span> paṣẹ pẹlu ipepe gbangba. </p>',
            ],
            17 => [
                'question' => 'Ibeere 18: Kí ni iṣesi Anabi (ki ikẹ ati ọla Ọlọhun maa ba a) ati awọn ti wọn gba a gbọ wa lẹyin ti ipepe gbangba waye?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6260.mp3',
                'answer' => '<p> Idahun – Àwọn ọṣẹbọ fi ṣuta kan an gan ati awọn Musulumi, titi ti o fi yọnda fun awọn olugbagbọ ododo lati ṣe hijira lọ si ọdọ Najaashi ni ilẹ Habasha.<br /> Awọn ẹlẹbọ si fi ẹnu kò lati fi ṣuta kan an, ati lati pa a <span class="c2">(ki ikẹ ati ọla Ọlọhun maa ba a)</span>. Ọlọhun wa dáàbò bo o, ti O si rọgbayika rẹ pẹlu ẹgbọn baba rẹ tii ṣe Abuu Taalib lati le baa daabo bo o kuro lọwọ wọn. </p>',
            ],
            18 => [
                'question' => 'Ibeere 19: Ta ni ẹniti o ku ni ọdun ẹlẹẹkẹwaa lati igba ti wọn ti gbe e (ki ikẹ ati ọla Ọlọhun maa ba a) dide?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6300.mp3',
                'answer' => '<p> Idahun- Ẹgbọn baba rẹ tii ṣe Abuu Taalib ati iyawo rẹ tii ṣe Khadeejah <span class="c2">(ki Ọlọhun yọnu si i)</span> kú. </p>',
            ],
            19 => [
                'question' => 'Ibeere 20: Igba wo ni Israa\' ati Mi\'raaj waye?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6330.mp3',
                'answer' => '<p> Idahun: O wa ni ọmọ ọdun àádọ́ta. Ọlọhun si ṣe awọn irun márùn-ún ni ọranyan le e lori.<span class="c6"><br /> Idahun:</span> Israa\': Lati Mọṣalaṣi abeewọ lọ si Mọṣalaṣi Aq\'saa.<span class="c6"><br /> Mi\'raaj:</span> Oun waye lati Mọṣalaṣi Aq\'saah titi lọ si Sid\'ratil mun\'taha. </p>',
            ],
            20 => [
                'question' => 'Idahun 21: Bawo ni Anabi (ki ikẹ ati ọla Ọlọhun maa ba a) ṣe n pe awọn eeyan ni ita makkah.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6380.mp3',
                'answer' => '<p> Idahun: O maa n ṣe ipepe fun awọn ara ilẹ Taaif, o si maa n fi ara rẹ han wọn ni àwọn aaye ipadepọ awọn eeyan titi ti awọn Ansọọr fi de lati ilu Mẹdina ti wọn si gba a gbọ, wọn si tun gba ọwọ rẹ ni ti adehun lati ran an lọ́wọ́. </p>',
            ],
            21 => [
                'question' => 'Ibeere 22: Igba melo ni Anabi (ki ikẹ ati ọla Ọlọhun maa ba a) fi wa ni Mẹka ti n pe awọn eeyan?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6410.mp3',
                'answer' => '<p> Idahun- O lo ọdun mẹtala nibẹ. </p>',
            ],
            22 => [
                'question' => 'Ibeere 23: Nibo ni Anabi (ki ikẹ ati ọla Ọlọhun maa ba a) ṣe hijira lọ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6440.mp3',
                'answer' => '<p> Idahun: O ṣe e lati Makkah lọ si Mẹdina. </p>',
            ],
            23 => [
                'question' => 'Ibeere 24: Igba melo ni o lo ni Mẹdina?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6470.mp3',
                'answer' => '<p> Idahun: Ọdun mẹ́wàá ni in. </p>',
            ],
            24 => [
                'question' => '"Ibeere ẹlẹẹkarundinlọgbọn: Ki ni nnkan ti wọn ṣe ni ọranyan le e lori ni Mẹdina ninu awọn ofin Isilaamu? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6490.mp3',
                'answer' => '<p> "Idahun- wọn ṣe yiyọ zakah ni ọranyan le e lori, ati aawẹ gbigba, ati lilọ si ile oluwa, ati jijagun si oju-ọna Ọlọhun, ati pipe irun, ati eyi to yatọ si i ninu awọn ofin Isilaamu. </p>',
            ],
            25 => [
                'question' => '"Ibeere ẹlẹẹkẹrindinlọgbọn: Ki ni awọn to pataki ninu awọn ogun rẹ ti o kopa nibẹ -ki ikẹ Ọlọhun ati ọla Rẹ maa ba a-? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6520.mp3',
                'answer' => '<p> "Idahun- ogun badari nla."<br /> ."Ogun uhud."<br /> "Ogun Al-Ahzâb "<br /> Ogun ṣiṣi Mẹka" </p>',
            ],
            26 => [
                'question' => '"Ibeere ẹlẹẹkẹtadinlọgbọn: ki ni eyi to kẹyin ninu nnkan ti wọn sọkalẹ ninu Kuraani? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6580.mp3',
                'answer' => '<p> "Idahun- ọrọ Rẹ -Ọba ti ọla Rẹ ga-: " "{Ẹ bẹ̀rù ọjọ́ kan tí wọ́n máa da yín padà sí ọ̀dọ̀ Allāhu. Lẹ́yìn náà, Wọ́n máa san ẹ̀mí kọ̀ọ̀kan ní ẹ̀san ní ẹ̀kún rẹ́rẹ́ <span class="c2">(nípa)</span> ohun tí ó ṣe níṣẹ́. Wọn kò sì níí ṣàbòsí sí wọn 281}. " <span class="c5">[Suuratul-<span class="c6">Baqarah:</span> 281]</span>. </p>',
            ],
            27 => [
                'question' => '"Ibeere ẹlẹẹkejidinlọgbọn: Ìgbà wo ni Anabi -ki ikẹ Ọlọhun ati ọla Rẹ maa ba a- kú? Ati pe mélòó ni ọjọ ori rẹ? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6610.mp3',
                'answer' => '<p> "Idahun- o ku ni oṣu Robii’ul Awwal, ni ọdun ẹlẹẹkọkanla ni ọdun hijra, ti o si jẹ ọmọ ọdún mẹtalelọgọta. </p>',
            ],
            28 => [
                'question' => '"Ibeere ẹlẹẹkọkandinlọgbọn: Dárúkọ awọn iyawo Anabi -ki ikẹ Ọlọhun ati ọla Rẹ maa ba a- ? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6640.mp3',
                'answer' => '<p> "1- Khadijah ọmọ Khuwailid -ki Ọlọhun yọnu si i- "<br /> "2- Saodah ọmọ Zam\'ah- ki Ọlọhun yọnu si i- "<br /> "3- A\'ishah ọmọ Abu Bakr -ki Ọlọhun yọnu si i- "<br /> 4- Hafsoh ọmọ Umar -ki Ọlọhun yọnu si i- "<br /> "5- Zainab ọmọ Khuzaimoh -ki Ọlọhun yọnu si i- "<br /> "6- Ummu Salamoh Hind ọmọ Abu Umayyah- ki Ọlọhun yọnu si i- "<br /> "7- Ummu Habibah Romlah ọmọ Abu Sufyan- ki Ọlọhun yọnu si i- "<br /> "8- Juwayriyah ọmọ Harith- ki Ọlọhun yọnu si i- "<br /> "9- Maimuunah ọmọ Haarith- ki Ọlọhun yọnu si i- "<br /> 10- Sofiyyah ọmọ Hayiy- ki Ọlọhun yọnu si i- "<br /> "11- Zainab ọmọ Jahsh- ki Ọlọhun yọnu si i-" </p>',
            ],
            29 => [
                'question' => 'Ibeere 30: Awọn wo ni awọn ọmọ rẹ (ki ikẹ ati ọla Ọlọhun maa ba a)?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6760.mp3',
                'answer' => '<p> Awọn ọkunrin mẹta ni wọn:<br /> Qāsim, oun si ni wọn fi maa n da a pe.<br /> Ati Abdullāhi.<br /> Ati Ibrāhīm.<span class="c6"><br /> Awọn Obinrin:</span><br /> Fatima<br /> Rukayyah<br /> Ummu kulthuum<br /> Zaynab<br /> Gbogbo ọmọ rẹ pata, ati ara Khadījah ni wọn ti wa - ki Ọlọhun yọnu si i - ayaafi Ibrāhīm, gbogbo wọn lo si ku ṣaaju rẹ ayaafi Fātimah to ku lẹyin rẹ lẹyin oṣu mẹfa. </p>',
            ],
            30 => [
                'question' => 'Ibeere 31: Darukọ apakan awọn iroyin Anabi - ki ikẹ ati ọla Ọlọhun maa ba a - ti o jẹ ti ṣiṣẹda rẹ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6880.mp3',
                'answer' => '<p> O jẹ - ki ikẹ ati ọla Ọlọhun maa ba a - ẹniti o wa ni iwọntun-wọnsi ninu awọn ọkunrin ni, ko kuru ko si ga, amọ o wa laarin iyẹn, o jẹ ẹniti o funfun ti pupa dà papọ mọ ọn - ki ikẹ ati ọla maa ba a- o jẹ ẹniti irungbọn rẹ pọ, ti oju rẹ mejeeji si fẹ̀, ti ẹnu rẹ si tóbi, irun rẹ dudu gan-an, ejika rẹ mejeeji si tóbi, oorun rẹ si dun, ati èyí tí o yatọ si iyẹn ninu ṣiṣẹda rẹ to rẹwa <span class="c2">(ki ikẹ ati ọla Ọlọhun maa ba a)</span> </p>',
            ],
            31 => [
                'question' => 'Ibeere 32: Lori ki ni Anabi - ki ikẹ ati ọla Ọlọhun maa ba a - fi awọn ijọ rẹ le?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6910.mp3',
                'answer' => '<p> Idahun- O fi ijọ rẹ silẹ - ki ikẹ ati ọla Ọlọhun maa ba a - sori oju-ọna ti o funfun, ti oru rẹ da bi ọsan rẹ, ẹnikan o si nii yẹ kuro nibẹ ayaafi ẹni iparun, ko si fi daadaa kan silẹ ayaafi ko juwe ijọ rẹ si i, ko si tun fi aburu kan silẹ ayaafi ki o kọ fun wọn kuro nibẹ. </p>',
            ],
        ],
        4 => [
            0 => [
                'question' => 'Ibeere 1: Ka Sūratul Fātiha ki o si ṣe alaye rẹ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/6960.mp3',
                'answer' => '<p> Idahun-<span class="c6"> Sūratul Fātiha ati alaye rẹ:</span><br /> "BismiLlāhir Rahmānir Rahīm 1" "Alhamdulillāhi robbil aalamiin 2" "Ar-<span class="c6">Rahmānir Rahīm 3" "Māliki yaomid dīn 4" "Iyyāka na‘budu wa Iyyāka nasta‘īn 5" "Ihdinaṣ ṣirātal mistaqīm 6" Sirātọl Ladhīna an‘amta ‘alayhim gayril magdūbi ‘alayhim walad dālīn} Sūratul Fātiha:</span> 1-7.<br /> Alaye<br /> Wọn sọ ọ ni Sūratul Fātiah; latari wipe wọn bẹrẹ iwe Ọlọhun pẹlu rẹ.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001001.mp3"></audio> 1- <span class="c4">{BismiLlāhir Rahmānir Rahīm 1}</span> maa bẹrẹ kika Al-Qur\'āni mi pẹlu orukọ Ọlọhun, lẹniti n wa iranwọ pẹlu Rẹ lẹniti n wa alubarika pẹlu orukọ Rẹ.<br /> <span class="c4">{Allāhu}</span> itumọ rẹ ni: Ẹniti a maa jọsin fun l\'ododo, ati pe wọn ki n pe elomiiran bẹẹ yatọ si I- mimọ n bẹ fun un.<br /> <span class="c4">{Ar-Rahmān}</span> itumọ rẹ ni wipe: Oni ikẹ ti o gbaaye ti o kari gbogbo nkan.<br /> <span class="c4">{Ar-Rọhīm}</span> itumọ rẹ ni wipe: Ẹniti O ni ikẹ fun awọn Mu’mini.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001002.mp3"></audio> <span class="c4">{Alhamdulillāhi robbil aalamiin 2}</span> itumọ rẹ ni pe: Gbogbo iran ẹyin ati pipe ti Ọlọhun ni ni Òun nikan soso.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001003.mp3"></audio> 3- <span class="c4">{Ar-Rahmānir Rahīm 3}</span> itumọ rẹ ni pe: Oni ikẹ ti o gbaaye ti o kari gbogbo nkan, Oni ikẹ ti o maa de ọdọ awọn Mu‘mini.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001004.mp3"></audio> 4- <span class="c4">{Māliki yaomid dīn 4}</span>: Oun ni ọjọ igbende.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001005.mp3"></audio> 5- <span class="c4">{Iyyāk na‘budu wa Iyyāk nasta‘īn 5}</span> itumọ rẹ ni pe: A o maa jọsin fun O ni Iwọ nikan a o si tun maa wa iranwọ Rẹ ni Iwọ nikan.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001006.mp3"></audio> 6- <span class="c4">{Ihdinas Sirātal mustaqīm 6}</span>: Oun ni imọna lọ si inu Isilaamu ati Sunnah.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/001007.mp3"></audio> 7- <span class="c4">{Sirātọl Ladhīna an‘amta ‘alayhim gayril magdūbi ‘alayhim walad dhālīn 7}</span> itumọ rẹ ni pe: Oju-ọna awọn ẹrusin Rẹ ti wọn jẹ ẹni ire ninu awọn Anabi ati awọn ti wọn tẹle wọn, yatọ si ọna awọn Kristẹni ati awọn Júù.<span class="c6"><br /> Wọn si tun ṣe e ni sunnah ki o sọ lẹyin kika a pe:</span> <span class="c2">(Āmīn)</span> itumọ rẹ ni pe: Jẹ ipe wa <span class="c2">(da wa loun)</span>. </p>',
            ],
            1 => [
                'question' => 'Ibeere 2: Ka Sūratuz Zalzalah ki o si ṣe alaye rẹ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7130.mp3',
                'answer' => '<p> Idahun-<span class="c6"> Sūratuz Zalzalah ati alaye rẹ:</span><br /> "BismiLlāhir Rahmānir Rahīm"<br /> "<span class="c4">{Idhā zulzilatil’ardu zilzālahā 1" "Wa ’akhrajatil ’ardu athqālahā 2" "Wa qālal insānu mālahā 3" "Yaoma idhin tuhaddithu akhbārahā 4" "Bi anna robbaka ’aohālahā 5" "Yaoma idhin yasdurun nāsu ashtātan liyurao ’a‘mālahun 6" "Fa man ya‘mal mithqāla dharratin khoyron yarahu 7" Ẹni tí ó bá sì ṣe iṣẹ́ aburú ní òdíwọ̀n ọmọ iná-igún, ó máa rí i 8}</span>." "<span class="c5">[Surah Az-<span class="c6">Zalzalah:</span> 1 - 8]</span><br /> Alaye<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099001.mp3"></audio> "1- <span class="c4">{Izaa zul zilatil ardu zil zaalaha 1}</span>: ti wọn ba mi ilẹ ni mimi to le koko to jẹ wipe yio sẹlẹ si i ni ọjọ igbedide. "<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099002.mp3"></audio> "2- <span class="c4">{Wa akh rajatil ardu athqaalaha 2}</span>: ti ilẹ maa mu nnkan ti o wa ninu ẹ jade ninu awọn oku ati nnkan to yatọ si wọn. "<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099003.mp3"></audio> 3- <span class="c4">{Wa qaalal insaanu ma laha 3}</span>: eniyan yo si wi pe ni ẹni ti ọrọ o ye: kini o mu ilẹ ti o n mi ti o si n daru?! "<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099004.mp3"></audio> 4- <span class="c4">{Yawmaa izin tuhaddithu akhbaaraha 4}</span>: ni ọjọ nla yẹn ilẹ o ma sọrọ pẹlu nnkan ti wọn ṣe lori ẹ ninu rere ati aburu."<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099005.mp3"></audio> 5- <span class="c4">{Bi-anna rabbaka awhaa laha 5}</span>: nitori pe dajudaju Ọlọhun lo fi mọọ ti O si pa a laṣẹ pẹlu iyẹn. "<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099006.mp3"></audio> "6- <span class="c4">{Yawma iziny yas durun naasu ash tatal liyuraw a’maalahum 6}</span>: ni ọjọ nla yẹn, eyi to jẹ pe ilẹ ma mi titi nibẹ, ti eniyan o ma jade lati inu aye iṣiro ni ijọ, lati ri awọn iṣẹ wọn eyi to jẹ pe wọn ṣe e ni ile-aye.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099007.mp3"></audio> 7- <span class="c4">{Famaiy ya’mal mithqala zarratin khai raiy-yarah 7}</span>: ẹni ti o ba ṣe iṣẹ to to odiwọn awurebe kerere ninu awọn iṣẹ rere ati daada, yo ri i ni iwaju rẹ. "<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/099008.mp3"></audio> "8- <span class="c4">{Wa maiy-y’amal mithqala zarratin sharraiy-yarah 8}</span>: ẹni ti o ba ṣe iṣẹ ti odiwọn ẹ ninu awọn iṣẹ aburu; yo ri i ni iwaju rẹ. " </p>',
            ],
            2 => [
                'question' => '"Ibeere kẹta: ka Suratul A\'diyah ki o si ṣe alaye ẹ? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7270.mp3',
                'answer' => '<p> "Idahun-<span class="c6"> Suratul A\'diyah ati alaye ẹ:</span><br /> Bismillah hir Rahman nir Raheem<br /> <span class="c4">{Wal’aadi yaati dabha 1 " "{Fal mooriyaati qadha 2 " "{Fal mugheeraati subha 3 " "{Fa atharna bihii naq’a 4 " "{Fawasatna bihii jam’a 5 " "{Innal-insaana lirabbihii lakanood 6 " "{Wa innahu ‘alaa zaalika la shaheed 7 " {Wa innahu lihubbil khairi la shadeed 8 " "{Afala ya’lamu iza b’uthira ma fil kubuur 9 " "{Wa hussila maa fis suduur 10 " {Inna rabbahum bihim yauma ‘izin lakhabeer 11}</span> " <span class="c5">[Sūratul ‘Ādiyāt: 1 - 11]</span>.<span class="c6"><br /> Alaye:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100001.mp3"></audio> 1- <span class="c4">{Wal ‘ādiyāti dọbhā 1}</span>: Ọlọhun bura pẹlu awọn ẹṣin ti wọn maa n sare debi wipe wọn a maa gbọ ohun eemi wọn latari lile ere sisa naa.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100002.mp3"></audio> 2- <span class="c4">{Fal mūriyāti qad’hā 2}</span>: O si tun bura pẹlu awọn ẹṣin ti awọn patako ẹsẹ wọn maa n sa ina nígbà tí wọn ba tẹ apata látàrí lile titẹ ẹ wọn.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100003.mp3"></audio> 3- <span class="c4">{Fal mugīrāti subhā 3}</span>: O si tun búra pẹlu awọn ẹṣin tii maa n kọlu awọn ọta ni aarọ.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100004.mp3"></audio> 4- <span class="c4">{Fa ’atharna bihi naq‘ā 4}</span>: Ti wọn ta eruku lala pẹlu ere sisa wọn.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100005.mp3"></audio> 5- <span class="c4">{Fa wasatna bihi jam‘ā 5}</span>: Wọn si tun bẹ gija papọ pẹlu awọn afẹsinjagun wọn si aarin awọn ọta.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100006.mp3"></audio> 6- <span class="c4">{Innal insāna li Robbihi la kanūd 6}</span>: Dajudaju ọmọniyan ẹniti maa n kọ daadaa ti Oluwa rẹ n fẹ lati ọdọ rẹ ni.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100007.mp3"></audio> 7- <span class="c4">{Wa innāhu ‘alā dhālika la shahīd 7}</span>: Ati pe dajudaju oun naa n jẹrii lori kikọ daadaa rẹ <span class="c2">(ṣiṣe aimoore rẹ)</span>.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100008.mp3"></audio> 8- <span class="c4">{Wa innāhu li hubbil khayri la shadīd 8}</span>: Ati pe dajudaju latari ifẹ afẹju rẹ si owo, yio maa ṣe ahun pẹlu rẹ.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100009.mp3"></audio> 9- <span class="c4">{Afalā ya‘lamu izaa bu‘thira mā fil qubūr 9}</span>: Ṣe ọmọniyan ti n gba ẹtan pẹlu isẹmi aye o wa mọ wipe nígbà tí Ọlọhun ba gbe nkan ti o wa ninu ilẹ ni awọn oku jade ti O si tun mu wọn jade lati inu ilẹ fun iṣiro ati ẹsan wipe dajudaju alamọri naa ko ri bi oun ṣe n ro o?.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100010.mp3"></audio> 10- <span class="c4">{Wa hussila mā fis suduur 10}</span>: Wọn o ṣe afihan gbogbo nkan ti o wa ninu awọn ọkan ni awọn erongba ati awọn adisọkan ati nkan miran yatọ si i.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/100011.mp3"></audio> 11- <span class="c4">{Inna Rọbbahum bihim yaoma’idhin la khabīr 11}</span>: Dajudaju Oluwa wọn ni Alamọtan nipa wọn ni ọjọ yẹn, ti nkankan o si nii pamọ fun un ninu alamọri awọn ẹru Rẹ, ti Yio si san wọn ni ẹsan lori iyẹn. </p>',
            ],
            3 => [
                'question' => 'Ibeere 4: Ka Sūratul Qāri‘ah ki o si ṣe alaye rẹ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7450.mp3',
                'answer' => '<p> Idahun-<span class="c6"> Sūratul Qāri‘ah ati alaye rẹ:</span><br /> "BismiLlāhir Rahmānir Rahīm"<br /> "Al-Qāri‘ah 1" "Mal qāri‘ah 2" "Wa mā adrāka mal qāri‘ah 3" "Yaoma yakūnun nāsu kal farāshil mabthūth 4" "Wa takūnul jibālu kal ‘ihnil manfūsh 5" "Fa ammā man thaqulat mawāzīnuhu 6" "Fa huwa fī ‘īshatin rādiyah 7" "Wa ammā man khaffat mawāzīnuhu 8" "Fa ummuhu hāwiyah 9" "Wa mā adrāka mā hiyah 10" "Nārun hāmiyah 11} <span class="c5">[Sūratul Qāri‘ah: 1 - 11]</span>.<span class="c6"><br /> Alaye:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101001.mp3"></audio> 1- <span class="c4">{Al-Qāri‘ah 1}</span>: Asiko ti yio maa lu awọn ọkan awọn eniyan latari titobi ibẹru rẹ.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101002.mp3"></audio> 2- <span class="c4">{Mal qāri‘ah 2}</span>: Ki ni n jẹ asiko yii ti yio maa lu awọn ọkan awọn eniyan latari titobi ibẹru rẹ?<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101003.mp3"></audio> 3- <span class="c4">{Wa mā adrāka mal qāri‘ah 3}</span>: Ki lo mu ọ mọ - irẹ Ojiṣẹ - nkan ti n jẹ asiko yii ti yio maa lu awọn ọkan awọn eniyan latari titobi ibẹru rẹ? Dajudaju oun ni ọjọ igbedide.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101004.mp3"></audio> 4- <span class="c4">{Yaoma yakūnun nāsu kal farāshil mabthūth 4}</span>: Ọjọ ti yio maa lu awọn ọkan awọn eniyan, wọn o waa da gẹ́gẹ́ bí afopina ti wọn fọnka síhìn-ín sọ́hùn-ún.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101005.mp3"></audio> 5- <span class="c4">{Wa takūnul jibālu kal ‘ihnil manfūsh 5}</span>: Ati pe awọn oke o wa da gẹgẹ bii òwú ti wọn fi kùmọ̀ lù ki o le lẹ̀, látara yíyára rẹ.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101006.mp3"></audio> 6- <span class="c4">{Fa ammā man thaqulat mawāzīnuhu 6}</span>: Amọ ẹni tí awọn iṣẹ rere rẹ ba tẹsunwọn ju awọn iṣẹ aburu rẹ lọ.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101007.mp3"></audio> 7- <span class="c4">{Fa huwa fī ‘īshatin rādiyah 7}</span>: Nitori naa oun o maa bẹ ninu isẹmi kan ti yio yọ ọ ninu ti yio maa ri i ninu aljanna.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101008.mp3"></audio> 8- <span class="c4">{Wa ammā man khaffat mawāzīnuhu 8}</span>: Amọ ẹniti awọn iṣẹ aburu rẹ ba tẹsunwọn ju awọn iṣẹ rere rẹ lọ.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101009.mp3"></audio> 9- <span class="c4">{Fa ummuhu hāwiyah 9}</span>: Ibugbe rẹ ati ibudo rẹ ni ọjọ Igbedide ni Jahannama.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101010.mp3"></audio> 10- <span class="c4">{Wa mā adrāka mā hiyah 10}</span>: Ki ni o mu ọ mọ - irẹ Ojiṣẹ - nkan naa?!<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/101011.mp3"></audio> 11- <span class="c4">{Nārun hāmiyah 11}</span>: Oun ni ina kan ti igbona rẹ le gidi. </p>',
            ],
            4 => [
                'question' => 'Ibeere 5: Ka Sūratut Takāthur ki o si ṣe alaye rẹ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7610.mp3',
                'answer' => '<p> Idahun-<span class="c6"> Sūratut Takāthur ati itumọ rẹ:</span><br /> "BismiLlāhir Rahmānir Rahīm"<br /> <span class="c4">{’Alhākumut takāthur 1" "Hattā zurtumul maqābir 2" "Kallā saofa ta‘lamūn 3" "Thumma Kallā saofa ta‘lamūn 4" "Kallā lao ta‘lamūna ‘ilmal yaqīn 5" "La tarawunnal jahīm 6" "Thumma la tarawunnahā ‘aynal yaqīn 7" " Thumma la tus’alunna yaoma’idhi ‘anin na‘īm 8}</span> "<span class="c5">[Sūratut Takāthur: 1 - 8]</span>"<br /> Alaye:<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102001.mp3"></audio> 1- <span class="c4">{’Alhākumut takāthur 1}</span>: Imaa ṣe iyanran pẹlu awọn dukia ati awọn ọmọ ti ko airoju ba yin - ẹyin eniyan - kuro nibi itẹle Ọlọhun.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102002.mp3"></audio> 2- <span class="c4">{Hattā zurtumul maqābir 2}</span>: Titi ti ẹ fi ku ti ẹ si wọ inu awọn sàréè yin.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102003.mp3"></audio> 3- <span class="c4">{Kallā saofa ta‘lamūn 3}</span>: Ko yẹ fun yin ki iṣe iyanran yin pẹlu rẹ <span class="c2">(awọn dukia ati ọmọ)</span> o ko airoju ba yin kuro nibi itẹle Ọlọhun, ẹ maa pada mọ atunbọtan ikoairoju yẹn.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102004.mp3"></audio> 4- <span class="c4">{Thumma Kallā saofa ta‘lamūn 4}</span>: Lẹyin naa ẹ maa mọ atunbọtan rẹ.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102005.mp3"></audio> 5- <span class="c4">{Kallā lao ta‘lamūna ‘ilmal yaqīn 5}</span>: Ododo ni ka ni pe ẹ mọ ni amọdaju wipe wọn yio gbe yin dide si ọdọ Ọlọhun, ati pe Yio san yin ni ẹsan awọn iṣẹ yin, ẹ ko nii ko airoju pẹlu imaa ṣe iyanran pẹlu awọn dukia ati awọn ọmọ yin.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102006.mp3"></audio> 6- <span class="c4">{La tarawunnal jahīm 6}</span>: Mo fi Ọlọhun bura ẹ maa ri ina ni ọjọ Igbedide.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102007.mp3"></audio> 7- <span class="c4">{Thumma la tarawunnahā ‘aynal yaqīn 7}</span>: Lẹyin naa ẹ maa ri i ni riri ti o daju ti ko si iyemeji nibẹ.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/102008.mp3"></audio> 8- <span class="c4">{Thumma la tus’alunna yaoma’idhin ‘anin na‘īm 8}</span>: Lẹyin naa Ọlọhun o maa bi yin leere ni ọjọ yẹn nipa nkan ti o fi ṣe idẹra le yin lori ninu alaafia ati ọrọ ati nkan miran yatọ si mejeeji. </p>',
            ],
            5 => [
                'question' => 'Ibeere 6: Ka Sūratul Asri ki o si ṣe alaye rẹ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7750.mp3',
                'answer' => '<p> Idahun-<span class="c6"> Sūratul Asri ati alaye rẹ:</span><br /> "BismiLlāhir Rahmānir Rahīm"<br /> <span class="c4">{Wal Asri 1 " "Innal insāna lafī khusri 2" "Illāl Ladhīna ’āmanū wa ‘amilus sālihāti wa tawāsao bil haqqi watawāsao bis sobr 3}</span>" <span class="c5">[Suuratul-<span class="c6">Asr:</span> 1-3]</span>.<span class="c6"><br /> Alaye:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/103001.mp3"></audio> 1- <span class="c4">{Wal Asri 1}</span>: Ọba ti mimọ n bẹ fun bura pẹlu igba.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/103002.mp3"></audio> 2- <span class="c4">{Innal insāna lafī khusri 2}</span>: itumọ rẹ ni pe: Gbogbo eeyan n bẹ ninu adinku ati iparun.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/103003.mp3"></audio> 3- <span class="c4">{Illāl Ladhīna ’āmanū wa ‘amilus soolihaat wa tawāṣao bil haqqi watawāṣao biṣ ṣobr 3}</span>: Ayaafi ẹniti o ba ni igbagbọ ti o si tun ṣe iṣẹ rere, pẹlu iyẹn wọn tun pepe lọ si idi ododo ti wọn si tun ṣe suuru lori rẹ, nitori naa awọn wọnyii ni wọn ti la kuro ninu ofo. </p>',
            ],
            6 => [
                'question' => 'Ibeere 7: Ka Sūratul Humazah ki o si ṣe alaye rẹ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7830.mp3',
                'answer' => '<p> Idahun-<span class="c6"> Sūratul Humazah ati alaye rẹ:</span><br /> "BismiLlāhir Rahmānir Rahīm"<br /> "<span class="c4">{Wailul-likulli humazatil-lumazah 1 " "Allazee jama’a maalan wa ‘addadah 2 " "Yahsabu anna maalahuu akhladah 3 " "Kallaa; layumbazanna fil hutamah 4 " "Wa maa adrọọka mal-hutọma 5 " "Naarul Lọọhil mu\'kọdah 6 " "Allatii tattọlihu ‘alal af’hidah 7 " "Innahaa ‘alaihim muh’sọdah 8 " "Fii ‘amadim mumaddadah 9}</span> " <span class="c5">[Surah Al-Humazah 1 - 9]</span>.<span class="c6"> "<br /> "Alaye:</span> "<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104001.mp3"></audio> "1- <span class="c4">{Wailul-likulli humazatil-lumazah 1}</span>: Àtúbọ̀tán to buru ati iya to le koko n bẹ fun ẹni ti o pọ ni ọrọ-ẹyin fun àwọn eeyan ati biba wọn jẹ. "<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104002.mp3"></audio> "2- <span class="c4">{Allazee jama’a maalan wa ‘addadah 2}</span>: Ẹni ti o jẹ pe ironu rẹ ni kiko owo jọ ati kika a, ko si ironu miiran fun un yatọ si iyẹn. "<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104003.mp3"></audio> 3- <span class="c4">{Yahsabu anna maalahooo akhladah 3}</span>: Ti o n ro pe dajudaju owo rẹ eyi to jẹ pe o kojọ pe yio la a kuro nibi iku, ti yo wa maa ṣe gbere ni isẹmi aye. "<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104004.mp3"></audio> "4- <span class="c4">{Kallaa; layumbazanna fil hutamah 4}</span>: Ọ̀rọ̀ kii ṣe bi alaimọkan yii ṣe ro, dajudaju wọn maa ju u sinu ina jahannamọ eyi ti o maa n run gbogbo nnkan ti wọn ba ju síbẹ̀ nitori ilekoko agbara to n bẹ fun un. "<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104005.mp3"></audio> "5- <span class="c4">{Wa maa adraaka mal-hutamah 5}</span>: Ki ni o mu ọ mọ̀ -iwọ Ojiṣẹ- ki ni ina yii to jẹ pe o maa n run gbogbo nnkan ti wọn ba ju síbẹ̀?! "<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104006.mp3"></audio> "6- <span class="c4">{Naarul laahil-mooqada 6}</span>: Dajudaju oun ni ina Ọlọhun ti o n jò geregere"<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104007.mp3"></audio> "7- <span class="c4">{Allatee tattali’u ‘alal af’idah 7}</span>: Èyí to jẹ pe o maa n ti inú ara àwọn èèyàn bọ sinu awọn ọkan wọn. "<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104008.mp3"></audio> "8- <span class="c4">{Innahaa ‘alaihim mu’sada 8}</span>: Dajudaju wọn maa ti i mọ awọn ti a n fi iya jẹ. "<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/104009.mp3"></audio> "9- <span class="c4">{Fee ‘amadin mumaddadah 9}</span>: Pẹ̀lú àwọn òpó kìrìbìtì ti wọn gùn ti wọn ko fi nii le jáde kúrò nibẹ. </p>',
            ],
            7 => [
                'question' => '"Ibeere kẹjọ: Ka Suuratul Fiil, ki o si ṣe alaye ẹ? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/7970.mp3',
                'answer' => '<p> "Idahun-<span class="c6"> Suuratul Fiil ati alaye ẹ:</span> "<br /> "Bismillah hir Rahman nir Raheem "<br /> "<span class="c4">{Alam tara kaifa fa’ala rabbuka bi as’haabil feel 1 " "Alam yaj’al kaidahum fee tadleel 2 " "Wa arsala ‘alayhim tayran ’abābīl 3" "Tarmīhim bi hijāratim min sijjīl 4" " Fa ja‘alahum ka ‘asfin ma’kūl 5}</span> * <span class="c5">[Sūratul Fīl: 1 - 5]</span>.<br /> Alaye<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105001.mp3"></audio> 1- <span class="c4">{Alam tarọ kayfa fa‘ala Rọbbuka bi as’haabil fīl 1}</span>: Ṣe o o wa mọ - irẹ ojiṣẹ- bi Oluwa rẹ ṣe ṣe Abrahatu ati awọn eeyan rẹ awọn eleerin nigba ti won fẹ wo ka‘bah?!<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105002.mp3"></audio> 2- <span class="c4">{Alam yaj‘al kaydahum fī tadlīl 2}</span>: Ọlọhun ti sọ ìpètepèrò aburu wọn lati wo o di anu, ọwọ wọn ko si tun tẹ nkan ti wọn fẹ lati siju awọn eeyan kuro ni ka‘bah, ọwọ wọn ko si tẹ nkankan ninu rẹ.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105003.mp3"></audio> 3- <span class="c4">{Wa arsala ‘alayhim tayran ’abābīl 3}</span>: O si tun gbe awọn ẹyẹ kan dide si wọn ti wọn wa ba wọn nijọnijọ.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105004.mp3"></audio> 4- <span class="c4">{Tarmīhim bi hijāratin min sijjīl 4}</span>: Ti wọn n ju wọn ni oko lati ara amọ̀ ti o le bii òkúta.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/105005.mp3"></audio> 5- <span class="c4">{Fa ja‘alahum ka ‘asfin ma’kūl 5}</span>: Ọlọhun wa ṣe wọn gẹ́gẹ́ bí ewe irugbin ti awọn ẹranko ti jẹ ẹ ti o si tun ti tẹ ẹ mọlẹ. </p>',
            ],
            8 => [
                'question' => 'Ibeere 9: Ka Sūratu Quraysh ki o si ṣe alaye rẹ?.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8070.mp3',
                'answer' => '<p> Idahun-<span class="c6"> Sūratu Quraysh ati alaye rẹ:</span><br /> "BismiLlāhir Rahmānir Rahīm"<br /> "<span class="c4">{Li ’īlāfi Quraysh 1 " "’Īlāfihim rihlatash shitā’i was sayf 2" " Fal ya‘budū robba hādhal bayt 3" "Allādhī ’at‘amahum min jū‘in wa āmanahum min khaof 4}</span> <span class="c5">[Sūratu Quraysh 1 - 4]</span>.<span class="c6"><br /> Alaye:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106001.mp3"></audio> 1- <span class="c4">{Li ’īlāfi Quraysh 1}</span>: Itumọ iyẹn ni nkan ti wọn ti ba saaba ni ṣiṣe irin-ajo ni asiko ọyẹ ati ni asiko ooru.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106002.mp3"></audio> 2- <span class="c4">{’Īlāfihim rihlatash shitā’i was sayf 2}</span>: Irin-ajo asiko ọyẹ lọ sí ilu Yemen, ati irin-ajo asiko ooru lọ sí ilu Shām lẹniti ọkan wọn balẹ.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106003.mp3"></audio> 3- <span class="c4">{Fal ya‘budū robba hādhal bayt 3}</span>: Ki wọn yaa maa sin Allāhu Oluwa ile abọwọ yii ni Oun nikan ṣoṣo, Ẹnití O ṣe irin-ajo yii ni irọrun fun wọn, ti wọn o si gbọdọ mu nkankan mọ Ọn ni orogun.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/106004.mp3"></audio> 4- <span class="c4">{Allādhī ’at‘amahum min jū‘in wa āmanahum min khaof 4}</span>: Ẹniti maa n fun wọn ni jijẹ ninu ẹbi, ti si maa n fi ọkan wọn balẹ ninu ipaya, pẹlu nkan ti O fi si awọn ọkan awọn larubawa ni imaa gbe ile abọwọ naa tobi, ati imaa gbe awọn olugbe ibẹ tobi. </p>',
            ],
            9 => [
                'question' => 'Ibeere 10: Ka Sūratul Mā‘ūn ki o si ṣe alaye rẹ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8160.mp3',
                'answer' => '<p> Idahun-<span class="c6"> Sūratul Mā‘ūn ati alaye rẹ:</span><br /> "BismiLlāhir Rahmānir Rahīm"<br /> "<span class="c4">{Ara’aytal ladhī yukaddhibu bid dīn 1" "Fa dhālikal ladhī yaduhhul yatīm 2" "Walā yahuddu ‘alā ta‘āmil miskīn 3" "Fa waylun lil musọlliin 4" "Allādhīna hum ‘an sọlaatihim sāhūn 5" "Alladhīna hum yurā’ūn 6" "Wa yamna‘ūnal mā‘ūn 7}</span>" "<span class="c5">[Sūratul Mā‘ūn: 1 - 7]</span>.<span class="c6"><br /> Alaye:</span><br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107001.mp3"></audio> 1- <span class="c4">{Ara’aytal ladhī yukaddhibu bid dīn 1}</span>: Njẹ o mọ ẹni tí maa n pe ẹsan ti ọjọ Igbedide ni irọ.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107002.mp3"></audio> 2- <span class="c4">{Fa dhālikal ladhī yaduhhul yatīm 2}</span>: Oun ni ẹni naa ti maa n fi agbara le ọmọ orukan danu kuro nibi gbigbọ bukaata rẹ.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107003.mp3"></audio> 3- <span class="c4">{Walā yahuddu ‘alā ta‘āmil miskīn 3}</span>: Ko si ki n ṣe ẹmi rẹ ni ojukokoro, ko si tun ki n ṣe ẹlomiran ni ojukokoro lori fifun alaini ni ounjẹ.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107004.mp3"></audio> 4- <span class="c4">{Fa waylun lil musalliin 4}</span>: Nitori naa iparun ati iya ko maa bẹ fun awọn kirunkirun.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107005.mp3"></audio> 5- <span class="c4">{Allādhīna hum ‘an salaatihim sāhūn 5}</span>: Awọn ti wọn maa n gbagbera kuro nibi Irun wọn, ti wọn o si ki n bikita pẹlu rẹ titi ti asiko rẹ o fi lọ.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107006.mp3"></audio> 6- <span class="c4">{Alladhīna hum yurā’ūn 6}</span>: Awọn ti wọn maa n ṣe ṣekarimi pẹlu Irun wọn ati awọn iṣẹ wọn, wọn o si ki n mọ iṣẹ kanga fun Ọlọhun.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/107007.mp3"></audio> 7- <span class="c4">{Wa yamna‘ūnal mā‘ūn 7}</span>: Wọn o si maa kọ lati ṣe iranlọwọ fun ẹni tí o yatọ si wọn pẹlu nkan ti ko si inira kankan nibi ṣiṣe iranlọwọ pẹlu rẹ. </p>',
            ],
            10 => [
                'question' => 'Ibeere 11: Ka Sūratul Kaothar ki o si ṣe alaye rẹ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8280.mp3',
                'answer' => '<p> Idahun-<span class="c6"> Sūratul Kaothar ati alaye rẹ:</span><br /> " BismiLlāhir Rahmānir Rahīm "<br /> <span class="c4">{Innā a‘taynākal kaothar 1 " " Fa salli li robbika wanhar 2 " " Inna shāni’aka huwal ’abtar 3}</span> " <span class="c5">[Suuratul-<span class="c6">Kawthar:</span> 1-3]</span>.<br /> Alaye<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/108001.mp3"></audio> 1- <span class="c4">{Innā a‘taynākal kaothar 1}</span>: Dajudaju Awa ni A fun ọ - irẹ Ojiṣẹ - ni oore ti o pọ, ninu rẹ naa si ni abata Kaothar ninu al-Jannah.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/108002.mp3"></audio> 2- <span class="c4">{Fa salli li robbika wanhar 2}</span>: Nitori naa dúpẹ́ fun Ọlọhun rẹ lori idẹra yii, pẹlu ki o kirun fun Un ki o si pa ẹran fun Un ni Oun nikan ṣoṣo, yatọ si nkan ti awọn ọṣẹbọ maa n ṣe nibi imaa wa asunmọ awọn oriṣa wọn pẹlu pipa nkan fun wọn.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/108003.mp3"></audio> 3- <span class="c4">{Inna shāni’aka huwal ’abtar 3}</span>: Dajudaju ẹniti ba n binu rẹ <span class="c2">(korira rẹ)</span> oun ni ẹniti o ja kuro nibi gbogbo daadaa, ẹni igbagbe ti o ṣe wipe ti wọn ba ranti rẹ wọn o ranti rẹ pẹlu aburu ni. </p>',
            ],
            11 => [
                'question' => 'Ibeere 12: Ka Sūratul Kāfirūn ki o si ṣe alaye rẹ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8360.mp3',
                'answer' => '<p> Idahun-<span class="c6"> Sūratul Kāfirūn ati alaye rẹ:</span><br /> "BismiLlāhir Rahmānir Rahīm"<br /> "<span class="c4">{Qul yā ayyuhal kāfirūn 1" "Lā a‘budu mā ta‘budūn 2" "Walā ’antum ‘ābidūna mā a‘budu 3" "Walā anā ‘ābidun mā ‘abadtum 4" "Walā ’antum ‘ābidūna mā a‘budu 5" "Lakum dīnukum waliya dīni 6}</span>" <span class="c5">[Suuratul-<span class="c6">Kafirun:</span> 1-6]</span>.<br /> Alaye<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109001.mp3"></audio> 1- <span class="c4">{Qul yā ayyuhal kāfirūn 1}</span>: Sọ - irẹ Ojiṣẹ - pe mo pe ẹyin ti ẹ ṣe aigbagbọ pẹlu Ọlọhun.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109002.mp3"></audio> 2- <span class="c4">{Lā a‘budu mā ta‘budūn 2}</span>: Mi o nii sin nkan ti ẹ n sin ni awọn oriṣa lọwọlọwọ báyìí ati ni ọjọ iwaju.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109003.mp3"></audio> 3- <span class="c4">{Walā ’antum ‘ābidūna mā a‘budu 3}</span>: Ati pe ẹyin o nii sin nkan ti emi n sin, Oun naa ni Allāhu ni Oun nikan ṣoṣo.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109004.mp3"></audio> 4- <span class="c4">{Walā anā ‘ābidun mā ‘abadtum 4}</span>: Ati pe emi o nii sin nkan ti ẹ n sin ni awọn oriṣa.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109005.mp3"></audio> 5- <span class="c4">{Walā ’antum ‘ābidūna mā a‘budu 5}</span>: Ati pe ẹyin o nii sin nkan ti emi n sin, Oun naa ni Allāhu ni Oun nikan ṣoṣo.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/109006.mp3"></audio> 6- <span class="c4">{Lakum dīnukum waliya dīni 6}</span>: Ti yin ni ẹsin yin ti ẹ da silẹ funra yin, temi naa si ni ẹsin mi ti Ọlọhun sọkalẹ fun mi. </p>',
            ],
            12 => [
                'question' => 'Ibeere 13: Ka Sūratun Nasr ki o si ṣe alaye rẹ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8470.mp3',
                'answer' => '<p> Idahun-<span class="c6"> Sūratun Nasr ati alaye rẹ:</span><br /> "BismiLlāhir Rahmānir Rahīm"<br /> "<span class="c4">{Idhā jā’a nasrul Lāhi wal fath 1" "Wa ra’aytan nāsa yadkhulūna fī dīnil Lāhi afwājā 2" "Fa sabbih bi hamdi rabbika wastagfirhu innahu kāna tawwābā 3}</span>" "<span class="c5">[Sūratun Nasri: 1 - 3]</span>"<br /> Alaye:<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/110001.mp3"></audio> 3- <span class="c4">{Idhā jā’a nasrul Lāhi wal fath 1}</span>: Ti aranse Ọlọhun ba ti de fun ẹsin rẹ - irẹ Ojiṣẹ -, ati fífún un ní agbára, ti ṣiṣi Mẹka si ṣẹlẹ.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/110002.mp3"></audio> 2- <span class="c4">{Wa ra’aytan nāsa yadkhulūna fī dīnil Lāhi afwājā 2}</span>: Wàá ri awọn eeyan ti wọn o maa wọ inu Isilaamu ni ikọ kan lẹyin ikọ miran.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/110003.mp3"></audio> 3- <span class="c4">{Fa sabbih bi hamdi rabbika wastagfirhu innahu kāna tawwābā 3}</span>: Lọ mọ wipe dajudaju iyẹn ami ipari iṣẹ ti wọn tori rẹ gbe ọ dide ni, nitori naa ṣe afọmọ pẹlu fifi ẹyin fun Oluwa rẹ, ki o fi wa aforijin lọdọ rẹ, dajudaju Oun ni Olugba-tuuba ti maa n gba tuuba awọn ẹrusin Rẹ, ti si tun maa n ṣe aforijin fun wọn. </p>',
            ],
            13 => [
                'question' => 'Ibeere 14: Ka Sūratul Masad ki o si ṣe alaye rẹ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8550.mp3',
                'answer' => '<p> Idahun-<span class="c6"> Sūratul Masad ati alaye rẹ:</span><br /> "BismiLlāhir Rahmānir Rahīm"<br /> <span class="c4">{Tabbat yadā abī lahabin wa tabba 1" "Mā agnā ‘anhu māluhu wa mā kasaba 2" "Sa yaslaa nāran dhāta lahab 3" "Wamra’atuhu hammālatal hatab 4" "Fī jīdihā hablun min masad 5}</span> "<span class="c5">[Sūratul Masad: 1 - 5]</span>"<br /> Alaye<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111001.mp3"></audio> 1- <span class="c4">{Tabbat yadā abī lahabin wa tabba 1}</span>: Ọwọ mejeeji ọmọ-ìyá baba Anabi - ki ikẹ ati ọla Ọlọhun maa ba a - tii ṣe Abu Lahabi ọmọ Abdul Muttalib ti p\'ofo latari ipofo iṣẹ rẹ, nitori pe o maa n fi suta kan Anabi - ki ikẹ ati ọla Ọlọhun maa ba a -, nitori naa wahala rẹ ja si ofo.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111002.mp3"></audio> 2- <span class="c4">{Mā agnā ‘anhu māluhu wa mā kasaba 2}</span>: Ki ni nkan ti dukia ati ọmọ rẹ fi ṣe e ni anfaani? Wọn o lee ti iya danu fun un, bẹẹ si ni wọn o lee fa ikẹ wa fun un.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111003.mp3"></audio> 3- <span class="c4">{Sa yaslaa nāran dhāta lahab 3}</span>: Yio si wọ ina eléjò fòfò, ti yoo maa fojú winá ooru rẹ.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111004.mp3"></audio> 4- <span class="c4">{Wamra’atuhu hammālatal hatab 4}</span>: Iyawo rẹ Ummu Jamīl naa o wọ ọ <span class="c2">(ina)</span>, ẹniti o ṣe wipe o maa n ni Anabi lara pẹlu dida ẹgun si oju-ọna rẹ.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/111005.mp3"></audio> 5- <span class="c4">{Fī jīdihā hablun min masad 5}</span>: Okun kan ti wọn lọ yanjú <span class="c2">(daadaa)</span> wa ni orun rẹ ti wọn o fi wọ ọ lọ si inu ina. </p>',
            ],
            14 => [
                'question' => 'Ibeere 15: Ka Sūratul Ikhlās ki o si ṣe alaye rẹ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8650.mp3',
                'answer' => '<p> Idahun-<span class="c6"> Sūratul Ikhlās ati alaye rẹ:</span><br /> "BismiLlāhir Rahmānir Rahīm"<br /> "<span class="c4">{Qul Uwa Allāhu Ahad 1" "Allāhus Sọmad 2" "Lam yalid wa lam yūlad 3" "Wa lam yakun lahu kufwan ahad}</span>" "<span class="c5">[Sūratul Ikhlās: 1 - 4]</span>"<br /> Alaye<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112001.mp3"></audio> 1- <span class="c4">{Qul Uwa Allāhu Ahad 1}</span>: Sọ - irẹ Ojiṣẹ -: Oun ni Ẹniti ijọsin tọ si, ko si ẹlomiran ti ijọsin tọ si yatọ si I.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112002.mp3"></audio> 2- <span class="c4">{Allāhus Sọmad 2}</span>: Itumọ rẹ ni pe: Ọdọ Rẹ ni wọn maa n gbe awọn bukaata awọn ẹda lọ.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112003.mp3"></audio> 3- <span class="c4">{Lam yalid wa lam yūlad}</span>: Ko si ọmọ fun Un ko si si baba <span class="c2">(mimọ n bẹ fun Un)</span>.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/112004.mp3"></audio> 4- <span class="c4">{Wa lam yakun lahu kufwan ahad 4}</span>: Ko si ẹniti o jọ ọ ninu awọn ẹda Rẹ. </p>',
            ],
            15 => [
                'question' => 'Ibeere 16: Ka Sūratul Falaq, ki o si ṣe alaye rẹ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8750.mp3',
                'answer' => '<p> Idahun-<span class="c6"> Sūratul Falaq ati alaye rẹ:</span><br /> "BismiLlāhir Rahmānir Rahīm"<br /> "<span class="c4">{Qul a‘ūdhu bi robbil falaq 1" "Min sharri mā khalaqa 2" "Wa min sharri gāsiqin idhā waqaba 3" "Wa min sharrin naffāthāti fil ‘uqad 4" "Wa min sharri hāsidin idhā hasada 5}</span>" "<span class="c5">[Sūratul Falaq: 1 - 5]</span>"<br /> Alaye<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113001.mp3"></audio> 1- <span class="c4">{Qul a‘ūdhu bi robbil falaqi 1}</span>: Sọ pe - irẹ Ojiṣẹ - mọ wa iṣọra pẹlu Ọba owurọ, mo si wa ààbò pẹlu Rẹ.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113002.mp3"></audio> 2- <span class="c4">{Min sharri mā khalaqa 2}</span>: Nibi aburu nkan ti maa n fi suta kan eeyan ninu awọn ẹda Rẹ.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113003.mp3"></audio> 3- <span class="c4">{Wa min sharri gāsiqin idhā waqaba 3}</span>: Mo si tun wa isadi pẹlu Ọlọhun kuro nibi awọn aburu ti maa n han ni oru lati ọwọ awọn ẹranko ati awọn ole.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113004.mp3"></audio> 4- <span class="c4">{Wa min sharrin naffāthāti fil ‘uqad 4}</span>: Mo si tun dirọ mọ Ọn kuro nibi aburu àwọn opindan lóbìnrin ti wọn maa n fẹ atẹgun tuẹtuẹ si inu awọn koko.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/113005.mp3"></audio> 5- <span class="c4">{Wa min sharri hāsidin idhā hasada 5}</span>: Ati kuro nibi aburu oni keeta ti maa n binu wọn, nígbà tí o ba ṣe keeta wọn nibi nkan ti Ọlọhun fi ta wọn lọrẹ ninu idẹra, ti o n fẹ ki o yẹ kuro lọdọ wọn, ati ki aburu o ṣẹlẹ si wọn. </p>',
            ],
            16 => [
                'question' => 'Ibeere 17: Ka Sūratun Nās ki o si ṣe alaye rẹ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/8870.mp3',
                'answer' => '<p> Idahun-<span class="c6"> Sūratun Nās ati alaye rẹ:</span><br /> "BismiLlāhir Rahmānir Rahīm"<br /> "<span class="c4">{Qul a‘ūdhu bi robbin nās 1" "Malikin nās 2" "Ilāhin nās 3" "Min sharril waswāsil khannās 4" "Alladhī yuwaswisu fī suduurin nās 5" "Minal jinnati wan nās 6}</span>" "<span class="c5">[Sūratun Nās: 1 - 6]</span>"<br /> Alaye<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114001.mp3"></audio> 1- <span class="c4">{Qul a‘ūdhu bi robbin nās 1}</span>: Sọ- irẹ ojiṣẹ -<span class="c6"> pe:</span> Mo wa isadi pẹlu Ọba awọn ènìyàn, mo si tun wa aabo pẹlu Rẹ̀.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114002.mp3"></audio> 2- <span class="c4">{Malikin nās 2}</span>: O maa n ṣe nkan ti o ba wu u si wọn, ko si olukapa miran fun wọn yatọ si I.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114003.mp3"></audio> 3- <span class="c4">{Ilāhin nās 3}</span>: Ẹni tí wọn o maa jọsin fun lododo ni I, ti ko si si ẹni ti ìjọsìn tọ si fun wọn yàtọ̀ si I.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114004.mp3"></audio> 4- <span class="c4">{Min sharril waswāsil khannās 4}</span>: Kuro nibi aburu shaytān ti o maa n ju royiroyi rẹ si awọn eeyan.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114005.mp3"></audio> 5- <span class="c4">{Alladhī yuwaswisu fī suduurin nās 5}</span>: O maa n ju royiroyi rẹ si ọkan awọn ọmọniyan.<br /> <a href="javascript:;" onclick="$(\'audio\').hide();$(this).next(\'audio\').show()[0].play()"><img style="width:28px" src="https://kids.islamenc.com/assets/imgs/play.png"> </a><audio style="display:none;position:fixed;z-index:9999;left:0;bottom:50px;width:100%" controls src="https://everyayah.com/data/Hudhaify_64kbps/114006.mp3"></audio> 6- <span class="c4">{Minal jinnati wan nās 6}</span>: Ìtumọ̀ rẹ ni pé: Ẹniti maa n ko royiroyi báni le jẹ ninu awọn eeyan, o si le jẹ ninu awọn alujannu. </p>',
            ],
        ],
        5 => [
            0 => [
                'question' => 'Ibeere 1: Parí hadīth: «Innamal a‘mālu bin niyyaat...», ki o si tun sọ díẹ̀ nínú awọn anfaani rẹ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9030.mp3',
                'answer' => '<p> Idahun- Lati ọdọ alaṣẹ awọn olugbagbọ ododo tii ṣe baba Hafs, Umar ọmọ khatāb - ki Ọlọhun yọnu si i -<span class="c6"> o sọ pe:</span> Mo gbọ ti ojiṣẹ Ọlọhun - ki ikẹ ati ọla Ọlọhun maa ba a -<span class="c6"> n sọ pe:</span> <span class="c3">«Dajudaju gbogbo iṣẹ n bẹ pẹlu aniyan, ati pe gbogbo nkan ti ọmọniyan kọọkan ba gbero ni yio maa jẹ tiẹ, nitori naa ẹniti o ba ṣe hijirah tiẹ̀ nítorí ti Ọlọhun ati Ojiṣẹ Rẹ; yio gba ẹsan hijira rẹ nitori ti Ọlọhun ati Ojiṣẹ Rẹ, ẹniti o ba si ṣe hijirah tiẹ̀ nitori aye tabi nitori obinrin ti o fẹẹ fẹ; ẹsan hijirah rẹ o maa bẹ lori nkan ti o tori rẹ ṣe hijirah»</span>. Bukhārī ati Muslim ni wọn gba a wa.<span class="c6"><br /> Awọn anfaani inu Hadīth:</span><br /> 1- Ko si ibuyẹ fun gbogbo iṣẹ nibi aniyan, bii Irun, ati Aawẹ, ati Hajj, ati eyiti o yatọ si i ninu awọn iṣẹ.<br /> "2- Èèyàn gbọdọ̀ ni imọkanga nibi aniyan fun Ọlọhun.<span class="c6">"<br /> "Hadīth ẹlẹẹkeji:</span>" </p>',
            ],
            1 => [
                'question' => '"Ibeere 2: Pari hadīth «Man ’ahdatha fī amrinā hādhā ...», ki o si tun darukọ awọn anfaani rẹ?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9090.mp3',
                'answer' => '<p> "Idahun- Lati ọdọ iya gbogbo Mu’mini Umu Abdullāhi ‘Āishah ki Ọlọhun yọnu si i,<span class="c6"> o sọ pe:</span> Ojiṣẹ Ọlọhun - ki ikẹ ati ọla Ọlọhun maa ba a -<span class="c6"> sọ pe:</span>" "<span class="c3">«Ẹniti o ba da adadaalẹ ni inu alamọri yii ti ko si ninu rẹ, yio jẹ adapada fun un»</span>" Bukhaari ati Muslim ni wọn gba a wa<br /> "Awọn anfaani lati inu Hadīth yii:"<br /> "1- kikọ kuro nibi adadaalẹ ninu ẹsin"<br /> "2-<span class="c6"> Ati pe dajudaju gbogbo iṣẹ ti o jẹ adadaalẹ nkan ti wọn o da pada ni ti ko nii jẹ atewọgba"<br /> "Hadīth ẹlẹẹkẹta:</span>" </p>',
            ],
            2 => [
                'question' => 'Ibeere 3: Parí hadiisi (baenamaa nahnu juluusun inda rọsuulullaahi- solla Loohu alaehi wa sallam-) ki o si sọ díẹ̀ nínú àwọn anfaani rẹ.',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9160.mp3',
                'answer' => '<p> "Idahun- Lati ọdọ Umar ọmọ Khataab- ki Ọlọhun yọnu si i-<span class="c6"> o sọ pe:</span> Láàrin ìgbátí a jókòó si ọdọ ojiṣẹ Ọlọhun - ki ikẹ ati ọla Ọlọhun maa ba a - ni ọjọ kan, arakunrin kan yọ si wa ti asọ rẹ funfun gbòò, irun ori rẹ si dudu kirikiri, a o si ri apẹrẹ arìnrìn-àjò lara rẹ, ẹnikankan o si mọ ọn ninu wa, titi ti o fi jókòó ti Anabi - ki ikẹ ati ọla Ọlọhun maa ba a -, o wa fi orunkun rẹ mejeeji ti orunkun rẹ <span class="c2">(Anabi)</span>, o si tun gbe ọwọ rẹ mejeeji le ori itan rẹ mejeeji,<span class="c6"> o wa sọ pe:</span> <span class="c3">«Irẹ Muhammad, fun mi ni iro nipa Isilaamu»</span>,<span class="c6"> o wa sọ fun un pe:</span> <span class="c3">«Nkan ti n jẹ Isilaamu ni: ki o jẹrii wipe ko si ẹniti ijọsin ododo tọ si ayaafi Allāhu, ati pe dajudaju Muhammad Ojiṣẹ Rẹ ni, ki o si maa gbe Irun duro, ki o si tun maa yọ Zakah, ki o tun maa gba Aawẹ Ramadan, ki o si tun lọ si Ile Ọlọhun ti o ba kapa ọna atilọ»</span>,<span class="c6"> o sọ pe:</span> <span class="c3">«ododo ni o sọ»</span>, o waa ya wa lẹnu fun un pe oun ni n bi i leere oun naa ni o tun n fi ododo rẹ rinlẹ,<span class="c6"> o sọ pe:</span> «Fún mi ni iro nipa ’Īmān <span class="c2">(Igbagbọ)</span>»,<span class="c6"> o sọ pe:</span> <span class="c3">«ki o ni igbagbọ ninu Ọlọhun, ati awọn Malaika Rẹ, ati awọn Tira Rẹ, ati awọn Ojiṣẹ Rẹ, ati ọjọ ikẹhin, ki o si tun ni igbagbọ ninu kadara, daadaa rẹ ni abi aburu rẹ»</span>,<span class="c6"> o sọ pe:</span> <span class="c3">«ododo ni o sọ»</span>,<span class="c6"> o sọ pe:</span> <span class="c3">«Fún mi ni iro nipa ’Ihsān»</span>,<span class="c6"> o sọ pe:</span> <span class="c3">«ki o maa sin Ọlọhun bi wipe o n ri I, ti o o ba ri I, dajudaju Oun n ri ọ»</span>,<span class="c6"> o sọ pe:</span> «Fún mi ni iro nipa As Sā‘ah <span class="c2">(Igbẹyin aye)</span>»,<span class="c6"> o sọ pe:</span> <span class="c3">«ki ẹrubinrin o maa bi olowo rẹ, ki o si tun maa ri awọn ti wọn ko nii wọ bàtà, ati awọn arinhoho, ati awọn alaini awọn adaranjẹ, ti wọn a maa kọ awọn ile giga ni ti ìdíje»</span> lẹyin naa ni o wa lọ, mo wa ṣe suuru fun igba diẹ, lẹyin naa,<span class="c6"> o wa sọ pé:</span> <span class="c3">«Irẹ Umar, njẹ o mọ onibeere yẹn?»</span>,<span class="c6"> mo sọ pe:</span> "Ọlọhun ati Ojiṣẹ Rẹ nikan ni wọn ni imọ julọ",<span class="c6"> o sọ pe:</span> <span class="c3">«Jibrīlu ni, o wa ba yin lati fi ẹsin yin mọ yin»</span>" Muslim ni o gba a wa.<span class="c6"><br /> "Ninu awọn anfaani inu Hadīth yii:</span>"<br /> 1- Didarukọ awọn origun Isilaamu maraarun,<span class="c6"> awọn naa ni:</span><br /> "Ijẹrii pe ko si ẹniti ijọsin tọ si l\'ododo ayaafi Allāhu, ati pe dajudaju Muhammad ojiṣẹ Rẹ ni"<br /> "Ati gbigbe Irun duro"<br /> "Ati yiyọ Zakah"<br /> "Ati gbigba aawẹ Ramadan"<br /> "Ati ṣíṣe hajj lọ si ile Ọlọhun abeewọ"<br /> 2- Didarukọ awọn origun igbagbọ,<span class="c6"> mẹfa ni:</span><br /> "Nini igbagbọ ninu Ọlọhun"<br /> "Ati awọn malaika Rẹ"<br /> "Ati awọn tira Rẹ"<br /> "Ati awọn ojiṣẹ Rẹ"<br /> Ati ọjọ ikẹyin."<br /> Ati kadara, eyi ti o daa nibẹ ati eyi ti o buru nibẹ."<br /> "3- Didarukọ origun ṣíṣe dáadáa, origun kan ni, oun ni ki o maa jọsin fun Ọlọhun gẹgẹ bii pe o n ri I, ti o o ba ri I, dajudaju Oun n ri ẹ."<br /> "4- Asiko ọjọ igbedide, ko si ẹni kan kan ti o ni imọ nipa ẹ afi Ọlọhun -ti ọla Rẹ ga-.<span class="c6"> "<br /> "Hadisi ẹlẹẹkẹrin:</span> " </p>',
            ],
            3 => [
                'question' => '"Ibeere ẹlẹẹkẹrin: Parí hadisi “ẹni ti o pe ju ni ìgbàgbọ́ nínú àwọn mumini…”, ki o si darukọ diẹ ninu awọn anfaani ẹ?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9360.mp3',
                'answer' => '<p> "Idahun- lati ọdọ Abu Hurayra -ki Ọlọhun yọnu si i-<span class="c6"> o sọ pe:</span> Ojisẹ Ọlọhun -ki ikẹ Ọlọhun ati ọla Rẹ maa ba a-<span class="c6"> sọ pe:</span> " <span class="c1">“Ẹni ti o pe julọ ninu awọn mumini ni igbagbọ: Ni ẹni ti o dára julọ ninu wọn ni iwa”</span>. "Tirmidhi ni o gba a wa,<span class="c6"> o wa sọ pe:</span> <span class="c1">“Hadiisi to daa ni to ni alaafia".<br /> "Awọn anfaani to wa ninu hadiisi naa”</span><br /> "1- Iṣenilojukokoro si iwa dáadáa. "<br /> "2- Dajudaju pipe iwa wa ninu pipe igbagbọ. "<br /> 3- Igbagbọ a maa lekun a si maa dikun. "<br /> "Hadisi karun-<span class="c6">un:</span> " </p>',
            ],
            4 => [
                'question' => '"Ibeere ẹlẹẹkarun-un: Parí hadiisi: “Ẹni ti o ba bura pẹlu nnkan to yatọ si Ọlọhun....”, ki o si darukọ diẹ ninu awọn anfaani ẹ?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9440.mp3',
                'answer' => '<p> "Idahun- lati ọdọ Ibn Umar -ki Ọlọhun yọnu si awọn mejeeji- dajudaju Anabi- ki ikẹ Ọlọhun ati ọla Rẹ maa ba a-<span class="c6"> sọ pe:</span> " <span class="c1">“Ẹni ti o ba bura pẹlu nnkan to yatọ si Ọlọhun; ti ṣe aigbagbọ tabi da ẹbọ pọ mọ Ọlọhun”</span>.<span class="c6">" Tirmidhiy ni o gba a wa<br /> "Awọn anfaani to wa ninu hadiisi naa:</span> "<br /> "1- Bibura ko tọ afi pẹlu Ọlọhun -ti ọla Rẹ ga- "<br /> "2- Bibura pẹlu nnkan to yatọ si Ọlọhun wa ninu ẹbọ kekere.<span class="c6">"<br /> "Hadiisi kẹfa:</span> " </p>',
            ],
            5 => [
                'question' => '"Ibeere ẹlẹẹkẹfa: Parí Hadiisi: “Ẹnikẹ́ni ninu yin o ni tii di olugbagbọ titi maa fi di ẹni ti o ni ifẹ si julọ....” ki o si darukọ diẹ ninu awọn anfaani ẹ? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9510.mp3',
                'answer' => '<p> "Idahun- lati ọdọ Anas -ki Ọlọhun yọnu si i-, Ojiṣẹ Ọlọhun -ki ikẹ Ọlọhun ati ọla Rẹ maa ba a-<span class="c6"> sọ pe:</span> " <span class="c1">“Ẹnikẹni ninu yin o ni tii di olugbagbọ titi maa fi di ẹni ti o ni ifẹ si ju obi rẹ lọ, ati ọmọ rẹ, ati gbogbo eniyan patapata”</span>. "Bukhari ati Muslim ni wọn gba a wa.<span class="c6"> "<br /> "Ninu awọn anfaani to wa ninu Hadiisi naa:</span> "<br /> Nini ifẹ Anabi -ki ikẹ Ọlọhun ati ọla Rẹ maa ba a- ju gbogbo eniyan lọ jẹ dandan. "<br /> Ati pe iyẹn wa ninu pipe igbagbọ.<br /> Hadiith eleekeje. </p>',
            ],
            6 => [
                'question' => '"Ibeere ẹlẹẹkeje: Parí hadisi: “Ẹni kan kan ninu yin o ni tii di olugbagbọ titi yoo fi fẹ fun ọmọ iya rẹ…”, ki o si darukọ diẹ ninu awọn anfaani rẹ? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9580.mp3',
                'answer' => '<p> "Idahun- lati ọdọ Anas -ki Ọlọhun yọnu si i-, Ojiṣẹ Ọlọhun- ki ikẹ Ọlọhun ati ọla Rẹ maa ba a-<span class="c6"> sọ pe:</span> " <span class="c1">“Ẹni kan kan ninu yin o ni tii di olugbagbọ titi yoo fi fẹ fun ọmọ iya rẹ nnkan to fẹ fun ara rẹ”</span>. " "Bukhari ati Muslim ni wọn gba a wa.<span class="c6"> "<br /> "Ninu awọn anfaani to wa ninu Hadiisi naa:</span> "<br /> "1- O jẹ dandan fun olugbagbọ lati fẹ fun awọn olugbagbọ ninu dáadáa gẹgẹ bi o ṣe fẹ fun ara rẹ. "<br /> Ati pe iyẹn wa ninu pipe igbagbọ.<span class="c6"><br /> "Hadiisi kẹjọ:</span> " </p>',
            ],
            7 => [
                'question' => '"Ibeere ẹlẹẹkẹjọ: Parí Hadiisi: “Mo fi Ẹni ti ẹmi mi wa lọwọ Rẹ bura…!, ki o si darukọ diẹ nínú awọn anfaani ẹ? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9650.mp3',
                'answer' => '<p> "Idahun- lati ọdọ Abu Saheed -ki Ọlọhun yọnu si i- Ojiṣẹ Ọlọhun -ki ikẹ Ọlọhun ati ọla Rẹ maa ba a-<span class="c6"> sọ pe:</span> " <span class="c1">“Mo fi Ẹni ti ẹmi mi wa lọwọ Rẹ bura! dajudaju o ṣe déédéé idamẹta Kuraani”</span>. "Bukhari ni o gba a wa. "<br /> Anfaani ti a maa ṣe lara Hadiisi naa ni pe<br /> 1- Ọla to n bẹ fun Surah Al-Ikhlaas. "<br /> 2- Ati pe o ṣe déédéé idamẹta Kuraani.<br /> "Hadiisi kẹsan-<span class="c6">an:</span> " </p>',
            ],
            8 => [
                'question' => '"Ibeere ẹlẹẹkẹsan-an: Parí Hadiisi: “Laa hawla wa laa quwwata illa bi-Llah…”, ki o si darukọ diẹ ninu awọn anfaani ẹ? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9720.mp3',
                'answer' => '<p> "Idahun- lati ọdọ Abu Musa -ki Ọlọhun yọnu si i- Ojiṣẹ Ọlọhun -ki ikẹ Ọlọhun ati ọla Rẹ maa ba a-<span class="c6"> sọ pe:</span> " <span class="c1">“Laa hawla wa laa quwwata illa bi-Llah jẹ pẹpẹ ọrọ kan ninu awọn pẹpẹ ọrọ alujanna”</span>. Bukhari ati Muslim ni wọn gba a wa.<span class="c6"><br /> Ninu awọn anfaani Hadiisi yii:</span><br /> 1- Ọla ti n bẹ fun gbolohun yii, ati pe pẹpẹ ọrọ kan ni in ninu awọn pẹpẹ ọrọ alijanna.<br /> 2- Yoo mu ẹrusin bọpa bọsẹ kuro nibi ìkápá ati agbara rẹ ati gbigbara le Ọlọhun <span class="c2">(Ọba ti O ga)</span> nikan ṣoṣo.<span class="c6"><br /> Hadiisi kẹwàá:</span> </p>',
            ],
            9 => [
                'question' => 'Ibeere 10: Pari hadiisi “Ẹ gbọ o, baaṣi ẹran kan n bẹ ninu ara…”, ki o si darukọ awọn apa kan anfaani rẹ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9790.mp3',
                'answer' => '<p> Idahun: Nu\'maan ọmọ Basheer <span class="c2">(ki Ọlọhun yọnu si i)</span> sọ pe: Mo gbọ ti ojiṣẹ Ọlọhun <span class="c2">(ki ikẹ ati ọla Ọlọhun maa ba a)</span> n sọ pe: <span class="c1">“Ẹ gbọ o, baaṣi ẹran kan n bẹ ninu ara, ti o ba dara, gbogbo ara ni yoo dara, ti o ba si bajẹ, gbogbo ara ni yoo bajẹ, ẹ gbọ o, oun naa ni ọkan”</span>. "Bukhaari ati Muslim ni wọn gba a wa.<span class="c6">"<br /> Awọn apa kan anfaani hadiisi yii:</span><br /> 1- Didara ọkan yoo jẹ ki gbangba ati kọkọ o dara.<br /> 2 – Nini akolekan didara ọkan, nitori pe ibẹ ni didara ọmọniyan wa.<span class="c6"><br /> Hadiisi ẹlẹẹkọkanla:</span> </p>',
            ],
            10 => [
                'question' => 'Ibeere 11: Parí hadiisi yii: “Ẹni ti igbẹyin ọrọ rẹ nile aye ba jẹ: Laa ilaaha  ilaLlah...”, ki o si darukọ awọn apa kan anfaani rẹ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9860.mp3',
                'answer' => '<p> Idahun: Lati ọdọ Muaadh ọmọ Jabal <span class="c2">(ki Ọlọhun yọnu si i)</span> o sọ pe: Ojiṣẹ Ọlọhun <span class="c2">(ki ikẹ ati ọla Ọlọhun maa ba a)</span> sọ pe: <span class="c1">“Ẹni tí igbẹyin ọrọ rẹ nile aye ba jẹ: Laa ilaaha illaal Looh; yoo wọ alijanna”</span>. Abu Daud ni o gba a wa.<span class="c6"><br /> Diẹ ninu awọn anfaani hadiisi naa:</span><br /> 1- Ọla ti n bẹ fun "Laa ilaaha illaLlaah" ati pe ẹrusin yoo wọ alujanna pẹlu rẹ.<br /> 2-<span class="c6"> Ọla ti n bẹ fun ẹni tí igbẹyin ọrọ rẹ ni ile aye yii ba jẹ "Laa ilaaha illaLlaah"<br /> Hadiisi ẹlẹẹkejila:</span> </p>',
            ],
            11 => [
                'question' => 'Ibeere 12: Pari Hadiisi  “Kii ṣe olugbagbọ ododo ni ẹni tí maa n saaba bu ẹnu atẹ lu àwọn èèyàn, tabi ẹni ti máa n saaba sẹbi le àwọn eeyan…”, ati diẹ ninu awọn anfaani rẹ?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/9940.mp3',
                'answer' => '<p> Idahun: Lati ọdọ Abdullah ọmọ Mas\'uud <span class="c2">(ki Ọlọhun yọnu si i)</span> o sọ pe: Ojiṣẹ Ọlọhun <span class="c2">(ki ikẹ ati ọla Ọlọhun maa ba a)</span> sọ pe: "Mu\'mini o ki n ṣe ẹni tí maa n yọ aleebu ara eeyan, ko si ki n ṣe ẹni tí maa n ṣepe, ko si ki n ṣe oni ibajẹ, ko si ki n ṣe ẹlẹnu jijo <span class="c2">(ti ko si ọrọ ti ko le sọ)</span> Tirmidhiy ni o gba a wa<br /> Ninu awọn anfaani Hadiisi yii:<br /> "1-Kikọ kuro nibi gbogbo ọrọ ibajẹ ati ọrọ buruku. "<br /> Dajudaju iyẹn jẹ iroyin olugbagbọ nibi ahọn rẹ.<span class="c6"> "<br /> Hadiisi kẹtala:</span> " </p>',
            ],
            12 => [
                'question' => '"Ibeere ẹlẹẹkẹtala: Parí hadiisi: “Ninu didara Isilaamu ọmọniyan...”, ki o si darukọ diẹ ninu awọn anfaani ẹ?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10020.mp3',
                'answer' => '<p> Idahun- lati ọdọ Abu Hurayra -ki Ọlọhun yọnu si i-<span class="c6"> o sọ pe:</span> Ojiṣẹ Ọlọhun- ki ikẹ Ọlọhun ati ọla Rẹ maa ba a-<span class="c6"> sọ pe:</span> " <span class="c1">“Ninu dida Isilaamu ọmọniyan: Ni ki o maa gbe nnkan ti ko ba kan an ju silẹ”</span>. "Tirmidhi ati ẹni ti o yatọ si i ni wọn gba a wa.<span class="c6"><br /> "Ninu awọn anfaani to wa ninu hadiisi naa:</span> "<br /> "1- Gbigbe nnkan ti ko ba kan eniyan ju silẹ ninu awọn alamọri ẹsin ẹlomiran ati aye rẹ. "<br /> "2- Ki o gbe nnkan ti ko kan an ju silẹ wa ninu pipe ẹsin rẹ.<span class="c6"> "<br /> "* Hadiisi kẹrinla:</span> " </p>',
            ],
            13 => [
                'question' => '"Ibeere ẹlẹẹkẹrinla: Parí hadiisi: “Ẹni ti o ba ka arafi kan ninu iwe Ọlọhun…”, ki o si darukọ diẹ ninu awọn anfaani ẹ? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10100.mp3',
                'answer' => '<p> "Idahun-<span class="c6"> lati ọdọ Abdulahi ọmọ Mas\'ud:</span> Pe Anabi- ki ikẹ Ọlọhun ati ọla Rẹ maa ba a-<span class="c6"> sọ pe:</span> " <span class="c1">“Ẹni ti o ba ka arafi kan ninu iwe Ọlọhun yio gba dáadáa kan pẹlu ẹ, ati pe dáadáa jẹ ilọpo mẹ́wàá iru ẹ,<span class="c6"> mi ko sọ pe:</span> Alif Lam Mim jẹ arafi kan, bi ko ṣe pe Alif jẹ arafi kan, Lam jẹ arafi kan, Mim jẹ arafi kan”</span>.<span class="c6"> Tirmidhiy ni o gba a wa<br /> "Ninu awọn anfaani to wa ninu hadiisi naa:</span><br /> "1- Ọla ti n bẹ fun kika Kuraani."<br /> 2- Dáadáa o maa wa fun ẹ fun gbogbo arafi kọọkan ti o n ka. " </p>',
            ],
        ],
        6 => [
            0 => [
                'question' => '"Ibeere kini- bawo ni ẹkọ pẹlu Ọlọhun- ti ọla Rẹ ga- ṣe maa jẹ? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10190.mp3',
                'answer' => '<p> "Idahun- 1- gbigbe E tobi -mimọ ni fun Un Ọba ti ọla Rẹ ga- "<br /> "2- Jijọsin fun Un ni Oun nikan ṣoṣo ti ko si orogun kankan fun Un. "<br /> "3- Titẹle E. "<br /> 4- Gbigbe yiyapa aṣẹ Rẹ ju silẹ. "<br /> "5- Didupẹ fun Un ati yiyin In, Alagbara ti O gbọnngbọn lori ọla Rẹ ati awọn idẹra Rẹ eleyii ti ko ṣee ka. "<br /> "6- Ati ṣiṣe suuru lori awọn ìpinnu Rẹ. " </p>',
            ],
            1 => [
                'question' => '"Ibeere keji: Báwo ni ẹkọ pẹlu Ojiṣẹ Ọlọhun- ki ikẹ Ọlọhun ati ọla Rẹ maa ba a- ṣe maa jẹ? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10270.mp3',
                'answer' => '<p> "Idahun- 1- Titẹle e ati ikọṣe rẹ. "<br /> "2- Titẹle aṣẹ rẹ. "<br /> "3- Gbigbe yiyapa rẹ ju silẹ. "<br /> "4- Gbigba a lododo nibi nnkan ti o ba sọ. "<br /> "5- Aida adadaalẹ nipa ṣiṣe alekun lori oju-ọna rẹ. "<br /> "6- Nini ifẹ rẹ ju ara ẹni lọ ati ju gbogbo eniyan lọ. "<br /> "7- Gbigbe e tobi ati riran an lọwọ ati riran sunna rẹ lọwọ. " </p>',
            ],
            2 => [
                'question' => '"Ibeere kẹta: Báwo ni nini ẹkọ pẹlu awọn obi mejeeji ṣe maa jẹ? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10360.mp3',
                'answer' => '<p> "Idahun- 1- titẹle aṣẹ awọn obi mejeeji nibi nnkan to yatọ si ẹṣẹ. "<br /> "2- Sisin awọn obi mejeeji. "<br /> "3- Ṣíṣe ikunlọwọ fun awọn obi mejeeji. "<br /> "4- Bibiya awọn bukaata awọn obi mejeeji. "<br /> "5- Ṣiṣe adura fun obi mejeeji."<br /> "6- Lílo ẹkọ pẹlu wọn nibi ọrọ; ṣiṣe "ṣiọ" wọn ko tọ, oun ni eyi to kere julọ ninu awọn ọrọ"<br /> "7- Mimaa rẹẹrin-musẹ loju awọn obi mejeeji, mi o si nii lejú. "<br /> "8- Mi o nii gbe ohun mi soke ju ohun awọn obi mejeeji lọ, maa maa gbọ ọrọ si wọn lẹnu, mi o nii da ọrọ mọ wọn lẹnu, mi o nii pe wọn pẹlu orúkọ awọn mejeeji,<span class="c6"> bi ko ṣe pe maa sọ pe:</span> "Bàbá mi", "iya mi". "<br /> "9- Maa gba iyọnda lọwọ wọn ṣíwájú ki n to wọle ti baba mi ati iya mi ti awọn mejeeji si wa ninu yara. "<br /> "10- Fifi ẹnu ko ọwọ ati ori awọn obi mejeeji. " </p>',
            ],
            3 => [
                'question' => '"Ibeere kẹrin: Báwo ni maa ṣe so okun-ibi pọ? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10490.mp3',
                'answer' => '<p> "Idahun-1- Ṣiṣẹ abẹwo awọn mọlẹbi bi ọmọ-iya l\'ọkunrin ati ọmọ-iya lobinrin, ati ọmọ-iya baba ẹni l\'ọkunrin ati ọmọ-iya baba ẹni lobinrin, ati ọmọ-iya iya ẹni l\'ọkunrin ati ọmọ-iya iya ẹni lobinrin, ati awọn mọlẹbi yoku."<br /> "2- Imaa ṣe daadaa si wọn pẹlu ọrọ ati isẹ ati imaa ran wọn lọwọ."<br /> "3- Ninu rẹ tun ni imaa pe wọn ati imaa beere nipa ìṣesí wọn.\' </p>',
            ],
            4 => [
                'question' => '"Ibeere 5: Bawo ni maa ṣe ri pẹlu awọn ọmọ-iya mi ati awọn ọrẹ mi?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10550.mp3',
                'answer' => '<p> "Idahun-1- Maa nífẹ̀ẹ́, maa si maa ba awọn ẹnirere ṣe ọrẹ."<br /> "2- Maa jina si biba awọn eeyan buruku ṣe ọ̀rẹ́, maa si gbe e ju silẹ."<br /> "3- Maa salamọ si awọn ọmọ-ìyá mi, maa si bọ wọn lọwọ."<br /> "4- Maa bẹ wọn wo ti wọn ba ṣe aisan, maa si ṣe adua iwosan fun wọn."<br /> "5- Maa ki ẹniti o ba sin."<br /> "6- Maa jẹ ipe rẹ ti o ba pe mi lati bẹ ẹ wo."<br /> "7- Maa gba a ni imọran."<br /> "8- Maa ran an lọwọ ti wọn ba ṣe abosi rẹ, maa si kọ fun un kuro nibi abosi."<br /> "10- Maa nífẹ̀ẹ́ fun ọmọ-ìyá mi ti o jẹ Musulumi nkan ti mo ba n fẹ funra mi."<br /> "11- Maa ran an lọwọ ti o ba bukaata si iranlọwọ mi."<br /> "12- Mio nii fi suta kan an, yala pẹlu ọrọ ni tabi iṣe."<br /> "13- Maa sọ kọkọ rẹ."<br /> "14- Mi o nii bu u, mi o si nii sọ ọrọ rẹ lẹyin, tabi yẹpẹrẹ rẹ, tabi ṣe keeta rẹ, tabi tọpinpin rẹ, tabi ki n rẹ ẹ jẹ." </p>',
            ],
            5 => [
                'question' => '"Ibeere 6: Ki ni awọn ẹkọ alámùlétì?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10710.mp3',
                'answer' => '<p> "Idahun- Maa ṣe daadaa si alamuleti pẹlu ọrọ ati iṣe, maa si ran an lọwọ nígbà tí o ba bukaata si iranlọwọ mi."<br /> "2- Maa ki i nígbà tí o ba n yọ ayọ ọdun, tabi igbeyawo tabi èyí tí o yatọ si i."<br /> "3- Maa bẹ ẹ wo ti aisan ba ṣe e, maa si ba a kẹdun ti ajalu ba ṣẹlẹ si i."<br /> "4- Maa gbe eyi ti o ba rọrun ninu ounjẹ ti mo ba se fun un."<br /> "5- Mi o nii fi suta kankan kan an pẹlu ọrọ ni abi iṣe."<br /> "6- Mi o nii da a láàmú pẹlu ohun to lọ soke tabi ki n maa tọpinpin rẹ, ati pe maa ṣe suuru fun un. " </p>',
            ],
            6 => [
                'question' => '"Ibeere keje: Ki ni awọn ẹkọ iṣe alejo ati alejo? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10800.mp3',
                'answer' => '<p> "Idahun- 1- maa da ẹni ti o ba pe mi lóhùn fun igbalejo rẹ. "<br /> "2- Ti mo ba fẹ bẹ ẹnikẹni wo, maa gba iyọnda ati àsìkò. "<br /> 3- Maa gba iyọnda ki n to wọle. "<br /> "Mi o nii pẹ nibi abẹwo."<br /> "5- Maa rẹ oju nilẹ fun awọn ara ile. "<br /> "6- Maa ki alejo kaabọ, maa si gba àlejò dáadáa pẹ̀lú itujuka, ati eyi to daa julọ ninu awọn agbekalẹ ọrọ ikinikaabọ. "<br /> "7- Maa mu alejo jókòó si ààyè to daa julọ. "<br /> "8- Maa pọn ọn lé pẹlu iṣe alejo pẹ̀lú jijẹ ati mimu. " </p>',
            ],
            7 => [
                'question' => '"Ibeere kẹjọ: Dárúkọ awọn ẹkọ aisan ati bibẹ awọn alaisan wo? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10900.mp3',
                'answer' => '<p> "Idahun- 1- Ti mo ba ti n mọ inira lara; maa gbe ọwọ mi ọtun le aaye ẹ,<span class="c6"> maa sọ pe:</span> <span class="c1">“Bismillaah”</span> lẹẹmẹta,<span class="c6"> maa si sọ pe:</span> <span class="c1">“A\'uudhu bi izzatillahi wa kudrotihi min sharri maa ajidu wa uhaadhir”</span> lẹẹmeje. "<br /> "2- Maa yọnu si nnkan ti Ọlọhun kadara ẹ, maa si ṣe suuru. "<br /> "3- Maa yara lati lọ bẹ ọmọ-iya mi alaisan wo, maa si ṣe adura fun un, mi o si nii jókòó pẹ lọdọ rẹ. "<br /> "4- Maa ṣe ruk\'ya fun un láìní jẹ ki o beere pe ki n ṣe e fun oun. "<br /> "5- Maa sọ asọtẹlẹ fun un pẹlu suuru ati adura, ati irun kiki ati imọra bi o ba ṣe kapa mọ.<br /> "6-<span class="c6"> Adura fun alaisan:</span> <span class="c1">“As’alul Lọọhal Aziim, Rọbbal Ar\'shil Aziim, an yash’fiyanii”</span> lẹẹmeje. " </p>',
            ],
            8 => [
                'question' => '"Ibeere kẹsan-an: Dárúkọ awọn ẹkọ wiwa imọ? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/10990.mp3',
                'answer' => '<p> "Idahun- 1- Mimọ aniyan kanga fun Ọlọhun Alagbara ti O gbọnngbọn.<br /> 2- Maa maa ṣe amulo imọ ti mo kọ "<br /> "3- Maa maa ṣe apọnle olukọ ni oju rẹ ati ni ẹyin rẹ. "<br /> "4- Maa maa jókòó ni iwaju rẹ pẹlu ẹkọ. "<br /> "5- Maa tẹti si i daadaa ti mi o si nii ge ọrọ mọ ọn lẹnu nibi idanilẹkọ rẹ."<br /> "6- Maa maa lo ẹkọ pẹlu bibeere ibeere."<br /> "7- Mi o nii fi orukọ rẹ pe e." </p>',
            ],
            9 => [
                'question' => '"Ibeere 10: Ki ni awọn ẹkọ ààyè ìjókòó?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11090.mp3',
                'answer' => '<p> "Idahun-1- Maa salamọ si awọn ti wọn wa ni ìjókòó."<br /> "2- Maa jókòó si ibi ti ìjókòó naa ba pari si, mi o si nii gbe ẹnikẹni dide kuro ni ibùjókòó rẹ tabi pe ki n jókòó laarin awọn meji ayaafi pẹlu iyọnda wọn."<br /> "3- Maa gba ẹlomiran láàyè láti jókòó."<br /> "4- Mi o nii ja lu ọrọ ni ìjókòó."<br /> "5- Maa gba iyọnda maa si salamọ ki n to kuro ni ìjókòó."<br /> "6- Nígbà tí ìjókòó ba ti pari, maa ṣe adua kaffāratul Majlis <span class="c2">(pipa ẹṣẹ ìjókòó rẹ)</span>" "<span class="c3">«Subhānaka Llāhummọ wabi hamdiKa, ash-hadu an lā ilāha illā Anta, astagfirukKa wa atūbu ilayKa»</span>." </p>',
            ],
            10 => [
                'question' => '"Ibeere 11: Darukọ awọn ẹkọ oorun?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11180.mp3',
                'answer' => '<p> "Idahun-1- Maa tete sun."<br /> "2- Maa sun lori imọra."<br /> "3- Mi o nii da ikùn dé ilẹ̀ sùn.<br /> "4- Maa fi ẹgbẹ ọtun mi sun, maa wa gbe ọwọ ọtun mi si abẹ parikẹ ọtun mi."<br /> "5- Maa gbọn ibusun mi."<br /> "6- Maa ka awọn iranti oorun, bi Āyatul Kursiyyu, ati Sūratul Ikhlās, ati Al-Mu‘awidhatayn ni ẹẹmẹta mẹta.<span class="c6"> Maa wa sọ pe:</span>" "<span class="c3">«Bismika Llāhummọ amūtu wa ’ahyā»</span>."<br /> "7- Maa ji dide fun Irun Al-fajri."<br /> "8-<span class="c6"> Maa wa sọ lẹyin ti mo ba ji lati oju oorun pe:</span> "<span class="c3">«Alhamdulillāhi lladhi ahyānā ba‘damā amātanā wa ilayhin nushūr»</span>" </p>',
            ],
            11 => [
                'question' => '"Ibeere 12: Ki ni àwọn ẹkọ ounjẹ?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11290.mp3',
                'answer' => '<p> "Idahun-"<br /> "1- Maa ni aniyan pẹlu jijẹ ati mimu mi ìní agbára lori titẹle Ọlọhun Ọba ti O biyi ti O si gbọnngbọn."<br /> 2- "Fifọ ọwọ mejeeji ṣaaju jijẹ."<br /> "3-<span class="c6"> Maa sọ pe:</span> "BismiLlāh", maa si fi ọwọ ọtun mi jẹun ati ninu èyí tí o ba sunmọ mi, mi ò si nii jẹun ni aarin abọ, tabi ni iwaju ẹlomiran."<br /> "4-<span class="c6"> Ti mo ba gbagbe lati darukọ Ọlọhun maa sọ pe:</span> "Bismillāh awwalahu wa ākhirahu" "<br /> "5- Maa yọnu si ounjẹ ti o ba wa, mi ò si nii fi aleebu kan ounjẹ, ti o ba wu mi maa jẹ ẹ, ti ko ba si wu mi maa fi i silẹ."<br /> "6- Maa jẹ awọn okele diẹ, mi ò si ni jẹun pupọ."<br /> "7- Mi o nii fẹ atẹgun si inu ounjẹ tabi nkan mimu, maa si fi i silẹ titi yio fi tutu."<br /> "8- Maa ma jẹun papọ pẹlu awọn miran ninu awọn ara ile mi tabi alejo."<br /> "9- Mi o nii bẹrẹ ounjẹ ṣaaju ẹlomiran ninu awọn ti wọn ju mi lọ."<br /> "10- Maa darukọ Ọlọhun ti mo ba fẹ mu nkan, maa si mu un lori ìjókòó ni gẹ̀ẹ́ mẹta."<br /> "11- Maa dupẹ fun Ọlọhun ti mo ba jẹun tan." </p>',
            ],
            12 => [
                'question' => '"Ibeere 13: Onka awọn ẹkọ wíwọ aṣọ?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11440.mp3',
                'answer' => '<p> "Idahun-1- Maa bẹrẹ wíwọ aṣọ mi pẹlu ọtun, maa wa dupẹ fun Ọlọhun lori iyẹn."<br /> "2- Mi o nii jẹ ki aṣọ mi o gun kọja kokosẹ mejeeji."<br /> "3- Awọn ọmọkùnrin o gbọdọ wọ aṣọ awọn ọmọbinrin, bẹẹ si ni awọn ọmọbinrin o gbọdọ wọ aṣọ awọn ọmọkunrin."<br /> "4- Ki o ma jọ aṣọ awọn keferi tabi awọn ẹlẹṣẹ."<br /> "5- Ṣiṣe BismiLlāh nibi bibọ aṣọ."<br /> "6- Wiwọ bata si ọtun ni akọkọ, ati bibọ ọ sílẹ̀ lati osi." </p>',
            ],
            13 => [
                'question' => '"Ibeere 14: Darukọ awọn ẹkọ gigun nkan ọ̀gùn?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11540.mp3',
                'answer' => '<p> "Idahun-1-<span class="c6"> Maa sọ pe:</span> <span class="c3">«Bismillāh, Alhamdulillāhi»</span>," "<span class="c4">{Subhāna Llādhi sakhara lanā hādhā wa mā kunnā lahu muqrinīn 13" "{Àti pé dájúdájú ọ̀dọ̀ Olúwa wa ni àwa yóò padà sí 14}</span>." <span class="c5">[Suuratu Az-<span class="c6">Zukhruf:</span> 13, 14]</span>.<br /> "2- Ti mo ba kọja lára musulumi kan; maa ki i. " </p>',
            ],
            14 => [
                'question' => '"Ibeere ẹlẹẹkarundinlogun: Dárúkọ awọn ẹkọ oju-ọna? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11590.mp3',
                'answer' => '<p> "Idahun- 1- Maa duro déédéé, ma si tẹriba nibi irin mi, maa si maa rin ni ẹgbẹ ọtun oju-ọna. "<br /> "2- Maa maa salamọ si gbogbo ẹni ti mo ba n pade. "<br /> "3- Maa rẹ oju mi nilẹ, mi o si nii fi suta kan ẹnikẹni. "<br /> "4- Maa maa paṣẹ pẹlu ohun rere, maa si maa kọ ohun buruku."<br /> "5- Maa maa mu suta kuro ni oju-ọna. " </p>',
            ],
            15 => [
                'question' => '"Ibeere ẹlẹẹkerindinlogun: Dárúkọ awọn ẹkọ wiwọ inu ile ati jijade kuro nibẹ? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11670.mp3',
                'answer' => '<p> "Idahun- 1- Maa jade pẹlu ẹsẹ mi òsì,<span class="c6"> maa wa sọ pe:</span> " Bismillaah, tawakkaltu \'alaallahi, laa awla walaa quwwata illa billahi, Allahumo innii a\'udhubika an adilla aw udọlla, aw azilla aw uzalla, aw azlima aw uzlama, aw ajhala aw yujhala alayya. 3- Maa wọle pẹlu ẹsẹ mi ọtun,<span class="c6"> maa maa sọ pe:</span> Bismillahi walajnaa, wa bismillahi khorojnaa, wa \'alaa Robbinaa tawakkalnaa.<br /> "3- Ati pe maa bẹrẹ pẹlu rirun pako, lẹyin naa maa ki awọn ara ile. " </p>',
            ],
            16 => [
                'question' => '"Ibeere ẹlẹẹkẹtadinlogun: Dárúkọ awọn ẹkọ bibiya bukaata? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11730.mp3',
                'answer' => '<p> "1- Maa wọle pẹlu ẹsẹ mi osi. "<br /> "2-<span class="c6"> Maa maa sọ ṣíwájú wiwọle pe:</span> <span class="c1">“Bismillahi, Allahumo innii a\'udhubika minal khubthi wal khobaahith”</span>.<br /> "3- Mi ko nii wọle pẹlu nnkankan ti iranti Ọlọhun n bẹ nibẹ."<br /> 4- Maa fi ara pamọ ti mo ba n gbọ bukaata lọ́wọ́.<br /> 5- Mi ko nii sọrọ ni aaye bibiya bukaata. "<br /> "6- Mi o nii kọju si qiblah mi o si nii kọ ẹyin si i ti mo ba n tọ tabi ti mo ba n ya igbẹ."<br /> "7- Maa lo ọwọ osi mi lati fi mu ẹgbin kuro, mi o si nii lo ọwọ ọtun."<br /> "8- Mi o nii ya igbẹ tabi tọ̀ si oju-ọna awọn eeyan tabi abẹ iboji wọn."<br /> "9- Maa fọ ọwọ mi lẹ́yìn tí mo ba yagbẹ tabi tọ̀ tán.<br /> "10- Maa gbe ẹsẹ osi mi jade,<span class="c6"> maa wa sọ pe:</span> "Gufrānak"." </p>',
            ],
            17 => [
                'question' => '"Ibeere 18: Darukọ awọn ẹkọ masalasi?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11860.mp3',
                'answer' => '<p> "Idahun-1-<span class="c6"> Maa gbe ẹsẹ ọtun mi wọ inu masalasi maa wa sọ pe:</span>" "<span class="c3">«BismiLlāh, Allāhummọ iftah lī abwāba rahmatiKa»</span>."<br /> "2- Mi o nii jókòó titi maa fi ki rakah meji."<br /> "3- Mi o nii gba iwaju awọn to n kirun kọja, mi o si nii kéde nkan ti o ba sọnu ninu masalasi, mi o si nii ta mi o nii ra ninu masalasi."<br /> "4-<span class="c6"> Maa gbe ẹsẹ osi mi jade lati inu masalasi maa wa sọ pe:</span>" "<span class="c3">«Allāhummọ innī as’aluKa min fadliKa»</span>." </p>',
            ],
            18 => [
                'question' => '"Ibeere19: Darukọ awọn ẹkọ salamọ?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/11930.mp3',
                'answer' => '<p> "Idahun-1- Ti mo ba pade Musulumi kan, maa kọkọ salamọ si i,<span class="c6"> pẹlu gbolohun:</span> <span class="c3">«As salāmu alaykum wa rahmotulloohi wa barakaatuhu»</span> ko nii jẹ nkan ti o yatọ si salamọ, mi o si nii ṣe itọka pẹ̀lú ọwọ mi nikan."<br /> "2- Maa rẹẹrin si ẹniti mo ba salamọ si."<br /> "3- Maa si tun bọ ọ lọwọ pẹlu ọwọ ọtun mi."<br /> "4- Ti ẹnikẹni ba ki mi pẹlu kiki kan, maa ki i pẹlu eyiti o daa ju u lọ, tabi ki n da iru rẹ pada."<br /> "5- Mi o nii kọkọ salamọ si keferi, ti o ba si salamọ si mi maa da a loun pẹlu iru rẹ."<br /> "6- Ọmọde a salamọ si agbalagba, ẹniti n gun nkan a salamọ si ẹniti n rin, ẹniti n ri a salamọ si ẹniti o jókòó, awọn to kere a salamọ si awọn to pọ̀." </p>',
            ],
            19 => [
                'question' => '"Ibeere 20: Darukọ awọn ẹkọ gbigba iyọnda?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12020.mp3',
                'answer' => '<p> "Idahun-1- Maa gba iyọnda ṣíwájú ki n to wọle si aaye náà."<br /> "2- Maa gba iyọnda ni ẹẹmẹta ti mi o si nii fi kun un, lẹyin naa maa kuro."<br /> "3- Maa kan ilẹkun pẹlu pẹlẹpẹlẹ, mi o si nii duro si ọ̀ọ́kán ilẹkun, bi ko ṣe wipe maa duro si ọtun rẹ tabi osi rẹ."<br /> "4- Mi o nii wọ yàrá baba mi tabi iya mi tabi ẹnikẹ́ni ṣíwájú iyọnda, agaga julọ ni asiko Al-fajri ati asiko qaylūlah <span class="c2">(oorun ọsan)</span>, ati ni ẹyin Ishai."<br /> "5- O rọrun ki n wọ awọn aaye ti wọn kò gbe ibẹ̀,<span class="c6"> bii:</span> Ilé iwosan tabi ile itaja lai gba iyọnda." </p>',
            ],
            20 => [
                'question' => '"Ibeere 21: Darukọ awọn ẹkọ siṣe pẹlẹpẹlẹ pẹlu awọn ẹranko?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12100.mp3',
                'answer' => '<p> "Idahun-1- Maa fun ẹranko ni jijẹ maa si tun fun un ni mimu."<br /> "2- Ṣiṣe ikẹ ati aanu pẹlu ẹranko, ati ima maa gbe nkan ti agbara rẹ o ka le e lori."<br /> "3- Mi o nii fi iya jẹ ẹranko pẹlu eyikeyi iran iya ati suta." </p>',
            ],
            21 => [
                'question' => '"Ibeere 22: Darukọ awọn ẹ̀kọ́ ti n bẹ fun ere idaraya?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12160.mp3',
                'answer' => '<p> "Idahun-1- Maa gbero pẹlu ere idaraya ìní agbára torí itẹle Ọlọhun ati iyọnu Rẹ."<br /> "2- A ko nii ṣeré ni asiko Irun."<br /> "3- Awọn ọmọkunrin o nii ṣe ere idaraya pẹlu awọn ọmọbinrin."<br /> "4- Maa dunni mọ aṣọ ere idaraya ti o bo ihoho mi."<br /> "5- Maa jina si awọn ere idaraya ti o jẹ eewọ, bii èyí tí gbigba oju ati ṣiṣi ihoho ara silẹ wa níbẹ̀." </p>',
            ],
            22 => [
                'question' => '"Ibeere 23: Darukọ diẹ ninu awọn ẹkọ awada?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12240.mp3',
                'answer' => '<p> "Idahun-1- Sisọ ootọ nibi awada, ki o si ma ni irọ ninu."<br /> "2- Awada ti ko ni iyẹpẹrẹ ati yẹyẹ ati iṣeninisuta ati idẹruba ninu."<br /> "3- Ki awada o ma pọ ju." </p>',
            ],
            23 => [
                'question' => '"Ibeere 24: Darukọ awọn ẹkọ sisin?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12300.mp3',
                'answer' => '<p> "Idahun-1- Gbigbe ọwọ tabi aṣọ tabi aṣọ pelebe ìnujú si imu nígbà tí a ba sin."<br /> "2- Ki o dupẹ fun Ọlọhun lẹyin sisin pe <span class="c3">«AlhamduliLlāh»</span>."<br /> "3- Ki ọmọ-<span class="c6">ìyá rẹ tabi ọrẹ rẹ o sọ fun un pe:</span> <span class="c3">«Yarhamuka Llāhu»</span>.<span class="c6">"<br /> "Ti o ba ti wa sọ bẹẹ fun un:</span> ki o yaa sọ pe: <span class="c3">«Yahdīkumu Llāhu wa yuslihu bālakum»</span>." </p>',
            ],
            24 => [
                'question' => '"Ibeere 25: Ki ni àwọn ẹkọ yiyan?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12360.mp3',
                'answer' => '<p> "Idahun-1- Gbigba iyanju lati dá yiyan padà."<br /> "2- Ima maa gbe ohun sókè pẹlu sisọ pe "aah" aah"."<br /> "3- Gbigbe ọwọ le ẹnu." </p>',
            ],
            25 => [
                'question' => '"Ibeere 26: Sọ awọn ẹkọ kika (Al-Qur\'āni)?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12420.mp3',
                'answer' => '<p> "Idahun-1- Kika lori imọra lẹyin aluwala."<br /> "2- Jíjókòó pẹlu ẹkọ ati ibalẹ ara."<br /> "3- Maa wa iṣọra pẹlu Ọlọhun kuro lọdọ Shaytān ni ibẹrẹ kika."<br /> "4- Maa ronu si kika naa" </p>',
            ],
        ],
        7 => [
            0 => [
                'question' => '"Ibeere 1: Sọ ọla ti n bẹ fun iwa rere?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12500.mp3',
                'answer' => '<p> "Idahun: Anabi - ki ikẹ ati ọla maa ba a -<span class="c6"> sọ pe:</span>" "«Ẹniti o pe julọ ni igbagbọ ninu awọn Mu\'mini ni ẹniti o dara julọ ni iwa." Tirmiziy ati Ahmad ni won gba a wa </p>',
            ],
            1 => [
                'question' => '"Ibeere 2: Ki nìdí ti a maa fi dunni mọ awọn iwa Isilaamu?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12530.mp3',
                'answer' => '<p> "Idahun-1- Nítorí pé o jẹ okunfa ifẹ Ọlọhun ti ọla Rẹ ga."<br /> "2- O tun jẹ okunfa ifẹ awọn ẹda."<br /> "3- O si tun jẹ nkan ti o wuwo ju ninu oṣuwọn."<br /> "4- Laada ati ẹsan si maa n jẹ adipele pẹlu iwa daadaa."<br /> "5- O si tun jẹ ami fun pipe ìgbàgbọ́." </p>',
            ],
            2 => [
                'question' => '"3- Nibo ni a ti maa mu awọn ìwà?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12600.mp3',
                'answer' => '<p> "Idahun- Ninu Kuraani Alapọn-ọnle,<span class="c6"> Ọba ti ọla Rẹ ga sọ pe:</span> "<span class="c4">{Dájúdájú al-Ƙur’ān yìí, ó ń fini mọ̀nà sí ọ̀nà tààrà}</span>" <span class="c5">[Suuratul-<span class="c6">Israa:</span> 9]</span>.<span class="c6"> "Ninu ọrọ ojiṣẹ Ọlọhun:</span> Nibi ti ojiṣẹ Ọlọhun- ki ikẹ Ọlọhun ati ọla Rẹ maa ba a-<span class="c6"> ti sọ pe:</span> " <span class="c1">“Dájúdájú wọn gbe mi dide lati pe awọn eyi to daa ninu awọn iwa”</span>. Ahmad ni o gba a wa " </p>',
            ],
            3 => [
                'question' => '"Ibeere kẹrin: Ki ni iwa dáadáa ati awọn aworan ẹ? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12640.mp3',
                'answer' => '<p> "Idahun-<span class="c6"> iṣe dáadáa:</span> Oun ni sisọ Ọlọhun ni gbogbo igba, ati ṣiṣe dáadáa ati dáadáa fun àwọn ẹda. "<br /> "Anabi- ki ikẹ Ọlọhun ati ọla Rẹ maa ba a-<span class="c6"> sọ pe:</span> <span class="c1">“Dájúdájú Ọlọhun ti kọ dáadáa lori gbogbo nnkan”</span> Muslim ni o gba a wa.<span class="c6"><br /> "Ninu awọn aworan ṣiṣe dáadáa ni:</span> "<br /> 1388."Ṣiṣe dáadáa nibi ijọsin fun Ọlọhun -ti ọla Rẹ ga-, iyẹn jẹ pẹlu imọkanga nibi ijọsin Rẹ. "<br /> "Ṣiṣe dáadáa si awọn obi mejeeji, pẹlu ọrọ ati iṣẹ. "<br /> "Ṣiṣe dáadáa si awọn ẹbi ati alasunmọ "<br /> "Ṣiṣe dáadáa si aládùúgbò<br /> "Ṣiṣe dáadáa si awọn ọmọ-orukan ati awọn mẹkunnu"<br /> "Ṣiṣe dáadáa si ẹni ti o n ṣe aburu si ẹ"<br /> "Ṣiṣe dáadáa nibi ọrọ"<br /> Ṣiṣe dáadáa nibi atako "<br /> "Ṣiṣe dáadáa si ẹranko " </p>',
            ],
            4 => [
                'question' => '"Ibeere karun-un: Ki ni idakeji ṣiṣe dáadáa? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12780.mp3',
                'answer' => '<p> "Idahun- Idakeji ṣiṣe dáadáa ni ṣíṣe aida.<span class="c6"> "<br /> *Ninu iyẹn ni:</span> Gbígbé imọkanga ju silẹ nibi ijọsin fun Ọlọhun ti ọla Rẹ ga<br /> "Ṣiṣẹ obi mejeeji "<br /> Gige okun ebi.<br /> Aladugboo buruku<br /> "*Ati gbigbe ṣiṣe daadaa si awọn talaka ati alaini ju silẹ, ati eyiti o yatọ si iyẹn ninu awọn ọrọ ati iṣẹ buruku." </p>',
            ],
            5 => [
                'question' => '"Ibeere 6: Ki ni awọn ìran ifọkantan ati awọn aworan rẹ?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12860.mp3',
                'answer' => '<p> "Idahun-"<br /> "1- Ifọkantan nibi sisọ awọn iwọ̀ Ọlọhun ti ọla Rẹ ga.<span class="c6">"<br /> "Awọn aworan rẹ:</span> Ifọkantan nibi pipe awọn ijọsin bi Irun, ati Zakah, ati Aawẹ, ati Hajj, ati eyiti o yatọ si wọn ninu awọn nkan ti Ọlọhun ṣe ni ọranyan le wọn lori.<span class="c6">"<br /> "Ifọkantan nibi sisọ awọn iwọ awọn ẹda:</span>"<br /> "Nibi sisọ ijẹ-ọmọluabi awọn eeyan."<br /> "Ati awọn dukia wọn."<br /> "Ati awọn ẹjẹ wọn."<br /> "Ati awọn kọkọ wọn, ati gbogbo nkan ti awọn eeyan ba fi ọkan balẹ si ọ lọdọ lori rẹ.<span class="c6">"<br /> "Ọba ti ọla Rẹ ga sọ nibi awọn iroyin awọn olujere pe:</span>" "<span class="c4">{àwọn t’ó ń ṣọ́ àgbàfipamọ́ wọn àti àdéhùn wọn 8}</span>" <span class="c5">[Suuratul-<span class="c6">Mu’minuun:</span> 8]</span>. </p>',
            ],
            6 => [
                'question' => '"Ibeere 7: Ki ni idakeji Ifọkantan?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/12980.mp3',
                'answer' => '<p> "Idahun- Ijanba, oun naa ni rira awọn iwọ Ọlọhun ti ọla Rẹ ga ati awọn iwọ awọn eeyan lare."<br /> "Anabi - ki ikẹ ati ọla maa ba a -<span class="c6"> sọ pe:</span>" "<span class="c3">«Ami Munaafiki mẹta ni»</span> - o wa darukọ ninu rẹ pe - <span class="c3">«Ti wọn ba fi ọkan tan an yio janba»</span> " Wọn fi ẹnu ko le e lori. </p>',
            ],
            7 => [
                'question' => '"Ibeere 8: Ki ni o n jẹ iwa ododo?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13020.mp3',
                'answer' => '<p> "Idahun- Oun ni ifunni ni iro pẹlu nkan ti yio ba nkan ti o n ṣẹlẹ mu tabi nipa nkan gẹgẹ bi o ṣe wa.<span class="c6">"<br /> "Ati pe ninu awọn aworan rẹ ni:</span><br /> "Sisọ ododo nibi isọrọ pẹlu awọn eeyan."<br /> "Sisọ ododo nibi adehun."<br /> "Sisọ ododo nibi gbogbo ọrọ ati iṣe. "<br /> "Anabi- ki ikẹ Ọlọhun ati ọla Rẹ maa ba a-<span class="c6"> sọ pe:</span> " <span class="c1">“Dajudaju ododo maa n tọ ni sọna sibi dáadáa, ati pe dajudaju dáadáa maa n tọ ni sọna sinu alujanna, ati pe dajudaju eniyan a maa sọ ododo titi ti o fi maa di olódodo”</span> Wọn fi ẹnu ko le e lori. </p>',
            ],
            8 => [
                'question' => '"Ibeere kẹsan-an: Ki ni idakeji ododo? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13100.mp3',
                'answer' => '<p> "Idahun- Irọ, òun ni idakeji ododo, ninu iyẹn ni, pipa irọ mọ awọn eniyan, ati yiyapa awọn adehun, ati jijẹrii eke. "<br /> "Anabi- ki ikẹ Ọlọhun ati ọla Rẹ maa ba a-<span class="c6"> sọ pe:</span> " <span class="c1">“Ati pe dajudaju irọ maa n tọ ni sọna sibi iwa aburu, dajudaju iwa aburu maa n tọ ni sọna sinu ina, ati pe dajudaju eniyan a maa pa irọ titi ti o fi maa di onirọ lọdọ Ọlọhun”</span>. Wọn fi ẹnu ko le e lori. Ati pe Anabi- ki ikẹ Ọlọhun ati ọla Rẹ maa ba a-<span class="c6"> sọ pe:</span> " <span class="c1">“Àmì ṣọbẹ-ṣelu musulumi, mẹta ni”</span> -o darukọ ninu ẹ- <span class="c1">“Ti o ba sọrọ, yoo pa irọ, ti o ba ṣe adehun yóò yapa”</span>. Wọn fi ẹnu ko le e lori. </p>',
            ],
            9 => [
                'question' => '"Ibeere kẹwaa: Dárúkọ awọn iran suuru? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13140.mp3',
                'answer' => '<p> "Idahun- Ṣíṣe suuru lori itẹle ti Ọlọhun -ti ọla Rẹ ga- "<br /> Ṣíṣe suuru kuro nibi ẹṣẹ "<br /> Ṣíṣe suuru lori kádàrá Ọlọhun to mu inira dani, ati di dupẹ fun Ọlọhun lori gbogbo iṣesi.<span class="c6">"<br /> Ọba ti ọla Rẹ ga sọ pe:</span> "<span class="c4">{Allāhu sì nífẹ̀ẹ́ àwọn onísùúrù 146}</span>." "<span class="c5">[Surah Âl-<span class="c6">`Imrân:</span> 146]</span>" "Ati pe Anabi- ki ikẹ Ọlọhun ati ọla Rẹ maa ba a-<span class="c6"> sọ pe:</span> " “Eemọ ni fun alamọri olugbagbọ, dajudaju gbogbo alamọri rẹ pátápátá jẹ dáadáa, iyẹn ko si fun ẹnikẹni afi fun olugbagbọ; ti idunnu ba ṣẹlẹ si i o maa dupẹ, ìyẹn si maa lóore fun un, ti inira ba ṣẹlẹ si i o ma ṣe suuru, ìyẹn sì maa jẹ oore fun un. Muslim ni o gba a wa. </p>',
            ],
            10 => [
                'question' => '"Ibeere ẹlẹẹkọkanla: Ki ni idakeji suuru? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13210.mp3',
                'answer' => '<p> "Idahun- Oun ni aiṣe suuru lori itẹle, ati aiṣe suuru kuro nibi ẹṣẹ, ati aiyọnu si awọn kádàrá Ọlọhun pẹlu ọrọ ati iṣẹ.<span class="c6"> "<br /> "Ninu awọn aworan ẹ:</span> "<br /> "Imaa tanmọọn iku."<br /> "Imaa gba ara ẹni ni oju."<br /> "Imaa fa aṣọ ya."<br /> "Imaa tu irun ka si ori <span class="c2">(latari fifi ibanujẹ hàn)</span>."<br /> "Imaa ṣe adua iparun lori ara ẹni."<br /> "Anabi - ki ikẹ ati ọla maa ba a -<span class="c6"> sọ pe:</span>" "Ẹsan n bẹ pẹlu titobi adanwo, ati pe dajudaju ti Ọlọhun ba nífẹ̀ẹ́ ijọ kan yio dan wọn wo, ẹniti o ba yọnu, iyọnu o maa jẹ tiẹ, ẹniti o ba si binu, ibinu o maa jẹ tiẹ." "Tirmidhiy ati Ibnu Mājah ni wọn gba a wa." </p>',
            ],
            11 => [
                'question' => '"Ibeere 12: Darukọ iwa ikunlọwọ?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13310.mp3',
                'answer' => '<p> "Idahun- Oun naa ni ki awọn eeyan maa ṣe ikunlọwọ laarin ara wọn lori ododo ati daadaa.<span class="c6">"<br /> "Awọn aworan iṣe ikunlọwọ:</span>"<br /> "Iṣe ikunlọwọ lori dida awọn ẹtọ pada."<br /> "Iṣe ikunlọwọ lori dida alabosi ni ọwọ kọ."<br /> "Iṣe ikunlọwọ lori bibiya bukaata awọn eeyan ati awọn alaini."<br /> "Iṣe ikunlọwọ lori gbogbo daadaa."<br /> " Ima maa ṣe ikunlọwọ lori ẹsẹ ati ṣiṣe suta ati ikọja aala.<span class="c6">"<br /> Ọba ti ọla Rẹ ga sọ pe:</span> "{Ẹ ran ara yín lọ́wọ́ lórí iṣẹ́ rere àti ìbẹ̀rù Allāhu. Ẹ má ṣe ran ara yín lọ́wọ́ lórí <span class="c2">(ìwà)</span> ẹ̀ṣẹ̀ àti ìtayọ ẹnu-àlà. Ẹ bẹ̀rù Allāhu. Dájúdájú Allāhu le <span class="c2">(níbi)</span> ìyà.}" "<span class="c5">[Sūratul Mā’idah: 2]</span>." "Anabi - ki ikẹ ati ọla maa ba a -<span class="c6"> sọ pe:</span>" "<span class="c3">«Mu’mini si Mu\'mini da bii ile ni; ti apakan o maa fun apakan ni agbara»</span> " Wọn fi ẹnu ko le e lori. "Anabi - ki ikẹ ati ọla maa ba a -<span class="c6"> tun sọ pe:</span>" "<span class="c3">«Musulumi ọmọ-ìyá Musulumi ni, ko nii ṣe abosi rẹ, ko si nii fa a kalẹ fun ẹniti yio fi ara ni i, ẹniti o ba si n biya bukaata ọmọ-ìyá rẹ, Ọlọhun a maa biya bukaata tiẹ naa, ẹniti o ba si mu ibanujẹ kuro fun musulumi kan, Ọlọhun a mu kuro fun un ibanujẹ kan ninu awọn ibanujẹ ọjọ igbedide, ẹniti o ba si bo musulumi kan ni aṣiri, Ọlọhun a bo oun naa ni aṣiri ni ọjọ igbedide»</span> " Wọn fi ẹnu ko le e lori. </p>',
            ],
            12 => [
                'question' => '"Ibeere ẹlẹẹkẹtala: Ki ni awọn iran iwa itiju? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13420.mp3',
                'answer' => '<p> "Idahun- 1-<span class="c6"> Ìtìjú Ọlọhun:</span> Yoo maa wáyé pẹ̀lú pe ki o ma maa ṣẹ Ẹ -mimọ ni fun Un-. "<br /> "2-<span class="c6"> Itiju awọn eniyan:</span> Nínú iyẹn ni gbigbe ọrọ buruku ti ko dara ju silẹ ati ṣiṣi ihoho silẹ. "<br /> "Ojiṣẹ Ọlọhun- ki ikẹ Ọlọhun ati ọla Rẹ maa ba a-<span class="c6"> sọ pe:</span> " Igbagbọ ni ẹka aadọrin ati diẹ tabi ọgọta ati diẹ,<span class="c6"> eyi to ga julọ nibẹ ni gbólóhùn:</span> Laa ilaaha illallohu.<span class="c6"> Eyi to kere julọ nibẹ:</span> Mímú suta kuro ni oju-ọna,ati pe itiju jẹ ẹka kan ninu igbagbọ”. Muslim ni o gba a wa. </p>',
            ],
            13 => [
                'question' => '"Ibeere ẹlẹẹkẹrinla: Darukọ awọn aworan iwa àánú? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13470.mp3',
                'answer' => '<p> "Idahun- 1- Ṣíṣe ikẹ awọn agbalagba ati ṣiṣe apọnle wọn. "<br /> "2- Ṣíṣe ikẹ awọn ọmọde ati awọn oponlo. "<br /> "3- Ṣíṣe ikẹ alaini ati mẹkunnu ati ẹni ti o ni bukaata. "<br /> "4- Ṣíṣe ikẹ ẹranko pẹlu pe ki o maa fun un ni ounjẹ ki o si ma fi suta kan an. "<br /> "Ninu iyẹn ni ọrọ Anabi- ki ikẹ Ọlọhun ati ọla Rẹ maa ba a-: " Waa ri awọn olugbagbọ nibi ṣiṣe ikẹ ara wọn ati nini ifẹ ara wọn ati nini aanu ara wọn, wọn da gẹgẹ bi ara, ti orikee kan ba ké ìrora, awọn orikee yoku a maa pe ara wọn fun un pẹlu aisun ati iba”. Wọn fi ẹnu ko le e lori. "Ati pe Ojisẹ Ọlọhun- ki ikẹ Ọlọhun ati ọla Rẹ maa ba a-<span class="c6"> sọ pe:</span> " Àwọn onikẹẹ, Ọba Ajọke-aye a maa kẹ wọn, ẹ maa ṣe ikẹ awọn ara ilẹ, Ẹni ti O wa ni sanmọ a maa kẹ yin”. "Abu Daud ati Tirmidhi ni wọ́n gba a wa. " </p>',
            ],
            14 => [
                'question' => '"Ibeere ẹlẹẹkarundinlogun: Ki ni awọn iran iwa ifẹ? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13550.mp3',
                'answer' => '<p> "Idahun- Níní ifẹ Ọlọhun- ti ọla Rẹ ga-<span class="c6"> "<br /> Ọba ti ọla Rẹ ga sọ pe:</span> "<span class="c4">{Àwọn t’ó gbàgbọ́ ní òdodo sì le jùlọ nínú ìfẹ́ sí}</span>." "<span class="c5">[Surah Al-<span class="c6">Baqarah:</span> 165]</span>"<br /> "Nini ifẹ ojiṣẹ Ọlọhun- ki ikẹ Ọlọhun ati ọla Rẹ maa ba a-.<span class="c6"> "<br /> o so pe:</span> <span class="c1">“Mo fi Ẹni ti ẹmi mi n bẹ ni ọwọ Rẹ bura, ẹnikẹni ninu yin o ni tii di olugbagbọ titi maa fi di ẹni ti o ni ifẹ si ju obi rẹ ati ọmọ rẹ lọ”</span>. "Al-Bukhāriy ni o gba a wa."<br /> "Nini ifẹ awọn Mu\'mini, ati nini ifẹ daadaa fun wọn gẹgẹ bi o ṣe nífẹ̀ẹ́ rẹ fun ara rẹ."<br /> "Anabi - ki ikẹ ati ọla maa ba a -<span class="c6"> sọ pe:</span>" "<span class="c3">«Ẹnikẹni ninu yin o le tii pe ni igbagbọ titi ti yio fi maa fẹ fun ọmọ-ìyá rẹ nkan ti n fẹ fun ara rẹ»</span>" "Al-Bukhāriy ni o gba a wa." </p>',
            ],
            15 => [
                'question' => '"Ibeere 16: Ṣe alaye nkan ti n jẹ Al-Bashāshatu?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13630.mp3',
                'answer' => '<p> "Idahun- Oun ni titu oju ka, pẹlu idunnu ati ririn ẹrin musẹ, ati aanu ati fifi idunnu han nígbà tí a ba pade awọn eeyan."<br /> "Ati pe oun jẹ idakeji lile oju mọ awọn eeyan ni èyí tí yio maa le wọn sa."<br /> "Ati pe awọn hadīth ti o pọ ti wa nipa ọla iyẹn, lati ọdọ Abu Dharri - ki Ọlọhun yọnu si i -<span class="c6"> o sọ pe:</span> Anabi - ki ikẹ ati ọla Ọlọhun maa ba a -<span class="c6"> sọ fun mi pe:</span>" "<span class="c3">«Ma fi oju kere nkankan ninu daadaa, koda ki o pade ọmọ-ìyá rẹ pẹlu titu oju ka»</span> " Muslim ni o gba a wa. "Ojiṣẹ Ọlọhun - ki ikẹ ati ọla Ọlọhun maa ba a -<span class="c6"> tun sọ pe:</span>" "<span class="c3">«Ririn ẹrin musẹ loju ọmọ-ìyá rẹ, saara ni fun ọ»</span> " Tirmidhiy ni o gba a wa </p>',
            ],
            16 => [
                'question' => '"Ibeere 17: Ki ni n jẹ Hasad (Keeta)?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13690.mp3',
                'answer' => '<p> "Idahun- Oun ni ti tanmọọn yiyẹ idẹra kuro lọdọ ẹlomiran tabi kikorira idẹra ẹlomiran.<span class="c6">"<br /> "Ọba ti ọla Rẹ ga sọ pe:</span> <span class="c4">{Àti níbi aburú onílara nígbà tí ó bá ṣe ìlara 5}</span> <span class="c5">[Sūratul Falaq: 5]</span>."<br /> " Lati ọdọ Anas ọmọ Mālik - ki Ọlọhun yọnu si i - dajudaju Ojiṣẹ Ọlọhun - ki ikẹ ati ọla Ọlọhun maa ba a -<span class="c6"> sọ pe:</span>" "<span class="c3">«Ẹ ma korira ara yin, ẹ ma ṣe keeta ara yin, ẹ ma kọyin si ara yin, ẹ jẹ - ẹyin ẹrusin Ọlọhun - ọmọ-ìyá»</span> " "Al-Bukhāriy ati Muslim ni wọn gba a wa." </p>',
            ],
            17 => [
                'question' => '"Ki ni n jẹ Al-’Istihzāh?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13740.mp3',
                'answer' => '<p> "Idahun- Oun ni yi yẹyẹ ọmọ-iya rẹ to jẹ musulumi ati iyẹpẹrẹ rẹ, eleyii ko lẹ́tọ̀ọ́.<span class="c6">"<br /> "Ọba ti ọla Rẹ sọ nibi kikọ kuro nibi iyẹn:</span>" "{Ẹ̀yin tí ẹ gbàgbọ́ ní òdodo, àwọn ènìyàn kan kò gbọ́dọ̀ fi àwọn ènìyàn kan ṣe yẹ̀yẹ́. Ó lè jẹ́ pé àwọn <span class="c2">(tí wọ́n sọ di oníyẹ̀yẹ́)</span> dára ju àwọn <span class="c2">(t’ó ń ṣe yẹ̀yẹ́)</span>. Àwọn obìnrin kan <span class="c2">(kò sì gbọ́dọ̀ fi)</span> àwọn obìnrin kan <span class="c2">(ṣe yẹ̀yẹ́)</span>. Ó lè jẹ́ pé àwọn <span class="c2">(tí wọ́n sọ di oníyẹ̀yẹ́)</span> dára ju àwọn <span class="c2">(t’ó ń ṣe yẹ̀yẹ́)</span>. Ẹ má ṣe búra yín. Ẹ má pe’ra yín lóríkì burúkú lẹ́yìn ìgbàgbọ́ òdodo. Ẹnikẹ́ni tí kò bá ronú pìwàdà, àwọn wọ̀nyẹn ni àwọn alábòsí. 11}" <span class="c5">[Suuratul-Hujuraat 11]</span>. </p>',
            ],
            18 => [
                'question' => '"Ibeere 19: Ṣe alaye nkan ti n jẹ Itẹriba?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13780.mp3',
                'answer' => '<p> "Idahun- Oun ni ki ọmọniyan o ma maa ri ara rẹ lori awọn eeyan, ki o si ma maa yẹpẹrẹ awọn eeyan, ki o si ma maa kọ ododo.<span class="c6">"<br /> Ọba ti ọla Rẹ ga sọ pe:</span> "<span class="c4">{Àwọn ẹrúsìn Àjọkẹ́-ayé ni àwọn t’ó ń rìn jẹ́ẹ́jẹ́ lórí ilẹ̀}</span> " <span class="c5">[Suuratul-<span class="c6">Furqan:</span> 63]</span>.<span class="c6"> "Itumọ rẹ ni:</span> Ni àwọn tí wọ́n n tẹrí bá." "- Ojiṣẹ Ọlọhun - ki ikẹ ati ọla Ọlọhun maa ba a -<span class="c6"> tun sọ pe:</span>" "<span class="c3">«Ẹnikankan o si nii rẹ ara rẹ silẹ fun Ọlọhun ayaafi ki Ọlọhun gbe e ga»</span> " Muslim ni o gba a wa. "O tun sọ - ki ikẹ ati ọla Ọlọhun maa ba a -<span class="c6"> pe:</span>" "<span class="c3">«Dajudaju Ọlọhun ranṣẹ si mi wipe ki ẹ tẹriba, debi wipe ẹnikankan o nii maa ṣe iyanran lori ẹnikẹni, ẹnikankan o si nii maa tayọ aala lori ẹnikẹni»</span> " Muslim ni o gba a wa. </p>',
            ],
            19 => [
                'question' => '"Ibeere 20: Ki ni awọn iran igberaga ti o jẹ eewọ?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13840.mp3',
                'answer' => '<p> "Idahun-1- Ṣiṣe igberaga nibi ododo, oun naa ni dida a pada ati ai gba a wọle."<br /> "2- Ṣiṣe igberaga si awọn eeyan, oun naa ni iyẹpẹrẹ wọn, ati fifi oju kere wọn."<br /> "Ojiṣẹ Ọlọhun - ki ikẹ ati ọla Ọlọhun maa ba a -<span class="c6"> sọ pe:</span>" "<span class="c3">«Ko nii wọ al-Jannah, ẹni tí deedee ọmọ ina-igun ninu igberaga ba wa ni ọkan rẹ»</span>.<span class="c6">" "Ni arakunrin kan ba sọ pe:</span> Dajudaju ọmọkunrin a maa nífẹ̀ẹ́ si ki aṣọ rẹ o yaayi ki bata rẹ naa o si dara? O sọ pe:" "<span class="c3">«Dajudaju Ọlọhun Ọba, Arẹwa ni, O si nífẹ̀ẹ́ si nkan ti o ba rẹwa,<span class="c6"> nkan ti n jẹ igberaga ni:</span> kikọ ododo, ati iyẹpẹrẹ awọn eeyan»</span> " Muslim ni o gba a wa.<br /> "-<span class="c6"> Batarul Haqqi:</span> Dida a pada"<br /> "-<span class="c6"> Gamtun Nās:</span> Yiyẹpẹrẹ wọn"<br /> "- Aṣọ ti o dara ati bata ti o dara o si ninu igberaga." </p>',
            ],
            20 => [
                'question' => '"Ibeere 21: Darukọ apakan ninu awọn irẹjẹ ti o jẹ eewọ?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13910.mp3',
                'answer' => '<p> "- Irẹjẹ nibi kata-kara, oun naa ni fifi aleebu ọja pamọ."<br /> "- Irẹjẹ nibi kikọ imọ, apejuwe iyẹn ni irẹjẹ awọn ọmọ akẹ́kọ̀ọ́ ninu idanwo."<br /> "- Irẹjẹ nibi ọrọ sisọ, gẹ́gẹ́ bíi ijẹrii eke ati irọ pipa.\'<br /> "- Aipe adehun pẹlu nkan ti o sọ ati nkan ti o fi ẹnu ko pẹlu awọn eeyan lori rẹ."<br /> "O si ti wa nibi kikọ kuro nibi irẹjẹ pe, dajudaju Ojiṣẹ Ọlọhun - ki ikẹ ati ọla Ọlọhun maa ba a - kọja nibi okiti ounjẹ kan, o wa ti ọwọ rẹ bọ inu rẹ, ni awọn ọmọnika rẹ ba kan nkan tutu kan,<span class="c6"> ni o ba sọ pe:</span> <span class="c3">«Ki ni eyi irẹ oni ounjẹ?»</span> o sọ pe: Ojo ni o pa a irẹ Ojiṣẹ Ọlọhun.<span class="c6"> O sọ pe:</span>" "<span class="c3">«Oo ṣe jẹ́ ki o wa lókè ounjẹ ki awọn eeyan le baa ri i? Ẹnikẹni ti o ba ṣe irẹjẹ ko si ni ara mi»</span> " Muslim ni o gba a wa.<br /> "As-<span class="c6">Subrọ:</span> Oun ni okiti ounjẹ." </p>',
            ],
            21 => [
                'question' => '"Ibeere 22: Ki ni n jẹ Al-Gībah (Ọrọ ẹyin)?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/13990.mp3',
                'answer' => '<p> "Idahun- Oun ni didarukọ ọmọ-ìyá rẹ musulumi pẹlu nkan ti o korira ti oun ko si si nibẹ.<span class="c6">"<br /> Ọba ti ọla Rẹ ga sọ pe:</span> "<span class="c4">{Kí apá kan yín má ṣe sọ̀rọ̀ apá kan lẹ́yìn. Ṣé ọ̀kan nínú yín nífẹ̀ẹ́ sí láti jẹ ẹran-ara ọmọ ìyá rẹ̀ t’ó ti kú ni? Ẹ sì kórira rẹ̀. Ẹ bẹ̀rù Allāhu. Dájúdájú Allāhu ni Olùgba-ìronúpìwàdà, Àṣàkẹ́-ọ̀run 12}</span>" <span class="c5">[Suuratul-Hujuraat 12]</span>. </p>',
            ],
            22 => [
                'question' => '"Ibeere 23: Ṣe alaye An-Namīmah (Òfófó)?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14030.mp3',
                'answer' => '<p> "Idahun- Oun ni gbigbe awọn ọrọ kiri laarin awọn eeyan lati da ibajẹ silẹ laarin wọn."<br /> "- Ojiṣẹ Ọlọhun - ki ikẹ ati ọla Ọlọhun maa ba a -<span class="c6"> sọ pe:</span>" "<span class="c3">«Olofofo ko nii wọ al-Jannah»</span>" Muslim ni o gba a wa. </p>',
            ],
            23 => [
                'question' => '"Ibeere 24: Ki ni n jẹ Al-Kasal (oju riro)?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14070.mp3',
                'answer' => '<p> "Idahun- Oun ni kíkàndí mọ́lẹ̀ nibi ṣiṣe iṣẹ oloore ati nkan ti ṣiṣe rẹ jẹ dandan fun ọmọniyan.<span class="c6">"<br /> "Ati pe ninu iyẹn ni:</span> Ìmẹ́lẹ́ nibi ṣiṣe awọn ọranyan.<span class="c6">"<br /> "Ọba ti ọla Rẹ ga sọ pe:</span>" "{Dájúdájú àwọn ṣọ̀bẹ-ṣèlu mùsùlùmí ń tan Allāhu, Òun náà sì máa tàn wọ́n. Nígbà tí wọ́n bá dúró láti kírun, wọ́n á dúró <span class="c2">(ní ìdúró)</span> òròjú, wọn yó sì máa ṣe ṣekárími <span class="c2">(lórí ìrun)</span>. Wọn kò sì níí ṣe <span class="c2">(gbólóhùn)</span> ìrántí Allāhu <span class="c2">(lórí ìrun)</span> àfi díẹ̀ 142}" "<span class="c5">[Sūratun Nisā\'i: 142]</span>."<br /> "Nitori naa o lẹ́tọ̀ọ́ fun Mu\'mini gbigbe imẹlẹ ati aileṣiṣẹ, ati ijokoo tẹtẹrẹ ju silẹ, o si tun lẹ́tọ̀ọ́ fun un igbiyanju nibi iṣẹ ati lilọ bibọ ati ṣiṣe wahala ati gbigba iyanju ninu aye sibi nkan ti yio yọ Ọlọhun ti ọla Rẹ ga ninu." </p>',
            ],
            24 => [
                'question' => '"Ibeere 25: Darukọ awọn iran ibinu?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14130.mp3',
                'answer' => '<p> "Idahun- 1-<span class="c6"> Ibinu ti o dara:</span> Oun ni ki o jẹ fun Ọlọhun nigba ti awọn alaigbagbọ tabi awọn ṣọbẹ-ṣelu musulumi tabi ẹni ti o yatọ si wọn ba fa awọn ọgba eewọ Ọlọhun -mimọ ni fun Un- ya. "<br /> "2-<span class="c6"> Ibinu ti ko dara:</span> Oun ni ibinu to jẹ pe o maa n mu eniyan ṣe ati sọ nnkan ti ko tọ.<span class="c6"> "<br /> "Iwosan ibinu ti ko dara:</span> "<br /> "Aluwala. "<br /> "Jíjókòó ti o ba wa ni iduro, ati fifi ẹgbẹ le ilẹ ti o ba wa lori ìjókòó. "<br /> "Ki o dunni mọ asọtẹlẹ Anabi -ki ikẹ Ọlọhun ati ọla Rẹ maa ba a-<span class="c6"> nibi ìyẹn:</span> <span class="c1">“O o gbọdọ maa binu”</span>.<br /> <span class="c1">“Ki o ko ẹmi rẹ ni ìjánu lati ma yára ṣe nǹkan ti ìbínú ba n ti i lati ṣe ni àsìkò ìbínú”</span><br /> "Wiwa iṣọra pẹlu Ọlọhun kuro lọ́dọ̀ eṣu ẹni ẹkọ. "<br /> Didakẹ </p>',
            ],
            25 => [
                'question' => 'Ibeere ẹlẹẹkẹrindinlọgbọn: Ki ni o n jẹ itọpinpin? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14240.mp3',
                'answer' => '<p> "Idahun- Oun ni afihan ati iwadii nipa awọn ihoho awọn eniyan ati nnkan ti wọn n bo.<span class="c6"> "<br /> "Ninu awọn aworan ẹ ti a ṣe ni eewọ ni:</span> "<br /> Wíwo ihoho awọn eniyan ninu awọn ile wọn. "<br /> Ki eniyan maa tẹti gbọ ọrọ awọn ijọ kan ti wọn ko si mọ̀ si i.<span class="c6"> "<br /> Ọba ti ọla Rẹ ga sọ pe:</span> "<span class="c4">{Ẹ má ṣe tọpinpin ara yín...}</span>." <span class="c5">[Suuratul-Hujuraat 12]</span>. </p>',
            ],
            26 => [
                'question' => '"Ibeere ẹlẹẹketadinlọgbọn: Ki ni o n jẹ ina-apa? Ki si ni o n jẹ ahun? Ki ni o n jẹ ọrẹ?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14310.mp3',
                'answer' => '<p> "Idahun- ina-<span class="c6">apa:</span> Oun ni nina owo ni ọna ti ko lẹtọọ,<span class="c6">"<br /> Idakeji ẹ:</span> Ahun: Oun ni ki eeyan ma ṣe ẹtọ rẹ fun un.<br /> "Eyi to tọ ni wiwa laarin mejeeji, ki musulumi si jẹ ọlọrẹ.<span class="c6"> "<br /> Ọba ti ọla Rẹ ga sọ pe:</span> "{Àwọn tí ó jẹ́ pé nígbà tí wọ́n bá náwó, wọn kò ná ìná-àpà, wọn kò sì ṣahun; <span class="c2">(ìnáwó wọn)</span> wà láààrin ìyẹn ní ìwọ̀ntún-wọ̀nsì 67}. " "<span class="c5">[Surah Al-<span class="c6">Furqan :</span> 67]</span>" </p>',
            ],
            27 => [
                'question' => '"Ibeere ẹlẹẹkejidinlọgbọn: Ki ni o n jẹ ojo? Ki si ni o n jẹ igboya? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14370.mp3',
                'answer' => '<p> "Idahun- Al-Jubnu <span class="c2">(Ojo)</span>: Ni ki o maa bẹru nkan ti ko tọ ki eeyan o bẹru."<br /> "Gẹgẹ bíi pipaya sisọ ododo ati kikọ ibajẹ."<br /> "Ash-Shajā‘ah <span class="c2">(Akin)</span>: Oun naa ni gbigba iwaju nibi òdodo, iyẹn ni bii gbigba iwaju ni awọn ojude ija ẹsin lati da aabo bo Isilaamu ati awọn Musulumi."<br /> "Ati pe Anabi - ki ikẹ ati ọla Ọlọhun maa ba a -<span class="c6"> maa n sọ ninu adua rẹ pe:</span>" "<span class="c3">«Allāhummọ innī a‘ūdhu biKa minal jubni...»</span>." "Ojiṣẹ Ọlọhun - ki ikẹ ati ọla Ọlọhun maa ba a -<span class="c6"> tun sọ pe:</span>" "«Mu\'mini to ni agbara loore, o si tun jẹ ẹniti Ọlọhun nífẹ̀ẹ́ si ju Mu\'mini to jẹ ọlẹ lọ, ati pe oore n bẹ lara ọkọọkan wọn." Muslim ni o gba a wa. </p>',
            ],
            28 => [
                'question' => '"Ibeere 29: Darukọ diẹ ninu awọn ọrọ ẹnu ti o jẹ eewọ?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14440.mp3',
                'answer' => '<p> "Idahun- Gẹgẹ bii epe ati eebu."<br /> "- Gẹgẹ bii gbolohun wipe “lagbaja ẹranko ni" tabi èyí tí o jọ ọ ninu awọn gbolohun."<br /> "- Tabi didarukọ awọn ihoho pẹlu awọn ọrọ buruku ati ọrọkọrọ."<br /> "- Ati pe Anabi - ki ikẹ ati ọla Ọlọhun maa ba a - ti kọ kuro nibi gbogbo iyẹn patapata,<span class="c6"> nitori naa ni o fi sọ pe:</span> "Mu\'mini o ki n ṣe ẹni tí maa n yọ aleebu ara eeyan, ko si ki n ṣe ẹni tí maa n ṣepe, ko si ki n ṣe oni ọrọ buruku, ko si ki n ṣe ẹlẹnu jijo <span class="c2">(ti ko si ọrọ ti ko le sọ)</span>." "Tirmidhiy ati Ibnu Hibbān ni wọ́n gba a wa." </p>',
            ],
            29 => [
                'question' => '"Ibeere 3: Darukọ awọn okunfa kan ti maa n ran musulumi lọwọ lati maa wu iwa rere?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14500.mp3',
                'answer' => '<p> "Idahun- Ṣiṣe adua wipe ki Ọlọhun rọ ọ ni ọrọ iwa rere, ki O si tun ran ọ lọwọ lori rẹ."<br /> "2- Imaa sọ Ọlọhun Ọba ti O lágbára ti O gbọnngbọn, ati pe O mọ ọ, O si n gbọ ọ, O si n ri ọ."<br /> "3- Imaa ranti ẹsan iwa rere ati pe oun ni okunfa wiwọ al-Jannah."<br /> "4- Imaa ranti àtúbọ̀tán iwa buruku ati pe oun ni okunfa wiwọ ina."<br /> "5- Dajudaju iwa rere maa n fa ifẹ Ọlọhun ti ọla Rẹ ga ati ifẹ awọn ẹda Rẹ, ati pe dajudaju iwa buruku maa n fa ikorira Ọlọhun ati ikorira awọn ẹda Rẹ."<br /> "6- Kika itan Anabi - ki ikẹ ati ọla maa ba a - ati wiwo o kọṣe."<br /> "7- Mimaa ba awọn ẹnirere sọrẹ, ati jijina si biba awọn ẹni burúkú sọrẹ." </p>',
            ],
        ],
        8 => [
            0 => [
                'question' => '"Ibeere 1: Ki ni ọla ti n bẹ fun iranti (Ọlọhun)?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14630.mp3',
                'answer' => '<p> "Idahun- Anabi - ki ikẹ ati ọla Ọlọhun maa ba a -<span class="c6"> sọ pe:</span>" "<span class="c3">«Apẹrẹ ẹni tí n ranti Oluwa rẹ ati ẹni tí ko ki n ranti Oluwa rẹ, apẹrẹ alaaye ati oku ni»</span> ". "Al-Bukhāriy ni o gba a wa."<br /> "- Eleyii ri bẹ́ẹ̀ nitori pe pàtàkì isẹmi ọmọniyan n bẹ pẹlu odiwọn iranti rẹ fun Ọlọhun ti ọla Rẹ ga." </p>',
            ],
            1 => [
                'question' => '"Ibeere 2: Darukọ díẹ̀ nínú awọn anfaani iranti (Ọlọhun)?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14670.mp3',
                'answer' => '<p> "Idahun-1- Yio maa yọ Ọba Ar-Rahmān ninu."<br /> "2- Yio tun maa le Shaytān jina."<br /> "3- Yio si tun maa da aabo bo musulumi kuro nibi awọn aburu."<br /> "4- Ẹsan ati laada o maa ti ara rẹ wa." </p>',
            ],
            2 => [
                'question' => '"Ibeere 3: Ki ni iranti to ni ọla julọ?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14730.mp3',
                'answer' => '<p> "Idahun- <span class="c3">«Lā ilāha illā Allāhu»</span> " "Tirmidhiy ati Ibnu Mājah ni wọ́n gba a wa." </p>',
            ],
            3 => [
                'question' => '"Ibeere 4: Ki ni waa sọ ti o ba ji lati oju orun?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14760.mp3',
                'answer' => '<p> "Idahun- <span class="c3">«AlhamduliLāhi Lladhī ’ahyānā ba‘da mā amātanā\' wa ilayHi nushūr»</span> " Wọn fi ẹnu ko le e lori. </p>',
            ],
            4 => [
                'question' => '"Ibeere 5: Ki ni waa sọ ti o ba wọ aṣọ rẹ?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14790.mp3',
                'answer' => '<p> "Idahun- <span class="c3">«AlhamduliLlāhi Lladhī kasānī hādha thaoba wa rọzaqanīhi min gayri haolin minnī walā quwwah»</span> " "Abū Dāud ati Tirmidhiy ati ẹlomiran yatọ si wọn ni wọ́n gba a wa." </p>',
            ],
            5 => [
                'question' => '"Ibeere 6: Ki ni waa sọ ti o ba bọ aṣọ?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14820.mp3',
                'answer' => '<p> "Idahun- <span class="c3">«BismiLlāhi»</span> " Tirmidhiy ni o gba a wa </p>',
            ],
            6 => [
                'question' => '"Ibeere 7: Ki ni adua wiwọ aṣọ titun?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14850.mp3',
                'answer' => '<p> "Idahun- <span class="c3">«Allāhummọ laKal hamdu Anta kasaoTanīhi, as’aluka khayrahu wa khayra mā suniha lahu, wa a‘ūdhu biKa min sharrihi wa sharri mā suniha lahu»</span> " "Abu Dāud ati Tirmidhiy ni o gba a wa." </p>',
            ],
            7 => [
                'question' => '"Ibeere kẹjọ: Ki ni adura ti ẹni ti o ba fẹ wọ aṣọ tuntun maa ṣe? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14880.mp3',
                'answer' => '<p> "Idahun- Ti o ba ri aṣọ tuntun lọrun ẹlòmíràn, waa ṣe adura fun un,<span class="c6"> waa sọ pe:</span> " <span class="c1">“Tublii wa yukhlifullahu Ta\'aalaa”</span>. Abu Daud ni o gba a wa. </p>',
            ],
            8 => [
                'question' => '"Ibeere kẹsan-an: Dárúkọ adura iwọ inu ile-ẹgbin, oun ni aaye ibiiya bukaata? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14910.mp3',
                'answer' => '<p> "Idahun- <span class="c1">“Allahumo innii \'audhu bika minal khubthi wal khobaahith”</span>. Wọn fi ẹnu ko le e lori. </p>',
            ],
            9 => [
                'question' => '"Ibeere kẹwaa: Ki ni adura jijade kuro lati inu ile-ẹgbin? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14940.mp3',
                'answer' => '<p> "Idahun- <span class="c1">“Gufrọọnaka”</span>. "Abu Daud ati Tirmidhi ni wọ́n gba a wa. " </p>',
            ],
            10 => [
                'question' => '"Ibeere ẹlẹẹkọkanla: Ki ni waa sọ ṣíwájú aluwala? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/14970.mp3',
                'answer' => '<p> "Idahun- <span class="c1">“Bismillaah”</span> "Abu Daud ati ẹni ti o yatọ si i ni wọ́n gba a wa. " </p>',
            ],
            11 => [
                'question' => '"Ibeere ẹlẹẹkejila: Ki ni iranti ti a maa ka nigba ti a ba pari aluwala? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15000.mp3',
                'answer' => '<p> "Idahun- <span class="c1">“Ash’hadu an laa ilaaha illallohu wahdahu laa shareeka lahu, wa ash-adu anna Muhammadan \'abduhu wa rosuuluhu”</span>. Muslim ni o gba a wa. </p>',
            ],
            12 => [
                'question' => '"Ibeere ẹlẹẹkẹtala: Ki ni iranti ti a maa ka ti a ba n jade nile? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15020.mp3',
                'answer' => '<p> "Idahun- <span class="c1">“Bismillah, tawakkaltu \'alaallahi, wa laa awla wa laa quwwata illaa billahi”</span>. Abu Daud ati Tirmidhi ni o gba a wa. " </p>',
            ],
            13 => [
                'question' => '"Ibeere ẹlẹẹkẹrinla: Ki ni iranti ti a ba wọ inu ile? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15050.mp3',
                'answer' => '<p> "Idahun- <span class="c1">“Bismillah walajnaa, wa bismillah khorojnaa, wa \'alaallahi Robbinaa tawakkalnaa", lẹyin naa ki o salamọ si awọn ara ile rẹ”</span>. Abu Daud ni o gba a wa. </p>',
            ],
            14 => [
                'question' => '"Ibeere ẹlẹẹkarundinlogun: Ki ni adura wiwọ inu mọsalasi? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15080.mp3',
                'answer' => '<p> "Idahun- <span class="c1">“Allahumo iftah lii abwaaba rahmotika”</span>, Muslim ni o gba a wa. " </p>',
            ],
            15 => [
                'question' => '"Ibeere ẹlẹẹkẹrindinlogun: Dárúkọ adura jijade lati inu mọsalasi? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15110.mp3',
                'answer' => '<p> "Idahun- <span class="c3">«Allāhummọ innī as’aluKa min fadliKa»</span> Muslim ni o gba a wa." </p>',
            ],
            16 => [
                'question' => '"Ibeere 17: Ki ni waa sọ ti o ba n gbọ ipe Irun?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15140.mp3',
                'answer' => '<p> "Idahun-<span class="c6"> Maa maa sọ iru nkan ti aperun ba n sọ ayaafi nibi:</span> <span class="c3">«Hayya ‘alas solaat»</span> ati <span class="c3">«Hayya ‘alal falāh»</span> ma sọ pe: <span class="c3">«Lā haola walā quwwata illā bilLāh»</span> " Wọn fi ẹnu ko le e lori. </p>',
            ],
            17 => [
                'question' => '"Ibeere 18: Ki ni waa sọ lẹyin ipe Irun?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15170.mp3',
                'answer' => '<p> "Idahun- <span class="c2">(Waa ṣe asalaatu fun Anabi (ki ikẹ ati ọla Ọlọhun maa ba a)</span>" Muslim ni o gba a wa.<span class="c6"> "Wa waa sọ pe:</span> <span class="c3">«Allāhummọ robba hādhihid da‘watit tāmah was solaatil qā’imah, Āti Muhammadanil wasīlata wal fadīlah, wab‘ath\'hu maqāman mahmūdanil ladhī wa‘adTahu»</span> " "Al-Bukhāriy."<br /> "Wa ṣe adua laarin ipe Irun ati iqāmah; torí pé wọn o nii da adua naa pada." </p>',
            ],
            18 => [
                'question' => '"Ibeere 19: Ki ni waa sọ ni aarọ ati ni irọlẹ ninu awọn iranti (Ọlọhun)?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15220.mp3',
                'answer' => '<p> "Idahun-1-<span class="c6"> Ka āyatal Kursiyyu:</span>" "<span class="c4">{Allāhu lā ilāha illā Uwa Al-Hayyu Al-Qoyyūm lā ta’khudhuHu sinatun walā naom laHu mā fis samāwāti wa mā fil ardi man dha lladhī yashfa‘u ‘indaHu illā bi idhniHi Ya‘lamu mā bayna aydīhim wa mā khalfahum walā yuhītūna bi shay’in min ‘ilmiHi illā bimā Shā’a wasi‘a kursiyyuHus samāwāti wal ardọ walā ya’ūduHu hifdhuhumā wa Huwal Aliyyil ‘Adhīm 255}</span>" "<span class="c5">[Sūratul Baqorah: 255]</span>.<span class="c6">" Ki o waa ka:</span> "BismiLlāhir Rahmānir Rahīm" "<span class="c4">{Qul Uwa Allāhu Ahad 1" "Allāhus Sọmad 2" "Lam yalid wa lam yūlad 3" "Walam yakun lahu kufuwan ahad 4}</span>" "Ni ẹẹmẹta." "BismiLlāhir Rahmānir Rahīm" "<span class="c4">{Qul a‘ūdhu bi robbil falaqi 1" "Min sharri mā khalaqa 2" "Wa min sharri gāsiqin idhā waqaba 3" "Wa min sharrin naffāthāti fil ‘uqad 4" "Wa min sharri hāsidin idhā hasada 5}</span>" "Ẹẹmẹta" "BismiLlāhir Rahmānir Rahīm" "<span class="c4">{Qul a‘ūdhu bi robbin nās 1" "Malikin nās 2" "Ilāhin nās 3" "Min sharril waswāsil khannās 4" "Alladhī yuwaswisu fī suduurin nās 5" "Minal jinnati wan nās 6}</span>" "Ẹẹmẹta." "<span class="c3">«Allāhumma Anta Robbī lā ilāha illā Anta, khalaqTani wa ana ‘abduKa, wa anā ‘alā ‘ahdiKa wa wa‘diKa mastata‘tu, a‘ūdhu biKa min sharri mā sọnah’tu, ’abū’u laKa bi ni‘matiKa alayya, wa ’abū’u bi dhambī, fagfirlii, fa innahu lā yagfirudh dhunūba illā Anta»</span> \' "Al-Bukhāriy ni o gba a wa." </p>',
            ],
            19 => [
                'question' => '"Ibeere 20: Ki ni waa sọ ti o ba fẹ sun?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15290.mp3',
                'answer' => '<p> "Idahun- <span class="c3">«BismiKa Llāhumma amūtu wa ahyā»</span> " Wọn fi ẹnu ko le e lori. </p>',
            ],
            20 => [
                'question' => '"Ibeere 21: Ki ni waa sọ ṣíwájú jijẹ ounjẹ?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15320.mp3',
                'answer' => '<p> "Idahun- <span class="c3">«BismiLlāhi»</span> "<br /> "Ti o ba gbagbe lati wi i ni ibẹrẹ rẹ,<span class="c6"> ki o sọ pe:</span>"<br /> "BismiLlāhi fii awwalihii wa aakhirihii» " "Abu Dāud ati Tirmidhiy ni wọ́n gba a wa." </p>',
            ],
            21 => [
                'question' => '"Ibeere 22: Ki ni waa sọ ti o ba jẹun tan?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15370.mp3',
                'answer' => '<p> "Idahun- <span class="c3">«AlhamduliLlāhi Lladhī at‘amanī hādha, wa razaqanīhi min gayri haolin minnī walā quwwata»</span> " "Abū Dāud ati Ibnu Mājah ati ẹlomiran yatọ si awọn mejeeji ni wọ́n gba a wa." </p>',
            ],
            22 => [
                'question' => '"Ibeere 23: Ki ni adua ti alejo o ṣe fún ẹniti o ni ounjẹ?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15400.mp3',
                'answer' => '<p> "Idahun- <span class="c3">«Allāhummọ bārik lahum fīmā rọzaqTahum, wagfir lahum warhamhum»</span> " Muslim ni o gba a wa. </p>',
            ],
            23 => [
                'question' => '"Ibeere 24: Ki ni ọmọniyan o sọ ti o ba sin?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15430.mp3',
                'answer' => '<p> "Idahun- <span class="c3">«AlhamduliLlāhi»</span>."<br /> "Ki ọmọ-<span class="c6">ìyá rẹ tabi ọrẹ rẹ o sọ fun un pe:</span> <span class="c3">«Yarhamuka Llāhu»</span>.<span class="c6">"<br /> "Ti o ba ti waa sọ ọ fun un:</span> ki o yaa sọ pé: <span class="c3">«Yahdīkumu Llāhu wa yuslihu bālakum»</span> " "Al-Bukhāriy ni o gba a wa." </p>',
            ],
            24 => [
                'question' => '"Ibeere 25: Ki ni waa sọ ti o ba fẹ dìde nígbà ti o ba ṣetan ni ijokoo "Adua ipa aṣiṣe ijokoo rẹ (kaffāratul Majlis)"?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15480.mp3',
                'answer' => '<p> "Idahun- <span class="c3">«SubhānaKa Allāhummọ wa bi hamdiKa, ash’hadu an lā ilāha illā Anta, astagfiruKa wa atūbu ’illayKa»</span> " "Abū Dāud ati Tirmidhiy ati ẹlomiran yatọ si awọn mejeeji ni wọ́n gba a wa." </p>',
            ],
            25 => [
                'question' => '"Ibeere 26: Ki ni adua gigun nkan ọ̀gùn?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15510.mp3',
                'answer' => '<p> "Idahun- "BismiLlāh, wal hamdu liLlāh <span class="c4">{Subhāna Lladhī sakhara lanā hādha wa mā kunnā lahu muqrinīn 13 wa innā ilā robbinā la munqalibūn 14}</span> <span class="c3">«AlhamduliLlāh, AlhamduliLlāh, AlhamduliLlāh, Allāhu akbar, Allāhu akbar, Allāhu akbar, subhānaKa Alllāhummọ innī zọlamtu nafsī fagfir lī; fa innahu lā yagfirid dhunūba illā Anta»</span> " "Abū Dāud ati Tirimidhi ni wọn gba a wa." </p>',
            ],
            26 => [
                'question' => 'Ibeere 27: "Darukọ adua irin-ajo?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15540.mp3',
                'answer' => '<p> "Idahun- <span class="c3">«Allāhu akbar, Allāhu akbar, Allāhu akbar <span class="c4">{Subhāna Lladhī sakhara lanā hādha wa mā kunnā lahu muqrinīn 13 wa innā ilā robbinā la munqalibūn 14}</span>, Allāhummọ innā nasaluKa fī safarinā hādhal birra wat taqwā, wa minal ‘amali mā tardọọ, Allāhummọ hawwin ‘alaynā safaranā hādha, watwi ‘annā bu‘dahu, Allāhummọ Antas Soohibu fis safari wal Khalīfatu fīl ahli, Allāhummọ innī a‘ūdhu biKa min wa‘thāis safari, wa ka’ābatil mansọri, wa sū’il munqọlabi fil māli wal ahli»</span> "<br /> "Ti o ba si ṣẹri pada yio sọ ọ,<span class="c6"> yio si tun fi kun un pe:</span>\'<br /> "<span class="c3">«\'Āyibūna, tā’ibūna, ‘ābidūna, li Rabbinā hāmidūn»</span> " Muslim ni o gba a wa. </p>',
            ],
            27 => [
                'question' => '"Ibeere 28: Ki ni adua ti arìnrìn-àjò o ṣe fun ẹniti o wa nile?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15590.mp3',
                'answer' => '<p> "Idahun- <span class="c3">«Astaodi‘ukumu Llāha Lladhī lā tadī‘u wadā’i‘uHu»</span> " "Ahmad ati Ibnu Mājah ni wọ́n gba a wa." </p>',
            ],
            28 => [
                'question' => '"Ibeere 29: Ki ni adua ti ẹni tí o wa nile o ṣe fun arinrin-ajo?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15620.mp3',
                'answer' => '<p> "Idahun- <span class="c3">«Astaodi‘ul Lāha dīnaka, wa amānataka, wa khawātiima ‘amalika»</span> " "Ahmad ati Tirmidhiy ni wọ́n gba a wa." </p>',
            ],
            29 => [
                'question' => '"Ibeere 30: Ki ni adua wiwọ inu ọja?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15650.mp3',
                'answer' => '<p> "Idahun- <span class="c3">«Lā ilāha illā Llāhu wahdaHu lā sharīka laHu, laHul mulku, wa laHul amdu, yuhyī wa yumītu, wa Huwa Ayyun lā yamūtu, bi yadiHil khayru, wa Huwa ‘alā kulli shay’in qadīr»</span> " "Tirmidhiy ati Ibnu Mājah ni wọn gba a wa." </p>',
            ],
            30 => [
                'question' => '"Ibeere 31: Darukọ adua ti a maa n ṣe nigba ibinu?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15680.mp3',
                'answer' => '<p> "Idahun- <span class="c3">«’A‘ūdhu biLlāhi minash Shaytānir rajīm»</span> " Wọn fi ẹnu ko le e lori. </p>',
            ],
            31 => [
                'question' => '"Ibeere 32: Ki ni waa sọ fun ẹni tí o ba ṣe daadaa si ọ?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15710.mp3',
                'answer' => '<p> "Idahun- <span class="c3">«JazākaLlāhu khayran»</span> " Tirmidhiy ni o gba a wa </p>',
            ],
            32 => [
                'question' => '"Ibeere 33: Ki ni adua ti a maa ṣe ti nkan ọ̀gùn ṣubú?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15740.mp3',
                'answer' => '<p> "Idahun- <span class="c3">«BismiLlāhi»</span> " Abu Daud ni o gba a wa. </p>',
            ],
            33 => [
                'question' => '"Ibeere 34: Ki ni waa sọ ti nkan ti o dun mọ ọ ba ṣẹlẹ?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15770.mp3',
                'answer' => '<p> "Idahun- <span class="c3">«AlhamduliLlāhi Lladhī bi ni‘matiHi tatimmus sọọlihaat»</span> " "Al-Hākim ati ẹni tí o yatọ si i ni wọn gba a wa." </p>',
            ],
            34 => [
                'question' => '"Ibeere 35: Ki ni waa sọ ti nkan ti o korira ba ṣẹlẹ?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15800.mp3',
                'answer' => '<p> "Idahun- <span class="c3">«AlhamduliLāhi ‘alā kulli hāl»</span> " "Sọhīhul jāmi." </p>',
            ],
            35 => [
                'question' => '"Ibeere 36: Bawo ni sisalamọ ati dida salamọ pada?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15830.mp3',
                'answer' => '<p> "Idahun-<span class="c6"> Musulumi o sọ pe:</span> <span class="c3">«As Salāmu alaykum wa rahmotuLloohi wa barakaatuHu»</span> "<br /> Ọmọ-<span class="c6">iya rẹ maa da a lohun pe:</span> <span class="c3">«Wa alaykumus salāmu wa rahmotuLloohi wa barakaatuHu»</span> " "O wa ni Tirmidhiy ati Abū Dāud ati awọn to yatọ si awọn mejeeji." </p>',
            ],
            36 => [
                'question' => '"Ibeere 37: Ki ni adua ti a maa sọ ni asiko rirọ ojo?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15870.mp3',
                'answer' => '<p> "Idahun- <span class="c3">«Allāhummọ soyyiban nāfi‘an»</span> " "Al-Bukhāriy." </p>',
            ],
            37 => [
                'question' => '"Ibeere 38: Ki ni adua ti a maa n ṣe lẹyin rirọ ojo?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15900.mp3',
                'answer' => '<p> "Idahun- <span class="c3">«Mutirnā bi fadliLlāhi wa rahmatiHl»</span> " Al-Bukhari ati Muslim. </p>',
            ],
            38 => [
                'question' => '"Ibeere 39: Sọ adua ti atẹgun ba n fẹ́?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15930.mp3',
                'answer' => '<p> "Idahun- <span class="c3">«Allāhummọ innī as\'aluka khayrahā wa ’a‘ūdhu biKa min sharrihā»</span> " "Abū Dāud ati Ibnu Mājah." </p>',
            ],
            39 => [
                'question' => '"Ibeere 40: Darukọ adua ṣiṣe nibi gbigbọ didun ara?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15960.mp3',
                'answer' => '<p> "Idahun- <span class="c3">«Subhāna Lladhī yusabbihur ra‘du bi hamdihii wal malāikatu min khīfatiHi»</span> " Muwattahu Maalik </p>',
            ],
            40 => [
                'question' => '"Ibeere 41: Ki ni adua ti waa ṣe ti o ba ri ẹni tí adanwo kọlu?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/15990.mp3',
                'answer' => '<p> "Idahun- <span class="c3">«AlhamduliLlāhi Lladhī ‘āfānī mimmā ibtalāka bihi, wa faddalanī ‘alā kathīrin mimman khalaqọ tafdīlah»</span> " Tirmidhiy ni o gba a wa </p>',
            ],
            41 => [
                'question' => '"Ibeere 42: Adua ẹni tí ba n paya lati ma fi ojukoju ko adanwo ba nkankan?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16020.mp3',
                'answer' => '<p> "Idahun-<span class="c6"> O wa ninu hadīth pe:</span> <span class="c3">«Ti ẹnikẹni ninu yin ba ri nkan ti o wu u lọdọ ọmọ-ìyá rẹ tabi lọdọ ara rẹ, tabi nibi dukia rẹ, <span class="c5">[ki o yaa ṣe adua alubarika fun un]</span> tori pé dajudaju ojukoju ododo ni»</span> " "Ahmad ati Ibnu Mājah ati ẹlomiran yatọ si awọn mejeeji ni wọn gba a wa." </p>',
            ],
            42 => [
                'question' => '"Ibeere 43: Bawo ni waa ṣe ṣe assalātu fun Anabi (ki ikẹ ati ọla maa ba a)?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16050.mp3',
                'answer' => '<p> "Idahun- <span class="c3">«Allāhummọ sọlli ‘alā Muhammadin wa ‘alā ’āli Muhammadin, kamā sọllayta ‘alā Ibrāhīma, wa ‘alā ’āli Ibrāhīma, innaKa Hamīdun Majīd, Allāhummọ bārik ‘alā Muhammadin wa ‘alā ’āli Muhammadin, kamā bārakTa ‘alā Ibrāhīma, wa ‘alā ’āli Ibrāhīma, innaKa Hamīdun Majīd»</span> " Wọn fi ẹnu ko le e lori. </p>',
            ],
        ],
        9 => [
            0 => [
                'question' => '"Ibeere 1: Ki ni awọn idajọ ila-nnkan-bọni-lọrun maraarun?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16090.mp3',
                'answer' => '<p> "Idahun-"<br /> "1- Nkan ti o jẹ dandan."<br /> "2- Nkan ti a fẹ."<br /> "3- Nkan ti wọn ṣe ni eewọ."<br /> "4- Nkan ti wọn korira."<br /> "5- Nkan ti wọn ṣe ni ẹ̀tọ́." </p>',
            ],
            1 => [
                'question' => '"Ibeere 2: Ṣe alaye awọn idajọ maraarun yii?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16170.mp3',
                'answer' => '<p> "Idahun-"<br /> "1- Al-<span class="c6">Wājib:</span> Gẹgẹ bíi awọn Irun ọranyan maraarun, ati Aawẹ Ramadan ati ṣiṣe daadaa si obi mejeeji."<br /> "- Al-Wājib, wọn maa san ẹni ti o ba ṣe e ni ẹsan, wọn si maa fi iya jẹ ẹni ti o ba gbe e ju silẹ."<br /> "2- Al-<span class="c6">Mustahabbu:</span> Gẹgẹ bíi àwọn sunnah awọn Irun ọranyan, ati qiyāmul layli ati fifun awọn eeyan ni ounjẹ, ati sisalamọ. Wọn si tun maa n pe e ni As-Sunnah ati Al-Madūb."<br /> "- Al-Mustahabbu, wọn maa san ẹni ti o ba ṣe e ni ẹsan, wọn o si nii fi iya jẹ ẹni tí o ba gbe e ju silẹ.<span class="c6">"<br /> "Akiyesi pataki:</span>"<br /> "O tọ fun musulumi ti o ba gbọ wipe alamọri yii sunnah tabi mustahabbu ni ki o tara sasa lọ ṣe e, ki o si tun maa kọṣe Anabi <span class="c2">(ki ikẹ ati ọla Ọlọhun maa ba a)</span>."<br /> "3- Al-<span class="c6">Muharram:</span> Gẹgẹ bíi mimu ọtí ati ṣiṣẹ obi mejeeji, ati jija okun ẹbi."<br /> "- Al-Muharram, wọn maa san ẹni ti o ba gbe e ju silẹ ni ẹsan, wọn o si tun fi iya jẹ ẹni ti o ba ṣe e."<br /> "4- Al-<span class="c6">Makrūhu:</span> Gẹgẹ bíi gbigba ati fifun pẹlu ọwọ osi, ati kika aṣọ ni ori Irun."<br /> "- Al-Makrūhu, wọn maa san ẹni ti o ba gbe e ju silẹ ni ẹsan bẹẹ si ni wọn o nii fi iya jẹ ẹni ti o ba ṣe e."<br /> "5- Al-<span class="c6">Mubāhu:</span> Gẹgẹ bíi jijẹ eso ajara <span class="c2">(apple)</span> ati mimu tíì,<span class="c6"> wọn si tun maa n pe e ni:</span> Al-Jā’iz ati Al-Halāl."<br /> "- Al-Mubāhu, wọn o nii san ẹni ti o ba gbe e ju silẹ ni ẹsan, bẹẹ si ni wọn o nii fi iya jẹ ẹni ti o ba ṣe e." </p>',
            ],
            2 => [
                'question' => '"Ibeere 3: Ki ni idajọ kata-kara ati ajọṣepọ?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16320.mp3',
                'answer' => '<p> "Idahun- Ìpìlẹ̀ nibi gbogbo owo ati ajọṣepọ ni pe ẹtọ ni, ayaafi awọn iran kan ninu awọn nkan ti Ọlọhun ti ọla Rẹ ga ṣe ni eewọ.<span class="c6">"<br /> Ọba ti ọla Rẹ ga sọ pe:</span> "<span class="c4">{Allāhu sì ṣe òwò ṣíṣe ní ẹ̀tọ́, Ó sì ṣe òwò èlé ní èèwọ̀}</span>" "<span class="c5">[Sūratul Baqorah: 275]</span>." </p>',
            ],
            3 => [
                'question' => '"Ibeere 4- Darukọ díẹ̀ nínú awọn ajọṣepọ ati awọn kata-kara ti o jẹ eewọ?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16360.mp3',
                'answer' => '<p> "Idahun-"<br /> "1- Irẹjẹ,<span class="c6"> ninu rẹ si ni:</span> Fifi aleebu ọja pamọ."<br /> "Lati ọdọ Abū Hurayrah - ki Ọlọhun yọnu si i - dajudaju Ojiṣẹ Ọlọhun - ki ikẹ ati ọla Ọlọhun maa ba a - kọja nibi okiti ounjẹ kan, o wa ti ọwọ rẹ bọ inu rẹ, ni awọn ọmọnika rẹ ba kan nkan tutu kan,<span class="c6"> ni o ba sọ pe:</span> <span class="c3">«Ki ni eléyìí, irẹ oni ounjẹ?»</span> O sọ pe: Ojo ni o pa a irẹ Ojiṣẹ Ọlọhun.<span class="c6"> O sọ pe:</span>" <span class="c3">«O o ṣe fi i si oke ounjẹ ki awọn eeyan le ba ri i? Ẹni ti o ba ṣe irẹjẹ kii ṣe ara mi»</span> " Muslim ni o gba a wa.<br /> "2- Riba <span class="c2">(Ele)</span>: Ninu ẹ ni ki n ya ẹgbẹrun kan ni ọwọ ẹnikan lori pe maa da ẹgbẹrun meji pada fun un."<br /> "Alekun yẹn ni ele ti o jẹ eewọ.<span class="c6">"<br /> Ọba ti ọla Rẹ ga sọ pe:</span> "<span class="c4">{Allāhu sì ṣe òwò ṣíṣe ní ẹ̀tọ́, Ó sì ṣe òwò èlé ní èèwọ̀}</span>" "<span class="c5">[Sūratul Baqorah: 275]</span>."<br /> "3- Ẹtanjẹ ati Iruju <span class="c2">(Aimọ)</span>: Gẹgẹ bíi ki n ta wara ti n bẹ ninu ọyan ẹran fun ọ, tabi ẹja ti n bẹ ninu omi ti mi o si tii dẹdẹ rẹ.<span class="c6">"<br /> "O ti wa ninu hadīth pe:</span> <span class="c2">(Ojiṣẹ Ọlọhun - ki ikẹ ati ọla Ọlọhun maa ba a - kọ kuro nibi òwò ẹtanjẹ)</span>" Muslim ni o gba a wa. </p>',
            ],
            4 => [
                'question' => '"Ibeere 5: Darukọ diẹ ninu awọn idẹra Ọlọhun lori rẹ?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16460.mp3',
                'answer' => '<p> "Idahun-1- Idẹra Isilaamu, ati pe o o si ninu awọn keferi."<br /> "2- Idẹra sunnah, ati pe o o si ninu awọn oni adadaalẹ."<br /> "3- Idẹra alaafia ati igbadun, nibi gbigbọ ati riri ati ririn ati èyí tí o yatọ si i."<br /> "4- Idẹra jijẹ ati mimu ati wiwọ."<br /> "Ati pe awọn idẹra Ọlọhun lori wa pọ ko ṣeé ka.<span class="c6">"<br /> Ọba ti ọla Rẹ ga sọ pe:</span> "<span class="c4">{Tí ẹ bá ṣòǹkà ìdẹ̀ra Allāhu, ẹ kò lè kà á tán. Dájúdájú Allāhu mà ni Aláforíjìn, Oníkẹ̀ẹ́ 18}</span>" "<span class="c5">[Sūratun Nahl: 18]</span>." </p>',
            ],
            5 => [
                'question' => '"Ibeere 6: Ki ni nkan ti o jẹ dandan nibi awọn idẹra? Ati pe bawo ni waa ṣe dupẹ rẹ?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16540.mp3',
                'answer' => '<p> "Idahun-<span class="c6"> Nkan ti o jẹ dandan ni:</span> Didupẹ rẹ, iyẹn ni pẹlu yiyin Ọlọhun ati didu ọpẹ fun Un pẹlu ahọn ati pe Oun nikan ṣoṣo ni o ni ọla, ati lílo idẹra yii sibi nkan ti yio yọ Ọlọhun ti ọla Rẹ ga ninu, ti kii ṣe sibi ṣiṣẹ Ẹ." </p>',
            ],
            6 => [
                'question' => '"Ibeere 7: Ki ni awọn ọdun awọn Musulumi?"',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16570.mp3',
                'answer' => '<p> "Idahun- Ọdun itunu Aawẹ ati ọdun ileya."<br /> "- Gẹgẹ bi o ṣe wa ninu hadīth Anas,<span class="c6"> o sọ pe:</span> Anabi - ki ikẹ ati ọla Ọlọhun maa ba a - wa si Medinah, wọn si ni ọjọ meji ti wọn fi maa n ṣere,<span class="c6"> o wa sọ pe:</span> <span class="c3">«Ki ni ọjọ mejeeji yii»</span>,<span class="c6"> wọn sọ pe:</span> A maa n ṣere ninu ẹ ni igba aimọkan, Ojiṣẹ Ọlọhun - ki ikẹ ati ọla Ọlọhun maa ba a -<span class="c6"> wa sọ pe:</span> "«Dajudaju Ọlọhun ti fi eyi ti o loore ju mejeeji lọ jirọ wọn fun yin: Ọjọ́ adhā <span class="c2">(iléyá)</span>, ati ọjọ itunu Aawẹ» " "Abū Dāud ni o gba a wa."<br /> "Eyi ti o ba si yatọ si mejeeji ninu awọn ọdun, ninu adadaalẹ ni." </p>',
            ],
            7 => [
                'question' => '"Ibeere kẹjọ: Èwo ni o daa julọ ninu awọn oṣu? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16620.mp3',
                'answer' => '<p> "Idahun- Oṣu Ramadan. " </p>',
            ],
            8 => [
                'question' => '"Ibeere kẹsan-an: Èwo ni o daa julọ ninu awọn ọjọ? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16650.mp3',
                'answer' => '<p> "Idahun- Ọjọ́ Jimọh. " </p>',
            ],
            9 => [
                'question' => '"Ibeere kẹwaa: Ọjọ́ wo ni o ni ọla ju nínú ọdun?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16680.mp3',
                'answer' => '<p> "Idahun- Ọjọ́ arafah. " </p>',
            ],
            10 => [
                'question' => '"Ibeere ẹlẹẹkọkanla: Òru wo ni o ni ọla ju nínú ọdún?',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16710.mp3',
                'answer' => '<p> "Idahun- Oru Laylatul Kọdri . " </p>',
            ],
            11 => [
                'question' => '"Ibeere ẹlẹẹkejila: Ki ni nnkan to jẹ dandan lati ṣe nigba ti o ba ri obinrin kan to jẹ ajoji? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16740.mp3',
                'answer' => '<p> "Idahun- Nǹkan to jẹ dandan ni rirẹ oju nilẹ,<span class="c6"> Ọba ti ọla Rẹ ga sọ pe:</span> " "<span class="c4">{Sọ fún àwọn onígbàgbọ́ òdodo lọ́kùnrin pé kí wọ́n rẹ ojú wọn nílẹ̀}</span> "<span class="c5">[Surah An-<span class="c6">Nûr:</span> 30]</span>" </p>',
            ],
            12 => [
                'question' => '"Ibeere ẹlẹẹkẹtala: Àwọn wo ni awọn ọta eniyan? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16770.mp3',
                'answer' => '<p> "Ẹmi ti o maa n pani laṣẹ aburu: Ìyẹn ni pe ki eniyan maa tẹle nnkan ti ẹmi rẹ ba n sọ fun un ki o ṣe ati ifẹ-inu rẹ nibi ṣíṣẹ Ọlọhun- ti ibukun n bẹ fun Un ti ọla Rẹ ga-,<span class="c6"> Ọlọhun Ọba sọ pe:</span> " "{dájúdájú ẹ̀mí kúkú ń pàṣẹ èròkérò <span class="c2">(fún ẹ̀dá)</span> ni àfi ẹni tí Olúwa mi bá kẹ́. Dájúdájú Olúwa mi ni Aláforíjìn, Àṣàkẹ́-ọ̀run}. " <span class="c5">[Suuratu Yusuf: 53]</span>.<span class="c6"> "Eṣu:</span> Oun ni ọta ọmọ Anabi Adam, ati pe ero rẹ ni pe ki o sọ eniyan nu ki o si ko royiroyi ba a nibi aburu ki o si mu u wọ ina.<span class="c6"> Ọba ti ọla Rẹ ga sọ pe:</span> " "<span class="c4">{Ẹ má sì ṣe tẹ̀lé àwọn ojú-ẹsẹ̀ Èṣù. Dájúdájú òun ni ọ̀tá pọ́nńbélé fun yín}</span>. " "<span class="c5">[Surah Al-<span class="c6">Baqarah:</span> 168]</span> "3-<span class="c6"> Awọn ọrẹ buruku:</span> Àwọn to jẹ pe wọn maa n ṣe ni loju kokoro si aburu, ti wọn si maa n ṣẹri eeyan kuro nibi ohun rere.<span class="c6"> Ọba ti ọla Rẹ ga sọ pe:</span> " "{Àwọn ọ̀rẹ́ àyò ní ọjọ́ yẹn, apá kan wọn yóò jẹ́ ọ̀tá fún apá kan àyàfi àwọn olùbẹ̀rù <span class="c2">(Allāhu)</span>} " <span class="c5">[Suuratu Az-<span class="c6">Zukhruf:</span> 67]</span>. </p>',
            ],
            13 => [
                'question' => 'Ibeere ẹlẹẹkẹrinla: ki ni o n jẹ ironupiwada?  "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16820.mp3',
                'answer' => '<p> Idahun-<span class="c6"> Ìrònúpìwàdà:</span> Oun ni ṣiṣẹri pada kuro nibi ṣiṣẹ Ọlọhun- ti ọla Rẹ ga- lọ si ibi itẹle E.<span class="c6"> Ọba ti ọla Rẹ ga sọ pe:</span> " "<span class="c4">{Dájúdájú Èmi ni Aláforíjìn fún ẹnikẹ́ni tí ó bá ronú pìwàdà, tí ó gbàgbọ́ ní òdodo, tí ó sì ṣe iṣẹ́ rere, lẹ́yìn náà tí ó tún tẹ̀lé ìmọ̀nà}</span>. " "<span class="c5">[Surah Al-<span class="c6">taha :</span> 82]</span>" </p>',
            ],
            14 => [
                'question' => '"Ibeere ẹlẹẹkarundinlogun: Ki ni awọn majẹmu ironupiwada to ni alaafia? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16850.mp3',
                'answer' => '<p> "Idahun- 1- Jijawọ nibi ẹṣẹ. "<br /> 2- Ṣiṣe abamọ lori nnkan to ti kọja.<br /> "Ṣíṣe ipinnu lati ma pada si ibẹ mọ. "<br /> "4- Dida awọn ẹtọ ati awọn nnkan ti wọn gba pẹ̀lú àbòsí pada fun awọn to ni i.<span class="c6"> "<br /> Ọba ti ọla Rẹ ga sọ pe:</span> ."{Àwọn tí <span class="c2">(ó jẹ́ pé)</span> nígbà tí wọ́n bá ṣe ìbàjẹ́ kan tàbí tí wọ́n bá ṣàbòsí sí ẹ̀mí ara wọn, wọ́n á rántí Allāhu, wọ́n á sì tọrọ àforíjìn fún ẹ̀ṣẹ̀ wọn, - Ta sì ni Ó ń forí àwọn ẹ̀ṣẹ̀ jin <span class="c2">(ẹ̀dá)</span> bí kò ṣe Allāhu. Wọn kò sì takú sórí ohun tí wọ́n ṣe nígbà tí wọ́n mọ̀ <span class="c2">(pé ẹ̀ṣẹ̀ ni)</span> 135}. " "<span class="c5">[Surah Âl-<span class="c6">`Imrân:</span> 135]</span>" </p>',
            ],
            15 => [
                'question' => '"Ibeere ẹlẹẹkẹrindinlogun: Ki ni itumọ ṣíṣe asalaatu fun Anabi -ki ikẹ Ọlọhun ati ọla Rẹ maa ba-? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16920.mp3',
                'answer' => '<p> "Idahun- Ìtumọ̀ ẹ ni pe ki o tọrọ lọdọ Ọlọhun lati ṣe ẹyin fun Anabi Rẹ- ki ikẹ Ọlọhun ati ọla Rẹ maa ba- ni ọdọ àwọn mọlaika. " </p>',
            ],
            16 => [
                'question' => '"Ibeere ẹlẹẹkẹtadinlogun: Ki ni itumọ "Subhaanallah"?  "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16950.mp3',
                'answer' => '<p> " Idahun- Ìṣe afọmọ ni fifọ Ọ mọ- mimọ ni fun Un ti Ọla Rẹ ga- kuro nibi gbogbo adinku ati aleebu ati aburu. " </p>',
            ],
            17 => [
                'question' => '"Ibeere ẹlẹẹkejidinlogun: Ki ni itumọ "Alhamdulillah"?  "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/16980.mp3',
                'answer' => '<p> "Idahun- Oun ni ṣiṣe ẹyin fun Ọlọhun- ti ọla Rẹ ga- ati riroyin Rẹ pẹlu awọn iroyin pipe. " </p>',
            ],
            18 => [
                'question' => '"Ibeere ẹlẹẹkọkandinlogun: Ki ni itumọ "Allahu Akbar"? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/17000.mp3',
                'answer' => '<p> "Idahun- Ìtumọ̀ rẹ ni pé Oun-mimọ ni fun Un- tobi ju gbogbo nnkan lọ, O si gbọnngbọn, O tobi, O lagbara ju gbogbo nnkan lọ. " </p>',
            ],
            19 => [
                'question' => '"Ibeere ogun: Ki ni itumọ Laa awla wa laa quwwata illaa billah? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/17030.mp3',
                'answer' => '<p> "Idahun-<span class="c6"> Ìtumọ̀ ẹ ni:</span> Ẹrú ko le kúrò ninu iṣesi kan bọ sinu iṣesi mìíràn, ko si si agbara kankan fun un lori ìyẹn afi pẹlu Ọlọhun. " </p>',
            ],
            20 => [
                'question' => '"Ibeere ẹlẹẹkọkanlelogun: Ki ni itumọ Astagfirullah? "',
                'audio' => 'https://kids.islamenc.com/assets/audios/ar/17060.mp3',
                'answer' => '<p> "Idahun-<span class="c6"> Ìtumọ̀ rẹ ni:</span> Ki ẹru beere lọwọ Ọba rẹ lati pa awọn ẹṣẹ rẹ rẹ ati lati bo awọn aleebu rẹ. " </p>',
            ],
        ],
    ],
];
